/**
 * Created by pro on 27/03/17.
 */
Animations = function () {

    var lowerFpsTimer = null;
    var weeklyQuestEffect = null;
    this.runAction = function (node, action, isRepeatForever) {
        if (!utilObj.isNodeValid(node)) {
            loggerObj.errorLog("node is invalid in runAction");
            return;
        }
        if (!action || (utilObj.isArray(action) && action.length < 1)) {
            loggerObj.errorLog("invalid action in runAction");
            return;
        }
        if (runtimeObj.getBatteryOpti() != 1) {
            node.runAction(action);
            return;
        }
        if (isRepeatForever && isRepeatForever === true) {
            animObj.permanentIncreaseFps();
        } else {
            animObj.increaseFPS();
        }
        node.runAction(action);
    };

    this.increaseFPS = function () {
        if (runtimeObj.getBatteryOpti() != 1) {
            return;
        }
        cc.director.setAnimationInterval(1 / constantsObj.FPS);
        if (lowerFpsTimer != null) {
            window.clearTimeout(lowerFpsTimer);
            cc.director.setAnimationInterval(1 / constantsObj.FPS);
        }
        if (curScreen == constantsObj.SCREEN_GAME || curScreen == constantsObj.SCREEN_CALENDAR) {
            lowerFpsTimer = window.setTimeout(animObj.lowerFPS, 5000);
        }
    };

    this.permanentIncreaseFps = function () {
        if (runtimeObj.getBatteryOpti() != 1) {
            cc.director.setAnimationInterval(1 / constantsObj.FPS);
            return;
        }
        if (lowerFpsTimer != null) {
            window.clearTimeout(lowerFpsTimer);
        }
        cc.director.setAnimationInterval(1 / constantsObj.FPS);
    };

    this.lowerFPS = function () {
        if (runtimeObj.getBatteryOpti() != 1) {
            cc.director.setAnimationInterval(1 / constantsObj.FPS);
            return;
        }
        if (lowerFpsTimer != null) {
            window.clearTimeout(lowerFpsTimer);
        }
        cc.director.setAnimationInterval(1 / constantsObj.LOW_FPS);
    };

    this.lowerFpsScroll = function () {
        // loggerObj.debugLog("called screen", curScreen);
        if (runtimeObj.getBatteryOpti() != 1) {
            cc.director.setAnimationInterval(1 / constantsObj.FPS);
            return;
        }
        if (lowerFpsTimer != null) {
            window.clearTimeout(lowerFpsTimer);
        }
        cc.director.setAnimationInterval(1 / constantsObj.FPS);
    };
    this.animateStar = function (sender, params) {
        var star = params.node;
        var initDelay = params.delay;
        var finalScale = params.finalScale;

        star.setScale(constantsObj.SCALE_SPRITE_8);

        var delay = utilObj.getDelayTime(initDelay);
        var fadeIn = new cc.FadeIn(0.1);
        var scale1 = utilObj.getScaleTo(0.1, finalScale * 1.2);
        var scale2 = utilObj.getScaleTo(0.2, finalScale * 0.9);
        var scale3 = utilObj.getScaleTo(0.2, finalScale);
        var easeScale3 = scale3.easing(cc.easeOut(2));

        var seq = new cc.Sequence([delay, fadeIn, scale1, scale2, easeScale3]);
        animObj.runAction(star, seq);
    };

    this.animate1RevealWord = function (sender, params) {
        var initDelay = params.delay;
        var delay = utilObj.getDelayTime(initDelay);
        var tileToAnimate2 = params.node;
        var func = utilObj.getCallFunc(gameLayer.addChildForTile, gameLayer, params);

        var sX = tileToAnimate2.getScaleX();
        var sY = tileToAnimate2.getScaleY();

        var scaleNormal = utilObj.getScaleTo(0.05, sX * 0.1, sY);//0.05
        var scaleWide1 = utilObj.getScaleTo(0.15, sX, sY);//0.15

        var seq2 = new cc.Sequence([delay, scaleNormal, scaleWide1,func]);
        animObj.runAction(tileToAnimate2, seq2);

    };

    this.animateRevealWordInBlitz = function (sender, params) {
        var initDelay = params.delay;
        var delay = utilObj.getDelayTime(initDelay);
        var tileToAnimate2 = params.node;

        var sX = tileToAnimate2.getScaleX();
        var sY = tileToAnimate2.getScaleY();

        var scaleNormal = utilObj.getScaleTo(0.05, sX * 0.1, sY);
        var scaleWide1 = utilObj.getScaleTo(0.15, sX, sY);

        var seq2 = new cc.Sequence([delay, scaleNormal, scaleWide1]);
        animObj.runAction(tileToAnimate2, seq2);

    };


    this.addShainAnimation = function (sender, params) {

        var actions = [];
        var shainSpriteArr = params.arr;
        // actions.push(utilObj.getDelayTime(0.3 + 0.5));
        for (var i in shainSpriteArr) {
            var node = shainSpriteArr[i];
            var func2 = utilObj.getCallFunc(animObj.animateTwinkle, subscriptionsLaunchLayer, {node : node});
            actions.push(func2);
            actions.push(utilObj.getDelayTime(0.25));
        }
        animObj.runAction(subscriptionsLaunchLayer, cc.RepeatForever(animObj.getSequence(actions)), true);

    };

    this.animateTwinkle = function (sender, params) {
        var rand = utilObj.getRandomIntInRange(80, 110);
        var scaleUp = utilObj.getScaleTo(0.25, constantsObj.SCALE_SPRITE_5 * (rand/100)).easing(cc.easeIn(1.0));
        var scaleDown = utilObj.getScaleTo(0.2, 0).easing(cc.easeIn(1.0));
        var rotate = utilObj.getRotateBy(0.25, 90).easing(cc.easeIn(1.0));
        var animSeq1 = [scaleUp, scaleDown];
        var spawn =  cc.Spawn([animObj.getSequence(animSeq1), rotate]);
        animObj.runAction(params.node, spawn);
    };

    this.addShainAnimationHome = function (sender, params) {

        var actions = [];
        var shainSpriteArr = params.arr;
        var screen = params.screen;
        // actions.push(utilObj.getDelayTime(0.3 + 0.5));
        for (var i in shainSpriteArr) {
            var node = shainSpriteArr[i];
            var func2 = utilObj.getCallFunc(animObj.animateTwinkleHome, screen, {node : node});
            actions.push(func2);
            actions.push(utilObj.getDelayTime(1.5));
        }
        animObj.runAction(screen, cc.RepeatForever(animObj.getSequence(actions)), true);

    };

    this.animateTwinkleHome = function (sender, params) {
        var rand = utilObj.getRandomIntInRange(80, 110);
        var scaleUp = utilObj.getScaleTo(0.25, constantsObj.SCALE_SPRITE_2 * (rand/100)).easing(cc.easeIn(1.0));
        var scaleDown = utilObj.getScaleTo(0.2, 0).easing(cc.easeIn(1.0));
        var rotate = utilObj.getRotateBy(0.25, 90).easing(cc.easeIn(1.0));
        var animSeq1 = [scaleUp, scaleDown];
        var spawn =  cc.Spawn([animObj.getSequence(animSeq1), rotate]);
        animObj.runAction(params.node, spawn);
    };

    this.animateImage = function(node, delay, starAnimDuration) {
        if(!utilObj.isNodeValid(node)) {
            return 0;
        }

        var scaleUpDuration = 0.2;
        var rotateLeftDuration = 0.125;
        var rotateRightDuration = 0.125;
        var rotateNormalDuration = 0.125;
        var scaleDownDuration = 0.2;

        var origScale = node.getScale();

        var initDelay = animObj.getDelayTime(delay);
        var scaleAction = new cc.ScaleTo(scaleUpDuration, 1.5 * origScale);


        var rotateLeftAction = new cc.RotateTo(rotateLeftDuration, -45);
        var rotateRightAction = new cc.RotateTo(rotateRightDuration, 45);
        var rotateNormalAction = new cc.RotateTo(rotateNormalDuration, 0);

        var scaleDownAction = new cc.ScaleTo(scaleDownDuration, origScale);

        var starAnimDelayAction = animObj.getDelayTime(starAnimDuration);
        animObj.runAction(node, new cc.RepeatForever(animObj.getSequence(([initDelay, scaleAction, rotateLeftAction, rotateRightAction, rotateNormalAction, scaleDownAction, starAnimDelayAction]))));

        return (scaleUpDuration + rotateLeftDuration + rotateRightDuration + rotateNormalDuration + scaleDownDuration);
    };

    this.genericCoinGrantAnimation = function (cash, shouldCashLabelFly, isCashGrantedAlready, initialPosition, finalPosition, layer, lbl, oocScreen) {
        var spriteArr = [];
        var labelArr = [];

        for (var i = 0; i < 6; i++) {
            var coinSprite = utilObj.getSprite(constantsObj.coin_one, initialPosition.x, initialPosition.y, 0.5, 0.5, constantsObj.SCALE_SPRITE_5, spriteArr, layer, constantsObj.FTUE_Z_ORDER + 2, constantsObj.SPRITE_MISC);
            var scale = coinSprite.scale;
            coinSprite.scale = scale * 0.5;
            if (oocScreen != undefined && oocScreen == true) {
                coinSprite.scale = scale * 0.75;
            }
            coinSprite.setOpacity(constantsObj.OPACITY_50);
            coinSprite.setVisible(false);
            var delayAction = utilObj.getDelayTime(0.25 + i * 0.1);
            var toggleVisibility = cc.toggleVisibility();
            var removeSelf = utilObj.getIndependentRemoveSelf();

            var scaleUpAction = utilObj.getScaleTo(0.2, scale);
            var alphaUpAction2 = utilObj.getFadeTo(0.01, constantsObj.OPACITY_100);

            var direction = 1;
            if(initialPosition.x > finalPosition.x) {
                direction = -1;
            }
            var points = [];
            var point1 = cc.p(initialPosition.x, initialPosition.y);
            points.push(point1);
            var point4 = cc.p(finalPosition.x, finalPosition.y);
            points.push(point4);
            var moveToAction = animObj.getCardinalSplineTo(0.40, points, 0.2).easing(new cc.easeIn(1.5));

            var spawnAction = cc.spawn([scaleUpAction, alphaUpAction2, moveToAction]);
            var toggleVisibility2 = cc.toggleVisibility();

            animObj.runAction(coinSprite, animObj.getSequence([delayAction, toggleVisibility, spawnAction, removeSelf]));
        }

        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);

        animObj.updateCashLbl(lbl, cash, 0.25 + 0.40, isCashGrantedAlready);
        return 0.25 + 4 * 0.15 + 0.40;
    };

    this.updateCashLbl = function (node, cash, delayPlus, isGrantedAlready) {
        var coinInc = parseInt(cash / 5);
        var n = 5;
        var extra = 0;
        if (cash < 5) {
            coinInc = 1;
            n = cash;
        }
        var cashAdd = economyObj.getCash() + coinInc;
        if (isGrantedAlready) {
            cashAdd -= cash;
        }
        if (cash > 5 && (cash % 5 != 0)) {
            cashAdd += cash % 5;
        }
        var callFunc;
        var delay;
        var actions = [];
        if (isGrantedAlready) {
            var params = {
                n: node,
                cA: economyObj.getCash() - cash
            };
            animObj.updateCoinCountAbsolute(subscriptionsLaunchLayer, params);
        }
        var delayInit = utilObj.getDelayTime(delayPlus);
        actions.push(delayInit);
        for (var i = 0; i < n; i++) {
            var params = {
                n: node,
                cA: cashAdd
            };
            callFunc = utilObj.getCallFunc(animObj.updateCoinCountAbsolute, subscriptionsLaunchLayer, params);
            delay = utilObj.getDelayTime(0.12);
            actions.push(callFunc);
            actions.push(delay);
            cashAdd += coinInc;
        }
        if (actions.length <= 1) {
            node.runAction(actions);
        } else {
            var seq = animObj.getSequence(actions, false);
            node.runAction(seq);
        }
    };

    this.updateCoinCountAbsolute = function (sender, params) {
        utilObj.setString(params.n, (params.cA) + "");
    };

    this.animate2RevealWord = function (sender, params) {
        var initDelay = params.delay;
        var delay = utilObj.getDelayTime(initDelay);
        var x = params.xTemp;
        var y = params.yTemp;
        var tileToAnimate2 = params.node;
        var colorTo1 = new cc.TintTo(0, 107, 213, 255);//0
        var colorTo2 = new cc.TintTo(0.1, 187, 234, 254);//0.1
        var func = utilObj.getCallFunc(function () {
            var colorToX = new cc.TintTo(0.25, 255, 255, 255);
            if (x == gameObj.getSelectedX() && y == gameObj.getSelectedY()) {
                colorToX = new cc.TintTo(0.25, 252, 247, 121);
            } else if (gameLayer.highlightedTilesCoord.indexOf(x + "_" + y) != -1) {
                colorToX = new cc.TintTo(0.25, 193, 255, 250);//0.25
            } else {
                colorToX = new cc.TintTo(0.25, 255, 255, 255);//0.25
            }
            animObj.runAction(tileToAnimate2, colorToX);
        }, gameLayer, null);

        var seq1 = new cc.Sequence([delay, colorTo1, colorTo2, func]);
        animObj.runAction(tileToAnimate2, seq1);
    };

    this.showTriangleMark = function (sender, params) {
        var anims = [];
        var delay = params.delay;
        var node = params.node;
        var initialDelay = utilObj.getDelayTime(delay + 0.3);
        anims.push(initialDelay);
        var fadeIn = new cc.FadeIn(0.2);
        anims.push(fadeIn);
        animObj.runAction(node, utilObj.getSequence(anims));
        // node.runAction(utilObj.getSequence(anims));
    };

    this.coinGrantAnimation = function (sender, params) {
        var isMiniOrMidi = gameObj.checkForMiniOrMidi(gameLayer.crosswordDate);
        if (!isMiniOrMidi) {
            return;
        }
        var startPos = params.startPos;
        var endPos = params.endPos;
        var initDelay = params.initDelay;
        var delayStart = initDelay + 0.60;
        var isDirectionRight = params.isDirectionRight;
        var reward = params.reward;
        var xOffset = 150;
        if (!isDirectionRight) {
            xOffset = -xOffset;
        }
        var parent = params.parent;
        var midPoint = cc.p(startPos.x + xOffset, startPos.y - 200);

        var res1 = animObj.getCurvedPath(startPos, midPoint);
        var res2 = animObj.getCurvedPath(midPoint, endPos);

        var coinImg = constantsObj.coin_png_2;
        var delayInc = 0.18;
        if (reward <= 10) {
            //coinImg = constantsObj.coin_png_2;
        } else if (reward <= 50) {
            //coinImg = constantsObj.new_facebook_icon;
        } else {
            //coinImg = constantsObj.message_icon;
        }

        var countForLoop = reward;
        if (reward > 5) {
            countForLoop = 5;
        }
        var timeDelayForCash = 0;
        for (var i = 0; i < countForLoop; i++) {
            var node = utilObj.getSprite(coinImg, startPos.x, startPos.y, 0.5, 0.5, constantsObj.SCALE_SPRITE_24);
            if (utilObj.isNodeValid(parent) && utilObj.isNodeValid(node)) {
                utilObj.addChild(parent, constantsObj.FTUE_Z_ORDER);
            }
            node.setOpacity(0);
            var startDelay = utilObj.getDelayTime(initDelay);

            var path1Mid = cc.p(startPos.x + 10, startPos.y - 100);
            var path1 = [startPos, path1Mid, midPoint];
            var time1 = res1.time + 0.1;
            var moveAnim1 = utilObj.getCardinalSpline(time1, path1, 0);
            var easeOutMove1 = moveAnim1.easing(cc.easeOut(2));

            var path2Mid = cc.p(endPos.x + 50, (midPoint.y + endPos.y) / 2);
            var path2 = [midPoint, path2Mid, endPos];
            var time2 = res2.time - 0.15;
            var moveAnim2 = utilObj.getCardinalSpline(time2, path2, 0);
            var easeOutMove2 = moveAnim2.easing(cc.easeOut(0.4));

            var func1 = utilObj.getCallFunc(animObj.pulseLabel, sender, {node: params.target});
            var remove = utilObj.getIndependentRemoveSelf();

            var fadeIn = new cc.FadeIn(initDelay + time1 + 0.2);

            animObj.runAction(node, fadeIn);

            var seq = new cc.Sequence([startDelay, easeOutMove1, easeOutMove2, func1, remove]);
            animObj.runAction(node, seq);

            timeDelayForCash += (0.18);

            initDelay += 0.18;
        }


        delayInc = timeDelayForCash / reward;
        var node2 = params.target;
        for (var i = 0; i < reward; i++) {
            var labelNode = null;
            if (utilObj.isNodeValid(node2)) {
                if (utilObj.isNodeValid(node2.getChildByTag(0))) {
                    labelNode = node2.getChildByTag(0);
                }
            }
            if (!utilObj.isNodeValid(labelNode)) {
                break;
            }
            var startDelay2 = utilObj.getDelayTime(delayStart);
            var func2 = utilObj.getCallFunc(animObj.updateLabel, sender, {node: labelNode});

            var seq2 = new cc.Sequence([startDelay2, func2]);
            animObj.runAction(labelNode, seq2);

            delayStart += delayInc;
        }

        utilObj.delayedCallback(curLayer, gameObj.resetCoinGrantAnimationRunning, delayStart);

    };

    this.updateLabelAndPulse = function (sender, params) {
        var node = params.node;
        var scale1 = new cc.ScaleBy(0.07, 1.111);
        var scale2 = new cc.ScaleBy(0.07, 0.9);
        var seq = new cc.Sequence([scale1, scale2]);

        if (utilObj.isNodeValid(node)) {
            var label = node.getChildByTag(0);
            if (utilObj.isNodeValid(label)) {
                label.setString(parseInt(label.getString()) + 1 + "");
            }

            animObj.runAction(node, seq);
        }
    };

    this.pulseLabel = function (sender, params) {
        var node = params.node;
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        var scale1 = new cc.ScaleBy(0.07, 1.111);
        var scale2 = new cc.ScaleBy(0.07, 0.9);
        var seq = new cc.Sequence([scale1, scale2]);

        animObj.runAction(node, seq);
    };

    this.pulseButton = function (sender, params) {
        var node = params.node;
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        var scale1 = new cc.ScaleTo(1, 1.05);
        var scale2 = new cc.ScaleTo(1, 0.95);

        var seq = new cc.Sequence([scale1, scale2]);
        var seqRepeat = new cc.RepeatForever(seq);
        animObj.runAction(node, seqRepeat);
    };

    this.textSizeAnimation = function (sender, params) {
        var node = params.node;
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        var anim_time1 = 0.16;
        var anim_time2 = 0.04;
        var scale_plist = 5;
        var xPos = 0;
        var w2ePowerUpExp = epmObj.getChosenVariant(constantsObj.EXP_W2E_POWER_UP);
        if (w2ePowerUpExp == constantsObj.EXP_VAR_2 || w2ePowerUpExp == constantsObj.EXP_VAR_3 || w2ePowerUpExp == constantsObj.EXP_VAR_4) {
            xPos = 100 * canvasWidth / 1440;
        }
        if (params.anim_time1 != undefined) {
            anim_time1 = params.anim_time1;
        }
        if (params.anim_time2 != undefined) {
            anim_time2 = params.anim_time2;
        }
        if (params.scale_plist != undefined) {
            scale_plist = params.scale_plist;
        }
        var scale1 = new cc.ScaleTo(anim_time1, 4).easing((cc.easeOut(1)));
        var scale2 = new cc.ScaleTo(anim_time2, 3.5).easing((cc.easeOut(1)));
        var seq = new cc.Sequence([scale1, scale2]);
        animObj.runAction(node, seq);
        var zOrder = params.zOrder;
        var params1 = {
            x: centerXPos + (200 * canvasWidth / 1440) + xPos,
            y: centerYPos + 60,
            layer: gameLayer,
            zOrder: zOrder,
            scale: scale_plist
        };
        utilObj.delayedCallback(gameLayer, effectsObj.playStarBlastEffect, 0.5, params1, false);

        var params2 = {
            x: centerXPos - (180 * canvasWidth / 1440) - xPos,
            y: centerYPos + 20,
            layer: gameLayer,
            zOrder: zOrder,
            scale: scale_plist
        };
        utilObj.delayedCallback(gameLayer, effectsObj.playStarBlastEffect, 0.6, params2, false);
        if (w2ePowerUpExp == constantsObj.EXP_VAR_2 || w2ePowerUpExp == constantsObj.EXP_VAR_3 || w2ePowerUpExp == constantsObj.EXP_VAR_4) {
            var params3 = {
                layer: gameLayer,
                node: node,
                zOrder: zOrder,
                fadeDur: 0.1
            };
            utilObj.delayedCallback(gameLayer,animObj.fadeOutAnimation, 1.6, params3, false);
            utilObj.delayedCallback(gameLayer,animObj.revealLetterAnimation, 1.85, params, false);
        } else {
            utilObj.delayedCallback(gameLayer, animObj.moveTextAnimation, 0.9, params, false);
        }
    };

    this.revealLetterAnimation = function (sender, params) {
        loggerObj.debugLog("check for the reveal letter anim1 ");
        var node = params.node;
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        loggerObj.debugLog("check for the reveal letter anim ");
        gameObj.activateRevealLetters();
    };

    this.revealLetterAnimDirect = function (sender, params) {
        gameObj.activateRevealLetters(undefined, undefined, true);
        gameObj.setPowerUpPuzzleId(gameLayer.crosswordDate, constantsObj.POWER_UP_USED);
    };

    this.moveTextAnimation = function (sender, params) {
        var node = params.node;
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        var startX = centerXPos;
        var startY = centerYPos;
        var delay = 0.6;
        var isMiniOrMidi = gameObj.checkForMiniOrMidi(gameLayer.crosswordDate);
        var endX = xRightPos - (300 * canvasWidth / 1440);
        if (isMiniOrMidi) {
            endX = xRightPos - (160 * canvasWidth / 1440);
        }
        var endY = 50 + gameLayer.shiftInHints;
        var midX = startX + (400 * canvasWidth / 1440);
        var midY = (startY - endY) / 2;
        var moveTo = animObj.getCardinalSplineTo(delay, [{
            x: startX,
            y: startY
        }, {x: midX, y: midY}, {
            x: endX,
            y: endY,
        }], 0).easing(new cc.easeOut(2));
        animObj.runAction(node, moveTo);
        var scale2 = new cc.ScaleTo(0.6, 0.7).easing((cc.easeOut(1)));
        //var seq = new cc.Sequence([scale1, scale2]);
        animObj.runAction(node, scale2);
        utilObj.delayedCallback(gameLayer, animObj.fadeOutAnimation, delay, params, false);
    };

    this.fadeOutAnimation = function (sender, params) {
        var node = params.node;
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        var fadeDur = 0.4;
        if (params.fadeDur != undefined) {
            fadeDur = params.fadeDur;
        }
        var fadeOut = utilObj.getFadeOut(fadeDur);
        animObj.runAction(node, fadeOut);
    };

    this.fadeInAnimation = function (sender, params) {
        var node = params.node;
        //node.setVisible(true);
        if (!utilObj.isNodeValid(node)) {
            return 0;
        }
        var fadeDur = 0.4;
        if (params.fadeDur != undefined) {
            fadeDur = params.fadeDur;
        }
        var fadeIn = utilObj.getFadeIn(fadeDur);
        animObj.runAction(node, fadeIn);
        return fadeDur;
    };

    /**
     * generic wrapper for fadeto animation, default fadeDur -> 0.4, opacity -> 0
     * @param sender
     * @param params
     * @returns {number}
     */
    this.fadeToAnimation = function (sender, params) {
        var node = params.node;
        //node.setVisible(true);
        if (!utilObj.isNodeValid(node)) {
            return 0;
        }
        var fadeDur = 0.4;
        if (params.fadeDur != undefined) {
            fadeDur = params.fadeDur;
        }
        var opacity = constantsObj.OPACITY_0;
        if(params.opacity != undefined){
            opacity = params.opacity;
        }
        var fadeIn = animObj.getFadeTo(fadeDur, opacity);
        animObj.runAction(node, fadeIn);
        return fadeDur;
    };

    var progressTimer = null;
    this.animateProgressTimer = function (sender,params) {
        var node = params.tile;
        var timerClock = params.timerClock;
        var timerCircle = params.timerCircle;
        if (!utilObj.isNodeValid(node) && !utilObj.isNodeValid(timerClock) && !utilObj.isNodeValid(timerCircle)) {
            return;
        }
        var origScale = timerClock.getScale();
        var scaleUpDuration = 0.2;
        var scaleDownDuration = 0.2;
        var initDelay = animObj.getDelayTime(0.3);
        var scaleAction = new cc.ScaleTo(scaleUpDuration, 1.5 * origScale).easing(cc.easeOut(1));
        var scaleDownAction = new cc.ScaleTo(scaleDownDuration, origScale).easing(cc.easeIn(1));
        var seq = animObj.getSequence([initDelay, scaleAction, scaleDownAction]);
        //var starAnimDelayAction = animObj.getDelayTime(starAnimDuration);
        animObj.runAction(timerClock, seq);

        var initDelay1 = animObj.getDelayTime(0.3);
        var origScale2 = timerCircle.getScale();
        var scaleAction1 = new cc.ScaleTo(scaleUpDuration, 1.5 * origScale2);
        var scaleDownAction1 = new cc.ScaleTo(scaleDownDuration, origScale2);
        var seq = animObj.getSequence([initDelay1, scaleAction1, scaleDownAction1]);
        //var starAnimDelayAction = animObj.getDelayTime(starAnimDuration);
        animObj.runAction(timerCircle, seq);



        // showing timer animation

        var duration = runtimeObj.getW2ePowerUpTimer() + 0.3;
        var sprite = utilObj.getSprite(constantsObj.white_circle_150, 30, 45, 0.5, 0.5, constantsObj.SCALE_SPRITE_12);
        progressTimer = new cc.ProgressTimer(sprite);
        progressTimer.setType(cc.ProgressTimer.TYPE_RADIAL);
        progressTimer.setMidpoint(cc.p(0.5, 0.5));
        progressTimer.setBarChangeRate(cc.p(1, 0));
        progressTimer.setColor(constantsObj.COLOR_BLACK);
        utilObj.setPosition(progressTimer, 30, 45);
        utilObj.setScale(progressTimer, constantsObj.SCALE_SPRITE_12);
        utilObj.addChild(node, progressTimer, constantsObj.UI_Z_ORDER + 1);
        animObj.runAction(node, cc.targetedAction(progressTimer, cc.ProgressFromTo(duration, 0, 100)));

        // clock shaking animation
        duration += 0.15;
        var rotateLeftDuration = 0.05;
        var rotateRightDuration = 0.05;
        var rotateNormalDuration = 0.05;
        if (!utilObj.isNodeValid(timerClock)) {
            return;
        }
        var initDelay = animObj.getDelayTime(duration);
        var rotateLeftAction = new cc.RotateTo(rotateLeftDuration, -25);
        var rotateLeftAction2 = new cc.RotateTo(rotateLeftDuration, -14);
        var rotateLeftAction3 = new cc.RotateTo(rotateLeftDuration, -8);
        var rotateLeftAction4 = new cc.RotateTo(rotateLeftDuration, -4);
        var rotateRightAction = new cc.RotateTo(rotateRightDuration, 25);
        var rotateRightAction2 = new cc.RotateTo(rotateRightDuration, 14);
        var rotateRightAction3 = new cc.RotateTo(rotateRightDuration, 8);
        var rotateRightAction4 = new cc.RotateTo(rotateRightDuration, 4);
        var rotateNormalAction = new cc.RotateTo(rotateNormalDuration, 0);
        var seq = animObj.getSequence((([initDelay, rotateLeftAction, rotateRightAction, rotateLeftAction2, rotateRightAction2, rotateLeftAction3, rotateRightAction3,rotateLeftAction4, rotateRightAction4,rotateNormalAction])));
        animObj.runAction(timerClock, seq);

        var totalDuration = duration + (4 * rotateLeftDuration) + (4 * rotateRightDuration) + rotateNormalDuration;
        loggerObj.debugLog("check for the total duration ", totalDuration);
        utilObj.delayedCallback(popupLayer, animObj.fadeOutPowerUp ,totalDuration, params);

        //return (rotateLeftDuration + rotateRightDuration + rotateNormalDuration);
    };

    this.fadeOutPowerUp = function (sender, params) {
        var node = params.tile;
        var timerClock = params.timerClock;
        var timerCircle = params.timerCircle;
        var offerText = params.offerText;
        if (!utilObj.isNodeValid(node) || !utilObj.isNodeValid(timerClock) || !utilObj.isNodeValid(timerCircle) || !utilObj.isNodeValid(offerText)) {
            return;
        }
        timerCircle.setVisible(false);
        var scaleUpDuration = 0.04;
        var origScale = timerClock.getScale();
        var scaleAction1 = new cc.ScaleTo(scaleUpDuration, 1.15 * origScale);
        var scaleAction2 = new cc.ScaleTo(scaleUpDuration, 1.3 * origScale);
        var scaleAction3 = new cc.ScaleTo(scaleUpDuration, 1.45 * origScale);
        var scaleAction4 = new cc.ScaleTo(scaleUpDuration, 1.6 * origScale);
        var seq = animObj.getSequence((([scaleAction1, scaleAction2, scaleAction3, scaleAction4])));
        animObj.runAction(timerClock, seq);

        var opacityDuration = 0.2;
        var newAnim1 = new cc.FadeTo(opacityDuration, 0);
        var newAnim2 = new cc.FadeTo(opacityDuration, 0);
        var newAnim3 = new cc.FadeTo(opacityDuration, 0);
        animObj.runAction(offerText, newAnim1);
        animObj.runAction(timerClock, newAnim2);
        animObj.runAction(progressTimer, newAnim3);
    };

    this.fadeOutW2eButton = function (sender, params) {
        var node = params.tile;
        if (!utilObj.isNodeValid(node) && !utilObj.isNodeValid(params.powerUpText) && !utilObj.isNodeValid(params.w2ePowerUpButton) && !utilObj.isNodeValid(params.freeHintText) && !utilObj.isNodeValid(params.w2eIcon)) {
            return;
        }
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), "w2e_level_intro", "timed_out", "", gameObj.getPuzzleSpeciesTracking(), "", "");
        var fadeDur = 0.2;
        var fadeOut = utilObj.getFadeOut(fadeDur);
        var fadeOut1 = new cc.FadeTo(fadeDur, 0);
        var fadeOut2 = new cc.FadeTo(fadeDur, 0);
        var fadeOut3 = new cc.FadeTo(fadeDur, 0);
        animObj.runAction(params.powerUpText, fadeOut);
        animObj.runAction(params.w2ePowerUpButton, fadeOut1);
        animObj.runAction(params.freeHintText, fadeOut2);
        animObj.runAction(params.w2eIcon, fadeOut3);
    };

    this.updateLabel = function (sender, params) {
        var label = params.node;
        if (!utilObj.isNodeValid(label)) {
            return;
        }
        label.setString(parseInt(label.getString()) + 1 + "");
    };


    this.playTapEffect = function (hand, tapEffect) {
        var scaleDownTime = 0.4;
        var scaleUpTime = 0.6;
        var handScaleX = hand.getScaleX();
        var tapScaleX = tapEffect.getScaleX();

        var fade1 = utilObj.getFadeIn(0);
        var scale1 = utilObj.getScaleTo(0, tapScaleX, tapScaleX);
        var sp1 = new cc.Spawn(new cc.FadeOut(0.2), utilObj.getScaleTo(0.2, 1.75 * tapScaleX));
        var seqTap = utilObj.getSequence([utilObj.getDelayTime(0.4), fade1, scale1, sp1, utilObj.getDelayTime(0.4)]);
        // tapEffect.runAction(seqTap.repeatForever());a
        animObj.runAction(tapEffect, seqTap.repeatForever(), true);

        var seq = utilObj.getSequence([utilObj.getScaleTo(scaleDownTime, handScaleX), utilObj.getScaleTo(scaleUpTime, handScaleX * 1.25)]);
        // hand.runAction(seq.repeatForever());
        animObj.runAction(hand, seq.repeatForever(), true);
    };

    this.getCurvedPath = function (pos_a, pos_b) {
        var path = [];
        var time = 0.8;

        if (pos_b == undefined || pos_a == undefined) {
            loggerObj.errorLog("Invalid params passed to getCurvedPath", pos_a, pos_b);
            return {path: path, time: 0};
        }
        var center_x = pos_b.x;
        var center_y = pos_a.y;

        var pi = Math.PI;
        var angle = 0;
        var finalAngle = pi / 2;

        if (pos_a.x < pos_b.x && pos_a.y < pos_b.y) {
            angle = pi;
            finalAngle = pi / 2;
            center_x = pos_b.x;
            center_y = pos_a.y;
        } else if (pos_a.x < pos_b.x && pos_a.y > pos_b.y) {
            angle = pi / 2;
            finalAngle = 0;
            center_x = pos_a.x;
            center_y = pos_b.y;
        } else if (pos_a.x > pos_b.x && pos_a.y > pos_b.y) {
            angle = pi / 2;
            finalAngle = pi;
            center_x = pos_a.x;
            center_y = pos_b.y;
        } else if (pos_a.x == pos_b.x) {
            if (pos_a.y > pos_b.y) {
                angle = pi / 2;
                finalAngle = 3 * pi / 2;
            } else {
                angle = 3 * pi / 2;
                finalAngle = pi / 2;
            }
            center_x = pos_a.x;
            center_y = (pos_a.y + pos_b.y) / 2;

        } else if (pos_a.y == pos_b.y) {
            if (pos_a.x > pos_b.x) {
                angle = 0;
                finalAngle = pi;
            } else {
                angle = pi;
                finalAngle = 0;
            }
            center_x = (pos_a.x + pos_b.x) / 2;
            center_y = pos_a.y;
        } else {
            angle = 0;
            finalAngle = pi / 2;
            center_x = pos_b.x;
            center_y = pos_a.y;
        }

        var diff_a_x = center_x - pos_a.x;
        var diff_a_y = center_y - pos_a.y;
        var dist_a = Math.sqrt(diff_a_x * diff_a_x + diff_a_y * diff_a_y);

        var diff_b_x = center_x - pos_b.x;
        var diff_b_y = center_y - pos_b.y;
        var dist_b = Math.sqrt(diff_b_x * diff_b_x + diff_b_y * diff_b_y);


        time = dist_b / constantsObj.DESIGN_HEIGHT * time;

        var diff = dist_b - dist_a;
        var n = 100;
        var angleInc = (finalAngle - angle) / n;
        var inc = diff / n;
        var r = Math.max(dist_a, 0);

        for (var i = 0; i < n; i++) {
            var x = center_x + Math.cos(angle) * r;
            var y = center_y + Math.sin(angle) * r;
            path.push({x: x, y: y});
            r += inc;
            angle += angleInc;
        }
        return {path: path, time: time};
    };


    this.showDarkScreen = function (firstDelay) {
        var anims = [];
        
        var preDelay = utilObj.getDelayTime(firstDelay);
        anims.push(preDelay);


        var blackBgHeight = constantsObj.DESIGN_HEIGHT + topBarOffset;
        var yDownPos = 0;
        var blackBg = utilObj.getScale9Sprite(constantsObj.black_80, xLeftPos, yDownPos, 0, 0, canvasWidth, blackBgHeight);
        if (curScreen == constantsObj.SCREEN_HOME) {
            utilObj.addChild(homeLayer, blackBg, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_CALENDAR) {
            utilObj.addChild(calendarLayer, blackBg, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_GAME) {
            utilObj.addChild(gameLayer, blackBg, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_PACK_INFO_LAYER) {
            utilObj.addChild(packInfoLayer, blackBg, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_ACHIEVEMENTS) {
            utilObj.addChild(achievementsLayer, blackBg, constantsObj.UI_Z_ORDER);
        } else if(curScreen == constantsObj.SCREEN_LINEAR_PROGRESSION){
            utilObj.addChild(linearLevelProgression, blackBg, constantsObj.UI_Z_ORDER);
        }  else {
            utilObj.addChild(popupLayer, blackBg, constantsObj.UI_Z_ORDER);
        }
        blackBg.setLocalZOrder(constantsObj.UI_Z_ORDER + 2);
        blackBg.setOpacity(0);

        var move1 = new cc.FadeIn(0.2);
        anims.push(move1);

        var midDelay = utilObj.getDelayTime(1.8);
        anims.push(midDelay);

        var move2 = new cc.FadeOut(0.2);
        anims.push(move2);

        blackBg.runAction(utilObj.getSequence(anims));
    };

    this.sideShowTq = function (heading, desc, firstDelay) {

        var anims = [];

        var preDelay = utilObj.getDelayTime(firstDelay);
        anims.push(preDelay);

        // create a sprite for banner here
        var imageForSideShow = constantsObj.achievement_banner;
        var textColor = constantsObj.COLOR_WHITE;
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            imageForSideShow = constantsObj.achv_toaster;
            textColor = constantsObj.COLOR_BLACK;
        }
        var banner = utilObj.getSprite(imageForSideShow, 0, 0, 0, 0.5, constantsObj.SCALE_SPRITE_7);
        utilObj.setPosition(banner, xLeftPos - canvasWidth, centerYPos + 160);
        if (curScreen == constantsObj.SCREEN_HOME) {
            utilObj.addChild(homeLayer, banner, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_CALENDAR) {
            utilObj.addChild(calendarLayer, banner, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_GAME) {
            utilObj.addChild(gameLayer, banner, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_PACK_INFO_LAYER) {
            utilObj.addChild(packInfoLayer, banner, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_ACHIEVEMENTS) {
            utilObj.addChild(achievementsLayer, banner, constantsObj.UI_Z_ORDER);
        } else {
            utilObj.addChild(popupLayer, banner, constantsObj.UI_Z_ORDER);
        }
        banner.setLocalZOrder(constantsObj.UI_Z_ORDER + 2);

        // create text Labels for achievement Title and description here
        var headingText = heading;
        var headingLbl = utilObj.getTTFFontLabel(headingText, constantsObj.FONT_ROBOTO_MEDIUM_60, textColor,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 370, 210, 0, 0.5, null, banner, constantsObj.UI_Z_ORDER + 1);
        utilObj.addChild(banner, headingLbl);

        var descText = desc;
        var textArr = [];
        textArr = utilObj.getSplitStringsArr(descText, 25);

        var yShift = 65;

        for (var i = 1; i <= textArr.length; i++) {
            var textLabel = utilObj.getTTFFontLabel(textArr[i - 1], constantsObj.FONT_ROBOTO_MEDIUM_40, textColor,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 370, 210 - yShift, 0, 0.5);
            //textLabel.setFontFillColor(constantsObj.COLOR_WHITE);
            utilObj.addChild(banner, textLabel);
            yShift += 50;
        }


        // then set the movements required while entering here

        var initialDelay = utilObj.getDelayTime(0.1);
        anims.push(initialDelay);

        var move1 = new cc.MoveTo(0.2, xLeftPos, centerYPos + 160);
        var ease1 = move1.easing(new cc.easeOut(10.0));
        anims.push(ease1);

        var midDelay = utilObj.getDelayTime(1.5);
        anims.push(midDelay);

        var move3 = new cc.MoveTo(0.2, xLeftPos - canvasWidth, centerYPos + 160);
        var ease3 = move3.easing(new cc.easeIn(1.0));
        anims.push(ease3);

        banner.runAction(utilObj.getSequence(anims));


        // then set the movements required while leaving here

    };

    this.showBubbleLeft = function (node, localYPos) {
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        var move1 = new cc.MoveTo(0.16, xLeftPos + 350 - 35, localYPos - 290);
        var move2 = new cc.MoveTo(0.16, xLeftPos + 350, localYPos - 290);
        var move3 = new cc.MoveTo(0.34, xLeftPos + 350, localYPos - 290);
        var d2 = utilObj.getDelayTime(0.74);
        var ease1 = move1.easing(new cc.easeIn(1.0));
        var ease2 = move2.easing(new cc.easeIn(1.0));
        var ease3 = move3.easing(new cc.easeOut(1.0));

        var seqAction = [ease1, ease2, ease1, ease3, d2];

        if (utilObj.isNodeValid(node)) {
            // node.runAction(cc.RepeatForever(utilObj.getSequence(seqAction)));
            animObj.runAction(node, cc.RepeatForever(utilObj.getSequence(seqAction)), true);
            // animObj.runAction(node, cc.RepeatForever(utilObj.getSequence(seqAction)));
        }

    };

    this.getFadeTo = function (duration, opacity) {
        return new cc.FadeTo(duration, opacity);
    };

    // this.showFrenzyAnimation = function (node, popupNode, yPos, spriteArrForFrenzy, labelArrForFrenzy) {
    //     if (!utilObj.isNodeValid(node)) {
    //         return;
    //     }
    //     var time = 0.25;
    //     var timeForAnim = 0.2;
    //     var ease_rate = 1;
    //     var delay = utilObj.getDelayTime(1);
    //     var delay2 = utilObj.getDelayTime(5);
    //
    //     var zOrder = constantsObj.FTUE_Z_ORDER;
    //     var time1 = 0;
    //
    //     // Text Animation
    //     var move1 = new cc.MoveTo(time, centerXPos - 60, yPos + 10);
    //     var fadeTo = animObj.getFadeIn(time);
    //     var moveAndFadeIn = new cc.Spawn(fadeTo, move1);
    //     var ease1 = moveAndFadeIn.easing(new cc.easeIn(1.0));
    //     var move2 = new cc.MoveTo(time, centerXPos, yPos + 10).easing(new cc.easeIn(1.0));
    //     var seqAction2 = [delay, ease1, move2];
    //     animObj.runAction(popupNode, cc.targetedAction(labelArrForFrenzy[0]["label"], utilObj.getSequence(seqAction2)));
    //     // --- Text Animation
    //
    //     time1 += 1.5;
    //     var FollowupDelay = time1;
    //
    //     // Word Animation
    //     var actions = [];
    //     var delay1 = utilObj.getDelayTime(0.1);
    //     actions.push(utilObj.getDelayTime(FollowupDelay));
    //     for (var i = 1; i <= 5; i++) {
    //         var params = {
    //             node: labelArrForFrenzy[i]["label"]
    //         };
    //         var callFunc = utilObj.getCallFunc(animObj.animateLabels, popupNode, params);
    //         actions.push(callFunc);
    //         actions.push(delay1);
    //     }
    //     animObj.runAction(popupNode, cc.targetedAction(node, utilObj.getSequence(actions)));
    //     // --- Word Animation
    //
    //     FollowupDelay += 2.5;
    //
    //     // Frenzy Animation
    //     var Followup = utilObj.getDelayTime(FollowupDelay);
    //     var fadeIn1 = animObj.getFadeIn(0.05);
    //     var scaleUp1 = utilObj.getScaleTo(0.1, 1.5).easing(new cc.easeOut(ease_rate));
    //     var zoomInAndMove1 = new cc.Spawn(fadeIn1, scaleUp1);
    //     var ease1 = zoomInAndMove1.easing(new cc.easeOut(1.0));
    //
    //     var scaleDown1 = utilObj.getScaleTo(timeForAnim, 1.3).easing(new cc.easeOut(ease_rate));
    //
    //     var scaleUp1 = utilObj.getScaleTo(timeForAnim, 1.2).easing(new cc.easeOut(ease_rate));
    //
    //     var scaleDown2 = utilObj.getScaleTo(timeForAnim, 0).easing(new cc.easeOut(ease_rate));
    //     var fadeIn1 = animObj.getFadeTo(timeForAnim, 0);
    //     var zoomInAndMove2 = new cc.Spawn(scaleDown2, fadeIn1);
    //     var ease2 = zoomInAndMove2.easing(new cc.easeOut(1.0));
    //
    //     var seqAction2 = [Followup, ease1, delay1, scaleUp1, delay, scaleDown1, ease2];
    //
    //     var params1 = {
    //         x: spriteArrForFrenzy[22]["sprite"].getPositionX() - 350,
    //         y: spriteArrForFrenzy[22]["sprite"].getPositionY() + 200,
    //         layer: popupNode,
    //         scale: 0.7,
    //         zOrder: 30,
    //         scale: 1.2
    //     };
    //
    //     var params2 = {
    //         x: spriteArrForFrenzy[22]["sprite"].getPositionX() + 350,
    //         y: spriteArrForFrenzy[22]["sprite"].getPositionY() + 150,
    //         layer: popupNode,
    //         scale: 0.7,
    //         zOrder: 30,
    //         scale: 1.8
    //     };
    //
    //     utilObj.delayedCallback(popupNode, effectsObj.playStarEffect1, FollowupDelay + 0.15, params1, false);
    //     utilObj.delayedCallback(popupNode, effectsObj.playStarEffect1, FollowupDelay + 0.8, params2, false);
    //
    //     animObj.runAction(popupNode, cc.targetedAction(spriteArrForFrenzy[22]["sprite"], utilObj.getSequence(seqAction2)));
    //     // -- Frenzy Animation
    //
    //     FollowupDelay += 2;
    //
    //     var params = {
    //         x: centerXPos,
    //         y: yPos - 280,
    //         layer: popupNode,
    //         zOrder: constantsObj.UI_Z_ORDER + 2,
    //         scale: 0.8,
    //         duration: 3,
    //         opacity: 0.8
    //     };
    //
    //     var params1 = {
    //         x: centerXPos,
    //         y: yPos - 280,
    //         layer: popupNode,
    //         zOrder: constantsObj.UI_Z_ORDER + 2,
    //         scale: 0.8,
    //         rotation: 90,
    //         duration: 3,
    //         opacity: 0.8
    //     };
    //
    //     var params2 = {
    //         x: centerXPos,
    //         y: yPos - 280,
    //         layer: popupNode,
    //         zOrder: constantsObj.UI_Z_ORDER + 2,
    //         scale: 0.8,
    //         rotation: 45,
    //         duration: 3,
    //         opacity: 0.8
    //     };
    //     utilObj.delayedCallback(popupNode, effectsObj.playThunderEffect1, FollowupDelay, params, false);
    //     utilObj.delayedCallback(popupNode, effectsObj.playThunderEffect1, FollowupDelay, params1, false);
    //     utilObj.delayedCallback(popupNode, effectsObj.playThunderEffect2, FollowupDelay, params2, false);
    //
    //     // Rotate
    //     var delayRotate = utilObj.getDelayTime(FollowupDelay - 0.2);
    //     var rotationAngle = -360;
    //     var rotate1 = -40;
    //     var rotate2 = -80;
    //     var rotate3 = -140;
    //     var rotate4 = -260;
    //     var rotate5 = -400;
    //     var rotate6 = -880;
    //
    //     var rotDuration = 1;
    //     var rotateBy1 = animObj.getRotateBy(rotDuration - 0.2, rotate1);
    //     var rotateBy11 = animObj.getRotateBy(rotDuration - 0.2, -rotate1);
    //     var rotateBy111 = animObj.getRotateBy(rotDuration - 0.2, rotate1);
    //     var rotateBy2 = animObj.getRotateBy(rotDuration - 0.1, rotate2);
    //     var rotateBy22 = animObj.getRotateBy(rotDuration - 0.1, -rotate2);
    //     var rotateBy222 = animObj.getRotateBy(rotDuration - 0.1, rotate2);
    //     var rotateBy3 = animObj.getRotateBy(rotDuration, rotate3);
    //     var rotateBy33 = animObj.getRotateBy(rotDuration, -rotate3);
    //     var rotateBy333 = animObj.getRotateBy(rotDuration, rotate3);
    //     var rotateBy4 = animObj.getRotateBy(rotDuration, rotate4);
    //     var rotateBy44 = animObj.getRotateBy(rotDuration, -rotate4);
    //     var rotateBy444 = animObj.getRotateBy(rotDuration, rotate4);
    //     var rotateBy5 = animObj.getRotateBy(rotDuration, rotate5);
    //     var rotateBy55 = animObj.getRotateBy(rotDuration, -rotate5);
    //     var rotateBy555 = animObj.getRotateBy(rotDuration, rotate5);
    //     var rotateBy6 = animObj.getRotateBy(rotDuration * 2, rotate6);
    //     var rotateBy66 = animObj.getRotateBy(rotDuration * 2, -rotate6);
    //     var rotateBy666 = animObj.getRotateBy(rotDuration * 2, rotate6);
    //     var seqAction4 = [delayRotate, rotateBy1, rotateBy2, rotateBy3, rotateBy4, rotateBy5, rotateBy6];
    //     var seqAction5 = [delayRotate, rotateBy11, rotateBy22, rotateBy33, rotateBy44, rotateBy55, rotateBy66];
    //     var seqAction6 = [delayRotate, rotateBy111, rotateBy222, rotateBy333, rotateBy444, rotateBy555, rotateBy666];
    //     var seq = animObj.getSequence(seqAction4, false);
    //     var seq1 = animObj.getSequence(seqAction5, false);
    //     var seq2 = animObj.getSequence(seqAction6, false);
    //     animObj.runAction(popupNode, cc.targetedAction(spriteArrForFrenzy[25]["sprite"], seq));
    //     animObj.runAction(popupNode, cc.targetedAction(spriteArrForFrenzy[26]["sprite"], seq1));
    //     animObj.runAction(popupNode, cc.targetedAction(spriteArrForFrenzy[27]["sprite"], seq2));
    //     // -- rotate
    //
    //
    //     // Ring
    //     var fadeIn2 = animObj.getFadeIn(0.2);
    //     var seqAct2 = [utilObj.getDelayTime(FollowupDelay - 1), fadeIn2];
    //     var seq4 = animObj.getSequence(seqAct2, false);
    //     animObj.runAction(popupNode, cc.targetedAction(spriteArrForFrenzy[24]["sprite"], seq4));
    //     // -Ring
    //
    //     // Ring grid
    //     var fadeIn3 = animObj.getFadeIn(0.5);
    //     var scaleUp3 = utilObj.getScaleTo(0.5, 2).easing(new cc.easeOut(ease_rate));
    //     var fadeTo3 = utilObj.getFadeTo(0.5, 0);
    //     var zoomAndFade3 = new cc.Spawn(scaleUp3, fadeTo3);
    //     var ease11 = zoomAndFade3.easing(new cc.easeOut(1.0));
    //     var seqAct3 = [utilObj.getDelayTime(FollowupDelay), fadeIn3, ease11];
    //     var seq5 = animObj.getSequence(seqAct3, false);
    //     var params1 = {
    //         x: spriteArrForFrenzy[11]["sprite"].getPositionX(),
    //         y: spriteArrForFrenzy[11]["sprite"].getPositionY(),
    //         layer: popupNode,
    //         zOrder: constantsObj.UI_Z_ORDER + 2,
    //         scale: 0.4,
    //         duration: 0.2,
    //         opacity: 1
    //     };
    //
    //     var params2 = {
    //         x: spriteArrForFrenzy[11]["sprite"].getPositionX(),
    //         y: spriteArrForFrenzy[11]["sprite"].getPositionY(),
    //         layer: popupNode,
    //         zOrder: constantsObj.UI_Z_ORDER + 2,
    //         scale: 0.4,
    //         rotation: 90,
    //         duration: 0.2,
    //         opacity: 1
    //     };
    //     utilObj.delayedCallback(popupNode, effectsObj.playThunderEffect1, FollowupDelay + 0.15, params1, false);
    //     utilObj.delayedCallback(popupNode, effectsObj.playThunderEffect1, FollowupDelay + 0.15, params1, false);
    //     animObj.runAction(popupNode, cc.targetedAction(spriteArrForFrenzy[11]["sprite"], seq5));
    //     // -- Ring grid
    //
    //     FollowupDelay += 1;
    //
    //     var temp = spriteArrForFrenzy[13];
    //     spriteArrForFrenzy[13] = spriteArrForFrenzy[1];
    //     spriteArrForFrenzy[1] = temp;
    //
    //     actions = [];
    //     actions.push(utilObj.getDelayTime(FollowupDelay + 0.1));
    //     var list = [1, 5, 13, 17];
    //     for (var i in list) {
    //         var params = {
    //             node: spriteArrForFrenzy[list[i]]["sprite"],
    //             layer: popupNode
    //         };
    //         var callFunc = utilObj.getCallFunc(animObj.animateLabelsAfter, popupNode, params);
    //         actions.push(callFunc);
    //         actions.push(utilObj.getDelayTime(0.5));
    //     }
    //     animObj.runAction(popupNode, cc.targetedAction(node, utilObj.getSequence(actions)));
    //     actions = [];
    //     actions.push(utilObj.getDelayTime(FollowupDelay));
    //     for (var i = 10; i >= 6; i--) {
    //         var params = {
    //             node: spriteArrForFrenzy[i]["sprite"],
    //             label: labelArrForFrenzy[i - 5]["label"],
    //             layer: popupNode
    //         };
    //
    //         var callFunc = utilObj.getCallFunc(animObj.animateTiles, popupNode, params);
    //         actions.push(callFunc);
    //         actions.push(utilObj.getDelayTime(0.1));
    //     }
    //     animObj.runAction(popupNode, cc.targetedAction(node, utilObj.getSequence(actions)));
    //
    //     var posList = [18, 19, 20, 21];
    //     var posToList = [0, 4, 12, 16];
    //     var delayList = [0, 0.5, 0.5, 1];
    //
    //     for (var i = 0; i <= 3; i++) {
    //         var position1 = {
    //             x: spriteArrForFrenzy[posList[i]]["sprite"].getPositionX(),
    //             y: spriteArrForFrenzy[posList[i]]["sprite"].getPositionY()
    //         };
    //         var position2 = {
    //             x: spriteArrForFrenzy[posToList[i]]["sprite"].getPositionX(),
    //             y: spriteArrForFrenzy[posToList[i]]["sprite"].getPositionY()
    //         };
    //         var positions = [position1, position2];
    //         var move3 = animObj.getCardinalSplineTo(timeForAnim + 0.3, positions, 0.5);
    //         var scaleUp2 = utilObj.getScaleTo(timeForAnim, constantsObj.SCALE_SPRITE_1 * 1.6).easing(new cc.easeOut(ease_rate));
    //         var fadeIn6 = animObj.getFadeTo(0.2, 0);
    //         var zoomInAndMove1 = new cc.Spawn(move3, scaleUp2).easing(new cc.easeOut(ease_rate));
    //         var seqAction5 = [utilObj.getDelayTime(FollowupDelay + delayList[i]), zoomInAndMove1, fadeIn6];
    //         var params1 = {
    //             x: spriteArrForFrenzy[posToList[i]]["sprite"].getPositionX(),
    //             y: spriteArrForFrenzy[posToList[i]]["sprite"].getPositionY(),
    //             layer: popupNode,
    //             zOrder: constantsObj.UI_Z_ORDER + 2,
    //             scale: 0.5,
    //             duration: 0.2,
    //             opacity: 1
    //         };
    //         utilObj.delayedCallback(popupNode, effectsObj.playThunderEffect1, FollowupDelay + delayList[i] + 0.1, params1, false);
    //         animObj.runAction(popupNode, cc.targetedAction(spriteArrForFrenzy[posList[i]]["sprite"], utilObj.getSequence(seqAction5)));
    //     }
    //
    //     utilObj.delayedCallback(popupNode, subscriptionsTestPopup.makeFrenzyAnimObjInVisible, 14);
    // };
    //
    // this.getRotateBy = function (duration, angle) {
    //     return new cc.RotateBy(duration, angle);
    // };
    //
    // this.frenzyRingAnim = function (sender, params) {
    //     var node = params;
    //     var delay = utilObj.getDelayTime(0.05);
    //     var fadeIn2 = animObj.getFadeIn(1);
    //     var fadeOut2 = utilObj.getFadeOut(1);
    //     // utilObj.getDelayTime(2),
    //     var seqAct2 = [delay, fadeIn2, fadeOut2];
    //     var seq4 = animObj.getSequence(seqAct2, false);
    //     animObj.runAction(node, seq4);
    // };
    //
    // this.animateTiles = function (sender, params) {
    //     var node = params.node;
    //     var label = params.label;
    //     var layer = params.layer;
    //     var timeForAnim = 0.2;
    //     var ease_rate = 1;
    //     var scaleUp = utilObj.getScaleTo(timeForAnim, constantsObj.SCALE_SPRITE_1 * 1.8).easing(new cc.easeOut(ease_rate));
    //     var scaleDown = utilObj.getScaleTo(timeForAnim, constantsObj.SCALE_SPRITE_1 * 1.6).easing(new cc.easeOut(ease_rate));
    //     var fadeT1 = utilObj.getFadeTo(timeForAnim, constantsObj.OPACITY_100);
    //     var seqAction = [scaleUp, scaleDown];
    //     var seq = animObj.getSequence(seqAction, false);
    //     var params1 = {
    //         x: node.getPositionX(),
    //         y: node.getPositionY(),
    //         layer: layer,
    //         zOrder: constantsObj.UI_Z_ORDER + 2,
    //         scale: 2.5
    //     };
    //     utilObj.delayedCallback(layer, effectsObj.playDustEffect, 0.2, params1, false);
    //     label.runAction(fadeT1);
    //     node.runAction(seq);
    // };
    //
    // this.animateLabelsAfter = function (sender, params) {
    //     var node = params.node;
    //     var label = params.label;
    //     var layer = params.layer;
    //     var timeForAnim = 0.2;
    //     var ease_rate = 1;
    //     var fadeIn = animObj.getFadeIn(timeForAnim).easing(new cc.easeOut(ease_rate));
    //     node.runAction(fadeIn);
    //
    // };
    //
    // this.animateLabels = function (sender, params) {
    //     var time = 1.0;
    //     var timeForAnim = 0.2;
    //     var timeForAnim1 = 0.5;
    //     var ease_rate = 1;
    //     var node = params.node;
    //     var delay = utilObj.getDelayTime(time);
    //     var delay1 = utilObj.getDelayTime(0.1);
    //
    //     var fadeIn = animObj.getFadeIn(timeForAnim);
    //     var scaleUp = utilObj.getScaleTo(timeForAnim, 1.2).easing(new cc.easeOut(ease_rate));
    //     var zoomInAndMove = new cc.Spawn(fadeIn, scaleUp);
    //     var ease = zoomInAndMove.easing(new cc.easeOut(1.0));
    //
    //     var fadeOut = utilObj.getFadeTo(timeForAnim, constantsObj.OPACITY_80);
    //     var scaleDown = utilObj.getScaleTo(timeForAnim, 0.8).easing(new cc.easeOut(ease_rate));
    //     var zoomOutAndMove = new cc.Spawn(fadeOut, scaleDown);
    //     var ease1 = zoomOutAndMove.easing(new cc.easeOut(1.0));
    //
    //     var fadeTo = utilObj.getFadeTo(timeForAnim, constantsObj.OPACITY_50);
    //     var scaleUp1 = utilObj.getScaleTo(timeForAnim, 1).easing(new cc.easeOut(ease_rate));
    //     var zoomInAndMove1 = new cc.Spawn(fadeTo, scaleUp1);
    //     var ease2 = zoomInAndMove1.easing(new cc.easeOut(1.0));
    //
    //     var seqAction = [delay, ease, delay1, ease1, delay1, ease2];
    //     var seq = animObj.getSequence(seqAction, false);
    //     node.runAction(seq);
    // };

    this.getCardinalSplineTo = function (duration, points, tension) {
        var err = false;
        if (duration < 0) {
            loggerObj.errorLog("Cardinal spline duration < 0", duration);
            duration = 0;
            err = true;
        }

        for (var i = 0; i < points.length; i++) {
            var point = points[i];
            if (!utilObj.isValidPoint(point)) {
                loggerObj.errorLog("Invalid point passed to cardinal spline:", utilObj.getStringifiedJson(point));
                err = true;
            }
        }

        if (tension < 0) {
            loggerObj.errorLog("Invalid value for tension:", tension);
            err = true;
        }

        if (!err) {
            var spline = new cc.CardinalSplineTo(duration, points, tension);
            return spline;
        } else {
            return animObj.getDelayTime(duration);
        }
    };

    this.sideShow = function (index, firstDelay) {

        var anims = [];

        var preDelay = utilObj.getDelayTime(firstDelay);
        anims.push(preDelay);

        // create a sprite for banner here

        var imageForSideShow = constantsObj.achievement_banner;
        var textColor = constantsObj.COLOR_WHITE;
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            imageForSideShow = constantsObj.achv_toaster;
            textColor = constantsObj.COLOR_BLACK;
        }
        var banner = utilObj.getSprite(imageForSideShow, 0, 0, 0, 0.5, constantsObj.SCALE_SPRITE_7);
        utilObj.setPosition(banner, xLeftPos - canvasWidth, centerYPos + 160);
        if (curScreen == constantsObj.SCREEN_HOME) {
            utilObj.addChild(homeLayer, banner, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_CALENDAR) {
            utilObj.addChild(calendarLayer, banner, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_GAME) {
            utilObj.addChild(gameLayer, banner, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_PACK_INFO_LAYER) {
            utilObj.addChild(packInfoLayer, banner, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_ACHIEVEMENTS) {
            utilObj.addChild(achievementsLayer, banner, constantsObj.UI_Z_ORDER);
        } else {
            utilObj.addChild(popupLayer, banner, constantsObj.UI_Z_ORDER);
        }
        banner.setLocalZOrder(constantsObj.UI_Z_ORDER + 2);

        // create text Labels for achievement Title and description here
        var headingText = constantsObj.ACHIEVEMENTS_TITLES[index];
        var headingLbl = utilObj.getTTFFontLabel(headingText, constantsObj.FONT_ROBOTO_MEDIUM_60, textColor,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 370, 210, 0, 0.5, null, banner, constantsObj.UI_Z_ORDER + 1);
        utilObj.addChild(banner, headingLbl);

        var descText = constantsObj.ACHIEVEMENTS_DESCS[index];
        var textArr = [];
        textArr = utilObj.getSplitStringsArr(descText, 25);

        var yShift = 65;

        for (var i = 1; i <= textArr.length; i++) {
            var textLabel = utilObj.getTTFFontLabel(textArr[i - 1], constantsObj.FONT_ROBOTO_MEDIUM_40, textColor,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 370, 210 - yShift, 0, 0.5);
            //textLabel.setFontFillColor(constantsObj.COLOR_WHITE);
            utilObj.addChild(banner, textLabel);
            yShift += 50;
        }


        // then set the movements required while entering here

        var initialDelay = utilObj.getDelayTime(0.1);
        anims.push(initialDelay);

        var move1 = new cc.MoveTo(0.2, xLeftPos, centerYPos + 160);
        var ease1 = move1.easing(new cc.easeOut(10.0));
        anims.push(ease1);

        var midDelay = utilObj.getDelayTime(1.5);
        anims.push(midDelay);

        var move3 = new cc.MoveTo(0.2, xLeftPos - canvasWidth, centerYPos + 160);
        var ease3 = move3.easing(new cc.easeIn(1.0));
        anims.push(ease3);

        banner.runAction(utilObj.getSequence(anims));
        // animObj.runAction(banner, utilObj.getSequence(anims));

        // then set the movements required while leaving here

    };

    this.sideShowV2 = function (index, firstDelay , questDesc  ,questReward) {

        var anims = [];
        

        var preDelay = utilObj.getDelayTime(firstDelay);
        anims.push(preDelay);

        // create a sprite for banner here

        // var imageForSideShow = constantsObj.achievement_banner;
        // var textColor = constantsObj.COLOR_WHITE;
        // if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
        //     imageForSideShow = constantsObj.achv_toaster;
        //     textColor = constantsObj.COLOR_BLACK;
        // }
        var imageForSideShow = constantsObj.achv_toaster;
        var textColor = constantsObj.COLOR_BLACK;

        var banner = utilObj.getSprite(imageForSideShow, 0, 0, 0, 0.5, constantsObj.SCALE_SPRITE_7);
        utilObj.setPosition(banner, xLeftPos - canvasWidth, centerYPos + 160);
        if (curScreen == constantsObj.SCREEN_HOME) {
            utilObj.addChild(homeLayer, banner, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_CALENDAR) {
            utilObj.addChild(calendarLayer, banner, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_GAME) {
            utilObj.addChild(gameLayer, banner, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_PACK_INFO_LAYER) {
            utilObj.addChild(packInfoLayer, banner, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_ACHIEVEMENTS) {
            utilObj.addChild(achievementsLayer, banner, constantsObj.UI_Z_ORDER);
        } else if(curScreen == constantsObj.SCREEN_LINEAR_PROGRESSION){
            utilObj.addChild(linearLevelProgression, banner, constantsObj.UI_Z_ORDER);
        } else {
            utilObj.addChild(popupLayer, banner, constantsObj.UI_Z_ORDER);
        }
        banner.setLocalZOrder(constantsObj.UI_Z_ORDER + 2);


        // create text Labels for achievement Title and description here
        var headingText = "Quest Completed";
        // var headingLbl = utilObj.getTTFFontLabel(headingText, constantsObj.FONT_HELVETICA_MEDIUM_80, textColor,
        //     constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 370, 210, 0, 0.5, null, banner, constantsObj.UI_Z_ORDER + 1);
        var headingLbl = utilObj.getBMFontLabel(headingText, constantsObj.FONT_HELVETICA_MEDIUM_70, textColor,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), 320, 210, 0, 0.5, null, banner, constantsObj.UI_Z_ORDER + 1);
        utilObj.addChild(banner, headingLbl);

        var descText = questDesc;
        var textArr = [];
        textArr = utilObj.getSplitStringsArr(descText, 25);

        var yShift = 65;

        for (var i = 1; i <= textArr.length; i++) {
            var textLabel = utilObj.getBMFontLabel(textArr[i - 1], constantsObj.FONT_HELVETICA_MEDIUM_40, textColor,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), 320, 210 - yShift, 0, 0.5);
            //textLabel.setFontFillColor(constantsObj.COLOR_WHITE);
            utilObj.addChild(banner, textLabel);
            yShift += 50;
        }

        var xShift = 350;
        if(questReward >= 10){
            xShift = 330;
        }
        var questCoinLabel = utilObj.getBMFontLabel(questReward, constantsObj.FONT_HELVETICA_MEDIUM_65, textColor,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0),banner.getContentSize().width/2  + xShift ,banner.getContentSize().height/2 - 80, 0.5,0.5);
        utilObj.addChild(banner, questCoinLabel);

        var coinIcon  = utilObj.getSprite(constantsObj.coin_png_3, banner.getContentSize().width/2  + 420, banner.getContentSize().height/2 - 80, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.4);
        coinIcon.setLocalZOrder(constantsObj.UI_Z_ORDER + 2);
        utilObj.addChild(banner,coinIcon);

        // then set the movements required while entering here

        var initialDelay = utilObj.getDelayTime(0.1);
        anims.push(initialDelay);

        var move1 = new cc.MoveTo(0.2, xLeftPos, centerYPos + 160);
        var ease1 = move1.easing(new cc.easeOut(10.0));
        anims.push(ease1);

        var midDelay = utilObj.getDelayTime(1.5);
        anims.push(midDelay);

        var move3 = new cc.MoveTo(0.2, xLeftPos - canvasWidth, centerYPos + 160);
        var ease3 = move3.easing(new cc.easeIn(1.0));
        anims.push(ease3);

        banner.runAction(utilObj.getSequence(anims));
        // animObj.runAction(banner, utilObj.getSequence(anims));

        // then set the movements required while leaving here

    };

    this.showQuestIconAnimation = function (preDelay , img) {
        var anims = [];
        var preDelay = utilObj.getDelayTime(preDelay);
        anims.push(preDelay);

        var initialDelay = utilObj.getDelayTime(0.2);
        anims.push(initialDelay);

        var badgeSprite = utilObj.getSprite(img, 0, 0, 0.5, 0.5, constantsObj.SCALE_SPRITE_4);
        utilObj.setPosition(badgeSprite, centerXPos, centerYPos + 160);
        if (curScreen == constantsObj.SCREEN_HOME) {
            utilObj.addChild(homeLayer, badgeSprite, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_CALENDAR) {
            utilObj.addChild(calendarLayer, badgeSprite, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_GAME) {
            utilObj.addChild(gameLayer, badgeSprite, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_PACK_INFO_LAYER) {
            utilObj.addChild(packInfoLayer, badgeSprite, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_ACHIEVEMENTS) {
            utilObj.addChild(achievementsLayer, badgeSprite, constantsObj.UI_Z_ORDER);
        }else if(curScreen == constantsObj.SCREEN_LINEAR_PROGRESSION){
            utilObj.addChild(linearLevelProgression, badgeSprite, constantsObj.UI_Z_ORDER);
        }else {
            utilObj.addChild(popupLayer, badgeSprite, constantsObj.UI_Z_ORDER);
        }
        badgeSprite.setLocalZOrder(constantsObj.UI_Z_ORDER + 3);


        badgeSprite.setOpacity(0);

        var fadeIn = new cc.FadeIn(0);
        anims.push(fadeIn);

        var move1 = new cc.MoveTo(0.2, centerXPos - (canvasWidth) / 3, centerYPos + 160);
        var ease1 = move1.easing(new cc.easeIn(1.0));

        var scale1 = new cc.ScaleTo(0.2, constantsObj.SCALE_SPRITE_45);
        var actionForBadge = new cc.Spawn(ease1, scale1);

        anims.push(actionForBadge);

        var scale2 = new cc.ScaleTo(0.1, constantsObj.SCALE_SPRITE_39);
        anims.push(scale2);

        var midDelay = utilObj.getDelayTime(1.3);
        anims.push(midDelay);

        var move3 = new cc.MoveTo(0.2, xLeftPos - canvasWidth, centerYPos + 160);
        var ease3 = move3.easing(new cc.easeIn(1.0));
        anims.push(ease3);

        badgeSprite.runAction(utilObj.getSequence(anims));
        // animObj.runAction(badgeSprite, utilObj.getSequence(anims));
    };

    this.showBadgeAnimation = function (preDelay) {
        var anims = [];
        var preDelay = utilObj.getDelayTime(preDelay);
        anims.push(preDelay);

        var initialDelay = utilObj.getDelayTime(0.2);
        anims.push(initialDelay);

        var badgeSprite = utilObj.getSprite(constantsObj.badge_color_anim, 0, 0, 0.5, 0.5, constantsObj.SCALE_SPRITE_4);
        utilObj.setPosition(badgeSprite, centerXPos, centerYPos + 160);
        if (curScreen == constantsObj.SCREEN_HOME) {
            utilObj.addChild(homeLayer, badgeSprite, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_CALENDAR) {
            utilObj.addChild(calendarLayer, badgeSprite, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_GAME) {
            utilObj.addChild(gameLayer, badgeSprite, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_PACK_INFO_LAYER) {
            utilObj.addChild(packInfoLayer, badgeSprite, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_ACHIEVEMENTS) {
            utilObj.addChild(achievementsLayer, badgeSprite, constantsObj.UI_Z_ORDER);
        } else {
            utilObj.addChild(popupLayer, badgeSprite, constantsObj.UI_Z_ORDER);
        }
        badgeSprite.setLocalZOrder(constantsObj.UI_Z_ORDER + 3);


        badgeSprite.setOpacity(0);

        var fadeIn = new cc.FadeIn(0);
        anims.push(fadeIn);

        var move1 = new cc.MoveTo(0.2, centerXPos - (canvasWidth) / 3, centerYPos + 160);
        var ease1 = move1.easing(new cc.easeIn(1.0));

        var scale1 = new cc.ScaleTo(0.2, constantsObj.SCALE_SPRITE_45);
        var actionForBadge = new cc.Spawn(ease1, scale1);

        anims.push(actionForBadge);

        var scale2 = new cc.ScaleTo(0.1, constantsObj.SCALE_SPRITE_46);
        anims.push(scale2);

        var midDelay = utilObj.getDelayTime(1.3);
        anims.push(midDelay);

        var move3 = new cc.MoveTo(0.2, xLeftPos - canvasWidth, centerYPos + 160);
        var ease3 = move3.easing(new cc.easeIn(1.0));
        anims.push(ease3);

        badgeSprite.runAction(utilObj.getSequence(anims));
        // animObj.runAction(badgeSprite, utilObj.getSequence(anims));
    };

    this.showBadgeOutlineAnimation = function (preDelay) {
        var anims = [];

        var preDelay = utilObj.getDelayTime(preDelay);
        anims.push(preDelay);

        var initialDelay = utilObj.getDelayTime(0.4);
        anims.push(initialDelay);

        var badgeOutline = utilObj.getSprite(constantsObj.badge_outline_anim, 0, 0, 0.5, 0.5, constantsObj.SCALE_SPRITE_18);
        utilObj.setPosition(badgeOutline, centerXPos - (canvasWidth) / 3, centerYPos + 160);
        if (curScreen == constantsObj.SCREEN_HOME) {
            utilObj.addChild(homeLayer, badgeOutline, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_CALENDAR) {
            utilObj.addChild(calendarLayer, badgeOutline, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_GAME) {
            utilObj.addChild(gameLayer, badgeOutline, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_PACK_INFO_LAYER) {
            utilObj.addChild(packInfoLayer, badgeOutline, constantsObj.UI_Z_ORDER);
        } else if (curScreen == constantsObj.SCREEN_ACHIEVEMENTS) {
            utilObj.addChild(achievementsLayer, badgeOutline, constantsObj.UI_Z_ORDER);
        } else {
            utilObj.addChild(popupLayer, badgeOutline, constantsObj.UI_Z_ORDER);
        }
        //achievementsLayer.addChild(badgeOutline, constantsObj.UI_Z_ORDER);
        badgeOutline.setLocalZOrder(constantsObj.UI_Z_ORDER + 2);


        badgeOutline.setOpacity(0);

        var fadeIn = new cc.FadeIn(0);
        anims.push(fadeIn);

        var scale2 = new cc.ScaleTo(0.1, constantsObj.SCALE_SPRITE_46);
        anims.push(scale2);

        var midDelay = utilObj.getDelayTime(1.3);
        anims.push(midDelay);

        var move3 = new cc.MoveTo(0.2, xLeftPos - canvasWidth, centerYPos + 160);
        var ease3 = move3.easing(new cc.easeIn(1.0));
        anims.push(ease3);

        badgeOutline.runAction(utilObj.getSequence(anims));
        // animObj.runAction(badgeOutline, utilObj.getSequence(anims));
    };

    this.getSequence = function (seqAction, skipReport) {
        if (seqAction == null || seqAction == undefined || !utilObj.isArray(seqAction) || seqAction.length <= 1) {
            loggerObj.errorLog("Invalid values passed for seq:", seqAction);
            // if number of actions in the actions sequence is equal to 1, returning the 1st action here
            if(seqAction.length == 1){
                return seqAction[0];
            }
            return null;
        }

        skipReport = true;
        if (skipReport == undefined || skipReport == false) {
            var seqInfo = "";
            if (utilObj.isAndroid()) {
                seqInfo = loggerObj.getLineNumber(1, false);
            } else if (utilObj.isWeb()) {
                seqInfo = loggerObj.getLineNumber(2, true);
            }
            // loggerObj.debugLog("Seq info");
            // cc.log.apply(null, seqInfo);
            // Disabling reports for now
            // utilObj.sendReport(seqInfo);
        }
        return new cc.Sequence(seqAction);
    };

    this.getDelayTime = function (time) {
        if (time < 0) {
            loggerObj.errorLog("Delay time called with time < 0", time);
            time = 0;
        }
        var delayTime = new cc.DelayTime(time);
        return delayTime;
    };

    // Frenzy Animation

    // Used for Animating the Frenzy Word and make the dust effect on it.
    // Frenzy sprite is also animated here
    this.animateFrenzyWordTiles = function (sender, params) {
        var wordMap = params.wordMap;
        var startX = wordMap.startX;
        var startY = wordMap.startY;
        var endX = wordMap.endX;
        var endY = wordMap.endY;
        var timeForAnim = 0.2;
        var ease_rate = 1;

        gameLayer.frenzyMapForColoringTile = [];
        gameObj.setFrenzyAnimationStarted(true);
        // utilObj.playSound(constantsObj.FRENZY_SOUND, false);
        utilObj.delayedCallback(gameLayer, function () {
            gameObj.setFrenzyAnimationStarted(false);
        }, 3, null, false);
        for (var i = endX; i >= startX; i--) {
            for (var j = endY; j >= startY; j--) {

                // For gridTiles
                var colorTo = new cc.TintTo(0.1, 252, 0, 114);

                // SCALING OF THE GRIDTILES
                // var scaleUp = utilObj.getScaleTo(0.2, gameLayer.gridTileScale * 1.3).easing(new cc.easeOut(ease_rate));
                // var scaleDown = utilObj.getScaleTo(0.2, gameLayer.gridTileScale).easing(new cc.easeOut(ease_rate));
                // var colorAndScale = cc.Spawn(colorTo, scaleUp).easing(new cc.easeOut(ease_rate));
                // var seq = [colorTo];

                gameLayer.gridTiles[j][i].setLocalZOrder(constantsObj.FTUE_Z_ORDER);
                animObj.runAction(gameLayer.gridTiles[j][i], colorTo);
                gameLayer.frenzyMapForColoringTile.push(gameLayer.gridTiles[j][i]);

                var paramsTile = {
                    x: gameLayer.gridBg.getPositionX() + gameLayer.gridTiles[j][i].getPositionX(),
                    y: gameLayer.gridBg.getPositionY() + gameLayer.gridTiles[j][i].getPositionY(),
                    layer: gameLayer,
                    zOrder: constantsObj.UI_Z_ORDER,
                    scale: 1,
                    duration: 0.5
                };

                effectsObj.playTileEffect(gameLayer, paramsTile);
                // For gridLabels
                if (gameLayer.attemptGridLbls != undefined) {
                    if (gameLayer.attemptGridLbls[j] && gameLayer.attemptGridLbls[j][i]) {
                        // SCALING OF THE GRIDLABELS
                        // var scaleX = gameLayer.attemptGridLbls[j][i].getScaleX();
                        // var scaleY = gameLayer.attemptGridLbls[j][i].getScaleY();
                        // var scaleUp = utilObj.getScaleTo(0.2, scaleX * 1.3, scaleY * 1.3).easing(new cc.easeOut(ease_rate));
                        // var scaleDown = utilObj.getScaleTo(0.2, scaleX, scaleY).easing(new cc.easeOut(ease_rate));
                        // var seq = [scaleUp, scaleDown];

                        var colorToLabel = new cc.TintTo(0.1, 255, 255, 255);
                        animObj.runAction(gameLayer.attemptGridLbls[j][i], colorToLabel);
                    }
                }
            }
        }

        var delayForFrenzySprite = 0;
        // utilObj.playSound(constantsObj.FRENZY_SOUND, false);
        utilObj.delayedCallback(gameLayer, function () {
            if (gameObj.getSounds()) {
                utilObj.playSound(constantsObj.FRENZY_SOUND, false);
            }
        }, 0, null, false);

        // FRENZY SPRITE ANIMATION
        // var spriteFrenzy = utilObj.getSprite(constantsObj.subs_frenzyTxt, centerXPos, gameLayer.gridBg.getPositionY() + gameLayer.gridBg.getContentSize().height / 2, 0.5, 0.5, 1, null, null, constantsObj.UI_Z_ORDER, constantsObj.SPRITE_MISC);
        // utilObj.addChild(gameLayer, spriteFrenzy, 100);
        // spriteFrenzy.setOpacity(0);
        // spriteFrenzy.setScale(0);
        //
        // // gameObj.setcheckToShowFrenzyWordAnimation(true);
        // var Followup = utilObj.getDelayTime(0.4);
        // var fadeIn1 = animObj.getFadeIn(0.05);
        // var scaleUp1 = utilObj.getScaleTo(timeForAnim, 1.5).easing(new cc.easeOut(ease_rate));
        // var zoomInAndMove1 = new cc.Spawn(fadeIn1, scaleUp1);
        // var ease1 = zoomInAndMove1.easing(new cc.easeOut(1.0));
        // var scaleDown1 = utilObj.getScaleTo(timeForAnim, 1.3).easing(new cc.easeOut(ease_rate));
        // var scaleUp1 = utilObj.getScaleTo(timeForAnim, 1.2).easing(new cc.easeOut(ease_rate));
        // var scaleDown2 = utilObj.getScaleTo(timeForAnim, 0).easing(new cc.easeOut(ease_rate));
        // var fadeIn1 = animObj.getFadeTo(timeForAnim, 0);
        // var zoomInAndMove2 = new cc.Spawn(scaleDown2, fadeIn1);
        // var ease2 = zoomInAndMove2.easing(new cc.easeOut(1.0));
        // var remove = utilObj.getIndependentRemoveSelf();
        //
        // var seqAction2 = [Followup, ease1, utilObj.getDelayTime(0.1), scaleUp1, utilObj.getDelayTime(0.4), scaleDown1, ease2, remove];
        //
        // var params1 = {
        //     x: spriteFrenzy.getPositionX() - 350,
        //     y: spriteFrenzy.getPositionY() + 200,
        //     layer: gameLayer,
        //     scale: 0.8,
        //     zOrder: 30,
        //     scale: 1.2
        // };
        //
        // var params2 = {
        //     x: spriteFrenzy.getPositionX() + 350,
        //     y: spriteFrenzy.getPositionY() + 150,
        //     layer: gameLayer,
        //     scale: 0.8,
        //     zOrder: 30,
        //     scale: 1.8
        // };
        //
        // utilObj.delayedCallback(gameLayer, effectsObj.playStarEffect1, 0.5 + 0.15, params1, false);
        // utilObj.delayedCallback(gameLayer, effectsObj.playStarEffect1, 0.5 + 0.45, params2, false);
        //
        // animObj.runAction(gameLayer, cc.targetedAction(spriteFrenzy, utilObj.getSequence(seqAction2)));
        // delayForFrenzySprite += 1.4;


        var delayTime = 0.5 + delayForFrenzySprite;
        for (var i = endX; i >= startX; i--) {
            for (var j = endY; j >= startY; j--) {
                if (!utilObj.isNodeValid(gameLayer.gridTiles[j][i]) || !utilObj.isNodeValid(gameLayer.gridBg)) {
                    return;
                }
                var delay = utilObj.getDelayTime(delayTime);
                var scaleUp = utilObj.getScaleTo(timeForAnim, gameLayer.gridTileScale * 1.4).easing(new cc.easeOut(ease_rate));
                var scaleDown = utilObj.getScaleTo(timeForAnim, gameLayer.gridTileScale).easing(new cc.easeOut(ease_rate));
                var seqAction = [delay, scaleUp, scaleDown];
                animObj.runAction(gameLayer.gridTiles[j][i], utilObj.getSequence(seqAction));

                var params = {
                    x: gameLayer.gridBg.getPositionX() + gameLayer.gridTiles[j][i].getPositionX(),
                    y: gameLayer.gridBg.getPositionY() + gameLayer.gridTiles[j][i].getPositionY(),
                    layer: gameLayer,
                    zOrder: constantsObj.UI_Z_ORDER + 2,
                    scale: 1.5
                };
                utilObj.delayedCallback(gameLayer, effectsObj.playDustEffect, delayTime, params, false);
                delayTime += 0.15;
            }
        }


        for (var i = endX; i >= startX; i--) {
            for (var j = endY; j >= startY; j--) {
                var colorTo = new cc.TintTo(0.1, 255, 255, 255);
                var seq = [utilObj.getDelayTime(delayTime + 0.15), colorTo];
                animObj.runAction(gameLayer.gridTiles[j][i], utilObj.getSequence(seq));
                if (gameLayer.attemptGridLbls[j] && gameLayer.attemptGridLbls[j][i]) {
                    var colorToLabel = new cc.TintTo(0.1, 0, 0, 0);
                    var seq1 = [utilObj.getDelayTime(delayTime + 0.15), colorToLabel];
                    animObj.runAction(gameLayer.attemptGridLbls[j][i], utilObj.getSequence(seq1));
                }
            }
        }

        return delayTime;
    };

    // Frenzy letters are revealed here with animation from the tiles
    this.animateRevealLettersFrenzy = function (sender, params) {
        var initDelay = params.delay;
        var delay = utilObj.getDelayTime(initDelay);
        var tile = params.tile;
        var ease_rate = 1;

        if (!utilObj.isNodeValid(params.tile) || !utilObj.isNodeValid(params.label)) {
            return;
        }

        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1, stringsObj.frenzy, constantsObj.TRACK_VIEW, "", "", 1, "");

        animObj.moveRevealLetters(this, {
            node: params.tile,
            endX: params.endX,
            endY: params.endY,
            delay: delay,
            scale: gameLayer.gridTileScale
        });


        var spriteArr = [];
        var emptySprite = utilObj.getSprite(constantsObj.tile_white, params.tile.getPositionX(), params.tile.getPositionY(), 0.5, 0.5, 0.5, spriteArr, gameLayer, constantsObj.UI_Z_ORDER, constantsObj.SPRITE_MISC);
        utilObj.addSprites(spriteArr);
        emptySprite.setOpacity(0);

        var paramsTrail = {
            x: 58,
            y: 58,
            layer: emptySprite,
            zOrder: constantsObj.UI_Z_ORDER,
            scale: 1.5
        };

        var trailEffect = null;
        utilObj.delayedCallback(emptySprite, function (sender, params) {
            trailEffect = effectsObj.playTrailEffect(emptySprite, params.p);
        }, params.delay + 0.1, {p: paramsTrail}, false);
        var moveTo = utilObj.getMoveTo(0.9, params.endX, params.endY);
        var remove = utilObj.getIndependentRemoveSelf();
        var seq1 = [utilObj.getDelayTime(params.delay + 0.1), moveTo, remove];
        animObj.runAction(gameLayer, cc.targetedAction(emptySprite, utilObj.getSequence(seq1)));


        animObj.moveRevealLetters(this, {
            node: params.label,
            endX: params.endX,
            endY: params.endY,
            delay: delay,
            scale: params.finalScale

        });

        // var fadeIn = animObj.getFadeIn(0.1).easing(new cc.easeOut(ease_rate));
        // var seqAction = [delay, utilObj.getDelayTime(1.1), fadeIn];
        // animObj.runAction(tileToAnimate2, utilObj.getSequence(seqAction));

        var params1 = {
            x: params.endX,
            y: params.endY,
            layer: gameLayer,
            zOrder: constantsObj.FTUE_Z_ORDER + 2,
            scale: 0.3,
            duration: 0.8,
            opacity: 0.8
        };

        utilObj.delayedCallback(gameLayer, effectsObj.playThunderEffect1, params.delay + 0.9, params1, false);
    };

    // Function for the movement and scaling of the frenzy letters
    this.moveRevealLetters = function (sender, params) {
        var timeForAnim = 0.2;
        var ease_rate = 1;
        var scaleTo = utilObj.getScaleTo(timeForAnim + 0.05, params.scale * 2);
        var scaleIn = utilObj.getScaleTo(timeForAnim + 0.05, params.scale);
        var position1 = {
            x: params.node.getPositionX(),
            y: params.node.getPositionY()
        };
        var position2 = {
            x: params.endX,
            y: params.endY
        };
        var positions = [position1, position2];
        var move = animObj.getCardinalSplineTo(timeForAnim + 0.7, positions, 2);
        var scaleDown = utilObj.getFadeOut(0.5).easing(new cc.easeOut(ease_rate));
        var seq = [utilObj.getDelayTime(timeForAnim), scaleTo, scaleIn];
        var scaleUpandMove = new cc.Spawn(utilObj.getSequence(seq), move).easing(new cc.easeOut(ease_rate));
        var remove = utilObj.getIndependentRemoveSelf();
        var seqAction1 = [params.delay, scaleUpandMove, utilObj.getDelayTime(0.5), scaleDown, remove];
        animObj.runAction(params.node, utilObj.getSequence(seqAction1));
    };

    // ------- WeeklyReward Animation
    this.getScaleDifferentTo = function (duration, scaleX, scaleY) {
        if (duration < 0 || scaleX < 0 || scaleY < 0) {
            loggerObj.errorLog("Invalid params for scaling:", duration, scaleX, scaleY);
            duration = 0;
            scaleY = 0;
            scaleX = 0;
        }

        var scaleTo = new cc.ScaleTo(duration, scaleX, scaleY);
        return scaleTo;
    };

    this.animateGiftOpen1 = function (delay, time, zOrder, coins, starAchieved, milestones, layer, cashLabel) {

        // if (!utilObj.isNodeValid(homeLayer.gift) || !utilObj.isNodeValid(cashLabel)) {
        //     return;
        // }
        if (!utilObj.isNodeValid(cashLabel)) {
            return;
        }
        // loggerObj.debugLog("AnimRunning1", gameObj.getIsAnimShown());
        var params = {
            val: true
        };
        gameObj.setIsAnimShown(layer, params);
        // loggerObj.debugLog("AnimRunning2", gameObj.getIsAnimShown());
        var spriteArr = [];
        var labelArr = [];
        var spritesToRemove = [];

        var giftScale = 1.0;
        var giftTopScale = 1.2;

        var cover = utilObj.getScale9Sprite(constantsObj.black_80, xLeftPos, 0, 0, 0, canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset, spriteArr, layer, zOrder + 4, constantsObj.BOTTOM_BAR_OFFSET1);
        spritesToRemove.push(cover);
        // loggerObj.debugLog("AnimRunning3", xLeftPos + 310 + (weeklyQuestObj.getWeeklyQuestMilestones(2) / weeklyQuestObj.getWeeklyQuestTotalstars()) * 750, constantsObj.DESIGN_HEIGHT - 180, cashLabel.getPositionX(), cashLabel.getPositionY());

        var giftBot = utilObj.getSprite(constantsObj.giftbox, xLeftPos + 310 + (weeklyQuestObj.getWeeklyQuestMilestones(2) / weeklyQuestObj.getWeeklyQuestTotalstars()) * 750, constantsObj.DESIGN_HEIGHT - 180, 0.5, 0.5, giftScale, spriteArr, layer, zOrder + 10, constantsObj.SPRITE_LOCAL);
        var giftTop = utilObj.getSprite(constantsObj.cap, giftBot.getContentSize().width / 2, giftBot.getContentSize().height - 40, 0.5, 0, giftScale, spriteArr, giftBot, 0, constantsObj.SPRITE_LOCAL);
        utilObj.setScale(giftBot, 0);
        spritesToRemove.push(giftBot);
        spritesToRemove.push(giftTop);

        //box jumping effect
        var startPosX = xLeftPos + 310 + (weeklyQuestObj.getWeeklyQuestMilestones(2) / weeklyQuestObj.getWeeklyQuestTotalstars()) * 750;
        var startPosY = constantsObj.DESIGN_HEIGHT - 180;

        var endPositionX = centerXPos;
        var endPositionY = centerYPos - 100;

        var start = cc.p(startPosX, startPosY);
        var end = cc.p(endPositionX, endPositionY);
        var path1Mid = cc.p(startPosX - 100, startPosY - 100);
        var path1 = [start, path1Mid, end];
        var moveAnim1 = utilObj.getCardinalSpline(time, path1, 0);
        var easeOutMove1 = moveAnim1.easing(cc.easeOut(2));

        var animNew = [];
        animNew.push(animObj.getDelayTime(delay));
        var spawn = cc.Spawn(utilObj.getScaleTo(time, giftScale), easeOutMove1);
        animNew.push(spawn);
        animObj.runAction(giftBot, animObj.getSequence(animNew));


        var anims = [];
        anims.push(animObj.getDelayTime(delay));
        anims.push(animObj.getDelayTime(time));
        anims.push(animObj.getScaleDifferentTo(0.1, giftScale, giftScale * 0.9));
        anims.push(animObj.getScaleDifferentTo(0.1, giftScale, giftScale * 1.1));
        anims.push(utilObj.getScaleTo(0.1, giftScale));
        animObj.runAction(giftBot, animObj.getSequence(anims));


        var giftBot2 = utilObj.getSprite(constantsObj.giftbox, centerXPos, centerYPos - (giftBot.getContentSize().height * giftScale) / 2 - 100, 0.5, 0, giftScale, spriteArr, layer, zOrder + 10, constantsObj.SPRITE_LOCAL);
        var giftTop2 = utilObj.getSprite(constantsObj.cap, centerXPos, giftBot2.getPositionY() + giftBot2.getContentSize().height - 40, 0.5, 0, giftScale, spriteArr, layer, zOrder + 10, constantsObj.SPRITE_LOCAL);
        utilObj.setVisible(giftBot2, false);
        utilObj.setVisible(giftTop2, false);
        spritesToRemove.push(giftBot2);
        spritesToRemove.push(giftTop2);


        delay += 0.3;
        utilObj.delayedCallback(layer, function () {
            utilObj.setVisible(giftBot, false);
            utilObj.setVisible(giftBot2, true);
            utilObj.setScale(giftBot2, giftScale);
            utilObj.setVisible(giftTop2, true);
        }, delay + time, null, false);

        //milestones completion lable
        var milestoneLabel = null;
        if (starAchieved >= milestones[0] && starAchieved < milestones[1]) {
            milestoneLabel = utilObj.getBMFontLabel("Milestone Reached!", constantsObj.FONT_ROBOTO_BOLD_100, constantsObj.COLOR_WHITE, constantsObj.LABEL_AUTO_WIDTH,
                cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, centerYPos + 800, 0.5, 1.0, labelArr, layer, zOrder + 20);
            // utilObj.setScale(milestoneLabel, 0);
            utilObj.setOpacity(milestoneLabel, 0);
            var animArr = [];
            animArr.push(utilObj.getDelayTime(delay + time));
            animArr.push((new cc.Spawn(utilObj.getFadeTo(0.2, constantsObj.OPACITY_100), animObj.getMoveBy(0.15, 0, 200).easing(new cc.easeOut(1.0)))));
            // animArr.push((new cc.Spawn(utilObj.getFadeTo(0.2, constantsObj.OPACITY_100),utilObj.getScaleTo(0.12, 1.3))));
            animObj.runAction(milestoneLabel, utilObj.getSequence(animArr));
            // homeLayer.rewardAnim(delay + time,milestoneLabel, 1.3, constantsObj.OPACITY_100);
        }
        else if (starAchieved >= milestones[1] && starAchieved < milestones[2]) {
            milestoneLabel = utilObj.getBMFontLabel("Milestone Reached!", constantsObj.FONT_ROBOTO_BOLD_100, constantsObj.COLOR_WHITE, constantsObj.LABEL_AUTO_WIDTH,
                cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, centerYPos + 800, 0.5, 1.0, labelArr, layer, zOrder + 20);
            // utilObj.setScale(milestoneLabel, 0);
            utilObj.setOpacity(milestoneLabel, 0);
            var animArr = [];
            animArr.push(utilObj.getDelayTime(delay + time));
            animArr.push((new cc.Spawn(utilObj.getFadeTo(0.2, constantsObj.OPACITY_100),animObj.getMoveBy(0.15, 0, 200).easing(new cc.easeOut(1.0)))));
            animObj.runAction(milestoneLabel, utilObj.getSequence(animArr));
            // homeLayer.rewardAnim(delay + time,milestoneLabel, 1.3, constantsObj.OPACITY_100);
        }
        else {
            var str = "Weekly Quest Completed!";
            if (!gameObj.getIsThemedQuestLocked()) {
                str = "Themed Quest Completed!"
            }
            milestoneLabel = utilObj.getBMFontLabel(str, constantsObj.FONT_ROBOTO_BOLD_100, constantsObj.COLOR_WHITE, constantsObj.LABEL_AUTO_WIDTH,
                cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, centerYPos + 800, 0.5, 1.0, labelArr, layer, zOrder + 20);
            // utilObj.setScale(milestoneLabel, 0);
            utilObj.setOpacity(milestoneLabel, 0);
            var animArr = [];
            animArr.push(utilObj.getDelayTime(delay + time));
            animArr.push((new cc.Spawn(utilObj.getFadeTo(0.2, constantsObj.OPACITY_100), animObj.getMoveBy(0.15, 0, 200).easing(new cc.easeOut(1.0)))));
            // animArr.push( animObj.getMoveBy(0.15, 0, 250).easing(new cc.easeOut(1.0)));
            animObj.runAction(milestoneLabel, utilObj.getSequence(animArr));
            // homeLayer.rewardAnim(delay + time,milestoneLabel, 1.3,constantsObj.OPACITY_100);
        }
        spritesToRemove.push(milestoneLabel);

        // gift top open
        var animTopOpen = [];
        animTopOpen.push(animObj.getDelayTime(delay));
        animTopOpen.push(animObj.getDelayTime(time + 0.6));
        animTopOpen.push(animObj.getCardinalSplineTo(0.25, [{
            x: centerXPos - 100,
            y: centerYPos + 300 - 100
        }, {x: centerXPos - 250, y: centerYPos + 600}, {
            x: centerXPos - 350,
            y: giftBot2.getPositionY() - 30
        }], 0));
        animTopOpen.push(animObj.getScaleDifferentTo(0.05, giftScale * giftTopScale, giftScale * giftTopScale * 0.8));
        animTopOpen.push(animObj.getScaleDifferentTo(0.05, giftScale * giftTopScale, giftScale * giftTopScale));
        animObj.runAction(giftTop2, animObj.getSequence(animTopOpen));

        // reward anim after opening
        var rewardIconLocal = constantsObj.coin_png_2;
        var rewardIconLocalScale = 1.3;
        var rewardStrLocal = "+" + coins;
        var rewardStrLocalScale = 1.5;

        var rewardLbl = utilObj.getBMFontLabel(rewardStrLocal, constantsObj.FONT_ROBOTO_BOLD_90, constantsObj.COLOR_WHITE, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos + 140, centerYPos + 110 + 40 + 30 + 100 - 100, 0.5, 0.5, labelArr, layer, zOrder + 20);
        utilObj.setScale(rewardLbl, 0);
        utilObj.setOpacity(rewardLbl, 0);
        spritesToRemove.push(rewardLbl);
        homeLayer.rewardAnim(delay + time + 0.8 - 0.15 + 0.25, rewardLbl, 1.0);

        var glowColor1 = constantsObj.COLOR_WHITE;
        if (rewardIconLocal == constantsObj.coin_png_2) {
            glowColor1 = constantsObj.COLOR_YELLOW_06;
        }

        var glowScale1 = 0.48;
        var rewardCoin = utilObj.getSprite(rewardIconLocal, centerXPos - 140, centerYPos + 110 + 140 + 20 - 100, 0.5, 0.5, 1.3 * 1.2, spriteArr, layer, zOrder + 25, constantsObj.SPRITE_LOCAL);
        utilObj.setOpacity(rewardCoin, 0);
        // spritesToRemove.push(rewardCoin);

        var imgSize = rewardCoin.getContentSize();
        homeLayer.addRewardBgGlow(imgSize.width / 2, imgSize.height / 2, 0.5, 0.5, glowScale1, glowColor1, constantsObj.OPACITY_100, rewardCoin);
        utilObj.setScale(rewardCoin, 0);
        homeLayer.rewardAnim(delay + time + 0.8 - 0.15 + 0.25, rewardCoin, rewardIconLocalScale, false, true);


        // coing anim
        var animTopOpen = [];
        animTopOpen.push(animObj.getDelayTime(delay + time + 0.8 - 0.15 + 2.3));
        animTopOpen.push(animObj.getCardinalSplineTo(0.45, [{
            x: rewardCoin.getPositionX(),
            y: rewardCoin.getPositionY() + 240 + 20
        }, {
            x: cashLabel.getPositionX() - 130,
            y: cashLabel.getPositionY()
        }], 0).easing(new cc.easeIn(2)));
        animTopOpen.push(utilObj.getScaleTo(0.2, 0));
        animTopOpen.push(utilObj.getIndependentRemoveSelf());
        // animTopOpen.push(animObj.getScaleDifferentTo(0.05, giftScale * giftTopScale, giftScale * giftTopScale * 0.8));
        // animTopOpen.push(animObj.getScaleDifferentTo(0.05, giftScale * giftTopScale, giftScale * giftTopScale));
        animObj.runAction(rewardCoin, animObj.getSequence(animTopOpen));

        animObj.updateCashLbl1(cashLabel, coins, delay + time + 0.8 - 0.15 + 2.3 + 0.2, true, layer);


        var rewardRay = utilObj.getSprite(constantsObj.rays, centerXPos, centerYPos - 100 - 100 + 250, 0.5, 0, 1.3, spriteArr, layer, zOrder + 10, constantsObj.SPRITE_LOCAL);
        spritesToRemove.push(rewardRay);
        utilObj.setOpacity(rewardRay, 0);


        utilObj.setScale(rewardRay, 0);
        homeLayer.rewardAnim(delay + time + 0.8 - 0.15, rewardRay, 2.3, constantsObj.OPACITY_80);
        //var starImage=utilObj.getSprite(constantsObj.weekly_star, centerXPos, centerYPos-100 , 0.5, 0, 1.3, spriteArr, homeLayer, zOrder+25, constantsObj.SPRITE_LOCAL);

        //animObj.animateStar(this, {node: starImage, delay: delay + time + 0.8 + 0.3, finalScale: constantsObj.SCALE_SPRITE_4});

        var params1 = {
            x: centerXPos,
            y: centerYPos + 160 - 100,
            layer: layer,
            scale: 1,
            zOrder: zOrder + 25
        };

        // utilObj.delayedCallback(homeLayer, effectsObj.playWeeklyStarEffect, delay + time + 0.8 - 0.15, params1, false);
        utilObj.delayedCallback(layer, animObj.removeSpritesForWeeklyQuest, delay + time + 0.8 - 0.15 + 2.3, {spriteArr: spritesToRemove}, false);
        utilObj.delayedCallback(layer, gameObj.setIsAnimShown, delay + time + 0.8 - 0.15 + 2.4, {val: false}, false);
        // loggerObj.debugLog("AnimRunning3",gameObj.getIsAnimShown());


        utilObj.delayedCallback(layer, function (sender, params) {
            weeklyQuestEffect = effectsObj.playWeeklyStarEffect(layer, params.p);
        }, delay + time + 0.8 - 0.15, {p: params1}, false);

        // var param2 = {
        //     startPos:{x:}
        // }


        homeLayer.animArr = homeLayer.animArr.concat(spriteArr);
        homeLayer.animArr = homeLayer.animArr.concat(labelArr);

        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);
    };

    // animation for the streak completion
    this.animateStreakCompletion = function (delay, time, zOrder, coins, layer, cashLabel, streakType) {
        var animDelay = 0;
        if (!utilObj.isNodeValid(cashLabel)) {
            return animDelay;
        }
        var params = {
            val: true
        };
        gameObj.setIsAnimShown(layer, params);
        var spriteArr = [];
        var labelArr = [];
        var spritesToRemove = [];

        var giftScale = 1.0;
        var giftTopScale = 1.2;
        var scaleForStreak = 1;


        if (streakType == 2) {
            scaleForStreak = 1.2;
            giftScale *= 1.2;
        }

        var imageBottom = constantsObj.gift_streak_small_base_res;
        var imageTop = constantsObj.gift_streak_small_cap_res;
        if (streakType == 2) {
            imageBottom = constantsObj.gift_streak_big_base_res;
            imageTop = constantsObj.gift_streak_big_cap_res;
        }

        var cover = utilObj.getScale9Sprite(constantsObj.black_80, xLeftPos, 0, 0, 0, canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset, spriteArr, layer, zOrder + 4, constantsObj.BOTTOM_BAR_OFFSET1);
        spritesToRemove.push(cover);
        // loggerObj.debugLog("AnimRunning3", xLeftPos + 310 + (weeklyQuestObj.getWeeklyQuestMilestones(2) / weeklyQuestObj.getWeeklyQuestTotalstars()) * 750, constantsObj.DESIGN_HEIGHT - 180, cashLabel.getPositionX(), cashLabel.getPositionY());

        var giftBot = utilObj.getSprite(imageBottom, xLeftPos + 310 + (weeklyQuestObj.getWeeklyQuestMilestones(2) / weeklyQuestObj.getWeeklyQuestTotalstars()) * 750, constantsObj.DESIGN_HEIGHT - 180, 0.5, 0.5, giftScale, spriteArr, layer, zOrder + 10, constantsObj.SPRITE_LOCAL);
        var giftTop = utilObj.getSprite(imageTop, giftBot.getContentSize().width / 2, giftBot.getContentSize().height - 40, 0.5, 0, giftScale, spriteArr, giftBot, 0, constantsObj.SPRITE_LOCAL);
        utilObj.setScale(giftBot, 0);
        spritesToRemove.push(giftBot);
        spritesToRemove.push(giftTop);

        //box jumping effect
        var startPosX = xLeftPos + 310 + (weeklyQuestObj.getWeeklyQuestMilestones(2) / weeklyQuestObj.getWeeklyQuestTotalstars()) * 750;
        var startPosY = constantsObj.DESIGN_HEIGHT - 180;

        var endPositionX = centerXPos;
        var endPositionY = centerYPos - 100;

        var start = cc.p(startPosX, startPosY);
        var end = cc.p(endPositionX, endPositionY);
        var path1Mid = cc.p(startPosX - 100, startPosY - 100);
        var path1 = [start, path1Mid, end];
        var moveAnim1 = utilObj.getCardinalSpline(time, path1, 0);
        var easeOutMove1 = moveAnim1.easing(cc.easeOut(2));

        var animNew = [];
        animNew.push(animObj.getDelayTime(delay));
        var spawn = cc.Spawn(utilObj.getScaleTo(time, giftScale), easeOutMove1);
        animNew.push(spawn);
        animObj.runAction(giftBot, animObj.getSequence(animNew));


        var anims = [];
        var scaleTime = 0.3;
        anims.push(animObj.getDelayTime(delay));
        anims.push(animObj.getDelayTime(time));
        anims.push(animObj.getScaleDifferentTo(scaleTime/3, giftScale, giftScale * 0.9));
        anims.push(animObj.getScaleDifferentTo(scaleTime/3, giftScale, giftScale * 1.1));
        anims.push(utilObj.getScaleTo(scaleTime/3, giftScale));
        animObj.runAction(giftBot, animObj.getSequence(anims));


        var giftBot2 = utilObj.getSprite(imageBottom, centerXPos, centerYPos - (giftBot.getContentSize().height * giftScale) / 2 - 100, 0.5, 0, giftScale, spriteArr, layer, zOrder + 10, constantsObj.SPRITE_LOCAL);
        var giftTop2 = utilObj.getSprite(imageTop, centerXPos, giftBot2.getPositionY() + (giftBot2.getContentSize().height * giftScale) - 40, 0.5, 0, giftScale * scaleForStreak, spriteArr, layer, zOrder + 10, constantsObj.SPRITE_LOCAL);
        utilObj.setVisible(giftBot2, false);
        utilObj.setVisible(giftTop2, false);
        spritesToRemove.push(giftBot2);
        spritesToRemove.push(giftTop2);
        //

        delay += scaleTime;
        utilObj.delayedCallback(layer, function () {
            utilObj.setVisible(giftBot, false);
            utilObj.setVisible(giftBot2, true);
            utilObj.setScale(giftBot2, giftScale);
            utilObj.setVisible(giftTop2, true);
        }, delay + time, null, false);

        //
        var giftBotAnimTime = delay + time;
        //

        //milestones completion label
        var milestoneLabel = null;
        var str = "Congratulations!\nWeekly Streak Achieved!";
        var txtFont = constantsObj.FONT_ROBOTO_BOLD_100;
        var streakStatusArr = homeObj.getStreakStatusArr();
        if (streakStatusArr[1] == 1 || streakStatusArr[1] == 2) {
            str =  "Congratulations!\nComplete both of today's puzzles\nfor the Grand Reward!";
            txtFont = constantsObj.FONT_ROBOTO_BOLD_80;
        }
        if (streakType == 2) {
            str = "Congratulations!\nGrand Streak Achieved!"
        }
        milestoneLabel = utilObj.getBMFontLabel(str, txtFont, constantsObj.COLOR_WHITE, constantsObj.LABEL_AUTO_WIDTH,
            cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, centerYPos + 800, 0.5, 1.0, labelArr, layer, zOrder + 20);
        // utilObj.setScale(milestoneLabel, 0);
        utilObj.setOpacity(milestoneLabel, 0);
        var animArr = [];
        var fadeTime = 0.2;
        var moveTime = 0.15;
        animArr.push(utilObj.getDelayTime(delay + time));
        animArr.push((new cc.Spawn(utilObj.getFadeTo(fadeTime, constantsObj.OPACITY_100), animObj.getMoveBy(moveTime, 0, 200).easing(new cc.easeOut(1.0)))));
        // animArr.push( animObj.getMoveBy(0.15, 0, 250).easing(new cc.easeOut(1.0)));
        animObj.runAction(milestoneLabel, utilObj.getSequence(animArr));
        // homeLayer.rewardAnim(delay + time,milestoneLabel, 1.3,constantsObj.OPACITY_100);
        spritesToRemove.push(milestoneLabel);

        //
        var labelAnimTime = delay + time + Math.max(fadeTime, moveTime);
        //


        // gift top open
        var animTopOpen = [];
        var extraDelayTime = 0.6;
        moveTime = 0.25;
        scaleTime = 0.1;
        animTopOpen.push(animObj.getDelayTime(delay));
        animTopOpen.push(animObj.getDelayTime(time + extraDelayTime));
        animTopOpen.push(animObj.getCardinalSplineTo(moveTime, [{
            x: centerXPos - 100,
            y: centerYPos + 300 - 100
        }, {x: centerXPos - 250, y: centerYPos + 600}, {
            x: centerXPos - 350,
            y: giftBot2.getPositionY() - 30
        }], 0));
        animTopOpen.push(animObj.getScaleDifferentTo(scaleTime/2, giftScale * giftTopScale, giftScale * giftTopScale * 0.8));
        animTopOpen.push(animObj.getScaleDifferentTo(scaleTime/2, giftScale * giftTopScale, giftScale * giftTopScale));
        animObj.runAction(giftTop2, animObj.getSequence(animTopOpen));

        //
        var giftTopAnimTime = delay + time + extraDelayTime + moveTime + scaleTime;
        //

        // reward anim after opening
        var rewardIconLocal = constantsObj.coin_png_2;
        var rewardIconLocalScale = 1.3;
        var rewardStrLocal = "+" + coins;
        var rewardStrLocalScale = 1.5;

        var rewardLbl = utilObj.getBMFontLabel(rewardStrLocal, constantsObj.FONT_ROBOTO_BOLD_90, constantsObj.COLOR_WHITE, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos + 140, centerYPos + 110 + 40 + 30 + 100 - 100, 0.5, 0.5, labelArr, layer, zOrder + 20);
        utilObj.setScale(rewardLbl, 0);
        utilObj.setOpacity(rewardLbl, 0);
        spritesToRemove.push(rewardLbl);
        var homeRewardInitDelay = delay + time + 0.8 - 0.15 + 0.25; // make timing values clear here
        var rewardAnimTime = homeRewardInitDelay + homeLayer.rewardAnim(homeRewardInitDelay, rewardLbl, 1.0);

        var glowColor1 = constantsObj.COLOR_WHITE;
        if (rewardIconLocal == constantsObj.coin_png_2) {
            glowColor1 = constantsObj.COLOR_YELLOW_06;
        }

        var glowScale1 = 0.48;
        var rewardCoin = utilObj.getSprite(rewardIconLocal, centerXPos - 140, centerYPos + 110 + 140 + 20 - 100, 0.5, 0.5, 1.3 * 1.2, spriteArr, layer, zOrder + 25, constantsObj.SPRITE_LOCAL);
        utilObj.setOpacity(rewardCoin, 0);

        var imgSize = rewardCoin.getContentSize();
        homeLayer.addRewardBgGlow(imgSize.width / 2, imgSize.height / 2, 0.5, 0.5, glowScale1, glowColor1, constantsObj.OPACITY_100, rewardCoin);
        utilObj.setScale(rewardCoin, 0);
        rewardAnimTime = Math.max(rewardAnimTime, homeRewardInitDelay + homeLayer.rewardAnim(homeRewardInitDelay, rewardCoin, rewardIconLocalScale, false, true));


        // coing anim
        var animTopOpen = [];
        var coinInitDelay = delay + time + 0.8 - 0.15 + 2.3; // make timings clear here, hardcoded values make it difficult to change later on
        moveTime = 0.45;
        scaleTime = 0.2;
        animTopOpen.push(animObj.getDelayTime(coinInitDelay));
        animTopOpen.push(animObj.getCardinalSplineTo(moveTime, [{
            x: rewardCoin.getPositionX(),
            y: rewardCoin.getPositionY() + 240 + 20
        }, {
            x: cashLabel.getPositionX() - 130,
            y: cashLabel.getPositionY()
        }], 0).easing(new cc.easeIn(2)));
        animTopOpen.push(utilObj.getScaleTo(scaleTime, 0));
        animTopOpen.push(utilObj.getIndependentRemoveSelf());
        animObj.runAction(rewardCoin, animObj.getSequence(animTopOpen));

        //
        var coinAnimTime = coinInitDelay + moveTime + scaleTime;
        //

        var updateCashInitDelay = delay + time + 0.8 - 0.15 + 2.3 + 0.2; // make timings clear here
        var cashAnimTime = updateCashInitDelay;
        cashAnimTime += animObj.updateCashLbl1(cashLabel, coins, updateCashInitDelay, true, layer);

        var position = 0;
        if (streakType == 2) {
            position = ((scaleForStreak - 1) * giftBot2.getContentSize().height * giftScale) - 50 * scaleForStreak
        }

        var rewardRay = utilObj.getSprite(constantsObj.rays, centerXPos, centerYPos - 100 - 100 + 250 + position, 0.5, 0, 1.3 * scaleForStreak, spriteArr, layer, zOrder + 10, constantsObj.SPRITE_LOCAL);
        spritesToRemove.push(rewardRay);
        utilObj.setOpacity(rewardRay, 0);

        utilObj.setScale(rewardRay, 0);
        homeRewardInitDelay = delay + time + 0.8 - 0.15;
        rewardAnimTime = Math.max(rewardAnimTime, homeRewardInitDelay + homeLayer.rewardAnim(delay + time + 0.8 - 0.15, rewardRay, 2.3, constantsObj.OPACITY_80));

        var params1 = {
            x: centerXPos,
            y: centerYPos + 160 - 100 + position,
            layer: layer,
            scale: 1,
            zOrder: zOrder + 25
        };

        utilObj.delayedCallback(layer, animObj.removeSpritesForWeeklyQuest, delay + time + 0.8 - 0.15 + 2.3, {spriteArr: spritesToRemove}, false);
        utilObj.delayedCallback(layer, gameObj.setIsAnimShown, delay + time + 0.8 - 0.15 + 2.4, {val: false}, false);

        var effectExtraTime = 0.5;
        var effectDelay = delay + time + 0.8 - 0.15;
        utilObj.delayedCallback(layer, function (sender, params) {
            weeklyQuestEffect = effectsObj.playWeeklyStarEffect(layer, params.p);
        }, effectDelay, {p: params1}, false);
        //
        var effectAnimTime = effectDelay + effectExtraTime;
        //


        homeLayer.animArr = homeLayer.animArr.concat(spriteArr);
        homeLayer.animArr = homeLayer.animArr.concat(labelArr);

        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);
        animDelay = Math.max(giftBotAnimTime, labelAnimTime, giftTopAnimTime, rewardAnimTime, coinAnimTime, cashAnimTime, effectAnimTime);
        return animDelay;
    };

    this.updateCashLbl1 = function (node, cash, delayPlus, isGrantedAlready, layer) {
        if (!utilObj.isNodeValid(node)) {
            return 0;
        }
        var coinInc = parseInt(cash / 5);
        var n = 5;
        var extra = 0;
        if (cash < 5) {
            coinInc = 1;
            n = cash;
        }
        var cashAdd = economyObj.getCash() + coinInc;
        if (isGrantedAlready) {
            cashAdd -= cash;
        }
        if (cash > 5 && (cash % 5 != 0)) {
            cashAdd += cash % 5;
        }
        var callFunc;
        var delay;
        var actions = [];
        if (isGrantedAlready) {
            var params = {
                n: node,
                cA: economyObj.getCash() - cash
            };
            animObj.updateCoinCountAbsolute(layer, params);
        }
        var delayInit = utilObj.getDelayTime(delayPlus);
        actions.push(delayInit);
        var delayPerUpdate = 0.12;
        for (var i = 0; i < n; i++) {
            var params = {
                n: node,
                cA: cashAdd
            };
            callFunc = utilObj.getCallFunc(animObj.updateCoinCountAbsolute, layer, params);
            delay = utilObj.getDelayTime(delayPerUpdate);
            actions.push(callFunc);
            actions.push(delay);
            cashAdd += coinInc;
        }
        if (actions.length <= 1) {
            node.runAction(actions);
        } else {
            var seq = animObj.getSequence(actions, false);
            node.runAction(seq);
        }
        return (delayPerUpdate * n);
    };

    this.genericCoinLossAnimation = function(node, cash, delayPlus, isLostAlready, layer){
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        var coinDec = parseInt(cash / 5);
        var n = 5;
        var extra = 0;
        if (cash < 5) {
            coinDec = 1;
            n = cash;
        }
        var cashAdd = economyObj.getCash() - coinDec;
        if (isLostAlready) {
            cashAdd += cash;
        }
        if (cash > 5 && (cash % 5 != 0)) {
            cashAdd -= cash % 5;
        }
        var callFunc;
        var delay;
        var actions = [];
        if (isLostAlready) {
            var params = {
                n: node,
                cA: economyObj.getCash() + cash
            };
            animObj.updateCoinCountAbsolute(layer, params);
        }
        var delayInit = utilObj.getDelayTime(delayPlus);
        actions.push(delayInit);
        for (var i = 0; i < n; i++) {
            var params = {
                n: node,
                cA: cashAdd
            };
            callFunc = utilObj.getCallFunc(animObj.updateCoinCountAbsolute, layer, params);
            delay = utilObj.getDelayTime(0.12);
            actions.push(callFunc);
            actions.push(delay);
            cashAdd -= coinDec;
        }
        if (actions.length <= 1) {
            node.runAction(actions);
        } else {
            var seq = animObj.getSequence(actions, false);
            node.runAction(seq);
        }
    };

    this.updateCashLbl2 = function (node, cash, delayPlus, isGrantedAlready, layer) {
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        var coinInc = parseInt(cash / 5);
        var n = 5;
        var extra = 0;
        if (cash < 5) {
            coinInc = 1;
            n = cash;
        }
        var cashAdd = zenModeObj.getCurrentScore() + coinInc;
        if (isGrantedAlready) {
            cashAdd -= cash;
        }
        if (cash > 5 && (cash % 5 != 0)) {
            cashAdd += cash % 5;
        }
        var callFunc;
        var delay;
        var actions = [];
        if (isGrantedAlready) {
            var params = {
                n: node,
                cA: economyObj.getCash() - cash
            };
            animObj.updateCoinCountAbsolute(layer, params);
        }
        var delayInit = utilObj.getDelayTime(delayPlus);
        actions.push(delayInit);
        for (var i = 0; i < n; i++) {
            var params = {
                n: node,
                cA: cashAdd
            };
            callFunc = utilObj.getCallFunc(animObj.updateCoinCountAbsolute, layer, params);
            delay = utilObj.getDelayTime(0.12);
            actions.push(callFunc);
            actions.push(delay);
            cashAdd += coinInc;
        }
        if (actions.length <= 1) {
            node.runAction(actions);
        } else {
            var seq = animObj.getSequence(actions, false);
            node.runAction(seq);
        }
    };
    this.updateCoinCountAbsolute = function (sender, params) {
        utilObj.setString(params.n, (params.cA) + "");
    };

    this.getMoveBy = function (duration, deltaX, deltaY) {
        return new cc.MoveBy(duration, deltaX, deltaY);
    };

    this.removeSpritesForWeeklyQuest = function (parent, params) {
        var spritesToRemove = params.spriteArr;
        for (var i in spritesToRemove) {
            if (utilObj.isNodeValid(spritesToRemove[i])) {
                var fadeOut = utilObj.getFadeOut(0.15);
                var remove = utilObj.getIndependentRemoveSelf();
                var animArr = [fadeOut, remove]
                animObj.runAction(spritesToRemove[i], utilObj.getSequence(animArr));
            }
        }
        if (weeklyQuestEffect != null) {
            utilObj.setVisible(weeklyQuestEffect, false);
        }
        spritesToRemove = [];
    };

    this.moveHomeTodaySection = function (sender, params) {
        var node = params.node;
        // loggerObj.debugLog("check for the anim1 ");
        if (!utilObj.isNodeValid(node)) {
            // loggerObj.debugLog("check for the anim2 ");
            return 0;
        }
        // loggerObj.debugLog("check for the anim3 ");
        var xPos = node.getPosition().x;
        var yPos = node.getPosition().y;
        var yPosShift = params.yPosShift;
        var fadeDur = params.fadeDur;
        var anims = [];
        var preDelay = params.preDelay;
        var opacity = params.opacity;
        utilObj.setPosition(node, xPos, yPos - yPosShift);
        var initDelay = utilObj.getDelayTime(preDelay);
        anims.push(initDelay);
        var move = new cc.MoveTo(fadeDur, xPos, yPos);
        var ease = move.easing(new cc.easeOut(0.9));

        // loggerObj.debugLog("check for the anim4 ", node.getOpacity());
        var fadeIn = utilObj.getFadeTo(fadeDur, opacity);
        var spawn = cc.Spawn(ease, fadeIn);
        anims.push(spawn);
        animObj.runAction(node, utilObj.getSequence(anims));
        return fadeDur + preDelay;
    };

    this.timerFadeInAction = function (sender, params) {
        var node = params.node;
        if (!utilObj.isNodeValid(node)) {
            return 0;
        }
        var fadeDur = params.fadeDur;
        var preDelay = params.preDelay;
        var opacity = params.opacity;
        var anims = [];
        var initDelay = utilObj.getDelayTime(preDelay);
        anims.push(initDelay);
        var fadeIn = utilObj.getFadeTo(fadeDur, opacity);
        anims.push(fadeIn);
        animObj.runAction(node, utilObj.getSequence(anims));
    };

    this.tileFadeOutAction = function (sender, params) {
        var node = params.node;
        loggerObj.debugLog("coming here for scroll node1 ", utilObj.getStringifiedJson(params));
        if (!utilObj.isNodeValid(node)) {
            return 0;
        }
        var fadeDur = params.fadeDur;
        var preDelay = params.preDelay;
        var origScale = node.getScale();
        var scaleTo = params.scaleTo;
        //var opacity = params.opacity;
        var anims = [];
        var initDelay = utilObj.getDelayTime(preDelay);
        anims.push(initDelay);
        //var scaleDifferentTo = animObj.getScaleDifferentTo(0.1, origScale, origScale * 0.5);
        var scaleTo = utilObj.getScaleTo(fadeDur, scaleTo * origScale);//new cc.ScaleTo(fadeDur, scaleTo * origScale);
        var fadeOut = utilObj.getFadeOut(fadeDur);
        var spawn =  new cc.Spawn(scaleTo, fadeOut);
        anims.push(spawn);
        animObj.runAction(node, utilObj.getSequence(anims));

        if (params.scroll_node != undefined) {
            loggerObj.debugLog("coming here for scroll node ");
            var arr = params.scroll_node;
            for (var i = 0; i < arr.length; i++) {
                var params1 = {
                    node: arr[i],
                    yPosShift: params.yPosShift
                };
                utilObj.delayedCallback(homeLayer.scrollView, animObj.scrollBelowNode, 0.05, params1);
            }
        }
        if (params.today_bg != undefined) {
            var params2 = {
                node: params.today_bg,
                yPosShift: params.yPosShift,
                scaleFactor: params.scaleFactor,
                redrawForNoContent: params.redrawForNoContent
            };
            utilObj.delayedCallback(homeLayer, animObj.scrollTodayBg, 0.05, params2);
        }
    };

    this.scrollBelowNode = function (sender, params) {
        var node = params.node;
        if (!utilObj.isNodeValid(node)) {
            return 0;
        }
        var xPos = node.getPosition().x;
        var yPos = node.getPosition().y;
        var yPosShift = params.yPosShift;
        var dur = 0.5;
        var move = new cc.MoveTo(dur, xPos, yPos + yPosShift);
        var ease = move.easing(new cc.easeIn(1.0));
        animObj.runAction(node, ease);

        // setting anim false after run
        utilObj.delayedCallback(homeLayer, homeLayer.setAnimRunning, dur);
        utilObj.delayedCallback(homeLayer, homeLayer.redraw, dur);
    };

    this.scrollTodayBg = function (sender, params) {
        loggerObj.debugLog("check coming here to scroll" );
        var node = params.node;
        if (!utilObj.isNodeValid(node)) {
            loggerObj.debugLog("check coming here to scroll1" );
            return 0;
        }
        loggerObj.debugLog("check coming here to scroll2" );
        var origScale = 1;
        var dur = 0.5;
        var newScale = params.scaleFactor;
        loggerObj.debugLog("check for the scale factor ", newScale);
        var scaleDifferentTo = animObj.getScaleDifferentTo(dur, origScale, origScale * newScale);
        animObj.runAction(node, scaleDifferentTo);

        if (params.redrawForNoContent) {
            utilObj.delayedCallback(homeLayer, homeLayer.redraw, dur);
        }
    };

    this.tileScaleDownAction = function (sender, params) {
        var node = params.node;
        if (!utilObj.isNodeValid(node)) {
            loggerObj.debugLog("check coming here to scale down " );
            return 0;
        }
        var moveXPos = params.moveXPos;
        var xPos = node.getPosition().x;
        var yPos = node.getPosition().y;
        if (params.fadeDur == 0.1) {
            node.setOpacity(0);
        } else {
            var origScale = node.getScaleX();
            var fadeDur = params.fadeDur;
            var scaleValue = params.scaleTo;
            var scaleTo = utilObj.getScaleTo(fadeDur, scaleValue * origScale);
            var move = new cc.MoveTo(fadeDur, xPos + moveXPos, yPos);
            var spawn = cc.Spawn(scaleTo, move);
            animObj.runAction(node, spawn);
        }
    };

    this.removeTodayText = function (sende, params) {
        var node = params.node;
        if (!utilObj.isNodeValid(node)) {
            loggerObj.debugLog("check coming here to scale down " );
            return 0;
        }
        var fadeDur = params.fadeDur;
        var fadeOut = utilObj.getFadeOut(fadeDur);
        animObj.runAction(node, fadeOut);
    };

    this.getRotateBy = function (duration, angle) {
        return new cc.RotateBy(duration, angle);
    };

    this.getRotateTo = function (duration, rotation) {
        if (duration < 0) {
            loggerObj.errorLog("Invalid params for scaling:", duration);
            duration = 0;
            rotation = 0;
        }
        var rotateTo = new cc.RotateTo(duration, rotation, rotation);
        return rotateTo;
    };

    /**
     * nudge animation for jewel notification for packs on bottom Nav
     * @param sender
     * @param params
     */
    this.animateNudgePack = function (sender, params) {
        var icon = params.icon;
        var animCircle = params.animCircle;

        if (!utilObj.isNodeValid(icon) || !utilObj.isNodeValid(animCircle)) {
            return;
        }

        var scaleX = icon.getScaleX();
        var scaleY = icon.getScaleY();

        var multiplier = 0.8;

        var scaleUp = utilObj.getScaleTo(0.4 * multiplier, scaleX * 1.2, scaleY * 1.2);
        var scaleDown = utilObj.getScaleTo(0.4 * multiplier, scaleX, scaleY);

        var scaleCircle = animObj.getScaleDifferentTo(0.6 * multiplier, scaleX * 1.6, scaleY * 1.6);
        var fadeOut = utilObj.getFadeOut(0.6 * multiplier);
        var delay = utilObj.getDelayTime(0.78 * multiplier);
        var spawn = cc.Spawn([scaleCircle, fadeOut]);
        var scaleBack = animObj.getScaleDifferentTo(0.01 * multiplier, scaleX, scaleY);
        var fadeIn = utilObj.getFadeIn(0.01 * multiplier);

        var delay1 = utilObj.getDelayTime(1.2 * multiplier);
        var delay2 = utilObj.getDelayTime(0.6 * multiplier);


        var animSeq = [scaleUp, scaleDown, delay1];
        var animSeq2 = [delay, scaleBack, fadeIn, spawn, delay2];

        animObj.runAction(icon, cc.RepeatForever(utilObj.getSequence(animSeq)));
        animObj.runAction(animCircle, cc.RepeatForever(utilObj.getSequence(animSeq2)));
    };

    /**
     * shine animation for achievements jewel notifications
     * @param params
     */
    this.animateShine = function (params) {
        var node = params.node;
        if(!utilObj.isNodeValid(node)){
            return ;
        }
        utilObj.setVisible(node, true);
        var xPos = params.xPos;
        var firstAnimDelay = params.initAnimDelay;
        var initDelay = utilObj.getDelayTime(firstAnimDelay);

        var move1Delay = 1.15;
        var actionCallFunc = new cc.CallFunc(function () {
            var moveToOriginalPos = new cc.CallFunc(function () {
                utilObj.setPositionX(node , xPos);
            });
            var width = params.width;
            var move1 = new cc.MoveTo(1.15, node.getPositionX() + width + 200, node.getPositionY());

            var delay = utilObj.getDelayTime(2.0);
            var animSeq = [moveToOriginalPos, move1, delay];
            animObj.runAction(node,  new cc.RepeatForever(utilObj.getSequence(animSeq)));
        });

        var completeAnimSeq = [initDelay, actionCallFunc];
        animObj.runAction(node, utilObj.getSequence(completeAnimSeq));
        return (firstAnimDelay + move1Delay);
    };

    /**
     * Button Interactions
     */
    this.showBtnFeedBackZoomIn = function (node, nodeScale, child, childScale, type) {
        var delay = animationObj.getDelayTime(0);
        var scaleTo = 1;
        if (type == 1) {
            scaleTo = 1.1;
        }
        for (var i = 0; i < child.length; i++) {
            var img = child[i];
            if (utilObj.isNodeValid(img)) {
                var ease_rate = 1.0;
                var scaleUp = animationObj.getScaleTo(0.07, childScale[i] * scaleTo).easing(new cc.easeOut(ease_rate));
                var seqAction = [delay, scaleUp];
                var seq = animationObj.getSequence(seqAction, false);
                animationObj.runAction(img, seq);

            }
        }
        if (utilObj.isNodeValid(node)) {
            var ease_rate = 1.0;
            var scaleUp1 = animationObj.getScaleTo(0.07, nodeScale * scaleTo).easing(new cc.easeOut(ease_rate));
            var seqAction1 = [delay, scaleUp1];
            var seq1 = animationObj.getSequence(seqAction1, false);
            animationObj.runAction(node, seq1);

        }
    };

    /*
    * it is slight grey effect to be shown mainly in all black buttons with a white outline.
     */
    this.showBtnFeedBackGreyEffect = function(btnNode , child){
        if(utilObj.isNodeValid(btnNode)){
            btnNode.setColor(constantsObj.COLOR_WHITE);
            btnNode.setOpacity(constantsObj.OPACITY_60);
            utilObj.setOpacity(child , constantsObj.OPACITY_30);
        }
    };


    /*
    * it is the reverse effect of grey effect for black buttons.
     */
    this.callGreyEffectReverse = function(sender , params){
        var btnNode = params.p;
        var child = params.c;
        if(utilObj.isNodeValid(btnNode)){
            btnNode.setColor(constantsObj.COLOR_BLACK);
            btnNode.setOpacity(constantsObj.OPACITY_100);
            utilObj.setOpacity(child , constantsObj.OPACITY_60);
        }
    };

    /**
     *
     * @param node
     * @param nodeScale
     * @param child
     * @param childScale
     * @param type
     */
    this.showBtnFeedBackZoomOut = function (node, nodeScale, child, childScale, type) {
        var delay = animationObj.getDelayTime(0);
        var seqAction = [];
        var scaleUp, scaleDown;
        for (var i = 0; i < child.length; i++) {
            var img = child[i];
            if (utilObj.isNodeValid(img)) {
                var ease_rate = 1.0;
                if (type == 1) {
                    scaleDown = animationObj.getScaleTo(0.07, childScale[i] * 0.9).easing(new cc.easeOut(ease_rate));
                    scaleUp = animationObj.getScaleTo(0.07, childScale[i]).easing(new cc.easeOut(ease_rate));
                    seqAction = [delay, scaleDown, scaleUp];
                } else {
                    scaleDown = animationObj.getScaleTo(0.07, childScale[i] * 0.90).easing(new cc.easeOut(ease_rate));
                    seqAction = [delay, scaleDown];
                }
                var seq = animationObj.getSequence(seqAction, false);
                animationObj.runAction(img, seq);
            }
        }
        var seqAction1 = [];
        var scaleUp1, scaleDown1;
        if (utilObj.isNodeValid(node)) {
            var ease_rate = 1.0;
            if (type == 1) {
                scaleDown1 = animationObj.getScaleTo(0.07, nodeScale * 0.9).easing(new cc.easeOut(ease_rate));
                scaleUp1 = animationObj.getScaleTo(0.07, nodeScale).easing(new cc.easeOut(ease_rate));
                seqAction1 = [delay, scaleDown1, scaleUp1];
            } else {
                scaleDown1 = animationObj.getScaleTo(0.07, nodeScale * 0.90).easing(new cc.easeOut(ease_rate));
                seqAction1 = [delay, scaleDown1];
            }
            var seq1 = animationObj.getSequence(seqAction1, false);
            animationObj.runAction(node, seq1);
        }
    };

    /**
     * calls alpha layer fade in
     * @param node
     * @param child
     * @returns {number}
     */
    this.callBtnAlphaLayerFadeInAnimation = function (node, child) {
        // loggerObj.debugLog("darkenFeedBackBoundedLog: button fade animation called");
        var targetOpacity = constantsObj.OPACITY_10;
        var animationDelay = 0.07;
        var fadeDelay = 0.01;
        for (var i = 0; i < child.length; i++) {
            var childNode = child[i];
            var childNodeScale = utilObj.getSpriteScales(childNode);
            utilObj.setScaleX(childNode, 0.1);
            var scaleAnimation = animationObj.getScaleDifferentTo(animationDelay, childNodeScale.scaleX, childNodeScale.scaleY).easing(cc.easeIn(1.0));
            var fadeAnimation = animationObj.getFadeTo(fadeDelay, targetOpacity);
            animationObj.runAction(childNode, cc.Spawn([scaleAnimation, fadeAnimation]));
        }

        return Math.max(animationDelay, fadeDelay);
    };

    /**
     * calls alpha layer fade out animation for button feedback
     * @param node
     * @param child
     * @param deleteSelf
     * @param clippingNode
     */
    this.callBtnAlphaLayerFadeOutAnimation = function (node, child, deleteSelf) {
        var targetOpacity = constantsObj.OPACITY_0;
        var fadeDelay = 0.15;
        for (var i = 0; i < child.length; i++) {
            var childNode = child[i];
            var fadeAnimation = animationObj.getFadeTo(fadeDelay, targetOpacity);
            var animationSeq = [fadeAnimation];
            if(deleteSelf) {
                animationSeq.push(new cc.CallFunc(function () {
                    utilObj.removeChild(utilObj.getSpriteParent(childNode), childNode);
                }));
            }
            animationObj.runAction(childNode, animationObj.getSequence(animationSeq, false));
        }
        return fadeDelay;
    };


    /**
     * calls zoom in animation for button feedback by appropriate parameters
     * @param sender
     * @param params
     */
    this.callZoomIn = function (sender, params) {
        animationObj.showBtnFeedBackZoomIn(params.p, params.pS, params.c, params.cS, params.f);
    };

    /**
     * calls zoom out animation for button feedback by appropriate parameters
     * @param sender
     * @param params
     */
    this.callZoomOut = function (sender, params) {
        animationObj.showBtnFeedBackZoomOut(params.p, params.pS, params.c, params.cS, params.f);
    };

    /**
     * calls alpha layer fade out animation for button feedback by appropriate parameters
     * @param sender
     * @param params
     */
    this.callAlphaLayerFadeOutAnimation = function (sender, params) {
        animationObj.callBtnAlphaLayerFadeOutAnimation(params.p, params.c, params.dn);
    };

    /**
     * for animation to a particular scaling in the given duration
     * @param duration
     * @param scaleX
     * @param scaleY
     * @returns {*}
     */
    this.getScaleTo = function (duration, scaleX, scaleY) {
        if (duration < 0 || scaleX < 0) {
            //loggerObj.errorLog("Invalid params for scaling:", duration, scale);
            duration = 0;
            scaleX = 0;
            scaleY = 0;
        }
        var scaleTo = new cc.ScaleTo(duration, scaleX, scaleY);
        return scaleTo;
    };

    ///// ---------- Intro Outro animations

    /**
     *
     * @param params additional values required to do the animation
     * type -> which anim to trigger
     * arr -> input arr
     * dist -> move the elem by certain distances
     */
    this.animAllElements = function (sender, params) {

        var type = params.type;
        switch (type) {
            case constantsObj.FADE_IN_ALL:
                var arr = params.arr;
                for (var i in arr) {
                    if (utilObj.isNodeValid(arr[i])) {
                        var fadeIn = utilObj.getFadeIn(0.15).easing(cc.easeIn(1.0));
                        var moveBy = animObj.getMoveBy(0.15, 0, -100).easing(cc.easeIn(1.0));
                        var spawn = new cc.Spawn(fadeIn, moveBy);
                        animObj.runAction(arr[i], spawn);
                    }
                }
                break;

            case constantsObj.MOVE_ALL:
                var arr = params.arr;
                var dist = params.dist;
                for (var i in arr) {
                    if (utilObj.isNodeValid(arr[i])) {
                        var move = utilObj.getMoveBy(0.25, 0, dist).easing(cc.easeIn(1.0));
                        animObj.runAction(arr[i], move);
                    }
                }
                break;

            case constantsObj.SHRINK_BG:
                var bg = params.bg;
                var rationYTo = params.scaleYTo;
                if (!utilObj.isNodeValid(bg)) {
                    return;
                }
                var origScaleX = bg.getScaleX();
                var origScaleY = bg.getScaleY();
                var scaleTo = utilObj.getScaleTo(0.25, origScaleX, rationYTo * origScaleY).easing(cc.easeIn(1.0));
                animObj.runAction(bg, scaleTo);
                break;

            case constantsObj.FADE_OUT_ALL:
                var arr = params.arr;
                for (var i in arr) {
                    if (utilObj.isNodeValid(arr[i])) {
                        var fadeOut = utilObj.getFadeOut(0.5).easing(cc.easeIn(1.0));
                        animObj.runAction(arr[i], fadeOut);
                    }
                }
                break;

            case constantsObj.MOVE_CENTER_GRID:
                var node = params.node;
                var posToMoveX = params.endX;
                var posToMoveY = params.endY;
                if (!utilObj.isNodeValid(node)) {
                    return;
                }
                var scaleX = node.getScaleX();
                var scaleY = node.getScaleY();
                var animArr = [];
                var moveTo = utilObj.getMoveTo(0.25, posToMoveX, posToMoveY).easing(cc.easeIn(1.0));
                var scaleTo = utilObj.getScaleTo(0.25, scaleX * 1.4, scaleY * 1.4).easing(cc.easeIn(1.0));
                var spawn = new cc.Spawn(moveTo, scaleTo);
                animArr.push(spawn);
                var scaleIn = utilObj.getScaleTo(1, scaleX * 1.1, scaleY * 1.1).easing(cc.easeIn(1.0));
                var fadeOut = utilObj.getFadeOut(0.6);
                var spawn2 = new cc.Spawn(scaleIn, fadeOut);
                animArr.push(spawn2);
                animObj.runAction(node, utilObj.getSequence(animArr));
                break;

            case constantsObj.FRENZY_GLOW:
                var node1 = params.node;
                utilObj.setVisible(node1, true);
                var scaleTo = animObj.getScaleDifferentTo(1, 16, 16).easing(cc.easeIn(1.0));
                var delay = utilObj.getDelayTime(0.7);
                var fadeOut = utilObj.getFadeOut(0.3).easing(cc.easeIn(1.0));
                var animArr = [];
                animArr.push(delay);
                animArr.push(fadeOut);

                var spawn = new cc.Spawn(scaleTo, utilObj.getSequence(animArr));
                animObj.runAction(node1, spawn);
                break;

            case constantsObj.SEEWRONG_MOVE:
                var node = params.node;
                var posToMoveX = params.endX;
                var posToMoveY = params.endY;
                if (!utilObj.isNodeValid(node)) {
                    return;
                }
                var scaleX = node.getScaleX();
                var scaleY = node.getScaleY();
                var animArr = [];
                var moveTo = utilObj.getMoveTo(0.25, posToMoveX, posToMoveY).easing(cc.easeIn(1.0));
                // var scaleTo = utilObj.getScaleTo(0.5, scaleX * 1.4, scaleY * 1.4);
                // var spawn = new cc.Spawn(moveTo, scaleTo);
                animArr.push(moveTo);
                var scaleIn = utilObj.getScaleTo(0.5, scaleX * 0.4, scaleY * 0.4).easing(cc.easeIn(1.0));
                var fadeOut = utilObj.getFadeOut(0.35).easing(cc.easeIn(1.0));
                var spawn2 = new cc.Spawn(scaleIn, fadeOut);
                animArr.push(spawn2);
                animObj.runAction(node, utilObj.getSequence(animArr));
                break;

            case constantsObj.FADE_IN:
                var arr = params.arr;
                for (var i in arr) {
                    if (utilObj.isNodeValid(arr[i])) {
                        var fadeIn = utilObj.getFadeIn(0.5);
                        animObj.runAction(arr[i], fadeIn);
                    }
                }
                break;
            case constantsObj.FADE_IN_SCALE:
                var arr = params.arr;
                for (var i in arr) {
                    if (utilObj.isNodeValid(arr[i])) {
                        var fadeIn = utilObj.getFadeIn(0.5).easing(cc.easeIn(1.0));
                        var scaleX = arr[i].getScaleX();
                        var scaleY = arr[i].getScaleY();
                        var scaleTo = utilObj.getScaleTo(0.5, scaleX * 1.15, scaleY * 1.15).easing(cc.easeIn(1.0));
                        var scaleDown = utilObj.getScaleTo(0.5, scaleX , scaleY).easing(cc.easeIn(1.0));
                        var spawn = new cc.Spawn(fadeIn, scaleTo);
                        var animArr = [];
                        animArr.push(spawn, scaleDown);
                        animObj.runAction(arr[i], utilObj.getSequence(animArr));
                    }
                }
                gameObj.updateIsSeeWrongActive();
                break;
        }
    };


    //------------ ///////////////

    this.checkAndTriggerPowerAnim = function () {
        if(newIntroLayer.ifNewIntroAvailable() && curScreen == constantsObj.SCREEN_NEW_INTRO && gameObj.getW2ePowerUpVideo()){
            gameObj.setW2ePowerUpVideo(false);
            if (newIntroLayer.powerUps[constantsObj.FREE_LETTERS_POWERUP] == true) {
                newIntroLayer.powerUps[constantsObj.FREE_LETTERS_POWERUP] = false;
            }
          newIntroLayer.playAnimAfterPlayClick();
        }else {
            if ((introOutroRevampExp == constantsObj.EXP_VAR_1 || introOutroRevampExp == constantsObj.EXP_VAR_2) && curScreen == constantsObj.SCREEN_GAME && gameObj.getW2ePowerUpVideo()) {
                gameObj.setW2ePowerUpVideo(false);
                if (newIntroLayer.powerUps[constantsObj.FREE_LETTERS_POWERUP] == true) {
                    newIntroLayer.powerUps[constantsObj.FREE_LETTERS_POWERUP] = false;
                }

                gameLayer.showPowerUpUI();
            }
        }

    };


    // ------ outro animations ---------
    /**
     *
     * @param params additional values required to do the animation
     * type -> which anim to trigger
     */
    this.outroAnimations = function (sender, params) {
        var type = params.case;
        if (type == undefined) {
            return;
        }
        switch (type) {
            case constantsObj.OUTRO_OVERLAY_FADEIN:
                if (utilObj.isNodeValid(params.node)) {
                    var fadeIn = utilObj.getFadeTo(params.animDelay, params.opacity).easing(new cc.easeIn(1.0));
                    animObj.runAction(params.node, fadeIn);
                }
                break;

            case constantsObj.OUTRO_MAIN_TEXT:
                if (utilObj.isNodeValid(params.node)) {
                    var initDelay = utilObj.getDelayTime(params.animDelay);
                    var scale1 = new cc.ScaleTo(params.delay / 2, params.scale * 1.25).easing((cc.easeOut(1)));
                    var scale2 = new cc.ScaleTo(params.delay / 2, params.scale).easing((cc.easeOut(1)));
                    var seq = new cc.Sequence([initDelay, scale1, scale2]);
                    animObj.runAction(params.node, seq);
                }
                break;

            case constantsObj.OUTRO_SUB_TEXT:
                if (utilObj.isNodeValid(params.node)) {
                    var initDelay = utilObj.getDelayTime(params.animDelay);
                    var subTextFadeIn = utilObj.getFadeTo(params.delay, params.opacity).easing(new cc.easeIn(1.0));
                    var seq = new cc.Sequence([initDelay, subTextFadeIn]);
                    animObj.runAction(params.node, seq);
                }
                break;

            case constantsObj.OUTRO_CONFETTI_PLIST1:
                utilObj.delayedCallback(transOutroLayer, effectsObj.playConfettiEffect, params.animDelay, params, false);
                break;

            case constantsObj.OUTRO_CONFETTI_PLIST2:
                utilObj.delayedCallback(transOutroLayer, effectsObj.playConfettiEffect, params.animDelay, params, false);
                break;

            case constantsObj.OUTRO_MAIN_TEXT_FADE_OUT:
                if (utilObj.isNodeValid(params.node)) {
                    var initDelay = utilObj.getDelayTime(params.animDelay);
                    var scaleOut1 = new cc.ScaleTo(params.delay / 2, params.scale * 1.25).easing((cc.easeOut(1)));
                    var scaleOut2 = new cc.ScaleTo(params.delay / 2, 0).easing((cc.easeOut(1)));
                    var seq = new cc.Sequence([initDelay, scaleOut1, scaleOut2]);
                    animObj.runAction(params.node, seq);
                }
                break;

            case constantsObj.OUTRO_SUB_TEXT_FADE_OUT:
                if (utilObj.isNodeValid(params.node)) {
                    var initDelay = utilObj.getDelayTime(params.animDelay);
                    var subTextFadeOut = utilObj.getFadeTo(params.delay / 2, 0).easing(new cc.easeIn(1.0));
                    var seq = new cc.Sequence([initDelay, subTextFadeOut]);
                    animObj.runAction(params.node, seq);
                }
                break;

            case constantsObj.OUTRO_FADE_IN_TOP_PART:
                var arrForSecondAnim = params.node;
                for(var i = 0; i < arrForSecondAnim.length; i++) {
                    if (utilObj.isNodeValid(arrForSecondAnim[i])) {
                        arrForSecondAnim[i].setOpacity(0);
                        var initDelay = utilObj.getDelayTime(params.animDelay);
                        var fadeInAnim = utilObj.getFadeTo(params.delay, constantsObj.OPACITY_100).easing(new cc.easeIn(1.0));
                        var seq = new cc.Sequence([initDelay, fadeInAnim]);
                        animObj.runAction(arrForSecondAnim[i], seq);
                    }
                }
                break;

            case constantsObj.OUTRO_MASTERY_ANIM:
                var starAnimNode = params.node;
                if (!utilObj.isNodeValid(starAnimNode)) {
                    break;
                }
                var origScale = starAnimNode.getScale();
                var initDelay1 = utilObj.getDelayTime(params.initDelayTime + params.animDelay);
                var animTime = params.animTime;
                var scaleDown = new cc.ScaleTo(animTime, origScale / 5).easing((cc.easeOut(1)));
                var fadeIn = utilObj.getFadeTo(animTime, constantsObj.OPACITY_100).easing(new cc.easeIn(1.0));
                var spawn = new cc.Spawn([scaleDown, fadeIn]);
                var seq1 = new cc.Sequence([initDelay1, spawn]);
                animObj.runAction(starAnimNode, seq1);

                var i = params.index;
                var tqMastery = params.collectible;
                if (tqMastery != undefined && tqMastery != null && utilObj.isNodeValid(tqMastery)) {
                    var actions = [];
                    var callFunc;
                    var delay;
                    var p = {
                        lbl: tqMastery,
                        score: (params.mastery + i + 1)
                    };
                    callFunc = utilObj.getCallFunc(transOutroLayer.updateScoreLbl, transOutroLayer, p);
                    delay = animObj.getDelayTime(params.initDelayTime + params.animDelay + animTime);
                    actions.push(delay);
                    actions.push(callFunc);
                    var seq = animObj.getSequence(actions, false);
                    tqMastery.runAction(seq);
                }

                var stopDelay = params.stopDelay;
                var initDelay2 = utilObj.getDelayTime(params.initDelayTime + params.animDelay + animTime + stopDelay);
                var scaleUp = new cc.ScaleTo(0.1, (origScale / 5) * 1.25).easing((cc.easeOut(1)));
                var scaleDown = new cc.ScaleTo(0.1, origScale / 5).easing((cc.easeOut(1)));
                var seq2 = new cc.Sequence([initDelay2, scaleUp, scaleDown]);
                animObj.runAction(starAnimNode, seq2);

                var xPos = params.xPos;
                var localYPos = params.yPos;
                var zOrder = params.zOrder;
                var xValue = xPos - 350;
                var yValue = localYPos - 70;
                if (i == 1) {
                    xValue = xPos;
                    yValue = localYPos;
                } else if (i == 2) {
                    xValue = xPos + 350;
                    yValue = localYPos - 70;
                }
                var params1 = {
                    x: xValue,
                    y: yValue,
                    layer: transOutroLayer,
                    zOrder: zOrder + 1,
                    scale: 2
                };
                utilObj.delayedCallback(transOutroLayer, effectsObj.playStarOutroEffect, (params.initDelayTime + params.animDelay + animTime + stopDelay + 0.05), params1, false);
                break;

            case constantsObj.OUTRO_QUEST_FADE_IN_ANIM:
                if (utilObj.isNodeValid(params.node)) {
                    var initDelay = utilObj.getDelayTime(params.animDelay);
                    var fadeIn = utilObj.getFadeTo(0.1, params.opacity).easing(new cc.easeIn(1.0));
                    var seq = new cc.Sequence([initDelay, fadeIn]);
                    animObj.runAction(params.node, seq);
                }
                break;

            case constantsObj.OUTRO_FADE_OUT_TOP_PART:
                if (utilObj.isNodeValid(params.node)) {
                    var initDelay = utilObj.getDelayTime(params.animDelay);
                    var fadeOut = utilObj.getFadeTo(params.animTime, 0).easing(new cc.easeIn(1.0));
                    var seq = new cc.Sequence([initDelay, fadeOut]);
                    animObj.runAction(params.node, seq);
                }
                break;

            case constantsObj.OUTRO_FADE_IN_BELOW_PART:
                if (utilObj.isNodeValid(params.node)) {
                    var initDelay = utilObj.getDelayTime(params.animDelay);
                    var fadeIn = utilObj.getFadeTo(params.animTime, params.opacity).easing(new cc.easeIn(1.0));
                    var seq = new cc.Sequence([initDelay, fadeIn]);
                    animObj.runAction(params.node, seq);
                }
                break;

            case constantsObj.OUTRO_SHRINK_BG:
                utilObj.delayedCallback(transOutroLayer, animObj.animAllElements, params.animDelay, {
                    type: constantsObj.SHRINK_BG,
                    bg: params.bg,
                    scaleYTo: params.scaleYTo
                });
                break;
        }
    };

    this.blitzRewardAnimation = function (sender, params) {
        var type = params.case;
        if (type == undefined) {
            return;
        }
        switch (type) {
            case constantsObj.OUTRO_OVERLAY_FADEIN:
                if (utilObj.isNodeValid(params.node)) {
                    var animDelay = 0;
                    if (params.animDelay != undefined) {
                        animDelay = params.animDelay;
                    }
                    var initDelay = utilObj.getDelayTime(animDelay);
                    var fadeIn = utilObj.getFadeTo(params.animDur, params.opacity).easing(new cc.easeIn(1.0));
                    var seq = new cc.Sequence([initDelay, fadeIn]);
                    animObj.runAction(params.node, seq);
                }
                break;

            case constantsObj.HEADER_TEXT_FADEIN:
                if (utilObj.isNodeValid(params.node)) {
                    var fadeIn = utilObj.getFadeTo(params.animDur, params.opacity).easing(new cc.easeIn(1.0));
                    animObj.runAction(params.node, fadeIn);
                }
                break;

            case constantsObj.MILESTONE_TILE_ANIM:
                if (utilObj.isNodeValid(params.node)) {
                    var scale = params.node.getScale();
                    var scaleFrom = params.scaleFrom;
                    var scaleTo = params.scaleTo;
                    var initDelay = utilObj.getDelayTime(params.animDelay);
                    var fadeIn = utilObj.getFadeTo(params.animFadeDur, params.opacity).easing(new cc.easeIn(1.0));
                    var scale1 = new cc.ScaleTo(0, scaleFrom).easing((cc.easeOut(1)));
                    var scale2 = new cc.ScaleTo(params.animScaleUpDur, scale * 1.1).easing((cc.easeOut(1)));
                    var scale3 = new cc.ScaleTo(params.animScaleDownDur, scale).easing((cc.easeOut(1)));
                    var seq = new cc.Sequence([initDelay, fadeIn, scale1, scale2, scale3]);
                    animObj.runAction(params.node, seq);
                }
                break;

            case constantsObj.MILESTONE_MOVE_DOWN:
                if (utilObj.isNodeValid(params.node)) {
                    var node = params.node;
                    var scaleDown = 0.75;
                    if (params.scaleDown) {
                        scaleDown = params.scaleDown;
                    }
                    var yShift = 200;
                    if (params.yShift) {
                        yShift = params.yShift;
                    }
                    var scale = node.getScale();
                    var initDelay = utilObj.getDelayTime(params.animDelay);
                    var moveTo = utilObj.getMoveTo(params.animDur, node.getPositionX(), 60 + yShift).easing(cc.easeIn(1.0));
                    var scaleTo = new cc.ScaleTo(params.animDur, scale * scaleDown).easing((cc.easeOut(1)));
                    var spawn = new cc.Spawn([scaleTo, moveTo]);
                    var seq = new cc.Sequence([initDelay, spawn]);
                    animObj.runAction(node, seq);
                }
                break;

            case constantsObj.PROGRESS_POINTER_ANIM:
                var progressArr = params.node;
                var progressDelay = params.animDur;
                if (progressArr != undefined) {
                    for (var i = 0; i < progressArr.length; i++) {
                        progressArr[i].setOpacity(0);
                        var xPos = progressArr[i].getPosition().x;
                        var yPos = progressArr[i].getPosition().y;
                        var yPosShift = 50;
                        utilObj.setPosition(progressArr[i], xPos, yPos + yPosShift);
                        var anims = [];
                        var delayAction = utilObj.getDelayTime(params.animDelay);
                        anims.push(delayAction);
                        var move = new cc.MoveTo(progressDelay, xPos, yPos);
                        var ease = move.easing(new cc.easeOut(0.9));
                        var fadeIn = utilObj.getFadeTo(progressDelay, params.opacity);
                        var spawn = new cc.Spawn(ease, fadeIn);
                        anims.push(spawn);
                        animObj.runAction(progressArr[i], utilObj.getSequence(anims));
                    }
                }
                break;

            case constantsObj.PROGRESS_POINTER_FADE_OUT_ANIM:
                var progressArr = params.node;
                if (progressArr != undefined) {
                    for (var i = 0; i < progressArr.length; i++) {
                        var initDelay = utilObj.getDelayTime(params.animDelay);
                        var fadeOut = utilObj.getFadeTo(params.animDur, 0).easing(new cc.easeIn(1.0));
                        var seq = new cc.Sequence([initDelay, fadeOut]);
                        animObj.runAction(progressArr[i], seq);
                    }
                }
                break;

            case constantsObj.TICK_ICON_FADE_IN:
                if (utilObj.isNodeValid(params.node)) {
                    var initDelay = utilObj.getDelayTime(params.animDelay);
                    var fadeIn = utilObj.getFadeTo(params.animDur, params.opacity).easing(new cc.easeIn(1.0));
                    var seq = new cc.Sequence([initDelay, fadeIn]);
                    animObj.runAction(params.node, seq);
                }
                break;

            case constantsObj.REWARD_LBL_FADE_IN:
                var node = params.node;
                if (utilObj.isNodeValid(node)) {
                    var scale = node.getScale();
                    var initDelay = utilObj.getDelayTime(params.animDelay);
                    var fadeIn = utilObj.getFadeTo(params.animFadeDur, params.opacity).easing(new cc.easeIn(1.0));
                    var spawn = new cc.Spawn(utilObj.getScaleTo(params.animMoveDur, scale * params.scaleUp), utilObj.getMoveTo(params.animMoveDur, node.getPositionX(), node.getPositionY() + 150)).easing(new cc.easeOut(1.0));
                    var seq = new cc.Sequence([initDelay, fadeIn, spawn]);
                    animObj.runAction(node, seq);
                }
                break;

            case constantsObj.REWARD_COIN_FADE_IN:
                var node = params.node;
                if (utilObj.isNodeValid(node)) {
                    var scale = node.getScale();
                    var initDelay = utilObj.getDelayTime(params.animDelay);
                    var fadeIn = utilObj.getFadeTo(params.animFadeDur, params.opacity).easing(new cc.easeIn(1.0));
                    var spawn = new cc.Spawn(utilObj.getScaleTo(params.animMoveDur, scale * params.scaleUp), utilObj.getMoveTo(params.animMoveDur, node.getPositionX(), node.getPositionY() + 400)).easing(new cc.easeOut(1.0));
                    var seq = new cc.Sequence([initDelay, fadeIn, spawn]);
                    animObj.runAction(node, seq);
                }
                break;
            case constantsObj.REWARD_COIN_MOVE_DOWN_AND_FADE_OUT:
                var node = params.node;
                if (utilObj.isNodeValid(node)) {
                    var nodePos = utilObj.getSpriteCoordinates(node);
                    var initDelay = utilObj.getDelayTime(params.animDelay);
                    var fadeIn = utilObj.getFadeTo(params.animFadeDur, params.opacity).easing(new cc.easeIn(1.0));
                    var startPosition = nodePos;
                    var endPosition = params.moveToPos;
                    var start = cc.p(startPosition.xPos, startPosition.yPos);
                    var end = cc.p(endPosition.xPos, endPosition.yPos);
                    var pathMid = cc.p((endPosition.xPos + startPosition.xPos)/2, (startPosition.yPos + endPosition.yPos)/2);
                    var path = [start, pathMid, end];
                    var moveAndScaleDownAnim = cc.Spawn(utilObj.getCardinalSpline(params.animMoveDur, path, 0).easing(cc.easeOut(2)), utilObj.getScaleTo(params.animMoveDur, params.scaleUp));
                    var removeSelf = utilObj.getIndependentRemoveSelf();
                    var seq = new cc.Sequence([initDelay, fadeIn, moveAndScaleDownAnim, removeSelf]);
                    animObj.runAction(node, seq);
                }
                break;

            case constantsObj.REWARD_RAY_ANIM:
                var node = params.node;
                if (utilObj.isNodeValid(node)) {
                    var scale = params.scaleUp;
                    var initDelay = utilObj.getDelayTime(params.animDelay);
                    var spawn = new cc.Spawn(utilObj.getFadeIn(params.animDur), utilObj.getScaleTo(0.12, scale * 1.3));
                    var seq = new cc.Sequence([initDelay, spawn]);
                    animObj.runAction(node, seq);
                }
                break;

            case constantsObj.MILESTONE_TILE_FADE_OUT:
                var node = params.node;
                if (utilObj.isNodeValid(node)) {
                    var initDelay = utilObj.getDelayTime(params.animDelay);
                    var fadeOut = utilObj.getFadeTo(params.animDur, params.opacity).easing(new cc.easeIn(1.0));
                    var seq = new cc.Sequence([initDelay, fadeOut]);
                    animObj.runAction(node, seq);
                }
                break;

            case constantsObj.HEADER_TEXT_FADE_OUT:
                var node = params.node;
                if (utilObj.isNodeValid(node)) {
                    var initDelay = utilObj.getDelayTime(params.animDelay);
                    var fadeOut = utilObj.getFadeTo(params.animDur, params.opacity).easing(new cc.easeIn(1.0));
                    var seq = new cc.Sequence([initDelay, fadeOut]);
                    animObj.runAction(node, seq);
                }
                break;

            case constantsObj.FADE_OUT_GIFT_ITEM:
                var node = params.node;
                if (utilObj.isNodeValid(node)) {
                    var initDelay = utilObj.getDelayTime(params.animDelay);
                    var fadeOut = utilObj.getFadeTo(params.animDur, params.opacity).easing(new cc.easeIn(1.0));
                    var seq = new cc.Sequence([initDelay, fadeOut]);
                    animObj.runAction(node, seq);
                }
                break;

            case constantsObj.SCALE_DOWN_MILESTONE_TILE:
                var node = params.node;
                if (utilObj.isNodeValid(node)) {
                    var initDelay = utilObj.getDelayTime(params.animDelay);
                    var scaleTo = new cc.ScaleTo(params.animDur, 0).easing((cc.easeOut(1)));
                    var seq = new cc.Sequence([initDelay, scaleTo]);
                    animObj.runAction(node, seq);
                }
                break;

            case constantsObj.NEW_MILESTNE_TILE_APPEAR:
                var node = params.node;
                if (utilObj.isNodeValid(node)) {
                    var scale = params.scale;
                    var initDelay = utilObj.getDelayTime(params.animDelay);
                    var scaleUp = new cc.ScaleTo(params.animDur / 2, scale).easing((cc.easeOut(1)));
                    var scaleDown = new cc.ScaleTo(params.animDur / 2, scale * 0.75).easing((cc.easeOut(1)));
                    var seq = new cc.Sequence([initDelay, scaleUp, scaleDown]);
                    animObj.runAction(node, seq);
                }
                break;
        }
    };

    /**
     * wrapper for stopAllActions
     * @param node
     */
    this.stopAllActions = function (node) {
        if(!utilObj.isNodeValid(node)){
            return;
        }

        node.stopAllActions();
    };

    /**
     * wrapper function for fadeOut
     * @param duration
     * @returns {*}
     */
    this.getFadeOut = function (duration) {
        return new cc.FadeOut(duration);
    };

    /**
     * wrapper function for fadeIn
     * @param duration
     * @returns {*}
     */
    this.getFadeIn = function (duration) {
        return new cc.FadeIn(duration);
    };

    /**
     * this function handles the complete animation daily bonus reward grant
     * @param giftBoxSprite
     * @param giftBoxClone
     * @param capSpriteClone
     * @param cashLbl
     * @returns {number}
     */
    this.grantDailyBonusRewardAnimation = function (giftBoxSprite, giftBoxClone, capSpriteClone, cashLbl) {
        if(!utilObj.isNodeValid(giftBoxSprite) || !utilObj.isNodeValid(giftBoxClone) || !utilObj.isNodeValid(capSpriteClone) || !utilObj.isNodeValid(cashLbl)){
            return 0;
        }

        var spriteArr = [];
        var labelArr = [];
        var giftBoxCloneScale = utilObj.getScale(giftBoxClone);
        var giftBoxCloneZOrder = utilObj.getSpriteZOrder(giftBoxClone);
        var giftBoxCloneDimensions = utilObj.getSpriteDimensions(giftBoxClone);
        var scaleMultiplier = 1.6;
        var initialPosition = utilObj.getSpriteCoordinates(giftBoxSprite);
        var finalPos = {xPos: centerXPos, yPos: initialPosition.yPos};
        var spritesToRemove = [];
        var spritesToRemoveAfterDelay = [];

        var initialDelayDuration = 0.06;
        var scaleDuration = 0.5;
        var moveDuration = 0.5;
        var fadeOutDuration = 0.10;

        var midDelayDuration = 0.2;
        var scaleDownDuration = 0.2;
        var scaleUpDuration = 0.2;
        var scaleNormalDuration = 0.2;

        var UiState = dailyBonusLayer.getUiState();

        if (UiState == 1) {
            var cashLblArr = dailyBonusLayer.getCashLblArr();
            for(var j = 0; j < cashLblArr.length; j++) {
                animObj.fadeInAnimation(curLayer, {node: cashLblArr[j], fadeDur: initialDelayDuration});
            }
        }

        var localTime = new Date().toLocaleDateString();
        if (localTime == undefined || localTime == null) {
            localTime = "na";
        }

        var points = [];
        var point1 = {x: initialPosition.xPos, y: initialPosition.yPos};
        points.push(point1);
        var point2 = {x: (initialPosition.xPos + finalPos.xPos)/2 , y: finalPos.yPos};
        points.push(point2);
        var point3 = {x: finalPos.xPos, y: finalPos.yPos};
        points.push(point3);

        var initDelayAction = animObj.getDelayTime(initialDelayDuration);
        var scaleByAction =  new cc.ScaleBy(scaleDuration, scaleMultiplier);
        var fadeOutAction = animObj.getFadeOut(fadeOutDuration);
        var moveToAction = animObj.getCardinalSplineTo(moveDuration, points, 0).easing(new cc.easeIn(1));
        var spawnActionGiftBox = new cc.Spawn(scaleByAction, fadeOutAction, moveToAction);
        animObj.runAction(giftBoxSprite, animObj.getSequence([initDelayAction, spawnActionGiftBox], false));


        var scaleByActionClone = new cc.ScaleBy(scaleDuration, scaleMultiplier);
        var moveToActionClone = animObj.getCardinalSplineTo(moveDuration, points, 0).easing(new cc.easeIn(1));
        var spawnActionClone = new cc.Spawn(scaleByActionClone, moveToActionClone);
        var midDelayActionClone = animObj.getDelayTime(midDelayDuration);
        var currentGiftBoxCloneScale = giftBoxCloneScale * scaleMultiplier;
        var currentGiftBoxCloneDimensions = {width: giftBoxCloneDimensions.width * scaleMultiplier, height: giftBoxCloneDimensions.height * scaleMultiplier};

        var scaleDownActionClone = animObj.getScaleDifferentTo(scaleDownDuration, currentGiftBoxCloneScale, currentGiftBoxCloneScale * 0.9);
        var scaleUpActionClone = animObj.getScaleDifferentTo(scaleUpDuration, currentGiftBoxCloneScale, currentGiftBoxCloneScale * 1.3);
        var scaleNormalActionClone = animObj.getScaleDifferentTo(scaleNormalDuration, currentGiftBoxCloneScale, currentGiftBoxCloneScale);
        animObj.runAction(giftBoxClone, animObj.getSequence([spawnActionClone, midDelayActionClone, scaleDownActionClone, scaleUpActionClone, scaleNormalActionClone]));

        var capInitialDelayDuration = moveDuration + midDelayDuration + scaleDownDuration;
        var capDelayAction = animObj.getDelayTime(capInitialDelayDuration);
        var capDisappearAction = new cc.CallFunc(function () {
            utilObj.setVisible(capSpriteClone, false);
        });
        animObj.runAction(capSpriteClone, animObj.getSequence([capDelayAction, capDisappearAction], false));

        // adding a new clone of cap sprite here
        var newCapSprite = utilObj.getSpriteClone(capSpriteClone);
        utilObj.addChild(curLayer, newCapSprite, giftBoxCloneZOrder + 2);
        utilObj.setOpacity(newCapSprite, constantsObj.OPACITY_0);

        var newCapScale = utilObj.getScale(newCapSprite) * currentGiftBoxCloneScale;
        var newCapDelayTime = capInitialDelayDuration;
        var newCapMoveDuration = 0.25;
        var newCapScaleDownDuration = 0.1;
        var newCapScaleUpDuration = 0.15;
        var newCapScaleNormalDuration = 0.1;

        var newCapInitialPosition = utilObj.getSpriteCoordinates(newCapSprite);
        var newCapDelayAction = animObj.getDelayTime(newCapDelayTime);
        var newCapPoints = [];

        // calculating new cap sprite position on screen using the dimensions and scale of the box sprite
        var newCapGlobalPositionX = finalPos.xPos;
        var newCapGlobalPositionY = finalPos.yPos - currentGiftBoxCloneDimensions.height/2 + newCapInitialPosition.yPos * currentGiftBoxCloneScale;
        var newCapGlobalPosition = {xPos: newCapGlobalPositionX, yPos: newCapGlobalPositionY};
        //
        var newCapPoint1 = {x: newCapGlobalPosition.xPos, y: newCapGlobalPosition.yPos};
        newCapPoints.push(newCapPoint1);
        var newCapPoint2 = {x: newCapGlobalPosition.xPos - 80, y: newCapGlobalPosition.yPos + 320};
        newCapPoints.push(newCapPoint2);
        var newCapPoint3 = {x: newCapGlobalPosition.xPos - 240, y: newCapGlobalPosition.yPos - currentGiftBoxCloneDimensions.height + 120};
        newCapPoints.push(newCapPoint3);

        var newCapUpdateAction = new cc.CallFunc(function () {
            utilObj.setSpriteScales(newCapSprite, newCapScale, newCapScale);
            utilObj.setPosition(newCapSprite, newCapGlobalPosition.xPos, newCapGlobalPosition.yPos);
            utilObj.setOpacity(newCapSprite, constantsObj.OPACITY_100);
        });

        var newCapMoveToAction = animObj.getCardinalSplineTo(newCapMoveDuration, newCapPoints, 0).easing(new cc.easeIn(1));
        var newCapScaleDownAction = animObj.getScaleDifferentTo(newCapScaleDownDuration, newCapScale, newCapScale * 0.9);
        var newCapScaleUpAction = animObj.getScaleDifferentTo(newCapScaleUpDuration, newCapScale, newCapScale * 1.2);
        var newCapScaleNormalAction = animObj.getScaleDifferentTo(newCapScaleNormalDuration, newCapScale, newCapScale);
        animObj.runAction(newCapSprite, animObj.getSequence([newCapDelayAction, newCapUpdateAction, newCapMoveToAction, newCapScaleDownAction, newCapScaleUpAction, newCapScaleNormalAction], false));
        spritesToRemove.push(newCapSprite);
        //

        var rewardRay = utilObj.getSprite(constantsObj.rays, finalPos.xPos, finalPos.yPos + (currentGiftBoxCloneDimensions.height)/2 - 40, 0.5, 0, 1.8, spriteArr, curLayer, giftBoxCloneZOrder  , constantsObj.SPRITE_LOCAL);
        utilObj.setScale(rewardRay, 0);
        spritesToRemove.push(rewardRay);
        var raysAnimDuration = homeLayer.rewardAnim(capInitialDelayDuration, rewardRay, 2.6, constantsObj.OPACITY_80);

        // for text fadeInAnim
        if (UiState == 2) {
            var rewardText = utilObj.getBMFontLabel(stringsObj.rewardText, constantsObj.FONT_HELVETICA_70, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, finalPos.yPos - 300, 0.5, 0.5, labelArr, curLayer, giftBoxCloneZOrder + 1);
            spritesToRemove.push(rewardText);
            utilObj.setOpacity(rewardText, constantsObj.OPACITY_0);
            animObj.fadeInAnimation(curLayer, {node: rewardText, fadeDur: 0.5});
        }

        // particle effect added here
        var params1 = {
            x: finalPos.xPos,
            y: finalPos.yPos + (currentGiftBoxCloneDimensions.height)/2 - 35,
            layer: homeLayer,
            scale: 1,
            zOrder: giftBoxCloneZOrder + 1,
            duration: 0.5
        };

        utilObj.delayedCallback(homeLayer, function (sender, params) {
            effectsObj.playWeeklyStarEffect(homeLayer, params.p);
        }, capInitialDelayDuration, {p: params1}, false);

        // coin appearing and grant animation here
        var coinGrantDelay = capInitialDelayDuration + raysAnimDuration;
        var rewardToGive = dailyBonusObj.getRewardToGiveToUser();
        if (UiState == 2) {
            rewardToGive = dailyBonusObj.getRewardToGiveToUser(true);
        }
        var rewardString = "db1_reward_anim";
        if (UiState == 2) {
            rewardString = "db2_reward_anim";
        }
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", localTime, constantsObj.TRACK_DB, rewardString, dailyBonusObj.getBucketForUser(), "", 1, "");

        var coinImg1 = utilObj.getSprite(constantsObj.coin_png_2, finalPos.xPos - 50, finalPos.yPos + (currentGiftBoxCloneDimensions.height)/2 - 38, 0.5, 0.5, constantsObj.SCALE_SPRITE_9 * 1.25, spriteArr, curLayer, giftBoxCloneZOrder + 1 , constantsObj.SPRITE_MISC);
        utilObj.setOpacity(coinImg1, constantsObj.OPACITY_0);
        if (UiState == 1) {
            spritesToRemove.push(coinImg1);
        } else {
            spritesToRemoveAfterDelay.push(coinImg1);
        }

        var rewardValue = utilObj.getBMFontLabel(rewardToGive, constantsObj.FONT_HELVETICA_MEDIUM_100, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), finalPos.xPos + 40, finalPos.yPos + (currentGiftBoxCloneDimensions.height)/2 - 30 , 0, 0.5, labelArr, curLayer, giftBoxCloneZOrder + 1 );
        utilObj.setOpacity(rewardValue, constantsObj.OPACITY_0);
        spritesToRemove.push(rewardValue);

        var durationfadeIn = 0.05;
        var durationMoveUpCoin = 0.2;

        var fadeInCoin1 = utilObj.getFadeIn(durationfadeIn);
        var fadeInCoin2 = utilObj.getFadeIn(durationfadeIn);
        var moveBy1 = animObj.getMoveBy(durationMoveUpCoin, 0, 290);
        var moveBy2 = animObj.getMoveBy(durationMoveUpCoin, 0, 290);

        var spawn1 = new cc.Spawn(fadeInCoin1, moveBy1);
        var spawn2 = new cc.Spawn(fadeInCoin2, moveBy2);

        var move1 = utilObj.getScaleTo(durationMoveUpCoin, 1.8);
        var move2 = utilObj.getScaleTo(durationMoveUpCoin, constantsObj.SCALE_SPRITE_9 * 1.25 * 1.8);

        var spawn11 = new cc.Spawn(spawn1, move1);
        var spawn22 = new cc.Spawn(spawn2, move2);

        animObj.runAction(coinImg1, utilObj.getSequence([utilObj.getDelayTime(coinGrantDelay), spawn11]));
        animObj.runAction(rewardValue, utilObj.getSequence([utilObj.getDelayTime(coinGrantDelay), spawn22]));

        // for video success
        var extraDelayVideo = 0.5;

        // coin move  anim
        var animCoinMove = [];
        var coinMoveDuration = 0.65;
        var coinScaleDuration = 0.2;
        animCoinMove.push(animObj.getDelayTime(coinGrantDelay + durationfadeIn + durationMoveUpCoin + extraDelayVideo));
        animCoinMove.push(animObj.getCardinalSplineTo(coinMoveDuration, [{
            x: coinImg1.getPositionX(),
            y: coinImg1.getPositionY() + 290
        }, {
            x: cashLbl.getPositionX() - 130,
            y: cashLbl.getPositionY()
        }], 0).easing(new cc.easeIn(2)));
        animCoinMove.push(utilObj.getScaleTo(coinScaleDuration, 0));
        animCoinMove.push(utilObj.getIndependentRemoveSelf());
        animObj.runAction(coinImg1, animObj.getSequence(animCoinMove));
        var updateLblDelay = animObj.updateCashLbl1(cashLbl, rewardToGive, coinGrantDelay + durationMoveUpCoin + coinMoveDuration + coinScaleDuration + extraDelayVideo, false, curLayer);

        var orderCash = constantsObj.TRACK_DB;
        if (UiState == 2) {
            orderCash = constantsObj.TRACK_DB_W2E;
        }
        economyObj.addCash(rewardToGive, constantsObj.TRACK_EARN, orderCash, dailyBonusObj.getBucketForUser());

        // ------------


        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);

        var giftBoxAnimDuration = initialDelayDuration + scaleDuration;
        var giftBoxCloneAnimDuration = scaleDuration + midDelayDuration + scaleDownDuration + scaleUpDuration +scaleNormalDuration;
        var capAnimDuration = capInitialDelayDuration;
        var newCapAnimDuration = newCapDelayTime + newCapMoveDuration + newCapScaleDownDuration + newCapScaleUpDuration+ newCapScaleNormalDuration;
        var raysAnimDuration = capInitialDelayDuration + raysAnimDuration;
        var coinGrantAnimDuration = coinGrantDelay + durationMoveUpCoin + coinMoveDuration + coinScaleDuration + updateLblDelay + extraDelayVideo;

        var totalDelay = Math.max(giftBoxAnimDuration, giftBoxCloneAnimDuration, capAnimDuration, newCapAnimDuration, raysAnimDuration, coinGrantAnimDuration);
        var extraDelay = 0.15;
        // removing extra sprites created for animation only here
        if (UiState == 2) {
            utilObj.delayedCallback(curLayer, animObj.removeTemporarySprites, totalDelay, {spriteArr: spritesToRemove}, false);
            utilObj.delayedCallback(curLayer, animObj.removeTemporarySprites, totalDelay, {spriteArr: [giftBoxSprite, giftBoxClone, capSpriteClone, dailyBonusLayer.getHeader()]}, false);
            utilObj.delayedCallback(curLayer, animObj.removeTemporarySprites, totalDelay + extraDelay, {spriteArr: spritesToRemoveAfterDelay}, false);
        } else {
            utilObj.delayedCallback(curLayer, animObj.removeTemporarySprites, totalDelay, {spriteArr: spritesToRemove}, false);
        }

        return totalDelay + extraDelay;
    };

    this.removeTemporarySprites = function (sender, params) {
        var spritesToRemove = params.spriteArr;
        var fadeOutDur = 0.15;
        if (params.fadeDur) {
            fadeOutDur = params.fadeDur;
        }
        for (var i in spritesToRemove) {
            if (utilObj.isNodeValid(spritesToRemove[i])) {
                var fadeOut = utilObj.getFadeOut(fadeOutDur);
                var remove = utilObj.getIndependentRemoveSelf();
                var animArr = [fadeOut, remove];
                animObj.runAction(spritesToRemove[i], utilObj.getSequence(animArr));
            }
        }
        return fadeOutDur;
    };

    /**
     * this function moves gift boxes, transparent buttons, clipper nodes and lock Sprites to the calculated positions respectively
     * @param transBtnSprite
     * @param boxSprite
     * @param clipperNode
     * @param lockSprite
     * @param finalXPos
     * @returns {number}
     */
    this.moveGiftBoxes = function (transBtnSprite, boxSprite, clipperNode, lockSprite, finalXPos) {
        if(!utilObj.isNodeValid(transBtnSprite) || !utilObj.isNodeValid(boxSprite) || !utilObj.isNodeValid(clipperNode) || !utilObj.isNodeValid(lockSprite)){
            return 0;
        }
        var boxSpritePos = utilObj.getSpriteCoordinates(boxSprite);
        var initialXPos = boxSpritePos.xPos;
        var initialYPos = boxSpritePos.yPos;

        var btnSpritePos = utilObj.getSpriteCoordinates(transBtnSprite);
        var btnSpriteYPos = btnSpritePos.yPos;

        var movementDuration = 0.25;
        var moveToActionTransBtn = utilObj.getMoveTo(movementDuration, finalXPos, btnSpriteYPos).easing(cc.easeIn(1.0));
        animObj.runAction(transBtnSprite, moveToActionTransBtn);

        var moveToActionBoxSprite = utilObj.getMoveTo(movementDuration, finalXPos, initialYPos).easing(cc.easeIn(1.0));
        animObj.runAction(boxSprite, moveToActionBoxSprite);

        var clipperNodePos = utilObj.getSpriteCoordinates(clipperNode);
        var xDiffBox = finalXPos - initialXPos;
        var moveToActionClipperNode = utilObj.getMoveTo(movementDuration, clipperNodePos.xPos + xDiffBox, clipperNodePos.yPos).easing(cc.easeIn(1.0));
        animObj.runAction(clipperNode, moveToActionClipperNode);

        utilObj.setPositionY(lockSprite, initialYPos + 60);
        var lockSpritePos = utilObj.getSpriteCoordinates(lockSprite);
        var fadeInLock = utilObj.getFadeIn(movementDuration);
        var moveToActionLockSprite = utilObj.getMoveTo(movementDuration, finalXPos, lockSpritePos.yPos).easing(cc.easeIn(1.0));
        var lockAnimSpawn = new cc.Spawn(fadeInLock, moveToActionLockSprite);
        animObj.runAction(lockSprite, lockAnimSpawn);

        return movementDuration;
    };

    /**
     * gift box appear animation
     * @param btnSprite
     * @param boxSprite
     * @param initialDelayDuration
     * @returns {*}
     */
    this.runGiftBoxAppearAnimation = function (btnSprite, boxSprite, initialDelayDuration) {
        if(!utilObj.isNodeValid(btnSprite) || !utilObj.isNodeValid(boxSprite)){
            return 0;
        }

        var btnScale = utilObj.getScale(btnSprite);
        var giftBoxScale = utilObj.getScale(boxSprite);

        utilObj.setSpriteScales(btnSprite, 0, 0);
        utilObj.setSpriteScales(boxSprite, 0, 0);

        var scaleUpDuration = 0.15;
        var scaleDownDuration = 0.14;

        var initDelayActionBox = animObj.getDelayTime(initialDelayDuration);
        var scaleUpActionBox = animObj.getScaleDifferentTo(scaleUpDuration, giftBoxScale * 1.2, giftBoxScale * 1.2);
        var scaleDownActionBox = animObj.getScaleDifferentTo(scaleDownDuration, giftBoxScale, giftBoxScale);
        animObj.runAction(boxSprite, animObj.getSequence([initDelayActionBox, scaleUpActionBox, scaleDownActionBox], false));


        var initDelayActionBtn = animObj.getDelayTime(initialDelayDuration);
        var scaleUpActionBtn = animObj.getScaleDifferentTo(scaleUpDuration, btnScale * 1.2, btnScale * 1.2);
        var scaleDownActionBtn = animObj.getScaleDifferentTo(scaleDownDuration, btnScale, btnScale);
        animObj.runAction(btnSprite, animObj.getSequence([initDelayActionBtn, scaleUpActionBtn, scaleDownActionBtn], false));

        return (initialDelayDuration + scaleUpDuration + scaleDownDuration);
    };

    /**
     * plays star glitter plist effect
     * @param sender
     * @param params
     * @returns {number}
     */
    this.runStarGlitterAnimation = function (sender, params) {
        if (!params) {
            return 0;
        }
        if (!params.parentSprite || !utilObj.isNodeValid(params.parentSprite)) {
            return 0;
        }
        var parentSprite = params.parentSprite;
        var spriteDimensions = utilObj.getSpriteDimensions(parentSprite);
        var paramsNew = {
            x: spriteDimensions.width / 2,
            y: spriteDimensions.height / 2 + 40,
            layer: parentSprite,
            scale: 2,
            zOrder: constantsObj.FTUE_Z_ORDER
        };
        var starGlitterEffect = effectsObj.playStarGlitterEffect(sender, paramsNew);
        dailyBonusLayer.addToStarGlitterArr(starGlitterEffect);
        return 0;
    };

    /**
     * pulsate animation for gift boxes
     * @param btnSprite
     * @param boxSprite
     * @returns {number}
     */
    this.runGiftBoxPulsateAnimation = function (btnSprite, boxSprite) {
        if(!utilObj.isNodeValid(btnSprite) || !utilObj.isNodeValid(boxSprite)){
            return 0;
        }

        var giftBoxPos = utilObj.getSpriteCoordinates(boxSprite);
        var btnPos = utilObj.getSpriteCoordinates(btnSprite);

        var moveUpDuration = 0.60;
        var moveDownDuration = 0.60;
        var yMoveShift = 30;

        var moveUpActionBox = utilObj.getMoveTo(moveUpDuration, giftBoxPos.xPos, giftBoxPos.yPos + yMoveShift).easing(cc.easeInOut(1.0));
        var moveDownActionBox = utilObj.getMoveTo(moveDownDuration, giftBoxPos.xPos, giftBoxPos.yPos).easing(cc.easeIn(1.0));

        animObj.runAction(boxSprite, cc.RepeatForever(animObj.getSequence([moveUpActionBox, moveDownActionBox], false)), true);

        var moveUpActionBtn = utilObj.getMoveTo(moveUpDuration, btnPos.xPos, btnPos.yPos + yMoveShift).easing(cc.easeInOut(1.0));
        var moveDownActionBtn = utilObj.getMoveTo(moveDownDuration, btnPos.xPos, btnPos.yPos).easing(cc.easeIn(1.0));

        animObj.runAction(btnSprite, cc.RepeatForever(animObj.getSequence([moveUpActionBtn, moveDownActionBtn], false)), true);

        return (moveUpDuration + moveDownDuration);
    };

    /**
     * scales to same scaling for both x and y
     * @param duration
     * @param scale
     * @returns {*}
     */
    this.getScaleSameTo = function (duration, scale) {
        if (duration < 0 || scale < 0) {
            loggerObj.errorLog("Invalid params for scaling:", duration, scale);
            duration = 0;
            scale = 0;
        }

        var scaleTo = new cc.ScaleTo(duration, scale);
        return scaleTo;
    };

    /**
     * this function checks for valid parameters specific for single action animation types
     * @param animationType
     * @param animationParams
     * @returns {boolean}
     */
    this.checkValidParamsForSingleActionAnimationWithDelay = function (animationType, animationParams) {
        if(!animationType || !animationParams){
            return false;
        }


        if(animationType == constantsObj.FADE_TO_ANIM){
            if (!animationParams.opacity) {
                return false;
            }
        } else if(animationType == constantsObj.SCALE_SAME_ANIM){
            if (!animationParams.scale) {
                return false;
            }
        } else if(animationType == constantsObj.SCALE_DIFFERENT_ANIM){
            if(!animationParams.scaleX || !animationParams.scaleY){
                return false;
            }
        }
        return true;
    };


    /**
     * this function is for running single action animations with a delay
     * @param params
     * @returns {number}
     */
    this.runSingleActionAnimationWithDelay = function (params) {
        if (!params) {
            return 0;
        }

        var node = params.node;
        var animationType = params.animType;
        var delayTime = params.delayTime;
        if (!utilObj.isNodeValid(node) || !animationType || !delayTime) {
            return 0;
        }

        var action = null;

        var singleActionAnimations = constantsObj.SINGLE_ACTION_ANIM_ARR;
        if(singleActionAnimations.indexOf(animationType) == -1){
            return 0;
        }

        var animationParams = params.animParams;
        var animDuration = animationParams.animDuration;
        if(!animationParams || !animDuration || !animObj.checkValidParamsForSingleActionAnimationWithDelay(animationType, animationParams)){
            return 0;
        }

        switch (animationType) {
            case constantsObj.FADE_IN_ANIM:
                utilObj.setOpacity(node, constantsObj.OPACITY_0);
                action = animObj.getFadeIn(animDuration);
                break;
            case constantsObj.FADE_OUT_ANIM:
                utilObj.setOpacity(node, constantsObj.OPACITY_100);
                action = animObj.getFadeIn(animDuration);
                break;
            case constantsObj.FADE_TO_ANIM:
                utilObj.setOpacity(node, constantsObj.OPACITY_0);
                var opacityValue = animationParams.opacity;
                action = animObj.getFadeTo(animDuration, opacityValue);
                break;
            case constantsObj.SCALE_SAME_ANIM:
                var scale = animationParams.scale;
                action = animObj.getScaleSameTo(animDuration, scale);
                break;
            case constantsObj.SCALE_DIFFERENT_ANIM:
                var scaleX = animationParams.scaleX;
                var scaleY = animationParams.scaleY;
                action = animObj.getScaleDifferentTo(animDuration, scaleX, scaleY);
                break;
            default:
                break;
        }

        var animationArr = [];
        if (action) {
            var delayAction = animObj.getDelayTime(delayTime);
            animationArr.push(delayAction);
            animationArr.push(action);
            animObj.runAction(node, animObj.getSequence(animationArr, false));
            return (delayTime + animDuration);
        }
        return 0;
    };

    /**
     * this function fades in/to/out sprites based on the parameters
     * @param sprites
     * @param params
     */
    this.fadeSprites = function (sprites, params) {
        var animDelay = 0;
        if(!params){
            return animDelay;
        }

        var fadeType = constantsObj.FADE_OUT_ANIM;
        if (params.type) {
            fadeType = params.type;
        }
        var fadeDur = 0.5;
        if(params.fadeDur){
            fadeDur = params.fadeDur;
        }

        var fadeFn = animObj.fadeOutAnimation;
        var fadeParams = {"fadeDur": fadeDur};
        if(fadeType == constantsObj.FADE_TO_ANIM){
            fadeFn = animObj.fadeToAnimation;
            var opacity = constantsObj.OPACITY_0;
            if(params.opacity){
                opacity = params.opacity;
            }
            fadeParams = {"fadeDur": fadeDur, "opacity": opacity};
        } else if(fadeType == constantsObj.FADE_IN_ANIM){
            fadeFn = animObj.fadeInAnimation;
        }

        var numSprites = sprites.length;
        for(var i = 0; i < numSprites; i++){
            fadeParams["node"] = sprites[i];
            fadeFn(curLayer, fadeParams);
        }

        animDelay = fadeDur;
        return animDelay;
    };

    /**
     * runs overlay fade in, hold and fade Out animation
     * @param node
     * @returns {number}
     */
    this.runOverlayAnimation = function (node) {
        var animDelay = 0;
        if(!utilObj.isNodeValid(node)){
            return animDelay;
        }

        var fadeInDuration = 0.2;
        var holdDuration = 1.8;
        var fadeOutDuration = 0.2;

        animObj.runAction(node, animObj.getSequence([animObj.getFadeIn(fadeInDuration), animObj.getDelayTime(holdDuration), animObj.getFadeOut(fadeOutDuration)]));
        animDelay = fadeInDuration + holdDuration + fadeOutDuration;
        return animDelay;
    };

    /**
     * runs scaling up, hold, scaling down animation
     * @param node
     * @returns {number}
     */
    this.runParentSectionAnimation = function (node) {
        var animDelay = 0;
        if(!utilObj.isNodeValid(node)){
            return animDelay;
        }

        var nodeScale = utilObj.getScale(node);

        var initialScaleFactor = 0.4;
        var extraScaleFactor = 1.05;
        utilObj.setSpriteScales(node, nodeScale * initialScaleFactor, nodeScale * initialScaleFactor);

        var zoomInDuration = 0.5;
        var holdDuration = 1.0;
        var zoomInExtraDuration = 0.2;
        var zoomOutDuration = 0.5;
        var fadeOutDuration = 0.5;

        var scaleUpAction = animObj.getScaleTo(zoomInDuration, nodeScale, nodeScale).easing(cc.easeIn(1.0));
        var holdAction = animObj.getDelayTime(holdDuration);
        var scaleUpExtraAction = animObj.getScaleTo(zoomInExtraDuration, nodeScale * extraScaleFactor, nodeScale * extraScaleFactor).easing(cc.easeOut(1.0));
        var scaleDownAction = animObj.getScaleTo(zoomOutDuration, nodeScale * initialScaleFactor, nodeScale * initialScaleFactor).easing(cc.easeOut(1.0));
        var fadeOutAction = animObj.getFadeOut(fadeOutDuration);
        var scaleDownAndFadeOutAction = new cc.Spawn(scaleDownAction, fadeOutAction);

        animObj.runAction(node, animObj.getSequence([scaleUpAction, holdAction, scaleUpExtraAction, scaleDownAndFadeOutAction]));
        animDelay = zoomInDuration + holdDuration + zoomInExtraDuration + zoomOutDuration;
        return animDelay;
    };

    /**
     * fades in image and text elements to some opacity values
     * @param header
     * @param themeImage
     * @param subHeaders
     * @returns {number}
     */
    this.fadeInImageAndTextElements = function (header, themeImage, subHeaders) {
        var fadeInDuration = 0.5;
        var animDelay = animObj.fadeSprites([header, themeImage], {type: constantsObj.FADE_IN_ANIM, fadeDur: fadeInDuration});
        if(subHeaders) {
            var numSubheaders = subHeaders.length;
            for(var i = 0; i < numSubheaders; i++){
                animDelay = Math.max(animDelay, animObj.fadeSprites([subHeaders[i]], {
                    type: constantsObj.FADE_TO_ANIM,
                    opacity: constantsObj.OPACITY_80,
                    fadeDur: fadeInDuration
                }));
            }
        }
        return animDelay;
    };

    /**
     * runs todays section move up and fade In animation on quest Map layer
     * @param todaysSectionBg
     * @param outline
     * @param todaysSectionButton
     * @param clipperNode
     * @returns {number}
     */
    this.runTodaysSectionMoveUpAndFadeInAnimation = function (todaysSectionBg, outline, todaysSectionButton, clipperNode, initDelay) {
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "" , "", constantsObj.TRACK_WQ_MAP, "dc_enter_anim", "" , "", "", "");
        var animDelay = 0;
        if(!utilObj.areAllNodesValid([todaysSectionBg, outline, todaysSectionButton, clipperNode]) || !initDelay){
            return animDelay;
        }

        var fadeInDuration = 0.4;
        var moveUpDuration = 0.4;
        utilObj.makeAllNodesTransparent([todaysSectionBg, outline, todaysSectionButton, clipperNode]);
        var todaysSectionPosition = utilObj.getSpriteCoordinates(todaysSectionBg);
        var actualXPos = todaysSectionPosition.xPos;
        var actualYPos = todaysSectionPosition.yPos;
        var initialXPos = actualXPos;
        var initialYPos = 0;
        utilObj.setPosition(todaysSectionBg, initialXPos, initialYPos);
        utilObj.setPosition(outline, initialXPos, initialYPos);
        utilObj.setPosition(todaysSectionButton, initialXPos, initialYPos);
        animObj.runAction(todaysSectionBg, animObj.getSequence([animObj.getDelayTime(initDelay), cc.Spawn(animObj.getFadeIn(fadeInDuration).easing(cc.easeOut(1.0)), utilObj.getMoveTo(moveUpDuration, actualXPos, actualYPos).easing(cc.easeOut(1.0)))]));
        animObj.runAction(outline, animObj.getSequence([animObj.getDelayTime(initDelay), cc.Spawn(animObj.getFadeIn(fadeInDuration).easing(cc.easeOut(1.0)), utilObj.getMoveTo(moveUpDuration, actualXPos, actualYPos).easing(cc.easeOut(1.0)))]));
        animObj.runAction(todaysSectionButton, animObj.getSequence([animObj.getDelayTime(initDelay), cc.Spawn(animObj.getFadeIn(fadeInDuration).easing(cc.easeOut(1.0)), utilObj.getMoveTo(moveUpDuration, actualXPos, actualYPos).easing(cc.easeOut(1.0)))]));

        var clipperNodePosition = utilObj.getSpriteCoordinates(clipperNode);
        var clipperXPos = clipperNodePosition.xPos;
        var clipperYPos = clipperNodePosition.yPos;
        var clipperInitialXPos = clipperXPos;
        var clipperInitialYPos = clipperYPos - (actualYPos - initialYPos);
        utilObj.setPosition(clipperNode, clipperInitialXPos, clipperInitialYPos);
        animObj.runAction(clipperNode, animObj.getSequence([animObj.getDelayTime(initDelay), cc.Spawn(animObj.getFadeIn(fadeInDuration).easing(cc.easeOut(1.0)), utilObj.getMoveTo(moveUpDuration, clipperXPos, clipperYPos).easing(cc.easeOut(1.0)))]));

        animDelay = initDelay + Math.max(fadeInDuration, moveUpDuration);
        return animDelay;
    };

    /**
     * runs tick exchange animation for questMap layer today's challenge section
     * @param oldTick
     * @param newTick
     * @param initialDelay
     * @returns {number}
     */
    this.runTickAnimation = function (oldTick, newTick, tickParent, initialDelay, sectionWidth, sectionHeight) {
        var animDelay = 0;
        if(!utilObj.areAllNodesValid([oldTick, newTick, tickParent]) || !initialDelay){
            return animDelay;
        }

        var animFactor = 1;
        var extraDelay = 0.5;
        var oldTickDelayDuration = initialDelay + extraDelay;
        var oldTickFadeOutDuration = 0.3 * animFactor;
        var oldTickScaleDownDuration = 0.3 * animFactor;
        var newTickDelayDuration = oldTickDelayDuration + oldTickFadeOutDuration;
        var newTickFadeInDuration = 0.4 * animFactor;
        var newTickScaleUpDuration = 0.4 * animFactor;
        var newTickScaleNormalDuration = 0.3 * animFactor;

        var newTickScale = utilObj.getScale(newTick);
        var extraScaleFactor = 1.5;

        animObj.runAction(oldTick, animObj.getSequence([animObj.getDelayTime(oldTickDelayDuration), cc.Spawn(animObj.getFadeOut(oldTickFadeOutDuration), animObj.getScaleTo(oldTickScaleDownDuration, 0, 0))]));
        animObj.runAction(newTick, animObj.getSequence([animObj.getDelayTime(newTickDelayDuration), cc.Spawn(animObj.getFadeIn(newTickFadeInDuration), animObj.getScaleTo(newTickScaleUpDuration, newTickScale * extraScaleFactor, newTickScale * extraScaleFactor)), animObj.getScaleTo(newTickScaleNormalDuration, newTickScale, newTickScale)]));

        var tickCoordinates = utilObj.getSpriteCoordinates(newTick);
        var paramsBoxEffect = {
            x: tickCoordinates.xPos,
            y: tickCoordinates.yPos,
            layer: tickParent,
            scale: 0.75,
            zOrder: constantsObj.FTUE_Z_ORDER - 1
        };
        utilObj.delayedCallback(tickParent, effectsObj.playBoxEffect, oldTickDelayDuration + oldTickFadeOutDuration/2, paramsBoxEffect, false);

        var paramsRoundEffect = {
            x: tickCoordinates.xPos,
            y: tickCoordinates.yPos,
            layer: tickParent,
            scale: 0.75,
            zOrder: constantsObj.FTUE_Z_ORDER - 1
        };
        utilObj.delayedCallback(tickParent, effectsObj.playRoundEffect, oldTickDelayDuration + oldTickFadeOutDuration/2, paramsRoundEffect, false);

        animDelay = Math.max((oldTickDelayDuration + oldTickFadeOutDuration), (newTickDelayDuration + newTickFadeInDuration + newTickScaleNormalDuration));
        return animDelay;
    };

    /**
     * shine animation once
     * @param params
     */
    this.animateShineOnce = function (params) {
        var animDelay = 0;
        if(!params.node || !utilObj.isNodeValid(params.node) || !params.parent || !utilObj.isNodeValid(params.parent)){
            return animDelay;
        }

        var node = params.node;
        var nodePosition = utilObj.getSpriteCoordinates(node);
        var firstAnimDelay = params.initAnimDelay;
        var parentNode = params.parent;
        var width = params.width;
        var moveDelay = 1.15;

        var setVisibleAction = new cc.CallFunc(function () {
            utilObj.setVisible(node, true);
        });
        animObj.runAction(node, animObj.getSequence([animObj.getDelayTime(firstAnimDelay), setVisibleAction, animObj.getMoveTo(moveDelay, nodePosition.xPos + width + 200, node.getPositionY())], false));
        animDelay = firstAnimDelay + moveDelay;
        utilObj.delayedCallback(parentNode, animObj.removeTemporarySprites, animDelay, {spriteArr: node}, false);
        return animDelay;
    };

    /**
     * nudge animation once
     * @param sender
     * @param params
     */
    this.animateNudgeOnce = function (icon, animCircle, initialDelay) {
        var animDelay = 0;
        if (!utilObj.areAllNodesValid([icon, animCircle]) || !initialDelay) {
            return animDelay;
        }

        var scaleX = utilObj.getScaleX(icon);
        var scaleY = utilObj.getScaleY(icon);
        var multiplier = 0.8;

        var initialHoldDuration = initialDelay;
        var scaleUpIconDuration = 0.4 * multiplier;
        var scaleDownIconDuration = 0.4 * multiplier;
        animObj.runAction(icon, animObj.getSequence([animObj.getDelayTime(initialHoldDuration), animObj.getScaleTo(scaleUpIconDuration, scaleX * 1.2, scaleY * 1.2), animObj.getScaleTo(scaleDownIconDuration, scaleX, scaleY)]));

        var holdDuration = 0.78 * multiplier + initialHoldDuration;
        var scaleCircleDuration = 0.6 * multiplier;
        var fadeOutDuration = 0.6 * multiplier;
        var scaleBackDuration = 0.01 * multiplier;
        var fadeInDuration = 0.01 * multiplier;
        animObj.runAction(animCircle, animObj.getSequence([animObj.getDelayTime(holdDuration), cc.Spawn([animObj.getScaleTo(scaleCircleDuration, scaleX * 1.6, scaleY * 1.6), animObj.getFadeOut(fadeOutDuration)]), animObj.getScaleTo(scaleBackDuration, scaleX, scaleY), animObj.getFadeIn(fadeInDuration)]));

        animDelay = Math.max(scaleUpIconDuration + scaleDownIconDuration, holdDuration + scaleCircleDuration + scaleBackDuration + fadeInDuration);
        return animDelay;
    };

    /**
     * runs todays section move Down and fade Out animation on quest Map layer
     * @param todaysSectionBg
     * @param outline
     * @param todaysSectionButton
     * @param clipperNode
     * @param initDelay
     * @returns {number}
     */
    this.runTodaysSectionMoveDownAndFadeOutAnimation = function (todaysSectionBg, outline, todaysSectionButton, clipperNode, initDelay) {
        var animDelay = 0;
        if(!utilObj.areAllNodesValid([todaysSectionBg, outline, todaysSectionButton, clipperNode]) || !initDelay){
            return animDelay;
        }

        var fadeOutDuration = 0.4;
        var moveDownDuration = 0.4;
        var extraDelay = 0.5;
        initDelay += extraDelay;
        var todaysSectionPosition = utilObj.getSpriteCoordinates(todaysSectionBg);
        var initialXPos = todaysSectionPosition.xPos;
        var initialYPos = todaysSectionPosition.yPos;
        var finalXPos = initialXPos;
        var finalYPos = 0;
        animObj.runAction(todaysSectionBg, animObj.getSequence([animObj.getDelayTime(initDelay) , cc.Spawn(animObj.getFadeOut(fadeOutDuration).easing(cc.easeIn(1.0)), animObj.getMoveTo(moveDownDuration, finalXPos, finalYPos).easing(cc.easeIn(1.0)))]));
        animObj.runAction(outline, animObj.getSequence([animObj.getDelayTime(initDelay) , cc.Spawn(animObj.getFadeOut(fadeOutDuration).easing(cc.easeIn(1.0)), animObj.getMoveTo(moveDownDuration, finalXPos, finalYPos).easing(cc.easeIn(1.0)))]));
        animObj.runAction(todaysSectionButton, animObj.getSequence([animObj.getDelayTime(initDelay) , cc.Spawn(animObj.getFadeOut(fadeOutDuration).easing(cc.easeIn(1.0)), animObj.getMoveTo(moveDownDuration, finalXPos, finalYPos).easing(cc.easeIn(1.0)))]));

        var clipperNodePosition = utilObj.getSpriteCoordinates(clipperNode);
        var clipperInitialXPos = clipperNodePosition.xPos;
        var clipperInitialYPos = clipperNodePosition.yPos;
        var clipperFinalXPos = clipperInitialXPos;
        var clipperFinalYPos = clipperInitialYPos - (initialYPos - finalYPos);
        animObj.runAction(clipperNode, animObj.getSequence([animObj.getDelayTime(initDelay), cc.Spawn(animObj.getFadeOut(fadeOutDuration).easing(cc.easeIn(1.0)), utilObj.getMoveTo(moveDownDuration, clipperFinalXPos, clipperFinalYPos).easing(cc.easeIn(1.0)))]));

        animDelay = initDelay + Math.max(fadeOutDuration, moveDownDuration);
        utilObj.delayedCallback(curLayer, animObj.removeTemporarySprites, animDelay, {spriteArr: [todaysSectionBg, outline, todaysSectionButton, clipperNode]}, false);

        return animDelay;
    };


    /**
     * wrapper function for moveTo Action
     * @param delay
     * @param x
     * @param y
     * @returns {*}
     */
    this.getMoveTo = function (delay, x, y) {
        var moveTo = new cc.MoveTo(delay, x, y);
        return moveTo;
    };

};