Util = function () {
    var filesDir = "";
    var filesDirV1 = "";
    var advertiserId = "";
    var filesList = null;
    var lastFileUpdateTime = 0;
    var soundsRunning = [];
    var soundIndex = 0;
    var screenStack = [];
    var bannerAdShowTime = 0;
    var lastScrollTracked = 0;
    var screenTraceStatus = false;
    var isSpriteandFontLoaded = false;
    var isFacebookStaticInterstaticInterstitialAvailable = false;
    var isAppInstalled = {};
    var isLimitTrackingVar = null;
    var isLimitTrackingWithoutAdjustIdVar = null;
    var tipNumber = 0 ;


    this.isFunction = function (functionToCheck) {
        var getType = {};
        return functionToCheck && getType.toString.call(functionToCheck) === '[object Function]';
    };

    // this.getTip = function(){
    //     var totalTips = constantsObj.totalNumOfTips;
    //     var tipNum = tipNumber;
    //     tipNumber = (tipNum + 1)% totalTips;
    //     var tip = stringsObj.tips[tipNumber];
    //     return tip;
    //
    // };

    this.getTipNum = function(){
        var randNum = utilObj.getRandomIntInRange(1, 9);
        tipNumber = randNum;
    };

    this.getTip = function(){
        var tip = stringsObj.tips[tipNumber];
        return tip;
    };

    this.isWeb = function () {
        if (cc.sys.platform == cc.sys.DESKTOP_BROWSER || cc.sys.platform == cc.sys.MOBILE_BROWSER) {
            return true;
        }
        return false;
    };

    this.isOurWebsite = function () {
        if (utilObj.isWeb() && window.top.location == window.location) {
            return true;
        }
        return false;
    };

    this.redirectTo = function (url) {
        if (!utilObj.isWeb()) {
            return;
        }
        var a = document.createElement("a");
        if (!a.click) {
            // For IE
            window.top.location = url;
            return;
        }
        a.setAttribute("href", url);
        a.style.display = "none";
        document.body.appendChild(a);
        a.click();
    };

    this.screenTraceStart = function (sc) {
        if (utilObj.isAndroid()) {
            screenTraceStatus = true;
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "screenTraceStart", "(Ljava/lang/String;)V", sc);
        } else if (utilObj.isIos()) {
            screenTraceStatus = true;
            jsb.reflection.callStaticMethod("Util", "screenTraceStart:", sc);
        }
    };

    this.screenTraceEnd = function () {
        if (utilObj.isAndroid()) {
            screenTraceStatus = false;
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "screenTraceStop", "()V");
        } else if (utilObj.isIos()) {
            screenTraceStatus = false;
            jsb.reflection.callStaticMethod("Util", "screenTraceStop");
        }
    };

    this.isNative = function () {
        return cc.sys.isNative;
    };

    this.isAndroid = function () {
        if (cc.sys.os == cc.sys.OS_ANDROID) {
            return true;
        }
        return false;
    };

    this.isIos = function () {
        if (cc.sys.os == cc.sys.OS_IOS) {
            return true;
        }
        return false;
    };

    this.isOsX = function () {
        if (cc.sys.os == cc.sys.OS_OSX) {
            return true;
        }
        return false;
    };

    this.getDeviceLocale = function () {
        return cc.sys.language;
    };

    this.getTrackingClient = function () {
        if (this.isNative()) {
            if (this.isAndroid()) {
                return constantsObj.CLIENT_ANDROID;
            } else if (this.isIos()) {
                return constantsObj.CLIENT_IOS;
            } else if (this.isOsX()) {
                return constantsObj.CLIENT_MAC_OS;
            } else {
                return constantsObj.CLIENT_UNKNOWN;
            }
        }
        return constantsObj.CLIENT_FACEBOOK;
    };

    this.isAndroidTab = function () {
        var isTab = false;
        return isTab;
        var deviceHeight = utilObj.getDeviceHeight();
        var deviceWidth = utilObj.getDeviceWidth();
        var ratio = ((deviceHeight / deviceWidth) > (deviceWidth / deviceHeight)) ? deviceHeight / deviceWidth : deviceWidth / deviceHeight;
        if (ratio <= 1.6) {
            isTab = true;
        }
        //isTab = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "isOnline", "()Z");*/
        return isTab;
    };

    this.openStore = function (itunesId, link) {
        if (!utilObj.isOnline()) {
            utilObj.showMessage(stringsObj.not_online);
            return;
        }

        if (itunesId == undefined || itunesId == null) {
            utilObj.openUrl(link);
            return;
        }
        if (utilObj.isNative()) {
            if (utilObj.isAndroid()) {
                utilObj.openUrl(link);
            } else {
                jsb.reflection.callStaticMethod("Ads", "openStoreProductViewControllerWithITunesItemIdentifier:link:", itunesId, link);
            }
        } else {
            window.open(link, "_blank");
        }
    };

    this.isTablet = function () {
        var deviceType = false;
        if (utilObj.isAndroid()) {
            deviceType = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "isTablet", "()Z");
        } else if (utilObj.isIos()) {
            deviceType = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Util", "isIPad");
        }
        return deviceType;
    };

    this.getCurrentTimestamp = function () {
        return Math.round(utilObj.getCurrentTimestampMs() / 1000);
    };

    this.getCurrentTimestampMs = function () {
        var extraTime = 0;
        if (utilObj.isStaging() && qaConfigObj != null) {
            extraTime = (qaConfigObj.getQAConfigData("add_days_for_testing") * constantsObj.SECONDS_IN_DAY * 1000) + (qaConfigObj.getQAConfigData("add_hours_for_testing") * constantsObj.SECONDS_IN_HOUR * 1000);
        }
        return (new Date().getTime()) + extraTime;
    };

    this.getCurrentYear = function () {
        var d = new Date();
        return d.getFullYear();
    };

    this.getCurrentDate = function () {
        var d = new Date();
        return d.getDate();
    };

    this.getCurrentMonth = function () {
        var d = new Date();
        return d.getMonth();
    };

    this.isAutoPlayOn = function () {
        return false;
    };

    this.isNonStopPlayOn = function () {
        if (utilObj.isAutoPlayOn() && runtimeObj.getNonStopAutoPlay()) {
            return true;
        }
        return false;
    };

    this.isAutoPlayNoAnim = function () {
        if (utilObj.isAutoPlayOn() && runtimeObj.isAutoPlayNoAnim()) {
            return true;
        }
        return false;
    };

    this.isNonStopNoAnimOn = function () {
        if (utilObj.isNonStopPlayOn() && utilObj.isAutoPlayNoAnim()) {
            return true;
        }
        return false;
    };

    this.updateCrossGameStatus = function (questId, linkId, schedule_name) {
        /*var expQuestCenter = epmObj.getExperiment(constantsObj.EXP_QUEST_CENTER);
         var varQuestCenter = constantsObj.VAR_CONTROL;
         if (expQuestCenter != null) {
         varQuestCenter = expQuestCenter.getChosenVariant();
         }*/


        // loggerObj.debugLog("WIll trigger push notif test", gameObj.getPushNotifGrant());


        gameObj.lastQuestPushNotif = true;
        questsObj.updateCrossGameFromPushNotif(questId, constantsObj.QUEST_STARTED, linkId, schedule_name);


        if (gameObj.getPushNotifGrant()) {
            // questsObj.redirectToPlaystore(linkId);
            // loggerObj.debugLog("Here ", questId);
            gameObj.setLastCrossQuestTouched("push_" + questId);
        } else {
            gameObj.setLastCrossQuestTouched("");
        }

    };

    // Not inclusive of max
    this.getRandomIntInRange = function (min, max, forceRandom) {
        var rand = 0;
        var nextRand = 0;
        if (max <= 1) {
            return rand;
        }
        if (utilObj.isSeededRandomnessOn() && forceRandom != true) {
            // Deterministic mode for this for being able to replay scenarios
            nextRand = utilObj.seededRandom();
            // Using seeded random. A sequence of 100 or 256 integers doesn't generate results which are random enough.
            // nextRand = randomizerObj.getNextRandNum() * 1.0 / constantsObj.MAX_RANDOM_NUM;
            // nextRand is a number between 0 and MAX_RANDOM_NUM
        } else {
            nextRand = Math.random();
        }
        rand = (nextRand * (max - min)) + min;
        // loggerObj.debugLog("Next rand is:", nextRand, rand);
        return Math.floor(rand);
    };

    // the initial seed
    var seed = 1;
    var originalSeed = seed;
    // in order to work 'seed' must NOT be undefined,
    // so in any case, you HAVE to provide a seed
    this.seededRandom = function () {
        seed = (seed * 9301 + 49297) % 233280;
        var rnd = seed / 233280;
        return rnd;
    };

    this.setSeed = function (s) {
        seed = s;
        originalSeed = s;
    };

    this.getOriginalSeed = function () {
        return originalSeed;
    };

    this.isSeededRandomnessOn = function () {
        if (utilObj.isAutoPlayOn()) {
            return true;
        }
        return false;
    };

    this.getAutoPlaySeed = function () {
        return runtimeObj.getAutoPlaySeed();
    };

    this.isInReqRange = function (percent) {
        var randInt = utilObj.getRandomIntInRange(0, 100);
        if (randInt < percent) {
            return true;
        }
        return false;
    };

    this.isInReqRangeForceRandom = function (percent) {
        var randInt = utilObj.getRandomIntInRange(0, 100, true);
        if (randInt < percent) {
            return true;
        }
        return false;
    };

    this.getParseId = function () {
        if (utilObj.isNative()) {
            if (utilObj.isAndroid()) {
                return jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "getParseId", "()Ljava/lang/String;");
            } else if (utilObj.isIos()) {
                return jsb.reflection.callStaticMethod("Util", "getParseId");
            }
        } else {
            // loggerObj.debugLog("Get parse id not on web ??");
        }
    };

    this.getNumProperties = function (obj) {
        var count = 0;
        for (var k in obj) {
            if (obj.hasOwnProperty(k)) {
                count++;
            }
        }
        return count;
    };

    this.isOnScreen = function (screen) {
        if (curScreen != screen) {
            return false;
        }
        return true;
    };

    this.createClone = function (obj) {
        var res = null;
        if (obj != null && obj != undefined) {
            try {
                res = JSON.parse(utilObj.getStringifiedJson(obj));
            } catch (err) {
                //loggerObj.errorLog("Cloning failed:", err, obj);
            }
        }
        return res;
    };

    this.trimLastChar = function (str) {
        if (str == undefined || str == null || str == "") {
            return "";
        }
        return str.substr(0, str.length - 1);
    };

    this.trimStr = function (x) {
        return x.replace(/^\s+|\s+$/gm, '');
    };

    this.urlEncode = function (x) {
        return x.replace(/\s+/g, '%20');
    };

    this.ucFirst = function (str) {
        return str.charAt(0).toUpperCase() + str.slice(1);
    };

    this.getFirstName = function (n) {
        if (n == undefined) {
            //loggerObj.errorLog("Invalid param for get first name");
            return "";
        }
        var splitName = n.split(" ");
        return splitName[0];
    };

    this.formatName = function (n) {
        if (n.length > constantsObj.MAX_NAME_LENGTH) {
            n = n.slice(0, constantsObj.MAX_NAME_LENGTH);
        }
        var newName = n.replace(/[^a-zA-Z0-9 ]/g, "");
        return newName;
    };

    this.formatPrice = function (n) {
        n = n + "";
        var newPrice = n.replace(/[^a-zA-Z0-9$£₹.]/g, "");
        return newPrice;
    };

    this.replaceNum = function (str, num) {
        return str.replace("%NUM%", num);
    };

    this.replaceName = function (str, name) {
        return str.replace("%NAME%", name);
    };

    this.isTouchSupported = function () {
        if (cc.sys.capabilities.hasOwnProperty('touches')) {
            return true;
        }
        return false;
    };

    this.isMouseSupported = function () {
        if (cc.sys.capabilities.hasOwnProperty('mouse')) {
            return true;
        }
        return false;
    };

    this.wasHorizontalSwipe = function (touchStartX, touchEndX, duration) {
        var swipeType = constantsObj.NO_SWIPE;
        var direction = constantsObj.SWIPE_LEFT;
        var displacement = touchStartX - touchEndX;
        if (displacement < 0) {
            direction = constantsObj.SWIPE_RIGHT;
            displacement *= -1;
        }
        if (displacement > constantsObj.MIN_SWIPE_DISTANCE) {
            // Not using duration of swipe yet
            swipeType = direction;
        }
        return swipeType;
    };

    this.wasVerticalSwipe = function (touchStartY, touchEndY, duration) {
        var swipeType = constantsObj.NO_SWIPE;
        var direction = constantsObj.SWIPE_DOWN;
        var displacement = touchStartY - touchEndY;
        if (displacement < 0) {
            direction = constantsObj.SWIPE_UP;
            displacement *= -1;
        }
        if (displacement > constantsObj.MIN_SWIPE_DISTANCE) {
            // Not using duration of swipe yet
            swipeType = direction;
        }
        return swipeType;
    };

    this.loadSpriteFrameCache = function (withMap) {
        // var deviceHeight = utilObj.getDeviceHeight();
        /*if (deviceHeight <= constantsObj.HEIGHT_LOW_RES) {
         cc.spriteFrameCache.addSpriteFrames(res.misc_0_860_plist, res.misc_0_860_png);
         } else if (deviceHeight <= constantsObj.HEIGHT_MEDIUM_RES) {
         cc.spriteFrameCache.addSpriteFrames(res.misc_0_1280_plist, res.misc_0_1280_png);
         } else {
         cc.spriteFrameCache.addSpriteFrames(res.misc_0_1920_plist, res.misc_0_1920_png);
         }*/
        cc.spriteFrameCache.addSpriteFrames(res.flags_plist_V1, res.flags_png_V1);
        // cc.spriteFrameCache.addSpriteFrames(res.misc_1280_plist, res.misc_1280_png);
        // cc.spriteFrameCache.addSpriteFrames(res.misc_level_plist, res.misc_level_png);
        // cc.spriteFrameCache.addSpriteFrames(res.misc_v2_plist, res.misc_v2_png);
        cc.spriteFrameCache.addSpriteFrames(res.misc_dtc2V1_plist, res.misc_dtc2V1_png);
        cc.spriteFrameCache.addSpriteFrames(res.misc_dtc2_plist, res.misc_dtc2_png);
        cc.spriteFrameCache.addSpriteFrames(res.misc_arcade_plist, res.misc_arcade_png);
        // TODO - Enabling quest sprite sheets to surfacing quest icons, confirm with game team
        xpromoUtilObj.addSpriteFrames();
    };

    var lastOnlineCheck = 0;
    var lastIsOnline = false;
    this.isOnline = function () {
        var isOnline = false;
        var curTimestampMs = utilObj.getCurrentTimestampMs();
        if (curTimestampMs - lastOnlineCheck < constantsObj.ONLINE_CHECK_INTERVAL) {
            return lastIsOnline;
        }

        if (this.isNative()) {
            if (utilObj.isAndroid()) {
                isOnline = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "isOnline", "()Z");
            } else if (utilObj.isIos()) {
                isOnline = jsb.reflection.callStaticMethod("Util", "isOnline");
            }
        } else {
            isOnline = true;
        }
        lastIsOnline = isOnline;
        lastOnlineCheck = curTimestampMs;
        return isOnline;
    };

    this.isPingWorking = function () {
        return utilObj.isOnline();
        if (utilObj.isAndroid()) {
            return jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "isPingWorking", "()Z");
        } else {
            return utilObj.isOnline();
        }
    };

    var deviceId = false;
    this.getDeviceId = function () {
        if (deviceId != false) {
            return deviceId;
        }
        if (this.isNative()) {
            if (utilObj.isAndroid()) {
                deviceId = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "getDeviceId", "()Ljava/lang/String;");
            } else if (utilObj.isIos()) {
                deviceId = jsb.reflection.callStaticMethod("Util", "getDeviceId");
            }
        } else {
            // TODO: Change this to "" before releasing for web.
            deviceId = "";
        }
        return deviceId;
    };

    var versionCode = 0;
    this.getVersionCode = function () {
        if (versionCode != 0) {
            return versionCode;
        }
        if (this.isNative()) {
            if (utilObj.isAndroid()) {
                versionCode = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "getVersionCode", "()I");
            } else if (utilObj.isIos()) {
                versionCode = jsb.reflection.callStaticMethod("Util", "getVersionCode");
            }
        } else {
            versionCode = 0;
        }
        return versionCode;
    };

    var clientBuildVersion = "";
    this.getClientBuildVersion = function () {
        if (clientBuildVersion != "") {
            return clientBuildVersion;
        }
        if (this.isNative()) {
            if (utilObj.isAndroid()) {
                clientBuildVersion = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "getClientBuildVersion", "()I");
            } else if (utilObj.isIos()) {
                clientBuildVersion = jsb.reflection.callStaticMethod("Util", "getClientBuildVersion");
            }
        } else {
            clientBuildVersion = "";
        }
        return clientBuildVersion;
    };

    var osVersion = "";
    this.getOsVersion = function () {
        if (osVersion != "") {
            return osVersion;
        }
        if (this.isNative()) {
            if (utilObj.isAndroid()) {
                osVersion = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "getOsVersion", "()Ljava/lang/String;");
            } else if (utilObj.isIos()) {
                osVersion = jsb.reflection.callStaticMethod("Util", "getOsVersion");
            }
        } else {

        }
        return osVersion;
    };

    var deviceWidth = 0;
    this.getDeviceWidth = function () {
        if (deviceWidth != 0) {
            return deviceWidth;
        }
        if (this.isNative()) {
            if (utilObj.isAndroid()) {
                deviceWidth = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "getDeviceWidth", "()I");
            } else if (utilObj.isIos()) {
                deviceWidth = jsb.reflection.callStaticMethod("Util", "getDeviceWidth");
            }
        } else {
            deviceWidth = window.innerWidth;
        }
        return deviceWidth;
    };

    var deviceHeight = 0;
    this.getDeviceHeight = function () {
        if (deviceHeight != 0) {
            return deviceHeight;
        }
        if (this.isNative()) {
            if (utilObj.isAndroid()) {
                deviceHeight = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "getDeviceHeight", "()I");
            } else if (utilObj.isIos()) {
                deviceHeight = jsb.reflection.callStaticMethod("Util", "getDeviceHeight");
            }
        } else {
            deviceHeight = window.innerHeight;
        }

        var dw = utilObj.getDeviceWidth();
        if (deviceHeight / dw > 16.0 / 9.0) {
            // This is a iphoneX like device.
            deviceHeight = Math.floor(dw * 16.0 / 9.0);
        }

        return deviceHeight;
    };

    var country = "";
    this.getCountry = function () {
        if (country != "") {
            return country;
        }
        if (this.isNative()) {
            if (utilObj.isAndroid()) {
                country = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "getCountry", "()Ljava/lang/String;");
            } else if (utilObj.isIos()) {
                country = jsb.reflection.callStaticMethod("Util", "getCountry");
            }
        } else {

        }
        return country;
    };

    this.downloadNormalFile = function (request_url, callback, version) {
        return;
        var xmlHttp = cc.loader.getXMLHttpRequest();
        xmlHttp.onreadystatechange = function () {
            if (xmlHttp.readyState == 4 && xmlHttp.status == 200) {
                //loggerObj.traceLog("rest - success", xmlHttp.responseText);
                utilObj.normalFileDownloadComplete(xmlHttp.responseText, callback, version);
            } else {
                //loggerObj.traceLog("rest - error", xmlHttp.statusText, "status", xmlHttp.readyState, xmlHttp.status);
            }
        };

        // You gotta trick it into downloading binary.
        xmlHttp.open('GET', request_url);
        xmlHttp.overrideMimeType('text\/plain; charset=x-user-defined');
        xmlHttp.send("");
    };

    this.normalFileDownloadComplete = function (rawfile, callback, version) {
        callback(rawfile, version);
        return;
        // Create a byte array.
        var bytes = [];

        // Walk through each character in the stream.
        for (var fileidx = 0; fileidx < rawfile.length; fileidx++) {
            var abyte = rawfile.charCodeAt(fileidx) & 0xff;
            bytes.push(abyte);
        }

        // Instantiate our zlib object, and gunzip it.
        // Requires: https://github.com/imaya/zlib.js/blob/master/bin/gunzip.min.js
        // (remove the map instruction at the very end.)
        var gunzip = new Zlib.Gunzip(bytes);
        var plain = gunzip.decompress();

        // Now go ahead and create an ascii string from all those bytes.
        // Seeing we've just got a big ole byte buffer, but, not an ASCII file.
        var asciistring = "";
        for (var i = 0; i < plain.length; i++) {
            asciistring += String.fromCharCode(plain[i]);
        }

        callback(asciistring);
    };

    var deviceModel = "";
    this.getDeviceModel = function () {
        if (deviceModel != "") {
            return deviceModel;
        }
        if (this.isNative()) {
            if (utilObj.isAndroid()) {
                deviceModel = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "getDeviceModel", "()Ljava/lang/String;");
            } else if (utilObj.isIos()) {
                deviceModel = jsb.reflection.callStaticMethod("Util", "getDeviceModel");
            }
        } else {

        }
        return deviceModel;
    };

    var cpuArch = "";
    this.getCpuArch = function () {
        if (cpuArch != "") {
            return cpuArch;
        }
        if (utilObj.isAndroid()) {
            cpuArch = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "getCpuArch", "()Ljava/lang/String;");
        } else {

        }
        return cpuArch;
    };

    this.didCrashOnLastLoad = function () {
        var crashed = false;
        if (this.isNative()) {
            if (utilObj.isAndroid()) {
                crashed = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "didCrashOnLastLoad", "()Z");
            }
        } else {

        }
        return crashed;
    };

    this.contactUs = function (issueTag, subject) {
        var pv = constantsObj.PUZZLES_VERSION;
        var isPayer = gameObj.getIsPayer() + "";
        // loggerObj.debugLog("hitting contactUs js");
        if (issueTag == undefined) {
            issueTag = "";
        }
        if (subject == undefined) {
            subject = "";
        }
        var refid = userObj.getRefId();
        var isDummy = "";
        if (refid == "") {
            refid = userObj.getTrackingRefId();
            isDummy = "NA";
        }
        if (utilObj.isAndroid()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "contactUs", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V", userObj.getRefId(), issueTag, subject, pv);
        } else if (utilObj.isIos()) {
            jsb.reflection.callStaticMethod("Util", "contactUs:issueTag:subjectTitle:pv:isPayer:isDummy:", refid, issueTag, subject, pv, isPayer, isDummy);
        }
    };

    this.contactUsSuggestion = function (issueTag, subject) {
        var pv = constantsObj.PUZZLES_VERSION;
        var isPayer = gameObj.getIsPayer() + "";
        // loggerObj.debugLog("hitting contactUs js");
        if (issueTag == undefined) {
            issueTag = "";
        }
        if (subject == undefined) {
            subject = "";
        }
        if (utilObj.isAndroid()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "contactUsSuggestion", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V", userObj.getRefId(), issueTag, subject, pv);
        } else if (utilObj.isIos()) {
            jsb.reflection.callStaticMethod("Util", "contactUsSuggestion:issueTag:subjectTitle:pv:isPayer:", userObj.getRefId(), issueTag, subject, pv, isPayer);
        }
    };

    this.saveData = function () {
        // gameObj.save();
        // trackObj.save();
    };

    this.closeApp = function () {
        xpromoUtilObj.endGame();
        if (utilObj.isAndroid()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "closeApp", "()V");
        } else {

        }
    };

    this.sendReport = function (crumb) {
        if (this.isNative()) {
            if (utilObj.isAndroid()) {
                jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "sendReport", "(Ljava/lang/String;)V", crumb);
            } else if (utilObj.isIos()) {
                jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Analytics", "sendReport:", crumb);
            }
        } else {

        }
    };

    this.getBrowserInfo = function () {
        var userAgent = navigator.userAgent;
        var chrome = "Chrome";
        var firefox = "Firefox";
        var safari = "Safari";
        var opera = "Opera";
        var dolfin = "Dolfin";
        var other = "Other";

        var browser = "";
        if (userAgent.indexOf(chrome) !== -1) {
            browser = chrome;
        } else if (userAgent.indexOf(firefox) !== -1) {
            browser = firefox;
        } else if (userAgent.indexOf(safari) !== -1) {
            browser = safari;
        } else if (userAgent.indexOf(opera) !== -1) {
            browser = opera;
        } else if (userAgent.indexOf(dolfin) !== -1) {
            browser = dolfin;
        } else {
            browser = other;
        }
        return browser;
    };

    this.getBrowserOsInfo = function () {
        var userAgent = navigator.userAgent;

        var linux = "Linux";
        var ipad = "iPad";
        var iphone = "iPhone";
        var android = "Android";
        var windowsPhone = "Windows Phone";
        var windows = "Windows";
        var mac = "Macintosh";
        var blackberry = "BlackBerry";
        var bada = "Bada";
        var other = "Other";

        var os = "";
        if (userAgent.indexOf(ipad) != -1) {
            os = ipad;
        } else if (userAgent.indexOf(iphone) != -1) {
            os = iphone;
        } else if (userAgent.indexOf(android) != -1) {
            os = android;
        } else if (userAgent.indexOf(linux) != -1) {
            os = linux;
        } else if (userAgent.indexOf(windowsPhone) != -1) {
            os = windowsPhone;
        } else if (userAgent.indexOf(windows) != -1) {
            os = windows;
        } else if (userAgent.indexOf(mac) != -1) {
            os = mac;
        } else if (userAgent.indexOf(blackberry) != -1) {
            os = blackberry;
        } else if (userAgent.indexOf(bada) != -1) {
            os = bada;
        } else {
            os = other;
        }
        return os;
    };

    var lastErrorMessage = 0;
    this.showErrorMessage = function (msg) {
        var curTimestampMs = utilObj.getCurrentTimestampMs();
        if (curTimestampMs - lastErrorMessage < 2000) {
            return;
        }
        lastErrorMessage = curTimestampMs;
        utilObj.showMessage(msg);
    };

    var lastMessage = 0;
    this.showMessage = function (msg, dynamicYPos) {
        var curTimestampMs = utilObj.getCurrentTimestampMs();
        if (Math.abs(curTimestampMs - lastMessage) < 1000) {
            return;
        }
        lastMessage = curTimestampMs;

        // using in house toaster instead of native toaster
        var labelArr = [];
        var spriteArr = [];
        var labels = [];
        var messageArr = utilObj.getSplitStringsArr(msg, 35);
        var numLines = messageArr.length;
        var lineHeight = 70;
        var margin = 100;
        var toasterHeight = numLines * lineHeight + margin;

        var yPosForPos = centerYPos;
        if (dynamicYPos) {
            yPosForPos = dynamicYPos;
        }

        var yPos = yPosForPos + lineHeight * (messageArr.length - 1) / 2;
        for (var i = 0; i < messageArr.length; i++) {
            var label = utilObj.getBMFontLabel(messageArr[i], constantsObj.FONT_HELVETICA_MEDIUM_60, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, yPos, 0.5, 0.5, labelArr, mainScene, constantsObj.TOASTER_Z_ORDER + 1);
            utilObj.setOpacity(label, 0);
            labels.push(label);
            yPos -= lineHeight;
        }
        var toasterWidth = 1000;
        if (labels[0] != undefined && labels[0] != null) {
            var labelDimension = utilObj.getSpriteDimensions(labels[0]);
            toasterWidth = labelDimension.width + 150;
        }

        // toasterBg.setInnerContainerSize(cc.size(labelDimension.width + 100, labelDimension.height + 100));
        var toasterBg = utilObj.getScale9Sprite(constantsObj.white_rounded_3, centerXPos, yPosForPos, 0.5, 0.5, toasterWidth, toasterHeight, spriteArr, mainScene, constantsObj.TOASTER_Z_ORDER, constantsObj.SPRITE_MISC);
        utilObj.setOpacity(toasterBg, 0);
        utilObj.setColor(toasterBg, constantsObj.COLOR_BLACK);
        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);

        // fade in and out
        var fadeToAction = utilObj.getFadeTo(0.15, constantsObj.OPACITY_70);
        var delay = utilObj.getDelayTime(1.5);
        var fadeOutAction = utilObj.getFadeOut(0.15);
        var removeSelf = utilObj.getIndependentRemoveSelf();
        var sequence = utilObj.getSequence([fadeToAction, delay, fadeOutAction, removeSelf]);
        animObj.runAction(toasterBg, sequence);
        for (var i = 0; i < labels.length; i++) {
            var fadeInAction = utilObj.getFadeIn(0.15);
            var sequence = utilObj.getSequence([fadeInAction, delay.clone(), fadeOutAction.clone(), removeSelf.clone()]);
            animObj.runAction(labels[i], sequence);
        }
    };

    this.showMessageAtTop = function (msg) {
        if (this.isNative()) {
            // calling show message function from here as all the toaster message need to appear on the center of the screen
            utilObj.showMessage(msg);
            //
        } else {
            swal(msg);
            // loggerObj.debugLog(msg);
        }
    };

    this.showMessagePopup = function (msg) {
        if (this.isNative()) {
            if (utilObj.isAndroid()) {
                jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "showMessagePopup", "(Ljava/lang/String;)V", msg);
            } else if (utilObj.isIos()) {
                jsb.reflection.callStaticMethod("Util", "showMessagePopup:", msg);
            }
        }
    };

    this.replaceSprite = function (sprite, node, spriteNew, scaling, opacity, spriteZorder) {
        // TODO: Make this possible without removing sprite
        // cc.Sprite.createWithSpriteFrameName(image);
        // sprite.setSpriteFrame(image);
        // sprite.setTexture(image);
        if (!utilObj.isSpriteValid(sprite)) {
            return constantsObj.TILE_NOT_FOUND;
        }
        if (utilObj.isGettingRemoved(sprite)) { //|| sprite.getNumberOfRunningActions() > 0
            return sprite; // Don't change, this is getting removed and changing the sprite will cause problems.
        }

        try {
            var pos = utilObj.getPosition();
            var oldScaleX = sprite.getScaleX();
            var oldScaleY = sprite.getScaleY();
            var zOrder = sprite.getLocalZOrder();
            var tag = sprite.getTag();
            var spriteIndex = sprite.spriteIndex;

            utilObj.removeChild(node, sprite);

            if (!utilObj.isSpriteValid(spriteNew)) {
                return constantsObj.TILE_NOT_FOUND;
            }
            if (opacity != undefined && opacity != null) {
                spriteNew.setOpacity(opacity);
            }

            if (scaling != undefined && scaling != null) {
                if (utilObj.isFunction(scaling)) {
                    spriteNew.setScale(scaling(image, sprite)); // Suraj: What is image?? Seems an undefined variable.
                } else {
                    spriteNew.setScale(scaling);
                }
            } else {
                spriteNew.setScaleX(oldScaleX);
                spriteNew.setScaleY(oldScaleY);
            }
            if (spriteZorder != null && spriteZorder != undefined) {
                zOrder = spriteZorder;
            }

            node.addChild(spriteNew, zOrder, tag);
            spriteNew.setPosition(pos.x, pos.y);
            spriteNew.replacement = true;
            spriteNew.spriteIndex = spriteIndex;
            return spriteNew;
        } catch (err) {
            // //loggerObj.errorLog("Error in replacing sprite", err);
            return constantsObj.TILE_NOT_FOUND;
        }

    };

    this.isGettingRemoved = function (sprite) {
        if (sprite.markedForRemoval == undefined) {
            return false;
        }
        return true;
    };

    this.removeChild = function (parent, child) {
        // //loggerObj.traceLog("Removing child:", child);
        if (!utilObj.isSpriteValid(child)) {
            if (!utilObj.isAutoPlayNoAnim()) {
                // loggerObj.debugLog("Invalid sprite when attempting to remove");
            }
            return false;
        }

        try {
            var numRunningActions = child.getNumberOfRunningActions();
            if (numRunningActions > 0) {
                //loggerObj.traceLog("Removing child which had actions running:", child.markedForRemoval, child.spriteIndex, child.replacement);
                child.stopAllActions();
            }
            parent.removeChild(child);
        } catch (e) {
            // loggerObj.debugLog("Error when removing child:", e);
            return false;
        }
        return true;
    };

    this.removeAllChildren = function (parent) {
        //loggerObj.traceLog("Removing all children");
        parent.removeAllChildren();
    };

    this.getSequence = function (seqAction, skipReport) {
        if (seqAction == null || seqAction == undefined || !utilObj.isArray(seqAction) || seqAction.length <= 1) {
            //loggerObj.errorLog("Invalid values passed for seq:", seqAction);
            return null;
        }

        skipReport = true;
        if (skipReport == undefined || skipReport == false) {
            var seqInfo = "";
            if (utilObj.isAndroid()) {
                seqInfo = loggerObj.getLineNumber(1, false);
            } else if (utilObj.isWeb()) {
                seqInfo = loggerObj.getLineNumber(2, true);
            }
            // loggerObj.debugLog("Seq info");
            // cc.log.apply(null, seqInfo);
            // Disabling reports for now
            // utilObj.sendReport(seqInfo);
        }
        return new cc.Sequence(seqAction);
    };

    this.getDelayTime = function (time) {
        if (time < 0) {
            //loggerObj.errorLog("Delay time called with time < 0", time);
            time = 0;
        }
        var delayTime = new cc.DelayTime(time);
        return delayTime;
    };

    this.getRotateTo = function (duration, rotation) {
        if (duration < 0) {
            //loggerObj.errorLog("Invalid params for scaling:", duration);
            duration = 0;
            rotation = 0;
        }
        var rotateTo = new cc.RotateTo(duration, rotation, rotation);
        return rotateTo;
    };

    this.getFadeOut = function (duration) {
        return new cc.FadeOut(duration);
    };

    this.getFadeIn = function (duration) {
        return new cc.FadeIn(duration);
    };

    this.getFadeTo = function (duration, opacity) {
        return new cc.FadeTo(duration, opacity);
    };

    this.getMoveBy = function (duration, deltaX, deltaY) {
        return new cc.MoveBy(duration, deltaX, deltaY);
    };

    this.getScaleTo = function (duration, scaleX, scaleY) {
        if (duration < 0 || scaleX < 0) {
            //loggerObj.errorLog("Invalid params for scaling:", duration, scale);
            duration = 0;
            scaleX = 0;
            scaleY = 0;
        }
        var scaleTo = new cc.ScaleTo(duration, scaleX, scaleY);
        return scaleTo;
    };

    this.getEucledianDistance = function (p1, p2) {
        var xDis = p1.x - p2.x;
        var yDis = p1.x - p2.x;
        return Math.sqrt(xDis * xDis + yDis * yDis);
    };

    this.getDistancesFromCenter = function (center) {
        var distances = [];
        var maxDistance = 0;
        for (var x = 0; x < constantsObj.GRID_WIDTH; x++) {
            distances[x] = [];
            for (var y = 0; y < constantsObj.GRID_WIDTH; y++) {
                var distance = utilObj.getEucledianDistance(center, {x: x, y: y});
                distances[x][y] = {
                    distance: distance,
                    distanceX: center.x - x,
                    distanceY: center.y - y
                };
                if (distance > maxDistance) {
                    maxDistance = distance;
                }
            }
        }
        return {dist: distances, max: maxDistance};
    };

    this.getCardinalSpline = function (duration, points, tension) {
        var err = false;
        if (duration < 0) {
            //loggerObj.errorLog("Cardinal spline duration < 0", duration);
            duration = 0;
            err = true;
        }

        for (var i = 0; i < points.length; i++) {
            var point = points[i];
            if (!utilObj.isValidPoint(point)) {
                //loggerObj.errorLog("Invalid point passed to cardinal spline:", utilObj.getStringifiedJson(point));
                err = true;
            }
        }

        if (tension < 0) {
            //loggerObj.errorLog("Invalid value for tension:", tension);
            err = true;
        }

        if (!err) {
            var spline = new cc.CardinalSplineTo(duration, points, tension);
            return spline;
        } else {
            return utilObj.getDelayTime(duration);
        }
    };

    this.getBezierTo = function (duration, points) {
        return new cc.BezierTo(duration, points);
    };

    this.getRotateBy = function (duration, angle) {
        return new cc.RotateBy(duration, angle);
    };

    this.getMoveTo = function (delay, x, y) {
        var moveTo = new cc.MoveTo(delay, x, y);
        return moveTo;
    };

    this.isValidPoint = function (point) {
        var x = parseInt(point.x);
        var y = parseInt(point.y);
        if (utilObj.isInt(x) && utilObj.isInt(y)) {
            return true;
        }
        return false;
    };
    
    this.isValid = function (obj) {
        if (obj == null || obj == undefined) {
            return false;
        }

        //if (utilObj.isWeb()) {
        //	// Is native object has no issues on web
        //	return true;
        //} else {
        //	loggerObj.traceLog("Is valid check");
        //	return obj.isValid();
        //}
        return true;
    };

    this.setPosition = function (node, x, y) {
        if (!utilObj.isSpriteValid(node) || x == undefined || y == undefined) {
            //loggerObj.errorLog("Invalid param passed while setting position", node, x, y);
        }
        try {
            node.setPositionX(x);
            node.setPositionY(y);
        } catch (e) {
            //loggerObj.errorLog("Error when setting position:", e, node, x, y);
        }
    };

    this.pulse = function (params) {
        var node = params.node;
        var rotation = params.rotation;
        var duration = params.dur;
        var scaleUp = params.scaleUp;
        var actionTag = params.actionTag;
        var repeatCount = params.repeat;
        var rotate = params.rotate;
        var moveFrom = params.moveFrom;
        var moveTo = params.moveTo;
        var moveAnim = params.moveAnim;
        var curScale = node.getScaleX(); // Don't use getScale() - Just in case scaleX and scaleY are not equal. If they were unequal, it causes a crash.
        scaleUp *= curScale;

        var scaleUpAction = utilObj.getScaleTo(duration / 2, scaleUp, scaleUp);
        var scaleDownAction = utilObj.getScaleTo(duration / 2, curScale, curScale);
        var rotUp = new cc.RotateTo(duration / 3, rotation + 20, rotation + 20);
        var rotDown = new cc.RotateTo(duration / 3, rotation + 0, rotation + 0);

        var actions = [];
        actions.push(scaleUpAction);
        if (rotate) {
            for (var i = 0; i < 2; i++) {
                actions.push(rotUp.clone());
                actions.push(rotDown.clone());
            }
        }

        if (moveAnim) {
            var posX = (moveTo.x + moveFrom.x) / 2;
            var posY = (moveTo.y + moveFrom.y) / 2;
            if (moveTo.x - moveFrom.x > 1) {
                posX = moveFrom.x + 10;
            } else if (moveFrom.x - moveTo.x > 1) {
                posX = moveFrom.x - 10;
            }
            if (moveTo.y - moveFrom.y > 1) {
                posY = moveFrom.y + 10;
            } else if (moveFrom.y - moveTo.y > 1) {
                posY = moveFrom.y - 10;
            }
            for (var i = 0; i < 2; i++) {
                actions.push(new cc.MoveTo(duration / 3, posX, posY));
                actions.push(new cc.MoveTo(duration / 3, moveFrom.x, moveFrom.y));
            }
        }
        actions.push(scaleDownAction);
        var seqAction = utilObj.getSequence(actions);
        var seqRepeat;
        if (repeatCount <= 0) {
            seqRepeat = new cc.RepeatForever(seqAction);
        } else {
            seqRepeat = new cc.Repeat(seqAction, repeatCount);
        }
        seqRepeat.setTag(actionTag);
        animObj.runAction(node, seqRepeat, true);
        // node.runAction(seqRepeat);
        return 4 / 3 * duration;
    };

    this.pulseButton = function (node, actionTag, repeatCount, smallButton) {
        if(!utilObj.isNodeValid(node)){
            return;
        }
        var sX = node.getScaleX();
        var sY = node.getScaleY();

        var scaleWide = utilObj.getScaleTo(0.4, sX * 1.06, sY * 1.06).easing((cc.easeIn(1)));
        var scaleVertical = utilObj.getScaleTo(0.6, sX, sY).easing((cc.easeIn(1)));
        var scaleNormal = utilObj.getScaleTo(0.3, sX, sY).easing((cc.easeIn(1)));
        if (smallButton) {
            scaleWide = utilObj.getScaleTo(0.7, sX * 1.4, sY);
            scaleVertical = utilObj.getScaleTo(1, sX, sY);
            scaleNormal = utilObj.getScaleTo(0.5, sX, sY);
        }
        var actions = [];
        actions.push(scaleWide);
        actions.push(scaleVertical);
        actions.push(scaleNormal);
        var seqAction = utilObj.getSequence(actions);
        var seqRepeat;
        if (repeatCount <= 0) {
            seqRepeat = new cc.RepeatForever(seqAction);
        } else {
            seqRepeat = new cc.Repeat(seqAction, repeatCount);
        }
        seqRepeat.setTag(actionTag);
        // node.runAction(seqRepeat);
        animObj.runAction(node, seqRepeat, true);
    };

    this.pulseButton2 = function(node , actionTag , repeatCount ,smallButton, scaleX , scaleY){
        if(!utilObj.isNodeValid(node)){
            return;
        }
        var sX = scaleX;
        var sY = scaleY;

        var scaleWide = utilObj.getScaleTo(0.4, sX * 1.04, sY);
        var scaleVertical = utilObj.getScaleTo(0.6, sX, sY);
        var scaleNormal = utilObj.getScaleTo(0.3, sX, sY);
        if (smallButton) {
            scaleWide = utilObj.getScaleTo(0.7, sX * 1.4, sY);
            scaleVertical = utilObj.getScaleTo(1, sX, sY);
            scaleNormal = utilObj.getScaleTo(0.5, sX, sY);
        }
        var actions = [];
        actions.push(scaleWide);
        actions.push(scaleVertical);
        actions.push(scaleNormal);
        var seqAction = utilObj.getSequence(actions);
        var seqRepeat;
        if (repeatCount <= 0) {
            seqRepeat = new cc.RepeatForever(seqAction);
        } else {
            seqRepeat = new cc.Repeat(seqAction, repeatCount);
        }
        seqRepeat.setTag(actionTag);
        // node.runAction(seqRepeat);
        animObj.runAction(node, seqRepeat, true);
    };

    this.stopPulsingButton = function(node){
        if(utilObj.isNodeValid(node)){
            node.stopAllActions();
        }
    };

    this.pulseButtonMore = function (node, actionTag, repeatCount, smallButton) {
        var sX = node.getScaleX();
        var sY = node.getScaleY();

        var scaleWide = utilObj.getScaleTo(0.4, sX * 1.10, sY);
        var scaleVertical = utilObj.getScaleTo(0.6, sX, sY);
        var scaleNormal = utilObj.getScaleTo(0.3, sX, sY);
        if (smallButton) {
            scaleWide = utilObj.getScaleTo(0.7, sX * 1.60, sY);
            scaleVertical = utilObj.getScaleTo(1, sX, sY);
            scaleNormal = utilObj.getScaleTo(0.5, sX, sY);
        }
        var actions = [];
        actions.push(scaleWide);
        actions.push(scaleVertical);
        actions.push(scaleNormal);
        var seqAction = utilObj.getSequence(actions);
        var seqRepeat;
        if (repeatCount <= 0) {
            seqRepeat = new cc.RepeatForever(seqAction);
        } else {
            seqRepeat = new cc.Repeat(seqAction, repeatCount);
        }
        seqRepeat.setTag(actionTag);
        // node.runAction(seqRepeat);
        animObj.runAction(node, seqRepeat, true);
    };

    this.wobble = function (node, totalDuration, rotation, numRotations) {
        var rotDuration = totalDuration / numRotations;
        var actions = [];
        for (var i = 0; i < numRotations; i++) {
            var curRotation = rotation;
            if (i == 0 || i == numRotations - 1) {
                curRotation /= 2;
            }
            if (i % 2 == 0) {
                curRotation *= -1;
            }
            actions[i] = new cc.RotateBy(rotDuration, curRotation, curRotation);
        }
        var seqAction = utilObj.getSequence(actions);
        // node.runAction(seqAction);
        animObj.runAction(node, seqAction);
    };

    var lastFbDialogOpen = 0;
    this.setFbDialogOpen = function (val) {
        // loggerObj.debugLog("Setting fb dialog open:", val);
        lastFbDialogOpen = utilObj.getCurrentTimestamp();
        fbDialogOpen = val;
    };

    var lastBackTouch = 0;
    this.goBack = function (cs, cl, from) {
        // loggerObj.debugLog("Attempting to go back:", cs, cl, from, fbDialogOpen);
        if (updatingToScreen != curScreen) {
            // loggerObj.debugLog("Screen update in progress. Ignore back command.", updatingToScreen, curScreen);
            return;
        }
        var curTimestamp = utilObj.getCurrentTimestamp();
        if (curTimestamp - lastBackTouch < 2) {
            //loggerObj.traceLog("Too early for another back:", cs, from, lastBackTouch, curTimestamp);
            return;
        }

        lastBackTouch = curTimestamp;
        if (fbDialogOpen || curTimestamp - lastFbDialogOpen < 2) {
            // loggerObj.debugLog("FB dialog is/was open");
            popupLayer.setDontGoToLastScreen(false);
            freeCoins2Popup.close();
            return;
        }

        if (from == undefined || from == null || typeof from != "string") {
            from = constantsObj.TRACK_BACK;
        }
        var screenName = utilObj.getScreenName(curScreen);
        trackObj.trackDialog(screenName, from, "", "", 1, "");
        if(screenName == "free_coins_2"){
            screenName = "invite";
        }
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), screenName, from, "", gameObj.getPuzzleSpeciesTracking(), "1", "");

        trackObj.save();

        if (cs == constantsObj.SCREEN_INTRO) {
            introPopup.back();
            return;
        }

        if (cs == constantsObj.SCREEN_OUTRO) {
            outroPopup.back();
            return;
        }

        if (cs == constantsObj.SCREEN_REPLAY) {
            replayPopup.back();
            return;
        }

        if (cs == constantsObj.SCREEN_PRIVACY_POLICY) {
            privacyPolicyPopup.back();
        }

        if (cs == constantsObj.SCREEN_PUZZLE_UNLOCK_POPUP) {
            puzzleUnlockPopup.back();
        }

        if (cs == constantsObj.SCREEN_QUIT) {
            quitPopup.goToHome();
            return;
        }

        if (cs == constantsObj.SCREEN_FREE_COINS_2) {
            popupLayer.setDontGoToLastScreen(false);
            //freeCoins2Popup.close();
        }

        if (cs == constantsObj.SCREEN_LANDING) {
            landingScreenLayer.back();
            return;
        }
        if (cl != null && typeof cl.back === 'function') {
            cl.back();
        }


    };

    this.softBack = function () {
        if (animationRunning) {
            return;
        }
        utilObj.goBack(curScreen, curLayer, null);
    };

    this.passesBasicSyncChecks = function (lastSyncStart, syncInterval) {
        var refId = userObj.getRefId();
        if (refId == "" || refId == undefined || !utilObj.isPingWorking()) {
            // loggerObj.debugLog("Not syncing yet. RefId missing or no network.");
            return false;
        }
        var curTimestamp = utilObj.getCurrentTimestamp();
        if (Math.abs(curTimestamp - lastSyncStart) < syncInterval) {
            return false;
        }

        return true;
    };

    this.attemptSyncs = function () {
        gameObj.syncToServer();
        scoresObj.syncToServer();
        return;
        if (utilObj.isPingWorking()) {
            if (curScreen == constantsObj.SCREEN_FIRST_LAUNCH) {
                return;
            }
            var refId = userObj.getRefId();
            if (refId == "" || refId == undefined) {
                trackObj.trackCounter(constantsObj.TRACK_DEBUG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), "no_refid", utilObj.getIdForDate(gameObj.getTodaysPuzzleDate()), "", gameObj.getPuzzleSpeciesTracking(), 1, "");
                //loggerObj.errorLog("DTC.app/Error in calling syncs; refid missing");
                userObj.syncToServer(false);
            } else {
                var curTimestamp = utilObj.getCurrentTimestamp();
                // loggerObj.debugLog("App start time:", appStartTime, curTimestamp - appStartTime);
                if (curTimestamp - appStartTime > constantsObj.DELAY_SYNC_START) {
                    gameObj.syncToServer();
                    trackObj.syncToServer();
                    runtimeObj.syncToServer();
                    epmObj.syncToServer();
                    scoresObj.syncToServer();
                    questsObj.syncToServer();
                    subscriptionsObj.syncToServer();
                    syncReqRespCheckObj.syncToServer();
                    if (machineLearningDataObj.getSyncInProgress() && machineLearningDataObj.getLastSync() - curTimestamp > 3 * constantsObj.SECONDS_IN_MIN) {
                        machineLearningDataObj.syncToServer();
                    }

                    if (!isFirstLoad) {
                        // epmObj.updateUserObject(false);
                        // fbRequestObj.getOpenReqCount();
                        friendsObj.attemptUpdate();
                    }
                }
            }
        }
    };

    this.setPositionX = function(node , pos){
        if(utilObj.isNodeValid(node)){
            node.setPositionX(pos);
        }
    };

    this.setPositionY = function(node , pos){
        if(utilObj.isNodeValid(node)){
            node.setPositionY(pos);
        }
    };

    this.canChangeScreen = function () {
        if (updatingToScreen != curScreen) {
            return false;
        }
        return true;
    };

    this.updateLastScreen = function (ls, ll) {
        // Not called normally. These updates should get handled by updateScreen itself.
        lastScreen = ls;
        lastLayer = ll;
    };

    this.goToLastScreen = function (redraw, callback, callbackParams) {
        utilObj.popCurScreen();
        // loggerObj.debugLog("coming here ");
        var screen = utilObj.popCurScreen();
        var layer = utilObj.getLayerForScreen(screen);

        utilObj.updateScreenBegin(screen);
        utilObj.updateScreen(screen, layer);

        if (redraw) {
            curLayer.redraw();
        }

        if (utilObj.isFunction(callback)) {
            callback(callbackParams);
        }
    };

    this.popCurScreen = function () {
        if (screenStack.length > 0) {
            var sc = screenStack.pop();
            return sc;
        }
        return -1;
    };

    this.getLastScreen = function () {
        if (screenStack.length > 1) {
            var sc = screenStack[screenStack.length - 2];
            loggerObj.debugLog("LastScreen", sc);
            return sc;
        }
        return -1;
    };

    this.pushNextScreen = function (newScreen) {
        if (newScreen < 0) {
            //loggerObj.errorLog("Invalid screen passed to push next screen.");
            return;
        }
        var sc = utilObj.getCurScreen();
        if (sc != newScreen) {
            screenStack.push(newScreen);
        }
    };

    this.getCurScreen = function () {
        if (screenStack.length > 0) {
            return screenStack[screenStack.length - 1];
        }
        return -1;
    };

    this.getLayerForScreen = function (sc) {
        var layer = null;
        if (sc < 0) {
            //loggerObj.errorLog("invalid screen passed to getLayerForScreen");
            return layer;
        }
        switch (sc) {
            case constantsObj.SCREEN_HOME:
                layer = homeLayer;
                break;
            case constantsObj.SCREEN_CALENDAR:
                layer = calendarLayer;
                break;
            case constantsObj.SCREEN_GAME:
                layer = gameLayer;
                break;
            case constantsObj.SCREEN_MFS:
                layer = mfsLayer;
                break;
            case constantsObj.SCREEN_PACK_INFO_LAYER:
                layer = packInfoLayer;
                break;
            case constantsObj.SCREEN_ACHIEVEMENTS:
                layer = achievementsLayer;
                break;
            case constantsObj.SCREEN_STORE_LAYER:
                layer = storeLayer;
                break;
            case constantsObj.SCREEN_PACK_LAYER:
                layer = packsLayer;
                break;
            case constantsObj.SCREEN_HIGH_LEVEL_STORE_LAYER:
                layer = highLevelStoreLayer;
                break;
            case constantsObj.SCREEN_ZEN_MODE:
                layer = zenModeLayer;
                break;
            case constantsObj.SCREEN_LANDING:
                layer = landingScreenLayer;
                break;
            case constantsObj.SCREEN_LINEAR_PROGRESSION:
                layer = linearLevelProgression;
                break;
            case constantsObj.SCREEN_NEW_INTRO:
                layer = newIntroLayer;
                break;
            default:
                layer = popupLayer;
        }
        return layer;
    };

    this.launchAnotherApp = function (pkgName) {
        if (utilObj.isAndroid()) {
            var success = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "launchAnotherGame", "(Ljava/lang/String;)Z", pkgName);
        }
        if (utilObj.isIos()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Util", "launchAnotherApp:", pkgName);
        }
    };

    this.hitUrl = function (trackId, src, creative) {
        var xmlHttp = cc.loader.getXMLHttpRequest();
        xmlHttp.onreadystatechange = function () {
            if (xmlHttp.readyState == 4 && xmlHttp.status == 200) {
                // loggerObj.debugLog("its a success");
            } else {
                // loggerObj.debugLog("its a fail");
            }
        };
        if (creative == undefined) {
            creative = src + "_" + constantsObj.GAME_ID;
        }
        if (utilObj.isLimitAdTracking()) {
            xmlHttp.open("POST", "https://app.adjust.com/" + trackId);
        } else {
            xmlHttp.open("POST", "https://s2s.adjust.com/" + trackId);
        }
        xmlHttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
        if (utilObj.isIos()) {
            xmlHttp.send("campaign=" + src + "&adgroup=" + (src + "_" + constantsObj.GAME_ID) + "&creative=" + creative + "&idfa=" + gameObj.getAdvertiserId());
        } else if (utilObj.isAndroid()) {
            xmlHttp.send("campaign=" + src + "&adgroup=" + (src + "_" + constantsObj.GAME_ID) + "&creative=" + creative + "&gps_adid=" + utilObj.getAdvertiserId());
        }
    };

    this.hitAdjustViewTracking = function (trackId, src, creative) {
        var xmlHttp = cc.loader.getXMLHttpRequest();
        xmlHttp.onreadystatechange = function () {
            if (xmlHttp.readyState == 4 && xmlHttp.status == 200) {
                // loggerObj.debugLog("its a success");
            } else {
                // loggerObj.debugLog("its a fail");
            }
        };
        if (src == constantsObj.TRACK_QUEST_CENTER && xpromoQuestRuntimesObj.getRuntime(constantsObj.RUNTIME_QUEST_ADJUST_TRACKING_IMPRESSION) == 0) {
            return;
        }
        if (creative == undefined) {
            creative = src + "_" + constantsObj.GAME_ID;
        }
        xmlHttp.open("POST", "https://view.adjust.com/impression/" + trackId);
        xmlHttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
        if (utilObj.isIos()) {
            xmlHttp.send("campaign=" + src + "&adgroup=" + (src + "_" + constantsObj.GAME_ID) + "&creative=" + creative + "&idfa=" + gameObj.getAdvertiserId());
        } else if (utilObj.isAndroid()) {
            xmlHttp.send("campaign=" + src + "&adgroup=" + (src + "_" + constantsObj.GAME_ID) + "&creative=" + creative + "&gps_adid=" + utilObj.getAdvertiserId());
        }
    };

    this.updateScreenBegin = function (updatingTo) {
        if (!utilObj.canChangeScreen()) {
            //loggerObj.errorLog("Attempting to update screen before previous update is done:", updatingToScreen, curScreen, updatingTo);
        }

        bottomNavObj.updateHighestPriorityEligibleJewelNotif();
        updatingToScreen = updatingTo;
        screenChangeStart = utilObj.getCurrentTimestampMs();
        if (utilObj.isAndroid() && screenChangeStart % 10 == 0) {
            utilObj.screenTraceStart(utilObj.getScreenName(updatingToScreen, null));
        }
        utilObj.resetCallbacksInfo();
        utilObj.pushNextScreen(updatingTo);

        // loggerObj.debugLog("Screen - update begins at:", screenChangeStart, updatingToScreen);
    };

    this.updateScreen = function (sc, layer, screenSubType, trackG, trackS, specialField) {
        // loggerObj.debugLog("Updated curScreen to:", utilObj.getScreenName(sc, screenSubType), sc, curScreen, lastScreen, utilObj.getStringifiedJson(screenStack));
        // loggerObj.debugLog("called screen1", sc);
        if (sc == constantsObj.SCREEN_CALENDAR || sc == constantsObj.SCREEN_OUT_OF_COINS) {
            animObj.lowerFPS();
        }

        if (sc == constantsObj.SCREEN_HOME || sc == constantsObj.SCREEN_GAME || sc == constantsObj.SCREEN_HIGH_LEVEL_STORE_LAYER || sc == constantsObj.SCREEN_PACK_INFO_LAYER || sc == constantsObj.SCREEN_ACHIEVEMENTS || sc == constantsObj.SCREEN_STORE_LAYER || sc == constantsObj.SCREEN_PACK_LAYER || sc == constantsObj.SCREEN_FAQ) {
            animObj.lowerFpsScroll();
        }
        if (curScreen == sc) {
            // loggerObj.debugLog("Ignoring screen update:", sc, curScreen, lastScreen);
            timersObj.resetTimers();
            curLayer.setVisible(true);
            return;
        }

        if (updatingToScreen != sc) {
            //loggerObj.errorLog("Screen update not done correctly:", updatingToScreen, sc);
            return;
        }

        lastToLastScreen = lastScreen;

        lastScreen = curScreen;
        lastLayer = curLayer;

        curScreen = sc;
        curLayer = layer;

        if (curLayer != null) {

            curLayer.setVisible(true);
            if (curLayer == homeLayer && lastScreen == constantsObj.SCREEN_RATE_US) {
                curLayer.redraw();
            }

        }
        screenChangeEnd = utilObj.getCurrentTimestampMs();

        timersObj.resetTimers();
        // utilObj.saveData();
        //utilObj.attemptSyncs();

        var screenName = utilObj.getScreenName(curScreen, screenSubType);
        var screenChangeEnd = utilObj.getCurrentTimestampMs();
        if (utilObj.isAndroid() && screenTraceStatus) {
            utilObj.screenTraceEnd();
        }
        var timeTaken = screenChangeEnd - screenChangeStart;

        analyticsObj.screenView(screenName);
        if (trackG == undefined) {
            trackG = "";
            if (curScreen == constantsObj.SCREEN_HOME || curScreen == constantsObj.SCREEN_GAME || curScreen == constantsObj.SCREEN_CALENDAR
                || curScreen == constantsObj.SCREEN_PACK_INFO_LAYER || curScreen == constantsObj.SCREEN_ACHIEVEMENTS || curScreen == constantsObj.SCREEN_STORE_LAYER
                || curScreen == constantsObj.SCREEN_PACK_LAYER || curScreen == constantsObj.SCREEN_MFS || curScreen == constantsObj.SCREEN_FAQ ||
                curScreen == constantsObj.SCREEN_FIRST_LAUNCH || curScreen == constantsObj.SCREEN_HIGH_LEVEL_STORE_LAYER) {
                trackG = "screen";
                if (specialField != undefined) {
                    trackG += specialField;
                }
            }
        }
        if (trackS == undefined) {
            trackS = "";
        }
        utilObj.sendReport("Screen updated to " + screenName);
        // loggerObj.debugLog("ggggggg", screenName, trackG);
        if (screenName == "free_coins_2" || (screenName == "hint_confirm" && trackG == "archive") || screenName == "recommendation"
            || screenName == "bonus_archive_popup" || screenName == "questStart"
            || screenName == "questMilestone" || screenName == "ooc_store_offerwall" || screenName == "ooc_store") {

        } else {
            trackObj.trackDialog(screenName, constantsObj.TRACK_VIEW, trackG, trackS, 1, "");
        }

        // if (!(screenName == "free_coins_2")) {
        //     trackObj.trackDialog(screenName, constantsObj.TRACK_VIEW, trackG, trackS, 1, "");
        // }
        trackObj.trackCounterSampled(screenName, "load", lastScreen, curScreen, timeTaken, "", "", timeTaken, "");

        var exceptionCase = false;
        var isMiniOrMidi = gameObj.checkForMiniOrMidi(gameLayer.crosswordDate);
        if (curScreen == constantsObj.SCREEN_GAME) {
            if (!isMiniOrMidi) {
                exceptionCase = true;
            }
        }
        if (!popupLayer.popupOpen && exceptionCase == false) {
            // loggerObj.debugLog("popup not open");
            utilObj.showOrHideAd(false, curScreen);
        }

        // Magic button
        if (gameObj.getDebugOptions()) {
            var magicButton = magicObj.getMagicButton(sc);
            utilObj.addChild(layer, magicButton, constantsObj.ANIM_Z_ORDER);

            if (curScreen == constantsObj.SCREEN_LINEAR_PROGRESSION || curScreen == constantsObj.SCREEN_GAME) {
                magicObj.addWizardButton();
            }
        }
        //

        economyObj.resetAdditionalCashLabels();
        // uiCreatorObj.checkAndCreateUIElements(curScreen);
    };

    this.getScreenName = function (screen, screenSubType) {
        if (screen <= 0) {
            return constantsObj.SCREEN_NAMES[1];
        }
        var screenName = constantsObj.SCREEN_NAMES[screen];
        var screenSubTypeName = utilObj.getSubScreenName(screenSubType);
        if (screenSubTypeName != null && screenSubTypeName != undefined) {
            screenName += "_" + screenSubTypeName;
        }
        if (screen == constantsObj.SCREEN_MESSAGE_CENTER) {
            var msgs = msgCenterPopup.getAllMessages();
            if (fbWrapperObj.isLoggedIn() && msgs.length == 0) {
                screenName = constantsObj.TRACK_NO_MSG;
            } else if (msgs.length != 0) {
                screenName = constantsObj.TRACK_MSG;
            } else {
                screenName = constantsObj.TRACK_MSG_FB;
            }
        }
        /*if (screen == constantsObj.SCREEN_HINT_AND_BUY) {
         screenName = constantsObj.HINT_AND_BUY_POPUP[screenSubType];
         }*/
        return screenName;
    };

    this.getSubScreenName = function (subScreen) {
        if (subScreen == undefined) {
            return null;
        }
        var subScreenName = constantsObj.SUB_SCREEN_NAMES[subScreen];
        return subScreenName;
    };

    this.getMonth = function (monthNumber) {
        switch (monthNumber) {
            case 0:
                return stringsObj.january;
            case 1:
                return stringsObj.february;
            case 2:
                return stringsObj.march;
            case 3:
                return stringsObj.april;
            case 4:
                return stringsObj.may;
            case 5:
                return stringsObj.june;
            case 6:
                return stringsObj.july;
            case 7:
                return stringsObj.august;
            case 8:
                return stringsObj.september;
            case 9:
                return stringsObj.october;
            case 10:
                return stringsObj.november;
            case 11:
                return stringsObj.december;
                return "Invalid";
        }
    };


    this.addChild = function (parent, child, zOrder) {
        if (zOrder != undefined) {
            if (utilObj.isNodeValid(parent) && utilObj.isNodeValid(child)) {
                parent.addChild(child, zOrder);
            }
        } else {
            if (utilObj.isNodeValid(parent) && utilObj.isNodeValid(child)) {
                parent.addChild(child);
            }
        }
    };

    this.getIdForDate = function (date) {
        var d = new Date(date.getTime());
        var month = d.getMonth() + 1;
        if (month < 10) {
            month = "0" + String(month);
        }
        var date = d.getDate();
        if (date < 10) {
            date = "0" + String(date);
        }
        var id = d.getFullYear() + "" + month + "" + date;
        return id;
    };

    this.getFormattedDate = function (d, trimMonth) {
        var date = new Date(d.getTime());
        var year = date.getFullYear();
        var month = d.getMonth();
        var date = d.getDate();
        var formattedDate = stringsObj.month_list[month] + " " + date + ", " + year;
        if (trimMonth && trimMonth == true) {
            formattedDate = stringsObj.month_list[month].substr(0, 3) + " " + date + ", " + year;
        }
        return formattedDate;
    };

    this.isBezelScreen = function () {
        if (aspectRatio >= 1.9) {
            return true;
        } else {
            return false;
        }
    };

    this.getBezelShift = function () {
        var shift = 0;
        if (utilObj.isBezelScreen()) {
            shift = (constantsObj.DESIGN_HEIGHT - constantsObj.HEIGHT_2560 - constantsObj.BEZEL_SAFE_AREA) / 2;
        }
        return shift;
    };

    this.getFormattedDate1 = function (d, trimMonth) {
        var date = new Date(d.getTime());
        var year = date.getFullYear();
        var month = d.getMonth();
        var date = d.getDate();
        var formattedDate = stringsObj.month_list[month].substr(0, 3) + " " + date;

        return formattedDate;
    };

    this.countProperties = function (obj) {
        var count = 0;

        for (var prop in obj) {
            if (obj.hasOwnProperty(prop))
                ++count;
        }

        return count;
    };

    var logCounter = 0;
    var lastTs = 0;
    this.logTimestampMs = function () {
        var curTimestampMs = utilObj.getCurrentTimestampMs();
        // loggerObj.debugLog("Checking timestamp " + logCounter + ": " + (curTimestampMs - lastTs));
        logCounter++;
        lastTs = curTimestampMs;
    };

    this.getDateForId = function (id) {
       
        // loggerObj.debugLog("In get Date For id" , id);
        if (id == null) {
            trackObj.trackCounter(constantsObj.TRACK_DEBUG, "","","", "id_is_null", curScreen, lastScreen, "", "");
            id = gameObj.getIdForTodaysPuzzle();
        }
        // id.slice in null js error 
        // && !utilObj.isStaging())
        if (id == 0){
            id = gameObj.getIdForTodaysPuzzle();
        }
        // loggerObj.debugLog("djain123450",id);
        //var d = new Date();
        // loggerObj.debugLog("djain123451",d);
        var year = parseInt(id.slice(0, 4));
        // loggerObj.debugLog("djain123452",year);
        var month = parseInt(id.slice(4, 6)) - 1;
        // loggerObj.debugLog("djain123453",month);
        var date = parseInt(id.slice(6, 8));
        // loggerObj.debugLog("djain123454",date);
        var d = new Date(year, month, date);
        /*d.setFullYear(year);
         d.setMonth(month1);
         //d.setMonth(month);
         d.setDate(date);*/
        // loggerObj.debugLog("djain123455",d,d.getFullYear(),d.getMonth(),d.getDate());

        return d;
        // return "20200405";
    };

    // The target contains information on what callback is to be triggered, the params to be passed to it, as well as the tracking for it.
    this.getButton = function (width, height, anchorX, anchorY, x, y, normalColor, touchedColor, disabledColor, target, roundButton, textureType, scale) {
        // loggerObj.debugLog("Tracking info:", utilObj.getStringifiedJson(target.track));
        if (target.track == undefined) {
            // //loggerObj.errorLog("Tracking info missing");
        }
    
        var button = new ccui.Button();
        if (roundButton == null || roundButton == false) {
            button.setScale9Enabled(true);
            if (textureType == undefined) {
                textureType = ccui.Widget.PLIST_TEXTURE;
            }
        }
        try {
            button.loadTextures(normalColor, touchedColor, disabledColor, textureType);
        } catch (e) {
            // loggerObj.debugLog("Loading textures:", e, textureType, normalColor);
        }
        if (scale != null && scale != undefined) {
            button.setScale(scale);
        }
        button.attr({
            height: height,
            width: width,
            x: x,
            y: y,
            anchorX: anchorX,
            anchorY: anchorY
        });
        var cScale = [];
        target.nodeScale = scale;
        if (target.child != undefined && (target.feedBackType == constantsObj.ZOOMIN_FEEDBACK || target.feedBackType == constantsObj.ZOOMOUT_FEEDBACK || target.feedBackType == constantsObj.DARKEN_FEEDBACK)) {
            for (var i = 0; i < target.child.length; i++) {
                cScale[i] = target.child[i].getScale();
            }
            target.childScale = cScale;
        }

        // Special button type which would not consider swipes as touches.
        // Also it will not swallow the touch to allow other event handlers to run the swipe.
        if(target.feedBackType != undefined && target.feedBackType == constantsObj.NO_TOUCH_ON_SWIPE_FEEDBACK) {
            button.setSwallowTouches(false);
        }

        button.addTouchEventListener(utilObj.buttonClick, target);
        return button;
    };

    this.formattedTime = function (time) {

        var days = Math.floor(time / 86400);

        if (days > 0) {
            if (days == 1) {
                return days + " day";
            } else {
                return days + " days";
            }
        }

        time = time % 86400;
        var hours = Math.floor(time / 3600);

        if (hours < 10) {
            hours = "0" + hours;
        }
        time = time % 3600;
        var minutes = Math.floor(time / 60);
        if (minutes < 10) {
            minutes = "0" + minutes;
        }
        time = time % 60;
        var seconds = time;
        if (seconds < 10) {
            seconds = "0" + seconds;
        }

        return hours + ":" + minutes + ":" + seconds;
    };

    this.buttonClick = function (sender, type) {
        // loggerObj.debugLog("Button click:",curScreen, type, this.screen, this.track);
        /*if (curScreen == constantsObj.SCREEN_LEVEL_PANEL) {
         // loggerObj.debugLog("No touch events allowed along with level panel");
         return;
         }*/
        if (curScreen != this.screen) {
            if (lastScreen == 3 && (curScreen == 33) && type == 2) {
                // loggerObj.debugLog("Entering w2eFtue", curScreen, this.screen);
                gameObj.setDoNotShowW2e1Popup(true);
                /*if (adsObj.checkRewardedVideo()) {
                 adsObj.showVideoAd();
                 } else {
                 utilObj.showMessage("No Video Available. Please watch after some time")
                 }*/
                popupLayer.closeWithDefault();
            } else {
                loggerObj.errorLog("Calling function on screen other than curScreen is not allowed", curScreen, lastScreen, this);
                return;
            }
        }

        if (updatingToScreen != curScreen || (utilObj.getCurrentTimestampMs() - screenChangeEnd < constantsObj.POPUP_ANIM_DELAY * 1000)) {
            // loggerObj.debugLog("Screen not yet ready");
            return;
        }
        var buttonBg1 = this.buttonBg;
        if (buttonBg1 != undefined && buttonBg1 != null) {
            sender = buttonBg1;
        }

        var receivedParams;
        if (this.params == undefined) {
            receivedParams = {sound: true, alreadyFaded: false};
        } else {
            receivedParams = this.params;
        }

        //
        if(!utilObj.isWeb()) {
            if (homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2) {
                if (this.feedBackType == constantsObj.DARKEN_FEEDBACK_BOUNDED) {
                    var childNodeVal = this.child;
                    if (childNodeVal == undefined || (childNodeVal != undefined && childNodeVal.length >= 1 && !utilObj.isNodeValid(childNodeVal[0]))) {
                        var nodeInfo = uiCreatorObj.addBoundedAlphaChild(this.boundingSprite);
                        this.child = [nodeInfo.childNode];
                        this.clippingNode = [nodeInfo.clippingNode];
                    }
                }
            }
        }
        //


        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                if (receivedParams.originButton != "list_widget" && receivedParams.originButton != "list_tile") {
                    if (receivedParams.alreadyFaded == false) {
                        sender.setCascadeOpacityEnabled(true);
                        sender.setOpacity(180);
                    }
                }

                utilObj.onTouchBeganFeedBack(this.feedBackType, sender, this.nodeScale, this.child, this.childScale);
                var trackingInfo = this.track;
                var originButton = "";
                var familyButton = "";
                if (trackingInfo != undefined) {
                    originButton = trackingInfo.o;
                    familyButton = trackingInfo.f;
                }
                var isReviewedPuzzle = gameObj.getIsReview();
                if (this.sound != "false") {
                    if (familyButton == constantsObj.TRACK_SOUND) {
                        if (!gameObj.getSounds()) {
                            // loggerObj.debugLog("lelouch button tap line 1420 util.js originbutton : ", originButton);
                            utilObj.playSound(constantsObj.BUTTON_TAP, false);
                        }
                        return;
                    }
                    if (gameObj.getSounds() && receivedParams.sound != false && !isReviewedPuzzle && originButton != constantsObj.TRACK_BULB && receivedParams.originButton != "list_widget" && receivedParams.originButton != "list_tile") {
                        if (receivedParams.originButton == "clue_left" || receivedParams.originButton == "clue_right" || receivedParams.originButton == "backspace") {
                            utilObj.playSound(constantsObj.KEYBOARD_TAP, false);
                        } else {
                            utilObj.playSound(constantsObj.BUTTON_TAP, false);
                        }
                    }
                }
                break;
            case ccui.Widget.TOUCH_MOVED:
                if (receivedParams.originButton == "list_widget" || receivedParams.originButton == "list_tile") {
                    var currentTime = utilObj.getCurrentTimestamp();
                    if (currentTime - lastScrollTracked > 2) {
                        trackObj.trackCounter(constantsObj.TRACK_PUZZLE, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(),
                            constantsObj.TRACK_SCROLL, "", "", gameObj.getPuzzleSpeciesTracking(), "", "");
                    }
                    lastScrollTracked = currentTime;
                }
                break;
            case ccui.Widget.TOUCH_ENDED:
                if (receivedParams.originButton != "list_widget" && receivedParams.originButton != "list_tile") {
                    if (receivedParams.alreadyFaded == false) {
                        sender.setOpacity(255);
                        sender.setCascadeOpacityEnabled(false);
                    }
                }

                var disableFuncCall = false;
                if(this.feedBackType != undefined && this.feedBackType == constantsObj.NO_TOUCH_ON_SWIPE_FEEDBACK) {
                    var endTouch = sender.getTouchEndPosition();
                    var startTouch = sender.getTouchBeganPosition();
                    if(endTouch != undefined && startTouch != undefined && endTouch.x != undefined && startTouch.x != undefined) {
                        disableFuncCall = Math.abs(endTouch.x - startTouch.x) > 150;
                    }
                }

                var obj = window[this.obj];
                var fn = obj[this.fn];
                // loggerObj.debugLog("Is fn a function:", utilObj.isFunction(fn), fn);
                // Let it fail here with js error if its not a valid function
                if (curScreen == constantsObj.SCREEN_MFS && this.params != null) {
                    this.params.sender = sender;
                }

                if(!disableFuncCall && !utilObj.isWeb()) {
                    if (homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2) {
                        if (fn != undefined && !gameObj.getIsFuncCalled()) {
                            var delay = 0;
                            gameObj.setIsFuncCalled(true);
                            if (this.feedBackType != undefined && this.feedBackType != constantsObj.NO_TOUCH_ON_SWIPE_FEEDBACK) {
                                if (this.feedBackType == constantsObj.ZOOMIN_FEEDBACK) {
                                    delay = 0.2;
                                } else if (this.feedBackType == constantsObj.ZOOMOUT_FEEDBACK) {
                                    delay = 0.2;
                                }
                                // else if (this.feedBackType == constantsObj.DARKEN_FEEDBACK) {
                                //     delay = 0.4;
                                // }
                                else if (this.feedBackType == constantsObj.DARKEN_FEEDBACK_BOUNDED) {
                                    delay = 0.2;
                                } else if(this.feedBackType == constantsObj.DARKEN_FEEDBACK_BOUNDED_PREADDED_CHILD){
                                    delay = 0.2;
                                } else if(this.feedBackType == constantsObj.GREY_EFFECT){
                                    delay = 0.2;
                                }
                                utilObj.delayedCallback(curLayer, fn, delay, this.params, false);
                            } else {
                                fn(this.params);
                            }
                        }
                    } else {
                        fn(this.params);
                    }
                } else if (!disableFuncCall) {
                    fn(this.params);
                }
                utilObj.delayedCallback(gameLayer, utilObj.setFuncCalled, delay, null, false);
                var tracking = this.track;
                if (tracking) {
                    trackObj.trackCounter(tracking.k, tracking.p, tracking.c, tracking.o, tracking.f, tracking.g, tracking.s, tracking.co, tracking.oppId);
                }
                utilObj.onTouchEndFeedBack(this.feedBackType, sender, this.nodeScale, this.child, this.childScale, this.clippingNode);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                if (receivedParams.alreadyFaded == false) {
                    sender.setOpacity(255);
                    sender.setCascadeOpacityEnabled(false);
                }
                utilObj.onTouchEndFeedBack(this.feedBackType, sender, this.nodeScale, this.child, this.childScale, this.clippingNode);
                break;
        }
    };

    this.callMainScene = function (sender, type) {

        switch (type) {
            case ccui.Widget.TOUCH_ENDED:
                var loadingScene = new LoadingScene();
                loadingScene.delayedSetup();
                break;
            default:
                break;
        }
    };

    this.setFuncCalled = function () {
        gameObj.setIsFuncCalled(false);
    };

    this.onTouchBeganFeedBack = function (feedBackType, sender, nodeScale, child, childScale) {
        if(homeLayoutExpNew != constantsObj.EXP_VAR_1 && homeLayoutExpNew != constantsObj.EXP_VAR_2){
            return;
        }
        if (feedBackType == undefined || child == undefined) {
            return;
        }
        switch (feedBackType) {
            case constantsObj.ZOOMIN_FEEDBACK:
                animationObj.showBtnFeedBackZoomIn(sender, nodeScale, child, childScale, feedBackType);
                break;
            case constantsObj.ZOOMOUT_FEEDBACK:
                animationObj.showBtnFeedBackZoomOut(sender, nodeScale, child, childScale, feedBackType);
                break;
            // case constantsObj.DARKEN_FEEDBACK:
            //     animationObj.callBtnAlphaLayerFadeInAnimation(sender, child);
            //     break;
            case constantsObj.DARKEN_FEEDBACK_BOUNDED:
                // loggerObj.debugLog("darkenFeedBackBoundedLog: touch Began");
                animationObj.callBtnAlphaLayerFadeInAnimation(sender, child);
                break;
            case constantsObj.DARKEN_FEEDBACK_BOUNDED_PREADDED_CHILD:
                animationObj.callBtnAlphaLayerFadeInAnimation(sender, child);
                break;
            case constantsObj.GREY_EFFECT:
                animationObj.showBtnFeedBackGreyEffect(sender , child);
                break;
            default:
                break;
        }
    };

    this.onTouchEndFeedBack = function (feedBackType, sender, nodeScale, child, childScale, clippingNode) {
        if(homeLayoutExpNew != constantsObj.EXP_VAR_1 && homeLayoutExpNew != constantsObj.EXP_VAR_2){
            return;
        }
        if (feedBackType == undefined || child == undefined) {
            return;
        }
        switch (feedBackType) {
            case constantsObj.ZOOMIN_FEEDBACK:
                var param = {
                    p: sender,
                    c: child,
                    cS: childScale,
                    pS: nodeScale,
                    f: feedBackType
                };
                utilObj.delayedCallback(gameLayer, animationObj.callZoomOut, 0.07, param, false);
                break;
            case constantsObj.ZOOMOUT_FEEDBACK:
                var param = {
                    p: sender,
                    c: child,
                    cS: childScale,
                    pS: nodeScale,
                    f: feedBackType
                };
                utilObj.delayedCallback(gameLayer, animationObj.callZoomIn, 0.07, param, false);
                break;
            // case constantsObj.DARKEN_FEEDBACK:
            //     var param = {
            //         p: sender,
            //         c: child,
            //         dn: constantsObj.NO,
            //     };
            //     utilObj.delayedCallback(gameLayer, animationObj.callAlphaLayerFadeOutAnimation, 0.07, param, false);
            //     break;
            case constantsObj.DARKEN_FEEDBACK_BOUNDED:
                var param = {
                    p: sender,
                    c: child,
                    cn: clippingNode,
                    dn: constantsObj.YES
                };
                utilObj.delayedCallback(gameLayer, animationObj.callAlphaLayerFadeOutAnimation, 0.07, param, false);
                break;
            case constantsObj.DARKEN_FEEDBACK_BOUNDED_PREADDED_CHILD:
                var param = {
                    p: sender,
                    c: child,
                    cn: clippingNode,
                    dn: constantsObj.NO
                };
                utilObj.delayedCallback(gameLayer, animationObj.callAlphaLayerFadeOutAnimation, 0.07, param, false);
                break;
            case constantsObj.GREY_EFFECT :
                var param = {
                    p: sender,
                    c: child,
                };
                utilObj.delayedCallback(curLayer, animationObj.callGreyEffectReverse, 0.1, param, false);
                break;
            default :
                break;
        }
    };

    this.getContentSize = function () {
        return cc.size(this._contentSize);
    };

    this.noOp = function () {
        //loggerObj.traceLog("No op called");
    };

    this.getBMFontLabel = function (str, font_name, color, width, alignment, imageOffset, x, y, anchorX, anchorY, labelArr, layer, zOrder, tag) {
        if (width == undefined || width == null) {
            width = constantsObj.LABEL_AUTO_WIDTH;
        }
        if (alignment == undefined || alignment == null) {
            alignment = cc.TEXT_ALIGNMENT_LEFT;
        }
        if (imageOffset == undefined || imageOffset == null) {
            imageOffset = cc.p(0, 0);
        }


        var scale = 1;
        var font = font_name;
        var fontArr = fontArr2;
        switch (font_name) {
            case constantsObj.FONT_HELVETICA_75:
                font = fontArr.hel_neue_75;
                break;
            case constantsObj.FONT_HELVETICA_80:
                font = fontArr.hel_neue_75;
                scale = 16 / 15;
                break;
            case constantsObj.FONT_HELVETICA_90:
                font = fontArr.hel_neue_75;
                scale = 18 / 15;
                break;
            case constantsObj.FONT_HELVETICA_60:
                font = fontArr.hel_neue_60;
                // scale = 6 / 8;
                break;
            case constantsObj.FONT_HELVETICA_65:
                font = fontArr.hel_neue_60;
                scale = 6.5 / 6;
                break;
            case constantsObj.FONT_HELVETICA_70:
                font = fontArr.hel_neue_60;
                scale = 7 / 6;
                break;
            case constantsObj.FONT_HELVETICA_100:
                font = fontArr.hel_neue_60;
                scale = 10 / 6;
                break;
            case constantsObj.FONT_HELVETICA_150:
                font = fontArr.hel_neue_60;
                scale = 15 / 6;
                break;
            case constantsObj.FONT_HELVETICA_120:
                font = fontArr.hel_neue_60;
                scale = 12 / 6;
                break;
            case constantsObj.FONT_HELVETICA_45:
                font = fontArr.hel_neue_60;
                scale = 3 / 4;
                break;
            case constantsObj.FONT_HELVETICA_55:
                font = fontArr.hel_neue_60;
                scale = 11 / 12;
                break;
            case constantsObj.FONT_HELVETICA_58:
                font = fontArr.hel_neue_60;
                scale = 11 / 12;
                break;
            case constantsObj.FONT_HELVETICA_40:
                font = fontArr.hel_neue_60;
                scale = 4 / 6;
                break;
            case constantsObj.FONT_HELVETICA_50:
                font = fontArr.hel_neue_60;
                scale = 5 / 6;
                break;
            case constantsObj.FONT_HELVETICA_35:
                font = fontArr.hel_neue_60;
                scale = 3.5 / 6;
                break;
            case constantsObj.FONT_HELVETICA_230:
                font = fontArr.hel_neue_medium_70;
                scale = 23 / 7;
                break;
            case constantsObj.FONT_HELVETICA_BOLD_50:
                font = fontArr.hel_neue_bold_90;
                scale = 5 / 9;
                break;
            case constantsObj.FONT_HELVETICA_BOLD_90:
                font = fontArr.hel_neue_bold_90;
                // scale = 6 / 8;
                break;
            case constantsObj.FONT_HELVETICA_BOLD_100:
                font = fontArr.hel_neue_bold_90;
                scale = 10 / 9;
                break;
            case constantsObj.FONT_HELVETICA_BOLD_60:
                font = fontArr.hel_neue_bold_90;
                scale = 6 / 9;
                break;
            case constantsObj.FONT_HELVETICA_BOLD_70:
                font = fontArr.hel_neue_bold_90;
                scale = 7 / 9;
                break;
            case constantsObj.FONT_HELVETICA_BOLD_80:
                font = fontArr.hel_neue_bold_90;
                scale = 8 / 9;
                break;
            case constantsObj.FONT_HELVETICA_BOLD_40:
                font = fontArr.hel_neue_bold_90;
                scale = 4 / 9;
                break;
            case constantsObj.FONT_HELVETICA_BOLD_45:
                font = fontArr.hel_neue_bold_90;
                scale = 4.5 / 9;
                break;
            case constantsObj.FONT_HELVETICA_MEDIUM_80:
                font = fontArr.hel_neue_medium_70;
                scale = 8 / 7;
                break;
            case constantsObj.FONT_HELVETICA_MEDIUM_100:
                font = fontArr.hel_neue_medium_70;
                scale = 10 / 7;
                break;
            case constantsObj.FONT_HELVETICA_MEDIUM_107:
                font = fontArr.hel_neue_medium_70;
                scale = 10.7 / 7;
            case constantsObj.FONT_HELVETICA_MEDIUM_105:
                font = fontArr.hel_neue_medium_70;
                scale = 10.5 / 7;
                break;
            case constantsObj.FONT_HELVETICA_MEDIUM_110:
                font = fontArr.hel_neue_medium_70;
                scale = 11 / 7;
                break;
            case constantsObj.FONT_HELVETICA_MEDIUM_200:
                font = fontArr.hel_neue_medium_70;
                scale = 20 / 7;
                break;
            case constantsObj.FONT_HELVETICA_MEDIUM_250:
                font = fontArr.hel_neue_medium_70;
                scale = 25 / 7;
                break;
            case constantsObj.FONT_HELVETICA_MEDIUM_120:
                font = fontArr.hel_neue_medium_70;
                scale = 12 / 7;
                break;
            case constantsObj.FONT_HELVETICA_MEDIUM_90:
                font = fontArr.hel_neue_medium_70;
                scale = 9 / 7;
                break;
            case constantsObj.FONT_HELVETICA_MEDIUM_70:
                font = fontArr.hel_neue_medium_70;
                // scale = 6 / 8;
                break;
            case constantsObj.FONT_HELVETICA_MEDIUM_75:
                font = fontArr.hel_neue_medium_70;
                scale = 7.5 / 7;
                break;
            case constantsObj.FONT_HELVETICA_MEDIUM_60:
                font = fontArr.hel_neue_medium_70;
                scale = 6 / 7;
                break;
            case constantsObj.FONT_HELVETICA_MEDIUM_65:
                font = fontArr.hel_neue_medium_70;
                scale = 6.5 / 7;
                break;
            case constantsObj.FONT_HELVETICA_MEDIUM_45:
                font = fontArr.hel_neue_medium_70;
                scale = 9 / 14;
                break;
            case constantsObj.FONT_HELVETICA_MEDIUM_35:
                font = fontArr.hel_neue_medium_70;
                scale = 3.5/ 7;
                break;
            case constantsObj.FONT_HELVETICA_MEDIUM_40:
                font = fontArr.hel_neue_medium_70;
                scale = 4 / 7;
                break;
            case constantsObj.FONT_HELVETICA_MEDIUM_25:
                font = fontArr.hel_neue_medium_70;
                scale = 2.5 / 7;
                break;
            case constantsObj.FONT_HELVETICA_MEDIUM_50:
                font = fontArr.hel_neue_medium_70;
                scale = 5 / 7;
                break;
            case constantsObj.FONT_HELVETICA_MEDIUM_55:
                font = fontArr.hel_neue_medium_70;
                scale = 5.5 / 7;
                break;
            case constantsObj.FONT_HELVETICA_REGULAR_60:
                font = fontArr.sf_compact_regular_80;
                scale = 6 / 8;
                break;
            case constantsObj.FONT_HELVETICA_REGULAR_65:
                font = fontArr.sf_compact_regular_80;
                scale = 6.5 / 8;
                break;
            case constantsObj.FONT_HELVETICA_REGULAR_50:
                font = fontArr.sf_compact_regular_80;
                scale = 5 / 8;
                break;
            case constantsObj.FONT_HELVETICA_REGULAR_75:
                font = fontArr.sf_compact_regular_80;
                scale = 7.5 / 8;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_30:
                font = fontArr.sf_compact_regular_50;
                scale = 3 / 5;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_35:
                font = fontArr.sf_compact_regular_50;
                scale = 3.5 / 5;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_40:
                font = fontArr.sf_compact_regular_50;
                scale = 4 / 5;
                //font_size = 40;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_45:
                font = fontArr.sf_compact_regular_50;
                scale = 4.5 / 5;
                //font_size = 40;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_50:
                font = fontArr.sf_compact_regular_50;
                //font_size = 50;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_55:
                font = fontArr.sf_compact_regular_80;
                scale = 5.5 / 8;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_60:
                font = fontArr.sf_compact_regular_80;
                scale = 6 / 8;
                //font_size = 60;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_70:
                font = fontArr.sf_compact_regular_80;
                scale = 7 / 8;
                //font_size = 70;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_80:
                font = fontArr.sf_compact_regular_80;
                // scale = 8/13;
                //font_size = 80;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_90:
                font = fontArr.sf_compact_regular_120;
                scale = 9 / 12;
                //font_size = 90;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_100:
                font = fontArr.sf_compact_regular_120;
                scale = 10 / 12;
                //font_size = 100;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_120:
                font = fontArr.sf_compact_regular_120;
                // scale = 12/13;
                //font_size = 120;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_130:
                font = fontArr.sf_compact_regular_120;
                scale = 13 / 12;
                //font_size = 120;
                break;
            case constantsObj.FONT_ROBOTO_BOLD_30:
                font = fontArr.sf_compact_bold_50;
                scale = 3 / 5;
                //font_size = 30;
                break;
            case constantsObj.FONT_ROBOTO_BOLD_40:
                font = fontArr.sf_compact_bold_50;
                scale = 4 / 5;
                //font_size = 40;
                break;
            case constantsObj.FONT_ROBOTO_BOLD_50:
                font = fontArr.sf_compact_bold_50;
                // scale = 5/6;
                //font_size = 50;
                break;
            case constantsObj.FONT_ROBOTO_BOLD_60:
                font = fontArr.sf_compact_bold_80;
                scale = 6 / 8;
                //font_size = 60;
                break;
            case constantsObj.FONT_ROBOTO_BOLD_70:
                font = fontArr.sf_compact_bold_80;
                scale = 7 / 8;
                //font_size = 70;
                break;
            case constantsObj.FONT_ROBOTO_BOLD_80:
                font = fontArr.sf_compact_bold_80;
                // scale = 8/12;
                //font_size = 80;
                break;
            case constantsObj.FONT_ROBOTO_BOLD_90:
                font = fontArr.sf_compact_bold_120;
                scale = 9 / 12;
                //font_size = 90;
                break;
            case constantsObj.FONT_ROBOTO_BOLD_100:
                font = fontArr.sf_compact_bold_120;
                scale = 10 / 12;
                //font_size = 100;
                break;
            case constantsObj.FONT_ROBOTO_BOLD_120:
                font = fontArr.sf_compact_bold_120;
                //font_size = 120;
                break;
            case constantsObj.FONT_ROBOTO_BOLD_200:
                font = fontArr.sf_compact_bold_120;
                scale = 20 / 12;
                //font_size = 120;
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM_30:
                font = fontArr.sf_compact_regular_50;
                scale = 3 / 5;
                //font_size = 30;
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM_40:
                font = fontArr.sf_compact_regular_50;
                scale = 4 / 5;
                //font_size = 40;
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM_50:
                font = fontArr.sf_compact_regular_50;
                // scale = 5/6;
                //font_size = 50;
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM_45:
                font = fontArr.sf_compact_regular_50;
                scale = 9 / 10;
                //font_size = 50;
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM_55:
                font = fontArr.sf_compact_regular_80;
                scale = 11 / 16;
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM_60:
                font = fontArr.sf_compact_regular_80;
                scale = 6 / 8;
                //font_size = 60;
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM_70:
                font = fontArr.sf_compact_regular_80;
                scale = 7 / 8;
                //font_size = 70;
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM_80:
                font = fontArr.sf_compact_regular_80;
                // scale = 8/12;
                //font_size = 80;
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM_90:
                font = fontArr.sf_compact_regular_120;
                scale = 9 / 12;
                //font_size = 90;
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM_100:
                font = fontArr.sf_compact_regular_120;
                scale = 10 / 12;
                //font_size = 100;
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM_120:
                font = fontArr.sf_compact_regular_120;
                //font_size = 120;
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM_160:
                font = fontArr.sf_compact_regular_120;
                scale = 16 / 12;
                break;
            case constantsObj.FONT_ROBOTO_BOLD_160:
                font = fontArr.sf_compact_bold_120;
                scale = 16 / 12;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_25:
                font = fontArr.sf_compact_regular_50;
                scale = 0.5;
                break;
            case constantsObj.FONT_SFCOMPACT_MEDIUM_50:
                font = fontArr.sf_compact_regular_50;
                break;
            case constantsObj.FONT_SFCOMPACT_MEDIUM_60:
                font = fontArr.sf_compact_regular_80;
                scale = 6 / 8;
                break;
            case constantsObj.FONT_SFCOMPACT_MEDIUM_40:
                font = fontArr.sf_compact_regular_50;
                scale = 4 / 5;
                break;
            case constantsObj.FONT_SFCOMPACT_MEDIUM_30:
                font = fontArr.sf_compact_regular_50;
                scale = 3 / 5;
                break;
            case constantsObj.FONT_SFCOMPACT_MEDIUM_70:
                font = fontArr.sf_compact_regular_80;
                scale = 7 / 8;
                break;
            case constantsObj.FONT_SFCOMPACT_MEDIUM_80:
                font = fontArr.sf_compact_regular_80;
                scale = 1.0;
                break;
            case constantsObj.FONT_SFCOMPACT_MEDIUM_90:
                font = fontArr.sf_compact_regular_80;
                scale = 9 / 8;
                break;
            case constantsObj.FONT_SFCOMPACT_MEDIUM_100:
                font = fontArr.sf_compact_regular_80;
                scale = 10 / 8;
                break;
            case constantsObj.FONT_SFCOMPACT_MEDIUM_180:
                font = fontArr.sf_compact_regular_80;
                scale = 18 / 8;
                break;
            case constantsObj.FONT_SFCOMPACT_MEDIUM_190:
                font = fontArr.sf_compact_regular_120;
                scale = 19 / 12;
                break;
            case constantsObj.FONT_SFCOMPACT_REGULAR_200:
                font = fontArr.sf_compact_regular_120;
                scale = 1.66;
                break;
            case constantsObj.FONT_SFCOMPACT_REGULAR_30:
                font = fontArr.sf_compact_regular_50;
                scale = 3 / 5;
                break;
            case constantsObj.FONT_SFCOMPACT_REGULAR_120:
                font = fontArr.sf_compact_regular_120;
                break;
            case constantsObj.FONT_SFCOMPACT_REGULAR_60:
                font = fontArr.sf_compact_regular_80;
                scale = 6 / 8;
                break;
            case constantsObj.FONT_SFCOMPACT_REGULAR_70:
                font = fontArr.sf_compact_regular_80;
                scale = 7 / 8;
                break;
            case constantsObj.FONT_SFCOMPACT_REGULAR_80:
                font = fontArr.sf_compact_regular_80;
                // scale = 8/12;
                break;
            case constantsObj.FONT_SFCOMPACT_REGULAR_100:
                font = fontArr.sf_compact_regular_120;
                scale = 5 / 6;
                break;
        }
        // //loggerObj.traceLog("Getting label:", str, font_name);
        var label = new cc.LabelBMFont(str, font, width, alignment, imageOffset);
        if (color) {
            label.setColor(color);
        }
        label.setScale(scale);
        label.attr({
            x: x,
            y: y,
            anchorX: anchorX,
            anchorY: anchorY
        });
        utilObj.setPosition(label, x, y);

        if (labelArr != undefined && labelArr != null) {
            var info = {
                "label": label,
                "layer": layer,
                "z-order": zOrder,
                "font": font_name
            };
            if (tag != undefined) {
                info.tag = tag;
            }
            labelArr.push(info);
        }

        return label;
    };

    this.getBMFontLabelV1 = function (str, font_name, font_size, color, width, alignment, imageOffset, x, y, anchorX, anchorY, labelArr, layer, zOrder, tag) {
        if (width == undefined || width == null) {
            width = constantsObj.LABEL_AUTO_WIDTH;
        }
        if (alignment == undefined || alignment == null) {
            alignment = cc.TEXT_ALIGNMENT_LEFT;
        }
        if (imageOffset == undefined || imageOffset == null) {
            imageOffset = cc.p(0, 0);
        }

        const { baseFont, scale } = utilObj.getBaseFontNameAndScale(font_name, font_size);

        // //loggerObj.traceLog("Getting label:", str, font_name);
        var label = new cc.LabelBMFont(str, baseFont, width, alignment, imageOffset);
        if (color) {
            label.setColor(color);
        }
        label.setScale(scale);
        label.attr({
            x: x,
            y: y,
            anchorX: anchorX,
            anchorY: anchorY
        });
        utilObj.setPosition(label, x, y);

        if (labelArr != undefined && labelArr != null) {
            var info = {
                "label": label,
                "layer": layer,
                "z-order": zOrder,
                "font": font_name
            };
            if (tag != undefined) {
                info.tag = tag;
            }
            labelArr.push(info);
        }

        return label;
    };

    /**
     * function calculates and return the baseFont and scaleFactor required to get the needed font size.
     * @note - any new font file must be added in these if-else ladder once with correct baseFont and baseFontSize value to reflect in build.
     * @param {*} fontName 
     * @param {*} fontSize 
     * @returns 
     */
    this.getBaseFontNameAndScale = function (fontName, fontSize) {
        let scale, baseFont, baseFontSize;
        const fontArr = fontArr1;

        switch (fontName) {
            case constantsObj.FONT_ROBOTO_REGULAR:
                if (fontSize <= 45) {
                    baseFont = fontArr.roboto_regular_45;
                    baseFontSize = 45;
                } else if (fontSize <= 60) {
                    baseFont = fontArr.roboto_regular_60;
                    baseFontSize = 60;
                } else if (fontSize <= 75) {
                    baseFont = fontArr.roboto_regular_75;
                    baseFontSize = 75;
                } else {
                    baseFont = fontArr.roboto_regular_110;
                    baseFontSize = 110;
                }
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM:
                baseFont = fontArr.roboto_medium_70;
                baseFontSize = 70;
                break;
            case constantsObj.FONT_ROBOTO_BOLD:
                if (fontSize <= 45) {
                    baseFont = fontArr.roboto_bold_45;
                    baseFontSize = 45;
                } else if (fontSize <= 75) {
                    baseFont = fontArr.roboto_bold_75;
                    baseFontSize = 75;
                } else if (fontSize <= 90) {
                    baseFont = fontArr.roboto_bold_90;
                    baseFontSize = 90;
                } else {
                    baseFont = fontArr.roboto_bold_110;
                    baseFontSize = 110;
                }
                break;
            default:
                baseFont = fontName, baseFontSize = 1;
                break;
        }
        scale = fontSize / baseFontSize;
        return { baseFont, scale };
    };
    
    this.getFontName = function (resource) {
        if (utilObj.isNative() && !utilObj.isIos()) {
            return resource.srcs[0];
        } else {
            return resource.name;
        }
    };

    this.setColor = function (node, color) {
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        node.setColor(color);
    };

    this.getTTFFontLabel = function (str, font_name, color, width, alignment, imageOffset, x, y, anchorX, anchorY, labelArr, layer, zOrder, tag) {
        if (alignment == undefined || alignment == null) {
            alignment = cc.TEXT_ALIGNMENT_CENTER;
        }
        var font_size = 0;
        var font = null;
        switch (font_name) {
            case constantsObj.FONT_ROBOTO_REGULAR_25:
                font = utilObj.getFontName(res.roboto_regular);
                font_size = 25;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_30:
                font = utilObj.getFontName(res.roboto_regular);
                font_size = 30;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_40:
                font = utilObj.getFontName(res.roboto_regular);
                font_size = 40;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_50:
                font = utilObj.getFontName(res.roboto_regular);
                font_size = 50;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_55:
                font = utilObj.getFontName(res.roboto_regular);
                font_size = 55;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_60:
                font = utilObj.getFontName(res.roboto_regular);
                font_size = 60;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_70:
                font = utilObj.getFontName(res.roboto_regular);
                font_size = 70;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_80:
                font = utilObj.getFontName(res.roboto_regular);
                font_size = 80;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_90:
                font = utilObj.getFontName(res.roboto_regular);
                font_size = 90;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_100:
                font = utilObj.getFontName(res.roboto_regular);
                font_size = 100;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_120:
                font = utilObj.getFontName(res.roboto_regular);
                font_size = 120;
                break;
            case constantsObj.FONT_ROBOTO_BOLD_30:
                font = utilObj.getFontName(res.roboto_bold);
                font_size = 30;
                break;
            case constantsObj.FONT_ROBOTO_BOLD_40:
                font = utilObj.getFontName(res.roboto_bold);
                font_size = 40;
                break;
            case constantsObj.FONT_ROBOTO_BOLD_50:
                font = utilObj.getFontName(res.roboto_bold);
                font_size = 50;
                break;
            case constantsObj.FONT_ROBOTO_BOLD_60:
                font = utilObj.getFontName(res.roboto_bold);
                font_size = 60;
                break;
            case constantsObj.FONT_ROBOTO_BOLD_70:
                font = utilObj.getFontName(res.roboto_bold);
                font_size = 70;
                break;
            case constantsObj.FONT_ROBOTO_BOLD_80:
                font = utilObj.getFontName(res.roboto_bold);
                font_size = 80;
                break;
            case constantsObj.FONT_ROBOTO_BOLD_90:
                font = utilObj.getFontName(res.roboto_bold);
                font_size = 90;
                break;
            case constantsObj.FONT_ROBOTO_BOLD_100:
                font = utilObj.getFontName(res.roboto_bold);
                font_size = 100;
                break;
            case constantsObj.FONT_ROBOTO_BOLD_120:
                font = utilObj.getFontName(res.roboto_bold);
                font_size = 120;
                break;
            case constantsObj.FONT_ROBOTO_BOLD_230:
                font = utilObj.getFontName(res.roboto_bold);
                font_size = 230;
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM_30:
                font = utilObj.getFontName(res.roboto_medium);
                font_size = 30;
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM_40:
                font = utilObj.getFontName(res.roboto_medium);
                font_size = 40;
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM_45:
                font = utilObj.getFontName(res.roboto_medium);
                font_size = 45;
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM_50:
                font = utilObj.getFontName(res.roboto_medium);
                font_size = 50;
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM_60:
                font = utilObj.getFontName(res.roboto_medium);
                font_size = 60;
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM_70:
                font = utilObj.getFontName(res.roboto_medium);
                font_size = 70;
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM_80:
                font = utilObj.getFontName(res.roboto_medium);
                font_size = 80;
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM_90:
                font = utilObj.getFontName(res.roboto_medium);
                font_size = 90;
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM_100:
                font = utilObj.getFontName(res.roboto_medium);
                font_size = 100;
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM_110:
                font = utilObj.getFontName(res.roboto_medium);
                font_size = 110;
                break;
            case constantsObj.FONT_ROBOTO_MEDIUM_120:
                font = utilObj.getFontName(res.roboto_medium);
                font_size = 120;
                break;
            case constantsObj.FONT_ROBOTO_REGULAR_130:
                font = utilObj.getFontName(res.roboto_medium);
                font_size = 130;
                break;
            case constantsObj.FONT_SFCOMPACT_REGULAR_70:
                font = utilObj.getFontName(res.sfCompactDisplay_regular);
                font_size = 70;
                break;
            case constantsObj.FONT_SFCOMPACT_REGULAR_80:
                font = utilObj.getFontName(res.sfCompactDisplay_regular);
                font_size = 90;
                break;
        }
        var label = new cc.LabelTTF(str, font,
            font_size,
            cc.size(0, 0),
            alignment);
        label.setFontFillColor(color);
        label.attr({
            x: x,
            y: y,
            anchorX: anchorX,
            anchorY: anchorY
        });
        utilObj.setPosition(label, x, y);

        if (labelArr != undefined && labelArr != null) {
            var info = {
                "label": label,
                "layer": layer,
                "z-order": zOrder,
                "font": font_name
            };
            if (tag != undefined) {
                info.tag = tag;
            }
            labelArr.push(info);
        }
        return label;
    };

    this.getTextFieldTTF = function (str, width, height, alignment, font, fontSize, xPos, yPos, anchorX, anchorY, fn) {
        /*var textField = new cc.TextFieldTTF(str, cc.size(width, height), alignment, font, fontSize);
         textField.attr({
         x: xPos,
         y: yPos,
         anchorX: anchorX,
         anchorY: anchorY
         });
         utilObj.setPosition(textField, xPos, yPos);*/

        var textField = new ccui.TextField();
        textField.attr({
            x: xPos,
            y: yPos,
            anchorX: anchorX,
            anchorY: anchorY,
            height: height,
            width: width,
            align: alignment
        });

        textField.setMaxLengthEnabled(true);
        textField.setMaxLength(12);
        textField.setTouchEnabled(true);
        textField.fontName = font;
        textField.fontSize = fontSize;
        textField.setTextColor(constantsObj.COLOR_GREY_05);
        textField.setPlaceHolder(str);
        textField.addEventListener(fn);
        textField.setDetachWithIME(true);

        return textField;
    };

    this.getSprite = function (spriteName, xPos, yPos, anchorX, anchorY, scale, spriteArr, layer, zOrder, spritesheetType, tag) {
        //loggerObj.traceLog("Getting sprite for:", spriteName);
        var sprite;
        if (spriteName == null || spriteName == undefined || spriteName == "") {
            //loggerObj.errorLog("Sprite name is invalid:", spriteName);
        }
        try {
            // If the spritename is an invalid value, this simply causes crash on android.
            // It doesn't go to the catch block.
            // TODO: Make sure this is a valid sprite name - by comparing from a map perhaps.
            sprite = new cc.Sprite(spriteName);
            sprite.attr({
                anchorX: anchorX,
                anchorY: anchorY,
                scale: scale,
            });
            utilObj.setPosition(sprite, xPos, yPos);
        } catch (e) {
            // loggerObj.debugLog("Sprite not found:", spriteName, utilObj.getStringifiedJson(e));
            utilObj.loadSpriteFrameCache(false);
            sprite = new cc.Sprite();
        }

        if (spriteArr != undefined && spriteArr != null) {
            var info = {
                "sprite": sprite,
                "layer": layer,
                "z-order": zOrder,
                "type": spritesheetType,
            };
            if (tag != undefined && tag != "") {
                info.tag = tag;
            }
            spriteArr.push(info);
        }
        return sprite;
    };

    /**
     * creates a layer gradient using the values of the parameters
     * @param startColor
     * @param endColor
     * @param xPos
     * @param yPos
     * @param anchorX
     * @param anchorY
     * @param width
     * @param height
     * @param spriteArr
     * @param layer
     * @param zOrder
     * @param tag
     * @param directionVector
     * @param v
     * @param stops
     * @returns {*}
     */
    this.getLayerGradient = function (startColor, endColor, xPos, yPos, anchorX, anchorY, width, height, spriteArr, layer, zOrder, tag, directionVector, v, stops) {
        var gradient;
        if(!startColor || !endColor){
            loggerObj.debugLog("layerGradientBg: Undefined/Null values for creating gradient Layer");
            return;
        }
        gradient = new cc.LayerGradient(startColor, endColor, v, stops);
        gradient.anchorX = anchorX;
        gradient.anchorY = anchorY;
        gradient.ignoreAnchorPointForPosition(false);
        gradient.setPositionX(xPos);
        gradient.setPositionY(yPos);
        gradient.width = (width);
        gradient.height = (height);
        gradient.setVector(directionVector);

        if (spriteArr != undefined && spriteArr != null) {
            var info = {
                "sprite": gradient,
                "layer": layer,
                "z-order": zOrder,
                "type": null,
            };
            if (tag != undefined && tag != "") {
                info.tag = tag;
            }
            spriteArr.push(info);
        }

        return gradient;
    };

    var doesFileExist = {};
    this.loadImage = function (fileName, fileUrl, xPos, yPos, anchorX, anchorY, scale) {
        // loggerObj.debugLog("loading image fileName = ", fileName);
        var image = null;

        image = new cc.Sprite.create(fileUrl);

        if (image == null || image == undefined) {
            image = new cc.Sprite(constantsObj.profile_pic);
        }
        /*if (utilObj.isNative()) {
         /*var exists = false;
         if (doesFileExist[fileName] == undefined) {
         exists = utilObj.imageExists(fileName);
         doesFileExist[fileName] = exists;
         } else {
         exists = doesFileExist[fileName];
         }
         if (exists) {
         image = new cc.Sprite(fileUrl);
         // loggerObj.debugLog("loadImage = ", fileName);
         } else {
         image = new cc.Sprite(constantsObj.profile_pic);
         // loggerObj.debugLog("loadImage returned null for ", fileName);
         }
         image = new cc.Sprite.create(fileUrl);
         } else {
         image = new cc.Sprite.create(fileUrl);
         }*/
        image.attr({
            x: xPos,
            y: yPos,
            anchorX: anchorX,
            anchorY: anchorY,
            scale: scale
        });
        return image;
    };

    this.getScale9Sprite = function (spriteName, xPos, yPos, anchorX, anchorY, width, height, spriteArr, layer, zOrder, spritesheetType, tag) {
        var sprite;
        try {
            sprite = new cc.Scale9Sprite(spriteName);
            sprite.attr({
                x: xPos,
                y: yPos,
                anchorX: anchorX,
                anchorY: anchorY,
                width: width,
                height: height,
            });
        } catch (e) {
            //loggerObj.errorLog("Scale 9 Sprite not found:", spriteName, utilObj.getStringifiedJson(e));
            sprite = new cc.Scale9Sprite();
        }

        if (spriteArr != undefined && spriteArr != null) {
            var info = {
                "sprite": sprite,
                "layer": layer,
                "z-order": zOrder,
                "type": spritesheetType,
            };
            if (tag != undefined && tag != "") {
                info.tag = tag;
            }
            spriteArr.push(info);
        }
        return sprite;
    };

    /**
     * getRoundedButton params
     *
    */
    this.getRoundedButton = function(xPos,yPos,width,height,spriteArr,layer,zOrder,buttonColor){

        var btnShadow = utilObj.getScale9Sprite(constantsObj.button_round_shadow, xPos, yPos, 0.5,0.5, width * 242/height, 242, spriteArr, layer, zOrder, constantsObj.SPRITE_MISC);

        var btnBg = utilObj.getScale9Sprite(constantsObj.button_round, (width * 242/height)/2, 135, 0.5, 0.5, width * 242/height - 35, 206, spriteArr, btnShadow, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setColor( btnBg, buttonColor);

        utilObj.setScale(btnShadow , height/242);

        var childArr = [btnShadow, btnBg];
        return childArr;
       
    };

    this.updateJewelNotifTop = function(nodeIcon , nodeLabel){
        var jewlNotifState = questCenterObj.showJewelNotif();

        if(jewlNotifState == 0){
            utilObj.setString(nodeLabel, "NEW");
            utilObj.setVisible(nodeIcon , true);
            utilObj.setVisible(nodeLabel , true);
            utilObj.setScale(nodeIcon, 0);
            utilObj.setScale(nodeIcon, constantsObj.SCALE_SPRITE_NEW_1 * 0.4);
        }else if(jewlNotifState > 0){
            var strg = "";
            strg += jewlNotifState;
            utilObj.setString(nodeLabel, strg);
            utilObj.setVisible(nodeIcon , true);
            utilObj.setVisible(nodeLabel , true);
            utilObj.setScale(nodeIcon , 0);
            utilObj.setScale(nodeIcon , constantsObj.SCALE_SPRITE_NEW_1 * 0.4);
            utilObj.setScaleX(nodeIcon, (constantsObj.SCALE_SPRITE_NEW_1 * 0.4) / 1.5);
        }else if(jewlNotifState == -1){
            utilObj.setVisible(nodeIcon , false);
            utilObj.setVisible(nodeLabel , false);
        }

        questCenterObj.notifSurfacingTracking();

    };
    // Delay time is in seconds
    this.delayedCallback = function (node, fn, delay, params, force) {
        // loggerObj.debugLog("changeBg log : Delayed callback with params", fn);
        if (utilObj.isAutoPlayNoAnim() || (constantsObj.LOG_LEVEL == constantsObj.TRACE && utilObj.isNonStopPlayOn() && curScreen != constantsObj.SCREEN_GAME)) {
            if (force == undefined || force == false) {
                fn(node, params);
                return;
            }
        }
        if (node == null || node == undefined) {
            //loggerObj.errorLog("node is invalid in delayedCallback");
            return;
        }
        var delayAction = utilObj.getDelayTime(delay);
        var fnCallAction = utilObj.getCallFunc(fn, this, params);

        var actions = [delayAction, fnCallAction];
        var seq = utilObj.getSequence(actions, true);
        if (utilObj.isNodeValid(node)) {
            // node.runAction(seq);
            animObj.runAction(node, seq);
        }
    };

    this.getColorForHexCode = function (hex) {
        var r = parseInt(hex.substr(0, 2), 16);
        var g = parseInt(hex.substr(2, 2), 16);
        var b = parseInt(hex.substr(4, 2), 16);
        return cc.color(r, g, b);
    };


    this.setColorToPartialTextWordWise = function (labelNode, wordIndexStartFor, wordsCountForColor, newColor, isNewColorHex, defaultColor, isDefaultColorHex) {
        if(isDefaultColorHex) {
            defaultColor = utilObj.getColorForHexCode(defaultColor);
        }
        if(isNewColorHex) {
            newColor = utilObj.getColorForHexCode(newColor);
        }
        var currentWordCount = 1;
        var labelString = labelNode.getString();
        var letter = null;
        var letterChar = '';
        for (var letterIndex = 0; letterIndex < labelString.length; letterIndex++) {
            var letter = labelNode.getLetter(letterIndex);
            letterChar = labelString[letterIndex];
            if(letterChar == ' ') {
                currentWordCount += 1;
            }
            if(currentWordCount >= wordIndexStartFor && currentWordCount < wordIndexStartFor + wordsCountForColor) {
                utilObj.setColor(letter, newColor);
            } else {
                utilObj.setColor(letter, defaultColor);
            }
        }
    };

    this.setVisible = function (node, bool) {
        if (utilObj.isNodeValid(node)) {
            node.setVisible(bool);
        } else {
            // loggerObj.debugLog("Node is not valid for set visible for layer:", node, bool);
        }
    };

    this.canScheduleMoreCallbacksComfortably = function () {
        var callbacksPending = callbackIndex - callbacksIntercepted;
        if (callbacksPending + 5 > constantsObj.CALLBACKS_LIMIT) {
            return false;
        }
        return true;
    };

    this.canScheduleMoreCallbacks = function () {
        var callbacksPending = callbackIndex - callbacksIntercepted;
        if (callbacksPending > constantsObj.CALLBACKS_LIMIT) {
            //loggerObj.errorLog("Too many callbacks pending:", callbacksPending);
            return false;
        }
        return true;
    };

    var callbacksIntercepted = 0;
    this.callbackInterceptor = function (sender, params) {
        var paramsAsStr = "";
        try {
            // paramsAsStr = utilObj.getStringifiedJson(params.originalParams);
        } catch (e) {

        }
        // //loggerObj.traceLog("Callback intercepted:", params, paramsAsStr, params.index);

        var originalFunc = params.originalFunc;
        var originalParams = params.originalParams;
        var index = params.index;
        var screen = params.screen;
        /*if (index == 121 || index == 112 || index == 119 || index == 123) {
         //loggerObj.traceLog("Checking what happens without these", index);
         return;
         }*/
        if (utilObj.isObject(originalParams)) {
            originalParams.callbackIndex = callbackIndex;
        }
        if (curScreen != screen) {
            // Suraj: Can't do this in a blanket manner right now. Affects things like popups.
            // //loggerObj.errorLog("Function:", originalFunc, utilObj.getStringifiedJson(params));
            if (curLayer != popupLayer) {
                //loggerObj.traceLog("Callback pending from older screen ignored:", screen, curScreen, index);
                // return; // Suraj: This doesn't work with timer levels. Condition needs to be added for that.
            }
        } else {
            callbacksIntercepted++;
        }

        if (utilObj.isFunction(originalFunc)) {
            originalFunc(sender, originalParams);
        } else {
            // loggerObj.debugLog("Callback intercepted with invalid function:", index, utilObj.getStringifiedJson(params));
        }
    };

    var callbackIndex = 0;
    this.getCallFunc = function (fn, obj, params) {
        var f;
        if (!utilObj.canScheduleMoreCallbacks() && params != undefined && params.criticalCallback == false) {
            // loggerObj.debugLog("Dropping callback function as already many pending:", params);
            return utilObj.getDelayTime(0);
        }
        if (constantsObj.LOG_LEVEL == 0) {
            var paramsAsStr = "";
            // var paramsAsStr = utilObj.getStringifiedJson(params);
            /*if (fn == animObj.blast && (params.score == undefined || params.blastFrameDelay == undefined)) {
             //loggerObj.errorLog("Got calling function match - with invalid params:", params, paramsAsStr);
             }*/

            /*if (callbackIndex >= 120) {
             f = new cc.CallFunc(utilObj.noOp, obj, params);
             //loggerObj.traceLog("Callback index limit reached:", callbackIndex, paramsAsStr);
             return f;
             }*/

            //loggerObj.traceLog("Getting calling func:", callbackIndex, curScreen, updatingToScreen);
            var p = {
                originalFunc: fn,
                originalParams: params,
                index: callbackIndex,
                screen: updatingToScreen,
                curScreen: curScreen
            };
            callbackIndex++;
            f = new cc.CallFunc(utilObj.callbackInterceptor, obj, p);
        } else {
            f = new cc.CallFunc(fn, obj, params);
        }

        return f;
    };

    this.flipSpriteX = function (sender, sprite) {
        if (utilObj.isSpriteValid(sprite)) {
            if (utilObj.isWeb()) {
                sprite.setScale(-1 * sprite.getScale(), sprite.getScale());
            } else {
                sprite.setFlippedX(true);
            }
        }
    };

    this.flipLabelX = function (sender, sprite) {
        if (utilObj.isSpriteValid(sprite)) {
            sprite.setScale(-1 * sprite.getScale(), sprite.getScale());
        }
    };

    this.flipSpriteY = function (sender, sprite) {
        if (utilObj.isSpriteValid(sprite)) {
            if (utilObj.isWeb()) {
                sprite.setScale(sprite.getScale(), -1 * sprite.getScale());
            } else {
                sprite.setFlippedY(true);
            }
        }
    };

    this.getCallbackIndex = function () {
        return callbackIndex;
    };

    this.resetCallbacksInfo = function () {
        callbackIndex = 0;
        callbacksIntercepted = 0;
    };

    var removeIndex = 0;
    this.getRemoveSelf = function (layer, desc) {
        if (desc == undefined) {
            desc = "";
        }
        // //loggerObj.traceLog("Remove self in seq:", layer, removeIndex, desc);
        var r = utilObj.getCallFunc(utilObj.removeSelf, this, {layer: layer, index: removeIndex, canStringify: false});
        removeIndex++;
        return r;
    };

    // Used for elements which are not going to interact or get accessed from any other place
    this.getIndependentRemoveSelf = function () {
        return new cc.RemoveSelf(false);
    };

    this.removeOrFade = function (tile, sprite) {
        // Not using sprite yet, but may use it later on.
        if (sprite.isSprite) {
            return new cc.FadeOut(0);
        } else {
            return utilObj.getCallFunc(utilObj.changeVisibility, gameLayer, {element: sprite, status: false});
        }
        return null;
    };

    this.getRemoveSelfAndMark = function (node, layer, desc) {
        if (!utilObj.isSpriteValid(node)) {
            return;
        }
        if (node.markedForRemoval) {
            //loggerObj.traceLog("Already marked for removal:", node.markedForRemoval, node.removeIndex);
            return false;
        }
        // Suraj: Adding custom properties to know state
        node.markedForRemoval = true;
        node.removeIndex = removeIndex;

        return utilObj.getIndependentRemoveSelf(); // Suraj: For now most places where node was getting removed have been converted to fadeout. So simplifying.

        if (desc == undefined) {
            desc = "";
        }
        // //loggerObj.traceLog("Remove scheduled with markings:", node.markedForRemoval, node.removeIndex);
        return utilObj.getRemoveSelf(layer, desc);
    };

    var lastRemoved = -1;
    this.removeSelf = function (child, params) {
        if (params.desc != undefined) {
            // //loggerObj.traceLog("Remove self triggered with desc:", params, params.desc);
        } else {
            // //loggerObj.traceLog("Remove self triggered with params:", params);
        }

        var parent = null;
        var index = constantsObj.NOT_FOUND;
        // Suraj: Uncommenting this will cause crashes. Even checking for valid int causes crash if the value is an invalid memory location.
        if (params.index != undefined && utilObj.isInt(params.index)) {
            index = params.index;
        }
        if (utilObj.isSpriteValid(child)) {
            // //loggerObj.traceLog("Removing self:", index);
            try {
                child.stopAllActions();
                child.setVisible(false);
                var parent = child.getParent();
                if (parent != null) {
                    utilObj.removeChild(parent, child);
                    lastRemoved = index;
                }
            } catch (e) {
                // loggerObj.debugLog("Exception when removing child:", e);
            }
        } else {
            // loggerObj.debugLog("Invalid sprite when trying to remove self", child, index, parent);
        }
    };

    this.isStaging = function () {
        if (constantsObj.ENV == constantsObj.STAGING) {
            return true;
        }
        return false;
    };

    this.areAnimsOn = function () {
        if (constantsObj.ANIM_MODE == constantsObj.ANIM_LOW) {
            return false;
        }
        return true;
    };

    this.isSpriteValid = function (sprite) {
        if (sprite != undefined && sprite != constantsObj.NOT_FOUND
            && sprite != null && utilObj.isObject(sprite)) {
            // Suraj: The getParent may be causing crashes when things go wrong.
            try {
                sprite.getParent();
            } catch (err) {
                loggerObj.debugLog("Sprite passed is invalid:", sprite);
                return false;
            }
            return true;
        }
        return false;
    };

    /**
     * checks if the node is valid
     * @param node
     */
    this.isNodeValid = function (node) {
        return utilObj.isSpriteValid(node);
    };

    /**
     * checks if all the nodes passed in the array are valid or not
     * @param nodeArr
     * @returns {boolean}
     */
    this.areAllNodesValid = function (nodeArr) {
        var allNodesValid = true;
        for(var i = 0; i < nodeArr.length; i++){
            allNodesValid = (allNodesValid && utilObj.isNodeValid(nodeArr[i]));
        }
        return allNodesValid;
    };

    this.getStringifiedJson = function (obj) {
        var str = "";
        if (obj == undefined || obj.layer != null) {
            return str;
        }
        try {
            if (obj.canStringify == undefined || obj.canStringify == true || obj.spriteIndex != undefined) {
                str = JSON.stringify(obj);
            }
        } catch (e) {
            // //loggerObj.errorLog("Error when trying to stringify params:", e);
        }
        return str;
    };

    var soundsPlayedAt = {};
    var lastSoundAt = 0;
    this.playSound = function (s, loop, throttled) {
        if (!gameObj.getSounds()) {
            return;
        }
        cc.audioEngine.stopAllEffects();
        if (utilObj.isAutoPlayOn()) {
            return -1;
        }
        // return; //Suraj: Need to optimize the number of triggers happening to this. Calling this too often is also causing crashes.
        //loggerObj.traceLog("Attempting to play sound:", s, loop);
        if (utilObj.isSoundPlayable()) {
            var soundId = cc.audioEngine.playEffect(s, loop);
            utilObj.addSoundToPlaying(soundId);
            if (utilObj.isIos()) {
                cc.audioEngine.setEffectsVolume(0.1);
            }
            return soundId;

            /*if (curTimestampMs - lastSoundAt > constantsObj.MIN_SOUND_DELAY
             && curTimestampMs - soundsPlayedAt[s] > constantsObj.MIN_SAME_SOUND_DELAY) {
             /*if (throttled == true && curTimestampMs - soundsPlayedAt[s] < constantsObj.MIN_THROTTLED_SOUND_DELAY) {
             return -1;
             }*/
            /*soundsPlayedAt[s] = curTimestampMs;
             lastSoundAt = curTimestampMs;
             var soundId = cc.audioEngine.playEffect(s, loop);
             utilObj.addSoundToPlaying(soundId);
             return soundId;
             }*/
            //return -1;
        }
        return -1;
    };

    this.addSoundToPlaying = function (soundId) {
        if (soundsRunning.length < constantsObj.MAX_SOUNDS) {
            soundsRunning.push(soundId);
        } else {
            var id = soundsRunning[soundIndex];
            if (id > -1) {
                utilObj.stopSound(id);
            }
            soundsRunning[soundIndex] = soundId;
            soundIndex = (soundIndex + 1) % constantsObj.MAX_SOUNDS;
        }
    };

    this.stopSound = function (id) {
        cc.audioEngine.stopEffect(id);
    };

    this.stopPlayingSound = function () {
        cc.audioEngine.stopAllEffects();
    };

    this.isSoundPlayable = function () {
        /**
         This is to check if the sound can be played at the system level..
         if the user has set phone to vibration or mute.
         **/

        if (utilObj.isNative()) {
            if (utilObj.isAndroid()) {
                return jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "isSoundPlayable", "()Z");
            } else if (utilObj.isIos()) {
                return true;
            }
        } else {
            return true;
        }
    };

    var isMusicPaused = true;
    this.playMusic = function (s, loop) {
        if (!gameObj.getSounds()) {
            return;
        }
        if (utilObj.isAutoPlayOn()) {
            return;
        }
        cc.audioEngine.setMusicVolume(1.0);
        if (utilObj.isSoundPlayable()) {
            isMusicPaused = false;
            cc.audioEngine.playMusic(s, loop);
        }
    };

    this.playBgMusic = function () {
        utilObj.playMusic(constantsObj.BG_MUSIC_FILE_1, true);
    };

    this.stopMusic = function () {
        if (!isMusicPaused) {
            isMusicPaused = true;
            cc.audioEngine.stopMusic(false);
        }
    };

    this.pauseMusic = function () {
        if (!isMusicPaused) {
            isMusicPaused = !isMusicPaused;
            cc.audioEngine.pauseMusic();
        }
    };

    this.resumeMusic = function () {
        if (isMusicPaused) {
            isMusicPaused = !isMusicPaused;
            cc.audioEngine.resumeMusic();
        }
    };

    this.fadeMusicOn = function () {
        cc.audioEngine.setMusicVolume(0.5);
    };

    this.fadeMusicOff = function () {
        cc.audioEngine.setMusicVolume(1.0);
    };

    this.addLabels = function (labelArr) {
        if (labelArr.length <= 0) {
            return;
        }

        var orderedArr = null;
        if (labelArr[0]["font"] != undefined) {
            var sortedPerFont = {};
            for (var i = 0; i < labelArr.length; i++) {
                var font = labelArr[i]["font"];
                if (sortedPerFont[font] == undefined) {
                    sortedPerFont[font] = [];
                }
                sortedPerFont[font].push(labelArr[i]);
            }

            orderedArr = [];
            for (var f in sortedPerFont) {
                // //loggerObj.traceLog("Sorted per font:", f);
                for (var n in sortedPerFont[f]) {
                    orderedArr.push(sortedPerFont[f][n]);
                }
            }
        } else {
            orderedArr = labelArr;
        }
        for (var i = 0; i < orderedArr.length; i++) {
            var tag = orderedArr[i]["tag"];
            var zOrder = parseInt(orderedArr[i]["z-order"]);
            var label = orderedArr[i]["label"];
            if (tag == undefined) {
                orderedArr[i]["layer"].addChild(label, zOrder);
            } else {
                orderedArr[i]["layer"].addChild(label, zOrder, parseInt(tag));
            }
        }
    };

    this.addSprites = function (spriteArr) {
        // loggerObj.debugLog("Adding sprites:", spriteArr.length);
        if (spriteArr.length <= 0) {
            // loggerObj.debugLog("No sprites to add");
            return;
        }

        var orderedArr = null;
        if (spriteArr[0]["type"] != undefined) {
            var sortedPerType = {};
            for (var i = 0; i < spriteArr.length; i++) {
                var elementType = spriteArr[i]["type"];
                if (sortedPerType[elementType] == undefined) {
                    sortedPerType[elementType] = [];
                }
                sortedPerType[elementType].push(spriteArr[i]);
            }

            orderedArr = [];
            for (var f in sortedPerType) {
                //loggerObj.traceLog("Sorted per type:", f);
                for (var n in sortedPerType[f]) {
                    orderedArr.push(sortedPerType[f][n]);
                }
            }
        } else {
            orderedArr = spriteArr;
        }
        for (var i = 0; i < orderedArr.length; i++) {
            var tag = orderedArr[i]["tag"];
            var zOrder = parseInt(orderedArr[i]["z-order"]);
            // loggerObj.debugLog("Sorted sprite of z order:", zOrder);
            var label = orderedArr[i]["sprite"];
            if (tag == undefined) {
                orderedArr[i]["layer"].addChild(label, zOrder);
            } else {
                orderedArr[i]["layer"].addChild(label, zOrder, parseInt(tag));
            }
        }
    };

    this.getSplitStringsArr = function (string1, splitLen) {
        var finalLinesArr = [];
        if (string1 == undefined) {
            return finalLinesArr;
        }
        var lines = string1.split("\n");
        var finalLinesArr = [];
        var lineNum = 0;
        for (var i = 0; i < lines.length; i++) {
            finalLinesArr[lineNum] = "";
            var words = lines[i].split(" ");
            for (var w = 0; w < words.length; w++) {
                if (finalLinesArr[lineNum].length + words[w].length > splitLen) {
                    finalLinesArr[lineNum] = finalLinesArr[lineNum].substr(0, finalLinesArr[lineNum].length - 1);
                    lineNum++;
                    finalLinesArr[lineNum] = "";
                }

                finalLinesArr[lineNum] += words[w] + " ";
            }
            lineNum++;
            //finalLinesArr[lineNum] = " ";
            //lineNum++;
        }

        return finalLinesArr;
    };

    this.getSpitStringArrwithWidth = function (string1, splitwidth, font) {
        var finalLinesArr = [];
        if (string1 == undefined) {
            return finalLinesArr;
        }
        var lines = string1.split("\n");
        var lineNum = 0;
        var fontDictData = gameObj.getFontDictData();
        for (var i = 0; i < lines.length; i++) {
            finalLinesArr[lineNum] = "";
            var widthForlineNum = 0;
            var words = lines[i].split(" ");
            for (var w = 0; w < words.length; w++) {
                var widthforWord = utilObj.getWidthforWord(words[w], font);
                if (widthForlineNum + widthforWord > splitwidth) {
                    finalLinesArr[lineNum] = finalLinesArr[lineNum].substr(0, finalLinesArr[lineNum].length - 1);
                    lineNum++;
                    widthForlineNum = 0;
                    finalLinesArr[lineNum] = "";
                    // loggerObj.debugLog("coming here1", widthForlineNum + widthforWord);
                }

                finalLinesArr[lineNum] += words[w] + " ";
                widthForlineNum += widthforWord;
                if (fontDictData != null) {
                    widthForlineNum += parseInt(fontDictData[font]['116']);
                }
                // loggerObj.debugLog("coming here2", widthForlineNum, widthforWord);
            }

            lineNum++;
        }

        return finalLinesArr;
    };

    this.getWidthforWord = function (word, font) {
        var width = 0;
        var fontDictData = gameObj.getFontDictData();
        if (fontDictData == null) {
            return 20;
        }
        for (var i = 0; i < word.length; i++) {
            //loggerObj.debugLog("coming here3",  word[i], word[i].charCodeAt(0), gameLayer.fontDictData[font][word[i].charCodeAt(0)]);

            width += parseInt(fontDictData[font][word[i].charCodeAt(0)]);

            // loggerObj.debugLog("coming here3",  word[i], word[i].charCodeAt(0), gameLayer.fontDictData[font][word[i].charCodeAt(0)]);
        }
        return width;
    };

    this.getStringsArrWithFont = function (paras) {
        var lines = paras;
        var finalLinesArr = [];
        var lineNum = 0;
        var splitLen = 5000000;
        for (var i = 0; i < lines.length; i++) {
            var bold_st = 0;
            var font = res.roboto_regular;
            finalLinesArr[lineNum] = ["", font];
            var words = lines[i].split(" ");
            for (var w = 0; w < words.length; w++) {
                if (finalLinesArr[lineNum][0].length + words[w].length > splitLen) {
                    var lineTemp = finalLinesArr[lineNum][0];
                    if (lineTemp.indexOf("<b>") > -1) {
                        bold_st = 1;
                    }
                    font = res.roboto_regular;
                    if (bold_st == 1) {
                        font = res.roboto_bold;
                    }

                    finalLinesArr[lineNum] = [finalLinesArr[lineNum][0].replace("<b>", "").replace("</b>", "").substr(0, finalLinesArr[lineNum][0].length - 1), font];

                    if (lineTemp.indexOf("</b>") > -1) {
                        bold_st = 0;
                    }

                    lineNum++;
                    finalLinesArr[lineNum] = ["", font];
                }
                finalLinesArr[lineNum][0] += words[w] + " ";
            }
            var lineTemp = finalLinesArr[lineNum][0];
            if (lineTemp.indexOf("<b>") > -1) {
                bold_st = 1;
            }
            font = res.roboto_regular;
            if (bold_st == 1) {
                font = res.roboto_bold;
            }
            finalLinesArr[lineNum] = [finalLinesArr[lineNum][0].replace("<b>", "").replace("</b>", ""), font];
            if (lineTemp.indexOf("</b>") > -1) {
                bold_st = 0;
            }
            // loggerObj.debugLog("final string here", finalLinesArr[lineNum][0]);
            lineNum++;
            finalLinesArr[lineNum] = " ";
            lineNum++;

        }

        return finalLinesArr;
    };

    this.getSplitStringsArrWithFont = function (string, splitLen) {
        var lines = string.split("<br>");
        var finalLinesArr = [];
        var lineNum = 0;

        for (var i = 0; i < lines.length; i++) {
            var bold_st = 0;
            var font = res.roboto_regular;
            finalLinesArr[lineNum] = ["", font];
            var words = lines[i].split(" ");
            for (var w = 0; w < words.length; w++) {
                if (finalLinesArr[lineNum][0].length + words[w].length > splitLen) {
                    var lineTemp = finalLinesArr[lineNum][0];
                    if (lineTemp.indexOf("<b>") > -1) {
                        bold_st = 1;
                    }
                    font = res.roboto_regular;
                    if (bold_st == 1) {
                        font = res.roboto_bold;
                    }

                    finalLinesArr[lineNum] = [finalLinesArr[lineNum][0].replace("<b>", "").replace("</b>", "").substr(0, finalLinesArr[lineNum][0].length - 1), font];

                    if (lineTemp.indexOf("</b>") > -1) {
                        bold_st = 0;
                    }

                    lineNum++;
                    finalLinesArr[lineNum] = ["", font];
                }
                finalLinesArr[lineNum][0] += words[w] + " ";
            }
            var lineTemp = finalLinesArr[lineNum][0];
            if (lineTemp.indexOf("<b>") > -1) {
                bold_st = 1;
            }
            font = res.roboto_regular;
            if (bold_st == 1) {
                font = res.roboto_bold;
            }
            finalLinesArr[lineNum] = [finalLinesArr[lineNum][0].replace("<b>", "").replace("</b>", ""), font];
            if (lineTemp.indexOf("</b>") > -1) {
                bold_st = 0;
            }
            lineNum++;
            finalLinesArr[lineNum] = " ";
            lineNum++;
        }

        return finalLinesArr;
    };

    this.getDayOfYearFor = function (dateFor) {
        var start = new Date(dateFor.getFullYear(), 0, 0);
        var diff = dateFor - start;
        var oneDay = 1000 * constantsObj.SECONDS_IN_DAY;
        var day = Math.ceil(diff / oneDay);
        return day;
    };

    this.getDayOfYear = function () {
        if (utilObj.isAndroid()) {
            return jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "getDayOfYear", "()I");
        } else {
            var now = new Date();
            return utilObj.getDayOfYearFor(now);
        }
    };

    this.getYesterdaysDayOfYear = function () {
        if (utilObj.isAndroid()) {
            return jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "getYesterdaysDayOfYear", "()I");
        } else {
            var date = new Date();
            date.setDate(date.getDate() - 1);
            return utilObj.getDayOfYearFor(date);
        }
    };

    this.getLocalNotifClickedType = function () {
        if (utilObj.isAndroid()) {
            if (epmObj.getChosenVariant(constantsObj.EXP_NOTIF_REVAMP_NEW) != constantsObj.EXP_VAR_CONTROL) {
                var type = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "checkLocalNotifClicked", "()I");
                // loggerObj.debugLog("local notif clicked type ", type);
                if (type != 0) {
                    return type;
                }
            }
        }
        return 0;
    };

    this.checkNotifTriggered = function () {
        // if (utilObj.isAndroid()) {
        //     loggerObj.debugLog("local notif - notif redirection - check for the logs");
        //     if (epmObj.getChosenVariant(constantsObj.EXP_NOTIF_REVAMP_NEW) != constantsObj.EXP_VAR_CONTROL) {
        //         var success = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "checkNotifTriggered", "()I");
        //         loggerObj.debugLog("local notif - notif redirection - chekc for the current date4321 ",success);
        //         if (success != 0) {
        //             gameObj.setIsRetargetedNotifTriggered(true);
        //         }
        //         // loggerObj.debugLog("check for the logs1", success);
        //         return success;
        //     }
        // }
        return 0;
    };

    this.checkAnyNotifTriggered = function () {
        if (utilObj.isAndroid()) {
            // loggerObj.debugLog("check for the logs");
            var success = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "checkAnyNotifTriggered", "()I");
            // loggerObj.debugLog("check for the logs1", success);
            return success == 1 ? true : false;
        }
        return false;
    };

    this.setupDailyAlarm = function () {

        loggerObj.debugLog("local notif - call coming");

        if (utilObj.isNative()) {
            if (utilObj.isAndroid()) {
                jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "setupDailyAlarm", "()V");
            } else if (utilObj.isIos()) {
                jsb.reflection.callStaticMethod("Util", "setupLocalNotifs"); // Stopping notif call as of now
            }
        } else {
            // loggerObj.debugLog("No alarms for web");
        }
    };

    this.checkForNotifPermission = function () {
        if (utilObj.isIos()) {
            jsb.reflection.callStaticMethod("Util", "checkForNotifPermission");
        }
    };

    this.redirectToSettings = function () {
        if (utilObj.isIos()) {
            jsb.reflection.callStaticMethod("Util", "redirectToSettings");
        }
    };

    this.checkIfNotifsEnabled = function (doNotGrant) {
        var noMoneyReward = false;
        if (doNotGrant != undefined && doNotGrant == true) {
            noMoneyReward = true;
        }
        var notifsEnabled = false;
        if (utilObj.isIos()) {
            notifsEnabled = jsb.reflection.callStaticMethod("Notifs", "isNotificationEnabled");
            if (notifsEnabled == true) {
                gameObj.setNotifsEnabled(true);
            }
        }
        return notifsEnabled;
    };

    this.getAspectRatio = function () {
        var screenSize = cc.view.getFrameSize();
        var ratio = screenSize.height / screenSize.width;
        //loggerObj.debugLog("the aspect ratio", ratio);
        return ratio;
    };

    this.getDesignHeight = function () {
        if (utilObj.getIsLikeIphoneX()) {
            var designHeight = 1440 * aspectRatio;
            return designHeight;
        } else {
            return constantsObj.DESIGN_HEIGHT;
        }
    };

    this.showCashGrantMessage = function (cashToGrant) {
        var text1 = stringsObj.coins_added;
        var text2 = stringsObj.coin_added;
        var text = text1;
        if (cashToGrant == 1) {
            text = text2;
        }
        text = text.replace("%N%", cashToGrant);
        utilObj.showMessage(text);
    };

    this.getSystemUpTime = function () {
        var systemUpTime = null;
        if (utilObj.isNative()) {
            if (utilObj.isAndroid()) {
                systemUpTime = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "getSystemUpTime", "()I");
            } else if (utilObj.isIos()) {
                systemUpTime = utilObj.getCurrentTimestamp();
            }
        } else {
            systemUpTime = utilObj.getCurrentTimestamp();
        }
        return systemUpTime;
    };

    this.formatTime = function (s, zeroStr) {
        if (s <= 0 && zeroStr != undefined && zeroStr != "") {
            return zeroStr;
        }
        var hrs = parseInt(s / constantsObj.SECONDS_IN_HOUR);
        var hrsStr = "";
        if (hrs > 0) {
            s -= hrs * constantsObj.SECONDS_IN_HOUR;
            if (hrs < 10) {
                hrsStr = "0";
            }
            hrsStr += hrs + ":";
        }
        var min = parseInt(s / constantsObj.SECONDS_IN_MIN);
        if (min < 10) {
            min = "0" + min;
        }
        var sec = s % constantsObj.SECONDS_IN_MIN;
        if (sec < 10) {
            sec = "0" + sec;
        }
        return hrsStr + min + ":" + sec;
    };

    this.formatTimeHour = function (totalSec) {
        totalSec = Number(totalSec);
        var h = Math.floor(totalSec / 3600);
        var m = Math.floor(totalSec % 3600 / 60);
        var s = Math.floor(totalSec % 3600 % 60);
        return ((h > 0 ? h + ":" + (m < 10 ? "0" : "") : "") + m + ":" + (s < 10 ? "0" : "") + s);
    };

    this.updateLabel = function (layer, tag, val, font) {
        // loggerObj.debugLog("coinloss", layer, tag, val, font);
        if (layer == undefined || layer == null) {
            return;
        }
        if (tag == undefined || tag == null) {
            return;
        }
        var label = layer.getChildByTag(tag);
        if (label != null && utilObj.isNodeValid(label)) {
            label.setString(val);

            if (font != null && font != undefined) {
                label.setFntFile(font);
            }
        }
    };

    this.updateCashLabel = function (layer, font) {
        if (layer == undefined || layer == null) {
            return;
        }
        if (layer.cashLbl == undefined || layer.cashLbl == null || !utilObj.isNodeValid(layer.cashLbl)) {
            return;
        }
        var cashCount = economyObj.getCash();
        if (utilObj.isNodeValid(layer.cashLbl)) {
            layer.cashLbl.setString(cashCount + "");
        }
    };

    this.setString = function (label, str) {
        if (!utilObj.isNodeValid(label)) {
            // loggerObj.debugLog("labelLog: Invalid label passed for setting string str -> ", str);
            return;
        }
        label.setString(str);
    };

    this.updateMasteryLabel = function (layer, font) {
        if (layer == undefined || layer == null) {
            return;
        }
        if (layer.masteryLbl == undefined || layer.masteryLbl == null || !utilObj.isNodeValid(layer.masteryLbl)) {
            return;
        }
        var MasteryCount = gameObj.getMastery();

        if (utilObj.isNodeValid(layer.masteryLbl)) {
            layer.masteryLbl.setString(MasteryCount + "");
        }
    };

    this.getAdvertiserId = function () {
        if (utilObj.isAndroid()) {
            advertiserId = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "getAdvertiserId", "()Ljava/lang/String;");
        } else if (utilObj.isIos()) {
            advertiserId = jsb.reflection.callStaticMethod("Util", "getAdvertiserId");
        }
        return advertiserId;
    };

    this.getAbsFilePath = function (fileName) {
        var path = "";
        if (utilObj.isNative()) {
            var dir = utilObj.getFilesDir();
            path = dir + "/" + fileName;
        }
        return path;
    };

    this.getFilesDirV1 = function () {
        if (filesDirV1 != "") {
            return filesDirV1;
        }
        if (utilObj.isAndroid()) {
            filesDirV1 = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "getFilesDirPath", "()Ljava/lang/String;");
        } else if (utilObj.isIos()) {
            filesDirV1 = jsb.reflection.callStaticMethod("Util", "getFileDirPath");
        }
        return filesDirV1;
    };

    this.getAbsFilePathV1 = function (fileName) {
        var path = "";
        if (utilObj.isNative()) {
            var dir = utilObj.getFilesDirV1();
            path = dir + fileName;
        }
        return path;
    };

    this.getFilesDir = function () {
        if (filesDir != "") {
            return filesDir;
        }
        if (utilObj.isAndroid()) {
            filesDir = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "getFilesDirPath", "()Ljava/lang/String;");
        } else if (utilObj.isIos()) {
            filesDir = jsb.reflection.callStaticMethod("Util", "getImageDirPath");
        }
        return filesDir;
    };


    this.getShowScreenQuestId = function () {
        var str = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "getScreenQuestId", "()Ljava/lang/String;");
        // loggerObj.debugLog("The showScreen quest id is ", str);
        return str;
    };

    var fileExistsMap = {};
    this.fileExists = function (fileName) {
        var exists = false;
        if (fileExistsMap[fileName] == true) {
            return true;
        }
        if (utilObj.getCurrentTimestampMs() - lastFileUpdateTime > 15000) {
            var data = ls.getItem(constantsObj.FILE_LIST_FILE);
            if (data != undefined && data != null && data.length > 0) {
                filesList = JSON.parse(data);
            }
            lastFileUpdateTime = utilObj.getCurrentTimestampMs();
        }
        if (utilObj.isAndroid()) {
            if (filesList != null && filesList.hasOwnProperty(fileName)) {
                exists = filesList[fileName];
            }
            //exists = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "fileExists", "(Ljava/lang/String;)Z", fileName);
        } else if (utilObj.isIos()) {
            exists = jsb.reflection.callStaticMethod("Util", "imageExists:", fileName);
            // loggerObj.debugLog("Double checking:", fileName, exists);
        }
        //loggerObj.debugLog("file exists ", exists);
        fileExistsMap[fileName] = exists;
        return exists;
    };

    this.fileExistsV1 = function (fileAbsPath) {
        var exists = false;
        if (utilObj.isIos()) {
            exists = jsb.reflection.callStaticMethod("Util", "fileExistsV1:", fileAbsPath);
            //loggerObj.debugLog("Double checking:", fileName, exists);
        }
        //loggerObj.debugLog("file exists ", exists);
        return exists;
    };

    var imageExistsMap = {};
    this.imageExists = function (fileName) {
        var exists = false;
        if (imageExistsMap[fileName] == true) {
            return true;
        }
        if (utilObj.isAndroid()) {
            exists = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "fileExists", "(Ljava/lang/String;)Z", fileName);
        } else if (utilObj.isIos()) {
            exists = jsb.reflection.callStaticMethod("Util", "imageExists:", fileName);
            // loggerObj.debugLog("Checking ", fileName, exists);
        }
        imageExistsMap[fileName] = exists;
        return exists;
    };

    this.downloadFile = function (saveAs, url, postProcessing, callback, callbackMsg) {
        return;
       
        if (!utilObj.isOnline()) {
            return;
        }
        if (postProcessing == undefined) {
            postProcessing = "";
        }
        if (callback == undefined) {
            callback = "";
        }
        if (callbackMsg == undefined) {
            callbackMsg = "";
        }
        if (utilObj.isAndroid()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "downloadFile", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V",
                saveAs, url, postProcessing, callback, callbackMsg);
        } else if (utilObj.isIos()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Util", "downloadImage:fileName:", url, saveAs);
        }
    };

    this.downloadFileV1 = function (saveAs, url) {
        return;
        if (utilObj.isAndroid()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "downloadFile", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V",
                saveAs, url, "", "", "");
        } else if (utilObj.isIos()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Util", "downloadImage:fileName:", url, saveAs);
        }
    };

    this.downloadFileV2 = function (url, saveAs) {
        return;
        if (utilObj.isAndroid()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "downloadFile", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V",
                saveAs, url, "", "", "");
        } else if (utilObj.isIos()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Util", "downloadImage:fileName:", url, saveAs);
        }
    };


    this.downloadImages = function (urlFileNameInfo) {
        return;
        if (!utilObj.isOnline()) {
            return;
        }
        // urlFileNameInfo is of the format: url1,fileName1;url2,fileName2;....urlN,fileNameN;
        // loggerObj.debugLog("Triggering download of friend images from ", urlFileNameInfo);
        if (utilObj.isNative()) {
            if (utilObj.isAndroid()) {
                return jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "downloadImages", "(Ljava/lang/String;)V", urlFileNameInfo);
            } else if (utilObj.isIos()) {
                //jsb.reflection.callStaticMethod("Util", "downloadImages:", urlFileNameInfo);
            }
        } else {
            // loggerObj.debugLog("image download on web??");
        }
    };

    var appPauseDay = 0;
    this.appPause = function () {
        // loggerObj.debugLog("App is paused");
        analyticsObj.trackAppPause();
        trackObj.trackCounter(constantsObj.TRACK_SESSION, "minimize", "", constantsObj.SCREEN_NAMES[curScreen], subScreen, "", "", 1, "");
        gameObj.setLastPlayedTimeStamp(utilObj.getCurrentTimestamp());
        timedHintsObj.appPause();
        gameObj.setExistingUser();
        gameObj.save();
        questsObj.save();
        userObj.save();
        questsObj.setCrossGameDataAvailable(0);
        machineLearningDataObj.save();
        xpromoUtilObj.appPause();
        if (!utilObj.getisSpriteandFontLoaded()) {
            //loggerObj.debugLog("coming here for font1");
            utilObj.loadSpritesinit(sprite_topush);
            utilObj.loadFontInit();
            utilObj.setisSpriteandFontLoaded(true);
        }
        appPauseDay = utilObj.getDayOfYear();
        gameObj.setIsGameActive(false);
        if (curLayer) {
            curLayer.pause();
        }
        var subScreen = "";
        if (curScreen == constantsObj.SCREEN_HOME && !ftueObj.isFtueShown()) {
            subScreen = "ftue0";
        } else if (curScreen == constantsObj.SCREEN_GAME && !ftueObj.isFtueShown() && ftueObj.getScreenIndex() == 0) {
            subScreen = "ftue0";
        } else if (curScreen == constantsObj.SCREEN_GAME && !ftueObj.isFtueShown() && ftueObj.getScreenIndex() == 0) {
            subScreen = "ftue1";
        } else if (curScreen == constantsObj.SCREEN_HOME && !ftueObj.isPackFtueShown()) {
            subScreen = "ftuePack";
        } else if (curScreen == constantsObj.SCREEN_CALENDAR && !ftueObj.isCalendarFtueShown()) {
            subScreen = "ftue0";
        } else if (curScreen == constantsObj.SCREEN_ACHIEVEMENTS && !ftueObj.isAchievementFtueShown()) {
            subScreen == "ftue0";
        }
        trackObj.save();
        // trackObj.syncPendingTracking(false,true);
        psUtilObj.appPause();
    };

    this.appResume = function () {
        if (curLayer == null || curLayer == undefined) {
            curLayer = homeLayer;
        }
        // loggerObj.debugLog("App is resumed");
        gameObj.setIsGameActive(true);
        xpromoUtilObj.appResume();
        var appResumeDay = utilObj.getDayOfYear();
        if (appPauseDay != appResumeDay && appPauseDay != 0) {
            //gameObj.setLastLogin(appPauseDay);
            gameObj.updateDailyInfo(true);
            // loggerObj.debugLog("App is resumed1");
        }
        if ((curScreen == constantsObj.SCREEN_HOME || curScreen == constantsObj.SCREEN_CALENDAR) && runtimeObj.getForceUpdate() == 1) {
            utilObj.forceUpdate();  //triggers call to check for force update
        }
        var screenToShow = utilObj.getScreenVal();
        if (screenToShow == constantsObj.OPEN_HOME_SCREEN) {
            gameObj.setMysteryRewardProbabilityAlreadyChecked(true);
        }
        if (screenToShow == "1" || screenToShow == "2" || screenToShow == constantsObj.OPEN_PUZZLE_SCREEN || screenToShow == constantsObj.OPEN_DAILY_MINI || screenToShow == constantsObj.OPEN_HOME_SCREEN) {
            //TO-Do work here
            //gameObj.setScreenToShow(true);
            utilObj.resetScreenVal();
        }

        // if(gameObj.getShowAdWall() == 0 && (curScreen == constantsObj.SCREEN_GAME || curScreen == constantsObj.SCREEN_HOME || curScreen == constantsObj.SCREEN_CALENDAR || curScreen == constantsObj.SCREEN_PACK_LAYER || curScreen == constantsObj.SCREEN_PACK_INFO_LAYER || curScreen == constantsObj.SCREEN_ACHIEVEMENTS)) {
        //     utilObj.delayedCallback(moreGamesLayer, adWallObj.showAdWall, 1.0, null, false);
        // }
        // gameObj.setShowAdWall(0);

        analyticsObj.trackAppResume();

        // loggerObj.debugLog("check for the logs 123",utilObj.checkNotifTriggered());
        // if (utilObj.isAndroid() && utilObj.checkNotifTriggered()) {
        //     gameLayer.show();
        // } else {
            curLayer.resume();
        // }

        if (utilObj.isIos() && !gameObj.getDailyAlarmSet()) {
            //loggerObj.debugLog("check coming here to set notif1dcds",gameObj.getLastPlayedTimeStamp());
            utilObj.setupDailyAlarm();
            gameObj.setDailyAlarmSet(true);
        } else if (utilObj.isAndroid()) {
            utilObj.setupDailyAlarm();
        }

        // checking streak cases on app resume
        homeObj.checkingStreakCases();
        psUtilObj.appResume();

        // timed hints on app resume
        timedHintsObj.appResume();
    };

    this.flutterAppPause = function() {
        pspnFlutterObj.flutterAppPause();
    };

    this.flutterAppResume = function() {
        pspnFlutterObj.flutterAppResume();
    };

    this.isLimitAdTracking = function () {
        var advId = xpromoUtilObj.getAdvertiserId();
        if (advId != null && advId != "") {
            return false;
        }
        return true;
    };

    this.isLimitTrackingWithoutAdjustId = function () {
        if (gameObj.getIsLimitAdTrackingOnWithoutAdjustId() != null) {
            return gameObj.getIsLimitAdTrackingOnWithoutAdjustId();
        }
        if (utilObj.isIos()) {
            isLimitTrackingWithoutAdjustIdVar = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Util", "isLimitTracking");
        } else if (utilObj.isAndroid()) {
            isLimitTrackingWithoutAdjustIdVar = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "isLimitTracking", "()Z");
        }
        gameObj.setIsLimitAdTrackingOnWithoutAdjustId(isLimitTrackingWithoutAdjustIdVar);
        return isLimitTrackingWithoutAdjustIdVar;
    };

    this.checkPushNotifs = function (pushNotifString) {
        var pushNotifString = pushNotifString;
        // loggerObj.debugLog("this is checkpushnotif");
        if (utilObj.isAndroid() && !utilObj.getIsNotifClicked()) {
            utilObj.setPushNotifString("");
            return;
        }
        if (pushNotifString != "") {
            var obj = pushNotifString.split(':');
            // loggerObj.debugLog("these are coins to be added ",obj[1], obj[1].length);
            if (obj[0] == constantsObj.COIN_GRANT_PUSH_NOTIF && !(obj[1] == "" || obj[1] == "0" || obj[1] == 0 || obj[1] == null || obj[1] == "null")) {
                var message = obj[1] + " coins are granted!";
                utilObj.showMessage(message);
                var cashReward = parseInt(obj[1]);
                economyObj.addCash(cashReward, constantsObj.TRACK_EARN, "push", "");
                if (obj[2] != "") {
                    questsObj.redirectToPlaystore(obj[2]);
                    utilObj.openUrl(obj[2]);
                }
                utilObj.setPushNotifString("");
            }
        }
    };

    this.openWhatsappForSubscriber = function (msg, phoneNumber) {
        if (utilObj.isAndroid()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "subscribeOnWhatsApp", "(Ljava/lang/String;Ljava/lang/String;)V", msg, phoneNumber);
        }
    };

    this.getPushNotifType = function () {
        if (utilObj.isIos()) {
            return "";
        } else if (utilObj.isAndroid()) {
            return jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "getPushNotifTypeV1", "()Ljava/lang/String;");
        }
    };

    this.setPushNotifType = function (val) {
        if (utilObj.isIos()) {
            return;
        } else if (utilObj.isAndroid()) {
            return jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "setPushNotifType", "(Ljava/lang/String;)V", val);
        }
    };

    this.getPushNotifString = function () {
        if (utilObj.isIos()) {
            return "";
        } else if (utilObj.isAndroid()) {
            return jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "getNotifString", "()Ljava/lang/String;");
        }
    };

    this.setPushNotifString = function (notifStr) {
        if (utilObj.isIos()) {
            return;
        } else if (utilObj.isAndroid()) {
            return jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "setNotifString", "(Ljava/lang/String;)V", notifStr);
        }
    };

    this.appDestroy = function () {
        gameObj.setLastPlayedTimeStamp(utilObj.getCurrentTimestamp());
        gameObj.setExistingUser();
        // loggerObj.debugLog("App is getting destroyed");
    };

    this.shuffleArray = function (input) {
        if (input.length == 1) {
            return input;
        }
        var isSeededRandomness = utilObj.isSeededRandomnessOn();
        for (var i = input.length - 1; i >= 0; i--) {
            var randomIndex = 0;
            if (!isSeededRandomness) {
                randomIndex = Math.floor(Math.random() * (i + 1));
            } else {
                randomIndex = utilObj.getRandomIntInRange(0, i + 1);
            }
            var itemAtIndex = input[randomIndex];

            input[randomIndex] = input[i];
            input[i] = itemAtIndex;
        }
        return input;
    };

    this.isInt = function (value) {
        if (value == null || value == undefined) {
            return false;
        }
        if (isNaN(value)) {
            return false;
        }
        var x = parseFloat(value);
        return (x | 0) === x;
    };

    this.isFloat = function (value) {
        return Number(value) === value && value % 1 !== 0;
    };

    this.isString = function (value) {
        if (typeof value === "string") {
            return true;
        }
        //loggerObj.traceLog("Check for string failed:", value);
        return false;
    };

    this.isObject = function (value) {
        if (value != null && typeof value === "object") {
            return true;
        }
        return false;
    };

    this.isArray = function (value) {
        if (value != null && value.constructor === Array) {
            return true;
        }
        return false;
    };

    this.arePointsSame = function (point1, point2) {
        if (point1 == null || point2 == null) {
            return false;
        }
        if (point1.x == point2.x && point1.y == point2.y) {
            return true;
        }
        return false;
    };

    var lastActionBreak = 0;
    this.canScheduleMoreActions = function (node) {
        return true;
        if (!utilObj.canScheduleMoreCallbacks()) {
            return false;
        }
        var numRunningActions = node.getNumberOfRunningActions();
        var curTimestamp = utilObj.getCurrentTimestamp();
        if (numRunningActions < constantsObj.RUNNING_ACTIONS_SOFT_LIMIT) {
            if (curTimestamp - lastActionBreak < 2) {
                // Had just gone into low animation mode. Stay there.
                //loggerObj.traceLog("Not scheduling more actions - too soon", numRunningActions);
                return false;
            }
            //loggerObj.traceLog("Scheduling more actions:", numRunningActions);
            return true;
        }

        lastActionBreak = curTimestamp;
        //loggerObj.traceLog("Not scheduling more actions:", numRunningActions);
        return false;
    };

    this.initJsComplete = function () {
        if (utilObj.isAndroid()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "initJSComplete", "()V");
        } else if (utilObj.isIos()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Util", "initJSComplete");
        }
    };

    this.getScreenVal = function () {
        if (utilObj.isIos()) {
            var screenVal = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Util", "getScreenVal");
            //loggerObj.debugLog("The screen val is ", screenVal);
            return screenVal;
        }
        return "0";
    };

    this.resetScreenVal = function () {
        if (utilObj.isIos()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Util", "resetScreenVal");
        }
    };

    /**
     * native call to get refill value
     */
    this.getRefill = function () {
        var result = "0";
        if (utilObj.isIos()) {
            result = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Util", "getRefill");
        }
        return result;
    };

    /**
     * native call to reset refill value
     */
    this.resetRefill = function () {
        if (utilObj.isIos()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Util", "resetRefill");
        }
    };

    this.addPopupPattern = function (node, popupHeight, headerHeight, zOrder, xPos, yPos, is_canvas, is_popup, patternWidth) {
        if (!node) {
            return;
        }

        var width = constantsObj.DESIGN_WIDTH;
        if (is_canvas) {
            width = canvasWidth;
        }
        if (patternWidth) {
            width = patternWidth;
        }
        var effectiveHeight = popupHeight - headerHeight;
        var patYPos = centerYPos;
        var patternSide = 300; // Pattern is 300 x 300
        var xReps = Math.floor(width / patternSide);
        var xOffset = (width - xReps * patternSide) / 2;
        var patXPos = centerXPos - width / 2 + xOffset;
        if (xPos != undefined && xPos != null) {
            patXPos = xPos;
        }
        var yReps = Math.floor(effectiveHeight / patternSide);
        var yOffset = (effectiveHeight - yReps * patternSide) / 2;
        var patYPos = centerYPos - constantsObj.POPUP_START_OFFSET - headerHeight;
        if (patYPos > centerYPos - popupHeight / 2) {
            patYPos += (patYPos - popupHeight / 2 + 50);
        }
        if (is_popup != undefined && !is_popup) {
            patYPos = centerYPos - headerHeight;
        }

        if (yPos != undefined && yPos != null) {
            patYPos = yPos;
        }
        for (var x = patXPos, xCount = 0; xCount < xReps; x += patternSide, xCount++) {
            for (var y = patYPos, yCount = 0; yCount < yReps; y += patternSide, yCount++) {
                var pattern = utilObj.getSprite(constantsObj.popup_pattern, x, y, 0, 1.0, constantsObj.SCALE_ONE * constantsObj.SCALE_THREE_POINT_THREE);
                pattern.setOpacity(30);
                node.addChild(pattern, zOrder - 10);
            }
        }
    };


    this.getSpriteScalingFactor = function () {
        var deviceHeight = utilObj.getDeviceHeight();
        var scaleFactor = 2.25;
        /*if (deviceHeight <= constantsObj.HEIGHT_LOW_RES) {
         scaleFactor = 3.375;
         } else if (deviceHeight <= constantsObj.HEIGHT_MEDIUM_RES) {
         scaleFactor = 2.25;
         } else {
         scaleFactor = 1.5;
         }*/
        return scaleFactor;
    };

    /**
     * new fucntion for the scaling factor for new scaling constants with scaling as 1.5 so that it resounds with the correct scale
     * @return {number} scaling factor
     */
    this.getSpriteScalingFactorNew = function () {
        var scaleFactor = 1.5;
        return scaleFactor;
    };

    this.runFocusAnim = function (spriteArr) {
        var startTime = 0.5;
        for (var i = 0; i < spriteArr.length; i++) {
            var sprite = spriteArr[i].sprite;
            var order = spriteArr[i].animOrder;
            var layer = spriteArr[i].layer;
            if (layer) {
                // utilObj.delayedCallback(layer, animObj.focusAnim, startTime + order * 0.1, sprite);
                animObj.focusAnim(layer, sprite);
            }
        }
    };

    this.exitAnimation = function (sender, spriteArr) {
        if (spriteArr) {
            for (var i = 0; i < spriteArr.length; i++) {
                var params = spriteArr[i];
                var animType = params["animType"];
                var layer = params["layer"];
                params.reverse = true;
                if (params.animate) {
                    animObj.showTransition(layer, params);
                }
            }
        }
    };

    this.addHeader = function (labelArr, screen, layer, baseZOrder, makeDull, screenSubType) { //common function for adding header

        var xPos = centerXPos - 470;
        var yPos = constantsObj.DESIGN_HEIGHT - 70;

        var cashAction = "showStore";
        var secCashAction = "showStore";
        var lifeAction = "showGetLives";
        if (screen == constantsObj.SCREEN_DESP_BUY || lastScreen == constantsObj.SCREEN_DESP_BUY || lastScreen == constantsObj.SCREEN_GAME
            || screen == constantsObj.SCREEN_PU_BUY || screen == constantsObj.SCREEN_PU_PURCHASE
            || lastScreen == constantsObj.SCREEN_PU_BUY || lastScreen == constantsObj.SCREEN_PU_PURCHASE
            || layer == levelIntroLayer || layer == levelOutroLayer || screen == constantsObj.SCREEN_GET_LIVES) {
            cashAction = "noOp";
            secCashAction = "noOp";
            lifeAction = "noOp";
        }
        if (screen == constantsObj.SCREEN_STORE && screenSubType == constantsObj.SCREEN_SUB_CASH) {
            cashAction = "noOp";
        } else if (screen == constantsObj.SCREEN_PU_PURCHASE || (screen == constantsObj.SCREEN_STORE && screenSubType == constantsObj.SCREEN_SUB_SEC_CASH)) {
            secCashAction = "noOp";
        }
        if (screen == constantsObj.SCREEN_STORE && screenSubType == constantsObj.SCREEN_SUB_CASH) {
            secCashAction = "noOp";
            lifeAction = "noOp";
        } else if ((screen == constantsObj.SCREEN_PU_PURCHASE || (screen == constantsObj.SCREEN_STORE && screenSubType == constantsObj.SCREEN_SUB_SEC_CASH))) {
            cashAction = "noOp";
            lifeAction = "noOp";
        } else if (screen == constantsObj.SCREEN_GET_LIVES) {
            cashAction = "noOp";
            secCashAction = "noOp";
        }
        var headerInfo = [
            {
                "img": constantsObj.hud_heart,
                "val": economyObj.getNumLives() + "",
                "tag": constantsObj.LIVES_TAG,
                "bg": constantsObj.hud_bg,
                "action": lifeAction,
                "tColor": constantsObj.COLOR_WHITE,
            }, {
                "img": constantsObj.hud_coin,
                "val": economyObj.getCash() + "",
                "tag": constantsObj.COINS_TAG,
                "bg": constantsObj.hud_bg,
                "action": cashAction,
                "tColor": constantsObj.COLOR_WHITE,
                "params": constantsObj.PKG_CASH,
            }, {
                "img": constantsObj.hud_diamond,
                "val": economyObj.getSecCash() + "",
                "tag": constantsObj.SEC_CASH_TAG,
                "bg": constantsObj.hud_bg,
                "action": secCashAction,
                "tColor": constantsObj.COLOR_WHITE,
                "params": constantsObj.PKG_SEC_CASH,
                "img_tag": constantsObj.DIAMONDS_SCORE_TAG
            }
        ];

        var zOrder = baseZOrder;

        var topBg = utilObj.getScale9Sprite(constantsObj.hud_black_bg, xLeftPos, constantsObj.DESIGN_HEIGHT, 0, 1.0, canvasWidth, 150);
        layer.addChild(topBg, zOrder);

        if (makeDull == true) {
            baseZOrder--;
        }

        var remPlus = false;

        var livesVariant = epmObj.getChosenVariant(constantsObj.EXP_LIVES_CAP);
        for (var i = 0; i < headerInfo.length; i++) {
            zOrder = baseZOrder;
            remPlus = false;
            if (screen == constantsObj.SCREEN_STORE && screenSubType == constantsObj.SCREEN_SUB_CASH && i == 1) {
                zOrder++;
                remPlus = true;
            } else if ((screen == constantsObj.SCREEN_PU_PURCHASE || (screen == constantsObj.SCREEN_STORE && screenSubType == constantsObj.SCREEN_SUB_SEC_CASH)) && i == 2) {
                zOrder++;
                remPlus = true;
            } else if (screen == constantsObj.SCREEN_GET_LIVES && i == 0) {
                zOrder++;
                remPlus = true;
            }
            var valueBg = utilObj.getScale9Sprite(headerInfo[i].bg, xPos + 110, yPos - 5, 0.5, 0.5, 260, 85);
            layer.addChild(valueBg, zOrder);

            var element = utilObj.getSprite(headerInfo[i].img, xPos - 10, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_11);
            layer.addChild(element, zOrder);

            var actionButton = utilObj.getButton(350, 150, 0, 0.5, xPos - 60, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'utilObj',
                fn: headerInfo[i].action,
                screen: screen,
                params: headerInfo[i].params,
            }, false, ccui.Widget.PLIST_TEXTURE);
            layer.addChild(actionButton, zOrder);

            var noLabel = false;
            var fontFile = res.gadugi_50;
            var fontName = constantsObj.FONT_GADUGI_50;
            if (headerInfo[i].tag != constantsObj.LIVES_TAG) {
                xPos += 130;
            } else {
                fontFile = res.gadugi_60;
                fontName = constantsObj.FONT_GADUGI_60;
                xPos += 10;
                if (livesVariant == constantsObj.EXP_VAR_1) {
                    noLabel = true;
                }
            }

            if (!noLabel) {
                var elementValue = utilObj.getBMFontLabel(headerInfo[i].val, fontFile, headerInfo[i].tColor,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 20, yPos, 0.5, 0.5);
                layer.addChild(elementValue, zOrder, headerInfo[i].tag);
            }
            if (headerInfo[i].tag == constantsObj.LIVES_TAG) {
                xPos += 120;
            }

            if (!remPlus) {
                var plusBg = utilObj.getSprite(constantsObj.light_green_round, valueBg.getContentSize().width - 5, valueBg.getContentSize().height / 2, 0.5, 0.5, constantsObj.SCALE_40);
                valueBg.addChild(plusBg, zOrder);

                var plus = utilObj.getSprite(constantsObj.white_plus, valueBg.getContentSize().width - 5, valueBg.getContentSize().height / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_6);
                valueBg.addChild(plus, zOrder);
            }
            xPos += 240;
        }
        zOrder = baseZOrder;
        xPos = centerXPos - 470;
        xPos += 110;
        if (screen == constantsObj.SCREEN_GET_LIVES) {
            zOrder++;
        }
        var nextLifeIn = economyObj.getNextLifeIn();
        var numLives = economyObj.getNumLives();
        if (nextLifeIn == 0 && numLives == 0) {
            nextLifeIn = economyObj.getLifeRefillInterval();
        }
        var formattedTime = utilObj.formatTime(nextLifeIn, stringsObj.full);
        if (livesVariant == constantsObj.EXP_VAR_1) {
            var infinity = utilObj.getSprite(other_resources.infinity_white, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_60);
            layer.addChild(infinity, zOrder);
        } else {
            var lifeTimer = utilObj.getBMFontLabel(formattedTime, res.gadugi_50, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 0.5);
            layer.addChild(lifeTimer, zOrder, constantsObj.TIMER_LIFE_TAG);
        }

    };

    this.showStore = function (storeType) {
        curLayer.close();
        storePopup.show(true, null, null, storeType);
    };

    this.showGetLives = function () {
        curLayer.close();
        getLivesPopup.show(true, constantsObj.TRACK_HEADER);
    };

    this.hasHeader = function () {
        if (curScreen == constantsObj.SCREEN_HOME || curScreen == constantsObj.SCREEN_CALENDAR) {
            return true;
        } else if (curLayer == popupLayer) {
            return true;
        }
        return false;
    };

    this.compressText = function (txt) {
        var compressed = LZString.compressToUTF16(txt);
        return compressed;
    };

    this.decompressText = function (txt) {
        var decompressed = LZString.decompressFromUTF16(txt);
        return decompressed;
    };

    this.sanitizeStringForRest = function (str) {
        var lettersToSanitize = "%!&',;=#@";
        var lettersToSanitizeEscaped = "$()*+:=/?[]";
        var toSanitize = lettersToSanitize;
        for (var i = 0; i < toSanitize.length; i++) {
            var replacement = encodeURIComponent(toSanitize[i]);
            // loggerObj.debugLog("Attempting sanitization:", replacement);
            str = str.replace(new RegExp(toSanitize[i], 'g'), replacement);
        }
        toSanitize = lettersToSanitizeEscaped;
        for (var i = 0; i < toSanitize.length; i++) {
            var replacement = encodeURIComponent(toSanitize[i]);
            // loggerObj.debugLog("Attempting sanitization:", replacement);
            str = str.replace(new RegExp("\\" + toSanitize[i], 'g'), replacement);
        }
        return str;
    };


    this.showFbConnectUi = function (layer, layerStr, saveLabel, puzzleToShow, screenName, spriteArr, labelArr, focusArr, xPos, yPos, overallBgWidth, zOrder, screen) {
        var boxFb = utilObj.getScale9Sprite(constantsObj.popup_bg7, xPos, yPos - 170, 0.5, 0.5, overallBgWidth, 360,
            spriteArr, layer, constantsObj.BG_Z_ORDER + 1, constantsObj.SPRITE_LOCAL);

        var localXPos = overallBgWidth / 2;
        var localYPos = 300;
        utilObj.getBMFontLabel(saveLabel, constantsObj.FONT_STREET_60, constantsObj.COLOR_BROWN,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos, localYPos, 0.5, 0.5,
            labelArr, boxFb, zOrder);

        localYPos -= 130;
        var loginButton = utilObj.getButton(constantsObj.BUTTON_WIDTH_SMALL_1, constantsObj.BUTTON_HEIGHT_TINY_2, 0.5, 0.5, localXPos,
            localYPos - constantsObj.BUTTON_SMALL_Y_OFFSET, constantsObj.blue_150, constantsObj.blue_150_glow, constantsObj.blue_150, {
                obj: layerStr,
                fn: 'showLogin',
                screen: screen,
                track: {
                    k: screenName,
                    p: constantsObj.TRACK_FB_LOGIN,
                    c: puzzleToShow,
                    o: "",
                    f: "",
                    g: "",
                    s: "",
                    co: 1,
                    oppId: ""
                },
            });
        boxFb.addChild(loginButton, zOrder);

        utilObj.getSprite(constantsObj.fb_icon, 70, constantsObj.BUTTON_HEIGHT_TINY_2 / 2 + constantsObj.BUTTON_LARGE_Y_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_1,
            spriteArr, loginButton, zOrder, constantsObj.SPRITE_MISC);

        utilObj.getBMFontLabel(stringsObj.connect, constantsObj.FONT_STREET_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), constantsObj.BUTTON_WIDTH_SMALL_1 / 2 + 30,
            constantsObj.BUTTON_HEIGHT_TINY_2 / 2 + constantsObj.BUTTON_LARGE_Y_OFFSET, 0.5, 0.5, labelArr, loginButton, zOrder);

        var offerYPos = constantsObj.BUTTON_HEIGHT_TINY_2 / 2 - 20;
        var offerXPos = constantsObj.BUTTON_WIDTH_SMALL_1;
        utilObj.getSprite(constantsObj.offer_tag, offerXPos, offerYPos, 0.5, 0.5, constantsObj.SCALE_TWO_THIRD,
            spriteArr, loginButton, zOrder, constantsObj.SPRITE_LOCAL);

        utilObj.getBMFontLabel(runtimeObj.getFbConnectCash() + "", res.gadugi_50_stroke, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), offerXPos + 18, offerYPos - 20, 0.5, 0.5, labelArr, loginButton, zOrder + 1);

        utilObj.getBMFontLabel(stringsObj.free_caps, constantsObj.FONT_GADUGI_30_STROKE, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), offerXPos + 4, offerYPos - 60, 0.5, 0.5, labelArr, loginButton, zOrder + 1);

        var vineBottomYPos = yPos - 380;
        utilObj.getSprite(constantsObj.vine_down, xPos + overallBgWidth / 2 - 60, vineBottomYPos, 0.5, 0, constantsObj.SCALE_TWO_THIRD,
            spriteArr, layer, zOrder, constantsObj.SPRITE_LOCAL);
    };

    this.openUrl = function (link) {
        if (!utilObj.isOnline()) {
            utilObj.showMessage(stringsObj.not_online);
            return;
        }
        if (utilObj.isNative()) {
            if (utilObj.isAndroid()) {
                jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "openUrl", "(Ljava/lang/String;)V", link);
            } else if (utilObj.isIos()) {
                jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Util", "openUrl:", link);
            }
        } else {
            window.open(link, "_blank");
        }
    };

    this.showFriendsLeaderboard = function (layer, layerStr, topFriends, puzzleToShow, screenName, spriteArr, labelArr, focusArr, xPos, yPos, overallBgWidth, zOrder, screen) {
        var scoresList = leaderBoardObj.getFriendLeaderBoardForLevel(puzzleToShow);
        // loggerObj.debugLog("scores list fetched ", scoresList);
        var friends = [];

        var invitableFriends = friendsObj.getNextInvitableBatch(false, fbRequestObj.getReqSendLimit(), constantsObj.INVITE);
        var icon = constantsObj.light_green_tick;
        var iconScale = constantsObj.SCALE_SPRITE_4;
        var text = stringsObj.sent;
        var playing_ids = "";
        var invitable_ids = "";
        // var scoresList = [{"Score":28300,"Member":"6ax2h"}, {"Score":26300,"Member":"7vk"}];
        var lbTitle = topFriends;
        if (scoresList && scoresList.length > 0) {
            lbTitle = stringsObj.top_scorers;
            var nextPlayingFriends = friendsObj.getNextPlayingBatch(false, fbRequestObj.getReqSendLimit(), constantsObj.SEND_LIVES);
            var missingDataFor = {};
            for (var i = 0; i < scoresList.length; i++) {
                var refId = scoresList[i]["Member"];
                if (refId != userObj.getRefId()) {
                    // loggerObj.debugLog(refId, userObj.getRefId());
                    friends[i] = friendsObj.getPsFriendForRefId(refId);
                    if (friends[i] != null) {
                        var playingFriend = friendsObj.getPlayingFriendForName(friends[i].Name);
                        friends[i].name = friends[i].Name;
                        if (playingFriend != null) {
                            friends[i].id = playingFriend.id;
                            friends[i].refId = friends[i].RefId;
                            friends[i].picUrl = playingFriend.picture.data.url;
                        } else {
                            missingDataFor[refId] = 1;
                        }
                    } else {
                        missingDataFor[refId] = 1;
                    }
                } else {
                    var playingFriend = userObj.getUserObj();
                    friends[i] = playingFriend;
                    friends[i].id = playingFriend.fbid;
                    friends[i].picUrl = friendsObj.getFbPicUrl(playingFriend.fbid);
                }
                if (friends[i] == null) {
                    continue;
                }

                friends[i].score = scoresList[i]["Score"];
                if (nextPlayingFriends.indexOf(playingFriend) > -1) {
                    friends[i].icon = constantsObj.fb_life;
                    friends[i].iconScale = 0.25;
                    icon = constantsObj.fb_life;
                    iconScale = 0.6;
                    text = stringsObj.send_all;
                    playing_ids += friends[i].id + ",";
                } else {
                    friends[i].icon = constantsObj.light_green_tick;
                    friends[i].iconScale = constantsObj.SCALE_SPRITE_7;
                }
            }
        }

        for (var i = 0; i < invitableFriends.length; i++) {
            invitable_ids += invitableFriends[i].id + ",";
        }

        if (friends.length == 0 && invitableFriends.length == 0) {
            return;
        }

        //yPos -= 20;
        var boxFb = utilObj.getScale9Sprite(constantsObj.popup_bg7, xPos, yPos - 215, 0.5, 0.5, overallBgWidth, 450);
        spriteArr.push({
            "sprite": boxFb,
            "layer": layer,
            "z-order": constantsObj.BG_Z_ORDER + 1,
            "type": constantsObj.SPRITE_MISC,
            "animate": true,
            "animType": constantsObj.TYPE_RIGHT_APPEAR,
            "animOrder": 1,
            "pos": cc.p(xPos, yPos - 160)
        });

        var headText = utilObj.getBMFontLabel(lbTitle, res.streetscript_redux_60, constantsObj.COLOR_BROWN,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 300, yPos - 50, 0.5, 0.5);
        labelArr.push({
            "label": headText,
            "layer": layer,
            "z-order": zOrder,
            "font": constantsObj.FONT_STREET_50
        });

        var inviteAll = utilObj.getButton(constantsObj.BUTTON_WIDTH_TINY_3, constantsObj.BUTTON_HEIGHT_TINY_1, 0.5, 0.5,
            xPos + 170, yPos - 70, constantsObj.blue_150, constantsObj.blue_150_glow, constantsObj.blue_150, {
                obj: layerStr,
                fn: 'sendRequests',
                screen: screen,
                params: {
                    reqType: constantsObj.INVITE,
                    fbIds: invitable_ids,
                },
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzLevelTracking(),
                    c: gameObj.getCurPuzTypeTracking(),
                    o: screenName,
                    f: constantsObj.TRACK_INVITE_ALL,
                    g: "",
                    s: "",
                    co: 1,
                    oppId: ""
                },
            }, false);
        layer.addChild(inviteAll, zOrder);


        var offerTag = utilObj.getSprite(constantsObj.offer_tag_leaderboard, xPos + 470 - constantsObj.BUTTON_WIDTH_SMALLER / 2, yPos - 50, 0, 0.5, constantsObj.SCALE_TWO_THIRD);
        layer.addChild(offerTag, zOrder);

        var offerXPos = 80;
        var offerYPos = 140;

        var connectAndGet = utilObj.getBMFontLabel(constantsObj.CASH_PER_REFERRAL + "", res.gadugi_70_stroke, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), offerXPos + 18, offerYPos - 20, 0.5, 0.5, labelArr, offerTag, zOrder + 1);

        utilObj.getBMFontLabel(stringsObj.free_caps, constantsObj.FONT_GADUGI_40_STROKE, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), offerXPos + 4, offerYPos - 70, 0.5, 0.5, labelArr, offerTag, zOrder + 1);

        var fbIcon = utilObj.getSprite(constantsObj.fb_icon, xPos + 200 - constantsObj.BUTTON_WIDTH_TINY_3 / 2, yPos - 60, 0, 0.5, constantsObj.SCALE_SPRITE_18);
        layer.addChild(fbIcon, zOrder);

        var loginLabel = utilObj.getBMFontLabel(stringsObj.invite, res.gadugi_50_stroke, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 200, yPos - 60, 0.5, 0.5);
        labelArr.push({
            "label": loginLabel,
            "layer": layer,
            "z-order": zOrder,
            "font": constantsObj.FONT_STREET_80
        });

        var listViewWidth = overallBgWidth - 100;
        var listViewHeight = 300;
        var listView = new ccui.ListView();
        listView.setDirection(ccui.ScrollView.DIR_HORIZONTAL);
        listView.setTouchEnabled(true);
        listView.setContentSize(cc.size(listViewWidth, listViewHeight));
        listView.setPosition(xPos, yPos - 270);
        listView.setItemsMargin(0);
        listView.setBounceEnabled(true);
        listView.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
        listView.setAnchorPoint(0.5, 0.5);
        listView.setBackGroundImage(constantsObj.fb_bg, ccui.Widget.PLIST_TEXTURE);
        listView.setBackGroundImageScale9Enabled(true);

        var lifeButton = epmObj.getChosenVariant(constantsObj.EXP_LIFE_BUTTON);
        var itemWidth = 250;

        var fbSliderSt = utilObj.getSprite(constantsObj.fb_slider_bg, xPos - constantsObj.DESIGN_WIDTH / 2 + 55, yPos - 260, 0.5, 0.5, 1);
        fbSliderSt.setScaleY(1.5);
        layer.addChild(fbSliderSt, zOrder - 1);

        var fbSliderEnd = utilObj.getSprite(constantsObj.fb_slider_bg, xPos + constantsObj.DESIGN_WIDTH / 2 - 55, yPos - 260, 0.5, 0.5, 1);
        fbSliderEnd.setScaleY(1.5);
        layer.addChild(fbSliderEnd, zOrder - 1);

        var fbSliderShadowSt = utilObj.getSprite(constantsObj.fb_slider_shadow, xPos - constantsObj.DESIGN_WIDTH / 2 + 70, yPos - 262, 0.5, 0.5, 1);
        fbSliderShadowSt.setScaleY(1.42);
        layer.addChild(fbSliderShadowSt, zOrder + 2);

        var fbSliderShadowEnd = utilObj.getSprite(constantsObj.fb_slider_shadow, xPos + constantsObj.DESIGN_WIDTH / 2 - 70, yPos - 262, 0.5, 0.5, 1);
        fbSliderShadowEnd.setScaleY(1.42);
        fbSliderShadowEnd.setFlippedX(true);
        layer.addChild(fbSliderShadowEnd, zOrder + 2);

        //send to all at start
        if (lifeButton == constantsObj.EXP_VAR_CONTROL) {
            if (friends.length > 0) {
                var itemWidget = sendAll(itemWidth, listViewHeight, screen, screenName, layerStr, labelArr, playing_ids, icon, text, iconScale);
                listView.addChild(itemWidget);
            }
        }

        //game friends
        for (var i = 0; i < friends.length; i++) {
            if (friends[i] == null) {
                continue;
            }
            // loggerObj.debugLog("Friends info:", friends[i]);
            var itemWidget = new ccui.Widget();
            itemWidget.setContentSize(cc.size(itemWidth, listViewHeight));
            var localXPos = itemWidth / 2 + 20;
            var localYPos = listViewHeight / 2 + 5;
            itemWidget.setAnchorPoint(0.5, 0.5);

            var pic = "";
            var picUrl = "";
            if (!utilObj.isWeb()) {
                pic = friends[i].id + ".jpg";
                picUrl = friendsObj.getPlayingFriendPic(friends[i].id);
                if (friends[i].refId == userObj.getRefId()) {
                    pic = userObj.getName() + "_profile.jpg";
                    picUrl = utilObj.getFilesDir() + "/" + pic;
                }
            } else {
                pic = friends[i].picUrl;
                picUrl = pic;
            }

            var imageFrame = utilObj.getSprite(constantsObj.fb_frame, localXPos, localYPos, 0.5, 0.5, 0.7);
            itemWidget.addChild(imageFrame);

            var profilePic = utilObj.loadImage(pic, picUrl, 15, 145, 0, 0, 1.1);
            imageFrame.addChild(profilePic, -1);
            var firstNameText = mfsLayer.getFirstName(friends[i].name);
            firstNameText = utilObj.formatName(firstNameText);
            var nameFont = constantsObj.FONT_GADUGI_40_STROKE;
            if (firstNameText.length < 7) {
                nameFont = constantsObj.FONT_GADUGI_30_STROKE;
            }
            utilObj.getBMFontLabel(firstNameText, nameFont, constantsObj.COLOR_LIGHT_YELLOW,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos, localYPos - 60, 0.5, 0.5, labelArr, itemWidget, 0);
            utilObj.getBMFontLabel(friends[i].score, constantsObj.FONT_GADUGI_35_STROKE, constantsObj.COLOR_LIGHT_YELLOW,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos, localYPos - 95, 0.5, 0.5, labelArr, itemWidget, 0);

            if (friends[i].refId != userObj.getRefId()) {
                utilObj.getBMFontLabel(i + 1, constantsObj.FONT_GADUGI_60_STROKE, constantsObj.COLOR_LIGHT_YELLOW,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), itemWidth - 30, localYPos + 70, 0.5, 0.5, labelArr, itemWidget, 0);
                if (friends[i].icon == constantsObj.fb_life) {
                    var invite = utilObj.getButton(itemWidth, listViewHeight, 0.5, 0.5,
                        localXPos, localYPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                            obj: layerStr,
                            fn: 'sendRequests',
                            screen: screen,
                            params: {
                                fbIds: friends[i].id,
                                reqType: constantsObj.SEND_LIVES,
                            }, track: {
                                k: constantsObj.TRACK_DIALOG,
                                p: gameObj.getCurPuzLevelTracking(),
                                c: gameObj.getCurPuzTypeTracking(),
                                o: screenName,
                                f: constantsObj.TRACK_LIFE_ONE,
                                g: "",
                                s: "",
                                co: 1,
                                oppId: ""
                            },
                        }, false, constantsObj.trans_texture);
                    itemWidget.addChild(invite);
                }
                if (friends[i].icon != undefined) {
                    var iconSprite = utilObj.getSprite(friends[i].icon, itemWidth - 27, localYPos + 10, 0.5, 0.5, friends[i].iconScale);
                    itemWidget.addChild(iconSprite);
                }
            } else {
                utilObj.getBMFontLabel(i + 1, constantsObj.FONT_GADUGI_50_STROKE, constantsObj.COLOR_LIGHT_YELLOW,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), itemWidth - 30, localYPos + 80, 0.5, 0.5, labelArr, itemWidget, 0);
            }
            listView.addChild(itemWidget);

            //send to all after first element
            if (lifeButton == constantsObj.EXP_VAR_2 && i == 0) {
                if (friends.length > 0) {
                    var itemWidget = sendAll(itemWidth, listViewHeight, screen, screenName, layerStr, labelArr, playing_ids, icon, text, iconScale);
                    listView.addChild(itemWidget);
                }
            }
        }

        //send to all at end
        if (lifeButton == constantsObj.EXP_VAR_1) {
            if (friends.length > 0) {
                var itemWidget = sendAll(itemWidth, listViewHeight, screen, screenName, layerStr, labelArr, playing_ids, icon, text, iconScale);
                listView.addChild(itemWidget);
            }
        }

        //invitable Friends
        if (friends.length < 2) {
            icon = constantsObj.fb_message;
            for (var i = 0; i < invitableFriends.length; i++) {
                var itemWidget = new ccui.Widget();
                itemWidget.setContentSize(cc.size(itemWidth, listViewHeight));
                var localXPos = itemWidth / 2;
                var localYPos = listViewHeight / 2 + 5;
                itemWidget.setAnchorPoint(0.5, 0.5);

                var pic = "";
                var picUrl = "";
                if (!utilObj.isWeb()) {
                    pic = invitableFriends[i].name + ".jpg";
                    picUrl = friendsObj.getNonPlayingFriendPic(invitableFriends[i]);
                } else {
                    pic = invitableFriends[i].picture.data.url;
                    picUrl = pic;
                }

                var imageFrame = utilObj.getSprite(constantsObj.fb_frame, localXPos + 5, localYPos, 0.5, 0.5, 0.7);
                itemWidget.addChild(imageFrame);

                var profilePic = utilObj.loadImage(pic, picUrl, 15, 145, 0, 0, 1.1);
                imageFrame.addChild(profilePic, -1);
                var firstNameText = mfsLayer.getFirstName(invitableFriends[i].name);
                firstNameText = utilObj.formatName(firstNameText);
                var nameFont = res.gadugi_40_stroke;
                if (firstNameText.length > 7) {
                    nameFont = res.gadugi_30_stroke;
                }
                var firstName = utilObj.getBMFontLabel(firstNameText, nameFont, constantsObj.COLOR_LIGHT_YELLOW,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos, localYPos - 80, 0.5, 0.5);
                labelArr.push({
                    "label": firstName,
                    "layer": itemWidget,
                    "z-order": 0,
                    "font": constantsObj.FONT_GADUGI_35
                });

                //utilObj.getBMFontLabel(stringsObj.invite, constantsObj.FONT_GADUGI_35_STROKE, constantsObj.COLOR_LIGHT_YELLOW,
                //constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos, localYPos - 105, 0.5, 0.5, labelArr, itemWidget, 0);


                var invite = utilObj.getButton(itemWidth, listViewHeight, 0.5, 0.5,
                    localXPos, localYPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                        obj: layerStr,
                        fn: 'sendRequests',
                        screen: screen,
                        params: {
                            fbIds: invitable_ids,
                            reqType: constantsObj.INVITE,
                        },
                        track: {
                            k: constantsObj.TRACK_DIALOG,
                            p: gameObj.getCurPuzLevelTracking(),
                            c: gameObj.getCurPuzTypeTracking(),
                            o: screenName,
                            f: constantsObj.TRACK_INVITE_ONE,
                            g: "",
                            s: "",
                            co: 1,
                            oppId: ""
                        },
                    }, false, ccui.Widget.PLIST_TEXTURE);
                itemWidget.addChild(invite);

                var iconSprite = utilObj.getSprite(icon, itemWidth - 42, localYPos + 40, 0.5, 0.5, 0.55);
                itemWidget.addChild(iconSprite);

                listView.addChild(itemWidget);
            }
        }

        var itemWidget = new ccui.Widget();
        itemWidget.setContentSize(cc.size(20, listViewHeight));
        listView.addChild(itemWidget);

        layer.addChild(listView, zOrder + 1);
    };

    this.shareOnWhatsapp = function () {
        if (!utilObj.isOnline()) {
            utilObj.showMessage(stringsObj.not_online);
            return;
        }
        var shareText = utilObj.getShareMsg("wa");
        if (utilObj.isNative()) {
            if (utilObj.isAndroid()) {
                jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "shareOnWhatsapp", "(Ljava/lang/String;)Z", shareText);
            } else if (utilObj.isIos()) {
                jsb.reflection.callStaticMethod("Util", "shareOnWhatsapp:", shareText);
            }
        } else {
            utilObj.showMessage(stringsObj.error_on_mobile);
        }
    };

    this.shareOnFb = function () {
        var link = utilObj.getGameShareLinkMsg("fb");
        fbWrapperObj.shareLink("https://playsimple.in/dtc");
    };

    this.getGameShareLinkMsg = function (group) {
        // var msg1 = constantsObj.GAME_SHARE_LINK;
        var msg1 = constantsObj.APP_STORE_URL;
        msg1 = msg1.replace("%GROUP%", group);
        var label = constantsObj.GAME_ID + ":" + userObj.getRefId();
        msg1 = msg1.replace("%LABEL%", label);
        return msg1;
    };

    this.getShareMsg = function (group) {
        var msg = stringsObj.invite_text_dtc2;

        var msg1 = msg + " " + utilObj.getSharableLink();
        var creative = "";

        msg1 = msg1.replace("%GROUP%", group);
        var label = constantsObj.GAME_ID + ":" + userObj.getRefId();
        if (utilObj.isStaging()) {
            label += ":" + 1;
        }
        msg1 = msg1.replace("%LABEL%", label);
        msg1 = msg1.replace("%CREATIVE%", creative);
        return msg1;
    };

    this.shareOnMessenger = function () {
        if (!utilObj.isOnline()) {
            utilObj.showMessage(stringsObj.not_online);
            return;
        }
        var success = false;
        var shareText = utilObj.getShareMsg("me");
        if (utilObj.isNative()) {
            if (utilObj.isAndroid()) {
                success = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "shareOnMessenger", "(Ljava/lang/String;)Z", shareText);
            } else if (utilObj.isIos()) {
                shareText = utilObj.getGameShareLinkMsg("me");
                success = jsb.reflection.callStaticMethod("Util", "shareOnMessenger:appId:", shareText, constantsObj.FB_APP_ID);
            }
        } else {
            utilObj.showMessage(stringsObj.error_on_mobile);
        }
        // loggerObj.debugLog("success is ", success);
        return success;
    };

    this.shareOnTwtr = function () {
        if (!utilObj.isOnline()) {
            utilObj.showMessage(stringsObj.not_online);
            return;
        }
        var success = false;
        var shareText = utilObj.getShareMsg("t");
        if (utilObj.isNative()) {
            if (utilObj.isAndroid()) {
                success = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "shareTwtr", "(Ljava/lang/String;)Z", shareText);
            } else if (utilObj.isIos()) {
                success = jsb.reflection.callStaticMethod("Util", "shareTwtr:", shareText);
            }
        } else {
            utilObj.showMessage(stringsObj.error_on_mobile);
        }
        // loggerObj.debugLog("success is ", success);
        return success;
    };

    this.shareOnSms = function () {
        var shareMsg = utilObj.getShareMsg("s");
        var success = true;
        if (utilObj.isNative()) {
            if (utilObj.isAndroid()) {
                // if (!utilObj.fileExists(constantsObj.SHARE_PHOTO)) {
                //     return;
                // }
                success = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "shareOnSms", "(Ljava/lang/String;)Z", shareMsg);
            } else if (utilObj.isIos()) {
                jsb.reflection.callStaticMethod("Util", "shareOnSms:", shareMsg);
            }
            return success;
        } else {
            utilObj.showMessage(stringsObj.error_on_mobile);
            return false;
        }
    };

    this.isAmazonDevice = function () {
        if (utilObj.getTrackingClient() == constantsObj.CLIENT_AMAZON) {
            return true;
        } else {
            return false;
        }
    };

    this.isPlayStore = function () {
        return utilObj.getTrackingClient() == constantsObj.CLIENT_ANDROID;
    };

    this.shareAnywhere = function () {
        var shareMsg = utilObj.getShareMsg("s");
        var success = true;
        if (utilObj.isNative()) {
            if (utilObj.isAndroid()) {
                success = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "shareAnywhere", "(Ljava/lang/String;)Z", shareMsg);
            } else if (utilObj.isIos()) {
                jsb.reflection.callStaticMethod("Util", "shareAnywhere:", userObj.getRefId());
            }
            return success;
        } else {
            utilObj.showMessage(stringsObj.error_on_mobile);
            return false;
        }
    };

    this.sharePhotoAndUrlAnywhere = function (text, photourl, k, p, c) {
        var shareText = utilObj.getShareMsg("ot");
        if (utilObj.isNative()) {
            if (utilObj.isAndroid()) {
                jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "sharePhotoAndUrlAnywhere", "(Ljava/lang/String;)V", shareText);
            } else if (utilObj.isIos()) {
                if (utilObj.isOnline()) {
                    jsb.reflection.callStaticMethod("Util", "shareLocalPhotoAndUrlAnywhere:url:k:p:c:", shareText, "");
                } else {
                    utilObj.showMessage(stringsObj.not_online);
                }
            }
        } else {
            utilObj.showMessage(stringsObj.error_on_mobile);
        }
    };

    this.sendRequestsFromFriendLeaderBoard = function (params, screen) {
        var type = params.reqType;
        var fbIds = params.fbIds;
        var fbIdArr = fbIds.split(",");
        switch (type) {
            case constantsObj.INVITE:
                friendsObj.setBatchTypeInvitableFriends();
                friendsObj.populateSendingIds(fbIdArr);
                fbRequestObj.inviteFriends(stringsObj.invite_friends, fbIds, "invite", screen, "");
                break;
            case constantsObj.SEND_LIVES:
                friendsObj.setBatchTypePlayingFriends();
                friendsObj.populateSendingIds(fbIdArr);
                fbRequestObj.sendLives(fbIds, stringsObj.req_send_lives_desc, "gift_lives", screen, "");
                break;
        }
        // curLayer.hide();
    };

    function sendAll(itemWidth, itemHeight, screen, screenName, layerStr, labelArr, playing_ids, icon, text, iconScale) {
        var itemWidget = new ccui.Widget();
        itemWidget.setContentSize(cc.size(itemWidth, itemHeight));
        var localXPos = itemWidth / 2 + 20;
        var localYPos = itemHeight / 2 + 5;
        itemWidget.setAnchorPoint(0.5, 0.5);

        var imageFrame = utilObj.getSprite(constantsObj.fb_frame_sendall, localXPos, localYPos, 0.5, 0.5, 0.7);
        itemWidget.addChild(imageFrame);

        var yPos = 210;
        if (icon == constantsObj.fb_life) {
            var invite = utilObj.getButton(constantsObj.BUTTON_WIDTH_TINY, constantsObj.BUTTON_HEIGHT_TINY_4, 0.5, 0.5,
                localXPos, localYPos - 90, constantsObj.orange_150, constantsObj.orange_150_glow, constantsObj.orange_150, {
                    obj: layerStr,
                    fn: 'sendRequests',
                    screen: screen,
                    params: {
                        fbIds: playing_ids,
                        reqType: constantsObj.SEND_LIVES,
                    }, track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzLevelTracking(),
                        c: gameObj.getCurPuzTypeTracking(),
                        o: screenName,
                        f: constantsObj.TRACK_LIFE_ALL,
                        g: "",
                        s: "",
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE);
            itemWidget.addChild(invite);
            var lifeText = utilObj.getBMFontLabel("Life", res.gadugi_40, constantsObj.COLOR_BROWN,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos, localYPos - 15, 0.5, 0.5);
            labelArr.push({
                "label": lifeText,
                "layer": itemWidget,
                "z-order": 0,
                "font": constantsObj.FONT_GADUGI_50
            });

        } else if (icon == constantsObj.light_green_tick) {
            text = stringsObj.invite;
            var invite = utilObj.getButton(constantsObj.BUTTON_WIDTH_TINY, constantsObj.BUTTON_HEIGHT_TINY_4, 0.5, 0.5,
                localXPos, localYPos - 90, constantsObj.orange_150, constantsObj.orange_150_glow, constantsObj.orange_150, {
                    obj: layerStr,
                    fn: 'sendRequests',
                    screen: screen,
                    params: {
                        fbIds: playing_ids,
                        reqType: constantsObj.INVITE
                    }, track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzLevelTracking(),
                        c: gameObj.getCurPuzTypeTracking(),
                        o: screenName,
                        f: constantsObj.TRACK_LIFE_ALL,
                        g: "",
                        s: "",
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE);
            itemWidget.addChild(invite);

            icon = constantsObj.fb_message;
            iconScale = 1;
            yPos -= 10;
        }
        var iconSprite = utilObj.getSprite(icon, localXPos, yPos, 0.5, 0.5, iconScale);
        itemWidget.addChild(iconSprite);

        var text = utilObj.getBMFontLabel(text, res.gadugi_35_stroke, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos, localYPos - 80, 0.5, 0.5);
        labelArr.push({
            "label": text,
            "layer": itemWidget,
            "z-order": 0,
            "font": constantsObj.FONT_GADUGI_50
        });

        return itemWidget;
    }

    this.getRandomPath = function (start, end) {
        var pointsArr = [];
        var minDistance = 150;
        var stepSize = 250;
        var xOffset = 200, yOffset = 200;
        var maxBacks = 1;
        var distanceDecayFactor = 75;
        var fwdX = 7, fwdY = 7, minfwds = 7;
        if (utilObj.getEucledianDistance(start, end) < minDistance) {
            maxBacks = 3;
            minfwds = 5;
        }
        var maxPoints = 100;
        var stepX = Math.abs(start.x - end.x) / maxPoints;
        var stepY = Math.abs(start.y - end.y) / maxPoints;
        var backs = 0;
        var lastPos = start;
        var stop = 0;
        pointsArr.push(start);
        var numPts = 0;
        var it;
        var tilePositions = gameObj.getTilePos();
        var posMinX = tilePositions[0][0].x;
        var posMaxX = tilePositions[8][0].x;
        var posMinY = tilePositions[8][8].y;
        var posMaxY = tilePositions[0][0].y;

        var stopLimit = 1;//5 * Math.random();
        while (stop < stopLimit && numPts < maxPoints) {
            var newX = lastPos.x + Math.random() * stepSize - stepSize / 3;
            if (Math.abs(newX - lastPos.x) < minDistance) {
                if (newX < lastPos.x) {
                    newX -= minDistance;
                } else {
                    newX += minDistance;
                }
                minDistance = minDistance - distanceDecayFactor;
                distanceDecayFactor = distanceDecayFactor / 2;
            } else {
                minDistance = minDistance + distanceDecayFactor;
                distanceDecayFactor = distanceDecayFactor * 1.2;
            }
            if ((newX <= lastPos.x && lastPos.x < end.x) || (newX >= lastPos.x && lastPos.x > end.x)) {
                backs++;
                if (backs > maxBacks || fwdX < minfwds) {
                    it = 0;
                    while ((newX <= lastPos.x && lastPos.x < end.x) || (newX >= lastPos.x && lastPos.x > end.x)) {
                        newX = lastPos.x + Math.random() * stepSize - stepSize / 3;
                        it += 1;
                        if (it > 100) {
                            newX = lastPos.x;
                            if (lastPos.x > end.x) {
                                newX -= minDistance;
                            } else {
                                newX += minDistance;
                            }
                            minDistance = minDistance - distanceDecayFactor;
                            distanceDecayFactor = distanceDecayFactor / 2;
                            break;
                        }
                    }
                    backs = 0;
                    fwdX++;
                    if (Math.abs(newX - lastPos.x) < minDistance) {
                        if (newX < lastPos.x) {
                            newX -= minDistance;
                        } else {
                            newX += minDistance;
                        }
                        minDistance = minDistance - distanceDecayFactor;
                        distanceDecayFactor = distanceDecayFactor / 2;
                    } else {
                        minDistance = minDistance + distanceDecayFactor;
                        distanceDecayFactor = distanceDecayFactor * 1.2;
                    }
                }
            } else {
                fwdX = 0;
            }
            if (newX < posMinX) {
                newX = posMinX;
            }
            if (newX > posMaxX) {
                newX = posMaxX;
            }
            var newY = lastPos.y + Math.random() * stepSize - stepSize / 3;
            if (Math.abs(newY - lastPos.y) < minDistance) {
                if (newY < lastPos.y) {
                    newY -= minDistance;
                } else {
                    newY += minDistance;
                }
                minDistance = minDistance - distanceDecayFactor;
                distanceDecayFactor = distanceDecayFactor / 2;
            } else {
                minDistance = minDistance + distanceDecayFactor;
                distanceDecayFactor = distanceDecayFactor * 1.2;
            }
            if ((newY <= lastPos.y && lastPos.y < end.y) || (newY >= lastPos.y && lastPos.y > end.y)) {
                backs++;
                if (backs > maxBacks || fwdY < minfwds) {
                    it = 0;
                    while ((newY <= lastPos.y && lastPos.y < end.y) || (newY >= lastPos.y && lastPos.y > end.y)) {
                        newY = lastPos.y + Math.random() * stepSize - stepSize / 3;
                        it += 1;
                        if (it > 100) {
                            newY = lastPos.y;
                            if (lastPos.y > end.y) {
                                newY -= minDistance;
                            } else {
                                newY += minDistance;
                            }
                            minDistance = minDistance - distanceDecayFactor;
                            distanceDecayFactor = distanceDecayFactor / 2;
                            break;
                        }
                    }
                    backs = 0;
                    fwdY++;
                    if (Math.abs(newY - lastPos.y) < minDistance) {
                        if (newY < lastPos.y) {
                            newY -= minDistance;
                        } else {
                            newY += minDistance;
                        }
                        minDistance = minDistance - distanceDecayFactor;
                        distanceDecayFactor = distanceDecayFactor / 2;
                    } else {
                        minDistance = minDistance + distanceDecayFactor;
                        distanceDecayFactor = distanceDecayFactor * 1.2;
                    }
                }
            } else {
                fwdY = 0;
            }
            if (newY < posMinY) {
                newY = posMinY;
            }
            if (newY > posMaxY) {
                newY = posMaxY;
            }
            pointsArr.push(cc.p(newX, newY));

            if (utilObj.getEucledianDistance(cc.p(newX, newY), end) <= 200) {
                stop += 1;
            }

            lastPos = cc.p(newX, newY);
            numPts++;
        }

        pointsArr.push(end);

        return pointsArr;
    };

    this.getEucledianDistance = function (p1, p2) {
        var x = Math.pow(p1.x - p2.x, 2);
        var y = Math.pow(p1.y - p2.y, 2);
        return Math.pow(x + y, 0.5);
    };

    this.changeVisibility = function (sender, params) {
        var element = params.element;
        var status = params.status;

        if (utilObj.isSpriteValid(element)) {
            try {
                element.setVisible(status);
            } catch (err) {
                // loggerObj.debugLog("Exception when changing visibility for element", err);
            }
        } else {
            // loggerObj.debugLog("Unable to change visibility for invalid element");
        }
    };

    this.dropShow = function (sender, params) {
        popupOpenAnimRunning = true;
        var node = params.node;
        var blackBg = params.blackBg;
        var cb = params.cb;
        var layer = params.layer;
        var cbParams = params.cbParams;
        var preDelay = params.delay;

        if (!preDelay) {
            preDelay = 0;
        }

        if (!utilObj.isSpriteValid(node)) {
            popupOpenAnimRunning = false;
            return;
        }

        if (utilObj.isSpriteValid(blackBg)) {
            blackBg.setOpacity(0);
            blackBg.runAction(new cc.FadeIn(0.2));
        }

        var x = node.getPosition().x;
        utilObj.setPosition(node, x, constantsObj.DESIGN_HEIGHT + 50);

        var anims = [];
        var initialDelay = utilObj.getDelayTime(preDelay + 0.05);
        anims.push(initialDelay);
        var move1 = new cc.MoveTo(0.15, x, -70);
        var ease1 = move1.easing(new cc.easeIn(1.0));
        anims.push(ease1);
        var resetAnim = utilObj.getCallFunc(utilObj.resetPopupOpenAnimationRunning, layer, {});
        anims.push(resetAnim);
        var move2 = new cc.MoveTo(0.18, x, 40);
        var ease2 = move2.easing(new cc.easeOut(0.8));
        anims.push(ease2);
        var move3 = new cc.MoveTo(0.23, x, -20);
        var ease3 = move3.easing(new cc.easeOut(0.9));
        anims.push(ease3);
        var move4 = new cc.MoveTo(0.28, x, 0);
        var ease4 = move4.easing(new cc.easeOut(1));
        anims.push(ease4);
        var postDelay = utilObj.getDelayTime(0.1);
        anims.push(postDelay);

        // var anims = [];
        // var initialDelay = animationObj.getDelayTime(0.05);
        // anims.push(initialDelay);
        // popupLayer.setScale(0);
        // if (utilObj.isNative()) {

        //     popupLayer.setOpacity(0);
        //     utilObj.setScale(popupLayer, 0.5);
        //     var scaleUp = animationObj.getScaleTo(0.3, 1.0).easing(new cc.easeBackOut());
        //     var fadeIn = animationObj.getFadeIn(0.12);
        //     var spawn = cc.Spawn([scaleUp, fadeIn]);
        //     anims.push(spawn);
        // } else {
        //     var scaleUp = animationObj.getScaleTo(0.2, 1.0).easing(new cc.easeInOut(1.0));
        //     anims.push(scaleUp);
        // }

        if (cb) {
            var func = utilObj.getCallFunc(cb, layer, cbParams);
            anims.push(func);
        }
        // node.runAction(utilObj.getSequence(anims));
        // var resetAnim = utilObj.getCallFunc(animationObj.resetPopupOpenAnimationRunning, layer, {});
        anims.push(resetAnim);
        animObj.runAction(node, utilObj.getSequence(anims));
    };

    this.dropShowV1 = function (sender, params) {
        popupOpenAnimRunning = true;
        var node = params.node;
        var blackBg = params.blackBg;
        var cb = params.cb;
        var layer = params.layer;
        var cbParams = params.cbParams;
        var preDelay = params.delay;
        var toShowFtue = params.toShowFtue;

        if (!preDelay) {
            preDelay = 0;
        }

        if (!utilObj.isSpriteValid(node)) {
            popupOpenAnimRunning = false;
            return;
        }

        // if (utilObj.isSpriteValid(blackBg)) {
        //     blackBg.setOpacity(0);
        //     blackBg.runAction(new cc.FadeIn(0.2));
        // }

        transBgLayerV2.show(toShowFtue);
        var anims = [];
        var initialDelay = utilObj.getDelayTime(0.05);
        anims.push(initialDelay);
        popupLayer.setScale(0);
        if (utilObj.isNative()) {
            popupLayer.setOpacity(0);
            utilObj.setScale(popupLayer, 0.5);
            var scaleUp = utilObj.getScaleTo(0.3, 1.0).easing(new cc.easeBackOut());
            var fadeIn = utilObj.getFadeIn(0.12);
            var spawn = cc.Spawn([scaleUp, fadeIn]);
            anims.push(spawn);
        } else {
            var scaleUp = utilObj.getScaleTo(0.2, 1.0).easing(new cc.easeInOut(1.0));
            anims.push(scaleUp);
        }
        

        if (cb) {
            var func = utilObj.getCallFunc(cb, layer, cbParams);
            anims.push(func);
        }
        var resetAnim = utilObj.getCallFunc(utilObj.resetPopupOpenAnimationRunning, layer, {});
        anims.push(resetAnim);
        animObj.runAction(popupLayer, utilObj.getSequence(anims));
    };


    this.getPosition = function (node) {
        if (utilObj.isNodeValid(node)) {
            return node.getPosition();
        } else {
            //loggerObj.debugLog("Node is not valid for getting position", node);
        }
    };

    this.getPositionX = function (node) {
        if (utilObj.isNodeValid(node)) {
            return node.getPositionX();
        } else {
            //loggerObj.debugLog("Node is not valid for getting position", node);
        }
    };

    this.getPositionY = function (node) {
        if (utilObj.isNodeValid(node)) {
            return node.getPositionY();
        } else {
            //loggerObj.debugLog("Node is not valid for getting position", node);
        }
    };

    this.setPositionX = function (node, x) {
        if (utilObj.isNodeValid(node) && x != null && x != undefined) {
            node.setPositionX(x);
        } else {
            //loggerObj.debugLog("Node is not valid for set position:", node, x);
        }
    };

    this.ifArrayContainsAnElement = function(array , value){
        if(array.indexOf(value) !== -1){
            return true;
        }
        return false;
    };

    this.setPositionY = function (node, y) {
        if (utilObj.isNodeValid(node) && y != null && y != undefined) {
            node.setPositionY(y);
        } else {
            //loggerObj.debugLog("Node is not valid for set position:", node, y);
        }
    };

    this.scrollToPercentVertical = function(node , percentToScroll , duration, boolean){
        if(utilObj.isNodeValid(node)){
            node.scrollToPercentVertical(percentToScroll, duration, boolean);
        }
    };

    this.dropShowPowerUp = function (sender, params) {
        var node = params.node;
        var preDelay = params.preDelay;
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        var x = node.getPosition().x;
        var y = node.getPosition().y;
        loggerObj.debugLog("check for the yPos ", y);
        utilObj.setPosition(node, x, y - 350);

        var anims = [];
        var initialDelay = utilObj.getDelayTime(preDelay + 0.05);
        anims.push(initialDelay);
        // var move1 = new cc.MoveTo(0.15, x, y - 400);
        // var ease1 = move1.easing(new cc.easeIn(1.0));
        // anims.push(ease1);
        // var move2 = new cc.MoveTo(0.18, x, y - 380);
        // var ease2 = move2.easing(new cc.easeOut(0.8));
        // anims.push(ease2);
        var move3 = new cc.MoveTo(0.23, x, y - 420);
        var ease3 = move3.easing(new cc.easeOut(0.9));
        anims.push(ease3);
        var move4 = new cc.MoveTo(0.28, x, y - 400);
        var ease4 = move4.easing(new cc.easeOut(1));
        anims.push(ease4);
        var postDelay = utilObj.getDelayTime(0.1);
        anims.push(postDelay);
        animObj.runAction(node, utilObj.getSequence(anims));
        return preDelay + 0.05 + 0.1;
    };

    this.timerProgressAnimation = function (sender, params) {

    };

    this.showTqAchievementsAnimation = function (heading, desc, initialDelay) {

        gameObj.setTimeStampForAchievementAnimation(utilObj.getCurrentTimestamp());

        //animation for dark screen here
        animObj.showDarkScreen(initialDelay);

        // animation for banner here
        animObj.sideShowTq(heading, desc, initialDelay);

        // animation for badge sprite here
        animObj.showBadgeAnimation(initialDelay);

        // animation for badge outline here
        animObj.showBadgeOutlineAnimation(initialDelay);

        var params = {
            x: centerXPos - (canvasWidth) / 3,
            y: centerYPos + 160,
            layer: curLayer,
            zOrder: constantsObj.UI_Z_ORDER + 2,
            scale: constantsObj.SCALE_SPRITE_3
        };  // * scaling
        utilObj.delayedCallback(curLayer, effectsObj.playStarEffect, initialDelay + 0.4, params, false);
    };


    this.showAchievementsAnimation = function (index, initialDelay) {

        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_ACHIEVEMENTS, constantsObj.TRACK_VIEW, utilObj.getScreenName(curScreen), index, "", "");
        gameObj.setTimeStampForAchievementAnimation(utilObj.getCurrentTimestamp());

        //animation for dark screen here
        animObj.showDarkScreen(initialDelay);

        // animation for banner here
        animObj.sideShow(index, initialDelay);

        // animation for badge sprite here
        animObj.showBadgeAnimation(initialDelay);

        // animation for badge outline here
        animObj.showBadgeOutlineAnimation(initialDelay);

        var params = {
            x: centerXPos - (canvasWidth) / 3,
            y: centerYPos + 160,
            layer: curLayer,
            zOrder: constantsObj.UI_Z_ORDER + 2,
            scale: constantsObj.SCALE_SPRITE_3
        };  // * scaling
        utilObj.delayedCallback(curLayer, effectsObj.playStarEffect, initialDelay + 0.4, params, false);
    };

    this.showQuestCompleteAnimation = function(desc , img ,reward , questId){

        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1,"quest_center", questId,curScreen, gameObj.getPuzzleSpeciesTracking(), "", "");

        var initialDelay = 0;
        
        //animation for dark screen here
        animObj.showDarkScreen(initialDelay);

        // animation for banner here
        animObj.sideShowV2(0, initialDelay,desc,reward);

        animObj.showQuestIconAnimation(initialDelay,img);

        var params = {
            x: centerXPos - (canvasWidth) / 3,
            y: centerYPos + 160,
            layer: curLayer,
            zOrder: constantsObj.UI_Z_ORDER + 2,
            scale: constantsObj.SCALE_SPRITE_3
        };  // * scaling
        utilObj.delayedCallback(curLayer, effectsObj.playStarEffect, initialDelay + 0.4, params, false);
    };

    this.hideUp = function (sender, params) {
        animationRunning = true;
        popupAnimRunning = true;
        var node = params.node;
        var blackBg = params.blackBg;
        var cb = params.cb;
        var layer = params.layer;
        var cbParams = params.cbParams;
        var preDelay = params.delay;

        if (!preDelay) {
            preDelay = 0;
        }

        if (!utilObj.isSpriteValid(node)) {
            animationRunning = false;
            popupAnimRunning = false;
            return;
        }

        if (utilObj.isSpriteValid(blackBg)) {
            blackBg.runAction(new cc.FadeOut(0.6));
        }

        var x = node.getPosition().x;

        var anims = [];
        var initialDelay = utilObj.getDelayTime(preDelay + 0.1);
        anims.push(initialDelay);
        var move1 = new cc.MoveTo(0.10, x, -30);
        var ease1 = move1.easing(new cc.easeOut(1.5));
        anims.push(ease1);
        var move2 = new cc.MoveTo(0.20, x, constantsObj.DESIGN_HEIGHT + 50);
        var ease2 = move2.easing(new cc.easeIn(1.5));
        anims.push(ease2);
        var postDelay = utilObj.getDelayTime(0);
        anims.push(postDelay);

        if (cb) {
            var func = utilObj.getCallFunc(cb, layer, cbParams);
            anims.push(func);
        }
        var resetAnim = utilObj.getCallFunc(utilObj.resetAnimationRunning, layer, {});
        anims.push(resetAnim);
        // node.runAction(utilObj.getSequence(anims));
        animObj.runAction(node, utilObj.getSequence(anims));
    };

    this.getScaleToV2 = function (duration, scale) {
        if (duration < 0 || scale < 0) {
            loggerObj.errorLog("Invalid params for scaling:", duration, scale);
            duration = 0;
            scale = 0;
        }
        var scaleTo = new cc.ScaleTo(duration, scale);
        return scaleTo;
    };

    this.hideUpV1 = function (sender, params) {
        animationRunning = true;
        popupAnimRunning = true;
        var node = params.node;
        var blackBg = params.blackBg;
        var cb = params.cb;
        var layer = params.layer;
        var cbParams = params.cbParams;
        var preDelay = params.delay;

        if (!preDelay) {
            preDelay = 0;
        }

        if (!utilObj.isSpriteValid(node)) {
            animationRunning = false;
            popupAnimRunning = false;
            return;
        }
        // if (utilObj.isSpriteValid(blackBg)) {
        //     blackBg.runAction(new cc.FadeOut(0.6));
        // }

        
        var anims = [];
        var initialDelay = utilObj.getDelayTime(0.01);
        anims.push(initialDelay);
        if (utilObj.isNative()) {
            var scaleDown = utilObj.getScaleTo(0.2, 0).easing(new cc.easeIn(1));
            var fadeOut = utilObj.getFadeOut(0.1);
            var spawn = cc.Spawn([scaleDown, fadeOut]);
            anims.push(spawn);
        } else {
            var scaleDown = utilObj.getScaleTo(0.1, 0).easing(new cc.easeInOut(1.0));
            anims.push(scaleDown);
        }
        

        if (cb) {
            loggerObj.debugLog("popup hideUp in callback")
            var func = utilObj.getCallFunc(cb, layer, cbParams);
            anims.push(func);
        }
        var resetAnim = utilObj.getCallFunc(utilObj.resetAnimationRunning, layer, {});
        anims.push(resetAnim);
        animObj.runAction(popupLayer, utilObj.getSequence(anims));
        transBgLayerV2.hide();
    };

    this.resetPopupOpenAnimationRunning = function () {
        popupOpenAnimRunning = false;
    };

    this.resetAnimationRunning = function () {
        animationRunning = false;
        popupAnimRunning = false;
    };

    this.handleConnHttpRequest = function (response) {
        // loggerObj.debugLog("handling response = ", response);
        //Using game controller to process response, else would have to create a new controller
        gameObj.handleControllerResponse(response);
    };

    // Suraj: Currently this is not downloading GZips correctly. So only downloading normal files using it.
    this.downloadGZipFile = function (request_url, callback, params) {
        return;
        var xmlHttp = cc.loader.getXMLHttpRequest();
        xmlHttp.onreadystatechange = function () {
            if (xmlHttp.readyState == 4 && xmlHttp.status == 200) {
                //loggerObj.traceLog("rest - success", xmlHttp.responseText);
                utilObj.unzipGZipFile(xmlHttp.responseText, callback, params);
            } else {
                //loggerObj.traceLog("rest - error", xmlHttp.statusText, "status", xmlHttp.readyState, xmlHttp.status);
            }
        };

        // You gotta trick it into downloading binary.
        xmlHttp.open('GET', request_url);
        xmlHttp.overrideMimeType('text\/plain; charset=x-user-defined');
        xmlHttp.send("");
    };

    this.unzipGZipFile = function (rawfile, callback, params) {
        callback(rawfile, params);
        return;
        // Create a byte array.
        var bytes = [];

        // Walk through each character in the stream.
        for (var fileidx = 0; fileidx < rawfile.length; fileidx++) {
            var abyte = rawfile.charCodeAt(fileidx) & 0xff;
            bytes.push(abyte);
        }

        // Instantiate our zlib object, and gunzip it.
        // Requires: https://github.com/imaya/zlib.js/blob/master/bin/gunzip.min.js
        // (remove the map instruction at the very end.)
        var gunzip = new Zlib.Gunzip(bytes);
        var plain = gunzip.decompress();

        // Now go ahead and create an ascii string from all those bytes.
        // Seeing we've just got a big ole byte buffer, but, not an ASCII file.
        var asciistring = "";
        for (var i = 0; i < plain.length; i++) {
            asciistring += String.fromCharCode(plain[i]);
        }

        callback(asciistring, params);
    };

    this.showScreenPush = function (msg) {

        var status = utilObj.isTriggeredFromPushNotif();
        var str = msg;
        var obj = str.split(":");
        if (popupLayer.popupOpen) {
            popupLayer.hide();
            utilObj.goToLastScreen(null, false, false);
        }
        if (obj[0] == "1") {
            if (curLayer != undefined && curLayer != null) {
                curLayer.hide();
            }
            redirectPushNotifLayerObj.show(msg);
        } else {
            utilObj.checkPushNotifs(msg);
            gameObj.setLastNotifTimestamp(obj[5]);
        }
        // loggerObj.debugLog("Will hide the layer 2");

    };

    this.isTriggeredFromPushNotif = function () {
        if (utilObj.isIos()) {
            return false;
        } else if (utilObj.isAndroid()) {
            var status = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "isTriggeredFromPushNotif", "()Z");
            // loggerObj.debugLog("Triggered from push notif ? ", status);
            return status;
        }
    };

    this.convertToBinary = function (num) {
        return (num >>> 0).toString(2);
    };

    this.isAdLayout = function () {
        var expBannerPayer = epmObj.getChosenVariant(constantsObj.EXP_BANNER_PAYER);
        var validForNoAds = false;
        if (expBannerPayer == constantsObj.EXP_VAR_CONTROL && gameObj.getIsPayer()) {
            validForNoAds = true;
        }
        if (expBannerPayer == constantsObj.EXP_VAR_1 && gameObj.getIsPayer()) {
            var bannerAdsWatched = gameObj.getCountBannerPayer();
            if (bannerAdsWatched >= runtimeObj.getMaxBannerPayer()) {
                validForNoAds = true;
            }
        }
        if ((!gameObj.getShowAds()) || validForNoAds) {
            // loggerObj.debugLog("isAdLayout : noShowAds = false");
            return false;
        }

        var adLayout = false;
        if (utilObj.isWeb()) {
            return adLayout;
        }
        /*var gameLayoutExp = epmObj.getExperiment(constantsObj.EXP_GAME_LAYOUT);
         if (gameLayoutExp != null) {
         var layoutVariant = gameLayoutExp.getChosenVariant();
         if (layoutVariant == constantsObj.VAR_SHOW_ADS) {
         adLayout = true;
         }
         utilObj.log("isAdLayout :" + layoutVariant);
         }else{
         utilObj.log("isAdLayout : no exp data");
         utilObj.log(epmObj.getExperimentsMap());
         }*/
        adLayout = true;
        // loggerObj.debugLog("isAdLayout = " + adLayout);
        return adLayout;
    };

    this.adVisible = false;

    this.showOrHideAd = function (forceHide, screenVal) {
        //loggerObj.debugLog("calling showOrHide banner Ad");
        var userCreated = userObj.getCreated();
        if (userCreated == "" || (utilObj.getCurrentTimestamp() - userCreated < 1 * constantsObj.SECONDS_IN_DAY)) {
            return;
        }
        if (screenVal == constantsObj.SCREEN_STORE_LAYER) {
            utilObj.hideBannerAd(utilObj.getScreenName(constantsObj.SCREEN_STORE_LAYER));
            return;
        }
        var isMiniOrMidi = gameObj.checkForMiniOrMidi(gameLayer.crosswordDate);
        if (screenVal == constantsObj.SCREEN_GAME) {
            if (!isMiniOrMidi) {
                // loggerObj.debugLog("entering do nothing case");
                //do nothing, move on
            }
        }

        if (screenVal == constantsObj.SCREEN_MFS) {
            // loggerObj.debugLog("entering do return 1");
            return;
        }

        if ((forceHide != undefined && forceHide == true) || !(utilObj.doesScreenHaveBanner(curScreen)) || (!ftueObj.isCalendarFtueShown() && curScreen == constantsObj.SCREEN_CALENDAR)
            || (!ftueObj.isFtueShown() && curScreen == constantsObj.SCREEN_HOME) || (!ftueObj.isAchievementFtueShown() && curScreen == constantsObj.SCREEN_ACHIEVEMENTS)) {
            //condition for hiding ads
            //loggerObj.debugLog("calling showOrHide banner Ad - force hide");
            utilObj.hideBannerAd(utilObj.getScreenName(screenVal));
        } else if (utilObj.adVisible == false) {
            //condition for showing ads
            if (!gameObj.getDidLoadAdLayout() || ((!gameObj.getShowAds()) || gameObj.getIsPayer())) {
                // loggerObj.debugLog("ad layout ", gameObj.getDidLoadAdLayout(), "show ads ", gameObj.getShowAds());
                return;
            }
            //loggerObj.debugLog("calling showOrHide banner Ad actually making a call");
            utilObj.showBannerAd(utilObj.getScreenName(screenVal));
        } else {
            // loggerObj.debugLog("no condition met");
        }
    };

    this.doesScreenHaveBanner = function (screen) {
        var screenWithBanner = [constantsObj.SCREEN_HOME, constantsObj.SCREEN_CALENDAR, constantsObj.SCREEN_ACHIEVEMENTS, constantsObj.SCREEN_GAME, constantsObj.SCREEN_PACK_LAYER, constantsObj.SCREEN_PACK_INFO_LAYER, constantsObj.SCREEN_ZEN_MODE,constantsObj.SCREEN_LINEAR_PROGRESSION];
        for (var i = 0; i < screenWithBanner.length; ++i) {
            if (screen == screenWithBanner[i]) {
                return true;
            }
        }
        return false;
    };

    var noShowBannerFlag = false;
    this.showBannerAd = function (source) {
       // loggerObj.debugLog("ShowBannerAd");
        if (subscriptionsDTCObj.getIsSubscriptionActive()) {
            return;
        }
        // check for banner for payers
        var noBannerForPayer = adsObj.checkBannerForPayer();
        if (noBannerForPayer) {
            return;
        }
        // loggerObj.debugLog("calling show banner Ad1", source);
        var bannerAdsVariant = epmObj.getChosenVariant(constantsObj.EXP_BANNER);
        // loggerObj.debugLog("calling show banner Ad145", source, bannerAdsVariant);
        if (bannerAdsVariant == constantsObj.EXP_VAR_CONTROL || source == utilObj.getScreenName(constantsObj.SCREEN_STORE_LAYER)) {
            if (utilObj.adVisible == true) {
                // loggerObj.debugLog("calling show banner Ad133", source);
                utilObj.hideBannerAd(source);
            }
            if (utilObj.isAndroid() && bannerAdsVariant == constantsObj.EXP_VAR_CONTROL) {
                // loggerObj.debugLog("calling show banner Ad135", source);
                utilObj.hideBannerAd(source);
                return;
            }
            if (bannerAdsVariant == constantsObj.EXP_VAR_CONTROL) {
                return;
            }
        }
        if (source == utilObj.getScreenName(constantsObj.SCREEN_STORE_LAYER)) {
            // loggerObj.debugLog("calling show banner Ad134", source);
            utilObj.hideBannerAd(source);
            return;
        }

        if (source == "callback") {
            // loggerObj.debugLog("callback from banner active", source, isBannerAdCallBackDone);
            if (curScreen != constantsObj.SCREEN_STORE_LAYER && !isBannerAdCallBackDone && curScreen != constantsObj.SCREEN_MFS && curScreen != constantsObj.SCREEN_FAQ) {
                // loggerObj.debugLog("callback accepted", isBannerAdCallBackDone);
                isBannerAdCallBackDone = true;
            } else {
                // loggerObj.debugLog("callback returned", isBannerAdCallBackDone);
                return;
            }
        }

        if (bannerAdsVariant == constantsObj.EXP_VAR_CONTROL) {
            // loggerObj.debugLog("calling show banner Ad13,will return eventually ", bannerAdsVariant);
            // loggerObj.debugLog("cannot load banner ad since user is  in achievementVariant control");
            utilObj.hideBannerAd(source);

            return;
        }
        if (!utilObj.isOnline()) {
            // loggerObj.debugLog("calling show banner Ad123", source);
            // loggerObj.debugLog("cannot load banner ad since user is offline");
            return;
        }
        // loggerObj.debugLog("show banner ad");
        if (gameObj.isNoAdBannerActive()) {
            // loggerObj.debugLog("skipping banner ad view as no banner ad is live right now");
            // loggerObj.debugLog("calling show banner Ad1234", source);
            return;
        }

        if (!gameObj.getDidLoadAdLayout()) {
            // loggerObj.debugLog("calling show banner Ad12345", source);
            return;
        }
        // loggerObj.debugLog("check banner ad screen",source,utilObj.getScreenName(constantsObj.SCREEN_MORE_GAMES_LAYER));
        if (source == utilObj.getScreenName(constantsObj.SCREEN_MORE_GAMES_LAYER)) {
            // loggerObj.debugLog("coming here for adwall screen");
            return;
        }

        var userCreated = userObj.getCreated();
        // loggerObj.debugLog("calling show banner Ad123456", userCreated,(utilObj.getCurrentTimestamp() - userCreated < 1 * constantsObj.SECONDS_IN_DAY));
        if (userCreated == "" || (utilObj.getCurrentTimestamp() - userCreated < 1 * constantsObj.SECONDS_IN_DAY)) {
            // loggerObj.debugLog("calling show banner Ad123456", userCreated);
            if (!(epmObj.getChosenVariant(constantsObj.EXP_D0_BANNER) == constantsObj.EXP_VAR_1 && gameObj.getMastery1() >= runtimeObj.getBannerMastery())) {
                utilObj.hideBannerAd(source);
                return;
            }
        }
        psMopubAdsObj.showPlacement(adsObj.PLACEMENT_BANNER, utilObj.getScreenName(curScreen), gameObj.getPuzzleSpeciesTracking());
    };

    this.hideBannerAd = function (source) {
        var HIDE_BANNER_AD_SCREENS = [constantsObj.SCREEN_FAQ, constantsObj.SCREEN_STORE_LAYER, constantsObj.SCREEN_MFS, constantsObj.SCREEN_FIRST_LAUNCH, constantsObj.SCREEN_MORE_GAMES_LAYER, constantsObj.SCREEN_PUSH_NOTIF_SCREEN, constantsObj.SCREEN_ZEN_MODE , constantsObj.SCREEN_QUEST_MAP , constantsObj.SCREEN_NEW_INTRO, constantsObj.SCREEN_OUTRO_LAYER, constantsObj.SCREEN_TRANS_OUTRO_LAYER , constantsObj.SCREEN_LANDING];
         //loggerObj.debugLog("ShowBannerAd1", source, utilObj.adVisible);

        var hide_Banner_Ad = false;
        for (var i = 0; i < HIDE_BANNER_AD_SCREENS.length; i++) {
            if (source == utilObj.getScreenName(HIDE_BANNER_AD_SCREENS[i])) {
                hide_Banner_Ad = true;
                break;
            }
        }
        psMopubAdsObj.hidePlacement(adsObj.PLACEMENT_BANNER, utilObj.getScreenName(curScreen), gameObj.getPuzzleSpeciesTracking());
        return;
    };

    this.showFacebookStaticInterstitialAd = function (adNet) {
        if (utilObj.isAndroid()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "MediationStack", "showFacebookStaticInterstitialAd", "(I)V", adNet);
        } else {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Util", "showFacebookStaticInterstitialVideo");
        }
    };

    this.showAdmobStaticInterstitialAd = function (screen) {
        var screenName = utilObj.getScreenName(screen);
        if (utilObj.isAndroid()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "MediationStack", "displayInterstitial", "(Ljava/lang/String;)V", screenName);
        }
    };

    this.showInterstitialAdsVideo = function (source) {
        if (((!gameObj.getShowAds()) || gameObj.getIsPayer())) {
            return;
        }
        gameObj.incInterstitialsShownToday();
        var screenName = utilObj.getScreenName(source);
        if (utilObj.isAndroid()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "displayInterstitial", "()V");
        } else if (utilObj.isIos()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Ads", "displayInterstitial:", screenName);
        }
    };

    this.showInterstitialAdsVideoOrStatic = function (source) {
        if (((!gameObj.getShowAds()) || gameObj.getIsPayer())) {
            return;
        }
        gameObj.incInterstitialsShownToday();
        var screenName = utilObj.getScreenName(source);
        if (utilObj.isAndroid()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "displayInterstitial", "()V");
        } else if (utilObj.isIos()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Util", "displayInterstitial:", screenName);
        }
    };

    this.getTotalMemAvailable = function () {
        if (utilObj.isAndroid()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "getTotalMem", "()V");
        } else if (utilObj.isIos()) {
            // jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Util", "getTotalMem");
            //loggerObj.debugLog("ram available is",  totalMem);
        }
    };

    this.getAvailableMem = function () {
        var variant = epmObj.getChosenVariant(constantsObj.EXP_RAM_CALC);
        if (variant != constantsObj.EXP_VAR_1) {
            return;
        }
        if (utilObj.isAndroid()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "getFreeMem", "()V");
        } else if (utilObj.isIos()) {
            // jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Util", "getAvailableMem");
        }
    };

    /*this.showQuestInterstitialAds = function() {
     if (utilObj.isAndroid()) {
     jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "displayQuestInterstitial", "()V");
     } else if (utilObj.isIos()) {
     utilObj.showInterstitialAds();
     //jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Util", "displayQuestInterstitial");
     }
     };*/

    this.initOrReloadQuestInterstitialAds = function () {
        if (utilObj.isAndroid()) {
            //jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "initOrReloadQuestInterstitialAds", "()V");
        } else if (utilObj.isIos()) {
            //jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Util", "initOrReloadQuestInterstitialAds");
        }
    };

    this.getAdjustDeviceId = function () {
        return "";
        if (utilObj.isIos()) {
            var adjustId = jsb.reflection.callStaticMethod("Analytics", "adjustDeviceId");
            if (adjustId == null) {
                adjustId = "";
            }
            return adjustId;
        }
    };

    this.forceUpdate = function () {
        var latestBuildVersion = gameObj.getLatestBuildVersion();
        if (!latestBuildVersion || !ftueObj.isFtueShown()) {
            return;
        }
        var clientBuildVersion = utilObj.getClientBuildVersion();
        var latestBuildString = latestBuildVersion.split(" ");
        var latestBuild = latestBuildString[1];
        latestBuild = latestBuild.trim();
        clientBuildVersion = clientBuildVersion.trim();
        if (latestBuild !== clientBuildVersion) {
            jsb.reflection.callStaticMethod("Util", "forceUpdatePopup");
        }
    };

    this.syncFabricEvent = function (eventName, status) {
        if (utilObj.isAndroid()) {

        } else if (utilObj.isIos()) {
            var params = {eventName: eventName, status: status};
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Util", "syncFabricEvent:status:", eventName, status);
        }
    };

    this.updateSpinLabel = function (layer, font) {
        if (layer == undefined || layer == null) {
            return;
        }
        if (layer.spinLbl == undefined || layer.spinLbl == null || !utilObj.isNodeValid(layer.spinLbl)) {
            return;
        }
        var spinLeft = economyObj.getSpinCount();
        if (utilObj.isNodeValid(layer.spinLbl)) {
            layer.spinLbl.setString(spinLeft + "");
        }
    };

    this.showArrow = function (zOrder, xFromCenter, flip, specialCase) {
        var anims = [];
        var arrow1 = utilObj.getSprite(constantsObj.ftue_arrow1, 0, 0, 1, 1, constantsObj.SCALE_SPRITE_12);

        if (specialCase == true) {
            arrow1 = utilObj.getSprite(constantsObj.ftue_arrow1, 0, 0, 1, 1, constantsObj.SCALE_SPRITE_12);
        }
        if (flip) {
            arrow1.setFlippedX(true);
        }
        popupLayer.addChild(arrow1, zOrder + 2);
        //arrow1.setVisible(false);
        var initialDelay = utilObj.getDelayTime(0.20);
        anims.push(initialDelay);
        var move1 = new cc.MoveTo(0, centerXPos + xFromCenter + 50, gameLayer.hintsBg.getPositionY() + 470 + constantsObj.BOTTOM_BAR_OFFSET1);
        if (specialCase == true) {
            move1 = new cc.MoveTo(0, centerXPos + xFromCenter + 50, gameLayer.hintsBg.getPositionY() + 410 + constantsObj.BOTTOM_BAR_OFFSET1);
        }
        anims.push(move1);
        arrow1.runAction(utilObj.getSequence(anims));
    };

    this.getLockedPuzzleCount = function (selectedMonth, year, dailyMiniCalendar) {

        //TODO: consider year also for unlocking all puzzles along with month
        // loggerObj.debugLog("get puzzle id1",year,selectedMonth);

        var date = gameObj.getTodaysPuzzleDate();
        var d = new Date(date.getTime());
        var curMonth = d.getMonth() + 1;
        var curyear = d.getFullYear();
        var lastDayOfMonth = d.getDate();
        if (curMonth > selectedMonth || curyear > year) {
            lastDayOfMonth = constantsObj.DAYS_IN_MONTH[selectedMonth - 1];
        }
        var miniCalendar = "";
        if (dailyMiniCalendar != undefined && dailyMiniCalendar == "dailyMiniCalendar") {
            miniCalendar = miniCalendar;
        }
        var puzzleId = "";
        //var year1 = constantsObj.YEAR_START + "";
        var monthPrefix = "";
        var dayPrefix = "";
        if (selectedMonth < 10) {
            monthPrefix = "0";
        }
        var inProgress = gameObj.getInProgress();
        var count = 0;
        var todaysPuzzleId = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
        if (miniCalendar == "dailyMiniCalendar") {
            todaysPuzzleId == stringsObj.mini_prefix + todaysPuzzleId.substr(2, todaysPuzzleId.length);
        }
        for (var i = 1; i <= lastDayOfMonth; i++) {
            dayPrefix = "";
            if (i < 10) {
                dayPrefix = "0";
            }
            puzzleId = year + "" + monthPrefix + selectedMonth + dayPrefix + i;
            if (miniCalendar == "dailyMiniCalendar") {
                puzzleId = stringsObj.mini_prefix + puzzleId.substr(2, puzzleId.length);
            }
            if (puzzleId == todaysPuzzleId) {
                continue;
            }
            var score = scoresObj.getHighScore(puzzleId);
            if ((inProgress[puzzleId] == null || inProgress[puzzleId] == undefined) && score <= 0) {
                count += 1;
            }
        }
        // loggerObj.debugLog("get puzzle id", puzzleId, todaysPuzzleId, lastDayOfMonth, curyear, year, selectedMonth);
        return count;
    };

    this.unlockAllPuzzles = function (selectedMonth, year) {

        //TODO: consider year also for unlocking all puzzles along with month

        var date = gameObj.getTodaysPuzzleDate();
        var d = new Date(date.getTime());
        var curMonth = d.getMonth() + 1;
        var curyear = d.getFullYear();
        var lastDayOfMonth = d.getDate();
        var todaysPuzzleId = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
        if (curMonth > selectedMonth || curyear > year) {
            lastDayOfMonth = constantsObj.DAYS_IN_MONTH[selectedMonth - 1];
        }
        var puzzleId = "";
        //var year = constantsObj.YEAR_START + "";
        var monthPrefix = "";
        var dayPrefix = "";
        if (selectedMonth < 10) {
            monthPrefix = "0";
        }
        var inProgress = gameObj.getInProgress();
        for (var i = 1; i <= lastDayOfMonth; i++) {
            dayPrefix = "";
            if (i < 10) {
                dayPrefix = "0";
            }
            puzzleId = year + "" + monthPrefix + selectedMonth + dayPrefix + i;
            var score = scoresObj.getHighScore(puzzleId);
            if ((inProgress[puzzleId] == null || inProgress[puzzleId] == undefined) && score <= 0 && (puzzleId != todaysPuzzleId)) {
                gameObj.unlockPuzzle(puzzleId);
            }
        }
        //updating packs
        gameObj.segregatePuzzlesForPack();
    };

    /**
     * returns days difference between dates
     * @param {*} currentDate 
     * @param {*} oldDate 
     * @returns 
     */
    this.getDaysDiff = function (currentDate, oldDate) {
        var curDate = new Date(currentDate);
        var oldDate = new Date(oldDate);
        oldDate.setHours(0, 0, 0, 0);
        curDate.setHours(0, 0, 0, 0);
        var diffInMilliseconds = curDate.getTime() - oldDate.getTime();
        var diffInDays = diffInMilliseconds / (1000 * constantsObj.SECONDS_IN_DAY);
        return diffInDays;
    };

    this.getMonthDiff = function (date1, date2) {
        var newDate1 = new Date(date1);
        var newDate2 = new Date(date2);
        var monthDate1 = newDate1.getMonth();
        var monthDate2 = newDate2.getMonth();
        if (monthDate1 > monthDate2) {
            return (monthDate1 - monthDate2);
        } else {
            return (monthDate2 - monthDate1);
        }
    };

    this.isAppInstalled = function (appName) {
        if (isAppInstalled[appName] != undefined) {
            return isAppInstalled[appName];
        }
        var installed = false;
        if (utilObj.isAndroid()) {
            installed = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "isAppInstalled", "(Ljava/lang/String;)Z", appName);
        } else if (utilObj.isIos()) {
            installed = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Util", "isAppInstalled:", appName);
        }
        isAppInstalled[appName] = installed;
        return installed;
    };

    this.resetIsAppInstalledMap = function () {
        isAppInstalled = {};
    };

    this.checkGameAchievementforCrossPromoTracking = function (name) {
        var crossPromoArray = stringsObj.track_cross_promo;
        for (var i = 0; i < crossPromoArray.length; i++) {
            if (crossPromoArray[i] == name) {
                return 201 + i;
            }
        }
    };

    this.getIsNotifClicked = function () {
        if (utilObj.isIos()) {
            var val = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Util", "getIsNotifClicked");
            //loggerObj.debugLog("this is getisnotifclicked ", val);
            return val;
        } else if (utilObj.isAndroid()) {
            var val = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID + "Util", "getIsNotifClicked", "()Z");
            //loggerObj.debugLog("this is getisnotifclicked ", val);
            return val;
        }
    };

    this.getisSpriteandFontLoaded = function () {
        return isSpriteandFontLoaded;
    };

    this.setisSpriteandFontLoaded = function (val) {
        isSpriteandFontLoaded = val;
    };

    this.restorePackages = function () {
        if (utilObj.isIos()) {
            var val = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Payments", "restorePurchases");
        }

    };

    this.loadSpritesinit = function (res) {
        var spriteArr = [];
        for (var i in res) {
            // loggerObj.debugLog("sprite to push is", JSON.stringify(res[i]));
            utilObj.getSprite(res[i], 10, 10, 0.5, 0,
                constantsObj.SCALE_ONE, spriteArr, null, 0, constantsObj.SPRITE_LOCAL);
        }
    };

    this.loadFontInit = function () {
        for (var i in fontArr1) {
            var label = new cc.LabelBMFont("A", fontArr1[i], constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0));
        }
    };


    this.getIsLikeIphoneX = function () {
        return aspectRatio >= 1.95;
    };

    this.getRandomNumberinRange = function (min, max) {
        return Math.floor(Math.random() * (max - min + 1)) + min;
    };

    this.getconditionForFirstLaunch = function () {
        if (utilObj.isWeb()) {
            return false;
        }
        return (gameObj.getQuickPlayCheck() || userObj.getUserDataLoaded() || gameObj.getIsGameDataLoaded());
    };

    this.checkForShowingTodaysPuzzle = function () {
        return true;
    };

    this.forceSync = function () {
        //loggerObj.debugLog("MagicLogSync:started");
        gameObj.syncToServer(true);
        runtimeObj.syncToServer();
        epmObj.syncToServer(true);
        fbRequestObj.getOpenReqCount();
        friendsObj.attemptUpdate();
    };

    this.getCurrentScreenName = function () {
        return utilObj.getScreenName(curScreen, null);
    };

    this.getSharableLink = function () {
        // return constantsObj.GAME_SHARE_LINK;
        return constantsObj.APP_STORE_URL;
    };

    this.validateEmail = function (email) {
        var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        return re.test(String(email).toLowerCase());
    };

    this.getFps = function () {
        var fps = Math.floor(1 / cc.director.getAnimationInterval());
        machineLearningDataObj.setLowestFps(fps);
    };

    // function to rollout pack to users on the basis of experiment, called on app start
    // Updates the new pack number if person is eligible
    // Updates the ordering arr for the packs afterwards
    // Updates the other constants and strings for that pack number
    this.checkIfEligibleForNewPack = function () {
        // loggerObj.debugLog("check for new pack", gameObj.getNewPackSurfacedVersion(), runtimeObj.getNewPackVersion(), epmObj.getChosenVariant(constantsObj.EXP_PACK_ROLLOUT));

        /**
         * handles the case where the runtime get updated to next pack so that the current pack gets available for the user on the old build
         */
        var runtimeValue = runtimeObj.getNewPackVersion();
        var currentPackVersion = constantsObj.PACK_VERSION;
        var subStrRuntimeValue = parseInt(runtimeValue.substr(1, runtimeValue.length));
        var subStrCurrentPackVersion = parseInt(currentPackVersion.substr(1, currentPackVersion.length));

        if (gameObj.getNewPackSurfacedVersion() == constantsObj.PACK_VERSION || (utilObj.getCurrentTimestamp() >= constantsObj.TIME_STAMP_FOR_NEW_PACK_RELEASE)) {
            constantsObj.NUM_PACKS = 45;
            var reorderArr = gameObj.getOrderingOfPacks();
            var index = reorderArr.indexOf(constantsObj.NUM_PACKS - 1);
            if (index == -1) {
                gameObj.setNewPackTimestamp(utilObj.getCurrentTimestamp());
                var temp = reorderArr[0];
                reorderArr.splice(0, 1, constantsObj.NUM_PACKS - 1);
                reorderArr.splice(3, 0, temp);
                gameObj.setNotifForPack(0);
            }
            var purchasedPackInfoNew1 = gameObj.getPurchasedPackInfo();
            purchasedPackInfoNew1[constantsObj.NUM_PACKS - 1] = ["00003701", "00003702", "00003703", "00003704", "00003705", "00003706", "00003707", "00003708", "00003709", "00003710", "00003711", "00003712", "00003713", "00003714", "00003715"];

            gameObj.setPurchasedPackInfo(purchasedPackInfoNew1);
            gameObj.segregatePuzzlesForPack();
            //loggerObj.debugLog("index is", index, gameObj.getOrderingOfPacks());
            stringsObj.puzzle_themes_pack[constantsObj.NUM_PACKS - 1] = constantsObj.MINI_PACK_INFO[constantsObj.NUM_PACKS - 1]["puzzle_themes_pack"];
            stringsObj.puzzle_themes_pack_Info[constantsObj.NUM_PACKS - 1] = constantsObj.MINI_PACK_INFO[constantsObj.NUM_PACKS - 1]["puzzle_themes_pack_Info"];
            stringsObj.puzzle_themes_pack_Info_desc[constantsObj.NUM_PACKS - 1] = constantsObj.MINI_PACK_INFO[constantsObj.NUM_PACKS - 1]["puzzle_themes_pack_Info_desc"];
            gameObj.setNewPackSurfacedVersion(constantsObj.PACK_VERSION);
        }

        /**
         * handles the case to update the new pack once the date is available
         */
        if (utilObj.getCurrentTimestamp() >= constantsObj.TIME_STAMP_FOR_NEW_BRIT_PACK_RELEASE) {
            constantsObj.NUM_BRIT_PACKS = 1;
            var reorderBritArr = gameObj.getOrderingOfBritPacks();
            var index = reorderBritArr.indexOf(constantsObj.NUM_BRIT_PACKS - 1);
            if (index == -1) {
                // gameObj.setNewPackTimestamp(utilObj.getCurrentTimestamp());
                // var temp = reorderBritArr[0];
                // reorderArr.splice(0, 1, constantsObj.NUM_PACKS - 1);
                // reorderArr.splice(3, 0, temp);
                // gameObj.setNotifForPack(0);
                reorderBritArr.push(constantsObj.NUM_BRIT_PACKS - 1);
            }
            var purchasedBritPackInfoNew1 = gameObj.getBritPurchasedPackInfo();
            purchasedBritPackInfoNew1[constantsObj.NUM_BRIT_PACKS] = ["10000101", "10000102", "10000103", "10000104", "10000105"];
            gameObj.setBritPurchasedPackInfo(purchasedBritPackInfoNew1);
            stringsObj.puzzle_themes_brit_pack[constantsObj.NUM_BRIT_PACKS - 1] = constantsObj.BRIT_PACK_INFO[constantsObj.NUM_BRIT_PACKS - 1]["puzzle_themes_pack"];
            stringsObj.puzzle_themes_brit_pack_Info[constantsObj.NUM_BRIT_PACKS - 1] = constantsObj.BRIT_PACK_INFO[constantsObj.NUM_BRIT_PACKS - 1]["puzzle_themes_pack_Info"];
            stringsObj.puzzle_themes_brit_pack_Info_desc[constantsObj.NUM_BRIT_PACKS - 1] = constantsObj.BRIT_PACK_INFO[constantsObj.NUM_BRIT_PACKS - 1]["puzzle_themes_pack_Info_desc"];

        }

    };

    this.isAmazonAppStore = function () {
        return utilObj.getTrackingClient() == constantsObj.CLIENT_AMAZON;
    };

    this.setScale = function (node, val) {
        if (utilObj.isNodeValid(node)) {
            node.setScale(val);
        } else {
            // loggerObj.debugLog("Node is not valid for setting scale", node, val);
        }
    };

    this.getSubsPkgPrices = function (priceSub, cut) {
        // loggerObj.debugLog("price sub1", priceSub);
        var currency = priceSub.slice(0, 1);
        priceSub = priceSub.replace(",", "");
        var intStartIndex = -1;
        for (var i = 0; i < priceSub.length; i++) {
            if (utilObj.isInt(priceSub[i])) {
                intStartIndex = i;
                break;
            }
        }
        // loggerObj.debugLog("price sub2", currency + parseFloat(priceSub.substr(intStartIndex)) + "", parseFloat(priceSub.substr(intStartIndex)));
        var price = currency + Math.floor(parseFloat(priceSub.slice(intStartIndex, priceSub.length - 3)) / cut) + "";
        return price + priceSub.slice(-3);
    };

    this.checkExecutionTime = function (cbFunc, params, functionName) {
        var startTime = new Date().getTime();
        cbFunc.apply(this, params);
        var endTime = new Date().getTime();
    };

    this.isUserDnOrMore = function (n) {
        var installTimestamp = gameObj.getInstallTimeStamp();
        if (userObj.getCreated() != "") {
            installTimestamp = userObj.getCreated();
        }
        if (installTimestamp == 0) {
            return n == 0;
        }

        var futureDate = new Date(installTimestamp * 1000);
        futureDate.setDate(futureDate.getDate() + n);
        futureDate.setHours(0);
        futureDate.setMinutes(0);
        futureDate.setSeconds(0);
        futureDate.setMilliseconds(0);
        //loggerObj.debugLog("Reached here5",futureDate,new Date(utilObj.getCurrentTimestampMs()));

        var curTimestamp = utilObj.getCurrentTimestampMs();
        var futureTimestamp = futureDate.getTime();
        var diff = curTimestamp - futureTimestamp;
        //loggerObj.debugLog("Reached here4",diff);
        if (diff < 0) {
            return false;
        }
        return true;
    };

    // Only for Game Screen where extra height was needed for hints button
    this.getBottomShiftGameScreen = function () {
        return constantsObj.BOTTOM_BAR_OFFSET1;
    };

    // For other screens where the bottom nav is shifted up a little to accomodate above 18:9 screens
    this.getBottomShift = function () {
        return constantsObj.BOTTOM_BAR_OFFSET;
    };

    // this is the space added on top where the banner surfacing will be there and no ui will be present
    // subtracting bezel safe area in case of ios and on android we cannot detect it hence 0.
    this.getTopBarShift = function () {
        return topBarOffset - constantsObj.BEZEL_SAFE_AREA;
    };

    /**
     * this function returns the dimensions of the sprite drawn in Pixels
     * @param node
     */
    this.getSpriteDimensions = function (node) {
        if (!utilObj.isNodeValid(node)) {
            return {width: 1, height: 1};
        }

        var spriteBoundingBox = node.getBoundingBox();
        return {width: spriteBoundingBox.width, height: spriteBoundingBox.height};
    };

    /**
     * this function returns the content size of the node
     * @param node
     * @returns {*}
     */
    this.getSpriteContentSize = function (node) {
        if(!utilObj.isNodeValid(node)){
            return {width: 1, height: 1};
        }

        var spriteContentSize = node.getContentSize();
        return {width: spriteContentSize.width, height: spriteContentSize.height};
    };

    /**
     * this function returns the actual coordinate positions of the sprite on screen
     * @param node
     * @returns {*}
     */
    this.getSpriteCoordinates = function (node) {
        if (!utilObj.isNodeValid(node)) {
            return {xPos: 0, yPos: 0};
        }
        return {xPos: node.getPositionX(), yPos: node.getPositionY()};
    };

    /**
     * returns the x and y scaling of a node
     * @param node
     * @returns {*}
     */
    this.getSpriteScales = function (node) {
        if(!utilObj.isNodeValid(node)) {
            return {scaleX: 1, scaleY: 1};
        }

        return {scaleX: node.getScaleX(), scaleY: node.getScaleY()};
    };

    /**
     * this function returns the anchor point for the sprite
     * @param node
     * @returns {{x: number, y: number}}
     */
    this.getSpriteAnchor = function(node){
        if(!utilObj.isNodeValid(node)){
            return {x: 0.5, y: 0.5};
        }

        var anchor = node.getAnchorPoint();
        return {x: anchor.x, y: anchor.y};
    };

    /**
     * this function sets the anchor points for the given sprite
     * @param node
     */
    this.setSpriteAnchor = function (node, anchorX, anchorY) {
        if(!utilObj.isNodeValid(node)){
            // loggerObj.debugLog("spriteAnchorLog: invalid node passed for setting anchor point");
            return;
        }

        node.setAnchorPoint(anchorX, anchorY);
    };

    /**
     * this function returns the parent of a node
     * works only if the node has been added to the parent node
     * @param node
     * @param spriteArr
     * @returns {*}
     */
    this.getSpriteParent = function (node) {
        if(!utilObj.isNodeValid(node)){
            return null;
        }

        return node.getParent();
    };

    /**
     * sets the x scale of a node
     * @param node
     * @param scale
     */
    this.setScaleX = function (node, scale) {
        if(!utilObj.isNodeValid(node)){
            return;
        }

        node.setScaleX(scale);
    };

    /**
     * sets the y scale of a node
     * @param node
     * @param scale
     */
    this.setScaleY = function (node, scale) {
        if(!utilObj.isNodeValid(node)){
            return;
        }

        node.setScaleY(scale);
    };

    /**
     * returns the X scaling for the node
     * @param node
     * @returns {number}
     */
    this.getScaleX = function (node) {
        if(!utilObj.isNodeValid(node)){
            return 1;
        }

        return node.getScaleX();
    };

    /**
     * returns the Y scaling for the node
     * @param node
     * @returns {number}
     */
    this.getScaleY = function (node) {
        if(!utilObj.isNodeValid(node)){
            return 1;
        }

        return node.getScaleY();
    };

    /**
     * returns the z-order of the node
     * @param node
     * @returns {number}
     */
    this.getSpriteZOrder = function (node) {
        if(!utilObj.isNodeValid(node)){
            return 1;
        }

        return node.getZOrder();
    };

    /**
     * sets the scaleX and scaleY values for the given sprite
     * @param node
     * @param scaleX
     * @param scaleY
     */
    this.setSpriteScales = function (node, scaleX, scaleY) {
        if(!utilObj.isNodeValid(node)){
            return;
        }

        utilObj.setScaleX(node, scaleX);
        utilObj.setScaleY(node, scaleY);
    };

    /**
     * returns the scale of the sprite
     * in case of different scaling for x and y, returns the scale of the x
     * @param node
     * @returns {*|Number|float}
     */
    this.getScale = function (node) {
        if(!utilObj.isNodeValid(node)){
            return;
        }

        if(node.getScaleX() != node.getScaleY()){
            return node.getScaleX();
        }

        return node.getScale();
    };

    /**
     * returns the clone of the given node
     * uses the anchor, scaling and positions of the original sprite
     * @param node
     */
    this.getSpriteClone = function (node) {
        if(!utilObj.isNodeValid(node)){
            // loggerObj.debugLog("spriteCloneLog: invalid node passed for cloning sprite");
            return;
        }

        var clone = new cc.Sprite();
        clone.initWithSpriteFrame(node.getSpriteFrame());
        var nodeScale = utilObj.getScale(node);
        var nodeAnchor = utilObj.getSpriteAnchor(node);
        clone.attr({
            anchorX: nodeAnchor.x,
            anchorY: nodeAnchor.y,
            scale: nodeScale
        });
        var nodePos = utilObj.getSpriteCoordinates(node);
        utilObj.setPosition(clone, nodePos.xPos, nodePos.yPos);
        return clone;
    };

    /**
     * this function clones existing sprites basic properties i.e. scale, anchor and position
     * @param source
     * @param target
     */
    this.cloneSpriteProperties = function (source, target) {
        if(!utilObj.isNodeValid(source)){
            // loggerObj.debugLog("cloneSpritePropertiesLog: invalid node passed for cloning sprite properties");
            return;
        }

        var sourceScale = utilObj.getScale(source);
        var sourceAnchor = utilObj.getSpriteAnchor(source);
        var sourcePos = utilObj.getSpriteCoordinates(source);

        utilObj.setScale(target, sourceScale);
        utilObj.setSpriteAnchor(target, sourceAnchor.x, sourceAnchor.y);
        utilObj.setPosition(target, sourcePos.xPos, sourcePos.yPos);
    };

    /**
     * returns the clone of the given label
     * uses the properties of the original label
     * @param label
     * @param labelType
     */
    this.getLabelClone = function (label, labelType) {
        if(!utilObj.isNodeValid(label)){
            // loggerObj.debugLog("labelCloneLog: invalid label passed for cloning label");
            return;
        }

        if(labelType == constantsObj.FONT_TTF){
            return utilObj.getTTFLabelClone(label);
        }
        return utilObj.getBMLabelClone(label);
    };

    /**
     * TODO: implement when some ttf label needs to be reused
     * returns the clone for a ttf label
     * @param label
     * @returns {null}
     */
    this.getTTFLabelClone = function (label) {
        return null;
    };

    /**
     * note: can be generalised further by getting the width , alignment, etc of the original label
     * returns the clone for a BM label
     * @param label
     * @returns {*}
     */
    this.getBMLabelClone = function (label) {
        var labelStr = label.getString();
        var labelFont = label.getFntFile();
        var labelColor = label.getColor();
        var labelScale = label.getScale();
        var labelAnchor = utilObj.getSpriteAnchor(label);
        var labelPosition = utilObj.getSpriteCoordinates(label);

        var clone = new cc.LabelBMFont(labelStr, labelFont, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0));
        clone.attr({
            anchorX: labelAnchor.x,
            anchorY: labelAnchor.y
        });
        utilObj.setPosition(clone, labelPosition.xPos, labelPosition.yPos);
        utilObj.setColor(clone, labelColor);
        utilObj.setScale(clone, labelScale);
        return clone;
    };

    this.updateAdditionalCashLabels = function () {
        var extraCashLbls = economyObj.getAdditionalCashLabels();
        var numLbls = extraCashLbls.length;
        for(var i = 0; i < numLbls; i++){
            utilObj.setString(extraCashLbls[i], economyObj.getCash());
        }
    };

    /**
     * removes childNode using the tag value
     * @param parent
     * @param tag
     * @returns {boolean}
     */
    this.removeChildByTag = function (parent, tag) {
        if(!utilObj.isNodeValid(parent)) {
            return false;
        }
        var child = parent.getChildByTag(tag);
        if(!utilObj.isNodeValid(child)) {
            return false;
        }
        parent.removeChildByTag(tag);
        return true;
    };

    /**
     * this function adds child to a node with the given values of zOrder and tags
     * @param parentNode
     * @param childNode
     * @param zOrder
     * @param tag
     */
    this.addChildWithTag = function (parentNode, childNode, zOrder, tag) {
        if (zOrder == undefined) {
            if (utilObj.isNodeValid(parentNode) && utilObj.isNodeValid(childNode)) {
                parentNode.addChild(childNode);
            }
        } else {
            if (utilObj.isNodeValid(parentNode) && utilObj.isNodeValid(childNode)) {
                parentNode.addChild(childNode, zOrder, tag);
            }
        }
    };

    /**
     * converts degree value to radians
     * @param angle
     * @returns {number}
     */
    this.toRadians = function (angle) {
        return angle * (Math.PI / 180);
    };
    
    this.getDecryptedData = function (cipherText) {
        var decryptedData = Tea.decrypt(cipherText, stringsObj.spinner_txt);
        decryptedData = decryptedData.replace(/[\x00-\x1F\x7F-\x9F]/g, "");
        return JSON.parse(decryptedData);
    };

    /**
     * wrapper for cascade opacity enabled function
     * @param node
     * @param val
     */
    this.setCascadeOpacityEnabled = function (node, val) {
        if(!utilObj.isNodeValid(node)){
            // loggerObj.debugLog("cascadeOpacityLog: invalid node value");
            return;
        }

        node.setCascadeOpacityEnabled(val);
    };

    /**
     * wrapper function to create clipping Node
     * @param sprite
     * @param alphaThreshold
     * @param spriteArr
     * @param layer
     * @param zOrder
     * @param tag
     * @returns {*}
     */
    this.getClippingNode = function (sprite, alphaThreshold, spriteArr, layer, zOrder, tag) {
        var clippingNode;
        try {
            clippingNode = new cc.ClippingNode(sprite);
            clippingNode.attr({
                alphaThreshold: alphaThreshold
            });
        } catch (e) {
            clippingNode = new cc.ClippingNode();
        }

        if (spriteArr != undefined && spriteArr != null) {
            var info = {
                "sprite": clippingNode,
                "layer": layer,
                "z-order": zOrder
            };
            if (tag != undefined && tag != "") {
                info.tag = tag;
            }
            spriteArr.push(info);
        }
        return clippingNode;
    };

    /**
     * wrapper function to get opacity of a node
     * returns 0 opacity in case node is not valid
     * @param node
     * @returns {*}
     */
    this.getOpacity = function (node) {
        if(!utilObj.isNodeValid(node)){
            return constantsObj.OPACITY_0;
        }

        return node.getOpacity();
    };

    /**
     * wrapper function to set opacity of a node
     * @param label
     * @param val
     */
    this.setOpacity = function (node, val) {
        if(!utilObj.isNodeValid(node)){
            return;
        }
        node.setOpacity(val);
    };

    /**
     * sets opacity to 0 for all nodes passed in the node array
     * @param nodeArr
     */
    this.makeAllNodesTransparent = function (nodeArr) {
        var nodeCount = nodeArr.length;
        for(var i = 0; i < nodeCount ;i++){
            utilObj.setOpacity(nodeArr[i], constantsObj.OPACITY_0);
        }
    };

    /**
     * sets opacity to 100 for all nodes passed in the node array
     * @param nodeArr
     */
    this.makeAllNodesOpaque = function (nodeArr) {
        var nodeCount = nodeArr.length;
        for(var i = 0; i < nodeCount; i++){
            utilObj.setOpacity(nodeArr[i], constantsObj.OPACITY_100);
        }
    };

    /**
     * wrapper function to set rotation (in degrees) of a node
     * @param node
     * @param val
     */
    this.setRotation = function (node, val) {
        if (!utilObj.isNodeValid(node)) {
            return;
        }

        node.rotation = val;
    };

    /**
     * returns minute values from seconds value
     * @param seconds
     * @returns {number}
     */
    this.getMinutesFromSeconds = function (seconds) {
        return seconds / 60;
    };

    /**
     * returns seconds value from minutes value
     * @param minutes
     * @returns {number}
     */
    this.getSecondsFromMinutes = function (minutes) {
        return minutes * 60;
    };

    /**
     * returns hours values from seconds value
     * @param seconds
     * @returns {number}
     */
    this.getHoursFromSeconds = function (seconds) {
        return seconds / (60 * 60);
    };

    /**
     * returns seconds value from hours value
     * @param hours
     * @returns {number}
     */
    this.getSecondsFromHours = function (hours) {
        return hours * 60 * 60;
    };

    /**
     * returns hours values from minutes value
     * @param minutes
     * @returns {number}
     */
    this.getHoursFromMinutes = function (minutes) {
        return minutes / 60;
    };

    /**
     * returns minutes value from hours value
     * @param hours
     * @returns {number}
     */
    this.getMinutesFromHours = function (hours) {
        return hours * 60;
    };

    /**
     *  wrapper function to get the stencil of the clipper node
     * @param node
     * @returns {*}
     */
    this.getStencil = function (node) {
        if(!utilObj.isNodeValid(node)){
            // loggerObj.debugLog("stencilLog: invalid node to find stencil of");
            return null;
        }

        if(!utilObj.isFunction(node.getStencil)){
            // loggerObj.debugLog("stencilLog: invalid function invoking");
            return null;
        }

        // loggerObj.debugLog("stencilLog: success");
        return node.getStencil();
    };

    this.disableGoogleInstallTimestampTracking = function () {
        // gameObj.setShouldSendInstallTracking(false);
    };

    /**
     * function to increment date based on the given values of date and days
     * @param date
     * @param days
     * @returns {*}
     */
    this.getIncrementedDate = function (date, days) {
        var curDate = new Date(date.getTime());
        curDate.setDate(date.getDate() + days);
        return curDate;
    };

    /**
     * returns an array consisiting of all keys in the map
     * @param map
     * @returns {Array}
     */
    this.getKeysArrayFromMap = function (map) {
        var arr = [];
        for(var key in map){
            if(map.hasOwnProperty(key)){
                arr.push(key);
            }
        }
        return arr;
    };

    //DTC2 FOR Image Background changes
    this.removePrevBg = function (sender, params) {
        var parent = params.parent;
        var child = params.child;
        
        if (!utilObj.isSpriteValid(child)) {
            if (!utilObj.isAutoPlayNoAnim()) {
                loggerObj.debugLog("changeBg log : Invalid sprite when attempting to remove");

            }
            return false;
        }

        try {
            var numRunningActions = child.getNumberOfRunningActions();
            if (numRunningActions > 0) {
                loggerObj.traceLog("Removing child which had actions running:", child.markedForRemoval, child.spriteIndex, child.replacement);
                child.stopAllActions();
            }
            parent.removeChild(child);
        } catch (e) {
            // loggerObj.debugLog("changeBg log : Error while Removing Child" , e);
            return false;
        }
        return true;
    };
    this.changeBgImg = function (sprite, node, spriteNew, scaling, opacity, spriteZorder) {

        if (!utilObj.isSpriteValid(sprite)) {
            loggerObj.debugLog("changeBg log : sprite is NOT VALID" , sprite);
            return null;
        }
        if (utilObj.isGettingRemoved(sprite)) {
            loggerObj.debugLog("changeBg log : sprite is Getting Removed");
            return sprite;
        }

        try {
            var pos = utilObj.getPosition(sprite);
            var oldScaleX = sprite.getScaleX();
            var oldScaleY = sprite.getScaleY();
            var zOrder = sprite.getLocalZOrder();
            var tag = sprite.getTag();
            var spriteIndex = sprite.spriteIndex;
            var delay = animObj.getDelayTime(0);
            var params = {
                parent: node,
                child: sprite
            };
            utilObj.delayedCallback(linearLevelProgression, utilObj.removePrevBg, 0.5, params, false);

            loggerObj.debugLog("changeBg log : After Delayed CallBack")
            if (!utilObj.isSpriteValid(spriteNew)) {
                loggerObj.debugLog("changeBg log : sprite NEW is NOT VALID");
                return null;
            }
            if (opacity != undefined && opacity != null) {
                spriteNew.setOpacity(opacity);
            }

            if (scaling != undefined && scaling != null) {
                if (utilObj.isFunction(scaling)) {
                    spriteNew.setScale(scaling(image, sprite)); // Suraj: What is image?? Seems an undefined variable.
                } else {
                    spriteNew.setScale(scaling);
                }
            } else {
                spriteNew.setScaleX(oldScaleX);
                spriteNew.setScaleY(oldScaleY);
            }
            if (spriteZorder != null && spriteZorder != undefined) {
                zOrder = spriteZorder;
            }

            spriteNew.setOpacity(0);
            var delay1 = animObj.getDelayTime(0);
            var fadeIn = animObj.getFadeIn(0.5);
            var seqAction = [delay, fadeIn];
            animObj.runAction(spriteNew, animObj.getSequence(seqAction, false));

            node.addChild(spriteNew, zOrder, tag);
            utilObj.setPosition(spriteNew, pos.x, pos.y);
            spriteNew.replacement = true;
            spriteNew.spriteIndex = spriteIndex;
            return spriteNew;
        } catch (err) {
            loggerObj.debugLog("changeBg log : EROR",err);
            return null;
        }
    };

    //  this function takes actual width and height of an asset 
    //  and returns the width ,height and scale to get the desired width and height.
    this.getButtonDimensions = function (actualAssetWidth, actualAssetHeight, desiredWidth, desiredHeight) {
        var scale = desiredHeight / actualAssetHeight;
        var widthOfAsset = desiredWidth / scale;
        var heightOfAsset = actualAssetHeight;
        
        return {"width": widthOfAsset, "height": heightOfAsset, "scale": scale};
    };

     /**
     * This function sets the anchor for the node based on the offset so that button interactions are stable
     * @param node - the node on which the offset is to be added
     * @param xOffset
     * @param yOffset
     */
      this.setOffsetByAnchor = function (node, xOffset, yOffset) {
        if (!utilObj.isNodeValid(node)) {
            return false;
        }

        var width = node.getBoundingBox().width;
        var height = node.getBoundingBox().height;
        var xAnchor = node.anchorX;
        var yAnchor = node.anchorY;

        if (xOffset < 0) {
            xAnchor += (-1 * xOffset) / width;
        } else {
            xAnchor -= xOffset / width;
        }

        if (yOffset < 0) {
            yAnchor += (-1 * yOffset) / height;
        } else {
            yAnchor -= yOffset / height;
        }
        node.anchorX = xAnchor;
        node.anchorY = yAnchor;

        // loggerObj.debugLog("anchor log: the anchors are ", xOffset, xAnchor, width, yOffset, yAnchor, height);

    };

    /**
     * allow notifications functionality 
     */
    this.allowNotifications = function(){
        if(utilObj.isIos()){
            if (!gameObj.getNotifPermissionForIos()) {
                gameObj.setNotifPermissionForIos(true);
                utilObj.checkForNotifPermission();
            } else {
                utilObj.redirectToSettings();
            }
        }
    };

    /**
     * wrapper for setting local z order for a node
     * @param {*} node 
     * @param {*} zOrder 
     * @returns 
     */
     this.setLocalZOrder = function(node, zOrder){
        if(!utilObj.isValid(node)){
            return;
        }
        if(zOrder == null || isNaN(zOrder)){
            return;
        }

        node.setLocalZOrder(zOrder);
    };
   /**
    * checks if the key is an own key of object
    * @param {*} obj 
    * @param {*} key 
    * @returns 
    */
    this.isOwnKeyOfObject = function(obj, key){
        if(!utilObj.isObject(obj)){
            return false;
        }
        return Object.prototype.hasOwnProperty.call(obj, key);
    };

    /**
     * logs object
     * @param {*} obj 
     */
    this.logObject = function (obj) {
        if (utilObj.isObject(obj)) {
            for (var key in obj) {
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    loggerObj.debugLog("arcadeSprint: timedHints: log2DMaps: obj[key] for key -> ", key, utilObj.getStringifiedJson(obj[key]));
                }
            }
        } else {
            loggerObj.debugLog("arcadeSprint: timedHints: logMap: obj -> ", utilObj.getStringifiedJson(obj));
        }
    };

    /**
     * returns formatted string for object
     * @param {*} obj 
     * @returns 
     */
    this.stringifiedObject = function(obj){
        var str = "";
        if (utilObj.isObject(obj)) {
            for (var key in obj) {
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    str += key + " " + utilObj.getStringifiedJson(obj[key]) + "\n";
                }
            }
        } else {
            str += utilObj.getStringifiedJson(obj);
        }
        return str;
    };

    /**
     * formates time in xh:ym:zs format
     * @param {*} s 
     * @returns 
     */
    this.formatTime1 = function (s) {
        if (s < 0) {
            return "00m:00s";
        }
        var hrs = parseInt(s / constantsObj.SECONDS_IN_HOUR);
        var hrsStr = "";
        if (hrs > 0) {
            s -= hrs * constantsObj.SECONDS_IN_HOUR;
            if (hrs < 10) {
                hrsStr = "0";
            }
            hrsStr += hrs + "h:";
        }
        var min = parseInt(s / constantsObj.SECONDS_IN_MIN);
        if (min < 10) {
            min = "0" + min;
        }
        var sec = s % constantsObj.SECONDS_IN_MIN;
        if (sec < 10) {
            sec = "0" + sec;
        }
        return hrsStr + min + "m:" + sec + "s";
    };

    /**
     * formats time in x hours / y minutes / z seconds format 
     * @param {*} s 
     * @returns 
     */
    this.formatTime2 = function(s){
        if (s < 0) {
            return "0 seconds";
        }
        var hrs = parseInt(s / constantsObj.SECONDS_IN_HOUR);
        if (hrs > 0) {
            s -= hrs * constantsObj.SECONDS_IN_HOUR;
            var hrStr = "hours";
            if(hrs == 1){
                hrStr = "hour";
            }
            return hrs + " " + hrStr;
        }
        var min = parseInt(s / constantsObj.SECONDS_IN_MIN);
        if(min > 0){
            var minStr = "minutes";
            if(min == 1){
                minStr = "minute";
            }
            return min + " " + minStr;
        }
        var sec = s % constantsObj.SECONDS_IN_MIN;
        return sec + " seconds";
    };

    /**
     * return time in mm:ss format
     * @param {*} s (time in seconds)
     * @returns 
     */
    this.formatTime3 = function (s) {
        if (s < 0) {
            return "00:00";
        }
        const minutes = Math.floor(s / 60);
        const remainingSeconds = s % 60;
        const formattedMinutes = (minutes < 10 ? '0' : '') + minutes;
        const formattedSeconds = (remainingSeconds < 10 ? '0' : '') + remainingSeconds;
        return formattedMinutes + ":" + formattedSeconds;
    };

    /**
     * sets the visibility of true for all the nodeArr elements
     * @param {*} nodeArr 
     */
     this.showAllNodes = function (nodeArr) {
         if (utilObj.isArray(nodeArr)) {
             var nodeCount = nodeArr.length;
             for (var i = 0; i < nodeCount; i++) {
                 utilObj.setVisible(nodeArr[i], true);
             }
         }
    };
    
    /**
     * sets the visibility of false for all the nodeArr elements
     * @param nodeArr
     */
    this.hideAllNodes = function (nodeArr) {
        if (utilObj.isArray(nodeArr)) {
            var nodeCount = nodeArr.length;
            for (var i = 0; i < nodeCount; i++) {
                utilObj.setVisible(nodeArr[i], false);
            }
        }
    };

    /**
    * wrapper function for parseInt
    * if str contains both characters and digits starting with digits, parseInt parses the first set of digits
    * e.g. parseInt("34d23") will return 34
    * defaultValue should always be valid 
    */
    this.convertToInt = function (str, defaultValue) {
        return (utilObj.isInt(parseInt(str)) ? parseInt(str) : defaultValue);
    };

    /**
     * returns the scaling factor to be used for background images of different resolutions 
     * @param {*} imageWidth 
     * @returns 
     */
    this.getBgScalingForDiffResolutionBgs = function (imageWidth) {
        var bgScaling = 1.25 * aspectRatio / constantsObj.ASPECT_NORMAL;
        if (aspectRatio < 1.78) {
            var scale = 1.78 / aspectRatio;
            bgScaling = scale * 1.25;
        }

        var scaleFactorBase = {
            width: 1152,
            height: 2048,
            scale: bgScaling
        };
        var imageScale = scaleFactorBase.width / imageWidth;
        var scaling = scaleFactorBase.scale * imageScale;
        return scaling;
    };

    /**
     * returns if the device aspect ratio is approx like 21:9
     * @return {boolean}
     */
    this.isDeviceLike21_9 = function () {
        return aspectRatio >= 2.25;
    };
};