package in.playsimple.common;

import android.util.Log;

import org.json.JSONObject;

import in.playsimple.Constants;

public class AdUnit {
    private int sequence; // This is the index of the adUnit in the various runtimes for the game.
    private String name;
    private int mopubAdType;
    private String adUnitId;
    private String trackP;
    private String trackG;
    private int psAdType;
    private String trackC; // This is not normally useful. Only in rare cases.

    private AdUnit() {
        // For creation of dummy ad units.
    }

    public AdUnit(int seq, String n, int mType, String id, String p, String g, int pType) {
        sequence = seq;
        name = n;
        mopubAdType = mType;
        adUnitId = id;
        trackP = p;
        trackG = g;
        psAdType = pType;
    }

    public int getSequence() { return sequence; }

    public String getName() { return name; }

    public int getMopubAdType() {
        return mopubAdType;
    }

    public int getPsAdType() {
        return psAdType;
    }

    public String getAdUnitId() {
        return adUnitId;
    }

    public String getTrackG() {
        return trackG;
    }

    public String getTrackP() {
        return trackP;
    }

    public String getTrackC() {
        return trackC;
    }

    public void setAdUnitId(String id) {
        adUnitId = id;
    }

    public void setTrackC(String c) {
        trackC = c;
    }

    public JSONObject getJSONObject() {
        JSONObject adUnitObj = new JSONObject();
        try {
            adUnitObj.put("sequence", sequence);
            adUnitObj.put("name", name);
            adUnitObj.put("mopubAdType", mopubAdType);
            adUnitObj.put("adUnitId", adUnitId);
            adUnitObj.put("trackP", trackP);
            adUnitObj.put("trackG", trackG);
            adUnitObj.put("psAdType", psAdType);
        } catch (Exception e) {

        }

        return adUnitObj;
    }

    public static AdUnit createFromJSONStr(String adUnitStr) {
        if (adUnitStr == null) {
            return new AdUnit();
        }
        try {
            JSONObject adUnitObj = new JSONObject(adUnitStr);
            int sequence = adUnitObj.getInt("sequence");
            String name = adUnitObj.getString("name");
            int mopubAdType = adUnitObj.getInt("mopubAdType");
            int psAdType = adUnitObj.getInt("psAdType");
            String adUnitId = adUnitObj.getString("adUnitId");
            String trackP = adUnitObj.getString("trackP");
            String trackG = adUnitObj.getString("trackG");
            String trackC = adUnitObj.getString("trackC");
            AdUnit adUnit = new AdUnit(sequence, name, mopubAdType, adUnitId, trackP, trackG, psAdType);
            adUnit.trackC = trackC;
            return adUnit;
        } catch (Exception e) {
            Log.e(Constants.TAG, "mopub log: Exception when parsing json string:" + e);
        }
        return new AdUnit();
    }
}
