package in.playsimple.common;

import android.app.Activity;
import android.util.Log;

import com.google.firebase.crashlytics.FirebaseCrashlytics;
import com.tapjoy.TJConnectListener;
import com.tapjoy.Tapjoy;
import com.tapjoy.TapjoyConnectFlag;

import java.util.Hashtable;

import in.playsimple.Constants;
import in.playsimple.GameSpecific;

public class Ads {
    private static Activity activity = null;

    private static TapjoyContent offerwall = null;
    public static String screen = "";

    public static void setActivity(Activity act) {
        activity = act;
    }

    public static void updateTapjoyCash(int amount) {
        GameSpecific.sendCallBack("adsObj.updateTapjoyCash", amount + "");
    }

    public static void loadTapjoyContent() {
        // TAPJOY_OFFERWALL_PLACEMENT_ID is generally set to "offerwall"
        offerwall = TapjoyContent.get(activity, Constants.TAPJOY_OFFERWALL_PLACEMENT_ID);
    }

    public static boolean hasTapjoyOfferWall() {
        if (offerwall != null && offerwall.isContentReady()) {
            return true;
        }
        return false;
    }


    public static void showTapjoyOfferWall() {
        Log.i(Constants.TAG, "Offerwall show attempt");
        if (hasTapjoyOfferWall()) {
            offerwall.showContent();
            String status = "view";
            String offerwallType = "Tapjoy";
            Analytics.offerwallEventFor(status, offerwallType);
        } else {
            Log.i(Constants.TAG, "Offerwall not available when attempting to show");
        }
    }

    public static void initializeTapjoy() {
        try {
            Hashtable<String, Object> connectFlags = new Hashtable<String, Object>();
            connectFlags.put(TapjoyConnectFlag.DISABLE_PERSISTENT_IDS, "true");
            Tapjoy.setDebugEnabled(false);
            Tapjoy.connect(activity.getApplicationContext(), Constants.TAPJOY_KEY,
                    connectFlags, new TJConnectListener() {

                        @Override
                        public void onConnectSuccess() {
                            // The SDK is now connected.
                            // We can start preloading our placements now that we are connected
                            Log.i(Constants.TAG, "Tapjoy connected successfully");
                            Ads.loadTapjoyContent();
                            TapjoyContent.checkTapjoyCash();
                        }

                        @Override
                        public void onConnectFailure() {
                            Log.i(Constants.TAG, "Tapjoy connection failure");
                        }
                    });

        } catch (Exception e) {
            Analytics.logException(e);
        }
    }

    public static void checkAndAddUserTagsForTapjoyOfferwall(String tag) {
        if (!Tapjoy.getUserTags().contains(tag)) {
            Tapjoy.clearUserTags();
            Tapjoy.addUserTag(tag);
            Log.d(Constants.TAG, "tapjoy user tags: clearing and setting tag: " + tag);
        }
    }

}
