package in.playsimple.common;

import android.content.Context;
import android.util.Log;

import com.android.volley.AuthFailureError;
import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;

import java.util.HashMap;
import java.util.Map;

import in.playsimple.Constants;
import in.playsimple.GameSpecific;


public class Controller {
    private String uri = null;
    private static Context context;

    public static void setContext(Context c) {
        context = c;
    }

    public Controller(String uri) {
        this.uri = uri;
    }

    public void sendHttpRequest(final String controller, final String action,
                                final HashMap<String, String> map) {
        try {
            RequestQueue queue = Volley.newRequestQueue(context);
            StringRequest sr = new StringRequest(Request.Method.POST, uri, new Response.Listener<String>() {
                @Override
                public void onResponse(String response) {
                    Log.i(Constants.TAG, "Controller:" + controller + ";Action:" + action + " success response" + response);
                    processResponse(response);
                }
            }, new Response.ErrorListener() {
                @Override
                public void onErrorResponse(VolleyError error) {
                    Log.i(Constants.TAG, "Controller:" + controller + ";Action:" + action + " error response:" + error.getMessage());
                }
            }) {
                @Override
                protected Map<String, String> getParams() {
                    return map;
                }

                @Override
                public Map<String, String> getHeaders() throws AuthFailureError {
                    Map<String, String> params = new HashMap<String, String>();
                    params.put("Content-Type", "application/x-www-form-urlencoded");
                    return params;
                }
            };
            queue.add(sr);

        } catch (Exception e) {
            Analytics.logException(e);
        }
    }

    public void processResponse(String response) {
        GameSpecific.processResponse(response);
    }
}

