package in.playsimple.common;

import android.content.Context;
import android.util.Log;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.HashMap;

import in.playsimple.Constants;
import in.playsimple.GameSpecific;

public class Experiment {
    private static Context context = null;
    private static Experiment experiment = null;
    private String chosenVariant = null;
    private String chosenExp = null;
    private static HashMap<String, String> map = new HashMap<String, String>();
    private Experiment() {
    }

    public static Experiment get() throws Exception {
        if (Experiment.context == null) {
            throw new Exception(
                    "Experiment context must be initialized before asking for Experiment object.");
        }
        if (Experiment.experiment == null) {
            experiment = new Experiment();
        }
        experiment.load(); // Reloading this just in case some data has been updated
        // from js
        return experiment;
    }

    public static void setContext(Context context) {
        Experiment.context = context;
    }

    private boolean load() {
        try {
            String expData = GameSpecific.loadFromLocalStorage(Constants.EXPERIMENTS_FILE);
            JSONObject expObj = new JSONObject(expData);
            JSONArray arr = expObj.getJSONArray("arr");

            for(int itr = 0; itr< arr.length();itr++){
                JSONObject obj = arr.getJSONObject(itr);
                map.put(obj.getString("expName"), obj.getString("chosenVariant"));
            }

        } catch (Exception e) {
            // Analytics.logException(e);
            Log.i(Constants.TAG, "No data for Experiment yet.");
            return false;
        }
        return true;
    }

    public static String getChosenVariant(String experimentName) {
        if (map.containsKey(experimentName)) {
            return map.get(experimentName);
        }
        return "0";
    }

    public static HashMap getExpMap(){
        return map;
    }
}
