package in.playsimple.common;

import android.app.Activity;
import android.net.Uri;
import android.os.Bundle;

import com.adjust.sdk.Adjust;
import com.adjust.sdk.AdjustConfig;
import com.adjust.sdk.OnDeeplinkResponseListener;

import in.playsimple.Constants;
import in.playsimple.GameSpecificApplication;
import in.playsimple.common.smaato.PSSmaato;

public class GameApplication extends GameSpecificApplication {
    @Override
    public void onCreate() {
        super.onCreate();
        PSSmaato.init(this);

        String environment = AdjustConfig.ENVIRONMENT_PRODUCTION;
        AdjustConfig config = new AdjustConfig(this, Constants.ADJUST_APP_TOKEN, environment);
        config.setAppSecret(Constants.ADJUST_SEC_0, Constants.ADJUST_SEC_1, Constants.ADJUST_SEC_2, Constants.ADJUST_SEC_3, Constants.ADJUST_SEC_4);
        config.setOnDeeplinkResponseListener(new OnDeeplinkResponseListener() {
            @Override
            public boolean launchReceivedDeeplink(Uri deeplink) {
                // don't launch deeplink activity in Deferred deep linking scenario
                return false;
            }
        });

        // Set session success tracking delegate.
        config.setOnSessionTrackingSucceededListener(sessionSuccessResponseData -> {
//          Log.d(Constants.TAG, "ADJUST:SESSION getting triggered:" + sessionSuccessResponseData.toString());
            Track.trackCounter(PSConstants.TRACK_ADJUST_DEBUG, PSConstants.TRACK_SESSION_SUCCESS, "" + sessionSuccessResponseData.message, "" + sessionSuccessResponseData.adid, "" + sessionSuccessResponseData.timestamp, "" + PSUtil.getCurrentTimestamp(), "", "0", "");
        });


        Adjust.onCreate(config);
        // config.setLogLevel(LogLevel.ERROR);

        registerActivityLifecycleCallbacks(new AdjustLifecycleCallbacks());
    }

    private static final class AdjustLifecycleCallbacks implements ActivityLifecycleCallbacks {
        @Override
        public void onActivityResumed(Activity activity) {
            Adjust.onResume();
        }

        @Override
        public void onActivityPaused(Activity activity) {
            Adjust.onPause();
        }

        @Override
        public void onActivityCreated(Activity activity, Bundle bundle) {

        }

        @Override
        public void onActivityStarted(Activity activity) {

        }

        @Override
        public void onActivityStopped(Activity activity) {

        }

        @Override
        public void onActivityDestroyed(Activity activity) {

        }

        @Override
        public void onActivitySaveInstanceState(Activity activity, Bundle bundle) {

        }
    }
}
