package in.playsimple.common;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.util.Log;

import com.adjust.sdk.AdjustReferrerReceiver;
import com.google.android.gms.analytics.CampaignTrackingReceiver;
import com.google.firebase.crashlytics.FirebaseCrashlytics;
import com.tapjoy.InstallReferrerReceiver;

import in.playsimple.Constants;

public class InstallReceiver extends BroadcastReceiver {
    @Override
    public void onReceive(Context context, Intent intent) {
        try {
            // Adjust
            new AdjustReferrerReceiver().onReceive(context, intent);
        } catch (Exception e) {
            Log.i(Constants.TAG, "Failed to send install tracking to Adjust");
            Analytics.logException(e);
        }

        try {
            // Google Analytics
            new CampaignTrackingReceiver().onReceive(context, intent);
        } catch (Exception e) {
            Log.i(Constants.TAG, "Failed to send install tracking to Google");
            Analytics.logException(e);
        }

        try {
            new InstallReferrerReceiver().onReceive(context, intent);
        } catch (Exception e) {
            Log.i(Constants.TAG, "Failed to send install tracking to Tapjoy");
            Analytics.logException(e);
        }
    }
}
