package in.playsimple.common;

import android.annotation.TargetApi;
import android.app.NotificationChannel;
import android.app.NotificationManager;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Build;
import android.util.Log;
import android.widget.RemoteViews;

import com.google.firebase.messaging.FirebaseMessagingService;
import com.google.firebase.messaging.RemoteMessage;

import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.LinkedList;
import java.util.List;

import androidx.annotation.RequiresApi;
import in.playsimple.Constants;
import in.playsimple.GameSpecific;

public class PSFirebaseMessagingService extends FirebaseMessagingService {

    public List<String> mURLs = new LinkedList<String>();
    public Bitmap firstImage = null;
    public Bitmap secImage = null;
    private NotificationManager mManager;

    public String title = "";
    public String message = "";
    public String notifType = "";
    public String deepLink = "";
    public String packageId = "";
    public String questName = "";
    public String questId = "";
    public String schedule_name = "";
    public String redirect = "";
    public Track track = null;
    public int showScreenVal = -1;
    public String showScreenQuestId = "";
    public String coinValue = "";
    public String timeStamp = "";

    @Override
    public void onMessageReceived(RemoteMessage remoteMessage) {
        super.onMessageReceived(remoteMessage);

        Log.d(Constants.TAG, "PushNotif Message received");
        Context context = getBaseContext();
        GameSpecific.setContext(context);

        this.mManager = (NotificationManager) getBaseContext().getSystemService(Context.NOTIFICATION_SERVICE);
        if (android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
            NotificationChannel mChannel = new NotificationChannel(Constants.NOTIFICATION_CHANNEL, GameSpecific.getPushNotifChannelName(), NotificationManager.IMPORTANCE_DEFAULT);

            this.mManager.createNotificationChannel(mChannel);
        }

        Log.d(Constants.TAG, "From: " + remoteMessage.getFrom());

        if (remoteMessage.getData().size() > 0) {
            Log.d(Constants.TAG, "Message data payload: " + remoteMessage.getData());
        }


        if (remoteMessage.getNotification() != null) {
            Log.d(Constants.TAG, "Message Notification Body: " + remoteMessage.getNotification().getBody());
        }

        boolean initSuccess = GameSpecific.initLocalStorage(context);
        Log.i(Constants.TAG, "Local storage init:" + initSuccess);

//        Game.setContext(context);
//        Controller.setContext(context);
//        Flags.setContext(context);
//        Util.setContext(context);
        Track.setContext(context);
        User.setContext(context);

        track = null;

        try {
            track = Track.get();
        } catch (Exception e) {
        }

        setTheRequestParameters(remoteMessage);

        String smallImage = remoteMessage.getData().get(PSConstants.SMALL_IMAGE);
        String bigImage = remoteMessage.getData().get(PSConstants.BIG_IMAGE);

        mURLs.add(bigImage);
        mURLs.add(smallImage);

        loadNextImage();

        try {
            if (notifType != null) { // Notif type would be null incase of notifications messages - https://firebase.google.com/docs/cloud-messaging/concept-options
//                if (notifType.equals(Constants.THEMED_QUEST_PUSH_ACTION)) {
//
//                } else if (notifType.equals(Constants.COIN_GRANT)) {
//                    Track.trackCounterImmediate(Constants.TRACK_PUSH, Constants.TRACK_SENT,
//                            schedule_name, Constants.COIN_GRANT, questId, questName, redirect, "", "");
//                    try {
//                        showScreenVal = 0;
//                        showScreenQuestId = deepLink + ":" + coinValue;
//                        Log.d(Constants.TAG, "The show screen quest id is" + deepLink + "  " + coinValue);
//
//                        String notifString;
//
//                        notifString = notifType + ":" + coinValue + ":" + deepLink + ":" + "true" + ":" + redirect;
//                        Log.d(Constants.TAG, "The notif string" + notifString);
//                        Util.setNotifString(notifString);
//                        Util.setPushNotifType(Constants.COIN_GRANT);
//
//                    } catch (Exception e) {
//                        e.printStackTrace();
//                    }
//                } else {
//                    Track.trackCounterImmediate(Constants.TRACK_PUSH, Constants.TRACK_SENT,
//                            schedule_name, Constants.CROSS_PROMO, questId, questName, redirect, "", "");
//                    try {
//                        showScreenVal = Constants.SCREEN_PUSH_NOTIF_SCREEN;
//                        showScreenQuestId = questId + ":" + deepLink + ":" + questName + ":" + schedule_name + ":" + redirect + ":" + title;
//                        String notifString;
//                        notifString = notifType + ":" + questId + ":" + deepLink + ":" + questName + ":" + schedule_name + ":" + redirect + ":" + title;
//                        Util.setNotifString(notifString);
//                        Util.setPushNotifType(Constants.CROSS_PROMO);
//                        Log.d(Constants.TAG, "The show screen quest id is " + showScreenQuestId);
//                    } catch (Exception e) {
//                        e.printStackTrace();
//                    }
//                }
            }
        } catch (Exception e) {
        }

        GameSpecific.handleFirebasePropertyNotif(remoteMessage);

        track.save();
        track.syncTracking();
    }

    public void loadNextImage() {
        if (mURLs.size() == 0) {
            return;
        }

        String url = mURLs.get(0);
        mURLs.remove(0);
        if (url != null) {
            ProcessImagesForPushNotif px = new ProcessImagesForPushNotif(getBaseContext());
            px.execute(url);
        }
    }

    @RequiresApi(api = Build.VERSION_CODES.JELLY_BEAN)
    public void triggerPushNotification(Context context) {

//        Intent intent = new Intent(context, AppActivity.class);
//        intent.putExtra("key_push_notif", "push_notif");
//
//        RemoteViews bigView = getTheRemoteView(context, GameSpecific.getPushNotifLayout(false), GameSpecific.getPushNotifImage(false), firstImage);
//
//        RemoteViews smallView = getTheRemoteView(context, GameSpecific.getPushNotifLayout(true), GameSpecific.getPushNotifImage(true), secImage);
//
//        PendingIntent pendingIntent = PendingIntent.getActivity(context, 100, intent, PendingIntent.FLAG_ONE_SHOT);
//
//        Notification.Builder builder = new Notification.Builder(context)
//                .setContentIntent(pendingIntent).setSmallIcon(GameSpecific.getPushNotifIcon()).setContent(smallView).setContentTitle(title).setContentText(message);
//        if (android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
//            builder.setChannelId(Constants.NOTIFICATION_CHANNEL);
//        }
//        Notification notif = builder.build();
//
//
//        notif.bigContentView = bigView;
//        notif.flags |= Notification.FLAG_AUTO_CANCEL;
//
//
//        Track.trackCounterImmediate(Constants.TRACK_PUSH, Constants.TRACK_SENT,
//                schedule_name, "", "", "", "", "", "");
//
//        /* Getting the shared preffs */
//        if (notifType.equals(Constants.COIN_GRANT)) {
//            SharedPreferences.Editor editor = getSharedPreferences(Constants.PREFS_PUSH_NOTIF, MODE_PRIVATE).edit();
//            editor.putBoolean(Constants.IS_PUSH_NOTIF, true);
//            editor.putString(Constants.DEEP_LINK, deepLink);
//            editor.putString(Constants.COIN_GRANT_STRING, coinValue);
//            editor.putString(Constants.REDIRECT, redirect);
//            editor.putString(Constants.NOTIF_TYPE, notifType);
//            editor.putString(Constants.NOTIF_ACTION_TYPE, "2");
//            editor.putString(Constants.SCHEDULE_NAME, schedule_name);
//            editor.putString(Constants.TIMESTAMP, timeStamp);
//            editor.apply();
//        } else {
//            SharedPreferences.Editor editor = getSharedPreferences(Constants.PREFS_PUSH_NOTIF, MODE_PRIVATE).edit();
//            editor.putBoolean(Constants.IS_PUSH_NOTIF, true);
//            editor.putString(Constants.QUEST_ID, questId);
//            editor.putString(Constants.REDIRECT, redirect);
//            editor.putString(Constants.SCHEDULE_NAME, schedule_name);
//            editor.putString(Constants.QUEST_NAME, questName);
//            editor.putString(Constants.DEEP_LINK, deepLink);
//            editor.putString(Constants.NOTIF_TYPE, notifType);
//            editor.putString(Constants.TITLE, title);
//            editor.putString(Constants.NOTIF_ACTION_TYPE, "1");
//            editor.putString(Constants.TIMESTAMP, timeStamp);
//            editor.apply();
//        }
//
//        mManager.notify(1, notif);
//
//        SharedPreferences.Editor editorFlag = getSharedPreferences(Constants.PREFS_PUSH_NOTIF_FLAG, MODE_PRIVATE).edit();
//        editorFlag.putInt("screen_val", showScreenVal);
//        editorFlag.putString("show_screen_quest_id", showScreenQuestId);
//        editorFlag.apply();
//
//        Log.d(Constants.TAG, "The screen val is " + showScreenQuestId + " " + showScreenVal);
    }


    public class ProcessImagesForPushNotif extends AsyncTask<String, Void, Bitmap> {
        Context context;

        public ProcessImagesForPushNotif(Context context) {
            super();
            this.context = context;
        }

        @Override
        protected Bitmap doInBackground(String... params) {

            Log.d(Constants.TAG, "Starting downloading of image for push notif 1");
            InputStream in;
            try {
                URL url = new URL(params[0]);
                HttpURLConnection connection = (HttpURLConnection) url.openConnection();
                connection.setDoInput(true);
                connection.connect();
                in = connection.getInputStream();
                Bitmap myBitmap = BitmapFactory.decodeStream(in);
                return myBitmap;
            } catch (MalformedURLException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }
            return null;
        }

        @TargetApi(Build.VERSION_CODES.JELLY_BEAN)
        @Override
        protected void onPostExecute(Bitmap result) {
            super.onPostExecute(result);

//
//            if (result == null) {
//                triggerTextNotif(context);
//                Track.trackCounterImmediate(Constants.TRACK_PUSH, Constants.TRACK_SENT,
//                        schedule_name, notifType, Constants.NO_IMAGE, "", "", "", "");
//                return;
//            }
//
//            if (mURLs.size() == 1) {
//                firstImage = result;
//                loadNextImage();
//            } else if (mURLs.size() == 0) {
//                secImage = result;
//                triggerPushNotification(context);
//            }
        }
    }

    @RequiresApi(api = Build.VERSION_CODES.JELLY_BEAN)
    public void triggerTextNotif(Context context) {

//        Intent intent = new Intent(context, AppActivity.class);
//        intent.putExtra("key_push_notif", "push_notif");
//
//        PendingIntent pendingIntent = PendingIntent.getActivity(context, 100, intent, PendingIntent.FLAG_ONE_SHOT);
//
//
//        Notification.Builder builder = new Notification.Builder(context)
//                .setContentIntent(pendingIntent).setSmallIcon(GameSpecific.getPushNotifIcon()).setContentTitle(title).setContentText(message);
//
//        if (android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
//            builder.setChannelId(Constants.NOTIFICATION_CHANNEL);
//        }
//
//        Notification notif = builder.build();
//        notif.flags |= Notification.FLAG_AUTO_CANCEL;
//
//
//        Track.trackCounter(Constants.TRACK_PUSH, Constants.TRACK_SENT,
//                notifType, schedule_name, "", "", "", "", "");
//
//
//        /* Getting the shared preffs */
//        if (notifType.equals(Constants.COIN_GRANT)) {
//            SharedPreferences.Editor editor = getSharedPreferences(Constants.PREFS_PUSH_NOTIF, MODE_PRIVATE).edit();
//            editor.putBoolean(Constants.IS_PUSH_NOTIF, true);
//            editor.putString(Constants.DEEP_LINK, deepLink);
//            editor.putString(Constants.COIN_GRANT_STRING, coinValue);
//            editor.putString(Constants.REDIRECT, redirect);
//            editor.putString(Constants.NOTIF_TYPE, notifType);
//            editor.putString(Constants.NOTIF_ACTION_TYPE, "2");
//            editor.putString(Constants.SCHEDULE_NAME, schedule_name);
//            editor.putString(Constants.TIMESTAMP, timeStamp);
//            editor.apply();
//        } else {
//            SharedPreferences.Editor editor = getSharedPreferences(Constants.PREFS_PUSH_NOTIF, MODE_PRIVATE).edit();
//            editor.putBoolean(Constants.IS_PUSH_NOTIF, true);
//            editor.putString(Constants.QUEST_ID, questId);
//            editor.putString(Constants.REDIRECT, redirect);
//            editor.putString(Constants.SCHEDULE_NAME, schedule_name);
//            editor.putString(Constants.QUEST_NAME, questName);
//            editor.putString(Constants.DEEP_LINK, deepLink);
//            editor.putString(Constants.NOTIF_TYPE, notifType);
//            editor.putString(Constants.TITLE, title);
//            editor.putString(Constants.NOTIF_ACTION_TYPE, "1");
//            editor.putString(Constants.TIMESTAMP, timeStamp);
//            editor.apply();
//        }
//
//        mManager.notify(1, notif);
//
//        SharedPreferences.Editor editorFlag = getSharedPreferences(Constants.PREFS_PUSH_NOTIF_FLAG, MODE_PRIVATE).edit();
//        editorFlag.putInt("screen_val", showScreenVal);
//        editorFlag.putString("show_screen_quest_id", showScreenQuestId);
//        editorFlag.apply();
//
//        Log.d(Constants.TAG, "The screen val is " + showScreenQuestId + " " + showScreenVal);
    }

    public RemoteViews getTheRemoteView(Context context, int layoutId, int id, Bitmap image) {
        RemoteViews view = new RemoteViews(context.getPackageName(),
                layoutId);
        view.setImageViewBitmap(id, image);
        return view;
    }

    public void setTheRequestParameters(RemoteMessage remoteMessage) {
//        title = remoteMessage.getData().get(Constants.TITLE);
//        message = remoteMessage.getData().get(Constants.BODY);
//        deepLink = remoteMessage.getData().get(Constants.DEEP_LINK);
//        notifType = remoteMessage.getData().get(Constants.NOTIF_TYPE);
//        packageId = remoteMessage.getData().get(Constants.PACKAGE_ID);
//        questName = remoteMessage.getData().get(Constants.QUEST_NAME);
//        questId = remoteMessage.getData().get(Constants.QUEST_ID);
//        schedule_name = remoteMessage.getData().get(Constants.SCHEDULE_NAME);
//        redirect = remoteMessage.getData().get(Constants.REDIRECT);
//        coinValue = remoteMessage.getData().get(Constants.COIN_GRANT_STRING);
//        timeStamp = remoteMessage.getData().get(Constants.TIMESTAMP);
    }


    @Override
    public void onDeletedMessages() {
        super.onDeletedMessages();
    }

    /**
     * Called if InstanceID token is updated. This may occur if the security of
     * the previous token had been compromised. Note that this is called when the InstanceID token
     * is initially generated so this is where you would retrieve the token.
     */
    @Override
    public void onNewToken(String token) {
        Log.d(Constants.TAG, "Refreshed token: " + token);

        // If you want to send messages to this application instance or
        // manage this apps subscriptions on the server side, send the
        // Instance ID token to your app server.
        GameSpecific.saveUpdatedFirebaseToken(token);
    }
    // [END on_new_token]
}
