package in.playsimple.common;

import android.content.Context;
import android.util.Log;

import org.json.JSONObject;

import in.playsimple.Constants;
import in.playsimple.GameSpecific;

public class PSRuntime {
    private static Context context = null;
    private static JSONObject rawRuntime = new JSONObject();

    public static void init(Context c) {
        setContext(c);
        load();
    }

    public static void setContext(Context c) {
        context = c;
    }

    public static boolean load() {
        try {
            String runtimeData = GameSpecific.loadFromLocalStorage(Constants.RUNTIME_CONFIG_FILE);
            Log.d(Constants.TAG, runtimeData);
            rawRuntime = new JSONObject(runtimeData);
        } catch (Exception e) {
            Log.i(Constants.TAG, "No data for PSRuntime yet.");
            return false;
        }
        return true;
    }

    public static String getRawRuntimeString(String key) {
        Log.d(Constants.TAG, "calling getRawRuntime PSRuntime" + key);
        String val = null;
        try {
            val = rawRuntime.getString(key);
            Log.d(Constants.TAG, "value getRawRuntime PSRuntime" + val);
        } catch (Exception e) {
            Analytics.logException(e);
        }

        return val;
    }

    public static int getRawRuntimeInt(String key) {
        Log.d(Constants.TAG, "calling getRawRuntime PSRuntime" + key);
        int val = 0;
        try {
            val = rawRuntime.getInt(key);
            Log.d(Constants.TAG, "value getRawRuntime PSRuntime" + val);
        } catch (Exception e) {
            Analytics.logException(e);
        }

        return val;
    }
}
