// package in.playsimple.common.bidmachine;

// import android.app.Activity;
// import android.util.Log;

// import com.mopub.common.MoPub;
// import com.mopub.common.privacy.PersonalInfoManager;
// import com.mopub.mobileads.BidMachineMediationSettings;
// import com.mopub.mobileads.BidMachineUtils;

// import java.util.HashMap;
// import java.util.Map;

// import androidx.annotation.NonNull;
// import in.playsimple.AdsGameSpecific;
// import in.playsimple.Constants;
// import in.playsimple.Track;
// import in.playsimple.Util;
// import in.playsimple.common.Experiment;
// import in.playsimple.common.PSConstants;
// import in.playsimple.common.PSUtil;
// import in.playsimple.common.mopub.PSMopubAds;
// import in.playsimple.common.mopub.PSMopubBanners;
// import in.playsimple.common.mopub.PSMopubInterstitials;
// import in.playsimple.common.mopub.PSMopubRewardedVideos;
// import io.bidmachine.AdRequest;
// import io.bidmachine.AdsFormat;
// import io.bidmachine.BidMachine;
// import io.bidmachine.BidMachineFetcher;
// import io.bidmachine.ads.networks.AmazonConfig;
// import io.bidmachine.banner.BannerRequest;
// import io.bidmachine.banner.BannerSize;
// import io.bidmachine.interstitial.InterstitialRequest;
// import io.bidmachine.models.AuctionResult;
// import io.bidmachine.rewarded.RewardedRequest;
// import io.bidmachine.utils.BMError;

// public class PSBidMachine {
//     private static Activity activity;

//     private static double bidsRoundingThresholds[][];
//     private static double bidsRounding[][];
//     private static String defaultRounding = "20-1^40-2^100-5^0-10:7-0.1^0-0.2:20-1^40-2^100-5^150-10^0-25";

//     public static boolean isBidMachineEnabled() {
//         if (AdsGameSpecific.BID_MACHINE_EXP_ENABLED) {
//             return !Experiment.getChosenVariant(PSConstants.EXP_BID_MACHINE).equals("0");
//         }
//         return AdsGameSpecific.BID_MACHINE_ADS_ENABLED;
//     }

//     public static void init(Activity a) {
//         activity = a;

//         BidMachine.setTestMode(AdsGameSpecific.BIDMACHINE_TEST_MODE_ENABLED);
//         BidMachine.setLoggingEnabled(AdsGameSpecific.BIDMACHINE_LOGGING_ENABLED);
//         BidMachine.setSubjectToGDPR(true);
//         BidMachine.setCoppa(false);
//         if (AdsGameSpecific.isAmazonAdsEnabled()) {
//             BidMachine.registerNetworks(
//                     new AmazonConfig(AdsGameSpecific.AMAZON_APP_ID).withMediationConfig(AdsFormat.Banner_320x50, AdsGameSpecific.AMAZON_BANNER_PHONE_ID)
//                             .withMediationConfig(AdsFormat.Banner_728x90, AdsGameSpecific.AMAZON_BANNER_TABLET_ID)
//                             .withMediationConfig(AdsFormat.InterstitialStatic, AdsGameSpecific.AMAZON_INTERSTITIAL_ID)
//                             .withMediationConfig(AdsFormat.InterstitialVideo, AdsGameSpecific.AMAZON_VIDEO_ID));
//         }

//         PSBidMachine.updateRoundingConfig();
//         BidMachine.initialize(activity, AdsGameSpecific.BID_MACHINE_SELLER_ID);
//     }

//     public static void grantConsent() {
//         if (!PSBidMachine.isBidMachineEnabled()) {
//             return;
//         }
//         Log.i(Constants.TAG, "mopub log: grantBidMachine consent called");
//         PersonalInfoManager infoManager = MoPub.getPersonalInformationManager();
//         if (infoManager != null && infoManager.gdprApplies()) {
//             Log.d(Constants.TAG, "mopub log: grantBidMachine consent gdpr applies");
//             BidMachine.setSubjectToGDPR(true);
//             BidMachine.setConsentConfig(true, MoPub.getPersonalInformationManager().getConsentData().getConsentedVendorListIabFormat());
//         } else {
//             BidMachine.setSubjectToGDPR(false);
//         }
//     }

//     public static Map<String, String> getBidMachineConfiguration() {
//         // Reference doc: https://wiki.appodeal.com/display/BID/BidMachine+Android+SDK+Documentation
//         // Prepare configuration map for BidMachineAdapterConfiguration
//         Map<String, String> configuration = new HashMap<>();
//         // configuration.put("seller_id", Constants.BID_MACHINE_SELLER_ID);
//         // configuration.put("coppa", "true");
//         // configuration.put("logging_enabled", "true");
//         // configuration.put("test_mode", "true");

//         return configuration;
//     }

//     public static void getBannerBids(boolean shouldLoad) {
//         BannerSize size = BannerSize.Size_320x50;
//         if (PSUtil.isTablet()) {
//             size = BannerSize.Size_728x90;
//         }
//         BannerRequest bannerRequest = new BannerRequest.Builder()
//                 .setSize(size)
//                 .setListener(new AdRequest.AdRequestListener<BannerRequest>() {
//                     @Override
//                     public void onRequestSuccess(@NonNull BannerRequest bannerRequest,
//                                                  @NonNull AuctionResult auctionResult) {
//                         // Log.i(Constants.TAG, "mopub log: banner: BidMachine: result received from request - demandSource:" + auctionResult.getDemandSource() + " - adDomains:" + auctionResult.getAdDomains().length + " - Cid:" + auctionResult.getCid() + " - CreativeId:"+ auctionResult.getCreativeId() + " - Id:" + auctionResult.getId() + " - Seat:" + auctionResult.getSeat() + " - Price:" + auctionResult.getPrice());
//                         Log.i(Constants.TAG, "mopub log: banner: BidMachine: request success");
//                         PSBidMachine.roundBids(PSMopubAds.MOPUB_AD_TYPE_BANNER, auctionResult.getPrice());
//                         // Fetch BidMachine Ads params
//                         Map<String, String> fetchParams = BidMachineFetcher.fetch(bannerRequest);
//                         if (fetchParams != null) {
//                             trackSuccessResponse(PSConstants.TRACK_BANNER, PSConstants.TRACK_RESPONSE, auctionResult.getDemandSource(), auctionResult.getPrice() + "", auctionResult.getSeat());
//                             trackSuccessResponse(PSConstants.TRACK_BANNER, PSConstants.TRACK_ROUNDED, auctionResult.getDemandSource(), fetchParams.get("bm_pf") + "", auctionResult.getSeat());
//                             //Prepare MoPub keywords
//                             String keywords = BidMachineUtils.toMoPubKeywords(fetchParams);
//                             PSMopubBanners.setKeywords(keywords);
//                             Map<String, Object> localExtras = new HashMap<>(fetchParams);
//                             //Set MoPub local extras
//                             PSMopubBanners.setLocalExtras(localExtras);
//                             checkAndLoadBanner(shouldLoad);
//                         } else {
//                             trackAction(PSConstants.TRACK_BANNER, PSConstants.TRACK_ERROR);
//                             //Params fetching failed
//                             Log.i(Constants.TAG, "mopub log: banner: BidMachine: params fetching failed");
//                             checkAndLoadBanner(shouldLoad);
//                         }
//                     }

//                     @Override
//                     public void onRequestFailed(@NonNull BannerRequest bannerRequest,
//                                                 @NonNull BMError bmError) {
//                         trackAction(PSConstants.TRACK_BANNER, PSConstants.TRACK_FAIL);
//                         //Request failed, additional info can be found in "bmError" object
//                         Log.i(Constants.TAG, "mopub log: banner: BidMachine: request failed - " + bmError.getMessage());
//                         checkAndLoadBanner(shouldLoad);
//                     }

//                     @Override
//                     public void onRequestExpired(@NonNull BannerRequest bannerRequest) {
//                         //ignore
//                         Log.i(Constants.TAG, "mopub log: banner: BidMachine: request expired - " + bannerRequest.toString());
//                         trackAction(PSConstants.TRACK_BANNER, PSConstants.TRACK_EXPIRED);
//                     }
//                 })
//                 .build();

//         //Request BidMachine Ads without loading it
//         Log.i(Constants.TAG, "mopub log: banner: BidMachine: making banner request" + bannerRequest.toString());
//         bannerRequest.request(activity);
//         trackAction(PSConstants.TRACK_BANNER, PSConstants.TRACK_REQUEST);
//     }

//     private static void checkAndLoadBanner(boolean shouldLoad) {
//         if (!shouldLoad) {
//             return;
//         }
//         PSMopubBanners.load();
//     }

//     public static void getInterstitialBids(int psAdType) {
//         //Create new BidMachine request
//         InterstitialRequest interstitialRequest = new InterstitialRequest.Builder()
//         .setListener(new AdRequest.AdRequestListener<InterstitialRequest>() {
//             @Override
//             public void onRequestSuccess(@NonNull InterstitialRequest interstitialRequest,
//                                          @NonNull AuctionResult auctionResult) {
//                 Log.i(Constants.TAG, "mopub log: interstitial: BidMachine: request success");
//                 PSBidMachine.roundBids(PSMopubAds.MOPUB_AD_TYPE_INTERSTITIAL, auctionResult.getPrice());
//                 // Fetch BidMachine Ads params
//                 Map<String, String> fetchParams = BidMachineFetcher.fetch(interstitialRequest);
//                 if (fetchParams != null) {
//                     trackSuccessResponse(PSConstants.TRACK_INTERSTITIAL, PSConstants.TRACK_RESPONSE, auctionResult.getDemandSource(), auctionResult.getPrice() + "", auctionResult.getSeat());
//                     trackSuccessResponse(PSConstants.TRACK_INTERSTITIAL, PSConstants.TRACK_ROUNDED, auctionResult.getDemandSource(), fetchParams.get("bm_pf") + "", auctionResult.getSeat());
//                     //Prepare MoPub keywords
//                     String keywords = BidMachineUtils.toMoPubKeywords(fetchParams);
//                     PSMopubInterstitials.setKeywords(keywords);
//                     Map<String, Object> localExtras = new HashMap<>(fetchParams);
//                     //Set MoPub local extras
//                     PSMopubInterstitials.setLocalExtras(localExtras);
//                     PSMopubInterstitials.load(psAdType);
//                 } else {
//                     trackAction(PSConstants.TRACK_INTERSTITIAL, PSConstants.TRACK_ERROR);
//                     //Params fetching failed
//                     PSMopubInterstitials.load(psAdType);
//                 }
//             }

//             @Override
//             public void onRequestFailed(@NonNull InterstitialRequest interstitialRequest,
//                                         @NonNull BMError bmError) {
//                 trackAction(PSConstants.TRACK_INTERSTITIAL, PSConstants.TRACK_FAIL);
//                 //Request failed, additional info can be found in "bmError" object
//                 Log.i(Constants.TAG, "mopub log: interstitial: BidMachine: request failed - " + bmError.getMessage());
//                 PSMopubInterstitials.load(psAdType);
//             }

//             @Override
//             public void onRequestExpired(@NonNull InterstitialRequest interstitialRequest) {
//                 //ignore
//                 Log.i(Constants.TAG, "mopub log: interstitial: BidMachine: request expired - " + interstitialRequest.toString());
//                 trackAction(PSConstants.TRACK_INTERSTITIAL, PSConstants.TRACK_EXPIRED);
//             }
//         })
//                 .build();

//         //Request BidMachine Ads without loading it
//         interstitialRequest.request(activity);
//         trackAction(PSConstants.TRACK_INTERSTITIAL, PSConstants.TRACK_REQUEST);
//     }

//     public static void getRewardedBids(int psAdType) {
//         //Create new BidMachine request
//         RewardedRequest request = new RewardedRequest.Builder()
//         .setListener(new AdRequest.AdRequestListener<RewardedRequest>() {
//             @Override
//             public void onRequestSuccess(@NonNull RewardedRequest rewardedRequest,
//                                          @NonNull AuctionResult auctionResult) {
//                 Log.i(Constants.TAG, "mopub log: video: BidMachine: request success");
//                 PSBidMachine.roundBids(PSMopubAds.MOPUB_AD_TYPE_REWARDED, auctionResult.getPrice());
//                 //Fetch BidMachine Ads params
//                 Map<String, String> fetchParams = BidMachineFetcher.fetch(rewardedRequest);
//                 if (fetchParams != null) {
//                     //Prepare MoPub keywords
//                     trackSuccessResponse(PSConstants.TRACK_W2E, PSConstants.TRACK_RESPONSE, auctionResult.getDemandSource(), auctionResult.getPrice() + "", auctionResult.getSeat());
//                     trackSuccessResponse(PSConstants.TRACK_W2E, PSConstants.TRACK_ROUNDED, auctionResult.getDemandSource(), fetchParams.get("bm_pf") + "", auctionResult.getSeat());
//                     String keywords = BidMachineUtils.toMoPubKeywords(fetchParams);
//                     PSMopubRewardedVideos.setKeywords(keywords);
//                     PSMopubRewardedVideos.setMediationSettings(new BidMachineMediationSettings(fetchParams));
//                     PSMopubRewardedVideos.load(psAdType);
//                 } else {
//                     //Params fetching failed
//                     trackAction(PSConstants.TRACK_W2E, PSConstants.TRACK_ERROR);
//                     PSMopubRewardedVideos.load(psAdType);
//                 }
//             }

//             @Override
//             public void onRequestFailed(@NonNull RewardedRequest rewardedRequest,
//                                         @NonNull BMError bmError) {
//                 trackAction(PSConstants.TRACK_W2E, PSConstants.TRACK_FAIL);
//                 //Request failed, additional info can be found in "bmError" object
//                 Log.i(Constants.TAG, "mopub log: video: BidMachine: request failed - " + bmError.getMessage());
//                 PSMopubRewardedVideos.load(psAdType);
//             }

//             @Override
//             public void onRequestExpired(@NonNull RewardedRequest rewardedRequest) {
//                 //ignore
//                 Log.i(Constants.TAG, "mopub log: video: BidMachine: request expired - " + rewardedRequest.toString());
//                 trackAction(PSConstants.TRACK_W2E, PSConstants.TRACK_EXPIRED);
//             }
//         })
//                 .build();

//         //Request BidMachine Ads without load it
//         request.request(activity);
//         trackAction(PSConstants.TRACK_W2E, PSConstants.TRACK_REQUEST);
//     }

//     private static void trackAction(String p, String c) {
//         Track.trackCounter(PSConstants.TRACK_AD_TRACKING, p, c, PSMopubAds.screen, Util.isOnline() + "", PSConstants.TRACK_BIDMACHINE, "", "", "");
//     }

//     private static void trackSuccessResponse(String p, String c, String o, String f, String s) {
//         Log.i(Constants.TAG, "mopub log: BidMachine success:" + p + " - " + c + " - " + o + " - " + f + " - " + s);
//         Track.trackCounter(PSConstants.TRACK_AD_TRACKING, p, c, o, f, PSConstants.TRACK_BIDMACHINE, s, "", "");
//     }

//     public static void updateRoundingConfig() {
//         String roundingRuntime = AdsGameSpecific.getBidMachineRounding();
//         if (roundingRuntime == null) {
//             roundingRuntime = PSBidMachine.defaultRounding;
//         }

//         String adTypeConfig[] = roundingRuntime.split(":");
//         bidsRounding = new double[adTypeConfig.length][];
//         bidsRoundingThresholds = new double[adTypeConfig.length][];
//         for (int i = 0; i < adTypeConfig.length; i++) {
//             // Log.i(Constants.TAG, "mopub log: Bid rounding info - adType:" + adTypeConfig[i]);
//             String bidRoundingInfo[] = adTypeConfig[i].split("\\^");
//             bidsRounding[i] = new double[bidRoundingInfo.length];
//             bidsRoundingThresholds[i] = new double[bidRoundingInfo.length];
//             for (int j = 0; j < bidRoundingInfo.length; j++) {
//                 // Log.i(Constants.TAG, "mopub log: Bid rounding info:" + bidRoundingInfo[j]);
//                 String bidInfo[] = bidRoundingInfo[j].split("-");
//                 try {
//                     bidsRoundingThresholds[i][j] = Double.parseDouble(bidInfo[0]);
//                     bidsRounding[i][j] = Math.round(Double.parseDouble(bidInfo[1]) * 10) / 10.0;
//                     Log.i(Constants.TAG, "mopub log: Bid rounding - " + bidsRoundingThresholds[i][j] + " - " + bidsRounding[i][j]);
//                 } catch (Exception e) {
//                     Log.i(Constants.TAG, "mopub log: Bid rounding - Exception in rounding of bids - " + e.getMessage());
//                 }
//             }
//         }
//     }

//     public static void roundBids(int mopubAdType, double price) {
//         Log.i(Constants.TAG, "mopub log: Bid rounding start - rounding for adType - " + mopubAdType + " - price - " + price);

//         int bidRoundingIndex = mopubAdType - 1;
//         boolean roundingDone = false;
//         for (int i = 0; i < bidsRoundingThresholds[bidRoundingIndex].length; i++) {
//             if (price < bidsRoundingThresholds[bidRoundingIndex][i]) {
//                 Log.i(Constants.TAG, "mopub log: Bid rounding - rounding for adType - " + mopubAdType + " - price - " + price + " - rounding - " + bidsRounding[bidRoundingIndex][i]);
//                 BidMachineFetcher.setPriceRounding(bidsRounding[bidRoundingIndex][i]);
//                 roundingDone = true;
//                 break;
//             }
//         }

//         if (!roundingDone) {
//             int numBids = bidsRounding[bidRoundingIndex].length;
//             BidMachineFetcher.setPriceRounding(bidsRounding[bidRoundingIndex][numBids - 1]);
//             Log.i(Constants.TAG, "mopub log: Bid rounding - rounding for adType - " + mopubAdType + " - price - " + price + " - rounding - " + bidsRounding[bidRoundingIndex][numBids - 1]);
//         }
//     }
// }
