package in.playsimple.common.flutter;

import android.util.Log;

import java.util.ArrayList;
import java.util.List;

import in.playsimple.Constants;
import in.playsimple.GameSpecific;
import in.playsimple.PSPNGameSpecific;
import in.playsimple.common.PSUtil;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;

public class PSPNFlutterBridge {

    public static boolean handleDartCall(MethodCall call, MethodChannel.Result result) {
        boolean success = true;
        String method = call.method;
        switch (method) {
            case "onPspnModuleInteracted":
                String m = call.argument("method");
                String args = call.argument("args");
                GameSpecific.sendCallBack(m, args);
                result.success(null);
                break;
            case "gettingSharedData":
                String androidBundleIds = call.argument("androidBundleIds");
                String androidGameIds = call.argument("androidGameIds");
                PSPNGameSpecific.gettingSharedData(androidBundleIds, androidGameIds);
                result.success(null);
                break;
            case "shareDataBetweenGames":
                String allGamesData = call.argument("allGamesData");
                String crossGameProgress = call.argument("crossGameProgress");
                PSPNGameSpecific.shareDataBetweenGames(allGamesData, crossGameProgress);
                result.success(null);
                break;
            case "getInstalledApps":
                String bundleIds = call.argument("bundleIds");
                String[] bundles = bundleIds.split(",", -1);
                String gameIds = call.argument("gameIds");
                String[] games = gameIds.split(",", -1);

                List<String> installedIds = new ArrayList<>();
                for (int index = 0; index < bundles.length; index++) {
                    if (PSUtil.isAppInstalled(bundles[index])) {
                        installedIds.add(games[index]);
                    }
                }
                result.success(installedIds);
                break;
            case "updateQuestNotifs":
                int arg1 = call.argument("dailyQuestUnlockTime");
                boolean arg2 = call.argument("shouldShowDailyQuestNotif");
                boolean arg3 = call.argument("isDailyQuestCompleted");
                // NOTE: If this method is not implemented on your code base, define this method in PSPNGameSpecific.java with empty body
                PSPNGameSpecific.saveNotifData(arg1, arg2, arg3);
                result.success(null);
                break;
            case "launchAnotherApp":
                String bundleId = call.argument("bundleId");
                PSUtil.launchAnotherGame(bundleId);
                result.success(null);
                break;
            default:
                success = false;
                break;
        }
        return success;
    }

}