package in.playsimple.common.smaato;

import android.app.Application;
import android.content.SharedPreferences;

import com.mopub.common.MoPub;
import com.mopub.common.privacy.PersonalInfoManager;
import com.smaato.sdk.core.SmaatoSdk;

import in.playsimple.Constants;
import in.playsimple.common.PSConstants;

import static android.content.Context.MODE_PRIVATE;

public class PSSmaato {
    private static Application application = null;

    public static void init(Application a) {
        if (!Constants.SMAATO_ADS_ENABLED) {
            return;
        }
        application = a;

        final SharedPreferences prefs = application.getSharedPreferences(PSConstants.PREFS_SMAATO_CONSENT, MODE_PRIVATE);
        prefs.edit()
                .putBoolean(PSConstants.PREFS_SMAATO_CONSENT_PRESENT_KEY, true)
                .putString(PSConstants.PREFS_SMAATO_GDPR_APPLICABLE_KEY, "0")
                .apply();

//        Config configSmaato = Config.builder()
//                .setLogLevel(LogLevel.DEBUG).setHttpsOnly(false).build();
        SmaatoSdk.init(application, Constants.SMAATO_PUBLISHER_KEY);

    }

    public static void grantConsent() {
        if (!Constants.SMAATO_ADS_ENABLED) {
            return;
        }
        PersonalInfoManager mPersonalInfoManager = MoPub.getPersonalInformationManager();
        SharedPreferences prefs = application.getSharedPreferences(PSConstants.PREFS_SMAATO_CONSENT, MODE_PRIVATE);
        if (!MoPub.canCollectPersonalInformation()) {
            prefs.edit()
                    .putString(PSConstants.PREFS_SMAATO_GDPR_APPLICABLE_KEY, "1")
                    .apply();
            if (mPersonalInfoManager.shouldShowConsentDialog()) {
                mPersonalInfoManager.grantConsent();
            }
        } else {
            prefs.edit()
                    .putString(PSConstants.PREFS_SMAATO_GDPR_APPLICABLE_KEY, "0")
                    .apply();
        }
    }

    public static void revokeConsent() {
        if (!Constants.SMAATO_ADS_ENABLED) {
            return;
        }
        PersonalInfoManager mPersonalInfoManager = MoPub.getPersonalInformationManager();
        SharedPreferences prefs = application.getSharedPreferences(PSConstants.PREFS_SMAATO_CONSENT, MODE_PRIVATE);
        if (!MoPub.canCollectPersonalInformation()) {
            prefs.edit()
                    .putString(PSConstants.PREFS_SMAATO_GDPR_APPLICABLE_KEY, "1")
                    .apply();
        } else {
            prefs.edit()
                    .putString(PSConstants.PREFS_SMAATO_GDPR_APPLICABLE_KEY, "0")
                    .apply();
        }
    }
}
