//
//  AdUnit.m
//

#import "AdUnit.h"

@implementation AdUnit

//- (instancetype)initAdUnit {
//    return self;
//}

- (instancetype)initAdUnit:seq name:(NSString *)name mType:(int)mType unitId:(NSString *)unitId p:(NSString *)p g:(NSString *)g pType:(int)pType {
    self = [super init];
    if (self) {
        _sequence = seq;
        _name = name;
        _mopubAdType = mType;
        _adUnitId = unitId;
        _trackP = p;
        _trackG = g;
        _psAdType = pType;
    }
    return self;
}

- (NSDictionary*) getJSONObject {
    NSLog(@"mopub log: getJSONObject - alloc begins");
    NSDictionary* jsonObject = @{
        @"sequence":[NSNumber numberWithInt:_sequence],
        @"name":_name,
        @"mopubAdType":[NSNumber numberWithInt:_mopubAdType],
        @"adUnitId":_adUnitId,
        @"trackP":_trackP,
        @"trackG":_trackG,
        @"psAdType":[NSNumber numberWithInt:_psAdType],
    };
    return jsonObject;
}

+ (AdUnit*) createFromJsonStr:(NSString*)adUnitStr {
    AdUnit* adUnit = [AdUnit alloc];
    if (adUnitStr == nil) {
        return adUnit;
    }
    NSData *jsonData = [adUnitStr dataUsingEncoding:NSUTF8StringEncoding];
    NSMutableDictionary* jsonObject = [NSJSONSerialization JSONObjectWithData:jsonData options:NSJSONReadingMutableContainers error:nil];
    @try {
        int sequence = [[jsonObject objectForKey:@"sequence"] intValue];
        NSString* name = [[NSString alloc] initWithString:[jsonObject objectForKey:@"name"]];
        int mopubAdType = [[jsonObject objectForKey:@"mopubAdType"] intValue];
        int psAdType = [[jsonObject objectForKey:@"psAdType"] intValue];
        NSString* adUnitId = [[NSString alloc] initWithString:[jsonObject objectForKey:@"adUnitId"]];
        NSString* trackP = [[NSString alloc] initWithString:[jsonObject objectForKey:@"trackP"]];
        NSString* trackG = [[NSString alloc] initWithString:[jsonObject objectForKey:@"trackG"]];
        NSString* trackC = [[NSString alloc] initWithString:[jsonObject objectForKey:@"trackC"]];
        adUnit = [[AdUnit alloc] initAdUnit:sequence name:name mType:mopubAdType unitId:adUnitId p:trackP g:trackG pType:psAdType];
        adUnit.trackC = trackC;
        
        NSLog(@"mopub log: createFromJsonStr: Original - %@, Converted - %d %@ %d %d %@ %@ %@ %@", adUnitStr, sequence, name, mopubAdType, psAdType, adUnitId, trackP, trackG, trackC);
        return adUnit;
    } @catch (NSException *exception) {
        NSLog(@"mopub log: Exception when createFromJsonStr:%@ %@", adUnitStr, exception);
    }
    return adUnit;
}

@end
