#ifndef Analytics_h
#define Analytics_h

@interface Analytics : NSObject

+ (void) trackPurchaseWithTransaction:(NSString*) title
                               price:(NSString*)price
                        currencyCode:(NSString*)currencyCode
                                 sku:(NSString*)sku
                           receiptId:(NSString*) receiptId
                       transactionId:(NSString*) transactionId
                             pkgType:(NSString*)pkgType;
+ (void) trackPurchaseFailure:(NSString*)price
                    currency:(NSString*)currency
                    itemName:(NSString*)itemName
                    itemType:(NSString*)itemType
                      itemId:(NSString*)itemId
                      errMsg:(NSString*)errMsg
                     errCode:(NSString*)errCode;
+ (void) purchaseBegin:(NSString*)price
             currency:(NSString*)currency
             itemName:(NSString*)itemName
             itemType:(NSString*)itemType
               itemId:(NSString*)itemId;
+ (void) updateVirtualCurrency:(NSString*)item val:(NSString*)val trackClass:(NSString*)trackClass order:(NSString*)order;
+ (void) share:(NSString*)method name:(NSString*)name type:(NSString*)type sid:(NSString*)sid;
+ (void) login:(NSString*)method screen:(NSString*)screen success:(NSString*)success;
+ (void) invite:(NSString*)method screen:(NSString*)screen count:(NSString*)count;
+ (void) levelStart:(NSString*)level bucket:(NSString*)bucket puzId:(NSString*)puzId;
+ (void) levelEnd:(NSString*)level bucket:(NSString*)bucket puzId:(NSString*)puzId score:(NSString*)score success:(bool)success;
+ (void) customEvent:(NSString*)track;
+ (void) triggerProductViewsScreen;
+ (void) triggerCustomEvent:(NSString*) eventName;
+ (void) screenView:(NSString*) screenName;
+ (void) rating:(NSNumber*)rating name:(NSString*)name;
+ (void) signUp:(NSString*)method success:(boolean_t)success;

+ (void) trackNoRefid:(NSString *)state eventType:(NSString*)eventType restSync:(NSString*)restSync wbSync:(NSString*)wbSync respCount:(NSString*)respCount respSuccess:(NSString*)respSuccess connSucc:(NSString*)connSucc connError:(NSString*)connError;
+ (void) installEvent:(NSString*) refid syncId:(NSString*) syncId;
+ (void) incentLevelComplete:(NSString*) refid duration:(NSString*)duration;
+ (void) triggerAdjustCustomEvent:(NSString*) refid eventName:(NSString*)eventName duration:(NSString*)duration;
+ (void) triggerAdjustEvent:(NSString*) refid eventName:(NSString*)eventName duration:(NSString*)duration;
+ (void) triggerAdsAdjustEvents:(NSString*) eventName;
+ (void) syncFabricEvent:(NSString *)eventName status:(NSString*)status;
+ (void) sendFirebaseCustomEvent:(NSString*)eventName refId:(NSString*)refId;
+ (void) sendReport:(NSString*) msg;
+ (void) setUserId:(NSString*) refId;
+ (void) setDeviceInfo:(NSString *)cpuArch deviceWidth:(NSString*)deviceWidth deviceHeight:(NSString*)deviceHeight deviceModel:(NSString*)deviceModel deviceId:(NSString*)deviceId country:(NSString*)country isOnline:(NSString*)isOnline;

@end


#endif /* Analytics_h */
