//
//  Experiment.m
//  Word Trip
//
//  Created by HarshGarg on 10/01/19.
//

#import <Foundation/Foundation.h>
#import "Experiment.h"
#import "Util.h"

@implementation Experiment
Experiment *experiment;
NSMutableDictionary *expDict;

+(Experiment*) get{
    if(experiment==nil){
        experiment=[[Experiment alloc] init];
        [experiment load];
    }
    return experiment;
}

-(id) init;{
    database = [SqliteHelper get:READONLY];
    return self;
}

-(void) load;
{
    @try {
        NSString *exp = EXPERIMENTS_FILE;
        NSString *exp_data = [database getData:exp];
        expDict = [[NSMutableDictionary alloc]initWithCapacity:10000];
        if(exp_data){
            NSError *e = nil;
            NSDictionary *epmObj = [Util stringToJson:exp_data];
            if(e){
                ENError(@"No data for user yet %@", e.description);
                return;
            }
//            for(NSString *key in [epmObj allKeys]) {
//                NSLog(@"%@ this is experi %@", key, [epmObj objectForKey:key]);
//            }
            
            NSArray *jsonArr = [epmObj objectForKey:@"arr"];
            NSMutableArray * mainArray = [[NSMutableArray alloc] initWithArray:jsonArr];
            
            for (int i = 0; i<mainArray.count; i++) {
                NSDictionary *BatchDict = [mainArray objectAtIndex:i];
                
                NSString * exp = [BatchDict objectForKey:@"expName"];
                NSString * var = [BatchDict objectForKey:@"chosenVariant"];
                [expDict setObject:var forKey:exp];
            }
            for(NSString *key in [expDict allKeys]) {
                NSLog(@" this is experi %@ %@", key, [expDict objectForKey:key]);
            }
        }
    }
    @catch (NSException *exception) {
        ENError(@"%@", [exception description]);
    }
}

+(NSString*) getChosenVariant:(NSString*)expName {
    return [expDict objectForKey:expName];
}

@end
