#import <Foundation/Foundation.h>

#import "FacebookWrapper.h"
#import "SqliteHelper.h"
#import "Util.h"
#import "PSUtil.h"

@implementation FacebookWrapper

FacebookWrapper* facebookObj;

NSString* PUBLISH_ACTIONS = @"publish_actions";
NSString* CALLBACK_FUNCTION = @"fbWrapperObj.jsbCallBack";

NSString* ACCESS_TOKEN = @"accessToken";
NSString* GRANTED_PERMISSIONS = @"permissions";
NSString* SUCCESS = @"success";
NSString* REQ_ID = @"request";
NSString* API_ID = @"apiId";

NSString* TYPE = @"type";
NSString* TYPE_LOGIN = @"login";
NSString* TYPE_API = @"api";
NSString* TYPE_LOGOUT = @"logout";
NSString* TYPE_LINK_SHARE = @"linkShare";
NSString* TYPE_APP_REQUEST = @"appRequest";
NSString* TOAST_MSG = @"toast";

NSString* KEY_POST_ID = @"postId";
NSString* KEY_ERROR = @"error";
NSString* KEY_REQ_ID = @"request";
NSString* KEY_TO = @"to";

// NSNumber* USER_INFO_API_ID = @8;

NSString* grantedPermissions = @"";

#define IX_SUCCESS 0
#define IX_CANCEL 1
#define IX_ERROR 2

+(FacebookWrapper*) sharedInstance {
    if (facebookObj == nil) {
        facebookObj = [[FacebookWrapper alloc] init];
//        facebookObj.loginMgr = [[FBSDKLoginManager alloc] init];
        [facebookObj loadFriendsDict];
    }
    return facebookObj;
}

int lastFBLogin = 0;

-(int) getLastFbLogin;{
    return lastFBLogin;
}

+(void) login:permsStr {
    if ([FacebookWrapper isFacebookLoggedIn]) {
        // [Util showMessage:@"You're already logged in to Facebook!"];
        return;
    }
    
    if (facebookObj == nil) {
        facebookObj = [FacebookWrapper sharedInstance];
    }
    
    NSArray* perms = [permsStr componentsSeparatedByString:@","];
    lastFBLogin = [Util getCurrentTimeStampSeconds];
//    [facebookObj.loginMgr logInWithPermissions:perms fromViewController:[Util getRootViewController] handler:^(FBSDKLoginManagerLoginResult *result, NSError *error) {
//        if (error) {
//            NSLog(@"Process error");
//            [FacebookWrapper sendLoginCallBack:nil code:IX_ERROR];
//        } else if (result.isCancelled) {
//            NSLog(@"Cancelled");
//            [FacebookWrapper sendLoginCallBack:nil code:IX_CANCEL];
//        } else {
//            NSSet* grantedPermissionsSet = result.grantedPermissions;
//            grantedPermissions = [[[grantedPermissionsSet allObjects] componentsJoinedByString:@","] copy];
//
//            [FacebookWrapper getUserInfo];
//        }
//
//    }];
    // if ([perms containsObject:PUBLISH_ACTIONS]) {
    //     lastFBLogin = [Util getCurrentTimeStampSeconds];
    //     [facebookObj.loginMgr logInWithPublishPermissions:perms fromViewController:[Util getRootViewController] handler:^(FBSDKLoginManagerLoginResult *result, NSError *error) {
    //         [FacebookWrapper sendLoginCallBack:result code:error];
    //     }];
    // } else {
    //     lastFBLogin = [Util getCurrentTimeStampSeconds];
    //     [facebookObj.loginMgr logInWithReadPermissions:perms fromViewController:[Util getRootViewController] handler:^(FBSDKLoginManagerLoginResult *result, NSError *error) {
    //         [FacebookWrapper sendLoginCallBack:result code:error];
    //     }];
    // }
}

+(void) sendLoginCallBack:(id)data code:(NSInteger*) code  {
    NSMutableDictionary* dict = [[NSMutableDictionary alloc] init];
    [dict setObject:TYPE_LOGIN forKey:TYPE];
    [dict setObject:[NSNumber numberWithInt:-1] forKey:SUCCESS];
    
    if (code != IX_ERROR && code != IX_CANCEL) {
        NSLog(@"Logged in");
        [dict setObject:[NSNumber numberWithInt:IX_SUCCESS] forKey:SUCCESS];
        
        if(grantedPermissions.length > 0){
            grantedPermissions = [grantedPermissions substringToIndex:(grantedPermissions.length - 1)];
        }
        [dict setObject:grantedPermissions forKey:GRANTED_PERMISSIONS];

        if ([data objectForKey:@"id"]) {
            [dict setObject:[data objectForKey:@"id"] forKey:@"id"];
        }
        if ([data objectForKey:@"name"]) {
            [dict setObject:[data objectForKey:@"name"] forKey:@"name"];
        }
        if ([data objectForKey:@"gender"]) {
            [dict setObject:[data objectForKey:@"gender"] forKey:@"gender"];
        }
        if ([data objectForKey:@"email"]) {
            [dict setObject:[data objectForKey:@"email"] forKey:@"email"];
        }
        if ([data objectForKey:@"token_for_business"]) {
            [dict setObject:[data objectForKey:@"token_for_business"] forKey:@"token_for_business"];
        }
    }
    
    NSString* msg = [Util JSONToString:dict];
    [Util sendJSCallBack:CALLBACK_FUNCTION msg:msg];
}

+(void) logout {
    if (facebookObj == nil) {
        facebookObj = [FacebookWrapper sharedInstance];
    }
//    [facebookObj.loginMgr logOut];
}

+(NSString*) getAccessToken {
    NSString* accessToken = @"";
    return accessToken;
//    FBSDKAccessToken* currentAccessToken = [FBSDKAccessToken currentAccessToken];
//    if ([FacebookWrapper isFacebookLoggedIn]) {
//        if ([currentAccessToken.expirationDate compare:[NSDate date]] != NSOrderedAscending) {
//            accessToken = currentAccessToken.tokenString;
//        } else {
//            [FBSDKAccessToken refreshCurrentAccessToken:^(FBSDKGraphRequestConnection *connection, id result, NSError *error) {
//                if (error != nil) {
//                    NSLog(@"error while refreshing access token");
//                }
//            }];
//        }
//    }
//    return accessToken;
}

+(bool) isFacebookLoggedIn {
    return false;
//    return [FBSDKAccessToken currentAccessToken] != nil;
}

+(void) getUserInfo {
    NSMutableDictionary* dict = [[NSMutableDictionary alloc] init];
    [dict setObject:@"id,name,email,gender,token_for_business" forKey:@"fields"];
    
    [FacebookWrapper onApiMain:@"/me" mode:@"GET" params:[PSUtil JSONToString:dict] apiId:@8];
}

+(void) onApiMain:(NSString*)graphPath mode:(NSString*) mode params:(NSString*)params apiId:(NSNumber*)apiId {
    
    NSDictionary* paramDict = [Util stringToJson:params];
    if (paramDict == NULL) {
        return;
    }
    
    
//    if ([FBSDKAccessToken currentAccessToken]) {
//        [[[FBSDKGraphRequest alloc] initWithGraphPath:graphPath
//                                           parameters:paramDict
//                                           HTTPMethod:mode]
//         startWithCompletionHandler:^(FBSDKGraphRequestConnection *connection, id result, NSError *error) {
//            if (error) {
//                [FacebookWrapper sendLoginCallBack:result code:IX_ERROR];
//            } else {
//                [FacebookWrapper sendLoginCallBack:result code:IX_SUCCESS];
//            }
//         }];
//    }
}

+(void) onApi:(NSString*)graphPath mode:(NSString*) mode params:(NSString*)params apiId:(NSNumber*)apiId {
    dispatch_async(dispatch_get_main_queue(), ^{
        NSDictionary* paramDict = [Util stringToJson:params];
        if (paramDict == NULL) {
            return;
        }
        
        if ([mode isEqualToString:@"POST"]) {
//            if (![[FBSDKAccessToken currentAccessToken] hasGranted:PUBLISH_ACTIONS]) {
//                [FacebookWrapper login:PUBLISH_ACTIONS];
//                return;
//            }
        }
        NSMutableString *msg =[NSMutableString stringWithFormat:@""];
        if([paramDict objectForKey:TOAST_MSG]){
            msg = [paramDict objectForKey:TOAST_MSG];
        }
        
        NSString *toastMsg = msg;
//        if ([FBSDKAccessToken currentAccessToken]) {
//            [[[FBSDKGraphRequest alloc] initWithGraphPath:graphPath
//                                               parameters:paramDict
//                                               HTTPMethod:mode]
//             startWithCompletionHandler:^(FBSDKGraphRequestConnection *connection, id result, NSError *error) {
//                 NSMutableDictionary* respDict = [NSMutableDictionary dictionaryWithDictionary:result];
//                 [respDict setObject:TYPE_API forKey:TYPE];
//                 [respDict setObject:apiId forKey:API_ID];
//                 [respDict setObject:toastMsg forKey:TOAST_MSG];
//                 [Util sendJSCallBack:CALLBACK_FUNCTION msg:[Util JSONToString:respDict]];
//             }];
//        }
    });
}

+(NSString*) getUserId {
    return @"";
//    return [[FBSDKAccessToken currentAccessToken] userID];
}

#pragma mark appRequests
+(void) appRequests:(NSString*)infoStr reqType:(NSString*)reqType {
    NSDictionary* info = [Util stringToJson:infoStr];
    
//    FBSDKGameRequestContent* content = [[FBSDKGameRequestContent alloc] init];
//    content.title = [info objectForKey:@"title"];
//    content.recipients = [[info objectForKey:@"to"] componentsSeparatedByString:@","];
//    content.message = [info objectForKey:@"message"];
    
    if (facebookObj == nil) {
        facebookObj = [FacebookWrapper sharedInstance];
    }
    //[FBSDKGameRequestDialog showWithContent:content delegate:facebookObj];
//    FBSDKGameRequestDialog *dialog = [[FBSDKGameRequestDialog alloc] init];
//    dialog.delegate = facebookObj;
//    if (![reqType isEqualToString:@"9"]) {
//        dialog.frictionlessRequestsEnabled = YES;
//    } else {
//        content.title = @"Invite Friends";
//    }
//    dialog.content = content;
//    [dialog show];
}

//- (void)gameRequestDialog:(FBSDKGameRequestDialog *)gameRequestDialog didCompleteWithResults:(NSDictionary *)results {
//    bool noFriends = false;
//    
//    @try {
//    NSMutableDictionary* dict = [[NSMutableDictionary alloc] init];
//    [dict setObject:TYPE_APP_REQUEST forKey:TYPE];
//    if (results == nil) {
//        if ([results count] > 0) {
//            [dict setObject:[results objectForKey:@"request"] forKey:KEY_REQ_ID];
//        }
//    }
//    [dict setObject:[NSNumber numberWithInt:IX_SUCCESS] forKey:SUCCESS];
//    [dict setObject:[results objectForKey:@"request"] forKey:KEY_REQ_ID];
//    
//    NSString* toStr = [[results objectForKey:@"to"] componentsJoinedByString:@","];
//    if (toStr.length > 0) {
//        [dict setObject:toStr forKey:KEY_TO];
//        [Util sendJSCallBack:CALLBACK_FUNCTION msg:[Util JSONToString:dict]];
//    } else {
//        noFriends = true;
//        [Util showMessage:@"You have not selected any friends. Please select a friend to continue."];
//    }
//    } @catch (NSException *exception) {
//        ENError(@"%@", [exception description]);
//        noFriends = true;
//        [Util showMessage:@"You have not selected any friends. Please select a friend to continue."];
//    }
//    
//}

//- (void)gameRequestDialog:(FBSDKGameRequestDialog *)gameRequestDialog didFailWithError:(NSError *)error {
//    NSMutableDictionary* dict = [[NSMutableDictionary alloc] init];
//    [dict setObject:TYPE_APP_REQUEST forKey:TYPE];
//    [dict setObject:[NSNumber numberWithInt:-2] forKey:KEY_REQ_ID];
//    [dict setObject:[NSNumber numberWithInt:IX_ERROR] forKey:SUCCESS];
//    [dict setObject:[error localizedDescription] forKey:KEY_ERROR];
//    [Util sendJSCallBack:CALLBACK_FUNCTION msg:[Util JSONToString:dict]];
//}

//- (void)gameRequestDialogDidCancel:(FBSDKGameRequestDialog *)gameRequestDialog {
//    NSMutableDictionary* dict = [[NSMutableDictionary alloc] init];
//    [dict setObject:TYPE_APP_REQUEST forKey:TYPE];
//    [dict setObject:[NSNumber numberWithInt:-2] forKey:KEY_REQ_ID];
//    [dict setObject:[NSNumber numberWithInt:IX_CANCEL] forKey:SUCCESS];
//    [Util sendJSCallBack:CALLBACK_FUNCTION msg:[Util JSONToString:dict]];
//}

#pragma mark shareLink
+(void) shareLink:(NSString*) contentStr {
    NSDictionary* dict = [Util stringToJson:contentStr];
    NSString* link = [dict objectForKey:@"link"];
    
//    FBSDKShareLinkContent *content = [[FBSDKShareLinkContent alloc] init];
//    content.contentURL = [NSURL URLWithString:link];
//
//    if (facebookObj == nil) {
//        facebookObj = [FacebookWrapper sharedInstance];
//    }
//
//    FBSDKShareDialog *dialog = [[FBSDKShareDialog alloc] init];
//    dialog.fromViewController = [Util getRootViewController];
//    dialog.shareContent = content;
//    dialog.delegate = facebookObj;
//
//    // needed to not let the native dialog show, native dialog does not let us add pictures or text from code
//    dialog.mode = FBSDKShareDialogModeNative;
//    NSSet *permissions = [[FBSDKAccessToken currentAccessToken] permissions];
//    if(false && permissions!=nil && [permissions containsObject:PUBLISH_ACTIONS]){
//        [FBSDKShareAPI shareWithContent:content delegate:facebookObj];
//    }else{
//        if (true || ![dialog canShow]) {
//            // fallback presentation when there is no FB app
//            dialog.mode = FBSDKShareDialogModeFeedBrowser;
//        }
//        [dialog show];
//    }
    
}

+(void) shareGivenLink:(NSString*) link {
//    FBSDKShareLinkContent *content = [[FBSDKShareLinkContent alloc] init];
//    content.contentURL = [NSURL URLWithString:link];
//
//    if (facebookObj == nil) {
//        facebookObj = [FacebookWrapper sharedInstance];
//    }
//
//    FBSDKShareDialog *dialog = [[FBSDKShareDialog alloc] init];
//    dialog.fromViewController = [Util getRootViewController];
//    dialog.shareContent = content;
//    dialog.delegate = facebookObj;
//
//    // needed to not let the native dialog show, native dialog does not let us add pictures or text from code
//    dialog.mode = FBSDKShareDialogModeNative;
//    NSSet *permissions = [[FBSDKAccessToken currentAccessToken] permissions];
//    if(false && permissions!=nil && [permissions containsObject:PUBLISH_ACTIONS]){
//        [FBSDKShareAPI shareWithContent:content delegate:facebookObj];
//    }else{
//        if (true || ![dialog canShow]) {
//            // fallback presentation when there is no FB app
//            dialog.mode = FBSDKShareDialogModeFeedBrowser;
//        }
//        [dialog show];
//    }
    
}

+(void) shareVideo:(NSString*) photoLink videoLink:(NSString*)videoLink {
//    NSLog(@"Attempting video share: %@ %@", photoLink, videoLink);
//    NSString *absPathPhoto = [Util getAbsPath:@"sharePhoto.png"];
//    NSString *absPathVideo = [Util getAbsPath:@"sampleVideo.mp4"];
//    NSLog(@"Does image exist: %@", absPathVideo);
//    FBSDKSharePhoto *photo = [FBSDKSharePhoto photoWithImageURL:[NSURL URLWithString:absPathPhoto] userGenerated:false];
//    FBSDKShareVideo *video = [FBSDKShareVideo videoWithVideoURL:[NSURL URLWithString:absPathVideo] previewPhoto:photo];
//
//    FBSDKShareMediaContent *content = [FBSDKShareMediaContent new];
//    content.media = @[video];
//
//    FBSDKShareDialog *dialog = [[FBSDKShareDialog alloc] init];
//    dialog.fromViewController = [Util getRootViewController];
//    dialog.shareContent = content;
//    dialog.mode = FBSDKShareDialogModeShareSheet;
//    dialog.delegate = facebookObj;
//
//    [dialog show];
}

+(void) sharePhotoOnFb:(NSString*) link {
//    NSLog(@"Attempting photo share on fb");
//    NSURL *url2 = [NSURL URLWithString: link];
//    NSData *data = [NSData dataWithContentsOfURL : url2];
//    UIImage *image = [UIImage imageWithData: data];
//
//    FBSDKSharePhoto *sharePhoto = [[FBSDKSharePhoto alloc] init];
//    sharePhoto.image = image;
//    FBSDKSharePhotoContent *content = [[FBSDKSharePhotoContent alloc] init];
//    content.photos = @[sharePhoto];
//
//    FBSDKShareDialog *dialog = [[FBSDKShareDialog alloc] init];
//    dialog.fromViewController = [Util getRootViewController];
//    dialog.shareContent = content;
//    dialog.delegate = facebookObj;
//
//    dialog.mode = FBSDKShareDialogModeShareSheet;
//
//    [dialog show];
}

//- (void)sharer:(id<FBSDKSharing>)sharer didCompleteWithResults:(NSDictionary *)results {
//    NSLog(@"Sharer complete with results?");
//    NSMutableDictionary* dict = [[NSMutableDictionary alloc] init];
//    [dict setObject:TYPE_LINK_SHARE forKey:TYPE];
//    if (results == nil || [results count] == 0) {
//        [dict setObject:[NSNumber numberWithInt:IX_CANCEL] forKey:SUCCESS];
//        [Util showMessage:@"Post Shared Successfully!"];
//    } else {
//        [dict setObject:[results objectForKey:@"postId"] forKey:KEY_POST_ID];
//        [dict setObject:[NSNumber numberWithInt:IX_SUCCESS] forKey:SUCCESS];
//        [Util sendJSCallBack:@"utilObj.completedFBShare" msg:@"false"];
//        
//    }
//    [Util sendJSCallBack:CALLBACK_FUNCTION msg:[Util JSONToString:dict]];
//}

//- (void)sharer:(id<FBSDKSharing>)sharer didFailWithError:(NSError *)error {
//    NSLog(@"Sharer error:");
//    NSMutableDictionary* dict = [[NSMutableDictionary alloc] init];
//    [dict setObject:TYPE_LINK_SHARE forKey:TYPE];
//    [dict setObject:[NSNumber numberWithInt:IX_ERROR] forKey:SUCCESS];
//    [dict setObject:[error localizedDescription] forKey:KEY_ERROR];
//    [Util sendJSCallBack:CALLBACK_FUNCTION msg:[Util JSONToString:dict]];
//}

//- (void)sharerDidCancel:(id<FBSDKSharing>)sharer {
//    NSLog(@"Sharer cancelled");
//    NSMutableDictionary* dict = [[NSMutableDictionary alloc] init];
//    [dict setObject:TYPE_LINK_SHARE forKey:TYPE];
//    [dict setObject:[NSNumber numberWithInt:IX_CANCEL] forKey:SUCCESS];
//    [Util sendJSCallBack:CALLBACK_FUNCTION msg:[Util JSONToString:dict]];
//}

-(void) loadFriendsDict;{
    SqliteHelper *database = [SqliteHelper get:READONLY];
    @try {
        NSString *friendsData = [database getData:FRIENDS_DATA_FILE];
        if(friendsData){
            self.friendsData = [Util stringToJson:friendsData];
        }
    }
    @catch (NSException *exception) {
        ENError(@"%@", [exception description]);
    }
}

+(void) downloadFriendPics {
    NSLog(@"Attempt Downloading friend pics");
    FacebookWrapper *facebookObj = [FacebookWrapper sharedInstance];
    [facebookObj downloadFriendPics:false];
}

-(void) downloadFriendPics:(bool)background;{
    @try {
        FacebookWrapper *facebookObj = [FacebookWrapper sharedInstance];
        [facebookObj loadFriendsDict];
        int totalDownloadCount = 0;
        int maxDownloadAtOneTime = 20;
        if(facebookObj.friendsData!=nil){
            NSString *allInfo = [[NSString alloc] init];
            if (facebookObj.friendsData[@"invitableFriends"]!=nil && [facebookObj.friendsData[@"invitableFriends"] count]!=0) {
                for (int ix=0; ix<[facebookObj.friendsData[@"invitableFriends"] count] && ix<10; ix++) {
                    NSDictionary *obj = facebookObj.friendsData[@"invitableFriends"][ix];
                    NSString *url = obj[@"picture"][@"data"][@"url"];
                    NSString *name = [NSString stringWithFormat:@"%@.jpg",obj[@"name"]];
                    if(![Util imageExists:name]){
                        totalDownloadCount++;
                        allInfo = [allInfo stringByAppendingString:[NSString stringWithFormat:@"%@,%@;", url, name]];
                    }
                }
            }
            if (facebookObj.friendsData[@"playingFriends"]!=nil && [facebookObj.friendsData[@"playingFriends"] count]!=0) {
                for (int ix=0; ix<[facebookObj.friendsData[@"playingFriends"] count] && totalDownloadCount < maxDownloadAtOneTime; ix++) {
                    NSDictionary *obj = facebookObj.friendsData[@"playingFriends"][ix];
                    NSString *url = obj[@"picture"][@"data"][@"url"];
                    NSString *name = [NSString stringWithFormat:@"%@.jpg",obj[@"id"]];
                    if(![Util imageExists:name]){
                        totalDownloadCount++;
                        allInfo = [allInfo stringByAppendingString:[NSString stringWithFormat:@"%@,%@;", url, name]];
                    }
                }
            }
            
            if (facebookObj.friendsData[@"invitableFriends"]!=nil && [facebookObj.friendsData[@"invitableFriends"] count]!=0) {
                for (int ix=10; ix<[facebookObj.friendsData[@"invitableFriends"] count] && totalDownloadCount < maxDownloadAtOneTime; ix++) {
                    NSDictionary *obj = facebookObj.friendsData[@"invitableFriends"][ix];
                    NSString *url = obj[@"picture"][@"data"][@"url"];
                    NSString *name = [NSString stringWithFormat:@"%@.jpg",obj[@"name"]];
                    if(![Util imageExists:name]){
                        totalDownloadCount++;
                        allInfo = [allInfo stringByAppendingString:[NSString stringWithFormat:@"%@,%@;", url, name]];
                    }
                }
            }
            
            if (![allInfo isEqualToString:@""]) {
                NSLog(@"Triggering download");
                [Util downloadImages:allInfo background:background];
            } else {
                NSLog(@"Nothing to download");
            }
        } else {
            ENInfo(@"friends data is empty");
        }
        
    }
    @catch (NSException *exception) {
        ENError(@"%@", [exception description]);
    }
}

@end
