#import <Foundation/Foundation.h>

#import "ObjLocalStorage.h"

#import "Util.h"

#define CACHE_HIT_COUNT  5
#define ADD_INTERVAL  50
@implementation ObjLocalStorage

ObjLocalStorage *localObj=nil;

+(id) get;{
    if(localObj==nil){
        localObj = [[ObjLocalStorage alloc] init];
    }
    return localObj;
}

-(id) init{
    self = [super init];
    self.imgDownloaded = [[NSMutableArray alloc] init];
    NSArray *directoryContent = [[NSFileManager defaultManager] contentsOfDirectoryAtPath:[Util getImageDirPath] error:NULL];
    [self.imgDownloaded addObjectsFromArray:directoryContent];
    return self;
}

-(BOOL) checkIfImgDownloaded:(NSString*) img;{
    img = [img stringByReplacingOccurrencesOfString:[Util getImageDirPath] withString:@""];
    BOOL success = [self.imgDownloaded containsObject:img] ;
    if(success){
        ENInfo(@"file found in local cache -- %@ not downloading", img);
    }
    return success;
}

-(BOOL) checkImageOnDisk:(NSString*) fileName;{
    BOOL imageExists = true;
    NSString *absPath = [Util getAbsPath:fileName];
    imageExists = [[NSFileManager defaultManager] fileExistsAtPath:absPath];
    
    if (imageExists) {
        UIImage *imageBitmap = [UIImage imageWithContentsOfFile:absPath];
        if (imageBitmap == nil) {
            imageExists = false;
        } else {
            imageExists = true;
        }
    }
    
    return imageExists;
}

-(void) deleteImageFromDisk:(NSString*)fileName;{
    fileName = [fileName stringByReplacingOccurrencesOfString:[Util getImageDirPath] withString:@""];
    
    NSFileManager *fileManager = [NSFileManager defaultManager];
    NSString *imgDir  = [Util getImageDirPath];
    NSString *absPath =[NSString stringWithFormat:@"%@%@",imgDir, fileName];
    BOOL fileExists = [fileManager fileExistsAtPath:absPath];
    NSError *e;
    if (fileExists)
    {
        [fileManager removeItemAtPath:absPath error:&e];
    }
}

@end
