//
//  PSUtil.m
//

#import "Reachability.h"
#import "GameSpecific.h"
#import "PSUtil.h"
//#import "PSMopubAds.h"
#import "FlutterBridge.h"
#import "Ads.h"
//#import "Adjust.h"
#import "PSNotifs.h"
#import "PSLogin.h"

@implementation PSUtil

static NSString* FLUTTER_ROUTE_NAME = @"psUtil";
static PSUtil *psUtil = nil;

+ (void) init {
    if (psUtil == nil) {
        psUtil = [[PSUtil alloc] init];
    }

    [Ads init];
    
//    NSString *yourAppToken = ADJUST_APP_TOKEN;
//    NSString *environment = ADJEnvironmentProduction;
//    ADJConfig *adjustConfig = [ADJConfig configWithAppToken:yourAppToken
//                                                environment:environment];
//    [adjustConfig setAppSecret:ADJUST_0 info1:ADJUST_1 info2:ADJUST_2 info3:ADJUST_3 info4:ADJUST_4];
//    [adjustConfig setDelegate:psUtil];
//    [Adjust appDidLaunch:adjustConfig];
    [PSNotifs init];
    
    [self performSelector:@selector(callDelayedInitMethod) withObject:self afterDelay:1.5];
}

// Adjust
- (BOOL)adjustDeeplinkResponse:(NSURL *)deeplink {
    // deeplink object contains information about deferred deep link content

    // Apply your logic to determine whether the Adjust SDK should try to open the deep link
    // return YES;
    // or
    NSLog(@"deeplinking log: deferred deep link url to be opened is: %@", deeplink);
    return NO;
}


+ (void) callDelayedInitMethod {
    NSLog(@"Delayed init happening");
//    [PSMopubAds init];
    [PSLogin init];
    // [PSAmazonAds init];
    
    [FlutterBridge init];
}

+(bool) isOnline{
    Reachability *reachability = [Reachability reachabilityForInternetConnection];
    NetworkStatus networkStatus = [reachability currentReachabilityStatus];
    return networkStatus != NotReachable;
}

+ (NSString *) getIsOnlineString {
    bool isOnline = [PSUtil isOnline];
    if (isOnline) {
        return @"true";
    }
    return @"false";
}

+ (NSNumber *) stringToInt:(NSString *)str {
    NSNumberFormatter *f = [[NSNumberFormatter alloc] init];
    f.numberStyle = NSNumberFormatterDecimalStyle;
    NSNumber *myNumber = [f numberFromString:str];
    return myNumber;
}

+ (void) onPause {
    [FlutterBridge sendStateToFlutterModule:FLUTTER_ROUTE_NAME action:@"onPause"];
//    [PSMopubAds appPause];
}

+ (void) onResume {
    [FlutterBridge sendStateToFlutterModule:FLUTTER_ROUTE_NAME action:@"onResume"];
//    [PSMopubAds appResume];
    [GameSpecific appResume];
}

+ (UIViewController*) getRootViewController {
    UIViewController *rootViewController = [UIApplication sharedApplication].keyWindow.rootViewController;
    return rootViewController;
}

+ (NSString *) getAdjustId {
    return @"";
}

+(NSData*) JSONToData:(id) inputJSON;{
    NSError *e;
    if (inputJSON==nil) {
        return nil;
    }
    NSData *data = [NSJSONSerialization dataWithJSONObject:inputJSON options:kNilOptions error:&e];
    if(data == nil){
        return nil;
    }
    return data;
}

+(NSString*) JSONToString:(id) inputJSON;{
    NSData *data = [PSUtil JSONToData:inputJSON];
    if (data==nil) {
        return @"";
    }
    return [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
}

+(id) stringToJson:(NSString*) inputString;
{
    NSString *newString = [NSString stringWithString:inputString];
    if (newString==nil) {
        return nil;
    }
    
    NSData *data_response = [newString dataUsingEncoding:NSUTF8StringEncoding];
    NSError *error=[[NSError alloc] init];
    id jsonObject = [NSJSONSerialization JSONObjectWithData:data_response options:NSJSONReadingMutableContainers error:&error];
    if(jsonObject == nil)
    {
        ENError(@"Error converting %@ to json", newString);
        return NULL;
    }
    return jsonObject;
}

+(BOOL)isAppInstalled:(NSString*) appName {
    NSString *str = [NSString stringWithFormat: @"%@://", appName];
    NSLog(@"Attempting to check if app present: %@", str);
    return [[UIApplication sharedApplication] canOpenURL:[NSURL URLWithString:str]];
}

+(void) launchAnotherApp:(NSString *)key{
    NSString *appScheme = [NSString stringWithFormat:@"%@%@", key, @":"];
    NSLog(appScheme);
    [[UIApplication sharedApplication] openURL: [NSURL URLWithString:appScheme]];
}

@end
