#import <Foundation/Foundation.h>

#import "Track.h"
#import "Util.h"
#import "Analytics.h"
#import "SqliteHelper.h"
#import "GameSpecific.h"

@implementation Track

+ (void)trackCounter:(NSString*)k p:(NSString*)p c:(NSString*)c o:(NSString*)o f:(NSString*)f g:(NSString*)g s:(NSString*)s co:(NSString*)co oppId:(NSString*)oppId;
{
    return;
    [Track sendJSTracking:k p:p c:c o:o f:f g:g s:s co:co oppId:oppId isCritical:@"yes"];
}

+ (void)trackCounterCpp:(NSString*)log;
{
    NSString *blank = @"";
    if ([log hasPrefix:@"cocos2d: fullPathForFilename"] || [log hasPrefix:@"DEBUG::"] || [log hasPrefix:@"TRACE::"]
        || [log hasPrefix:@"INFO::"] || [log hasPrefix:@"WARNING::"] || [log hasPrefix:@"ERROR::"]
        || [log hasPrefix:@"\n"] || [log hasPrefix:@"Inner "] || [log hasPrefix:@"Evaluating "] || [log hasPrefix:@"offest"]
        || [log hasPrefix:@"ScriptingCore:: evaluateScript fail:"] || [log hasPrefix:@"In the constructor of"] || [log hasPrefix:@"cocos2d: SpriteFrameCache:"]|| [log hasPrefix:@"cocos2d: QuadCommand: resizing index"]
        || [log hasPrefix:@"basic_object_finalize"]||[log hasPrefix:@"The-Internet-connection"] ||[log hasPrefix:@"The-network-connection-was-lost"] || [log hasPrefix:@"cocos2d: unsupported image format!"]
        || [log hasPrefix:@"debug server"] || [log hasPrefix:@"Response failed, error buffer"]
        || [log hasPrefix:@"Cocos2d-JS v3."]){
        return;
    }
    log = [log stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
    NSString *searchStr = @".app/";
    NSInteger loc = [log rangeOfString:searchStr].location;
    if (loc != NSNotFound) {
        NSInteger startLoc = loc + searchStr.length;
        log = [log substringWithRange:NSMakeRange(startLoc, log.length - startLoc)];
    }
    
    searchStr = @"js-bindings/";
    loc = [log rangeOfString:searchStr].location;
    if (loc != NSNotFound) {
        NSInteger startLoc = loc + searchStr.length;
        log = [log substringWithRange:NSMakeRange(startLoc, log.length - startLoc)];
    }
    
    [GameSpecific checkAndShowJSErrorAlert:log];
    return;
    
    NSInteger versionCode = [Util getVersionCode];
    NSLog(@"Attempting to track: %@ %ld", log, (long)loc);
    [Track trackCounter:@"log" p:blank c:log o:blank f:blank g:blank s:blank co:blank oppId:blank];
    
    
    if (versionCode % 2 == 0) {
        [Analytics syncFabricEvent:@"jsError" status:[[Util getClientBuildVersion] stringByAppendingFormat:@" %@", log]];
    } else {
        [Analytics syncFabricEvent:@"jsErrorStaging" status:[[Util getClientBuildVersion] stringByAppendingFormat:@" %@", log]];
    }
    
    [GameSpecific checkAndShowJSErrorAlert:log];
    return;
}

+(NSString *)sanitizeTrackingFields:(NSString *)f {
    if (f == nil || [f isEqual:[NSNull null]]) {
        f = @"";
    } else {
        f = [f stringByReplacingOccurrencesOfString:@":" withString:@"-"];
    }
    return f;
}

+(void) sendJSTracking:(NSString*)k
                     p:(NSString*)p
                     c:(NSString*)c
                     o:(NSString*)o
                     f:(NSString*)f
                     g:(NSString*)g
                     s:(NSString*)s
                    co:(NSString*)co
                 oppId:(NSString*)oppId
            isCritical:(NSString*)isCritical {
    
    if (k == nil) {
        return;
    }
    p = [Track sanitizeTrackingFields:p];
    c = [Track sanitizeTrackingFields:c];
    o = [Track sanitizeTrackingFields:o];
    f = [Track sanitizeTrackingFields:f];
    g = [Track sanitizeTrackingFields:g];
    s = [Track sanitizeTrackingFields:s];
    co = [Track sanitizeTrackingFields:co];
    oppId = [Track sanitizeTrackingFields:oppId];
    
    NSArray *trackingStrings = [[NSArray alloc] initWithObjects:k, p, c, o, f, g, s, co, oppId, nil];
    NSString *trackingParams = [trackingStrings componentsJoinedByString:@":"];
    
    [Util sendJSCallBack:@"trackObj.processNativeTracking" msg:trackingParams];
}

NSArray *lastNJSTracking;
int lastNJSTrackingCount = 0;
+(void) loadJsTracking {
    SqliteHelper *database;
    database = [SqliteHelper get:READONLY];
    NSString *trackData = [database getData:JS_TRACK_FILE];
    if (trackData){
        NSError *e = nil;
        NSDictionary *trackObj = [Util stringToJson:trackData];
        if(e){
            NSLog(@"No data for tracking yet %@", e.description);
            return;
        }
        
        if([trackObj objectForKey:@"lastNTracking"]!=nil){
            lastNJSTracking = [trackObj objectForKey:@"lastNTracking"];
        }
        if([trackObj objectForKey:@"lastNTrackingCount"]!=nil){
            lastNJSTrackingCount = [[trackObj objectForKey:@"lastNTrackingCount"] intValue];;
        }
        // NSLog(@"Last n tracking - 1: %@", lastNJSTracking);
        
    }
    
}

+(NSString *)getLastNJsTracking {
    [Track loadJsTracking];
    // NSLog(@"Loaded tracking data:%d %@", lastNJSTrackingCount, lastNJSTracking);
    return [Util JSONToString:lastNJSTracking];
}
@end
