#ifndef User_h
#define User_h

#import "SqliteHelper.h"

@interface User : NSObject{
    SqliteHelper *database;
}
@property (readonly) bool isFirstLaunch;
@property (nonatomic, retain) NSString *refId;
@property (nonatomic, retain) NSString *syncId;
@property (nonatomic, retain) NSString *trackingRefId;
@property (nonatomic, retain) NSString *advertiserId;
@property (nonatomic, retain) NSString *name;
@property (nonatomic, retain) NSString *email;
@property (nonatomic, retain) NSString *gender;
@property (nonatomic, retain) NSString *fbid;
@property (nonatomic, retain) NSString *countryCode;
@property (nonatomic, retain) NSString *subDivision;
@property (nonatomic, retain) NSString *city;
@property (nonatomic, retain) NSString *installNetwork;
@property (nonatomic, retain) NSString *installCampaign;
@property (nonatomic, retain) NSString *installAdGroup;
@property (nonatomic, retain) NSString *installCreative;
@property (nonatomic, retain) NSString *trackerToken;
@property (nonatomic, retain) NSString *chosenName;
@property (nonatomic, retain) NSString *chosenEmail;

@property (nonatomic, retain) NSString *curDevice;
@property (nonatomic, retain) NSString *deviceHash;
@property (nonatomic, retain) NSString *infoHash;
@property (nonatomic) Boolean logoutClicked;
@property (readonly) int httpConnectionFailure;
@property (nonatomic, retain) NSString *isPayer;
@property (nonatomic, retain) NSString *xpromoId;
@property (nonatomic, retain) NSString *gpsid;
@property (nonatomic, retain) NSString *deviceId;
@property (nonatomic, retain) NSString *gameUserInfoHash;
@property (nonatomic, retain) NSString *xpromoHash;

+(User*) get;
-(Boolean) load;
+(NSString*) getName;
+(NSString*) getRefId;
+(NSString*) getTrackingRefId;
+(void) updateNameEmail:(NSString*)name email:(NSString*)email;
+(void) showPrivacy:(NSString*)theme refId:(NSString*)refId trackingRefId:(NSString*)trackingRefId countryCode:(NSString*)countryCode subDivision:(NSString*)subDivision law:(NSString*)law;
+(void) updateChosenCountry:(NSString*)chosenCountry;
+(void) updateAgeRange:(NSString*)cmin cmax:(NSString*)cmax;
+(void) acceptPrivacyPolicy;
@end

#endif /* User_h */
