PSConstants = function () {
    this.TRACK_SERVER_REST = "https://playsimple.in:11000/rest";
    this.TRACK_SERVER_PIPELINE = "https://playsimple.in:11000/pipeline";
    this.LOGIN_SERVER_REST = "https://playsimple.in:9001/rest";
    this.LOGIN_SERVER_ID_STAGING = "https://playsimple.in:9007/login";
    this.LOGIN_SERVER_ID_PROD = "https://playsimple.in:9005/login";
    
    this.PACKAGE_PATH_ANDROID_PS = "in/playsimple/";
    this.PACKAGE_PATH_ANDROID_COMMON = "in/playsimple/common/";
    this.PACKAGE_PATH_IOS = "";

    // Privacy Constants
    this.PRIVACY_FILE = "ps_privacy.json";
    this.SECONDS_IN_DAY = 86400;
    this.SECONDS_IN_HOUR = 3600;

    // Tracking Constants.
    this.DELETION_CANCELLATION_DAYS_LIMIT = 7;
    this.TRACK_AD_TRACKING = "ad_tracking";
    this.TRACK_INTERSTITIAL = "interstitial";
    this.TRACK_DEBUG = "debug";
    this.TRACK_PSCI = "psci";
    this.TRACK_HOME = "home";
    this.TRACK_FIRST_LAUNCH = "first_launch";
    this.TRACK_REFID_ALLOCATION = "refid_allocation";
    this.TRACK_ORIGIN_MAX = 100000;
    this.TRACK_MOD_VAL = 10000;
    this.TRACK_DAY_START_TRACKING = "day_start_tracking";
    this.TRACK_REQUEST = "request";
    this.TRACK_SUCCESS = "success";
    this.TRACK_FAIL = "fail";
    this.TRACK_SESSION = "session";
    this.TRACK_START = "start";
    this.TRACK_PUZZLE = "puzzle";
    this.TRACK_APP = "app";
    this.TRACK_NON_APP = "non_app";
    this.TRACK_GIFT_COINS = "gift_coins";
    this.TRACK_GIFT_SPINS = "gift_spins";
    this.TRACK_EARN = "earn";
    this.TRACK_GIFT = "gift";
    this.TRACK_GET_SPINS = "get_spins";
    this.TRACK_GRANT = "grant";
    this.TRACK_NOT_SENT = "not_sent";
    this.TRACK_SENT = "sent";
    this.TRACK_LEVELUP = "level_up";
    this.TRACK_SPIN = "spin";
    this.TRACK_FB = "fb";
    this.TRACK_FB_CONNECT = "fb_connect";
    this.TRACK_CLICK = "click";
    this.TRACK_PERF = "perf";
    this.TRACK_END = "end";
    this.TRACK_LENGTH = "length";

    // Analytics Event Types Constants.
    this.EVENT_TYPE_DAU = "dau";
    this.EVENT_TYPE_FACEBOOK_CONNECT = "fb_connect";
    this.EVENT_TYPE_INSTALL_LAUNCH = "install_launch";
    this.EVENT_TYPE_HINT_RETENTION = "hint_retention";
    this.EVENT_TYPE_PHONE_USER = "phone_user";
    this.EVENT_TYPE_PUZZLE_CLEAR_20_GHOST = "puzzle_20_clear_ghost";
    this.EVENT_TYPE_VIDEO_VIEW = "video_view";
    this.EVENT_TYPE_PUZZLE_CLEAR = "puzzle_clear";
    this.EVENT_TYPE_PUZZLE_CLEAR_PHONE = "puzzle_clear_phone";
    this.EVENT_TYPE_RETENTION_DAYS = "retention_days";
    this.EVENT_TYPE_WATCH_VIDEOS = "watch_videos";
    this.EVENT_TYPE_SHUFFLE = "shuffle";
    this.EVENT_TYPE_SHUFFLE_PHONE = "shuffle_phone";
    this.EVENT_TYPE_D0_SESSIONS = "d0_sessions";
    this.EVENT_TYPE_D0_SESSIONS_PHONE = "d0_sessions_phone";
    this.EVENT_TYPE_WORD_CLEARS = "word_clears";
    this.EVENT_TYPE_SUBSCRIPTION = "subscription";
    this.EVENT_TYPE_REWARDED_VIDEO_IMPRESSION = "rewarded_video_impression";
    this.EVENT_TYPE_OFFERWALL_EARN = "offerwall_earn";
    this.EVENT_TYPE_PURCHASE_COMPLETED = "purchase_completed";
    this.EVENT_TYPE_NEW_SESSION = "new_session";
    this.EVENT_TYPE_PUZZLE_COMPLETED = "puzzle_complete";
    this.ADJUST_CUSTOM_EVENT_TYPES = [this.EVENT_TYPE_PUZZLE_CLEAR, this.EVENT_TYPE_WATCH_VIDEOS, this.EVENT_TYPE_FACEBOOK_CONNECT, this.EVENT_TYPE_SHUFFLE, this.EVENT_TYPE_SHUFFLE_PHONE, this.EVENT_TYPE_D0_SESSIONS,
        this.EVENT_TYPE_D0_SESSIONS_PHONE, this.EVENT_TYPE_WORD_CLEARS, this.EVENT_TYPE_SUBSCRIPTION, this.EVENT_TYPE_REWARDED_VIDEO_IMPRESSION, this.EVENT_TYPE_OFFERWALL_EARN, this.EVENT_TYPE_PURCHASE_COMPLETED,
        this.EVENT_TYPE_NEW_SESSION, this.EVENT_TYPE_PUZZLE_COMPLETED];

    // Firebase Events Constants.
    this.FIREBASE_DAU = "dau";
    this.FIREBASE_FACEBOOK_CONNECTED = "facebook_connect";
    this.FIREBASE_INSTALL_LAUNCH = "install_launch";
    this.FIREBASE_PHONE_USER = "phone_user";
    this.FIREBASE_PUZZLE_20_CLEAR_GHOST = "puzzle_20_clear_ghost";
    this.FIREBASE_VIDEO_VIEW = "video_view";

    this.LIVES_PER_REQUEST = 0;
    this.FB_REQ_MOVES_LIMIT = 0; 
    this.PU_EXTRA_MOVES_2 = 0;
    this.MOVES_PER_REQUEST = 0;
    this.EXTRA_MOVES_2_LIMIT = 0;
    this.SCREEN_LEVEL_INTRO = 0;
    this.SCREEN_LEVEL_OUTRO = 0;
    this.FB_REQ_LIVES_LIMIT = 0;
    this.PACKAGE_PATH_MOPUB_ANDROID = "in/playsimple/common/mopub/";

    this.SECONDS_IN_MINUTE = 60;

    this.LOGIN_TYPE_GUEST = "0";
    this.LOGIN_TYPE_FB = "1";
    this.LOGIN_TYPE_FB_INSTANT = "2";
    this.LOGIN_TYPE_APPLE = "3";
    this.LOGIN_TYPE_GOOGLE = "4";
    this.LOGIN_TYPE_PS_LOGIN = "5";

    this.NETWORK_NONE = 0;
    this.NETWORK_FACEBOOK = 1;
    this.NETWORK_APPLE = 2;

};