PSMopubAds = function () {
    this.PS_AD_TYPE_INTERSTITIAL = 1; // This is only interstitials, but could include Rewarded also in future.
    this.PS_AD_TYPE_BANNER = 2;
    this.PS_AD_TYPE_REWARDED = 3; // This is rewarded + video interstitials

    this.MOPUB_AD_TYPE_INTERSTITIAL = 1; // Interstitials as per Mopub classification
    this.MOPUB_AD_TYPE_BANNER = 2;
    this.MOPUB_AD_TYPE_REWARDED = 3; // Rewarded videos as per Mopub classification

    var PACKAGE_PATH_MOPUB_ANDROID = "in/playsimple/common/mopub/";

    var resetDailyData = false;
    var reqVariant = 0;

    var psRewardedPlayStarted = false;
    var psRewardedViewCallback = false;
    var psRewardedImpressionCallback = false;

    var appPausedAt = 0;

    this.init = function () {

    };

    this.appPause = function () {
        // loggerObj.debugLog("mopub log: appPaused");
        appPausedAt = psUtilObj.getCurrentTimestamp();
    };

    this.appResume = function () {
        // loggerObj.debugLog("mopub log: appResumed");
        psMopubAdsObj.checkForRewardedGrant();
    };

    this.grantMopubConsent = function () {
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(PACKAGE_PATH_MOPUB_ANDROID + "PSMopubAds", "grantMopubConsent", "()V");
        } else if (utilObj.isIos()) {
            return psUtilObj.makeNativeCall("PSMopubAds", "grantMopubConsent");
        }
    };

    this.checkForUserOptAndGrantMopubConsent = function () {
        if(psPrivacyObj.hasUserOptedOut()) {
            return;
        }
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(PACKAGE_PATH_MOPUB_ANDROID + "PSMopubAds", "grantMopubConsent", "()V");
        } else if (utilObj.isIos()) {
            return psUtilObj.makeNativeCall("PSMopubAds", "grantMopubConsent");
        }
    };


    // updateMopubSessionInfo
    // reset - whether to reset the stored data for ad calculations (usually reset at the start of a new day)
    // variant - which variant is the user in for the adUnits experiment. This will determine the adUnits which get used.
    this.updateMopubSessionInfo = function (reset, variant) {
        resetDailyData = reset;
        reqVariant = variant;
    };

    // dartConfigLoaded
    // This is called from the native side once all initializations are complete, with the proper config.
    this.dartConfigLoaded = function (resp) {
        trackObj.trackCounter(psConstantsObj.TRACK_DEBUG, psConstantsObj.TRACK_PSCI, "dart_config_loaded", resetDailyData + "", reqVariant + "", "", "", "", "");
        
        // Receive all required config data from native code.
        // loggerObj.debugLog("mopub log: js received info that dart config is loaded");
        // Go ahead and make the native calls for updating data related to sessions since now we are confident that data is loaded.
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(PACKAGE_PATH_MOPUB_ANDROID + "PSMopubAds", "updateSessionInfo", "(ZI)V", resetDailyData, reqVariant);
        } else if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("PSMopubAds", "updateSessionInfo:variant:", resetDailyData, reqVariant + "");
        }
    };

    this.isPlacementAvailable = function (placementName) {
        if (utilObj.isAndroid()) {
            return psUtilObj.makeNativeCall(PACKAGE_PATH_MOPUB_ANDROID + "PSMopubAds", "isPlacementAvailable", "(Ljava/lang/String;)Z", placementName);
        } else if (utilObj.isIos()) {
            return psUtilObj.makeNativeCall("PSMopubAds", "isPlacementAvailable:", placementName);
        }
        return false;
    };

    this.isAnyPlacementAvailable = function (colonSeparatedPlacementNames) {
        if (utilObj.isAndroid()) {
            return psUtilObj.makeNativeCall(PACKAGE_PATH_MOPUB_ANDROID + "PSMopubAds", "isAnyPlacementAvailable", "(Ljava/lang/String;)Z", colonSeparatedPlacementNames);
        } else if (utilObj.isIos()) {
            return psUtilObj.makeNativeCall("PSMopubAds", "isAnyPlacementAvailable:", colonSeparatedPlacementNames);
        }
        return false;
    };

    this.showPlacement = function (placementName, screen, puzzleInfo) {
        if (utilObj.isAndroid()) {
            return psUtilObj.makeNativeCall(PACKAGE_PATH_MOPUB_ANDROID + "PSMopubAds", "showPlacement", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Z", placementName, screen, puzzleInfo);
        } else if (utilObj.isIos()) {
            return psUtilObj.makeNativeCall("PSMopubAds", "showPlacement:screen:puzzleInfo:", placementName, screen, puzzleInfo);
        }
        return false;
    };

    this.showAnyPlacementAvailable = function (placementNames, screen, puzzleInfo) {
        if (utilObj.isAndroid()) {
            return psUtilObj.makeNativeCall(PACKAGE_PATH_MOPUB_ANDROID + "PSMopubAds", "showAnyPlacementAvailable", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Z", placementNames, screen, puzzleInfo);
        } else if (utilObj.isIos()) {
            return psUtilObj.makeNativeCall("PSMopubAds", "showAnyPlacementAvailable:screen:puzzleInfo:", placementNames, screen, puzzleInfo);
        }
        return false;
    };

    this.hidePlacement = function (placementName, screen, puzzleInfo) {
        if (utilObj.isAndroid()) {
            return psUtilObj.makeNativeCall(PACKAGE_PATH_MOPUB_ANDROID + "PSMopubAds", "hidePlacement", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Z", placementName, screen, puzzleInfo);
        } else if (utilObj.isIos()) {
            return psUtilObj.makeNativeCall("PSMopubAds", "hidePlacement:screen:puzzleInfo:", placementName, screen, puzzleInfo);
        }
        return false;
    };

    this.retryAdLoadForPlacementType = function (mopubPlacementType, psPlacementType) {
        mopubPlacementType = parseInt(mopubPlacementType);
        psPlacementType = parseInt(psPlacementType);
        if (utilObj.isAndroid()) {
            return psUtilObj.makeNativeCall(PACKAGE_PATH_MOPUB_ANDROID + "PSMopubAds", "loadMopubAdType", "(II)Z", mopubPlacementType, psPlacementType);
        } else if (utilObj.isIos()) {
            return psUtilObj.makeNativeCall("PSMopubAds", "loadMopubAdType:psType:", mopubPlacementType, psPlacementType);
        }
        return false;
    };

    this.afterView = function (resp) {
        // loggerObj.debugLog("mopub log: afterView - original info - " + resp);
        var respJson = {};
        try {
            respJson = JSON.parse(resp);
        } catch (e) {

        }
        // loggerObj.debugLog("mopub log: afterView - ", utilObj.getStringifiedJson(respJson));
        if (respJson.psAdType != psMopubAdsObj.PS_AD_TYPE_REWARDED) {
            return;
        }
        psRewardedViewCallback = true;
    };

    this.afterImpression = function (resp) {
        // loggerObj.debugLog("mopub log: afterImpression - original info - " + resp);
        var respJson = {};
        try {
            respJson = JSON.parse(resp);
        } catch (e) {

        }
        // loggerObj.debugLog("mopub log: afterImpression - ", utilObj.getStringifiedJson(respJson));
        var curTimestampMs = psUtilObj.getCurrentTimestampMs();
        trackObj.trackCounter(psConstantsObj.TRACK_DEBUG, psConstantsObj.TRACK_PSCI, "after_impression", psRewardedPlayStarted + "", psRewardedImpressionCallback + "", respJson.psAdType + "", curTimestampMs + "", "", "");
        
        if (respJson.psAdType != psMopubAdsObj.PS_AD_TYPE_REWARDED) {
            return;
        }
        
        if (!psRewardedPlayStarted) {
            return;
        }
        psRewardedImpressionCallback = true;
    };

    this.setPSRewardedPlayStarted = function (s) {
        // loggerObj.debugLog("mopub log: setPSRewardedPlayStarted - " + s);
        psRewardedPlayStarted = s;
    };

    this.getPSRewardedPlayStarted = function () {
        return psRewardedPlayStarted;
    };

    this.checkForRewardedGrant = function () {
        // loggerObj.debugLog("mopub log: checkForRewardedGrant - " + psRewardedPlayStarted + " - " +  psRewardedImpressionCallback + " - " + psRewardedViewCallback);
        
        var curTimestampMs = psUtilObj.getCurrentTimestampMs();
        var curTimestamp = psUtilObj.getCurrentTimestamp();
        if (curTimestamp - appPausedAt <= 15) {
            // Should have spent atleast few seconds watching the video to be eligible for reward.
            // loggerObj.debugLog("mopub log: not enough time spent on video for reward attempt");
        // } else if (psRewardedPlayStarted && psRewardedImpressionCallback && !psRewardedViewCallback) {
        } else if (psRewardedPlayStarted && !psRewardedViewCallback) {
            // View callback not received => it's likely that the completed/close callbacks will also be missing.
            trackObj.trackCounter(psConstantsObj.TRACK_DEBUG, psConstantsObj.TRACK_PSCI, "w2e_grant_via_hack", psRewardedPlayStarted + "", psRewardedImpressionCallback + "", psRewardedViewCallback + "", curTimestampMs + "", "", "");
        
            adsObj.grantVideoReward();
        } else {
            trackObj.trackCounter(psConstantsObj.TRACK_DEBUG, psConstantsObj.TRACK_PSCI, "w2e_no_grant", psRewardedPlayStarted + "", psRewardedImpressionCallback + "", psRewardedViewCallback + "", curTimestampMs + "", "", "");
        }

        psRewardedImpressionCallback = false;
        psRewardedViewCallback = false;
    };

    this.loadAdForPlacement = function (placementName) {
        // loggerObj.debugLog("mopub log: video load call from js ", placementName);
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(PACKAGE_PATH_MOPUB_ANDROID + "PSMopubAds", "loadAdForPlacement", "(Ljava/lang/String;)V", placementName);
        } else if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("PSMopubAds", "loadAdForPlacement:", placementName);
        }
    };

    this.loadAdForPlacements = function (colonSeparatedPlacementNames) {
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(PACKAGE_PATH_MOPUB_ANDROID + "PSMopubAds", "loadAdForPlacements", "(Ljava/lang/String;)V", colonSeparatedPlacementNames);
        } else if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("PSMopubAds", "loadAdForPlacements:", colonSeparatedPlacementNames);
        }
    };
};
