PSPrivacy = function () {
    this.REQUEST_STATUS_REQUESTED = "requested";
    this.REQUEST_STATUS_EMPTY = "";
    this.REQUEST_STATUS_SUCCESS = "success";
    this.REQUEST_STATUS_USER_CANCELLED =  "user-cancelled";


    var userTicketId = "";
    var refIdSha = "";
    var retrievalRequestId = "";
    var retrievalRequestStatus = "";
    var retrievalRequestSuccessTime = "";
    var retrievalRequestSuccessCount = 0;
    var firstRetrievalRequestAcceptTime = "";
    var isRetrievalRequestPendingToBeSent = false;
    var retrievalRequestCreatedTime  = "";
    var deletionRequestId = "";
    var deletionRequestStatus = "";
    var deletionRequestSuccessTime = "";
    var deletionRequestReceivedTime = "";
    var isDeletionRequestPendingToBeSent = false;
    var userEmailChosen = false;
    var userOptedOut = false;
    var chosenOptOutReason = "";
    var isOptInRewardToBeShown = false;
    var hasUserReadTerms = false;
    var chosenDeleteReason = "";
    var isDeleteReasonChosen = false;
    var currentConsentStatus = true;
    var lastStatusCheckTimestamp = 0;

    var jewelNotifToBeShownForHelpCenter = false;

    this.init = function () {
        psPrivacyObj.load();
    };

    this.load = function () {
        var privacyJson = ls.getItem(psConstantsObj.PRIVACY_FILE);
        if (privacyJson == null || privacyJson == "") {
            return false;
        }
        psPrivacyObj.loadPrivacyObjLocal(privacyJson);
        return true;
    };

    this.loadPrivacyObjLocal = function (privacyJson) {
        var privacyData = JSON.parse(privacyJson);
        if (privacyData.userTicketId != undefined) {
            userTicketId = privacyData.userTicketId;
        }
        if (privacyData.retrievalRequestId != undefined) {
            retrievalRequestId = privacyData.retrievalRequestId;
        }
        if (privacyData.retrievalRequestStatus != undefined) {
            retrievalRequestStatus = privacyData.retrievalRequestStatus;
        }
        if (privacyData.retrievalRequestSuccessTime != undefined) {
            retrievalRequestSuccessTime = privacyData.retrievalRequestSuccessTime;
        }
        if (privacyData.retrievalRequestSuccessCount != undefined) {
            retrievalRequestSuccessCount = privacyData.retrievalRequestSuccessCount;
        }
        if (privacyData.firstRetrievalRequestAcceptTime != undefined) {
            firstRetrievalRequestAcceptTime = privacyData.firstRetrievalRequestAcceptTime;
        }
        if (privacyData.isRetrievalRequestPendingToBeSent != undefined) {
            isRetrievalRequestPendingToBeSent = privacyData.isRetrievalRequestPendingToBeSent;
        }
        if (privacyData.retrievalRequestCreatedTime  != undefined) {
            retrievalRequestCreatedTime  = privacyData.retrievalRequestCreatedTime ;
        }
        if (privacyData.deletionRequestId != undefined) {
            deletionRequestId = privacyData.deletionRequestId;
        }
        if (privacyData.deletionRequestStatus != undefined) {
            deletionRequestStatus = privacyData.deletionRequestStatus;
        }
        if (privacyData.deletionRequestSuccessTime != undefined) {
            deletionRequestSuccessTime = privacyData.deletionRequestSuccessTime;
        }
        if (privacyData.deletionRequestReceivedTime != undefined) {
            deletionRequestReceivedTime = privacyData.deletionRequestReceivedTime;
        }
        if (privacyData.isDeletionRequestPendingToBeSent != undefined) {
            isDeletionRequestPendingToBeSent = privacyData.isDeletionRequestPendingToBeSent;
        }
        if (privacyData.refIdSha != undefined) {
            refIdSha = privacyData.refIdSha;
        }
        if (privacyData.userOptedOut != undefined) {
            userOptedOut = privacyData.userOptedOut;
        }
        if (privacyData.chosenOptOutReason != undefined) {
            chosenOptOutReason = privacyData.chosenOptOutReason;
        }
        if (privacyData.hasUserReadTerms != undefined) {
            hasUserReadTerms = privacyData.hasUserReadTerms;
        }
        if (privacyData.chosenDeleteReason != undefined) {
            chosenDeleteReason = privacyData.chosenDeleteReason;
        }
        if (privacyData.isDeleteReasonChosen != undefined) {
            isDeleteReasonChosen = privacyData.isDeleteReasonChosen;
        }
        if (privacyData.userEmailChosen != undefined) {
            userEmailChosen = privacyData.userEmailChosen;
        }
        if (privacyData.isOptInRewardToBeShown != undefined) {
            isOptInRewardToBeShown = privacyData.isOptInRewardToBeShown;
        }
        if (privacyData.currentConsentStatus != undefined) {
            currentConsentStatus = privacyData.currentConsentStatus;
        }
        if (privacyData.jewelNotifToBeShownForHelpCenter != undefined) {
            jewelNotifToBeShownForHelpCenter = privacyData.jewelNotifToBeShownForHelpCenter;
        }
        if (privacyData.lastStatusCheckTimestamp != undefined) {
            lastStatusCheckTimestamp = privacyData.lastStatusCheckTimestamp;
        }
    };

    this.saveData = function () {
        var privacyData = {};
        privacyData.userTicketId = userTicketId;
        privacyData.retrievalRequestId = retrievalRequestId;
        privacyData.retrievalRequestStatus = retrievalRequestStatus;
        privacyData.retrievalRequestSuccessTime = retrievalRequestSuccessTime;
        privacyData.retrievalRequestSuccessCount = retrievalRequestSuccessCount;
        privacyData.firstRetrievalRequestAcceptTime = firstRetrievalRequestAcceptTime;
        privacyData.isRetrievalRequestPendingToBeSent = isRetrievalRequestPendingToBeSent;
        privacyData.retrievalRequestCreatedTime  = retrievalRequestCreatedTime ;
        privacyData.deletionRequestId = deletionRequestId;
        privacyData.deletionRequestStatus = deletionRequestStatus;
        privacyData.deletionRequestSuccessTime = deletionRequestSuccessTime;
        privacyData.deletionRequestReceivedTime = deletionRequestReceivedTime;
        privacyData.isDeletionRequestPendingToBeSent = isDeletionRequestPendingToBeSent;
        privacyData.refIdSha = refIdSha;
        privacyData.userOptedOut = userOptedOut;
        privacyData.chosenOptOutReason = chosenOptOutReason;
        privacyData.hasUserReadTerms = hasUserReadTerms;
        privacyData.chosenDeleteReason = chosenDeleteReason;
        privacyData.isDeleteReasonChosen = isDeleteReasonChosen;
        privacyData.userEmailChosen = userEmailChosen;
        privacyData.isOptInRewardToBeShown = isOptInRewardToBeShown;
        privacyData.currentConsentStatus = currentConsentStatus;
        privacyData.jewelNotifToBeShownForHelpCenter = jewelNotifToBeShownForHelpCenter;
        privacyData.lastStatusCheckTimestamp = lastStatusCheckTimestamp;
        ls.setItem(psConstantsObj.PRIVACY_FILE, utilObj.getStringifiedJson(privacyData));
        gameSpecificObj.checkAndRedrawGameLayerIfCcpaPopupsToBeShown();
    };

    this.hasUserOptedOut = function () {
        return userOptedOut;
    };

    this.getIsOptInRewardToBeShown = function () {
        return isOptInRewardToBeShown;
    };

    this.setIsOptInRewardToBeShown = function(val) {
        isOptInRewardToBeShown = val;
        psPrivacyObj.saveData();
    };

    this.setJewelNotifToBeShownForHelpCenter = function (val) {
        jewelNotifToBeShownForHelpCenter = val;
        psPrivacyObj.saveData();
    };

    this.isJewelNotifToBeShownForHelpCenter = function () {
        return jewelNotifToBeShownForHelpCenter;
    };

    this.setCurrentConsentStatus = function (consentStatus) {
        currentConsentStatus = (parseInt(consentStatus) == 1);
    };

    this.updateUserChosenConsentStatusToGame = function (userChosenConsentStatusParams) {
        loggerObj.debugLog("CCPA: DATA_PRIVACY: CONSENT: received consent on js side: ",userChosenConsentStatusParams);
        var prevUserOptedOut = userOptedOut;
        userOptedOut = (parseInt(userChosenConsentStatusParams.split(":")[0]) == 1);
        chosenOptOutReason = userChosenConsentStatusParams.split(":")[1];
        if(prevUserOptedOut == false && userOptedOut == true) {
            isOptInRewardToBeShown = true;
        } else {
            isOptInRewardToBeShown = false;
        }
        loggerObj.debugLog("CCPA: updated user consent status on js: ",isOptInRewardToBeShown, userOptedOut);
        gameSpecificObj.checkAndRedrawGameLayerIfCcpaPopupsToBeShown();
        psPrivacyObj.saveData();
    };

    this.updateUserPrivacyDataFromDart = function (privacyData) {
        loggerObj.debugLog("CCPA: DATA_PRIVACY: REQUESTS: received data on js side: ",privacyData);
        var previousRetrievalRequestStatus = retrievalRequestStatus;
        var previousDeletionRequestStatus = deletionRequestStatus;
        var privacyVals = JSON.parse(privacyData);

        if(privacyVals['ticketId'] != undefined) {
            userTicketId = privacyVals['ticketId'];
        }
        if(privacyVals['retrievalRequestId'] != undefined) {
            retrievalRequestId = privacyVals['retrievalRequestId'];
        }
        if(privacyVals['retrievalRequestStatus'] != undefined) {
            retrievalRequestStatus = privacyVals['retrievalRequestStatus'];
        }
        if(privacyVals['retrievalRequestSuccessTime'] != undefined) {
            retrievalRequestSuccessTime = privacyVals['retrievalRequestSuccessTime'];
        }
        if(privacyVals['firstRetrievalRequestAcceptTime'] != undefined) {
            firstRetrievalRequestAcceptTime = privacyVals['firstRetrievalRequestAcceptTime'];
        }
        if(privacyVals['retrievalRequestCreatedTime'] != undefined) {
            retrievalRequestCreatedTime  = privacyVals['retrievalRequestCreatedTime'];
        }
        if(privacyVals['deletionRequestId'] != undefined) {
            deletionRequestId = privacyVals['deletionRequestId'];
        }
        if(privacyVals['deletionRequestStatus'] != undefined) {
            deletionRequestStatus = privacyVals['deletionRequestStatus'];
        }
        if(privacyVals['deletionRequestSuccessTime'] != undefined) {
            deletionRequestSuccessTime = privacyVals['deletionRequestSuccessTime'];
        }
        if(privacyVals['deletionRequestReceivedTime'] != undefined) {
            deletionRequestReceivedTime = privacyVals['deletionRequestReceivedTime'];
        }
        if(privacyVals['isOptedOut'] != undefined) {
            userOptedOut = privacyVals['isOptedOut'];
        }
        if(privacyVals['optReasonFlag'] != undefined) {
            chosenOptOutReason = privacyVals['optReasonFlag'];
        }
        if(privacyVals['readTerms'] != undefined) {
            hasUserReadTerms = privacyVals['readTerms'];
        }
        if(privacyVals['deleteReason'] != undefined) {
            chosenDeleteReason = privacyVals['deleteReason'];
        }
        if(privacyVals['isDeleteReasonChosen'] != undefined) {
            isDeleteReasonChosen = privacyVals['isDeleteReasonChosen'];
        }
        if(privacyVals['refIdSha'] != undefined) {
            refIdSha = privacyVals['refIdSha'];
        }
        if(privacyVals['retrievalRequestSuccessCount'] != undefined) {
            retrievalRequestSuccessCount = parseInt(privacyVals['retrievalRequestSuccessCount']);
        }
        if(privacyVals['isRetrievalRequestPendingToBeSent'] != undefined) {
            isRetrievalRequestPendingToBeSent = (parseInt(privacyVals['isRetrievalRequestPendingToBeSent'])==1);
        }
        if(privacyVals['isDeletionRequestPendingToBeSent'] != undefined) {
            isDeletionRequestPendingToBeSent = (parseInt(privacyVals['isDeletionRequestPendingToBeSent'])==1);
        }
        if(previousRetrievalRequestStatus != retrievalRequestStatus && retrievalRequestStatus == psPrivacyObj.REQUEST_STATUS_SUCCESS) {
            psPrivacyObj.setJewelNotifToBeShownForHelpCenter(true);
        }
        if(previousDeletionRequestStatus == psPrivacyObj.REQUEST_STATUS_REQUESTED && deletionRequestStatus == psPrivacyObj.REQUEST_STATUS_USER_CANCELLED) {
            gameSpecificObj.removeAccountLocked();
        }
        psPrivacyObj.saveData();
    };

    this.checkAndtriggerStatusUpdateForDataPrivacyRequests = function () {
        if((psUtilObj.getCurrentTimestamp() - lastStatusCheckTimestamp) < psConstantsObj.SECONDS_IN_HOUR) {
            return;
        }
        lastStatusCheckTimestamp = psUtilObj.getCurrentTimestamp();
        loggerObj.debugLog("CCPA: DATA_PRIVACY: NATIVE FLOW: attempting to status update request from js");
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "PSPrivacy", "triggerStatusUpdateForDataPrivacyRequestsOnDart","()V");
        } else if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("PSPrivacy", "triggerStatusUpdateForDataPrivacyRequestsOnDart");
        }
        psPrivacyObj.saveData();
    };

    this.triggerCancelAccountDeletionRequest = function () {
        loggerObj.debugLog("CCPA: DATA_PRIVACY: NATIVE FLOW: DELETE FLOW: attempting to call cancel delete request from js");
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "PSPrivacy", "triggerCancelDeleteRequestOnDart","()V");
        } else if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("PSPrivacy", "triggerCancelDeleteRequestOnDart");
        }
    };

    this.shouldCancelDeletionOptionBeShown = function () {
        if(deletionRequestStatus == psPrivacyObj.REQUEST_STATUS_REQUESTED) {
            return (psUtilObj.getCurrentTimestamp() - parseInt(deletionRequestReceivedTime) < psConstantsObj.DELETION_CANCELLATION_DAYS_LIMIT * psConstantsObj.SECONDS_IN_DAY);
        }
        return false;
    };

    this.shouldAccountLockedBeShown = function () {
        return (deletionRequestStatus != psPrivacyObj.REQUEST_STATUS_EMPTY && deletionRequestStatus != psPrivacyObj.REQUEST_STATUS_USER_CANCELLED);
    };
};
