PSRemoteConfig = function () {

    var cacheMap = {};
    var runtimesMap = {};

    this.resetCacheMap = function() {
        cacheMap = {};
        runtimesMap = {};
    };

    this.fetchAndActivate = function() {
        if (utilObj.isNative()) {
            psRemoteConfigObj.resetCacheMap();
            if (utilObj.isAndroid()) {
                psUtilObj.makeNativeCall(constantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "fetchAndActivateRemoteConfig", "()V");
            }
            // TODO - Handle flow during iOS implementations
        }
    };

    this.getConfigForKey = function(key) {
        if (utilObj.isNative()) {
            if(cacheMap[key] != undefined) {
                return cacheMap[key];
            }

            if (utilObj.isAndroid()) {
                cacheMap[key] = psUtilObj.makeNativeCall(constantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "getRemoteConfigValue", "(Ljava/lang/String;)Ljava/lang/String;", key);
            } else {
                // TODO - Handle flow during iOS implementations
                cacheMap[key] = "";
            }
            return cacheMap[key];
        }
    };

    this.fetchRuntimes = function() {
        if(runtimesMap == undefined || Object.keys(runtimesMap).length == 0) {
            var key = constantsObj.ENV + "_runtimes";
            var rawRuntimes = psRemoteConfigObj.getConfigForKey(key);

            try {
                if(rawRuntimes != undefined && rawRuntimes != "") {
                    runtimesMap = JSON.parse(rawRuntimes)
                }
            } catch (e) {
                runtimesMap = {};
            }
        }
        return runtimesMap;
    };

    this.getRuntimeValue = function(key) {
        var allRuntimes = psRemoteConfigObj.fetchRuntimes();
        var value;
        if(allRuntimes != undefined) {
            value = allRuntimes[key];
        }
        return value;
    };
};