//////////////////////////////
// Common Infra START
var psConstantsObj = null;
var psMopubAdsObj = null;
var psUtilObj = null;
var psRenderRateObj = null;
var gameSpecificObj = null;
var psRemoteConfigObj = null;
var psPrivacyObj = null;
// Common Infra END
//////////////////////////////


PSUtil = function () {
    var adjustId = "";
    var appResumeTime = 0;
    var appPauseTime = 0;

    this.init = function () {
        psConstantsObj = new PSConstants();
        psMopubAdsObj = new PSMopubAds();
        psRenderRateObj = new PSRenderRate();
        gameSpecificObj = new GameSpecific();
        psRemoteConfigObj = new PSRemoteConfig();
        psPrivacyObj = new PSPrivacy();
    };

    this.sendReport = function (crumb) {
        if (utilObj.isNative()) {
            if (utilObj.isAndroid()) {
                jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "sendReport", "(Ljava/lang/String;)V", crumb);
            } else if (utilObj.isIos()) {
                jsb.reflection.callStaticMethod("Analytics", "sendReport:", crumb);
            }
        } else {

        }
    };

    var keys = [
        "242540424E4D2825346E6234562325404A4E525437366E356562374023562564",
        "5E4256266E38353356402362366E35346D376D23255E2425366E624C3B6D6C6E",
        "2158442666636E62767324252342264D7D6F5B6E706C6B5D53444624234E3837",
        "254E386237255E4D2A62764453434158454F7D505B2C6F6D3F3E2C6D77343676",
        "4B5929264654284E62647929492B4C555F6B306D6F6E6B6A2C686D3B6C6E6463"
    ];
    var ivs = [
        "FC6D3B05DE8602A451891EE24D7837EA",
        "50D9C4F675AD6F2F40020AFD0AF0A0F4",
        "12EE88508B3E7E647F1D106295E15F3A",
        "C174249009FD65F9776165D8E6FB8F32",
        "C801C411417AF1460BF1A5A89276C31A"
    ];

    this.getEncryptedMessage = function(msg, ts) {
        var numStrs = keys.length;
        var key = CryptoJS.enc.Hex.parse(keys[ts % numStrs]);
        var iv = CryptoJS.enc.Hex.parse(ivs[ts % numStrs]);
        var encrypted =  CryptoJS.AES.encrypt(msg, key, { iv: iv });
        var encBase64 = encrypted.ciphertext.toString(CryptoJS.enc.Base64);
        // loggerObj.debugLog("Encrypted data --- ", ts, encBase64);
        return encBase64.toString();
    };

    this.getDecryptedMessage = function(encryptedStr, ts) {
        var numStrs = keys.length;
        var key = CryptoJS.enc.Hex.parse(keys[ts % numStrs]);
        var iv = CryptoJS.enc.Hex.parse(ivs[ts % numStrs]);
        var decrypted = CryptoJS.AES.decrypt({ciphertext:CryptoJS.enc.Base64.parse(encryptedStr)}, key, { iv: iv, format: CryptoJS.format.Base64 });
        // loggerObj.debugLog("Decrypted data --- ",decrypted.toString(CryptoJS.enc.Utf8));
        return decrypted.toString(CryptoJS.enc.Utf8);
    };

    // add required params for gameInfoHash validation.
    this.getGameUserInfoHashParams = function (map) {
        if(map == undefined || map == null) {
            map = {};
        }
        map.pi = userObj.getPsId();
        map.email = userObj.getEmail();
        map.g = constantsObj.GAME_ID + "";
        map.createdAt = userObj.getCreated() + "";
        map.tr = userObj.getTrackingRefId();
        map.gi = "";
        return map;
    };

    this.getUpdatedInfo = function(data) {
        var msg = "";
        var sortedKeys = [];
        for (var k in data) {
            sortedKeys.push(k);
        }
        sortedKeys.sort();

        for (var i = 0; i < sortedKeys.length; i++) {
            var key = sortedKeys[i];
            if (data[key] == undefined) {
                data[key] = "";
                trackObj.trackCounter("debug", "security_fixes", key + "", "coming_undefined", "", "", "", "", "");
            } else if (data[key] == null) {
                data[key] = "";
                trackObj.trackCounter("debug", "security_fixes", key + "", "coming_null", "", "", "", "", "");
            }
            msg += key + "-" + data[key].toString() + "^";
        };
        var ts = psUtilObj.getCurrentTimestamp();
        data["hInfo"] = psUtilObj.getFormattedMessage(msg, ts);
        data["hTs"] = ts + "";
        data["hEngine"] = "1";
        return data;
    };

    this.getFormattedMessage = function(msg, ts) {
        var strs = ['%#$2346vY257@B^2526%2b466', '$%# &$%& @#V%B%H%&^#&B#$23%^&*B%Bv', '@!#V#@B&^N*$%&(6()M46c}L({&*NPULBK','&*)n5b47v365b8634v7b25vBV&#^B$^#VETCn','X^C$%$*BN#%^& V&B353y@$V%&576V@%#^C$truyor tH'];
        var numStrs = strs.length;
        var k = strs[ts % numStrs];
        var hash = CryptoJS.HmacSHA1(msg, k);
        return CryptoJS.enc.Hex.stringify(hash);
    };

    this.makeNativeCall = function () {
        var args = Array.prototype.slice.call(arguments, 0);
        // loggerObj.debugLog("makeNativeCall - " + psUtilObj.getStringifiedJson(args));
        var refId = "";
        if (userObj != undefined && userObj != null) {
            refId = userObj.getRefId();
        }
        psUtilObj.sendReport(refId + " - nc - " + psUtilObj.getStringifiedJson(args));
        if (args.length < 2) {
            // loggerObj.debugLog("Invalid params for native call: Args received as:", psUtilObj.getStringifiedJson(args));
            return;
        }
        try {
            var result = jsb.reflection.callStaticMethod.apply(this, args);
            return result;
        } catch (err) {
            psUtilObj.sendReport("Error in making native call:" + psUtilObj.getStringifiedJson(err));
            loggerObj.errorLog("Error in making native call");
            return;
        }
        
        // // TODO: See if there's a way to make this clean.
        // if (args.length == 2) {
        //     return jsb.reflection.callStaticMethod(args[0], args[1]);
        // } else if (args.length == 3) {
        //     return jsb.reflection.callStaticMethod(args[0], args[1], args[2]);
        // } else if (args.length == 4) {
        //     return jsb.reflection.callStaticMethod(args[0], args[1], args[2], args[3]);
        // } else if (args.length == 5) {
        //     return jsb.reflection.callStaticMethod(args[0], args[1], args[2], args[3], args[4]);
        // } else if (args.length == 6) {
        //     return jsb.reflection.callStaticMethod(args[0], args[1], args[2], args[3], args[4], args[5]);
        // } else if (args.length == 7) {
        //     return jsb.reflection.callStaticMethod(args[0], args[1], args[2], args[3], args[4], args[5], args[6]);
        // } else if (args.length == 8) {
        //     return jsb.reflection.callStaticMethod(args[0], args[1], args[2], args[3], args[4], args[5], args[6], args[7]);
        // } else if (args.length == 9) {
        //     return jsb.reflection.callStaticMethod(args[0], args[1], args[2], args[3], args[4], args[5], args[6], args[7], args[8]);
        // } else if (args.length == 10) {
        //     return jsb.reflection.callStaticMethod(args[0], args[1], args[2], args[3], args[4], args[5], args[6], args[7], args[8], args[9]);
        // } else if (args.length == 11) {
        //     return jsb.reflection.callStaticMethod(args[0], args[1], args[2], args[3], args[4], args[5], args[6], args[7], args[8], args[9], args[10]);
        // } else if (args.length == 12) {
        //     return jsb.reflection.callStaticMethod(args[0], args[1], args[2], args[3], args[4], args[5], args[6], args[7], args[8], args[9], args[10], args[11]);
        // } else {
        //     // loggerObj.debugLog("Unhandled case for native call: Args received as:", utilObj.getStringifiedJson(args));
        // }
    };

    this.getStringifiedJson = function (obj) {
        var str = "";
        if (obj == undefined || obj.layer != null) {
            return str;
        }
        try {
            if (obj.canStringify == undefined || obj.canStringify == true || obj.spriteIndex != undefined) {
                str = JSON.stringify(obj);
            }
        } catch (e) {
            // //loggerObj.errorLog("Error when trying to stringify params:", e);
        }
        return str;
    };

    this.appPause = function () {
        appPauseTime = psUtilObj.getCurrentTimestamp();
        psMopubAdsObj.appPause();
        psPrivacyObj.saveData();
    };

    this.appResume = function () {
        psMopubAdsObj.appResume();
        appResumeTime = psUtilObj.getCurrentTimestamp();
        var timeBetween = appResumeTime - appPauseTime;
        if (timeBetween >= 2 * psConstantsObj.SECONDS_IN_MINUTE) {
            // Call this every session
            trackObj.sendUpdateToDauMapping();
        }
    };

    this.flutterAppPause = function() {
        if (psUtilObj.checkIsFunction(utilObj.flutterAppPause)) {
            utilObj.flutterAppPause();
        }
    };

    this.flutterAppResume = function() {
        if (psUtilObj.checkIsFunction(utilObj.flutterAppResume)) {
            utilObj.flutterAppResume();
        }
    };
    
    this.updateDailyInfo = function (isFirstTimeToday, lastLogin, consLogins) {
        psUtilObj.sendReport("updateDailyInfo - isFirstTimeToday - " + isFirstTimeToday + " - LastLogin - " + lastLogin + " - ConsLogin - " + consLogins);
        if (isFirstTimeToday) {
            userObj.sendDailyPing();
        }
        psPrivacyObj.checkAndtriggerStatusUpdateForDataPrivacyRequests();
    };

    this.getCurrentTimestamp = function () {
        return Math.round(psUtilObj.getCurrentTimestampMs() / 1000);
    };

    this.getCurrentTimestampMs = function () {
        var extraTime = 0;
        // if (utilObj.isStaging() && qaConfigObj != null) {
        //     extraTime = (qaConfigObj.getQAConfigData("add_days_for_testing") * constantsObj.SECONDS_IN_DAY * 1000) + (qaConfigObj.getQAConfigData("add_hours_for_testing") * constantsObj.SECONDS_IN_HOUR * 1000);
        // }
        return (new Date().getTime()) + extraTime;
    };

    this.checkIsFunction = function (functionToCheck) {
        var getType = {};
        return functionToCheck && getType.toString.call(functionToCheck) === '[object Function]';
    };

    this.getAdjustId = function () {
        if (adjustId != "") {
            return adjustId;
        }
        if (utilObj.isAndroid()) {
            adjustId = psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "PSUtil", "getAdjustId", "()Ljava/lang/String;");
        } else if (utilObj.isIos()) {
            adjustId = psUtilObj.makeNativeCall("PSUtil", "getAdjustId");
        }
        return adjustId;
    };

    this.downloadTextFile = function (request_url, callback, meta) {        
        var xmlHttp = cc.loader.getXMLHttpRequest();
        xmlHttp.onreadystatechange = function () {
            if (xmlHttp.readyState == 4 && xmlHttp.status == 200) {                
                callback(xmlHttp.responseText, meta)                
            } else {                
                loggerObj.errorLog("rest - error", xmlHttp.statusText, "status", xmlHttp.readyState, xmlHttp.status);
            }
        };

        // You gotta trick it into downloading binary.
        xmlHttp.open('GET', request_url);
        xmlHttp.overrideMimeType('text\/plain; charset=x-user-defined');
        xmlHttp.send("");
    };

};