AnalyticsWrapper = function () {
    // Reference
    // https://docs.fabric.io/android/answers/answers-events.html

    this.LEVEL = "Level ";
    var eventsCallback = null;

    this.init = function () {

    };

    this.screenView = function (screenName) {
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "screenView", "(Ljava/lang/String;)V", screenName);
        } else if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("Analytics", "screenView:", screenName);
        }
    };

    // On purchase success or failure
    this.purchase = function (success, price, currency, itemName, itemType, itemId, receiptId) {
        if (utilObj.isAndroid()) {
            // Handled in Java
        }
    };

    this.purchaseBegin = function (price, currency, itemName, itemType, itemId) {
        if (utilObj.isAndroid()) {
            // Handled in Java
        }
    };

    this.updateVirtualCurrency = function (resource, amount, trackClass, order) {
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "updateVirtualCurrency",
                "(Ljava/lang/String;ILjava/lang/String;Ljava/lang/String;)V",
                resource, amount, trackClass, order);
        } else if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("Analytics", "updateVirtualCurrency:val:trackClass:order:", resource, amount + "", trackClass, order);
        }
    };

    this.share = function (method, name, type, id) {
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "share",
                "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V",
                method, name, type, id);
        } else if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("Analytics", "share:name:type:sid:", method, name, type, id);
        }
    };

    this.rating = function (rating, name) {
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "rating",
                "(ILjava/lang/String;)V", rating, name);
        } else if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("Analytics", "rating:name:", rating, name);
        }
    };

    this.signUp = function (method, rid, success) {
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "signUp",
                "(Ljava/lang/String;Ljava/lang/String;Z)V", method, rid, success);
        } else if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("Analytics", "signUp:success:", method, success);
        }
    };

    this.login = function (method, screen, success) {
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "login",
                "(Ljava/lang/String;Ljava/lang/String;Z)V", method, screen, success);
        } else if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("Analytics", "login:screen:success:", method, screen, success);
        }
    };

    this.invite = function (method, screen, count) {
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "invite",
                "(Ljava/lang/String;Ljava/lang/String;I)V", method, screen, count);
        } else if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("Analytics", "invite:screen:count:", method, screen, count);
        }
    };

    this.levelStart = function (level, bucket, puzId) {
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "levelStart",
                "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V", level, bucket, puzId);
        } else if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("Analytics", "levelStart:bucket:puzId:", level, bucket, puzId);
        }
    };

    this.levelEnd = function (level, bucket, puzId, score, success) {
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "levelEnd",
                "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;IZ)V", level, bucket, puzId, score, success);
        } else if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("Analytics", "levelEnd:bucket:puzId:score:success:", level, bucket, puzId, score + "", success);
        }
    };

    this.sendFirebaseErrorEvents = function (eventName, spriteName) {
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "sendFirebaseErrorEvents",
                "(Ljava/lang/String;Ljava/lang/String;)V", eventName, spriteName);
        } else if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("Analytics", "sendFirebaseErrorEvents:spriteName:", eventName, spriteName);
        }
    };

    this.sendFirebasePositionEvents = function (eventName, screenName) {
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "sendFirebasePositionEvents",
                "(Ljava/lang/String;Ljava/lang/String;)V", eventName, screenName);
        } else if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("Analytics", "sendFirebasePositionEvents:screenName:", eventName, screenName);
        }
    };

    this.sendFirebaseScreenErrorEvent = function (screen) {
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "sendFirebaseScreenErrorEvent",
                "(Ljava/lang/String;)V", screen + "");
        } else if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("Analytics", "sendFirebaseScreenErrorEvent:", screen);
        }
    };

    this.streakStarted = function (puzzleNum) {
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "streakStarted",
                "(Ljava/lang/String;)V", puzzleNum + "");
        }
    };

    this.userSyncStart = function (hasRefId) {
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "userSyncStart",
                "(Z)V", hasRefId);
        }
    };

    this.userSyncEnd = function (hasRefId, action, success) {
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "userSyncEnd",
                "(ZLjava/lang/String;Z)V", hasRefId, action, success);
        }
    };

    this.refIdMissing = function (level) {
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "refIdMissing",
                "(I)V", level);
        }
    };

    this.customEvent = function (refId, k, p, c, o, f, g, s, co, oppId) {
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "customEvent",
                "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;ILjava/lang/String;)V",
                refId, k, p, c, o, f, g, s, co, oppId);
        }
    };

    this.allocateUserToExperiments = function (expAllocations) {
        return;
    };

    this.getRefIdForAdjust = function () {
        //this needs to send tracking id for analysis flow. 
       //TODO: Fix needs to be added where we can also share syncid. 
        return userObj.getTrackingRefId();
    };

    this.trackInstall = function () {
        var refId = analyticsObj.getRefIdForAdjust();
        var syncId = userObj.getRefId();
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "installEvent",
                "(Ljava/lang/String;Ljava/lang/String;)V", refId , syncId);
        } else if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("Analytics", "installEvent:syncId", refId , syncId);
        }
    };

    this.incentLevelComplete = function () {
        var refId = analyticsObj.getRefIdForAdjust();
        var installTimeDiff = utilObj.getCurrentTimestamp() - gameObj.getInstallTimeStamp();
        installTimeDiff = installTimeDiff + "";
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "incentLevelComplete",
                "(Ljava/lang/String;Ljava/lang/String;)V", refId, installTimeDiff);
        } else if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("Analytics", "incentLevelComplete:duration:", refId, installTimeDiff);
        }
    };

    this.triggerAdjustCustomEvent = function (eventName) {
        if (eventName == undefined || eventName == null || eventName == "") {
            return;
        }
        var refId = analyticsObj.getRefIdForAdjust();
        // loggerObj.debugLog("Triggering adjust custom event:", eventName);
        var installTimeDiff = utilObj.getCurrentTimestamp() - gameObj.getInstallTimeStamp();
        installTimeDiff = installTimeDiff + "";
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "triggerAdjustCustomEvent",
                "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V", refId, eventName, installTimeDiff);
        } else if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("Analytics", "triggerAdjustCustomEvent:eventName:duration:", refId, eventName, installTimeDiff);
        }
    };

    this.triggerAdjustEvent = function (eventName) {
        if (eventName == undefined || eventName == null || eventName == "") {
            return;
        }
        var refId = analyticsObj.getRefIdForAdjust();
        // loggerObj.debugLog("Triggering adjust event:", eventName);
        var installTimeDiff = utilObj.getCurrentTimestamp() - gameObj.getInstallTimeStamp();
        installTimeDiff = installTimeDiff + "";
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "triggerAdjustEvent",
                "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V", refId, eventName, installTimeDiff);
        } else if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("Analytics", "triggerAdjustEvent:eventName:duration:", refId, eventName, installTimeDiff);
        }
    };

    this.trackAppLoad = function () {
        analyticsObj.trackAppResume();
    };

    var sessionStartAt = 0;
    var sessionEndAt = 0;
    this.trackAppResume = function () {
        var curTimestamp = utilObj.getCurrentTimestamp();
        sessionStartAt = curTimestamp;
        trackObj.trackCounter(psConstantsObj.TRACK_SESSION, psConstantsObj.TRACK_START, curTimestamp, "", "", "", "", "", "");
        machineLearningDataObj.incNumSessions();
    };

    this.trackAppPause = function () {
        var curTimestamp = utilObj.getCurrentTimestamp();
        sessionEndAt = curTimestamp;
        trackObj.trackCounter(psConstantsObj.TRACK_SESSION, psConstantsObj.TRACK_END, curTimestamp, "", "", "", "", "", "");
        trackObj.trackCounter(psConstantsObj.TRACK_SESSION, psConstantsObj.TRACK_LENGTH, curTimestamp - sessionStartAt, "", "", "", "", "", "");
        machineLearningDataObj.incSessionTime(curTimestamp - sessionStartAt);
        machineLearningDataObj.setLastAppPauseTimeStamp(curTimestamp);
    };

    this.syncFabricEvent = function (eventName, status) {
        // if (utilObj.isIos()) {
        //     psUtilObj.makeNativeCall("Analytics", "syncFabricEvent:status:", eventName, status);
        // } else if (utilObj.isAndroid()) {
        //     psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "syncFabricEvent",
        //         "(Ljava/lang/String;Ljava/lang/String;)V", eventName, status);
        // }
    };

    this.setUserId = function (refId) {
        if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("Analytics", "setUserId:", refId);
        } else if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "setUserId",
                "(Ljava/lang/String;)V", refId);
        }
    };

    this.setDeviceInfo = function (cpuArch, deviceWidth, deviceHeight, deviceModel, deviceId, country, isOnline) {
        cpuArch = cpuArch + "";
        deviceWidth = deviceWidth + "";
        deviceHeight = deviceHeight + "";
        deviceModel = deviceModel + "";
        deviceId = deviceId + "";
        country = country + "";
        isOnline = isOnline + "";
        if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("Analytics", "setDeviceInfo:deviceWidth:deviceHeight:deviceModel:deviceId:country:isOnline:",
                cpuArch, deviceWidth, deviceHeight, deviceModel, deviceId, country, isOnline);
        } else if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "setDeviceInfo",
                "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V",
                cpuArch, deviceWidth, deviceHeight, deviceModel, deviceId, country, isOnline);
        }
    };

    this.triggerRefIdEvent = function () {
        // If user is offline when app is loaded for first time, this event will get triggered immediately.
        // If user is online on 1st load and refid is created in this session, appropriate bucket will get triggered.
        // If user is online on 1st load, but refid doesn't get generated in this session
        // - In this case, when refid gets generated, the after_first_session event will get triggered.
        var val = "offline";
        var refId = userObj.getRefId();
        if (refId == "" && utilObj.isOnline()) {
            return;
        }
        if (refId != "") {
            var curTimestamp = utilObj.getCurrentTimestamp();
            var timeTaken = curTimestamp - firstLoadStart;
            if (!isFirstLoad) {
                val = "after_1st_session";
            } else if (timeTaken <= 5) {
                val = "5";
            } else if (timeTaken <= 10) {
                val = "10";
            } else if (timeTaken <= 20) {
                val = "20";
            } else if (timeTaken <= 30) {
                val = "30";
            } else if (timeTaken <= 60) {
                val = "60";
            } else if (timeTaken > 1500) {
                val = "infinite";
            } else {
                val = "60+";
            }
        }
        
        analyticsObj.syncFabricEvent("refIdTime", val);
    };

    /**
     * returns the function to be used for triggering adjust event
     * @param eventType
     * @returns {*}
     */
    this.getAdjustEventFunction = function (eventType) {
        if (analyticsObj.isAdjustCustomEvent(eventType)) {
            return analyticsObj.triggerAdjustCustomEvent;
        }
        return analyticsObj.triggerAdjustEvent;
    };

    /**
     * triggers Adjust and FireBase events for the given eventType and parameters
     * @param eventType
     * @param eventParam
     */
    this.triggerEvents = function (eventType, eventParam) {
        // loggerObj.debugLog("triggeringEventsLog: trigger events called with eventType, eventParam -> ", eventType, eventParam);
        var adjustEventTriggerFunction = analyticsObj.getAdjustEventFunction(eventType);
        adjustEventTriggerFunction(analyticsObj.getKeyForAdjustEvent(eventType, eventParam));
        analyticsObj.sendFirebaseCustomEvent(analyticsObj.getKeyForFirebaseEvent(eventType, eventParam));
        analyticsObj.checkAndFireCallbacks();
    };

    /**
     * gets key for Adjust EVent for given eventType and parameters
     * @param eventType
     * @param eventParam
     * @returns {*}
     */
    this.getKeyForAdjustEvent = function (eventType, eventParam) {
        // loggerObj.debugLog("triggeringEventsLog: getting key for adjust event");
        var func = function () {
            return "";
        };

        if (eventType == undefined || eventType == null) {
            // loggerObj.debugLog("triggeringEventsLog: eventType undefined or null: eventType -> ", eventType);
            return func();
        }

        if (eventType == psConstantsObj.EVENT_TYPE_DAU) {
            return constantsObj.ADJUST_DAU;
        }
        if (eventType == psConstantsObj.EVENT_TYPE_FACEBOOK_CONNECT) {
            return constantsObj.ADJUST_FACEBOOK_CONNECTED;
        }
        if (eventType == psConstantsObj.EVENT_TYPE_INSTALL_LAUNCH) {
            return constantsObj.ADJUST_INSTALL_LAUNCH;
        }
        if (eventType == psConstantsObj.EVENT_TYPE_PHONE_USER) {
            return constantsObj.ADJUST_PHONE_USER;
        }
        if (eventType == psConstantsObj.EVENT_TYPE_PUZZLE_CLEAR_20_GHOST) {
            return constantsObj.ADJUST_PUZZLE_20_CLEAR_GHOST;
        }
        if (eventType == psConstantsObj.EVENT_TYPE_VIDEO_VIEW) {
            return constantsObj.ADJUST_VIDEO_VIEW;
        }
        if (eventType == psConstantsObj.EVENT_TYPE_HINT_RETENTION) {
            return constantsObj.ADJUST_HINT_RETENTION;
        }
        if (eventType == psConstantsObj.EVENT_TYPE_REWARDED_VIDEO_IMPRESSION) {
            return constantsObj.ADJUST_REWARDED_VIDEO_IMPRESSION;
        }
        if (eventType == psConstantsObj.EVENT_TYPE_OFFERWALL_EARN) {
            return constantsObj.ADJUST_OFFERWALL_EARN;
        }
        if (eventType == psConstantsObj.EVENT_TYPE_PURCHASE_COMPLETED) {
            return constantsObj.ADJUST_PURCHASE_COMPLETED;
        }
        if (eventType == psConstantsObj.EVENT_TYPE_NEW_SESSION) {
            return constantsObj.ADJUST_NEW_SESSION;
        }

        if (eventType == psConstantsObj.EVENT_TYPE_PUZZLE_CLEAR) {
            func = analyticsObj.getPuzzleClearKeyForAdjustEvent;
        } else if (eventType == psConstantsObj.EVENT_TYPE_PUZZLE_CLEAR_PHONE) {
            func = analyticsObj.getPuzzleClearPhoneKeyForAdjustEvent;
        } else if (eventType == psConstantsObj.EVENT_TYPE_RETENTION_DAYS) {
            func = analyticsObj.getRetentionDaysKeyForAdjustEvent;
        } else if (eventType == psConstantsObj.EVENT_TYPE_WATCH_VIDEOS) {
            func = analyticsObj.getWatchVideoKeyForAdjustEvent;
        } else if (eventType == psConstantsObj.EVENT_TYPE_SHUFFLE) {
            func = analyticsObj.getShuffleKeyForAdjustEvent;
        } else if (eventType == psConstantsObj.EVENT_TYPE_SHUFFLE_PHONE) {
            func = analyticsObj.getShufflePhoneKeyForAdjustEvent;
        } else if (eventType == psConstantsObj.EVENT_TYPE_D0_SESSIONS) {
            func = analyticsObj.getD0SessionsKeyForAdjustEvent;
        } else if (eventType == psConstantsObj.EVENT_TYPE_D0_SESSIONS_PHONE) {
            func = analyticsObj.getD0SessionsPhonePhoneKeyForAdjustEvent;
        } else if (eventType == psConstantsObj.EVENT_TYPE_WORD_CLEARS) {
            func = analyticsObj.getWordClearsKeyForAdjustEvent;
        } else if (eventType == psConstantsObj.EVENT_TYPE_SUBSCRIPTION) {
            func = analyticsObj.getSubscriptionKeyForAdjustEvent;
        } else if (eventType == psConstantsObj.EVENT_TYPE_PUZZLE_COMPLETED) {
            func = analyticsObj.getPuzzleCompletedKeyForAdjustEvent;
        }
        return func(eventParam);
    };

    /**
     * this function fires FireBase Custom Event for the eventName
     * @param eventName
     * @param refId
     */
    this.sendFirebaseCustomEvent = function (eventName) {
        // loggerObj.debugLog("triggeringEventsLog: firebase custom event : eventName -> ", eventName);
        if (eventName == undefined || eventName == null || eventName == "") {
            return;
        }

        // loggerObj.debugLog("triggeringEventsLog: success");
        var refId = userObj.getRefId();
        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Analytics", "sendFirebaseCustomEvent",
                "(Ljava/lang/String;Ljava/lang/String;)V", eventName, refId);
        } else if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("Analytics", "sendFirebaseCustomEvent:refId:", eventName, refId);
        }
    };

    this.isAdjustCustomEvent = function (eventType) {
        var adjustCustomEventsArr = psConstantsObj.ADJUST_CUSTOM_EVENT_TYPES;
        if (adjustCustomEventsArr.indexOf(eventType) != -1) {
            return true;
        }
        return false;
    };

    /**
     * gets keys for FireBase events for the given eventType and parameters
     * @param eventType
     * @param eventParam
     * @returns {*}
     */
    this.getKeyForFirebaseEvent = function (eventType, eventParam) {
        // loggerObj.debugLog("triggeringEventsLog: getting key for firebase event");
        var keyString = "";
        if (eventType == undefined || eventType == null) {
            // loggerObj.debugLog("triggeringEventsLog: invalid eventType: eventType -> ", eventType);
            return keyString;
        }

        if (!analyticsObj.shouldFireFirebaseEvent(eventType, eventParam)) {
            // loggerObj.debugLog("triggeringEventsLog: should not firebase event returns here : eventType, eventParam -> ", eventType, eventParam);
            return keyString;
        }

        if (eventType == psConstantsObj.EVENT_TYPE_DAU) {
            return psConstantsObj.FIREBASE_DAU;
        }
        if (eventType == psConstantsObj.EVENT_TYPE_FACEBOOK_CONNECT) {
            return psConstantsObj.FIREBASE_FACEBOOK_CONNECTED;
        }
        if (eventType == psConstantsObj.EVENT_TYPE_INSTALL_LAUNCH) {
            return psConstantsObj.FIREBASE_INSTALL_LAUNCH;
        }
        if (eventType == psConstantsObj.EVENT_TYPE_PHONE_USER) {
            return psConstantsObj.FIREBASE_PHONE_USER;
        }
        if (eventType == psConstantsObj.EVENT_TYPE_PUZZLE_CLEAR_20_GHOST) {
            return psConstantsObj.FIREBASE_PUZZLE_20_CLEAR_GHOST;
        }
        if (eventType == psConstantsObj.EVENT_TYPE_VIDEO_VIEW) {
            return psConstantsObj.FIREBASE_VIDEO_VIEW
        }
        if (eventType == psConstantsObj.EVENT_TYPE_HINT_RETENTION) {
            return keyString;
        }
        if (eventType == psConstantsObj.EVENT_TYPE_WORD_CLEARS) {
            return analyticsObj.getWordClearsKeyForFirebaseEvent(eventParam);
        }
        if (eventType == psConstantsObj.EVENT_TYPE_REWARDED_VIDEO_IMPRESSION) {
            return psConstantsObj.FIREBASE_REWARDED_VIDEO_IMPRESSION;
        }
        if (eventType == psConstantsObj.EVENT_TYPE_OFFERWALL_EARN) {
            return psConstantsObj.FIREBASE_OFFERWALL_EARN;
        }
        if (eventType == psConstantsObj.EVENT_TYPE_PURCHASE_COMPLETED) {
            return psConstantsObj.FIREBASE_PURCHASE_COMPLETED;
        }

        // only if firebase event needs to be fired for puzzle clear, it should be fired
        // similarly for retention days event and watch videos event

        if (eventType == psConstantsObj.EVENT_TYPE_PUZZLE_CLEAR) {
            keyString = stringsObj.firebase_event_puzzle_clear;
        } else if (eventType == psConstantsObj.EVENT_TYPE_PUZZLE_CLEAR_PHONE) {
            keyString = stringsObj.firebase_event_puzzle_clear_phone;
        }  else if (eventType == psConstantsObj.EVENT_TYPE_RETENTION_DAYS) {
            keyString = stringsObj.firebase_event_retained_user;
        } else if (eventType == psConstantsObj.EVENT_TYPE_WATCH_VIDEOS) {
            keyString = stringsObj.firebase_event_watch_video;
        } else if (eventType == psConstantsObj.EVENT_TYPE_SHUFFLE) {
            keyString = stringsObj.firebase_event_shuffle;
        } else if (eventType == psConstantsObj.EVENT_TYPE_SHUFFLE_PHONE) {
            keyString = stringsObj.firebase_event_shuffle_phone;
        } else if (eventType == psConstantsObj.EVENT_TYPE_D0_SESSIONS) {
            keyString = stringsObj.firebase_event_d0_sessions;
        } else if (eventType == psConstantsObj.EVENT_TYPE_D0_SESSIONS_PHONE) {
            keyString = stringsObj.firebase_event_d0_sessions_phone;
        } else if (eventType == psConstantsObj.EVENT_TYPE_SUBSCRIPTION) {
            keyString = stringsObj.firebase_event_subscription;
        } else if (eventType == psConstantsObj.EVENT_TYPE_PUZZLE_COMPLETED) {
            keyString = stringsObj.firebase_event_puzzle_clear;
        }
        return keyString.replace("%N%", eventParam);
    };

    /**
     * checks if the firebase event should be fired for the given eventType and event Parameter
     * @param eventType
     * @param eventParam
     * @returns {boolean}
     */
    this.shouldFireFirebaseEvent = function (eventType, eventParam) {
        // loggerObj.debugLog("triggeringEventsLog: shouldFireFirebase Event");
        if (eventType == undefined || eventType == null) {
            // loggerObj.debugLog("triggeringEventsLog: invalid eventType: eventType -> ", eventType);
            return false;
        }

        var value = eventParam;
        var valuesArr = analyticsObj.getValuesArrForFirebaseEvent(eventType);
        return ((valuesArr.length == 0) ? true : ((valuesArr.indexOf(value) != -1) ? true : false));
    };

    /**
     * returns the values array for Firebase events
     */
    this.getValuesArrForFirebaseEvent = function (eventType) {
        var valuesArr = [];
        if (eventType == psConstantsObj.EVENT_TYPE_PUZZLE_CLEAR) {
            valuesArr = constantsObj.FIREBASE_PUZZLE_CLEAR_VALUES;
        } else if (eventType == psConstantsObj.EVENT_TYPE_PUZZLE_CLEAR_PHONE) {
            valuesArr = constantsObj.FIREBASE_PUZZLE_CLEAR_PHONE_VALUES;
        } else if (eventType == psConstantsObj.EVENT_TYPE_RETENTION_DAYS) {
            valuesArr = constantsObj.FIREBASE_RETENTION_DAY_VALUES;
        } else if (eventType == psConstantsObj.EVENT_TYPE_WATCH_VIDEOS) {
            valuesArr = constantsObj.FIREBASE_WATCH_VIDEO_EVENT_VALUES;
        } else if (eventType == psConstantsObj.EVENT_TYPE_SHUFFLE) {
            valuesArr = constantsObj.FIREBASE_SHUFFLE_VALUES;
        } else if (eventType == psConstantsObj.EVENT_TYPE_SHUFFLE_PHONE) {
            valuesArr = constantsObj.FIREBASE_SHUFFLE_PHONE_VALUES;
        } else if (eventType == psConstantsObj.EVENT_TYPE_D0_SESSIONS) {
            valuesArr = constantsObj.FIREBASE_D0_SESSIONS_VALUES;
        } else if (eventType == psConstantsObj.EVENT_TYPE_D0_SESSIONS_PHONE) {
            valuesArr = constantsObj.FIREBASE_D0_SESSIONS_PHONE_VALUES;
        }
        return valuesArr;
    };

    /**
     * gets keys for watch Video Events for Adjust
     * @param videoCount
     * @returns {string}
     */
    this.getWatchVideoKeyForAdjustEvent = function (videoCount) {
        // loggerObj.debugLog("triggeringEventsLog: getting watch videos event key value for adjust");
        var keyValue = "";
        if (videoCount == null || videoCount == undefined || isNaN(videoCount)) {
            // loggerObj.debugLog("triggeringEventsLog: invalid videoCount value : videoCount -> ", videoCount);
            return keyValue;
        }

        switch (videoCount) {
            case 5:
                keyValue = constantsObj.ADJUST_WATCH_5_VIDEOS;
                break;
            case 10:
                keyValue = constantsObj.ADJUST_WATCH_10_VIDEOS;
                break;
            default:
                break;
        }
        return keyValue;
    };

    /**
     * gets keys for retention days events for Adjust
     * @param dayValue
     * @returns {string}
     */
    this.getRetentionDaysKeyForAdjustEvent = function (dayValue) {
        // loggerObj.debugLog("triggeringEventsLog: getting retention events key for Adjust");
        var keyValue = "";
        if (dayValue == null || dayValue == undefined || isNaN(dayValue)) {
            // loggerObj.debugLog("triggeringEventsLog: invalid dayValue : dayValue -> ", dayValue);
            return keyValue;
        }

        switch (dayValue) {
            case 1:
                keyValue = constantsObj.ADJUST_D1_RETAIN;
                break;
            case 2:
                keyValue = constantsObj.ADJUST_D2_RETAIN;
                break;
            case 3:
                keyValue = constantsObj.ADJUST_D3_RETAIN;
                break;
            case 7:
                keyValue = constantsObj.ADJUST_D7_RETAIN;
                break;
            default:
                break;
        }
        return keyValue;
    };

    /**
     * gets the key for puzzle clear events for adjust
     * @param puzNum
     * @returns {string}
     */
    this.getPuzzleClearKeyForAdjustEvent = function (puzNum) {
        // loggerObj.debugLog("triggeringEventsLog: getting puzzle clear key for adjust event");
        var keyValue = "";
        if (puzNum == null || puzNum == undefined || isNaN(puzNum)) {
            // loggerObj.debugLog("triggeringEventsLog: puzNum has invalid value : puzNum -> ", puzNum);
            return keyValue;
        }
        keyValue = constantsObj.ADJUST_EVENT_NAMES[puzNum];
        return keyValue;
    };

    /**
     * Method for returning the key for puzzle clear phone events for adjust.
     * @param puzNum
     * @return {string}
     */
    this.getPuzzleClearPhoneKeyForAdjustEvent = function (puzNum) {
        var keyValue = "";
        if (puzNum == null || puzNum == undefined || isNaN(puzNum)) {
            // loggerObj.debugLog("triggeringEventsLog: puzNum has invalid value : puzNum -> ", puzNum);
            return keyValue;
        }
        keyValue = constantsObj.ADJUST_EVENT_NAMES_PHONE[puzNum];
        return keyValue;
    };

    /**
     * Method for returning adjust key for shuffle events.
     * @param numTimesShuffle
     * @return {*}
     */
    this.getShuffleKeyForAdjustEvent = function (numTimesShuffle) {
        return constantsObj.ADJUST_SHUFFLE[numTimesShuffle];
    };

    /**
     * Method for returning adjust key for shuffle events for phone.
     * @param numTimesShuffle
     * @return {*}
     */
    this.getShufflePhoneKeyForAdjustEvent = function (numTimesShuffle) {
        return constantsObj.ADJUST_SHUFFLE_PHONE[numTimesShuffle];
    };

    /**
     * Method for returning adjust key based on number of D0 sessions.
     * @param numDOSessions
     * @return {*}
     */
    this.getD0SessionsKeyForAdjustEvent = function (numDOSessions) {
        return constantsObj.ADJUST_SESSIONS_D0[numDOSessions];
    };

    /**
     * Method for returning adjust key based on number of D0 sessions for phone.
     * @param numTimesShuffle
     * @return {*}
     */
    this.getD0SessionsPhonePhoneKeyForAdjustEvent = function (numTimesShuffle) {
        return constantsObj.ADJUST_SESSIONS_D0_PHONE[numTimesShuffle];
    };

    this.timeSinceResume = function () {
        if (sessionStartAt > 0) {
            return psUtilObj.getCurrentTimestamp() - sessionStartAt;
        }
        return 0;
    };

    this.getSubscriptionKeyForAdjustEvent = function (pkgId) {
        // loggerObj.debugLog("triggeringEventsLog: subscription -> ", pkgId);
        return subscriptionsObj.getAdjustIdToFireForSubscription(pkgId);
    };

    /**
     * gets the word clears keys for adjust events
     * @param numWordsCleared
     * @returns {*}
     */
    this.getWordClearsKeyForAdjustEvent = function (numWordsCleared) {
        return analyticsObj.getWordClearsKeyForEvent(constantsObj.ADJUST_EVENT, numWordsCleared);
    };

    /**
     * gets the word clears key for firebase events
     * @param numWordsCleared
     * @returns {*}
     */
    this.getWordClearsKeyForFirebaseEvent = function (numWordsCleared) {
        return analyticsObj.getWordClearsKeyForEvent(constantsObj.FIREBASE_EVENT, numWordsCleared);
    };

    /**
     * this function returns the word clears event key depending upon the event Type
     * @param event
     * @param numWordsCleared
     * @returns {*}
     */
    this.getWordClearsKeyForEvent = function (event, numWordsCleared) {
        var keyValue = "";
        if (!gameObj.getIsAdjustThirtyWordTriggered()) {
            if (numWordsCleared >= 30) {
                if (event == constantsObj.ADJUST_EVENT) {
                    eventsCallback = gameObj.markAdjustThirtyWordTriggered;
                    return constantsObj.ADJUST_30_WORD_CLEAR;
                } else {
                    return stringsObj.firebase_event_30_word_clears;
                }
            }
        }
        if (!gameObj.getIsAdjustFiftyWordTriggered()) {
            if (numWordsCleared >= 50) {
                if (event == constantsObj.ADJUST_EVENT) {
                    eventsCallback = gameObj.markAdjustFiftyWordTriggered;
                    return constantsObj.ADJUST_50_WORD_CLEAR;
                } else {
                    return stringsObj.firebase_event_50_word_clears;
                }
            }
        }
        return keyValue;
    };

    /**
     * for firing adjust event for the new session
     */
    this.fireSessionEvent = function () {
        var runtimeForDaysSinceInstall = runtimeObj.getDaysForSessionEvent();
        var currentTimeStamp = utilObj.getCurrentTimestamp();
        var installTimeStamp = gameObj.getInstallTimeStamp();

        if (currentTimeStamp - installTimeStamp < runtimeForDaysSinceInstall * constantsObj.SECONDS_IN_DAY) {
            var lastPauseTime = machineLearningDataObj.getLastAppPauseTimeStamp();
            if (currentTimeStamp - lastPauseTime >= 30 * constantsObj.SECONDS_IN_MIN) {
                analyticsObj.triggerEvents(constantsObj.EVENT_TYPE_NEW_SESSION);
            }
        }
    };

    /**
     * this function checks and fires any callback if set
     */
    this.checkAndFireCallbacks = function () {
        if (eventsCallback == null || !eventsCallback) {
            // loggerObj.debugLog("triggeringEventsLog: not firing any callback as no callback is set");
            return;
        }
        eventsCallback();
    };

    this.getSessionStartTime = function(){
        return sessionStartAt;
    };

    /**
     * gets the key for puzzle clear events for adjust
     * @param puzNum
     * @returns {string}
     */
    this.getPuzzleCompletedKeyForAdjustEvent = function (puzNum) {
        // loggerObj.debugLog("triggeringEventsLog: getting puzzle clear key for adjust event");
        var keyValue = "";
        if (puzNum == null || puzNum == undefined || isNaN(puzNum)) {
            // loggerObj.debugLog("triggeringEventsLog: puzNum has invalid value : puzNum -> ", puzNum);
            return keyValue;
        }
        switch (puzNum) {
            case 2:
                keyValue = constantsObj.ADJUST_TWO_PUZZLE_COMPLETED;
                break;
            case 3:
                keyValue = constantsObj.ADJUST_THREE_PUZZLE_COMPLETED;
                break;
            case 4:
                keyValue = constantsObj.ADJUST_FOUR_PUZZLE_COMPLETED;
                break;
            case 5:
                keyValue = constantsObj.ADJUST_FIVE_PUZZLE_COMPLETED;
                break;
            case 7:
                keyValue = constantsObj.ADJUST_SEVEN_PUZZLE_COMPLETED;
                break;
            default:
                break;
        }

        return keyValue;
    };

};