Controller = function (resturi) {
    var conn = new Connection(this);
    var reqStarts = {};
    var restEndPoint = resturi;

    function setReqStart(controller, action) {
        if (controller != "track") {
            var curTimestampMs = utilObj.getCurrentTimestampMs();
            reqStarts[controller + ";" + action] = curTimestampMs;
            reqStarts[controller] = curTimestampMs; //For the cases in which the response is a failure and doesn't have
                                                    // action
        }
    }

    this.processResponse = function (response, ts) {
        if(ts != constantsObj.NOT_FOUND) {
            response = psUtilObj.getDecryptedMessage(response,ts);
        }
        var res = null;
        try {
            res = JSON.parse(response);
        } catch (e) {
            // loggerObj.debugLog("the JSON has some problem");
            return;
        }
        var controller = res.c;
        var success = res.s;
        var action = res.a;
        var data = res.d;
        // loggerObj.debugLog("Response received:", controller, action, success, data);

        var logger_msg = "Resp: " + "c:" + controller + "a:" + action + "s:" + success + "t:" + utilObj.getCurrentTimestamp();
        psUtilObj.sendReport(logger_msg);
        var startKey = controller + ";" + action;
        var timeTaken = constantsObj.NOT_FOUND;
        var curTimestampMs = utilObj.getCurrentTimestampMs();
        if (controller != "track") {
            if (reqStarts[startKey] != undefined && reqStarts[startKey] != constantsObj.NOT_FOUND) {
                timeTaken = curTimestampMs - reqStarts[startKey];
                reqStarts[startKey] = constantsObj.NOT_FOUND;
                trackObj.trackCounterSampled(psConstantsObj.TRACK_PERF, "resp", controller, action, timeTaken, success, "1", timeTaken, "");
            } else if (reqStarts[controller] != undefined && reqStarts[controller] != constantsObj.NOT_FOUND) {
                // This may be a failure case - since in this case the sent and received action differ.
                timeTaken = curTimestampMs - reqStarts[controller];
                trackObj.trackCounterSampled(psConstantsObj.TRACK_PERF, "resp", controller, action, timeTaken, success, "0", timeTaken, "");
            }
            // loggerObj.infoLog("Resp time:", controller, action, timeTaken);
        }

        if (controller === "user" || controller === "ip") {
            userObj.respHandler(action, data, success);
		} else if (controller === "track") {
            trackObj.respHandler(action, data, success);
        } else if (controller == "dau_mapping") {
            // Nothing to handle for this response right now.
        } else {
			gameSpecificObj.respHandler(controller, action, data, success);
		}
    };

    this.sendHttpRequest = function (controller, action, map) {
        return;
        var msg = {
            c: controller,
            a: action,
            d: map
        };
        // loggerObj.debugLog("Sending HTTP - 1: controller:" + controller + "; action:" + action, utilObj.getStringifiedJson(map));

        var logger_msg = "Req: " + "c:" + controller + "a:" + action + "t:" + utilObj.getCurrentTimestamp();
        psUtilObj.sendReport(logger_msg);
        setReqStart(controller, action);
        if (restEndPoint != null) {
            var customUrl = restEndPoint;
            conn.sendHttpMsg(customUrl, encodeURI(JSON.stringify(msg)));

        } else {
            loggerObj.errorLog("rest api end point not set");
        }
    };

    this.sendHttpRequest2 = function (controller, action, map) {
        if (controller != "track") {
            map = psUtilObj.getGameUserInfoHashParams(map);
            map = psUtilObj.getUpdatedInfo(map);
        }
        var msg = {
            c: controller,
            a: action,
            d: map
        };

        var ts = constantsObj.NOT_FOUND;
        if(controller != "track") {
            ts = psUtilObj.getCurrentTimestamp();
            msg = psUtilObj.getEncryptedMessage(utilObj.getStringifiedJson(msg), ts).toString();
        }
        // loggerObj.debugLog("Sending HTTP - 1: msg controller:" + controller + "; action:" + action, restEndPoint, utilObj.getStringifiedJson(msg));
        var logger_msg = "Req: " + "c:" + controller + "a:" + action + "t:" + utilObj.getCurrentTimestamp();
        psUtilObj.sendReport(logger_msg);
        setReqStart(controller, action);
        if (restEndPoint != null) {
            var customUrl = restEndPoint;
            var encMsg = "";
            if(ts != -1) {
                encMsg = encodeURIComponent(msg);
            } else {
                encMsg = encodeURI(JSON.stringify(msg));
            }
            conn.sendHttpMsg(customUrl, encMsg, ts);

        } else {
            loggerObj.errorLog("rest api end point not set");
        }
    };

    this.getHttpConnectionFailureCount = function () {
        return conn.getHttpConnectionFailureCount();
    };
};
