FacebookWrapper = function () {
    var nativeClassName = "FacebookWrapper";

    var PUBLISH = "publish_actions";
    var fbAction = constantsObj.NOT_FOUND;

    var REQ_FRIENDS = 1;
    var REQ_INVITABLE_FRIENDS = 2;
    var REQ_ALL_OPEN = 3;
    var REQ_DELETE_OPEN = 4;
    var REQ_PHOTO_UPLOAD = 5;
    var REQ_LEVELUP_COGS = 6;
    var REQ_SPINNER_COGS = 7;
    var USER_INFO = 8;


    var ACCESS_TOKEN = "accessToken",
        SUCCESS = "success",
        API_ID = "apiId",
        KEY_POST_ID = "postId",
        KEY_ERROR = "error",
        KEY_TO = "to";

    var TYPE = "type",
        TYPE_LOGIN = "login",
        TYPE_API = "api",
        TYPE_LOGOUT = "logout",
        TYPE_LINK_SHARE = "linkShare",
        TYPE_APP_REQUEST = "appRequest";


    var actionTitle = "",
        actionMessage = "",
        actionCb = null,
        actionTo = "";
    var VAL_SUCCESS = 0,
        VAL_CANCEL = 1,
        VAL_ERROR = 2;

    var fbPermsStr = "public_profile,email";

    var cb = null;
    this.meta = null;
    this.reqType = null;

    this.webLogin = false;
    this.accessToken = null;
    this.loggedIn = false;
    var lastAccessTokenFetch = 0;
    var lastLoginCheck = 0;
    var MIN_TOKEN_FETCH_INTERVAL = 300;
    var MIN_LOGIN_CHECK_INTERVAL = 30;

    function loginStatusChangeCallback(response) {
        // loggerObj.debugLog("check - fb6");
        // The response object is returned with a status field that lets the
        // app know the current login status of the person.
        // Full docs on the response object can be found in the documentation
        // for FB.getLoginStatus().
        if (response.status === 'connected') {
            // loggerObj.debugLog("check - fb7");
            // Logged into your app and Facebook.
            fbWrapperObj.loggedIn = true;
            fbWrapperObj.accessToken = response.authResponse.accessToken;
            fbWrapperObj.webLogin = true;

            var meta = {};
            if (response.authResponse.grantedScopes != undefined) {
                meta["permissions"] = response.authResponse.grantedScopes.split(",");
            } else {
                meta["permissions"] = [];
            }

            fbWrapperObj.loginCallback(0, meta);
        } else if (response.status === 'not_authorized') {
            // The person is logged into Facebook, but not your app.
            // loggerObj.debugLog("fb not auth");
            fbWrapperObj.webLogin = false;
        } else {
            // The person is not logged into Facebook, so we're not sure if
            // they are logged into this app or not.
            // loggerObj.debugLog("fb not connected");
            fbWrapperObj.webLogin = false;
        }
    }

    var FBERROR = -2;
    var webFbListener = {
        onApi: function (tag, response) {
            // loggerObj.debugLog("web callback", tag, response);
            fbListener.onAPI(tag, response);
        },
        onAppRequestsCallback: function (response, meta) {
            // loggerObj.debugLog("Callback after fb request:", utilObj.getStringifiedJson(response));
            var to = null;
            var reqId = response.request;

            var code = 0;
            if (reqId == FBERROR) {
                // loggerObj.debugLog("Sending request failed, error #" + code + ": " + utilObj.getStringifiedJson(response));
                fbWrapperObj.getAllRequests();
                return;
            } else {

            }

            to = response.to;
            fbRequestObj.storeReqId(reqId);
            if (meta == undefined) {
                meta = {};
            }

            var p = "", c = "", o = "", s = "";
            if (meta.s != undefined || meta.s != null) {
                s = meta.s
            }
            if (meta.p != undefined || meta.p != null) {
                p = meta.p
            }
            if (meta.c != undefined || meta.c != null) {
                c = meta.c
            }
            if (meta.o != undefined || meta.o != null) {
                o = meta.o
            }

            if (to == undefined || to == null) {
                // loggerObj.debugLog("requests not sent:", p, c, o, s);
                trackObj.trackCounter(psConstantsObj.TRACK_REQUEST, p, c, o, psConstantsObj.TRACK_NOT_SENT, "", s, "", "");
            } else {
                var sentCount = to.length;
                // loggerObj.debugLog("requests sent:", p, c, o, sentCount, s);
                trackObj.trackCounter(psConstantsObj.TRACK_REQUEST, p, c, o, psConstantsObj.TRACK_SENT, sentCount, s, "" + sentCount, "");
            }

            if (utilObj.isFunction(fbWrapperObj.cb)) {
                fbWrapperObj.cb(code, response, o);
            }

            // loggerObj.debugLog("reqType  = ", fbWrapperObj.reqType);
            if (fbWrapperObj.reqType == fbRequestObj.INVITE) {
                var code = 0;
                var response = {};
                response.to = [];
                fbRequestObj.inviteSuccess(code, response)
            } else if (fbWrapperObj.reqType != null) {
                fbRequestObj.clearRequests(fbWrapperObj.reqType, response.to);
            }
            utilObj.setFbDialogOpen(false);
        }
    };

    var fbListener = {
        onLogin: function (isLogin, msg) {
            // loggerObj.debugLog("Fb login res:", isLogin, utilObj.getStringifiedJson(msg));
            if (isLogin == 0) {
                var permissionList = msg["permissions"].split(",");
                if (msg[SUCCESS] == 0) {
                    // Successful login. Parsing and setting user information
                    userObj.updateInformationFromFbLogin(msg);
                }
                fbWrapperObj.loginCallback(msg[SUCCESS], {permissions: permissionList, accessToken: msg[ACCESS_TOKEN]});
            }
        },
        onAPI: function (tag, data) {
            var response = data;

            if (tag == REQ_FRIENDS) {
                friendsObj.updatePlaying(response);
            } else if (tag == REQ_INVITABLE_FRIENDS) {
                friendsObj.updateInvitable(response);
            } else if (tag == REQ_PHOTO_UPLOAD) {
                var res = false;
                if (response.hasOwnProperty("post_id")) {
                    res = true;
                    // loggerObj.debugLog("post_id: " + response["post_id"]);
                } else {
                    // loggerObj.debugLog("Graph API request failed, error #", tag, utilObj.getStringifiedJson(response));
                }

                fbWrapperObj.postPhotoResult(res);
            } else if (tag == REQ_ALL_OPEN) {
                var data = response.data;
                if (data && data.length > 0) {
                    fbRequestObj.handleOpenRequests(data);
                }
            } else if (tag == REQ_LEVELUP_COGS) {
                var curLevel = gameObj.getLevel();
                if (response.id != undefined) {
                    trackObj.trackCounter("og_story", psConstantsObj.TRACK_LEVELUP, curLevel, "post", "success", "", "", "", "");
                } else {
                    trackObj.trackCounter("og_story", psConstantsObj.TRACK_LEVELUP, curLevel, "post", "fail", "", "", "", "");
                    // loggerObj.debugLog("Graph API request failed, error #", tag, response);
                }
            } else if (tag == REQ_SPINNER_COGS) {
                var curLevel = gameObj.getLevel();
                if (response.id != undefined) {
                    trackObj.trackCounter("og_story", psConstantsObj.TRACK_SPIN, curLevel, "post", "success", "", "", "", "");
                } else {
                    trackObj.trackCounter("og_story", psConstantsObj.TRACK_SPIN, curLevel, "post", "fail", "", "", "", "");
                    // loggerObj.debugLog("Graph API request failed, error #", tag, response);
                }
            } else {
                // loggerObj.debugLog("no matching tag");
            }

        },
        onSharedSuccess: function (data) {
            // loggerObj.debugLog("On shared success:", utilObj.getStringifiedJson(data));
        },
        onSharedFailed: function (data) {
            // loggerObj.debugLog("on share failed", data);
            utilObj.showMessage(stringsObj.error_generic);
        },

        onSharedCancel: function () {
            // loggerObj.debugLog("On shared cancel");
        },

        onPermission: function (isLogin, msg) {
            // loggerObj.debugLog("Fb on permission res:", utilObj.getStringifiedJson(isLogin), utilObj.getStringifiedJson(msg));
            if (isLogin) {
                trackObj.trackCounter(psConstantsObj.TRACK_HOME, "fb_connect", psConstantsObj.TRACK_SUCCESS, psConstantsObj.TRACK_HOME, "", "", "", "0", "");

                userObj.syncToServer(true, psConstantsObj.NETWORK_FACEBOOK);
                homeLayer.updateFbConnect();
                fbWrapperObj.publishActionsCallback(0, msg);
            }
            analyticsObj.login(psConstantsObj.TRACK_FB, psConstantsObj.TRACK_HOME, isLogin);
        },

        onAppRequestCallBack: function (response, success) {
            if (success) {
                webFbListener.onAppRequestsCallback(response, fbWrapperObj.meta);
            }
        }
    };


    this.showDefaultFbInvite = function (message, title) {
        if (!utilObj.isWeb()) {
            var info = {
                "message": message,
                "title": title
            };
            var infoStr = utilObj.getStringifiedJson(info);
            if (utilObj.isAndroid()) {
                jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + nativeClassName,
                    "appRequests", "(Ljava/lang/String;)V", infoStr);
            } else if (utilObj.isIos()) {
                jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_IOS + nativeClassName,
                    "appRequests:reqType:", infoStr, "");
            }

        } else {
            FB.ui({
                method: 'apprequests',
                message: message,
                title: title
            }, function (response) {
                webFbListener.onAppRequestsCallback(response, fbWrapperObj.meta);
            });
        }
    };


    this.getFbListener = function () {
        return fbListener;
    };

    this.init = function () {
        if (utilObj.isWeb()) {
            window.fbAsyncInit = function () {
                FB.init({
                    appId: constantsObj.FB_APP_ID,
                    xfbml: true,
                    version: 'v2.8'
                });
                FB.getLoginStatus(function (response) {
                    loginStatusChangeCallback(response);
                });
            };

            (function (d, s, id) {
                var js, fjs = d.getElementsByTagName(s)[0];
                if (d.getElementById(id)) {
                    return;
                }
                js = d.createElement(s);
                js.id = id;
                js.src = "//connect.facebook.net/en_US/sdk.js";
                fjs.parentNode.insertBefore(js, fjs);
            }(document, 'script', 'facebook-jssdk'));
        }
    };

    this.login = function (callback) {
        cb = callback;
        if (!utilObj.isWeb()) {
            if (utilObj.isOnline()) {
                // loggerObj.debugLog("fb login:online");
                if (utilObj.isAndroid()) {
                    jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + nativeClassName,
                        "login", "(Ljava/lang/String;)V", fbPermsStr);
                } else if (utilObj.isIos()) {
                    jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_IOS + nativeClassName,
                        "login:", fbPermsStr);
                }
            } else {
                // loggerObj.debugLog("fb login: not online");
                utilObj.showMessage(stringsObj.not_online);
            }
        } else {
            // loggerObj.debugLog("check - fb5");
            FB.login(function (response) {
                loginStatusChangeCallback(response);
            }, {
                scope: 'public_profile,email',
                return_scopes: true
            });
        }
    };

    this.logout = function () {
        if (utilObj.isNative()) {
            if (utilObj.isAndroid()) {
                jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + nativeClassName,
                    "logout", "()V");
                fbWrapperObj.logoutCallback(0, null);
            } else if (utilObj.isIos()) {
                jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_IOS + nativeClassName,
                    "logout");
                fbWrapperObj.logoutCallback(0, null);
            }
            // TODO: Remove profile pic if downloaded
        } else {
            //logout in web is not supported
        }
    };

    this.isLoggedIn = function () {
        var success = false;
        var curTimestamp = utilObj.getCurrentTimestamp();
        if (curTimestamp - lastLoginCheck < MIN_LOGIN_CHECK_INTERVAL) {
            return fbWrapperObj.loggedIn;
        }

        try {
            if (!utilObj.isWeb()) {
                if (utilObj.isAndroid()) {
                    success = jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + nativeClassName,
                        "isFacebookLoggedIn", "()Z");
                } else if (utilObj.isIos()) {
                    success = jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_IOS + nativeClassName,
                        "isFacebookLoggedIn");
                }
                // loggerObj.debugLog("is logged in = ", success);
            } else {
                return fbWrapperObj.webLogin;
            }
        } catch (e) {
            // loggerObj.debugLog("Error while checking fb login");
        }

        lastLoginCheck = curTimestamp;
        fbWrapperObj.loggedIn = success;
        return success;
    };

    this.getAccessToken = function () {
        var token = '';
        if (utilObj.isNative()) {
            var curTimestamp = utilObj.getCurrentTimestamp();
            if (curTimestamp - lastAccessTokenFetch > MIN_TOKEN_FETCH_INTERVAL) {
                if (utilObj.isAndroid()) {
                    token = jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + nativeClassName,
                        "getAccessToken", "()Ljava/lang/String;");
                    fbWrapperObj.accessToken = token;
                    lastAccessTokenFetch = curTimestamp;
                    // loggerObj.debugLog("accesstoken fetched from Java = ", token);
                } else if (utilObj.isIos()) {
                    token = jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_IOS + nativeClassName,
                        "getAccessToken");
                }
            } else {
                token = fbWrapperObj.accessToken;
                // loggerObj.debugLog("accesstoken fetched locally = ", token);
            }
        } else {
            token = fbWrapperObj.accessToken;
        }
        return token;
    };

    this.logoutCallback = function (code, response) {
        // loggerObj.infoLog("Success code:", 0, code);
        if (code == 0) {
            lastAccessTokenFetch = 0;
            lastLoginCheck = 0;
            // loggerObj.infoLog("Logout succeeded");
            userObj.logout();
        } else {
            // loggerObj.errorLog("Logout failed, error #", code, utilObj.getStringifiedJson(response));
        }
    };

    this.loginCallback = function (code, response) {
        // loggerObj.debugLog("check - fb1");
        var success = false;
        if (code == 0) {
            success = true;
        }
        lastAccessTokenFetch = 0;
        lastLoginCheck = 0;
        analyticsObj.login(psConstantsObj.TRACK_FB, psConstantsObj.TRACK_HOME, success);
        if (code == 0) {
            // loggerObj.debugLog("check - fb2");
            var permissions = response["permissions"];
            trackObj.trackCounter(psConstantsObj.TRACK_HOME, psConstantsObj.TRACK_FB_CONNECT, psConstantsObj.TRACK_SUCCESS, "", "", "", "", "1", "");

            //analyticsObj.triggerAdjustEvent(constantsObj.ADJUST_FB_CONNECT);
            userObj.syncToServer(true, psConstantsObj.NETWORK_FACEBOOK);
            if (cb != null) {
                var tempCb = cb;
                cb = null;
                tempCb();
            } else {
                // homeLayer.updateFbConnect();
                fbWrapperObj.getAllRequests();
            }
        } else {
            if (!utilObj.isNative()) {
                if (code == 1) {
                    location.reload();
                    return;
                }
            }
            utilObj.showMessage(stringsObj.error_generic);
            // loggerObj.debugLog("Login failed, error #" + code, utilObj.getStringifiedJson(response));
        }
    };

    this.updateD0Puzzle = function () {
        // loggerObj.debugLog("check - fb3");
        var createdTimeStamp = gameObj.getCreatedTime();
        if (createdTimeStamp == 0) {
            // loggerObj.debugLog("check - fb4");
            utilObj.delayedCallback(curLayer, fbWrapperObj.updateD0Puzzle, 3);
            return;
        }

        if (createdTimeStamp > 1488359718) {//1506438562
            // loggerObj.debugLog("check - fb7");
            var createdDate = new Date(createdTimeStamp * 1000);
            //var date = new Date(createdTimeStamp);
            var puzzleId = utilObj.getIdForDate(createdDate);
            var todaysPuzzleDate = utilObj.getDateForId(puzzleId);
            // loggerObj.debugLog("scores checking", gameObj.getFirstLoadTime(), todaysPuzzleDate);
            if (parseInt(gameObj.getFirstLoadTime()) < parseInt(todaysPuzzleDate)) {
                return;
            }

            var day = todaysPuzzleDate.getDay();
            if (day == 0) {
                day = 7;
            }
            // loggerObj.debugLog("scores djain fblogin 1", puzzleId);
            gameObj.setInstallDay(puzzleId);

            var puzzleId1 = "2017000" + day;
            // loggerObj.debugLog("scores djain fblogin 2", puzzleId1);
            gameObj.setD0Id(puzzleId1);
        } else {
            gameObj.setInstallDay("20170301");
            if (gameObj.getD0Id() == 0 || gameObj.getD0Id() == null) {
                gameObj.setD0Id("20170003");
            }

        }
    };

    this.getPublishPerms = function () {
        if (utilObj.isNative()) {
            if (utilObj.isAndroid()) {
                jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + nativeClassName,
                    "login", "(Ljava/lang/String;)V", "publish_actions");
            } else {
                jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_IOS + nativeClassName,
                    "login:", "publish_actions");
            }
        } else {
            FB.api('/me/permissions', function (response) {
                var declined = [];
                for (var i = 0; i < response.data.length; i++) {
                    if (response.data[i].status == 'declined') {
                        declined.push(response.data[i].permission)
                    } else {
                        gameObj.setHasPublishPerms(true);
                    }
                    // loggerObj.debugLog("Status:", response.data[i].status);
                }
                FB.login(function (response) {
                    loginStatusChangeCallback(response);
                }, {
                    "scope": declined,
                    auth_type: 'rerequest'
                });
            });
        }
    };

    this.publishActionsCallback = function (code, response) {
        // loggerObj.debugLog("Publish actions callback:", code, utilObj.getStringifiedJson(response));
        if (code == 0) {
            // loggerObj.debugLog("Sharing screenshot after login");
            if (fbAction == constantsObj.FB_ACTION_POST_PHOTO) {
                gameObj.shareScreenshot();
            }
        } else {

        }
        fbAction = constantsObj.NOT_FOUND;
    };

    this.getUserId = function () {
        var userId = "";
        if (utilObj.isNative()) {
            if (utilObj.isAndroid()) {
                userId = jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + nativeClassName,
                    "getUserId", "()Ljava/lang/String;");
            } else if (utilObj.isIos()) {
                userId = jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_IOS + nativeClassName,
                    "getUserId");
            }
        } else {
            //    TODO userid for web
        }
        return userId;
    };

    this.getPlayingFriends = function () {
        return;
        if (!fbWrapperObj.isLoggedIn()) {
            // loggerObj.debugLog("Attempting fb login check from playing friends");
            return;
        }
        // loggerObj.debugLog("get playing friends");
        var params = {};
        params["limit"] = 200;
        params["fields"] = "name,picture.width(200).height(200)";
        if (utilObj.isNative()) {
            var paramsStr = utilObj.getStringifiedJson(params);
            // loggerObj.debugLog("Passing params:", paramsStr);
            if (utilObj.isAndroid()) {
                jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + nativeClassName,
                    "onApi", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;I)V", "/me/friends", "GET",
                    paramsStr, REQ_FRIENDS);
            } else if (utilObj.isIos()) {
                jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_IOS + nativeClassName,
                    "onApi:mode:params:apiId:", "/me/friends", "GET",
                    paramsStr, REQ_FRIENDS);
            }
        } else {
            FB.api("/me/friends", params, function (response) {
                webFbListener.onApi(REQ_FRIENDS, response)
            });
        }
    };

    this.getInvitableFriends = function () {
        return;
        var params = {};
        params["fields"] = "name,picture.width(200).height(200)";
        params["limit"] = 5000;
        if (utilObj.isNative()) {
            var paramsStr = utilObj.getStringifiedJson(params);
            if (utilObj.isAndroid()) {
                jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + nativeClassName,
                    "onApi", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;I)V", "/me/invitable_friends", "GET",
                    paramsStr, REQ_INVITABLE_FRIENDS);
            } else if (utilObj.isIos()) {
                jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_IOS + nativeClassName,
                    "onApi:mode:params:apiId:", "/me/invitable_friends", "GET",
                    paramsStr, REQ_INVITABLE_FRIENDS);
            }
        } else {
            FB.api("/me/invitable_friends", params, function (response) {
                webFbListener.onApi(REQ_INVITABLE_FRIENDS, response)
            });
        }
    };

    this.getAllRequests = function () {
        if (!fbWrapperObj.isLoggedIn()) {
            return;
        }

        if (!utilObj.isWeb()) {
            var params = {"fields": ""};
            var paramsStr = utilObj.getStringifiedJson(params);
            if (utilObj.isAndroid()) {
                jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + nativeClassName,
                    "onApi", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;I)V", "/me/apprequests", "GET",
                    paramsStr, REQ_ALL_OPEN);
            } else if (utilObj.isIos()) {
                jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_IOS + nativeClassName,
                    "onApi:mode:params:apiId:", "/me/apprequests", "GET",
                    paramsStr, REQ_ALL_OPEN);
            }
        } else {
            FB.api("/me/apprequests", function (response) {
                webFbListener.onApi(REQ_ALL_OPEN, response);
            });
        }
    };

    this.deleteRequest = function (reqObjId) {
        if (!fbWrapperObj.isLoggedIn()) {
            return;
        }
        var params = {};
        // loggerObj.debugLog("clearing app requests for ", reqObjId);
        if (utilObj.isNative()) {
            var paramsStr = utilObj.getStringifiedJson(params);
            if (utilObj.isAndroid()) {
                jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + nativeClassName,
                    "onApi", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;I)V", reqObjId + "", "DELETE",
                    paramsStr, REQ_DELETE_OPEN);
            } else if (utilObj.isIos()) {
                jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_IOS + nativeClassName,
                    "onApi:mode:params:apiId:", reqObjId + "", "DELETE",
                    paramsStr, REQ_DELETE_OPEN);
            }
        } else {
            FB.api(reqObjId, "DELETE", function (response) {
                webFbListener.onApi(REQ_DELETE_OPEN, response);
            })
        }

    };

    var lastSentTo = null,
        lastSentBatchType = null,
        lastSentReqType = null;

    this.sendRequests = function (title, message, cb, to, p, c, o, s, reqType) {
        if (!utilObj.isOnline()) {
            utilObj.showMessage(stringsObj.not_online);
            return;
        }
        if (!fbWrapperObj.isLoggedIn()) {
            actionTitle = title;
            actionMessage = message;
            actionCb = cb;
            actionTo = to;
            fbWrapperObj.setFbAction(constantsObj.FB_ACTION_REQUESTS);
            fbWrapperObj.login();
            return;
        }
        utilObj.setFbDialogOpen(true);

        var info = {
            "message": message,
            "title": title
        };
        if (to != undefined && to != null && to != "") {
            info.to = to;
        }

        lastSentBatchType = friendsObj.getBatchType();
        //lastSentReqType = friendsObj.getReqType();
        lastSentTo = to;

        // loggerObj.debugLog("Info:", utilObj.getStringifiedJson(info), to.length, reqType);
        var meta = {};
        meta["p"] = p;
        meta["c"] = c;
        meta["o"] = o;
        meta["s"] = s;

        fbWrapperObj.meta = meta;
        fbWrapperObj.reqType = null;

        var reqTypeStr = "";
        if (reqType != undefined) {
            fbWrapperObj.reqType = reqType;
            reqTypeStr = reqType + "";
        }
        if (!utilObj.isWeb()) {
            var infoStr = utilObj.getStringifiedJson(info);
            if (utilObj.isAndroid()) {
                jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + nativeClassName,
                    "appRequests", "(Ljava/lang/String;)V", infoStr);
            } else if (utilObj.isIos()) {
                jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_IOS + nativeClassName,
                    "appRequests:reqType:", infoStr, reqTypeStr);
            }
        } else {
            FB.ui({
                method: 'apprequests',
                message: message,
                title: title,
                to: to
            }, function (response) {
                webFbListener.onAppRequestsCallback(response, meta);
            });
        }

        /*
         lets assume code =0 and send was successfull
         */


        var code = 0;
        var response = {};
        response.to = [];

        fbWrapperObj.cb = cb;
        //if (reqType == undefined || reqType != fbRequestObj.INVITE_FRIENDS) {
        //    cb(code, response);
        //}
        if (code == 0) {

        }

        // loggerObj.debugLog("Click tracking req:", p, c, o, s);
        trackObj.trackCounter(psConstantsObj.TRACK_REQUEST, p, c, o, psConstantsObj.TRACK_CLICK, "", "", "", "");
    };

    // this.shareLink = function (link, name, description, picture) {
    //     if (!utilObj.isOnline()) {
    //         utilObj.showMessage(stringsObj.not_online);
    //         return;
    //     }
    //
    //     var info = {};
    //
    //     if (utilObj.isNative()) {
    //         info.type = "link";
    //         info.link = link;
    //         info.title = name;
    //         info.text = description;
    //         info.image = picture;
    //     } else {
    //         info.method = "share";
    //         info.href = link;
    //         info.title = name;
    //         info.text = description;
    //         info.image = picture;
    //     }
    //
    //     fbWrapperObj.shareLinkMap = info;
    //
    //     var success = false;
    //     // if (!fbWrapperObj.isLoggedIn()) {
    //     //     success = fbWrapperObj.checkAndShowFbConnect(constantsObj.FB_ACTION_SHARE_LINK);
    //     // }
    //
    //     if (success == false) {
    //         fbWrapperObj.shareLinkCallback();
    //     }
    // };
    // this.shareLinkMap = null;
    // this.shareLinkCallback = function () {
    //     if (!fbWrapperObj.isLoggedIn()) {
    //         fbWrapperObj.setFbAction(constantsObj.FB_ACTION_SHARE_LINK);
    //         fbWrapperObj.login();
    //     } else {
    //         if (utilObj.isNative()) {
    //             // loggerObj.debugLog("dcsscsacasc");
    //             var contentStr = utilObj.getStringifiedJson(fbWrapperObj.shareLinkMap);
    //             if (utilObj.isAndroid()) {
    //                 jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + nativeClassName,
    //                     "shareLink", "(Ljava/lang/String;)V", "dcsdeverveve");
    //             } else if (utilObj.isIos()) {
    //                 jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + nativeClassName,
    //                     "shareLink:", constantsObj.GAME_SHARE_LINK);
    //             }
    //         } else {
    //             FB.ui(fbWrapperObj.shareLinkMap, function (response) {
    //                 // loggerObj.debugLog("share succesfull");
    //             });
    //         }
    //
    //     }
    // };

    this.shareLink = function (link) {
        var info = {};
        if (utilObj.isNative()) {
            info.type = "link";
            info.link = link;
        } else {
            info.method = "share";
            info.href = link;
        }
        fbWrapperObj.shareLinkMap = info;
        fbWrapperObj.shareLinkCallback()
    };

    this.shareLinkMap = null;
    this.shareLinkCallback = function () {
        if (utilObj.isNative()) {
            if (utilObj.isAndroid()) {
                jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + nativeClassName,
                    "shareLink", "(Ljava/lang/String;)V", fbWrapperObj.shareLinkMap.link);
            } else if (utilObj.isIos()) {
                jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_IOS + nativeClassName,
                    "shareGivenLink:", fbWrapperObj.shareLinkMap.link);
            }
        } else {
            FB.ui(fbWrapperObj.shareLinkMap, function (response) {
                // loggerObj.debugLog("share successfull");
            });
        }
    };


    this.setFbAction = function (action) {
        fbAction = action;
    };

    this.shareGameLink = function () {
        var link = constantsObj.GAME_URL;
        var name = stringsObj.game_name;
        var desc = stringsObj.game_desc;
        var pic = constantsObj.GAME_LOGO_URL;
        fbWrapperObj.shareLink(link, name, desc, pic);
    };

    this.postPhoto = function (url) {
        // loggerObj.debugLog("Attempting to upload photo:", url);
        if (!fbWrapperObj.isLoggedIn()) {
            // loggerObj.debugLog("Not logged in when uploading photo");

            // gameObj.setScreenshotEnabled(true);
            var success = fbWrapperObj.checkAndShowFbConnect(constantsObj.FB_ACTION_POST_PHOTO);
            if (success == false) {
                fbWrapperObj.setFbAction(constantsObj.FB_ACTION_POST_PHOTO);
                // facebookObj.login();
            }
            return;
        }
        // gameObj.setScreenshotEnabled(false);
        var params = {};
        params["url"] = url;
        if (utilObj.isNative()) {
            return;
            if (utilObj.isAndroid()) {
                jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Facebook",
                    "onApi", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;I)V", "/me/photos", "POST",
                    JSON.stringify(params), REQ_PHOTO_UPLOAD);
            } else if (utilObj.isIos()) {
                psUtilObj.makeNativeCall("Facebook",
                    "onApi:mode:params:apiId:", "/me/photos", "POST",
                    JSON.stringify(params), REQ_PHOTO_UPLOAD);
            }
        } else {
            FB.api("/me/photos", "POST", params, function (response) {
                webFbListener.onApi(REQ_PHOTO_UPLOAD, response);
            });
        }
    };

    this.postPhotoResult = function (res) {
        // gameObj.setScreenshotEnabled(true);
        if (res) {
            utilObj.showMessage(stringsObj.screenshot_uploaded_fb);
            /*trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getViewingBucket(),
                gameObj.getViewingPuzIdInBucket(), "photo_upload", constantsObj.TRACK_VIEW,
                constantsObj.TRACK_SUCCESS, gameObj.getViewingLevel() + "," + gameObj.getViewingPuzNumber(),
                "", "");*/
        } else {
            utilObj.showMessage(stringsObj.screenshot_share_fail);
            fbWrapperObj.getPublishPerms();
            /*trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getViewingBucket(),
                gameObj.getViewingPuzIdInBucket(), "photo_upload", constantsObj.TRACK_VIEW, constantsObj.TRACK_FAIL,
                gameObj.getViewingLevel() + "," + gameObj.getViewingPuzNumber(), "", "");*/
        }
    };

    this.jsbCallBack = function (msg) {
        // loggerObj.debugLog("jsbCallBack", msg);
        var type = null,
            jObj = null;
        try {
            jObj = JSON.parse(msg);
            type = jObj["type"];
        } catch (err) {
            type = null;
        }
        // loggerObj.debugLog("type = ", type);
        if (type == TYPE_LOGIN) {
            fbListener.onLogin(jObj[SUCCESS], jObj);
            // Suraj: Letting these things happen after a delay in user resp handler as they slow down the game.
            /*fbWrapperObj.getPlayingFriends();
             fbWrapperObj.getInvitableFriends();
             fbRequestObj.checkOpenRequests();*/
        } else if (type == TYPE_API) {
            if (utilObj.isIos()) {
                fbListener.onAPI(jObj[API_ID], jObj);
            } else {
                var file = jObj["data"];
                var jsonObj = null;
                try {
                    jsonObj = JSON.parse(ls.getItem(file));
                } catch (err) {

                }
                fbListener.onAPI(jObj[API_ID], jsonObj);
            }
        } else if (type == TYPE_LINK_SHARE) {
            switch (jObj[SUCCESS]) {
                case VAL_SUCCESS:
                    fbListener.onSharedSuccess(jObj);
                    break;
                case VAL_CANCEL:
                    fbListener.onSharedCancel();
                    break;
                case VAL_ERROR:
                    fbListener.onSharedFailed(jObj);
                    break;
            }
        } else if (type == TYPE_APP_REQUEST) {
            if (jObj[KEY_TO] != undefined) {
                jObj[KEY_TO] = jObj[KEY_TO].split(",");
            }
            // loggerObj.debugLog("onAppRequestCallBack success = ", jObj[SUCCESS], VAL_SUCCESS, VAL_CANCEL, VAL_ERROR);
            switch (jObj[SUCCESS]) {
                case VAL_SUCCESS:
                    gameObj.updateRequestCount();
                    if (gameObj.getRequestCount() >= constantsObj.MAX_REQUESTS_LIMIT) {
                        // do not show mfs layer
                        if (curScreen == constantsObj.SCREEN_MFS) {
                            utilObj.popCurScreen();
                            mfsLayer.hide();
                            mfsLayer.close();
                        }
                    } else {
                        fbListener.onAppRequestCallBack(jObj, true);
                        // fbRequestObj.showMFS(fbRequestObj.type);
                    }
                    break;
                case VAL_CANCEL:
                    // loggerObj.debugLog("Requests sending cancelled:", curScreen);
                    if (curScreen != constantsObj.SCREEN_MFS && curScreen != constantsObj.SCREEN_LETS_CONNECT) {
                        // popupLayer.closeWithDefault();
                        // fbRequestObj.showMFS(fbRequestObj.type);
                    }

                    break;
                case VAL_ERROR:
                    // loggerObj.debugLog("Requests sending had an error");
                    // loggerObj.debugLog("onAppRequestCallBack", jObj["error"]);
                    // fbRequestObj.showMFS(fbRequestObj.type);
                    break;
            }
            utilObj.setFbDialogOpen(false);
        }
    };

    // purchases on FB
    this.purchaseCoins = function (coinAmt) {
        // loggerObj.debugLog("Purchase coins on fb:", coinAmt);
        // loggerObj.debugLog(constantsObj.FB_PRICING_BASE + "?amt=" + coinAmt + "&gid=" + constantsObj.GAME_ID + "&purchaseType=Coins");
        var info = {
            method: 'pay',
            action: 'purchaseitem',
            product: constantsObj.FB_PRICING_BASE + "?amt=" + coinAmt + "&gid=" + constantsObj.GAME_ID + "&purchaseType=Coins"
        };

        FB.ui(info, function (response) {
            // loggerObj.debugLog("Response on success: ", response);
            if (response['status'] === 'completed') {
                // loggerObj.debugLog("Payment succeeded: ", response['amount'], response['currency'], coinAmt);
                paymentsObj.grantCash(coinAmt, 0);
            } else {
                // loggerObj.debugLog("Payment failed: ", response['status']);
            }
        });
    };
    this.purchaseSpins = function (spinAmt) {
        cc.log("Purchase spins on fb:", spinAmt);
        // loggerObj.debugLog(constantsObj.FB_PRICING_BASE + "?amt=" + spinAmt + "&gid=" + constantsObj.GAME_ID + "&purchaseType=Spins");
        var info = {
            method: 'pay',
            action: 'purchaseitem',
            product: constantsObj.FB_PRICING_BASE + "?amt=" + spinAmt + "&gid=" + constantsObj.GAME_ID + "&purchaseType=Spins"
        };

        FB.ui(info, function (response) {
            // loggerObj.debugLog("Response on success: ", response);
            if (response['status'] === 'completed') {
                // loggerObj.debugLog("Payment succeeded: ", response['amount'], response['currency'], spinAmt);
                paymentsObj.grantSpins(spinAmt, 0);
            } else {
                // loggerObj.debugLog("Payment failed: ", response['status']);
            }
        });
    };
    this.shareVideo = function () {
        if (utilObj.isNative()) {
            if (utilObj.isAndroid()) {
                psUtilObj.makeNativeCall(constantsObj.PACKAGE_PATH_ANDROID_COMMON + nativeClassName,
                    "shareVideo", "()V");
            } else if (utilObj.isIos()) {
                return;
                // psUtilObj.makeNativeCall(constantsObj.PACKAGE_PATH_IOS + nativeClassName,
                //    "shareVideo:videoLink:", photoUrl, videoUrl);
            }
        }
    };
};