Friends = function () {
    var lastUpdate = 0;
    var lastPsUpdate = 0;
    var invitableFriends = new Array();
    var playingFriends = new Array();
    var psFriends = new Array();
    var sentAtMap = {};
    var lastReqTo = 0;
    var tempLastReqTo = 0;
    var lastInviteTo = 0;
    var tempLastInviteTo = 0;
    this.BATCH_APP_FRIEND = 1;
    this.BATCH_NON_APP_FRIEND = 2;
    var batchType = -1;
    var attemptingSendTo = new Array();
    var playingFriendsSendTo = new Array();
    var inviteFriendsSendTo = new Array();
    var DEFAULT_TYPE = -1;
    var reqType = -1;
    var DUMMY_IMAGE = "friendly_%D%.jpg";
    var NUM_DUMMY_IMAGES = 19;
    var friendsImageUrlFile = 0;
    var friendsController = null;

    this.init = function () {
        friendsController = userObj.getLoginRestController();
        load();
        friendsImageUrlFile = 0;
    };

    function loadFriendsObjLocal(friendsData) {
        var friendsInfo = JSON.parse(friendsData);
        if (friendsInfo.lastUpdate == undefined) {
            return;
        }
        lastUpdate = friendsInfo.lastUpdate;
        lastReqTo = friendsInfo.lastReqTo;
        if (friendsInfo.invitableFriends != undefined) {
            invitableFriends = friendsInfo.invitableFriends;
        }
        if (friendsInfo.playingFriends != undefined) {
            playingFriends = friendsInfo.playingFriends;
        }
        if (friendsInfo.lastInviteTo != undefined) {
            lastInviteTo = friendsInfo.lastInviteTo;
        }
        if (friendsInfo.sentAtMap != undefined) {
            sentAtMap = friendsInfo.sentAtMap;
        }
        if (friendsInfo.psFriends != undefined) {
            psFriends = friendsInfo.psFriends;
        }
        if (friendsInfo.lastPsUpdate != undefined) {
            lastPsUpdate = friendsInfo.lastPsUpdate;
        }

        // loggerObj.debugLog("Loaded friends:", invitableFriends.length, playingFriends.length);
    }

    this.reload = function () {
        load();
        friendsObj.downloadFriendPics();
    };

    function load() {
        var friendsData = ls.getItem(constantsObj.FRIENDS_FILE);
        if (friendsData == null || friendsData == "") {
            // loggerObj.debugLog("No friends data found.");
            return false;
        }
        loadFriendsObjLocal(friendsData);

        // loggerObj.debugLog('Read friends data in js as:', friendsData);
        return true;
    }

    function getFriendsObj() {
        var friendsInfo = {};
        friendsInfo.invitableFriends = invitableFriends;
        friendsInfo.playingFriends = playingFriends;
        friendsInfo.psFriends = psFriends;
        friendsInfo.lastUpdate = lastUpdate;
        friendsInfo.lastPsUpdate = lastPsUpdate;
        friendsInfo.lastReqTo = lastReqTo;
        friendsInfo.lastInviteTo = lastInviteTo;
        friendsInfo.sentAtMap = sentAtMap;

        return friendsInfo;
    }

    this.save = function () {
        if (lastUpdate === undefined) {
            return false;
        }

        var friendsInfo = getFriendsObj();
        ls.setItem(constantsObj.FRIENDS_FILE, utilObj.getStringifiedJson(friendsInfo));

        // utilObj.log("Saving friends info in js:" + utilObj.getStringifiedJson(friendsInfo));
        return true;
    };

    this.reset = function () {
        lastUpdate = 0;
        lastPsUpdate = 0;
        lastPsAttempt = 0;
        attemptUpdateLastTime = 0;
        invitableFriends = new Array();
        playingFriends = new Array();
        psFriends = new Array();

        lastReqTo = 0;
        if (utilObj.isAndroid()) {
            jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Friends", "reset", "()V");
        }
    };

    var attemptUpdateLastTime = 0;
    this.attemptUpdate = function () {
        return;
        if (!utilObj.isOnline()) {
            return;
        }
        if (!fbWrapperObj.isLoggedIn()) {
            return;
        }

        var curTimestamp = utilObj.getCurrentTimestamp();
        if (curTimestamp - attemptUpdateLastTime < constantsObj.SECONDS_IN_MIN) {
            return;
        }

        attemptUpdateLastTime = curTimestamp;
        if (curTimestamp - lastUpdate > constantsObj.FRIENDS_FETCH_INTERVAL) {
            if (utilObj.isAndroid()) {
                jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Friends", "attemptUpdate", "()V");
            } else {
                fbWrapperObj.getPlayingFriends();
            }
            friendsObj.attemptPsFriendsUpdate();
        }
    };

    var lastPsAttempt = 0;
    this.attemptPsFriendsUpdate = function () {
        return;
        if (!utilObj.isOnline()) {
            return;
        }
        if (!fbWrapperObj.isLoggedIn()) {
            return;
        }

        var curTimestamp = utilObj.getCurrentTimestamp();
        if (curTimestamp - lastPsAttempt < constantsObj.SECONDS_IN_MIN * 2) {
            return;
        }

        lastPsAttempt = curTimestamp;
        if (utilObj.isAndroid()) {
            jsb.reflection.callStaticMethod(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "Friends", "attemptPsFriendsUpdate", "()V");
        } else {

            if (curTimestamp - lastPsUpdate > constantsObj.FRIENDS_FETCH_INTERVAL) {
                friendsObj.syncPsFriends();
            }
        }
    };

    this.syncPsFriends = function () {
        return;
        /*if (utilObj.isAndroid()) {
         // loggerObj.debugLog("Shouldn't be getting called for android");
         return;
         }*/
        // loggerObj.infoLog("Attempting to sync ps friends");
        var map = userObj.getUserObj();
        if (map.fbAccessToken == "" || map.refId == "") {
            // loggerObj.debugLog("Not yet ready to fetch ps friends");
            return;
        }
        friendsController.sendHttpRequest("psfriends", "sync2", map);
    };

    this.respHandler = function (action, data, success) {
        // loggerObj.debugLog("Received ps friends info:", data);
        if (action == "sync") {
            if (success == false) {
                return;
            }
            var psFriendsData = JSON.parse(data.psfriends);
            var friendsStr = psFriendsData.Friends;
            var friendsArr = friendsStr.split(";");
            psFriends = [];
            for (var i = 0; i < friendsArr.length; i++) {
                var obj = {};
                var friendInfo = friendsArr[i].split(",");
                if (friendInfo.length > 3) {
                    //to handle case if there is an extra comma, possibly in name
                    continue;
                }
                obj.Name = friendInfo[0];
                obj.RefId = friendInfo[1];
                obj.Fbid = friendInfo[2];
                // loggerObj.debugLog("Fetched psFriends", utilObj.getStringifiedJson(obj));
                psFriends.push(obj);
            }

            // loggerObj.debugLog("ps Friends", psFriends.length);
            lastPsUpdate = utilObj.getCurrentTimestamp();
            friendsObj.save();

            // lbObj.syncToServer();
            // loggerObj.debugLog("Parsed friends:", psFriends);
            if(pspnFlutterObj != undefined && psUtilObj.checkIsFunction(pspnFlutterObj.saveFriendData)) {
                pspnFlutterObj.saveFriendData(utilObj.getStringifiedJson(psFriends));
            }
        }
    };

    this.getLastPsUpdate = function () {
        return lastPsUpdate;
    };

    this.getPsFriendRefIds = function () {
        if (psFriends == null || psFriends == "") {
            return "";
        }
        var friendRefIds = "";
        for (var i = 0; i < psFriends.length; i++) {
            friendRefIds += psFriends[i].RefId + ",";
        }

        return utilObj.trimLastChar(friendRefIds);
    };

    this.getPsFriendForRefId = function (refId) {
        if (psFriends == null || psFriends == "") {
            return null;
        }
        var currPs = null;
        for (var i = 0; i < psFriends.length; i++) {
            var currRefId = psFriends[i].RefId;
            if (currRefId == refId) {
                currPs = psFriends[i];
                break;
            }
        }
        return currPs;
    };

    this.getPlayingFriendForName = function (name) {
        if (playingFriends == null || playingFriends == "") {
            return null;
        }
        var friend = null;
        for (var i = 0; i < playingFriends.length; i++) {
            var currName = playingFriends[i].name;
            if (currName == name) {
                friend = playingFriends[i];
                break;
            }
        }
        return friend;
    };

    this.updatePlaying = function (response) {
        // loggerObj.debugLog("Got response from fb callback - playing:", response);
        playingFriends = response.data;
        lastUpdate = utilObj.getCurrentTimestamp();
        friendsObj.save();
        fbWrapperObj.getInvitableFriends();
    };

    this.updateInvitable = function (response) {
        // loggerObj.debugLog("Got response from fb callback - invitable:", response);
        invitableFriends = response.data;
        lastUpdate = utilObj.getCurrentTimestamp();
        friendsObj.save();
        friendsObj.trackNumFriends();

        if (utilObj.isNative()) {
            friendsObj.lastDownloadImages = 0;
            friendsObj.downloadFriendPics();
        }
    };

    this.trackNumFriends = function () {
        if (invitableFriends == undefined || playingFriends == undefined) {
            return;
        }
        // loggerObj.debugLog("Tracking num friends:", playingFriends.length, invitableFriends.length, "", "");

        trackObj.trackCounter("friends", playingFriends.length, invitableFriends.length, "", "", "", "", "", "");
    };

    this.getAttemptedSend = function () {
        return attemptingSendTo;
    };

    this.setAttemptSendTo = function (tmp) {
        attemptingSendTo = utilObj.createClone(tmp);
        var currList = null;
        if (batchType == friendsObj.BATCH_APP_FRIEND) {
            playingFriendsSendTo = attemptingSendTo;
        } else if (batchType == friendsObj.BATCH_NON_APP_FRIEND) {
            inviteFriendsSendTo = attemptingSendTo;
        }
    };

    this.sendSuccessful = function (msg, parentScreen) {
        // loggerObj.debugLog("send successfull called:", curScreen);
        if (batchType == friendsObj.BATCH_APP_FRIEND) {
            // Not using msg.to since it returns incorrect info on android
            lastReqTo = tempLastReqTo;
            var curTimestamp = utilObj.getCurrentTimestamp();
            if (sentAtMap[reqType] == undefined) {
                sentAtMap[reqType] = {};
            }

            for (var i = 0; i < playingFriendsSendTo.length; i++) {
                sentAtMap[reqType][playingFriendsSendTo[i]] = curTimestamp;
            }
            // loggerObj.debugLog("After successful send, updating sentAtMap:", utilObj.getStringifiedJson(sentAtMap));
        } else if (batchType == friendsObj.BATCH_NON_APP_FRIEND) {
            lastInviteTo = tempLastInviteTo;

            if (sentAtMap[reqType] == undefined) {
                sentAtMap[reqType] = {};
            }
            var curTimestamp = utilObj.getCurrentTimestamp();
            for (var i = 0; i < inviteFriendsSendTo.length; i++) {
                sentAtMap[reqType][inviteFriendsSendTo[i]] = curTimestamp;
            }
        }

        gameObj.updateRequestCount();

        if (gameObj.getRequestCount() >= constantsObj.MAX_REQUESTS_LIMIT) {
            // loggerObj.debugLog("Hooyaaa Lelouch");
            // do not show mfs layer logic
            if (curScreen == constantsObj.SCREEN_MFS) {
                utilObj.popCurScreen();
                mfsLayer.hide();
                mfsLayer.close();
            }
        } else {
            if (curScreen == constantsObj.SCREEN_LEVEL_INTRO || curScreen == constantsObj.SCREEN_LEVEL_OUTRO) {
                // loggerObj.debugLog("hey lelouch , currentlayer is redrawn now");
                curLayer.redraw();
            } else if (curScreen == constantsObj.SCREEN_MFS) {
                // loggerObj.debugLog("hey lelouch , mfs is redrawn now");
                mfsLayer.redraw();
                //utilObj.popCurScreen();
                //mfsLayer.hide();
                //mfsLayer.close();
            }
        }

        // loggerObj.debugLog("reqType = ", reqType);
        gameObj.save();
        friendsObj.save();
        friendsObj.attemptUpdate();
    };

    function getBatch(friendList, onlyIds, size, reqType) {
        if (size == undefined) {
            size = fbRequestObj.getReqSendLimit();
        }

        var batch = "";
        var numFriends = friendList.length;
        var friendsData = new Array();

        // loggerObj.debugLog("getting next batch of ", size, " from ", numFriends, " for ", batchType);

        var j = 0;
        attemptingSendTo = new Array();

        var startVal = 0;
        if (batchType == friendsObj.BATCH_APP_FRIEND) {
            playingFriendsSendTo = new Array();
        } else if (batchType == friendsObj.BATCH_NON_APP_FRIEND) {
            inviteFriendsSendTo = new Array();
        }

        var i = 0;
        for (j = startVal; j < numFriends && i < size; j++) {
            if (batchType == friendsObj.BATCH_APP_FRIEND && !friendsObj.canSendReqTo(friendList[j].id, reqType, false)) {
                continue;
            } else if (batchType == friendsObj.BATCH_NON_APP_FRIEND && !friendsObj.canSendReqTo(friendList[j].id, reqType, false)) {
                continue;
            }
            // loggerObj.debugLog("adding ", j, " to friendList");
            batch += friendList[j].id + ",";
            friendsData.push(friendList[j]);

            i++;
        }
        if (j >= numFriends) {
            // End of friend list reached
            j = 0;
            for (; j < numFriends && j < startVal && i < size; i++, j++) {
                if (batchType == friendsObj.BATCH_APP_FRIEND && !friendsObj.canSendReqTo(friendList[j].id, reqType, false)) {
                    continue;
                } else if (batchType == friendsObj.BATCH_NON_APP_FRIEND && !friendsObj.canSendReqTo(friendList[j].id, reqType, false)) {
                    continue;
                }
                batch += friendList[j].id + ",";
                friendsData.push(friendList[j]);

                i++;
            }
        }
        batch = batch.replace(/,$/, "");
        // loggerObj.debugLog("Next batch is:", i, batch);
        if (batchType == friendsObj.BATCH_APP_FRIEND) {
            tempLastReqTo = j;
        } else {
            // loggerObj.debugLog("setting last invite to " + j);
            tempLastInviteTo = j;
        }

        if (onlyIds) {
            return batch;
        } else {
            return friendsData;
        }
    };

    this.populateSendingIds = function (ids) {
        playingFriendsSendTo = [];
        inviteFriendsSendTo = [];
        for (var i = 0; i < ids.length; i++) {
            if (batchType == friendsObj.BATCH_APP_FRIEND) {
                friendsObj.addPlayingFriend(ids[i]);
            } else if (batchType == friendsObj.BATCH_NON_APP_FRIEND) {
                friendsObj.addNonPlayingFriend(ids[i]);
            }
        }
    };

    this.getPlayingFriends = function () {
        return playingFriends;
    };

    this.removePlayingFriend = function (id) {
        var index = playingFriendsSendTo.indexOf(id);
        if (index > -1) {
            playingFriendsSendTo.splice(index, 1);
        }
    };

    this.addPlayingFriend = function (id) {
        var index = playingFriendsSendTo.indexOf(id);
        if (index == -1) {
            playingFriendsSendTo.push(id);
        }
    };

    this.removeNonPlayingFriend = function (id) {
        var index = inviteFriendsSendTo.indexOf(id);
        if (index > -1) {
            inviteFriendsSendTo.splice(index, 1);
        }
    };

    this.addNonPlayingFriend = function (id) {
        var index = inviteFriendsSendTo.indexOf(id);
        if (index == -1) {
            inviteFriendsSendTo.push(id);
        }
    };

    function extractInfoFromFriend(obj, onlyFBbId) {
        if (onlyFBbId) {
            return obj.id;
        } else {
            return obj;
        }
    };

    this.canSendReqTo = function (id, reqType, update) {
        var curTimestamp = utilObj.getCurrentTimestamp();
        if (sentAtMap[reqType] == undefined || sentAtMap[reqType][id] == undefined ||
            curTimestamp - sentAtMap[reqType][id] > (constantsObj.FRIEND_REQ_COOLDOWN_INTERVAL)) {
            return true;
        }
        // loggerObj.debugLog("cannot send req to ", utilObj.getStringifiedJson(id));
        return false;
    };


    this.setBatchTypePlayingFriends = function () {
        batchType = friendsObj.BATCH_APP_FRIEND;
    };
    this.setReqType = function (req) {
        reqType = req;
    };

    this.getNextPlayingBatch = function (onlyIds, size, reqType) {

        if (onlyIds == undefined) {
            onlyIds = true
        }

        if (size == undefined) {
            size = fbRequestObj.getReqSendLimit();
        }


        if (reqType == undefined) {
            reqType = DEFAULT_TYPE;
        }

        friendsObj.setReqType(reqType);

        friendsObj.setBatchTypePlayingFriends();
        var b = getBatch(playingFriends, onlyIds, size, reqType);
        return b;
    };

    this.setBatchTypeInvitableFriends = function () {
        batchType = friendsObj.BATCH_NON_APP_FRIEND;
    };

    this.getNextInvitableBatch = function (onlyIds, size, reqType) {
        if (onlyIds == undefined) {
            onlyIds = true;
        }
        if (size == undefined) {
            size = fbRequestObj.getReqSendLimit();
        }

        if (reqType == undefined) {
            reqType = DEFAULT_TYPE;
        }
        friendsObj.setReqType(reqType);
        reqType = constantsObj.INVITE;

        var b = "";
        if (invitableFriends == undefined || invitableFriends.length == 0) {
            friendsObj.attemptUpdate();
            return b;
        }
        friendsObj.setBatchTypeInvitableFriends();
        b = getBatch(invitableFriends, onlyIds, size, reqType);
        friendsObj.save();
        return b;
    };

    this.getNumInvitableFriends = function () {
        if (invitableFriends == undefined) {
            return 0;
        }
        return invitableFriends.length;
    };

    this.getBatchType = function () {
        return batchType;
    };

    this.getFbPicUrl = function (fbid) {
        return constantsObj.GRAPH_API_BASE + "/" + fbid + "/picture?type=normal&width=300&height=300";
    };

    this.getDummyPicUrl = function (imageName) {
        return "";
    };

    this.getProfilePic = function (fbid) {
        if (utilObj.isNative()) {
            var imgDir = utilObj.getFilesDir();
            var imgPath = fbid + ".jpg";
            // loggerObj.debugLog("coming here1");
            if (utilObj.imageExists(imgPath)) {
                // loggerObj.debugLog("coming here2");
                return imgDir + "/" + imgPath;
            } else {
                var url = friendsObj.getFbPicUrl(fbid);
                // loggerObj.debugLog("coming here3", url);
                utilObj.downloadFileV1(imgPath, url);
                return constantsObj.profile_pic;
            }
        } else {
            return friendsObj.getFbPicUrl(fbid);
        }
    };

    this.getPlayingFriendPic = function (fbid) {
        if (utilObj.isNative()) {
            var imgDir = utilObj.getFilesDir();
            var imgPath = fbid + ".jpg";
            if (utilObj.imageExists(imgPath)) {
                return imgDir + "/" + imgPath;
            } else {
                var url = friendsObj.getFbPicUrl(fbid);
                utilObj.downloadFile(imgPath, url, "");
                friendsObj.downloadFriendPics();
                return constantsObj.profile_pic;
            }
        } else {
            return friendsObj.getFbPicUrl(fbid);
        }
    };

    this.getNonPlayingFriendPic = function (obj) {
        if (utilObj.isNative()) {
            var imgDir = utilObj.getFilesDir();
            var imgPath = obj.name + ".jpg";
            if (utilObj.imageExists(imgPath)) {
                return imgDir + "/" + imgPath;
            } else {
                utilObj.downloadFile(imgPath, obj.picture.data.url, "");
                friendsObj.downloadFriendPics();
                return constantsObj.profile_pic;
            }
        } else {
            return obj.picture.data.url;
        }
    };


    this.getFriendPics = function (howMany) {
        var friendsFound = 0;
        var friendPics = new Array();
        var imageMissing = false;
        if (utilObj.isNative()) {
            var imgDir = utilObj.getFilesDir();
            for (; friendsFound < invitableFriends.length && friendsFound < howMany; friendsFound++) {
                var imgName = invitableFriends[friendsFound].name + ".jpg";
                if (utilObj.fileExists(imgName)) {
                    friendPics.push(imgDir + "/" + imgName);
                } else {
                    friendPics.push(constantsObj.profile_pic);
                    imageMissing = true;
                }
            }
        } else {
            for (; friendsFound < invitableFriends.length && friendsFound < howMany; friendsFound++) {
                friendPics.push(invitableFriends[friendsFound].picture.data.url);
            }
        }

        if (friendsFound < howMany) {
            var dummyImageIndex = parseInt(Math.random() * NUM_DUMMY_IMAGES);
            for (; friendsFound < howMany; friendsFound++) {
                dummyImageIndex += 1;
                dummyImageIndex = dummyImageIndex % NUM_DUMMY_IMAGES;
                var dummyImageName = DUMMY_IMAGE.replace("%D%", dummyImageIndex);
                if (utilObj.isNative()) {
                    if (utilObj.fileExists(dummyImageName)) {
                        friendPics.push(imgDir + dummyImageName);
                    } else {
                        friendPics.push(constantsObj.profile_pic);
                        imageMissing = true;
                    }
                }
            }
        }
        if (imageMissing) {
            friendsObj.downloadFriendPics();
        }
        return friendPics;
    };

    this.lastDownloadImages = 0;
    this.downloadFriendPics = function () {
        if (utilObj.getCurrentTimestamp() - friendsObj.lastDownloadImages < constantsObj.FRIEND_IMG_DOWNLOAD_INTERVAL) {
            // loggerObj.debugLog("too early for download call", friendsObj.lastDownloadImages, utilObj.getCurrentTimestamp());
            return;
        }
        if (utilObj.isWeb() || !fbWrapperObj.isLoggedIn()) {
            return;
        }

        friendsObj.lastDownloadImages = utilObj.getCurrentTimestamp();
        if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("FacebookWrapper", "downloadFriendPics");
            return;
        }

        var friendPicInfo = "";
        var count = 0;
        var max_count = 20;
        // breaking up invitable friends into 2 parts
        for (var i = 0; i < invitableFriends.length && count < 10; i++) {
            var fileName = invitableFriends[i].name + ".jpg";
            var url = invitableFriends[i].picture.data.url;
            if (!utilObj.fileExists(fileName) && count < max_count) {
                count++;
                friendPicInfo += url + "," + fileName + ";";
            }
        }
        for (var i = 0; i < playingFriends.length && count < max_count; i++) {
            var fileName = playingFriends[i].id + ".jpg";
            var url = friendsObj.getFbPicUrl(playingFriends[i].id);
            if (!utilObj.fileExists(fileName) && count < max_count) {
                count++;
                friendPicInfo += url + "," + fileName + ";";
            }
        }

        // continuing invitable friends from 10 onwards
        for (var i = 10; i < invitableFriends.length && count < max_count; i++) {
            var fileName = invitableFriends[i].name + ".jpg";
            var url = invitableFriends[i].picture.data.url;
            if (!utilObj.fileExists(fileName) && count < max_count) {
                count++;
                friendPicInfo += url + "," + fileName + ";";
            }
        }
        friendPicInfo = friendsObj.downloadProfilePic(friendPicInfo);

        var file = "friendsUrlInfo" + friendsImageUrlFile + ".json";
        if (friendPicInfo != "") {
            ls.setItem(file, friendPicInfo);
            utilObj.downloadImages(file);
            friendsObj.save();
            friendsImageUrlFile = (friendsImageUrlFile + 1) % 5;
        }
    };
    this.downloadProfilePic = function (friendPicInfo) {
        if (!userObj.isLoggedIn()) {
            // loggerObj.debugLog("not downloading image since not logged in");
            return;
        }

        var url = friendsObj.getFbPicUrl(userObj.getFbid());
        var fileName = userObj.getName() + "_profile.jpg";
        if (utilObj.fileExists(fileName)) {
            return friendPicInfo;
        }
        friendPicInfo += url + "," + fileName + ";";
        return friendPicInfo;
    };
};