Logger = function () {
    this.MODE = {
        TRACE: 0,
        DEBUG: 1,
        INFO: 2,
        WARNING: 3,
        ERROR: 4
    };

    this.getLineNumber = function (maxTrace, skipFirst) {
        var tempErr = null;
        try {
            throw Error('');
        } catch (err) {
            tempErr = err;
        }
        var stack = tempErr.stack.split("\n");

        var maxStackTrace = 6;
        if (maxTrace != undefined) {
            maxStackTrace = maxTrace;
        }
        if (skipFirst == undefined) {
            skipFirst = false;
        }
        var traceInfo = new Array();
        for (var i = 2; i < (maxStackTrace + 2) && i < stack.length; i++) {
            if (skipFirst && i == 2) {
                continue;
            }
            var caller = stack[i].split("/");
            var lineNu = caller[caller.length - 1];
            var func = stack[i].split("@")[0];
            traceInfo = traceInfo.concat([func + ":" + lineNu]);
        }
        return traceInfo;
    };

    this.level = this.MODE.DEBUG;

    this.setLevel = function (val) {
        loggerObj.level = val;
    };

    this.DEBUG = "DEBUG::";
    this.debugLog = function () {
        if (loggerObj.MODE.DEBUG >= loggerObj.level) {
            var args = Array.prototype.slice.call(arguments, 0);
            var trace = loggerObj.getLineNumber();
            var newArr = [loggerObj.DEBUG];
            newArr = newArr.concat(args);
            newArr = newArr.concat(trace);
            cc.log.apply(null, newArr);
        }
    };
    this.TRACE = "TRACE::";
    this.traceLog = function () {
        if (loggerObj.MODE.TRACE >= loggerObj.level) {
            var args = Array.prototype.slice.call(arguments, 0);
            var trace = loggerObj.getLineNumber();
            var newArr = [loggerObj.TRACE];
            newArr = newArr.concat(args);
            newArr = newArr.concat(trace);
            cc.log.apply(null, newArr);
        }
    };

    this.INFO = "INFO::";
    this.infoLog = function () {
        if (loggerObj.MODE.INFO >= loggerObj.level) {
            var args = Array.prototype.slice.call(arguments, 0);
            var trace = loggerObj.getLineNumber();
            var newArr = [loggerObj.INFO];
            newArr = newArr.concat(args);
            newArr = newArr.concat(trace);
            cc.log.apply(null, newArr);
        }
    };

    this.WARNING = "WARNING::";
    this.warningLog = function () {
        if (loggerObj.MODE.WARNING >= loggerObj.level) {
            var args = Array.prototype.slice.call(arguments, 0);
            var trace = loggerObj.getLineNumber();
            var newArr = [loggerObj.WARNING];
            newArr = newArr.concat(args);
            newArr = newArr.concat(trace);
            cc.log.apply(null, newArr);
        }
    };

    this.ERROR = "ERROR::";
    this.errorLog = function () {
        if (loggerObj.MODE.ERROR >= loggerObj.level) {
            var args = Array.prototype.slice.call(arguments, 0);
            var trace = loggerObj.getLineNumber();
            var newArr = [loggerObj.ERROR];
            newArr = newArr.concat(args);
            newArr = newArr.concat(trace);
            cc.log.apply(null, newArr);
        }
    };
};