User = function () {
    var syncInProgress = false;
    var syncResetTimer = null;

    var refId = "";
    var syncId = "";
    var xpromoId = "";
    var gpsid = "";
    var trackingRefId = "";
    var name = "";
    var email = "";
    var gender = "";
    var fbid = "";
    var fbbid = "";
    var curDevice = "";
    var deviceId = "";
    var created = "";
    var lastUpdate = "";
    var infoHash = "";
    var gameUserInfoHash = "";
    var xpromoHash = "";
    var deviceHash = "";
    var advertiserId = "";
    var adjustId = "";
    var userCreated = false;
    var isPayer = "";
    var payerStatusSynced = "0";
    var chosenName = "";
    var chosenEmail = "";
    var chosenCountry = "";
    var chosenMinAge = "";
    var chosenMaxAge = "";
    var countryCode = "";
    var subDivision = "";
    var city = "";
    var installNetwork = "";
    var installCampaign = "";
    var installAdGroup = "";
    var installCreative = "";
    var appleUserId = "";

    var loginType = "";

    var fbPermissions = "";
    var fbAccessToken = "";

    var connectPsIds = [];
    var connectNetworks = [];

    var syncingForNetwork = psConstantsObj.NETWORK_NONE;

    var loginRest = null;
    var loginId = null;
    var trackerToken = null;

    var PRIVACY_POLICY_EXEMPT = {au: 1, ca: 1, nz: 1, in: 1, ng: 1};
    var privacyPolicyAccepted = "";
    var applicablePrivacyLaw = "unknown";
    var privacyVersionChecked = "0";

    var LAW_NONE = "";
    var LAW_GDPR = "gdpr";
    var LAW_CCPA = "ccpa";
    var LAW_UNKNOWN = "unknown";

    var shouldForceSyncGameObj = false;
    var Dob = "";
    var appleLoginCallback = null;

    this.getPsId = function () {
        return refId;
    };

    // Deprecated. Use one of the other id functions correctly.
    this.getRefId = function () {
        return syncId;
    };

    this.getSyncId = function () {
        return syncId;
    };

    this.getGpsid = function () {
        return gpsid;
    };

    this.getTrackingRefId = function () {
        return trackingRefId;
    };

    this.getXpromoId = function () {
        return xpromoId;
    };

    this.getDeviceId = function () {
        if (deviceId == "" || deviceId == "undefined") {
            deviceId = userObj.getCurDevice();
        }
        return deviceId;
    };

    this.getAdvertiserId = function () {
        if (advertiserId == "" || advertiserId == "undefined") {
            advertiserId = utilObj.getAdvertiserId();
        }
        return advertiserId;
    };

    this.getAdjustId = function () {
        if (adjustId == "" || adjustId == "undefined") {
            psUtilObj.getAdjustId();
        }
        return adjustId;
    };

    this.setRefId = function (val) {
        refId = val;
    };

    this.setSyncId = function (val) {
        syncId = val;
        userObj.save();
        loggerObj.debugLog("setting sync id here", syncId);
    };

    this.getName = function () {
        return name;
    };

    this.setName = function (val) {
        name = val;
    };

    this.getEmail = function () {
        return email;
    };

    this.setEmail = function (val) {
        email = val;
    };

    this.getChosenName = function () {
        return chosenName;
    };

    this.setChosenName = function (val) {
        chosenName = val;
    };

    this.getAppleUserId = function () {
        return appleUserId;
    };

    this.setAppleUserId = function (val) {
        appleUserId = val;
    };

    this.getChosenEmail = function () {
        return chosenEmail;
    };

    this.setChosenEmail = function (val) {
        chosenEmail = val;
    };

    this.getGender = function () {
        return gender;
    };

    this.setGender = function (val) {
        gender = val;
    };

    this.getFbid = function () {
        return fbid;
    };

    this.getFbBid = function () {
        return fbbid;
    };

    this.setFbid = function (val) {
        fbid = val;
    };

    this.getCreated = function () {
        return created;
	};
	
	this.getIsUserCreated = function () {
		if (created != "" && created != 0) {
			return true;
		}
		return false;
	};

    this.setCreated = function (val) {
        created = val;
    };

    this.getCurDevice = function () {
        if (deviceId == "") {
            curDevice = utilObj.getDeviceId();
            deviceId = curDevice;
        }
        return curDevice + "";
    };

    this.setCurDevice = function (val) {
        curDevice = val;
    };

    this.getInfoHash = function () {
        return infoHash;
    };

    this.setInfoHash = function (val) {
        infoHash = val;
    };

    this.getDeviceHash = function () {
        return deviceHash;
    };

    this.setDeviceHash = function (val) {
        deviceHash = val;
    };

    this.getIsPayer = function () {
        if (isPayer == "1") {
            return true;
        }
        return false;
    };

    this.setLoginType = function (val) {
        loginType = val;
    };

    this.setIsPayer = function () {
		isPayer = "1";
		if (psUtilObj.checkIsFunction(questsObj.getPayerStatusForDailyQuests)) {
			if (questsObj.getPayerStatusForDailyQuests() == 0) {
				questsObj.setPayerStatusForDailyQuests(1);
			}
		}
    };

    this.getCountryCode = function () {
        return countryCode;
    };

    this.getSubDivision = function () {
        return subDivision;
    };

    this.getCity = function () {
        return city;
    };

    this.getInstallNetwork = function () {
        return installNetwork;
    };

    this.getInstallCampaign = function () {
        return installCampaign;
    };

    this.getInstallAdGroup = function () {
        return installAdGroup;
    };

    this.getInstallCreative = function () {
        return installCreative;
    };

    this.getShouldForceSyncGameObj = function () {
        return shouldForceSyncGameObj;
    };

    this.resetShouldForceSyncGameObj = function () {
        shouldForceSyncGameObj = false;
    };

    this.getChosenBirthday = function () {
        return Dob;
    };

    this.setChosenBirthday = function (val) {
        Dob = val;
    };


    this.init = function () {
		loginRest = new Controller(constantsObj.LOGIN_SERVER_REST);
        loginId = new Controller(constantsObj.LOGIN_SERVER_ID);
        load();
    };

    this.getLoginRestController = function () {
        if (loginRest == null || loginRest == undefined) {
            userObj.init();
        }
        return loginRest;
    };

    this.getLoginIdController = function () {
        if (loginId == null || loginId == undefined) {
            userObj.init();
        }
        return loginId;
    }

    this.getPurchaseToken = function (qty) {
        return refId + "_" + qty + "_" + utilObj.getCurrentTimestamp();
    };

    this.getTrackerToken = function () {
        return trackerToken;
    };

    this.setTrackerToken = function (val) {
        trackerToken = val;
    };

    function loadUserObjLocal(userData) {
        var user = JSON.parse(userData);
        refId = user.refId + "";
        name = user.name + "";
        email = user.email + "";
        gender = user.gender + "";
        fbid = user.fbid + "";
        created = user.created + "";
        if (user.lastUpdate != undefined) {
            lastUpdate = user.lastUpdate;
        } else {
            lastUpdate = "0";
        }
        infoHash = user.infoHash + "";
        if (user.gi != undefined) {
            gameUserInfoHash = user.gi;
        }
        if (user.xh != undefined) {
            xpromoHash = user.xh;
        }
        deviceHash = user.deviceHash + "";
        curDevice = user.curDevice + "";
        if (user.deviceId != undefined) {
            deviceId = user.deviceId = "";
        } else {
            deviceId = user.curDevice + "";
        }
        advertiserId = user.advertiserId + "";
        if (user.adjustId != undefined) {
            adjustId = user.adjustId + "";
        } else {
            adjustId = psUtilObj.getAdjustId();
        }
        if (user.trackingRefId != undefined) {
            trackingRefId = user.trackingRefId;
        } else {
            // This is only possible for old users.
            // For these users, trackingRefId is to be kept same as refId.
            trackingRefId = refId;
        }
        if (user.syncId != undefined) {
            syncId = user.syncId + "";
        } else {
            // This is only possible for old users.
            // For these users, syncId is to be kept same as refId.
            syncId = refId;
        }
        if (user.xpromoId != undefined) {
            xpromoId = user.xpromoId + "";
        } else {
            // This is only possible for old users.
            // For these users, syncId is to be kept same as refId.
            xpromoId = refId;
        }
        if (user.gpsid != undefined) {
            gpsid = user.gpsid;
        } else {
            // This is only possible for old users.
            // For these users, trackingRefId is to be kept same as refId.
            gpsid = trackingRefId;
        }
        if (user.chosenName != undefined) {
            chosenName = user.chosenName + "";
        }
        if (user.chosenEmail != undefined) {
            chosenEmail = user.chosenEmail + "";
        }
        if (user.fbbid != undefined) {
            fbbid = user.fbbid;
        }
        if (user.isPayer != undefined) {
            isPayer = user.isPayer;
        }
        if (user.payerStatusSynced != undefined) {
            payerStatusSynced = user.payerStatusSynced;
        }
        if (user.countryCode != undefined) {
            countryCode = user.countryCode;
        }
        if (user.subDivision != undefined) {
            subDivision = user.subDivision;
        }
        if (user.city != undefined) {
            city = user.city;
        }
        if (user.installNetwork != undefined) {
            installNetwork = user.installNetwork;
        }
        if (user.installCampaign != undefined) {
            installCampaign = user.installCampaign;
        }
        if (user.installAdGroup != undefined) {
            installAdGroup = user.installAdGroup;
        }
        if (user.installCreative != undefined) {
            installCreative = user.installCreative;
        }
        if (user.trackerToken != undefined) {
            trackerToken = user.trackerToken;
        }
        if (user.chosenCountry != undefined) {
            chosenCountry = user.chosenCountry;
        }
        if (user.chosenMinAge != undefined) {
            chosenMinAge = user.chosenMinAge;
        }
        if (user.chosenMaxAge != undefined) {
            chosenMaxAge = user.chosenMaxAge;
        }
        if (user.privacyPolicyAccepted != undefined) {
            if(user.privacyPolicyAccepted == "") {
                privacyPolicyAccepted = 0;
            } else {
                privacyPolicyAccepted = parseInt(user.privacyPolicyAccepted);
            }
        }
        if (user.applicablePrivacyLaw != undefined) {
            applicablePrivacyLaw = user.applicablePrivacyLaw;
        }
        if (user.privacyVersionChecked != undefined) {
            privacyVersionChecked = user.privacyVersionChecked;
        }
        if (user.applicablePrivacyLaw != undefined) {
            applicablePrivacyLaw = user.applicablePrivacyLaw;
        }
        if (user.privacyVersionChecked != undefined) {
            privacyVersionChecked = user.privacyVersionChecked;
        }
        if (user.appleid != undefined) {
            appleUserId = user.appleid;
        }
        if(user.fbAccessToken != undefined) {
            fbAccessToken = user.fbAccessToken;
        }
        if(user.fbPermissions != undefined) {
            fbPermissions = user.fbPermissions;
        }
        if(user.connectPsIds != undefined) {
            connectPsIds = user.connectPsIds;
        }
        if(user.connectNetworks != undefined) {
            connectNetworks = user.connectNetworks;
        }

        loggerObj.debugLog("IDRevamp - IDs loaded -  PSID: ", refId, " SyncID: ", syncId, " XpromoID: ", xpromoId, " TrackingRefId: ", trackingRefId, " GPSID: " , gpsid);
    }

    var userDataLoaded = true;

    function load() {
        var userData = ls.getItem(constantsObj.USER_DATA_FILE);
        if (userData == null || userData == "") {
            // loggerObj.debugLog("No user data found.");
            userDataLoaded = false;
            // This is a fresh install. Need to generate a trackingRefId for the user.
            trackingRefId = userObj.generateTrackingRefId();
            // loggerObj.debugLog("Tracking refId generated as - ", trackingRefId);
            // advertiserId = utilObj.getAdvertiserId();
            return false;
        }
        loadUserObjLocal(userData);
        return true;
    }

    this.getUserDataLoaded = function () {
        return userDataLoaded;
    };

    // Start using this to send necessary information to game servers about user.
    this.getUserObjForSync = function (user) {
        if(user == undefined || user == null) {
            user = {};
        }
        user.refId = userObj.getPsId();
        user.syncId = userObj.getSyncId();
        user.trackingRefId = userObj.getTrackingRefId();
        user.xpromoId = userObj.getXpromoId();
        user.advertiserId = userObj.getAdvertiserId();
        user.name = userObj.getName();
        user.email = userObj.getEmail();
        user.gender = userObj.getGender();
        user.fbid = userObj.getFbid();
        user.createdAt = userObj.getCreated() + "";
        user.deviceId = userObj.getDeviceId();
        user.infoHash = userObj.getInfoHash();
        user.deviceHash = userObj.getDeviceHash();
        user.gi = gameUserInfoHash + "";
        user.xh = xpromoHash + "";
        user.cli = utilObj.getTrackingClient() + "";
        user.gid = constantsObj.GAME_ID + "";
        return user;
    };

    // Internal function useful to making requests to login server
    this.getUserObj = function (withToken) {
        var user = {};
        user.refId = refId + "";
        if (trackingRefId == "") {
            trackingRefId = refId
        }
        user.trackingRefId = trackingRefId + "";    
        
        user.xpromoId = xpromoId + "";
        user.syncId = syncId + "";
        user.gpsid = gpsid + "";
        user.name = name + "";
        user.email = email + "";
        user.gender = gender + "";
        user.fbid = fbid + "";
        user.created = created + "";
        user.createdAt = created + ""; //This is needed for sync to server.
        user.lastUpdate = lastUpdate + "";
        user.infoHash = infoHash + "";
        user.gi = gameUserInfoHash + "";
        user.xh = xpromoHash + "";
        user.deviceHash = deviceHash + "";
        user.fbAccessToken = fbWrapperObj.getAccessToken() + "";
        user.curDevice = userObj.getCurDevice();
        user.deviceId = user.curDevice;
        if (advertiserId == "") {
            advertiserId = utilObj.getAdvertiserId();
        }
        user.advertiserId = advertiserId;
        user.adjustId = adjustId;
        user.gid = constantsObj.GAME_ID + "";
        user.fbbid = fbbid + "";
        user.cli = utilObj.getTrackingClient() + "";
        user.isPayer = isPayer + "";
        user.payerStatusSynced = payerStatusSynced + "";
        user.chosenName = chosenName + "";
        user.chosenEmail = chosenEmail + "";
        user.trackerToken = trackerToken + "";
        user.appleid = appleUserId + "";
        user.lt = loginType;
        user.uid = userObj.getUserId();
        return user;
    };

    this.getUserId = function () {
        switch (loginType) {
            case psConstantsObj.LOGIN_TYPE_APPLE:
                return appleUserId;

            case psConstantsObj.LOGIN_TYPE_FB:
                return fbbid;
    
            default:
                return "";
        }
    };

    this.getUserObjForSaving = function () {
        var user = userObj.getUserObj();
        user.countryCode = countryCode + "";
        user.subDivision = subDivision + "";
        user.city = city + "";
        user.installNetwork = installNetwork + "";
        user.installCampaign = installCampaign + "";
        user.installAdGroup = installAdGroup + "";
        user.installCreative = installCreative + "";
        user.chosenCountry = chosenCountry + "";
        user.chosenMinAge = chosenMinAge + "";
        user.chosenMaxAge = chosenMaxAge + "";
        user.privacyPolicyAccepted = privacyPolicyAccepted + "";
        user.applicablePrivacyLaw = applicablePrivacyLaw + "";
        user.privacyVersionChecked = privacyVersionChecked + "";
        user.applicablePrivacyLaw = applicablePrivacyLaw + "";
        user.privacyVersionChecked = privacyVersionChecked + "";
        user.fbAccessToken = fbAccessToken + "";
        user.fbPermissions = fbPermissions + "";
        user.connectPsIds = connectPsIds;
        user.connectNetworks = connectNetworks;
        return user;
    };

    this.getMinUserObj = function () {
        var user = {};
        user.refId = refId + "";
        user.createdAt = created + "";
        if (name != "") {
            user.name = name + "";
            user.email = email + "";
            user.gender = gender + "";
            user.infoHash = infoHash + "";
        } else {
            user.deviceHash = deviceHash + "";
            user.deviceId = userObj.getCurDevice();
        }
        return user;
    };

    this.save = function () {
        // if (refId === "" || refId === undefined) {
        //     // loggerObj.debugLog("No need to save blank user");
        //     return false;
        // }

        var user = userObj.getUserObjForSaving();
        ls.setItem(constantsObj.USER_DATA_FILE, utilObj.getStringifiedJson(user));
        return true;
    };

    this.resetSyncInProgress = function () {
        if (syncInProgress) {
            syncInProgress = false;
        }
    };

    this.syncToServer = function (forcedSync, network) {
        // loggerObj.debugLog("Starting user sync:", syncInProgress, forcedSync, refId);
        if ((syncInProgress && (forcedSync == false || forcedSync == undefined)) || !utilObj.isPingWorking()) {
            // loggerObj.debugLog("not syncing user progress syncinprogress, pingtest::", syncInProgress, utilObj.isPingWorking());
            return;
        }
        if (refId == "" || refId == undefined || forcedSync) {
            var map = userObj.getUserObj();
            // TODO: Every game should set RestoreOldProgress itself, reading it through a place like a constants file.
            map.rop = constantsObj.RESTORE_OLD_PROGRESS_ON_LOGIN + "";
            // if (map.deviceId == "" && (map.fbAccessToken == "" || map.fbAccessToken == null)) {
            //     // loggerObj.debugLog("not syncing user progress currdevice, fbaccesstoken::", map.curDevice, map.fbAccessToken);
            //     return;
            // }

            if (syncResetTimer != null) {
                window.clearTimeout(syncResetTimer);
            }
            syncResetTimer = window.setTimeout(userObj.resetSyncInProgress, 60 * 1000);

            syncInProgress = true;
            loggerObj.debugLog("IDRevamp - syncToServer", utilObj.getStringifiedJson(map));
            loginId.sendHttpRequest("user", "login2", map);

            if(network != undefined) {
                syncingForNetwork = network;
            }

            var hasRefId = true;
            if (refId == "" || refId == undefined) {
                hasRefId = false;
            }
            analyticsObj.userSyncStart(hasRefId);
        }
    };

    this.checkAndSync = function () {
        if (refId == "") {
            userObj.syncToServer(false, psConstantsObj.NETWORK_NONE);
        } else if (isPayer == "1" && payerStatusSynced == "0") {
            userObj.markAsPayer();
        }
    };

    function loadUserObjServer(userData) {
        var user = userData.split("^");
        if (user[0] != "") {
            refId = user[0];    
        }
        if (user[1] != "") {
            created = user[1];    
        }
        if (user[2] != "") {
            lastUpdate = user[2];   
        }
        if (user[3] != "") {
            localIsPayer = user[3];
            if (localIsPayer == "1") {
                isPayer = localIsPayer;
                payerStatusSynced = "1";
                if (psUtilObj.checkIsFunction(questsObj.setPayerStatusForDailyQuests)) {
                    questsObj.setPayerStatusForDailyQuests(2);
                }
            }    
        }
        if (user[4] != "") {
            syncId = user[4];
        }
        // if (user[5] != "") {
        //     fbid = user[5];    
        // }
        if (user[7] != "" || email == undefined) {
            email = user[7];
        }
        if (user[8] != "" || chosenEmail == undefined) {
            chosenEmail = user[8];
        }
        if (user[9] != "" || name == undefined) {
            name = user[9];
        }
        if (user[10] != "" || chosenName == undefined) {
            chosenName = user[10];
        }
        if (user[11] != "" || gender == undefined) {
            gender = user[11];
        }
        if (user[12] != "" || Dob == undefined) {
            Dob = user[12];
        }
    }

    this.reset = function () {
        refId = "";
        name = "";
        email = "";
        gender = "";
        fbid = "";
        infoHash = "";
        isPayer = "";
        trackerToken = "";
    };

    this.logout = function () {
        return; // No support for logout with subscriptions
    };

    this.markAsPayer = function () {
        var map = userObj.getUserObj();
        loginId.sendHttpRequest("user", "markPayer2", map);
    };

    this.storeChosenDetails = function () {
        var map = userObj.getUserObj();
        loginId.sendHttpRequest("user", "updateChosen2", map);
    };

    this.respHandler = function (action, data, success) {
        syncInProgress = false;
        if (syncResetTimer != null) {
            window.clearTimeout(syncResetTimer);
            syncResetTimer = null;
        }
        var hasRefId = true;
        if (refId == "" || refId == undefined) {
            hasRefId = false;
        }
        loggerObj.debugLog("IDRevamp - respHandler - ", action, psUtilObj.getStringifiedJson(data), success);
        if (action === "save") {
            analyticsObj.userSyncEnd(hasRefId, action, success);
            if (success === false) {
                return;
            }

            var userUpdated = false;
            userCreated = false;
            var userFbLogin = false;
            if (refId == "" || !refId) {
                userCreated = true;
            }
            var curFbid = fbid;
            loadUserObjServer(data.user);
            
            xpromoId = data.xid;
            gpsid = data.gpsid;
            xpromoHash = data.xh;
            gameUserInfoHash = data.gi;

            if (curFbid != fbid) {
                userFbLogin = true;
            }
            // this updates the old and new sync id to server whenever a additional User is received and decided by client
            var toUpdateSyncIdToServer = false;
            var oldSyncId = "";
            var newSyncId = "";
            
            if (data.additionalInfoHash != "") {
                var additionalUser = data.additionalUser.split("^");
                var curCreation = created;
                var additionalCreation = additionalUser[1];

                oldSyncId = syncId;
                loadUserObjServer(data.additionalUser);
                userUpdated = true;
                gameUserInfoHash = data.agi;

                newSyncId = syncId;
                toUpdateSyncIdToServer = true;
            }
            userObj.setDeviceHash(data.deviceHash);

            if (userUpdated) {
				if (psUtilObj.checkIsFunction(questsObj.setQuestCenterSeen)) {
					questsObj.setQuestCenterSeen(false);
				}
                userObj.setInfoHash(data.additionalInfoHash);
            } else {
                userObj.setInfoHash(data.infoHash);
            }
            userObj.save();

            if (toUpdateSyncIdToServer) {
                userObj.updateSyncIdToServer(oldSyncId, newSyncId);
            }
            
            loggerObj.debugLog("IDRevamp - IDs loaded -  PSID: ", refId, " SyncID: ", syncId, " XpromoID: ", xpromoId, " TrackingRefId: ", trackingRefId, " GPSID: " , gpsid);

            if (userCreated == true) {
                analyticsObj.signUp(psConstantsObj.TRACK_HOME, refId, true);
                trackObj.trackCounter(psConstantsObj.TRACK_FIRST_LAUNCH, psConstantsObj.TRACK_REFID_ALLOCATION, "", userObj.getInstallNetwork(), utilObj.getDeviceModel(), utilObj.getCpuArch(), "", 1, "");
                var deviceWidth = utilObj.getDeviceWidth();
                var deviceHeight = utilObj.getDeviceHeight();
                appResumeTime = utilObj.getCurrentTimestamp();
                if (psUtilObj.checkIsFunction(questsObj.setQuestCenterSeen)) {
					questsObj.setQuestCenterSeen(false);
				}
                if (utilObj.isNative()) {
                    var countryCode = utilObj.getCountry();
                    var osVersion = utilObj.getOsVersion();
                    var deviceModel = utilObj.getDeviceModel();
                    var cpuArch = "";
                    var isOnline = utilObj.isOnline();
                    trackObj.trackCounter("device", osVersion,
                        deviceWidth, deviceHeight, countryCode,
                        deviceModel, "", 1, "");
                    if (utilObj.isAndroid()) {
                        cpuArch = utilObj.getCpuArch();
                        trackObj.trackCounter(psConstantsObj.TRACK_DEBUG, "device", cpuArch, "", "", "", "", 1, "");
                    }
                    analyticsObj.setDeviceInfo(cpuArch, deviceWidth, deviceHeight, deviceModel, curDevice, countryCode, isOnline);
                } else {
                    trackObj.trackCounter("browser", utilObj.getBrowserInfo(),
                        deviceWidth, deviceHeight, utilObj.getBrowserOsInfo(),
                        "", "", 1, "");
                }
                trackObj.save();
                analyticsObj.triggerRefIdEvent();
                analyticsObj.setUserId(refId);
            }

            if (userDataLoaded == false) {
                userDataLoaded = true;
            } else {

            }
            if (userUpdated || userCreated) {
                shouldForceSyncGameObj = true;
				if (psUtilObj.checkIsFunction(questsObj.resetInGameQuestData)) {
					questsObj.resetInGameQuestData();
				}
                gameObj.syncToServer(true);
                epmObj.syncToServer(true);
                analyticsObj.trackInstall();
				window.setTimeout(userObj.delayedUpdates, 5000);
				if (psUtilObj.checkIsFunction(questsObj.resetInGameDataAvailable)) {
					questsObj.resetInGameDataAvailable();
				}
            } else if (userFbLogin) {
                gameObj.syncToServer(true);
                if (psUtilObj.checkIsFunction(questsObj.resetInGameDataAvailable)) {
					questsObj.resetInGameDataAvailable();
				}
            }

            // handle game level actions based on the response
            if (psUtilObj.checkIsFunction(gameSpecificObj.handleUserResponseActions)) { // EDIT: added isFunction check for handling all games
                var userData = userObj.getUserObjForSaving();
                gameSpecificObj.handleUserResponseActions(userCreated, userUpdated, userData);
            }

            if (syncingForNetwork != psConstantsObj.NETWORK_NONE) {
                var connectRefId = data.conPsid;
                if (connectRefId == "" || connectRefId == undefined) {
                    connectRefId = refId
                }
                userObj.checkAndAddConnectPsId(connectRefId, syncingForNetwork);
            }
        } else if (action == "markPayer2") {
            if (success) {
                payerStatusSynced = "1";
                userObj.save();
            }
        } else if (action == "updateChosen2") {
            if (success) {
                userObj.save();
            }
        } else if (action == "privacy") {
            if (success) {
                applicablePrivacyLaw = data.p;
                privacyVersionChecked = data.v;
                // loggerObj.debugLog("Applicable privacy law determined as:", applicablePrivacyLaw, privacyVersionChecked);
            }
        } else if (action == "dailyPing2") {
            if (data.adjId != undefined) {
                adjustId = data.adjId;
            }
            if (data.gi != undefined) {
                gameUserInfoHash = data.gi;
            }
            if (data.xh != undefined) {
                xpromoHash = data.xh;
            }
            if (data.user != undefined) {
                loadUserObjServer(data.user)
            }
            userObj.save();
        }

    };

    this.delayedUpdates = function () {
        if (!fbWrapperObj.isLoggedIn()) {
            return;
        }
        fbRequestObj.checkOpenRequests();
        fbWrapperObj.getPlayingFriends();
        fbWrapperObj.getInvitableFriends();
        friendsObj.syncPsFriends();
    };

    this.isLoggedIn = function () {
        var isLoggedIn = false;
        if (fbid != "" && fbid != null) {
            isLoggedIn = true;
        }
        return isLoggedIn;
    };

    this.isUserCreated = function () {
        return userCreated;
    };

    this.updateNameEmail = function (resp) {
        var respJson = {};
        try {
            respJson = JSON.parse(resp);
            chosenName = respJson.cn;
            chosenEmail = respJson.ce;

            userObj.storeChosenDetails();
        } catch (e) {

        }
    };

    this.generateTrackingRefId = function () {
        // 100,000,000,000 - 100 billion - range of current refIds is upto this.
        // 9007199254740991 - Max safe integer in JS - 2^53 -1 - FfGNdXsE7
        // 9,007,199,254,740,991
        // 1,000,000,000,000,000
        // 100,000,000,000
        //
        // 916,132,831 - ZZZZZ
        // 14,776,335 - ZZZZ
        // Making client generated tracking refIds be like ZZZZZ-ZZZZ.
        // This will clearly differentiate them from current refIds, and using two random numbers which are so large makes the probability of collision really low.
        return Base62.FromBase10(utilObj.getRandomIntInRange(0, 916132831, true)) + "-" + Base62.FromBase10(utilObj.getRandomIntInRange(0, 14776335, true));
    };

    this.getUserCountry = function () {
        var cc = chosenCountry;
        if (chosenCountry == "") {
            cc = utilObj.getCountry();
        }
        return cc.toLowerCase();
    };

    this.showPrivacy = function (theme) {
        var cc = userObj.getUserCountry();
        if (!userObj.isPrivacyAcceptanceRequired(cc)) {
            return;
        }

        if (utilObj.isAndroid()) {
            psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_ANDROID_COMMON + "User", "showPrivacy", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V", theme, refId, trackingRefId, cc, subDivision, applicablePrivacyLaw);
        } else if (utilObj.isIos()) {
            psUtilObj.makeNativeCall("User", "showPrivacy:refId:trackingRefId:countryCode:subDivision:law:", theme, refId, trackingRefId, cc, subDivision, applicablePrivacyLaw);
        } else {
            // TODO: For web what should be triggered?
        }
    };

    this.updateChosenCountry = function (resp) {
        var respJson = {};
        try {
            respJson = JSON.parse(resp);
            chosenCountry = respJson.cc;

            userObj.save();
        } catch (e) {

        }
    };

    this.updateAgeRange = function (resp) {
        var respJson = {};
        try {
            respJson = JSON.parse(resp);
            chosenMinAge = respJson.cmin;
            chosenMaxAge = respJson.cmax;

            userObj.save();
        } catch (e) {

        }
    };

    this.isPrivacyAcceptanceRequired = function (cc) {
        if (PRIVACY_POLICY_EXEMPT[cc] == 1) {
            // loggerObj.debugLog("Privacy - sim in exempted list returning false.");
            return false;
        }
        if (applicablePrivacyLaw == LAW_NONE) {
            // loggerObj.debugLog("Privacy - api returned no policy applicable returning false.");
            return false;
        }
        if (userObj.getCcpaApplicable(cc)) {
            // loggerObj.debugLog("Privacy - ccpa is aaplicable returning true.");
            return true;
        }
        if (userObj.getGdprApplicable(cc)) {
            // loggerObj.debugLog("Privacy - gdpr is applicable returning true.");
            return true;
        }
        return false;
    };


    this.getCcpaApplicable = function (cc) {
        // loggerObj.debugLog("Privacy - checking for ccpa applicable.");
        if (applicablePrivacyLaw == LAW_UNKNOWN) {
            // loggerObj.debugLog("Privacy - no api location, returning sim = us.");
            return (cc =="us");
        } else if (applicablePrivacyLaw == LAW_CCPA) {
            // loggerObj.debugLog("Privacy - api returned ccpa applicable");
            return true;
        }
        // loggerObj.debugLog("Privacy - ccpa not applicable, all checks done.");
        return false;
    };


    this.getGdprApplicable = function (cc) {
        // loggerObj.debugLog("Privacy - checking for gdpr applicable.");
        if (applicablePrivacyLaw == LAW_UNKNOWN) {
            // loggerObj.debugLog("Privacy - no api data, returning gdpr as true.");
            return true;
        } else if(applicablePrivacyLaw == LAW_GDPR) {
            // loggerObj.debugLog("Privacy - api returned gdpr applicable.");
            return true;
        }
        // loggerObj.debugLog("Privacy - gdpr not applicable, all checks done.");
        return false;
    };



    this.acceptPrivacyPolicy = function (resp) {
        privacyPolicyAccepted = "1";
		userObj.save();
		psMopubAdsObj.grantMopubConsent();
    };

    this.getPrivacyPolicyStatus = function () {
        if (!userObj.isPrivacyAcceptanceRequired(userObj.getUserCountry())) {
            // loggerObj.debugLog("Privacy - Acceptance is not required hence returning status as true");
            //Privacy Not required
            // loggerObj.debugLog("Privacy - ", userObj.getUserCountry());
            return true;
        }
        // loggerObj.debugLog("Privacy - ", userObj.getUserCountry(), privacyPolicyAccepted);
        // loggerObj.debugLog("Privacy - Acceptance is required hence returning Accept status");
        //Privacy Accepted then true else false
        return userObj.getIsCurrentPrivacyAccepted();
    };


    this.getIsCurrentPrivacyAccepted = function () {
        return (privacyPolicyAccepted == userObj.getCurrentPrivacyVersion());
    };

    this.getCurrentPrivacyVersion = function () {
        return constantsObj.PRIVACY_VERSION;
    };

    this.checkPrivacyFirstSession = function () {
        if (userDataLoaded) {
            // loggerObj.debugLog("Privacy - user data already loaded");
            return;
        }
        // loggerObj.debugLog("Privacy - user data not loaded");
        // TODO: This check would prevent calls to server for checking privacy policy status.
        // To be removed at a later stage once we know that the api is stable.
        // Additional check for stored privacyVersionChecked and runtime value of privacyVersion to be added
        // - if the two differ, check to be done again on server
        if (userObj.getPrivacyPolicyStatus()) {
            // loggerObj.debugLog("Privacy - user status already known and not us");
            return;
        }
        // loggerObj.debugLog("Privacy - user privacy status unknown");
        // Make a request for ip based determination of privacy policy
        loginRest.sendHttpRequest("ip", "privacy", {});
    };

    this.getApplicablePrivacyLaw = function () {
        return applicablePrivacyLaw;
    };

    // TODO: Call this once a day.
    // Send a daily ping to id server with your information. ID server will update internal data, and return any new data it has.
    this.sendDailyPing = function () {
        if (refId != "") {
            var map = userObj.getUserObj();
            loginId.sendHttpRequest("user", "dailyPing2", map);
        }
    };

    this.updateInformationFromFbLogin = function (map) {
        if (map["id"] != undefined) {
            fbid = map["id"];    
        }
        if (map["name"] != undefined) {
            name = map["name"];    
        }
        if (map["gender"] != undefined) {
            gender = map["gender"];
        }
        if (map["email"] != undefined) {
            email = map["email"];    
        }
        if (map["token_for_business"] != undefined) {
            fbbid = map["token_for_business"];
        }
        if (map["accessToken"] != undefined) {
            fbAccessToken = map["accessToken"];
        }
        if (map["permissions"] != undefined) {
            fbPermissions = map["permissions"];
        }
        userObj.setLoginType(psConstantsObj.LOGIN_TYPE_FB);
    };

      // ----------------

    // Apple Sign in helper functions

    /**
     * receives the success response
     * @param resp -> json with userId, email and name
     */
    var APPLE = "apple";
    this.loginSuccessActions = function (resp) {
        var respJson = {};
        try {
            respJson = JSON.parse(resp);
        } catch (e) {

        }

        var type = respJson.type;
        switch (type) {
            case APPLE:
                var appleID = respJson.appleid;
                var email = respJson.emailID;
                var name = respJson.fullName;

                // sets email from apple login data
                if (email != "") {
                    userObj.setEmail(email);
                }

                // sets name from apple login data
                if (name != "") {
                    userObj.setName(name);
                }

                userObj.setLoginType(psConstantsObj.LOGIN_TYPE_APPLE);
                userObj.setAppleUserId(appleID); // saving apple id in user local data
                userObj.syncToServer(true, psConstantsObj.NETWORK_APPLE);
                if(appleLoginCallback != null)
                {
                    appleLoginCallback();
                    appleLoginCallback = null;
                }
                loggerObj.debugLog("AppleSign: values are appleId -> ", appleID, " email ->", email, " name is -> ", name);

                break;
            default:
                // Nothing for now
        }


    };

    this.appleLogin = function (callback) {
        appleLoginCallback = callback;
        if(utilObj.isIos()){
			psUtilObj.makeNativeCall("PSLogin", "startAppleSignIn");
		}
    }

    /**
     * updates the new and old sync id to server
     * @param oldSyncId -> which is not chosen on client
     * @param newSyncId -> which is chosen out of two
     */
    this.updateSyncIdToServer = function (oldSyncId, newSyncId) {
        var map = userObj.getUserObj();
        map.oldSyncId = oldSyncId + "";
        map.newSyncId = newSyncId + "";

        loginId.sendHttpRequest("user", "updateSyncId", map);
        loggerObj.debugLog("userRevamp: update sync id request sent", JSON.stringify(map));
    }

    this.checkAndAddConnectPsId = function (psId, network) {
        var found = false;
        for (var i = 0; i < connectPsIds.length; i++) {
            if (connectPsIds[i] == psId) {
                found = true;
                break;
            }
        }
        if (!found) {
          connectPsIds.push(psId);
          connectNetworks.push(network);
        }
    }

};

var Base62 = (function(){
    var table = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';

    function _to10(num)
    {
        var limit = num.length;
        var res = 0;
        for (var i = 0; i < limit; i ++)
        {
            res = 62 * res + table.indexOf(num.charAt(i));
        }
        return res;
    }

    function _toBase(num)
    {
        var r = num % 62;
        var res = table.charAt(r);
        var q = Math.floor(num / 62);
        while (q)
        {
            r = q % 62;
            q = Math.floor(q / 62);
            res = table.charAt(r) + res;
        }
        return res;
    }

    return {
        FromBase10: function()
        {
            var r = [];
            for (var i = 0; i < arguments.length; i ++)
            {
                var num = parseInt(arguments[i]);
                r.push(_toBase(num));
            }
            return r;
        },

        FromBase62: function()
        {
            var r = [];
            for (var i = 0; i < arguments.length; i ++)
            {
                var num = arguments[i].toString();
                if (num.length)
                {
                    r.push(_to10(num));
                }
            }
            return r;
        }
    }
})();
