var LandingScreenLayer = cc.Layer.extend({
    functionSelected: null,
    loginButton: null,
    playAsGuestButton: null,
    dailyPuzzleButton: null,
    playLevelButton: null,
    settingsButton: null,
    isEocUser : false,
    jewelIconTop : null,
    jewelLabelTop : null,

    show: function (isFirstLaunch, isFirstSession) {

        var screen = constantsObj.SCREEN_LANDING;
        var screenName = utilObj.getScreenName(screen);
        utilObj.updateScreenBegin(screen);
        utilObj.hideBannerAd(utilObj.getScreenName(constantsObj.SCREEN_LANDING));

        landingScreenLayer.isEocUser = false;

        var zOrder = constantsObj.UI_Z_ORDER;
        var labelArr = [];
        var spriteArr = [];

        var xPos = centerXPos;
        var yPos = centerYPos;
        var animDelay = 0;

        var bgScaling = 1.25 * aspectRatio / constantsObj.ASPECT_NORMAL;
        if (aspectRatio < 1.78) {
            var scale = 1.78 / aspectRatio;
            bgScaling = scale * 1.25;
        }
        /**
         * landing screen background image
         */
        utilObj.getSprite(constantsObj.landing_screen_bg, xPos, yPos, 0.5, 0.5, bgScaling, spriteArr, landingScreenLayer, zOrder, constantsObj.SPRITE_MISC);
        /**
         * crossword explorer logo (with spine animation)
         */
        yPos = constantsObj.DESIGN_HEIGHT;
        
        var treeArrow = utilObj.getSprite(constantsObj.tree_arrow, xPos, yPos - 260, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 1.7, spriteArr, landingScreenLayer, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setOpacity(treeArrow , constantsObj.OPACITY_0);
        landingScreenLayer.fadeInNode(treeArrow, animDelay, 0.3,constantsObj.OPACITY_100);

        animDelay += 0.2;
        // daily_headingIcon
        var tinyTxt = utilObj.getSprite(constantsObj.tiny_icon, xPos, yPos - 480, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 1.3, spriteArr, landingScreenLayer, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setOpacity(tinyTxt , constantsObj.OPACITY_0);
        landingScreenLayer.fadeInNode(tinyTxt, animDelay, 0.3,constantsObj.OPACITY_100);

        animDelay += 0.1;
        var crosswordTxt = utilObj.getSprite(constantsObj.crossword_tiny_icon, xPos, yPos - 670, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 1.7, spriteArr, landingScreenLayer, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setOpacity(crosswordTxt , constantsObj.OPACITY_0);
        landingScreenLayer.fadeInNode(crosswordTxt, animDelay, 0.3,constantsObj.OPACITY_100);
    
        animDelay += 0.2;
        var bottomArrow = utilObj.getSprite(constantsObj.arrow_bottom, xPos, yPos - 800, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 1.7, spriteArr, landingScreenLayer, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setOpacity(bottomArrow , constantsObj.OPACITY_0);
        landingScreenLayer.fadeInNode(bottomArrow, animDelay, 0.3,constantsObj.OPACITY_100);

        animDelay += 0.3;

        /**
         * Setting Button
         */
        var settingsIsFrom = constantsObj.TRACK_NON_FB_SCREEN;
        var speciesState = gameObj.getPuzzleSpeciesTracking();
        if (isFirstLaunch || !fbWrapperObj.isLoggedIn()){
            settingsIsFrom = constantsObj.TRACK_FB_LAUNCH;
        } else {
            settingsIsFrom = constantsObj.TRACK_NON_FB_SCREEN;
        }

        var jewlNotifState = questCenterObj.showJewelNotif();
        if(jewlNotifState >= 0){
            settingsIsFrom += "_notif";
            speciesState = questCenterObj.questCenterState();
        }

        yPos += topBarOffset
        var childArr = [];
        landingScreenLayer.settingsButton = utilObj.getButton(180, 180, 0.5, 0.5,
            xRightPos - 120, yPos - 120, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'landingScreenLayer',
                fn: 'openSettings',
                screen: screen,
                params: {
                    "sound": constantsObj.button_tap_01,
                    "sound_on": true,
                },
                child: childArr,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                    o: settingsIsFrom,
                    f: constantsObj.TRACK_SETTINGS,
                    g: "",
                    s: speciesState,
                    co: 1,
                    oppId: ""
                },
                feedBackType: constantsObj.GREY_EFFECT
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(landingScreenLayer, landingScreenLayer.settingsButton, zOrder + 1);

        var settings = utilObj.getSprite(constantsObj.SETTING_ICON_2, 90, 90, 0.5, 0.5, constantsObj.SCALE_SPRITE_1 * 0.8, spriteArr, landingScreenLayer.settingsButton, zOrder, constantsObj.SPRITE_MISC);
        
        /**
         * Adding Jewel Notif For Qc
         */
        
        var jewelNotifText = "NEW";
        if(jewlNotifState > 0){
            jewelNotifText = jewlNotifState;
        }
        landingScreenLayer.jewelIconTop  = utilObj.getSprite(constantsObj.newJewelBg, 110, 138, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.4, spriteArr, landingScreenLayer.settingsButton, zOrder + 1, constantsObj.SPRITE_MISC);
        landingScreenLayer.jewelLabelTop = utilObj.getBMFontLabel(jewelNotifText, constantsObj.FONT_HELVETICA_MEDIUM_35, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 110,140, 0.5, 0.5, labelArr, landingScreenLayer.settingsButton, zOrder+1);

        utilObj.setVisible(landingScreenLayer.jewelIconTop , false);
        utilObj.setVisible(landingScreenLayer.jewelLabelTop , false);

        utilObj.updateJewelNotifTop(landingScreenLayer.jewelIconTop , landingScreenLayer.jewelLabelTop);
        /**
         * Setting button animation
         */
        landingScreenLayer.settingsButton.setCascadeOpacityEnabled(true);
        utilObj.setOpacity(landingScreenLayer.settingsButton, constantsObj.OPACITY_0);
        utilObj.setVisible(landingScreenLayer.settingsButton, false);

        utilObj.delayedCallback(landingScreenLayer, landingScreenLayer.showButton, animDelay, {buttonToShow: landingScreenLayer.settingsButton}, false);

        /**
         * Login and daily puzzle button flow
         */
        yPos = 0;
        var playBtnText = "";
        var font = "";
        var buttonWidth = 800;
        var buttonHeight = 240;
        yPos += 850;
        /**
         *  For first launch show facebook login & play as a guest option
         */
        var trackNonFbClick = constantsObj.TRACK_LEVEL_PLAY;
        if ((isFirstLaunch || !fbWrapperObj.isLoggedIn() ) && !utilObj.isIos() && false) {
            
            landingScreenLayer.loginButton = utilObj.getButton(1125, 240, 0.5, 0.5,
                xPos, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: 'landingScreenLayer',
                    fn: 'showLogin',
                    screen: screen,
                    params: {
                        "sound": constantsObj.button_tap_01,
                        "sound_on": true,
                    },
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                        o: constantsObj.TRACK_FB_LAUNCH,
                        f: constantsObj.TRACK_FB_LOGIN,
                        g: "",
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            utilObj.addChild(landingScreenLayer, landingScreenLayer.loginButton, zOrder + 1);

            var newX = landingScreenLayer.loginButton.getContentSize().width / 2;
            var newY = landingScreenLayer.loginButton.getContentSize().height / 2;

            var childArr = utilObj.getRoundedButton(landingScreenLayer.loginButton.getContentSize().width / 2, landingScreenLayer.loginButton.getContentSize().height / 2, 1125, 240, spriteArr, landingScreenLayer.loginButton, zOrder, constantsObj.COLOR_FB_LOGIN, 0);
            var faebookIcon = utilObj.getSprite(constantsObj.facebook_logo, newX - 450, newY + 15, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1, spriteArr, landingScreenLayer.loginButton, zOrder + 1, constantsObj.SPRITE_MISC);
            var saleTag = utilObj.getSprite(constantsObj.sale_tag, newX + 450, newY + 15, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.7, spriteArr, landingScreenLayer.loginButton, zOrder + 1, constantsObj.SPRITE_MISC);
            var coin = utilObj.getSprite(constantsObj.coin_png_3, newX + 450, newY + 10, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.65, spriteArr, landingScreenLayer.loginButton, zOrder + 1, constantsObj.SPRITE_MISC);

            var coinText = utilObj.getBMFontLabel("100", constantsObj.FONT_HELVETICA_55, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), newX + 445, newY - 65, 0.5, 0.5, labelArr, landingScreenLayer.loginButton, zOrder + 1);

            var freeText = utilObj.getBMFontLabel("FREE", constantsObj.FONT_HELVETICA_35, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), newX + 450, newY - 110, 0.5, 0.5, labelArr, landingScreenLayer.loginButton, zOrder + 1);

            var loginFont = utilObj.getBMFontLabel("Login & Play", constantsObj.FONT_HELVETICA_MEDIUM_120, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), newX, newY + 15, 0.5, 0.5, labelArr, landingScreenLayer.loginButton, zOrder + 1);

            utilObj.pulseButton(landingScreenLayer.loginButton, constantsObj.PULSE_ACTION_TAG, 0);

            /**
             * Facebook login button animation .
             */
            landingScreenLayer.loginButton.setCascadeOpacityEnabled(true);
            utilObj.setOpacity(landingScreenLayer.loginButton, constantsObj.OPACITY_0);
            utilObj.setVisible(landingScreenLayer.loginButton, false);


            utilObj.delayedCallback(landingScreenLayer, landingScreenLayer.showButton, animDelay, {buttonToShow: landingScreenLayer.loginButton}, false);

            /**
             * Play as a Guest
             */
            yPos -= 300;
            buttonWidth = 700;
            buttonHeight = 240;
            font = constantsObj.FONT_HELVETICA_80;
            playBtnText = "Play as Guest";
            landingScreenLayer.functionSelected = 'playAsGuest';

            var childArr = [];
            landingScreenLayer.playAsGuestButton = utilObj.getButton(buttonWidth, buttonHeight, 0.5, 0.5,
                xPos, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: 'landingScreenLayer',
                    fn: landingScreenLayer.functionSelected,
                    screen: screen,
                    params: {
                        "sound": constantsObj.button_tap_01,
                        "sound_on": true,
                    },
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                        o: constantsObj.TRACK_FB_LAUNCH,
                        f: constantsObj.TRACK_GUEST,
                        g: "",
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                    child: childArr,
                    feedBackType: constantsObj.GREY_EFFECT
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            utilObj.addChild(landingScreenLayer, landingScreenLayer.playAsGuestButton, zOrder + 1);

            newX = landingScreenLayer.playAsGuestButton.getContentSize().width / 2;
            newY = landingScreenLayer.playAsGuestButton.getContentSize().height / 2;

            var btnArr = utilObj.getRoundedButton(newX, newY, buttonWidth, buttonHeight, spriteArr, landingScreenLayer.playAsGuestButton, zOrder, constantsObj.COLOR_PRIMARY_BTN, 0);
            var playText = utilObj.getBMFontLabel(playBtnText, font, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), newX, newY + 15, 0.5, 0.5, labelArr, landingScreenLayer.playAsGuestButton, zOrder + 1);
            /**
             * play as a guest animation .
             */
            landingScreenLayer.playAsGuestButton.setCascadeOpacityEnabled(true);
            utilObj.setOpacity(landingScreenLayer.playAsGuestButton, constantsObj.OPACITY_0);
            utilObj.setVisible(landingScreenLayer.playAsGuestButton, false);

            animDelay += 0.1;
            utilObj.delayedCallback(landingScreenLayer, landingScreenLayer.showButton, animDelay, {buttonToShow: landingScreenLayer.playAsGuestButton}, false);
            
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1, constantsObj.TRACK_FB_LAUNCH, constantsObj.TRACK_VIEW, "", gameObj.getPuzzleSpeciesTracking(), "", "");

        } /**else if (isFirstSession) {

            playBtnText = "Play"
            landingScreenLayer.functionSelected = 'playClicked';
            font = constantsObj.FONT_HELVETICA_MEDIUM_120;

            trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1,  constantsObj.TRACK_NON_FB_SCREEN, constantsObj.TRACK_VIEW, "", gameObj.getPuzzleSpeciesTracking(), "", "");
            trackNonFbClick = constantsObj.TRACK_PLAY_SESSION;
        } */ 
        else {

            if(utilObj.isIos() && isFirstLaunch){
                playBtnText = "Play";
                landingScreenLayer.functionSelected = 'playAsGuest';
                font = constantsObj.FONT_HELVETICA_MEDIUM_120;

            } else  { 

                if(linearLevelObj.getCurLevel() > constantsObj.TOTAL_NUM_COUNTRIES){
                    landingScreenLayer.isEocUser = true;
                    playBtnText = "Play";
                    landingScreenLayer.functionSelected = 'showEocToaster';
                    font = constantsObj.FONT_HELVETICA_MEDIUM_120;
                } else{
                    var levelNumber = linearLevelObj.getDtc2PuzzleCompleted() + 1;
                    playBtnText = "Level " + levelNumber;
                    landingScreenLayer.functionSelected = 'openLevelPuzzle';
                    font = constantsObj.FONT_HELVETICA_MEDIUM_120;
                }
            }
            
            

            trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1, constantsObj.TRACK_NON_FB_SCREEN, constantsObj.TRACK_VIEW, "", gameObj.getPuzzleSpeciesTracking(), "", "");
            trackNonFbClick = constantsObj.TRACK_LEVEL_PLAY;
        }


        /**
         * For the firts session of the day after play button is shown and onclick the player is redirected to llp
         * and for the second session and onwords if landing screen is opened the level x button will be shown
         */
        if ((!isFirstLaunch && fbWrapperObj.isLoggedIn()) || (utilObj.isIos())) {
            
            var childArr = [];
            landingScreenLayer.playLevelButton = utilObj.getButton(buttonWidth, buttonHeight, 0.5, 0.5,
                xPos, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: 'landingScreenLayer',
                    fn: landingScreenLayer.functionSelected,
                    screen: screen,
                    params: {
                        "sound": constantsObj.button_tap_01,
                        "sound_on": true,
                    },
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                        o: constantsObj.TRACK_NON_FB_SCREEN,
                        f: trackNonFbClick,
                        g: "",
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                    child : childArr,
                    feedBackType: constantsObj.GREY_EFFECT
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            utilObj.addChild(landingScreenLayer, landingScreenLayer.playLevelButton, zOrder + 1);

            var newX = landingScreenLayer.playLevelButton.getContentSize().width / 2;
            var newY = landingScreenLayer.playLevelButton.getContentSize().height / 2;
            var childArr = utilObj.getRoundedButton(newX, newY, buttonWidth, buttonHeight, spriteArr, landingScreenLayer.playLevelButton, zOrder, constantsObj.COLOR_PRIMARY_BTN, 0);

            var playText = utilObj.getBMFontLabel(playBtnText, font, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), newX, newY + 15, 0.5, 0.5, labelArr, landingScreenLayer.playLevelButton, zOrder + 1);

            if(landingScreenLayer.isEocUser){
                // landingScreenLayer.playLevelButton.setCascadeOpacityEnabled(true);
            } else{
                utilObj.pulseButton(landingScreenLayer.playLevelButton, constantsObj.PULSE_ACTION_TAG, 0);
            }
           

            /**
             * play level animation
             */
            landingScreenLayer.playLevelButton.setCascadeOpacityEnabled(true);
            utilObj.setOpacity(landingScreenLayer.playLevelButton, constantsObj.OPACITY_0);
            utilObj.setVisible(landingScreenLayer.playLevelButton, false);

            utilObj.delayedCallback(landingScreenLayer, landingScreenLayer.showButton, animDelay, {buttonToShow: landingScreenLayer.playLevelButton}, false);
        }

        /**
         * Daily Puzzle
         */
        var dailyPuzzleIsFrom = constantsObj.TRACK_NON_FB_SCREEN;
        if (isFirstLaunch || !fbWrapperObj.isLoggedIn()){
            dailyPuzzleIsFrom = constantsObj.TRACK_FB_LAUNCH;
        } else {
            dailyPuzzleIsFrom = constantsObj.TRACK_NON_FB_SCREEN;
        }

        yPos -= 300;
        var childArr = [];

        var opacity = constantsObj.OPACITY_100;
        var stateofDailyPuzzle = linearLevelProgression.getStateOfDailyPuzzle();

        var buttonTapState = "";
        if (stateofDailyPuzzle != constantsObj.STATE_LOCKED){
            buttonTapState = constantsObj.GREY_EFFECT;
        }

        landingScreenLayer.dailyPuzzleButton = utilObj.getButton(buttonWidth, buttonHeight, 0.5, 0.5,
            xPos, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'landingScreenLayer',
                fn: 'openDailyPuzzle',
                screen: screen,
                params: {
                    "sound": constantsObj.button_tap_01,
                    "sound_on": true,
                },
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                    o: dailyPuzzleIsFrom,
                    f: constantsObj.TRACK_DAILY_PUZZLE,
                    g: "",
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
                child: childArr,
                feedBackType: buttonTapState
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(landingScreenLayer, landingScreenLayer.dailyPuzzleButton, zOrder + 1);

        newX = landingScreenLayer.dailyPuzzleButton.getContentSize().width / 2;
        newY = landingScreenLayer.dailyPuzzleButton.getContentSize().height / 2;

        var btnArr = utilObj.getRoundedButton(newX, newY, buttonWidth, buttonHeight, spriteArr, landingScreenLayer.dailyPuzzleButton, zOrder, constantsObj.COLOR_DAILY_PUZZLE, 0);
        utilObj.setCascadeOpacityEnabled(btnArr[0], true);

        var dailyText = utilObj.getBMFontLabel("Daily Puzzle", constantsObj.FONT_HELVETICA_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), newX + 70, newY + 15, 0.5, 0.5, labelArr, landingScreenLayer.dailyPuzzleButton, zOrder + 1);


        // if it is locked
        if (stateofDailyPuzzle != constantsObj.STATE_LOCKED) {
            var dailyCalender = utilObj.getSprite(constantsObj.DAILY_CALLENDER, newX - 220, newY + 20, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.6, spriteArr, landingScreenLayer.dailyPuzzleButton, zOrder + 1, constantsObj.SPRITE_MISC);

            var today = new Date();
            var currDate = today.getDate();
            var currMonth = linearLevelObj.getCurrentMonth(today.getMonth());
            if (currDate < 10) {
                currDate = "0" + currDate;
            }

            var currDateText = utilObj.getBMFontLabel(currDate, constantsObj.FONT_HELVETICA_MEDIUM_40, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), newX - 220, newY + 8, 0.5, 0.5, labelArr, landingScreenLayer.dailyPuzzleButton, zOrder + 1);

            var currMonthText = utilObj.getBMFontLabel(currMonth, constantsObj.FONT_ROBOTO_REGULAR_25, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), newX - 220, newY + 42, 0.5, 0.5, labelArr, landingScreenLayer.dailyPuzzleButton, zOrder + 1);
        } else {

            var lockIcon = utilObj.getSprite(constantsObj.lock_quest, newX - 220, newY + 20, 0.5, 0.5, constantsObj.SCALE_SPRITE_15 * 1.1, spriteArr, landingScreenLayer.dailyPuzzleButton, zOrder + 1, constantsObj.SPRITE_MISC);

            // var runtimeValue = runtimeObj.getDailyPuzzle();
            // var splitStr = runtimeValue.split(":");
            // var puzzleNeeded = parseInt(splitStr[1]);
            var unlockTextLandingScreen = "Unlocks after a few puzzles!";
            var unlockText = utilObj.getBMFontLabel(unlockTextLandingScreen, constantsObj.FONT_HELVETICA_MEDIUM_55, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), newX, newY - buttonHeight / 2 - 15, 0.5, 0.5, labelArr, landingScreenLayer.dailyPuzzleButton, zOrder + 1);

            opacity = constantsObj.OPACITY_70;
        }
        /**
         * Daily puzzle animation
         */
        landingScreenLayer.dailyPuzzleButton.setCascadeOpacityEnabled(true);
        utilObj.setOpacity(landingScreenLayer.dailyPuzzleButton, 0);
        utilObj.setVisible(landingScreenLayer.dailyPuzzleButton, false);

        animDelay += 0.1;
        utilObj.delayedCallback(landingScreenLayer, landingScreenLayer.showButton, animDelay, {
            buttonToShow: landingScreenLayer.dailyPuzzleButton,
            opacity: opacity
        }, false);

        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);
        utilObj.updateScreen(screen, landingScreenLayer);
    },

    hide: function () {
        landingScreenLayer.setVisible(false);
        landingScreenLayer.removeAllChildren();
    },
    /**
     *  if ftue is not complete then redirect to gameLayer for rhat
     */
    playClicked: function () {
        if (!ftueObj.isFtueShown()) {
            landingScreenLayer.showHome();
        } else {
            landingScreenLayer.hide();
            linearLevelProgression.show();
        }
    },
    showLogin: function () {
        gameObj.setisFirstLaunchClicked(true);
        if (fbWrapperObj.isLoggedIn()) {
            landingScreenLayer.loginSuccess();
        } else {
            fbWrapperObj.login(landingScreenLayer.loginSuccess);
        }
    },

    /**
     * callback from the fb login listeners
     */
    loginSuccess: function () {
        gameObj.setLoggedInFb(true);
        landingScreenLayer.showHome();
    },

    /**
     * redraws screen on cases
     * 1. Fb login success on first launch
     * 2. Fb login from settings popup success
     */
    redraw: function () {
        landingScreenLayer.hide();
        landingScreenLayer.show(false, false);
    },

    showHome: function () {

        /**
         * Handling the when all puzzles are completed
         */
        if(linearLevelObj.getDtc2PuzzleCompleted() >= linearLevelObj.totalDtc2Puzzles()){
            landingScreenLayer.hide();
            linearLevelProgression.show();
            return;
        }

        var index = linearLevelObj.getDtc2PuzzleCompleted();
        var gameId = linearLevelObj.getPuzzleIdLlp(index);
        linearLevelObj.setClickedNodeId(gameId);

        landingScreenLayer.hide();
        gameLayer.show(gameId);
    },
    openLevelPuzzle: function () {

        var index = linearLevelObj.getDtc2PuzzleCompleted();
        var gameId = linearLevelObj.getPuzzleIdLlp(index);
        linearLevelObj.setClickedNodeId(gameId);

        landingScreenLayer.hide();
        gameLayer.show(gameId);
    },
    playAsGuest: function () {
        loggerObj.debugLog("play as guest");
        gameObj.setisFirstLaunchClicked(true);
        userObj.syncToServer();
        landingScreenLayer.showHome();
    },

    /**
     * Eoc Function Called
     */
    showEocToaster : function(){
        utilObj.showMessage("You have completed all puzzles! Please play the Daily Puzzle while we make more!");

    },

    /**
     * opens the daily puzzle
     */
    openDailyPuzzle: function () {
        // gets the state of the daily puzzle button
        var stateofDailyPuzzle = linearLevelProgression.getStateOfDailyPuzzle();

        var runtimeValue = runtimeObj.getDailyPuzzle();
        var splitStr = runtimeValue.split(":");
        var puzzleNeeded = parseInt(splitStr[0]);

        // if it is locked
        if (stateofDailyPuzzle == constantsObj.STATE_LOCKED) {
            utilObj.showMessage("Clear Level " + puzzleNeeded + " to play the Daily Puzzle!");
            var trackPuzzleNeeded = puzzleNeeded + "_landing";
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_DAILY_PUZZLE_UNLOCK, constantsObj.TRACK_VIEW, trackPuzzleNeeded, gameObj.getPuzzleSpeciesTracking(), "", "");
            return;
        }

        var puzzleId = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
        puzzleId = stringsObj.mini_prefix + puzzleId.substr(2, puzzleId.length);

        var ifPuzzleCompleted = gameObj.getPuzzleCompleted(puzzleId);
        if (ifPuzzleCompleted) {
            utilObj.showMessage("You've completed today's puzzle. Solve again tomorrow!");
            return;
        }

        if (gameObj.getCrosswordForDate(puzzleId) == null) {
            ftueObj.setDailyMiniFtueShown(true);
            if (utilObj.isOnline() == false) {
                utilObj.showMessage("Please connect to internet to download content");
            } else {
                utilObj.showMessage("Please try after some time");
            }
            return;
        }

        landingScreenLayer.hide();
        gameLayer.show(puzzleId);

    },
    /**
     * open settings popup
     */
    openSettings: function () {
        settingsPopup.show(constantsObj.SCREEN_LANDING);
    },
    back: function () {
        if (utilObj.isAndroid()) {
            quitPopup.show(constantsObj.SCREEN_LANDING);
        }
    },


    /**
     * show button func used in animation to show a button after delay
     */
    showButton: function (sender, params) {
        var node = params.buttonToShow;
        var opacity = constantsObj.OPACITY_100;
        if (params.opacity) {
            opacity = params.opacity;
        }
        loggerObj.debugLog("sss :", node, opacity);
        landingScreenLayer.fadeInNode(node, 0, 0.3, opacity);
        utilObj.delayedCallback(landingScreenLayer, landingScreenLayer.visibleButton, 0.1, {visibleNode: node}, false);
    },

    visibleButton: function (sender, params) {
        utilObj.setVisible(params.visibleNode, true);
    },

    /**
     *  Fade in animation on a node.
     */
    fadeInNode: function (node, animdelay, delay, opacity) {
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        var initdelay = utilObj.getDelayTime(animdelay);
        var fadeIn = utilObj.getFadeIn(delay).easing(cc.easeIn(1));
        if (opacity != undefined) {
            fadeIn = utilObj.getFadeTo(delay, opacity).easing(cc.easeIn(1));
        }
        var animArr = [];
        animArr.push(initdelay);
        animArr.push(fadeIn);
        animObj.runAction(node, utilObj.getSequence(animArr));
    },

    // updateJewelNotifTop : function(){

    //     var jewlNotifState = questCenterObj.showJewelNotif();

    //     if(jewlNotifState == 0){
    //         utilObj.setString(landingScreenLayer.jewelLabelTop, "NEW");
    //         utilObj.setVisible(landingScreenLayer.jewelIconTop , true);
    //         utilObj.setVisible(landingScreenLayer.jewelLabelTop , true);
    //     }else if(jewlNotifState > 0){
    //         var strg = "";
    //         strg += jewlNotifState;
    //         utilObj.setString(landingScreenLayer.jewelLabelTop, strg);
    //         utilObj.setVisible(landingScreenLayer.jewelIconTop , true);
    //         utilObj.setVisible(landingScreenLayer.jewelLabelTop , true);
    //     }else if(jewlNotifState == -1){
    //         utilObj.setVisible(landingScreenLayer.jewelIconTop , false);
    //         utilObj.setVisible(landingScreenLayer.jewelLabelTop , false);
    //     }
    // },

    freeVideoFunc: function () {
        
        if (!utilObj.isOnline()) {
            utilObj.showMessage(stringsObj.not_online);
            return;
        }
        
        var coolDownPeriod = 7200;

        var firstVideoShownTimeStamp = gameObj.getFirstVideoSeenTimeStamp();
        if (firstVideoShownTimeStamp == null || (utilObj.getCurrentTimestamp() - firstVideoShownTimeStamp) > coolDownPeriod) {
            firstVideoShownTimeStamp = utilObj.getCurrentTimestamp();
            gameObj.setFirstVideoSeenTimeStamp(firstVideoShownTimeStamp);
            if (!(gameObj.isEligibleForVideoAchiement() && gameObj.getAchievementsState(43) == constantsObj.ACHIEVEMENT_IN_PROGRESS)) {
                gameObj.setNumVideos(0);
            }
        }

        // var storeVideoVariant = epmObj.getChosenVariant(constantsObj.EXP_STORE_VIDEO_VIEWS);
        // var forcedEarnFreeFtue = false;
        // if (storeVideoVariant == constantsObj.EXP_VAR_1) {
        //     var lastStoreVideoClickedTimeStamp = gameObj.getWatchVideoStoreTimeStamp();
        //     var currTimeStamp = utilObj.getCurrentTimestamp();
        //     if (currTimeStamp - lastStoreVideoClickedTimeStamp < constantsObj.SECONDS_IN_HOUR) {
        //         forcedEarnFreeFtue = true;
        //     } else {
        //         gameObj.setWatchVideoStoreTimeStamp(currTimeStamp);
        //     }
        // }

        var maxVideosAllowed = 5;
        if (gameObj.getIsPayer()) {
            maxVideosAllowed = runtimeObj.getNumVideosNew(2);
        } else {
            if ((utilObj.getCurrentTimestamp() - userObj.getCreated()) < 7 * constantsObj.SECONDS_IN_DAY) {
                maxVideosAllowed = runtimeObj.getNumVideosNew(0);
            } else {
                maxVideosAllowed = runtimeObj.getNumVideosNew(1);
            }
        }

        if (gameObj.isEligibleForVideoAchiement() && gameObj.getAchievementsState(43) == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
            maxVideosAllowed = 6;
        }

        if ((utilObj.getCurrentTimestamp() - firstVideoShownTimeStamp) < coolDownPeriod && gameObj.getNumVideos() < maxVideosAllowed) {
            if (adsObj.checkRewardedVideo(false, landingScreenLayer.callbackfnForVideo)) {
                gameObj.setLastVideoSeenTimeStamp(utilObj.getCurrentTimestamp());
                /*if (storeVideoVariant == constantsObj.EXP_VAR_2) {
                 storeLayer.redraw();
                 }*/
                adsObj.showVideoAd(false);
                adsObj.setNotRewardedVideo(false);
            }
            else {
                trackObj.trackCounter(constantsObj.TRACK_AD_TRACKING, constantsObj.TRACK_W2E, constantsObj.TRACK_RETRY, curScreen, "", "mopub", "", "", "");
                // utilObj.showMessage("No Video Available. Please watch after some time");
            }

        } else {
            var timeRemaining = coolDownPeriod - (utilObj.getCurrentTimestamp() - firstVideoShownTimeStamp);
            //utilObj.showMessageAtTop("Next video in " + utilObj.formatTime(timeRemaining));
            if (timeRemaining > 0) {
                utilObj.showMessageAtTop("Next video in " + utilObj.formatTime(timeRemaining));
                trackObj.trackCounter(constantsObj.TRACK_AD_MEDIATION, constantsObj.TRACK_W2E, "cooldown", curScreen, "", "", "", "", "");
                machineLearningDataObj.setVideoTriesCooldown();
            }
        }
    },
    callbackfnForVideo: function () {
        gameObj.setLastVideoSeenTimeStamp(utilObj.getCurrentTimestamp());
        adsObj.setNotRewardedVideo(false);
    },
});


