var LinearLevelProgression = cc.Layer.extend({
    screen: null,
    scrollView: null,
    countryNodes: [],
    levelNodes: {},
    countryNodesMap: {},
    countryNodesAddedPos: {},
    curCountryNode: null,
    curPuzzleNo: null,
    scrollViewPos: null,
    lastScrollViewPos: null,
    bgScaling: null,
    bg: null,
    curCountryInfo: null,
    allCountriesInfo: null,
    nextBtnXPosIndex: null,
    nextBtnYPosIndex: null,
    numCountries: 0,
    leaderBoardData: null,
    currentLevel: 0,
    keys: null,
    shouldFtueBeShown: false,
    ftueShownNum: 0,
    curLevelHeight: null,
    shouldAddButton: 1,
    redirectBtn: null,
    redirectImg: null,
    jumpToPercent: null,
    levelNodePos: {},
    curLevelNum: null,
    isLevelNodeAdded: {},
    totalNodesNumBelow: null,
    totalNodesNumAbove: null,
    isEocUser: false,
    notifCircle1: null,
    notifCircle2: null,
    numQuestsLbl1: null,
    numQuestsLbl2: null,
    totalPuzzles: 0,
    eocImgXPos: null,
    eocImgYPos: null,
    indexArr: [],
    countryNameLbl: null,
    countryLastNodeIndex: [],
    bezelShift: 0,
    dailyQuestToaster: null,
    commonToasterAnimRunning: 0,
    dailyQuestCoin: null,
    dailyQuestRewardLbl: null,
    btnSpriteScaling: 0.67,
    headerCoins: null,
    coinsLbl: null,
    transBgBtn: null,
    transVisBtn: null,
    progressArr: [],
    countryNameLblYPos: null,
    minimapNotifCircle: null,
    minimapNewTag: null,
    minimapImg: null,
    calendarImg: null,
    dailySpellingBeeButtonArr: [],
    eventButtonArr: [],
    ftueArr1: [],
    eventTimerLbl: null,
    transBg: null,
    pathsPosMap: {},
    isPathNodeAdded: {},
    totalPathsNumAbove: null,
    totalPathsNumBelow: null,
    curPathNum: null,
    digraphFtueElements: [],
    piggyBankFtueElements: [],
    piggyBankButtonArr: [],
    yPosForRedirectBtn: 0,
    profileImage: null,
    dailyPuzzleFtueBg: null,
    dailyPuzzleFtueBtn: null,
    activeNodeForFtue: null,
    activeFontForFtue: null,
    isEndOfContentPopupShown: false,
    cashLbl: null,
    trackVariabes: null,
    jewelIconTop1: null,
    jewelLabelTop1: null,
    jewelIconBottom1: null,
    jewelLabelBottom1: null,
    jewelIconBottom2: null,
    jewelLabelBottom2: null,
    timerLabl : null,
    dailyPuzzleButtonElements: [],
    timerfunc : null,

    hide: function () {

        linearLevelProgression.removeAllChildren();
        linearLevelProgression.setVisible(false);
    },

    redraw: function () {
        linearLevelProgression.hide();
        linearLevelProgression.show();
    },

    show: function () {

        // try loading jsons if not loaded for puzzles
        linearLevelObj.loadDataForCurrentCountry();

        linearLevelProgression.screen = constantsObj.SCREEN_LINEAR_PROGRESSION;
        var screenName = utilObj.getScreenName(linearLevelProgression.screen);
        // utilObj.hideBannerAd(utilObj.getScreenName(constantsObj.SCREEN_LINEAR_PROGRESSION));

        var spriteArr = [];
        var labelArr = [];
        var zOrder = constantsObj.SPRITE_Z_ORDER;
        utilObj.updateScreenBegin(linearLevelProgression.screen);

        linearLevelProgression.bgScaling = 1.25 * aspectRatio / constantsObj.ASPECT_NORMAL;
        if (aspectRatio < 1.78) {
            var scale = 1.78 / aspectRatio;
            linearLevelProgression.bgScaling = scale * 1.25;
        }


        // TOP BANNER
        var xPos = centerXPos;
        var yPos = constantsObj.DESIGN_HEIGHT;
        var heightOfBanner = 226;
        if (utilObj.getIsLikeIphoneX()) {
            heightOfBanner += topBarOffset;
        }
        var topBanner = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, yPos + topBarOffset + 15, 0.5, 1, canvasWidth, heightOfBanner, spriteArr, linearLevelProgression, zOrder + 1, constantsObj.SPRITE_MISC);
        utilObj.setColor(topBanner, constantsObj.COLOR_BLACK);
        utilObj.setOpacity(topBanner, constantsObj.OPACITY_70);

        var bannerArrow = utilObj.getSprite(constantsObj.BANNER_ARROW, centerXPos, yPos + 15 - 113, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1, spriteArr, linearLevelProgression, zOrder + 1, constantsObj.SPRITE_MISC);

        // Top Bar 
        linearLevelProgression.addTopBar(xPos, yPos + 15, spriteArr, labelArr);


        // Bottom Bar
        if (false) {
            var heightOfBottomNav = 175;
            var bottomNavBg = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, 0, 0.5, 0, canvasWidth, heightOfBottomNav + constantsObj.BOTTOM_BAR_OFFSET, spriteArr, linearLevelProgression, zOrder + 1, constantsObj.SPRITE_MISC);//, null, homeLayer, zOrder + 1, constantsObj.SPRITE_MISC);
            utilObj.setColor(bottomNavBg, constantsObj.COLOR_BLACK);
            utilObj.setOpacity(bottomNavBg, constantsObj.OPACITY_50);
            linearLevelProgression.addBottomBar(spriteArr, labelArr);
        }


        // LLp Layer (Nodes and Curve)
        var linearShift = 0;
        linearLevelProgression.bezelShift = 0;
        if (utilObj.isBezelScreen()) {
            linearShift = constantsObj.BEZEL_SAFE_AREA;
            if (utilObj.isIos()) {
                linearLevelProgression.bezelShift = 50;
            }
        }


        linearLevelProgression.currentLevel = 0;

        // Starting of with the main logic of llp
        linearLevelProgression.shouldAddButton = 1;
        linearLevelProgression.isLevelNodeAdded = {};
        linearLevelProgression.isPathNodeAdded = {};
        linearLevelProgression.countryLastNodeIndex = [];

        // var levelGroups = linearLevelObj.getLevelGroups();
        // if (levelGroups != null) {
        //     loggerObj.debugLog("Check the lenght of groupsssss", levelGroups[levelGroups.length - 1]["le"]);
        //     linearLevelProgression.numCountries = levelGroups[levelGroups.length - 1]["le"];
        // }

        linearLevelProgression.numCountries = linearLevelObj.getTotalNumberOfCountries();
        var totalCountries = linearLevelProgression.numCountries;

        linearLevelProgression.totalPuzzles = linearLevelObj.totalDtc2Puzzles();
        linearLevelProgression.allCountriesInfo = linearLevelObj.getLevels();

        var curCountry = linearLevelObj.getCurLevel();//returns the current country level which user is in

        linearLevelProgression.isEocUser = false; //Ask about Eoc
        if (linearLevelObj.getCurLevel() > totalCountries) {
            linearLevelProgression.isEocUser = true;
            curCountry = totalCountries;
        }


        // THIS IS FOR PUZZLES FOR DTC2(TESTING)
        // var puzzleInfo = linearLevelObj.getDtcTwoPuzzleInfo();

        linearLevelProgression.curCountryInfo = linearLevelProgression.allCountriesInfo[curCountry - 1];
        // loggerObj.debugLog("Current Country Info " , linearLevelProgression.curCountryInfo)

        var curCountryInfo = linearLevelProgression.curCountryInfo;
        var lastPuzIndex = curCountryInfo["co"];
        var puzStartIndex = lastPuzIndex - curCountryInfo["pc"];

        var curPuzzleIndex = 0;
        var puzState = constantsObj.STATE_PUZ_COMPLETED;


        for (var i = puzStartIndex, puzIndex = 1; i < lastPuzIndex; i++, puzIndex++) {
            puzState = linearLevelObj.getPuzState(i);
            if (puzState == constantsObj.STATE_PUZ_OPEN) {
                curPuzzleIndex = puzIndex;
            }
        }

        if (linearLevelProgression.isEocUser) {
            curPuzzleIndex = linearLevelProgression.curCountryInfo["pc"];
        }

        var curCountryIndex = curCountryInfo["i"];
        linearLevelProgression.curPuzzleNo = curPuzzleIndex;
        // loggerObj.debugLog("Puzzle index curr" , curPuzzleIndex);
        //  linearLevelProgression.loadFriends(); // Not calling this function (Pending)

        linearLevelProgression.curCountryNode = curCountryIndex - 1;

        /**
         * Below is for TRACKING
         */
        var stateofDailyPuzzle = linearLevelProgression.getStateOfDailyPuzzle();
        linearLevelProgression.trackVariabes = "";
        linearLevelProgression.trackVariabes += curCountry + "_";
        linearLevelProgression.trackVariabes += (linearLevelObj.getDtc2PuzzleCompleted() + 1 ) + "_";
        if (stateofDailyPuzzle == constantsObj.STATE_LOCKED) {
            linearLevelProgression.trackVariabes += 0;
        } else {
            linearLevelProgression.trackVariabes += 1;
        }


        // var numPaths = 1045;
        var numPaths = 698;
        var pathHeight = 2048;
        var scaledPathHeight = pathHeight * 0.9;
        var yShift = 45;
        var mapHeight = (scaledPathHeight - yShift) * numPaths;
        var scrollViewHeight = mapHeight + 400;

        linearLevelProgression.scrollView = new ccui.ScrollView();
        linearLevelProgression.scrollView.setDirection(ccui.ScrollView.DIR_VERTICAL);
        linearLevelProgression.scrollView.setTouchEnabled(true);
        linearLevelProgression.scrollView.setBounceEnabled(true);
        linearLevelProgression.scrollView.setScrollBarEnabled(false);
        linearLevelProgression.scrollView.setInertiaScrollEnabled(true);
        linearLevelProgression.scrollView.setPosition(centerXPos, constantsObj.DESIGN_HEIGHT + topBarOffset);
        linearLevelProgression.scrollView.setContentSize(cc.size(canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset));
        linearLevelProgression.scrollView.setInnerContainerSize(cc.size(canvasWidth, scrollViewHeight));
        linearLevelProgression.scrollView.setAnchorPoint(cc.p(0.5, 1.0));
        linearLevelProgression.scrollViewPos = 0;

        linearLevelProgression.scrollView.addEventListener(function (scope, eventType) {

            // loggerObj.debugLog("IN CALL BACK FUNCTION")
            linearLevelProgression.lastScrollViewPos = linearLevelProgression.scrollViewPos;
            linearLevelProgression.scrollViewPos = linearLevelProgression.scrollView.getInnerContainerPosition();
            var scrollViewYPos = Math.abs(linearLevelProgression.scrollViewPos.y);
            var lastScrollViewYPos = Math.abs(linearLevelProgression.lastScrollViewPos.y);

            // Bg's change
            if ((scrollViewYPos - lastScrollViewYPos >= 0) && linearLevelProgression.curCountryNode + 1 < totalCountries && scrollViewYPos + centerYPos >= linearLevelProgression.countryNodesAddedPos[linearLevelProgression.curCountryNode + 1]) {
                linearLevelProgression.curCountryNode++;
                linearLevelProgression.changeBg(linearLevelProgression.curCountryNode);
                // trackObj.trackCounter(constantsObj.TRACK_MAP,  linearLevelProgression.curCountryInfo["i"] - 1, gameObj.getTrackingPuzId(), constantsObj.TRACK_SCROLL, constantsObj.TRACK_UP,  linearLevelProgression.curCountryNode, gameObj.getTrackingPuzzleInfo(), 1, "");
            } else if ((scrollViewYPos - lastScrollViewYPos < 0) && linearLevelProgression.curCountryNode - 1 >= 0 && scrollViewYPos + centerYPos <= linearLevelProgression.countryNodesAddedPos[linearLevelProgression.curCountryNode]) {
                linearLevelProgression.curCountryNode--;
                linearLevelProgression.changeBg(linearLevelProgression.curCountryNode);
                // trackObj.trackCounter(constantsObj.TRACK_MAP,  linearLevelProgression.curCountryInfo["i"] - 1, gameObj.getTrackingPuzId(), constantsObj.TRACK_SCROLL, constantsObj.TRACK_DOWN,  linearLevelProgression.curCountryNode, gameObj.getTrackingPuzzleInfo(), 1, "");
            }

            // Revised Logic for adding nodes
            if (linearLevelProgression.levelNodePos != null) {

                if (scrollViewYPos - lastScrollViewYPos >= 0 && linearLevelProgression.curLevelNum + 1 <= linearLevelProgression.totalPuzzles && scrollViewYPos + centerYPos >= linearLevelProgression.levelNodePos[linearLevelProgression.curLevelNum + 1]["y"]) {
                    linearLevelProgression.curLevelNum += 1;
                    if (linearLevelProgression.curLevelNum + linearLevelProgression.totalNodesNumAbove <= linearLevelProgression.totalPuzzles) {
                        linearLevelProgression.addLevelNodes(linearLevelProgression.curLevelNum + linearLevelProgression.totalNodesNumAbove);
                        if (linearLevelProgression.curLevelNum + linearLevelProgression.totalNodesNumAbove == linearLevelProgression.totalPuzzles) {
                            linearLevelProgression.addEocImg();
                        }
                    }
                } else if (scrollViewYPos - lastScrollViewYPos < 0 && scrollViewYPos + centerYPos <= linearLevelProgression.levelNodePos[linearLevelProgression.curLevelNum]["y"]) {
                    linearLevelProgression.curLevelNum -= 1;
                    if (linearLevelProgression.curLevelNum - linearLevelProgression.totalNodesNumBelow >= 1) {
                        linearLevelProgression.addLevelNodes(linearLevelProgression.curLevelNum - linearLevelProgression.totalNodesNumBelow);
                    }
                }
            }

            // // Logic for adding path to LLP
            if (linearLevelProgression.pathsPosMap != null && linearLevelProgression.curPathNum != null) {
                if (scrollViewYPos - lastScrollViewYPos >= 0 && linearLevelProgression.curPathNum + 1 < numPaths && scrollViewYPos + centerYPos >= linearLevelProgression.pathsPosMap[linearLevelProgression.curPathNum + 1]["y"]) {
                    linearLevelProgression.curPathNum += 1;
                    if (linearLevelProgression.curPathNum + linearLevelProgression.totalPathsNumAbove < numPaths) {
                        linearLevelProgression.addPathNodes(linearLevelProgression.curPathNum + linearLevelProgression.totalPathsNumAbove);
                    }
                } else if (scrollViewYPos - lastScrollViewYPos < 0 && linearLevelProgression.curPathNum - 1 >= 0 && scrollViewYPos + centerYPos <= linearLevelProgression.pathsPosMap[linearLevelProgression.curPathNum]["y"]) {
                    linearLevelProgression.curPathNum -= 1;
                    if (linearLevelProgression.curPathNum - linearLevelProgression.totalPathsNumBelow >= 0) {
                        linearLevelProgression.addPathNodes(linearLevelProgression.curPathNum - linearLevelProgression.totalPathsNumBelow);
                    }
                }
            }

            // Redirect Button Logic
            var curLevelPos = 0;
            if (linearLevelProgression.levelNodes != null && linearLevelProgression.curCountryInfo != null && linearLevelProgression.curPuzzleNo != null &&
                linearLevelProgression.levelNodes[linearLevelProgression.curCountryInfo["i"] - 1][linearLevelProgression.curPuzzleNo - 1] != undefined && linearLevelProgression.curCountryInfo["i"] - 1 >= 0 &&
                linearLevelProgression.curPuzzleNo - 1 >= 0) {
                curLevelPos = linearLevelProgression.levelNodes[linearLevelProgression.curCountryInfo["i"] - 1][linearLevelProgression.curPuzzleNo - 1]["y"];
            }
            if (linearLevelProgression.levelNodes != null && linearLevelProgression.levelNodes != undefined && linearLevelProgression.shouldAddButton == 1) {
                if (scrollViewYPos + constantsObj.DESIGN_HEIGHT < curLevelPos) {
                    linearLevelProgression.addRedirectButton("up");
                } else if (scrollViewYPos > curLevelPos) {
                    linearLevelProgression.addRedirectButton("down");
                }
            }
            if (scrollViewYPos + constantsObj.DESIGN_HEIGHT > curLevelPos && scrollViewYPos < curLevelPos) {
                linearLevelProgression.shouldAddButton = 1;
                linearLevelProgression.hideRedirectBtn(linearLevelProgression, linearLevelProgression.redirectBtn);
            }
        });

        linearLevelProgression.calculateLevelNodesAndCountryNodesPos(totalCountries);
        linearLevelProgression.calculatePathsPosition(400, linearShift, numPaths);

        var bgScaling = 1.25 * aspectRatio / constantsObj.ASPECT_NORMAL;
        if (aspectRatio < 1.78) {
            var scale = 1.78 / aspectRatio;
            bgScaling = scale * 1.25;
        }
        linearLevelProgression.countryNameLblYPos = 310 + linearShift - linearLevelProgression.bezelShift + 100;

        if (linearLevelProgression.curCountryInfo["i"] <= totalCountries) {
            linearLevelProgression.bg = utilObj.getSprite(linearLevelObj.getBackGroundPath(linearLevelProgression.curCountryInfo["cc"]), centerXPos, centerYPos, 0.5, 0.5, bgScaling, spriteArr, linearLevelProgression, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_LOCAL);
            //BELOW CODE WAS for THE PROGRESS BAR AND THE Number of levels completed
            // linearLevelProgression.countryNameLbl = utilObj.getBMFontLabel( linearLevelProgression.allCountriesInfo[ linearLevelProgression.curCountryInfo["i"] - 1]["c"].toUpperCase(), constantsObj.FONT_HELVETICA_MEDIUM_60, constantsObj.COLOR_BLACK,
            //     constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xLeftPos + 40, 310 + linearShift -  linearLevelProgression.bezelShift + 100, 0, 0.5, labelArr,  linearLevelProgression, constantsObj.UI_Z_ORDER);

            // var totalPuzzles =  linearLevelProgression.curCountryInfo["pc"];
            // var puzzlesCompleted =  linearLevelProgression.curPuzzleNo - 1; //beacause currPuzzleNo = currPuzzleIndex which need to be solved hence -1 so that we can get puzzles completed till that point
            // if ( linearLevelProgression.isEocUser) {
            //     puzzlesCompleted += 1;
            // }
            // var xDiff = 180;
            // var progressWidth = (puzzlesCompleted / totalPuzzles) * 2 * xDiff;
            // var progressYPos = 310 + linearShift -  linearLevelProgression.bezelShift;
            // linearLevelProgression.progressArr.push(utilObj.getScale9Sprite(constantsObj.tile_white, xLeftPos + 80, progressYPos, 0, 0.5, 2 * xDiff, 65, spriteArr,  linearLevelProgression, constantsObj.UI_Z_ORDER, constantsObj.SPRITE_LOCAL));
            // linearLevelProgression.progressArr.push(utilObj.getSprite(constantsObj.circle_bg, xLeftPos + 80, progressYPos, 0.5, 0.5, 0.5, spriteArr,  linearLevelProgression, constantsObj.UI_Z_ORDER, constantsObj.SPRITE_LOCAL));
            // linearLevelProgression.progressArr.push(utilObj.getSprite(linearLevelObj.getFlagsMonumentsInfo( linearLevelProgression.curCountryInfo["cc"])["fV1"], xLeftPos + 80, progressYPos, 0.5, 0.5, 0.45 * constantsObj.SPRITE_SCALING_FACTOR, spriteArr,  linearLevelProgression, constantsObj.UI_Z_ORDER, constantsObj.SPRITE_MISC));
            // var completedProgressBar = utilObj.getScale9Sprite(constantsObj.tile_white, xLeftPos + 80, progressYPos, 0, 0.5, progressWidth, 57, spriteArr,  linearLevelProgression, constantsObj.UI_Z_ORDER, constantsObj.SPRITE_MISC);
            // utilObj.setColor(completedProgressBar, constantsObj.COLOR_OUTRO_PROGRESS_BAR);
            // linearLevelProgression.progressArr.push(completedProgressBar);
            // linearLevelProgression.progressArr.push(utilObj.getBMFontLabel(puzzlesCompleted + "/" + totalPuzzles, constantsObj.FONT_HELVETICA_MEDIUM_60, constantsObj.COLOR_BLACK,
            //     constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xLeftPos + 80 + xDiff, progressYPos, 0.5, 0.5, labelArr,  linearLevelProgression, constantsObj.UI_Z_ORDER));
            // linearLevelProgression.progressArr.push(utilObj.getSprite(constantsObj.gift_new, xLeftPos + 80 + (2 * xDiff), progressYPos + 8, 0.5, 0.5, 1.2 * constantsObj.SPRITE_SCALING_FACTOR, spriteArr,  linearLevelProgression, constantsObj.UI_Z_ORDER, constantsObj.SPRITE_MISC));

        } else {
            linearLevelProgression.bg = utilObj.getSprite(constantsObj.COUNTRY_GENRIC_BG, centerXPos, centerYPos, 0.5, 0.5, bgScaling, spriteArr, linearLevelProgression, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_LOCAL);
        }

        for (var i = 1; i < linearLevelProgression.countryLastNodeIndex.length; i++) {
            linearLevelProgression.countryLastNodeIndex[i] = linearLevelProgression.countryLastNodeIndex[i] + linearLevelProgression.countryLastNodeIndex[i - 1];
        }

        linearLevelProgression.curLevelNum = linearLevelProgression.curPuzzleNo + linearLevelProgression.curCountryInfo["co"] - linearLevelProgression.curCountryInfo["pc"];
        // loggerObj.debugLog("Curr level no " , linearLevelProgression.curLevelNum)

        // // JUMP TO CURRENT COUNTRY CODE 
        var jumpToCountry = 0;
        if (!(curCountryIndex == 1 && curPuzzleIndex <= 2)) {
            if (linearLevelProgression.levelNodes != null && linearLevelProgression.levelNodes != undefined) {

                jumpToCountry = scrollViewHeight - linearLevelProgression.levelNodes[curCountryIndex - 1][curPuzzleIndex - 1]["y"] - centerYPos;
                linearLevelProgression.jumpToPercent = ((jumpToCountry / scrollViewHeight) * 100);
                linearLevelProgression.jumpToCurrentCountry(linearLevelProgression.jumpToPercent, true);
                var tempPos1 = linearLevelProgression.levelNodes[curCountryIndex - 1][curPuzzleIndex - 1]["y"] - Math.abs(linearLevelProgression.scrollView.getInnerContainerPosition().y);
                var tempPos2 = centerYPos - tempPos1;
                var jump = scrollViewHeight - linearLevelProgression.levelNodes[curCountryIndex - 1][curPuzzleIndex - 1]["y"] - centerYPos + tempPos2;
                // if (linearLevelProgression.shouldFtueBeShown && linearLevelProgression.ftueShownNum == ftueObj.FTUE_LINEAR_PROGRESSION && gameObj.getPuzCompleted() == 5) {
                //     jump += 500 + linearShift;
                // } 
                // else if (curCountryIndex == totalCountries && curPuzzleIndex >= curCountryInfo["pc"] - 1) {
                //     jump = 0;
                // }
                linearLevelProgression.jumpToPercent = ((jump / scrollViewHeight) * 100);
                linearLevelProgression.jumpToCurrentCountry(linearLevelProgression.jumpToPercent, true);
            }
        } else {
            linearLevelProgression.jumpToPercent = 100;
            linearLevelProgression.jumpToCurrentCountry(linearLevelProgression.jumpToPercent, true);
        }

        // Adding paths for current country, (+/- 1).
        var totalNumCountries = constantsObj.TOTAL_NUM_COUNTRIES;
        var numPathsToAddBelow, numPathsToAddAbove;
        var startPathNum, endPathNum, countryIndex;
        if (curCountryInfo["i"] - 1 == 0) { // Adding paths till 3 countries up
            numPathsToAddBelow = 0;
            numPathsToAddAbove = 0;
            for (var index = 0; index <= 2; index++) {
                numPathsToAddAbove += linearLevelProgression.allCountriesInfo[index]["pc"] / 5;
            }
            startPathNum = 0;
            endPathNum = numPathsToAddAbove - 1;
            countryIndex = 0;
        } else if (curCountryInfo["i"] - 1 == totalNumCountries - 1) {  // Adding paths till 3 countries down
            numPathsToAddAbove = 0;
            numPathsToAddBelow = 0;
            for (var index = totalNumCountries - 1; index >= totalNumCountries - 3; index--) {
                numPathsToAddBelow += linearLevelProgression.allCountriesInfo[index]["pc"] / 5;
            }
            startPathNum = numPaths - numPathsToAddBelow - 1;
            endPathNum = numPaths - 1;
            countryIndex = constantsObj.TOTAL_NUM_COUNTRIES - 1;
        } else {    // Adding paths till (+/- 1) countries
            startPathNum = ( linearLevelProgression.allCountriesInfo[curCountryInfo["i"] - 2]["co"] - linearLevelProgression.allCountriesInfo[curCountryInfo["i"] - 2]["pc"]) / 5;
            endPathNum = ( linearLevelProgression.allCountriesInfo[curCountryInfo["i"]]["co"] / 5) - 1;
            countryIndex = linearLevelProgression.allCountriesInfo[curCountryInfo["i"] - 2]["i"];
            startPathNum += Math.floor(countryIndex / 5);
            endPathNum += Math.floor(countryIndex / 5);
        }
        linearLevelProgression.curPathNum = Math.ceil(linearLevelProgression.curLevelNum / 5 - 1) + Math.floor(countryIndex / 5);
        linearLevelProgression.totalPathsNumAbove = endPathNum - linearLevelProgression.curPathNum;
        linearLevelProgression.totalPathsNumBelow = linearLevelProgression.curPathNum - startPathNum;


        for (var index = startPathNum; index <= endPathNum; index++) {
            linearLevelProgression.addPathNodes(index);
        }

        // Adding only 16 nodes on screen load for current country.
        var totalPuzzles = linearLevelProgression.totalPuzzles;
        var numNodesToAdd = 16;
        if (curCountryInfo["i"] - 1 == 0) {
            linearLevelProgression.totalNodesNumBelow = linearLevelProgression.curPuzzleNo - 1;
            linearLevelProgression.totalNodesNumAbove = numNodesToAdd - linearLevelProgression.curPuzzleNo;
        } else if (curCountryInfo["i"] - 1 == totalCountries - 1) {
            linearLevelProgression.totalNodesNumAbove = Math.min(totalPuzzles - linearLevelProgression.curLevelNum, numNodesToAdd / 2);
            linearLevelProgression.totalNodesNumBelow = numNodesToAdd - linearLevelProgression.totalNodesNumAbove;
        } else {
            linearLevelProgression.totalNodesNumBelow = numNodesToAdd / 2;
            linearLevelProgression.totalNodesNumAbove = numNodesToAdd / 2;
        }

        var startLevelNum = linearLevelProgression.curLevelNum - linearLevelProgression.totalNodesNumBelow;
        for (var i = 0; i <= numNodesToAdd; i++) {
            linearLevelProgression.addLevelNodes(startLevelNum);
            if (startLevelNum == totalPuzzles) {
                linearLevelProgression.addEocImg();
            }
            startLevelNum++;
        }

        linearLevelProgression.scrollViewPos = linearLevelProgression.countryNodesAddedPos[linearLevelProgression.curCountryNode];
        linearLevelProgression.addChild(linearLevelProgression.scrollView, zOrder + 1);


        // Free Video Button 
        var yPos = 250;
        var childArr = [];
        // var freeVideoBtn = utilObj.getButton(205, 205, 0.5, 0.5,
        //     xLeftPos + 180, yPos + constantsObj.BOTTOM_BAR_OFFSET + 150, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
        //         obj: 'linearLevelProgression',
        //         fn: 'freeVideoFunc',
        //         screen: linearLevelProgression.screen,
        //         params: {
        //             "sound": constantsObj.trans_button,
        //             "sound_on": true,
        //         },
        //         track: {
        //             k: constantsObj.TRACK_DIALOG,
        //             p: gameObj.getCurPuzzleTracking(),
        //             c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
        //             o: constantsObj.TRACK_MAP_SCREEN,
        //             f: constantsObj.TRACK_MAP_W2E,
        //             g: linearLevelProgression.trackVariabes,
        //             s: gameObj.getPuzzleSpeciesTracking(),
        //             co: 1,
        //             oppId: ""
        //         },
        //         child: childArr,
        //         feedBackType: constantsObj.ZOOMIN_FEEDBACK
        //     }, false, ccui.Widget.PLIST_TEXTURE, 1);
        // linearLevelProgression.addChild(freeVideoBtn, zOrder + 2);

        // var newX = freeVideoBtn.getContentSize().width / 2;
        // var newY = freeVideoBtn.getContentSize().height / 2;
        // var freeVideoBtnBg = utilObj.getSprite(constantsObj.icon_holder_circle, newX, newY, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 / 1.42, spriteArr, freeVideoBtn, zOrder + 1, constantsObj.SPRITE_MISC);
        // var videoIcon = utilObj.getSprite(constantsObj.w2eIcon, newX, newY + 50, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_79, spriteArr, freeVideoBtn, zOrder + 1, constantsObj.SPRITE_MISC);
        // var freeText = utilObj.getBMFontLabel("FREE", constantsObj.FONT_ROBOTO_REGULAR_50, constantsObj.COLOR_WHITE,
        //     constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), newX - 30, newY - 30, 0.5, 0.5, labelArr, freeVideoBtn, zOrder + 1);
        // var coin = utilObj.getSprite(constantsObj.coin_png_3, newX + 60, newY - 30, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.3, spriteArr, freeVideoBtn, zOrder + 1, constantsObj.SPRITE_MISC);

        // Addind Daily Puzzle Icon After Checking the condition
        linearLevelProgression.yPosForRedirectBtn = yPos;
        linearLevelProgression.yPosForRedirectBtn = yPos + 350;


        var btnXPos = xRightPos - 180;
        var btnYPos = yPos + constantsObj.BOTTOM_BAR_OFFSET + 150;
        var childArr = [];
        var dpIconPos = {x: btnXPos, y: btnYPos - 20};

        var newDailyPuzzleIcon = utilObj.getSprite(constantsObj.new_dp_icon, dpIconPos.x, dpIconPos.y, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1, spriteArr, linearLevelProgression, zOrder + 1, constantsObj.SPRITE_MISC);
        var componentDp = utilObj.getButtonDimensions(345, 144, 140, 70);
        var newDpTxtBg = utilObj.getScale9Sprite(constantsObj.round_white_toggleBtn, dpIconPos.x , dpIconPos.y, 0.5, 0.5, componentDp.width, componentDp.height, spriteArr, linearLevelProgression, zOrder + 1, constantsObj.SPRITE_MISC);
        utilObj.setScale(newDpTxtBg, componentDp.scale * utilObj.getScale(newDpTxtBg) * 1.05);
        utilObj.setOffsetByAnchor(newDpTxtBg, 0, -105);
        var newDpTxt = utilObj.getBMFontLabel(" Daily \nPuzzle", constantsObj.FONT_HELVETICA_MEDIUM_60, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), dpIconPos.x, dpIconPos.y, 0.5, 0.5, labelArr, linearLevelProgression, zOrder + 1);
        utilObj.setScale(newDpTxt, componentDp.scale * utilObj.getScale(newDpTxt) * 1.05);
        utilObj.setOffsetByAnchor(newDpTxt, 0, -105);

        childArr = [newDailyPuzzleIcon, newDpTxtBg, newDpTxt];

        linearLevelProgression.dailyPuzzleButtonElements = [newDpTxtBg, newDpTxt];
        linearLevelProgression.dailyPuzzleFtueBg = newDailyPuzzleIcon;

        var dpTracking = constantsObj.TRACK_DP_UNLOCKED;
        if (stateofDailyPuzzle == constantsObj.STATE_LOCKED) {
            utilObj.setOpacity(newDailyPuzzleIcon, constantsObj.OPACITY_60);
            var lockIcon = utilObj.getSprite(constantsObj.new_dp_lock , dpIconPos.x , dpIconPos.y, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 / 2.6, spriteArr, linearLevelProgression, zOrder + 1, constantsObj.SPRITE_MISC);
            var lockIconDimensions = utilObj.getSpriteDimensions(lockIcon);
            utilObj.setOffsetByAnchor(lockIcon, 0, 8 - lockIconDimensions.height / 2);
            utilObj.setOpacity(lockIcon, constantsObj.OPACITY_100);
            utilObj.setColor(newDpTxtBg, constantsObj.COLOR_COLLECTING_BG);
            childArr.push(lockIcon);
            linearLevelProgression.dailyPuzzleButtonElements.push(lockIcon);
            dpTracking = constantsObj.TRACK_DP_LOCKED;

            // if (linearLevelProgression.toShowCountryCompleteAnimation) {
            //     utilObj.setVisible(lockIcon, false);
            // }
        } else {
            
            var puzzleId = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
            puzzleId = stringsObj.mini_prefix + puzzleId.substr(2, puzzleId.length);
            var ifPuzzleCompleted = gameObj.getPuzzleCompleted(puzzleId);
            if (ifPuzzleCompleted) {
                // Timer ui will come here
                var timerDim = utilObj.getButtonDimensions(103.18, 32.16, 136, 38);
                var timerBg = utilObj.getScale9Sprite(constantsObj.new_timer_bg, dpIconPos.x , dpIconPos.y, 0.5, 0.5, timerDim.width, timerDim.height, spriteArr, linearLevelProgression, zOrder + 1, constantsObj.SPRITE_MISC);
                utilObj.setScale(timerBg, timerDim.scale * utilObj.getScale(timerBg) * 1.1);
                utilObj.setOffsetByAnchor(timerBg, 0, -165);
                utilObj.setColor(timerBg,constantsObj.COLOR_BLACK);
                utilObj.setOpacity(timerBg,constantsObj.OPACITY_60);
                childArr.push(timerBg);
        
                var timerBgOut = utilObj.getScale9Sprite(constantsObj.new_timer_bg_outline, dpIconPos.x , dpIconPos.y, 0.5, 0.5, timerDim.width, timerDim.height, spriteArr, linearLevelProgression, zOrder + 1, constantsObj.SPRITE_MISC);
                utilObj.setScale(timerBgOut, timerDim.scale * utilObj.getScale(timerBgOut) * 1.1);
                utilObj.setOffsetByAnchor(timerBgOut, 0, -165);
                childArr.push(timerBgOut);

                /***
                 * Next day details
                 */
                var tomorrow = new Date(); 
                tomorrow.setDate(new Date().getDate()+1);
                linearLevelProgression.getTimer(tomorrow);
                linearLevelProgression.timerLabl = utilObj.getBMFontLabel("Unlocks :", constantsObj.FONT_HELVETICA_MEDIUM_25, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), dpIconPos.x, dpIconPos.y, 0.5, 0.5, labelArr, linearLevelProgression, zOrder + 2);
                utilObj.setOffsetByAnchor(linearLevelProgression.timerLabl, 0, -163);
                childArr.push(linearLevelProgression.timerLabl);
            }
        }

       

        

        var openPuzzleBtn = utilObj.getButton(205, 205, 0.5, 0.5,
            btnXPos, btnYPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
            obj: 'linearLevelProgression',
            fn: 'openDailyPuzzle',
            screen: linearLevelProgression.screen,
            params: {
                "sound": constantsObj.trans_button,
                "sound_on": true,
            },
            track: {
                k: constantsObj.TRACK_DIALOG,
                p: gameObj.getCurPuzzleTracking(),
                c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                o: constantsObj.TRACK_MAP_SCREEN,
                f: dpTracking,
                g: linearLevelProgression.trackVariabes,
                s: gameObj.getPuzzleSpeciesTracking(),
                co: 1,
                oppId: ""
            },
            child: childArr,
            feedBackType: constantsObj.ZOOMIN_FEEDBACK
        }, false, ccui.Widget.PLIST_TEXTURE, 1);
        linearLevelProgression.addChild(openPuzzleBtn, zOrder + 2);

        linearLevelProgression.dailyPuzzleFtueBtn = openPuzzleBtn;

        /****    OLD BUTTON FLOW
        var dailyPuzzleBtnBg = utilObj.getSprite(constantsObj.icon_holder_circle, xRightPos - 180, yPos + constantsObj.BOTTOM_BAR_OFFSET + 150, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 / 1.42, spriteArr, linearLevelProgression, zOrder + 1, constantsObj.SPRITE_MISC);
        utilObj.setCascadeOpacityEnabled(dailyPuzzleBtnBg, true);

        utilObj.getSprite(constantsObj.DAILY_CALLENDER, 120, 145, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_85 * 0.9, spriteArr, dailyPuzzleBtnBg, zOrder + 1, constantsObj.SPRITE_MISC);

        var today = new Date();
        var currDate = today.getDate();
        var currMonth = linearLevelObj.getCurrentMonth(today.getMonth());
        if (currDate < 10) {
            currDate = "0" + currDate;
        }
        var currMonthText = utilObj.getBMFontLabel(currMonth, constantsObj.FONT_HELVETICA_MEDIUM_25, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), 120, 172.5, 0.5, 0.5, labelArr, dailyPuzzleBtnBg, zOrder + 1);

        var currDateText = utilObj.getBMFontLabel(currDate, constantsObj.FONT_HELVETICA_MEDIUM_40, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), 120, 125, 0.5, 0.5, labelArr, dailyPuzzleBtnBg, zOrder + 1);

        var childArr = [dailyPuzzleBtnBg];

        // gets the state of the daily puzzle button
        stateofDailyPuzzle = linearLevelProgression.getStateOfDailyPuzzle();
        var dpTracking = constantsObj.TRACK_DP_UNLOCKED;
        if (stateofDailyPuzzle == constantsObj.STATE_LOCKED) {
            utilObj.setOpacity(dailyPuzzleBtnBg, constantsObj.OPACITY_60);
            var lockIcon = utilObj.getSprite(constantsObj.lock_quest, xRightPos - 100, yPos + constantsObj.BOTTOM_BAR_OFFSET + 80, 0.5, 0.5, constantsObj.SCALE_SPRITE_15 * 0.85, spriteArr, linearLevelProgression, zOrder + 1, constantsObj.SPRITE_MISC);
            utilObj.setOpacity(lockIcon, constantsObj.OPACITY_100);
            childArr.push(lockIcon);
            dpTracking = constantsObj.TRACK_DP_LOCKED;
        }

        var openPuzzleBtn = utilObj.getButton(205, 205, 0.5, 0.5,
            xRightPos - 180, yPos + constantsObj.BOTTOM_BAR_OFFSET + 150, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'linearLevelProgression',
                fn: 'openDailyPuzzle',
                screen: linearLevelProgression.screen,
                params: {
                    "sound": constantsObj.trans_button,
                    "sound_on": true,
                },
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                    o: constantsObj.TRACK_MAP_SCREEN,
                    f: dpTracking,
                    g: linearLevelProgression.trackVariabes,
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
                child: childArr,
                feedBackType: constantsObj.ZOOMIN_FEEDBACK
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        linearLevelProgression.addChild(openPuzzleBtn, zOrder + 2);

        linearLevelProgression.dailyPuzzleFtueBg = dailyPuzzleBtnBg;
        linearLevelProgression.dailyPuzzleFtueBtn = openPuzzleBtn;

        ***/


        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1, constantsObj.TRACK_MAP_SCREEN, constantsObj.TRACK_VIEW, linearLevelProgression.trackVariabes, gameObj.getPuzzleSpeciesTracking(), "", "");

        // AT The End Of Show Function
        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);
        utilObj.updateScreen(linearLevelProgression.screen, linearLevelProgression);

        if (gameObj.shouldShowNotifPermPopup()) {
            gameObj.showNotifPermPopup();
        } else if (linearLevelObj.canShowDailyPuzzleFtue()) {
            linearLevelProgression.showDailyPuzzleFtue();
        }  else if (linearLevelObj.canShowCountryUnlockFtue() && !linearLevelObj.isEndOfContent()) {
            linearLevelProgression.showCountryUnlockFtue();
        } else {
            utilObj.showBannerAd(utilObj.getScreenName(constantsObj.SCREEN_LINEAR_PROGRESSION));
            linearLevelProgression.checkAndShowPopups();
        }

        if (gameObj.getBackFromPuzzleScreen()) {
            gameObj.setBackFromPuzzleScreen(false);
        }

        // if(ftueObj.isFtueShown()) {
        //     questsObj.incActionForQuestType(xpromoConstantsObj.QUEST_TYPE_COMPLETE_TUTORIAL);
        // }


    },

    checkAndShowPopups: function () {

        var curTimestamp1 = utilObj.getCurrentTimestamp();
        var timeSpentFbLoginShown = curTimestamp1 - gameObj.getLastFbLoginShowTimestamp();
        var timeSpentRateUsShown = curTimestamp1 - gameObj.getLastRateUsShowTimestamp();
        var timeSpentInviteAndWinShown = curTimestamp1 - gameObj.getLastInviteAndWinShowTimestamp();


        var runtimeValue = runtimeObj.getCoolDownForPopups();
        var splitStr = runtimeValue.split(":");

        var coolDownPeriodFbLogin = parseInt(splitStr[0]);
        var coolDownPeriodRateUS = parseInt(splitStr[1]);
        var coolDownPeriodInviteAndWin = parseInt(splitStr[2]);

        var daysEligibleRateUs = 1; // TODO: add runtime for this
        var daysEligibleFbLogin = 1; // TODO: add runtime for this
        var daysEligibleInviteAndWin = 2; // TODO: add runtime for this

        var puzzlesCompletedRateUs = 16; // TODO: add runtime for this
        var puzzlesCompletedFbLogin = 11; // TODO: add runtime for this
        var puzzlesCompletedInviteAndWin = 11; // TODO: add runtime for this

        var userCreatedTimeStamp = userObj.getCreated();
        var diffTimeStamp = curTimestamp1 - userCreatedTimeStamp;


        var puzzlesCleared = linearLevelObj.getDtc2PuzzleCompleted();

        if (false && linearLevelObj.getisPuzzleSolvedForToday() && puzzlesCleared >= puzzlesCompletedFbLogin && !fbWrapperObj.isLoggedIn() && diffTimeStamp >= daysEligibleFbLogin && timeSpentFbLoginShown > coolDownPeriodFbLogin * constantsObj.SECONDS_IN_HOUR && (curTimestamp1 - gameObj.getTimeStampForAutoDialogShown()) > 4 * constantsObj.SECONDS_IN_MIN) {
            fbConnectPopup.show();
        } else if (linearLevelObj.getisPuzzleSolvedForToday() && puzzlesCleared >= puzzlesCompletedRateUs && diffTimeStamp >= daysEligibleRateUs && timeSpentRateUsShown > coolDownPeriodRateUS * constantsObj.SECONDS_IN_HOUR && gameObj.getLastRatedVersion() == 0 && (curTimestamp1 - gameObj.getTimeStampForAutoDialogShown()) > 4 * constantsObj.SECONDS_IN_MIN) {
            rateUsPopup.show();
        } else if (false && linearLevelObj.getisPuzzleSolvedForToday() && puzzlesCleared >= puzzlesCompletedInviteAndWin && diffTimeStamp >= daysEligibleInviteAndWin && fbWrapperObj.isLoggedIn() && timeSpentInviteAndWinShown > coolDownPeriodInviteAndWin * constantsObj.SECONDS_IN_HOUR && (curTimestamp1 - gameObj.getTimeStampForAutoDialogShown()) > 4 * constantsObj.SECONDS_IN_MIN) {
            freeCoins2Popup.show(true, constantsObj.SCREEN_LINEAR_PROGRESSION);
        } else if (!linearLevelProgression.isEndOfContentPopupShown && linearLevelObj.isEndOfContent()) {
            linearLevelProgression.isEndOfContentPopupShown = true;
            eocPopup.show();
        }
        /**
         * End Of content popup to be shown when all puzzles are completed
         */


    },

    /**
     * heck elgibility state for daily puzzle
     * @return {number|string} state of daily puzzle lock state
     */
    getStateOfDailyPuzzle: function () {
        if (linearLevelObj.getIsDailyPuzzleUnLocked()) {
            return constantsObj.STATE_UNLOCKED;
        }
        var puzzleSolved = linearLevelObj.getDtc2PuzzleCompleted();
        var runtimeValue = runtimeObj.getDailyPuzzle();

        var splitStr = runtimeValue.split(":");
        var puzzleNeeded = parseInt(splitStr[0]);

        // if (utilObj.getCurrentTimestamp() - userObj.getCreated() < daysUnlock * constantsObj.SECONDS_IN_DAY ) {
        //     return constantsObj.STATE_LOCKED;
        // }

        if (puzzleSolved < puzzleNeeded) {
            return constantsObj.STATE_LOCKED;
        } else {
            linearLevelObj.setIsDailyPuzzleUnLocked(true);
            return constantsObj.STATE_UNLOCKED;
        }


    },

    checkButtonWrk: function () {
        loggerObj.debugLog("CHECKING BUTTON FUNCTIONALITY");
    },

    /**
     * opens the daily puzzle
     */
    openDailyPuzzle: function () {
        // gets the state of the daily puzzle button
        var stateofDailyPuzzle = linearLevelProgression.getStateOfDailyPuzzle();

        var runtimeValue = runtimeObj.getDailyPuzzle();
        var splitStr = runtimeValue.split(":");
        var puzzleNeeded = parseInt(splitStr[0]);

        // if it is locked
        if (stateofDailyPuzzle == constantsObj.STATE_LOCKED) {
            utilObj.showMessage("Clear Level " + puzzleNeeded + " to play the Daily Puzzle!");
            var trackPuzzleNeeded = puzzleNeeded + "_map";
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1, constantsObj.TRACK_DAILY_PUZZLE_UNLOCK, constantsObj.TRACK_VIEW, trackPuzzleNeeded, gameObj.getPuzzleSpeciesTracking(), "", "");
            return;
        }

        var puzzleId = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
        puzzleId = stringsObj.mini_prefix + puzzleId.substr(2, puzzleId.length);

        var ifPuzzleCompleted = gameObj.getPuzzleCompleted(puzzleId);
        if (ifPuzzleCompleted) {
            utilObj.showMessage("You've completed today's puzzle. Solve again tomorrow!");
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1, constantsObj.MAP_DP_COMPLETE, constantsObj.TRACK_VIEW, linearLevelProgression.trackVariabes, gameObj.getPuzzleSpeciesTracking(), "", "");
            return;
        }

        if (gameObj.getCrosswordForDate(puzzleId) == null) {
            ftueObj.setDailyMiniFtueShown(true);
            if (utilObj.isOnline() == false) {
                utilObj.showMessage("Please connect to internet to download content");
            } else {
                utilObj.showMessage("Please try after some time");
            }
            return;
        }

        linearLevelProgression.hide();
        gameLayer.show(puzzleId);

        linearLevelObj.setIsDailyPuzzleFtueSeen(true);

    }

    ,
    addLevelNodes: function (nodeNum) {
        var spriteArr = [];
        var labelArr = [];
        if (linearLevelProgression.isLevelNodeAdded[nodeNum]) {
            return;
        }
        var levelNodeInfo = linearLevelProgression.levelNodePos[nodeNum];
        // if (nodeNum <=  linearLevelProgression.totalPuzzles) {
        //     var friendNodeInfo =  linearLevelProgression.levelNodePos[nodeNum];
        // }
        if (levelNodeInfo != undefined && levelNodeInfo["li"] == 0) {
            linearLevelProgression.showCountryNode(linearLevelProgression.countryNodesMap, levelNodeInfo["ci"], spriteArr, labelArr, constantsObj.SPRITE_Z_ORDER + 1);
        }
        if (levelNodeInfo != undefined) {
            linearLevelProgression.showLevelNode(levelNodeInfo["ci"], levelNodeInfo["li"], levelNodeInfo["x"], levelNodeInfo["y"], nodeNum, spriteArr, labelArr);
        }
        // if (fbWrapperObj.isLoggedIn() &&  linearLevelProgression.leaderBoardData[nodeNum.toString()] != undefined && nodeNum <=  linearLevelProgression.totalPuzzles) {
        //      linearLevelProgression.currentLevel += 1;
        //      linearLevelProgression.checkFriendSprites(friendNodeInfo["x"], friendNodeInfo["y"], nodeNum, spriteArr);
        // }
        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);
    },

    showLevelNode: function (countryIndex, levelNum, xPos, yPos, counter, spriteArr, labelArr) {


        var childArr = [];
        var linearShift = 0;
        if (utilObj.isBezelScreen()) {
            linearShift = constantsObj.BEZEL_SAFE_AREA;
        }
        yPos += linearShift;
        linearLevelProgression.isLevelNodeAdded[counter] = true;
        var curPuzzleIndex = linearLevelProgression.curPuzzleNo + linearLevelProgression.curCountryInfo["co"] - linearLevelProgression.curCountryInfo["pc"];
        var setNodeZOrder = constantsObj.SPRITE_Z_ORDER;
        var setNodeLayer = linearLevelProgression.scrollView;
        // loggerObj.debugLog("In Show Level Function params recived" , countryIndex , levelNum , counter)
        // loggerObj.debugLog("Curr Puzzle index here " , curPuzzleIndex)
        // if ( linearLevelProgression.shouldFtueBeShown &&  linearLevelProgression.ftueShownNum == ftueObj.FTUE_LINEAR_PROGRESSION && counter == curPuzzleIndex) {
        //     setNodeZOrder = constantsObj.FTUE_Z_ORDER;
        //     setNodeLayer =  linearLevelProgression;
        //     yPos = centerYPos + 500;
        // }

        var font = constantsObj.FONT_HELVETICA_MEDIUM_80;
        if (counter >= 1000) {
            font = constantsObj.FONT_HELVETICA_MEDIUM_75;
        }
        var levelLabel = utilObj.getBMFontLabel("" + counter, font, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, linearLevelProgression.scrollView, constantsObj.SPRITE_Z_ORDER + 3);

        // if (fbWrapperObj.isLoggedIn() && counter == curPuzzleIndex) {
        //      linearLevelProgression.checkFriendSprites(xPos, yPos, counter, spriteArr);
        // } else if (counter == curPuzzleIndex) {
        //     var generic_profile = utilObj.getSprite(constantsObj.generic_profile_img, xPos, yPos + 220, 0.5, 0.5, constantsObj.SCALE_ONE_POINT_ONE * constantsObj.SPRITE_SCALING_FACTOR, spriteArr,  linearLevelProgression.scrollView, setNodeZOrder + 1, constantsObj.SPRITE_MISC);
        //     childArr = [generic_profile];
        //     var fbConnectBtn = utilObj.getButton(160, 160, 0.5, 0.5,
        //         xPos, yPos + 220, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
        //             obj: ' linearLevelProgression',
        //             // fn: 'connectFb',
        //             fn: '',
        //             screen:  linearLevelProgression.screen,
        //             params: {
        //                 "sound": constantsObj.button_tap_01,
        //                 "sound_on": true,
        //             },
        //             child: childArr,
        //             feedBackType: constantsObj.ZOOMIN_FEEDBACK
        //         }, false, ccui.Widget.PLIST_TEXTURE, constantsObj.SCALE_ONE_POINT_ONE);
        //     setNodeLayer.addChild(fbConnectBtn, setNodeZOrder + 2);
        //     // animationObj.animateCurrentProfile(generic_profile);
        // }

        if (counter <= curPuzzleIndex) {
            if (counter < curPuzzleIndex || linearLevelProgression.isEocUser) {
                utilObj.setVisible(levelLabel, false);
                // var solvedNodeBg = utilObj.getSprite(constantsObj.map_node, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_79, spriteArr, setNodeLayer, setNodeZOrder, constantsObj.SPRITE_MISC);
                //     solvedNodeBg.setColor(constantsObj.COLOR_WHITE);
                var solvedNode = utilObj.getSprite(constantsObj.NODE_COMPLETE, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_79, spriteArr, setNodeLayer, setNodeZOrder + 1, constantsObj.SPRITE_MISC);
                // solvedNode.setColor(constantsObj.COLOR_SOLVED_NODE2);
                var tick = utilObj.getSprite(constantsObj.tick, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1, spriteArr, setNodeLayer, setNodeZOrder + 1, constantsObj.SPRITE_MISC);
                utilObj.setColor(tick, constantsObj.COLOR_WHITE);

                childArr = [solvedNode, tick];
                var solvedLevelNodeBtn = utilObj.getButton(205, 205, 0.5, 0.5,
                    xPos, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                        obj: 'linearLevelProgression',
                        fn: 'solvedPuzzleFunc',
                        screen: linearLevelProgression.screen,
                        params: {
                            "sound": constantsObj.button_tap_01,
                            "sound_on": true,
                            "c": countryIndex,
                            "l": levelNum,
                            "co": counter
                        },
                        track: {
                            k: constantsObj.TRACK_DIALOG,
                            p: gameObj.getCurPuzzleTracking(),
                            c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                            o: constantsObj.TRACK_MAP_SCREEN,
                            f: constantsObj.TRACK_COMPLETED_NODE,
                            g: linearLevelProgression.trackVariabes,
                            s: gameObj.getPuzzleSpeciesTracking(),
                            co: 1,
                            oppId: ""
                        },
                        child: childArr,
                        feedBackType: constantsObj.ZOOMIN_FEEDBACK
                    }, false, ccui.Widget.PLIST_TEXTURE, 1);
                setNodeLayer.addChild(solvedLevelNodeBtn, setNodeZOrder + 2);


            } else if (counter == curPuzzleIndex) {
                utilObj.setVisible(levelLabel, false);


                if (!linearLevelObj.canShowCountryUnlockFtue()) {

                    var bg1 = utilObj.getSprite(constantsObj.white_circle_150, xPos, yPos, 0.5, 0.5,
                        constantsObj.SCALE_SPRITE_2 * 1.5, spriteArr, setNodeLayer, setNodeZOrder + 1, constantsObj.SPRITE_MISC);

                    // utilObj.setColor(bg1, constantsObj.COLOR_HOT_PINK_2);
                    var color = constantsObj.COLOR_HOT_PINK_2;
                    ;
                    if (linearLevelProgression.curCountryInfo["nc"] == "pink") {
                        color = constantsObj.COLOR_HOT_PINK_2;
                    } else if (linearLevelProgression.curCountryInfo["nc"] == "white") {
                        color = constantsObj.COLOR_WHITE;
                    }
                    utilObj.setColor(bg1, color);
                    utilObj.setOpacity(bg1, constantsObj.OPACITY_30);

                    linearLevelProgression.pulseBg(setNodeLayer, {node: bg1, scale: 3.5});

                    var bg2 = utilObj.getSprite(constantsObj.white_circle_150, xPos, yPos, 0.5, 0.5,
                        constantsObj.SCALE_SPRITE_2 * 1.5, spriteArr, setNodeLayer, setNodeZOrder + 1, constantsObj.SPRITE_MISC);
                    // utilObj.setColor(bg2, constantsObj.COLOR_HOT_PINK_2);
                    utilObj.setColor(bg2, color);
                    utilObj.setOpacity(bg2, constantsObj.OPACITY_30);

                    utilObj.delayedCallback(setNodeLayer, linearLevelProgression.pulseBg, 0.3, {
                        node: bg2,
                        scale: 3.5
                    }, false);
                }
                linearLevelProgression.profileImage = utilObj.getSprite(constantsObj.PROFILE_ICON, xPos, yPos + 280, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_85, spriteArr, setNodeLayer, setNodeZOrder + 1, constantsObj.SPRITE_MISC);

                // var activeNodeBg = utilObj.getSprite(constantsObj.activeNode_bg, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_ONE_POINT_SIX, spriteArr, setNodeLayer, setNodeZOrder + 1, constantsObj.SPRITE_MISC);
                var activeNode = utilObj.getSprite(constantsObj.NODE_CURR, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.7, spriteArr, setNodeLayer, setNodeZOrder + 1, constantsObj.SPRITE_MISC);
                var activeNodeFont = constantsObj.FONT_HELVETICA_MEDIUM_105;
                if (counter >= 1000) {
                    activeNodeFont = constantsObj.FONT_HELVETICA_MEDIUM_90;
                }
                var activeNodeLbl = utilObj.getBMFontLabel("" + counter, activeNodeFont, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, setNodeLayer, setNodeZOrder + 1);

                if (!linearLevelObj.canShowCountryUnlockFtue() && !linearLevelObj.canShowDailyPuzzleFtue()) {
                    linearLevelProgression.animateProfileIcon(linearLevelProgression.profileImage, xPos, yPos);
                }

                linearLevelProgression.activeNodeForFtue = activeNode;
                loggerObj.debugLog("position is", linearLevelObj.getCurLevel(), linearLevelProgression.curPuzzleNo, countryIndex, levelNum, counter);

                childArr = [activeNode, activeNodeLbl];
                var curLevelNodeBtn = utilObj.getButton(200, 200, 0.5, 0.5,
                    xPos, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                        obj: 'linearLevelProgression',
                        fn: 'openPuzzle',
                        screen: linearLevelProgression.screen,
                        params: {
                            "sound": constantsObj.button_tap_01,
                            "sound_on": true,
                            "c": countryIndex,
                            "l": levelNum,
                            "co": counter
                        },
                        track: {
                            k: constantsObj.TRACK_DIALOG,
                            p: gameObj.getCurPuzzleTracking(),
                            c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                            o: constantsObj.TRACK_MAP_SCREEN,
                            f: constantsObj.TRACK_CURRENT_NODE,
                            g: linearLevelProgression.trackVariabes,
                            s: gameObj.getPuzzleSpeciesTracking(),
                            co: 1,
                            oppId: ""
                        },
                        child: childArr,
                        feedBackType: constantsObj.ZOOMIN_FEEDBACK
                    }, false, ccui.Widget.PLIST_TEXTURE, constantsObj.SCALE_ONE);
                setNodeLayer.addChild(curLevelNodeBtn, setNodeZOrder + 2);
                // animationObj.rotateActiveNode(activeNodeBg);

            }
        } else {
            var closedNodeBg = utilObj.getSprite(constantsObj.white_circle_150, xPos, yPos - 5, 0.5, 0.5, 1.1 * constantsObj.SCALE_SPRITE_NEW_1 * 1.1, spriteArr, setNodeLayer, setNodeZOrder + 1, constantsObj.SPRITE_MISC);
            utilObj.setColor(closedNodeBg, constantsObj.COLOR_BLACK);
            utilObj.setOpacity(closedNodeBg, constantsObj.OPACITY_30);

            var closedNodeBg2 = utilObj.getSprite(constantsObj.white_circle_150, xPos, yPos, 0.5, 0.5, 1.1 * constantsObj.SCALE_SPRITE_NEW_1 * 1.1, spriteArr, setNodeLayer, setNodeZOrder + 1, constantsObj.SPRITE_MISC);
            utilObj.setColor(closedNodeBg2, constantsObj.COLOR_WHITE);

            var closedNodeBg3 = utilObj.getSprite(constantsObj.white_circle_150, xPos, yPos, 0.5, 0.5, 1.13 * constantsObj.SCALE_SPRITE_NEW_1, spriteArr, setNodeLayer, setNodeZOrder + 1, constantsObj.SPRITE_MISC);
            utilObj.setColor(closedNodeBg3, constantsObj.COLOR_CLOSED_NODE);

            childArr = [closedNodeBg, closedNodeBg2, closedNodeBg3];
            var lockLevelBtn = utilObj.getButton(205, 205, 0.5, 0.5,
                xPos, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: 'linearLevelProgression',
                    fn: 'showLockLevelMsg',
                    screen: linearLevelProgression.screen,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                        o: constantsObj.TRACK_MAP_SCREEN,
                        f: constantsObj.TRACK_INCOMPLETED_NODE,
                        g: linearLevelProgression.trackVariabes,
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                    child: childArr,
                    feedBackType: constantsObj.ZOOMIN_FEEDBACK
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            linearLevelProgression.scrollView.addChild(lockLevelBtn, setNodeZOrder + 2);
        }
    },

    solvedPuzzleFunc: function () {

        if (linearLevelProgression.isEocUser) {
            utilObj.showMessage("You have completed all puzzles! Please play the Daily Puzzle while we make more!");
        } else {
            utilObj.showMessage(stringsObj.puzzle_solved);
        }

    },

    animateProfileIcon: function (profile, xPosFinal, yPosFinal) {
        if (!utilObj.isNodeValid(profile)) {
            return;
        }
        var xPos = profile.getPositionX();
        var yPos = profile.getPositionY();
        var moveUp = new cc.MoveTo(0.6, xPos, yPos + 50).easing((cc.easeIn(1)));
        var moveDown = new cc.MoveTo(0.15, xPos, yPos).easing((cc.easeOut(1)));
        var delay = utilObj.getDelayTime(0.65);
        var p = {
            xPosFinal: xPosFinal,
            yPosFinal: yPosFinal
        };
        // var callFunc = utilObj.getCallFunc(questMapLayer.backRingsAnim, questMapLayer, p);
        var animArr = [];
        animArr.push(moveUp);
        animArr.push(moveDown);
        // animArr.push(callFunc);
        animArr.push(delay);
        var seq = utilObj.getSequence(animArr);
        animObj.runAction(profile, seq.repeatForever(), true);

    },

    addEocImg: function () {
        var spriteArr = [];
        var labelArr = [];
        utilObj.getSprite(constantsObj.eoc_img, linearLevelProgression.eocImgXPos - 100, linearLevelProgression.eocImgYPos + 150, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.35, spriteArr, linearLevelProgression.scrollView, constantsObj.SPRITE_Z_ORDER + 1, constantsObj.SPRITE_MISC);
        var comingSoonLabel = utilObj.getBMFontLabel("COMING SOON", constantsObj.FONT_HELVETICA_MEDIUM_40, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), linearLevelProgression.eocImgXPos - 100, linearLevelProgression.eocImgYPos - 145 + 150, 0.5, 0.5, labelArr, linearLevelProgression.scrollView, constantsObj.SPRITE_Z_ORDER + 1);
        var contentSize = comingSoonLabel.getContentSize();
        var countryLabelBg = utilObj.getScale9Sprite(constantsObj.labelBg, linearLevelProgression.eocImgXPos - 100, linearLevelProgression.eocImgYPos - 145 + 150, 0.5, 0.5, contentSize.width - 70, 70, spriteArr, linearLevelProgression.scrollView, constantsObj.SPRITE_Z_ORDER, constantsObj.SPRITE_LOCAL);
        utilObj.setColor(countryLabelBg, constantsObj.COLOR_WHITE);
        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);
    },

    addRedirectButton: function (scrollDirection) {

        var zOrder = constantsObj.SPRITE_Z_ORDER;
        var spriteArr = [];
        linearLevelProgression.shouldAddButton = 0;

        var linearShift = 0;
        if (utilObj.isBezelScreen()) {
            linearShift = constantsObj.BEZEL_SAFE_AREA;
        }
        var yPos = linearLevelProgression.yPosForRedirectBtn;
        linearLevelProgression.redirectImg = utilObj.getSprite(constantsObj.icon_holder_circle, xRightPos - 180, yPos + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0, constantsObj.SCALE_SPRITE_NEW_1 / 1.42, spriteArr, linearLevelProgression, zOrder + 2, constantsObj.SPRITE_MISC);
        // linearLevelProgression.redirectImg.setColor(constantsObj.COLOR_WHITE);
        // linearLevelProgression.redirectImg.setCascadeOpacityEnabled(true);

        // var scrollBtnBlack = utilObj.getSprite(constantsObj.white_circle_150, linearLevelProgression.redirectImg.getContentSize().width / 2, linearLevelProgression.redirectImg.getContentSize().height / 2, 0.5, 0.5, 0.95, spriteArr, linearLevelProgression.redirectImg, zOrder + 2, constantsObj.SPRITE_MISC);
        // scrollBtnBlack.setColor(constantsObj.COLOR_BLACK);
        // scrollBtnBlack.setOpacity(constantsObj.OPACITY_90);

        var arrow = utilObj.getSprite(constantsObj.down_arrow, linearLevelProgression.redirectImg.getContentSize().width / 2, linearLevelProgression.redirectImg.getContentSize().height / 2 + 10, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_79, spriteArr, linearLevelProgression.redirectImg, zOrder + 2, constantsObj.SPRITE_MISC);
        arrow.rotation = 180;

        //linearLevelProgression.redirectImg.setCascadeOpacityEnabled(true);
        var scrollTrack = constantsObj.TRACK_MAP_SCROLL_UP;
        if (scrollDirection == "down") {
            scrollTrack = constantsObj.TRACK_MAP_SCROLL_DOWN;
        }

        linearLevelProgression.redirectBtn = utilObj.getButton(205, 205, 0.5, 0.5,
            xRightPos - 230, yPos + constantsObj.BOTTOM_BAR_OFFSET + 140, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'linearLevelProgression',
                fn: 'redirectToCurLevel',
                screen: linearLevelProgression.screen,
                params: {
                    "sound": constantsObj.trans_button,
                    "sound_on": true,
                },
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                    o: constantsObj.TRACK_MAP_SCREEN,
                    f: scrollTrack,
                    g: linearLevelProgression.trackVariabes,
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
                child: [linearLevelProgression.redirectImg],
                feedBackType: constantsObj.ZOOMIN_FEEDBACK
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        linearLevelProgression.addChild(linearLevelProgression.redirectBtn, constantsObj.SPRITE_Z_ORDER + 2);
        // utilObj.setOpacity(linearLevelProgression.redirectBtn, 0);

        if (scrollDirection == "down") {
            arrow.setRotation(360);
        }
        // utilObj.setVisible(linearLevelProgression.redirectImg, false);
        linearLevelProgression.redirectImg.setCascadeOpacityEnabled(true);
        utilObj.setOpacity(linearLevelProgression.redirectImg, 0);
        linearLevelProgression.showRedirectBtn(linearLevelProgression.redirectBtn);
        utilObj.addSprites(spriteArr);
    },

    hideRedirectBtn: function (layer, node) {
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        // utilObj.setVisible(linearLevelProgression.redirectImg, false);
        var time = 0.2;
        var delay = utilObj.getDelayTime(0.1);
        var fadeOut = utilObj.getFadeOut(time);
        var seqAction = [delay, fadeOut];
        var seq = utilObj.getSequence(seqAction, false);
        animObj.runAction(linearLevelProgression.redirectImg, seq);

        var params = {
            n: node,
            l: layer
        };
        utilObj.delayedCallback(layer, linearLevelProgression.removeRedirectBtn, 0.3, params, false);

        var params = {
            n: linearLevelProgression.redirectImg,
            l: layer
        };
        utilObj.delayedCallback(layer, linearLevelProgression.removeRedirectBtn, 0.3, params, false);

    },
    showRedirectBtn: function (node) {
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        // utilObj.setVisible(linearLevelProgression.redirectImg, true);
        var time = 0.2;
        var delay1 = utilObj.getDelayTime(0.1);
        var fadeIn = utilObj.getFadeTo(time, constantsObj.OPACITY_80);
        var seqAction1 = [delay1, fadeIn];
        var seq1 = utilObj.getSequence(seqAction1, false);
        animObj.runAction(linearLevelProgression.redirectImg, seq1);
    },

    removeRedirectBtn: function (sender, params) {
        var node = params.n;
        var layer = params.l;
        utilObj.removeChild(layer, node);
    },

    redirectToCurLevel: function () {
        loggerObj.debugLog("IN REDIRECT TO CURR LEVELL")
        // console.log("IN REDIRECT TO CURR LEVELL")
        linearLevelProgression.curLevelNum = linearLevelProgression.curPuzzleNo + linearLevelProgression.curCountryInfo["co"] - linearLevelProgression.curCountryInfo["pc"];
        linearLevelProgression.jumpToCurrentCountry(linearLevelProgression.jumpToPercent, true);
        linearLevelProgression.changeBg(linearLevelProgression.curCountryInfo["i"] - 1);
        linearLevelProgression.curCountryNode = linearLevelProgression.curCountryInfo["i"] - 1;
        linearLevelProgression.shouldAddButton = 1;
        linearLevelProgression.hideRedirectBtn(linearLevelProgression, linearLevelProgression.redirectBtn);
    },

    showLockLevelMsg: function () {
        loggerObj.debugLog("IN SHOW LOCK LEVEL MESAGE")
        // console.log("Innnn show lock")
        utilObj.showMessage(stringsObj.puzzle_not_open);

    },
    openPuzzle: function (params) {


        // loggerObj.debugLog("Clicked country and level is", params.c , params.l,  linearLevelProgression.curPuzzleNo +  linearLevelProgression.curCountryInfo["co"] -  linearLevelProgression.curCountryInfo["pc"], params.co);

        // Commeneted for testing
        // var gameId = linearLevelObj.getPuzzleIdLlp(curPuzzleIndex-1);
        var index = linearLevelObj.getDtc2PuzzleCompleted();
        var gameId = linearLevelObj.getPuzzleIdLlp(index);
        linearLevelObj.setClickedNodeId(gameId)
        linearLevelProgression.hide();
        gameLayer.show(gameId, false, false, false, false, false, true);

    },

    jumpToCurrentCountry: function (percentJump, directJump) {
        if (utilObj.isNative() || directJump) {
            linearLevelProgression.scrollView.jumpToPercentVertical(percentJump);
        } else {
            utilObj.scrollToPercentVertical(linearLevelProgression.scrollView, percentJump, 0.1, false);

        }
    },


    showCountryNode: function (countryNodesHeight, startCountry, spriteArr, labelArr, zOrder) {
        // loggerObj.debugLog("IN SHOW COUNTRY NODE",linearLevelProgression.allCountriesInfo[startCountry]["cc"]);
        var linearShift = 0;
        if (utilObj.isBezelScreen()) {
            linearShift = constantsObj.BEZEL_SAFE_AREA;
        }
        var xPos = countryNodesHeight[startCountry]["x"];
        var yPos = countryNodesHeight[startCountry]["y"] + linearShift;

        var countryNodeBg = utilObj.getSprite(constantsObj.white_circle_150, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 1.42, spriteArr, linearLevelProgression.scrollView, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setColor(countryNodeBg, constantsObj.COLOR_WHITE);

        // var countryNodeBlack = utilObj.getSprite(constantsObj.white_circle_150, countryNodeBg.getContentSize().width /2, countryNodeBg.getContentSize().height / 2, 0.5, 0.5,  constantsObj.SPRITE_SCALING_FACTOR, spriteArr, countryNodeBg, zOrder, constantsObj.SPRITE_MISC);
        var countryNodeBlack = utilObj.getSprite(constantsObj.white_circle_150, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 1.3, spriteArr, linearLevelProgression.scrollView, zOrder, constantsObj.SPRITE_MISC);

        utilObj.setColor(countryNodeBlack, constantsObj.COLOR_BLACK);
        utilObj.getSprite(linearLevelObj.getFlagsMonumentsInfo(linearLevelProgression.allCountriesInfo[startCountry]["cc"])["fV1"], countryNodeBlack.getContentSize().width / 2, countryNodeBlack.getContentSize().width / 2 + 1, 0.5, 0.5, 0.70, spriteArr, countryNodeBlack, zOrder, constantsObj.SPRITE_FLAGS_V1);
        // utilObj.getSprite(linearLevelObj.getFlagsMonumentsInfo( linearLevelProgression.allCountriesInfo[startCountry]["cc"])["fV1"], xPos, yPos, 0.5, 0.5, 1.65* constantsObj.SPRITE_SCALING_FACTOR/2, spriteArr,  linearLevelProgression.scrollView, zOrder, constantsObj.SPRITE_FLAGS_V1);
        if (startCountry < linearLevelProgression.curCountryInfo["i"]) {

        } else {
            // loggerObj.debugLog("In ShowCountry else")
            // linearLevelProgression.countryNodes[startCountry] = utilObj.getSprite(constantsObj.unlock_level_img, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_ONE_POINT_THREE * constantsObj.SPRITE_SCALING_FACTOR, spriteArr,  linearLevelProgression.scrollView, zOrder, constantsObj.SPRITE_MISC);
            var countryNodeBlackLock = utilObj.getSprite(constantsObj.white_circle_150, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 1.3, spriteArr, linearLevelProgression.scrollView, zOrder, constantsObj.SPRITE_MISC);
            utilObj.setColor(countryNodeBlackLock, constantsObj.COLOR_BLACK);
            utilObj.setOpacity(countryNodeBlackLock, constantsObj.OPACITY_50);
            var lockImage = utilObj.getSprite(constantsObj.lock_icon, xPos, yPos, 0.5, 0.5, 0.78 * constantsObj.SCALE_SPRITE_NEW_1, spriteArr, linearLevelProgression.scrollView, zOrder + 3, constantsObj.SPRITE_MISC);
            utilObj.setColor(lockImage, constantsObj.COLOR_BLACK)
        }

    },

    addPathNodes: function (index) {

        if (linearLevelProgression.isPathNodeAdded[index]) {
            return;
        }
        linearLevelProgression.isPathNodeAdded[index] = true;
        var spriteArr = [];
        var path = utilObj.getSprite(constantsObj.map_path_3, centerXPos, linearLevelProgression.pathsPosMap[index]["y"], 0.5, 0, 0.9, spriteArr, linearLevelProgression.scrollView, constantsObj.SPRITE_Z_ORDER, constantsObj.SPRITE_LOCAL);
        utilObj.addSprites(spriteArr);
    },

    changeBg: function (curCountryNode) {
        if (curCountryNode != null) {
            // loggerObj.debugLog("IN CHANGE BACKGROUND FUNCTION")
            var isVisible = false;
            var changedYPos = linearLevelProgression.countryNameLblYPos;
            if (linearLevelProgression.curCountryInfo["c"] == linearLevelProgression.allCountriesInfo[curCountryNode]["c"]) {
                isVisible = true;
            } else {
                changedYPos -= 100;
            }
            utilObj.delayedCallback(linearLevelProgression, function () {
                utilObj.setPositionY(linearLevelProgression.countryNameLbl, changedYPos);
                // linearLevelProgression.countryNameLbl.setPositionY(changedYPos);
                for (var i = 0; i < linearLevelProgression.progressArr.length; i++) {
                    utilObj.setVisible(linearLevelProgression.progressArr[i], isVisible);
                }
            }, 0.3, null, false);
            // animationObj.showCountryNameChangeEffect( linearLevelProgression.countryNameLbl,  linearLevelProgression.allCountriesInfo[curCountryNode]["c"].toUpperCase());

            // changing country name and bg
            var nextBgImg = null;
            if (linearLevelProgression.curCountryInfo["i"] - 1 < curCountryNode) {
                nextBgImg = new cc.Sprite(constantsObj.COUNTRY_GENERIC_BLUR_BG);
            } else if (linearLevelProgression.curCountryInfo["i"] - 1 >= curCountryNode) {
                if (curCountryNode < linearLevelProgression.numCountries) {

                    nextBgImg = new cc.Sprite(linearLevelObj.getBackGroundPath(linearLevelProgression.allCountriesInfo[curCountryNode]["cc"]));
                } else {
                    nextBgImg = new cc.Sprite(constantsObj.COUNTRY_GENRIC_BG);
                }
            }
            linearLevelProgression.bg = utilObj.changeBgImg(linearLevelProgression.bg, linearLevelProgression, nextBgImg);
        }
    },

    calculateLevelNodesAndCountryNodesPos: function (numCountries) {
        var pathHeight = 1843.2;
        var yPos = 400;
        var btnXPos = [centerXPos, centerXPos + 430, centerXPos + 240, centerXPos - 270, centerXPos - 430];
        var btnYPos = [];
        var nextBtnXPos = 0;
        var nextBtnYPos = 0;
        var levelYPos = 0;
        var counter = 0;
        var count = 0;
        linearLevelProgression.levelNodePos = {};

        for (var i = 0; i < numCountries; i++) {
            levelYPos = yPos - (counter * 45);
            // Number of level in each country
            var levelsNum = linearLevelProgression.allCountriesInfo[i]["pc"];
            btnYPos = [levelYPos + 30, levelYPos + 370, levelYPos + 840, levelYPos + 1020, levelYPos + 1500];
            linearLevelProgression.levelNodes[i] = [];

            if (i == 0) {
                linearLevelProgression.countryNodesMap[i] = {"x": btnXPos[0], "y": btnYPos[0]};
                linearLevelProgression.countryNodesAddedPos[i] = btnYPos[0];
                yPos = yPos + pathHeight;
                counter++;
                linearLevelProgression.indexArr[counter - 1] = 5;
                levelYPos = yPos - (counter * 45);
                for (var j = 0; j < 4; j++) {
                    linearLevelProgression.levelNodes[i][j] = {
                        "x": btnXPos[j + 1],
                        "y": btnYPos[j + 1],
                        "c": count + j + 1
                    };
                    linearLevelProgression.levelNodePos[count + j + 1] = {
                        "x": btnXPos[j + 1],
                        "y": btnYPos[j + 1],
                        "ci": i,
                        "li": j
                    };
                }
                linearLevelProgression.levelNodes[i][j] = {"x": btnXPos[0], "y": yPos - 15, "c": 5};
                linearLevelProgression.levelNodePos[5] = {"x": btnXPos[0], "y": yPos - 15, "ci": i, "li": j};
                btnYPos = [levelYPos + 30, levelYPos + 370, levelYPos + 840, levelYPos + 1020, levelYPos + 1500];

                linearLevelProgression.nextBtnXPosIndex = 1;
                linearLevelProgression.nextBtnYPosIndex = 1;
                count += 5;
                linearLevelProgression.countryLastNodeIndex.push(5);
            } else {
                nextBtnXPos = linearLevelProgression.nextBtnXPosIndex;
                nextBtnYPos = linearLevelProgression.nextBtnYPosIndex;

                if (nextBtnYPos == nextBtnXPos && nextBtnYPos == 0) {
                    yPos = yPos + pathHeight;
                    counter++;
                    levelYPos = yPos - (counter * 45);
                    btnYPos = [levelYPos + 30, levelYPos + 370, levelYPos + 840, levelYPos + 1020, levelYPos + 1500];
                    linearLevelProgression.indexArr[counter - 1] = count;
                }

                linearLevelProgression.countryNodesMap[i] = {"x": btnXPos[nextBtnXPos], "y": btnYPos[nextBtnYPos]};
                linearLevelProgression.countryNodesAddedPos[i] = btnYPos[nextBtnYPos];
                for (var j = 0; j < levelsNum;) {
                    if (levelsNum >= 5) {
                        for (var k = 0; k < 5; k++) {
                            nextBtnXPos = (nextBtnXPos + 1) % 5;
                            nextBtnYPos = (nextBtnYPos + 1) % 5;
                            if (nextBtnYPos == nextBtnXPos && nextBtnYPos == 0) {
                                yPos = yPos + pathHeight;
                                counter++;
                                levelYPos = yPos - (counter * 45);
                                btnYPos = [levelYPos + 30, levelYPos + 370, levelYPos + 840, levelYPos + 1020, levelYPos + 1500];
                                linearLevelProgression.indexArr[counter - 1] = count + 1;
                            }
                            if (nextBtnXPos == nextBtnYPos) {
                                linearLevelProgression.levelNodes[i][k + j] = {
                                    "x": btnXPos[nextBtnXPos],
                                    "y": btnYPos[nextBtnYPos],
                                    "c": count + 1
                                };
                                linearLevelProgression.levelNodePos[count + 1] = {
                                    "x": btnXPos[nextBtnXPos],
                                    "y": btnYPos[nextBtnYPos],
                                    "ci": i,
                                    "li": k + j
                                };
                            }
                            count++;
                        }
                        j += 5;
                    }
                    if (j == levelsNum) {
                        linearLevelProgression.countryLastNodeIndex.push(j);
                    }
                }

                nextBtnXPos = (nextBtnXPos + 1) % 5;
                nextBtnYPos = (nextBtnYPos + 1) % 5;
                linearLevelProgression.nextBtnXPosIndex = nextBtnXPos;
                linearLevelProgression.nextBtnYPosIndex = nextBtnYPos;

                if (i == numCountries - 1) {
                    if (nextBtnYPos == nextBtnXPos && nextBtnYPos == 0) {
                        yPos = yPos + pathHeight;
                        counter++;
                        levelYPos = yPos - (counter * 45);
                        btnYPos = [levelYPos + 30, levelYPos + 370, levelYPos + 840, levelYPos + 1020, levelYPos + 1500];
                    }
                    linearLevelProgression.eocImgXPos = btnXPos[nextBtnXPos];
                    linearLevelProgression.eocImgYPos = btnYPos[nextBtnYPos];
                }
            }
        }
    },


    calculatePathsPosition: function (yPos, linearShift, numPaths) {
        var pathHeight = 1843.2;
        linearLevelProgression.pathsPosMap = {};
        for (var i = 0; i < numPaths; i++) {
            linearLevelProgression.pathsPosMap[i] = {
                "x": centerXPos,
                "y": yPos - (i * 45) + linearShift
            };
            yPos = yPos + pathHeight;
        }
    },

    addBottomBar: function (spriteArr, labelArr) {

        var btnWidth = (canvasWidth / 4) - (canvasWidth / 72);
        var btnHeight = 125;
        var xPos = btnWidth / 2 + (canvasWidth / 120);
        var zOrder = constantsObj.SPRITE_Z_ORDER;
        var yPos = btnHeight / 2 + 35 + constantsObj.BOTTOM_BAR_OFFSET;
        var yPosText = yPos - 75;
        // Home Icom
        // var homeIcon = utilObj.getSprite(constantsObj.home_newIcon, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_12 * 2.5, spriteArr, linearLevelProgression, zOrder + 1, constantsObj.SPRITE_MISC);
        // var homeText = utilObj.getBMFontLabel("Home", constantsObj.FONT_HELVETICA_MEDIUM_40, constantsObj.COLOR_WHITE,
        //     constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPosText, 0.5, 0.5, labelArr, linearLevelProgression, zOrder + 1);

        var childArr = [homeIcon, homeText];
        var homeButton = utilObj.getButton(btnWidth, btnHeight + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, xPos, btnHeight / 2 + 3 + constantsObj.BOTTOM_BAR_OFFSET / 2 + 10,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'linearLevelProgression',
                fn: 'showHome',
                screen: linearLevelProgression.screen,
                params: {
                    "sound": constantsObj.button_tap_01,
                    "sound_on": true,
                },
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                    o: constantsObj.TRACK_MAP_SCREEN,
                    f: constantsObj.TRACK_MAP_HOME,
                    g: linearLevelProgression.trackVariabes,
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
                child: childArr,
                feedBackType: constantsObj.GREY_EFFECT
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(linearLevelProgression, homeButton, zOrder + 2);
        utilObj.setCascadeOpacityEnabled(homeButton, true);

        var homeIcon = utilObj.getSprite(constantsObj.home_newIcon, homeButton.getContentSize().width / 2, homeButton.getContentSize().height / 2 + 20, 0.5, 0.5, constantsObj.SCALE_SPRITE_12 * 2.5, spriteArr, homeButton, zOrder + 1, constantsObj.SPRITE_MISC);
        var homeText = utilObj.getBMFontLabel("Home", constantsObj.FONT_HELVETICA_MEDIUM_40, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), homeButton.getContentSize().width / 2, homeButton.getContentSize().height / 2 - 55, 0.5, 0.5, labelArr, homeButton, zOrder + 1);


        // Quest Icon 
        xPos += btnWidth + (canvasWidth / 72) - (canvasWidth / 720);
        // var questIcon = utilObj.getSprite(constantsObj.QUEST_ICON, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_12 * 2, spriteArr, linearLevelProgression, zOrder + 1, constantsObj.SPRITE_MISC);
        // var questText = utilObj.getBMFontLabel("Quest Center", constantsObj.FONT_HELVETICA_MEDIUM_40, constantsObj.COLOR_WHITE,
        //     constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPosText, 0.5, 0.5, labelArr, linearLevelProgression, zOrder + 1);
        // utilObj.setOpacity(questIcon , constantsObj.OPACITY_70);
        // utilObj.setOpacity(questText , constantsObj.OPACITY_70);

        // var childArr = [questIcon, questText];


        var jewlNotifState = questCenterObj.showJewelNotif();
        var qcJewelTrack = constantsObj.TRACK_MAP_QC;
        var speciesState = gameObj.getPuzzleSpeciesTracking();
        if (jewlNotifState >= 0) {
            qcJewelTrack += "_notif";
            speciesState = questCenterObj.questCenterState();
        }
        var childArr = [];
        var questButton = utilObj.getButton(btnWidth, btnHeight + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, xPos, btnHeight / 2 + 3 + constantsObj.BOTTOM_BAR_OFFSET / 2 + 10,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'linearLevelProgression',
                fn: 'showQuest',
                screen: linearLevelProgression.screen,
                params: {
                    "sound": constantsObj.button_tap_01,
                    "sound_on": true,
                },
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                    o: constantsObj.TRACK_MAP_SCREEN,
                    f: qcJewelTrack,
                    g: linearLevelProgression.trackVariabes,
                    s: speciesState,
                    co: 1,
                    oppId: ""
                },
                child: childArr,
                feedBackType: constantsObj.GREY_EFFECT
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(linearLevelProgression, questButton, zOrder + 2);

        utilObj.setCascadeOpacityEnabled(questButton, true);
        var questIcon = utilObj.getSprite(constantsObj.QUEST_ICON, questButton.getContentSize().width / 2, questButton.getContentSize().height / 2 + 20, 0.5, 0.5, constantsObj.SCALE_SPRITE_12 * 2, spriteArr, questButton, zOrder + 1, constantsObj.SPRITE_MISC);
        var questText = utilObj.getBMFontLabel("Quest Center", constantsObj.FONT_HELVETICA_MEDIUM_40, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), questButton.getContentSize().width / 2, questButton.getContentSize().height / 2 - 55, 0.5, 0.5, labelArr, questButton, zOrder + 1);
        utilObj.setOpacity(questIcon, constantsObj.OPACITY_70);
        utilObj.setOpacity(questText, constantsObj.OPACITY_70);

        // Adding jewel Notif in case of quest 


        var jewelNotifText = "NEW";
        if (jewlNotifState > 0) {
            jewelNotifText = jewlNotifState;
        }
        linearLevelProgression.jewelIconBottom1 = utilObj.getSprite(constantsObj.newJewelBg, questButton.getContentSize().width / 2 + 100, questButton.getContentSize().height / 2 + 85, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.6, spriteArr, questButton, zOrder + 1, constantsObj.SPRITE_MISC);
        linearLevelProgression.jewelLabelBottom1 = utilObj.getBMFontLabel(jewelNotifText, constantsObj.FONT_HELVETICA_MEDIUM_50, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), questButton.width / 2 + 100, questButton.getContentSize().height / 2 + 85, 0.5, 0.5, labelArr, questButton, zOrder + 1);

        utilObj.setVisible(linearLevelProgression.jewelIconBottom1, false);
        utilObj.setVisible(linearLevelProgression.jewelLabelBottom1, false);

        linearLevelProgression.jewelIconBottom2 = utilObj.getSprite(constantsObj.newJewelBg, questButton.getContentSize().width / 2 + 70, questButton.getContentSize().height / 2 + 85, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.45, spriteArr, questButton, zOrder + 1, constantsObj.SPRITE_MISC);
        linearLevelProgression.jewelLabelBottom2 = utilObj.getBMFontLabel(jewelNotifText, constantsObj.FONT_HELVETICA_MEDIUM_50, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), questButton.width / 2 + 70, questButton.getContentSize().height / 2 + 85, 0.5, 0.5, labelArr, questButton, zOrder + 1);

        var scale = linearLevelProgression.jewelIconBottom2.scale;
        utilObj.setScaleX(linearLevelProgression.jewelIconBottom2, scale / 1.3);

        utilObj.setVisible(linearLevelProgression.jewelIconBottom2, false);
        utilObj.setVisible(linearLevelProgression.jewelLabelBottom2, false);


        linearLevelProgression.updateJewelNotifBottom();

        // Invite Icon
        xPos += btnWidth + (canvasWidth / 72) - (canvasWidth / 720);
        // var InviteIcon = utilObj.getSprite(constantsObj.INVITE_ICON, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_12 * 2, spriteArr, linearLevelProgression, zOrder + 1, constantsObj.SPRITE_MISC);
        // var InviteText = utilObj.getBMFontLabel("Invite", constantsObj.FONT_HELVETICA_MEDIUM_40, constantsObj.COLOR_WHITE,
        //     constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 10, yPosText, 0.5, 0.5, labelArr, linearLevelProgression, zOrder + 1);
        // utilObj.setOpacity(InviteIcon , constantsObj.OPACITY_70);
        // utilObj.setOpacity(InviteText , constantsObj.OPACITY_70);
        // var childArr = [InviteIcon, InviteText];

        var childArr = [];
        var inviteButton = utilObj.getButton(btnWidth, btnHeight + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, xPos, btnHeight / 2 + 3 + constantsObj.BOTTOM_BAR_OFFSET / 2 + 10,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'linearLevelProgression',
                fn: 'showInvitePopup',
                screen: linearLevelProgression.screen,
                params: {
                    "sound": constantsObj.button_tap_01,
                    "sound_on": true,
                },
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                    o: constantsObj.TRACK_MAP_SCREEN,
                    f: constantsObj.TRACK_INVITE_BOTTOM,
                    g: linearLevelProgression.trackVariabes,
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
                child: childArr,
                feedBackType: constantsObj.GREY_EFFECT
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(linearLevelProgression, inviteButton, zOrder + 2);
        utilObj.setCascadeOpacityEnabled(inviteButton, true);

        var InviteIcon = utilObj.getSprite(constantsObj.INVITE_ICON, inviteButton.getContentSize().width / 2, inviteButton.getContentSize().height / 2 + 20, 0.5, 0.5, constantsObj.SCALE_SPRITE_12 * 2, spriteArr, inviteButton, zOrder + 1, constantsObj.SPRITE_MISC);
        var InviteText = utilObj.getBMFontLabel("Invite", constantsObj.FONT_HELVETICA_MEDIUM_40, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), inviteButton.getContentSize().width / 2 + 10, inviteButton.getContentSize().height / 2 - 55, 0.5, 0.5, labelArr, inviteButton, zOrder + 1);
        utilObj.setOpacity(InviteIcon, constantsObj.OPACITY_70);
        utilObj.setOpacity(InviteText, constantsObj.OPACITY_70);

        // shop Icon
        xPos += btnWidth + (canvasWidth / 72) - (canvasWidth / 720);
        // var storeIcon = utilObj.getSprite(constantsObj.STORE_ICON, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_12 * 2, spriteArr, linearLevelProgression, zOrder + 1, constantsObj.SPRITE_MISC);
        // var storeText = utilObj.getBMFontLabel("Store", constantsObj.FONT_HELVETICA_MEDIUM_40, constantsObj.COLOR_WHITE,
        //     constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 10, yPosText, 0.5, 0.5, labelArr, linearLevelProgression, zOrder + 1);
        // utilObj.setOpacity(storeIcon , constantsObj.OPACITY_70);
        // utilObj.setOpacity(storeText , constantsObj.OPACITY_70);
        // var childArr = [storeIcon, storeText];

        var childArr = [];
        var storeButton = utilObj.getButton(btnWidth, btnHeight + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, xPos, btnHeight / 2 + 3 + constantsObj.BOTTOM_BAR_OFFSET / 2 + 10,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'linearLevelProgression',
                fn: 'showStore',
                screen: linearLevelProgression.screen,
                params: {
                    "sound": constantsObj.button_tap_01,
                    "sound_on": true,
                },
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                    o: constantsObj.TRACK_MAP_SCREEN,
                    f: constantsObj.TRACK_MAP_STORE_BOTTOM,
                    g: linearLevelProgression.trackVariabes,
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
                child: childArr,
                feedBackType: constantsObj.GREY_EFFECT
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(linearLevelProgression, storeButton, zOrder + 2);
        utilObj.setCascadeOpacityEnabled(storeButton, true);

        var storeIcon = utilObj.getSprite(constantsObj.STORE_ICON, storeButton.getContentSize().width / 2, storeButton.getContentSize().height / 2 + 20, 0.5, 0.5, constantsObj.SCALE_SPRITE_12 * 2, spriteArr, storeButton, zOrder + 1, constantsObj.SPRITE_MISC);
        var storeText = utilObj.getBMFontLabel("Store", constantsObj.FONT_HELVETICA_MEDIUM_40, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), storeButton.getContentSize().width / 2 + 10, storeButton.getContentSize().height / 2 - 55, 0.5, 0.5, labelArr, storeButton, zOrder + 1);
        utilObj.setOpacity(storeIcon, constantsObj.OPACITY_70);
        utilObj.setOpacity(storeText, constantsObj.OPACITY_70);

    },

    addTopBar: function (xPos, yPos, spriteArr, labelArr) {
        var screen = linearLevelProgression.screen;
        yPos -= 226;
        var localYPos = yPos - 70;
        var zOrder = constantsObj.SPRITE_Z_ORDER;

        // Top Bar Bg 
        var bar = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos, 0.5, 1, canvasWidth, 140, spriteArr, linearLevelProgression, zOrder + 1, constantsObj.SPRITE_MISC);
        utilObj.setColor(bar, constantsObj.COLOR_BLACK);
        utilObj.setOpacity(bar, constantsObj.OPACITY_50);

        // SETTING BUTTON FORMATION
        var settingStatus = constantsObj.TRACK_MAP_SETTINGS;
        var speciesState = gameObj.getPuzzleSpeciesTracking();
        var jewlNotifState = questCenterObj.showJewelNotif();
        if (jewlNotifState >= 0) {
            settingStatus += "_notif";
            speciesState = questCenterObj.questCenterState();
        }

        var childArr = [];
        var settingsButton = utilObj.getButton(150, 180, 0.5, 0.5, xRightPos - 120, localYPos,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'linearLevelProgression',
                fn: 'openSettings',
                screen: screen,
                params: {
                    "sound": constantsObj.button_tap_01,
                    "sound_on": true,
                },
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                    o: constantsObj.TRACK_MAP_SCREEN,
                    f: settingStatus,
                    g: linearLevelProgression.trackVariabes,
                    s: speciesState,
                    co: 1,
                    oppId: ""
                },
                child: childArr,
                feedBackType: constantsObj.GREY_EFFECT
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(linearLevelProgression, settingsButton, zOrder + 2);
        utilObj.setCascadeOpacityEnabled(settingsButton, true);
        var settings = utilObj.getSprite(constantsObj.SETTING_ICON_2, 75, 90, 0.5, 0.5, constantsObj.SCALE_SPRITE_1 * 0.8, spriteArr, settingsButton, zOrder + 1, constantsObj.SPRITE_MISC);

        // Adding jewel Notif in case of quest 
        var jewelNotifText = "NEW";
        if (jewlNotifState > 0) {
            jewelNotifText = jewlNotifState;
        }
        linearLevelProgression.jewelIconTop1 = utilObj.getSprite(constantsObj.newJewelBg, settingsButton.getContentSize().width / 2 + 25, settingsButton.getContentSize().height / 2 + 45, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.4, spriteArr, settingsButton, zOrder + 2, constantsObj.SPRITE_MISC);
        linearLevelProgression.jewelLabelTop1 = utilObj.getBMFontLabel(jewelNotifText, constantsObj.FONT_HELVETICA_MEDIUM_35, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), settingsButton.getContentSize().width / 2 + 25, settingsButton.getContentSize().height / 2 + 48, 0.5, 0.5, labelArr, settingsButton, zOrder + 2);

        utilObj.setVisible(linearLevelProgression.jewelIconTop1, false);
        utilObj.setVisible(linearLevelProgression.jewelLabelTop1, false);
        utilObj.updateJewelNotifTop(linearLevelProgression.jewelIconTop1, linearLevelProgression.jewelLabelTop1);// linearLevelProgression.updateJewelNotifTop(); // Function call for updating the state from llp only if theres a late call from qc side.
        xPos = xRightPos - 30;

        const xPositionForWisdomIcons = 310 * canvasWidth / 1440;
        var starBg = utilObj.getScale9Sprite(constantsObj.tile_white_curved_2, xPositionForWisdomIcons, yPos - 70, 0, 0.5, 350, 80, spriteArr,
            linearLevelProgression, zOrder + 1, constantsObj.SPRITE_MISC);
        utilObj.setColor(starBg, constantsObj.COLOR_BLACK);
        utilObj.setOpacity(starBg, constantsObj.OPACITY_50);

        var star = utilObj.getSprite(constantsObj.xp_png, xPositionForWisdomIcons - 40, yPos - 65, 0, 0.5, constantsObj.SCALE_SPRITE_1, spriteArr, linearLevelProgression, zOrder + 1, constantsObj.SPRITE_MISC);
        var starCount = xpProgressionObj.getXpCountTrimStr();
        var masteryCount = utilObj.getBMFontLabel(starCount + "", constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPositionForWisdomIcons + 140, yPos - 70, 0, 0.5, labelArr, linearLevelProgression, zOrder + 1);

    },

    updateJewelNotifBottom: function () {
        var jewlNotifState = questCenterObj.showJewelNotif();

        if (jewlNotifState == 0) {
            utilObj.setString(linearLevelProgression.jewelLabelBottom1, "NEW");
            utilObj.setVisible(linearLevelProgression.jewelIconBottom1, true);
            utilObj.setVisible(linearLevelProgression.jewelLabelBottom1, true);

            utilObj.setVisible(linearLevelProgression.jewelIconBottom2, false);
            utilObj.setVisible(linearLevelProgression.jewelLabelBottom2, false);

        } else if (jewlNotifState > 0) {
            var strg = "";
            strg += jewlNotifState;
            utilObj.setString(linearLevelProgression.jewelLabelBottom2, strg);

            utilObj.setVisible(linearLevelProgression.jewelIconBottom1, false);
            utilObj.setVisible(linearLevelProgression.jewelLabelBottom1, false);

            utilObj.setVisible(linearLevelProgression.jewelIconBottom2, true);
            utilObj.setVisible(linearLevelProgression.jewelLabelBottom2, true);


        } else if (jewlNotifState == -1) {
            utilObj.setVisible(linearLevelProgression.jewelIconBottom1, false);
            utilObj.setVisible(linearLevelProgression.jewelLabelBottom1, false);
            utilObj.setVisible(linearLevelProgression.jewelIconBottom2, false);
            utilObj.setVisible(linearLevelProgression.jewelLabelBottom2, false);
        }
    },

    // updateJewelNotifTop : function(){

    //     var jewlNotifState = questCenterObj.showJewelNotif();

    //     if(jewlNotifState == 0){
    //         utilObj.setString(linearLevelProgression.jewelLabelTop1 , "NEW");
    //         utilObj.setVisible(linearLevelProgression.jewelIconTop1 , true);
    //         utilObj.setVisible(linearLevelProgression.jewelLabelTop1 , true);
    //         utilObj.setScale(linearLevelProgression.jewelIconTop1 , 0);
    //         utilObj.setScale(linearLevelProgression.jewelIconTop1 , constantsObj.SCALE_SPRITE_NEW_1 * 0.4);
    //     }else if(jewlNotifState > 0){
    //         var strg = "";
    //         strg += jewlNotifState;
    //         utilObj.setString(linearLevelProgression.jewelLabelTop1 , strg);
    //         utilObj.setVisible(linearLevelProgression.jewelIconTop1 , true);
    //         utilObj.setVisible(linearLevelProgression.jewelLabelTop1 , true);
    //         utilObj.setScale(linearLevelProgression.jewelIconTop1 , 0);
    //         utilObj.setScale(linearLevelProgression.jewelIconTop1 , constantsObj.SCALE_SPRITE_NEW_1 * 0.4);
    //         utilObj.setScaleX(linearLevelProgression.jewelIconTop1 , (constantsObj.SCALE_SPRITE_NEW_1 * 0.4) / 1.5);
    //     }else if(jewlNotifState == -1){
    //         utilObj.setVisible(linearLevelProgression.jewelIconTop1 , false);
    //         utilObj.setVisible(linearLevelProgression.jewelLabelTop1 , false);
    //     }
    // },

    hide: function () {
        if(linearLevelProgression.timerfunc != null) {
            clearInterval(linearLevelProgression.timerfunc);
        }
        linearLevelProgression.setVisible(false);
        linearLevelProgression.removeAllChildren();
    },
    showLandingScreen: function () {
        linearLevelProgression.back();
    },

    back: function () {
        linearLevelProgression.hide();
        landingScreenLayer.show(false, false);
    },

    showHome: function () {
        loggerObj.debugLog("SHOW HOME CLICKED");
    },
    showQuest: function () {

        if (questCenterObj.getQuestCenterVariant() == 1) {
            if (pspnFlutterObj.isFlutterEnabled()) {
                if (ftueObj.isFtueShown()) {
                    questsObj.incActionForQuestType(xpromoConstantsObj.QUEST_TYPE_COMPLETE_TUTORIAL);
                }


                questCenterLayer.show(utilObj.getScreenName(constantsObj.SCREEN_LINEAR_PROGRESSION));
                return;
            }
        } else if (questCenterObj.getQuestCenterVariant() == 0) {
            utilObj.showMessage("Coming Soon");
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1, constantsObj.TRACK_QC_TOASTER, constantsObj.TRACK_VIEW, "", gameObj.getPuzzleSpeciesTracking(), "", "");
        }

        // fbConnectPopup.show();
        // rateUsPopup.show();
        // seeErrorContextualHelpPopup.show();
        // quitPopup.show();
        // w2eFtuePopup.show();
    },
    showInvitePopup: function () {
        loggerObj.debugLog("SHOW INVITE CLICKED");
        // inviteOthersPopup.show(true)
        popupLayer.closeWithDefault();
        freeCoins2Popup.show(true, constantsObj.SCREEN_LINEAR_PROGRESSION);
    },
    showStore: function () {
        loggerObj.debugLog("SHOW STORE CLICKED");
        linearLevelProgression.hide();
        storeLayer.show();
    },
    openSettings: function () {
        loggerObj.debugLog("Settings Clicled");
        settingsPopup.show(constantsObj.SCREEN_LINEAR_PROGRESSION);
        
    },

    addCoins: function () {

        if (utilObj.isIos()) {
            return;
        }

        linearLevelProgression.hide();
        storeLayer.show();
    },
    freeVideoFunc: function () {

        if (!utilObj.isOnline()) {
            utilObj.showMessage(stringsObj.not_online);
            return;
        }

        var coolDownPeriod = 7200;

        var firstVideoShownTimeStamp = gameObj.getFirstVideoSeenTimeStamp();
        if (firstVideoShownTimeStamp == null || (utilObj.getCurrentTimestamp() - firstVideoShownTimeStamp) > coolDownPeriod) {
            firstVideoShownTimeStamp = utilObj.getCurrentTimestamp();
            gameObj.setFirstVideoSeenTimeStamp(firstVideoShownTimeStamp);
            if (!(gameObj.isEligibleForVideoAchiement() && gameObj.getAchievementsState(43) == constantsObj.ACHIEVEMENT_IN_PROGRESS)) {
                gameObj.setNumVideos(0);
            }
        }

        // var storeVideoVariant = epmObj.getChosenVariant(constantsObj.EXP_STORE_VIDEO_VIEWS);
        // var forcedEarnFreeFtue = false;
        // if (storeVideoVariant == constantsObj.EXP_VAR_1) {
        //     var lastStoreVideoClickedTimeStamp = gameObj.getWatchVideoStoreTimeStamp();
        //     var currTimeStamp = utilObj.getCurrentTimestamp();
        //     if (currTimeStamp - lastStoreVideoClickedTimeStamp < constantsObj.SECONDS_IN_HOUR) {
        //         forcedEarnFreeFtue = true;
        //     } else {
        //         gameObj.setWatchVideoStoreTimeStamp(currTimeStamp);
        //     }
        // }

        var maxVideosAllowed = 5;
        if (gameObj.getIsPayer()) {
            maxVideosAllowed = runtimeObj.getNumVideosNew(2);
        } else {
            if ((utilObj.getCurrentTimestamp() - userObj.getCreated()) < 7 * constantsObj.SECONDS_IN_DAY) {
                maxVideosAllowed = runtimeObj.getNumVideosNew(0);
            } else {
                maxVideosAllowed = runtimeObj.getNumVideosNew(1);
            }
        }

        if (gameObj.isEligibleForVideoAchiement() && gameObj.getAchievementsState(43) == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
            maxVideosAllowed = 6;
        }

        if ((utilObj.getCurrentTimestamp() - firstVideoShownTimeStamp) < coolDownPeriod && gameObj.getNumVideos() < maxVideosAllowed) {
            if (adsObj.checkRewardedVideo(false, linearLevelProgression.callbackfnForVideo)) {
                gameObj.setLastVideoSeenTimeStamp(utilObj.getCurrentTimestamp());
                /*if (storeVideoVariant == constantsObj.EXP_VAR_2) {
                 storeLayer.redraw();
                 }*/
                adsObj.showVideoAd(false);
                adsObj.setNotRewardedVideo(false);
            }
            else {
                trackObj.trackCounter(constantsObj.TRACK_AD_TRACKING, constantsObj.TRACK_W2E, constantsObj.TRACK_RETRY, curScreen, "", "mopub", "", "", "");
                // utilObj.showMessage("No Video Available. Please watch after some time");
            }

        } else {
            var timeRemaining = coolDownPeriod - (utilObj.getCurrentTimestamp() - firstVideoShownTimeStamp);
            //utilObj.showMessageAtTop("Next video in " + utilObj.formatTime(timeRemaining));
            if (timeRemaining > 0) {
                utilObj.showMessageAtTop("Next video in " + utilObj.formatTime(timeRemaining));
                trackObj.trackCounter(constantsObj.TRACK_AD_MEDIATION, constantsObj.TRACK_W2E, "cooldown", curScreen, "", "", "", "", "");
                machineLearningDataObj.setVideoTriesCooldown();
            }
        }
    },

    callbackfnForVideo: function () {
        gameObj.setLastVideoSeenTimeStamp(utilObj.getCurrentTimestamp());
        adsObj.setNotRewardedVideo(false);
    },
    /**
     * shows the daily puzzle ftue
     */
    showDailyPuzzleFtue: function () {
        var spriteArr = [];
        var labelArr = [];
        var zOrder = constantsObj.FTUE_Z_ORDER;
        linearLevelProgression.scrollView.setTouchEnabled(false);

        var transBg = utilObj.getScale9Sprite(constantsObj.tile_white, 0, 0, 0, 0, canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset, spriteArr,
            linearLevelProgression, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setColor(transBg, constantsObj.COLOR_BLACK);
        utilObj.setOpacity(transBg, constantsObj.OPACITY_85);

        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1, constantsObj.TRACK_DP_FTUE, constantsObj.TRACK_VIEW, linearLevelProgression.trackVariabes, gameObj.getPuzzleSpeciesTracking(), "", "");

        // trans button to prevent background screen checks
        var transBtn = utilObj.getButton(canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset, 0.5, 0, centerXPos, 0,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'linearLevelProgression',
                fn: 'preventBackgroundScreenTouch',
                screen: linearLevelProgression.screen,
                params: {sound: false, transBg: transBg},
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_DP_FTUE,
                    f: constantsObj.TRACK_OVERLAY_CLICK,
                    g: linearLevelProgression.trackVariabes,
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(transBg, transBtn, zOrder);

        var xPosRight = 0;
        if (isTablet) {
            xPosRight  = 180;
        }

        var stringsArr = utilObj.getSplitStringsArr(stringsObj.dailyPuzzleFtueText, 25);
        var yPos = utilObj.getSpriteCoordinates(linearLevelProgression.dailyPuzzleFtueBg).yPos + 700;
        for (var i = 0; i < stringsArr.length; i++) {
            var ftueTextLbl = utilObj.getBMFontLabel(stringsArr[i], constantsObj.FONT_HELVETICA_65, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos + xPosRight, yPos, 0.5, 1, labelArr, transBg, zOrder);
            utilObj.setOpacity(ftueTextLbl, constantsObj.OPACITY_90);
            yPos -= 90;
        }

        var arrow = utilObj.getSprite(constantsObj.dailyPuzzleFtueArrow, centerXPos + xPosRight + 450, yPos + 165, 0, 1, constantsObj.SCALE_SPRITE_NEW_1 * 0.7, spriteArr, transBg, zOrder + 1, constantsObj.SPRITE_MISC);
        utilObj.setRotation(arrow, 55);

        linearLevelProgression.dailyPuzzleFtueBg.setLocalZOrder(zOrder + 1);
        linearLevelProgression.dailyPuzzleFtueBtn.setLocalZOrder(zOrder + 1);
        if(utilObj.isArray(linearLevelProgression.dailyPuzzleButtonElements)){
            var numItems = linearLevelProgression.dailyPuzzleButtonElements.length;
            for(var i = 0 ; i < numItems; i++){
                utilObj.setLocalZOrder(linearLevelProgression.dailyPuzzleButtonElements[i], zOrder + 1);
            }
        }

        var bg1 = utilObj.getSprite(constantsObj.white_circle_150, linearLevelProgression.dailyPuzzleFtueBg.getPositionX(), linearLevelProgression.dailyPuzzleFtueBg.getPositionY() + 10, 0.5, 0.5,
            constantsObj.SCALE_SPRITE_2 * 1.5, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setColor(bg1, constantsObj.COLOR_WHITE);
        utilObj.setOpacity(bg1, constantsObj.OPACITY_30);

        linearLevelProgression.pulseBg(transBg, {node: bg1});

        var bg2 = utilObj.getSprite(constantsObj.white_circle_150, linearLevelProgression.dailyPuzzleFtueBg.getPositionX(), linearLevelProgression.dailyPuzzleFtueBg.getPositionY() + 10, 0.5, 0.5,
            constantsObj.SCALE_SPRITE_2 * 1.5, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setColor(bg2, constantsObj.COLOR_WHITE);
        utilObj.setOpacity(bg2, constantsObj.OPACITY_30);

        utilObj.delayedCallback(transBg, linearLevelProgression.pulseBg, 0.3, {node: bg2}, false);


        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);
    },

    dismissFtue: function (parent) {
        utilObj.removeChild(linearLevelProgression, parent);
        linearLevelObj.setIsDailyPuzzleFtueSeen(true);
        linearLevelProgression.scrollView.setTouchEnabled(true);
    },

    // function to do nothing
    preventBackgroundScreenTouch: function (params) {
        // do nothing -> rest here xD
        linearLevelProgression.dismissFtue(params.transBg);
    },

    // ************

    /**
     * shows the country unlock ftue on llp
     */
    showCountryUnlockFtue: function () {
        var spriteArr = [];
        var labelArr = [];
        var zOrder = constantsObj.FTUE_Z_ORDER;

        linearLevelProgression.scrollView.setTouchEnabled(false);


        var transBg = utilObj.getScale9Sprite(constantsObj.tile_white, 0, 0, 0, 0, canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset, spriteArr,
            linearLevelProgression, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setColor(transBg, constantsObj.COLOR_BLACK);
        utilObj.setOpacity(transBg, constantsObj.OPACITY_80);

        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1, constantsObj.TRACK_MAP_NODE_FTUE, constantsObj.TRACK_VIEW, linearLevelProgression.trackVariabes, gameObj.getPuzzleSpeciesTracking(), "", "");

        // trans button to prevent background screen checks
        var transBtn = utilObj.getButton(canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset, 0.5, 0, centerXPos, 0,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'linearLevelProgression',
                fn: 'preventBackgroundScreenTouch2',
                screen: linearLevelProgression.screen,
                params: {sound: false, transBg: transBg},
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                    o: constantsObj.TRACK_MAP_NODE_FTUE,
                    f: constantsObj.TRACK_OVERLAY_CLICK,
                    g: linearLevelProgression.trackVariabes,
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(transBg, transBtn, zOrder);

        var activeNodeFtue = linearLevelProgression.activeNodeForFtue;
        var xPos = activeNodeFtue.getPositionX();
        var yPos = activeNodeFtue.getPositionY();
        yPos = centerYPos - 25 + constantsObj.BOTTOM_BAR_OFFSET;


        var bg1 = utilObj.getSprite(constantsObj.white_circle_150, xPos, yPos, 0.5, 0.5,
            constantsObj.SCALE_SPRITE_2 * 1.5, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setColor(bg1, constantsObj.COLOR_HOT_PINK_2);
        utilObj.setOpacity(bg1, constantsObj.OPACITY_30);

        linearLevelProgression.pulseBg(transBg, {node: bg1, scale: 3.5});

        var bg2 = utilObj.getSprite(constantsObj.white_circle_150, xPos, yPos, 0.5, 0.5,
            constantsObj.SCALE_SPRITE_2 * 1.5, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setColor(bg2, constantsObj.COLOR_HOT_PINK_2);
        utilObj.setOpacity(bg2, constantsObj.OPACITY_30);

        utilObj.delayedCallback(transBg, linearLevelProgression.pulseBg, 0.3, {node: bg2, scale: 3.5}, false);

        var activeNode = utilObj.getSprite(constantsObj.NODE_CURR, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.7, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);

        var counter = linearLevelObj.getDtc2PuzzleCompleted() + 1;
        var activeNodeFont = constantsObj.FONT_HELVETICA_MEDIUM_105;
        var activeNodeLbl = utilObj.getBMFontLabel("" + counter, activeNodeFont, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, transBg, zOrder);

        var countryIndex = linearLevelObj.getCurLevel() - 1;
        var levelNum = linearLevelProgression.curPuzzleNo - 1;
        var childArr = [activeNode, activeNodeLbl];
        var curLevelNodeBtn = utilObj.getButton(200, 200, 0.5, 0.5,
            xPos, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'linearLevelProgression',
                fn: 'openPuzzleFtue',
                screen: linearLevelProgression.screen,
                params: {
                    "sound": constantsObj.button_tap_01,
                    "sound_on": true,
                    "c": countryIndex,
                    "l": levelNum,
                    "co": counter
                },
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                    o: constantsObj.TRACK_MAP_NODE_FTUE,
                    f: constantsObj.TRACK_OVERLAY_NODE_CLICK,
                    g: linearLevelProgression.trackVariabes,
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
                child: childArr,
                feedBackType: constantsObj.ZOOMIN_FEEDBACK
            }, false, ccui.Widget.PLIST_TEXTURE, constantsObj.SCALE_ONE);
        transBg.addChild(curLevelNodeBtn, zOrder);

        yPos += 450;

        var ftueTextLbl = utilObj.getBMFontLabel(stringsObj.countryUnlockFtueText, constantsObj.FONT_HELVETICA_65, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, yPos, 0.5, 1, labelArr, transBg, zOrder);
        utilObj.setOpacity(ftueTextLbl, constantsObj.OPACITY_90);

        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);
    },

    openPuzzleFtue: function (params) {
        linearLevelProgression.openPuzzle();
        linearLevelObj.setIsCountryUnlockNodeFtueSeen(true);
    },

    dismissFtue2: function (parent) {
        utilObj.removeChild(linearLevelProgression, parent);
        linearLevelObj.setIsCountryUnlockNodeFtueSeen(true);
        linearLevelProgression.scrollView.setTouchEnabled(true);
    },
    // function to do nothing
    preventBackgroundScreenTouch2: function (params) {
        // do nothing -> rest here xD
        linearLevelProgression.dismissFtue2(params.transBg);
    },

    // animate pulse
    pulseBg: function (sender, params) {
        var durationForScaleUp = 1.25;
        var durationFadeOut = 0.55;
        var delayMid = 0.48;
        var scale = 3;
        if (params.scale) {
            scale = params.scale;
        }
        var scaleTo = new cc.ScaleBy(durationForScaleUp, scale).easing(new cc.easeOut(1));
        var fadeOut = animObj.getFadeOut(durationFadeOut).easing(new cc.easeOut(1));
        var delayFadeOut = utilObj.getDelayTime(durationForScaleUp - durationFadeOut);
        var animArrFadeout = [delayFadeOut, fadeOut];

        var spawn = new cc.Spawn(scaleTo, animObj.getSequence(animArrFadeout));
        var delayTime = animObj.getDelayTime(delayMid);
        var scaleBack = new cc.ScaleBy(0.01, 1 / scale).easing(new cc.easeIn(1));
        var fadeBack = animObj.getFadeTo(0.01, constantsObj.OPACITY_30);
        var animArr = [spawn, delayTime, scaleBack, fadeBack];
        var seq = animObj.getSequence(animArr);

        animObj.runAction(params.node, seq.repeatForever());
    },


    getTimer : function(tomorrow){
       
        var str = "";
        str += linearLevelObj.getCurrentMonth(tomorrow.getMonth()) + " ";
        str += tomorrow.getDate() + ", ";
        str += tomorrow.getFullYear() + " 24:0:0";
       
        var countDownDate = new Date(str).getTime();
        linearLevelProgression.timerfunc = setInterval(function() {
            var now = new Date().getTime();
            var timeleft = countDownDate - now;
            if (timeleft < 0) {
                clearInterval(linearLevelProgression.timerfunc)
            }
            var hours = Math.floor((timeleft % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));
            var minutes = Math.floor((timeleft % (1000 * 60 * 60)) / (1000 * 60));
            var seconds = Math.floor((timeleft % (1000 * 60)) / 1000);
           
            var ans = "";
            ans+=hours + ":";
            ans+=minutes + ":";
            if(seconds < 10){
                ans += "0";
            }
            ans+=seconds;
            loggerObj.debugLog("TIM ::",ans);
            utilObj.setString(linearLevelProgression.timerLabl,  ans+ "");
            
         }, 1000)
    }
});