var TransOutroLayerV2 = cc.Layer.extend({
    screen : null,
    screenName : null,
    animRunning : false,
    puzzleId : 0,
    coinCount : null,
    coinMiniLabel : null,
    coinMainLabel : null,
    playButtonGreen : null,
    transBg : null,
    lowerAnimArr : [],
    nodeArr : [],
    countryCompleteName : null,
    isCountryCompleted : false,
    currFlag : null,
    isMiniOrMidi : null,
    isDailyMini : null,
    isBritMini : null,
    countryBackgroundImage : null,
    newFlag : null,
    unlockedCountryName : null,
    delayForCountryCompleteAnim : null,
    delayForCountryUnlockAnim : null,
    countryCompleteAd : false,
    levelCompleteReward : null,
    countryCompleteReward : null,
    showClaimText : false,
    hoursLeft : null,
    unlockLabel : null,
    timerfunc : null,
    outroStarted : false,
    isFromDailyPuzzle : false,
    outroShareButton : null,
    coverForFreeCoins2Popup: null,
    bgImg: null,
    bgImgScalingFactor: 1,
    fontColor: null,

    hide : function(){
        transOutroLayerV2.stopAllActions();
        transOutroLayerV2.removeAllChildren();
        transOutroLayerV2.outroStarted = false;
        utilObj.setVisible(transOutroLayerV2, false);
    },
    show: function (withAnim, params) {
        
        /**
         * Check Added so that if outro is called again.
         */
        if(transOutroLayerV2.outroStarted == false){
            transOutroLayerV2.outroStarted = true;
        } else {
            return ;
        }
        transOutroLayerV2.isFromDailyPuzzle = false; 
        transOutroLayerV2.showClaimText = false;

        transOutroLayerV2.screen = constantsObj.SCREEN_TRANS_OUTRO_LAYER;
        transOutroLayerV2.screenName = utilObj.getScreenName(constantsObj.SCREEN_TRANS_OUTRO_LAYER);
        // utilObj.updateScreenBegin(transOutroLayerV2.screen);
        utilObj.setVisible(transOutroLayerV2, true);

        gameObj.setisReview(true);
        gameObj.setIsOutroTransLayerOn(true);
       
        utilObj.hideBannerAd(utilObj.getScreenName(constantsObj.SCREEN_TRANS_OUTRO_LAYER));


        /**
         * Reward coins
         */
        var puzzletype = gameObj.getGridHeight();
        linearLevelObj.setPrevGridHeight(puzzletype); // Used to store it so as if coins were not added .

        transOutroLayerV2.levelCompleteReward = linearLevelObj.getLevelCompleteReward(puzzletype);//TODO :: RUNTIME VALUE
        linearLevelObj.setIsLevelCoinsAdded(false);
        // if(linearLevelObj.getEndOfCountryCase()){
        //     transOutroLayerV2.countryCompleteReward = linearLevelObj.getCountryCompleteReward() ;//TODO :: RUNTIME VALUE
        //     linearLevelObj.setIsCountryCoinsAdded(false);
        // }
        if(linearLevelObj.checkEndOfCountryCase()){
            transOutroLayerV2.countryCompleteReward = linearLevelObj.getCountryCompleteReward() ;//TODO :: RUNTIME VALUE
            linearLevelObj.setIsCountryCoinsAdded(false);
        }

        /**
         *  TO SHOW QUEST COMPLETION ANIMATION IF ANY QUEST IS COMPLETED
         */
        var animDelay = 0;
        if(questCenterObj.getQuestCenterVariant() == 1){
            if(questCenterObj.toShowQuestCompletionAnim()){
                
                var questobj = questCenterObj.getQuestToShow();
                if(questobj != null){
                    utilObj.showQuestCompleteAnimation(questobj.desc,questobj.icon,questobj.reward,questobj.id);
                    animDelay += 2;
                }
            }
        }

        var spriteArr = [];
        var labelArr = [];
        var zOrder = constantsObj.UI_Z_ORDER;

        transOutroLayerV2.puzzleId = gameObj.getCrosswordToShow();
        transOutroLayerV2.isMiniOrMidi = gameObj.checkForMiniOrMidi(transOutroLayerV2.puzzleId);
        
        // transOutroLayerV2.isDailyMini = gameObj.checkForDailyMini(transOutroLayerV2.puzzleId);
        transOutroLayerV2.isBritMini = gameObj.checkForBritMini(transOutroLayerV2.puzzleId);


        var xPos = centerXPos;
        var yPos = centerYPos;
        

        var scaleMul = 1.2;
        
        /**
         * First amazing gratification
         */
        var sub_text_rand_arr = [stringsObj.outro_sub_text2_rand1, stringsObj.outro_sub_text2_rand2, stringsObj.outro_sub_text2_rand3];
        var rand_value = utilObj.getRandomIntInRange(0, 2);
        var sub_text = sub_text_rand_arr[rand_value];
        
        if(linearLevelObj.getDtc2PuzzleCompleted() == 1){
            sub_text = sub_text_rand_arr[0];
        }

        var mainTextImage = constantsObj.amazing_gratification;

        var showMainText = utilObj.getSprite(mainTextImage, xPos, yPos + 100, 0.5, 0.5, constantsObj.SCALE_ONE * scaleMul, spriteArr, transOutroLayerV2, zOrder + 1, constantsObj.SPRITE_MISC);
        showMainText.setScale(0);
        var showMainTextDelay = 0.2;
        // animObj.outroAnimations(transOutroLayerV2, {
        //     case: constantsObj.OUTRO_MAIN_TEXT,
        //     node: showMainText,
        //     animDelay: animDelay,
        //     scale: constantsObj.SCALE_ONE * scaleMul,
        //     delay: showMainTextDelay
        // });
        transOutroLayerV2.gratifAnimation(showMainText , animDelay , constantsObj.SCALE_ONE * scaleMul ,showMainTextDelay );
        var arrForSecondAnim = [];

        animDelay += 0.15;
        /**
        * -> TransBackground placement , subtext ,outro_confetti animation
        */
        var outroUIData = transOutroLayerV2.getOutroUIData();
        transOutroLayerV2.bgImg = outroUIData.bg;
        transOutroLayerV2.bgImgScalingFactor = outroUIData.bgImgScale;
        transOutroLayerV2.fontColor = outroUIData.fontColor;
        transOutroLayerV2.transBg = utilObj.getSprite(transOutroLayerV2.bgImg, centerXPos, constantsObj.DESIGN_HEIGHT + topBarOffset, 0.5, 1.0, constantsObj.SCALE_SPRITE_NEW_1 * 0.667, spriteArr, transOutroLayerV2, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        var scaleWidth = canvasWidth / 1440;
        var scaleHeight = (constantsObj.DESIGN_HEIGHT + topBarOffset) / 2560;
        var toScale = (scaleWidth > scaleHeight ? scaleWidth : scaleHeight) * transOutroLayerV2.bgImgScalingFactor;
        utilObj.setScale(transOutroLayerV2.transBg, toScale);
        utilObj.setOpacity(transOutroLayerV2.transBg , constantsObj.OPACITY_0);
        
        transOutroLayerV2.fadeInNode(transOutroLayerV2.transBg , animDelay , 0 , constantsObj.OPACITY_100);
        arrForSecondAnim.push(transOutroLayerV2.transBg);

        // Display of the subtext
        
        var showSubtext = utilObj.getBMFontLabel(sub_text, constantsObj.FONT_HELVETICA_75, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - 100, 0.5, 0.5, labelArr, transOutroLayerV2, zOrder + 1);
        showSubtext.setOpacity(0);

        animDelay += 0.1;
        transOutroLayerV2.fadeInNode(showSubtext , animDelay , showMainTextDelay , constantsObj.OPACITY_100);

        animDelay += showMainTextDelay;

        var params1 = {
            case: constantsObj.OUTRO_CONFETTI_PLIST1,
            animDelay: animDelay - (showMainTextDelay / 2),
            x: xLeftPos - 100,
            y: yPos - 400,
            layer: transOutroLayerV2,
            scale: 1,
            zOrder: zOrder + 1,
            angle: 55,
            speed : 1000,
        };
        animObj.outroAnimations(transOutroLayerV2, params1);

        var params2 = {
            case: constantsObj.OUTRO_CONFETTI_PLIST2,
            animDelay: animDelay - (showMainTextDelay / 2),
            x: xRightPos + 100,
            y: yPos - 400,
            layer: transOutroLayerV2,
            scale: 1,
            zOrder: zOrder + 1,
            angle: 125,
            speed : 1000,
        };
        animObj.outroAnimations(transOutroLayerV2, params2);
        animDelay += 1;


        /**
        * Fading out the gartification main text and sub text
        */
        transOutroLayerV2.fadeOutNode(showMainText , animDelay , showMainTextDelay);
        
        transOutroLayerV2.fadeOutNode(showSubtext , animDelay , showMainTextDelay);

        animDelay += showMainTextDelay;


        /**
         * After First Anim 
         * Checking if it is mini or main and accordingly coin placement
        */
        // if(transOutroLayerV2.isMiniOrMidi){
        //     transOutroLayerV2.coinPlacementForMini(spriteArr , labelArr , zOrder , arrForSecondAnim);
        // } else {
        //     transOutroLayerV2.coinPlacementForMain(spriteArr , labelArr , zOrder , arrForSecondAnim);
        // }

        var setOpacityValue = constantsObj.OPACITY_100;
        for(var i=0; i<arrForSecondAnim.length; i++){
            utilObj.setOpacity(arrForSecondAnim[i] , constantsObj.OPACITY_0);
            transOutroLayerV2.fadeInNode(arrForSecondAnim[i] , animDelay , 0.15 ,setOpacityValue);
        }

        /**
         * Coin Increment fly anim
         */
        var coins_granted =  transOutroLayerV2.levelCompleteReward;
        // if(transOutroLayerV2.isMiniOrMidi){
        //
        //     var localYPos = constantsObj.DESIGN_HEIGHT - constantsObj.HEADER_HEIGHT / 2;
        //     localYPos -= 380;
        //     var localXPos = xRightPos;
        //     localXPos -= 200;
        //
        //     var coinGrantedText = utilObj.getBMFontLabel(" +" + coins_granted, constantsObj.FONT_HELVETICA_MEDIUM_100, constantsObj.COLOR_XP_YELLOW_LIGHT,
        //         constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos - 210, localYPos, 0.5, 0.5, labelArr, transOutroLayerV2, zOrder + 1);
        //     utilObj.setOpacity(coinGrantedText, constantsObj.OPACITY_0);
        //     arrForSecondAnim.push(coinGrantedText);
        //
        //     transOutroLayerV2.fadeInNode(coinGrantedText , animDelay , 0.2 ,constantsObj.OPACITY_100);
        //
        //     animDelay += 0.1;
        //     transOutroLayerV2.cashFly(coinGrantedText , animDelay , 0 , 150);
        //
        //     // transOutroLayerV2.showScoreIncrementAnim(transOutroLayerV2.coinMiniLabel, coins_granted, transOutroLayerV2.coinCount, animDelay,true);
        //
        //     trackObj.trackCounter(constantsObj.TRACK_DIALOG,  transOutroLayerV2.puzzleId, linearLevelObj.getDtc2PuzzleCompleted(), constantsObj.TRACK_LEVEL_COMPLETE_OUTRO, constantsObj.TRACK_COIN_ANIM, "", gameObj.getPuzzleSpeciesTracking(), "", "");
        //
        // } else {
        //
        //     var localXPos = xRightPos - 100;
        //     var btnHeight = constantsObj.HINTS_HEIGHT - 20;
        //     var yPos = btnHeight / 2;
        //     var offset = 30;
        //     var shiftInHints = 0;
        //     if (utilObj.getIsLikeIphoneX() && utilObj.isAndroid()) {
        //         shiftInHints = constantsObj.BOTTOM_BAR_OFFSET1 / 2;
        //     }
        //     var localYPos = yPos + offset - 10 + constantsObj.BOTTOM_BAR_OFFSET1 - shiftInHints;
        //
        //     var coinGrantedText = utilObj.getBMFontLabel(" +" + coins_granted, constantsObj.FONT_HELVETICA_MEDIUM_100, constantsObj.COLOR_XP_YELLOW_LIGHT,
        //         constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos, localYPos + 180, 0.5, 0.5, labelArr, transOutroLayerV2, zOrder + 1);
        //     utilObj.setOpacity(coinGrantedText, constantsObj.OPACITY_0);
        //     arrForSecondAnim.push(coinGrantedText);
        //
        //     transOutroLayerV2.fadeInNode(coinGrantedText , animDelay , 0.2 ,constantsObj.OPACITY_100);
        //
        //     animDelay += 0.1;
        //     transOutroLayerV2.cashFly(coinGrantedText , animDelay , 0 , -180);
        //
        //     // transOutroLayerV2.showScoreIncrementAnim(transOutroLayerV2.coinMainLabel, coins_granted, transOutroLayerV2.coinCount, animDelay , true);
        //
        //     trackObj.trackCounter(constantsObj.TRACK_DIALOG,  transOutroLayerV2.puzzleId, linearLevelObj.getDtc2PuzzleCompleted(), constantsObj.TRACK_LEVEL_COMPLETE_OUTRO, constantsObj.TRACK_COIN_ANIM, "", gameObj.getPuzzleSpeciesTracking(), "", "");
        //
        // }
        animDelay += 0.5;

        /**
         * showing the level completed and xp , coins gained animation
         */
        yPos = constantsObj.DESIGN_HEIGHT + topBarOffset - constantsObj.BEZEL_SAFE_AREA;
        yPos -= topBarOffset;
        var yOffset = 222;
        yPos -= yOffset;
        var yShift = 0;
        if (transOutroLayerV2.isMiniOrMidi) {
            yShift = 250;
        }
        yShift = 250;
        yPos -= yShift;
        
        animDelay += 0.2;

        var index = linearLevelObj.getDtc2PuzzleCompleted();
        var level_sub_text = "Level " + index;
        if(transOutroLayerV2.puzzleId != linearLevelObj.getClickedNodeId()){
            level_sub_text = "Daily Puzzle"
        }
        var showLevelText = utilObj.getBMFontLabel(level_sub_text, constantsObj.FONT_HELVETICA_80, transOutroLayerV2.fontColor,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, transOutroLayerV2, zOrder + 1);
        utilObj.setOpacity(showLevelText, constantsObj.OPACITY_0);
        
        transOutroLayerV2.fadeInNode(showLevelText , animDelay , showMainTextDelay , constantsObj.OPACITY_100);
        arrForSecondAnim.push(showLevelText);

        animDelay += 0.1;
        yPos -= 130;
        var completeLabel = "Completed!"
        var showCompletedText = utilObj.getBMFontLabel(completeLabel, constantsObj.FONT_HELVETICA_MEDIUM_100, transOutroLayerV2.fontColor,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, transOutroLayerV2, zOrder + 1);
        utilObj.setOpacity(showCompletedText, constantsObj.OPACITY_0);
        
        transOutroLayerV2.fadeInNode(showCompletedText , animDelay , showMainTextDelay , constantsObj.OPACITY_100);
        arrForSecondAnim.push(showCompletedText);

        yPos -= 200;
        yPos -= 600;

        /**
         *  XP Animation starts here
         */

        /**
         * Anim Ring
         */
        animDelay += 0.2;

        var bg1 = utilObj.getSprite(constantsObj.white_circle_300, xPos, yPos - 10, 0.5, 0.5,
            constantsObj.SCALE_SPRITE_1 /1.15, spriteArr, transOutroLayerV2, zOrder - 1, constantsObj.SPRITE_MISC);
        
        utilObj.setColor(bg1 , constantsObj.XP_RING_COLOR);
        utilObj.setOpacity(bg1 , constantsObj.OPACITY_0);
        arrForSecondAnim.push(bg1);

        transOutroLayerV2.fadeInNode(bg1 , animDelay , 0.2 , constantsObj.OPACITY_20);

        /**
         * Fading in the xp start and xpGrant
         */
        animDelay += 0.1;
        var xpStar= utilObj.getSprite(constantsObj.xp_png_2, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_1 * 0.2, spriteArr, transOutroLayerV2, zOrder + 1, constantsObj.SPRITE_MISC);
        utilObj.setOpacity(xpStar , constantsObj.OPACITY_0);
        arrForSecondAnim.push(xpStar);

        transOutroLayerV2.fadeInNode(xpStar , animDelay , 0.2 , constantsObj.OPACITY_100);

        var xpData = xpProgressionObj.getXpForOutro(); 
        var xp_granted = xpData.xpAbsoluteVal ;
        var xpGrantedText = utilObj.getBMFontLabel("+" + xp_granted, constantsObj.FONT_HELVETICA_MEDIUM_100, constantsObj.COLOR_XP_YELLOW_LIGHT,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 130, yPos + 250, 0.5, 0.5, labelArr, transOutroLayerV2, zOrder);
        var scaleToKeep = xpGrantedText.scale;
        utilObj.setScale(xpGrantedText , scaleToKeep * 0.2);
        utilObj.setOpacity(xpGrantedText , constantsObj.OPACITY_0);
        arrForSecondAnim.push(xpGrantedText);

        transOutroLayerV2.fadeInNode(xpGrantedText , animDelay , 0.2 , constantsObj.OPACITY_100);
        
        /**
         * Scaling up the xp star and xp count
         */
        animDelay += 0.1;

        scaleToKeep = xpGrantedText.scale;
        transOutroLayerV2.scaleNodeTo(xpGrantedText , animDelay , scaleToKeep * 5);

        /**
         * Scaling up and down the xp star
         */
        var initDelay = utilObj.getDelayTime(animDelay);
        var scaleUp = new cc.ScaleTo(0.2, constantsObj.SCALE_SPRITE_NEW_1 * 1.5).easing((cc.easeOut(1)));
        var scaleDown = new cc.ScaleTo(0.2, constantsObj.SCALE_SPRITE_NEW_1 * 1.3).easing((cc.easeOut(1)));
        var seq = new cc.Sequence([initDelay, scaleUp , scaleDown]);
        animObj.runAction(xpStar , seq);

        /**
         * Other Anim Rings are added
         */
        animDelay += 0.1;
        var bg2 = utilObj.getSprite(constantsObj.white_circle_300, xPos, yPos -10, 0.5, 0.5,
            constantsObj.SCALE_SPRITE_1 * 1.08, spriteArr, transOutroLayerV2, zOrder , constantsObj.SPRITE_MISC);
        
        utilObj.setColor(bg2 , constantsObj.XP_RING_COLOR);
        utilObj.setOpacity(bg2 , constantsObj.OPACITY_0);
        arrForSecondAnim.push(bg2);

        transOutroLayerV2.fadeInNode(bg2 , animDelay , 0.2 , constantsObj.OPACITY_15);

        animDelay += 0.1;
        var bg3 = utilObj.getSprite(constantsObj.white_circle_300, xPos, yPos - 10, 0.5, 0.5,
            constantsObj.SCALE_SPRITE_1 * 1.3, spriteArr, transOutroLayerV2, zOrder , constantsObj.SPRITE_MISC);

        utilObj.setColor(bg3 , constantsObj.XP_RING_COLOR);
        utilObj.setOpacity(bg3 , constantsObj.OPACITY_0);
        arrForSecondAnim.push(bg3);

        transOutroLayerV2.fadeInNode(bg3 , animDelay , 0.2 , constantsObj.OPACITY_10);

        /**
         * Wisdom Score 
         */
        animDelay += 0.3;
        var wisdomLabel = "Your wisdom score:"
        var wisdomText = utilObj.getBMFontLabel(wisdomLabel, constantsObj.FONT_HELVETICA_70, constantsObj.COLOR_XP_YELLOW,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - 300, 0.5, 0.5, labelArr, transOutroLayerV2, zOrder );
        utilObj.setOpacity(wisdomText, constantsObj.OPACITY_0);
        
        transOutroLayerV2.fadeInNode(wisdomText , animDelay , 0.2 , constantsObj.OPACITY_80);
        arrForSecondAnim.push(wisdomText);

        var wisdomScore = xpData.xpIntialValue;
        var wisdomScoreText = utilObj.getBMFontLabel(""+wisdomScore, constantsObj.FONT_HELVETICA_MEDIUM_200, constantsObj.COLOR_XP_YELLOW_LIGHT,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - 450, 0.5, 0.5, labelArr, transOutroLayerV2, zOrder + 1);
        utilObj.setOpacity(wisdomScoreText, constantsObj.OPACITY_0);

        transOutroLayerV2.fadeInNode(wisdomScoreText , animDelay , 0.2 , constantsObj.OPACITY_100);
        arrForSecondAnim.push(wisdomScoreText);

         /**
         * Moving the xpGrantedText 
         */
        animDelay += 0.2;
        var xpInitialX = xPos + 130;
        var xpInitialY = yPos + 250;
        var pointsArr = [];
        pointsArr.push({x: xpInitialX, y: xpInitialY});
        pointsArr.push({x: xpInitialX - 80, y: xpInitialY});
        pointsArr.push({x: xPos , y: yPos});

        var delayAction = utilObj.getDelayTime(animDelay);
        var scaleDown = new cc.ScaleTo(0.2, scaleToKeep * 4).easing((cc.easeOut(1)));
        var moveToAction = animObj.getCardinalSplineTo(0.5, pointsArr, 0.2).easing(new cc.easeIn(1.5));
        var spawnAction = cc.spawn([scaleDown , moveToAction]);
        animObj.runAction(xpGrantedText, animObj.getSequence([delayAction, spawnAction]));

        /**
         * Scaling up the xp star
         */
        animDelay += 0.4;
        var initDelay = utilObj.getDelayTime(animDelay);
        var scaleUp = new cc.ScaleTo(0.2, constantsObj.SCALE_SPRITE_NEW_1 * 1.6).easing((cc.easeOut(1)));
        var scaleDown = new cc.ScaleTo(0.2, constantsObj.SCALE_SPRITE_NEW_1 * 1.4).easing((cc.easeOut(1)));
        var seq = new cc.Sequence([initDelay, scaleUp , scaleDown]);
        animObj.runAction(xpStar , seq);

        /**
         * Incrementing the xp Gained score.
         */
        transOutroLayerV2.showScoreIncrementAnim(wisdomScoreText, xp_granted, wisdomScore, animDelay ,false);

        // XP TRACKING
        trackObj.trackCounter(constantsObj.TRACK_DIALOG,  transOutroLayerV2.puzzleId, linearLevelObj.getDtc2PuzzleCompleted(), constantsObj.TRACK_LEVEL_COMPLETE_OUTRO, constantsObj.TRACK_STAR_ANIM, wisdomScore + xp_granted, gameObj.getPuzzleSpeciesTracking(), "", "");

        // ---------------------------------------------------------------------------------

        /**
         *  Fading out the screen and the elements involved (removeTemporarySprites)
         */
        animDelay += 0.8;
        var animDelayTopFadeOut = 0.15;
        utilObj.delayedCallback(transOutroLayerV2, transOutroLayerV2.removeUsedSprites, animDelay, {spriteArr: arrForSecondAnim}, false);

        utilObj.delayedCallback(transOutroLayerV2, transOutroLayerV2.updateEconomyAfterLevel, animDelay,null, false);

        /**
         *  Progress Bar animation starts here
         *  -> Trans Background animation for progressBar animation
         */
        animDelay += arrForSecondAnim.length * animDelayTopFadeOut - 2.25 + 0.8;
        var lowerTransBgHeight = gameLayer.clueYOffset;
        var lowerTransBg = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, 0, 0.5, 0, canvasWidth, lowerTransBgHeight, spriteArr, transOutroLayerV2, zOrder, constantsObj.SPRITE_MISC);
        var lowerBgUIData = transOutroLayerV2.getLowerTransBgUIData();
        utilObj.setColor(lowerTransBg, lowerBgUIData.color);
        utilObj.setOpacity(lowerTransBg, constantsObj.OPACITY_0);
        transOutroLayerV2.lowerAnimArr.push(lowerTransBg);
        // var bgDelay = 0.15;

        // transOutroLayerV2.fadeInNode(lowerTransBg ,animDelay , bgDelay , constantsObj.OPACITY_90);

        /**
         * Mini Tile height Positioning
         */
       
        yPos = centerYPos - constantsObj.BOTTOM_BAR_OFFSET1;
        var tileHeight = 350;
        var tileWidth = 1230;
        var newX = lowerTransBg.getContentSize().width / 2;
        var newY = lowerTransBg.getContentSize().height / 2;
        // xPos, yPos - 750
        var miniTile = utilObj.getScale9Sprite(constantsObj.trans_button, newX, newY + 180, 0.5, 0.5, tileWidth, tileHeight, spriteArr, transOutroLayerV2, zOrder, constantsObj.SPRITE_MISC);
        transOutroLayerV2.lowerAnimArr.push(miniTile);

        var newX = miniTile.getContentSize().width / 2;
        var newY = miniTile.getContentSize().height / 2;
        var yShift = 25;

        // var progressBarBgWidth = 880;
        // var progressBarBg = utilObj.getScale9Sprite(constantsObj.tile_white, newX, newY + yShift, 0.5, 0.5, progressBarBgWidth , 60, spriteArr, miniTile, zOrder, constantsObj.SPRITE_MISC);
        // utilObj.setColor(progressBarBg , constantsObj.COLOR_PROGRESS_BAR_BG);
        // transOutroLayerV2.lowerAnimArr.push(progressBarBg);


        /**
         * Country Information
         * Fetching the country information for progress bar formation i.e. total no puzzles in a country and no of puzzles completed
         */

        /**
         * IF CONDITION TO CHECK IF CURR COUNTRY IS AVAILABE OR NOT  i.e for EOC case 
         * for eg agr if cur level is 56 then eoc case and no data for that will be found (where total country available is 55)
         */
        var curCountry  = linearLevelObj.getCurLevel();
        if(linearLevelObj.getCurLevel() <= linearLevelObj.getTotalNumberOfCountries()){
            // curCountry = linearLevelObj.getCurLevel();
            var curCountryInfo = linearLevelObj.getCurrentCountryInfo(curCountry);
            var totalPuzzles = curCountryInfo["pc"];    // ::  Get Total No of Puzzles in the particular country .
        }
        
        var totalPuzzlesCompleted = linearLevelObj.getDtc2PuzzleCompleted();    // :: Total number Of Puzzles completed through Out
        var puzzleCompletedInCountry = 0;   // :: this will carry toatl no puzzzles completed in a particular country (like a country has total 10 puzzles , then out of 10 how many are completed);

        /**
         * Check if Daily puzzle
         */
        var isDailyPuzzle = false;
        if(transOutroLayerV2.puzzleId != linearLevelObj.getClickedNodeId()){
            isDailyPuzzle = true;
        }

        /**
         * Once end of content is reached the progress bar of last country will be shown with full state
         */
        var spriteNextFlag = null;
        var assignFlag = false;
        var eocCountryFlag = false;
        if (curCountry < constantsObj.TOTAL_NUM_COUNTRIES || !curCountry || (linearLevelObj.checkEndOfCountryCase() && curCountry == constantsObj.TOTAL_NUM_COUNTRIES)) {
            assignFlag = true;
        } else if (curCountry >= constantsObj.TOTAL_NUM_COUNTRIES) {
            eocCountryFlag = true;
        }
        var newCountryLock = false;

        if (linearLevelObj.isEndOfContent()) {
            curCountry = linearLevelObj.getCurLevel();
            var previousCountryInfo = linearLevelObj.getCurrentCountryInfo(curCountry - 1);
            puzzleCompletedInCountry = previousCountryInfo["pc"];
            totalPuzzles = previousCountryInfo["pc"];
            transOutroLayerV2.currFlag = linearLevelObj.getFlagsMonumentsInfo(previousCountryInfo["cc"])["fV1"];
            transOutroLayerV2.countryCompleteName = previousCountryInfo["c"];

            // Since in End of content case EndOfCountry Case needs to be set false here , so as if there is no issue if puzzles are added in future
            // linearLevelObj.setEndOfCountryCase(false);
        }    
        else if (linearLevelObj.checkEndOfCountryCase() && !isDailyPuzzle) {
            // get previous country info and extract co;
            transOutroLayerV2.isCountryCompleted = true;
            var previousCountryInfo = linearLevelObj.getCurrentCountryInfo(curCountry - 1);
            puzzleCompletedInCountry = previousCountryInfo["pc"];
            totalPuzzles = previousCountryInfo["pc"];
            transOutroLayerV2.currFlag = linearLevelObj.getFlagsMonumentsInfo(previousCountryInfo["cc"])["fV1"];
            transOutroLayerV2.countryCompleteName = previousCountryInfo["c"];

            if (assignFlag) {
                var spriteNextFlagInfo = linearLevelObj.getCurrentCountryInfo(curCountry);
                spriteNextFlag = linearLevelObj.getFlagsMonumentsInfo(spriteNextFlagInfo["cc"])["fV1"];
                newCountryLock = true;
            }
            /**
             * Country Background image and newFlag for country unlock animation
             */
            transOutroLayerV2.countryBackgroundImage = linearLevelObj.getBackGroundPath(curCountryInfo["cc"]);
            transOutroLayerV2.newFlag =   linearLevelObj.getFlagsMonumentsInfo(curCountryInfo["cc"])["fV1"];
            transOutroLayerV2.unlockedCountryName = curCountryInfo["c"];

            transOutroLayerV2.showClaimText = true; // Because for the last puzzle of the country the outro text will be "claim";
            // linearLevelObj.setEndOfCountryCase(false); 

        } else if(!isDailyPuzzle) {
            puzzleCompletedInCountry = totalPuzzlesCompleted - (curCountryInfo["co"] - curCountryInfo["pc"]);
            transOutroLayerV2.currFlag = linearLevelObj.getFlagsMonumentsInfo(curCountryInfo["cc"])["fV1"];

            if (assignFlag) {
                var spriteNextFlagInfo = linearLevelObj.getCurrentCountryInfo(curCountry + 1);
                spriteNextFlag = linearLevelObj.getFlagsMonumentsInfo(spriteNextFlagInfo["cc"])["fV1"];
            }
            //:: REMOVE ONLY FOR TESTING PURPOSE
            // transOutroLayerV2.countryBackgroundImage = linearLevelObj.getBackGroundPath(curCountryInfo["cc"]);
            // if (totalPuzzlesCompleted + 1 == curCountryInfo["co"]) {
            //     linearLevelObj.setEndOfCountryCase(true);
            //     linearLevelObj.storeCountryInfo(curCountryInfo);
            // }
        }



        /**
         * Case to be checked whether daily puzzle is solved or not ,and accordingly the case is handled
         */
        // var isDailyPuzzle = false;
        // if(transOutroLayerV2.puzzleId != linearLevelObj.getClickedNodeId()){
        //     isDailyPuzzle = true;
        // }
        
        var fnName = "play";
        var outroText = "Next"
        var trackProgressButton = "";
        if(isDailyPuzzle){
            fnName = "continue";
            outroText = "Continue";
            trackProgressButton = constantsObj.TRACK_PROGRESS_CONTINUE;

            // var dailyPuzzleBtnBg = utilObj.getSprite(constantsObj.icon_holder_circle,  180 , newY + yShift - 30, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 / 1.42, spriteArr, miniTile, zOrder , constantsObj.SPRITE_MISC);
            // utilObj.setCascadeOpacityEnabled(dailyPuzzleBtnBg, true);
            // transOutroLayerV2.lowerAnimArr.push(dailyPuzzleBtnBg);

            // utilObj.getSprite(constantsObj.DAILY_CALLENDER, 120, 140, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_85 * 0.9, spriteArr, dailyPuzzleBtnBg, zOrder + 1, constantsObj.SPRITE_MISC);

            // var lockIcon = utilObj.getSprite(constantsObj.lock_quest, 250, newY + yShift - 100, 0.5, 0.5, constantsObj.SCALE_SPRITE_15 * 0.85, spriteArr, miniTile, zOrder , constantsObj.SPRITE_MISC);
            // transOutroLayerV2.lowerAnimArr.push(lockIcon);

            var newDailyPuzzleIcon = utilObj.getSprite(constantsObj.new_dp_icon, 180, newY + yShift - 30, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 , spriteArr, miniTile, zOrder + 1, constantsObj.SPRITE_MISC);
            transOutroLayerV2.lowerAnimArr.push(newDailyPuzzleIcon);
            var componentDp = utilObj.getButtonDimensions(345, 144, 140, 70);
            utilObj.setOpacity(newDailyPuzzleIcon, constantsObj.OPACITY_60);
            var lockIcon = utilObj.getSprite(constantsObj.new_dp_lock , newDailyPuzzleIcon.getContentSize().width / 2 , newDailyPuzzleIcon.getContentSize().height / 2 + 8, 0.5, 1, constantsObj.SCALE_SPRITE_NEW_1 / 3.5, spriteArr, newDailyPuzzleIcon, zOrder + 2, constantsObj.SPRITE_MISC);
            utilObj.setOpacity(lockIcon, constantsObj.OPACITY_100);
            transOutroLayerV2.lowerAnimArr.push(lockIcon);
        
            /**
             * getting next days detail.
             */
            var tomorrow = new Date();
            tomorrow.setDate(new Date().getDate()+1);
            loggerObj.debugLog("date 2:",tomorrow.getDate());

            // var currMonth = linearLevelObj.getCurrentMonth(tomorrow.getMonth());
            // var currDate = tomorrow.getDate();

            // var monthText = utilObj.getBMFontLabel(currMonth, constantsObj.FONT_HELVETICA_MEDIUM_25, constantsObj.COLOR_MIDNIGHT_BLUE,
            //     constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), 120, 169, 0.5, 0.5, labelArr, dailyPuzzleBtnBg, zOrder + 1);
    
            // var dateText = utilObj.getBMFontLabel(currDate, constantsObj.FONT_HELVETICA_MEDIUM_40, constantsObj.COLOR_WHITE,
            //     constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), 120, 120, 0.5, 0.5, labelArr, dailyPuzzleBtnBg, zOrder );

            var tommPuzzle = "Tomorrow's Puzzle"
            var tommPuzzleLabel = utilObj.getBMFontLabel(tommPuzzle, constantsObj.FONT_HELVETICA_70, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), newX + 50, newY + yShift + 30, 0.5, 0.5, labelArr, miniTile, zOrder );
            transOutroLayerV2.lowerAnimArr.push(tommPuzzleLabel);

            /**
             *  Function call for timer.
             */
            transOutroLayerV2.getTimer(tomorrow);
           
            // var unlockTime = ;
            transOutroLayerV2.unlockLabel = utilObj.getBMFontLabel("Unlocks in ", constantsObj.FONT_HELVETICA_70, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), newX + 60, newY + yShift - 80, 0.5, 0.5, labelArr, miniTile, zOrder );
            transOutroLayerV2.lowerAnimArr.push(transOutroLayerV2.unlockLabel);

        } else {
            fnName = "play";
            outroText = "Next";
            trackProgressButton = constantsObj.TRACK_PROGRESS_NEXT;
            if(transOutroLayerV2.showClaimText || linearLevelObj.isEndOfContent()){
                outroText = "Next";
                transOutroLayerV2.showClaimText = false;
                trackProgressButton = constantsObj.TRACK_PROGRESS_CLAIM;
            }

            var progressBarBgWidth = 880;
            var progressBarBg = utilObj.getScale9Sprite(constantsObj.tile_white, newX, newY + yShift, 0.5, 0.5, progressBarBgWidth, 60, spriteArr, miniTile, zOrder, constantsObj.SPRITE_MISC);
            utilObj.setColor(progressBarBg, constantsObj.COLOR_PROGRESS_BAR_BG);
            transOutroLayerV2.lowerAnimArr.push(progressBarBg);

            var puzzlesCompletedBefore = puzzleCompletedInCountry - 1; //  -1 becuase we need to get the total puzzles completed till now excluding the current solved one which will be shown using animation .
            var progressWidth = (puzzlesCompletedBefore / totalPuzzles) * progressBarBgWidth;

            // var puzzlesCompletedBefore = puzzleCompletedInCountry - 1; //  -1 becuase we need to get the total puzzles completed till now excluding the current solved one which will be shown using animation .
            // loggerObj.debugLog("info puzzles", puzzleCompletedInCountry, puzzlesCompletedBefore);
            // var progressWidth = (puzzlesCompletedBefore / totalPuzzles) * progressBarBgWidth;

            if (progressWidth == 0) {
                progressWidth = 1;
            }

            var progressBar = utilObj.getScale9Sprite(constantsObj.tile_white, newX - progressBarBgWidth / 2, newY + yShift , 0, 0.5, progressWidth, 60, spriteArr, miniTile, zOrder, constantsObj.SPRITE_MISC);
            utilObj.setColor(progressBar , constantsObj.COLOR_PROGRESS_BAR_BG);
            transOutroLayerV2.lowerAnimArr.push(progressBar);

            if (assignFlag) {
                var countryNodeBg1 = utilObj.getSprite(constantsObj.white_circle_150, newX + 490, newY + yShift, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 1.01, spriteArr, miniTile, zOrder, constantsObj.SPRITE_MISC);
                utilObj.setColor(countryNodeBg1, constantsObj.COLOR_WHITE);
                transOutroLayerV2.lowerAnimArr.push(countryNodeBg1);

                var countryNodeBlack1 = utilObj.getSprite(constantsObj.white_circle_150, newX + 490, newY + yShift, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.95, spriteArr, miniTile, zOrder, constantsObj.SPRITE_MISC);
                utilObj.setColor(countryNodeBlack1, constantsObj.COLOR_BLACK);
                transOutroLayerV2.lowerAnimArr.push(countryNodeBlack1);

                var flagSprite1 = utilObj.getSprite(spriteNextFlag, newX + 490, newY + yShift + 2.5, 0.5, 0.5, 1, spriteArr, miniTile, zOrder, constantsObj.SPRITE_FLAGS_V1);
                transOutroLayerV2.lowerAnimArr.push(flagSprite1);

                if (!newCountryLock) {
                    var countryNodeNew = utilObj.getSprite(constantsObj.white_circle_150, newX + 490, newY + yShift, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.9, spriteArr, miniTile, zOrder + 1, constantsObj.SPRITE_MISC);
                    utilObj.setColor(countryNodeNew, constantsObj.COLOR_BLACK);
                    utilObj.setOpacity(countryNodeNew, constantsObj.OPACITY_0);
                    // transOutroLayerV2.lowerAnimArr.push(countryNodeNew);
                    transOutroLayerV2.fadeInNode(countryNodeNew, animDelay, 0.1, constantsObj.OPACITY_50);

                    var flagSprite3 = utilObj.getSprite(constantsObj.lock_png, newX + 490, newY + yShift + 2.5, 0.5, 0.5, 1, spriteArr, miniTile, zOrder, constantsObj.SPRITE_FLAGS_V1);
                    transOutroLayerV2.lowerAnimArr.push(flagSprite3);
                    utilObj.setColor(flagSprite3, constantsObj.COLOR_WHITE);
                }
            } else if (eocCountryFlag) {
                var eocImg = utilObj.getSprite(constantsObj.eoc_img, newX + 490, newY + yShift, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.28, spriteArr, miniTile, zOrder, constantsObj.SPRITE_MISC);
                transOutroLayerV2.lowerAnimArr.push(eocImg);
            }

            var countryNodeBg = utilObj.getSprite(constantsObj.white_circle_150, newX - 500, newY + yShift, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 1.01  , spriteArr, miniTile, zOrder, constantsObj.SPRITE_MISC);
            utilObj.setColor(countryNodeBg ,constantsObj.COLOR_WHITE);
            transOutroLayerV2.lowerAnimArr.push(countryNodeBg);

            var countryNodeBlack = utilObj.getSprite(constantsObj.white_circle_150, newX - 500, newY + yShift, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.95, spriteArr, miniTile, zOrder, constantsObj.SPRITE_MISC);
            utilObj.setColor(countryNodeBlack ,constantsObj.COLOR_BLACK);
            transOutroLayerV2.lowerAnimArr.push(countryNodeBlack);

            var flagSprite = utilObj.getSprite(transOutroLayerV2.currFlag, newX - 500, newY + yShift + 2.5 , 0.5, 0.5, 1, spriteArr, miniTile, zOrder, constantsObj.SPRITE_FLAGS_V1);
            transOutroLayerV2.lowerAnimArr.push(flagSprite);

            /**
             * Puzzle completed pointer
             * Need to show animation for before and after puzzle completion
             */

            // var pointerText = "";
            // var puzzlesToComplete = totalPuzzles - puzzlesCompletedBefore;
            // pointerText = puzzlesToComplete + " puzzles to go!";
            // if(puzzlesToComplete == 1){
            //     pointerText =  puzzlesToComplete + " puzzle to go!";
            // }

            // if (puzzlesToComplete == 0 && isDailyPuzzle) {
            //     pointerText = "Complete!"
            // }

            // var localXPos = newX - progressBarBgWidth / 2;
            // var pointerTile = utilObj.getSprite(constantsObj.pointer_holder, localXPos + progressWidth - 12, newY + yShift - 105, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.9, spriteArr, miniTile, zOrder + 1, constantsObj.SPRITE_MISC);
            // utilObj.setScaleX(pointerTile , pointerTile.scale * 1.2);
            // // utilObj.setScaleY(pointerTile , pointerTile.scale * 0.8)
            // transOutroLayerV2.lowerAnimArr.push(pointerTile);
            // var pointerTextLabel = utilObj.getBMFontLabel(pointerText, constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_BLACK,
            //     constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + progressWidth - 10, newY + yShift - 115, 0.5, 0.5, labelArr, miniTile, zOrder + 1);
            // transOutroLayerV2.lowerAnimArr.push(pointerTextLabel);

        }
            var setOpacityValue = constantsObj.setOpacity_100;
            var lowerBgOpacity = lowerBgUIData.opacity;
            for(var i = 0; i<transOutroLayerV2.lowerAnimArr.length ; i++){
                utilObj.setOpacity(transOutroLayerV2.lowerAnimArr[i] , constantsObj.OPACITY_0);

                if(transOutroLayerV2.lowerAnimArr[i] == lowerTransBg){
                    setOpacityValue = lowerBgOpacity;
                }
                if(transOutroLayerV2.lowerAnimArr[i] == miniTile){
                    setOpacityValue = constantsObj.OPACITY_40;
                }
                if(transOutroLayerV2.lowerAnimArr[i] == progressBarBg){
                    setOpacityValue = constantsObj.OPACITY_20;
                }
                if(transOutroLayerV2.lowerAnimArr[i] == progressBar){
                    setOpacityValue = constantsObj.OPACITY_100;
                }
                if(transOutroLayerV2.lowerAnimArr[i] == tommPuzzleLabel){
                    setOpacityValue = constantsObj.OPACITY_50;
                }
                if(transOutroLayerV2.lowerAnimArr[i] == transOutroLayerV2.unlockLabel || transOutroLayerV2.lowerAnimArr[i] == lockIcon){
                    setOpacityValue = constantsObj.OPACITY_100;
                }
                // if(transOutroLayerV2.lowerAnimArr[i] == dailyPuzzleBtnBg){
                //     setOpacityValue = constantsObj.OPACITY_60;
                // }
                transOutroLayerV2.fadeInNode(transOutroLayerV2.lowerAnimArr[i] , animDelay , 0.1 ,setOpacityValue);
            }
        
        if(!isDailyPuzzle){
            // Progress Bar animation
            animDelay += 0.5;
            var newWidth = (puzzleCompletedInCountry / totalPuzzles) * progressBarBgWidth;
            var sy = 1;
            var delayAction = animObj.getDelayTime(animDelay);

            var scaleAction = animObj.getScaleDifferentTo(0.5, newWidth / progressWidth, sy);
            var actions = [delayAction, scaleAction];
            animObj.runAction(progressBar, animObj.getSequence(actions));

            /**
             * Fading out the previous pointer
             */
            // transOutroLayerV2.fadeOutNode(pointerTile , animDelay , 0.1);
            
            // transOutroLayerV2.fadeOutNode(pointerTextLabel , animDelay , 0.1);

            /**
             * Formation of new pointer and with fading in animation
             */
            var pointerArr = [];
            var pointerText2 = "";
            var puzzlesToComplete2 = totalPuzzles - puzzleCompletedInCountry;
            var isFull = false;
            pointerText2 =  puzzlesToComplete2 + " puzzles to go!";
            if(puzzlesToComplete2 == 1){
                pointerText2 = puzzlesToComplete2 + " puzzle to go!";
            }else if (puzzlesToComplete2 == 0) {
                if (linearLevelObj.getIsEocUser()) {
                    pointerText2 = "Complete!";
                } else {
                    pointerText2 = "Unlocked!";
                }
                isFull = true;
            }
            var localXPos = newX - progressBarBgWidth / 2;
            var xShift = 0;
            // var pointerTile2 = utilObj.getSprite(constantsObj.pointer_holder, localXPos + newWidth - 12, newY + yShift - 105, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.9, spriteArr, miniTile, zOrder + 1, constantsObj.SPRITE_MISC);
            // utilObj.setScaleX(pointerTile2 ,  pointerTile2.scale * 1.2);
            // // utilObj.setScaleY(pointerTile2 , pointerTile2.scale * 0.8);
            // pointerArr.push(pointerTile2);
            // pointerTile2.setOpacity(0);
            // transOutroLayerV2.lowerAnimArr.push(pointerTile2);

            // var pointerTextLabel2 = utilObj.getBMFontLabel(pointerText2, constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_BLACK,
            //     constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + newWidth - 10, newY + yShift - 115, 0.5, 0.5, labelArr, miniTile, zOrder + 1);
            // pointerArr.push(pointerTextLabel2);
            // pointerTextLabel2.setOpacity(0);
            // transOutroLayerV2.lowerAnimArr.push(pointerTextLabel2);

            /**
             * New flow for pointer and puzzles to go
             */
            if(totalPuzzles >= 20 && puzzleCompletedInCountry <= 4){
                xShift = 145;
                
            }else if(puzzleCompletedInCountry <=2){
                xShift = 110;
                if(totalPuzzles <= 5 && puzzleCompletedInCountry >1){
                    xShift = 0;
                }
            }

            var yPosShift = 0;
            var xPosShift = 0;
            if (isFull && assignFlag) {
                yPosShift = 50;
                xPosShift = 35;
            }

            var pointerArrow = utilObj.getSprite(constantsObj.level_pointer, localXPos + newWidth + xPosShift , newY + yShift - 50 - yPosShift, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1, spriteArr, miniTile, zOrder + 1, constantsObj.SPRITE_MISC);
            pointerArr.push(pointerArrow);
            pointerArrow.setOpacity(0);
            transOutroLayerV2.lowerAnimArr.push(pointerArrow);

            var pointerTile2 = utilObj.getSprite(constantsObj.progress_container, localXPos + newWidth + xShift + xPosShift, newY + yShift - 120 - yPosShift, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 , spriteArr, miniTile, zOrder + 1, constantsObj.SPRITE_MISC);
            var pointerScale = pointerTile2.scale;
            utilObj.setScaleX(pointerTile2 ,  pointerScale * 1.14);
            utilObj.setScaleY(pointerTile2 , pointerScale * 0.8);
            pointerArr.push(pointerTile2);
            pointerTile2.setOpacity(0);
            transOutroLayerV2.lowerAnimArr.push(pointerTile2);
            
            var pointerTextLabel2 = utilObj.getBMFontLabel(pointerText2, constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + newWidth + xShift + xPosShift, newY + yShift - 115 - yPosShift, 0.5, 0.5, labelArr, miniTile, zOrder + 1);
            pointerArr.push(pointerTextLabel2);
            pointerTextLabel2.setOpacity(0);
            transOutroLayerV2.lowerAnimArr.push(pointerTextLabel2);
            
            animDelay += 0.7;
            for (var i = 0; i < pointerArr.length; i++) {
                transOutroLayerV2.fadeInNode(pointerArr[i] , animDelay , 0.25 , constantsObj.OPACITY_100);
            }
        }

        // buttons ui
        yPos = 180 + constantsObj.BOTTOM_BAR_OFFSET1;
        var btnWidth = 600;
        var btnHeight = 200;
        var shiftFromCenter = 328;
        animDelay += 0.5;

        // share button
        transOutroLayerV2.outroShareButton = utilObj.getButton(btnWidth, btnHeight, 0.5, 0.5, centerXPos - shiftFromCenter, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
            obj: 'transOutroLayerV2',
            fn: 'share',
            track: {
                k: constantsObj.TRACK_DIALOG,
                p: transOutroLayerV2.puzzleId,
                c: linearLevelObj.getDtc2PuzzleCompleted(),
                o: constantsObj.TRACK_OUTRO_REVIEW,
                f: trackProgressButton,
                g: "",
                s: gameObj.getPuzzleSpeciesTracking(),
                co: 1,
                oppId: ""
            },
            screen: gameLayer.screen,
            feedBackType: constantsObj.GREY_EFFECT,
        }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(transOutroLayerV2, transOutroLayerV2.outroShareButton, zOrder + 1);

        var btnDim = utilObj.getButtonDimensions(208, 159, btnWidth, btnHeight);
        var btnImage = utilObj.getScale9Sprite(constantsObj.button_outline_shadow_d2, btnWidth/2, btnHeight/2, 0.5, 0.5, btnDim.width, btnDim.height, spriteArr, transOutroLayerV2.outroShareButton, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setScale(btnImage, btnDim.scale);

        var shareText = utilObj.getBMFontLabel(stringsObj.outro_share, constantsObj.FONT_HELVETICA_MEDIUM_107, constantsObj.WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), btnWidth / 2, btnHeight / 2, 0.5, 0.39, labelArr, transOutroLayerV2.outroShareButton, zOrder);

        var shareBtnElements = [btnImage, transOutroLayerV2.outroShareButton, shareText];
        transOutroLayerV2.lowerAnimArr = transOutroLayerV2.lowerAnimArr.concat(shareBtnElements);
        utilObj.setCascadeOpacityEnabled(transOutroLayerV2.outroShareButton, true);
        utilObj.setOpacity(transOutroLayerV2.outroShareButton, 0);
        utilObj.setVisible(transOutroLayerV2.outroShareButton, false);

        utilObj.delayedCallback(transOutroLayerV2, transOutroLayerV2.showOutroShareButton, animDelay, null, false);

        /**
         * Play Next buttom ui and animation from here
         */
        transOutroLayerV2.playButtonGreen = utilObj.getButton(btnWidth, btnHeight, 0.5, 0.5, centerXPos + shiftFromCenter, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
            obj: 'transOutroLayerV2',
            fn : fnName,
            track: {
                k: constantsObj.TRACK_DIALOG,
                p: transOutroLayerV2.puzzleId,
                c: linearLevelObj.getDtc2PuzzleCompleted(),
                o: constantsObj.TRACK_OUTRO_REVIEW,
                f: trackProgressButton,
                g: "",
                s: gameObj.getPuzzleSpeciesTracking(),
                co: 1,
                oppId: ""
            },
            screen: gameLayer.screen,
            feedBackType: constantsObj.GREY_EFFECT,
        },false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(transOutroLayerV2, transOutroLayerV2.playButtonGreen, zOrder + 1);

        var btnArr = utilObj.getRoundedButton(btnWidth/2, btnHeight/2, btnWidth, btnHeight, spriteArr, transOutroLayerV2.playButtonGreen, zOrder, constantsObj.COLOR_PRIMARY_BTN , 1);

        var playText = utilObj.getBMFontLabel(outroText, constantsObj.FONT_HELVETICA_MEDIUM_107, constantsObj.WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), btnWidth/2, btnHeight/2, 0.5, 0.39, labelArr, transOutroLayerV2.playButtonGreen, zOrder);

        utilObj.pulseButton(transOutroLayerV2.playButtonGreen, constantsObj.PULSE_ACTION_TAG, 0);

        transOutroLayerV2.lowerAnimArr.push(transOutroLayerV2.playButtonGreen);
        transOutroLayerV2.lowerAnimArr = transOutroLayerV2.lowerAnimArr.concat(btnArr);
        transOutroLayerV2.lowerAnimArr.push(playText);

        transOutroLayerV2.playButtonGreen.setCascadeOpacityEnabled(true);
        utilObj.setOpacity(transOutroLayerV2.playButtonGreen, 0);
        utilObj.setVisible(transOutroLayerV2.playButtonGreen, false);
        
        utilObj.delayedCallback(transOutroLayerV2, transOutroLayerV2.showPlayButton, animDelay, null, false);

        trackObj.trackCounter(constantsObj.TRACK_DIALOG, transOutroLayerV2.puzzleId, linearLevelObj.getDtc2PuzzleCompleted(), constantsObj.TRACK_OUTRO_REVIEW, constantsObj.TRACK_VIEW, "", gameObj.getPuzzleSpeciesTracking(), "", "");

        transOutroLayerV2.coverForFreeCoins2Popup = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, 0, 0.5, 0, canvasWidth, lowerTransBgHeight , spriteArr, transOutroLayerV2, zOrder + 1, constantsObj.SPRITE_MISC);
        utilObj.setColor(transOutroLayerV2.coverForFreeCoins2Popup , constantsObj.COLOR_BLACK)
        utilObj.setOpacity(transOutroLayerV2.coverForFreeCoins2Popup , constantsObj.OPACITY_50);
        utilObj.setVisible(transOutroLayerV2.coverForFreeCoins2Popup, false);
        
        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);
        // utilObj.updateScreen(transOutroLayerV2.screen, transOutroLayerV2);

    },

    updateEconomyAfterLevel : function(){
        economyObj.addCash(transOutroLayerV2.levelCompleteReward ,constantsObj.TRACK_EARN , constantsObj.TRACK_PUZZLE_SOLVED , constantsObj.TRACK_LEVEL_COMPLETE_OUTRO);
        linearLevelObj.setIsLevelCoinsAdded(true);
    },
    updateEconomyAfterCountry : function(){
        var trackCountryCompletedNumber = linearLevelObj.getCurLevel() - 1;
        economyObj.addCash(transOutroLayerV2.countryCompleteReward ,constantsObj.TRACK_EARN , constantsObj.TRACK_COUNTRY_COMPLETE , trackCountryCompletedNumber);
        linearLevelObj.setIsCountryCoinsAdded(true);

    },
    /**
     * coin placement on top right for minis  
     * NOTE : Whenever if change in coin placement position  is made ,REMEMBER to change the final positions in their respective COIN TRAILS
     */
    coinPlacementForMini : function(spriteArr , labelArr , zOrder , arrToStoreSprite){
        var localYPos = constantsObj.DESIGN_HEIGHT - constantsObj.HEADER_HEIGHT / 2;
        localYPos -= 225;
        var localXPos = xRightPos;
        localXPos -= 200;

        var coinMiniBg = utilObj.getScale9Sprite(constantsObj.tile_white_curved_2, localXPos - 350 , localYPos, 0, 0.5, 300, 80, spriteArr, transOutroLayerV2, zOrder + 1, constantsObj.SPRITE_MISC);
        utilObj.setColor(coinMiniBg, constantsObj.COLOR_BLACK);
        utilObj.setOpacity(coinMiniBg, constantsObj.OPACITY_50);
        var coinMiniImage = utilObj.getSprite(constantsObj.coin_png_3, localXPos - 350, localYPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_9 * 0.9, spriteArr, transOutroLayerV2, zOrder + 1, constantsObj.SPRITE_MISC);
        transOutroLayerV2.coinCount = economyObj.getCash();
        transOutroLayerV2.coinMiniLabel = utilObj.getBMFontLabel(transOutroLayerV2.coinCount + "", constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos - 210, localYPos, 0.5, 0.5, labelArr, transOutroLayerV2, zOrder + 2);
        var plusImg = utilObj.getSprite(constantsObj.green_plus, localXPos - 100, localYPos, 0, 0.5, constantsObj.SCALE_SPRITE_1, spriteArr, transOutroLayerV2, zOrder + 1, constantsObj.SPRITE_MISC);

        arrToStoreSprite.push(coinMiniBg);
        arrToStoreSprite.push(coinMiniImage);
        arrToStoreSprite.push(plusImg);
        arrToStoreSprite.push(transOutroLayerV2.coinMiniLabel);
    },
    /**
     * coin placement on bottom right  for mains
     *  NOTE : Whenever if change in coin placement position  is made ,REMEMBER to chamge the final positions in their respective COIN TRAILS
     */
    coinPlacementForMain : function(spriteArr , labelArr , zOrder , arrToStoreSprite){
        var localXPos = xRightPos - 100;
        var btnHeight = constantsObj.HINTS_HEIGHT - 20;
        var yPos = btnHeight / 2;
        var offset = 30;
        var shiftInHints = 0;
        if (utilObj.getIsLikeIphoneX() && utilObj.isAndroid()) {
            shiftInHints = constantsObj.BOTTOM_BAR_OFFSET1 / 2;
        }
        var localYPos = yPos + offset - 10 + constantsObj.BOTTOM_BAR_OFFSET1 - shiftInHints;

        var coinMainImage = utilObj.getSprite(constantsObj.coin_png_3, localXPos + 6.66, localYPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_2* 0.9, spriteArr, transOutroLayerV2, zOrder + 1, constantsObj.SPRITE_MISC);
        transOutroLayerV2.coinCount = economyObj.getCash();
        var fontForCoin = constantsObj.FONT_HELVETICA_50;
        if( transOutroLayerV2.coinCount > 9999){
            fontForCoin = constantsObj.FONT_HELVETICA_40;
        }
        transOutroLayerV2.coinMainLabel = utilObj.getBMFontLabel(transOutroLayerV2.coinCount + "", fontForCoin, constantsObj.COLOR_WHITE,
        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos, localYPos - 70, 0.5, 0.5, labelArr, transOutroLayerV2, zOrder + 1);

        arrToStoreSprite.push(coinMainImage);
        arrToStoreSprite.push(transOutroLayerV2.coinMainLabel);

           
    },
    continue : function(){
        
        clearInterval(transOutroLayerV2.timerfunc); // clear interval function called to stop the timer.
        transOutroLayerV2.isFromDailyPuzzle = true;
        transOutroLayerV2.showAd();

        // gameObj.setisReview(false);
        // gameObj.setIsOutroTransLayerOn(false);
        // transOutroLayerV2.hide();
        // gameLayer.hide();
        // linearLevelProgression.show();
    },

    play : function(){

        /**
         * showing the save progress popup for the first time
         * EDIT 1: removing save progress popup
         */
        // if (!gameObj.getLoginPopupShown()) {
        //     saveProgressPopup.show();
        //     return;
        // }
        /**
         * Removing the lower Ui (Progress Bar)
         */
        var animDelay = 0;
        utilObj.delayedCallback(transOutroLayerV2, transOutroLayerV2.removeUsedSprites, animDelay, {spriteArr: transOutroLayerV2.lowerAnimArr}, false);
        /**
         * If it is endOfContent case then direct it to map screen
         */
        // if(linearLevelObj.isEndOfContent()){
        //     gameObj.setisReview(false);
        //     gameObj.setIsOutroTransLayerOn(false);
        //     transOutroLayerV2.hide();
        //     gameLayer.hide();
        //     linearLevelProgression.show();
        //     return;
        // }
        /**
         *  if Country is completed the flow is -> giftBoxAnimation -> ad ->countryUnlockAnimation -> intro for next Puzzle
         *  else flow is -> ad - > intro for the next puzzle
         */

        if(transOutroLayerV2.isCountryCompleted || linearLevelObj.isEndOfContent()){
           
            if(utilObj.isWeb()){
                // Updating the coins after country completion.
                utilObj.delayedCallback(transOutroLayerV2, transOutroLayerV2.updateEconomyAfterCountry, animDelay,null, false);

                transOutroLayerV2.isCountryCompleted = false;
                transOutroLayerV2.countryUnlockAnimation();
                var delay = transOutroLayerV2.delayForCountryUnlockAnim ;
                delay += 1;
                utilObj.delayedCallback(transOutroLayerV2, transOutroLayerV2.goToNextPuzzle, delay, null, false);
            }else{
                // transOutroLayerV2.showCountryCompleteAnimation();
                transOutroLayerV2.countryCompleteAd = true;
                var delay = 0;
                utilObj.delayedCallback(transOutroLayerV2,  transOutroLayerV2.showAd, delay,null ,false);

                // ad
                // var toShowAd = true;
                // if(toShowAd){
                //     transOutroLayerV2.countryCompleteAd = true;
                //     loggerObj.debugLog("hello show ad caled after country complete");
                //     var delay = transOutroLayerV2.delayForCountryCompleteAnim ;
                //     utilObj.delayedCallback(transOutroLayerV2,  transOutroLayerV2.showAd, delay,null ,false);

                // }else{
                //     utilObj.delayedCallback(transOutroLayerV2, transOutroLayerV2.countryUnlockAnimation, transOutroLayerV2.delayForCountryCompleteAnim);
                //     var delay = transOutroLayerV2.delayForCountryUnlockAnim + transOutroLayerV2.delayForCountryCompleteAnim + 2;
                //     utilObj.delayedCallback(transOutroLayerV2, transOutroLayerV2.goToNextPuzzle, delay, null, false);
                // }
            }

         } else{
            transOutroLayerV2.showAd();
         }
    },
    /**
     *  Function redirects to the intro-gameLayer of next puzzle.
     */
    goToNextPuzzle : function(params){

        gameObj.setisReview(false);
        gameObj.setIsOutroTransLayerOn(false);
        transOutroLayerV2.hide();
        gameLayer.hide();

        if(linearLevelObj.isEndOfContent()){
            linearLevelProgression.show();
            return;
        }

        if(transOutroLayerV2.isFromDailyPuzzle){
            transOutroLayerV2.isFromDailyPuzzle = false;
            linearLevelProgression.show();
            return ;
        }

        if(linearLevelObj.canShowDailyPuzzleFtue()){
            linearLevelProgression.show();
            return;
        }

        //new puzzle called
        var index = linearLevelObj.getDtc2PuzzleCompleted();
        var gameId = linearLevelObj.getPuzzleIdLlp(index);
        linearLevelObj.setClickedNodeId(gameId);
        gameLayer.show(gameId);
    },
    /**
     * Is a callback function called from java side when ad is dismissed or when no ad is found called from this layer only.
     * Handles the case when country is complete -> shows contry unlock animation and redirect to next puzzle.
     */
    afterAdDismiss : function(){

        /**
         * when isEndOfContent condtion is true no need for country unlock animation
         */
        if(!linearLevelObj.isEndOfContent() && transOutroLayerV2.isCountryCompleted){
            
            transOutroLayerV2.countryUnlockAnimation();
            var delay = transOutroLayerV2.delayForCountryUnlockAnim ;
            delay += 0;
            transOutroLayerV2.isCountryCompleted = false;

            utilObj.delayedCallback(transOutroLayerV2, transOutroLayerV2.goToNextPuzzle, delay, {callShowAd : false}, false);
        }else{
            
            utilObj.delayedCallback(transOutroLayerV2, transOutroLayerV2.goToNextPuzzle); // delay, {callShowAd : false}, false);
        }
        
    },
    showPlayButton : function(){
        transOutroLayerV2.fadeInNode(transOutroLayerV2.playButtonGreen, 0 ,0.25 );
        utilObj.delayedCallback(transOutroLayerV2,transOutroLayerV2.visiblePlayButton , 0.1 , null, false);
    },

    visiblePlayButton : function(){
        utilObj.setVisible(transOutroLayerV2.playButtonGreen, true);
    },

    showOutroShareButton : function(){
        transOutroLayerV2.fadeInNode(transOutroLayerV2.outroShareButton, 0 ,0.25 );
        utilObj.delayedCallback(transOutroLayerV2,transOutroLayerV2.visibleOutroShareButton , 0.1 , null, false);
    },

    visibleOutroShareButton : function(){
        utilObj.setVisible(transOutroLayerV2.outroShareButton, true);
    },

    /**
     *  Used to remove the sprites which have already been used in the animation flow.
     */
    removeUsedSprites : function (sender, params) {
        var spritesToRemove = params.spriteArr;
        var fadeOutDur = 0.15;
        if (params.fadeDur) {
            fadeOutDur = params.fadeDur;
        }
        for (var i in spritesToRemove) {
            if (utilObj.isNodeValid(spritesToRemove[i])) {
                var fadeOut = utilObj.getFadeOut(fadeOutDur);
                var remove = utilObj.getIndependentRemoveSelf();
                var animArr = [fadeOut, remove];
                animObj.runAction(spritesToRemove[i], utilObj.getSequence(animArr));
            }
        }
        return fadeOutDur;
    },
    /**
     *  Fade in animation on a node.
     */
    fadeInNode: function (node, animdelay, delay ,opacity) {
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        var initdelay = utilObj.getDelayTime(animdelay);
        var fadeIn = utilObj.getFadeIn(delay).easing(cc.easeIn(1));
        if (opacity != undefined) {
            fadeIn = utilObj.getFadeTo(delay, opacity).easing(cc.easeIn(1));
        }
        var animArr = [];
        animArr.push(initdelay);
        animArr.push(fadeIn);
        animObj.runAction(node, utilObj.getSequence(animArr));
    },
    /**
     * Fade out animation on a node.
     */
    fadeOutNode : function(node , animDelay , delay){
        if(!utilObj.isNodeValid(node)){
            return ;
        }
        
        var initDelay = utilObj.getDelayTime(animDelay);
        var fadeOut = utilObj.getFadeTo(delay / 2, 0).easing(new cc.easeIn(1.0));
        var seq = new cc.Sequence([initDelay, fadeOut]);
        animObj.runAction(node, seq);
    },
    /**
     * scale animation on a node (node is scaled to passed scale).
     */  
    scaleNodeTo : function(node , animDelay , scaleTo ,duration){
        if(!utilObj.isNodeValid(node)){
            return ;
        }

        var initDelay = utilObj.getDelayTime(animDelay);
        if(duration == undefined){
            duration = 0.1;
        }
        var scaleOut = new cc.ScaleTo(duration, scaleTo).easing((cc.easeOut(1)));
        var seq = new cc.Sequence([initDelay, scaleOut]);
        animObj.runAction(node , seq);

    },
    /**
     *  Animation to scale and move a node simultaneously.
     */
    scaleAndMoveNode : function(node , animDelay , scaleTo , moveDuration , deltaX , deltaY){
        if(!utilObj.isNodeValid(node)){
            return ;
        }

        var actions = [];
        var delayInit = utilObj.getDelayTime(animDelay);
        actions.push(delayInit);
        var moveTo = utilObj.getMoveBy(moveDuration, deltaX, deltaY);
        actions.push(moveTo);
        var scale1 = new cc.ScaleTo(0.2, scaleTo).easing((cc.easeOut(1)));
        actions.push(scale1)
        var seq = animObj.getSequence(actions, false);
        node.runAction(seq);
    },
    /**
     * Animation to replace nodes text with another.
     */
    replaceNodeText : function(node , animDelay ,str){
        if(!utilObj.isNodeValid(node)){
            return ;
        }

        var actions = [];
        var delayInit = utilObj.getDelayTime(animDelay);
        actions.push(delayInit);
        var params = {
            n: node,
            cA: str
        };
        var callFunc = utilObj.getCallFunc(transOutroLayerV2.updateNodeString, transOutroLayerV2, params);
        // var delay1 = utilObj.getDelayTime(0.12);
        // var moveTo = utilObj.getMoveBy(0.12, 100, 0);
        actions.push(callFunc);
        // actions.push(delay1);
        // actions.push(moveTo);
        var seq = animObj.getSequence(actions, false);
        node.runAction(seq);

    },
    updateNodeString : function (sender, params) {
        utilObj.setString(params.n, (params.cA) + "");
    },
    /**
     * Anim to move node , by passing the magnitude to move .
     */
    moveNodeByAnim : function(node , animDelay , moveDuration , deltaX , deltaY){
        if(!utilObj.isNodeValid(node)){
            return ;
        }

        var actions = [];
        var delayInit = utilObj.getDelayTime(animDelay);
        actions.push(delayInit);
        var moveTo = utilObj.getMoveBy(moveDuration, deltaX, deltaY);
        actions.push(moveTo);
        var seq = animObj.getSequence(actions, false);
        node.runAction(seq);
    },

    cashFly : function(node , animDelay , deltaX , deltaY){
        return;
        if(!utilObj.isNodeValid(node)){
            return ;
        }

        var delayInit = utilObj.getDelayTime(animDelay);
        var moveTo = utilObj.getMoveBy(1, deltaX, deltaY);
        var fadeOut = utilObj.getFadeTo(1, 0).easing(new cc.easeIn(1.0));
        var spawnAction = cc.spawn([moveTo, fadeOut ]);
        animObj.runAction(node, animObj.getSequence([delayInit, spawnAction]));
    },

    gratifAnimation : function(node , animDelay , scale , delay){
        if(!utilObj.isNodeValid(node)){
            return ;
        }
        
        var initDelay = utilObj.getDelayTime(animDelay);
        var scale1 = new cc.ScaleTo(delay / 2, scale * 1.25).easing((cc.easeOut(1)));
        var scale2 = new cc.ScaleTo(delay / 2, scale).easing((cc.easeOut(1)));
        var seq = new cc.Sequence([initDelay, scale1, scale2]);
        animObj.runAction(node, seq);
        
        trackObj.trackCounter(constantsObj.TRACK_DIALOG,  transOutroLayerV2.puzzleId, linearLevelObj.getDtc2PuzzleCompleted(), constantsObj.TRACK_LEVEL_COMPLETE_OUTRO, constantsObj.TRACK_TEXT_GRATIF, "", gameObj.getPuzzleSpeciesTracking(), "", "");

    },
   
    /**
     * Shows animation for country complete 
     * includes -> spine gift box animation and coin trail based on mini or mains.
     */
    showCountryCompleteAnimation : function(){
       
        var animDelay = 0;
        // utilObj.delayedCallback(transOutroLayerV2, transOutroLayerV2.removeUsedSprites, animDelay, {spriteArr: transOutroLayerV2.lowerAnimArr}, false);

        var spriteArr = [];
        var labelArr = [];
        var zOrder = constantsObj.UI_Z_ORDER;
        
        transOutroLayerV2.transBg = utilObj.getSprite(transOutroLayerV2.bgImg, centerXPos, constantsObj.DESIGN_HEIGHT + topBarOffset, 0.5, 1.0, constantsObj.SCALE_SPRITE_NEW_1 * 0.667, spriteArr, transOutroLayerV2, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        var scaleWidth = canvasWidth/1440;
        var scaleHeight =  (constantsObj.DESIGN_HEIGHT + topBarOffset)/2560;
        var toScale = (scaleWidth > scaleHeight ? scaleWidth : scaleHeight) * transOutroLayerV2.bgImgScalingFactor;
        utilObj.setScale(transOutroLayerV2.transBg, toScale);
        utilObj.setOpacity(transOutroLayerV2.transBg , constantsObj.OPACITY_0);
        transOutroLayerV2.nodeArr.push(transOutroLayerV2.transBg);

        transOutroLayerV2.fadeInNode(transOutroLayerV2.transBg , 0.15 , 0 , constantsObj.OPACITY_100);

        /**
         * coin placement for mini or main
         */
        // if(transOutroLayerV2.isMiniOrMidi){
        //     transOutroLayerV2.coinPlacementForMini(spriteArr , labelArr , zOrder ,  transOutroLayerV2.nodeArr);
        // } else {
        //     transOutroLayerV2.coinPlacementForMain(spriteArr , labelArr , zOrder ,  transOutroLayerV2.nodeArr);
        // }

        animDelay += 0.3
        var setOpacityValue = constantsObj.OPACITY_100;
        for(var i=0; i<transOutroLayerV2.nodeArr.length; i++){
            utilObj.setOpacity(transOutroLayerV2.nodeArr[i] , constantsObj.OPACITY_0);
            transOutroLayerV2.fadeInNode(transOutroLayerV2.nodeArr[i] , animDelay , 0.15 ,setOpacityValue);
        }
        
        // var yPos = constantsObj.DESIGN_HEIGHT ;
        // yPos -= topBarOffset;
        // var yOffset = 222;
        // yPos -= yOffset;
        // var yShift = 250;
        // yPos -= yShift;
        var yPos = constantsObj.DESIGN_HEIGHT + topBarOffset - constantsObj.BEZEL_SAFE_AREA;
        yPos -= topBarOffset;
        var yOffset = 222;
        yPos -= yOffset;
        var yShift = 0;
        if (transOutroLayerV2.isMiniOrMidi) {
            yShift = 250;
        }
        yShift = 250;
        yPos -= yShift;
        var xPos = centerXPos;

        animDelay += 0.1
        var countryName =  transOutroLayerV2.countryCompleteName ; // TODO :: USE THIS transOutroLayerV2.countryCompleteName
        var countryNameLabel = utilObj.getBMFontLabel(countryName, constantsObj.FONT_HELVETICA_80, transOutroLayerV2.fontColor,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, transOutroLayerV2, zOrder );

        utilObj.setOpacity(countryNameLabel, constantsObj.OPACITY_0);
        transOutroLayerV2.fadeInNode(countryNameLabel , animDelay , 0.2 , constantsObj.OPACITY_100);
        transOutroLayerV2.nodeArr.push(countryNameLabel);

        yPos -= 130;

        animDelay += 0.1
        var completeLabel = "Completed!"
        var showCompletedText = utilObj.getBMFontLabel(completeLabel, constantsObj.FONT_HELVETICA_MEDIUM_100, transOutroLayerV2.fontColor,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, transOutroLayerV2, zOrder );
        
        utilObj.setOpacity(showCompletedText, constantsObj.OPACITY_0);
        transOutroLayerV2.fadeInNode(showCompletedText , animDelay , 0.2 , constantsObj.OPACITY_100);
        transOutroLayerV2.nodeArr.push(showCompletedText);

        animDelay += 0.2;
        /**
         * Spine Not Working on web Check Condition
         */
        transOutroLayerV2.giftBoxSpineAnim(animDelay , yPos);
        animDelay += 2;
        transOutroLayerV2.giftBoxCoinTrail(animDelay);

        utilObj.addLabels(labelArr);
        utilObj.addSprites(spriteArr);
    },
    /**
     * Coin trail animation on country complete (mini and mains).
     */
    giftBoxCoinTrail : function(animDelay){

        var spriteArr = [];
        var labelArr = [];
        var zOrder = constantsObj.UI_Z_ORDER;
        var xPos = centerXPos;
        var yPos = centerYPos+ 50;
        var coinImage = utilObj.getSprite(constantsObj.coin_png_3, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_1 * 0.7, spriteArr, transOutroLayerV2, zOrder +1, constantsObj.SPRITE_MISC);
        utilObj.setOpacity(coinImage ,constantsObj.OPACITY_0);
        transOutroLayerV2.nodeArr.push(coinImage);

        transOutroLayerV2.fadeInNode(coinImage , animDelay , 0.2 ,constantsObj.OPACITY_100);

        var coinAdded = transOutroLayerV2.countryCompleteReward;
        var coinAddedLabel = utilObj.getBMFontLabel("+" + coinAdded, constantsObj.FONT_HELVETICA_65, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 100, yPos, 0.5, 0.5, labelArr, transOutroLayerV2, zOrder );
        utilObj.setOpacity(coinAddedLabel ,constantsObj.OPACITY_0);
        transOutroLayerV2.nodeArr.push(coinAddedLabel);

        transOutroLayerV2.fadeInNode(coinAddedLabel , animDelay , 0.2 ,constantsObj.OPACITY_100);

        // Updating the coins after country completion.
        utilObj.delayedCallback(transOutroLayerV2, transOutroLayerV2.updateEconomyAfterCountry, animDelay,null, false);
        /**
         * Move and scale up coinImage
         */
        
        transOutroLayerV2.scaleAndMoveNode(coinImage , animDelay ,  constantsObj.SCALE_SPRITE_1 * 1.2, 0.12 , 20 , 300);
        var prevShowTextscale = coinAddedLabel.scale;
        transOutroLayerV2.scaleAndMoveNode(coinAddedLabel , animDelay ,  prevShowTextscale * 3, 0.12 , 150 , 300);
        /**
         * Coin trail animation
         */
        if(transOutroLayerV2.isMiniOrMidi){
            var initialXpos = xPos + 20;
            var initialYPos = yPos + 300;

            var localYPos = constantsObj.DESIGN_HEIGHT - constantsObj.HEADER_HEIGHT / 2;
            localYPos -= 225;
            var localXPos = xRightPos;
            localXPos -= 200;
            localXPos = localXPos - 350;
        
            var pointsArr = [];
            pointsArr.push({x: initialXpos, y: initialYPos});
            pointsArr.push({x: initialXpos + 150, y: initialYPos + 200});
            pointsArr.push({x: initialXpos + 220, y: initialYPos + 400});
            pointsArr.push({x: localXPos , y: localYPos});

            animDelay += 0.1;
            var coinDelay  = animDelay;
            for (var i = 0; i < 5; i++) {

                var coinSprite = utilObj.getSprite(constantsObj.coin_png_3, initialXpos, initialYPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_1 *1.2, spriteArr, transOutroLayerV2, zOrder + 2, constantsObj.SPRITE_MISC);
                coinSprite.setVisible(false);
                var delayAction = utilObj.getDelayTime(coinDelay);
                var toggleVisibility = cc.toggleVisibility();
                var removeSelf = utilObj.getIndependentRemoveSelf();

                var moveToAction = animObj.getCardinalSplineTo(0.5, pointsArr, 0.2).easing(new cc.easeIn(1.5));
                var scaleDown = new cc.ScaleTo(0.7, constantsObj.SCALE_SPRITE_9 *0.9).easing((cc.easeOut(1)));

                var spawnAction = cc.spawn([moveToAction , scaleDown]);

            
                animObj.runAction(coinSprite, animObj.getSequence([delayAction, toggleVisibility, spawnAction, removeSelf]));
                coinDelay += 0.1;
            }
            animDelay = coinDelay;
            // animDelay += 0.1;
            // animDelay = transOutroLayerV2.outroCoinTrailAnimation(initialXpos , initialYPos ,animDelay ,5 ,pointsArr ,0.5,constantsObj.SCALE_SPRITE_1 *1.2 , spriteArr);
           
            transOutroLayerV2.showScoreIncrementAnim(transOutroLayerV2.coinMiniLabel, coinAdded, transOutroLayerV2.coinCount, animDelay , true);

        }else{
            var initialXpos = xPos + 20;
            var initialYPos = yPos + 300;
            var pointsArr = [];
            pointsArr.push({x: initialXpos, y: initialYPos});
            pointsArr.push({x: xRightPos - 650, y: initialYPos - 100});
            pointsArr.push({x: xRightPos - 500, y: initialYPos - 250});
            pointsArr.push({x: xRightPos - 350, y: initialYPos - 500});
            pointsArr.push({x: xRightPos - 250, y: initialYPos - 750});
            pointsArr.push({x: xRightPos - 100, y: 150});

            animDelay += 0.1;
            var coinDelay  = animDelay;
            for (var i = 0; i < 5; i++) {

                var coinSprite = utilObj.getSprite(constantsObj.coin_png_3, initialXpos, initialYPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_1 *1.2, spriteArr, transOutroLayerV2, zOrder + 2, constantsObj.SPRITE_MISC);
                coinSprite.setVisible(false);
                var delayAction = utilObj.getDelayTime(coinDelay);
                var toggleVisibility = cc.toggleVisibility();
                var removeSelf = utilObj.getIndependentRemoveSelf();

                var moveToAction = animObj.getCardinalSplineTo(0.5, pointsArr, 0.2).easing(new cc.easeIn(1.5));
                var scaleDown = new cc.ScaleTo(0.7, constantsObj.SCALE_SPRITE_9 *0.9).easing((cc.easeOut(1)));

                var spawnAction = cc.spawn([moveToAction , scaleDown]);
                animObj.runAction(coinSprite, animObj.getSequence([delayAction, toggleVisibility, spawnAction, removeSelf]));
                coinDelay += 0.1;
            }
            animDelay = coinDelay;

            // animDelay += 0.1;
            // animDelay = transOutroLayerV2.outroCoinTrailAnimation(initialXpos , initialYPos ,animDelay ,5 ,pointsArr ,0.5,constantsObj.SCALE_SPRITE_1 *1.2 , spriteArr);

            transOutroLayerV2.showScoreIncrementAnim(transOutroLayerV2.coinMainLabel, coinAdded, transOutroLayerV2.coinCount, animDelay , true);

            
        }
        

        // Fading Out the coin Image and coinLabel
        transOutroLayerV2.fadeOutNode(coinImage , animDelay , 0.1);
        transOutroLayerV2.fadeOutNode(coinAddedLabel , animDelay , 0.1);

        animDelay += 0.8;
        utilObj.delayedCallback(transOutroLayerV2, transOutroLayerV2.removeUsedSprites, animDelay, {spriteArr: transOutroLayerV2.nodeArr}, false);

        
        utilObj.addLabels(labelArr);
        utilObj.addSprites(spriteArr);

        transOutroLayerV2.delayForCountryCompleteAnim = animDelay;
    },
    /**
     *  Spine animation for gift box.
     */
    giftBoxSpineAnim : function(animDelay ,yPos){

        var zOrder = constantsObj.UI_Z_ORDER;
        var jsonFile = res.gift_box_anim_json;
        var atlasFile = res.gift_box_anim_atlas;
        var giftNode = sp.SkeletonAnimation.createWithJsonFile(jsonFile, atlasFile);

        utilObj.setPosition(giftNode , centerXPos, yPos - 900);
        transOutroLayerV2.addChild(giftNode , zOrder);
        giftNode.setScale(constantsObj.SCALE_TWO);
        utilObj.setOpacity(giftNode , constantsObj.OPACITY_0);

        transOutroLayerV2.nodeArr.push(giftNode);
        animDelay += 0.1;
        transOutroLayerV2.fadeInNode(giftNode , animDelay , 0.2 , constantsObj.OPACITY_100);

        giftNode.addAnimation(0 , 'animation_gift_box_dtc' , false , animDelay);

        trackObj.trackCounter(constantsObj.TRACK_DIALOG,  "", "", constantsObj.TRACK_COUNTRY_COMPLETE_ANIM, constantsObj.TRACK_VIEW, linearLevelObj.getCurLevel() - 1, gameObj.getPuzzleSpeciesTracking(), "", "");


    },
    /**
     * Shows the unlocked country background with old flag fade out and new flag fade in animation.
     */
    countryUnlockAnimation : function(){

        var spriteArr = [];
        var labelArr = [];
        var zOrder = constantsObj.UI_Z_ORDER;
        var animDelay = 0;
        
        var bgScaling = 1.25 * aspectRatio / constantsObj.ASPECT_NORMAL;
        if (aspectRatio < 1.78) {
            var scale = 1.78 / aspectRatio;
            bgScaling = scale * 1.25;
        }
        var countryBg  = utilObj.getSprite(transOutroLayerV2.countryBackgroundImage, centerXPos, centerYPos, 0.5, 0.5, bgScaling, spriteArr, transOutroLayerV2, zOrder, constantsObj.SPRITE_LOCAL);
        
        transOutroLayerV2.fadeInNode(countryBg , animDelay , 0, constantsObj.OPACITY_100);

        var xPos = centerXPos;
        var yPos = constantsObj.DESIGN_HEIGHT;

        yPos -= 225;
        var countryName = transOutroLayerV2.unlockedCountryName;
        var countryNameLabel = utilObj.getBMFontLabel(countryName, constantsObj.FONT_HELVETICA_120, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos , yPos, 0.5, 0.5, labelArr, transOutroLayerV2, zOrder );
        
        yPos -= 130;
        var unlockLabel = utilObj.getBMFontLabel("Unlocked!", constantsObj.FONT_HELVETICA_MEDIUM_100, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos , yPos, 0.5, 0.5, labelArr, transOutroLayerV2, zOrder );

        
        yPos = centerYPos;
        
        var animRing1 = utilObj.getSprite(constantsObj.white_circle_300, xPos, yPos, 0.5, 0.5,  constantsObj.SCALE_SPRITE_NEW_1 * 0.3 , spriteArr, transOutroLayerV2, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setColor(animRing1, constantsObj.COLOR_WHITE);
        utilObj.setOpacity(animRing1, constantsObj.OPACITY_30);

        animDelay += 0.2;
        transOutroLayerV2.scaleNodeTo(animRing1 , animDelay , constantsObj.SCALE_SPRITE_NEW_1 * 1.333);
       
        var animRing2 = utilObj.getSprite(constantsObj.white_circle_300, xPos, yPos, 0.5, 0.5,  constantsObj.SCALE_SPRITE_NEW_1 * 0.3, spriteArr, transOutroLayerV2, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setColor(animRing2, constantsObj.COLOR_WHITE);
        utilObj.setOpacity(animRing2, constantsObj.OPACITY_30);


        animDelay += 0.1;
        transOutroLayerV2.scaleNodeTo(animRing2 , animDelay , constantsObj.SCALE_SPRITE_NEW_1 * 1.111 , 0.2);

        /**
         * scaleUp -> scaleDown -> flagImage ->  rings and Flag scaleDown  
         */
        
        var flagSprite = utilObj.getSprite(transOutroLayerV2.newFlag, xPos, yPos + 5 , 0.5, 0.5, 0, spriteArr, transOutroLayerV2, zOrder, constantsObj.SPRITE_FLAGS_V1);
        animDelay += 0.2;

        var initDelay = utilObj.getDelayTime(animDelay);
        var scaleUp = new cc.ScaleTo(0.2, constantsObj.SCALE_SPRITE_NEW_1 * 2.15).easing((cc.easeOut(1)));
        var scaleDown = new cc.ScaleTo(0.2, constantsObj.SCALE_SPRITE_NEW_1 * 1.95).easing((cc.easeOut(1)));
        var seq = new cc.Sequence([initDelay, scaleUp , scaleDown]);
        animObj.runAction(flagSprite , seq);

       
        // var flagSprite2 = utilObj.getSprite(transOutroLayerV2.newFlag, xPos, yPos + 5 , 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 1.98, spriteArr, transOutroLayerV2, zOrder, constantsObj.SPRITE_FLAGS_V1);
        // utilObj.setOpacity(flagSprite2 , constantsObj.OPACITY_0);

        // animDelay += 1;
        // transOutroLayerV2.fadeInNode(flagSprite2 , animDelay ,0.2 , constantsObj.OPACITY_100);
        // transOutroLayerV2.fadeOutNode(flagSprite , animDelay + 0.2, 0);

       
        // animDelay += 0.5;
        // transOutroLayerV2.scaleNodeTo(flagSprite2 , animDelay , constantsObj.SCALE_SPRITE_NEW_1 * 2.15 , 0.2);

        animDelay += 0.8;
        transOutroLayerV2.scaleNodeTo(flagSprite , animDelay , 0, 0.2);
        animDelay += 0.1;
        transOutroLayerV2.scaleNodeTo(animRing2 , animDelay , 0, 0.2);
        animDelay += 0.1;
        transOutroLayerV2.scaleNodeTo(animRing1 , animDelay , 0, 0.2);

        transOutroLayerV2.fadeOutNode(countryBg, animDelay , 0.2);
        transOutroLayerV2.fadeOutNode(countryNameLabel, animDelay , 0.2);
        transOutroLayerV2.fadeOutNode(unlockLabel, animDelay , 0.2);

        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);

        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() , constantsObj.TRACK_COUNTRY_UNLOCK_ANIMATION, constantsObj.TRACK_VIEW, linearLevelObj.getCurLevel(), gameObj.getPuzzleSpeciesTracking(), "", "");

        transOutroLayerV2.delayForCountryUnlockAnim = animDelay;
    },
    /**
     * 
     * @param {*} startXpos 
     * @param {*} startYPos 
     * @param {*} delay 
     * @param {*} noOfCoins 
     * @param {*} pointsArr 
     * @param {*} cardinalDuartion 
     * @param {*} coinSpriteScale 
     * @param {*} spriteArr 
     * 
     * Generic code for coin trial animation.
     */
    outroCoinTrailAnimation : function(startXpos , startYPos , delay ,noOfCoins ,pointsArr , cardinalDuartion ,coinSpriteScale ,spriteArr){
        var initialXpos = startXpos;
        var initialYPos = startYPos;
        var zOrder = constantsObj.UI_Z_ORDER;
        var coinDelay  = delay;
        for (var i = 0; i < noOfCoins; i++) {

            var coinSprite = utilObj.getSprite(constantsObj.coin_png_3, initialXpos, initialYPos, 0.5, 0.5, coinSpriteScale, spriteArr, transOutroLayerV2, zOrder + 2, constantsObj.SPRITE_MISC);
            coinSprite.setVisible(false);
            var delayAction = utilObj.getDelayTime(coinDelay);
            var toggleVisibility = cc.toggleVisibility();
            var removeSelf = utilObj.getIndependentRemoveSelf();

            var moveToAction = animObj.getCardinalSplineTo(cardinalDuartion, pointsArr, 0.2).easing(new cc.easeIn(1.5));
            var spawnAction = cc.spawn([moveToAction]);

            animObj.runAction(coinSprite, animObj.getSequence([delayAction, toggleVisibility, spawnAction, removeSelf]));
            coinDelay += 0.1;
        }
        return coinDelay;
    },
    /**
     *  Here Total xp will be decremented to 0 from awarded xps
     */
    showXpCountDecrementAnim: function (node, xpAwarded, animDelay) {
        var xpNew = 0;
        var xpDec = parseInt(xpAwarded / 10);
        var n = 10;
        var delayTime = 0.12
        if (xpAwarded <= 10) {
            xpDec = 1;
            n = xpAwarded;
            // delayTime = 0.35
        }
        var xpNew = xpAwarded - xpDec;
        if (xpAwarded >= 10 && (xpAwarded % 10 != 0)) {
            xpNew -= xpAwarded % 10;
        }
        var callFunc;
        var delay1;
        var actions = [];
        var delayInit = utilObj.getDelayTime(animDelay);
        actions.push(delayInit);
        for (var i = 0; i < n; i++) {
            var params = {
                n: node,
                cA: xpNew
            };
            callFunc = utilObj.getCallFunc(animObj.updateCoinCountAbsolute, transOutroLayerV2, params);
            delay1 = utilObj.getDelayTime(delayTime);
            actions.push(callFunc);
            actions.push(delay1);
            xpNew -= xpDec;
        }
        var seq = animObj.getSequence(actions, false);
        node.runAction(seq);
    },

    /**
     * Here total node count  will be incremented to the awarded value.
     */
    showScoreIncrementAnim: function (node, xpAwarded, score_count, animDelay ,isCoinIncrement) {
        // loggerObj.debugLog("increment" , node,xpAwarded,score_count)
        var xpInc = parseInt(xpAwarded / 10);
        var n = 10;
        var delayTime = 0.04
        if (xpAwarded < 10) {
            xpInc = 1;
            n = xpAwarded;
        }
        if(isCoinIncrement){
            delayTime = 0.1;
        }
        var scoreNew = score_count + xpInc;
        if (xpAwarded >= 10 && (xpAwarded % 10 != 0)) {
            scoreNew += xpAwarded % 10;
        }

        var callFunc;
        var delay1;
        var actions = [];
        var delayInit = utilObj.getDelayTime(animDelay);
        actions.push(delayInit);
        for (var i = 0; i < n; i++) {
            var params = {
                n: node,
                cA: scoreNew
            };
            callFunc = utilObj.getCallFunc(animObj.updateCoinCountAbsolute, transOutroLayerV2, params);
            delay1 = utilObj.getDelayTime(delayTime);
            actions.push(callFunc);
            actions.push(delay1);
            scoreNew += xpInc;
        }
        var seq = animObj.getSequence(actions, false);
        node.runAction(seq);
    },
    /**
     *  -> Ad will not be shown in case of payer , if it has not completed runtime node on day one or if x no ads are shown after cooldown.
     *  -> while in case of daily puzzle ad will be shown if its non payer . and accordingly cases are handled in after ad dismis.
     *   transOutroLayerV2.isFromDailyPuzzle -> is the variable that handles ad when daily puzzle is played.
     */
    showAd: function () {
        loggerObj.debugLog("hello in showad");

        var runtimeValue = runtimeObj.getNodesCompletedD0();//TODO:: RUNTIME CONTROLLED
        var splitStr = runtimeValue.split(":");
        var runTimeValueForNodesCompleted = parseInt(splitStr[1]);
        loggerObj.debugLog("nodes :",runTimeValueForNodesCompleted);
        var noOfNodesCompleted = linearLevelObj.getDtc2PuzzleCompleted();
        
        // Payer Condition
        if (((!gameObj.getShowAds()) || gameObj.getIsPayer())) {
            transOutroLayerV2.afterAdDismiss();
            return;
        }

        //D0 conditon
        if (!transOutroLayerV2.isFromDailyPuzzle && (noOfNodesCompleted <= runTimeValueForNodesCompleted) && (utilObj.getCurrentTimestamp() - userObj.getCreated() < constantsObj.SECONDS_IN_DAY)) {
           transOutroLayerV2.afterAdDismiss();
           return;
        }

        // CoolDown Condition
        if (!transOutroLayerV2.isFromDailyPuzzle && gameObj.getNumberOfVideoIntWatched() >= runtimeObj.getVideoIntCount()) {
            transOutroLayerV2.afterAdDismiss();
            return;
        }


        if (adsObj.checkRewardedVideo(true)) {
            loggerObj.debugLog("hello in showad 6");
            adsObj.showVideoAd(true);
            gameObj.setNumberOfVideoIntWatched(gameObj.getNumberOfVideoIntWatched() + 1);
            gameObj.setTimestampForLastVideoInterstitial(utilObj.getCurrentTimestamp());
            adsObj.setNotRewardedVideo(true);
            // utilObj.delayedCallback(transOutroLayer, transOutroLayer.enableNextButton, 1.5);
        } else {
            loggerObj.debugLog("hello in showad 7");
            transOutroLayerV2.afterAdDismiss();
        }
    },

    enableNextButton: function () {
        gameObj.setNextButtonState(true);
    },
    /**
     * Returns the Height of the lower bg of the progress bar which is based on the keyboard heights of differnrt devices.
     */
    clueHeightForShrink: function (isMiniOrMidi, isBritMini) {
        var ratioYPosShrink = constantsObj.DESIGN_HEIGHT - gameObj.getGridPixelHeight();
        var shiftInKeyboard = 0;
        var keyBoardHeight = constantsObj.KEYBOARD_HEIGHT;
        var clueHeight = constantsObj.CLUE_HEIGHT;
        var hintsHeight = constantsObj.HINTS_HEIGHT;
        var shiftIpad = 0;
        if (isTablet) {
            shiftIpad = 35;
        }

        if (utilObj.getIsLikeIphoneX() && utilObj.isIos()) {
            keyBoardHeight = 805;
            clueHeight = 275;
        }


        if (!isMiniOrMidi || isBritMini) {
            clueHeight = constantsObj.CLUE_HEIGHT_NEW;
            keyBoardHeight = constantsObj.KEYBOARD_HEIGHT_NEW;
            hintsHeight = constantsObj.HINTS_HEIGHT_NEW;
            if (utilObj.getIsLikeIphoneX() && utilObj.isIos()) {
                keyBoardHeight = 675;
                clueHeight = 275;
            }
        }
        if (isMiniOrMidi && !isBritMini) {
            ratioYPosShrink -= (140 - shiftIpad);
            keyBoardHeight -= 110;
            clueHeight -= 10;
            hintsHeight -= 20;
        }
        if (!isMiniOrMidi || isBritMini) {
            ratioYPosShrink -= (225 - shiftIpad);
        }
        ratioYPosShrink -= clueHeight;
        if (utilObj.getIsLikeIphoneX() && utilObj.isAndroid()) {
            var miniOffset = 0;
            if (isMiniOrMidi && !isBritMini) {
                miniOffset = constantsObj.HEADER_HEIGHT - 225;
            }
            shiftInKeyboard = utilObj.getDesignHeight() - keyBoardHeight - clueHeight - hintsHeight - 390 - gameObj.getGridPixelHeight() - miniOffset - constantsObj.BOTTOM_BAR_OFFSET1 + 10;
        }
        if (shiftInKeyboard < 0) {
            shiftInKeyboard = 0;
        }
        ratioYPosShrink = ratioYPosShrink - shiftInKeyboard;
        return ratioYPosShrink;
    },
    /**
     * 
     * @param {*} tomorrow 
     * Function to run timer till the next puzzle unlocks.
     * TO Stop the timer clearInterVal function is called when daily puzzles continue button is clicked.
     */
    getTimer : function(tomorrow){
       
        var str = "";
        str += linearLevelObj.getCurrentMonth(tomorrow.getMonth()) + " ";
        str += tomorrow.getDate() + ", ";
        str += tomorrow.getFullYear() + " 24:0:0";
       
        var countDownDate = new Date(str).getTime();
        transOutroLayerV2.timerfunc = setInterval(function() {
            var now = new Date().getTime();
            var timeleft = countDownDate - now;
            if (timeleft < 0) {
                clearInterval(transOutroLayerV2.timerfunc)
            }
            var hours = Math.floor((timeleft % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));
            var minutes = Math.floor((timeleft % (1000 * 60 * 60)) / (1000 * 60));
            var seconds = Math.floor((timeleft % (1000 * 60)) / 1000);
           
            var ans = "Unlocks in ";
            ans+=hours + ":";
            ans+=minutes + ":";
            if(seconds < 10){
                ans += "0";
            }
            ans+=seconds;
            utilObj.setString(transOutroLayerV2.unlockLabel,  ans+ "");
            
         }, 1000)
    },

    /**
     * handles share button click 
     */
    share: function () {
        // popupLayer.closeWithDefault();
        utilObj.setVisible(transOutroLayerV2.coverForFreeCoins2Popup, true);
        freeCoins2Popup.show(true, constantsObj.SCREEN_GAME);
    },

    /**
     * returns outro UI data
     * @returns 
     */
    getOutroUIData: function () {
        var bgImg = realisticBgObj.getRealisticBgInfoMap()["tbg"];
        var bgScale = 2;
        var fontColorVal = utilObj.getColorForHexCode(realisticBgObj.getRealisticBgInfoMap()["fc"]);
        return { bg: bgImg, bgImgScale: bgScale, fontColor: fontColorVal };
    },

    /**
     * returns lower trans background UI data
     * @returns 
     */
    getLowerTransBgUIData: function () {
        var colorVal = utilObj.getColorForHexCode(realisticBgObj.getRealisticBgInfoMap()["rc"]);
        var opacityVal = constantsObj.OPACITY_95;
        return { color: colorVal, opacity: opacityVal };
    },

});