var HighLevelStoreLayer = cc.Layer.extend({
    screen: null,
    cashLbl: null,
    isRedraw: false,
    bottomBar: null,
    parentScreen: null,

    show: function () {
        highLevelStoreLayer.screen = constantsObj.SCREEN_HIGH_LEVEL_STORE_LAYER;
        var screen = highLevelStoreLayer.screen;

        var spriteArr = [];
        var labelArr = [];
        var zOrder = constantsObj.UI_Z_ORDER;

        var xPos = centerXPos;
        var yPos = constantsObj.DESIGN_HEIGHT;

        var parentScreen = curScreen;
        // loggerObj.debugLog("curscreen is ", utilObj.getScreenName(parentScreen));
        highLevelStoreLayer.parentScreen = curScreen;

        utilObj.updateScreenBegin(highLevelStoreLayer.screen);


        utilObj.hideBannerAd(utilObj.getScreenName(highLevelStoreLayer.screen));

        // updates all the achievement status here
        achievementsObj.checkForAchievements();

        // updates the achievements whose reward has been already granted to claimed state
        achievementsObj.checkForClaimedAchievements();


        var background = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos, 0.5, 1, canvasWidth, constantsObj.DESIGN_HEIGHT);
        background.setColor(constantsObj.COLOR_WHITE);
        utilObj.addChild(highLevelStoreLayer, background, zOrder);

        var tab = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos, 0.5, 1, canvasWidth, 350, spriteArr, highLevelStoreLayer, zOrder, constantsObj.SPRITE_MISC);
        tab.setColor(constantsObj.COLOR_TOP_BAR);

        // header starts here
        yPos -= 175;

        utilObj.getSprite(constantsObj.arrow_02, xLeftPos + 60, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_3, spriteArr, highLevelStoreLayer, zOrder, constantsObj.SPRITE_MISC);
        var backButton = utilObj.getButton(150, 200, 0, 0.5, xLeftPos, yPos,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'highLevelStoreLayer',
                fn: 'back',
                screen: highLevelStoreLayer.screen,
                params: {sound: false},
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_CALENDAR,
                    f: constantsObj.TRACK_BACK,
                    g: "",
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(highLevelStoreLayer, backButton, zOrder);

        utilObj.getBMFontLabel("Out of Coins?", constantsObj.FONT_ROBOTO_REGULAR_120, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, highLevelStoreLayer, zOrder + 1);

        xPos = xRightPos - 270;

        var coinBg = utilObj.getScale9Sprite(constantsObj.coin_number_bg, xPos, yPos, 0, 0.5, 240, 80, spriteArr,
            highLevelStoreLayer, zOrder + 1, constantsObj.SPRITE_MISC);
        coinBg.setOpacity(constantsObj.OPACITY_10);
        utilObj.getSprite(constantsObj.coin_png_2, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, highLevelStoreLayer, zOrder + 1, constantsObj.SPRITE_MISC);
        var coinCount = economyObj.getCash();
        highLevelStoreLayer.cashLbl = utilObj.getBMFontLabel(coinCount + "", constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 130, yPos, 0.5, 0.5, labelArr, highLevelStoreLayer, zOrder + 1);

        yPos -= 175;

        yPos -= 115;


        var imageBgLength = canvasWidth / (1.29);

        var imageBg = utilObj.getScale9Sprite(constantsObj.rounded_4, centerXPos, yPos, 0.5, 1, imageBgLength, 986);
        imageBg.setColor(constantsObj.COLOR_LIGHT_GREY_01);
        utilObj.addChild(highLevelStoreLayer, imageBg, zOrder);

        var coins_stack = utilObj.getSprite(constantsObj.coin_stack_2, imageBgLength / 2, 986 / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_20, null, imageBg, zOrder, constantsObj.SPRITE_MISC);
        utilObj.addChild(imageBg, coins_stack, zOrder);

        yPos -= (1200);

        var text = stringsObj.high_level_store_text;

        var textLabel = utilObj.getBMFontLabel(text, constantsObj.FONT_ROBOTO_REGULAR_90, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, yPos - 100, 0.5, 0.5);
        utilObj.addChild(highLevelStoreLayer, textLabel, zOrder + 1);


        highLevelStoreLayer.bottomBar = utilObj.getScale9Sprite(constantsObj.tile_white, canvasWidth / 2, 0, 0.5, 0, canvasWidth, 470, null, highLevelStoreLayer, zOrder + 1, constantsObj.SPRITE_MISC);
        highLevelStoreLayer.bottomBar.setColor(constantsObj.COLOR_TOP_BAR);
        utilObj.addChild(highLevelStoreLayer, highLevelStoreLayer.bottomBar, constantsObj.UI_Z_ORDER + 1);

        highLevelStoreLayer.addBottomBarOptions();

        if (gameObj.getIsRedraw()) {
            gameObj.setIsRedraw(false);
        }


        utilObj.updateScreen(highLevelStoreLayer.screen, highLevelStoreLayer);

        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);

    },

    addBottomBarOptions: function () {
        var screen = highLevelStoreLayer.screen;
        var btnWidth = (canvasWidth - canvasWidth / 10);
        highLevelStoreLayer.buttonWidth = btnWidth;
        var btnHeight = 170;
        var xPos = canvasWidth / 2;
        var zOrder = constantsObj.UI_Z_ORDER;
        var yShift = 45;


        var parentScreen = highLevelStoreLayer.parentScreen;
        var parentScreenName = utilObj.getScreenName(highLevelStoreLayer.screen);
        if (highLevelStoreLayer.parentScreen != null) {
            parentScreenName = utilObj.getScreenName(highLevelStoreLayer.screen);
        }


        var buyButton = utilObj.getButton(btnWidth, btnHeight, 0.5, 0.5, xPos, btnHeight / 2 + 200 + yShift,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'highLevelStoreLayer',
                fn: 'buy',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_STORE_LAYER_BUY,
                    f: "",
                    g: parentScreenName,
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(highLevelStoreLayer, buyButton, zOrder + 1);
        buyButton.setColor(constantsObj.COLOR_BUTTON_GREEN);

        var buyLabel = utilObj.getBMFontLabel("Buy Coins", constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), btnWidth / 2 - 50, btnHeight / 2, 0.5, 0.5, null, buyButton, zOrder + 1);
        utilObj.addChild(buyButton, buyLabel, zOrder + 1);

        var cashIcon1 = utilObj.getSprite(constantsObj.coin_one, btnWidth / 2 + 250, btnHeight / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_18);
        utilObj.addChild(buyButton, cashIcon1, zOrder + 1);


        var earnButton = utilObj.getButton(btnWidth, btnHeight, 0.5, 0.5, xPos, btnHeight / 2 + yShift,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'highLevelStoreLayer',
                fn: 'earnFree',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_OOC_STORE_LAYER,
                    f: utilObj.getScreenName(constantsObj.SCREEN_FREE_COINS),
                    g: parentScreenName,
                    s: "",
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(highLevelStoreLayer, earnButton, zOrder + 1);
        earnButton.setColor(constantsObj.COLOR_BUTTON_LIGHT_BLUE);
        highLevelStoreLayer.earnFreeButton = earnButton;

        var cashIcon = utilObj.getSprite(constantsObj.coin_one, btnWidth / 2 + 250, btnHeight / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_18);
        utilObj.addChild(earnButton, cashIcon, zOrder + 1);

        var earnLabel = utilObj.getBMFontLabel("FREE Coins", constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), btnWidth / 2 - 50, btnHeight / 2, 0.5, 0.5, null, earnButton, zOrder + 1);
        utilObj.addChild(earnButton, earnLabel, zOrder + 1);


    },

    hide: function () {
        sc = utilObj.popCurScreen();
        highLevelStoreLayer.removeAllChildren();
        highLevelStoreLayer.setVisible(false);
    },

    back: function () {
        highLevelStoreLayer.hide();
        var sc = utilObj.popCurScreen();
        if (sc == constantsObj.SCREEN_CALENDAR) {
            calendarLayer.show();
        } else if (sc == constantsObj.SCREEN_PACK_INFO_LAYER) {
            var packId = packInfoLayer.selectedPackId;
            packInfoLayer.show(packId, null, packInfoLayer.britPack);
        } else if (sc == constantsObj.SCREEN_ACHIEVEMENTS) {
            if (ProfileExp == constantsObj.EXP_VAR_1) {
                achievementsLayer.show(gameObj.getShowStat());
            } else {
                achievementsLayer.show();
            }
        } else if (sc == constantsObj.SCREEN_GAME) {
            if (gameLayer.isPuzzleFromPack) {
                gameLayer.show(gameLayer.crosswordDate, true);
            } else {
                gameLayer.show(gameLayer.crosswordDate);
            }
        } else if (sc == constantsObj.SCREEN_PACK_LAYER) {
            packsLayer.show();
        } else {
            homeLayer.show();
        }
    },

    buy: function () {
        highLevelStoreLayer.hide();
        storeLayer.show();
    },

    earnFree: function () {
        var screen = utilObj.getScreenName(curScreen);
        if (adsObj.hasOfferWall()) {
            adsObj.showOfferWall();
            return;
        }
        freeCoinsPopup.show(true, null, constantsObj.SCREEN_HIGH_LEVEL_STORE_LAYER);
    },


});

