HomeLayerV2 = cc.Layer.extend({
    screen: null,
    listView: null,
    scrollView: null,
    cashLbl: null,
    sections: null,
    masteryLbl: null,
    bottomNavBg: null,
    homeButtonBg: null,
    transBg: null,
    achivementReminderVisible: false,
    coverLeft: null,
    coverRight: null,
    achievementBackground: null,
    videoProgress: null,
    timerLbl: null,
    ctaButtonVideo: null,
    textLbl1: null,
    toShowDailyMini: false,
    crossGameTimeQuests: [],
    subscriptionTag: 0,
    dailyMiniToShow: null,
    subs_popup_condition: false,
    intervalId1: null,
    intervalId2: null,
    intervalId3: null,
    animArr: [],
    gift: null,
    todayAnimRunning: false,

    show: function (isSubscribe) {
        var screen = constantsObj.SCREEN_HOME;
        homeLayer.screen = screen;
        var screenName = utilObj.getScreenName(screen);
        utilObj.updateScreenBegin(screen);
        adWallObj.setAdWallLastScreen(constantsObj.SCREEN_HOME);
        gameObj.setIdForTodaysPuzzle(utilObj.getIdForDate(gameObj.getTodaysPuzzleDate()));
        gameObj.setRegularNotifTriggered("0");
        gameObj.setW2ePowerUpVideoWatched(false);
        gameObj.setW2ePowerUpVideo(false);
        gameObj.setHomeScreenViewsToday(gameObj.getHomeScreenViewsToday() + 1);


        if (gameObj.getShowCoinGrantMessage() == true) {
            utilObj.showMessage("Your coins through the last milestone are already granted");
        }

        clearInterval(homeLayer.intervalId1);
        clearInterval(homeLayer.intervalId2);
        clearInterval(homeLayer.intervalId3);

        achievementsObj.checkForAchievements();
        gameObj.setUserCreatedForNotif(userObj.getCreated());

        var spriteArr = [];
        var labelArr = [];
        var zOrder = constantsObj.SPRITE_Z_ORDER;
        var layoutExperimentVariant = epmObj.getChosenVariant(constantsObj.EXP_LAYOUT);

        var xPos = centerXPos;
        var yPos = constantsObj.DESIGN_HEIGHT;

        themedQuestObj.unlock();
        weeklyQuestObj.unlock();


        var background = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos, 0.5, 1, canvasWidth, constantsObj.DESIGN_HEIGHT, spriteArr, homeLayer, zOrder - 1, constantsObj.SPRITE_MISC);
        if (layoutExperimentVariant == constantsObj.EXP_VAR_CONTROL) {
            background.setColor(constantsObj.COLOR_BLACK);
        } else {
            background.setColor(constantsObj.COLOR_WHITE_01);
        }

        // Header 1
        var bannerbg = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos + topBarOffset, 0.5, 1, canvasWidth, 226 + topBarOffset, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_MISC);
        bannerbg.setColor(constantsObj.COLOR_TOP_BAR);
        //homeLayer.addChild(bannerbg, zOrder);
        //utilObj.addChild(homeLayer, bannerbg, zOrder);

        if (utilObj.isIos()) {
            var adBanner = constantsObj.ad_banner_place_holder;
            homeLayer.header = utilObj.getSprite(adBanner, centerXPos, yPos - 50, 0.5, 1, constantsObj.SCALE_SPRITE_6 * 3 / 2, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_MISC);
        } else {
            var adBanner = constantsObj.header_logo;
            homeLayer.header = utilObj.getSprite(adBanner, centerXPos - 330 * canvasWidth / 1440, yPos - 50 + topBarOffset / 2, 0.5, 1, constantsObj.SCALE_SPRITE_10 * 3 / 2, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_MISC);
        }


        //header 2 start
        yPos -= 226;
        var localYPos = yPos - 70;
        var tab = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos, 0.5, 1, canvasWidth, 140, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_MISC);
        tab.setColor(constantsObj.COLOR_TOP_BAR);
        xPos = xRightPos - 30;

        var settingsButton = utilObj.getButton(123, 200, 1, 0.5, xRightPos - 50, localYPos,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'homeLayer',
                fn: 'settings',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_HOME,
                    f: constantsObj.TRACK_SETTINGS,
                    g: screen,
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE);
        //homeLayer.addChild(settingsButton, zOrder + 1);
        utilObj.addChild(homeLayer, settingsButton, zOrder);

        var msg = utilObj.getSprite(constantsObj.setting_icon, xRightPos - 70, localYPos, 1, 0.5, constantsObj.SCALE_SPRITE_14 * 1.5, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_MISC);
        if (layoutExperimentVariant != constantsObj.EXP_VAR_CONTROL) {
            msg.setColor(constantsObj.COLOR_WHITE);
        }

        xPos = xRightPos - 30;
        var xShiftTemp = 200;
        var coinBg = utilObj.getScale9Sprite(constantsObj.tile_white_curved, xPos - (350 + xShiftTemp), localYPos, 0, 0.5, 300, 80, spriteArr,
            homeLayer, zOrder, constantsObj.SPRITE_MISC);
        //coinBg.setOpacity(constantsObj.OPACITY_10);
        utilObj.getSprite(constantsObj.coin_png_2, xPos - (350 + xShiftTemp), localYPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_MISC);
        var coinCount = economyObj.getCash();
        homeLayer.cashLbl = utilObj.getBMFontLabel(coinCount + "", constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - (210 + xShiftTemp), localYPos, 0.5, 0.5, labelArr, homeLayer, zOrder + 1);

        utilObj.getSprite(constantsObj.green_plus, xPos - (100 + xShiftTemp), localYPos, 0, 0.5, constantsObj.SCALE_SPRITE_1, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_MISC);

        var buttonAtCoins = utilObj.getButton(450, 180, 0, 0.5, xPos - (420 + xShiftTemp), localYPos,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'homeLayer',
                fn: 'showStore',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_HOME,
                    f: constantsObj.TRACK_STORE,
                    g: "",
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        //homeLayer.addChild(buttonAtCoins, zOrder);
        utilObj.addChild(homeLayer, buttonAtCoins, zOrder);

        //mastery display on home screen
        var starCount = gameObj.getMastery1();
        //gameObj.updateMasteryFromSync();


        xPos = xLeftPos + 100;
        // var masteryBg = utilObj.getScale9Sprite(constantsObj.tile_white_curved, xPos, yPos - 65, 0, 0.5, 350, 90, spriteArr,
        //     homeLayer, zOrder, constantsObj.SPRITE_MISC);
        // //masteryBg.setOpacity(constantsObj.OPACITY_10);
        var star = utilObj.getSprite(constantsObj.star_white_2, xPos + 160, yPos - 65, 0, 0.5, constantsObj.SCALE_SPRITE_1, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_MISC);
        star.setColor(constantsObj.COLOR_BLUE_01);

        var xOffset = 0;
        var offsetForMessageCenter = 90;
        if (starCount > 999) {
            xOffset = 30;
            offsetForMessageCenter = 240;
        } else if (starCount > 99) {
            xOffset = 20;
            offsetForMessageCenter = 190;
        } else if (starCount > 9) {
            xOffset = 10;
            offsetForMessageCenter = 150;
        }
        homeLayer.masteryLbl = utilObj.getBMFontLabel(starCount + "", constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 300 + xOffset, yPos - 70, 0, 0.5, labelArr, homeLayer, zOrder + 1);


        xPos = xLeftPos - 60;
        if (layoutExperimentVariant == constantsObj.EXP_VAR_3) {
            if (subscriptionsDTCObj.getIsSubscriptionActive()) {
                var diamond = utilObj.getSprite(constantsObj.diamond, xLeftPos + (100 * canvasWidth / 1440), localYPos - 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_8, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_MISC);
                //Shain Animation
                if (ftueObj.isFtueShown() && ftueObj.isAchievementFtueShown() && !gameObj.getPackFtueVisible() && !gameObj.getdailyMiniFtueVisible()) {
                    var xPos = diamond.getPositionX();
                    var yPos1 = diamond.getPositionY();
                    var width = diamond.getContentSize().width * constantsObj.SCALE_SPRITE_8/* / (constantsObj.SCALE_SPRITE_9 * 1.5)*/;
                    var height = diamond.getContentSize().height * constantsObj.SCALE_SPRITE_8/* / (constantsObj.SCALE_SPRITE_9 * 1.5)*/;

                    var xBottom = xPos - width / 2;
                    var xTop = xPos + width / 2;
                    var yLeft = yPos1 - height / 2;
                    var yRight = yPos1 + height / 2;

                    var posArr = [{x: xPos + width / 4, y: yRight}, {
                        x: xPos + 5,
                        y: yLeft
                    }, {x: xPos, y: yRight}, {x: xBottom, y: yPos1}, {x: xPos + width / 4, y: yRight}, {
                        x: xBottom,
                        y: yPos1
                    }, {x: xPos + width / 4, y: yRight}, {x: xPos, y: yRight}];
                    var shainSpriteArr = [];

                    for (var i in posArr) {
                        var shainSprite = utilObj.getSprite(constantsObj.shain, posArr[i].x, posArr[i].y, 0.5, 0.5, constantsObj.SCALE_SPRITE_10, null, null, constantsObj.FTUE_Z_ORDER + 2, constantsObj.SPRITE_MISC);
                        utilObj.addChild(homeLayer, shainSprite, constantsObj.FTUE_Z_ORDER + 2);
                        utilObj.setScale(shainSprite, 0);
                        shainSpriteArr.push(shainSprite);
                        subscriptionsLaunchLayer.spritesArrToRemove.push(shainSprite);
                    }

                    utilObj.delayedCallback(homeLayer, animObj.addShainAnimationHome, 0.02, {
                        arr: shainSpriteArr,
                        screen: homeLayer
                    });
                }

                // var diamondSprite = utilObj.getSprite(constantsObj.diamond, xPos, yPos1, 0.5, 0.5, constantsObj.SCALE_SPRITE_8, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_MISC);
                // animObj.animateImage(diamondSprite, 0.5, 2.0);
                var subsButton = utilObj.getButton(140, 140, 0, 0.5,
                    xLeftPos + (40 * canvasWidth / 1440), localYPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                        obj: 'homeLayer',
                        fn: 'showSubsDailyStatus',
                        screen: homeLayer.screen,
                        // buttonBg: gameLayer.bg,
                        track: {
                            k: constantsObj.TRACK_DIALOG,
                            p: gameObj.getCurPuzzleTracking(),
                            c: gameObj.getTrackingPuzzleTheme(),
                            o: constantsObj.TRACK_HOME,
                            f: constantsObj.TRACK_DIAMOND,
                            g: "",
                            s: "",
                            co: 1,
                            oppId: ""
                        },
                    }, false, ccui.Widget.PLIST_TEXTURE, constantsObj.SCALE_ONE);
                //homeLayer.addChild(msgButton, zOrder + 1);
                utilObj.addChild(homeLayer, subsButton, zOrder);
            } else if (subscriptionsObj.getSubPkgId() != "" && subscriptionsObj.getSubPkgId() != null && subscriptionsDTCObj.getIsSubscriptionInActive()) {
                var diamond = utilObj.getSprite(constantsObj.diamond_grey, xLeftPos + (100 * canvasWidth / 1440), localYPos - 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_8, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_MISC);
                var subsButton = utilObj.getButton(140, 140, 0, 0.5,
                    xLeftPos + (40 * canvasWidth / 1440), localYPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                        obj: 'homeLayer',
                        fn: 'showSubsPopupOffer',
                        screen: homeLayer.screen,
                        // buttonBg: gameLayer.bg,
                        track: {
                            k: constantsObj.TRACK_PUZZLE,
                            p: gameObj.getCurPuzzleTracking(),
                            c: gameObj.getTrackingPuzzleTheme(),
                            o: constantsObj.TRACK_HOME,
                            f: constantsObj.TRACK_DIAMOND_GREY,
                            g: "",
                            s: "",
                            co: 1,
                            oppId: ""
                        },
                    }, false, ccui.Widget.PLIST_TEXTURE, constantsObj.SCALE_ONE);
                //homeLayer.addChild(msgButton, zOrder + 1);
                utilObj.addChild(homeLayer, subsButton, zOrder);
            } else {
                var msgButton = utilObj.getButton(140, 140, 0, 0.5,
                    xLeftPos + (40 * canvasWidth / 1440), localYPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                        obj: 'homeLayer',
                        fn: 'showMsgCenter',
                        screen: homeLayer.screen,
                        // buttonBg: gameLayer.bg,
                        track: {
                            k: constantsObj.TRACK_PUZZLE,
                            p: gameObj.getCurPuzzleTracking(),
                            c: gameObj.getTrackingPuzzleTheme(),
                            o: constantsObj.TRACK_HOME,
                            f: constantsObj.TRACK_MSG,
                            g: "",
                            s: "",
                            co: 1,
                            oppId: ""
                        },
                    }, false, ccui.Widget.PLIST_TEXTURE, constantsObj.SCALE_ONE);
                //homeLayer.addChild(msgButton, zOrder + 1);
                utilObj.addChild(homeLayer, msgButton, zOrder);
                homeLayer.msgIcon = utilObj.getSprite(constantsObj.message_icon, xLeftPos + (40 * canvasWidth / 1440), localYPos - 2, 0, 0.5, constantsObj.SCALE_SPRITE_11, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_MISC);
            }
        }

        //Achievement header
        yPos += 100;
        var currentTime = utilObj.getCurrentTimestamp();
        var date = gameObj.getTodaysPuzzleDate();
        var id = utilObj.getIdForDate(date);
        // loggerObj.debugLog("hello1", date, gameObj.getInstallDay());
        //if (gameObj.getInstallDay() != id) {
        // loggerObj.debugLog("hello2", id, gameObj.getInstallDay());
        yPos -= 240;
        var themedQuestData = themedQuestObj.getThemedQuestData();
        var starsAchieved = gameObj.getThemedQuestMastery();
        var totalStars = null;
        var mileStones1 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(0));
        var mileStones2 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(1));
        var mileStones3 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(2));
        var milestones = [mileStones1, mileStones2, mileStones3];

        var coinsArr = null;
        var curTimestamp = gameObj.getLastSync();
        //var curTimestamp =utilObj.getCurrentTimestamp();


        if (epmObj.getChosenVariant(constantsObj.EXP_PRICING) == constantsObj.EXP_VAR_6) {
            coinsArr = themedQuestData["coinsExp2"];
        } else {
            coinsArr = themedQuestData["coinsExp1"];
        }
        var milestonesCompleted = gameObj.getThemedQuestMilestonesCompleted();
        var factor = 1;
        var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
        // if (gameObj.getIsThemedQuestFinished() == true && ) {
        //     if(milestonesCompleted[2] == 0) {
        //         milestonesCompleted[2] = 1;
        //         totalStars = starsAchieved;
        //         gameObj.setThemedQuestMilestonesCompleted(milestonesCompleted);
        //         economyObj.addCash(coinsArr[2]);
        //         utilObj.showMessage(coinsArr[2] + " " + " coins have been rewarded");
        //     }
        // }  gameObj.getThemedQuestMastery() < themedQuestData["totalStars"]
        // var checkDone = gameObj.getCheckDone();
        // if (!checkDone) {
        //
        //     if (gameObj.getIsWeeklyQuestLocked() == true && gameObj.getNewUser() == null) {
        //
        //         if (gameObj.getMastery1() >= 5) {
        //             gameObj.setCheckDone(true);
        //             checkDone =gameObj.getCheckDone();
        //
        //         }
        //     }
        // }
        // loggerObj.debugLog("themedQuestCheck5", gameObj.getIsThemedQuestLocked(), gameObj.getIsThemedQuestFinished(), gameObj.getWeeklyQuestMastery(), gameObj.getMastery1(), utilObj.getCurrentTimestamp());
        if (curTimestamp >= themedQuestData.start && curTimestamp < themedQuestData.end && utilObj.getCurrentTimestamp() >= themedQuestData.start && utilObj.getCurrentTimestamp() < themedQuestData.end && gameObj.getIsThemedQuestLocked() == false && gameObj.getIsThemedQuestFinished() == false) {

            // loggerObj.debugLog("hello",checkDone,epmObj.getChosenVariant(constantsObj.EXP_THEMED_QUEST));
            // if (checkDone == true) {
            //     gameObj.setNewUser(1);
            // }
            // loggerObj.debugLog("themedQuestCheck4", starsAchieved);
            if (starsAchieved >= weeklyQuestObj.getWeeklyQuestTotalstars()) {
                homeLayer.achievementBackground = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, yPos, 0.5, 1, canvasWidth, 250, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_MISC);
                homeLayer.achievementBackground.setColor(constantsObj.COLOR_DARK_BLUE_07);
                gameObj.setIsThemedQuestLocked(true);
                gameObj.setIsThemedQuestFinished(true);
                themedQuestObj.updateCash(homeLayer, homeLayer.cashLbl);
                if (milestonesCompleted[2] == 1) {
                    var raysImage = utilObj.getSprite(constantsObj.rays_achievement, centerXPos - canvasWidth / 6, yPos, 0.5, 1, constantsObj.SCALE_SPRITE_3 * 1.5, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_MISC);
                    raysImage.setColor(constantsObj.COLOR_WHITE);
                    raysImage.setOpacity(constantsObj.OPACITY_10);
                    //utilObj.addChild(homeLayer, raysImage, zOrder);

                    // updates all the achievement status here


                    // updates the achievements whose reward has been already granted to claimed state
                    achievementsObj.checkForAchievements();
                    achievementsObj.checkForClaimedAchievements();
                    homeLayer.populateAchievements(yPos, spriteArr, labelArr);
                    // if(!ftueObj.isAchievementFtueShown()){
                    //     ftueObj.showAchievementFtue();
                    // }

                    // milestonesCompleted[2] = 1;
                    totalStars = starsAchieved;
                    // gameObj.setThemedQuestMilestonesCompleted(milestonesCompleted);
                    // economyObj.addCash(coinsArr[2], constantsObj.TRACK_EARN, constantsObj.TRACK_TQ_3, "");
                    // utilObj.showMessage(coinsArr[2] + " " + " coins have been rewarded");
                }
            } else {

                // for storing the last quest mastery for runtimes
                gameObj.setLastSeenQuest(constantsObj.THEMED_QUEST_SEEN);

                homeLayer.achievementBackground = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, yPos, 0.5, 1, canvasWidth, 250, spriteArr, homeLayer, zOrder - 1, constantsObj.SPRITE_MISC);
                // setting gradients color from left to right
                var color_bgLeftColorCode = homeObj.getColorFromStringCode(themedQuestData["BGleftcolorcode"]);
                var color_bgRightColorCode = homeObj.getColorFromStringCode(themedQuestData["BGrightcolorcode"]);

                var color_theme = new cc.LayerGradient(color_bgLeftColorCode, color_bgRightColorCode, null, null);
                color_theme.anchorX = 0.5;
                color_theme.anchorY = 1;
                color_theme.ignoreAnchorPointForPosition(false);
                color_theme.setPositionX(centerXPos);
                color_theme.setPositionY(yPos);
                color_theme.width = canvasWidth;
                color_theme.height = 250;
                color_theme.setVector(new cc.p(1, 0));
                utilObj.addChild(homeLayer, color_theme, zOrder);

                var transButton = utilObj.getButton(canvasWidth, 250, 0, 1.0, xPos, yPos,
                    constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                        obj: 'themedQuestStartPopup',
                        fn: 'delayedShow',
                        params: {source: constantsObj.TRACK_TQ_HOME},
                        screen: homeLayer.screen,
                        track: {
                            k: constantsObj.TRACK_DIALOG,
                            p: "",
                            c: "",
                            o: constantsObj.TRACK_HOME,
                            f: constantsObj.TRACK_TQ,
                            g: "",
                            s: "",
                            co: "",
                            oppId: ""
                        },
                    }, false, ccui.Widget.PLIST_TEXTURE, 1);
                utilObj.addChild(homeLayer, transButton, zOrder + 1);


                // Check whether to run animation for a user where out of memory is coming repetitively
                if (gameObj.getShouldPlistRun()) {
                    // ---- Animation block for tq
                    // ---- commented params on type of animation that is given for particular tq

                    var stencil = new cc.DrawNode();
                    stencil.drawRect(cc.p(xLeftPos, homeLayer.achievementBackground.getPositionY() - 250), cc.p(canvasWidth, homeLayer.achievementBackground.getPositionY() - 2), cc.color(255, 0, 0, 255), 3, cc.color(0, 255, 0, 255));
                    var content = cc.ClippingNode(stencil);
                    utilObj.addChild(homeLayer, content, zOrder);

                    var plistCountToRun = parseInt(themedQuestData["plistCount"]);
                    var plistOrientationArr = [themedQuestData["plistOrientation1"], themedQuestData["plistOrientation2"], themedQuestData["plistOrientation3"]];

                    // run through number of plists to run
                    // MAX of 3 plists can run at same time
                    for (var i = 0; i < plistCountToRun; i++) {
                        var orientation = plistOrientationArr[i];
                        var positionX = centerXPos;
                        var positionY = centerYPos;

                        // check orientation and update positions for plists
                        if (orientation == "TOP") {
                            positionY = homeLayer.achievementBackground.getPositionY() + 10;
                        } else if (orientation == "LEFT") {
                            positionX = xLeftPos - 10;
                            positionY = yPos - 125;
                        } else if (orientation == "RIGHT") {
                            positionX = xRightPos + 10;
                            positionY = yPos - 125;
                        } else if (orientation == "BOTTOM") {
                            positionY = homeLayer.achievementBackground.getPositionY() - 260;
                        } else if (orientation == "CENTER") {
                            positionY = homeLayer.achievementBackground.getPositionY() - 125;
                        }

                        var params = {
                            x: positionX,
                            y: positionY,
                            layer: content,
                            scale: 0.75,
                            zOrder: zOrder - 1
                        };

                        // run based on the i value for plists
                        switch(i) {
                            case 0:
                                utilObj.delayedCallback(content, effectsObj.playSnowEffect, 0, params, false);
                                break;
                            case 1:
                                utilObj.delayedCallback(content, effectsObj.playSnowEffect2, 0, params, false);
                                break;
                            case 2:
                                utilObj.delayedCallback(content, effectsObj.playSnowEffect3, 0, params, false);
                                break;
                        }
                    }

                    // ---- Animation block for tq ends
                }
                // Can use diff. animation based on type

                themedQuestObj.updateCash(homeLayer, homeLayer.cashLbl);
                // timer label text color settings
                var color_daysLeftTextColorCode = homeObj.getColorFromStringCode(themedQuestData["Dayslefttextcolorcode"]);
                var timerLabel = utilObj.getBMFontLabel(themedQuestObj.getTqHomeTimerText(), constantsObj.FONT_HELVETICA_MEDIUM_45, color_daysLeftTextColorCode,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xLeftPos + 32 + ((700 * 0.3) / 2), yPos - 167, 0.5, 1, labelArr, homeLayer, zOrder);

                themedQuestObj.setTqHomeTimerLabel(timerLabel);

                // play button settings
                var playButton = utilObj.getButton(230, 90, 0.5, 1.0, xRightPos - 170, yPos - 75,
                    constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                        obj: 'themedQuestStartPopup',
                        fn: 'gameScreen',
                        screen: homeLayer.screen,
                        track: {
                            k: constantsObj.TRACK_DIALOG,
                            p: "",
                            c: "",
                            o: constantsObj.TRACK_HOME,
                            f: constantsObj.TRACK_TQ,
                            g: constantsObj.TRACK_PLAY,
                            s: "",
                            co: "",
                            oppId: ""
                        },
                    }, false, ccui.Widget.PLIST_TEXTURE, 1);

                utilObj.getBMFontLabel("Play", constantsObj.FONT_HELVETICA_BOLD_60, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xRightPos - 170, yPos - 115, 0.5, 0.5, labelArr, homeLayer, zOrder + 1);


                //play button color change
                var color_playButtonColorCode = homeObj.getColorFromStringCode(themedQuestData["Playbuttoncolorcode"]);
                playButton.setColor(color_playButtonColorCode);
                utilObj.addChild(homeLayer, playButton, zOrder + 1);

                // play text color settings
                var color_playTextColorCode = homeObj.getColorFromStringCode(themedQuestData["Playtextcolorcode"]);
                utilObj.getBMFontLabel(themedQuestData["Playbuttontext"], constantsObj.FONT_HELVETICA_BOLD_60, color_playTextColorCode,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xRightPos - 170, yPos - 115, 0.5, 0.5, labelArr, homeLayer, zOrder + 1);

                // tq header text color settings
                var color_tqTileTextColorCode = homeObj.getColorFromStringCode(themedQuestData["TQtiletextcolorcode"]);
                utilObj.getBMFontLabel(themedQuestData["TQtitletext"], constantsObj.FONT_HELVETICA_MEDIUM_70, color_tqTileTextColorCode,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xLeftPos + 270, yPos - 10, 0, 1, labelArr, homeLayer, zOrder + 1);

                // tq desc text color settings
                var color_tqDescTextColorCode =  homeObj.getColorFromStringCode(themedQuestData["TQDesctextcolorcode"]);
                utilObj.getBMFontLabel(themedQuestData["TQDesctext"], constantsObj.FONT_HELVETICA_MEDIUM_45, color_tqDescTextColorCode,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xLeftPos + 270, yPos - 95, 0, 1, labelArr, homeLayer, zOrder + 1);

                var theme_icon = utilObj.getSprite(constantsObj.themed_quest_progress_icon_1, xLeftPos + 60, yPos - 15, 0, 1.0, constantsObj.SCALE_TWO * 0.35, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_LOCAL);

                // progress bg color code
                var color_pbBarBgColorCode = homeObj.getColorFromStringCode(themedQuestData["PBbarbgcolorcode"]);
                var progressBg = utilObj.getScale9Sprite(constantsObj.full_bar, xLeftPos + 270, yPos - 165, 0, 1, 750, 55, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_LOCAL);
                progressBg.setColor(color_pbBarBgColorCode);
                progressBg.setOpacity(constantsObj.OPACITY_30);

                // progress bar fill code
                var color_pbBarFillColorCode = homeObj.getColorFromStringCode(themedQuestData["PBbarfillcolorcode"]);
                var progress = utilObj.getScale9Sprite(constantsObj.full_bar, xLeftPos + 270, yPos - 165, 0, 1, 750 * (starsAchieved / weeklyQuestObj.getWeeklyQuestTotalstars()), 55, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_LOCAL);
                progress.setColor(color_pbBarFillColorCode);

                var totalStarsLabel = 0;
                if (starsAchieved < milestones[0]) {
                    totalStarsLabel = milestones[0];
                } else if (starsAchieved >= milestones[0] && starsAchieved < milestones[1]) {
                    totalStarsLabel = milestones[1];
                } else if (starsAchieved >= milestones[1] && starsAchieved < milestones[2]) {
                    totalStarsLabel = milestones[2];
                } else if(starsAchieved >= milestones[2]){
                    totalStarsLabel = milestones[2];
                }

                // progress bar value color settings
                var color_progressBarValueColorCode =  homeObj.getColorFromStringCode(themedQuestData["ProgressBar_valuecolor"]);
                utilObj.getBMFontLabel(starsAchieved + "/" + totalStarsLabel, constantsObj.FONT_HELVETICA_BOLD_40, color_progressBarValueColorCode,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xLeftPos + 290 + 330, yPos - 167, 0, 1, labelArr, homeLayer, zOrder);

                for (var i = 0; i < 2; i++) {
                    var progressPointer = utilObj.getSprite(constantsObj.themed_quest_progress_pointer, xLeftPos + 270 + (milestones[i] / weeklyQuestObj.getWeeklyQuestTotalstars()) * 750, yPos - 210, 0.5, 1, constantsObj.SCALE_SPRITE_18 * 1.5, spriteArr, homeLayer, zOrder + 1, constantsObj.SPRITE_MISC);
                    // arrow color code
                    var color_arrowColorCode = homeObj.getColorFromStringCode(themedQuestData["ArrowColorcode"]);
                    progressPointer.setColor(color_arrowColorCode);
                }
                utilObj.getSprite(constantsObj.tq_gift3, xLeftPos + 270 + 740, yPos - 178.5, 0, 0.5, constantsObj.SCALE_ONE * 1.18, spriteArr, homeLayer, zOrder + 1, constantsObj.SPRITE_MISC);


            }
        } else if (gameObj.getIsWeeklyQuestLocked() == false && (weeklyQuestExp == constantsObj.EXP_VAR_1 || weeklyQuestExp == constantsObj.EXP_VAR_2 || weeklyQuestExp == constantsObj.EXP_VAR_3 || weeklyQuestExp == constantsObj.EXP_VAR_4)) {

            // weeklyQuestIntroPopup.show();
            //var weeklyQuestData = weeklyQuestObj.getWeeklyQuestData();
            var starsAchieved = gameObj.getWeeklyQuestMastery();
            var totalStars = null;
            var mileStones1 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(0));
            var mileStones2 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(1));
            var mileStones3 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(2));
            var milestones = [mileStones1, mileStones2, mileStones3];
            var coinsArr = null;
            var curTimestamp = gameObj.getLastSync();


            var milestonesCompleted = gameObj.getWeeklyQuestMilestonesCompleted();
            if (milestonesCompleted == null) {
                milestonesCompleted = [0, 0, 0];
                gameObj.setWeeklyQuestMilestonesCompleted(milestonesCompleted);
                gameObj.setWeeklyQuestCompleted(false);
            }


            // Already completed weeklyQuest cond.
            if (starsAchieved >= weeklyQuestObj.getWeeklyQuestTotalstars()) {

                homeLayer.gift = utilObj.getSprite(constantsObj.weekly_quest_reward2, xLeftPos + 310 + (weeklyQuestObj.getWeeklyQuestMilestones(2) / weeklyQuestObj.getWeeklyQuestTotalstars()) * 750, yPos - 180, 0.5, 0.5, constantsObj.SCALE_SPRITE_18 * 0.7, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_LOCAL);
                utilObj.setVisible(homeLayer.gift, false);
                homeLayer.achievementBackground = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, yPos, 0.5, 1, canvasWidth, 250, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_MISC);
                homeLayer.achievementBackground.setColor(constantsObj.COLOR_DARK_BLUE_07);
                gameObj.setIsWeeklyQuestLocked(true);
                weeklyQuestObj.updateCash(homeLayer, homeLayer.cashLbl);
                if (milestonesCompleted[2] == 1) {
                    var raysImage = utilObj.getSprite(constantsObj.rays_achievement, centerXPos - canvasWidth / 6, yPos, 0.5, 1, constantsObj.SCALE_SPRITE_3 * 1.5, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_MISC);
                    raysImage.setColor(constantsObj.COLOR_WHITE);
                    raysImage.setOpacity(constantsObj.OPACITY_10);
                    achievementsObj.checkForAchievements();
                    achievementsObj.checkForClaimedAchievements();
                    homeLayer.populateAchievements(yPos, spriteArr, labelArr);
                    totalStars = starsAchieved;
                }

            } else {

                // for storing the last quest mastery for runtimes
                gameObj.setLastSeenQuest(constantsObj.WEEKLY_QUEST_SEEN);

                // InProgress Weekly Quest
                homeLayer.achievementBackground = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, yPos, 0.5, 1, canvasWidth, 250, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_MISC);
                homeLayer.achievementBackground.setVisible(false);

                var color_theme = new cc.LayerGradient(constantsObj.COLOR_WQ_END, constantsObj.COLOR_WQ_START, null, null);
                color_theme.anchorX = 0.5;
                color_theme.anchorY = 1;
                color_theme.ignoreAnchorPointForPosition(false);
                color_theme.setPositionX(centerXPos);
                color_theme.setPositionY(yPos);
                color_theme.width = canvasWidth;
                color_theme.height = 250;
                color_theme.setVector(new cc.p(1, 0));
                utilObj.addChild(homeLayer, color_theme, zOrder);

                var transButton = utilObj.getButton(canvasWidth, 250, 0, 1.0, xPos, yPos,
                    constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                        obj: 'weeklyQuestStartPopup',
                        fn: 'delayedShow',
                        params: {source: constantsObj.TRACK_WQ_HOME},
                        screen: homeLayer.screen,
                        track: {
                            k: constantsObj.TRACK_DIALOG,
                            p: "",
                            c: "",
                            o: constantsObj.TRACK_HOME,
                            f: constantsObj.TRACK_WQ,
                            g: "",
                            s: "",
                            co: "",
                            oppId: ""
                        },
                    }, false, ccui.Widget.PLIST_TEXTURE, 1);
                utilObj.addChild(homeLayer, transButton, zOrder + 1);

                var timerLabel = utilObj.getBMFontLabel(weeklyQuestObj.getWqHomeTimerText(), constantsObj.FONT_HELVETICA_MEDIUM_40, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xLeftPos + 32 + ((750 * 0.3) / 2), yPos - 182, 0.5, 1, labelArr, homeLayer, zOrder);
                weeklyQuestObj.setWqHomeTimerLabel(timerLabel);


                var playButton = utilObj.getButton(250, 100, 0.5, 1.0, xRightPos - 170, yPos - 75,
                    constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                        obj: 'weeklyQuestStartPopup',
                        fn: 'gameScreen',
                        screen: homeLayer.screen,
                        track: {
                            k: constantsObj.TRACK_DIALOG,
                            p: "",
                            c: "",
                            o: constantsObj.TRACK_HOME,
                            f: constantsObj.TRACK_WQ,
                            g: constantsObj.TRACK_PLAY,
                            s: "",
                            co: "",
                            oppId: ""
                        },
                    }, false, ccui.Widget.PLIST_TEXTURE, 1);
                playButton.setColor(constantsObj.COLOR_GREEN_11);
                utilObj.addChild(homeLayer, playButton, zOrder + 1);

                utilObj.getBMFontLabel("Play", constantsObj.FONT_HELVETICA_BOLD_60, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xRightPos - 170, yPos - 125, 0.5, 0.5, labelArr, homeLayer, zOrder + 1);


                var totalStars = weeklyQuestObj.getWeeklyQuestTotalstars();

                utilObj.getBMFontLabel("Weekly Quest", constantsObj.FONT_HELVETICA_MEDIUM_70, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xLeftPos + 270, yPos - 10, 0, 1, labelArr, homeLayer, zOrder + 1);

                utilObj.getBMFontLabel(stringsObj.weeklyQuestBannerText, constantsObj.FONT_HELVETICA_MEDIUM_45, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xLeftPos + 270, yPos - 90, 0, 1, labelArr, homeLayer, zOrder + 1);

                var theme_icon = utilObj.getSprite(constantsObj.weeklyQuestNew, xLeftPos + 60, yPos - 20, 0, 1.0, constantsObj.SCALE_TWO * 0.38, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_LOCAL);

                var params2 = {
                    x: xLeftPos + 60 + (theme_icon.getContentSize().width * constantsObj.SCALE_TWO * 0.45) + 5,
                    y: homeLayer.achievementBackground.getPositionY() - 100,
                    layer: homeLayer,
                    scale: 1,
                    zOrder: zOrder - 1
                };

                var progressBg = utilObj.getScale9Sprite(constantsObj.full_bar, xLeftPos + 270, yPos - 165, 0, 1, 750, 55, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_LOCAL);
                progressBg.setColor(constantsObj.COLOR_BLACK);
                progressBg.setOpacity(constantsObj.OPACITY_15);

                var progress = utilObj.getScale9Sprite(constantsObj.full_bar, xLeftPos + 270, yPos - 165, 0, 1, 750 * (starsAchieved / totalStars), 55, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_LOCAL);
                progress.setColor(constantsObj.COLOR_BLUE_14);

                var totalStarsLabel = 0;
                if (starsAchieved < milestones[0]) {
                    totalStarsLabel = milestones[0];
                } else if (starsAchieved >= milestones[0] && starsAchieved < milestones[1]) {
                    totalStarsLabel = milestones[1];
                } else if (starsAchieved >= milestones[1] && starsAchieved < milestones[2]) {
                    totalStarsLabel = milestones[2];
                } else if(starsAchieved >= milestones[2]){
                    totalStarsLabel = milestones[2];
                }
                utilObj.getBMFontLabel(starsAchieved + "/" + totalStarsLabel, constantsObj.FONT_HELVETICA_BOLD_40, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xLeftPos + 290 + 330, yPos - 167, 0, 1, labelArr, homeLayer, zOrder);

                for (var i = 0; i < 2; i++) {
                    var progressPointer = utilObj.getSprite(constantsObj.themed_quest_progress_pointer, xLeftPos + 290 + (milestones[i] / totalStars) * 750, yPos - 210, 0.5, 1, constantsObj.SCALE_SPRITE_18 * 1.5, spriteArr, homeLayer, zOrder + 1, constantsObj.SPRITE_MISC);
                    progressPointer.setColor(constantsObj.COLOR_BLACK);
                }

                homeLayer.gift =  utilObj.getSprite(constantsObj.tq_gift3, xLeftPos + 270 + 740, yPos - 178.5, 0, 0.5, constantsObj.SCALE_ONE * 1.18, spriteArr, homeLayer, zOrder + 1, constantsObj.SPRITE_MISC);
                weeklyQuestObj.updateCash(homeLayer, homeLayer.cashLbl);
            }

        } else {
            if (gameObj.checkIfAllAchievementsDone() == false) {
                homeLayer.achievementBackground = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, yPos, 0.5, 1, canvasWidth, 250, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_MISC);
                homeLayer.achievementBackground.setColor(constantsObj.COLOR_DARK_BLUE_07);
                var raysImage = utilObj.getSprite(constantsObj.rays_achievement, centerXPos - canvasWidth / 6, yPos, 0.5, 1, constantsObj.SCALE_SPRITE_3 * 1.5, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_MISC);
                raysImage.setColor(constantsObj.COLOR_WHITE);
                raysImage.setOpacity(constantsObj.OPACITY_10);

                achievementsObj.checkForAchievements();
                achievementsObj.checkForClaimedAchievements();
                homeLayer.populateAchievements(yPos, spriteArr, labelArr);
            }
        }

        utilObj.delayedCallback(homeLayer, homeLayer.delayedShowBannerAd, 4.0, null, null);


        var shadow = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, yPos - 250, 0.5, 1, canvasWidth, 100, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_LOCAL);
        shadow.setColor(constantsObj.COLOR_WHITE_01);
        xPos = xLeftPos;
        var d = gameObj.getTodaysPuzzleDate();
        var day = d.getDay();
        var sectionsForInProgress = homeLayer.getSectionsForRecentPuzzles();

        homeLayer.toShowDailyMini = utilObj.checkForShowingTodaysPuzzle();


        var recentUnopenedPuzzles = [];
        var curTime = d.getTime();
        var count = 2;
        var startTimestamp = 1488326400000;
        var milliSecInDay = 86400000;
        var inProgress = gameObj.getInProgress();
        var counter = 0;
        var todaysFreePuzzle = gameObj.getTodaysFreePuzzle();
        var cb = "loadTodaysPuzzle";
        var hasFreeTag = true;
        var herosPosText = stringsObj.TODAYS_PUZZLE;
        var playIcon = null;

        if (subscriptionsDTCObj.checkSubscriptionStatus() == constantsObj.SUBSCRIPTION_ACTIVE && (runtimeObj.getBonusArchiveSwitch() == 1)) {
            var recentUnopenedPuzzles = [];
            var curTime = d.getTime();
            var count = 2;
            var startTimestamp = 1488326400000;
            var milliSecInDay = 86400000;
            var inProgress = gameObj.getInProgress();
            var counter = 0;
            var firstDay = gameObj.getFirstLoadTime();
            var ftueArchiveDate = new Date(firstDay);
            var ftueDate = new Date(firstDay);
            ftueArchiveDate.setDate(ftueDate.getDate() - 1);
            var archivePuzzle = utilObj.getIdForDate(ftueArchiveDate);
            while (curTime > startTimestamp) {
                curTime -= milliSecInDay;
                var date = new Date(curTime);
                var id = utilObj.getIdForDate(date);
                if (parseInt(id) < 20170301) {
                    continue;
                }
                if (inProgress[id] == undefined && scoresObj.getMastery(id) == 0) {
                    if ((todaysFreePuzzle != null && todaysFreePuzzle == id && gameObj.getTodaysPuzzleCompleted1()) || archivePuzzle == id) {
                        continue;
                    }
                    recentUnopenedPuzzles.push(date);
                    counter++;
                }
                if (counter == count) {
                    break;
                }
            }
            var subTodaysFreePuzzle = gameObj.getSubsTodaysFreePuzzle();
            if (subTodaysFreePuzzle != null && subTodaysFreePuzzle != undefined) {
                if (scoresObj.getMastery(subTodaysFreePuzzle) != 0) {
                    gameObj.setSubCompletedTodaysFreePuzzle(true);
                }
            }

            if (gameObj.getTodaysPuzzleCompleted1()) {
                if ((gameObj.getSubsTodaysFreePuzzle() == null || gameObj.getSubCompletedTodaysFreePuzzle()) && gameObj.getFreeArchivePuzzleSub() > 0 && recentUnopenedPuzzles.length > 0) {
                    d = recentUnopenedPuzzles[0];
                    day = d.getDay();
                    gameObj.setSubsTodaysFreePuzzle(utilObj.getIdForDate(d));
                    gameObj.setSubCompletedTodaysFreePuzzle(false);
                }
            } else {
                gameObj.setSubCompletedTodaysFreePuzzle(false);
                gameObj.setSubsTodaysFreePuzzle(null);
            }
            loggerObj.debugLog("coming to this point -", d, gameObj.getSubsTodaysFreePuzzle());
        }
        var inProgress1 = gameObj.getInProgress();

        if (subscriptionsDTCObj.checkSubscriptionStatus() == constantsObj.SUBSCRIPTION_ACTIVE && gameObj.getTodaysPuzzleCompleted1() && gameObj.getSubsTodaysFreePuzzle() != null && gameObj.getFreeArchivePuzzleSub() > 0 && !gameObj.getSubCompletedTodaysFreePuzzle()) {
            cb = "loadSubsPuzzle";
            herosPosText = stringsObj.PREMIUM_ARCHIVE_PUZZLE;
            d = utilObj.getDateForId(gameObj.getSubsTodaysFreePuzzle());
            day = d.getDay();
            loggerObj.debugLog("coming to this point - 12");
        }


        if (cb != "loadSubsPuzzle" && (runtimeObj.getBonusArchiveSwitch() == 1)) {
            var recentUnopenedPuzzles = [];
            //loggerObj.debugLog("dayy", d);
            var curTime = d.getTime();
            var count = 2;
            var startTimestamp = 1488326400000;
            var milliSecInDay = 86400000;
            var inProgress = gameObj.getInProgress();
            var counter = 0;
            var todaysFreePuzzle = gameObj.getTodaysFreePuzzle();
            var firstDay = gameObj.getFirstLoadTime();
            var ftueArchiveDate = new Date(firstDay);
            var ftueDate = new Date(firstDay);
            ftueArchiveDate.setDate(ftueDate.getDate() - 1);
            var archivePuzzle = utilObj.getIdForDate(ftueArchiveDate);
            playIcon = constantsObj.video_icon;
            while (curTime > startTimestamp) {
                curTime -= milliSecInDay;
                var date = new Date(curTime);
                var id = utilObj.getIdForDate(date);
                if (parseInt(id) < 20170301) {
                    continue;
                }
                if (inProgress[id] == undefined && scoresObj.getMastery(id) == 0) {
                    if ((todaysFreePuzzle != null && todaysFreePuzzle == id && gameObj.getTodaysPuzzleCompleted1()) || archivePuzzle == id) {
                        continue;
                    }
                    recentUnopenedPuzzles.push(date);
                    counter++;
                    //loggerObj.debugLog("datesss", date);
                }
                //loggerObj.debugLog("inprogress", JSON.stringify(gameObj.get));
                if (counter == count) {
                    break;
                }
            }
            if (todaysFreePuzzle != null && todaysFreePuzzle != undefined) {
                if (scoresObj.getMastery(todaysFreePuzzle) != 0) {
                    if (scoresObj.getHighScore(todaysFreePuzzle) > 0 && (gameObj.getNumberOfBonusArchiveWatched() + questMapObj.getNumberOfBonusArchiveWatched()) < runtimeObj.getNumberOfBonusArchive()) {
                        gameObj.setTodaysFreePuzzle(null);
                    } else {
                        gameObj.setCompletedTodaysFreePuzzle(true);
                    }
                }
            }
            if (gameObj.getTodaysPuzzleCompleted1()) {
                herosPosText = stringsObj.BONUS_ARCHIVE_PUZZLE;
                if ((gameObj.getNumberOfBonusArchiveWatched() + questMapObj.getNumberOfBonusArchiveWatched()) >= runtimeObj.getNumberOfBonusArchive()) {
                    gameObj.setCompletedTodaysFreePuzzle(true);
                }
                if (!gameObj.getCompletedTodaysFreePuzzle() && (!gameObj.getViewedTodaysFreePuzzle() || gameObj.getTodaysFreePuzzle() == null) && recentUnopenedPuzzles.length > 0 && (gameObj.getNumberOfBonusArchiveWatched() + questMapObj.getNumberOfBonusArchiveWatched()) < runtimeObj.getNumberOfBonusArchive()) {
                    d = recentUnopenedPuzzles[0];
                    day = d.getDay();
                    recentUnopenedPuzzles.splice(0, 1);
                    gameObj.setTodaysFreePuzzle(utilObj.getIdForDate(d));
                    gameObj.setNumberOfBonusArchiveWatched(gameObj.getNumberOfBonusArchiveWatched() + 1);
                    gameObj.setViewedTodaysFreePuzzle(true);
                    cb = "loadArchievePuzzle";
                    //loggerObj.debugLog("herosPos2",heroPosPuzzle);
                } else if (!gameObj.getCompletedTodaysFreePuzzle() && gameObj.getViewedTodaysFreePuzzle()) {
                    d = utilObj.getDateForId(gameObj.getTodaysFreePuzzle());
                    day = d.getDay();
                    cb = "loadArchievePuzzle";
                } else if (gameObj.getCompletedTodaysFreePuzzle() && recentUnopenedPuzzles.length > 0) {
                    var heroPosPuzzle = gameObj.getCurrentHeroPosPuzzle();
                    //loggerObj.debugLog("herePos1",scoresObj.getMastery(heroPosPuzzle),(heroPosPuzzle == null),(scoresObj.getMastery(heroPosPuzzle) != 0));
                    if (heroPosPuzzle == null || scoresObj.getMastery(heroPosPuzzle) != 0) {
                        d = recentUnopenedPuzzles[0];
                        recentUnopenedPuzzles.splice(0, 1);
                        gameObj.setCurrentHeroPosPuzzle(utilObj.getIdForDate(d));
                    } else {
                        d = utilObj.getDateForId(heroPosPuzzle);
                        if (inProgress[heroPosPuzzle] == undefined) {
                            recentUnopenedPuzzles.splice(0, 1);
                        }
                    }
                    day = d.getDay();
                    cb = "loadArchievePuzzle";
                    hasFreeTag = false;
                } else if (gameObj.getCompletedTodaysFreePuzzle() && recentUnopenedPuzzles.length == 0) {
                    var heroPosPuzzle = gameObj.getCurrentHeroPosPuzzle();
                    if (heroPosPuzzle == null) {
                        herosPosText = stringsObj.TODAYS_PUZZLE;
                    }
                    if (heroPosPuzzle != null && scoresObj.getMastery(heroPosPuzzle) == 0) {
                        d = utilObj.getDateForId(heroPosPuzzle);
                        day = d.getDay();
                        cb = "loadArchievePuzzle";
                        hasFreeTag = false;
                    } else if (heroPosPuzzle != null && scoresObj.getMastery(heroPosPuzzle) != 0) {
                        herosPosText = stringsObj.TODAYS_PUZZLE;
                    }
                }
                if (gameObj.getTodaysFreePuzzle() == null && recentUnopenedPuzzles.length == 0) {
                    herosPosText = stringsObj.TODAYS_PUZZLE;
                }
            } else {
                gameObj.setViewedTodaysFreePuzzle(false);
                gameObj.setCompletedTodaysFreePuzzle(false);
                gameObj.setNumberOfBonusArchiveWatched(0);
                gameObj.setTodaysFreePuzzle(null);
                gameObj.setCurrentHeroPosPuzzle(null);
            }

            // setting free tag as false as soon as puzzle goes to in progress

            if (cb == "loadTodaysPuzzle") {
                if (gameObj.getInstallDay() == utilObj.getIdForDate(gameObj.getTodaysPuzzleDate())) {
                    if (inProgress[gameObj.getD0Id()]) {
                        hasFreeTag = false;
                    }
                } else {
                    if (inProgress[utilObj.getIdForDate(d)]) {
                        hasFreeTag = false;
                    }
                }
            } else {
                if (inProgress[utilObj.getIdForDate(d)]) {
                    hasFreeTag = false;
                }
            }

            if (cb == "loadArchievePuzzle") {
                hasFreeTag = false;
            }
        }
        var dailyMiniArchiveVisibilityCondition = false;
        if (gameObj.getMasteryForBonusMiniArchive()) {
            dailyMiniArchiveVisibilityCondition = true;
        } else {
            if (gameObj.getMastery1() >= runtimeObj.getMasteryMiniArchiveCondition()) {
                gameObj.setMasteryForBonusMiniArchive(true);
                dailyMiniArchiveVisibilityCondition = true;
            }
        }

        var puzzleIdDailyMini = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
        puzzleIdDailyMini = stringsObj.mini_prefix + puzzleIdDailyMini.substr(2, puzzleIdDailyMini.length);
        homeLayer.subscriptionTag = 0;

        if (gameObj.getPuzzleCompleted(puzzleIdDailyMini) && epmObj.getChosenVariant(constantsObj.EXP_DAILY_MINI_BONUS) == constantsObj.EXP_VAR_1 && dailyMiniArchiveVisibilityCondition) {
            var dailyMini = gameObj.getDailyMiniArchiveId();
            if (dailyMini != null && !gameObj.getPuzzleCompleted(dailyMini)) {
                homeLayer.dailyMiniToShow = dailyMini;
            } else {
                var coolDownForDailyMiniArchive = runtimeObj.getCoolDownBonusDailyMini();
                if (subscriptionsDTCObj.getIsSubscriptionInActive()) {
                    coolDownForDailyMiniArchive = runtimeObj.getCoolDownBonusDailyMiniSubs();
                }
                if ((gameObj.getNumberOfBonusDailyMini() + questMapObj.getNumberOfBonusMiniWatched()) < coolDownForDailyMiniArchive || subscriptionsDTCObj.getIsSubscriptionActive()) {
                    homeLayer.dailyMiniToShow = gameObj.firstUnOpenedPuzzle(puzzleIdDailyMini);
                    if (homeLayer.dailyMiniToShow == null) {
                        homeLayer.dailyMiniToShow = gameObj.firstInProgressPuzzle(puzzleIdDailyMini);
                    }
                } else {
                    homeLayer.dailyMiniToShow = null;
                }
                gameObj.setDailyMiniArchiveId(homeLayer.dailyMiniToShow);
                if (homeLayer.dailyMiniToShow != null) {
                    gameObj.setNumberOfBonusDailyMini(gameObj.getNumberOfBonusDailyMini() + 1);
                }
            }
            if (homeLayer.dailyMiniToShow != null && gameObj.getPuzzleCompleted(homeLayer.dailyMiniToShow)) {
                homeLayer.dailyMiniToShow = null;
            }
        }
        var track_daily_mini = constantsObj.TRACK_DAILY_MINI;
        if (homeLayer.dailyMiniToShow != null) {
            track_daily_mini = constantsObj.TRACK_DAILY_MINI_BONUS;
        }

        // Subcription tag to be shown at which place if it is inactive.
        if (subscriptionsDTCObj.getIsSubscriptionInActive()) {
            homeLayer.subs_popup_condition = false;
            var numberOfSubscriptionDialogShown = gameObj.getNumberOfSubscriptionDialogShown();
            loggerObj.debugLog("check for the subs popup condition ", homeLayer.subs_popup_condition, gameObj.getNumberOfSubsPopup(), runtimeObj.getNumberOfSubsPopup(), numberOfSubscriptionDialogShown);
            if (numberOfSubscriptionDialogShown >= 8) {
                var timestampOfLastSubsPopupOverall = gameObj.getTimestampOfLastSubsPopupOverall();
                if (utilObj.getCurrentTimestamp() - timestampOfLastSubsPopupOverall >= runtimeObj.getCoolDownForSubsDialog() * constantsObj.SECONDS_IN_DAY) {
                    homeLayer.subs_popup_condition = true;
                }
            } else if (gameObj.getNumberOfSubsPopup() >= runtimeObj.getNumberOfSubsPopup()) {
                var timeStampOfLastSubsPopup = gameObj.getTimestampOfLastSubsPopup();
                loggerObj.debugLog("check for the subs popup condition1 ", homeLayer.subs_popup_condition, utilObj.getCurrentTimestamp(), timeStampOfLastSubsPopup, runtimeObj.getCoolDownForSubsPopup() * constantsObj.SECONDS_IN_MIN);
                if (utilObj.getCurrentTimestamp() - timeStampOfLastSubsPopup >= runtimeObj.getCoolDownForSubsPopup() * constantsObj.SECONDS_IN_HOUR) {
                    gameObj.setNumberOfSubsPopup(0);
                    homeLayer.subs_popup_condition = true;
                } else {
                    var completedDailyMiniPuzzle = gameObj.getPuzzleCompleted(puzzleIdDailyMini);
                    if (completedDailyMiniPuzzle) {
                        if (homeLayer.dailyMiniToShow == null) {
                            homeLayer.subscriptionTag = 2;
                        }
                    }
                }
            } else {
                homeLayer.subs_popup_condition = true;
                loggerObj.debugLog("check for the subs popup condition2 ", homeLayer.subs_popup_condition);
            }
            loggerObj.debugLog("check for the subs popup condition3 ", homeLayer.subs_popup_condition, homeLayer.subscriptionTag);
            if (homeLayer.subs_popup_condition) {
                var completedTodaysPuzzle = gameObj.getTodaysPuzzleCompleted1();
                var completedTodaysBonusPuzzle = false;
                if (completedTodaysPuzzle) {
                    completedTodaysBonusPuzzle = gameObj.getCompletedTodaysFreePuzzle();
                }
                var completedDailyMiniPuzzle = gameObj.getPuzzleCompleted(puzzleIdDailyMini);
                if (completedDailyMiniPuzzle) {
                    if (homeLayer.dailyMiniToShow != null) {
                        completedDailyMiniPuzzle = false;
                    }
                }

                homeLayer.subscriptionTag = 3;
                if (completedTodaysBonusPuzzle || completedDailyMiniPuzzle) {
                    if (completedTodaysBonusPuzzle && completedDailyMiniPuzzle) {
                        if (gameObj.getLastCompletedPuzzleType() == "archivePuzzle") {
                            homeLayer.subscriptionTag = 1;
                        } else if (gameObj.getLastCompletedPuzzleType() == "dailyMini") {
                            homeLayer.subscriptionTag = 2;
                        }
                    } else {
                        if (completedTodaysBonusPuzzle) {
                            homeLayer.subscriptionTag = 1;
                        }
                        if (completedDailyMiniPuzzle) {
                            homeLayer.subscriptionTag = 2;
                        }
                    }
                }
            } else {
                // homeLayer.subscriptionTag = 0;
            }
        }

        var track = constantsObj.TRACK_TODAYS_PUZZLE;
        var isBonusArchive = false;
        if (cb != "loadTodaysPuzzle" ) {
            track = "archive_puzzle";
            isBonusArchive = true;
        }

        if (cb == "loadSubsPuzzle") {
            herosPosText = stringsObj.PREMIUM_ARCHIVE_PUZZLE;
            if (inProgress[utilObj.getIdForDate(d)]) {
                hasFreeTag = false;
            }
        }
        if (homeLayer.subscriptionTag == 1) {
            herosPosText = stringsObj.REGULAR_ARCHIVE;
        }

        var headerColor = (layoutExperimentVariant == constantsObj.EXP_VAR_CONTROL) ? constantsObj.COLOR_LIGHT_RED : constantsObj.COLOR_RED_01;
        var headerColor1 = (layoutExperimentVariant == constantsObj.EXP_VAR_CONTROL) ? constantsObj.COLOR_GREEN : constantsObj.COLOR_BLUE_04;


        var listItems = [
            {
                headerColor: (layoutExperimentVariant == constantsObj.EXP_VAR_CONTROL) ? constantsObj.COLOR_LIGHT_RED : constantsObj.COLOR_RED_01,
                headerLine: constantsObj.COLOR_LIGHT_RED_LINE,
                headerText: herosPosText,
                fn: cb,
                params: (cb == "loadTodaysPuzzle") ? undefined : {id: utilObj.getIdForDate(d), from: "heros"},
                trackF: track,
                sectionHeight: 350,
                section: [
                    {
                        text: stringsObj.puzzle_themes[day],
                        subText: utilObj.getFormattedDate(d),
                        circleSprite: constantsObj.LOGO_FOR_DAYS[day],
                        headerTextSize: constantsObj.FONT_ROBOTO_MEDIUM_80,
                        hasFreeTag: hasFreeTag,
                        day: day,
                        playIcon: playIcon,
                        isBonusArchive: isBonusArchive
                    }
                ],
                extraYOffset: 0
            },
            {
                headerColor: (layoutExperimentVariant == constantsObj.EXP_VAR_CONTROL) ? constantsObj.COLOR_LIGHT_RED : constantsObj.COLOR_RED_01,
                headerLine: constantsObj.COLOR_LIGHT_RED_LINE,
                headerText: stringsObj.Daily_mini_puzzle,
                fn: "loadDailyMiniPuzzle",
                trackF: track_daily_mini,
                sectionHeight: 350,
                section: [
                    {
                        text: stringsObj.Daily_mini,
                        subText: utilObj.getFormattedDate(d),
                        circleSprite: constantsObj.daily_mini,
                        headerTextSize: constantsObj.FONT_ROBOTO_MEDIUM_80,
                        hasFreeTag: true,
                        day: day,
                        isBonusArchive: isBonusArchive
                    }
                ],
                extraYOffset: 0
            },
            {
                headerColor: headerColor,
                headerLine: constantsObj.COLOR_LIGHT_RED_LINE,
                headerText: stringsObj.GAMES_MODES,
                fn: "loadBlitzMode",
                trackF: constantsObj.TRACK_BLITZ,
                sectionHeight: 350,
                section: [
                    {
                        text: stringsObj.Blitz_mode_string,
                        subText: stringsObj.blitz_best_score,
                        circleSprite: constantsObj.blitz_mode_icon,
                        headerTextSize: constantsObj.FONT_ROBOTO_MEDIUM_80,
                        day: day,

                    }
                ],
                extraYOffset: 0
            },

            {
                headerColor: (layoutExperimentVariant == constantsObj.EXP_VAR_CONTROL) ? constantsObj.COLOR_GREEN : constantsObj.COLOR_BLUE_04,
                headerLine: constantsObj.COLOR_BLUE_LINE,
                headerText: stringsObj.archive_calendar,
                fn: "loadCalendar",
                trackF: constantsObj.TRACK_CALENDAR,
                section: [
                    {
                        text: stringsObj.calendar,
                        circleSprite: constantsObj.icons_calendar,
                        subText: stringsObj.play_more
                    }
                ],
                extraYOffset: 0
            }
            /*, {
             headerColor: (layoutExperimentVariant == constantsObj.EXP_VAR_CONTROL) ? constantsObj.COLOR_GREEN : constantsObj.COLOR_BLUE_04,
             headerLine: constantsObj.COLOR_GREEN_LINE,
             headerText: stringsObj.PACKS,
             fn: "loadPackInfo",
             trackF: constantsObj.TRACK_PACK,
             section: [],
             extraYOffset: 0
             }*/
            ,
            {
                headerColor: (layoutExperimentVariant == constantsObj.EXP_VAR_CONTROL) ? constantsObj.COLOR_BLUE : constantsObj.COLOR_BLUE_04,
                headerLine: constantsObj.COLOR_BLUE_LINE,
                headerText: stringsObj.IN_PROGRESS,
                fn: "loadPuzzle",
                trackF: constantsObj.TRACK_OLD,
                section: sectionsForInProgress,
                extraYOffset: 400
            }
        ];

        if (sectionsForInProgress.length < 1) {
            listItems.splice(listItems.length - 1, 1);
        }

        yPos -= 20;

        // ScrollView init
        var offsetlocal = 0;
        var sections = sectionsForInProgress.length;
        if (sections >= 0) {
            offsetlocal = sections * 200;
        }

        if (homeLayer.toShowDailyMini) {
            offsetlocal += 300;
            offsetlocal += 105;

        }
        if (offsetlocal < 0) {
            offsetlocal = 0;
        }
        yPos += (20 - 250);
        var totalLen = 1050 + offsetlocal;
        if (zenModeObj.isZenModeAvailable()) {
            totalLen += 450;
        }
        var innerContentSize = totalLen > yPos - (235 + constantsObj.BOTTOM_BAR_OFFSET) ? totalLen : yPos - (235 + constantsObj.BOTTOM_BAR_OFFSET);
        homeLayer.scrollView = new ccui.ScrollView();
        homeLayer.scrollView.setDirection(ccui.ScrollView.DIR_VERTICAL);
        homeLayer.scrollView.setTouchEnabled(true);
        homeLayer.scrollView.setContentSize(cc.size(canvasWidth, yPos - (235 + constantsObj.BOTTOM_BAR_OFFSET)));
        homeLayer.scrollView.setPosition(centerXPos, yPos);
        homeLayer.scrollView.setBounceEnabled(true);
        homeLayer.scrollView.setAnchorPoint(0.5, 1);
        homeLayer.scrollView.setBackGroundColor(constantsObj.COLOR_YELLOW_02);
        homeLayer.scrollView.setInnerContainerSize(cc.size(canvasWidth, innerContentSize));
        homeLayer.scrollView.setBounceEnabled(true);

        var position = innerContentSize;
        for (var i in listItems) {
            //loggerObj.debugLog("Reached here6", utilObj.isUserDnOrMore(2), epmObj.getChosenVariant(constantsObj.EXP_BLITZ_MODE) == constantsObj.EXP_VAR_1, ftueObj.areFtuesDone());
            if ((i == constantsObj.BLITZ_INDEX_IN_HS && zenModeObj.isZenModeAvailable()) || i != constantsObj.BLITZ_INDEX_IN_HS) {
                if (zenModeObj.isZenModeAvailable()) {
                    trackObj.trackCounter(constantsObj.TRACK_DIALOG, zenModeObj.getBlitzPuzzleTracking(), zenModeObj.getBlitzPuzzleTheme(), constantsObj.TRACK_HOME + "_" + constantsObj.TRACK_BLITZ, zenModeObj.getLivesCount(), "", "", 1, "");

                }
                position = homeLayer.createListElement(listItems[i], position, labelArr, spriteArr);
            }
        }
        //homeLayer.addChild(homeLayer.listView, zOrder + 1);
        utilObj.addChild(homeLayer, homeLayer.scrollView, zOrder + 1);

        var heightOfBottomNav = 235;
        homeLayer.bottomNavBg = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, 0, 0.5, 0, canvasWidth, heightOfBottomNav + constantsObj.BOTTOM_BAR_OFFSET, spriteArr, homeLayer, zOrder + 1, constantsObj.SPRITE_MISC);
        utilObj.setColor(homeLayer.bottomNavBg, constantsObj.COLOR_TOP_BAR);

        // homeLayer.addBottomNavOptions(spriteArr, labelArr);

        utilObj.updateScreen(constantsObj.SCREEN_HOME, homeLayer);
        uiCreatorObj.checkAndCreateUIElements(curScreen , heightOfBottomNav + constantsObj.BOTTOM_BAR_OFFSET);

        var isFirstSession = gameObj.getIsFirstSession();

        //PopUp Surfacing Logic
        var curTimestamp1 = utilObj.getCurrentTimestamp();
        var timeSpentFbLoginShown = curTimestamp1 - gameObj.getLastFbLoginShowTimestamp();
        var timeSpentRateUsShown = curTimestamp1 - gameObj.getLastRateUsShowTimestamp();
        var timeSpentInviteAndWinShown = curTimestamp1 - gameObj.getLastInviteAndWinShowTimestamp();
        var timeSpentFromLastInterstitial = curTimestamp1 - gameObj.getLastInterstitialTimestamp();

        if (ftueObj.isForcedFtueStarted() == true) {
            if (!ftueObj.isFtueShown()) {
                ftueObj.setFtueShown(true);
            }
        }

        var isD0 = false;
        if (((curTimestamp1 - userObj.getCreated()) < 24 * constantsObj.SECONDS_IN_HOUR)) {
            isD0 = true;
        }

        // Ftues condition and the autopopups checks
        if (!(gameObj.getIsAnimShown()) && !isSubscribe) {
            if (!ftueObj.isFtueShown()) {
                ftueObj.showHomeFtue();
            } else if (!ftueObj.isDailyMiniFtueShown()) {
                ftueObj.showDailyMiniftue();
            } else if (gameObj.checkEligibleForPackFtue()) {
                // loggerObj.debugLog("coming to this point - 6");
                ftueObj.showPackFtue();
            } else if (!ftueObj.isAchievementFtueShown()) {
                ftueObj.showAchievementFtue();
            } else if (gameObj.getShouldShowJoiningBonusGrantPopup()) {
                subscriptionsDTCObj.autoTriggerCongratulations();
                machineLearningDataObj.incNumAutoPopupsShown();
                gameObj.setShouldShowJoiningBonusGrantPopup(false);
            } else if (zenModeObj.isZenModeAvailable() && zenModeObj.getMaxScore() <= 0 && false) {
                blitzFirstIntroPopup.show();
            } else if (subscriptionsDTCObj.checkSubscriptionOffline() && !popupLayer.popupOpen) {
                subscriptionOfflinePopup.show();
                machineLearningDataObj.incNumAutoPopupsShown();
            } else if (gameObj.isEligibleForStarterPack1() || gameObj.isEligibleForStarterPack2()) {
                if (gameObj.isEligibleForStarterPack2()) {
                    if (curTimestamp1 - gameObj.getTimeStampStarterPopup() > 3 * constantsObj.SECONDS_IN_DAY && gameObj.getNumStarterPack2() < 2) {
                        var countStarterPackPopup = gameObj.getStarterPackPopupShownCount();
                        if (countStarterPackPopup < 2) {
                            gameObj.setStarterPackPopupShownCount(countStarterPackPopup + 1);
                            starterPackPopup.show();
                            gameObj.setNumStarterPack2(gameObj.getNumStarterPack2() + 1);
                            machineLearningDataObj.incNumAutoPopupsShown();
                        }
                    }
                } else if ((curTimestamp1 - gameObj.getTimeStampStarterPopup() > 15 * constantsObj.SECONDS_IN_MIN)) {
                    var countStarterPackPopup = gameObj.getStarterPackPopupShownCount();
                    if (countStarterPackPopup < 2) {
                        gameObj.setStarterPackPopupShownCount(countStarterPackPopup + 1);
                        starterPackPopup.show();
                        machineLearningDataObj.incNumAutoPopupsShown();
                    }
                }

            } else if (gameObj.hasNeverClaimedAchievement() && gameObj.conditionsForAchivementReminder() && (gameObj.getIsRedraw() == false)) {
                homeLayer.showAchievementReminder();
            } else if (isD0 && !gameObj.getNotifsEnabled() && !gameObj.getNotifPopupShownOnHomeScreen() && gameObj.getNotifPopupCount() < 2 && !homeLayer.achivementReminderVisible) {
                gameObj.setNotifPopupShown(true);
                gameObj.setNotifPopupShownOnHomeScreen(true);
                gameObj.setLastNotifPopupTimeStamp(curTimestamp1);
                notifPermissionPopup.show();
                machineLearningDataObj.incNumAutoPopupsShown();
                gameObj.setNotifPopupCount(gameObj.getNotifPopupCount() + 1);
                gameObj.setIsBackFromGameLayer(false);
            } else if (!popupLayer.popupOpen && !homeLayer.achivementReminderVisible) {
                if (runtimeObj.getForceUpdate() == 1) {
                    utilObj.forceUpdate();
                } else if (timeSpentRateUsShown > 72 * constantsObj.SECONDS_IN_HOUR && gameObj.getLastRatedVersion() == 0 && !gameObj.getIsRedraw() && curScreen != gameObj.getLastScreenOnWhichPopupShown() && (curTimestamp1 - gameObj.getTimeStampForAutoDialogShown()) > 4 * constantsObj.SECONDS_IN_MIN) {
                    if (isFirstSession == false && ftueObj.isCalendarFtueShown() == true) {
                        rateUsPopup.show();
                        machineLearningDataObj.incNumAutoPopupsShown();
                    }
                } else if (fbWrapperObj.isLoggedIn() && timeSpentInviteAndWinShown > 24 * constantsObj.SECONDS_IN_HOUR && !gameObj.getIsRedraw() && curScreen != gameObj.getLastScreenOnWhichPopupShown() && (curTimestamp1 - gameObj.getTimeStampForAutoDialogShown()) > 4 * constantsObj.SECONDS_IN_MIN) {
                    if (isFirstSession == false) {
                        inviteAndWinPopup.show();
                        machineLearningDataObj.incNumAutoPopupsShown();
                    }
                } else if (!fbWrapperObj.isLoggedIn() && timeSpentFbLoginShown > 24 * constantsObj.SECONDS_IN_HOUR && !gameObj.getIsRedraw() && curScreen != gameObj.getLastScreenOnWhichPopupShown() && (curTimestamp1 - gameObj.getTimeStampForAutoDialogShown()) > 4 * constantsObj.SECONDS_IN_MIN) {
                    if (isFirstSession == false) {
                        fbConnectPopup.show();
                        machineLearningDataObj.incNumAutoPopupsShown();
                    }
                }
            }
        }
        //toaster and add coins in case if user is L3,L8,L20,L40
        var curDay = utilObj.getDayOfYear();
        var lastLogin = gameObj.getPrevDay();
        var daysLapsed = curDay - lastLogin - 1;
        var typeOfUser = "L" + (daysLapsed + 1);

        //for all lapsers L1, L2, L3 etc..
        if (!isFirstLoad && (daysLapsed == 3 || daysLapsed == 8 || daysLapsed == 20 || daysLapsed == 40) && gameObj.getLapserCoinGrantDay() != curDay) {
            utilObj.showMessage("10 coins have been granted");
            economyObj.addCash(10, constantsObj.TRACK_EARN, constantsObj.TRACK_LAPSER, "fu");
            gameObj.setLapserCoinGrantDay(curDay);
        } else {
            gameObj.setPrevDay(curDay - 1);
        }

        if (gameObj.getIsRedraw()) {
            gameObj.setIsRedraw(false);
        }

        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);


        privacyPolicyPopup.show(constantsObj.SCREEN_HOME);
        if (!isSubscribe) {
            homeLayer.checkAndShowPopups();
        }
    },

    // check and show tq, wq, adwall, pzUnlock popups
    checkAndShowPopups: function () {
        if (gameObj.getIsAnimShown() || popupLayer.popupOpen) {
            return;
        }
        if (!ftueObj.areFtuesDone()) {
            return;
        }
        var showAdwall = false;
        if (epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST) != constantsObj.EXP_VAR_CONTROL && !gameObj.getIsThemedQuestLocked() && gameObj.getIsThemedQuestIntroPopupEligible() && !(gameObj.getThemedQuestMastery() > 0)) {
            themedQuestStartPopup.show();
            gameObj.setIsThemedQuestIntroPopupEligible(false);
        } else if (!gameObj.getIsWeeklyQuestLocked() && gameObj.getIsWeeklyQuestIntroPopupEligible() && !(gameObj.getWeeklyQuestMastery() > 0)) {
            weeklyQuestIntroPopup.show();
        } else if (epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST) == constantsObj.EXP_VAR_CONTROL && epmObj.getChosenVariant(constantsObj.EXP_THEMED_QUEST) == constantsObj.EXP_VAR_1 && !gameObj.getIsThemedQuestLocked()) {
            themedQuestStartPopup.show();
        } else {
            showAdwall = true;
        }

        xpromoUtilObj.xpromoActionsToPerformOnScreenComplete(showAdwall);
    },


    addBottomNavOptions: function (spriteArr, labelArr) {
        return;
        var screen = homeLayer.screen;
        var btnWidth = (canvasWidth / 4) - (canvasWidth / 72);
        var btnHeight = 228;
        var xPos = btnWidth / 2 + (canvasWidth / 120);
        var zOrder = constantsObj.SPRITE_Z_ORDER;

        var transHomeButton = utilObj.getButton(btnWidth, btnHeight + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, xPos, btnHeight / 2 + 3 + constantsObj.BOTTOM_BAR_OFFSET / 2,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'homeLayer',
                fn: 'showHome',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_BOTTOM_NAV,
                    f: constantsObj.TRACK_HOME,
                    g: utilObj.getScreenName(screen),
                    s: "",
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(homeLayer, transHomeButton, zOrder + 1);
        var homeIcon = utilObj.getSprite(constantsObj.bottom_nav_home, xPos, btnHeight / 2 + 35 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_12 * 1.5, spriteArr, homeLayer, zOrder + 1, constantsObj.SPRITE_MISC);
        var homeLabel = utilObj.getBMFontLabel("HOME", constantsObj.FONT_ROBOTO_BOLD_40, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, 40 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, labelArr, homeLayer, zOrder + 1);

        xPos += btnWidth + (canvasWidth / 72) - (canvasWidth / 720);
        var transCalendarButton = utilObj.getButton(btnWidth, btnHeight + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, xPos, btnHeight / 2 + 3 + constantsObj.BOTTOM_BAR_OFFSET / 2,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'homeLayer',
                fn: 'showCalendar',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_BOTTOM_NAV,
                    f: constantsObj.TRACK_CALENDAR,
                    g: utilObj.getScreenName(screen),
                    s: "",
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(homeLayer, transCalendarButton, zOrder + 1);
        var calendarIcon = utilObj.getSprite(constantsObj.calendar_normal, xPos, btnHeight / 2 + 35 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_2 * 1.5, spriteArr, homeLayer, zOrder + 1, constantsObj.SPRITE_MISC);

        var calendarLabel = utilObj.getBMFontLabel("CALENDAR", constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, 40 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, labelArr, homeLayer, zOrder + 1);

        xPos += btnWidth + (canvasWidth / 72) - (canvasWidth / 720);
        var packsButton = utilObj.getButton(btnWidth, btnHeight + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, xPos, btnHeight / 2 + 3 + constantsObj.BOTTOM_BAR_OFFSET / 2,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'homeLayer',
                fn: 'showPacks',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_BOTTOM_NAV,
                    f: constantsObj.TRACK_PACK,
                    g: utilObj.getScreenName(screen),
                    s: "",
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(homeLayer, packsButton, zOrder + 1);

        var isHalloweenOn = gameObj.checkIfHalloweenOn();
        if (isHalloweenOn) {
            var packIcon = utilObj.getSprite(constantsObj.bottom_nav_packs_holloween, xPos, btnHeight / 2 + 35 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_6, spriteArr, homeLayer, zOrder + 1, constantsObj.SPRITE_MISC);
        } else {
            var packIcon = utilObj.getSprite(constantsObj.packs_normal, xPos, btnHeight / 2 + 35 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_2 * 1.5, spriteArr, homeLayer, zOrder + 1, constantsObj.SPRITE_MISC);
        }

        var circleIcon1 = utilObj.getSprite(constantsObj.white_circle_150, xPos + btnWidth / 4 - btnHeight / 8, btnHeight / 2 + btnHeight / 4 + btnHeight / 16 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_2, spriteArr, homeLayer, zOrder + 1, constantsObj.SPRITE_MISC);
        circleIcon1.setColor(constantsObj.COLOR_RED_01);

        var alreadySeenNotif = gameObj.isAlreadySeenPackNotifForPack();
        var circleIconLabel = utilObj.getBMFontLabel("!", constantsObj.FONT_ROBOTO_BOLD_60, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + btnWidth / 4 - btnHeight / 8, btnHeight / 2 + btnHeight / 4 + btnHeight / 16 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, labelArr, homeLayer, zOrder + 1);
        circleIcon1.setVisible(false);
        circleIconLabel.setVisible(false);


        if ((alreadySeenNotif == 1 || ((utilObj.getCurrentTimestamp() - gameObj.getPackLayerLastOpenedTimeStamp()) > 3 * constantsObj.SECONDS_IN_DAY && (!gameObj.getifAllPackCompleted())) || (gameObj.getPacknotiftimestamp() > gameObj.getPackLayerLastOpenedTimeStamp())) && gameObj.getMastery1() > 0) {
            gameObj.setPacknotiftimestamp(utilObj.getCurrentTimestamp());
            circleIcon1.setVisible(true);
            circleIconLabel.setVisible(true);
        }
        //packsButton.addChild(circleIcon1, zOrder + 1)
        //utilObj.addChild(packsButton, circleIcon1, zOrder + 1);

        var packLabel = utilObj.getBMFontLabel("PACKS", constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, 40 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, labelArr, homeLayer, zOrder + 1);
        //packsButton.addChild(packLabel, zOrder + 1);
        //utilObj.addChild(packsButton, packLabel, zOrder + 1);

        xPos += btnWidth + (canvasWidth / 72) - (canvasWidth / 720);
        //achievementsLayer.achievementsButtonBg = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, xPos, btnHeight/2 + 3, 0.5, 0.5, btnWidth, btnHeight);
        //achievementsLayer.addChild(achievementsLayer.achievementsButtonBg, constantsObj.UI_Z_ORDER + 1);
        homeLayer.transAchievementsButton = utilObj.getButton(btnWidth, btnHeight + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, xPos, btnHeight / 2 + 3 + constantsObj.BOTTOM_BAR_OFFSET / 2,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'homeLayer',
                fn: 'showAchievements',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_BOTTOM_NAV,
                    f: constantsObj.TRACK_ACHIEVEMENTS,
                    g: utilObj.getScreenName(screen),
                    s: "",
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        //homeLayer.addChild(homeLayer.transAchievementsButton, constantsObj.UI_Z_ORDER + 1);
        utilObj.addChild(homeLayer, homeLayer.transAchievementsButton, zOrder + 1);
        var proIcon = constantsObj.achievement_normal;
        if (ProfileExp == constantsObj.EXP_VAR_1) {
            proIcon = constantsObj.profile_screen;
            var badgeIcon = utilObj.getSprite(proIcon, xPos, btnHeight / 2 + 35 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_12 * 2.25, spriteArr, homeLayer, zOrder + 1, constantsObj.SPRITE_MISC);
        } else {
            var badgeIcon = utilObj.getSprite(proIcon, xPos, btnHeight / 2 + 35 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_2 * 1.5, spriteArr, homeLayer, zOrder + 1, constantsObj.SPRITE_MISC);
        }
        // var badgeIcon = utilObj.getSprite(constantsObj.bottom_nav_badge, xPos, btnHeight / 2 + 35 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_12 * 1.5, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_MISC);
        //homeLayer.transAchievementsButton.addChild(badgeIcon, zOrder + 1);
        //utilObj.addChild(homeLayer.transAchievementsButton, badgeIcon, zOrder + 1);

        var circleIcon = utilObj.getSprite(constantsObj.white_circle_150, xPos + btnWidth / 4 - btnHeight / 8, btnHeight / 2 + btnHeight / 4 + btnHeight / 16 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_2, spriteArr, homeLayer, zOrder + 1, constantsObj.SPRITE_MISC);
        circleIcon.setColor(constantsObj.COLOR_RED_01);

        var completedAchievementsCount = achievementsObj.getNumOfCompletedAchievements();
        var indexofAchievement = achievementsObj.getAchievementToSurfaceOnStats();
        var jewelNotif = 0;
        if (completedAchievementsCount != 0) {
            jewelNotif = completedAchievementsCount;
            //loggerObj.debugLog("iiiiiiii12");
        } else if (indexofAchievement != -1) {
            jewelNotif = "!";
        } else {
            gameObj.setShowJewelNotif(false);
        }

        var completedAchievementsLabel = utilObj.getBMFontLabel(jewelNotif + "", constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + btnWidth / 4 - btnHeight / 8, btnHeight / 2 + btnHeight / 4 + btnHeight / 16 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, labelArr, homeLayer, zOrder + 1);
        //circleIcon.addChild(completedAchievementsLabel, zOrder + 1);
        //utilObj.addChild(circleIcon, completedAchievementsLabel, zOrder + 1);

        if (jewelNotif == "!" && ProfileExp != constantsObj.EXP_VAR_1) {
            circleIcon.setVisible(false);
            completedAchievementsLabel.setVisible(false);
        } else if (completedAchievementsCount == 0 && gameObj.getShowJewelNotif() == false || jewelNotif == 0) {
            circleIcon.setVisible(false);
            completedAchievementsLabel.setVisible(false);
        }

        if (!ftueObj.isAchievementFtueShown()) {
            circleIcon.setVisible(false);
            completedAchievementsLabel.setVisible(false);
        }

        //homeLayer.transAchievementsButton.addChild(circleIcon, zOrder + 1);
        //utilObj.addChild(homeLayer.transAchievementsButton, circleIcon, zOrder + 1);
        var achievement_string = "ACHIEVEMENTS";
        if (ProfileExp == constantsObj.EXP_VAR_1) {
            achievement_string = "PROFILE";
        }
        //homeLayer.transAchievementsButton.addChild(circleIcon, zOrder + 1);
        //utilObj.addChild(homeLayer.transAchievementsButton, circleIcon, zOrder + 1);

        var achievementsLabel = utilObj.getBMFontLabel(achievement_string, constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, 40 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, labelArr, homeLayer, zOrder + 1);
        //homeLayer.transAchievementsButton.addChild(achievementsLabel, zOrder + 1);
        //utilObj.addChild(homeLayer.transAchievementsButton, achievementsLabel, zOrder + 1);

        // utilObj.showBannerAd(utilObj.getScreenName(constantsObj.SCREEN_HOME));
        gameObj.setUnlockingBonusArchive(false);
        gameObj.setUnlockingW2eVideoCalendar(false);
    },

    showHome: function () {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
            // loggerObj.debugLog("coming to this point - 61");
            return;
        }
        if (!ftueObj.isAchievementFtueShown()) {
            return;
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }
        if (homeLayer.achivementReminderVisible) {
            homeLayer.removeReminder();
            gameObj.setIsBackFromGameLayer(false);
            gameObj.setAchivementReminderSeenTimestamp(utilObj.getCurrentTimestamp());
            return;
        }
        homeLayer.redraw();
    }
    ,

    showCalendar: function () {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
            // loggerObj.debugLog("coming to this point - 62");
            return;
        }
        if (!ftueObj.isAchievementFtueShown()) {
            return;
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }
        if (homeLayer.achivementReminderVisible) {
            homeLayer.removeReminder();
            gameObj.setIsBackFromGameLayer(false);
            gameObj.setAchivementReminderSeenTimestamp(utilObj.getCurrentTimestamp());
            return;
        }
        homeLayer.hide();
        calendarLayer.show();
    }
    ,

    showPacks: function () {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
            // loggerObj.debugLog("coming to this point - 63");
            return;
        }
        if (!ftueObj.isAchievementFtueShown()) {
            return;
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }
        if (homeLayer.achivementReminderVisible) {
            homeLayer.removeReminder();
            gameObj.setIsBackFromGameLayer(false);
            gameObj.setAchivementReminderSeenTimestamp(utilObj.getCurrentTimestamp());
            return;
        }
        if (gameObj.getMastery1() <= 0) {
            utilObj.showMessage("Please complete a puzzle to access packs.");
            return;
        }
        if (gameObj.isAlreadySeenPackNotifForPack() == 1) {
            gameObj.setNotifForPack(2);
        }

        gameObj.segregatePuzzlesForPack();
        gameObj.segregatePuzzlesForBonusPacks();
        gameObj.reOrderNewPacks();
        homeLayer.hide();
        packsLayer.show();
    }
    ,

    showPacksQuick: function () {
        if (!ftueObj.isFtueShown() || gameObj.getdailyMiniFtueVisible()) {
            return;
        }
        if (!ftueObj.isAchievementFtueShown()) {
            return;
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }
        if (homeLayer.achivementReminderVisible) {
            homeLayer.removeReminder();
            gameObj.setIsBackFromGameLayer(false);
            gameObj.setAchivementReminderSeenTimestamp(utilObj.getCurrentTimestamp());
            return;
        }
        var id = gameObj.getPackIdSurfaced();
        if (id == -1) {
            id = gameObj.getPackIdSurfacedToBuy();
            if (id == -1) {
                utilObj.showMessage("We will be up with more packs soon!")
                return;
            }
            homeLayer.hide();
            packInfoLayer.show(id);
            return;
        }
        if (gameObj.isAlreadySeenPackNotifForPack() == 1) {
            gameObj.setNotifForPack(2);
        }

        // if (utilObj.isIos() && gameObj.getMastery1() <= 0) {
        //     utilObj.showMessage("Please complete a themed puzzle to access packs.");
        //     return;
        // }

        var puzzleId = gameObj.firstIncompletePuzzle(id);
        homeLayer.hide();
        gameLayer.show(puzzleId, true);
    }
    ,

    showAchievements: function () {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
            // loggerObj.debugLog("coming to this point - 64");
            return;
        }
        if (!ftueObj.isAchievementFtueShown()) {
            return;
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }
        if (homeLayer.achivementReminderVisible == true) {
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "achv_reminder", "go", "", "", 1, "");
        }
        homeLayer.hide();
        if (ProfileExp == constantsObj.EXP_VAR_1) {
            achievementsLayer.show(gameObj.getShowStat());
        } else {
            achievementsLayer.show();
        }
        machineLearningDataObj.incUserOpenedAchievements();
    }
    ,

    loadArchievePuzzle: function (params) {
        if (homeLayer.subscriptionTag == 1) {
            gameObj.setNumberOfSubsPopup(gameObj.getNumberOfSubsPopup() + 1);
            gameObj.setTimestampOfLastSubsPopup(utilObj.getCurrentTimestamp());
            gameObj.setScreenTypeForSubsLayer(constantsObj.SUBSCRIPTION_OFFER);
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_HOME, "SP1", "", gameObj.getPuzzleSpeciesTracking(), "", "");
            var params1 = {};
            params1.popupName = "goToArchivePuzzle";
            params1.popupParams = params.id;
            subscriptionsLaunchLayer.show(true, false, params1);
            // homeLayer.redraw();
            return;
        }
        if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
            return;
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }
        if (!ftueObj.isAchievementFtueShown()) {
            return;
        }
        var id = params.id;
        var from = params.from;
        var inProgress = gameObj.getInProgress();
        gameObj.setCrosswordToShow(id);
        if (id == gameObj.getTodaysFreePuzzle() || inProgress[id]) {
            // homeLayer.hide();
            // gameLayer.show(id);
            if (inProgress[id]) {
                homeLayer.hide();
                gameLayer.show(id);
            }  else if (adsObj.checkRewardedVideoAvailable() && utilObj.isOnline()) {
                gameObj.setPuzzleToUnlock(id);
                gameObj.setArchiveUnlockReward(true);
                adsObj.showVideoAd(false, "forBonusArchiveNew");
                adsObj.setNotRewardedVideo(false);
                trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_HOME, "w2e_archive", "", gameObj.getPuzzleSpeciesTracking(), "", "");
            } else {
                hintAndBuyPopup.show(constantsObj.HINT_AND_BUY_POPUP[6], id, from);
                trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_HOME, "w2e_archive", "", gameObj.getPuzzleSpeciesTracking(), "", "");
            }

        } else {
            if (from == "heros") {
                homeLayer.loadArchivePuzzle1(id, "heros");
            } else {
                homeLayer.loadArchivePuzzle1(id, "archive");
            }
            // ftueObj.showArchiveFtue(id);
        }

    }
    ,

    callbackfnForVideo: function (id) {
        gameObj.setPuzzleToUnlock(id);
        gameObj.setArchiveUnlockReward(true);
        adsObj.setNotRewardedVideo(false);
        popupLayer.closeWithDefault();
    },

    loadPuzzleVideoReward: function (id) {
        homeLayer.hide();
        calendarLayer.hide();
        gameLayer.show(id);
    }
    ,

    loadArchivePuzzle2: function (id, from, watchedvideo, archiveFtueOpen) {
        if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
            return;
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }
        var date = id;
        if (!economyObj.makePayment(null, null, constantsObj.PKG_CASH, economyObj.getRevealCrosswordCost(), "bonus_archive", "", calendarLayer)) {
            return false;
        }
        homeLayer.hide();

        // loggerObj.debugLog("3. clicked date is ", date);
        gameLayer.show(date, false);

    }
    ,

    loadArchivePuzzle1: function (id, from, watchedVideo, archiveFtueOpen) {
        if (homeLayer.subscriptionTag == 1) {
            gameObj.setNumberOfSubsPopup(gameObj.getNumberOfSubsPopup() + 1);
            gameObj.setTimestampOfLastSubsPopup(utilObj.getCurrentTimestamp());
            gameObj.setScreenTypeForSubsLayer(constantsObj.SUBSCRIPTION_OFFER);
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_HOME, "SP1", "", gameObj.getPuzzleSpeciesTracking(), "", "");
            var params1 = {};
            params1.popupParams = id;
            params1.popupName = "goToArchivePuzzle";
            subscriptionsLaunchLayer.show(true, false, params1);
            // homeLayer.redraw();
            return;
        }
        if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
            return;
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }
        var date = id;
        var w2eUnlockArchiveVariant = epmObj.getChosenVariant(constantsObj.EXP_W2E_UNLOCK_ARCHIVE);
        var currentTime = utilObj.getCurrentTimestamp();
        var currentDate = new Date(currentTime * 1000);
        var forcedArchiveFtue = false;
        var conditionValue = false;

        var conditionForArchiveUnlockPopup = false;

        if (from == "heros" && (gameObj.getisHeroesArchivePopupforUnlockShown() || economyObj.getCash() < economyObj.getRevealCrosswordCost())) {
            conditionForArchiveUnlockPopup = true;
        }

        if (from == "heros" && gameObj.getIsHeroesArchiveFtueShow()) {
            conditionValue = true;
        }

        if (from == "archive" && (gameObj.getisHsArchivePopupforUnlockShown() || economyObj.getCash() < economyObj.getRevealCrosswordCost())) {
            conditionForArchiveUnlockPopup = true;
        }

        if (from == "archive" && gameObj.getIsHsArchiveFtueShown()) {
            conditionValue = true;
        }
        if (ftueObj.isArchiveFtueShown() && economyObj.getCash() < economyObj.getRevealCrosswordCost()) {
            conditionValue = true;
        }

        if (conditionValue && date != gameObj.getTodaysFreePuzzle()) {
            if (w2eUnlockArchiveVariant == constantsObj.EXP_VAR_1 && economyObj.getCash() < economyObj.getRevealCrosswordCost() && adsObj.checkRewardedVideoAvailable()) {
                // loggerObj.debugLog("inside non-payer video2", gameObj.getIsPayer());
                if (gameObj.getLastVideoForArchiveDate() != null) {
                    //loggerObj.debugLog("check for the w2e2 ");
                    var daysDiff = utilObj.getDaysDiff(currentDate, gameObj.getLastVideoForArchiveDate());
                    if (daysDiff > 0) {
                        //loggerObj.debugLog("check for the w2e3 ");
                        gameObj.setCountVideoWatched(0);
                    }
                    if (daysDiff != 0) {
                        //loggerObj.debugLog("check for the w2e4 ");
                        forcedArchiveFtue = true;
                    }
                    if (gameObj.getIsPayer() == false && gameObj.getCountVideoWatched() < runtimeObj.getCountWatchedVideo()) {
                        //loggerObj.debugLog("check for the w2e5 ");
                        //loggerObj.debugLog("inside non-payer video3", runtimeObj.getCountWatchedVideo());
                        forcedArchiveFtue = true;
                    }
                    if (gameObj.getIsPayer() == true && gameObj.getCountVideoWatched() < runtimeObj.getCountWatchedVideoPayer()) {
                        //loggerObj.debugLog("check for the w2e6 ");
                        //loggerObj.debugLog("inside payer video", runtimeObj.getCountWatchedVideoPayer());
                        forcedArchiveFtue = true;
                    }
                }
                else {
                    //loggerObj.debugLog("check for the w2e7 ");
                    forcedArchiveFtue = true;
                }
            }
        }


        calendarLayer.clickedDate = date;
        //calendarLayer.selectedDate = utilObj.getDateForId(date);

        if (gameObj.getSounds()) {
            //loggerObj.debugLog("check for the w2e8 ");
            utilObj.playSound(constantsObj.BUTTON_TAP, false);
        }

        if (gameObj.getCrosswordForDate(date) == null) {
            //loggerObj.debugLog("check for the w2e9 ");
            if (utilObj.isOnline() == false) {
                utilObj.showMessage("Please connect to internet to download content");
            } else {
                runtimeObj.syncToServer();
                utilObj.showMessage("Please try after some time");
            }
            //utilObj.showMessagePopup(stringsObj.request_update);
            return;
        }

        var d = gameObj.getTodaysPuzzleDate();
        // loggerObj.debugLog("Today date", d);
        var id = utilObj.getIdForDate(d);

        var inProgress = gameObj.getInProgress();
        // if (!ftueObj.isCalendarFtueShown()) {
        //     ftueObj.setCalendarFtueShown(true);
        //     ftueObj.dismissCalendarFtue();
        // }
        if (date == id) {
            //loggerObj.debugLog("check for the w2e10 ");
            // Todays Puzzle
        } else if (inProgress[date] != null && inProgress[date] != undefined) {

        }/*else if (inProgress[date] != null && inProgress[date] != undefined) {
         //loggerObj.debugLog("check for the w2e11 ");
         // Puzzle In Progress
         if (!ftueObj.isCalendarFtueShown()) {
         ftueObj.setCalendarFtueShown(true);
         ftueObj.dismissCalendarFtue();
         gameObj.setCalendarFtueVisible(false);
         }
         } */ else {
            //loggerObj.debugLog("check for the w2e12 ");
            var score = scoresObj.getHighScore(date);
            if (score > 0) {
                // Replay Puzzle
                gameObj.setReplayPuzzle(true);
                gameObj.setReplay(true);
            } else {
                var videoWatched = runtimeObj.getCountWatchedVideo();
                if (gameObj.getIsPayer() == true) {
                    videoWatched = runtimeObj.getCountWatchedVideoPayer();
                }
                //loggerObj.debugLog("check for the w2e21 ",watchedVideo);
                //loggerObj.debugLog("check for the w2e13 ",conditionValue,archiveFtueOpen,forcedArchiveFtue,date,gameObj.getTodaysFreePuzzle());
                // New Puzzle
                /*if (!ftueObj.isCalendarFtueShown() /*&& !(fbWrapperObj.isLoggedIn())) {
                 //loggerObj.debugLog("check for the w2e14 ");
                 ftueObj.setCalendarFtueShown(true);
                 ftueObj.dismissCalendarFtue();
                 gameObj.setCalendarFtueVisible(false);
                 } else*/
                if ((!conditionForArchiveUnlockPopup || !conditionValue || (archiveFtueOpen == undefined && forcedArchiveFtue == true)) && date != gameObj.getTodaysFreePuzzle()) {
                    //loggerObj.debugLog("check for the w2e15 ");
                    ftueObj.showArchiveFtue(date, from);
                    return;
                } else if (watchedVideo != undefined && watchedVideo == true) {
                    //loggerObj.debugLog("check for the w2e16 ");
                    gameObj.setLastVideoForArchiveDate(currentDate);
                    gameObj.setCountVideoWatched(gameObj.getCountVideoWatched() + 1);
                    trackObj.trackCounter(constantsObj.TRACK_CASH, constantsObj.TRACK_SPEND, constantsObj.TRACK_ARCHIVE, "video", economyObj.getCash(), 0, gameObj.getPuzzleSpeciesTracking(), "", "");
                } else if (date == gameObj.getTodaysFreePuzzle()) {
                    //loggerObj.debugLog("check for the w2e17 ");
                    // Nothing
                } else if (!economyObj.makePayment(null, null, constantsObj.PKG_CASH, economyObj.getRevealCrosswordCost(), constantsObj.TRACK_ARCHIVE, "", calendarLayer)) {
                    //loggerObj.debugLog("check for the w2e18 ");
                    return false;
                }
            }
        }
        calendarLayer.monthDiff = 0;
        calendarLayer.hide();
        homeLayer.hide();

        // loggerObj.debugLog("3. clicked date is ", date);
        gameLayer.show(date, false);
    }
    ,

    showSubsPopupOffer: function () {
        gameObj.setScreenTypeForSubsLayer(constantsObj.SUBSCRIPTION_OFFER);
        subscriptionsLaunchLayer.show(true);
    },

    loadDailyMiniPuzzle: function () {
        if (!ftueObj.isFtueShown()) {
            //ftueObj.dismissHomeFtue();
            return;
        }

        if (gameObj.getPackFtueVisible()) {
            // loggerObj.debugLog("coming to this point - 65");
            return;
        }

        if (!ftueObj.isAchievementFtueShown()) {
            return;
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }

        if (homeLayer.achivementReminderVisible) {
            homeLayer.removeReminder();
            gameObj.setIsBackFromGameLayer(false);
            gameObj.setAchivementReminderSeenTimestamp(utilObj.getCurrentTimestamp());
            return;
        }

        var puzzleId = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
        puzzleId = stringsObj.mini_prefix + puzzleId.substr(2, puzzleId.length);
        if (homeLayer.dailyMiniToShow != null) {
            puzzleId = homeLayer.dailyMiniToShow;
        }

        if (homeLayer.subscriptionTag == 2) {
            if (homeLayer.subs_popup_condition) {
                gameObj.setNumberOfSubsPopup(gameObj.getNumberOfSubsPopup() + 1);
                gameObj.setTimestampOfLastSubsPopup(utilObj.getCurrentTimestamp());
                gameObj.setScreenTypeForSubsLayer(constantsObj.SUBSCRIPTION_OFFER);
                trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_HOME, "SP2", "", gameObj.getPuzzleSpeciesTracking(), "", "");
                var params = {};
                params.popupName = "goToMiniCalendar";
                params.popupParams = null;
                subscriptionsLaunchLayer.show(true, false, params);
                // homeLayer.redraw();
            } else {
                calendarLayer.selectedTab = constantsObj.MINI_SCREEN;
                homeLayer.hide();
                calendarLayer.show();
            }
            return;
        }
        //loggerObj.debugLog("puzzle id is", puzzleId, JSON.stringify(gameObj.getCrosswordForDate(puzzleId)));

        // if( scoresObj.getMastery(puzzleId) > 0 ) {
        //     utilObj.showMessage("You have already Completed the Puzzle. Come back tomorrow to complete it");
        //     return;
        // }

        if (gameObj.getCrosswordForDate(puzzleId) == null) {
            ftueObj.setDailyMiniFtueShown(true);
            if (utilObj.isOnline() == false) {
                utilObj.showMessage("Please connect to internet to download content");
            } else {
                utilObj.showMessage("Please try after some time");
            }
            return;
        }

        homeLayer.hide();
        gameLayer.show(puzzleId);
    }
    ,

    loadSubsPuzzle: function () {
        loggerObj.debugLog("coming to this point - 65");
        if (!ftueObj.isFtueShown()) {
            //ftueObj.dismissHomeFtue();
            return;
        }
        if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
            //loggerObj.debugLog("coming to this point - 65");
            return;
        }
        if (!ftueObj.isAchievementFtueShown()) {
            return;
        }
        if (homeLayer.achivementReminderVisible) {
            homeLayer.removeReminder();
            gameObj.setIsBackFromGameLayer(false);
            gameObj.setAchivementReminderSeenTimestamp(utilObj.getCurrentTimestamp());
            return;
        }
        var puzzleId = gameObj.getSubsTodaysFreePuzzle();
        if (gameObj.getCrosswordForDate(puzzleId) == null) {

            ftueObj.setFtueShown(true);
            if (utilObj.isOnline() == false) {
                utilObj.showMessage("Please connect to internet to download content");
            } else {
                runtimeObj.syncToServer();
                utilObj.showMessage("Please try after some time");
            }
            //utilObj.showMessage(stringsObj.request_update);
            //utilObj.showMessagePopup(stringsObj.request_update);
            return;
        }

        if (!(gameObj.getInProgress()[puzzleId])) {
            gameObj.setFreeArchivePuzzleSub(gameObj.getFreeArchivePuzzleSub() - 1);
        }

        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_HOME, constantsObj.TRACK_TODAYS_PUZZLE, "", gameObj.getPuzzleSpeciesTracking(), "", "");
        //puzzleId = '20170216'
        homeLayer.hide();
        gameLayer.show(puzzleId);
    },

    loadTodaysPuzzle: function () {
        // loggerObj.debugLog("loading todays puzzle");
        if (!ftueObj.isFtueShown()) {
            //ftueObj.dismissHomeFtue();
            return;
        }
        if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
            // loggerObj.debugLog("coming to this point - 65");
            return;
        }
        if (!ftueObj.isAchievementFtueShown()) {
            return;
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }

        if (homeLayer.achivementReminderVisible) {
            homeLayer.removeReminder();
            gameObj.setIsBackFromGameLayer(false);
            gameObj.setAchivementReminderSeenTimestamp(utilObj.getCurrentTimestamp());
            return;
        }

        var puzzleId = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
        if (gameObj.getCrosswordForDate(puzzleId) == null) {

            ftueObj.setFtueShown(true);
            if (utilObj.isOnline() == false) {
                utilObj.showMessage("Please connect to internet to download content");
            } else {
                runtimeObj.syncToServer();
                utilObj.showMessage("Please try after some time");
            }
            //utilObj.showMessage(stringsObj.request_update);
            //utilObj.showMessagePopup(stringsObj.request_update);
            return;
        }

        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_HOME, constantsObj.TRACK_TODAYS_PUZZLE, "", gameObj.getPuzzleSpeciesTracking(), "", "");
        //puzzleId = '20170216'
        homeLayer.hide();
        gameLayer.show(puzzleId);
    }
    ,

    loadPackInfo: function (params) {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
            // loggerObj.debugLog("coming to this point - 66");
            return;
        }

        if (!ftueObj.isAchievementFtueShown()) {
            return;
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }

        if (gameObj.getMastery1() <= 0) {
            utilObj.showMessage("Please complete a puzzle to access packs.");
            return;
        }

        homeLayer.hide();
        //check if pack is already completed
        var packInfo = gameObj.getPackInfo();
        var packArr = packInfo[params.index];

        var numberOfPuzzleSolved = 0;
        for (var i = 0; i < packArr.length; i++) {
            var crossWord = packArr[i];
            var score = scoresObj.getHighScore(crossWord);
            if (score > 0) {
                numberOfPuzzleSolved++;
            }
        }
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_HOME, constantsObj.TRACK_PACK, "", gameObj.getPuzzleSpeciesTracking(), "", "");
        packInfoLayer.show(params.index, numberOfPuzzleSolved == packArr.length);
    }
    ,

    loadCalendar: function () {
        if (homeLayer.subscriptionTag == 3) {
            gameObj.setNumberOfSubsPopup(gameObj.getNumberOfSubsPopup() + 1);
            gameObj.setTimestampOfLastSubsPopup(utilObj.getCurrentTimestamp());
            gameObj.setScreenTypeForSubsLayer(constantsObj.SUBSCRIPTION_OFFER);
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_HOME, "SP3", "", gameObj.getPuzzleSpeciesTracking(), "", "");
            var params = {};
            params.popupName = "goToCalendar";
            subscriptionsLaunchLayer.show(true, false, params);
            // homeLayer.redraw();
            return;
        }
        if (!ftueObj.isFtueShown()) {
            return;
        }
        if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
            // loggerObj.debugLog("coming to this point - 67");
            return;
        }

        if (!ftueObj.isAchievementFtueShown()) {
            return;
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }

        if (homeLayer.achivementReminderVisible) {
            homeLayer.removeReminder();
            gameObj.setIsBackFromGameLayer(false);
            gameObj.setAchivementReminderSeenTimestamp(utilObj.getCurrentTimestamp());
            return;
        }
        // loggerObj.debugLog("loading calendar");
        homeLayer.hide();
        calendarLayer.show();

        /*var timeSpentFbLoginShown = utilObj.getCurrentTimestamp() - gameObj.getLastFbLoginShowTimestamp();
         var timeSpentRateUsShown = utilObj.getCurrentTimestamp() - gameObj.getLastRateUsShowTimestamp();
         var timeSpentInviteAndWinShown = utilObj.getCurrentTimestamp() - gameObj.getLastInviteAndWinShowTimestamp();

         if (!popupLayer.popupOpen && ftueObj.isFtueShown()) {
         if (timeSpentRateUsShown > 72 * 3600 && gameObj.getLastRatedVersion() == 0) {
         rateUsPopup.show();
         } else if (fbWrapperObj.isLoggedIn() && timeSpentInviteAndWinShown > 24 * 3600) {
         inviteAndWinPopup.show();
         } else if (!fbWrapperObj.isLoggedIn() && timeSpentFbLoginShown > 24 * 3600) {
         fbConnectPopup.show();
         }
         }*/
    }
    ,

    loadPuzzle: function (params) {
        if (!ftueObj.isFtueShown() || homeLayer.achivementReminderVisible) {
            return;
        }
        if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
            // loggerObj.debugLog("coming to this point - 68");
            return;
        }

        if (!ftueObj.isAchievementFtueShown()) {
            return;
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }
        var index = params.index;
        var recentInProgress = homeLayer.sections;
        // gameObj.setCrosswordToShow(recentInProgress[index].id);
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_HOME, constantsObj.TRACK_OLD, "", gameObj.getPuzzleSpeciesTracking(), "", "");
        homeLayer.hide();
        calendarLayer.selectedDate = utilObj.getDateForId(recentInProgress[index].id);
        gameLayer.show(recentInProgress[index].id);
    }
    ,

    hide: function () {
        homeLayer.stopAllActions();
        homeLayer.removeAllChildren();
        homeLayer.setVisible(false);
    }
    ,

    getSectionsForRecentPuzzles: function () {
        var sections = [];
        gameObj.loadRecentInProgress();
        var recentInProgress = gameObj.getRecentInProgress();
        var todaysId = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
        for (var i in recentInProgress) {
            var id = recentInProgress[i];
            if (id == todaysId || gameObj.checkForMiniOrMidi(id) || (id == gameObj.getTodaysFreePuzzle() && scoresObj.getMastery(id) == 0) || id == gameObj.getCurrentHeroPosPuzzle()) {
                continue;
            }
            if (parseInt(id) < 20170301) {
                continue;
            }
            var date = utilObj.getDateForId(id);
            var formattedDate = utilObj.getFormattedDate(date);
            var day = date.getDay();
            var section = {
                id: id,
                text: stringsObj.puzzle_themes[day],
                subText: formattedDate,
                circleSprite: constantsObj.LOGO_FOR_DAYS[day],
                day: day
            };
            sections.push(section);
        }
        if (sections.length > 1) {
            var emptySection = {
                isEmpty: true
            };
            sections.push(emptySection);
        }
        homeLayer.sections = sections;
        return sections;
    }
    ,

    settings: function () {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
            // loggerObj.debugLog("coming to this point - 69");
            return;
        }

        if (!ftueObj.isAchievementFtueShown()) {
            return;
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }
        if (homeLayer.achivementReminderVisible) {
            homeLayer.removeReminder();
            gameObj.setIsBackFromGameLayer(false);
            gameObj.setAchivementReminderSeenTimestamp(utilObj.getCurrentTimestamp());
            return;
        }
        settingsPopup.show(constantsObj.SCREEN_HOME);
    }
    ,

    getListElement: function (index) {
        var item = homeLayer.scrollView.getIndex(index)
        if (utilObj.isNodeValid(item)) {
            return item;
        }
        return null;
    }
    ,

    createListElementForPacks: function (item, j) {
        return;
        var zOrder = constantsObj.UI_Z_ORDER;
        var xPos = xLeftPos;
        var screen = constantsObj.SCREEN_HOME;

        var sectionHeight = 550;
        var itemWidget = new ccui.Widget();
        //var sections = item.section;
        var textFont = constantsObj.FONT_ROBOTO_MEDIUM_70, subTextFont = constantsObj.FONT_ROBOTO_REGULAR_60;

        var circleScale = constantsObj.SCALE_SPRITE_1 * 1.5;
        var offsetForCircleSprite = 50;
        if (j > 6) {
            circleScale = constantsObj.SCALE_SPRITE_6 * 1.5;
            offsetForCircleSprite = 75
        }
        if (j == 12) {
            circleScale = constantsObj.SCALE_SPRITE_14 * 1.5;
            //offsetForCircleSprite = 75
        }

        var itemHeight = 440;
        var itemWidth = 330;
        itemWidget.setContentSize(cc.size(itemWidth, itemHeight + 30));
        var localXPos = xPos;
        var localYPos = itemHeight;

        var sectionBg = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, localXPos, localYPos - 185, 0, 0.5, itemWidth, itemHeight);
        //itemWidget.addChild(sectionBg, zOrder);
        utilObj.addChild(itemWidget, sectionBg, zOrder);

        //check for number of puzzles completed
        var packInfo = gameObj.getPackInfo();
        var packArr = packInfo[j];
        var lockStatus = gameObj.getPackInfoLockStatus();

        var numberOfPuzzleSolved = 0;
        for (var i = 0; i < packArr.length; i++) {
            var crossWord = packArr[i];
            var score = scoresObj.getHighScore(crossWord);
            if (score > 0) {
                numberOfPuzzleSolved++;
            }
        }
        var created = userObj.getCreated();
        var createdDate = new Date(created * 1000);
        var cDate = utilObj.getIdForDate(createdDate);

        if (j == 13 && !(numberOfPuzzleSolved == packArr.length) && cDate < constantsObj.NEW_PACK_DATE) {
            var new_banner = utilObj.getSprite(constantsObj.new_banner, localXPos + 180, localYPos + 50, 0, 1, constantsObj.SCALE_SPRITE_9);
            //itemWidget.addChild(new_banner, zOrder + 1);
            utilObj.addChild(itemWidget, new_banner, zOrder + 1);
        }

        var circleSprite = constantsObj.LOGO_FOR_DAYS_PACK[j];
        if (circleSprite) {
            var circleImage = utilObj.getSprite(circleSprite, localXPos + offsetForCircleSprite, localYPos - 120, 0, 0.5, circleScale);
            circleImage.setColor(constantsObj.COLOR_FOR_WEEK_THEMES[j]);
            //itemWidget.addChild(circleImage, zOrder);
            utilObj.addChild(itemWidget, circleImage, zOrder);
        }

        var text1 = stringsObj.puzzle_themes_pack[j];
        var textLabel = utilObj.getBMFontLabel(text1, constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localXPos + 160, localYPos - 280, 0.5, 0.5);
        //itemWidget.addChild(textLabel, zOrder);
        utilObj.addChild(itemWidget, textLabel, zOrder);

        if (numberOfPuzzleSolved == packArr.length) {
            var textLabel2 = utilObj.getBMFontLabel("Completed", constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localXPos + 160, localYPos - 365, 0.5, 0.5);
            //itemWidget.addChild(textLabel2, zOrder);
            utilObj.addChild(itemWidget, textLabel2, zOrder);
        } else if (lockStatus[j] == true || lockStatus[j] == undefined) {
            if (lockStatus[j] == undefined) {
                lockStatus[j] = true;
                gameObj.setPackInfoLockStatus(lockStatus);
            }
            var textLabel2 = utilObj.getBMFontLabel(packArr.length + " " + "Puzzles", constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localXPos + 160, localYPos - 365, 0.5, 0.5);
            //itemWidget.addChild(textLabel2, zOrder);
            utilObj.addChild(itemWidget, textLabel2, zOrder);
        } else {
            var textLabel2 = utilObj.getBMFontLabel(numberOfPuzzleSolved + "/" + packArr.length, constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localXPos + 160, localYPos - 365, 0.5, 0.5);
            //itemWidget.addChild(textLabel2, zOrder);
            utilObj.addChild(itemWidget, textLabel2, zOrder);
        }

        if (j == 7) {
            var free_tag = utilObj.getSprite(constantsObj.free_tag_1, localXPos + offsetForCircleSprite + 140, localYPos - 62, 0, 0.5, constantsObj.SCALE_SPRITE_9);
            //itemWidget.addChild(free_tag, zOrder);
            utilObj.addChild(itemWidget, free_tag, zOrder);
        }

        var button = utilObj.getButton(320, 450, 0, 0.5, localXPos, localYPos - 185,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'homeLayer',
                fn: item.fn,
                params: {index: j, sound: false},
                screen: screen,
                track: {
                    k: constantsObj.TRACK_PACK,
                    p: constantsObj.TRACK_HOME_CLICK,
                    c: stringsObj.puzzle_themes[j],
                    o: "",
                    f: "",
                    g: gameObj.getPackStatus(j),
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        //itemWidget.addChild(button, zOrder);
        utilObj.addChild(itemWidget, button, zOrder);
        return itemWidget;
    }
    ,


    createListElement: function (item, yPos, labelArr, spriteArr) {
        var layoutExperimentVariant = epmObj.getChosenVariant(constantsObj.EXP_LAYOUT);
        var homeScreenExp = epmObj.getChosenVariant(constantsObj.EXP_HOME_SCREEN)
        var zOrder = constantsObj.SPRITE_Z_ORDER;
        var xPos = xLeftPos;
        var screen = constantsObj.SCREEN_HOME;

        if (layoutExperimentVariant == constantsObj.EXP_VAR_CONTROL) {

        } else {
            if (item.headerText == stringsObj.Daily_mini_puzzle && !homeLayer.toShowDailyMini) {
                return yPos;
            }

            var sectionHeight = 300;
            var circleScale = constantsObj.SCALE_SPRITE_31 * 1.5;
            var textFont = constantsObj.FONT_ROBOTO_MEDIUM_60, subTextFont = constantsObj.FONT_ROBOTO_REGULAR_50;
            if (item.headerText == stringsObj.PACKS) {
                sectionHeight = 450;
                circleScale = constantsObj.SCALE_SPRITE_48 * 1.5;
            } else if (item.headerText == stringsObj.TODAYS_PUZZLE || item.headerText == stringsObj.BONUS_ARCHIVE_PUZZLE || item.headerText == stringsObj.PREMIUM_ARCHIVE_PUZZLE || item.headerText == stringsObj.REGULAR_ARCHIVE) {
                sectionHeight = 400;
                circleScale = constantsObj.SCALE_SPRITE_31;
                textFont = constantsObj.FONT_ROBOTO_MEDIUM_80;
                subTextFont = constantsObj.FONT_ROBOTO_REGULAR_60;
            } else if (item.headerText == stringsObj.Daily_mini_puzzle) {
                sectionHeight = 300;
                circleScale = constantsObj.SCALE_SPRITE_31 * 0.6;
                textFont = constantsObj.FONT_ROBOTO_MEDIUM_60;
                subTextFont = constantsObj.FONT_ROBOTO_REGULAR_40;
            } else if (item.headerText == stringsObj.GAMES_MODES) {
                sectionHeight = 300;
                circleScale = constantsObj.SCALE_SPRITE_17;
                textFont = constantsObj.FONT_ROBOTO_MEDIUM_70;
                subTextFont = constantsObj.FONT_ROBOTO_REGULAR_50;
            } else if (item.headerText == stringsObj.archive_calendar) {
                sectionHeight = 440;
                circleScale = constantsObj.SCALE_SPRITE_1 * 1.5;
            } else {
                sectionHeight = 200;
                circleScale = constantsObj.SCALE_SPRITE_1;
            }

            var itemWidget = new ccui.Widget();
            var sections = item.section;
            var offset = item.extraYOffset;

            if ((item.headerText == stringsObj.IN_PROGRESS)) {
                // loggerObj.debugLog("offset change");
                offset -= 400;
            }

            if (item.headerText == stringsObj.TODAYS_PUZZLE || item.headerText == stringsObj.BONUS_ARCHIVE_PUZZLE || item.headerText == stringsObj.PREMIUM_ARCHIVE_PUZZLE || item.headerText == stringsObj.REGULAR_ARCHIVE) {
                var id = null;
                if (item.params) {
                    id = item.params.id;
                } else {
                    if (gameObj.getInstallDay() == utilObj.getIdForDate(gameObj.getTodaysPuzzleDate())) {
                        id = gameObj.getD0Id();
                    } else {
                        id = gameObj.getIdForTodaysPuzzle();
                    }
                }
                var fontColorTime = constantsObj.COLOR_CALENDAR_TIME;
                var crosswordInfo = gameObj.getCrosswordForDate(id);

                // var themedQuestData = themedQuestObj.getThemedQuestData();
                // var timeSt = gameObj.getLastSync();
                // if (!utilObj.isStaging()) {
                //     timeSt = gameObj.getLastSync();
                // }
                // var buildVersionCode = utilObj.getVersionCode();
                // if (timeSt > themedQuestData["start"] && timeSt <= themedQuestData["end"] && homeLayer.subscriptionTag != 1 && !gameObj.getIsThemedQuestFinished() && !gameObj.getIsThemedQuestLocked() && ((utilObj.isAndroid() && buildVersionCode >= themedQuestData["minBuildAndroid"]) || (utilObj.isIos() && buildVersionCode >= themedQuestData["minBuildIos"]))) {
                //     var themedQuestOverlay = utilObj.getSprite(constantsObj.themed_quest_puzzle_overlay, xPos + 1220 * canvasWidth / 1440, yPos - sectionHeight / 2 - offset - 110, 0.5, 0.5, constantsObj.SCALE_ONE, spriteArr, homeLayer.scrollView, zOrder + 1, constantsObj.SPRITE_MISC);
                // }
                homeLayer.timerCircle(crosswordInfo, id, xPos, yPos, sectionHeight, offset, spriteArr, labelArr, zOrder, false);
                if (id == gameObj.getTodaysFreePuzzle() && !gameObj.getInProgress()[id]) {
                    var videoIcon = utilObj.getSprite(item.section[0].playIcon, xPos + 1260 * canvasWidth / 1440, yPos - sectionHeight / 2 - offset - 80, 0.5, 0.5, constantsObj.SCALE_SPRITE_1, spriteArr, homeLayer.scrollView, zOrder + 1, constantsObj.SPRITE_MISC);
                    videoIcon.setColor(constantsObj.COLOR_PURPLE_02);
                    var videoLabel = utilObj.getBMFontLabel("FREE", constantsObj.FONT_ROBOTO_REGULAR_50, constantsObj.COLOR_PURPLE_02,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 1260 * canvasWidth / 1440, yPos - sectionHeight / 2 - offset - 180, 0.5, 0.5, labelArr, homeLayer.scrollView, zOrder + 1);
                }

                if (homeLayer.subscriptionTag == 1) {
                    var offerTag = utilObj.getSprite(constantsObj.offer_tag, xPos + 1260 * canvasWidth / 1440, yPos - sectionHeight / 2 - offset - 70, 0.5, 0, constantsObj.SCALE_SPRITE_1, spriteArr, homeLayer.scrollView, zOrder + 1, constantsObj.SPRITE_MISC);
                }
            }

            if (item.headerText == stringsObj.Daily_mini_puzzle) {
                var id = null;
                if (item.params) {
                    id = item.params.id;
                } else {
                    id = gameObj.getIdForTodaysPuzzle();
                    id = stringsObj.mini_prefix + id.substr(2, id.length);
                }
                if (homeLayer.dailyMiniToShow != null) {
                    id = homeLayer.dailyMiniToShow;
                }
                var fontColorTime = constantsObj.COLOR_CALENDAR_TIME;
                var crosswordInfo = gameObj.getCrosswordForDate(id);
                var offsetlocal = 0;
                if (sections[0].isBonusArchive || homeLayer.dailyMiniToShow != null || homeLayer.subscriptionTag == 2) {
                    offsetlocal -= 95;
                }
                if (homeLayer.subscriptionTag == 2) {
                    if (homeLayer.subs_popup_condition) {
                        var offerTag = utilObj.getSprite(constantsObj.offer_tag, xPos + 1260 * canvasWidth / 1440, yPos + 60 + offsetlocal - sectionHeight / 2 - offset - 85, 0.5, 0, constantsObj.SCALE_SPRITE_1, spriteArr, homeLayer.scrollView, zOrder + 5, constantsObj.SPRITE_MISC);
                    }
                } else {
                    homeLayer.timerCircle(crosswordInfo, id, xPos, yPos + 100 + offsetlocal, sectionHeight, offset, spriteArr, labelArr, zOrder, false);
                }
            }

            var itemHeight = 100 + sectionHeight * sections.length + 3 * sections.length;
            if (item.headerText == stringsObj.IN_PROGRESS) {
                itemHeight = 100 + sectionHeight * (sections.length + 1.5);
            }
            var itemWidth = canvasWidth - 40;
            itemWidget.setContentSize(cc.size(itemWidth, itemHeight));
            var localXPos = xPos + 20;
            var localYPos = yPos - offset;
            // loggerObj.debugLog("ypos and offset", yPos, localYPos, offset);
            var i = 0;
            if (item.headerText == stringsObj.IN_PROGRESS) {

                itemWidget.setContentSize(cc.size(itemWidth, itemHeight));
            }
            var headerTextOffset = 0;
            var d = gameObj.getTodaysPuzzleDate();
            if (item.headerText != stringsObj.Daily_mini_puzzle) {
                var counterText = "";
                if (item.headerText == stringsObj.PREMIUM_ARCHIVE_PUZZLE) {
                    var numberOfFreeArchive = constantsObj.SUBSCRIPTION_FREEARCHIVE;
                    var numberOfOpenedFreeArchive = constantsObj.SUBSCRIPTION_FREEARCHIVE - gameObj.getFreeArchivePuzzleSub();
                    counterText = " (" + numberOfOpenedFreeArchive + "/" + numberOfFreeArchive + ")";
                }
                var headerTextLabel = utilObj.getBMFontLabel(item.headerText + counterText, constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 50, localYPos - 60, 0, 0.5, labelArr, homeLayer.scrollView, zOrder + 1);

                if (item.headerText == stringsObj.TODAYS_PUZZLE) {
                    var headerTextLabel = utilObj.getBMFontLabel(utilObj.getFormattedDate(d), constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 1350 * canvasWidth / 1440, localYPos - 60, 1, 0.5, labelArr, homeLayer.scrollView, zOrder + 1);
                }
                localYPos -= 105;
                headerTextOffset = 105;
            }

            if (item.headerText == stringsObj.Daily_mini_puzzle && (sections[0].isBonusArchive || homeLayer.dailyMiniToShow != null || homeLayer.subscriptionTag == 2)) {
                if (homeLayer.dailyMiniToShow != null || homeLayer.subscriptionTag == 2) {
                    if (homeLayer.dailyMiniToShow != null) {
                        var dailyMiniId = homeLayer.dailyMiniToShow;
                        dailyMiniId = "20" + dailyMiniId.substr(2, dailyMiniId.length);
                        var date = utilObj.getDateForId(dailyMiniId);
                        if (subscriptionsDTCObj.getIsSubscriptionActive() || subscriptionsDTCObj.getIsSubscriptionInActive()) {
                            var headerTextLabel = utilObj.getBMFontLabel(stringsObj.FROM_MINI_ARCHIVE, constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
                                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 50, localYPos - 60, 0, 0.5, labelArr, homeLayer.scrollView, zOrder + 1);
                        } else {
                            var headerTextLabel = utilObj.getBMFontLabel(stringsObj.ARCHIVE_DAILY_MINI, constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
                                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 50, localYPos - 60, 0, 0.5, labelArr, homeLayer.scrollView, zOrder + 1);
                        }
                        var headerTextLabel = utilObj.getBMFontLabel(utilObj.getFormattedDate(date), constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
                            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 1350 * canvasWidth / 1440, localYPos - 60, 1, 0.5, labelArr, homeLayer.scrollView, zOrder + 1);
                        localYPos -= 105;
                        headerTextOffset = 105;
                    } else {
                        var headerTextLabel = utilObj.getBMFontLabel(stringsObj.PREMIUM_EDITION_ONLY, constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
                            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 50, localYPos - 60, 0, 0.5, labelArr, homeLayer.scrollView, zOrder + 1);
                        localYPos -= 105;
                        headerTextOffset = 105;
                    }
                } else {
                    var headerTextLabel = utilObj.getBMFontLabel(stringsObj.TODAY_DAILY_MINI, constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 50, localYPos - 60, 0, 0.5, labelArr, homeLayer.scrollView, zOrder + 1);
                    var headerTextLabel = utilObj.getBMFontLabel(utilObj.getFormattedDate(d), constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 1350 * canvasWidth / 1440, localYPos - 60, 1, 0.5, labelArr, homeLayer.scrollView, zOrder + 1);
                    localYPos -= 105;
                    headerTextOffset = 105;
                }
            }


            var day = d.getDay();

            if (item.headerText != stringsObj.PACKS) {
                if (item.headerText == stringsObj.archive_calendar) {
                    itemWidth = itemWidth / 2 - 50;
                }
                for (var j in sections) {
                    // loggerObj.debugLog("sections here");
                    var section = sections[j];
                    if (section.isEmpty) {
                        var bg = utilObj.getScale9Sprite(constantsObj.trans_button, localXPos, localYPos, 0, 1, canvasWidth, sectionHeight, spriteArr, homeLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
                        //itemWidget.addChild(bg, zOrder);
                        //utilObj.addChild(itemWidget, bg, zOrder);
                        localYPos -= sectionHeight;
                        continue;
                    }

                    var puzzleTracking = gameObj.getCurPuzzleTracking();
                    var puzzleTheme = gameObj.getTrackingPuzzleTheme();
                    var puzzleSpecies = gameObj.getPuzzleSpeciesTracking();
                    if (zenModeObj.isBlitzMode(item)) {
                        puzzleTracking = zenModeObj.getBlitzPuzzleTracking();
                        puzzleTheme = zenModeObj.getBlitzPuzzleTheme();
                        puzzleSpecies = zenModeObj.getBlitzSpeciesTracking();
                    }
                    var button = utilObj.getButton(itemWidth, sectionHeight, 0, 1.0, localXPos, localYPos,
                        constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                            obj: 'homeLayer',
                            fn: item.fn,
                            // params: {index: j, sound: false},
                            screen: screen,
                            //params: {buttonNum: i},
                            params: (item.params) ? item.params : {index: j, sound: false},
                            track: {
                                k: constantsObj.TRACK_DIALOG,
                                p: puzzleTracking,
                                c: puzzleTheme,
                                o: constantsObj.TRACK_HOME,
                                f: item.trackF,
                                g: "",
                                s: puzzleSpecies,
                                co: 1,
                                oppId: ""
                            },
                        }, false, ccui.Widget.PLIST_TEXTURE, 1);
                    //itemWidget.addChild(button, zOrder);
                    utilObj.addChild(homeLayer.scrollView, button, zOrder);
                    var tile = constantsObj.tile_white;
                    tile = constantsObj.rounded_2;
                    var sectionBg = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, itemWidth / 2 + 20, localYPos - sectionHeight / 2, 0.5, 0.5, itemWidth - 20, sectionHeight, spriteArr, homeLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
                    sectionBg.setColor(constantsObj.COLOR_WHITE);

                    if (homeLayer.subscriptionTag == 2 && item.headerText == stringsObj.Daily_mini_puzzle) {
                        var sectionBgFaded = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, itemWidth / 2 + 20, localYPos - sectionHeight / 2, 0.5, 0.5, itemWidth - 20, sectionHeight, spriteArr, homeLayer.scrollView, zOrder + 2, constantsObj.SPRITE_MISC);
                        sectionBgFaded.setColor(constantsObj.COLOR_WHITE);
                        sectionBgFaded.setOpacity(90);
                    }


                    var idt = gameObj.getPackIdSurfaced();
                    var packsFinished = false;
                    if (idt == -1) {
                        idt = gameObj.getPackIdSurfacedToBuy();
                        if (idt == -1) {
                            packsFinished = true;
                            // loggerObj.debugLog("packs over , setting packs finished as true");
                        }
                    }

                    if (item.headerText == stringsObj.archive_calendar && (packsFinished == true)) {
                        var headerTextLabel1 = utilObj.getBMFontLabel("PUZZLE PACKS", constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
                            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xRightPos - itemWidth + 20, localYPos - 60 + 105, 0, 0.5, labelArr, homeLayer.scrollView, zOrder + 1);

                        var sectionBg = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, xRightPos - itemWidth / 2 - 40, localYPos - sectionHeight / 2, 0.5, 0.5, itemWidth - 20, sectionHeight, spriteArr, homeLayer.scrollView, zOrder);
                        sectionBg.setColor(constantsObj.COLOR_WHITE);
                        var textLabel = utilObj.getBMFontLabel("MORE PACKS", constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_LIGHT_GREY,
                            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xRightPos - itemWidth / 2 - 30, localYPos - sectionHeight / 2 + 40, 0.5, 0.5, labelArr, homeLayer.scrollView, zOrder + 1);

                        var textLabel = utilObj.getBMFontLabel("ON ITS WAY", constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_LIGHT_GREY,
                            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xRightPos - itemWidth / 2 - 40, localYPos - sectionHeight / 2 - 50, 0.5, 0.5, labelArr, homeLayer.scrollView, zOrder + 1);

                    }

                    if (item.headerText == stringsObj.archive_calendar && (packsFinished == false)) {
                        var button = utilObj.getButton(itemWidth, sectionHeight, 0, 1.0, xRightPos - itemWidth - 20, localYPos,
                            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                                obj: 'homeLayer',
                                fn: 'showPacksQuick',
                                params: {index: j, sound: false},
                                screen: screen,
                                //params: {buttonNum: i},
                                track: {
                                    k: constantsObj.TRACK_DIALOG,
                                    p: gameObj.getCurPuzzleTracking(),
                                    c: gameObj.getTrackingPuzzleTheme(),
                                    o: constantsObj.TRACK_HOME,
                                    f: constantsObj.TRACK_PACK,
                                    g: "",
                                    s: gameObj.getPuzzleSpeciesTracking(),
                                    co: 1,
                                    oppId: ""
                                },
                            }, false, ccui.Widget.PLIST_TEXTURE, 1);
                        //itemWidget.addChild(button, zOrder);
                        utilObj.addChild(homeLayer.scrollView, button, zOrder);
                        var tile = constantsObj.tile_white;
                        tile = constantsObj.rounded_2;
                        var sectionBg = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, xRightPos - itemWidth / 2 - 20, localYPos - sectionHeight / 2, 0.5, 0.5, itemWidth - 20, sectionHeight, spriteArr, homeLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
                        sectionBg.setColor(constantsObj.COLOR_WHITE);
                        if (section.circleSprite) {
                            var id = gameObj.getPackIdSurfaced();
                            if (id == -1) {
                                id = gameObj.getPackIdSurfacedToBuy();
                                if (id == -1) {
                                    utilObj.showMessage("We will be up with more packs soon!")
                                    //return;
                                }
                            }
                            var image = constantsObj.LOGO_FOR_DAYS_PACK[id];
                            circleScale *= constantsObj.MINI_PACK_INFO[id]["circleScaleHome"];


                            var circleImage = utilObj.getSprite(image, localXPos + 180, localYPos - sectionHeight / 2 - 10, 0.5, 0.5, circleScale);
                            if (item.headerText == stringsObj.archive_calendar) {

                                var headerTextLabel1 = utilObj.getBMFontLabel("PUZZLE PACKS", constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
                                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xRightPos - itemWidth + 20, localYPos - 60 + 105, 0, 0.5, labelArr, homeLayer.scrollView, zOrder + 1);


                                circleImage = utilObj.getSprite(image, xRightPos - itemWidth / 2 - 30, localYPos - sectionHeight / 2 + 60, 0.5, 0.5, circleScale);

                                if (gameObj.getMastery1() <= 0) {
                                    if (gameObj.checkIfPackComplete(7) == false) {
                                        // loggerObj.debugLog("coming to this point - 3")
                                    } else {
                                        // loggerObj.debugLog("coming to this point - 4");
                                        var lock = utilObj.getSprite(constantsObj.lock, xRightPos - itemWidth / 2 - 30, localYPos - sectionHeight / 2 + 60, 0.5, 0.5, constantsObj.SCALE_SPRITE_1 * 1.5, spriteArr, homeLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
                                        lock.setColor(constantsObj.COLOR_BLACK);

                                    }
                                }
                            }

                            if (item.headerText != stringsObj.archive_calendar) {
                                circleImage.setColor(constantsObj.COLOR_FOR_WEEK_THEMES[section.day]);

                            }


                            circleImage.setColor((constantsObj.MINI_PACK_INFO[id]["packColor"]));
                            if (id == constantsObj.NUM_PACKS - 1) {
                                sectionBg.setColor(constantsObj.MINI_PACK_INFO[id]["packColor"]);
                                circleImage.setColor(constantsObj.COLOR_WHITE);
                            }

                            utilObj.addChild(homeLayer.scrollView, circleImage, zOrder + 1);
                            //var text1 = ;

                            var textLabel = utilObj.getBMFontLabel(stringsObj.puzzle_themes_pack_Info[id], textFont, constantsObj.COLOR_BLACK,
                                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xRightPos - itemWidth / 2 - 30, localYPos - sectionHeight / 2 - 100, 0.5, 0.5, labelArr, homeLayer.scrollView, zOrder + 1);

                            var firstIncompletePuzzle = gameObj.firstIncompletePuzzle(id);
                            if (firstIncompletePuzzle.length > 2 && firstIncompletePuzzle.indexOf("20") == 0) {
                                firstIncompletePuzzle = gameObj.getFirstUnopenedCalendarCollectionPuzzle();
                            }
                            if (firstIncompletePuzzle.length > 2) {
                                firstIncompletePuzzle = firstIncompletePuzzle.substr(-2);
                                if (firstIncompletePuzzle.length > 1 && firstIncompletePuzzle < 10) {
                                    firstIncompletePuzzle = firstIncompletePuzzle.substr(-1);
                                }
                            }
                            var numberOfPuzzleCompleted = firstIncompletePuzzle;
                            var totalPuzzles = gameObj.getTotalPuzzle(id);
                            if (numberOfPuzzleCompleted > totalPuzzles) {
                                numberOfPuzzleCompleted = totalPuzzles;
                            }

                            var subTextLabel = utilObj.getBMFontLabel("Puzzle " + numberOfPuzzleCompleted + " of " + totalPuzzles, subTextFont, constantsObj.COLOR_LIGHT_GREY,
                                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xRightPos - itemWidth / 2 - 30, localYPos - sectionHeight / 2 - 170, 0.5, 0.5, labelArr, homeLayer.scrollView, zOrder + 1);
                            if (id == constantsObj.NUM_PACKS - 1) {
                                textLabel.setColor(constantsObj.COLOR_WHITE);
                                subTextLabel.setColor(constantsObj.COLOR_WHITE)
                            }

                            if (gameObj.getMastery1() <= 0) {
                                if (gameObj.checkIfPackComplete(7) == false) {
                                    circleImage.setOpacity(255);
                                    textLabel.setOpacity(255);
                                    subTextLabel.setOpacity(255);
                                } else {
                                    circleImage.setOpacity(60);
                                    textLabel.setOpacity(60);
                                    subTextLabel.setOpacity(60);
                                }
                            } else {
                                circleImage.setOpacity(255);
                                textLabel.setOpacity(255);
                                subTextLabel.setOpacity(255);
                            }
                        }

                    }

                    if (section.circleSprite) {
                        if (item.headerText == stringsObj.archive_calendar) {
                            var circleImage = utilObj.getSprite(section.circleSprite, localXPos + itemWidth / 2, localYPos - sectionHeight / 2 + 60, 0.5, 0.5, circleScale, spriteArr, homeLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
                            if (homeLayer.subscriptionTag == 3) {
                                var offerTag = utilObj.getSprite(constantsObj.offer_tag, localXPos + itemWidth / 2 + (210 * canvasWidth / 1440), localYPos - sectionHeight / 2 + 60, 0.5, 0, constantsObj.SCALE_SPRITE_1, spriteArr, homeLayer.scrollView, zOrder + 1, constantsObj.SPRITE_MISC);
                            }

                        } else if (item.headerText != stringsObj.archive_calendar) {
                            var circleImage = utilObj.getSprite(section.circleSprite, localXPos + 180, localYPos - sectionHeight / 2, 0.5, 0.5, circleScale, spriteArr, homeLayer.scrollView, zOrder + 1, constantsObj.SPRITE_MISC);
                            loggerObj.debugLog("circleSpite", section.circleSprite, item.headerText);
                            if (item.headerText == stringsObj.GAMES_MODES) {
                                loggerObj.debugLog("circleSpite1", section.circleSprite, item.headerText);
                            } else if (item.headerText != stringsObj.Daily_mini_puzzle) {
                                circleImage.setColor(constantsObj.COLOR_FOR_WEEK_THEMES[section.day]);
                            }

                        }
                    }

                    localYPos -= sectionHeight / 2;

                    if (item.headerText == stringsObj.archive_calendar) {
                        var textLabel = utilObj.getBMFontLabel(section.text, textFont, constantsObj.COLOR_BLACK,
                            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + itemWidth / 2, localYPos - 105, 0.5, 0.5, labelArr, homeLayer.scrollView, zOrder + 1);

                        var subTextLabel = utilObj.getBMFontLabel(section.subText, subTextFont, constantsObj.COLOR_LIGHT_GREY,
                            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + itemWidth / 2, localYPos - 170, 0.5, 0.5, labelArr, homeLayer.scrollView, zOrder + 1);

                    } else {
                        var xOffset = 300 + 90;
                        var heartsSpacing = 80;
                        var zOrderLocal = zOrder + 1;
                        var hearts_array = [];
                        if ((item.headerText == stringsObj.TODAYS_PUZZLE || item.headerText == stringsObj.Daily_mini_puzzle )) {
                            if (item.headerText == stringsObj.Daily_mini_puzzle) {
                                textFont = constantsObj.FONT_ROBOTO_MEDIUM_80;
                            } else {
                                textFont = constantsObj.FONT_ROBOTO_MEDIUM_90;
                            }

                            if (homeLayer.subscriptionTag != 2) {
                                var textLabel = utilObj.getBMFontLabel(section.text, textFont, constantsObj.COLOR_BLACK,
                                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 300 + 90, localYPos + 10, 0, 0.5, labelArr, homeLayer.scrollView, zOrder + 1);
                            } else {
                                if (item.headerText == stringsObj.Daily_mini_puzzle) {
                                    var textLabel = utilObj.getBMFontLabel("Mini Archive", textFont, constantsObj.COLOR_BLACK,
                                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 300 + 90, localYPos + 40, 0, 0.5, labelArr, homeLayer.scrollView, zOrder + 1);
                                    var subTextLabel = utilObj.getBMFontLabel("Unlimited Access", constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_BLACK,
                                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 300 + 90, localYPos - 50, 0, 0.5, labelArr, homeLayer.scrollView, zOrder + 1);
                                } else {
                                    var textLabel = utilObj.getBMFontLabel(section.text, textFont, constantsObj.COLOR_BLACK,
                                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 300 + 90, localYPos + 10, 0, 0.5, labelArr, homeLayer.scrollView, zOrder + 1);
                                }

                            }

                        } else if (zenModeObj.isBlitzMode(item)) {
                            utilObj.getBMFontLabel(section.text, textFont, constantsObj.COLOR_BLACK,
                                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + xOffset, localYPos + 70, 0, 0.5, labelArr, homeLayer.scrollView, zOrderLocal);

                            var textToShow = stringsObj.blitz_solve_as_many;
                            if (zenModeObj.getMaxScore() > 0) {
                                textToShow = stringsObj.blitz_best_score + " " + zenModeObj.getMaxScore();
                            }
                            utilObj.getBMFontLabel(textToShow, subTextFont, constantsObj.COLOR_ACHIEVEMENT_DESC,
                                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + xOffset, localYPos - 5, 0, 0.5, labelArr, homeLayer.scrollView, zOrderLocal);

                            var maxLives = runtimeObj.getMaxLivesForBlitz();
                            for (var i = 0; i < maxLives; ++i) {
                                var heart_empty = utilObj.getSprite(constantsObj.blitz_white_heart, localXPos + xOffset + (i * heartsSpacing), localYPos - 75, 0, 0.5, constantsObj.SCALE_SPRITE_39, spriteArr, homeLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
                                heart_empty.setVisible(false);
                                hearts_array.push(heart_empty);
                            }
                            var coolDownMessage = utilObj.getBMFontLabel("", constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_ACHIEVEMENT_DESC,
                                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + xOffset, localYPos - 75, 0, 0.5, labelArr, homeLayer.scrollView, zOrderLocal);

                            var params = {
                                coolDownMessage: coolDownMessage,
                                lives: hearts_array,
                                bg: sectionBg,
                            };
                            zenModeObj.setHomeScreenParams(params);

                        } else {
                            var textLabel = utilObj.getBMFontLabel(section.text, textFont, constantsObj.COLOR_BLACK,
                                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + xOffset, localYPos + 40, 0, 0.5, labelArr, homeLayer.scrollView, zOrderLocal);
                        }


                        if (item.headerText == stringsObj.IN_PROGRESS) {
                            var subTextLabel = utilObj.getBMFontLabel(section.subText, subTextFont, constantsObj.COLOR_LIGHT_GREY,
                                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + xOffset, localYPos - 40, 0, 0.5, labelArr, homeLayer.scrollView, zOrderLocal);

                        } else {
                            if ((item.headerText == stringsObj.BONUS_ARCHIVE_PUZZLE || item.headerText == stringsObj.PREMIUM_ARCHIVE_PUZZLE || item.headerText == stringsObj.REGULAR_ARCHIVE)) {
                                var subTextLabel = utilObj.getBMFontLabel(section.subText, subTextFont, constantsObj.COLOR_LIGHT_GREY,
                                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + xOffset, localYPos - 60, 0, 0.5, labelArr, homeLayer.scrollView, zOrderLocal);
                            }
                        }
                    }

                    if (item.headerText == stringsObj.IN_PROGRESS) {
                        var inProgress = gameObj.getInProgress();
                        if (section.id == gameObj.getInstallDay()) {
                            section.id = gameObj.getD0Id();
                        }
                        if (inProgress.hasOwnProperty(section.id) && inProgress[section.id] != undefined) {
                            var tileWidth = 197.025;
                            var crosswordInfo = gameObj.getCrosswordForDate(section.id);
                            homeLayer.timerCircle(crosswordInfo, section.id, xPos, localYPos, sectionHeight, offset, spriteArr, labelArr, zOrder, true);
                        }
                    }


                    if (section.hasFreeTag) {
                        var inProgress = gameObj.getInProgress();
                        var tag = utilObj.getSprite(constantsObj.free_tag, xLeftPos + 20 + itemWidth - 10, yPos - sectionHeight - offset - headerTextOffset, 1, 0, constantsObj.SCALE_SPRITE_1, spriteArr, homeLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
                        if (scoresObj.getHighScore(id) > 0 || inProgress.hasOwnProperty(id)) {
                            tag.setVisible(false);
                        }
                    }

                    localYPos -= sectionHeight / 2;

                    if (item.headerText != stringsObj.IN_PROGRESS) {
                        //do nothing
                    } else {
                        localYPos -= 3;
                        i++;

                    }

                }

            }
            // loggerObj.debugLog("position", yPos - offset - 105 - sectionHeight);
            return yPos - offset - headerTextOffset - sectionHeight;

        }
        return yPos;

    }
    ,

    timerCircle: function (crosswordInfo, id, xPos, yPos, sectionHeight, offset, spriteArr, labelArr, zOrder, inProgress1) {
        var localYPos = yPos - sectionHeight / 2 - offset - 80;
        if (inProgress1) {
            localYPos = yPos + 20;
        }
        var yPosShift = 0;
        if (id.substring(0, 2) == "20") {
            yPosShift = 20;
        }
        var score = scoresObj.getHighScore(id);
        if (crosswordInfo != null) {
            var fillCount = crosswordInfo.fc;
            var inProgress = gameObj.getInProgress();
            if (inProgress[id]) {
                var filled = inProgress[id].filled;
                var percentCompleted = (filled / fillCount) * 100;
                var outerCircle = utilObj.getSprite(constantsObj.white_circle_150, xPos + 1280 * canvasWidth / 1440, localYPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, homeLayer.scrollView, zOrder + 1, constantsObj.SPRITE_MISC);
                outerCircle.setColor(constantsObj.COLOR_BLACK);
                outerCircle.setOpacity(constantsObj.OPACITY_10);
                var sprite = utilObj.getSprite(constantsObj.white_circle_150, xPos + 1280 * canvasWidth / 1440, localYPos, 0, 1, constantsObj.SCALE_SPRITE_9);
                var progressTimer = new cc.ProgressTimer(sprite);
                progressTimer.setType(cc.ProgressTimer.TYPE_RADIAL);
                progressTimer.setMidpoint(cc.p(0.5, 0.5));
                progressTimer.setBarChangeRate(cc.p(1, 0));
                progressTimer.setColor(constantsObj.COLOR_GREEN_01);
                progressTimer.setPosition(xPos + 1280 * canvasWidth / 1440, localYPos);
                progressTimer.setPercentage(percentCompleted);
                progressTimer.setScale(constantsObj.SCALE_SPRITE_9, constantsObj.SCALE_SPRITE_9);
                utilObj.addChild(homeLayer.scrollView, progressTimer, zOrder + 1);
                var innerCircle = utilObj.getSprite(constantsObj.white_circle_150, xPos + 1280 * canvasWidth / 1440, localYPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_18, spriteArr, homeLayer.scrollView, zOrder + 1, constantsObj.SPRITE_MISC);
                var timeTaken = utilObj.formatTime(inProgress[id].timeElapsed);
                var labelTime = utilObj.getBMFontLabel(timeTaken, constantsObj.FONT_ROBOTO_BOLD_40, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 1280 * canvasWidth / 1440, localYPos - 50, 0.5, 1, labelArr, homeLayer.scrollView, zOrder + 1);

                labelTime.setVisible(false);
                if (inProgress[id].isOpened == "true") {
                    labelTime.setVisible(true);
                }
            } else if (score > 0) {
                var fontColorTime = constantsObj.COLOR_CALENDAR_TIME;
                var masteryStars = scoresObj.getMastery(id);
                var starColor = constantsObj.COLOR_BLUE_01;
                var star1 = utilObj.getSprite(constantsObj.star_white_2, xPos + 1200 * canvasWidth / 1440, localYPos - yPosShift, 0, 0.5, constantsObj.SCALE_SPRITE_2, spriteArr, homeLayer.scrollView, zOrder + 1, constantsObj.SPRITE_MISC);
                star1.setColor(starColor);
                if (masteryStars < constantsObj.MASTERY_SILVER) {
                    starColor = constantsObj.COLOR_GREY_02;
                }
                var star2 = utilObj.getSprite(constantsObj.star_white_2, xPos + 1255 * canvasWidth / 1440, localYPos + 25 - yPosShift, 0, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, homeLayer.scrollView, zOrder + 1, constantsObj.SPRITE_MISC);
                star2.setColor(starColor);
                if (masteryStars < constantsObj.MASTERY_GOLD) {
                    starColor = constantsObj.COLOR_GREY_02;
                }
                var star3 = utilObj.getSprite(constantsObj.star_white_2, xPos + 1315 * canvasWidth / 1440, localYPos - yPosShift, 0, 0.5, constantsObj.SCALE_SPRITE_2, spriteArr, homeLayer.scrollView, zOrder + 1, constantsObj.SPRITE_MISC);
                star3.setColor(starColor);
                var timeTaken = utilObj.formatTime(score);
                var labelTime = utilObj.getBMFontLabel(timeTaken, constantsObj.FONT_ROBOTO_BOLD_40, fontColorTime,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 1285 * canvasWidth / 1440, localYPos - 40 - yPosShift, 0.5, 1, labelArr, homeLayer.scrollView, zOrder + 1);
            }
        }
    }
    ,

    loginToFB: function () {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
            // loggerObj.debugLog("coming to this point - 70");
            return;
        }
        if (!ftueObj.isAchievementFtueShown()) {
            return;
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }
        fbWrapperObj.login(homeLayer.loginSuccess);
    }
    ,

    loginSuccess: function () {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
            // loggerObj.debugLog("coming to this point - 71");
            return;
        }

        if (!ftueObj.isAchievementFtueShown()) {
            return;
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }
        gameObj.setLoggedInFb(true);
        homeLayer.show();
    }
    ,

    invite: function () {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
            // loggerObj.debugLog("coming to this point - 72");
            return;
        }
        if (!ftueObj.isAchievementFtueShown()) {
            return;
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }
        homeLayer.hide();
        //var curTimestamp = utilObj.getCurrentTimestamp();
        gameObj.setRequestCount(0);
        mfsLayer.checkAndShow(constantsObj.INVITE, constantsObj.SCREEN_HOME, null, null);
        //gameObj.lastInviteAndConnectShow = curTimestamp;
    }
    ,

    rateUs: function () {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
            // loggerObj.debugLog("coming to this point - 73");
            return;
        }
        if (!ftueObj.isAchievementFtueShown()) {
            return;
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }
        rateUsPopup.show();
    }
    ,

    redraw: function () {
        if (homeLayer.achivementReminderVisible == true) {
            return;
        }
        gameObj.setIsRedraw(true);
        homeLayer.hide();
        homeLayer.show();
    }
    ,

    back: function () {
        if (utilObj.isAndroid()) {
            quitPopup.show(constantsObj.SCREEN_HOME);
        }
    }
    ,

    showStore: function () {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
            // loggerObj.debugLog("coming to this point - 74");
            return;
        }
        if (!ftueObj.isAchievementFtueShown()) {
            return;
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }
        if (homeLayer.achivementReminderVisible) {
            homeLayer.removeReminder();
            gameObj.setIsBackFromGameLayer(false);
            gameObj.setAchivementReminderSeenTimestamp(utilObj.getCurrentTimestamp());
            return;
        }
        homeLayer.hide();
        storeLayer.show();
    }
    ,

    spinner: function () {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
            // loggerObj.debugLog("coming to this point - 75");
            return;
        }
        if (!ftueObj.isAchievementFtueShown()) {
            return;
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }

        if (((gameObj.getNumSpinnerVideos() < runtimeObj.getMaxW2eVideosSpinner()) && adsObj.hasLivesRewardedVideo() || (economyObj.getSpinCount() > 0))) {
            spinnerPopup.show();
        } else {
            outOfSpinsPopup.show();
        }
    }
    ,

    showAchievementReminder: function () {
        // loggerObj.debugLog("djain 66666");
        if (homeLayer.achivementReminderVisible == true) {
            return;
        }
        var zOrder = constantsObj.UI_Z_ORDER;
        homeLayer.transBg = utilObj.getScale9Sprite(constantsObj.black_80, xLeftPos, 0, 0, 0, canvasWidth, constantsObj.DESIGN_HEIGHT);
        //homeLayer.addChild(homeLayer.transBg, zOrder + 1);
        utilObj.addChild(homeLayer, homeLayer.transBg, zOrder + 1);
        homeLayer.achivementReminderVisible = true;

        var text = "Claim the coins you\n     earned here!";
        var textLabel1 = utilObj.getBMFontLabel(text, constantsObj.FONT_ROBOTO_REGULAR_100, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos + canvasWidth / 6, centerYPos - 350, 0.5, 1);
        //homeLayer.transBg.addChild(textLabel1, zOrder);
        utilObj.addChild(homeLayer.transBg, textLabel1, zOrder);

        var character = utilObj.getSprite(constantsObj.ftue_alien, centerXPos - 425, centerYPos - 500, 0.5, 0.5, 2.5 * 1.5);
        character.setFlippedX(true);
        //homeLayer.transBg.addChild(character);
        utilObj.addChild(homeLayer.transBg, character);


        var hand = utilObj.getSprite(constantsObj.ftue_hand, centerXPos + 3 * canvasWidth / 8, centerYPos - 750, 0.5, 0.5, constantsObj.SCALE_SPRITE_25);
        hand.setRotation(210);
        //homeLayer.transBg.addChild(hand);
        utilObj.addChild(homeLayer.transBg, hand);
        homeLayer.transAchievementsButton.setLocalZOrder(zOrder + 3);
        gameObj.setNumberOfTimeAchivementReminderShown();
        utilObj.hideBannerAd(utilObj.getScreenName(constantsObj.SCREEN_HOME));
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "achv_reminder", constantsObj.TRACK_VIEW, "", "", 1, "");

    }
    ,

    removeReminder: function () {
        if (homeLayer.achivementReminderVisible == true) {
            homeLayer.achivementReminderVisible = false;
            utilObj.removeChild(homeLayer, homeLayer.transBg);
            // utilObj.showBannerAd(utilObj.getScreenName(constantsObj.SCREEN_HOME));
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "achv_reminder", constantsObj.TRACK_CLOSE, "", "", 1, "");
            //utilObj.removeChild(gameLayer, gameLayer.cover);
            //trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), "lightning_hint", constantsObj.TRACK_CLOSE, "", gameObj.getPuzzleSpeciesTracking(), "", "");
            return true;
        }
    }
    ,

    showSubsDailyStatus: function () {
        if (!ftueObj.isFtueShown()) {
            //loggerObj.debugLog("returning point 1");
            return;
        }
        if (!ftueObj.isAchievementFtueShown()) {
            return;
        }
        if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
            //loggerObj.debugLog("coming to this point - 76");
            return;
        }
        gameObj.setScreenTypeForSubsLayer(constantsObj.SUBSCRIPTION_DAILY_STATUS);
        subscriptionsLaunchLayer.show(true);
    },

    showMsgCenter: function () {
        if (!ftueObj.isFtueShown()) {
            // loggerObj.debugLog("returning point 1");
            return;
        }
        if (!ftueObj.isAchievementFtueShown()) {
            return;
        }
        if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
            // loggerObj.debugLog("coming to this point - 76");
            return;
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), utilObj.getScreenName(curScreen), "msg_center", "", "", "", "");


        popupLayer.closeWithDefault();
        freeCoins2Popup.show(true, constantsObj.SCREEN_HOME);
    }
    ,

    // made achievement surfacing generic in model/achievements.js by the function name:= createHomeLayerUi
    populateAchievements: function (yPos, spriteArr, labelArr) {
        //Variant 2 for HomeV2
        var homeVariant = 2;
        achievementsObj.createHomeLayerUi(yPos, spriteArr, labelArr, homeVariant);
    },

    performCtaAction: function (params) {
        if (!ftueObj.isFtueShown()) {
            // loggerObj.debugLog("returning point 1");
            return;
        }
        if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
            // loggerObj.debugLog("coming to this point - 77");
            return;
        }
        if (!ftueObj.isAchievementFtueShown()) {
            return;
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }
        // loggerObj.debugLog("hitting perform cta home");
        achievementsObj.performCtaActionForId(params.id, constantsObj.TRACK_HOME);
    }
    ,

    claimReward: function (params) {
        //var toJump = params.toScroll;
        var listItems = achievementsObj.getListItemsQuest();
        if (!ftueObj.isFtueShown()) {
            // loggerObj.debugLog("returning point 1");
            return;
        }
        if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
            // loggerObj.debugLog("coming to this point - 78");
            return;
        }
        if (!ftueObj.isAchievementFtueShown()) {
            return;
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }
        economyObj.addCash(params.reward, constantsObj.TRACK_EARN, constantsObj.TRACK_ACHIEVEMENTS, params.id);
        achievementsObj.updateStateOfAchievement(params.id);
        if (params.id == constantsObj.CrossPromoAchievement1 || params.id == constantsObj.CrossPromoAchievement2) {
            machineLearningDataObj.incCrossGameQuestsEarns();
            if (listItems[params.id - constantsObj.CrossPromoOffset].isSocialQuest == 1) {
                socialQuestObj.setChangeFriendInSocialQuest(1);
            }
            trackObj.trackCounter(constantsObj.TRACK_XPROMO, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_QUEST_CENTER, listItems[params.id - constantsObj.CrossPromoOffset].id, constantsObj.TRACK_CLAIM, constantsObj.TRACK_HOME, "", "");
        } else if (params.id == constantsObj.InGameAchievement1) {
            machineLearningDataObj.incCrossGameQuestsEarns();
            var questDetails = questsObj.getWhatsappQuest();
            trackObj.trackCounter(constantsObj.TRACK_XPROMO, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_QUEST_CENTER, questDetails.id, constantsObj.TRACK_CLAIM, constantsObj.TRACK_HOME, "", "");
        } else {
            machineLearningDataObj.incInGameQuestsEarns();
        }
        //gameObj.save();
        homeLayer.redraw();
        utilObj.showCashGrantMessage(params.reward);
    }
    ,

    claimFtueReward: function (params) {
        if (!ftueObj.isAchievementFtueShown()) {
            ftueObj.setAchievementFtueShown(true);
            ftueObj.dismissAchievementFtue();
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_ACHIEVEMENTS_FTUE, constantsObj.TRACK_CLAIM, "", "", "", "");
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_ACHIEVEMENTS_FTUE, constantsObj.TRACK_CLOSE, "", "", "", "");
        }
        var toJump = params.toScroll;
        economyObj.addCash(params.reward, constantsObj.TRACK_EARN, constantsObj.TRACK_HOME, params.id);
        achievementsObj.updateStateOfAchievement(params.id);
        if (params.id == 43) {
            gameObj.setNumVideos(0);
        }
        //gameObj.save();
        homeLayer.redraw();
        utilObj.showCashGrantMessage(params.reward);
    }
    ,

    updateRemainingTimeLbl: function (timeRemaining) {
        if (curScreen == constantsObj.SCREEN_HOME && homeLayer.videoProgress != null) {
            if (utilObj.isNodeValid(homeLayer.timerLbl)) {
                homeLayer.timerLbl.setString(utilObj.formatTime(timeRemaining));
                var videoProgres = homeLayer.videoProgress.getString();
                homeLayer.videoProgress.setString(gameObj.getNumVideos() + "/" + constantsObj.ACHIEVEMENT_COUNT_WATCH_6_VIDEOS);
                if (videoProgres != homeLayer.videoProgress.getString()) {
                    homeLayer.redraw();
                }

            }

            if (gameObj.getNumVideos() >= 6) {
                /*if(utilObj.isNodeValid(homeLayer.ctaButtonVideo)){
                 homeLayer.ctaButtonVideo.setColor(constantsObj.COLOR_BUTTON_ORANGE);
                 }*/
                //achievementsLayer.ctaButtonVideo.setColor(constantsObj.COLOR_BUTTON_ORANGE);
                if (utilObj.isNodeValid(homeLayer.textLbl1)) {
                    homeLayer.textLbl1.setString("Claim");
                }
            }
        }
    }
    ,

    rewardAnim: function (delay, node, scale, alpha, coinSent) {
        var animsLbl = [];
        animsLbl.push(animObj.getDelayTime(delay));
        if (!alpha) {
            animsLbl.push((new cc.Spawn(utilObj.getScaleTo(0.15, scale * 1.3), animObj.getMoveBy(0.15, 0, 250))).easing(new cc.easeOut(1.0)));
        }
        if (coinSent) {
            animsLbl.push((new cc.Spawn(utilObj.getFadeIn(0.2), utilObj.getScaleTo(0.12, scale * 1.7))));
        }
        if (alpha) {
            animsLbl.push((new cc.Spawn(utilObj.getFadeTo(0.2, alpha), utilObj.getScaleTo(0.12, scale))));
        } else if (!coinSent) {
            animsLbl.push((new cc.Spawn(utilObj.getFadeIn(0.2), utilObj.getScaleTo(0.12, scale * 1.3))));
        }
        animObj.runAction(node, animObj.getSequence(animsLbl));
    }
    ,
    addRewardBgGlow: function (xPos, yPos, anchorX, anchorY, scale, color, opacity, sender) {
        var spriteArr = [];
        var glowImg = utilObj.getSprite(constantsObj.icon_glow, xPos, yPos, anchorX, anchorY, scale, spriteArr, sender, -1, constantsObj.SPRITE_LOCAL);
        utilObj.setOpacity(glowImg, opacity);
        glowImg.setColor(color);
        utilObj.addSprites(spriteArr);

    },

    delayedShowBannerAd: function () {
        if (curScreen == constantsObj.SCREEN_HOME) {
            utilObj.showBannerAd(utilObj.getScreenName(curScreen));
        }
    },

    loadBlitzMode: function () {
        zenModeLayer.loadBlitzMode();
    }
    ,


})
;

