var MfsLayer = cc.Layer.extend({
    scrollView: null,
    uiNode: null,
    screenName: "",
    curType: -1,
    all_friends_tag: 1,
    crossword_friends_tag: 2,
    tick_tag: 3,
    active_tag: 4,
    col_1_tag: 5,
    col_2_tag: 6,
    friendsAll: [],
    friendsJungle: [],
    friends: [],
    selectedFriends: [],
    listViewWidth: null,
    listViewHeight: 1150,
    listBgGap: 60,
    listViewYPos: 0,
    reqType: -1,
    parentScreen: null,
    parentPopup: null,
    shownAllFriends: false,
    shownJungleFriends: false,
    parentCb: null,
    lastPopup: null,
    lastPopupScreen: null,
    popupType: null,
    screen: null,
    showWithAnim: true,
    isRedraw: false,
    sendTrackOrder: null,
    checkBox_tag: 7,
    parentLayer: null,
    checkBox_array: [],
    tick_array: [],
    listYPos: 0,
    closeMfs: false,


    show: function (type, lastPopScreen, lastPop, cb, sendTrackOrder, pL) {
        if (cb) {
            mfsLayer.parentCb = cb;
        }
        if (pL) {
            mfsLayer.parentLayer = pL;
        }
        mfsLayer.lastPopup = lastPop;
        mfsLayer.lastPopupScreen = lastPopScreen;
        mfsLayer.popupType = type;
        // loggerObj.debugLog("lelouch the type is : ", type);
        mfsLayer.screen = constantsObj.SCREEN_MFS;
        utilObj.hideBannerAd(utilObj.getScreenName(constantsObj.SCREEN_MFS));
        if (sendTrackOrder) {
            mfsLayer.sendTrackOrder = sendTrackOrder;
        } else {
            mfsLayer.sendTrackOrder = null;
        }
        utilObj.updateScreenBegin(mfsLayer.screen);
        var screenName = constantsObj.SCREEN_NAMES[mfsLayer.screen];

        if (mfsLayer.lastPopupScreen == undefined) {
            loggerObj.errorLog("Invalid params to show mfs popup:", type, mfsLayer.lastPopupScreen, mfsLayer.lastPopup);
            return;
        }
        var labelArr = [];
        var spriteArr = [];
        //mfsLayer.uiNode = new cc.Node();
        var xPos = centerXPos;
        var yPos = constantsObj.DESIGN_HEIGHT;
        var zOrder = constantsObj.SPRITE_Z_ORDER;

        mfsLayer.parentScreen = mfsLayer.lastPopupScreen;
        // loggerObj.debugLog("parent screen", mfsLayer.parentScreen);
        mfsLayer.parentPopup = mfsLayer.lastPopup;

        var heading = stringsObj.invite_friends;
        var desc = stringsObj.earn_coins;
        var iconSprite = null;
        var sendButtonLabel = stringsObj.invite;
        var iconSpriteScale = constantsObj.SCALE_SPRITE_2;
        var buttonFamily = constantsObj.TRACK_SEND;
        switch (type) {
            case constantsObj.ASK_COINS:
                heading = stringsObj.ask_coins;
                // iconSprite = constantsObj.diamond_glow;
                sendButtonLabel = stringsObj.ask;
                if (mfsLayer.isRedraw) {
                    sendButtonLabel += " More";
                }
                desc = stringsObj.ask_coins_desc;
                break;
            case constantsObj.SEND_COINS:
                heading = stringsObj.send_coins;
                // iconSprite = constantsObj.diamond_glow;
                sendButtonLabel = stringsObj.send;
                if (mfsLayer.isRedraw) {
                    sendButtonLabel = stringsObj.send_more;
                    buttonFamily = constantsObj.TRACK_SEND_MORE;
                }
                desc = stringsObj.send_coins_desc;
                break;
            case constantsObj.ASK_SPINS:
                heading = stringsObj.ask_spins;
                sendButtonLabel = stringsObj.ask;
                if (mfsLayer.isRedraw) {
                    sendButtonLabel += " More";
                }
                desc = stringsObj.ask_spins_desc;
                break;
            case constantsObj.SEND_SPINS:
                heading = stringsObj.send_spins;
                sendButtonLabel = stringsObj.send;
                if (mfsLayer.isRedraw) {
                    sendButtonLabel = stringsObj.send_more;
                    buttonFamily = constantsObj.TRACK_SEND_MORE;
                }
                desc = stringsObj.send_spins_desc;
                break;
            case constantsObj.CREATURE_COINS:
                heading = stringsObj.send_coins;
                sendButtonLabel = stringsObj.send;
                if (mfsLayer.isRedraw) {
                    sendButtonLabel = stringsObj.send_more;
                    buttonFamily = constantsObj.TRACK_SEND_MORE;
                }
                desc = stringsObj.send_coins_desc;
                break;
            case constantsObj.CREATURE_SPINS:
                heading = stringsObj.send_spins;
                sendButtonLabel = stringsObj.send;
                if (mfsLayer.isRedraw) {
                    sendButtonLabel = stringsObj.send_more;
                    buttonFamily = constantsObj.TRACK_SEND_MORE;
                }
                desc = stringsObj.send_spins_desc;
                break;
            case constantsObj.INVITE:
            default:
                heading = stringsObj.invite_friends;
                sendButtonLabel = stringsObj.invite;
                if (mfsLayer.isRedraw) {
                    sendButtonLabel += " More";
                }
                desc = stringsObj.earn_coins;
                desc = desc.replace("%N%", economyObj.getReferralReward());
                break;
        }

        mfsLayer.reqType = type;

        var buttonTabs = [
            {
                type: friendsObj.BATCH_NON_APP_FRIEND,
                btnText: stringsObj.all_friends,
                tag: mfsLayer.all_friends_tag,
                trackFamily: constantsObj.TRACK_ALL_FRIENDS

            },
            {
                type: friendsObj.BATCH_APP_FRIEND,
                btnText: stringsObj.game_friends,
                tag: mfsLayer.crossword_friends_tag,
                trackFamily: constantsObj.TRACK_GAME_FRIENDS
            }
        ];

        mfsLayer.shownAllFriends = false;
        mfsLayer.shownJungleFriends = false;

        mfsLayer.listViewWidth = canvasWidth - 100;
        var tabWidth = mfsLayer.listViewWidth / 2 - 60;
        var tabGap = 30;
        var localXPos = centerXPos - tabWidth / 2 - tabGap / 2;

        var popupBg = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos, 0.5, 1, canvasWidth, constantsObj.DESIGN_HEIGHT, spriteArr, mfsLayer, zOrder, constantsObj.SPRITE_MISC);
        popupBg.setColor(constantsObj.COLOR_YELLOW_02);
        //mfsLayer.uiNode.addChild(popupBg, 0);
        //utilObj.addChild(mfsLayer.uiNode, popupBg, 0);

        mfsLayer.header = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos, 0.5, 1, canvasWidth, 200, spriteArr, mfsLayer, zOrder, constantsObj.SPRITE_MISC);
        //mfsLayer.uiNode.addChild(mfsLayer.header);
        //utilObj.addChild(mfsLayer.uiNode, mfsLayer.header);
        mfsLayer.header.setColor(constantsObj.COLOR_YELLOW_07);

        utilObj.getBMFontLabel(heading, constantsObj.FONT_ROBOTO_MEDIUM_100, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - 50, 0.5, 1.0, labelArr, mfsLayer, zOrder + 1);

        var backArrow = utilObj.getSprite(constantsObj.arrow_01, xLeftPos + 50, yPos - 50, 0, 1, constantsObj.SCALE_SPRITE_1, spriteArr, mfsLayer, zOrder, constantsObj.SPRITE_MISC);
        //mfsLayer.uiNode.addChild(backArrow, zOrder);
        //utilObj.addChild(mfsLayer.uiNode, backArrow, zOrder);
        backArrow.setColor(constantsObj.COLOR_BLACK);
        var backButton = utilObj.getButton(200, 200, 0, 1.0, xLeftPos + 50, yPos - 50,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'mfsLayer',
                fn: 'back',
                screen: mfsLayer.screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: screenName,
                    f: constantsObj.TRACK_BACK,
                    g: "",
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        //mfsLayer.uiNode.addChild(backButton, zOrder);
        utilObj.addChild(mfsLayer, backButton, zOrder + 1);

        yPos -= 350;

        var lineHeight = 80;
        var stringsArr = utilObj.getSplitStringsArr(desc, 30);
        var offset = lineHeight;

        if (stringsArr.length == 1) {
            offset = 0;
        } else if (stringsArr.length == 2) {
            offset = lineHeight / 2;
        }

        yPos += offset;

        for (var i = 0; i < stringsArr.length; i++) {
            utilObj.getBMFontLabel(stringsArr[i], constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, mfsLayer, zOrder + 1);

            yPos -= lineHeight;
        }

        yPos -= 150;

        var defaultButton = null;
        var buttonType = friendsObj.BATCH_APP_FRIEND;
        var friends = mfsLayer.getJungleFriends();
        if (friends.length == 0) {
            buttonType = friendsObj.BATCH_NON_APP_FRIEND;
            // loggerObj.debugLog("Switching to all friends as no game friends");
        }
        for (var i = 0; i < buttonTabs.length; i++) {
            var imageTabBg = utilObj.getButton(tabWidth, 200, 0.5, 0.5, localXPos, yPos, constantsObj.button_cutup,
                constantsObj.button_cutup, constantsObj.button_cutup, {
                    obj: 'mfsLayer',
                    fn: 'showList',
                    screen: mfsLayer.screen,
                    params: {type: buttonTabs[i].type},
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: gameObj.getTrackingPuzzleTheme(),
                        o: screenName,
                        f: buttonTabs[i].trackFamily,
                        g: "",
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            imageTabBg.setColor(constantsObj.COLOR_GREY_09);
            var fontColor = constantsObj.COLOR_BLACK;
            var btnZOrder = zOrder + 1;
            if ((type == constantsObj.INVITE || friends.length == 0) && buttonTabs[i].type == friendsObj.BATCH_NON_APP_FRIEND
                || (type != constantsObj.INVITE && buttonTabs[i].tag == mfsLayer.crossword_friends_tag && friends.length > 0)) {
                defaultButton = imageTabBg;
                buttonType = buttonTabs[i].type;
                btnZOrder = zOrder - 1;
                imageTabBg.setEnabled(false);
                imageTabBg.setBright(false);
            } else {
                fontColor = constantsObj.COLOR_WHITE;
                imageTabBg.setEnabled(true);
                imageTabBg.setBright(true);
                imageTabBg.setColor(constantsObj.COLOR_BLUE_01);
            }
            mfsLayer.addChild(imageTabBg, zOrder + 1, buttonTabs[i].tag);
            utilObj.getBMFontLabel(buttonTabs[i].btnText, constantsObj.FONT_ROBOTO_MEDIUM_70, fontColor,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos, yPos + 5, 0.5, 0.5, labelArr, mfsLayer,
                zOrder + 1, buttonTabs[i].tag + 1000);

            localXPos += tabWidth + tabGap;
        }
        // loggerObj.debugLog("Button type is:", type, buttonType);
        mfsLayer.listYPos = yPos + 20;
        mfsLayer.scrollView = null;
        yPos -= (mfsLayer.listViewHeight / 2 + 100 + mfsLayer.listBgGap / 2);
        mfsLayer.listViewYPos = yPos;


        var listViewBg = utilObj.getScale9Sprite(constantsObj.rounded_4, centerXPos, yPos, 0.5, 0.5, mfsLayer.listViewWidth, mfsLayer.listViewHeight + mfsLayer.listBgGap, spriteArr, mfsLayer, zOrder, constantsObj.SPRITE_MISC);
        listViewBg.setColor(constantsObj.COLOR_GREY_09);
        //mfsLayer.uiNode.addChild(listViewBg, zOrder);
        //utilObj.addChild(mfsLayer.uiNode, listViewBg, zOrder);

        yPos -= (mfsLayer.listViewHeight / 2 + 60);
        yPos -= 50;
        xPos = centerXPos;

        var selectAllButton = utilObj.getButton(500, 90, 0.5, 0.5, xPos, yPos, constantsObj.trans_button,
            constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'mfsLayer',
                fn: 'selectAll',
                screen: mfsLayer.screen,
                params: {clicked: true},
            }, false, ccui.Widget.PLIST_TEXTURE, 1);

        //mfsLayer.uiNode.addChild(selectAllButton, zOrder);
        utilObj.addChild(mfsLayer, selectAllButton, zOrder + 1);

        var checkBox = utilObj.getScale9Sprite(constantsObj.rounded_4, xPos - 200, yPos, 0.5, 0.5, 90, 90, spriteArr, mfsLayer, zOrder, constantsObj.SPRITE_MISC, mfsLayer.checkBox_tag);
        checkBox.setColor(constantsObj.COLOR_GREY_08);
        //mfsLayer.addChild(checkBox, zOrder + 1, mfsLayer.checkBox_tag);

        var tick = utilObj.getSprite(constantsObj.tick, xPos - 200, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_1, spriteArr, mfsLayer, zOrder, constantsObj.SPRITE_MISC, mfsLayer.tick_tag);
        //mfsLayer.addChild(tick, zOrder + 1, mfsLayer.tick_tag);
        tick.setColor(constantsObj.COLOR_WHITE);
        tick.setVisible(false);

        utilObj.getBMFontLabel(stringsObj.select_all, constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 120, yPos + 5, 0, 0.5, labelArr, mfsLayer, zOrder + 1);


        xPos = centerXPos;
        yPos -= 200;
        var sendButton = utilObj.getButton(585, 170, 0.5, 0.5,
            xPos, yPos, constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'mfsLayer',
                fn: 'sendRequests',
                screen: mfsLayer.screen,
                params: {reqType: type},
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: screenName,
                    f: buttonFamily,
                    g: "",
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        //mfsLayer.uiNode.addChild(sendButton, zOrder);
        utilObj.addChild(mfsLayer, sendButton, zOrder + 1);
        sendButton.setColor(constantsObj.COLOR_BUTTON_ORANGE);

        // if (iconSprite) {
        //  var icon = utilObj.getSprite(iconSprite, xPos + constantsObj.BUTTON_WIDTH_SMALL_2 / 2 - 80, yPos, 0.5, 0.5, iconSpriteScale);
        //  mfsLayer.uiNode.addChild(icon, zOrder);
        //  }

        utilObj.getBMFontLabel(sendButtonLabel, constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 292, 85, 0.5, 0.5, labelArr, sendButton, zOrder);

        utilObj.pulseButton(sendButton, constantsObj.PULSE_ACTION_TAG, 0);
        // if (!iconSprite) {
        //  sendLbl.setPositionX(xPos);
        //  }

        // loggerObj.debugLog("Showing popup with node:", mfsLayer.uiNode);
        mfsLayer.showList({type: buttonType, initialLoad: true, sender: mfsLayer});
        /*// mfsLayer.selectAll({sender: popupLayer});
        //mfsLayer.addChild(mfsLayer.uiNode);
        //utilObj.addChild(mfsLayer, mfsLayer.uiNode);

        // utilObj.addSprites(spriteArr);
        //utilObj.addLabels(labelArr);

        //utilObj.updateScreen(constantsObj.SCREEN_MFS, mfsLayer);
        */
        utilObj.updateScreen(constantsObj.SCREEN_MFS, mfsLayer);
        utilObj.addLabels(labelArr);
        utilObj.addSprites(spriteArr);

    },

    showList: function (params) {

        mfsLayer.checkBox_array = [];
        var closeMFS = false;
        mfsLayer.tick_array = [];
        var type = params.type;
        var initialLoad = params.initialLoad;
        var sender = params.sender;
        var zOrder = constantsObj.SPRITE_Z_ORDER;

        // loggerObj.debugLog("here 1");
        if (mfsLayer.curType == type) {
            // Suraj: Redraw has to be allowed - for cases after sending req to few friends.
            // loggerObj.debugLog("Not allowing redraw");
            // return;
        }

        if (type == friendsObj.BATCH_APP_FRIEND && mfsLayer.reqType == constantsObj.INVITE) {
            utilObj.showMessage("Invite can only be sent to non-DTC friends");
            return;
        }
        // loggerObj.debugLog("here 2");
        mfsLayer.curType = type;
        if (mfsLayer) {   //resetting select all on tab change
            var tick = mfsLayer.getChildByTag(mfsLayer.tick_tag);
            var checkBox = mfsLayer.getChildByTag(mfsLayer.checkBox_tag);
            if (tick) {
                tick.setVisible(true);
                checkBox.setColor(constantsObj.COLOR_BLUE_08);
            }
        }

        mfsLayer.selectedFriends = [];
        if (initialLoad == undefined || initialLoad == null || initialLoad == false) {
            for (var i = friendsObj.BATCH_APP_FRIEND; i <= friendsObj.BATCH_NON_APP_FRIEND; i++) {

                var but = mfsLayer.getChildByTag(i);
                // loggerObj.debugLog("coming here 3", utilObj.getStringifiedJson(but));
                if (but) {
                    if (but == sender) {
                        but.setEnabled(false);
                        but.setBright(false);
                        var label = mfsLayer.getChildByTag(i + 1000);
                        // loggerObj.debugLog("coming here 1");
                        if (utilObj.isNodeValid(label)) {
                            // loggerObj.debugLog("coming here 2");
                            label.setColor(constantsObj.COLOR_BLACK);
                        }
                        // loggerObj.debugLog("coming here 11");
                        //mfsLayer.reorderChild(but, 15);
                        but.setColor(constantsObj.COLOR_GREY_09);
                    } else {
                        // loggerObj.debugLog("coming here 4");
                        but.setEnabled(true);
                        but.setBright(true);
                        var label = mfsLayer.getChildByTag(i + 1000);
                        if (utilObj.isNodeValid(label)) {
                            // loggerObj.debugLog("coming here 5");
                            label.setColor(constantsObj.COLOR_WHITE);
                        }
                        // loggerObj.debugLog("coming here 6");
                        //mfsLayer.reorderChild(but, 15);
                        but.setColor(constantsObj.COLOR_BLUE_01);
                    }

                }
            }
        }
        // loggerObj.debugLog("here 3");
        switch (type) {
            case friendsObj.BATCH_NON_APP_FRIEND:
                trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "mfs", "all_friends", "", "", "", "");
                mfsLayer.friends = mfsLayer.getAllFriends();
                break;
            case friendsObj.BATCH_APP_FRIEND:
                trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "mfs", "game_friends", "", "", "", "");
                mfsLayer.friends = mfsLayer.getJungleFriends();
                break;
        }

        var yPos = mfsLayer.listViewYPos;

        if (mfsLayer.scrollView != null) {
            mfsLayer.removeChild(mfsLayer.scrollView);
        }
        var totalFriends = mfsLayer.friends.length;
        var totalHeight;
        if (totalFriends % 2 != 0) {
            totalHeight = (totalFriends / 2 + 1) * 280;
        } else {
            totalHeight = (totalFriends / 2) * 280;
        }
        // loggerObj.debugLog("here 4");
        var scrollHeight = totalHeight;


        // mfsLayer.listView = new ccui.ListView();
        // mfsLayer.listView.setDirection(ccui.ScrollView.DIR_VERTICAL);
        // mfsLayer.listView.setTouchEnabled(true);
        // mfsLayer.listView.setContentSize(cc.size(mfsLayer.listViewWidth, mfsLayer.listViewHeight));
        // mfsLayer.listView.setPosition(centerXPos, yPos);
        // mfsLayer.listView.setItemsMargin(40);
        // mfsLayer.listView.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
        // mfsLayer.listView.setAnchorPoint(0.5, 0.5);
        // // mfsLayer.listView.setColor(constantsObj.COLOR_GREY_09);


        mfsLayer.scrollView = new ccui.ScrollView();
        mfsLayer.scrollView.setDirection(ccui.ScrollView.DIR_VERTICAL);
        mfsLayer.scrollView.setTouchEnabled(true);
        mfsLayer.scrollView.setContentSize(cc.size(mfsLayer.listViewWidth, mfsLayer.listViewHeight + 20));
        mfsLayer.scrollView.setPosition(centerXPos, yPos);
        mfsLayer.scrollView.setAnchorPoint(0.5, 0.5);
        mfsLayer.scrollView.setBounceEnabled(true);
        mfsLayer.scrollView.setInnerContainerSize(cc.size(mfsLayer.listViewWidth, scrollHeight));

        if (totalHeight < mfsLayer.listViewHeight) {
            totalHeight += (mfsLayer.listViewHeight - totalHeight);
        }

        // loggerObj.debugLog("here 5");
        var framePos = 170;
        var namePos = framePos + 80;
        var itemHeight = 250;

        var labelArr = [];
        var spriteArr = [];

        if ((mfsLayer.friends.length == 0 || (mfsLayer.reqType == mfsLayer.INVITE && mfsLayer.friends.length == 0))) {
            closeMFS = true;
            // loggerObj.debugLog("No friends available");
            friendsObj.attemptUpdate();
            // loggerObj.debugLog("No friends available12");
            fbWrapperObj.showDefaultFbInvite(stringsObj.reward_mul_desc_1, stringsObj.multiply_coins);
        }

        if (closeMFS) {
            if (popupLayer.popupOpen) {
                popupLayer.closeWithDefault();
            }
            mfsLayer.back();
            // loggerObj.debugLog("checking coming here");
            //homeLayer.show();
            return;
        }

        if (mfsLayer.friends.length > 0) {
            for (var i = 0; i < mfsLayer.friends.length; i++) {
                //var itemWidget = new ccui.Widget();
                var itemWidth = mfsLayer.listViewWidth / 2 - 50;
                //itemWidget.setContentSize(cc.size(mfsLayer.listViewWidth, itemHeight));
                var localXPos = mfsLayer.listViewWidth / 4 + 10;
                yPos = itemHeight / 2;
                //itemWidget.setAnchorPoint(0.5, 0.5);
                // itemWidget.setColor(constantsObj.COLOR_GREY_09);

                var item1Bg = utilObj.getButton(itemWidth, itemHeight, 0.5, 1, localXPos, totalHeight, constantsObj.tile_white, constantsObj.tile_white, constantsObj.tile_white, {
                    obj: 'mfsLayer',
                    fn: 'selectFriend',
                    screen: constantsObj.SCREEN_MFS,
                    params: {fbId: mfsLayer.friends[i].id, clicked: true, index: i},
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
                item1Bg.setColor(constantsObj.COLOR_WHITE);
                mfsLayer.scrollView.addChild(item1Bg, zOrder, mfsLayer.col_1_tag);

                var pic = "";
                var picUrl = "";
                if (!utilObj.isWeb()) {
                    switch (type) {
                        case friendsObj.BATCH_NON_APP_FRIEND:
                            pic = mfsLayer.friends[i].name + ".jpg";
                            picUrl = friendsObj.getNonPlayingFriendPic(mfsLayer.friends[i]);
                            break;
                        case friendsObj.BATCH_APP_FRIEND:
                            pic = mfsLayer.friends[i].id + ".jpg";
                            picUrl = friendsObj.getPlayingFriendPic(mfsLayer.friends[i].id);
                            break;
                    }
                } else {
                    pic = mfsLayer.friends[i].picture.data.url;
                    picUrl = pic;
                }
                // loggerObj.debugLog("here 6");
                //
                // var profilePic = mfsLayer.getImageSprite(pic, picUrl, cc.p(framePos, yPos));
                // //item1Bg.addChild(profilePic);
                // utilObj.addChild(item1Bg, profilePic);

                if (utilObj.imageExists(pic)) {
                    utilObj.getSprite(picUrl, framePos + 40, totalHeight - 125, 0.5, 0.5, 0.73, spriteArr, mfsLayer.scrollView, zOrder, constantsObj.SPRITE_LOCAL);
                } else {
                    utilObj.getSprite(constantsObj.profile_pic, framePos + 40, totalHeight - 125, 0.5, 0.5, 0.73, spriteArr, mfsLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
                }

                var imageFrame = utilObj.getSprite(constantsObj.image_frame, framePos + 40, totalHeight - 125, 0.5, 0.5, constantsObj.SCALE_SPRITE_5 * 1.5, spriteArr, mfsLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
                imageFrame.setColor(constantsObj.COLOR_WHITE);
                //item1Bg.addChild(imageFrame);
                //utilObj.addChild(item1Bg, imageFrame);

                // var checkBox = utilObj.getSprite(constantsObj.rounded_44, 90, totalHeight - 125, 0.5, 0.5, 1.2);
                // checkBox.setColor(constantsObj.COLOR_GREY_08);
                var checkBox = utilObj.getScale9Sprite(constantsObj.rounded_4, 90, totalHeight - 125, 0.5, 0.5, 70, 70, spriteArr, mfsLayer.scrollView, zOrder, constantsObj.SPRITE_MISC, mfsLayer.checkBox_tag);
                checkBox.setColor(constantsObj.COLOR_GREY);
                mfsLayer.checkBox_array[i] = checkBox;
                //item1Bg.addChild(checkBox, 0, mfsLayer.checkBox_tag);

                //var tick = utilObj.getSprite(constantsObj.tick, 50, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_5);
                //item1Bg.addChild(tick, 0, mfsLayer.tick_tag);
                var tick = utilObj.getSprite(constantsObj.tick, 90, totalHeight - 125, 0.5, 0.5, constantsObj.SCALE_SPRITE_2, spriteArr, mfsLayer.scrollView, zOrder, constantsObj.SPRITE_MISC, mfsLayer.tick_tag);
                tick.setColor(constantsObj.COLOR_WHITE);
                mfsLayer.tick_array[i] = tick;
                tick.setVisible(false);

                var firstNameText = mfsLayer.getFirstName(mfsLayer.friends[i].name);
                firstNameText = utilObj.formatName(firstNameText);
                /*var lastNameText = mfsLayer.getLastName(mfsLayer.friends[i].name);
                 lastNameText = utilObj.formatName(lastNameText);
                 var name = firstNameText + " " + lastNameText;*/
                var name = firstNameText;
                utilObj.getBMFontLabel(name, constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), namePos + 40, totalHeight - 125, 0, 0.5, labelArr, mfsLayer.scrollView, zOrder + 1);

                //itemWidget.addChild(item1Bg, 0, mfsLayer.col_1_tag);
                i++;
                if (i < mfsLayer.friends.length) {
                    var localXPos = 3 * mfsLayer.listViewWidth / 4 - 10;
                    yPos = itemHeight / 2;

                    var item2Bg = utilObj.getButton(itemWidth, itemHeight, 0.5, 1, localXPos, totalHeight, constantsObj.tile_white, constantsObj.tile_white, constantsObj.tile_white, {
                        obj: 'mfsLayer',
                        fn: 'selectFriend',
                        screen: constantsObj.SCREEN_MFS,
                        params: {fbId: mfsLayer.friends[i].id, clicked: true, index: i},
                    }, false, ccui.Widget.PLIST_TEXTURE, 1);
                    item2Bg.setColor(constantsObj.COLOR_WHITE);
                    mfsLayer.scrollView.addChild(item2Bg, zOrder, mfsLayer.col_2_tag);

                    var pic = "";
                    var picUrl = "";
                    if (!utilObj.isWeb()) {
                        switch (type) {
                            case friendsObj.BATCH_NON_APP_FRIEND:
                                pic = mfsLayer.friends[i].name + ".jpg";
                                picUrl = friendsObj.getNonPlayingFriendPic(mfsLayer.friends[i]);
                                break;
                            case friendsObj.BATCH_APP_FRIEND:
                                pic = mfsLayer.friends[i].id + ".jpg";
                                picUrl = friendsObj.getPlayingFriendPic(mfsLayer.friends[i].id);
                                break;
                        }
                    } else {
                        pic = mfsLayer.friends[i].picture.data.url;
                        picUrl = pic;
                    }
                    //
                    // var profilePic = mfsLayer.getImageSprite(pic, picUrl, cc.p(framePos, yPos));
                    // //item2Bg.addChild(profilePic);
                    // utilObj.addChild(item2Bg, profilePic);

                    if (utilObj.imageExists(pic)) {
                        utilObj.getSprite(picUrl, framePos + mfsLayer.listViewWidth / 2 + 20, totalHeight - 125, 0.5, 0.5, 0.73,
                            spriteArr, mfsLayer.scrollView, zOrder, constantsObj.SPRITE_LOCAL);
                    } else {
                        utilObj.getSprite(constantsObj.profile_pic, framePos + mfsLayer.listViewWidth / 2 + 20, totalHeight - 125, 0.5, 0.5, 0.73, spriteArr, mfsLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
                    }

                    var imageFrame = utilObj.getSprite(constantsObj.image_frame, framePos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_5 * 1.5);
                    imageFrame.setColor(constantsObj.COLOR_WHITE);
                    //item2Bg.addChild(imageFrame);
                    utilObj.addChild(item2Bg, imageFrame);

                    // var checkBox = utilObj.getSprite(constantsObj.rounded_44, 50, yPos, 0.5, 0.5, 1.2);
                    // checkBox.setColor(constantsObj.COLOR_GREY_08);
                    // item2Bg.addChild(checkBox, 0, mfsLayer.checkBox_tag);

                    var checkBox = utilObj.getScale9Sprite(constantsObj.rounded_4, 50 + mfsLayer.listViewWidth / 2 + 20, totalHeight - 125, 0.5, 0.5, 70, 70, spriteArr, mfsLayer.scrollView, zOrder, constantsObj.SPRITE_MISC, mfsLayer.checkBox_tag);
                    checkBox.setColor(constantsObj.COLOR_GREY);
                    mfsLayer.checkBox_array[i] = checkBox;


                    // var tick = utilObj.getSprite(constantsObj.tick, 50, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_5);
                    // item2Bg.addChild(tick, 0, mfsLayer.tick_tag);
                    // tick.setColor(constantsObj.COLOR_WHITE);
                    // tick.setVisible(false);

                    var tick = utilObj.getSprite(constantsObj.tick, 50 + mfsLayer.listViewWidth / 2 + 20, totalHeight - 125, 0.5, 0.5, constantsObj.SCALE_SPRITE_2, spriteArr, mfsLayer.scrollView, zOrder, constantsObj.SPRITE_MISC, mfsLayer.tick_tag);
                    tick.setColor(constantsObj.COLOR_WHITE);
                    tick.setVisible(false);
                    mfsLayer.tick_array[i] = tick;

                    var firstNameText = mfsLayer.getFirstName(mfsLayer.friends[i].name);
                    firstNameText = utilObj.formatName(firstNameText);
                    /*var lastNameText = mfsLayer.getLastName(mfsLayer.friends[i].name);
                     lastNameText = utilObj.formatName(lastNameText);
                     var name = firstNameText + " " + lastNameText;*/
                    var name = firstNameText;
                    utilObj.getBMFontLabel(name, constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_BLACK,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), namePos + mfsLayer.listViewWidth / 2 + 20, totalHeight - 125, 0, 0.5, labelArr, mfsLayer.scrollView, zOrder + 1);

                    //itemWidget.addChild(item2Bg, 0, mfsLayer.col_2_tag);
                }

                totalHeight -= 280;
                //itemWidget.setColor(constantsObj.COLOR_GREY_09);
                //mfsLayer.listView.addChild(itemWidget);
                //utilObj.addChild(mfsLayer.listView, itemWidget);
            }
            mfsLayer.selectAll(mfsLayer, {});
        } else {
            // var itemWidget = new ccui.Widget();
            //itemWidget.setContentSize(cc.size(mfsLayer.listViewWidth, itemHeight * 1.5));
            var localXPos = mfsLayer.listViewWidth / 2;
            var localYPos = mfsLayer.listViewHeight;
            yPos = itemHeight / 2;
            mfsLayer.scrollView.setTouchEnabled(false);
            if (totalFriends > 0) {
                localYPos = scrollHeight;
            }
            //itemWidget.setAnchorPoint(0.5, 0.5);
            utilObj.getBMFontLabel(stringsObj.unable_to_send_message, constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos, localYPos - 100, 0.5, 1, labelArr, mfsLayer.scrollView, zOrder + 1);
            yPos -= 70;
            utilObj.getBMFontLabel(stringsObj.please_try_later, constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos, localYPos - 170, 0.5, 1, labelArr, mfsLayer.scrollView, zOrder + 1);
            //mfsLayer.listView.addChild(itemWidget);
            //utilObj.addChild(mfsLayer.listView, itemWidget);

            if (mfsLayer) {
                var tick = mfsLayer.getChildByTag(mfsLayer.tick_tag);
                var checkBox = mfsLayer.getChildByTag(mfsLayer.checkBox_tag);
                if (tick) {
                    tick.setVisible(false);
                    checkBox.setColor(constantsObj.COLOR_GREY_08);
                }
            }
            //itemWidget.setColor(constantsObj.COLOR_GREY_09);
        }

        utilObj.addLabels(labelArr);
        utilObj.addSprites(spriteArr);
        //mfsLayer.listView.setColor(constantsObj.COLOR_GREY_09);
        //mfsLayer.uiNode.addChild(mfsLayer.listView, zOrder + 2);
        mfsLayer.addChild(mfsLayer.scrollView, zOrder + 1);
    },


    getImageSprite: function (pic, url, pos) {
        var imgSprite = utilObj.loadImage(pic, url, pos.x, pos.y, 0.5, 0.5, 0.73);
        return imgSprite;
    },

    getFirstName: function (name) {
        var firstNameText = "";
        var indexOfSpace = name.indexOf(" ");
        if (indexOfSpace > -1 && indexOfSpace < 12) {
            firstNameText = name.slice(0, indexOfSpace);
        } else {
            firstNameText = name.slice(0, 10) + "..";
        }
        return firstNameText;
    },

    getLastName: function (name) {
        var lastNameText = "";
        var indexOfSpace = name.indexOf(" ");
        if (indexOfSpace > -1 && indexOfSpace + 11 >= name.length - 1) {
            lastNameText = name.slice(indexOfSpace + 1, name.length);
        } else {
            lastNameText = name.slice(indexOfSpace + 1, indexOfSpace + 11) + "..";
        }
        return lastNameText;
    },

    selectFriend: function (params) {
        if (params.index < mfsLayer.checkBox_array.length) {
            var checkBox = mfsLayer.checkBox_array[params.index];
            var tick = mfsLayer.tick_array[params.index];

            if (tick) {
                if (params.vis != undefined && params.vis != null) {
                    //utilObj.setVisible(tick, params.vis);
                    tick.setVisible(params.vis);
                } else {
                    var vis = !tick.isVisible();
                    //utilObj.setVisible(tick, vis);
                    tick.setVisible(vis);
                }
                if (tick.isVisible()) {
                    if (params.fbId) {
                        mfsLayer.selectedFriends.push(params.fbId);
                    }
                    checkBox.setColor(constantsObj.COLOR_BLUE_08);


                } else {
                    checkBox.setColor(constantsObj.COLOR_GREY_08);

                    var fbIndex = mfsLayer.selectedFriends.indexOf(params.fbId);
                    if (fbIndex > -1) {
                        mfsLayer.selectedFriends.splice(fbIndex, 1);
                    }
                }
            }
        }
        if (params.clicked) {
            mfsLayer.checkOrUncheckSelectAll();
        }
    },

    checkOrUncheckSelectAll: function () {
        if (mfsLayer) {
            var checkBox = mfsLayer.getChildByTag(mfsLayer.checkBox_tag);
            var tick = mfsLayer.getChildByTag(mfsLayer.tick_tag);
            if (tick) {
                var vis = (mfsLayer.selectedFriends.length == mfsLayer.friends.length) ? true : false;
                tick.setVisible(vis);
            }
            if (tick.isVisible()) {
                checkBox.setColor(constantsObj.COLOR_MFS_CHECKBOX);
            } else {
                checkBox.setColor(constantsObj.COLOR_GREY);
            }
        }
    },

    selectAll: function (params) {
        var vis = false;
        if (mfsLayer.friends.length == 0) {
            return;
        }
        if (mfsLayer) {
            var checkBox = mfsLayer.getChildByTag(mfsLayer.checkBox_tag);
            var tick = mfsLayer.getChildByTag(mfsLayer.tick_tag);
            if (utilObj.isNodeValid(tick)) {
                if (params.clicked) {
                    vis = !tick.isVisible();
                } else {
                    vis = true;
                }
                tick.setVisible(vis);
            }
            if (utilObj.isNodeValid(tick) && utilObj.isNodeValid(checkBox)) {
                if (tick.isVisible()) {
                    checkBox.setColor(constantsObj.COLOR_BLUE_08);
                } else {
                    checkBox.setColor(constantsObj.COLOR_GREY_08);
                }
            }
        }

        // var allFriends = mfsLayer.listView.getChildren();
        // for (var i in allFriends) {
        //     var widgetRow = allFriends[i];
        //     if(utilObj.isNodeValid(widgetRow)) {
        //         var friend1 = widgetRow.getChildByTag(mfsLayer.col_1_tag);
        //         if (utilObj.isNodeValid(friend1)) {
        //             mfsLayer.selectFriend({vis: vis, sender: friend1});
        //         }
        //         var friend2 = widgetRow.getChildByTag(mfsLayer.col_2_tag);
        //         if (utilObj.isNodeValid(friend2)) {
        //             mfsLayer.selectFriend({vis: vis, sender: friend2});
        //         }
        //     }
        // }
        if (mfsLayer.scrollView != null) {
            for (var i = 0; i < mfsLayer.checkBox_array.length; i++) {
                mfsLayer.selectFriend({vis: vis, index: i});
                i++;
                if (i < mfsLayer.checkBox_array.length) {
                    mfsLayer.selectFriend({vis: vis, index: i});
                }
            }
        }

        mfsLayer.selectedFriends = [];
        if (vis) {
            for (var i = 0; i < mfsLayer.friends.length; i++) {
                mfsLayer.selectedFriends.push(mfsLayer.friends[i].id);
            }
        }
    },

    sendRequests: function (params) {
        var type = params.reqType;
        var inviteThroughCreature = false;
        gameObj.setRequestCountUpdated(false);
        if (mfsLayer.curType == friendsObj.BATCH_NON_APP_FRIEND) {
            if (type == constantsObj.CREATURE_COINS || type == constantsObj.CREATURE_SPINS) {
                inviteThroughCreature = true;
            }
            type = constantsObj.INVITE;
            friendsObj.setBatchTypeInvitableFriends();
        } else {
            friendsObj.setBatchTypePlayingFriends();
        }
        if (mfsLayer.selectedFriends.length > 0) {
            friendsObj.populateSendingIds(mfsLayer.selectedFriends);
            var fbIds = mfsLayer.selectedFriends.join(",");
            var screenName = utilObj.getScreenName(mfsLayer.parentScreen);
            if (mfsLayer.parentScreen == constantsObj.SCREEN_MESSAGE_CENTER) {
                if (msgCenterPopup.getAllMessages().length > 0) {
                    screenName = "msgs";
                } else {
                    screenName = "no_msg";
                }
            } else if (screenName == constantsObj.SCREEN_INVITE_AND_WIN) {
                screenName = "fb_invite";
            }
            if (type == constantsObj.CREATURE_COINS || type == constantsObj.CREATURE_SPINS || inviteThroughCreature) {
                screenName = constantsObj.TRACK_CREATURE;
            }
            if (mfsLayer.sendTrackOrder) {
                screenName = mfsLayer.sendTrackOrder;
            }
            switch (type) {
                case constantsObj.CREATURE_COINS:
                    fbRequestObj.sendCoins(fbIds, stringsObj.req_send_coins_desc, "gift_coins", screenName, "");
                    break;
                case constantsObj.CREATURE_SPINS:
                    fbRequestObj.sendSpins(fbIds, stringsObj.req_send_spins_desc, "gift_spins", screenName, "");
                    break;
                case constantsObj.INVITE:
                    fbRequestObj.inviteFriends(stringsObj.invite_friends, fbIds, "invite", screenName, "");
                    gameObj.setTriggerAlienRequest(true);
                    if (gameObj.getCreatureRequestActiveTimeStamp() == 0) {
                        gameObj.setCreatureRequestActiveTimeStamp(utilObj.getCurrentTimestamp());
                    } else if ((utilObj.getCurrentTimestamp() - gameObj.getCreatureRequestActiveTimeStamp()) > 30 * 24 * 3600) {
                        gameObj.setCreatureRequestActiveTimeStamp(0);
                        gameObj.setTotalCreatureCoinRequestThisMonth(0);
                        gameObj.setTotalCreatureSpinRequestThisMonth(0);
                    }
                    break;
                case constantsObj.ASK_COINS:
                    fbRequestObj.askCoins(fbIds, stringsObj.req_ask_coins_desc, "ask_coins", screenName, "");
                    gameObj.setTriggerAlienRequest(true);
                    if (gameObj.getCreatureRequestActiveTimeStamp() == 0) {
                        gameObj.setCreatureRequestActiveTimeStamp(utilObj.getCurrentTimestamp());
                    } else if ((utilObj.getCurrentTimestamp() - gameObj.getCreatureRequestActiveTimeStamp()) > 30 * 24 * 3600) {
                        gameObj.setCreatureRequestActiveTimeStamp(0);
                        gameObj.setTotalCreatureCoinRequestThisMonth(0);
                        gameObj.setTotalCreatureSpinRequestThisMonth(0);
                    }
                    break;
                case constantsObj.SEND_COINS:
                    fbRequestObj.sendCoins(fbIds, stringsObj.req_send_coins_desc, "gift_coins", screenName, "");
                    break;
                case constantsObj.ASK_SPINS:
                    fbRequestObj.askSpins(fbIds, stringsObj.req_ask_spins_desc, "ask_spins", screenName, "");
                    gameObj.setTriggerAlienRequest(true);
                    if (gameObj.getCreatureRequestActiveTimeStamp() == 0) {
                        gameObj.setCreatureRequestActiveTimeStamp(utilObj.getCurrentTimestamp());
                    } else if ((utilObj.getCurrentTimestamp() - gameObj.getCreatureRequestActiveTimeStamp()) > 30 * 24 * 3600) {
                        gameObj.setCreatureRequestActiveTimeStamp(0);
                        gameObj.setTotalCreatureCoinRequestThisMonth(0);
                        gameObj.setTotalCreatureSpinRequestThisMonth(0);
                    }
                    break;
                case constantsObj.SEND_SPINS:
                    fbRequestObj.sendSpins(fbIds, stringsObj.req_send_spins_desc, "gift_spins", screenName, "");
                    break;
                case constantsObj.ASK_LIVES:
                    fbRequestObj.askLives(fbIds, stringsObj.req_ask_lives_desc, "ask_lives", screenName, "");
                    break;
                case constantsObj.SEND_LIVES:
                    fbRequestObj.sendLives(fbIds, stringsObj.req_send_lives_desc, "gift_lives", screenName, "");
                    break;
                case constantsObj.ASK_MOVES:
                    fbRequestObj.askMoves(fbIds, stringsObj.req_ask_moves_desc, "ask_moves", screenName, "");
                    break;
                case constantsObj.SEND_MOVES:
                    fbRequestObj.sendMoves(fbIds, stringsObj.req_send_moves_desc, "gift_moves", screenName, "");
                    break;
            }
        } else {
            utilObj.showMessage(stringsObj.no_selected_friends);
        }
    },

    getJungleFriends: function () {
        if (mfsLayer.shownJungleFriends && mfsLayer.friendsJungle != []) {
            return mfsLayer.friendsJungle;
        }

        mfsLayer.shownJungleFriends = true;
        mfsLayer.friendsJungle = friendsObj.getNextPlayingBatch(false, fbRequestObj.getReqSendLimit(), mfsLayer.reqType);
        return mfsLayer.friendsJungle;
    },


    getAllFriends: function () {
        if (mfsLayer.shownAllFriends && mfsLayer.friendsAll != []) {
            return mfsLayer.friendsAll;
        }

        mfsLayer.shownAllFriends = true;
        mfsLayer.friendsAll = friendsObj.getNextInvitableBatch(false, fbRequestObj.getReqSendLimit(), mfsLayer.reqType);
        return mfsLayer.friendsAll;
    },

    close: function () {
        // loggerObj.debugLog("Closing MFS:", mfsLayer.parentScreen, mfsLayer.parentCb);
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), "mfs", constantsObj.TRACK_CLOSE, "", gameObj.getPuzzleSpeciesTracking(), "", "");
        mfsLayer.curType = -1;
        var cb = mfsLayer.parentCb;
        mfsLayer.parentCb = null;

        /*if (mfsLayer.parentScreen == constantsObj.SCREEN_INVITE_SUCCESS
         || mfsLayer.parentScreen == constantsObj.SCREEN_DAILY_REWARD_COLLECT
         || mfsLayer.parentScreen == constantsObj.SCREEN_INVITE_AND_WIN || mfsLayer.parentScreen == constantsObj.SCREEN_LEVEL_MAP) {
         } else if (mfsLayer.parentScreen == constantsObj.SCREEN_MOVES_AUTOPOP) {
         levelIntroLayer.show();
         } else {
         if (mfsLayer.parentPopup) {
         mfsLayer.parentPopup.show(true, cb);
         } else if (mfsLayer.parentScreen == constantsObj.SCREEN_LEVEL_INTRO) {
         levelIntroLayer.show();
         } else if (mfsLayer.parentScreen == constantsObj.SCREEN_LEVEL_OUTRO) {
         if (cb != null) {
         cb();
         }
         }
         }*/
        var screen = mfsLayer.parentScreen;
        if (screen == constantsObj.SCREEN_MESSAGE_CENTER) {
            homeLayer.show();
        } else if (screen == constantsObj.SCREEN_INVITE_OTHERS) {
            var lastCb = inviteOthersPopup.getLastCb();
            inviteOthersPopup.show(true, lastCb);
        } else if (screen == constantsObj.SCREEN_FREE_COINS_2) {
            freeCoins2Popup.close();
            storeLayer.show();
        } else if (screen == constantsObj.SCREEN_HOME) {
            homeLayer.show();
        } else if (screen == constantsObj.SCREEN_GAME) {
            if (gameObj.checkForMiniOrMidi(gameLayer.crosswordDate)) {
                gameLayer.show(gameLayer.crosswordDate, true);
            } else {
                gameLayer.show(gameLayer.crosswordDate);
            }
        } else if (screen == constantsObj.SCREEN_CALENDAR) {
            calendarLayer.show();
        } else if (screen == constantsObj.SCREEN_ACHIEVEMENTS) {
            if (ProfileExp == constantsObj.EXP_VAR_1) {
                achievementsLayer.show(gameObj.getShowStat());
            } else {
                achievementsLayer.show();
            }
        } else if (screen == constantsObj.SCREEN_PACK_LAYER) {
            packsLayer.show();
        } else if (screen == constantsObj.SCREEN_FREE_COINS) {
            var lastCb = freeCoinsPopup.getLastCb();
            freeCoinsPopup.show(true, lastCb, mfsLayer.parentLayer);
        } else if (mfsLayer.parentPopup) {
            mfsLayer.parentPopup.show();
        }
    },

    resetFriendsList: function (batchType) {
        if (batchType == friendsObj.BATCH_APP_FRIEND) {
            mfsLayer.shownJungleFriends = false;
        } else if (batchType == friendsObj.BATCH_NON_APP_FRIEND) {
            mfsLayer.shownAllFriends = false;
        }
    },

    getRequestType: function () {
        return mfsLayer.reqType;
    },

    wasEligibleForMovesPopup: false,
    checkAndSetMovesPopupEligibility: function () {
        if (mfsLayer.wasEligibleForMovesPopup) {
            return mfsLayer.wasEligibleForMovesPopup;
        }

        var puzCompleted = gameObj.getPuzCompleted();
        var minLevel = runtimeObj.getMinLevelForMovesPopup();
        var secCurVariant = epmObj.getChosenVariant(constantsObj.EXP_SECONDARY_CURRENCY);
        var loggedIn = fbWrapperObj.isLoggedIn();
        if (!loggedIn
            || secCurVariant != constantsObj.EXP_VAR_2
            || puzCompleted < minLevel) {
            mfsLayer.wasEligibleForMovesPopup = false;
            // loggerObj.debugLog("Moves autopop: Not eligible", loggedIn, secCurVariant, puzCompleted, minLevel);
            return mfsLayer.wasEligibleForMovesPopup;
        }

        var successesToday = gameObj.getLevelSuccessesToday();
        var repeatAfter = runtimeObj.getMovesPopupAfter();
        // loggerObj.debugLog("Moves autopop:", successesToday, repeatAfter, successesToday % repeatAfter);
        if (successesToday % repeatAfter == 1) {
            // Since this is to be shown after 1st success, and then after specified repeat interval.
            mfsLayer.wasEligibleForMovesPopup = true;
        }

        return mfsLayer.wasEligibleForMovesPopup;
    },

    checkAndShowMovesPopup: function () {
        var canShow = mfsLayer.checkAndSetMovesPopupEligibility();
        if (canShow) {
            mfsLayer.wasEligibleForMovesPopup = false;
            mfsLayer.show(constantsObj.SEND_MOVES, constantsObj.SCREEN_MOVES_AUTOPOP);
            return true;
        }
        return false;
    },

    back: function () {
        utilObj.popCurScreen();
        mfsLayer.hide();
        mfsLayer.close();
    },

    hide: function () {
        mfsLayer.isRedraw = false;
        mfsLayer.removeAllChildren();
        mfsLayer.setVisible(false);
    },

    redraw: function () {
        // loggerObj.debugLog("lelouch , mfs layer is redrawn in mfs.js");
        mfsLayer.hide();
        mfsLayer.isRedraw = true;
        mfsLayer.show(mfsLayer.popupType, mfsLayer.lastPopupScreen, mfsLayer.lastPopup, mfsLayer.parentCb);
    },

    checkAndShow: function (type, lastPopScreen, lastPop, cb, sendTrackOrder, pL) {
        // loggerObj.debugLog("HERE at popupscreen 1");
        // loggerObj.debugLog("lelouch , mfs layer is checkedandshown in mfs.js");
        if (fbWrapperObj.isLoggedIn()) {
            if (lastPopScreen == constantsObj.SCREEN_HOME) {
                // loggerObj.debugLog("HERE at popupscreen 2");
                homeLayer.hide();
            }
            if (lastPopScreen == constantsObj.SCREEN_ACHIEVEMENTS) {
                // loggerObj.debugLog("HERE at popupscreen 3");
                achievementsLayer.hide();
            }
            if (lastPopScreen == constantsObj.SCREEN_CALENDAR) {
                // loggerObj.debugLog("HERE at popupscreen 4");
                calendarLayer.hide();
            }
            if (lastPopScreen == constantsObj.SCREEN_GAME) {
                // loggerObj.debugLog("HERE at popupscreen 5");
                gameLayer.hide();
            }
            if (lastPopScreen == constantsObj.SCREEN_PACK_LAYER) {
                // loggerObj.debugLog("HERE at popupscreen 6");
                packsLayer.hide();
            }
            if (lastPopScreen == constantsObj.SCREEN_STORE || lastPopScreen == constantsObj.SCREEN_FREE_COINS_2) {
                // loggerObj.debugLog("HERE at popupscreen 7");
                storeLayer.hide();
            }

            mfsLayer.show(type, lastPopScreen, lastPop, cb, sendTrackOrder, pL);
        } else {
            // loggerObj.debugLog("HERE at popupscreen 8");
            fbConnectPopup.show(true, cb);
        }
    }
});