var OutOfCoinsLayer = cc.Layer.extend({
    screen: null,
    cashLbl: null,
    isRedraw: false,
    bottomBar: null,
    parentScreen: null,

    show: function () {
        outOfCoinsLayer.screen = constantsObj.SCREEN_OUT_OF_COINS;
        var screen = outOfCoinsLayer.screen;

        var spriteArr = [];
        var labelArr = [];
        var zOrder = constantsObj.UI_Z_ORDER;

        var xPos = centerXPos;
        var yPos = constantsObj.DESIGN_HEIGHT;

        var parentScreen = curScreen;
        // loggerObj.debugLog("curscreen is ", utilObj.getScreenName(parentScreen));
        outOfCoinsLayer.parentScreen = curScreen;

        utilObj.updateScreenBegin(outOfCoinsLayer.screen);


        utilObj.hideBannerAd(utilObj.getScreenName(outOfCoinsLayer.screen));

        var background = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos, 0.5, 1, canvasWidth, constantsObj.DESIGN_HEIGHT);
        background.setColor(constantsObj.COLOR_WHITE);
        //outOfCoinsLayer.addChild(background, zOrder);
        utilObj.addChild(outOfCoinsLayer, background, zOrder);

        var tab = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos, 0.5, 1, canvasWidth, 350, spriteArr, outOfCoinsLayer, zOrder, constantsObj.SPRITE_MISC);
        tab.setColor(constantsObj.COLOR_TOP_BAR);

        // header starts here
        yPos -= 175;

        utilObj.getSprite(constantsObj.close_icon, xLeftPos + 105, yPos + 80, 0.5, 0.5, constantsObj.SCALE_SPRITE_3, spriteArr, outOfCoinsLayer, zOrder, constantsObj.SPRITE_MISC);
        var backButton = utilObj.getButton(200, 200, 0, 0.5, xLeftPos + 105, yPos + 80,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'outOfCoinsLayer',
                fn: 'back',
                screen: outOfCoinsLayer.screen,
                params: {sound: false},
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_OUT_OF_COINS,
                    f: constantsObj.TRACK_BACK,
                    g: "",
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        //outOfCoinsLayer.addChild(backButton, zOrder);
        utilObj.addChild(outOfCoinsLayer, backButton, zOrder);

        utilObj.getBMFontLabel("Out of Coins?", constantsObj.FONT_ROBOTO_REGULAR_120, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos + 10, 0.5, 0.5, labelArr, outOfCoinsLayer, zOrder + 1);

        xPos = xRightPos - 270;

        var coinBg = utilObj.getScale9Sprite(constantsObj.coin_number_bg, xPos, yPos, 0, 0.5, 240, 80, spriteArr,
            outOfCoinsLayer, zOrder + 1, constantsObj.SPRITE_MISC);
        coinBg.setOpacity(constantsObj.OPACITY_10);
        utilObj.getSprite(constantsObj.coin_png_2, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, outOfCoinsLayer, zOrder + 1, constantsObj.SPRITE_MISC);
        var coinCount = economyObj.getCash();
        outOfCoinsLayer.cashLbl = utilObj.getBMFontLabel(coinCount + "", constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 130, yPos, 0.5, 0.5, labelArr, outOfCoinsLayer, zOrder + 1);

        yPos -= 175;

        yPos -= 115;


        var imageBgLength = canvasWidth / (1.29);

        var imageBg = utilObj.getScale9Sprite(constantsObj.rounded_4, centerXPos, yPos, 0.5, 1, imageBgLength, 986);
        imageBg.setColor(constantsObj.COLOR_LIGHT_GREY_01);
        //outOfCoinsLayer.addChild(imageBg, zOrder);
        utilObj.addChild(outOfCoinsLayer, imageBg, zOrder);

        var coins_stack = utilObj.getSprite(constantsObj.coin_stack, imageBgLength / 2, 986 / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_20, null, imageBg, zOrder, constantsObj.SPRITE_MISC);
        //imageBg.addChild(coins_stack, zOrder);
        utilObj.addChild(imageBg, coins_stack, zOrder);

        yPos -= (1200);

        var text = stringsObj.high_level_store_text;

        var textLabel = utilObj.getBMFontLabel(text, constantsObj.FONT_ROBOTO_REGULAR_90, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, yPos - 100, 0.5, 0.5);
        //outOfCoinsLayer.addChild(textLabel, zOrder + 1);
        utilObj.addChild(outOfCoinsLayer, textLabel, zOrder + 1);


        outOfCoinsLayer.bottomBar = utilObj.getScale9Sprite(constantsObj.tile_white, canvasWidth / 2, 0, 0.5, 0, canvasWidth, 470, null, outOfCoinsLayer, zOrder + 1, constantsObj.SPRITE_MISC);
        outOfCoinsLayer.bottomBar.setColor(constantsObj.COLOR_TOP_BAR);
        //outOfCoinsLayer.addChild(outOfCoinsLayer.bottomBar, constantsObj.UI_Z_ORDER + 1);
        utilObj.addChild(outOfCoinsLayer, outOfCoinsLayer.bottomBar, constantsObj.UI_Z_ORDER + 1);

        outOfCoinsLayer.addBottomBarOptions();

        if (gameObj.getIsRedraw()) {
            gameObj.setIsRedraw(false);
        }


        utilObj.updateScreen(outOfCoinsLayer.screen, outOfCoinsLayer);

        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);

    },

    addBottomBarOptions: function () {
        var screen = outOfCoinsLayer.screen;
        var btnWidth = (canvasWidth - canvasWidth / 10);
        outOfCoinsLayer.buttonWidth = btnWidth;
        var btnHeight = 250;
        var xPos = canvasWidth / 2;
        var zOrder = constantsObj.UI_Z_ORDER;
        var yShift = 45;


        var parentScreen = outOfCoinsLayer.parentScreen;
        var parentScreenName = utilObj.getScreenName(outOfCoinsLayer.screen);
        if (outOfCoinsLayer.parentScreen != null) {
            parentScreenName = utilObj.getScreenName(parentScreen);
        }

        var earnButton = utilObj.getButton(btnWidth, btnHeight, 0.5, 0.5, xPos, btnHeight / 2 + yShift + 30,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'outOfCoinsLayer',
                fn: 'earnFree',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_OUT_OF_COINS,
                    f: constantsObj.TRACK_FREE,
                    g: parentScreenName,
                    s: "",
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        //outOfCoinsLayer.addChild(earnButton, zOrder + 1);
        utilObj.addChild(outOfCoinsLayer, earnButton, zOrder + 1);
        earnButton.setColor(constantsObj.COLOR_BUTTON_LIGHT_BLUE);
        outOfCoinsLayer.earnFreeButton = earnButton;

        var cashIcon = utilObj.getSprite(constantsObj.coin_one, btnWidth / 2 + 250, btnHeight / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_18);
        //earnButton.addChild(cashIcon, zOrder + 1);
        utilObj.addChild(earnButton, cashIcon, zOrder + 1);

        var earnLabel = utilObj.getBMFontLabel("FREE Coins", constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), btnWidth / 2 - 50, btnHeight / 2, 0.5, 0.5, null, earnButton, zOrder + 1);
        //earnButton.addChild(earnLabel, zOrder + 1);
        utilObj.addChild(earnButton, earnLabel, zOrder + 1);


    },

    hide: function () {
        sc = utilObj.popCurScreen();
        outOfCoinsLayer.removeAllChildren();
        outOfCoinsLayer.setVisible(false);
    },

    back: function () {
        outOfCoinsLayer.hide();
        //var sc = utilObj.popCurScreen();
        storeLayer.show();
    },

    earnFree: function () {
        var screen = utilObj.getScreenName(curScreen);
        if (adsObj.hasOfferWall()) {
            adsObj.showOfferWall();
            return;
        }
        freeCoinsPopup.show(true, null, constantsObj.SCREEN_OUT_OF_COINS);
    },


});

