var PackInfoLayer = cc.Layer.extend({
    screen: null,
    header: null,
    cashLbl: null,
    sections: null,
    masteryLbl: null,
    index: null,
    alreadyCompleted: false,
    highLighted: false,
    selectedPackId: null,
    achivementReminderVisible: false,
    transBg: null,
    showFeedback: false,
    britPack: 0,

    show: function (index, alreadyCompleted, packType) {
        var spriteArr = [];
        var labelArr = [];
        var zOrder = constantsObj.UI_Z_ORDER;

        var xPos = centerXPos;
        var yPos = constantsObj.DESIGN_HEIGHT;

        if (index == undefined) {
            index = 1;
        }
        packInfoLayer.britPack = constantsObj.NORMAL_PACKS;
        if (packType != undefined && packType == constantsObj.BRITISH_PACKS && index < constantsObj.NUM_BRIT_PACKS) {
            packInfoLayer.britPack = packType;
        }

        packInfoLayer.selectedPackId = index;
        gameLayer.index = index;

        if (alreadyCompleted != undefined) {
            packInfoLayer.alreadyCompleted = alreadyCompleted;
            packInfoLayer.showFeedback = true;
        } else {
            packInfoLayer.showFeedback = false;
        }

        achievementsObj.checkForAchievements();

        gameObj.segregatePuzzlesForPack();
        packInfoLayer.screen = constantsObj.SCREEN_PACK_INFO_LAYER;
        var screenName = utilObj.getScreenName(packInfoLayer.screen);
        utilObj.updateScreenBegin(packInfoLayer.screen);
        adWallObj.setAdWallLastScreen(constantsObj.SCREEN_PACK_INFO_LAYER);
        var screen = packInfoLayer.screen;

        var background = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos, 0.5, 1, canvasWidth, constantsObj.DESIGN_HEIGHT);
        utilObj.addChild(packInfoLayer, background, zOrder - 1);

        var fontColor = constantsObj.COLOR_BLACK;

        if (homeLayoutExpNew == constantsObj.EXP_VAR_CONTROL) {
            var bannerbg = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos + topBarOffset, 0.5, 1, canvasWidth, 226 + topBarOffset);
            bannerbg.setColor(constantsObj.COLOR_TOP_BAR);

            if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                bannerbg.setColor(constantsObj.COLOR_WHITE);
            }

            utilObj.addChild(packInfoLayer, bannerbg, zOrder);

            if (utilObj.isIos()) {
                var adBanner = constantsObj.ad_banner_place_holder;
                packInfoLayer.header = utilObj.getSprite(adBanner, centerXPos, yPos - 50, 0.5, 1, constantsObj.SCALE_SPRITE_6 * 3 / 2, spriteArr, packInfoLayer, zOrder, constantsObj.SPRITE_MISC);
            } else {
                var adBanner = constantsObj.header_logo;
                packInfoLayer.header = utilObj.getSprite(adBanner, centerXPos - 330 * canvasWidth / 1440, yPos - 50 + topBarOffset / 2, 0.5, 1, constantsObj.SCALE_SPRITE_10 * 3 / 2, spriteArr, packInfoLayer, zOrder, constantsObj.SPRITE_MISC);
            }
        } else {
            // banner image on top
            var banner = utilObj.getSprite(constantsObj.banner_bg, centerXPos, yPos - 226, 0.5, 0, constantsObj.SCALE_ONE * 2, spriteArr, packInfoLayer, zOrder, constantsObj.SPRITE_LOCAL);
            utilObj.addChild(packInfoLayer, banner, zOrder);

            // game title text
            var dtcText = utilObj.getBMFontLabel(stringsObj.DTC_full_form_caps, constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, yPos - 196, 0.5, 0, labelArr, packInfoLayer, zOrder + 1);
            utilObj.setOpacity(dtcText, constantsObj.OPACITY_40);
            utilObj.addChild(packInfoLayer, dtcText, zOrder + 1);
            //
        }
        //packInfoLayer.addChild(packInfoLayer.header, zOrder);
        utilObj.addChild(packInfoLayer, packInfoLayer.header, zOrder);

//Header 2
        yPos -= 226;
        var localYPos = yPos - 70;
        var tab = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos, 0.5, 1, canvasWidth, 140, spriteArr, packInfoLayer, zOrder, constantsObj.SPRITE_MISC);
        tab.setColor(constantsObj.COLOR_TOP_BAR);

        utilObj.addChild(packInfoLayer, tab, zOrder);

        var textColor = constantsObj.COLOR_WHITE;
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            textColor = constantsObj.COLOR_BLACK;
            tab.setColor(constantsObj.COLOR_WHITE);
        }
        var xShift = 120;
        var childArr = [];

        var backArrow = utilObj.getSprite(constantsObj.arrow_01, xLeftPos + 50, localYPos, 0, 0.5, constantsObj.SCALE_SPRITE_7, spriteArr, packInfoLayer, zOrder, constantsObj.SPRITE_MISC);
        backArrow.setColor(textColor);
        //packInfoLayer.addChild(backArrow, zOrder);
        utilObj.addChild(packInfoLayer, backArrow, zOrder);
        childArr = [backArrow];
        var backButton = utilObj.getButton(160, 250, 0, 0.5, xLeftPos, yPos,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'packInfoLayer',
                fn: 'back',
                screen: packInfoLayer.screen,
                params: {sound: false},
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_PACK_INFO,
                    f: constantsObj.TRACK_BACK,
                    g: "",
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
                child: childArr,
                feedBackType: constantsObj.ZOOMIN_FEEDBACK
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(packInfoLayer, backButton, zOrder);
//}

        xPos = xRightPos - 30;

        var msg = utilObj.getSprite(constantsObj.setting_icon, xRightPos - 70, localYPos, 1, 0.5, constantsObj.SCALE_SPRITE_14 * 1.5, spriteArr, packInfoLayer, zOrder, constantsObj.SPRITE_MISC);
        msg.setColor(textColor);
        utilObj.addChild(packInfoLayer, msg, zOrder);

        var settingsButton = utilObj.getButton(123, 200, 1, 0.5, xRightPos - 50, localYPos,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'packInfoLayer',
                fn: 'settings',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_PACK_INFO,
                    f: constantsObj.TRACK_SETTINGS,
                    g: screen,
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE);
        //packInfoLayer.addChild(settingsButton, zOrder + 1);
        utilObj.addChild(packInfoLayer, settingsButton, zOrder + 1);


        var xShiftTemp = 200;
        var coinBg = utilObj.getScale9Sprite(constantsObj.tile_white_curved, xPos - (350 + xShiftTemp), localYPos, 0, 0.5, 320, 80, spriteArr,
            packInfoLayer, zOrder, constantsObj.SPRITE_MISC);
        // coinBg.setOpacity(constantsObj.OPACITY_10);
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            coinBg.setColor(constantsObj.COLOR_GREY);
        } else {
            coinBg.setOpacity(constantsObj.OPACITY_10);
        }

        utilObj.addChild(packInfoLayer, coinBg, zOrder);

        var coin = utilObj.getSprite(constantsObj.coin_png_2, xPos - (350 + xShiftTemp), localYPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, packInfoLayer, zOrder, constantsObj.SPRITE_MISC);

        utilObj.addChild(packInfoLayer, coin, zOrder);
        var coinCount = economyObj.getCash();
        packInfoLayer.cashLbl = utilObj.getBMFontLabel(coinCount + "", constantsObj.FONT_ROBOTO_REGULAR_60, textColor,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - (210 + xShiftTemp), localYPos, 0.5, 0.5, labelArr, packInfoLayer, zOrder);

        utilObj.addChild(packInfoLayer, packInfoLayer.cashLbl, zOrder);

        var greenPlus = utilObj.getSprite(constantsObj.green_plus, xPos - (100 + xShiftTemp), localYPos, 0, 0.5, constantsObj.SCALE_SPRITE_1, spriteArr, packInfoLayer, zOrder, constantsObj.SPRITE_MISC);

        utilObj.addChild(packInfoLayer, greenPlus, zOrder);

        childArr = [coin, greenPlus];
        var buttonAtCoins = utilObj.getButton(450, 180, 0, 0.5, xPos - (420 + xShiftTemp), localYPos,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'packInfoLayer',
                fn: 'showStore',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_PACK_INFO,
                    f: constantsObj.TRACK_STORE,
                    g: "",
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
                child: childArr,
                feedBackType: constantsObj.ZOOMIN_FEEDBACK
            }, false, ccui.Widget.PLIST_TEXTURE, 1);

        utilObj.addChild(packInfoLayer, buttonAtCoins, zOrder);

        if (!gameObj.getIsWeeklyQuestLocked()) {
            weeklyQuestObj.updateCash(packInfoLayer, packInfoLayer.cashLbl);
        }

        var starCount = gameObj.getMastery1();

        xPos = xLeftPos + 100;

        var xPosShift1 = 0;
        var xWidth = 0;
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            xPosShift1 = 10;
            xWidth = 100;
        }
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            var starBg = utilObj.getScale9Sprite(constantsObj.tile_white_curved, xPos + 210, yPos - 70, 0, 0.5, 250 + xWidth, 80, null,
                packInfoLayer, zOrder, constantsObj.SPRITE_MISC);
            starBg.setColor(constantsObj.COLOR_GREY);
            utilObj.addChild(packInfoLayer, starBg, zOrder);
        }

        var star = utilObj.getSprite(constantsObj.star_white_2, xPos + 160 + xPosShift1, yPos - 65, 0, 0.5, constantsObj.SCALE_SPRITE_1, spriteArr, packInfoLayer, zOrder, constantsObj.SPRITE_MISC);
        star.setColor(constantsObj.COLOR_BLUE_01);

        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            var line_grey = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, yPos - 140, 0.5, 1, canvasWidth, 5, null, packInfoLayer, zOrder, constantsObj.SPRITE_MISC);
            line_grey.setColor(constantsObj.COLOR_GREY_HS);
            utilObj.addChild(packInfoLayer, line_grey, zOrder);
            yPos -= 5;
        }

        utilObj.addChild(packInfoLayer, star, zOrder);

        var xOffset = 0;
        if (starCount > 999) {
            xOffset = 30;
        } else if (starCount > 99) {
            xOffset = 20;
        } else if (starCount > 9) {
            xOffset = 10;
        }
        packInfoLayer.masteryLbl = utilObj.getBMFontLabel(starCount + "", constantsObj.FONT_ROBOTO_REGULAR_70, textColor,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 300 + xWidth / 2 + xOffset, yPos - 70, 0, 0.5, labelArr, packInfoLayer, zOrder);
        //packInfoLayer.addChild(packInfoLayer.masteryLbl, zOrder);
        utilObj.addChild(packInfoLayer, packInfoLayer.masteryLbl, zOrder);

        var videoYPos = yPos - 270;
        if (index == 15) {
            videoYPos -= 25;
        }
        var videoButton = utilObj.getButton(360, 120, 0.5, 0.5, xRightPos - 300, videoYPos,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'packInfoLayer',
                fn: 'watchAVideo',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_PACK,
                    p: constantsObj.TRACK_W2E,
                    c: stringsObj.puzzle_themes_pack[index],
                    o: "",
                    f: constantsObj.TRACK_CLICK,
                    g: "",
                    s: "",
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        videoButton.setColor(constantsObj.COLOR_BUTTON_ORANGE);
        //packInfoLayer.addChild(videoButton, zOrder);
        utilObj.addChild(packInfoLayer, videoButton, zOrder);
        var lbl1 = utilObj.getBMFontLabel("Watch for", constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xRightPos - 340, videoYPos, 0.5, 0.5, labelArr, packInfoLayer, zOrder + 1);
        //packInfoLayer.addChild(lbl1, zOrder + 2);
        utilObj.addChild(packInfoLayer, lbl1, zOrder + 2);

        var coin = utilObj.getSprite(constantsObj.coin_png_2, xRightPos - 180, videoYPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_18, spriteArr, packInfoLayer, zOrder, constantsObj.SPRITE_MISC);
        //packInfoLayer.addChild(coin, zOrder);
        utilObj.addChild(packInfoLayer, coin, zOrder);

        yPos -= 300;
        if (packInfoLayer.britPack == constantsObj.BRITISH_PACKS) {
            var packInfo1 = packInfoLayer.showBritPackInfo(index, spriteArr, labelArr, zOrder, xPos, yPos, screen);
        } else {
            if (index < 7) {
                var theme_icon = constantsObj.LOGO_FOR_DAYS[index];
                var color = constantsObj.COLOR_FOR_WEEK_THEMES[index];
                var scale = constantsObj.SCALE_SPRITE_20;
                if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                    theme_icon = constantsObj.LOGO_FOR_DAYS_NEW_ICON[index];
                    color = constantsObj.COLOR_FOR_WEEK_THEMES_NEW[index];
                    if (index == 0 || index == 3) {
                        scale = scale * 0.6;
                    } else if (index == 1 || index == 2 || index == 5 || index == 6) {
                        scale = scale * 0.8;
                    }
                }
                var icon = utilObj.getSprite(theme_icon, centerXPos, yPos, 0.5, 0.5, scale, spriteArr, packInfoLayer, zOrder, constantsObj.SPRITE_MISC);
                icon.setColor(color);
                //packInfoLayer.addChild(icon, zOrder);
                utilObj.addChild(packInfoLayer, icon, zOrder);
            } else {
                var scale = constantsObj.SCALE_SPRITE_1;
                /*if (index == 19 || index == 20 || index == 21 ) {
                    scale = constantsObj.SCALE_SPRITE_1 * 1.5;
                } else {
                    scale = constantsObj.SCALE_SPRITE_1 * 1.5;
                }
                if (index == 22 || index == 23) {
                    scale = constantsObj.SCALE_SPRITE_1;
                }*/
                if (constantsObj.MINI_PACK_INFO[index] != undefined) {
                    scale = scale * constantsObj.MINI_PACK_INFO[index]["scale"];
                }
                var icon = utilObj.getSprite(constantsObj.LOGO_FOR_DAYS_PACK[index], centerXPos, yPos, 0.5, 0.5, scale, spriteArr, packInfoLayer, zOrder, constantsObj.SPRITE_MISC);
                //icon.setColor(constantsObj.COLOR_FOR_WEEK_THEMES[index]);
                icon.setColor(constantsObj.MINI_PACK_INFO[index]["packColor"]);
                /*if (index == 16) {
                    icon.setColor(constantsObj.COLOR_HOLIDAY_PACK);
                }
                if (index == 18) {
                    icon.setColor(constantsObj.COLOR_VALENTINE_BACKGROUND);
                }
                if (index == 19) {
                    icon.setColor(constantsObj.COLOR_WOMENDAY_BACKGROUND);
                }
                if (index == 20) {
                    icon.setColor(constantsObj.COLOR_LOL_BACKGROUND);
                }
                if (index == 21) {
                    icon.setColor(constantsObj.COLOR_MAY_BACKGROUND);
                }
                if (index == 22 ) {
                    icon.setColor(constantsObj.COLOR_JUNE_BACKGROUND);
                }
                if (index == 23 ) {
                    icon.setColor(constantsObj.COLOR_JULY_BACKGROUND);
                }*/
                //packInfoLayer.addChild(icon, zOrder);
                utilObj.addChild(packInfoLayer, icon, zOrder);
            }


            yPos -= 200;
            var textForPack = utilObj.getBMFontLabel(stringsObj.puzzle_themes_pack_Info[index], constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, yPos, 0.5, 0.5, labelArr, packInfoLayer, zOrder);
            //packInfoLayer.addChild(textForPack, zOrder);
            utilObj.addChild(packInfoLayer, textForPack, zOrder);

            yPos -= 100;
            var textForPack1 = utilObj.getBMFontLabel(stringsObj.puzzle_themes_pack_Info_desc[index], constantsObj.FONT_ROBOTO_REGULAR_50, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, yPos, 0.5, 0.5, labelArr, packInfoLayer, zOrder);
            //packInfoLayer.addChild(textForPack1, zOrder);
            utilObj.addChild(packInfoLayer, textForPack1, zOrder);

            yPos -= 80;
            var divider = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, yPos, 0.5, 0.5, 1360, 2);
            divider.setColor(constantsObj.COLOR_GREY_05);
            //packInfoLayer.addChild(divider, zOrder);
            utilObj.addChild(packInfoLayer, divider, zOrder);

            yPos -= 90;
            if (index >= constantsObj.INDEX_START_FOR_MINIS_MIDIS) {
                var reward = gameObj.getRewardForPackOtherThenArchive(index);
                var textForPack1 = utilObj.getBMFontLabel("Pack Reward: " + reward, constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, yPos, 0.5, 0.5, labelArr, packInfoLayer, zOrder);
                //packInfoLayer.addChild(textForPack1, zOrder);
                utilObj.addChild(packInfoLayer, textForPack1, zOrder);
                var coin = utilObj.getSprite(constantsObj.coin_png_2, centerXPos + 300, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_6, null, packInfoLayer, zOrder, constantsObj.SPRITE_MISC);
                //packInfoLayer.addChild(coin, zOrder);
                utilObj.addChild(packInfoLayer, coin, zOrder);
            }

            yPos -= 90;
            var numPuzzlesInPack = gameObj.getNumberOfPuzzlesInPack(index);

            if (numPuzzlesInPack <= 10) {
                var sectionBg = utilObj.getScale9Sprite(constantsObj.popup_bg, centerXPos, yPos, 0.5, 1, 1350, 1000);
                sectionBg.setColor(constantsObj.COLOR_YELLOW_07);
            } else {
                var sectionBg = utilObj.getScale9Sprite(constantsObj.popup_bg, centerXPos, yPos, 0.5, 1, 1350, 1250);
                sectionBg.setColor(constantsObj.COLOR_YELLOW_07);
            }

            //packInfoLayer.addChild(sectionBg, zOrder);
            utilObj.addChild(packInfoLayer, sectionBg, zOrder);


            var NUM_ROWS = Math.ceil(numPuzzlesInPack / constantsObj.MAX_NUMBER_OF_PUZZLES_PER_ROW);
            var NUM_COL = constantsObj.MAX_NUMBER_OF_PUZZLES_PER_ROW;

            //Add buttons to access puzzles
            var packLockedInfo = gameObj.getPackInfoLockStatus();
            var packInfo = gameObj.getPackInfo();
            var arr = packInfo[index];
            var inProgress = gameObj.getInProgress();

            //highLight the first inprogress or uncompleted puzzle
            var number1 = 1
            var firstNotStarted = -1;
            var firstInprogress = -1;
            packInfoLayer.highLighted = false;
            for (var row = 0; row < NUM_ROWS; row++) {
                for (var col = 0; col < NUM_COL; col++) {
                    if (number1 > numPuzzlesInPack) {
                        break;
                    }
                    var puzzleId = arr[number1 - 1];
                    var score = scoresObj.getHighScore(puzzleId);
                    if (score == 0 && inProgress.hasOwnProperty(puzzleId) && inProgress[puzzleId] != undefined) {
                        if (inProgress[puzzleId].timeElapsed > 0) {
                            if (firstInprogress == -1) {
                                firstInprogress = number1;
                            }
                        }
                        if (inProgress[puzzleId].timeElapsed == 0) {
                            if (firstNotStarted == -1) {
                                firstNotStarted = number1;
                            }
                        }
                    }
                    number1++;
                }
            }

            xPos = centerXPos - 222 * 2 - 80;
            yPos -= 50;
            var number = 1;
            for (var row = 0; row < NUM_ROWS; row++) {
                for (var col = 0; col < NUM_COL; col++) {
                    if (number > numPuzzlesInPack) {
                        break;
                    }
                    var x = row;
                    var y = col;
                    var t = x * 5 + y;
                    var d = arr[t];
                    var id = d;
                    var crosswordInfo = gameObj.getCrosswordForDate(id + "");
                    var score = scoresObj.getHighScore(id);
                    var square = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, xPos, yPos, 0.5, 1, 222, 222);
                    //packInfoLayer.addChild(square, zOrder);
                    utilObj.addChild(packInfoLayer, square, zOrder);
                    var outer = false;
                    /*if (((number == constantsObj.FIRST_PUZZLE_INDEX && index > 7) || index == 7) && inProgress.hasOwnProperty(id) == false && crosswordInfo.timeElapsed == 0) {
                     var free_tag = utilObj.getSprite(constantsObj.free_icon, xPos, yPos, 0.5, 1, constantsObj.SCALE_SPRITE_9, spriteArr, packInfoLayer, zOrder, constantsObj.SPRITE_MISC);
                     packInfoLayer.addChild(free_tag, zOrder+1);
                     }*/
                    if (id == gameLayer.crosswordDate && (score == 0)) {
                        if (packInfoLayer.highLighted == false) {
                            square.setColor(constantsObj.COLOR_SKY_BLUE_02);
                            outer = true;
                            packInfoLayer.highLighted = true;
                        }
                    } else {
                        if (firstInprogress != -1 && (gameLayer.crosswordDate == null || gameObj.checkForMiniOrMidi(gameLayer.crosswordDate))) {
                            if (number == firstInprogress) {
                                if (!inProgress.hasOwnProperty(gameLayer.crosswordDate)) {
                                    if (packInfoLayer.highLighted == false) {
                                        square.setColor(constantsObj.COLOR_SKY_BLUE_02);
                                        outer = true;
                                        packInfoLayer.highLighted = true;
                                    }
                                }
                            }
                        }
                        if (firstNotStarted != -1 && (gameLayer.crosswordDate == null || gameObj.checkForMiniOrMidi(gameLayer.crosswordDate))) {
                            if (number == firstNotStarted && firstInprogress == -1) {
                                if (!inProgress.hasOwnProperty(gameLayer.crosswordDate)) {
                                    if (packInfoLayer.highLighted == false && number != 1) {
                                        square.setColor(constantsObj.COLOR_SKY_BLUE_02);
                                        outer = true;
                                        packInfoLayer.highLighted = true;
                                    }
                                }
                            }
                        }
                    }

                    if (packLockedInfo[index] != undefined) {
                        var numberLabel = utilObj.getBMFontLabel(number + "", constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
                            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos - 70, yPos - 10, 0.5, 1, labelArr, packInfoLayer, zOrder);
                        //packInfoLayer.addChild(numberLabel, zOrder + 1);
                        utilObj.addChild(packInfoLayer, numberLabel, zOrder + 1);
                        if (packLockedInfo[index] == true && ((number != constantsObj.FIRST_PUZZLE_INDEX) || index < constantsObj.FREE_PACK_INDEX)) {
                            var lock = utilObj.getSprite(constantsObj.lock, xPos, yPos - 60, 0.5, 1, constantsObj.SCALE_SPRITE_9 * 1.5, spriteArr, packInfoLayer, zOrder, constantsObj.SPRITE_MISC);
                            lock.setColor(constantsObj.COLOR_BLACK);
                            lock.setOpacity(125);
                            //packInfoLayer.addChild(lock, zOrder);
                            utilObj.addChild(packInfoLayer, lock, zOrder);
                        } else {
                            //show mastery per puzzle
                            var tempCondition = true;

                            if (inProgress.hasOwnProperty(id)) {
                                if (inProgress[id] != undefined) {
                                    if (inProgress[id].timeElapsed > 0) {
                                        tempCondition = false;
                                    }
                                }
                            }
                            if (score > 0) {
                                tempCondition = false;
                            }
                            if (((number == constantsObj.FIRST_PUZZLE_INDEX && index > 7) || index == 7 || index >= 14 /*|| index == 15 || index == 16 || index == 17 || index == 18 || index == 19 || index == 20 || index == 21 || index == 22 || index == 23 || index == 24*/) && /*inProgress.hasOwnProperty(id)*/tempCondition) {
                                var free_tag = utilObj.getSprite(constantsObj.free_icon, xPos, yPos, 0.5, 1, constantsObj.SCALE_SPRITE_9 * 1.5, spriteArr, packInfoLayer, zOrder, constantsObj.SPRITE_MISC);
                                utilObj.addChild(packInfoLayer, free_tag, zOrder + 1);
                                if ((packInfoLayer.highLighted == false && firstNotStarted == 1 && firstInprogress == -1) || outer == true) {
                                    free_tag.setColor(constantsObj.COLOR_SKY_BLUE_02);
                                    outer = true;
                                    packInfoLayer.highLighted = true;
                                }

                                // setting visibility of free_tag to false for hs v2
                                if (homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2) {
                                    utilObj.setVisible(free_tag, false);
                                }
                                //

                                var numberLabel = utilObj.getBMFontLabel(number + "", constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
                                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos - 70, yPos - 10, 0.5, 1, labelArr, packInfoLayer, zOrder);
                                //packInfoLayer.addChild(numberLabel, zOrder + 1);
                                utilObj.addChild(packInfoLayer, numberLabel, zOrder + 1);
                                if (inProgress.hasOwnProperty(id)) {
                                    if (inProgress[id] != undefined) {
                                        inProgress[id].isOpened == "true";
                                    }
                                }
                            } else {
                                if (inProgress.hasOwnProperty(id) && inProgress[id] != undefined && crosswordInfo != null) {
                                    // Puzzle unlocked and started
                                    var fillCount = crosswordInfo.fc;
                                    var filled = inProgress[id].filled;
                                    var percentCompleted = (filled / fillCount) * 100;
                                    var tileWidth = 222;

                                    yPos += 10;
                                    var outerCircle = utilObj.getSprite(constantsObj.white_circle_150, tileWidth / 2, tileWidth / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_6);
                                    outerCircle.setColor(constantsObj.COLOR_GREY_05);
                                    //square.addChild(outerCircle, zOrder);
                                    utilObj.addChild(square, outerCircle, zOrder);
                                    var sprite = utilObj.getSprite(constantsObj.white_circle_150, tileWidth / 2, tileWidth / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_6);
                                    var progressTimer = new cc.ProgressTimer(sprite);
                                    progressTimer.setType(cc.ProgressTimer.TYPE_RADIAL);
                                    progressTimer.setMidpoint(cc.p(0.5, 0.5));
                                    progressTimer.setBarChangeRate(cc.p(1, 0));
                                    progressTimer.setColor(constantsObj.COLOR_GREEN_04);
                                    if (id == gameLayer.crosswordDate) {
                                        progressTimer.setColor(constantsObj.COLOR_BLACK);
                                    }
                                    progressTimer.setPosition(222 / 2, 222 / 2);
                                    progressTimer.setPercentage(percentCompleted);
                                    progressTimer.setScale(constantsObj.SCALE_SPRITE_6, constantsObj.SCALE_SPRITE_6);
                                    //square.addChild(progressTimer, zOrder + 1);
                                    utilObj.addChild(square, progressTimer, zOrder + 1);
                                    var innerCircle = utilObj.getSprite(constantsObj.white_circle_150, tileWidth / 2, tileWidth / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_14);
                                    if (outer == true) {
                                        innerCircle.setColor(constantsObj.COLOR_SKY_BLUE_02);
                                    }
                                    //square.addChild(innerCircle, zOrder + 1);
                                    utilObj.addChild(square, innerCircle, zOrder + 1);
                                    yPos -= 10;
                                    var timeTaken = utilObj.formatTime(inProgress[id].timeElapsed);
                                    var labelTime = utilObj.getBMFontLabel(timeTaken, constantsObj.FONT_ROBOTO_BOLD_40, constantsObj.COLOR_BLACK,
                                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 111, 55, 0.5, 1, null, square, zOrder);
                                    //square.addChild(labelTime, zOrder + 1);
                                    utilObj.addChild(square, labelTime, zOrder + 1);
                                    labelTime.setVisible(false);
                                    // loggerObj.debugLog("lelouch inProgress[id].isOpened is for ", inProgress[id].isOpened, typeof inProgress[id].isOpened, inProgress[id].isOpened == "true", id);

                                    if (inProgress[id].isOpened == "true") {
                                        labelTime.setVisible(true);
                                    }

                                } else if (score == 0 && crosswordInfo != null) {
                                    var tileWidth = 222;
                                    var outerCircle = utilObj.getSprite(constantsObj.white_circle_150, tileWidth / 2, tileWidth / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_6);
                                    outerCircle.setColor(constantsObj.COLOR_GREY_05);
                                    utilObj.addChild(square, outerCircle, zOrder);

                                    var innerCircle = utilObj.getSprite(constantsObj.white_circle_150, tileWidth / 2, tileWidth / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_14);
                                    if (outer == true) {
                                        innerCircle.setColor(constantsObj.COLOR_SKY_BLUE_02);
                                    }
                                    //square.addChild(innerCircle, zOrder + 1);
                                    utilObj.addChild(square, innerCircle, zOrder + 1);

                                } else if (score > 0) {
                                    // Puzzle Completed
                                    var xxPos = 10;
                                    var yyPos = 20;
                                    var masteryStars = scoresObj.getMastery(id);

                                    var starColor = constantsObj.COLOR_BLUE_01;
                                    var star1 = utilObj.getSprite(constantsObj.star_white_2, xxPos + 12, yyPos - 25 + 120, 0, 0.5, constantsObj.SCALE_SPRITE_9, null, square, zOrder, constantsObj.SPRITE_MISC);
                                    star1.setColor(starColor);
                                    //square.addChild(star1, zOrder + 1);
                                    utilObj.addChild(square, star1, zOrder + 1);
                                    if (masteryStars < constantsObj.MASTERY_SILVER) {
                                        starColor = constantsObj.COLOR_GREY_02;
                                    }
                                    var star2 = utilObj.getSprite(constantsObj.star_white_2, xxPos + 70, yyPos + 135, 0, 0.5, constantsObj.SCALE_SPRITE_6, null, square, zOrder, constantsObj.SPRITE_MISC);
                                    star2.setColor(starColor);
                                    //square.addChild(star2, zOrder + 1);
                                    utilObj.addChild(square, star2, zOrder + 1);
                                    if (masteryStars < constantsObj.MASTERY_GOLD) {
                                        starColor = constantsObj.COLOR_GREY_02;
                                    }
                                    var star3 = utilObj.getSprite(constantsObj.star_white_2, xxPos + 133, yyPos - 25 + 120, 0, 0.5, constantsObj.SCALE_SPRITE_9, null, square, zOrder, constantsObj.SPRITE_MISC);
                                    star3.setColor(starColor);
                                    //square.addChild(star3, zOrder + 1);
                                    utilObj.addChild(square, star3, zOrder + 1);
                                    var timeTaken = utilObj.formatTime(score);
                                    var labelTime = utilObj.getBMFontLabel(timeTaken, constantsObj.FONT_ROBOTO_BOLD_40, constantsObj.COLOR_BLACK,
                                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 111, 55, 0.5, 1, null, square, zOrder + 1);
                                    //square.addChild(labelTime, zOrder + 1);
                                    utilObj.addChild(square, labelTime, zOrder + 1);
                                }
                            }

                        }
                    }

                    var buttonAtCoins = utilObj.getButton(222, 222, 0.5, 1, xPos, yPos,
                        constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                            obj: 'packInfoLayer',
                            fn: 'loadPuzzle',
                            screen: screen,
                            params: {x: row, y: col, status: packLockedInfo[index], index: index, packType: constantsObj.NORMAL_PACKS},
                            track: {
                                k: constantsObj.TRACK_DIALOG,
                                p: gameObj.getCurPuzzleTracking(),
                                c: gameObj.getTrackingPuzzleTheme(),
                                o: constantsObj.TRACK_PACK_INFO,
                                f: constantsObj.TRACK_STORE,
                                g: "",
                                s: gameObj.getPuzzleSpeciesTracking(),
                                co: 1,
                                oppId: ""
                            },
                        }, false, ccui.Widget.PLIST_TEXTURE, 1);
                    //packInfoLayer.addChild(buttonAtCoins, zOrder);
                    utilObj.addChild(packInfoLayer, buttonAtCoins, zOrder);

                    xPos += 222 + 40;
                    number += 1;
                }
                xPos = centerXPos - 222 * 2 - 80;
                yPos -= 222 + 42;
            }

            if (NUM_ROWS == 2) {
                yPos -= 0;
            } else {
                yPos -= 50;
            }
            if (packLockedInfo[index] == true) {
                packInfoLayer.unlockButton = utilObj.getButton(830, 200, 0.5, 0.5, centerXPos, yPos - 175,
                    constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                        obj: 'packInfoLayer',
                        fn: 'unlock',
                        screen: screen,
                        params: {index: index},
                        track: {
                            k: constantsObj.TRACK_DIALOG,
                            p: gameObj.getCurPuzzleTracking(),
                            c: gameObj.getTrackingPuzzleTheme(),
                            o: constantsObj.TRACK_FREE_COINS,
                            f: constantsObj.TRACK_REFER,
                            g: utilObj.getScreenName(screen),
                            s: gameObj.getPuzzleSpeciesTracking(),
                            co: 1,
                            oppId: ""
                        },
                    }, false, ccui.Widget.PLIST_TEXTURE, 1);
                packInfoLayer.unlockButton.setColor(constantsObj.COLOR_GREEN);
                utilObj.pulseButton(packInfoLayer.unlockButton, constantsObj.PULSE_ACTION_TAG, 0);
                //packInfoLayer.addChild(packInfoLayer.unlockButton, zOrder);
                utilObj.addChild(packInfoLayer, packInfoLayer.unlockButton, zOrder);

                var coinsToUnlock = gameObj.getCostForPackOtherThenArchive(index);
                if (index == constantsObj.FREE_PACK_INDEX || index == 14) {
                    var lbl1 = utilObj.getBMFontLabel("Unlock for Free", constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_WHITE,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 415 - 30, 100, 0.5, 0.5, labelArr, packInfoLayer.unlockButton, zOrder);
                    //packInfoLayer.unlockButton.addChild(lbl1, zOrder + 1);
                    utilObj.addChild(packInfoLayer.unlockButton, lbl1, zOrder + 1);
                } else if (index >= 7) {
                    var lbl1 = utilObj.getBMFontLabel("Unlock for " + coinsToUnlock, constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_WHITE,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 415 - 30, 100, 0.5, 0.5, labelArr, packInfoLayer.unlockButton, zOrder);
                    //packInfoLayer.unlockButton.addChild(lbl1, zOrder + 1);
                    utilObj.addChild(packInfoLayer.unlockButton, lbl1, zOrder + 1);
                } else {
                    coinsToUnlock = gameObj.getNumberOfPuzzlesInPack(index) * economyObj.getRevealCrosswordCost();
                    var lbl1 = utilObj.getBMFontLabel("Unlock for " + coinsToUnlock, constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_WHITE,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 415 - 30, 100, 0.5, 0.5, labelArr, packInfoLayer.unlockButton, zOrder);
                    //packInfoLayer.unlockButton.addChild(lbl1, zOrder + 1);
                    utilObj.addChild(packInfoLayer.unlockButton, lbl1, zOrder + 1);
                }
                var coin = utilObj.getSprite(constantsObj.coin_png_2, 415 + 280, 100, 0.5, 0.5, constantsObj.SCALE_SPRITE_6, null, packInfoLayer, zOrder, constantsObj.SPRITE_MISC);
                //packInfoLayer.unlockButton.addChild(coin, zOrder);
                utilObj.addChild(packInfoLayer.unlockButton, coin, zOrder);
            } else {
                //check how many puzzles got completed
                var count = gameObj.getNumberOfPuzzlesCompletedInPack(index);

                var colorOfProgressBar = constantsObj.COLOR_BLUE_PROGRESS_BAR;
                var showProgressBar2 = true;
                if (count == numPuzzlesInPack) {
                    showProgressBar2 = false;
                    colorOfProgressBar = constantsObj.COLOR_BUTTON_LIGHT_BLUE;
                }

                //show progress bar
                var progressBar = utilObj.getScale9Sprite(constantsObj.full_bar, centerXPos, yPos - 175, 0.5, 0.5, 800, 100);
                progressBar.setColor(colorOfProgressBar);
                //packInfoLayer.addChild(progressBar, zOrder);
                utilObj.addChild(packInfoLayer, progressBar, zOrder);

                var lengthOfProgressBar2 = (800 / numPuzzlesInPack) * count;
                if (count > 0 && showProgressBar2 == true) {
                    var progressBar2 = utilObj.getScale9Sprite(constantsObj.full_bar, centerXPos - 400, yPos - 175, 0, 0.5, lengthOfProgressBar2, 100);//, null,"", zOrder, constantsObj.SPRITE_MISC);
                    progressBar2.setColor(constantsObj.COLOR_BUTTON_LIGHT_BLUE);
                    //packInfoLayer.addChild(progressBar2, zOrder);
                    utilObj.addChild(packInfoLayer, progressBar2, zOrder);
                }

                if (index >= constantsObj.INDEX_START_FOR_MINIS_MIDIS) {
                    var lbl2 = utilObj.getBMFontLabel(count + "/" + numPuzzlesInPack, constantsObj.FONT_ROBOTO_MEDIUM_60, constantsObj.COLOR_WHITE,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, yPos - 175, 0.5, 0.5, labelArr, packInfoLayer.unlockButton, zOrder);
                    //packInfoLayer.addChild(lbl2, zOrder + 2);
                    utilObj.addChild(packInfoLayer, lbl2, zOrder + 2);
                } else {
                    var lbl2 = utilObj.getBMFontLabel(count + "/" + numPuzzlesInPack, constantsObj.FONT_ROBOTO_MEDIUM_60, constantsObj.COLOR_WHITE,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, yPos - 175, 0.5, 0.5, labelArr, packInfoLayer.unlockButton, zOrder);
                    //packInfoLayer.addChild(lbl2, zOrder + 2);
                    utilObj.addChild(packInfoLayer, lbl2, zOrder + 2);
                }

                if (index >= constantsObj.INDEX_START_FOR_MINIS_MIDIS && !(count == numPuzzlesInPack)) {
                    var progressBarCompletion = utilObj.getScale9Sprite(constantsObj.popup_bg, centerXPos + 450, yPos - 175, 0.5, 0.5, 190, 220);//, null,"", zOrder, constantsObj.SPRITE_MISC);
                    progressBarCompletion.setColor(constantsObj.COLOR_BLUE_PROGRESS_BAR_END);
                    //packInfoLayer.addChild(progressBarCompletion, zOrder + 3);
                    utilObj.addChild(packInfoLayer, progressBarCompletion, zOrder + 3);

                    var coin = utilObj.getSprite(constantsObj.coin_png_2, centerXPos + 450, yPos - 130, 0.5, 0.5, constantsObj.SCALE_SPRITE_7, null, packInfoLayer, zOrder, constantsObj.SPRITE_MISC);
                    //packInfoLayer.addChild(coin, zOrder + 3);
                    utilObj.addChild(packInfoLayer, coin, zOrder + 3);

                    var reward = gameObj.getRewardForPackOtherThenArchive(index);

                    var lbl1 = utilObj.getBMFontLabel(reward, constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_WHITE,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos + 450, yPos - 240, 0.5, 0.5, labelArr, packInfoLayer.unlockButton, zOrder);
                    //packInfoLayer.addChild(lbl1, zOrder + 3);
                    utilObj.addChild(packInfoLayer, lbl1, zOrder + 3);
                }
            }

            utilObj.updateScreen(constantsObj.SCREEN_PACK_INFO_LAYER, packInfoLayer);
            packInfoLayer.setVisible(true);


            //check for is_pack complete.
            var reward = gameObj.getRewardForPackOtherThenArchive(index);
            var numberOfPuzzleSolved = gameObj.getNumberOfPuzzlesCompletedInPack(index);
            var packCompletionPopupShown = false;
            var isPackCompletionRewarded = gameObj.checkIfPackCompleteRewarded(index);

            // loggerObj.debugLog("pack completion ", numberOfPuzzleSolved, numPuzzlesInPack, isPackCompletionRewarded, index);
            if (numberOfPuzzleSolved == numPuzzlesInPack) {
                if (index >= constantsObj.FREE_PACK_INDEX && (isPackCompletionRewarded != true)) {
                    packCompletePopup.show(true, index);
                    gameObj.setPacksComplete(index);
                    economyObj.addCash(reward, constantsObj.TRACK_EARN, constantsObj.TRACK_PACK_COMPLETE, stringsObj.puzzle_themes_pack_Info[index]);
                    utilObj.showMessage(reward + " coins have been rewarded");
                    //packInfoLayer.alreadyCompleted = true;
                }
                gameObj.makePacksInOrder(index, 1, packInfoLayer.britPack);
            }

            var curTimestamp1 = utilObj.getCurrentTimestamp();

            var timeSpentFromLastNotifPopup = curTimestamp1 - gameObj.getLastNotifPopupTimestamp();

            var isD1 = false;
            if (((curTimestamp1 - userObj.getCreated()) > 24 * constantsObj.SECONDS_IN_HOUR && (curTimestamp1 - userObj.getCreated()) < 48 * constantsObj.SECONDS_IN_HOUR)) {
                isD1 = true;
            }

            var isD0 = false;
            if (((curTimestamp1 - userObj.getCreated()) < 24 * constantsObj.SECONDS_IN_HOUR)) {
                isD0 = true;
            }

            // loggerObj.debugLog("gameobj.getopenedfrom outro = ", gameObj.getOpenedFromOutro(),packCompletionPopupShown);

            if ((gameObj.getMastery1() <= 0) && gameObj.checkIfPackComplete(7) == true) {
                // loggerObj.debugLog("coming inside this");
            } else {
                if (!popupLayer.popupOpen && packCompletionPopupShown == false) {
                    if (!gameObj.getNotifsEnabled() && gameObj.getOpenedFromOutro()) {
                        if (isD0) {
                            if (!gameObj.getNotifPopupShownOnPackInfoScreen() && gameObj.getNotifPopupCount() < 2) {
                                gameObj.setNotifPopupShown(true);
                                gameObj.setNotifPopupShownOnPackInfoScreen(true);
                                gameObj.setLastNotifPopupTimeStamp(curTimestamp1);
                                notifPermissionPopup.show();
                                gameObj.setNotifPopupCount(gameObj.getNotifPopupCount() + 1);
                            }
                        } else if (isD1 && !gameObj.getNotifPopupShownOnD1() && (gameObj.getNotifPopupCount() < constantsObj.MAX_NOTIF_LIMIT)) {
                            gameObj.setNotifPopupShown(true);
                            gameObj.setNotifPopupShownOnD1(true);
                            gameObj.setLastNotifPopupTimeStamp(curTimestamp1);
                            notifPermissionPopup.show();
                            gameObj.setNotifPopupCount(gameObj.getNotifPopupCount() + 1);
                        } else if ((timeSpentFromLastNotifPopup > 48 * constantsObj.SECONDS_IN_HOUR) && (gameObj.getNotifPopupCount() < constantsObj.MAX_NOTIF_LIMIT)) {
                            gameObj.setNotifPopupShown(true);
                            gameObj.setLastNotifPopupTimeStamp(curTimestamp1);
                            notifPermissionPopup.show();
                            gameObj.setNotifPopupCount(gameObj.getNotifPopupCount() + 1);
                        }
                    }
                }
            }

            var timeSpentFbLoginShown = curTimestamp1 - gameObj.getLastFbLoginShowTimestamp();
            var timeSpentRateUsShown = curTimestamp1 - gameObj.getLastRateUsShowTimestamp();
            var timeSpentInviteAndWinShown = curTimestamp1 - gameObj.getLastInviteAndWinShowTimestamp();
            var timeSpentFromLastInterstitial = curTimestamp1 - gameObj.getLastInterstitialTimestamp();
            var timeSpentFromLastNotifPopup = curTimestamp1 - gameObj.getLastNotifPopupTimestamp();
            // loggerObj.debugLog("Interstitial time ", timeSpentFromLastInterstitial);

            var isFirstSessionCalendar = gameObj.getIsFirstSessionCalendar();
            var isD1 = false;
            if (((curTimestamp1 - userObj.getCreated()) > 24 * constantsObj.SECONDS_IN_HOUR && (curTimestamp1 - userObj.getCreated()) < 48 * constantsObj.SECONDS_IN_HOUR)) {
                isD1 = true;
            }

            var isD0 = false;
            if (((curTimestamp1 - userObj.getCreated()) < 24 * constantsObj.SECONDS_IN_HOUR)) {
                isD0 = true;
            }


            // loggerObj.debugLog("djain triggering rateUs");
            // loggerObj.debugLog("triggering rateus", timeSpentRateUsShown, gameObj.getLastRatedVersion(), (utilObj.getCurrentTimestamp() - gameObj.getTimeStampForAutoDialogShown()), gameObj.getOpenedFromOutro(), isFirstSessionCalendar, ftueObj.isCalendarFtueShown());

            if ((gameObj.getMastery1() <= 0) && gameObj.checkIfPackComplete(7) == true) {
                // loggerObj.debugLog("coming inside this");
            }
            else {
                if (!popupLayer.popupOpen && packCompletionPopupShown == false) {
                    if (runtimeObj.getForceUpdate() == 1) {
                        utilObj.forceUpdate();
                    } else if (!gameObj.getNotifsEnabled() && gameObj.getOpenedFromOutro() && utilObj.isIos()) {
                        if (isD0) {
                            if (!gameObj.getNotifPopupShownOnCalendarScreen() && gameObj.getNotifPopupCount() < 2) {
                                gameObj.setNotifPopupShown(true);
                                gameObj.setNotifPopupShownOnCalendarScreen(true);
                                gameObj.setLastNotifPopupTimeStamp(curTimestamp1);
                                notifPermissionPopup.show();
                                gameObj.setNotifPopupCount(gameObj.getNotifPopupCount() + 1);
                            }
                        } else if (isD1 && !gameObj.getNotifPopupShownOnD1() && (gameObj.getNotifPopupCount() < constantsObj.MAX_NOTIF_LIMIT)) {
                            gameObj.setNotifPopupShown(true);
                            gameObj.setNotifPopupShownOnD1(true);
                            gameObj.setLastNotifPopupTimeStamp(curTimestamp1);
                            notifPermissionPopup.show();
                            gameObj.setNotifPopupCount(gameObj.getNotifPopupCount() + 1);
                        } else if ((timeSpentFromLastNotifPopup > 48 * constantsObj.SECONDS_IN_HOUR) && (gameObj.getNotifPopupCount() < constantsObj.MAX_NOTIF_LIMIT)) {
                            gameObj.setNotifPopupShown(true);
                            gameObj.setLastNotifPopupTimeStamp(curTimestamp1);
                            notifPermissionPopup.show();
                            gameObj.setNotifPopupCount(gameObj.getNotifPopupCount() + 1);
                        }
                    } else if (timeSpentRateUsShown > 48 * constantsObj.SECONDS_IN_HOUR /*&& gameObj.getLastRatedVersion() == 0*/ && (curTimestamp1 - gameObj.getTimeStampForAutoDialogShown()) > 4 * constantsObj.SECONDS_IN_MIN && gameObj.getOpenedFromOutro()) {

                        rateUsPopup.show();
                    } else if (fbWrapperObj.isLoggedIn() && timeSpentInviteAndWinShown > 24 * constantsObj.SECONDS_IN_HOUR && !gameObj.getIsRedraw() && (curTimestamp1 - gameObj.getTimeStampForAutoDialogShown()) > 4 * constantsObj.SECONDS_IN_MIN) {

                        inviteAndWinPopup.show();

                    } else if (!fbWrapperObj.isLoggedIn() && timeSpentFbLoginShown > 24 * constantsObj.SECONDS_IN_HOUR && !gameObj.getIsRedraw() && (curTimestamp1 - gameObj.getTimeStampForAutoDialogShown()) > 4 * constantsObj.SECONDS_IN_MIN) {

                        fbConnectPopup.show();

                    }
                }
            }

            if (gameObj.getOpenedFromOutro()) {
                gameObj.setOpenedFromOutro(false);
            }

            if (gameObj.getIsRedraw()) {
                gameObj.setIsRedraw(false);
            }

            trackObj.trackCounter(constantsObj.TRACK_PACK, "pack_view", stringsObj.puzzle_themes[index],
                "", "", gameObj.getPackStatus(index), gameObj.getPuzzleSpeciesTracking(), "", "");

            //triggering tracking for pack directory
            var packLockStatus = gameObj.getPackInfoLockStatus;
            var numberOfPacksPurchased = 0;
            for (var g = 0; g < packLockStatus; g++) {
                if (packLockStatus[g] == false) {
                    numberOfPacksPurchased++;
                }
            }
            var numberOfPacksInProgress = numberOfPacksPurchased;
            numberOfPacksPurchased -= 1;

            //total packs available
            var packInfoTrack = gameObj.getPackInfo();
            var totalPacksAvailable = 0;
            for (var packNo = 0; packNo < 11; packNo++) {
                var packArr = packInfoTrack[packNo];
                if (packArr.length > 4) {
                    totalPacksAvailable += 1;
                }
            }
            trackObj.trackCounter(constantsObj.TRACK_PACK, "directory", totalPacksAvailable + "",
                numberOfPacksPurchased + "", numberOfPacksInProgress + "", "", gameObj.getPuzzleSpeciesTracking(), "", "");
        }

        /*if(gameObj.hasNeverClaimedAchievement()){
            packInfoLayer.showAchievementReminder();
        }*/

        //gameObj.makePacksInOrder(index,2);
        utilObj.showBannerAd(utilObj.getScreenName(constantsObj.SCREEN_PACK_INFO_LAYER));
        if(epmObj.getChosenVariant(constantsObj.EXP_THEMED_QUEST) == constantsObj.EXP_VAR_1) {
            themedQuestObj.updateCash(packInfoLayer, packInfoLayer.cashLbl);
        }
    },

    /**
     * adding the info for brit packs
     */
    showBritPackInfo: function (index, spriteArr, labelArr, zOrder, xPos, yPos, screen) {
        var scale = constantsObj.SCALE_SPRITE_1;
        if (constantsObj.BRIT_PACK_INFO[index] != undefined) {
            scale = scale * constantsObj.BRIT_PACK_INFO[index]["scale"];
        }
        var icon = utilObj.getSprite(constantsObj.LOGO_FOR_BRIT_PACKS[index], centerXPos, yPos, 0.5, 0.5, scale, spriteArr, packInfoLayer, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setColor(icon, constantsObj.BRIT_PACK_INFO[index]["packColor"]);
        utilObj.addChild(packInfoLayer, icon, zOrder);


        yPos -= 200;
        var textForPack = utilObj.getBMFontLabel(stringsObj.puzzle_themes_brit_pack_Info[index], constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, yPos, 0.5, 0.5, labelArr, packInfoLayer, zOrder);
        utilObj.addChild(packInfoLayer, textForPack, zOrder);

        yPos -= 100;
        var textForPack1 = utilObj.getBMFontLabel(stringsObj.puzzle_themes_brit_pack_Info_desc[index], constantsObj.FONT_ROBOTO_REGULAR_50, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, yPos, 0.5, 0.5, labelArr, packInfoLayer, zOrder);
        utilObj.addChild(packInfoLayer, textForPack1, zOrder);

        yPos -= 80;
        var divider = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, yPos, 0.5, 0.5, 1360, 2);
        utilObj.setColor(divider, constantsObj.COLOR_GREY_05);
        utilObj.addChild(packInfoLayer, divider, zOrder);

        yPos -= 90;
        var reward = gameObj.getRewardForPackOtherThenArchive(index, constantsObj.BRITISH_PACKS);
        var textForPack1 = utilObj.getBMFontLabel("Pack Reward: " + reward, constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, yPos, 0.5, 0.5, labelArr, packInfoLayer, zOrder);
        utilObj.addChild(packInfoLayer, textForPack1, zOrder);
        var coin = utilObj.getSprite(constantsObj.coin_png_2, centerXPos + 300, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_6, null, packInfoLayer, zOrder, constantsObj.SPRITE_MISC);
        utilObj.addChild(packInfoLayer, coin, zOrder);

        yPos -= 90;
        var numPuzzlesInPack = gameObj.getNumberOfPuzzlesInPack(index, constantsObj.BRITISH_PACKS);

        if (numPuzzlesInPack <= 10) {
            var sectionBg = utilObj.getScale9Sprite(constantsObj.popup_bg, centerXPos, yPos, 0.5, 1, 1350, 1000);
            utilObj.setColor(sectionBg, constantsObj.COLOR_YELLOW_07);
        } else {
            var sectionBg = utilObj.getScale9Sprite(constantsObj.popup_bg, centerXPos, yPos, 0.5, 1, 1350, 1250);
            utilObj.setColor(sectionBg, constantsObj.COLOR_YELLOW_07);
        }

        utilObj.addChild(packInfoLayer, sectionBg, zOrder);


        var NUM_ROWS = Math.ceil(numPuzzlesInPack / constantsObj.MAX_NUMBER_OF_PUZZLES_PER_ROW);
        var NUM_COL = constantsObj.MAX_NUMBER_OF_PUZZLES_PER_ROW;

        //Add buttons to access puzzles
        var packLockedInfo = gameObj.getPackInfoLockStatus();
        var packInfo = gameObj.getBritPurchasedPackInfo();
        var arr = packInfo[index];
        var inProgress = gameObj.getInProgress();

        //highLight the first inprogress or uncompleted puzzle
        var number1 = 1;
        var firstNotStarted = -1;
        var firstInprogress = -1;
        packInfoLayer.highLighted = false;
        for (var row = 0; row < NUM_ROWS; row++) {
            for (var col = 0; col < NUM_COL; col++) {
                if (number1 > numPuzzlesInPack) {
                    break;
                }
                var puzzleId = arr[number1 - 1];
                var score = scoresObj.getHighScore(puzzleId);
                if (score == 0 && inProgress.hasOwnProperty(puzzleId) && inProgress[puzzleId] != undefined) {
                    if (inProgress[puzzleId].timeElapsed > 0) {
                        if (firstInprogress == -1) {
                            firstInprogress = number1;
                        }
                    }
                    if (inProgress[puzzleId].timeElapsed == 0) {
                        if (firstNotStarted == -1) {
                            firstNotStarted = number1;
                        }
                    }
                }
                number1++;
            }
        }

        xPos = centerXPos - 222 * 2 - 80;
        yPos -= 50;
        var number = 1;
        for (var row = 0; row < NUM_ROWS; row++) {
            for (var col = 0; col < NUM_COL; col++) {
                if (number > numPuzzlesInPack) {
                    break;
                }
                var x = row;
                var y = col;
                var t = x * 5 + y;
                var d = arr[t];
                var id = d;
                var crosswordInfo = gameObj.getCrosswordForDate(id + "");
                var score = scoresObj.getHighScore(id);
                var square = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, xPos, yPos, 0.5, 1, 222, 222);
                utilObj.addChild(packInfoLayer, square, zOrder);
                var outer = false;
                if (id == gameLayer.crosswordDate && (score == 0)) {
                    if (packInfoLayer.highLighted == false) {
                        utilObj.setColor(square, constantsObj.COLOR_SKY_BLUE_02);
                        outer = true;
                        packInfoLayer.highLighted = true;
                    }
                } else {
                    if (firstInprogress != -1 && (gameLayer.crosswordDate == null || gameObj.checkForMiniOrMidi(gameLayer.crosswordDate))) {
                        if (number == firstInprogress) {
                            if (!inProgress.hasOwnProperty(gameLayer.crosswordDate)) {
                                if (packInfoLayer.highLighted == false) {
                                    utilObj.setColor(square, constantsObj.COLOR_SKY_BLUE_02);
                                    outer = true;
                                    packInfoLayer.highLighted = true;
                                }
                            }
                        }
                    }
                    if (firstNotStarted != -1 && (gameLayer.crosswordDate == null || gameObj.checkForMiniOrMidi(gameLayer.crosswordDate))) {
                        if (number == firstNotStarted && firstInprogress == -1) {
                            if (!inProgress.hasOwnProperty(gameLayer.crosswordDate)) {
                                if (packInfoLayer.highLighted == false && number != 1) {
                                    utilObj.setColor(square, constantsObj.COLOR_SKY_BLUE_02);
                                    outer = true;
                                    packInfoLayer.highLighted = true;
                                }
                            }
                        }
                    }
                }

                var numberLabel = utilObj.getBMFontLabel(number + "", constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos - 70, yPos - 10, 0.5, 1, labelArr, packInfoLayer, zOrder);
                //packInfoLayer.addChild(numberLabel, zOrder + 1);
                utilObj.addChild(packInfoLayer, numberLabel, zOrder + 1);
                //show mastery per puzzle
                var tempCondition = true;

                if (inProgress.hasOwnProperty(id)) {
                    if (inProgress[id] != undefined) {
                        if (inProgress[id].timeElapsed > 0) {
                            tempCondition = false;
                        }
                    }
                }
                if (score > 0) {
                    tempCondition = false;
                }
                loggerObj.debugLog("check for the pack info arr2 ", number, tempCondition);
                if (tempCondition) {
                    var free_tag = utilObj.getSprite(constantsObj.free_icon, xPos, yPos, 0.5, 1, constantsObj.SCALE_SPRITE_9 * 1.5, spriteArr, packInfoLayer, zOrder, constantsObj.SPRITE_MISC);
                    utilObj.addChild(packInfoLayer, free_tag, zOrder + 1);
                    if ((packInfoLayer.highLighted == false && firstNotStarted == 1 && firstInprogress == -1) || outer == true) {
                        utilObj.setColor(free_tag, constantsObj.COLOR_SKY_BLUE_02);
                        outer = true;
                        packInfoLayer.highLighted = true;
                    }

                    // setting visibility of free_tag to false for hs v2
                    if (homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2) {
                        utilObj.setVisible(free_tag, false);
                    }
                    //

                    var numberLabel = utilObj.getBMFontLabel(number + "", constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos - 70, yPos - 10, 0.5, 1, labelArr, packInfoLayer, zOrder);
                    //packInfoLayer.addChild(numberLabel, zOrder + 1);
                    utilObj.addChild(packInfoLayer, numberLabel, zOrder + 1);
                    if (inProgress.hasOwnProperty(id)) {
                        if (inProgress[id] != undefined) {
                            inProgress[id].isOpened == "true";
                        }
                    }
                } else {
                    loggerObj.debugLog("check for the pack info arr3 ", id, score, inProgress.hasOwnProperty(id));
                    if (inProgress.hasOwnProperty(id) && inProgress[id] != undefined && crosswordInfo != null) {
                        // Puzzle unlocked and started
                        var fillCount = crosswordInfo.fc;
                        var filled = inProgress[id].filled;
                        var percentCompleted = (filled / fillCount) * 100;
                        var tileWidth = 222;

                        yPos += 10;
                        var outerCircle = utilObj.getSprite(constantsObj.white_circle_150, tileWidth / 2, tileWidth / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_6);
                        utilObj.setColor(outerCircle,  constantsObj.COLOR_GREY_05);
                        //square.addChild(outerCircle, zOrder);
                        utilObj.addChild(square, outerCircle, zOrder);
                        var sprite = utilObj.getSprite(constantsObj.white_circle_150, tileWidth / 2, tileWidth / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_6);
                        var progressTimer = new cc.ProgressTimer(sprite);
                        progressTimer.setType(cc.ProgressTimer.TYPE_RADIAL);
                        progressTimer.setMidpoint(cc.p(0.5, 0.5));
                        progressTimer.setBarChangeRate(cc.p(1, 0));
                        utilObj.setColor(progressTimer, constantsObj.COLOR_GREEN_04);
                        if (id == gameLayer.crosswordDate) {
                            utilObj.setColor(progressTimer, constantsObj.COLOR_BLACK);
                        }
                        progressTimer.setPosition(222 / 2, 222 / 2);
                        progressTimer.setPercentage(percentCompleted);
                        progressTimer.setScale(constantsObj.SCALE_SPRITE_6, constantsObj.SCALE_SPRITE_6);
                        //square.addChild(progressTimer, zOrder + 1);
                        utilObj.addChild(square, progressTimer, zOrder + 1);
                        var innerCircle = utilObj.getSprite(constantsObj.white_circle_150, tileWidth / 2, tileWidth / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_14);
                        if (outer == true) {
                            utilObj.setColor(innerCircle, constantsObj.COLOR_SKY_BLUE_02);
                        }
                        //square.addChild(innerCircle, zOrder + 1);
                        utilObj.addChild(square, innerCircle, zOrder + 1);
                        yPos -= 10;
                        var timeTaken = utilObj.formatTime(inProgress[id].timeElapsed);
                        var labelTime = utilObj.getBMFontLabel(timeTaken, constantsObj.FONT_ROBOTO_BOLD_40, constantsObj.COLOR_BLACK,
                            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 111, 55, 0.5, 1, null, square, zOrder);
                        //square.addChild(labelTime, zOrder + 1);
                        utilObj.addChild(square, labelTime, zOrder + 1);
                        utilObj.setVisible(labelTime, false);
                        // loggerObj.debugLog("lelouch inProgress[id].isOpened is for ", inProgress[id].isOpened, typeof inProgress[id].isOpened, inProgress[id].isOpened == "true", id);

                        if (inProgress[id].isOpened == "true") {
                            utilObj.setVisible(labelTime, true);
                        }

                    } else if (score == 0 && crosswordInfo != null) {
                        var tileWidth = 222;
                        var outerCircle = utilObj.getSprite(constantsObj.white_circle_150, tileWidth / 2, tileWidth / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_6);
                        utilObj.setColor(outerCircle, constantsObj.COLOR_GREY_05);
                        utilObj.addChild(square, outerCircle, zOrder);

                        var innerCircle = utilObj.getSprite(constantsObj.white_circle_150, tileWidth / 2, tileWidth / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_14);
                        if (outer == true) {
                            utilObj.setColor(innerCircle, constantsObj.COLOR_SKY_BLUE_02);
                        }
                        //square.addChild(innerCircle, zOrder + 1);
                        utilObj.addChild(square, innerCircle, zOrder + 1);

                    } else if (score > 0) {
                        // Puzzle Completed
                        var xxPos = 10;
                        var yyPos = 20;
                        var masteryStars = scoresObj.getMastery(id);

                        var starColor = constantsObj.COLOR_BLUE_01;
                        var star1 = utilObj.getSprite(constantsObj.star_white_2, xxPos + 12, yyPos - 25 + 120, 0, 0.5, constantsObj.SCALE_SPRITE_9, null, square, zOrder, constantsObj.SPRITE_MISC);
                        utilObj.setColor(star1, starColor);
                        //square.addChild(star1, zOrder + 1);
                        utilObj.addChild(square, star1, zOrder + 1);
                        if (masteryStars < constantsObj.MASTERY_SILVER) {
                            starColor = constantsObj.COLOR_GREY_02;
                        }
                        var star2 = utilObj.getSprite(constantsObj.star_white_2, xxPos + 70, yyPos + 135, 0, 0.5, constantsObj.SCALE_SPRITE_6, null, square, zOrder, constantsObj.SPRITE_MISC);
                        utilObj.setColor(star2, starColor);
                        //square.addChild(star2, zOrder + 1);
                        utilObj.addChild(square, star2, zOrder + 1);
                        if (masteryStars < constantsObj.MASTERY_GOLD) {
                            starColor = constantsObj.COLOR_GREY_02;
                        }
                        var star3 = utilObj.getSprite(constantsObj.star_white_2, xxPos + 133, yyPos - 25 + 120, 0, 0.5, constantsObj.SCALE_SPRITE_9, null, square, zOrder, constantsObj.SPRITE_MISC);
                        utilObj.setColor(star3, starColor);
                        //square.addChild(star3, zOrder + 1);
                        utilObj.addChild(square, star3, zOrder + 1);
                        var timeTaken = utilObj.formatTime(score);
                        var labelTime = utilObj.getBMFontLabel(timeTaken, constantsObj.FONT_ROBOTO_BOLD_40, constantsObj.COLOR_BLACK,
                            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 111, 55, 0.5, 1, null, square, zOrder + 1);
                        //square.addChild(labelTime, zOrder + 1);
                        utilObj.addChild(square, labelTime, zOrder + 1);
                    }
                }

                var buttonAtCoins = utilObj.getButton(222, 222, 0.5, 1, xPos, yPos,
                    constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                        obj: 'packInfoLayer',
                        fn: 'loadPuzzle',
                        screen: screen,
                        params: {x: row, y: col, status: false, index: index, packType: constantsObj.BRITISH_PACKS},
                        track: {
                            k: constantsObj.TRACK_DIALOG,
                            p: gameObj.getCurPuzzleTracking(),
                            c: gameObj.getTrackingPuzzleTheme(),
                            o: constantsObj.TRACK_PACK_INFO,
                            f: constantsObj.TRACK_STORE,
                            g: "",
                            s: gameObj.getPuzzleSpeciesTracking(),
                            co: 1,
                            oppId: ""
                        },
                    }, false, ccui.Widget.PLIST_TEXTURE, 1);
                //packInfoLayer.addChild(buttonAtCoins, zOrder);
                utilObj.addChild(packInfoLayer, buttonAtCoins, zOrder);

                xPos += 222 + 40;
                number += 1;
            }
            xPos = centerXPos - 222 * 2 - 80;
            yPos -= 222 + 42;
        }

        if (NUM_ROWS == 2) {
            yPos -= 0;
        } else {
            yPos -= 50;
        }

        //check how many puzzles got completed
        var count = gameObj.getNumberOfPuzzlesCompletedInPack(index, constantsObj.BRITISH_PACKS);

        var colorOfProgressBar = constantsObj.COLOR_BLUE_PROGRESS_BAR;
        var showProgressBar2 = true;
        if (count == numPuzzlesInPack) {
            showProgressBar2 = false;
            colorOfProgressBar = constantsObj.COLOR_BUTTON_LIGHT_BLUE;
        }

        //show progress bar
        var progressBar = utilObj.getScale9Sprite(constantsObj.full_bar, centerXPos, yPos - 175, 0.5, 0.5, 800, 100);
        utilObj.setColor(progressBar, colorOfProgressBar);
        //packInfoLayer.addChild(progressBar, zOrder);
        utilObj.addChild(packInfoLayer, progressBar, zOrder);

        var lengthOfProgressBar2 = (800 / numPuzzlesInPack) * count;
        if (count > 0 && showProgressBar2 == true) {
            var progressBar2 = utilObj.getScale9Sprite(constantsObj.full_bar, centerXPos - 400, yPos - 175, 0, 0.5, lengthOfProgressBar2, 100);//, null,"", zOrder, constantsObj.SPRITE_MISC);
            utilObj.setColor(progressBar2, constantsObj.COLOR_BUTTON_LIGHT_BLUE);
            //packInfoLayer.addChild(progressBar2, zOrder);
            utilObj.addChild(packInfoLayer, progressBar2, zOrder);
        }

        var lbl2 = utilObj.getBMFontLabel(count + "/" + numPuzzlesInPack, constantsObj.FONT_ROBOTO_MEDIUM_60, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, yPos - 175, 0.5, 0.5, labelArr, packInfoLayer.unlockButton, zOrder);
        //packInfoLayer.addChild(lbl2, zOrder + 2);
        utilObj.addChild(packInfoLayer, lbl2, zOrder + 2);

        var progressBarCompletion = utilObj.getScale9Sprite(constantsObj.popup_bg, centerXPos + 450, yPos - 175, 0.5, 0.5, 190, 220);//, null,"", zOrder, constantsObj.SPRITE_MISC);
        utilObj.setColor(progressBarCompletion, constantsObj.COLOR_BLUE_PROGRESS_BAR_END);
        //packInfoLayer.addChild(progressBarCompletion, zOrder + 3);
        utilObj.addChild(packInfoLayer, progressBarCompletion, zOrder + 3);

        var coin = utilObj.getSprite(constantsObj.coin_png_2, centerXPos + 450, yPos - 130, 0.5, 0.5, constantsObj.SCALE_SPRITE_7, null, packInfoLayer, zOrder, constantsObj.SPRITE_MISC);
        //packInfoLayer.addChild(coin, zOrder + 3);
        utilObj.addChild(packInfoLayer, coin, zOrder + 3);

        var reward = gameObj.getRewardForPackOtherThenArchive(index, constantsObj.BRITISH_PACKS);

        var lbl1 = utilObj.getBMFontLabel(reward, constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos + 450, yPos - 240, 0.5, 0.5, labelArr, packInfoLayer.unlockButton, zOrder);
        //packInfoLayer.addChild(lbl1, zOrder + 3);
        utilObj.addChild(packInfoLayer, lbl1, zOrder + 3);

        utilObj.updateScreen(constantsObj.SCREEN_PACK_INFO_LAYER, packInfoLayer);
        packInfoLayer.setVisible(true);


        //check for is_pack complete.
        var reward = gameObj.getRewardForPackOtherThenArchive(index, constantsObj.BRITISH_PACKS);
        var numberOfPuzzleSolved = gameObj.getNumberOfPuzzlesCompletedInPack(index, constantsObj.BRITISH_PACKS);
        var packCompletionPopupShown = false;
        var isPackCompletionRewarded = gameObj.checkIfPackCompleteRewarded(index, constantsObj.BRITISH_PACKS);
        if (numberOfPuzzleSolved == numPuzzlesInPack) {
            if (isPackCompletionRewarded != true) {
                packCompletePopup.show(true, index, packInfoLayer.britPack);
                gameObj.setBritPacksComplete(index);
                economyObj.addCash(reward, constantsObj.TRACK_EARN, constantsObj.TRACK_BRIT_PACK_COMPLETE, stringsObj.puzzle_themes_brit_pack_Info[index]);
                utilObj.showMessage(reward + " coins have been rewarded");
            }
        }

        var curTimestamp1 = utilObj.getCurrentTimestamp();

        var timeSpentFromLastNotifPopup = curTimestamp1 - gameObj.getLastNotifPopupTimestamp();

        var isD1 = false;
        if (((curTimestamp1 - userObj.getCreated()) > 24 * constantsObj.SECONDS_IN_HOUR && (curTimestamp1 - userObj.getCreated()) < 48 * constantsObj.SECONDS_IN_HOUR)) {
            isD1 = true;
        }

        var isD0 = false;
        if (((curTimestamp1 - userObj.getCreated()) < 24 * constantsObj.SECONDS_IN_HOUR)) {
            isD0 = true;
        }

        if (!popupLayer.popupOpen && packCompletionPopupShown == false) {
            if (!gameObj.getNotifsEnabled() && gameObj.getOpenedFromOutro()) {
                if (isD0) {
                    if (!gameObj.getNotifPopupShownOnPackInfoScreen() && gameObj.getNotifPopupCount() < 2) {
                        gameObj.setNotifPopupShown(true);
                        gameObj.setNotifPopupShownOnPackInfoScreen(true);
                        gameObj.setLastNotifPopupTimeStamp(curTimestamp1);
                        notifPermissionPopup.show();
                        gameObj.setNotifPopupCount(gameObj.getNotifPopupCount() + 1);
                    }
                } else if (isD1 && !gameObj.getNotifPopupShownOnD1() && (gameObj.getNotifPopupCount() < constantsObj.MAX_NOTIF_LIMIT)) {
                    gameObj.setNotifPopupShown(true);
                    gameObj.setNotifPopupShownOnD1(true);
                    gameObj.setLastNotifPopupTimeStamp(curTimestamp1);
                    notifPermissionPopup.show();
                    gameObj.setNotifPopupCount(gameObj.getNotifPopupCount() + 1);
                } else if ((timeSpentFromLastNotifPopup > 48 * constantsObj.SECONDS_IN_HOUR) && (gameObj.getNotifPopupCount() < constantsObj.MAX_NOTIF_LIMIT)) {
                    gameObj.setNotifPopupShown(true);
                    gameObj.setLastNotifPopupTimeStamp(curTimestamp1);
                    notifPermissionPopup.show();
                    gameObj.setNotifPopupCount(gameObj.getNotifPopupCount() + 1);
                }
            }
        }

        var timeSpentFbLoginShown = curTimestamp1 - gameObj.getLastFbLoginShowTimestamp();
        var timeSpentRateUsShown = curTimestamp1 - gameObj.getLastRateUsShowTimestamp();
        var timeSpentInviteAndWinShown = curTimestamp1 - gameObj.getLastInviteAndWinShowTimestamp();
        var timeSpentFromLastInterstitial = curTimestamp1 - gameObj.getLastInterstitialTimestamp();
        var timeSpentFromLastNotifPopup = curTimestamp1 - gameObj.getLastNotifPopupTimestamp();
        // loggerObj.debugLog("Interstitial time ", timeSpentFromLastInterstitial);

        var isFirstSessionCalendar = gameObj.getIsFirstSessionCalendar();
        var isD1 = false;
        if (((curTimestamp1 - userObj.getCreated()) > 24 * constantsObj.SECONDS_IN_HOUR && (curTimestamp1 - userObj.getCreated()) < 48 * constantsObj.SECONDS_IN_HOUR)) {
            isD1 = true;
        }

        var isD0 = false;
        if (((curTimestamp1 - userObj.getCreated()) < 24 * constantsObj.SECONDS_IN_HOUR)) {
            isD0 = true;
        }


        // loggerObj.debugLog("djain triggering rateUs");
        // loggerObj.debugLog("triggering rateus", timeSpentRateUsShown, gameObj.getLastRatedVersion(), (utilObj.getCurrentTimestamp() - gameObj.getTimeStampForAutoDialogShown()), gameObj.getOpenedFromOutro(), isFirstSessionCalendar, ftueObj.isCalendarFtueShown());

        if (!popupLayer.popupOpen && packCompletionPopupShown == false) {
            if (runtimeObj.getForceUpdate() == 1) {
                utilObj.forceUpdate();
            } else if (!gameObj.getNotifsEnabled() && gameObj.getOpenedFromOutro() && utilObj.isIos()) {
                if (isD0) {
                    if (!gameObj.getNotifPopupShownOnCalendarScreen() && gameObj.getNotifPopupCount() < 2) {
                        gameObj.setNotifPopupShown(true);
                        gameObj.setNotifPopupShownOnCalendarScreen(true);
                        gameObj.setLastNotifPopupTimeStamp(curTimestamp1);
                        notifPermissionPopup.show();
                        gameObj.setNotifPopupCount(gameObj.getNotifPopupCount() + 1);
                    }
                } else if (isD1 && !gameObj.getNotifPopupShownOnD1() && (gameObj.getNotifPopupCount() < constantsObj.MAX_NOTIF_LIMIT)) {
                    gameObj.setNotifPopupShown(true);
                    gameObj.setNotifPopupShownOnD1(true);
                    gameObj.setLastNotifPopupTimeStamp(curTimestamp1);
                    notifPermissionPopup.show();
                    gameObj.setNotifPopupCount(gameObj.getNotifPopupCount() + 1);
                } else if ((timeSpentFromLastNotifPopup > 48 * constantsObj.SECONDS_IN_HOUR) && (gameObj.getNotifPopupCount() < constantsObj.MAX_NOTIF_LIMIT)) {
                    gameObj.setNotifPopupShown(true);
                    gameObj.setLastNotifPopupTimeStamp(curTimestamp1);
                    notifPermissionPopup.show();
                    gameObj.setNotifPopupCount(gameObj.getNotifPopupCount() + 1);
                }
            } else if (timeSpentRateUsShown > 48 * constantsObj.SECONDS_IN_HOUR /*&& gameObj.getLastRatedVersion() == 0*/ && (curTimestamp1 - gameObj.getTimeStampForAutoDialogShown()) > 4 * constantsObj.SECONDS_IN_MIN && gameObj.getOpenedFromOutro()) {

                rateUsPopup.show();
            } else if (fbWrapperObj.isLoggedIn() && timeSpentInviteAndWinShown > 24 * constantsObj.SECONDS_IN_HOUR && !gameObj.getIsRedraw() && (curTimestamp1 - gameObj.getTimeStampForAutoDialogShown()) > 4 * constantsObj.SECONDS_IN_MIN) {

                inviteAndWinPopup.show();

            } else if (!fbWrapperObj.isLoggedIn() && timeSpentFbLoginShown > 24 * constantsObj.SECONDS_IN_HOUR && !gameObj.getIsRedraw() && (curTimestamp1 - gameObj.getTimeStampForAutoDialogShown()) > 4 * constantsObj.SECONDS_IN_MIN) {

                fbConnectPopup.show();

            }
        }

        if (gameObj.getOpenedFromOutro()) {
            gameObj.setOpenedFromOutro(false);
        }

        if (gameObj.getIsRedraw()) {
            gameObj.setIsRedraw(false);
        }

        trackObj.trackCounter(constantsObj.TRACK_BRIT_PACK, "pack_view", "",
            "", "", gameObj.getPackStatus(index, constantsObj.BRITISH_PACKS), gameObj.getPuzzleSpeciesTracking(), "", "");
    },

    back: function () {
        // loggerObj.debugLog("check for the puzzle completed ",packInfoLayer.selectedPackId,gameObj.getNumberOfPuzzlesCompletedInPack(packInfoLayer.selectedPackId),packInfoLayer.showFeedback);
        if (utilObj.getCurrentTimestamp() - gameObj.getLeavePuzzlePopupTimestamp() >= 36 * constantsObj.SECONDS_IN_HOUR) {
            gameObj.setLeavePuzzlePopupShown(false);
        }

        // if (!gameObj.getLeavePuzzlePopupShown() && !packInfoLayer.showFeedback && !(gameObj.getNumberOfPuzzlesCompletedInPack(packInfoLayer.selectedPackId) == gameObj.getNumberOfPuzzlesInPack(packInfoLayer.selectedPackId)) && packInfoLayer.selectedPackId > 6) {
        //     leavePuzzlePopup.show(constantsObj.SCREEN_PACK_INFO_LAYER, false, true);
        //     gameObj.setLeavePuzzlePopupShown(true);
        //     gameObj.setLeavePuzzlePopupTimestamp(utilObj.getCurrentTimestamp());
        //     return;
        // }
        packInfoLayer.hide();
        utilObj.popCurScreen();
        var sc = utilObj.popCurScreen();
        if (sc == constantsObj.SCREEN_HOME) {
            homeLayer.show();
        } else {
            packsLayer.show();
        }
    },

    hide: function () {
        //utilObj.popCurScreen();
        packInfoLayer.removeAllChildren();
        packInfoLayer.setVisible(false);
    },

    settings: function () {
        settingsPopup.show(constantsObj.SCREEN_PACK_INFO_LAYER);
    },

    showStore: function () {
        packInfoLayer.hide();
        storeLayer.show();
    },

    unlock: function (params) {
        var packInfoLockStatus = gameObj.getPackInfoLockStatus();
        var packInfo = gameObj.getPackInfo();
        var purchasedPackInfo = gameObj.getPurchasedPackInfo();
        var packInfoArr = packInfo[params.index];
        var numOfPuzzlesInThisPack = packInfoArr.length;
        var costToUnlockThisPack = numOfPuzzlesInThisPack * (economyObj.getRevealCrosswordCost());
        if (params.index >= constantsObj.FREE_PACK_INDEX) {
            costToUnlockThisPack = gameObj.getCostForPackOtherThenArchive(params.index);
        }

        var spend = "spend";
        if (params.recommendation != null && params.recommendation == true) {
            spend = "recommendation";
        }
        if (economyObj.makePayment(null, null, constantsObj.PKG_CASH, costToUnlockThisPack, constantsObj.TRACK_PACK, spend, packInfoLayer)) {
            // for (var i = 0; i < numOfPuzzlesInThisPack; i++) {
            //     if (i == 0 && params.index > 6) {
            //         continue;
            //     }
            //     var puzzleId = packInfoArr[i] + "";
            //     gameObj.unlockPuzzle(puzzleId + "");
            // }
            if (params.index <= 6) {
                for (var i = 0; i < packInfoArr.length; i++) {
                    gameObj.unlockPuzzle(packInfoArr[i]);
                }
            }
            purchasedPackInfo[params.index] = packInfoArr;
            gameObj.setPurchasedPackInfo(purchasedPackInfo);
            packInfoLockStatus[params.index] = false;
            gameObj.setPackInfoLockStatus(packInfoLockStatus);
            gameObj.setLastBoughtPack(params.index);
            gameObj.makePacksInOrder(params.index, 0);
            gameObj.save();
            if (params.recommendation != null && params.recommendation == true) {

            }else {
                packInfoLayer.redraw(params.index);
            }
            trackObj.trackCounter(constantsObj.TRACK_PACK, "buy", stringsObj.puzzle_themes[params.index],
                "", "", gameObj.getPackStatus(params.index), gameObj.getPuzzleSpeciesTracking(), "", "");
        }

    },

    redraw: function (index) {
        //gameObj.setIsRedraw(true);
        packInfoLayer.hide();
        packInfoLayer.show(index, null, packInfoLayer.britPack);
    },

    watchAVideo: function () {

        var w2eFtueOpen = false;
        if (ftueObj.isW2EFtueShown()) {
            w2eFtueOpen = true;
            ftueObj.hideWatchToEarnFtue(true);
        }

        if (!utilObj.isOnline()) {
            utilObj.showMessage(stringsObj.not_online);
            return;
        }

        var coolDownPeriod = 7200;
        var curTimestamp1 = utilObj.getCurrentTimestamp();

        var firstVideoShownTimeStamp = gameObj.getFirstVideoSeenTimeStamp();
        if (firstVideoShownTimeStamp == null || (curTimestamp1 - firstVideoShownTimeStamp) > coolDownPeriod) {
            firstVideoShownTimeStamp = curTimestamp1;
            gameObj.setFirstVideoSeenTimeStamp(firstVideoShownTimeStamp);
            if (!(gameObj.isEligibleForVideoAchiement() && gameObj.getAchievementsState(43) == constantsObj.ACHIEVEMENT_IN_PROGRESS)) {
                gameObj.setNumVideos(0);
            }
        }

        var maxVideosAllowed = 5;
        if (gameObj.getIsPayer()) {
            maxVideosAllowed = runtimeObj.getNumVideosNew(2);
        } else {
            if ((curTimestamp1 - userObj.getCreated()) < 7 * constantsObj.SECONDS_IN_DAY) {
                maxVideosAllowed = runtimeObj.getNumVideosNew(0);
            } else {
                maxVideosAllowed = runtimeObj.getNumVideosNew(1);
            }
        }

        if (gameObj.isEligibleForVideoAchiement() && gameObj.getAchievementsState(43) == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
            maxVideosAllowed = 6;
        }

        if ((curTimestamp1 - firstVideoShownTimeStamp) < coolDownPeriod && gameObj.getNumVideos() < maxVideosAllowed) {
            if (gameObj.getDoNotShowW2e1Popup()) {
                if (adsObj.checkRewardedVideo(false, adsObj.setNotRewardedVideo, false)) {
                    adsObj.showVideoAd(false);
                    adsObj.setNotRewardedVideo(false);
                } else {
                    trackObj.trackCounter(constantsObj.TRACK_AD_TRACKING, constantsObj.TRACK_W2E, constantsObj.TRACK_RETRY, curScreen, "", "mopub", "", "", "");
                    // utilObj.showMessage("No Video Available. Please watch after some time");
                    if (w2eFtueOpen == true) {
                        utilObj.delayedCallback(gameLayer, gameLayer.showEarnFreeFtueInStore, 1.0, null, null);
                    }
                }
            } else {
                w2e1Popup.show();
            }
        } else {
            var timeRemaining = coolDownPeriod - (curTimestamp1 - firstVideoShownTimeStamp);
            var storeVideoVariant = epmObj.getChosenVariant(constantsObj.EXP_STORE_VIDEO_VIEWS);
            if (storeVideoVariant == constantsObj.EXP_VAR_1) {
                utilObj.showMessageAtTop("Next video in " + utilObj.formatTime(timeRemaining));
            } else {
                utilObj.showMessage("Next video in " + utilObj.formatTime(timeRemaining));
            }
            trackObj.trackCounter(constantsObj.TRACK_AD_MEDIATION, constantsObj.TRACK_W2E, "cooldown", curScreen, "", "", "", "", "");
            machineLearningDataObj.setVideoTriesCooldown();
            if (w2eFtueOpen == true) {
                utilObj.delayedCallback(gameLayer, gameLayer.showEarnFreeFtueInStore, 1.0, null, null);
            } else {
                gameLayer.showEarnFreeFtueInStore();
            }
            //var timeRemaining = coolDownPeriod - (utilObj.getCurrentTimestamp() - firstVideoShownTimeStamp);
            // w2e2Popup.show(utilObj.formatTime(timeRemaining));
        }
    },

    showEarnFreeFtueInStore: function () {
        gameLayer.showStore();
        gameLayer.showEarnFreeFtue();
    },

    showEarnFreeFtue: function () {
        storeLayer.showEarnFreeFtue(constantsObj.SCREEN_PACK_INFO_LAYER);
    },

    loadPuzzle: function (params) {
        var index = params.index;
        var isBritMini = false;
        if (params.packType != undefined && params.packType == constantsObj.BRITISH_PACKS) {
            isBritMini = true;
        }
        var packInfo = {};
        if (isBritMini) {
            packInfo = gameObj.getBritPurchasedPackInfo();
        } else {
            packInfo = gameObj.getPackInfo();
        }

        var arr = packInfo[index];
        var x = params.x;
        var y = params.y;
        var t = x * 5 + y;
        var date = arr[t];
        var score = scoresObj.getHighScore(date + "");
        //replay case
        if (score > 0) {
            gameObj.setReplay(true);
        }
        if (!isBritMini) {
            if (params.status == true && index < 7) {
                utilObj.showMessage("Purchase the Pack to unlock the puzzle");
                return;
            }
            if (params.status == true && (t != 0)) {
                utilObj.showMessage("Purchase the Pack to unlock the puzzle");
                return;
            }
        }
        packInfoLayer.hide();
        gameLayer.show(date + "", true);
        if (isBritMini) {
            trackObj.trackCounter(constantsObj.TRACK_BRIT_PACK, "puzzle_play", "",
                "", "", gameObj.getPackStatus(params.index, constantsObj.BRITISH_PACKS), gameObj.getPuzzleSpeciesTracking(), "", "");
        } else {
            trackObj.trackCounter(constantsObj.TRACK_PACK, "puzzle_play", stringsObj.puzzle_themes[index],
                "", "", gameObj.getPackStatus(params.index), gameObj.getPuzzleSpeciesTracking(), "", "");
        }
    },

    showAchievementReminder: function () {
        var zOrder = constantsObj.UI_Z_ORDER;
        packInfoLayer.transBg = utilObj.getScale9Sprite(constantsObj.black_80, xLeftPos, 0, 0, 0, canvasWidth, constantsObj.DESIGN_HEIGHT);
        utilObj.addChild(packInfoLayer, packInfoLayer.transBg, zOrder + 1);
        packInfoLayer.achivementReminderVisible = true;

    },

    removeReminder: function () {
        // loggerObj.debugLog("djain hitting touchEnded2");
        if (packInfoLayer.achivementReminderVisible == true) {
            packInfoLayer.achivementReminderVisible = false;
            utilObj.removeChild(packInfoLayer, packInfoLayer.transBg);
            return true;
        }
    }

});

