var PacksLayer = cc.Layer.extend({
    screen: null,
    listView: null,
    listView1: null,
    listView2: null,
    listView3: null,
    cashLbl: null,
    sections: null,
    masteryLbl: null,
    bottomNavBg: null,
    homeButtonBg: null,
    countList1: 0,
    countList2: 0,
    countList3: 0,
    notifPackSet: false,

    show: function () {
        var screen = constantsObj.SCREEN_PACK_LAYER;
        packsLayer.screen = screen;
        var screenName = utilObj.getScreenName(screen);
        utilObj.updateScreenBegin(screen);
        adWallObj.setAdWallLastScreen(constantsObj.SCREEN_PACK_LAYER);
        gameObj.setIdForTodaysPuzzle(utilObj.getIdForDate(gameObj.getTodaysPuzzleDate()));
        packsLayer.notifPackSet = false;

        achievementsObj.checkForAchievements();

        var spriteArr = [];
        var labelArr = [];
        var zOrder = constantsObj.UI_Z_ORDER;
        var layoutExperimentVariant = epmObj.getChosenVariant(constantsObj.EXP_LAYOUT);

        var xPos = centerXPos;
        var yPos = constantsObj.DESIGN_HEIGHT;

        var background = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos, 0.5, 1, canvasWidth, constantsObj.DESIGN_HEIGHT);
        if (layoutExperimentVariant == constantsObj.EXP_VAR_CONTROL) {
            background.setColor(constantsObj.COLOR_BLACK);
        } else {
            background.setColor(constantsObj.COLOR_WHITE_01);
        }

        utilObj.addChild(packsLayer, background, zOrder - 1);

        if (homeLayoutExpNew == constantsObj.EXP_VAR_CONTROL) {
            var bannerbg = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos + topBarOffset, 0.5, 1, canvasWidth, 226 + topBarOffset);
            bannerbg.setColor(constantsObj.COLOR_TOP_BAR);
            if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                bannerbg.setColor(constantsObj.COLOR_WHITE);
            }

            utilObj.addChild(packsLayer, bannerbg, zOrder);

            if (utilObj.isIos()) {
                var adBanner = constantsObj.ad_banner_place_holder;
                packsLayer.header = utilObj.getSprite(adBanner, centerXPos, yPos - 50, 0.5, 1, constantsObj.SCALE_SPRITE_6 * 3 / 2, spriteArr, packsLayer, zOrder, constantsObj.SPRITE_MISC);
            } else {
                var adBanner = constantsObj.header_logo;
                packsLayer.header = utilObj.getSprite(adBanner, centerXPos - 330 * canvasWidth / 1440, yPos - 50 + topBarOffset / 2, 0.5, 1, constantsObj.SCALE_SPRITE_10 * 3 / 2, spriteArr, packsLayer, zOrder, constantsObj.SPRITE_MISC);
            }
        } else {
            // banner image on top
            utilObj.getSprite(constantsObj.banner_bg, centerXPos, yPos - 226, 0.5, 0, constantsObj.SCALE_ONE * 2, spriteArr, packsLayer, zOrder, constantsObj.SPRITE_LOCAL);

            // game title text
            var dtcText = utilObj.getBMFontLabel(stringsObj.DTC_full_form_caps, constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, yPos - 196, 0.5, 0, labelArr, packsLayer, zOrder + 1);
            utilObj.setOpacity(dtcText, constantsObj.OPACITY_40);
            //
        }

        //header 2 start
        yPos -= 226;
        var localYPos = yPos - 70;
        var tab = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos, 0.5, 1, canvasWidth, 140, spriteArr, packsLayer, zOrder, constantsObj.SPRITE_MISC);
        tab.setColor(constantsObj.COLOR_DARK_BLUE_01);
        xPos = xRightPos - 30;
        var textColor = constantsObj.COLOR_WHITE;
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            textColor = constantsObj.COLOR_BLACK;
            tab.setColor(constantsObj.COLOR_WHITE);
        }

        var msg = utilObj.getSprite(constantsObj.setting_icon, xRightPos - 70, localYPos, 1, 0.5, constantsObj.SCALE_SPRITE_14 * 1.5, spriteArr, packsLayer, zOrder, constantsObj.SPRITE_MISC);
        if (layoutExperimentVariant != constantsObj.EXP_VAR_CONTROL) {
            msg.setColor(constantsObj.COLOR_WHITE);
        }
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            msg.setColor(constantsObj.COLOR_BLACK);
        }
        var settingsButton = utilObj.getButton(123, 200, 1, 0.5, xRightPos - 50, localYPos,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'packsLayer',
                fn: 'settings',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_HOME,
                    f: constantsObj.TRACK_SETTINGS,
                    g: screen,
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE);
        //packsLayer.addChild(settingsButton, zOrder + 1);
        utilObj.addChild(packsLayer, settingsButton, zOrder + 1);


        xPos = xRightPos - 30;
        var xShiftTemp = 200;

        var coinBg = utilObj.getScale9Sprite(constantsObj.tile_white_curved, xPos - (350 + xShiftTemp), localYPos, 0, 0.5, 320, 80, spriteArr,
            packsLayer, zOrder, constantsObj.SPRITE_MISC);
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            coinBg.setColor(constantsObj.COLOR_GREY);
        }
        //coinBg.setOpacity(constantsObj.OPACITY_10);
        var coinImg = utilObj.getSprite(constantsObj.coin_png_2, xPos - (350 + xShiftTemp), localYPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, packsLayer, zOrder, constantsObj.SPRITE_MISC);
        var coinCount = economyObj.getCash();
        var font = constantsObj.FONT_ROBOTO_REGULAR_60;
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            font = constantsObj.FONT_HELVETICA_60;
        }
        packsLayer.cashLbl = utilObj.getBMFontLabel(coinCount + "", font, textColor,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - (210 + xShiftTemp), localYPos, 0.5, 0.5, labelArr, packsLayer, zOrder);
        var plusImg = utilObj.getSprite(constantsObj.green_plus, xPos - (100 + xShiftTemp), localYPos, 0, 0.5, constantsObj.SCALE_SPRITE_1, spriteArr, packsLayer, zOrder, constantsObj.SPRITE_MISC);
        var childArr = [coinImg, plusImg];
        var buttonAtCoins = utilObj.getButton(450, 180, 0, 0.5, xPos - (420 + xShiftTemp), localYPos,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'packsLayer',
                fn: 'showStore',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_HOME,
                    f: constantsObj.TRACK_STORE,
                    g: "",
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
                child: childArr,
                feedBackType: constantsObj.ZOOMIN_FEEDBACK
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        //packsLayer.addChild(buttonAtCoins, zOrder);
        utilObj.addChild(packsLayer, buttonAtCoins, zOrder);

        //mastery display on home screen
        var starCount = gameObj.getMastery1();
        xPos = xLeftPos + 100;

        var xPosShift1 = 0;
        var xWidth = 0;
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            xPosShift1 = 10;
            xWidth = 100;
        }
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            var starBg = utilObj.getScale9Sprite(constantsObj.tile_white_curved, xPos + 210, yPos - 70, 0, 0.5, 250 + xWidth, 80, spriteArr,
                packsLayer, zOrder, constantsObj.SPRITE_MISC);
            starBg.setColor(constantsObj.COLOR_GREY);
        }

        var star = utilObj.getSprite(constantsObj.star_white_2, xPos + 160 + xPosShift1, yPos - 65, 0, 0.5, constantsObj.SCALE_SPRITE_1, spriteArr, packsLayer, zOrder, constantsObj.SPRITE_MISC);
        star.setColor(constantsObj.COLOR_BLUE_01);

        var numberOfPuzzleSolved = gameObj.getNumberOfPuzzlesCompletedInPack(7);
        var numPuzzlesInPack = gameObj.getNumberOfPuzzlesInPack(7);
        if (numberOfPuzzleSolved == numPuzzlesInPack) {
            gameObj.makePacksInOrder(7, 1);
        }
        var xOffset = 0;
        var offsetForMessageCenter = 90;
        if (starCount > 999) {
            xOffset = 30;
            offsetForMessageCenter = 240;
        } else if (starCount > 99) {
            xOffset = 20;
            offsetForMessageCenter = 190;
        } else if (starCount > 9) {
            xOffset = 10;
            offsetForMessageCenter = 150;
        }
        var font1 = constantsObj.FONT_ROBOTO_REGULAR_70;
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            font1 = constantsObj.FONT_HELVETICA_60;
        }
        packsLayer.masteryLbl = utilObj.getBMFontLabel(starCount + "", font1, textColor,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 300 + xWidth / 2 + xOffset, yPos - 70, 0, 0.5, labelArr, packsLayer, zOrder);


        xPos = xLeftPos - 60;
        var iconNewMsg = constantsObj.message_icon;
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            iconNewMsg = constantsObj.messenger_icon_new;
        }

        if (layoutExperimentVariant == constantsObj.EXP_VAR_3) {
            if (subscriptionsDTCObj.getIsSubscriptionActive()) {
                var diamond = utilObj.getSprite(constantsObj.diamond, xLeftPos + (100 * canvasWidth / 1440), localYPos - 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_8, spriteArr, packsLayer, zOrder, constantsObj.SPRITE_MISC);
                //Shain Animation
                var ftueCondition = ftueObj.isFtueShown() && ftueObj.isAchievementFtueShown() && !gameObj.getPackFtueVisible() && !gameObj.getdailyMiniFtueVisible();
                if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                    ftueCondition = homeObj.checkFtueConditions();
                }
                if (ftueCondition) {
                    var xPos = diamond.getPositionX();
                    var yPos1 = diamond.getPositionY();
                    var width = diamond.getContentSize().width * constantsObj.SCALE_SPRITE_8/* / (constantsObj.SCALE_SPRITE_9 * 1.5)*/;
                    var height = diamond.getContentSize().height * constantsObj.SCALE_SPRITE_8/* / (constantsObj.SCALE_SPRITE_9 * 1.5)*/;

                    var xBottom = xPos - width / 2;
                    var xTop = xPos + width / 2;
                    var yLeft = yPos1 - height / 2;
                    var yRight = yPos1 + height / 2;

                    var posArr = [{x: xPos + width / 4, y: yRight}, {
                        x: xPos,
                        y: yLeft - 5
                    }, {x: xPos, y: yRight}, {x: xBottom, y: yPos1}, {x: xPos + width / 4, y: yRight}, {x: xBottom, y: yPos1}, {x: xPos + width / 4, y: yRight}, {x: xPos, y: yRight}];
                    var shainSpriteArr = [];

                    for (var i in posArr) {
                        var shainSprite = utilObj.getSprite(constantsObj.shain, posArr[i].x, posArr[i].y, 0.5, 0.5, constantsObj.SCALE_SPRITE_10, null, null, constantsObj.FTUE_Z_ORDER + 2, constantsObj.SPRITE_MISC);
                        utilObj.addChild(packsLayer, shainSprite, constantsObj.FTUE_Z_ORDER + 2);
                        utilObj.setScale(shainSprite, 0);
                        shainSpriteArr.push(shainSprite);
                        subscriptionsLaunchLayer.spritesArrToRemove.push(shainSprite);
                    }

                    utilObj.delayedCallback(packsLayer, animObj.addShainAnimationHome, 0.02, {arr: shainSpriteArr, screen: packsLayer});
                }

                childArr = [diamond];
                // var diamondSprite = utilObj.getSprite(constantsObj.diamond, xPos, yPos1, 0.5, 0.5, constantsObj.SCALE_SPRITE_8, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_MISC);
                // animObj.animateImage(diamondSprite, 0.5, 2.0);
                var subsButton = utilObj.getButton(140, 140, 0, 0.5,
                    xLeftPos + (40 * canvasWidth / 1440), localYPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                        obj: 'packsLayer',
                        fn: 'showSubsDailyStatus',
                        screen: packsLayer.screen,
                        // buttonBg: gameLayer.bg,
                        track: {
                            k: constantsObj.TRACK_PUZZLE,
                            p: gameObj.getCurPuzzleTracking(),
                            c: gameObj.getTrackingPuzzleTheme(),
                            o: constantsObj.TRACK_HOME,
                            f: constantsObj.TRACK_DIAMOND,
                            g: "",
                            s: "",
                            co: 1,
                            oppId: ""
                        },
                        child: childArr,
                        feedBackType: constantsObj.ZOOMIN_FEEDBACK
                    }, false, ccui.Widget.PLIST_TEXTURE, constantsObj.SCALE_ONE);
                utilObj.addChild(packsLayer, subsButton, zOrder);
            } else if (subscriptionsObj.getSubPkgId() != "" && subscriptionsObj.getSubPkgId() != null && subscriptionsDTCObj.getIsSubscriptionInActive()) {
                var diamond = utilObj.getSprite(constantsObj.diamond_grey, xLeftPos + (100 * canvasWidth / 1440), localYPos - 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_8, spriteArr, packsLayer, zOrder, constantsObj.SPRITE_MISC);
                childArr = [diamond];
                var subsButton = utilObj.getButton(140, 140, 0, 0.5,
                    xLeftPos + (40 * canvasWidth / 1440), localYPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                        obj: 'packsLayer',
                        fn: 'showSubsPopupOffer',
                        screen: packsLayer.screen,
                        // buttonBg: gameLayer.bg,
                        track: {
                            k: constantsObj.TRACK_PUZZLE,
                            p: gameObj.getCurPuzzleTracking(),
                            c: gameObj.getTrackingPuzzleTheme(),
                            o: constantsObj.TRACK_HOME,
                            f: constantsObj.TRACK_DIAMOND_GREY,
                            g: "",
                            s: "",
                            co: 1,
                            oppId: ""
                        },
                        child: childArr,
                        feedBackType: constantsObj.ZOOMIN_FEEDBACK
                    }, false, ccui.Widget.PLIST_TEXTURE, constantsObj.SCALE_ONE);
                utilObj.addChild(packsLayer, subsButton, zOrder);
            }else {
                packsLayer.msgIcon = utilObj.getSprite(iconNewMsg, xLeftPos + (40 * canvasWidth / 1440), localYPos - 2, 0, 0.5, constantsObj.SCALE_SPRITE_11, spriteArr, packsLayer, zOrder, constantsObj.SPRITE_MISC);
                if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                    packsLayer.msgIcon.setColor(constantsObj.COLOR_BLACK);
                }
                childArr = [packsLayer.msgIcon];
                var msgButton = utilObj.getButton(140, 140, 0, 0.5,
                    xLeftPos + (40 * canvasWidth / 1440), localYPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                        obj: 'packsLayer',
                        fn: 'showMsgCenter',
                        screen: packsLayer.screen,
                        // buttonBg: gameLayer.bg,
                        track: {
                            k: constantsObj.TRACK_PUZZLE,
                            p: gameObj.getCurPuzzleTracking(),
                            c: gameObj.getTrackingPuzzleTheme(),
                            o: constantsObj.TRACK_HOME,
                            f: constantsObj.TRACK_MSG,
                            g: "",
                            s: "",
                            co: 1,
                            oppId: ""
                        },
                        child: childArr,
                        feedBackType: constantsObj.ZOOMIN_FEEDBACK
                    }, false, ccui.Widget.PLIST_TEXTURE, constantsObj.SCALE_ONE);
                //homeLayer.addChild(msgButton, zOrder + 1);
                utilObj.addChild(packsLayer, msgButton, zOrder);
            }
        }
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            var line_grey = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, yPos - 140, 0.5, 1, canvasWidth, 5, spriteArr, packsLayer, zOrder, constantsObj.SPRITE_MISC);
            line_grey.setColor(constantsObj.COLOR_GREY_HS);
            yPos -= 5;
        }
        var heightOfBottomNav = 235;
        if(homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2){
            heightOfBottomNav = 175;
        }

        packsLayer.bottomNavBg = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, 0, 0.5, 0, canvasWidth, heightOfBottomNav + constantsObj.BOTTOM_BAR_OFFSET, null, packsLayer, zOrder + 1, constantsObj.SPRITE_MISC);
        utilObj.addChild(packsLayer, packsLayer.bottomNavBg, constantsObj.UI_Z_ORDER + 1);
        if (homeLayoutExpNew != constantsObj.EXP_VAR_1 && homeLayoutExpNew != constantsObj.EXP_VAR_2) {
            utilObj.setColor(packsLayer.bottomNavBg, constantsObj.COLOR_TOP_BAR);
        } else {
            // adding line in the bottom bar nav bar
            var line_grey = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, heightOfBottomNav + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0, canvasWidth, 5, null, packsLayer, zOrder + 1, constantsObj.SPRITE_MISC );
            utilObj.setColor(line_grey, constantsObj.COLOR_GREY_HS);
            utilObj.addChild(packsLayer, line_grey, constantsObj.UI_Z_ORDER + 1);

        }

        // packsLayer.addBottomNavOptions();

        localYPos -= 64;
        localYPos -= 44;
        var checkInteractionWithPack = gameObj.checkInteractionWithPack(constantsObj.INTRODUCING_MINIS);
        packsLayer.listView = new ccui.ListView();
        packsLayer.listView.setDirection(ccui.ScrollView.DIR_HORIZONTAL);
        packsLayer.listView.setTouchEnabled(true);
        packsLayer.listView.setBounceEnabled(true);
        packsLayer.listView.setContentSize(cc.size(canvasWidth, 550));
        packsLayer.listView.setPosition(20, yPos - 864 + 210 + 140 + 240);
        packsLayer.listView.setItemsMargin(80);
        //packsLayer.listView.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
        packsLayer.listView.setAnchorPoint(0, 1);
        packsLayer.listView.setBackGroundColor(constantsObj.COLOR_WHITE);

        //packsLayer.addChild(packsLayer.listView, zOrder + 1);
        utilObj.addChild(packsLayer, packsLayer.listView, zOrder + 1);
        packsLayer.countList1 = 0;
        packsLayer.populatePacks(1);


        if (gameObj.getMyPackToInprogress()) {
            utilObj.getBMFontLabel(stringsObj.IN_PROGRESS, constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xLeftPos + 50, localYPos, 0, 1.0, labelArr, packsLayer, zOrder + 1);
        } else {
            utilObj.getBMFontLabel(stringsObj.MY_PACKS, constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xLeftPos + 50, localYPos, 0, 1.0, labelArr, packsLayer, zOrder + 1);
        }

        localYPos -= 580;
        var divider = utilObj.getScale9Sprite(constantsObj.tile_white, xLeftPos, localYPos , 0, 0.5, canvasWidth - 40, 2);//, null,"", zOrder, constantsObj.SPRITE_MISC);
        divider.setColor(constantsObj.COLOR_WHITE_01);

        utilObj.addChild(packsLayer, divider, zOrder + 1);

        localYPos -= 64;
        var moreMiniPack;
        packsLayer.countList2 = 0;
        utilObj.getBMFontLabel(stringsObj.CALENDAR_COLLECTIONS, constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xLeftPos + 50, localYPos, 0, 1.0, labelArr, packsLayer, zOrder + 1);

        packsLayer.listView1 = new ccui.ListView();
        packsLayer.listView1.setDirection(ccui.ScrollView.DIR_HORIZONTAL);
        packsLayer.listView1.setTouchEnabled(true);
        packsLayer.listView1.setBounceEnabled(true);
        packsLayer.listView1.setContentSize(cc.size(canvasWidth, 500));
        packsLayer.listView1.setPosition(20, yPos - 864 + 210 + 140 - 600 + 200);
        packsLayer.listView1.setItemsMargin(80);
        //packsLayer.listView.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
        packsLayer.listView1.setAnchorPoint(0, 1);
        packsLayer.listView1.setBackGroundColor(constantsObj.COLOR_WHITE);

        //packsLayer.addChild(packsLayer.listView1, zOrder + 1);
        utilObj.addChild(packsLayer, packsLayer.listView1, zOrder + 1);
        packsLayer.populatePacks(2);


        localYPos -= 600
        var divider = utilObj.getScale9Sprite(constantsObj.tile_white, xLeftPos, localYPos, 0, 0.5, canvasWidth - 40, 2);//, null,"", zOrder, constantsObj.SPRITE_MISC);
        divider.setColor(constantsObj.COLOR_WHITE_01);

        utilObj.addChild(packsLayer, divider, zOrder + 1);

        localYPos -= 64;
        var calendarCollection;
        packsLayer.countList3 = 0;
        utilObj.getBMFontLabel(stringsObj.BONUS_PACKS, constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xLeftPos + 50, localYPos, 0, 1.0, labelArr, packsLayer, zOrder + 1);

        packsLayer.listView2 = new ccui.ListView();
        packsLayer.listView2.setDirection(ccui.ScrollView.DIR_HORIZONTAL);
        packsLayer.listView2.setTouchEnabled(true);
        packsLayer.listView2.setBounceEnabled(true);
        packsLayer.listView2.setContentSize(cc.size(canvasWidth, 500));
        packsLayer.listView2.setPosition(20, yPos - 864 + 210 + 140 - 1200 + 150);
        packsLayer.listView2.setItemsMargin(80);
        //packsLayer.listView.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
        packsLayer.listView2.setAnchorPoint(0, 1);
        packsLayer.listView2.setBackGroundColor(constantsObj.COLOR_WHITE);

        utilObj.addChild(packsLayer, packsLayer.listView2, zOrder + 1);
        packsLayer.populatePacks(3);
        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);

        utilObj.updateScreen(constantsObj.SCREEN_PACK_LAYER, packsLayer);
        uiCreatorObj.checkAndCreateUIElements(curScreen , heightOfBottomNav + constantsObj.BOTTOM_BAR_OFFSET);

        var isFirstSession = gameObj.getIsFirstSession();

        if (gameObj.getIsRedraw()) {
            gameObj.setIsRedraw(false);
        }

        if (gameObj.isEligibleForStarterPack1() || gameObj.isEligibleForStarterPack2()) {
            if (gameObj.isEligibleForStarterPack2()) {
                if (utilObj.getCurrentTimestamp() - gameObj.getTimeStampStarterPopup() > 3 * constantsObj.SECONDS_IN_DAY && gameObj.getNumStarterPack2() < 2) {
                    if (gameObj.getTimeStampStarterPopup() != 0) {
                        var countStarterPackPopup = gameObj.getStarterPackPopupShownCount();
                        if (countStarterPackPopup < 2) {
                            gameObj.setStarterPackPopupShownCount(countStarterPackPopup + 1);
                            starterPackPopup.show();
                            gameObj.setNumStarterPack2(gameObj.getNumStarterPack2() + 1);
                            machineLearningDataObj.incNumAutoPopupsShown();
                        }
                    }
                }
            } else if ((utilObj.getCurrentTimestamp() - gameObj.getTimeStampStarterPopup() > 15 * constantsObj.SECONDS_IN_MIN)) {
                if (gameObj.getTimeStampStarterPopup() != 0) {
                    var countStarterPackPopup = gameObj.getStarterPackPopupShownCount();
                    if (countStarterPackPopup < 2) {
                        gameObj.setStarterPackPopupShownCount(countStarterPackPopup + 1)
                        starterPackPopup.show();
                        machineLearningDataObj.incNumAutoPopupsShown();
                    }
                }
            }
        }
        utilObj.showBannerAd(utilObj.getScreenName(constantsObj.SCREEN_PACK_LAYER));
    },

    populatePacks: function (listNum) {
        var orderingArrOfPacks = gameObj.getOrderingOfPacks();
        // loggerObj.debugLog("current ordering of packs", utilObj.getStringifiedJson(orderingArrOfPacks), listNum);
        var packInfo = gameObj.getPackInfo();
        var britPackInfo = gameObj.getBritPurchasedPackInfo();
        var layoutExperimentVariant = epmObj.getChosenVariant(constantsObj.EXP_LAYOUT);
        var rowOneList = [];
        var rowBritList = [];
        var rowBritListCompleted = [];

        var listItems = [{
            headerColor: (layoutExperimentVariant == constantsObj.EXP_VAR_CONTROL) ? constantsObj.COLOR_GREEN : constantsObj.COLOR_BLUE_04,
            headerLine: constantsObj.COLOR_GREEN_LINE,
            headerText: stringsObj.PACKS,
            fn: "loadPackInfo",
            trackF: constantsObj.TRACK_PACK,
            section: [],
            extraYOffset: 0
        }];

        var initialPackInfo = gameObj.getInitialPackInfo();
        for (var j = 0; j < constantsObj.NUM_PACKS; j++) {
            if (orderingArrOfPacks[j] == constantsObj.STARTER_PACK_MINIS && gameObj.getIsStarterPackUnlocked() == false) {
                continue;
            }
            // loggerObj.debugLog("ijk Populating List 1", orderingArrOfPacks[j], j);
            //var packArr = packInfo[orderingArrOfPacks[j]];
            var packLockStatus = gameObj.getPackInfoLockStatus();
            if (packLockStatus[orderingArrOfPacks[j]] == undefined) {
                packLockStatus[orderingArrOfPacks[j]] = initialPackInfo.packInfoLockStatusFinal1[orderingArrOfPacks[j]];
                //lockedPack = false;
                // loggerObj.debugLog("pushing pack locked status:", initialPackInfo.packInfoLockStatusFinal1[orderingArrOfPacks[j]]);
                gameObj.setPackInfoLockStatus(packLockStatus);
            }
            var lockedPack = packLockStatus[orderingArrOfPacks[j]];

            //check for number of puzzles completed
            var packArr = packInfo[orderingArrOfPacks[j]];
            //var lockStatus = gameObj.getPackInfoLockStatus();
            var mid = orderingArrOfPacks[j] - 7;
            var firstFreePuzzleId = "00000" + mid + "01";
            // loggerObj.debugLog("FIRSTFREEPUZZLEID", firstFreePuzzleId);

            //var crosswordInfo = gameObj.getCrosswordForDate(packArr[0]);
            var inProgress = gameObj.getInProgress();
            var hasUserInteractedWithPack = false;
            if (inProgress[firstFreePuzzleId] != undefined && (orderingArrOfPacks[j] > 6)) {
                hasUserInteractedWithPack = (inProgress[firstFreePuzzleId].timeElapsed > 0) ? true : false;
            }

            if (hasUserInteractedWithPack) {
                gameObj.setUserPackInteraction(true);
            }

            //user has completed the puzzle
            var score = scoresObj.getHighScore(firstFreePuzzleId);
            if (score > 0) {
                hasUserInteractedWithPack = true;
            }

            var numberOfPuzzleSolved = 0;
            for (var i = 0; i < packArr.length; i++) {
                var crossWord = packArr[i];
                var score = scoresObj.getHighScore(crossWord);
                if (score > 0) {
                    numberOfPuzzleSolved++;
                }
            }
            var packComplete = (numberOfPuzzleSolved == packArr.length && packArr.length != 0) ? true : false;
            if (listNum == 2 && orderingArrOfPacks[j] >= 7) {
                continue;
            }
            if (listNum == 3 && orderingArrOfPacks[j] < 7) {
                continue;
            }
            // loggerObj.debugLog("ijk Populating List 1 before adding to list1", orderingArrOfPacks[j], j, listNum, lockedPack, hasUserInteractedWithPack, packComplete);
            if (packArr.length == 0) {
                continue;
            }
            var itemForPacks = packsLayer.createListElementForPacks(listItems[0], orderingArrOfPacks[j], listNum);
            loggerObj.debugLog("check for the items for packs ", listNum, orderingArrOfPacks[j], lockedPack, hasUserInteractedWithPack, packComplete);
            if (listNum == 3 && lockedPack && !hasUserInteractedWithPack && packComplete == false) {
                //packsLayer.listView2.addChild(itemForPacks);
                utilObj.addChild(packsLayer.listView2, itemForPacks);
                // loggerObj.debugLog("ijk Populating List 3 k", orderingArrOfPacks[j], j);
            } else if (listNum == 2 && lockedPack && packComplete == false) {
                // loggerObj.debugLog("ijk Populating List 2 k", orderingArrOfPacks[j], j);
                //packsLayer.listView1.addChild(itemForPacks);
                utilObj.addChild(packsLayer.listView1, itemForPacks);
            } else if ((listNum == 1 && (lockedPack == false || hasUserInteractedWithPack))) {
                // loggerObj.debugLog("ijk Populating List 1 k", orderingArrOfPacks[j], j);
                //packsLayer.listView.addChild(itemForPacks);
                rowOneList.push(itemForPacks);
                // utilObj.addChild(packsLayer.listView, itemForPacks);
            }
        }

        /**
         * condition to check whether brit pack eligibility
         */
        if (gameObj.shouldSurfaceBritPack(constantsObj.SCREEN_PACK_LAYER)) {
            /**
             * populating brit pack data
             */
            for (var j = 0; j < constantsObj.NUM_BRIT_PACKS; j++) {
                var orderingArrOfBritPack = gameObj.getOrderingOfBritPacks();
                var packId = orderingArrOfBritPack[j];
                var britPackCompleted = gameObj.checkIfPackComplete(packId, constantsObj.BRITISH_PACKS);
                if (listNum == 1) {
                    var itemForPacks = packsLayer.createListElementForBritPacks(listItems[0], orderingArrOfBritPack[j], listNum);
                    if (britPackCompleted) {
                        rowBritListCompleted.push(itemForPacks);
                    } else {
                        rowBritList.push(itemForPacks);
                    }
                }
            }
        }

        var j = rowOneList.length - 1;
        var k = rowBritList.length - 1;
        var count = 1;
        /**
         * populating brit pack data at every 3rd index in first row
         */
        for (var i = 0; i <= j + k + 1; i++) {
            if (count % 3 == 0 && k >= 0) {
                utilObj.addChild(packsLayer.listView, rowBritList[k]);
                k--;
                i--;
            } else {
                if (i < rowOneList.length) {
                    utilObj.addChild(packsLayer.listView, rowOneList[i]);
                }  else {
                    utilObj.addChild(packsLayer.listView, rowBritList[k]);
                    k--;
                }
            }
            count++;
        }

        /**
         * populating brit completed pack data at the end of first row
         */
        for (var i = 0; i < rowBritListCompleted.length; i++) {
            utilObj.addChild(packsLayer.listView, rowBritListCompleted[i]);
        }
    },

    populatePacks1: function (listNum) {
        var orderingArrOfPacks = gameObj.getOrderingOfPacks();
        var packInfo = gameObj.getPackInfo();
        var layoutExperimentVariant = epmObj.getChosenVariant(constantsObj.EXP_LAYOUT);

        var listItems = [{
            headerColor: (layoutExperimentVariant == constantsObj.EXP_VAR_CONTROL) ? constantsObj.COLOR_GREEN : constantsObj.COLOR_BLUE_04,
            headerLine: constantsObj.COLOR_GREEN_LINE,
            headerText: stringsObj.PACKS,
            fn: "loadPackInfo",
            trackF: constantsObj.TRACK_PACK,
            section: [],
            extraYOffset: 0
        }];

        var initialPackInfo = gameObj.getInitialPackInfo();
        var rowTwoList = [];
        var rowOneList1 = [];

        for (var j = 0; j < constantsObj.NUM_PACKS; j++) {
            if (orderingArrOfPacks[j] == constantsObj.STARTER_PACK_MINIS && gameObj.getIsStarterPackUnlocked() == false) {
                continue;
            }
            var packLockStatus = gameObj.getPackInfoLockStatus();
            if (packLockStatus[orderingArrOfPacks[j]] == undefined) {
                packLockStatus[orderingArrOfPacks[j]] = initialPackInfo.packInfoLockStatusFinal1[orderingArrOfPacks[j]];
                gameObj.setPackInfoLockStatus(packLockStatus);
            }
            var lockedPack = packLockStatus[orderingArrOfPacks[j]];
            var packArr = packInfo[orderingArrOfPacks[j]];
            var mid = orderingArrOfPacks[j] - 7;
            var firstFreePuzzleId = "00000" + mid + "01";
            var inProgress = gameObj.getInProgress();
            var hasUserInteractedWithPack = false;
            if (orderingArrOfPacks[j] >= 14 && orderingArrOfPacks[j] <= constantsObj.NUM_PACKS) {
                var id = 0;
                id = mid + 7;
                //loggerObj.debugLog("check for the puzzleid1 ", id);
                hasUserInteractedWithPack = gameObj.checkInteractionWithPack(id);
            }
            if (orderingArrOfPacks[j] == constantsObj.STARTER_PACK_MINIS) {
                hasUserInteractedWithPack = true;
            }
            if (inProgress[firstFreePuzzleId] != undefined && (orderingArrOfPacks[j] > 6)) {
                hasUserInteractedWithPack = (inProgress[firstFreePuzzleId].timeElapsed > 0) ? true : false;
            }

            if (hasUserInteractedWithPack) {
                gameObj.setUserPackInteraction(true);
            }

            //user has completed the puzzle
            var score = scoresObj.getHighScore(firstFreePuzzleId);
            if (score > 0) {
                hasUserInteractedWithPack = true;
            }

            var numberOfPuzzleSolved = 0;
            for (var i = 0; i < packArr.length; i++) {
                var crossWord = packArr[i];
                var score = scoresObj.getHighScore(crossWord);
                if (score > 0) {
                    numberOfPuzzleSolved++;
                }
            }
            var packComplete = (numberOfPuzzleSolved == packArr.length && packArr.length != 0) ? true : false;
            if (listNum == 3 && orderingArrOfPacks[j] >= 7) {
                continue;
            }
            if (listNum == 2 && orderingArrOfPacks[j] < 7) {
                continue;
            }
            if (listNum == 1) {
                if (orderingArrOfPacks[j] >= 0 && orderingArrOfPacks[j] < 7 && lockedPack) {
                    continue;
                }
                if (orderingArrOfPacks[j] >= 8 && orderingArrOfPacks[j] < 14 && lockedPack) {
                    continue;
                }
                if (((orderingArrOfPacks[j] >= 14 && orderingArrOfPacks[j] < constantsObj.NUM_PACKS)) && !hasUserInteractedWithPack) {
                    continue;
                }
            }
            if (packArr.length == 0) {
                continue;
            }
            var itemForPacks = packsLayer.createListElementForPacks(listItems[0], orderingArrOfPacks[j], listNum);
            var isEligibleForList1 = false;
            if (orderingArrOfPacks[j] >= 8 && orderingArrOfPacks[j] < 14 && lockedPack) {
                isEligibleForList1 = true;
            }
            if (orderingArrOfPacks[j] >= 14 && orderingArrOfPacks[j] < constantsObj.NUM_PACKS && !hasUserInteractedWithPack) {
                isEligibleForList1 = true;
            }

            if (listNum == 3 && lockedPack) {
                utilObj.addChild(packsLayer.listView2, itemForPacks);
                packsLayer.countList3++;
            } else if (listNum == 2 && isEligibleForList1 && packComplete == false) {
                rowTwoList.push(itemForPacks);
                // utilObj.addChild(packsLayer.listView1, itemForPacks);
            } else if ((listNum == 1 && !isEligibleForList1)) {
                if (!gameObj.checkIfPackComplete(constantsObj.INTRODUCING_MINIS)) {
                    if (orderingArrOfPacks[j] != constantsObj.INTRODUCING_MINIS) {
                        rowOneList1.push(itemForPacks);
                    }
                }else {
                    utilObj.addChild(packsLayer.listView, itemForPacks);
                }
                packsLayer.countList1++;
            }
        }
        var j = rowTwoList.length - 1;
        var count = 1;
        for (var i = 0; i <= j; i++) {
            if (count % 3 == 0) {
                utilObj.addChild(packsLayer.listView1, rowTwoList[j]);
                j--;
                i--;
            } else {
                utilObj.addChild(packsLayer.listView1, rowTwoList[i]);
            }
            count++;
            packsLayer.countList2++;
        }
        if (listNum == 1 && !gameObj.checkIfPackComplete(constantsObj.INTRODUCING_MINIS)) {
            var itemForPack1 = packsLayer.createListElementForPacks(listItems[0], constantsObj.INTRODUCING_MINIS, listNum);
            utilObj.addChild(packsLayer.listView, itemForPack1);
            // if (rowOneList1.length > 0) {
                //loggerObj.debugLog("check the row list1 ", rowOneList1.length, rowOneList1[i].textLabel);
                for (var i = 0; i < rowOneList1.length; i++) {
                    utilObj.addChild(packsLayer.listView, rowOneList1[i]);
                }

            // }
        }
    },

    createListElementForPacks: function (item, j, listNum) {
        var showNotificationIcon = false;
        if(bottomNavObj.getJewelNotifId() == constantsObj.JEWEL_NOTIF_PACK_ID) {
            if (!packsLayer.notifPackSet) {
                if (listNum == 1 && !gameObj.checkIfPackComplete(j)) {
                    packsLayer.notifPackSet = true;
                    showNotificationIcon = true;
                }
            }
        }

        var zOrder = constantsObj.UI_Z_ORDER;
        var xPos = xLeftPos;
        var screen = constantsObj.SCREEN_PACK_LAYER;

        var sectionHeight = 550;
        var itemWidget = new ccui.Widget();
        //var sections = item.section;

        //check if the user is D0
        var created = userObj.getCreated();
        var createdDate = new Date(created * 1000);
        var cDate = utilObj.getIdForDate(createdDate);


        var textFont = constantsObj.FONT_ROBOTO_MEDIUM_70, subTextFont = constantsObj.FONT_ROBOTO_REGULAR_60;

        var circleScale = constantsObj.SCALE_SPRITE_1 * constantsObj.MINI_PACK_INFO[j]["circleScale"];
        // if (j == 4) {
        //     circleScale = constantsObj.SCALE_SPRITE_1;
        // }
        var offsetForCircleSprite = constantsObj.MINI_PACK_INFO[j]["offsetForCircleSprite"];
        /*if (j > 6) {
            circleScale = constantsObj.SCALE_SPRITE_6 * 1.5;
            offsetForCircleSprite = 75
        }
        if (j == constantsObj.TV_MINIS || j == constantsObj.AROUND_THE_WORLD) {
            circleScale = constantsObj.SCALE_SPRITE_14 * 1.5;
        }
        if (j == constantsObj.VALENTINE_MINIS) {
            circleScale = 0.8 * circleScale;
        }
        if (j == constantsObj.CELEBRATING_WOMEN || j == constantsObj.MINI_TICKLERS || j == constantsObj.VACATION_MINIS) {
            circleScale = 0.7 * circleScale * 1.5;
            offsetForCircleSprite = 70;
        }
        if (j == constantsObj.GOURMET_MINIS || j == constantsObj.PLAY_OFF_MINIS) {
            circleScale = 0.7 * circleScale  ;
            offsetForCircleSprite = 70;
        }
        if (j == constantsObj.HALLOWEEN_MINIS) {
            circleScale = constantsObj.SCALE_SPRITE_7 * 1.5;
        }

        if (j == constantsObj.STARTER_PACK_MINIS) {
            circleScale = constantsObj.SCALE_SPRITE_7 * 1.5;
            offsetForCircleSprite = 25;
        }

        if (j == constantsObj.HAPPY_HOLIDAYS) {
            circleScale = constantsObj.SCALE_SPRITE_7 * 1.5;
            //offsetForCircleSprite = 50;
        }*/

        var itemHeight = 440;
        var itemWidth = 330;
        itemWidget.setContentSize(cc.size(itemWidth, itemHeight + 30));
        var localXPos = xPos;
        var localYPos = itemHeight;

        var sectionBg = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, localXPos, localYPos - 185, 0, 0.5, itemWidth, itemHeight);


        /*if (j == constantsObj.HALLOWEEN_MINIS) {
            sectionBg.setColor(constantsObj.COLOR_WHITE);
        }*/

        /*if (j == 18) {
            sectionBg.setColor(constantsObj.COLOR_VALENTINE_BACKGROUND);
        }*/

        /*if (j == 19) {
            sectionBg.setColor(constantsObj.COLOR_WOMENDAY_BACKGROUND);
        }

        if (j == 20) {
            sectionBg.setColor(constantsObj.COLOR_LOL_BACKGROUND);
        }*/

        if (j == constantsObj.NUM_PACKS - 1) {
            sectionBg.setColor(constantsObj.MINI_PACK_INFO[j]["packColor"]);
        }
        //itemWidget.addChild(sectionBg, zOrder);
        utilObj.addChild(itemWidget, sectionBg, zOrder);

        //check for number of puzzles completed
        var packInfo = gameObj.getPackInfo();
        // loggerObj.debugLog("1 . j and packArr is ", j, packInfo[j]);
        var packArr = packInfo[j];
        // loggerObj.debugLog("2 . j and packArr is ", j, packInfo[j]);
        var lockStatus = gameObj.getPackInfoLockStatus();

        var numberOfPuzzleSolved = 0;
        for (var i = 0; i < packArr.length; i++) {
            var crossWord = packArr[i];
            var score = scoresObj.getHighScore(crossWord);
            if (score > 0) {
                numberOfPuzzleSolved++;
            }
        }

        var circleSprite = constantsObj.LOGO_FOR_DAYS_PACK[j];
        if (j < 7 && homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            circleSprite = constantsObj.LOGO_FOR_DAYS_NEW_ICON[j];
            if (j == 0 || j == 3) {
                circleScale = circleScale * 0.6;
            } else if (j == 1 || j == 2 || j == 5 || j == 6) {
                circleScale = circleScale * 0.8;
            } else if (j == 4) {
                circleScale = circleScale * 1.2;
            }
        }
        if (circleSprite) {
            var t = 0;
            if (j == constantsObj.BIBLIOPHILE_MINIS || j == constantsObj.DISNIAC_PACK || j == constantsObj.FRIENDS_PACK) {
                t = 10;
            }
            var circleImage = utilObj.getSprite(circleSprite, itemWidth / 2, localYPos - 120 + t, 0.5, 0.5, circleScale);
            circleImage.setColor(constantsObj.MINI_PACK_INFO[j]["packColor"]);
            if (j < 7 && homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                circleImage.setColor(constantsObj.COLOR_FOR_WEEK_THEMES_NEW[j]);
            }
            if (j == constantsObj.NUM_PACKS - 1) {
                circleImage.setColor(constantsObj.COLOR_WHITE);
            }
            //itemWidget.addChild(circleImage, zOrder);
            utilObj.addChild(itemWidget, circleImage, zOrder);
            /*if (j == 18) {
                circleImage.setColor(constantsObj.COLOR_VALENTINE_BACKGROUND);
            }
            if (j == 19) {
                circleImage.setColor(constantsObj.COLOR_WOMENDAY_BACKGROUND);
            }

            if (j == 20) {
                circleImage.setColor(constantsObj.COLOR_LOL_BACKGROUND);
            }
            if (j == 21) {
                circleImage.setColor(constantsObj.COLOR_MAY_BACKGROUND);
            }
            if (j == 22) {
                circleImage.setColor(constantsObj.COLOR_JUNE_BACKGROUND);
            }*/
        }


        var text1 = stringsObj.puzzle_themes_pack[j];
        var textLabel = utilObj.getBMFontLabel(text1, constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localXPos + 160, localYPos - 280, 0.5, 0.5);

        if (j == constantsObj.NUM_PACKS - 1) {
            textLabel = utilObj.getBMFontLabel(text1, constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localXPos + 160, localYPos - 280, 0.5, 0.5);
        }
        //itemWidget.addChild(textLabel, zOrder);
        utilObj.addChild(itemWidget, textLabel, zOrder);


        if (numberOfPuzzleSolved == packArr.length) {
            var textLabel2 = utilObj.getBMFontLabel("Completed", constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localXPos + 160, localYPos - 365, 0.5, 0.5);
            if (j == constantsObj.NUM_PACKS - 1) {
                textLabel2 = utilObj.getBMFontLabel("Completed", constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localXPos + 160, localYPos - 365, 0.5, 0.5);
            }
            if (lockStatus[j] == true || lockStatus[j] == undefined) {
                lockStatus[j] = false;
                gameObj.setPackInfoLockStatus(lockStatus);
            }
            //itemWidget.addChild(textLabel2, zOrder);
            utilObj.addChild(itemWidget, textLabel2, zOrder);
        } else if (lockStatus[j] == true || lockStatus[j] == undefined) {
            if (lockStatus[j] == undefined) {
                lockStatus[j] = true;
                gameObj.setPackInfoLockStatus(lockStatus);
            }
            var textLabel2 = utilObj.getBMFontLabel(packArr.length + " " + "Puzzles", constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localXPos + 160, localYPos - 365, 0.5, 0.5);

            if (j == constantsObj.NUM_PACKS - 1) {
                textLabel2 = utilObj.getBMFontLabel(packArr.length + " " + "Puzzles", constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localXPos + 160, localYPos - 365, 0.5, 0.5);
            }
            //itemWidget.addChild(textLabel2, zOrder);
            utilObj.addChild(itemWidget, textLabel2, zOrder);
        } else {
            if (numberOfPuzzleSolved > 1) {
                lockStatus[j] = false;
                gameObj.setPackInfoLockStatus(lockStatus);
            }
            var interactedWithPack = gameObj.checkInteractionWithPack(j);
            var textLabel2;
            if (j >= constantsObj.AROUND_THE_WORLD && j < constantsObj.NUM_PACKS && j != constantsObj.STARTER_PACK_MINIS && !interactedWithPack) {
                textLabel2 = utilObj.getBMFontLabel(packArr.length + " " + "Puzzles", constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localXPos + 160, localYPos - 365, 0.5, 0.5);
                if (j == constantsObj.NUM_PACKS - 1) {
                    textLabel2 = utilObj.getBMFontLabel(packArr.length + " " + "Puzzles", constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_WHITE,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localXPos + 160, localYPos - 365, 0.5, 0.5);
                }
            }else {
                textLabel2 = utilObj.getBMFontLabel(numberOfPuzzleSolved + "/" + packArr.length, constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localXPos + 160, localYPos - 365, 0.5, 0.5);
                if (j == constantsObj.NUM_PACKS - 1) {
                    textLabel2 = utilObj.getBMFontLabel(numberOfPuzzleSolved + "/" + packArr.length, constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_WHITE,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localXPos + 160, localYPos - 365, 0.5, 0.5);
                }
            }
            //itemWidget.addChild(textLabel2, zOrder);
            utilObj.addChild(itemWidget, textLabel2, zOrder);
        }
        //     //itemWidget.addChild(free_tag, zOrder);
          //     utilObj.addChild(itemWidget, free_tag, zOrder);
        // }

        if(showNotificationIcon){
            var circleIcon1 = utilObj.getSprite(constantsObj.white_circle_150, localXPos + itemWidth, localYPos + 25, 0.5, 0.5, constantsObj.SCALE_SPRITE_2 * 0.66, null, packsLayer, zOrder + 1, constantsObj.SPRITE_MISC);
            utilObj.setColor(circleIcon1, constantsObj.COLOR_RED_01);

            var circleIconAnim = utilObj.getSprite(constantsObj.white_circle_150, localXPos + itemWidth, localYPos + 25, 0.5, 0.5, constantsObj.SCALE_SPRITE_2 * 0.66, null, packsLayer, zOrder + 1, constantsObj.SPRITE_MISC);
            utilObj.setColor(circleIconAnim, constantsObj.COLOR_RED_01);

            utilObj.addChild(itemWidget, circleIcon1, zOrder + 2);
            utilObj.addChild(itemWidget, circleIconAnim, zOrder + 2);


            utilObj.delayedCallback(packsLayer, animationObj.animateNudgePack, 1, {
                icon: circleIcon1,
                animCircle: circleIconAnim
            }, false);
        }

        if (constantsObj.MINI_PACK_INFO[j]["freeTag"]) {
            var freeTagImage = constantsObj.MINI_PACK_INFO[j]["freeTagImage"];

            if (homeLayoutExpNew != constantsObj.EXP_VAR_1 && homeLayoutExpNew != constantsObj.EXP_VAR_2) {
                if (freeTagImage == constantsObj.free_tag3) {
                    var free_tag = utilObj.getSprite(freeTagImage, localXPos + 75 + 150, localYPos - 62, 0, 0.5, constantsObj.SCALE_SPRITE_9);
                    utilObj.addChild(itemWidget, free_tag, zOrder);
                } else {
                    var free_tag = utilObj.getSprite(freeTagImage, localXPos + 75 + 150, localYPos - 62, 0, 0.5, constantsObj.SCALE_SPRITE_9 * 1.5);
                    utilObj.addChild(itemWidget, free_tag, zOrder);
                }
            }
        }
        /*if (j == 16 || j == 18 || j == 19 || j == 20 || j == 21 || j== 22 ) {
            var free_tag = utilObj.getSprite(constantsObj.free_tag2, localXPos + 75 + 150, localYPos - 62, 0, 0.5, constantsObj.SCALE_SPRITE_9 * 1.5);
            utilObj.addChild(itemWidget, free_tag, zOrder);
        }
        if (j == 23) {
            var free_tag = utilObj.getSprite(constantsObj.free_tag3, localXPos + 75 + 150, localYPos - 62, 0, 0.5, constantsObj.SCALE_SPRITE_9);
            utilObj.addChild(itemWidget, free_tag, zOrder);
        }*/

        var button = utilObj.getButton(320, 450, 0, 0.5, localXPos, localYPos - 185,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'packsLayer',
                fn: item.fn,
                params: {index: j, sound: false, packType: constantsObj.NORMAL_PACKS},
                screen: screen,
                track: {
                    k: constantsObj.TRACK_PACK,
                    p: constantsObj.TRACK_HOME_CLICK,
                    c: stringsObj.puzzle_themes[j],
                    o: "",
                    f: "",
                    g: gameObj.getPackStatus(j),
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        //itemWidget.addChild(button, zOrder);
        utilObj.addChild(itemWidget, button, zOrder);
        return itemWidget;
    },

    createListElementForBritPacks: function (item, j, listNum) {
        var showNotificationIcon = false;
        if(bottomNavObj.getJewelNotifId() == constantsObj.JEWEL_NOTIF_PACK_ID) {
            if (!packsLayer.notifPackSet) {
                if (listNum == 1 && !gameObj.checkIfPackComplete(j, constantsObj.BRITISH_PACKS)) {
                    packsLayer.notifPackSet = true;
                    showNotificationIcon = true;
                }
            }
        }
        var zOrder = constantsObj.UI_Z_ORDER;
        var xPos = xLeftPos;
        var screen = constantsObj.SCREEN_PACK_LAYER;
        var sectionHeight = 550;
        var itemWidget = new ccui.Widget();
        var circleScale = constantsObj.SCALE_SPRITE_1 * constantsObj.BRIT_PACK_INFO[j]["circleScale"];
        var offsetForCircleSprite = constantsObj.BRIT_PACK_INFO[j]["offsetForCircleSprite"];
        var itemHeight = 440;
        var itemWidth = 330;
        itemWidget.setContentSize(cc.size(itemWidth, itemHeight + 30));
        var localXPos = xPos;
        var localYPos = itemHeight;

        var sectionBg = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, localXPos, localYPos - 185, 0, 0.5, itemWidth, itemHeight);
        if (j == constantsObj.NUM_BRIT_PACKS - 1) {
            sectionBg.setColor(constantsObj.BRIT_PACK_INFO[j]["packColor"]);
        }
        utilObj.addChild(itemWidget, sectionBg, zOrder);

        //check for number of puzzles completed
        var packInfo = gameObj.getBritPurchasedPackInfo();
        var packArr = packInfo[j];
        var lockStatus = false;//gameObj.getPackInfoLockStatus();

        var numberOfPuzzleSolved = 0;
        for (var i = 0; i < packArr.length; i++) {
            var crossWord = packArr[i];
            var score = scoresObj.getHighScore(crossWord);
            if (score > 0) {
                numberOfPuzzleSolved++;
            }
        }

        var circleSprite = constantsObj.LOGO_FOR_BRIT_PACKS[j];
        if (circleSprite) {
            var circleImage = utilObj.getSprite(circleSprite, itemWidth / 2, localYPos - 120 + 10, 0.5, 0.5, circleScale);
            circleImage.setColor(constantsObj.BRIT_PACK_INFO[j]["packColor"]);
            if (j == constantsObj.NUM_BRIT_PACKS - 1) {
                circleImage.setColor(constantsObj.COLOR_WHITE);
            }
            utilObj.addChild(itemWidget, circleImage, zOrder);
        }


        var text1 = stringsObj.puzzle_themes_brit_pack[j];
        loggerObj.debugLog("check for the list called ", j, text1, listNum, utilObj.getStringifiedJson(item));
        var textLabel = utilObj.getBMFontLabel(text1, constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localXPos + 160, localYPos - 280, 0.5, 0.5);

        if (j == constantsObj.NUM_BRIT_PACKS - 1) {
            textLabel = utilObj.getBMFontLabel(text1, constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localXPos + 160, localYPos - 280, 0.5, 0.5);
        }
        utilObj.addChild(itemWidget, textLabel, zOrder);


        if (numberOfPuzzleSolved == packArr.length) {
            var textLabel2 = utilObj.getBMFontLabel("Completed", constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localXPos + 160, localYPos - 365, 0.5, 0.5);
            if (j == constantsObj.NUM_BRIT_PACKS - 1) {
                textLabel2 = utilObj.getBMFontLabel("Completed", constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localXPos + 160, localYPos - 365, 0.5, 0.5);
            }
            // if (lockStatus[j] == true || lockStatus[j] == undefined) {
            //     lockStatus[j] = false;
            //     gameObj.setPackInfoLockStatus(lockStatus);
            // }
            //itemWidget.addChild(textLabel2, zOrder);
            utilObj.addChild(itemWidget, textLabel2, zOrder);
        } else {
            var interactedWithPack = gameObj.checkInteractionWithPack(j, constantsObj.BRITISH_PACKS);
            var textLabel2;
            if (!interactedWithPack) {
                textLabel2 = utilObj.getBMFontLabel(packArr.length + " " + "Puzzles", constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localXPos + 160, localYPos - 365, 0.5, 0.5);
                if (j == constantsObj.NUM_BRIT_PACKS - 1) {
                    textLabel2 = utilObj.getBMFontLabel(packArr.length + " " + "Puzzles", constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_WHITE,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localXPos + 160, localYPos - 365, 0.5, 0.5);
                }
            } else {
                textLabel2 = utilObj.getBMFontLabel(numberOfPuzzleSolved + "/" + packArr.length, constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localXPos + 160, localYPos - 365, 0.5, 0.5);
                if (j == constantsObj.NUM_BRIT_PACKS - 1) {
                    textLabel2 = utilObj.getBMFontLabel(numberOfPuzzleSolved + "/" + packArr.length, constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_WHITE,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localXPos + 160, localYPos - 365, 0.5, 0.5);
                }
            }
            utilObj.addChild(itemWidget, textLabel2, zOrder);
        }
        //     //itemWidget.addChild(free_tag, zOrder);
        //     utilObj.addChild(itemWidget, free_tag, zOrder);
        // }

        if(showNotificationIcon){
            var circleIcon1 = utilObj.getSprite(constantsObj.white_circle_150, localXPos + itemWidth, localYPos + 25, 0.5, 0.5, constantsObj.SCALE_SPRITE_2 * 0.66, null, packsLayer, zOrder + 1, constantsObj.SPRITE_MISC);
            utilObj.setColor(circleIcon1, constantsObj.COLOR_RED_01);

            var circleIconAnim = utilObj.getSprite(constantsObj.white_circle_150, localXPos + itemWidth, localYPos + 25, 0.5, 0.5, constantsObj.SCALE_SPRITE_2 * 0.66, null, packsLayer, zOrder + 1, constantsObj.SPRITE_MISC);
            utilObj.setColor(circleIconAnim, constantsObj.COLOR_RED_01);

            utilObj.addChild(itemWidget, circleIcon1, zOrder + 2);
            utilObj.addChild(itemWidget, circleIconAnim, zOrder + 2);


            utilObj.delayedCallback(packsLayer, animationObj.animateNudgePack, 1, {
                icon: circleIcon1,
                animCircle: circleIconAnim
            }, false);
        }

        if (constantsObj.BRIT_PACK_INFO[j]["freeTag"]) {
            var freeTagImage = constantsObj.BRIT_PACK_INFO[j]["freeTagImage"];

            if (homeLayoutExpNew != constantsObj.EXP_VAR_1 && homeLayoutExpNew != constantsObj.EXP_VAR_2) {
                if (freeTagImage == constantsObj.free_tag3) {
                    var free_tag = utilObj.getSprite(freeTagImage, localXPos + 75 + 150, localYPos - 62, 0, 0.5, constantsObj.SCALE_SPRITE_9);
                    utilObj.addChild(itemWidget, free_tag, zOrder);
                } else {
                    var free_tag = utilObj.getSprite(freeTagImage, localXPos + 75 + 150, localYPos - 62, 0, 0.5, constantsObj.SCALE_SPRITE_9 * 1.5);
                    utilObj.addChild(itemWidget, free_tag, zOrder);
                }
            }
        }

        var button = utilObj.getButton(320, 450, 0, 0.5, localXPos, localYPos - 185,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'packsLayer',
                fn: item.fn,
                params: {index: j, sound: false, packType: constantsObj.BRITISH_PACKS},
                screen: screen,
                track: {
                    k: constantsObj.TRACK_BRIT_PACK,
                    p: constantsObj.TRACK_HOME_CLICK,
                    c: "",
                    o: "",
                    f: "",
                    g: gameObj.getPackStatus(j, constantsObj.BRITISH_PACKS),
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        //itemWidget.addChild(button, zOrder);
        utilObj.addChild(itemWidget, button, zOrder);
        return itemWidget;
    },

    addBottomNavOptions: function () {
        return;
        var screen = packsLayer.screen;
        var btnWidth = (canvasWidth / 4) - (canvasWidth / 72);
        var btnHeight = 228;
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            btnHeight = 125;
        }
        var xPos = btnWidth / 2 + (canvasWidth / 120);
        var zOrder = constantsObj.UI_Z_ORDER;
        var homeNewExp = homeLayoutExp;

        var transHomeButton = utilObj.getButton(btnWidth, btnHeight + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, xPos, btnHeight / 2 + 3 + constantsObj.BOTTOM_BAR_OFFSET / 2,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'packsLayer',
                fn: 'showHome',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_BOTTOM_NAV,
                    f: constantsObj.TRACK_HOME,
                    g: utilObj.getScreenName(screen),
                    s: "",
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);

        utilObj.addChild(packsLayer, transHomeButton, zOrder + 1);
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            var homeIcon = utilObj.getSprite(constantsObj.home_newIcon, btnWidth / 1.9, btnHeight / 2 + 35 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_12 * 2.5, null, null, zOrder, constantsObj.SPRITE_MISC);
            homeIcon.setColor(constantsObj.COLOR_BOTTOM_NAV_HS);
            utilObj.addChild(packsLayer, homeIcon, zOrder + 1);
        } else {
            if (homeNewExp == 0) {
                var homeIcon = utilObj.getSprite(constantsObj.bottom_nav_home, btnWidth / 2, btnHeight / 2 + 35 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_12 * 1.5);
            } else {
                var homeIcon = utilObj.getSprite(constantsObj.home_normal, btnWidth / 1.9, btnHeight / 2 + 35 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_9 * 1.4);
            }
            utilObj.addChild(packsLayer, homeIcon, zOrder + 1);
        }

        if (!(homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL)) {
            var homeLabel = utilObj.getBMFontLabel("HOME", constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), btnWidth / 2, 40 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, null, transHomeButton, zOrder + 1);
        }
        utilObj.addChild(transHomeButton, homeLabel, zOrder + 1);

        xPos += btnWidth + (canvasWidth / 72) - (canvasWidth / 720);
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL && homeLayer.subscriptionTag == 3) {
            var idMini = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
            idMini = stringsObj.mini_prefix + idMini.substr(2, idMini.length);
            homeLayer.subscriptionTagCondition(idMini);
            var offerTag = utilObj.getSprite(constantsObj.offer_tag_calendar, xPos + (50 * canvasWidth / 1440), btnHeight + 125 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 1, constantsObj.SCALE_SPRITE_1, null, packsLayer, zOrder + 1, constantsObj.SPRITE_MISC);
            utilObj.addChild(packsLayer, offerTag, zOrder + 1);
        }
        var transCalendarButton = utilObj.getButton(btnWidth, btnHeight + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, xPos, btnHeight / 2 + 3 + constantsObj.BOTTOM_BAR_OFFSET / 2,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'packsLayer',
                fn: 'showCalendar',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_BOTTOM_NAV,
                    f: constantsObj.TRACK_PACK,
                    g: utilObj.getScreenName(screen),
                    s: "",
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        //packsLayer.addChild(transCalendarButton, zOrder + 1);
        utilObj.addChild(packsLayer, transCalendarButton, zOrder + 1);

        var calendarImage = constantsObj.calendar_normal;
        var scaleImage = constantsObj.SCALE_SPRITE_2 * 1.5;
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            calendarImage = constantsObj.calendar_icon;
            scaleImage = constantsObj.SCALE_SPRITE_2 * 1.6;
        }

        if (homeNewExp == 0) {
            var calendarIcon = utilObj.getSprite(constantsObj.bottom_nav_calendar, xPos, btnHeight / 2 + 35 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, scaleImage);
        } else {
            var calendarIcon = utilObj.getSprite(calendarImage, xPos, btnHeight / 2 + 35 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, scaleImage);
            if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                calendarIcon.setColor(constantsObj.COLOR_BOTTOM_NAV_HS);
            }
        }


        utilObj.addChild(packsLayer, calendarIcon, zOrder + 1);

        if (!(homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL)) {
            var calendarLabel = utilObj.getBMFontLabel("CALENDAR", constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, 40 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, null, transCalendarButton, zOrder + 1);
            utilObj.addChild(packsLayer, calendarLabel, zOrder + 1);
        }

        xPos += btnWidth + (canvasWidth / 72) - (canvasWidth / 720);
        if (homeNewExp == 0) {
            packsLayer.packsButtonBg = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, xPos, btnHeight / 2 + 3 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, btnWidth, btnHeight);
        }

        utilObj.addChild(packsLayer, packsLayer.packsButtonBg, constantsObj.UI_Z_ORDER + 1);
        var packsButton = utilObj.getButton(btnWidth, btnHeight + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, xPos, btnHeight / 2 + 3 + constantsObj.BOTTOM_BAR_OFFSET / 2,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'packsLayer',
                fn: 'showPacks',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_BOTTOM_NAV,
                    f: constantsObj.TRACK_CALENDAR,
                    g: utilObj.getScreenName(screen),
                    s: "",
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);

        utilObj.addChild(packsLayer, packsButton, zOrder + 1);

        var isHalloweenOn = gameObj.checkIfHalloweenOn();
        var IconImg = constantsObj.bottom_nav_packs;
        var scale = constantsObj.SCALE_SPRITE_32;
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            IconImg = constantsObj.pack_icon;
            scale = constantsObj.SCALE_SPRITE_2;
        }

        if (isHalloweenOn) {
            var packIcon = utilObj.getSprite(constantsObj.bottom_nav_packs_holloween, btnWidth / 2, btnHeight / 2 + 35 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_6);
            utilObj.addChild(packsButton, packIcon, zOrder + 1);
        } else {
            var packIcon = utilObj.getSprite(IconImg, btnWidth / 2, btnHeight / 2 + 35 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, scale * 1.5);
            if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                packIcon.setColor(constantsObj.COLOR_BLUE_NAV_BAR);
            }
            utilObj.addChild(packsButton, packIcon, zOrder + 1);
        }
        if (!(homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL)) {
            if (homeNewExp == 0) {
                packIcon.setColor(constantsObj.COLOR_DARK_BLUE_01);
                var packLabel = utilObj.getBMFontLabel("PACKS", constantsObj.FONT_ROBOTO_BOLD_40, constantsObj.COLOR_DARK_BLUE_01,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), btnWidth / 2, 40 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, null, packsButton, zOrder + 1);
            } else {
                var packLabel = utilObj.getBMFontLabel("PACKS", constantsObj.FONT_ROBOTO_BOLD_40, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), btnWidth / 2, 40 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, null, packsButton, zOrder + 1);
            }
            utilObj.addChild(packsButton, packLabel, zOrder + 1);
        }

        xPos += btnWidth + (canvasWidth / 72) - (canvasWidth / 720);
        var transAchievementsButton = utilObj.getButton(btnWidth, btnHeight + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, xPos, btnHeight / 2 + 3 + constantsObj.BOTTOM_BAR_OFFSET / 2,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'packsLayer',
                fn: 'showAchievements',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_BOTTOM_NAV,
                    f: constantsObj.TRACK_ACHIEVEMENTS,
                    g: utilObj.getScreenName(screen),
                    s: "",
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(packsLayer, transAchievementsButton, constantsObj.UI_Z_ORDER + 1);
        if (homeNewExp == 0) {
            var proIcon = constantsObj.achievement_normal;
            if (ProfileExp == constantsObj.EXP_VAR_1) {
                proIcon = constantsObj.profile_screen;
                var badgeIcon = utilObj.getSprite(proIcon, xPos, btnHeight / 2 + 35 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_12 * 2.25);
            } else {
                var badgeIcon = utilObj.getSprite(constantsObj.bottom_nav_badge, xPos, btnHeight / 2 + 35 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_12 * 1.5);
            }
        } else {
            var proIcon = constantsObj.achievement_normal;
            var scale = 1.5;
            if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                proIcon = constantsObj.achievement_icon;
                scale = 1.75;
            }

            if (ProfileExp == constantsObj.EXP_VAR_1) {
                proIcon = constantsObj.profile_screen;
                var badgeIcon = utilObj.getSprite(proIcon, xPos, btnHeight / 2 + 35 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_12 * 2.25);
                if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                    badgeIcon.setColor(constantsObj.COLOR_BOTTOM_NAV_HS);
                }
            } else {
                var badgeIcon = utilObj.getSprite(proIcon, xPos, btnHeight / 2 + 35 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_2 * scale);
                if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                    badgeIcon.setColor(constantsObj.COLOR_BOTTOM_NAV_HS);
                }
            }
        }

        utilObj.addChild(packsLayer, badgeIcon, zOrder + 1);

        var offset = 0;
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            offset = 20;
        }


        var circleIcon = utilObj.getSprite(constantsObj.white_circle_150, xPos + btnWidth / 4 - btnHeight / 8 - offset, btnHeight / 2 + btnHeight / 4 + btnHeight / 16 + (offset * 2) + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_2);
        circleIcon.setColor(constantsObj.COLOR_RED_01);

        var circleIconAnim = utilObj.getSprite(constantsObj.white_circle_150, xPos + btnWidth / 4 - btnHeight / 8 - offset, btnHeight / 2 + btnHeight / 4 + btnHeight / 16 + (offset * 2) + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_2);
        circleIconAnim.setColor(constantsObj.COLOR_RED_01);


        var completedAchievementsCount = achievementsObj.getNumOfCompletedAchievements();
        var indexofAchievement = achievementsObj.getAchievementToSurfaceOnStats();
        var jewelNotif = 0;
        if (completedAchievementsCount != 0) {
            jewelNotif = completedAchievementsCount;
        } else if (indexofAchievement != -1) {
            jewelNotif = "!";
        } else {
            gameObj.setShowJewelNotif(false);
        }
        utilObj.addChild(packsLayer, circleIconAnim, zOrder + 1);
        var completedAchievementsLabel = utilObj.getBMFontLabel(jewelNotif + "", constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 50, 50, 0.5, 0.5, null, circleIcon, zOrder + 1);
        utilObj.addChild(circleIcon, completedAchievementsLabel, zOrder + 1);

        if (jewelNotif == "!" && ProfileExp != constantsObj.EXP_VAR_1) {
            circleIcon.setVisible(false);
            completedAchievementsLabel.setVisible(false);
            circleIconAnim.setVisible(false);
        } else if (completedAchievementsCount == 0 && gameObj.getShowJewelNotif() == false || jewelNotif == 0) {
            circleIcon.setVisible(false);
            completedAchievementsLabel.setVisible(false);
            circleIconAnim.setVisible(false);
        } else if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            utilObj.delayedCallback(packsLayer, homeObj.animateNudgeAchv, 1, {icon: circleIcon, label: completedAchievementsLabel, animCircle: circleIconAnim}, false);
        }

        if (homeLayoutExpNew == constantsObj.EXP_VAR_CONTROL) {
            if (!ftueObj.isAchievementFtueShown()) {
                circleIcon.setVisible(false);
                completedAchievementsLabel.setVisible(false);
            }
        }

        var achievement_string = "ACHIEVEMENTS";
        if (ProfileExp == constantsObj.EXP_VAR_1) {
            achievement_string = "PROFILE";
        }

        utilObj.addChild(packsLayer, circleIcon, zOrder + 1);

        if (!(homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL)) {
            var achievementsLabel = utilObj.getBMFontLabel(achievement_string, constantsObj.FONT_ROBOTO_REGULAR_40, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, 40 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, null, transAchievementsButton, zOrder + 1);
        }

        utilObj.addChild(packsLayer, achievementsLabel, zOrder + 1);
    },

    showSubsPopupOffer: function () {
        gameObj.setScreenTypeForSubsLayer(constantsObj.SUBSCRIPTION_OFFER);
        subscriptionsLaunchLayer.show(true);
    },

    showHome: function () {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        packsLayer.hide();
        utilObj.popCurScreen();
        homeLayer.show();
    },

    showCalendar: function () {
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL && homeLayer.subscriptionTag == 3) {
            gameObj.setNumberOfSubsPopup(gameObj.getNumberOfSubsPopup() + 1);
            gameObj.setTimestampOfLastSubsPopup(utilObj.getCurrentTimestamp());
            gameObj.setScreenTypeForSubsLayer(constantsObj.SUBSCRIPTION_OFFER);
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_HOME, "SP1", "", gameObj.getPuzzleSpeciesTracking(), "", "");
            var params = {};
            params.popupName = "goToCalendarFromPack";
            subscriptionsLaunchLayer.show(true, false, params);
            // homeLayer.redraw();
            return;
        }
        if (!ftueObj.isFtueShown()) {
            return;
        }
        packsLayer.hide();
        utilObj.popCurScreen();
        calendarLayer.show();
    },

    showPacks: function () {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        packsLayer.redraw();
    },

    showAchievements: function () {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        packsLayer.hide();
        utilObj.popCurScreen();
        if (ProfileExp == constantsObj.EXP_VAR_1) {
            achievementsLayer.show(gameObj.getShowStat());
        } else {
            achievementsLayer.show();
        }
        machineLearningDataObj.incUserOpenedAchievements();
    },

    loadPackInfo: function (params) {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        packsLayer.hide();
        var packInfo = gameObj.getPackInfo();
        var packArr = packInfo[params.index];

        var numberOfPuzzleSolved = 0;
        for (var i = 0; i < packArr.length; i++) {
            var crossWord = packArr[i];
            var score = scoresObj.getHighScore(crossWord);
            if (score > 0) {
                numberOfPuzzleSolved++;
            }
        }
        var packType = 0;
        if (params.packType != undefined) {
            packType = params.packType;
        }
        // loggerObj.debugLog("djain loading packinfo");
        packInfoLayer.show(params.index, numberOfPuzzleSolved == packArr.length, packType);
    },

    hide: function () {
        packsLayer.stopAllActions();
        packsLayer.removeAllChildren();
        packsLayer.setVisible(false);
    },

    settings: function () {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        settingsPopup.show(constantsObj.SCREEN_PACK_LAYER);
    },

    getListElement: function (index) {
        var item = packsLayer.listView.getItem(index);
        if (utilObj.isNodeValid(item)) {
            return item;
        }
        return null;
    },

    loginToFB: function () {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        fbWrapperObj.login(packsLayer.loginSuccess);
    },

    loginSuccess: function () {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        gameObj.setLoggedInFb(true);
        packsLayer.show();
    },

    invite: function () {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        packsLayer.hide();
        //var curTimestamp = utilObj.getCurrentTimestamp();
        gameObj.setRequestCount(0);
        mfsLayer.checkAndShow(constantsObj.INVITE, constantsObj.SCREEN_HOME, null, null);
        //gameObj.lastInviteAndConnectShow = curTimestamp;
    },

    rateUs: function () {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        rateUsPopup.show();
    },

    redraw: function () {
        gameObj.setIsRedraw(true);
        packsLayer.hide();
        packsLayer.show();
    },

    showStore: function () {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        packsLayer.hide();
        storeLayer.show();
    },

    back: function () {
        packsLayer.hide();
        utilObj.popCurScreen();
        homeLayer.show();
    },

    showSubsDailyStatus: function() {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        gameObj.setScreenTypeForSubsLayer(constantsObj.SUBSCRIPTION_DAILY_STATUS);
        subscriptionsLaunchLayer.show(true);
    },

    showMsgCenter: function () {
        if (!ftueObj.isFtueShown()) {
            return;
        }
        /*if (!fbWrapperObj.isLoggedIn()) {
            fbConnectPopup.show()
            return;
        }*/
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), utilObj.getScreenName(curScreen), "msg_center", "", "", "", "");

        popupLayer.closeWithDefault();
        freeCoins2Popup.show(true, constantsObj.SCREEN_PACK_LAYER);
        // packsLayer.hide();
        // gameObj.setRequestCount(0);
        // mfsLayer.checkAndShow(constantsObj.INVITE, constantsObj.SCREEN_PACK_LAYER, null, null);

    },
});
