var PopupLayer = cc.Layer.extend({
    popup: null,
    popupType: null,
    popupName: null,
    popupOpen: false,
    showClose: true,
    lastBackOn: null,
    parentPopupNode: null,
    backCount: 0,
    refCodeEntered: "",
    blackBg: null,
    popupLastOpen: null,
    toShowFtue : false ,

    updatingToScreen: null,
    popupRedraw: false,
    popupCallback: false,
    popupCallbackParams: null,
    popupShowWithAnim: false,
    popupCloseParams: null,
    coinTarget: null,
    coinTargetPos: null,
    headerLabel: null,
    cover: null,

    transBg: null,
    earnFreeFtueShown: null,
    earnFreeButton: null,
    watchVideoButton: null,
    watchVideoFtueShown: null,
    hideBannerAd: false,
    snowAnimation: null,
    intervalId1: null,
    intervalId2: null,
    intervalId3: null,

    ctor: function () {
        this._super();
        return true;
    },

    lastLayer: null,

    back: function () {
        popupLayer.resetLayerPos();
        var numActionsRunning = popupLayer.getNumberOfRunningActions();
        if (numActionsRunning > 0) {
            //return; // Suraj: Animations are still running for making the popup visible. Stopping them abruptly may cause issues.
        }
        loggerObj.traceLog("Number of running actions on popupLayer:", numActionsRunning);

        popupLayer.backCount++;
        var shouldClose = false;
        if (curScreen == constantsObj.SCREEN_STORE) {
            if (popupLayer.lastBackOn == curScreen && popupLayer.backCount >= 2) {
                // Close if this is done twice
                shouldClose = true;
            }
        } else if (popupLayer.showClose == false || curScreen == constantsObj.SCREEN_DESP_BUY) {
            // Don't close popup on back button press
        } else {
            shouldClose = true;
        }

        if (shouldClose) {
            popupLayer.close(popupLayer.popupCloseParams);
            popupLayer.backCount = 0;
        }
        popupLayer.lastBackOn = curScreen;
    },

    pause: function () {

    },

    resume: function () {

    },

    checkAndShow: function (cb, params) {
        /*if (popupOpenAnimRunning) {
            return;
        }*/
        popupOpenAnimRunning = true;
        if (popupLayer.popupOpen) {
            // loggerObj.debugLog("here it is 1");
            utilObj.delayedCallback(popupLayer, cb, constantsObj.POPUP_ANIM_DELAY, params);
        } else {
            // loggerObj.debugLog("here it is 2");
            cb(popupLayer, params);
        }
    },

    popupSetup: function (screen, redraw, callback, callbackParams, showWithAnim, closeParams) {
        // loggerObj.debugLog("Popup setup:", screen, closeParams);
        popupLayer.popupLastOpen = popupLayer.updatingToScreen;

        popupLayer.updatingToScreen = screen;
        popupLayer.popupRedraw = redraw;
        popupLayer.popupCallback = callback;
        popupLayer.popupCallbackParams = callbackParams;
        popupLayer.popupShowWithAnim = showWithAnim;
        popupLayer.popupCloseParams = closeParams;
    },

    resetSetup: function () {
        popupLayer.updatingToScreen = null;
        popupLayer.popupRedraw = null;
        popupLayer.popupCallback = null;
        popupLayer.popupCallbackParams = null;
        popupLayer.popupShowWithAnim = false;
        popupLayer.popupCloseParams = null;
    },

    show: function (popupHeight, popupType, header, popupUI, popupLabels,
                    showClose, screenSubType, trackGenus, trackSpecies, extraWide, extraHeader, noHeader, coinHeader, headerBgColor, headerColor, headerBg, spriteArrPopup, newPopupUi) {
        if (curScreen == constantsObj.SCREEN_MORE_GAMES_LAYER) {
            return;
        }

        var newTypePopup = false;
        if (newPopupUi) {
            newTypePopup = true;
        }

        if (popupLayer.updatingToScreen == null || popupLayer.updatingToScreen != popupType) {
            loggerObj.errorLog("Setup not done properly for popup:", popupLayer.updatingToScreen, popupType);
        }
        if (popupLayer.popupOpen) {
            loggerObj.errorLog("Popup still open when attempting to show:", popupType, popupLayer.popupLastOpen);
        }

        clearInterval(popupLayer.intervalId1);
        clearInterval(popupLayer.intervalId2);
        clearInterval(popupLayer.intervalId3);

        var isMiniOrMidi = gameObj.checkForMiniOrMidi(gameLayer.crosswordDate);
        var isBritMini = gameObj.checkForBritMini(gameLayer.crosswordDate);
        // utilObj.playSound(constantsObj.SOUND_POPUP_APPEAR, false, true);
        utilObj.updateScreenBegin(popupType);
        if (utilObj.adVisible) {
            utilObj.fadeBannerAd();
        }
        popupLayer.popupOpen = true;
        popupLayer.resetLayerPos();
        // Use the curScreen value for any tracking for where the popup is coming from.

        popupLayer.showClose = showClose;
        popupLayer.parentPopupNode = popupUI;

        /**
         * made scale to 1 as in animation poplayer scale is made to 0 and hence for the popups 
         * where no animation is to be shown scale need to made 1 to show the popup and handling the screens
         */
        popupLayer.setScale(1);

        var spriteArr = [];
        var popupWidth = constantsObj.POPUP_WIDTH;
        if (extraWide) {
            popupWidth = constantsObj.LARGE_POPUP_WIDTH;
        }
        if (newTypePopup) {
            popupWidth = constantsObj.NEW_POPUP_WIDTH;
        }

        var zOrder = constantsObj.UI_Z_ORDER;
        var layoutExperimentVariant = epmObj.getChosenVariant(constantsObj.EXP_LAYOUT);

        var blackBgHeight = constantsObj.DESIGN_HEIGHT;
        var yDownPos = 0;

        if (popupType == constantsObj.SCREEN_CONTEXTUAL_HELP) {
            blackBgHeight -= (constantsObj.HINTS_HEIGHT - 20);
            yDownPos += (constantsObj.HINTS_HEIGHT - 20) + constantsObj.BOTTOM_BAR_OFFSET1;
            popupLayer.cover = utilObj.getScale9Sprite(constantsObj.black_80, xLeftPos, 0, 0, 0, (canvasWidth / 3), constantsObj.HINTS_HEIGHT - 20 + constantsObj.BOTTOM_BAR_OFFSET1);
            //popupLayer.addChild(popupLayer.cover, zOrder + 2);
            utilObj.addChild(popupLayer, popupLayer.cover, zOrder + 2);
        }

        if (popupType == constantsObj.SCREEN_WATCH_TO_EARN_FTUE) {
            popupLayer.toShowFtue = true;
            blackBgHeight -= (constantsObj.HINTS_HEIGHT - 20);
            yDownPos += (constantsObj.HINTS_HEIGHT - 20) + constantsObj.BOTTOM_BAR_OFFSET1;
            if (!isMiniOrMidi || isBritMini) {
                //it won't enter into it as spinner is turned off and the above condition was for specific layout which is not getting used now
                gameLayer.hintsBg.setLocalZOrder(constantsObj.FTUE_Z_ORDER + 5);
                popupLayer.cover1 = utilObj.getScale9Sprite(constantsObj.black_80, xLeftPos, 0, 0, 0, (184 * canvasWidth / 1440), constantsObj.HINTS_HEIGHT - 20 + constantsObj.BOTTOM_BAR_OFFSET1);
                utilObj.addChild(popupLayer, popupLayer.cover1, zOrder + 2);
                popupLayer.cover2 = utilObj.getScale9Sprite(constantsObj.black_80, xLeftPos + (384 * canvasWidth / 1440), 0, 0, 0, (1070 * canvasWidth / 1440), constantsObj.HINTS_HEIGHT - 20 + constantsObj.BOTTOM_BAR_OFFSET1);
                utilObj.addChild(popupLayer, popupLayer.cover2, zOrder + 2);
            } else {
                popupLayer.cover1 = utilObj.getScale9Sprite(constantsObj.black_80, xLeftPos, 0, 0, 0, (canvasWidth / 6), constantsObj.HINTS_HEIGHT - 20 + constantsObj.BOTTOM_BAR_OFFSET1);
                utilObj.addChild(popupLayer, popupLayer.cover1, zOrder + 2);
                popupLayer.cover2 = utilObj.getScale9Sprite(constantsObj.black_80, xLeftPos + (canvasWidth / 3), 0, 0, 0, (canvasWidth * 4 / 6), constantsObj.HINTS_HEIGHT - 20 + constantsObj.BOTTOM_BAR_OFFSET1);
                utilObj.addChild(popupLayer, popupLayer.cover2, zOrder + 2);
            }
        }

        if (popupType == constantsObj.SCREEN_FREE_HINT) {
            blackBgHeight -= (constantsObj.HINTS_HEIGHT - 20);
            yDownPos += (constantsObj.HINTS_HEIGHT - 20) + constantsObj.BOTTOM_BAR_OFFSET1;

            //it won't enter into it as spinner is turned off and the above condition was for specific layout which is not getting used now
            gameLayer.hintsBg.setLocalZOrder(constantsObj.FTUE_Z_ORDER + 5);
            popupLayer.cover1 = utilObj.getScale9Sprite(constantsObj.black_80, xLeftPos, 0, 0, 0, (384 * canvasWidth / 1440), constantsObj.HINTS_HEIGHT - 20 + constantsObj.BOTTOM_BAR_OFFSET1);
            utilObj.addChild(popupLayer, popupLayer.cover1, zOrder + 2);
            popupLayer.cover2 = utilObj.getScale9Sprite(constantsObj.black_80, xLeftPos + (1284 * canvasWidth / 1440), 0, 0, 0, (1070 * canvasWidth / 1440), constantsObj.HINTS_HEIGHT - 20 + constantsObj.BOTTOM_BAR_OFFSET1);
            utilObj.addChild(popupLayer, popupLayer.cover2, zOrder + 2);

        }

        if(!popupLayer.popupShowWithAnim){
            var transBg = utilObj.getScale9Sprite(constantsObj.black_80, xLeftPos, yDownPos, 0, 0, canvasWidth, blackBgHeight + 100 + topBarOffset);
            //popupLayer.addChild(transBg, zOrder);
            utilObj.addChild(popupLayer, transBg, zOrder);
            // popupLayer.blackBg = transBg;
        }
        //var hintsSection = utilObj.getScale9Sprite(constantsObj.black_80, xLeftPos, 0, 0, 0, (canvasWidth / 3) , constantsObj.HINTS_HEIGHT - 20);

        var headingColor = constantsObj.COLOR_WHITE;

        var yPos = centerYPos + popupHeight / 2 - constantsObj.POPUP_START_OFFSET;
        if (popupType == constantsObj.SCREEN_SETTINGS) {
            yPos -= 60;
        }
        var xPos = centerXPos + constantsObj.POPUP_CLOSE_OFFSET;

        if (trackGenus == undefined) {
            trackGenus = "";
        }
        if (trackSpecies == undefined) {
            trackSpecies = "";
        }

        var headerHeight = 300;
        yPos += headerHeight;
        yPos -= 40;

        var extraYOffset = 0;
        if (extraHeader) {
            // Has extra header space
            extraYOffset = constantsObj.POPUP_EXTRA_HEADER_OFFSET;
        }
        yPos -= extraYOffset;

        if (extraWide) {
            xPos += 65;
        }
        if (showClose) {
            xPos = centerXPos + popupWidth / 2;
            var headerYPos = yPos;
            var closeImage = constantsObj.cross_icon;
            var scaleForClose = constantsObj.SCALE_SPRITE_31;
            if (noHeader) {
                yPos -= headerHeight - 60;
                headerYPos = yPos;
            }

            if (popupType == constantsObj.SCREEN_THEMED_QUEST || newTypePopup) {
                headerYPos += 100;
                xPos += 30;
                closeImage = constantsObj.close_icon2;
                scaleForClose = constantsObj.SCALE_SPRITE_43;
            }

            var allParams = {};
            allParams.sound = false;
            allParams.noAnim = popupLayer.popupCloseParams.noAnim;
            allParams.dontGoToLastScreen = popupLayer.popupCloseParams.dontGoToLastScreen;
            var screenTracking = utilObj.getScreenName(popupType, screenSubType);
            if (screenTracking == "ooc_store_offerwall") {
                screenTracking = "ooc_store";
            }
            if(screenTracking == "free_coins_2"){
                screenTracking = "invite";
            }
            var closeButton = utilObj.getButton(150, 150, 0.5, 0.5,
                xPos - 15, headerYPos - 30, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: 'popupLayer',
                    fn: 'close',
                    screen: popupType,
                    params: allParams,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: linearLevelObj.getDtc2PuzzleCompleted()+1,
                        o: screenTracking,
                        f: constantsObj.TRACK_CLOSE,
                        g: trackGenus,
                        s: trackSpecies,
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);

            //popupUI.addChild(closeButton, zOrder + 1);
            utilObj.addChild(popupUI, closeButton, zOrder + 1);

            var closeCross = utilObj.getSprite(closeImage, xPos - 15,
                headerYPos - 30, 0.5, 0.5, scaleForClose);
            //popupUI.addChild(closeCross, zOrder + 1);
            utilObj.addChild(popupUI, closeCross, zOrder + 1);
        }

        if (coinHeader) {
            var localXPos = xRightPos;
            var localYPos = constantsObj.DESIGN_HEIGHT - 70;
            var coinBgTarget = utilObj.getScale9Sprite(constantsObj.tile_white, localXPos - 400, localYPos, 0.5, 0.5, 300, 80);
            coinBgTarget.setOpacity(constantsObj.OPACITY_10);
            //popupLayer.addChild(coinBgTarget, zOrder);
            utilObj.addChild(popupLayer, coinBgTarget, zOrder);
            popupLayer.coinTarget = coinBgTarget;
            var coinIcon = utilObj.getSprite(constantsObj.coin_png_2, 0, 40, 0.5, 0.5, constantsObj.SCALE_SPRITE_9);
            //coinBgTarget.addChild(coinIcon);
            utilObj.addChild(coinBgTarget, coinIcon);
            var coinCount = economyObj.getCash() - economyObj.getCrosswordCompletionReward();
            var coinLabel = utilObj.getBMFontLabel(coinCount + "", constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 140, 40, 0.5, 0.5);
            coinBgTarget.addChild(coinLabel, zOrder, 0);
            var plusIcon = utilObj.getSprite(constantsObj.green_plus, 250, 40, 0, 0.5, constantsObj.SCALE_SPRITE_1);
            //coinBgTarget.addChild(plusIcon);
            utilObj.addChild(coinBgTarget, plusIcon);
            popupLayer.coinTargetPos = cc.p(localXPos - 350, localYPos);
        } else {
            popupLayer.coinTarget = null;
            popupLayer.coinTargetPos = null;
        }

        xPos = centerXPos;

        if (!noHeader) {
            if (layoutExperimentVariant == constantsObj.EXP_VAR_CONTROL) {
                var puzzleId = header;
                var date = utilObj.getDateForId(puzzleId);
                var day = date.getDay();
                var heading = stringsObj.puzzle_themes[day];
                var heading2 = utilObj.getFormattedDate(date);

                var hBg = utilObj.getScale9Sprite(constantsObj.popup_header, xPos, yPos, 0.5, 1.0, popupWidth, headerHeight, spriteArr, popupUI, zOrder, constantsObj.SPRITE_MISC);
                hBg.setColor(constantsObj.COLOR_LIGHT_RED);
                var theme_icon = constantsObj.LOGO_FOR_DAYS[day];
                var scale = constantsObj.SCALE_SPRITE_3;
                loggerObj.debugLog("check for the theme_icon ",homeLayoutExpNew);
                if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                    theme_icon = constantsObj.LOGO_FOR_DAYS_NEW_ICON[day];
                    if (day == 0 || day == 3) {
                        scale = constantsObj.SCALE_SPRITE_3 * 0.8;
                    }
                }
                utilObj.getSprite(theme_icon, xPos - 450, yPos - 30, 1, 1, scale, spriteArr, popupUI, zOrder, constantsObj.SPRITE_MISC);

                utilObj.getBMFontLabel(heading, constantsObj.FONT_ROBOTO_MEDIUM_100, headingColor,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 400, yPos - 50, 0, 1, popupLabels, popupUI, zOrder + 1);

                utilObj.getBMFontLabel(heading2, constantsObj.FONT_ROBOTO_REGULAR_50, headingColor,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 400, yPos - 180, 0, 1, popupLabels, popupUI, zOrder + 1);
            } else {
                headerHeight -= 40;
                if (header == "Settings") {
                    headerHeight -= 80;
                }
                yPos -= 40;
                if (!(popupType == constantsObj.SCREEN_THEMED_QUEST || newTypePopup)) {
                    var hBg = utilObj.getScale9Sprite(constantsObj.popup_header, xPos, yPos, 0.5, 1.0, popupWidth, headerHeight, spriteArr, popupUI, zOrder, constantsObj.SPRITE_MISC);
                    if (headerBgColor == null) {
                        hBg.setColor(constantsObj.COLOR_YELLOW_07);
                    } else {
                        hBg.setColor(headerBgColor);
                    }
                }
                var fontSize = constantsObj.FONT_ROBOTO_MEDIUM_120;
                if (popupType == constantsObj.SCREEN_HINT_AND_BUY) {
                    if (calendarLayer.clickedDate != undefined && calendarLayer.clickedDate != null) {
                        var dateForPuzzle = utilObj.getDateForId(calendarLayer.clickedDate);
                        var dayOfPuzzle = dateForPuzzle.getDay();
                        if (dayOfPuzzle == 3) {
                            fontSize = constantsObj.FONT_ROBOTO_MEDIUM_100;
                        }
                    }
                }
                if (popupType == constantsObj.SCREEN_RECOMMENDATION) {
                    fontSize = constantsObj.FONT_ROBOTO_MEDIUM_100;
                }
                if (popupType == constantsObj.SCREEN_THEMED_QUEST || newTypePopup) {
                    fontSize = constantsObj.FONT_HELVETICA_BOLD_100;
                }
                var fontColor = constantsObj.COLOR_BLACK;
                if (popupType == constantsObj.SCREEN_SAVE_PROGRESS) {
                    fontSize = constantsObj.FONT_HELVETICA_BOLD_100;
                    fontColor = constantsObj.COLOR_SAVE_BLUE;
                }
                if (headerBg != null) {
                    var Header = utilObj.getSprite(headerBg, xPos, yPos, 0.5, 1.0, constantsObj.SCALE_ONE * 1.15, spriteArr, popupUI, zOrder, constantsObj.SPRITE_LOCAL);
                }
                if (!(popupType == constantsObj.SCREEN_THEMED_QUEST)) {
                    if (newTypePopup) {
                        if (headerColor == null) {
                            popupLayer.headerLabel = utilObj.getBMFontLabel(header, fontSize, fontColor,
                                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - headerHeight / 2 + 20, 0.5, 0.5, popupLabels, popupUI, zOrder + 1);
                        } else {
                            popupLayer.headerLabel = utilObj.getBMFontLabel(header, fontSize, headerColor,
                                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - headerHeight / 2 + 20, 0.5, 0.5, popupLabels, popupUI, zOrder + 1);
                        }
                    } else {
                        if (headerColor == null) {
                            popupLayer.headerLabel = utilObj.getTTFFontLabel(header, fontSize, fontColor,
                                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - headerHeight / 2, 0.5, 0.5, popupLabels, popupUI, zOrder + 1);
                        } else {
                            popupLayer.headerLabel = utilObj.getTTFFontLabel(header, fontSize, headerColor,
                                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - headerHeight / 2, 0.5, 0.5, popupLabels, popupUI, zOrder + 1);
                        }
                    }
                } else {
                    var themedQuestData = themedQuestObj.getThemedQuestData();
                    var color_TQtitletextcc = homeObj.getColorFromStringCode(themedQuestData["TQtitletextcc"]);
                    popupLayer.headerLabel = utilObj.getBMFontLabel(header, fontSize, color_TQtitletextcc,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - headerHeight / 2 + 20, 0.5, 0.5, popupLabels, popupUI, zOrder + 1);

                    // Check whether to run animation for a user where out of memory is coming repetitively
                    if (gameObj.getShouldPlistRun() && false) {

                        var stencil = new cc.DrawNode();
                        stencil.drawRect(cc.p(centerXPos - constantsObj.POPUP_WIDTH / 2, centerYPos - popupHeight/2), cc.p(xPos + constantsObj.POPUP_WIDTH / 2, centerYPos + popupHeight/2), cc.color(122, 122, 122, 255), 3, cc.color(122, 122, 122, 255));
                        var content = cc.ClippingNode(stencil);
                        utilObj.addChild(popupUI, content, constantsObj.BG_Z_ORDER - 1);

                        var themedQuestData = themedQuestObj.getThemedQuestData();
                        var plistCountToRun = parseInt(themedQuestData["plistCount"]);
                        var plistOrientationArr = [themedQuestData["plistOrientation1"], themedQuestData["plistOrientation2"], themedQuestData["plistOrientation3"]];

                        // run through number of plists to run
                        // MAX of 3 plists can run at same time
                        for (var i = 0; i < plistCountToRun; i++) {
                            var orientation = plistOrientationArr[i];
                            var positionX = centerXPos;
                            var positionY = centerYPos;

                            // check orientation and update positions for plists
                            if (orientation == "TOP") {
                                positionY = centerYPos + popupHeight/2 + 20;
                            } else if (orientation == "LEFT") {
                                positionX = xPos - constantsObj.POPUP_WIDTH / 2 - 10;
                            } else if (orientation == "RIGHT") {
                                positionX = xPos + constantsObj.POPUP_WIDTH / 2 + 10;
                            } else if (orientation == "BOTTOM") {
                                positionY = yPos - (Header.getContentSize().height * constantsObj.SCALE_ONE * 1.15) - 10;
                            } else if (orientation == "CENTER") {
                                positionY = yPos - ((Header.getContentSize().height * constantsObj.SCALE_ONE * 1.15)/2);
                            }

                            var params = {
                                x: positionX ,
                                y: positionY ,
                                layer: content,
                                scale: 1.2,
                                zOrder: constantsObj.BG_Z_ORDER - 1
                            };

                            // run based on the i value for plists
                            switch(i) {
                                case 0:
                                    utilObj.delayedCallback(content, function (sender, params) {
                                        popupLayer.snowAnimation = effectsObj.playSnowEffect1(popupUI, params.p);
                                    }, 0, {p: params}, false);
                                    break;
                                case 1:
                                    utilObj.delayedCallback(content, function (sender, params) {
                                        popupLayer.snowAnimation = effectsObj.playSnowEffect2(popupUI, params.p);
                                    }, 0, {p: params}, false);
                                    break;
                                case 2:
                                    utilObj.delayedCallback(content, function (sender, params) {
                                        popupLayer.snowAnimation = effectsObj.playSnowEffect3(popupUI, params.p);
                                    }, 0, {p: params}, false);
                                    break;
                            }
                        }
                    }

                }
            }

        }


        if (popupType == constantsObj.SCREEN_PRIVACY_POLICY) {
            // var PrivacyPolicyIcon = utilObj.getSprite(constantsObj.privacy_policy_icon, xPos - 500, yPos - headerHeight / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_17 * 1.5, spriteArr, popupUI, zOrder + 1, constantsObj.SPRITE_MISC);
            //utilObj.addChild(popupLayer, PrivacyPolicyIcon, zOrder + 1);
        }

        spriteArr.push({
            "sprite": popupUI,
            "layer": popupLayer,
            "z-order": zOrder,
            "type": constantsObj.SPRITE_MISC
        });

        // utilObj.addPopupPattern(popupUI, popupHeight, headerHeight, zOrder, null, null, false, true, popupWidth);
        if (spriteArrPopup != undefined) {
            spriteArr = spriteArr.concat(spriteArrPopup);
            //utilObj.addSprites(spriteArrPopup);
        }
        utilObj.addSprites(spriteArr);
        utilObj.addLabels(popupLabels);

        utilObj.updateScreen(popupType, popupLayer, screenSubType, trackGenus, trackSpecies);
        if (popupLayer.popupShowWithAnim) {
            utilObj.dropShowV1(popupLayer, {
                preDelay: 0,
                node: popupLayer.parentPopupNode,
                blackBg: popupLayer.blackBg,
                layer: popupLayer,
                toShowFtue : popupLayer.toShowFtue
            });
        }
        if (popupType == constantsObj.SCREEN_CONTEXTUAL_HELP) {
            utilObj.showArrow(zOrder, 350, false);
        }

        if (popupType == constantsObj.SCREEN_WATCH_TO_EARN_FTUE) {
            if (!isMiniOrMidi || isBritMini) {
                //it won't enter into it as spinner is turned off and the above condition was for specific layout which is not getting used now
                utilObj.showArrow(zOrder, -(350 * canvasWidth / 1440), true, true);
            } else {
                utilObj.showArrow(zOrder, -(350 * canvasWidth / 1440), true);
            }
        }

        /*if ((lastScreen != constantsObj.SCREEN_GAME || gameObj.checkForMiniOrMidi(gameLayer.crosswordDate)) && lastScreen != constantsObj.SCREEN_STORE_LAYER && gameObj.getShowBannerAd() == true) {
            utilObj.showFadedBannerAd(utilObj.getScreenName(curScreen));
        }*/

    },

    getParentPopupNode: function () {
        return popupLayer.parentPopupNode;
    },

    hide: function () {
        loggerObj.traceLog("Hiding and removing everything");
        popupLayer.removeAllChildren();
        popupLayer.setVisible(false);
        transBgLayerV2.hide();
    },

    closeWithDefault: function () {
        freeCoins2Popup.setisFreeCoinPopupShown(false);
        popupLayer.close(popupLayer.popupCloseParams);
    },

    close: function (params) {
        if (curScreen == constantsObj.SCREEN_BONUS_ARCHIVE_POPUP && !bonusArchivePopup.getContinueButtonState()) {
            return;
        }
        if (curScreen == constantsObj.SCREEN_HINT_AND_BUY && !hintAndBuyPopup.getContinueButtonState()) {
            return;
        }
        if(curScreen == constantsObj.SCREEN_SPINNER_1 && gameObj.getSpinnerPopupAnimRunning()){
            return;
        }
        if (params == undefined || params.noAnim == undefined) {
            loggerObj.errorLog("Invalid params to popup close:", params);
        }

        //loggerObj.debugLog("popup params", JSON.stringify(params));

        //var isMiniOrMidi = gameObj.checkForMiniOrMidi(gameLayer.crosswordDate);
        /*if (lastScreen == constantsObj.SCREEN_STORE_LAYER || gameObj.getShowBannerAd() == false) {
            utilObj.hideBannerAd(utilObj.getScreenName(constantsObj.SCREEN_GAME));
            // loggerObj.debugLog("hiding banner ad here");
        } else {
            utilObj.hideBannerAd(utilObj.getScreenName(constantsObj.SCREEN_GAME));
            utilObj.showBannerAd(utilObj.getScreenName(constantsObj.SCREEN_GAME));
            // loggerObj.debugLog("showing banner ad here");
        }*/

        // if(popupLayer.hideBannerAd == true){
        //     utilObj.hideBannerAd(utilObj.getScreenName(constantsObj.SCREEN_FAQ));
        // }


        if (!popupLayer.popupOpen) {
            // loggerObj.debugLog("No popup open during attempted close");
            return;
        }
        
        if (curScreen == constantsObj.SCREEN_HIGH_LEVEL_STORE_OFFERWALL || curScreen == constantsObj.SCREEN_HIGH_LEVEL_STORE) {
            highLevelStorePopup.fadeOutStoreIcon();
        }

        if(popupLayer.snowAnimation) {
            utilObj.setVisible(popupLayer.snowAnimation, false);
            popupLayer.stopAllActions();
            popupLayer.snowAnimation = null;
        }

        if (utilObj.adVisible) {
            utilObj.unFadeBannerAd();
        }

        if (curScreen == constantsObj.SCREEN_STORE && (popupLayer.earnFreeFtueShown == true || popupLayer.watchVideoFtueShown == true)) {
            if (popupLayer.earnFreeFtueShown == true) {
                popupLayer.removeEarnFreeFtue();
            } else if (popupLayer.watchVideoFtueShown == true) {
                popupLayer.removeWatchVideoFtue();
            }
            return;
        }

        if (curScreen == constantsObj.SCREEN_SPINNER && gameObj.getIsSpinning()) {
            return;
        }
        popupLayer.resetLayerPos();
        if (params.noAnim) {
            loggerObj.debugLog("popup anims : noanim" )
            popupLayer.postHideAnim(this, params);
        } else {
            loggerObj.debugLog("popup anims : anim" )
            utilObj.hideUpV1(popupLayer, {
                preDelay: 0, node: popupLayer.parentPopupNode, blackBg: popupLayer.blackBg,
                cb: popupLayer.postHideAnim, layer: popupLayer, cbParams: params
            });
        }
    },

    postHideAnim: function (sender, params) {

        loggerObj.debugLog("popup postHideAnim")
        popupLayer.popupOpen = false; //
        popupLayer.hide(); // Always hide the current popup first. Otherwise if callback involves opening a new popup, it'll cause issues.
        if (params.dontGoToLastScreen) {
            // This case may be needed in case of redraw
            utilObj.popCurScreen();
            if (popupLayer.popupCallback != null) {
                popupLayer.popupCallback(popupLayer.popupCallbackParams);
            }
        } else {
            utilObj.goToLastScreen(popupLayer.popupRedraw, popupLayer.popupCallback, popupLayer.popupCallbackParams);
        }
    },

    setPopupCallback: function (cb, params) {
        popupLayer.popupCallback = cb;
        popupLayer.popupCallbackParams = params;
    },

    setPopupRedraw: function (params) {
        popupLayer.popupRedraw = params;
    },

    setHideBannerAd: function (params) {
        popupLayer.hideBannerAd = params;
    },

    /*
     resetCb: function () {
     popupLayer.cb = null;
     },*/

    updateHeader: function () {
        economyObj.updateCashLabel(popupLayer);
    },

    refCodeEvent: function (sender, type) {
        // loggerObj.debugLog("Ref code event:", sender, type);
        var textField = sender;
        popupLayer.refCodeEntered = textField.getString();
        loggerObj.traceLog("Text field contains:", textField.getString());
        if (utilObj.isWeb()) {
            return;
        }
        switch (type) {
            case ccui.TextField.EVENT_ATTACH_WITH_IME:
                // Moving the popup up can happen here
                // loggerObj.debugLog("Attaching with ime");
                popupLayer.shiftLayerUp(800);
                break;
            case ccui.TextField.EVENT_DETACH_WITH_IME:
                // Moving the popup down can happen here
                // loggerObj.debugLog("Detaching with ime");
                popupLayer.resetLayerPos();
                break;
            case ccui.TextField.EVENT_INSERT_TEXT:
                // cc.log("insert with IME max length:" + textField.getMaxLength());gameLayer.hintsBg.setLocalZOrder(zOrder + 2);
                // TODO: Fix below line
                // ftueObj.highlightClue(0, 0, transBg);
                var cover = utilObj.getScale9Sprite(constantsObj.black_80, xLeftPos, 0, 0, 0, (5 * canvasWidth / 9), constantsObj.HINTS_HEIGHT - 20);
                //gameLayer.addChild(cover, zOrder + 3);
                utilObj.addChild(gameLayer, cover, zOrder + 3);
                var coverRight = utilObj.getScale9Sprite(constantsObj.black_80, xLeftPos + (7 * canvasWidth / 9), 0, 0, 0, canvasWidth / 2, constantsObj.HINTS_HEIGHT - 20);
                //gameLayer.addChild(coverRight, zOrder + 3);
                utilObj.addChild(gameLayer, coverRight, zOrder + 3);
                break;
            case ccui.TextField.EVENT_DELETE_BACKWARD:
                // cc.log("delete with IME max length:" + textField.getMaxLength());
                break;
            default:
                break;
        }
    },

    shiftLayerUp: function (shiftY) {
        popupLayer.setPositionY(shiftY);
    },

    resetLayerPos: function () {
        popupLayer.setPositionY(0);
    },

    setDontGoToLastScreen: function (val) {
        popupLayer.popupCloseParams.dontGoToLastScreen = val;
    },

    showWatchVideoFtue: function () {
        var parentScreenName = utilObj.getScreenName(constantsObj.SCREEN_STORE);
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), "ftue0", constantsObj.TRACK_VIDEO, parentScreenName,
            gameObj.getPuzzleSpeciesTracking(), 1, "");

        var zOrder = constantsObj.UI_Z_ORDER;
        popupLayer.transBg = utilObj.getScale9Sprite(constantsObj.black_80, xLeftPos, 0, 0, 0, canvasWidth, constantsObj.DESIGN_HEIGHT);
        //popupLayer.addChild(popupLayer.transBg, zOrder + 1);
        utilObj.addChild(popupLayer, popupLayer.transBg, zOrder + 1);

        popupLayer.watchVideoFtueShown = true;


        var text = "Need more coins?\nClick to earn more";
        var textLabel1 = utilObj.getBMFontLabel(text, constantsObj.FONT_ROBOTO_REGULAR_100, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, centerYPos + 240, 0.5, 1);
        //popupLayer.transBg.addChild(textLabel1, zOrder);
        utilObj.addChild(popupLayer.transBg, textLabel1, zOrder);


        var arrow1 = utilObj.getSprite(constantsObj.ftue_arrow1, centerXPos - 330, 1000, 0.5, 0.5, constantsObj.SCALE_SPRITE_9);
        arrow1.setFlippedX(true);
        //popupLayer.transBg.addChild(arrow1, zOrder + 1);
        utilObj.addChild(popupLayer.transBg, arrow1, zOrder + 1);

        var watchVideoButton = utilObj.getButton(622, 180, 0.5, 0.5, centerXPos - 327,
            centerYPos - 810, constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'storePopup',
                fn: 'watch',
                screen: constantsObj.SCREEN_STORE,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_STORE,
                    f: utilObj.getScreenName(constantsObj.SCREEN_FREE_COINS),
                    g: "",
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        watchVideoButton.setColor(constantsObj.COLOR_BUTTON_ORANGE);

        var coinIcon1 = utilObj.getSprite(constantsObj.coin_png_2, 80 + 460, 90, 0.5, 0.5, constantsObj.SCALE_SPRITE_7, null, watchVideoButton, zOrder, constantsObj.SPRITE_MISC);
        //watchVideoButton.addChild(coinIcon1, zOrder);
        utilObj.addChild(watchVideoButton, coinIcon1, zOrder);

        var watchLbl = utilObj.getBMFontLabel("Watch for FREE", constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 245, 90, 0.5, 0.5, null, watchVideoButton, zOrder);
        watchLbl.setScale(0.90);
        //watchVideoButton.addChild(watchLbl, zOrder + 1);
        utilObj.addChild(watchVideoButton, watchLbl, zOrder + 1);

        //popupLayer.transBg.addChild(watchVideoButton, zOrder + 1);
        utilObj.addChild(popupLayer.transBg, watchVideoButton, zOrder + 1);
    },

    showEarnFreeFtue: function (params) {
        var parentScreen = constantsObj.SCREEN_STORE;
        if (params != undefined) {
            parentScreen = parseInt(params.pl);
        }
        var parentScreenName = utilObj.getScreenName(parentScreen);
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), "ftue0", constantsObj.TRACK_OFFERWALL, parentScreenName,
            gameObj.getPuzzleSpeciesTracking(), 1, "");

        var zOrder = constantsObj.UI_Z_ORDER;
        popupLayer.transBg = utilObj.getScale9Sprite(constantsObj.black_80, xLeftPos, 0, 0, 0, canvasWidth, constantsObj.DESIGN_HEIGHT);
        //popupLayer.addChild(popupLayer.transBg, zOrder + 1);
        utilObj.addChild(popupLayer, popupLayer.transBg, zOrder + 1);

        popupLayer.earnFreeFtueShown = true;


        var text = "Need more coins?\nClick to earn more";
        var textLabel1 = utilObj.getBMFontLabel(text, constantsObj.FONT_ROBOTO_REGULAR_100, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, centerYPos + 240, 0.5, 1);
        //popupLayer.transBg.addChild(textLabel1, zOrder);
        utilObj.addChild(popupLayer.transBg, textLabel1, zOrder);

        var storeVideoVariant = epmObj.getChosenVariant(constantsObj.EXP_STORE_VIDEO_VIEWS);
        var showVideoButton = true;
        if (storeVideoVariant == constantsObj.EXP_VAR_3 || (storeVideoVariant == constantsObj.EXP_VAR_2 && (utilObj.getCurrentTimestamp() - gameObj.getLastVideoSeenTimeStamp()) < 6 * constantsObj.SECONDS_IN_HOUR)) {
            showVideoButton = false;
        }
        if (showVideoButton) {
            var arrow1 = utilObj.getSprite(constantsObj.ftue_arrow1, centerXPos + constantsObj.POPUP_WIDTH / 2 - 330, 1000, 0.5, 0.5, constantsObj.SCALE_SPRITE_9);
            //popupLayer.transBg.addChild(arrow1, zOrder + 1);
            utilObj.addChild(popupLayer.transBg, arrow1, zOrder + 1);
        } else {
            var arrow1 = utilObj.getSprite(constantsObj.ftue_arrow1, centerXPos, 1000, 0.5, 0.5, constantsObj.SCALE_SPRITE_9);
            //popupLayer.transBg.addChild(arrow1, zOrder + 1);
            utilObj.addChild(popupLayer.transBg, arrow1, zOrder + 1);
        }

        if (showVideoButton) {
            var freeCoinsButton = utilObj.getButton(622, 180, 0.5, 0.5, centerXPos + constantsObj.POPUP_WIDTH / 2 - 330,
                centerYPos - 810, constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                    obj: 'storePopup',
                    fn: 'freeCoins',
                    screen: constantsObj.SCREEN_STORE,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: gameObj.getTrackingPuzzleTheme(),
                        o: constantsObj.TRACK_STORE,
                        f: utilObj.getScreenName(constantsObj.SCREEN_FREE_COINS),
                        g: "",
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            freeCoinsButton.setColor(constantsObj.COLOR_BUTTON_LIGHT_BLUE);

            var coinIcon1 = utilObj.getSprite(constantsObj.coin_png_2, 110 + 400, 90, 0.5, 0.5, constantsObj.SCALE_SPRITE_7, null, freeCoinsButton, zOrder, constantsObj.SPRITE_MISC);
            //freeCoinsButton.addChild(coinIcon1, zOrder);
            utilObj.addChild(freeCoinsButton, coinIcon1, zOrder);

            var freeLabel = utilObj.getBMFontLabel(stringsObj.earn_free, constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 300, 90, 0.5, 0.5, null, freeCoinsButton, zOrder);
            freeLabel.setScale(0.90);
            //freeCoinsButton.addChild(freeLabel, zOrder + 1);
            utilObj.addChild(freeCoinsButton, freeLabel, zOrder + 1);
        } else {
            var freeCoinsButton = utilObj.getButton(670, 180, 0.5, 0.5, centerXPos,
                centerYPos - 810, constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                    obj: 'storePopup',
                    fn: 'freeCoins',
                    screen: constantsObj.SCREEN_STORE,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: gameObj.getTrackingPuzzleTheme(),
                        o: constantsObj.TRACK_STORE,
                        f: utilObj.getScreenName(constantsObj.SCREEN_FREE_COINS),
                        g: "",
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            freeCoinsButton.setColor(constantsObj.COLOR_BUTTON_LIGHT_BLUE);

            var coinIcon1 = utilObj.getSprite(constantsObj.coin_png_2, 500, 90, 0.5, 0.5, constantsObj.SCALE_SPRITE_7, null, freeCoinsButton, zOrder, constantsObj.SPRITE_MISC);
            //freeCoinsButton.addChild(coinIcon1, zOrder);
            utilObj.addChild(freeCoinsButton, coinIcon1, zOrder);

            var freeLabel = utilObj.getBMFontLabel(stringsObj.earn_free, constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 260, 90, 0.5, 0.5, null, freeCoinsButton, zOrder);
            freeLabel.setScale(0.90);
            //freeCoinsButton.addChild(freeLabel, zOrder + 1);
            utilObj.addChild(freeCoinsButton, freeLabel, zOrder + 1);
        }

        //popupLayer.transBg.addChild(freeCoinsButton, zOrder + 1);
        utilObj.addChild(popupLayer.transBg, freeCoinsButton, zOrder + 1);

    },

    removeEarnFreeFtue: function () {
        if (popupLayer.earnFreeFtueShown == true) {
            popupLayer.earnFreeFtueShown = false;
            utilObj.removeChild(popupLayer, popupLayer.transBg);
            return true;
        }
    },

    removeWatchVideoFtue: function () {
        if (popupLayer.watchVideoFtueShown == true) {
            popupLayer.watchVideoFtueShown = false;
            utilObj.removeChild(popupLayer, popupLayer.transBg);
            return true;
        }
    },

    getWidthForPopup: function(popupType, extraWide) {
        var popupWidth = constantsObj.POPUP_WIDTH;
        if (extraWide) {
            popupWidth = constantsObj.LARGE_POPUP_WIDTH;
        }
        return popupWidth;
    },
});