var QuestMapLayer = cc.Layer.extend({
        screen: null,
        scrollView: null,
        path: [],
        milestoneNodes: [],
        levelNodes: {},
        milestoneNodesMap: {},
        milestoneNodesAddedPos: {},
        curMilestoneNode: null,
        curPuzzleNo: 0,
        scrollViewPos: null,
        lastScrollViewPos: null,
        bg: null,
        curMilestoneInfo: {},
        allMilestonesInfo: null,
        nextBtnXPosIndex: 0,
        nextBtnYPosIndex: 0,
        totalPuzzles: 0,
        lastLevel: 0,
        currentLevelHeight: null,
        jumpToPercent: null,
        levelNodePos: {},
        curLevelNum: 0,
        isLevelNodeAdded: {},
        totalNodesNumBelow: null,
        totalNodesNumAbove: 0,
        indexArr: [],
        milestoneLastNodeIndex: [],
        bezelShift: 0,
        curLevelHeight: null,
        puzzlesCompleted: [],
        cashLbl: null,
        masteryLbl: null,
        themeType: "",
        idIndexArr: [],
        clickedPuzzleId: 0,
        clickedPuzzleIndex: 0,
        shouldAddButton: 1,
        redirectBtn: null,
        redirectImg: null,
        toShowMileStoneAnim: null,
        solvedNodeBgAnim: null,
        solvedNodeAnim: null,
        tickAnim: null,
        activeNodeBgAnim: null,
        activeNodeAnim: null,
        activeNodeLblAnim: null,
        profileAnim: null,
        circleSpriteAnim1: null,
        circleSpriteAnim2: null,
        infoArrForAnim: null,
        activeNodeBgAnim1: null,
        activeNodeAnim1: null,
        animRunning: false,
        lblForDebug: null,
        toShowNodeChangeAnim: false,
        circle1 : null,
        circle2 : null,
        startingPos : 0,
        isAnimCompleteStarted: false,
        profile : null,
        isFromPlayQuest : false,

        back: function () {
            questMapLayer.hide();
            if(questMapLayer.isFromPlayQuest){
                var isTodaysDailyMini = false;
                var isDailyMini = gameObj.checkForDailyMini(transOutroLayer.puzzleId);
                if (isDailyMini) {
                    var dailyMiniDate = gameObj.convertDailyMiniIdToArchive(transOutroLayer.puzzleId);
                    if (!subscriptionsDTCObj.getIsSubscriptionActive() || dailyMiniDate == utilObj.getIdForDate(gameObj.getTodaysPuzzleDate())) {
                        isTodaysDailyMini = true;
                    }
                }
                var bonusArchiveAvailable = false;
                if (gameObj.getTodaysFreePuzzle() == gameLayer.crosswordDate && (gameObj.getNumberOfBonusArchiveWatched() + questMapObj.getNumberOfBonusArchiveWatched()) < runtimeObj.getNumberOfBonusArchive() && runtimeObj.getBonusArchiveOutro() == 1) {
                    bonusArchiveAvailable = true;
                }
                if ((isTodaysDailyMini || utilObj.getIdForDate(gameObj.getTodaysPuzzleDate()) == transOutroLayer.puzzleId || bonusArchiveAvailable) && homeLayoutExp == constantsObj.EXP_VAR_2) {
                    homeLayer.show();
                }else {
                    var isFromPack = gameLayer.isPuzzleFromPack;
                    if (gameLayer.isFromMapScreen) {
                        homeLayer.show();
                    } else if (isFromPack) {
                        packsLayer.show();
                    } else {
                        if (!transOutroLayer.isDailyMiniPuzzle) {
                            calendarLayer.selectedTab = constantsObj.CALENDAR_SCREEN;
                        }
                        calendarLayer.show();
                    }
                }
            }else {
                homeLayer.show();
            }
        },

        hide: function () {
            questMapLayer.removeAllChildren();
        },

        show: function (isFromPlayQuest) {
            questMapLayer.isFromPlayQuest = false;

            // assigning total puzzles to be present on layer according to varying difficulty of user and milestoneInfo for that user.
            questMapLayer.totalPuzzles = questMapObj.getTotalPuzzles();
            questMapLayer.allMilestonesInfo = questMapObj.getMilestoneInfoForQuest();

            // checks if milestone animation is to be triggered
            questMapLayer.infoArrForAnim = questMapObj.updateMilestonesCompletedArray();
            questMapLayer.toShowMileStoneAnim = false;
            questMapLayer.toShowNodeChangeAnim = false;
            questMapLayer.animRunning = false;
            if (questMapLayer.infoArrForAnim["mileStoneIndex"] != null) {
                questMapLayer.toShowMileStoneAnim = true;
            }

            // setting questMapAutoOn false here
            questMapObj.setQuestMapAutoOn(false);

            //setting back options
            if(isFromPlayQuest) {
                questMapLayer.isFromPlayQuest = true;
            }
            //

            // -------------------
            //captures the theme quest available - weekly or themed of the month.
            if (!gameObj.getIsThemedQuestLocked()) {
                questMapLayer.themeType = "themed";
            } else {
                questMapLayer.themeType = "weekly";
            }
            //---------------------

            //loggerObj.debugLog("lastLevel",gameObj.getMapLastLevel());

            //----------------------
            //fetching information of the last level and last puzzle played by user in this current weekly quest.
            questMapLayer.lastLevel = gameObj.getMapLastLevel();
            questMapLayer.puzzlesCompleted = gameObj.getPuzzlesCompletedArray();
            //----------------------

            questMapLayer.screen = constantsObj.SCREEN_QUEST_MAP;
            var screenName = utilObj.getScreenName(questMapLayer.screen);
            utilObj.hideBannerAd(utilObj.getScreenName(constantsObj.SCREEN_QUEST_MAP));

            var spriteArr = [];
            var labelArr = [];
            var zOrder = constantsObj.SPRITE_Z_ORDER;
            utilObj.updateScreenBegin(questMapLayer.screen);
            utilObj.hideBannerAd(utilObj.getScreenName(constantsObj.SCREEN_QUEST_MAP));

            var yPos = constantsObj.DESIGN_HEIGHT + topBarOffset;

            //utilObj.getSprite(constantsObj.banner_bg, centerXPos, yPos - 226, 0.5, 0, constantsObj.SCALE_ONE * 2, spriteArr, questMapLayer, zOrder + 1, constantsObj.SPRITE_LOCAL);

            //adjusting height for devices having notch area.
            var linearShift = 0;
            questMapLayer.bezelShift = 0;
            if (utilObj.isBezelScreen()) {
                linearShift = constantsObj.BEZEL_SAFE_AREA;
                if (utilObj.isIos()) {
                    questMapLayer.bezelShift = 50;
                }
            }

            yPos -= linearShift;

            questMapLayer.startingPos = (yPos - 140)/3 ;

            // add top options available on map screen.
            questMapLayer.addTopOptions(centerXPos, yPos, spriteArr, labelArr, zOrder + 1);


            questMapLayer.lblForDebug = utilObj.getBMFontLabel("", constantsObj.FONT_ROBOTO_REGULAR_50, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, centerYPos, 0.5, 0.5, labelArr, questMapLayer, zOrder + 1);
            questMapLayer.lblForDebug.setOpacity(0);


            // making ftue as true after wq map is opened
            gameObj.setIsLLPWQFtueShown(true);

            yPos -= 190;

            var topBgWidthToBeGiven = 623;
            var topBgScale = 1.67;

            //---------------------------
            // formation of black top bar giving info of the weekly quest unlocked.

            var topBg = utilObj.getScale9Sprite(constantsObj.tile_white_curved2, centerXPos, yPos, 0.5, 1.0, topBgWidthToBeGiven, 90, spriteArr, questMapLayer, zOrder + 1, constantsObj.SPRITE_MISC);
            topBg.setScale(topBgScale);
            utilObj.setColor(topBg, constantsObj.COLOR_BLACK);
            utilObj.setOpacity(topBg, constantsObj.OPACITY_85);

            var topBgWidth = topBg.getContentSize().width * 1.67;
            var topBgHeight = topBg.getContentSize().height;

            // var milestoneThemeBg = utilObj.getSprite(constantsObj.white_circle_150, 30, 25, 0, 0, constantsObj.SCALE_SPRITE_NEW_1 * 0.68, spriteArr, topBg, zOrder + 1, constantsObj.SPRITE_MISC);
            // milestoneThemeBg.setColor(constantsObj.COLOR_WHITE);

            var experiment = gameObj.getExpNewWeeklyQuestVariant();

            var now = new Date();
            var year = questMapObj.y2k(now.getYear());
            var month = now.getMonth();
            var date = now.getDate();


            var weekNum = questMapObj.getWeek(year, month, date);
            var image = questMapObj.getWeeklyThemeImage(year, weekNum, experiment);
            var themeName = questMapObj.getWeeklyThemeText(year, weekNum, experiment);


            var weeklyTheme = utilObj.getSprite(image, centerXPos - topBgWidth / 2 + 22, yPos - 17, 0, 1.0, 0.45, spriteArr, questMapLayer, zOrder + 1, constantsObj.SPRITE_MISC);

            var weeklyThemeName = utilObj.getBMFontLabel(themeName , constantsObj.FONT_HELVETICA_MEDIUM_60, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, yPos - 40, 0.5, 0.5, labelArr, questMapLayer, zOrder + 1);
            var timerText = "";

            if (questMapLayer.themeType == "themed") {
                timerText = themedQuestObj.getTqMapLayerTimerText();
            } else {
                timerText = weeklyQuestObj.getWqMapLayerTimerText();
            }

            var timerLbl = utilObj.getBMFontLabel(timerText, constantsObj.FONT_HELVETICA_50, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, yPos - 100, 0.5, 0.5, labelArr, questMapLayer, zOrder + 1);
            timerLbl.setOpacity(constantsObj.OPACITY_60);
            if (questMapLayer.themeType == "themed") {
                themedQuestObj.setTqMapLayerTimerLabel(timerLbl);
            } else {
                weeklyQuestObj.setWqMapLayerTimerLabel(timerLbl);
            }

            var infoBtnBg = utilObj.getSprite(constantsObj.info_streak, centerXPos + topBgWidth / 2 - 30, yPos - 40, 1, 1, constantsObj.SCALE_SPRITE_3, spriteArr, questMapLayer, zOrder + 1, constantsObj.SPRITE_MISC);
            infoBtnBg.setColor(constantsObj.COLOR_WHITE);
            infoBtnBg.setOpacity(constantsObj.OPACITY_80);

            var helpButton = utilObj.getButton(1041, 150, 0.5, 1.0, centerXPos, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'questMapLayer',
                fn: 'showHelpCenter',
                screen: questMapLayer.screen,
                params: {
                    "sound": constantsObj.trans_button,
                    "sound_on": true,
                    "topBg" : topBg,
                    "weeklyTheme" : weeklyTheme,
                    "weeklyThemeName" : weeklyThemeName,
                    "timerLbl" : timerLbl,
                    "infoBtn" : infoBtnBg
                },
                feedBackType: constantsObj.ZOOMIN_FEEDBACK
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
            questMapLayer.addChild(helpButton, zOrder + 2);

            //-------------------------------------------

           // main logic of the linear progression starts here.

            questMapLayer.isLevelNodeAdded = {};
            questMapLayer.mileStoneLastNodeIndex = [];
            var totalMilestones = 3;


            if (questMapLayer.lastLevel > 0 && questMapLayer.lastLevel < questMapLayer.totalPuzzles) {
                if (questMapLayer.puzzlesCompleted[questMapLayer.lastLevel - 1]["completed"] && !questMapLayer.puzzlesCompleted[questMapLayer.lastLevel - 1]["animShown"]) {
                    //show animation of that puzzle here and set its animShown true.
                    // if (questMapLayer.toShowMileStoneAnim) {
                    //     questMapLayer.puzzlesCompleted[questMapLayer.lastLevel - 1]["completed"] = false;
                    // }
                    questMapLayer.puzzlesCompleted[questMapLayer.lastLevel - 1]["animShown"] = true;
                    questMapLayer.toShowNodeChangeAnim = true;
                }
            }

            if (questMapLayer.toShowMileStoneAnim) {
                questMapLayer.toShowNodeChangeAnim = false;
            }

            if ((questMapLayer.lastLevel + 1) <= questMapLayer.totalPuzzles) {
                questMapLayer.curLevelNum = questMapLayer.lastLevel + 1;
                if (questMapLayer.toShowMileStoneAnim || questMapLayer.toShowNodeChangeAnim) {
                    questMapLayer.curLevelNum = questMapLayer.lastLevel;
                }
            } else {
                questMapLayer.curLevelNum = questMapLayer.totalPuzzles;
            }

            var bucket = questMapObj.getBucketAllocated();

            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", constantsObj.TRACK_WQ_MAP, constantsObj.TRACK_VIEW, bucket + "_" + questMapLayer.curLevelNum , "", "", "");

            //loggerObj.debugLog("curpuzzle1", questMapLayer.lastLevel, questMapLayer.curLevelNum);
            // questMapLayer.curLevelNum = (questMapLayer.lastLevel + 1 ) <= questMapLayer.totalPuzzles? questMapLayer.lastLevel + 1 : questMapLayer.totalPuzzles;
            var curMilestone = 0;


            if (questMapLayer.themeType == "themed") {
                curMilestone = questMapObj.getCurrentThemedQuestMilestone();
                if (questMapLayer.toShowMileStoneAnim) {
                    curMilestone = questMapObj.getLastThemedMileStoneCompleted();
                }
            } else {
                curMilestone = questMapObj.getCurrentWeeklyQuestMilestone();
                if (questMapLayer.toShowMileStoneAnim) {
                    curMilestone = questMapObj.getLastWeeklyMileStoneCompleted();
                }
            }

            questMapLayer.curMileStoneInfo = questMapLayer.allMilestonesInfo[curMilestone - 1];
            var curMilestoneInfo = questMapLayer.curMileStoneInfo;

            var lastPuzIndex = curMilestoneInfo["index"];
            var puzStartIndex = lastPuzIndex - curMilestoneInfo["totalPuzzles"];
           // loggerObj.debugLog("openPuzzle", questMapLayer.curLevelNum, questMapLayer.curMileStoneInfo["index"], questMapLayer.curMileStoneInfo["totalPuzzles"]);

            var curPuzzleIndex = questMapLayer.curLevelNum - (questMapLayer.curMileStoneInfo["index"] - questMapLayer.curMileStoneInfo["totalPuzzles"] );
            //loggerObj.debugLog("levelnum", questMapLayer.curLevelNum, curPuzzleIndex, questMapLayer.lastLevel, utilObj.getStringifiedJson(questMapLayer.curMileStoneInfo));
            var puzState = constantsObj.STATE_PUZ_COMPLETED;


            var curMilestoneIndex = curMilestoneInfo["id"];
            questMapLayer.curPuzzleNo = curPuzzleIndex;

            //----------------------------------

            //calculation number of paths required to populate all nodes including milestones also.

            var numPaths = Math.floor((questMapLayer.totalPuzzles + 3) / 4);
            var addSecondPath = true;
            if ((numPaths * 4) < questMapLayer.totalPuzzles + 3) {
                var diff = questMapLayer.totalPuzzles + 3 - (numPaths * 4);
                if (diff > 1) {
                    numPaths += 1;
                }
                if(diff <= 3 && diff > 1){
                    addSecondPath = false;
                }
            } else if((numPaths * 4) == questMapLayer.totalPuzzles + 3){
                diff = 0;
            }

            var scaledPathHeight = 1336;
            var mapHeight = (scaledPathHeight) * numPaths;
            var scrollViewHeight = mapHeight + 366 + 50 + questMapLayer.startingPos - 226;

            if(diff == 1){
                scrollViewHeight += 334;
            }
            if(!addSecondPath){
                scrollViewHeight -= (scaledPathHeight/2);
                if(diff == 3){
                    scrollViewHeight += 334;
                }
            }

           //-------------------------------------

            // creating scrollview of the layer.
            questMapLayer.scrollView = new ccui.ScrollView();
            questMapLayer.scrollView.setDirection(ccui.ScrollView.DIR_VERTICAL);
            questMapLayer.scrollView.setTouchEnabled(true);
            questMapLayer.scrollView.setScrollBarEnabled(false);
            questMapLayer.scrollView.setInertiaScrollEnabled(true);
            questMapLayer.scrollView.setContentSize(cc.size(canvasWidth, constantsObj.DESIGN_HEIGHT + linearShift + topBarOffset));
            questMapLayer.scrollView.setPosition(centerXPos, constantsObj.DESIGN_HEIGHT + linearShift + topBarOffset);
            questMapLayer.scrollView.setBounceEnabled(true);
            questMapLayer.scrollView.setAnchorPoint(0.5, 1.0);
            questMapLayer.scrollView.setBackGroundColor(constantsObj.COLOR_YELLOW_02);
            questMapLayer.scrollView.setInnerContainerSize(cc.size(canvasWidth, scrollViewHeight));
            questMapLayer.scrollViewPos = 0;

            //---------------------------------------

            // adding event listener to the scrollview to detect movements on scrollview by user and to activate redirect button whenever required.
            questMapLayer.scrollView.addEventListener(function (scope, eventType) {

                questMapLayer.lastScrollViewPos = questMapLayer.scrollViewPos;
                // if(questMapLayer.lastScrollViewPos != null) {
                //     var lastScrollViewYPos = Math.abs(questMapLayer.lastScrollViewPos.y);
                // }else{
                //     var lastScrollViewYPos = Math.abs(questMapLayer.scrollViewPos.y);
                // }
                questMapLayer.scrollViewPos = questMapLayer.scrollView.getInnerContainerPosition();
                var scrollViewYPos = Math.abs(questMapLayer.scrollViewPos.y);

                // Redirect Button Logic
                var curLevelPos = 0;
                if (questMapLayer.levelNodes != null && curMilestoneInfo != null && questMapLayer.curPuzzleNo != null &&
                    questMapLayer.levelNodes[curMilestoneInfo["id"] - 1][questMapLayer.curPuzzleNo - 1] != undefined && curMilestoneInfo["id"] - 1 >= 0 &&
                    questMapLayer.curPuzzleNo - 1 >= 0) {
                    curLevelPos = questMapLayer.levelNodes[curMilestoneInfo["id"] - 1][questMapLayer.curPuzzleNo - 1]["y"];
                }
                if (questMapLayer.levelNodes != null && questMapLayer.levelNodes != undefined && questMapLayer.shouldAddButton == 1) {
                    if (scrollViewYPos + constantsObj.DESIGN_HEIGHT < curLevelPos) {
                        questMapLayer.addRedirectButton("up");
                    } else if (scrollViewYPos > curLevelPos) {
                        questMapLayer.addRedirectButton("down");
                    }
                }
                if (scrollViewYPos + constantsObj.DESIGN_HEIGHT > curLevelPos && scrollViewYPos < curLevelPos) {
                    questMapLayer.shouldAddButton = 1;
                    questMapLayer.hideRedirectBtn(questMapLayer, questMapLayer.redirectBtn);
                }
            });

            //--------------------------------------

            // calculate the positions of level nodes and milestone nodes on LLP.
            questMapLayer.calculateLevelNodesAndMilestoneNodesPos();

            //--------------------------------------

            // curved paths making according to their required number. Required curved one full paths are already calculated earlier.

            var pathCounter = 1;
            var yPos = questMapLayer.startingPos;

            var vector_color = constantsObj.COLOR_BLACK;
            var realistic_color = constantsObj.COLOR_WHITE;

            if(questMapObj.getColorForVectorPath(year , weekNum)!= undefined && questMapObj.getColorForVectorPath(year , weekNum)!= null){
                vector_color = questMapObj.getColorForVectorPath(year , weekNum);
            }
            if(questMapObj.getColorForRealisticPath(year , weekNum)!= undefined && questMapObj.getColorForRealisticPath(year , weekNum)!= null){
                realistic_color = questMapObj.getColorForRealisticPath(year , weekNum);
            }

            for (var i = 0; i < numPaths; i++) {
                var image = constantsObj.mapPath;
                var scale = 0.63 * constantsObj.SCALE_SPRITE_NEW_1;
                if(diff == 2 && i == numPaths - 1 && !addSecondPath){
                    image = constantsObj.mapPath2;
                    scale = 0.63 * 1.5;
                }
                questMapLayer.path[pathCounter] = utilObj.getSprite(image, centerXPos + 200, yPos + linearShift, 0.5, 0, scale, spriteArr, questMapLayer.scrollView, zOrder + 1, constantsObj.SPRITE_LOCAL);
                yPos = yPos + questMapLayer.path[pathCounter].getContentSize().height * scale - 15;
                pathCounter++;

                var yShift = (questMapLayer.path[pathCounter - 1].getContentSize().height * scale) / 2;
                var rotation = 180;

                var xShift = 0;
                if((i == numPaths - 1 && addSecondPath) || i < numPaths - 1) {
                     if(diff == 0 && i == numPaths - 1 && addSecondPath){
                         image = constantsObj.mapPath2;
                         scale = 0.63 * 1.5 ;
                         yShift = (questMapLayer.path[pathCounter - 1].getContentSize().height * scale) / 4 + 50;
                         xShift = 25;
                         rotation = -270;

                     }
                    questMapLayer.path[pathCounter] = utilObj.getSprite(image, centerXPos - 200 - xShift, yPos + linearShift + yShift, 0.5, 0.5, scale, spriteArr, questMapLayer.scrollView, zOrder + 1, constantsObj.SPRITE_LOCAL);
                    questMapLayer.path[pathCounter].rotation = rotation;
                    yPos = yPos + questMapLayer.path[pathCounter].getContentSize().height * scale - 15;
                }
                if (experiment == constantsObj.EXP_VAR_2) {
                    if((i == numPaths - 1 && addSecondPath) || i < numPaths - 1) {
                        questMapLayer.path[pathCounter].setColor(realistic_color);
                    }
                    questMapLayer.path[pathCounter - 1].setColor(realistic_color);

                } else {
                    if((i == numPaths - 1 && addSecondPath) || i < numPaths - 1) {
                        questMapLayer.path[pathCounter].setColor(vector_color);
                    }
                    questMapLayer.path[pathCounter - 1].setColor(vector_color);
                }
                if((i == numPaths - 1 && addSecondPath) || i < numPaths - 1) {
                    questMapLayer.path[pathCounter].setOpacity(constantsObj.OPACITY_90);
                }
                questMapLayer.path[pathCounter - 1].setOpacity(constantsObj.OPACITY_90);
                pathCounter++;
            }

            //---------------------------------------

            // get background image for the layer according to the theme of present week.

            var scaleFitToHeight = (constantsObj.DESIGN_HEIGHT + linearShift + topBarOffset) / 2560;
            var scaleFitToWidth = canvasWidth /1440;

            var scaleOfBg = scaleFitToHeight;
            if(scaleFitToWidth > scaleFitToHeight){
                scaleOfBg = scaleFitToWidth;
            }

            if (curMilestoneIndex <= totalMilestones) {
                questMapLayer.bg = utilObj.getSprite(questMapObj.getBackGroundPath(year, weekNum, experiment), centerXPos, centerYPos, 0.5, 0.5, scaleOfBg , spriteArr, questMapLayer, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_LOCAL);
            }

            //---------------------------------------
            // jump to the present node whenever layer is opened.

            var jumpToMilestone = 0;
            if (!(curMilestoneIndex == 1 && curPuzzleIndex <= 2)) {
                if (questMapLayer.levelNodes != null && questMapLayer.levelNodes != undefined) {
                    try {
                        if (questMapLayer.levelNodes[curMilestoneIndex - 1] == undefined || questMapLayer.levelNodes[curMilestoneIndex - 1][curPuzzleIndex - 1] == undefined || questMapLayer.levelNodes[curMilestoneIndex - 1][curPuzzleIndex - 1]["y"] == undefined) {
                            trackObj.trackCounter(constantsObj.TRACK_DEBUG, "", "", "wq_error", curMilestoneIndex + "_" + curPuzzleIndex, "", "", "", "");
                            questMapObj.resetVariablesForNewQuest();
                            questMapLayer.redraw();
                            return ;
                        }
                    } catch (err){
                        trackObj.trackCounter(constantsObj.TRACK_DEBUG, "", "", "wq_error_catch", curMilestoneIndex + "_" + curPuzzleIndex, "", "", "", "");
                        questMapObj.resetVariablesForNewQuest();
                        questMapLayer.redraw();
                        return ;
                    }
                    jumpToMilestone = scrollViewHeight - (questMapLayer.levelNodes[curMilestoneIndex - 1][curPuzzleIndex - 1]["y"] + (constantsObj.DESIGN_HEIGHT + linearShift + topBarOffset+ 366)/2);
                    questMapLayer.jumpToPercent = ((jumpToMilestone / (scrollViewHeight - (constantsObj.DESIGN_HEIGHT + linearShift + topBarOffset ))) * 100);

                    if ( questMapLayer.jumpToPercent < 0 ) {
                        questMapLayer.jumpToPercent = 0;
                    }
                    if ( questMapLayer.jumpToPercent > 100 ) {
                        questMapLayer.jumpToPercent = 100;
                    }
                    questMapLayer.jumpToCurrentNode(questMapLayer.jumpToPercent, true);
                    // var tempPos1 = questMapLayer.levelNodes[curMilestoneIndex - 1][curPuzzleIndex - 1]["y"] - Math.abs(questMapLayer.scrollView.getInnerContainerPosition().y);
                    // var tempPos2 = centerYPos - tempPos1;
                    // var jump = scrollViewHeight - questMapLayer.levelNodes[curMilestoneIndex - 1][curPuzzleIndex - 1]["y"] - centerYPos + tempPos2;
                    // if (curMilestoneIndex == totalMilestones && curPuzzleIndex >= curMilestoneInfo["totalPuzzles"] - 1) {
                    //     jump = 0;
                    // }
                    // questMapLayer.jumpToPercent = ((jump / scrollViewHeight) * 100);
                    // questMapLayer.jumpToCurrentNode(questMapLayer.jumpToPercent, true);
                }
            } else {
                questMapLayer.jumpToPercent = 100;
                questMapLayer.jumpToCurrentNode(questMapLayer.jumpToPercent, true);
            }
           //--------------------------------------------

            questMapLayer.curLevelNum = questMapLayer.curPuzzleNo + curMilestoneInfo["index"] - curMilestoneInfo["totalPuzzles"];
            //loggerObj.debugLog("curpuzzle2", questMapLayer.curLevelNum);
            var totalPuzzles = questMapLayer.totalPuzzles;
            var numNodesToAdd = totalPuzzles;
            if (curMilestoneInfo["id"] == 1) {
                questMapLayer.totalNodesNumBelow = questMapLayer.curPuzzleNo - 1;
                questMapLayer.totalNodesNumAbove = numNodesToAdd - questMapLayer.curPuzzleNo;
            } else if (curMilestoneInfo["id"] == totalMilestones) {
                questMapLayer.totalNodesNumAbove = Math.min(totalPuzzles - questMapLayer.curLevelNum, numNodesToAdd / 2);
                questMapLayer.totalNodesNumBelow = numNodesToAdd - questMapLayer.totalNodesNumAbove;
            } else {
                questMapLayer.totalNodesNumBelow = numNodesToAdd / 2;
                questMapLayer.totalNodesNumAbove = numNodesToAdd / 2;
            }

            // start populating level nodes according to the positions calculated earlier.
            var startLevelNum = 1;
            for (var i = 0; i <= numNodesToAdd; i++) {
                questMapLayer.addLevelNodes(startLevelNum);
                startLevelNum++;
            }


            questMapLayer.curMilestoneNode = curMilestoneIndex - 1;
            questMapLayer.scrollViewPos = questMapLayer.milestoneNodesAddedPos[questMapLayer.curMilestoneNode];
            utilObj.addChild(questMapLayer, questMapLayer.scrollView, zOrder + 1);

            //------------------------------------

            // buttons on the lower region of the layer are added here.

            // free video watch button formation.

            var freeVideoBtnBg = utilObj.getSprite(constantsObj.white_circle_150, xRightPos - 30, 50, 1.0, 0, constantsObj.SCALE_SPRITE_NEW_1 * 1.42, spriteArr, questMapLayer, zOrder + 1, constantsObj.SPRITE_MISC);
            freeVideoBtnBg.setColor(constantsObj.COLOR_WHITE);

            var freeVideoBtnBlack = utilObj.getSprite(constantsObj.white_circle_150, freeVideoBtnBg.getContentSize().width / 2, freeVideoBtnBg.getContentSize().height / 2, 0.5, 0.5, 0.95, spriteArr, freeVideoBtnBg, zOrder + 1, constantsObj.SPRITE_MISC);
            freeVideoBtnBlack.setColor(constantsObj.COLOR_BLACK);
            freeVideoBtnBlack.setOpacity(constantsObj.OPACITY_80);

            var yShift = 0;
            var xShift = 0;
            if (isTablet) {
                yShift = 10;
                xShift = 10;
            }
            var videoIcon = utilObj.getSprite(constantsObj.w2eIcon, freeVideoBtnBlack.getContentSize().width / 2, freeVideoBtnBlack.getContentSize().height / 2 + 20, 0.5, 0.5, 0.5, spriteArr, freeVideoBtnBlack, zOrder + 1, constantsObj.SPRITE_MISC);
            var freeText = utilObj.getBMFontLabel("FREE", constantsObj.FONT_ROBOTO_REGULAR_50, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xRightPos - 113, 90, 1.0, 0, labelArr, questMapLayer, zOrder + 1);
            var coin = utilObj.getSprite(constantsObj.coin_png_2, xRightPos - 70, 100, 1.0, 0, constantsObj.SCALE_SPRITE_NEW_1 * 0.3, spriteArr, questMapLayer, zOrder + 1, constantsObj.SPRITE_MISC);
            var childArr = [freeVideoBtnBg];

            var freeVideoBtn = utilObj.getButton(205, 205, 1.0, 0,
                xRightPos - 30, 50, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: 'questMapLayer',
                    fn: 'freeVideoFunc',
                    screen: questMapLayer.screen,
                    params: {
                        "sound": constantsObj.trans_button,
                        "sound_on": true,
                    },
                    child: childArr,
                    feedBackType: constantsObj.ZOOMIN_FEEDBACK
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            questMapLayer.addChild(freeVideoBtn, zOrder + 2);

            //------------------------------------------

            // back button on the layer to drive it to the homeLayer.


            var backBtnBg = utilObj.getSprite(constantsObj.white_circle_150, xLeftPos + 30, 50, 0, 0, constantsObj.SCALE_SPRITE_NEW_1 * 1.42, spriteArr, questMapLayer, zOrder + 1, constantsObj.SPRITE_MISC);
            backBtnBg.setColor(constantsObj.COLOR_WHITE);

            var backBtnBlack = utilObj.getSprite(constantsObj.white_circle_150, backBtnBg.getContentSize().width / 2, backBtnBg.getContentSize().height / 2, 0.5, 0.5, 0.95, spriteArr, backBtnBg, zOrder + 1, constantsObj.SPRITE_MISC);
            backBtnBlack.setColor(constantsObj.COLOR_BLACK);
            backBtnBlack.setOpacity(constantsObj.OPACITY_80);

            var back_arrow = utilObj.getSprite(constantsObj.arrow_01, backBtnBg.getContentSize().width / 2, backBtnBg.getContentSize().height / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.5, spriteArr, backBtnBg, zOrder + 1, constantsObj.SPRITE_MISC);


            var backBtn = utilObj.getButton(205, 205, 0, 0,
                xLeftPos + 30, 50, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: 'questMapLayer',
                    fn: 'back',
                    screen: questMapLayer.screen,
                    params: {
                        "sound": constantsObj.trans_button,
                        "sound_on": true,
                    },
                    child: [backBtnBg],
                    feedBackType: constantsObj.ZOOMIN_FEEDBACK
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            questMapLayer.addChild(backBtn, zOrder + 2);

            //------------------------------------------
            // surfacing of today's section on quest layer.

            if(((experiment == constantsObj.EXP_VAR_1 || experiment == constantsObj.EXP_VAR_2) && (epmObj.getChosenVariant(constantsObj.EXP_QUEST_MARKETING) == constantsObj.EXP_VAR_1 || epmObj.getChosenVariant(constantsObj.EXP_QUEST_MARKETING) == constantsObj.EXP_VAR_2))) {
                var completedPuzzlesNumber = 0;
                if(homeLayer.isTodaySectionCompleted()){
                    completedPuzzlesNumber = 2;
                }else if((!homeLayer.isTodaysPuzzleSeen(true) && homeLayer.isDailyMiniCompleted()) || (homeLayer.isTodaysPuzzleSeen(true) && !homeLayer.isDailyMiniCompleted())){
                    completedPuzzlesNumber = 1;
                }
                var previousCompletedPuzzleCount = gameObj.getTodaysSectionCompletedPuzzleCount();
                var puzzleRemaining = 2 - completedPuzzlesNumber;
                if(puzzleRemaining > 0 || completedPuzzlesNumber > previousCompletedPuzzleCount) {
                    if(!(previousCompletedPuzzleCount == constantsObj.NOT_FOUND && puzzleRemaining == 0)){
                        if(previousCompletedPuzzleCount == constantsObj.NOT_FOUND) {
                            previousCompletedPuzzleCount = 0;
                        }
                        questMapLayer.createTodayPuzzlesSection(spriteArr, labelArr, completedPuzzlesNumber, previousCompletedPuzzleCount);
                    }
                }
            }

            //------------------------------------------

            utilObj.addSprites(spriteArr);
            utilObj.addLabels(labelArr);
            utilObj.updateScreen(questMapLayer.screen, questMapLayer);

            //-------------------------------------------

            // to check if any previous animation is remaining to show .
            
            if (questMapLayer.toShowMileStoneAnim) {
                questMapLayer.fadeOutRings();
                utilObj.delayedCallback(questMapLayer, questMapLayer.showMileStoneAnim, 0.5, {scrollHeight: scrollViewHeight, linearShift: linearShift}, false)

                // disable touch for the scrollview
                questMapLayer.scrollView.setTouchEnabled(false);
                questMapLayer.animRunning = true;
            } else if (questMapLayer.toShowNodeChangeAnim) {
                questMapLayer.fadeOutRings();
                utilObj.delayedCallback(questMapLayer, questMapLayer.showNodeChangeAnim, 0.5, {scrollHeight: scrollViewHeight, linearShift: linearShift, index: questMapLayer.lastLevel + 1}, false);
                questMapLayer.scrollView.setTouchEnabled(false);
                questMapLayer.animRunning = true;
            }

            //--------------------------------------------

            // marking redraw of screen false here if it is true
            if(gameObj.getIsRedraw()){
                gameObj.setIsRedraw(false);
            }
            //
        },

        /**
         * today puzzle surfacing on quest layer
         * will have different text depending on how many today's puzzles are completed out of 2.
         * will be shown only in variant 3 of quest_revamp.
         * @param spriteArr
         * @param labelArr
         * @param completedPuzzlesNumber
         * @param previousCompletedPuzzleCount
         * @returns {number}
         */
        createTodayPuzzlesSection : function(spriteArr , labelArr, completedPuzzlesNumber, previousCompletedPuzzleCount) {
            var d = gameObj.getTodaysPuzzleDate();
            var day = d.getDay();
            var date = d.getDate();
            var month = d.getMonth();
            var zOrder = constantsObj.SPRITE_Z_ORDER;
            var color_theme_start = constantsObj.COLOR_THEME_COLLECTION_START[day];
            var color_theme_end = constantsObj.COLOR_THEME_COLLECTION_END[day];
            var color_theme = new cc.LayerGradient(color_theme_start, color_theme_end, null, null);
            var bgWidth = 843;
            var bgHeight = 180;
            var todaysSectionYPos = 80;

            utilObj.getScale9Sprite(constantsObj.map_shadow, centerXPos, 0, 0.5, 0, canvasWidth, 1126, spriteArr, questMapLayer, zOrder, constantsObj.SPRITE_MISC);
            var outline = utilObj.getScale9Sprite(constantsObj.todaySectionHolderOutline, centerXPos, todaysSectionYPos, 0.5, 0, bgWidth, bgHeight, spriteArr, questMapLayer, zOrder + 1, constantsObj.SPRITE_MISC);
            var todaySectionBg = utilObj.getScale9Sprite(constantsObj.trans_button, centerXPos, todaysSectionYPos, 0.5, 0, bgWidth, bgHeight, spriteArr, questMapLayer, zOrder + 1, constantsObj.SPRITE_MISC);
            utilObj.setCascadeOpacityEnabled(todaySectionBg, true);

            var stencil = new cc.Scale9Sprite(constantsObj.todaySectionHolder);
            stencil.attr({
                anchorX: 0.5,
                anchorY: 0,
                width: bgWidth,
                height: bgHeight
            });
            utilObj.setPosition(stencil, centerXPos, todaysSectionYPos);
            var clipperNode = cc.ClippingNode(stencil);
            clipperNode.setAlphaThreshold(0);
            utilObj.setCascadeOpacityEnabled(clipperNode, true);
            utilObj.addChild(questMapLayer, clipperNode, zOrder + 1);

            color_theme.anchorX = 0.5;
            color_theme.anchorY = 0;
            color_theme.ignoreAnchorPointForPosition(false);
            color_theme.setPositionX(centerXPos);
            color_theme.setPositionY(todaysSectionYPos);
            color_theme.width = bgWidth;
            color_theme.height = bgHeight;
            color_theme.setVector(new cc.p(1, 0));
            utilObj.addChild(clipperNode, color_theme, zOrder + 1);
            utilObj.setCascadeOpacityEnabled(color_theme, true);
            utilObj.setColor(todaySectionBg, color_theme_start);
            var alphaLayerChild = uiCreatorObj.addAlphaLayerChild(todaySectionBg, clipperNode, zOrder + 10, spriteArr);
            var childArr = [alphaLayerChild];
            var todaysSectionButton = utilObj.getButton(bgWidth, bgHeight, 0.5, 0,
                centerXPos, todaysSectionYPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: 'questMapLayer',
                    fn: 'checkAndOpenAvailableTodaysPuzzle',
                    screen: questMapLayer.screen,
                    params: {sound: false},
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: "",
                        c: "",
                        o: constantsObj.TRACK_WQ_MAP,
                        f: "dc_click",
                        g: "",
                        s: "",
                        co: "",
                        oppId: ""
                    },
                    child: childArr,
                    feedBackType: constantsObj.DARKEN_FEEDBACK_BOUNDED_PREADDED_CHILD
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            utilObj.addChild(questMapLayer, todaysSectionButton, zOrder + 2);
            var text = "Today's Challenge";
            var lastPuzzlesCompleted = gameObj.getDailyPuzzlesCompleted();
            if (lastPuzzlesCompleted != completedPuzzlesNumber) {
                trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", constantsObj.TRACK_WQ_MAP, "dc_update", (day + 1) + "_" + completedPuzzlesNumber, "", "", "");
            }
            gameObj.setDailyPuzzlesCompleted(completedPuzzlesNumber);

            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", constantsObj.TRACK_WQ_MAP, "dc_view", (day + 1) + "_" + completedPuzzlesNumber, "", "", "");


            var todayChallengeText = utilObj.getBMFontLabel(text, constantsObj.FONT_HELVETICA_MEDIUM_60, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), 176, 87, 0, 0, labelArr, color_theme, zOrder + 1);

            var dateSection = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, 31, 30, 0, 0, 122, 122, spriteArr, color_theme, zOrder + 1, constantsObj.SPRITE_MISC);
            utilObj.setCascadeOpacityEnabled(dateSection, true);

            var dateLabel = utilObj.getBMFontLabel(date, constantsObj.FONT_HELVETICA_MEDIUM_75, color_theme_start,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), dateSection.getContentSize().width / 2, 40, 0.5, 0, labelArr, dateSection, zOrder + 1);

            var formattedMonth = stringsObj.month_list[month].substr(0, 3);

            var monthSection = utilObj.getBMFontLabel(formattedMonth, constantsObj.FONT_HELVETICA_REGULAR_50, color_theme_start,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), dateSection.getContentSize().width / 2, 5, 0.5, 0, labelArr, dateSection, zOrder + 1);

            var completedSection = utilObj.getBMFontLabel("Completed: " + completedPuzzlesNumber + "/2", constantsObj.FONT_HELVETICA_MEDIUM_50, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), 176, 25.5, 0, 0, labelArr, color_theme, zOrder + 1);
            utilObj.setOpacity(completedSection, constantsObj.OPACITY_90);

            var weSectionBg = utilObj.getScale9Sprite(constantsObj.todaySectionHolder, 725, 23, 0, 0, 91.5, 131, spriteArr, color_theme, zOrder + 1, constantsObj.SPRITE_MISC);
            utilObj.setColor(weSectionBg, constantsObj.COLOR_WHITE);
            utilObj.setOpacity(weSectionBg, constantsObj.OPACITY_90);
            utilObj.setCascadeOpacityEnabled(weSectionBg, true);

            var dayText = utilObj.getBMFontLabel(constantsObj.streakDayMap[day], constantsObj.FONT_HELVETICA_MEDIUM_45, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), weSectionBg.getContentSize().width / 2, 69, 0.5, 0, labelArr, weSectionBg, zOrder + 1);
            utilObj.setOpacity(dayText, constantsObj.OPACITY_60);

            var tickImageDetails = questMapLayer.getTickImageDetailsForTodaysSection(completedPuzzlesNumber);
            var tickImage = tickImageDetails.image;
            var tickColor = tickImageDetails.color;
            var tickOpacity = tickImageDetails.opacity;
            var scale = tickImageDetails.scale;

            var newTick = utilObj.getSprite(tickImage, weSectionBg.getContentSize().width / 2, 38, 0.5, 0.5, scale, spriteArr, weSectionBg, constantsObj.FTUE_Z_ORDER + 1, constantsObj.SPRITE_MISC);
            utilObj.setColor(newTick, tickColor);
            utilObj.setOpacity(newTick, tickOpacity);

            var oldTick = null;
            var showTickAnimation = false;
            var puzzlesRemaining = 2 - completedPuzzlesNumber;
            if (completedPuzzlesNumber > previousCompletedPuzzleCount) {
                var oldTickImageDetails = questMapLayer.getTickImageDetailsForTodaysSection(previousCompletedPuzzleCount);
                var oldTickImage = oldTickImageDetails.image;
                var oldTickColor = oldTickImageDetails.color;
                var oldTickOpacity = oldTickImageDetails.opacity;
                var oldTickScale = oldTickImageDetails.scale;

                oldTick = utilObj.getSprite(oldTickImage, weSectionBg.getContentSize().width / 2, 38, 0.5, 0.5, oldTickScale, spriteArr, weSectionBg, constantsObj.FTUE_Z_ORDER + 1, constantsObj.SPRITE_MISC);
                utilObj.setColor(oldTick, oldTickColor);
                utilObj.setOpacity(oldTick, oldTickOpacity);

                utilObj.setOpacity(newTick, constantsObj.OPACITY_0);
                showTickAnimation = true;
                gameObj.resetDcAnimationLastSeenTimestamp();
            }

            var notifBubble = utilObj.getSprite(constantsObj.white_circle_150, bgWidth - 37, bgHeight, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.45, spriteArr, todaySectionBg, zOrder + 2, constantsObj.SPRITE_MISC);
            utilObj.setColor(notifBubble, constantsObj.COLOR_RED_01);
            utilObj.setCascadeOpacityEnabled(notifBubble, true);

            var notifBubbleAnim = utilObj.getSprite(constantsObj.white_circle_150, bgWidth - 37, bgHeight, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.45, spriteArr, todaySectionBg, zOrder + 1, constantsObj.SPRITE_MISC);
            utilObj.setColor(notifBubbleAnim, constantsObj.COLOR_RED_01);

            utilObj.getBMFontLabel(puzzlesRemaining + "", constantsObj.FONT_HELVETICA_MEDIUM_70, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), notifBubble.getContentSize().width / 2, notifBubble.getContentSize().height / 2, 0.5, 0.5, labelArr, notifBubble, zOrder + 1);

            // todays section animation should not surface in case of screen redraw
            var showTodaysSectionAnimation = true;
            if (gameObj.getIsRedraw()) {
                showTodaysSectionAnimation = false;
            }
            //

            if (showTodaysSectionAnimation) {
                // showing todays section animation here
                var showNotifBubbleAnimation = questMapObj.shouldShowNotifBubbleAnimation();
                var showTodaysSectionFadeOutAnimation = false;
                // if the number of daily puzzle not yet solved is less than equal to zero, notif bubble ui and shine and notif bubble animation should not be shown
                if (puzzlesRemaining <= 0) {
                    showNotifBubbleAnimation = false;
                    utilObj.setVisible(notifBubble, false);
                    utilObj.setVisible(notifBubbleAnim, false);
                    showTodaysSectionFadeOutAnimation = true;
                }


                // complete section move up and fade in animation here
                var animDelay = questMapObj.getExtraDelayForSurfacingTodaysChallengeSection();
                animDelay = animObj.runTodaysSectionMoveUpAndFadeInAnimation(todaySectionBg, outline, todaysSectionButton, clipperNode, animDelay);
                // if tick animation conditions meet, then animation here
                if (showTickAnimation) {
                    animDelay = animObj.runTickAnimation(oldTick, newTick, weSectionBg, animDelay, bgWidth, bgHeight);
                    trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", constantsObj.TRACK_WQ_MAP, "dc_completion_anim", "", "", "", "");
                }
                // shine and notif bubble animation here
                if (showNotifBubbleAnimation) {
                    trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", constantsObj.TRACK_WQ_MAP, "dc_anim", "", "", "", "");
                    // shine animation here
                    var shineNode = utilObj.getSprite(constantsObj.shine, centerXPos - bgWidth / 2, 100 + bgHeight / 2, 0.5, 0.5, 0.80);
                    utilObj.setRotation(shineNode, 40);
                    utilObj.setColor(shineNode, constantsObj.COLOR_WHITE);
                    utilObj.addChild(clipperNode, shineNode, zOrder + 2);
                    utilObj.setVisible(shineNode, false);
                    var params = {
                        node: shineNode,
                        width: bgWidth,
                        height: bgHeight,
                        parent: clipperNode,
                        initAnimDelay: animDelay
                    };
                    animDelay = animObj.animateShineOnce(params);

                    // notif bubble animation here
                    var removeDelay = 0.30;
                    animDelay = animObj.animateNudgeOnce(notifBubble, notifBubbleAnim, animDelay - removeDelay);
                    gameObj.setDcAnimationQuestMapViewsToday(gameObj.getDcAnimationQuestMapViewsToday() + 1);
                    gameObj.setDcAnimationLastSeenTimestamp(utilObj.getCurrentTimestamp());
                }
                // if number of daily puzzle yet to be solved is less than equal to zero, entire today's challenge moves down and fades out with animation
                if (showTodaysSectionFadeOutAnimation) {
                    trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", constantsObj.TRACK_WQ_MAP, "dc_exit_anim", "", "", "", "");
                    animDelay = animObj.runTodaysSectionMoveDownAndFadeOutAnimation(todaySectionBg, outline, todaysSectionButton, clipperNode, animDelay);
                }
                //
            }

            gameObj.setTodaysSectionCompletedPuzzleCount(completedPuzzlesNumber);
            questMapObj.setExtraDelayForSurfacingTodaysChallengeSection(0.1);
            return animDelay;
        },

        /**
         * node change animation after completing
         * @param sender layer
         * @param params map data essential
         */
        showNodeChangeAnim: function (sender, params1) {

            var bucket = questMapObj.getBucketAllocated();
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "node_shift_anim", constantsObj.TRACK_VIEW, bucket + "_" + (questMapLayer.curLevelNum + 1) , questMapLayer.curLevelNum, "", "");

            var scaleOutVal = 1.1;
            var delay = 0;

            var index = params1.index;

            // scale out and scale in of the elements (current node)

            var durationScaleOut = 0.1;
            var durationScaleIn = 0.4;

            // to disable screen touch
            var useLessBtn = utilObj.getButton(canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset, 0.5, 0.5,
                centerXPos, centerYPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: 'questMapLayer',
                    fn: 'preventBackgroundScreenTouch',
                    screen: questMapLayer.screen,
                    params: {
                        sound : false
                    }
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            utilObj.addChild(curLayer, useLessBtn, constantsObj.FTUE_Z_ORDER);

            var scaleOut = utilObj.getScaleTo(durationScaleOut,  1.4 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 * scaleOutVal,  1.4 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 * scaleOutVal);
           var scaleIn = utilObj.getScaleTo(durationScaleIn, 0, 0);
            var animArr = [scaleOut, scaleIn];
            animObj.runAction(questMapLayer.activeNodeBgAnim, utilObj.getSequence(animArr));

            var scaleOut1 = utilObj.getScaleTo(durationScaleOut, constantsObj.SCALE_SPRITE_NEW_1 * 1.5 * scaleOutVal, constantsObj.SCALE_SPRITE_NEW_1 * 1.5 * scaleOutVal);
            var scaleIn1 = utilObj.getScaleTo(durationScaleIn, 0, 0);
            var animArr1 = [scaleOut1, scaleIn1];
            animObj.runAction(questMapLayer.activeNodeAnim, utilObj.getSequence(animArr1));

            var scaleOut2 = utilObj.getScaleTo(durationScaleOut, utilObj.getScaleX(questMapLayer.activeNodeLblAnim) * scaleOutVal, utilObj.getScaleY( questMapLayer.activeNodeLblAnim) * scaleOutVal);
           var scaleIn2 = utilObj.getScaleTo(durationScaleIn, 0, 0);
            var animArr2 = [scaleOut2, scaleIn2];
            animObj.runAction(questMapLayer.activeNodeLblAnim, utilObj.getSequence(animArr2));

            // --------------------------
            // fade out rings

            var durationFadeOutRings = 0.2;
            var durationScaleOut = 0.1;
            var fadeOut = utilObj.getFadeOut(durationFadeOutRings);
            var fadeOut1 = utilObj.getFadeOut(durationFadeOutRings);
            var animArrRing1 = [utilObj.getDelayTime(durationScaleOut), fadeOut];
            var animArrRing2 = [utilObj.getDelayTime(durationScaleOut), fadeOut1];

            animObj.runAction(questMapLayer.circleSpriteAnim1,  utilObj.getSequence(animArrRing1));
            animObj.runAction(questMapLayer.circleSpriteAnim2,  utilObj.getSequence(animArrRing2));
            // --------------------------


            delay += durationScaleOut;
            delay += durationScaleIn/2;

            // scale out and scale in of the elements (tick node)

            var durationScaleOut1 = 0.4;
            var durationScaleIn1 = 0.1;

            var scaleOut3 = utilObj.getScaleTo(durationScaleOut1, 1.4 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 * scaleOutVal, 1.4 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 * scaleOutVal);
            var scaleIn3 = utilObj.getScaleTo(durationScaleIn1, 1.4 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 , 1.4 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 );
            var animArr3 = [utilObj.getDelayTime(delay), scaleOut3, scaleIn3];
            animObj.runAction(questMapLayer.solvedNodeBgAnim,  utilObj.getSequence(animArr3));

            var scaleOut4 = utilObj.getScaleTo(durationScaleOut1, constantsObj.SCALE_SPRITE_NEW_1 * 1.5 * scaleOutVal, constantsObj.SCALE_SPRITE_NEW_1 * 1.5 * scaleOutVal);
            var scaleIn4 = utilObj.getScaleTo(durationScaleIn1, constantsObj.SCALE_SPRITE_NEW_1 * 1.5 , constantsObj.SCALE_SPRITE_NEW_1 * 1.5 );
            var animArr4 = [utilObj.getDelayTime(delay), scaleOut4, scaleIn4];
            animObj.runAction(questMapLayer.solvedNodeAnim,  utilObj.getSequence(animArr4));

            var scaleOut5 = utilObj.getScaleTo(durationScaleOut1, constantsObj.SCALE_SPRITE_NEW_1 * scaleOutVal, constantsObj.SCALE_SPRITE_NEW_1 * scaleOutVal);
            var scaleIn5 = utilObj.getScaleTo(durationScaleIn1, constantsObj.SCALE_SPRITE_NEW_1 , constantsObj.SCALE_SPRITE_NEW_1 );
            var animArr5 = [utilObj.getDelayTime(delay), scaleOut5, scaleIn5];
            animObj.runAction(questMapLayer.tickAnim,  utilObj.getSequence(animArr5));

            // --------------------------

            delay += durationScaleIn/2;
            delay += 0.2;

            // move the profile image to the milestone level

            var milestoneIndex = questMapLayer.infoArrForAnim.mileStoneIndex;
            var moveToTime = 0.6;

            var xPosStart = utilObj.getPositionX(questMapLayer.profileAnim);
            var yPosStart = utilObj.getPositionY(questMapLayer.profileAnim);

           // loggerObj.debugLog("goto1",index,  questMapLayer.levelNodePos[index].x);
            var xPosFinal =  questMapLayer.levelNodePos[index].x;
            var yPosFinal =  questMapLayer.levelNodePos[index].y + 140;

            var xPosMid = xPosFinal + Math.abs(xPosStart - xPosFinal) /2;
            var yPosMid = yPosStart + Math.abs(yPosFinal - yPosStart)/2 + 50;

            if (xPosFinal < xPosStart && xPosStart == centerXPos) {
                xPosMid = xPosFinal + Math.abs(xPosStart - xPosFinal) /2;
                yPosMid = yPosStart + Math.abs(yPosFinal - yPosStart)/2 - 50;
            } else if (xPosFinal > xPosStart && xPosStart != centerXPos) {
                xPosMid = xPosStart + Math.abs(xPosStart - xPosFinal) /2;
                yPosMid = yPosStart + Math.abs(yPosFinal - yPosStart)/2 + 50;
            } else if (xPosFinal > xPosStart && xPosStart == centerXPos) {
                xPosMid = xPosStart + Math.abs(xPosStart - xPosFinal) /2;
                yPosMid = yPosStart + Math.abs(yPosFinal - yPosStart)/2 - 200;
            }

            //loggerObj.debugLog("current milestone index", xPosStart, yPosStart,"scdsc", xPosFinal, yPosFinal,"mid", xPosMid, yPosMid );
            // xPosMid = centerXPos;
            // yPosMid = centerYPos;

            var moveTo = animObj.getCardinalSplineTo(moveToTime, [{
                x: xPosStart,
                y: yPosStart
            },{
                x: xPosMid,
                y: yPosMid
            },{
                x: xPosFinal,
                y: yPosFinal
            }], 0).easing(new cc.easeIn(1));

            // bouncy effect on landing the profile icon
            var durationScaleUp = 0.2;
            var scaleUp =  utilObj.getScaleTo(durationScaleUp, 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 , 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 * 1.3);
            var scaleDown = utilObj.getScaleTo(durationScaleUp, 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 , 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 * 0.85);
            var scaleUp1 = utilObj.getScaleTo(durationScaleUp - 0.1, 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 , 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7);
            var animArr6 = [utilObj.getDelayTime(delay + moveToTime - 0.2), scaleUp, scaleDown, scaleUp1];

            var animArr7 = [utilObj.getDelayTime(delay), moveTo];
            var spawn = new cc.Spawn(utilObj.getSequence(animArr6), utilObj.getSequence(animArr7));
            animObj.runAction(questMapLayer.profileAnim, spawn);

            // -----------------------

            delay += 0.9;

            // circle fade in on the next ring node to make it active
            var spriteArr = [];
            var labelArr = [];

            var circle1 = utilObj.getSprite(constantsObj.white_circle_150, xPosFinal, yPosFinal - 140, 0.5, 0.5, constantsObj.SCALE_SPRITE_9 * 3, spriteArr, questMapLayer.scrollView, constantsObj.FTUE_Z_ORDER, constantsObj.SPRITE_MISC);
            circle1.setOpacity(0);

            var circle2 = utilObj.getSprite(constantsObj.white_circle_150, xPosFinal, yPosFinal - 140, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, questMapLayer.scrollView, constantsObj.FTUE_Z_ORDER, constantsObj.SPRITE_MISC);
            circle2.setOpacity(0);

            var durationScaleRings = 0.6;
            var fadeOutCircle = new cc.ScaleBy(durationScaleRings, 1.5);
            var fadeOutRing = utilObj.getFadeOut(durationScaleRings);
            var fadeInRing = utilObj.getFadeTo(0.01, constantsObj.OPACITY_40);

            var spawnRing = new cc.Spawn(fadeOutCircle, fadeOutRing);
            animObj.runAction(circle1, utilObj.getSequence([utilObj.getDelayTime(delay), fadeInRing, spawnRing]));

            var fadeOutCircle1 = new cc.ScaleBy(durationScaleRings, 4.5);
            var fadeOutRing1 = utilObj.getFadeOut(durationScaleRings);
            var fadeInRing1 = utilObj.getFadeTo(0.01, constantsObj.OPACITY_40);

            var spawnRing = new cc.Spawn(fadeOutCircle1, fadeOutRing1);
            animObj.runAction(circle2, utilObj.getSequence([utilObj.getDelayTime(delay), fadeInRing1, spawnRing]));

            // -------------------

            //scale up the next active node

            var durationActiveNode = 0.3;
            var scaleIn = utilObj.getScaleTo(durationActiveNode, 1.4 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7);
            var scaleIn1 = utilObj.getScaleTo(durationActiveNode, constantsObj.SCALE_SPRITE_NEW_1 * 1.5);

            animObj.runAction(questMapLayer.activeNodeBgAnim1, utilObj.getSequence([utilObj.getDelayTime(delay), scaleIn]));
            animObj.runAction(questMapLayer.activeNodeAnim1, utilObj.getSequence([utilObj.getDelayTime(delay), scaleIn1]));

            // -------------------


            delay += durationScaleRings;
            delay += 0.1;

            // scroll the next to center

            var durationToScroll = 0.8;
            var jumpToMilestone = params1.scrollHeight - (questMapLayer.levelNodePos[index].y + (constantsObj.DESIGN_HEIGHT + params1.linearShift + topBarOffset + 366) / 2);
            questMapLayer.jumpToPercent = ((jumpToMilestone / (params1.scrollHeight - (constantsObj.DESIGN_HEIGHT + params1.linearShift + topBarOffset))) * 100);


            if ( questMapLayer.jumpToPercent < 0 ) {
                questMapLayer.jumpToPercent = 0;
            }

            if ( questMapLayer.jumpToPercent > 100 ) {
                questMapLayer.jumpToPercent = 100;
            }

            //loggerObj.debugLog("curpuzzle3", questMapLayer.jumpToPercent);

            utilObj.delayedCallback(curLayer, questMapLayer.scrollVerticalWithAnim, delay, {
                scrollPercent: questMapLayer.jumpToPercent,
                dur: durationToScroll
            }, false);

            // -------------------

            delay += durationToScroll;

            // redraw layer

            utilObj.delayedCallback(curLayer, questMapLayer.redraw, delay);

            // -------------

            utilObj.addSprites(spriteArr);
            utilObj.addLabels(labelArr);
        },

        animateProfileIcon : function(profile , xPosFinal , yPosFinal){
            if(!utilObj.isNodeValid(profile)){
                return;
            }
            var xPos = profile.getPositionX();
            var yPos = profile.getPositionY();
            var moveUp = new cc.MoveTo(0.6, xPos, yPos + 50).easing((cc.easeIn(1)));
            var moveDown = new cc.MoveTo(0.15, xPos, yPos ).easing((cc.easeOut(1)));
            var delay = utilObj.getDelayTime(0.65);
            var p = {
                xPosFinal: xPosFinal,
                yPosFinal: yPosFinal
            };
            var callFunc = utilObj.getCallFunc(questMapLayer.backRingsAnim, questMapLayer, p);
            var animArr = [];
            animArr.push(moveUp);
            animArr.push(moveDown);
            animArr.push(callFunc);
            animArr.push(delay);
            var seq = utilObj.getSequence(animArr);
            animObj.runAction(profile , seq.repeatForever() , true);

        },


         backRingsAnim : function(sender , params){
             var xPosFinal = params.xPosFinal;
             var yPosFinal = params.yPosFinal;
             var spriteArr = [];
             var delay = 0.15;

             questMapLayer.circle1 = utilObj.getSprite(constantsObj.white_circle_150, xPosFinal, yPosFinal , 0.5, 0.5, constantsObj.SCALE_SPRITE_9 * 3, spriteArr, questMapLayer.scrollView, constantsObj.SPRITE_Z_ORDER - 1, constantsObj.SPRITE_MISC);
             questMapLayer.circle1.setVisible(true);
             questMapLayer.circle1.setOpacity(0);

             //  questMapLayer.circle2 = utilObj.getSprite(constantsObj.white_circle_150, xPosFinal, yPosFinal , 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, questMapLayer.scrollView, constantsObj.SPRITE_Z_ORDER - 1, constantsObj.SPRITE_MISC);
             // questMapLayer.circle2.setVisible(true);
             // questMapLayer.circle2.setOpacity(0);

             var durationScaleRings = 1.2;
             var fadeOutCircle = new cc.ScaleTo(durationScaleRings, 1.5 * constantsObj.SCALE_SPRITE_9 * 3).easing((cc.easeOut(1)));
             var fadeOutRing = utilObj.getFadeOut(durationScaleRings);
             var fadeInRing = utilObj.getFadeTo(0.05, constantsObj.OPACITY_40);
             // var scaleToOriginal = new cc.ScaleTo(0.01, constantsObj.SCALE_SPRITE_9 * 3);

             var spawnRing = new cc.Spawn(fadeOutCircle, fadeOutRing);
             var seq = utilObj.getSequence([utilObj.getDelayTime(delay), fadeInRing, spawnRing ]);
             animObj.runAction(questMapLayer.circle1, seq);

             // var fadeOutCircle1 = new cc.ScaleTo(durationScaleRings, 4.5 * constantsObj.SCALE_SPRITE_9).easing((cc.easeOut(1)));
             // var fadeOutRing1 = utilObj.getFadeOut(durationScaleRings);
             // var fadeInRing1 = utilObj.getFadeTo(0.05, constantsObj.OPACITY_40);
             // // var scaleToOriginal1 = new cc.ScaleTo(0.01, constantsObj.SCALE_SPRITE_9);
             //
             // var spawnRing = new cc.Spawn(fadeOutCircle1, fadeOutRing1);
             // var seq2 =  utilObj.getSequence([utilObj.getDelayTime(delay), fadeInRing1, spawnRing]);
             // animObj.runAction(questMapLayer.circle2, seq2);

             utilObj.addSprites(spriteArr);
         },

         fadeOutRings : function () {
             if (!utilObj.isNodeValid(questMapLayer.profile)) {
                 return;
             }
             if (utilObj.isNodeValid(questMapLayer.profile)) {
                 questMapLayer.profile.stopAllActions();
             }

             if (!utilObj.isNodeValid(questMapLayer.circle1)) {
                 return;
             }
             if (utilObj.isNodeValid(questMapLayer.circle1)) {
                 questMapLayer.circle1.setVisible(false);
                 questMapLayer.circle1.stopAllActions();
             }
             // if (questMapLayer.circle2 == null) {
             //     return;
             // }
             // if (utilObj.isNodeValid(questMapLayer.circle2)) {
             //     questMapLayer.circle2.setVisible(false);
             //     questMapLayer.circle2.stopAllActions();
             // }
         },


        /**
         * triggers the milestone anim for the map puzzles
         * @param sender parent
         * @param params map for the essential data
         */
        showMileStoneAnim: function (sender, params1) {

            var bucket = questMapObj.getBucketAllocated();
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "wq_anim", constantsObj.TRACK_VIEW, bucket + "_" + (questMapLayer.curLevelNum + 1) , questMapLayer.infoArrForAnim.mileStoneIndex, "", "");

            var delay = 0;
            var scaleOutVal = 1.1;

            // scale out and scale in of the elements (current node)

            var durationScaleOut = 0.1;
            var durationScaleIn = 0.4;

            // to disable screen touch
            var useLessBtn = utilObj.getButton(canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset, 0.5, 0.5,
                centerXPos, centerYPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: 'questMapLayer',
                    fn: 'preventBackgroundScreenTouch',
                    screen: questMapLayer.screen,
                    params: {
                        sound : false
                    }
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            utilObj.addChild(curLayer, useLessBtn, constantsObj.FTUE_Z_ORDER);

            var scaleOut = utilObj.getScaleTo(durationScaleOut, 1.4 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 * scaleOutVal, 1.4 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 * scaleOutVal);
            var scaleIn = utilObj.getScaleTo(durationScaleIn, 0, 0);
            var animArr = [scaleOut, scaleIn];
            animObj.runAction(questMapLayer.activeNodeBgAnim, utilObj.getSequence(animArr));

            var scaleOut1 = utilObj.getScaleTo(durationScaleOut, constantsObj.SCALE_SPRITE_NEW_1 * 1.5 * scaleOutVal, constantsObj.SCALE_SPRITE_NEW_1 * 1.5 * scaleOutVal);
            var scaleIn1 = utilObj.getScaleTo(durationScaleIn, 0, 0);
            var animArr1 = [scaleOut1, scaleIn1];
            animObj.runAction(questMapLayer.activeNodeAnim,  utilObj.getSequence(animArr1));

            var scaleOut2 = utilObj.getScaleTo(durationScaleOut, utilObj.getScaleX(questMapLayer.activeNodeLblAnim) * scaleOutVal,  utilObj.getScaleY(questMapLayer.activeNodeLblAnim) * scaleOutVal);
            var scaleIn2 = utilObj.getScaleTo(durationScaleIn, 0, 0);
            var animArr2 = [scaleOut2, scaleIn2];
            animObj.runAction(questMapLayer.activeNodeLblAnim,  utilObj.getSequence(animArr2));

            // --------------------------

            // fade out rings

            var durationFadeOutRings = 0.2;
            var fadeOut = utilObj.getFadeOut(durationFadeOutRings);
            var fadeOut1 = utilObj.getFadeOut(durationFadeOutRings);
            var animArrRing1 = [utilObj.getDelayTime(durationScaleOut), fadeOut];
            var animArrRing2 = [utilObj.getDelayTime(durationScaleOut), fadeOut1];

            animObj.runAction(questMapLayer.circleSpriteAnim1,  utilObj.getSequence(animArrRing1));
            animObj.runAction(questMapLayer.circleSpriteAnim2,  utilObj.getSequence(animArrRing2));

            // --------------------------

            delay += durationScaleOut;
            delay += durationScaleIn/2;

            // scale out and scale in of the elements (tick node)

            var durationScaleOut1 = 0.4;
            var durationScaleIn1 = 0.1;
            var scaleOutVal = 1.1;

            var scaleOut3 = utilObj.getScaleTo(durationScaleOut1, 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 * scaleOutVal, 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 * scaleOutVal);
            var scaleIn3 = utilObj.getScaleTo(durationScaleIn1, 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 , 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 );
            var animArr3 = [utilObj.getDelayTime(delay), scaleOut3, scaleIn3];
            animObj.runAction(questMapLayer.solvedNodeBgAnim,  utilObj.getSequence(animArr3));

            var scaleOut4 = utilObj.getScaleTo(durationScaleOut1, constantsObj.SCALE_SPRITE_NEW_1 * 1.28 * scaleOutVal, constantsObj.SCALE_SPRITE_NEW_1 * 1.28 * scaleOutVal);
            var scaleIn4 = utilObj.getScaleTo(durationScaleIn1, constantsObj.SCALE_SPRITE_NEW_1 * 1.28 , constantsObj.SCALE_SPRITE_NEW_1 * 1.28 );
            var animArr4 = [utilObj.getDelayTime(delay), scaleOut4, scaleIn4];
            animObj.runAction(questMapLayer.solvedNodeAnim,  utilObj.getSequence(animArr4));

            var scaleOut5 = utilObj.getScaleTo(durationScaleOut1, constantsObj.SCALE_SPRITE_NEW_1 * scaleOutVal, constantsObj.SCALE_SPRITE_NEW_1 * scaleOutVal);
            var scaleIn5 = utilObj.getScaleTo(durationScaleIn1, constantsObj.SCALE_SPRITE_NEW_1 , constantsObj.SCALE_SPRITE_NEW_1 );
            var animArr5 = [utilObj.getDelayTime(delay), scaleOut5, scaleIn5];
            animObj.runAction(questMapLayer.tickAnim,  utilObj.getSequence(animArr5));

            // --------------------------

            delay += durationScaleIn/2;
            delay += 0.2;

            // move the profile image to the milestone level

            var milestoneIndex = questMapLayer.infoArrForAnim.mileStoneIndex;
            var moveToTime = 0.6;

            var xPosStart = utilObj.getPositionX(questMapLayer.profileAnim);
            var yPosStart = utilObj.getPositionY(questMapLayer.profileAnim);

            var xPosFinal = questMapLayer.milestoneNodesMap[milestoneIndex - 1].x;
            var yPosFinal = questMapLayer.milestoneNodesMap[milestoneIndex - 1].y + 140;

            var xPosMid = xPosFinal + Math.abs(xPosStart - xPosFinal) /2 + 50;
            var yPosMid = yPosStart + Math.abs(yPosFinal - yPosStart)/2 + 50;

            if (xPosFinal < xPosStart && xPosStart == centerXPos) {
                xPosMid = xPosFinal + Math.abs(xPosStart - xPosFinal) /2 - 50;
                yPosMid = yPosStart + Math.abs(yPosFinal - yPosStart)/2 - 50;
            } else if (xPosFinal > xPosStart && xPosStart != centerXPos) {
                xPosMid = xPosStart + Math.abs(xPosStart - xPosFinal) /2 + 50;
                yPosMid = yPosStart + Math.abs(yPosFinal - yPosStart)/2 + 50;
            } else if (xPosFinal > xPosStart && xPosStart == centerXPos) {
                xPosMid = xPosStart + Math.abs(xPosStart - xPosFinal) /2 - 50;
                yPosMid = yPosStart + Math.abs(yPosFinal - yPosStart)/2 - 50;
            }

           // loggerObj.debugLog("current milestone index", xPosStart, yPosStart,"scdsc", xPosFinal, yPosFinal);

            var moveTo = animObj.getCardinalSplineTo(moveToTime, [{
                x: xPosStart,
                y: yPosStart
            },{
                x: xPosMid,
                y: yPosMid
            },{
                x: xPosFinal,
                y: yPosFinal
            }], 0).easing(new cc.easeIn(1.5));

            // bouncy effect on landing the profile icon
            var durationScaleUp = 0.2;
            var scaleUp =  utilObj.getScaleTo(durationScaleUp, 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 , 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 * 1.3);
            var scaleDown = utilObj.getScaleTo(durationScaleUp, 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 , 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 * 0.85);
            var scaleUp1 = utilObj.getScaleTo(durationScaleUp - 0.1, 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 , 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7);
            var animArr6 = [utilObj.getDelayTime(delay + moveToTime - 0.2), scaleUp, scaleDown, scaleUp1];

            var animArr7 = [utilObj.getDelayTime(delay), moveTo];
            var spawn = new cc.Spawn(utilObj.getSequence(animArr6), utilObj.getSequence(animArr7));
            animObj.runAction(questMapLayer.profileAnim, spawn);

            // -----------------------

            delay += 0.9;


            // plist on the gift
            var xPosPlist = questMapLayer.milestoneNodesMap[milestoneIndex - 1].x;
            var yPosPlist = questMapLayer.milestoneNodesMap[milestoneIndex - 1].y;

            var params = {
                x: xPosPlist,
                y: yPosPlist,
                layer: questMapLayer.scrollView,
                scale: 1.25,
                zOrder: constantsObj.FTUE_Z_ORDER - 1
            };
            utilObj.delayedCallback(curLayer, effectsObj.playBoxEffect, delay, params, false);


            // ----------------

            // fade out the gift box on the milestone place

            var giftImage = questMapLayer.milestoneNodes[milestoneIndex - 1];
            var durationGiftFade = 0.3;

            var fadeOutGift = utilObj.getFadeOut(durationGiftFade);
            animObj.runAction(giftImage, utilObj.getSequence([utilObj.getDelayTime(delay), fadeOutGift]));

            // ----------------

            delay += durationGiftFade;

            //*** trans bg UI for the screen and it elements animations

                var spritesToRemove = [];
                var spriteArr = [];
                var labelArr = [];

                var transBg = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, 0, 0.5, 0, canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset, spriteArr, curLayer, constantsObj.FTUE_Z_ORDER, constantsObj.SPRITE_MISC);
                utilObj.setColor(transBg, constantsObj.COLOR_BLACK);
                utilObj.setOpacity(transBg, constantsObj.OPACITY_0);
                spritesToRemove.push(transBg);
                transBg.setCascadeOpacityEnabled(true);

                // white circle background

                var milestoneNodeBg = utilObj.getSprite(constantsObj.white_circle_150, centerXPos, centerYPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 3.2, spriteArr, transBg, constantsObj.FTUE_Z_ORDER, constantsObj.SPRITE_MISC);
                milestoneNodeBg.setColor(constantsObj.COLOR_CIRCLE_ORANGE_WQ);
                milestoneNodeBg.setOpacity(0);

                var milestoneNode = utilObj.getSprite(constantsObj.white_circle_150, centerXPos, centerYPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 3, spriteArr, transBg, constantsObj.FTUE_Z_ORDER, constantsObj.SPRITE_MISC);
                milestoneNode.setColor(constantsObj.COLOR_WHITE);
                milestoneNode.setOpacity(0);

                // ----------------

                // milestone images
                var experiment = gameObj.getExpNewWeeklyQuestVariant();

                var now = new Date();
                var year = questMapObj.y2k(now.getYear());
                var month = now.getMonth();
                var date = now.getDate();
                var weekNum = questMapObj.getWeek(year, month, date);

                var mileStoneCollectible = questMapObj.getMilestoneImage(year, weekNum, experiment, milestoneIndex - 1);
                var mileStoneImg = utilObj.getSprite(mileStoneCollectible, centerXPos, 374, 0.5, 0.5, 0.5, spriteArr, transBg, constantsObj.FTUE_Z_ORDER, constantsObj.SPRITE_MISC);
                mileStoneImg.setOpacity(0);

                // ----------------

                // fade in transBg

                var durationFadeIn = 0.2;
                var fadeInTransBg = utilObj.getFadeTo(durationFadeIn, constantsObj.OPACITY_90);
                animObj.runAction(transBg, utilObj.getSequence([utilObj.getDelayTime(delay), fadeInTransBg]));

                // ----------------

                // coin bg image fade in

                var xPos = xRightPos - 30;
                var localYPos = constantsObj.DESIGN_HEIGHT + topBarOffset - 70;
                var xShiftTemp = 200;
                var arrForCoinFadeIn = [];

                var coinBg = utilObj.getScale9Sprite(constantsObj.tile_white_curved, xPos - (350 + xShiftTemp), localYPos, 0, 0.5, 320, 80, spriteArr,
                    transBg, constantsObj.FTUE_Z_ORDER, constantsObj.SPRITE_MISC);
                coinBg.setColor(constantsObj.COLOR_WHITE);
                coinBg.setOpacity(0);
                arrForCoinFadeIn.push(coinBg);

                var coinImg = utilObj.getSprite(constantsObj.coin_png_2, xPos - (350 + xShiftTemp), localYPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, transBg, constantsObj.FTUE_Z_ORDER, constantsObj.SPRITE_MISC);
                coinImg.setOpacity(0);
                arrForCoinFadeIn.push(coinImg);

                var coinCount = economyObj.getCash();
                var cashLbl = utilObj.getBMFontLabel(coinCount + "", constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - (210 + xShiftTemp), localYPos, 0.5, 0.5, labelArr, transBg, constantsObj.FTUE_Z_ORDER + 1);
                cashLbl.setOpacity(0);
                arrForCoinFadeIn.push(cashLbl);

                var plusImg = utilObj.getSprite(constantsObj.green_plus, xPos - (100 + xShiftTemp), localYPos, 0, 0.5, constantsObj.SCALE_SPRITE_1, spriteArr, transBg, constantsObj.FTUE_Z_ORDER, constantsObj.SPRITE_MISC);
                plusImg.setOpacity(0);
                arrForCoinFadeIn.push(plusImg);

                for (var i in arrForCoinFadeIn) {
                    var fadeIn = utilObj.getFadeIn(durationFadeIn);
                    animObj.runAction(arrForCoinFadeIn[i], utilObj.getSequence([utilObj.getDelayTime(delay), fadeIn]));
                }

                // ----------------

                delay += durationFadeIn;

                // gift image scale in and move down

                var giftScale = 1.0;
                var durationMoveDown = 0.6;
                var durationScaleUpGift = 0.2;

                var giftBotImg = constantsObj.wq_box_blue;
                var giftCapImg = constantsObj.wq_box_blue_cap;
                if (milestoneIndex == 2) {
                    giftBotImg = constantsObj.wq_box_green;
                    giftCapImg = constantsObj.wq_box_green_cap;
                } else if (milestoneIndex == 3) {
                    giftBotImg = constantsObj.giftbox;
                    giftCapImg = constantsObj.cap;
                }

                var giftBot = utilObj.getSprite(giftBotImg, centerXPos, centerYPos - 100, 0.5, 0, giftScale, spriteArr, transBg, constantsObj.FTUE_Z_ORDER, constantsObj.SPRITE_LOCAL);
                var giftTop = utilObj.getSprite(giftCapImg, giftBot.getContentSize().width / 2, giftBot.getContentSize().height - 40, 0.5, 0, giftScale, spriteArr, giftBot, constantsObj.FTUE_Z_ORDER, constantsObj.SPRITE_LOCAL);
                utilObj.setScale(giftBot, 0);
                giftBot.setCascadeOpacityEnabled(true);

                var startXPos = centerXPos;
                var startYPos = centerYPos;
                var startGift = cc.p(startXPos, startYPos);

                var endXPos = centerXPos;
                var endYPos = 0;
                var endGift = cc.p(endXPos, endYPos);

                var midXPos = centerXPos;
                var midYPos = centerYPos;
                var midGift =  cc.p(midXPos, midYPos);

                var pathGift = [startGift, midGift, endGift];

                var moveAnimGift = utilObj.getCardinalSpline(durationMoveDown, pathGift, 0);
                var easeOutMoveGift = moveAnimGift.easing(cc.easeOut(1));

                // ----------------

                // bouncy effect for the gift box
                var durationScalenGift = 0.2;
                var scaleDownGift = utilObj.getScaleTo(durationScalenGift, giftScale, giftScale * 0.65);
                var scaleUpGift = utilObj.getScaleTo(durationScalenGift, giftScale, giftScale * 1.2);
                var scaleSettleGift = utilObj.getScaleTo(durationScalenGift - 0.1, giftScale, giftScale );

                var animNew = [];
                animNew.push(animObj.getDelayTime(delay));
                var spawn = cc.Spawn(utilObj.getScaleTo(durationScaleUpGift, giftScale), easeOutMoveGift);
                animNew.push(spawn, scaleDownGift, scaleUpGift, scaleSettleGift);
                animObj.runAction(giftBot, animObj.getSequence(animNew));

                // ----------------

                delay += durationMoveDown;
                delay += 2 * durationScalenGift;
                delay += durationScalenGift - 0.1;

                // gift top open animation

                var durationGiftTopOpen = 0.3;

                var startXTop = giftBot.getContentSize().width / 2;
                var startYTop = giftBot.getContentSize().height - 40;
                var startGiftTop = cc.p(startXTop, startYTop);

                var endXTop = -giftBot.getContentSize().width / 2;
                var endYTop = 70;
                var endGiftTop = cc.p(endXTop, endYTop);

                var midXTop = 0;
                var midYTop = giftBot.getContentSize().height + 100;
                var midGiftTop = cc.p(midXTop, midYTop);

                var pathGiftTop = [startGiftTop, midGiftTop, endGiftTop];

                var moveAnimGiftTop = utilObj.getCardinalSpline(durationGiftTopOpen, pathGiftTop, 0);
                var easeOutMoveGiftTop = moveAnimGiftTop.easing(cc.easeOut(1));

                animObj.runAction(giftTop, animObj.getSequence([utilObj.getDelayTime(delay), moveAnimGiftTop]));

                // ----------------

                // reward glow

                var glowImg = utilObj.getSprite(constantsObj.rays, centerXPos, giftBot.getContentSize().height - 35, 0.5, 0, 2.3, spriteArr, transBg, constantsObj.FTUE_Z_ORDER, constantsObj.SPRITE_LOCAL);
                utilObj.setOpacity(glowImg, 0);
                glowImg.setColor(constantsObj.COLOR_YELLOW_06);

                var durationFadeInGlow = 0.2;
                var fadeInGlow = utilObj.getFadeTo(durationFadeInGlow, constantsObj.OPACITY_50);
                animObj.runAction(glowImg, utilObj.getSequence([utilObj.getDelayTime(delay), fadeInGlow]));

                // ----------------

                delay += durationGiftTopOpen;

                // milestone collectible coming out anim

                var durationMoveMileStoneImg = 0.5;
                var durationScaleDownImg = 0.1;
                var fadeInMileStoneImg = utilObj.getFadeIn(0.01);
                var scaleUp = utilObj.getScaleTo(durationMoveMileStoneImg, 2.25);
                scaleDown = utilObj.getScaleTo(durationScaleDownImg, 2.1);
                var pathMoveMileStoneImg = [{x: centerXPos, y: 374}, {x: centerXPos, y: centerYPos}];
                var moveAnimMileStoneImg = utilObj.getCardinalSpline(durationMoveMileStoneImg, pathMoveMileStoneImg, 0);

                var spawnMile = new cc.Spawn(scaleUp, moveAnimMileStoneImg);
                var animArrMile = [utilObj.getDelayTime(delay), fadeInMileStoneImg, spawnMile, scaleDown];
                animObj.runAction(mileStoneImg, utilObj.getSequence(animArrMile));

                // ----------------

                delay += durationMoveMileStoneImg;

                // fade in of the white circle bg for the milestone

                var durationFadeIn = 0.4;
                var fadeInCircle1 = utilObj.getFadeIn(durationFadeIn);
                var fadeInCircle2 = utilObj.getFadeIn(durationFadeIn);
                animObj.runAction(milestoneNodeBg, utilObj.getSequence([utilObj.getDelayTime(delay), fadeInCircle1]));
                animObj.runAction(milestoneNode, utilObj.getSequence([utilObj.getDelayTime(delay), fadeInCircle2]));


                // ----------------

                // milestone achieved label

                var str = "Milestone Unlocked!";
                if (milestoneIndex == 3) {
                    str = "Quest Completed!";
                }
                var mileLabel = utilObj.getBMFontLabel(str, constantsObj.FONT_HELVETICA_BOLD_90, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, localYPos - 225 , 0.5, 0.5, labelArr, transBg, constantsObj.FTUE_Z_ORDER);
                mileLabel.setOpacity(0);


                var durationFadeLabel = 0.2;
                var fadeInLabel = utilObj.getFadeIn(durationFadeLabel);
                animObj.runAction(mileLabel, utilObj.getSequence([utilObj.getDelayTime(delay), fadeInLabel]));

                // ----------------


                // coin image and reward coming from the box

                var rewardToGive = questMapObj.getRewardNumber(milestoneIndex);

                var coinImg1 = utilObj.getSprite(constantsObj.coin_png_2, centerXPos - 50, giftBot.getContentSize().height + 200, 0.5, 0.5, constantsObj.SCALE_SPRITE_9 * 1.25, spriteArr, transBg, constantsObj.FTUE_Z_ORDER, constantsObj.SPRITE_MISC);
                coinImg1.setOpacity(0);

                var rewardValue = utilObj.getBMFontLabel(rewardToGive, constantsObj.FONT_HELVETICA_MEDIUM_100, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos + 40, giftBot.getContentSize().height + 200 , 0, 0.5, labelArr, transBg, constantsObj.FTUE_Z_ORDER);
                rewardValue.setOpacity(0);

                var durationfadeIn = 0.01;
                var fadeInCoin1 = utilObj.getFadeIn(durationfadeIn);
                var fadeInCoin2 = utilObj.getFadeIn(durationfadeIn);

                var durationMoveUpCoin = 0.2;
                var moveBy1 = animObj.getMoveBy(durationMoveUpCoin, 0, 120);
                var moveBy2 = animObj.getMoveBy(durationMoveUpCoin, 0, 120);

                var spawn1 = new cc.Spawn(fadeInCoin1, moveBy1);
                var spawn2 = new cc.Spawn(fadeInCoin2, moveBy2);

                animObj.runAction(coinImg1, utilObj.getSequence([utilObj.getDelayTime(delay), spawn1]));
                animObj.runAction(rewardValue, utilObj.getSequence([utilObj.getDelayTime(delay), spawn2]));

               // ----------------

                delay += durationFadeIn - 0.1;

                // milestone achieved label
            
                var stringDesc = questMapObj.getToPushCollectible(year, weekNum, experiment, milestoneIndex - 1);
                var textArr = utilObj.getSplitStringsArr(stringDesc, 35);
                var arrDescTxt = [];

                var yPosDesc = localYPos - 400;
                for (var i = 0; i < textArr.length; i++) {
                    var subText = utilObj.getBMFontLabel(textArr[i], constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_WHITE,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, yPosDesc, 0.5, 0.5, labelArr, transBg, constantsObj.FTUE_Z_ORDER);
                    yPosDesc -= 70;
                    arrDescTxt.push(subText);
                    subText.setOpacity(0);
                }

                for (var i in arrDescTxt) {
                    var durationFadeDesc = 0.2;
                    var fadeInLabelDesc = utilObj.getFadeIn(durationFadeDesc);
                    animObj.runAction(arrDescTxt[i], utilObj.getSequence([utilObj.getDelayTime(delay), fadeInLabelDesc]));
                }

                // ----------------

                // particle effect for burst

                var params = {
                    x: centerXPos,
                    y: centerYPos,
                    layer: curLayer,
                    scale: 2,
                    zOrder: constantsObj.FTUE_Z_ORDER
                };
                utilObj.delayedCallback(curLayer, effectsObj.playWQBurstEffect, delay, params, false);

                // ---------------

                // trigger coin grant anim

                delay += 0.2;

                utilObj.delayedCallback(curLayer, questMapLayer.showCoinGrantAnimation, delay, {reward: rewardToGive,
                start:  {x: centerXPos - 50, y: giftBot.getContentSize().height + 320 }, end: {x: xPos - (350 + xShiftTemp), y:localYPos},
                layer: transBg, lbl: cashLbl, index: milestoneIndex}, false)

                // ---------------

                delay += 5;


                // mileStone image for layer Use

                var yPosScroll = Math.abs(questMapLayer.scrollView.getInnerContainerPosition().y) + (constantsObj.DESIGN_HEIGHT + topBarOffset)/2;
                var milestoneNodeBg1 = utilObj.getSprite(constantsObj.white_circle_150, centerXPos, yPosScroll, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 3.2, spriteArr, questMapLayer.scrollView, constantsObj.FTUE_Z_ORDER, constantsObj.SPRITE_MISC);
                milestoneNodeBg1.setColor(constantsObj.COLOR_CIRCLE_ORANGE_WQ);
                milestoneNodeBg1.setOpacity(0);
                var fadeInLayerMileImg1 = utilObj.getFadeIn(0.01);
                animObj.runAction(milestoneNodeBg1, utilObj.getSequence([utilObj.getDelayTime(delay - 4), fadeInLayerMileImg1]));


                var milestoneNode1 = utilObj.getSprite(constantsObj.white_circle_150, centerXPos, yPosScroll, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 3, spriteArr, questMapLayer.scrollView, constantsObj.FTUE_Z_ORDER, constantsObj.SPRITE_MISC);
                milestoneNode1.setColor(constantsObj.COLOR_WHITE);
                milestoneNode1.setOpacity(0);
                var fadeInLayerMileImg2 = utilObj.getFadeIn(0.01);
                animObj.runAction(milestoneNode1, utilObj.getSequence([utilObj.getDelayTime(delay - 4), fadeInLayerMileImg2]));


                var mileStoneImg1 = utilObj.getSprite(mileStoneCollectible, centerXPos, yPosScroll, 0.5, 0.5, 2.1, spriteArr, questMapLayer.scrollView, constantsObj.FTUE_Z_ORDER, constantsObj.SPRITE_MISC);
                mileStoneImg1.setOpacity(0);
                var fadeInLayerMileImg = utilObj.getFadeIn(0.01);
                animObj.runAction(mileStoneImg1, utilObj.getSequence([utilObj.getDelayTime(delay - 4), fadeInLayerMileImg]));

                // --------------

                // to close the tran layer before 5 seconds for players who want to skip
                var useLessBtnNew = utilObj.getButton(canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset, 0.5, 0.5,
                    centerXPos, centerYPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                        obj: 'questMapLayer',
                        fn: 'completeAnim',
                        screen: questMapLayer.screen,
                        params: {
                            sound : false,
                            spriteArr : spriteArr, mileStoneCollectible: mileStoneCollectible, transBg: transBg,
                            delay: delay,milestoneIndex: milestoneIndex,params1: params1, mileStoneImg1: mileStoneImg1, milestoneNodeBg1: milestoneNodeBg1, milestoneNode1: milestoneNode1, yPosScroll: yPosScroll
                        }
                    }, false, ccui.Widget.PLIST_TEXTURE, 1);
                utilObj.addChild(transBg, useLessBtnNew, constantsObj.FTUE_Z_ORDER);
                utilObj.setVisible(useLessBtnNew, false);

                // making this btn functional after coin grant happened
                utilObj.delayedCallback(curLayer, questMapLayer.makeBtnVisible, delay - 3.8, {btn: useLessBtnNew}, false);

                // normal close for anim if the player did not tap
                utilObj.delayedCallback(curLayer, questMapLayer.completeRemainingMileStoneAnim, delay, {spriteArr : spriteArr, mileStoneCollectible: mileStoneCollectible, transBg: transBg,
                    delay: delay,milestoneIndex: milestoneIndex,params1: params1, mileStoneImg1: mileStoneImg1, milestoneNodeBg1: milestoneNodeBg1, milestoneNode1: milestoneNode1, yPosScroll: yPosScroll }, false);


            utilObj.addSprites(spriteArr);
            utilObj.addLabels(labelArr);
        },

        // force complete remaining animation by button click
        completeAnim: function (params) {
            questMapLayer.completeRemainingMileStoneAnim(curLayer, params)
        },

        // making this btn functional after coin grant happened
        makeBtnVisible: function (sender, params) {
            questMapLayer.isAnimCompleteStarted = false;
            utilObj.setVisible(params.btn, true);
        },

        /**
         * completes the remaining animation for the milestone anim
         * @param sender
         * @param params
         */
        completeRemainingMileStoneAnim: function (sender, params) {

            if (questMapLayer.isAnimCompleteStarted) {
                return;
            }
            questMapLayer.isAnimCompleteStarted = true;

            var spriteArr = [];
            var transBg = params.transBg;
            var delay = 0;
            var milestoneIndex = params.milestoneIndex;
            var params1 = params.params1;
            var mileStoneImg1 = params.mileStoneImg1;
            var milestoneNodeBg1 = params.milestoneNodeBg1;
            var milestoneNode1 = params.milestoneNode1;
            var yPosScroll = params.yPosScroll;

            // fade out transbg elements and remove them
            var durationFadeOutAll = 0.5;
            utilObj.delayedCallback(curLayer, questMapLayer.fadeOutAll, delay, {node: transBg, time: durationFadeOutAll}, false);
            // -------------

            delay += durationFadeOutAll;


            // -----------------------------------
            // transBg UI end here

            // move the milestone image to the center

            var startMileImg = cc.p(centerXPos, yPosScroll);
            var endMileImg = cc.p(questMapLayer.milestoneNodesMap[milestoneIndex - 1].x, questMapLayer.milestoneNodesMap[milestoneIndex - 1].y);

            var path = [startMileImg, endMileImg];
            var durationMoveToMileImg = 0.3;

            var moveAnimGiftTop = utilObj.getCardinalSpline(durationMoveToMileImg, path, 0);
            var scaleDown = utilObj.getScaleTo(durationMoveToMileImg, 1);
            var spawn = new cc.Spawn(scaleDown, moveAnimGiftTop)
            animObj.runAction(mileStoneImg1, utilObj.getSequence([utilObj.getDelayTime(delay), spawn]));

            var moveAnimGiftTop1 = utilObj.getCardinalSpline(durationMoveToMileImg, path, 0);
            var scaleDown1 = utilObj.getScaleTo(durationMoveToMileImg, constantsObj.SCALE_SPRITE_NEW_1 * 1.33);
            var spawn1 = new cc.Spawn(scaleDown1, moveAnimGiftTop1);
            animObj.runAction(milestoneNodeBg1, utilObj.getSequence([utilObj.getDelayTime(delay), spawn1]));


            var moveAnimGiftTop2 = utilObj.getCardinalSpline(durationMoveToMileImg, path, 0);
            var scaleDown2 = utilObj.getScaleTo(durationMoveToMileImg, constantsObj.SCALE_SPRITE_NEW_1 * 1.28);
            var spawn2 = new cc.Spawn(scaleDown2, moveAnimGiftTop2);
            animObj.runAction(milestoneNode1, utilObj.getSequence([utilObj.getDelayTime(delay), spawn2]));

            // --------------------

            delay += durationMoveToMileImg;
            delay += 0.1;

            if (milestoneIndex != 3) {

                // move the profile badge to the next node

                var xPosStart = questMapLayer.milestoneNodesMap[milestoneIndex - 1].x;
                var yPosStart = questMapLayer.milestoneNodesMap[milestoneIndex - 1].y + 140;

                var xPosFinal = questMapLayer.levelNodes[milestoneIndex][0].x;
                var yPosFinal = questMapLayer.levelNodes[milestoneIndex][0].y + 140;

                var xPosMid = xPosFinal + Math.abs(xPosStart - xPosFinal) / 2 + 50;
                var yPosMid = yPosStart + Math.abs(yPosFinal - yPosStart) / 2 + 50;

                if (xPosFinal < xPosStart && xPosStart == centerXPos) {
                    xPosMid = xPosFinal + Math.abs(xPosStart - xPosFinal) / 2 - 50;
                    yPosMid = yPosStart + Math.abs(yPosFinal - yPosStart) / 2 - 50;
                } else if (xPosFinal > xPosStart && xPosStart != centerXPos) {
                    xPosMid = xPosStart + Math.abs(xPosStart - xPosFinal) / 2 + 50;
                    yPosMid = yPosStart + Math.abs(yPosFinal - yPosStart) / 2 + 50;
                } else if (xPosFinal > xPosStart && xPosStart == centerXPos) {
                    xPosMid = xPosStart + Math.abs(xPosStart - xPosFinal) / 2 - 50;
                    yPosMid = yPosStart + Math.abs(yPosFinal - yPosStart) / 2 - 50;
                }

                var moveToTime = 0.6;
                var moveTo = animObj.getCardinalSplineTo(moveToTime, [{
                    x: xPosStart,
                    y: yPosStart
                }, {
                    x: xPosMid,
                    y: yPosMid
                }, {
                    x: xPosFinal,
                    y: yPosFinal
                }], 0).easing(new cc.easeIn(1.5));

                var durationScaleUp = 0.2;
                var scaleUp = utilObj.getScaleTo(durationScaleUp, 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7, 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 * 1.3);
                var scaleDown = utilObj.getScaleTo(durationScaleUp, 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7, 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 * 0.85);
                var scaleUp1 = utilObj.getScaleTo(durationScaleUp - 0.1, 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7, 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7);
                var animArr6 = [utilObj.getDelayTime(delay + moveToTime - 0.2), scaleUp, scaleDown, scaleUp1];

                var animArr7 = [utilObj.getDelayTime(delay), moveTo];
                var spawn = new cc.Spawn(utilObj.getSequence(animArr6), utilObj.getSequence(animArr7));
                animObj.runAction(questMapLayer.profileAnim, spawn);

                // --------------------

                delay += moveToTime;

                // circle fade in on the next ring node to make it active

                var circle1 = utilObj.getSprite(constantsObj.white_circle_150, xPosFinal, yPosFinal - 140, 0.5, 0.5, constantsObj.SCALE_SPRITE_9 * 3, spriteArr, questMapLayer.scrollView, constantsObj.FTUE_Z_ORDER, constantsObj.SPRITE_MISC);
                circle1.setOpacity(0);

                var circle2 = utilObj.getSprite(constantsObj.white_circle_150, xPosFinal, yPosFinal - 140, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, questMapLayer.scrollView, constantsObj.FTUE_Z_ORDER, constantsObj.SPRITE_MISC);
                circle2.setOpacity(0);

                var durationScaleRings = 0.6;
                var fadeOutCircle = new cc.ScaleBy(durationScaleRings, 1.5);
                var fadeOutRing = utilObj.getFadeOut(durationScaleRings);
                var fadeInRing = utilObj.getFadeTo(0.01, constantsObj.OPACITY_40);

                var spawnRing = new cc.Spawn(fadeOutCircle, fadeOutRing);
                animObj.runAction(circle1, utilObj.getSequence([utilObj.getDelayTime(delay), fadeInRing, spawnRing]));

                var fadeOutCircle1 = new cc.ScaleBy(durationScaleRings, 4.5);
                var fadeOutRing1 = utilObj.getFadeOut(durationScaleRings);
                var fadeInRing1 = utilObj.getFadeTo(0.01, constantsObj.OPACITY_40);

                var spawnRing = new cc.Spawn(fadeOutCircle1, fadeOutRing1);
                animObj.runAction(circle2, utilObj.getSequence([utilObj.getDelayTime(delay), fadeInRing1, spawnRing]));

                // -------------------

                //scale up the next active node

                var durationActiveNode = 0.3;
                var scaleIn = utilObj.getScaleTo(durationActiveNode, 1.4 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7);
                var scaleIn1 = utilObj.getScaleTo(durationActiveNode, constantsObj.SCALE_SPRITE_NEW_1 * 1.5);

                animObj.runAction(questMapLayer.activeNodeBgAnim1, utilObj.getSequence([utilObj.getDelayTime(delay), scaleIn]));
                animObj.runAction(questMapLayer.activeNodeAnim1, utilObj.getSequence([utilObj.getDelayTime(delay), scaleIn1]));

                // -------------------

                delay += durationScaleRings;
                delay += 0.1;

                // scroll the next to center

                var durationToScroll = 0.8;
                var jumpToMilestone = params1.scrollHeight - (questMapLayer.levelNodes[milestoneIndex][0]["y"] + (constantsObj.DESIGN_HEIGHT + params1.linearShift + topBarOffset+ 366) / 2);
                questMapLayer.jumpToPercent = ((jumpToMilestone / (params1.scrollHeight - (constantsObj.DESIGN_HEIGHT + params1.linearShift + topBarOffset))) * 100);


                if ( questMapLayer.jumpToPercent < 0 ) {
                    questMapLayer.jumpToPercent = 0;
                }

                if ( questMapLayer.jumpToPercent > 100 ) {
                    questMapLayer.jumpToPercent = 100;
                }

                utilObj.delayedCallback(curLayer, questMapLayer.scrollVerticalWithAnim, delay, {
                    scrollPercent: questMapLayer.jumpToPercent,
                    dur: durationToScroll
                }, false)

                // -------------------

                delay += durationToScroll;
            }

            // redraw layer

            utilObj.delayedCallback(curLayer, questMapLayer.redraw, delay);

            // -------------

            utilObj.addSprites(spriteArr);
        },

        // function to do nothing
        preventBackgroundScreenTouch: function () {
        // do nothing -> rest here xD
        },


        redraw: function() {
            gameObj.setIsRedraw(true);
            questMapLayer.hide();
            questMapLayer.show(true);
        },

        /**
         * scrolls to the percent passed
         * @param sender layer
         * @param params percent to scroll
         */
        scrollVerticalWithAnim: function(sender, params) {
            var percentToScroll = params.scrollPercent;
            var time = params.dur;
            utilObj.scrollToPercentVertical(questMapLayer.scrollView , percentToScroll, time, true);
        },

        /**
         * removes the element passed to it
         * @param sender layer
         * @param params
         */
        fadeOutAll: function (sender, params) {
            var durationFadeOutNode = params.time;
            var fadeOut = utilObj.getFadeOut(durationFadeOutNode);
            var remove = utilObj.getIndependentRemoveSelf();

            var node = params.node;
            animObj.runAction(node, utilObj.getSequence([fadeOut, remove]));
        },

        /**
         * triggers the coin grant animation
         * @param sender layer
         * @param params data for the generic coin animation to happen
         */
        showCoinGrantAnimation: function(sender, params) {
            var rewardToGive = params.reward;
            var start = params.start;
            var end = params.end;
            var transBg = params.layer;
            var cashLbl = params.lbl;
            animObj.genericCoinGrantAnimation(rewardToGive, false, false, start, end, transBg, cashLbl);
            var bucket = questMapObj.getBucketAllocated();
            var index = params.index;
            economyObj.addCash(rewardToGive, constantsObj.TRACK_EARN, "wq_" + index, bucket);
        },

        addLevelNodes: function (nodeNum) {
            var spriteArr = [];
            var labelArr = [];
            if (questMapLayer.isLevelNodeAdded[nodeNum]) {
                return;
            }
            var levelNodeInfo = questMapLayer.levelNodePos[nodeNum];

            if (levelNodeInfo != undefined && levelNodeInfo["li"] == 0) {
                questMapLayer.showMilestoneNode(questMapLayer.milestoneNodesMap, levelNodeInfo["mi"], spriteArr, labelArr, constantsObj.SPRITE_Z_ORDER + 1);
            }
            if (levelNodeInfo != undefined) {
                questMapLayer.showLevelNode(levelNodeInfo["mi"], levelNodeInfo["li"], levelNodeInfo["x"], levelNodeInfo["y"], nodeNum, spriteArr, labelArr);
            }
            utilObj.addSprites(spriteArr);
            utilObj.addLabels(labelArr);

        },


        calculateLevelNodesAndMilestoneNodesPos: function () {
            var pathHeight = 1300 + 32;
            var yPos = questMapLayer.startingPos;
            //questMapLayer.path = [];
            var btnXPos = [centerXPos, centerXPos + 400, centerXPos, centerXPos - 400];
            var btnYPos = [];
            var nextBtnXPos = 0;
            var nextBtnYPos = 0;
            var levelYPos = 0;
            var counter = 0;
            var count = 0;
            questMapLayer.levelNodePos = {};
            var totalMilestones = 3;
            levelYPos = yPos;
            questMapLayer.nextBtnXPosIndex = 0;
            questMapLayer.nextBtnYPosIndex = 0;
            var offset = 8;


            for (var i = 0; i < totalMilestones; i++) {
                var levelsNum = questMapLayer.allMilestonesInfo[i]["totalPuzzles"];
                btnYPos = [levelYPos, levelYPos + 325 + offset, levelYPos + 650 + 2 * offset, levelYPos + 975 + 3 * offset];
                questMapLayer.levelNodes[i] = [];

                nextBtnXPos = questMapLayer.nextBtnXPosIndex;
                nextBtnYPos = questMapLayer.nextBtnYPosIndex;

                for (var j = 0; j < levelsNum;) {
                    questMapLayer.levelNodes[i][j] = {
                        "x": btnXPos[nextBtnXPos],
                        "y": btnYPos[nextBtnYPos],
                        "c": count + 1
                    };
                    questMapLayer.levelNodePos[count + 1] = {
                        "x": btnXPos[nextBtnXPos],
                        "y": btnYPos[nextBtnYPos],
                        "mi": i,
                        "li": j
                    };

                    count++;
                    nextBtnXPos = (nextBtnXPos + 1) % 4;
                    nextBtnYPos = (nextBtnYPos + 1) % 4;
                    if (nextBtnYPos == nextBtnXPos && nextBtnYPos == 0) {
                        yPos = yPos + pathHeight;
                        counter++;
                        levelYPos = yPos;
                        btnYPos = [levelYPos, levelYPos + 325 + offset, levelYPos + 650 + 2 * offset, levelYPos + 975 + 3 * offset];
                        questMapLayer.indexArr[counter - 1] = count;
                    }
                    j++;
                    if (j == levelsNum) {
                        questMapLayer.milestoneLastNodeIndex.push(j);
                    }
                }

                questMapLayer.milestoneNodesMap[i] = {"x": btnXPos[nextBtnXPos], "y": btnYPos[nextBtnYPos]};
                questMapLayer.milestoneNodesAddedPos[i] = btnYPos[nextBtnYPos];

                nextBtnXPos = (nextBtnXPos + 1) % 4;
                nextBtnYPos = (nextBtnYPos + 1) % 4;
                if (nextBtnYPos == nextBtnXPos && nextBtnYPos == 0) {
                    yPos = yPos + pathHeight;
                    counter++;
                    levelYPos = yPos;
                    btnYPos = [levelYPos, levelYPos + 325 + offset, levelYPos + 650 + 2 * offset, levelYPos + 975 + 3 * offset];
                    questMapLayer.indexArr[counter - 1] = count;
                }
                questMapLayer.nextBtnXPosIndex = nextBtnXPos;
                questMapLayer.nextBtnYPosIndex = nextBtnYPos;
            }
        },

        showMilestoneNode: function (milestoneNodesHeight, startMilestone, spriteArr, labelArr, zOrder) {
            var linearShift = 0;
            if (utilObj.isBezelScreen()) {
                linearShift = constantsObj.BEZEL_SAFE_AREA;
            }
            var xPos = milestoneNodesHeight[startMilestone]["x"];
            var yPos = milestoneNodesHeight[startMilestone]["y"] + linearShift;
            var setNodeLayer = questMapLayer.scrollView;
            var setNodeZOrder = constantsObj.SPRITE_Z_ORDER + 2;

            var experiment = gameObj.getExpNewWeeklyQuestVariant();

            var now = new Date();
            var year = questMapObj.y2k(now.getYear());
            var month = now.getMonth();
            var date = now.getDate();

            var weekNum = questMapObj.getWeek(year, month, date);


            var mileStoneCollectible = questMapObj.getMilestoneImage(year, weekNum, experiment, startMilestone);
            var yPosition = yPos + 10;
            var scale = 1.2;

            var mileStoneImage = constantsObj.weekly_quest_reward2;
            if (startMilestone == 0) {
                mileStoneImage = constantsObj.tq_gift1;
            } else if (startMilestone == 1) {
                mileStoneImage = constantsObj.tq_gift4;
            } else if (startMilestone == 2) {
                mileStoneImage = constantsObj.tq_gift3;
            }

            var bgColor = constantsObj.COLOR_MILESTONE_BG;//(experiment == constantsObj.EXP_VAR_1) ? constantsObj.COLOR_BACK_OUTLINE : constantsObj.COLOR_REALISTIC_MILESTONE;
            if (!(questMapLayer.toShowMileStoneAnim && questMapLayer.infoArrForAnim.mileStoneIndex - 1 == startMilestone)) {
                if (questMapObj.getIsMilestoneDiscovered(startMilestone)) {
                    mileStoneImage = mileStoneCollectible;
                    yPosition = yPos;
                    bgColor = constantsObj.COLOR_WHITE;
                    scale = 1.0;
                }
            }

            var milestoneNodeBg = utilObj.getSprite(constantsObj.white_circle_150, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 1.33, spriteArr, setNodeLayer, setNodeZOrder, constantsObj.SPRITE_MISC);
            milestoneNodeBg.setColor(constantsObj.COLOR_REALISTIC_MILESTONE);
            var milestoneNode = utilObj.getSprite(constantsObj.white_circle_150, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 1.28, spriteArr, setNodeLayer, setNodeZOrder, constantsObj.SPRITE_MISC);
            milestoneNode.setColor(bgColor);
            questMapLayer.milestoneNodes[startMilestone] = utilObj.getSprite(mileStoneImage, xPos, yPosition, 0.5, 0.5, scale, spriteArr, setNodeLayer, setNodeZOrder, constantsObj.SPRITE_MISC);

            var childArr = [milestoneNodeBg, milestoneNode, questMapLayer.milestoneNodes[startMilestone]];
            var milestoneNodeBtn = utilObj.getButton(190, 190, 0.5, 0.5,
                xPos, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: 'questMapLayer',
                    fn: 'milestoneHitFunc',
                    screen: questMapLayer.screen,
                    params: {
                        "sound": constantsObj.trans_button,
                        "sound_on": true,
                        "mileStoneNum": startMilestone,
                    },
                    child: childArr,
                    feedBackType: constantsObj.ZOOMIN_FEEDBACK
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            setNodeLayer.addChild(milestoneNodeBtn, setNodeZOrder);

        }
        ,

        showLevelNode: function (milestoneIndex, levelNum, xPos, yPos, counter, spriteArr, labelArr) {
            var childArr = [];
            var linearShift = 0;
            if (utilObj.isBezelScreen()) {
                linearShift = constantsObj.BEZEL_SAFE_AREA;
            }
            yPos += linearShift;
            questMapLayer.isLevelNodeAdded[counter] = true;
            var curPuzzleIndex = questMapLayer.curLevelNum;
            var setNodeZOrder = constantsObj.SPRITE_Z_ORDER + 2;
            var setNodeLayer = questMapLayer.scrollView;
            var offset = 5;


            if (counter <= curPuzzleIndex) {
                if ((counter < curPuzzleIndex || (counter == curPuzzleIndex && questMapLayer.lastLevel == curPuzzleIndex)) && !(counter == curPuzzleIndex && (questMapLayer.toShowMileStoneAnim ||questMapLayer.toShowNodeChangeAnim))) {
                    var solvedNodeBg = utilObj.getSprite(constantsObj.map_node, xPos, yPos, 0.5, 0.5, 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7 , spriteArr, setNodeLayer, setNodeZOrder, constantsObj.SPRITE_MISC);
                    solvedNodeBg.setColor(constantsObj.COLOR_WHITE);
                    var solvedNode = utilObj.getSprite(constantsObj.white_circle_150, xPos, yPos + offset, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 1.28, spriteArr, setNodeLayer, setNodeZOrder, constantsObj.SPRITE_MISC);
                    solvedNode.setColor(constantsObj.COLOR_SOLVED_NODE);
                    var tick = utilObj.getSprite(constantsObj.tick, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1, spriteArr, setNodeLayer, setNodeZOrder, constantsObj.SPRITE_MISC);
                    tick.setColor(constantsObj.COLOR_WHITE);
                    var str = counter + "_" + "completed";

                    childArr = [solvedNodeBg, solvedNode, tick];
                    var solvedLevelNodeBtn = utilObj.getButton(150, 150, 0.5, 0.5,
                        xPos, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                            obj: 'questMapLayer',
                            fn: 'solvedPuzzleFunc',
                            screen: questMapLayer.screen,
                            params: {
                                "sound": constantsObj.trans_button,
                                "sound_on": true,
                                "c": milestoneIndex,
                                "l": levelNum,
                                "co": counter
                            },
                            track : {
                                k: constantsObj.TRACK_DIALOG,
                                p: "",
                                c: "",
                                o: constantsObj.TRACK_WQ_MAP,
                                f: "node_click",
                                g: str,
                                s: "",
                                co: "",
                                oppId: ""
                            },
                            child: childArr,
                            feedBackType: constantsObj.ZOOMIN_FEEDBACK
                        }, false, ccui.Widget.PLIST_TEXTURE, 1);
                    setNodeLayer.addChild(solvedLevelNodeBtn, setNodeZOrder);



                } else if (counter == curPuzzleIndex) {


                    var state = constantsObj.STATE_PUZ_CLOSED;
                    var info1 = [];
                    var info = {};
                    if(utilObj.getStringifiedJson(gameObj.getCurPuzzleInfo()) != utilObj.getStringifiedJson([])) {
                        info1 = gameObj.getCurPuzzleInfo();
                        info = info1[0];
                        state = questMapObj.getPuzState(info.id);
                    }
                     var xWidth = 200;
                    var yWidth = 400;
                    var yPositionForBtn = yPos + 100;
                    if(state == constantsObj.STATE_PUZ_CLOSED || state == constantsObj.STATE_PUZ_COMPLETED) {
                        xWidth = 400;
                        yWidth = 660;
                        yPositionForBtn = yPos;
                    }

                    //loggerObj.debugLog("stateOfPuzzle",state);
                    questMapLayer.profile = utilObj.getSprite(constantsObj.profile_icon, xPos, yPos + 140, 0.5, 0, 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7, spriteArr, questMapLayer.scrollView, setNodeZOrder, constantsObj.SPRITE_MISC);


                    var activeNodeBg = utilObj.getSprite(constantsObj.map_node, xPos, yPos, 0.5, 0.5, 1.4 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7, spriteArr, setNodeLayer, setNodeZOrder, constantsObj.SPRITE_MISC);
                    activeNodeBg.setColor(constantsObj.COLOR_WHITE);
                    var activeNode = utilObj.getSprite(constantsObj.white_circle_150, xPos, yPos + offset, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 1.5, spriteArr, setNodeLayer, setNodeZOrder, constantsObj.SPRITE_MISC);
                    activeNode.setColor(constantsObj.COLOR_ACTIVE_NODE);
                    var activeNodeFont = constantsObj.FONT_HELVETICA_MEDIUM_100;
                    var activeNodeLbl = utilObj.getBMFontLabel("" + counter, activeNodeFont, constantsObj.COLOR_WHITE,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos + offset, 0.5, 0.5, labelArr, setNodeLayer, setNodeZOrder);

                    questMapLayer.animateProfileIcon(questMapLayer.profile ,xPos , yPos);

                    if (!(questMapLayer.toShowMileStoneAnim || questMapLayer.toShowNodeChangeAnim)) {
                        childArr = [activeNodeBg, activeNode, activeNodeLbl];
                        var curLevelNodeBtn = utilObj.getButton(xWidth, yWidth, 0.5, 0.5,
                            xPos, yPositionForBtn, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                                obj: 'questMapLayer',
                                fn: 'openPuzzle',
                                screen: questMapLayer.screen,
                                params: {
                                    "sound": constantsObj.trans_button,
                                    "sound_on": true,
                                    "c": milestoneIndex,
                                    "l": levelNum,
                                    "co": counter
                                },
                                child: childArr,
                                feedBackType: constantsObj.ZOOMIN_FEEDBACK
                            }, false, ccui.Widget.PLIST_TEXTURE, 1);
                        setNodeLayer.addChild(curLevelNodeBtn, setNodeZOrder);

                        var typeOfPuzzle = questMapObj.getTypeAndPriceOfPuzzle(counter);
                        var bgWidth = 285;
                        if(typeOfPuzzle == "free" && counter == 1 && !gameObj.getWqTapHereMessageSeen()){
                            bgWidth = 360;
                        }
                        var colorBg = constantsObj.COLOR_BLACK;
                        var typeBg = utilObj.getScale9Sprite(constantsObj.tile_white_curved2, xPos, yPos - 200, 0.5, 0.5, bgWidth, 90, spriteArr, questMapLayer.scrollView, setNodeZOrder, constantsObj.SPRITE_MISC);
                        typeBg.setColor(colorBg);
                        typeBg.setOpacity(0);
                        typeBg.setCascadeOpacityEnabled(true);
                        if(state == constantsObj.STATE_PUZ_CLOSED || state == constantsObj.STATE_PUZ_COMPLETED) {
                            if (typeOfPuzzle == "free") {
                                //var diamond = utilObj.getSprite(constantsObj.diamond, 30 , 45, 0, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.15, spriteArr, typeBg, setNodeZOrder, constantsObj.SPRITE_MISC);
                                var freeMessage = "FREE";
                                if(counter == 1 && !gameObj.getWqTapHereMessageSeen()){
                                    freeMessage = "TAP HERE";
                                }
                                var freeLbl = utilObj.getBMFontLabel(freeMessage, constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_WHITE,
                                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), bgWidth/2, 45, 0.5, 0.5, labelArr, typeBg, setNodeZOrder);
                            } else if (typeOfPuzzle == "w2e") {
                                var lock = utilObj.getSprite(constantsObj.lock_quest, 40, 45, 0, 0.5, 0.1 * constantsObj.SCALE_SPRITE_NEW_1, spriteArr, typeBg, setNodeZOrder, constantsObj.SPRITE_MISC);
                                lock.setColor(constantsObj.COLOR_THEME_TEXT);
                                var w2e = utilObj.getSprite(constantsObj.w2eIcon, 150, 45, 0, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.6, spriteArr, typeBg, setNodeZOrder, constantsObj.SPRITE_MISC);
                                w2e.setOpacity(constantsObj.OPACITY_90);
                            } else if (typeOfPuzzle != "free") {
                                var lock = utilObj.getSprite(constantsObj.lock_quest, 40, 45, 0, 0.5, 0.1 * constantsObj.SCALE_SPRITE_NEW_1, spriteArr, typeBg, setNodeZOrder, constantsObj.SPRITE_MISC);
                                lock.setColor(constantsObj.COLOR_THEME_TEXT);
                                var price = utilObj.getBMFontLabel(typeOfPuzzle, constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_WHITE,
                                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), 180, 45, 1.0, 0.5, labelArr, typeBg, setNodeZOrder);
                                var coin = utilObj.getSprite(constantsObj.coin_png_2, 265, 45, 1, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 0.5, spriteArr, typeBg, setNodeZOrder, constantsObj.SPRITE_MISC);
                            }

                            var fadeIn = utilObj.getFadeTo(0.5, constantsObj.OPACITY_90);
                            animObj.runAction(typeBg, fadeIn);
                        }
                    } else {

                        // anim elements for the current node which are to be scaled in
                        questMapLayer.solvedNodeBgAnim = utilObj.getSprite(constantsObj.map_node, xPos, yPos, 0.5, 0.5, 1.2 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7, spriteArr, setNodeLayer, setNodeZOrder, constantsObj.SPRITE_MISC);
                        questMapLayer.solvedNodeBgAnim.setColor(constantsObj.COLOR_WHITE);
                        // questMapLayer.solvedNodeBgAnim.setOpacity(constantsObj.OPACITY_0);
                        questMapLayer.solvedNodeBgAnim.setScale(0);

                        questMapLayer.solvedNodeAnim = utilObj.getSprite(constantsObj.white_circle_150, xPos, yPos + offset, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 1.5, spriteArr, setNodeLayer, setNodeZOrder, constantsObj.SPRITE_MISC);
                        questMapLayer.solvedNodeAnim.setColor(constantsObj.COLOR_SOLVED_NODE);
                        // questMapLayer.solvedNodeAnim.setOpacity(constantsObj.OPACITY_0);
                        questMapLayer.solvedNodeAnim.setScale(0);

                        questMapLayer.tickAnim = utilObj.getSprite(constantsObj.tick, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1, spriteArr, setNodeLayer, setNodeZOrder, constantsObj.SPRITE_MISC);
                        questMapLayer.tickAnim.setColor(constantsObj.COLOR_WHITE);
                        // questMapLayer.tickAnim.setOpacity(constantsObj.OPACITY_0);
                        questMapLayer.tickAnim.setScale(0);

                        // anim elements for the scale in and scale out animations
                        questMapLayer.activeNodeBgAnim = activeNodeBg;
                        questMapLayer.activeNodeAnim = activeNode;
                        questMapLayer.activeNodeLblAnim = activeNodeLbl;
                        questMapLayer.profileAnim = questMapLayer.profile;

                        questMapLayer.circleSpriteAnim1 = utilObj.getSprite(constantsObj.white_circle_150, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_9 * 3.5, spriteArr, setNodeLayer, setNodeZOrder - 1 , constantsObj.SPRITE_MISC);
                        questMapLayer.circleSpriteAnim1.setOpacity(constantsObj.OPACITY_40);

                        questMapLayer.circleSpriteAnim2 = utilObj.getSprite(constantsObj.white_circle_150, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_9 * 3.75 * 1.2, spriteArr, setNodeLayer, setNodeZOrder - 1, constantsObj.SPRITE_MISC);
                        questMapLayer.circleSpriteAnim2.setOpacity(constantsObj.OPACITY_40);

                    }

                }
            } else {

                var closedNodeBg = utilObj.getSprite(constantsObj.map_node, xPos, yPos, 0.5, 0.5, 1.1 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7, spriteArr, setNodeLayer, setNodeZOrder, constantsObj.SPRITE_MISC);
                closedNodeBg.setColor(constantsObj.COLOR_CLOSED_NODE);
                var closedNodeFont = constantsObj.FONT_HELVETICA_MEDIUM_90;
                var lblYPos = yPos;
                if ((questMapLayer.toShowMileStoneAnim || questMapLayer.toShowNodeChangeAnim) && counter == curPuzzleIndex + 1) {
                    closedNodeFont = constantsObj.FONT_HELVETICA_MEDIUM_100;
                    lblYPos += offset;
                }

                var closedNodeLbl = utilObj.getBMFontLabel("" + counter, closedNodeFont, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, lblYPos, 0.5, 0.5, labelArr, setNodeLayer, setNodeZOrder);

                var str = counter + "_" + "locked";

                childArr = [closedNodeBg, closedNodeLbl];
                var lockLevelBtn = utilObj.getButton(170, 170, 0.5, 0.5,
                    xPos, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                        obj: 'questMapLayer',
                        fn: 'showLockLevelMsg',
                        screen: questMapLayer.screen,
                        params: {
                            "sound": constantsObj.trans_button,
                            "sound_on": true,
                            "counter" : counter
                        },
                        track : {
                            k: constantsObj.TRACK_DIALOG,
                            p: "",
                            c: "",
                            o: constantsObj.TRACK_WQ_MAP,
                            f: "node_click",
                            g: str,
                            s: "",
                            co: "",
                            oppId: ""
                        },
                        child: childArr,
                        feedBackType: constantsObj.ZOOMIN_FEEDBACK
                    }, false, ccui.Widget.PLIST_TEXTURE, 1);
                questMapLayer.scrollView.addChild(lockLevelBtn, constantsObj.SPRITE_Z_ORDER + 1);

                if ((questMapLayer.toShowMileStoneAnim || questMapLayer.toShowNodeChangeAnim) && counter == curPuzzleIndex + 1) {
                    questMapLayer.activeNodeBgAnim1 = utilObj.getSprite(constantsObj.map_node, xPos, yPos, 0.5, 0.5, 1.4 * constantsObj.SCALE_SPRITE_NEW_1 * 0.7, spriteArr, setNodeLayer, setNodeZOrder, constantsObj.SPRITE_MISC);
                    questMapLayer.activeNodeBgAnim1.setColor(constantsObj.COLOR_WHITE);
                    questMapLayer.activeNodeBgAnim1.setScale(0);

                    questMapLayer.activeNodeAnim1 = utilObj.getSprite(constantsObj.white_circle_150, xPos, yPos + offset, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * 1.5, spriteArr, setNodeLayer, setNodeZOrder, constantsObj.SPRITE_MISC);
                    questMapLayer.activeNodeAnim1.setColor(constantsObj.COLOR_ACTIVE_NODE);
                    questMapLayer.activeNodeAnim1.setScale(0);
                }
            }
        }
        ,

        openPuzzle: function (sender, params) {
            var curPuzzleNo = questMapLayer.curLevelNum;
            var puzzleInfo = {};
            var puzzleState = 0;
            var info = [];
            if (utilObj.getStringifiedJson(gameObj.getCurPuzzleInfo()) != utilObj.getStringifiedJson([])) {
                info = gameObj.getCurPuzzleInfo();
                puzzleInfo = info[0];
                puzzleState = questMapObj.getPuzStateById(puzzleInfo.id);
            } else {
                puzzleInfo = questMapObj.getPuzzleForIndex(curPuzzleNo);
                puzzleState = questMapObj.getPuzStateById(puzzleInfo.id);
                info.push(puzzleInfo);
                gameObj.setCurPuzzleInfo(info);
            }
            questMapLayer.clickedPuzzleId = puzzleInfo.id;
            gameObj.setClickedPuzzleId(questMapLayer.clickedPuzzleId);
            questMapLayer.clickedPuzzleIndex = curPuzzleNo;
            gameObj.setClickedPuzzleNum(questMapLayer.clickedPuzzleIndex);
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, questMapLayer.clickedPuzzleId , "", constantsObj.TRACK_WQ_MAP, "node_click", questMapLayer.curLevelNum + "_" + "current", "", "", "");

            //loggerObj.debugLog("curpuzzle", questMapLayer.curLevelNum, curPuzzleNo, questMapLayer.clickedPuzzleIndex, utilObj.getStringifiedJson(gameObj.getCurPuzzleInfo()), utilObj.getStringifiedJson(puzzleInfo), puzzleState, utilObj.getStringifiedJson(gameObj.getCurPuzzleInfo()) != []);


            var type = puzzleInfo.type;
            var id = puzzleInfo.id;
            var price = puzzleInfo.price;
            var isMiniOrMidi = gameObj.checkForMiniOrMidi(puzzleInfo.id);
            var showPopupCondition = false;
            if (puzzleState == constantsObj.STATE_PUZ_CLOSED && (type == constantsObj.PAID_PUZZLE || type == constantsObj.BONUS_ARCHIVE)) {
                showPopupCondition = true;
            }
            var inProgress = gameObj.getInProgress();
            if (puzzleState == constantsObj.STATE_PUZ_COMPLETED && inProgress[id] == undefined) {
                showPopupCondition = true;
            }
            if (showPopupCondition) {
                if (puzzleState == constantsObj.STATE_PUZ_COMPLETED) {
                    if (isMiniOrMidi && gameObj.getQuestCompMiniConfirmationPopup() == 1) {
                        questPuzzleUnlockPopup.replay("fromQuest", puzzleInfo.id);
                        return;
                    } else if (!isMiniOrMidi && gameObj.getQuestCompMainConfirmationPopup() == 1) {
                        questPuzzleUnlockPopup.replay("fromQuest", puzzleInfo.id);
                        return;
                    }
                } else {
                    if (isMiniOrMidi && gameObj.getQuestMiniConfirmationPopup() == 1) {
                        questPuzzleUnlockPopup.loadMiniPuzzle(id, price, "noPopup");
                        return;
                    }
                    if (!isMiniOrMidi && gameObj.getQuestMainConfirmationPopup() == 1) {
                        if (type == constantsObj.BONUS_ARCHIVE) {
                            var bucket = questMapObj.getBucketAllocated();
                            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", constantsObj.TRACK_WQ_MAP, "w2e_archive", bucket + "_" + questMapLayer.curLevelNum, "", "", "");
                            questPuzzleUnlockPopup.loadBonusArchivePuzzle(id, "noPopup");
                            return;
                        } else {
                            questPuzzleUnlockPopup.loadArchivePuzzle(id, price, "noPopup");
                            return;
                        }
                    }
                }
                questPuzzleUnlockPopup.show(null, puzzleInfo);
            } else {
                questMapLayer.hide();
                var isFromPack = false;
                if (puzzleInfo.type == "packsFree") {
                    isFromPack = true;
                }
                gameLayer.show(puzzleInfo.id, false, false, true);
            }
        }
        ,

        showLockLevelMsg: function (sender , params) {
            var bucket = questMapObj.getBucketAllocated();
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "node_locked",params.counter, bucket + "_" + questMapLayer.curLevelNum , "", "", "");

            utilObj.showMessage(stringsObj.puzzle_not_open);
        }
        ,

        solvedPuzzleFunc: function () {
            utilObj.showMessage(stringsObj.puzzle_solved);
        },

        // this will open a popup for the completed or incompleted milestone
        milestoneHitFunc: function (sender, params) {
            questMilestonePopup.show(null, params);
            //popup will be open here to show milestone discovered.
        },

        addTopOptions: function (xPos, yPos, spriteArr, labelArr, zOrder) {
            //yPos -= 226;
            var localYPos = yPos - 70;
            var screen = questMapLayer.screen;
            var setLayer = questMapLayer;
            var tab = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos, 0.5, 1, canvasWidth, 140, spriteArr, setLayer, zOrder, constantsObj.SPRITE_MISC);
            tab.setColor(constantsObj.COLOR_WHITE);
            xPos = xRightPos - 30;

            var msg = utilObj.getSprite(constantsObj.setting_icon, xRightPos - 70, localYPos, 1, 0.5, constantsObj.SCALE_SPRITE_14 * 1.5, spriteArr, setLayer, zOrder, constantsObj.SPRITE_MISC);
            msg.setColor(constantsObj.COLOR_BLACK);
            var settingsButton = utilObj.getButton(123, 200, 1, 0.5, xRightPos - 50, localYPos,
                constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: 'questMapLayer',
                    fn: 'settings',
                    screen: screen,
                }, false, ccui.Widget.PLIST_TEXTURE);
            utilObj.addChild(setLayer, settingsButton, zOrder + 1);


            xPos = xRightPos - 30;
            var xShiftTemp = 200;
            var coinBg = utilObj.getScale9Sprite(constantsObj.tile_white_curved, xPos - (350 + xShiftTemp), localYPos, 0, 0.5, 320, 80, spriteArr,
                setLayer, zOrder, constantsObj.SPRITE_MISC);
            coinBg.setColor(constantsObj.COLOR_GREY);
            var coinImg = utilObj.getSprite(constantsObj.coin_png_2, xPos - (350 + xShiftTemp), localYPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, setLayer, zOrder, constantsObj.SPRITE_MISC);
            var coinCount = economyObj.getCash();
            setLayer.cashLbl = utilObj.getBMFontLabel(coinCount + "", constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - (210 + xShiftTemp), localYPos, 0.5, 0.5, labelArr, setLayer, zOrder + 1);

            var plusImg = utilObj.getSprite(constantsObj.green_plus, xPos - (100 + xShiftTemp), localYPos, 0, 0.5, constantsObj.SCALE_SPRITE_1, spriteArr, setLayer, zOrder, constantsObj.SPRITE_MISC);

            var childArr = [coinImg, plusImg];
            var buttonAtCoins = utilObj.getButton(450, 180, 0, 0.5, xPos - (420 + xShiftTemp), localYPos,
                constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: 'questMapLayer',
                    fn: 'showStore',
                    screen: screen,
                    child: childArr,
                    feedBackType: constantsObj.ZOOMIN_FEEDBACK
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            utilObj.addChild(setLayer, buttonAtCoins, zOrder + 1);

            //mastery display on home screen
            var starCount = gameObj.getMastery1();

            xPos = xLeftPos + 100;

            var starBg = utilObj.getScale9Sprite(constantsObj.tile_white_curved, xPos + 210, yPos - 70, 0, 0.5, 350, 80, spriteArr,
                setLayer, zOrder, constantsObj.SPRITE_MISC);
            starBg.setColor(constantsObj.COLOR_GREY);

            var star = utilObj.getSprite(constantsObj.star_white_2, xPos + 170, yPos - 65, 0, 0.5, constantsObj.SCALE_SPRITE_1, spriteArr, setLayer, zOrder, constantsObj.SPRITE_MISC);
            star.setColor(constantsObj.COLOR_BLUE_01);

            var xOffset = 0;
            var offsetForMessageCenter = 90;
            if (starCount > 999) {
                xOffset = 30;
                offsetForMessageCenter = 240;
            } else if (starCount > 99) {
                xOffset = 20;
                offsetForMessageCenter = 190;
            } else if (starCount > 9) {
                xOffset = 10;
                offsetForMessageCenter = 150;
            }
            setLayer.masteryLbl = utilObj.getBMFontLabel(starCount + "", constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 350 + xOffset, yPos - 70, 0, 0.5, labelArr, setLayer, zOrder + 1);

            xPos = xLeftPos - 60;
            if (subscriptionsDTCObj.getIsSubscriptionActive()) {
                var diamond = utilObj.getSprite(constantsObj.diamond, xLeftPos + (100 * canvasWidth / 1440), localYPos - 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_8, spriteArr, setLayer, zOrder, constantsObj.SPRITE_MISC);
                //Shain Animation
                if (!homeObj.checkFtueConditions()) {
                    var xPos = diamond.getPositionX();
                    var yPos1 = diamond.getPositionY();
                    var width = diamond.getContentSize().width * constantsObj.SCALE_SPRITE_8/* / (constantsObj.SCALE_SPRITE_9 * 1.5)*/;
                    var height = diamond.getContentSize().height * constantsObj.SCALE_SPRITE_8/* / (constantsObj.SCALE_SPRITE_9 * 1.5)*/;

                    var xBottom = xPos - width / 2;
                    var xTop = xPos + width / 2;
                    var yLeft = yPos1 - height / 2;
                    var yRight = yPos1 + height / 2;

                    var posArr = [{x: xPos + width / 4, y: yRight}, {
                        x: xPos + 5,
                        y: yLeft
                    }, {x: xPos, y: yRight}, {x: xBottom, y: yPos1}, {x: xPos + width / 4, y: yRight}, {
                        x: xBottom,
                        y: yPos1
                    }, {x: xPos + width / 4, y: yRight}, {x: xPos, y: yRight}];
                    var shainSpriteArr = [];

                    for (var i in posArr) {
                        var shainSprite = utilObj.getSprite(constantsObj.shain, posArr[i].x, posArr[i].y, 0.5, 0.5, constantsObj.SCALE_SPRITE_10, null, null, constantsObj.FTUE_Z_ORDER + 2, constantsObj.SPRITE_MISC);
                        utilObj.addChild(setLayer, shainSprite, constantsObj.FTUE_Z_ORDER + 2);
                        utilObj.setScale(shainSprite, 0);
                        shainSpriteArr.push(shainSprite);
                        subscriptionsLaunchLayer.spritesArrToRemove.push(shainSprite);
                    }

                    utilObj.delayedCallback(setLayer, animObj.addShainAnimationHome, 0.02, {
                        arr: shainSpriteArr,
                        screen: setLayer
                    });
                }
                childArr = [diamond];
                var subsButton = utilObj.getButton(140, 140, 0, 0.5,
                    xLeftPos + (40 * canvasWidth / 1440), localYPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                        obj: 'questMapLayer',
                        fn: 'showSubsDailyStatus',
                        screen: setLayer.screen,
                        // buttonBg: gameLayer.bg,
                        child: childArr,
                        feedBackType: constantsObj.ZOOMIN_FEEDBACK
                    }, false, ccui.Widget.PLIST_TEXTURE, constantsObj.SCALE_ONE);
                utilObj.addChild(setLayer, subsButton, zOrder);
            } else if (subscriptionsObj.getSubPkgId() != "" && subscriptionsObj.getSubPkgId() != null && subscriptionsDTCObj.getIsSubscriptionInActive()) {
                var diamond = utilObj.getSprite(constantsObj.diamond_grey, xLeftPos + (100 * canvasWidth / 1440), localYPos - 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_8, spriteArr, setLayer, zOrder, constantsObj.SPRITE_MISC);
                childArr = [diamond];
                var subsButton = utilObj.getButton(140, 140, 0, 0.5,
                    xLeftPos + (40 * canvasWidth / 1440), localYPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                        obj: 'questMapLayer',
                        fn: 'showSubsPopupOffer',
                        screen: setLayer.screen,
                        child: childArr,
                        feedBackType: constantsObj.ZOOMIN_FEEDBACK
                    }, false, ccui.Widget.PLIST_TEXTURE, constantsObj.SCALE_ONE);
                utilObj.addChild(setLayer, subsButton, zOrder);
            } else {
                var msgIcon = utilObj.getSprite(constantsObj.messenger_icon_new, xLeftPos + (40 * canvasWidth / 1440), localYPos - 2, 0, 0.5, constantsObj.SCALE_SPRITE_11, spriteArr, setLayer, zOrder, constantsObj.SPRITE_MISC);
                msgIcon.setColor(constantsObj.COLOR_BLACK);
                childArr = [msgIcon];
                var msgButton = utilObj.getButton(140, 140, 0, 0.5,
                    xLeftPos + (40 * canvasWidth / 1440), localYPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                        obj: 'questMapLayer',
                        fn: 'showMsgCenter',
                        screen: setLayer.screen,
                        child: childArr,
                        feedBackType: constantsObj.ZOOMIN_FEEDBACK
                    }, false, ccui.Widget.PLIST_TEXTURE, constantsObj.SCALE_ONE);
                utilObj.addChild(setLayer, msgButton, zOrder + 1);
            }
        },

        freeVideoFunc: function () {

            var bucket = questMapObj.getBucketAllocated();
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", constantsObj.TRACK_WQ_MAP, "w2e_click", bucket + "_" + questMapLayer.curLevelNum , "", "", "");


            if (!utilObj.isOnline()) {
                utilObj.showMessage(stringsObj.not_online);
                return;
            }

            var coolDownPeriod = 7200;

            var firstVideoShownTimeStamp = gameObj.getFirstVideoSeenTimeStamp();
            if (firstVideoShownTimeStamp == null || (utilObj.getCurrentTimestamp() - firstVideoShownTimeStamp) > coolDownPeriod) {
                firstVideoShownTimeStamp = utilObj.getCurrentTimestamp();
                gameObj.setFirstVideoSeenTimeStamp(firstVideoShownTimeStamp);
                if (!(gameObj.isEligibleForVideoAchiement() && gameObj.getAchievementsState(43) == constantsObj.ACHIEVEMENT_IN_PROGRESS)) {
                    gameObj.setNumVideos(0);
                }
            }

            var storeVideoVariant = epmObj.getChosenVariant(constantsObj.EXP_STORE_VIDEO_VIEWS);
            var forcedEarnFreeFtue = false;
            if (storeVideoVariant == constantsObj.EXP_VAR_1) {
                var lastStoreVideoClickedTimeStamp = gameObj.getWatchVideoStoreTimeStamp();
                var currTimeStamp = utilObj.getCurrentTimestamp();
                if (currTimeStamp - lastStoreVideoClickedTimeStamp < constantsObj.SECONDS_IN_HOUR) {
                    forcedEarnFreeFtue = true;
                } else {
                    gameObj.setWatchVideoStoreTimeStamp(currTimeStamp);
                }
            }

            var maxVideosAllowed = 5;
            if (gameObj.getIsPayer()) {
                maxVideosAllowed = runtimeObj.getNumVideosNew(2);
            } else {
                if ((utilObj.getCurrentTimestamp() - userObj.getCreated()) < 7 * constantsObj.SECONDS_IN_DAY) {
                    maxVideosAllowed = runtimeObj.getNumVideosNew(0);
                } else {
                    maxVideosAllowed = runtimeObj.getNumVideosNew(1);
                }
            }

            if (gameObj.isEligibleForVideoAchiement() && gameObj.getAchievementsState(43) == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                maxVideosAllowed = 6;
            }
            // loggerObj.debugLog("checking no of videos", maxVideosAllowed);

            /*if (forcedEarnFreeFtue == true) {
             // loggerObj.debugLog("coming to this point");
             storeLayer.showEarnFreeFtue(constantsObj.SCREEN_STORE_LAYER);
             } else*/
            if ((utilObj.getCurrentTimestamp() - firstVideoShownTimeStamp) < coolDownPeriod && gameObj.getNumVideos() < maxVideosAllowed) {
                if (adsObj.checkRewardedVideo(false, storeLayer.callbackfnForVideo)) {
                    gameObj.setLastVideoSeenTimeStamp(utilObj.getCurrentTimestamp());
                    /*if (storeVideoVariant == constantsObj.EXP_VAR_2) {
                     storeLayer.redraw();
                     }*/
                    adsObj.showVideoAd(false);
                    adsObj.setNotRewardedVideo(false);
                }
                else {
                    trackObj.trackCounter(constantsObj.TRACK_AD_TRACKING, constantsObj.TRACK_W2E, constantsObj.TRACK_RETRY, curScreen, "", "mopub", "", "", "");
                    // utilObj.showMessage("No Video Available. Please watch after some time");
                }

            } else {
                var timeRemaining = coolDownPeriod - (utilObj.getCurrentTimestamp() - firstVideoShownTimeStamp);
                //utilObj.showMessageAtTop("Next video in " + utilObj.formatTime(timeRemaining));
                if (timeRemaining > 0) {
                    utilObj.showMessageAtTop("Next video in " + utilObj.formatTime(timeRemaining));
                    trackObj.trackCounter(constantsObj.TRACK_AD_MEDIATION, constantsObj.TRACK_W2E, "cooldown", curScreen, "", "", "", "", "");
                    machineLearningDataObj.setVideoTriesCooldown();
                }
            }
        },


        back: function () {
            // check for anim running
            if (questMapLayer.animRunning) {
                return;
            }
            var bucket = questMapObj.getBucketAllocated();
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", constantsObj.TRACK_WQ_MAP, "back_btn", bucket + "_" + questMapLayer.curLevelNum , "", "", "");

            questMapLayer.hide();
            if(questMapLayer.isFromPlayQuest){
                var isTodaysDailyMini = false;
                var isDailyMini = gameObj.checkForDailyMini(transOutroLayer.puzzleId);
                if (isDailyMini) {
                    var dailyMiniDate = gameObj.convertDailyMiniIdToArchive(transOutroLayer.puzzleId);
                    if (!subscriptionsDTCObj.getIsSubscriptionActive() || dailyMiniDate == utilObj.getIdForDate(gameObj.getTodaysPuzzleDate())) {
                        isTodaysDailyMini = true;
                    }
                }
                var bonusArchiveAvailable = false;
                if (gameObj.getTodaysFreePuzzle() == gameLayer.crosswordDate && (gameObj.getNumberOfBonusArchiveWatched() + questMapObj.getNumberOfBonusArchiveWatched()) < runtimeObj.getNumberOfBonusArchive() && runtimeObj.getBonusArchiveOutro() == 1) {
                    bonusArchiveAvailable = true;
                }
                if ((isTodaysDailyMini || utilObj.getIdForDate(gameObj.getTodaysPuzzleDate()) == transOutroLayer.puzzleId || bonusArchiveAvailable) && homeLayoutExp == constantsObj.EXP_VAR_2) {
                    homeLayer.show();
                }else {
                    var isFromPack = gameLayer.isPuzzleFromPack;
                    if (gameLayer.isFromMapScreen) {
                        homeLayer.show();
                    } else if (isFromPack) {
                        packsLayer.show();
                    } else {
                        if (!transOutroLayer.isDailyMiniPuzzle) {
                            calendarLayer.selectedTab = constantsObj.CALENDAR_SCREEN;
                        }
                        calendarLayer.show();
                    }
                }
            }else {
                homeLayer.show();
            }
        },

        showHelpCenter: function (sender , params) {
            var topBg = params.topBg;
            var weeklyTheme =params.weeklyTheme;
            var weeklyThemeName = params.weeklyThemeName;
            var timerLbl = params.timerLbl;
            var infoBtn = params.infoBtn;

            utilObj.setOpacity(topBg , constantsObj.OPACITY_60);
            utilObj.setOpacity(weeklyTheme , constantsObj.OPACITY_60);
            utilObj.setOpacity(weeklyThemeName , constantsObj.OPACITY_60);
            utilObj.setOpacity(timerLbl , constantsObj.OPACITY_60);
            utilObj.setOpacity(infoBtn , constantsObj.OPACITY_60);

            var bucket = questMapObj.getBucketAllocated();
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", constantsObj.TRACK_WQ_MAP, "info", bucket + "_" + questMapLayer.curLevelNum , "", "", "");

            utilObj.delayedCallback(questMapLayer , questMapLayer.showSupportLayer , 0.1 , null , false);

        },

        showSupportLayer : function(){
            utilObj.contactUsSuggestion("What is the Weekly Quest?");
            /*
            var params = {
                pLayer: constantsObj.SCREEN_QUEST_MAP,
            };
            questMapLayer.hide();
            supportLayer.init();
            supportLayer.show("features:How to play Weekly Quest?", params);*/

        },

        addRedirectButton: function (scrollDirection) {
            var zOrder = constantsObj.SPRITE_Z_ORDER + 1;
            var spriteArr = [];
            questMapLayer.shouldAddButton = 0;

            var linearShift = 0;
            if (utilObj.isBezelScreen()) {
                linearShift = constantsObj.BEZEL_SAFE_AREA;
            }
            questMapLayer.redirectImg = utilObj.getSprite(constantsObj.white_circle_150, xRightPos - 30, 417, 1.0, 0, constantsObj.SCALE_SPRITE_NEW_1 * 1.42, spriteArr, questMapLayer, zOrder + 1, constantsObj.SPRITE_MISC);
            questMapLayer.redirectImg.setColor(constantsObj.COLOR_WHITE);
            questMapLayer.redirectImg.setCascadeOpacityEnabled(true);

            var scrollBtnBlack = utilObj.getSprite(constantsObj.white_circle_150, questMapLayer.redirectImg.getContentSize().width / 2, questMapLayer.redirectImg.getContentSize().height / 2, 0.5, 0.5, 0.95, spriteArr, questMapLayer.redirectImg, zOrder + 1, constantsObj.SPRITE_MISC);
            scrollBtnBlack.setColor(constantsObj.COLOR_BLACK);
            scrollBtnBlack.setOpacity(constantsObj.OPACITY_90);

            var arrow = utilObj.getSprite(constantsObj.arrow_map_layer, questMapLayer.redirectImg.getContentSize().width / 2, questMapLayer.redirectImg.getContentSize().height / 2, 0.5, 0.5, 0.35 * constantsObj.SCALE_SPRITE_NEW_1, spriteArr, questMapLayer.redirectImg, zOrder + 1, constantsObj.SPRITE_MISC);
            arrow.rotation = 90;

            //questMapLayer.redirectImg.setCascadeOpacityEnabled(true);

            questMapLayer.redirectBtn = utilObj.getButton(205, 205, 1.0, 0,
                xRightPos - 30, 417, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: 'questMapLayer',
                    fn: 'redirectToCurLevel',
                    screen: questMapLayer.screen,
                    params: {
                        "sound": constantsObj.trans_button,
                        "sound_on": false,
                    },
                    child: [questMapLayer.redirectImg],
                    feedBackType: constantsObj.ZOOMIN_FEEDBACK
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            questMapLayer.addChild(questMapLayer.redirectBtn, zOrder + 2);
            utilObj.setOpacity(questMapLayer.redirectBtn, 0);

            if (scrollDirection == "down") {
                arrow.setRotation(-90);
            }
            // utilObj.setVisible(questMapLayer.redirectImg, false);
            utilObj.setOpacity(questMapLayer.redirectImg, 0);
            questMapLayer.showRedirectBtn(questMapLayer.redirectBtn);
            utilObj.addSprites(spriteArr);
        },

        redirectToCurLevel: function () {
            //questMapLayer.curLevelNum = questMapLayer.curPuzzleNo + questMapLayer.curMilestoneInfo["index"] - questMapLayer.curMilestoneInfo["totalPuzzles"];
            var bucket = questMapObj.getBucketAllocated();
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", constantsObj.TRACK_WQ_MAP, "scroll_down", bucket + "_" + questMapLayer.curLevelNum , "", "", "");

            var durationToScroll = 0.8;
            utilObj.scrollToPercentVertical(questMapLayer.scrollView , questMapLayer.jumpToPercent, durationToScroll, true);
            questMapLayer.curMilestoneNode = questMapLayer.curMilestoneInfo["id"] - 1;
            questMapLayer.shouldAddButton = 1;
            questMapLayer.hideRedirectBtn(questMapLayer, questMapLayer.redirectBtn);
        },


        hideRedirectBtn: function (layer, node) {
            if (!utilObj.isNodeValid(node)) {
                return;
            }
            // utilObj.setVisible(questMapLayer.redirectImg, false);
            var time = 0.2;
            var delay = utilObj.getDelayTime(0.1);
            var fadeOut = utilObj.getFadeOut(time);
            var seqAction = [delay, fadeOut];
            var seq = utilObj.getSequence(seqAction, false);
            animObj.runAction(questMapLayer.redirectImg, seq);

            var params = {
                n: node,
                l: layer
            };
            utilObj.delayedCallback(layer, questMapLayer.removeRedirectBtn, 0.3, params, false);

            var params = {
                n: questMapLayer.redirectImg,
                l: layer
            };
            utilObj.delayedCallback(layer, questMapLayer.removeRedirectBtn, 0.3, params, false);

        },

        removeRedirectBtn: function (sender, params) {
            var node = params.n;
            var layer = params.l;
            utilObj.removeChild(layer, node);
        },

        jumpToCurrentNode: function (percentJump, directJump) {
            if (utilObj.isNative() || directJump) {
                questMapLayer.scrollView.jumpToPercentVertical(percentJump);
            } else {
                utilObj.scrollToPercentVertical(questMapLayer.scrollView , percentJump, 0.1, false);
            }
        },

        showRedirectBtn: function (node) {
            if (!utilObj.isNodeValid(node)) {
                return;
            }
            // utilObj.setVisible(questMapLayer.redirectImg, true);
            var time = 0.2;
            var delay1 = utilObj.getDelayTime(0.1);
            var fadeIn = utilObj.getFadeTo(time , constantsObj.OPACITY_80);
            var seqAction1 = [delay1, fadeIn];
            var seq1 = utilObj.getSequence(seqAction1, false);
            animObj.runAction(questMapLayer.redirectImg, seq1);
        },

        settings: function () {
            var bucket = questMapObj.getBucketAllocated();
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", constantsObj.TRACK_WQ_MAP, "settings", bucket + "_" + questMapLayer.curLevelNum , "", "", "");

            settingsPopup.show(constantsObj.SCREEN_QUEST_MAP);
        },

        showStore: function () {
            var bucket = questMapObj.getBucketAllocated();
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", constantsObj.TRACK_WQ_MAP, "store", bucket + "_" + questMapLayer.curLevelNum , "", "", "");

            questMapLayer.hide();
            storeLayer.show();
        },

        showMsgCenter: function () {
            popupLayer.closeWithDefault();
            freeCoins2Popup.show(true, constantsObj.SCREEN_QUEST_MAP);
        },

        showSubsDailyStatus: function () {
            gameObj.setScreenTypeForSubsLayer(constantsObj.SUBSCRIPTION_DAILY_STATUS);
            subscriptionsLaunchLayer.show(true);
        },

        showSubsPopupOffer: function () {
            gameObj.setScreenTypeForSubsLayer(constantsObj.SUBSCRIPTION_OFFER);
            subscriptionsLaunchLayer.show(true);
        },

        /**
         * this function checks and opens the available daily puzzle (mains or mini)
         */
        checkAndOpenAvailableTodaysPuzzle: function() {
            var puzzleId = gameObj.getAvailableTodaysPuzzleId();
            if (puzzleId == constantsObj.NOT_FOUND) {
                utilObj.showMessage("Come back tomorrow to keep your streak going");
                return;
            }

            if(gameObj.getCrosswordForDate(puzzleId) == null){
                if (utilObj.isOnline() == false) {
                    utilObj.showMessage("Please connect to internet to download content");
                } else {
                    runtimeObj.syncToServer();
                    utilObj.showMessage("Please try after some time");
                }
                return;
            }

            questMapLayer.hide();
            questMapObj.setQuestMapAutoOn(true);
            gameLayer.show(puzzleId, false, false,false,false,true);
        },

        /**
         * function returns tick image details for creating ui on todays challenge section
         * @param completedPuzzlesCount
         * @returns {{image: string, color: *, opacity: *, scale: number}}
         */
        getTickImageDetailsForTodaysSection: function (completedPuzzlesCount) {
            var tickDetails = {image: constantsObj.tick_streak1, color: constantsObj.COLOR_GREY, opacity: constantsObj.OPACITY_30, scale: constantsObj.SCALE_SPRITE_1 * 0.6};
            if(completedPuzzlesCount == 1){
                tickDetails.color = constantsObj.COLOR_BLUE_HS_NEW;
                tickDetails.opacity = constantsObj.OPACITY_100;
            } else if(completedPuzzlesCount == 2){
                tickDetails.image = constantsObj.tick_streak2;
                tickDetails.color = constantsObj.COLOR_PURPLE_03;
                tickDetails.opacity = constantsObj.OPACITY_100;
                tickDetails.scale = constantsObj.SCALE_SPRITE_3 * 0.55;
            }
            return tickDetails;
        },

        /**
         * this function checks if all the quest puzzles are completed
         * it compares the lastLevel and totalPuzzles values to get the result
         * @returns {boolean}
         */
        areAllQuestPuzzlesCompleted: function () {
            if(!questMapLayer.totalPuzzles){
                return false;
            }
            if(questMapLayer.lastLevel < questMapLayer.totalPuzzles){
                return false;
            }
            return true;
        },



        // loadBonusArchivePuzzle : function(id , from){
        //     var id = id;
        //     var from = from;
        //     var inProgress = gameObj.getInProgress();
        //     gameObj.setCrosswordToShow(id);
        //
        //         if (inProgress[id]) {
        //             questMapLayer.hide();
        //             gameLayer.show(id);
        //         } else if (adsObj.checkRewardedVideoAvailable() && utilObj.isOnline()) {
        //             gameObj.setPuzzleToUnlock(id);
        //             gameObj.setArchiveUnlockReward(true);
        //             adsObj.showVideoAd(false, "forBonusArchiveNew");
        //             adsObj.setNotRewardedVideo(false);
        //             } else {
        //             hintAndBuyPopup.show(constantsObj.HINT_AND_BUY_POPUP[6], id, from);
        //
        //              }
        //
        //
        // },

        // loadBonusMiniPuzzle : function(id , from){
        //     var id = id;
        //     var inProgress = gameObj.getInProgress();
        //     gameObj.setCrosswordToShow(id);
        //         if (inProgress[id]) {
        //             questMapLayer.hide();
        //             gameLayer.show(id);
        //         } else if (adsObj.checkRewardedVideoAvailable() && utilObj.isOnline()) {
        //             gameObj.setPuzzleToUnlock(id);
        //             gameObj.setBonusMiniUnlockReward(true);
        //             adsObj.showVideoAd(false, "forBonusMiniNew");
        //             adsObj.setNotRewardedVideo(false);
        //         } else {
        //             hintAndBuyPopup.show(constantsObj.HINT_AND_BUY_POPUP[6], id, from);
        //
        //         }
        //
        //
        // },

        // loadPaidPuzzle : function(id){
        //     if (!economyObj.makePayment(null, null, constantsObj.PKG_CASH, economyObj.getRevealCrosswordCost(), "bonus_archive", "", questMapLayer)) {
        //         return false;
        //     }
        //     questMapLayer.hide();
        //
        //     gameLayer.show(id, false);
        // }

    })
    ;

