var SubscriptionsLaunch = cc.Layer.extend({
    spritesArrToRemove: [],
    screen: null,
    scrollview: null,
    greenbg1: null,
    greenbg2: null,
    pricelbll1: null,
    procelbll2: null,
    pricelbll3: null,
    perWeek1: null,
    pricelblr1: null,
    pricelblr2: null,
    pricelblr3: null,
    perWeek2: null,
    selected1: false,
    selected2: true,
    puzzleUnlockLabel: null,
    puzzleUnlockLabel1: null,
    arrForTimeRem: null,
    arrForClaimB: null,
    returnParams: null,
    popupName: null,
    popupParams: null,
    fromCalendar: null,
    isCoinGrantAnimRunning: false,
    goBackToStore: false,
    outlineForAnim1: null,
    outlineForAnim2: null,
    isRingAnimAlreadyRunning: false,
    priceLbl: null,
    subPrice1: null,
    subPrice2: null,

    hide: function () {
        subscriptionsLaunchLayer.stopAllActions();
        subscriptionsLaunchLayer.setVisible(false);
        subscriptionsLaunchLayer.removeAllChildren();
    },

    backToGame: function () {
        if (utilObj.isAndroid()) {
            var redraw = true;
            if ((subscriptionsLaunchLayer.popupName != null && !subscriptionsDTCObj.getIsSubscriptionActive()) || subscriptionsLaunchLayer.goBackToStore) {
               redraw = false;
            }
            utilObj.goToLastScreen(redraw);
        } else {
            utilObj.goToLastScreen(true);
        }
        if (subscriptionsLaunchLayer.popupName == "hintAndBuy" && !subscriptionsDTCObj.getIsSubscriptionActive()) {
            hintAndBuyPopup.show(constantsObj.HINT_AND_BUY_POPUP[4], subscriptionsLaunchLayer.returnParams, subscriptionsLaunchLayer.fromCalendar);
        } else if (subscriptionsLaunchLayer.popupName == "goToCalendar" && !subscriptionsDTCObj.getIsSubscriptionActive()) {
            homeLayer.hide();
            calendarLayer.show();
        } else if (subscriptionsLaunchLayer.popupName == "goToCalendarFromPack" && !subscriptionsDTCObj.getIsSubscriptionActive()) {
            packsLayer.hide();
            calendarLayer.show();
        } else if (subscriptionsLaunchLayer.popupName == "goToCalendarFromAchievement" && !subscriptionsDTCObj.getIsSubscriptionActive()) {
            achievementsLayer.hide();
            calendarLayer.show();
        } else if (subscriptionsLaunchLayer.popupName == "goToMiniCalendar") {
            if (subscriptionsLaunchLayer.popupParams != null) {
                homeLayer.subscriptionTag = 0;
                homeLayer.loadDailyMiniPuzzle();
            } else {
                calendarLayer.selectedTab = constantsObj.MINI_SCREEN;
                homeLayer.hide();
                calendarLayer.show();
            }
        } else if (subscriptionsLaunchLayer.popupName == "goToArchivePuzzle" && subscriptionsLaunchLayer.popupParams != undefined && economyObj.getCash() >= economyObj.getRevealCrosswordCost()) {
            homeLayer.subscriptionTag = 0;
            homeLayer.loadArchivePuzzle1(subscriptionsLaunchLayer.popupParams);
        } else if (subscriptionsLaunchLayer.goBackToStore) {
            curLayer.hide();
            storeLayer.show(true);
        }
    },

    back: function () {
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "subsciption", constantsObj.TRACK_BACK, "", "", "1", "");
        subscriptionsLaunchLayer.hide();
        subscriptionsLaunchLayer.backToGame();
    },

    closewithAnim: function () {
        for (var i in subscriptionsLaunchLayer.spritesArrToRemove) {
            var node = subscriptionsLaunchLayer.spritesArrToRemove[i];
            if (utilObj.isNodeValid(node)) {
                subscriptionsLaunchLayer.fadeOutElements(node, 0.7, 0);
            }
        }

        utilObj.delayedCallback(subscriptionsLaunchLayer, subscriptionsLaunchLayer.back, 0.7);
    },

    show: function (withAnim, grantNow, params) {
        subscriptionsLaunchLayer.popupName = null;
        subscriptionsLaunchLayer.returnParams = null;
        subscriptionsLaunchLayer.fromCalendar = null;
        subscriptionsLaunchLayer.goBackToStore = false;
        if (params != undefined) {
            if (params.popupName != undefined) {
                subscriptionsLaunchLayer.popupName = params.popupName;
            }
            if (params.popupParams != undefined) {
                subscriptionsLaunchLayer.popupParams = params.popupParams;
            }
            if (params.returnParams != undefined) {
                subscriptionsLaunchLayer.returnParams = params.returnParams;
            }
            if (params.fromCalendar != undefined) {
                subscriptionsLaunchLayer.fromCalendar = params.fromCalendar;
            }
            if (params.goBackToStore != undefined) {
                subscriptionsLaunchLayer.goBackToStore = params.goBackToStore;
            }
        }
        subscriptionsLaunchLayer.removeSprites(subscriptionsLaunchLayer);
        subscriptionsLaunchLayer.spritesArrToRemove = [];
        subscriptionsLaunchLayer.screen = constantsObj.SCREEN_SUBSCRIPTIONS;
        subscriptionsLaunchLayer.isCoinGrantAnimRunning = false;
        subscriptionsLaunchLayer.isRingAnimAlreadyRunning = false;
        var screenName = utilObj.getScreenName(subscriptionsLaunchLayer.screen);
        utilObj.updateScreenBegin(subscriptionsLaunchLayer.screen);
        var screenType = gameObj.getScreenTypeForSubsLayer();

        if (grantNow) {
            subscriptionsLaunchLayer.addCongratulationsNode(withAnim, grantNow);
        } else {
            switch (screenType) {
                case constantsObj.SUBSCRIPTION_OFFER:
                    subscriptionsLaunchLayer.addSubscriptionOffer(withAnim);
                    break;
                case constantsObj.SUBSCRIPTION_CONGRATULATIONS:
                    subscriptionsLaunchLayer.addCongratulationsNode(withAnim);
                    break;
                case constantsObj.SUBSCRIPTION_DAILYDRIP:
                    subscriptionsLaunchLayer.addDailyDripNode(withAnim);
                    break;
                case constantsObj.SUBSCRIPTION_DAILY_STATUS:
                    subscriptionsLaunchLayer.addSubscriptionStatus(withAnim);
                    break;
            }
        }

        utilObj.hideBannerAd(utilObj.getScreenName(constantsObj.SCREEN_SUBSCRIPTIONS));
        utilObj.updateScreen(subscriptionsLaunchLayer.screen, subscriptionsLaunchLayer);
    },

    addDailyDripNode: function (withAnim) {
        var zOrder = constantsObj.UI_Z_ORDER;
        subscriptionsLaunchLayer.isCoinGrantAnimRunning = false;
        subscriptionsLaunchLayer.goBackToStore = false;
        subscriptionsLaunchLayer.isRingAnimAlreadyRunning = false;
        subscriptionsLaunchLayer.removeSprites(subscriptionsLaunchLayer);
        var arrForAnim = [];
        var spriteArr = [];
        var labelArr = [];
        var transBg = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, centerYPos, 0.5, 0.5, canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset - constantsObj.BEZEL_SAFE_AREA, spriteArr, subscriptionsLaunchLayer, zOrder, constantsObj.SPRITE_MISC);
        transBg.setColor(constantsObj.COLOR_BLACK);
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "subsciption", "drip_view", "", "", "1", "");
        transBg.setOpacity(constantsObj.OPACITY_90);
        subscriptionsLaunchLayer.spritesArrToRemove.push(transBg);
        var xPos = xRightPos - 30;
        var localYPos = constantsObj.DESIGN_HEIGHT - 226 - 70;


        var coinBg = utilObj.getScale9Sprite(constantsObj.tile_white_curved, xPos - (350 + 200), localYPos, 0, 0.5, 300, 80, spriteArr,
            transBg, zOrder, constantsObj.SPRITE_MISC);
        //coinBg.setOpacity(constantsObj.OPACITY_10);
        utilObj.getSprite(constantsObj.coin_png_2, xPos - (350 + 200), localYPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
        var coinCount = economyObj.getCash();
        var cashLbl = utilObj.getBMFontLabel(coinCount + "", constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - (210 + 200), localYPos, 0.5, 0.5, labelArr, transBg, zOrder + 1);

        utilObj.getSprite(constantsObj.green_plus, xPos - (100 + 200), localYPos, 0, 0.5, constantsObj.SCALE_SPRITE_1, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);

        xPos = centerXPos;

        localYPos = centerYPos + (constantsObj.DESIGN_HEIGHT + topBarOffset - constantsObj.BEZEL_SAFE_AREA) / 4 - 100;
        localYPos -= 180;

        var offset = (170 * constantsObj.SCALE_SPRITE_9 * 1.5)/ 2;
        var diamond = utilObj.getSprite(constantsObj.diamond, xPos, localYPos - offset, 0.5, 0.5, constantsObj.SCALE_SPRITE_9 * 1.5, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);

        //Shain Animation
        var xPos = diamond.getPositionX();
        var yPos = diamond.getPositionY();
        var width = diamond.getContentSize().width;
        var height = diamond.getContentSize().height;

        var xBottom = xPos - width/2;
        var xTop = xPos + width/2;
        var yLeft = yPos - height/2;
        var yRight = yPos + height/2;

        var posArr = [{x:xBottom + width/4, y:yLeft + height/2}, {x:xBottom + width/2 - 20, y:yLeft + height/4}, {x:xBottom + width/4 - 20, y:yLeft + height}, {x:xBottom + 3*width/4, y:yLeft + height/2 - 10}, {x:xBottom + 3*width/4 + 20, y:yLeft + 3*height/4 + 20}]
        var shainSpriteArr = [];

        for (var i in posArr) {
            var shainSprite = utilObj.getSprite(constantsObj.shain, posArr[i].x, posArr[i].y, 0.5, 0.5, constantsObj.SCALE_SPRITE_5, null, null, constantsObj.FTUE_Z_ORDER + 2, constantsObj.SPRITE_MISC);
            utilObj.addChild(transBg ,shainSprite, constantsObj.FTUE_Z_ORDER + 2);
            utilObj.setScale(shainSprite, 0);
            shainSpriteArr.push(shainSprite);
            subscriptionsLaunchLayer.spritesArrToRemove.push(shainSprite);
        }

        utilObj.delayedCallback(subscriptionsLaunchLayer, animObj.addShainAnimation, 0.02, {arr: shainSpriteArr});


        var light_effect = utilObj.getSprite(constantsObj.light_effect, diamond.getPositionX(), diamond.getPositionY() + 10, 0.5, 0.5, constantsObj.SCALE_SPRITE_44 * 1.5, spriteArr, transBg, constantsObj.UI_Z_ORDER - 1, constantsObj.SPRITE_MISC);
        light_effect.setOpacity(constantsObj.OPACITY_70);

        var rotateBy = utilObj.getRotateBy(20, 360);
        if (utilObj.isNodeValid(light_effect)) {
            animObj.runAction(light_effect, cc.RepeatForever(rotateBy), true);
        }

        localYPos = localYPos - 150 - (diamond.getContentSize().height * constantsObj.SCALE_SPRITE_9 * 1.5);

        var driptxt = utilObj.getBMFontLabel(stringsObj.dailyDripTxt, constantsObj.FONT_ROBOTO_REGULAR_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, localYPos, 0.5, 1, labelArr, transBg, zOrder + 1);
        arrForAnim.push(driptxt);

        localYPos -= 300;

        var coinImg = utilObj.getSprite(constantsObj.coin_four, centerXPos - 60, localYPos, 0.5, 1, constantsObj.SCALE_SPRITE_9, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
        arrForAnim.push(coinImg);

        var rewardLbl = utilObj.getBMFontLabel(subscriptionsDTCObj.getDailyDripAccumulatedCoins(), constantsObj.FONT_ROBOTO_BOLD_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos + 60, localYPos, 0.5, 1, labelArr, transBg, zOrder + 1);
        arrForAnim.push(rewardLbl);

        localYPos -= 305;

        var claimBtn = utilObj.getButton(900, 200, 0.5, 0.5,
            xPos, localYPos, constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'subscriptionsLaunchLayer',
                fn: 'claimDrip',
                params: {coins: subscriptionsDTCObj.getDailyDripAccumulatedCoins(), initialx: coinImg.getPositionX(), initialy: coinImg.getPositionY(), finalx: coinBg.getPositionX(), finaly: coinBg.getPositionY(), transbg: transBg , lbl: cashLbl},
                screen: subscriptionsLaunchLayer.screen
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        claimBtn.setColor(constantsObj.COLOR_LIGHT_BLUE);
        subscriptionsLaunchLayer.spritesArrToRemove.push(claimBtn);
        utilObj.addChild(transBg, claimBtn, zOrder);
        arrForAnim.push(claimBtn);

        var claimTxt = utilObj.getBMFontLabel("Claim", constantsObj.FONT_ROBOTO_BOLD_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, localYPos, 0.5, 0.5, labelArr, transBg, zOrder + 1);
        arrForAnim.push(claimTxt);

        if (withAnim) {
            subscriptionsLaunchLayer.animateFadeInDrip(arrForAnim);
        }

        for (var i in spriteArr) {
            subscriptionsLaunchLayer.spritesArrToRemove.push(spriteArr[i][["sprite"]]);
        }

        for (var i in labelArr) {
            subscriptionsLaunchLayer.spritesArrToRemove.push(labelArr[i][["label"]]);
        }

        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);

    },

    animateFadeInDrip: function (arr) {
        for (var i in arr) {
            var node = arr[i];
            if (utilObj.isNodeValid(node)) {
                utilObj.setOpacity(node, 0);
            }
        }
        for (var i in arr) {
            var node = arr[i];
            if (utilObj.isNodeValid(node)) {
                var fadeIn = utilObj.getFadeIn(0.4, constantsObj.OPACITY_100).easing(new cc.easeIn(1.0));
                animObj.runAction(node, fadeIn);
            }
        }
    },

    addCongratulationsNode: function (withAnim, grantNow) {
        var zOrder = constantsObj.UI_Z_ORDER;
        subscriptionsLaunchLayer.isCoinGrantAnimRunning = false;
        subscriptionsLaunchLayer.goBackToStore = false;
        subscriptionsLaunchLayer.isRingAnimAlreadyRunning = false;
        subscriptionsLaunchLayer.removeSprites(subscriptionsLaunchLayer);
        var spriteArr = [];
        var labelArr = [];
        var arrForFadeInAnim = [];
        var BtnAnim = null;
        var lblAnim = null;
        var transBg = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, centerYPos, 0.5, 0.5, canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset - constantsObj.BEZEL_SAFE_AREA, spriteArr, subscriptionsLaunchLayer, zOrder, constantsObj.SPRITE_MISC);
        transBg.setColor(constantsObj.COLOR_BLACK);
        // subscriptionsLaunchLayer.spritesArrToRemove.push(transBg);
        arrForFadeInAnim.push(transBg);

        var xPos = xRightPos - 30;
        var localYPos = constantsObj.DESIGN_HEIGHT - 226 - 70;


        var coinBg = utilObj.getScale9Sprite(constantsObj.tile_white_curved, xPos - (350 + 200), localYPos, 0, 0.5, 300, 80, spriteArr,
            transBg, zOrder, constantsObj.SPRITE_MISC);
        //coinBg.setOpacity(constantsObj.OPACITY_10);
        utilObj.getSprite(constantsObj.coin_png_2, xPos - (350 + 200), localYPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
        var coinCount = economyObj.getCash();
        var cashLbl = utilObj.getBMFontLabel(coinCount + "", constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - (210 + 200), localYPos, 0.5, 0.5, labelArr, transBg, zOrder + 1);

        utilObj.getSprite(constantsObj.green_plus, xPos - (100 + 200), localYPos, 0, 0.5, constantsObj.SCALE_SPRITE_1, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);

        xPos = centerXPos;
        localYPos = centerYPos + (constantsObj.DESIGN_HEIGHT + topBarOffset - constantsObj.BEZEL_SAFE_AREA) / 4 - 100;

        var congoImg = utilObj.getSprite(constantsObj.congratulations_txt, xPos, localYPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_9 * 1.5, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
        arrForFadeInAnim.push(congoImg);

        localYPos -= 180;

        var offset = (170 * constantsObj.SCALE_SPRITE_9 * 1.5)/ 2;
        var diamond = utilObj.getSprite(constantsObj.diamond, xPos, localYPos - offset, 0.5, 0.5, constantsObj.SCALE_SPRITE_9 * 1.5, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);

        // var delayShain = 0.3 + 0.45;
        // for (var i = 0; i < 1; i++) {
        //     animObj.addShainAnimation(transBg, diamond);
        // }


        localYPos = localYPos - 150 - (diamond.getContentSize().height * constantsObj.SCALE_SPRITE_9 * 1.5);
        loggerObj.debugLog("diamond size is", diamond.getContentSize().height);

        var congoTxt = utilObj.getBMFontLabel(stringsObj.congratulations_text, constantsObj.FONT_ROBOTO_REGULAR_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, localYPos, 0.5, 1, labelArr, transBg, zOrder + 1);
        arrForFadeInAnim.push(congoTxt);

        localYPos -= 300;

        var uiType = gameObj.getTrackCongratsPopupType();

        if (grantNow) {
            uiType = gameObj.getCongratsPopupTypeForAutoTrigger();
            if (uiType == constantsObj.TRACK_SUBSCRITPION_JOINING_BONUS_POPUP) {
                subscriptionsObj.setJoiningBonusGiven();
            }
        }

        if (uiType == constantsObj.TRACK_SUBSCRITPION_JOINING_BONUS_POPUP) {
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "subsciption", "jb_view", "", "", "1", "");
            var joiningBonus1 = utilObj.getBMFontLabel(stringsObj.claim_joiningBonus1, constantsObj.FONT_ROBOTO_REGULAR_80, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, localYPos, 0.5, 1, labelArr, transBg, zOrder + 1);
            arrForFadeInAnim.push(joiningBonus1);
            localYPos -= 100;
            var localxPos = centerXPos - 225;
            var joiningBonus2 = utilObj.getBMFontLabel("of", constantsObj.FONT_ROBOTO_REGULAR_80, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localxPos, localYPos, 0.5, 1, labelArr, transBg, zOrder + 1);
            arrForFadeInAnim.push(joiningBonus2);
            localxPos += 120;

            var coinImg = utilObj.getSprite(constantsObj.coin_four, localxPos, localYPos, 0.5, 1, constantsObj.SCALE_SPRITE_9, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
            arrForFadeInAnim.push(coinImg);

            localxPos += coinImg.getContentSize().width / 2 + 30;
            var joiningBonus3 = utilObj.getBMFontLabel(subscriptionsDTCObj.getJoiningBonus() + " Coins!", constantsObj.FONT_ROBOTO_REGULAR_80, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localxPos, localYPos, 0, 1, labelArr, transBg, zOrder + 1);
            arrForFadeInAnim.push(joiningBonus3);

            localYPos -= 305;

            var claimBtn = utilObj.getButton(900, 200, 0.5, 0.5,
                xPos, localYPos, constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                    obj: 'subscriptionsLaunchLayer',
                    fn: 'claimJoiningBonus',
                    params: {coins: subscriptionsDTCObj.getJoiningBonus(), initialx: coinImg.getPositionX(), initialy: coinImg.getPositionY(), finalx: coinBg.getPositionX(), finaly: coinBg.getPositionY(), transbg: transBg , lbl: cashLbl},
                    screen: subscriptionsLaunchLayer.screen
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            claimBtn.setColor(constantsObj.COLOR_LIGHT_BLUE);
            utilObj.addChild(transBg, claimBtn, zOrder);
            subscriptionsLaunchLayer.spritesArrToRemove.push(claimBtn);
            BtnAnim = claimBtn;
            gameObj.setIsJoiningBonusCongratsPopupShown(true);

            var btnLbl = utilObj.getBMFontLabel("Claim", constantsObj.FONT_ROBOTO_BOLD_80, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, localYPos, 0.5, 0.5, labelArr, transBg, zOrder + 1);
            lblAnim = btnLbl;

        } else if (uiType == constantsObj.TRACK_SUBSCRIPTION_RENEWAL_POPUP) {
            var renew1 = utilObj.getBMFontLabel(stringsObj.renew_subs, constantsObj.FONT_ROBOTO_REGULAR_80, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, localYPos, 0.5, 1, labelArr, transBg, zOrder + 1);
            arrForFadeInAnim.push(renew1);

            localYPos -= 385;
            var continueBtn = utilObj.getButton(900, 200, 0.5, 0.5,
                xPos, localYPos, constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                    obj: 'subscriptionsLaunchLayer',
                    fn: 'continueToDrip',
                    screen: subscriptionsLaunchLayer.screen
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            continueBtn.setColor(constantsObj.COLOR_LIGHT_BLUE);
            subscriptionsLaunchLayer.spritesArrToRemove.push(continueBtn);
            loggerObj.debugLog("continue btn is", continueBtn.getContentSize().width, continueBtn.getContentSize().height, continueBtn.getScale());
            BtnAnim = continueBtn;
            utilObj.addChild(transBg, continueBtn, zOrder);

            var btnLbl = utilObj.getBMFontLabel("Continue", constantsObj.FONT_ROBOTO_BOLD_80, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, localYPos, 0.5, 0.5, labelArr, transBg, zOrder + 1);
            lblAnim = btnLbl;
        } else {
            var freeTrial1 = utilObj.getBMFontLabel(stringsObj.free_trial1, constantsObj.FONT_ROBOTO_BOLD_80, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, localYPos, 0.5, 1, labelArr, transBg, zOrder + 1);
            arrForFadeInAnim.push(freeTrial1);
            localYPos -= 100;
            var localxPos = centerXPos - 485;
            var freeTrial2 = utilObj.getBMFontLabel("of", constantsObj.FONT_ROBOTO_BOLD_80, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localxPos, localYPos, 0.5, 1, labelArr, transBg, zOrder + 1);
            arrForFadeInAnim.push(freeTrial2);
            localxPos += 120;
            var coinImg = utilObj.getSprite(constantsObj.coin_four, localxPos, localYPos, 0.5, 1, constantsObj.SCALE_SPRITE_9, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
            arrForFadeInAnim.push(coinImg);

            localxPos += coinImg.getContentSize().width / 2 + 30;
            var freeTrial2 = utilObj.getBMFontLabel(subscriptionsDTCObj.getJoiningBonus() + " Coins will be added", constantsObj.FONT_ROBOTO_REGULAR_80, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localxPos, localYPos, 0, 1, labelArr, transBg, zOrder + 1);
            arrForFadeInAnim.push(freeTrial2);

            localYPos -= 100;

            var freeTrial3 = utilObj.getBMFontLabel(stringsObj.free_trial2, constantsObj.FONT_ROBOTO_BOLD_80, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, localYPos, 0.5, 1, labelArr, transBg, zOrder + 1);
            arrForFadeInAnim.push(freeTrial3);

            localYPos -= 365;
            var continueBtn = utilObj.getButton(900, 200, 0.5, 0.5,
                xPos, localYPos, constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                    obj: 'subscriptionsLaunchLayer',
                    fn: 'continueToDrip',
                    screen: subscriptionsLaunchLayer.screen
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            continueBtn.setColor(constantsObj.COLOR_LIGHT_BLUE);
            subscriptionsLaunchLayer.spritesArrToRemove.push(continueBtn);
            BtnAnim = continueBtn;
            utilObj.addChild(transBg, continueBtn, zOrder);

            var btnLbl = utilObj.getBMFontLabel("Continue", constantsObj.FONT_ROBOTO_BOLD_80, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, localYPos, 0.5, 0.5, labelArr, transBg, zOrder + 1);
            lblAnim = btnLbl;

        }

        if (withAnim) {
            subscriptionsLaunchLayer.animateFadeIn(arrForFadeInAnim, diamond, BtnAnim, btnLbl);
        }

        for (var i in spriteArr) {
            subscriptionsLaunchLayer.spritesArrToRemove.push(spriteArr[i][["sprite"]]);
        }

        for (var i in labelArr) {
            subscriptionsLaunchLayer.spritesArrToRemove.push(labelArr[i][["label"]]);
        }

        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);


    },


    fadeOutElements: function (node, time, delay) {
        var animSeq1 = [];
        animSeq1.push(utilObj.getDelayTime(delay));
        animSeq1.push(utilObj.getFadeOut(time));
        animObj.runAction(node, animObj.getSequence(animSeq1));
    },

    animateFadeIn: function (arr, diamond, btn, lbl) {

        // Fade in for the Text
        for (var i in arr) {
            var node = arr[i];
            if (utilObj.isNodeValid(node)) {
                utilObj.setOpacity(node, 0);
            }
        }

        if (utilObj.isNodeValid(btn)) {
            utilObj.setScale(btn, 0);
        }

        if (utilObj.isNodeValid(lbl)) {
            utilObj.setScale(lbl, 0);
        }

        if (utilObj.isNodeValid(diamond)) {
            utilObj.setOpacity(diamond, 0);
            utilObj.setScale(diamond, constantsObj.SCALE_SPRITE_9 * 4)
        }
        var delay = 0.3;
        for (var i in arr) {
            var node = arr[i];
            if (utilObj.isNodeValid(node)) {
                if (i == 0) {
                    var fadeIn = utilObj.getFadeTo(delay, constantsObj.OPACITY_90).easing(new cc.easeIn(1.0));
                    animObj.runAction(node, fadeIn);
                } else {
                    var animSeq = [];
                    animSeq.push(utilObj.getDelayTime(delay - 0.1));
                    var fadeIn = utilObj.getFadeIn(delay - 0.15 , constantsObj.OPACITY_100).easing(new cc.easeIn(1.0));
                    animSeq.push(fadeIn);
                    animObj.runAction(node, animObj.getSequence(animSeq));
                }
            }
        }

        // diamond animation
        var animSeq = [];
        var delayTime = utilObj.getDelayTime(delay + 0.05);
        animSeq.push(delayTime);
        var ScaleDown = utilObj.getScaleTo(0.25, constantsObj.SCALE_SPRITE_9 * 1.5).easing(new cc.easeBackOut());
        var fadeIn = utilObj.getFadeIn(0.01).easing(new cc.easeIn(1.0));
        var delay1 = utilObj.getDelayTime(0.1);
        var spawn = cc.Spawn([delay1, fadeIn]);
        animSeq.push(spawn);
        animSeq.push(ScaleDown);
        animObj.runAction(diamond, animObj.getSequence(animSeq));

        //Shain Animation
        var xPos = diamond.getPositionX();
        var yPos = diamond.getPositionY();
        var width = diamond.getContentSize().width;
        var height = diamond.getContentSize().height;

        var xBottom = xPos - width/2;
        var xTop = xPos + width/2;
        var yLeft = yPos - height/2;
        var yRight = yPos + height/2;

        var posArr = [{x:xBottom + width/4, y:yLeft + height/2}, {x:xBottom + width/2 - 20, y:yLeft + height/4}, {x:xBottom + width/4 - 20, y:yLeft + height}, {x:xBottom + 3*width/4, y:yLeft + height/2 - 10}, {x:xBottom + 3*width/4 + 20, y:yLeft + 3*height/4 + 20}]
        var shainSpriteArr = [];

        for (var i in posArr) {
            var shainSprite = utilObj.getSprite(constantsObj.shain, posArr[i].x, posArr[i].y, 0.5, 0.5, constantsObj.SCALE_SPRITE_5, null, null, constantsObj.FTUE_Z_ORDER + 2, constantsObj.SPRITE_MISC);
            utilObj.addChild(arr[0] ,shainSprite, constantsObj.FTUE_Z_ORDER + 2);
            utilObj.setScale(shainSprite, 0);
            shainSpriteArr.push(shainSprite);
            subscriptionsLaunchLayer.spritesArrToRemove.push(shainSprite);
        }

        utilObj.delayedCallback(subscriptionsLaunchLayer, animObj.addShainAnimation, 0.8, {arr: shainSpriteArr});1

        //Button Animation
        animSeq = [];
        var animSeq1 = [];
        var delayTime = utilObj.getDelayTime(delay + 0.2);
        animSeq.push(delayTime);
        animSeq1.push(delayTime);
        var scaleUp = utilObj.getScaleTo(0.3, 1).easing(new cc.easeBackOut());
        var scaleUp1 = utilObj.getScaleTo(0.3, 1).easing(new cc.easeBackOut());
        animSeq.push(scaleUp);
        animSeq1.push(scaleUp1);

        if (utilObj.isNodeValid(btn)) {
            animObj.runAction(btn, animObj.getSequence(animSeq));
        }

        if (utilObj.isNodeValid(lbl)) {
            animObj.runAction(lbl, animObj.getSequence(animSeq1));
        }


        // light effect
        animSeq = [];
        var light_effect = utilObj.getSprite(constantsObj.light_effect, diamond.getPositionX(), diamond.getPositionY() + 10, 0.5, 0.5, constantsObj.SCALE_SPRITE_44 * 1.5, null, null, constantsObj.UI_Z_ORDER - 1, constantsObj.SPRITE_MISC);
        subscriptionsLaunchLayer.spritesArrToRemove.push(light_effect);
        light_effect.setOpacity(0);
        utilObj.addChild(arr[0], light_effect, constantsObj.UI_Z_ORDER - 1);
        animSeq.push(utilObj.getDelayTime(delay + 0.45));
        var fadeIn1 = utilObj.getFadeTo(0.1, constantsObj.OPACITY_70).easing(new cc.easeIn(1.0));
        animSeq.push(fadeIn1);
        animObj.runAction(light_effect, animObj.getSequence(animSeq));

        var rotateBy = utilObj.getRotateBy(20, 360);
        if (utilObj.isNodeValid(light_effect)) {
            animObj.runAction(light_effect, cc.RepeatForever(rotateBy), true);
        }

        // star effect
        var params = {
            x: diamond.getPositionX(),
            y: diamond.getPositionY(),
            layer: arr[0],
            zOrder: constantsObj.UI_Z_ORDER - 1,
            scale: 2,
            particles: 300
        };

        utilObj.delayedCallback(arr[0], effectsObj.playSubEffect, delay + 0.45 , params, false);

    },

    animateTransBg: function (Bg, fadeTo) {
        var node = Bg;
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        var animSeq = [];
        animSeq.push(utilObj.getDelayTime(0.4));
        utilObj.setOpacity(node, 0);
        utilObj.setScale(node, 0);
        var opacityTo = constantsObj.OPACITY_90;
        if (fadeTo) {
            opacityTo = constantsObj.OPACITY_100
        }

        var scaleUp = utilObj.getScaleTo(0.3, 1.0).easing(new cc.easeBackOut());
        var fadeIn = utilObj.getFadeTo(0.01, opacityTo);
        var spawn = cc.Spawn([scaleUp, fadeIn]);
        animSeq.push(spawn);
        animObj.runAction(node, animObj.getSequence(animSeq));

    },

    continueToDrip: function () {
        if (subscriptionExp == constantsObj.EXP_VAR_1 && subscriptionsDTCObj.checkIfEligibleForDailyDrip()) {
            subscriptionsLaunchLayer.addDailyDripNode(true);
        } else {
            subscriptionsLaunchLayer.closewithAnim();
        }
    },

    continueToForceDrip: function () {
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "subsciption_prog", constantsObj.TRACK_CLAIM, "", "", "1", "");
        subscriptionsLaunchLayer.addDailyDripNode(true);
    },

    // this function handles the case when joining bonus congratulations popup was active and user kills the app, then on opening of app again we have to grant him coins.
    grantJoiningBonusWhenAppKilled: function () {
        gameObj.setIsJoiningBonusGiven(true);
        var priceSub = subscriptionsObj.getPkgsPriceNumeric(subscriptionsObj.getSubPkgId());
        economyObj.addCash(subscriptionsDTCObj.getJoiningBonus(), constantsObj.TRACK_PURCHASE, constantsObj.TRACK_SUBSCRIPTION, priceSub + "");
    },

    claimDrip: function (params) {
        if (subscriptionsLaunchLayer.isCoinGrantAnimRunning) {
            return;
        }
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "subsciption", "drip_claim", "", "", "1", "");
        subscriptionsLaunchLayer.isCoinGrantAnimRunning = true;
        economyObj.addCash(params.coins, constantsObj.TRACK_EARN, constantsObj.TRACK_SUBSCRIPTION, "drip_claim");
        var delay = animObj.genericCoinGrantAnimation(params.coins, false, true, {x: params.initialx, y: params.initialy - 20 }, {x:params.finalx, y:params.finaly}, params.transbg, params.lbl);
        gameObj.setLastDateDailyDripGiven(gameObj.getTodaysPuzzleDate().getTime());
        utilObj.delayedCallback(subscriptionsLaunchLayer,subscriptionsLaunchLayer.closewithAnim,delay + 0.1);
        utilObj.delayedCallback(subscriptionsLaunchLayer,subscriptionsLaunchLayer.setIsCoinGrantAnimRunning,delay + 0.8);
    },

    claimJoiningBonus: function (params) {
        if (subscriptionsLaunchLayer.isCoinGrantAnimRunning) {
            return;
        }
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "subsciption", "jb_claim", "", "", "1", "");
        subscriptionsLaunchLayer.isCoinGrantAnimRunning = true;
        economyObj.addCash(params.coins, constantsObj.TRACK_EARN, constantsObj.TRACK_SUBSCRIPTION, "jb_claim");
        gameObj.setIsJoiningBonusGiven(true);
        gameObj.setIsJoiningBonusCongratsPopupShown(false);
        var delay = animObj.genericCoinGrantAnimation(params.coins, false, true, {x: params.initialx, y: params.initialy - 20 }, {x:params.finalx, y:params.finaly}, params.transbg, params.lbl);
        utilObj.delayedCallback(subscriptionsLaunchLayer,subscriptionsLaunchLayer.continueToDrip,delay + 0.1);
        utilObj.delayedCallback(subscriptionsLaunchLayer,subscriptionsLaunchLayer.setIsCoinGrantAnimRunning,delay + 0.8);
    },

    setIsCoinGrantAnimRunning: function () {
        subscriptionsLaunchLayer.isCoinGrantAnimRunning = false;
    },

    setIsRingAnimAlreadyRunning: function () {
        subscriptionsLaunchLayer.isRingAnimAlreadyRunning = false;
    },

    addSubscriptionOffer: function (withAnim) {
        var zOrder = constantsObj.UI_Z_ORDER;
        var spriteArr = [];
        var labelArr = [];
        var xPos = centerXPos;
        var yPos = constantsObj.DESIGN_HEIGHT;
        subscriptionsLaunchLayer.removeSprites(subscriptionsLaunchLayer);
        gameObj.setNumberOfSubscriptionDialogShown(gameObj.getNumberOfSubscriptionDialogShown() + 1);
        gameObj.setTimestampOfLastSubsPopupOverall(utilObj.getCurrentTimestamp());
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "subsciption", constantsObj.TRACK_VIEW, "", "", "1", "");
        var transBg = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, centerYPos, 0.5, 0.5, canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset - constantsObj.BEZEL_SAFE_AREA, spriteArr, subscriptionsLaunchLayer, zOrder, constantsObj.SPRITE_MISC);
        // transBg.setColor(constantsObj.COLOR_BLACK);
        subscriptionsLaunchLayer.spritesArrToRemove.push(transBg);

        var tab = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos + topBarOffset - constantsObj.BEZEL_SAFE_AREA, 0.5, 1, canvasWidth, 226 + topBarOffset, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
        tab.setColor(constantsObj.COLOR_TOP_BAR);

        var uiType = subscriptionsDTCObj.checkUITypeForSubscription();

        if (uiType == constantsObj.SUBSCRIPTION_UI_RENEW) {
            gameObj.setTrackCongratsPopupType(constantsObj.TRACK_SUBSCRIPTION_RENEWAL_POPUP);
        } else if (uiType == constantsObj.SUBSCRIPTION_UI_NO_FREE_TRIAL) {
            gameObj.setTrackCongratsPopupType(constantsObj.TRACK_SUBSCRITPION_JOINING_BONUS_POPUP);
        } else {
            gameObj.setTrackCongratsPopupType(constantsObj.TRACK_SUBSCRIPTION_FREE_TRIAL_SUCCESS_POPUP);
        }

        var backButton = utilObj.getButton(300, 300, 0.5, 1, xRightPos - 125, yPos - 50 + topBarOffset / 2,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'subscriptionsLaunchLayer',
                fn: 'back',
                screen: subscriptionsLaunchLayer.screen,
                params: {sound: false}
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(transBg, backButton, zOrder);

        utilObj.getSprite(constantsObj.close_icon_sub, xRightPos - 125, yPos - 50 + topBarOffset / 2, 0.5, 1, constantsObj.SCALE_SPRITE_9 * 1.5, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);

        if (utilObj.isIos()) {
            var adBanner = constantsObj.ad_banner_place_holder;
            utilObj.getSprite(adBanner, centerXPos, yPos - 50, 0.5, 1, constantsObj.SCALE_SPRITE_6 * 3 / 2, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
        } else {
            var adBanner = constantsObj.header_logo;
            utilObj.getSprite(adBanner, centerXPos - 330 * canvasWidth / 1440, yPos - 50 + topBarOffset / 2, 0.5, 1, constantsObj.SCALE_SPRITE_10 * 3 / 2, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
        }

        yPos -= 226;

        var alpha_height = 0;
        if (isTablet) {
            var alpha_bg = utilObj.getSprite(constantsObj.subs_bg_tablet, xPos, yPos , 0.5, 1, 1.8 * canvasWidth/1440, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
            alpha_height = alpha_bg.getContentSize().height * 1.8 * canvasWidth/1440;
        } else {
            alpha_bg = utilObj.getSprite(constantsObj.subs_bg, xPos, yPos , 0.5, 1, 2 * canvasWidth/1440, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
            alpha_height = alpha_bg.getContentSize().height * 2  * canvasWidth/1440;
        }
        utilObj.getBMFontLabel(stringsObj.subs_offer_txt, constantsObj.FONT_ROBOTO_MEDIUM_120, constantsObj.COLOR_BLACK_SUB_OFFER,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), canvasWidth/6 , yPos - alpha_height/2, 0, 0.5, labelArr, transBg, zOrder + 1);


        yPos -= alpha_height;

        var totalHeight = yPos - 30;
        var innerHeight = totalHeight > 1800? totalHeight: 1800;
        if (utilObj.isIos()) {
            innerHeight += 400;
        }
        if (!gameObj.getIsJoiningBonusGiven() && !subscriptionsObj.getJoiningBonusStatus()) {
            innerHeight += 125;
        }
        loggerObj.debugLog("innerHeight is", innerHeight);
        subscriptionsLaunchLayer.scrollview = new ccui.ScrollView();
        subscriptionsLaunchLayer.scrollview.setDirection(ccui.ScrollView.DIR_VERTICAL);
        subscriptionsLaunchLayer.scrollview.setTouchEnabled(true);
        subscriptionsLaunchLayer.scrollview.setBounceEnabled(true);
        subscriptionsLaunchLayer.scrollview.setContentSize(cc.size(canvasWidth, totalHeight));
        subscriptionsLaunchLayer.scrollview.setPosition(xPos, yPos );
        subscriptionsLaunchLayer.scrollview.setAnchorPoint(0.5, 1);
        subscriptionsLaunchLayer.scrollview.setInnerContainerSize(cc.size(canvasWidth, innerHeight));
        subscriptionsLaunchLayer.scrollview.setBackGroundColor(constantsObj.COLOR_BLACK);
        utilObj.addChild(transBg, subscriptionsLaunchLayer.scrollview, zOrder + 1);

        xPos = canvasWidth/6;
        yPos = innerHeight - 100;

        var diamond_img = utilObj.getSprite(constantsObj.diamond, xPos, yPos, 0, 1, constantsObj.SCALE_SPRITE_15 * 3 / 2, spriteArr, subscriptionsLaunchLayer.scrollview, zOrder, constantsObj.SPRITE_MISC);

        xPos += diamond_img.getContentSize().width * constantsObj.SCALE_SPRITE_16 * 3 / 2;
        xPos += 30;

        utilObj.getBMFontLabel(stringsObj.premium_edition, constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_PINK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos , yPos, 0, 0.8, labelArr, subscriptionsLaunchLayer.scrollview, zOrder + 1);

        yPos -= 180;
        for (var i in stringsObj.subs_text_arr) {
            xPos = canvasWidth/6;
            if (subscriptionExp != constantsObj.EXP_VAR_1 && i == 2) {
                continue;
            }
            var tick = utilObj.getSprite(constantsObj.tick, xPos, yPos, 0, 1, constantsObj.SCALE_SPRITE_2 * 3 / 2, spriteArr, subscriptionsLaunchLayer.scrollview, zOrder, constantsObj.SPRITE_MISC);
            tick.setColor(constantsObj.COLOR_GREEN);
            xPos += diamond_img.getContentSize().width * constantsObj.SCALE_SPRITE_16 * 3 / 2;
            xPos += 30;
            utilObj.getBMFontLabel(stringsObj.subs_text_arr[i], constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0, 0.8, labelArr, subscriptionsLaunchLayer.scrollview, zOrder + 1);
            if ( i == 2 ) {
                utilObj.getSprite(constantsObj.coin_one, xPos + 660, yPos + 5, 0, 0.8, constantsObj.SCALE_SPRITE_9, spriteArr, subscriptionsLaunchLayer.scrollview, zOrder, constantsObj.SPRITE_MISC);
            }
            yPos -= 120;
        }

        yPos -= 100;

        var subPrice = subscriptionsObj.getSubscriptionPkgPriceWeekly();
        if ( subscriptionExp == constantsObj.EXP_VAR_2 || subscriptionExp == constantsObj.EXP_VAR_3) {
            if (utilObj.isAndroid()) {
                subPrice = subscriptionsObj.getSubscriptionPkgPriceWeekly(4);
            }
        }

        xPos = centerXPos - 30;

        subscriptionsLaunchLayer.greenbg1 = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos , 1, 1, 520, 340 - 40, spriteArr, subscriptionsLaunchLayer.scrollview, zOrder, constantsObj.SPRITE_MISC);
        subscriptionsLaunchLayer.greenbg1.setColor(constantsObj.COLOR_GREEN);
        subscriptionsLaunchLayer.greenbg1.setOpacity(0);

        var outline1 = utilObj.getScale9Sprite(constantsObj.loader_outline1, xPos, yPos , 1, 1, 520, 340 - 40, spriteArr, subscriptionsLaunchLayer.scrollview, zOrder, constantsObj.SPRITE_MISC);
        outline1.setColor(constantsObj.COLOR_GREEN);
        // outline1.setVisible(false);

        subscriptionsLaunchLayer.outlineForAnim1 = utilObj.getScale9Sprite(constantsObj.outlineForSubAnim, xPos - 260, yPos - 170 + 20 , 0.5, 0.5, 520, 340 - 40, spriteArr, subscriptionsLaunchLayer.scrollview, zOrder, constantsObj.SPRITE_MISC);
        subscriptionsLaunchLayer.outlineForAnim1.setColor(constantsObj.COLOR_GREEN);
        subscriptionsLaunchLayer.outlineForAnim1.setOpacity(0);


        var selectBtn1 = utilObj.getButton(520, 340 - 40, 1, 1,
            xPos, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'subscriptionsLaunchLayer',
                fn: 'select',
                params: {flag: false},
                screen: subscriptionsLaunchLayer.screen
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(subscriptionsLaunchLayer.scrollview, selectBtn1, zOrder);

        var localxPos = xPos - 260;
        var localyPos = yPos - 170 - 20;
        var xPosForPrice = localxPos;

        var priceStr = utilObj.formatPrice(subPrice);
        var priceArr = priceStr.split(".");

        subscriptionsLaunchLayer.subPrice1 = utilObj.formatPrice(subscriptionsObj.getSubscriptionPkgPriceWeekly());
        if (utilObj.isIos()) {
            if (subscriptionExp == constantsObj.EXP_VAR_2 || subscriptionExp == constantsObj.EXP_VAR_3) {
                subscriptionsLaunchLayer.subPrice1 = utilObj.formatPrice(subscriptionsObj.getSubscriptionPkgPriceWeekly(1));
            }
        }
        if (priceStr.length > 5) {
            var offset = priceStr.length % 5;
            xPosForPrice += offset * 30;
        }

        subscriptionsLaunchLayer.pricelbll1 = utilObj.getTTFFontLabel(priceArr[0], constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_BLACK_SUB_OFFER,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPosForPrice - 10, localyPos + 66.5 - 50 , 1, 0, labelArr, subscriptionsLaunchLayer.scrollview, zOrder + 1);

        subscriptionsLaunchLayer.pricelbll2 = utilObj.getBMFontLabel(".", constantsObj.FONT_ROBOTO_MEDIUM_40, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPosForPrice, localyPos + 74.5 - 50 , 0.5, 0, labelArr, subscriptionsLaunchLayer.scrollview, zOrder + 1);

        subscriptionsLaunchLayer.pricelbll3 = utilObj.getBMFontLabel(priceArr[1], constantsObj.FONT_ROBOTO_MEDIUM_40, constantsObj.COLOR_BLACK_SUB_OFFER,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPosForPrice + 10, localyPos + 74.5 - 50 , 0, 0, labelArr, subscriptionsLaunchLayer.scrollview, zOrder + 1);

        if (utilObj.isAndroid()) {
            subscriptionsLaunchLayer.perWeek1 = utilObj.getBMFontLabel("Per Week", constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK_SUB_OFFER,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localxPos, localyPos - 15, 0.5, 0.5, labelArr, subscriptionsLaunchLayer.scrollview, zOrder + 1);
        } else {
            var perStr = "per week";
            if (subscriptionExp == constantsObj.EXP_VAR_2 || subscriptionExp == constantsObj.EXP_VAR_3) {
                perStr = "per month";
            }
            subscriptionsLaunchLayer.perWeek1 = utilObj.getBMFontLabel(perStr, constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK_SUB_OFFER,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localxPos, localyPos - 15, 0.5, 0.5, labelArr, subscriptionsLaunchLayer.scrollview, zOrder + 1);
        }

        // if ( subscriptionExp == constantsObj.EXP_VAR_2) {
        //     var week_lbl = utilObj.getBMFontLabel("Monthly billing", constantsObj.FONT_ROBOTO_MEDIUM_40, constantsObj.COLOR_BLACK,
        //         constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localxPos, localyPos - 105.5, 0.5, 0.5, labelArr, subscriptionsLaunchLayer.scrollview, zOrder + 1);
        //     week_lbl.setOpacity(constantsObj.OPACITY_70);
        // } else {
        //     var week_lbl = utilObj.getBMFontLabel("Weekly billing", constantsObj.FONT_ROBOTO_MEDIUM_40, constantsObj.COLOR_BLACK,
        //         constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localxPos, localyPos - 105.5, 0.5, 0.5, labelArr, subscriptionsLaunchLayer.scrollview, zOrder + 1);
        //     week_lbl.setOpacity(constantsObj.OPACITY_70);
        // }


        xPos = centerXPos + 30;

        subscriptionsLaunchLayer.greenbg2 = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos , 0, 1, 520, 340 - 40, spriteArr, subscriptionsLaunchLayer.scrollview, zOrder, constantsObj.SPRITE_MISC);
        subscriptionsLaunchLayer.greenbg2.setColor(constantsObj.COLOR_GREEN);

        var image_offer = constantsObj.save_offer_subs;
        if (subscriptionExp == constantsObj.EXP_VAR_2 || subscriptionExp == constantsObj.EXP_VAR_3) {
            image_offer = constantsObj.save_offer_tag;
        }
        utilObj.getSprite(image_offer, xPos - 2.5, yPos + 7.5, 0, 1, constantsObj.SCALE_SPRITE_6 * 3 / 2, spriteArr, subscriptionsLaunchLayer.scrollview, zOrder + 1, constantsObj.SPRITE_MISC);

        var outline2 = utilObj.getScale9Sprite(constantsObj.loader_outline1, xPos, yPos , 0, 1, 520, 340 - 40, spriteArr, subscriptionsLaunchLayer.scrollview, zOrder, constantsObj.SPRITE_MISC);
        outline2.setColor(constantsObj.COLOR_GREEN);
        // outline2.setVisible(false);

        subscriptionsLaunchLayer.outlineForAnim2 = utilObj.getScale9Sprite(constantsObj.outlineForSubAnim, xPos + 260, yPos - 170 + 20,  0.5, 0.5, 520, 340 - 40, spriteArr, subscriptionsLaunchLayer.scrollview, zOrder, constantsObj.SPRITE_MISC);
        subscriptionsLaunchLayer.outlineForAnim2.setColor(constantsObj.COLOR_GREEN);
        subscriptionsLaunchLayer.outlineForAnim2.setOpacity(0);

        var selectBtn2 = utilObj.getButton(520, 340 - 40, 0, 1,
            xPos, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'subscriptionsLaunchLayer',
                fn: 'select',
                params: {flag: true},
                screen: subscriptionsLaunchLayer.screen
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(subscriptionsLaunchLayer.scrollview, selectBtn2, zOrder);

        var localxPos = xPos + 260;
        xPosForPrice = localxPos;

        if (utilObj.isAndroid()) {
            subPrice = subscriptionsObj.getSubscriptionPkgPriceMonthly(4);
        } else {
            subPrice = subscriptionsObj.getSubscriptionPkgPriceMonthly(1);
        }
        if (subscriptionExp == constantsObj.EXP_VAR_2 || subscriptionExp == constantsObj.EXP_VAR_3) {
            subPrice = subscriptionsObj.getSubscriptionPkgPriceMonthly(1);
        }
        priceStr = utilObj.formatPrice(subPrice);
        priceArr = priceStr.split(".");

        if (utilObj.isAndroid()) {
            subscriptionsLaunchLayer.subPrice2 = utilObj.formatPrice(subscriptionsObj.getSubscriptionPkgPriceMonthly(1));
        } else {
            subscriptionsLaunchLayer.subPrice2 = utilObj.formatPrice(subscriptionsObj.getSubscriptionPkgPriceMonthly(4));
            if (subscriptionExp == constantsObj.EXP_VAR_2 || subscriptionExp == constantsObj.EXP_VAR_3) {
                subscriptionsLaunchLayer.subPrice2 = utilObj.formatPrice(subscriptionsObj.getSubscriptionPkgPriceMonthly(12));
            }
        }
        if (priceStr.length > 5) {
            var offset = priceStr.length % 5;
            xPosForPrice += offset * 30;
        }

        subscriptionsLaunchLayer.pricelblr1 = utilObj.getTTFFontLabel(priceArr[0], constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPosForPrice - 10, localyPos + 66.5 - 50, 1, 0, labelArr, subscriptionsLaunchLayer.scrollview, zOrder + 1);

        subscriptionsLaunchLayer.pricelblr2 = utilObj.getBMFontLabel(".", constantsObj.FONT_ROBOTO_MEDIUM_40, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPosForPrice, localyPos + 74.5 - 50, 0.5, 0, labelArr, subscriptionsLaunchLayer.scrollview, zOrder + 1);

        subscriptionsLaunchLayer.pricelblr3 = utilObj.getBMFontLabel(priceArr[1], constantsObj.FONT_ROBOTO_MEDIUM_40, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPosForPrice + 10, localyPos + 74.5 - 50, 0, 0, labelArr, subscriptionsLaunchLayer.scrollview, zOrder + 1);


        var perStr = "Per Week";
        if (utilObj.isIos()) {
            perStr = "per month";
            if (subscriptionExp == constantsObj.EXP_VAR_2 || subscriptionExp == constantsObj.EXP_VAR_3) {
                perStr = "per year";
            }
        }

        subscriptionsLaunchLayer.perWeek2 = utilObj.getBMFontLabel(perStr, constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localxPos, localyPos - 15
            , 0.5, 0.5, labelArr, subscriptionsLaunchLayer.scrollview, zOrder + 1);


        var stringBilling = "Monthly Billing";

        if (utilObj.isIos()) {
            stringBilling = "1 week at " + subscriptionsLaunchLayer.subPrice2 + ", save 40%";
        }
        if (subscriptionExp == constantsObj.EXP_VAR_2 || subscriptionExp == constantsObj.EXP_VAR_3) {
            stringBilling = "Yearly Billing";
            if (utilObj.isIos()) {
                stringBilling = "1 month at " + subscriptionsLaunchLayer.subPrice2 + ", save 52%";
            }
        }
        if (utilObj.isAndroid()) {
            subscriptionsLaunchLayer.priceLbl = utilObj.getTTFFontLabel(stringBilling + " @" + subscriptionsLaunchLayer.subPrice2, constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, yPos - 370, 0.5, 0.5, labelArr, subscriptionsLaunchLayer.scrollview, zOrder + 1);
        } else {
            subscriptionsLaunchLayer.priceLbl = utilObj.getTTFFontLabel(stringBilling, constantsObj.FONT_ROBOTO_MEDIUM_45, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, yPos - 370, 0.5, 0.5, labelArr, subscriptionsLaunchLayer.scrollview, zOrder + 1);
        }
        subscriptionsLaunchLayer.priceLbl.setOpacity(constantsObj.OPACITY_70);



        xPos = centerXPos;
        yPos -= 500;
        subscriptionsLaunchLayer.selected1 = false;
        subscriptionsLaunchLayer.selected2 = true;


        var subsBtn = utilObj.getButton(650, 200, 0.5, 0.5,
            xPos, yPos, constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'subscriptionsLaunchLayer',
                fn: 'subscribe',
                screen: subscriptionsLaunchLayer.screen
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        subsBtn.setColor(constantsObj.COLOR_GREEN);
        utilObj.pulseButton(subsBtn, 2, 0);
        utilObj.addChild(subscriptionsLaunchLayer.scrollview, subsBtn, zOrder);

        var lbl = utilObj.getBMFontLabel("Subscribe", constantsObj.FONT_ROBOTO_BOLD_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, subscriptionsLaunchLayer.scrollview, zOrder + 1);
        utilObj.pulseButton(lbl, 1, 0);

        var yPosOffset = 0;
        if (!gameObj.getIsJoiningBonusGiven() && !subscriptionsObj.getJoiningBonusStatus()) {
            yPos -= 125;
            yPosOffset = 125;
            xPos = centerXPos - 325;

            var cashIcon = utilObj.getSprite(constantsObj.coin_four, xPos - 30, yPos, 0.2, 1, constantsObj.SCALE_SPRITE_6 * 1.25, spriteArr, subscriptionsLaunchLayer.scrollview, zOrder, constantsObj.SPRITE_MISC);
            var text = utilObj.getBMFontLabel(subscriptionsDTCObj.getJoiningBonus() + " Joining Bonus", constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + (cashIcon.getContentSize().width / 2 * constantsObj.SCALE_SPRITE_6 * 1.25) + 70 - 30, yPos - 20, 0, 1, labelArr, subscriptionsLaunchLayer.scrollview, zOrder + 1);
        }


        localyPos -= 550;
        localyPos -= yPosOffset;
        var renewStrArr = "";
        var textScaling = 0.54;
        var autoRenewTxt;
        if (utilObj.isIos()) {
            renewStrArr = utilObj.getSplitStringsArr(stringsObj.auto_renewable_ios, parseInt(83 * canvasWidth/1350));
            textScaling = 0.65;
        }

        if (utilObj.isIos()) {
            for (var index = 0; index < renewStrArr.length; index++) {
                autoRenewTxt = utilObj.getBMFontLabel(renewStrArr[index], constantsObj.FONT_SFCOMPACT_MEDIUM_50, constantsObj.COLOR_BLACK, constantsObj.LABEL_AUTO_WIDTH,
                    cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, localyPos, 0.5, 0.5, labelArr, subscriptionsLaunchLayer.scrollview, zOrder + 1);
                autoRenewTxt.setScale(textScaling);
                utilObj.setOpacity(autoRenewTxt, constantsObj.OPACITY_20);
                localyPos -= 50;
            }
            localyPos -= 60;
        }

        var termsLbl = stringsObj.terms_conditions_ios;
        var termsOpacity = constantsObj.OPACITY_20;
        var termsConditions = utilObj.getBMFontLabel(termsLbl, constantsObj.FONT_SFCOMPACT_MEDIUM_50, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, localyPos, 0.5, 0.5, labelArr, subscriptionsLaunchLayer.scrollview, zOrder);
        utilObj.setOpacity(termsConditions, constantsObj.OPACITY_70);

        var separator2 = utilObj.getScale9Sprite(constantsObj.white_line, centerXPos, localyPos - 35, 0.5, 0.5, termsConditions.getContentSize().width , 2, spriteArr, subscriptionsLaunchLayer.scrollview, zOrder + 1,
            constantsObj.SPRITE_MISC);
        separator2.setColor(constantsObj.COLOR_BLACK);
        utilObj.setOpacity(separator2, constantsObj.OPACITY_50);

        var termsBtn = utilObj.getButton(450, 50, 0.5, 0.5, centerXPos, localyPos - 10, constantsObj.trans_button,
            constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'subscriptionsLaunchLayer',
                fn: "showPrivacyPolicy",
                screen: subscriptionsLaunchLayer.screen
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(subscriptionsLaunchLayer.scrollview, termsBtn, zOrder + 1);

        if (withAnim) {
            subscriptionsLaunchLayer.animateTransBg(transBg, true);
        }

        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);

    },

    addSubscriptionStatus: function (withAnim) {
        var zOrder = constantsObj.UI_Z_ORDER;
        subscriptionsLaunchLayer.goBackToStore = false;
        subscriptionsLaunchLayer.isRingAnimAlreadyRunning = false;
        subscriptionsLaunchLayer.removeSprites(subscriptionsLaunchLayer);
        var spriteArr = [];
        var labelArr = [];
        subscriptionsLaunchLayer.arrForTimeRem = [];
        subscriptionsLaunchLayer.arrForClaimB = [];
        var transBg = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, centerYPos, 0.5, 0.5, canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset - constantsObj.BEZEL_SAFE_AREA, spriteArr, subscriptionsLaunchLayer, zOrder, constantsObj.SPRITE_MISC);
        // transBg.setColor(constantsObj.COLOR_BLACK);
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "subsciption_prog", constantsObj.TRACK_VIEW, "", "", "1", "");
        subscriptionsLaunchLayer.spritesArrToRemove.push(transBg);

        var xPos = centerXPos;
        var yPos = constantsObj.DESIGN_HEIGHT;

        var tab = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos + topBarOffset - constantsObj.BEZEL_SAFE_AREA, 0.5, 1, canvasWidth, 226 + topBarOffset, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
        tab.setColor(constantsObj.COLOR_TOP_BAR);


        var backButton = utilObj.getButton(300, 300, 0.5, 1, xRightPos - 125, yPos - 50 + topBarOffset / 2,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'subscriptionsLaunchLayer',
                fn: 'back',
                screen: subscriptionsLaunchLayer.screen,
                params: {sound: false}
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(transBg, backButton, zOrder);

        utilObj.getSprite(constantsObj.close_icon_sub, xRightPos - 125, yPos - 50 + topBarOffset / 2, 0.5, 1, constantsObj.SCALE_SPRITE_9 * 1.5, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);

        if (utilObj.isIos()) {
            var adBanner = constantsObj.ad_banner_place_holder;
            utilObj.getSprite(adBanner, centerXPos, yPos - 50, 0.5, 1, constantsObj.SCALE_SPRITE_6 * 3 / 2, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
        } else {
            var adBanner = constantsObj.header_logo;
            utilObj.getSprite(adBanner, centerXPos - 330 * canvasWidth / 1440, yPos - 50 + topBarOffset / 2, 0.5, 1, constantsObj.SCALE_SPRITE_10 * 3 / 2, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
        }

        yPos -= 226;

        var alpha_height = 0;
        if (isTablet) {
            var alpha_bg = utilObj.getSprite(constantsObj.subs_bg_tablet, xPos, yPos , 0.5, 1, 1.5 * canvasWidth/1440, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
            alpha_height = alpha_bg.getContentSize().height * 1.5 * canvasWidth/1440;
        } else {
            alpha_bg = utilObj.getSprite(constantsObj.subs_bg, xPos, yPos , 0.5, 1, 2 * canvasWidth/1440, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
            alpha_height = alpha_bg.getContentSize().height * 2  * canvasWidth/1440;
        }

        xPos = xLeftPos + 180;
        var diamond_img = utilObj.getSprite(constantsObj.diamond, xPos, yPos - alpha_height/3 + 50 , 0, 1, constantsObj.SCALE_SPRITE_15 * 3 / 2 * 1.1, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
        xPos += diamond_img.getContentSize().width * constantsObj.SCALE_SPRITE_16 * 3 / 2;
        xPos += 30;

        var premiumTxt = utilObj.getBMFontLabel(stringsObj.premium_edition, constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_PINK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos , yPos - alpha_height/3 + 50, 0, 0.8, labelArr, transBg, zOrder + 1);
        //premiumTxt.setOpacity(constantsObj.OPACITY_70);

        xPos = xLeftPos + 180;
        var txt = utilObj.getBMFontLabel(stringsObj.subs_daily_txt, constantsObj.FONT_ROBOTO_MEDIUM_120, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos , yPos - 2 * alpha_height/3 , 0, 0.5, labelArr, transBg, zOrder + 1);
        txt.setOpacity(constantsObj.OPACITY_70);

        yPos -= alpha_height ;
        yPos -= 100;
        xPos = xLeftPos + 160;

        var calendarImg = utilObj.getSprite(constantsObj.icons_calendar, xPos, yPos, 0, 1, constantsObj.SCALE_SPRITE_11 * 1.2, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);

        var localxPos = xPos + calendarImg.getContentSize().width * (constantsObj.SCALE_SPRITE_11 * 1.28) + 40;

        utilObj.getBMFontLabel("FREE Themed Puzzles Daily", constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localxPos, yPos + 25, 0, 1, labelArr, transBg, zOrder);

        yPos -= 90;

        utilObj.getBMFontLabel("Today", constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localxPos, yPos - 10 + 35, 0, 1, labelArr, transBg, zOrder);

        var tick = utilObj.getSprite(constantsObj.tick, xPos - 10, yPos - 10 + 35, 1, 1, constantsObj.SCALE_SPRITE_2 * 3 / 2, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
        tick.setColor(constantsObj.COLOR_GREEN);

        var loader_outline = utilObj.getScale9Sprite(constantsObj.loader_outline, localxPos + 230 , yPos - 30 + 35, 0, 1, 550, 53, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
        // loader_outline.setColor(constantsObj.COLOR_WHITE);

        var numberOfFreeArchive = constantsObj.SUBSCRIPTION_FREEARCHIVE;
        var numberOfOpenedFreeArchive = numberOfFreeArchive - gameObj.getFreeArchivePuzzleSub();
        if (numberOfOpenedFreeArchive > 5) {
            numberOfOpenedFreeArchive = 5;
        }

        var calculateInnerLoader = 108 * numberOfOpenedFreeArchive;

        var loader_inner = utilObj.getScale9Sprite(constantsObj.loader, localxPos + 230 + 5,yPos - 35 + 35, 0, 1, calculateInnerLoader, 43, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);

        var text_loader = utilObj.getBMFontLabel(numberOfOpenedFreeArchive + "/" + numberOfFreeArchive, constantsObj.FONT_ROBOTO_BOLD_50, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localxPos + 230 + 550 + 25, yPos - 30 + 35, 0, 1, labelArr, transBg, zOrder + 1);

        if (numberOfOpenedFreeArchive == numberOfFreeArchive) {
            var rewardLbl1 = utilObj.getBMFontLabel("Next free in ", constantsObj.FONT_ROBOTO_MEDIUM_60, constantsObj.COLOR_GREY_05,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localxPos, yPos - 30 - 40, 0, 1, labelArr, transBg, zOrder);
            //rewardLbl1.setOpacity(constantsObj.OPACITY_70);

            var time = utilObj.formatTime(gameObj.getPuzzleUnlockTime());
            subscriptionsLaunchLayer.puzzleUnlockLabel1 = utilObj.getBMFontLabel(time, constantsObj.FONT_ROBOTO_MEDIUM_60, constantsObj.COLOR_GREY_05,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localxPos + 310, yPos - 30 - 40, 0, 1, labelArr, transBg, zOrder + 1);
            //subscriptionsLaunchLayer.puzzleUnlockLabel1.setOpacity(constantsObj.OPACITY_70);
        }

        xPos = xLeftPos + 180;
        yPos -= 250;

        var dailyMiniImg = utilObj.getSprite(constantsObj.daily_mini, xPos, yPos, 0, 1, constantsObj.SCALE_SPRITE_11 * 0.95, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);

        utilObj.getBMFontLabel("Mini Archive is unlocked!", constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localxPos, yPos - (dailyMiniImg.getContentSize().height * constantsObj.SCALE_SPRITE_11 * 0.95)/2 + 10, 0, 0.5, labelArr, transBg, zOrder);

        var tick = utilObj.getSprite(constantsObj.tick, xPos - 30, yPos - (dailyMiniImg.getContentSize().height * constantsObj.SCALE_SPRITE_11 * 0.95)/2 + 20, 1, 1, constantsObj.SCALE_SPRITE_2 * 3 / 2, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
        tick.setColor(constantsObj.COLOR_GREEN);


        if (subscriptionsObj.getSubPkgId().indexOf("coindrip") != -1) {
            yPos -= 300;
            xPos = xLeftPos + 160;

            utilObj.getSprite(constantsObj.coin_two, xPos, yPos, 0, 1, constantsObj.SCALE_SPRITE_11 * 1.2, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);

            loggerObj.debugLog("coin drip is", subscriptionsDTCObj.getDailyDripAccumulatedCoins());
            var claimTxt = utilObj.getBMFontLabel("You claimed today's", constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localxPos, yPos - 30 + 10, 0, 1, labelArr, transBg, zOrder);
            subscriptionsLaunchLayer.arrForTimeRem.push(claimTxt);

            var coinImg = utilObj.getSprite(constantsObj.coin_one, localxPos + 600, yPos - 30 + 20, 0, 1, constantsObj.SCALE_SPRITE_1 * 0.7, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
            subscriptionsLaunchLayer.arrForTimeRem.push(coinImg);


            var numCoins = utilObj.getBMFontLabel("15", constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localxPos + 600 + (coinImg.getContentSize().width * constantsObj.SCALE_SPRITE_1 * 0.6), yPos - 30 + 10, 0, 1, labelArr, transBg, zOrder);
            subscriptionsLaunchLayer.arrForTimeRem.push(numCoins);

            yPos -= 60;
            var rewardLbl = utilObj.getBMFontLabel("Next reward in ", constantsObj.FONT_ROBOTO_MEDIUM_60, constantsObj.COLOR_GREY_05,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localxPos, yPos - 50, 0, 1, labelArr, transBg, zOrder);
            //rewardLbl.setOpacity(constantsObj.OPACITY_70);
            subscriptionsLaunchLayer.arrForTimeRem.push(rewardLbl);

            var diff = 0;
            try {
                if (gameObj.getLastDateDailyDripGiven() != null) {
                    diff = Math.abs(utilObj.getDaysDiff(new Date(gameObj.getLastDateDailyDripGiven()), gameObj.getTodaysPuzzleDate()));
                }
            } catch (e) {

            }
            var timeToAdd = constantsObj.SECONDS_IN_DAY * diff;

            var time = utilObj.formatTime(gameObj.getPuzzleUnlockTime());
            subscriptionsLaunchLayer.puzzleUnlockLabel = utilObj.getBMFontLabel(time + timeToAdd, constantsObj.FONT_ROBOTO_MEDIUM_60, constantsObj.COLOR_GREY_05,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localxPos + 400, yPos - 50, 0, 1, labelArr, transBg, zOrder + 1);
            //subscriptionsLaunchLayer.puzzleUnlockLabel.setOpacity(constantsObj.OPACITY_70);
            subscriptionsLaunchLayer.arrForTimeRem.push(subscriptionsLaunchLayer.puzzleUnlockLabel);

            var claimTxt1 = utilObj.getBMFontLabel("Today's Bonus", constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localxPos, yPos + 30 + 20, 0, 1, labelArr, transBg, zOrder);
            subscriptionsLaunchLayer.arrForClaimB.push(claimTxt1);

            var coinImg1 = utilObj.getSprite(constantsObj.coin_one, localxPos + 630 - 200, yPos + 30 + 30, 0, 1, constantsObj.SCALE_SPRITE_1 * 0.7, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
            subscriptionsLaunchLayer.arrForClaimB.push(coinImg1);

            var numCoins1 = utilObj.getBMFontLabel(subscriptionsDTCObj.getDailyDripAccumulatedCoins(), constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localxPos + 630 + (coinImg1.getContentSize().width * constantsObj.SCALE_SPRITE_1 * 0.6) - 200, yPos + 30 + 20, 0, 1, labelArr, transBg, zOrder);
            subscriptionsLaunchLayer.arrForClaimB.push(numCoins1);

            var tick = utilObj.getSprite(constantsObj.tick, xPos - 10, yPos - 60 + 20, 1, 1, constantsObj.SCALE_SPRITE_2 * 3 / 2, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
            tick.setColor(constantsObj.COLOR_GREEN);

            var claimTxt2 = utilObj.getBMFontLabel("Claim now", constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localxPos, yPos - 60 + 20, 0, 1, labelArr, transBg, zOrder);
            claimTxt2.setColor(constantsObj.COLOR_LIGHT_BLUE);
            subscriptionsLaunchLayer.arrForClaimB.push(claimTxt2);

            var tile = utilObj.getScale9Sprite(constantsObj.tile_white, localxPos, yPos - 145 + 20, 0, 1, 320, 7, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
            tile.setColor(constantsObj.COLOR_LIGHT_BLUE);
            subscriptionsLaunchLayer.arrForClaimB.push(tile);

            var coinBtn = utilObj.getButton(320, 85, 0, 1, localxPos, yPos - 60 + 20, constantsObj.trans_button,
                constantsObj.trans_button, constantsObj.trans_button, {
                    obj: 'subscriptionsLaunchLayer',
                    fn: "continueToForceDrip",
                    screen: subscriptionsLaunchLayer.screen
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            utilObj.addChild(transBg, coinBtn, zOrder + 1);
            subscriptionsLaunchLayer.arrForClaimB.push(coinBtn);

            if (!subscriptionsDTCObj.checkIfEligibleForDailyDrip()) {
                subscriptionsLaunchLayer.setVisibility(subscriptionsLaunchLayer.arrForTimeRem, true);
                subscriptionsLaunchLayer.setVisibility(subscriptionsLaunchLayer.arrForClaimB, false);
            } else {
                subscriptionsLaunchLayer.setVisibility(subscriptionsLaunchLayer.arrForClaimB, true);
                subscriptionsLaunchLayer.setVisibility(subscriptionsLaunchLayer.arrForTimeRem, false);
            }
        }

        yPos -= 300;
        xPos = xLeftPos + 180;

        utilObj.getSprite(constantsObj.no_ads_pack, xPos, yPos, 0, 1, constantsObj.SCALE_SPRITE_11 * 1.2, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);

        utilObj.getBMFontLabel("Ads are not showing!", constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), localxPos, yPos - (dailyMiniImg.getContentSize().height * constantsObj.SCALE_SPRITE_11 * 0.95)/2, 0, 0.5, labelArr, transBg, zOrder);

        var tick = utilObj.getSprite(constantsObj.tick, xPos - 30, yPos - (dailyMiniImg.getContentSize().height * constantsObj.SCALE_SPRITE_11 * 0.95)/2 + 10, 1, 1, constantsObj.SCALE_SPRITE_2 * 3 / 2, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
        tick.setColor(constantsObj.COLOR_GREEN);

        yPos -= 400;
        xPos = centerXPos;

        var coinBtn1 = utilObj.getButton(600, 200, 0.5, 0.5, xPos, yPos, constantsObj.button_cutup,
            constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'subscriptionsLaunchLayer',
                fn: "back",
                screen: subscriptionsLaunchLayer.screen
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(transBg, coinBtn1, zOrder + 1);
        coinBtn1.setColor(constantsObj.COLOR_LIGHT_BLUE);

        var claimTxt = utilObj.getBMFontLabel("Continue", constantsObj.FONT_ROBOTO_BOLD_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, transBg, zOrder + 1);


        if (withAnim) {
            subscriptionsLaunchLayer.animateTransBg(transBg, true);
        }

        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);
    },

    setVisibility: function (arr, val) {
        for (var i in  arr) {
            if (utilObj.isNodeValid(arr[i])) {
                arr[i].setVisible(val);
            }
        }
    },

    updateTimeLabel: function (time) {
        if (curScreen == constantsObj.SCREEN_SUBSCRIPTIONS) {
            if (!subscriptionsDTCObj.checkIfEligibleForDailyDrip()) {
                subscriptionsLaunchLayer.setVisibility(subscriptionsLaunchLayer.arrForTimeRem, true);
                subscriptionsLaunchLayer.setVisibility(subscriptionsLaunchLayer.arrForClaimB, false);
            } else {
                subscriptionsLaunchLayer.setVisibility(subscriptionsLaunchLayer.arrForClaimB, true);
                subscriptionsLaunchLayer.setVisibility(subscriptionsLaunchLayer.arrForTimeRem, false);
            }
            var diff = 0;
            try {
                if (gameObj.getLastDateDailyDripGiven() != null) {
                    diff = Math.abs(utilObj.getDaysDiff(new Date(gameObj.getLastDateDailyDripGiven()), gameObj.getTodaysPuzzleDate()));
                }
            } catch (e) {

            }
            var timeToAdd = constantsObj.SECONDS_IN_DAY * diff;
            if (utilObj.isNodeValid(subscriptionsLaunchLayer.puzzleUnlockLabel)) {
                subscriptionsLaunchLayer.puzzleUnlockLabel.setString(utilObj.formatTime(timeToAdd+time));
            }
            if (utilObj.isNodeValid(subscriptionsLaunchLayer.puzzleUnlockLabel1)) {
                subscriptionsLaunchLayer.puzzleUnlockLabel1.setString(utilObj.formatTime(time));
            }
        }
    },

    select: function (params) {
        loggerObj.debugLog("here it is", params.flag, JSON.stringify(params));
        if (params.flag) {
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "subsciption","pack2", "", "", "1", "");
            // subscriptionsLaunchLayer.greenbg2.setVisible(true);
            subscriptionsLaunchLayer.pricelblr1.setFontFillColor(constantsObj.COLOR_WHITE);
            subscriptionsLaunchLayer.pricelblr2.setColor(constantsObj.COLOR_WHITE);
            subscriptionsLaunchLayer.pricelblr3.setColor(constantsObj.COLOR_WHITE);
            subscriptionsLaunchLayer.perWeek2.setColor(constantsObj.COLOR_WHITE);
            // subscriptionsLaunchLayer.greenbg1.setVisible(false);
            subscriptionsLaunchLayer.pricelbll1.setFontFillColor(constantsObj.COLOR_BLACK);
            subscriptionsLaunchLayer.pricelbll2.setColor(constantsObj.COLOR_BLACK);
            subscriptionsLaunchLayer.pricelbll3.setColor(constantsObj.COLOR_BLACK);
            subscriptionsLaunchLayer.perWeek1.setColor(constantsObj.COLOR_BLACK);
            subscriptionsLaunchLayer.selected1 = false;
            subscriptionsLaunchLayer.selected2 = true;
            if (utilObj.isAndroid()) {
                var str = "Monthly Billing @";
                if (subscriptionExp == constantsObj.EXP_VAR_2 || subscriptionExp == constantsObj.EXP_VAR_3) {
                    str = "Yearly Billing @";
                }
                subscriptionsLaunchLayer.priceLbl.setString(str + subscriptionsLaunchLayer.subPrice2);
            } else {
                var stringBilling = "1 week at " + subscriptionsLaunchLayer.subPrice2 + ", save 40%";
                if (subscriptionExp == constantsObj.EXP_VAR_2 || subscriptionExp == constantsObj.EXP_VAR_3) {
                    stringBilling = "1 month at " +  subscriptionsLaunchLayer.subPrice2 + ", save 52%";
                }
                subscriptionsLaunchLayer.priceLbl.setString(stringBilling);
            }
            subscriptionsLaunchLayer.animateRingOnSelect(true);
        } else {
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "subsciption","pack1", "", "", "1", "");
            // subscriptionsLaunchLayer.greenbg2.setVisible(false);
            subscriptionsLaunchLayer.pricelblr1.setFontFillColor(constantsObj.COLOR_BLACK);
            subscriptionsLaunchLayer.pricelblr2.setColor(constantsObj.COLOR_BLACK);
            subscriptionsLaunchLayer.pricelblr3.setColor(constantsObj.COLOR_BLACK);
            subscriptionsLaunchLayer.perWeek2.setColor(constantsObj.COLOR_BLACK);
            // subscriptionsLaunchLayer.greenbg1.setVisible(true);
            subscriptionsLaunchLayer.pricelbll1.setFontFillColor(constantsObj.COLOR_WHITE);
            subscriptionsLaunchLayer.pricelbll2.setColor(constantsObj.COLOR_WHITE);
            subscriptionsLaunchLayer.pricelbll3.setColor(constantsObj.COLOR_WHITE);
            subscriptionsLaunchLayer.perWeek1.setColor(constantsObj.COLOR_WHITE);
            subscriptionsLaunchLayer.selected1 = true;
            subscriptionsLaunchLayer.selected2 = false;
            if (utilObj.isAndroid()) {
                var str = "Weekly Billing @";
                if (subscriptionExp == constantsObj.EXP_VAR_2 || subscriptionExp == constantsObj.EXP_VAR_3) {
                    str = "Monthly Billing @";
                }
                subscriptionsLaunchLayer.priceLbl.setString(str + subscriptionsLaunchLayer.subPrice1);
            } else {
                var stringBilling = "1 week at " +  subscriptionsLaunchLayer.subPrice1;
                if (subscriptionExp == constantsObj.EXP_VAR_2 || subscriptionExp == constantsObj.EXP_VAR_3) {
                    stringBilling = "1 month at " +  subscriptionsLaunchLayer.subPrice1;
                }
                subscriptionsLaunchLayer.priceLbl.setString(stringBilling);
            }
            subscriptionsLaunchLayer.animateRingOnSelect(false);
        }

        utilObj.delayedCallback(subscriptionsLaunchLayer, subscriptionsLaunchLayer.subscribe, 0.55);
    },

    animateRingOnSelect: function (flag) {
        if (!flag) {
            // Ring Animation
            if (!subscriptionsLaunchLayer.isRingAnimAlreadyRunning) {
                subscriptionsLaunchLayer.isRingAnimAlreadyRunning = true;
                utilObj.setOpacity(subscriptionsLaunchLayer.outlineForAnim1, constantsObj.OPACITY_100);
                var scaleX = subscriptionsLaunchLayer.outlineForAnim1.getScaleX();
                var scaleY = subscriptionsLaunchLayer.outlineForAnim1.getScaleY();
                var scaleUp = utilObj.getScaleTo(0.5, scaleX * 1.2, scaleY * 1.2);
                var scaleDown = utilObj.getScaleTo(0.01, scaleX, scaleY);
                var fadeOut = utilObj.getFadeOut(0.5);
                var spawn = cc.Spawn(scaleUp, fadeOut).easing(new cc.easeOut(1.0));
                var animSeq = [spawn, scaleDown];
                animObj.runAction(subscriptionsLaunchLayer.outlineForAnim1, utilObj.getSequence(animSeq));
                utilObj.delayedCallback(subscriptionsLaunchLayer, subscriptionsLaunchLayer.setIsRingAnimAlreadyRunning, 0.55);
            }

            // Bg Anim
            var fadeIn = utilObj.getFadeIn(0.2);
            var fadeOut1 = utilObj.getFadeOut(0.2);
            animObj.runAction(subscriptionsLaunchLayer.greenbg1, fadeIn);
            animObj.runAction(subscriptionsLaunchLayer.greenbg2, fadeOut1);

        } else {
            // Ring Animation
            if (!subscriptionsLaunchLayer.isRingAnimAlreadyRunning) {
                subscriptionsLaunchLayer.isRingAnimAlreadyRunning = true;
                utilObj.setOpacity(subscriptionsLaunchLayer.outlineForAnim2, constantsObj.OPACITY_100);
                var scaleX = subscriptionsLaunchLayer.outlineForAnim2.getScaleX();
                var scaleY = subscriptionsLaunchLayer.outlineForAnim2.getScaleY();
                var scaleUp = utilObj.getScaleTo(0.5, scaleX * 1.2, scaleY * 1.2);
                var scaleDown = utilObj.getScaleTo(0.01, scaleX, scaleY);
                var fadeOut = utilObj.getFadeOut(0.5);
                var spawn = cc.Spawn(scaleUp, fadeOut).easing(new cc.easeOut(1.0));
                var animSeq = [spawn, scaleDown];
                animObj.runAction(subscriptionsLaunchLayer.outlineForAnim2, utilObj.getSequence(animSeq));
                utilObj.delayedCallback(subscriptionsLaunchLayer, subscriptionsLaunchLayer.setIsRingAnimAlreadyRunning, 0.55);
            }

            // Bg Anim
            var fadeIn = utilObj.getFadeIn(0.2);
            var fadeOut1 = utilObj.getFadeOut(0.2);
            animObj.runAction(subscriptionsLaunchLayer.greenbg1, fadeOut1);
            animObj.runAction(subscriptionsLaunchLayer.greenbg2, fadeIn);
        }

    },

    subscribe: function () {
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "subsciption","subscribe", "", "", "1", "");
        if (subscriptionsLaunchLayer.selected1) {
            subscriptionsObj.subscribe(0);
        } else {
            subscriptionsObj.subscribe(1);
        }

    },

    showPrivacyPolicy: function () {
        utilObj.openUrl("https://playsimple.in/privacy_aa");
        /*
        supportLayer.init();
        subscriptionsLaunchLayer.hide();
        supportLayer.show("privacy_policy", {pLayer: constantsObj.SCREEN_SUBSCRIPTIONS});
        */
    },

    removeSprites: function (parent) {
        for (var i in subscriptionsLaunchLayer.spritesArrToRemove) {
            if (utilObj.isNodeValid(subscriptionsLaunchLayer.spritesArrToRemove[i])) {
                utilObj.removeChild(parent, subscriptionsLaunchLayer.spritesArrToRemove[i]);
            }
        }
        subscriptionsLaunchLayer.spritesArrToRemove = [];
    }


});