/**
 * Created by pro on 13/04/17.
 */

var SUPPORT_TYPE_CATEG = "categ";
var SUPPORT_TYPE_DETAIL = "text";

var KEY_TITLE = "title";
var KEY_DESC = "desc";
var KEY_LINK = "link";
var KEY_SHOW_OPT = "show_options";

var SupportLayer = cc.Layer.extend({
    headerWrapper: null,
    headerHeight: 0,
    lastScreen: null,
    lastLayer: null,
    supportDict: null,
    nodesTraversed: [],
    homeMenu: null,
    listView: null,
    lastContentDownloaded: 0,
    userEmail: "",
    userIssue: "",
    issueTag: "",
    screen: null,
    parentLayer: null,
    params: null,
    supportJsonVersion: null,
    sub_link: "",

    load: function () {
        //var supportStored = ls.getItem(constantsObj.SUPPORT_JSON);
        var supportStored = ls.getItem(constantsObj.SUPPORT_DATA_FILE);
        var supportData = {};
        try {
            if (supportStored && supportStored != "") {
                supportData = JSON.parse(supportStored);
                // loggerObj.debugLog("lastContentDownloaded = ", utilObj.getStringifiedJson(supportData));
            }
        } catch (err) {
            // loggerObj.debugLog(err);
        }

        if (supportData != null && supportData.lastContentDownloaded != undefined) {
            supportLayer.lastContentDownloaded = supportData.lastContentDownloaded;
            supportLayer.supportJsonVersion = supportData.supportJsonVersion;
        }
        // loggerObj.debugLog("lastContentDownloaded = ", supportLayer.lastContentDownloaded);
    },

    save: function () {
        // loggerObj.debugLog("support save called");
        try {
            var supportData = {};
            supportData.lastContentDownloaded = supportLayer.lastContentDownloaded;
            supportData.supportJsonVersion = supportLayer.supportJsonVersion;
            // loggerObj.debugLog("support data = ", JSON.stringify(supportData));
            //ls.setItem(constantsObj.SUPPORT_JSON, JSON.stringify(supportData));
            ls.setItem(constantsObj.SUPPORT_DATA_FILE, JSON.stringify(supportData));
        } catch (err) {
            // loggerObj.debugLog(err)
        }
        return true;
    },

    init: function () {
        supportLayer.nodesTraversed = [];
        supportLayer.load();
        supportLayer.loadFaq();
        supportLayer.fun();
    },

    fun: function () {
        cc.loader.loadJson(res.support_json, function (error, data) {
            supportLayer.supportDict = data;
        });
        // loggerObj.debugLog("Json is ->", utilObj.getStringifiedJson(supportLayer.supportDict));
    },

    xyz: function () {
        // loggerObj.debugLog("this is xyz function");
    },

    loadFaq: function () {
        // var time3 = utilObj.getCurrentTimestampMs();
        if (utilObj.isNative()) {
            var faqData = ls.getItem(constantsObj.SUPPORT_JSON);
            try {
                if (faqData && faqData != "") {
                    supportLayer.supportDict = JSON.parse(faqData);
                } else {
                    cc.loader.loadJson(res.support_json, function (error, data) {
                        if (error == null) {
                            supportLayer.supportDict = data;
                        } else {
                            // loggerObj.debugLog(error);
                        }
                    });
                }
            } catch (err) {
                // loggerObj.debugLog(err);
            }
            supportLayer.triggerConfigDownload();
        }
        // loggerObj.debugLog("this is support dict", utilObj.getStringifiedJson(supportLayer.supportDict));
    },

    triggerConfigDownload: function () {
        if (supportLayer.supportJsonVersion != runtimeObj.getSupportJsonVersion()
            && utilObj.getCurrentTimestamp() - supportLayer.lastContentDownloaded > constantsObj.SECONDS_IN_DAY) {
            var downloadFileUrl = constantsObj.PUZZLES_BASE_URL + "support/" + runtimeObj.getSupportJsonVersion() + "/" + constantsObj.SUPPORT_JSON;
            supportLayer.lastContentDownloaded = utilObj.getCurrentTimestamp();
            supportLayer.save();
            // loggerObj.debugLog("triggering support download");
            utilObj.downloadGZipFile(downloadFileUrl, supportLayer.faqDownloaded);
        }
    },

    faqDownloaded: function (faqData) {
        if (faqData && faqData != "") {
            supportLayer.supportJsonVersion = runtimeObj.getSupportJsonVersion();
            ls.setItem(constantsObj.SUPPORT_JSON, faqData);
            if (curScreen != constantsObj.SCREEN_FAQ) {
                supportLayer.loadFaq();
            }
        }
    },

    back: function () {
        var params = supportLayer.params;
        var nodeTrackId = supportLayer.topOf(supportLayer.nodesTraversed);
        supportLayer.popFrom(supportLayer.nodesTraversed);
        var lastNode = supportLayer.topOf(supportLayer.nodesTraversed);
        // loggerObj.debugLog("curscreen lastnode for back button is ", lastNode);
        if (lastNode != null) {
            if (nodeTrackId.indexOf(":") > 0) {
                var nodeIdArr = nodeTrackId.split(":");
                // trackObj.trackCounter(constantsObj.TRACK_HELP_CENTER, gameObj.getViewingBucket(), gameObj.getViewingPuzIdInBucket(), nodeIdArr[0], nodeIdArr[1], "back", gameObj.getViewingLevel() + "," + gameObj.getViewingPuzNumber(), "", "");
            } else {
                // trackObj.trackCounter(constantsObj.TRACK_HELP_CENTER, gameObj.getViewingBucket(), gameObj.getViewingPuzIdInBucket(), nodeTrackId, "", "back", gameObj.getViewingLevel() + "," + gameObj.getViewingPuzNumber(), "", "");
            }
            supportLayer.redraw(lastNode);
            // loggerObj.debugLog("curscreen redrawing last node here ", lastNode);
        } else {
            // trackObj.trackCounter(constantsObj.TRACK_HELP_CENTER, gameObj.getViewingBucket(), gameObj.getViewingPuzIdInBucket(), "main", "", "back", gameObj.getViewingLevel() + "," + gameObj.getViewingPuzNumber(), "", "");
            supportLayer.backToHome(params);
        }
    },

    hide: function () {
        // loggerObj.debugLog("curscreen sc is ", curScreen, utilObj.getCurScreen());
        if (utilObj.getCurScreen() == constantsObj.SCREEN_FAQ) {
            var sc = utilObj.popCurScreen();
            // loggerObj.debugLog("curscreen sc is ", sc);
        }
        supportLayer.setVisible(false);
        supportLayer.removeAllChildren();
    },

    redraw: function (nodeId) {
        // loggerObj.debugLog("node tapped ", utilObj.getStringifiedJson(nodeId));
        supportLayer.hide();
        supportLayer.show(nodeId, supportLayer.params);
    },

    backToHome: function (params) {
        supportLayer.nodesTraversed = [];
        // loggerObj.debugLog("pLayer in backToHome Call is12 ");
        if (params == undefined) {
            return;
        }
        supportLayer.hide();
        utilObj.popCurScreen();
         if(params.pLayer == constantsObj.SCREEN_QUEST_MAP) {
             questMapLayer.show();
        }else if (params.pLayer == constantsObj.SCREEN_GAME) {
            gameLayer.show(gameLayer.crosswordDate);
        } else if (params.pLayer == constantsObj.SCREEN_CALENDAR) {
            calendarLayer.show()
        } else if (params.pLayer == constantsObj.SCREEN_HOME) {
            homeLayer.show();
        } else if (params.pLayer == constantsObj.SCREEN_ACHIEVEMENTS) {
            if (ProfileExp == constantsObj.EXP_VAR_1) {
                achievementsLayer.show(gameObj.getShowStat());
            } else {
                achievementsLayer.show();
            }
        } else if (params.pLayer == constantsObj.SCREEN_PACK_LAYER) {
            packsLayer.show();
        } else if (params.pLayer == constantsObj.SCREEN_FIRST_LAUNCH) {
            firstLaunchLayer.show();
        } else if (params.pLayer == constantsObj.SCREEN_SUBSCRIPTIONS) {
            gameObj.setScreenTypeForSubsLayer(constantsObj.SUBSCRIPTION_OFFER);
            subscriptionsLaunchLayer.show(true);
        } else if(params.player == constantsObj.SCREEN_SPINNER_1){
            newSpinnerPopup.show();
        } else {
            var packId = packInfoLayer.selectedPackId;
            packInfoLayer.show(packId, null, packInfoLayer.britPack);
        }
    },

    show: function (nodeId, params) {
        supportLayer.parentLayer = params.pLayer;
        supportLayer.screen = constantsObj.SCREEN_FAQ;
        supportLayer.params = params;
        var screenId = constantsObj.SCREEN_FAQ;
        var spriteArr = [];
        var labelArr = [];
        var zOrder = constantsObj.UI_Z_ORDER;
        var xPos = centerXPos;
        var yPos = constantsObj.DESIGN_HEIGHT + topBarOffset;
        if (utilObj.isIos()) {
            yPos = constantsObj.DESIGN_HEIGHT;
        }

        loggerObj.debugLog("coming here for ccpa privacy");

        if (nodeId == undefined || nodeId == "") {
            nodeId = "root";
        }

        // to send mail whenever needed
        var nodeDesc = supportLayer.supportDict[nodeId][KEY_DESC];
        if (nodeDesc == null) {
            nodeDesc = "";
        }
        if (nodeDesc == "SEND_MAIL") {
            var nodeIdArr = nodeId.split(":");
            // trackObj.trackCounter(constantsObj.TRACK_HELP_CENTER, gameObj.getViewingBucket(), gameObj.getViewingPuzIdInBucket(), nodeIdArr[0], nodeIdArr[1], "help", gameObj.getViewingLevel() + "," + gameObj.getViewingPuzNumber(), "", "");

            // EXPERIMENT CHECK HERE
            // supportLayer.back();
            supportLayer.sendMail(nodeId);
            return;
        }

        /*if(supportLayer.supportDict[nodeId][KEY_TITLE] == "Privacy Policy") {
            // loggerObj.debugLog("checking json file 111");
            nodeDesc = "";
            for(var i=1;i<=25;i++) {
                nodeDesc = nodeDesc + supportLayer.supportDict[nodeId][KEY_DESC + i];
            }
            // loggerObj.debugLog("checking json file",str);
        }*/


        utilObj.updateScreenBegin(screenId);

        if (supportLayer.topOf(supportLayer.nodesTraversed) != nodeId) {
            // utilObj.playSound(res.s_button_tap);
            supportLayer.nodesTraversed.push(nodeId);
        }

        var RETRY_INTERVAL = 200;
        if (supportLayer.supportDict == null) {
            window.setTimeout(supportLayer.show, RETRY_INTERVAL);
            return;
        }


        // loggerObj.debugLog("Calling screen", curScreen);
        utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos, 0.5, 1, canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset, spriteArr, supportLayer, zOrder - 1, constantsObj.SPRITE_MISC);

        // HEADER
        supportLayer.header = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos, 0.5, 1, canvasWidth, 200, spriteArr, supportLayer, zOrder, constantsObj.SPRITE_MISC);
        supportLayer.header.setColor(constantsObj.COLOR_YELLOW_07);

        var lineHeight = 85;
        if (supportLayer.supportDict[nodeId][KEY_TITLE] != "Privacy Policy") {
            // var heading = supportLayer.supportDict[nodeId][KEY_TITLE];
            // var text = utilObj.getSplitStringsArr(heading, 42);
            // for (var i = 0; i < text.length; i++) {
            //     utilObj.getBMFontLabel(text[i], constantsObj.FONT_ROBOTO_BOLD_70, constantsObj.COLOR_BLACK, constantsObj.LABEL_AUTO_WIDTH,
            //         cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - 50 , 0.5, 1.0, labelArr, supportLayer, zOrder);
            //     yPos -= lineHeight;
            // }
            utilObj.getBMFontLabel(stringsObj.help_center, constantsObj.FONT_ROBOTO_MEDIUM_100, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 200 - canvasWidth / 4, yPos - 40, 0, 1.0, labelArr, supportLayer, zOrder);
        }
        else {
            utilObj.getBMFontLabel("Privacy Policy", constantsObj.FONT_ROBOTO_MEDIUM_100, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 200 - canvasWidth / 4, yPos - 40, 0, 1.0, labelArr, supportLayer, zOrder);
        }
        yPos -= 200;
        var shadow = utilObj.getScale9Sprite(constantsObj.shadow, centerXPos, yPos, 0.5, 1, canvasWidth, 20, spriteArr, supportLayer, zOrder, constantsObj.SPRITE_LOCAL);
        yPos += 200;
        var backArrow = utilObj.getSprite(constantsObj.arrow_01, xLeftPos + 50, yPos - 50, 0, 1, constantsObj.SCALE_SPRITE_1, spriteArr, supportLayer, zOrder, constantsObj.SPRITE_MISC);
        backArrow.setColor(constantsObj.COLOR_BLACK);
        var backButton = utilObj.getButton(250, 250, 0, 1.0, xLeftPos, yPos,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'supportLayer',
                fn: 'back',
                screen: supportLayer.screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: utilObj.getScreenName(screenId),
                    f: constantsObj.TRACK_BACK,
                    g: nodeId,
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        //supportLayer.addChild(backButton, zOrder);
        utilObj.addChild(supportLayer, backButton, zOrder);

        yPos -= 200;
        var title = supportLayer.supportDict[nodeId][KEY_TITLE];
        var type = supportLayer.supportDict[nodeId]["type"];
        if (title != "Privacy Policy") {
            if (type == SUPPORT_TYPE_DETAIL) {
                var text = utilObj.getSplitStringsArr(title, 38);
                yPos -= lineHeight;
                for (var i = 0; i < text.length; i++) {
                    utilObj.getBMFontLabel(text[i], constantsObj.FONT_ROBOTO_BOLD_70, constantsObj.COLOR_BLACK, constantsObj.LABEL_AUTO_WIDTH,
                        cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 200 - canvasWidth / 4, yPos, 0, 0.5, labelArr, supportLayer, zOrder);
                    yPos -= lineHeight;
                }
            }
            // yPos -= 20;
            // var shadow = utilObj.getScale9Sprite(constantsObj.shadow, centerXPos, yPos, 0.5, 1,canvasWidth, 20, spriteArr, supportLayer, zOrder , constantsObj.SPRITE_MISC);
            // yPos += 20;

        }
        /*else {
            yPos -= lineHeight;
            utilObj.getSprite(constantsObj.privacy_policy_icon, centerXPos, yPos, 0.5, 1, constantsObj.SCALE_SPRITE_18, spriteArr, supportLayer, zOrder + 1, constantsObj.SPRITE_MISC);
            yPos -= lineHeight + 50;
        }*/

        // BODY
        yPos -= 20;
        if (type == SUPPORT_TYPE_CATEG) {
            //if ( title != "Privacy Policy") {
            /*var line = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, yPos, 0.5, 1, canvasWidth, 4, spriteArr, supportLayer, zOrder + 1, constantsObj.SPRITE_MISC);
            line.setColor(constantsObj.COLOR_LIGHT_GREY_02);*/
            yPos -= 10;
            //}

            supportLayer.renderCategScreen(nodeId, spriteArr, labelArr, yPos);
        } else if (type == SUPPORT_TYPE_DETAIL) {
            supportLayer.renderTextScreen(nodeId, spriteArr, yPos);
        }

        // FOOTER
        xPos = centerXPos;
        //yPos = 200;
        /*supportLayer.footer = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos, 0.5, 1, canvasWidth, 200, spriteArr, supportLayer, zOrder, constantsObj.SPRITE_MISC);
        supportLayer.footer.setColor(constantsObj.COLOR_YELLOW_07);

        utilObj.getBMFontLabel(stringsObj.back_to_game, constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - 100, 0.5, 0.5, labelArr, supportLayer, zOrder + 1);

        var exitButton = utilObj.getButton(700, 150, 0.5, 0.5, xPos, yPos - 100,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'supportLayer',
                fn: 'backToHome',
                screen: supportLayer.screen,
                params: params,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: utilObj.getScreenName(screenId),
                    f: constantsObj.TRACK_BACK_GAME,
                    g: nodeId,
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        exitButton.setColor(constantsObj.COLOR_BUTTON_GREEN);


        utilObj.addChild(supportLayer, exitButton, zOrder + 1);*/


        //supportLayer.addChild(supportLayer.listView, zOrder);
        utilObj.addChild(supportLayer, supportLayer.listView, zOrder);
        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);

        utilObj.updateScreen(screenId, supportLayer);
        // loggerObj.debugLog("coming to this point");

        utilObj.hideBannerAd(utilObj.getScreenName(constantsObj.SCREEN_FAQ));
    },

    renderCategScreen: function (nodeId, spriteArr, labelArr, yPos) {
        var allNodes = supportLayer.supportDict[nodeId]["nodes"];

        var nodeTrackId = nodeId;
        if (nodeTrackId == "root") {
            nodeTrackId = "main";
        }
        // trackObj.trackCounter(constantsObj.TRACK_HELP_CENTER, gameObj.getViewingBucket(), gameObj.getViewingPuzIdInBucket(), nodeTrackId, "", "view", gameObj.getViewingLevel() + "," + gameObj.getViewingPuzNumber(), "", "");

        /*if (supportLayer.listView != null) {
         supportLayer.removeChild(supportLayer.listView);
         }*/
        supportLayer.listView = new ccui.ListView();
        supportLayer.listView.setDirection(ccui.ScrollView.DIR_VERTICAL);
        supportLayer.listView.setTouchEnabled(true);
        supportLayer.listView.setContentSize(cc.size(canvasWidth, yPos));
        supportLayer.listView.setPosition(centerXPos, yPos);
        supportLayer.listView.setItemsMargin(10);
        supportLayer.listView.setBounceEnabled(true);
        supportLayer.listView.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
        supportLayer.listView.setAnchorPoint(0.5, 1);

        for (var i = -1; i < allNodes.length; i++) {
            if (i != -1) {
                var singleNode = allNodes[i];
                loggerObj.debugLog("singleNode",singleNode);
                var title = supportLayer.supportDict[singleNode][KEY_TITLE];
                var titleArr = utilObj.getSplitStringsArr(title, 35);
            }
            if (i == -1) {
                var title = supportLayer.supportDict[nodeId][KEY_TITLE];
                var titleArr = utilObj.getSplitStringsArr(title, 35);
            }
            var lineHeight = 85;
            var textHeight = (titleArr.length - 1) * lineHeight + 200;
            var xPos = centerXPos;
            // loggerObj.debugLog("lelouch , title is ", title, supportLayer.supportDict[nodeId][KEY_TITLE]);
            if ((utilObj.isIos() && (title == "DTC Premium Subscription")) || ((title == "DTC Premium Subscription") && subscriptionsDTCObj.checkSubscriptionStatus() != constantsObj.SUBSCRIPTION_ACTIVE)) {
                continue;
            }

            if ((utilObj.isAndroid() && (title == "Subscription - DTC Premium")) || ((title == "Subscription - DTC Premium") && subscriptionsDTCObj.checkSubscriptionStatus() != constantsObj.SUBSCRIPTION_ACTIVE)) {
                continue;
            }

            var itemWidget = new ccui.Widget();
            itemWidget.setContentSize(cc.size(canvasWidth, textHeight + 4));

            if ((title == "What is the Weekly Quest?") && (epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST) == constantsObj.EXP_VAR_CONTROL || gameObj.getExpNewWeeklyQuestVariant() != constantsObj.EXP_VAR_CONTROL)) {
                continue;
            }
            if ((title == "How to play Weekly Quest?") && (epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST) == constantsObj.EXP_VAR_CONTROL || gameObj.getExpNewWeeklyQuestVariant() == constantsObj.EXP_VAR_CONTROL)) {
                continue;
            }
            if ((title == "What is the Lucky Spin?") && epmObj.getChosenVariant(constantsObj.EXP_SPINNER_NEW) == constantsObj.EXP_VAR_CONTROL) {
                continue;
            }
            if ((title == "What is the Weekly Streak?") && homeLayoutExpNew != constantsObj.EXP_VAR_2) {
                continue;
            }
            if (title == "What is the Valentine's Quest?" && gameObj.getExpNewWeeklyQuestVariant() != constantsObj.EXP_VAR_CONTROL) {
                continue;
            }
            if((title == "Blitz Mode")&& !zenModeObj.isZenModeAvailable()){
                continue;
            }

            // for redirecting to privacy policy url
            var fnForBtnToRedraw = "redraw";
            if (title == "Privacy Policy") {
                fnForBtnToRedraw = "openPrivacyLink";
            }

            if (i == -1) {
                var itemBg = utilObj.getButton(canvasWidth, textHeight, 0.5, 0.5, centerXPos, textHeight / 2 + 4, constantsObj.tile_white, constantsObj.tile_white, constantsObj.tile_white, {
                    obj: 'supportLayer',
                    fn: 'doNothing',
                    screen: constantsObj.SCREEN_FAQ,
                    params: nodeId,
                    sound: "false",
                    track: {
                        k: constantsObj.TRACK_HELP_CENTER,
                        p: constantsObj.TRACK_CLICK,
                        c: title,
                        o: "",
                        f: "",
                        g: "",
                        s: "",
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
                itemBg.setColor(constantsObj.COLOR_WHITE);
                //var itemBg = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos, 0.5, 1, canvasWidth, textHeight, spriteArr, " ", 0, constantsObj.SPRITE_MISC);
            } else {
                var itemBg = utilObj.getButton(canvasWidth, textHeight, 0.5, 0.5, centerXPos, textHeight / 2 + 4, constantsObj.tile_white, constantsObj.tile_white, constantsObj.tile_white, {
                    obj: 'supportLayer',
                    fn: fnForBtnToRedraw,
                    screen: constantsObj.SCREEN_FAQ,
                    params: singleNode,
                    track: {
                        k: constantsObj.TRACK_HELP_CENTER,
                        p: constantsObj.TRACK_CLICK,
                        c: title,
                        o: "",
                        f: "",
                        g: "",
                        s: "",
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
                itemBg.setColor(constantsObj.COLOR_WHITE);
            }

            var localYPos = textHeight - 100;
            if (i == -1) {
                for (var j = 0; j < titleArr.length; j++) {
                    utilObj.getBMFontLabel(titleArr[j], constantsObj.FONT_ROBOTO_BOLD_70, constantsObj.COLOR_BLACK,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 200 - canvasWidth / 4, localYPos, 0, 0.5, labelArr, itemBg, 0);
                    localYPos -= lineHeight;
                }
            } else {
                for (var j = 0; j < titleArr.length; j++) {
                    utilObj.getBMFontLabel(titleArr[j], constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_BLACK,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 200 - canvasWidth / 4, localYPos, 0, 0.5, labelArr, itemBg, 0);
                    localYPos -= lineHeight;
                }
            }

            /*var arrow2 = utilObj.getSprite(constantsObj.arrow_02, xRightPos - 100, textHeight / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_13, spriteArr, itemBg, 0, constantsObj.SPRITE_MISC);
            arrow2.setColor(constantsObj.COLOR_BLACK);
            arrow2.setFlippedX(true);*/

            //itemWidget.addChild(itemBg, 0);
            utilObj.addChild(itemWidget, itemBg, 0);
            if (i == -1) {
                var line = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, 4, 0.5, 1, canvasWidth, 4, spriteArr, itemWidget, 1, constantsObj.SPRITE_MISC);
            } else {
                var line = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, 4, 0.5, 1, canvasWidth - 100, 4, spriteArr, itemWidget, 1, constantsObj.SPRITE_MISC);
            }
            line.setColor(constantsObj.COLOR_LIGHT_GREY_02);
            //supportLayer.listView.addChild(itemWidget);
            utilObj.addChild(supportLayer.listView, itemWidget);
        }
    },

    renderTextScreen: function (nodeId, spriteArr, yPos) {
        if (nodeId == undefined) {
            nodeId = "";
        }

        var nodeIdArr = nodeId.split(":");
        // trackObj.trackCounter(constantsObj.TRACK_HELP_CENTER, gameObj.getViewingBucket(), gameObj.getViewingPuzIdInBucket(), nodeIdArr[0], nodeIdArr[1], "view", gameObj.getViewingLevel() + "," + gameObj.getViewingPuzNumber(), "", "");

        var lineHeight = 70;
        var nodeDesc = supportLayer.supportDict[nodeId][KEY_DESC];
        if (nodeDesc == null) {
            nodeDesc = "";
        }

        var countNewLines = 0;
        var strDesc = "";
        for (var i = 0; i < nodeDesc.length; i++) {
            countNewLines += (nodeDesc[i].match(/\n/g) || []).length;
            strDesc += nodeDesc[i];
        }

        var stringsArr = utilObj.getStringsArrWithFont(nodeDesc);


        var heightFactor = 10;
        var txtHeight = lineHeight * (stringsArr.length + countNewLines + 8);
        var buttonHeight = 0;
        var xPos = centerXPos;
        if ((supportLayer.supportDict[nodeId].hasOwnProperty(KEY_SHOW_OPT) && supportLayer.supportDict[nodeId][KEY_SHOW_OPT] == true)) {
            buttonHeight = 500;
        }

        if (supportLayer.supportDict[nodeId][KEY_TITLE] == stringsObj.my_data) {
            buttonHeight = 500;
        }
        supportLayer.listView = new ccui.ListView();
        supportLayer.listView.setDirection(ccui.ScrollView.DIR_VERTICAL);
        supportLayer.listView.setTouchEnabled(true);
        supportLayer.listView.setContentSize(cc.size(canvasWidth, yPos));
        supportLayer.listView.setPosition(centerXPos, yPos);
        supportLayer.listView.setItemsMargin(10);
        supportLayer.listView.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
        supportLayer.listView.setAnchorPoint(0.5, 1.0);

        var itemWidget = new ccui.Widget();
        itemWidget.setContentSize(cc.size(canvasWidth, txtHeight + buttonHeight));

        var yPos1 = txtHeight + buttonHeight;

        yPos1 -= lineHeight / 2 - 50;

        if (supportLayer.supportDict[nodeId][KEY_TITLE] != "Privacy Policy") {
            var line = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, yPos1, 0.5, 1, canvasWidth, 4, spriteArr, itemWidget, constantsObj.UI_Z_ORDER + 1, constantsObj.SPRITE_MISC);
            line.setColor(constantsObj.COLOR_LIGHT_GREY_02);
        }


        //supportLayer.listView.addChild(itemWidget);
        if (supportLayer.supportDict[nodeId][KEY_TITLE] == "Privacy Policy") {
            //yPos -= lineHeight;
            var x = utilObj.getSprite(constantsObj.privacy_policy_icon, centerXPos, yPos1 - 15, 0.5, 1, constantsObj.SCALE_SPRITE_17, null, supportLayer.listView, constantsObj.UI_Z_ORDER);
            utilObj.addChild(itemWidget, x, 1);
            yPos1 -= 100;
        }
        yPos1 -= 100;
        for (var i = 0; i < stringsArr.length; i++) {
            // either the whole line will be bold or not at all

            var str = stringsArr[i][0];
            var newLineCount = (str.match(/\n/g) || []).length;
            var font = stringsArr[i][1];
            if (font == res.roboto_regular) {
                font = constantsObj.FONT_ROBOTO_REGULAR_60;
            } else {
                font = constantsObj.FONT_ROBOTO_BOLD_60;
            }


            yPos -= 10;
            // loggerObj.debugLog("stringarr "  + str );


            if (str == null || str == "" || str.trim() == "") {
                var label = utilObj.getTTFFontLabel("\n", font, constantsObj.COLOR_BLACK, constantsObj.LABEL_AUTO_WIDTH,
                    cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos - constantsObj.DESIGN_WIDTH / 2 + 45, yPos1, 0, 1.0, null, supportLayer.listView, 0);
                //itemWidget.addChild(label, 1);
                utilObj.addChild(itemWidget, label, 1);
                yPos1 -= 20;
                continue;
            }


            var label = utilObj.getTTFFontLabel(str, font, constantsObj.COLOR_BLACK, constantsObj.LABEL_AUTO_WIDTH,
                cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos - constantsObj.DESIGN_WIDTH / 2 + 95, yPos1, 0, 1.0, null, supportLayer.listView, constantsObj.UI_Z_ORDER);
            //itemWidget.addChild(label, 1);
            utilObj.addChild(itemWidget, label, 1);


            yPos1 -= lineHeight * (newLineCount + 2);
        }

        if (supportLayer.supportDict[nodeId][KEY_TITLE] == stringsObj.my_data) {
            yPos1 -= 75;

            var buttonWidth = 900;
            var xPos1 = centerXPos;

            supportLayer.issueTag = nodeId;

            var l1 = utilObj.getBMFontLabel(stringsObj.delete_my_data, constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos1, yPos1 - 85 - 600, 0.5, 0.5, null, supportLayer, 1);
            //itemWidget.addChild(l1, 1);
            utilObj.addChild(itemWidget, l1, 1);
            l1.setColor(constantsObj.COLOR_GREY_02);

            var helpfulButton = utilObj.getButton(buttonWidth, 170, 0.5, 1.0, xPos1, yPos1 - 600,
                constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: 'supportLayer',
                    fn: 'deleteMyData',
                    params: nodeId,
                    screen: supportLayer.screen,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: gameObj.getTrackingPuzzleTheme(),
                        o: utilObj.getScreenName(supportLayer.screen),
                        f: constantsObj.TRACK_DELETE_DATA,
                        g: nodeId,
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            //helpfulButton.setColor(constantsObj.COLOR_BUTTON_LIGHT_BLUE);
            //itemWidget.addChild(helpfulButton, 0);
            utilObj.addChild(itemWidget, helpfulButton, 0);
            var arrow2 = utilObj.getScale9Sprite(constantsObj.button_gdpr1, xPos1, yPos1 - 600, 0.5, 1.0, buttonWidth - 200, 170, spriteArr, itemWidget, 0, constantsObj.SPRITE_MISC);
        }

        if ((supportLayer.supportDict[nodeId].hasOwnProperty(KEY_SHOW_OPT) && supportLayer.supportDict[nodeId][KEY_SHOW_OPT] == true)) {
            yPos1 -= 75;

            var buttonWidth = 900;
            var xPos1 = centerXPos;

            supportLayer.issueTag = nodeId;

            loggerObj.debugLog("check for the titles ",supportLayer.supportDict[nodeId][KEY_TITLE], nodeId);

            if (supportLayer.supportDict[nodeId][KEY_TITLE].toString() == "Issues with payments?" || supportLayer.supportDict[nodeId][KEY_TITLE].toString() == "How can I get a refund?" || supportLayer.supportDict[nodeId][KEY_TITLE].toString() == "Where can I view, manage or cancel my Subscription?" || nodeId == "subscriptions:How_much_does_it_cost?" || nodeId == "subscriptions_ios:How_much_does_it_cost?") {
                var l2 = utilObj.getBMFontLabel("HELP", constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos1, yPos1 - 85, 0.5, 0.5, null, supportLayer, 1);
                //itemWidget.addChild(l2, 1);
                supportLayer.sub_link = "";
                if (utilObj.isAndroid()) {
                    //"desc": ["In case you are facing issues with your payment \nmethod, you can learn more here- \n\nAndroid: \nhttps:\/\/support.google.com/googleplay/answer\n/1267137 \n\niOS: \nhttps:\/\/support.apple.com/en-us/HT203005"],
                    if (supportLayer.supportDict[nodeId][KEY_TITLE].toString() == "Issues with payments?") {
                        supportLayer.sub_link = constantsObj.subs_link1;
                    } else if (supportLayer.supportDict[nodeId][KEY_TITLE].toString() == "How can I get a refund?") {
                        supportLayer.sub_link = constantsObj.subs_link2;
                    } else if (supportLayer.supportDict[nodeId][KEY_TITLE].toString() == "Where can I view, manage or cancel my Subscription?") {
                        supportLayer.sub_link = constantsObj.subs_link3;
                    } else if (nodeId == "subscriptions:How_much_does_it_cost?") {
                        supportLayer.sub_link = constantsObj.subs_link4;
                    }
                }

                if (utilObj.isIos()) {
                    if (supportLayer.supportDict[nodeId][KEY_TITLE].toString() == "Issues with payments?") {
                        supportLayer.sub_link = constantsObj.subs_link1_ios;
                    } else if (supportLayer.supportDict[nodeId][KEY_TITLE].toString() == "How can I get a refund?") {
                        supportLayer.sub_link = constantsObj.subs_link2_ios;
                    } else if (supportLayer.supportDict[nodeId][KEY_TITLE].toString() == "Where can I view, manage or cancel my Subscription?") {
                        supportLayer.sub_link = constantsObj.subs_link3_ios;
                    } else if (nodeId == "subscriptions_ios:How_much_does_it_cost?") {
                        supportLayer.sub_link = constantsObj.subs_link4_ios;
                    }
                }
                // params.title1 = supportLayer.supportDict[nodeId][KEY_TITLE].toString();

                utilObj.addChild(itemWidget, l2, 1);
                var restorePackage = utilObj.getButton(buttonWidth, 170, 0.5, 1.0, xPos1, yPos1,
                    constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                        obj: 'supportLayer',
                        fn: 'helpSubs',
                        params: nodeId,
                        screen: supportLayer.screen,
                        track: {
                            k: constantsObj.TRACK_DIALOG,
                            p: gameObj.getCurPuzzleTracking(),
                            c: gameObj.getTrackingPuzzleTheme(),
                            o: utilObj.getScreenName(supportLayer.screen),
                            f: "restore_purchase",
                            g: nodeId,
                            s: gameObj.getPuzzleSpeciesTracking(),
                            co: 1,
                            oppId: ""
                        },
                    }, false, ccui.Widget.PLIST_TEXTURE, 1);
                restorePackage.setColor(constantsObj.COLOR_BUTTON_ORANGE);
                //itemWidget.addChild(notHelpfulButton, 0);
                utilObj.addChild(itemWidget, restorePackage, 0);
                yPos1 -= 250;
            } else {
                if (supportLayer.supportDict[nodeId][KEY_TITLE].toString().startsWith("Coins purchased not showing") && utilObj.isIos()) {
                    var l2 = utilObj.getBMFontLabel("Restore Purchases", constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_WHITE,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos1, yPos1 - 85, 0.5, 0.5, null, supportLayer, 1);
                    //itemWidget.addChild(l2, 1);
                    utilObj.addChild(itemWidget, l2, 1);
                    var restorePackage = utilObj.getButton(buttonWidth, 170, 0.5, 1.0, xPos1, yPos1,
                        constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                            obj: 'supportLayer',
                            fn: 'restorePurchase',
                            params: nodeId,
                            screen: supportLayer.screen,
                            track: {
                                k: constantsObj.TRACK_DIALOG,
                                p: gameObj.getCurPuzzleTracking(),
                                c: gameObj.getTrackingPuzzleTheme(),
                                o: utilObj.getScreenName(supportLayer.screen),
                                f: "restore_purchase",
                                g: nodeId,
                                s: gameObj.getPuzzleSpeciesTracking(),
                                co: 1,
                                oppId: ""
                            },
                        }, false, ccui.Widget.PLIST_TEXTURE, 1);
                    restorePackage.setColor(constantsObj.COLOR_BUTTON_ORANGE);
                    //itemWidget.addChild(notHelpfulButton, 0);
                    utilObj.addChild(itemWidget, restorePackage, 0);
                    yPos1 -= 250;
                }

                var l1 = utilObj.getBMFontLabel(stringsObj.wasHelpful, constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos1, yPos1 - 85, 0.5, 0.5, null, supportLayer, 1);
                //itemWidget.addChild(l1, 1);
                utilObj.addChild(itemWidget, l1, 1);

                var helpfulButton = utilObj.getButton(buttonWidth, 170, 0.5, 1.0, xPos1, yPos1,
                    constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                        obj: 'supportLayer',
                        fn: 'wasHelpful',
                        params: nodeId,
                        screen: supportLayer.screen,
                        track: {
                            k: constantsObj.TRACK_DIALOG,
                            p: gameObj.getCurPuzzleTracking(),
                            c: gameObj.getTrackingPuzzleTheme(),
                            o: utilObj.getScreenName(supportLayer.screen),
                            f: constantsObj.TRACK_HELPFUL,
                            g: nodeId,
                            s: gameObj.getPuzzleSpeciesTracking(),
                            co: 1,
                            oppId: ""
                        },
                    }, false, ccui.Widget.PLIST_TEXTURE, 1);
                helpfulButton.setColor(constantsObj.COLOR_BUTTON_LIGHT_BLUE);
                //itemWidget.addChild(helpfulButton, 0);
                utilObj.addChild(itemWidget, helpfulButton, 0);

                yPos1 -= 250;
                /*
                 var nodeLink = supportLayer.supportDict[nodeId][KEY_LINK];
                 if (nodeLink != undefined && nodeLink != "") {
                 callbackFunc = "goToSupportLink";
                 callbackArg = nodeLink;
                 callbackFuncWeb = supportLayer.goToSupportLink;
                 }
                 */
                var l2 = utilObj.getBMFontLabel(stringsObj.wasNotHelpful, constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos1, yPos1 - 85, 0.5, 0.5, null, supportLayer, 1);
                //itemWidget.addChild(l2, 1);
                utilObj.addChild(itemWidget, l2, 1);

                var notHelpfulButton = utilObj.getButton(buttonWidth, 170, 0.5, 1.0, xPos1, yPos1,
                    constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                        obj: 'supportLayer',
                        fn: 'wasNotHelpful',
                        params: nodeId,
                        screen: supportLayer.screen,
                        track: {
                            k: constantsObj.TRACK_DIALOG,
                            p: gameObj.getCurPuzzleTracking(),
                            c: gameObj.getTrackingPuzzleTheme(),
                            o: utilObj.getScreenName(supportLayer.screen),
                            f: constantsObj.TRACK_NOT_HELPFUL,
                            g: nodeId,
                            s: gameObj.getPuzzleSpeciesTracking(),
                            co: 1,
                            oppId: ""
                        },
                    }, false, ccui.Widget.PLIST_TEXTURE, 1);
                notHelpfulButton.setColor(constantsObj.COLOR_BUTTON_ORANGE);
                //itemWidget.addChild(notHelpfulButton, 0);
                utilObj.addChild(itemWidget, notHelpfulButton, 0);
            }
        }
        //supportLayer.listView.addChild(itemWidget, 0);
        utilObj.addChild(supportLayer.listView, itemWidget, 0);
    },

    deleteMyData: function (issueTag) {
        if (issueTag == undefined) {
            issueTag = supportLayer.issueTag;
        }
        var nodeIdArr = issueTag.split(":");
        // trackObj.trackCounter(constantsObj.TRACK_HELP_CENTER, gameObj.getViewingBucket(), gameObj.getViewingPuzIdInBucket(), nodeIdArr[0], nodeIdArr[1], "help", gameObj.getViewingLevel() + "," + gameObj.getViewingPuzNumber(), "", "");
        //utilObj.showMessage("Please let us know what are you looking for!!");
        supportLayer.sendMail(issueTag);
    },

    helpSubs: function (params) {
        var link = supportLayer.sub_link;
        loggerObj.debugLog("check for the url ", link);
        utilObj.openUrl(link);

    },

    restorePurchase: function () {
        utilObj.restorePackages();
    },

    wasHelpful: function (issueTag) {
        if (issueTag == undefined) {
            issueTag = supportLayer.issueTag;
        }
        var nodeIdArr = issueTag.split(":");
        // trackObj.trackCounter(constantsObj.TRACK_HELP_CENTER, gameObj.getViewingBucket(), gameObj.getViewingPuzIdInBucket(), nodeIdArr[0], nodeIdArr[1], "worked", gameObj.getViewingLevel() + "," + gameObj.getViewingPuzNumber(), "", "");
        utilObj.showMessage("Thank you for your feedback!");
        var params = {pLayer: supportLayer.parentLayer};
        supportLayer.backToHome(params);
    },

    wasNotHelpful: function (issueTag) {
        if (issueTag == undefined) {
            issueTag = supportLayer.issueTag;
        }
        var nodeIdArr = issueTag.split(":");
        // trackObj.trackCounter(constantsObj.TRACK_HELP_CENTER, gameObj.getViewingBucket(), gameObj.getViewingPuzIdInBucket(), nodeIdArr[0], nodeIdArr[1], "help", gameObj.getViewingLevel() + "," + gameObj.getViewingPuzNumber(), "", "");
        utilObj.showMessage("Please let us know what are you looking for!!");
        supportLayer.sendMail(issueTag);
    },

    popFrom: function (arr) {
        if (arr.length > 0) {
            arr.length -= 1;
        }
    },

    topOf: function (arr) {
        if (arr.length > 0) {
            return arr[arr.length - 1];
        }
        return null;
    },

    doNothing: function (nodeid) {

    },

    openPrivacyLink: function () {
        utilObj.openUrl(constantsObj.PLAY_SIMPLE_PRIVACY_URL);
    },

    sendMail: function (issueTag) {
        // processing can be done here
        // loggerObj.debugLog("send mail called");
        supportLayer.issueTag = issueTag;
        var title = supportLayer.supportDict[issueTag][KEY_TITLE];
        // utilObj.contactUs(issueTag, title);

        // EXPERIMENT CHECK HERE
        // supportLayer.hide();
        // mailSupportLayer.show(title, supportLayer.parentLayer, supportLayer.nodesTraversed);
        utilObj.contactUs(issueTag);
    },

    getRectangle: function (start, end, fill, width, lineColor) {
        var rect = new cc.DrawNode();
        rect.drawRect(start, end, fill, width, lineColor);
        return rect;
    },

    selectedItemEvent: function (listElementNum, touchEndX) {
        // loggerObj.debugLog("Callback received:", listElementNum, touchEndX);
    }
});
