var transOutroLayer = cc.Layer.extend({
    screen: null,
    screenName: null,
    puzzleId: 0,
    eligibleForThemeQuest: false,
    tqStarsAchieved: 0,
    tqFinalMasteryEarned: 0,
    tqTotalStars: 0,
    eligibleForWeeklyQuest: false,
    wqStarsAchieved: 0,
    wqFinalMasteryEarned: 0,
    wqTotalStars: 0,
    parmsForShare: null,
    animRunning: false,
    isDailyMiniPuzzle: false,

    hide: function () {
        transOutroLayer.stopAllActions();
        transOutroLayer.removeAllChildren();
        utilObj.setVisible(transOutroLayer, false);
    },

    show: function (withAnim, params) {
        transOutroLayer.screen = constantsObj.SCREEN_OUTRO_LAYER;
        transOutroLayer.screenName = utilObj.getScreenName(constantsObj.SCREEN_OUTRO_LAYER);
        // utilObj.updateScreenBegin(transOutroLayer.screen);
        utilObj.setVisible(transOutroLayer, true);

        gameObj.setisReview(true);
        gameObj.setIsOutroTransLayerOn(true);
        utilObj.hideBannerAd(utilObj.getScreenName(constantsObj.SCREEN_OUTRO_LAYER));
        var spriteArr = [];
        var labelArr = [];
        var timeTaken = params.timeElapsed;
        var replay = params.replay;
        var zOrder = constantsObj.UI_Z_ORDER;
        transOutroLayer.puzzleId = gameObj.getCrosswordToShow();
        var mastery = scoresObj.getMastery(transOutroLayer.puzzleId);
        if (gameObj.getD0Id() == transOutroLayer.puzzleId) {
            transOutroLayer.puzzleId = gameObj.getInstallDay();
            var todaysDate = gameObj.getTodaysPuzzleDate();
            var todaysId = utilObj.getIdForDate(todaysDate);
            var puzzleDate = utilObj.getDateForId(todaysId);
            var puzzleMonth = puzzleDate.getMonth();
            if (mastery == constantsObj.MASTERY_GOLD) {
                gameObj.setThreeStarsInMonth(puzzleMonth);
            }
        }
        var isMiniOrMidi = gameObj.checkForMiniOrMidi(transOutroLayer.puzzleId);
        var isDailyMini = gameObj.checkForDailyMini(transOutroLayer.puzzleId);
        var isBritMini = gameObj.checkForBritMini(transOutroLayer.puzzleId);
        var xPos = centerXPos;
        var yPos = centerYPos;
        var animDelay = 0;
        transOutroLayer.parmsForShare = {timetaken: timeTaken};
        transOutroLayer.animRunning = true;
        var toShowQuestLLPUi = false;
        var experimentWQUI = gameObj.getExpNewWeeklyQuestVariant();
        if(experimentWQUI != constantsObj.EXP_VAR_CONTROL) {
            toShowQuestLLPUi = true;
        }
        var isFromMapScreen = gameLayer.isFromMapScreen;
        var info1 = gameObj.getCurPuzzleInfo();
        var info = {};
        var puzzleInfo = 0;
        if (info1 != undefined && info1[0] != undefined) {
            info = info1[0];
        }
        if (info != undefined && info.id != undefined) {
            puzzleInfo = info.id;
        }
        if (gameLayer.crosswordDate == puzzleInfo) {
            isFromMapScreen = true;
        }

        if (!homeObj.getIsMiniPuzzleClicked() && homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            homeObj.setIsMiniPuzzleClicked(true);
        }
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_TRANS_OUTRO_LAYER, constantsObj.TRACK_VIEW, "", "", "", "");

        //black overlay on outro layer
        var transBg = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, 0, 0.5, 0, canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset, spriteArr, transOutroLayer, zOrder, constantsObj.SPRITE_MISC);
        transBg.setColor(constantsObj.COLOR_BLACK);
        transBg.setOpacity(0);

        // fade in animation for black overlay
        animObj.outroAnimations(transOutroLayer, {
            case: constantsObj.OUTRO_OVERLAY_FADEIN,
            node: transBg,
            animDelay: 0.15,
            opacity: constantsObj.OPACITY_85
        });

        var sub_text_rand_arr = [stringsObj.outro_sub_text1_rand1, stringsObj.outro_sub_text1_rand2, stringsObj.outro_sub_text1_rand3];
        var rand_value = utilObj.getRandomIntInRange(0, 2);
        var mainTextImage = constantsObj.exemplary_image;
        var sub_text = sub_text_rand_arr[rand_value];
        var scaleMul = 1;

        // to show the text according to the mastery
        if (mastery != constantsObj.MASTERY_GOLD) {
            sub_text_rand_arr = [stringsObj.outro_sub_text2_rand1, stringsObj.outro_sub_text2_rand2, stringsObj.outro_sub_text2_rand3];
            mainTextImage = constantsObj.amazing_image;
            sub_text = sub_text_rand_arr[rand_value];
            scaleMul = 1;
        }

        // 1st animation for gratification
        var showMainText = utilObj.getSprite(mainTextImage, xPos, yPos + 50, 0.5, 0.5, constantsObj.SCALE_SPRITE_3 * scaleMul, spriteArr, transOutroLayer, zOrder + 1, constantsObj.SPRITE_MISC);
        showMainText.setScale(0);
        var showMainTextDelay = 0.2;
        animObj.outroAnimations(transOutroLayer, {
            case: constantsObj.OUTRO_MAIN_TEXT,
            node: showMainText,
            animDelay: animDelay,
            scale: constantsObj.SCALE_SPRITE_3 * scaleMul,
            delay: showMainTextDelay
        });
        utilObj.delayedCallback(transOutroLayer, transOutroLayer.trackingParams, animDelay, {
            node: showMainText,
            txt: "textgratif_outro"
        });

        var showSubtext = utilObj.getBMFontLabel(sub_text, constantsObj.FONT_HELVETICA_75, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - 150, 0.5, 0.5, labelArr, transOutroLayer, zOrder + 1);
        showSubtext.setOpacity(0);
        animObj.outroAnimations(transOutroLayer, {
            case: constantsObj.OUTRO_SUB_TEXT,
            node: showSubtext,
            animDelay: animDelay,
            delay: showMainTextDelay,
            opacity: constantsObj.OPACITY_100
        });
        animDelay += showMainTextDelay;

        var params1 = {
            case: constantsObj.OUTRO_CONFETTI_PLIST1,
            animDelay: animDelay - (showMainTextDelay / 2),
            x: xLeftPos - 100,
            y: yPos - 400,
            layer: transOutroLayer,
            scale: 1,
            zOrder: zOrder + 1,
            angle: 65,
        };
        animObj.outroAnimations(transOutroLayer, params1);

        var params2 = {
            case: constantsObj.OUTRO_CONFETTI_PLIST2,
            animDelay: animDelay - (showMainTextDelay / 2),
            x: xRightPos + 100,
            y: yPos - 400,
            layer: transOutroLayer,
            scale: 1,
            zOrder: zOrder + 1,
            angle: 115,
        };
        animObj.outroAnimations(transOutroLayer, params2);
        animDelay += 3.0;

        //scaling down first text here
        animObj.outroAnimations(transOutroLayer, {
            case: constantsObj.OUTRO_MAIN_TEXT_FADE_OUT,
            node: showMainText,
            animDelay: animDelay,
            scale: constantsObj.SCALE_SPRITE_3,
            delay: showMainTextDelay
        });

        animObj.outroAnimations(transOutroLayer, {
            case: constantsObj.OUTRO_SUB_TEXT_FADE_OUT,
            node: showSubtext,
            animDelay: animDelay,
            delay: showMainTextDelay
        });

        animDelay += showMainTextDelay;


        //after 1st animation completed
        animDelay += 0.1;
        var arrForSecondAnim = [];
        yPos = centerYPos + 900;
        var localYPos = yPos;
        var star1 = utilObj.getSprite(constantsObj.star_white_2, xPos - 350, yPos - 70, 0.5, 0.5, constantsObj.SCALE_SPRITE_21, spriteArr, transOutroLayer, zOrder + 1, constantsObj.SPRITE_MISC);
        star1.setColor(constantsObj.COLOR_MASTERY_OUTRO);
        star1.setRotation(-30);
        arrForSecondAnim.push(star1);

        var star2 = utilObj.getSprite(constantsObj.star_white_2, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_21 * 1.25, spriteArr, transOutroLayer, zOrder + 1, constantsObj.SPRITE_MISC);
        star2.setColor(constantsObj.COLOR_MASTERY_OUTRO);
        arrForSecondAnim.push(star2);

        var star3 = utilObj.getSprite(constantsObj.star_white_2, xPos + 350, yPos - 70, 0.5, 0.5, constantsObj.SCALE_SPRITE_21, spriteArr, transOutroLayer, zOrder + 1, constantsObj.SPRITE_MISC);
        star3.setColor(constantsObj.COLOR_MASTERY_OUTRO);
        star3.setRotation(30);
        arrForSecondAnim.push(star3);


        yPos -= 350;
        var yourTime = utilObj.getBMFontLabel("Your time", constantsObj.FONT_HELVETICA_75, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, transOutroLayer, zOrder + 1);
        arrForSecondAnim.push(yourTime);

        yPos -= 150;
        var timerText;
        var score = timeTaken;
        if (score) {
            timerText = utilObj.formatTime(score);
        } else {
            timerText = "--:--";
        }

        var timerIcon = utilObj.getSprite(constantsObj.timer_icon, xPos - 120, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_3 * 1.15);
        utilObj.addChild(transOutroLayer, timerIcon, zOrder + 1);
        arrForSecondAnim.push(timerIcon);
        var timerValue = utilObj.getBMFontLabel(timerText, constantsObj.FONT_HELVETICA_75, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 70, yPos, 0.5, 0.5, labelArr, transOutroLayer, zOrder + 1);
        arrForSecondAnim.push(timerValue);

        //home anim condition
        transOutroLayer.isDailyMiniPuzzle = false;
        if(isDailyMini) {
            transOutroLayer.isDailyMiniPuzzle = true;
            var dailyMinPuzzleId = gameObj.getIdForTodaysPuzzle();
            dailyMinPuzzleId = stringsObj.mini_prefix + dailyMinPuzzleId.substr(2, dailyMinPuzzleId.length);
            if (dailyMinPuzzleId == transOutroLayer.puzzleId) {
                gameObj.setCompletedTodayMini(true);
            }
        } else if (transOutroLayer.puzzleId == gameObj.getD0Id() || transOutroLayer.puzzleId == gameObj.getIdForTodaysPuzzle()) {
            gameObj.setCompletedTodayMain(true);
        }

        var crosswordCompletionReward = economyObj.getCrosswordCompletionReward();
        if (isMiniOrMidi) {
            crosswordCompletionReward = 0;
        }
        if (isDailyMini) {
            crosswordCompletionReward = economyObj.getDailyMiniCompletionReward();
        }
        if (crosswordCompletionReward != 0) {
            yPos -= 250;
            var coinIcon = utilObj.getSprite(constantsObj.coin_png_2, xPos - 80, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_11);
            utilObj.addChild(transOutroLayer, coinIcon, zOrder + 1);
            arrForSecondAnim.push(coinIcon);
            var coinValue = utilObj.getBMFontLabel(crosswordCompletionReward, constantsObj.FONT_HELVETICA_75, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 70, yPos, 0.5, 0.5, labelArr, transOutroLayer, zOrder + 1);
            arrForSecondAnim.push(coinValue);
        }

        var checkCollectibleCondition = transOutroLayer.collectiblesForThemeQuest(mastery);
        var tqMastery = null;
        var tqMasteryValue = 0;
        if (checkCollectibleCondition && (!toShowQuestLLPUi)) {
            yPos -= 250;
            var themedQuestMasteryIcon = utilObj.getSprite(constantsObj.themed_quest_progress_icon_2, xPos - 80, yPos, 0.5, 0.5, constantsObj.SCALE_ONE * 1.25);
            arrForSecondAnim.push(themedQuestMasteryIcon);
            utilObj.addChild(transOutroLayer, themedQuestMasteryIcon, zOrder + 1);
            tqMasteryValue = mastery - transOutroLayer.tqFinalMasteryEarned;
            var masteryInitial = tqMasteryValue;
            tqMastery = utilObj.getBMFontLabel(masteryInitial, constantsObj.FONT_HELVETICA_75, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 70, yPos, 0.5, 0.5, labelArr, transOutroLayer, zOrder + 1);
            var actions = [];
            var callFunc;
            var delay;
            var p = {
                lbl: tqMastery,
                score: (masteryInitial)
            };
            callFunc = utilObj.getCallFunc(transOutroLayer.updateScoreLbl, transOutroLayer, p);
            delay = animObj.getDelayTime(0);
            actions.push(delay);
            actions.push(callFunc);
            var seq = animObj.getSequence(actions, false);
            tqMastery.runAction(seq);
            arrForSecondAnim.push(tqMastery);
        }

        //fade in top part
        var fadeInTopPartDelay = 0.3;
        animObj.outroAnimations(transOutroLayer, {
            case: constantsObj.OUTRO_FADE_IN_TOP_PART,
            node: arrForSecondAnim,
            animDelay: animDelay,
            delay: fadeInTopPartDelay
        });
        animDelay += fadeInTopPartDelay;

        var starAnimArr = [];
        var starAnim1 = utilObj.getSprite(constantsObj.star_white_2, xPos - 350, localYPos - 70, 0.5, 0.5, constantsObj.SCALE_SPRITE_21 * 5, spriteArr, transOutroLayer, zOrder + 1, constantsObj.SPRITE_MISC);
        starAnim1.setColor(constantsObj.COLOR_BLUE_01);
        starAnim1.setRotation(-30);
        starAnimArr.push(starAnim1);
        arrForSecondAnim.push(starAnim1);

        if (mastery >= constantsObj.MASTERY_SILVER) {
            var starAnim2 = utilObj.getSprite(constantsObj.star_white_2, xPos, localYPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_21 * 1.25 * 5, spriteArr, transOutroLayer, zOrder + 1, constantsObj.SPRITE_MISC);
            starAnim2.setColor(constantsObj.COLOR_BLUE_01);
            starAnimArr.push(starAnim2);
            arrForSecondAnim.push(starAnim2);
        }

        if (mastery >= constantsObj.MASTERY_GOLD) {
            var starAnim3 = utilObj.getSprite(constantsObj.star_white_2, xPos + 350, localYPos - 70, 0.5, 0.5, constantsObj.SCALE_SPRITE_21 * 5, spriteArr, transOutroLayer, zOrder + 1, constantsObj.SPRITE_MISC);
            starAnim3.setColor(constantsObj.COLOR_BLUE_01);
            starAnim3.setRotation(30);
            starAnimArr.push(starAnim3);
            arrForSecondAnim.push(starAnim3);
        }
        var initDelayTime = 0;

        //Mastery anim started
        for (var i = 0; i < starAnimArr.length; i++) {
            starAnimArr[i].setOpacity(0);
            var masteryAnimScaleTime = 0.3;
            var stopDelay = 0.1;
            animObj.outroAnimations(transOutroLayer, {
                case: constantsObj.OUTRO_MASTERY_ANIM,
                node: starAnimArr[i],
                animDelay: animDelay,
                animTime: masteryAnimScaleTime,
                initDelayTime: initDelayTime,
                stopDelay: stopDelay,
                xPos: xPos,
                yPos: localYPos,
                zOrder: zOrder,
                index: i,
                collectible: tqMastery,
                mastery: tqMasteryValue
            });
            initDelayTime += 0.3 + stopDelay + 0.1;
        }
        if (starAnimArr.length >= 1) {
            utilObj.delayedCallback(transOutroLayer, transOutroLayer.trackingParams, animDelay, {
                node: starAnimArr[0],
                txt: "starsearned_outro"
            });
        }
        var plistAnim = 0.2;
        initDelayTime += 0.1 + plistAnim / 2;
        var animDelayForTq = animDelay;
        animDelay += initDelayTime;

        var arrForBelowInfo = [];
        var arrOpacityForBelowInfo = [];

        yPos = centerYPos - constantsObj.BOTTOM_BAR_OFFSET1;
        var eligibleForQuest = transOutroLayer.questAvailability(mastery);
        var tileHeight = 0;
        var tileWidth = 0;
        if (eligibleForQuest && (!toShowQuestLLPUi || (toShowQuestLLPUi && isFromMapScreen))) {
            tileHeight = 350;
            tileWidth = 1230;
            var questAnimArr = [];
            var questTile = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, xPos, yPos - 750, 0.5, 0.5, tileWidth, tileHeight, spriteArr, transOutroLayer, zOrder, constantsObj.SPRITE_MISC);
            questTile.setColor(constantsObj.COLOR_OUTRO_QUEST_TILE);
            questTile.setOpacity(constantsObj.OPACITY_70);
            questAnimArr.push(questTile);

            if (transOutroLayer.eligibleForThemeQuest) {
                var themedQuestData = themedQuestObj.getThemedQuestData();
                var mileStones1 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(0));
                var mileStones2 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(1));
                var mileStones3 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(2));
                var starsText = [mileStones1, mileStones2, mileStones3];
                var collectibleDesc = "Collect " + themedQuestData["TQCollectible"] + ". Win rewards!!";
                if (toShowQuestLLPUi) {
                    collectibleDesc = "Solve puzzles, win epic rewards!";
                }

                var collectibleText = utilObj.getBMFontLabel(collectibleDesc, constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), tileWidth / 2, 300, 0.5, 0.5, labelArr, questTile, zOrder + 1);
                questAnimArr.push(collectibleText);

                var progressBarBg = utilObj.getScale9Sprite(constantsObj.full_bar, 155, 160, 0, 0.5, 840, 30, null, questTile, zOrder + 1, constantsObj.SPRITE_MISC);
                progressBarBg.setColor(constantsObj.COLOR_BLACK);
                progressBarBg.setOpacity(constantsObj.OPACITY_30);
                utilObj.addChild(questTile, progressBarBg, zOrder + 1);
                questAnimArr.push(progressBarBg);

                if (toShowQuestLLPUi) {
                    var completedArray = gameObj.getPuzzlesCompletedArray();
                    transOutroLayer.tqStarsAchieved = 0;
                    for (var i in completedArray) {
                        if (completedArray[i]["completed"]) {
                            transOutroLayer.tqStarsAchieved += 1;
                        }
                    }
                    transOutroLayer.tqTotalStars = questMapObj.getTotalPuzzles();
                    transOutroLayer.tqFinalMasteryEarned = 1;
                    var milestonesCompleted = gameObj.getThemedQuestMilestonesCompleted();
                    if (milestonesCompleted == null) {
                        milestonesCompleted = [0, 0, 0];
                        gameObj.setThemedQuestMilestonesCompleted(milestonesCompleted);
                        gameObj.setThemedQuestCompleted(false);
                    }
                    var mileInfo = questMapObj.getMilestoneInfoForQuest();
                    var milestones = [mileInfo["0"]["index"], mileInfo["1"]["index"], mileInfo["2"]["index"]];
                    starsText = [milestones[0], milestones[1], milestones[2]];
                }

                var len = ((transOutroLayer.tqStarsAchieved - transOutroLayer.tqFinalMasteryEarned) / transOutroLayer.tqTotalStars) * 840;
                var finalLen = 0;
                var starInfo = -1;
                var starXPos = 0;
                if (len == 0) {
                    finalLen = (1 / transOutroLayer.tqTotalStars) * 840;
                }
                if (toShowQuestLLPUi) {
                    finalLen = (0.1 / transOutroLayer.tqTotalStars) * 840;
                }
                var progressBar = utilObj.getScale9Sprite(constantsObj.full_bar, 155, 160, 0, 0.5, len + finalLen, 30, null, questTile, zOrder, constantsObj.SPRITE_MISC);
                progressBar.setColor(homeObj.getColorFromStringCode(themedQuestData["PBbarfillcolorcode"]));
                utilObj.addChild(questTile, progressBar, zOrder + 1);
                questAnimArr.push(progressBar);

                var tqGiftsArr = [constantsObj.tq_gift1, constantsObj.tq_gift2, constantsObj.tq_gift3];
                var tqOpenGiftsArr = [constantsObj.tq_gift_open1, constantsObj.tq_gift_open2, constantsObj.tq_gift_open3];
                var scalingArr = [constantsObj.SCALE_ONE * 1.08, constantsObj.SCALE_ONE * 1.08, constantsObj.SCALE_ONE * 1.08];
                var giftBoxAnim = null;
                for (var i = 1; i <= 3; i++) {
                    if (transOutroLayer.tqStarsAchieved - transOutroLayer.tqFinalMasteryEarned >= starsText[i - 1]) {
                        var progressBarIconStart2 = utilObj.getSprite(tqOpenGiftsArr[i - 1], 155 + (starsText[i - 1] / transOutroLayer.tqTotalStars) * 840, 130, 0.5, 0.5, scalingArr[i - 1], null, transOutroLayer, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
                        var positionParams = utilObj.getSpriteDimensions(progressBarIconStart2);
                        var nodeCoordinates = utilObj.getSpriteCoordinates(progressBarIconStart2);
                        utilObj.setPosition(progressBarIconStart2, nodeCoordinates.xPos, nodeCoordinates.yPos + (positionParams.height / 2));
                        utilObj.addChild(questTile, progressBarIconStart2, zOrder + 1);
                        questAnimArr.push(progressBarIconStart2);
                        var tickIcon = utilObj.getSprite(constantsObj.tick, 155 + (starsText[i - 1] / transOutroLayer.tqTotalStars) * 840, 240, 0.5, 0.5, constantsObj.SCALE_SPRITE_18 * 1.25, null, questTile, zOrder, constantsObj.SPRITE_MISC);
                        tickIcon.setColor(constantsObj.COLOR_THEME_QUEST_TICK);
                        utilObj.addChild(questTile, tickIcon, zOrder);
                        questAnimArr.push(tickIcon);
                    } else {
                        var progressBarIconStart2 = utilObj.getSprite(tqGiftsArr[i - 1], 155 + (starsText[i - 1] / transOutroLayer.tqTotalStars) * 840, 130, 0.5, 0.5, scalingArr[i - 1], null, transOutroLayer, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
                        var positionParams = utilObj.getSpriteDimensions(progressBarIconStart2);
                        var nodeCoordinates = utilObj.getSpriteCoordinates(progressBarIconStart2);
                        utilObj.setPosition(progressBarIconStart2, nodeCoordinates.xPos, nodeCoordinates.yPos + (positionParams.height / 2));
                        utilObj.addChild(questTile, progressBarIconStart2, zOrder + 1);
                        if (transOutroLayer.tqStarsAchieved >= starsText[i - 1] && transOutroLayer.tqStarsAchieved - transOutroLayer.tqFinalMasteryEarned < starsText[i - 1]) {
                            giftBoxAnim = progressBarIconStart2;
                        }
                        questAnimArr.push(progressBarIconStart2);
                    }
                    if ((transOutroLayer.tqStarsAchieved < starsText[i - 1] && starInfo == -1) || (i == 3 && transOutroLayer.tqStarsAchieved <= starsText[i - 1] && starInfo == -1)) {
                        starInfo = starsText[i - 1] - transOutroLayer.tqStarsAchieved;
                        starXPos = starsText[i - 1];
                    }
                }
                var starInfoText = "";
                var yPosShift = 10;
                if (starInfo > 0) {
                    starInfoText = starInfo + " more   " +  "  to go!";
                    if (toShowQuestLLPUi) {
                        starInfoText = starInfo + " more to go!";
                    }
                    if (starInfo > 10) {
                        yPosShift += 20;
                    }
                } else if (starInfo == 0) {
                    starInfoText = "completed!";
                }
                if (starInfoText != "") {
                    var width = 410;
                    var height = 75;
                    if (starInfo == 0) {
                        width = 300;
                    }
                    var tqProgressArr = [];
                    var tqProgressPointer = utilObj.getSprite(constantsObj.themed_quest_progress_pointer, 155 + (starXPos / transOutroLayer.tqTotalStars) * 840, 100, 0.5, 0, constantsObj.SCALE_SPRITE_6, spriteArr, questTile, zOrder + 1, constantsObj.SPRITE_MISC);
                    tqProgressArr.push(tqProgressPointer);
                    tqProgressPointer.setOpacity(0);
                    var tqProgressPointerTile = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, 155 + (starXPos / transOutroLayer.tqTotalStars) * 840, 100 - height / 2, 0.5, 0.5, width, height, spriteArr, questTile, zOrder + 1, constantsObj.SPRITE_MISC);
                    tqProgressPointerTile.setOpacity(0);
                    tqProgressArr.push(tqProgressPointerTile);
                    tqProgressPointerTile.setCascadeOpacityEnabled(true);
                    var tqProgressPointerText = utilObj.getBMFontLabel(starInfoText, constantsObj.FONT_HELVETICA_50, constantsObj.COLOR_BLACK,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), width / 2, height / 2, 0.5, 0.5, labelArr, tqProgressPointerTile, zOrder);
                    if (starInfo > 0 && !toShowQuestLLPUi) {
                        var tqThemeIcon = utilObj.getSprite(constantsObj.themed_quest_progress_icon_2, width / 2 + yPosShift, height / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_8 * 1.2, spriteArr, tqProgressPointerTile, zOrder, constantsObj.SPRITE_MISC);
                    }
                }
                animDelay = transOutroLayer.showTQProgressAnimOnOutro(len + finalLen, transOutroLayer.tqFinalMasteryEarned, progressBar, transOutroLayer.tqStarsAchieved - transOutroLayer.tqFinalMasteryEarned, transOutroLayer.tqTotalStars, (animDelay + 0.1), giftBoxAnim, tqProgressArr);
            } else if (transOutroLayer.eligibleForWeeklyQuest) {
                var mileStones1 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(0));
                var mileStones2 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(1));
                var mileStones3 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(2));
                var starsText = [mileStones1, mileStones2, mileStones3];
                var collectibleDesc = "Collect stars. Win rewards!!";
                if (toShowQuestLLPUi) {
                    collectibleDesc = "Solve puzzles, win epic rewards!";
                }

                var collectibleText = utilObj.getBMFontLabel(collectibleDesc, constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), tileWidth / 2, 320, 0.5, 0.5, labelArr, questTile, zOrder);
                questAnimArr.push(collectibleText);

                var progressBarBg = utilObj.getScale9Sprite(constantsObj.full_bar, 155, 160, 0, 0.5, 840, 30, null, questTile, zOrder, constantsObj.SPRITE_MISC);
                progressBarBg.setColor(constantsObj.COLOR_BLACK);
                progressBarBg.setOpacity(constantsObj.OPACITY_30);
                utilObj.addChild(questTile, progressBarBg, zOrder);
                questAnimArr.push(progressBarBg);

                if (toShowQuestLLPUi) {
                    var completedArray = gameObj.getPuzzlesCompletedArray();
                    transOutroLayer.wqStarsAchieved = 0;
                    for (var i in completedArray) {
                        if (completedArray[i]["completed"]) {
                            transOutroLayer.wqStarsAchieved += 1;
                        }
                    }
                    transOutroLayer.wqTotalStars = questMapObj.getTotalPuzzles();
                    transOutroLayer.wqFinalMasteryEarned = 1;
                    var milestonesCompleted = gameObj.getWeeklyQuestMilestonesCompleted();
                    if (milestonesCompleted == null) {
                        milestonesCompleted = [0, 0, 0];
                        gameObj.setWeeklyQuestMilestonesCompleted(milestonesCompleted);
                        gameObj.setWeeklyQuestCompleted(false);
                    }
                    var mileInfo = questMapObj.getMilestoneInfoForQuest();
                    var milestones = [mileInfo["0"]["index"], mileInfo["1"]["index"], mileInfo["2"]["index"]];
                    starsText = [milestones[0], milestones[1], milestones[2]];
                }

                var len = ((transOutroLayer.wqStarsAchieved - transOutroLayer.wqFinalMasteryEarned) / transOutroLayer.wqTotalStars) * 840;
                var finalLen = 0;
                var starInfo = -1;
                var starXPos = 0;
                if (len == 0) {
                    finalLen = (1 / transOutroLayer.wqTotalStars) * 840;
                }
                if (toShowQuestLLPUi) {
                    finalLen = (0.1 / transOutroLayer.wqTotalStars) * 840;
                }
                var progressBar = utilObj.getScale9Sprite(constantsObj.full_bar, 155, 160, 0, 0.5, len + finalLen, 30, null, questTile, zOrder, constantsObj.SPRITE_MISC);
                progressBar.setColor(constantsObj.COLOR_SKY_BLUE_03);
                utilObj.addChild(questTile, progressBar, zOrder);
                questAnimArr.push(progressBar);

                var wqGiftsArr = [constantsObj.tq_gift1, constantsObj.tq_gift2, constantsObj.tq_gift3];
                var wqOpenGiftsArr = [constantsObj.tq_gift_open1, constantsObj.tq_gift_open2, constantsObj.tq_gift_open3];
                var scalingArr = [constantsObj.SCALE_ONE * 1.08, constantsObj.SCALE_ONE * 1.15, constantsObj.SCALE_ONE * 1.25];
                var giftBoxAnim = null;
                for (var i = 1; i <= 3; i++) {
                    if (transOutroLayer.wqStarsAchieved < starsText[i-1]) {
                        var progressBarIconStart2 = utilObj.getSprite(wqGiftsArr[i - 1], 155 + (starsText[i - 1] / transOutroLayer.wqTotalStars) * 840, 130, 0.5, 0.5, scalingArr[i - 1], null, questTile, zOrder, constantsObj.SPRITE_MISC);
                        var positionParams = utilObj.getSpriteDimensions(progressBarIconStart2);
                        var nodeCoordinates = utilObj.getSpriteCoordinates(progressBarIconStart2);
                        utilObj.setPosition(progressBarIconStart2, nodeCoordinates.xPos, nodeCoordinates.yPos + (positionParams.height / 2));
                        utilObj.addChild(questTile, progressBarIconStart2, zOrder);
                        questAnimArr.push(progressBarIconStart2);
                        if ((transOutroLayer.wqStarsAchieved < starsText[i - 1] && starInfo == -1) || (i == 3 && transOutroLayer.tqStarsAchieved <= starsText[i - 1] && starInfo == -1)) {
                            starInfo = starsText[i - 1] - transOutroLayer.wqStarsAchieved;
                            starXPos = starsText[i - 1];
                        }
                    } else {
                        var progressBarIconStart2 = utilObj.getSprite(wqOpenGiftsArr[i - 1], 155 + (starsText[i - 1] / transOutroLayer.wqTotalStars) * 840, 130, 0.5, 0.5, scalingArr[i - 1], null, questTile, zOrder, constantsObj.SPRITE_MISC);
                        var positionParams = utilObj.getSpriteDimensions(progressBarIconStart2);
                        var nodeCoordinates = utilObj.getSpriteCoordinates(progressBarIconStart2);
                        utilObj.setPosition(progressBarIconStart2, nodeCoordinates.xPos, nodeCoordinates.yPos + (positionParams.height / 2));
                        utilObj.addChild(questTile, progressBarIconStart2, zOrder);
                        questAnimArr.push(progressBarIconStart2);
                        var tickIcon = utilObj.getSprite(constantsObj.tick, 155 + 20 + (starsText[i - 1] / transOutroLayer.wqTotalStars) * 840, 240, 0.5, 0.5, constantsObj.SCALE_SPRITE_18 * 1.25, null, questTile, zOrder, constantsObj.SPRITE_MISC);
                        tickIcon.setColor(constantsObj.COLOR_BLUE_01);
                        utilObj.addChild(questTile, tickIcon, zOrder);
                        questAnimArr.push(tickIcon);
                        if (transOutroLayer.wqStarsAchieved >= starsText[i - 1] && transOutroLayer.wqStarsAchieved - transOutroLayer.wqFinalMasteryEarned < starsText[i - 1]) {
                            giftBoxAnim = progressBarIconStart2;
                        }
                    }
                }
                var starInfoText = "";
                var yPosShift = 10;
                if (starInfo > 0) {
                    starInfoText = starInfo + " more   " + "  to go!";
                    if (toShowQuestLLPUi) {
                        starInfoText = starInfo + " more to go!";
                    }
                    if (starInfo > 10) {
                        yPosShift += 20;
                    }
                } else if (starInfo == 0) {
                    starInfoText = "completed!";
                }
                if (starInfoText != "") {
                    var width = 410;
                    var height = 75;
                    if (starInfo == 0) {
                        width = 300;
                    }
                    var wqProgressArr = [];
                    var wqProgressPointer = utilObj.getSprite(constantsObj.themed_quest_progress_pointer, 155 + (starXPos / transOutroLayer.wqTotalStars) * 840, 100, 0.5, 0, constantsObj.SCALE_SPRITE_6, spriteArr, questTile, zOrder, constantsObj.SPRITE_MISC);
                    wqProgressPointer.setOpacity(0);
                    wqProgressArr.push(wqProgressPointer);
                    var wqProgressPointerTile = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, 155 + (starXPos / transOutroLayer.wqTotalStars) * 840, 100 - height / 2, 0.5, 0.5, width, height, spriteArr, questTile, zOrder, constantsObj.SPRITE_MISC);
                    wqProgressPointerTile.setOpacity(0);
                    wqProgressArr.push(wqProgressPointerTile);
                    wqProgressPointerTile.setCascadeOpacityEnabled(true);
                    var wqProgressPointerText = utilObj.getBMFontLabel(starInfoText, constantsObj.FONT_HELVETICA_50, constantsObj.COLOR_BLACK,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), width / 2, height / 2, 0.5, 0.5, labelArr, wqProgressPointerTile, zOrder);
                    if (starInfo > 0 && !toShowQuestLLPUi) {
                        var wqThemeIcon = utilObj.getSprite(constantsObj.star_white_2, width / 2 + yPosShift, height / 2 + 5, 0.5, 0.5, constantsObj.SCALE_SPRITE_18, spriteArr, wqProgressPointerTile, zOrder, constantsObj.SPRITE_MISC);
                        wqThemeIcon.setColor(constantsObj.COLOR_BLUE_01);
                    }
                }
                animDelay = transOutroLayer.showTQProgressAnimOnOutro(len + finalLen, transOutroLayer.wqFinalMasteryEarned, progressBar, transOutroLayer.wqStarsAchieved - transOutroLayer.wqFinalMasteryEarned, transOutroLayer.wqTotalStars, (animDelay + 0.1), giftBoxAnim, wqProgressArr);
            }
            //quest anim to appear
            var questOpacity = constantsObj.OPACITY_100;

            for (var i = 0; i < questAnimArr.length; i++) {
                questAnimArr[i].setOpacity(0);
                if (questAnimArr[i] == questTile) {
                    questOpacity = constantsObj.OPACITY_70;
                }
                if (questAnimArr[i] == progressBarBg) {
                    questOpacity = constantsObj.OPACITY_100;
                }
                if (questAnimArr[i] == collectibleText) {
                    questOpacity = constantsObj.OPACITY_90;
                }
                animObj.outroAnimations(transOutroLayer, {
                    case: constantsObj.OUTRO_QUEST_FADE_IN_ANIM,
                    node: questAnimArr[i],
                    animDelay: animDelayForTq,
                    opacity: questOpacity
                });
            }
        } else {
            // here one nested if-else can be inserted to check whether to put new ui with button or go with the same ui below.
            // a function should check whether new ui with button is required or nor to put that condition in nested if-else.
            tileHeight = 350;
            var date = utilObj.getDateForId(transOutroLayer.puzzleId);
            var weekDay = date.getDay();
            var text = "";
            if (isMiniOrMidi && isDailyMini) {
                var archiveId = gameObj.convertDailyMiniIdToArchive(transOutroLayer.puzzleId);
                var dailyMiniDateForId = utilObj.getDateForId(archiveId);
                text = stringsObj.Daily_mini + " | " + utilObj.getFormattedDate(dailyMiniDateForId);
            } else if (isMiniOrMidi){
                if (isBritMini) {
                    var packId = gameObj.getPackIdFromPuzzleId(transOutroLayer.puzzleId);
                    var totalPuzzles = gameObj.getTotalPuzzle(packId, constantsObj.BRITISH_PACKS);
                    var puzzleNumber = parseInt(transOutroLayer.puzzleId) % 100;
                    var themePackName = stringsObj.puzzle_themes_brit_pack_Info[packId];
                    text = stringsObj.puzzle_themes_brit_pack_info_1 + " | " + "Puzzle " + puzzleNumber + " of " + totalPuzzles;
                } else {
                    var packId = gameObj.getPackIdFromPuzzleId(transOutroLayer.puzzleId);
                    var totalPuzzles = gameObj.getTotalPuzzle(packId);
                    var puzzleNumber = parseInt(transOutroLayer.puzzleId) % 100;
                    var themePackName = stringsObj.puzzle_themes_pack_Info[packId];
                    if (packId == 35) {
                        themePackName = stringsObj.puzzle_themes_pack_Info_35;
                    } else if (packId == 36) {
                        themePackName = stringsObj.puzzle_themes_pack_Info_36;
                    } else if (packId == 38) {
                        themePackName = stringsObj.puzzle_themes_pack_info_38;
                    } else if (packId == 39) {
                        themePackName = stringsObj.puzzle_themes_pack_info_39;
                    }
                    text = themePackName + " | " + "Puzzle " + puzzleNumber + " of " + totalPuzzles;
                }
            } else {
                text = stringsObj.puzzle_themes[weekDay] + " | " + utilObj.getFormattedDate(date);
            }

            var themeText = utilObj.getBMFontLabel(text, constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - 600, 0.5, 0.5, labelArr, transOutroLayer, zOrder + 1);
            arrForBelowInfo.push(themeText);
            arrOpacityForBelowInfo.push(constantsObj.OPACITY_100);

            var starColor = constantsObj.COLOR_BLUE_01;
            var starValue1 = utilObj.getSprite(constantsObj.star_white_2, xPos - 200, yPos - 600 - 125, 0.5, 0.5, constantsObj.SCALE_SPRITE_3, spriteArr, transOutroLayer, zOrder + 1, constantsObj.SPRITE_MISC);
            starValue1.setColor(starColor);
            // starValue1.setRotation(-30);
            arrForBelowInfo.push(starValue1);
            arrOpacityForBelowInfo.push(constantsObj.OPACITY_100);

            if (mastery < constantsObj.MASTERY_SILVER) {
                starColor = constantsObj.COLOR_MASTERY_OUTRO;
            }
            var starValue2 = utilObj.getSprite(constantsObj.star_white_2, xPos, yPos - 600 - 125, 0.5, 0.5, constantsObj.SCALE_SPRITE_3, spriteArr, transOutroLayer, zOrder + 1, constantsObj.SPRITE_MISC);
            starValue2.setColor(starColor);
            arrForBelowInfo.push(starValue2);
            arrOpacityForBelowInfo.push(constantsObj.OPACITY_100);

            if (mastery < constantsObj.MASTERY_GOLD) {
                starColor = constantsObj.COLOR_MASTERY_OUTRO;
            }
            var starValue3 = utilObj.getSprite(constantsObj.star_white_2, xPos + 200, yPos - 600 - 125, 0.5, 0.5, constantsObj.SCALE_SPRITE_3, spriteArr, transOutroLayer, zOrder + 1, constantsObj.SPRITE_MISC);
            starValue3.setColor(starColor);
            // starValue3.setRotation(30);
            arrForBelowInfo.push(starValue3);
            arrOpacityForBelowInfo.push(constantsObj.OPACITY_100);

            var timerText;
            var score = timeTaken;
            if (score) {
                timerText = utilObj.formatTime(score);
            } else {
                timerText = "--:--";
            }

            // checking the presence of play quest button eligibility on outro.
            if(!transOutroLayer.ifPlayQuestOnOutroAvailable()) {
            var timerIcon = utilObj.getSprite(constantsObj.timer_icon, xPos - 100, yPos - 600 - 350, 0.5, 0.5, constantsObj.SCALE_SPRITE_11);
            utilObj.addChild(transOutroLayer, timerIcon, zOrder + 1);
            var timerValue = utilObj.getBMFontLabel(timerText, constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 60, yPos - 600 - 350, 0.5, 0.5, labelArr, transOutroLayer, zOrder + 1);
                arrForBelowInfo.push(timerIcon);
                arrForBelowInfo.push(timerValue);
                arrOpacityForBelowInfo.push(constantsObj.OPACITY_100);
                arrOpacityForBelowInfo.push(constantsObj.OPACITY_100);
            }

        }

        var buttonHeight = 170;
        var buttonWidth = 550;
        yPos -= (750 + tileHeight / 2 + 50 + buttonHeight / 2);

        // ui for  play quest button surfacing on qutro layer only if condition satisties.
        if(transOutroLayer.ifPlayQuestOnOutroAvailable()){
            var now = new Date();
            var year = questMapObj.y2k(now.getYear());
            var month = now.getMonth();
            var date = now.getDate();
            var experiment = gameObj.getExpNewWeeklyQuestVariant();

            var weekNum = questMapObj.getWeek(year, month , date);

            // color start and end
            var color_startUi = questMapObj.getHomeGradientColorStart(year, weekNum, experiment);
            var color_endUi = questMapObj.getHomeGradientColorEnd(year, weekNum, experiment);

            var color_theme = new cc.LayerGradient(color_endUi, color_startUi, null, null);
            var bgWidth = 1358 * canvasWidth/1440;
            var bgHeight = 230 * canvasWidth/1440;

            var yPosition = yPos + 250;
            var wqSectionBg = utilObj.getScale9Sprite(constantsObj.todaySectionHolder, centerXPos, yPosition, 0.5, 1.0, bgWidth ,bgHeight , spriteArr, transOutroLayer, zOrder, constantsObj.SPRITE_MISC);
            if (!utilObj.isWeb()) {
                var stencil = new cc.Scale9Sprite(constantsObj.todaySectionHolder);
                stencil.attr({
                    anchorX: 0.5,
                    anchorY: 1.0,
                    width: bgWidth,
                    height: bgHeight
                });
                utilObj.setPosition(stencil, centerXPos, yPosition );
                var clipperNode = cc.ClippingNode(stencil);
                clipperNode.setAlphaThreshold(0);
                utilObj.setCascadeOpacityEnabled(clipperNode , true);
                transOutroLayer.addChild(clipperNode, zOrder + 1);

                color_theme.anchorX = 0.5;
                color_theme.anchorY = 1.0;
                color_theme.ignoreAnchorPointForPosition(false);
                color_theme.setPositionX(centerXPos);
                color_theme.setPositionY(yPosition);
                color_theme.width = bgWidth;
                color_theme.height = bgHeight;
                color_theme.setVector(new cc.p(1,0));
                clipperNode.addChild(color_theme, zOrder + 1);
                utilObj.setCascadeOpacityEnabled(color_theme , true);
                arrForBelowInfo.push(clipperNode);
                arrOpacityForBelowInfo.push(constantsObj.OPACITY_100);
            }
            utilObj.setColor(wqSectionBg , color_startUi);
            arrForBelowInfo.push(wqSectionBg);
            arrOpacityForBelowInfo.push(constantsObj.OPACITY_100);

            var scaleForThemedImage = constantsObj.SCALE_TWO * 0.4;

            var themeImage = questMapObj.getWeeklyThemeImage(year, weekNum, experiment);
            var theme_icon = utilObj.getSprite(themeImage, 21, bgHeight/2, 0,0.5, scaleForThemedImage, spriteArr, color_theme, zOrder + 1, constantsObj.SPRITE_LOCAL);

            var title = questMapObj.getWeeklyThemeText(year, weekNum, experiment) ;
            var titleLabel = utilObj.getBMFontLabel(title, constantsObj.FONT_HELVETICA_70, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 273 * canvasWidth/1440, 120 * bgHeight/230, 0, 0, labelArr, color_theme, zOrder + 1);

            var awesomeText = utilObj.getBMFontLabel(stringsObj.awesomeText, constantsObj.FONT_HELVETICA_50, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 273 * canvasWidth/1440, 34 * bgHeight/230, 0, 0, labelArr, color_theme, zOrder + 1);

            var playButton = utilObj.getScale9Sprite(constantsObj.button_outline_3, 993 * canvasWidth/1440, bgHeight/2, 0 ,0.5, 325 * canvasWidth/1440 , 134 * bgHeight/230, spriteArr, color_theme, zOrder + 1, constantsObj.SPRITE_MISC);

            var playText = utilObj.getBMFontLabel("PLAY", constantsObj.FONT_HELVETICA_MEDIUM_80, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), (325 * canvasWidth/1440)/2 , (134 * bgHeight/230)/2, 0.5, 0.5, labelArr, playButton, zOrder + 1);
            arrForBelowInfo.push(playText);
            arrOpacityForBelowInfo.push(constantsObj.OPACITY_100);

            var alphaLayerChild = uiCreatorObj.addAlphaLayerChild(wqSectionBg, clipperNode, zOrder + 10, spriteArr);
            var childArr = [alphaLayerChild];

            var transButtonPlay = utilObj.getButton(bgWidth, bgHeight, 0.5, 1.0, centerXPos, yPosition,
                constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: 'transOutroLayer',
                    fn: 'playQuest',
                    screen: gameLayer.screen,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: gameObj.getTrackingPuzzleTheme(),
                        o: constantsObj.TRACK_TRANS_OUTRO_LAYER,
                        f: constantsObj.TRACK_QUEST,
                        g: "1",
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                    child : childArr,
                    feedBackType : constantsObj.DARKEN_FEEDBACK_BOUNDED_PREADDED_CHILD,
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            utilObj.addChild(transOutroLayer, transButtonPlay, zOrder + 1);
            arrForBelowInfo.push(transButtonPlay);
            arrOpacityForBelowInfo.push(constantsObj.OPACITY_100);

            var noThanksOutline = utilObj.getScale9Sprite(constantsObj.button_outline_3, centerXPos, yPosition - bgHeight - 41, 0.5 ,1.0, 410 , 120, spriteArr, transOutroLayer, zOrder + 1, constantsObj.SPRITE_MISC);
            arrForBelowInfo.push(noThanksOutline);
            arrOpacityForBelowInfo.push(constantsObj.OPACITY_50);


            var transButtonNoThanks = utilObj.getButton(410, 120, 0.5, 1.0, centerXPos, yPosition - bgHeight - 41,
                constantsObj.tile_white_curved, constantsObj.tile_white_curved, constantsObj.tile_white_curved, {
                    obj: 'transOutroLayer',
                    fn: 'noThanks',
                    screen: gameLayer.screen,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: gameObj.getTrackingPuzzleTheme(),
                        o: constantsObj.TRACK_TRANS_OUTRO_LAYER,
                        f: constantsObj.TRACK_NEXT,
                        g: "1",
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                    child : [noThanksOutline],
                    feedBackType : constantsObj.GREY_EFFECT,
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            utilObj.addChild(transOutroLayer, transButtonNoThanks, zOrder + 1);
            utilObj.setColor(transButtonNoThanks , constantsObj.COLOR_BLACK);
            arrForBelowInfo.push(transButtonNoThanks);
            arrOpacityForBelowInfo.push(constantsObj.OPACITY_100);

            var noThanksText = utilObj.getBMFontLabel("No, thanks", constantsObj.FONT_HELVETICA_70, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 205, 60, 0.5, 0.5, labelArr, transButtonNoThanks, zOrder + 1);
            utilObj.setOpacity(noThanksText , constantsObj.OPACITY_60);
            arrForBelowInfo.push(noThanksText);
            arrOpacityForBelowInfo.push(constantsObj.OPACITY_50);

        } else {
            var shareButton = utilObj.getButton(buttonWidth, buttonHeight, 0.5, 0.5, xPos - 60 - buttonWidth / 2, yPos - 50,
                constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: 'transOutroLayer',
                    fn: 'share',
                    screen: gameLayer.screen,
                    params: {},
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: gameObj.getTrackingPuzzleTheme(),
                        o: constantsObj.TRACK_TRANS_OUTRO_LAYER,
                        f: constantsObj.TRACK_SHARE,
                        g: "0",
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            utilObj.addChild(transOutroLayer, shareButton, zOrder + 1);
            utilObj.getBMFontLabel("Share", constantsObj.FONT_HELVETICA_75, constantsObj.COLOR_BACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), buttonWidth / 2, buttonHeight / 2, 0.5, 0.5, labelArr, shareButton, zOrder + 1);
            var outline = utilObj.getScale9Sprite(constantsObj.button_outline, buttonWidth / 2, buttonHeight / 2, 0.5, 0.5, buttonWidth, buttonHeight, spriteArr, shareButton, zOrder + 1, constantsObj.SPRITE_MISC);
            utilObj.setColor(outline, constantsObj.COLOR_BACK_OUTLINE);
            utilObj.setCascadeOpacityEnabled(shareButton , true);
            arrForBelowInfo.push(shareButton);
            arrOpacityForBelowInfo.push(constantsObj.OPACITY_100);

            var fn = "goToCalendar";
            var OutroNext = "Next";


            // condition for daily mini outro
            var isTodaysDailyMini = false;
            if (isDailyMini) {
                var dailyMiniDate = gameObj.convertDailyMiniIdToArchive(transOutroLayer.puzzleId);
                if (!subscriptionsDTCObj.getIsSubscriptionActive() || dailyMiniDate == utilObj.getIdForDate(gameObj.getTodaysPuzzleDate())) {
                    isTodaysDailyMini = true;
                }
            }
            var bonusArchiveAvailable = false;
            if (gameObj.getTodaysFreePuzzle() == gameLayer.crosswordDate && (gameObj.getNumberOfBonusArchiveWatched() + questMapObj.getNumberOfBonusArchiveWatched()) < runtimeObj.getNumberOfBonusArchive() && runtimeObj.getBonusArchiveOutro() == 1) {
                bonusArchiveAvailable = true;
            }
            if ((isTodaysDailyMini || utilObj.getIdForDate(gameObj.getTodaysPuzzleDate()) == transOutroLayer.puzzleId || bonusArchiveAvailable) && homeLayoutExp == constantsObj.EXP_VAR_2) {
                fn = "goToHomeScreen";
                OutroNext = "Continue";
            } else {
                if (subscriptionsDTCObj.getIsSubscriptionActive() && isDailyMini && !isTodaysDailyMini) {
                    calendarLayer.selectedTab = constantsObj.MINI_SCREEN;
                } else if (subscriptionsDTCObj.getIsSubscriptionActive()) {
                    calendarLayer.selectedTab = constantsObj.CALENDAR_SCREEN;
                }
            }
            var nextButton = utilObj.getButton(buttonWidth, buttonHeight, 0.5, 0.5, xPos + 60 + buttonWidth / 2, yPos - 50,
                constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                    obj: 'transOutroLayer',
                    fn: fn,
                    params: {
                        id: transOutroLayer.puzzleId,
                        cashAvailable: false,
                        bonusArchive: false,
                        watchVideo: false,
                        inProgress: false
                    },
                    screen: gameLayer.screen,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: gameObj.getTrackingPuzzleTheme(),
                        o: constantsObj.TRACK_TRANS_OUTRO_LAYER,
                        f: constantsObj.TRACK_NEXT,
                        g: "0",
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            nextButton.setColor(constantsObj.COLOR_INTRO_PLAY_BUTTON);
            utilObj.addChild(transOutroLayer, nextButton, zOrder + 1);
            utilObj.getTTFFontLabel(OutroNext, constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), buttonWidth / 2, buttonHeight / 2, 0.5, 0.5, labelArr, nextButton, zOrder + 1);
            utilObj.setCascadeOpacityEnabled(nextButton , true);
            arrForBelowInfo.push(nextButton);
            arrOpacityForBelowInfo.push(constantsObj.OPACITY_100);
            utilObj.pulseButton(nextButton, constantsObj.PULSE_ACTION_TAG, 0);
        }

        //shrink overlay anim
        var ratioYPosShrink = transOutroLayer.clueHeightForShrink(isMiniOrMidi, isBritMini);
        var ratioShrinkYAxis = ratioYPosShrink / (constantsObj.DESIGN_HEIGHT + topBarOffset);
        animObj.outroAnimations(transOutroLayer, {
            case: constantsObj.OUTRO_SHRINK_BG,
            node: transBg,
            animDelay: animDelay,
            bg: transBg,
            scaleYTo: ratioShrinkYAxis
        });

        //fade out top part
        var animDelayTopFadeOut = 0.15;
        for (var i = 0; i < arrForSecondAnim.length; i++) {
            animObj.outroAnimations(transOutroLayer, {
                case: constantsObj.OUTRO_FADE_OUT_TOP_PART,
                node: arrForSecondAnim[i],
                animDelay: animDelay,
                animTime: animDelayTopFadeOut
            });
        }
        animDelay += animDelayTopFadeOut;

        //fade in below part
        var animDelayForBelowFadeIn = 0.15;
        for (var i = 0; i < arrForBelowInfo.length; i++) {
            arrForBelowInfo[i].setOpacity(0);
            animObj.outroAnimations(transOutroLayer, {
                case: constantsObj.OUTRO_FADE_IN_BELOW_PART,
                node: arrForBelowInfo[i],
                animDelay: animDelay,
                animTime: animDelayForBelowFadeIn,
                opacity : arrOpacityForBelowInfo[i],
            });
        }
        animDelay += animDelayForBelowFadeIn;

        if (epmObj.getChosenVariant(constantsObj.EXP_VI_LEVEL_OUTRO) == constantsObj.EXP_VAR_CONTROL) {
            gameObj.setNextButtonState(false);
            utilObj.delayedCallback(transOutroLayer, transOutroLayer.showAd, animDelay);
        }

        utilObj.delayedCallback(transOutroLayer, transOutroLayer.animCompleted, animDelay);

        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);
        // utilObj.updateScreen(transOutroLayer.screen, transOutroLayer);
    },

    //anim completed
    animCompleted: function () {
        transOutroLayer.animRunning = false;
    },

    //condition to play play quest option on outro
    ifPlayQuestOnOutroAvailable : function(){
        var isFromMapScreen = gameLayer.isFromMapScreen;
        var info1 = gameObj.getCurPuzzleInfo();
        var info = {};
        var puzzleInfo = 0;
        if (info1 != undefined && info1[0] != undefined) {
            info = info1[0];
        }
        if (info != undefined && info.id != undefined) {
            puzzleInfo = info.id;
        }
        if (gameLayer.crosswordDate == puzzleInfo) {
            isFromMapScreen = true;
        }
        var weeklyQuestExp = gameObj.getExpNewWeeklyQuestVariant();
        if(!gameObj.getIsWeeklyQuestLocked() && (weeklyQuestExp == constantsObj.EXP_VAR_1 || weeklyQuestExp == constantsObj.EXP_VAR_2)&& epmObj.getChosenVariant(constantsObj.EXP_QUEST_MARKETING) == constantsObj.EXP_VAR_1 && homeLayer.isTodaysPuzzleSeen(true)
        && gameObj.getIsLLPWQFtueShown() && gameObj.getIsQuestEligileToShow() && !isFromMapScreen &&!gameLayer.isStopPlayQuestOnOutro){
               return true;
        }
        return false;
    },

    // condition for collectibles for theme quest
    collectiblesForThemeQuest: function (mastery) {
        var timeSt = gameObj.getLastSync();
        var themedQuestData = themedQuestObj.getThemedQuestData();
        var curMastery = mastery;
        var prevMastery = gameObj.getPrevMastery();
        var masteryEarned = curMastery - prevMastery;
        if (timeSt >= themedQuestData["start"] && timeSt <= themedQuestData["end"] && !gameObj.getIsThemedQuestLocked() && epmObj.getChosenVariant(constantsObj.EXP_THEMED_QUEST) == constantsObj.EXP_VAR_1 && (gameObj.getMastery() - mastery) > 0) {
            transOutroLayer.tqTotalStars = weeklyQuestObj.getWeeklyQuestTotalstars();
            transOutroLayer.tqStarsAchieved = gameObj.getThemedQuestMastery();
            var prevAchieved = transOutroLayer.tqStarsAchieved;
            if (transOutroLayer.tqStarsAchieved > transOutroLayer.tqTotalStars) {
                transOutroLayer.tqStarsAchieved = transOutroLayer.tqTotalStars;
            }
            var extraCount = 0;
            if (prevAchieved > transOutroLayer.tqStarsAchieved) {
                extraCount = prevAchieved - transOutroLayer.tqStarsAchieved;
            }
            transOutroLayer.tqFinalMasteryEarned = masteryEarned - extraCount;
        }
        if (timeSt >= themedQuestData["start"] && timeSt <= themedQuestData["end"] && !gameObj.getIsThemedQuestLocked() && epmObj.getChosenVariant(constantsObj.EXP_THEMED_QUEST) == constantsObj.EXP_VAR_1 && (gameObj.getMastery() - mastery) > 0 && (gameObj.getThemedQuestMastery() - transOutroLayer.tqFinalMasteryEarned) < weeklyQuestObj.getWeeklyQuestTotalstars()) {
            return true;
        }
        return false;
    },

    questAvailability: function (mastery) {
        var eligibleForQuest = false;
        var themedQuestData = themedQuestObj.getThemedQuestData();
        var timeSt = gameObj.getLastSync();
        transOutroLayer.eligibleForThemeQuest = false;
        transOutroLayer.eligibleForWeeklyQuest = false;
        var curMastery = mastery;
        var prevMastery = gameObj.getPrevMastery();
        var masteryEarned = curMastery - prevMastery;
        var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
        if (timeSt >= themedQuestData["start"] && timeSt <= themedQuestData["end"] && !gameObj.getIsThemedQuestLocked() && epmObj.getChosenVariant(constantsObj.EXP_THEMED_QUEST) == constantsObj.EXP_VAR_1 && (gameObj.getMastery() - mastery) > 0) {

            transOutroLayer.tqTotalStars = weeklyQuestObj.getWeeklyQuestTotalstars();
            var mileStones1 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(0));
            var mileStones2 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(1));
            var mileStones3 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(2));
            var starsText = [mileStones1, mileStones2, mileStones3];
            transOutroLayer.tqStarsAchieved = gameObj.getThemedQuestMastery();
            var prevAchieved = transOutroLayer.tqStarsAchieved;
            if (transOutroLayer.tqStarsAchieved > transOutroLayer.tqTotalStars) {
                transOutroLayer.tqStarsAchieved = transOutroLayer.tqTotalStars;
            }
            var extraCount = 0;
            if (prevAchieved > transOutroLayer.tqStarsAchieved) {
                extraCount = prevAchieved - transOutroLayer.tqStarsAchieved;
            }
            transOutroLayer.tqFinalMasteryEarned = masteryEarned - extraCount;
            if (gameObj.getThemedQuestMastery() - transOutroLayer.tqFinalMasteryEarned < weeklyQuestObj.getWeeklyQuestTotalstars() && weeklyQuestExp != constantsObj.EXP_VAR_CONTROL) {
                transOutroLayer.eligibleForThemeQuest = true;
            }
        }
        if (gameObj.getIsWeeklyQuestLocked() == false && (weeklyQuestExp == constantsObj.EXP_VAR_1 || weeklyQuestExp == constantsObj.EXP_VAR_2 || weeklyQuestExp == constantsObj.EXP_VAR_3 || weeklyQuestExp == constantsObj.EXP_VAR_4)) {
            transOutroLayer.wqTotalStars = weeklyQuestObj.getWeeklyQuestTotalstars();
            var mileStones1 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(0));
            var mileStones2 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(1));
            var mileStones3 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(2));
            var starsText = [mileStones1, mileStones2, mileStones3];
            transOutroLayer.wqStarsAchieved = gameObj.getWeeklyQuestMastery();
            var prevAchieved = transOutroLayer.wqStarsAchieved;
            if (transOutroLayer.wqStarsAchieved > weeklyQuestObj.getWeeklyQuestTotalstars()) {
                transOutroLayer.wqStarsAchieved = weeklyQuestObj.getWeeklyQuestTotalstars()
            }
            var extraCount = 0;
            if (prevAchieved > transOutroLayer.wqStarsAchieved) {
                extraCount = prevAchieved - transOutroLayer.wqStarsAchieved;
            }
            transOutroLayer.wqFinalMasteryEarned = masteryEarned - extraCount;
            if (gameObj.getWeeklyQuestMastery() - transOutroLayer.wqFinalMasteryEarned < weeklyQuestObj.getWeeklyQuestTotalstars()) {
                transOutroLayer.eligibleForWeeklyQuest = true;
            }
        }
        if (transOutroLayer.eligibleForThemeQuest || transOutroLayer.eligibleForWeeklyQuest) {
            eligibleForQuest = true;
        }
        return eligibleForQuest;
    },

    showAd: function () {
        var isAchievementAnimationShown = false;
        if (subscriptionsDTCObj.getIsSubscriptionActive()) {
            gameObj.setNextButtonState(true);
            return;
        }
        if (((!gameObj.getShowAds()) || gameObj.getIsPayer())) {
            gameObj.setNextButtonState(true);
            return;
        }
        if (utilObj.getCurrentTimestamp() - gameObj.getTimeStampForAchievementAnimation() < (1 * constantsObj.SECONDS_IN_MIN)) {
            if (utilObj.getCurrentTimestamp() - userObj.getCreated() < constantsObj.SECONDS_IN_DAY) {
                isAchievementAnimationShown = true;
            }
        }
        if (gameObj.getD0Id() == gameObj.getCrosswordToShow() && (utilObj.getCurrentTimestamp() - userObj.getCreated() < constantsObj.SECONDS_IN_DAY)) {
            gameObj.setNextButtonState(true);
            return;
        }
        // check for VI coolDown for a day.
        if (gameObj.getNumberOfVideoIntWatched() >= runtimeObj.getVideoIntCount()) {
            gameObj.setNextButtonState(true);
            return;
        }
        if (adsObj.checkRewardedVideo(true)) {
            adsObj.showVideoAd(true);
            gameObj.setNumberOfVideoIntWatched(gameObj.getNumberOfVideoIntWatched() + 1);
            gameObj.setTimestampForLastVideoInterstitial(utilObj.getCurrentTimestamp());
            adsObj.setNotRewardedVideo(true);
            utilObj.delayedCallback(transOutroLayer, transOutroLayer.enableNextButton, 1.5);
        } else {
            gameObj.setNextButtonState(true);
        }
    },

    enableNextButton: function () {
        gameObj.setNextButtonState(true);
    },

    share: function () {
        if (transOutroLayer.animRunning) {
            return;
        }
        if (epmObj.getChosenVariant(constantsObj.EXP_VI_LEVEL_OUTRO) != constantsObj.EXP_VAR_CONTROL) {
            transOutroLayer.showAd();
        } else {
            if (gameObj.getNextButtonState() == false) {
                return;
            }
        }
        gameObj.setisReview(false);
        gameObj.setIsOutroTransLayerOn(false);
        freeCoins2Popup.show(true, constantsObj.SCREEN_OUTRO_LAYER, transOutroLayer.parmsForShare);
    },

    showTQProgressAnimOnOutro: function (len, finalMasteryEarned,progressBar, starsAchieved, totalStars, initDelay, giftBoxAnim, questProgressArr) {
        var progressBar = progressBar;
        if (!utilObj.isNodeValid(progressBar)) {
            return initDelay;
        }
        var originalWidth = len;
        var totalWidth = 840;
        if (originalWidth < 0) {
            return initDelay;
        }
        if (finalMasteryEarned <= 0) {
            return initDelay;
        }
        var newWidth = ((starsAchieved + finalMasteryEarned) / totalStars) * totalWidth;
        var sy = 1;
        if (originalWidth == 0) {
            originalWidth = 1;
            newWidth += 1;
        }

        // for progress bar anim
        var delayAction = animObj.getDelayTime(initDelay);
        var scaleAction = animObj.getScaleDifferentTo(0.5, newWidth / originalWidth, sy);
        var actions = [delayAction, scaleAction];
        animObj.runAction(progressBar, animObj.getSequence(actions));

        initDelay += 0.5;
        var giftBoxDelay = 0;
        if (giftBoxAnim != null) {
            giftBoxDelay = 0.2;
            var origScale = giftBoxAnim.getScale();
            var delayAction = animObj.getDelayTime(initDelay);
            var scaleUp = new cc.ScaleTo(0.15, (origScale * 1.5)).easing((cc.easeOut(1)));
            var scaleDown = new cc.ScaleTo(0.15, (origScale)).easing((cc.easeIn(1)));
            var actions = [delayAction, scaleUp, scaleDown];
            animObj.runAction(giftBoxAnim, animObj.getSequence(actions));
        }

        var questProgressDelay = 0;
        if (questProgressArr != undefined) {
            questProgressDelay = 0.2;
            for (var i = 0; i < questProgressArr.length; i++) {
                questProgressArr[i].setOpacity(0);
                var xPos = questProgressArr[i].getPosition().x;
                var yPos = questProgressArr[i].getPosition().y;
                var yPosShift = 50;
                utilObj.setPosition(questProgressArr[i], xPos, yPos + yPosShift);
                var anims = [];
                var delayAction = utilObj.getDelayTime(initDelay + giftBoxDelay);
                anims.push(delayAction);
                var move = new cc.MoveTo(questProgressDelay, xPos, yPos);
                var ease = move.easing(new cc.easeOut(0.9));
                var fadeIn = utilObj.getFadeTo(questProgressDelay, constantsObj.OPACITY_100);
                var spawn = cc.Spawn(ease, fadeIn);
                anims.push(spawn);
                animObj.runAction(questProgressArr[i], utilObj.getSequence(anims));
            }
        }
        return initDelay + giftBoxDelay;
    },

    goToHomeScreen: function () {
        if (transOutroLayer.animRunning) {
            return;
        }
        if (gameObj.getNextButtonState() == false) {
            return;
        }
        if (epmObj.getChosenVariant(constantsObj.EXP_VI_LEVEL_OUTRO) != constantsObj.EXP_VAR_CONTROL) {
            transOutroLayer.showAd();
        }
        gameObj.setisReview(false);
        gameObj.setIsOutroTransLayerOn(false);
        transOutroLayer.hide();
        gameLayer.hide();
        linearLevelProgression.show();
        // if(gameLayer.isFromMapScreen){
        //     gameLayer.hide();
        //     questMapLayer.show();
        // }else {
        //     homeLayer.show();
        // }
    },

    goToCalendar: function () {
        if (transOutroLayer.animRunning) {
            return;
        }
        if (gameObj.getNextButtonState() == false) {
            return;
        }
        if (epmObj.getChosenVariant(constantsObj.EXP_VI_LEVEL_OUTRO) != constantsObj.EXP_VAR_CONTROL) {
            transOutroLayer.showAd();
        }
        gameObj.setisReview(false);
        gameObj.setIsOutroTransLayerOn(false);
        transOutroLayer.hide();
        gameLayer.hide();
        linearLevelProgression.show();
        // var isFromPack = gameLayer.isPuzzleFromPack;
        // if(gameLayer.isFromMapScreen){
        //     gameLayer.hide();
        //     questMapLayer.show();
        // }else if (isFromPack) {
        //     transOutroLayer.showPuzzleInfo();
        // }else {
        //     if (!transOutroLayer.isDailyMiniPuzzle) {
        //         calendarLayer.selectedTab = constantsObj.CALENDAR_SCREEN;
        //     }
        //     calendarLayer.show();
        // }
    },

    showPuzzleInfo: function () {
        if ((gameObj.getMastery1() <= 0)) {
            if (gameObj.checkIfPackComplete(7) == false) {
                gameLayer.hide();
                var puzzleId1 = gameObj.firstIncompletePuzzle(7);
                gameLayer.show(puzzleId1, true);
                return;
            }
            else if (gameObj.checkIfPackComplete(7) == true) {
                gameLayer.hide();
                var packId = gameObj.getPackIdFromPuzzleId(7);
                gameObj.setOpenedFromOutro(true);
                packInfoLayer.show(packId);
                return;
            }
        }
        var id = parseInt(transOutroLayer.puzzleId.substring(6, 8));
        gameLayer.hide();
        var isBritMini = gameObj.checkForBritMini(transOutroLayer.puzzleId);
        var packId = gameObj.getPackIdFromPuzzleId(transOutroLayer.puzzleId);
        var packLockStatus = gameObj.getPackInfoLockStatus();
        var nextPackId = 0;
        var packIdLockStatus = false;
        if (isBritMini) {
            nextPackId = gameObj.nextIncompletePuzzle(packId, id, constantsObj.BRITISH_PACKS);
            if (nextPackId != 0) {
                gameLayer.show(nextPackId, true);
                return;
            }
            gameObj.setOpenedFromOutro(true);
            packInfoLayer.show(packId, null, constantsObj.BRITISH_PACKS);
        } else {
            nextPackId = gameObj.nextIncompletePuzzle(packId, id);
            if (packId >= 0 && packId <= 6) {
                packIdLockStatus = true;
            } else {
                packIdLockStatus = packLockStatus[packId];
            }
            if (nextPackId != 0 && !packIdLockStatus) {
                gameLayer.show(nextPackId, true);
                return;
            }
            gameObj.setOpenedFromOutro(true);
            packInfoLayer.show(packId, null, constantsObj.NORMAL_PACKS);
        }
    },

    updateScoreLbl: function (sender, params) {
        utilObj.setString(params.lbl, (params.score) + "");
    },

    trackingParams: function (sender, params) {
        if (utilObj.isNodeValid(params.node)) {
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), params.txt, constantsObj.TRACK_VIEW, "", "", "", "");
        }
    },

    // get clue height for shrinking the black overlay.
    clueHeightForShrink: function (isMiniOrMidi, isBritMini) {
        var ratioYPosShrink = constantsObj.DESIGN_HEIGHT - gameObj.getGridPixelHeight();
        var shiftInKeyboard = 0;
        var keyBoardHeight = constantsObj.KEYBOARD_HEIGHT;
        var clueHeight = constantsObj.CLUE_HEIGHT;
        var hintsHeight = constantsObj.HINTS_HEIGHT;

        if (utilObj.getIsLikeIphoneX() && utilObj.isIos()) {
            keyBoardHeight = 805;
            clueHeight = 275;
        }


        if (!isMiniOrMidi || isBritMini) {
            clueHeight = constantsObj.CLUE_HEIGHT_NEW;
            keyBoardHeight = constantsObj.KEYBOARD_HEIGHT_NEW;
            hintsHeight = constantsObj.HINTS_HEIGHT_NEW;
            if (utilObj.getIsLikeIphoneX() && utilObj.isIos()) {
                keyBoardHeight = 675;
                clueHeight = 275;
            }
        }
        if (isMiniOrMidi && !isBritMini) {
            ratioYPosShrink -= 140;
            keyBoardHeight -= 110;
            clueHeight -= 10;
            hintsHeight -= 20;
        }
        if (!isMiniOrMidi || isBritMini) {
            ratioYPosShrink -= 225;
        }
        ratioYPosShrink -= clueHeight;
        if (utilObj.getIsLikeIphoneX() && utilObj.isAndroid()) {
            var miniOffset = 0;
            if (isMiniOrMidi && !isBritMini) {
                miniOffset = constantsObj.HEADER_HEIGHT - 225;
            }
            shiftInKeyboard = utilObj.getDesignHeight() - keyBoardHeight - clueHeight - hintsHeight - 390 - gameObj.getGridPixelHeight() - miniOffset - constantsObj.BOTTOM_BAR_OFFSET1 + 10;
        }
        if (shiftInKeyboard < 0) {
            shiftInKeyboard = 0;
        }
        ratioYPosShrink = ratioYPosShrink - shiftInKeyboard;
        return ratioYPosShrink;
    },

    playQuest : function(){
        if (transOutroLayer.animRunning) {
            return;
        }
        gameObj.setisReview(false);
        gameObj.setIsOutroTransLayerOn(false);
        transOutroLayer.hide();
        gameLayer.hide();
        questMapLayer.show(true);
    },

    noThanks: function(){
        var fn = transOutroLayer.goToCalendar;
        // condition for daily mini outro
        var isTodaysDailyMini = false;
        var isDailyMini = gameObj.checkForDailyMini(transOutroLayer.puzzleId);
        if (isDailyMini) {
            var dailyMiniDate = gameObj.convertDailyMiniIdToArchive(transOutroLayer.puzzleId);
            if (!subscriptionsDTCObj.getIsSubscriptionActive() || dailyMiniDate == utilObj.getIdForDate(gameObj.getTodaysPuzzleDate())) {
                isTodaysDailyMini = true;
            }
        }
        var bonusArchiveAvailable = false;
        if (gameObj.getTodaysFreePuzzle() == gameLayer.crosswordDate && (gameObj.getNumberOfBonusArchiveWatched() + questMapObj.getNumberOfBonusArchiveWatched()) < runtimeObj.getNumberOfBonusArchive() && runtimeObj.getBonusArchiveOutro() == 1) {
            bonusArchiveAvailable = true;
        }
        if ((isTodaysDailyMini || utilObj.getIdForDate(gameObj.getTodaysPuzzleDate()) == transOutroLayer.puzzleId || bonusArchiveAvailable) && homeLayoutExp == constantsObj.EXP_VAR_2) {
            fn = transOutroLayer.goToHomeScreen;
        } else {
            if (subscriptionsDTCObj.getIsSubscriptionActive() && isDailyMini && !isTodaysDailyMini) {
                calendarLayer.selectedTab = constantsObj.MINI_SCREEN;
            } else if (subscriptionsDTCObj.getIsSubscriptionActive()) {
                calendarLayer.selectedTab = constantsObj.CALENDAR_SCREEN;
            }
        }
        fn();

    },

});