Ads = function () {
    var videoProvider = "mopub";
    var lastVideoRewardAt = 0;
    var lastVideoStartedAt = 0;
    var notRewardedVideo = false;


    var PLACEMENT_NAME_SEPARATOR = ":";

    this.PLACEMENT_BANNER = "BANNER";
    this.PLACEMENT_INTERSTITIAL = "INTERSTITIAL";
    this.PLACEMENT_RV_BACKFILL = "RV_BACKFILL";
    this.PLACEMENT_VIDEO_1 = "VIDEO_1";
    this.PLACEMENT_VIDEO_2 = "VIDEO_2";

    var callbackFunction = null;
    var callbackParams = null;
    var hasUserRequestedVideo = false;
    var videoCheckCallbackSet = false;
    var videoCheckTimeout = null;

    this.init = function () {

    };

    this.checkRewardedVideoAvailable = function () {
        return false;
        var placementNames = adsObj.PLACEMENT_VIDEO_1 + PLACEMENT_NAME_SEPARATOR + adsObj.PLACEMENT_VIDEO_2 + PLACEMENT_NAME_SEPARATOR + adsObj.PLACEMENT_RV_BACKFILL;
        return psMopubAdsObj.isAnyPlacementAvailable(placementNames);
    };

    this.checkRewardedVideo = function (notRewarded, callback, params, directCheck, fromBlitz) {
        return false;
        var placementNames = adsObj.PLACEMENT_VIDEO_1 + PLACEMENT_NAME_SEPARATOR + adsObj.PLACEMENT_VIDEO_2 + PLACEMENT_NAME_SEPARATOR + adsObj.PLACEMENT_RV_BACKFILL;
        var isUserTriggered = !notRewarded;
        if (!notRewarded) {
            if (directCheck) {
                isUserTriggered = false;
            }
            if (xpromoUtilObj.isWebStaging()) {
                var status = xpromoUtilObj.isVideoAvailable();
                if (!status && isUserTriggered) {
                    utilObj.showMessage(stringsObj.video_not_available);
                }
                return status;
            }
            if (!isUserTriggered) {
                return adsObj.checkRewardedVideoAvailable();
            }
            var placementStatus = psMopubAdsObj.isPlacementAvailable(adsObj.PLACEMENT_VIDEO_1);
            loggerObj.debugLog("mopub log: ads.js: checkRewardedVideo", placementStatus, isUserTriggered);
            if (!placementStatus) {
                adsObj.setHasUserRequestedVideo(true);
                callbackFunction = callback;
                callbackParams = params;
                adsObj.setVideoCheckCallback();
                psMopubAdsObj.retryAdLoadForPlacementType(psMopubAdsObj.MOPUB_AD_TYPE_REWARDED);
                return false;
            }
        } else {
            // return mopubAdsObj.isInterstitialAvailable(notRewarded, false, fromBlitz);
            var interstitialAdCondition = adsObj.eligibilityToShowInterstitial(fromBlitz);
            loggerObj.debugLog("mopub log: ads.js: checkInterstitialVideo", interstitialAdCondition);
            if (!interstitialAdCondition) {
                return false;
            }
            var placementStatus = psMopubAdsObj.isAnyPlacementAvailable(adsObj.PLACEMENT_INTERSTITIAL);
            loggerObj.debugLog("mopub log: ads.js: checkInterstitialVideo 1:", placementStatus, adsObj.PLACEMENT_INTERSTITIAL);
            return placementStatus;
        }
        return psMopubAdsObj.isAnyPlacementAvailable(placementNames);
    };



    this.showVideoAd = function (notRewarded, from, isContinueWatch) {
        if (xpromoUtilObj.isWebStaging() && xpromoUtilObj.isVideoAvailable()) {
            adsObj.grantVideoReward(null);
            return;
        }
        var placementNames = "";
        if (!notRewarded) {
            placementNames = adsObj.getOrderedPlacementForVideo();
            gameObj.setLastW2eTimestamp(utilObj.getCurrentTimestamp());
            analyticsObj.triggerEvents(constantsObj.EVENT_TYPE_REWARDED_VIDEO_IMPRESSION);
            // TODO: ask abdul about the handleVideoStart case
            // if (from == "fromPowerUp" || from == "forBonusArchiveNew" || from == "spinner" || from == "highLevelStore") {
            //     // return mopubAdsObj.showRewardedVideoDirect();
            // } else {
            //
            //     // return mopubAdsObj.showVideoAd();
            // }
            xpromoW2eObj.handleVideoStart(isContinueWatch);
            loggerObj.debugLog("mopub log: ads.js: showVideoAd  rewarded video 1: ");
        } else {
            loggerObj.debugLog("mopub log: ads.js: showVideoAd 1: ");
            placementNames = adsObj.PLACEMENT_INTERSTITIAL;
        }
        if (curScreen == constantsObj.SCREEN_BONUS_ARCHIVE_POPUP || curScreen == constantsObj.SCREEN_HINT_AND_BUY) {
            popupLayer.closeWithDefault();
        }
        return psMopubAdsObj.showAnyPlacementAvailable(placementNames, utilObj.getScreenName(curScreen), gameObj.getPuzzleSpeciesTracking());
        // return mopubAdsObj.showInterstitialAd(false);
    };

    this.eligibilityToShowInterstitial = function(fromBlitz) {
        var fromBlitzMode = false;
        if (fromBlitz != undefined) {
            fromBlitzMode = fromBlitz;
        }
        if (((!gameObj.getShowAds()) || gameObj.getIsPayer())) {
            return;
        }
        if (subscriptionsDTCObj.getIsSubscriptionActive()) {
            return false;
        }
        var curTime = utilObj.getCurrentTimestamp();
        var lastVideoInterstitialTime = gameObj.getTimestampForLastVideoInterstitial();
        if ((gameObj.getCrosswordToShow() != 0 && gameObj.getCrosswordToShow() != undefined && gameObj.getCrosswordToShow() != null) || fromBlitzMode) {
            var isMiniOrMidi = gameObj.checkForMiniOrMidi(gameObj.getCrosswordToShow());
            // loggerObj.debugLog("check for the last video time ",curTime, lastVideoInterstitialTime, gameObj.getVideoInterstitialCoolDown())
            if (curTime - lastVideoInterstitialTime < gameObj.getVideoInterstitialCoolDown() * constantsObj.SECONDS_IN_MIN && (isMiniOrMidi || fromBlitzMode)) {
                trackObj.trackCounter(constantsObj.TRACK_AD_MEDIATION, constantsObj.TRACK_VIDEO, "cooldown", curScreen, "", "", "", "", "");
                //loggerObj.debugLog("check for the last video time1");
                return false;
            }
        }
        return true;
    };

    this.setHasUserRequestedVideo = function (val) {
        hasUserRequestedVideo = val;
        loggerObj.debugLog("mopub log: ads.js: hasUserRequestedVideo", hasUserRequestedVideo);
    };

    this.setVideoCheckCallback = function () {
        loggerObj.debugLog("mopub log: ads.js: setVideoCheckCallback ", videoCheckCallbackSet);
        if (videoCheckCallbackSet) {
            return;
        }
        adsObj.setVideoCheckCallbackSet(true);
        utilObj.showMessage(stringsObj.checking_for_video);
        adsObj.setScreenStateAfterVideoCallBack();
        loggerObj.debugLog("mopub log: ads.js: setting delayed callback for video status message ", runtimeObj.getMopubVideoWaitDuration());
        videoCheckTimeout = window.setTimeout(adsObj.showVideoStatusMessage, runtimeObj.getMopubVideoWaitDuration() * 1000);
        trackObj.trackCounter(constantsObj.TRACK_AD_TRACKING, constantsObj.TRACK_WATCH, "fetching_video", utilObj.getCurrentScreenName(), utilObj.isOnline(), "mopub", "", 1, "");
    };

    this.setVideoCheckCallbackSet = function (val) {
        videoCheckCallbackSet = val;
        loggerObj.debugLog("mopub log: ads.js: videoCheckCallbackSet", videoCheckCallbackSet);
    };

    this.showVideoStatusMessage = function () {
        // Check VI and Ad unit 2. Show if available.
        loggerObj.debugLog("mopub log: ads.js: checking if video is available after wait duration,", runtimeObj.getMopubVideoPriority());
        var placementNames = adsObj.getOrderedPlacementForVideo();
        if (adsObj.checkAndShowVideoPlacements(placementNames)) {
            return;
        }
        adsObj.setVideoCheckCallbackSet(false);
        callbackFunction = null;
        callbackParams = null;
        utilObj.showMessage(stringsObj.video_not_available);
        trackObj.trackCounter(constantsObj.TRACK_AD_TRACKING, constantsObj.TRACK_WATCH, constantsObj.TRACK_NOT_AVAILABLE, utilObj.getCurrentScreenName(), utilObj.isOnline(), "mopub", "", 1, "");
    };

    this.checkAndShowVideoPlacements = function (placementNames) {
        var placementStatus = psMopubAdsObj.isAnyPlacementAvailable(placementNames);
        if (placementStatus) {
            if (videoCheckCallbackSet && hasUserRequestedVideo) {
                window.clearTimeout(videoCheckTimeout);
                if (callbackFunction != undefined && callbackFunction != null) {
                    callbackFunction(callbackParams);
                    callbackFunction = null;
                    callbackParams = null;
                }
            }
            adsObj.setVideoCheckCallbackSet(false);
            adsObj.setHasUserRequestedVideo(false);
            if (curScreen == constantsObj.SCREEN_BONUS_ARCHIVE_POPUP || curScreen == constantsObj.SCREEN_HINT_AND_BUY) {
                popupLayer.closeWithDefault();
            }
            psMopubAdsObj.showAnyPlacementAvailable(placementNames);
            return true;
        }
        return false;
    };

    this.setScreenStateAfterVideoCallBack = function () {
        if (curScreen == constantsObj.SCREEN_BONUS_ARCHIVE_POPUP) {
            bonusArchivePopup.continueButtonState(false);
            utilObj.delayedCallback(popupLayer, bonusArchivePopup.enableContinueButton, runtimeObj.getMopubVideoWaitDuration());
        } else if (curScreen == constantsObj.SCREEN_ZEN_MODE) {
            zenModeLayer.setContinueButtonState(false);
            utilObj.delayedCallback(popupLayer, zenModeLayer.enableContinueButton, runtimeObj.getMopubVideoWaitDuration());
        } else if (curScreen == constantsObj.SCREEN_HOME || curScreen == constantsObj.SCREEN_HINT_AND_BUY) {
            hintAndBuyPopup.continueButtonState(false);
            utilObj.delayedCallback(popupLayer, hintAndBuyPopup.enableContinueButton, runtimeObj.getMopubVideoWaitDuration());
        }
    };

    this.getOrderedPlacementForVideo = function () {
        var placementNames = adsObj.PLACEMENT_VIDEO_1 + PLACEMENT_NAME_SEPARATOR;
        if (runtimeObj.getMopubVideoPriority() == 1) {
            placementNames += adsObj.PLACEMENT_RV_BACKFILL + PLACEMENT_NAME_SEPARATOR + adsObj.PLACEMENT_VIDEO_2;
        } else {
            placementNames += adsObj.PLACEMENT_VIDEO_2 + PLACEMENT_NAME_SEPARATOR + adsObj.PLACEMENT_RV_BACKFILL;
        }
        return placementNames;
    };

    /**
     * this function sets the variable for grant video reward function
     * @param val
     */
    this.setNotRewardedVideo = function (val) {
        notRewardedVideo = val;
    };

    this.hasTapjoyEarnCoinsVideo = function () {
        if (utilObj.isIos() && epmObj.getChosenVariant(constantsObj.EXP_OFFERWALL_IOS) == constantsObj.EXP_VAR_CONTROL) {
            return false;
        }
        var hasVideo = false;
        if (utilObj.isAndroid()) {
            hasVideo = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID_COMMON + "Ads", "hasTapjoyEarnCoinsVideo", "()Z");
        } else if (utilObj.isIos()) {
            hasVideo = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Ads", "hasTapjoyEarnCoinsVideo");
        }
        if (!hasVideo) {
            trackObj.trackCounter(constantsObj.TRACK_AD_TRACKING, constantsObj.TRACK_W2E, constantsObj.TRACK_NOT_AVAILABLE, utilObj.getScreenName(curScreen), "", constantsObj.TRACK_TAPJOY, gameObj.getPuzzleSpeciesTracking(), 1, "");
        } else {
            trackObj.trackCounter(constantsObj.TRACK_AD_TRACKING, constantsObj.TRACK_W2E, constantsObj.TRACK_PULLED, utilObj.getScreenName(curScreen), "", constantsObj.TRACK_TAPJOY, "", 1, "");
        }
        return hasVideo;
    };

    this.showTapjoyOfferWall = function () {
        if (utilObj.isIos() && epmObj.getChosenVariant(constantsObj.EXP_OFFERWALL_IOS) == constantsObj.EXP_VAR_CONTROL) {
            return;
        }
        if (utilObj.isAndroid()) {
            // loggerObj.debugLog("showing for tapjoy offerwall");
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID_COMMON + "Ads", "showTapjoyOfferWall", "()V");
        } else if (utilObj.isIos()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Ads", "showTapjoyOfferWall");
        }

        trackObj.trackCounter(constantsObj.TRACK_AD_TRACKING, constantsObj.TRACK_OFFERWALL, constantsObj.TRACK_VIEW, utilObj.getScreenName(curScreen), "", constantsObj.TRACK_TAPJOY, gameObj.getPuzzleSpeciesTracking(), 1, "");
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", constantsObj.TRACK_OFFERWALL, constantsObj.TRACK_VIEW, "", "", "", "");
    };

    this.hasTapjoyOfferWall = function () {
        if (utilObj.isIos() && epmObj.getChosenVariant(constantsObj.EXP_OFFERWALL_IOS) == constantsObj.EXP_VAR_CONTROL) {
            return false;
        }
        var hasOfferwall = false;
        if (utilObj.isAndroid()) {
            hasOfferwall = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID_COMMON + "Ads", "hasTapjoyOfferWall", "()Z");
            // loggerObj.debugLog("asking for offerwall", hasOfferwall);
        } else if (utilObj.isIos()) {
            hasOfferwall = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Ads", "hasTapjoyOfferWall");
        }
        if (!hasOfferwall) {
            trackObj.trackCounter(constantsObj.TRACK_AD_TRACKING, constantsObj.TRACK_OFFERWALL, constantsObj.TRACK_NOT_AVAILABLE, utilObj.getScreenName(curScreen), "", constantsObj.TRACK_TAPJOY, gameObj.getPuzzleSpeciesTracking(), 1, "");
        } else {
            trackObj.trackCounter(constantsObj.TRACK_AD_TRACKING, constantsObj.TRACK_OFFERWALL, constantsObj.TRACK_PULLED, utilObj.getScreenName(curScreen), "", constantsObj.TRACK_TAPJOY, "", 1, "");
        }
        return hasOfferwall;
    };

    this.hasOfferWall = function () {
        if (utilObj.isIos() && epmObj.getChosenVariant(constantsObj.EXP_OFFERWALL_IOS) == constantsObj.EXP_VAR_CONTROL) {
            return false;
        }
        return adsObj.hasTapjoyOfferWall();
    };

    this.showOfferWall = function () {
        if (utilObj.isIos() && epmObj.getChosenVariant(constantsObj.EXP_OFFERWALL_IOS) == constantsObj.EXP_VAR_CONTROL) {
            return;
        }
        if (utilObj.isAndroid() && epmObj.getChosenVariant(constantsObj.EXP_SURVEY) != constantsObj.EXP_VAR_CONTROL) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID_COMMON + "Ads", "showTapResearch", "()V");
            if (tapResearch == false) {
                utilObj.showMessage("coming soon");
            }
        } else {
            var ironSourceOrTapjoy = 1;//runtimeObj.getIronsourceTapjoy();
            // loggerObj.debugLog("runTime for ironSourceOrTapjoy", ironSourceOrTapjoy);

            if (ironSourceOrTapjoy == 0) {
                if (adsObj.hasTapjoyOfferWall()) {
                    // loggerObj.debugLog("showing tapjoy offerwall");
                    adsObj.showTapjoyOfferWall();
                }
            } else {
                if (adsObj.hasTapjoyOfferWall()) {
                    // loggerObj.debugLog("showing tapjoy offerwall");
                    adsObj.showTapjoyOfferWall();
                }
            }
        }

    };

    this.showTapjoyEarnCoinsVideo = function () {
        if (utilObj.isIos() && epmObj.getChosenVariant(constantsObj.EXP_OFFERWALL_IOS) == constantsObj.EXP_VAR_CONTROL) {
            return;
        }
        if (utilObj.isAndroid()) {
            var success = jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_ANDROID_COMMON + "Ads", "showTapjoyEarnCoinsVideo", "()Z");
            if (!success) {
                // loggerObj.debugLog("No rewarded video available");
            }
        } else if (utilObj.isIos()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Ads", "showTapjoyEarnCoinsVideo");
            trackObj.trackCounter(constantsObj.TRACK_AD_TRACKING, constantsObj.TRACK_W2E, constantsObj.TRACK_VIEW, utilObj.getScreenName(curScreen), "", constantsObj.TRACK_TAPJOY, gameObj.getPuzzleSpeciesTracking(), 1, "");
        }
        lastVideoStartedAt = utilObj.getCurrentTimestamp();
    };

    /**
     * resetting the variables related to rewarded ad grant call
     */
    this.rewardedVideoClosed = function () {
        animObj.checkAndTriggerPowerAnim();
        gameObj.setArchiveUnlockReward(false);
        gameObj.setPuzzleToUnlock(null);
        gameObj.setUnlockingQuestBonusArchive(false);
        gameObj.setSpinRewardActive(false);
        gameObj.setW2ePowerUpVideo(false);
        dailyBonusObj.setIsDailyBonusRewardActive(false);
        if (utilObj.isIos() && curScreen == constantsObj.SCREEN_GAME) {
            gameLayer.resume();
        }
    };

    this.grantVideoReward = function () {
        if (notRewardedVideo) {
            notRewardedVideo = false;
            // loggerObj.debugLog("2.94 callback hits grantVideoReward redrawing achievement", notRewardedVideo, curScreen);
            if (curScreen == constantsObj.SCREEN_ACHIEVEMENTS) {
                // loggerObj.debugLog("2.94 callback hits grantVideoReward redrawing achievement", notRewardedVideo);
                gameObj.setNumVideosOnAchievement(gameObj.getNumVideosOnAchievement() + 1);
                achievementsLayer.redraw();
            }
            return;
        }
        lastVideoRewardAt = utilObj.getCurrentTimestamp();
        gameObj.setTimeStampW2eShown();

        // updating value for spinner on free coin action
        spinnerObj.updateRevStatusMap();

        // daily bonus rev map update
        dailyBonusObj.updateRevStatusMap();

        if (utilObj.isIos() && curScreen == constantsObj.SCREEN_GAME) {
            gameLayer.resume();
        }

        if (gameObj.getArchiveUnlockReward()) {
            gameObj.setArchiveUnlockReward(false);
            if (gameObj.getPuzzleToUnlock()) {
                if (gameObj.getCallingFromRecommendationPopup()) {
                    recommendationPopup.setCb(recommendationPopup.loadPuzzleVideoReward);
                    recommendationPopup.setPlayButtonClicked(true);
                    popupLayer.closeWithDefault();
                    // recommendationPopup.loadPuzzleVideoReward(gameObj.getPuzzleToUnlock());
                    // gameObj.setPuzzleToUnlock(null);
                } else if (gameObj.getUnlockingBonusArchive()) {
                    bonusArchivePopup.unlockArchive();
                } else {
                    trackObj.trackCounter(constantsObj.TRACK_CASH, constantsObj.TRACK_EARN, "w2e_bonus_archive", "", economyObj.getCash() + 10, 10, gameObj.getPuzzleSpeciesTracking(), "", "");
                    trackObj.trackCounter(constantsObj.TRACK_CASH, constantsObj.TRACK_SPEND, "w2e_bonus_archive", "", economyObj.getCash(), -10, gameObj.getPuzzleSpeciesTracking(), "", "");
                    if (gameObj.getUnlockingQuestBonusArchive()) {
                        questPuzzleUnlockPopup.loadPuzzleVideoReward(gameObj.getPuzzleToUnlock());
                        gameObj.setUnlockingQuestBonusArchive(false);
                    } else {
                        homeLayer.loadPuzzleVideoReward(gameObj.getPuzzleToUnlock());
                    }
                    gameObj.setPuzzleToUnlock(null);
                }
            } else {
                hintAndBuyPopup.unlockArchive();
            }
        } else if (gameObj.getW2ePowerUpVideo()) {
            gameObj.setW2ePowerUpVideo(false);
            gameObj.setW2ePowerUpVideoWatched(true);
        } else if (gameObj.getSpinRewardActive()) {
            newSpinnerPopup.rewardAfterWatchingAvideo();
            gameObj.setSpinRewardActive(false);
            // trackObj.trackCounter(constantsObj.TRACK_SPIN, "earn", "w2e", "", economyObj.getSpinCount(), 1, gameObj.getPuzzleSpeciesTracking(), "", "");

        } else if (dailyBonusObj.getIsDailyBonusRewardActive()) {

            // grant reward for w2e watch from daily bonus
            dailyBonusObj.callbackRewardDailyBonusVideo();
        } else if (curScreen == constantsObj.SCREEN_ZEN_MODE) { // keeping check for the blitz screen only
            trackObj.trackCounter(constantsObj.TRACK_CASH, constantsObj.TRACK_EARN, "bz_w2e", "bz", economyObj.getCash() + 10, 10, gameObj.getPuzzleSpeciesTracking(), "", "");
            trackObj.trackCounter(constantsObj.TRACK_CASH, constantsObj.TRACK_SPEND, "bz_w2e", "bz", economyObj.getCash(), -10, gameObj.getPuzzleSpeciesTracking(), "", "");
            zenModeObj.grantAdditionalTime();
        } else {
            var cashToGrant = economyObj.getPriceForHints(constantsObj.TRACK_W2E);//xpromoW2eObj.getRewardValue();
            if (cashToGrant + economyObj.getCash() >= constantsObj.MAX_CASH_ALLOWED) {
                utilObj.showMessage(stringsObj.coin_limit_reached);
                return;
            }

            economyObj.addCash(cashToGrant, constantsObj.TRACK_EARN, constantsObj.TRACK_W2E, "");
            gameObj.setNumVideos(gameObj.getNumVideos() + 1);
            gameObj.setLastRewardedVideoTimestamp(utilObj.getCurrentTimestamp());

            // First lets see if there are any xpromo / okay popups that we need to surface.
            xpromoW2eObj.setCallbackOnClose(adsObj.postPopupShow);
            var openingPopup = false; //xpromoW2eObj.showW2EPopup();
            if (!openingPopup) { // There were no popups / message to surface, we can go ahead with surfacing a toaster message
                adsObj.showCashGrantMessage(cashToGrant);
            }

            // Incrementing progress for watch video type quests and also update quest statuses
            questsObj.incActionForQuestType(xpromoConstantsObj.QUEST_TYPE_WATCH_VIDEOS);
            questsObj.updateAllQuests();

            machineLearningDataObj.setVideoEarns();
        }
    };

    this.postPopupShow = function () {
        if (gameLayer.isVisible() && (curScreen == constantsObj.SCREEN_GAME || lastScreen == constantsObj.SCREEN_GAME)) { // Need to do a redraw only if the gameLayer is currently visible.
            gameLayer.redrawWithoutPopping();
        }
    };

    this.setVideoProvider = function (val) {
        videoProvider = val;
    };

    this.showGrantMessage = function () {
        var cashToGrant = gameObj.getCashToGrant();
        adsObj.showCashGrantMessage(cashToGrant);
    };

    this.showCashGrantMessage = function (cashToGrant) {
        var text1 = stringsObj.coins_added;
        var text2 = stringsObj.coin_added;
        var text = text1;
        if (cashToGrant == 1) {
            text = text2;
        }
        text = text.replace("%N%", cashToGrant);
        utilObj.showMessage(text);
    };

    this.updateTapjoyCash = function (amount) {
        var curTapjoyCash = gameObj.getTapjoyCash();
        var amount1 = parseInt(amount);
        if (curTapjoyCash == constantsObj.NOT_FOUND) {
            // This is a fresh install. Set the Current value
        } else if (curTapjoyCash == amount) {
            // Cash amounts matching. Nothing to do.
        } else {
            var cashDiff = amount - curTapjoyCash;
            if (cashDiff > 0) {
                // updating value for spinner on free coin action
                spinnerObj.updateRevStatusMap();

                // daily bonus rev map update
                dailyBonusObj.updateRevStatusMap();

                // analyticsObj.triggerAdjustEvent(constantsObj.OFFER_EARN);
                analyticsObj.triggerEvents(constantsObj.EVENT_TYPE_OFFERWALL_EARN);
                economyObj.addCash(cashDiff, constantsObj.TRACK_EARN, constantsObj.TRACK_OFFERWALL, constantsObj.TRACK_TAPJOY);
                gameObj.setLastRewardedOfferwallTimestamp(utilObj.getCurrentTimestamp());
                gameObj.setOffercompletedTimeStamp(utilObj.getCurrentTimestamp());
                adsObj.showCashGrantMessage(cashDiff);
                machineLearningDataObj.incOfferwallEarns(cashDiff);
            }

            if (gameObj.getOfferwallAchievement() == false) {
                gameObj.setOfferwallAchievement(true);
                if (curScreen == constantsObj.SCREEN_ACHIEVEMENTS) {
                    achievementsLayer.redraw();
                }
                // Incrementing progress for complete offerwall quest
                questsObj.incActionForQuestType(xpromoConstantsObj.QUEST_TYPE_COMPLETE_OFFER);
            }
        }
        gameObj.setTapjoyCash(amount1);
        // loggerObj.debugLog("Tapjoy cash value:", amount1);
    };

    this.checkBannerForPayer = function () {
        var expBannerPayer = epmObj.getChosenVariant(constantsObj.EXP_BANNER_PAYER);
        var validForNoAds = false;
        if (expBannerPayer == constantsObj.EXP_VAR_CONTROL && gameObj.getIsPayer()) {
            validForNoAds = true;
        }
        if (expBannerPayer == constantsObj.EXP_VAR_1 && gameObj.getIsPayer()) {
            var bannerAdsWatched = gameObj.getCountBannerPayer();
            if (bannerAdsWatched >= runtimeObj.getMaxBannerPayer()) {
                validForNoAds = true;
            }
        }
        if ((!gameObj.getShowAds()) || validForNoAds) {
            return true;
        }
        return false;
    };

    this.updatePlacementLoadStatus = function (resp) {
        var respJson = {};
        try {
            respJson = JSON.parse(resp);
        } catch (e) {

        }
        loggerObj.debugLog("mopub log: ads.js: updatePlacementLoadStatus,", utilObj.getStringifiedJson(respJson));
        var adUnitName = respJson.adUnitName;
        var success = respJson.success;
        if (success) {
            if (adUnitName == adsObj.PLACEMENT_VIDEO_1 || adUnitName == adsObj.PLACEMENT_VIDEO_2) {
                if (!hasUserRequestedVideo) {
                    return;
                }
                var placementNames = adsObj.getOrderedPlacementForVideo();
                if (videoCheckCallbackSet && hasUserRequestedVideo) {
                    window.clearTimeout(videoCheckTimeout);
                    if (callbackFunction != undefined && callbackFunction != null) {
                        loggerObj.debugLog("mopub log: calling function with params");
                        callbackFunction(callbackParams);
                        callbackFunction = null;
                        callbackParams = null;
                    }
                } else if (psMopubAdsObj.isAnyPlacementAvailable(placementNames)) {
                    trackObj.trackCounter(constantsObj.TRACK_AD_TRACKING, constantsObj.TRACK_WATCH, "available_now", utilObj.getCurrentScreenName(), utilObj.isOnline(), "mopub", "", 1, "");
                    utilObj.showMessage(stringsObj.video_available_now);
                }
                adsObj.setHasUserRequestedVideo(false);
                adsObj.setVideoCheckCallbackSet(false);
            } else if (adUnitName == adsObj.PLACEMENT_BANNER) {
                var expBannerPayer = epmObj.getChosenVariant(constantsObj.EXP_BANNER_PAYER);
                if (expBannerPayer == constantsObj.EXP_VAR_1 && gameObj.getIsPayer()) {
                    var countBannerPayer = gameObj.getCountBannerPayer();
                    if (countBannerPayer < runtimeObj.getMaxBannerPayer()) {
                        gameObj.setCountBannerPayer(countBannerPayer + 1);
                        if (gameObj.getCountBannerPayer() >= runtimeObj.getMaxBannerPayer()) {
                            utilObj.delayedCallback(curLayer, utilObj.hideBannerAd, 20, null, null);
                        }
                    }
                }
            }
        }
    };
    
    this.checkRewardedPlacementsToLoadAd = function () {
        var placementNames = adsObj.PLACEMENT_VIDEO_1 + PLACEMENT_NAME_SEPARATOR + adsObj.PLACEMENT_VIDEO_2;

         loggerObj.debugLog("mopub log: video load call from js ");
        // if (epmObj.getChosenVariant(constantsObj.EXP_DAILY_BONUS_NEW) == constantsObj.EXP_VAR_2 && toShowDailyBonus) {
        //     placementNames += PLACEMENT_NAME_SEPARATOR + adsObj.PLACEMENT_VIDEO_3;
        // }
        psMopubAdsObj.loadAdForPlacements(placementNames);
    };

    this.interstitialAdDismiss = function() {
        transOutroLayerV2.afterAdDismiss();
    };
};
