ExperimentManager = function () {
    var experimentsMap = {};
    var experimentsSynced = 0;
    var lastUpdate = 0;
    var lastUserExperimentsSync = 0;
    var experimentController = null;
    var lastSyncedUser = "";
    var lastSyncStart = 0;

    var expAllocations = [];

    var hardCodedExpsIos = "content_experiment:-2:1:1:1:[0.5,0.5];layout_experiment:-3:2:1:1:[0,0,0,1];pricing_experiment:-1:3:1:1:[1,0,0,0,0,0,0,0];free_hints:-2:4:1:1:[0,1];lightning_hint:-2:5:1:1:[1,0,0];list_layout:-3:6:1:1:[1,0];spinner:-1:7:1:1:[1,0];hintRevealBehaviour:-1:8:1:1:[1,0,0];home_screen:-2:9:1:1:[0,1];Nuke:-1:10:1:1:[0,1,0,0,0];privacy_policy:-2:11:1:1:[0,1.0];D0_archive:-2:12:1:1:[0,1,0];hs_revamp:-2:13:1:1:[0,0,1];achv_profile:-1:14:1:1:[1,0];hs:-2:15:1:1:[1,0,0];notif_revamp_new:-3:16:1:1:[0,1,0];homescreen_newui:-3:17:1:1:[0,0,1];homescreen_newui_all:-4:18:1:1:[0,0,1];ccpa:-1:19:1:1:[0.7,0.3];d0_fixed_minis:-1:20:1:1:[0.8, 0.1, 0.1];content_experiment_xp:-1:21:1:1:[1, 0];puzzle_ftue:-2:22:1:1:[0,0,1];";
    var hardCodedExps = "content_experiment:-2:1:1:1:[0.5,0.5];layout_experiment:-3:2:1:1:[0,0,0,1];pricing_experiment:-1:3:1:1:[1,0,0,0,0,0,0,0];free_hints:-2:4:1:1:[0,1];lightning_hint:-2:5:1:1:[1,0,0];list_layout:-3:6:1:1:[1,0];spinner:-1:7:1:1:[1,0];hintRevealBehaviour:-1:8:1:1:[1,0,0];home_screen:-2:9:1:1:[0,1];Nuke:-1:10:1:1:[0,1,0,0,0];privacy_policy:-2:11:1:1:[0,1.0];D0_archive:-2:12:1:1:[0,1,0];hs_revamp:-2:13:1:1:[0,0,1];achv_profile:-1:14:1:1:[1,0];hs:-2:15:1:1:[1,0,0];notif_revamp_new:-3:16:1:1:[0,1,0];homescreen_newui:-3:17:1:1:[0,0,1];homescreen_newui_all:-3:18:1:1:[0,0,1];ccpa:-1:19:1:1:[0.7,0.3];d0_fixed_minis:-1:20:1:1:[0.8, 0.1, 0.1];content_experiment_xp:-1:21:1:1:[1, 0];puzzle_ftue:-2:22:1:1:[0.5,0,0.5];";

    /*var hardCodedExpsIos = "content_experiment:-2:1:1:1:[0.5,0.5];layout_experiment:-3:2:1:1:[0,0,0,1];pricing_experiment:-1:3:1:1:[0.40,0,0,0,0,0,0.60,0];free_hints:-2:4:1:1:[0,1];lightning_hint:-2:5:1:1:[1,0,0];list_layout:-3:6:1:1:[1,0];spinner:-1:7:1:1:[1,0];hintRevealBehaviour:-1:8:1:1:[0.33,0.33,0.34];home_screen:-1:9:1:1:[0,1];Nuke:-1:10:1:1:[0.34,0.33,0.33];privacy_policy:-2:11:1:1:[0,1.0];";
    var hardCodedExps = "content_experiment:-2:1:1:1:[0.5,0.5];layout_experiment:-3:2:1:1:[0,0,0,1];pricing_experiment:-1:3:1:1:[0.40,0,0,0,0,0,0.60,0];free_hints:-2:4:1:1:[0,1];lightning_hint:-2:5:1:1:[1,0,0];list_layout:-3:6:1:1:[1,0];spinner:-1:7:1:1:[1,0];hintRevealBehaviour:-1:8:1:1:[1,0,0];home_screen:-1:9:1:1:[0,1];Nuke:-1:10:1:1:[0.34,0.33,0.33];privacy_policy:-2:11:1:1:[0,1.0];";*/
    var hardCodedAllocationsDone = false;
    var localDataAvailable = false;

    this.init = function () {
        experimentController = gameObj.getGameController();
        localDataAvailable = load();
    };

    function getExperimentObject() {
        var expData = userObj.getUserObj();
        expData.cli = utilObj.getTrackingClient() + "";
        return expData;
    }

    this.getExperimentsSynced = function () {
        return experimentsSynced;
    };

    this.setExperimentsSynced = function (val) {
        experimentsSynced = val;
    };

    this.syncToServer = function (forceSync) {
        var passesBasicChecks = utilObj.passesBasicSyncChecks(lastSyncStart, constantsObj.EXPERIMENT_SYNC_INTERVAL);
        var curTimestamp = utilObj.getCurrentTimestamp();
        var expObjData = getExperimentObject();
        if (gameObj.getIsFirstSyncForUser() == false) {
            trackObj.trackCounter(constantsObj.TRACK_DEBUG, "launch_sync", "start",
                "", "", "", "", "", "");
            gameObj.setTimeStampForFirstExperimentSync(utilObj.getCurrentTimestampMs());
        }
        expObjData.lastUpdate = lastUpdate + "";
        expObjData.userExp = encodeUserExpData(experimentsMap);
        if (passesBasicChecks) {
            lastSyncStart = curTimestamp;
            // loggerObj.debugLog("calling server log : for normal exp sync:", lastUpdate);
            experimentController.sendHttpRequest("exp", "getExp", expObjData);
        } else if (forceSync) {
            lastSyncStart = curTimestamp;
            // loggerObj.debugLog("calling server log : for forced exp sync:", lastUpdate);
            experimentController.sendHttpRequest("exp", "fetch", expObjData);
        }
    };

    this.respHandler = function (action, data, success) {
        // loggerObj.debugLog("Experiments resp: ", action, utilObj.getStringifiedJson(data));
        if (action === "sync") {
            if (gameObj.getIsFirstSyncForUser() == false) {
                gameObj.setIsFirstSyncForUser(true);
                if (success == false) {
                    trackObj.trackCounter(constantsObj.TRACK_DEBUG, "launch_sync", "fail",
                        "", "", "", "", "", "");
                } else {
                    var timeForSync = (utilObj.getCurrentTimestampMs() - gameObj.getTimeStampForFirstExperimentSync());
                    trackObj.trackCounter(constantsObj.TRACK_DEBUG, "launch_sync", "end",
                        timeForSync + "", "", "", "", "", "");
                }
            }
            if (success == false) {
                experimentsSynced = 1;
                return;
            }
            experimentsSynced = 1;


            lastUpdate = data.lastUpdate;
            var currentSyncedUser = data.refId;
            var experimentsVariantsMap = {};
            var userExpArr = decodeUserExpData(data.userExp);
            for (var i = 0; i < userExpArr.length; i++) {
                var obj = userExpArr[i];
                if (obj.hasOwnProperty("expName") && obj.hasOwnProperty("version")) {
                    var key = obj.expName + "_" + obj.version;
                    experimentsVariantsMap[key] = obj.chosenVariant;
                }
            }
            var gameExperiments = decodeGameExpData(data.exp);
            // loggerObj.debugLog("experiment variants map", utilObj.getStringifiedJson(experimentsVariantsMap), utilObj.getStringifiedJson(gameExperiments));
            var experimentsUpdated = false;
            var syncedExpNames = [];
            // loggerObj.debugLog("Exp var map:", utilObj.getStringifiedJson(experimentsVariantsMap));
            for (var i = 0; i < gameExperiments.length; i++) {
                var syncedExp = new Experiment();
                syncedExp.initWithExp(gameExperiments[i]);

                var name = syncedExp.getExpName();
                var version = syncedExp.getVersion();
                var gaDim = syncedExp.getGaDim();
                syncedExpNames.push(name);

                var toTrack = false;
                // Check if server already contains the information for
                // the user,experiment, variant, if the server has the information take it
                var key = name + "_" + version;
                var currentExperiment = epmObj.getExperiment(name);
                var variant;
                // loggerObj.debugLog("Looking for key:", key);

                if (key in experimentsVariantsMap) {
                    // case when server has already got some information for this user with the current experiment and variant
                    variant = syncedExp.assignVariant(experimentsVariantsMap[key]);
                } else if (currentExperiment != null && currentExperiment.getVersion() == version) {
                    // case of a reinstall, logout, login case when the client has some
                    // information for the current experiment and variant, we try to use it
                    // instead of creating a new
                    variant = syncedExp.assignVariant(currentExperiment.getChosenVariant());
                    toTrack = true;
                } else if (currentExperiment != null && parseInt(currentExperiment.getVersion()) < 0) {
                    // This is a hard coded exp. Don't reallocate.
                    variant = currentExperiment.getChosenVariant();
                    // loggerObj.debugLog("Not allocating for exp:", key, variant);
                    syncedExp = currentExperiment;
                } else if (currentExperiment != null && parseInt(currentExperiment.getVersion()) < parseInt(version)) {
                    variant = syncedExp.reallocateVariant(currentExperiment);
                } else {
                    // when neither the client nor the server has information about the current exp and variant
                    variant = syncedExp.allocateVariant();
                    toTrack = true;
                }

                if (toTrack) {
                    epmObj.saveExpAllocationForTracking(name, version, variant, gaDim);
                }

                var expUpdated = true;
                if (utilObj.isNative()) {
                    expUpdated = true;
                    if (currentSyncedUser == lastSyncedUser) {
                        if (name in experimentsMap) {
                            var currDeployedVersion = experimentsMap[name].getVersion();
                            if (currDeployedVersion === version) {
                                expUpdated = false;
                            }
                            if (!experimentsVariantsMap.hasOwnProperty(key)) {
                                // loggerObj.debugLog("not found key ", key);
                                expUpdated = true;
                            }
                        }
                    }
                    // loggerObj.debugLog("expName:", name, expUpdated, variant);
                    experimentsUpdated = experimentsUpdated || expUpdated;
                }
                if (expUpdated == true) {
                    experimentsMap[name] = syncedExp;
                    // loggerObj.debugLog("experimentLog: expUpdated true for -> ", utilObj.getStringifiedJson(syncedExp));
                } else if (variant != constantsObj.NOT_FOUND) {
                    // updating only the chosen variant for the current experiment here
                    if (currentExperiment != null) {
                        currentExperiment.setChosenVariant(variant);
                        experimentsMap[name] = currentExperiment;
                        // loggerObj.debugLog("experimentLog: variant set here -> ", variant, utilObj.getStringifiedJson(experimentsMap[name].toJson()));
                    }
                }
            }

            /*if(curScreen == constantsObj.SCREEN_GAME){
                gameLayer.redraw();
            }*/

            // clear the experiments which do not exist anymore
            var existingExpNames = [];
            for (var key in experimentsMap) {
                if (experimentsMap.hasOwnProperty(key)) {
                    existingExpNames.push(key);
                }
            }
            for (var key in existingExpNames) {
                if (!(syncedExpNames.hasOwnProperty(key))) {
                    delete experimentsMap[key];
                }
            }

            if (experimentsUpdated) {
                epmObj.trackExpAllocation();
                epmObj.updateUserObject(true);
            }
            lastSyncedUser = userObj.getRefId();
            // economyObj.setInitCash();
            save();
            // gameObj.loadPuzzles(); - Not doing this as if done in the middle of things, it leads to crashes

            localDataAvailable = true;
            if(pspnFlutterObj != undefined && pspnFlutterObj.isFlutterEnabled()) {
                pspnFlutterObj.tryInitializeFlutterQuestCenter();
                pspnFlutterObj.updateFlutterExperiments();
            }

        } else if (action === "update") {
            lastUserExperimentsSync = utilObj.getCurrentTimestamp();
            save();
        } else if (action == "no_update") {
        } else {
            // loggerObj.debugLog("Unknown action received from experiment server.Action:" + action + ";Data:" + utilObj.getStringifiedJson(data));
        }
    };

    function performHardCodedAllocations() {
        if (hardCodedAllocationsDone) {
            return;
        }
        hardCodedAllocationsDone = true;
        // loggerObj.debugLog("Attempting to allocate hard coded experiments:", utilObj.isIos());
        var hardCodedToUse = hardCodedExps;
        if (utilObj.isIos()) {
            hardCodedToUse = hardCodedExpsIos;
        }
        var gameExperiments = decodeGameExpData(hardCodedToUse);
        var hardCodedExpNames = [];
        var allocationHappened = false;
        for (var i = 0; i < gameExperiments.length; i++) {
            var hardCodedExp = new Experiment();
            hardCodedExp.initWithExp(gameExperiments[i]);

            var name = hardCodedExp.getExpName();
            var version = hardCodedExp.getVersion();
            var gaDim = hardCodedExp.getGaDim();
            hardCodedExpNames.push(name);

            var currentExp = epmObj.getExperiment(name);
            if (currentExp == null || currentExp.getVersion() != version) {
                if (!allocationHappened && currentExp != null) {
                    allocationHappened = true;
                }
                var variant = 0;
                if (currentExp == null) {
                    variant = hardCodedExp.allocateVariant();
                } else {
                    variant = hardCodedExp.reallocateVariant(currentExp);
                }
                // loggerObj.debugLog("Performing allocation for hard coded exp:", name, variant);
                experimentsMap[name] = hardCodedExp;
                epmObj.saveExpAllocationForTracking(name, version, variant, gaDim);
            }
        }
        epmObj.trackExpAllocation();
        if (allocationHappened) {
            epmObj.updateUserObject(true);
            save();
        }

    }

    this.updateUserObject = function (forceUpdate) {
        if (userObj.getRefId() == "" || userObj.getRefId() == undefined || !utilObj.isPingWorking()) {
            return;
        }

        var curTimestamp = utilObj.getCurrentTimestamp();
        if (forceUpdate || (curTimestamp - lastUserExperimentsSync > constantsObj.SECONDS_IN_DAY)) {
            var expObj = getExperimentObject();
            expObj.userExp = encodeUserExpData(experimentsMap);
            experimentController.sendHttpRequest("exp", "update", expObj);
        }
    };

    this.reset = function () {
        lastUpdate = 0;
        lastUserExperimentsSync = 0;
        lastSyncStart = 0;
    };

    function load() {
        var expJson = ls.getItem(constantsObj.EXPERIMENTS_FILE);
        if (expJson == null || expJson == "") {
            // loggerObj.debugLog("No experiment data found.");
            performHardCodedAllocations();
            return false;
        }
        expJson = JSON.parse(expJson);
        // loggerObj.debugLog("Exp json is:", JSON.stringify(expJson));
        var arr = expJson["arr"];
        for (var ix = 0; ix < arr.length; ix++) {
            var tempExpObj = new Experiment();
            tempExpObj.initWithExp(arr[ix]);
            var expName = tempExpObj.getExpName();
            if (experimentsMap[expName] == undefined) {
                experimentsMap[expName] = tempExpObj;
            }
        }
        performHardCodedAllocations(); // In case some variant has changed in the hard coded experiments.
        // loggerObj.debugLog("Exp map json is:", JSON.stringify(experimentsMap));
        lastUserExperimentsSync = expJson.lastUserExperimentsSync;
        lastSyncedUser = expJson.lastSyncedUser;
        if (expJson.lastUpdate != undefined) {
            lastUpdate = expJson.lastUpdate;
        }
        return true;
    }

    this.getExperimentsMap = function () {
        return utilObj.getStringifiedJson(experimentsMap);
    };

    function save() {
        var expJson = {};
        var arr = [];
        for (var key in experimentsMap) {
            if (experimentsMap.hasOwnProperty(key)) {
                arr.push(experimentsMap[key].toJson());
            }
        }
        expJson["arr"] = arr;
        expJson["lastUpdate"] = lastUpdate;
        expJson["lastSyncedUser"] = lastSyncedUser;
        expJson["lastUserExperimentsSync"] = lastUserExperimentsSync;
        ls.setItem(constantsObj.EXPERIMENTS_FILE, utilObj.getStringifiedJson(expJson));
        return true;
    }

    this.getExperiment = function (expName) {
        if (experimentsMap.hasOwnProperty(expName)) {
            var exp = experimentsMap[expName];
            if (exp.isAvailable()) {
                return exp;
            } else {
                return null;
            }
        } else {
            return null;
        }
    };

    this.doesExpExist = function (expName) {
        var exp = epmObj.getExperiment(expName);
        if (exp == null) {
            return false;
        }
        return true;
    };

    this.saveExpAllocationForTracking = function (expName, version, chosenVariant, gaDim) {
        expAllocations.push({name: expName, version: version, variant: chosenVariant, gaDim: gaDim});
    };

    this.trackExpAllocation = function () {
        for (var i = 0; i < expAllocations.length; i++) {
            var exp = expAllocations[i];
            if (!exp || !exp.name) {
                continue;
            }
            var varTracking = '';
            if (exp.variant == 0) {
                varTracking = "control";
            } else {
                varTracking = "var" + exp.variant;
            }
            expAllocations[i].varTracking = varTracking;
            trackObj.trackCounter(constantsObj.TRACK_EXPERIMENT, exp.name, exp.version, varTracking, "", "", "", "0", "");
            // loggerObj.debugLog("Tracking exp allocation", exp.name, exp.version, varTracking);
        }
        // analyticsObj.allocateUserToExperiments(utilObj.getStringifiedJson(expAllocations));
        expAllocations = [];
    };

    this.getChosenVariant = function (expName) {
        if (xpromoUtilObj.isWebStaging()) {
            if (expName == constantsObj.EXP_HOME_SCREEN_REVAMP_NEW) {
                return constantsObj.EXP_VAR_2;
            }
            if (qaConfigObj != undefined && qaConfigObj != null) {
                var variant = qaConfigObj.getQAConfigData(expName + "_variant");
                if (variant == constantsObj.EXP_VAR_CONTROL) {
                    return constantsObj.EXP_VAR_CONTROL;
                }
                if (variant != "" && variant != -1) {
                    return variant;
                }
            }
        }
        var exp = epmObj.getExperiment(expName);
        var variant = constantsObj.EXP_VAR_CONTROL;
        if (expName == constantsObj.EXP_VIDEO_INTERSTITAL || expName == constantsObj.EXP_OOC_STORE) {
            variant = constantsObj.EXP_VAR_2;
        } else if (expName == constantsObj.EXP_BANNER || expName == constantsObj.EXP_ACHIEVEMENTS) {
            variant = constantsObj.EXP_VAR_1;
        }
        /*if (exp == this.EXP_LAYOUT) {
            variant = constantsObj.EXP_VAR_3;
        } else if (exp == this.EXP_ACHIEVEMENTS) {
            variant = constantsObj.EXP_VAR_1;
        }  else if (exp == this.EXP_LIST_LAYOUT) {
            variant = constantsObj.EXP_VAR_1;
        }*/
        if (exp != null) {
            // //loggerObj.debugLog("experiment before sync ->", JSON.stringify(expName)," variant -> ", JSON.stringify(variant));
            variant = exp.getChosenVariant();
            // //loggerObj.debugLog("experiment after sync ->", JSON.stringify(expName)," variant -> ", JSON.stringify(variant));
        }

        if (expName == constantsObj.EXP_INTRO_OUTRO_REVAMP || expName == constantsObj.EXP_INTRO_REVAMP_2 || expName == constantsObj.EXP_FRENZY || expName == constantsObj.EXP_FRENZY_GLOBAL) {
            variant = constantsObj.EXP_VAR_1;
        }
        if (expName == constantsObj.EXP_FRENZY_V2 || expName == constantsObj.EXP_W2E_POWER_UP) {
            variant = constantsObj.EXP_VAR_2;
        }

        return parseInt(variant);
    };

    /**
     * this function returns the list of all the experiments (experiment names)
     * @returns {Array}
     */
    this.getAllExperimentKeys = function () {
        var expKeys = [];
        for (var key in experimentsMap) {
            if (experimentsMap.hasOwnProperty(key)) {
                // loggerObj.debugLog("debugFunctionalityLog: experimentKeys are -> ", key);
                expKeys.push(key);
            }
        }
        return expKeys;
    };

    /**
     * this function gets the names of all the variants of the given experiment
     * @param expName
     * @returns {Array}
     */
    this.getVariantNamesForExperiment = function (expName) {
        var variantsDetails = epmObj.getVariantsForExperiment(expName);
        var numVariants = variantsDetails.length;
        var variantNamesArr = [];
        for(var j = 0; j < numVariants; j++) {
            variantNamesArr.push(variantsDetails[j].getName());
        }
        return variantNamesArr;
    };

    /**
     * this function returns the variants details for the given experiment
     * @param expName
     * @returns {Array}
     */
    this.getVariantsForExperiment = function (expName) {
        var exp = epmObj.getExperiment(expName);
        var variantDetailsArr = [];
        if(exp != null){
            variantDetailsArr = exp.getVariants();
        }
        return variantDetailsArr;
    };

    /**
     * this function returns the number of variants available for an experiment
     * @param expName
     * @returns {Number}
     */
    this.getNumVariantsForExperiment = function(expName) {
        var varArr = epmObj.getVariantsForExperiment(expName);
        return varArr.length;
    };

    this.doesVariantExistForExperiment = function (expName, variant) {
        if(expName == undefined || variant == undefined) {
            // loggerObj.debugLog("experimentLog: undefined expName or variant while assigning variant to experiment -> ", expName, variant);
            return false;
        }

        var variantNamesForExp = epmObj.getVariantNamesForExperiment(expName);
        if(variantNamesForExp.indexOf(variant) == -1) {
            // loggerObj.debugLog("experimentLog: the given variant does not exist for the given experiment -> ", expName, variant);
            return false;
        }

        return true;
    };

    /**
     * this function assigns a given variant for the given experiment
     * @param expName
     * @param variant
     * @returns {boolean}
     */
    this.assignVariantForExperiment = function (expName, variant) {
        if(expName == undefined || variant == undefined) {
            // loggerObj.debugLog("experimentLog: undefined expName or variant while assigning variant to experiment -> ", expName, variant);
            return false;
        }

        if(!epmObj.doesExpExist(expName)) {
            // loggerObj.debugLog("experimentLog: cannot assign variant to a non-existing experiment -> ", expName, variant);
            return false;
        }

        var exp = epmObj.getExperiment(expName);
        if(!epmObj.doesVariantExistForExperiment(expName, variant)) {
            // loggerObj.debugLog("experimentLog: given variant does not exist for the given experiment -> ", expName, variant);
            return false;
        }

        exp.assignVariant(variant);
        return true;
    };

    function decodeUserExpData(encodedStr) {
        var experimentsArr = [];
        var expArr = encodedStr.split(",");
        for (var i = 0; i < expArr.length; i++) {
            var expStr = expArr[i];
            var keys = expStr.split(":");
            var exp = {};
            exp.expName = keys[0];
            exp.version = keys[1];
            exp.chosenVariant = keys[2];
            experimentsArr.push(exp);
        }
        return experimentsArr;
    }

    function encodeUserExpData(obj) {
        //[<exp_name>:<version>:<variant>,]
        var expDesc = null;
        for (var key in obj) {
            if (obj.hasOwnProperty(key)) {
                var exp = obj[key];
                var desc = exp.getExpName() + ":" + exp.getVersion() + ":" + exp.getChosenVariant();
                if (expDesc == null) {
                    expDesc = desc;
                } else {
                    expDesc = expDesc + "," + desc;
                }
            }
        }
        return expDesc
    }

    function decodeGameExpData(encoding) {
        var jarr = [];
        var expArr = encoding.split(";");
        for (var ix = 0; ix < expArr.length; ix++) {
            var exp = expArr[ix];
            if (exp == "") {
                continue;
            }
            var expKeys = exp.split(":");
            var expObj = {};
            for (var jx = 0; jx < expKeys.length; jx++) {
                expObj.expName = expKeys[0];
                expObj.version = expKeys[1];
                expObj.gaDim = parseInt(expKeys[2]);
                expObj.androidSwitch = parseInt(expKeys[3]);
                expObj.iosSwitch = parseInt(expKeys[4]);
                expObj.variant = [];
                var variantArr = expKeys[5].substring(1,
                    expKeys[5].length - 1).split(",");

                for (var kx = 0; kx < variantArr.length; kx++) {
                    var v = {};
                    v["name"] = kx;
                    v["prob"] = parseFloat(variantArr[kx]);
                    expObj.variant.push(v);
                }
            }
            jarr.push(expObj);
        }
        return jarr;
    }

    this.isLocalDataAvailable = function() {
        return localDataAvailable;
    }
};

Variant = function () {
    var name, prob;

    this.init = function (obj) {
        name = obj["name"];
        prob = obj["prob"];
    };

    this.toJson = function () {
        var jObj = {};
        jObj["name"] = name;
        jObj["prob"] = prob;
        return jObj;
    };

    this.getProb = function () {
        return prob;
    };

    this.getName = function () {
        return name;
    }
};

Experiment = function () {

    var expName,
        version,
        gaDim,
        chosenVariant,
        iosSwitch = 1,
        androidSwitch = 1;

    var variants = [];

    this.init = function () {
        expName = "";
        version = "";
        variants = [];
        gaDim = -1;
        chosenVariant = "";
        iosSwitch = 1;
        androidSwitch = 1;
    };

    this.isAvailable = function () {
        return checkAllowed();
    };

    function checkAllowed() {
        var allowed = true;
        var ver = parseInt(version);
        if (ver < 0) {
            // loggerObj.debugLog("Hard coded exp always allowed:", ver);
            return true;
        }
        if (utilObj.isAndroid() && androidSwitch != 1) {
            allowed = false;
        }

        if (utilObj.isIos() && iosSwitch != 1) {
            allowed = false;
        }
        return allowed;
    }

    this.initWithExp = function (experimentJson) {
        expName = experimentJson["expName"];
        version = experimentJson["version"];
        variants = [];
        for (var ix = 0; ix < experimentJson["variant"].length; ix++) {
            var tempVariant = new Variant();
            tempVariant.init(experimentJson["variant"][ix]);
            variants.push(tempVariant);
        }
        chosenVariant = "";
        if (experimentJson.hasOwnProperty("chosenVariant")) {
            // would be present in case of load, but would be absent in case
            // of sync from server
            chosenVariant = experimentJson["chosenVariant"];
        }
        gaDim = experimentJson["gaDim"];
        if (experimentJson.hasOwnProperty("androidSwitch")) {
            androidSwitch = parseInt(experimentJson["androidSwitch"]);
        } else {
            androidSwitch = 1;
        }

        if (experimentJson.hasOwnProperty("iosSwitch")) {
            iosSwitch = parseInt(experimentJson["iosSwitch"]);
        } else {
            iosSwitch = 1;
        }
    };

    this.setChosenVariant = function (variant) {
        chosenVariant = variant;
    };

    this.getIosSwitch = function () {
        return iosSwitch;
    };

    this.getAndroidSwitch = function () {
        return androidSwitch;
    };

    this.getExpName = function () {
        return expName;
    };

    this.getVersion = function () {
        return version;
    };

    this.getVariants = function () {
        return variants;
    };

    this.getChosenVariant = function () {
        if (!checkAllowed()) {
            // loggerObj.debugLog("Experiment not allowed:", expName, androidSwitch, iosSwitch);
            return constantsObj.EXP_VAR_CONTROL;
        }

        if (chosenVariant == "" || chosenVariant == null) {
            loggerObj.traceLog("Experiment chosenVariant null", expName, chosenVariant);
            return constantsObj.EXP_VAR_CONTROL;
        }
        // loggerObj.debugLog("Experiment chosen variant:", expName, chosenVariant);
        return chosenVariant;
    };

    this.getGaDim = function () {
        return gaDim;
    };

    this.toJson = function () {
        var jObj = {};
        jObj["expName"] = expName;
        jObj["version"] = version;
        var arr = [];
        for (var ix = 0; ix < variants.length; ix++) {
            arr.push(variants[ix].toJson());
        }
        jObj["variant"] = arr;
        jObj["chosenVariant"] = chosenVariant;
        jObj["gaDim"] = gaDim;
        jObj["androidSwitch"] = androidSwitch;
        jObj["iosSwitch"] = iosSwitch;
        return jObj;
    };

    this.reallocateVariant = function (oldExperimentInfo) {
        var allowed = checkAllowed();
        if (!allowed) {
            // loggerObj.debugLog("Experiment not allocated:", expName, constantsObj.EXP_VAR_CONTROL);
            return constantsObj.EXP_VAR_CONTROL;
        }

        var oldChosenVariant = parseInt(oldExperimentInfo.getChosenVariant());
        var oldVariants = oldExperimentInfo.getVariants();
        var oldVariantProb = oldVariants[oldChosenVariant].getProb();
        var currentVariantProb = variants[oldChosenVariant].getProb();
        if (currentVariantProb != 0 && currentVariantProb >= oldVariantProb) {
            chosenVariant = oldChosenVariant;
            //loggerObj.debugLog("Experiment - variant change not required for user:", oldChosenVariant, oldVariants[oldChosenVariant].getProb(), variants[oldChosenVariant].getProb())
        } else {
            var firstDice = Math.random();
            // Current probability for this variant is less than last probability for this variant.
            // The portion of users which need to move away from this variant is:
            var movePortion = 1;
            if(oldVariantProb != 0){
                movePortion = (oldVariantProb - currentVariantProb) / oldVariantProb;
            }
            if (firstDice < movePortion) {
                // These guys need to move to a different variant.
                // For moving to a different variant, we need to do the calculations.
                var secondDice = Math.random();
                var maxLen = oldVariants.length;
                if (variants.length > maxLen) {
                    maxLen = variants.length;
                }
                // Sum of positive differences to last version
                var sumOfDiffs = 0;
                var possibleVariants = [];
                for (var ix = 0; ix < maxLen; ix++) {
                    var oldProb = 0;
                    var curProb = 0;
                    if (oldVariants[ix] != undefined) {
                        oldProb = oldVariants[ix].getProb();
                    }
                    if (variants[ix] != undefined) {
                        curProb = variants[ix].getProb();
                    }
                    var diff = curProb - oldProb;
                    if (diff > 0) {
                        // This is one of the possible variants to which the move needs to happen.
                        sumOfDiffs += diff;
                        possibleVariants.push({v: ix, d: diff})
                    }
                }
                var cumValue = 0;
                var allocationDone = false;
                for (var ix = 0; ix < possibleVariants.length; ix++) {
                    var info = possibleVariants[ix];
                    var portion = info.d / sumOfDiffs;
                    cumValue += portion;
                    //loggerObj.debugLog("Experiment - cumulative value:", portion, cumValue, info.d, info.v);
                    if (cumValue >= secondDice) {
                        chosenVariant = info.v;
                        allocationDone = true;
                        //loggerObj.debugLog("Experiment - new variant chosen:", chosenVariant);
                        break;
                    }
                }
                if (!allocationDone) {
                    // Might have been due to some float calculations.
                    // Assign the last variant.
                    if (possibleVariants.length > 0) {
                        chosenVariant = possibleVariants[possibleVariants.length - 1].v;
                    } else {
                        chosenVariant = constantsObj.EXP_VAR_CONTROL;
                    }

                }
            } else {
                // These guys continue to stick to their oldVariant.
                chosenVariant = oldChosenVariant;
            }
        }

        trackObj.trackCounter(constantsObj.TRACK_EXPERIMENT, expName, version, this.getVarForTracking(chosenVariant), constantsObj.TRACK_ALLOCATE, "", "", "0", "");
        return chosenVariant;
    };

    this.allocateVariant = function () {
        var allowed = checkAllowed();
        if (!allowed) {
            // loggerObj.debugLog("Experiment not allocated:", expName, constantsObj.EXP_VAR_CONTROL);
            return constantsObj.EXP_VAR_CONTROL;
        }

        var experimentProb = Math.random();
        var cumValue = 0;
        var ix = 0;
        for (; ix < variants.length; ix++) {
            cumValue += variants[ix].getProb();
            if (experimentProb < cumValue) {
                break;
            }
        }
        if (ix == variants.length) {
            chosenVariant = constantsObj.EXP_VAR_CONTROL;
        } else {
            chosenVariant = variants[ix].getName();
        }

        loggerObj.traceLog("Experiment allocated:", expName, chosenVariant);
        utilObj.syncFabricEvent("exp_allocate_" + expName, chosenVariant);
        return chosenVariant;
    };


    this.assignVariant = function (variant) {
        loggerObj.traceLog("Experiment assigned:", expName, variant);
        utilObj.syncFabricEvent("exp_assign_" + expName, chosenVariant);
        chosenVariant = variant;
        return variant;
    };

    this.getVarForTracking = function (variant) {
        var varTracking = '';
        if (variant == 0) {
            varTracking = "control";
        } else {
            varTracking = "var" + variant;
        }
        return varTracking;
    };
};