Runtime = function () {
    var lastUpdate = 0;
    var lastSyncStart = 0;
    var runtimeController = null;

    var fbConnectCash = 10;
    var revealCount = 10;
    var puzzlesVersion = constantsObj.PUZZLES_VERSION;
    var dailyMiniVersion = constantsObj.DAILY_MINI_JSON_VERSION;
    var newPackVersion = constantsObj.PACK_VERSION;
    var themedQuestJsonVersion = constantsObj.THEMED_QUEST_JSON_VERSION;
    var interstitial_cooldown_screens = "7:7:7:7";
    var numVideos = "2:4";
    var numVideosNew = "3:5:3";
    var numVideosVar1 = "3:8:2";
    var interstitialOnPuzzleScreen = "0:4:6:3:2";
    var mastery_grant_control = "1:1:1";
    var mastery_grant_var6 = "3:2:1";
    var w2eRewardedCoins = 10;
    var forceUpdate = 0;
    var watchToEarnFtueCooldownHours = 6;
    var startSpin = constantsObj.START_SPIN;
    var refillRate = 6;
    var maxW2eVideosSpinner = 10;
    var placementPriority = ["", "", ""];
    var placementPriorityObj = new PlacementPriority();
    var placementResetTime = 5;
    var autoOnResetTime = 0;

    var maxCreatureSpins = 20;
    var maxCreatureCoins = 50;
    var creatureGrantInterval = 1800;
    var adType = 2;
    var ironsourceTapjoy = 1;
    var IronsourceReceptive = 1;
    var CountWatchedVideo = 2;
    var countWatchedVideoPayer = 1;
    var notif_perm_c = 40;
    var notif_perm_v = 60;
    var supportJsonVersion = "v1";
    var MopubNativeAdsRefreshInterval = 20;
    //var freeRevealWord = constantsObj.START_FREE_REVEAL_WORD;
    //var freeRevealLetters = constantsObj.START_FREE_REVEAL_LETTERS;
    var adwallCooldownTime = 30;
    var adwallLimit = 5;
    var adWallDays = 1;
    var isPrivacyPolicyOn = 1;
    var fb_mediation = 1;
    var mystery_reward_threshold = "6:23:40";
    var wqTotalstars = 30;
    var wqMilestones = "5:20:30";
    var Wq_payer_prob = "0:0:100:0:0:100:0:0:100";
    var Wq_payer_reward = "20:15:10:30:25:20:60:55:50";
    var Wq_prob = "10:30:60:10:30:60:10:30:60";
    var Wq_reward = "20:15:10:30:25:20:60:55:50";
    var wqTotalstarsHard = 30;
    var wqMilestonesHard = "5:20:30";
    var Wq_payer_prob_hard = "0:0:100:0:0:100:0:0:100";
    var Wq_payer_reward_hard = "20:15:10:30:25:20:60:55:50";
    var Wq_prob_hard = "10:30:60:10:30:60:10:30:60";
    var Wq_reward_hard = "20:15:10:30:25:20:60:55:50";
    var mystery_reward_probability = "0.285:0.428:0.428:0.571:0.3:0.4:0.5";
    var mystery_reward_threshold_p = "10:20:30";
    var coolDownRecommendationPopup = 48;
    var frenzy_hard = 3;
    var frenzy_easy = 6;
    var frenzy_max_reveal = 50;
    var frenzy_avg_days = 2;
    var frenzy_start_day = 1;
    var video_var1 = 10;
    var video_var2 = 5;
    var poverty_line = 10;
    var bonusArchiveSwitch = 1;
    var garbageCollectionSwitch = 0;
    var battery_opti = 0;
    var videoOrPopupCooldown = 3;
    var subscriptionFreeTrialDuration = 3;
    var static_int = 1;
    var coolDownForBonusDailyMini = 2;
    var coolDownForBonusDailyMiniSubs = 1;
    var coolDownForSubsPopup = 5;
    var numberOfSubsPopup = 2;
    var coolDownForSubsDialog = 10;
    var newPurchaseFlow = 1;

    var spinWheelProb = new SpinnerWheelProb();
    var watch2EarnCoinsReward = new Watch2EarnCoinsReward();
    var mystery_w2e_coolDown = 7;
    var mastery_mini_archive = 5;
    var mopubVideoRetryParams = new MopubVideoRetryParams();
    var mini_mastery_time = "1:2";
    var main_mastery_time = "10:20";
    var mopubVideoPriority = 1;
    var videoIntCount = 7;
    var coolDownTimeForVIOnOutro = 50;
    var w2ePowerUpCoolDown = 60;
    var w2ePowerUpTimer = 10;
    var numberOfBonusArchive = 4;
    var w2ePowerUpLimit = "6:4";
    var w2ePowerUpDayLimit = 0;
    var weeklyQuestMasteryLimit = 50;
    var bonusArchiveOutro = 0;
    var homeCarouselParams = new HomeCarouselParams();
    var dcaQuestMap = new DailyChallengeAnimationQuestMap();
    var adaptive_start = "2_3:4_5";
    var puzzleRequired_adaptive = "3:4";
    var adaptive_averageMastery = "2.2:2_3";

    // w2e highlights runtimes
    var w2eHighlight = new W2eHighlight();
    var w2eHighlightStr = "";

    // Download Manager
    var rawRuntime = {};

    // review version for iOS
    var reviewVersion = -1;

    // blitx runtimes
    var blitzRuntimes = new BlitzRuntimes();
    var blitzRuntimesStr = "";
    var blitzRewardRuntimes = new BlitzRewardRuntimes();
    var blitzRewardRuntimeStr = "";

    //contextual w2e runtimes
    var contextualW2eRuntimes = new ContextualW2eRuntimes();
    var contextualW2eRuntimesStr = "";

    // streak rewards
    var streak_reward_small = 10;
    var streak_reward_grand = 20;



    // spinner runtimes
    var spinner_rewardProb =  "40_0_0_40_20_0_40_0_0_30_30_0_40_0_0_30_30_0_40_0_0_40_20_0_40_0_0_30_30_0_30_10_0_30_30_0_10_30_30_10_10_10_10_30_30_10_10_10_10_30_30_10_10_10_50_3_1_35_10_1";

    var spinnerRuntimes = new SpinnerRuntimesNew();
    var spinnerRuntimesStr = "";

    var vidlaunchdelay = 3;
    // mopub runtime
    var mopubAdUnits = "5-3a4580edd2b544e59eaab4aca0391fab-6de1171bb4fc41b8acaa3de0ac1fce17-e381694ca04e41f7a5093eede0d8094c-92a0b0eb573340b99e0e495e457a58e6-d787c970fe524ef0854689966e2eb4bf:5-29b66fdc491746f2b7b8ce7a71767206-2f93e05aa2364ec386d531259fbd0f1d-98b01bf05f894160a8d3dcf514026d89-f93156c53dfd4d7cbce9f2448b54d350-41ab153a37294429b4485e8976c57edf:5-026ebd9515694c1b92218998d88d2588-8196f3628fe44106864bb1ffd15677f2-a39f0ec5c21e49d8915c5f0f68249798-196d7c4254f84a3cb5ca97862b1163ed-92a4513871eb44109db66793d8bc9e0f:5-3cfa194d54a1487aaa286569d98f22fd-fe5c5f51b52349bc9cb2a4b9d8e6b0ba-55e012c3931a47c1bb22e2e2c2908c07-4fa64c6c1de24d8e9ee1f621b62b1ede-9d2b010662194a85aa442673c567033c:5-83ea7c81bf634b7e8654cb3b03235250-e612f9f181f44c62bda7ce57c443f23d-264b61fb5d5d463c852b02340756c376-2a61dbc0372b4816b221e43161c75e12-319c0741d35546018b6c58c5dc632a32:5-e5b01dcfc14246e48443a7839983d0e6-8ae0d4ff6e0a48218688f05a4fc14d5b-07e4854177094ab1b8093487494ce3fa-4ef35d0682c24b9eae4de6a2f26e5e80-a7917e60e8fb43589af06e38e70ae7d2:5-02bd2390482b4cd099bfdd74229a5908-8312c91fc0cd420481b8524148715fab-591f659d76eb43cb8964ba445eecbb52-7d774187fd8946369acbfeb742b4a63d-550c092da96546ea8e001fefc5e13819:5-4c966b05a27d4c4f985fef7f131c9415-bda2ef62061b42fb98192c24b9fb0058-62b2ae00c86848b6b26072bb3e3b1a75-2761aa6fc8984e9a9148ac43f8e5bcb3-e032ded8d56543cd9f02a7b1b60a75f3:5-13c1d71f1943468a9ffdc3621abda22e-606c583cbac643c28e55a53e0454e94c-1d0fcc4590bb4f68ba8503890f04b6fd-1c29bad10e0e4a7783621c15b2990ca4-afd2fe3a8d8141628a7e3740314f6f9d:5-71744f0a08f34f7c8c6c57e21f908273-c0073e1879db45b9a70974895ad22930-1a1295578c164c6f95c514f4eba97663-5330e5b49e134af180b30991b4fed0da-c2e9d2dd313f4b19a0dc36301467687c";
    var mopubBannerRefresh = 20;

    var mopubAdUnitsIos = "6-e975d5f2071941c0873fc32294ceee87-e975d5f2071941c0873fc32294ceee87-a02f860c6aaa4e2dac01e7796810e59d-04cf0df364204581bd9e0c3d02898375-b9d6c9d2bea742dfbe1d1e4b217d6644-9ccafc3bda354f3a82a3e9f543069c9f:6-95bffa259d9041c48246331cc045c193-95bffa259d9041c48246331cc045c193-14ff553aba58450ab6761d59452dbfa0-8bb5d0acaee64782985a9291c63a88f6-d93b8621b4594ee092233426eb421efe-4b620583925041c7a1311f26d9d6f905:6-192fb965941346e4b92c56a1ef5763b5-192fb965941346e4b92c56a1ef5763b5-5f26027c0d9c4751b811971262e76cbd-97099100e6314493ab9ce6d265a70a9c-00131184439b46c6bb87f344354046cc-ef200b77e7bf4b2491be78a9b2106250:6-623c99ba93fc4ab29e0beb8cac2bc244-623c99ba93fc4ab29e0beb8cac2bc244-01a2eb77a9a74333899fdb3c79085220-1c8d38e0dfc2496d86ab8364406c80dc-043270e903d344a4a47c1e39d17517b4-edc679e97fcf4b0f858d2dd386187af0:6-f3404217701f40b1a8363341ce32a409-f3404217701f40b1a8363341ce32a409-457ec68b1906417dab3317f54c0af719-00669f7f51104119be0c6c1993f5bf7d-6efd2b098f1f4861888536d0da3e6db0-f10461e5e1db4cb29f2c155a8b800dd9";
    var mopubBannerRefreshIos = 25;

    var w2eAutoSec = "5:10";

    // wq bucket split for the user
    var engg_bucket = "7_12";

    // wq puzzle split runtime
    var puzzle_split = "0_2_2_0_0_3_6_6_3_0_6_13_12_5_2_0_3_2_1_0_2_10_9_3_0_6_15_14_5_2_1_2_2_1_0_4_8_7_4_1_6_15_14_5_2_2_8_8_2_0_5_10_8_5_2_7_18_10_10_5";
    var questArchivePrice = 5;
    var questMiniPrice = 2;
    var wq_reward_prob = "4_15_5_80_8_5_15_14_20_80_30_6_45_10_50_85_60_5:4_10_5_90_8_0_15_5_20_95_30_0_45_5_50_95_60_0";

    // switch for thanksgivingPack on/off
    var switchThanksGivingPack = 0;

    // mastery check variable for D0 banner
    var bannerMastery = 5;

    // number of banner to show for a payer
    var maxBannerP = 2;

    // days eligibility to show brit pack premium tile on Home Screen
    var britPackSurfacingDaysEligibility = 7;

    // minimum mastery requirement for showing brit pack premium tile on home screen
    var britPackMinimumMasteryRequirement = 25;

    // number of days for which if brit pack is viewed but not played, brit pack premium tile disappears from home screen
    var britPackViewedNotPlayedDays = 7;

    // for the adjust new session event
    var daysForSessionEvent = 7;

    // daily bonus surfacing day
    var dailyBonusSurfacingDay = 1;
    var dailyBonusBucketR = "14_80_3_12";
    var db_rewards_1 = "10_50_40_2_5_8_15_50_35_2_4_7_20_50_30_2_4_6_30_50_20_2_4_5_25_55_20_2_3_5_20_60_20_2_3_4_70_25_5_1_2_3_75_23_2_1_2_3_80_19_1_1_2_3_80_19_1_1_2_3";
    var db_rewards_2 = "10_50_40_2_5_8_15_50_35_2_4_7_20_50_30_2_4_6_30_50_20_2_4_5_25_55_20_2_3_5_20_60_20_2_3_4_70_25_5_1_2_3_75_23_2_1_2_3_80_19_1_1_2_3_80_19_1_1_2_3";
    var db_timePeriod = 7;

    // daily bonus surfacing day
    var dailyBonusSurfacingDay_ios = 1;
    var dailyBonusBucketR_ios = "14_80_3_12";
    var db_rewards_1_ios = "10_50_40_2_5_8_15_50_35_2_4_7_20_50_30_2_4_6_30_50_20_2_4_5_25_55_20_2_3_5_20_60_20_2_3_4_70_25_5_1_2_3_75_23_2_1_2_3_80_19_1_1_2_3_80_19_1_1_2_3";
    var db_rewards_2_ios = "10_50_40_2_5_8_15_50_35_2_4_7_20_50_30_2_4_6_30_50_20_2_4_5_25_55_20_2_3_5_20_60_20_2_3_4_70_25_5_1_2_3_75_23_2_1_2_3_80_19_1_1_2_3_80_19_1_1_2_3";
    var db_timePeriod_ios = 7;

    //runtime for ooc_flow cooldown value according to variant
    var ooc_coolDown = "24_24_24";
    var ooc_coolDownIos = "24_24";

    // frenzyv2 runtime
    var frenzy_type1 = "5_7:1_2:6_9_9:50";
    var frenzy_type2 = "4:9_6:50:9_6";

    var frenzy_type2_dtc2 = "4:12_12_12_16_12_6_12_6:50:1_1_2_2_3_2_9_6";
    var xpValue = 1;
    var dailyPuzzle = "10";
    var pricingHintsFinal = "10_10_5_20_20_5_1_3_5_10:20_10_5_10_20_5_2_4_6_20";
    var nodesCompletedVal = "0:3";
    var coinGrantOnCountry = 1;
    var miniCoinGrant = 5;
    var midiCoinGrant = 5;
    var bigCoinGrant = 5;
    var frenzy_start = "1:1";
    var coolDownForPopups = "72:72:72";
    var pricingExpCoins = "300_550_1150_2400_6250:200_450_1050_2300_6000";

    // insta achievement reward value
    var reward_insta = 5;

    // PSPN QC Versioning
    var pspnQcVersion0 = 0;
    var pspnQcVersion1 = 0;
    var pspnQcVersion2 = 0;


    var localDataAvailable = false;

    this.init = function () {
        runtimeController = gameObj.getGameController();
        localDataAvailable = load();
    };

    function load() {
        var runtimeJson = ls.getItem(constantsObj.RUNTIME_CONFIG_FILE);
        if (runtimeJson == null || runtimeJson == "") {
            // loggerObj.debugLog("No runtime data found.");
            runtimeObj.syncToServer();
            return false;
        }
        loadRuntimeObjLocal(runtimeJson);
        return true;
    }

    function getParsedSpinnerProb(objStr) {
        var valArr = objStr.split(":");
        var valDict = {};
        valDict["free1"] = Number(valArr[0]);
        valDict["free2"] = Number(valArr[1]);
        valDict["plus10"] = Number(valArr[2]);
        valDict["plus5"] = Number(valArr[3]);
        valDict["revealWord"] = Number(valArr[4]);
        valDict["freeSpin"] = Number(valArr[5]);
        return valDict;
    }

    function getParsedWatch2EarnCoinsReward(objStr) {
        var valArr = objStr.split(":");
        var valDict = {};
        valDict["control"] = Number(valArr[0]);
        valDict["var1"] = Number(valArr[1]);
        valDict["var2"] = Number(valArr[2]);
        valDict["var3"] = Number(valArr[3]);
        valDict["var4"] = Number(valArr[4]);
        valDict["var5"] = Number(valArr[5]);
        valDict["var6"] = Number(valArr[6]);
        valDict["var7"] = Number(valArr[7]);
        return valDict;
    }

    function loadRuntimeObjLocal(runtimeJson) {
        var runtimeData = JSON.parse(runtimeJson);
        xpromoGameRuntimeObj.loadRuntime(runtimeData);
        if (runtimeData.rawRuntime != undefined) {
            rawRuntime = runtimeData.rawRuntime;
        }
        if (runtimeData.sftd != undefined) {
            subscriptionFreeTrialDuration = runtimeData.sftd;
        }
        if (runtimeData.fbc != undefined) {
            fbConnectCash = runtimeData.fbc;
        }
        if (runtimeData.pv != undefined) {
            puzzlesVersion = runtimeData.pv;
        }
        if (runtimeData.dmjv != undefined) {
            dailyMiniVersion = runtimeData.dmjv;
        }
        if (runtimeData.npv != undefined) {
            newPackVersion = runtimeData.npv;
        }
        if (runtimeData.tqjv != undefined) {
            themedQuestJsonVersion = runtimeData.tqjv;
        }
        if (runtimeData.ics != undefined) {
            interstitial_cooldown_screens = runtimeData.ics;
        }
        if (runtimeData.numVideos != undefined) {
            numVideos = runtimeData.numVideos;
        }
        if (runtimeData.numVideosNew != undefined) {
            numVideosNew = runtimeData.numVideosNew;
        }
        if (runtimeData.numVideosVar1 != undefined) {
            numVideosVar1 = runtimeData.numVideosVar1;
        }
        if (runtimeData.interstitialOnPuzzleScreen != undefined) {
            interstitialOnPuzzleScreen = runtimeData.interstitialOnPuzzleScreen;
        }
        if (runtimeData.mastery_grant_control != undefined) {
            mastery_grant_control = runtimeData.mastery_grant_control;
        }
        if (runtimeData.mastery_grant_var6 != undefined) {
            mastery_grant_var6 = runtimeData.mastery_grant_var6;
        }
        if (runtimeData.w2eRewardedCoins != undefined) {
            w2eRewardedCoins = runtimeData.w2eRewardedCoins;
        }
        if (runtimeData.forceUpdate != undefined) {
            forceUpdate = runtimeData.forceUpdate;
        }
        if (runtimeData.watchToEarnFtueCooldownHours != undefined) {
            watchToEarnFtueCooldownHours = runtimeData.watchToEarnFtueCooldownHours;
        }
        if (runtimeData.startSpin != undefined) {
            startSpin = runtimeData.startSpin;
        }
        if (runtimeData.supportJsonVersion != undefined) {
            supportJsonVersion = runtimeData.supportJsonVersion;
        }
        if (runtimeData.adType != undefined) {
            adType = runtimeData.adType;
        }
        if (runtimeData.notif_perm_c != undefined) {
            notif_perm_c = runtimeData.notif_perm_c;
        }
        if (runtimeData.notif_perm_v != undefined) {
            notif_perm_v = runtimeData.notif_perm_v;
        }
        if (runtimeData.ironsourceTapjoy != undefined) {
            ironsourceTapjoy = runtimeData.ironsourceTapjoy;
        }
        if (runtimeData.IronsourceReceptive != undefined) {
            IronsourceReceptive = runtimeData.IronsourceReceptive;
        }
        if (gameObj.getIsPayer()) {
            if (runtimeData.spinWheelProb != undefined) {
                spinWheelProb.load(runtimeData.spinWheelProbPayer);
            }
        } else {
            if (runtimeData.spinWheelProb != undefined) {
                spinWheelProb.load(runtimeData.spinWheelProb);
            }
        }

        if (runtimeData.watch2EarnCoinsReward != undefined) {
            watch2EarnCoinsReward.load(runtimeData.watch2EarnCoinsReward);
        }

        if (runtimeData.refillRate != undefined) {
            refillRate = runtimeData.refillRate;
        }
        if (runtimeData.maxW2eVideosSpinner != undefined) {
            maxW2eVideosSpinner = runtimeData.maxW2eVideosSpinner;
        }
        if (runtimeData.maxCreatureCoins != undefined) {
            maxCreatureCoins = runtimeData.maxCreatureCoins;
        }
        if (runtimeData.maxCreatureSpins != undefined) {
            maxCreatureSpins = runtimeData.maxCreatureSpins;
        }
        if (runtimeData.creatureGrantInterval != undefined) {
            creatureGrantInterval = runtimeData.creatureGrantInterval;
        }
        if (runtimeData.videoOrPopupCooldown != undefined) {
            videoOrPopupCooldown = runtimeData.videoOrPopupCooldown;
        }
        if (runtimeData.static_int != undefined) {
            static_int = runtimeData.static_int;
        }
        if (runtimeData.coolDownForBonusDailyMini != undefined) {
            coolDownForBonusDailyMini = runtimeData.coolDownForBonusDailyMini;
        }
        if (runtimeData.coolDownForBonusDailyMiniSubs != undefined) {
            coolDownForBonusDailyMiniSubs = runtimeData.coolDownForBonusDailyMiniSubs;
        }
        if (runtimeData.coolDownForSubsPopup != undefined) {
            coolDownForSubsPopup = runtimeData.coolDownForSubsPopup;
        }
        if (runtimeData.numberOfSubsPopup != undefined) {
            numberOfSubsPopup = runtimeData.numberOfSubsPopup;
        }
        if (runtimeData.coolDownForSubsDialog != undefined) {
            coolDownForSubsDialog = coolDownForSubsDialog;
        }
        if (utilObj.isIos()) {
            // pvpi //placement video priority ios
            // pvipi // placement video interstitial priority ios
            if (runtimeData.pvpi != undefined) {
                placementPriority[constantsObj.PLACEMENT_REWARDED_VIDEO] = runtimeData.pvpi;
                placementPriorityObj.load(placementPriority[constantsObj.PLACEMENT_REWARDED_VIDEO], constantsObj.PLACEMENT_REWARDED_VIDEO);
            }
            if (runtimeData.pvipi != undefined) {
                placementPriority[constantsObj.PLACEMENT_VIDEO_INTERSTITIAL] = runtimeData.pvipi;
                placementPriorityObj.load(placementPriority[constantsObj.PLACEMENT_VIDEO_INTERSTITIAL], constantsObj.PLACEMENT_VIDEO_INTERSTITIAL);
            }
            if (runtimeData.psipi != undefined) {
                placementPriority[constantsObj.PLACEMENT_STATIC_INTERSTITIAL] = runtimeData.psipi;
                placementPriorityObj.load(placementPriority[constantsObj.PLACEMENT_STATIC_INTERSTITIAL], constantsObj.PLACEMENT_STATIC_INTERSTITIAL);
            }
            if (runtimeData.reviewVersion != undefined) {
                reviewVersion = runtimeData.reviewVersion;
            }
        }

        if (utilObj.isAndroid()) {
            // pvpa // placement video priority android
            // pvipa // placement video interstitial priority android

            if (runtimeData.pvpa != undefined) {
                placementPriority[constantsObj.PLACEMENT_REWARDED_VIDEO] = runtimeData.pvpa;
                placementPriorityObj.load(placementPriority[constantsObj.PLACEMENT_REWARDED_VIDEO], constantsObj.PLACEMENT_REWARDED_VIDEO);
            }
            if (runtimeData.pvipa != undefined) {
                placementPriority[constantsObj.PLACEMENT_VIDEO_INTERSTITIAL] = runtimeData.pvipa;
                placementPriorityObj.load(placementPriority[constantsObj.PLACEMENT_VIDEO_INTERSTITIAL], constantsObj.PLACEMENT_VIDEO_INTERSTITIAL);
            }
            if (runtimeData.psipa != undefined) {
                placementPriority[constantsObj.PLACEMENT_STATIC_INTERSTITIAL] = runtimeData.psipa;
                placementPriorityObj.load(placementPriority[constantsObj.PLACEMENT_STATIC_INTERSTITIAL], constantsObj.PLACEMENT_STATIC_INTERSTITIAL);
            }
        }

        if (runtimeData.placementResetTime != undefined) {
            placementResetTime = runtimeData.placementResetTime;
        }

        if(runtimeData.autoOnResetTime != undefined){
            autoOnResetTime = runtimeData.autoOnResetTime;
        }

        if (runtimeData.CountWatchedVideo != undefined) {
            CountWatchedVideo = runtimeData.CountWatchedVideo;
        }
        if (runtimeData.countWatchedVideoPayer != undefined) {
            countWatchedVideoPayer = runtimeData.countWatchedVideoPayer;
        }

        if (runtimeData.MopubNativeAdsRefreshInterval != undefined) {
            MopubNativeAdsRefreshInterval = runtimeData.MopubNativeAdsRefreshInterval;
        }
        if (runtimeData.isPrivacyPolicyOn != undefined) {
            isPrivacyPolicyOn = runtimeData.isPrivacyPolicyOn;
        }
        if (runtimeData.awd != undefined) {
            adWallDays = runtimeData.awd;
        }
        if (runtimeData.awl != undefined) {
            adwallLimit = runtimeData.awl;
        }
        if (runtimeData.awct != undefined) {
            adwallCooldownTime = runtimeData.awct;
        }
        if (runtimeData.fb_mediation != undefined) {
            fb_mediation = runtimeData.fb_mediation;
        }
        if (runtimeData.mystery_reward_threshold != undefined) {
            mystery_reward_threshold = runtimeData.mystery_reward_threshold;
        }
        if (runtimeData.wqTotalstars != undefined) {
            wqTotalstars = runtimeData.wqTotalstars;
        }
        if (runtimeData.wqMilestones != undefined) {
            wqMilestones = runtimeData.wqMilestones;
        }
        if (runtimeData.Wq_payer_prob != undefined) {
            Wq_payer_prob = runtimeData.Wq_payer_prob;
        }
        if (runtimeData.Wq_payer_reward != undefined) {
            Wq_payer_reward = runtimeData.Wq_payer_reward;
        }
        if (runtimeData.Wq_prob != undefined) {
            Wq_prob = runtimeData.Wq_prob;
        }
        if (runtimeData.Wq_reward != undefined) {
            Wq_reward = runtimeData.Wq_reward;
        }
        if (runtimeData.wqTotalstarsHard != undefined) {
            wqTotalstarsHard = runtimeData.wqTotalstarsHard;
        }
        if (runtimeData.wqMilestonesHard != undefined) {
            wqMilestonesHard = runtimeData.wqMilestonesHard;
        }
        if (runtimeData.Wq_payer_prob_hard != undefined) {
            Wq_payer_prob_hard = runtimeData.Wq_payer_prob_hard;
        }
        if (runtimeData.Wq_payer_reward_hard != undefined) {
            Wq_payer_reward_hard = runtimeData.Wq_payer_reward_hard;
        }
        if (runtimeData.Wq_prob_hard != undefined) {
            Wq_prob_hard = runtimeData.Wq_prob_hard;
        }
        if (runtimeData.Wq_reward_hard != undefined) {
            Wq_reward_hard = runtimeData.Wq_reward_hard;
        }
        if (runtimeData.mystery_reward_probability != undefined) {
            mystery_reward_probability = runtimeData.mystery_reward_probability;
        }
        if (runtimeData.mini_mastery_time != undefined) {
            mini_mastery_time = runtimeData.mini_mastery_time;
        }
        if (runtimeData.main_mastery_time != undefined) {
            main_mastery_time = runtimeData.main_mastery_time;
        }
        if (runtimeData.mystery_reward_threshold_p != undefined) {
            mystery_reward_threshold_p = runtimeData.mystery_reward_threshold_p;
        }
        if (runtimeData.coolDownRecommendationPopup != undefined) {
            coolDownRecommendationPopup = runtimeData.coolDownRecommendationPopup;
        }
        if (runtimeData.frenzy_hard != undefined) {
            frenzy_hard = runtimeData.frenzy_hard;
        }
        if (runtimeData.bonusArchiveSwitch != undefined) {
            bonusArchiveSwitch = runtimeData.bonusArchiveSwitch;
        }
        if (runtimeData.battery_opti != undefined) {
            battery_opti = runtimeData.battery_opti;
        }
        if (runtimeData.garbageCollectionSwitch != undefined) {
            garbageCollectionSwitch = runtimeData.garbageCollectionSwitch;
        }
        if (runtimeData.frenzy_easy != undefined) {
            frenzy_easy = runtimeData.frenzy_easy;
        }
        if (runtimeData.frenzy_max_reveal != undefined) {
            frenzy_max_reveal = runtimeData.frenzy_max_reveal;
        }
        if (runtimeData.frenzy_avg_days != undefined) {
            frenzy_avg_days = runtimeData.frenzy_avg_days;
        }
        if (runtimeData.frenzy_start_day != undefined) {
            frenzy_start_day = runtimeData.frenzy_start_day;
        }
        if (runtimeData.video_var1 != undefined) {
            video_var1 = runtimeData.video_var1;
        }
        if (runtimeData.video_var2 != undefined) {
            video_var2 = runtimeData.video_var2;
        }
        if (runtimeData.poverty_line != undefined) {
            poverty_line = runtimeData.poverty_line;
        }
        if (runtimeData.npf != undefined) {
            newPurchaseFlow = runtimeData.npf;
        }
        if (runtimeData.mystery_w2e_coolDown != undefined) {
            mystery_w2e_coolDown = runtimeData.mystery_w2e_coolDown;
        }
        if (runtimeData.streak_reward_small != undefined) {
            streak_reward_small = runtimeData.streak_reward_small;
        }
        if (runtimeData.streak_reward_grand != undefined) {
            streak_reward_grand = runtimeData.streak_reward_grand;
        }
        if (runtimeData.mastery_mini_archive != undefined) {
            mastery_mini_archive = runtimeData.mastery_mini_archive;
        }
        if (runtimeData.mvr != undefined) {
            mopubVideoRetryParams.load(runtimeData.mvr);
        }
        if (runtimeData.mvp != undefined) {
            mopubVideoPriority = parseInt(runtimeData.mvp);
        }
        if (runtimeData.videoIntCount != undefined) {
            videoIntCount = parseInt(runtimeData.videoIntCount);
        }
        if (runtimeData.coolDownTimeForVIOnOutro != undefined) {
            coolDownTimeForVIOnOutro = parseInt(runtimeData.coolDownTimeForVIOnOutro);
        }
        if (runtimeData.w2ePowerUpCoolDown != undefined) {
            w2ePowerUpCoolDown = parseInt(runtimeData.w2ePowerUpCoolDown);
        }
        if (runtimeData.w2ePowerUpTimer != undefined) {
            w2ePowerUpTimer = parseInt(runtimeData.w2ePowerUpTimer);
        }
        if (runtimeData.spinner_rewardProb != undefined) {
            spinner_rewardProb = runtimeData.spinner_rewardProb;
        }
        if (runtimeData.numberOfBonusArchive != undefined) {
            numberOfBonusArchive = parseInt(runtimeData.numberOfBonusArchive);
        }
        if (runtimeData.w2ePowerUpLimit != undefined) {
            w2ePowerUpLimit = runtimeData.w2ePowerUpLimit;
        }
        if(runtimeData.adaptive_start != undefined){
            adaptive_start = runtimeData.adaptive_start;
        }
        if(runtimeData.puzzleRequired_adaptive != undefined){
            puzzleRequired_adaptive = runtimeData.puzzleRequired_adaptive;
        }
        if(runtimeData.adaptive_averageMastery != undefined){
            adaptive_averageMastery = runtimeData.adaptive_averageMastery;
        }
        if (runtimeData.w2ePowerUpDayLimit != undefined) {
            w2ePowerUpDayLimit = parseInt(runtimeData.w2ePowerUpDayLimit);
        }
        if (runtimeData.weeklyQuestMasteryLimit != undefined) {
            weeklyQuestMasteryLimit = runtimeData.weeklyQuestMasteryLimit;
        }
        if (runtimeData.bonusArchiveOutro != undefined) {
            bonusArchiveOutro = runtimeData.bonusArchiveOutro;
        }

        if (runtimeData.mopubAdUnits != undefined) {
            mopubAdUnits = runtimeData.mopubAdUnits;
        }
        if (runtimeData.mopubBannerRefresh != undefined) {
            mopubBannerRefresh = runtimeData.mopubBannerRefresh;
        }
        if (runtimeData.mopubAdUnitsIos != undefined) {
            mopubAdUnitsIos = runtimeData.mopubAdUnitsIos;
        }
        if (runtimeData.mopubBannerRefreshIos != undefined) {
            mopubBannerRefreshIos = runtimeData.mopubBannerRefreshIos;
        }
        if (runtimeData.w2eAutoSec != undefined) {
            w2eAutoSec = runtimeData.w2eAutoSec;
        }

        if (runtimeData.engg_bucket != undefined) {
            engg_bucket = runtimeData.engg_bucket;
        }

        if (runtimeData.puzzle_split != undefined) {
            puzzle_split = runtimeData.puzzle_split;
        }

        if (runtimeData.questArchivePrice != undefined) {
            questArchivePrice = runtimeData.questArchivePrice;
        }

        if (runtimeData.questMiniPrice != undefined) {
            questMiniPrice = runtimeData.questMiniPrice;
        }
        if (runtimeData.wq_reward_prob != undefined) {
            wq_reward_prob = runtimeData.wq_reward_prob;
        }
        if (runtimeData.switchThanksGivingPack != undefined) {
            switchThanksGivingPack = runtimeData.switchThanksGivingPack;
        }
        // if(runtimeData.freeRevealWord != undefined) {
        //     freeRevealWord = runtimeData.freeRevealWord;
        // }
        // if(runtimeData.freeRevealLetters != undefined) {
        //     freeRevealLetters = runtimeData.freeRevealLetters;
        // }
        if (runtimeData.blitzRuntimesStr != undefined) {
            blitzRuntimes.load(runtimeData.blitzRuntimesStr);
        }
        if (runtimeData.w2eHighlightStr != undefined) {
            w2eHighlight.load(runtimeData.w2eHighlightStr);
        }

        if (runtimeData.blitzRewardRuntimeStr != undefined) {
            blitzRewardRuntimes.load(runtimeData.blitzRewardRuntimeStr);
        }

        if(runtimeData.contextualW2eRuntimesStr != undefined){
            contextualW2eRuntimes.load(runtimeData.contextualW2eRuntimesStr);
        }

        if (runtimeData.spinnerRuntimesStr != undefined) {
            spinnerRuntimes.load(runtimeData.spinnerRuntimesStr);
        }

        if(runtimeData.vidlaunchdelay != undefined) {
            vidlaunchdelay = runtimeData.vidlaunchdelay;
        }

        // if(runtimeData.homeCarouselParams != undefined) {
        //     homeCarouselParams.load(runtimeData.homeCarouselParams);
        // }

        if(runtimeData.homeCarouselParamsNew != undefined) {
            homeCarouselParams.load(runtimeData.homeCarouselParamsNew);
        }

        if (runtimeData.bannerMastery != undefined) {
            bannerMastery = runtimeData.bannerMastery;
        }

        if (runtimeData.maxBannerP != undefined) {
            maxBannerP = runtimeData.maxBannerP;
        }

        if(runtimeData.britPackSurfacingDaysEligibility != undefined){
            britPackSurfacingDaysEligibility = runtimeData.britPackSurfacingDaysEligibility;
        }

        if(runtimeData.britPackMinimumMasteryRequirement != undefined){
            britPackMinimumMasteryRequirement = runtimeData.britPackMinimumMasteryRequirement;
        }

        if(runtimeData.britPackViewedNotPlayedDays != undefined) {
            britPackViewedNotPlayedDays = runtimeData.britPackViewedNotPlayedDays;
        }

        if (runtimeData.daysForSessionEvent != undefined) {
            daysForSessionEvent = runtimeData.daysForSessionEvent;
        }

        if (runtimeData.dailyBonusSurfacingDay != undefined) {
            dailyBonusSurfacingDay = runtimeData.dailyBonusSurfacingDay;
        }

        if (runtimeData.db_timePeriod != undefined) {
            db_timePeriod = runtimeData.db_timePeriod;
        }

        if (runtimeData.dailyBonusBucketR != undefined) {
            dailyBonusBucketR = runtimeData.dailyBonusBucketR;
        }
        if (runtimeData.db_rewards_1 != undefined) {
            db_rewards_1 = runtimeData.db_rewards_1;
        }
        if (runtimeData.db_rewards_2 != undefined) {
            db_rewards_2 = runtimeData.db_rewards_2;
        }

        // ios

        if (runtimeData.dailyBonusSurfacingDay_ios != undefined) {
            dailyBonusSurfacingDay_ios = runtimeData.dailyBonusSurfacingDay_ios;
        }

        if (runtimeData.db_timePeriod_ios != undefined) {
            db_timePeriod_ios = runtimeData.db_timePeriod_ios;
        }

        if (runtimeData.dailyBonusBucketR_ios != undefined) {
            dailyBonusBucketR_ios = runtimeData.dailyBonusBucketR_ios;
        }
        if (runtimeData.db_rewards_1_ios != undefined) {
            db_rewards_1_ios = runtimeData.db_rewards_1_ios;
        }
        if (runtimeData.db_rewards_2_ios != undefined) {
            db_rewards_2_ios = runtimeData.db_rewards_2_ios;
        }

        // ----------

        if(runtimeData.dcaQuestMap != undefined) {
            dcaQuestMap.load(runtimeData.dcaQuestMap);
        }

        if (runtimeData.ooc_coolDown != undefined) {
            ooc_coolDown = runtimeData.ooc_coolDown;
        }

        if (runtimeData.ooc_coolDownIos != undefined) {
            ooc_coolDownIos = runtimeData.ooc_coolDownIos;
        }

        if (runtimeData.frenzy_type1 != undefined) {
            frenzy_type1 = runtimeData.frenzy_type1;
        }

        if (runtimeData.frenzy_type2_dtc2 != undefined) {
            frenzy_type2_dtc2 = runtimeData.frenzy_type2_dtc2;
        }

        if (runtimeData.xpValue != undefined) {
            xpValue = runtimeData.xpValue;
        }
        if (runtimeData.dailyPuzzle != undefined) {
            dailyPuzzle = runtimeData.dailyPuzzle;
        }
        if (runtimeData.coolDownForPopups != undefined) {
            coolDownForPopups = runtimeData.coolDownForPopups;
        }
        if (runtimeData.frenzy_start != undefined) {
            frenzy_start = runtimeData.frenzy_start;
        }
        if (runtimeData.nodesCompletedVal != undefined) {
            nodesCompletedVal = runtimeData.nodesCompletedVal;
        }
        if (runtimeData.miniCoinGrant != undefined) {
            miniCoinGrant = runtimeData.miniCoinGrant;
        }
        if (runtimeData.midiCoinGrant != undefined) {
            midiCoinGrant = runtimeData.midiCoinGrant;
        }
        if (runtimeData.bigCoinGrant != undefined) {
            bigCoinGrant = runtimeData.bigCoinGrant;
        }
        if (runtimeData.coinGrantOnCountry != undefined) {
            coinGrantOnCountry = runtimeData.coinGrantOnCountry;
        }
        if (runtimeData.pricingHintsFinal != undefined) {
            pricingHintsFinal = runtimeData.pricingHintsFinal;
        }
        if (runtimeData.pricingExpCoins != undefined) {
            pricingExpCoins = runtimeData.pricingExpCoins;
        }
        if (runtimeData.reward_insta != undefined) {
            reward_insta = runtimeData.reward_insta;
        }

        // Runtimes for QC A/B on Flutter
        if(runtimeData.pspn_qc_ab_0 != undefined) {
            pspnQcVersion0 = parseInt(runtimeData.pspn_qc_ab_0);
        }
        if(runtimeData.pspn_qc_ab_1 != undefined) {
            pspnQcVersion1 = parseInt(runtimeData.pspn_qc_ab_1);
        }
        if(runtimeData.pspn_qc_ab_2 != undefined) {
            pspnQcVersion2 = parseInt(runtimeData.pspn_qc_ab_2);
        }
    }

    function save() {
        var runtimeData = {};
        runtimeData = xpromoGameRuntimeObj.saveRuntime(runtimeData);
        runtimeData.rawRuntime = rawRuntime;
        runtimeData.sftd = subscriptionFreeTrialDuration;
        runtimeData.fbc = fbConnectCash;
        runtimeData.pv = puzzlesVersion;
        runtimeData.dmjv = dailyMiniVersion;
        runtimeData.npv = newPackVersion;
        runtimeData.tqjv = themedQuestJsonVersion;
        runtimeData.ics = interstitial_cooldown_screens;
        runtimeData.numVideos = numVideos;
        runtimeData.numVideosNew = numVideosNew;
        runtimeData.numVideosVar1 = numVideosVar1;
        runtimeData.interstitialOnPuzzleScreen = interstitialOnPuzzleScreen;
        runtimeData.mastery_grant_control = mastery_grant_control;
        runtimeData.mastery_grant_var6 = mastery_grant_var6;
        runtimeData.w2eRewardedCoins = w2eRewardedCoins;
        runtimeData.forceUpdate = forceUpdate;
        runtimeData.watchToEarnFtueCooldownHours = watchToEarnFtueCooldownHours;
        runtimeData.startSpin = startSpin;
        runtimeData.spinWheelProb = spinWheelProb.getSpinnerObj();
        runtimeData.watch2EarnCoinsReward = watch2EarnCoinsReward.getWatch2EarnCoinsObj();
        runtimeData.refillRate = refillRate;
        runtimeData.maxW2eVideosSpinner = maxW2eVideosSpinner;
        runtimeData.maxCreatureSpins = maxCreatureSpins;
        runtimeData.maxCreatureCoins = maxCreatureCoins;
        runtimeData.creatureGrantInterval = creatureGrantInterval;
        runtimeData.adType = adType;
        runtimeData.notif_perm_c = notif_perm_c;
        runtimeData.notif_perm_v = notif_perm_v;
        runtimeData.supportJsonVersion = supportJsonVersion;
        runtimeData.ironsourceTapjoy = ironsourceTapjoy;
        runtimeData.IronsourceReceptive = IronsourceReceptive;
        runtimeData.isPrivacyPolicyOn = isPrivacyPolicyOn;
        runtimeData.fb_mediation = fb_mediation;
        runtimeData.mystery_reward_threshold = mystery_reward_threshold;
        runtimeData.wqTotalstars = wqTotalstars;
        runtimeData.Wq_payer_prob = Wq_payer_prob;
        runtimeData.wqMilestones = wqMilestones;
        runtimeData.Wq_payer_reward = Wq_payer_reward;
        runtimeData.Wq_prob = Wq_prob;
        runtimeData.Wq_reward = Wq_reward;

        runtimeData.Wq_payer_prob_hard = Wq_payer_prob_hard;
        runtimeData.wqMilestonesHard = wqMilestonesHard;
        runtimeData.Wq_payer_reward_hard = Wq_payer_reward_hard;
        runtimeData.Wq_prob_hard = Wq_prob_hard;
        runtimeData.Wq_reward_hard = Wq_reward_hard;
        runtimeData.wqTotalstarsHard = wqTotalstarsHard;

        runtimeData.mystery_reward_probability = mystery_reward_probability;
        runtimeData.mini_mastery_time = mini_mastery_time;
        runtimeData.main_mastery_time = main_mastery_time;
        runtimeData.mystery_reward_threshold_p = mystery_reward_threshold_p;
        runtimeData.videoOrPopupCooldown = videoOrPopupCooldown;
        runtimeData.static_int = static_int;
        runtimeData.coolDownForBonusDailyMini = coolDownForBonusDailyMini;
        runtimeData.coolDownForBonusDailyMiniSubs = coolDownForBonusDailyMiniSubs;
        runtimeData.coolDownForSubsPopup = coolDownForSubsPopup;
        runtimeData.numberOfSubsPopup = numberOfSubsPopup;
        runtimeData.coolDownForSubsDialog = coolDownForSubsDialog;
        if (utilObj.isIos()) {
            runtimeData.pvpi = placementPriority[constantsObj.PLACEMENT_REWARDED_VIDEO];
            runtimeData.pvipi = placementPriority[constantsObj.PLACEMENT_VIDEO_INTERSTITIAL];
            runtimeData.psipi = placementPriority[constantsObj.PLACEMENT_STATIC_INTERSTITIAL];
        }
        if (utilObj.isAndroid()) {
            runtimeData.pvpa = placementPriority[constantsObj.PLACEMENT_REWARDED_VIDEO];
            runtimeData.pvipa = placementPriority[constantsObj.PLACEMENT_VIDEO_INTERSTITIAL];
            runtimeData.psipa = placementPriority[constantsObj.PLACEMENT_STATIC_INTERSTITIAL];
        }
        runtimeData.placementResetTime = placementResetTime;
        runtimeData.autoOnResetTime = autoOnResetTime;
        runtimeData.CountWatchedVideo = CountWatchedVideo;
        runtimeData.countWatchedVideoPayer = countWatchedVideoPayer;
        runtimeData.MopubNativeAdsRefreshInterval = MopubNativeAdsRefreshInterval;
        // runtimeData.freeRevealWord = freeRevealWord;
        // runtimeData.freeRevealLetters = freeRevealLetters;
        runtimeData.awd = adWallDays;
        runtimeData.awl = adwallLimit;
        runtimeData.awct = adwallCooldownTime;
        runtimeData.coolDownRecommendationPopup = coolDownRecommendationPopup;
        runtimeData.frenzy_easy = frenzy_easy;
        runtimeData.frenzy_hard = frenzy_hard;
        runtimeData.bonusArchiveSwitch = bonusArchiveSwitch;
        runtimeData.battery_opti = battery_opti;
        runtimeData.garbageCollectionSwitch = garbageCollectionSwitch;
        runtimeData.frenzy_max_reveal = frenzy_max_reveal;
        runtimeData.frenzy_avg_days = frenzy_avg_days;
        runtimeData.frenzy_start_day = frenzy_start_day;
        runtimeData.video_var1 = video_var1;
        runtimeData.video_var2 = video_var2;
        runtimeData.poverty_line = poverty_line;
        runtimeData.npf = newPurchaseFlow;
        runtimeData.mystery_w2e_coolDown = mystery_w2e_coolDown;
        runtimeData.streak_reward_grand = streak_reward_grand;
        runtimeData.streak_reward_small = streak_reward_small;
        runtimeData.mastery_mini_archive = mastery_mini_archive;
        runtimeData.blitzRuntimesStr = blitzRuntimesStr;
        runtimeData.w2eHighlightStr = w2eHighlightStr;
        runtimeData.blitzRewardRuntimeStr = blitzRewardRuntimeStr;
        runtimeData.contextualW2eRuntimesStr = contextualW2eRuntimesStr;
        runtimeData.spinnerRuntimesStr = spinnerRuntimesStr;
        runtimeData.mvr = mopubVideoRetryParams.getData();
        runtimeData.mvp = mopubVideoPriority;
        runtimeData.videoIntCount = videoIntCount;
        runtimeData.coolDownTimeForVIOnOutro = coolDownTimeForVIOnOutro;
        runtimeData.w2ePowerUpCoolDown = w2ePowerUpCoolDown;
        runtimeData.w2ePowerUpTimer = w2ePowerUpTimer;
        runtimeData.spinner_rewardProb = spinner_rewardProb;
        runtimeData.numberOfBonusArchive = numberOfBonusArchive;
        runtimeData.w2ePowerUpLimit = w2ePowerUpLimit;
        runtimeData.adaptive_start = adaptive_start;
        runtimeData.puzzleRequired_adaptive = puzzleRequired_adaptive;
        runtimeData.adaptive_averageMastery = adaptive_averageMastery;
        runtimeData.w2ePowerUpDayLimit = w2ePowerUpDayLimit;
        runtimeData.weeklyQuestMasteryLimit = weeklyQuestMasteryLimit;
        runtimeData.reviewVersion = reviewVersion;
        runtimeData.bonusArchiveOutro = bonusArchiveOutro;
        runtimeData.vidlaunchdelay = vidlaunchdelay;
        runtimeData.mopubAdUnits = mopubAdUnits;
        runtimeData.mopubBannerRefresh = mopubBannerRefresh;
        // runtimeData.homeCarouselParams = homeCarouselParams.getData();
        runtimeData.homeCarouselParamsNew = homeCarouselParams.getData();
        runtimeData.mopubAdUnitsIos = mopubAdUnitsIos;
        runtimeData.mopubBannerRefreshIos = mopubBannerRefreshIos;
        runtimeData.w2eAutoSec = w2eAutoSec;
        runtimeData.engg_bucket = engg_bucket;
        runtimeData.puzzle_split = puzzle_split;
        runtimeData.questArchivePrice = questArchivePrice;
        runtimeData.questMiniPrice = questMiniPrice;
        runtimeData.wq_reward_prob = wq_reward_prob;
        runtimeData.switchThanksGivingPack = switchThanksGivingPack;
        runtimeData.bannerMastery = bannerMastery;
        runtimeData.maxBannerP = maxBannerP;
        runtimeData.britPackSurfacingDaysEligibility = britPackSurfacingDaysEligibility;
        runtimeData.britPackMinimumMasteryRequirement = britPackMinimumMasteryRequirement;
        runtimeData.britPackViewedNotPlayedDays = britPackViewedNotPlayedDays;
        runtimeData.daysForSessionEvent = daysForSessionEvent;
        runtimeData.dailyBonusSurfacingDay = dailyBonusSurfacingDay;
        runtimeData.db_timePeriod = db_timePeriod;
        runtimeData.dailyBonusBucketR = dailyBonusBucketR;
        runtimeData.db_rewards_1 = db_rewards_1;
        runtimeData.db_rewards_2 = db_rewards_2;
        runtimeData.dailyBonusSurfacingDay_ios = dailyBonusSurfacingDay_ios;
        runtimeData.db_timePeriod_ios = db_timePeriod_ios;
        runtimeData.dailyBonusBucketR_ios = dailyBonusBucketR_ios;
        runtimeData.db_rewards_1_ios = db_rewards_1_ios;
        runtimeData.db_rewards_2_ios = db_rewards_2_ios;
        runtimeData.dcaQuestMap = dcaQuestMap.getData();
        runtimeData.ooc_coolDown = ooc_coolDown;
        runtimeData.ooc_coolDownIos = ooc_coolDownIos;
        runtimeData.frenzy_type1 = frenzy_type1;
        runtimeData.frenzy_type2_dtc2 = frenzy_type2_dtc2;
        runtimeData.xpValue = xpValue;
        runtimeData.dailyPuzzle = dailyPuzzle;
        runtimeData.coolDownForPopups = coolDownForPopups;
        runtimeData.frenzy_start = frenzy_start;
        runtimeData.nodesCompletedVal =  nodesCompletedVal;
        runtimeData.miniCoinGrant = miniCoinGrant;
        runtimeData.midiCoinGrant = midiCoinGrant;
        runtimeController.bigCoinGrant = bigCoinGrant;
        runtimeData.coinGrantOnCountry = coinGrantOnCountry;
        runtimeData.pricingHintsFinal = pricingHintsFinal;
        runtimeData.pricingExpCoins = pricingExpCoins;
        runtimeData.reward_insta = reward_insta;
        runtimeData.pspn_qc_ab_0 = pspnQcVersion0;
        runtimeData.pspn_qc_ab_1 = pspnQcVersion1;
        runtimeData.pspn_qc_ab_2 = pspnQcVersion2;

        ls.setItem(constantsObj.RUNTIME_CONFIG_FILE, utilObj.getStringifiedJson(runtimeData));
        return true;
    }

    this.syncToServer = function () {
        // var passesBasicChecks = utilObj.passesBasicSyncChecks(lastSyncStart, constantsObj.RUNTIME_SYNC_INTERVAL);
        var passesBasicChecks = true;
        if (!utilObj.isPingWorking()) {
            // loggerObj.debugLog("Not syncing yet. No network.");
            passesBasicChecks = false;
        }
        var curTimestamp = utilObj.getCurrentTimestamp();
        if (curTimestamp - lastSyncStart < constantsObj.RUNTIME_SYNC_INTERVAL) {
            passesBasicChecks = false;
        }
        var readyToSync = passesBasicChecks;
        if (readyToSync) {
            var curTimestamp = utilObj.getCurrentTimestamp();
            lastSyncStart = curTimestamp;
            var mapData = userObj.getUserObj();
            mapData.lastUpdate = lastUpdate + "";
            runtimeController.sendHttpRequest("runtime", "getRuntime", mapData);
            trackObj.trackCounter(constantsObj.TRACK_DEBUG, constantsObj.TRACK_RUNTIME_SYNC, constantsObj.TRACK_REQUEST, "", "", "", "", 1, "");
            utilObj.syncFabricEvent(constantsObj.TRACK_RUNTIME_SYNC, constantsObj.TRACK_REQUEST);
        }
    };

    this.respHandler = function (action, data, success) {
        if (success === false) {
            trackObj.trackCounter(constantsObj.TRACK_DEBUG, constantsObj.TRACK_RUNTIME_SYNC, constantsObj.TRACK_FAIL, "", "", "", "", 1, "");
            utilObj.syncFabricEvent(constantsObj.TRACK_RUNTIME_SYNC, constantsObj.TRACK_FAIL);
            return;
        }
        trackObj.trackCounter(constantsObj.TRACK_DEBUG, constantsObj.TRACK_RUNTIME_SYNC, constantsObj.TRACK_SUCCESS, "", "", "", "", 1, "");
        utilObj.syncFabricEvent(constantsObj.TRACK_RUNTIME_SYNC, constantsObj.TRACK_SUCCESS);
        if (action === "sync") {
            var runtimeData = data.runtime;
            var runtime = JSON.parse(runtimeData);
            lastUpdate = runtime.lu;
            var info = runtime.r.split(";");
            var vals = {};
            for (var i = 0; i < info.length; i++) {
                var keyInfo = info[i].split(",");
                vals[keyInfo[0]] = keyInfo[1];
            }
            rawRuntime = vals;
            xpromoGameRuntimeObj.respHandlerLoad(vals);
            subscriptionFreeTrialDuration = parseInt(vals['sftd']);
            fbConnectCash = parseInt(vals['fbc']);
            if (puzzlesVersion != vals['pv']) {
                // There has been an update in crosswords version
                puzzlesVersion = vals['pv'];
                gameObj.downloadCrosswords();
            }

            if (dailyMiniVersion != vals['dmjv']) {
                dailyMiniVersion = vals['dmjv'];
                gameObj.downloadDailyMinis();
            }
            if (themedQuestJsonVersion != vals['tqjv']) {
                themedQuestJsonVersion = vals['tqjv'];
                gameObj.downloadThemedQuestJson();
            }
            if (newPackVersion != vals['npv']) {
                newPackVersion = vals['npv'];
            }
            if (supportJsonVersion != vals['sjv']) {
                supportJsonVersion = vals['sjv'];
                supportLayer.triggerConfigDownload();
            }
            if (adType != undefined) {
                adType = vals['adType'];
            }
            if (notif_perm_c != undefined) {
                notif_perm_c = vals['notif_perm_c'];
            }
            if (notif_perm_v != undefined) {
                notif_perm_v = vals['notif_perm_v'];
            }
            if (CountWatchedVideo != undefined) {
                CountWatchedVideo = vals['CountWatchedVideo'];
            }
            if (countWatchedVideoPayer != undefined) {
                countWatchedVideoPayer = vals['countWatchedVideoPayer'];
            }
            if (ironsourceTapjoy != undefined) {
                ironsourceTapjoy = vals['ironsourceTapjoy'];
            }
            if (IronsourceReceptive != undefined) {
                IronsourceReceptive = vals['IronsourceReceptive'];
            }
            if (MopubNativeAdsRefreshInterval != undefined) {
                MopubNativeAdsRefreshInterval = vals['MopubNativeAdsRefreshInterval']
            }

            if(autoOnResetTime != undefined){
                autoOnResetTime = vals['introOutroRevamp_autoOnResetCount']
            }
            //ironsourceTapjoy
            interstitial_cooldown_screens = vals['ics'];
            numVideos = vals['numVideos'];
            numVideosNew = vals['numVideosNew'];
            numVideosVar1 = vals['numVideosVar1'];
            if (vals['itops'] != undefined) {
                interstitialOnPuzzleScreen = vals['itops'];
            }
            if (vals['mastery_grant_control'] != undefined) {
                mastery_grant_control = vals['mastery_grant_control'];
            }

            if (vals['mastery_grant_var6'] != undefined) {
                mastery_grant_var6 = vals['mastery_grant_var6'];
            }
            if (utilObj.isIos()) {
                if (vals["pvpi"] != undefined) {
                    placementPriority[constantsObj.PLACEMENT_REWARDED_VIDEO] = vals["pvpi"];
                    placementPriorityObj.load(placementPriority[constantsObj.PLACEMENT_REWARDED_VIDEO], constantsObj.PLACEMENT_REWARDED_VIDEO);
                }
                if (vals["pvipi"] != undefined) {
                    placementPriority[constantsObj.PLACEMENT_VIDEO_INTERSTITIAL] = vals["pvipi"];
                    placementPriorityObj.load(placementPriority[constantsObj.PLACEMENT_VIDEO_INTERSTITIAL], constantsObj.PLACEMENT_VIDEO_INTERSTITIAL);
                }
                if (vals["psipi"] != undefined) {
                    placementPriority[constantsObj.PLACEMENT_STATIC_INTERSTITIAL] = vals["psipi"];
                    placementPriorityObj.load(placementPriority[constantsObj.PLACEMENT_STATIC_INTERSTITIAL], constantsObj.PLACEMENT_STATIC_INTERSTITIAL);
                }
                if (vals["rv"] != undefined) {
                    reviewVersion = parseInt(vals['rv']);
                }
            }
            if (utilObj.isAndroid()) {
                if (vals["pvpa"] != undefined) {
                    placementPriority[constantsObj.PLACEMENT_REWARDED_VIDEO] = vals["pvpa"];
                    placementPriorityObj.load(placementPriority[constantsObj.PLACEMENT_REWARDED_VIDEO], constantsObj.PLACEMENT_REWARDED_VIDEO);
                }
                if (vals["pvipa"] != undefined) {
                    placementPriority[constantsObj.PLACEMENT_VIDEO_INTERSTITIAL] = vals["pvipa"];
                    placementPriorityObj.load(placementPriority[constantsObj.PLACEMENT_VIDEO_INTERSTITIAL], constantsObj.PLACEMENT_VIDEO_INTERSTITIAL);
                }
                if (vals["psipa"] != undefined) {
                    placementPriority[constantsObj.PLACEMENT_STATIC_INTERSTITIAL] = vals["psipa"];
                    placementPriorityObj.load(placementPriority[constantsObj.PLACEMENT_STATIC_INTERSTITIAL], constantsObj.PLACEMENT_STATIC_INTERSTITIAL);
                }
            }
            if (vals['prt'] != undefined) {
                placementResetTime = parseInt(vals['prt']);
            }

            //runtimeData.mastery_grant_control = mastery_grant_control;
            // revealCount = parseInt(vals['rc']);

            w2eRewardedCoins = vals['w2eRewardedCoins'];
            forceUpdate = vals['forceUpdate'];
            watchToEarnFtueCooldownHours = vals['w2eFtueCool'];
            if (vals['startSpin'] != undefined) {
                startSpin = vals['startSpin'];
            }
            refillRate = vals['refillRate'];
            maxW2eVideosSpinner = vals['maxW2eVideosSpinner'];

            if (gameObj.getIsPayer()) {
                if (vals['spinWheelProbPayer'] != undefined) {
                    spinWheelProb.load(getParsedSpinnerProb(vals['spinWheelProbPayer']));
                }
            } else {
                if (vals['spinWheelProb'] != undefined) {
                    spinWheelProb.load(getParsedSpinnerProb(vals['spinWheelProb']));
                }
            }

            if (vals['watch2EarnCoinsReward'] != undefined) {
                watch2EarnCoinsReward.load(getParsedWatch2EarnCoinsReward(vals['watch2EarnCoinsReward']));
            }

            if (constantsObj.ENV == constantsObj.STAGING) {
                // Variables only to be updated in case of staging
            }

            if (vals['maxCreatureSpins'] != undefined) {
                maxCreatureSpins = vals['maxCreatureSpins'];
            }
            if (vals['maxCreatureCoins'] != undefined) {
                maxCreatureCoins = vals['maxCreatureCoins'];
            }
            if (vals['awd'] != undefined) {
                adWallDays = parseInt(vals['awd']);
            }
            if (vals['awl'] != undefined) {
                adwallLimit = parseInt(vals['awl']);
            }
            if (vals['awct'] != undefined) {
                adwallCooldownTime = parseInt(vals['awct']);
            }
            if (vals['fb_mediation'] != undefined) {
                fb_mediation = parseInt(vals['fb_mediation']);
                gameObj.setFbMediation(fb_mediation);
            }
            if (vals['mystery_reward_threshold'] != undefined) {
                mystery_reward_threshold = vals['mystery_reward_threshold'];
            }
            if (vals['wqTotalstars'] != undefined) {
                wqTotalstars = vals['wqTotalstars'];
            }
            if (vals['wqMilestones'] != undefined) {
                wqMilestones = vals['wqMilestones'];
            }
            if (vals['Wq_prob'] != undefined) {
                Wq_prob = vals['Wq_prob'];
            }
            if (vals['Wq_payer_reward'] != undefined) {
                Wq_payer_reward = vals['Wq_payer_reward'];
            }
            if (vals['Wq_payer_prob'] != undefined) {
                Wq_payer_prob = vals['Wq_payer_prob'];
            }
            if (vals['Wq_reward'] != undefined) {
                Wq_reward = vals['Wq_reward'];
            }
            if (vals['wqTotalstarsHard'] != undefined) {
                wqTotalstarsHard = vals['wqTotalstarsHard'];
            }
            if (vals['wqMilestonesHardNew'] != undefined) {
                wqMilestonesHard = vals['wqMilestonesHardNew'];
            }
            if (vals['Wq_prob_hard'] != undefined) {
                Wq_prob_hard = vals['Wq_prob_hard'];
            }
            if (vals['Wq_payer_reward_hard'] != undefined) {
                Wq_payer_reward_hard = vals['Wq_payer_reward_hard'];
            }
            if (vals['Wq_payer_prob_hard'] != undefined) {
                Wq_payer_prob_hard = vals['Wq_payer_prob_hard'];
            }
            if (vals['Wq_reward_hard'] != undefined) {
                Wq_reward_hard = vals['Wq_reward_hard'];
            }
            if (vals['mystery_reward_probability_new'] != undefined) {
                mystery_reward_probability = vals['mystery_reward_probability_new'];
            }
            if (vals['Minis_Mastery_time'] != undefined) {
                mini_mastery_time = vals['Minis_Mastery_time'];
            }
            if (vals['Regular_Mastery_time'] != undefined) {
                main_mastery_time = vals['Regular_Mastery_time'];
            }
            if (vals['mystery_reward_threshold_p'] != undefined) {
                mystery_reward_threshold_p = vals['mystery_reward_threshold_p'];
            }
            if (vals['coolDownRecommendationPopup'] != undefined) {
                coolDownRecommendationPopup = vals['coolDownRecommendationPopup'];
            }
            if (vals['frenzy_hard'] != undefined) {
                frenzy_hard = vals['frenzy_hard'];
            }
            if (vals['bas'] != undefined) {
                bonusArchiveSwitch = vals['bas'];
            }
            if (vals['battery_opti'] != undefined) {
                battery_opti = vals['battery_opti'];
            }
            if (vals['gc'] != undefined) {
                garbageCollectionSwitch = vals['gc'];
            }
            if (vals['frenzy_easy'] != undefined) {
                frenzy_easy = vals['frenzy_easy'];
            }
            if (vals['frenzy_max_reveal'] != undefined) {
                frenzy_max_reveal = vals['frenzy_max_reveal'];
            }
            if (vals['frenzy_avg_days'] != undefined) {
                frenzy_avg_days = vals['frenzy_avg_days'];
            }
            if (vals['frenzy_start_day'] != undefined) {
                frenzy_start_day = vals['frenzy_start_day'];
            }
            if (vals['video_var1'] != undefined) {
                video_var1 = vals['video_var1'];
            }
            if (vals['video_var2'] != undefined) {
                video_var2 = vals['video_var2'];
            }
            if (vals['poverty_line'] != undefined) {
                poverty_line = vals['poverty_line'];
            }
            if (vals['itops_popup_cooldown'] != undefined) {
                videoOrPopupCooldown = vals['itops_popup_cooldown'];
            }
            if (vals['static_int'] != undefined) {
                static_int = vals['static_int'];
            }
            if (vals['bonus_mini'] != undefined) {
                coolDownForBonusDailyMini = vals['bonus_mini'];
            }
            if (vals['bonus_mini_subs'] != undefined) {
                coolDownForBonusDailyMiniSubs = vals['bonus_mini_subs'];
            }
            if (vals['S_popup_cooldown'] != undefined) {
                coolDownForSubsPopup = vals['S_popup_cooldown'];
            }
            if (vals['S_popup_no'] != undefined) {
                numberOfSubsPopup = vals['S_popup_no'];
            }
            if (vals['S_popup_cooldown_post'] != undefined) {
                coolDownForSubsDialog = vals['S_popup_cooldown_post'];
            }
            if (vals['npf'] != undefined) {
                newPurchaseFlow = parseInt(vals['npf']);
            }
            if (vals['myst_w2e_cooldown'] != undefined) {
                mystery_w2e_coolDown = vals['myst_w2e_cooldown'];
            }
            if (vals['streak_reward_small'] != undefined) {
                streak_reward_small = vals['streak_reward_small'];
            }
            if (vals['streak_reward_grand'] != undefined) {
                streak_reward_grand = vals['streak_reward_grand'];
            }
            if (vals['dm_msty'] != undefined) {
                mastery_mini_archive = vals['dm_msty'];
            }
            if (vals['blitz_runtimes'] != undefined) {
                blitzRuntimesStr = vals['blitz_runtimes'];
                blitzRuntimes.load(blitzRuntimesStr);
            }
            if (vals['w2eHighlight'] != undefined) {
                w2eHighlightStr = vals['w2eHighlight'];
                w2eHighlight.load(w2eHighlightStr);
            }
            if (vals['blitz_rwd'] != undefined) {
                blitzRewardRuntimeStr = vals['blitz_rwd'];
                blitzRewardRuntimes.load(blitzRewardRuntimeStr);
            }

            if(vals['contextualW2eRuntimes'] != undefined){
                contextualW2eRuntimesStr = vals['contextualW2eRuntimes'];
                contextualW2eRuntimes.load(contextualW2eRuntimesStr);
            }
            if (vals['spinner_runtimes'] != undefined) {
                spinnerRuntimesStr = vals['spinner_runtimes'];
                spinnerRuntimes.load(spinnerRuntimesStr);
            }
            if (vals['mvr2'] != undefined) {
                mopubVideoRetryParams.load(vals['mvr2']);
            }
            if (vals['mvp'] != undefined) {
                mopubVideoPriority = parseInt(vals['mvp']);
            }
            if (vals['vic'] != undefined) {
                videoIntCount = parseInt(vals['vic']);
            }
            if(vals['vicb'] != undefined){
                coolDownTimeForVIOnOutro = parseInt(vals['vicb']);
            }
            if (vals['LIVC'] != undefined) {
                w2ePowerUpCoolDown = parseInt(vals['LIVC']);
            }
            if (vals['LIC'] != undefined) {
                w2ePowerUpTimer = parseInt(vals['LIC']);
            }
            if (vals['spinner_rewardProb'] != undefined) {
                spinner_rewardProb = vals['spinner_rewardProb'];
            }
            if (vals['bonus_archive_count'] != undefined) {
                numberOfBonusArchive = parseInt(vals['bonus_archive_count']);
            }
            if (vals['wlim'] != undefined) {
                w2ePowerUpLimit = vals['wlim'];
            }
            if (vals['adaptive_start'] != undefined) {
                adaptive_start = vals['adaptive_start'];
            }
            if (vals['puzzleRequired_adaptive'] != undefined) {
                puzzleRequired_adaptive = vals['puzzleRequired_adaptive'];
            }
            if (vals['adaptive_averageMastery'] != undefined) {
                adaptive_averageMastery = vals['adaptive_averageMastery'];
            }
            if (vals['wlid'] != undefined) {
                w2ePowerUpDayLimit = parseInt(vals['wlid']);
            }
            if (vals['wqMasteryLimit'] != undefined) {
                weeklyQuestMasteryLimit = vals['wqMasteryLimit'];
            }
            if (vals['bonusArchiveOutro'] != undefined) {
                bonusArchiveOutro = vals['bonusArchiveOutro'];
            }
            if(vals['vidlaunchdelay'] != undefined) {
                vidlaunchdelay = vals['vidlaunchdelay'];
            }
            if (vals['mopubAdUnits'] != undefined) {
                mopubAdUnits = vals['mopubAdUnits'];
            }
            if (vals['mopubBannerRefresh'] != undefined) {
                mopubBannerRefresh = parseInt(vals['mopubBannerRefresh']);
            }
            // if (vals['switch_carousel_item'] != undefined) {
            //     homeCarouselParams.load(vals['switch_carousel_item']);
            // }
            if (vals['switch_carousel_item_new'] != undefined) {
                homeCarouselParams.load(vals['switch_carousel_item_new']);
            }
            if (vals['mopubAdUnitsIos'] != undefined) {
                mopubAdUnitsIos = vals['mopubAdUnitsIos'];
            }
            if (vals['mopubBannerRefreshIos'] != undefined) {
                mopubBannerRefreshIos = parseInt(vals['mopubBannerRefreshIos']);
            }
            if (vals['w2eAutoSec'] != undefined) {
                w2eAutoSec = vals['w2eAutoSec'];
            }
            if (vals['engg_bucket'] != undefined) {
                engg_bucket = vals['engg_bucket'];
            }
            if (vals['puzzle_split'] != undefined) {
                puzzle_split = vals['puzzle_split'];
            }
            if (vals['questArchivePrice'] != undefined) {
                questArchivePrice = vals['questArchivePrice'];
            }
            if (vals['questMiniPrice'] != undefined) {
                questMiniPrice = vals['questMiniPrice'];
            }
            if (vals['wq_reward_prob'] != undefined) {
                wq_reward_prob = vals['wq_reward_prob'];
            }
            if (vals['switchThanksGivingPack'] != undefined) {
                switchThanksGivingPack = vals['switchThanksGivingPack'];
            }
            if (vals['bannerMastery'] != undefined) {
                bannerMastery = parseInt(vals['bannerMastery']);
            }
            if (vals['maxBannerP'] != undefined) {
                maxBannerP = parseInt(vals['maxBannerP']);
            }
            if (vals['bpsde'] != undefined) {
                britPackSurfacingDaysEligibility = vals['bpsde'];
            }
            if (vals['bpmmr'] != undefined) {
                britPackMinimumMasteryRequirement = vals['bpmmr'];
            }
            if (vals['bpvnpd'] != undefined) {
                britPackViewedNotPlayedDays = vals['bpvnpd'];
            }
            if (vals['daySess'] != undefined) {
                daysForSessionEvent = parseInt(vals['daySess']);
            }
            if (vals['db_firstsurf'] != undefined) {
                dailyBonusSurfacingDay = parseInt(vals['db_firstsurf']);
            }
            if (vals['wallet_Rev_split'] != undefined) {
                dailyBonusBucketR = vals['wallet_Rev_split'];
            }
            if (vals['db_rewards'] != undefined) {
                db_rewards_1 = vals['db_rewards'];
            }
            if (vals['db_rewards_2'] != undefined) {
                db_rewards_2 = vals['db_rewards_2'];
            }
            if (vals['db_timePeriod'] != undefined) {
                db_timePeriod = parseInt(vals['db_timePeriod']);
            }

            // ios

            if (vals['dailyBonusSurfacingDay_ios'] != undefined) {
                dailyBonusSurfacingDay_ios = parseInt(vals['dailyBonusSurfacingDay_ios']);
            }
            if (vals['wallet_Rev_split_ios'] != undefined) {
                dailyBonusBucketR_ios = vals['wallet_Rev_split_ios'];
            }
            if (vals['db_rewards_ios'] != undefined) {
                db_rewards_1_ios = vals['db_rewards_ios'];
            }
            if (vals['db_rewards_2_ios'] != undefined) {
                db_rewards_2_ios = vals['db_rewards_2_ios'];
            }
            if (vals['db_timePeriod_ios'] != undefined) {
                db_timePeriod_ios = parseInt(vals['db_timePeriod_ios']);
            }

            // ----
            if (vals['dcaQuestMap'] != undefined) {
                dcaQuestMap.load(vals['dcaQuestMap']);
            }

            if (vals['ooc_coolDown'] != undefined) {
                ooc_coolDown = vals['ooc_coolDown'];
            }

            if (vals['ooc_coolDownIos'] != undefined) {
                ooc_coolDownIos = vals['ooc_coolDownIos'];
            }

            if (vals['frenzy_type1'] != undefined) {
                frenzy_type1 = vals['frenzy_type1'];
            }

            if (vals['frenzy_type2_dtc2'] != undefined) {
                frenzy_type2_dtc2 = vals['frenzy_type2_dtc2'];
            }

            if (vals['xp'] != undefined) {
                xpValue = vals['xp'];
            }
            if (vals['daily_puzzle'] != undefined) {
                dailyPuzzle = vals['daily_puzzle'];
            }
            if (vals['popup_coolDown'] != undefined) {
                coolDownForPopups = vals['popup_coolDown'];
            }
            if (vals['frenzy_start'] != undefined) {
                frenzy_start = vals['frenzy_start'];
            }
            if (vals['nodesCompletedDayZero'] != undefined) {
                nodesCompletedVal = vals['nodesCompletedDayZero'];
            }
            if (vals['mini_reward'] != undefined) {
                miniCoinGrant = vals['mini_reward'];
            }
            if (vals['midi_reward'] != undefined) {
                midiCoinGrant = vals['midi_reward'];
            }
            if (vals['big_reward'] != undefined) {
                bigCoinGrant = vals['big_reward'];
            }
            if (vals['coin_countryComplete'] != undefined) {
                coinGrantOnCountry = vals['coin_countryComplete'];
            }
            if (vals['pricingHintsFinal'] != undefined) {
                pricingHintsFinal = vals['pricingHintsFinal'];
            }
            if (vals['pricingExpCoin'] != undefined) {
                pricingExpCoins = vals['pricingExpCoin'];
            }
            if (vals['reward_insta'] != undefined) {
                reward_insta = vals['reward_insta'];
            }

            if(vals['pspn_qc_ab_0'] != undefined) {
                pspnQcVersion0 = parseInt(vals['pspn_qc_ab_0']);
            }
            if(vals['pspn_qc_ab_1'] != undefined) {
                pspnQcVersion1 = parseInt(vals['pspn_qc_ab_1']);
            }
            if(vals['pspn_qc_ab_2'] != undefined) {
                pspnQcVersion2 = parseInt(vals['pspn_qc_ab_2']);
            }

            // isPrivacyPolicyOn = parseInt(vals['pp']);
            isPrivacyPolicyOn = parseInt(vals['pp']);
            // if(vals['creatureGrantInterval'] != undefined) {
            //     creatureGrantInterval = vals['creatureGrantInterval'];
            // }
            // if(vals['freeRevealWord'] != undefined) {
            //     freeRevealWord = vals['freeRevealWord'];
            // }
            // if(vals['freeRevealLetters'] != undefined) {
            //     freeRevealLetters = vals['freeRevealLetters'];
            // }
            // loggerObj.debugLog("lelouch the freeRevealWord from runtime is ", freeRevealWord);
            // loggerObj.debugLog("lelouch the freeRevealLetters from runtime is ", freeRevealLetters);
            save();

            localDataAvailable = true;
            if(pspnFlutterObj != undefined) {
                pspnFlutterObj.tryInitializeFlutterQuestCenter();
            }

        } else if (action == "no_update") {

        }
    };

    this.getFromRawRuntime = function (r) {
        return rawRuntime[r];
    };

    this.isNewPurchaseFlowEnabled = function () {
        return newPurchaseFlow;
    };

    this.getAdType = function () {
        return adType;
    };
    this.getAdWallDays = function () {
        return adWallDays;
    };
    this.getAdWallLimit = function () {
        return adwallLimit;
    };
    this.getAdwallCooldownTime = function () {
        return adwallCooldownTime;
    };

    this.getCoolDownRecommendationPopup = function () {
        return coolDownRecommendationPopup;
    };

    this.getFrenzyEasy = function () {
        return frenzy_easy;
    };

    this.getFrenzyHard = function () {
        return frenzy_hard;
    };

    this.getBonusArchiveSwitch = function () {
        return bonusArchiveSwitch;
    };

    this.getBatteryOpti = function () {
        return battery_opti;
    };

    this.getFrenzyMaxReveal = function () {
        return frenzy_max_reveal;
    };

    this.getFrenzyAvgDays = function () {
        return frenzy_avg_days;
    };

    this.getFrenzyStartDay = function () {
        return frenzy_start_day;
    };

    this.getGarbageCollectionSwitch = function () {
        return garbageCollectionSwitch;
    };


    this.getVideoInterstitialCoolDownVar1 = function () {
        return video_var1;
    };

    this.isSubscriptionFreeTrialActive = function () {
        return subscriptionFreeTrialDuration > 0;
    };

    this.getSubscriptionFreeTrialDuration = function () {
        return subscriptionFreeTrialDuration;
    };

    this.getVideoInterstitialCoolDownVar2 = function () {
        return video_var2;
    };

    this.getPovertyLineValue = function () {
        return poverty_line;
    };

    this.getnotifpermcon = function () {
        return notif_perm_c;
    };
    this.getnotifpermvar1 = function () {
        return notif_perm_v;
    };
    this.getIronsourceTapjoy = function () {
        return 1;
        //return ironsourceTapjoy;
    };

    this.getIronsourceReceptive = function () {
        return IronsourceReceptive;
    };

    this.getSupportJsonVersion = function () {
        return supportJsonVersion;
    };

    this.getFbConnectCash = function () {
        return fbConnectCash;
    };

    this.getRevealCount = function () {
        return revealCount;
    };

    this.getPuzzlesVersion = function () {
        return puzzlesVersion;
    };

    this.getReviewVersionCode = function () {
        return reviewVersion;
    };

    this.getDailyMiniVersion = function () {
        return dailyMiniVersion;
    };
    
    this.getNewPackVersion = function () {
        return newPackVersion;
    };

    this.getThemedQuestJsonVersion = function () {
        return themedQuestJsonVersion;
    };

    this.getMopubNativeAdsRefreshInterval = function () {
        return MopubNativeAdsRefreshInterval;
    };

    this.getNumVideos = function (variant) {
        var vals = numVideos.split(":");
        return vals[variant];

    };

    this.getFbMediation = function () {
        return fb_mediation;
    };

    this.getMysteryWatchToEarnCoolDownInDays = function () {
        return mystery_w2e_coolDown * constantsObj.SECONDS_IN_DAY;
    };

    this.getStreakRewardSmall = function () {
        return parseInt(streak_reward_small);
    };

    this.getStreakRewardGrand = function () {
        return parseInt(streak_reward_grand);
    };

    this.getMasteryMiniArchiveCondition = function () {
        return mastery_mini_archive;
    };

    this.getNumVideosNew = function (variant) {
        var w2e_exp = epmObj.getChosenVariant(constantsObj.EXP_W2E_CAPPING);
        var valsNew = [2, 4, 6];
        if (w2e_exp == constantsObj.EXP_VAR_CONTROL) {
            // loggerObj.debugLog("inside control");
            valsNew = numVideosNew.split(":");
            return valsNew[variant];
        }
        else if (w2e_exp == constantsObj.EXP_VAR_1) {
            // loggerObj.debugLog("inside variant1");
            valsNew = numVideosVar1.split(":");
            return valsNew[variant];
        } else {
            return valsNew[variant];
        }
    };

    this.getMysteryRewardThreshold = function (variant) {
        var reward1 = [6, 23, 40];
        reward1 = mystery_reward_threshold.split(":");
        return reward1[variant];
    };
    this.getWeeklyQuestMilestones = function (index) {
        var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
        var wqReward = wqMilestones.split(":");
        if ((weeklyQuestExp == constantsObj.EXP_VAR_3 || weeklyQuestExp == constantsObj.EXP_VAR_4) && gameObj.getWeeklyQuestLastWeekMastery() >= runtimeObj.getWeeklyQuestMasteryLimit()) {
            wqReward = wqMilestonesHard.split(":");
        }
        // loggerObj.debugLog("reward1",wqReward[0]);
        return wqReward[index];
    };
    this.getWeeklyQuestProb = function (index) {
        var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
        var wq_probability = Wq_prob.split(":");
        if ((weeklyQuestExp == constantsObj.EXP_VAR_3 || weeklyQuestExp == constantsObj.EXP_VAR_4) && gameObj.getWeeklyQuestLastWeekMastery() >= runtimeObj.getWeeklyQuestMasteryLimit()) {
            wq_probability = Wq_prob_hard.split(":");
        }
        return wq_probability[index];
    };
    this.getWeeklyQuestPayerProb = function (index) {
        var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
        var wq_payer_probability = Wq_payer_prob.split(":");
        if ((weeklyQuestExp == constantsObj.EXP_VAR_3 || weeklyQuestExp == constantsObj.EXP_VAR_4) && gameObj.getWeeklyQuestLastWeekMastery() >= runtimeObj.getWeeklyQuestMasteryLimit()) {
            wq_payer_probability = Wq_payer_prob_hard.split(":");
        }
        return wq_payer_probability[index];
    };
    this.getWeeklyQuestReward = function (index) {
        var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
        var wq_reward_given = Wq_reward.split(":");
        if ((weeklyQuestExp == constantsObj.EXP_VAR_3 || weeklyQuestExp == constantsObj.EXP_VAR_4) && gameObj.getWeeklyQuestLastWeekMastery() >= runtimeObj.getWeeklyQuestMasteryLimit()) {
            wq_reward_given = Wq_reward_hard.split(":");
        }
        return wq_reward_given[index];
    };
    this.getWeeklyQuestPayerReward = function (index) {
        var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
        var wq_payer_reward_given = Wq_payer_reward.split(":");
        if ((weeklyQuestExp == constantsObj.EXP_VAR_3 || weeklyQuestExp == constantsObj.EXP_VAR_4) && gameObj.getWeeklyQuestLastWeekMastery() >= runtimeObj.getWeeklyQuestMasteryLimit()) {
            wq_payer_reward_given = Wq_payer_reward_hard.split(":");
        }
        return wq_payer_reward_given[index];

    };
    this.getWeeklyQuestTotalstars = function () {
        var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
        if ((weeklyQuestExp == constantsObj.EXP_VAR_3 || weeklyQuestExp == constantsObj.EXP_VAR_4) && gameObj.getWeeklyQuestLastWeekMastery() >= runtimeObj.getWeeklyQuestMasteryLimit()) {
            return wqTotalstarsHard;
        }
        return wqTotalstars;
    };

    this.getMysteryRewardThresholdNew = function (variant) {
        var reward1 = [10, 20, 30];
        reward1 = mystery_reward_threshold_p.split(":");
        return reward1[variant];
    };

    this.getMysteryRewardProbability = function (variant) {
        var probability = [0.285, 0.428, 0.428, 0.571, 0.3, 0.3, 0.3];
        probability = mystery_reward_probability.split(":");
        return probability[variant];
    };

    this.getInterstitialOnPuzzleScreen = function (variant) {
        var vals = interstitialOnPuzzleScreen.split(":");
        return vals[variant];

    };
    this.getCoolDownAfterVideoOrPopups = function () {
        return videoOrPopupCooldown;
    };

    this.getStaticIntSwitch = function () {
        if (static_int == 1) {
            return true;
        }
        return false;

    };

    this.getCoolDownBonusDailyMini = function () {
        return coolDownForBonusDailyMini;
    };

    this.getCoolDownBonusDailyMiniSubs = function () {
        return coolDownForBonusDailyMiniSubs;
    };

    this.getCoolDownForSubsPopup = function () {
        return coolDownForSubsPopup;
    };

    this.getNumberOfSubsPopup = function () {
        return numberOfSubsPopup;
    };
    this.getCoolDownForSubsDialog = function () {
        return coolDownForSubsDialog;
    };
    this.getMastery_grant_control = function (variant) {
        var vals = mastery_grant_control.split(":");
        return vals[variant];

    };

    this.getMastery_grant_var6 = function (variant) {
        var vals = mastery_grant_var6.split(":");
        return vals[variant];

    };

    this.getW2eRewardedCoins = function () {
        return w2eRewardedCoins;
    };

    this.getForceUpdate = function () {
        return parseInt(forceUpdate);
    };

    this.getMaxCreatureSpins = function () {
        return maxCreatureSpins;
    };

    this.getMaxCreatureCoins = function () {
        return maxCreatureCoins;
    };

    this.getInterstitialScreensForVariant = function (variant) {
        var vals = interstitial_cooldown_screens.split(":");
        var val = "7:7:7:7";
        if (vals[variant]) {
            val = vals[variant];
        }
        return val;
    };

    this.getW2eAutoSec = function () {
        var vals = w2eAutoSec.split(":");
        var value = 0;
        if (epmObj.getChosenVariant(constantsObj.EXP_W2E_POWER_UP) == constantsObj.EXP_VAR_3) {
            if (vals[0]) {
                value = parseInt(vals[0]);
            }
        } else if (epmObj.getChosenVariant(constantsObj.EXP_W2E_POWER_UP) == constantsObj.EXP_VAR_4) {
            if (vals[1]) {
                value = parseInt(vals[1]);
            }
        }
        return value;
    };

    // returns the user bucket split for the wq
    this.getEnggBucket = function () {
        return engg_bucket;
    };

    // returns the user puzzle split for the wq
    this.getPuzzleSplit = function () {
        return puzzle_split;
    };

    // returns the questArchivePrice for the wq
    this.getQuestArchivePrice = function () {
        return questArchivePrice;
    };

    // returns the questMiniPrice for the wq
    this.getQuestMiniPrice = function () {
        return questMiniPrice;
    };

    // returns the WQ reward prob for the wq
    this.getWQRewardProb = function () {
        return wq_reward_prob;
    };

    this.getWatchToEarnFtueCooldownHours = function () {
        return watchToEarnFtueCooldownHours;
    };

    this.getSwitchThanksGivingPack = function () {
        return parseInt(switchThanksGivingPack);
    };

    this.getBannerMastery = function () {
        return bannerMastery;
    };

    this.getMaxBannerPayer = function () {
        return maxBannerP;
    };

    this.getDaysForSessionEvent = function () {
        return daysForSessionEvent;
    };

    this.getDailyBonusSurfacingDay = function () {
        return parseInt(dailyBonusSurfacingDay);
    };

    this.getDbTimePeriod = function () {
        return parseInt(db_timePeriod);
    };

    this.getDailyBonusBucketR = function () {
        return dailyBonusBucketR;
    };

    this.getDbRewards1 = function () {
        return db_rewards_1;
    };

    this.getDbRewards2 = function () {
        return db_rewards_2;
    };

    // ios

    this.getDailyBonusSurfacingDay_ios = function () {
        return parseInt(dailyBonusSurfacingDay_ios);
    };

    this.getDbTimePeriod_ios = function () {
        return parseInt(db_timePeriod_ios);
    };

    this.getDailyBonusBucketR_ios = function () {
        return dailyBonusBucketR_ios;
    };

    this.getDbRewards1_ios = function () {
        return db_rewards_1_ios;
    };

    this.getDbRewards2_ios = function () {
        return db_rewards_2_ios;
    };

    // ----

    this.getStartSpin = function () {
        return parseInt(startSpin);
    };

    this.getSpinWheelProb = function () {
        return spinWheelProb;
    };

    this.getWatch2EarnCoinsReward = function () {
        return watch2EarnCoinsReward;
    };

    this.getRefillRate = function () {
        //return 6;
        return refillRate;
    };

    this.getMaxW2eVideosSpinner = function () {
        return maxW2eVideosSpinner;
    };

    this.getCreatureGrantInterval = function () {
        return creatureGrantInterval;
    };

    this.getPrivacyPolicyOn = function () {
        return isPrivacyPolicyOn;
    };

    this.getPlacementStatus = function (placementType) {
        return placementPriorityObj.getAdNetDetails(placementType);
    };

    this.getPlacementResetTime = function () {
        return placementResetTime;
    };

    this.getAutoOnResetTime = function(){
        return autoOnResetTime;
    };

    this.getCountWatchedVideo = function () {
        return CountWatchedVideo;
    };

    this.getCountWatchedVideoPayer = function () {
        return countWatchedVideoPayer;
    };

    this.getMiniMasteryTime = function () {
        return mini_mastery_time;
    };

    this.getMainMasteryTime = function () {
        return main_mastery_time;
    };

    this.getBlitzBufferTime = function () {
        return blitzRuntimes.getBufferTime();
    };

    this.getBlitzBufferTimeFtue = function () {
        return blitzRuntimes.getBufferTimeFtue();
    };

    this.getBlitzTimePerWord = function () {
        return blitzRuntimes.getTimePerWord();
    };

    this.getMaxLivesForBlitz = function () {
        return blitzRuntimes.getMaxLives();
    };

    this.getLivesRefillTimeForBlitz = function () {
        return blitzRuntimes.getLivesRefillTime();
    };

    this.getBlitzLowStreakMul = function () {
        return blitzRuntimes.getLowStreakMul();
    };

    this.getBlitzMediumStreakMul = function () {
        return blitzRuntimes.getMediumStreakMul();
    };

    this.getBlitzHighStreakMul = function () {
        return blitzRuntimes.getHighStreakMul();
    };

    this.getBlitzDiffIncrement = function () {
        return blitzRuntimes.getDiffInc();
    };

    this.getBlitzSetLength = function () {
        return blitzRuntimes.getSetLength();
    };

    this.getBlitzEasyCount = function () {
        return blitzRuntimes.getEasyCount();
    };

    this.getCoinsUsed = function () {
        return blitzRuntimes.getCoinsUsedForResume();
    };

    this.getBlitzFreeLetters = function(){
        return blitzRuntimes.getBlitzFreeLetter();
    };

    this.getBlitzFreeWords = function(){
        return blitzRuntimes.getBlitzFreeWord();
    };

    this.getBlitzRevealLettersCost = function () {
        return blitzRuntimes.getBlitzRevealLetterCost();
    };

    this.getBlitzRevealWordsCost = function () {
        return blitzRuntimes.getBlitzRevealWordCost();
    };

    this.getBlitzContinueTime = function(){
        return blitzRuntimes.getBlitzContinueTime();
    };

    this.getBlitzFinalMilestoneCap = function () {
        return blitzRewardRuntimes.getFinalMilestoneCap();
    };

    this.getBlitzRewardFillSessionLow = function () {
        return blitzRewardRuntimes.getRewardFillSessionLow();
    };

    this.getBlitzRewardFillSessionHigh = function () {
        return blitzRewardRuntimes.getRewardFillSessionHigh();
    };

    this.getBlitzRewardRevStatusLow = function () {
        return blitzRewardRuntimes.getRewardRevStatusLow();
    };

    this.getBlitzRewardRevStatusHigh = function () {
        return blitzRewardRuntimes.getRewardRevStatusHigh();
    };

    this.getBlitzRewardValuePayer = function () {
        return blitzRewardRuntimes.getRewardValuePayer();
    };

    this.getBlitzRewardValueLow = function () {
        return blitzRewardRuntimes.getRewardValueLow();
    };

    this.getBlitzRewardValueMed = function () {
        return blitzRewardRuntimes.getRewardValueMed();
    };

    this.getBlitzRewardValueHigh = function () {
        return blitzRewardRuntimes.getRewardValueHigh();
    };

    this.getBlitzFirstTimeMilestoneValue = function () {
        return blitzRewardRuntimes.getFirstTimeMilestoneValue();
    };

    // this.getFreeRevealWord = function () {
    //     return freeRevealWord;
    // }

    // this.getFreeRevealLetters = function () {
    //     return freeRevealLetters;
    // }

    this.getVideoRetryInterval = function () {
        return mopubVideoRetryParams.getVideoRetryInterval();
    };

    this.getMopubVideoRetryIc = function () {
        return mopubVideoRetryParams.getMopubVideoRetryIc();
    };

    this.getMopubVideoRetryInc = function () {
        return mopubVideoRetryParams.getMopubVideoRetryInc();
    };

    this.getMopubVideoRetryMax = function () {
        return mopubVideoRetryParams.getMopubVideoRetryMax();
    };

    this.getMopubVideoWaitDuration = function () {
        return mopubVideoRetryParams.getMopubVideoWaitDuration();
    };

    this.getMopubVideoPriority = function () {
        return mopubVideoPriority;
    };

    this.getVideoIntCount = function () {
        return videoIntCount;
    };

    this.getCoolDownTimeForVIOnOutro = function () {
        return coolDownTimeForVIOnOutro;
    };

    this.getW2ePowerUpCoolDown = function () {
        return w2ePowerUpCoolDown;
    };

    this.getW2ePowerUpTimer = function () {
        return w2ePowerUpTimer;
    };

    this.getVideoLaunchMaxTime = function(){
        return parseInt(vidlaunchdelay);
    };

    this.getSpinnerFirstDays = function () {
        return spinnerRuntimes.getSpinnerFirstDays();
    };

    this.getSpinGrantInterval = function () {
        return spinnerRuntimes.getSpinGrantInterval();
    };

    this.getMaxSpins = function () {
        return spinnerRuntimes.getMaxSpins();
    };

    this.getSpinnerVideoCap = function(){
        return spinnerRuntimes.getSpinnerVideoCap();
    };

    this.getSpinnerVideoCapForPayer = function(){
        return spinnerRuntimes.getSpinnerVideoCapForPayer();
    };

    this.getSpinnerVideoRefillTime = function(){
        return spinnerRuntimes.getSpinnerVideoRefillTime();
    };

    this.getSpinnerLowCoins = function(){
        return spinnerRuntimes.getSpinnerLowCoins();
    };

    this.getSpinnerLowCoinsForPayer = function(){
        return spinnerRuntimes.getSpinnerLowCoinsForPayer();
    };

    this.getSpinnerMaxCapPayer = function(){
        return spinnerRuntimes.getSpinnerMaxCapPayer();
    };

    this.getSpinnerMedCoins = function(){
        return spinnerRuntimes.getSpinnerMedCoins();
    };

    this.getSpinnerHighCoins = function(){
        return spinnerRuntimes.getSpinnerHighCoins();
    };

    this.getSpinnerHintDisc = function(){
        return spinnerRuntimes.getSpinnerHintDisc();
    };

    this.getSpinnerRevEngagement = function () {
        return spinnerRuntimes.getSpinnerRevEngagement();
    };

    this.getSpinnerTimePeriod = function () {
        return spinnerRuntimes.getSpinnerTimePeriod();
    };

    this.getSpinnerPuzzleEngagement = function () {
        return spinnerRuntimes.getSpinnerPuzzleEngagement();
    };

    this.getSpinnerRewardProb = function () {
        return spinner_rewardProb;
    };

    this.getNumberOfBonusArchive = function () {
        return numberOfBonusArchive;
    };

    this.getW2ePowerUpLimit = function (index) {
        var arr = w2ePowerUpLimit.split(":");
        return arr[index];
    };
    this.getAdaptiveStartVals = function(){
        return adaptive_start;
    };
    this.getPuzzlesRequiredForAdaptive = function(){
        return puzzleRequired_adaptive;
    };
    this.getAvgMasteryForAdaptive = function(){
        return adaptive_averageMastery;
    };
    this.getW2ePowerUpDayLimit = function () {
        return w2ePowerUpDayLimit;
    };

    this.getWeeklyQuestMasteryLimit = function () {
        return weeklyQuestMasteryLimit;
    };

    this.getTriggering_time_w2e = function(){
        return contextualW2eRuntimes.getTriggering_time();
    };

    this.getContextual_w2e_day_cap = function(){
        return contextualW2eRuntimes.getPopupDayCap();
    };

    this.getTriggeringCooldownW2e = function(){
        return contextualW2eRuntimes.getTriggeringCooldown();
    };

    this.getMinWordFailsW2e = function(){
        return contextualW2eRuntimes.getMinWordFails();
    };

    this.getMaxFillPercentForW2e = function(){
        return contextualW2eRuntimes.getMaxFillPercent();
    };

    this.getTriggering_time_w2e_var2 = function(){
        return contextualW2eRuntimes.getTriggering_time_var2();
    };

    this.getContextual_w2e_day_cap_var2 = function(){
        return contextualW2eRuntimes.getPopupDayCapVar2();
    };

    this.getTriggeringCooldownW2eVar2 = function(){
        return contextualW2eRuntimes.getTriggeringCooldownVar2();
    };

    this.getMinWordFailsW2eVar2 = function(){
        return contextualW2eRuntimes.getMinWordFailsVar2();
    };

    this.getMaxFillPercentForW2eVar2 = function(){
        return contextualW2eRuntimes.getMaxFillPercentVar2();
    };

    this.getBonusArchiveOutro = function () {
        return bonusArchiveOutro;
    };

    this.getW2eHighlightButtonDelay = function () {
        return w2eHighlight.getW2eButtonDelay();
    };
    this.getW2eHighlightButtonCount = function () {
        return w2eHighlight.getW2eButtonCount();
    };
    this.getW2eHighlightButtonTime = function () {
        return w2eHighlight.getW2eButtonTime();
    };
    this.getW2eHighlightButtonCoolDown = function () {
        return w2eHighlight.getW2eButtonCoolDown();
    };
    this.getW2eHighlightAnimationCount = function () {
        return w2eHighlight.getW2eAnimationCount();
    };
    this.getW2eHighlightAnimationCoolDown = function () {
        return w2eHighlight.getW2eAnimationCoolDown();
    };

    this.getMopubAdUnits = function () {
        loggerObj.debugLog("check for the adunit data js data1 ", utilObj.getStringifiedJson(mopubAdUnits));
        if (utilObj.isAndroid()) {
            return mopubAdUnits;
        } else if (utilObj.isIos()) {
            return mopubAdUnitsIos;
        }
    };

    this.getMopubBannerRefresh = function () {
        if (utilObj.isAndroid()) {
            return mopubBannerRefresh;
        } else if (utilObj.isIos()) {
            return mopubBannerRefreshIos;
        }
    };

    this.getCarouselViewsRequired = function () {
        return homeCarouselParams.getViewsRequired();
    };

    this.getCarouselAnimCooldownHours = function () {
        return homeCarouselParams.getAnimCooldownHours();
    };

    this.getCarouselDaysEligibility = function () {
        return homeCarouselParams.getDaysEligibility();
    };

    this.getBritPackSurfacingDaysEligibility = function () {
        return britPackSurfacingDaysEligibility;
    };

    this.setBritPackSurfacingDaysEligibility = function (val) {
        britPackSurfacingDaysEligibility = val;
    };

    this.getBritPackMinimumMasteryRequirement = function () {
        return britPackMinimumMasteryRequirement;
    };

    this.setBritPackMinimumMasteryRequirement = function (val) {
        britPackMinimumMasteryRequirement = val;
    };

    this.getBritPackViewedNotPlayedDays = function () {
        return britPackViewedNotPlayedDays;
    };

    this.setBritPackViewedNotPlayedDays = function (val) {
        britPackViewedNotPlayedDays = val;
    };

    this.getDCQuestMapCooldownMinutes = function () {
        return dcaQuestMap.getCooldownMins();
    };

    this.getDCQuestMapMaxViewPerDay = function () {
        return dcaQuestMap.getMaxViewPerDay();
    };

    this.getOOCCoolDown = function () {
        if (utilObj.isIos()) {
            return ooc_coolDownIos;
        }
        return ooc_coolDown;
    };

    this.getFrenzyType1 = function () {
        return frenzy_type1;
    };

    this.getFrenzyType2 = function () {
        return frenzy_type2_dtc2;
    };

    this.getXpValue = function () {
        return parseInt(xpValue);
    };

    this.getDailyPuzzle = function () {
        return dailyPuzzle;
    };
    this.getCoolDownForPopups = function(){
        return coolDownForPopups;
    };
    this.getFrenzyStart = function () {
        return frenzy_start;
    };
    this.getNodesCompletedD0 = function(){
        return nodesCompletedVal;
    };
    this.getCoinGrantValOnCountry =  function(){
        return coinGrantOnCountry;
    };
    this.getMiniReward = function(){
        return miniCoinGrant;
    };
    this.getMidiReward = function(){
        return midiCoinGrant;
    };
    this.getBigReward = function(){
        return bigCoinGrant;
    };
    this.getPricingHintsFinal = function () {
        return pricingHintsFinal;
    };
    this.getPricingExpCoins = function(){
        return pricingExpCoins;
    };
    this.getRewardInsta = function () {
        return parseInt(reward_insta);
    };

    this.getQuestCenterVersion = function() {
        return {
            "pspn_qc_ab_0": pspnQcVersion0,
            "pspn_qc_ab_1": pspnQcVersion1,
            "pspn_qc_ab_2": pspnQcVersion2,
        };
    };

    this.isLocalDataAvailable = function() {
        return localDataAvailable;
    }
};

SpinnerWheelProb = function () {
    var free1 = 0.5,
        free2 = 0.3,
        plus10 = 0.01,
        plus5 = 0.1,
        revealWord = 0.04,
        freeSpin = 0.05;

    this.getSpinnerObj = function () {
        var obj = {};

        obj.freeSpin = freeSpin;
        obj.free1 = free1;
        obj.free2 = free2;
        obj.plus10 = plus10;
        obj.plus5 = plus5;
        obj.revealWord = revealWord;
        return obj;
    };

    this.load = function (obj) {
        free1 = parseFloat(obj.free1);
        free2 = parseFloat(obj.free2);
        plus10 = parseFloat(obj.plus10);
        plus5 = parseFloat(obj.plus5);
        revealWord = parseFloat(obj.revealWord);
        freeSpin = parseFloat(obj.freeSpin);

        /*var newSpinnerInterval = parseInt(obj.spinWheelInterval);
         if (newSpinnerInterval != spinWheelInterval) {
         gameObj.resetOrSetSpinnerTimer();
         }
         spinWheelInterval = newSpinnerInterval;*/
    };

    this.getFree2 = function () {
        return free2;
    };
    this.getFree1 = function () {
        return free1;
    };
    this.getPlus10 = function () {
        return plus10;
    };
    this.getPlus5 = function () {
        return plus5;
    };

    this.getRevealWord = function () {
        return revealWord;
    };

    this.getFreeSpin = function () {
        return freeSpin;
    };

};

Watch2EarnCoinsReward = function () {
    var control = 3,
        var1 = 3,
        var2 = 1,
        var3 = 1,
        var4 = 3,
        var5 = 6,
        var6 = 5,
        var7 = 5;

    this.getWatch2EarnCoinsObj = function () {
        var obj = {};
        obj.control = control;
        obj.var1 = var1;
        obj.var2 = var2;
        obj.var3 = var3;
        obj.var4 = var4;
        obj.var5 = var5;
        obj.var6 = var6;
        obj.var7 = var7;
        return obj;
    };

    this.load = function (obj) {
        control = parseFloat(obj.control);
        var1 = parseFloat(obj.var1);
        var2 = parseFloat(obj.var2);
        var3 = parseFloat(obj.var3);
        var4 = parseFloat(obj.var4);
        var5 = parseFloat(obj.var5);
        var6 = parseFloat(obj.var6);
        var7 = parseFloat(obj.var7);
    };

    this.getControl = function () {
        return control;
    };

    this.getVar1 = function () {
        return var1;
    };

    this.getVar2 = function () {
        return var2;
    };

    this.getVar3 = function () {
        return var3;
    };

    this.getVar4 = function () {
        return var4;
    };

    this.getVar5 = function () {
        return var5;
    };

    this.getVar6 = function () {
        return var6;
    };

    this.getVar7 = function () {
        return var7;
    };
};

PlacementPriority = function () {
    var adNetDetails = [[], [], []];
    adNetDetails[0][0] = {"n": 3, "p": 1, "i": 2, "r": 5};
    adNetDetails[1][0] = {"n": 3, "p": 1, "i": 2, "r": 5};
    adNetDetails[2][0] = {"n": 3, "p": 1, "i": 1, "r": 5};
    this.load = function (data, placementType) {
        if (data == "" || data == undefined) {
            return;
        }
        var info = data.split(":");
        var j = 0;
        for (var i = 0; i < info.length; i++) {
            var adNet = info[i].split("-");
            var adSwitch = parseInt(adNet[0]);
            if (adSwitch == 1) {
                adNetDetails[placementType][j] = {
                    "n": parseInt(adNet[2]),
                    "p": parseInt(adNet[1]),
                    "i": i,
                    "r": parseInt(adNet[3])
                };
                j++;
            }
        }
        // loggerObj.debugLog("check for the place type ", adNetDetails[placementType]);
        var adNetDetailForPlacement = adNetDetails[placementType];
        // loggerObj.debugLog("check for the place type", placementType, JSON.stringify(adNetDetailForPlacement));
        adNetDetailForPlacement.sort(function (a, b) {
            var keyA = a.p;
            var keyB = b.p;
            return keyA - keyB;
        });
    };

    this.getAdNetDetails = function (placementType) {
        return adNetDetails[placementType];
    };
};

// spinner runtimes
SpinnerRuntimesNew = function () {

    var spinner_firstdays = 7;
    var spinner_revEngagement = 4;
    var spinner_timePeriod = 7;
    var spinner_puzzleEngagement = 3;
    var spinner_refillTime = 12 * 60 * 60;
    var spinner_cap = 2;
    var spinner_locoins = 3;
    var spinner_medcoins = 5;
    var spinner_hicoins = 7;
    var spinner_hintdisc = 40;
    var spinner_w2erefillTime = 12* 60 * 60;
    var spinner_w2ecap = 1;
    var spinner_w2ecap_payer = 2;
    var spinner_locoins_payer = 2;
    var spinner_max_cap_payer = 1;

    this.load = function (data) {
        if (data == "") {
            return;
        }
        var info = data.split(":");
        spinner_firstdays = parseInt(info[0]);
        spinner_revEngagement = parseInt(info[1]);
        spinner_timePeriod = parseInt(info[2]);
        spinner_puzzleEngagement = parseInt(info[3]);
        spinner_refillTime = parseInt(info[4]);
        spinner_cap = parseInt(info[5]);
        spinner_locoins = parseInt(info[6]);
        spinner_medcoins = parseInt(info[7]);
        spinner_hicoins = parseInt(info[8]);
        spinner_hintdisc = parseInt(info[9]);
        spinner_w2erefillTime = parseInt(info[10]);
        spinner_w2ecap = parseInt(info[11]);
        if(parseInt(info[12]) != undefined){
            spinner_w2ecap_payer = parseInt(info[12]);
        }
        if(parseInt(info[13]) != undefined){
            spinner_locoins_payer = parseInt(info[13]);
        }
        if(parseInt(info[14]) != undefined){
            spinner_max_cap_payer = parseInt(info[14]);
        }

    };

    this.getSpinnerFirstDays = function () {
        return parseInt(spinner_firstdays);
    };

    this.getSpinnerRevEngagement = function () {
        return parseInt(spinner_revEngagement);
    };

    this.getSpinnerTimePeriod = function () {
        return parseInt(spinner_timePeriod);
    };

    this.getSpinnerPuzzleEngagement = function () {
        return parseInt(spinner_puzzleEngagement);
    };

    this.getSpinGrantInterval = function () {
        return parseInt(spinner_refillTime);
    };

    this.getMaxSpins = function () {
        return parseInt(spinner_cap);
    };

    this.getSpinnerLowCoins = function(){
        return spinner_locoins;
    };

    this.getSpinnerMedCoins = function(){
        return spinner_medcoins;
    };

    this.getSpinnerHighCoins = function(){
        return spinner_hicoins;
    };

    this.getSpinnerHintDisc = function(){
        return spinner_hintdisc;
    };

    this.getSpinnerVideoRefillTime = function(){
        return spinner_w2erefillTime;
    };

    this.getSpinnerVideoCap = function(){
        return spinner_w2ecap;
    };

    this.getSpinnerVideoCapForPayer = function(){
        return spinner_w2ecap_payer;
    };

    this.getSpinnerLowCoinsForPayer = function(){
        return spinner_locoins_payer;
    };

    this.getSpinnerMaxCapPayer = function(){
        return spinner_max_cap_payer;
    };
};

BlitzRuntimes = function () {
    var bufferTime = 60;
    var bufferTimeFtue = 30;
    var timePerWord = 10;
    var livesRefillTime = 120; // In seconds.
    var maxLives = 3;
    var lowStreakMul = 2;
    var mediumStreakMul = 5;
    var highStreakMul = 10;
    var setLength = 10;
    var easyCount = 10;
    var diffIncrement = 1;
    var coinsUsed = 10;
    var blitz_free_letter = 3;
    var blitz_free_word = 1;
    var REVEAL_LETTER_COST = 1;
    var REVEAL_WORD_COST = 3;
    var blitz_continue_time = 30;

    this.load = function (data) {
        if (data == "") {
            return;
        }
        var info = data.split(":");
        bufferTime = parseInt(info[0]);//10;
        timePerWord = parseInt(info[1]);
        livesRefillTime = parseInt(info[2]);
        maxLives = parseInt(info[3]);
        lowStreakMul = parseInt(info[4]);
        mediumStreakMul = parseInt(info[5]);
        highStreakMul = parseInt(info[6]);
        setLength = parseInt(info[7]);
        easyCount = parseInt(info[8]);
        diffIncrement = parseInt(info[9]);
        coinsUsed = parseInt(info[10]);
        blitz_free_letter = parseInt(info[11]);
        blitz_free_word = parseInt(info[12]);
        REVEAL_LETTER_COST = parseInt(info[13]);
        REVEAL_WORD_COST = parseInt(info[14]);
        if (info[15] != undefined) {
            bufferTimeFtue = parseInt(info[15]);
        }
        if(info[16] != undefined){
            blitz_continue_time = parseInt(info[16]);
        }
    };

    this.getBufferTime = function () {
        return bufferTime;
    };

    this.getBufferTimeFtue = function () {
        return bufferTimeFtue;
    };

    this.getTimePerWord = function () {
        return timePerWord;
    };

    this.getMaxLives = function () {
        return maxLives;
    };

    this.getLivesRefillTime = function () {
        return livesRefillTime;
    };

    this.getLowStreakMul = function () {
        return lowStreakMul;
    };

    this.getMediumStreakMul = function () {
        return mediumStreakMul;
    };

    this.getHighStreakMul = function () {
        return highStreakMul;
    };

    this.getSetLength = function () {
        return setLength;
    };

    this.getEasyCount = function () {
        return easyCount;
    };

    this.getDiffInc = function () {
        return diffIncrement;
    };

    this.getCoinsUsedForResume = function () {
        return coinsUsed;
    };

    this.getBlitzFreeLetter = function(){
        return blitz_free_letter;
    };

    this.getBlitzFreeWord = function(){
        return blitz_free_word;
    };

    this.getBlitzRevealLetterCost = function () {
        return REVEAL_LETTER_COST;
    };

    this.getBlitzRevealWordCost = function () {
        return REVEAL_WORD_COST;
    }

    this.getBlitzContinueTime = function(){
        return blitz_continue_time;
    }
};

//blitz reward runtimes
BlitzRewardRuntimes = function () {
    var finalMilestoneCap = 500;
    var rewardFillSessionLow = 5;
    var rewardFillSessionHigh = 10;
    var rewardRevStatusLow = 7;
    var rewardRevStatusHigh = 15;
    var rewardValuePayer = 10;
    var rewardValueLow = 10;
    var rewardValueMed = 20;
    var rewardValueHigh = 30;
    var firstTimeMilestoneValue = 550;

    this.load = function (data) {
        if (data == "") {
            return;
        }
        var info = data.split(":");
        finalMilestoneCap = parseInt(info[0]);
        rewardFillSessionLow = parseInt(info[1]);
        rewardFillSessionHigh = parseInt(info[2]);
        rewardRevStatusLow = parseInt(info[3]);
        rewardRevStatusHigh = parseInt(info[4]);
        rewardValuePayer = parseInt(info[5]);
        rewardValueLow = parseInt(info[6]);
        rewardValueMed = parseInt(info[7]);
        rewardValueHigh = parseInt(info[8]);
        firstTimeMilestoneValue = parseInt(info[9]);
    };
    this.getFinalMilestoneCap = function () {
        return finalMilestoneCap;
    };

    this.getRewardFillSessionLow = function () {
        return rewardFillSessionLow;
    };

    this.getRewardFillSessionHigh = function () {
        return rewardFillSessionHigh;
    };

    this.getRewardRevStatusLow = function () {
        return rewardRevStatusLow;
    };

    this.getRewardRevStatusHigh = function () {
        return rewardRevStatusHigh;
    };

    this.getRewardValuePayer = function () {
        return rewardValuePayer;
    };

    this.getRewardValueLow = function () {
        return rewardValueLow;
    };

    this.getRewardValueMed = function () {
        return rewardValueMed;
    };

    this.getRewardValueHigh = function () {
        return rewardValueHigh;
    };

    this.getFirstTimeMilestoneValue = function () {
        return firstTimeMilestoneValue
    };
};

// w2e highlight runtimes
W2eHighlight = function () {
    var w2eButtonDelay = 12;
    var w2eButtonCount = 6;
    var w2eButtonTime = 3600;
    var w2eButtonCoolDown = 4;
    var w2eAnimationCount = 5;
    var w2eAnimationCoolDown = 60;

    this.load = function (data) {
        if (data == "" || data == undefined) {
            return;
        }
        var dataArr = data.split(":");
        w2eButtonDelay = parseInt(dataArr[0]);
        w2eButtonCount = parseInt(dataArr[1]);
        w2eButtonTime = parseInt(dataArr[2]);
        w2eButtonCoolDown = parseInt(dataArr[3]);
        w2eAnimationCount = parseInt(dataArr[4]);
        w2eAnimationCoolDown = parseInt(dataArr[5]);
    };

    this.getW2eButtonDelay = function () {
        return w2eButtonDelay;
    };
    this.getW2eButtonCount = function () {
        return w2eButtonCount;
    };
    this.getW2eButtonTime = function () {
        return w2eButtonTime;
    };
    this.getW2eButtonCoolDown = function () {
        return w2eButtonCoolDown;
    };
    this.getW2eAnimationCount = function () {
        return w2eAnimationCount;
    };
    this.getW2eAnimationCoolDown = function () {
        return w2eAnimationCoolDown;
    };
};


// Mopubs Runtimes
MopubVideoRetryParams = function () {
    var videoRetryInterval = 180;
    var mopubVideoRetryIc = 10;
    var mopubVideoRetryInc = 10;
    var mopubVideoRetryMax = 60;
    var mopubVideoWaitDuration = 3;

    this.load = function (data) {
        if (data == "" || data == undefined) {
            return;
        }
        var dataArr = data.split(":");
        videoRetryInterval = parseInt(dataArr[0]);
        mopubVideoRetryIc = parseInt(dataArr[1]);
        mopubVideoRetryInc = parseInt(dataArr[2]);
        mopubVideoRetryMax = parseInt(dataArr[3]);
        mopubVideoWaitDuration = parseInt(dataArr[4]);
    };


    this.getData = function () {
        return videoRetryInterval + ":" + mopubVideoRetryIc + ":" + mopubVideoRetryInc + ":" + mopubVideoRetryMax + ":" + mopubVideoWaitDuration;
    };

    this.getVideoRetryInterval = function () {
        return videoRetryInterval;
    };
    this.getMopubVideoRetryIc = function () {
        return mopubVideoRetryIc;
    };
    this.getMopubVideoRetryInc = function () {
        return mopubVideoRetryInc;
    };
    this.getMopubVideoRetryMax = function () {
        return mopubVideoRetryMax;
    };
    this.getMopubVideoWaitDuration = function () {
        return mopubVideoWaitDuration;
    };
};

HomeCarouselParams = function () {
    var views = [2, 3, -1];
    var cooldownHours = [1, 1, -1];
    var daysSinceInstall = [7, 7, -1];

    this.load = function (data) {
        if (data == "" || data == undefined) {
            return;
        }
        var dataArr = data.split(":");
        var variant = 0;
        for(var i = 0; (i+3) <= dataArr.length; i+=3) {
            views[variant] = parseInt(dataArr[i]);
            cooldownHours[variant] = parseFloat(dataArr[i+1]);
            daysSinceInstall[variant] = parseInt(dataArr[i+2]);
            variant++;
        }
    };


    this.getData = function () {
        var data = "";
        for(var i = 0; i < views.length; i++) {
            data = data + views[i] + ":"  + cooldownHours[i] + ":" + daysSinceInstall[i] + ":";
        }

        if(data.length > 0) {
            data = data.substring(0, data.length-1);
        }
        return data;
    };

    this.getViewsRequired = function () {
        var carouselExp = xpromoDtcObj.getCarouseExperimentVariant();
        if(carouselExp > 0 && views[carouselExp - 1] != undefined) {
            return views[carouselExp - 1];
        }
        return -1;
    };

    this.getAnimCooldownHours = function () {
        var carouselExp = xpromoDtcObj.getCarouseExperimentVariant();
        if(carouselExp > 0 && cooldownHours[carouselExp - 1] != undefined) {
            return cooldownHours[carouselExp - 1];
        }
        return -1;
    };

    this.getDaysEligibility = function() {
        var carouselExp = xpromoDtcObj.getCarouseExperimentVariant();
        if(carouselExp > 0 && daysSinceInstall[carouselExp - 1] != undefined) {
            return daysSinceInstall[carouselExp - 1];
        }
        return -1;
    }
};

/*
* will have all runtimes for contextual w2e with different set of runtimes for var1 and var2.
 */
ContextualW2eRuntimes = function() {
    var triggering_time_w2e = 50;
    var contextual_w2e_day_cap = 3;
    var triggering_coolDown = 10;
    var min_wfails = 10;
    var max_fill = 50;
    var triggering_time_w2e_var2 = 30;
    var contextual_w2e_day_cap_var2 = 4;
    var triggering_coolDown_var2 = 15;
    var min_wfails_var2 = 15;
    var max_fill_var2= 60;

    this.load = function (data) {
        if (data == "") {
            return;
        }
        var info = data.split(":");
        triggering_time_w2e = parseInt(info[0]);
        contextual_w2e_day_cap = parseInt(info[1]);
        triggering_coolDown = parseInt(info[2]);
        min_wfails = parseInt(info[3]);
        max_fill = parseInt(info[4]);
        triggering_time_w2e = parseInt(info[0]);
        contextual_w2e_day_cap = parseInt(info[1]);
        triggering_coolDown = parseInt(info[2]);
        min_wfails = parseInt(info[3]);
        max_fill = parseInt(info[4]);
        triggering_time_w2e_var2 = parseInt(info[5]);
        contextual_w2e_day_cap_var2 = parseInt(info[6]);
        triggering_coolDown_var2 = parseInt(info[7]);
        min_wfails_var2 = parseInt(info[8]);
        max_fill_var2 = parseInt(info[9]);
    };

    this.getTriggering_time = function () {
        return triggering_time_w2e;
    };

    this.getPopupDayCap = function () {
        return contextual_w2e_day_cap;
    };

    this.getTriggeringCooldown = function () {
        return triggering_coolDown;
    };

    this.getMinWordFails = function () {
        return min_wfails;
    };

    this.getMaxFillPercent = function () {
        return max_fill;
    };

    this.getTriggering_time_var2 = function () {
        return triggering_time_w2e_var2;
    };

    this.getPopupDayCapVar2 = function () {
        return contextual_w2e_day_cap_var2;
    };

    this.getTriggeringCooldownVar2= function () {
        return triggering_coolDown_var2;
    };

    this.getMinWordFailsVar2 = function () {
        return min_wfails_var2;
    };

    this.getMaxFillPercentVar2 = function () {
        return max_fill_var2;
    };

};

/**
 * runtime for storing viewPerDayLimits and cooldown for daily challenge section animation on questMapLayer
 * @constructor
 */
DailyChallengeAnimationQuestMap = function () {
    var cooldownMins = 3;
    var maxViewPerDay = 5;

    this.load = function (data) {
        if (data == "" || data == undefined) {
            return;
        }
        var dataArr = data.split(":");
        cooldownMins = dataArr[0];
        maxViewPerDay = dataArr[1];
    };

    this.getData = function () {
        return cooldownMins + ":" + maxViewPerDay;
    };

    this.getCooldownMins = function () {
        return cooldownMins;
    };

    this.getMaxViewPerDay = function () {
        return maxViewPerDay;
    };

};
