Timers = function () {
    var globalTimer = null;
    var numNonNullLabels = 0;
    var sync = false;

    // On screen change, look for all tags and update every second on that screen.
    var nextDailyBonusLabel = null;

    var screenQueue = [];
    var tickCount = 0;
    var nativeAdTimer = 0;
    this.init = function () {
        globalTimer = window.setInterval(function () {
            // loggerObj.traceLog("Global timer triggered");
            if (tickCount > 15 && tickCount % 5 == 0) {
                // Suraj: Can be used to put some test method calls here, if something needs to be triggered periodically
            }
            tickCount++;

            var timeStamp = utilObj.getCurrentTimestamp();
            if (isFirstLoad && tickCount == 10) {
                analyticsObj.trackInstall();
            }
            if (utilObj.hasHeader()) {
                timersObj.updateLabels();
                timersObj.showPendingScreen();
                timersObj.updateOthers();
            } else {
                // loggerObj.debugLog("No label update");
            }

            if (loadingNewLayer.layerSeen && (adsObj.checkRewardedVideoAvailable() || (utilObj.getCurrentTimestamp() > (startLoadingTime + runtimeObj.getVideoLaunchMaxTime())))) {
                var reason = "";
                var isVideoAvailable = adsObj.checkRewardedVideoAvailable();
                if (isVideoAvailable && (utilObj.getCurrentTimestamp() > (startLoadingTime + runtimeObj.getVideoLaunchMaxTime()))) {
                    reason = "videoAndRuntime";
                } else if (isVideoAvailable) {
                    reason = "video";
                } else {
                    reason = "runtime";
                }
                trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", reason, constantsObj.TRACK_LS_LAYER, constantsObj.TRACK_HIDE, "", "", "", "");
                loadingNewLayer.hide();
            }

            if (loadingNewLayer.layerSeen && !(adsObj.checkRewardedVideoAvailable() || (utilObj.getCurrentTimestamp() > (startLoadingTime + runtimeObj.getVideoLaunchMaxTime())))) {
                if (tickCount % 2 == 0) {
                    loadingNewLayer.animateProgressDots(loadingNewLayer.dots);
                }
            }

            if (tickCount % 30 == 0 && tickCount != 0) {
                psPrivacyObj.checkAndtriggerStatusUpdateForDataPrivacyRequests();
                spinnerObj.callShineAnimation();
            }
            gameObj.checkForSpinnerAnimation();
           gameObj.checkForSeeWrongContextualPopup();
            timersObj.updateSpinnerInfo();
            zenModeObj.updateTimerForZen();
            gameObj.incTimeElapsed();
            gameObj.updatePuzzleUnlockTime();
            gameObj.decTimeRemaining();
            // gameObj.updateSpinRefillTime();

            if (tickCount <= 60 && tickCount % 10 == 0) {
                var HIDE_BANNER_AD_SCREENS = [constantsObj.SCREEN_FAQ, constantsObj.SCREEN_STORE_LAYER, constantsObj.SCREEN_FIRST_LAUNCH, constantsObj.SCREEN_MORE_GAMES_LAYER, constantsObj.SCREEN_PUSH_NOTIF_SCREEN, constantsObj.SCREEN_ZEN_MODE, constantsObj.SCREEN_SUBSCRIPTIONS, constantsObj.SCREEN_MAIL_SUPPORT, constantsObj.SCREEN_QUEST_MAP, constantsObj.SCREEN_NEW_INTRO, constantsObj.SCREEN_OUTRO_LAYER, constantsObj.SCREEN_TRANS_OUTRO_LAYER , constantsObj.SCREEN_LANDING];
                var hide_Banner_Ad = false;
                for (var i = 0; i < HIDE_BANNER_AD_SCREENS.length; i++) {
                    if (utilObj.getScreenName(curScreen) == utilObj.getScreenName(HIDE_BANNER_AD_SCREENS[i])) {
                        hide_Banner_Ad = true;
                    }
                }
                if (dailyBonusLayer.getDailyBonusScreenVisible()) {
                    hide_Banner_Ad = true;
                }
                if (!hide_Banner_Ad) {
                    utilObj.showBannerAd(utilObj.getScreenName(curScreen));
                }
            }
            themedQuestObj.updateTimeRemaining();
            weeklyQuestObj.updateTimeRemaining();

            xpromoUtilObj.timerTick();

            if (homeLayoutExp == constantsObj.EXP_VAR_1) {
                homeLayer.updateRemainingTime();
            }

            if (tickCount > 15 && tickCount % 5 == 0) {
                // Suraj: Can be used to put some test method calls here, if something needs to be triggered periodically
            }

            if (tickCount == 1 && userObj.getRefId() == "") {
                userObj.syncToServer(true); // First attempt to get refid
            }

            if (tickCount % 10 == 0 || (isFirstLoad && tickCount % 5 == 0)) {
                // loggerObj.debugLog("Cur cash:", economyObj.getCash(), userObj.getRefId());
                utilObj.attemptSyncs();
            }

            if (tickCount % 3 == 0) {
                if (curScreen == constantsObj.SCREEN_GAME && gameObj.w2eHighlightCondition() == true) {
                    gameLayer.highlightW2eButton();
                }
                // zenModeLayer.addNextWord();

            }

            if (tickCount == 5 || tickCount % 60 == 0) {
                gameObj.syncToServerXcode();
            }

            // if (tickCount % 15 == 0) {
            //     timersObj.logMemoryFootprint();
            // }

            if (tickCount % 30 == 0) {
                utilObj.getAvailableMem();
                utilObj.getFps();
            }

            if (tickCount % 60 == 0) {
                trackObj.trackDupEvent();
                downloadManagerObj.checkAndDownloadFiles(false);
            }

            timedHintsObj.checkAndRefreshAllHints(timeStamp);
        }, constantsObj.SECOND_IN_MS);
    };

    this.resetTimers = function () {
        this.clearLabels();
        this.setLabels();
    };

    this.clearLabels = function () {
        numNonNullLabels = 0;
        nextDailyBonusLabel = null;
    };

    this.setLabels = function () {

    };

    this.updateLabels = function () {
        if (numNonNullLabels == 0) {
            return;
        }
    };

    this.updateSpinnerInfo = function () {
        if (epmObj.getChosenVariant(constantsObj.EXP_SPINNER_NEW) == constantsObj.EXP_VAR_1) {
            economyObj.checkAndStartSpinRegenerationTimer();
            economyObj.checkAndGrantSpin();
            economyObj.updateSpinTimer();
        }
    };


    this.showPendingScreen = function () {
        if (screenQueue.length <= 0) {
            return;
        }

        if (!utilObj.canChangeScreen()
            || (curScreen != constantsObj.SCREEN_HOME && curScreen != constantsObj.SCREEN_CALENDAR)) {
            return;
        }
        var screenInfo = screenQueue.pop();
        screenInfo.s(screenInfo.p);
    };

    this.queueScreenChange = function (screenShow, params) {
        screenQueue.push({s: screenShow, p: params});
    };

    this.updateOthers = function () {
        trackObj.resetTrackingLastSec();
    };

    this.startNativeAdTimer = function () {
        nativeAdTimer = 1;
    };

    this.stopNativeAdTimer = function () {
        nativeAdTimer = 0;
    };

    this.logMemoryFootprint = function () {
        if (utilObj.isIos()) {
            jsb.reflection.callStaticMethod(constantsObj.PACKAGE_PATH_IOS + "Util", "logMemoryFootprint");
        }
    };
};
