Achievements = function () {
    var achievementsInOrder = [];
    var achievementStats = [];
    var listItemsQuest = [];
    var countOfAchievements = constantsObj.ACHIEVEMENT_TOTAL;
    var BucketForTypeofAchievement = {
        "0": "43",
        "1": "0,1,2,3,17,4,40,10",
        "2": "6,72,7,73,74,8,75,76,77,9",
        "3": "41,42",
        "4": "11,44,12,45,46,13,49,50,51,52,53",
        "5": "14",
        "6": "15,16,54,55,56,57,58,59,60",
        "7": "18,19,61,62,63",
        "8": "20,21,22",
        "9": "23",
        "10": "24,25",
        "11": "26,27",
        "12": "28,29",
        "13": "30,31",
        "14": "32,33",
        "15": "34,35",
        "16": "36,37",
        "17": "38,39",
        "18": "64,65,66,67,68,69,70,71",
        "19": "79",
        "20": "80"
    };
    this.getAchievementDetails = function (ind) {
        //loggerObj.debugLog("this is index in getAchievements ", ind);
        var achievementSection = {};
        if (ind == constantsObj.CrossPromoAchievement1 || ind == constantsObj.CrossPromoAchievement2) {
            achievementSection = xpromoDtcObj.fetchingAchievementDetails(ind, listItemsQuest);
        } else if (ind == constantsObj.InGameAchievement1) {
            var questDetails = achievementsObj.getWhatsappQuest();
            if (questDetails == null) {
                return;
            }
            var desc = questDetails["d"];
            var cta = constantsObj.OPEN_WHATSAPP;
            var reward = Math.round(questDetails["re"] * questsObj.getDollarValue());
            var progress = 0;
            var hasProgressBar = 0;
            var maxCount = 0;
            var hasTimerBar = 0;
            achievementSection = {
                id: parseInt(ind),
                title: constantsObj.SUBSCRIBE,
                questId: questDetails["id"],
                desc: desc,
                cta: cta,
                reward: reward,
                progress: progress,
                maxCount: maxCount,
                state: questDetails["status"],
                hasProgressBar: hasProgressBar,
                hasTimerBar: hasTimerBar,
                bucket: questDetails["b"]
            };
        } else {
            var index = parseInt(ind);
            var title = constantsObj.ACHIEVEMENTS_TITLES[index];
            var desc = constantsObj.ACHIEVEMENTS_DESCS[index];
            var cta = constantsObj.ACHIEVEMENTS_CTAS[index];
            var reward = achievementsObj.getAchievementsReward(index);
            var state = gameObj.getAchievementsState(index);
            var progress = achievementsObj.getProgressForAchievement(index);
            var maxCount = constantsObj.ACHIEVEMENTS_COUNTS[index];
            var hasProgressBar = constantsObj.ACHIEVEMENTS_PROGRESS_BARS[index];
            var hasTimerBar = 0;

            if (state != constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                progress = maxCount;
            }

            if (index == 0) {
                reward = economyObj.getAllowNotifsReward();
            } else if (index == 1) {
                reward = economyObj.getFbConnectCash();
            } else if (index == 6) {
                reward = economyObj.getInviteBonus();
            } else if (index == 7) {
                reward = economyObj.getInviteBonus();
            } else if (index == 8) {
                reward = economyObj.getInviteBonus();
            } else if (index == 9 || (index >= 72 && index <= 77)) {
                reward = economyObj.getInviteBonus();
            }

            if (index == 43 || index == 42 || index == 41) {
                if ((index == 41 || index == 42) && (state != constantsObj.ACHIEVEMENT_IN_PROGRESS || homeLayoutExpNew != constantsObj.EXP_VAR_2)) {
                    hasTimerBar = 0;
                } else {
                    hasTimerBar = 1;
                }
            }


            achievementSection = {
                id: index,
                title: title,
                desc: desc,
                cta: cta,
                reward: reward,
                progress: progress,
                maxCount: maxCount,
                state: state,
                hasProgressBar: hasProgressBar,
                hasTimerBar: hasTimerBar
            };
        }
        return achievementSection;
    };

    this.getAchievementsReward = function (index) {
        var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
        if ((weeklyQuestExp == constantsObj.EXP_VAR_2 || weeklyQuestExp == constantsObj.EXP_VAR_4) && (index == 15 || index == 16 || index == 59 || index == 23 || index == 66 || index == 70)) {
            if(index == 15 || index == 66) {
                return 25;
            }
            if (index == 16|| index == 23 || index == 70) {
                return 50;
            }
            if (index == 59) {
                return 250;
            }
        }

        // instagram runtime reward
        if (index == constantsObj.ACHIEVEMENT_INSTA_INDEX) {
            return runtimeObj.getRewardInsta();
        }
        return constantsObj.ACHIEVEMENTS_REWARDS[index];
    };

    this.getOrderOfAchievements = function () {
        var markedAchievements = {};
        var achievementsInOrder = [];
        listItemsQuest = [];
        var questDetails = achievementsObj.getWhatsappQuest();
        if (questDetails != null) {
            achievementsInOrder.push(constantsObj.InGameAchievement1);
        }
        if (ftueObj.isAchievementFtueShown() && epmObj.getChosenVariant(constantsObj.EXP_CROSSPROMO) == constantsObj.EXP_VAR_1) {
            // loggerObj.debugLog("cross game quests from server1");
            var CrossGameQuests = questsObj.getAvailableCrossGameQuests();
            //loggerObj.debugLog("this is cross game quests ", utilObj.getStringifiedJson(CrossGameQuests));
            var relatedQuests = questsObj.getRelatedQuests();
            var questsSurfaced = {};
            for (var i = 0; i < CrossGameQuests.length; i++) {
                // loggerObj.debugLog("cross game quests1 from server", CrossGameQuests.length, utilObj.getStringifiedJson(CrossGameQuests[i]), CrossGameQuests[i]["qt"]);
                var EligibleDaysAfter = 4 * constantsObj.SECONDS_IN_DAY;
                if (CrossGameQuests[i]["ea"] != undefined && CrossGameQuests[i]["ea"] != null) {
                    EligibleDaysAfter = parseInt(CrossGameQuests[i]["ea"]) * constantsObj.SECONDS_IN_DAY;
                }
                var questTypeMatch = false;
                for (var j = 0; j < constantsObj.QUEST_TYPES.length; j++) {
                    if (constantsObj.QUEST_TYPES[j] == CrossGameQuests[i]["qt"]) {
                        questTypeMatch = true;
                        break;
                    }
                }
                //loggerObj.debugLog("this is CrossGameQuests quest type ", CrossGameQuests[i]["qt"], questTypeMatch);
                if ((CrossGameQuests[i]["qt"] == constantsObj.QUEST_TYPE_INSTALL_GAME || questTypeMatch) && (utilObj.getCurrentTimestamp() - userObj.getCreated()) > EligibleDaysAfter && questsSurfaced[CrossGameQuests[i]["id"]] == undefined) {
                    //loggerObj.debugLog("this is quest inside ", CrossGameQuests[i]["id"]);
                    listItemsQuest.push(CrossGameQuests[i]);
                    var questQueue = [];
                    questQueue.push(CrossGameQuests[i]["id"]);
                    while (questQueue.length > 0) {
                        var curQuest = questQueue.pop();
                        questsSurfaced[curQuest] = 1;
                        if (relatedQuests[curQuest] != undefined) {
                            for (var j = 0; j < relatedQuests[curQuest].length; j++) {
                                if (questsSurfaced[relatedQuests[curQuest][j]] == undefined) {
                                    questQueue.push(relatedQuests[curQuest][j]);
                                }
                            }
                        }
                    }
                }
            }

            //loggerObj.debugLog("this is list items ", utilObj.getStringifiedJson(listItemsQuest));

            var QuestList = achievementsObj.getsortedQuestList(listItemsQuest);
            listItemsQuest = [];

            for (var i = 0; i < QuestList.length; i++) {
                if (QuestList[i].status == constantsObj.QUEST_COMPLETED) {
                    listItemsQuest.push(QuestList[i]);
                }
            }

            for (var i = 0; i < QuestList.length; i++) {
                if (QuestList[i].status != constantsObj.QUEST_COMPLETED) {
                    listItemsQuest.push(QuestList[i]);
                }
            }

            for (var i = 0; i < listItemsQuest.length && i < 2; i++) {
                achievementsInOrder.push(i + constantsObj.CrossPromoOffset);
            }
        }
        if (!gameObj.getcheckifMapForAlreadyCompletedAchv()) {
            achievementsObj.checkForAlreadyCompletedAchievements();
        }

        // removes twitter achv 79 index
        achievementsObj.removeTwitterAchvmnt();

        var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
        if (weeklyQuestExp == constantsObj.EXP_VAR_2 || weeklyQuestExp == constantsObj.EXP_VAR_4 || homeLayoutExpNew == constantsObj.EXP_VAR_2 || homeLayoutExpNew == constantsObj.EXP_VAR_1) {
            achievementsObj.checkAchievementsRetuning();
        }

        // remove streak achv
        achievementsObj.removeStreakAchv();

        var markedTypeofAchievements = {};
        var index = achievementsInOrder[0];
        if (gameObj.getAchievementsState(index) != constantsObj.ACHIEVEMENT_CLAIMED) {
            //markedAchievements[index] = 1;
            //achievementsInOrder.push(index);
        }
        // pushing watch 6 videos acheivement in top
        for (var i in BucketForTypeofAchievement) {
            var AchievementIndex = BucketForTypeofAchievement[i];
            var achIndex = AchievementIndex.split(",");
            for (var j in achIndex) {

                if ((markedTypeofAchievements[parseInt(i)] != undefined || markedTypeofAchievements[parseInt(i)] == 1) && parseInt([i]) != 1) {
                    break;
                }
                var ind = parseInt(achIndex[j]);
                //loggerObj.debugLog("new data is1", ind == 43);
                if (ind == constantsObj.ACHIEVEMENT_INDEX_TODAYS_PUZZLE || ind == constantsObj.ACHIEVEMENT_INDEX_50_HINTS_SPINNER) {
                    continue;
                }
                if (utilObj.isAndroid() && ind == constantsObj.ACHIEVEMENT_INDEX_PUSH_NOTIFS) {
                    continue;
                }
                var stateOfAchievement = gameObj.getAchievementsState(ind);
                if (ind == 43) {
                    markedAchievements[ind] = 1;
                    markedTypeofAchievements[parseInt([i])] = 1;
                    if (gameObj.isEligibleForVideoAchiement()) {
                        gameObj.setTimestampForAchievementShown();
                        if (gameObj.getTimeStampVideoTimer() == 0 && !gameObj.getIsRedraw()) {
                            if (stateOfAchievement != constantsObj.ACHIEVEMENT_COMPLETED) {
                                gameObj.setTimeStampVideoTimer(utilObj.getCurrentTimestamp());
                                gameObj.setFirstVideoSeenTimeStamp(utilObj.getCurrentTimestamp());
                            }
                        }
                        if (gameObj.getAchievementsState(ind) != constantsObj.ACHIEVEMENT_CLAIMED) {
                            achievementsInOrder.push(ind);
                        } else {
                            continue;
                        }
                    }
                }
                // pushing SM achievement acheivements on top
                if (ind == constantsObj.ACHIEVEMENT_TWITTER_INDEX || ind == constantsObj.ACHIEVEMENT_INSTA_INDEX) {
                    markedAchievements[ind] = 1;
                    markedTypeofAchievements[parseInt([i])] = 1;
                    if (achievementsObj.conditionForSMAchievement(ind)) {
                        if (gameObj.getAchievementsState(ind) != constantsObj.ACHIEVEMENT_CLAIMED && gameObj.getAchievementsState(ind) != constantsObj.ACHIEVEMENT_STATE_REMOVED) {
                            achievementsInOrder.push(ind);
                        } else {
                            continue;
                        }
                    }
                }
                stateOfAchievement = gameObj.getAchievementsState(ind);
                if (markedAchievements[ind] == undefined || markedAchievements[ind] != 1) {
                    if (stateOfAchievement == constantsObj.ACHIEVEMENT_COMPLETED) {
                        markedAchievements[ind] = 1;
                        markedTypeofAchievements[parseInt([i])] = 1;
                        achievementsInOrder.push(ind);
                    }
                }
                //loggerObj.debugLog("achievement optimise2",j, achIndex[j]);
            }
            //loggerObj.debugLog("achievement optimise1",i , AchievementIndex);
        }


        for (var i in BucketForTypeofAchievement) {
            var AchievementIndex = BucketForTypeofAchievement[i];
            var achIndex = AchievementIndex.split(",");
            for (var j in achIndex) {
                if ((markedTypeofAchievements[parseInt(i)] != undefined || markedTypeofAchievements[parseInt(i)] == 1) && parseInt([i]) != 1) {
                    break;
                }
                var ind = parseInt(achIndex[j]);
                if (ind == constantsObj.ACHIEVEMENT_INDEX_TODAYS_PUZZLE || ind == constantsObj.ACHIEVEMENT_INDEX_50_HINTS_SPINNER) {
                    continue;
                }
                if (utilObj.isAndroid() && ind == constantsObj.ACHIEVEMENT_INDEX_PUSH_NOTIFS) {
                    continue;
                }
                var stateOfAchievement = gameObj.getAchievementsState(ind);
                if (markedAchievements[ind] == undefined || markedAchievements[ind] != 1) {
                    if (stateOfAchievement == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                        //loggerObj.debugLog("lelouch in Progress achievements are ", ind);
                        markedAchievements[ind] = 1;
                        markedTypeofAchievements[parseInt(i)] = 1;
                        achievementsInOrder.push(ind);
                    }
                }
            }
        }


        for (var i in BucketForTypeofAchievement) {
            var AchievementIndex = BucketForTypeofAchievement[i];
            var achIndex = AchievementIndex.split(",");
            for (var j in achIndex) {
                var ind = parseInt(achIndex[j]);
                if (ind == constantsObj.ACHIEVEMENT_INDEX_TODAYS_PUZZLE || ind == constantsObj.ACHIEVEMENT_INDEX_50_HINTS_SPINNER) {
                    continue;
                }
                if (utilObj.isAndroid() && ind == constantsObj.ACHIEVEMENT_INDEX_PUSH_NOTIFS) {
                    continue;
                }
                var stateOfAchievement = gameObj.getAchievementsState(ind);
                if (markedAchievements[ind] == undefined || markedAchievements[ind] != 1) {
                    if (stateOfAchievement == constantsObj.ACHIEVEMENT_CLAIMED) {
                        markedAchievements[ind] = 1;
                        achievementsInOrder.push(ind);
                    }
                }
            }
        }
        return achievementsInOrder;
    };

    // condition for Social media achievement twitter and instagram
    this.conditionForSMAchievement = function(index) {
        var isAppAvailable = false;
        var userCreated = userObj.getCreated();
        // exp and D2 condition
        if (epmObj.getChosenVariant(constantsObj.EXP_SOCIALMEDIA_ACHV) == constantsObj.EXP_VAR_CONTROL || userCreated == "" || (utilObj.getCurrentTimestamp() - userCreated < 2 * constantsObj.SECONDS_IN_DAY)) {
            return isAppAvailable;
        }
        if (index == constantsObj.ACHIEVEMENT_TWITTER_INDEX) {
            var twitterAppName = "";
            if (utilObj.isAndroid()) {
                twitterAppName = "com.twitter.android";
            } else if (utilObj.isIos()) {
                twitterAppName = "twitter";
            }
            isAppAvailable = utilObj.isAppInstalled(twitterAppName);
        } else if (index == constantsObj.ACHIEVEMENT_INSTA_INDEX) {
            var instagramAppName = "";
            if (utilObj.isAndroid()) {
                instagramAppName = "com.instagram.android";
            } else if (utilObj.isIos()) {
                instagramAppName = "instagram";
            }
            isAppAvailable = utilObj.isAppInstalled(instagramAppName);
        }
        return isAppAvailable;
    };

    this.getCrossGameQuestsSurfaced = function () {
        var CrossGameQuests = questsObj.getAvailableCrossGameQuests();
        var listItems = [];
        //loggerObj.debugLog("cross game quests1 from server", CrossGameQuests.length, utilObj.getStringifiedJson(CrossGameQuests[i]), CrossGameQuests[i]["qt"]);
        for (var i = 0; i < CrossGameQuests.length; i++) {
            var EligibleDaysAfter = 4 * constantsObj.SECONDS_IN_DAY;
            if (CrossGameQuests[i]["ea"] != undefined && CrossGameQuests[i]["ea"] != null) {
                EligibleDaysAfter = parseInt(CrossGameQuests[i]["ea"]) * constantsObj.SECONDS_IN_DAY;
            }
            if (CrossGameQuests[i]["qt"] == "installGame" && (utilObj.getCurrentTimestamp() - userObj.getCreated()) > EligibleDaysAfter) {
                listItems.push(CrossGameQuests[i]);
            }
        }

        var QuestList = achievementsObj.getsortedQuestList(listItems);
        listItems = [];

        for (var i = 0; i < QuestList.length; i++) {
            if (QuestList[i].status == constantsObj.QUEST_COMPLETED) {
                listItems.push(QuestList[i]);
            }
        }

        for (var i = 0; i < QuestList.length; i++) {
            if (QuestList[i].status != constantsObj.QUEST_COMPLETED) {
                listItems.push(QuestList[i]);
            }
        }
        return listItems;
    };

    // return non achieved Type 0-14, X achievement
    // type 0 : Type 1 - 14 achievement
    // type 1 : Type X achievement
    this.getNonAchievedType = function (type) {
        var markedTypeofAchievements = {};
        var achievementtoShow = -1;
        var LeastProximity = 100;
        var randomizerListForTypeX = [];
        for (var i in BucketForTypeofAchievement) {
            var AchievementIndex = BucketForTypeofAchievement[i];
            var achIndex = AchievementIndex.split(",");
            for (var j in achIndex) {
                //loggerObj.debugLog("coming to play5",j, achIndex[j]);
                var ind = parseInt(achIndex[j]);
                if (type == 0) {
                    if (ind == 0 || ind == 1 || ind == 40 || ind == 6 || ind == 7 || ind == 8 || ind == 9 || (ind >= 72 && ind <= 77)) {
                        continue;
                    }
                } else {
                    if (ind != 0 && ind != 1 && ind != 40 && ind != 6 && ind != 7 && ind != 8 && ind != 9 && ind != 72 && ind != 73 && ind != 74 && ind != 75 && ind != 76 && ind != 77) {
                        //loggerObj.debugLog("coming to play6",j, achIndex[j]);
                        continue;
                    }
                }
                //loggerObj.debugLog("coming to play7",ind);
                if ((markedTypeofAchievements[parseInt(i)] != undefined || markedTypeofAchievements[parseInt(i)] == 1) && parseInt([i]) != 1) {
                    break;
                }

                if (ind == constantsObj.ACHIEVEMENT_INDEX_TODAYS_PUZZLE || ind == constantsObj.ACHIEVEMENT_INDEX_50_HINTS_SPINNER) {
                    continue;
                }
                if (utilObj.isAndroid() && ind == constantsObj.ACHIEVEMENT_INDEX_PUSH_NOTIFS) {
                    continue;
                }

                // if ((ind >= 17 && ind <= 19) || (ind >= 61 && ind <= 63)) {
                //     if (gameObj.getMastery1() <= 0) {
                //         continue;
                //     }
                // }

                var stateOfAchievement = gameObj.getAchievementsState(ind);
                if (stateOfAchievement == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                    //loggerObj.debugLog("coming to play4",ind, stateOfAchievement);
                    //loggerObj.debugLog("lelouch in Progress achievements are ", ind);
                    // markedAchievements[ind] = 1;
                    markedTypeofAchievements[parseInt(i)] = 1;
                    if (type == 0) {
                        var ease = constantsObj.ACHIEVEMENTS_EASE_SCORE[ind];
                        if (ease > 0) {
                            var progress = achievementsObj.getProgressForAchievement(ind);
                            var count = constantsObj.ACHIEVEMENTS_COUNTS[ind];
                            var proximity = (count - progress) / ease;
                            if (proximity < LeastProximity) {
                                LeastProximity = proximity;
                                if (LeastProximity <= 10) {
                                    achievementtoShow = ind;
                                }
                            }
                        }
                    } else {
                        randomizerListForTypeX.push(ind);
                        // utilObj.shuffleArray(randomizerListForTypeX);
                        for (var i in randomizerListForTypeX) {
                            var checkforCooldown = achievementsObj.checkForCooldownForAchievements(randomizerListForTypeX[i]);
                            if (checkforCooldown != -1) {
                                achievementtoShow = checkforCooldown;
                                break;
                            }
                        }
                        // achievementtoShow = randomizerListForTypeX[0];
                        // achievementtoShow = ind;
                        // return achievementtoShow;
                    }
                }

            }
        }
        return achievementtoShow;
    };

    this.getProximityForStreakAchievement = function (index) {
        var achievementToShow = -1;
        var leastProximity = 100;
        for (var i in BucketForTypeofAchievement) {
            var AchievementIndex = BucketForTypeofAchievement[i];
            var achIndex = AchievementIndex.split(",");
            for (var j in achIndex) {
                var ind = parseInt(achIndex[j]);
                if ((index == 1 && (ind == 41 || ind == 42)) || (index == 2 && (ind == 15 || ind == 16 || (ind >= 54 && ind <= 60))) || (index == 3 && (ind == 38 || ind == 39))) {
                    var stateOfAchievement = gameObj.getAchievementsState(ind);
                    if (stateOfAchievement == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                        var ease = constantsObj.ACHIEVEMENTS_EASE_SCORE[ind];
                        if (ease > 0) {
                            var progress = achievementsObj.getProgressForAchievement(ind);
                            var count = constantsObj.ACHIEVEMENTS_COUNTS[ind];
                            var proximity = (count - progress) / ease;
                            if (proximity <= leastProximity) {
                                leastProximity = proximity;
                                if (leastProximity <= 5) {
                                    achievementToShow = leastProximity;
                                    if (index == 1) {
                                        gameObj.setStreakAchievementType(ind);
                                    } else if (index == 2) {
                                        gameObj.setStreakPuzzleAchievementType(ind);
                                    } else {
                                        gameObj.setStreakWeekAchievementType(ind);
                                    }
                                    return achievementToShow;
                                }
                            }
                        }
                    }
                }
            }
        }
        return achievementToShow;
    };

    this.checkForCooldownForAchievements = function (index) {
        var timeStamp = 0;
        if (index == constantsObj.ACHIEVEMENT_BOUNTY_HUNTER) {
            timeStamp = gameObj.getLastShownBountyHunterTimeStamp()
        }
        if (index == constantsObj.ACHIEVEMENT_INDEX_PUSH_NOTIFS) {
            timeStamp = gameObj.getLastShownNotifPermissionAchv();
        }

        if (index == constantsObj.ACHIEVEMENT_FB_LOGIN) {
            timeStamp = gameObj.getLastShownFacebookConnectAchv();
        }

        if ((index >= 6 && index <= 9) || (index >= 72 && index <= 77)) {
            timeStamp = gameObj.getLastShownInviteAchv();
        }

        if ((utilObj.getCurrentTimestamp() - timeStamp > 4 * constantsObj.SECONDS_IN_DAY) || timeStamp == 0) {
            return index;
        } else {
            return -1;
        }
    };

    this.getAchievementToSurfaceOnStats = function () {
        var markedTypeofAchievements = {};
        var achievementtoShow = -1;
        var stateofOntheRiseAchievement = gameObj.getAchievementsState(3);
        if (stateofOntheRiseAchievement == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
            return 3;
        }
        for (var i in BucketForTypeofAchievement) {
            if (parseInt(i) != 4 && parseInt(i) != 6 && parseInt(i) != 7 && parseInt(i) != 18) {
                //loggerObj.debugLog("here it is1", parseInt(i));
                continue;
            }
            var AchievementIndex = BucketForTypeofAchievement[i];
            var achIndex = AchievementIndex.split(",");
            //loggerObj.debugLog("here it is", i, JSON.stringify(achIndex), JSON.stringify(AchievementIndex));
            for (var j in achIndex) {
                var ind = parseInt(achIndex[j]);

                if ((markedTypeofAchievements[parseInt(i)] != undefined || markedTypeofAchievements[parseInt(i)] == 1)) {
                    break;
                }
                var stateOfAchievement = gameObj.getAchievementsState(ind);
                if (stateOfAchievement == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                    markedTypeofAchievements[parseInt(i)] = 1;
                    var threshold = constantsObj.ACHIEVEMENTS_THRESHOLD[ind];
                    var progress = achievementsObj.getProgressForAchievement(ind);
                    if (progress >= threshold) {
                        return ind;
                    }
                }
            }
        }

        return achievementtoShow;
    };

    this.getsortedQuestList = function (list) {
        var sortedInfo = [];
        for (var i in list) {
            var questData = list[i];
            var qp = questData.qp;
            if (sortedInfo[qp] == undefined) {
                sortedInfo[qp] = [];
            }
            sortedInfo[qp].push(questData);
        }
        var questList = [];
        // loggerObj.debugLog("Unsorted quest list:", utilObj.getStringifiedJson(sortedInfo));
        for (var i in sortedInfo) {
            for (var j in sortedInfo[i]) {
                var questInfo = sortedInfo[i][j];
                questList.push(questInfo);
            }
        }

        // loggerObj.debugLog("listquest", JSON.stringify(questList));

        return questList;
    };

    this.getListItemsQuest = function () {
        return listItemsQuest;
    };

    this.getCountListAchievement = function () {
        if (listItemsQuest.length > 2) {
            return 2;
        } else {
            return listItemsQuest.length;
        }

    };

    this.getAchievementsInOrder = function () {
        achievementsInOrder = achievementsObj.getOrderOfAchievements();
        return achievementsInOrder;
    };

    this.updateSolvingStreakAchievement = function () {

    };

    this.resetAchievementsStates = function () {
        for (var i = 0; i < countOfAchievements; i++) {
            if (i == constantsObj.CrossPromoAchievement1 || i == constantsObj.CrossPromoAchievement2) {
                continue;
            }
            if (gameObj.getAchievementsState(i) == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                var progressForAchievement = achievementsObj.getProgressForAchievement(i);
                if (progressForAchievement >= constantsObj.ACHIEVEMENTS_COUNTS[i]) {
                    gameObj.setAchievementsState(i, constantsObj.ACHIEVEMENT_COMPLETED);
                }
            }
        }
    };

    this.checkForClaimedAchievements = function () {
        for (var i = 0; i < countOfAchievements; i++) {
            if (i == constantsObj.CrossPromoAchievement1 || i == constantsObj.CrossPromoAchievement2) {
                continue;
            }
            if (gameObj.getAchievementsState(i) != constantsObj.ACHIEVEMENT_CLAIMED) {
                var collectedRewardForAchievement = achievementsObj.hasCollectedRewardForAchievement(i);
                if (collectedRewardForAchievement == true) {
                    gameObj.setAchievementsState(i, constantsObj.ACHIEVEMENT_CLAIMED);
                }
            }
        }
    };

    this.hasCollectedRewardForAchievement = function (i) {
        var ind = parseInt(i);
        var hasCollectedReward = false;
        switch (ind) {
            case 0:
                hasCollectedReward = achievementsObj.hasCollectedRewardForPushNotifs();
                break;
            case 1:
                hasCollectedReward = achievementsObj.hasCollectedRewardForFbConnect();
                break;
            case 6:
                hasCollectedReward = achievementsObj.hasCollectedRewardForInvite(1);
                break;
            case 7:
                hasCollectedReward = achievementsObj.hasCollectedRewardForInvite(3);
                break;
            case 8:
                hasCollectedReward = achievementsObj.hasCollectedRewardForInvite(6);
                break;
            case 9:
                hasCollectedReward = achievementsObj.hasCollectedRewardForInvite(10);
                break;
            case 72:
                hasCollectedReward = achievementsObj.hasCollectedRewardForInvite(2);
                break;
            case 73:
                hasCollectedReward = achievementsObj.hasCollectedRewardForInvite(4);
                break;
            case 74:
                hasCollectedReward = achievementsObj.hasCollectedRewardForInvite(5);
                break;
            case 75:
                hasCollectedReward = achievementsObj.hasCollectedRewardForInvite(7);
                break;
            case 76:
                hasCollectedReward = achievementsObj.hasCollectedRewardForInvite(8);
                break;
            case 77:
                hasCollectedReward = achievementsObj.hasCollectedRewardForInvite(9);
                break;
            default:
                break;
        }
        return hasCollectedReward;
    };

    this.hasCollectedRewardForFbConnect = function () {
        if (economyObj.hasCollectedFbConnectCash() == true) {
            return true;
        }
        return false;
    };

    this.hasCollectedRewardForPushNotifs = function () {
        if (gameObj.getNotifsRewardGranted() == true) {
            return true;
        }
        return false;
    };

    this.hasCollectedRewardForInvite = function (ind) {
        var count = parseInt(ind);
        var inviteCount = economyObj.getInviteRewardGrantedCount();
        if (inviteCount >= count) {
            return true;
        }
        return false;
    };

    this.checkForAchievements = function (paramsForOutro) {
        // var completedAchievements = [];
        // var numOfCompletedAchievements = 0;
        // if (!gameObj.getcheckifMapForAlreadyCompletedAchv()) {
        //     gameObj.settimeForCheckingAlreadycompletedAchv(utilObj.getCurrentTimestamp());
        //     achievementsObj.checkForAlreadyCompletedAchievements();
        // }
        //
        // // removes twitter achv 79 index
        // achievementsObj.removeTwitterAchvmnt();
        //
        // var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
        // if (weeklyQuestExp == constantsObj.EXP_VAR_2 || weeklyQuestExp == constantsObj.EXP_VAR_4 || homeLayoutExpNew == constantsObj.EXP_VAR_2 || homeLayoutExpNew == constantsObj.EXP_VAR_1) {
        //     achievementsObj.checkAchievementsRetuning();
        // }
        //
        // // remove streak achv
        // achievementsObj.removeStreakAchv();
        //
        // if ((utilObj.getCurrentTimestamp() - gameObj.gettimeForCheckingAlreadycompletedAchv()) < 10) {
        //     achievementsObj.checkForAlreadyCompletedAchievements();
        // }
        // // check for only non completed achievements here and update the state respectively as well
        // for (var i = 0; i < countOfAchievements; i++) {
        //     if (i == constantsObj.CrossPromoAchievement1 || i == constantsObj.CrossPromoAchievement2) {
        //         continue;
        //     }
        //     if (i == constantsObj.ACHIEVEMENT_INDEX_TODAYS_PUZZLE || i == constantsObj.ACHIEVEMENT_INDEX_50_HINTS_SPINNER) {
        //         continue;
        //     }
        //     if (utilObj.isAndroid() && i == constantsObj.ACHIEVEMENT_INDEX_PUSH_NOTIFS) {
        //         continue;
        //     }
        //     if (gameObj.getAchievementsState(i) == constantsObj.ACHIEVEMENT_IN_PROGRESS && gameObj.getAchievementsState(i) != constantsObj.ACHIEVEMENT_STATE_REMOVED) {
        //         var progressForAchievement = achievementsObj.getProgressForAchievement(i);
        //         if (i == 43 && !gameObj.isEligibleForVideoAchiement()) {
        //             progressForAchievement = 0;
        //         }
        //         if (progressForAchievement >= constantsObj.ACHIEVEMENTS_COUNTS[i]) {
        //             gameObj.setAchievementsState(i, constantsObj.ACHIEVEMENT_COMPLETED);
        //             numOfCompletedAchievements += 1;
        //             if (numOfCompletedAchievements <= 3) {
        //                 completedAchievements.push(i);
        //             }
        //             trackObj.trackCounter(constantsObj.TRACK_ACHIEVEMENTS, constantsObj.TRACK_GRANT, i, "", "", "", "", "", "");
        //         }
        //     }
        // }

        var initialDelay = 0;
        var extraDelayAdded = false;
        // for (var i in completedAchievements) {
        //     var indexOfAchievement = completedAchievements[i];
        //     if (gameObj.getLastWordReveal() || gameObj.getLastLettersReveal()) {
        //         initialDelay += 1.0;
        //         extraDelayAdded = true;
        //     }
        //     achievementsObj.showAnimationForCompletedAchievements(indexOfAchievement, initialDelay);
        //     initialDelay += 2.0;
        // }
        // // themedQuestAchievement
        // if (epmObj.getChosenVariant(constantsObj.EXP_THEMED_QUEST) == constantsObj.EXP_VAR_1) {
        //     var milestonesCompleted = gameObj.getThemedQuestMilestonesCompleted();
        //     var starsAchieved = gameObj.getThemedQuestMastery();
        //     var themedQuestData = themedQuestObj.getThemedQuestData();
        //     var themedQuestAchievementShown = gameObj.getThemedQuestAchievementsShown();
        //     var mileStones1 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(0));
        //     var mileStones2 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(1));
        //     var mileStones3 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(2));
        //     var milestones = [mileStones1, mileStones2, mileStones3];
        //     if (milestonesCompleted == null && gameObj.getExpNewWeeklyQuestVariant() == constantsObj.EXP_VAR_CONTROL) {
        //         if (starsAchieved >= 0 && starsAchieved < milestones[0]) {
        //             milestonesCompleted = [0, 0, 0];
        //             themedQuestAchievementShown = [0, 0, 0];
        //             gameObj.setThemedQuestMilestonesCompleted(milestonesCompleted);
        //             gameObj.setThemedQuestCompleted(false);
        //             gameObj.setThemedQuestAchievementsShown(themedQuestAchievementShown);
        //         } else if (starsAchieved >= milestones[0] && starsAchieved < milestones[1]) {
        //             milestonesCompleted = [1, 0, 0];
        //             themedQuestAchievementShown = [1, 0, 0];
        //             gameObj.setThemedQuestMilestonesCompleted(milestonesCompleted);
        //             gameObj.setThemedQuestAchievementsShown(themedQuestAchievementShown);
        //         } else if (starsAchieved >= milestones[1] && starsAchieved < milestones[2]) {
        //             milestonesCompleted = [1, 1, 0];
        //             themedQuestAchievementShown = [1, 1, 0];
        //             gameObj.setThemedQuestMilestonesCompleted(milestonesCompleted);
        //             gameObj.setThemedQuestAchievementsShown(themedQuestAchievementShown);
        //         } else {
        //             milestonesCompleted = [1, 1, 1];
        //             themedQuestAchievementShown = [1, 1, 1];
        //             gameObj.setThemedQuestMilestonesCompleted(milestonesCompleted);
        //             gameObj.setThemedQuestCompleted(true);
        //             gameObj.setThemedQuestAchievementsShown(themedQuestAchievementShown);
        //         }
        //     }
        //     var tqAchievementsHead = themedQuestData["achievementsHeads"];
        //     var tqAchievementsDesc = "Congratulations, you've hit the milestone!";
        //
        //     // taking the milestone completed array well before
        //     if (gameObj.getExpNewWeeklyQuestVariant() != constantsObj.EXP_VAR_CONTROL) {
        //         milestonesCompleted = questMapObj.getIfMileStoneUpdated();
        //         if (milestonesCompleted == null) {
        //             milestonesCompleted = [0, 0, 0];
        //             gameObj.setThemedQuestMilestonesCompleted(milestonesCompleted);
        //             gameObj.setThemedQuestCompleted(false);
        //         }
        //     }
        //
        //     if (themedQuestAchievementShown == null) {
        //         themedQuestAchievementShown = [0, 0, 0];
        //     }
        //     for (var i = 0; i < milestonesCompleted.length; i++) {
        //         if ((milestonesCompleted[i] == 1 || gameObj.getThemedQuestMastery() >= milestones[i]) && themedQuestAchievementShown[i] == 0) {
        //             utilObj.showTqAchievementsAnimation(tqAchievementsHead[i], tqAchievementsDesc, initialDelay);
        //             themedQuestAchievementShown[i] = 1;
        //             gameObj.setThemedQuestAchievementsShown(themedQuestAchievementShown);
        //             trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_TQ_ANIM, constantsObj.TRACK_VIEW, constantsObj.TRACK_GAME, i + 1, "", "");
        //             //loggerObj.debugLog("Here",i);
        //             initialDelay += 2.0;
        //         }
        //     }
        //
        // }

        // //weeklyQuest
        // var mileStones1 = parseInt(runtimeObj.getWeeklyQuestMilestones(0));
        // var mileStones2 = parseInt(runtimeObj.getWeeklyQuestMilestones(1));
        // var mileStones3 = parseInt(runtimeObj.getWeeklyQuestMilestones(2));
        // var milestonesWeekly = [mileStones1, mileStones2, mileStones3];
        // var milestonesCompletedWeekly = gameObj.getWeeklyQuestMilestonesCompleted();
        // var starsAchievedWeekly = gameObj.getWeeklyQuestMastery();
        // var weeklyQuestData = weeklyQuestObj.getWeeklyQuestData();
        //
        //
        //
        // if (milestonesCompletedWeekly == null) {
        //     if (starsAchievedWeekly >= 0 && starsAchievedWeekly < milestonesWeekly[0]) {
        //         milestonesCompletedWeekly = [0, 0, 0];
        //
        //         gameObj.setWeeklyQuestMilestonesCompleted(milestonesCompletedWeekly);
        //
        //
        //     } else if (starsAchievedWeekly >= milestonesWeekly[0] && starsAchievedWeekly < milestonesWeekly[1]) {
        //         milestonesCompletedWeekly = [1, 0, 0];
        //
        //         gameObj.setWeeklyQuestMilestonesCompleted(milestonesCompleted);
        //
        //     } else if (starsAchievedWeekly >= milestonesWeekly[1] && starsAchievedWeekly < milestonesWeekly[2]) {
        //         milestonesCompletedWeekly = [1, 1, 0];
        //
        //         gameObj.setWeeklyQuestMilestonesCompleted(milestonesCompletedWeekly);
        //
        //     } else {
        //         milestonesCompletedWeekly = [1, 1, 1];
        //
        //         gameObj.setWeeklyQuestMilestonesCompleted(milestonesCompletedWeekly);
        //
        //     }
        // }





        // utilObj.showTqAchievementsAnimation("hey", "congo", initialDelay);

        //var achievementsVariant = epmObj.getChosenVariant(constantsObj.EXP_ACHIEVEMENTS);
        if ((gameObj.getLastWordReveal() || gameObj.getLastLettersReveal()) && !extraDelayAdded) {
            initialDelay += 1.0;
        }
        if (paramsForOutro != undefined) {

            var showWithAnim = paramsForOutro.value;
            var timeElapsed = paramsForOutro.timeElapsed;
            var replay = paramsForOutro.replay;
            // loggerObj.debugLog("lelouch popup layer paramsForoutro are ", showWithAnim, timeElapsed, replay);
            if (introOutroRevampExp != constantsObj.EXP_VAR_CONTROL) {
                utilObj.delayedCallback(curLayer, transOutroLayerV2.show, initialDelay, {
                    showWithAnim: showWithAnim,
                    timeElapsed: timeElapsed,
                    replay: replay
                });
            } else {
                utilObj.delayedCallback(curLayer, outroPopup.show, initialDelay, {
                    showWithAnim: showWithAnim,
                    timeElapsed: timeElapsed,
                    replay: replay
                });
            }

            utilObj.delayedCallback(curLayer, achievementsObj.changeOutroPopupShownVal, initialDelay + 5, null);
        }
    };

    // remove streak achv
    this.removeStreakAchv = function () {
        if (homeLayoutExpNew == constantsObj.EXP_VAR_2) {
            var bucketList = [41, 42];
            var flag = false;
            for (var i in bucketList) {
                var achv = bucketList[i];
                var achInd = achv;
                var stateForAchievement = gameObj.getAchievementsState(achInd);
                var progressForAchievement = achievementsObj.getProgressForAchievement(achInd);
                if (stateForAchievement == constantsObj.ACHIEVEMENT_STATE_REMOVED) {
                    continue;
                }
                if (progressForAchievement == 1 /*&& (gameObj.getIdForTodaysPuzzle() == gameObj.getInstallDay())*/ && !flag) {
                    flag = true;
                }
                if (stateForAchievement == constantsObj.ACHIEVEMENT_IN_PROGRESS && !flag) {
                    flag = true;
                } else if (stateForAchievement == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                    gameObj.setAchievementsState(achInd, constantsObj.ACHIEVEMENT_STATE_REMOVED);
                }
            }
        }
    };

    this.changeOutroPopupShownVal = function(){
        gameObj.setOutroPopupShown(false);
    };

    this.trackProgressForAchievements = function () {
        for (var i = 0; i < countOfAchievements; i++) {
            if (i == constantsObj.CrossPromoAchievement1 || i == constantsObj.CrossPromoAchievement2) {
                continue;
            }
            if (gameObj.getAchievementsState(i) == constantsObj.ACHIEVEMENT_IN_PROGRESS && gameObj.getAchievementsState(i) != constantsObj.ACHIEVEMENT_STATE_REMOVED) {
                var progressForAchievement = achievementsObj.getProgressForAchievement(i);
                if (constantsObj.ACHIEVEMENTS_COUNTS[i] > 1 && progressForAchievement >= 1) {
                    var progressStr = progressForAchievement + "/" + constantsObj.ACHIEVEMENTS_COUNTS[i];
                    trackObj.trackCounter(constantsObj.TRACK_ACHIEVEMENTS, constantsObj.TRACK_PROGRESS, i, progressStr, i, "", gameObj.getPuzzleSpeciesTracking(), "", "");
                }
            }
        }
    };

    this.trackProgressForInviteAchievements = function () {
        for (var i = 6; i <= 9; i++) {
            if (gameObj.getAchievementsState(i) == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                var progressForAchievement = achievementsObj.getProgressForAchievement(i);
                if (progressForAchievement >= 1) {
                    var progressStr = progressForAchievement + "/" + constantsObj.ACHIEVEMENTS_COUNTS[i];
                    trackObj.trackCounter(constantsObj.TRACK_ACHIEVEMENTS, constantsObj.TRACK_PROGRESS, i, progressStr, i, "", gameObj.getPuzzleSpeciesTracking(), "", "");
                }
            }
        }
        for (var i = 72; i <= 77; i++) {
            if (gameObj.getAchievementsState(i) == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                var progressForAchievement = achievementsObj.getProgressForAchievement(i);
                if (progressForAchievement >= 1) {
                    var progressStr = progressForAchievement + "/" + constantsObj.ACHIEVEMENTS_COUNTS[i];
                    trackObj.trackCounter(constantsObj.TRACK_ACHIEVEMENTS, constantsObj.TRACK_PROGRESS, i, progressStr, i, "", gameObj.getPuzzleSpeciesTracking(), "", "");
                }
            }
        }

    };

    this.trackProgressForSpinnerHints = function () {
        // 14 -> 50 spinner hints count
        var progressForAchievement = achievementsObj.getProgressForAchievement(14);
        var progressStr = progressForAchievement + "/" + constantsObj.ACHIEVEMENTS_COUNTS[14];
        trackObj.trackCounter(constantsObj.TRACK_ACHIEVEMENTS, constantsObj.TRACK_PROGRESS, 14, progressStr, 14, "", gameObj.getPuzzleSpeciesTracking(), "", "");
    };

    this.trackProgressForSolvingStreakAchievements = function () {
        var list = [15, 16, 54, 55, 56, 57, 58, 59, 60];
        for (var ind in list) {
            var i = list[ind];
            if (gameObj.getAchievementsState(i) == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                var progressForAchievement = achievementsObj.getProgressForAchievement(i);
                if (progressForAchievement >= 1) {
                    var progressStr = progressForAchievement + "/" + constantsObj.ACHIEVEMENTS_COUNTS[i];
                    trackObj.trackCounter(constantsObj.TRACK_ACHIEVEMENTS, constantsObj.TRACK_PROGRESS, i, progressStr, i, "", gameObj.getPuzzleSpeciesTracking(), "", "");
                }
            }
        }
    };

    this.trackProgressForDailyPuzzleSolvedAchievements = function () {
        var list = [11, 12, 13, 44, 45, 46, 49, 50, 51, 52, 53];
        for (var ind in list) {
            var i = list[ind];
            if (gameObj.getAchievementsState(i) == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                var progressForAchievement = achievementsObj.getProgressForAchievement(i);
                if (progressForAchievement >= 1) {
                    var progressStr = progressForAchievement + "/" + constantsObj.ACHIEVEMENTS_COUNTS[i];
                    trackObj.trackCounter(constantsObj.TRACK_ACHIEVEMENTS, constantsObj.TRACK_PROGRESS, i, progressStr, i, "", gameObj.getPuzzleSpeciesTracking(), "", "");
                }
            }
        }
    };

    this.trackProgressForPuzzlesSolvedInWeek = function () {
        for (var i = 38; i <= 39; i++) {
            if (gameObj.getAchievementsState(i) == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                var progressForAchievement = achievementsObj.getProgressForAchievement(i);
                if (progressForAchievement >= 1) {
                    var progressStr = progressForAchievement + "/" + constantsObj.ACHIEVEMENTS_COUNTS[i];
                    trackObj.trackCounter(constantsObj.TRACK_ACHIEVEMENTS, constantsObj.TRACK_PROGRESS, i, progressStr, i, "", gameObj.getPuzzleSpeciesTracking(), "", "");
                }
            }
        }
    };

    this.trackProgressForPuzzleSolvedInDayOfWeek = function (val) {
        var index = parseInt(val);
        var lowInd = 24;
        var highInd = 37;
        if (index == 0) {
            lowInd = 36;
        } else if (val >= 1) {
            lowInd = 24 + (index - 1) * 2;
        }
        highInd = lowInd + 1;
        for (var i = lowInd; i <= highInd; i++) {
            if (gameObj.getAchievementsState(i) == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                var progressForAchievement = achievementsObj.getProgressForAchievement(i);
                if (progressForAchievement >= 1) {
                    var progressStr = progressForAchievement + "/" + constantsObj.ACHIEVEMENTS_COUNTS[i];
                    trackObj.trackCounter(constantsObj.TRACK_ACHIEVEMENTS, constantsObj.TRACK_PROGRESS, i, progressStr, i, "", gameObj.getPuzzleSpeciesTracking(), "", "");
                }
            }
        }
    };

    this.trackProgressForSolveEachTheme = function () {
        for (var i = 10; i <= 10; i++) {
            if (gameObj.getAchievementsState(i) == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                var progressForAchievement = achievementsObj.getProgressForAchievement(i);
                if (progressForAchievement >= 1) {
                    var progressStr = progressForAchievement + "/" + constantsObj.ACHIEVEMENTS_COUNTS[i];
                    trackObj.trackCounter(constantsObj.TRACK_ACHIEVEMENTS, constantsObj.TRACK_PROGRESS, i, progressStr, i, "", gameObj.getPuzzleSpeciesTracking(), "", "");
                }
            }
        }
    };

    this.trackProgressForMiniPuzzles = function () {
        var list = [17, 18, 19, 61, 62, 63];
        for (var ind in list) {
            var i = list[ind];
            if (gameObj.getAchievementsState(i) == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                var progressForAchievement = achievementsObj.getProgressForAchievement(i);
                if (progressForAchievement >= 1) {
                    var progressStr = progressForAchievement + "/" + constantsObj.ACHIEVEMENTS_COUNTS[i];
                    trackObj.trackCounter(constantsObj.TRACK_ACHIEVEMENTS, constantsObj.TRACK_PROGRESS, i, progressStr, i, "", gameObj.getPuzzleSpeciesTracking(), "", "");
                }
            }
        }
    };

    this.trackProgressForStars = function () {
        for (var i = 20; i <= 22; i++) {
            if (gameObj.getAchievementsState(i) == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                var progressForAchievement = achievementsObj.getProgressForAchievement(i);
                if (progressForAchievement >= 1) {
                    var progressStr = progressForAchievement + "/" + constantsObj.ACHIEVEMENTS_COUNTS[i];
                    trackObj.trackCounter(constantsObj.TRACK_ACHIEVEMENTS, constantsObj.TRACK_PROGRESS, i, progressStr, i, "", gameObj.getPuzzleSpeciesTracking(), "", "");
                }
            }
        }
    };

    this.trackProgressForConsecutiveLogins = function () {
        for (var i = 41; i <= 42; i++) {
            if (gameObj.getAchievementsState(i) == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                var progressForAchievement = achievementsObj.getProgressForAchievement(i);
                if (progressForAchievement >= 1) {
                    var progressStr = progressForAchievement + "/" + constantsObj.ACHIEVEMENTS_COUNTS[i];
                    trackObj.trackCounter(constantsObj.TRACK_ACHIEVEMENTS, constantsObj.TRACK_PROGRESS, i, progressStr, i, "", gameObj.getPuzzleSpeciesTracking(), "", "");
                }
            }
        }
    };

    this.trackProgressFor3StarCrosswords = function () {
        var list = [23, 64, 65, 66, 67, 68, 69, 70, 71];
        for (var ind in list) {
            var i = list[ind];
            if (gameObj.getAchievementsState(i) == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                var progressForAchievement = achievementsObj.getProgressForAchievement(i);
                if (progressForAchievement >= 1) {
                    var progressStr = progressForAchievement + "/" + constantsObj.ACHIEVEMENTS_COUNTS[i];
                    trackObj.trackCounter(constantsObj.TRACK_ACHIEVEMENTS, constantsObj.TRACK_PROGRESS, i, progressStr, i, "", gameObj.getPuzzleSpeciesTracking(), "", "");
                }
            }
        }
    };


    this.showAnimationForCompletedAchievements = function (index, initialDelay) {
        utilObj.showAchievementsAnimation(index, initialDelay);
    };

    this.getProgressForAchievement = function (ind) {
        var index = parseInt(ind);
        switch (index) {
            case 0:
                return achievementsObj.getProgressForPushNotifs();
                break;
            case 1:
                return achievementsObj.getProgressForFbLogin();
                break;
            case 2:
                return achievementsObj.getProgressForFtue();
                break;
            case 3:
                return achievementsObj.getProgressForFirstThemedPuzzle();
                break;
            case 4:
                return achievementsObj.getProgressForArchivePuzzleSolved();
                break;
            case 5:
                return achievementsObj.getProgressForTodaysPuzzleSolved();
                break;
            case 6:
            case 7:
            case 8:
            case 9:
            case 72:
            case 73:
            case 74:
            case 75:
            case 76:
            case 77:
                return achievementsObj.getProgressForInviteFriends();
                break;
            case 10:
                return achievementsObj.getProgressForSolvingEachThemeCrossword();
                break;
            case 11:
            case 12:
            case 13:
            case 44:
            case 45:
            case 49:
            case 50:
            case 51:
            case 52:
            case 53:
            case 46:
                return achievementsObj.getNumOfThemedCrosswordsSolved();
                break;
            case 14:
                return achievementsObj.getNumOfSpinnerHints();
                break;
            case 15:
            case 16:
            case 54:
            case 55:
            case 56:
            case 57:
            case 58:
            case 59:
            case 60:
                return achievementsObj.getDailyPuzzleSolvingStreak();
                break;
            case 17:
            case 18:
            case 61:
            case 62:
            case 63:
            case 19:
                return achievementsObj.getMiniPuzzlesSolvedCount();
                break;
            case 20:
            case 21:
            case 22:
                return achievementsObj.getCountOfStars();
                break;
            case 23:
                return achievementsObj.getProgressForThreeStarsAllMonth();
                break;
            case 24:
            case 25:
                return achievementsObj.getNumOfSolvedCrosswordsForDayOfWeek(1);
                break;
            case 26:
            case 27:
                return achievementsObj.getNumOfSolvedCrosswordsForDayOfWeek(2);
                break;
            case 28:
            case 29:
                return achievementsObj.getNumOfSolvedCrosswordsForDayOfWeek(3);
                break;
            case 30:
            case 31:
                return achievementsObj.getNumOfSolvedCrosswordsForDayOfWeek(4);
                break;
            case 32:
            case 33:
                return achievementsObj.getNumOfSolvedCrosswordsForDayOfWeek(5);
                break;
            case 34:
            case 35:
                return achievementsObj.getNumOfSolvedCrosswordsForDayOfWeek(6);
                break;
            case 36:
            case 37:
                return achievementsObj.getNumOfSolvedCrosswordsForDayOfWeek(0);
                break;
            case 38:
            case 39:
                return achievementsObj.getPuzzleSolvedCountForWeek();
                break;
            case 40:
                return achievementsObj.getOfferwallAchievementProgress();
                break;
            case 41:
                return gameObj.getConsecutiveLogins();
                break;
            case 42:
                return gameObj.getConsecutiveLogins();
                break;
            case 43:
                return gameObj.getNumVideos();
                break;
            case 64:
            case 65:
            case 66:
            case 67:
            case 68:
            case 69:
            case 70:
            case 71:
                return gameObj.getThreeStarPuzzleCount();
                break;
            case 79:
            case 80:
                return achievementsObj.getProgressForSMFAchievement(index);
                break;
            default:
                break;
        }
    };

    this.getProgressForPushNotifs = function () {
        var notifsEnabled = gameObj.getNotifsEnabled(true);
        if (notifsEnabled == true) {
            return 1;
        }
        return 0;
    };

    this.getProgressForFbLogin = function () {
        if (fbWrapperObj.isLoggedIn() == true) {
            return 1;
        }
        return 0;
    };

    this.getProgressForFtue = function () {
        var ftueShown = ftueObj.isFtueShown();
        if (ftueShown == true) {
            return 1;
        }
        return 0;
    };

    this.getProgressForFirstThemedPuzzle = function () {
        if (gameObj.getTotalDailyPuzzlesSolved() >= 1) {
            return 1;
        } else {
            return 0;
        }
    };

    this.getProgressForTodaysPuzzleSolved = function () {
        if (gameObj.getTodaysPuzzleSolved() == true) {
            return 1;
        }
        return 0;
    };

    this.getProgressForArchivePuzzleSolved = function () {
        if (gameObj.getArchivePuzzleSolved() == true) {
            return 1;
        }
        return 0;
    };


    this.getCountOfCompletedAchievements = function () {
        var completedAchievements = 0;
        for (var ind = 0; ind < countOfAchievements; ind++) {
            if (ind == constantsObj.CrossPromoAchievement1 || ind == constantsObj.CrossPromoAchievement2) {
                continue;
            }
            //disabling spinner achievement
            if (ind == constantsObj.ACHIEVEMENT_INDEX_TODAYS_PUZZLE || ind == constantsObj.ACHIEVEMENT_INDEX_50_HINTS_SPINNER) {
                continue;
            }
            if (utilObj.isAndroid() && ind == constantsObj.ACHIEVEMENT_INDEX_PUSH_NOTIFS) {
                continue;
            }

            var stateOfAchievement = gameObj.getAchievementsState(ind);
            if (stateOfAchievement == constantsObj.ACHIEVEMENT_COMPLETED || stateOfAchievement == constantsObj.ACHIEVEMENT_CLAIMED) {
                completedAchievements += 1;
            }
        }
        return completedAchievements;
    };

    this.getTotalCountOfAchievements = function () {
        return countOfAchievements;
    };

    this.updateStateOfAchievement = function (ind) {
        if (ind == 43) {
            gameObj.setAchievementsState(ind, constantsObj.ACHIEVEMENT_COMPLETED);
        }
        if (ind == constantsObj.CrossPromoAchievement1 || ind == constantsObj.CrossPromoAchievement2) {
            // loggerObj.debugLog("here it is" );
            questsObj.updateCrossGameQuestStatus(listItemsQuest[ind - constantsObj.CrossPromoOffset].id, constantsObj.QUEST_CLAIMED);
            var index = utilObj.checkGameAchievementforCrossPromoTracking(listItemsQuest[ind - constantsObj.CrossPromoOffset].d);
            trackObj.trackCounter(constantsObj.TRACK_ACHIEVEMENTS, constantsObj.TRACK_CLAIM, index, "", "", "", "", "", "");
            questsObj.getCrossGameProgress();
        }
        //loggerObj.debugLog("this is claim ind ", ind);
        if (ind == constantsObj.InGameAchievement1) {
            var questDetails = achievementsObj.getWhatsappQuest();
            questsObj.updateInGameQuestStatus(questDetails.id, constantsObj.QUEST_CLAIMED);
            trackObj.trackCounter(constantsObj.TRACK_ACHIEVEMENTS, constantsObj.TRACK_CLAIM, questDetails.id, "", "", "", "", "", "");
            questsObj.updateInGameProgress();
        }
        if (ind == constantsObj.ACHIEVEMENT_FB_LOGIN) {
            economyObj.updateFbConnectCash(true);
        }
        if (gameObj.getAchievementsState(ind) == constantsObj.ACHIEVEMENT_COMPLETED) {
            gameObj.setAchievementsState(ind, constantsObj.ACHIEVEMENT_CLAIMED);
            trackObj.trackCounter(constantsObj.TRACK_ACHIEVEMENTS, constantsObj.TRACK_CLAIM, ind, "", "", "", "", "", "");
        }
    };

    this.checkForInviteAchievements = function () {
        for (var i = 6; i < 10; i++) {
            if (gameObj.getAchievementsState(i) == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                var progressForAchievement = achievementsObj.getProgressForAchievement(i);
                if (progressForAchievement >= constantsObj.ACHIEVEMENTS_COUNTS[i]) {
                    gameObj.setAchievementsState(i, constantsObj.ACHIEVEMENT_COMPLETED);
                    achievementsObj.showAnimationForCompletedAchievements();
                }
            }
        }
        for (var i = 72; i <= 77; i++) {
            if (gameObj.getAchievementsState(i) == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                var progressForAchievement = achievementsObj.getProgressForAchievement(i);
                if (progressForAchievement >= constantsObj.ACHIEVEMENTS_COUNTS[i]) {
                    gameObj.setAchievementsState(i, constantsObj.ACHIEVEMENT_COMPLETED);
                    achievementsObj.showAnimationForCompletedAchievements();
                }
            }
        }
    };

    this.getProgressForInviteFriends = function () {
        return gameObj.getRefCount();
    };

    this.getProgressForSolvingEachThemeCrossword = function () {
        return gameObj.getProgressForSolvingEachThemeCrossword();
    };

    this.getNumOfThemedCrosswordsSolved = function () {
        return gameObj.getTotalDailyPuzzlesSolved();
    };

    this.getNumOfSpinnerHints = function () {
        return gameObj.getSpinnerHintsCount();
    };

    this.getDailyPuzzleSolvingStreak = function () {
        return gameObj.getDailyPuzzleSolvingStreak();
    };

    this.getMiniPuzzlesSolvedCount = function () {
        return gameObj.getMiniPuzzlesSolvedCount();
    };

    this.getCountOfStars = function () {
        return gameObj.getMastery1();
    };

    this.getProgressForThreeStarsAllMonth = function () {
        return gameObj.getProgressForThreeStarsAllMonth();
    };

    this.getNumOfSolvedCrosswordsForDayOfWeek = function (ind) {
        var index = parseInt(ind);
        return gameObj.getPuzzleSolvedCountForDayOfWeek(index);
    };

    this.getPuzzleSolvedCountForWeek = function () {
        return gameObj.getPuzzleSolvedCountForWeek();
    };

    this.getOfferwallAchievementProgress = function () {
        if (gameObj.getOfferwallAchievement()) {
            return 1;
        }
        return 0;
    };

    this.getProgressForSMFAchievement = function (index) {
        if (gameObj.getAchievementsState(index) != constantsObj.ACHIEVEMENT_IN_PROGRESS) {
            return 1;
        }
        return 0;
    };

    this.performCtaActionForId = function (ind, src) {
        if (src == undefined) {
            src = constantsObj.TRACK_ACHIEVEMENTS;
        }
        //loggerObj.debugLog("this is click action ", ind);
        var index = parseInt(ind);
        // this will perform the cta for the required achievements
        switch (index) {
            case 0:
                gameObj.setLastShownNotifPermissionAchv(utilObj.getCurrentTimestamp());
                achievementsObj.performCtaActionForNotifsPermission();
                machineLearningDataObj.incInGameQuestsClicks();
                break;
            case 1:
                gameObj.setLastShownFacebookConnectAchv(utilObj.getCurrentTimestamp());
                achievementsObj.performCtaActionForFbLogin();
                machineLearningDataObj.incInGameQuestsClicks();
                break;
            case 4:
            case 11:
            case 44:
            case 12:
            case 45:
            case 46:
            case 13:
            case 49:
            case 50:
            case 51:
            case 52:
            case 53:
            case 24:
            case 25:
            case 26:
            case 27:
            case 28:
            case 29:
            case 30:
            case 31:
            case 32:
            case 33:
            case 34:
            case 35:
            case 36:
            case 37:
            case 10:
                achievementsObj.performCtaActionForArchive();
                machineLearningDataObj.incInGameQuestsClicks();
                break;
            case 17:
            case 18:
            case 19:
            case 61:
            case 62:
            case 63:
                achievementsObj.performCtaActionForMinis();
                machineLearningDataObj.incInGameQuestsClicks();
                break;
            case 5:
                achievementsObj.performCtaActionForTodaysPuzzle();
                machineLearningDataObj.incInGameQuestsClicks();
                break;
            case 79:
            case 80:
                achievementsObj.performCtaActionForSMFAchievement(index);
                break;
            case 6:
            case 7:
            case 8:
            case 9:
            case 72:
            case 73:
            case 74:
            case 75:
            case 76:
            case 77:
                gameObj.setLastShownInviteAchv(utilObj.getCurrentTimestamp());
                achievementsObj.performCtaActionForInvite();
                machineLearningDataObj.incInGameQuestsClicks();
                break;
            case 40:
                gameObj.setLastShownBountyHunterTimeStamp(utilObj.getCurrentTimestamp());
                achievementsObj.performCtaActionForOfferwall();
                machineLearningDataObj.incInGameQuestsClicks();
                break;
            case 43:
                achievementsObj.performCtaActionForWatchVideos();
                machineLearningDataObj.incInGameQuestsClicks();
                break;
            case constantsObj.CrossPromoAchievement1:
                var questData = listItemsQuest[index - constantsObj.CrossPromoOffset];
                var questId = questData.id;
                questRotationObj.incBucketClickCount(questData.b, questId);
                gameObj.setLastShownXpromoAchv(utilObj.getCurrentTimestamp());
                if (questData.status == constantsObj.QUEST_NOT_STARTED) {
                    questsObj.updateCrossGameQuestStatus(questId, constantsObj.QUEST_STARTED);
                }
                var index1 = utilObj.checkGameAchievementforCrossPromoTracking(questData.d);
                trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_ACHIEVEMENTS, "action", "", index1, "", "");
                trackObj.trackCounter(constantsObj.TRACK_XPROMO, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_QUEST_CENTER, questId, constantsObj.TRACK_CLICK, src, "", "");
                achievementsObj.redirectToPlaystoreOnClick(questData, index);
                machineLearningDataObj.incCrossGameQuestsClicks();
                break;

            case constantsObj.CrossPromoAchievement2:
                var questData = listItemsQuest[index - constantsObj.CrossPromoOffset];
                var questId = questData.id;
                gameObj.setLastShownXpromoAchv(utilObj.getCurrentTimestamp());
                if (questData.status == constantsObj.QUEST_NOT_STARTED) {
                    questsObj.updateCrossGameQuestStatus(questId, constantsObj.QUEST_STARTED);
                }
                questRotationObj.incBucketClickCount(questData.b, questId);
                var index1 = utilObj.checkGameAchievementforCrossPromoTracking(questData.d);
                trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_ACHIEVEMENTS, "action", "", index1, "", "");
                // params = listItemsQuest[index - constantsObj.CrossPromoOffset].pa.split(":");
                trackObj.trackCounter(constantsObj.TRACK_XPROMO, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_QUEST_CENTER, questId, constantsObj.TRACK_CLICK, src, "", "");
                achievementsObj.redirectToPlaystoreOnClick(questData, index);
                machineLearningDataObj.incCrossGameQuestsClicks();
                break;

            case constantsObj.InGameAchievement1:
                var questDetails = achievementsObj.getWhatsappQuest();
                //loggerObj.debugLog("this is quest Details ", utilObj.getStringifiedJson(questDetails));
                if (questDetails == null) {
                    return;
                } else if (utilObj.isAndroid()) {
                    var msg = stringsObj.player_id + userObj.getRefId() + ":" + constantsObj.GAME_ID + "\n" + stringsObj.whatsapp_subscriber_text;
                    trackObj.trackCounter(constantsObj.TRACK_XPROMO, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_QUEST_CENTER, questDetails.id, constantsObj.TRACK_CLICK, src, "", "");
                    utilObj.openWhatsappForSubscriber(msg, questDetails["pa"]);
                }
                machineLearningDataObj.incCrossGameQuestsClicks();
                break;

            default:
                // loggerObj.debugLog("No cta action available");
                break;
        }
    };

    this.getWhatsappQuest = function () {
        var inGameQuests = questsObj.getAvailableInGameQuests();
        var inGameProgress = questsObj.getInGameProgressMap();
        for (var i = 0; i < inGameQuests.length; i++) {
            if (inGameQuests[i]["qt"] == constantsObj.QUEST_TYPE_SUBSCRIBE_WHATSAPP && (inGameProgress[inGameQuests[i]["id"]].status == constantsObj.QUEST_STARTED || inGameProgress[inGameQuests[i]["id"]].status == constantsObj.QUEST_COMPLETED)) {
                return inGameQuests[i];
            }
        }
        return null;

    };

    this.performCtaActionForNotifsPermission = function () {
        if (!utilObj.checkIfNotifsEnabled(true)) {
            gameObj.setNotifPopupShown(true);
            notifPermissionPopup.show();
        }
    };

    this.performCtaActionForFbLogin = function () {
        if (fbWrapperObj.isLoggedIn()) {
            achievementsLayer.hide();
            gameObj.setRequestCount(0);
            mfsLayer.checkAndShow(constantsObj.INVITE, constantsObj.SCREEN_ACHIEVEMENTS, null, null);
        } else {
            fbConnectPopup.show();
        }
    };

    this.performCtaActionForWatchVideos = function () {
        trackObj.trackCounter(constantsObj.TRACK_ACHIEVEMENTS, constantsObj.TRACK_WATCH, "43", "", "", "", "", "", "");
        if (utilObj.isOnline() == false) {
            utilObj.showMessage(stringsObj.no_video_available);
        }
        if (gameObj.getNumVideos() < 6 && adsObj.checkRewardedVideo(false, adsObj.setNotRewardedVideo, false)) {
            //loggerObj.debugLog("video available");
            adsObj.showVideoAd(false);
            adsObj.setNotRewardedVideo(false);
        } else if (gameObj.getNumVideos() >= 6) {
            var params = {id: 43, toScroll: 0, reward: 10};
            if (curScreen == constantsObj.SCREEN_HOME) {
                homeLayer.claimReward(params);

            } else if (curScreen == constantsObj.SCREEN_ACHIEVEMENTS) {
                achievementsLayer.claimReward(params);

            }
        } else {
            trackObj.trackCounter(constantsObj.TRACK_AD_TRACKING, constantsObj.TRACK_W2E, constantsObj.TRACK_RETRY, curScreen, "", "mopub", "", "", "");
            // utilObj.showMessage(stringsObj.no_video_available);
        }
    };

    this.performCtaActionForArchive = function () {
        if (curScreen == constantsObj.SCREEN_HOME) {
            homeLayer.hide();
        } else {
            achievementsLayer.hide();
        }
        sc = utilObj.popCurScreen();
        calendarLayer.selectedTab = constantsObj.CALENDAR_SCREEN;
        calendarLayer.show();
    };

    this.performCtaActionForMinis = function () {
        if (gameObj.getMastery1() <= 0) {
            utilObj.showMessage("Please complete a puzzle to access packs.");
            return;
        }
        if (curScreen == constantsObj.SCREEN_HOME) {
            homeLayer.hide();
        } else {
            achievementsLayer.hide();
        }
        sc = utilObj.popCurScreen();
        packsLayer.show();
    };

    this.performCtaActionForTodaysPuzzle = function () {
        achievementsLayer.hide();
        gameLayer.show(utilObj.getIdForDate(gameObj.getTodaysPuzzleDate()));
    };

    this.performCtaActionForInvite = function () {
        /*if (fbWrapperObj.isLoggedIn()) {
            achievementsLayer.hide();
            gameObj.setRequestCount(0);
            mfsLayer.checkAndShow(constantsObj.INVITE, constantsObj.SCREEN_ACHIEVEMENTS, null, null);
        } else {
            fbConnectPopup.show();
        }*/
        popupLayer.closeWithDefault();
        freeCoins2Popup.show(true, constantsObj.SCREEN_ACHIEVEMENTS);
    };

    this.performCtaActionForOfferwall = function () {
        if (!utilObj.isOnline()) {
            utilObj.showMessage(stringsObj.not_online);
            return;
        }
        if (adsObj.hasOfferWall()) {
            // loggerObj.debugLog("inside offerwall 1");
            adsObj.showOfferWall();
        } else {
            utilObj.showMessage("Offerwall not present . Please try after some time");
        }
    };

    this.performCtaActionForSMFAchievement = function (index) {
        if (!utilObj.isOnline()) {
            utilObj.showMessage(stringsObj.not_online);
            return;
        }
        if (gameObj.getAchievementsState(index) == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
            if (index == 79) {
                utilObj.openUrl(constantsObj.FOLLOW_ON_TWITTER);
            } else if (index == 80) {
                utilObj.openUrl(constantsObj.FOLLOW_ON_INSTAGRAM);
            }
            gameObj.setAchievementsState(index, constantsObj.ACHIEVEMENT_COMPLETED);
        } else if (gameObj.getAchievementsState(index == constantsObj.ACHIEVEMENT_COMPLETED)){
            gameObj.setAchievementsState(index, constantsObj.ACHIEVEMENT_CLAIMED);
            var params = {id: index, toScroll: 0, reward: 5};
            if (curLayer == constantsObj.SCREEN_HOME) {
                homeLayer.claimReward(params);
            } else if (curLayer == constantsObj.SCREEN_ACHIEVEMENTS) {
                achievementsLayer.claimReward(params);
            }
        }
        curLayer.redraw();
    };

    this.getNumOfCompletedAchievements = function () {
        var numOfCompletedAchievements = 0;
        for (var ind = 0; ind < countOfAchievements; ind++) {
            if (ind == constantsObj.ACHIEVEMENT_INDEX_TODAYS_PUZZLE) {
                continue;
            }
            if (ind == constantsObj.CrossPromoAchievement1 || ind == constantsObj.CrossPromoAchievement2) {
                if (gameObj.getAchievementsState(ind) == constantsObj.QUEST_COMPLETED) {
                    numOfCompletedAchievements += 1;
                }
            } else if (gameObj.getAchievementsState(ind) == constantsObj.ACHIEVEMENT_COMPLETED) {
                numOfCompletedAchievements += 1;
            }
        }
        return numOfCompletedAchievements;
    };

    this.getNumOfClaimedAchievements = function () {
        var numOfClaimedAchievements = 0;
        for (var ind = 0; ind < countOfAchievements; ind++) {
            if (ind == constantsObj.CrossPromoAchievement1 || ind == constantsObj.CrossPromoAchievement2) {
                continue;
            }
            if (gameObj.getAchievementsState(ind) == constantsObj.ACHIEVEMENT_CLAIMED) {
                numOfClaimedAchievements += 1;
            }
        }
        return numOfClaimedAchievements;
    };

    this.checkAndShowAnimationForPushNotifs = function () {
        if (gameObj.getAchievementsState(0) == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
            achievementsObj.showAnimationForCompletedAchievements(0, 0);
        }
    };

    // removing already completed achievements on build update
    this.checkForAlreadyCompletedAchievements = function () {
        var indexToCheck = [49, 50, 51, 52, 53, 64, 65, 66, 67, 68, 69, 70, 71, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63];

        for (var i in indexToCheck) {
            var progressForAchievement = achievementsObj.getProgressForAchievement(indexToCheck[i]);
            if (progressForAchievement >= constantsObj.ACHIEVEMENTS_COUNTS[indexToCheck[i]]) {
                gameObj.setAchievementsState(indexToCheck[i], constantsObj.ACHIEVEMENT_STATE_REMOVED);
            }
        }
        gameObj.setcheckifMapForAlreadyCompletedAchv(true);
    };

    /**
     * removes the twitter achievement indx 79 from the game if in progress for the user
     */
    this.removeTwitterAchvmnt = function () {

        var indexToRemove = constantsObj.ACHIEVEMENT_TWITTER_INDEX;
        var stateForAchievement = gameObj.getAchievementsState(indexToRemove);

        if (stateForAchievement == constantsObj.ACHIEVEMENT_STATE_REMOVED) {
            return;
        }

        if (stateForAchievement == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
            gameObj.setAchievementsState(indexToRemove, constantsObj.ACHIEVEMENT_STATE_REMOVED);
        }
    };

    // achievement retuning for the var 2 of the weekly Quest
    this.checkAchievementsRetuning = function () {
        var bucketListToProcess = {
            "0": "11,44,12,45,46,13,49,50,51,52,53",
            "1": "15,16,54,55,56,57,58,59,60",
            "2": "17,18,19,61,62,63",
            "3": "20,21,22",
            "4": "24,25",
            "5": "26,27",
            "6": "28,29",
            "7": "30,31",
            "8": "32,33",
            "9": "34,35",
            "10": "36,37",
            "11": "38,39",
            "12": "64,65,66,67,68,69,70,71",
            "13": "2"
        };
        var indexOfAchievementsToRemove = [2,15,11,44,12,45,46,49,50,51,53,16,55,56,57,59,18,19,62,20,21,22,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,65,67,68,69,71];

        for (var i in bucketListToProcess) {
            var achievementIndex = bucketListToProcess[i];
            var achvArr = achievementIndex.split(",");
            var flag = false;
            for (var j in achvArr) {
                var achInd = parseInt(achvArr[j]);
                // loggerObj.debugLog("achievement arr is", achInd);
                var stateForAchievement = gameObj.getAchievementsState(achInd);
                var progressForAchievement = achievementsObj.getProgressForAchievement(achInd);
                if (stateForAchievement == constantsObj.ACHIEVEMENT_STATE_REMOVED) {
                    continue;
                }
                if (progressForAchievement == 0 && !flag) {
                    flag = true;
                }
                if (stateForAchievement == constantsObj.ACHIEVEMENT_IN_PROGRESS && !flag) {
                    flag = true;
                } else if (stateForAchievement == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                    var isAchvToRemove = indexOfAchievementsToRemove.indexOf(achInd);
                    if (!(isAchvToRemove == -1)) {
                        gameObj.setAchievementsState(achInd, constantsObj.ACHIEVEMENT_STATE_REMOVED);
                        // loggerObj.debugLog("achievement arr remove is", achInd);
                    }
                }
            }
        }
    };

    this.redirectToPlaystoreOnClick = function (questData, index) {
        var params = questData.pa.split(":"), redirectionParams,
            trackingId = achievementsObj.getAchievementDetails(index).trackingId;
        if (questData.qt == constantsObj.QUEST_TYPE_INSTALL_GAME) {
            redirectionParams = {
                "adrAppId": params[0],
                "gameLink": params[2],
                "gameId": questData.gh,
                "fbId": params[4],
                "iosAppId": params[3]
            };
            questsObj.redirectToStoreWithTracking(constantsObj.TRACK_QUEST_CENTER, constantsObj.SCREEN_ACHIEVEMENTS, redirectionParams, trackingId);
        } else if (questData.qt.indexOf(constantsObj.QUEST_TYPE_CROSS_GAME_LEVEL_COMPLETE) == 0 || questData.qt.indexOf(constantsObj.QUEST_TYPE_INSTALL_AND) == 0 || questData.qt.indexOf(constantsObj.QUEST_TYPE_CROSS_GAME_ACTION) == 0 || questData.qt.indexOf(constantsObj.QUEST_TYPE_INSTALL_ACTION) == 0) {
            redirectionParams = {
                "adrAppId": params[0],
                "gameLink": params[2],
                "gameId": questData.gh,
                "fbId": params[5],
                "iosAppId": params[4]
            };
            questsObj.redirectToStoreWithTracking(constantsObj.TRACK_QUEST_CENTER, constantsObj.SCREEN_ACHIEVEMENTS, redirectionParams, trackingId);
        } else if (questData.qt.indexOf(constantsObj.QUEST_TYPE_CROSS_GAME_LEVEL_IN_TIME) == 0 || questData.qt.indexOf(constantsObj.QUEST_TYPE_INSTALL_TIME) == 0) {
            redirectionParams = {
                "adrAppId": params[0],
                "gameLink": params[2],
                "gameId": questData.gh,
                "fbId": params[6],
                "iosAppId": params[5]
            };
            questsObj.redirectToStoreWithTracking(constantsObj.TRACK_QUEST_CENTER, constantsObj.SCREEN_ACHIEVEMENTS, redirectionParams, trackingId);
        } else {
            questsObj.redirectToPlaystore1(params[2]);
        }
    };

    // made achievement Layer generic for two different achievement variants .
    /*
       FUNCTION PARAMS

       item:= Its a map which consists different quest and click functionalities.
       achievementVariant:= variable for checking the achievement variant.
     */
    this.createAchievementUi = function (item, yPos, zOrder, achievementVariant) {
        //var zOrder = constantsObj.UI_Z_ORDER;
        achievementsLayer.crossGameTimeQuests = [];
        var xPos = xLeftPos;
        var screen = constantsObj.SCREEN_ACHIEVEMENTS;
        var spriteArr = [];
        var labelArr = [];
        var sectionHeight = 340;
        //var itemWidget = new ccui.Widget();
        var sections = item.section;
        var textFont = constantsObj.FONT_ROBOTO_REGULAR_60;

        var count = 0;
        var count1 = 0;
        var itemMargin = 40;
        var middleMargin = 30;
        var numLines = 1;
        var CrossPromoOffsetforPosition = 0;
        var CrossPromoCount = achievementsObj.getCountListAchievement();
        //loggerObj.debugLog("count is cross promo", CrossPromoCount);
        for (var temp in sections) {
            count += 1;
        }
        if (CrossPromoCount > 0) {
            CrossPromoOffsetforPosition = (CrossPromoCount * sectionHeight) + 15;
        }
        var itemHeight = (count * (sectionHeight)) - CrossPromoOffsetforPosition;
        var doNotShowDivider = false;

        var itemWidth = canvasWidth;
        var localXPos = xPos + 40;
        var localYPos = yPos;
        var sectionYPos = localYPos;
        //itemWidget.setContentSize(cc.size(itemWidth, itemHeight));

        var sectionBgBig = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, canvasWidth / 2, localYPos - itemHeight - CrossPromoOffsetforPosition, 0.5, 0, canvasWidth - 40, itemHeight, spriteArr, achievementsLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
        //utilObj.addChild(itemWidget, sectionBgBig, zOrder + 1);
        var firstShineAnimationDelay = 0;

        for (var j in sections) {

            var section = sections[j];
            // loggerObj.debugLog("this is section with id ", utilObj.getStringifiedJson(section));
            sectionYPos = localYPos;
            var isCrossGame = 0;
            if (section.isCrossGame != undefined) {
                isCrossGame = section.isCrossGame;
            }
            count1 += 1;
            if (count1 == count) {
                doNotShowDivider = true;
            }

            var OffsetCrossPromo = 0;
            if (section == undefined) {
                continue;
            }
            var achievementTitle = section.title;
            var achievementDesc = section.desc;

            var showTitle = section.showTitle;
            if (showTitle == undefined) {
                showTitle = true;
            }


            var tile = constantsObj.white_rounded_bg;
            if (section.id == 43) {
                tile = constantsObj.white_rounded_bg_02;
            }
            var progressBarLength = 750;

            if (section.id == 43 || section.id == constantsObj.CrossPromoAchievement1 || section.id == constantsObj.CrossPromoAchievement2 || section.id == constantsObj.InGameAchievement1) {
                xpromoDtcObj.firingAdjustTracking(tile, itemWidth, sectionYPos, sectionHeight, spriteArr, zOrder, section, count1);
                if (utilObj.isStaging()) {
                    achievementDesc += " " + section.questId + " " + section.bucket;
                }
            }
            sectionYPos -= itemMargin;
            var textArr = [];
            if (achievementVariant == 0) {
                if (isTablet) {

                    if (showTitle == false) {
                        textArr = utilObj.getSplitStringsArr(achievementDesc, 25);
                    } else {
                        textArr = utilObj.getSplitStringsArr(achievementDesc, 50);
                    }
                } else {
                    if (showTitle == false) {
                        textArr = utilObj.getSplitStringsArr(achievementDesc, 25);
                    } else {
                        textArr = utilObj.getSplitStringsArr(achievementDesc, 56);
                    }
                }
            } else if (achievementVariant == 1) {
                if (isTablet) {
                    textArr = utilObj.getSplitStringsArr(achievementDesc, 56);
                } else {
                    textArr = utilObj.getSplitStringsArr(achievementDesc, 50);
                }
            }
            var yShift = 0;
            var xShift = 175;
            var xShiftLess = 70;
            numLines = textArr.length;
            var showTickIcon = false;
            var showClaimButton = false;
            var showCoinBg = false;
            var showCtaButton = false;
            var showProgressBar = false;
            var moveY = 0;
            var ctaText = "";

            var toScroll = (sectionHeight * (count1 - 1)) / itemHeight;

            if (section.hasProgressBar == true) {
                showProgressBar = true;
            }

            var badgeIconToUse = constantsObj.badge_white;
            if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                badgeIconToUse = constantsObj.achievement_icon;
            }

            if (section.id == constantsObj.CrossPromoAchievement1 || section.id == constantsObj.CrossPromoAchievement2 || section.id == constantsObj.InGameAchievement1) {
                questRotationObj.incBucketViewCount(section.bucket);
                trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_ACHIEVEMENTS, "qc", "", "", "", "");
                // loggerObj.debugLog("this is section id ", section.id, section.state);
                if (section.state == constantsObj.QUEST_CLAIMED) {
                    badgeIconToUse = constantsObj.badge_colour;
                    if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                        badgeIconToUse = constantsObj.achv_hs;
                    }
                    showTickIcon = true;
                    showProgressBar = false;
                }

                if (section.state == constantsObj.QUEST_COMPLETED) {
                    badgeIconToUse = constantsObj.badge_colour;
                    if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                        badgeIconToUse = constantsObj.achv_hs;
                    }
                    showClaimButton = true;
                    moveY = sectionHeight / 5;
                    showCoinBg = true;
                }

                if (section.state == constantsObj.QUEST_NOT_STARTED || section.state == constantsObj.QUEST_STARTED) {
                    if (section.cta != "") {
                        showCtaButton = true;
                        moveY = sectionHeight / 5;
                        ctaText = section.cta;
                    }
                    showCoinBg = true;
                }
            } else {
                if (section.state == constantsObj.ACHIEVEMENT_CLAIMED) {
                    badgeIconToUse = constantsObj.badge_colour;
                    if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                        badgeIconToUse = constantsObj.achv_hs;
                    }
                    showTickIcon = true;
                    showProgressBar = false;
                }

                if (section.state == constantsObj.ACHIEVEMENT_COMPLETED) {
                    badgeIconToUse = constantsObj.badge_colour;
                    if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                        badgeIconToUse = constantsObj.achv_hs;
                    }
                    showClaimButton = true;
                    moveY = sectionHeight / 5;
                    showCoinBg = true;
                }

                if (section.state == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                    if (section.cta != "") {
                        showCtaButton = true;
                        moveY = sectionHeight / 5;
                        ctaText = section.cta;
                    }
                    showCoinBg = true;
                }
            }


            if (showCoinBg == true) {
                var coinBg = utilObj.getScale9Sprite(constantsObj.rounded_4, xRightPos - 180, localYPos - sectionHeight / 2 - moveY, 0.5, 0.5, 230, 100, spriteArr, achievementsLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
                //utilObj.addChild(itemWidget, sectionBgBig, zOrder + 1););
                coinBg.setColor(constantsObj.COLOR_BLACK);
                coinBg.setOpacity(constantsObj.OPACITY_30);

                var coinIcon = utilObj.getSprite(constantsObj.coin_png_2, xRightPos - 180 - 115 + 15, localYPos - sectionHeight / 2 - moveY - 50 + 50, 0, 0.5, constantsObj.SCALE_SPRITE_14, spriteArr, achievementsLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
                //utilObj.addChild(coinBg, coinIcon, zOrder + 1);

                var textLbl2 = utilObj.getBMFontLabel(section.reward, constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xRightPos - 180 - 115 + 150, localYPos - sectionHeight / 2 - moveY - 50 + 50, 0.5, 0.5, labelArr, achievementsLayer.scrollView, zOrder + 1);
                //utilObj.addChild(coinBg, textLbl2, zOrder + 1);


                //utilObj.addChild(itemWidget, coinBg, zOrder + 1);
            }

            if (showClaimButton == true) {
                var claimBtnWidth = 230;
                var claimBtnHeight = 100;
                var claimButton = utilObj.getButton(claimBtnWidth, claimBtnHeight, 0.5, 0.5, xRightPos - 180, localYPos - sectionHeight / 2 + moveY,
                    constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                        obj: 'achievementsLayer',
                        fn: item.fn,
                        params: {reward: section.reward, id: section.id, toScroll: toScroll},
                        screen: screen,
                        track: {
                            k: "",
                            p: gameObj.getCurPuzzleTracking(),
                            c: gameObj.getTrackingPuzzleTheme(),
                            o: constantsObj.TRACK_CLUE_TAP,
                            f: "",
                            g: "",
                            s: "",
                            co: 1,
                            oppId: ""
                        },
                    }, false, ccui.Widget.PLIST_TEXTURE, 1);
                claimButton.setColor(constantsObj.COLOR_BUTTON_GREEN);
                utilObj.addChild(achievementsLayer.scrollView, claimButton, zOrder + 1);

                var stencil = new cc.Scale9Sprite(constantsObj.button_cutup);
                stencil.attr({
                    anchorX: 0.5,
                    anchorY: 0.5,
                    width: claimBtnWidth,
                    height: claimBtnHeight
                });
                utilObj.setPosition(stencil, xRightPos - 180, localYPos - sectionHeight / 2 + moveY);
                utilObj.setColor(stencil, constantsObj.COLOR_BUTTON_GREEN);
                var clipper = cc.ClippingNode(stencil);
                clipper.setAlphaThreshold(0);
                clipper.setCascadeOpacityEnabled(true);
                utilObj.addChild(achievementsLayer.scrollView, clipper, zOrder + 2);
                var clipperChild = new cc.Scale9Sprite(constantsObj.button_cutup);
                clipperChild.attr({
                    anchorX: 0.5,
                    anchorY: 0.5,
                    width: claimBtnWidth + 40,
                    height: claimBtnHeight
                });
                utilObj.setColor(clipperChild, constantsObj.COLOR_BUTTON_GREEN);
                utilObj.setPosition(clipperChild,  xRightPos - 180, localYPos - sectionHeight / 2 + moveY);
                utilObj.addChild(clipper, clipperChild, zOrder + 1);

                var shineNode = utilObj.getSprite(constantsObj.shine, xRightPos - 180 - claimBtnWidth/2 - 100, localYPos - sectionHeight / 2 + moveY, 0.5, 0.5, 0.40);
                shineNode.rotation = 30;
                shineNode.setColor(constantsObj.COLOR_WHITE);
                utilObj.addChild(clipper, shineNode, zOrder + 2);

                var params = {
                    node: shineNode,
                    width: claimBtnWidth,
                    height: claimBtnHeight,
                    xPos :  xRightPos - 180 - claimBtnWidth/2 - 100,
                    initAnimDelay: firstShineAnimationDelay
                };
                var animDelay = animationObj.animateShine(params);

                if(firstShineAnimationDelay == 0){
                    firstShineAnimationDelay = animDelay;
                }

                var textLbl2 = utilObj.getBMFontLabel("Claim", constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xRightPos - 180, localYPos - sectionHeight / 2 + moveY, 0.5, 0.5, labelArr, achievementsLayer.scrollView, zOrder + 3);
                if (!achievementsLayer.toPulseFirstClaimBtn && homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                    achievementsLayer.toPulseFirstClaimBtn = true;
                    utilObj.pulseButtonMore(stencil, 80, 0);
                    utilObj.pulseButtonMore(textLbl2, 81, 0);
                }
                //utilObj.addChild(claimButton, textLbl2, zOrder + 1);

            }

            if (showCtaButton == true) {
                if (section.id == 43) {
                    achievementsLayer.ctaButtonVideo = utilObj.getButton(230, 100, 0.5, 0.5, xRightPos - 180, localYPos - sectionHeight / 2 + moveY,
                        constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                            obj: 'achievementsLayer',
                            fn: item.ctaFn,
                            params: {reward: section.reward, id: section.id},
                            screen: screen,
                            track: {
                                k: "achievements",
                                p: section.cta + "",
                                c: section.id + "",
                                o: "",
                                f: "",
                                g: "",
                                s: "",
                                co: 1,
                                oppId: ""
                            },
                        }, false, ccui.Widget.PLIST_TEXTURE, 1);
                    achievementsLayer.ctaButtonVideo.setColor(constantsObj.COLOR_BUTTON_ORANGE);
                    utilObj.addChild(achievementsLayer.scrollView, achievementsLayer.ctaButtonVideo, zOrder + 1);
                    achievementsLayer.textLbl1 = utilObj.getBMFontLabel("Watch", constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_WHITE,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xRightPos - 180, localYPos - sectionHeight / 2 + moveY, 0.5, 0.5, labelArr, achievementsLayer.scrollView, zOrder + 1);
                    //utilObj.addChild(achievementsLayer.ctaButtonVideo, achievementsLayer.textLbl1, zOrder + 1);

                } else {
                    var ctaButton = utilObj.getButton(230, 100, 0.5, 0.5, xRightPos - 180, localYPos - sectionHeight / 2 + moveY,
                        constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                            obj: 'achievementsLayer',
                            fn: item.ctaFn,
                            params: {reward: section.reward, id: section.id},
                            screen: screen,
                            track: {
                                k: "achievements",
                                p: section.cta + "",
                                c: section.id + "",
                                o: "",
                                f: "",
                                g: "",
                                s: "",
                                co: 1,
                                oppId: ""
                            },
                        }, false, ccui.Widget.PLIST_TEXTURE, 1);
                    if (section.id == constantsObj.ACHIEVEMENT_FB_LOGIN) {
                        ctaButton.setColor(constantsObj.COLOR_CONTACT_US);
                    } else {
                        ctaButton.setColor(constantsObj.COLOR_BUTTON_ORANGE);
                    }
                    utilObj.addChild(achievementsLayer.scrollView, ctaButton, zOrder + 1);
                    var textLbl1 = utilObj.getBMFontLabel(ctaText, constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_WHITE,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xRightPos - 180, localYPos - sectionHeight / 2 + moveY, 0.5, 0.5, labelArr, achievementsLayer.scrollView, zOrder + 1);
                    //utilObj.addChild(ctaButton, textLbl1, zOrder + 1);

                }
            }

            if (showTickIcon == true) {
                var tick = utilObj.getSprite(constantsObj.tick, xRightPos - 180, localYPos - sectionHeight / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_13, spriteArr, achievementsLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
                tick.setColor(constantsObj.COLOR_GREEN);
                //utilObj.addChild(itemWidget, tick, zOrder + 1);
            }

            var gameIcon = badgeIconToUse;
            if (section.id == constantsObj.CrossPromoAchievement1 || section.id == constantsObj.CrossPromoAchievement2) {
                OffsetCrossPromo = 15;
                var badgeImageXpromo = xpromoDtcObj.showQuestIcon(section, gameIcon, badgeIconToUse, localXPos, localYPos, spriteArr, zOrder, achievementsLayer.scrollView);
            } else if (section.id == constantsObj.InGameAchievement1) {
                var badgeImage = utilObj.getSprite(constantsObj.whatsapp_pic, localXPos + 100, localYPos - 160, 0.5, 0.5, constantsObj.SCALE_SPRITE_11 * 1.5, spriteArr, achievementsLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
            } else if (section.id == 79 || section.id == 80) {
                if (section.id == 79) {
                    var badgeImage = utilObj.getSprite(constantsObj.twitter_icon, localXPos + 100, localYPos - 160, 0.5, 0.5, constantsObj.SCALE_SPRITE_2, spriteArr, achievementsLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
                } else if (section.id == 80) {
                    var badgeImage = utilObj.getSprite(constantsObj.instagram_icon, localXPos + 100, localYPos - 160, 0.5, 0.5, constantsObj.SCALE_SPRITE_7, spriteArr, achievementsLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
                }
            } else {
                var scaling = constantsObj.SCALE_SPRITE_9 * 1.5;
                var position = localXPos + 60;
                if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL ) {
                    if (badgeIconToUse != constantsObj.achievement_icon) {
                        position -= 11;
                    } else {
                        scaling *= 1.2
                    }
                }

                var badgeImage = utilObj.getSprite(badgeIconToUse, position, localYPos - 160, 0, 0.5, scaling, spriteArr, achievementsLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);

                if (section.state == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                        badgeImage.setColor(constantsObj.COLOR_BLACK);
                        badgeImage.setOpacity(constantsObj.OPACITY_50);
                }
            }

            if (showProgressBar != true) {
                sectionYPos -= 15;
            }

            if (isCrossGame == 1) {
                var textLabel1 = utilObj.getBMFontLabel(achievementTitle, constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 220, sectionYPos - 50, 0, 0.5, labelArr, achievementsLayer.scrollView, zOrder + 1);
                sectionYPos -= 100;
                var textLabel2 = utilObj.getBMFontLabel(achievementDesc, constantsObj.FONT_ROBOTO_REGULAR_50, constantsObj.COLOR_ACHIEVEMENT_DESC,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 220, sectionYPos - 40, 0, 0.5, labelArr, achievementsLayer.scrollView, zOrder + 1);
                sectionYPos -= (60 + middleMargin);

            } else if (gameIcon == badgeIconToUse) {
                var textLabel1 = utilObj.getBMFontLabel(achievementTitle, constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 220, sectionYPos - 50, 0, 0.5, labelArr, achievementsLayer.scrollView, zOrder + 1);
                sectionYPos -= 100;
                if (achievementVariant == 0 && showTitle == false) {
                    sectionYPos += 80;
                }
                for (var i = 1; i <= textArr.length; i++) {
                    var textLabel2 = utilObj.getBMFontLabel(textArr[i - 1], constantsObj.FONT_ROBOTO_REGULAR_50, constantsObj.COLOR_ACHIEVEMENT_DESC,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 220, sectionYPos - 40, 0, 0.5, labelArr, achievementsLayer.scrollView, zOrder + 1);
                    //utilObj.addChild(itemWidget, textLabel2, zOrder + 1);
                    sectionYPos -= (60 + middleMargin);
                }
            } else {
                var textLabel1 = utilObj.getBMFontLabel(achievementTitle, constantsObj.FONT_ROBOTO_REGULAR_50, constantsObj.COLOR_ACHIEVEMENT_DESC,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 300, sectionYPos - 50, 0, 0.5, labelArr, achievementsLayer.scrollView, zOrder + 1);
                sectionYPos -= 100;
                if (achievementVariant == 0 && showTitle == false) {
                    sectionYPos += 80;
                }
                for (var i = 1; i <= textArr.length; i++) {
                    var textLabel2 = utilObj.getBMFontLabel(textArr[i - 1], constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_BLACK,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 300, sectionYPos - 40, 0, 0.5, labelArr, achievementsLayer.scrollView, zOrder + 1);
                    sectionYPos -= (60 + middleMargin);
                }
            }

            var timerBarLength = (0.3 * progressBarLength);
            if (section.id == 43) {
                var stateOfAchievement = gameObj.getAchievementsState(43);
                //loggerObj.debugLog("check state28", section.id, gameObj.getAchievementsState(43), section.hasTimerBar);
                if (stateOfAchievement == constantsObj.ACHIEVEMENT_COMPLETED || stateOfAchievement == constantsObj.ACHIEVEMENT_CLAIMED) {
                    section.hasTimerBar = 0;
                    //showProgressBar = false;
                    //loggerObj.debugLog("check state29", section.id, gameObj.getAchievementsState(43), section.hasTimerBar, showProgressBar);
                }
            }
            if (section.hasTimerBar == 1) {
                // loggerObj.debugLog("this is section timer bar ", achievementDesc, section.id);
                progressBarLength = (0.6 * progressBarLength);
                //utilObj.addChild(itemWidget, timerBar, zOrder + 1);
                if (section.id == 43) {
                    var timerBar = utilObj.getScale9Sprite(constantsObj.full_bar, localXPos + 950 - timerBarLength, sectionYPos - 45, 0, 0.5, timerBarLength, 50, spriteArr, achievementsLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
                    timerBar.setColor(constantsObj.COLOR_RED_ACHIEVEMENT);
                    var timeRemainingVideo = gameObj.getTimeRemainingForVideoAchievement();
                    var timeRemainingStr = utilObj.formatTime(timeRemainingVideo);
                    achievementsLayer.timerLbl = utilObj.getBMFontLabel(timeRemainingStr + "", constantsObj.FONT_ROBOTO_MEDIUM_40, constantsObj.COLOR_WHITE,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 950 - timerBarLength / 2, sectionYPos - 45, 0.5, 0.5, labelArr, achievementsLayer.scrollView, zOrder + 1);
                } else if (section.id == 41 || section.id == 42) {
                    var timerBar = utilObj.getScale9Sprite(constantsObj.full_bar, localXPos + 950 - timerBarLength, sectionYPos - 45, 0, 0.5, timerBarLength, 50, spriteArr, achievementsLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
                    timerBar.setColor(constantsObj.COLOR_RED_ACHIEVEMENT);
                    var progressForAchievement = achievementsObj.getProgressForAchievement(section.id);
                    var count = constantsObj.ACHIEVEMENTS_COUNTS[section.id];
                    var remDays = count - progressForAchievement;
                    var str = remDays + " days";
                    if (remDays <= 1) {
                        str = remDays + " day";
                    }
                    var streakTimelbl = utilObj.getBMFontLabel(str + "", constantsObj.FONT_ROBOTO_MEDIUM_40, constantsObj.COLOR_WHITE,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 950 - timerBarLength / 2, sectionYPos - 45, 0.5, 0.5, labelArr, achievementsLayer.scrollView, zOrder + 1);

                } else if (section.status != constantsObj.QUEST_NOT_STARTED) {
                    var timerBar = utilObj.getScale9Sprite(constantsObj.full_bar, localXPos + 950 - timerBarLength, sectionYPos - 45, 0, 0.5, timerBarLength, 50, spriteArr, achievementsLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
                    timerBar.setColor(constantsObj.COLOR_RED_ACHIEVEMENT);
                    var timeRem = section.timeRem;
                    timeRem = Math.max(0, parseInt(section.startTime) + parseInt(timeRem) - parseInt(utilObj.getCurrentTimestamp()));
                    var timeRemainingStr = utilObj.formatTime(timeRem);
                    var timeLabel = utilObj.getBMFontLabel(timeRemainingStr + "", constantsObj.FONT_ROBOTO_MEDIUM_40, constantsObj.COLOR_WHITE,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 950 - timerBarLength / 2, sectionYPos - 45, 0.5, 0.5, labelArr, achievementsLayer.scrollView, zOrder + 1);
                    achievementsLayer.crossGameTimeQuests.push({
                        lbl: timeLabel,
                        startTime: section.startTime,
                        timeLimit: section.timeRem,
                        id: section.questId
                    });
                } else {
                    section.hasTimerBar = 0;
                }
                // utilObj.addChild(itemWidget, achievementsLayer.timerLbl, zOrder + 1);
            }


            if (showProgressBar == true) {
                //loggerObj.debugLog("check state291", section.id, gameObj.getAchievementsState(43), section.hasTimerBar, showProgressBar);
                var progressBarFull = utilObj.getScale9Sprite(constantsObj.full_bar, localXPos + 220, sectionYPos - 45, 0, 0.5, progressBarLength, 50, spriteArr, achievementsLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
                progressBarFull.setColor(constantsObj.COLOR_PROGRESS_BAR_FULL);
                //utilObj.addChild(itemWidget, progressBarFull, zOrder + 1);

                if (parseInt(section.progress) >= parseInt(section.maxCount)) {
                    section.progress = section.maxCount;
                }
                var ratioProgress = (section.progress) / (section.maxCount);
                var halfBar = constantsObj.half_bar;
                var halfProgressBarLength = ratioProgress * progressBarLength;
                if (halfProgressBarLength == progressBarLength) {
                    halfBar = constantsObj.full_bar;
                }
                var progressBarHalf = utilObj.getScale9Sprite(halfBar, localXPos + 220, sectionYPos - 45, 0, 0.5, halfProgressBarLength, 50, spriteArr, achievementsLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
                progressBarHalf.setColor(constantsObj.COLOR_PROGRESS_BAR_HALF);
                //utilObj.addChild(itemWidget, progressBarHalf, zOrder + 1);

                if (section.id != 43) {
                    var progressTextLbl = utilObj.getBMFontLabel(section.progress + "/" + section.maxCount, constantsObj.FONT_ROBOTO_MEDIUM_40, constantsObj.COLOR_PROGRESS_BAR_TEXT,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 220 + progressBarLength / 2, sectionYPos - 45, 0.5, 0.5, labelArr, achievementsLayer.scrollView, zOrder + 1);
                    //utilObj.addChild(itemWidget, progressTextLbl, zOrder + 1);
                } else {
                    achievementsLayer.videoProgress = utilObj.getBMFontLabel(section.progress + "/" + section.maxCount, constantsObj.FONT_ROBOTO_MEDIUM_40, constantsObj.COLOR_PROGRESS_BAR_TEXT,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 220 + progressBarLength / 2, sectionYPos - 45, 0.5, 0.5, labelArr, achievementsLayer.scrollView, zOrder + 1);
                    //utilObj.addChild(itemWidget, homeLayer.videoProgress, zOrder + 1);
                }
            }

            if (doNotShowDivider == false) {
                var divider = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, localYPos - sectionHeight, 0.5, 0.5, canvasWidth - 100, 2, spriteArr, achievementsLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
                divider.setColor(constantsObj.COLOR_GREY_05);
                //utilObj.addChild(itemWidget, divider, zOrder + 1);
            }


            localYPos -= sectionHeight;
            // localYPos -= OffsetCrossPromo;
        }
        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);

        return localYPos;
    };


    this.createHomeLayerUi = function (yPos, spriteArr, labelArr, homeVariant, layerToDraw) {
        if(layerToDraw == undefined) {
            layerToDraw = homeLayer;
        }
        var achievementsInOrder = achievementsObj.getAchievementsInOrder();

        var carouselExp = xpromoDtcObj.getCarouseExperimentVariant();

        var toAdjustUiForCarousel = false;
        if(homeVariant == 2 && carouselExp != constantsObj.EXP_VAR_CONTROL) {
            toAdjustUiForCarousel = true; // will adjust achv UI acc. to this
        }

        if(homeVariant == 2 && carouselExp != constantsObj.EXP_VAR_CONTROL) {
            // Requirement is to sort the achievements such that, "ready to claim" (completed) achievements appear first

            // First lets get state of all achievements whether they are completed or otherwise
            var achievementStates = {};
            for(var i = 0; i < achievementsInOrder.length; i++) {
                var index = achievementsInOrder[i];
                var state = gameObj.getAchievementsState(index);
                achievementStates[index] = 0; // otherwise

                if (index == constantsObj.CrossPromoAchievement1 || index == constantsObj.CrossPromoAchievement2) {
                    if (state == constantsObj.QUEST_COMPLETED) {
                        achievementStates[index] = 1; // completed
                    }
                } else if (state == constantsObj.ACHIEVEMENT_COMPLETED) {
                    achievementStates[index] = 1; // completed
                }
            }

            //Since we have the state information for all achievements, lets sort them by state (1's before 0's hence achievementStates[indexB] - achievementStates[indexA])
            achievementsInOrder.sort(function (indexA, indexB) {
                return achievementStates[indexB] - achievementStates[indexA];
            });
        }

        // to consider when redrawing
        var lastAchievementsOrder = gameObj.getLastOrderOfAchievements();
        var achievementsSection = [];
        homeLayer.crossGameTimeQuests = [];
        var i = 0;
        var achievement = achievementsObj.getAchievementDetails(achievementsInOrder[i]);

        var colorForText = constantsObj.COLOR_WHITE;
        var medium_50 = constantsObj.FONT_ROBOTO_MEDIUM_50;
        var medium_70 = constantsObj.FONT_ROBOTO_MEDIUM_70;
        var medium_60 = constantsObj.FONT_ROBOTO_MEDIUM_60;
        var medium_40 = constantsObj.FONT_ROBOTO_MEDIUM_40;
        var medium_45 = constantsObj.FONT_ROBOTO_MEDIUM_45;
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            colorForText = constantsObj.COLOR_BLACK;
            medium_50 = constantsObj.FONT_HELVETICA_MEDIUM_50;
            medium_70 = constantsObj.FONT_HELVETICA_MEDIUM_70;
            medium_60 = constantsObj.FONT_HELVETICA_MEDIUM_60;
            medium_40 = constantsObj.FONT_HELVETICA_MEDIUM_40;
            medium_45 = constantsObj.FONT_HELVETICA_MEDIUM_45;
        }
        // Code for Cooldown of CrossPromo Achievement
        // if (achievement.title == stringsObj.install_play) {
        //     if ((utilObj.getCurrentTimestamp() - gameObj.getLastShownXpromoAchv()) <= 4 * constantsObj.SECONDS_IN_DAY) {
        //         i += 1;
        //         achievement = achievementsObj.getAchievementDetails(achievementsInOrder[i]);
        //         if (achievement.title == stringsObj.install_play) {
        //             i += 1;
        //             achievement = achievementsObj.getAchievementDetails(achievementsInOrder[i]);
        //         }
        //
        //     } else {
        //         if (gameObj.getlastCrossPromoSeenTimeStamp() == 0) {
        //             gameObj.setlastCrossPromoSeenTimeStamp(utilObj.getCurrentTimestamp());
        //         }
        //         else {
        //             var numberOfDays = parseInt(utilObj.getCurrentTimestamp() - gameObj.getlastCrossPromoSeenTimeStamp()) / constantsObj.SECONDS_IN_DAY;
        //             //loggerObj.debugLog("number of days is", Math.round(numberOfDays), Math.round(numberOfDays)%4);
        //             if (Math.round(numberOfDays) % 4 != 0) {
        //                 i += 1;
        //                 achievement = achievementsObj.getAchievementDetails(achievementsInOrder[i]);
        //                 if (achievement.title == "Install & Play") {
        //                     i += 1;
        //                     achievement = achievementsObj.getAchievementDetails(achievementsInOrder[i]);
        //                 }
        //             }
        //         }
        //     }
        // }

        //loggerObj.debugLog("lelouch achievement is ", utilObj.getStringifiedJson(achievement));

        if (achievement.title == constantsObj.ACHIEVEMENT_TITLE_WATCH_6_VIDEOS && gameObj.getAchievementsState(43) == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
            if (!gameObj.isEligibleForVideoAchievementHS()) {
                i += 1;
                achievement = achievementsObj.getAchievementDetails(achievementsInOrder[i]);
            }
        }
        var isSMAchievement = false;
        if (achievement.title == constantsObj.ACHIEVEMENT_TITLE_TWITTER_LIKE || achievement.title == constantsObj.ACHIEVEMENT_TITLE_INSTAGRAM_LIKE) {
            isSMAchievement = true;
        }

        if (homeVariant != 0 && !(achievement.id == constantsObj.InGameAchievement1 && achievement.state == constantsObj.QUEST_COMPLETED)) {
            // Home Screen Achievement Surfacing based on Proximity
            if ((achievement.state != constantsObj.ACHIEVEMENT_COMPLETED && achievement.title != constantsObj.ACHIEVEMENT_TITLE_WATCH_6_VIDEOS && achievement.id != constantsObj.CrossPromoAchievement1 && achievement.id != constantsObj.CrossPromoAchievement2 && !isSMAchievement)){ //&& achievement.title != stringsObj.install_play) {
                var achievementIndex = achievementsObj.getNonAchievedType(0);
                if (achievementIndex == -1) {
                    var achievementIndex = achievementsObj.getNonAchievedType(1);
                    if (achievementIndex != -1) {
                        // loggerObj.debugLog("coming to play", achievementIndex);
                        achievement = achievementsObj.getAchievementDetails(achievementIndex);
                    } else {
                        // loggerObj.debugLog("coming to play1", achievementsInOrder[i]);
                        achievement = achievementsObj.getAchievementDetails(achievementsInOrder[i]);
                    }

                } else {
                    // loggerObj.debugLog("coming to play", achievementIndex);
                    achievement = achievementsObj.getAchievementDetails(achievementIndex);
                }
            }
        }


        achievementsSection.push(achievement);
        var listItems = [
            {
                //headerColor: (layoutExperimentVariant == constantsObj.EXP_VAR_CONTROL) ? constantsObj.COLOR_LIGHT_RED : constantsObj.COLOR_RED_01,
                //headerLine: constantsObj.COLOR_LIGHT_RED_LINE,
                //headerText: stringsObj.ACROSS_HINTS,
                fn: "claimReward",
                ctaFn: "performCtaAction",
                //widgetFn: "selectListWidget",
                //alignment: "across",
                section: achievementsSection
            }
        ];

        for (var i in listItems) {
            var item = listItems[i];
            //loggerObj.debugLog("lelouch list element added here");
            var zOrder = constantsObj.SPRITE_Z_ORDER;
            var xPos = xLeftPos;
            var screen = constantsObj.SCREEN_HOME;

            var sectionHeight = 250;
            if (toAdjustUiForCarousel) {
                sectionHeight = 380;
            }
            //var itemWidget = new ccui.Widget();
            var sections = item.section;
            var textFont = constantsObj.FONT_ROBOTO_REGULAR_60;

            var count = 0;
            var count1 = 0;
            var itemMargin = 40;
            var middleMargin = 30;
            var numLines = 1;

            for (var temp in sections) {
                count += 1;
            }

            var itemHeight = (count * (sectionHeight));
            var doNotShowDivider = false;

            var itemWidth = canvasWidth;
            var localXPos = xPos;
            var localYPos = itemHeight;
            var sectionYPos = yPos;
            //itemWidget.setContentSize(cc.size(itemWidth, itemHeight));

            /*var sectionBgBig = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, canvasWidth / 2, 0, 0.5, 0, canvasWidth - 40, itemHeight);
            utilObj.addChild(itemWidget,sectionBgBig, zOrder + 1);*/


            for (var j in sections) {
                var section = sections[j];
                sectionYPos = yPos;

                count1 += 1;
                var isCrossGame = 0;
                if (section.isCrossGame != undefined) {
                    isCrossGame = section.isCrossGame;
                }
                // loggerObj.debugLog("iscrossgame", isCrossGame);

                if (count1 == count) {
                    doNotShowDivider = true;
                }

                var achievementTitle = section.title;
                var achievementDesc = section.desc;


                var tile = constantsObj.white_rounded_bg;
                if (section.id == 43) {
                    tile = constantsObj.white_rounded_bg_02;
                }
                var progressBarLength = 750;
                sectionYPos -= itemMargin;


                var textArr = [];
                if (isTablet) {
                    textArr = utilObj.getSplitStringsArr(achievementDesc, 56);
                } else {
                    textArr = utilObj.getSplitStringsArr(achievementDesc, 50);
                }
                var yShift = 0;
                var xShift = 175;
                var xShiftLess = 70;
                numLines = textArr.length;
                var showTickIcon = false;
                var showClaimButton = false;
                var showCoinBg = false;
                var showCtaButton = false;
                var showProgressBar = false;
                var moveY = 0;
                var ctaText = "";

                var toScroll = (sectionHeight * (count1 - 1)) / itemHeight;

                if (section.hasProgressBar == true) {
                    showProgressBar = true;
                }

                var badgeIconToUse = constantsObj.badge_white;
                if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                    badgeIconToUse = constantsObj.achievement_icon;
                }

                if (section.id == constantsObj.CrossPromoAchievement1 || section.id == constantsObj.CrossPromoAchievement2 || section.id == constantsObj.InGameAchievement1) {
                    var trackingId = "", trackId = "";
                    if (section.id == constantsObj.CrossPromoAchievement1 || section.id == constantsObj.CrossPromoAchievement2) {
                        questRotationObj.incBucketViewCount(section.bucket);
                        if (section.isSocialQuest == 1) {
                            section.trackingId = "social_quest_" + count1;
                        } else {
                            section.trackingId = "quest_" + count1;
                        }
                        trackingId = section.trackingId;
                        if (utilObj.isAndroid()) {
                            trackId = constantsObj.trackAndroidMap[section.gh];
                        } else if (utilObj.isIos()) {
                            trackId = constantsObj.trackIosMap[section.gh];
                        }
                        xpromoUtilObj.hitAdjustViewTracking(trackId, constantsObj.TRACK_HOME, trackingId);
                    }
                    trackObj.trackCounter(constantsObj.TRACK_XPROMO, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_QUEST_CENTER, section.questId, constantsObj.TRACK_VIEW, constantsObj.TRACK_HOME, trackingId, "");

                    if (gameObj.getlastCrossPromoSeenTimeStamp() == 0) {
                        gameObj.setlastCrossPromoSeenTimeStamp(utilObj.getCurrentTimestamp());
                    }

                    if (section.state == constantsObj.QUEST_CLAIMED) {
                        badgeIconToUse = constantsObj.badge_colour;
                        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                            badgeIconToUse = constantsObj.achv_hs;
                        }
                        showTickIcon = true;
                        showProgressBar = false;
                    }

                    if (section.state == constantsObj.QUEST_COMPLETED) {
                        badgeIconToUse = constantsObj.badge_colour;
                        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                            badgeIconToUse = constantsObj.achv_hs;
                        }
                        showClaimButton = true;
                        moveY = 250 / 5;
                        showCoinBg = true;
                    }

                    if (section.state == constantsObj.QUEST_NOT_STARTED || section.state == constantsObj.QUEST_STARTED) {
                        if (section.cta != "") {
                            showCtaButton = true;
                            moveY = 250 / 5;
                            ctaText = section.cta;
                        }
                        showCoinBg = true;
                    }
                } else {
                    if (section.state == constantsObj.ACHIEVEMENT_CLAIMED) {
                        badgeIconToUse = constantsObj.badge_colour;
                        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                            badgeIconToUse = constantsObj.achv_hs;
                        }
                        showTickIcon = true;
                        showProgressBar = false;
                    }

                    if (section.state == constantsObj.ACHIEVEMENT_COMPLETED) {
                        badgeIconToUse = constantsObj.badge_colour;
                        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                            badgeIconToUse = constantsObj.achv_hs;
                        }
                        showClaimButton = true;
                        moveY = 250 / 5;
                        showCoinBg = true;
                    }

                    if (section.state == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                        if (section.cta != "") {
                            showCtaButton = true;
                            moveY = 250 / 5;
                            ctaText = section.cta;
                        }
                        showCoinBg = true;
                    }
                }


                if (showCoinBg == true) {
                    //loggerObj.debugLog("hitting coin bg");
                    var coinBg = utilObj.getScale9Sprite(constantsObj.rounded_4, xRightPos - 180, yPos - sectionHeight / 2 - moveY - 10, 0.5, 0.5, 230, 90, spriteArr, layerToDraw, zOrder, constantsObj.SPRITE_MISC);
                    //homeLayer.addChild(homeLayer.transBg, zOrder + 1);
                    //utilObj.addChild(homeLayer.achievementBackground, coinBg, zOrder + 1);
                    //var coinBg = utilObj.getScale9Sprite(constantsObj.rounded_4, xRightPos - 180, localYPos - sectionHeight / 2 - moveY - 50, 0.5, 0.5, 230, 100, null, homeLayer, 100, constantsObj.SPRITE_MISC);
                    coinBg.setColor(constantsObj.COLOR_BLACK);
                    coinBg.setOpacity(constantsObj.OPACITY_30);

                    var coinIcon = utilObj.getSprite(constantsObj.coin_png_2, xRightPos - 180 - 115 + 15, yPos - sectionHeight / 2 - moveY - 10 - 45 + 45, 0, 0.5, constantsObj.SCALE_SPRITE_2, spriteArr, layerToDraw, zOrder, constantsObj.SPRITE_MISC);
                    //utilObj.addChild(coinBg, coinIcon, zOrder + 1);

                    var textLbl2 = utilObj.getBMFontLabel(section.reward, medium_50, colorForText,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xRightPos - 180 - 115 + 150, yPos - sectionHeight / 2 - moveY - 10 - 45 + 45, 0.5, 0.5, labelArr, layerToDraw, zOrder + 1);
                    //utilObj.addChild(coinBg, textLbl2, zOrder + 1);


                    //utilObj.addChild(itemWidget,coinBg, zOrder + 1);
                }


                if (showClaimButton == true) {
                    var claimButton = utilObj.getButton(230, 90, 0.5, 0.5, xRightPos - 180, yPos - sectionHeight / 2 + moveY + 5,
                        constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                            obj: 'homeLayer',
                            fn: item.fn,
                            params: {reward: section.reward, id: section.id, toScroll: toScroll},
                            screen: screen,
                            track: {
                                k: "dialog",
                                p: section.cta + "",
                                c: section.id + "",
                                o: constantsObj.TRACK_HOME,
                                f: constantsObj.TRACK_ACHIEVEMENTS_CLAIM,
                                g: "",
                                s: "",
                                co: 1,
                                oppId: ""
                            },
                        }, false, ccui.Widget.PLIST_TEXTURE, 1);
                    // claimButton.setColor(constantsObj.COLOR_BUTTON_ORANGE);
                    if(toAdjustUiForCarousel) {
                        claimButton.setSwallowTouches(false);
                    }
                    utilObj.addChild(layerToDraw, claimButton, zOrder + 1);
                    var claimB = utilObj.getScale9Sprite(constantsObj.button_cutup, xRightPos - 180, yPos - sectionHeight / 2 + moveY + 5, 0.5, 0.5, 230, 90, spriteArr, layerToDraw, zOrder, constantsObj.SPRITE_MISC);
                    claimB.setColor(constantsObj.COLOR_BUTTON_GREEN);
                    var textLbl2 = utilObj.getBMFontLabel("Claim", medium_50, constantsObj.COLOR_WHITE,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xRightPos - 180 - 115 + 115, yPos - sectionHeight / 2 + moveY + 5 - 45 + 50, 0.5, 0.5, labelArr, layerToDraw, zOrder + 1);
                    //utilObj.addChild(claimButton, textLbl2, zOrder + 1);

                }

                if (showCtaButton == true) {
                    if (section.id == 43) {
                        homeLayer.ctaButtonVideo = utilObj.getButton(230, 100, 0.5, 0.5, xRightPos - 180, yPos - sectionHeight / 2 + moveY,
                            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                                obj: 'homeLayer',
                                fn: item.ctaFn,
                                params: {reward: section.reward, id: section.id},
                                screen: screen,
                                track: {
                                    k: "achievements",
                                    p: section.cta + "",
                                    c: section.id + "",
                                    o: "",
                                    f: "",
                                    g: "",
                                    s: "",
                                    co: 1,
                                    oppId: ""
                                },
                            }, false, ccui.Widget.PLIST_TEXTURE, 1);
                        // homeLayer.ctaButtonVideo.setColor(constantsObj.COLOR_BUTTON_ORANGE);
                        if(toAdjustUiForCarousel) {
                            homeLayer.ctaButtonVideo.setSwallowTouches(false);
                        }
                        utilObj.addChild(layerToDraw, homeLayer.ctaButtonVideo, zOrder + 1);
                        var ctaB = utilObj.getScale9Sprite(constantsObj.button_cutup, xRightPos - 180, yPos - sectionHeight / 2 + moveY, 0.5, 0.5, 230, 100, spriteArr, layerToDraw, zOrder, constantsObj.SPRITE_MISC);
                        ctaB.setColor(constantsObj.COLOR_BUTTON_ORANGE);
                        homeLayer.textLbl1 = utilObj.getBMFontLabel("Watch", medium_50, constantsObj.COLOR_WHITE,
                            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xRightPos - 180 - 115 + 115, yPos - sectionHeight / 2 + moveY - 45 + 50, 0.5, 0.5, labelArr, layerToDraw, zOrder + 1);
                        //utilObj.addChild(homeLayer.ctaButtonVideo, homeLayer.textLbl1, zOrder + 1);

                    } else {
                        // Making the entire tab clickable incase of crossPromo Achievements
                        if(section.id == constantsObj.CrossPromoAchievement1 || section.id == constantsObj.CrossPromoAchievement2) {
                            var transButton = utilObj.getButton(canvasWidth, sectionHeight, 0, 1.0, xPos, yPos,
                                constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                                    obj: 'homeLayer',
                                    fn: item.ctaFn,
                                    params: {reward: section.reward, id: section.id},
                                    screen: screen,
                                    track: {
                                        k: "dialog",
                                        p: section.cta + "",
                                        c: section.id + "",
                                        o: "",
                                        f: constantsObj.TRACK_ACHIEVEMENTS_CLICK,
                                        g: "",
                                        s: "",
                                        co: 1,
                                        oppId: ""
                                    },
                                    feedBackType: constantsObj.NO_TOUCH_ON_SWIPE_FEEDBACK,
                                }, false, ccui.Widget.PLIST_TEXTURE, 1);
                            utilObj.addChild(layerToDraw, transButton, zOrder + 1);
                        }

                        var ctaButton = utilObj.getButton(230, 100, 0.5, 0.5, xRightPos - 180, yPos - sectionHeight / 2 + moveY + 5,
                            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                                obj: 'homeLayer',
                                fn: item.ctaFn,
                                params: {reward: section.reward, id: section.id},
                                screen: screen,
                                track: {
                                    k: "dialog",
                                    p: section.cta + "",
                                    c: section.id + "",
                                    o: "",
                                    f: constantsObj.TRACK_ACHIEVEMENTS_CLICK,
                                    g: "",
                                    s: "",
                                    co: 1,
                                    oppId: ""
                                },
                            }, false, ccui.Widget.PLIST_TEXTURE, 1);
                        // ctaButton.setColor(constantsObj.COLOR_BUTTON_ORANGE);
                        if(toAdjustUiForCarousel) {
                            ctaButton.setSwallowTouches(false);
                        }
                        utilObj.addChild(layerToDraw, ctaButton, zOrder + 1);
                        var ctaB = utilObj.getScale9Sprite(constantsObj.button_cutup, xRightPos - 180, yPos - sectionHeight / 2 + moveY + 5, 0.5, 0.5, 230, 100, spriteArr, layerToDraw, zOrder, constantsObj.SPRITE_MISC);
                        if (section.id == constantsObj.ACHIEVEMENT_FB_LOGIN) {
                            ctaB.setColor(constantsObj.COLOR_CONTACT_US);
                        } else {
                            ctaB.setColor(constantsObj.COLOR_BUTTON_ORANGE);
                        }

                        //trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", constantsObj.TRACK_HOME, constantsObj.TRACK_ACHIEVEMENTS_CLICK, "", "", 1, "");
                        var textLbl1 = utilObj.getBMFontLabel(ctaText, medium_50, constantsObj.COLOR_WHITE,
                            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xRightPos - 180 - 115 + 115, yPos - sectionHeight / 2 + moveY - 45 + 50 - 45 + 50, 0.5, 0.5, labelArr, layerToDraw, zOrder + 1);
                        // utilObj.addChild(ctaButton, textLbl1, zOrder + 1);

                    }
                }
                if (section.title != undefined && homeLayer.achievementTileStr != null) {
                    homeLayer.achievementTileStr += "_" + section.id;
                }

                if (showTickIcon == true) {
                    var tick = utilObj.getSprite(constantsObj.tick, xRightPos - 180, yPos - sectionHeight / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_13, spriteArr, layerToDraw, zOrder, constantsObj.SPRITE_MISC);
                    tick.setColor(constantsObj.COLOR_GREEN);
                    //utilObj.addChild(homeLayer.achievementBackground, tick, zOrder + 1);
                }

                // setting the ui for carousel
                var adjustUiForCarouselHeader = 0;
                var adjustUiForCarouselDesc = 0;
                var adjustUiForCarouselProgressBar = 0;
                var scaleForBadgeIcon = 1;
                var progressBarHeight = 50;
                var fontForProgressBar = medium_40;
                var moveUpBadgeIcon = 0;
                var toShowRedBar = true;

                if (toAdjustUiForCarousel) {
                    adjustUiForCarouselHeader = 20;
                    adjustUiForCarouselDesc = 20;
                    adjustUiForCarouselProgressBar = 30;
                    scaleForBadgeIcon = 1.25;
                    progressBarHeight = 55;
                    fontForProgressBar = medium_45;
                    moveUpBadgeIcon = 60;
                    toShowRedBar = false;
                }
                // ----------


                var gameIcon = badgeIconToUse;
                var badgeWidth = 0;
                if (section.id == constantsObj.CrossPromoAchievement1 || section.id == constantsObj.CrossPromoAchievement2) {
                    var badgeImageXpromo = xpromoDtcObj.showQuestIcon(section, gameIcon, badgeIconToUse, localXPos + 30, yPos - sectionHeight / 2 + 160, spriteArr, zOrder, layerToDraw);
                    badgeWidth = badgeImageXpromo.getContentSize().width;
                } else if (section.id == constantsObj.InGameAchievement1) {
                    var badgeImage = utilObj.getSprite(constantsObj.whatsapp_pic, localXPos + 60, yPos - sectionHeight / 2, 0, 0.5, constantsObj.SCALE_SPRITE_11 * 1.5, spriteArr, layerToDraw, zOrder, constantsObj.SPRITE_MISC);
                    badgeWidth = badgeImage.getContentSize().width * constantsObj.SCALE_SPRITE_11 * 1.5;
                } else if (section.id == 79 || section.id == 80) {
                    if (section.id == 79) {
                        var badgeImage = utilObj.getSprite(constantsObj.twitter_icon, localXPos + 100, yPos - sectionHeight / 2 + moveUpBadgeIcon, 0.5, 0.5, constantsObj.SCALE_SPRITE_2, spriteArr, layerToDraw, zOrder, constantsObj.SPRITE_MISC);
                        badgeWidth = badgeImage.getContentSize().width * constantsObj.SCALE_SPRITE_2;
                    } else if (section.id == 80) {
                        var badgeImage = utilObj.getSprite(constantsObj.instagram_icon, localXPos + 100, yPos - sectionHeight / 2 + moveUpBadgeIcon, 0.5, 0.5, constantsObj.SCALE_SPRITE_7, spriteArr, layerToDraw, zOrder, constantsObj.SPRITE_MISC);
                        badgeWidth = badgeImage.getContentSize().width * constantsObj.SCALE_SPRITE_7;
                    }
                } else {
                    var badgeImage = utilObj.getSprite(badgeIconToUse, localXPos + 60, yPos - sectionHeight / 2 + moveUpBadgeIcon, 0, 0.5, constantsObj.SCALE_SPRITE_7 * 1.5 * scaleForBadgeIcon, spriteArr, layerToDraw, zOrder, constantsObj.SPRITE_MISC);

                    if (section.state == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
                        badgeImage.setColor(constantsObj.COLOR_WHITE);
                        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                            badgeImage.setColor(constantsObj.COLOR_BLACK);
                            badgeImage.setOpacity(constantsObj.OPACITY_30);
                        }
                    }
                    badgeWidth = badgeImage.getContentSize().width * constantsObj.SCALE_SPRITE_7 * 1.5;
                }
                //utilObj.addChild(homeLayer.achievementBackground, badgeImage, zOrder + 1);

                if (showProgressBar != true) {
                    sectionYPos -= 15;
                }

                if (isCrossGame == 1) {
                    var textLabel1 = utilObj.getBMFontLabel(achievementTitle, medium_70, colorForText,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 270, sectionYPos - 40 - adjustUiForCarouselHeader, 0, 0.5, labelArr, layerToDraw, zOrder + 1);
                    //utilObj.addChild(homeLayer.achievementBackground, textLabel1, zOrder + 1);
                    sectionYPos -= 100;
                    var textLabel2 = utilObj.getBMFontLabel(achievementDesc, medium_50, colorForText,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 270, sectionYPos - 15 - adjustUiForCarouselHeader, 0, 0.5, labelArr, layerToDraw, zOrder + 1);
                    // utilObj.addChild(homeLayer.achievementBackground, textLabel2, zOrder + 1);
                    sectionYPos -= (60 + middleMargin);
                } else if (gameIcon == badgeIconToUse) {
                    var textLabel1 = utilObj.getBMFontLabel(achievementTitle, medium_70, colorForText,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 270, sectionYPos - 10 - adjustUiForCarouselHeader, 0, 0.5, labelArr, layerToDraw, zOrder + 1);
                    //utilObj.addChild(homeLayer.achievementBackground, textLabel1, zOrder + 1);
                    sectionYPos -= 100;
                    for (var i = 1; i <= textArr.length; i++) {
                        var textLabel2 = utilObj.getBMFontLabel(textArr[i - 1], medium_50, colorForText,
                            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 270, sectionYPos + 15 - adjustUiForCarouselDesc, 0, 0.5, labelArr, layerToDraw, zOrder + 1);
                        // utilObj.addChild(homeLayer.achievementBackground, textLabel2, zOrder + 1);
                        sectionYPos -= (60 + middleMargin);
                    }
                } else {
                    var textLabel1 = utilObj.getBMFontLabel(achievementTitle, medium_50, colorForText,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 340, sectionYPos - 10, 0, 0.5, labelArr, layerToDraw, zOrder + 1);
                    //utilObj.addChild(homeLayer.achievementBackground, textLabel1, zOrder + 1);
                    sectionYPos -= 100;
                    for (var i = 1; i <= textArr.length; i++) {
                        var textLabel2 = utilObj.getBMFontLabel(textArr[i - 1], medium_60, colorForText,
                            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 340, sectionYPos + 15, 0, 0.5, labelArr, layerToDraw, zOrder + 1);
                        // utilObj.addChild(homeLayer.achievementBackground, textLabel2, zOrder + 1);
                        sectionYPos -= (60 + middleMargin);

                    }
                }


                //loggerObj.debugLog("check state27", section.id, gameObj.getAchievementsState(43), section.hasTimerBar);
                var timerBarLength = (0.3 * progressBarLength);

                var timerBarPosition = localXPos + 1000 - timerBarLength;
                var yPosDif = 0;
                var sizeOfTimerLbl = medium_40;
                var colorTimer = constantsObj.COLOR_TIMER_BARTXT_HS_NEW;
                if (toAdjustUiForCarousel) {
                    timerBarPosition = localXPos + 75 + badgeWidth/2;
                    yPosDif = 60;
                    sizeOfTimerLbl = constantsObj.FONT_HELVETICA_REGULAR_50;
                    colorTimer = constantsObj.COLOR_RED_TIMER_BAR_1;
                }
                if (section.id == 43) {
                    var stateOfAchievement = gameObj.getAchievementsState(43);
                    //loggerObj.debugLog("check state28", section.id, gameObj.getAchievementsState(43), section.hasTimerBar);
                    if (stateOfAchievement == constantsObj.ACHIEVEMENT_COMPLETED || stateOfAchievement == constantsObj.ACHIEVEMENT_CLAIMED) {
                        section.hasTimerBar = 0;
                        //showProgressBar = false;
                        //loggerObj.debugLog("check state29", section.id, gameObj.getAchievementsState(43), section.hasTimerBar, showProgressBar);
                    }
                }
                if (section.hasTimerBar == 1) {
                    // progressBarLength = (0.6 * progressBarLength);

                    if (section.isCrossGame == 1 && section.status != constantsObj.QUEST_NOT_STARTED) {
                        if (toShowRedBar) {
                            var timerBar = utilObj.getScale9Sprite(constantsObj.full_bar, timerBarPosition, sectionYPos + 25, 0.5, 0.5, timerBarLength, 50, spriteArr, layerToDraw, zOrder, constantsObj.SPRITE_MISC);
                            timerBar.setColor(constantsObj.COLOR_RED_ACHIEVEMENT);
                        }
                        var timeRem = section.timeRem;
                        timeRem = Math.max(0, parseInt(section.startTime) + parseInt(timeRem) - parseInt(utilObj.getCurrentTimestamp()));
                        var timeRemainingStr = utilObj.formatTime(timeRem);
                        var timeLabel = utilObj.getBMFontLabel(timeRemainingStr + "", sizeOfTimerLbl, constantsObj.COLOR_WHITE,
                            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), timerBarPosition, sectionYPos + 25 - yPosDif, 0.5, 0.5, labelArr, layerToDraw, zOrder + 1);
                        homeLayer.crossGameTimeQuests.push({
                            lbl: timeLabel,
                            startTime: section.startTime,
                            timeLimit: section.timeRem
                        });
                    } else if (section.id == 41 || section.id == 42) {
                        if (toShowRedBar) {
                            var timerBar = utilObj.getScale9Sprite(constantsObj.full_bar, timerBarPosition, sectionYPos + 25, 0.5, 0.5, timerBarLength, 50, spriteArr, layerToDraw, zOrder, constantsObj.SPRITE_MISC);
                            timerBar.setColor(constantsObj.COLOR_RED_ACHIEVEMENT);
                        }
                        var progressForAchievement = achievementsObj.getProgressForAchievement(section.id);
                        var count = constantsObj.ACHIEVEMENTS_COUNTS[section.id];
                        var remDays = count - progressForAchievement;
                        var str = remDays + " days";
                        if (remDays <= 1) {
                            str = remDays + " day";
                        }
                        var lbl = utilObj.getBMFontLabel(str + "", sizeOfTimerLbl, constantsObj.COLOR_WHITE,
                            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), timerBarPosition, sectionYPos + 25 - yPosDif, 0.5, 0.5, labelArr, layerToDraw, zOrder + 1);

                        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                            utilObj.setColor(timerBar, constantsObj.COLOR_TIMER_BAR_HS_NEW);
                            utilObj.setOpacity(timerBar, constantsObj.OPACITY_30);
                            lbl.setColor(colorTimer);
                        }
                    } else {
                        if (toShowRedBar) {
                            var timerBar = utilObj.getScale9Sprite(constantsObj.full_bar, timerBarPosition, sectionYPos + 25, 0.5, 0.5, timerBarLength, 50, spriteArr, layerToDraw, zOrder, constantsObj.SPRITE_MISC);
                            timerBar.setColor(constantsObj.COLOR_RED_ACHIEVEMENT);
                        }
                        var timeRemainingVideo = gameObj.getTimeRemainingForVideoAchievement();
                        var timeRemainingStr = utilObj.formatTime(timeRemainingVideo);
                        homeLayer.timerLbl = utilObj.getBMFontLabel(timeRemainingStr + "", sizeOfTimerLbl, constantsObj.COLOR_WHITE,
                            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), timerBarPosition, sectionYPos + 25 - yPosDif, 0.5, 0.5, labelArr, layerToDraw, zOrder + 1);

                        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                            utilObj.setColor(timerBar, constantsObj.COLOR_TIMER_BAR_HS_NEW);
                            utilObj.setOpacity(timerBar, constantsObj.OPACITY_30);
                            homeLayer.timerLbl.setColor(colorTimer);
                        }
                    }
                }


                if (showProgressBar == true) {
                    //loggerObj.debugLog("check state291", section.id, gameObj.getAchievementsState(43), section.hasTimerBar, showProgressBar);
                    var progressBarFull = utilObj.getScale9Sprite(constantsObj.full_bar, localXPos + 270, sectionYPos + 25 - adjustUiForCarouselProgressBar, 0, 0.5, progressBarLength, progressBarHeight, spriteArr, layerToDraw, zOrder, constantsObj.SPRITE_MISC);
                    progressBarFull.setColor(constantsObj.COLOR_PROGRESS_BAR_FULL_HOME);

                    if (parseInt(section.progress) >= parseInt(section.maxCount)) {
                        section.progress = section.maxCount;
                    }
                    var ratioProgress = (section.progress) / (section.maxCount);
                    var halfBar = constantsObj.half_bar;
                    var halfProgressBarLength = ratioProgress * progressBarLength;
                    if (halfProgressBarLength == progressBarLength) {
                        halfBar = constantsObj.full_bar;
                    }
                    var progressBarHalf = utilObj.getScale9Sprite(halfBar, localXPos + 270, sectionYPos + 25 - adjustUiForCarouselProgressBar, 0, 0.5, halfProgressBarLength, progressBarHeight, spriteArr, layerToDraw, zOrder, constantsObj.SPRITE_MISC);
                    progressBarHalf.setColor(constantsObj.COLOR_PROGRESS_BAR_HALF_HOME);

                    if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
                        progressBarFull.setOpacity(constantsObj.OPACITY_10);
                        progressBarHalf.setColor(constantsObj.COLOR_HS_AHCV_BAR);
                    }

                    if (section.id != 43) {
                        var progressTextLbl = utilObj.getBMFontLabel(section.progress + "/" + section.maxCount, fontForProgressBar, colorForText, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 270 + progressBarLength / 2, sectionYPos + progressBarHeight/2 - adjustUiForCarouselProgressBar, 0.5, 0.5, labelArr, layerToDraw, zOrder + 1);
                        //utilObj.addChild(homeLayer.achievementBackground, progressTextLbl, zOrder + 1);
                    } else {
                        layerToDraw.videoProgress = utilObj.getBMFontLabel(section.progress + "/" + section.maxCount, fontForProgressBar, colorForText, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 270 + progressBarLength / 2, sectionYPos + progressBarHeight/2 - adjustUiForCarouselProgressBar, 0.5, 0.5, labelArr, layerToDraw, zOrder + 1);
                        // utilObj.addChild(homeLayer.achievementBackground, homeLayer.videoProgress, zOrder + 1);
                    }
                }

                localYPos -= sectionHeight;
            }
        }
    };


};


