AdaptiveContent = function(){

    var puzzlesSolvedForApadtive = 0; 
    var puzzleMasteryMap = [];
    var storedAcrossClues = null;
    var storedDownClues = null;
    var clueSwapTrack = null;

    this.init = function(){

    };

    /**
     * set/stores values from/to gameData
     */
    this.setValueFromGameData = function(gameData){
        if(gameData.puzzlesSolvedForApadtive != undefined){
            puzzlesSolvedForApadtive = gameData.puzzlesSolvedForApadtive;
        }
        if(gameData.puzzleMasteryMap != undefined){
            puzzleMasteryMap = gameData.puzzleMasteryMap;
        }
        if(gameData.storedAcrossClues != undefined){
            storedAcrossClues = gameData.storedAcrossClues;
        }
        if(gameData.storedDownClues != undefined){
            storedDownClues = gameData.storedDownClues;
        }
    };

    this.getAdaptiveContentObj = function(gameData){
        gameData.puzzlesSolvedForApadtive = puzzlesSolvedForApadtive;
        gameData.puzzleMasteryMap = puzzleMasteryMap;
        gameData.storedAcrossClues = storedAcrossClues;
        gameData.storedDownClues = storedDownClues;
        return gameData;
    };


    //-------------------------------------------------------------------------------------------------------------------------------------
    
    /**
     * Getter / setter for stored clues.
     */
    this.setStoredClues = function(){
        // loggerObj.debugLog("hehe -- STORED CLUES SET TO NULL");
        storedAcrossClues = null;
        storedDownClues = null;
    }

    /**
     * Fetching the clues for across and down 
     * Control -> default clues are selected 
     * Var1 -> clues based on bucketing values are swapped.
     */
    this.fetchAcrossHints = function(curCrosswordInfo){
        

        var puzzleId = curCrosswordInfo.d;
        if((storedAcrossClues != null) && (puzzleId in storedAcrossClues)){
            return storedAcrossClues[puzzleId];
        }

        var adaptiveAcrossHints = null;
        var finalAcrossHints  = {};
        adaptiveAcrossHints = utilObj.getDecryptedData(curCrosswordInfo.ac);
        

        // loggerObj.debugLog("ADAPTIVE adaptiveAcrossHints",JSON.stringify(adaptiveAcrossHints));
        for(var key in adaptiveAcrossHints){
            finalAcrossHints[key] = adaptiveAcrossHints[key][0];
        }

        if (adaptiveContentObj.isEligibleForAdaptive()){

            var gridHeight = curCrosswordInfo.h;
            var gridWidth = curCrosswordInfo.w;
            var bucketNo = 1;
            var noOfCluesToBeSwapped = 0;
            var acrossSwapList = [];
            if (adaptiveContentObj.isPuzzleSizeEligible(gridHeight, gridWidth) && adaptiveContentObj.isEligbleForClueSwapping()) {
                bucketNo = adaptiveContentObj.getUserCurrentBucket();
                noOfCluesToBeSwapped = adaptiveContentObj.getNumberOfCluesToBeSwapped(bucketNo,gridWidth,gridHeight);

                var { "ac": acrossCluesToSkip } = adaptiveContentObj.getNumCluesToSkip(gridWidth, gridHeight);
                var acrossHintsKeys = Object.keys(adaptiveAcrossHints).sort(function (a, b) { return parseInt(a) - parseInt(b) });
                acrossSwapList = acrossHintsKeys.slice(acrossCluesToSkip);
            }
            // loggerObj.debugLog(constantsObj.LOG_ADAPTIVE, "  isEligibleForSwapping, BucketNo, NoOfCluesSwapped -> ", adaptiveContentObj.isEligbleForClueSwapping(), bucketNo, noOfCluesToBeSwapped);

            clueSwapTrack = ""; // Keeps the track for Number of clues swapped
            utilObj.shuffleArray(acrossSwapList);
            // PREVIOUS FLOW STOPED
            // for(var i = 0; i < noOfCluesToBeSwapped ;i++){

            //     loggerObj.debugLog("CHKCHK DEFAULT SWAP", adaptiveAcrossHints[acrossSwapList[i]][0] , adaptiveAcrossHints[acrossSwapList[i]][1]);
            //     if(adaptiveAcrossHints[acrossSwapList[i]][0] != adaptiveAcrossHints[acrossSwapList[i]][1]){
            //         loggerObj.debugLog("CHKCHK NOT SAME ");
            //     }
            //     if(adaptiveAcrossHints[acrossSwapList[i]][1] != undefined){
            //         finalAcrossHints[acrossSwapList[i]] = adaptiveAcrossHints[acrossSwapList[i]][1];

            //         clueSwapTrack += acrossSwapList[i] + "a-";
            //     }
                
            // }


            // Revised logic for Swapping the CLues 
            if (noOfCluesToBeSwapped > 0) {
                var cluesSwapped = 0;
                for (var i = 0; i < acrossSwapList.length; i++) {
                    var clueNumber = acrossSwapList[i];
                    var clueArr = adaptiveAcrossHints[clueNumber];
                    var adaptiveClueEntryPresent = clueArr.length >= 2;
                    var validAdaptiveClue = utilObj.isValid(clueArr[1]) && clueArr[1] != "" && (clueArr[0] != clueArr[1]);
                    if (adaptiveClueEntryPresent && validAdaptiveClue) {
                        finalAcrossHints[clueNumber] = clueArr[1];
                        cluesSwapped += 1;
                        clueSwapTrack += clueNumber + "a-";
                    }
                    if (cluesSwapped == noOfCluesToBeSwapped) {
                        break;
                    }
                }

            }

            

        }

        // loggerObj.debugLog("ADAPTIVE ::  final hints func",JSON.stringify(finalAcrossHints));
        
       
        if(storedAcrossClues == null){
            storedAcrossClues = {};
        }
        
        if(!(puzzleId in storedAcrossClues)){

            // THESE TWO ARE ADDED SO THAT IF PUZZLES ARE UPDATED FROM DASHBOARD , The LAST PUZZLES CLUE SET IS DELETED
            storedAcrossClues = null;
            storedAcrossClues = {};

            storedAcrossClues[puzzleId] = {};
            storedAcrossClues[puzzleId] = finalAcrossHints;
        }
       
        return finalAcrossHints;
    };


    this.fetchDownHints = function(curCrosswordInfo){

        var puzzleId = curCrosswordInfo.d;
        if((storedDownClues != null)  && (puzzleId in storedDownClues)){
            return storedDownClues[puzzleId];
        }

        var adaptiveDownHints = null
        var finalDownHints = {}
        adaptiveDownHints = utilObj.getDecryptedData(curCrosswordInfo.do);
        
        

        for(var key in adaptiveDownHints){
            finalDownHints[key] = adaptiveDownHints[key][0];
        }
       
        if(adaptiveContentObj.isEligibleForAdaptive()){
            var gridHeight = curCrosswordInfo.h;
            var gridWidth = curCrosswordInfo.w;
            var bucketNo = 1;
            var noOfCluesToBeSwapped = 0;
            var downSwapList = [];
            if (adaptiveContentObj.isPuzzleSizeEligible(gridHeight, gridWidth) && adaptiveContentObj.isEligbleForClueSwapping()) {
                bucketNo = adaptiveContentObj.getUserCurrentBucket();
                noOfCluesToBeSwapped = adaptiveContentObj.getNumberOfCluesToBeSwapped(bucketNo, gridWidth, gridHeight);
                var { "do": downCluesToSkip } = adaptiveContentObj.getNumCluesToSkip(gridWidth, gridHeight);
                var downHintKeys = Object.keys(adaptiveDownHints).sort(function (a, b) { return parseInt(a) - parseInt(b) });
                downSwapList = downHintKeys.slice(downCluesToSkip);
            }

            // loggerObj.debugLog("DOWN-- isEligibleForSwapping",adaptiveContentObj.isEligbleForClueSwapping());
            // loggerObj.debugLog("DOWN-- BucketNo - NoOfCluesSwapped",bucketNo,noOfCluesToBeSwapped);

            var puzzleFetchTrack = "view1";
            utilObj.shuffleArray(downSwapList);
            // for(var i = 0; i < noOfCluesToBeSwapped ;i++){

                
            //     if(adaptiveDownHints[downSwapList[i]][1] != undefined){
            //         finalDownHints[downSwapList[i]] = adaptiveDownHints[downSwapList[i]][1];

            //         clueSwapTrack += downSwapList[i] + "d-";
            //         puzzleFetchTrack = "view1";
            //     }
            // }

            // Revised Logic for Swapping the clues
            if (noOfCluesToBeSwapped > 0) {
                var cluesSwapped = 0;
                for (var i = 0; i < downSwapList.length; i++) {
                    var clueNumber = downSwapList[i];
                    var clueArr = adaptiveDownHints[clueNumber];
                    var adaptiveClueEntryPresent = clueArr.length >= 2;
                    var validAdaptiveClue = utilObj.isValid(clueArr[1]) && clueArr[1] != "" && (clueArr[0] != clueArr[1]);
                    if (adaptiveClueEntryPresent && validAdaptiveClue) {
                        finalDownHints[clueNumber] = clueArr[1];
                        cluesSwapped += 1;
                        clueSwapTrack += clueNumber + "d-";
                    }
                    if (cluesSwapped == noOfCluesToBeSwapped) {
                        break;
                    }
                }
            }

            /**
             * Tracking added
             */
            var swap_track =  bucketNo + "-" + adaptiveContentObj.getAvgMasteryForContent() + "-" + noOfCluesToBeSwapped;
            trackObj.trackCounter(constantsObj.TRACK_PUZZLE, gameObj.getCurPuzzleTracking(), clueSwapTrack, puzzleFetchTrack,linearLevelObj.getDtc2PuzzleCompleted() + 1 , swap_track, gameObj.getPuzzleSpeciesTracking(), "", "");

        }
        
        // loggerObj.debugLog("ADAPTIVE ::  final DOWN hints func",JSON.stringify(finalDownHints));
        

        if(storedDownClues == null){
            storedDownClues = {};
        }

        if(!(puzzleId in storedDownClues)){

            storedDownClues = null;
            storedDownClues = {};
            
            storedDownClues[puzzleId] = {};
            storedDownClues[puzzleId] = finalDownHints;
        }

        return finalDownHints;

    };

    /**
     * Getter / setter for No of puzzle solved for adaptive clue eligibility
     */
    this.getPuzzlesSolvedForAdaptive = function(){
        return puzzlesSolvedForApadtive;
    };

    this.setPuzzleSolvedForAdaptive = function(){
        puzzlesSolvedForApadtive += 1;
    };

    /**
     * Getter /Setter for puzzle clue Mapping 
     */
    this.getPuzzleMasteryMap = function(){
        return puzzleMasteryMap;
    };

    this.setPuzzleMasteryMap = function(puzzleId , masteryGained){
    
        var obj = {
            id : puzzleId,
            mastery : masteryGained
        };
        
        puzzleMasteryMap.push(obj);
        // loggerObj.debugLog("rere ::",JSON.stringify(puzzleMasteryMap));
    };


    /**
     * Return the Adaptive content varaint
     */
    this.getApadtiveContentVariant = function(){

        // var experimentValue = epmObj.getChosenVariant(constantsObj.ADAPTIVE_CONTENT_EXP);
        // if(experimentValue == constantsObj.EXP_VAR_CONTROL){
        //     return 0;
        // } else if(experimentValue == constantsObj.EXP_VAR_1){
        //     return 1;
        // } else if(experimentValue == constantsObj.EXP_VAR_2) {
        //     return 2;
        // }
        return constantsObj.EXP_VAR_2;
    };



    /**
     * this function checks that if player has played 'n' puzzles to be eligble for adaptive clue swapping
     */
    this.isEligbleForClueSwapping = function () {

        var runtimeValue = adaptiveContentObj.getNumberOfPuzzlesRequired();
        if (adaptiveContentObj.getPuzzlesSolvedForAdaptive() >= runtimeValue) {
            return true;
        }

        return false;
    };

    /**
     * Users current bucket is decided using the avg mastery he has gained in last 'n' puzzles.
     */
    this.getUserCurrentBucket = function(){

        var avgMastery = adaptiveContentObj.getAvgMasteryForContent();

        var expVal = adaptiveContentObj.getApadtiveContentVariant();
        var runtimeValue = runtimeObj.getAvgMasteryForAdaptive();
        var splitStr = runtimeValue.split(":");
        
        
        if(expVal == 1){
            var avgMasteryCheck;
            
            try{
                avgMasteryCheck = parseFloat(splitStr[0]);
            } catch(e){
                avgMasteryCheck = 2.2;
            }

            if(avgMastery < avgMasteryCheck){
                return 1;
            } else if(avgMastery >= avgMasteryCheck){
                return 2;
            }
            return 1;

        } else if(expVal == 2){
            var valuesToUse  = splitStr[1].split("_");

            var avgMasteryCheckLow ;
            var avgMasteryCheckHigh ;
            try {
                avgMasteryCheckLow = parseFloat(valuesToUse[0]);
                avgMasteryCheckHigh = parseFloat(valuesToUse[1]);
            } catch(e) {
                avgMasteryCheckLow = 2
                avgMasteryCheckHigh = 3
            } 
            
            if(avgMastery <= avgMasteryCheckLow) {
                return 1;
            } else if(avgMastery > avgMasteryCheckLow && avgMastery <= avgMasteryCheckHigh){
                return 2;
            } else if(avgMastery > avgMasteryCheckHigh) {
                return 3;
            }

            return 1 ;
        }

    };


    /**
     * Returns The Average Mastery of last n Buckets where n is runtime based .
     */
    this.getAvgMasteryForContent = function(){

        var n = adaptiveContentObj.getNumberOfPuzzlesRequired();
        var totalMastery = 0;
        var puzzleCount = n;

        for(var i = puzzleMasteryMap.length-1; i>=0 ; i--){
            totalMastery += puzzleMasteryMap[i].mastery;
            n -= 1;
            if(n == 0){
                break;
            }
        }
       
        return totalMastery/puzzleCount;
        
    };

    /***
     * Returns The Number of clues to be swapped
     */
    this.getNumberOfCluesToBeSwapped = function(bucketNo , gridWidth , gridHeight){

        var clueArr = [0,1,2];
        /**
         * Logic For bucketing changed in accordance with 3 buckets and var 2
         */

        if(adaptiveContentObj.getApadtiveContentVariant() == constantsObj.EXP_VAR_1){
            
            clueArr = [0,1,2];
            if((gridWidth == 5 && gridHeight == 5)){
                clueArr = [0,1,2];
            } else if((gridWidth == 7 && gridHeight == 7)){
                clueArr = [0,1,3];
            } else if((gridWidth == 9 && gridHeight == 9)) {
                clueArr = [0,2,4];
            } else if(gridWidth >=11 && gridHeight >= 11) {
                clueArr = [0,8,13];
            }

        } else if(adaptiveContentObj.getApadtiveContentVariant() == constantsObj.EXP_VAR_2) {
            
            clueArr = [0,1,2];
            if((gridWidth == 5 && gridHeight == 5)){
                clueArr = [0,1,2];
            } else if((gridWidth == 7 && gridHeight == 7)){
                clueArr = [0,1,2];
            } else if((gridWidth == 9 && gridHeight == 9)) {
                clueArr = [0,1,2];
            } else if(gridWidth >=11 && gridHeight >= 11) {
                clueArr = [0,4,8];
            }
        }

        
        

        // loggerObj.debugLog("ADAPTIVE :: bucket - clueArr",bucketNo , clueArr);
        return clueArr[bucketNo - 1];

    };  

    /**
     * Get Number of puzzle to be solved for adaptive 
     */

    this.getNumberOfPuzzlesRequired = function(){

        var expVal = adaptiveContentObj.getApadtiveContentVariant();
        var runtimeValue = runtimeObj.getPuzzlesRequiredForAdaptive();
        var splitStr = runtimeValue.split(":");

        // loggerObj.debugLog("ADAPTIVE :: NUmber of puzzles required EXP1 Exp2 ->",parseInt(splitStr[0]),parseInt(splitStr[1]));

        if(expVal == 1) {            
            try {
                return parseInt(splitStr[0]);
            } catch(e) {
                return 5;
            }
        } else if(expVal == 2){      
            try {
                return parseInt(splitStr[1]);
            } catch (e) {
                return 5;
            }
        }
        return 5;
    };

    /**
     * To check whether to start adaptive or not 
     * ADAPTIVE_START
     */
    this.isEligibleForAdaptive = function(){

        var expVal = adaptiveContentObj.getApadtiveContentVariant();
        // loggerObj.debugLog("ADAPTIVE :: expVal",expVal);
        
        if(expVal == 0){
            return false;
        }

        var runtimeValue = runtimeObj.getAdaptiveStartVals();
       

        var splitStr = runtimeValue.split(":");
        var arrToUse = splitStr[0];

        if(expVal == 2){
            arrToUse = splitStr[1];
        }
        var splitArr = arrToUse.split("_");
        var userDayNo = gameObj.getDForUserFromCreatedTime(gameObj.getInstallTimeStamp(), utilObj.getCurrentTimestamp());

        // loggerObj.debugLog("ADAPTIVE :: splitArr - userDayNo",parseInt(splitArr[0]) , parseInt(splitArr[1]) ,userDayNo);

        if(userDayNo > parseInt(splitArr[0]) && linearLevelObj.getDtc2PuzzleCompleted() > parseInt(splitArr[1])){
            return true;
        }

        return false;
    };

    /**
     * this function returns number of clues to skip for selecting adaptive clues
     * @param {*} puzGridWidth 
     * @param {*} puzGridHeight 
     * @returns 
     */
    this.getNumCluesToSkip = function (puzGridWidth, puzGridHeight) {
        var skipCluesForAcross = 1;
        var skipCluesForDown = 0
        if (puzGridWidth <= 7) {
            skipCluesForAcross = 1;
            skipCluesForDown = 0;
        } else if (puzGridWidth <= 11) {
            skipCluesForAcross = 1;
            skipCluesForDown = 1;
        } else {
            skipCluesForAcross = 4;
            skipCluesForDown = 4;
        }

        return {
            ac: skipCluesForAcross,
            do: skipCluesForDown
        };
    };

    /**
     * this function checks if puzzle size is eligible for adaptive clue
     * @param {*} gridWidth 
     * @param {*} gridHeight 
     * @returns 
     */
    this.isPuzzleSizeEligible = function (gridWidth, gridHeight) {
        return (gridWidth >= 5 && gridHeight >= 5);
    };
 };