LinearLevel = function () {

    var countries = null;
    var countriesLoaded = false;
    var countryGroups = null;
    var countryGroupsLoaded = false;
    var backgroundInfo = null;
    var backgroundInfoLocal = null;
    var backgroundInfoLoaded = false;
    var backgroundInfoLocalLoaded = false;
    var flagsMonumentsInfo = null;
    var flagsMonumentsLoaded = false;
    var puzzleIdLoaded = false;
    var isCountryInfoMapPopulated = false;
    var countryInfoMap = {};
    var monthNames = ["Jan", "Feb", "Mar", "Apr", "May", "Jun",
        "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];

    var isPuzzleSolvedForToday = false;
    var isDailyPuzzleFtueSeen = false;
    var isCountryUnlockNodeFtueSeen = false;
    var countryLevelArr = [
        {"pc": 5}, {"pc": 10}, {"pc": 10}, {"pc": 10}, {"pc": 10}, {"pc": 10}, {"pc": 10}, {"pc": 10}, {"pc": 10}, {"pc": 10},
        {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20},
        {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20},
        {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20},
        {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20},
        {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20},
        {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20},
        {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20},
        {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20},
        {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20},
        {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20},
        {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20},
        {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 20}, {"pc": 40}, {"pc": 40}, {"pc": 40}, {"pc": 40},
        {"pc": 40}, {"pc": 40}, {"pc": 40}, {"pc": 40}, {"pc": 40}, {"pc": 40}, {"pc": 40}, {"pc": 40}, {"pc": 40}, {"pc": 40},
        {"pc": 40}, {"pc": 40}, {"pc": 40}, {"pc": 40}, {"pc": 40}, {"pc": 40}, {"pc": 40}, {"pc": 40}, {"pc": 40}
    ];

    var puzCompleted = 0; //keeps a track tillwhere last puzzle is completed
    var clickedNodeId = 0;
    // var isEndOfCountry = false;
    // var previousCountryInfo = null;
    var isLevelCoinsAdded = true;
    var isCountryCoinsAdded = true;
    var prevGridHeight = null; // This is stored so as to add coins if coins are not added on previous game play
    var isDailyPuzzleUnLocked = false;
    var activeNodePuzzleStarted = false; // to trigger retarget notifs

    const BLUR_STR_SUFFIX = "_B";

    this.init = function () {

        // For Now
        linearLevelObj.loadPuzzles();
        linearLevelObj.loadListOfPuzzlesInMap();
        linearLevelObj.loadDataForCurrentCountry();

    };

    /**
     * sets/stores value from/to gameData
     */
    this.setValueFromGameData = function (gameData) {
        // if (gameData.isEndOfCountry != undefined) {
        //     isEndOfCountry = gameData.isEndOfCountry;
        // }
        // if (gameData.previousCountryInfo != undefined) {
        //     previousCountryInfo = gameData.previousCountryInfo;
        // }
        if (gameData.puzCompleted != undefined) {
            puzCompleted = gameData.puzCompleted;
        }
        if (gameData.isLevelCoinsAdded != undefined) {
            isLevelCoinsAdded = gameData.isLevelCoinsAdded;
        }
        if (gameData.isCountryCoinsAdded != undefined) {
            isCountryCoinsAdded = gameData.isCountryCoinsAdded;
        }
        if (gameData.clickedNodeId != undefined) {
            clickedNodeId = gameData.clickedNodeId;
        }
        if (gameData.prevGridHeight != undefined) {
            prevGridHeight = gameData.prevGridHeight;
        }
        if (gameData.isDailyPuzzleUnLocked != undefined) {
            isDailyPuzzleUnLocked = gameData.isDailyPuzzleUnLocked;
        }

        if (gameData.activeNodePuzzleStarted != undefined) {
            activeNodePuzzleStarted = gameData.activeNodePuzzleStarted;
        }
    };

    this.getLinearLevelObj = function (gameData) {
        // gameData.isEndOfCountry = isEndOfCountry;
        // gameData.previousCountryInfo = previousCountryInfo;
        gameData.puzCompleted = puzCompleted;
        gameData.isLevelCoinsAdded = isLevelCoinsAdded;
        gameData.isCountryCoinsAdded = isCountryCoinsAdded;
        gameData.clickedNodeId = clickedNodeId;
        gameData.prevGridHeight = prevGridHeight;
        gameData.isDailyPuzzleUnLocked = isDailyPuzzleUnLocked;
        gameData.activeNodePuzzleStarted = activeNodePuzzleStarted;
        gameData.totalPuzzles = linearLevelObj.totalDtc2Puzzles();
        return gameData;
    };

    this.getLinearLevelServerObj = function (gameData) {
        gameData.puzCompleted = puzCompleted + "";
        return gameData;
    };

    /*
         load value from game sync ahead call after possible fb login
      */
    this.setValueFromSyncAhead = function (val) {
        if (val != undefined) {
            puzCompleted = parseInt(val);
        }
    };

    this.getDtc2PuzzleCompleted = function () {
        return puzCompleted;
    };
    this.setDtc2PuzzleCompleted = function () {
        puzCompleted += 1;
    };

    this.getActiveNodePuzzleStarted = function () {
        return activeNodePuzzleStarted;
    };

    this.setActiveNodePuzzleStarted = function (val) {
        activeNodePuzzleStarted = val;
    };
    // this.setEndOfCountryCase = function (val) {
    //     isEndOfCountry = val;
    // };
    // this.getEndOfCountryCase = function () {
    //     //     if(isEndOfCountry){
    //     //         return true;
    //     //     }
    //     //    return false;
    //     return isEndOfCountry;
    // };
    // this.storeCountryInfo = function (val) {
    //     previousCountryInfo = val;
    // };
    // this.retrieveCountryInfo = function () {
    //     return previousCountryInfo;
    // };
    this.getClickedNodeId = function () {
        return clickedNodeId;
    };
    this.setClickedNodeId = function (val) {
        clickedNodeId = val;
    };
    this.getIsLevelCoinsAdded = function () {
        return isLevelCoinsAdded;
    }
    this.setIsLevelCoinsAdded = function (val) {
        isLevelCoinsAdded = val;
    }
    this.getIsCountryCoinsAdded = function () {
        return isCountryCoinsAdded;
    }
    this.setIsCountryCoinsAdded = function (val) {
        isCountryCoinsAdded = val;
    }
    this.setPrevGridHeight = function (val) {
        prevGridHeight = val;
    };
    this.getPrevGridHeight = function () {
        return prevGridHeight;
    };
    this.setIsDailyPuzzleUnLocked = function (val) {
        isDailyPuzzleUnLocked = val;
    };
    this.getIsDailyPuzzleUnLocked = function () {
        return isDailyPuzzleUnLocked;
    };


    /**
     * returns if active node is opened from game layer
     * @param puzzleId
     * @return {boolean}
     */
    this.getPuzzleIdForActiveNodeMatch = function (puzzleId) {
        if (linearLevelObj.getDtc2PuzzleCompleted() == linearLevelObj.totalDtc2Puzzles()) {
            return false;
        }

        var index = linearLevelObj.getDtc2PuzzleCompleted();
        var gameId = linearLevelObj.getPuzzleIdLlp(index);

        if (gameId == puzzleId) {
            return true;
        }

        return false;
    };

    //////////////////////////////////////

    this.loadPuzzles = function () {

        // var countryGroupsUrl = res.country_groups_json;
        var countriesUrl = res.countries_json;
        var backgroundInfoUrl = res.background_info_json;
        var flagsMonumentsInfoUrl = res.dtc2_flags_monuments_info_json;

        downloadManagerObj.loadData("dtc2_countries.json", linearLevelObj.markDataLoadedCountries, countriesUrl);
        downloadManagerObj.loadData("dtc2_flags_monuments_info.json", linearLevelObj.markDataLoadedFlagsMonuments, flagsMonumentsInfoUrl);
        // downloadManagerObj.loadData("dtc2_country_groups.json", linearLevelObj.markDataLoadedCountriesGroups, countryGroupsUrl);
        downloadManagerObj.loadData("dtc2_countries_info.json", linearLevelObj.markDataLoadedBackgroundInfo, backgroundInfoUrl);

        // Initaily 10 backgrounds are loaded localy and not Downloaded
        cc.loader.loadJson(backgroundInfoUrl, function (error, data) {
            if (error == null && data != null) {
                if (!backgroundInfoLocalLoaded) {
                    backgroundInfoLocal = data;
                    backgroundInfoLocalLoaded = true;
                }
            }
        });
    };

    this.populateCountryInfoMapAfterDownload = function () {
        loggerObj.debugLog("DOWNLOAD MANAGER POPULATE INFO")
        var backgroundInfoUrl = res.background_info_json;
        backgroundInfoLoaded = false;
        backgroundInfo = null;
        downloadManagerObj.loadData("dtc2_countries_info.json", linearLevelObj.markDataLoadedBackgroundInfo, backgroundInfoUrl);
        if (flagsMonumentsLoaded && countriesLoaded) {
            countryInfoMap = {};
            isCountryInfoMapPopulated = true;
            for (var index = 0; index < countries.length; index++) {
                var countryCode = countries[index].cc;
                var countryData = flagsMonumentsInfo[countryCode];
                var countryBackgroundImage = backgroundInfo[countryCode]['b'];
                var countryLandmarkImage = countryData.l;
                var puzzleLevel = countries[index].co - countries[index].pc;
                // loggerObj.debugLog("DOWNLOAD MANAGER COUNTRYINFO",countryCode,puzzleLevel);
                if (countryInfoMap[countryBackgroundImage] == undefined) {
                    countryInfoMap[countryBackgroundImage] = puzzleLevel;
                }
                // if (countryInfoMap[countryLandmarkImage] == undefined) {
                //     countryInfoMap[countryLandmarkImage] = puzzleLevel;
                // }
            }
        }
        // loggerObj.debugLog("downloadManager Log: country info map is->", utilObj.getStringifiedJson(countryInfoMap));
    };

    this.markDataLoadedCountries = function (error, data) {
        if (error == null && data != null) {
            if (!countriesLoaded) {
                countries = data;
                // gameObj.updateCurCountry(); // WORK ON THIS FUNCTION LATER IF NEEDED
                countriesLoaded = true;
                // linearLevelObj.populateCountryInfoMapAfterDownload();
            }
        }
    };

    this.markDataLoadedFlagsMonuments = function (error, data) {
        if (error == null && data != null) {
            if (!flagsMonumentsLoaded) {
                flagsMonumentsInfo = data;
                flagsMonumentsLoaded = true;
            }
        }
    };

    // this.markDataLoadedCountriesGroups = function (error, data) {
    //     if (error == null && data != null) {
    //         if (!countryGroupsLoaded) {
    //             countryGroups = data;
    //             countryGroupsLoaded = true;
    //         }
    //     }
    // };

    this.markDataLoadedBackgroundInfo = function (error, data) {
        if (error == null && data != null) {
            if (!backgroundInfoLoaded) {
                backgroundInfo = data;
                backgroundInfoLoaded = true;
            }
        }
    };

    this.isCountryImageReadyToDownload = function (fileName, version) {
        // loggerObj.debugLog("DOWNLOAD MANAGER IS COUNTRY IMAGE READY");
        if (!downloadManagerObj.versionCheck(fileName, version)) {
            loggerObj.debugLog("DOWNLOAD MANAGER IS COUNTRY IMAGE READY FALSEEEE");
            return false;
        }
        var puzzleLevel = parseInt(countryInfoMap[fileName]);
        // var currentPuzzleNumber = gameObj.getPuzCompleted();
        var currentPuzzleNumber = linearLevelObj.getDtc2PuzzleCompleted();
        // loggerObj.debugLog("DOWNLOAD MANAGER IS COUNTRY IMAGE READY True" , puzzleLevel);
        // loggerObj.debugLog("DOWNLOAD MANAGER IS COUNTRY IMAGE READY CURR" , currentPuzzleNumber);
        // loggerObj.debugLog("DOWNLOAD MANAGER IS COUNTRY IMAGE CALLEDD " , puzzleLevel - currentPuzzleNumber);
        return (puzzleLevel - currentPuzzleNumber <= 200); // this is condtion which is checked to download image or not
    };

    // this.getLevelGroups = function () {
    //     return countryGroups;
    // };

    this.getPuzzleIdLlp = function (index) {
        return linearLevelObj.getPuzzleIdForGivenNode();
    };
    this.getTotalNumberOfCountries = function () {
        return constantsObj.TOTAL_NUM_COUNTRIES; // TODO: put in constants
    };

    this.totalDtc2Puzzles = function () {
        if (countries == null || countries.length == 0 || countries[countries.length - 1] == undefined || countries[countries.length - 1].co == undefined) {
            return constantsObj.TOTAL_PUZZLES;
        }
        return countries[countries.length - 1].co;
    };
    this.getLevels = function () {
        return countries;
    };
    this.getCurrentCountryInfo = function (curCountry) {

        var allCountriesInfo = linearLevelObj.getLevels();
        return allCountriesInfo[curCountry - 1];
    };

    this.isEndOfContent = function () {
        var totalPuzzlesCompleted = linearLevelObj.getDtc2PuzzleCompleted();
        if (totalPuzzlesCompleted >= linearLevelObj.totalDtc2Puzzles()) {
            return true;
        }
        return false;
    };

    this.getPuzState = function (puz) {
        var puzState = constantsObj.STATE_PUZ_OPEN;
        var puzCompleted = linearLevelObj.getDtc2PuzzleCompleted();
        if (puz < puzCompleted) {
            puzState = constantsObj.STATE_PUZ_COMPLETED;
        } else if (puz == puzCompleted) {
            puzState = constantsObj.STATE_PUZ_OPEN;
        } else {
            puzState = constantsObj.STATE_PUZ_CLOSED;
        }
        return puzState;
    };
    this.getCurLevel = function () {

        var level = 1;
        var tempArr = [];
        var puzzleCompleted = linearLevelObj.getDtc2PuzzleCompleted() + 1;

        //In case of countries data loading late the info is collected from countryLevelArr;
        if (countries == null) {
            tempArr = countryLevelArr;
        } else {
            tempArr = countries;
        }
        var sum = 0;
        for (var i = 0; i < tempArr.length; i++) {
            sum += tempArr[i].pc;
            if (puzzleCompleted <= sum) {
                return level;
            }
            level++;
        }
        return level; // in case of last puzzle of last country (eoc case) (no of countries + 1 ) level will be returned;
    };
    /**
     * This function logic is in accordance to transOutroLayerV2
     * in which country level is increased before outro on the puzzle completion.
     */
    this.checkEndOfCountryCase = function () {
        var countryNo = linearLevelObj.getCurLevel();
        countryNo -= 1;
        if (countryNo == 0) {
            return false;
        }

        var countryInfo = linearLevelObj.getCurrentCountryInfo(countryNo);
        if (linearLevelObj.getDtc2PuzzleCompleted() == countryInfo["co"]) {
            return true;
        }
        return false;
    };
    this.getCurrCountryPlayerInInfo = function () {

        if (linearLevelObj.getCurLevel() > constantsObj.TOTAL_NUM_COUNTRIES) {
            return {countryName: "", puzzlesIncountry: 0, puzzleIndex: 0};
        }

        var curCountry = linearLevelObj.getCurLevel();
        var allCountriesInfo = linearLevelObj.getLevels();

        var curCountryInfo = allCountriesInfo[curCountry - 1];

        var lastPuzIndex = curCountryInfo["co"];
        var puzStartIndex = lastPuzIndex - curCountryInfo["pc"];

        var curPuzzleIndex = 0;
        var puzState = constantsObj.STATE_PUZ_COMPLETED;

        for (var i = puzStartIndex, puzIndex = 1; i < lastPuzIndex; i++, puzIndex++) {
            puzState = linearLevelObj.getPuzState(i);
            if (puzState == constantsObj.STATE_PUZ_OPEN) {
                curPuzzleIndex = puzIndex;
            }
        }

        return {countryName: curCountryInfo["c"], puzzlesIncountry: curCountryInfo["pc"], puzzleIndex: curPuzzleIndex};

    };
    this.getFlagsMonumentsInfo = function (countryCode) {
        if (countryCode != undefined && flagsMonumentsInfo[countryCode] != undefined) {
            return flagsMonumentsInfo[countryCode];
        }
        // trackObj.trackCounter(constantsObj.TRACK_DEBUG, "bg", "undefined", countryCode + "", "", "", gameObj.getTrackingPuzzleInfo(), "", "");
        return {
            "f": "#flag_australia.png",
            "fV1": "#flag_australiaV1.png",
            "l": "res/png/landmarks/landmark_australia.png"
        };
    };

    this.getBackGroundPath = function (countryCode) {
        // Code For DOWNLOAD Bgs Images
        var fileName = "";
        if (backgroundInfo != null && backgroundInfo != undefined) {
            // loggerObj.debugLog("backGroundPath Log : INFO NOT NULL")
            fileName = backgroundInfo[countryCode]['b'];
            if (downloadManagerObj.isFileDownloaded(fileName)) {
                var urlToUse = downloadManagerObj.getAbsoluteFilePath(fileName);
                if (!jsb.fileUtils.isFileExist(urlToUse)) {
                    downloadManagerObj.setDownloadsMapUndefinedForFile(fileName);
                    fileName = backgroundInfoLocal[countryCode]['b'];
                    urlToUse = "res/png/country_background/" + fileName;
                }
                fileName = urlToUse;
                // loggerObj.debugLog("backGroundPath Log : FILE DOWNLOADED",fileName);
            } else if (!downloadManagerObj.isFileInDownloadList(fileName)) {
                fileName = backgroundInfoLocal[countryCode]['b'];
                fileName = "res/png/country_background/" + fileName;
                // loggerObj.debugLog("backGroundPath Log : FILE DOWNLOADED LIST",fileName);
            } else {
                fileName = backgroundInfoLocal[countryCode]['b'];
                fileName = "res/png/country_background/" + fileName;
                // loggerObj.debugLog("backGroundPath Log : FILE DOWNLOADED ELSE",fileName);
            }
        } else if (backgroundInfoLocal != null && backgroundInfoLocal != undefined) {
            fileName = backgroundInfoLocal[countryCode]['b'];
            fileName = "res/png/country_background/" + fileName;
            // loggerObj.debugLog("backGroundPath Log : FILE FROM LOCAL",fileName);
        } else {
            return constantsObj.COUNTRY_GENRIC_BG;
        }
        return fileName;
    };

    /***
     * Returns the theme info for the curr country
     */
    this.getBgThemeInfo = function (countryCode) {

        var themeObj = {};
        themeObj.filename = "";
        themeObj.tc = "";
        var localFileName = linearLevelObj.deriveBlurBgFilename(backgroundInfoLocal[countryCode]['b']);

        if (backgroundInfo != null && backgroundInfo != undefined) {

            if (!backgroundInfo.hasOwnProperty(countryCode)) {
                backgroundInfo[countryCode] = backgroundInfoLocal[countryCode];
            }

            var downloadedFileName = linearLevelObj.deriveBlurBgFilename(backgroundInfo[countryCode]['b']);

            themeObj.filename = downloadedFileName;
            themeObj.tc = backgroundInfoLocal[countryCode]['tl'];
            realisticBgObj.setIsBgFromServer(true);

            if (downloadManagerObj.isFileDownloaded(themeObj.filename)) {
                var urlToUse = downloadManagerObj.getAbsoluteFilePath(themeObj.filename);
                if (!jsb.fileUtils.isFileExist(urlToUse)) {
                    downloadManagerObj.setDownloadsMapUndefinedForFile(themeObj.filename);
                    themeObj.filename = localFileName;
                    urlToUse = "res/png/country_realistic_bgs/" + themeObj.filename;
                    themeObj.tc = backgroundInfoLocal[countryCode]['tl'];
                    realisticBgObj.setIsBgFromServer(false);
                }
                themeObj.filename = urlToUse;

            } else if (!downloadManagerObj.isFileInDownloadList(themeObj.filename)) {
                themeObj.filename = localFileName;
                themeObj.filename = "res/png/country_realistic_bgs/" + themeObj.filename;
                themeObj.tc = backgroundInfoLocal[countryCode]['tl'];
                realisticBgObj.setIsBgFromServer(false);

            } else {
                themeObj.filename = localFileName;
                themeObj.filename = "res/png/country_realistic_bgs/" + themeObj.filename;
                themeObj.tc = backgroundInfoLocal[countryCode]['tl'];
                realisticBgObj.setIsBgFromServer(false);

            }
        } else if (backgroundInfoLocal != null && backgroundInfoLocal != undefined) {
            themeObj.filename = "res/png/country_realistic_bgs/" + localFileName;
            themeObj.tc = backgroundInfoLocal[countryCode]['tl'];
            realisticBgObj.setIsBgFromServer(false);

        } else {
            themeObj.filename = realisticBgObj.DEFAULT_THEME_BLUR_BG;
            themeObj.tc = realisticBgObj.DEFAULT_THEME_COLOR;
            realisticBgObj.setIsBgFromServer(false);

        }
        return themeObj;
    };

    /**
     * 
     * @param {*} fileName 
     * @returns the mapped file name which is derived from blur bg name
     */
    this.deriveBlurBgFilename = function (fileName) {
        var fileNameSplitArr = fileName.split(".");
        var fileNameReq = fileNameSplitArr[0]  + BLUR_STR_SUFFIX + "." + fileNameSplitArr[1];
        return fileNameReq;
    };

    this.updateTheNode = function () {

        linearLevelObj.setDtc2PuzzleCompleted();
        linearLevelObj.setActiveNodePuzzleStarted(false);
        // try loading json file for country after every puzzle complete
        linearLevelObj.loadDataForCurrentCountry();

    };
    this.getCurrentMonth = function (val) {
        return monthNames[val];
    };
    this.getLevelCompleteReward = function (gridheight) {

        // var reward ;
        // if(gridheight <= 5){
        //     reward = runtimeObj.getMiniReward();
        // } else if(gridheight >= 6 && gridheight <= 9){
        //     reward = runtimeObj.getMidiReward();
        // } else {
        //     reward = runtimeObj.getBigReward();
        // }
        // return reward;

        if (gridheight <= 5) {
            return economyObj.getPriceForHints(constantsObj.MINI_LEVEL_REWARD);
        } else if (gridheight >= 6 && gridheight <= 9) {
            return economyObj.getPriceForHints(constantsObj.MIDI_LEVEL_REWARD);
        } else {
            return economyObj.getPriceForHints(constantsObj.BIG_LEVEL_REWARD);
        }

    };
    this.getCountryCompleteReward = function () {
        return economyObj.getPriceForHints(constantsObj.COUNTRY_COMPLETE_REWARD);
    };

    /**********************
     * CONTENT INTEGRATION
     *************************/

    var urlForPuzzleCountryJson = "res/puzzlesCountryJson/";
    var prefixForCountryJson = "puzzlesData_";
    var siffixForCountryJson = "_enc.json";
    var siffixForCountryJson_v1 = "_enc_v1.json";
    var siffixForCountryJson_new = "_enc_new.json";
    var puzzleIdsListJson = "res/countryPuzzleSequenceAll55.json";
    var puzzleIdsListJsonNew = "res/countryPuzzleSequenceAll_new.json";
    var puzzleIdsListJson_v1 = "res/countryPuzzleSequenceAll55_v1.json";
    var listOfPuzzleIds = {};
    var puzzlesCountryData = {};
    var totalCountries = constantsObj.TOTAL_NUM_COUNTRIES;

    /**
     * loads list of ids in map
     */
    this.loadListOfPuzzlesInMap = function () {
        // var jsonUrl = puzzleIdsListJson;
        // if (gameObj.getNewUserContentBuild()) {
        //     jsonUrl = puzzleIdsListJsonNew;
        // }
        var jsonUrl = puzzleIdsListJson_v1;
        try {
            cc.loader.loadJson(jsonUrl, function (error, data) {
                listOfPuzzleIds = data;
            });
        } catch (e) {
            loggerObj.errorLog("Exception while loading json:", e);
        }
    };

    /**
     * loads the puzzle json for the country number passed from jsons
     * @param currentCountry country to load json for
     */
    this.loadPuzzlesForCountry = function (currentCountry) {
        // var jsonUrl = urlForPuzzleCountryJson + prefixForCountryJson + currentCountry + siffixForCountryJson;
        // if (gameObj.getNewUserContentBuild()) {
        //     jsonUrl = urlForPuzzleCountryJson + prefixForCountryJson + currentCountry + siffixForCountryJson_new;
        // }

        var jsonUrl = urlForPuzzleCountryJson + prefixForCountryJson + currentCountry + siffixForCountryJson_v1;
        try {
            cc.loader.loadJson(jsonUrl, function (error, data) {
                if (error == null) {
                    puzzlesCountryData[currentCountry] = data;
                }
            });
        } catch (e) {
            loggerObj.errorLog("Exception while loading json:", e);
        }


    };

    /**
     * loads json for current country and next country
     * TODO: add this funtion call on fb login case if users skips to higher level
     */
    this.loadDataForCurrentCountry = function () {
        var curCountry = linearLevelObj.getCurLevel();

        if (!puzzlesCountryData[curCountry]) {
            linearLevelObj.loadPuzzlesForCountry(curCountry);
        }

        if (curCountry + 1 <= totalCountries) {
            curCountry += 1;
            if (!puzzlesCountryData[curCountry]) {
                linearLevelObj.loadPuzzlesForCountry(curCountry);
            }
        }
    };

    /**
     * returns cr for the current node puzzle id to the helper fns
     * @return {*} puzzle id
     */
    this.getPuzzleIdForGivenNode = function () {
        var curCountry = linearLevelObj.getCurLevel();

        var allCountriesInfo = linearLevelObj.getLevels();

        var curCountryInfo = allCountriesInfo[curCountry - 1];

        var lastPuzIndex = curCountryInfo["co"];
        var puzStartIndex = lastPuzIndex - curCountryInfo["pc"];

        var curPuzzleIndex = 0;
        var puzState = constantsObj.STATE_PUZ_COMPLETED;

        for (var i = puzStartIndex, puzIndex = 1; i < lastPuzIndex; i++, puzIndex++) {
            puzState = linearLevelObj.getPuzState(i);
            if (puzState == constantsObj.STATE_PUZ_OPEN) {
                curPuzzleIndex = puzIndex;
            }
        }
        // loggerObj.debugLog("contentLog:", index, curPuzzleIndex);

        if (listOfPuzzleIds[curCountry]) {
            var pzid = listOfPuzzleIds[curCountry][curPuzzleIndex - 1];
            return pzid[0];
            // loggerObj.debugLog("contentLog: id is", listOfPuzzleIds[curCountry], pzid);
        } else {
            return "00000001";
        }
    };

    this.getCrForGivenNode = function () {

        if (linearLevelObj.getCurLevel() > constantsObj.TOTAL_NUM_COUNTRIES) {
            return undefined;
        }
        var curCountry = linearLevelObj.getCurLevel();
        var allCountriesInfo = linearLevelObj.getLevels();

        var curCountryInfo = allCountriesInfo[curCountry - 1];
        var lastPuzIndex = curCountryInfo["co"];
        var puzStartIndex = lastPuzIndex - curCountryInfo["pc"];

        var curPuzzleIndex = 0;
        var puzState = constantsObj.STATE_PUZ_COMPLETED;

        for (var i = puzStartIndex, puzIndex = 1; i < lastPuzIndex; i++, puzIndex++) {
            puzState = linearLevelObj.getPuzState(i);
            if (puzState == constantsObj.STATE_PUZ_OPEN) {
                curPuzzleIndex = puzIndex;
            }
        }

        if (listOfPuzzleIds[curCountry]) {
            var pzid = listOfPuzzleIds[curCountry][curPuzzleIndex - 1];
            return pzid[1];
            // loggerObj.debugLog("contentLog: id is", listOfPuzzleIds[curCountry], pzid);
        } else {
            return "102";
        }
    };


    /**
     * returns the json data for the specific puzzle id to showCrossword
     * @param date data to get for
     * @return {*} json for crossword
     */
    this.getPuzzleInfoForDate = function (date) {
        var curCountry = linearLevelObj.getCurLevel();
        if (puzzlesCountryData[curCountry]) {
            loggerObj.debugLog("contentLog: yoyo", date, curCountry, puzzlesCountryData[curCountry]);
            return puzzlesCountryData[curCountry][date];
        }

        return null;
    };

    /*************
     * END CONTENT
     **************/

    this.getisPuzzleSolvedForToday = function () {
        return isPuzzleSolvedForToday;
    };

    this.setisPuzzleSolvedForToday = function (val) {
        isPuzzleSolvedForToday = val;
    };

    this.getIsDailyPuzzleFtueSeen = function () {
        return isDailyPuzzleFtueSeen;
    };

    this.setIsDailyPuzzleFtueSeen = function (val) {
        isDailyPuzzleFtueSeen = val;
    };

    /**
     * returns if daily puzzle ftue can be seen on llp
     * @return {boolean}
     */
    this.canShowDailyPuzzleFtue = function () {
        var stateofDailyPuzzle = linearLevelProgression.getStateOfDailyPuzzle();

        /**
         * If puzzle is completed for that day then donot show the ftue
         */
        var puzzleId = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
        puzzleId = stringsObj.mini_prefix + puzzleId.substr(2, puzzleId.length);

        var ifPuzzleCompleted = gameObj.getPuzzleCompleted(puzzleId);
        if (ifPuzzleCompleted) {
            return false;
        }

        if (stateofDailyPuzzle != constantsObj.STATE_LOCKED && !isDailyPuzzleFtueSeen) {
            return true;
        }

        return false;
    };

    this.getIsCountryUnlockNodeFtueSeen = function () {
        return isCountryUnlockNodeFtueSeen;
    };

    this.setIsCountryUnlockNodeFtueSeen = function (val) {
        isCountryUnlockNodeFtueSeen = val;
    };

    this.canShowCountryUnlockFtue = function () {
        return false ;
        var currentCountry = linearLevelObj.getCurLevel();
        if (currentCountry >= 2 && !isCountryUnlockNodeFtueSeen) {
            return true;
        }

        return false;
    };

    this.openCurrPuzz = function () {
        var index = linearLevelObj.getDtc2PuzzleCompleted();
        var gameId = linearLevelObj.getPuzzleIdLlp(index);
        linearLevelObj.setClickedNodeId(gameId);
        gameLayer.show(gameId);
    };


    /**
     * Below Function will check and redirect the player 
     */
    this.checkAndDirectForEoc = function () {
        var puzzleId = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
        puzzleId = stringsObj.mini_prefix + puzzleId.substr(2, puzzleId.length);
        loggerObj.debugLog("EOC :: puzzleId",puzzleId);
        var ifPuzzleCompleted = gameObj.getPuzzleCompleted(puzzleId);
        if (ifPuzzleCompleted) {
            linearLevelProgression.show();
            return;
        }

        if (gameObj.getCrosswordForDate(puzzleId) == null) {
            // ftueObj.setDailyMiniFtueShown(true);
            linearLevelProgression.show();
            return;
        }

        gameLayer.show(puzzleId);
    };


    /**
     * ************* HELPS IN SKIPPING THE COUNTRY ***************
     */
     this.skipCountry = function () {
        var countryNo = linearLevelObj.getCurLevel();
        var currCountryInfo = linearLevelObj.getCurrentCountryInfo(countryNo);
        var jumpToPuzzNum = currCountryInfo["co"];
        if (jumpToPuzzNum != undefined) {
            puzCompleted = parseInt(jumpToPuzzNum);
        }

        var index = linearLevelObj.getDtc2PuzzleCompleted();
        var gameId = linearLevelObj.getPuzzleIdLlp(index);
        linearLevelObj.setClickedNodeId(gameId);

        // try loading jsons if not loaded for puzzles
        linearLevelObj.loadDataForCurrentCountry();

        linearLevelProgression.redraw();

    };

     /**
     * ************* HELPS IN SKIPPING THE COUNTRY ***************
     */
    this.skipCountry = function () {
        var countryNo = linearLevelObj.getCurLevel();
        var currCountryInfo = linearLevelObj.getCurrentCountryInfo(countryNo);
        var jumpToPuzzNum = currCountryInfo["co"];
        loggerObj.debugLog("JUMP :: jumpToPuzzNum", jumpToPuzzNum);
        if (jumpToPuzzNum != undefined) {
            puzCompleted = parseInt(jumpToPuzzNum);
        }

        var index = linearLevelObj.getDtc2PuzzleCompleted();
        var gameId = linearLevelObj.getPuzzleIdLlp(index);
        linearLevelObj.setClickedNodeId(gameId);

        // try loading jsons if not loaded for puzzles
        linearLevelObj.loadDataForCurrentCountry();

        linearLevelProgression.redraw();

    };

    /**
    * magic functionality for skipping n nodes
    */
    this.skipNodes = function (n) {
        puzCompleted += n;
        var index = linearLevelObj.getDtc2PuzzleCompleted();
        var gameId = linearLevelObj.getPuzzleIdLlp(index);
        linearLevelObj.setClickedNodeId(gameId);

        // try loading jsons if not loaded for puzzles
        linearLevelObj.loadDataForCurrentCountry();
        linearLevelProgression.redraw();
    };

    /**
     * Wrapper function returning if user is eoc user
     * @returns {Booleam}
     */
    this.getIsEocUser = function () {
        var curCountry = linearLevelObj.getCurLevel();
        var totalCountries = linearLevelObj.getTotalNumberOfCountries();
        var isEocUser = false;
        if (curCountry > totalCountries) {
            isEocUser = true;
        }
        return isEocUser;
    };
};