QuestCenter = function(){

    var puzzleSolvingStreakCount = 0;
    var lastPuzzleSolvedTime = 0;
    var isStreakCountInc = false;
    var showNewJewel = false;
    var showClaimJewel = 0;
    var questInfo = {};
    var completedQuestArr = [];
    /**
     * initialising variables here
     */
    this.init = function() {

    };

    /**
     * set/stores values from/to gameData
     */
    this.setValueFromGameData = function(gameData) {

        if (gameData.puzzleSolvingStreakCount != undefined) {
            puzzleSolvingStreakCount = gameData.puzzleSolvingStreakCount;
        }
        if (gameData.lastPuzzleSolvedTime != undefined) {
            lastPuzzleSolvedTime = gameData.lastPuzzleSolvedTime;
        }
        if (gameData.isStreakCountInc != undefined) {
            isStreakCountInc = gameData.isStreakCountInc;
        }
        if (gameData.questInfo != undefined) {
            questInfo = gameData.questInfo;
        }
    };

    this.getQuestCenterObject = function(gameData) {

        gameData.puzzleSolvingStreakCount = puzzleSolvingStreakCount;
        gameData.lastPuzzleSolvedTime = lastPuzzleSolvedTime;
        gameData.isStreakCountInc = isStreakCountInc;
        gameData.questInfo = questInfo;
        return gameData;
    };

    this.setIsStreakCountInc = function(val){
        isStreakCountInc = val;
    };

    this.getIsStreakCountInc = function(val){
        return isStreakCountInc;
    }

    this.setLastPuzzleSolvedTime = function(){
        lastPuzzleSolvedTime = utilObj.getCurrentTimestamp();
    };

    /**
     * The streak updted whenever a puzzle is played on a day , so on day 0 it gets updated and on the day after 
     * player brokes the streak and enters after dayDiff > 1 . And streak increments on consective days puzzles are solved.
     *
     */
    this.checkAndUpdatePuzzleStreak = function(isFromUpdateDailyInfo){

        var currentTime = utilObj.getCurrentTimestamp();
        var currentDate = new Date(currentTime * 1000);
        var lastPuzzleSolvedDate = new Date(lastPuzzleSolvedTime * 1000);
        var daysDiff = utilObj.getDaysDiff(currentDate, lastPuzzleSolvedDate);
        
        if(daysDiff == 0 && !questCenterObj.getIsStreakCountInc()){
            puzzleSolvingStreakCount += 1;
            questCenterObj.setIsStreakCountInc(true);
        }else if(daysDiff == 1 && !isFromUpdateDailyInfo){
            puzzleSolvingStreakCount += 1;
        } else if(daysDiff > 1){
            puzzleSolvingStreakCount = 0;
            questCenterObj.setIsStreakCountInc(false);
        }
        if(!isFromUpdateDailyInfo){
            lastPuzzleSolvedTime = utilObj.getCurrentTimestamp();
        }
        
    };
    /**
     * 
     * Below Functions are for the PSPN team to be used for Quest Center 
     */

    // No of crosswords player has cleared 
    this.noOfCrossWordsCleared = function(){
        return linearLevelObj.getDtc2PuzzleCompleted();
    };

    // Whether the player is fb connected
    this.isFbConnected = function(){
        if(fbWrapperObj.isLoggedIn()){
            return true;
        }
        return false;
    };

    // Have we reached the invite friend limit
    this.canInviteFriends = function(){
        return gameObj.getRefCount() < constantsObj.MAX_REFERRAL_COUNT;
    };

    // No of friends player has invited
    this.noOfFriendsInvited = function(){
        return gameObj.getRefCount();
    };

    // No of days in a row has the player solved crossword
    this.puzzleSolvedStreak = function(){
        return puzzleSolvingStreakCount;
    };

    // no of consecutive days has the player come in the game
    this.noOfConsectiveLogins = function(){
        return gameObj.getConsecutiveLogins();
    };

    // Whether to show video achievement or not
    this.toShowVideoAchievement = function(){
        return true;
    };

    //  to show complete the tutorial achievement
    this.toShowTutorialAchievement = function(){
        var puzzleFtueExp = epmObj.getChosenVariant(constantsObj.EXP_PUZZLE_FTUE);
        if(puzzleFtueExp == constantsObj.EXP_VAR_CONTROL){
            return true;
        }
        return false;
    };

    // No of coins per Dollar value 
    this.numberOfCoinsPerDollarValue = function(){
//        var pkgs = [];
//        pkgs = paymentsObj.getCashPackages();
//        var basePkgPrice = pkgs[0].priceNumeric;
//
//        var experimentValue = epmObj.getChosenVariant(constantsObj.EXP_PRICING_HINTS_FINAL);
//        var runtimeValue = runtimeObj.getPricingExpCoins();
//        var splitStr = runtimeValue.split(":");
//        var arrToUse = splitStr[0];
//        if (experimentValue == constantsObj.EXP_VAR_1) {
//            arrToUse = splitStr[1];
//        }
//
//        var splitStrIn = arrToUse.split("_");
//
//        var coinsPerBasePkg =  parseInt(splitStrIn[0]) / basePkgPrice;
//        coinsPerBasePkg = Math.trunc(coinsPerBasePkg);
//
//        return coinsPerBasePkg;
        return 100;
    };

    this.getQuestCenterVariant = function(){
        
        var experimentValue = epmObj.getChosenVariant(constantsObj.EXP_QC_GAME);
        if(experimentValue == constantsObj.EXP_VAR_1){
            return 1;
        }
        return 0;
    };
    /**
     *
     * Below Functions are callbacks that happen from the Flutter Quest Center
     */

    // Handle any notification / label change for the quests completed, active or claimed
    //
    // NOTE : shouldShowNewTag is a boolean value which is true in the following conditions
    //          1. When the quest center is loaded in the backend for the first time (ideally just after fresh install)
    //          2. When the quest center configuration is changed in the backend
    this.handleQuestNotifSurfacing = function(shouldShowNewTag, completedQuests, activeQuests, claimedQuests) {

        if(questCenterObj.getQuestCenterVariant() == 1){
            // As per spec, "new" tag should be shown after the completion of a quest and if the qc has never been opened before
            var lastOpened = questsObj.getQuestCenterLastOpenedTS();
            showNewJewel = shouldShowNewTag && completedQuests.length > 0 && (lastOpened == null || lastOpened == "");

            showClaimJewel = completedQuests.length;
            completedQuestArr = completedQuests;

            if(curScreen == constantsObj.SCREEN_LINEAR_PROGRESSION){
                
                utilObj.updateJewelNotifTop(linearLevelProgression.jewelIconTop1 ,linearLevelProgression.jewelLabelTop1);
                linearLevelProgression.updateJewelNotifBottom();

            } else if(curScreen == constantsObj.SCREEN_LANDING){
                // landingScreenLayer.updateJewelNotifTop();
                utilObj.updateJewelNotifTop(landingScreenLayer.jewelIconTop , landingScreenLayer.jewelLabelTop);
            } else if(curScreen == constantsObj.SCREEN_GAME){
                utilObj.updateJewelNotifTop(gameLayer.jewelIconTop , gameLayer.jewelLabelTop);
            }


        }
        
    };

    // Handle any notification when the quest gets completed
    this.handleQuestCompleteSurfacing = function(questId, questDescription, questIcon, questReward) {
        
        if(questCenterObj.getQuestCenterVariant() == 1){
            var questObj = {
                id : questId,
                desc : questDescription,
                icon : questIcon,
                reward : questReward,
                isClaimed : false
            };
                
            // questInfo.push(questObj);
            questInfo[questId] = questObj;
            // loggerObj.debugLog("hehe 100000",JSON.stringify(questInfo) , Object.keys(questInfo).length ,JSON.stringify(questInfo[questId]),questInfo[questId].desc);
        }
       
    };


    this.showJewelNotif = function(){
       
        var experimentValue = epmObj.getChosenVariant(constantsObj.EXP_QC_GAME);
        if(experimentValue == constantsObj.EXP_VAR_1){
            if(showNewJewel){
                return 0;
            } else if(showClaimJewel > 0){
                return showClaimJewel;
            } else {
                return -1;
            }
        } else {
            return -1;
        }
        
    };

    // Handle when the quest center is exited
    this.handleQuestCenterExit = function(fromBackButton) {
        
        if(questCenterObj.getQuestCenterVariant() == 1){
            if(curScreen == constantsObj.SCREEN_LINEAR_PROGRESSION){
                
                utilObj.updateJewelNotifTop(linearLevelProgression.jewelIconTop1 ,linearLevelProgression.jewelLabelTop1);
                linearLevelProgression.updateJewelNotifBottom();
                
            } else if(curScreen == constantsObj.SCREEN_SETTINGS){
                if(utilObj.getLastScreen() == constantsObj.SCREEN_LANDING){
                    
                    utilObj.updateJewelNotifTop(landingScreenLayer.jewelIconTop , landingScreenLayer.jewelLabelTop);
    
                } else if(utilObj.getLastScreen() == constantsObj.SCREEN_LINEAR_PROGRESSION){
                    
                    utilObj.updateJewelNotifTop(linearLevelProgression.jewelIconTop1 ,linearLevelProgression.jewelLabelTop1);
                    linearLevelProgression.updateJewelNotifBottom();

                } else if(utilObj.getLastScreen() == constantsObj.SCREEN_GAME){
                    
                    utilObj.updateJewelNotifTop(gameLayer.jewelIconTop , gameLayer.jewelLabelTop);
                }    
            }
            
            if(fromBackButton){
                trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1,"quest_center", "back","", "", "", "");

            }
        }
        
    };

    // Handle when the invite quest in the quest center gets clicked
    this.handleQuestCenterInvite = function() {
        questCenterObj.handleQuestCenterExit(false); // This is to ensure the notifs get updated correctly
        
        var screenFrom = constantsObj.SCREEN_LINEAR_PROGRESSION;
        if(curScreen == constantsObj.SCREEN_SETTINGS) {
            screenFrom = utilObj.getLastScreen();
        }
        // popupLayer.closeWithDefault();
        freeCoins2Popup.show(true, screenFrom);
    };

    // Handle when the watch video quest in the quest center gets clicked  handleQuestCenterVideo
    this.handleQuestCenterVideo = function() {
        questCenterObj.handleQuestCenterExit(false); // This is to ensure the notifs get updated correctly

        // if(curScreen == constantsObj.SCREEN_LINEAR_PROGRESSION){
        //     linearLevelProgression.freeVideoFunc();
        // } else if (curScreen == constantsObj.SCREEN_SETTINGS) {
        //     if(utilObj.getLastScreen() == constantsObj.SCREEN_LANDING){
        //         // if (utilObj.isNodeValid(curLayer)) {
        //         //     curLayer.hide();
        //         // }
        //         // linearLevelProgression.show();
        //         // linearLevelProgression.freeVideoFunc();
        //         loggerObj.debugLog("rtrt : 2");
        //         landingScreenLayer.freeVideoFunc();
        //     } else if (utilObj.getLastScreen() == constantsObj.SCREEN_LINEAR_PROGRESSION) {
        //         loggerObj.debugLog("rtrt : 3");
        //         linearLevelProgression.freeVideoFunc();
        //     } else if (utilObj.getLastScreen() == constantsObj.SCREEN_GAME) {
        //         loggerObj.debugLog("rtrt : 4");
        //         gameLayer.freeVideoFunc();
        //     }
        // }
        if(curScreen == constantsObj.SCREEN_LINEAR_PROGRESSION){
            linearLevelProgression.freeVideoFunc();
        } else if(curScreen == constantsObj.SCREEN_LANDING){
            landingScreenLayer.freeVideoFunc();
        } else if(curScreen == constantsObj.SCREEN_GAME){
            gameLayer.watchToEarn();
        }
    };

    // Handle when the offerwall quest is clicked
    this.handleQuestCenterOfferwall = function() {
        questCenterObj.handleQuestCenterExit(false);
        achievementsObj.performCtaActionForOfferwall();
    }

    /**
     * Quest Completion Surfacing 
     */
    this.toShowQuestCompletionAnim = function(){
        
        if(completedQuestArr.length > 0 && Object.keys(questInfo).length > 0){ // PUT A CONDITION THAT QUEST INFO ARRAY IS ALSO NOT  EMPTY because completedQuestArr will be full untill that quest is not claimed .
            return true;
        }
        return false;
    };

    this.getQuestToShow = function(){

        for(var i = 0; i<completedQuestArr.length;i++){
            
            var questCompletedId  = completedQuestArr[i];


            if(questInfo[questCompletedId] != null && !questInfo[questCompletedId].isClaimed){
                questInfo[questCompletedId].isClaimed = true;
                var questToReturn = questInfo[questCompletedId];
                delete questInfo[questCompletedId];
                return questToReturn;
            }
        }
        return null;
    };

    /**
     * Notif surfacing tracking on different screens.
     */
    this.notifSurfacingTracking = function(){
        var notifState = "QC_notif";
        
        if(!showNewJewel){
            notifState = "QC_notif_update";
        }

        var questId = "";
        if(completedQuestArr.length != 0){
            questId = completedQuestArr[completedQuestArr.length - 1];
        }
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(),linearLevelObj.getDtc2PuzzleCompleted() + 1,notifState,questId,utilObj.getScreenName(curScreen),questCenterObj.questCenterState(), "", "");
    };

    this.questCenterState = function(){
        var qcState = "";
        qcState += completedQuestArr.length;
        if(showNewJewel){
            qcState += "_1";
        } else {
            qcState += "_0";
        }
        
        return qcState;
    }
};
