RealisticBg = function () {

    var themesData = {};
    var isThemesDataLoaded = false;
    this.DEFAULT_THEME_COLOR = "purple";
    this.DEFAULT_THEME_BLUR_BG = "res/png/country_realistic_bgs/DailyPuzzle_B.webp";
    var currThemeInfo = {};
    var isBgFromServer = false;

    this.CLASSIC_THEME_KEY = "classic";
    /***
     * Initialiser
     */
    this.init = function () {
        realisticBgObj.loadThemesJson();
    };

    /***
     * sets/stores value from/to gameData
     */
    this.setValueFromGameData = function () {

    };

    this.getRealisticBgObj = function () {

    };

    /**
     * Below loads the themes data from themes json
     */
    this.loadThemesJson = function () {
        var themeJsonUrl = res.themse_info_json;
        try {
            cc.loader.loadJson(themeJsonUrl, function (error, data) {
                if (error == null && data != null) {
                    if (!isThemesDataLoaded) {
                        themesData = data;
                        isThemesDataLoaded = true;
                        // loggerObj.debugLog("realisticBg :: themesData loaded ->", JSON.stringify(themesData));
                    }
                }
            })
        } catch (e) {
        
        }
       
    };

    /***
     * Below function sets theme for currInfo of the puzzle
     */
    this.setRealisticBgInfoMap = function () {
        var themeInfo = {};
        // Daily Puzzle check for theme info
        if (gameObj.isOnDailyPuzzle()) {
            themeInfo = realisticBgObj.getDefaultThemeInfo();
        } else {
            var countryNo = linearLevelObj.getCurLevel();
            var currCountryInfo = linearLevelObj.getCurrentCountryInfo(countryNo);
            var currentBgThemeInfo = linearLevelObj.getBgThemeInfo(currCountryInfo["cc"]);
            themeInfo = realisticBgObj.getThemeInfo(currentBgThemeInfo);
        }

        // if (limitedKeyboardObj.getIsSkClassicThemeOpted()) {
        //     var classicThemeInfo = realisticBgObj.getThemeInfo(realisticBgObj.getClassicBgThemeInfo());
        //     if (utilObj.isValid(themeInfo) && psUtilObj.isValid(themeInfo["b"])) {
        //         classicThemeInfo["b"] = themeInfo["b"];
        //     }
        //     themeInfo = classicThemeInfo;
        // }
        currThemeInfo = themeInfo;
    };

    /**
     * 
     * @returns currThemeInfo for the current puzzle
     */
    this.getRealisticBgInfoMap = function () {
        return currThemeInfo;
    };

    /***
     * Below returns the theme info for particular theme key
     */
    this.getThemeInfo = function (themeInfo) {
        var themeKey = themeInfo["tc"];
        var bgFile = themeInfo["filename"];

        if (utilObj.isValid(themesData) && (themeKey in themesData)) {
            var info = themesData[themeKey];
            info["b"] = bgFile;
            info["tc"] = themeKey;
            // loggerObj.debugLog("realisticBg :: themeKey in themesData");
            return info;
        } else {
            // loggerObj.debugLog("realisticBg :: themesData null or undefined");
            return realisticBgObj.getDefaultThemeInfo();
        }
    };

    /**
     * Below is used for theme for daily puzzle and default theme
     */
    this.getDefaultThemeInfo = function () {
        var allThemeInfo = {};
        allThemeInfo["b"] = "res/png/country_realistic_bgs/DailyPuzzle_B.webp"; // backgrung image
        allThemeInfo["tc"] = "purple"; // Theme color
        allThemeInfo["tbg"] = "res/png/themes/BG_purple.png"; // Gradient theme for intro and outro
        allThemeInfo["gr"] = "res/png/themes/gradient_purple.png"; // overlay graidient for game Layer
        allThemeInfo["lc"] = "2b2657"; // lb lite bg color
        allThemeInfo["tb"] = "403783"; // top bar color
        allThemeInfo["cc"] = "403783"; // clue bar color
        allThemeInfo["rc"] = "07041c"; // review screen color
        allThemeInfo["fc"] = "b7adff"; // font color
        allThemeInfo["tc2"] = "382d81"; //Theme Color For var8 of limited keyboard (color is same for top bar/clue bar and keyboard bg)
        allThemeInfo["ak2"] = "#purple_tile_v2.png"; // Keyboard alphabets tiles bg used for var 8 of limited keyboard
        allThemeInfo["kc2"] = "6e69f0";//Tile Tap color for keypopup bg used for var8 of limited keyboard
        allThemeInfo["nbg"] = "notifBg_purple.png";// Tile background used in case of in game notifs 
        return allThemeInfo;
    };
    
    this.getIsBgFromServer = function () {
        return isBgFromServer;
    };

    this.setIsBgFromServer = function (val) {
        isBgFromServer = val;
    };

    /**
     * Returing default fileaname value in case of classic theme to incorporate it with current infra
     * @returns 
     */
    this.getClassicBgThemeInfo = function () {
        return {
            "filename" : "res/png/country_realistic_bgs/8_USA_B.webp",
            "tc" : realisticBgObj.CLASSIC_THEME_KEY
        }
    };
}