/*
 created on 22nd April by Panwar
 */

XpProgression = function(){

    var xpCount = 0;
    var xpLevel = 1;
    var xpInCurrentLevel = 0;
    /**
     * initializing variables here
     */
    this.init = function () {

    };

    /**
     * sets/stores value from/to gameData
     */
    this.setValueFromGameData = function (gameData) {
        if (gameData.xpCount) {
            xpCount = gameData.xpCount;
        }
        if (gameData.xpLevel) {
            xpLevel = gameData.xpLevel;
        }
        if (gameData.xpInCurrentLevel) {
            xpInCurrentLevel = gameData.xpInCurrentLevel;
        }
    };

    this.getXpProgressionObj = function (gameData) {
        gameData.xpCount = xpCount;
        gameData.xpLevel = xpLevel;
        gameData.xpInCurrentLevel = xpInCurrentLevel;
        return gameData;
    };

    this.getXpObjForServer = function (gameData) {
        gameData.xpCount = xpCount + "";
        return gameData;
    };

    this.getXpCount = function () {
        return xpCount;
    };

    /*
        load value from game sync ahead call after possible fb login
     */
    this.setValueFromSyncAhead = function (val) {
        if (val != undefined) {
            xpCount = parseInt(val);
        }
    };

    /**
     * calculates and adss the xp to given after puzzle completion
     */
    this.updateXpCountValueAfterPuzzleComplete = function () {

        var acrossHintsMap = gameObj.getAcrossHintsMap();
        var downHintsMap = gameObj.getDownHintsMap();

        var acrossHintsMapLength = Object.keys(acrossHintsMap).length;
        var downHintsMapLength = Object.keys(downHintsMap).length;

        var totalWordsSolved = acrossHintsMapLength + downHintsMapLength;
        totalWordsSolved *= runtimeObj.getXpValue();

        xpCount += parseInt(totalWordsSolved);

        updateXpLevel(parseInt(totalWordsSolved));
    };

     /*
    returns the xp value for any puzzle to be added
     */
    this.getXpForOutro = function () {
        var acrossHintsMap = gameObj.getAcrossHintsMap();
        var downHintsMap = gameObj.getDownHintsMap();

        var acrossHintsMapLength = Object.keys(acrossHintsMap).length;
        var downHintsMapLength = Object.keys(downHintsMap).length;

        var totalWordsSolved = acrossHintsMapLength + downHintsMapLength;
        totalWordsSolved *= runtimeObj.getXpValue();
        
        return {xpIntialValue: xpCount - parseInt(totalWordsSolved), xpAbsoluteVal: totalWordsSolved};
    };
    
    /*
    returns the xpCount str to show on header bar
     */
    this.getXpCountTrimStr = function () {
        var finalStr = xpCount + "";
        if (xpCount > 9999) {
            var mod = xpCount % 1000;
            var base = Math.floor(xpCount / 1000);

            var modBase = Math.floor(mod / 100);
            var modBaseStr = "";
            if (modBase != 0) {
                modBaseStr = modBase + "";
            }

            finalStr = base + "." + modBaseStr +"k";
        }
        return finalStr;
    };

    /**
     * currently it won't update in this release but just flow is coded so that it is
     * easier to plug in at the time of sprint by design approval
     */
    function updateXpLevel(newXp) {

        // returns the xp needed for the next level
        var n = getXpNeededForNextLevel(xpLevel);

        /*
         check for the currentXp level numbers
          */
        // xpInCurrentLevel += newXp;
        if (xpInCurrentLevel >= n) {
            /*
             increment level here and reset xpInCurrentLevel to base value to calc again for next levels
              */
            // xpLevel += 1;
            // xpInCurrentLevel = xpInCurrentLevel - n;
        }

    }

    /**
     * this will be based on the logic provided in next release by design
     */
    function getXpNeededForNextLevel(xpLevel) {
        // logic for n value based on xpLevel (formula to be provided by design side)
        return 100;
    }

};