Frenzy = function () {

    this.checkRevealFrenzy = function (x, y) {
        var answerWord = "";
        var attemptedWord = "";
        var totalCount = 0;
        var filledCount = 0;
        var answerGrid = gameObj.getAnswerGrid();
        for (var i = 0; i < answerGrid.length; i++) {
            for (var j = 0; j < answerGrid[0].length; j++) {
                if (answerGrid[i][j] != ".") {
                    totalCount++;
                    if (gameObj.getAttemptedTile(i, j) != "." && answerGrid[i][j] == gameObj.getAttemptedTile(i, j)) {
                        filledCount++;
                        //loggerObj.debugLog("attempted tile is", gameObj.getAttemptedTile(i,j));
                    }
                }
            }
        }

        var runtime_maxReveal = runtimeObj.getFrenzyMaxReveal();

        // runtime for the frenzy v2 max reveal condition
        if (frenzyV2Obj.conditionForFrenzyV2Type2()) {
            var type2Runtime = runtimeObj.getFrenzyType2();
            var splitStr = type2Runtime.split(":");
            runtime_maxReveal = parseInt(splitStr[2]);
        } else if (frenzyV2Obj.getExperimentAllocationFrenzyV2() == constantsObj.EXP_VAR_1) {
            var type1Runtime = runtimeObj.getFrenzyType1();
            var splitStr = type1Runtime.split(":");
            runtime_maxReveal = parseInt(splitStr[3]);
        }

        var maxReveal = totalCount * (runtime_maxReveal/100);
        var trackStrFrenzy = "";

        var toBeRevealed = (runtimeObj.getFrenzyEasy()/100) * (totalCount - filledCount);
        trackStrFrenzy = (totalCount - filledCount) + "_" + runtimeObj.getFrenzyEasy();
        if(frenzyObj.getFrenzyMasteryAvg() > 2) {
            toBeRevealed = (runtimeObj.getFrenzyHard()/100) * (totalCount - filledCount);
            trackStrFrenzy = (totalCount - filledCount) + "_" + runtimeObj.getFrenzyHard();
        }

        if (frenzyV2Obj.conditionForFrenzyV2Type2()) {
            var type2Runtime = runtimeObj.getFrenzyType2();
            var splitStr = type2Runtime.split(":");
            var burst_str = splitStr[1].split("_");
            var b1 = parseInt(burst_str[0]);
            var b2 = parseInt(burst_str[1]);
            toBeRevealed = (b1/100) * (totalCount - filledCount);
            trackStrFrenzy = (totalCount - filledCount) + "_" + b1;
            if(frenzyObj.getFrenzyMasteryAvg() > 2) {
                toBeRevealed = (b2/100) * (totalCount - filledCount);
                trackStrFrenzy = (totalCount - filledCount) + "_" + b2;
            }
        } else if (frenzyV2Obj.getExperimentAllocationFrenzyV2() == constantsObj.EXP_VAR_1) {

            var FRENZY_HARD = "FrenzyHard";
            var FRENZY_MEDIUM = "FrenzyMedium";
            var FRENZY_EASY = "FrenzyEasy";

            var type1Runtime = runtimeObj.getFrenzyType1();
            var splitStr = type1Runtime.split(":");
            var burst_str = splitStr[2].split("_");
            var b1 = parseInt(burst_str[0]);
            var b2 = parseInt(burst_str[1]);
            var b3 = parseInt(burst_str[2]);

            var frenzyBucket = frenzyV2Obj.getPuzzleLevelBasedBuckets(gameLayer.crosswordDate);
            loggerObj.debugLog("frenzy word is", JSON.stringify(gameLayer.puzzleMap));

            trackStrFrenzy = (totalCount - filledCount);
            if (frenzyBucket == FRENZY_EASY) {
                toBeRevealed = (b1/100) * (totalCount - filledCount);
                trackStrFrenzy += "_" + b1;
            } else if (frenzyBucket == FRENZY_MEDIUM) {
                toBeRevealed = (b2/100) * (totalCount - filledCount);
                trackStrFrenzy += "_" + b2;
            } else {
                toBeRevealed = (b3/100) * (totalCount - filledCount);
                trackStrFrenzy += "_" + b3;
            }
        }

        var spriteArr = [];
        var rec = gameLayer.gridTileRects[x][y];
        var xPosF = cc.rectGetMinX(rec) + gameLayer.gridTileWidth / 2;
        var yPosF = cc.rectGetMinY(rec) + gameLayer.gridTileWidth / 2;
        var subRing = utilObj.getSprite(constantsObj.subs_ring_frenzy, xPosF, yPosF, 0.5, 0.5, 1, spriteArr, gameLayer, constantsObj.SPRITE_Z_ORDER + 1, constantsObj.SPRITE_MISC);
        utilObj.addSprites(spriteArr);
        subRing.setOpacity(0);
        if (gameLayer.attemptLabelFrenzy) {
            var l = x;
            var m = y;
            var maX = gameLayer.gridWidth;
            var maY = gameLayer.gridHeight;
            var labelArr = [];
            // downwards
            while (l >= 0 && l < maX && gameObj.getAnswerTile(l, m) >= "A" && gameObj.getAnswerTile(l, m) <= "Z") {
                answerWord = gameObj.getAnswerTile(l, m) + answerWord;
                if (gameObj.getAttemptedTile(l, m) >= "A" && gameObj.getAttemptedTile(l, m) <= "Z") {
                    attemptedWord = gameObj.getAttemptedTile(l, m) + attemptedWord;
                }
                l--;
            }
            l = x + 1;
            m = y;
            while (l >= 0 && l < maX && gameObj.getAnswerTile(l, m) >= "A" && gameObj.getAnswerTile(l, m) <= "Z") {
                answerWord = answerWord + gameObj.getAnswerTile(l, m);
                if (gameObj.getAttemptedTile(l, m) >= "A" && gameObj.getAttemptedTile(l, m) <= "Z") {
                    attemptedWord = attemptedWord + gameObj.getAttemptedTile(l, m);
                }
                l++;
            }

            if (frenzyV2Obj.conditionForFrenzyV2Type2()) {
                if (attemptedWord == answerWord && gameLayer.frenzyRevealCount < maxReveal) {
                    gameLayer.frenzyRevealCount += toBeRevealed;
                    subRing.setOpacity(0);
                    trackObj.trackCounter(constantsObj.TRACK_PUZZLE, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1, stringsObj.frenzy, "", "", "", 1, "");
                    gameObj.revealFrenzyLetters(toBeRevealed, x, y, false, answerWord, trackStrFrenzy);
                    window.setTimeout(gameLayer.changeFrenzyLabel, 1500);
                    return;
                }
            } else {
                if (attemptedWord == answerWord && gameLayer.frenzyRevealCount < maxReveal && gameLayer.puzzleMap != null && gameLayer.puzzleMap[answerWord] && gameLayer.puzzleMap[answerWord]['revealDone'] == false) {
                    gameLayer.puzzleMap[answerWord]['revealDone'] = true;
                    gameLayer.frenzyRevealCount += toBeRevealed;

                    // gameLayer.frenzyLabel.setString("FRENZY");
                    subRing.setOpacity(0);
                    // animObj.frenzyRingAnim(this, subRing);
                    trackObj.trackCounter(constantsObj.TRACK_PUZZLE, gameObj.getCurPuzzleTracking(),linearLevelObj.getDtc2PuzzleCompleted() + 1, stringsObj.frenzy, "", "", "", 1, "");
                    gameObj.revealFrenzyLetters(toBeRevealed, x, y, false, answerWord, trackStrFrenzy);
                    window.setTimeout(gameLayer.changeFrenzyLabel, 1500);
                    return;
                }
                if (attemptedWord != answerWord && attemptedWord.length == answerWord.length && gameLayer.puzzleMap != null && gameLayer.puzzleMap[answerWord] && gameLayer.puzzleMap[answerWord]['revealDone'] == true) {
                    // gameLayer.frenzyLabel.setString("GUESSING?");
                    window.setTimeout(gameLayer.changeFrenzyLabel, 1000);
                }
                if (attemptedWord == answerWord && gameLayer.puzzleMap != null && gameLayer.puzzleMap[answerWord] && gameLayer.puzzleMap != null && gameLayer.puzzleMap[answerWord]['revealDone'] == true) {
                    // gameLayer.frenzyLabel.setString("BINGO!");
                    window.setTimeout(gameLayer.changeFrenzyLabel, 1000);
                }
            }

            attemptedWord = "";
            answerWord = "";

            l = x;
            m = y;

            //across
            while (m >= 0 && m < maY && gameObj.getAnswerTile(l, m) >= "A" && gameObj.getAnswerTile(l, m) <= "Z") {
                answerWord = gameObj.getAnswerTile(l, m) + answerWord;
                if (gameObj.getAttemptedTile(l, m) >= "A" && gameObj.getAttemptedTile(l, m) <= "Z") {
                    attemptedWord = gameObj.getAttemptedTile(l, m) + attemptedWord;
                }
                m--;
            }
            l = x;
            m = y + 1;
            while (m >= 0 && m < maY && gameObj.getAnswerTile(l, m) >= "A" && gameObj.getAnswerTile(l, m) <= "Z") {
                answerWord = answerWord + gameObj.getAnswerTile(l, m);
                if (gameObj.getAttemptedTile(l, m) >= "A" && gameObj.getAttemptedTile(l, m) <= "Z") {
                    attemptedWord = attemptedWord + gameObj.getAttemptedTile(l, m);
                }
                m++;
            }

            if (frenzyV2Obj.conditionForFrenzyV2Type2()) {
                if (attemptedWord == answerWord && gameLayer.frenzyRevealCount < maxReveal) {
                    gameLayer.frenzyRevealCount += toBeRevealed;
                    subRing.setOpacity(0);
                    trackObj.trackCounter(constantsObj.TRACK_PUZZLE, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1, stringsObj.frenzy, "", "", "", 1, "");
                    gameObj.revealFrenzyLetters(toBeRevealed, x, y, true, answerWord, trackStrFrenzy);
                    window.setTimeout(gameLayer.changeFrenzyLabel, 1500);
                    return;
                }
            } else {
                if (attemptedWord == answerWord && gameLayer.frenzyRevealCount < maxReveal && gameLayer.puzzleMap != null && gameLayer.puzzleMap[answerWord] && gameLayer.puzzleMap[answerWord]['revealDone'] == false) {
                    gameLayer.puzzleMap[answerWord]['revealDone'] = true;
                    gameLayer.frenzyRevealCount += toBeRevealed;

                    // gameLayer.frenzyLabel.setString("FRENZY");
                    subRing.setOpacity(0);
                    // animObj.frenzyRingAnim(this,subRing);
                    trackObj.trackCounter(constantsObj.TRACK_PUZZLE, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1, stringsObj.frenzy, "", "", "", 1, "");
                    gameObj.revealFrenzyLetters(toBeRevealed, x, y, true, answerWord, trackStrFrenzy);
                    window.setTimeout(gameLayer.changeFrenzyLabel, 1500);
                    return;
                }
                if (attemptedWord == answerWord && gameLayer.puzzleMap != null && gameLayer.puzzleMap[answerWord] && gameLayer.puzzleMap[answerWord]['revealDone'] == true) {
                    // gameLayer.frenzyLabel.setString("BINGO!");
                    window.setTimeout(gameLayer.changeFrenzyLabel, 1000);
                }

                if (attemptedWord != answerWord && attemptedWord.length == answerWord.length && gameLayer.puzzleMap != null && gameLayer.puzzleMap[answerWord] && gameLayer.puzzleMap[answerWord]['revealDone'] == true) {
                    // gameLayer.frenzyLabel.setString("GUESSING?");
                    window.setTimeout(gameLayer.changeFrenzyLabel, 1000);
                }
            }
        }

    };

    this.updateAttemptLblFrenzy = function (params, lblTxt, seeWrong, correct, isAnimated, delay, fromPrefilled, fromRevealFrenzy, isAcross, answerWord, count) {
        if (gameLayer.gridTileRects == null) {
            return;
        }
        var x = params.x;
        var y = params.y;
        var startX = params.startX;
        var startY = params.startY;
        var preFilled = false;
        if (fromPrefilled != undefined) {
            preFilled = fromPrefilled;
        }
        var rect = gameLayer.gridTileRects[x][y];
        var rect1 = gameLayer.gridTileRects[startX][startY];
        if (!utilObj.isObject(rect)) {
            return;
        }
        var xPos = cc.rectGetMinX(rect) + gameLayer.gridTileWidth / 2;
        var yPos = cc.rectGetMinY(rect) + gameLayer.gridTileWidth / 2;
        var xPosStart = cc.rectGetMinX(rect1) + gameLayer.gridTileWidth / 2;
        var yPosStart = cc.rectGetMinY(rect1) + gameLayer.gridTileWidth / 2;

        if(gameLayer.gridTiles == null){
            return ;
        }
        rect = gameLayer.gridTiles[x][y];
        var labelArr = [];
        if (gameLayer.attemptGridLbls == null) {
            gameLayer.attemptGridLbls = [];
        }
        if (gameLayer.attemptGridLbls[x] == undefined) {
            gameLayer.attemptGridLbls[x] = [];
        }
        let { toScale , textFont } = gameObj.getAttemptLblFontAndScale();

        var wordLength = answerWord.length;
        var randomNumberForBurst = count % (answerWord.length);
        var yPosForBurst = 0;
        var xPosForBurst = 0;
        var WordMapForFrenzyTile = gameObj.getMapForFrenzyWordTile();
        if (WordMapForFrenzyTile[answerWord]) {
            if (isAcross) {
                xPosForBurst = WordMapForFrenzyTile[answerWord].startY;
                yPosForBurst = WordMapForFrenzyTile[answerWord].endX - randomNumberForBurst;
            } else {
                xPosForBurst = WordMapForFrenzyTile[answerWord].endY - randomNumberForBurst;
                yPosForBurst = WordMapForFrenzyTile[answerWord].startX;
            }
        } else {
            return;
        }

        var gridTile = utilObj.getSprite(gameLayer.lk_grid_tile, gameLayer.gridBg.getPositionX() + gameLayer.gridTiles[xPosForBurst][yPosForBurst].getPositionX(), gameLayer.gridBg.getPositionY() + gameLayer.gridTiles[xPosForBurst][yPosForBurst].getPositionY(), 0.5, 0.5, gameLayer.gridTileScale, null, gameLayer.gridBg, constantsObj.SPRITE_Z_ORDER, constantsObj.SPRITE_MISC);
        utilObj.addChild(gameLayer, gridTile, constantsObj.FTUE_Z_ORDER);
        gridTile.setColor(constantsObj.COLOR_FRENZY_ORANGE);
        var labelForTile = utilObj.getBMFontLabel(lblTxt, textFont, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), gameLayer.gridBg.getPositionX() + gameLayer.gridTiles[xPosForBurst][yPosForBurst].getPositionX(), gameLayer.gridBg.getPositionY() + gameLayer.gridTiles[xPosForBurst][yPosForBurst].getPositionY(), 0.5, 0.5, null, null, constantsObj.SPRITE_Z_ORDER);
        // labelForTile.setColor(constantsObj.COLOR_RED_01);
        labelForTile.setScale(toScale);
        utilObj.addChild(gameLayer, labelForTile, constantsObj.FTUE_Z_ORDER);
        gridTile.setScale(0);
        labelForTile.setScale(0);

        if (!utilObj.isNodeValid(gameLayer.attemptGridLbls[x][y])) {
            gameLayer.attemptGridLbls[x][y] = utilObj.getBMFontLabel(lblTxt, textFont, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, gameLayer, constantsObj.SPRITE_Z_ORDER);
            gameLayer.attemptGridLbls[x][y].setScale(toScale);

            if (isAnimated) {
                if (isAnimated) {
                    gameLayer.attemptGridLbls[x][y].setOpacity(0);
                    gameLayer.attemptGridLbls[x][y].setString(lblTxt);
                    var params = {
                        node1: gameLayer.attemptGridLbls[x][y]
                    };
                    utilObj.delayedCallback(gameLayer, frenzyObj.showOpacity, delay + 1.1, params);
                    animObj.animateRevealLettersFrenzy(this, {
                        tile: gridTile,
                        label: labelForTile,
                        delay: delay,
                        finalScale: toScale,
                        xTemp: x,
                        yTemp: y,
                        lblTxt: lblTxt,
                        endX: xPos,
                        endY: yPos
                    });
                } else if (rect != undefined) {
                    utilObj.addChild(gameLayer, gameLayer.attemptGridLbls[x][y], constantsObj.SPRITE_Z_ORDER);
                    gameLayer.attemptGridLbls[x][y].setOpacity(constantsObj.OPACITY_100);
                }
            } else {
                if (rect != undefined) {
                    utilObj.addChild(gameLayer, gameLayer.attemptGridLbls[x][y], constantsObj.SPRITE_Z_ORDER);
                    gameLayer.attemptGridLbls[x][y].setOpacity(constantsObj.OPACITY_100);
                }
            }
        } else {
            if (utilObj.isNodeValid(gameLayer.attemptGridLbls[x][y]) && isAnimated != true) {
                gameLayer.attemptGridLbls[x][y].setString(lblTxt);
            }
            if (isAnimated) {
                gameLayer.attemptGridLbls[x][y].setOpacity(0);
                gameLayer.attemptGridLbls[x][y].setString(lblTxt);
                var params = {
                    node1: gameLayer.attemptGridLbls[x][y]
                };
                utilObj.delayedCallback(gameLayer, frenzyObj.showOpacity, delay + 1.1, params);
                animObj.animateRevealLettersFrenzy(this, {
                    tile: gridTile,
                    label: labelForTile,
                    delay: delay,
                    finalScale: toScale,
                    xTemp: x,
                    yTemp: y,
                    lblTxt: lblTxt,
                    endX: xPos,
                    endY: yPos
                });
            }
        }

        if (isAnimated) {
            var triangleScale = (gameLayer.gridTileScale / gameLayer.circleMarkScale);
            var triangularMark = utilObj.getSprite(constantsObj.white_circle_300, xPos + gameLayer.gridTileWidth / 2 - gameLayer.circleMarkOffset - gameLayer.circleXOffset, yPos + gameLayer.gridTileWidth / 2 - gameLayer.circleMarkOffset - gameLayer.circleYOffset, 1, 1, triangleScale, null, null, constantsObj.UI_Z_ORDER + 2, constantsObj.SPRITE_MISC);
            utilObj.setColor(triangularMark, utilObj.getColorForHexCode(constantsObj.HEX_2aad72));
            utilObj.addChild(gameLayer, triangularMark, constantsObj.SPRITE_Z_ORDER + 1);
            triangularMark.setOpacity(0);
            utilObj.setScale(triangularMark, utilObj.getScale(triangularMark) / constantsObj.SCALE_SPRITE_NEW_1);
            animObj.showTriangleMark(this, {
                node: triangularMark,
                delay: delay,
                finalScale: toScale,
                xTemp: x,
                yTemp: y,
                lblTxt: lblTxt
            });
        }

        var isSeeWrongPurchased = gameObj.getIsSeeWrongPurchased();
        if (isSeeWrongPurchased && seeWrong && lblTxt != correct) {
            if (gameLayer.attemptGridLbls[x][y].setFontFillColor) {
                gameLayer.attemptGridLbls[x][y].setFontFillColor(constantsObj.COLOR_LIGHT_RED);
            } else {
                gameLayer.attemptGridLbls[x][y].setColor(constantsObj.COLOR_LIGHT_RED);
            }
        } else {
            if (gameLayer.attemptGridLbls[x][y].setFontFillColor) {
                gameLayer.attemptGridLbls[x][y].setFontFillColor(constantsObj.COLOR_BLACK);
            } else {
                gameLayer.attemptGridLbls[x][y].setColor(constantsObj.COLOR_BLACK);
            }
        }
        utilObj.addLabels(labelArr);
    };

    this.getFrenzyMasteryAvg = function () {
        var puzzHistory = gameObj.getPuzzleSolvedHistory();
        var todaysDate = gameObj.getTodaysPuzzleDate();
        var todaysId = utilObj.getIdForDate(todaysDate);
        var mp = {};
        var n = 0;
        var scores = 0;
        for (var key in puzzHistory) {
            if (key == todaysId) {
                continue;
            }
            for (var i = 0; i < puzzHistory[key].length; i++) {
                if(!(mp[puzzHistory[key][i]] && mp[puzzHistory[key][i]]==true)) {
                    scores += scoresObj.getMastery(puzzHistory[key][i]);
                    mp[puzzHistory[key][i]] = true;
                    n++;
                }
            }
        }
        if (n == 0)
            return 0;
        var avg = scores / n;
        return avg;
    };

    this.showOpacity = function (sender ,params) {
        var node = params.node1;
        if (utilObj.isNodeValid(node)) {
            node.setOpacity(constantsObj.OPACITY_100);
        }
    };

    /**
     * first checks if the frenzy is active and then calls checkRevealFrenzy
     * @param x
     * @param y
     */
    this.checkAndRevealFrenzy = function (x, y) {
        if (!frenzyObj.checkAndUpdateFrenzyActive()) {
            return;
        }

        frenzyObj.checkRevealFrenzy(x, y);
    };

    /**
     * checks if frenzy feature is active
     * also being used for setting the variable 'isFrenzyPurchased' when any crossword is opened
     * @returns {boolean}
     */
    this.isFrenzyActive = function () {
        // base checks
        // loggerObj.debugLog("frenzyLog: isMiniMidi , installDayCheck -> ", gameObj.checkForMiniOrMidi(gameLayer.crosswordDate), (gameObj.getInstallDay() == 0));
        // if(/*gameObj.checkForMiniOrMidi(gameLayer.crosswordDate) ||*/ (gameObj.getInstallDay() == 0)){
        //     loggerObj.debugLog("frenzyLog: frenzy Inactive");
        //     return false;
        // }


        // frenzy experiment variant check
        var frenzyVariant = epmObj.getChosenVariant(constantsObj.EXP_FRENZY);
        // loggerObj.debugLog("frenzyLog: frenzyVariant -> ", frenzyVariant);
        if (frenzyVariant != constantsObj.EXP_VAR_1 && frenzyVariant != constantsObj.EXP_VAR_2) {
            loggerObj.debugLog("frenzyLog: frenzy Inactive");
            return false;
        }


        // d0_frenzy experiment variant check
        // days difference between today and install day needs to be at least equal to the runtime 'frenzy_start_day'
        // var d0FrenzyVariant = epmObj.getChosenVariant(constantsObj.EXP_D0_FRENZY);
        // var date1 = utilObj.getDateForId(gameObj.getInstallDay());
        // var date2 = utilObj.getDateForId(gameObj.getIdForTodaysPuzzle());
        // var dayDiff = utilObj.getDaysDiff(date1, date2);
        // dayDiff = Math.abs(dayDiff);

        // loggerObj.debugLog("frenzyLog: d0FrenzyVariant, dayDiff, 'frenzyStartDay' -> ", d0FrenzyVariant, dayDiff, runtimeObj.getFrenzyStartDay());
        // if(dayDiff <= runtimeObj.getFrenzyStartDay()){
        //     if(d0FrenzyVariant == constantsObj.EXP_VAR_1){
        //         if(dayDiff < runtimeObj.getFrenzyStartDay()){
        //             // loggerObj.debugLog("frenzyLog: frenzy Inactive");
        //             return false;
        //         }
        //     } else {
        //         // loggerObj.debugLog("frenzyLog: frenzy Inactive");
        //         return false;
        //     }
        // }

        // frenzy active conditions for introOutroRevamp Experiment Variant
        // frenzySwitch check for all variants excluding variant2 of introOutroRevamp Experiment
        // loggerObj.debugLog("frenzyLog: introOutroRevampVariant , frenzySwitch -> ", introOutroRevampExp, gameObj.getFrenzySwitch());
        if (introOutroRevampExp != constantsObj.EXP_VAR_2) {
            if (!gameObj.getFrenzySwitch()) {
                loggerObj.debugLog("frenzyLog: frenzy Inactive");
                return false;
            }
        }


        // frenzy is active, if the frenzy powerUp is purchased
        // loggerObj.debugLog("frenzyLog: isFrenzyPurchased -> ", gameObj.getIsFrenzyPurchased());
        if (gameObj.getIsFrenzyPurchased()) {
            // loggerObj.debugLog("frenzyLog: frenzy Active");
            return true;
        }

        // loggerObj.debugLog("frenzyLog: crosswordDate, todaysPuzzleId, d0PuzzleId, introOutroRevampExp, frenzyForTodayPuzzle  -> ", gameLayer.crosswordDate, gameObj.getIdForTodaysPuzzle(), gameObj.getD0Id(), introOutroRevampExp, gameObj.getFrenzyForTodayPuzzle());
        // frenzy is active if the user is playing today's main puzzle and is in variant2 of introOutroRevamp Experiment and frenzyForTodayPuzzle switch is on,
        // or, if the user is playing today's main puzzle and is not in variant2 of introOutroRevamp Experiment,
        // if ((gameLayer.crosswordDate == gameObj.getIdForTodaysPuzzle() || gameLayer.crosswordDate == gameObj.getD0Id())) {
        //     if (introOutroRevampExp == constantsObj.EXP_VAR_2) {
        //         if (gameObj.getFrenzyForTodayPuzzle()) {
        //             // loggerObj.debugLog("frenzyLog: frenzy Active");
        //             return true;
        //         }
        //     } else {
        //         // loggerObj.debugLog("frenzyLog: frenzy Active");
        //         return true;
        //     }
        // }

        // frenzy is active if user is in variant1 of frenzy_global experiment
        var frenzyGlobalVariant = epmObj.getChosenVariant(constantsObj.EXP_FRENZY_GLOBAL);
        // loggerObj.debugLog("frenzyLog: frenzyGlobalVariant, introOutroRevamp variant -> ", frenzyGlobalVariant, introOutroRevampExp);
        if(frenzyGlobalVariant == constantsObj.EXP_VAR_1){
            if(introOutroRevampExp != constantsObj.EXP_VAR_2) {
                // loggerObj.debugLog("frenzyLog: frenzy active");
                return true;
            }
        }

        // loggerObj.debugLog("frenzyLog: frenzy Inactive");
        return false;
    };

    /**
     * checks if the frenzy is active and updates the value of isFrenzyPurchased accordingly
     * setting the value of isFrenzyPurchased force activates frenzy
     * @returns {boolean}
     */
    this.checkAndUpdateFrenzyActive = function () {
        if(!frenzyObj.isFrenzyActive()){
            return false;
        }

        gameObj.setIsFrenzyPurchased(true);
        return true;
    };

    this.getMaxRevealCount = function () {
        var totalCount = 0;
        var answerGrid = gameObj.getAnswerGrid();
        if (answerGrid == null) {
            return 0;
        }
        for (var i = 0; i < answerGrid.length; i++) {
            if (answerGrid[0] == null) {
                return 0;
            }
            for (var j = 0; j < answerGrid[0].length; j++) {
                if (answerGrid[i][j] != ".") {
                    totalCount++;
                }
            }
        }
        var runtime_maxReveal = runtimeObj.getFrenzyMaxReveal();
        var frenzyV2Exp = frenzyV2Obj.getExperimentAllocationFrenzyV2()

        // runtime for the frenzy v2 max reveal condition
        if (frenzyV2Exp == constantsObj.EXP_VAR_2) {
            var type2Runtime = runtimeObj.getFrenzyType2();
            var splitStr = type2Runtime.split(":");
            runtime_maxReveal = parseInt(splitStr[2]);
        } else if (frenzyV2Exp == constantsObj.EXP_VAR_1) {
            var type1Runtime = runtimeObj.getFrenzyType1();
            var splitStr = type1Runtime.split(":");
            runtime_maxReveal = parseInt(splitStr[3]);
        }
        var maxReveal = totalCount * (runtime_maxReveal / 100);
        return maxReveal;
    };
};