FrenzyV2 = function () {

    var frenzyCountIndex = 0;
    var wordClearIndex = 1;
    var frenzyWindowMaxIndex = 2;
    var frenzyWindowIndex = 3;
    var frenzyWordMaxCount = 0;
    var totalWordsInPuzzle = 0;
    var frenzyWindowMinCount = 2;
    var frenzyWordForSpinner = "";
    var lastNPuzzlesWindow = [];
    var frenzyAvailabilityForPuzzles = {};
    var frenzyMapForFrenzyWindow = {};
    var frenzyWindowSizeMap = {};
    var puzzleMapForGenericFrenzy = {};

    var lastPuzzlesPlayedNDays = {};
    var lastPuzzleInserted = "";
    var puzzleBasedLevelStored = {};

    var isNewUserFrenzyV2 = false;
    var firstTimeDecidingBucket = false;

    // setters and getters functions
    this.getLastPuzzlesPlayedNDays = function () {
        return lastPuzzlesPlayedNDays
    };

    this.setLastPuzzlesPlayedNDays = function (val) {
        lastPuzzlesPlayedNDays = val;
    };

    this.getPuzzleBasedLevelStored = function () {
        return puzzleBasedLevelStored;
    };

    this.setPuzzleBasedLevelStored = function (val) {
        puzzleBasedLevelStored = val;
    };

    this.getIsNewUserFrenzyV2 = function () {
        return isNewUserFrenzyV2;
    };

    this.setIsNewUserFrenzyV2 = function (val) {
        isNewUserFrenzyV2 = val;
    };

    this.getFirstTimeDecidingBucket = function () {
        return firstTimeDecidingBucket;
    };

    this.setFirstTimeDecidingBucket = function (val) {
        firstTimeDecidingBucket = val;
    };

    // -----------------------------

    /**
     * adds the puzzle attempted to the puzzlesPlayed arr
     * @param puzzleId
     */
    this.addPuzzlesAttempted = function (puzzleId) {
        var todaysPuzzleDate = gameObj.getTodaysPuzzleDate();
        var id = utilObj.getIdForDate(todaysPuzzleDate);

        loggerObj.debugLog("frenzyV2 - coming to add puzzles attempted", puzzleId, JSON.stringify(lastPuzzlesPlayedNDays));

        if (!lastPuzzlesPlayedNDays[id]) {
            lastPuzzlesPlayedNDays[id] = [];
        }

        frenzyV2Obj.checkAndRemoveRepetitionInMapForPuzzles(puzzleId);

        lastPuzzleInserted = puzzleId;
        lastPuzzlesPlayedNDays[id].push(puzzleId);

        loggerObj.debugLog("frenzyV2 - after adding puzzles attempted", puzzleId, JSON.stringify(lastPuzzlesPlayedNDays));

    };

    /**
     * checks repeptition of the same puzzle in the array for the map
     * @param id puzzle id to be added in attempted arr
     * @return {boolean} to add or not to add
     */
    this.checkAndRemoveRepetitionInMapForPuzzles = function (id) {
        loggerObj.debugLog("frenzyV2 - before check of same puzzle", id, JSON.stringify(lastPuzzlesPlayedNDays));
        var index = -1;
        for(var key in lastPuzzlesPlayedNDays) {
            var length = lastPuzzlesPlayedNDays[key].length;
            for (var i = 0; i < length; i++) {
                // loggerObj.debugLog("frenzyV2 - iter check of same", lastPuzzlesPlayedNDays[key][i], id, key);
                if (id == lastPuzzlesPlayedNDays[key][i]) {
                    index = i;
                    break;
                }
            }
            if (index != -1) {
                lastPuzzlesPlayedNDays[key].splice(index, 1);
            }
        }
        loggerObj.debugLog("frenzyV2 - after check of same puzzle", id, index, JSON.stringify(lastPuzzlesPlayedNDays));
    };

    /**
     * update the dau version of the id
     */
    this.updateDauKeyForPuzzles = function () {
        var todaysPuzzleDate = gameObj.getTodaysPuzzleDate();
        var id = utilObj.getIdForDate(todaysPuzzleDate);

        if (!lastPuzzlesPlayedNDays[id]) {
            lastPuzzlesPlayedNDays[id] = [];
        }
    };

    /**
     * updates for the last x dau_days and deletes data for the rest
     */
    this.updateLastPuzzlesSolvedMap = function () {
        var countOfDauDays = 0;

        var type1Runtime = runtimeObj.getFrenzyType1();
        var splitStr = type1Runtime.split(":");
        var day_str = splitStr[0].split("_");
        var day = parseInt(day_str[1]);
        var dauDaysToStoreData = day;

        var todaysPuzzleDate = gameObj.getTodaysPuzzleDate();
        var milliSecInDay = 86400000;
        var curTime = todaysPuzzleDate.getTime();

        loggerObj.debugLog("frenzyV2 - map before update is ", JSON.stringify(lastPuzzlesPlayedNDays));

        while(true) {
            var newDate = new Date(curTime);
            var newId = utilObj.getIdForDate(newDate);

            if (newId < 20170301) {
                break;
            }

            if (lastPuzzlesPlayedNDays[newId]) {
                if (countOfDauDays < dauDaysToStoreData) {
                    countOfDauDays += 1;
                } else {
                    delete lastPuzzlesPlayedNDays[newId];
                }
            }

            curTime -= milliSecInDay;
        }

        loggerObj.debugLog("frenzyV2 - map after update is ", JSON.stringify(lastPuzzlesPlayedNDays));
    };

    /**
     * returns avg mastery for the last n puzzles for the user
     * @return {number} avg mastery value
     */
    this.getAverageMasteryForLastNPuzzles = function () {
        var avgMastery = 0;
        var puzzlesCount = 0;

        var type1Runtime = runtimeObj.getFrenzyType1();
        var splitStr = type1Runtime.split(":");
        var puz_str = splitStr[0].split("_");
        var pz = parseInt(puz_str[0]);
        var lastNPuzzlesCount = pz;

        var todaysPuzzleDate = gameObj.getTodaysPuzzleDate();
        var milliSecInDay = 86400000;
        var curTime = todaysPuzzleDate.getTime();

        loggerObj.debugLog("frenzyV2 - before average mastery calc is", avgMastery, puzzlesCount, JSON.stringify(lastPuzzlesPlayedNDays));

        while (true) {
            var newDate = new Date(curTime);
            var newId = utilObj.getIdForDate(newDate);

            if (newId < 20170301) {
                break;
            }
            if (puzzlesCount > lastNPuzzlesCount) {
                break;
            }

            if (lastPuzzlesPlayedNDays[newId]) {
                // loggerObj.debugLog("frenzyV2 - iter average mastery ca1");
                var length = lastPuzzlesPlayedNDays[newId].length;
                for (var i = length - 1; i >= 0 ; i--) {
                    var id = lastPuzzlesPlayedNDays[newId][i];
                    // loggerObj.debugLog("frenzyV2 - iter average mastery ca", id);
                    if (puzzlesCount >= lastNPuzzlesCount) {
                        break;
                    }
                    var stars = scoresObj.getMastery(id);
                    // loggerObj.debugLog("frenzyV2 - iter average ma", stars);
                    avgMastery += stars;
                    puzzlesCount++;
                }
            }
            curTime -= milliSecInDay;
        }


        loggerObj.debugLog("frenzyV2 - after average mastery calc is", avgMastery, puzzlesCount);

        if (puzzlesCount == 0) {
            return 0;
        }
        return avgMastery/puzzlesCount;
    };

    /**
     * checks and adds the puzzle to the arr if condition is satisfied for the time elapsed or filled count
     * @param puzzleId id to append
     * @param filledChars count of the filled Count
     * @param timeElapsed time elapsed on the current puzzle
     */
    this.checkAndAddPuzzleToArr = function (puzzleId, filledChars, timeElapsed) {

        loggerObj.debugLog("frenzyV2 - coming to insert puzzle ", puzzleId," filled char", filledChars, "time elap", timeElapsed,"last insert", lastPuzzleInserted, JSON.stringify(lastPuzzlesPlayedNDays));
        if (lastPuzzleInserted == puzzleId) {
            loggerObj.debugLog("frenzyV2 - returning already inserted puzzle", lastPuzzleInserted, "puzz id", puzzleId, " map is", JSON.stringify(lastPuzzlesPlayedNDays));
            return;
        }

        if(gameObj.checkForMiniOrMidi(puzzleId)) {
            loggerObj.debugLog("frenzyV2 - returning because not main");
            return;
        }

        var crosswordInfo = gameObj.getCrosswordForDate(puzzleId);
        if (crosswordInfo != null) {
            var fillCount = crosswordInfo.fc;
            var filled = filledChars;
            loggerObj.debugLog("frenzyV2 - check conditions puzzle",filled, fillCount, "timeelapsed", timeElapsed);
            if (filled/ fillCount > 0.5 || timeElapsed >= 120) {
                frenzyV2Obj.addPuzzlesAttempted(puzzleId);
            }
        }
    };

    /**
     * get the experiment for the experiment allocation for frenzy based on frenzy global experiment
     * @return {number} expriment allocated
     */
    this.getExperimentAllocationFrenzyV2 = function () {

        var experimentAllocFrenzyGlobal = epmObj.getChosenVariant(constantsObj.EXP_FRENZY_GLOBAL);
        var experimentAllocFrenzyV2 = epmObj.getChosenVariant(constantsObj.EXP_FRENZY_V2);
        if (experimentAllocFrenzyGlobal == constantsObj.EXP_VAR_CONTROL || experimentAllocFrenzyV2 == constantsObj.EXP_VAR_CONTROL) {
            experimentAllocFrenzyV2 = constantsObj.EXP_VAR_CONTROL;
        }

        loggerObj.debugLog("frenzyV2 log: experiment val", experimentAllocFrenzyV2, experimentAllocFrenzyGlobal);
        return experimentAllocFrenzyV2;
    };


    var FRENZY_HARD = "FrenzyHard";
    var FRENZY_MEDIUM = "FrenzyMedium";
    var FRENZY_EASY = "FrenzyEasy";

    /**
     * sets the puzzle id level for the frenzy type 1
     * @param puzzledId id to be calc for
     */
    this.setPuzzleLevelBasedBuckets = function (puzzledId) {

        if (gameObj.checkForMiniOrMidi(puzzledId)) {
            return;
        }

        if (puzzleBasedLevelStored[puzzledId]) {
            return puzzleBasedLevelStored[puzzledId];
        }

        if (!firstTimeDecidingBucket) {
            if (gameObj.getMastery1() == 0) {
                puzzleBasedLevelStored[puzzledId] = FRENZY_MEDIUM;
            } else {
                if (frenzyObj.getFrenzyMasteryAvg() < 2) {
                    puzzleBasedLevelStored[puzzledId] = FRENZY_MEDIUM;
                } else {
                    puzzleBasedLevelStored[puzzledId] = FRENZY_HARD;
                }
            }
            firstTimeDecidingBucket = true;
            loggerObj.debugLog("frenzyV2 log: puzzle based buckets setting mastery firstTime", puzzledId, puzzleBasedLevelStored[puzzledId]);
            return;
        }

        var type1Runtime = runtimeObj.getFrenzyType1();
        var splitStr = type1Runtime.split(":");
        var mastery_str = splitStr[1].split("_");
        var m1 = parseFloat(mastery_str[0]);
        var m2 = parseFloat(mastery_str[1]);

        var masteryLevel1 = m1;
        var masteryLevel2 = m2;
        var averageMastery = frenzyV2Obj.getAverageMasteryForLastNPuzzles();

        var frenzyLevel = FRENZY_EASY;
        if (averageMastery > masteryLevel1 && averageMastery <= masteryLevel2) {
            frenzyLevel = FRENZY_MEDIUM;
        } else if (averageMastery > masteryLevel2) {
            frenzyLevel = FRENZY_HARD;
        }

        loggerObj.debugLog("frenzyV2 log: puzzle based buckets setting mastery", averageMastery,"level is", frenzyLevel,"id is", puzzledId);

        puzzleBasedLevelStored[puzzledId] = frenzyLevel;
    };

    /**
     * gets the bucket for the puzzleid for frenzy type 1
     * @param puzzledId id to get for
     * @return {string} frenzy level, easy if not found.
     */
    this.getPuzzleLevelBasedBuckets = function (puzzledId) {
        var frenzyLevel  = FRENZY_EASY;

        if (puzzleBasedLevelStored[puzzledId]) {
            frenzyLevel  = puzzleBasedLevelStored[puzzledId];
        }

        loggerObj.debugLog("frenzyV2 log: puzzle get bucket", puzzledId,"level is", frenzyLevel);

        return frenzyLevel;
    };

    /**
     * this function updates the frenzy window for a puzzle
     * @param puzzleId
     * @param clueMap
     */
    this.updateFrenzyWindowForLastNPuzzles = function (puzzleId, clueArr) {
        lastNPuzzlesWindow = frenzyV2Obj.getLastNPuzzlesWindow();
        loggerObj.debugLog("frenzy v2 - check for the last n puzzle window ", utilObj.getStringifiedJson(lastNPuzzlesWindow));
        var index = -1;
        var maxLength = 10;
        if (lastNPuzzlesWindow) {
            for (var i = 0; i < lastNPuzzlesWindow.length; i++) {
                if (lastNPuzzlesWindow[i] && lastNPuzzlesWindow[i][puzzleId]) {
                    index = i;
                    // splice fn removes the n number of elements(2nd parameter) from the array from a particular index
                    lastNPuzzlesWindow.splice(index, 1);
                }
            }
        }
        //loggerObj.debugLog("frenzy v2 - check for the last n puzzle window1 ", utilObj.getStringifiedJson(lastNPuzzlesWindow));
        if (index == -1 && maxLength == lastNPuzzlesWindow.length) {
            var puzzleToRemove = 0;
            if (lastNPuzzlesWindow[0] != undefined) {
                for (var key in lastNPuzzlesWindow[0]) {
                    puzzleToRemove = key;
                }
                if (puzzleToRemove != 0 && puzzleToRemove != undefined) {
                    var mapForFrenzyWindow = frenzyV2Obj.getFrenzyMapForFrenzyWindow();
                    if (mapForFrenzyWindow && mapForFrenzyWindow[puzzleToRemove]) {
                        mapForFrenzyWindow[puzzleToRemove][frenzyWindowMaxIndex] = -1;
                        mapForFrenzyWindow[puzzleToRemove][frenzyWindowIndex] = -1;
                    }
                    //loggerObj.debugLog("frenzy v2 - check for reset variable for  puzzle ", puzzleId, utilObj.getStringifiedJson(mapForFrenzyWindow));
                    frenzyV2Obj.setFrenzyMapForFrenzyWindow(mapForFrenzyWindow);
                    frenzyV2Obj.setFrenzyAvailabilityForPuzzles(puzzleToRemove, true);
                }
            }
            // shift function removes the first index of the array and shift the array index by 1
            lastNPuzzlesWindow.shift();
        }
        // loggerObj.debugLog("frenzy v2 - check for the last n puzzle window2 ", utilObj.getStringifiedJson(lastNPuzzlesWindow));
        var clueArray = {};
        clueArray[puzzleId] = clueArr;
        // loggerObj.debugLog("frenzy v2 - check for the last n puzzle window21 ", utilObj.getStringifiedJson(clueArray));
        lastNPuzzlesWindow.push(clueArray);
        frenzyV2Obj.setLastNPuzzlesWindow(lastNPuzzlesWindow);
        loggerObj.debugLog("frenzy v2 - check for the last n puzzle window after update ", utilObj.getStringifiedJson(lastNPuzzlesWindow));
        var clueStr = frenzyV2Obj.frenzyWindowStringForTracking(puzzleId);
        trackObj.trackCounter(constantsObj.TRACK_PUZZLE, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted()+1, stringsObj.frenzy, "window_update", clueStr, "", 1, "");
    };

    /**
     * this function tells if clue is already available for that puzzle in the frenzy window
     * @param puzzleId
     * @param clueNum
     * @returns {boolean}
     */
    this.checkIfClueAvailableInFrenzyWindow = function (puzzleId, clueNum) {
        lastNPuzzlesWindow = frenzyV2Obj.getLastNPuzzlesWindow();

        // check if clue is same as the frenzy word given by spinner
        var frenzyBySpinnerClue = frenzyV2Obj.checkClueWithFrenzyWordBySpinner(puzzleId, clueNum);
        if (frenzyBySpinnerClue) {
            return true;
        }

        var index = -1;
        for (var i = 0; i < lastNPuzzlesWindow.length; i++) {
            if (lastNPuzzlesWindow && lastNPuzzlesWindow[i] && lastNPuzzlesWindow[i][puzzleId]) {
                index = i;
            }
        }
        if (index != -1) {
            for (var j = 0; j < lastNPuzzlesWindow[index][puzzleId].length; j++) {
                if (lastNPuzzlesWindow[index][puzzleId][j] == clueNum) {
                    return true;
                }
            }
        }
        return false;
    };

    /**
     * this function returns the array of last N puzzles frenzy window
     * @param puzzleId
     * @returns {it returns the puzzle window for last N puzzles if available otherwise null}
     */
    this.getWindowArrForCurrentPuzzle = function (puzzleId) {
        lastNPuzzlesWindow = frenzyV2Obj.getLastNPuzzlesWindow();
        for (var i = 0; i < lastNPuzzlesWindow.length; i++) {
            if (lastNPuzzlesWindow && lastNPuzzlesWindow[i] && lastNPuzzlesWindow[i][puzzleId]) {
                return lastNPuzzlesWindow[i][puzzleId];
            }
        }
        return null;
    };

    /**
     * this function set the frenzy variable for a puzzle
     * @param puzzleId
     * @param val
     */
    this.setFrenzyAvailabilityForPuzzles = function (puzzleId, val) {
        var frenzyGivenForPuzzles = frenzyV2Obj.getFrenzyAvailabilityForPuzzleMap();
        // loggerObj.debugLog("frenzy v2 - check for clue map here31 ", puzzleId, val, utilObj.getStringifiedJson(frenzyGivenForPuzzles));
        if (frenzyGivenForPuzzles) {
            frenzyGivenForPuzzles[puzzleId] = val;
        }
        loggerObj.debugLog("frenzy v2 - setFrenzyAvailabilityForPuzzles ", puzzleId, val, utilObj.getStringifiedJson(frenzyGivenForPuzzles));
        frenzyV2Obj.setFrenzyAvailabilityForPuzzleMap(frenzyGivenForPuzzles);
    };

    /**
     * it checks if frenzy available for a puzzle or not
     * @param puzzleId
     * @returns {true or false}
     */
    this.checkFrenzyAvailabilityForPuzzle = function(puzzleId) {
        // loggerObj.debugLog("frenzy v2 - check for clue map here -1");
        var frenzyGivenForPuzzles = frenzyV2Obj.getFrenzyAvailabilityForPuzzleMap();
        if (!frenzyGivenForPuzzles) {
            frenzyGivenForPuzzles = {};
        }
        if (frenzyGivenForPuzzles[puzzleId] == undefined) {
            frenzyGivenForPuzzles[puzzleId] = true;
        }
        if (frenzyV2Obj.getWindowArrForCurrentPuzzle(puzzleId) == null) {
            frenzyGivenForPuzzles[puzzleId] = true;
        }
        frenzyV2Obj.setFrenzyAvailabilityForPuzzleMap(frenzyGivenForPuzzles);
        loggerObj.debugLog("frenzy v2 - checkFrenzyAvailabilityForPuzzle ", frenzyGivenForPuzzles[puzzleId]);
        return frenzyGivenForPuzzles[puzzleId];
    };

    /**
     * it check whether to trigger frenzy ater every word clear
     * @param clueNum
     * @param isAcross - this tells if the word cleared just now was isAcross or isDown
     * @param x - this is tile x Position
     * @param y - this is tile y Position
     */
    this.checkForFrenzyAfterWordClear = function (clueNum, isAcross, x, y) {
        var mapForFrenzyWindow = frenzyV2Obj.getFrenzyMapForFrenzyWindow();
        var maxReveal = frenzyObj.getMaxRevealCount();
        if (gameLayer.frenzyRevealCount >= maxReveal) {
            loggerObj.debugLog("frenzy v2 - check for the frenzy after clear returning because of max reveal limit ",gameLayer.frenzyRevealCount, maxReveal);
            return;
        }
        loggerObj.debugLog("frenzy v2 - check for the frenzy map here get frenzy word count 1", gameLayer.crosswordDate, utilObj.getStringifiedJson(mapForFrenzyWindow));
        if (mapForFrenzyWindow == undefined || mapForFrenzyWindow[gameLayer.crosswordDate] == undefined) {
            frenzyV2Obj.setFrenzyWordsCountForPuzzles(gameLayer.crosswordDate);
        }
        if (mapForFrenzyWindow[gameLayer.crosswordDate][frenzyCountIndex] == 0) {
            return;
        }
        var suffix = "d";
        if (isAcross) {
            suffix = "a";
        }
        var clueNumber = clueNum + suffix;
        var frenzyWordBySpinner = frenzyV2Obj.checkClueWithFrenzyWordBySpinner(gameLayer.crosswordDate, clueNumber);
        loggerObj.debugLog("frenzy v2 - checkFrenzyAvailabilityForPuzzle - frenzyWordBySpinner ", frenzyV2Obj.checkFrenzyAvailabilityForPuzzle(gameLayer.crosswordDate), frenzyWordBySpinner);
        if (frenzyV2Obj.checkFrenzyAvailabilityForPuzzle(gameLayer.crosswordDate) || frenzyWordBySpinner) {
            // loggerObj.debugLog("frenzy v2 - checkFrenzyAvailabilityForPuzzle + frenzyWordBySpinner ", frenzyWordBySpinner);
            var clueArr = frenzyV2Obj.getWindowArrForCurrentPuzzle(gameLayer.crosswordDate);
            if (clueArr != null) {
                clueArr.push(clueNumber);
            } else {
                clueArr = [];
                clueArr.push(clueNumber);
            }
            // loggerObj.debugLog("frenzy v2 - check for clue map here3 ", utilObj.getStringifiedJson(clueArr));
            if (!frenzyWordBySpinner) {
                frenzyV2Obj.updateFrenzyWindowForLastNPuzzles(gameLayer.crosswordDate, clueArr);
                frenzyV2Obj.setFrenzyWordsCountForPuzzles(gameLayer.crosswordDate);
                frenzyV2Obj.setFrenzyAvailabilityForPuzzles(gameLayer.crosswordDate, false);
            }
            frenzyV2Obj.calculateFrenzyWindowSize(gameLayer.crosswordDate);
            loggerObj.debugLog("frenzy v2 - check and reveal frenzy");
            frenzyObj.checkAndRevealFrenzy(x, y);
        }
    };

    /**
     * this function reduces the frenzy variable by 1 after every frenzy triggers and initialise it,
     * if not initialized yet and set that variable in a map that is getting stored in game data
     * @param puzzleId
     */
    this.setFrenzyWordsCountForPuzzles = function(puzzleId) {
        var mapForFrenzyWindow = frenzyV2Obj.getFrenzyMapForFrenzyWindow();
        if (mapForFrenzyWindow == undefined) {
            mapForFrenzyWindow = {};
        }
        loggerObj.debugLog("frenzy v2 - check for the frenzy map here1 ", puzzleId, utilObj.getStringifiedJson(mapForFrenzyWindow));

        if (mapForFrenzyWindow[puzzleId] == undefined) {
            mapForFrenzyWindow[puzzleId] = [-1, -1, -1, -1];
        }

        loggerObj.debugLog("frenzy v2 - check for the frenzy map here2 ", frenzyV2Obj.getFrenzyWordMaxCount(), puzzleId, utilObj.getStringifiedJson(mapForFrenzyWindow));
        if (mapForFrenzyWindow[puzzleId][frenzyCountIndex] == undefined || mapForFrenzyWindow[puzzleId][frenzyCountIndex] == -1) {
            mapForFrenzyWindow[puzzleId][frenzyCountIndex] = frenzyV2Obj.getFrenzyWordMaxCount();
        } else {
            loggerObj.debugLog("frenzy v2 - check for the frenzy map here FrenzyWordsCount before update ", utilObj.getStringifiedJson(mapForFrenzyWindow));
            mapForFrenzyWindow[puzzleId][frenzyCountIndex]--;
            if (mapForFrenzyWindow[puzzleId][frenzyCountIndex] < 0) {
                mapForFrenzyWindow[puzzleId][frenzyCountIndex] = 0;
            }
        }
        loggerObj.debugLog("frenzy v2 - check for the frenzy map here FrenzyWordsCount after update ", utilObj.getStringifiedJson(mapForFrenzyWindow));
        frenzyV2Obj.setFrenzyMapForFrenzyWindow(mapForFrenzyWindow);
    };

    /**
     * this function returns the number of frenzy words left for a puzzle
     * if not initialized returns 0
     * @param puzzleId
     * @returns {number}
     */
    this.getFrenzyWordsCountForPuzzles = function (puzzleId) {
        var mapForFrenzyWindow = frenzyV2Obj.getFrenzyMapForFrenzyWindow();
        if (mapForFrenzyWindow == undefined || mapForFrenzyWindow[puzzleId] == undefined
            || mapForFrenzyWindow[puzzleId][frenzyCountIndex] == undefined) {
            frenzyV2Obj.setFrenzyWordsCountForPuzzles(puzzleId);
            return 0;
        }
        return mapForFrenzyWindow[puzzleId][frenzyCountIndex] > 0 ? mapForFrenzyWindow[puzzleId][frenzyCountIndex] : 0;
    };

    /**
     * this function set the value for max frenzy count
     * @param val
     */
    this.setFrenzyWordMaxCount = function (val) {
        frenzyWordMaxCount = val;
    };

    /**
     * this function returns the max frenzy that can trigger on a puzzle
     * only used when the frenzy count is not initialized for a puzzle
     * @returns {number}
     */
    this.getFrenzyWordMaxCount = function () {
        return frenzyWordMaxCount;
    };

    /**
     * this function set the count for word clear in a puzzles
     * @param puzzleId
     */
    this.setWordClearCountForPuzzles = function (puzzleId) {
        var mapForFrenzyWindow = frenzyV2Obj.getFrenzyMapForFrenzyWindow();
        loggerObj.debugLog("frenzy v2 - check for the frenzy map here-11 ", utilObj.getStringifiedJson(mapForFrenzyWindow));
        if (mapForFrenzyWindow == undefined) {
            mapForFrenzyWindow = {};
        }
        if (mapForFrenzyWindow[puzzleId] == undefined) {
            mapForFrenzyWindow[puzzleId] = [-1, -1, -1, -1];
        }
        if (mapForFrenzyWindow[puzzleId][wordClearIndex] == undefined || mapForFrenzyWindow[puzzleId][wordClearIndex] == -1) {
            mapForFrenzyWindow[puzzleId][wordClearIndex] = 0;
        }
        loggerObj.debugLog("frenzy v2 - check for the frenzy map here WordClearCount before update ", utilObj.getStringifiedJson(mapForFrenzyWindow));
        mapForFrenzyWindow[puzzleId][wordClearIndex]++;
        loggerObj.debugLog("frenzy v2 - check for the frenzy map here WordClearCount after update ", utilObj.getStringifiedJson(mapForFrenzyWindow));

        frenzyV2Obj.setFrenzyMapForFrenzyWindow(mapForFrenzyWindow);
    };

    /**
     * this function provides word count for a puzzle
     * @param puzzleId
     * @returns {number}
     */
    this.getWordClearCountForPuzzles = function (puzzleId) {
        var mapForFrenzyWindow = frenzyV2Obj.getFrenzyMapForFrenzyWindow();
        loggerObj.debugLog("frenzy v2 - check for the frenzy map here-13 ", utilObj.getStringifiedJson(mapForFrenzyWindow));
        if (mapForFrenzyWindow == undefined || mapForFrenzyWindow[puzzleId] == undefined || mapForFrenzyWindow[puzzleId][wordClearIndex] == undefined) {
            return 0;
        }
        return mapForFrenzyWindow[puzzleId][wordClearIndex] > 0 ? mapForFrenzyWindow[puzzleId][wordClearIndex] : 0;
    };

    /**
     * set the max size for frenzy window for a puzzle
     * and store that in a map in game data
     * @param puzzleId
     * @param val
     */
    this.setFrenzyWindowMaxSize = function (puzzleId, val) {
        var mapForFrenzyWindow = frenzyV2Obj.getFrenzyMapForFrenzyWindow();
        loggerObj.debugLog("frenzy v2 - check for the frenzy map here-14 ", utilObj.getStringifiedJson(mapForFrenzyWindow));
        if (mapForFrenzyWindow == undefined) {
            mapForFrenzyWindow = {};
        }
        if (mapForFrenzyWindow[puzzleId] == undefined) {
            mapForFrenzyWindow[puzzleId] = [-1, -1, -1, -1];
        }
        if (mapForFrenzyWindow[puzzleId][frenzyWindowMaxIndex] == undefined || mapForFrenzyWindow[puzzleId][frenzyWindowMaxIndex] == -1) {
            mapForFrenzyWindow[puzzleId][frenzyWindowMaxIndex] = 0;
        }
        loggerObj.debugLog("frenzy v2 - check for the frenzy map here FrenzyWindowMaxSize before update ", utilObj.getStringifiedJson(mapForFrenzyWindow));
        mapForFrenzyWindow[puzzleId][frenzyWindowMaxIndex] = val;
        loggerObj.debugLog("frenzy v2 - check for the frenzy map here FrenzyWindowMaxSize after update ", utilObj.getStringifiedJson(mapForFrenzyWindow));
        frenzyV2Obj.setFrenzyMapForFrenzyWindow(mapForFrenzyWindow);
    };

    /**
     * it used to provide the frenzy window max size foe a puzzle
     * @param puzzleId
     * @returns {number}
     */
    this.getFrenzyWindowMaxSize = function (puzzleId) {
        var mapForFrenzyWindow = frenzyV2Obj.getFrenzyMapForFrenzyWindow();
        loggerObj.debugLog("frenzy v2 - check for the frenzy map here-142 ", utilObj.getStringifiedJson(mapForFrenzyWindow));
        if (mapForFrenzyWindow == undefined || mapForFrenzyWindow[puzzleId] == undefined || mapForFrenzyWindow[puzzleId][frenzyWindowMaxIndex] == undefined) {
            return 0;
        }
        return mapForFrenzyWindow[puzzleId][frenzyWindowMaxIndex] > 0 ? mapForFrenzyWindow[puzzleId][frenzyWindowMaxIndex] : 0;
    };

    /**
     * it returns the current frenzy window size in a puzzle
     * @returns {number}
     */
    this.getFrenzyWindowSize = function (puzzleId) {
        var mapForFrenzyWindow = frenzyV2Obj.getFrenzyMapForFrenzyWindow();
        if (mapForFrenzyWindow == undefined || mapForFrenzyWindow[puzzleId] == undefined || mapForFrenzyWindow[puzzleId][frenzyWindowIndex] == undefined) {
            return 0;
        }
        return mapForFrenzyWindow[puzzleId][frenzyWindowIndex] > 0 ? mapForFrenzyWindow[puzzleId][frenzyWindowIndex] : 0;
    };

    /**
     * in this function we calculate the current frenzy window size
     * @param puzzleId
     */
    this.calculateFrenzyWindowSize = function (puzzleId) {
        var mapForFrenzyWindow = frenzyV2Obj.getFrenzyMapForFrenzyWindow();
        loggerObj.debugLog("frenzy v2 - check for the frenzy map here-14 ", utilObj.getStringifiedJson(mapForFrenzyWindow));
        if (mapForFrenzyWindow == undefined) {
            mapForFrenzyWindow = {};
        }
        if (mapForFrenzyWindow[puzzleId] == undefined) {
            mapForFrenzyWindow[puzzleId] = [-1, -1, -1, -1];
        }
        if (mapForFrenzyWindow[puzzleId][frenzyWindowIndex] == undefined || mapForFrenzyWindow[puzzleId][frenzyWindowIndex] == -1) {
            mapForFrenzyWindow[puzzleId][frenzyWindowIndex] = 0;
        }

        var totalWords = frenzyV2Obj.getTotalWordsInPuzzle();
        var clearWords = frenzyV2Obj.getWordClearCountForPuzzles(puzzleId);
        var frenzyCount = frenzyV2Obj.getFrenzyWordsCountForPuzzles(puzzleId);

        var e = 1;
        var gridHeight = gameObj.getGridHeight();
        if (gameObj.checkForMiniOrMidi(puzzleId)) {
            if (gridHeight != 0 && gridHeight != undefined && gridHeight != null){
                if (gridHeight == 9){
                    e = 4;
                } else if (gridHeight == 7) {
                    e = 2;
                }
            }
        } else {
            if (gridHeight != 0 && gridHeight != undefined && gridHeight != null){
                if (gridHeight == 13) {
                    e = 10;
                } else {
                    e = 15;
                }
            } else {
                e = 15;
            }
        }

        var unAttemptedWords = totalWords - clearWords - e; // updated value for dtc2
        mapForFrenzyWindow[puzzleId][frenzyWindowIndex] = 2;
        if (unAttemptedWords > 0) {
            mapForFrenzyWindow[puzzleId][frenzyWindowIndex] = Math.floor(unAttemptedWords / frenzyCount);
        }
        var maxValueForFrenzyWindow = frenzyV2Obj.getFrenzyWindowMaxSize(puzzleId);
        if (maxValueForFrenzyWindow == 0 && mapForFrenzyWindow[puzzleId][frenzyWindowIndex] != 0) {
            frenzyV2Obj.setFrenzyWindowMaxSize(puzzleId, mapForFrenzyWindow[puzzleId][frenzyWindowIndex]);
        }
        loggerObj.debugLog("frenzy v2 - check for the frenzy map here FrenzyWindowSize before update ", utilObj.getStringifiedJson(mapForFrenzyWindow));
        if (maxValueForFrenzyWindow != 0 && mapForFrenzyWindow[puzzleId][frenzyWindowIndex] > maxValueForFrenzyWindow) {
            mapForFrenzyWindow[puzzleId][frenzyWindowIndex] = maxValueForFrenzyWindow;
        }
        if (mapForFrenzyWindow[puzzleId][frenzyWindowIndex] < frenzyWindowMinCount) {
            mapForFrenzyWindow[puzzleId][frenzyWindowIndex] = frenzyWindowMinCount;
        }
        frenzyV2Obj.setFrenzyMapForFrenzyWindow(mapForFrenzyWindow);
        loggerObj.debugLog("frenzy v2 - check for the frenzy map here FrenzyWindowSize after update ", utilObj.getStringifiedJson(mapForFrenzyWindow), totalWords, clearWords, frenzyCount, unAttemptedWords);
    };

    /**
     * this function set the variable for total word count in a puzzle, set at every puzzle show function
     * @param val
     */
    this.setTotalWordsInPuzzle = function (val) {
        totalWordsInPuzzle = val;
    };

    /**
     * this function gives the total words count in a puzzle
     * @returns {number}
     */
    this.getTotalWordsInPuzzle = function () {
        return totalWordsInPuzzle;
    };

    /**
     * this function checks if user is eligible for frenzy v2
     * @returns {boolean}
     */
    this.conditionForFrenzyV2Type2 = function () {
        var frenzyV2Exp = frenzyV2Obj.getExperimentAllocationFrenzyV2();
        var isMiniOrMidi = false;//gameObj.checkForMiniOrMidi(gameLayer.crosswordDate);
        var isDailyMini = false;//gameObj.checkForDailyMini(gameLayer.crosswordDate);
        var puzzleEligibleForGenericFrenzy = true;//frenzyV2Obj.checkForInProgressPuzzleForFrenzyCondition(gameLayer.crosswordDate);
        var checkForFrenzyActive = frenzyObj.checkAndUpdateFrenzyActive();

        // switch for the mini freny based on exp
        var switchForMini = true;//!gameObj.checkForMiniOrMidi(gameLayer.crosswordDate) || epmObj.getChosenVariant(constantsObj.EXP_FRENZY_SMALLPUZZLES) == constantsObj.EXP_VAR_1;

        // runtime for node starting frenzy
        var frenzyStartingNodeRuntime = runtimeObj.getFrenzyStart();
        var index = 0;
        if (contentExpXPVariant == constantsObj.EXP_VAR_1) {
            index = 1;
        }
        var splitStr = frenzyStartingNodeRuntime.split(":");
        var runtimeValueToUse = parseInt(splitStr[index]);
        var switchFrenzyNodeOn = false;
        if (linearLevelObj.getDtc2PuzzleCompleted() + 1 >= runtimeValueToUse) {
            switchFrenzyNodeOn = true;
        }

        loggerObj.debugLog("frenzy v2 - conditionForFrenzyV2Type2 frenzyV2Exp-checkForFrenzyActive-isMiniOrMidi-isDailyMini-puzzleEligibleForGenericFrenzy", frenzyV2Exp, checkForFrenzyActive,isMiniOrMidi, isDailyMini, puzzleEligibleForGenericFrenzy);
        if (frenzyV2Exp == constantsObj.EXP_VAR_2 && checkForFrenzyActive && !isMiniOrMidi
            && !isDailyMini && puzzleEligibleForGenericFrenzy && switchForMini && switchFrenzyNodeOn) {
            loggerObj.debugLog("frenzy v2 - conditionForFrenzyV2Type2  true");
            return true;
        }
        loggerObj.debugLog("frenzy v2 - conditionForFrenzyV2Type2  false");
        return false;
    };

    /**
     * this function checks for the puzzle progress before adding it in the puzzleMapForGenericFrenzy
     * if it is inProgress puzzle then we will not add it in puzzleMapForGenericFrenzy to mark it as old inProgress puzzle
     * @param puzzleId
     * @returns {boolean}
     */
    this.checkForInProgressPuzzleForFrenzyCondition = function (puzzleId) {
        var puzzleMapForGenericFrenzy = frenzyV2Obj.getPuzzleMapForGenericFrenzy();
        // loggerObj.debugLog("frenzy v2 - check for the clue number value111 ", utilObj.getStringifiedJson(puzzleMapForGenericFrenzy));
        if (puzzleMapForGenericFrenzy != undefined && puzzleMapForGenericFrenzy[puzzleId] != undefined) {
            // loggerObj.debugLog("frenzy v2 - check for the clue number value112 ");
            return puzzleMapForGenericFrenzy[puzzleId];
        } else {
            var puzzleInProgress = gameObj.isInProgress(puzzleId);
            var isMiniOrMidi = gameObj.checkForMiniOrMidi(puzzleId);
            var isDailyMini = gameObj.checkForDailyMini(puzzleId);
            // loggerObj.debugLog("frenzy v2 - check for the clue number value113 ", puzzleId, puzzleInProgress, isMiniOrMidi, isDailyMini);
            if (puzzleInProgress || isMiniOrMidi || isDailyMini) {
                return false;
            } else {
                // loggerObj.debugLog("frenzy v2 - check for the clue number value114 ");
                if (puzzleMapForGenericFrenzy == undefined) {
                    puzzleMapForGenericFrenzy = {};
                }
                puzzleMapForGenericFrenzy[puzzleId] = true;
                frenzyV2Obj.setPuzzleMapForGenericFrenzy(puzzleMapForGenericFrenzy);
                return true;
            }
        }
        // loggerObj.debugLog("frenzy v2 - check for the clue number value115 ");
        frenzyV2Obj.setPuzzleMapForGenericFrenzy(puzzleMapForGenericFrenzy);
        return false;
    };

    /**
     * this function checks if frenzy can be given by spinner or not
     * @returns {boolean}
     */
    this.checkFrenzyAvailableForSpinner = function () {
        var frenzyCount = frenzyV2Obj.getFrenzyWordsCountForPuzzles(gameLayer.crosswordDate);
        if (frenzyCount == 0) {
            return false;
        }
        var xPos = gameObj.getSelectedX();
        var yPos = gameObj.getSelectedY();
        var randNum = 1;//utilObj.getRandomIntInRange(1, 4);
        gameObj.selectNextClue(randNum, xPos, yPos, true);
        var clueNum = 0;
        var clueForAnswer = gameObj.getclueNumberForAnswer();
        if (clueForAnswer != undefined) {
            clueNum = clueForAnswer;
        }
        if (clueNum == 0) {
            return false;
        }
        clueNum = clueNum.substring(0, clueNum.length - 1);
        var word = gameObj.getWordForClue(clueNum);
        if (word == "") {
            return false;
        }
        var word1 = word;
        var i = 0;
        loggerObj.debugLog("frenzy v2 - checkFrenzyAvailableForSpinner xPos-yPos-clueNum-word-word1", xPos, yPos, clueNum, word);
        while (word1.length > 4 && i < 3) {
            var key = gameObj.getTileLocationForClueNumber(clueNum);
            var yEnd = key.indexOf("_");
            var x = parseInt(key.substring(0, yEnd));
            var y = parseInt(key.substring(yEnd + 1, key.length));
            gameObj.selectNextClue(1, x, y, true);
            clueForAnswer = gameObj.getclueNumberForAnswer();
            if (clueForAnswer != undefined) {
                clueNum = clueForAnswer;
            }
            // loggerObj.debugLog("frenzy v2 - check for the clue number value22 ", gameObj.getclueNumberForAnswer(), x, y, clueNum, word1);
            clueNum = clueNum.substring(0, clueNum.length - 1);
            word1 = gameObj.getWordForClue(clueNum);
            if (word1.length <= 4) {
                break;
            }
            i++;
        }
        if (word1 != null && word1 != undefined && word1 != "") {
            if (word1.length <= 4){
                word = word1;
            }
        }
        loggerObj.debugLog("frenzy v2 - checkFrenzyAvailableForSpinner clueNum-word-word1", clueNum, word);
        if (word == null) {
            return false;
        }
        frenzyWordForSpinner = word;
        return true;
    };

    /**
     * this function check for the frenzy word by spinner for a puzzle
     * @returns {wordsArr if there is any word in the current puzzle marked as frenzy word by spinner}
     */
    this.getFrenzyWordForSpinner = function () {
        var word = frenzyWordForSpinner;
        // loggerObj.debugLog("frenzy v2 - check for the clue number here2 ",word);
        var wordArr = [];
        if (word != null && word != undefined) {
            wordArr.push(word);
            return wordArr;
        }
        return null;
    };

    /**
     * this function check the word for the clue given with the frenzy word by spinner.
     * @param puzzleId
     * @param clueNum
     * @returns {boolean}
     */
    this.checkClueWithFrenzyWordBySpinner = function (puzzleId, clueNum) {
        var mapForFrenzyWordBySpinner = spinnerObj.getMapFrenzyWordPuzzle();
        // loggerObj.debugLog("frenzy v2 - check for clue map here22 ", puzzleId, utilObj.getStringifiedJson(mapForFrenzyWordBySpinner));
        if (mapForFrenzyWordBySpinner == undefined || mapForFrenzyWordBySpinner[puzzleId] == undefined) {
            return false;
        }
        var clueNumber = clueNum.substring(0, clueNum.length - 1);
        var wordTile = gameObj.getWordForClue(clueNumber);
        // loggerObj.debugLog("frenzy v2 - check for clue map here23 ",clueNumber, wordTile);
        loggerObj.debugLog("frenzy v2 - checkClueWithFrenzyWordBySpinner clueNum-wordTile-bool",clueNumber, wordTile, wordTile == mapForFrenzyWordBySpinner[puzzleId]);
        if (wordTile == mapForFrenzyWordBySpinner[puzzleId]) {
            return true;
        }
        return false;
    };

    // setter and getter for all the variables

    this.setLastNPuzzlesWindow = function (val) {
        lastNPuzzlesWindow = val;
    };

    this.getLastNPuzzlesWindow = function() {
        return lastNPuzzlesWindow;
    };

    this.setFrenzyAvailabilityForPuzzleMap = function (val) {
        frenzyAvailabilityForPuzzles = val
    };

    this.getFrenzyAvailabilityForPuzzleMap = function () {
        return frenzyAvailabilityForPuzzles;
    };

    this.setFrenzyMapForFrenzyWindow = function (val) {
        frenzyMapForFrenzyWindow = val;
    };

    this.getFrenzyMapForFrenzyWindow = function () {
        return frenzyMapForFrenzyWindow;
    };

    this.setPuzzleMapForGenericFrenzy = function (val) {
        puzzleMapForGenericFrenzy = val;
    };

    this.getPuzzleMapForGenericFrenzy = function () {
        return puzzleMapForGenericFrenzy;
    };

    /**
     * this function reset the frenzy variable for puzzle which is completed
     * @param puzzleId
     */
    this.resetFrenzyVariableAfterCompletion = function (puzzleId) {
        var mapForFrenzyWindow = frenzyV2Obj.getFrenzyMapForFrenzyWindow();
        if (mapForFrenzyWindow && mapForFrenzyWindow[puzzleId]) {
            mapForFrenzyWindow[puzzleId] = [-1,-1,-1,-1];
        }
        loggerObj.debugLog("frenzy v2 - check for reset variable for completed puzzle before reset ",puzzleId, utilObj.getStringifiedJson(mapForFrenzyWindow));
        frenzyV2Obj.setFrenzyMapForFrenzyWindow(mapForFrenzyWindow);
        frenzyV2Obj.setFrenzyAvailabilityForPuzzles(puzzleId, true);
        var lastNPuzzlesWindow = frenzyV2Obj.getLastNPuzzlesWindow();
        if (lastNPuzzlesWindow) {
            for (var i = 0; i < lastNPuzzlesWindow.length; i++) {
                if (lastNPuzzlesWindow[i] && lastNPuzzlesWindow[i][puzzleId]) {
                    // splice fn removes the n number of elements(2nd parameter) from the array from a particular index
                    lastNPuzzlesWindow.splice(i, 1);
                }
            }
        }
        loggerObj.debugLog("frenzy v2 - check for reset variable for completed puzzle after reset ",puzzleId, utilObj.getStringifiedJson(lastNPuzzlesWindow));
        frenzyV2Obj.setLastNPuzzlesWindow(lastNPuzzlesWindow);
    };

    /**
     * this function return the frenzy window array for current puzzle in form of string for tracking
     * @param puzzleId
     * @returns {frenzy window in string form}
     */
    this.frenzyWindowStringForTracking = function (puzzleId) {
        var clueStr = "";
        var clueArr = frenzyV2Obj.getWindowArrForCurrentPuzzle(puzzleId);
        if (clueArr != null) {
            for (var i = 0; i < clueArr.length; i++) {
                clueStr += clueArr[i];
                if (i != clueArr.length - 1) {
                    clueStr += ":";
                }
            }
        }
        // loggerObj.debugLog("frenzy v2 - check for the last n puzzle window31 ", clueStr);
        return clueStr;
    };
};