// New file for home for handling the ui for the home and logic stuff for the ui
Home = function () {
    var eligibleForStreak = false;
    var streakStartDayTime = 0;
    var streakEndDayTime = 0;
    var streakStatusArr = [];
    var streakArr = [];

    // constants for the mini and big streak
    var MINI_STREAK = 0;
    var BIG_STREAK = 1;

    var ONE_DONE = 1;
    var BOTH_DONE = 2;
    var NONE_DONE = 0;

    var IN_PROGRESS = 1;
    var COMPLETED = 2;
    var CLAIMED = 3;
    var NOT_STARTED = 0;

    // for checking the eligibility of the streak
    this.getEligibilbeForStreak = function () {
        return eligibleForStreak;
    };

    this.setEligibilbeForStreak = function (val) {
        loggerObj.debugLog("todays puzzle date is7", val);
        eligibleForStreak = val;
    };
    // ------------------------------------------

    // calculate streak start and end time based on current time
    this.calculateStreakDays = function () {
        var todaysPuzzleDate = gameObj.getTodaysPuzzleDate();
        var endDate = new Date();
        endDate.setDate(todaysPuzzleDate.getDate() + 6);
        streakStartDayTime = todaysPuzzleDate.getTime();
        streakEndDayTime = endDate.getTime();

        // Streak arr where every index represents the progress over the week
        // 0 -> No solved
        // 1 -> Either of main or mini is solved
        // 2 -> Both Solved
        streakArr = [0, 0, 0, 0, 0, 0, 0];
        streakStatusArr = [0, 0];
        lastIndexViewed = null;
        lastStreakViewedOnHomeScreen = [0, 0, 0, 0, 0, 0, 0];
        // loggerObj.debugLog("todays puzzle date is",  todaysPuzzleDate, new Date(streakStartDayTime), new Date(streakEndDayTime),streakArr);
    };

    // streak start day time and end time and streak arr
    this.getStreakStartDayTime = function () {
        return streakStartDayTime;
    };

    this.getStreakEndDayTime = function () {
        return streakEndDayTime;
    };

    this.setStreakStartDayTime = function (val) {
        streakStartDayTime = val;
    };

    this.setStreakEndDayTime = function (val) {
        streakEndDayTime = val;
    };

    this.getStreakArr = function () {
        return streakArr;
    };

    this.setStreakArr = function (val) {
        streakArr = val;
    };

    this.getStreakStatusArr = function () {
        return streakStatusArr;
    };

    this.setStreakStatusArr = function (val) {
        streakStatusArr = val;
    };

    // updating the progress of the streak whenever todays main or mini is solved
    this.updateStreakProgress = function () {
        if (!eligibleForStreak) {
            return;
        }
        homeObj.streakNullChecks();
        var todaysPuzzleDate = gameObj.getTodaysPuzzleDate();
        var streakIndex = utilObj.getDaysDiff(todaysPuzzleDate, streakStartDayTime);
        if (streakIndex > 6 || streakIndex < 0) {
            homeObj.calculateStreakDays();
            streakIndex = 0;
        }
        var isBroken = checkifStreakBroken(streakIndex);
        if (isBroken) {
            homeObj.calculateStreakDays();
            streakIndex = 0;
        }
        var arr = [];
        for (var i in streakArr) {
            arr.push(streakArr[i]);
        }
        homeObj.setLastStreakIndexViewed(arr);
        streakArr[streakIndex]++;
        if (streakArr[streakIndex] > 2) {
            streakArr[streakIndex] = 2;
        }
        homeObj.updateStreakInProgress();
        homeObj.updateStreakCompletion();
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "","", "hs_streak", streakIndex + 1, gameObj.getCurPuzzleTracking(), streakArr[streakIndex], "", "");
        // loggerObj.debugLog("todays puzzle date is1", streakArr, streakIndex, streakStatusArr, streakStartDayTime, streakEndDayTime);
    };

    // null checks for streak variables
    this.streakNullChecks = function () {
        if (streakArr == [] || streakStartDayTime == 0 || streakEndDayTime == 0 || streakArr == [] || streakStatusArr == []) {
            homeObj.calculateStreakDays();
        }
    };

    // check the current streak progress and reset the streak if a day is missed
    this.checkingStreakCases = function () {
        if (!eligibleForStreak) {
            return;
        }
        homeObj.streakNullChecks();
        var todaysPuzzleDate = gameObj.getTodaysPuzzleDate();
        var diffDays = utilObj.getDaysDiff(todaysPuzzleDate, streakStartDayTime);
        if (diffDays > 6 || diffDays < 0) {
            homeObj.calculateStreakDays();
            return;
        }
        var isBroken = checkifStreakBroken(diffDays);
        if (isBroken) {
            homeObj.calculateStreakDays();
        }
        homeObj.updateStreakInProgress();
        homeObj.updateStreakCompletion();

        // tracking
        var startIndex = new Date(streakStartDayTime).getDay();
        var endIndex = new Date(streakEndDayTime).getDay();
        var streakDayMap = constantsObj.streakDayMap;
        trackObj.trackCounter("hs_streak", streakDayMap[startIndex], streakDayMap[endIndex], homeObj.getStreakJsonArr() , "", "", "", "", "");
        // loggerObj.debugLog("todays puzzle date is2", streakArr, streakStatusArr, streakStartDayTime, streakEndDayTime);
    };

    // check if streak completed
    // sets the variables for the streak completion and claimed
    this.updateStreakCompletion = function () {
        var bigStreak = true;
        var miniStreak = true;
        for (var i = 0; i < 7 ; i++) {
            if (streakArr[i] < 2 ) {
                bigStreak = false;
            }
            if (streakArr[i] < 1) {
                miniStreak = false;
            }
        }
        if (streakStatusArr[MINI_STREAK] != CLAIMED) {
            if (miniStreak) {
                streakStatusArr[MINI_STREAK] = COMPLETED;
            }
        }
        if (streakStatusArr[BIG_STREAK] != CLAIMED) {
            if (bigStreak) {
                streakStatusArr[BIG_STREAK] = COMPLETED;
            }
        }
    };

    // to set which streak this user is about to get to and show gift box acc.
    this.updateStreakInProgress = function () {
        var todaysPuzzleDate = gameObj.getTodaysPuzzleDate();
        var diffDays = utilObj.getDaysDiff(todaysPuzzleDate, streakStartDayTime);
        var miniInProgress = true;
        var bigInProgress = true;
        for (var i = 0; i < diffDays ; i++) {
            if (streakArr[i] < 2) {
                bigInProgress = false;
            }
        }
        if (streakStatusArr[BIG_STREAK] != CLAIMED && streakStatusArr[BIG_STREAK] != COMPLETED) {
            if (bigInProgress) {
                streakStatusArr[BIG_STREAK] = IN_PROGRESS;
            } else {
                streakStatusArr[BIG_STREAK] = NOT_STARTED;
            }
        }
        if (streakStatusArr[MINI_STREAK] != CLAIMED && streakStatusArr[MINI_STREAK] != COMPLETED) {
            streakStatusArr[MINI_STREAK] = IN_PROGRESS;
        }
    };

    // setting the claim status for the streak
    this.setMiniStreakClaimed = function () {
        streakStatusArr[MINI_STREAK] = CLAIMED;
    };

    this.setBigStreakClaimed = function () {
        streakStatusArr[BIG_STREAK] = CLAIMED;
    };
    // ----------

    // checking the streak is holding or broken on current day
    function checkifStreakBroken(diffDays) {
        for (var i = 0; i < diffDays ; i++) {
            if (streakArr[i] == 0) {
                return true;
            }
        }
        return false;
    };

    // get stringified streak arr
    this.getStreakJsonArr = function () {
        var returnArrStr = "";
        for (var i in streakArr) {
            if (i == streakArr.length - 1) {
                returnArrStr += streakArr[i]
            } else {
                returnArrStr += streakArr[i] + "^";
            }
        }
        loggerObj.debugLog("string is", streakArr,returnArrStr);
        // homeObj.setStreakArrFromServer(returnArrStr);
        return returnArrStr;
    };

    // decode stringified json from server
    this.setStreakArrFromServer = function (val) {
        var arr = val.split("^");
        loggerObj.debugLog("string is3", arr);
        streakArr = [0, 0 ,0 ,0 ,0, 0 ,0];
        for(var i in arr) {
            loggerObj.debugLog("string is2", arr[i]);
            streakArr[i] = parseInt(arr[i]);
        }
        loggerObj.debugLog("string is1", val, streakArr);
    };

    //updating on fb login
    this.updateStreakProgressFromServer = function () {
      homeObj.checkingStreakCases();
      homeObj.updateStreakInProgress();
      homeObj.updateStreakCompletion();
      if (streakStatusArr[MINI_STREAK] == COMPLETED) {
          homeObj.setMiniStreakClaimed();
      }
      if (streakStatusArr[BIG_STREAK] == COMPLETED) {
          homeObj.setBigStreakClaimed();
      }
    };

    // animation streak func

    // animation func for streak
    var lastIndexViewed = null;
    var lastStreakViewedOnHomeScreen = null;
    var percentageCompletedMain = null;
    var percentageCompletedMini = null;

    this.getLastIndexViewed = function () {
        return lastIndexViewed;
    };

    this.setLastIndexViewed = function (val) {
        lastIndexViewed = val;
    };

    this.setLastStreakIndexViewed = function (val) {
        lastStreakViewedOnHomeScreen = val;
    };

    this.getLastStreakIndexViewed = function () {
        return lastStreakViewedOnHomeScreen;
    };

    this.getPercentageCompletedMini = function () {
        return percentageCompletedMini;
    };

    this.setPercentageCompletedMini = function (val) {
        percentageCompletedMini = val;
    };

    this.getPercentageCompletedMain = function () {
        return percentageCompletedMain;
    };

    this.setPercentageCompletedMain = function (val) {
        percentageCompletedMain = val;
    };

    this.shiftAnimStreak = function (sender, params) {
        var bg = params.bg;
        var finalXPos = params.finalXPos;
        var finalYPos = params.finalYPos;
        var move1 = new cc.MoveTo(0.3, finalXPos, finalYPos);
        var ease1 = move1.easing(new cc.easeOut(1.0));
        animObj.runAction(bg, move1);
    };

    this.pulseAnimateBg = function (node) {
        var sX = node.getScaleX();
        var sY = node.getScaleY();

        var scaleWide = utilObj.getScaleTo(0.4, sX * 1.04, sY * 1.04);
        var scaleVertical = utilObj.getScaleTo(0.6, sX, sY);
        var scaleNormal = utilObj.getScaleTo(0.3, sX, sY);
        var actions = [];
        actions.push(scaleWide);
        actions.push(scaleVertical);
        actions.push(scaleNormal);
        var seqAction = utilObj.getSequence(actions);
        var seqRepeat;
        seqRepeat = new cc.RepeatForever(seqAction);
        animObj.runAction(node, seqRepeat, true);
    };

    this.animateProgressbar = function (sender, params) {
        var progressTimer = params.timer;
        var percentFrom = params.pFrom;
        var percentTo = params.pTo;
        if (percentTo > percentFrom && !utilObj.isWeb()) {
            animObj.runAction(progressTimer, cc.targetedAction(progressTimer, cc.ProgressFromTo(0.5, percentFrom, percentTo)));
        }
    };

    this.animateTickToStreakBg = function (sender, params) {
        var bg = params.bg;
        var progressTimer = params.timer;
        var percent = params.percent;
        var tickbg = params.tick;
        var innerCircle = params.innerCircle;
        var outerCircle = params.outerCircle;
        var xFinal = homeLayer.xPosToAnimate;
        var yFinal = homeLayer.yPosToAnimate;
        var ease_rate = 1;
        var delayTot = 0;

        animObj.runAction(progressTimer, cc.targetedAction(progressTimer, cc.ProgressFromTo(0.2, percent, 100)));
        delayTot += 0.2;

        var scaleD = animObj.getScaleDifferentTo(0.15, 0.6, 0.6);
        var scaleU = animObj.getScaleDifferentTo(0.15, constantsObj.SCALE_SPRITE_7, constantsObj.SCALE_SPRITE_7);
        var animS = [utilObj.getDelayTime(delayTot), scaleD, scaleU];

        var scaleD1 = animObj.getScaleDifferentTo(0.15, 0.6, 0.6);
        var scaleU1 = animObj.getScaleDifferentTo(0.15, constantsObj.SCALE_SPRITE_1, constantsObj.SCALE_SPRITE_1);
        var animS1 = [utilObj.getDelayTime(delayTot), scaleD1, scaleU1];

        var scaleD2 = animObj.getScaleDifferentTo(0.15, 0.45, 0.45);
        var scaleU2 = animObj.getScaleDifferentTo(0.15, constantsObj.SCALE_SPRITE_7 * 0.93, constantsObj.SCALE_SPRITE_7 * 0.93);
        var animS2 = [utilObj.getDelayTime(delayTot), scaleD2, scaleU2];

        var scaleD3 = animObj.getScaleDifferentTo(0.15, 0.6, 0.6);
        var scaleU3 = animObj.getScaleDifferentTo(0.15, constantsObj.SCALE_SPRITE_1, constantsObj.SCALE_SPRITE_1);
        var animS3 = [utilObj.getDelayTime(delayTot), scaleD3, scaleU3];


        animObj.runAction(tickbg, utilObj.getSequence(animS));
        animObj.runAction(progressTimer, utilObj.getSequence(animS1));
        animObj.runAction(innerCircle, utilObj.getSequence(animS2));
        animObj.runAction(outerCircle, utilObj.getSequence(animS3));

        var colorTo = new cc.TintTo(0.05, 0, 181, 229);
        var animS4 = [utilObj.getDelayTime(delayTot - 0.05), colorTo];
        animObj.runAction(tickbg,  utilObj.getSequence(animS4));


        if (homeLayoutExpNew != constantsObj.EXP_VAR_2) {
            return;
        }

        delayTot += 0.5;

        if (!utilObj.isNodeValid(bg)) {
            return;
        }

        var position1 = {
            x: bg.getPositionX(),
            y: bg.getPositionY()
        };

        var midPosX = (xFinal - bg.getPositionX()) / 2 + bg.getPositionX();
        var midPosY = (bg.getPositionY() - yFinal) / 2 + yFinal;
        if (xFinal < bg.getPositionX()) {
            midPosX = (bg.getPositionX() - xFinal) / 2 + xFinal;
        }

        var position2 = {
            x: midPosX + 150,
            y: midPosY
        };

        var position3 = {
            x: xFinal,
            y: yFinal
        };

        var positions = [position1,position2, position3];
        var move = animObj.getCardinalSplineTo(0.45, positions, 0).easing(new cc.easeOut(ease_rate));

        var fadeIn = utilObj.getFadeIn(0.01);
        var scaleTo = utilObj.getScaleTo(0.29, constantsObj.SCALE_SPRITE_1 * 2.5);
        var scaleDown = utilObj.getScaleTo(0.16, constantsObj.SCALE_SPRITE_1 );
        var animSeq = [fadeIn, scaleTo, scaleDown];

        var spawn = new cc.Spawn(move, utilObj.getSequence(animSeq));

        var animArr = [];
        animArr.push(utilObj.getDelayTime(delayTot));
        animArr.push(spawn);
        delayTot += 0.45;

        var params1 = {
            x: xFinal,
            y: yFinal,
            layer: homeLayer.scrollView,
            scale: 1,
            zOrder: constantsObj.FTUE_Z_ORDER - 1
        };
        utilObj.delayedCallback(homeLayer.scrollView, effectsObj.playBoxEffect, delayTot, params1, false);

        // var params1 = {
        //     x: xFinal,
        //     y: yFinal,
        //     layer: homeLayer.scrollView,
        //     scale: 1,
        //     zOrder: constantsObj.FTUE_Z_ORDER - 1
        // };
        // utilObj.delayedCallback(homeLayer.scrollView, effectsObj.playDotEffect, delayTot, params1, false);


        var params1 = {
            x: xFinal,
            y: yFinal,
            layer: homeLayer.scrollView,
            scale: 1,
            zOrder: constantsObj.FTUE_Z_ORDER - 1
        };
        utilObj.delayedCallback(homeLayer.scrollView, effectsObj.playRoundEffect, delayTot, params1, false);


        var delaytime = utilObj.getDelayTime(0.1);
        animArr.push(delaytime);
        delayTot += 0.1;

        var scaleDown1 = utilObj.getScaleTo(0.1, constantsObj.SCALE_SPRITE_1 * 0.5);
        var scaleUp1 = utilObj.getScaleTo(0.1, constantsObj.SCALE_SPRITE_1 * 0.7);

        animArr.push(scaleDown1);
        animArr.push(scaleUp1);
        delayTot += 0.2;

        var fadeOut = utilObj.getFadeOut(0.1);
        animArr.push(fadeOut);
        delayTot += 0.1;

        var del = utilObj.getRemoveSelf();
        animArr.push(del);

        animObj.runAction(bg, utilObj.getSequence(animArr));

        var delay =  utilObj.getDelayTime(delayTot);
        var scaleDown1 = utilObj.getScaleTo(0.1, 0);
        var animSeq = [delay, scaleDown1];
        animObj.runAction(homeLayer.todaysStreakTick, utilObj.getSequence(animSeq));
        delayTot += 0.1;

        var scale = constantsObj.SCALE_SPRITE_1 * 0.7;
        var imageToShow = constantsObj.tick_streak1;
        var color = constantsObj.COLOR_BLUE_HS_NEW;

        var idTheme = gameObj.getIdForTodaysPuzzle();
        if (gameObj.getInstallDay() != 0 && gameObj.getInstallDay() == gameObj.getIdForTodaysPuzzle()) {
            idTheme = gameObj.getD0Id();
        }
        var idMini = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
        idMini = stringsObj.mini_prefix + idMini.substr(2, idMini.length);
        var idThemeCompleted = gameObj.getPuzzleCompleted(idTheme);
        var idMiniCompleted = gameObj.getPuzzleCompleted(idMini);

        if (idThemeCompleted && idMiniCompleted) {
            scale = constantsObj.SCALE_SPRITE_3 * 0.65;
            imageToShow = constantsObj.tick_streak2;
            color = constantsObj.COLOR_PURPLE_03;
        }
        var newTickTemp = utilObj.getSprite(imageToShow, utilObj.getPositionX(homeLayer.todaysStreakTick), utilObj.getPositionY(homeLayer.todaysStreakTick), 0.5, 0.5, scale, null, null, constantsObj.FTUE_Z_ORDER, constantsObj.SPRITE_MISC);
        utilObj.addChild(homeLayer.scrollView, newTickTemp, constantsObj.FTUE_Z_ORDER);
        homeLayer.arr_node.push(newTickTemp);
        newTickTemp.setScale(0);
        newTickTemp.setColor(color);

        var delay1 = utilObj.getDelayTime(0.4);
        var delayT = utilObj.getDelayTime(delayTot);
        var scaleUp1 = utilObj.getScaleTo(0.1, scale * 1.2);
        var delayT1 = utilObj
        var scaleDown2 = utilObj.getScaleTo(0.2, scale);
        var animSeq1 = [delayT, scaleUp1, delay1, scaleDown2];
        animObj.runAction(newTickTemp, utilObj.getSequence(animSeq1));

        var scaleUp2 = animObj.getScaleDifferentTo(0.1, 1.2, 1.2);
        var scaleDown2= animObj.getScaleDifferentTo(0.2, 1.0, 1.0);

        var animSeq2 = [delayT, scaleUp2, delay1, scaleDown2];
        animObj.runAction(homeLayer.streakBg, utilObj.getSequence(animSeq2));

        var scaleUp3 = animObj.getScaleDifferentTo(0.1, 1.2, 1.2);
        var scaleDown3= animObj.getScaleDifferentTo(0.2, 0.9, 0.8);

        var animSeq3 = [delayT, scaleUp3, delay1, scaleDown3];
        animObj.runAction(homeLayer.todaysStreakTxt, utilObj.getSequence(animSeq3));

        var scaleUp = animObj.getScaleDifferentTo(0.1, 1.2, 1.2);
        var scaleDown2= animObj.getScaleDifferentTo(0.2, 1.0, 1.0);
    };

    // load listItems for the scrollView to show
    this.loadTodayPositionInfo = function () {
        var d = gameObj.getTodaysPuzzleDate();
        var day = d.getDay();

        var listItems = [
            {
                fn: "loadTodaysPuzzle",
                sectionHeight: 350,
                trackF: constantsObj.TRACK_TODAYS_PUZZLE,
                headerText: stringsObj.TODAYS_PUZZLE,
                extraYOffset: 0,
                section: [
                    {
                        text: stringsObj.themed_crossword,
                        text_2: stringsObj.puzzle_themes[day],
                        subText: utilObj.getFormattedDate(d),
                        circleSprite: constantsObj.LOGO_FOR_DAYS_NEW_ICON[day],
                        headerTextSize: constantsObj.FONT_ROBOTO_MEDIUM_80,
                        hasFreeTag: true,
                        day: day,
                        color_theme_start: constantsObj.COLOR_THEME_COLLECTION_START[day],
                        color_theme_end: constantsObj.COLOR_THEME_COLLECTION_END[day],
                        color: constantsObj.COLOR_RED_01
                    }
                ]
            },
            {
                fn: "loadDailyMiniPuzzle",
                sectionHeight: 350,
                trackF: constantsObj.TRACK_DAILY_MINI,
                headerText: stringsObj.Daily_mini_puzzle,
                extraYOffset: 0,
                section: [
                    {
                        text: stringsObj.Daily_mini,
                        text_2: stringsObj.pint_sized_crossword,
                        subText: utilObj.getFormattedDate(d),
                        circleSprite: constantsObj.mini_pack_icon,
                        headerTextSize: constantsObj.FONT_ROBOTO_MEDIUM_80,
                        hasFreeTag: true,
                        day: day,
                        color_theme_start: constantsObj.COLOR_MINI_COLLECTION_START[day],
                        color_theme_end: constantsObj.COLOR_MINI_COLLECTION_END[day],
                        color: constantsObj.COLOR_RED_01
                    }
                ]
            },
            {
                headerText: "Streak",
                streakArr: streakArr,
                streakStatusArr: streakStatusArr,
                streakStartTime: streakStartDayTime,
                streakEndTime: streakEndDayTime
            },
            {
                headerText: stringsObj.MORE_SECTION,
                trackF: constantsObj.TRACK_OLD
            },
            {
                headerText: stringsObj.Explore_more,
                trackF: constantsObj.TRACK_CALENDAR
            },
            {
                headerText: stringsObj.IN_PROGRESS,
                fn: "loadPuzzle",
                trackF: constantsObj.TRACK_OLD,
                section: homeObj.getSectionsForRecentPuzzles()
            }
        ];
        return listItems;
    };
    // get inprogress puzzles to display on hs
    this.getSectionsForRecentPuzzles = function () {

        // sets d0 info for the puzzls based on exp
        gameObj.setD0ArchivePuzzlesInfo();
        var sections = [];
        gameObj.loadRecentInProgress();
        var recentInProgress = gameObj.getRecentInProgress();
        var todaysId = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
        for (var i in recentInProgress) {
            var id = recentInProgress[i];
            if (id == todaysId || gameObj.checkForMiniOrMidi(id) || id == gameObj.getTodaysFreePuzzle()) {
                continue;
            }
            if (parseInt(id) < 20170301) {
                continue;
            }
            if (homeObj.forceCheckIfCrossWordComplete(id)) {
                trackObj.trackCounter(constantsObj.TRACK_DEBUG, "", id, "inProgress_complete", "", "", "", "1", "");
                gameObj.removeFromInProgressForDate(id);
                continue;
            }
            var date = utilObj.getDateForId(id);
            var formattedDate = utilObj.getFormattedDate(date);
            var day = date.getDay();
            var section = {
                id: id,
                text: stringsObj.puzzle_themes[day],
                subText: formattedDate,
                circleSprite: constantsObj.LOGO_FOR_DAYS_NEW_ICON[day],
                day: day
            };
            sections.push(section);
        }
        homeLayer.sections = sections;
        return sections;
    };

    // check if crossword complete for the given puzzle id
    this.forceCheckIfCrossWordComplete = function (id) {
        var curCrosswordInfo = gameObj.getCrosswordForDate(id);
        if (curCrosswordInfo == null) {
            // loggerObj.debugLog("check if crossword complete3");
            return false;
        }
        var answerGrid = curCrosswordInfo.g;
        var gridHeight = curCrosswordInfo.h;
        var gridWidth = curCrosswordInfo.w;
        var attemptGrid = {};

        var inProg = gameObj.getInProgress();

        if (inProg[id]) {
            var oldInfo = {};
            try {
                oldInfo = JSON.parse(utilObj.getStringifiedJson(inProg[id]));
            } catch (e) {
                trackObj.trackCounter(constantsObj.TRACK_DEBUG, "json_reload_inprogress", "", constantsObj.TRACK_FAIL, "", "", "", "1", "");
            }
            var check = gameObj.checkIfGridsMatch(oldInfo.attemptGrid, answerGrid);
            if (!check) {
                oldInfo.attemptGrid = null;
            }
            if (oldInfo.attemptGrid) {
                attemptGrid = oldInfo.attemptGrid;
            }

            var ifComplete = checkIfCrosswordComplete(answerGrid, attemptGrid, gridWidth, gridHeight);
            return ifComplete;
        }

        return false;
    };

    function checkIfCrosswordComplete(answerGrid, attemptedT, gridWidth, gridHeight) {
        var hasIncorrectTiles = false;
        if (gridWidth == 0 || gridHeight == 0) {
            return hasIncorrectTiles;
        }
        for (var x = 0; x < gridWidth && !hasIncorrectTiles; x++) {
            for (var y = 0; y < gridHeight && !hasIncorrectTiles; y++) {
                if (answerGrid[x] == undefined || answerGrid[x][y] == undefined) {
                    return false;
                }
                var ansTile = answerGrid[x][y];
                if (ansTile != constantsObj.BLANK_TILE) {
                    if (attemptedT[x] == undefined || attemptedT[x][y] == undefined) {
                        return false;
                    }
                    var attemptedTile = attemptedT[x][y];
                    if (attemptedTile != ansTile) {
                        hasIncorrectTiles = true;
                    }
                }
            }
        }
        return !hasIncorrectTiles;
    };

    this.getPercentageSolvedPuzzle = function (id) {
        var crosswordInfo = gameObj.getCrosswordForDate(id);
        var score = scoresObj.getHighScore(id);
        if (crosswordInfo != null) {
            var fillCount = crosswordInfo.fc;
            var inProgress = gameObj.getInProgress();
            var filled = 0;
            if (inProgress[id]) {
                filled = inProgress[id].filled;
            } else if (score > 0) {
                filled = fillCount;
            }
            loggerObj.debugLog("filled count is", fillCount, filled);
            var percentC = Math.floor(filled/ fillCount * 100);
            return percentC > 100? 100: percentC;
        }
        return 0;
    };

    this.calculatePackProgress = function (id, packType) {
        if (id == -1) {
            return 0;
        }
        var packTypeVar = constantsObj.NORMAL_PACKS;
        if (packType) {
            packTypeVar = packType;
        }
        var packInfo = gameObj.getPackInfoForPackType(packTypeVar);
        var packArr = packInfo[id];
        var sumFilled = 0;
        var sumTotal = 0;
        for (var i = 0; i < packArr.length; i++) {
            var packPuzzleId = packArr[i];
            var crosswordInfo = gameObj.getCrosswordForDate(packPuzzleId);
            var score = scoresObj.getHighScore(packPuzzleId);
            if (crosswordInfo != null) {
                var fillCount = crosswordInfo.fc;
                var inProgress = gameObj.getInProgress();
                var filled = 0;
                if (inProgress[packPuzzleId]) {
                    filled = inProgress[packPuzzleId].filled;
                } else if (score > 0) {
                    filled = fillCount;
                }
                sumFilled += filled;
                sumTotal += fillCount;
            }
        }
        var percentC = Math.floor(sumFilled / sumTotal * 100);
        return percentC > 100 ? 100 : percentC;
    };

    this.getMoreForYouItems = function () {
        var d = gameObj.getTodaysPuzzleDate();
        var day = d.getDay();
        var archiveId = null;
        var puzzleType = "";
        var paidArchiveId = null;
        var paidPuzzleType = "";
        archiveId = gameObj.checkForFirstUnOpenedPuzzle("subs");
        puzzleType = stringsObj.premium_archive_puzzle;
        if (archiveId != null) {
            gameObj.setSubsTodaysFreePuzzle(archiveId);
        }
        if (archiveId == null) {
            archiveId = gameObj.checkForFirstUnOpenedPuzzle("bonus_archive");
            puzzleType = stringsObj.bonus_archive;
            if (archiveId != null) {
                if (gameObj.getTodaysFreePuzzle() == null) {
                    gameObj.setNumberOfBonusArchiveWatched(gameObj.getNumberOfBonusArchiveWatched() + 1);
                }
                gameObj.setTodaysFreePuzzle(archiveId);
            }
        }

        paidArchiveId = gameObj.checkForFirstUnOpenedPuzzle("paid_archive");
        paidPuzzleType = stringsObj.paid_archive;
        if (paidArchiveId != null) {
            gameObj.setTodaysPaidPuzzle(paidArchiveId);
        }
        var bonusMiniId = gameObj.checkForBonusMiniPuzzle();
        var trackF = "archive_puzzle";
        var paidTrackF = "archive_puzzle";
        if (puzzleType == stringsObj.bonus_archive) {
            trackF = "w2e_archive";
        }
        var britPackId = constantsObj.NUM_BRIT_PACKS - 1;
        loggerObj.debugLog("check for the items 4 ", puzzleType);
        var listItems = [
            {
                headerColor: constantsObj.COLOR_BLUE_04,
                headerLine: constantsObj.COLOR_LIGHT_RED_LINE,
                headerText: stringsObj.archive_type,
                fn: "loadArchiveTypePuzzle",
                trackF: trackF,
                sectionHeight: 312,
                puzzleId: archiveId,
                params: {id: archiveId, type: puzzleType},
                section: [
                    {
                        text: puzzleType,
                        freeTag: (puzzleType == stringsObj.PREMIUM_ARCHIVE_PUZZLE || puzzleType == stringsObj.bonus_archive)?true:false,
                        videoIcon: (puzzleType == stringsObj.bonus_archive)?true:false,
                        // subText: stringsObj.blitz_best_score,
                        // circleSprite: constantsObj.blitz_mode_icon,
                        headerTextSize: constantsObj.FONT_ROBOTO_MEDIUM_80,
                        day: day,
                    }
                ],
                extraYOffset: 0
            },
            {
                headerColor: constantsObj.COLOR_BLUE_04,
                headerLine: constantsObj.COLOR_LIGHT_RED_LINE,
                headerText: stringsObj.bonus_mini,
                fn: "loadDailyMiniPuzzle",
                trackF: constantsObj.TRACK_DAILY_MINI_BONUS,
                sectionHeight: 312,
                puzzleId: bonusMiniId,
                params: {id: bonusMiniId},
                section: [
                    {
                        text: stringsObj.bonus_mini,
                        freeTag: true,
                        // subText: stringsObj.blitz_best_score,
                        // circleSprite: constantsObj.blitz_mode_icon,
                        headerTextSize: constantsObj.FONT_ROBOTO_MEDIUM_80,
                        day: day,
                    }
                ],
                extraYOffset: 0
            },
            {
                headerColor: constantsObj.COLOR_BLUE_04,
                headerLine: constantsObj.COLOR_LIGHT_RED_LINE,
                headerText: stringsObj.mini_puzzle_pack,
                fn: "showPacksQuick",
                trackF: constantsObj.TRACK_PACK_QUICK,
                sectionHeight: 312,
                section: [
                    {
                        text: stringsObj.mini_puzzle_pack,
                        // subText: stringsObj.blitz_best_score,
                        // circleSprite: constantsObj.blitz_mode_icon,
                        headerTextSize: constantsObj.FONT_ROBOTO_MEDIUM_80,
                        day: day,
                    }
                ],
                extraYOffset: 0
            },
            {
                headerColor: constantsObj.COLOR_BLUE_04,
                headerLine: constantsObj.COLOR_LIGHT_RED_LINE,
                headerText: stringsObj.GAMES_MODES,
                fn: "loadBlitzMode",
                trackF: constantsObj.TRACK_BLITZ,
                sectionHeight: 392,
                section: [
                    {
                        text: stringsObj.Blitz_mode_string,
                        subText: stringsObj.blitz_best_score,
                        circleSprite: constantsObj.blitz_mode_icon_white,
                        headerTextSize: constantsObj.FONT_ROBOTO_MEDIUM_80,
                        day: day,
                    }
                ],
                extraYOffset: 0
            },
            {
                headerColor: constantsObj.COLOR_BLUE_04,
                headerLine: constantsObj.COLOR_LIGHT_RED_LINE,
                headerText: stringsObj.paid_archive_type,
                fn: "loadArchiveTypePuzzle",
                trackF: paidTrackF,
                sectionHeight: 312,
                puzzleId: paidArchiveId,
                params: {id: paidArchiveId, type: paidPuzzleType},
                section: [
                    {
                        text: paidPuzzleType,
                        freeTag: false,
                        videoIcon: false,
                        // subText: stringsObj.blitz_best_score,
                        // circleSprite: constantsObj.blitz_mode_icon,
                        headerTextSize: constantsObj.FONT_ROBOTO_MEDIUM_80,
                        day: day,
                    }
                ],
                extraYOffset: 0
            },
            {
                headerColor: constantsObj.COLOR_BLUE_04,
                headerLine: constantsObj.COLOR_LIGHT_RED_LINE,
                headerText: stringsObj.brit_puzzle_pack,
                fn: "showBritPackQuick",
                trackF: constantsObj.TRACK_BRIT_PACK_CLICK,
                trackG: britPackId,
                sectionHeight: 312,
                section: [
                    {
                        text: stringsObj.brit_puzzle_pack,
                        // subText: stringsObj.blitz_best_score,
                        // circleSprite: constantsObj.blitz_mode_icon,
                        headerTextSize: constantsObj.FONT_ROBOTO_MEDIUM_80,
                        day: day,
                    }
                ],
                extraYOffset: 0
            },
        ];
        var listItemNew = homeObj.getListInOrder(listItems);
        return listItemNew;
    };

    this.getExploreMoreItems = function () {
        var listItems = [
            {
                headerText: stringsObj.CALENDAR_TEXT,
                fn: "loadCalendar",
                sectionHeight: 312,
                icon: constantsObj.calendar_icon,
                trackF: constantsObj.TRACK_CALENDAR
            },
            {
                headerText: stringsObj.PACK_TEXT,
                fn: "showPacks",
                sectionHeight: 312,
                icon: constantsObj.pack_icon,
                trackF: constantsObj.TRACK_PACK
            }
        ];
        return listItems;
    };

    // Home Screen Featured List Items
    var archiveTypeItem = null;
    var bonusMiniItem = null;
    var miniPuzzlePackItem = null;
    var gamesModesItem = null;
    var paidArchiveTypeItem = null;
    var britPuzzlePackItem = null;

    /**
     * this initialises home screen featured items
     */
    this.initFeaturedListItems = function () {
        archiveTypeItem = null;
        bonusMiniItem = null;
        miniPuzzlePackItem = null;
        gamesModesItem = null;
        paidArchiveTypeItem = null;
        britPuzzlePackItem = null;
    };

    /**
     * this updates the values for the home screen featured items
     * @param listItems
     */
    this.checkAndUpdateFeaturedListItems = function (listItems) {
        homeObj.initFeaturedListItems();
        // items for more for you section i.e featured section
        var zenAvailability = zenModeObj.isZenModeAvailable();
        var newPackTimeStamp = gameObj.getNewPackTimestamp();
        var curTimestamp = utilObj.getCurrentTimestamp();
        var id = -1;

        if (id == -1 && newPackTimeStamp != null && curTimestamp - newPackTimeStamp <= 3 * constantsObj.SECONDS_IN_DAY) {
            id = constantsObj.NUM_PACKS - 1;
            if (gameObj.checkIfPackComplete(id)) {
                id = -1;
            }
        }
        if (id == -1) {
            var packId = gameObj.getLastInteractedPackId();
            if (packId != null && !gameObj.checkIfPackComplete(packId)) {
                id = packId;
            }
        }
        if (id == -1) {
            id = gameObj.getPackIdSurfaced();
        }
        if (id == -1) {
            id = gameObj.getPackIdSurfacedToBuy();
        }

        var listItemsCount = listItems.length;
        for(var ind = 0; ind < listItemsCount; ind++) {
            if (listItems[ind].headerText == stringsObj.archive_type && listItems[ind].puzzleId != null){
                archiveTypeItem = listItems[ind];
            } else if(listItems[ind].headerText == stringsObj.bonus_mini && listItems[ind].puzzleId != null){
                bonusMiniItem = listItems[ind];
            } else if(listItems[ind].headerText == stringsObj.mini_puzzle_pack && id!=-1){
                miniPuzzlePackItem = listItems[ind];
            } else if(listItems[ind].headerText == stringsObj.GAMES_MODES && zenAvailability){
                gamesModesItem = listItems[ind];
            } else if(listItems[ind].headerText == stringsObj.paid_archive_type && listItems[ind].puzzleId != null){
                paidArchiveTypeItem = listItems[ind];
            } else if(listItems[ind].headerText == stringsObj.brit_puzzle_pack && gameObj.shouldSurfaceBritPack(constantsObj.SCREEN_HOME)){
                britPuzzlePackItem = listItems[ind];
            }
        }
    };

    /**
     * this function returns ordered array for featured items in home screen
     * @returns {[*,*,*,*,*]}
     */
    this.getFeaturedItemsOrdered = function () {
        var todayMiniCompleted = false;
        var bonusMiniCompleted = false;
        var idTheme = gameObj.getIdForTodaysPuzzle();
        if (gameObj.getInstallDay() != 0 && gameObj.getInstallDay() == gameObj.getIdForTodaysPuzzle()) {
            idTheme = gameObj.getD0Id();
        }
        var idThemeCompleted = gameObj.getPuzzleCompleted(idTheme);
        var puzzleIdDailyMini = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
        var puzzleIdDailyMini = stringsObj.mini_prefix + puzzleIdDailyMini.substr(2, puzzleIdDailyMini.length);
        if (gameObj.getPuzzleCompleted(puzzleIdDailyMini)) {
            todayMiniCompleted = true;
        }
        var bonusMiniArchiveId = gameObj.getDailyMiniArchiveId();
        if (bonusMiniArchiveId == null || (bonusMiniArchiveId != null && gameObj.getPuzzleCompleted(bonusMiniArchiveId))) {
            bonusMiniCompleted = true;
        }

        var orderedFeaturedItemsArr = [archiveTypeItem, paidArchiveTypeItem, bonusMiniItem, miniPuzzlePackItem, gamesModesItem];
        // loggerObj.debugLog("featuredItemsListLog: todayMiniCompleted, bonusMiniCompleted, idThemeCompleted -> ", todayMiniCompleted, bonusMiniCompleted, idThemeCompleted);
        if (todayMiniCompleted && bonusMiniCompleted && !idThemeCompleted) {
            // loggerObj.debugLog("featuredItemsListLog: 1");
            orderedFeaturedItemsArr = [miniPuzzlePackItem, archiveTypeItem, paidArchiveTypeItem, gamesModesItem, bonusMiniItem];
        } else if (todayMiniCompleted && !idThemeCompleted) {
            // loggerObj.debugLog("featuredItemsListLog: 2");
            orderedFeaturedItemsArr = [bonusMiniItem, miniPuzzlePackItem, gamesModesItem, archiveTypeItem, paidArchiveTypeItem];
        }

        return orderedFeaturedItemsArr;
    };

    /**
     * checks and returns only the list of items available for featured section
     * @param listItems
     * @returns {Array}
     */
    this.getListInOrder = function (listItems) {
        var listItemArr = [];
        homeObj.checkAndUpdateFeaturedListItems(listItems);
        var orderedFeaturedItemsArr = homeObj.getFeaturedItemsOrdered();

        var numItems = orderedFeaturedItemsArr.length;
        for(var i = 0; i < numItems; i++){
            if(orderedFeaturedItemsArr[i] != null){
                listItemArr.push(orderedFeaturedItemsArr[i]);
            }
        }


        // Handling brit pack item separately as it needs to be in 2nd position in the final list
        var listItemArrLen = listItemArr.length;
        if (britPuzzlePackItem != null) {
            listItemArr.splice(Math.min(1, listItemArrLen), 0, listItems[5]);
        }

        return listItemArr;
    };
    // Ftue ---

    var spritesToRemove = [];
    var isHomeFtueShown = false;
    var isMiniFtueVisible = false;
    var isMiniPuzzleClicked = false;
    var isStreakPopupShown = false;

    this.getisHomeFtueShown = function() {
        return isHomeFtueShown;
    };

    this.setIsHomeFtueShown = function (val) {
        isHomeFtueShown = val;
    };

    this.getIsMiniPuzzleClicked = function() {
        return isMiniPuzzleClicked;
    };

    this.setIsMiniPuzzleClicked = function (val) {
        isMiniPuzzleClicked = val;
    };

    this.setIsMiniFtueVisible = function (val) {
        isMiniFtueVisible = val;
    };

    this.getIsMiniFtueVisible = function () {
        return isMiniFtueVisible;
    };

    this.getIsStreakPopupShown = function() {
        return isStreakPopupShown;
    };

    this.setIsStreakPopupShown = function (val) {
        isStreakPopupShown = val;
    };



    this.showHomeFtueV1 = function (sender , params) {
        var zOrder = constantsObj.FTUE_Z_ORDER;
        var itemWidth = 1090 * canvasWidth / 1440;
        var sectionHeight = 345;
        var borderWidth = 55 * canvasWidth / 1440;
        var tickWidth = 200 * canvasWidth / 1440;
        var textFont = constantsObj.FONT_HELVETICA_MEDIUM_70;
        var subTextFont = constantsObj.FONT_HELVETICA_60;

        var iconOpacity = constantsObj.OPACITY_90;
        var circleScale = constantsObj.SCALE_SPRITE_19;

        var d = gameObj.getTodaysPuzzleDate();
        var day = d.getDay();
        if (day == 0 || day == 3) {
            circleScale = constantsObj.SCALE_SPRITE_19 * 0.8 * 0.8;
        } else if (day == 1 || day == 2 || day == 5 || day == 6) {
            circleScale = constantsObj.SCALE_SPRITE_19 * 0.8;
        }

        var theme_start = constantsObj.COLOR_MINI_COLLECTION_START[day];
        var theme_end = constantsObj.COLOR_MINI_COLLECTION_END[day];
        var color_start = theme_start;
        var color_end = theme_end;


        var transBg = utilObj.getScale9Sprite(constantsObj.tile_white, xLeftPos, 0, 0, 0, canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset);
        utilObj.setColor(transBg, constantsObj.COLOR_BLACK);
        transBg.setOpacity(0);
        //transBg.setCascadeOpacityEnabled(true);
        utilObj.addChild(homeLayer, transBg, zOrder);
        spritesToRemove.push(transBg);



        var yPosition = homeLayer.scrollView.getPositionY() - 180;

        if (!utilObj.isWeb()) {
            var stencil = new cc.Scale9Sprite(constantsObj.todays_bg);
            stencil.attr({
                anchorX: 0,
                anchorY: 1,
                width: itemWidth,
                height: sectionHeight
            });
            utilObj.setPosition(stencil, borderWidth + tickWidth + 25, yPosition);
            //stencil.setPosition(borderWidth + tickWidth, yPosition);
            var clipperNode = cc.ClippingNode(stencil);
            clipperNode.setAlphaThreshold(0);
            clipperNode.setCascadeOpacityEnabled(true);
            utilObj.addChild(transBg, clipperNode, zOrder);

            var color_theme = new cc.LayerGradient(color_start, color_end, null, null);
            color_theme.anchorX = 0;
            color_theme.anchorY = 1;
            color_theme.ignoreAnchorPointForPosition(false);
            color_theme.setPositionX(borderWidth + tickWidth + 25);
            color_theme.setPositionY(yPosition);
            color_theme.width = itemWidth;
            color_theme.height = sectionHeight;
            color_theme.setVector(new cc.p(1, 0));
            clipperNode.addChild(color_theme, zOrder);
        }

        var button = utilObj.getButton(itemWidth, sectionHeight, 0, 1.0, borderWidth + tickWidth + 25, yPosition,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'homeObj',
                fn: 'loadTodaysPuzzle',
                screen: constantsObj.SCREEN_HOME,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_HOME,
                    f: "",
                    g: "",
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(transBg, button, zOrder);
        spritesToRemove.push(button);

        var circleImage = utilObj.getSprite(constantsObj.LOGO_FOR_DAYS_NEW_ICON[day], borderWidth + tickWidth + 140 + 25, yPosition - sectionHeight / 2, 0.5, 0.5, circleScale, null, null, zOrder + 1, constantsObj.SPRITE_MISC);
        circleImage.setOpacity(iconOpacity);
        utilObj.addChild(transBg, circleImage, zOrder);

        var textLabel = utilObj.getBMFontLabel(stringsObj.themed_crossword, textFont, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), borderWidth + tickWidth + (260 * canvasWidth / 1440) + 25,  yPosition - sectionHeight / 2 + 50, 0, 0.5, null, null, zOrder + 1);
        utilObj.addChild(transBg, textLabel, zOrder);
        var subTextLabel = utilObj.getBMFontLabel(stringsObj.puzzle_themes[day], subTextFont, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), borderWidth + tickWidth + (260 * canvasWidth / 1440) + 25,  yPosition - sectionHeight / 2 - 50, 0, 0.5, null, null, zOrder + 1);
        subTextLabel.setOpacity(constantsObj.OPACITY_90);
        utilObj.addChild(transBg, subTextLabel, zOrder);

        var freeTextWidth = 140 * canvasWidth / 1440;
        var freeTextHeight = 70;
        var freeBg = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, borderWidth + tickWidth + (940 * canvasWidth / 1440) + 25, yPosition - sectionHeight / 2 - 50, 0, 0.5, freeTextWidth, freeTextHeight, null, null, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setColor(freeBg, color_start);
        utilObj.addChild(transBg, freeBg, zOrder);
        var text = utilObj.getBMFontLabel("FREE", constantsObj.FONT_HELVETICA_MEDIUM_50, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), freeTextWidth / 2, freeTextHeight / 2, 0.5, 0.5, null, null, zOrder + 1);
        utilObj.addChild(freeBg, text, zOrder);

        var ftue_txt = utilObj.getBMFontLabel(stringsObj.ftue_text, constantsObj.FONT_HELVETICA_75, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, yPosition + sectionHeight - 75, 0.5, 0.5, null, null, zOrder + 1);
        ftue_txt.setOpacity(0);
        utilObj.addChild(transBg, ftue_txt, zOrder);

        var params = {
            transBg : transBg,
            ftue_text : ftue_txt,
        };

        homeObj.animateHomeFtue(params);



        utilObj.hideBannerAd(utilObj.getScreenName(constantsObj.SCREEN_HOME));

        var yPos = yPosition - 3 *sectionHeight/4;
        var xPos = borderWidth + tickWidth + 25 + ( 3 * itemWidth)/4;
        var params = {};
        params.xPos = xPos;
        params.yPos = yPos;
        params.layer = homeLayer;
        params.achievementftue = 0;
        ftueObj.showTap(homeLayer, params);
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_FTUE_0, constantsObj.TRACK_VIEW, constantsObj.TRACK_HOME, gameObj.getPuzzleSpeciesTracking(), 1, "");
    };

    this.animateHomeFtue = function(params){
        var blackOverlay = params.transBg;
        var ftue_text = params.ftue_text;
        var fadeInOverlay = utilObj.getFadeTo(0.5 , constantsObj.OPACITY_80);
        var fadeInText = utilObj.getFadeIn(0.5);
        animObj.runAction(ftue_text , fadeInText);
        animObj.runAction(blackOverlay , fadeInOverlay);
    };

    this.showMiniFtueV1 = function (sender , params) {
        var innerContentSize = params.innerContentSize;
        var zOrder = constantsObj.FTUE_Z_ORDER;
        var itemWidth = 1090 * canvasWidth / 1440 + 2;
        var sectionHeight = 345 + 2;
        var borderWidth = 55 * canvasWidth / 1440;
        var tickWidth = 200 * canvasWidth / 1440;
        var textFont = constantsObj.FONT_HELVETICA_MEDIUM_70;
        var subTextFont = constantsObj.FONT_HELVETICA_60;

        var iconOpacity = constantsObj.OPACITY_90;
        var circleScale = constantsObj.SCALE_SPRITE_1 * 1.5;

        if (homeLayer.yPosForFtue == null) {
            homeObj.setIsMiniPuzzleClicked(true);
            return;
        }
        homeObj.setIsMiniFtueVisible(true);

        var d = gameObj.getTodaysPuzzleDate();
        var day = d.getDay();

        var theme_start = constantsObj.COLOR_MINI_COLLECTION_START[day];
        var theme_end = constantsObj.COLOR_MINI_COLLECTION_END[day];


        var transBg = utilObj.getScale9Sprite(constantsObj.tile_white, xLeftPos, 0, 0, 0, canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset);
        transBg.setColor(constantsObj.COLOR_BLACK);
        transBg.setOpacity(0);
       // transBg.setCascadeOpacityEnabled(true);
        utilObj.addChild(homeLayer, transBg, zOrder);
        spritesToRemove.push(transBg);
        // loggerObj.debugLog("position is", homeLayer.scrollView.getPositionY(), homeLayer.scrollView.getContentSize().height, homeLayer.yPosForFtue);


        var yPosition = homeLayer.scrollView.getPositionY() - (innerContentSize - homeLayer.yPosForFtue) ;

        var color_start = theme_start;
        var color_end = theme_end;
        var color_theme = new cc.LayerGradient(color_start, color_end, null, null);
        if (!utilObj.isWeb()) {
            var stencil = new cc.Scale9Sprite(constantsObj.todays_bg);
            stencil.attr({
                anchorX: 0,
                anchorY: 1,
                width: itemWidth,
                height: sectionHeight
            });
            utilObj.setPosition(stencil, borderWidth + tickWidth + 25, yPosition);
            //stencil.setPosition(borderWidth + tickWidth, yPosition);
            var clipperNode = cc.ClippingNode(stencil);
            clipperNode.setAlphaThreshold(0);
            clipperNode.setCascadeOpacityEnabled(true);
            utilObj.addChild(transBg, clipperNode, zOrder);
            color_theme.anchorX = 0;
            color_theme.anchorY = 1;
            color_theme.ignoreAnchorPointForPosition(false);
            color_theme.setPositionX(borderWidth + tickWidth + 25);
            color_theme.setPositionY(yPosition);
            color_theme.width = itemWidth;
            color_theme.height = sectionHeight;
            color_theme.setVector(new cc.p(1, 0));
            clipperNode.addChild(color_theme, zOrder);
        } else {
            var clipperNode = new cc.Scale9Sprite(constantsObj.todays_bg);
            clipperNode.attr({
                anchorX: 0,
                anchorY: 1,
                width: itemWidth,
                height: sectionHeight
            });
            utilObj.setPosition(clipperNode, borderWidth + tickWidth + 25, yPosition);
            utilObj.addChild(transBg, clipperNode, zOrder);
            clipperNode.setColor(color_start);
        }

        var button = utilObj.getButton(itemWidth, sectionHeight, 0, 1.0, borderWidth + tickWidth + 25, yPosition,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'homeObj',
                fn: 'loadDailyMini',
                screen: constantsObj.SCREEN_HOME,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_HOME,
                    f: "",
                    g: "",
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(transBg, button, zOrder);
        spritesToRemove.push(button);

        var circleImage = utilObj.getSprite(constantsObj.mini_pack_icon, borderWidth + tickWidth + 140 + 25, yPosition - sectionHeight / 2, 0.5, 0.5, circleScale, null, null, zOrder + 1, constantsObj.SPRITE_MISC);
        circleImage.setOpacity(iconOpacity);
        utilObj.addChild(transBg, circleImage, zOrder);

        var textLabel = utilObj.getBMFontLabel(stringsObj.mini_crossword, textFont, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), borderWidth + tickWidth + (260 * canvasWidth / 1440) + 25,  yPosition - sectionHeight / 2 + 50, 0, 0.5, null, null, zOrder + 1);
        utilObj.addChild(transBg, textLabel, zOrder);
        var subTextLabel = utilObj.getBMFontLabel(stringsObj.pint_sized_crossword, subTextFont, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), borderWidth + tickWidth + (260 * canvasWidth / 1440) + 25,  yPosition - sectionHeight / 2 - 50, 0, 0.5, null, null, zOrder + 1);
        subTextLabel.setOpacity(constantsObj.OPACITY_90);
        utilObj.addChild(transBg, subTextLabel, zOrder);

        var freeTextWidth = 140 * canvasWidth / 1440;
        var freeTextHeight = 70;
        var freeBg = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, borderWidth + tickWidth + (940 * canvasWidth / 1440) + 25, yPosition - sectionHeight / 2 - 50, 0, 0.5, freeTextWidth, freeTextHeight, null, null, zOrder, constantsObj.SPRITE_MISC);
        freeBg.setColor(color_start);
        utilObj.addChild(transBg, freeBg, zOrder);
        var text = utilObj.getBMFontLabel("FREE", constantsObj.FONT_HELVETICA_MEDIUM_50, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), freeTextWidth / 2, freeTextHeight / 2, 0.5, 0.5, null, null, zOrder + 1);
        utilObj.addChild(freeBg, text, zOrder);

        var ftue_txt = utilObj.getBMFontLabel(stringsObj.ftue_text_mini, constantsObj.FONT_HELVETICA_75, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, yPosition + sectionHeight - 75, 0.5, 0.5, null, null, zOrder + 1);
        ftue_txt.setOpacity(0);
        utilObj.addChild(transBg, ftue_txt, zOrder);

        var params = {
            transBg : transBg,
            ftue_text : ftue_txt,
        };

        homeObj.animateHomeFtue(params);

        utilObj.hideBannerAd(utilObj.getScreenName(constantsObj.SCREEN_HOME));

        var yPos = yPosition - 3 *sectionHeight/4;
        var xPos = borderWidth + tickWidth + 25 + ( 3 * itemWidth)/4;
        var params = {};
        params.xPos = xPos;
        params.yPos = yPos;
        params.layer = homeLayer;
        params.achievementftue = 0;
        ftueObj.showTap(homeLayer, params);
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), "daily_mini_ftue", constantsObj.TRACK_VIEW, constantsObj.TRACK_HOME, gameObj.getPuzzleSpeciesTracking(), 1, "");
    };

    this.loadDailyMini = function () {
        if (!homeObj.getIsMiniPuzzleClicked()) {
            homeObj.dismissHomeFtue();
            homeObj.setIsMiniFtueVisible(false);
            homeObj.setIsMiniPuzzleClicked(true);
        }

        var puzzleId = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
        puzzleId = stringsObj.mini_prefix + puzzleId.substr(2, puzzleId.length);
        if (gameObj.getCrosswordForDate(puzzleId) == null) {
            if (utilObj.isOnline() == false) {
                utilObj.showMessage("Please connect to internet to download content");
            } else {
                utilObj.showMessage("Please try after some time");
            }
            utilObj.delayedCallback(homeLayer, homeLayer.redraw, 1);
            return;
        }
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, puzzleId, gameObj.getTrackingPuzzleTheme(), "daily_mini_ftue", "click", "", gameObj.getPuzzleSpeciesTracking(), "", "");

        homeLayer.hide();
        gameLayer.show(puzzleId);
    };

    this.dismissHomeFtue = function () {
        homeObj.removeSprites(homeLayer);
    };

    this.removeSprites = function (parent) {
        for (var i in spritesToRemove) {
            if (utilObj.isNodeValid(spritesToRemove[i])) {
                utilObj.removeChild(parent, spritesToRemove[i]);
            }
        }
        spritesToRemove = [];
    };

    this.loadTodaysPuzzle = function () {
        // loggerObj.debugLog("loading todays puzzle");
        if (!homeObj.getisHomeFtueShown()) {
            homeObj.dismissHomeFtue();
        }
        homeObj.setIsHomeFtueShown(true);
        var puzzleId = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
        var todaysPuzzleDate = utilObj.getDateForId(puzzleId);
        var installId = utilObj.getIdForDate(todaysPuzzleDate);
        var day = todaysPuzzleDate.getDay();
        var d0PuzzleId = 0;
        if (day == 0) {
            day = 7;
        }
        gameObj.setInstallDay(installId);

        loggerObj.debugLog("fixedMinisLog: home: isEligibleForFixedMinis -> ", fixedMinisObj.isEligibleForFixedMinis());
        if(fixedMinisObj.isEligibleForFixedMinis()) {
            fixedMinisObj.setD0FixedMiniDateIdAndSplitAndSetMinisInGame(todaysPuzzleDate);
        }

        var puzzleId1 = "2017000" + day;
        var prevDay1 = day - 1;
        var prevDay2 = day - 2;
        if (day - 1 <= 0) {
            prevDay1 = day + 7 - 1;
        }
        if (day - 2 <= 0) {
            prevDay2 = day + 7 - 2;
        }
        var nextDay1 = day + 1;
        var nextDay2 = day + 2;
        var nextDay3 = day + 3;
        var nextDay4 = day + 4;
        if (day + 1 > 7) {
            nextDay1 = day - 7 + 1;
        }
        if (day + 2 > 7) {
            nextDay2 = day - 7 + 2;
        }
        if (day + 3 > 7) {
            nextDay3 = day - 7 + 3;
        }
        if (day + 4 > 7) {
            nextDay4 = day - 7 + 4;
        }
        // loggerObj.debugLog("coming in this 1234",day,prevDay1,prevDay2,nextDay1,nextDay2);
        var prevD1PuzzleId = "2017000" + prevDay1;
        var prevD2PuzzleId = "2017000" + prevDay2;
        var nextD1PuzzleId = "2017000" + nextDay1;
        var nextD2PuzzleId = "2017000" + nextDay2;
        var nextD3PuzzleId = "2017000" + nextDay3;
        var nextD4PuzzleId = "2017000" + nextDay4;
        gameObj.setPrevD1PuzzleId(prevD1PuzzleId);
        gameObj.setPrevD2PuzzleId(prevD2PuzzleId);
        gameObj.setNextD1PuzzleId(nextD1PuzzleId);
        gameObj.setNextD2PuzzleId(nextD2PuzzleId);
        gameObj.setNextD3PuzzleId(nextD3PuzzleId);
        gameObj.setNextD4PuzzleId(nextD4PuzzleId);
        gameObj.setD0Id(puzzleId1);
        gameObj.unlockPuzzle(puzzleId1);
        gameObj.unlockPuzzle(puzzleId);
        if (puzzleId == installId) {
            if (gameObj.checkEligibleforNukeExpFreeHint(puzzleId1)) {
                gameObj.setNukePopupShown(true);
            }
        }
        //gameObj.setCrosswordForDate(puzzleId,puzzleId1);

        if (gameObj.getCrosswordForDate(puzzleId) == null) {
            ftueObj.setFtueShown(true);
            //utilObj.showMessage(stringsObj.request_update);
            if (utilObj.isOnline() == false) {
                utilObj.showMessage("Please connect to internet to download content");
            } else {
                runtimeObj.syncToServer();
                // loggerObj.debugLog("coming to this point - 17");
                utilObj.showMessage("Please try after some time");
            }
            //utilObj.showMessagePopup(stringsObj.request_update);
            return;
        }

        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_HOME, constantsObj.TRACK_TODAYS_PUZZLE, "", gameObj.getPuzzleSpeciesTracking(), "", "");
        //puzzleId = '20170216'
        homeLayer.hide();
        gameLayer.show(puzzleId);
    };

    // ftue check condition
    this.checkFtueConditions = function (fromBlitz) {
        var condition1 =  homeObj.getisHomeFtueShown() && !homeObj.getIsMiniFtueVisible() && !homeObj.getIsWeeklyQuestFtueShown() ;
        if(fromBlitz != undefined && fromBlitz){
            return condition1;
        }
        if(!zenModeObj.isZenModeAvailable()){
            return condition1;
        }else{
            var condition2 = !zenModeObj.isBlitzFtueVisible();
            return condition1 && condition2;
        }
    };

    this.getTotalHeightOfScrollView = function () {
        var totalHeight = 0;

        // today section height
        var idTheme = gameObj.getIdForTodaysPuzzle();
        if (gameObj.getInstallDay() != 0 && gameObj.getInstallDay() == gameObj.getIdForTodaysPuzzle()) {
            idTheme = gameObj.getD0Id();
        }
        var idMini = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
        idMini = stringsObj.mini_prefix + idMini.substr(2, idMini.length);
        var idThemeCompleted = gameObj.getPuzzleCompleted(idTheme);
        var idMiniCompleted = gameObj.getPuzzleCompleted(idMini);
        totalHeight += 1200;
        if (idThemeCompleted && idMiniCompleted) {
            totalHeight -= 720 + 150;
            if (!homeObj.getEligibilbeForStreak() || homeLayoutExpNew != constantsObj.EXP_VAR_2) {
                totalHeight -= 330;
            }
        } else {
            if (!homeObj.getEligibilbeForStreak() || homeLayoutExpNew != constantsObj.EXP_VAR_2) {
                totalHeight -= 290;
            }
            if (idMiniCompleted) {
                totalHeight -= 345 + 30;
            }
            if (idThemeCompleted) {
                totalHeight -= 345;
            }
        }
        // loggerObj.debugLog("total height is1", totalHeight);

        if (homeObj.getisHomeFtueShown() && homeObj.getIsMiniPuzzleClicked()) {
            // loggerObj.debugLog("total height is2", totalHeight);
            // in progress section height
            var sections = homeObj.getSectionsForRecentPuzzles();
            if (sections.length > 0) {
                var totalItems = sections.length > 3 ? 3 : sections.length;
                totalHeight += (340 * totalItems) + 170;
            }

            // explore more height
            var exploreMoreItem = homeObj.getExploreMoreItems();
            var numberOfInCompleteArchives = homeObj.getNumberOfInCompleteArchivePuzzle();
            var numberOfIncompletePacks = homeObj.getNumberOfInCompletePacks();
            var exploreMoreFlag = false;
            for (var i in exploreMoreItem) {
                if (exploreMoreItem[i].headerText == stringsObj.CALENDAR_TEXT && numberOfInCompleteArchives > 0) {
                    exploreMoreFlag = true;
                    totalHeight += 312 + 40;
                } else if (exploreMoreItem[i].headerText == stringsObj.PACK_TEXT && numberOfIncompletePacks > 0) {
                    exploreMoreFlag = true;
                    totalHeight += 312 + 40;
                }
            }
            if (exploreMoreFlag) {
                totalHeight += 200;
            }

            // more for you height
            var moreForYouItem = homeObj.getMoreForYouItems();
            var inProgress = gameObj.getInProgress();
            var sectionHeight = 312 + 40;
            for (var i in moreForYouItem) {
                if(moreForYouItem[i].headerText == stringsObj.GAMES_MODES){
                    sectionHeight = 394 + 40;
                } else {
                    sectionHeight = 312 + 40
                }

                totalHeight += sectionHeight;
                if(moreForYouItem[i].headerText == stringsObj.archive_type || moreForYouItem[i].headerText == stringsObj.bonus_mini || moreForYouItem[i].headerText == stringsObj.paid_archive_type || moreForYouItem[i].headerText == stringsObj.brit_puzzle_pack){
                    if(inProgress[moreForYouItem[i].puzzleId]){
                        totalHeight += 10;
                    }
                }
            }

            // increasing the height of scrollView if any of the featured section item is present
            if (moreForYouItem.length > 0) {
                totalHeight += 200;
            }
        }

        return totalHeight + 30;
    };

    // count for incomplete archive puzzle.
    this.getNumberOfInCompleteArchivePuzzle = function () {
        var d = gameObj.getTodaysPuzzleDate();
        var day = d.getDay();
        var curTime = d.getTime();
        var startTimestamp = 1488326400000;//1561919400000
        var milliSecInDay = 86400000;
        var countForInCompletePuzzle = 0;
        while (curTime > startTimestamp) {
            var date = new Date(curTime);
            var id = utilObj.getIdForDate(date);
            if (parseInt(id) >= constantsObj.PUZZLE_START_ID) {
                if (id == gameObj.getInstallDay()) {
                    id = gameObj.getD0Id();
                }
                if (scoresObj.getMastery(id) == 0) {
                    countForInCompletePuzzle += 1;
                }
            }
            curTime -= milliSecInDay;
        }
        return countForInCompletePuzzle;
    };

    // count for incomplete packs
    this.getNumberOfInCompletePacks = function () {
        var countForInCompletePacks = 0;
        for (var packId = 7; packId < constantsObj.NUM_PACKS; packId++) {
            var packInfo = gameObj.getPackInfo();
            var packArr = packInfo[packId];
            if (packId == constantsObj.STARTER_PACK_MINIS && gameObj.getIsStarterPackUnlocked() == false) {
                continue;
            }
            if (packArr == undefined) {
                continue;
            }
            for (var i = 0; i < packArr.length; i++) {
                var crossWord = packArr[i];
                var inProgress = gameObj.getInProgress();
                var score = scoresObj.getHighScore(crossWord);
                if (score == 0) {
                    countForInCompletePacks += 1;
                    // break;
                }
            }
        }
        return countForInCompletePacks;
    };


    // animate the nudge for the achievement jewel notif
    this.animateNudgeAchv = function (sender, params) {
        var icon = params.icon;
        var label = params.label;
        var animCircle = params.animCircle;
        var delayForAnimForClaimTag = 2;

        if (!utilObj.isNodeValid(icon) || !utilObj.isNodeValid(label) || !utilObj.isNodeValid(animCircle)) {
            return;
        }
        
        var scalex = icon.getScaleX();
        var scaleY = icon.getScaleY();

        var scaleLabelX = label.getScaleX();
        var scaleLabelY = label.getScaleY();

        var scaleUp = utilObj.getScaleTo(0.4, scalex * 1.1 , scaleY * 1.1);
        var scaleDown = utilObj.getScaleTo(0.4, scalex , scaleY);

        var scaleUp1 = animObj.getScaleDifferentTo(0.4, scaleLabelX * 1.1, scaleLabelY * 1.1);
        var scaleDown1 = animObj.getScaleDifferentTo(0.4, scaleLabelX, scaleLabelY);

        var scaleCircle = animObj.getScaleDifferentTo(0.6, scalex * 1.6, scaleY * 1.6);
        var fadeOut = utilObj.getFadeOut(0.6);
        var delay = utilObj.getDelayTime(0.78);
        var spawn = cc.Spawn([scaleCircle, fadeOut]);
        var scaleBack = animObj.getScaleDifferentTo(0.01, scalex, scaleY);
        var fadeIn = utilObj.getFadeIn(0.01);
        var seq = [scaleBack,fadeIn];

        var delay1 = utilObj.getDelayTime(delayForAnimForClaimTag);
        var delay2 = utilObj.getDelayTime(0.6);

        var spawn1 = cc.Spawn([delay1, utilObj.getSequence(seq) ]);

        var animSeq = [scaleUp, scaleDown, delay1];
        var animSeq1 = [scaleUp1, scaleDown1, delay1];
        var animSeq2 = [delay,scaleBack,fadeIn, spawn, delay2];

        animObj.runAction(icon, cc.RepeatForever(utilObj.getSequence(animSeq)));
        animObj.runAction(label, cc.RepeatForever(utilObj.getSequence(animSeq1)));
        animObj.runAction(animCircle, cc.RepeatForever(utilObj.getSequence(animSeq2)));
    };

    //animate claim tag on achievement claim available.
    this.animateAchievementClaimTag = function (sender, params) {
        var icon = params.icon;
        var label = params.label;

        if (!utilObj.isNodeValid(icon) || !utilObj.isNodeValid(label)){
            return;
        }
        //--------------------------------
        var xPos = icon.getPositionX();
        var yPos = icon.getPositionY();

        var moveUp = new cc.MoveTo(0.6, xPos, yPos + 50).easing((cc.easeIn(1)));
        var moveDown = new cc.MoveTo(0.15, xPos, yPos).easing((cc.easeOut(1)));
        var delay = utilObj.getDelayTime(0.65);

        var animArr = [];
        animArr.push(moveUp);
        animArr.push(moveDown);
        animArr.push(delay);
        var seq = utilObj.getSequence(animArr);
        animObj.runAction(icon , seq.repeatForever() , true);
        //--------------------------------
        var xPos1 = label.getPositionX();
        var yPos1 = label.getPositionY();

        var moveUp1 = new cc.MoveTo(0.6, xPos1, yPos1 + 50).easing((cc.easeIn(1)));
        var moveDown1 = new cc.MoveTo(0.15, xPos1, yPos1).easing((cc.easeOut(1)));
        var delay1 = utilObj.getDelayTime(0.65);

        var animArr1= [];
        animArr1.push(moveUp1);
        animArr1.push(moveDown1);
        animArr1.push(delay1);
        var seq1 = utilObj.getSequence(animArr1);
        animObj.runAction(label , seq1.repeatForever() , true);

    };



    // return color after converting from input string code
    this.getColorFromStringCode = function (str) {
        var splitStr = str.split(",");
        var color = cc.color(parseInt(splitStr[0]), parseInt(splitStr[1]), parseInt(splitStr[2]));
        return color;
    };

    var isWeeklyQuestFtueShown = false;

    this.getIsWeeklyQuestFtueShown = function () {
        return isWeeklyQuestFtueShown;
    };

    this.setIsWeeklyQuestFtueShown = function (val) {
        isWeeklyQuestFtueShown = val;
    };

    // show the home ftue for the new wq
    this.showLLPWeeklyQuestFtue = function (yPos) {

        var bucket = questMapObj.getBucketAllocated();
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "" , "", "wq_overlay", constantsObj.TRACK_VIEW, bucket, "", "", "");

        yPos -= 140;
        // fetching experiment
        homeObj.setIsWeeklyQuestFtueShown(true);
        var experiment = gameObj.getExpNewWeeklyQuestVariant();
        var milestonesCompleted = gameObj.getWeeklyQuestMilestonesCompleted();
        if (!gameObj.getIsThemedQuestLocked()) {
            milestonesCompleted = gameObj.getThemedQuestMilestonesCompleted();
        }

        var toAdjustUiForCarousel = false;
        var carouselExp = xpromoDtcObj.getCarouseExperimentVariant();
        var zOrder = constantsObj.FTUE_Z_ORDER;
        var labelArr = [];
        var spriteArr = [];

        if(carouselExp != constantsObj.EXP_VAR_CONTROL) {
            toAdjustUiForCarousel = true;
        }

        // ui for carousel adjust
        var yShiftHeader = 0;
        var progressBarShift = 0;
        var iconShift = 0;
        var fontForTimer = constantsObj.FONT_HELVETICA_MEDIUM_40;
        var fontProgressBar = constantsObj.FONT_HELVETICA_BOLD_40;
        var uiHeight = 250;
        var btnFeedbackType = undefined;
        if (toAdjustUiForCarousel) {
            uiHeight = 380;
            yShiftHeader = 20;
            progressBarShift = 30;
            iconShift = 30;
            fontForTimer = constantsObj.FONT_HELVETICA_MEDIUM_50;
            fontProgressBar = constantsObj.FONT_HELVETICA_BOLD_45;
            btnFeedbackType = constantsObj.NO_TOUCH_ON_SWIPE_FEEDBACK;
        }
        // --------

        // date settings
        var now = new Date();
        var year = questMapObj.y2k(now.getYear());
        var month = now.getMonth();
        var date = now.getDate();

        var weekNum = questMapObj.getWeek(year, month , date);

        // color start and end
        var color_startUi = questMapObj.getHomeGradientColorStart(year, weekNum, experiment);
        var color_endUi = questMapObj.getHomeGradientColorEnd(year, weekNum, experiment);


        // trans black bg
        var transBg = utilObj.getScale9Sprite(constantsObj.tile_white, xLeftPos, 0, 0, 0, canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset, spriteArr, homeLayer, zOrder, constantsObj.SPRITE_MISC);
        transBg.setColor(constantsObj.COLOR_BLACK);
        transBg.setOpacity(constantsObj.OPACITY_0);

        utilObj.getBMFontLabel("Let's play the exciting new Quest!", constantsObj.FONT_HELVETICA_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, yPos + 130, 0.5, 0.5, labelArr, transBg, zOrder);

        // color themes for the gradient
        var color_theme = new cc.LayerGradient(color_startUi, color_endUi, null, null);
        color_theme.anchorX = 0.5;
        color_theme.anchorY = 1;
        color_theme.ignoreAnchorPointForPosition(false);
        color_theme.setPositionX(centerXPos);
        color_theme.setPositionY(yPos);
        color_theme.width = canvasWidth;
        color_theme.height = uiHeight;
        color_theme.setVector(new cc.p(1, 0));
        utilObj.addChild(transBg, color_theme, zOrder);

        var completedArray = gameObj.getPuzzlesCompletedArray();
        var starsAchieved = 0;
        for (var i in completedArray) {
            if (completedArray[i]["completed"]) {
                starsAchieved += 1;
            }
        }
        var totalStars = questMapObj.getTotalPuzzles();

        // button for the click flow
        var transButton = utilObj.getButton(canvasWidth, uiHeight, 0.5, 1.0, centerXPos, yPos,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'homeObj',
                fn: 'openQuest',
                params: {source: constantsObj.TRACK_WQ_HOME},
                screen: homeLayer.screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: "",
                    c: "",
                    o: "wq_overlay",
                    f: "play",
                    g: bucket,
                    s: "",
                    co: "",
                    oppId: ""
                },
                feedBackType: btnFeedbackType,
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(transBg, transButton, zOrder + 1);

        var offset = 20;
        var title = questMapObj.getWeeklyThemeText(year, weekNum, experiment) ;
        var desc = questMapObj.getWeeklyThemeHomeText(year, weekNum, experiment);
        var mileInfo = questMapObj.getMilestoneInfoForQuest();
        var milestones = [mileInfo["0"]["index"], mileInfo["1"]["index"], mileInfo["2"]["index"]];
        var colorOftext = constantsObj.COLOR_WHITE;

        // timer label for the quest
        var timeStr = weeklyQuestObj.getWqHomeTimerText();
        var scaleForThemedImage = constantsObj.SCALE_TWO * 0.38;
        if (!gameObj.getIsThemedQuestLocked()) {
            timeStr = themedQuestObj.getTqHomeTimerText();
            scaleForThemedImage = constantsObj.SCALE_TWO * 0.38 * 0.8;
        }
        var colorForQuest = questMapObj.getHomeTextColor(year, weekNum, experiment);
        var timerLabel = utilObj.getBMFontLabel(timeStr, fontForTimer, colorForQuest,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xLeftPos + 32 + ((750 * 0.3) / 2), yPos - 182 - iconShift - offset/2, 0.5, 1, labelArr, transBg, zOrder);
        weeklyQuestObj.setWqHomeTimerLabel(timerLabel);

        // play text
        var btn = utilObj.getScale9Sprite(constantsObj.button_cutup, xRightPos - 170, yPos - uiHeight/2, 0.5, 0.5, 250, 100, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
        // utilObj.setColor(btn, constantsObj.COLOR_GREEN_11);
        var colorForPlayButton = questMapObj.getPlayBgColor(year, weekNum, experiment);
        utilObj.setColor(btn, colorForPlayButton)
        utilObj.getBMFontLabel("Play", constantsObj.FONT_HELVETICA_BOLD_60, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xRightPos - 170, yPos - uiHeight/2, 0.5, 0.5, labelArr, transBg, zOrder );

        utilObj.getBMFontLabel(title, constantsObj.FONT_HELVETICA_MEDIUM_60, colorForQuest,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xLeftPos + 270, yPos - 10 - yShiftHeader, 0, 1, labelArr, transBg, zOrder );

        utilObj.getBMFontLabel(desc, constantsObj.FONT_HELVETICA_MEDIUM_50, colorForQuest,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xLeftPos + 270, yPos - 90 - yShiftHeader, 0, 1, labelArr, transBg, zOrder );

        // themed icon
        var themeIconWQ = questMapObj.getWeeklyThemeImage(year, weekNum, experiment);
        var theme_icon = utilObj.getSprite(themeIconWQ, xLeftPos + 60, yPos - 20 - iconShift + offset, 0, 1.0, scaleForThemedImage, spriteArr, transBg, zOrder, constantsObj.SPRITE_LOCAL);

        //
        var progressBg = utilObj.getScale9Sprite(constantsObj.full_bar, xLeftPos + 270, yPos - 165 - progressBarShift, 0, 1, 750, 55, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
        progressBg.setColor(constantsObj.COLOR_BLACK);
        progressBg.setOpacity(constantsObj.OPACITY_15);
        //
        var progress = utilObj.getScale9Sprite(constantsObj.full_bar, xLeftPos + 270, yPos - 165 - progressBarShift, 0, 1, 750 * (starsAchieved / totalStars), 55, spriteArr, transBg, zOrder, constantsObj.SPRITE_MISC);
        progress.setColor(constantsObj.COLOR_BLUE_14);

        var totalStarsLabel = milestones[0];


        utilObj.getBMFontLabel(starsAchieved + "/" + totalStarsLabel, fontProgressBar, colorOftext,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xLeftPos + 290 + 330, yPos - 167 - progressBarShift, 0, 1, labelArr, transBg, zOrder);

        for (var i = 0; i < 2; i++) {
            var progressPointer = utilObj.getSprite(constantsObj.themed_quest_progress_pointer, xLeftPos + 270 + (milestones[i] / totalStars) * 750, yPos - 210 - progressBarShift, 0.5, 1, constantsObj.SCALE_SPRITE_18 * 1.5, spriteArr, transBg, zOrder + 1, constantsObj.SPRITE_LOCAL);
            progressPointer.setColor(colorOftext);
        }

        var gift =  utilObj.getSprite(constantsObj.tq_gift3, xLeftPos + 270 + 740, yPos - 178.5 - progressBarShift, 0, 0.5, constantsObj.SCALE_ONE * 1.18, spriteArr, transBg, zOrder + 1, constantsObj.SPRITE_LOCAL);

        // if (toAdjustUiForCarousel) {
        //     var b1 = utilObj.getSprite(xpromoConstantsObj.blue_circle, centerXPos, yPos - uiHeight + 20 + constantsObj.BEZEL_SAFE_AREA / 3, 0.5, 0, xpromoUtilObj.getSpriteScale(0.17), spriteArr, transBg, zOrder, constantsObj.SPRITE_QUESTS);
        //     b1.setColor(constantsObj.COLOR_CAROUSEL_ACTIVE);
        //     // b1.setOpacity(constantsObj.OPACITY_40);
        // }

        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);

        // fade in animation for the ui
        var params = {
            transBg : transBg,
            ftue_text : null,
        };
        homeObj.animateHomeFtue(params);

    };

    this.openQuest = function () {
        homeLayer.hide();
        questMapLayer.show();

        homeObj.setIsWeeklyQuestFtueShown(false);
        gameObj.setIsLLPWQFtueShown(true);
        gameObj.setIsLLPWQFtueShownInSession(true);
    };

    /**
     * checks if streak popup conditions are met
     * @returns {boolean}
     */
    this.shouldShowStreakPopup = function () {
        return (!homeObj.getIsStreakPopupShown() && homeObj.getEligibilbeForStreak() && homeLayoutExpNew == constantsObj.EXP_VAR_2);
    };

};