InProgress = function () {
    var lastUpdate = 0;
    var lastSyncStart = 0;
    var inProgressController = null;
    var lastServerInProgress = "";
    var lastServerPackInProgress = "";
    var inProgressSent = "";
    var packInProgressSent = "";

    this.init = function () {
        inProgressController = gameObj.getGameController();
        load();
    };

    function load() {
        var inProgressJson = ls.getItem(constantsObj.INPROGRESS_FILE);
        if (inProgressJson == null || inProgressJson == "") {
            return false;
        }
        inProgressJson = JSON.parse(inProgressJson);
        lastServerInProgress = inProgressJson.linp;
        lastServerPackInProgress = inProgressJson.lpinp;
        lastSyncStart = inProgressJson.lastSyncStart;
        lastUpdate = inProgressJson.lastUpdate;
        return true;
    }

    function save() {
        var inProgressJson = {};
        inProgressJson.lastServerInProgress = lastServerInProgress;
        inProgressJson.lastServerPackInProgress = lastServerPackInProgress;
        inProgressJson.lastSyncStart = lastSyncStart;
        inProgressJson.lastUpdate = lastUpdate;
        ls.setItem(constantsObj.INPROGRESS_FILE, utilObj.getStringifiedJson(inProgressJson));
        return true;
    }

    this.syncToServer = function (syncAhead) {
        if(psPrivacyObj.shouldAccountLockedBeShown()) {
            return;
        }
        var passesBasicChecks = utilObj.passesBasicSyncChecks(lastSyncStart, constantsObj.INPROGRESS_SYNC_INTERVAL);
        if (syncAhead === "true") {
            var inProgressData = userObj.getUserObj();
            if (inProgressData.syncId == "") {
                return;
            }
            inProgressController.sendHttpRequest("inProgress", "fetch", inProgressData);
        } else if (passesBasicChecks) {
            var inProgressData = userObj.getUserObj();
            if (inProgressData.syncId == "") {
                return;
            }
            inProgressData.inp = gameObj.getEncodedInProgressV1();
            inProgressData.pinp = gameObj.getEncodedPackProgress();
            if (lastServerInProgress == inProgressData.inp && lastServerPackInProgress == inProgressData.pinp) {
                // Data on server is same as client
                return;
            }
            var curTimestamp = utilObj.getCurrentTimestamp();
            lastSyncStart = curTimestamp;
            inProgressSent = inProgressData.inp;
            packInProgressSent = inProgressData.pinp;
            inProgressController.sendHttpRequest("inProgress", "save", inProgressData);
        }
    };

    this.getLastUpdate = function () {
        return lastUpdate;
    };

    this.respHandler = function (action, data, success) {
        if (action === "save") {
            if (success == true) {
                lastServerInProgress = inProgressSent;
                lastServerPackInProgress = packInProgressSent;
                lastUpdate = data.lastUpdate;
                save();
            }
        } else if (action === "fetch") {
            if (success == false) {
                // Do nothing
            } else {
                lastServerInProgress = data.inp;
                lastServerPackInProgress = data.pinp;
                gameObj.setInProgressInfo(gameObj.mergeInProgressV1(data.inp));
                gameObj.getDecodedPackProgress(data.pinp);

                lastUpdate = data.lastUpdate;
                save();
            }

        } else {
            loggerObj.errorLog("Unknown action received from in progress server. Action:" + action + ";Data:" + data);
        }

    };

};