Recommendation = function () {

    this.getMultipleLockedPuzzle = function (puzzleId, count, dayDiff) {
        if (puzzleId.toString().substring(0,2) == stringsObj.mini_prefix) {
            puzzleId = gameObj.getIdForTodaysPuzzle();
        }
        var d = utilObj.getDateForId(puzzleId);
        var day = d.getDay();
        var randomPuzzleId = [];
        var firstDay = gameObj.getFirstLoadTime();
        var ftueArchiveDate = new Date(firstDay);
        var ftueDate = new Date(firstDay);
        ftueArchiveDate.setDate(ftueDate.getDate() - 1);
        var archivePuzzle = utilObj.getIdForDate(ftueArchiveDate);
        var startTimestamp = 1488326400000;
        var curTime = d.getTime();
        var inProgress = gameObj.getInProgress();
        var milliSecInDay = 86400000;
        var counter = 0;
        var totalCount = count;
        var lastArchivedPuzzleTime = curTime - dayDiff * milliSecInDay;
        var todaysFreePuzzle = gameObj.getTodaysFreePuzzle();
        while (lastArchivedPuzzleTime > startTimestamp) {
            var date = new Date(lastArchivedPuzzleTime);
            var id = utilObj.getIdForDate(date);
            if (parseInt(id) < constantsObj.PUZZLE_START_ID) {
                break;
            }
            if (inProgress[id] == undefined && scoresObj.getMastery(id) == 0) {
                if ((todaysFreePuzzle != null && todaysFreePuzzle == id && gameObj.getTodaysPuzzleCompleted1()) || id == gameObj.getD0Id() || id == gameObj.getInstallDay() || archivePuzzle == id) {
                    lastArchivedPuzzleTime = lastArchivedPuzzleTime - dayDiff * milliSecInDay;
                    continue;
                }
                randomPuzzleId.push(id);
                counter++;
            }
            if (totalCount == counter) {
                break;
            }
            lastArchivedPuzzleTime = lastArchivedPuzzleTime - dayDiff * milliSecInDay;
        }
        if (totalCount == 1) {
            return randomPuzzleId[0];
        } else {
            return randomPuzzleId;
        }
    };

    this.getMultipleFromFreePack = function (puzzleId) {
        var packId = 0;
        if (!gameObj.checkForDailyMini(puzzleId)) {
            packId = gameObj.getPackIdFromPuzzleId(puzzleId);
        }
        var packInfo = gameObj.getPackInfo();
        var randomPuzzleId = [];
        var packArr = packInfo[packId];
        if (packArr == undefined) {
            return 0;
        }
        var counter = 0;
        var totalCount = 10;
        var packId1 = 0;
        if (packId != constantsObj.INTRODUCING_MINIS) {
            packId1 = constantsObj.INTRODUCING_MINIS;
            var packArr = packInfo[packId1];
            for (var i = 0; i < packArr.length; i++) {
                var crossWord = packArr[i];
                var score = scoresObj.getHighScore(crossWord);
                if (score == 0) {
                    randomPuzzleId.push(packId1);
                    break;
                }
            }
        }

        for (var id = constantsObj.NUM_PACKS - 1; id >=  constantsObj.AROUND_THE_WORLD; id--) {
            if (id == constantsObj.STARTER_PACK_MINIS) {
                continue;
            }
            packId1 = id;
            if (packId1 == packId) {
                continue;
            }
            var packArr = packInfo[packId1];
            for (var i = 0; i < packArr.length; i++) {
                var crossWord = packArr[i];
                var score = scoresObj.getHighScore(crossWord);
                if (score == 0) {
                    randomPuzzleId.push(packId1);
                    break;
                }
            }
        }
        return randomPuzzleId;
    };

    this.getMultipleFromPaidPack = function (puzzleId) {
        var packId = gameObj.getPackIdFromPuzzleId(puzzleId);
        var packInfo = gameObj.getPackInfo();
        var randomPuzzleId = [];
        var packArr = packInfo[packId];
        if (packArr == undefined) {
            return 0;
        }
        var counter = 0;
        var totalCount = 10;
        var packId1 = 0;
        for (var id = constantsObj.EASY_PEASY; id < constantsObj.AROUND_THE_WORLD; id++) {
            packId1 = id;
            if (packId1 == packId) {
                continue;
            }
            var packArr = packInfo[packId1];
            for (var i = 0; i < packArr.length; i++) {
                var crossWord = packArr[i];
                var score = scoresObj.getHighScore(crossWord);
                if (score == 0) {
                    randomPuzzleId.push(packId1);
                    break;
                }
            }
        }
        return randomPuzzleId;
    };

    this.setTodaysBonusArchivePuzzle = function () {
        var d = gameObj.getTodaysPuzzleDate();
        var day = d.getDay();
        var recentUnopenedPuzzles = [];
        var curTime = d.getTime();
        var startTimestamp = 1488326400000;
        var milliSecInDay = 86400000;
        var inProgress = gameObj.getInProgress();
        var count = 1;
        var counter = 0;
        var todaysFreePuzzle = gameObj.getTodaysFreePuzzle();
        var firstDay = gameObj.getFirstLoadTime();
        var ftueArchiveDate = new Date(firstDay);
        var ftueDate = new Date(firstDay);
        ftueArchiveDate.setDate(ftueDate.getDate() - 1);
        var archivePuzzle = utilObj.getIdForDate(ftueArchiveDate);
        //loggerObj.debugLog("recommendation check for the id for same theme1011 ");
        while (curTime > startTimestamp) {
            curTime -= milliSecInDay;
            var date = new Date(curTime);
            var id = utilObj.getIdForDate(date);
            if (parseInt(id) < constantsObj.PUZZLE_START_ID) {
                continue;
            }
            if (inProgress[id] == undefined && scoresObj.getMastery(id) == 0) {
                if ((todaysFreePuzzle != null && todaysFreePuzzle == id && gameObj.getTodaysPuzzleCompleted1()) || archivePuzzle == id) {
                    continue;
                }
                recentUnopenedPuzzles.push(date);
                counter++;
                //loggerObj.debugLog("datesss", date);
            }
            //loggerObj.debugLog("inprogress", JSON.stringify(gameObj.get));
            if (counter == count) {
                break;
            }
        }
        if (todaysFreePuzzle != null && todaysFreePuzzle != undefined) {
            if (scoresObj.getMastery(todaysFreePuzzle) != 0) {
                gameObj.setCompletedTodaysFreePuzzle(true);
            }
        }
        //loggerObj.debugLog("recommendation check for the id for same theme1012 ");
        if (gameObj.getTodaysPuzzleCompleted1()) {
            if (!gameObj.getCompletedTodaysFreePuzzle() && !gameObj.getViewedTodaysFreePuzzle() && recentUnopenedPuzzles.length > 0) {
                //loggerObj.debugLog("recommendation check for the id for same theme1013 ");
                d = recentUnopenedPuzzles[0];
                day = d.getDay();
                recentUnopenedPuzzles.splice(0, 1);
                gameObj.setTodaysFreePuzzle(utilObj.getIdForDate(d));
                gameObj.setViewedTodaysFreePuzzle(true);
                //loggerObj.debugLog("herosPos2",heroPosPuzzle);
            } else if (!gameObj.getCompletedTodaysFreePuzzle() && gameObj.getViewedTodaysFreePuzzle()) {
                //loggerObj.debugLog("recommendation check for the id for same theme1014 ");
                d = utilObj.getDateForId(gameObj.getTodaysFreePuzzle());
                day = d.getDay();
            } else if (gameObj.getCompletedTodaysFreePuzzle() && recentUnopenedPuzzles.length > 0) {
                //loggerObj.debugLog("recommendation check for the id for same theme1015 ");
                var heroPosPuzzle = gameObj.getCurrentHeroPosPuzzle();
                //loggerObj.debugLog("herePos1",scoresObj.getMastery(heroPosPuzzle),(heroPosPuzzle == null),(scoresObj.getMastery(heroPosPuzzle) != 0));
                if (heroPosPuzzle == null || scoresObj.getMastery(heroPosPuzzle) != 0) {
                    //loggerObj.debugLog("recommendation check for the id for same theme1016 ");
                    //loggerObj.debugLog("hereee1",scoresObj.getMastery(heroPosPuzzle));
                    d = recentUnopenedPuzzles[0];
                    recentUnopenedPuzzles.splice(0, 1);
                    //loggerObj.debugLog("hereee3",recentUnopenedPuzzles);
                    gameObj.setCurrentHeroPosPuzzle(utilObj.getIdForDate(d));
                    //loggerObj.debugLog("hereee2", recentUnopenedPuzzles);
                } else {
                    //loggerObj.debugLog("recommendation check for the id for same theme1017 ");
                    d = utilObj.getDateForId(heroPosPuzzle);
                    if (inProgress[heroPosPuzzle] == undefined) {
                        recentUnopenedPuzzles.splice(0, 1);
                    }
                    //loggerObj.debugLog("hereee2");
                }
                //loggerObj.debugLog("herosPos",heroPosPuzzle);
                day = d.getDay();
            } else if (gameObj.getCompletedTodaysFreePuzzle() && recentUnopenedPuzzles.length == 0) {
                //loggerObj.debugLog("recommendation check for the id for same theme1018 ");
                //loggerObj.debugLog("hereee3");
                var heroPosPuzzle = gameObj.getCurrentHeroPosPuzzle();
                if (heroPosPuzzle == null) {
                }
                if (heroPosPuzzle != null && scoresObj.getMastery(heroPosPuzzle) == 0) {
                    d = utilObj.getDateForId(heroPosPuzzle);
                    day = d.getDay();
                } else if (heroPosPuzzle != null && scoresObj.getMastery(heroPosPuzzle) != 0) {
                    // herosPosText = stringsObj.TODAYS_PUZZLE;
                }
            }
            if (gameObj.getTodaysFreePuzzle() == null && recentUnopenedPuzzles.length == 0) {
                //loggerObj.debugLog("recommendation check for the id for same theme1019 ");
                // herosPosText = stringsObj.TODAYS_PUZZLE;
            }
        } else {
            //loggerObj.debugLog("recommendation check for the id for same theme10110 ");
            gameObj.setViewedTodaysFreePuzzle(false);
            gameObj.setCompletedTodaysFreePuzzle(false);
            gameObj.setTodaysFreePuzzle(null);
            gameObj.setCurrentHeroPosPuzzle(null);
        }
    };

    this.getMultipleInProgressPuzzle = function (count) {
        gameObj.loadRecentInProgress();
        var recentInProgress = gameObj.getRecentInProgress();
        var todaysId = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
        var idArr = [];
        for (var i in recentInProgress) {
            var id = recentInProgress[i];
            if (id == todaysId || id == gameObj.getD0Id() || id == gameObj.getInstallDay() ||gameObj.checkForMiniOrMidi(id) || (id == gameObj.getTodaysFreePuzzle() && scoresObj.getMastery(id) == 0) || id == gameObj.getCurrentHeroPosPuzzle()) {
                continue;
            }
            if (parseInt(id) < constantsObj.PUZZLE_START_ID) {
                continue;
            }
            idArr.push(id);
            if (count == 1) {
                return idArr[0];
            }
        }
        return idArr;
    };

    this.getDailyMiniCompleted = function (id) {
        var inProgress = gameObj.getInProgress();
        if (scoresObj.getMastery(id) > 0 && !utilObj.isObject(inProgress[id])){
            return true;
        }
        return false;
    };

    this.getFirstNonInteractedFreePack = function () {
        var id = 7;
        var packInfo = gameObj.getPackInfo();
        var inProgress = gameObj.getInProgress();
        var packArr = packInfo[id];
        if (packArr == undefined) {
            return -1;
        }
        var i = 0;
        for (i = 0; i< packArr.length; i++) {
            var crossWord = packArr[i];
            var score = scoresObj.getHighScore(crossWord);
            if (score != 0 || (inProgress[crossWord] != undefined && inProgress[crossWord].timeElapsed > 0)) {
                break;
            }
        }
        if (i == packArr.length) {
            return id;
        }
        for (var j = constantsObj.NUM_PACKS - 1; j >= constantsObj.AROUND_THE_WORLD; j--) {
            if (id == constantsObj.STARTER_PACK_MINIS) {
                continue;
            }
            var packArr = packInfo[j];
            if (j == constantsObj.STARTER_PACK_MINIS) {
                continue;
            }
            if (packArr == undefined) {
                return -1;
            }
            for (i = 0; i< packArr.length; i++) {
                var crossWord = packArr[i];
                var score = scoresObj.getHighScore(crossWord);
                if (score != 0 || (inProgress[crossWord] != undefined && inProgress[crossWord].timeElapsed > 0)) {
                    break;
                }
            }
            if (i == packArr.length) {
                return j;
            }
        }
        return -1;
    };

    this.getCountVideoWatchedRuntimeValue = function () {
        var currentTime = utilObj.getCurrentTimestamp();
        var currentDate = new Date(currentTime * 1000);
        var daysDiff = utilObj.getDaysDiff(currentDate, gameObj.getLastVideoForArchiveDate());
        if (daysDiff > 0) {
            gameObj.setCountVideoWatched(0);
        }
        var countVideoWatchedRuntime = runtimeObj.getCountWatchedVideo();
        if (gameObj.getIsPayer() == true) {
            countVideoWatchedRuntime = runtimeObj.getCountWatchedVideoPayer();
        }
        return countVideoWatchedRuntime;
    };

    this.getRecommendationClearerPuzzleId = function (params) {
        // var params = params1;
        var puzzleId = params.id;
        var score = 0;
        var isMiniOrMidi = gameObj.checkForMiniOrMidi(puzzleId);
        var mastery = scoresObj.getMastery(puzzleId);
        var deltaValue = runtimeObj.getPovertyLineValue();
        var coinCount = economyObj.getCash() - deltaValue;
        var recommendedPuzzleId = null;
        var todaysPuzzleId = gameObj.getIdForTodaysPuzzle();
        var inProgress = gameObj.getInProgress();
        //loggerObj.debugLog("recommendation check for the id for same theme10 ", puzzleId);
        if (isMiniOrMidi != true) {
            var dailyMiniId = stringsObj.mini_prefix + todaysPuzzleId.substr(2, todaysPuzzleId.length);
            var dailyMiniCompleted = recommendationObj.getDailyMiniCompleted(dailyMiniId);
            //loggerObj.debugLog("recommendation check for the id for same theme101 ", mastery);
            if (mastery <= constantsObj.MASTERY_BRONZE) {
                // main/archive clearer mastery 1 poor/rich P0
                if (!dailyMiniCompleted) {
                    recommendedPuzzleId = dailyMiniId;
                    params.conditionType = "LP2";
                }
                // main/archive clearer mastery 1 poor/rich P1
                if (recommendedPuzzleId == null && coinCount >= constantsObj.MAX_PACK_PRICE) {
                    var id = gameObj.getPackIdSurfacedToBuy();
                    if (id != -1) {
                        recommendedPuzzleId = id;
                        params.cashAvailable = true;
                        params.conditionType = "LP5";
                    }
                } else if (recommendedPuzzleId == null && coinCount < constantsObj.MAX_PACK_PRICE) {
                    var id = recommendationObj.getFirstNonInteractedFreePack();
                    if (id != -1) {
                        recommendedPuzzleId = gameObj.firstIncompletePuzzle(id);
                        params.conditionType = "LP6";
                    }
                }
                //loggerObj.debugLog("recommendation check for the id for same theme10133 ",id);
                // main/archive clearer mastery 1 poor/rich P2
                if (recommendedPuzzleId == null) {
                    var id = gameObj.getPackIdSurfaced();
                    //loggerObj.debugLog("recommendation check for the id for same theme10132 ",id);
                    if (id != -1) {
                        recommendedPuzzleId = gameObj.firstIncompletePuzzle(id);
                        params.inProgress = true;
                        params.conditionType = "LP8";
                    }
                }
                if (recommendedPuzzleId == null) {
                    recommendedPuzzleId = recommendationObj.getMultipleInProgressPuzzle(1);
                    params.inProgress = true;
                    params.conditionType = "LP7";
                }
                if (recommendedPuzzleId == null) {
                    if (coinCount < economyObj.getRevealCrosswordCost()) {
                        var countVideoWatchedRuntime = recommendationObj.getCountVideoWatchedRuntimeValue();
                        if (adsObj.checkRewardedVideo(false) && gameObj.getCountVideoWatched() < countVideoWatchedRuntime) {
                            recommendedPuzzleId = recommendationObj.getMultipleLockedPuzzle(puzzleId, 1, 1);
                            params.watchVideo = true;
                            params.conditionType = "LP3";
                        }
                    } else {
                        var id = recommendationObj.getFirstNonInteractedFreePack();
                        if (id != -1) {
                            recommendedPuzzleId = gameObj.firstIncompletePuzzle(id);
                            params.conditionType = "LP6";
                        }
                    }
                }
            } else {
                //loggerObj.debugLog("recommendation check for the id11 ", recommendedPuzzleId,gameObj.getTodaysFreePuzzle());
                if (gameObj.getTodaysFreePuzzle() == null) {
                    recommendationObj.setTodaysBonusArchivePuzzle();
                }
                //loggerObj.debugLog("recommendation check for the id12 ", recommendedPuzzleId,gameObj.getTodaysFreePuzzle());
                if (adsObj.checkRewardedVideo(false) && gameObj.getTodaysFreePuzzle() != null && !utilObj.isObject(inProgress[gameObj.getTodaysFreePuzzle()]) && !scoresObj.getMastery(gameObj.getTodaysFreePuzzle()) > 0) {
                    recommendedPuzzleId = gameObj.getTodaysFreePuzzle();
                    params.bonusArchive = true;
                    params.conditionType = "LP9";
                }
                if (recommendedPuzzleId == null) {
                    if (coinCount > economyObj.getRevealCrosswordCost()) {
                        recommendedPuzzleId = recommendationObj.getMultipleLockedPuzzle(puzzleId, 1, 7);
                        if (recommendedPuzzleId != null) {
                            params.cashAvailable = true;
                            params.conditionType = "LP4";
                        }
                        if (recommendedPuzzleId == null) {
                            var id = gameObj.getPackIdSurfacedToBuy();
                            if (id != -1) {
                                recommendedPuzzleId = id;
                                params.cashAvailable = true;
                                params.conditionType = "LP5";
                            }
                        }
                        if (recommendedPuzzleId == null) {
                            recommendedPuzzleId = recommendationObj.getMultipleInProgressPuzzle(1);
                            params.inProgress = true;
                            params.conditionType = "LP7";
                        }
                        if (recommendedPuzzleId == null) {
                            var id = gameObj.getPackIdSurfaced();
                            if (id != -1) {
                                recommendedPuzzleId = gameObj.firstIncompletePuzzle(id);
                                params.inProgress = true;
                                params.conditionType = "LP8";
                            }
                        }
                        params.id = recommendedPuzzleId;
                    } else {
                        if (puzzleId == todaysPuzzleId) {
                            if (recommendedPuzzleId == null) {
                                var countVideoWatchedRuntime = recommendationObj.getCountVideoWatchedRuntimeValue();
                                if (adsObj.checkRewardedVideo(false) && gameObj.getCountVideoWatched() < countVideoWatchedRuntime) {
                                    recommendedPuzzleId = recommendationObj.getMultipleLockedPuzzle(puzzleId, 1, 7);
                                    params.watchVideo = true;
                                    params.conditionType = "LP3";
                                }
                            }
                            if (recommendedPuzzleId == null && !dailyMiniCompleted) {
                                recommendedPuzzleId = dailyMiniId;
                                params.conditionType = "LP2";
                            }
                            if (recommendedPuzzleId == null) {
                                recommendedPuzzleId = recommendationObj.getMultipleInProgressPuzzle(1);
                                params.inProgress = true;
                                params.conditionType = "LP7";
                            }
                            if (recommendedPuzzleId == null) {
                                var id = gameObj.getPackIdSurfaced();
                                if (id != -1) {
                                    recommendedPuzzleId = gameObj.firstIncompletePuzzle(id);
                                    params.inProgress = true;
                                    params.conditionType = "LP8";
                                }
                            }
                        } else if (puzzleId != todaysPuzzleId) {
                            if (recommendedPuzzleId == null && !gameObj.getTodaysPuzzleCompleted()) {
                                recommendedPuzzleId = todaysPuzzleId;
                                params.conditionType = "LP1";
                            }
                            if (recommendedPuzzleId == null) {
                                var countVideoWatchedRuntime = recommendationObj.getCountVideoWatchedRuntimeValue();
                                if (adsObj.checkRewardedVideo(false) && gameObj.getCountVideoWatched() < countVideoWatchedRuntime) {
                                    recommendedPuzzleId = recommendationObj.getMultipleLockedPuzzle(puzzleId, 1, 7);
                                    params.watchVideo = true;
                                    params.conditionType = "LP3";
                                }
                            }
                            if (recommendedPuzzleId == null) {
                                recommendedPuzzleId = recommendationObj.getMultipleInProgressPuzzle(1);
                                params.inProgress = true;
                                params.conditionType = "LP7";
                            }
                            if (recommendedPuzzleId == null && !dailyMiniCompleted) {
                                var id = gameObj.getPackIdSurfaced();
                                if (id != -1) {
                                    recommendedPuzzleId = gameObj.firstIncompletePuzzle(id);
                                    params.inProgress = true;
                                    params.conditionType = "LP8";
                                }
                            }
                        }
                        params.id = recommendedPuzzleId;
                        // params.cashAvailable = false;
                    }
                }
            }
        } else if (gameObj.checkForDailyMini(gameLayer.crosswordDate)) {
            if (!gameObj.getTodaysPuzzleCompleted()) {
                recommendedPuzzleId = todaysPuzzleId;
                params.conditionType = "LP1";
            }
            if (recommendedPuzzleId == null) {
                var id = gameObj.getPackIdSurfaced();
                if (id != -1) {
                    recommendedPuzzleId = gameObj.firstIncompletePuzzle(id);
                    params.inProgress = true;
                    params.conditionType = "LP8";
                }
            }
            if (recommendedPuzzleId == null) {
                if (coinCount >= constantsObj.MAX_PACK_PRICE) {
                    var id = gameObj.getPackIdSurfacedToBuy();
                    if (id != -1) {
                        recommendedPuzzleId = id;
                        params.cashAvailable = true;
                        params.conditionType = "LP5";
                    }
                } else {
                    var id = recommendationObj.getFirstNonInteractedFreePack();
                    if (id != -1) {
                        recommendedPuzzleId = gameObj.firstIncompletePuzzle(id);
                        params.inProgress = true;
                        params.conditionType = "LP6";
                    }
                }
            }
            if (recommendedPuzzleId == null) {
                if (coinCount >= economyObj.getRevealCrosswordCost()) {
                    recommendedPuzzleId = recommendationObj.getMultipleLockedPuzzle(puzzleId, 1, 1);
                    params.cashAvailable = true;
                    params.conditionType = "LP4";
                } else {
                    recommendedPuzzleId = recommendationObj.getMultipleInProgressPuzzle(1);
                    params.conditionType = "LP7";
                }
            }
        }
        params.id = recommendedPuzzleId;
        // if (params.id != null) {
        //     recommendationPopup.show(true, params, constantsObj.SCREEN_GAME);
        // }
        return params;
    };

    this.getRecommendationNonClearerPuzzleId = function () {
        var params = {id: null, watchedVideo: false, bonusArchive: false, cashAvailable: false};
        var puzzleId = gameLayer.crosswordDate;
        var todaysPuzzleId = gameObj.getIdForTodaysPuzzle();
        var recommendedPuzzleId = null;
        var dailyMiniId = stringsObj.mini_prefix + todaysPuzzleId.substr(2, todaysPuzzleId.length);
        var dailyMiniCompleted = recommendationObj.getDailyMiniCompleted(dailyMiniId);
        var deltaValue = runtimeObj.getPovertyLineValue();
        var coinCount = economyObj.getCash() - deltaValue;
        var isMiniOrMidi = gameObj.checkForMiniOrMidi(gameLayer.crosswordDate);
        if (!isMiniOrMidi && gameLayer.crosswordDate != gameObj.getD0Id()) {
            if (!dailyMiniCompleted) {
                recommendedPuzzleId = dailyMiniId;
                params.conditionType = "LP2";
            }
            if (recommendedPuzzleId == null) {
                if (coinCount >= constantsObj.MAX_PACK_PRICE) {
                    var id = gameObj.getPackIdSurfacedToBuy();
                    if (id != -1) {
                        recommendedPuzzleId = id;
                        params.cashAvailable = true;
                        params.conditionType = "LP5";
                    }
                } else {
                    var id = recommendationObj.getFirstNonInteractedFreePack();
                    if (id != -1) {
                        recommendedPuzzleId = gameObj.firstIncompletePuzzle(id);
                        params.conditionType = "LP6";
                    }
                }
            }
            if (recommendedPuzzleId == null) {
                var id = gameObj.getPackIdSurfaced();
                if (id != -1) {
                    recommendedPuzzleId = gameObj.firstIncompletePuzzle(id);
                    params.inProgress = true;
                    params.conditionType = "LP8";
                }
            }
            if (recommendedPuzzleId == null) {
                var countVideoWatchedRuntime = recommendationObj.getCountVideoWatchedRuntimeValue();
                if (adsObj.checkRewardedVideo(false) && gameObj.getCountVideoWatched() < countVideoWatchedRuntime) {
                    recommendedPuzzleId = recommendationObj.getMultipleLockedPuzzle(puzzleId, 1, 1);
                    params.watchVideo = true;
                    params.conditionType = "LP3";
                }
            }
            if (recommendedPuzzleId == null && coinCount >= economyObj.getRevealCrosswordCost()) {
                recommendedPuzzleId = recommendationObj.getMultipleLockedPuzzle(puzzleId, 1, 1);
                params.cashAvailable = true;
                params.conditionType = "LP4";
            }
            params.id = recommendedPuzzleId;
            if (params.id != null) {
                gameObj.setRecommendationPopupShown(true);
                gameObj.setRecommendationPopupTimestamp(utilObj.getCurrentTimestamp());
                // recommendationPopup.show(true, params, constantsObj.SCREEN_GAME);
                // return;
            }
        } else if (gameObj.checkForDailyMini(gameLayer.crosswordDate)) {
            if (!gameObj.getTodaysPuzzleCompleted()) {
                recommendedPuzzleId = todaysPuzzleId;
                params.conditionType = "LP1";
            }
            if (recommendedPuzzleId == null) {
                var id = gameObj.getPackIdSurfaced();
                if (id != -1) {
                    recommendedPuzzleId = gameObj.firstIncompletePuzzle(id);
                    params.inProgress = true;
                    params.conditionType = "LP8";
                }
            }
            if (recommendedPuzzleId == null) {
                if (coinCount >= constantsObj.MAX_PACK_PRICE) {
                    var id = gameObj.getPackIdSurfacedToBuy();
                    if (id != -1) {
                        recommendedPuzzleId = id;
                        params.cashAvailable = true;
                        params.conditionType = "LP5";
                    }
                } else {
                    var id = recommendationObj.getFirstNonInteractedFreePack();
                    if (id != -1) {
                        recommendedPuzzleId = gameObj.firstIncompletePuzzle(id);
                        params.conditionType = "LP6";
                    }
                }
            }
            if (recommendedPuzzleId == null) {
                if (coinCount >= economyObj.getRevealCrosswordCost()) {
                    recommendedPuzzleId = recommendationObj.getMultipleLockedPuzzle(puzzleId, 1, 1);
                    params.cashAvailable = true;
                    params.conditionType = "LP4";
                } else {
                    recommendedPuzzleId = recommendationObj.getMultipleInProgressPuzzle(1);
                    params.inProgress = true;
                    params.conditionType = "LP7";
                }
            }
            params.id = recommendedPuzzleId;
            if (params.id != null) {
                gameObj.setRecommendationPopupShown(true);
                gameObj.setRecommendationPopupTimestamp(utilObj.getCurrentTimestamp());
                // recommendationPopup.show(true, params, constantsObj.SCREEN_GAME);
                // return;
            }
        }
        return params;
    };
};