SyncReqRespCheck = function () {
    var reqStarted = false;
    var lastReqStartTimeStamp = 0;
    var syncCheckController = null;
    var syncInProgress = false;
    var syncResetTimer = null;

    this.init = function () {
        syncCheckController = gameObj.getGameController();
    };

    this.syncToServer = function (syncAhead) {
        if(psPrivacyObj.shouldAccountLockedBeShown()) {
            return;
        }
        var passesBasicChecks = utilObj.passesBasicSyncChecks(lastReqStartTimeStamp, constantsObj.SYNC_REQ_RESP_INTERVAL);
        if (passesBasicChecks && reqStarted && !syncInProgress) {
            var syncReqRespData = {};
            syncInProgress = true;
            if (syncResetTimer != null) {
                window.clearTimeout(syncResetTimer);
            }
            syncResetTimer = window.setTimeout(syncReqRespCheckObj.resetSyncInProgress, 50 * 1000);
            syncReqRespData.refId = userObj.getRefId();
            if (syncReqRespData.refId == "") {
                return;
            }
            syncReqRespData.deviceId = userObj.getCurDevice();
            if (syncReqRespData.deviceId == "" && utilObj.isNative()) {
                syncReqRespData.deviceId = utilObj.getDeviceId() + "";
            }
            syncReqRespData.lastReqStartTimeStamp = lastReqStartTimeStamp + "";
            //loggerObj.debugLog("calling for syncReqResp reqresp sync", utilObj.getStringifiedJson(syncReqRespData));
            trackObj.trackCounter(constantsObj.TRACK_DEBUG, constantsObj.TRACK_GAME_SYNC_REQ_RESP, constantsObj.TRACK_REQUEST, economyObj.getCashIncrementInfo(), economyObj.getCashDecrementInfo(), utilObj.getCurrentTimestamp() + "", syncReqRespData.lastReqStartTimeStamp, 1, "");
            syncCheckController.sendHttpRequest("syncReqRespCheck", "fetch", syncReqRespData);
        }
    };

    this.respHandler = function (action, data, success) {
        if (action === "fetch") {
            if (success == true) {
                //loggerObj.debugLog("calling for syncReqResp reqresp response ");
                var cash = parseInt(data.ca);
                trackObj.trackCounter(constantsObj.TRACK_DEBUG, constantsObj.TRACK_GAME_SYNC_REQ_RESP, constantsObj.TRACK_SUCCESS,
                    economyObj.getCashIncrementInfo(), economyObj.getCashDecrementInfo(), cash, "", 1, "");
                if (cash != -1) {
                    //loggerObj.debugLog("calling for syncReqResp reqresp response found", cash);
                    economyObj.updateCash(cash);
                }
                gameObj.setSyncInProgress(false);
                reqStarted = false;
            }
            if (syncResetTimer != null) {
                window.clearTimeout(syncResetTimer);
                syncResetTimer = null;
            }
            syncInProgress = false;
        } else {
            loggerObj.errorLog("Unknown action received from in progress server. Action:" + action + ";Data:" + data);
        }

    };

    this.resetSyncInProgress = function () {
        if (syncInProgress) {
            trackObj.trackCounter(constantsObj.TRACK_DEBUG, constantsObj.TRACK_GAME_SYNC_REQ_RESP, constantsObj.TRACK_FAIL, economyObj.getCashIncrementInfo(), economyObj.getCashDecrementInfo(), "resetTimer", "", 1, "");
            syncInProgress = false;
        }
    };

    this.setReqStarted = function (val) {
        reqStarted = val;
    };

    this.getReqStarted = function () {
        return reqStarted;
    };

    this.setLastReqStartTimeStamp = function (val) {
        lastReqStartTimeStamp = val;
    };

    this.getLastReqStartTimeStamp = function () {
        return lastReqStartTimeStamp;
    };
};