ThemedQuest = function () {
    var themedQuestData = null;
    // var isQuestLocked = true;
    var questMastery = null;
    var tqPopupTimerLabel = null;
    var tqHomeTimerLabel = null;
    var tqMapLayerTimerLabel = null;
    var timerStringPopup = null;
    var timerStringHome = null;
    var timerStringMapLayer = null;


    this.init = function () {
        // Load Json
        var fileName = "themedQuest.json";
        if (utilObj.isStaging()) {
            fileName = "themedQuestStaging.json";
        }
        var questData = ls.getItem(fileName);
        var parsedQuestData = null;
        if (questData != null && questData != "") {
            try {
                parsedQuestData = JSON.parse(questData);
                // loggerObj.errorLog("daily load4");
            } catch (e) {
                loggerObj.errorLog("Exception while loading json:", e);
            }
        }

        cc.loader.loadJson("res/jsons/" + fileName, function (error, data) {
            if (!error) {
                themedQuestData = data;
                // milestones = data.milestones;
                //loggerObj.debugLog("themedquest mastery resset check1", JSON.stringify(themedQuestData));
            }
        });
        //loggerObj.debugLog("download themedQuest3", JSON.stringify(parsedQuestData), themedQuestData);

        if (parsedQuestData != null && themedQuestData!= null) {
            if (parsedQuestData.jsonVersion > themedQuestData.jsonVersion) {
                //loggerObj.debugLog("download themedQuest4", parsedQuestData);
                themedQuestData = parsedQuestData;
            }
        }

        // Call unlock function once json loaded
        this.unlock();
    };

    this.setThemedQuestData = function (val) {
        //loggerObj.debugLog("download themedQuest1", JSON.stringify(val));
        if (val.jsonVersion > themedQuestData.jsonVersion) {
            //loggerObj.debugLog("download themedQuest2", val);
            themedQuestData = val;
        }
        gameObj.checkAndSetThemedQuestVersion();
    };

    this.unlock = function () {
        // Check if any quest is ready to unlock
        // If unlocked, show the quest start popup
        var curTimestamp = gameObj.getLastSync();
        if(curTimestamp == 0) {
            return;
        }
        // if (utilObj.isStaging()) {
        //     curTimestamp = utilObj.getCurrentTimestamp();
        // } else {
        //     // For getting timestamp, get the last game sync time
        //     curTimestamp = gameObj.getLastSync();
        // }
        // Condition met
        // themedQuestStartPopup.show();
        //loggerObj.debugLog("curtime", curTimestamp);

        var buildVersionCode = utilObj.getVersionCode();
        var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
        // loggerObj.debugLog("themedQuestCheck3",buildVersionCode,curTimestamp );
        var completedArray = gameObj.getPuzzlesCompletedArray();
        var starsAchieved = 0;
        if (gameObj.getIsThemedQuestLocked()) {
            for (var i in completedArray) {
                if (completedArray[i]["completed"]) {
                    starsAchieved += 1;
                }
            }
        }
       // loggerObj.debugLog("themedQuestt1",gameObj.getWeeklyQuestMastery(),gameObj.getExpNewWeeklyQuestVariant(),starsAchieved,(gameObj.getWeeklyQuestMastery() == 0 && gameObj.getExpNewWeeklyQuestVariant() == constantsObj.EXP_VAR_CONTROL),(starsAchieved == 0 && gameObj.getExpNewWeeklyQuestVariant() != constantsObj.EXP_VAR_CONTROL));
        //loggerObj.debugLog("themedQuestt2",curTimestamp , themedQuestData.start, themedQuestData.end);
        if (curTimestamp >= themedQuestData.start && curTimestamp < themedQuestData.end && ((utilObj.isAndroid() && buildVersionCode >= themedQuestData.minBuildAndroid) || (utilObj.isIos() && buildVersionCode >= themedQuestData.minBuildIos))&&((gameObj.getMastery() > 0 && weeklyQuestExp == constantsObj.EXP_VAR_CONTROL && epmObj.getChosenVariant(constantsObj.EXP_THEMED_QUEST) == constantsObj.EXP_VAR_1)|| ( epmObj.getChosenVariant(constantsObj.EXP_THEMED_QUEST) == constantsObj.EXP_VAR_1 && gameObj.getMastery1() >= 5 && (weeklyQuestExp == constantsObj.EXP_VAR_1 || weeklyQuestExp == constantsObj.EXP_VAR_2 || weeklyQuestExp == constantsObj.EXP_VAR_3 || weeklyQuestExp == constantsObj.EXP_VAR_4)) )){
            if (gameObj.getIsThemedQuestLocked() == true && ((gameObj.getWeeklyQuestMastery() == 0 && gameObj.getExpNewWeeklyQuestVariant() == constantsObj.EXP_VAR_CONTROL) || (starsAchieved == 0 && gameObj.getExpNewWeeklyQuestVariant() != constantsObj.EXP_VAR_CONTROL))) {

                if (!gameObj.getIsQuestEligileToShow()) {
                    return;
                }

                var startTimestamp = constantsObj.PUZZLE_START_TIMESTAMP * 1000;
                var milliSecInDay = constantsObj.SECONDS_IN_DAY * 1000;
                var curTime = curTimestamp * 1000;
                var counter = 0;
                var count = constantsObj.THEMEDQUEST_PUZZLES;
                if (gameObj.getExpNewWeeklyQuestVariant() != constantsObj.EXP_VAR_CONTROL ){
                    count = questMapObj.getNumberOfPuzzlesInNextQuest();
                }
                var flag = false;

                // check if enough puzzles are available for tq to unlock
                while (curTime > startTimestamp) {
                    curTime -= milliSecInDay;
                    var date = new Date(curTime);
                    var id = utilObj.getIdForDate(date);
                    if (parseInt(id) < 20170301) {
                        continue;
                    }
                    if(id == gameObj.getInstallDay()) {
                        if(scoresObj.getMastery(gameObj.getD0Id()) == 0) {
                            counter++;
                        }
                    } else if (scoresObj.getMastery(id) == 0) {
                        counter++;
                        //loggerObj.debugLog("datesss", date);
                    }
                    //loggerObj.debugLog("inprogress", JSON.stringify(gameObj.get));
                    if (counter == count) {
                        // loggerObj.debugLog("themedQuestCheck3");
                        flag = true;
                        break;
                    }
                }
                // additional check for packs and minis
                if (!flag) {
                    var purchasedPackInfo = gameObj.getPurchasedPackInfo();
                    for (var id in purchasedPackInfo) {
                        for (var j in purchasedPackInfo[id]) {
                            var puzzleId = purchasedPackInfo[id][j];
                            if (scoresObj.getMastery(puzzleId) == 0) {
                                counter++;
                            }
                           // loggerObj.debugLog("checking packs and minis for numbers", counter, puzzleId);
                            if (counter == count) {
                                flag = true;
                                break;
                            }
                        }
                        if (flag) {
                            break;
                        }
                    }
                }

                if(flag == true) {

                    // fetchng experiment value for assigning the new llp quest allocation only when a new quest is unlocked
                    var expNewWeeklyQuestVariant = epmObj.getChosenVariant(constantsObj.EXP_QUEST_REVAMP);
                    gameObj.setExpNewWeeklyQuestVariant(expNewWeeklyQuestVariant);

                    if (expNewWeeklyQuestVariant != constantsObj.EXP_VAR_CONTROL) {
                        return;
                    }

                    if(gameObj.getExpNewWeeklyQuestVariant() == constantsObj.EXP_VAR_CONTROL) {
                        gameObj.setMasteryOnThemedQuestStart(gameObj.getMastery());
                    }

                    gameObj.setIsThemedQuestIntroPopupEligible(true);
                    if(!gameObj.getIsThemedQuestFinished()) {
                        // gameObj.setThemedQuestMastery(0);
                    }
                    gameObj.setIsThemedQuestLocked(false);
                    gameObj.setIsRuntimeReset(true);

                    //reset values for new quest
                    questMapObj.resetVariablesForNewQuest();
                }
            }
        } else {
            gameObj.setIsThemedQuestLocked(true);
        }
    };


    this.getThemedQuestData = function () {
        //loggerObj.debugLog("themesdscs");
        return themedQuestData;
    };

    this.getQuestState = function () {
        return gameObj.getIsThemedQuestLocked();
    };

    this.setTqPopupTimerLabel = function (lbl) {
        tqPopupTimerLabel = lbl;
    };

    this.setTqHomeTimerLabel = function (lbl) {
        tqHomeTimerLabel = lbl;
    };

    this.setTqMapLayerTimerLabel = function(lbl){
        tqMapLayerTimerLabel = lbl;
    };

    this.getTqPopupTimerText = function () {
        var timeRemaining = themedQuestData["end"] - utilObj.getCurrentTimestamp();
        var days = Math.floor(timeRemaining / 86400);
        if(days > 0) {
            if (Math.floor(timeRemaining / 86400) == 1) {
                return  Math.floor(timeRemaining / 86400) + " day left!";
            } else {
                return  Math.floor(timeRemaining / 86400) + " days left!";
            }
        } else {
            // var end = themedQuestData["end"];
            // var start = utilObj.getCurrentTimestamp();
            timeRemaining = timeRemaining % 86400;
            var hours = Math.floor(timeRemaining / 3600);
            if(hours < 10){
                hours = "0" + hours;
            }
            timeRemaining = timeRemaining % 3600;
            var minutes = Math.floor(timeRemaining / 60);
            if(minutes < 10){
                hours = "0" + minutes;
            }
            timeRemaining = timeRemaining % 60;
            var seconds = timeRemaining;
            if(seconds < 10){
                hours = "0" + seconds;
            }
            return "Hurry! Only "+ hours + ":" + minutes + ":" + seconds + " left!";
        }
    };

    this.getTqMapLayerTimerText = function () {
        var timeRemaining = themedQuestData["end"] - utilObj.getCurrentTimestamp();
        var days = Math.floor(timeRemaining / 86400);
        if(days > 0) {
            if (Math.floor(timeRemaining / 86400) == 1) {
                return  Math.floor(timeRemaining / 86400) + " day left!";
            } else {
                return  Math.floor(timeRemaining / 86400) + " days left!";
            }
        } else {
            // var end = themedQuestData["end"];
            // var start = utilObj.getCurrentTimestamp();
            timeRemaining = timeRemaining % 86400;
            var hours = Math.floor(timeRemaining / 3600);
            if(hours < 10){
                hours = "0" + hours;
            }
            timeRemaining = timeRemaining % 3600;
            var minutes = Math.floor(timeRemaining / 60);
            if(minutes < 10){
                hours = "0" + minutes;
            }
            timeRemaining = timeRemaining % 60;
            var seconds = timeRemaining;
            if(seconds < 10){
                hours = "0" + seconds;
            }
            return hours + ":" + minutes + ":" + seconds + " left!";
        }
    };

    this.getTqHomeTimerText = function () {
        var timeRemaining = themedQuestData["end"] - utilObj.getCurrentTimestamp();
        var days = Math.floor(timeRemaining / 86400);
        if(days > 0) {
            if (Math.floor(timeRemaining / 86400) == 1) {
                return Math.floor(timeRemaining / 86400) + " Day";
            } else {
                return Math.floor(timeRemaining / 86400) + " Days";
            }
        } else {
            // var end = themedQuestData["end"];
            // var start = utilObj.getCurrentTimestamp();
            timeRemaining = timeRemaining % 86400;
            var hours = Math.floor(timeRemaining / 3600);
            if(hours < 10){
                hours = "0" + hours;
            }
            timeRemaining = timeRemaining % 3600;
            var minutes = Math.floor(timeRemaining / 60);
            if(minutes < 10){
                minutes = "0" + minutes;
            }
            timeRemaining = timeRemaining % 60;
            var seconds = timeRemaining;
            if(seconds < 10){
                seconds = "0" + seconds;
            }
            return hours + ":" + minutes + ":" + seconds;
        }
    };

    this.updateTimeRemaining = function () {
        if (gameObj.getIsThemedQuestLocked()) {
            return;
        }
        var end = themedQuestData["end"];
        var start = utilObj.getCurrentTimestamp();
        var timeRemaining = end - start;
        if (timeRemaining <= 0) {
            var redrawHome = false;
            //loggerObj.debugLog("Check - curScreen:", curScreen, lastScreen);
            if (curScreen == constantsObj.SCREEN_THEMED_QUEST) {
                popupLayer.setDontGoToLastScreen(true);
                popupLayer.closeWithDefault();
                redrawHome = true;
            } else if (curScreen == constantsObj.SCREEN_HOME  || curScreen == constantsObj.SCREEN_QUEST_MAP) {
                redrawHome = true;
            }
            gameObj.setIsThemedQuestLocked(true);
            if (redrawHome) {
                homeLayer.redraw();
            }
            return;
        }
        var days = Math.floor(timeRemaining / 86400);
        if (days > 0) {
            return Math.floor(timeRemaining / 86400) + " days";
        }
        timeRemaining = timeRemaining % 86400;
        var hours = Math.floor(timeRemaining / 3600);

        if(hours < 10){
            hours = "0" + hours;
        }
        timeRemaining = timeRemaining % 3600;
        var minutes = Math.floor(timeRemaining / 60);
        if(minutes < 10){
            minutes = "0" + minutes;
        }
        timeRemaining = timeRemaining % 60;
        var seconds = timeRemaining;
        if(seconds < 10){
            seconds = "0" + seconds;
        }
        timerStringPopup = "Hurry! Only "+ hours + ":" + minutes + ":" + seconds + " left!";
        timerStringHome = hours + ":" + minutes + ":" + seconds;
        timerStringMapLayer = hours + ":" + minutes + ":" + seconds + " left!";
        if (utilObj.isNodeValid(tqPopupTimerLabel)) {
            tqPopupTimerLabel.setString(timerStringPopup);
        }
        if (utilObj.isNodeValid(tqHomeTimerLabel)) {
            tqHomeTimerLabel.setString(timerStringHome);
        }
        if(utilObj.isNodeValid(tqMapLayerTimerLabel)){
            tqMapLayerTimerLabel.setString(timerStringMapLayer);
        }
    };

    this.updateCashDelayed = function (sender, params) {
        var layer = params.layer;
        var cashLabel = params.label;
        themedQuestObj.updateCash(layer, cashLabel);
    };

    this.updateCash = function (layer, cashLabel) {
        if(gameObj.getExpNewWeeklyQuestVariant() == constantsObj.EXP_VAR_CONTROL) {
            var starsAchieved = gameObj.getThemedQuestMastery();
            var mileStones1 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(0));
            var mileStones2 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(1));
            var mileStones3 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(2));
            var milestones = [mileStones1, mileStones2, mileStones3];
            var milestonesCompleted = gameObj.getThemedQuestMilestonesCompleted();
            if (gameObj.getThemedQuestMilestonesCompleted() != null) {
                milestonesCompleted = gameObj.getThemedQuestMilestonesCompleted();
            }

            if (starsAchieved >= milestones[0] && starsAchieved < milestones[1]) {
                // economyObj.addCash(milestones[0]);
                if (milestonesCompleted[0] == 0) {
                    milestonesCompleted[0] = 1;
                    gameObj.setThemedQuestMilestonesCompleted(milestonesCompleted);
                    var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
                    var trackC = constantsObj.TRACK_TQ_1 + "easy";
                    if ((weeklyQuestExp == constantsObj.EXP_VAR_3 || weeklyQuestExp == constantsObj.EXP_VAR_4) && gameObj.getWeeklyQuestLastWeekMastery() >= runtimeObj.getWeeklyQuestMasteryLimit()) {
                        trackC = constantsObj.TRACK_TQ_1 + "hard";
                    }
                    var coins = weeklyQuestObj.checkWeeklyQuestMastery(starsAchieved, milestones);
                    economyObj.addCash(coins, constantsObj.TRACK_EARN, trackC, "");
                    if (epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST) == constantsObj.EXP_VAR_CONTROL) {
                        utilObj.showMessage(coins + " " + " coins have been rewarded");
                    } else {
                        animObj.animateGiftOpen1(0.25, 0.2, constantsObj.SPRITE_Z_ORDER + 100, coins, starsAchieved, milestones, layer, cashLabel);
                    }
                }
            } else if (starsAchieved >= milestones[1] && starsAchieved < milestones[2]) {
                // economyObj.addCash(milestones[0]);
                if (milestonesCompleted[1] == 0) {
                    milestonesCompleted[1] = 1;
                    gameObj.setThemedQuestMilestonesCompleted(milestonesCompleted);
                    var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
                    var trackC = constantsObj.TRACK_TQ_2 + "easy";
                    if ((weeklyQuestExp == constantsObj.EXP_VAR_3 || weeklyQuestExp == constantsObj.EXP_VAR_4) && gameObj.getWeeklyQuestLastWeekMastery() >= runtimeObj.getWeeklyQuestMasteryLimit()) {
                        trackC = constantsObj.TRACK_TQ_2 + "hard";
                    }
                    var coins = weeklyQuestObj.checkWeeklyQuestMastery(starsAchieved, milestones);
                    economyObj.addCash(coins, constantsObj.TRACK_EARN, trackC, "");
                    if (epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST) == constantsObj.EXP_VAR_CONTROL) {
                        utilObj.showMessage(coins + " " + " coins have been rewarded");
                    } else {
                        animObj.animateGiftOpen1(0.25, 0.2, constantsObj.SPRITE_Z_ORDER + 100, coins, starsAchieved, milestones, layer, cashLabel);
                    }
                }
            } else if (starsAchieved >= milestones[2]) {
                if (milestonesCompleted[2] == 0) {
                    milestonesCompleted[2] = 1;
                    gameObj.setThemedQuestMilestonesCompleted(milestonesCompleted);
                    gameObj.setThemedQuestCompleted(true);
                    var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
                    var trackC = constantsObj.TRACK_TQ_3 + "easy";
                    if ((weeklyQuestExp == constantsObj.EXP_VAR_3 || weeklyQuestExp == constantsObj.EXP_VAR_4) && gameObj.getWeeklyQuestLastWeekMastery() >= runtimeObj.getWeeklyQuestMasteryLimit()) {
                        trackC = constantsObj.TRACK_TQ_3 + "hard";
                    }
                    var coins = weeklyQuestObj.checkWeeklyQuestMastery(starsAchieved, milestones);
                    economyObj.addCash(coins, constantsObj.TRACK_EARN, trackC, "");
                    if (epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST) == constantsObj.EXP_VAR_CONTROL) {
                        utilObj.showMessage(coins + " " + " coins have been rewarded");
                    } else {
                        animObj.animateGiftOpen1(0.25, 0.2, constantsObj.SPRITE_Z_ORDER + 100, coins, starsAchieved, milestones, layer, cashLabel);
                    }

                    gameObj.setIsQuestEligileToShow(false);
                }
            }
        }
    };

    this.checkAnimationToShow = function () {
        if (gameObj.getIsThemedQuestLocked()) {
            return false;
        }
        var starsAchieved = gameObj.getThemedQuestMastery();
        var mileStones1 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(0));
        var mileStones2 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(1));
        var mileStones3 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(2));
        var milestones = [mileStones1, mileStones2, mileStones3];
        var coinsArr = weeklyQuestObj.checkWeeklyQuestMastery(starsAchieved, milestones);
        var milestonesCompleted = gameObj.getThemedQuestMilestonesCompleted();
        if(gameObj.getThemedQuestMilestonesCompleted() != null) {
            milestonesCompleted = gameObj.getThemedQuestMilestonesCompleted();
        }

        if (starsAchieved >= milestones[0] && starsAchieved < milestones[1]) {
            if(milestonesCompleted[0] == 0) {
                if (epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST) == constantsObj.EXP_VAR_CONTROL) {
                    // do nothing
                } else {
                   return true;
                }
            }
        } else if (starsAchieved >= milestones[1] && starsAchieved < milestones[2]){
            if(milestonesCompleted[1] == 0) {
                if (epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST) == constantsObj.EXP_VAR_CONTROL) {
                    //
                } else {
                    return true;
                }
            }
        } else if (starsAchieved >= milestones[2]){
            if(milestonesCompleted[2] == 0) {
                if (epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST) == constantsObj.EXP_VAR_CONTROL) {
                   // do nothing
                } else {
                    return true;
                }
            }
        }
        return false;
    };

};