WeeklyQuest = function () {
    var weeklyQuestData = null;
    // var isQuestLocked = true;
    var weeklyQuestMastery = null;
    var wqPopupTimerLabel = null;
    var wqHomeTimerLabel = null;
    var wqMapLayerTimerLabel = null;
    var timerStringPopup = null;
    var timerStringHome = null;
    var timerStringMapLayer = null;
    var weeklyQuestEndTime = null;
    var weeklyQuestStartTime = null;
    var wqMilestones = [];
    var wqTotalstars = null;
    var wq_reward = [];
    var wq_prob = [];
    var wq_payer_reward = [];
    var wq_payer_prob = [];

    this.unlock = function () {
        // Check if any quest is ready to unlock
        // If unlocked, show the quest start popup
        var weeklyQuestFirstStartTime = gameObj.getWeeklyQuestStartTime();
        var curTimestamp = utilObj.getCurrentTimestamp();
        if (curTimestamp == 0) {
            return;
        }


        var todayDate = gameObj.getTodaysPuzzleDate();
        var day = todayDate.getDay();
        // loggerObj.debugLog("Today day2", day);
        var startOfTheDay = constantsObj.SECONDS_IN_DAY - gameObj.getPuzzleUnlockTime();
        // loggerObj.debugLog("Today day3", startOfTheDay);
        weeklyQuestStartTime = utilObj.getCurrentTimestamp() - ((day) * constantsObj.SECONDS_IN_DAY) - startOfTheDay;
        // loggerObj.debugLog("Today day4", weeklyQuestStartTime, gameObj.getPuzzleUnlockTime());

        var masteryWQ = gameObj.getWeeklyQuestMastery();

        if (weeklyQuestFirstStartTime == null || weeklyQuestFirstStartTime == 0) {
            weeklyQuestFirstStartTime = weeklyQuestStartTime;
            gameObj.setWeeklyQuestStartTime(weeklyQuestFirstStartTime);
        }
        var weekDiff = utilObj.getCurrentTimestamp() - weeklyQuestFirstStartTime;
        var previousVersion = gameObj.getWeeklyQuestVersion();
        var version = -1;
        if(weekDiff < 0){
            version = previousVersion - 1;
        }else{
            version = (Math.floor(weekDiff / constantsObj.SECONDS_ONE_WEEK)) + 1;
        }

        var serverTime = gameObj.getLastSync();
        var themedQuestData = themedQuestObj.getThemedQuestData();
        //to prevent the case if date is changes backward or forward
        if (version > previousVersion ) {
            var quest_revamp =  gameObj.getExpNewWeeklyQuestVariant();
            var isEligibleForTq = true;
            if (quest_revamp != constantsObj.EXP_VAR_CONTROL) {
                isEligibleForTq = false;
            }
            if(!(gameObj.getIsWeeklyQuestLocked() == true && (isEligibleForTq && serverTime >= themedQuestData.start && serverTime < themedQuestData.end))) {
                gameObj.setWeeklyQuestVersion(version);

                //reset values for new quest

                questMapObj.resetVariablesForNewQuest();

                gameObj.setIsQuestEligileToShow(true);
            }else {
                return;
            }

        }

        //setting weekly quest start and end according the change of version
        if (version == previousVersion || version > previousVersion ) {
            loggerObj.debugLog("entering here3");
            weeklyQuestEndTime = utilObj.getCurrentTimestamp() + gameObj.getPuzzleUnlockTime() + ((6 - day) * constantsObj.SECONDS_IN_DAY);
            gameObj.setWeeklyQuestEnd(weeklyQuestEndTime);
            gameObj.setWeeklyQuestStart(weeklyQuestStartTime);
        }else{
            loggerObj.debugLog("entering here4",gameObj.getWeeklyQuestStart());
            weeklyQuestStartTime = gameObj.getWeeklyQuestStart();
            weeklyQuestEndTime = gameObj.getWeeklyQuestEnd();
        }
        var startTimestamp = constantsObj.PUZZLE_START_TIMESTAMP * 1000;
        var milliSecInDay = constantsObj.SECONDS_IN_DAY * 1000;
        var curTime = curTimestamp * 1000;
        var mileStones1 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(0));
        var mileStones2 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(1));
        var mileStones3 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(2));
        var milestones = [mileStones1, mileStones2, mileStones3];
        var count = Math.floor(milestones[2] / 3);
        if (gameObj.getExpNewWeeklyQuestVariant() != constantsObj.EXP_VAR_CONTROL ){
            count = questMapObj.getNumberOfPuzzlesInNextQuest();
        }
        var flag1 = false;
        var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);

        loggerObj.debugLog("entering here2", curTimestamp < weeklyQuestEndTime ,weeklyQuestExp ,gameObj.getIsThemedQuestLocked() == true);
        if (curTimestamp < weeklyQuestEndTime && (weeklyQuestExp == constantsObj.EXP_VAR_1 || weeklyQuestExp == constantsObj.EXP_VAR_2 || weeklyQuestExp == constantsObj.EXP_VAR_3 || weeklyQuestExp == constantsObj.EXP_VAR_4) && gameObj.getIsThemedQuestLocked() == true) {

            if (!gameObj.getIsQuestEligileToShow()) {
                return;
            }

            var questExp = gameObj.getExpNewWeeklyQuestVariant();
            var condition1 = (gameObj.getIsWeeklyQuestLocked() == true) && (gameObj.getMastery1() >= 5) ;//&& (questExp == constantsObj.EXP_VAR_CONTROL);
            var condition2 = (gameObj.getIsWeeklyQuestLocked() == true) && (questExp != constantsObj.EXP_VAR_CONTROL);
            if (condition1) {


                var counter = 0;
                while (curTime > startTimestamp) {
                    curTime -= milliSecInDay;
                    var date = new Date(curTime);
                    var id = utilObj.getIdForDate(date);
                    if (parseInt(id) < 20170301) {
                        continue;
                    }
                    if (id == gameObj.getInstallDay()) {
                        if (scoresObj.getMastery(gameObj.getD0Id()) == 0) {
                            counter++;
                        }
                    } else if (scoresObj.getMastery(id) == 0) {
                        counter++;

                    }

                    if (counter == count) {
                        flag1 = true;
                        break;
                    }
                }

                // additional check for packs and minis
                if (!flag1) {
                    var purchasedPackInfo = gameObj.getPurchasedPackInfo();
                    for (var id in purchasedPackInfo) {
                        for (var j in purchasedPackInfo[id]) {
                            var puzzleId = purchasedPackInfo[id][j];
                            if (scoresObj.getMastery(puzzleId) == 0) {
                                counter++;
                            }
                            loggerObj.debugLog("checking packs and minis for numbers", counter, puzzleId);
                            if (counter == count) {
                                flag1 = true;
                                break;
                            }
                        }
                        if (flag1) {
                            break;
                        }
                    }
                }

                if (flag1 == true) {

                    // fetchng experiment value for assigning the new llp quest allocation only when a new quest is unlocked
                    var expNewWeeklyQuestVariant =  epmObj.getChosenVariant(constantsObj.EXP_QUEST_REVAMP);
                    gameObj.setExpNewWeeklyQuestVariant(expNewWeeklyQuestVariant);

                    // unlocking weekly Quest
                    gameObj.setIsWeeklyQuestLocked(false);

                    // for storing the last quest mastery for runtimes
                    if (gameObj.getLastSeenQuest() == constantsObj.THEMED_QUEST_SEEN) {
                        gameObj.setWeeklyQuestLastWeekMastery(gameObj.getThemedQuestMastery());
                    } else {
                        gameObj.setWeeklyQuestLastWeekMastery(masteryWQ);
                    }

                    gameObj.setIsWeeklyQuestIntroPopupEligible(true);
                    gameObj.setIsRuntimeReset(true);

                    //sets the init variables for the llp new QUEST
                    questMapObj.setProgressOnStartOfNewQuest();

                    //reset values for new quest
                    questMapObj.resetVariablesForNewQuest();

                } else {
                    gameObj.setIsWeeklyQuestLocked(true);
                }

            }
        } else {
            gameObj.setIsWeeklyQuestLocked(true);
        }
    };


    this.getWeeklyQuestData = function () {

        return weeklyQuestData;
    };

    this.getQuestState = function () {
        return gameObj.getIsWeeklyQuestLocked();
    };

    this.setWqPopupTimerLabel = function (lbl) {
        wqPopupTimerLabel = lbl;
    };
    this.setWqMapLayerTimerLabel = function(lbl){
        wqMapLayerTimerLabel = lbl;
    };

    this.setWqHomeTimerLabel = function (lbl) {
        wqHomeTimerLabel = lbl;
    };

    this.getWqPopupTimerText = function () {
        var timeRemaining = weeklyQuestEndTime - utilObj.getCurrentTimestamp();
        var days = Math.floor(timeRemaining / 86400);
        if (days > 0) {
            if (Math.floor(timeRemaining / 86400) == 1) {
                return "Hurry! Only " + Math.floor(timeRemaining / 86400) + " day left!";
            } else {
                return "Hurry! Only " + Math.floor(timeRemaining / 86400) + " days left!";
            }
        } else {

            timeRemaining = timeRemaining % 86400;
            var hours = Math.floor(timeRemaining / 3600);
            if (hours < 10) {
                hours = "0" + hours;
            }
            timeRemaining = timeRemaining % 3600;
            var minutes = Math.floor(timeRemaining / 60);
            if (minutes < 10) {
                hours = "0" + minutes;
            }
            timeRemaining = timeRemaining % 60;
            var seconds = timeRemaining;
            if (seconds < 10) {
                hours = "0" + seconds;
            }
            return "Hurry! Only " + hours + ":" + minutes + ":" + seconds + " left!";
        }
    };

    this.getWqMapLayerTimerText = function () {
        var timeRemaining = weeklyQuestEndTime - utilObj.getCurrentTimestamp();
        var days = Math.floor(timeRemaining / 86400);
        if (days > 0) {
            if (Math.floor(timeRemaining / 86400) == 1) {
                return Math.floor(timeRemaining / 86400) + " day left!";
            } else {
                return Math.floor(timeRemaining / 86400) + " days left!";
            }
        } else {

            timeRemaining = timeRemaining % 86400;
            var hours = Math.floor(timeRemaining / 3600);
            if (hours < 10) {
                hours = "0" + hours;
            }
            timeRemaining = timeRemaining % 3600;
            var minutes = Math.floor(timeRemaining / 60);
            if (minutes < 10) {
                hours = "0" + minutes;
            }
            timeRemaining = timeRemaining % 60;
            var seconds = timeRemaining;
            if (seconds < 10) {
                hours = "0" + seconds;
            }
            return hours + ":" + minutes + ":" + seconds + " left!";
        }
    };


    this.getWqHomeTimerText = function () {
        var timeRemaining = weeklyQuestEndTime - utilObj.getCurrentTimestamp();
        var days = Math.floor(timeRemaining / 86400);
        if (days > 0) {
            if (Math.floor(timeRemaining / 86400) == 1) {
                return Math.floor(timeRemaining / 86400) + " day";
            } else {
                return Math.floor(timeRemaining / 86400) + " days";
            }
        } else {

            timeRemaining = timeRemaining % 86400;
            var hours = Math.floor(timeRemaining / 3600);
            if (hours < 10) {
                hours = "0" + hours;
            }
            timeRemaining = timeRemaining % 3600;
            var minutes = Math.floor(timeRemaining / 60);
            if (minutes < 10) {
                minutes = "0" + minutes;
            }
            timeRemaining = timeRemaining % 60;
            var seconds = timeRemaining;
            if (seconds < 10) {
                seconds = "0" + seconds;
            }
            return hours + ":" + minutes + ":" + seconds;
        }
    };

    this.updateTimeRemaining = function () {

        if (gameObj.getIsWeeklyQuestLocked()) {
            return;
        }
        if(weeklyQuestEndTime == null){
            return;
        }


        var end = weeklyQuestEndTime;
        var start = utilObj.getCurrentTimestamp();
        var timeRemaining = end - start;
        if (timeRemaining <= 0) {
            var redrawHome = false;
            if (curScreen == constantsObj.SCREEN_WEEKLY_START_POPUP || curScreen == constantsObj.SCREEN_WEEKLY_INTRO_POPUP) {
                popupLayer.setDontGoToLastScreen(true);
                popupLayer.closeWithDefault();
                redrawHome = true;
            } else if (curScreen == constantsObj.SCREEN_HOME || curScreen == constantsObj.SCREEN_QUEST_MAP) {
                redrawHome = true;
            }
            gameObj.setIsWeeklyQuestLocked(true);
            if (redrawHome) {
                homeLayer.redraw();
            }
            return;
        }
        var days = Math.floor(timeRemaining / 86400);

        if (days > 0) {
            return Math.floor(timeRemaining / 86400) + " days";
        }

        timeRemaining = timeRemaining % 86400;
        var hours = Math.floor(timeRemaining / 3600);

        if (hours < 10) {
            hours = "0" + hours;
        }
        timeRemaining = timeRemaining % 3600;
        var minutes = Math.floor(timeRemaining / 60);
        if (minutes < 10) {
            minutes = "0" + minutes;
        }
        timeRemaining = timeRemaining % 60;
        var seconds = timeRemaining;
        if (seconds < 10) {
            seconds = "0" + seconds;
        }
        timerStringPopup = "Hurry! Only " + hours + ":" + minutes + ":" + seconds + " left!";
        timerStringHome = hours + ":" + minutes + ":" + seconds;
        timerStringMapLayer = hours + ":" + minutes + ":" + seconds + " left!";
        if (utilObj.isNodeValid(wqPopupTimerLabel)) {
            wqPopupTimerLabel.setString(timerStringPopup);
        }
        if (utilObj.isNodeValid(wqHomeTimerLabel)) {
            wqHomeTimerLabel.setString(timerStringHome);
        }
        if(utilObj.isNodeValid(wqMapLayerTimerLabel)){
            wqMapLayerTimerLabel.setString(timerStringMapLayer);
        }
    };

    // updating the milestones array on fb login so that animation doesn't trigger again automatically
    this.updateMileStonesCompletedArr = function () {
        var starsAchieved = gameObj.getWeeklyQuestMastery();
        var mileStones1 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(0));
        var mileStones2 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(1));
        var mileStones3 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(2));
        var milestones = [mileStones1, mileStones2, mileStones3];
        var milestonesCompleted = gameObj.getWeeklyQuestMilestonesCompleted();
        if (milestonesCompleted == null) {
            milestonesCompleted = [0, 0, 0];
            gameObj.setWeeklyQuestMilestonesCompleted(milestonesCompleted);
            gameObj.setWeeklyQuestCompleted(false);
        }

        if (starsAchieved >= milestones[0] && starsAchieved < milestones[1]) {
            if (milestonesCompleted[0] == 0) {
                milestonesCompleted[0] = 1;
                gameObj.setWeeklyQuestMilestonesCompleted(milestonesCompleted);
            }
        } else if (starsAchieved >= milestones[1] && starsAchieved < milestones[2]) {
            if (milestonesCompleted[1] == 0) {
                milestonesCompleted[1] = 1;
                gameObj.setWeeklyQuestMilestonesCompleted(milestonesCompleted);
            }
        } else if (starsAchieved >= milestones[2]) {
            if (milestonesCompleted[2] == 0) {
                milestonesCompleted[2] = 1;
                gameObj.setWeeklyQuestMilestonesCompleted(milestonesCompleted);
                gameObj.setWeeklyQuestCompleted(true);
            }
        }
    };

    this.updateCashDelayed = function (sender, params) {
        var layer = params.layer;
        var cashLabel = params.label;
        weeklyQuestObj.updateCash(layer, cashLabel);
    };

    this.updateCash = function (layer, cashLabel) {
        var zOrder = constantsObj.SPRITE_Z_ORDER;
        if(gameObj.getExpNewWeeklyQuestVariant() == constantsObj.EXP_VAR_CONTROL) {
            var starsAchieved = gameObj.getWeeklyQuestMastery();
            // loggerObj.debugLog("StarsAchieved", starsAchieved);
            var mileStones1 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(0));
            var mileStones2 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(1));
            var mileStones3 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(2));
            var milestones = [mileStones1, mileStones2, mileStones3];
            // loggerObj.debugLog("finalcheck", mileStones1, mileStones2, mileStones3);
            var coins = null;

            var milestonesCompleted = gameObj.getWeeklyQuestMilestonesCompleted();
            if (milestonesCompleted == null) {
                milestonesCompleted = [0, 0, 0];
                gameObj.setWeeklyQuestMilestonesCompleted(milestonesCompleted);
                gameObj.setWeeklyQuestCompleted(false);
            }

            if (starsAchieved >= milestones[0] && starsAchieved < milestones[1]) {
                // loggerObj.debugLog("finalcheck1");
                if (milestonesCompleted[0] == 0) {
                    milestonesCompleted[0] = 1;
                    gameObj.setWeeklyQuestMilestonesCompleted(milestonesCompleted);
                    coins = weeklyQuestObj.checkWeeklyQuestMastery(starsAchieved, milestones);
                    // loggerObj.debugLog("finalcheck1", coins);
                    var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
                    var trackC = constantsObj.TRACK_WQ_1 + "easy";
                    if ((weeklyQuestExp == constantsObj.EXP_VAR_3 || weeklyQuestExp == constantsObj.EXP_VAR_4) && gameObj.getWeeklyQuestLastWeekMastery() >= runtimeObj.getWeeklyQuestMasteryLimit()) {
                        trackC = constantsObj.TRACK_WQ_1 + "hard";
                    }
                    economyObj.addCash(coins, constantsObj.TRACK_EARN, trackC, "");
                    trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_WQ_ANIM, constantsObj.TRACK_VIEW, constantsObj.TRACK_HOME, i + 1, "", "");
                    animObj.animateGiftOpen1(0.25, 0.2, zOrder + 100, coins, starsAchieved, milestones, layer, cashLabel);
                    //animObj.removeSprites();
                    //utilObj.showMessage(coins+ " " + " coins have been rewarded");
                }
            } else if (starsAchieved >= milestones[1] && starsAchieved < milestones[2]) {
                // loggerObj.debugLog("finalcheck2");
                if (milestonesCompleted[1] == 0) {
                    milestonesCompleted[1] = 1;
                    gameObj.setWeeklyQuestMilestonesCompleted(milestonesCompleted);
                    coins = weeklyQuestObj.checkWeeklyQuestMastery(starsAchieved, milestones);
                    // loggerObj.debugLog("finalcheck2", coins);
                    var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
                    var trackC = constantsObj.TRACK_WQ_2 + "easy";
                    if ((weeklyQuestExp == constantsObj.EXP_VAR_3 || weeklyQuestExp == constantsObj.EXP_VAR_4) && gameObj.getWeeklyQuestLastWeekMastery() >= runtimeObj.getWeeklyQuestMasteryLimit()) {
                        trackC = constantsObj.TRACK_WQ_2 + "hard";
                    }
                    economyObj.addCash(coins, constantsObj.TRACK_EARN, trackC, "");
                    // loggerObj.debugLog("finalcheck22", coins);
                    trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_WQ_ANIM, constantsObj.TRACK_VIEW, constantsObj.TRACK_HOME, i + 1, "", "");
                    animObj.animateGiftOpen1(0.25, 0.2, zOrder + 100, coins, starsAchieved, milestones, layer, cashLabel);
                    //animObj.removeSprites();
                    //utilObj.showMessage(coins + " " + " coins have been rewarded");
                }
            } else if (starsAchieved >= milestones[2]) {
                // loggerObj.debugLog("finalcheck3");
                if (milestonesCompleted[2] == 0) {
                    milestonesCompleted[2] = 1;
                    gameObj.setWeeklyQuestMilestonesCompleted(milestonesCompleted);
                    gameObj.setWeeklyQuestCompleted(true);
                    coins = weeklyQuestObj.checkWeeklyQuestMastery(starsAchieved, milestones);
                    // loggerObj.debugLog("finalcheck3", coins);
                    var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
                    var trackC = constantsObj.TRACK_WQ_3 + "easy";
                    if ((weeklyQuestExp == constantsObj.EXP_VAR_3 || weeklyQuestExp == constantsObj.EXP_VAR_4) && gameObj.getWeeklyQuestLastWeekMastery() >= runtimeObj.getWeeklyQuestMasteryLimit()) {
                        trackC = constantsObj.TRACK_WQ_3 + "hard";
                    }
                    economyObj.addCash(coins, constantsObj.TRACK_EARN, trackC, "");
                    trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_WQ_ANIM, constantsObj.TRACK_VIEW, constantsObj.TRACK_HOME, i + 1, "", "");
                    // loggerObj.debugLog("finalcheck33", coins);
                    animObj.animateGiftOpen1(0.25, 0.2, zOrder + 100, coins, starsAchieved, milestones, layer, cashLabel);

                    gameObj.setIsQuestEligileToShow(false);
                    //animObj.removeSprites();
                    //utilObj.showMessage(coins + " " + " coins have been rewarded");
                }
            }
        }
    };

    this.checkAnimationToShow = function () {
        if (gameObj.getIsWeeklyQuestLocked()) {
            return false;
        }
        var zOrder = constantsObj.SPRITE_Z_ORDER;
        var starsAchieved = gameObj.getWeeklyQuestMastery();
        var mileStones1 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(0));
        var mileStones2 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(1));
        var mileStones3 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(2));
        var milestones = [mileStones1, mileStones2, mileStones3];

        var milestonesCompleted = gameObj.getWeeklyQuestMilestonesCompleted();
        if (milestonesCompleted == null) {
            milestonesCompleted = [0, 0, 0];
        }

        if (starsAchieved >= milestones[0] && starsAchieved < milestones[1]) {
            if (milestonesCompleted[0] == 0) {
                return true;
            }
        } else if (starsAchieved >= milestones[1] && starsAchieved < milestones[2]) {
            if (milestonesCompleted[1] == 0) {
                return true;
            }
        } else if (starsAchieved >= milestones[2]) {
            if (milestonesCompleted[2] == 0) {
                return true;
            }
        }
        return false;
    };


    this.getWeeklyQuestStartTime = function () {
        if (weeklyQuestStartTime != null)
            return weeklyQuestStartTime;
    };
    this.getWeeklyQuestEndTime = function () {
        if (weeklyQuestEndTime != null)
            return weeklyQuestEndTime;
    };

    this.getRewardData = function (payer, val1, val2, val3) {
        var data = {};
        if (!payer) {
            data.highProb = weeklyQuestObj.getWeeklyQuestProb(val1);
            data.mediumProb = weeklyQuestObj.getWeeklyQuestProb(val2);
            data.lowProb = weeklyQuestObj.getWeeklyQuestProb(val3);
            data.highReward = weeklyQuestObj.getWeeklyQuestReward(val1);
            data.mediumReward = weeklyQuestObj.getWeeklyQuestReward(val2);
            data.lowReward = weeklyQuestObj.getWeeklyQuestReward(val3);
        } else {
            data.highProb = weeklyQuestObj.getWeeklyQuestPayerProb(val1);
            data.mediumProb = weeklyQuestObj.getWeeklyQuestPayerProb(val2);
            data.lowProb = weeklyQuestObj.getWeeklyQuestPayerProb(val3);
            data.highReward = weeklyQuestObj.getWeeklyQuestPayerReward(val1);
            data.mediumReward = weeklyQuestObj.getWeeklyQuestPayerReward(val2);
            data.lowReward = weeklyQuestObj.getWeeklyQuestPayerReward(val3);
        }

        return data;
    };

    this.checkWeeklyQuestMastery = function (starAchieved, mileStones) {
        var returnReward = 0;
        var data = {};

        if (starAchieved >= mileStones[0] && starAchieved < mileStones[1]) {
            data = this.getRewardData(gameObj.getIsPayer(), constantsObj.FIRST_MILESTONE_HIGH, constantsObj.FIRST_MILESTONE_MEDIUM, constantsObj.FIRST_MILESTONE_LOW);
            // loggerObj.debugLog("Payer1", data.highProb, data.mediumProb, data.lowProb, data.highReward, data.mediumReward, data.lowReward);
        }
        else if (starAchieved >= mileStones[1] && starAchieved < mileStones[2]) {
            data = this.getRewardData(gameObj.getIsPayer(), constantsObj.SECOND_MILESTONE_HIGH, constantsObj.SECOND_MILESTONE_MEDIUM, constantsObj.SECOND_MILESTONE_LOW);
            // loggerObj.debugLog("Payer2", data.highProb, data.mediumProb, data.lowProb, data.highReward, data.mediumReward, data.lowReward);
        }
        else if (starAchieved >= mileStones[2]) {
            data = this.getRewardData(gameObj.getIsPayer(), constantsObj.THIRD_MILESTONE_HIGH, constantsObj.THIRD_MILESTONE_MEDIUM, constantsObj.THIRD_MILESTONE_LOW);
            // loggerObj.debugLog("Payer3", data.highProb, data.mediumProb, data.lowProb, data.highReward, data.mediumReward, data.lowReward);

        }
        var rand = Math.floor(((Math.random() * 100) + 1));
        // loggerObj.debugLog("Payer", rand);
        if (rand <= (0 + data.lowProb) && data.lowProb != 0) {
            returnReward = data.lowReward;
        } else if (rand > (0 + data.lowProb) && rand <= (data.lowProb + data.mediumProb) && data.mediumProb != 0) {
            returnReward = data.mediumReward;
        } else {
            returnReward = data.highReward;
        }
        // loggerObj.debugLog("Payer", rand, returnReward);
        return returnReward;
    };


    this.loadLocal = function (gameData) {
        if (gameData.wq_payer_reward != null && gameData.wq_payer_reward != undefined) {
            wq_payer_reward = gameData.wq_payer_reward;
        } else {
            weeklyQuestObj.assignValues();
            return;
        }
        if (gameData.wq_reward != null && gameData.wq_reward != undefined) {
            wq_reward = gameData.wq_reward;
        }
        if (gameData.wq_prob != null && gameData.wq_prob != undefined) {
            wq_prob = gameData.wq_prob;
        }
        if (gameData.wq_payer_prob != null && gameData.wq_payer_prob != undefined) {
            wq_payer_prob = gameData.wq_payer_prob;
        }
        if (gameData.wqMilestones != null && gameData.wqMilestones != undefined) {
            wqMilestones = gameData.wqMilestones;
        }
        if (gameData.wqTotalstars != null && gameData.wqTotalstars != undefined) {
            wqTotalstars = gameData.wqTotalstars;
        }
    };

    this.assignValues = function () {
        wqTotalstars = runtimeObj.getWeeklyQuestTotalstars();
        // loggerObj.debugLog("Runtimecheck4", wqTotalstars);

        for (var i = 0; i < 3; ++i) {
            wqMilestones[i] = runtimeObj.getWeeklyQuestMilestones(i);
            // loggerObj.debugLog("Runtimecheck5", wqMilestones[i]);
        }

        for (var i = 0; i < 9; ++i) {
            wq_reward[i] = runtimeObj.getWeeklyQuestReward(i);
            wq_payer_reward[i] = runtimeObj.getWeeklyQuestPayerReward(i);
            wq_prob[i] = runtimeObj.getWeeklyQuestProb(i);
            wq_payer_prob[i] = runtimeObj.getWeeklyQuestPayerProb(i);
            // loggerObj.debugLog("Runtimecheck6", wq_reward[i], wq_prob[i], wq_payer_prob[i], wq_payer_reward[i]);
        }

    };

    this.getWeeklyQuestGameData = function (gameData) {
        // loggerObj.debugLog("Runtimecheck1", gameObj.getIsRuntimeReset());
        if (gameObj.getIsRuntimeReset()) {
            weeklyQuestObj.assignValues();
            // loggerObj.debugLog("Runtimecheck2", gameObj.getIsRuntimeReset());
            gameObj.setIsRuntimeReset(false);
        }
        // loggerObj.debugLog("Runtimecheck3", gameObj.getIsRuntimeReset());
        gameData.wq_payer_reward = wq_payer_reward;
        gameData.wq_payer_prob = wq_payer_prob;
        gameData.wq_prob = wq_prob;
        gameData.wq_reward = wq_reward;
        gameData.wqMilestones = wqMilestones;
        gameData.wqTotalstars = wqTotalstars;

        return gameData;
    };

    this.getWeeklyQuestReward = function (index) {
        return wq_reward[index];
    };

    this.getWeeklyQuestPayerReward = function (index) {
        return wq_payer_reward[index];
    };

    this.getWeeklyQuestProb = function (index) {
        return wq_prob[index];
    };

    this.getWeeklyQuestPayerProb = function (index) {
        return wq_payer_prob[index];
    };

    this.getWeeklyQuestMilestones = function (index) {
        return wqMilestones[index];
    };


    this.getWeeklyQuestTotalstars = function () {

        return wqTotalstars;
    };


};