ZenMode = function () {
    var zenData = {};
    var wordList = [];
    var clueList = [];
    var mapForWordIndexUsed = {};
    var lastWord = "";
    var isAcross = true;
    var level = 0;
    var selectedPos = 0;
    var attemptAns = [];
    var letterToSelect = "";
    var positionToPick = 0;
    var letters = ['Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P', 'A', 'S', 'D', 'F', 'G', 'H', 'J', 'K', 'L', 'Z', 'X', 'C', 'V', 'B', 'N', 'M'];
    var isTileTouchedbyUser = false;
    var timeAdded = 0;

    var bufferTimer = 60;

    var wordTimer = 10;
    var bonus = 0;
    var finalCount = 10;
    var easyCount = 10;
    var mediumCount = 0;
    var hardCount = 0;
    var oldEasyCount = 10;
    var oldMediumCount = 0;
    var oldHardCount = 0;

    var surfacingDay = 2; // Currently D2 needs to be shown this.
    var isBlitzModePopupShown = false;
    var blitzFtueVisible = false;
    var blitzFtueShown = false;
    var lives = -1;
    var nextLifeAt = 0;
    var hasPlayedBlitz = false;

    var STREAK_NONE = 0;
    var STREAK_LOW = 1;
    var STREAK_MEDIUM = 2;
    var STREAK_HIGH = 3;
    var wordCountInStreak = 0;
    var curStreak = STREAK_NONE;
    var curScore = 0;
    var lastScore = 0;
    var maxScore = 0;
    var wordStartedAt = 0;
    var blitzTimerText = null;
    var blitzTimerText1 = null;
    var blitzTimerText2 = null;

    // var revealLetters = 3;
    var revealWords = 0;
    var revealWordsLimit = 1;
    var retryCount = 0;
    var REVEAL_LETTER_COST = 1;
    var REVEAL_WORD_COST = 3;
    var RETRY_LIMIT = 2;

    var REVEALED_LETTER = 1;
    var livesOnHome = [];
    var hearts_array = [];
    var homeBg = null;
    var stopTimer = false;
    var lastTimerUpdate = 0;
    var WORD_EASY = 0;
    var WORD_MEDIUM = 1;
    var WORD_HARD = 2;

    var blitzModeOn = false;
    var lastTimeTaken = 0;
    var noOfWords = 0;
    var countdownTimerRunning = false;
    var countdownStart = 3;
    var COUNT_DOWN_SECONDS = 3;
    var currentWord = null;

    var skipFilledSquares = true;
    var eraseWrongWord = true;
    var letterPos = 0;
    var oldMul = 1;
    var maxBufferTime = 60;
    var diffIncCount = 1;
    var maxTimePerWord = 10;
    var maxLives = -1;
    var livesTimerStart = 0;
    var cost = 10;
    var refillTime = 120;
    var lowStreakMul = 2;
    var mediumStreakMul = 5;
    var highStreakMul = 10;
    var soundPlayed = false;
    //var lastSoundPlayed = false;
    var startAfterPopup = false;
    var scoreAdded = 0;
    var stopTimer1 = false;
    var text = null;
    var subText = null;
    var iconBg = null;
    var circleImage = null;
    var coolDownMessage = null;
    var attemptedWrong = false;
    var totalRewardCount = 0;
    var finalMilestoneValue = 0;
    var totalSessionCount = 0;

    // variable to check if any translayer is open
    var isTransLayerOpen = false;

    // Levels for BlitzMode
    var currentLevel = 1;

    //check if streak ftue is shown...it is shown once in a user's life.
    var checkForStreakFtue = false;
    var quitScreenOpen = false;

    // bonus time added check
    var bonusTimeAdded = 0;
    var highestStreakAchieved = STREAK_NONE;
    var lastWordStartedAt = 0;

    /**
     * blitz info variables
     */
    var MAX_LEVEL = constantsObj.MAX_LEVEL;
    var blitzInfo = constantsObj.BLITZ_LEVEL_INFO;

    this.init = function () {
        zenModeObj.loadZenData();
    };

    this.isInitDone = function () {
        if (wordList.length > 0) {
            return true;
        }
        return false;
    };

    /**
     * this function will check for the current level of the user and update the level
     * @return true if level updated, else false.
     */
    this.checkAndUpdateCurrentLevel = function () {
        if (currentLevel == MAX_LEVEL + 1) {
            return false;
        }
        if (curScore >= zenModeObj.getLevelTargetPointBasedOnExp(currentLevel)) {
            currentLevel += 1;
            return true;
        }
        return false;
    };

    this.getBlitzInfo = function () {
        return blitzInfo;
    };

    this.getMaxBufferTimer = function () {
        return maxBufferTime;
    };

    this.updateTimerForZen = function () {
        zenModeObj.checkAndAddLives();
        zenModeObj.updateTimeRemaining();
        zenModeObj.updateLivesOnRetryLayer();


        if (curScreen != constantsObj.SCREEN_ZEN_MODE) {
            return;
        }


        zenModeLayer.updateCashLbl();

        // if any other layer is open
        if (isTransLayerOpen) {
            return;
        }

        if (countdownTimerRunning) {
            if (countdownStart <= 0) {
                zenModeObj.setCountDownTimer(false);
                zenModeObj.setStopTimer(false);
                lastTimerUpdate = 0;
                zenModeObj.removeSpritesFromOverlay();
                zenModeLayer.addTilesToScreen();
            }
            // if (!soundPlayed) {
            //     zenModeLayer.countDownOverlay();
            //     // utilObj.playSound(constantsObj.BLITZ_COUNTDOWN_SOUND, false);
            //     soundPlayed = true;
            // }
            zenModeLayer.updateCountDownTimer(countdownStart);
            countdownStart -= 1;
        }
        if (stopTimer || stopTimer1) {
            //loggerObj.debugLog("stopTimer12");
            zenModeLayer.updateTimerOnScreen(bufferTimer);
            zenModeLayer.updateProgressOnScreen(bufferTimer, maxBufferTime, wordTimer);
            return;
        }
        zenModeObj.computeFreeWordCondition();

        var curTimestamp = utilObj.getCurrentTimestamp();
        if (bufferTimer > 0) {
            if (lastTimerUpdate == 0) {
                lastTimerUpdate = curTimestamp;
            }
            if (lastTimeTaken == 0) {
                lastTimeTaken = curTimestamp;
            }
            var diff = curTimestamp - lastTimerUpdate;
            if (diff < 0) {
                // to handle a case if user change device timestamp.
                diff = 1;
            }
            lastTimerUpdate = curTimestamp;
            bufferTimer -= diff;

            wordTimer -= diff;
            if (wordTimer <= 0) {
                if (zenModeObj.checkValidForIdleAnim()) {
                    var params = {
                        scaleOfTile: zenModeLayer.tileScale,
                        spriteArray: zenModeLayer.tileSprites[level]
                    };
                    zenModeLayer.startIdleTileAnimation(zenModeLayer, params);
                }
            }

            if (wordTimer <= 0) {
                wordTimer = 0;
            }
            if (bufferTimer <= 0) {
                bufferTimer = 0;
            }

            zenModeLayer.updateTimerOnScreen(bufferTimer);
            zenModeLayer.updateProgressOnScreen(bufferTimer, maxBufferTime, wordTimer);
        } else {
            timeAdded = 0;
            zenModeLayer.timeForPuzzle += ( curTimestamp - lastTimeTaken);
            zenModeObj.setLastTimeTaken(curTimestamp);
            //utilObj.stopMusic();

            //If quit overlay open return from here.
            if (zenModeObj.getQuitScreenOpen()) {
                return;
            }
            if (currentLevel > 2) {

                if (retryCount < RETRY_LIMIT) {
                    retryCount++;
                    zenModeObj.setStopTimer(true);
                    utilObj.delayedCallback(zenModeLayer , zenModeLayer.blitzRetry, 1.2 , {retryCount : retryCount} ,false) ;
                } else {
                    //blitzRetryPopup.show();
                    // TODO: add reward overlay with retry popup

                    blitzRetryLayer.show();
                }
            }else{
                blitzFtueOutro.show();
            }

            return;
        }

    };

    /**
     * sets the value if any trans layer is opened on ZenMode layer to stop timer actions
     * @param val -> value to be set to the variable
     */
    this.setTransLayerOpen = function (val) {
        isTransLayerOpen = val;
        if (!val) {
            lastTimerUpdate = utilObj.getCurrentTimestamp();
        }
    };

    this.getTransLayerOpen = function () {
        return isTransLayerOpen;
    };

    this.checkValidForIdleAnim = function () {
        var wordTime = runtimeObj.getBlitzTimePerWord();
        if (zenModeLayer.lastInput == 0) {
            zenModeLayer.lastInput = utilObj.getCurrentTimestamp();
            return true;
        }
        if (zenModeLayer.lastInput + wordTime == utilObj.getCurrentTimestamp()) {
            zenModeLayer.lastInput = utilObj.getCurrentTimestamp();
            return true;
        }
        return false;
    };

    this.getTimeRemaining = function () {
        return bufferTimer;
    };

    this.loadZenData = function () {
        //loggerObj.errorLog("Exception while loading json1:");
        var zenDataUrl = "res/crosswords/blitz_mode_v1.json";
        try {
            cc.loader.loadJson(zenDataUrl, function (error, data) {
                zenData = data;
                wordList = zenData['wordList'];
                //clueList = zenData['clueList'];
            });
        } catch (e) {
            //loggerObj.errorLog("Exception while loading json:", e);
        }
    };

    this.getFirstWordInfo = function () {
        while (true) {
            var firstIndex = utilObj.getRandomIntInRange(0, wordList.length);
            mapForWordIndexUsed[firstIndex] = 1;
            lastWord = wordList[firstIndex];
            clueList = zenData[lastWord];
            var clueToUse = "";
            for (var i in clueList) {
                //loggerObj.debugLog("Clear Rate for first Word", clueList[i][1]);
                if (clueList[i][1] < 90) {
                    continue;
                }
                clueToUse = clueList[i][0];
                break;
            }
            if (clueToUse == "") {
                continue;
            }
            isAcross = true;
            currentWord = lastWord;
            //loggerObj.debugLog("zenMode 2", lastWord, firstIndex, wordList[firstIndex]);
            return {
                word: lastWord,
                isAcross: isAcross,
                letterToPick: lastWord.length - 1,
                positionOfLetter: "lastLetter",
                level: level,
                clue: clueToUse,
            };
        }

    };

    /**
     *
     * @param lastWordInfo
     * @param thirdLastWordInfo
     * @param fourthLastWordInfo
     * @param maxX
     * @param maxY
     * @param ftueWord if only ftue word is needed
     * @returns {*}
     */
    this.getNextWordInfo = function (lastWordInfo, thirdLastWordInfo, fourthLastWordInfo, maxX, maxY, ftueWord) {
        letterPos = 0;
        letterToSelect = lastWord[0];
        var index;
        var lastPositionPicked = lastWordInfo.positionOfLetter;

        if (!isAcross) {
            if (lastPositionPicked == "lastLetter") {
                if (lastWord.length > 3) {
                    var selectIndex = utilObj.getRandomIntInRange(0, 2);
                    if (selectIndex == 0) {
                        index = 0;
                        letterToSelect = lastWord[index];
                        letterPos = index;
                    } else {
                        index = 1;
                        letterToSelect = lastWord[index];
                        letterPos = index;
                    }
                } else if (lastWord.length <= 3) {
                    index = 0;
                    letterToSelect = lastWord[index];
                    letterPos = index;
                }
            } else if (lastPositionPicked == "secondLastLetter") {
                index = 0;
                letterToSelect = lastWord[index];
                letterPos = index;
            }
        } else {
            if (lastPositionPicked == "lastLetter") {
                index = utilObj.getRandomIntInRange(0, lastWord.length - 2);
                letterToSelect = lastWord[index];

                letterPos = index;
            } else if (lastPositionPicked == "secondLetter") {
                index = utilObj.getRandomIntInRange(3, lastWord.length);
                letterToSelect = lastWord[index];

                //This case is not permissible.
                if (lastWord.length <= 3) {
                    index = 0;
                    letterToSelect = lastWord[index];
                }
                letterPos = index;
            } else if (lastPositionPicked == "secondLastLetter") {
                index = utilObj.getRandomIntInRange(0, lastWord.length - 3);//by default takes 0 if no value can be assigned to it
                letterPos = index;
                letterToSelect = lastWord[index];

                //This case is not permissible.
                if (lastWord.length <= 3) {
                    index = 0;
                    letterToSelect = lastWord[index];
                    letterPos = index;
                }

            } else if (lastPositionPicked == "firstLetter") {
                index = utilObj.getRandomIntInRange(2, lastWord.length);
                letterToSelect = lastWord[index];

                letterPos = index;
            }
        }
        var veryLastWord = lastWord;

        //loggerObj.debugLog("zenMode check", index);


        if (isAcross) {
            isAcross = false;
        } else {
            isAcross = true;
        }
        var val = utilObj.getRandomIntInRange(0, 4);
        var positionsAllowed = 2;
        var possiblePositionsToPick = ["secondLastLetter", "lastLetter", "firstLetter", "secondLetter"];
        var positionToPickOrig = val;
        if (!isAcross) {
            positionToPick = "secondLastLetter";
            positionToPickOrig = 0;
        } else {
            positionToPick = possiblePositionsToPick[val];
            positionsAllowed = 4;
        }


        if (!isAcross) {
            if (lastWordInfo != null && thirdLastWordInfo != null) {
                //loggerObj.debugLog("Checking1", lastWordInfo.yPos, thirdLastWordInfo.yPos);
                var yPositionOfLast = lastWordInfo.yPos;
                var yPositionOfThirdLast = thirdLastWordInfo.yPos;
                if (Math.abs(yPositionOfLast - yPositionOfThirdLast) <= 2) {
                    positionToPick = "lastLetter";
                }
            }
            if (lastWordInfo != null && fourthLastWordInfo != null) {
                //loggerObj.debugLog("Checking2", lastWordInfo.yPos, fourthLastWordInfo.yPos);
                var yPositionOfLast = lastWordInfo.yPos;
                var yPositionOfFourthLast = fourthLastWordInfo.yPos;

                if (Math.abs(yPositionOfLast - yPositionOfFourthLast) <= 2) {
                    positionToPick = "lastLetter";
                }
            }
        }

        //loggerObj.debugLog("Check1", letterToSelect, positionToPick, lastWord);

        var positionsTried = 1;
        while (true) {
            var indexList = zenData[letterToSelect][positionToPick];
            indexList = utilObj.shuffleArray(indexList);
            var chooseNewList = false;
            for (var ix in indexList) {
                var tryNextWord = false;
                if (mapForWordIndexUsed.hasOwnProperty(indexList[ix])) {
                    continue;
                }
                mapForWordIndexUsed[indexList[ix]] = 1;
                lastWord = wordList[indexList[ix]];
                //loggerObj.debugLog("YATCHING", lastWord, lastLength);
                if (!isAcross) {
                    if (lastWord.length > 6) {
                        mapForWordIndexUsed[indexList[ix]] = 0;
                        continue;
                    }
                    if (lastWord.length == 3 && positionToPick != "lastLetter" && (lastPositionPicked == "secondLastLetter" || lastPositionPicked == "lastLetter")) {
                        mapForWordIndexUsed[indexList[ix]] = 0;
                        positionToPick = "lastLetter";
                        chooseNewList = true;
                    } else if (lastWord.length == 3 && positionToPick != "lastLetter" && (lastPositionPicked == "firstLetter" || lastPositionPicked == "secondLetter")) {
                        // index = lastLength - 1;
                        // letterToSelect = veryLastWord[index];
                        // letterPos=index;
                        mapForWordIndexUsed[indexList[ix]] = 0;
                        positionToPick = "lastLetter";
                        chooseNewList = true;
                    } else if (positionToPick == "lastLetter") {
                        var yHeightOfLastWord = lastWordInfo.yPos;
                        var yHeightOfPresentWord = yHeightOfLastWord + (lastWord.length - 1);
                        if (Math.abs(maxY - yHeightOfPresentWord) < 3) {
                            mapForWordIndexUsed[indexList[ix]] = 0;
                            continue;
                        }
                    } else if (positionToPick == "secondLastLetter") {
                        var yHeightOfLastWord = lastWordInfo.yPos;
                        var yHeightOfPresentWord = yHeightOfLastWord + (lastWord.length - 2);
                        if (Math.abs(maxY - yHeightOfPresentWord) < 3) {
                            mapForWordIndexUsed[indexList[ix]] = 0;
                            continue;
                        }
                    }
                } else {
                    if (lastWord.length == 3 && (lastPositionPicked == "secondLastLetter" || lastPositionPicked == "lastLetter")) {
                        index = 0;
                        letterPos = index;
                        letterToSelect = veryLastWord[index];
                        mapForWordIndexUsed[indexList[ix]] = 0;
                        chooseNewList = true;
                    }
                }

                if (chooseNewList) {
                    break;
                }

                level = (level + 1) % constantsObj.BLITZ_WORD_LIMIT;

                //here clue will be selected according to clear rate of the word-clue pair
                var clue;

                // for ftue super easy set words
                // ftueWord -> when ftue word is needed for the word
                if (ftueWord) {
                    var counter = 0;
                    var flagForWordCheck = false;
                    for (var crValueIndex in zenData[lastWord]) {
                        var crValue = zenData[lastWord][crValueIndex][1];
                        var wordDifficulty = constantsObj.NOT_FOUND;
                        if (crValue >= 90) {
                            flagForWordCheck = true;
                            clue = zenData[lastWord][counter][0];
                        }
                        counter++;
                    }

                    if (!flagForWordCheck) {
                        mapForWordIndexUsed[indexList[ix]] = 0;
                        level--;
                        tryNextWord = true;
                    }

                } else {
                    while (true) {
                        if (finalCount > 0) {
                            var counter = 0;
                            var flag = 0;
                            for (var crValueIndex in zenData[lastWord]) {
                                var crValue = zenData[lastWord][crValueIndex][1];
                                var wordDifficulty = constantsObj.NOT_FOUND;
                                if (crValue >= 80 && crValue < 90  && easyCount > 0) {
                                    easyCount--;
                                    wordDifficulty = WORD_EASY;
                                } else if (crValue >= 60 && crValue < 80 && mediumCount > 0) {
                                    mediumCount--;
                                    wordDifficulty = WORD_MEDIUM;
                                } else if (crValue < 60 && hardCount > 0) {
                                    hardCount--;
                                    wordDifficulty = WORD_HARD;
                                }

                                if (wordDifficulty != constantsObj.NOT_FOUND) {
                                    clue = zenData[lastWord][counter][0];
                                    flag = 1;
                                    finalCount--;
                                    zenModeLayer.updateBucketOfClue(wordDifficulty);
                                    //loggerObj.debugLog("Clear Rate", crValue, lastWord);
                                    break;
                                }
                                counter++;
                            }
                            if (flag == 0) {
                                mapForWordIndexUsed[indexList[ix]] = 0;
                                level--;
                                tryNextWord = true;
                            }
                            //loggerObj.debugLog("Clear Rate 1", lastWord, finalCount, easyCount, mediumCount, hardCount);
                        } else {
                            zenModeObj.setFinalCount();
                            easyCount = oldEasyCount - diffIncCount;
                            mediumCount = oldMediumCount;
                            hardCount = oldHardCount;
                            for (var j = 0; j < diffIncCount; ++j) {
                                var randValue = utilObj.getRandomIntInRange(0, 2);
                                if (randValue == 1) {
                                    mediumCount = mediumCount + 1;
                                } else {
                                    hardCount = hardCount + 1;
                                }
                            }
                            oldEasyCount = easyCount;
                            oldMediumCount = mediumCount;
                            oldHardCount = hardCount;
                            //loggerObj.debugLog("YATCHING3", finalCount, easyCount, mediumCount, hardCount);
                            continue;
                        }
                        break;
                    }
                }

                if (tryNextWord) {
                    continue;
                }

                //loggerObj.debugLog("medium", flag);
                //loggerObj.debugLog("zenMode 100", lastWord, letterPos, letterToSelect, positionToPick);
                currentWord = lastWord;
                return {
                    word: lastWord,
                    isAcross: isAcross,
                    letterToPick: letterPos,
                    positionOfLetter: positionToPick,
                    level: level,
                    clue: clue,
                }
            }

            if (!chooseNewList) {
                if (positionsTried < positionsAllowed) {
                    positionsTried++;
                    positionToPickOrig = (positionToPickOrig + 1) % possiblePositionsToPick.length;
                    positionToPick = possiblePositionsToPick[positionToPickOrig];
                } else {
                    break;
                }
            }
        }

        return null;
    };

    this.getPositionToPick = function () {
        return positionToPick;
    };

    this.getFixedLetterIndex = function () {
        var index = constantsObj.NOT_FOUND;
        if (zenModeLayer.firstWord) {
            return index;
        }
        if (positionToPick == constantsObj.BLITZ_FIRST_LETTER) {
            index = 0;
        } else if (positionToPick == constantsObj.BLITZ_SECOND_LETTER) {
            index = 1;
        } else if (positionToPick == constantsObj.BLITZ_SECOND_LAST_LETTER) {
            index = currentWord.length - 2;
        } else {
            index = currentWord.length - 1;
        }

        return index;
    };

    this.chooseLetter = function (i) {
        if (zenModeObj.getFixedLetterIndex() == selectedPos) {
            zenModeObj.goToNext();
            return;
        }
        zenModeObj.setAttemptedTile(letters[i]);
        zenModeLayer.lastInput = utilObj.getCurrentTimestamp();
        zenModeLayer.stopIdleTileAnimation(zenModeLayer.tileSprites[zenModeLayer.level]);
        zenModeLayer.updateAttemptLbl(letters[i], selectedPos, level);
        zenModeObj.goToNext();
        zenModeObj.checkIfWordCompleted();
    };

    this.markSelectedPosition = function () {
        attemptAns[level][selectedPos] = "";

        zenModeLayer.updateAttemptLbl('', selectedPos, level);
        utilObj.setColor(zenModeLayer.tileSprites[level][selectedPos], constantsObj.COLOR_HIGHLIGHTED_TILE);
        for (var i = 0; i < zenModeLayer.tileSprites[level].length; ++i) {
            if (i != selectedPos)
                utilObj.setColor(zenModeLayer.tileSprites[level][i], constantsObj.COLOR_WHITE);
        }
    };

    this.isLetterBlank = function (letter) {
        if (letter == undefined || letter == "") {
            return true;
        }
        return false;
    };

    this.clearLetter = function (params) {
        //loggerObj.debugLog("SelectedPosition", selectedPos);
        if (zenModeObj.getStopTimer() || zenModeLayer.isAnimRunning()) {
            return;
        }

        if (selectedPos == undefined) {
            return;
        }
        var tryCount = 0;
        var wordLength = zenModeLayer.tileSprites[zenModeLayer.level].length;
        var maxTries = wordLength;
        var blankFound = constantsObj.NOT_FOUND;
        while (tryCount <= maxTries) {
            if (attemptAns[level] != undefined) {
                var isBlank = zenModeObj.isLetterBlank(attemptAns[level][selectedPos]);
            } else {
                return;
            }
            if (isBlank && blankFound == constantsObj.NOT_FOUND && tryCount > 0) {
                blankFound = selectedPos;
            }
            if (isBlank || zenModeLayer.mapForIndexing[level][selectedPos] == REVEALED_LETTER || zenModeLayer.mapForIndexing[level][selectedPos] == constantsObj.BLITZ_LAST_LEVEL_LETTER) {
                if (selectedPos == 0 && zenModeLayer.mapForIndexing[level][selectedPos] != REVEALED_LETTER && zenModeLayer.mapForIndexing[level][selectedPos] != constantsObj.BLITZ_LAST_LEVEL_LETTER) {
                    selectedPos = 0;
                } else {
                    selectedPos = (selectedPos - 1 + wordLength) % wordLength;
                }
                tryCount++;
                continue;
            }
            break;
        }
        if (tryCount > maxTries) {
            selectedPos = blankFound;
        }
        zenModeObj.markSelectedPosition();
    };

    var backupAttemptAns = [];
    this.setAttemptedTile = function (letter, levelToUse, pos) {
        if (levelToUse == undefined) {
            levelToUse = level;
        }
        var firstTry = false;
        if (attemptAns[levelToUse] == undefined) {
            attemptAns[levelToUse] = [];
        }
        if (attemptAns[levelToUse].length == 0) {
            firstTry = true;
        }
        if (pos == undefined) {
            pos = selectedPos;
        }
        if (zenModeLayer.mapForIndexing[levelToUse][pos] != REVEALED_LETTER) {
            //loggerObj.debugLog("selectedposition2", selectedPos);
            attemptAns[levelToUse][pos] = letter;
        }

        if (firstTry) {
            if (zenModeLayer.firstWord) {
                backupAttemptAns = [];
            } else {
                backupAttemptAns = utilObj.createClone(attemptAns[levelToUse]);
            }
            //loggerObj.debugLog("Backup:", backupAttemptAns);
        }
    };

    this.checkIfWordCompleted = function () {
        var word = "";
        for (var ix in attemptAns[level]) {
            if (attemptAns[level][ix] == null) {
                return;
            }
            word = word + attemptAns[level][ix];
        }

        var readyToAddWord = false;
        if (lastWord == word) {
            readyToAddWord = true;
        }


        if (readyToAddWord) {
            var timeTakenForWord = utilObj.getCurrentTimestamp() - wordStartedAt;
            var levelScreenToAppear = zenModeObj.calAndAddScore(word.length, timeTakenForWord);
            if (!levelScreenToAppear) {
                zenModeObj.setWordStartedAt();
                utilObj.delayedCallback(zenModeLayer, zenModeLayer.addNextWord, 1.2, null, false);
            } else {
                zenModeLayer.updateScoreOnScreen(zenModeObj.getCurrentScore(), true);
            }
            zenModeObj.resetTimerForWord(false);
            zenModeLayer.animateSuccessTiles(isAcross, zenModeLayer.tileSprites[level], zenModeLayer.errorTileSprites, zenModeLayer.lblRects[level]);
            utilObj.setColor(zenModeLayer.tileSprites[level][selectedPos], constantsObj.COLOR_WHITE);
        } else {
            if (word.length == zenModeLayer.tileSprites[level].length) {
                attemptedWrong = true;
                if (eraseWrongWord) {
                    attemptAns[level] = utilObj.createClone(backupAttemptAns);
                    loggerObj.debugLog("Backup:", attemptAns[level].length, attemptAns[level]);
                    if (attemptAns[level] != null) {
                        for (var j = 0; j < zenModeLayer.tileSprites[level].length; ++j) {
                            if (zenModeLayer.mapForIndexing[level][j] == REVEALED_LETTER) {
                                attemptAns[level][j] = zenModeLayer.answerLbs[level][j];
                            }
                        }
                    }
                }
                var totalLength = zenModeLayer.tileSprites[level].length;
                for (var i = 0; i < totalLength; ++i) {
                    if (zenModeLayer.mapForIndexing[level][i] != REVEALED_LETTER && !(i == 0 && positionToPick == constantsObj.BLITZ_FIRST_LETTER) && !(i == totalLength - 1 && positionToPick == constantsObj.BLITZ_LAST_LETTER) && !(i == 1 && positionToPick == constantsObj.BLITZ_SECOND_LETTER) && !(i == totalLength - 2 && positionToPick == constantsObj.BLITZ_SECOND_LAST_LETTER)) {
                        selectedPos = i;
                        break;
                    }
                }
                for (var i = 0; i < totalLength; ++i) {
                    if (i != selectedPos) {
                        utilObj.setColor(zenModeLayer.tileSprites[level][i], constantsObj.COLOR_WHITE);
                    }
                    utilObj.setColor(zenModeLayer.tileSprites[level][selectedPos], constantsObj.COLOR_HIGHLIGHTED_TILE);
                }
                zenModeLayer.animateErrorTiles(isAcross, zenModeLayer.tileSprites[level], zenModeLayer.errorTileSprites, zenModeLayer.lblRects[level], eraseWrongWord);

                var str = "0_0_" + lastWord ;

                trackObj.trackCounter(constantsObj.TRACK_PUZZLE, zenModeObj.getBlitzPuzzleTracking(), zenModeObj.getBlitzPuzzleTheme(), constantsObj.TRACK_W_FAIL, "", str, zenModeObj.getBlitzSpeciesTracking(), "", "");
            }
        }

        //loggerObj.debugLog("zenMode word is", word);

    };

    this.goToNext = function () {
        utilObj.setColor(zenModeLayer.tileSprites[level][selectedPos], constantsObj.COLOR_WHITE);
        var index = zenModeObj.getFixedLetterIndex();
        while (true) {
            selectedPos = (selectedPos + 1) % zenModeLayer.tileSprites[level].length;
            if (zenModeLayer.mapForIndexing[level][selectedPos] != REVEALED_LETTER && index != selectedPos) {
                break;
            } else {
                if (skipFilledSquares) {
                    continue;
                } else {
                    break;
                }
            }
        }

        utilObj.setColor(zenModeLayer.tileSprites[level][selectedPos], constantsObj.COLOR_HIGHLIGHTED_TILE);
    };

    this.computeFreeWordCondition = function () {
        if(revealWordsLimit <= 0){
            return;
        }
        var wordStart = zenModeObj.getWordStartedAt();
        var curTime = utilObj.getCurrentTimestamp();
        var diff = curTime - wordStart;
        if(revealWords == 0 && diff > 0){
            if(diff >= 20){
                revealWords += 1;
                revealWordsLimit -= 1;
                zenModeLayer.updateHintsStatus();
                zenModeLayer.updateRevealWordStatus();
            }
        }
    };

    this.getCurrentWord = function () {
        return currentWord;
    };


    this.setIsTileTouchbyUser = function (val) {
        isTileTouchedbyUser = val;
    };

    this.setLevel = function (val) {
        level = val;
    };

    this.getLevel = function () {
        return level;
    };

    this.setSelectedPos = function (val) {
        selectedPos = val;
    };


    this.selectTile = function (x1, y1) {
        //loggerObj.debugLog("PossibLe tile touch2", x1, y1);
        utilObj.setColor(zenModeLayer.tileSprites[x1][y1], constantsObj.COLOR_HIGHLIGHTED_TILE);
        for (var i = 0; i < zenModeLayer.tileSprites[x1].length; ++i) {
            if (i != y1)
                utilObj.setColor(zenModeLayer.tileSprites[x1][i], constantsObj.COLOR_WHITE);
        }

        selectedPos = y1;
    };

    this.resetValues = function () {
        //loggerObj.debugLog("I came first or second 2");
        isAcross = true;
        mapForWordIndexUsed = {};
        attemptAns = [];
        // ftue cases for init time
        if (currentLevel == constantsObj.FTUE_LEVEL_1 || currentLevel == constantsObj.FTUE_LEVEL_2 || currentLevel == constantsObj.FTUE_LEVEL_3 ) {
            bufferTimer = runtimeObj.getBlitzBufferTimeFtue();
        } else {
            bufferTimer = runtimeObj.getBlitzBufferTime();
        }
        lastTimerUpdate = 0;
        retryCount = 0;
        curScore = 0;
        lastScore = 0;
        lastTimeTaken = 0;
        countdownStart = COUNT_DOWN_SECONDS;
        curStreak = STREAK_NONE;
        wordCountInStreak = 0;
        // ftue cases for init time
        if (currentLevel == constantsObj.FTUE_LEVEL_1 || currentLevel == constantsObj.FTUE_LEVEL_2 || currentLevel == constantsObj.FTUE_LEVEL_3 ) {
            maxBufferTime = runtimeObj.getBlitzBufferTimeFtue();
        } else {
            maxBufferTime = runtimeObj.getBlitzBufferTime();
        }
        diffIncCount = runtimeObj.getBlitzDiffIncrement();
        maxTimePerWord = runtimeObj.getBlitzTimePerWord();
        maxLives = runtimeObj.getMaxLivesForBlitz();
        cost = runtimeObj.getCoinsUsed();
        refillTime = runtimeObj.getLivesRefillTimeForBlitz();
        lowStreakMul = runtimeObj.getBlitzLowStreakMul();
        mediumStreakMul = runtimeObj.getBlitzMediumStreakMul();
        highStreakMul = runtimeObj.getBlitzHighStreakMul();
        zenModeLayer.animRunning = [];
        stopTimer = false;
        stopTimer1 = false;
        scoreAdded = 0;
        // revealLetters = runtimeObj.getBlitzFreeLetters();
        revealWords = 0;
        revealWordsLimit = runtimeObj.getBlitzFreeWords();
        zenModeLayer.lastInput = 0;
        zenModeLayer.level = 0;
        REVEAL_LETTER_COST = runtimeObj.getBlitzRevealLettersCost();
        REVEAL_WORD_COST = runtimeObj.getBlitzRevealWordsCost();
        quitScreenOpen = false;

        zenModeLayer.spriteArr = [];
        zenModeLayer.errorTileSprites = [];
        zenModeLayer.labelArr = [];
        zenModeLayer.tileSprites = [];
        zenModeLayer.lblRects = [];
        zenModeLayer.answerLbs = [];
        zenModeLayer.xPosition = [];
        zenModeLayer.yPosition = [];
        ZenModeLayer.tileSpritesTouch = [];
        zenModeLayer.mapForIndexing = [];
        zenModeObj.setFinalCount();
        zenModeObj.setEasyCount();
        zenModeObj.setMediumCount();
        zenModeObj.setHardCount();
        zenModeObj.setLevel(0);
        zenModeObj.setBlitzModeOn(true);
        noOfWords = 0;
        zenModeLayer.timeForPuzzle = 0;
        zenModeLayer.tileScale = 2.4;//constantsObj.SCALE_SPRITE_3 * 1.626;
        zenModeLayer.lastStreak = 0;
        bonusTimeAdded = 0;
        highestStreakAchieved = STREAK_NONE;
        soundPlayed = false;
        //zenModeObj.setLastSoundPlayed(false);
        lastWordStartedAt = utilObj.getCurrentTimestamp();
    };

    this.setAnswer = function (level, i) {
        //loggerObj.debugLog("Sorted");
        if (attemptAns[level] == undefined) {
            attemptAns[level] = [];
        }
        attemptAns[level][i] = zenModeLayer.answerLbs[level][i];
    };

    this.resetTimerForWord = function (isFirstWord) {
        //loggerObj.debugLog("Sorting Buffer time: buffer bonus wordTimer: ", bufferTimer, bonus, wordTimer);
        timeAdded = 0;
        bonus = 0;
        var wordTimerForCheck = wordTimer + 1;
        if (!isFirstWord) {
            if (zenModeLayer.tileSprites[zenModeLayer.level].length > 6) {
                wordTimerForCheck += 1;
            }
        }

        if (!isFirstWord && wordTimerForCheck > 0 && bufferTimer > 10 && currentLevel > 2) {
            bonus = wordTimer;
            if (bonus <= 0) {
                bonus = 0;
            }
            timeAdded = bonus;
            if (scoreAdded != 0 && bonus != 0) {
                 zenModeLayer.bonusAddAnimation(bonus, isAcross);
            }
        }
        wordTimer = maxTimePerWord;
        if (scoreAdded != 0) {
            bufferTimer += timeAdded;
            bonusTimeAdded += timeAdded;
        }

        var maxBuffer = maxBufferTime;
        if (bufferTimer > maxBuffer) {
            bonusTimeAdded -= (bufferTimer - maxBuffer);
            timeAdded -= (bufferTimer - maxBuffer);
            bufferTimer = maxBuffer;
        }

    };

    this.getBonusTimeAdded = function () {
        return bonusTimeAdded;
    };

    this.getTimeAdded = function(){
        return timeAdded;
    };

    this.getHighestStreakAchieved = function () {
        return highestStreakAchieved;
    };

    this.getMaxTimePerWord = function () {
        return maxTimePerWord;
    };


    this.getBonus = function () {
        return bonus;

    };

    this.setFinalCount = function () {
        finalCount = runtimeObj.getBlitzSetLength();
    };

    this.setEasyCount = function () {
        easyCount = runtimeObj.getBlitzEasyCount();
    };

    this.setMediumCount = function () {
        mediumCount = finalCount - easyCount;
    };

    this.setHardCount = function () {
        hardCount = 0;
    };

    this.getSelectedPos = function () {
        return selectedPos;
    };

    this.checkAndShowFtue = function () {
        //loggerObj.debugLog("Reached here1",utilObj.isUserDnOrMore(surfacingDay));

        if (zenModeObj.isFtueShown()) {
            //loggerObj.debugLog("Reached here2");
            return false;
        }
        if (!ftueObj.areFtuesDone()) {
            return false;
        }
        if (!utilObj.isUserDnOrMore(surfacingDay)) {
            //loggerObj.debugLog("Reached here3");
            return false;
        }

        return true;
    };

    this.loadLocal = function (gameData) {
        if (gameData.isBlitzModePopupShown != undefined) {
            isBlitzModePopupShown = gameData.isBlitzModePopupShown;
        }

        if (gameData.blitzFtueShown != undefined) {
            blitzFtueShown = gameData.blitzFtueShown;
        }

        if (gameData.lives != undefined) {
            lives = gameData.lives;
            maxLives = runtimeObj.getMaxLivesForBlitz();
            if (lives > maxLives) {
                lives = maxLives;
            }
        }

        if (gameData.livesTimerStart != undefined) {
            livesTimerStart = gameData.livesTimerStart;
        }

        if (gameData.nextLifeAt != undefined) {
            nextLifeAt = gameData.nextLifeAt;
        }

        if (gameData.hasPlayedBlitz != undefined) {
            hasPlayedBlitz = gameData.hasPlayedBlitz;
        }

        if (gameData.maxScore != undefined) {
            maxScore = gameData.maxScore;
        }

        if (gameData.currentLevel != undefined) {
            currentLevel = gameData.currentLevel;
        }

        if (gameData.totalRewardCount != undefined) {
            totalRewardCount = gameData.totalRewardCount;
        }

        if (gameData.finalMilestoneValue != undefined) {
            finalMilestoneValue = gameData.finalMilestoneValue;
        }
        if (gameData.totalSessionCount != undefined) {
            totalSessionCount = gameData.totalSessionCount;
        }
        if(gameData.checkForStreakFtue != undefined){
            checkForStreakFtue = gameData.checkForStreakFtue;
        }
        // if (gameData.revealLetters != undefined) {
        //     revealLetters = gameData.revealLetters;
        // }
        //
        // if (gameData.revealWords != undefined) {
        //     revealWords = gameData.revealWords;
        // }

        return gameData;
    };

    this.getBlitzModeGameData = function (gameData) {

        gameData.isBlitzModePopupShown = isBlitzModePopupShown;
        gameData.lives = lives;
        gameData.livesTimerStart = livesTimerStart;
        gameData.nextLifeAt = nextLifeAt;
        gameData.hasPlayedBlitz = hasPlayedBlitz;
        gameData.maxScore = maxScore;
        gameData.blitzFtueShown = blitzFtueShown;
        gameData.currentLevel = currentLevel;
        gameData.totalRewardCount = totalRewardCount;
        gameData.finalMilestoneValue = finalMilestoneValue;
        gameData.totalSessionCount = totalSessionCount;
        gameData.checkForStreakFtue = checkForStreakFtue;
        // gameData.revealLetters = revealLetters;
        // gameData.revealWords = revealWords;

        return gameData;
    };

    this.isFtueShown = function () {
        return isBlitzModePopupShown;
    };

    this.setFtueShown = function (val) {
        isBlitzModePopupShown = val;
    };

    this.isBlitzFtueVisible = function () {
        return blitzFtueVisible;
    };

    this.setBlitzFtueVisible = function (val) {
        blitzFtueVisible = val;
    };

    this.getBlitzFtueShown = function () {
        return blitzFtueShown;
    };

    this.setBlitzFtueShown = function (val) {
        blitzFtueShown = val;
    };

    this.getLivesCount = function () {
        //loggerObj.debugLog("Lives Remaining", lives);
        return lives;
    };

    this.isLifeAvailable = function () {
        return (lives > 0);
    };

    this.getHasPlayedBlitz = function () {
        return hasPlayedBlitz;
    };

    this.setHasPlayedBlitz = function (val) {
        hasPlayedBlitz = val;
    };

    this.setTotalRewardCount = function (val) {
        totalRewardCount = val;
    };

    this.getTotalRewardCount = function () {
        return totalRewardCount;
    };

    this.setFinalMilestoneValue = function (val)  {
        finalMilestoneValue = val;
    };

    this.getFinalMilestoneValue = function (){
        return finalMilestoneValue;
    };

    this.setTotalSessionCount = function (val) {
        totalSessionCount = val;
    };

    this.getTotalSessionCount = function () {
        return totalSessionCount;
    };

    this.addLife = function (c , status) {
        var livesAdded = parseInt(c);
        lives += livesAdded;

        if (lives > maxLives) {
            livesAdded -= (lives - maxLives);
            lives = maxLives;
        }
        var order = "refill";
        if(status != undefined && status != ""){
            order = status;
        }
        loggerObj.debugLog("trackingsta",order,status);

        zenModeObj.addLifeTracking(livesAdded, constantsObj.TRACK_EARN, constantsObj.TRACK_BLITZ, order);

        if (lives == maxLives) {
            zenModeObj.stopLivesTimer();
        }

        //loggerObj.debugLog("Lives3", lives);
    };

    this.useLife = function (c) {
        var livesUsed = parseInt(c);
        lives -= livesUsed;
        if (lives < 0) {
            livesUsed += lives;
            lives = 0;
        }

        zenModeObj.addLifeTracking(-livesUsed, constantsObj.TRACK_SPEND, constantsObj.TRACK_BLITZ, "");

        if (livesTimerStart == 0) {
            zenModeObj.startLivesTimer();
        }
    };

    this.addLifeTracking = function (c, phylum, trackClass, order) {
        trackObj.trackCounter(constantsObj.TRACK_LIVES, phylum, trackClass, order, lives, c, "", "", "");
    };

    this.checkAndAddLives = function () {
        refillTime = runtimeObj.getLivesRefillTimeForBlitz();
        //loggerObj.debugLog("Lives0:", livesTimerStart, nextLifeAt);

        if (livesTimerStart == 0) {
            //loggerObj.debugLog("Lives5:", maxLives, lives, maxLives > lives);
            if (maxLives > lives) {
                zenModeObj.startLivesTimer();
            } else {
                return;
            }
        }

        var curTimestamp = utilObj.getCurrentTimestamp();
        if (curTimestamp < nextLifeAt) {
            return;
        }
        var diff = curTimestamp - livesTimerStart;
        var livesToGive = Math.floor(diff / refillTime);

        //loggerObj.debugLog("Lives4", livesToGive, diff);
        livesTimerStart = livesTimerStart + (livesToGive * refillTime);
        zenModeObj.updateNextLifeAt();

        zenModeObj.addLife(livesToGive, "", "", "");
    };

    this.stopLivesTimer = function () {
        livesTimerStart = 0;
        nextLifeAt = 0;
        //loggerObj.debugLog("Lives2", livesTimerStart, nextLifeAt);
    };

    this.startLivesTimer = function () {
        livesTimerStart = utilObj.getCurrentTimestamp();
        zenModeObj.updateNextLifeAt();

        //loggerObj.debugLog("Lives1", livesTimerStart, nextLifeAt);
    };

    this.updateNextLifeAt = function () {
        nextLifeAt = livesTimerStart + refillTime;
    };

    this.timeToNextLife = function () {
        var curTimestamp = utilObj.getCurrentTimestamp();
        var time = (nextLifeAt - curTimestamp);
        if(time < 0){
            time = 0;
        }
        return time ;
    };

    this.calAndAddScore = function (wordLength, timeTakenToForm, noScore) {
            if (noScore != 1) {
                if (currentLevel > 2) {
                    var lastStreak = curStreak;
                    lastScore = curScore;
                    var timePerWord = maxTimePerWord;
                    if (attemptedWrong) {
                        wordCountInStreak = 0;
                    } else {
                        wordCountInStreak++;
                    }
                    attemptedWrong = false;
                    if (wordCountInStreak == 0) {
                        curStreak = STREAK_NONE;
                    } else if (wordCountInStreak >= 2 && wordCountInStreak < 5) {
                        curStreak = STREAK_LOW;
                    } else if (wordCountInStreak >= 5 && wordCountInStreak < 10) {
                        curStreak = STREAK_MEDIUM;
                    } else if (wordCountInStreak >= 10) {
                        curStreak = STREAK_HIGH;
                    }
                    if (curStreak > highestStreakAchieved) {
                        highestStreakAchieved = curStreak;
                    }
                    var streakMul = zenModeObj.getStreakMultiplier(curStreak);
                    curScore += streakMul * wordLength;
                    if (curScore > maxScore) {
                        maxScore = curScore;
                    }
                    if (lastStreak != curStreak && checkForStreakFtue) {
                        //zenModeLayer.checkBgColorsRequired(curStreak);
                        zenModeLayer.changeStreakEffects(curStreak);
                    }
                    zenModeObj.setScoreAdded(streakMul, wordLength);
                } else {
                    lastScore = curScore;
                    curScore += wordLength;
                    if (curScore > maxScore) {
                        maxScore = curScore;
                    }
                    zenModeObj.setScoreAdded(1, wordLength);
                }
            }else {
                zenModeObj.setScoreAdded(streakMul, wordLength, noScore);
            }


        /**
         * checks and updates current level
         * @return if level is changed it is true, else false
         */

        var levelChanged = zenModeObj.checkAndUpdateCurrentLevel();
        if (levelChanged) {
            if (utilObj.isNodeValid(zenModeLayer.levelBadge)) {
                var params = {
                    x: zenModeLayer.levelBadge.getContentSize().width / 2,
                    y: zenModeLayer.levelBadge.getContentSize().height / 2,
                    layer: zenModeLayer.levelBadge,
                    scale: 1.0,
                    zOrder: constantsObj.SPRITE_Z_ORDER - 1,
                };
                utilObj.delayedCallback(zenModeLayer, effectsObj.playStarOutroEffect, 0, params, false);
            }
            zenModeObj.setTransLayerOpen(true);
            utilObj.delayedCallback(zenModeLayer, blitzLevelHit.show, 1.5);
        }
        return levelChanged;
    };

    // returns the current level of the user
    this.getCurrentLevel = function () {
        return currentLevel;
    };

    this.setCurrentLevel = function (val) {
        currentLevel = val;
    };

    this.setMaxScore = function (val) {
        maxScore = val;
    };

    this.getCurrentStreak = function () {
        return curStreak;
    };

    this.setScoreAdded = function (streak, length, noScore) {
        scoreAdded = streak * length;
        if (noScore == 1) {
            scoreAdded = 0;
        }
    };

    this.getScoreAdded = function () {
        return scoreAdded;
    };


    this.getStreakMultiplier = function (streak) {
        var mul = 1;
        if (streak == STREAK_LOW) {
            mul = lowStreakMul;
        } else if (streak == STREAK_MEDIUM) {
            mul = mediumStreakMul;
        }
        else if (streak == STREAK_HIGH) {
            mul = highStreakMul;
        } else {
            mul = 1;
        }
         if ( mul != 1) {
            oldMul = mul;
             if(mul == lowStreakMul && !checkForStreakFtue){
                 utilObj.delayedCallback(zenModeLayer,zenModeObj.hitFirstStreak , 0.5, null, false);
             }else {
                 zenModeLayer.updateMultiplierOnScreen(mul);
             }

        }

        return mul;

    };

    this.hitFirstStreak = function(){
        zenModeObj.setTransLayerOpen(true);
        zenModeLayer.streakOverlay();
        checkForStreakFtue = true;

    };

    // this.setCheckForStreakFtue = function(){
    //     checkForStreakFtue = true;
    // };

    this.getCurrentScore = function () {
        //loggerObj.debugLog("Blitz score", curScore);
        return curScore;
    };

    this.getLastScore = function () {
        return lastScore;
    };

    this.getMaxScore = function () {
        return maxScore;
    };

    this.setWordStartedAt = function () {
        wordStartedAt = utilObj.getCurrentTimestamp();
    };

    this.setLastWordStartedAt = function(){
        lastWordStartedAt = utilObj.getCurrentTimestamp();
    };

    this.getLastWordStartedAt = function(){
        return lastWordStartedAt ;
    };


    this.getBlitzTimerText = function () {
        var timeRemaining = zenModeObj.timeToNextLife();
        var days = Math.floor(timeRemaining / 86400);
        if (days > 0) {
            if (Math.floor(timeRemaining / 86400) == 1) {
                return Math.floor(timeRemaining / 86400) + " day";
            } else {
                return Math.floor(timeRemaining / 86400) + " days";
            }
        } else {

            timeRemaining = timeRemaining % 86400;
            var hours = Math.floor(timeRemaining / 3600);
            if (hours < 10) {
                hours = "0" + hours;
            }
            timeRemaining = timeRemaining % 3600;
            var minutes = Math.floor(timeRemaining / 60);
            if (minutes < 10) {
                minutes = "0" + minutes;
            }
            timeRemaining = timeRemaining % 60;
            var seconds = timeRemaining;
            if (seconds < 10) {
                seconds = "0" + seconds;
            }
            return hours + ":" + minutes + ":" + seconds;
        }
    };

    this.setTimerText = function (val) {
        blitzTimerText = val;
    };

    this.setTimerText1 = function (val) {
        blitzTimerText1 = val;
    };

    this.setTimerText2 = function(val){
        blitzTimerText2 = val;
    };

    this.setHomeScreenParams = function (params) {
        zenModeObj.setTimerText(params.coolDownMessage);
        livesOnHome = params.lives;
        homeBg = params.bg;
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            text = params.text;
            subText = params.subText;
            iconBg = params.iconBg;
            circleImage = params.circleImage;
            coolDownMessage = params.coolDownMessage;
        }

        if (lives == constantsObj.NOT_FOUND || maxLives == constantsObj.NOT_FOUND) {
            lives = runtimeObj.getMaxLivesForBlitz();
            maxLives = lives;
        }

        zenModeObj.updateHomeScreenUi();
        zenModeObj.updateTimeRemaining();
    };

    this.setLivesOnRetryLayer = function(params){
         hearts_array = params.hearts_array;
        zenModeObj.updateLivesOnRetryLayer();
    };

    this.updateLivesOnRetryLayer = function(){
        if(hearts_array == undefined){
            return ;
        }
        for (var i = 0; i < lives; ++i) {
            if (utilObj.isNodeValid(hearts_array[i])) {
                utilObj.setColor(hearts_array[i], constantsObj.COLOR_BLITZ_RED_HEART);
                hearts_array[i].setVisible(true);
            }
        }
        for (var i = lives; i < maxLives; ++i) {
            if (utilObj.isNodeValid(hearts_array[i])) {
                utilObj.setColor(hearts_array[i], constantsObj.COLOR_GREY_10);
                hearts_array[i].setVisible(true);
            }
        }
    };

    this.setNewHomeScreenBlitzCount = function () {
        if (lives == constantsObj.NOT_FOUND || maxLives == constantsObj.NOT_FOUND) {
            lives = runtimeObj.getMaxLivesForBlitz();
            maxLives = lives;
        }
    };

    this.updateHomeScreenUi = function () {
        if (!utilObj.isNodeValid(homeBg) || (livesOnHome == undefined)) {
            return;
        }
        if(zenModeObj.getCurrentLevel() > 2) {
            if (lives > 0) {
                utilObj.setOpacity(homeBg, constantsObj.OPACITY_100);
                if (homeLayoutExpNew == constantsObj.EXP_VAR_CONTROL) {
                    for (var i = 0; i < lives; ++i) {
                        if (utilObj.isNodeValid(livesOnHome[i])) {
                            utilObj.setColor(livesOnHome[i], constantsObj.COLOR_BLITZ_RED_HEART);
                            livesOnHome[i].setVisible(true);
                        }
                    }
                    for (var i = lives; i < maxLives; ++i) {
                        if (utilObj.isNodeValid(livesOnHome[i])) {
                            utilObj.setColor(livesOnHome[i], constantsObj.COLOR_GREY_10);
                            livesOnHome[i].setVisible(true);
                        }
                    }
                } else {
                    for (var i = 0; i < maxLives - lives; ++i) {
                        if (utilObj.isNodeValid(livesOnHome[i])) {
                            utilObj.setColor(livesOnHome[i], constantsObj.COLOR_GREY_10);
                            livesOnHome[i].setVisible(true);
                        }
                    }
                    for (var i = maxLives - lives; i < maxLives; ++i) {
                        if (utilObj.isNodeValid(livesOnHome[i])) {
                            utilObj.setColor(livesOnHome[i], constantsObj.COLOR_BLITZ_RED_HEART);
                            livesOnHome[i].setVisible(true);
                        }
                    }
                    utilObj.setColor(homeBg, constantsObj.COLOR_WHITE);
                    utilObj.setOpacity(iconBg, constantsObj.OPACITY_100);
                    utilObj.setOpacity(circleImage, constantsObj.OPACITY_100);
                    utilObj.setColor(subText, constantsObj.COLOR_GREY_HOME);
                    utilObj.setColor(text, constantsObj.COLOR_BLACK);
                    utilObj.setColor(coolDownMessage, constantsObj.COLOR_ACHIEVEMENT_DESC);
                }
            } else {
                //loggerObj.debugLog("MaxLives",maxLives);

                for (var i = 0; i < maxLives; ++i) {
                    if (utilObj.isNodeValid(livesOnHome[i])) {
                        livesOnHome[i].setVisible(false);
                    }
                }
                if (homeLayoutExpNew == constantsObj.EXP_VAR_CONTROL) {
                    utilObj.setOpacity(homeBg, constantsObj.OPACITY_50);
                } else {
                    // utilObj.setOpacity(homeBg, constantsObj.OPACITY_50);
                    utilObj.setColor(homeBg, constantsObj.COLOR_GREY_TILE_HOME);
                    utilObj.setOpacity(iconBg, constantsObj.OPACITY_50);
                    utilObj.setOpacity(circleImage, constantsObj.OPACITY_50);
                    utilObj.setColor(text, constantsObj.COLOR_TILE_HOME);
                    utilObj.setColor(subText, constantsObj.COLOR_TILE_HOME);
                    utilObj.setColor(coolDownMessage, constantsObj.COLOR_TILE_TIMER);
                }


            }
        }
    };

    this.updateTimeRemaining = function () {
        zenModeObj.updateHomeScreenUi();

        var timeText = "";
        var timerText2 = "";
        var timeRemaining = zenModeObj.timeToNextLife();
        if (lives <= 0) {
            //loggerObj.debugLog("time Remaining",timeRemaining);

            if (homeLayoutExpNew == constantsObj.EXP_VAR_CONTROL) {
                timeText = "Play again in " + utilObj.formattedTime(timeRemaining);
            } else {
                timeText = "Next Life in " + "\n" + "  " + utilObj.formattedTime(timeRemaining);
            }

        }
        if(lives < maxLives){
            timerText2 = "Next Life in " + utilObj.formattedTime(timeRemaining) + "";
        }else{
            timerText2 = "Lives full!";
        }


        if (utilObj.isNodeValid(blitzTimerText)) {
            blitzTimerText.setString(timeText);
        }

        if (utilObj.isNodeValid(blitzTimerText1)) {
            blitzTimerText1.setString(timeText);
        }

        if(utilObj.isNodeValid(blitzTimerText2)){
            blitzTimerText2.setString(timerText2);
        }
    };


    // this.getRevealLettersCount = function () {
    //     return revealLetters;
    // };

    this.useRevealLetter = function () {
        // if (revealLetters > 0) {
        //     revealLetters--;
        //     return true;
        // }
        if (economyObj.getCash() < REVEAL_LETTER_COST) {
            utilObj.showMessage(stringsObj.blitz_out_of_coin_message);
            return false;
        }
        // trackObj.trackCounter(constantsObj.TRACK_CASH, constantsObj.TRACK_SPEND, constantsObj.TRACK_REVEAL_1, constantsObj.TRACK_BLITZ, economyObj.getCash(), economyObj.getCash() - REVEAL_LETTER_COST, zenModeObj.getBlitzSpeciesTracking(), "", "");
        return economyObj.makePayment(null, null, constantsObj.PKG_CASH, REVEAL_LETTER_COST, "reveal_letter", "paid");
    };

    this.useRevealWord = function () {
        if (utilObj.isAutoPlayNoAnim()) {
            return true;
        }
        var status = "";
        if (revealWords > 0) {
            status = "free";
            revealWords--;
            economyObj.makePayment(null, null, constantsObj.PKG_CASH, 0, constantsObj.TRACK_REVEAL_WORD_1, status, zenModeLayer, false);
            trackObj.trackCounter(constantsObj.TRACK_BLITZ_PUZZLE, zenModeObj.getBlitzPuzzleTracking(), zenModeObj.getBlitzPuzzleTheme(), constantsObj.TRACK_BLITZ_USE_HINT, constantsObj.TRACK_REVEAL_WORD_1, status + "_" + zenModeObj.getCurrentLevel(), "", "", "");
            return true;
        }
        status = "paid";
        if (economyObj.getCash() < REVEAL_WORD_COST) {
            utilObj.showMessage(stringsObj.blitz_out_of_coin_message);
            return false;
        }
        trackObj.trackCounter(constantsObj.TRACK_BLITZ_PUZZLE, zenModeObj.getBlitzPuzzleTracking(), zenModeObj.getBlitzPuzzleTheme(), constantsObj.TRACK_BLITZ_USE_HINT, constantsObj.TRACK_REVEAL_WORD_1, status + "_" + zenModeObj.getCurrentLevel(), "", "", "");

        return economyObj.makePayment(null, null, constantsObj.PKG_CASH, REVEAL_WORD_COST, constantsObj.TRACK_REVEAL_WORD_1, status, zenModeLayer, false);
    };


    this.getRevealWordsCount = function () {
        return revealWords;
    };

    this.getRevealLetterCost = function () {
        return REVEAL_LETTER_COST;
    };

    this.getRevealWordCost = function () {
        return REVEAL_WORD_COST;
    };

    this.getWordStartedAt = function () {
        return wordStartedAt;
    };

    this.getAdditionalTime = function () {
        var timeToBeGiven = 0;
        if(currentLevel <= 2){
            var givenTime = Math.floor(maxBufferTime / 2);
            var quo = Math.floor(givenTime / 10);
            var rem = givenTime % 10;
            var timeToBeGiven = 10 * quo;
            if (rem >= 5) {
                timeToBeGiven += 10;
            }
        }else{
            timeToBeGiven = runtimeObj.getBlitzContinueTime();
        }
        return timeToBeGiven;
    };

    this.getStopTimer = function () {
        return stopTimer;
    };

    this.setStopTimer = function (val, play) {
        // if (play || (play == undefined)) {
        //     if (val) {
        //         loggerObj.debugLog("music pause");
        //         utilObj.stopMusic();
        //     } else {
        //         loggerObj.debugLog("music resume");
        //         utilObj.playMusic(constantsObj.BLITZ_BG_SOUND, true);
        //     }
        // }
        stopTimer = val;
    };

    this.getStopTimer1 = function () {
        return stopTimer1;
    };

    this.setStopTimer1 = function (val) {
        if (!val) {
            lastTimerUpdate = utilObj.getCurrentTimestamp();
        }
        stopTimer1 = val;
    };

    this.giveUp = function () {
        if (!zenModeLayer.getContinueButtonState()) {
            return;
        }
        zenModeObj.removeSpritesFromOverlay();

        //blitzRetryPopup.show();
        // TODO: add reward overlay with retry popup
        if(currentLevel > 2){
            blitzRetryLayer.show();
        }else{
            blitzFtueOutro.show();
        }

        stopTimer = false;
        // revealWords += 1;
        // zenModeLayer.showWord(1);
        if (zenModeLayer.OverlayEffect != null) {
            utilObj.setVisible(zenModeLayer.OverlayEffect, false);
        }
    };

    this.removeSpritesFromOverlay = function () {
        utilObj.showBannerAd(utilObj.getScreenName(constantsObj.SCREEN_ZEN_MODE));
        for (var i in zenModeLayer.elementsToRemove) {
            if (utilObj.isNodeValid(zenModeLayer.elementsToRemove[i])) {
                utilObj.removeChild(zenModeLayer, zenModeLayer.elementsToRemove[i]);
            }
        }
        zenModeLayer.elementsToRemove = [];

        zenModeLayer.updateRevealLetterStatus();
        zenModeLayer.updateRevealWordStatus();
        zenModeLayer.updateCashLbl();
    };

    this.watchVideo = function () {
        if (!utilObj.isOnline()) {
            utilObj.showMessage(stringsObj.error_not_online);
            return;
        }
        if (!adsObj.checkRewardedVideoAvailable()) {
            utilObj.showMessage(stringsObj.video_not_available);
            return;
        }
        if (adsObj.checkRewardedVideo(false, adsObj.setNotRewardedVideo, false)) {
            adsObj.showVideoAd(false);
            adsObj.setNotRewardedVideo(false);
        }
    };


    this.grantAdditionalTime = function () {
        var currentLevel = zenModeObj.getCurrentLevel();
        var retryCount = zenModeObj.getRetryCount();
        trackObj.trackCounter(constantsObj.TRACK_PUZZLE, zenModeObj.getBlitzPuzzleTracking(), zenModeObj.getBlitzPuzzleTheme(), constantsObj.TRACK_VIEW, currentLevel, "timeOut" + "_" + retryCount, "", "", "");

        zenModeObj.removeSpritesFromOverlay();
        utilObj.setColor(zenModeLayer.cashLbl, constantsObj.COLOR_BLACK);
        bufferTimer += zenModeObj.getAdditionalTime();
        lastTimerUpdate = 0;

        zenModeObj.setStopTimer(false);
        revealWords += 1;
        zenModeLayer.showWord(1);
        if (zenModeLayer.OverlayEffect != null) {
            utilObj.setVisible(zenModeLayer.OverlayEffect, false);
        }
    };

    this.useCoin = function () {
        if (!zenModeLayer.getContinueButtonState()) {
            return;
        }

        var coinsToBePaid = zenModeObj.getCoinsRequired(retryCount);
        //loggerObj.debugLog("Coins To Be Paid", coinsToBePaid);
        if (economyObj.getCash() >= coinsToBePaid) {
            if (economyObj.makePayment(null, null, constantsObj.PKG_CASH, coinsToBePaid, constantsObj.TRACK_CONTINUE_BLITZ, constantsObj.TRACK_BLITZ)) {
                zenModeObj.grantAdditionalTime();
            } else {
                //loggerObj.debugLog("Some unknown error has happened.Coins are not deducted");
            }
        } else {
            zenModeObj.setBlitzModeOn(false);
            storeLayer.show();
        }

    };

    this.getCoinsRequired = function (retryCount) {
        return (retryCount * cost);
    };

    this.getCurrentBufferTime = function () {
        if (bufferTimer <= 0) {
            return 0;
        }
        return bufferTimer;
    };

    this.getRetryCount = function () {
        return retryCount;
    };

    this.setRetryCount = function(val){
        retryCount = val;
    };

    this.getAttemptAnsArray = function(){
        var emptyArray = [];
        if(attemptAns[level] != undefined){
            return attemptAns[level];
        }else {
            return emptyArray;
        }

    };

    this.getAttemptAns = function (level) {
        if (attemptAns[level] != undefined) {
            return true;
        }
        return false;
    };

    this.setAttemptAnsEmpty = function (level) {
        attemptAns[level] = [];
    };

    this.getBlitzPuzzleTracking = function () {
        return "888888888";
    };

    this.getBlitzPuzzleTheme = function () {
        return constantsObj.TRACK_BLITZ;
    };

    this.isBlitzMode = function (item) {
        return (item.headerText == stringsObj.GAMES_MODES);
    };

    this.getBlitzSpeciesTracking = function () {
        var str2 = "";
        str2 = "888888888" + "_" + noOfWords + "_" + "v18" + "_" + "0" + "_" + constantsObj.TRACK_BLITZ;
        return str2;
    };

    this.setBlitzModeOn = function (val) {
        // if (!val) {
        //     loggerObj.debugLog("music stop");
        //     utilObj.stopMusic();
        // }
        if (val == false && curLayer != constantsObj.SCREEN_STORE_LAYER) {
            zenModeObj.setTotalSessionCount(zenModeObj.getTotalSessionCount() + 1);
        }
        blitzModeOn = val;
    };

    this.isBlitzModeOn = function () {
        return blitzModeOn;
    };

    this.setLastTimeTaken = function (val) {
        lastTimeTaken = val;
    };

    this.getLastTimeTaken = function () {
        return lastTimeTaken;
    };

    this.getNoOfWords = function () {
        return noOfWords;
    };

    this.setNoOfWords = function (val) {
        noOfWords = val;
    };

    this.playStart = function () {
        if(currentLevel >= 3){
            zenModeObj.useLife(1, "", "", "");
        }
        zenModeObj.setCountDownTimer(true);
        zenModeObj.setStopTimer(true);
        if(zenModeObj.getCountDownTimer()){
            if(!zenModeObj.getSoundPlayed()){
                zenModeLayer.countDownOverlay();
                zenModeObj.setSoundPlayed(true);
            }
        }
    };

    this.setCountDownTimer = function (val) {
        countdownTimerRunning = val;
    };

    this.getCountDownTimer = function () {
        return countdownTimerRunning;
    };

    this.isZenModeAvailable = function () {
        if (utilObj.isUserDnOrMore(2) && epmObj.getChosenVariant(constantsObj.EXP_BLITZ_MODE) != constantsObj.EXP_VAR_CONTROL && ftueObj.areFtuesDone(true) && gameObj.getMastery1() >= 10) {
            return true;
        }

        return false;
    };

    this.changeScreenforBack = function () {
        zenModeObj.removeSpritesFromOverlay();
        zenModeLayer.hide();
        zenModeObj.setBlitzModeOn(false);
        homeLayer.show();
        stopTimer = false;
    };

    this.changeScreenForReplay = function () {
        zenModeObj.removeSpritesFromOverlay();
        zenModeLayer.hide();
        zenModeLayer.loadBlitzMode();
        stopTimer = false;
    };

    this.setSoundPlayed = function (val) {
        soundPlayed = val;
    };

    this.getSoundPlayed = function(){
        return soundPlayed;
    };

    // this.setLastSoundPlayed = function(val){
    //     lastSoundPlayed = val;
    // };
    // this.getLastSoundPlayed = function(){
    //     return lastSoundPlayed;
    // };
    this.setStartAfterPopup = function (val) {
        startAfterPopup = val;
    };
    this.getStartAfterPopup = function () {
        return startAfterPopup;
    };

    this.getNumberOfDigits = function () {
        var number = 0;
        var maxNumber = maxScore;
        while (maxNumber > 0) {
            number++;
            maxNumber = Math.floor(maxNumber / 10);
        }
        if (maxScore == 0) {
            number = 1;
        }
        return number;
    };

    this.getRetryLimit = function(){
        return RETRY_LIMIT;
    };

    this.getQuitScreenOpen = function(){
        return quitScreenOpen;
    };

    this.setQuitScreenOpen = function(val){
        quitScreenOpen = val;
    };

    this.getCurrentLevelScoreThreshold = function(currLevel){
        return zenModeObj.getLevelTargetPointBasedOnExp(currLevel);
    };

    this.getLevelTargetPointBasedOnExp = function (level) {
        var points = blitzInfo[level]["targetPoints1"];
        if (epmObj.getChosenVariant(constantsObj.EXP_BLITZ_MODE) == constantsObj.EXP_VAR_2) {
            points = blitzInfo[level]["targetPoints2"];
        } else if (epmObj.getChosenVariant(constantsObj.EXP_BLITZ_MODE) == constantsObj.EXP_VAR_3) {
            points = blitzInfo[level]["targetPoints3"];
        }
        return points;
    };



};