StreakPopup = function () {
    var screen = constantsObj.SCREEN_STREAK_POPUP;
    var cb = null;
    var timerLabel = null;
    var showWithAnim = true;
    var auto_trigger = false;
    var MINI_STREAK = 0;
    var BIG_STREAK = 1;

    var ONE_DONE = 1;
    var BOTH_DONE = 2;
    var NONE_DONE = 0;

    var IN_PROGRESS = 1;
    var COMPLETED = 2;
    var CLAIMED = 3;
    var NOT_STARTED = 0;

    var enableNextPuzzleBtn = false;

    this.show = function (withAnim, enableNextBtn) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        if (enableNextBtn) {
            enableNextPuzzleBtn = true;
            auto_trigger = true;
        } else {
            enableNextPuzzleBtn = false;
            auto_trigger = false;
        }
        cb = null;
        popupLayer.checkAndShow(streakPopup.delayedShow, null);
    };

    this.delayedShow = function (sender, params) {
        var labelArr = [];
        var popupHeight = 1275 + constantsObj.POPUP_START_OFFSET;
        var popupNode = new cc.Node();

        var heading = "On a Streak!";

        // streak variables
        var streakArr = homeObj.getStreakArr();
        var streakStatusArr = homeObj.getStreakStatusArr();
        var startTime = homeObj.getStreakStartDayTime();
        var endTime = homeObj.getStreakEndDayTime();

        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2 - constantsObj.POPUP_START_OFFSET;

        var zOrder = constantsObj.UI_Z_ORDER;


        // popup bg
        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH, popupHeight - constantsObj.POPUP_START_OFFSET);
        popupNode.addChild(popupBg, zOrder);

        // info button on the top right
        var infoStreak = utilObj.getSprite(constantsObj.info_streak, centerXPos + constantsObj.POPUP_WIDTH/2 - 30, yPos - 70, 1, 1, constantsObj.SCALE_SPRITE_3 * 0.85);
        infoStreak.setColor(constantsObj.COLOR_BLACK);
        infoStreak.setOpacity(constantsObj.OPACITY_30);
        popupNode.addChild(infoStreak, zOrder);


        var helpButton = utilObj.getButton(100, 100, 1, 1, centerXPos + constantsObj.POPUP_WIDTH/2 - 30,
            yPos - 70, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'streakPopup',
                fn: 'showHelpCenter',
                screen: constantsObj.SCREEN_STREAK_POPUP,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: utilObj.getScreenName(constantsObj.SCREEN_STREAK_POPUP),
                    f: "streak_help",
                    g: "",
                    s: "",
                    co: 1,
                    oppId: ""
                },
            });
        popupNode.addChild(helpButton, zOrder);

        yPos -= 130;

        // check for the id mini and themed complete cases
        var idTheme = gameObj.getIdForTodaysPuzzle();
        if (gameObj.getInstallDay() != 0 && gameObj.getInstallDay() == gameObj.getIdForTodaysPuzzle()) {
            idTheme = gameObj.getD0Id();
        }
        var idMini = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
        idMini = stringsObj.mini_prefix + idMini.substr(2, idMini.length);
        var idThemeCompleted = gameObj.getPuzzleCompleted(idTheme);
        var idMiniCompleted = gameObj.getPuzzleCompleted(idMini);

        var textBtn = "Let's Play";

        if ( ((streakStatusArr[MINI_STREAK] == CLAIMED || streakStatusArr[MINI_STREAK] == COMPLETED) && streakStatusArr[BIG_STREAK] != IN_PROGRESS) || (streakStatusArr[BIG_STREAK] == COMPLETED || streakStatusArr[BIG_STREAK] == CLAIMED)) {
            // when streak is completed

            heading = "Way to go!";
            textBtn = "Continue";
            enableNextPuzzleBtn = false;
            // header text


            var text = stringsObj.streak_complete_text_mini;
            var streakType = "streak_complete_mini";
            if (streakStatusArr[BIG_STREAK] == CLAIMED || streakStatusArr[BIG_STREAK] == COMPLETED) {
                text = stringsObj.streak_complete_text_big;
                streakType = "streak_complete_big";
            }

            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "","", streakType, constantsObj.TRACK_VIEW, "", "", "", "");

            var stringsArr = utilObj.getSplitStringsArr(text, 25);
            var lineHeight = 75;

            // loggerObj.debugLog("sstring is now for", stringsArr);
            for (var j = 0; j < stringsArr.length; j++) {
                utilObj.getBMFontLabel(stringsArr[j], constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, popupNode, zOrder + 1);
                yPos -= lineHeight;
            }

            yPos += (lineHeight * stringsArr.length);

            var scale = constantsObj.SCALE_SPRITE_9;
            var imageGiftBase = constantsObj.gift_streak_small_base;
            var imageGiftCap = constantsObj.gift_streak_small_cap;
            var rays = constantsObj.gift_rays;
            var offset = 400;
            var offsetForText = 20;
            var reward = runtimeObj.getStreakRewardSmall();

            if (streakStatusArr[BIG_STREAK] == CLAIMED || streakStatusArr[BIG_STREAK] == COMPLETED) {
                heading = "Perfection!";
                imageGiftBase = constantsObj.gift_streak_big_base;
                imageGiftCap = constantsObj.gift_streak_big_cap;
                scale *= 1.2;
                offset *= 1.2;
                yPos -= 100;
                offsetForText = 35;
                reward = runtimeObj.getStreakRewardGrand();
            }

            yPos -= 700;

            var coin = utilObj.getSprite(constantsObj.coin_one, xPos , yPos + offset, 0.5, 0, scale);
            popupNode.addChild(coin, zOrder);

            utilObj.getBMFontLabel(reward, constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 30 + offsetForText, yPos + offset + offsetForText, 0, 0, labelArr, popupNode, zOrder + 1);

            var giftIcon = utilObj.getSprite(imageGiftBase, xPos + 50, yPos, 0.5, 0, scale);
            popupNode.addChild(giftIcon, zOrder);

            var rays = utilObj.getSprite(rays, xPos + 50, yPos + (giftIcon.getContentSize().height * scale), 0.5, 0, scale);
            popupNode.addChild(rays, zOrder);

            var cap = utilObj.getSprite(imageGiftCap, xPos + 50 - (giftIcon.getContentSize().width/2 * scale), yPos + (giftIcon.getContentSize().height * scale), 0, 0, scale);
            cap.setRotation(-120);
            popupNode.addChild(cap, zOrder);

            if (streakStatusArr[BIG_STREAK] != CLAIMED || streakStatusArr[BIG_STREAK] != COMPLETED) {
                yPos -= 100;
            }

        } else {
            // when streak is in progress

            // calculating the current streak day based on the index and updating bg and color for that day
            var startIndex = new Date(startTime).getDay();
            var endIndex = new Date(endTime).getDay();
            var streakDayMap = constantsObj.streakDayMap;
            var curdayIndex = utilObj.getDaysDiff(gameObj.getTodaysPuzzleDate(), startTime);

            var txt = stringsObj.streak_popup_text;
            var giftImage = constantsObj.gift_streak_small;
            if (streakStatusArr[BIG_STREAK] == IN_PROGRESS ) {
                heading = "Grand Streak!";
                txt = stringsObj.streak_info;
                giftImage = constantsObj.gift_streak_big;
                if (streakArr[curdayIndex] == 0) {
                    textBtn = "Let's Play!";
                    enableNextPuzzleBtn = true;
                } else if (streakArr[curdayIndex] == 1) {
                    textBtn = "Let's Play!";
                    enableNextPuzzleBtn = true;
                } else if (streakArr[curdayIndex] == 2) {
                    textBtn = "Continue";
                    enableNextPuzzleBtn = false;
                }
            } else if (streakStatusArr[MINI_STREAK] == IN_PROGRESS) {
                giftImage = constantsObj.gift_streak_small;
                if (streakArr[curdayIndex] == 0) {
                    heading = "On a Streak!";
                    txt = stringsObj.streak_info4;
                    textBtn = "Let's Play!";
                    enableNextPuzzleBtn = true;
                } else if (streakArr[curdayIndex] == 1) {
                    heading = "Weekly Streak!";
                    txt = stringsObj.streak_info1;
                    textBtn = "Let's Play!";
                    enableNextPuzzleBtn = true;
                } else if (streakArr[curdayIndex] == 2) {
                    heading = "Weekly Streak!";
                    txt = stringsObj.streak_info1;
                    textBtn = "Continue";
                    enableNextPuzzleBtn = false;
                }
            }

            if (utilObj.getStringifiedJson(streakArr) == utilObj.getStringifiedJson([0, 0, 0, 0, 0, 0, 0]) && curdayIndex == 0) {
                heading = "Weekly Streak!";
                txt = stringsObj.streak_info1;
                textBtn = "Let's Play!";
                giftImage = constantsObj.gift_streak_small;
                enableNextPuzzleBtn = true;
            } else if (utilObj.getStringifiedJson(streakArr) == utilObj.getStringifiedJson([1, 0, 0, 0, 0, 0, 0]) && curdayIndex == 0) {
                heading = "Streak Started!";
                if (idMiniCompleted) {
                    txt = stringsObj.streak_info2;
                    if (auto_trigger) {
                        txt = stringsObj.streak_popup_text1;
                    }
                } else {
                    txt = stringsObj.streak_info3;
                    if (auto_trigger) {
                        txt = stringsObj.streak_popup_text;
                    }
                }
                textBtn = "Let's Play!";
                giftImage = constantsObj.gift_streak_small;
                enableNextPuzzleBtn = true;
            } else if (utilObj.getStringifiedJson(streakArr) == utilObj.getStringifiedJson([2, 0, 0, 0, 0, 0, 0]) && curdayIndex == 0) {
                heading = "Grand Streak!";
                txt = stringsObj.streak_info;
                textBtn = "Continue";
                giftImage = constantsObj.gift_streak_big;
                enableNextPuzzleBtn = false;
            }

            if (idThemeCompleted && idMiniCompleted) {
                enableNextPuzzleBtn = false;
                textBtn = "Continue";
            }


            if (auto_trigger) {
                trackObj.trackCounter(constantsObj.TRACK_DIALOG, "","", "streak_start", constantsObj.TRACK_VIEW, "", "", "", "");
            } else {
                trackObj.trackCounter(constantsObj.TRACK_DIALOG, "","", "streak_status", constantsObj.TRACK_VIEW, "", "", "", "");
            }

            var stringsArr = utilObj.getSplitStringsArr(txt, 35);
            var lineHeight = 75;

            // loggerObj.debugLog("sstring is now for", stringsArr);
            for (var j = 0; j < stringsArr.length; j++) {
                utilObj.getBMFontLabel(stringsArr[j], constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, popupNode, zOrder + 1);
                yPos -= lineHeight;
            }

            yPos += (lineHeight * stringsArr.length) - 20;

            yPos -= 125;

            // gift image scaling based on conditions
            var scale = 0.4;
            if (giftImage == constantsObj.gift_streak_big) {
                scale *= 1.2;
            }
            var giftIcon = utilObj.getSprite(giftImage, xPos, yPos, 0.5, 1, scale);
            popupNode.addChild(giftIcon, zOrder);

            yPos = yPos - giftIcon.getContentSize().height * scale;
            yPos -= 125;

            utilObj.getBMFontLabel("Your Current Streak", constantsObj.FONT_HELVETICA_MEDIUM_45, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, popupNode, zOrder + 1);

            var streakBg = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, xPos, yPos - 50, 0.5, 1, constantsObj.POPUP_WIDTH - 100, 250, null, null, zOrder, constantsObj.SPRITE_MISC);
            popupNode.addChild(streakBg, zOrder);
            streakBg.setColor(constantsObj.COLOR_GREY);
            streakBg.setOpacity(constantsObj.OPACITY_10);

            yPos -= 125;


            // total width to use for streak
            var totalWidth = constantsObj.POPUP_WIDTH - 275;
            var xPos = centerXPos - constantsObj.POPUP_WIDTH / 2 + 137.5;
            var widthPerItem = totalWidth / 6;
            var localYPos = yPos;

            var toShowTimer = false;
            if (streakArr[curdayIndex] == 2) {
                toShowTimer = true;
            }

            for (var i in streakArr) {
                loggerObj.debugLog("ui for streak is1", streakArr[i]);
                var text = streakDayMap[startIndex];
                var textStreak = utilObj.getBMFontLabel(text, constantsObj.FONT_HELVETICA_MEDIUM_60, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, localYPos, 0.5, 0.5, labelArr, popupNode, zOrder + 1);

                // selecting image for showing in the tick position
                var imagePlacement = constantsObj.tick_streak1;
                var scale = constantsObj.SCALE_SPRITE_1 * 0.7;
                if (i > curdayIndex) {
                    imagePlacement = constantsObj.dash_streak;
                    scale = constantsObj.SCALE_SPRITE_3 * 0.65;
                } else if (streakArr[i] == 2) {
                    imagePlacement = constantsObj.tick_streak2;
                    scale = constantsObj.SCALE_SPRITE_3 * 0.65;
                }

                // Bg for the current day
                if (i == curdayIndex) {
                    var bg = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, xPos, localYPos - 45, 0.5, 0.5, widthPerItem / 2 + 15, 180, null, null, zOrder, constantsObj.SPRITE_MISC);
                    popupNode.addChild(bg, zOrder);
                    bg.setColor(constantsObj.COLOR_GREY);
                    bg.setOpacity(constantsObj.OPACITY_20);
                }

                // tick sprite and cond. for color and opacity
                var spriteStreakTick = utilObj.getSprite(imagePlacement, xPos, localYPos - 80, 0.5, 0.5, scale, null, null, zOrder, constantsObj.SPRITE_MISC);
                popupNode.addChild(spriteStreakTick, zOrder);
                if (i > curdayIndex) {
                    if (toShowTimer) {
                        toShowTimer = false;
                        var time = gameObj.getPuzzleUnlockTime();
                        var str = "New Puzzle\n   " + utilObj.formatTime(time);
                        if (time < 3600) {
                            str = "New Puzzle\n      " + utilObj.formatTime(time);
                        }
                        timerLabel = utilObj.getBMFontLabel(str, constantsObj.FONT_HELVETICA_35, constantsObj.COLOR_BLACK,
                            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, localYPos - 80, 0.5, 0.5, labelArr, popupNode, zOrder + 1);
                        spriteStreakTick.setVisible(false);
                    }
                    spriteStreakTick.setColor(constantsObj.COLOR_GREY);
                    spriteStreakTick.setOpacity(constantsObj.OPACITY_30);
                    textStreak.setOpacity(constantsObj.OPACITY_30);
                } else if (streakArr[i] == 2) {
                    spriteStreakTick.setColor(constantsObj.COLOR_PURPLE_03);
                } else if (streakArr[i] == 1) {
                    spriteStreakTick.setColor(constantsObj.COLOR_BLUE_HS_NEW);
                } else {
                    spriteStreakTick.setColor(constantsObj.COLOR_GREY);
                    spriteStreakTick.setOpacity(constantsObj.OPACITY_30);
                }
                // lateral movement in the ui
                xPos += widthPerItem;

                // updating index for the string for the day
                startIndex++;
                if (startIndex > 6) {
                    startIndex = 0;
                }
            }

            yPos -= 225;
        }

        // got it button
        // dismiss popup on click

        var buttonW = 450;
        var fnBtn = "goBackToHome";
        if (enableNextPuzzleBtn) {
            fnBtn = "nextPuzzle";
            buttonW = 700;
        }

        var quitButton = utilObj.getButton(buttonW, 170, 0.5, 1, centerXPos,
            yPos, constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'streakPopup',
                fn: fnBtn,
                screen: constantsObj.SCREEN_STREAK_POPUP,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: utilObj.getScreenName(constantsObj.SCREEN_STREAK_POPUP),
                    f: "streak",
                    g: "",
                    s: "",
                    co: 1,
                    oppId: ""
                },
            });
        quitButton.setColor(constantsObj.COLOR_BLUE_08);
        popupNode.addChild(quitButton, zOrder);

        // got it text
        utilObj.getBMFontLabel(textBtn, constantsObj.FONT_HELVETICA_MEDIUM_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, yPos - 85, 0.5, 0.5, labelArr, popupNode, zOrder);
        var dontGoToLastScreen = false;
        var closeBtn = true;
        if (enableNextPuzzleBtn) {
            dontGoToLastScreen = true;
            // closeBtn = false;
        }

        popupLayer.popupSetup(screen, false, streakPopup.close, null, showWithAnim, {noAnim: false, dontGoToLastScreen: false});
        popupLayer.show(popupHeight, screen, heading, popupNode, labelArr, closeBtn);
    };

    this.showHelpCenter = function () {
        // popupLayer.setDontGoToLastScreen(true);
        // popupLayer.setPopupCallback(streakPopup.showPrivacy, {pLayer : constantsObj.SCREEN_HOME});
        // popupLayer.closeWithDefault();
        streakPopup.showPrivacy();
    };

    this.showPrivacy = function () {
        utilObj.contactUsSuggestion("What is the Weekly Streak?");
        /*supportLayer.init();
        if (params.pLayer == constantsObj.SCREEN_HOME) {
            homeLayer.hide();
        } else if (params.pLayer == constantsObj.SCREEN_GAME) {
            gameLayer.removeAllChildren();
            gameLayer.setVisible(false);
        } else if (params.pLayer == constantsObj.SCREEN_CALENDAR) {
            calendarLayer.hide();
        } else if (params.pLayer == constantsObj.SCREEN_PACK_INFO_LAYER) {
            packInfoLayer.hide();
        } else if (params.pLayer == constantsObj.SCREEN_ACHIEVEMENTS) {
            achievementsLayer.hide();
        } else if (params.pLayer == constantsObj.SCREEN_PACK_LAYER) {
            packsLayer.hide();
        }
        supportLayer.show("features:what_is_weekly_streak?", params);*/
    };

    this.updateTimerLabel = function (time) {
        if(utilObj.isNodeValid(timerLabel)) {
            var str = "New Puzzle\n   " + utilObj.formatTime(time);
            if (time < 3600) {
                str = "New Puzzle\n      " + utilObj.formatTime(time);
            }
            timerLabel.setString(str);
            if (time < 1) {
                popupLayer.closeWithDefault();
            }
        }
    };

    this.nextPuzzle = function () {
        popupLayer.setDontGoToLastScreen(true);
        cb = streakPopup.showPuzzle;
        popupLayer.closeWithDefault();
    };

    this.showPuzzle = function () {
        var idTheme = gameObj.getIdForTodaysPuzzle();
        if (gameObj.getInstallDay() != 0 && gameObj.getInstallDay() == gameObj.getIdForTodaysPuzzle()) {
            idTheme = gameObj.getD0Id();
        }
        var idMini = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
        idMini = stringsObj.mini_prefix + idMini.substr(2, idMini.length);
        var idThemeCompleted = gameObj.getPuzzleCompleted(idTheme);
        var idMiniCompleted = gameObj.getPuzzleCompleted(idMini);

        if (idThemeCompleted && idMiniCompleted) {
            // do nothing
        } else if (idThemeCompleted) {
            homeLayer.hide();
            gameLayer.show(idMini);
        } else {
            homeLayer.hide();
            gameLayer.show(idTheme);
        }
        var streakStr = "streak_status";
        if (auto_trigger) {
            streakStr = "streak_start";
        }
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "","", streakStr, "next_puzzle", "", "", "", "");
        questMapObj.setQuestMapAutoOn(false);
    };

    this.goBackToHome = function () {
        var streakStatusArr = homeObj.getStreakStatusArr();
        var streakStr = "streak_status";
        if (streakStatusArr[MINI_STREAK] == CLAIMED && (streakStatusArr[BIG_STREAK] == NOT_STARTED || streakStatusArr[BIG_STREAK] == CLAIMED)) {
            streakStr = "streak_complete";
        }
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "","", streakStr, "okay", "", "", "", "");
        popupLayer.closeWithDefault();
    };

    this.close = function () {
        var streakStatusArr = homeObj.getStreakStatusArr();
        var streakStr = "streak_status";
        if (auto_trigger) {
            streakStr = "streak_start";
        } else if (streakStatusArr[MINI_STREAK] == CLAIMED && (streakStatusArr[BIG_STREAK] == NOT_STARTED || streakStatusArr[BIG_STREAK] == CLAIMED)) {
            streakStr = "streak_complete";
        }
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "","", streakStr, "close", "", "", "", "");
        streakPopup.checkAndCallHomeToQuestMapTransitionWithDelay();
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    /**
     * calls homeToQuestMapTransition animation with a bit of delay
     */
    this.checkAndCallHomeToQuestMapTransitionWithDelay = function () {
        if (!questMapTransLayer.shouldShowHomeToQuestMapTransition()) {
            return;
        }
        var delay = 0.25;
        utilObj.delayedCallback(homeLayer, homeLayer.transitionToQuestMapLayer, delay, null, false);
    };
};