ArchivesCalendarPopup = function () {
    var popupNode = null;
    var showWithAnim = true;
    var cb = null;
    var screen = constantsObj.SCREEN_ARCHIVE_CALENDARS;
    var ftue_Arrow_Color = constantsObj.COLOR_FTUE_ARROW;


    this.show = function (withAnim) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        popupLayer.checkAndShow(archivesCalendarPopup.delayedShow, null);
    };

    this.delayedShow = function () {
        var labelArr = [];
        var popupHeight = 700 + constantsObj.POPUP_START_OFFSET;
        var spriteArr = [];
        var layoutExperimentVariant = epmObj.getChosenVariant(constantsObj.EXP_LAYOUT);
        popupNode = new cc.Node();

        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2 - constantsObj.POPUP_START_OFFSET;
        var zOrder = constantsObj.UI_Z_ORDER;

        var text = stringsObj.calendar_ftue_text;
        //var ok = stringsObj.ok;
        var yyPos = constantsObj.DESIGN_HEIGHT - 380;
        var starColor = constantsObj.COLOR_WHITE;
        //var ftue_Arrow_Color = constantsObj.COLOR_FTUE_ARROW;

        var d = new Date(calendarLayer.selectedDate.getTime());
        d.setMonth(d.getMonth() + calendarLayer.monthDiff);
        // loggerObj.debugLog("date ", d);
        var monthName = utilObj.getMonth(d.getMonth());

        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_FTUE_0, constantsObj.TRACK_VIEW, constantsObj.TRACK_CALENDAR, gameObj.getPuzzleSpeciesTracking(), 1, "");

        if (layoutExperimentVariant == constantsObj.EXP_VAR_CONTROL) {
            var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH, popupHeight - constantsObj.POPUP_START_OFFSET, null, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
            //popupNode.addChild(popupBg);
            utilObj.addChild(popupNode, popupBg);

            var header = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yyPos, 0.5, 1, canvasWidth, 140, spriteArr, calendarLayer, zOrder, constantsObj.SPRITE_MISC);
            header.setColor(constantsObj.COLOR_LIGHT_RED);
            utilObj.getTTFFontLabel(monthName + " " + d.getFullYear(), constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_WHITE, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yyPos - 35, 0.5, 1.0, labelArr, popupNode, zOrder);
            //popupNode.addChild(header);
            utilObj.addChild(popupNode, header);

            var directionArrow1 = utilObj.getSprite(constantsObj.arrow_02, xLeftPos + 120, yyPos - 70, 0.5, 0.5, constantsObj.SCALE_SPRITE_19, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            directionArrow1.setColor(starColor);
            //popupNode.addChild(directionArrow1, zOrder + 1);
            utilObj.addChild(popupNode, directionArrow1, zOrder + 1);
            var directionArrow2 = utilObj.getSprite(constantsObj.arrow_02, xRightPos - 120, yyPos - 70, 0.5, 0.5, constantsObj.SCALE_SPRITE_19, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            utilObj.flipSpriteX(calendarLayer, directionArrow2);
            directionArrow2.setColor(starColor);
            //popupNode.addChild(directionArrow2, zOrder + 1);
            utilObj.addChild(popupNode, directionArrow2, zOrder + 1);

            var arrow1 = utilObj.getSprite(constantsObj.ftue_arrow, xRightPos - 360, yyPos - 180, 0.5, 0.5, constantsObj.SCALE_SPRITE_21, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            arrow1.setColor(ftue_Arrow_Color);
            arrow1.setRotation(-90);
            //popupNode.addChild(arrow1, zOrder + 1);
            utilObj.addChild(popupNode, arrow1, zOrder + 1);
            var arrow2 = utilObj.getSprite(constantsObj.ftue_arrow, xLeftPos + 360, yyPos - 180, 0.5, 0.5, constantsObj.SCALE_SPRITE_21, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            arrow2.setColor(ftue_Arrow_Color);
            utilObj.flipSpriteX(calendarLayer, arrow2);
            arrow2.setRotation(+90);
            //popupNode.addChild(arrow2, zOrder + 1);
            utilObj.addChild(popupNode, arrow2, zOrder + 1);

            yPos -= 80;
            utilObj.getTTFFontLabel(stringsObj.achives_Calendar_text, constantsObj.FONT_ROBOTO_MEDIUM_100, constantsObj.COLOR_BLACK, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);

            yPos -= 150;
            var stringsArr = utilObj.getSplitStringsArr(text, 30);
            for (var i = 0; i < stringsArr.length; i++) {
                utilObj.getTTFFontLabel(stringsArr[i], constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);
                yPos -= 80;
            }

            yPos -= 80;
            var continueButton = utilObj.getButton(470, 170, 0.5, 1.0, xPos, yPos,
                constantsObj.tile_white, constantsObj.tile_white, constantsObj.tile_white, {
                    obj: 'archivesCalendarPopup',
                    fn: 'continue',
                    screen: screen,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: gameObj.getTrackingPuzzleTheme(),
                        o: constantsObj.TRACK_FTUE_0,
                        f: constantsObj.TRACK_CONTINUE,
                        g: constantsObj.TRACK_CALENDAR,
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            continueButton.setColor(constantsObj.COLOR_SKY_BLUE_01);
            //popupNode.addChild(continueButton, zOrder);
            utilObj.addChild(popupNode, continueButton, zOrder);
            utilObj.getTTFFontLabel(stringsObj.continue, constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - 35, 0.5, 1, labelArr, popupNode, zOrder);
        } else {
            var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos - 500, 0.5, 1, constantsObj.POPUP_WIDTH, popupHeight - constantsObj.POPUP_START_OFFSET, null, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
            //popupNode.addChild(popupBg);
            utilObj.addChild(popupNode, popupBg);

            var header = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yyPos - 500, 0.5, 1, canvasWidth, 140, spriteArr, calendarLayer, zOrder, constantsObj.SPRITE_MISC);
            header.setColor(constantsObj.COLOR_DARK_BLUE_01);
            utilObj.getTTFFontLabel(monthName + " " + d.getFullYear(), constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_WHITE, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yyPos - 35 - 500, 0.5, 1.0, labelArr, popupNode, zOrder);
            //popupNode.addChild(header);
            utilObj.addChild(popupNode, header);

            var directionArrow1 = utilObj.getSprite(constantsObj.arrow_02, xLeftPos + 120, yyPos - 70 - 500, 0.5, 0.5, constantsObj.SCALE_SPRITE_19, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            directionArrow1.setColor(starColor);
            //popupNode.addChild(directionArrow1, zOrder + 1);
            utilObj.addChild(popupNode, directionArrow1, zOrder + 1);
            var directionArrow2 = utilObj.getSprite(constantsObj.arrow_02, xRightPos - 120, yyPos - 70 - 500, 0.5, 0.5, constantsObj.SCALE_SPRITE_19, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            utilObj.flipSpriteX(calendarLayer, directionArrow2);
            directionArrow2.setColor(starColor);
            //popupNode.addChild(directionArrow2, zOrder + 1);
            utilObj.addChild(popupNode, directionArrow2, zOrder + 1);

            var arrow1 = utilObj.getSprite(constantsObj.ftue_arrow, xRightPos - 360, yyPos - 180 - 500, 0.5, 0.5, constantsObj.SCALE_SPRITE_21, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            arrow1.setColor(ftue_Arrow_Color);
            arrow1.setRotation(-90);
            //popupNode.addChild(arrow1, zOrder + 1);
            utilObj.addChild(popupNode, arrow1, zOrder + 1);
            var arrow2 = utilObj.getSprite(constantsObj.ftue_arrow, xLeftPos + 360, yyPos - 180 - 500, 0.5, 0.5, constantsObj.SCALE_SPRITE_21, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            arrow2.setColor(ftue_Arrow_Color);
            utilObj.flipSpriteX(calendarLayer, arrow2);
            arrow2.setRotation(+90);
            //popupNode.addChild(arrow2, zOrder + 1);
            utilObj.addChild(popupNode, arrow2, zOrder + 1);

            yPos -= 80;
            utilObj.getTTFFontLabel(stringsObj.achives_Calendar_text, constantsObj.FONT_ROBOTO_MEDIUM_100, constantsObj.COLOR_BLACK, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - 500, 0.5, 1, labelArr, popupNode, zOrder);

            yPos -= 150;
            var stringsArr = utilObj.getSplitStringsArr(text, 30);
            for (var i = 0; i < stringsArr.length; i++) {
                utilObj.getTTFFontLabel(stringsArr[i], constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - 500, 0.5, 1, labelArr, popupNode, zOrder);
                yPos -= 80;
            }

            yPos -= 80;
            var continueButton = utilObj.getButton(470, 170, 0.5, 1.0, xPos, yPos - 500,
                constantsObj.tile_white, constantsObj.tile_white, constantsObj.tile_white, {
                    obj: 'archivesCalendarPopup',
                    fn: 'continue',
                    screen: screen,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: gameObj.getTrackingPuzzleTheme(),
                        o: constantsObj.TRACK_FTUE_0,
                        f: constantsObj.TRACK_CONTINUE,
                        g: constantsObj.TRACK_CALENDAR,
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            continueButton.setColor(constantsObj.COLOR_SKY_BLUE_01);
            //popupNode.addChild(continueButton, zOrder);
            utilObj.addChild(popupNode, continueButton, zOrder);
            utilObj.getTTFFontLabel(stringsObj.continue, constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - 35 - 500, 0.5, 1, labelArr, popupNode, zOrder);

        }
        popupLayer.popupSetup(screen, false, archivesCalendarPopup.close, null, showWithAnim, {
            noAnim: true,
            dontGoToLastScreen: false
        });
        popupLayer.show(popupHeight, screen, header, popupNode, labelArr, false, null, "", "", false, false, true);
    };

    this.close = function () {
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.continue = function () {
        ftueObj.setCalendarFtueShown(true);
        popupLayer.closeWithDefault();
        archivesCalendarPopup.close();
    };
};