BlitzFirstIntroPopup = function () {

    var showWithAnim = true;
    var popupNode = null;
    var cb = null;
    var screen = constantsObj.SCREEN_BLITZ_FIRST_INTRO;
    var screenName;

    this.show = function (withAnim) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }

        this.delayedShow();

    };

    this.delayedShow = function () {
        screenName = utilObj.getScreenName(screen);
        zenModeObj.setSoundPlayed(false);

        var popupHeight = 1120 + constantsObj.POPUP_START_OFFSET;
        var labelArr = [];
        var spriteArr = [];

        popupNode = new cc.Node();
        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2 - constantsObj.POPUP_START_OFFSET;
        var zOrder = constantsObj.UI_Z_ORDER;
        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH, popupHeight - constantsObj.POPUP_START_OFFSET, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        utilObj.setColor(popupBg,constantsObj.COLOR_BLITZ_POPUPBG);

        yPos -= 60;

        utilObj.getBMFontLabel("Say hello to Blitz!", constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);

        yPos -= 160;


        var blitzIcon = utilObj.getSprite(constantsObj.blitz_mode_icon, xPos, yPos, 0.5, 1, constantsObj.SCALE_SPRITE_39, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);

        yPos -= 460;

        utilObj.getBMFontLabel("A fun new mode where you solve as\nmany words as you can in the given time!", constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos , 0.5, 1, labelArr, popupNode, zOrder);


        var popupOffset = 200;
        var puzzleTracking = zenModeObj.getBlitzPuzzleTracking();
        var puzzleTheme = zenModeObj.getBlitzPuzzleTheme();
        yPos -= 230;

        var playButton = utilObj.getButton(490, 160, 0.5, 1.0, xPos , yPos ,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'blitzFirstIntroPopup',
                fn: 'play',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: puzzleTracking,
                    c: puzzleTheme,
                    o: screenName,
                    f: constantsObj.TRACK_BLITZ_BACK,
                    g: "",
                    s: "",
                    co: "",
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.setColor(playButton,constantsObj.COLOR_BLITZ_POPUP_BUTTON);
        utilObj.pulseButton(playButton, constantsObj.PULSE_ACTION_TAG, 0);
        utilObj.addChild(popupNode, playButton, zOrder);

        var playText = "Play Blitz!";

        var playButtonTxt = utilObj.getBMFontLabel(playText, constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos - 80, 0.5, 0.5, labelArr, popupNode, zOrder);
        utilObj.pulseButton(playButtonTxt, constantsObj.PULSE_ACTION_TAG, 0);

        utilObj.addSprites(spriteArr);

        popupLayer.popupSetup(screen, false, blitzFirstIntroPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });


        popupLayer.show(popupHeight, screen, "New Game Mode!", popupNode, labelArr, true, null, null, null, null, null, null, null, constantsObj.COLOR_BLITZ_POPUP_OFFSET, constantsObj.COLOR_BLACK, constantsObj.themed_quest_popup_header);

    };

    this.close = function () {
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };


    this.play = function () {
        popupLayer.setDontGoToLastScreen(false);
        popupLayer.setPopupCallback(zenModeLayer.loadBlitzMode, null);
        popupLayer.closeWithDefault();
    };

};

