BlitzIntroPopup = function () {


    var showWithAnim = true;
    var popupNode = null;
    var cb = null;
    var screen = constantsObj.SCREEN_BLITZ_INTRO;
    var screenName;

    this.show = function (withAnim) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }

        this.delayedShow();

    };

    this.delayedShow = function () {
        screenName = utilObj.getScreenName(screen);
        zenModeObj.setSoundPlayed(false);

        var popupHeight = 1050 + constantsObj.POPUP_START_OFFSET;
        var labelArr = [];
        var spriteArr = [];

        popupNode = new cc.Node();
        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2 - constantsObj.POPUP_START_OFFSET;
        var zOrder = constantsObj.UI_Z_ORDER;
        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH, popupHeight - constantsObj.POPUP_START_OFFSET, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);

        utilObj.getBMFontLabel(stringsObj.blitz_solve_as_many1, constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos - 120, 0.5, 0.5, labelArr, popupNode, zOrder);


        var bg = utilObj.getSprite(constantsObj.dialog_bg, xPos, yPos - 200, 0.5, 1, 1.9, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
        utilObj.addChild(popupNode, bg, zOrder);

        var blitzIcon = utilObj.getSprite(constantsObj.blitz_mode_icon, xPos, yPos - 240, 0.5, 1, constantsObj.SCALE_SPRITE_46, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);

        utilObj.getBMFontLabel(stringsObj.blitz_initial_popup_message, constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos - 700, 0.5, 0.5, labelArr, popupNode, zOrder);


        var popupOffset = 200;
        var puzzleTracking = zenModeObj.getBlitzPuzzleTracking();
        var puzzleTheme = zenModeObj.getBlitzPuzzleTheme();
        var backButton = utilObj.getButton(400, 150, 0.5, 1.0, xPos - 250, yPos - 1050 + popupOffset,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'blitzIntroPopup',
                fn: 'back',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: puzzleTracking,
                    c: puzzleTheme,
                    o: screenName,
                    f: constantsObj.TRACK_BLITZ_BACK,
                    g: "",
                    s: "",
                    co: "",
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.setColor(backButton,constantsObj.COLOR_BUTTON_LIGHT_BLUE);
        utilObj.addChild(popupNode, backButton, zOrder);

        var backText = "Back";

        var backButtonTxt = utilObj.getBMFontLabel(backText, constantsObj.FONT_ROBOTO_BOLD_70, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos - 260, yPos - 1075 + popupOffset, 0.5, 1, labelArr, popupNode, zOrder);

        var playButton = utilObj.getButton(400, 150, 0.5, 1.0, xPos + 250, yPos - 1050 + popupOffset,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'blitzIntroPopup',
                fn: 'play',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: puzzleTracking,
                    c: puzzleTheme,
                    o: screenName,
                    f: constantsObj.TRACK_BLITZ_PLAY,
                    g: "",
                    s: "",
                    co: "",
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.setColor( playButton,constantsObj.COLOR_BUTTON_ORANGE);
        utilObj.addChild(popupNode, playButton, zOrder);
        utilObj.pulseButton(playButton, constantsObj.PULSE_ACTION_TAG, 0);
        var playText = "Play";

        var playButtonTxt = utilObj.getBMFontLabel(playText, constantsObj.FONT_ROBOTO_BOLD_70, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos + 260, yPos - 1075 + popupOffset, 0.5, 1, labelArr, popupNode, zOrder);
        utilObj.pulseButton(playButtonTxt, constantsObj.PULSE_ACTION_TAG, 0);


        utilObj.addSprites(spriteArr);

        popupLayer.popupSetup(screen, false, blitzIntroPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });


        popupLayer.show(popupHeight, screen, "Blitz Mode!", popupNode, labelArr, false, null, null, null, null, null, null, null, constantsObj.COLOR_YELLOW_01, constantsObj.COLOR_BLACK, constantsObj.themed_quest_popup_header);

    };

    this.close = function () {
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.back = function () {
        popupLayer.setDontGoToLastScreen(true);
        popupLayer.setPopupCallback(blitzIntroPopup.changeScreenforBack, null);
        popupLayer.closeWithDefault();
    };

    this.play = function () {
        popupLayer.setDontGoToLastScreen(false);
        popupLayer.setPopupCallback(blitzIntroPopup.playStart, null);
        popupLayer.closeWithDefault();
    };

    this.changeScreenforBack = function () {
        zenModeLayer.hide();
        zenModeObj.setStopTimer(false,false);
        homeLayer.show();
    };

    this.playStart = function () {
        zenModeObj.playStart(screenName);
    };
};
