BlitzLivesFinishedPopup = function () {


    var showWithAnim = true;
    var popupNode = null;
    var cb = null;
    var screen = constantsObj.SCREEN_BLITZ_LIVES_FINISHED;
    var screenName;


    this.show = function (withAnim) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }

        this.delayedShow();

    };
    this.delayedShow = function () {
        screenName = utilObj.getScreenName(screen);

        var str = zenModeObj.getCurrentScore() + "_" + zenModeObj.getLivesCount();
        trackObj.trackCounter(constantsObj.TRACK_PUZZLE, zenModeObj.getBlitzPuzzleTracking(), zenModeObj.getBlitzPuzzleTheme(), constantsObj.TRACK_CLEAR, zenModeLayer.timeForPuzzle, str, zenModeObj.getBlitzSpeciesTracking(), "", "");

        var popupHeight = 1050 + constantsObj.POPUP_START_OFFSET;
        var labelArr = [];
        var spriteArr = [];

        popupNode = new cc.Node();
        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2 - constantsObj.POPUP_START_OFFSET;
        var zOrder = constantsObj.UI_Z_ORDER;
        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH, popupHeight - constantsObj.POPUP_START_OFFSET, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);

        var timer = utilObj.getBMFontLabel("Play again in " + zenModeObj.getBlitzTimerText(), constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos - 120, 0.5, 0.5, labelArr, popupNode, zOrder);
        zenModeObj.setTimerText1(timer);


        var bg = utilObj.getSprite(constantsObj.dialog_bg, xPos, yPos - 200, 0.5, 1, 1.9, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
        utilObj.addChild(popupNode, bg, zOrder);

        utilObj.getSprite(constantsObj.blitz_mode_icon, xPos, yPos - 240, 0.5, 1, constantsObj.SCALE_SPRITE_46, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);

        var scoreLbl = "Your Score:";


        if (zenModeObj.getMaxScore() > 0) {
            var bestScore = utilObj.getSprite(constantsObj.blitz_best_score, xPos, yPos - 530, 0.5, 1, constantsObj.SCALE_SPRITE_3, spriteArr, popupNode, zOrder + 1, constantsObj.SPRITE_MISC);
            utilObj.setColor(bestScore,constantsObj.COLOR_BLITZ_BEST_SCORE);
            scoreLbl = stringsObj.blitz_best_score1;
        }


        utilObj.getBMFontLabel(scoreLbl, constantsObj.FONT_SFCOMPACT_MEDIUM_50, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos - 530, 0.5, 1, labelArr, popupNode, zOrder + 1);

        var scoreBg = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos - 700, 0.5, 0.5, 380, 150, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setOpacity(scoreBg,constantsObj.OPACITY_20);

        utilObj.getBMFontLabel(zenModeObj.getMaxScore() + "", constantsObj.FONT_SFCOMPACT_REGULAR_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), 190, 75, 0.5, 0.5, labelArr, scoreBg, zOrder);


        var popupOffset = 200;
        var puzzleTracking = zenModeObj.getBlitzPuzzleTracking();
        var puzzleTheme = zenModeObj.getBlitzPuzzleTheme();
        var backButton = utilObj.getButton(400, 150, 0.5, 1.0, xPos, yPos - 1050 + popupOffset,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'blitzLivesFinishedPopup',
                fn: 'back',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: puzzleTracking,
                    c: puzzleTheme,
                    o: screenName,
                    f: constantsObj.TRACK_BACK,
                    g: constantsObj.TRACK_PUZZLE,
                    s: "",
                    co: "",
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.setColor(backButton,constantsObj.COLOR_BUTTON_LIGHT_BLUE);
        utilObj.addChild(popupNode, backButton, zOrder);
        utilObj.pulseButton(backButton, constantsObj.PULSE_ACTION_TAG, 0);
        var backText = "Home";

        var backButtonTxt = utilObj.getBMFontLabel(backText, constantsObj.FONT_ROBOTO_BOLD_70, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos - 1075 + popupOffset, 0.5, 1, labelArr, popupNode, zOrder);
        utilObj.pulseButton(backButtonTxt, constantsObj.PULSE_ACTION_TAG, 0);


        utilObj.addSprites(spriteArr);

        popupLayer.popupSetup(screen, false, blitzLivesFinishedPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });

        var headerLbl = "Keep trying!";

        if (zenModeObj.getMaxScore() > 0) {
            headerLbl = "Blitz-tas-tic!";
        }

        popupLayer.show(popupHeight, screen, headerLbl, popupNode, labelArr, false, null, null, null, null, null, null, null, constantsObj.COLOR_YELLOW_01, constantsObj.COLOR_BLACK, constantsObj.themed_quest_popup_header);

        var showAdDelay = 2;
        utilObj.delayedCallback(popupLayer, blitzLivesFinishedPopup.showAd, showAdDelay);


    };

    this.close = function () {
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", constantsObj.TRACK_BLITZ, constantsObj.TRACK_CLOSE, "", "", "", "");
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.back = function () {
        if (gameObj.getOutroBackOrRetryState() == false) {
            return;
        }
        zenModeObj.setBlitzModeOn(false);
        popupLayer.setDontGoToLastScreen(true);
        popupLayer.setPopupCallback(blitzLivesFinishedPopup.changeScreen, null);
        popupLayer.closeWithDefault();
    };

    this.changeScreen = function () {
        zenModeLayer.hide();
        homeLayer.show();
    };

    this.showAd = function () {
        var isAchievementAnimationShown = false;
        if (subscriptionsDTCObj.getIsSubscriptionActive()) {
            gameObj.setOutroBackOrRetryState(true);
            return;
        }
        if (((!gameObj.getShowAds()) || gameObj.getIsPayer())) {
            gameObj.setOutroBackOrRetryState(true);
            return;
        }

        // check for VI coolDown for a day.
        if (gameObj.getNumberOfVideoIntWatched() >= runtimeObj.getVideoIntCount()) {
            gameObj.setOutroBackOrRetryState(true);
            return;
        }
        if (utilObj.getCurrentTimestamp() <= (gameObj.getCoolDownForVIOnBlitzOutro() + runtimeObj.getCoolDownTimeForVIOnOutro())) {
            gameObj.setOutroBackOrRetryState(true);
            return;
        }
        if (adsObj.checkRewardedVideo(true, null, null, null, true)) {
            adsObj.showVideoAd(true);
            gameObj.setNumberOfVideoIntWatched(gameObj.getNumberOfVideoIntWatched() + 1);
            gameObj.setTimestampForLastVideoInterstitial(utilObj.getCurrentTimestamp());
            adsObj.setNotRewardedVideo(true);
            utilObj.delayedCallback(popupLayer, blitzLivesFinishedPopup.enableNextButton, 1.5);
        } else {
            gameObj.setOutroBackOrRetryState(true);
        }

    };


    this.enableNextButton = function () {
        gameObj.setOutroBackOrRetryState(true);
    };


};


