BlitzQuitPopup = function () {


    var showWithAnim = true;
    var popupNode = null;
    var cb = null;
    var screen = constantsObj.SCREEN_BLITZ_QUIT;
    var screenName;


    this.show = function (withAnim) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }

        this.delayedShow();

    };
    this.delayedShow = function () {
        screenName = utilObj.getScreenName(screen);

        var popupHeight = 540 + constantsObj.POPUP_START_OFFSET;
        var labelArr = [];
        var spriteArr = [];

        popupNode = new cc.Node();
        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2 - constantsObj.POPUP_START_OFFSET;
        var zOrder = constantsObj.UI_Z_ORDER;
        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH, popupHeight - constantsObj.POPUP_START_OFFSET, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);

        yPos -= 145;

        utilObj.getBMFontLabel("You will lose ", constantsObj.FONT_SFCOMPACT_REGULAR_80, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos - 50, yPos, 0.5, 1, labelArr, popupNode, zOrder);

        var life = utilObj.getSprite(constantsObj.blitz_white_heart, xPos + 180, yPos - 15, 0, 1, constantsObj.SCALE_SPRITE_39, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setColor(life,constantsObj.COLOR_BLITZ_RED_HEART);

        yPos -= 200;


        var puzzleTracking = zenModeObj.getBlitzPuzzleTracking();
        var puzzleTheme = zenModeObj.getBlitzPuzzleTheme();
        var resumeButton = utilObj.getButton(400, 150, 0.5, 1.0, xPos - 250, yPos   ,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'blitzQuitPopup',
                fn: 'resume',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: puzzleTracking,
                    c: puzzleTheme,
                    o: screenName,
                    f: constantsObj.TRACK_BLITZ_RESUME,
                    g: constantsObj.TRACK_PUZZLE,
                    s: "",
                    co: "",
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.setColor(resumeButton,constantsObj.COLOR_BUTTON_LIGHT_BLUE);
        utilObj.addChild(popupNode, resumeButton, zOrder);
        utilObj.pulseButton(resumeButton, constantsObj.PULSE_ACTION_TAG, 0);
        var resumeText = "Resume";

        var resumeButtonTxt = utilObj.getBMFontLabel(resumeText, constantsObj.FONT_ROBOTO_BOLD_70, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos - 260, yPos - 75, 0.5, 0.5, labelArr, popupNode, zOrder);
        utilObj.pulseButton(resumeButtonTxt, constantsObj.PULSE_ACTION_TAG, 0);

        var quitButton = utilObj.getButton(400, 150, 0.5, 1.0, xPos + 250, yPos ,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'blitzQuitPopup',
                fn: 'quit',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: puzzleTracking,
                    c: puzzleTheme,
                    o: screenName,
                    f: constantsObj.TRACK_BLITZ_QUIT,
                    g: constantsObj.TRACK_PUZZLE,
                    s: "",
                    co: "",
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.setColor(quitButton,constantsObj.COLOR_BUTTON_ORANGE);
        utilObj.addChild(popupNode, quitButton, zOrder);
        var quitText = "Quit";

        var quitButtonTxt = utilObj.getBMFontLabel(quitText, constantsObj.FONT_ROBOTO_BOLD_70, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos + 260, yPos - 75, 0.5, 0.5, labelArr, popupNode, zOrder);


        utilObj.addSprites(spriteArr);

        popupLayer.popupSetup(screen, false, blitzQuitPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });


        popupLayer.show(popupHeight, screen, "Quit Blitz?", popupNode, labelArr, false, null, null, null, null, null, null, null, constantsObj.COLOR_YELLOW_01, constantsObj.COLOR_BLACK, constantsObj.themed_quest_popup_header);

    };

    this.close = function () {
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", constantsObj.TRACK_BLITZ, constantsObj.TRACK_CLOSE, "", "", "", "");
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.quit = function () {
        zenModeObj.setBlitzModeOn(false);
        popupLayer.setDontGoToLastScreen(true);
        popupLayer.setPopupCallback(blitzQuitPopup.changeScreenforQuit, null);
        popupLayer.closeWithDefault();
    };

    this.resume = function () {
        popupLayer.setDontGoToLastScreen(false);
        popupLayer.closeWithDefault();
    };

    this.changeScreenforQuit = function () {
        zenModeLayer.hide();
        homeLayer.show();
    };

};



