BlitzRetryPopup = function () {


    var showWithAnim = true;
    var popupNode = null;
    var cb = null;
    var screen = constantsObj.SCREEN_BLITZ_RETRY;
    var screenName;

    this.show = function (withAnim) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }

        this.delayedShow();

    };
    this.delayedShow = function () {
        zenModeObj.setStartAfterPopup(true);
        screenName = utilObj.getScreenName(screen);
        zenModeObj.setSoundPlayed(false);

        var str = zenModeObj.getCurrentScore() + "_" + zenModeObj.getLivesCount();

        trackObj.trackCounter(constantsObj.TRACK_PUZZLE, zenModeObj.getBlitzPuzzleTracking(), zenModeObj.getBlitzPuzzleTheme(), constantsObj.TRACK_BLITZ_CLEAR, zenModeLayer.timeForPuzzle, str, zenModeObj.getBlitzSpeciesTracking(), "", "");


        var popupHeight = 1120 + constantsObj.POPUP_START_OFFSET;
        var labelArr = [];
        var spriteArr = [];

        popupNode = new cc.Node();
        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2 - constantsObj.POPUP_START_OFFSET;
        var zOrder = constantsObj.UI_Z_ORDER;
        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH, popupHeight - constantsObj.POPUP_START_OFFSET, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);

        utilObj.getBMFontLabel("Lives available :", constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos - 100, 0.5, 0.5, labelArr, popupNode, zOrder);

        var maxLives = runtimeObj.getMaxLivesForBlitz();
        var livesInActual = zenModeObj.getLivesCount();
        if (livesInActual > maxLives) {
            livesInActual = maxLives;
            loggerObj.debugLog("Lives in retry", livesInActual);
        }
        var heartSpacing = 80;
        var xOffset = heartSpacing * maxLives / 2.0;
        if (livesInActual > 0) {
            for (var i = 0; i < livesInActual; ++i) {
                var life = utilObj.getSprite(constantsObj.blitz_white_heart, centerXPos - xOffset + (i * heartSpacing), yPos - 180, 0, 0.5, constantsObj.SCALE_SPRITE_39, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);
               utilObj.setColor( life,constantsObj.COLOR_BLITZ_RED_HEART);
            }
            for (var i = livesInActual ; i < maxLives; ++i) {
                var life = utilObj.getSprite(constantsObj.blitz_white_heart, centerXPos - xOffset + (i * heartSpacing), yPos - 180, 0, 0.5, constantsObj.SCALE_SPRITE_39, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);
                utilObj.setColor(life,constantsObj.COLOR_GREY_10);
            }
        }


        var bg = utilObj.getSprite(constantsObj.dialog_bg, xPos, yPos - 250, 0.5, 1, 1.9, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
        utilObj.addChild(popupNode, bg, zOrder);

        var blitzIcon = utilObj.getSprite(constantsObj.blitz_mode_icon, xPos, yPos - 290, 0.5, 1, constantsObj.SCALE_SPRITE_46, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
        utilObj.addChild(popupNode, blitzIcon, zOrder);

        // var bestScore = utilObj.getSprite(constantsObj.blitz_best_score , xPos, yPos - 600, 0.5, 1, 1.3, null, popupNode, zOrder + 1, constantsObj.SPRITE_MISC);
        // utilObj.setColor(bestScore,constantsObj.COLOR_BLITZ_BEST_SCORE);
        // utilObj.addChild(popupNode,bestScore, zOrder + 1);
        var scoreLbl = "Your Score:";

        if (zenModeObj.getCurrentScore() > zenModeObj.getMaxScore()) {
            scoreLbl = "New High Score:";
        }

        utilObj.getBMFontLabel(scoreLbl, constantsObj.FONT_SFCOMPACT_MEDIUM_50, constantsObj.COLOR_BLITZ_SCORE_BAR,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos - 605, 0.5, 1, labelArr, popupNode, zOrder);

        var scoreBg = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos - 750, 0.5, 0.5, 380, 150, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setOpacity(scoreBg,constantsObj.OPACITY_20);

        utilObj.getBMFontLabel(zenModeObj.getCurrentScore() + "", constantsObj.FONT_SFCOMPACT_REGULAR_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), 190, 75, 0.5, 0.5, labelArr, scoreBg, zOrder);


        var popupOffset = 200;
        var puzzleTracking = zenModeObj.getBlitzPuzzleTracking();
        var puzzleTheme = zenModeObj.getBlitzPuzzleTheme();
        var backButton = utilObj.getButton(400, 150, 0.5, 1.0, xPos - 250, yPos - 1100 + popupOffset,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'blitzRetryPopup',
                fn: 'back',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: puzzleTracking,
                    c: puzzleTheme,
                    o: screenName,
                    f: constantsObj.TRACK_BLITZ_BACK,
                    g: constantsObj.TRACK_BLITZ_PUZZLE,
                    s: "",
                    co: "",
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.setColor( backButton,constantsObj.COLOR_BUTTON_LIGHT_BLUE);
        utilObj.addChild(popupNode, backButton, zOrder);

        var backText = "Home";
        var backButtonTxt = utilObj.getBMFontLabel(backText, constantsObj.FONT_ROBOTO_BOLD_70, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos - 260, yPos - 1125 + popupOffset, 0.5, 1, labelArr, popupNode, zOrder);

        var retryButton = utilObj.getButton(400, 150, 0.5, 1.0, xPos + 250, yPos - 1100 + popupOffset,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'blitzRetryPopup',
                fn: 'retry',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: puzzleTracking,
                    c: puzzleTheme,
                    o: screenName,
                    f: constantsObj.TRACK_BLITZ_RETRY,
                    g: constantsObj.TRACK_BLITZ_PUZZLE,
                    s: "",
                    co: "",
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.setColor(retryButton,constantsObj.COLOR_BUTTON_ORANGE);
        utilObj.addChild(popupNode, retryButton, zOrder);
        utilObj.pulseButton(retryButton, constantsObj.PULSE_ACTION_TAG, 0);
        var retryText = "Retry";

        var retryButtonTxt = utilObj.getBMFontLabel(retryText, constantsObj.FONT_ROBOTO_BOLD_70, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos + 260, yPos - 1125 + popupOffset, 0.5, 1, labelArr, popupNode, zOrder);
        utilObj.pulseButton(retryButtonTxt, constantsObj.PULSE_ACTION_TAG, 0);


        utilObj.addSprites(spriteArr);

        popupLayer.popupSetup(screen, false, blitzRetryPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: true
        });

        var headerLbl = "Keep trying!";

        if (zenModeObj.getCurrentScore() > 0) {
            headerLbl = "Blitz-tas-tic!";
        }

        popupLayer.show(popupHeight, screen, headerLbl, popupNode, labelArr, false, null, null, null, null, null, null, null, constantsObj.COLOR_YELLOW_01, constantsObj.COLOR_BLACK, constantsObj.themed_quest_popup_header);

        var showAdDelay = 2;
        utilObj.delayedCallback(popupLayer, blitzRetryPopup.showAd, showAdDelay);

    };

    this.close = function () {
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", constantsObj.TRACK_BLITZ, constantsObj.TRACK_CLOSE, "", "", "", "");
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.back = function () {
        if (gameObj.getOutroBackOrRetryState() == false) {
            return;
        }
        zenModeObj.setBlitzModeOn(false);
        popupLayer.setDontGoToLastScreen(true);
        popupLayer.setPopupCallback(blitzRetryPopup.changeScreenforBack, null);
        popupLayer.closeWithDefault();
    };

    this.retry = function () {
        if (gameObj.getOutroBackOrRetryState() == false) {
            return;
        }
        popupLayer.setDontGoToLastScreen(true);
        popupLayer.setPopupCallback(blitzRetryPopup.changeScreenForRetry, null);
        popupLayer.closeWithDefault();

    };

    this.changeScreenforBack = function () {
        zenModeObj.setStartAfterPopup(false);
        zenModeLayer.hide();
        homeLayer.show();
    };

    this.changeScreenForRetry = function () {
        zenModeLayer.hide();
        zenModeLayer.loadBlitzMode();
    };

    this.showAd = function () {
        var isAchievementAnimationShown = false;
        if (subscriptionsDTCObj.getIsSubscriptionActive()) {
            gameObj.setOutroBackOrRetryState(true);
            return;
        }
        if (((!gameObj.getShowAds()) || gameObj.getIsPayer())) {
            gameObj.setOutroBackOrRetryState(true);
            return;
        }

        // check for VI coolDown for a day.
        if (gameObj.getNumberOfVideoIntWatched() >= runtimeObj.getVideoIntCount()) {
            gameObj.setOutroBackOrRetryState(true);
            return;
        }
        if (utilObj.getCurrentTimestamp() <= (gameObj.getCoolDownForVIOnBlitzOutro() + runtimeObj.getCoolDownTimeForVIOnOutro())) {
            gameObj.setOutroBackOrRetryState(true);
            return;
        }
        if (adsObj.checkRewardedVideo(true, null, null, null, true)) {
            adsObj.showVideoAd(true);
            gameObj.setNumberOfVideoIntWatched(gameObj.getNumberOfVideoIntWatched() + 1);
            gameObj.setTimestampForLastVideoInterstitial(utilObj.getCurrentTimestamp());
            adsObj.setNotRewardedVideo(true);
            utilObj.delayedCallback(popupLayer, blitzRetryPopup.enableNextButton, 1.5);
        } else {
            gameObj.setOutroBackOrRetryState(true);
        }

    };

    this.enableNextButton = function () {
        gameObj.setOutroBackOrRetryState(true);
    };
};

