BlitzStartPopup = function () {


    var showWithAnim = true;
    var popupNode = null;
    var cb = null;
    var screen = constantsObj.SCREEN_BLITZ_START;
    var screenName;

    this.show = function (withAnim) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }

        this.delayedShow();

    };
    this.delayedShow = function () {
        zenModeObj.setStopTimer(true);
        zenModeObj.setSoundPlayed(false);

        screenName = utilObj.getScreenName(screen);

        var popupHeight = 1120 + constantsObj.POPUP_START_OFFSET;
        var labelArr = [];
        var spriteArr = [];

        popupNode = new cc.Node();
        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2 - constantsObj.POPUP_START_OFFSET;
        var zOrder = constantsObj.UI_Z_ORDER;
        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH, popupHeight - constantsObj.POPUP_START_OFFSET, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);

        utilObj.getBMFontLabel("Lives available :", constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos - 100, 0.5, 0.5, labelArr, popupNode, zOrder);

        var maxLives = runtimeObj.getMaxLivesForBlitz();
        var livesInActual = zenModeObj.getLivesCount();
        if(livesInActual > maxLives){
            livesInActual = maxLives;
        }
        var heartSpacing = 80;
        var xOffset = heartSpacing * maxLives / 2.0;
        if (livesInActual > 0) {
            for (var i = 0; i < livesInActual; ++i) {
                var life = utilObj.getSprite(constantsObj.blitz_white_heart, centerXPos - xOffset + (i * heartSpacing), yPos - 180, 0, 0.5, constantsObj.SCALE_SPRITE_39, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);
                utilObj.setColor(life,constantsObj.COLOR_BLITZ_RED_HEART);

            }
            for (var i = livesInActual; i < maxLives; ++i) {
                var life = utilObj.getSprite(constantsObj.blitz_white_heart, centerXPos - xOffset + (i * heartSpacing), yPos - 180, 0, 0.5, constantsObj.SCALE_SPRITE_39, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);
                utilObj.setColor(life,constantsObj.COLOR_GREY_10);
            }
        }

        var bg = utilObj.getSprite(constantsObj.dialog_bg, xPos, yPos - 250, 0.5, 1, 1.9, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
        utilObj.addChild(popupNode, bg, zOrder);

        var blitzIcon = utilObj.getSprite(constantsObj.blitz_mode_icon, xPos, yPos - 285, 0.5, 1, constantsObj.SCALE_SPRITE_46, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
        utilObj.addChild(popupNode, blitzIcon, zOrder);

        var bestScore = utilObj.getSprite(constantsObj.blitz_best_score, xPos, yPos - 580, 0.5, 1, constantsObj.SCALE_SPRITE_3, null, popupNode, zOrder + 1, constantsObj.SPRITE_MISC);
        utilObj.setColor(bestScore,constantsObj.COLOR_BLITZ_BEST_SCORE);
        utilObj.addChild(popupNode, bestScore, zOrder + 1);

        utilObj.getBMFontLabel(stringsObj.blitz_best_score1, constantsObj.FONT_SFCOMPACT_MEDIUM_50, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos - 580, 0.5, 1, labelArr, popupNode, zOrder + 1);

        var scoreBg = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos - 750, 0.5, 0.5, 380, 150, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setOpacity(scoreBg,constantsObj.OPACITY_20);

        utilObj.getBMFontLabel(zenModeObj.getMaxScore() + "", constantsObj.FONT_SFCOMPACT_REGULAR_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), 190, 75, 0.5, 0.5, labelArr, scoreBg, zOrder);


        var popupOffset = 200;
        var puzzleTracking = zenModeObj.getBlitzPuzzleTracking();
        var puzzleTheme = zenModeObj.getBlitzPuzzleTheme();
        var backButton = utilObj.getButton(400, 150, 0.5, 1.0, xPos - 250, yPos - 1100 + popupOffset,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'blitzStartPopup',
                fn: 'back',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: puzzleTracking,
                    c: puzzleTheme,
                    o: screenName,
                    f: constantsObj.TRACK_BLITZ_BACK,
                    g: "",
                    s: "",
                    co: "",
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.setColor(backButton,constantsObj.COLOR_BUTTON_LIGHT_BLUE);
        utilObj.addChild(popupNode, backButton, zOrder);

        var backText = "Back";

        var backButtonTxt = utilObj.getBMFontLabel(backText, constantsObj.FONT_ROBOTO_BOLD_70, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos - 260, yPos - 1125 + popupOffset, 0.5, 1, labelArr, popupNode, zOrder);

        var playButton = utilObj.getButton(400, 150, 0.5, 1.0, xPos + 250, yPos - 1100 + popupOffset,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'blitzStartPopup',
                fn: 'play',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: puzzleTracking,
                    c: puzzleTheme,
                    o: screenName,
                    f: constantsObj.TRACK_BLITZ_PLAY,
                    g: "",
                    s: "",
                    co: "",
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.setColor(playButton,constantsObj.COLOR_BUTTON_ORANGE);
        utilObj.addChild(popupNode, playButton, zOrder);
        utilObj.pulseButton(playButton, constantsObj.PULSE_ACTION_TAG, 0);
        var playText = "Play";

        var playButtonTxt = utilObj.getBMFontLabel(playText, constantsObj.FONT_ROBOTO_BOLD_70, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos + 260, yPos - 1125 + popupOffset, 0.5, 1, labelArr, popupNode, zOrder);
        utilObj.pulseButton(playButtonTxt, constantsObj.PULSE_ACTION_TAG, 0);


        utilObj.addSprites(spriteArr);

        popupLayer.popupSetup(screen, false, blitzStartPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });


        popupLayer.show(popupHeight, screen, "Blitz Mode!", popupNode, labelArr, false, null, null, null, null, null, null, null, constantsObj.COLOR_YELLOW_01, constantsObj.COLOR_BLACK, constantsObj.themed_quest_popup_header);

    };

    this.close = function () {
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.back = function () {
        popupLayer.setDontGoToLastScreen(true);
        popupLayer.setPopupCallback(blitzStartPopup.changeScreenforBack, null);
        popupLayer.closeWithDefault();
    };

    this.play = function () {
        popupLayer.setDontGoToLastScreen(false);
        popupLayer.setPopupCallback(blitzStartPopup.playStart, null);
        popupLayer.closeWithDefault();
    };

    this.changeScreenforBack = function () {
        zenModeLayer.hide();
        zenModeObj.setStopTimer(false,false);
        homeLayer.show();
    };

    this.playStart = function () {
        zenModeObj.playStart(screenName);
    };
};

