BonusArchivePopup = function () {
    var popupNode = null;
    var showWithAnim = true;
    var cb = null;
    var screen = constantsObj.SCREEN_BONUS_ARCHIVE_POPUP;
    var returnParams = null;
    var closeTrack = false;
    var from1 = "";
    var continueButtonState = true;
    var rewardedVideoAvailability = false;

    this.show = function (hintAndBuyPopupType, params, from) {
        var params1 = {};
        params1.params = params;
        popupLayer.checkAndShow(bonusArchivePopup.delayedShow, params1);
    };

    this.delayedShow = function (parentLayer, params1) {
        var labelArr = [];
        rewardedVideoAvailability = adsObj.checkRewardedVideoAvailable();
        var popupHeight = 850 + constantsObj.POPUP_START_OFFSET + 340;
        if (rewardedVideoAvailability) {
            popupHeight += 190;
        }
        var spriteArr = [];
        popupNode = new cc.Node();
        var icon = null;
        var btnText = "Unlock";
        var text_homeV1 = "Videos not available right now!";
        var text_homeV2 = "Unlock this archived puzzle?";
        if (rewardedVideoAvailability) {
            text_homeV1 = "Watch a video to unlock";
            text_homeV2 = "Unlock this archived puzzle?";
        }

        var w2eForArchiveVariant = epmObj.getChosenVariant(constantsObj.EXP_W2E_UNLOCK_ARCHIVE);

        var conditionForVideo = false;
        if (w2eForArchiveVariant == constantsObj.EXP_VAR_1 && economyObj.getCash() < economyObj.getRevealCrosswordCost()) {
            conditionForVideo = true;
            cb = bonusArchivePopup.showStore;
        }

        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2 - constantsObj.POPUP_START_OFFSET;
        var zOrder = constantsObj.UI_Z_ORDER;
        var headerText = "";
        var iconScale = null;

        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH, popupHeight - constantsObj.POPUP_START_OFFSET, null, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        utilObj.addChild(popupNode, popupBg);

        var id = params1.params;
        returnParams = id;
        var iconColor = constantsObj.COLOR_BLACK;
        yPos -= 200;

        var dateForPuzzle = utilObj.getDateForId(returnParams);
        var dayOfPuzzle = dateForPuzzle.getDay();
        headerText = "Bonus Archive!";
        icon = constantsObj.THEME_IMAGES_FOR_DAYS[dayOfPuzzle];
        var color = constantsObj.COLOR_FOR_WEEK_THEMES[dayOfPuzzle];
        iconScale = constantsObj.SCALE_SPRITE_3 * 1.5;
        if (homeLayoutExpNew != constantsObj.EXP_VAR_CONTROL) {
            icon = constantsObj.LOGO_FOR_DAYS_NEW_ICON[dayOfPuzzle];
            color = constantsObj.COLOR_FOR_WEEK_THEMES_NEW[dayOfPuzzle];
            if (dayOfPuzzle == 0 || dayOfPuzzle == 3) {
                iconScale = constantsObj.SCALE_SPRITE_3 * 1.2;
            }
        }
        iconColor = color;

        var yShift = 80;
        var powerupIcon = utilObj.getSprite(icon, xPos, yPos - yShift, 0.5, 0.5, iconScale);
        powerupIcon.setColor(iconColor);
        utilObj.addChild(popupNode, powerupIcon, zOrder);

        var themeStr = stringsObj.puzzle_themes[dayOfPuzzle];

        utilObj.getBMFontLabel(themeStr, constantsObj.FONT_ROBOTO_REGULAR_80, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - 300, 0.5, 1, labelArr, popupNode, zOrder);

        yPos -= 100;

        utilObj.getBMFontLabel(utilObj.getFormattedDate(dateForPuzzle), constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - 300, 0.5, 1, labelArr, popupNode, zOrder);

        yPos -= 150;
        var textYShift = 50;
        yPos -= 230;

        if (!rewardedVideoAvailability) {
            utilObj.getBMFontLabel(text_homeV1, constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - textYShift, 0.5, 1, labelArr, popupNode, zOrder);
            yPos -= 80;
        }

        utilObj.getBMFontLabel(text_homeV2, constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - textYShift, 0.5, 1, labelArr, popupNode, zOrder);
        yPos -= 80;

        yPos -= 100;

        var xPosShift = 0;
        var continueBtnColor = constantsObj.COLOR_BUTTON_LIGHT_BLUE;
        var continueBtnWidth = 470;

        var oStr = "bonus_archive_popup";
        var fStr = "video_unlock";

        var home_video_availability = "not_available";
        if (rewardedVideoAvailability) {
            home_video_availability = "available";
        }

        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), oStr, constantsObj.TRACK_VIEW, home_video_availability, "", 1, "");

        if (rewardedVideoAvailability) {
            var puzzleTracking = returnParams;
            var w2eButton = utilObj.getButton(continueBtnWidth, 170, 0.5, 1.0, xPos + xPosShift, yPos,
                constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                    obj: 'bonusArchivePopup',
                    fn: 'watchToEarn',
                    params: null,
                    screen: screen,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: puzzleTracking,
                        c: gameObj.getTrackingPuzzleTheme(),
                        o: oStr,
                        f: fStr,
                        g: "",
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            w2eButton.setColor(continueBtnColor);
            utilObj.addChild(popupNode, w2eButton, zOrder);

            var videoIcon = utilObj.getSprite(constantsObj.video_icon, 235 + 130, 85, 0.5, 0.5, constantsObj.SCALE_SPRITE_2);
            utilObj.addChild(w2eButton, videoIcon, zOrder);

            utilObj.getBMFontLabel(btnText, constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 235 - 50, 85, 0.5, 0.5, labelArr, w2eButton, zOrder);
            utilObj.pulseButton(w2eButton, constantsObj.PULSE_ACTION_TAG, 0);

            utilObj.getBMFontLabel("or", constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_GREY_01,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + xPosShift, yPos - 135 - 85, 0.5, 0.5, labelArr, popupNode, zOrder);

            yPos -= 270;
        }

        fStr = "coin_unlock";

        var params = {id: id};
        var continueButton = utilObj.getButton(continueBtnWidth, 170, 0.5, 1.0, xPos + xPosShift, yPos,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'bonusArchivePopup',
                fn: 'continue',
                params: params,
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: puzzleTracking,
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: oStr,
                    f: fStr,
                    g: "",
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        continueButton.setColor(constantsObj.COLOR_GREEN);
        utilObj.addChild(popupNode, continueButton, zOrder);

        var revealCrosswordCost = economyObj.getRevealCrosswordCost();
        btnText = btnText + "       " + revealCrosswordCost;
        var xPosShift = 0;
        if (revealCrosswordCost < 10) {
            xPosShift = 10;
        }

        var coinIcon = utilObj.getSprite(constantsObj.coin_png_2, 235 + 75 + xPosShift, 85, 0.5, 0.5, constantsObj.SCALE_SPRITE_2);
        utilObj.addChild(continueButton, coinIcon, zOrder);

        utilObj.getBMFontLabel(btnText, constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 235, 85, 0.5, 0.5, labelArr, continueButton, zOrder);
        if (!rewardedVideoAvailability) {
            utilObj.pulseButton(continueButton, constantsObj.PULSE_ACTION_TAG, 0);
        }

        popupLayer.popupSetup(screen, false, bonusArchivePopup.close, null, false, {
            noAnim: true,
            dontGoToLastScreen: false
        });
        popupLayer.show(popupHeight, screen, headerText, popupNode, labelArr, true, null, "", "", false, false, false);
    };

    this.close = function () {
        if (!continueButtonState) {
            return;
        }
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.continue = function (params) {
        if (!continueButtonState) {
            return;
        }
        popupLayer.closeWithDefault();
        homeLayer.loadArchivePuzzle2(returnParams, "heros",false,true);
    };

    this.watchToEarn = function () {
        cb = null;
        if (!utilObj.isOnline()) {
            utilObj.showMessage(stringsObj.not_online);
            return;
        }
        if (adsObj.checkRewardedVideo(false, bonusArchivePopup.callbackfnForVideo) && utilObj.isOnline()) {
            gameObj.setPuzzleToUnlock(returnParams);
            gameObj.setArchiveUnlockReward(true);
            gameObj.setUnlockingBonusArchive(true);
            adsObj.showVideoAd(false);
            adsObj.setNotRewardedVideo(false);
        } else {
            trackObj.trackCounter(constantsObj.TRACK_AD_TRACKING, constantsObj.TRACK_W2E, constantsObj.TRACK_RETRY, curScreen, "", "mopub", "", "", "");
        }
        // popupLayer.closeWithDefault();
    };

    this.callbackfnForVideo = function () {
        gameObj.setPuzzleToUnlock(returnParams);
        gameObj.setArchiveUnlockReward(true);
        gameObj.setUnlockingBonusArchive(true);
        adsObj.setNotRewardedVideo(false);
    };

    this.unlockArchive = function () {
        if (popupLayer.popupOpen) {
            popupLayer.popupSetup(curScreen, false, null, null, false, {noAnim: false, dontGoToLastScreen: false});
            popupLayer.closeWithDefault();
        }
        bonusArchivePopup.close();
        homeLayer.loadPuzzleVideoReward(returnParams);
        gameObj.setPuzzleToUnlock(null);
    };

    this.showStore = function () {
        if (!continueButtonState) {
            return;
        }
        calendarLayer.showStore();
    };

    this.continueButtonState = function (val) {
        continueButtonState = val;
    };

    this.getContinueButtonState = function() {
        return continueButtonState;
    };

    this.enableContinueButton = function () {
        bonusArchivePopup.continueButtonState(true);
    };
};
