BritPackIntroPopup = function () {
    var popupNode = null;
    var showWithAnim = true;
    var cb = null;
    var screen = constantsObj.SCREEN_BRIT_PACK_INTRO;

    this.show = function (withAnim) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        popupLayer.checkAndShow(britPackIntroPopup.delayedShow, null);
    };

    this.delayedShow = function () {
        var popupHeight = 1450 + constantsObj.POPUP_START_OFFSET;
        var popupWidth = constantsObj.NEW_POPUP_WIDTH + 100;
        var labelArr = [];
        var spriteArr = [];
        popupNode = new cc.Node();
        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2;
        var zOrder = constantsObj.UI_Z_ORDER;
        var popupObj = 'britPackIntroPopup';
        var header = stringsObj.brit_pack_intro_header;
        utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, popupWidth, popupHeight, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        yPos -= 560;
        utilObj.getSprite(constantsObj.home_popup_icon, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_5, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);
        yPos -= 380;
        utilObj.getBMFontLabel(stringsObj.brit_pack_intro_subheader, constantsObj.FONT_HELVETICA_MEDIUM_90, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);
        yPos -= 160;

        var descriptionText = stringsObj.brit_pack_intro_description;
        var textArr = utilObj.getSplitStringsArr(descriptionText, 30);
        var numLines = textArr.length;
        for (var i = 0; i < numLines; i++) {
            utilObj.getBMFontLabel(textArr[i], constantsObj.FONT_HELVETICA_70, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);
            yPos -= 100;
        }

        yPos -= 100;
        var playButton = utilObj.getButton(600, 180, 0.5, 1.0, xPos, yPos,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: popupObj,
                fn: 'play',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: utilObj.getScreenName(screen),
                    f: constantsObj.TRACK_PLAY,
                    g: "",
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(popupNode, playButton, zOrder);
        utilObj.setColor(playButton, constantsObj.COLOR_GREEN_09);
        utilObj.getBMFontLabel(stringsObj.brit_pack_intro_cta, constantsObj.FONT_HELVETICA_MEDIUM_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 300, 90, 0.5, 0.5, labelArr, playButton, zOrder);

        popupLayer.popupSetup(screen, false, britPackIntroPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });
        popupLayer.show(popupHeight, screen, header, popupNode, labelArr, false, null, null, null, null, null, null, null, null, null, null, spriteArr, true);
    };

    this.close = function () {
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.play = function () {
        popupLayer.setPopupCallback(homeLayer.pulsateBritPackSection, null);
        popupLayer.closeWithDefault();
    };

    /**
     * this function checks conditions for showing brit pack intro popup
     * @returns {boolean}
     */
    this.checkAndShowBritPackIntroPopup = function () {
        // not showing brit pack intro popup as it is already shown
        // loggerObj.debugLog("britPackLog: introPopup: britPackIntroPopupShown -> ", gameObj.getBritPackIntroPopupShown());
        if (gameObj.getBritPackIntroPopupShown()) {
            // loggerObj.debugLog("britPackLog: introPopup : brit pack intro popup does not surface");
            return false;
        }

        // not showing brit pack intro popup as brit pack does not surface on home screen yet
        // loggerObj.debugLog("britPackLog: introPopup: shouldSurfaceBritPackOnHomeScreen -> ", gameObj.shouldSurfaceBritPack(constantsObj.SCREEN_HOME));
        if (!gameObj.shouldSurfaceBritPack(constantsObj.SCREEN_HOME)) {
            // loggerObj.debugLog("britPackLog: introPopup : brit pack intro popup does not surface");
            return false;
        }

        // not showing brit pack intro popup as mini/weekly quest FTUE is being shown
        // loggerObj.debugLog("britPackLog: introPopup: !miniPuzzleClicked, homeLayer.yPosForFtue, weeklyQuestFtueShown -> ", !homeObj.getIsMiniPuzzleClicked(), homeLayer.yPosForFtue, homeObj.getIsWeeklyQuestFtueShown());
        if ((!homeObj.getIsMiniPuzzleClicked() && homeLayer.yPosForFtue) || homeObj.getIsWeeklyQuestFtueShown()) {
            // loggerObj.debugLog("britPackLog: introPopup: brit pack intro popup does not surface");
            return false;
        }

        // setting brit pack Intro Popup shown set to true here
        gameObj.setBritPackIntroPopupShown(true);
        britPackIntroPopup.show();
        return true;
    };
};
