AccountLocked = function () {
    var popupNode = null;
    var showWithAnim = true;
    var cb = null;
    this.show = function (withAnim) {
        popupLayer.closeWithDefault();
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        popupLayer.checkAndShow(accountLockedPopup.delayedShow, null);
    };

    this.delayedShow = function () {
        var screen = constantsObj.SCREEN_ACCOUNT_LOCKED;
        var screenName = utilObj.getScreenName(screen);
        popupNode = new cc.Node();
        var accountLockedText = stringsObj.account_locked_text;
        var popupHeight = 900;
        if(!psPrivacyObj.shouldCancelDeletionOptionBeShown()) {
            popupHeight -= 200;
            accountLockedText = stringsObj.account_reinstall_text;
        }
        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2;
        var zOrder = constantsObj.UI_Z_ORDER;
        var labelArr = [];
        var spriteArr = [];

        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH, popupHeight , null, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        utilObj.addChild(popupNode, popupBg);

        yPos -= 175;
        var headingColor = constantsObj.COLOR_PURPLE_04;
        utilObj.getBMFontLabel(stringsObj.account_locked_heading, constantsObj.FONT_HELVETICA_BOLD_100, headingColor,
            constantsObj.POPUP_WIDTH - 60, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, yPos, 0.5, 0.5, labelArr, popupNode, zOrder);
        yPos -= 200;
        if(!psPrivacyObj.shouldCancelDeletionOptionBeShown()) {
            yPos -= 80;
        }
        utilObj.getBMFontLabel(accountLockedText, constantsObj.FONT_HELVETICA_MEDIUM_70, headingColor,
            constantsObj.POPUP_WIDTH - 60, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, yPos, 0.5, 0.5, labelArr, popupNode, zOrder);

        if(psPrivacyObj.shouldCancelDeletionOptionBeShown()) {
            yPos -= 270;
            var cancelWidth = 1000;
            var cancelHeight = 190;
            var cancelDeleteBtn = utilObj.getButton(cancelWidth, cancelHeight, 0.5, 0.5,
                xPos, yPos,constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: 'accountLockedPopup',
                    fn: 'cancelDeleteRequest',
                    screen: screen,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                        o: constantsObj.TRACK_ACCOUNT_LOCKED,
                        f: constantsObj.TRACK_CANCEL_DELETE,
                        g: "",
                        s: "",
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            utilObj.addChild(popupNode, cancelDeleteBtn, zOrder);
            var newX = cancelDeleteBtn.getContentSize().width / 2;
            var newY = cancelDeleteBtn.getContentSize().height / 2;
            utilObj.getRoundedButton(newX, newY, cancelWidth, cancelHeight, spriteArr , cancelDeleteBtn, zOrder, constantsObj.COLOR_PRIMARY_BTN, 1);
            utilObj.getBMFontLabel(stringsObj.cancel_account_deletion, constantsObj.FONT_HELVETICA_MEDIUM_80, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), cancelWidth/2, cancelHeight/2, 0.5, 0.5, labelArr, cancelDeleteBtn, zOrder);
            utilObj.pulseButton(cancelDeleteBtn, constantsObj.PULSE_ACTION_TAG, 0);
        }
        utilObj.addSprites(spriteArr);
        popupLayer.popupSetup(screen, false, accountLockedPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });
        popupLayer.show(popupHeight, screen, "", popupNode, labelArr, false, null, "", "", false, false, false, null, null, null, null, null, true);

    };

    this.close = function () {
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.cancelDeleteRequest = function () {
        psPrivacyObj.triggerCancelAccountDeletionRequest();
    };
};

