QuitPopup = function () {
    var screen = constantsObj.SCREEN_QUIT;
    var showWithAnim = true;
    var lastScreen = 0;

    this.show = function (parentLayer, withAnim) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        if (parentLayer != undefined) {
            lastScreen = parentLayer;
        }
        popupLayer.checkAndShow(quitPopup.delayedShow, null);
    };

    this.delayedShow = function (sender, params) {
        // This will behave differently based on the current screen
        // loggerObj.debugLog("entering quit game popup");
        var labelArr = [];
        var spriteArr = [];
        var buttonsToPulse = [];
        var popupHeight = 1120;//1000 + constantsObj.POPUP_START_OFFSET;
        var popupNode = new cc.Node();

        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2;// - constantsObj.POPUP_START_OFFSET;

        var zOrder = constantsObj.UI_Z_ORDER;

        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg_2, xPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH, popupHeight, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        // var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, centerXPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH, popupHeight - constantsObj.POPUP_START_OFFSET);
        // popupNode.addChild(popupBg);

        yPos -= 350;
        var info = {
            heading: stringsObj.leaving_soon,
            desc: stringsObj.leave_desc,
            btn1Label: stringsObj.keep_solving,
            btn1Action: 'goToHome',
            btn2Label: stringsObj.quit,
            btn2Action: 'closeApp'
        };
        var stringsArr = utilObj.getSplitStringsArr(info.desc, 35);
        var lineHeight = 90;
        for (var i = 0; i < stringsArr.length; i++) {
            var descLabel = utilObj.getBMFontLabel(stringsArr[i], constantsObj.FONT_HELVETICA_MEDIUM_65, constantsObj.COLOR_MIDNIGHT_BLUE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, popupNode, zOrder);
            utilObj.setOpacity(descLabel, constantsObj.OPACITY_90);
            yPos -= lineHeight;
        }

        var screenName = utilObj.getScreenName(screen);
        xPos = centerXPos;
        yPos -= 230;
        if (stringsArr.length > 1) {
            yPos += lineHeight;
        }
        var playOnButton = utilObj.getButton(600, 200, 0.5, 0.5, xPos,
            yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'quitPopup',
                fn: info.btn1Action,
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                    o: screenName,
                    f: constantsObj.TRACK_PLAY,
                    g: "",
                    s: "",
                    co: 1,
                    oppId: ""
                },
            });
        utilObj.addChild(popupNode, playOnButton, zOrder);


        /*var gameIcon = utilObj.getSprite(constantsObj.game_icon, 30, 100, 0, 0.5, constantsObj.SCALE_SPRITE_7);
        playOnButton.addChild(gameIcon, zOrder);*/

        var newX = playOnButton.getContentSize().width / 2;
        var newY = playOnButton.getContentSize().height / 2;
        var btnArr = utilObj.getRoundedButton(newX, newY, 600, 200, spriteArr, playOnButton, zOrder, constantsObj.COLOR_PRIMARY_BTN, 1);
        var btnLabel = utilObj.getBMFontLabel("Stay", constantsObj.FONT_HELVETICA_MEDIUM_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), newX, newY + 15, 0.5, 0.5, labelArr, playOnButton, zOrder);

        yPos -= 280;

        var quitBtnwidth = 600;
        var quitBtnHeight = 180;
        var quitButton = utilObj.getButton(quitBtnwidth, quitBtnHeight, 0.5, 0.5, xPos,
            yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'quitPopup',
                fn: info.btn2Action,
                screen: constantsObj.SCREEN_QUIT,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                    o: screenName,
                    f: constantsObj.TRACK_QUIT,
                    g: "",
                    s: "",
                    co: 1,
                    oppId: ""
                },
            });
        utilObj.addChild(popupNode, quitButton, zOrder);

        var newX = quitButton.getContentSize().width / 2;
        var newY = quitButton.getContentSize().height / 2;

        var btnwidth = 800;
        var btnheight = 240;
        var btnShadow = utilObj.getScale9Sprite(constantsObj.button_round_shadow, newX, newY, 0.5, 0.5, btnwidth, btnheight, spriteArr, quitButton, zOrder, constantsObj.SPRITE_MISC);
        var btnBg = utilObj.getScale9Sprite(constantsObj.button_outline_4, btnwidth / 2, 240 / 2 + 12, 0.5, 0.5, btnwidth, btnheight, spriteArr, btnShadow, zOrder, constantsObj.SPRITE_MISC);
        var scaleFactorX = quitBtnwidth / 800;
        var scaleFactorY = quitBtnHeight / 240;
        utilObj.setScaleX(btnShadow, scaleFactorX);
        utilObj.setScaleY(btnShadow, scaleFactorY);

        var btnLabel = utilObj.getBMFontLabel("Leave", constantsObj.FONT_HELVETICA_MEDIUM_80, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), newX, newY + 15, 0.5, 0.5, labelArr, quitButton, zOrder);


        utilObj.addSprites(spriteArr);
        popupLayer.popupSetup(screen, false, quitPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });
        if (lastScreen == constantsObj.SCREEN_PRIVACY_POLICY) {
            // popupLayer.show(popupHeight, screen, info.heading, popupNode, labelArr, false);
            popupLayer.show(popupHeight, screen, info.heading, popupNode, labelArr, false, null, null, null, null, null, null, null, null, constantsObj.COLOR_MIDNIGHT_BLUE, null, null, true);

        } else {
            // popupLayer.show(popupHeight, screen, info.heading, popupNode, labelArr, true);
            popupLayer.show(popupHeight, screen, info.heading, popupNode, labelArr, true, null, null, null, null, null, null, null, null, constantsObj.COLOR_MIDNIGHT_BLUE, null, null, true);

        }
    };

    this.closeApp = function () {
        gameObj.setLastPlayedTimeStamp(utilObj.getCurrentTimestamp());
        popupLayer.closeWithDefault();
        gameObj.setExistingUser();
        utilObj.closeApp();
    };

    this.goToHome = function () {
        popupLayer.closeWithDefault();
        //loggerObj.debugLog("check coming here awafbjkwalelW",lastScreen,constantsObj.SCREEN_PRIVACY_POLICY);
        if (lastScreen == constantsObj.SCREEN_PRIVACY_POLICY) {
            //loggerObj.debugLog("check coming here awafbjkwalelWwe");
            //popupLayer.popupOpen = false;
            privacyPolicyPopup.show(constantsObj.SCREEN_QUIT);
        }
    };

    this.close = function () {

    };
};