RateUsPopup = function () {
    var popupNode = null;
    var showWithAnim = true;
    var cb = null;
    var screen = constantsObj.SCREEN_RATE_US;

    this.show = function (withAnim) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        // loggerObj.debugLog("Popup Layer", popupLayer);
        popupLayer.checkAndShow(rateUsPopup.delayedShow, null);
    };

    this.delayedShow = function () {
        if (gameObj.getLastRatedVersion()) {
            return;
        }
        var labelArr = [];
        var spriteArr = [];
        var popupHeight = 1600;//+ constantsObj.POPUP_START_OFFSET;
        var popupWidth = constantsObj.POPUP_WIDTH;
        var popupObj = 'rateUsPopup';
        popupNode = new cc.Node();

        var currentTimeStamp = utilObj.getCurrentTimestamp();
        gameObj.setLastRateUsShowTimestamp(currentTimeStamp);

        var yPos = centerYPos + popupHeight / 2;//- constantsObj.POPUP_START_OFFSET;
        var xPos = centerXPos;
        var zOrder = constantsObj.UI_Z_ORDER;
        var popupBgColor = constantsObj.COLOR_GREY_POPUP;

        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, popupWidth, popupHeight, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        // popupBg.setColor(popupBgColor);
        //popupNode.addChild(popupBg);
        // utilObj.addChild(popupNode, popupBg);

        yPos -= 650;
        var rateUsImg = utilObj.getSprite(constantsObj.rate_us_2, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_ONE, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);


        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1, constantsObj.TRACK_RATE_US, constantsObj.TRACK_VIEW, "", "", "", "");


        
        yPos -= 470;
        var text = stringsObj.rate_us_2;
        if (utilObj.isAndroid()) {
            text = text.replace("%DEVICE%", "Play");
        } else {
            text = text.replace("%DEVICE%", "App");
        }
        var stringsArr = utilObj.getSplitStringsArr(text, 60);
        for (var i = 0; i < stringsArr.length; i++) {
            // var textLabel = utilObj.getTTFFontLabel(stringsArr[i], constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_BLACK,
            //     constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1);
            // //popupNode.addChild(textLabel, zOrder);
            // utilObj.addChild(popupNode, textLabel, zOrder);
            var textLabel = utilObj.getBMFontLabel(stringsArr[i], constantsObj.FONT_HELVETICA_MEDIUM_65, constantsObj.COLOR_MIDNIGHT_BLUE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, popupNode, zOrder);
            utilObj.setOpacity(textLabel, constantsObj.OPACITY_80);
            yPos -= 100;
        }

        yPos -= 100;
        var buttonWidth = 600;
        var buttonHeight = 180;
        var rateButton = utilObj.getButton(buttonWidth, buttonHeight, 0.5, 0.5, xPos, yPos,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'rateUsPopup',
                fn: 'rateUs',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                    o: constantsObj.TRACK_RATE_US,
                    f: constantsObj.TRACK_RATE,
                    g: utilObj.getScreenName(screen),
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(popupNode, rateButton, zOrder);

        var newX = rateButton.getContentSize().width / 2;
        var newY = rateButton.getContentSize().height / 2;
        var childArr = utilObj.getRoundedButton(newX, newY, buttonWidth, buttonHeight, spriteArr, rateButton, zOrder, constantsObj.COLOR_PRIMARY_BTN, 1);
        var rateUsLabel = utilObj.getBMFontLabel("Rate Us!", constantsObj.FONT_HELVETICA_MEDIUM_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), newX, newY + 10, 0.5, 0.5, labelArr, rateButton, zOrder);
        utilObj.pulseButton(rateButton, constantsObj.PULSE_ACTION_TAG, 0);


        // utilObj.getTTFFontLabel(stringsObj.rate_this_game, constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_WHITE,
        //     constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 330, 100, 0.5, 0.5, labelArr, rateButton, zOrder);

        //gameObj.setLastRateAction(gameObj.RATE_VIEW);
        gameObj.setLastScreenOnWhichPopupShown(lastScreen);
        gameObj.setTimeStampForAutoDialogShown(utilObj.getCurrentTimestamp());

        utilObj.addSprites(spriteArr);
        popupLayer.popupSetup(screen, false, rateUsPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });
        // popupLayer.show(popupHeight, screen, stringsObj.having_good_time, popupNode, labelArr, true, null, utilObj.getScreenName(lastScreen));
        popupLayer.show(popupHeight, screen, stringsObj.having_good_time, popupNode, labelArr, true, null, utilObj.getScreenName(lastScreen), null, null, null, null, null, null, constantsObj.COLOR_MIDNIGHT_BLUE, null, null, true);

    };

    this.close = function () {
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.rateUs = function () {
        if (!utilObj.isOnline()) {
            utilObj.showMessage(stringsObj.not_online);
            return;
        }
        gameObj.setLastRateAction(gameObj.RATE_RATE);
        popupLayer.closeWithDefault();
        gameObj.showAndAwardRateUs();
    };
};