SaveProgress = function () {
    var popupNode = null;
    var showWithAnim = true;
    var cb = null;
    var popupObj = null;
    var lastScreen = null;
    var screen = constantsObj.SCREEN_SAVE_PROGRESS;
    var trackingSentForCCPA = false;

    this.show = function (parentLayer, withAnim, callback) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        cb = callback;
        popupLayer.checkAndShow(saveProgressPopup.delayedShow, null);
    };

    this.delayedShow = function (parentLayer, params) {
        var labelArr = [];
        var spriteArr = [];
        var popupHeight = 1420 ;

        popupNode = new cc.Node();
        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2 ;
        var zOrder = constantsObj.UI_Z_ORDER;
        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH , popupHeight , null, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        utilObj.addChild(popupNode, popupBg);
        var headerText = "Save Your Progress";
        var text = "Never lose your hard-earned progress\n" +
            "by logging in with Game Center";

        popupObj = 'saveProgressPopup';
        yPos -= 450;

        utilObj.getSprite(constantsObj.syncImg, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_ONE, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);



        yPos -= 300;
        var stringsArr = utilObj.getSplitStringsArr(text, 40);
        for (var i = 0; i < stringsArr.length; i++) {
            var colorTxt = constantsObj.COLOR_SAVE_BLUE;;
            var text1 = utilObj.getBMFontLabel(stringsArr[i], constantsObj.FONT_HELVETICA_MEDIUM_65, colorTxt,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);
            yPos -= 100;
        }

        yPos -= 40;

        var okButton = utilObj.getButton(690, 160, 0.5, 1.0, xPos, yPos,
                constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: popupObj,
                    fn: 'yes',
                    screen: screen
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
        okButton.setColor(constantsObj.COLOR_GREEN);
        utilObj.addChild(popupNode, okButton, zOrder);

        var newX = okButton.getContentSize().width / 2;
        var newY = okButton.getContentSize().height / 2;
        var btnArr = utilObj.getRoundedButton(newX, newY, 690, 160, spriteArr, okButton, zOrder, constantsObj.COLOR_PRIMARY_BTN, 1);
        utilObj.getBMFontLabel("Yes, Please!", constantsObj.FONT_HELVETICA_MEDIUM_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 690/2, 80, 0.5, 0.4, labelArr, okButton, zOrder);

        yPos -= 220;
        var noButton = utilObj.getButton(690, 160, 0.5, 1.0, xPos, yPos,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: popupObj,
                fn: 'no',
                screen: screen
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        noButton.setColor(constantsObj.COLOR_GREY_02);
        utilObj.addChild(popupNode, noButton, zOrder);
        var newX = noButton.getContentSize().width / 2;
        var newY = noButton.getContentSize().height / 2;

        var btnwidth = 800;
        var btnheight = 240;
        var btnShadow = utilObj.getScale9Sprite(constantsObj.button_round_shadow, newX, newY, 0.5, 0.5, btnwidth, btnheight, spriteArr, noButton, zOrder, constantsObj.SPRITE_MISC);
        var btnBg = utilObj.getScale9Sprite(constantsObj.button_outline_4, btnwidth / 2, 240 / 2 + 12, 0.5, 0.5, btnwidth, btnheight, spriteArr, btnShadow, zOrder, constantsObj.SPRITE_MISC);
        var scaleFactorX = 690 / 800;
        var scaleFactorY = 160 / 240;
        utilObj.setScaleX(btnShadow, scaleFactorX);
        utilObj.setScaleY(btnShadow, scaleFactorY);

        utilObj.getBMFontLabel("Later", constantsObj.FONT_HELVETICA_MEDIUM_80, constantsObj.COLOR_GREY_SAVE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 690/2, 80, 0.5, 0.4, labelArr, noButton, zOrder);

        utilObj.addSprites(spriteArr)
        popupLayer.popupSetup(screen, false, saveProgressPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });
        popupLayer.show(popupHeight, screen, headerText, popupNode, labelArr, false, null, "", "", false, false, false, null, null, null, null, null, true);
    };

    this.close = function () {
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.yes = function () {
        gameObj.setLoginPopupShown(true);
        psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_IOS + "Util", "startGameCenterLogin");
        popupLayer.setPopupCallback(window[popupObj]['continue'], null);
        popupLayer.closeWithDefault();
    };

    this.no = function () {
        gameObj.setLoginPopupShown(true);
        popupLayer.setPopupCallback(window[popupObj]['continue'], null);
        popupLayer.closeWithDefault();
    };

    this.continue = function () {
        transOutroLayerV2.play(true);
    };
};