SettingsPopup = function () {
    var successCallback = null;
    var failureCallback = null;
    var popupNode = null;
    var popupHeight = 0;
    var listViewWidth = constantsObj.POPUP_WIDTH - 60;
    var performFailureCallBack = true;
    var screen = constantsObj.SCREEN_SETTINGS;
    var showWithAnim = true;
    var soundOnImage = null;
    var soundOffImage = null;
    var hintsOffImage = null;
    var hintsOnImage = null;
    var frenzyOffImage = null;
    var frenzyOnImage = null;
    var cb = null;
    var lastScreen = null;

    // Tags
    var tick_tag = 1;
    var checkBox_tag = 2;
    var tick_tag1 = 3;
    var checkBox_tag1 = 4;
    var checkBoxTagFrenzy = 5;
    var tickTagFrenzy = 6;

    // Bg
    var seeErrorStaysOnBg = null;
    var seeHintStaysOnBg = null;
    var seeSettingsPrivacy = null;
    var seeFrenzyModeBg = null;

    this.show = function (parentLayer, withAnim) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        params = {};
        params.pLayer = parentLayer;
        lastScreen = parentLayer;
        popupLayer.checkAndShow(settingsPopup.delayedShow, params);
        // loggerObj.debugLog("DEEP calling settings popup show", params.pLayer);
    };

    this.delayedShow = function (parentLayer, params) {
        var labelArr = [];
        var spriteArr = [];
        popupNode = new cc.Node();
        performFailureCallBack = true;
        // loggerObj.debugLog("hitting settings popup");

        var screenName = utilObj.getScreenName(screen);
        var puzLevel = gameObj.getCurPuzzleTracking();
        var zOrder = constantsObj.UI_Z_ORDER;
        var itemHeight = 200;
        var localXPos = 70;

        // var date1 = utilObj.getDateForId(gameObj.getInstallDay());
        // var date2 = utilObj.getDateForId(gameObj.getIdForTodaysPuzzle());
        // var dayDiff = utilObj.getDaysDiff(date1, date2);
        // dayDiff = Math.abs(dayDiff);

        popupHeight = 1550;//+ constantsObj.POPUP_START_OFFSET;
        if(questCenterObj.getQuestCenterVariant() == 1){
            popupHeight = 1700;
        }
        var popupWidth = constantsObj.POPUP_WIDTH;

        var popupHeader = stringsObj.settings;

        // if (epmObj.getChosenVariant(constantsObj.EXP_FRENZY) != constantsObj.EXP_VAR_CONTROL){  
        //     popupHeight += 250;
        // }

        var notifsOff = !gameObj.getNotifsEnabled(true);
        if (notifsOff) {
            popupHeight += itemHeight;
        }

        if (utilObj.isIos() || fbWrapperObj.isLoggedIn()) {
            popupHeight -= 250
        }

        if (settingsPopup.eligileSaveProgress()) {
            popupHeight += 250;
        }

        // if (true) {
        //     popupHeight += 300;
        // }

        // if (introOutroRevampExp == constantsObj.EXP_VAR_2) {
        //     popupHeight -= (2 * itemHeight);
        // }
        // if(introOutroRevampExp == constantsObj.EXP_VAR_1 || introOutroRevampExp == constantsObj.EXP_VAR_3){
        //     popupHeight -= (1 * itemHeight);
        // }

        var yPos = centerYPos + popupHeight / 2;//- constantsObj.POPUP_START_OFFSET;
        yPos -= 60
        var xPos = centerXPos;

        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg_2, xPos, yPos, 0.5, 1, popupWidth, popupHeight, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);

        // var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, centerXPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH, popupHeight);
        // popupNode.addChild(popupBg);
        // utilObj.addChild(popupNode, popupBg);

        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1, constantsObj.TRACK_SETTINGS, constantsObj.TRACK_VIEW, "", "", "", "");


        yPos -= 280;

        var breakLineYshift = 110;
        var breakLineWidth = listViewWidth - 100;
        var breakLineHeight = 5;
        
        if (notifsOff) {
            // add notification option
            var notifPermBg = utilObj.getButton(listViewWidth, itemHeight, 0.5, 0.5, xPos, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'settingsPopup',
                fn: 'allowNotifs',
                screen: constantsObj.SCREEN_SETTINGS,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                    o: constantsObj.TRACK_SETTINGS,
                    f: constantsObj.TRACK_NOTIF_PERMISSION_1,
                    g: utilObj.getScreenName(lastScreen),
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
    
            utilObj.addChild(popupNode, notifPermBg, zOrder + 1);

            var notifPermLbl = utilObj.getBMFontLabel(stringsObj.notif_off, constantsObj.FONT_HELVETICA_MEDIUM_70, constantsObj.COLOR_MIDNIGHT_BLUE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos, 80, 0, 0.5, labelArr, notifPermBg, zOrder + 1);
            utilObj.setOpacity(notifPermLbl, constantsObj.OPACITY_80);

            utilObj.getSprite(constantsObj.confirm_hint_use, constantsObj.POPUP_WIDTH - 160, 80, 0.5, 0.5, constantsObj.SCALE_SPRITE_6, spriteArr, notifPermBg, zOrder + 1, constantsObj.SPRITE_MISC);
            
            yPos -= breakLineYshift;
            var breakLine = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, yPos, 0.5, 0.5, breakLineWidth, breakLineHeight, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);
            utilObj.setColor(breakLine, constantsObj.COLOR_BLACK);
            utilObj.setOpacity(breakLine, constantsObj.OPACITY_10);

            yPos -= 100;
        }

        var soundBg = utilObj.getButton(listViewWidth, itemHeight, 0.5, 0.5, xPos, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
            obj: 'settingsPopup',
            fn: 'soundFunc',
            screen: constantsObj.SCREEN_SETTINGS,
            track: {
                k: constantsObj.TRACK_DIALOG,
                p: gameObj.getCurPuzzleTracking(),
                c: linearLevelObj.getDtc2PuzzleCompleted()+1,
                o: constantsObj.TRACK_SETTINGS,
                f: constantsObj.TRACK_SOUND,
                g: utilObj.getScreenName(lastScreen),
                s: gameObj.getPuzzleSpeciesTracking(),
                co: 1,
                oppId: ""
            },
        }, false, ccui.Widget.PLIST_TEXTURE, 1);

        utilObj.addChild(popupNode, soundBg, zOrder + 1);


        var soundLabel = utilObj.getBMFontLabel(stringsObj.sound, constantsObj.FONT_HELVETICA_MEDIUM_70, constantsObj.COLOR_MIDNIGHT_BLUE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos, 80, 0, 0.5, labelArr, soundBg, zOrder + 1);
        utilObj.setOpacity(soundLabel, constantsObj.OPACITY_80);

        soundOnImage = utilObj.getSprite(constantsObj.sound_on_2, constantsObj.POPUP_WIDTH - 160, 80, 0.5, 0.5, constantsObj.SCALE_SPRITE_6, spriteArr, soundBg, zOrder + 1, constantsObj.SPRITE_MISC);

        soundOffImage = utilObj.getSprite(constantsObj.sound_off_2, constantsObj.POPUP_WIDTH - 160, 80, 0.5, 0.5, constantsObj.SCALE_SPRITE_6, spriteArr, soundBg, zOrder + 1, constantsObj.SPRITE_MISC);

        if (gameObj.getSounds()) {
            soundOnImage.setVisible(true);
            soundOffImage.setVisible(false);
        } else {
            soundOnImage.setVisible(false);
            soundOffImage.setVisible(true);
        }

        yPos -= breakLineYshift;

        var breakLine = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, yPos, 0.5, 0.5, breakLineWidth, breakLineHeight, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setColor(breakLine, constantsObj.COLOR_BLACK);
        utilObj.setOpacity(breakLine, constantsObj.OPACITY_10);


        if (settingsPopup.eligileSaveProgress()) {
            yPos -= 100
            // yPos -= 220;
            var fbLogOutBg = utilObj.getButton(listViewWidth, itemHeight, 0.5, 0.5, xPos, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'settingsPopup',
                fn: 'saveProgress',
                screen: constantsObj.SCREEN_SETTINGS
            }, false, ccui.Widget.PLIST_TEXTURE, 1);

            utilObj.addChild(popupNode, fbLogOutBg, zOrder + 1);

            var fbLoginLabel = utilObj.getBMFontLabel("Save Progress", constantsObj.FONT_HELVETICA_MEDIUM_70, constantsObj.COLOR_MIDNIGHT_BLUE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos, 80, 0, 0.5, labelArr, fbLogOutBg, zOrder + 1);
            utilObj.setOpacity(fbLoginLabel, constantsObj.OPACITY_80);

            var fb_icon = utilObj.getSprite(constantsObj.syncImg, constantsObj.POPUP_WIDTH - 160, 80, 0.5, 0.5, 0.27, spriteArr, fbLogOutBg, zOrder + 1, constantsObj.SPRITE_MISC);

            yPos -= breakLineYshift;
            var breakLine = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, yPos, 0.5, 0.5, breakLineWidth, breakLineHeight, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);
            utilObj.setColor(breakLine, constantsObj.COLOR_BLACK);
            utilObj.setOpacity(breakLine, constantsObj.OPACITY_10);

        }

        yPos -= 100;
        var contactUsBg = utilObj.getButton(listViewWidth, itemHeight, 0.5, 0.5, xPos, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
            obj: 'settingsPopup',
            fn: 'helpCenter',
            screen: constantsObj.SCREEN_SETTINGS,
            params: params,
            track: {
                k: constantsObj.TRACK_DIALOG,
                p: gameObj.getCurPuzzleTracking(),
                c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                o: constantsObj.TRACK_SETTINGS,
                f: constantsObj.TRACK_CONTACT_US,
                g: utilObj.getScreenName(lastScreen),
                s: gameObj.getPuzzleSpeciesTracking(),
                co: 1,
                oppId: ""
            },
        }, false, ccui.Widget.PLIST_TEXTURE, 1);

        utilObj.addChild(popupNode, contactUsBg, zOrder + 1);


        var helpCenterLabel = utilObj.getBMFontLabel(stringsObj.help_center, constantsObj.FONT_HELVETICA_MEDIUM_70, constantsObj.COLOR_MIDNIGHT_BLUE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos, 80, 0, 0.5, labelArr, contactUsBg, zOrder + 1);
        utilObj.setOpacity(helpCenterLabel, constantsObj.OPACITY_80);

        var contact_us_icon = utilObj.getSprite(constantsObj.help_center_icon, constantsObj.POPUP_WIDTH - 160, 80, 0.5, 0.5, constantsObj.SCALE_SPRITE_6, spriteArr, contactUsBg, zOrder + 1, constantsObj.SPRITE_MISC);
        yPos -= breakLineYshift;
        var breakLine = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, yPos, 0.5, 0.5, breakLineWidth, breakLineHeight, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setColor(breakLine, constantsObj.COLOR_BLACK);
        utilObj.setOpacity(breakLine, constantsObj.OPACITY_10);


        yPos -= 100;
        seeHintStaysOnBg = utilObj.getButton(listViewWidth, itemHeight, 0.5, 0.5, xPos, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
            obj: 'settingsPopup',
            fn: 'toggleHint',
            screen: constantsObj.SCREEN_SETTINGS,
            params: params,
            track: {
                k: constantsObj.TRACK_DIALOG,
                p: gameObj.getCurPuzzleTracking(),
                c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                o: constantsObj.TRACK_SETTINGS,
                f: constantsObj.TRACK_SHOW_HINT,
                g: utilObj.getScreenName(lastScreen),
                s: gameObj.getPuzzleSpeciesTracking(),
                co: 1,
                oppId: ""
            },
        }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(popupNode, seeHintStaysOnBg, zOrder + 1);

        var confirmHintLabel = utilObj.getBMFontLabel("Confirm Hint Use", constantsObj.FONT_HELVETICA_MEDIUM_70, constantsObj.COLOR_MIDNIGHT_BLUE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos, 80, 0, 0.5, labelArr, seeHintStaysOnBg, zOrder + 1);
        utilObj.setOpacity(confirmHintLabel, constantsObj.OPACITY_80);

        // TODO AFTER SPRITESHEET ADD;
        hintsOffImage = utilObj.getSprite(constantsObj.confirm_hint_use, constantsObj.POPUP_WIDTH - 160, 80, 0.5, 0.5, constantsObj.SCALE_SPRITE_6, spriteArr, seeHintStaysOnBg, zOrder + 1, constantsObj.SPRITE_MISC);
        hintsOnImage = utilObj.getSprite(constantsObj.frenzy_allowed, constantsObj.POPUP_WIDTH - 160, 80, 0.5, 0.5, constantsObj.SCALE_SPRITE_6, spriteArr, seeHintStaysOnBg, zOrder + 1, constantsObj.SPRITE_MISC);

        if (gameObj.getSeeHintStaysOn()) {
            hintsOnImage.setVisible(true);
            hintsOffImage.setVisible(false);
        } else {
            hintsOffImage.setVisible(true);
            hintsOnImage.setVisible(false);
        }

        yPos -= breakLineYshift;
        var breakLine = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, yPos, 0.5, 0.5, breakLineWidth, breakLineHeight, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setColor(breakLine, constantsObj.COLOR_BLACK);
        utilObj.setOpacity(breakLine, constantsObj.OPACITY_10);

        // Frenzy Toggle Button

        // if (epmObj.getChosenVariant(constantsObj.EXP_FRENZY) != constantsObj.EXP_VAR_CONTROL) {
        yPos -= 100;
        seeFrenzyModeBg = utilObj.getButton(listViewWidth, itemHeight, 0.5, 0.5, xPos, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
            obj: 'settingsPopup',
            fn: 'toggleFrenzyMode',
            screen: constantsObj.SCREEN_SETTINGS,
            params: params,
            track: {
                k: constantsObj.TRACK_DIALOG,
                p: gameObj.getCurPuzzleTracking(),
                c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                o: constantsObj.TRACK_SETTINGS,
                f: "frenzy_mode_toggle",
                g: utilObj.getScreenName(lastScreen),
                s: gameObj.getPuzzleSpeciesTracking(),
                co: 1,
                oppId: ""
            },
        }, false, ccui.Widget.PLIST_TEXTURE, 1);
        // seeFrenzyModeBg.setColor(constantsObj.COLOR_LIGHT_GREY_01);
        utilObj.addChild(popupNode, seeFrenzyModeBg, zOrder + 1);


        var frenzyLabel = utilObj.getBMFontLabel("Frenzy Mode", constantsObj.FONT_HELVETICA_MEDIUM_70, constantsObj.COLOR_MIDNIGHT_BLUE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos, 80, 0, 0.5, labelArr, seeFrenzyModeBg, zOrder + 1);
        utilObj.setOpacity(frenzyLabel, constantsObj.OPACITY_80);

        // TODO : FRENZY CHECKBOX
        frenzyOffImage = utilObj.getSprite(constantsObj.confirm_hint_use, constantsObj.POPUP_WIDTH - 160, 80, 0.5, 0.5, constantsObj.SCALE_SPRITE_6, spriteArr, seeFrenzyModeBg, zOrder + 1, constantsObj.SPRITE_MISC);
        frenzyOnImage = utilObj.getSprite(constantsObj.frenzy_allowed, constantsObj.POPUP_WIDTH - 160, 80, 0.5, 0.5, constantsObj.SCALE_SPRITE_6, spriteArr, seeFrenzyModeBg, zOrder + 1, constantsObj.SPRITE_MISC);

        if (gameObj.getFrenzySwitch()) {
            frenzyOnImage.setVisible(true);
            frenzyOffImage.setVisible(false);
        } else {
            frenzyOffImage.setVisible(true);
            frenzyOnImage.setVisible(false);
        }

        // var checkBox = utilObj.getScale9Sprite(constantsObj.rounded_4, constantsObj.POPUP_WIDTH - 205, 110, 0.5, 0.5, 90 * 1.5, 90 * 1.5);
        // if (gameObj.getFrenzySwitch()) {
        //     checkBox.setColor(constantsObj.COLOR_BLUE_08);
        // } else {
        //     checkBox.setColor(constantsObj.COLOR_GREY_08);
        // }
        // seeFrenzyModeBg.addChild(checkBox, zOrder, checkBoxTagFrenzy);
        // var tick1 = utilObj.getSprite(constantsObj.tick, constantsObj.POPUP_WIDTH - 205, 110, 0.5, 0.5, constantsObj.SCALE_SPRITE_1);
        // seeFrenzyModeBg.addChild(tick1, zOrder + 1, tickTagFrenzy);
        // tick1.setColor(constantsObj.COLOR_WHITE);
        // tick1.setVisible(gameObj.getFrenzySwitch());

        yPos -= breakLineYshift;
        var breakLine = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, yPos, 0.5, 0.5, breakLineWidth, breakLineHeight, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setColor(breakLine, constantsObj.COLOR_BLACK);
        utilObj.setOpacity(breakLine, constantsObj.OPACITY_10);
        // }

        yPos -= 100;
        seeSettingsPrivacy = utilObj.getButton(listViewWidth, itemHeight, 0.5, 0.5, xPos, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
            obj: 'settingsPopup',
            fn: 'ShowPrivacyPolicy',
            screen: constantsObj.SCREEN_SETTINGS,
            params: params,
            track: {
                k: constantsObj.TRACK_DIALOG,
                p: gameObj.getCurPuzzleTracking(),
                c: linearLevelObj.getDtc2PuzzleCompleted() + 1,
                o: constantsObj.TRACK_SETTINGS,
                f: constantsObj.TRACK_PRIVACY_POLICY,
                g: utilObj.getScreenName(lastScreen),
                s: gameObj.getPuzzleSpeciesTracking(),
                co: 1,
                oppId: ""
            },
        }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(popupNode, seeSettingsPrivacy, zOrder + 1);


        var privacyLabel = utilObj.getBMFontLabel("Privacy Policy", constantsObj.FONT_HELVETICA_MEDIUM_70, constantsObj.COLOR_MIDNIGHT_BLUE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos, 80, 0, 0.5, labelArr, seeSettingsPrivacy, zOrder + 1);
        utilObj.setOpacity(privacyLabel, constantsObj.OPACITY_80);

        // //var PrivacyPolicyCircle = utilObj.getSprite(constantsObj.rounded_white, constantsObj.POPUP_WIDTH - 205, 110, 0.5, 0.5, constantsObj.SCALE_SPRITE_1, null, howToPlayBg, zOrder, constantsObj.SPRITE_MISC);
        // //PrivacyPolicyCircle.setColor(constantsObj.COLOR_BUTTON_LIGHT_ORANGE);
        // //utilObj.addChild(seeSettingsPrivacy, PrivacyPolicyCircle, zOrder + 1);

        // var PrivacyPolicyIcon = utilObj.getSprite(constantsObj.privacy_policy_icon, constantsObj.POPUP_WIDTH - 205, 110, 0.5, 0.5, constantsObj.SCALE_SPRITE_10 * 1.5, null, soundBg, zOrder, constantsObj.SPRITE_MISC);
        // utilObj.addChild(seeSettingsPrivacy, PrivacyPolicyIcon, zOrder + 1);

        var PrivacyPolicyIcon = utilObj.getSprite(constantsObj.privacy_policy_icon_2, constantsObj.POPUP_WIDTH - 160, 80, 0.5, 0.5, constantsObj.SCALE_SPRITE_6, spriteArr, seeSettingsPrivacy, zOrder + 1, constantsObj.SPRITE_MISC);


        utilObj.addSprites(spriteArr);
        popupLayer.popupSetup(screen, false, settingsPopup.close(), null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });
        // popupLayer.show(popupHeight, screen, popupHeader, popupNode, labelArr, true, "", utilObj.getScreenName(lastScreen));
        popupLayer.show(popupHeight, screen, popupHeader, popupNode, labelArr, true, "", utilObj.getScreenName(lastScreen), null, null, null, null, null, null, constantsObj.COLOR_MIDNIGHT_BLUE, null, null, true);

    };

    this.close = function () {
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.performSuccessCallback = function () {
        failureCallback = null;
        if (successCallback != null) {
            var temp = successCallback;
            successCallback = null;
            temp();
        }
    };

    /*this.freeCoins = function () {
     performFailureCallBack = false;
     var cb = successCallback;
     successCallback = false;
     popupLayer.popupSetup(screen, false, storePopup.close, null, showWithAnim, {
     noAnim: false,
     dontGoToLastScreen: true
     });
     popupLayer.closeWithDefault();
     freeCoinsPopup.show(true, cb , parentLayer);
     };*/

    this.soundFunc = function () {
        // loggerObj.debugLog("lelouch getSounds returns ", gameObj.getSounds());
        if (gameObj.getSounds() == true) {
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1, constantsObj.TRACK_SETTINGS, constantsObj.TRACK_SOUND_OFF, utilObj.getScreenName(lastScreen), gameObj.getPuzzleSpeciesTracking(), 1, "");
            soundOnImage.setVisible(false);
            soundOffImage.setVisible(true);
            gameObj.setSounds(false);
        } else {
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1, constantsObj.TRACK_SETTINGS, constantsObj.TRACK_SOUND_ON, utilObj.getScreenName(lastScreen), gameObj.getPuzzleSpeciesTracking(), 1, "");
            soundOnImage.setVisible(true);
            soundOffImage.setVisible(false);
            gameObj.setSounds(true);
        }
    };

    this.showQuestCenter = function(){
        loggerObj.debugLog("hehe : quest center")
        if(pspnFlutterObj.isFlutterEnabled()) {
            if(ftueObj.isFtueShown()) {
                questsObj.incActionForQuestType(xpromoConstantsObj.QUEST_TYPE_COMPLETE_TUTORIAL);
            }

            questCenterLayer.show(utilObj.getScreenName(lastScreen));
            popupLayer.closeWithDefault();
            return;
        }
    };

    this.fbLogOut = function () {
        popupLayer.closeWithDefault();

        if (fbWrapperObj.isLoggedIn()) {
            fbLogoutPopup.show();
        } else {
            fbWrapperObj.login(settingsPopup.loginSuccess);
        }

    };

    this.loginSuccess = function () {
        gameObj.setLoggedInFb(true);
    };

    this.helpCenter = function (params) {
        // popupLayer.setDontGoToLastScreen(true);
        // loggerObj.debugLog("in setting help")
        popupLayer.setPopupCallback(settingsPopup.showHelpCenter, params);
        popupLayer.closeWithDefault();
    };

    this.showHelpCenter = function (params, node) {

        utilObj.contactUs();
        machineLearningDataObj.incUserOpenedHelpCenter();

        /*if (params.pLayer == constantsObj.SCREEN_HOME) {
            homeLayer.hide();
        } else if (params.pLayer == constantsObj.SCREEN_GAME) {
            gameObj.save();
            gameLayer.removeAllChildren();
            gameLayer.setVisible(false);
        } else if (params.pLayer == constantsObj.SCREEN_CALENDAR) {
            calendarLayer.hide();
        } else if (params.pLayer == constantsObj.SCREEN_PACK_INFO_LAYER) {
            packInfoLayer.hide();
        } else if (params.pLayer == constantsObj.SCREEN_ACHIEVEMENTS) {
            achievementsLayer.hide();
        } else if (params.pLayer == constantsObj.SCREEN_PACK_LAYER) {
            packsLayer.hide();
        } else if( params.pLayer == constantsObj.SCREEN_QUEST_MAP){
            questMapLayer.hide();
        }

        if (node != undefined) {
            supportLayer.show(node, params);
        } else {
            supportLayer.show("", params);
        }
        machineLearningDataObj.incUserOpenedHelpCenter();*/
    };

    this.howToPlay = function (params) {
        popupLayer.setPopupCallback(settingsPopup.startForcedFtue, params);
        popupLayer.closeWithDefault();
    };

    this.startForcedFtue = function () {
        var puzzleId = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
        if (gameLayer.crosswordDate != undefined) {
            puzzleId = gameLayer.crosswordDate;
        }
        if (gameObj.getCrosswordForDate(puzzleId) == null) {
            //loggerObj.debugLog("check for the w2e9 ");
            if (utilObj.isOnline() == false) {
                utilObj.showMessage("Please connect to internet to download content");
            } else {
                runtimeObj.syncToServer();
                utilObj.showMessage("Please try after some time");
            }
            //utilObj.showMessagePopup(stringsObj.request_update);
            return;
        }
        if (params.pLayer == constantsObj.SCREEN_GAME) {
            gameLayer.hide();
            puzzleId = gameLayer.crosswordDate;
        } else if (params.pLayer == constantsObj.SCREEN_HOME) {
            homeLayer.hide();
        } else if (params.pLayer == constantsObj.SCREEN_CALENDAR) {
            calendarLayer.hide();
        } else if (params.pLayer == constantsObj.SCREEN_PACK_INFO_LAYER) {
            packInfoLayer.hide();
        } else if (params.pLayer == constantsObj.SCREEN_ACHIEVEMENTS) {
            achievementsLayer.hide();
        } else if (params.pLayer == constantsObj.SCREEN_PACK_LAYER) {
            packsLayer.hide();
        } else if (params.pLayer == constantsObj.SCREEN_QUEST_MAP) {
            questMapLayer.hide();
        }
        gameObj.setIsHowToPlayOpened(true);
        ftueObj.setForcedFtueStarted(true);
        ftueObj.setFtueShown(false);
        ftueObj.setScreenIndex(0);
        gameObj.setOnGridView(true);
        gameLayer.show(puzzleId);
    };

    this.toggle = function () {
        if (seeErrorStaysOnBg && utilObj.isNodeValid(seeErrorStaysOnBg)) {
            var checkBox = seeErrorStaysOnBg.getChildByTag(checkBox_tag);
            var tick = seeErrorStaysOnBg.getChildByTag(tick_tag);
            if (utilObj.isNodeValid(tick) && utilObj.isNodeValid(checkBox)) {
                var vis = !tick.isVisible();
                tick.setVisible(vis);
                if (vis) {
                    trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1, constantsObj.TRACK_SETTINGS,
                        constantsObj.TRACK_SHOW_WRONG_ON, utilObj.getScreenName(lastScreen), gameObj.getPuzzleSpeciesTracking(), 1, "");
                    checkBox.setColor(constantsObj.COLOR_BLUE_08);
                } else {
                    trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1, constantsObj.TRACK_SETTINGS,
                        constantsObj.TRACK_SHOW_WRONG_OFF, utilObj.getScreenName(lastScreen), gameObj.getPuzzleSpeciesTracking(), 1, "");
                    checkBox.setColor(constantsObj.COLOR_GREY_08);
                }
                gameObj.setSeeWrongStaysOn(vis);
            }
        }
    };

    this.toggleHint = function () {
        // if (seeHintStaysOnBg && utilObj.isNodeValid(seeHintStaysOnBg)) {
        //     var checkBox1 = seeHintStaysOnBg.getChildByTag(checkBox_tag1);
        //     var tick1 = seeHintStaysOnBg.getChildByTag(tick_tag1);
        //     if (utilObj.isNodeValid(tick1) && utilObj.isNodeValid(checkBox1)) {
        //         var vis = !tick1.isVisible();
        //         tick1.setVisible(vis);
        //         if (vis) {
        //             trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_SETTINGS,
        //                 constantsObj.TRACK_SHOW_HINT_ON, utilObj.getScreenName(lastScreen), gameObj.getPuzzleSpeciesTracking(), 1, "");
        //             checkBox1.setColor(constantsObj.COLOR_BLUE_08);
        //         } else {
        //             trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_SETTINGS,
        //                 constantsObj.TRACK_SHOW_HINT_OFF, utilObj.getScreenName(lastScreen), gameObj.getPuzzleSpeciesTracking(), 1, "");
        //             checkBox1.setColor(constantsObj.COLOR_GREY_08);
        //         }
        //         gameObj.setSeeHintStaysOn(vis);
        //     }
        // }
        if (gameObj.getSeeHintStaysOn() == true) {
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1, constantsObj.TRACK_SETTINGS, constantsObj.TRACK_SHOW_HINT_OFF, utilObj.getScreenName(lastScreen), gameObj.getPuzzleSpeciesTracking(), 1, "");
            hintsOnImage.setVisible(false);
            hintsOffImage.setVisible(true);
            gameObj.setSeeHintStaysOn(false);
        } else {
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1, constantsObj.TRACK_SETTINGS, constantsObj.TRACK_SHOW_HINT_ON, utilObj.getScreenName(lastScreen), gameObj.getPuzzleSpeciesTracking(), 1, "");
            hintsOnImage.setVisible(true);
            hintsOffImage.setVisible(false);
            gameObj.setSeeHintStaysOn(true);
        }

    };

    this.toggleFrenzyMode = function () {
        // if (seeFrenzyModeBg && utilObj.isNodeValid(seeFrenzyModeBg)) {
        //     var checkBox = seeFrenzyModeBg.getChildByTag(checkBoxTagFrenzy);
        //     var tick = seeFrenzyModeBg.getChildByTag(tickTagFrenzy);
        //     if (utilObj.isNodeValid(tick) && utilObj.isNodeValid(checkBox)) {
        //         var vis = !tick.isVisible();
        //         tick.setVisible(vis);
        //         if (vis) {
        //             checkBox.setColor(constantsObj.COLOR_BLUE_08);
        //             trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_SETTINGS, constantsObj.TRACK_FRENZY_ON, utilObj.getScreenName(lastScreen), gameObj.getPuzzleSpeciesTracking(), 1, "");
        //         } else {
        //             checkBox.setColor(constantsObj.COLOR_GREY_08);
        //             trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_SETTINGS, constantsObj.TRACK_FRENZY_OFF, utilObj.getScreenName(lastScreen), gameObj.getPuzzleSpeciesTracking(), 1, "");
        //         }
        //         gameObj.setFrenzySwitch(vis);
        //     }
        // }
        if (gameObj.getFrenzySwitch() == true) {
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1, constantsObj.TRACK_SETTINGS, constantsObj.TRACK_FRENZY_OFF, utilObj.getScreenName(lastScreen), gameObj.getPuzzleSpeciesTracking(), 1, "");
            frenzyOnImage.setVisible(false);
            frenzyOffImage.setVisible(true);
            gameObj.setFrenzySwitch(false);
        } else {
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), linearLevelObj.getDtc2PuzzleCompleted() + 1, constantsObj.TRACK_SETTINGS, constantsObj.TRACK_FRENZY_ON, utilObj.getScreenName(lastScreen), gameObj.getPuzzleSpeciesTracking(), 1, "");
            frenzyOnImage.setVisible(true);
            frenzyOffImage.setVisible(false);
            gameObj.setFrenzySwitch(true);
        }
    };

    this.ShowPrivacyPolicy = function (params) {
        // loggerObj.debugLog("cheking prev layer",params.pLayer);
        // popupLayer.setDontGoToLastScreen(true);
        popupLayer.setPopupCallback(settingsPopup.showPrivacy, params);
        popupLayer.closeWithDefault();
    };

    this.showPrivacy = function (params) {

        utilObj.openUrl("https://playsimple.in/privacy_aa");
        machineLearningDataObj.incUserOpenedHelpCenter();

        /*supportLayer.init();
        if (params.pLayer == constantsObj.SCREEN_HOME) {
            homeLayer.hide();
        } else if (params.pLayer == constantsObj.SCREEN_GAME) {
            gameLayer.removeAllChildren();
            gameLayer.setVisible(false);
        } else if (params.pLayer == constantsObj.SCREEN_CALENDAR) {
            calendarLayer.hide();
        } else if (params.pLayer == constantsObj.SCREEN_PACK_INFO_LAYER) {
            packInfoLayer.hide();
        } else if (params.pLayer == constantsObj.SCREEN_ACHIEVEMENTS) {
            achievementsLayer.hide();
        } else if (params.pLayer == constantsObj.SCREEN_PACK_LAYER) {
            packsLayer.hide();
        } else if(params.pLayer == constantsObj.SCREEN_QUEST_MAP){
            questMapLayer.hide();
        }
        supportLayer.show("privacy_policy", params);*/
    };

    this.saveProgress = function () {
        psUtilObj.makeNativeCall(psConstantsObj.PACKAGE_PATH_IOS + "Util", "startGameCenterLogin");
        popupLayer.closeWithDefault();
    };

    this.eligileSaveProgress = function () {
        if (userObj.getSyncId() == "" /*&& gameObj.getLoginPopupShown()*/) {
            return true;
        }
        return false;
    };

    /**
     * handles click on "notifications" section
     */
    this.allowNotifs = function(){
        // popupLayer.setPopupCallback(utilObj.allowNotifications, null);
        popupLayer.closeWithDefault();
        utilObj.allowNotifications();
    };
};
