IntroPopup = function () {
    var popupNode = null;
    var showWithAnim = true;
    var cb = null;
    var screen = constantsObj.SCREEN_INTRO
    var puzzleId = null;
    var score = null;
    var lastCb = null;
    var videoAvailability = false;
    var timeOver = false;
    var animTime1 = 0;
    var popupShownCount = 0;
    var w2ePowerUpButton = null;
    var w2eOptOut = false;
    var w2eOptOutCondition = false;
    var popupShownTimeStamp = 0;

    this.show = function (withAnim) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        // loggerObj.debugLog("Popup Layer", popupLayer);
        popupLayer.checkAndShow(introPopup.delayedShow, null);
    };

    this.delayedShow = function () {
        var labelArr = [];
        var popupHeight = 1200 + constantsObj.POPUP_START_OFFSET;
        var popupObj = 'introPopup';
        introPopup.popupShownTimeStamp = utilObj.getCurrentTimestamp();
        var screenName = utilObj.getScreenName(screen);
        puzzleId = gameObj.getCrosswordToShow();
        var isMiniOrMidi = gameObj.checkForMiniOrMidi(puzzleId);
        var isDailyMini = gameObj.checkForDailyMini(puzzleId);
        var isBritMini = gameObj.checkForBritMini(puzzleId);
        gameObj.setW2ePowerUpVideoWatched(false);
        var popupBgYShift = 0;
        if (isMiniOrMidi != true) {
            if (gameObj.getD0Id() == puzzleId) {
                //puzzleId = gameObj.getInstallDay();
                var todaysDate = gameObj.getTodaysPuzzleDate();
                var todaysId = utilObj.getIdForDate(todaysDate);
                puzzleId = todaysId;
                /*var puzzleDate = utilObj.getDateForId(todaysId);
                var puzzleMonth = puzzleDate.getMonth();
                if (mastery == constantsObj.MASTERY_GOLD) {
                    gameObj.setThreeStarsInMonth(puzzleMonth);
                }*/
            }
            var d = utilObj.getDateForId(puzzleId);
            var day = d.getDay();
            score = gameObj.getBestTimeForTheme(day);
        } else {
            var packId = gameObj.getPackIdFromPuzzleId(puzzleId);
            //var puzzleNumber = gameObj.getnumberOfPuzzleCompleted(packId) + 1;
            var totalPuzzles = gameObj.getTotalPuzzle(packId);
            var curCrosswordInfo = gameObj.getCrosswordForDate(puzzleId);
            // loggerObj.debugLog("this is crosswordInfo", utilObj.getStringifiedJson(curCrosswordInfo));
            var puzzleNumber = parseInt(puzzleId) % 100;
            // loggerObj.debugLog("this is crosswordInfo puzzle Id", puzzleNumber);
            var height = curCrosswordInfo.h;
            var width = curCrosswordInfo.w;
        }
        var mastery = constantsObj.MASTERY_NONE; //scoresObj.getMasteryForScore(puzzleId, score);
        var layoutExperimentVariant = epmObj.getChosenVariant(constantsObj.EXP_LAYOUT);
        popupNode = new cc.Node();

        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2 - constantsObj.POPUP_START_OFFSET;
        var zOrder = constantsObj.UI_Z_ORDER;

        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, constantsObj.LARGE_POPUP_WIDTH, popupHeight - constantsObj.POPUP_START_OFFSET - popupBgYShift, null, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        popupBg.setColor(constantsObj.COLOR_WHITE);
        //popupNode.addChild(popupBg);
        utilObj.addChild(popupNode, popupBg);

        var header = puzzleId;

        if (layoutExperimentVariant == constantsObj.EXP_VAR_CONTROL) {
            yPos -= 80;
            utilObj.getTTFFontLabel(stringsObj.solve_the_puzzle, constantsObj.FONT_ROBOTO_MEDIUM_120, constantsObj.COLOR_GREY_03,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);

            yPos -= 300;
            var starColor = constantsObj.COLOR_GREY_02;
            if (mastery > constantsObj.MASTERY_NONE) {
                starColor = constantsObj.COLOR_STAR_1;
            }
            var star1 = utilObj.getSprite(constantsObj.star_white, xPos - 350, yPos - 70, 0.5, 0.5, constantsObj.SCALE_SPRITE_21, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            star1.setColor(starColor);
            star1.setRotation(-30);
            //popupNode.addChild(star1);
            utilObj.addChild(popupNode, star1);
            if (mastery < constantsObj.MASTERY_SILVER) {
                starColor = constantsObj.COLOR_GREY_02;
            }
            var star2 = utilObj.getSprite(constantsObj.star_white, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_22, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            star2.setColor(starColor);
            //popupNode.addChild(star2);
            utilObj.addChild(popupNode, star2);
            if (mastery < constantsObj.MASTERY_GOLD) {
                starColor = constantsObj.COLOR_GREY_02;
            }
            var star3 = utilObj.getSprite(constantsObj.star_white, xPos + 350, yPos - 70, 0.5, 0.5, constantsObj.SCALE_SPRITE_21, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            star3.setColor(starColor);
            star3.setRotation(30);
            //popupNode.addChild(star3);
            utilObj.addChild(popupNode, star3);

            yPos -= 270;
            utilObj.getTTFFontLabel("Your " + stringsObj.puzzle_themes[day] + " Record:", constantsObj.FONT_ROBOTO_MEDIUM_40, constantsObj.COLOR_GREY_03,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);
            yPos -= 50;
            var text;
            if (score) {
                text = utilObj.formatTime(score);
            } else {
                text = "--:--";
            }
            utilObj.getTTFFontLabel(text, constantsObj.FONT_ROBOTO_BOLD_120, constantsObj.COLOR_GREY_03,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);

            yPos -= 220;

            var playButton = utilObj.getButton(360, 150, 0.5, 1.0, xPos, yPos,
                constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                    obj: 'introPopup',
                    fn: 'play',
                    screen: screen,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: gameObj.getTrackingPuzzleTheme(),
                        o: constantsObj.TRACK_LEVEL_INTRO,
                        f: constantsObj.TRACK_PLAY,
                        g: "",
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            playButton.setColor(constantsObj.COLOR_GREEN_01);
            //popupNode.addChild(playButton, zOrder);
            utilObj.addChild(popupNode, playButton, zOrder);
            utilObj.getTTFFontLabel(stringsObj.play, constantsObj.FONT_ROBOTO_BOLD_70, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - 35, 0.5, 1, labelArr, popupNode, zOrder);
        } else {
            header = stringsObj.solve_crossword + "!";
            yPos -= 80;
            if (isMiniOrMidi != true) {
                utilObj.getBMFontLabel(stringsObj.puzzle_themes_pack_Info[day] + "!", constantsObj.FONT_ROBOTO_REGULAR_80, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);
            } else if (isDailyMini) {
                utilObj.getBMFontLabel(stringsObj.Daily_mini + "!", constantsObj.FONT_ROBOTO_REGULAR_80, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);
            } else {
                if (isBritMini) {
                    utilObj.getBMFontLabel(stringsObj.puzzle_themes_brit_pack_Info[packId] + "!", constantsObj.FONT_ROBOTO_REGULAR_80, constantsObj.COLOR_BLACK,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);
                } else {
                    utilObj.getBMFontLabel(stringsObj.puzzle_themes_pack_Info[packId] + "!", constantsObj.FONT_ROBOTO_REGULAR_80, constantsObj.COLOR_BLACK,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);
                }
            }

            yPos -= 100;
            if (isMiniOrMidi != true) {
                utilObj.getBMFontLabel(utilObj.getFormattedDate(d), constantsObj.FONT_ROBOTO_REGULAR_50, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);
            } else if (isDailyMini) {
                if (homeLayer.dailyMiniToShow != null) {
                    var dailyMiniId = homeLayer.dailyMiniToShow;
                    dailyMiniId = "20" + dailyMiniId.substr(2,dailyMiniId.length);
                    var date = utilObj.getDateForId(dailyMiniId);
                    utilObj.getBMFontLabel(utilObj.getFormattedDate(date), constantsObj.FONT_ROBOTO_REGULAR_50, constantsObj.COLOR_BLACK,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);
                } else {
                    var archiveId = gameObj.convertDailyMiniIdToArchive(puzzleId);
                    var dateForId = utilObj.getDateForId(archiveId);
                    utilObj.getBMFontLabel(utilObj.getFormattedDate(dateForId), constantsObj.FONT_ROBOTO_REGULAR_50, constantsObj.COLOR_BLACK,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);
                }
            } else {
                // utilObj.getBMFontLabel("Puzzle " + puzzleNumber + " of " + totalPuzzles, constantsObj.FONT_ROBOTO_REGULAR_50, constantsObj.COLOR_BLACK,
                //     constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);
            }

            yPos -= 80;

            introPopup.w2eOptOut = false;
            var bg = utilObj.getSprite(constantsObj.dialog_bg, xPos, yPos, 0.5, 1, 2, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            //popupNode.addChild(bg, zOrder);
            utilObj.addChild(popupNode, bg, zOrder);

            yPos -= 180;
            var starColor = constantsObj.COLOR_GREY_02;
            var opacity = constantsObj.OPACITY_30;
            if (mastery > constantsObj.MASTERY_NONE) {
                starColor = constantsObj.COLOR_BLUE_01;
                opacity = constantsObj.OPACITY_100;
            }
            var star1 = utilObj.getSprite(constantsObj.star_white_2, xPos - 270, yPos - 40, 0.5, 0.5, constantsObj.SCALE_SPRITE_4, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            star1.setColor(starColor);
            star1.setRotation(-30);
            star1.setOpacity(opacity);
            //popupNode.addChild(star1, zOrder);
            utilObj.addChild(popupNode, star1, zOrder);
            if (mastery < constantsObj.MASTERY_SILVER) {
                starColor = constantsObj.COLOR_GREY_02;
                opacity = constantsObj.OPACITY_30;
            }
            var star2 = utilObj.getSprite(constantsObj.star_white_2, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_21, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            star2.setColor(starColor);
            star2.setOpacity(opacity);
            //popupNode.addChild(star2, zOrder);
            utilObj.addChild(popupNode, star2, zOrder);
            if (mastery < constantsObj.MASTERY_GOLD) {
                starColor = constantsObj.COLOR_GREY_02;
                opacity = constantsObj.OPACITY_30;
            }
            var star3 = utilObj.getSprite(constantsObj.star_white_2, xPos + 270, yPos - 40, 0.5, 0.5, constantsObj.SCALE_SPRITE_4, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            star3.setColor(starColor);
            star3.setRotation(30);
            star3.setOpacity(opacity);
            //popupNode.addChild(star3, zOrder);
            utilObj.addChild(popupNode, star3, zOrder);

            yPos -= 200;
            /*utilObj.getTTFFontLabel("Your " + " " + stringsObj.puzzle_themes[day] + " Record:", constantsObj.FONT_ROBOTO_REGULAR_50, constantsObj.COLOR_BLUE_02,
             constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);*/
            yPos -= 120;
            /*var text;
             if (score) {
             text = utilObj.formatTime(score);
             } else {
             text = "--:--";
             }
             var timeBg = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos + 35, 0.5, 1, 400, 140, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
             timeBg.setOpacity(constantsObj.OPACITY_20);
             popupNode.addChild(timeBg, zOrder);
             utilObj.getTTFFontLabel(text, constantsObj.FONT_ROBOTO_REGULAR_80, constantsObj.COLOR_WHITE,
             constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);*/

            yPos -= 180;


            var backButton = utilObj.getButton(480, 170, 0.5, 1.0, xPos - 270, yPos,
                constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                    obj: 'introPopup',
                    fn: 'back',
                    screen: screen,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: gameObj.getTrackingPuzzleTheme(),
                        o: constantsObj.TRACK_LEVEL_INTRO,
                        f: constantsObj.TRACK_BACK,
                        g: "",
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            backButton.setColor(constantsObj.COLOR_LIGHT_BLUE);
            //popupNode.addChild(backButton, zOrder);
            utilObj.addChild(popupNode, backButton, zOrder);
            utilObj.getTTFFontLabel("Back", constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 265, yPos - 85, 0.5, 0.5, labelArr, popupNode, zOrder);

            var playButton = utilObj.getButton(480, 170, 0.5, 1.0, xPos + 270, yPos,
                constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                    obj: 'introPopup',
                    fn: 'play',
                    screen: screen,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: gameObj.getTrackingPuzzleTheme(),
                        o: constantsObj.TRACK_LEVEL_INTRO,
                        f: constantsObj.TRACK_PLAY,
                        g: "",
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            playButton.setColor(constantsObj.COLOR_BUTTON_ORANGE);
            //popupNode.addChild(playButton, zOrder);
            utilObj.addChild(popupNode, playButton, zOrder);
            utilObj.getTTFFontLabel(stringsObj.play, constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 240, 85, 0.5, 0.5, labelArr, playButton, zOrder + 1);
            if (!introPopup.w2ePowerConditions()) {
                utilObj.pulseButton(playButton, constantsObj.PULSE_ACTION_TAG, 0);
            }

            if (introPopup.w2ePowerConditions()) {
                gameObj.setVideoBtnSeenOnIntro(true);
                var powerUpTile = utilObj.getScale9Sprite(constantsObj.trans_button, xPos, yPos, 0.5, 0.5, 1000, 400, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
                powerUpTile.setColor(constantsObj.COLOR_GREEN);
                animTime1 = 0;
                popupShownCount += 1;
                // powerUpTile.setVisible(false);

                utilObj.addChild(popupNode, powerUpTile, zOrder + 1);

                var powerUpText = utilObj.getTTFFontLabel("Watch an ad for a free hint on this puzzle!", constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 500, 250, 0.5, 0.5, labelArr, powerUpTile, zOrder + 1);

                w2ePowerUpButton = utilObj.getButton(690, 172, 0.5, 0.5, 500, 100,
                    constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                        obj: 'introPopup',
                        fn: 'playVideo',
                        screen: screen,
                        track: {
                            k: constantsObj.TRACK_DIALOG,
                            p: gameObj.getCurPuzzleTracking(),
                            c: gameObj.getTrackingPuzzleTheme(),
                            o: "w2e_level_intro",
                            f: constantsObj.TRACK_W2E,
                            g: "",
                            s: gameObj.getPuzzleSpeciesTracking(),
                            co: 1,
                            oppId: ""
                        },
                    }, false, ccui.Widget.PLIST_TEXTURE, 1);
                w2ePowerUpButton.setColor(constantsObj.COLOR_GREEN);
                //popupNode.addChild(playButton, zOrder);
                utilObj.addChild(powerUpTile, w2ePowerUpButton, zOrder);
                utilObj.pulseButton(w2ePowerUpButton, constantsObj.PULSE_ACTION_TAG, 0);

                var freeHintText = utilObj.getTTFFontLabel("Get free hint", constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 280, 86, 0.5, 0.5, labelArr, w2ePowerUpButton, zOrder + 1);

                var w2eIcon = utilObj.getSprite(constantsObj.w2eIcon, 600, 86, 0.5, 0.5, constantsObj.SCALE_SPRITE_6, null, w2ePowerUpButton, zOrder, constantsObj.SPRITE_MISC);
                w2eIcon.setOpacity(constantsObj.OPACITY_90);
                utilObj.addChild(w2ePowerUpButton, w2eIcon, zOrder + 1);
                powerUpTile.setVisible(false);
                var params = {
                    tile: powerUpTile,
                    powerUpText: powerUpText,
                    w2ePowerUpButton: w2ePowerUpButton,
                    freeHintText: freeHintText,
                    w2eIcon: w2eIcon,
                    popupShownCount: popupShownCount
                };
                utilObj.delayedCallback(popupLayer, introPopup.w2ePowerUp, 0, params);

                var timerPowerUp = utilObj.getScale9Sprite(constantsObj.trans_button, xPos, yPos - 300, 0.5, 0.5, 600, 100, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
                // timerPowerUp.setColor(constantsObj.COLOR_BLACK);
                utilObj.addChild(popupNode, timerPowerUp, zOrder + 1);

                var offerText = utilObj.getTTFFontLabel("Limited time offer", constantsObj.FONT_ROBOTO_MEDIUM_60, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 330, 50, 0.5, 0.5, labelArr, timerPowerUp, zOrder + 1);

                var timerClock = utilObj.getSprite(constantsObj.timer_clock, 30, 50, 0.5, 0.5, constantsObj.SCALE_SPRITE_41, null, timerPowerUp, zOrder, constantsObj.SPRITE_MISC);
                utilObj.addChild(timerPowerUp, timerClock, zOrder + 1);

                var timerCircle = utilObj.getSprite(constantsObj.white_circle_150, 30, 45, 0.5, 0.5, constantsObj.SCALE_SPRITE_12);
                utilObj.addChild(timerPowerUp, timerCircle, zOrder + 1);
                timerCircle.setColor(constantsObj.COLOR_WHITE_01);

                timerPowerUp.setVisible(false);
                var params = {
                    tile: timerPowerUp,
                    timerClock: timerClock,
                    timerCircle: timerCircle,
                    offerText: offerText
                };
                utilObj.delayedCallback(popupLayer, introPopup.w2eTimerText, 0.5, params);

                gameObj.setPowerUpShownPuzzleId(gameLayer.crosswordDate);
            } else {
                trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), "level_intro_n", constantsObj.TRACK_VIEW, "", gameObj.getPuzzleSpeciesTracking(), "", "");
            }
        }

        popupLayer.popupSetup(screen, false, introPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });
        popupLayer.show(popupHeight, screen, header, popupNode, labelArr, false, undefined, "", "", true);
        gameObj.setLastPuzzleWithIntroId(gameLayer.crosswordDate);
    };

    this.close = function () {
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
        popupShownCount += 1;
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_LEVEL_INTRO, constantsObj.TRACK_CLOSE, "", gameObj.getPuzzleSpeciesTracking(), "", "");
    };

    this.play = function () {
        popupLayer.closeWithDefault();
        cb = ftueObj.checkAndShowWatchToEarnFtue;
        gameObj.trackPuzzleView();
        var id = gameLayer.crosswordDate;
        gameObj.setLastUnlockedPuzzle(gameLayer.crosswordDate);
        gameObj.setDailyMiniIdForCurrentDay(gameLayer.crosswordDate);
        gameObj.unlockPuzzle(id);
        var year = parseInt(id.slice(0, 4));
        popupLayer.popupSetup(screen, false, introPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: true
        });
        // if (introPopup.w2eOptOut) {
        //     introPopup.w2eOptOut = false;
        //     utilObj.delayedCallback(curLayer, optOutLayer.show, 0.5, null);
        // }

        if (year == 0 && gameObj.getMyPackToInprogress() == false) {
            gameObj.setMyPackToInprogress(true);
        }
    };

    this.getLastCb = function () {
        return lastCb;
    };

    this.back = function () {
        cb = gameLayer.back;
        introPopup.w2eOptOut = false;
        //params = {puzzleId: gameLayer.crosswordDate}
        if (gameObj.getUnlockingBonusArchive() && gameObj.getTodaysFreePuzzle() == gameLayer.crosswordDate) {
            gameObj.unlockPuzzle(gameLayer.crosswordDate);
            gameObj.setUnlockingBonusArchive(false);
        }
        popupLayer.closeWithDefault();
    };

    this.w2ePowerUp = function (sender, params) {
        var tile = params.tile;
        if (!utilObj.isNodeValid(tile)) {
            return;
        }
        timeOver = false;
        tile.setVisible(true);
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), "w2e_level_intro", constantsObj.TRACK_VIEW, "", gameObj.getPuzzleSpeciesTracking(), "", "");
        var animTime2 = utilObj.dropShowPowerUp(popupLayer, {
            preDelay: 0,
            node: tile
        });
        var totalTime = animTime1 + runtimeObj.getW2ePowerUpTimer() + 0.3 + 0.45 + 0.2 + 1;
        var params1 = {
            tile: tile,
            preDelay: totalTime,
            powerUpText: params.powerUpText,
            w2ePowerUpButton: params.w2ePowerUpButton,
            freeHintText: params.freeHintText,
            w2eIcon: params.w2eIcon
        };
        utilObj.delayedCallback(popupLayer, introPopup.timeOver, totalTime, params);
        utilObj.delayedCallback(popupLayer, animObj.fadeOutW2eButton, totalTime, params);
    };

    this.hidePowerUp = function (sender, params) {
        if (curScreen == constantsObj.SCREEN_INTRO) {
            var tile = params.tile;
            tile.setVisible(false);
        }
    };

    this.timeOver = function (sender, params) {
        var tile = params.tile;
        if (!utilObj.isNodeValid(tile) || params.popupShownCount != popupShownCount) {
            return;
        }
        w2ePowerUpButton.setVisible(false);
        timeOver = true;
    };

    this.w2eTimerText = function (sender, params) {
        var tile = params.tile;
        if (curScreen == constantsObj.SCREEN_INTRO) {
            tile.setVisible(true);
        }
        animTime1 = utilObj.dropShowPowerUp(popupLayer, {
            preDelay: 0,
            node: tile
        });
        animObj.animateProgressTimer(popupLayer, params);
    };

    this.playVideo = function () {
        if (!utilObj.isOnline()) {
           utilObj.showMessage(stringsObj.error_not_online);
           return;
        }
        if (!timeOver) {
            if (adsObj.checkRewardedVideoAvailable()) {
                gameObj.setVideoPlayedOnOldIntro(true);
                gameObj.setW2ePowerUpVideo(true);
                adsObj.showVideoAd(false, "fromPowerUp");
                gameObj.setNumberOfW2eOnIntro(gameObj.getNumberOfW2eOnIntro() + 1);
                adsObj.setNotRewardedVideo(false);
            }
            introPopup.play();
        }
    };

    this.w2ePowerConditions = function () {
        if (epmObj.getChosenVariant(constantsObj.EXP_W2E_POWER_UP) != constantsObj.EXP_VAR_CONTROL && utilObj.getCurrentTimestamp() - gameObj.getLastW2eTimestamp() > runtimeObj.getW2ePowerUpCoolDown() && adsObj.checkRewardedVideoAvailable() && gameLayer.crosswordDate != gameObj.getInstallDay() && economyObj.getFreeRevealLetters() <= 0) {
            var score = scoresObj.getHighScore(gameLayer.crosswordDate);
            var runtimeForW2eCount = runtimeObj.getW2ePowerUpLimit(0);
            if (gameObj.getIsPayer()) {
                runtimeForW2eCount = runtimeObj.getW2ePowerUpLimit(1);
            }
            var eligibleForW2e = gameObj.getNumberOfW2eOnIntro() < runtimeForW2eCount;
            var installTimeStamp = 0;
            if (gameObj.getInstallTimeStamp() != null) {
                installTimeStamp = gameObj.getInstallTimeStamp();
            }
            var eligibleDay = utilObj.getCurrentTimestamp() - installTimeStamp >= runtimeObj.getW2ePowerUpDayLimit() * constantsObj.SECONDS_IN_DAY;
            var powerUpShownBefore = gameObj.getPowerUpShownPuzzleId(gameLayer.crosswordDate);
            if (score <= 0 && eligibleForW2e && eligibleDay && !powerUpShownBefore) {
                return true;
            }
        }
        return false;
    };

    this.updateScoreLbl = function (sender, params) {
        utilObj.setString(params.lbl, (params.text) + "");
    };

    this.hideGreenCircle = function (sender, params) {
        if (utilObj.isNodeValid(params.node)) {
            utilObj.setColor(params.node, constantsObj.COLOR_WHITE);
        }
    };

};