InviteAndWinPopup = function () {
    var popupNode = null;
    var showWithAnim = true;
    var cb = null;
    var screen = constantsObj.SCREEN_INVITE_AND_WIN;
    var parentScreen = null;

    this.show = function (withAnim) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        // loggerObj.debugLog("Popup Layer", popupLayer);
        popupLayer.checkAndShow(inviteAndWinPopup.delayedShow, null);
    };

    this.delayedShow = function () {
        var labelArr = [];
        var popupHeight = 1630 + constantsObj.POPUP_START_OFFSET;
        parentScreen = curScreen;
        var popupObj = 'inviteAndWinPopup';
        popupNode = new cc.Node();

        var currentTimeStamp = utilObj.getCurrentTimestamp();
        gameObj.setLastInviteAndWinShowTimestamp(currentTimeStamp);

        var yPos = centerYPos + popupHeight / 2 - constantsObj.POPUP_START_OFFSET;
        var xPos = centerXPos;
        var zOrder = constantsObj.UI_Z_ORDER;

        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH, popupHeight - constantsObj.POPUP_START_OFFSET, null, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        //popupNode.addChild(popupBg);
        utilObj.addChild(popupNode, popupBg);

        yPos -= 120;
        var inviteBonus = economyObj.getInviteBonus();
        var textLabel = utilObj.getTTFFontLabel("+" + inviteBonus, constantsObj.FONT_ROBOTO_MEDIUM_90, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 100, yPos, 0.5, 1);
        //popupNode.addChild(textLabel, zOrder);
        utilObj.addChild(popupNode, textLabel, zOrder);

        var coin = utilObj.getSprite(constantsObj.coin_png_2, xPos + 100, yPos - 50, 0.5, 0.5, constantsObj.SCALE_SPRITE_1, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
        //popupNode.addChild(coin);
        utilObj.addChild(popupNode, coin);

        yPos -= 290;
        var coin_stack = utilObj.getSprite(constantsObj.coin_stack, xPos, yPos - 80, 0.5, 0.5, constantsObj.SCALE_SPRITE_13 * 1.5, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
        //popupNode.addChild(coin_stack);
        utilObj.addChild(popupNode, coin_stack);

        yPos -= 370;
        var text = stringsObj.invite_and_win_message;
        text = text.replace("%N%", economyObj.getReferralReward());
        var stringsArr = utilObj.getSplitStringsArr(text, 40);
        for (var i = 0; i < stringsArr.length; i++) {
            var textLabel = utilObj.getTTFFontLabel(stringsArr[i], constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1);
            //popupNode.addChild(textLabel, zOrder);
            utilObj.addChild(popupNode, textLabel, zOrder);
            yPos -= 90;
        }

        yPos -= 60;
        var inviteButton = utilObj.getButton(900, 200, 0.5, 1.0, xPos, yPos,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'inviteAndWinPopup',
                fn: 'invite',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_FB_INVITE,
                    f: constantsObj.TRACK_INVITE,
                    g: utilObj.getScreenName(lastScreen),
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        inviteButton.setColor(constantsObj.COLOR_DARK_BLUE_04);
        utilObj.pulseButton(inviteButton, constantsObj.PULSE_ACTION_TAG, 0);
        //popupNode.addChild(inviteButton, zOrder);
        utilObj.addChild(popupNode, inviteButton, zOrder);

        //utilObj.pulseButton(inviteButton, constantsObj.PULSE_ACTION_TAG, 0);

        utilObj.getTTFFontLabel(stringsObj.invite_and_win_1, constantsObj.FONT_ROBOTO_REGULAR_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 450, 100, 0.5, 0.5, labelArr, inviteButton, zOrder);

        var fbImage = utilObj.getSprite(constantsObj.fb_icon, 100, 100, 0.5, 0.5, constantsObj.SCALE_SPRITE_20 * 1.5, null, inviteButton, zOrder, constantsObj.SPRITE_MISC);
        //inviteButton.addChild(fbImage, zOrder + 1);
        utilObj.addChild(inviteButton, fbImage, zOrder + 1);

        yPos -= 280;
        var continueButton = utilObj.getButton(500, 150, 0.5, 1.0, xPos, yPos,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'inviteAndWinPopup',
                fn: 'continue',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_FB_INVITE,
                    f: constantsObj.TRACK_CONTINUE,
                    g: utilObj.getScreenName(lastScreen),
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        continueButton.setColor(constantsObj.COLOR_BUTTON_LIGHT_BLUE);
        //popupNode.addChild(continueButton, zOrder);
        utilObj.addChild(popupNode, continueButton, zOrder);

        gameObj.setLastScreenOnWhichPopupShown(lastScreen);
        gameObj.setTimeStampForAutoDialogShown(utilObj.getCurrentTimestamp());

        utilObj.getTTFFontLabel(stringsObj.continue, constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - 35, 0.5, 1, labelArr, popupNode, zOrder);

        popupLayer.popupSetup(screen, false, inviteAndWinPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });
        popupLayer.show(popupHeight, screen, stringsObj.invite_and_win_1, popupNode, labelArr, true, null, utilObj.getScreenName(lastScreen));
    };

    this.close = function () {
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.invite = function () {
        inviteAndWinPopup.showMfs();
        machineLearningDataObj.incInviteClicks();
        // popupLayer.setDontGoToLastScreen(true);
        // popupLayer.closeWithDefault();
        trackObj.trackCounter(constantsObj.TRACK_REQUEST, "non_app", "invite", "fb_invite", constantsObj.TRACK_CLICK, "", gameObj.getPuzzleSpeciesTracking(), "", "");
    };

    this.continue = function () {
        popupLayer.closeWithDefault();
    };

    this.showMfs = function () {
        gameObj.setRequestCount(0);
        fbWrapperObj.showDefaultFbInvite(stringsObj.reward_mul_desc_1, stringsObj.multiply_coins);
    };
};