MoreCoinsPopup = function () {
    var popupNode = null;
    var showWithAnim = true;
    var cb = null;
    var screen = constantsObj.SCREEN_MORE_COINS;

    this.show = function (withAnim, callback) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        cb = callback;
        // loggerObj.debugLog("Popup Layer", popupLayer);
        popupLayer.checkAndShow(moreCoinsPopup.delayedShow, null);
    };

    this.delayedShow = function () {
        var labelArr = [];
        var popupHeight = 650 + constantsObj.POPUP_START_OFFSET;
        var spriteArr = [];
        var layoutExperimentVariant = epmObj.getChosenVariant(constantsObj.EXP_LAYOUT);
        popupNode = new cc.Node();

        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2 - constantsObj.POPUP_START_OFFSET;
        var zOrder = constantsObj.UI_Z_ORDER;

        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH, popupHeight - constantsObj.POPUP_START_OFFSET, null, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        //popupNode.addChild(popupBg);
        utilObj.addChild(popupNode, popupBg);

        yPos -= 120;
        var loginButton = utilObj.getButton(700, 170, 0.5, 1.0, xPos + 250, yPos,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'moreCoinsPopup',
                fn: 'login',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_MORE_COIN,
                    f: constantsObj.TRACK_FB_LOGIN,
                    g: "",
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        if (fbWrapperObj.isLoggedIn()) {
            loginButton.setColor(constantsObj.COLOR_LIGHT_GREY_01);
        } else {
            loginButton.setColor(constantsObj.COLOR_BUTTON_LOGIN);
        }
        //popupNode.addChild(loginButton, zOrder);
        utilObj.addChild(popupNode, loginButton, zOrder);
        utilObj.getTTFFontLabel("Login and Play", constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 330, yPos - 45, 0.5, 1, labelArr, popupNode, zOrder);

        var fbIcon = utilObj.getSprite(constantsObj.fb_icon, xPos - 10, yPos - 85, 0.5, 0.5, constantsObj.SCALE_SPRITE_20, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
        //popupNode.addChild(fbIcon, zOrder + 1);
        utilObj.addChild(popupNode, fbIcon, zOrder + 1);

        if (fbWrapperObj.isLoggedIn()) {
            var tick = utilObj.getSprite(constantsObj.tick, xPos - 430, yPos - 90, 0.5, 0.5, constantsObj.SCALE_SPRITE_3);
            tick.setColor(constantsObj.COLOR_BLACK);
            //popupNode.addChild(tick, zOrder + 1);
            utilObj.addChild(popupNode, tick, zOrder + 1);
        } else {
            var fbConnectCash = economyObj.getFbConnectCash();
            var textLabel = utilObj.getTTFFontLabel("+" + fbConnectCash, constantsObj.FONT_ROBOTO_MEDIUM_90, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 330, yPos - 40, 0.5, 1);
            //popupNode.addChild(textLabel, zOrder);
            utilObj.addChild(popupNode, textLabel, zOrder);

            var coin = utilObj.getSprite(constantsObj.coin_png_2, xPos - 530, yPos - 90, 0.5, 0.5, constantsObj.SCALE_SPRITE_11, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            //popupNode.addChild(coin);
            utilObj.addChild(popupNode, coin);
        }

        yPos -= 270;
        var shareButton = utilObj.getButton(700, 170, 0.5, 1.0, xPos + 250, yPos,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'moreCoinsPopup',
                fn: 'spreadTheWord',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_MORE_COIN,
                    f: constantsObj.TRACK_TWTR_SHARE,
                    g: "",
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        shareButton.setColor(constantsObj.COLOR_BUTTON_TWITTER);
        //popupNode.addChild(shareButton, zOrder);
        utilObj.addChild(popupNode, shareButton, zOrder);
        utilObj.getTTFFontLabel("Share on twitter", constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 320, yPos - 45, 0.5, 1, labelArr, popupNode, zOrder);

        var twitterIcon = utilObj.getSprite(constantsObj.twitter_icon, xPos - 10, yPos - 80, 0.5, 0.5, constantsObj.SCALE_SPRITE_6, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
        //popupNode.addChild(twitterIcon, zOrder + 1);
        utilObj.addChild(popupNode, twitterIcon, zOrder + 1);

        var twitterCash = economyObj.getTwitterCash();
        var textLabel = utilObj.getTTFFontLabel("+" + twitterCash, constantsObj.FONT_ROBOTO_MEDIUM_90, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 330, yPos - 40, 0.5, 1);
        //popupNode.addChild(textLabel, zOrder);
        utilObj.addChild(popupNode, textLabel, zOrder);

        var coin = utilObj.getSprite(constantsObj.coin_png_2, xPos - 530, yPos - 90, 0.5, 0.5, constantsObj.SCALE_SPRITE_11, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
        //popupNode.addChild(coin);
        utilObj.addChild(popupNode, coin);

        /*yPos -= 270;
         var gameCenterButton = utilObj.getButton(600, 150, 0.5, 1.0, xPos + 300, yPos,
         constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
         obj: 'moreCoinsPopup',
         fn: 'gameCenter',
         screen: screen,
         track: {
         k: constantsObj.TRACK_DIALOG,
         p: gameObj.getCurPuzzleTracking(),
         c: gameObj.getTrackingPuzzleTheme(),
         o: "",
         f: "",
         g: "",
         s: gameObj.getPuzzleSpeciesTracking(),
         co: 1,
         oppId: ""
         },
         }, false, ccui.Widget.PLIST_TEXTURE, 1);
         gameCenterButton.setColor(constantsObj.COLOR_BUTTON_LIGHT_BLUE);
         popupNode.addChild(gameCenterButton, zOrder);
         utilObj.getTTFFontLabel("Game Center", constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_WHITE,
         constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 350, yPos - 35, 0.5, 1, labelArr, popupNode, zOrder);

         var textLabel = utilObj.getTTFFontLabel("+100", constantsObj.FONT_ROBOTO_MEDIUM_90, constantsObj.COLOR_BLACK,
         constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 300, yPos - 20, 0.5, 1);
         popupNode.addChild(textLabel, zOrder);

         var coin = utilObj.getSprite(constantsObj.coin_png_2, xPos - 500 , yPos - 80 , 0.5, 0.5, constantsObj.SCALE_SPRITE_11, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
         popupNode.addChild(coin);*/

        popupLayer.popupSetup(screen, false, moreCoinsPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });
        popupLayer.show(popupHeight, screen, "More free coins", popupNode, labelArr, true, null, "", "", false, false, false);
    };

    this.close = function () {
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.login = function () {
        if (fbWrapperObj.isLoggedIn()) {
            return;
        }
        fbWrapperObj.login(fbConnectPopup.loginSuccess);
    };

    this.spreadTheWord = function () {
        utilObj.showMessage("Coming Soon!");
        //popupLayer.closeWithDefault();
    };

    this.gameCenter = function () {
        utilObj.showMessage("Coming Soon!");
        //popupLayer.closeWithDefault();
    };
};
