/**
 * Created by navenduayush on 24/06/17.
 */
NotifPermissionPopup = function () {
    var popupNode = null;
    var popupHeight = 0;
    var showWithAnim = true;
    var cb = null;
    var screen = constantsObj.SCREEN_NOTIF_PERMISSION;
    var parentScreen = null;

    this.show = function (withAnim, callback) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        parentScreen = curScreen;
        cb = callback;
        // loggerObj.debugLog("Popup Layer", popupLayer);
        popupLayer.checkAndShow(notifPermissionPopup.delayedShow, null);
    };

    this.delayedShow = function (parentLayer, params) {

        //as in android notif permission is not valid
        if (utilObj.isAndroid()) {
            return;
        }
        var labelArr = [];
        popupNode = new cc.Node();

        var screenName = utilObj.getScreenName(screen);
        var puzLevel = gameObj.getCurPuzzleTracking();
        var zOrder = constantsObj.UI_Z_ORDER;
        var itemHeight = 220;
        var localXPos = 150;

        popupHeight = 1480 + constantsObj.POPUP_START_OFFSET;

        var popupHeader = stringsObj.notif_popup_header;

        var yPos = centerYPos + popupHeight / 2 - constantsObj.POPUP_START_OFFSET;
        var xPos = centerXPos;
        gameObj.setTimeStampForAutoDialogShown(utilObj.getCurrentTimestamp());

        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, centerXPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH, popupHeight - constantsObj.POPUP_START_OFFSET);
        //popupNode.addChild(popupBg);
        utilObj.addChild(popupNode, popupBg);

        yPos -= 130;

        //var imageBg = utilObj.getSprite(constantsObj.rounded_4, centerXPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_22, null, popupBg, zOrder + 1, constantsObj.SPRITE_MISC);
        var imageBg = utilObj.getScale9Sprite(constantsObj.rounded_4, centerXPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH - 120, 720);
        imageBg.setColor(constantsObj.COLOR_LIGHT_GREY_01);
        //popupNode.addChild(imageBg, zOrder);
        utilObj.addChild(popupNode, imageBg, zOrder);

        var topLbl = utilObj.getTTFFontLabel("Get " + economyObj.getAllowNotifsReward() + " ", constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 100, yPos - 40, 0.5, 1, labelArr, popupNode, zOrder);
        topLbl.setScale(1.5);

        var coin_icon = utilObj.getSprite(constantsObj.coin_png_2, xPos + 165, yPos - 100, 0.5, 0.5, constantsObj.SCALE_SPRITE_19, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
        //popupNode.addChild(coin_icon, zOrder);
        utilObj.addChild(popupNode, coin_icon, zOrder);


        var coin_stack = utilObj.getSprite(constantsObj.coin_stack, xPos, yPos - 460, 0.5, 0.5, constantsObj.SCALE_SPRITE_13 * 1.5, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
        //popupNode.addChild(coin_stack, zOrder);
        utilObj.addChild(popupNode, coin_stack, zOrder);

        var text = stringsObj.notif_popup_text;

        yPos -= 800;

        utilObj.getTTFFontLabel(text, constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);
        yPos -= 80;
        utilObj.getTTFFontLabel("get ", constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 200, yPos, 0.5, 1, labelArr, popupNode, zOrder);

        utilObj.getTTFFontLabel(" " + economyObj.getAllowNotifsReward() + " FREE coins !", constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 100, yPos, 0.5, 1, labelArr, popupNode, zOrder);
        yPos -= 80;


        var buttonWidth = (constantsObj.POPUP_WIDTH - 300) / 2;

        var xPosShift = (buttonWidth) / 2 + 40;

        yPos -= 120;

        var laterButton = utilObj.getButton(buttonWidth, 170, 0.5, 1.0, xPos - xPosShift, yPos,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'notifPermissionPopup',
                fn: 'later',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_NOTIF_PERMISSION_1,
                    f: stringsObj.later,
                    g: utilObj.getScreenName(parentScreen),
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        laterButton.setColor(constantsObj.COLOR_BUTTON_ORANGE);
        //popupNode.addChild(laterButton, zOrder);
        utilObj.addChild(popupNode, laterButton, zOrder);
        utilObj.getTTFFontLabel(stringsObj.maybe_later, constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), buttonWidth / 2, 85, 0.5, 0.5, labelArr, laterButton, zOrder);

        var allowButton = utilObj.getButton(buttonWidth, 170, 0.5, 1.0, xPos + xPosShift, yPos,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'notifPermissionPopup',
                fn: 'allow',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_NOTIF_PERMISSION_1,
                    f: stringsObj.yes,
                    g: utilObj.getScreenName(parentScreen),
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        allowButton.setColor(constantsObj.COLOR_BUTTON_LIGHT_BLUE);
        //popupNode.addChild(allowButton, zOrder);
        utilObj.addChild(popupNode, allowButton, zOrder);
        utilObj.getTTFFontLabel(stringsObj.yes, constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), buttonWidth / 2, 85, 0.5, 0.5, labelArr, allowButton, zOrder);
        utilObj.pulseButton(allowButton, constantsObj.PULSE_ACTION_TAG, 0);


        popupLayer.popupSetup(screen, false, notifPermissionPopup.close(), null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });
        popupLayer.show(popupHeight, screen, popupHeader, popupNode, labelArr, true, "", utilObj.getScreenName(parentScreen));
    };

    this.close = function () {
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.allow = function () {
        if (parentScreen == constantsObj.SCREEN_ACHIEVEMENTS) {
            popupLayer.setPopupCallback(achievementsLayer.redraw, null);
        } else if (parentScreen == constantsObj.SCREEN_HOME) {
            popupLayer.setPopupCallback(homeLayer.redraw, null);
        } else if (parentScreen == constantsObj.SCREEN_CALENDAR) {
            popupLayer.setPopupCallback(calendarLayer.redraw, null);
        } else if (parentScreen == constantsObj.SCREEN_GAME) {
            popupLayer.setPopupCallback(gameLayer.redrawWithoutPopping, null);
        }
        popupLayer.closeWithDefault();
        if (!gameObj.getNotifPermissionForIos()) {
            gameObj.setNotifPermissionForIos(true);
            utilObj.checkForNotifPermission();
        } else {
            utilObj.redirectToSettings();
        }
    };

    this.later = function () {
        popupLayer.closeWithDefault();
    };

}
