PrivacyPolicyPopup = function () {
    var popupNode = null;
    var showWithAnim = true;
    var cb = null;
    var lastScreen = null;
    var screen = constantsObj.SCREEN_PRIVACY_POLICY;
    var trackingSentForCCPA = false;

    this.show = function (parentLayer, withAnim, callback) {
        lastScreen = parentLayer;
        if (!privacyPolicyPopup.canShowPrivacyPolicy()) {
            loggerObj.debugLog("Privacy - privacy can show returned as true");
            if(!trackingSentForCCPA) {
                trackObj.trackDialog(constantsObj.TRACK_GDPR_HIDE, constantsObj.TRACK_VIEW, userObj.getUserCountry(), userObj.getApplicablePrivacyLaw());
                trackingSentForCCPA = true;
            }
            return;
        }
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        cb = callback;
        params = {};
        params.pLayer = parentLayer;
        trackObj.trackDialog(constantsObj.TRACK_GDPR, constantsObj.TRACK_VIEW, userObj.getUserCountry(), "");
        // loggerObj.debugLog("Popup Layer", popupLayer);
        popupLayer.checkAndShow(privacyPolicyPopup.delayedShow, params);
    };

    this.delayedShow = function (parentLayer, params) {
        var labelArr = [];
        var popupHeight = 1100 ;

        popupNode = new cc.Node();
        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2 ;
        var zOrder = constantsObj.UI_Z_ORDER;
        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH - 100, popupHeight , null, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        utilObj.addChild(popupNode, popupBg);
        var headerText = "Welcome!";
        var text = stringsObj.privacy_policy;

        yPos -= 380;


        var stringsArr = utilObj.getSplitStringsArr(text, 32);
        for (var i = 0; i < stringsArr.length; i++) {
            var colorTxt = constantsObj.COLOR_BLACK;
            if (i == 2) {
                colorTxt = constantsObj.COLOR_GREEN;
            }
             var text1 = utilObj.getBMFontLabel(stringsArr[i], constantsObj.FONT_HELVETICA_70, colorTxt,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);

            if (i == 2) {
                var privacyLinkBtn = utilObj.getButton(500, 90, 0.5, 1.0, xPos, yPos,
                    constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                        obj: 'privacyPolicyPopup',
                        fn: 'showPrivacy',
                        screen: screen,
                        track: {
                            k: constantsObj.TRACK_DIALOG,
                            p: gameObj.getCurPuzzleTracking(),
                            c: gameObj.getTrackingPuzzleTheme(),
                            o: "privacy_terms",
                            f: constantsObj.TRACK_OKAY_BUTTON,
                            g: utilObj.getScreenName(params.pLayer),
                            s: gameObj.getPuzzleSpeciesTracking(),
                            co: 1,
                            oppId: ""
                        },
                    }, false, ccui.Widget.PLIST_TEXTURE, 1);
                utilObj.addChild(popupNode, privacyLinkBtn, zOrder);
            }

            yPos -= 80;
        }
        text1.setScale(11 / 12);

        if (utilObj.isIos()) {
            yPos -= 130;
        } else {
            yPos -= 140;
        }


        yPos -= 10;
        var okButton = utilObj.getButton(700, 170, 0.5, 1.0, xPos, yPos,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'privacyPolicyPopup',
                fn: 'okay',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: "gdpr",
                    f: constantsObj.TRACK_OKAY_BUTTON,
                    g: utilObj.getScreenName(params.pLayer),
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        okButton.setColor(constantsObj.COLOR_GREEN);
        utilObj.addChild(popupNode, okButton, zOrder);
        utilObj.getBMFontLabel(stringsObj.privay_policy_cta, constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 350, 85, 0.5, 0.5, labelArr, okButton, zOrder);
        utilObj.pulseButton(okButton, constantsObj.PULSE_ACTION_TAG, 0);

        popupLayer.popupSetup(screen, false, privacyPolicyPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });
        popupLayer.show(popupHeight, screen, headerText, popupNode, labelArr, false, null, "", "", false, false, false, null, null, null, null, null, true);
    };

    this.close = function () {
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
        ftueObj.hideWatchToEarnFtue();
    };

    this.okay = function () {
        /*if (adsObj.checkRewardedVideo(false)) {
            adsObj.showVideoAd(false);
        } else {
            utilObj.showMessage("No Video Available. Please watch after some time")
        }*/
        trackObj.trackDialog(constantsObj.TRACK_GDPR, constantsObj.TRACK_ACCEPT, userObj.getUserCountry(), "");
        userObj.acceptPrivacyPolicy();
        gameObj.setPrivacyPolicyPopupShown(true);
        psMopubAdsObj.grantMopubConsent();
        popupLayer.closeWithDefault();
    };

    this.privacyPolicy = function (params) {
        // loggerObj.debugLog("cheking prev layer", params.pLayer);
        popupLayer.setDontGoToLastScreen(true);
        popupLayer.setPopupCallback(privacyPolicyPopup.showPrivacy, params);
        popupLayer.closeWithDefault();
        // loggerObj.debugLog("cheking prev layer12", params.pLayer);
    };

    this.showPrivacy = function (params) {
        // supportLayer.init();
        // // loggerObj.debugLog("cheking prev layer13", params.pLayer);
        // if (params.pLayer == constantsObj.SCREEN_HOME) {
        //     homeLayer.hide();
        // } else if (params.pLayer == constantsObj.SCREEN_GAME) {
        //     gameLayer.removeAllChildren();
        //     gameLayer.setVisible(false);
        // } else if (params.pLayer == constantsObj.SCREEN_CALENDAR) {
        //     calendarLayer.hide();
        // } else if (params.pLayer == constantsObj.SCREEN_PACK_INFO_LAYER) {
        //     packInfoLayer.hide();
        // } else if (params.pLayer == constantsObj.SCREEN_ACHIEVEMENTS) {
        //     achievementsLayer.hide();
        // } else if (params.pLayer == constantsObj.SCREEN_PACK_LAYER) {
        //     packsLayer.hide();
        // }
        // // loggerObj.debugLog("cheking prev layer14", params.pLayer);
        // supportLayer.show("privacy_policy", params);

        utilObj.openUrl(constantsObj.PLAY_SIMPLE_PRIVACY_URL);
    };

    this.canShowPrivacyPolicy = function () {

        if (!(popupLayer.popupOpen == false || lastScreen == constantsObj.SCREEN_QUIT)) {
            loggerObj.debugLog("Privacy - privacy condition not satisfied for popup:" , popupLayer.popupOpen, lastScreen);
            return false;
        }

        if (gameObj.getPrivacyPolicyPopupShown()) {
            loggerObj.debugLog("Privacy - privacy was accepted by user in gdpr before");
            return false;
        }

        // if (!userObj.getPrivacyPolicyStatus()) {
        //     return true;
        // }

        return true;
    };

    this.back = function () {
        if (gameObj.getToasterShown() == false) {
            utilObj.showMessage("Please click OK to continue.");
            gameObj.setToasterShown(true);
            return;
        }
        else {
            if (utilObj.isAndroid()) {
                popupLayer.closeWithDefault();
                quitPopup.show(constantsObj.SCREEN_PRIVACY_POLICY);
                return;
            }
        }
        return;
    };
};