QuestMilestonePopup = function () {

    var showWithAnim = true;
    var popupNode = null;
    var cb = null;
    var screen = constantsObj.SCREEN_QUEST_MILESTONE;
    var milestoneUnlocked = false;
    var startMilestone = -1;
    var collectibleName = "";
    var bucket = 0;

    this.show = function (withAnim, params) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        questMilestonePopup.delayedShow(params);
    };

    this.delayedShow = function (params) {
        questMapLayer.scrollView.setTouchEnabled(false);
        startMilestone = -1;
        if (params.mileStoneNum != undefined) {
            startMilestone = params.mileStoneNum;
        }
        if (startMilestone == -1) {
            utilObj.showMessage("milestone is locked");
            return;
        }
        var popupHeight = 1350;// + constantsObj.POPUP_START_OFFSET;
        var popupWidth = constantsObj.NEW_POPUP_WIDTH;
        var labelArr = [];
        var spriteArr = [];
        popupNode = new cc.Node();
        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2;
        var zOrder = constantsObj.UI_Z_ORDER;
        var headerText = "Milestone Discovered";
        milestoneUnlocked = questMapObj.getIsMilestoneDiscovered(startMilestone);
        collectibleName = "";
        if (!milestoneUnlocked) {
            popupHeight += 50;
        }

        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, popupWidth, popupHeight, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        bucket = questMapObj.getBucketAllocated();
        var str = bucket + "_" + questMapLayer.curLevelNum;


        if (milestoneUnlocked) {

            yPos -= 230 + 200 + 50;
            var eligibleForTq = false;
            var quest_exp = gameObj.getExpNewWeeklyQuestVariant();
            var themedQuestData = themedQuestObj.getThemedQuestData();
            var timeSt = gameObj.getLastSync();
            if (timeSt >= themedQuestData["start"] && timeSt <= themedQuestData["end"] && !gameObj.getIsThemedQuestLocked() && epmObj.getChosenVariant(constantsObj.EXP_THEMED_QUEST) == constantsObj.EXP_VAR_1) {
                eligibleForTq = true;
            }
            var now = new Date();
            var year = questMapObj.y2k(now.getYear());
            var month = now.getMonth();
            var date = now.getDate();
            var weekNum = questMapObj.getWeek(year, month, date);
            var milestoneImage = questMapObj.getMilestoneImage(year, weekNum, quest_exp, startMilestone);
            var description = questMapObj.getMilestoneDescription(year, weekNum, quest_exp, startMilestone);
            var themeName = questMapObj.getMilestoneTheme(year, weekNum, quest_exp);
            collectibleName = questMapObj.getMilestoneCollectible(year, weekNum, quest_exp, startMilestone);
            headerText = collectibleName;
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "MS_discovered",constantsObj.TRACK_VIEW, bucket + "_" + questMapLayer.curLevelNum , startMilestone + "_" + collectibleName, "", "");
            if (eligibleForTq) {
                var tqData = questMapObj.getTqData();
                var imageType = "vector";
                if(quest_exp == constantsObj.EXP_VAR_2){
                    imageType = "realistic";
                }
                milestoneImage = milestoneImage;
                description = description;
                themeName = themeName;
                headerText = collectibleName;
            }
            var lockOuterCircle = utilObj.getSprite(constantsObj.circle_progress, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_17, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
            utilObj.setColor(lockOuterCircle, constantsObj.COLOR_QUEST_MILESTONE);

            var lockInnerCircle = utilObj.getSprite(constantsObj.circle_progress, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_17 * 0.9, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
            utilObj.setColor(lockInnerCircle, constantsObj.COLOR_WHITE);

            var milestoneIcon = utilObj.getSprite(milestoneImage, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_11, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
            //utilObj.setColor(lockIcon, constantsObj.COLOR_QUEST_LOCK_ICON);

            yPos -= 200 + 115;
            var textArr = utilObj.getSplitStringsArr(description, 35);
            for (var i = 0; i < textArr.length; i++) {
                var subText = utilObj.getBMFontLabel(textArr[i], constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, popupNode, zOrder);
                utilObj.setOpacity(subText, constantsObj.OPACITY_90);
                yPos -= 70;
            }

            yPos = centerYPos - popupHeight / 2;
            yPos += 160;
            var greatButton = utilObj.getButton(500, 170, 0.5, 0.5, xPos, yPos,
                constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                    obj: 'questMilestonePopup',
                    fn: 'great',
                    screen: screen,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: "",
                        c: "",
                        o: "MS_discovered",
                        f: constantsObj.TRACK_OKAY_BUTTON,
                        g: str,
                        s: startMilestone,
                        co: "",
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            greatButton.setColor(constantsObj.COLOR_BUTTON_GREEN);
            utilObj.addChild(popupNode, greatButton, zOrder);
            //utilObj.pulseButton(startButton, constantsObj.PULSE_ACTION_TAG, 0);
            var greatText = "Great!";
            var okayButtonTxt = utilObj.getBMFontLabel(greatText, constantsObj.FONT_HELVETICA_MEDIUM_80, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, popupNode, zOrder);
        } else {
            var now = new Date();
            var year = questMapObj.y2k(now.getYear());
            var month = now.getMonth();
            var date = now.getDate();
            var weekNum = questMapObj.getWeek(year, month, date);
            var quest_exp = gameObj.getExpNewWeeklyQuestVariant();
            collectibleName = questMapObj.getMilestoneCollectible(year, weekNum, quest_exp, startMilestone);

            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "MS_locked",constantsObj.TRACK_VIEW, bucket + "_" + questMapLayer.curLevelNum , startMilestone + "_" + collectibleName, "", "");

            headerText = "Almost there!";
            yPos -= 230 + 60;
            var textStr = questMapObj.getMilestonePopupText(year, weekNum, quest_exp);
            var textArr = utilObj.getSplitStringsArr(textStr, 35);

            for (var i = 0; i < textArr.length; i++) {
                utilObj.getBMFontLabel(textArr[i], constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, popupNode, zOrder);
                yPos -= 70;
            }
            yPos -= 80 + 250;

            var lockOuterCircle = utilObj.getSprite(constantsObj.circle_progress, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_2, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
            utilObj.setColor(lockOuterCircle, constantsObj.COLOR_QUEST_LOCK_ICON);

            var lockInnerCircle = utilObj.getSprite(constantsObj.circle_progress, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_2 * 0.9, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
            utilObj.setColor(lockInnerCircle, constantsObj.COLOR_WHITE);

            var lockIcon = utilObj.getSprite(constantsObj.lock_quest, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
            utilObj.setColor(lockIcon, constantsObj.COLOR_QUEST_LOCK_ICON);

            yPos -= 250 + 150 + 30;
            var okayButton = utilObj.getButton(500, 160, 0.5, 0.5, xPos, yPos,
                constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                    obj: 'questMilestonePopup',
                    fn: 'okay',
                    screen: screen,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: "",
                        c: "",
                        o: "MS_locked",
                        f: constantsObj.TRACK_OKAY_BUTTON,
                        g: str,
                        s: startMilestone,
                        co: "",
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            okayButton.setColor(constantsObj.COLOR_BUTTON_GREEN);
            utilObj.addChild(popupNode, okayButton, zOrder);
            //utilObj.pulseButton(startButton, constantsObj.PULSE_ACTION_TAG, 0);
            var okayText = "Let's Play!";
            var okayButtonTxt = utilObj.getBMFontLabel(okayText, constantsObj.FONT_HELVETICA_MEDIUM_80, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, popupNode, zOrder);
        }

        utilObj.addSprites(spriteArr);
        // utilObj.addLabels(labelArr);


        popupLayer.popupSetup(screen, false, questMilestonePopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });

        popupLayer.show(popupHeight, screen, headerText, popupNode, labelArr, true, null, null, null, null, null, null, null, null, null, null, null, true);
    };

    this.close = function () {
        questMapLayer.scrollView.setTouchEnabled(true);
        if (milestoneUnlocked) {
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "MS_discovered",constantsObj.TRACK_CLOSE, bucket + "_" + questMapLayer.curLevelNum , startMilestone + "_" + collectibleName, "", "");
        } else {
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "MS_locked",constantsObj.TRACK_CLOSE, bucket + "_" + questMapLayer.curLevelNum , startMilestone + "_" + collectibleName, "", "");
        }
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.great = function () {
        questMapLayer.scrollView.setTouchEnabled(true);
        popupLayer.closeWithDefault();
    };

    this.okay = function () {
        questMapLayer.scrollView.setTouchEnabled(true);
        popupLayer.closeWithDefault();
        questMapLayer.redirectToCurLevel();
    };
};