QuestPuzzleUnlockPopup = function () {

    var showWithAnim = true;
    var popupNode = null;
    var cb = null;
    var screen = constantsObj.SCREEN_QUEST_PUZZLE_UNLOCK;
    var tickIcon = null;
    var checkBox = null;
    var isBonusArchive = false;
    var isMiniOrMidi = false;
    var completedPuzzle = false;
    var storeArr = [];
    this.show = function (withAnim, params) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        questPuzzleUnlockPopup.delayedShow(params);
    };
    this.delayedShow = function (params) {
        questMapLayer.scrollView.setTouchEnabled(false);
        var puzzleId = "0";
        var puzzleCost = 0;
        var type = "";
        if (params.id != undefined) {
            puzzleId = params.id.toString();
        }
        if (params.type != undefined) {
            type = params.type;
        }
        if (params.price != undefined) {
            puzzleCost = params.price;
        }
        var headerText = "Milestone Locked";
        isMiniOrMidi = gameObj.checkForMiniOrMidi(puzzleId);
        if (puzzleId == "0") {
            return;
        }
        isBonusArchive = false;
        var popupHeight = 1400;// + constantsObj.POPUP_START_OFFSET;
        var popupWidth = constantsObj.NEW_POPUP_WIDTH;
        var labelArr = [];
        var spriteArr = [];
        popupNode = new cc.Node();
        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2;
        var zOrder = constantsObj.UI_Z_ORDER;
        var puzzleState = questMapObj.getPuzStateById(puzzleId);
        var inProgress = gameObj.getInProgress();
        completedPuzzle = false;
        if (puzzleState == constantsObj.STATE_PUZ_COMPLETED && inProgress[puzzleId] == undefined) {
            completedPuzzle = true;
        }
        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, popupWidth, popupHeight, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);

        // if not same then milestone locked popup else puzzle unlock popup
        yPos -= 230 + 200 + 50;
        var textStr = "Unlock this Themed Archive for %N% coins?";
        var unlockText = "Unlock";
        headerText = "";
        textStr = textStr.replace("%N%", puzzleCost);
        var textArr = utilObj.getSplitStringsArr(textStr, 30);
        var dateForId = utilObj.getDateForId(puzzleId);
        var todayDate = utilObj.getFormattedDate(dateForId);
        var weekDay = dateForId.getDay();
        var themeIcon = constantsObj.LOGO_FOR_DAYS_NEW_ICON[weekDay];
        var themeColor = constantsObj.COLOR_FOR_WEEK_THEMES_NEW[weekDay];
        headerText = stringsObj.puzzle_themes[weekDay];
        var circleScale = constantsObj.SCALE_SPRITE_3;
        var yShift = 0;
        if (type == constantsObj.BONUS_ARCHIVE) {
            isBonusArchive = true;
        }

        if (weekDay == 0 || weekDay == 3) {
            yShift = 10;
            circleScale = constantsObj.SCALE_SPRITE_3 * 1.1 * 0.8;
        } else if (weekDay == 1 || weekDay == 2 || weekDay == 4 || weekDay == 5 || weekDay == 6) {
            yShift = 10;
            circleScale = constantsObj.SCALE_SPRITE_3 * 1.1;
        }
        if (isBonusArchive) {
            textStr = "Unlock this Themed Archive for a short video?";
            textStr = textStr.replace("%N%", puzzleCost);
            textArr = utilObj.getSplitStringsArr(textStr, 30);
        }
        if (isMiniOrMidi) {
            headerText = "Mini From Archive";
            textStr = "Unlock this mini Archive for %N% coins?";
            textStr = textStr.replace("%N%", puzzleCost);
            textArr = utilObj.getSplitStringsArr(textStr, 30);
            var archiveId = gameObj.convertDailyMiniIdToArchive(puzzleId);
            dateForId = utilObj.getDateForId(archiveId);
            todayDate = utilObj.getFormattedDate(dateForId);
            weekDay = dateForId.getDay();
            themeIcon = constantsObj.mini_pack_icon;
            themeColor = constantsObj.COLOR_BONUS_MINI_BG;
            circleScale = constantsObj.SCALE_SPRITE_35;
            yShift = 0;
        }

        if (completedPuzzle) {
            headerText = "Completed puzzle!";
            if  (isMiniOrMidi) {
                textStr = "No incomplete puzzle left. Replay?";
                var isDailyMini = gameObj.checkForDailyMini(puzzleId);
                if (!isDailyMini) {
                    var packId = gameObj.getPackIdFromPuzzleId(puzzleId);
                    todayDate = "Pack of Minis";
                    if (packId != -1) {
                        themeIcon = constantsObj.LOGO_FOR_DAYS_PACK[packId];
                        circleScale = constantsObj.SCALE_SPRITE_1 * constantsObj.MINI_PACK_INFO[packId]["circleScale"];
                        if (packId == constantsObj.INTRODUCING_MINIS) {
                            themeIcon = constantsObj.introducingMini_icon;
                            circleScale = circleScale * 1.5;
                        }
                    }
                }
            } else {
                textStr = "No incomplete puzzles left. Replay for %N% coins?";
                puzzleCost = economyObj.getReplayCrosswordCost();
                textStr = textStr.replace("%N%", puzzleCost);
            }
            textArr = utilObj.getSplitStringsArr(textStr, 30);
        }

        var iconBg = utilObj.getSprite(constantsObj.iconHolder, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_35, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setColor(iconBg,themeColor);
        var icon = utilObj.getSprite(themeIcon, xPos, yPos + yShift, 0.5, 0.5, circleScale, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);

        yPos -= 200 + 50;
        var formattedDate = utilObj.getBMFontLabel(todayDate, constantsObj.FONT_HELVETICA_55, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, popupNode, zOrder);
        utilObj.setOpacity(formattedDate, constantsObj.OPACITY_60);

        yPos -= 100;
        for (var i = 0; i < textArr.length; i++) {
            utilObj.getBMFontLabel(textArr[i], constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, popupNode, zOrder);
            utilObj.setOpacity(textArr[i], constantsObj.OPACITY_90);
            yPos -= 70;
        }

        yPos -= 100;
        var unlockButton = utilObj.getButton(570, 170, 0.5, 0.5, xPos, yPos,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'questPuzzleUnlockPopup',
                fn: 'unlock',
                screen: screen,
                params: {puzzleId: puzzleId, puzzleCost: puzzleCost},
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: "",
                    c: "",
                    o: screen,
                    f: "Unlock",
                    g: "",
                    s: "",
                    co: "",
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        unlockButton.setColor(constantsObj.COLOR_BUTTON_GREEN);
        utilObj.addChild(popupNode, unlockButton, zOrder);
        if (isBonusArchive) {
            var unlockButtonTxt = utilObj.getBMFontLabel(unlockText, constantsObj.FONT_HELVETICA_MEDIUM_80, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos - 80, yPos, 0.5, 0.5, labelArr, popupNode, zOrder);
            var unlockTextDimensions = utilObj.getSpriteDimensions(unlockButtonTxt);
            var videoIcon = utilObj.getSprite(constantsObj.w2eIcon, xPos - 80 + unlockTextDimensions.width / 2 + 50, yPos, 0, 0.5, constantsObj.SCALE_SPRITE_6, spriteArr, popupNode, zOrder);
        } else {
            if (completedPuzzle && puzzleCost == 0) {
                var unlockButtonTxt = utilObj.getBMFontLabel(unlockText, constantsObj.FONT_HELVETICA_MEDIUM_80, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, popupNode, zOrder);
            } else {
                var unlockButtonTxt = utilObj.getBMFontLabel(unlockText, constantsObj.FONT_HELVETICA_MEDIUM_80, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos - 90, yPos, 0.5, 0.5, labelArr, popupNode, zOrder);
                var unlockTextDimensions = utilObj.getSpriteDimensions(unlockButtonTxt);
                var coinIcon = utilObj.getSprite(constantsObj.coin_png_2, xPos - 90 + unlockTextDimensions.width / 2 + 20, yPos - 5, 0, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, popupNode, zOrder);
                var coinIconDimension = utilObj.getSpriteDimensions(coinIcon);
                var coinIconPositionX = utilObj.getPositionX(coinIcon);
                var unlockButtonTxt = utilObj.getBMFontLabel(puzzleCost, constantsObj.FONT_HELVETICA_MEDIUM_80, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), coinIconPositionX + coinIconDimension.width + 10, yPos, 0, 0.5, labelArr, popupNode, zOrder);

                // show store icon highlighted
                var localXPos = xRightPos - 30;
                var localYPos = constantsObj.DESIGN_HEIGHT + topBarOffset - 70;
                var xShiftTemp = 200;
                storeArr = [];
                var coinBgWhite = utilObj.getScale9Sprite(constantsObj.tile_white, localXPos - (350 + xShiftTemp), localYPos, 0, 0.5, 300, 80, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
                utilObj.setColor(coinBgWhite, constantsObj.COLOR_GREY_QUEST);
                storeArr.push(coinBgWhite);
                var coinBgWhiteSmall = utilObj.getScale9Sprite(constantsObj.tile_white, localXPos - (350 + xShiftTemp) + 300, localYPos, 0, 0.5, 20, 10, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
                utilObj.setColor(coinBgWhiteSmall, constantsObj.COLOR_GREY_QUEST);
                storeArr.push(coinBgWhiteSmall);
                var coinImg = utilObj.getSprite(constantsObj.coin_png_2, localXPos - (350 + xShiftTemp), localYPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);
                storeArr.push(coinImg);
                var coinCount = economyObj.getCash();
                var cashLbl = utilObj.getBMFontLabel(coinCount + "", constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos - (210 + xShiftTemp), localYPos, 0.5, 0.5, labelArr, popupNode, zOrder + 1);
                storeArr.push(cashLbl);
                var plusImg = utilObj.getSprite(constantsObj.green_plus, localXPos - (100 + xShiftTemp), localYPos, 0, 0.5, constantsObj.SCALE_SPRITE_1 * 1.1, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);
                storeArr.push(plusImg);

                // fade in anim for store variables
                for (var i = 0; i < storeArr.length; i++) {
                    utilObj.setOpacity(storeArr[i], constantsObj.OPACITY_0);
                    var initDelay = utilObj.getDelayTime(1);
                    var fadeIn = utilObj.getFadeTo(0.05, constantsObj.OPACITY_100).easing(new cc.easeIn(1.0));
                    var seq = new cc.Sequence([initDelay, fadeIn]);
                    animObj.runAction(storeArr[i], seq);
                }
            }
        }

        yPos -= 220;
        var checkBoxText = utilObj.getBMFontLabel("Don't ask again", constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos + 80, yPos, 0.5, 0.5, labelArr, popupNode, zOrder);
        utilObj.setOpacity(checkBoxText, constantsObj.OPACITY_50);
        var checkBoxTextDimensions = utilObj.getSpriteDimensions(checkBoxText);
        var checkBoxPositionX = xPos + 80 - checkBoxTextDimensions.width / 2 - 80;
        checkBox = utilObj.getScale9Sprite(constantsObj.rounded_4, checkBoxPositionX, yPos, 0.5, 0.5, 90, 90, spriteArr, popupNode, zOrder);
        utilObj.setColor(checkBox, constantsObj.COLOR_BLUE_08);
        var tickButton = utilObj.getButton(100 + checkBoxTextDimensions.width + 100, 150, 0, 0.5, checkBoxPositionX - 50, yPos,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'questPuzzleUnlockPopup',
                fn: 'select',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.SCREEN_NAMES[screen],
                    f: constantsObj.TRACK_VIEW_TICK,
                    g: constantsObj.SCREEN_GAME,
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE);
        utilObj.addChild(popupNode, tickButton, zOrder);
        tickIcon = utilObj.getSprite(constantsObj.tick, checkBoxPositionX, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_7, spriteArr, popupNode, zOrder);
        utilObj.setColor(tickIcon, constantsObj.COLOR_WHITE);

        utilObj.addSprites(spriteArr);
        // utilObj.addLabels(labelArr);

        popupLayer.popupSetup(screen, false, questPuzzleUnlockPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });

        popupLayer.show(popupHeight, screen, headerText, popupNode, labelArr, true, null, null, null, null, null, null, null, null, null, null, null, true);
    };

    this.close = function () {
        // popupLayer.dontGoToLastScreen = false;
        //popupLayer.closeWithDefault();
        // var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
        // var trackO = constantsObj.TRACK_WQ + "easy";
        // if ((weeklyQuestExp == constantsObj.EXP_VAR_3 || weeklyQuestExp == constantsObj.EXP_VAR_4) && gameObj.getWeeklyQuestLastWeekMastery() >= runtimeObj.getWeeklyQuestMasteryLimit()) {
        //     trackO = constantsObj.TRACK_WQ + "hard";
        // }
        // trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", trackO, constantsObj.TRACK_CLOSE, "", "", "", "");
        // fade out anim for store variables
        for (var i = 0; i < storeArr.length; i++) {
            // utilObj.setOpacity(storeArr[i], constantsObj.OPACITY_0);
            var initDelay = utilObj.getDelayTime(0);
            var fadeIn = utilObj.getFadeTo(0.05, constantsObj.OPACITY_0).easing(new cc.easeIn(1.0));
            var seq = new cc.Sequence([initDelay, fadeIn]);
            animObj.runAction(storeArr[i], seq);
        }
        questMapLayer.scrollView.setTouchEnabled(true);
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.select = function () {
        questMapLayer.scrollView.setTouchEnabled(true);
        if (popupNode && utilObj.isNodeValid(popupNode)) {
            if (utilObj.isNodeValid(tickIcon) && utilObj.isNodeValid(checkBox)) {
                var vis = !tickIcon.isVisible();
                tickIcon.setVisible(vis);
                if (vis) {
                    checkBox.setColor(constantsObj.COLOR_BLUE_08);
                } else {
                    checkBox.setColor(constantsObj.COLOR_GREY_08);
                }
            }
        }
    };

    this.unlock = function (params) {
        questMapLayer.scrollView.setTouchEnabled(true);
        var puzzleId = "0";
        var puzzleCost = 0;
        if (params.puzzleId != undefined) {
            puzzleId = params.puzzleId.toString();
        }
        if (params.puzzleCost != undefined) {
            puzzleCost = params.puzzleCost;
        }
        popupLayer.popupSetup(screen, false, questPuzzleUnlockPopup.close, null, showWithAnim, {
            noAnim: true,
            dontGoToLastScreen: false
        });
        var vis = tickIcon.isVisible();
        if (isMiniOrMidi) {
            if (completedPuzzle) {
                questPuzzleUnlockPopup.replay("fromQuest", puzzleId);
                if (vis) {
                    gameObj.setQuestCompMiniConfirmationPopup(1);
                } else {
                    gameObj.setQuestCompMiniConfirmationPopup(0);
                }
            } else {
                questPuzzleUnlockPopup.loadMiniPuzzle(puzzleId, puzzleCost);
                if (vis) {
                    gameObj.setQuestMiniConfirmationPopup(1);
                } else {
                    gameObj.setQuestMiniConfirmationPopup(0);
                }
            }
        } else
        {
            if (completedPuzzle) {
                questPuzzleUnlockPopup.replay("fromQuest", puzzleId);
                if (vis) {
                    gameObj.setQuestCompMainConfirmationPopup(1);
                } else {
                    gameObj.setQuestCompMainConfirmationPopup(0);
                }
            } else {
                if (isBonusArchive) {
                    questPuzzleUnlockPopup.loadBonusArchivePuzzle(puzzleId);
                } else {
                    questPuzzleUnlockPopup.loadArchivePuzzle(puzzleId, puzzleCost);
                }
                if (vis) {
                    gameObj.setQuestMainConfirmationPopup(1);
                } else {
                    gameObj.setQuestMainConfirmationPopup(0);
                }
            }
        }
    };

    this.loadBonusArchivePuzzle = function (puzzleId, noPopup) {
        gameObj.setCrosswordToShow(puzzleId);
        popupLayer.closeWithDefault();
        if (adsObj.checkRewardedVideoAvailable() && utilObj.isOnline()) {
            gameObj.setPuzzleToUnlock(puzzleId);
            gameObj.setArchiveUnlockReward(true);
            gameObj.setUnlockingQuestBonusArchive(true);
            adsObj.showVideoAd(false, "forBonusArchiveNew");
            adsObj.setNotRewardedVideo(false);
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), screen, "w2e_archive", "", gameObj.getPuzzleSpeciesTracking(), "", "");
        } else {
            if (!utilObj.isOnline()) {
                utilObj.showMessage(stringsObj.not_online);
            } else {
                utilObj.showMessage(stringsObj.no_video_available);
            }
        }
    };

    this.loadArchivePuzzle = function (puzzleId, puzzleCost, noPopup) {
        if (!economyObj.makePayment(null, null, constantsObj.PKG_CASH, puzzleCost, constantsObj.TRACK_ARCHIVE, "", calendarLayer)) {
            return;
        }
        popupLayer.closeWithDefault();
        questMapLayer.hide();
        gameLayer.show(puzzleId, false, false, true);
    };

    this.loadMiniPuzzle = function (puzzleId, puzzleCost, noPopup) {
        if (!economyObj.makePayment(null, null, constantsObj.PKG_CASH, puzzleCost, constantsObj.TRACK_DAILY_MINI, "", calendarLayer)) {
            return;
        }
        popupLayer.closeWithDefault();
        questMapLayer.hide();
        gameLayer.show(puzzleId, false, false, true);
    };

    this.loadPuzzleVideoReward =  function (id) {
        questMapLayer.hide();
        gameLayer.show(id, false, false, true);
    };

    this.replay = function (fromQuest, id) {
        popupLayer.closeWithDefault();
        questMapLayer.hide();
        gameLayer.show(id, false, false, true);
    };
};