QuestStartPopup = function () {

    var showWithAnim = true;
    var popupNode = null;
    var cb = null;
    var screen = constantsObj.SCREEN_QUEST_START;

    this.show = function (withAnim, params) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        questStartPopup.delayedShow(params);
    };

    this.delayedShow = function (params) {

        var bucket = questMapObj.getBucketAllocated();
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "weekly_intro_popup",constantsObj.TRACK_VIEW, bucket , "", "", "");

        var popupHeight = 1350;// + constantsObj.POPUP_START_OFFSET;
        var popupWidth = constantsObj.NEW_POPUP_WIDTH;
        var labelArr = [];
        var spriteArr = [];
        popupNode = new cc.Node();
        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2;
        var zOrder = constantsObj.UI_Z_ORDER;
        var isThemedQuest = params.isThemeQuest;
        var subTextStr = "Hurry! Only 7 days left!";
        var quest_exp = gameObj.getExpNewWeeklyQuestVariant();

        if (isThemedQuest) {
            if (gameObj.getThemedQuestLastPopupTimestamp() == null || gameObj.getThemedQuestLastPopupDay() == null || gameObj.getThemedQuestPopupCount() == 0 || gameObj.getThemedQuestPopupCount() == null) {
                gameObj.checkAndSetThemedQuestVersion();
                if (gameObj.getThemedQuestPopupCount() == null) {
                    gameObj.setThemedQuestPopupCount(0);
                }
                gameObj.setThemedQuestLastPopupTimestamp(utilObj.getCurrentTimestamp());
                gameObj.setThemedLastQuestPopupDay(gameObj.getLastLogin());
                gameObj.setThemedQuestPopupCount(gameObj.getThemedQuestPopupCount() + 1);
            } else if (utilObj.getCurrentTimestamp() - gameObj.getThemedQuestLastPopupTimestamp() >= 7200 && gameObj.getLastLogin() == gameObj.getThemedQuestLastPopupDay() && gameObj.getThemedQuestPopupCount() < 2) {
                gameObj.setThemedQuestLastPopupTimestamp(utilObj.getCurrentTimestamp());
                gameObj.setThemedLastQuestPopupDay(gameObj.getLastLogin());
                gameObj.setThemedQuestPopupCount(gameObj.getThemedQuestPopupCount() + 1);
            } else if (gameObj.getLastLogin() != gameObj.getThemedQuestLastPopupDay()) {
                gameObj.setThemedQuestLastPopupTimestamp(utilObj.getCurrentTimestamp());
                gameObj.setThemedLastQuestPopupDay(gameObj.getLastLogin());
                gameObj.setThemedQuestPopupCount(1);
            } else {
                return;
            }
            subTextStr = themedQuestObj.getTqMapLayerTimerText();
        } else {
            if (gameObj.getIsWeeklyQuestIntroPopupEligible() == false) {
                return;
            }
            subTextStr = weeklyQuestObj.getWqMapLayerTimerText();
        }

        var questText = "";
        var headerText = "";
        var imageType = "vector";
        if(quest_exp == constantsObj.EXP_VAR_2){
            imageType = "realistic";
        }
        var questAutoTitle = "";
        var questAutoDesc = "";
        var questIcon = null;
        var textArr = [];

        if (isThemedQuest) {
            var tqData = questMapObj.getTqData();
            questAutoTitle = tqData["tq_" + imageType]["quest_auto_title"];
            questAutoDesc = tqData["tq_" + imageType]["quest_auto_desc"];
            questIcon =tqData["tq_" + imageType]["theme_img"];
            headerText = questAutoTitle;
        } else {
            var wqData = questMapObj.getWqData();
            var now = new Date();
            var year = questMapObj.y2k(now.getYear());
            var month = now.getMonth();
            var date = now.getDate();
            var startMilestone = 0;
            var weekNum = questMapObj.getWeek(year, month, date);
            if (wqData[year + "_" + weekNum + "_" + imageType] == undefined) {
                questAutoTitle = constantsObj.DEFAULT_QUEST["default_week"]["quest_auto_title"];
                questAutoDesc = constantsObj.DEFAULT_QUEST["default_week"]["quest_auto_desc"];
            }else {
                questAutoTitle = wqData[year + "_" + weekNum + "_" + imageType]["quest_auto_title"];
                questAutoDesc = wqData[year + "_" + weekNum + "_" + imageType]["quest_auto_desc"];
            }
            questIcon = questMapObj.getWeeklyThemeImage(year , weekNum , quest_exp);
            headerText = questAutoTitle;
            gameObj.setIsWeeklyQuestIntroPopupEligible(false);
        }

        textArr = utilObj.getSplitStringsArr(questAutoDesc, 35);
        if (textArr.length > 2) {
            popupHeight += (textArr.length - 2) * 70;
        }

        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, popupWidth, popupHeight, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);

        yPos -= 230 + 40;
        for (var i = 0; i < textArr.length; i++) {
            var subText = utilObj.getBMFontLabel(textArr[i], constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, popupNode, zOrder);
            utilObj.setOpacity(subText, constantsObj.OPACITY_90);
            yPos -= 70;
        }

        yPos-= 50 + 250;
        var quest_icon = utilObj.getSprite(questIcon, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_3 * 0.9, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        // utilObj.setColor(lockOuterCircle, constantsObj.COLOR_QUEST_MILESTONE);

        yPos -= 250 + 80;
        var subText = utilObj.getBMFontLabel(subTextStr, constantsObj.FONT_HELVETICA_55, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, popupNode, zOrder);
        utilObj.setOpacity(subText, constantsObj.OPACITY_60);

        yPos -= 60 + 85;
        var startButton = utilObj.getButton(500, 170, 0.5, 0.5, xPos, yPos,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'questStartPopup',
                fn: 'start',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: "",
                    c: "",
                    o: "weekly_intro_popup",
                    f: constantsObj.TRACK_PLAY,
                    g: bucket,
                    s: "",
                    co: "",
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        startButton.setColor(constantsObj.COLOR_BUTTON_GREEN);
        utilObj.addChild(popupNode, startButton, zOrder);
        //utilObj.pulseButton(startButton, constantsObj.PULSE_ACTION_TAG, 0);
        var startText = "Start";
        var startButtonTxt = utilObj.getBMFontLabel(startText, constantsObj.FONT_HELVETICA_MEDIUM_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, popupNode, zOrder);

        utilObj.addSprites(spriteArr);
        // utilObj.addLabels(labelArr);


        popupLayer.popupSetup(screen, false, questStartPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });

        popupLayer.show(popupHeight, screen, headerText, popupNode, labelArr, true, null, null, null, null, null, null, null, null, null, null, null, true);
    };

    this.close = function () {
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.start = function () {
        popupLayer.popupSetup(screen, false, questStartPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: true
        });
        popupLayer.closeWithDefault();
        homeLayer.hide();
        questMapLayer.show();
    };
};