ReplayPopup = function () {
    var popupNode = null;
    var cb = null;
    var screen = constantsObj.SCREEN_REPLAY;
    var showWithAnim = true;
    var puzzleId = null;
    var score = null;

    this.show = function (withAnim) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        // loggerObj.debugLog("Popup Layer", popupLayer);
        popupLayer.checkAndShow(replayPopup.delayedShow, score);
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_LEVEL_INTRO_REPLAY, constantsObj.TRACK_VIEW, "", gameObj.getPuzzleSpeciesTracking(), "", "");
    };

    this.delayedShow = function () {
        var labelArr = [];
        var popupHeight = 1200 + constantsObj.POPUP_START_OFFSET;
        var popupObj = 'replayPopup';
        var screenName = utilObj.getScreenName(screen);
        puzzleId = gameObj.getCrosswordToShow();
        var score = -1;

        var mastery = scoresObj.getMastery(puzzleId);
        score = scoresObj.getHighScore(puzzleId);
        if (gameObj.getD0Id() == puzzleId) {
            puzzleId = gameObj.getInstallDay();
        }
        var isDailyMini = gameObj.checkForDailyMini(puzzleId);

        if (gameObj.checkForMiniOrMidi(puzzleId) != true) {
            var d = utilObj.getDateForId(puzzleId);
            var day = d.getDay();
            if (score == -1) {
                score = scoresObj.getHighScore(puzzleId);
            }
        } else {
            var packId = gameObj.getPackIdFromPuzzleId(puzzleId);
            var curCrosswordInfo = gameObj.getCrosswordForDate(puzzleId);
            var height = curCrosswordInfo.h;
            var width = curCrosswordInfo.w;
            score = scoresObj.getHighScore(gameLayer.crosswordDate);
            //scoresObj.setHighScore(puzzleId);
        }
        var layoutExperimentVariant = epmObj.getChosenVariant(constantsObj.EXP_LAYOUT);


        popupNode = new cc.Node();

        var header = puzzleId;
        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2 - constantsObj.POPUP_START_OFFSET;
        var zOrder = constantsObj.UI_Z_ORDER;

        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, constantsObj.LARGE_POPUP_WIDTH, popupHeight - constantsObj.POPUP_START_OFFSET, null, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        popupBg.setColor(constantsObj.COLOR_GREY_POPUP);
        //popupNode.addChild(popupBg);
        utilObj.addChild(popupNode, popupBg);
        yPos -= 80;

        if (layoutExperimentVariant == constantsObj.EXP_VAR_CONTROL) {
            utilObj.getTTFFontLabel("Puzzle Completed", constantsObj.FONT_ROBOTO_MEDIUM_120, constantsObj.COLOR_GREY_03,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);

            yPos -= 300;
            var starColor = constantsObj.COLOR_STAR_1;
            var star1 = utilObj.getSprite(constantsObj.star_white, xPos - 350, yPos - 70, 0.5, 0.5, constantsObj.SCALE_SPRITE_21, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            star1.setColor(starColor);
            star1.setRotation(-30);
            //popupNode.addChild(star1);
            utilObj.addChild(popupNode, star1);
            if (mastery < constantsObj.MASTERY_SILVER) {
                starColor = constantsObj.COLOR_GREY_02;
            }
            var star2 = utilObj.getSprite(constantsObj.star_white, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_22, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            star2.setColor(starColor);
            //popupNode.addChild(star2);
            utilObj.addChild(popupNode, star2);
            if (mastery < constantsObj.MASTERY_GOLD) {
                starColor = constantsObj.COLOR_GREY_02;
            }
            var star3 = utilObj.getSprite(constantsObj.star_white, xPos + 350, yPos - 70, 0.5, 0.5, constantsObj.SCALE_SPRITE_21, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            star3.setColor(starColor);
            star3.setRotation(30);
            //popupNode.addChild(star3);
            utilObj.addChild(popupNode, star3);

            yPos -= 270;
            utilObj.getTTFFontLabel("Your time:", constantsObj.FONT_ROBOTO_MEDIUM_40, constantsObj.COLOR_GREY_03,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);
            yPos -= 50;
            utilObj.getTTFFontLabel(utilObj.formatTime(score), constantsObj.FONT_ROBOTO_REGULAR_120, constantsObj.COLOR_GREY_03,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);

            yPos -= 220;
            var reviewButton = utilObj.getButton(360, 150, 0.5, 1.0, xPos - 400, yPos,
                constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                    obj: 'replayPopup',
                    fn: 'review',
                    screen: screen,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: gameObj.getTrackingPuzzleTheme(),
                        o: constantsObj.TRACK_LEVEL_INTRO_REPLAY,
                        f: constantsObj.TRACK_REVIEW,
                        g: "",
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            reviewButton.setColor(constantsObj.COLOR_LIGHT_BLUE);
            //popupNode.addChild(reviewButton, zOrder);
            utilObj.addChild(popupNode, reviewButton, zOrder);
            utilObj.getTTFFontLabel("Review", constantsObj.FONT_ROBOTO_BOLD_70, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 400, yPos - 35, 0.5, 1, labelArr, popupNode, zOrder);

            var replayButton = utilObj.getButton(360, 150, 0.5, 1.0, xPos, yPos,
                constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                    obj: 'replayPopup',
                    fn: 'replay',
                    screen: screen,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: gameObj.getTrackingPuzzleTheme(),
                        o: constantsObj.TRACK_LEVEL_INTRO_REPLAY,
                        f: constantsObj.TRACK_REPLAY,
                        g: "",
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            replayButton.setColor(constantsObj.COLOR_GREEN_01);
            //popupNode.addChild(replayButton, zOrder);
            utilObj.addChild(popupNode, replayButton, zOrder);
            utilObj.getTTFFontLabel("Replay", constantsObj.FONT_ROBOTO_BOLD_70, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - 35, 0.5, 1, labelArr, popupNode, zOrder);

            var homeButton = utilObj.getButton(360, 150, 0.5, 1.0, xPos + 400, yPos,
                constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                    obj: 'replayPopup',
                    fn: 'goToHome',
                    screen: screen,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: gameObj.getTrackingPuzzleTheme(),
                        o: constantsObj.TRACK_LEVEL_INTRO_REPLAY,
                        f: constantsObj.TRACK_HOME,
                        g: "",
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            homeButton.setColor(constantsObj.COLOR_LIGHT_BLUE);
            //popupNode.addChild(homeButton, zOrder);
            utilObj.addChild(popupNode, homeButton, zOrder);
            utilObj.getTTFFontLabel("Home", constantsObj.FONT_ROBOTO_BOLD_70, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 400, yPos - 35, 0.5, 1, labelArr, popupNode, zOrder);
        } else {
            header = "Puzzle Completed!";
            if (gameObj.checkForMiniOrMidi(puzzleId) != true) {
                utilObj.getBMFontLabel(stringsObj.puzzle_themes_pack_Info[day] + "!", constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);
            } else if(isDailyMini) {
                utilObj.getBMFontLabel(stringsObj.Daily_mini, constantsObj.FONT_ROBOTO_REGULAR_80, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);
            } else {
                utilObj.getBMFontLabel(stringsObj.puzzle_themes_pack_Info[packId] + "!", constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);
            }
            yPos -= 100;

            if (gameObj.checkForMiniOrMidi(puzzleId) != true) {
                utilObj.getBMFontLabel(utilObj.getFormattedDate(d), constantsObj.FONT_ROBOTO_REGULAR_50, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);
            } else if (isDailyMini) {
                utilObj.getBMFontLabel(utilObj.getFormattedDate(gameObj.getTodaysPuzzleDate()), constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder)
            } else {
                utilObj.getBMFontLabel(height + "*" + width, constantsObj.FONT_ROBOTO_REGULAR_50, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);
            }


            yPos -= 80;
            var bg = utilObj.getSprite(constantsObj.dialog_bg, xPos, yPos, 0.5, 1, 2, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            //popupNode.addChild(bg, zOrder);
            utilObj.addChild(popupNode, bg, zOrder);

            yPos -= 180;
            var starColor = constantsObj.COLOR_GREY_02;
            if (score) {
                starColor = constantsObj.COLOR_BLUE_01;
            }
            var star1 = utilObj.getSprite(constantsObj.star_white_2, xPos - 270, yPos - 40, 0.5, 0.5, constantsObj.SCALE_SPRITE_4, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            star1.setColor(starColor);
            star1.setRotation(-30);
            //popupNode.addChild(star1, zOrder);
            utilObj.addChild(popupNode, star1, zOrder);
            if (mastery < constantsObj.MASTERY_SILVER) {
                starColor = constantsObj.COLOR_GREY_02;
            }
            var star2 = utilObj.getSprite(constantsObj.star_white_2, xPos, yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_21, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            star2.setColor(starColor);
            //popupNode.addChild(star2, zOrder);
            utilObj.addChild(popupNode, star2, zOrder);
            if (mastery < constantsObj.MASTERY_GOLD) {
                starColor = constantsObj.COLOR_GREY_02;
            }
            var star3 = utilObj.getSprite(constantsObj.star_white_2, xPos + 270, yPos - 40, 0.5, 0.5, constantsObj.SCALE_SPRITE_4, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            star3.setColor(starColor);
            star3.setRotation(30);
            //popupNode.addChild(star3, zOrder);
            utilObj.addChild(popupNode, star3, zOrder);

            yPos -= 200;
            utilObj.getTTFFontLabel("Your time:", constantsObj.FONT_ROBOTO_REGULAR_50, constantsObj.COLOR_BLUE_02,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);
            yPos -= 120;
            var text;
            if (score) {
                text = utilObj.formatTime(score);
            } else {
                text = "--:--";
            }
            var timeBg = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, yPos + 35, 0.5, 1, 400, 140, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
            timeBg.setOpacity(constantsObj.OPACITY_20);
            //popupNode.addChild(timeBg, zOrder);
            utilObj.addChild(popupNode, timeBg, zOrder);
            utilObj.getTTFFontLabel(text, constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);

            yPos -= 200;
            var offsetForDailyMini = 0;
            if (isDailyMini) {
                offsetForDailyMini = 220;
            }
            var reviewButton = utilObj.getButton(360, 170, 0.5, 1.0, xPos + 440 - offsetForDailyMini, yPos,
                constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                    obj: 'replayPopup',
                    fn: 'review',
                    screen: screen,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: gameObj.getTrackingPuzzleTheme(),
                        o: constantsObj.TRACK_LEVEL_INTRO_REPLAY,
                        f: constantsObj.TRACK_REVIEW,
                        g: "",
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            reviewButton.setColor(constantsObj.COLOR_BUTTON_GREEN);
            //popupNode.addChild(reviewButton, zOrder);
            utilObj.addChild(popupNode, reviewButton, zOrder);
            utilObj.getTTFFontLabel("Review", constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 440 - offsetForDailyMini, yPos - 45, 0.5, 1, labelArr, popupNode, zOrder);

            if (!isDailyMini) {
                var replayButton = utilObj.getButton(440, 170, 0.5, 1.0, xPos, yPos,
                    constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                        obj: 'replayPopup',
                        fn: 'replay',
                        screen: screen,
                        track: {
                            k: constantsObj.TRACK_DIALOG,
                            p: gameObj.getCurPuzzleTracking(),
                            c: gameObj.getTrackingPuzzleTheme(),
                            o: constantsObj.TRACK_LEVEL_INTRO_REPLAY,
                            f: constantsObj.TRACK_REPLAY,
                            g: "",
                            s: gameObj.getPuzzleSpeciesTracking(),
                            co: 1,
                            oppId: ""
                        },
                    }, false, ccui.Widget.PLIST_TEXTURE, 1);
                replayButton.setColor(constantsObj.COLOR_BUTTON_ORANGE);
                //popupNode.addChild(replayButton, zOrder);
                utilObj.addChild(popupNode, replayButton, zOrder);
                utilObj.pulseButton(replayButton, constantsObj.PULSE_ACTION_TAG, 0);
                var lbl = utilObj.getTTFFontLabel("Replay", constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 220, 85, 0.5, 0.5, labelArr, replayButton, zOrder);
                utilObj.pulseButton(lbl, constantsObj.PULSE_ACTION_TAG, 0);
            }

            var homeButton = utilObj.getButton(360, 170, 0.5, 1.0, xPos - 440 + offsetForDailyMini, yPos,
                constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                    obj: 'replayPopup',
                    fn: 'goToHome',
                    screen: screen,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: gameObj.getTrackingPuzzleTheme(),
                        o: constantsObj.TRACK_LEVEL_INTRO_REPLAY,
                        f: constantsObj.TRACK_HOME,
                        g: "",
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            homeButton.setColor(constantsObj.COLOR_LIGHT_BLUE);
            //popupNode.addChild(homeButton, zOrder);
            utilObj.addChild(popupNode, homeButton, zOrder);
            utilObj.getTTFFontLabel("Back", constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 440 + offsetForDailyMini, yPos - 45, 0.5, 1, labelArr, popupNode, zOrder);
        }


        popupLayer.popupSetup(screen, false, replayPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });
        popupLayer.show(popupHeight, screen, header, popupNode, labelArr, false, undefined, "", "", true);
    };

    this.close = function () {
        if (cb != null) {
            if (homeLayoutExp != constantsObj.EXP_VAR_CONTROL) {
                ftueObj.setCalendarFtueShown(true);
            }
            var tempCb = cb;
            cb = null;
            tempCb();
        }
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_LEVEL_INTRO_REPLAY, constantsObj.TRACK_CLOSE, "", gameObj.getPuzzleSpeciesTracking(), "", "");
    };

    this.goToHome = function () {
        cb = gameLayer.back;
        popupLayer.popupSetup(screen, false, replayPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: true
        });
        popupLayer.closeWithDefault();
    };

    this.replay = function () {
        gameObj.trackPuzzleView();
        if (!ftueObj.isReplayFtueShown() && (!gameObj.checkForMiniOrMidi(gameLayer.crosswordDate))) {
            cb = ftueObj.showReplayFtue;
            popupLayer.closeWithDefault();
            return;
        }
        if (economyObj.getReplayCrosswordCost() != 0 && (!gameObj.checkForMiniOrMidi(gameLayer.crosswordDate))) {
            if (!economyObj.makePayment(replayPopup.replay, gameLayer.back, constantsObj.PKG_CASH, economyObj.getReplayCrosswordCost(), constantsObj.TRACK_REPLAY, 1, gameLayer)) {
                return false;
            }
        }
        gameObj.setReplay(false);
        //scoresObj.setHighScore(puzzleId);
        if (gameObj.getSeeWrongNewFlag()) {
            gameObj.setIsSeeWrongActive(gameObj.getIsSeeWrongForPuzzle());
        } else if (!gameObj.getSeeWrongStaysOn()) {
            if (gameObj.getIsSeeWrongActive()) {
                gameObj.setIsSeeWrongActive(false);
            }
        } else {
            if (gameObj.getIsSeeWrongActive() && !gameObj.getIsSeeWrongPurchased() && !gameObj.getLastSeeWrongwasfree()) {
                if (economyObj.getCash() >= economyObj.getSeeWrongCost()) {
                    gameObj.trackSeeWrong(true);
                    gameObj.purchaseSeeWrong();
                }
            }
        }
        gameObj.updateIsSeeWrongActive();

        cb = ftueObj.checkAndShowWatchToEarnFtue;
        popupLayer.closeWithDefault();
    };

    this.review = function () {
        popupLayer.closeWithDefault();
        gameObj.setReview();
        if (gameObj.checkForMiniOrMidi(gameLayer.crosswordDate)) {
            if (gameObj.checkForDailyMini(gameLayer.crosswordDate)) {
                machineLearningDataObj.incMiniPuzzlesReviewed();
            } else {
                machineLearningDataObj.incPackPuzzlesReviewed();
            }
        } else {
            machineLearningDataObj.incMainPuzzlesReviewed();
        }

        gameObj.trackPuzzleView();
    };

    this.back = function () {
        cb = gameLayer.back;
        //params = {puzzleId: gameLayer.crosswordDate}
        popupLayer.closeWithDefault();
    };
};