StarterPackPopup = function () {
    var popupNode = null;
    var showWithAnim = true;
    var cb = null;
    var pkgName = null;
    var timerLbl = null;
    var timeLeft = null;

    this.show = function (withAnim) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        popupLayer.checkAndShow(starterPackPopup.delayedShow, null);
    };

    this.delayedShow = function () {
        var labelArr = [];
        var popupHeight = 1490 + constantsObj.POPUP_START_OFFSET;
        var screen = constantsObj.SCREEN_STARTER_PACK;
        var screenName = utilObj.getScreenName(screen);
        gameObj.setTimeStampStarterPopup(utilObj.getCurrentTimestamp());
        var trackStarter = "starter_2";

        if (gameObj.isEligibleForStarterPack1()) {
            if (gameObj.getTimeStampForStarterPack1() <= 0) {
                gameObj.setTimeStampForStarterPack1();
                gameObj.setTimeStampForStarterPackTimer();
            }
        }

        popupNode = new cc.Node();

        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2 - constantsObj.POPUP_START_OFFSET;
        var zOrder = constantsObj.UI_Z_ORDER;

        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, centerXPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH, popupHeight - constantsObj.POPUP_START_OFFSET);
        popupBg.setColor(constantsObj.COLOR_STARTER_PACK_BG);
        utilObj.addChild(popupNode, popupBg);

        yPos -= 140;
        var limitedOffer = utilObj.getSprite(constantsObj.starter_tape, xPos, yPos - 30, 0.5, 0.5, constantsObj.SCALE_SPRITE_50 * 1.5, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
        popupNode.addChild(limitedOffer, zOrder + 1);
        var headertext = stringsObj.limited_offer;
        if (gameObj.isEligibleForStarterPack2()) {
            headertext = stringsObj.special_offer;
        }
        var limitedOfferText = utilObj.getTTFFontLabel(headertext, constantsObj.FONT_ROBOTO_MEDIUM_110, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos - 20, 0.5, 0.5, labelArr, popupNode, zOrder + 1);
        //yPos += 150;

        var timeRem = gameObj.getTimeRemainingForStarterPack();
        var timeRemainingStr = utilObj.formatTime(timeRem);
        if (gameObj.isEligibleForStarterPack1() == true) {
            timeLeft = utilObj.getTTFFontLabel("Time Left:", constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos - 150, yPos - 180, 0.5, 1, labelArr, popupNode, zOrder + 1);
            timerLbl = utilObj.getTTFFontLabel(timeRemainingStr + "", constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos + 150, yPos - 180, 0.5, 1, labelArr, popupNode, zOrder + 1);
        }

        yPos -= 320;
        if (gameObj.isEligibleForStarterPack2()) {
            yPos += 60;
        }
        var Bg2 = utilObj.getScale9Sprite(constantsObj.popup_bg, centerXPos, yPos, 0.5, 1, 450, 500);
        //popupBg.setColor(constantsObj.COLOR_STARTER_PACK_BG);
        utilObj.addChild(popupNode, Bg2);

        var coins = utilObj.getSprite(constantsObj.coin_four, centerXPos, yPos - 60, 0.5, 1, constantsObj.SCALE_SPRITE_48 * 1.5, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
        utilObj.addChild(popupNode, coins, zOrder + 1);

        if (gameObj.isEligibleForStarterPack1()) {
            var starterPackExp = epmObj.getChosenVariant(constantsObj.EXP_STARTER_PACK);
            if (starterPackExp == constantsObj.EXP_VAR_1) {
                utilObj.getTTFFontLabel("1150", constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, yPos - 400 - 110, 0.5, 1, labelArr, popupNode, zOrder + 1);
                var divider = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, yPos - 400 - 145, 0.5, 1, 160, 4);
                utilObj.addChild(popupNode, divider);
                utilObj.getTTFFontLabel("1700", constantsObj.FONT_ROBOTO_MEDIUM_90, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, yPos - 470 - 110, 0.5, 1, labelArr, popupNode, zOrder + 1);
                trackStarter = "starter_2";
                var coin1 = utilObj.getSprite(constantsObj.coin_two, centerXPos + 140, yPos - 470 - 110, 0.5, 1, constantsObj.SCALE_SPRITE_12 * 1.5, null, popupNode, zOrder + 1, constantsObj.SPRITE_MISC);
                utilObj.addChild(popupNode, coin1, zOrder + 1);
            }
            if (starterPackExp == constantsObj.EXP_VAR_2) {
                utilObj.getTTFFontLabel("550", constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, yPos - 400 - 110, 0.5, 1, labelArr, popupNode, zOrder + 1);
                var divider = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, yPos - 400 - 145, 0.5, 1, 160, 4);
                utilObj.addChild(popupNode, divider);
                utilObj.getTTFFontLabel("800", constantsObj.FONT_ROBOTO_MEDIUM_90, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, yPos - 470 - 110, 0.5, 1, labelArr, popupNode, zOrder + 1);
                trackStarter = "starter_2";
                var coin1 = utilObj.getSprite(constantsObj.coin_two, centerXPos + 140, yPos - 470 - 110, 0.5, 1, constantsObj.SCALE_SPRITE_12 * 1.5, null, popupNode, zOrder + 1, constantsObj.SPRITE_MISC);
                utilObj.addChild(popupNode, coin1, zOrder + 1);
            }

        } else {
            utilObj.getTTFFontLabel("300", constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, yPos - 400 - 110, 0.5, 1, labelArr, popupNode, zOrder + 1);
            var divider = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, yPos - 400 - 145, 0.5, 1, 160, 4);
            utilObj.addChild(popupNode, divider);
            utilObj.getTTFFontLabel("440", constantsObj.FONT_ROBOTO_MEDIUM_90, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, yPos - 470 - 110, 0.5, 1, labelArr, popupNode, zOrder + 1);
            var coin1 = utilObj.getSprite(constantsObj.coin_two, centerXPos + 140, yPos - 470 - 110, 0.5, 1, constantsObj.SCALE_SPRITE_12 * 1.5, null, popupNode, zOrder + 1, constantsObj.SPRITE_MISC);
            utilObj.addChild(popupNode, coin1, zOrder + 1);
        }


        yPos -= 55;
        var Bg1 = utilObj.getScale9Sprite(constantsObj.popup_bg, centerXPos - 420, yPos, 0.5, 1, 340, 400);
        //popupBg.setColor(constantsObj.COLOR_STARTER_PACK_BG);
        utilObj.addChild(popupNode, Bg1);

        var revealLetters = utilObj.getSprite(constantsObj.starter_reveal_letter, centerXPos - 410, yPos - 70, 0.5, 1, constantsObj.SCALE_SPRITE_24 * 1.5, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
        utilObj.addChild(popupNode, revealLetters, zOrder + 1);

        utilObj.getTTFFontLabel("Reveal Letters", constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos - 420, yPos - 320, 0.5, 1, labelArr, popupNode, zOrder + 1);

        utilObj.getTTFFontLabel("4", constantsObj.FONT_ROBOTO_MEDIUM_90, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos - 420, yPos - 420, 0.5, 1, labelArr, popupNode, zOrder + 1);

        var Bg3 = utilObj.getScale9Sprite(constantsObj.popup_bg, centerXPos + 420, yPos, 0.5, 1, 340, 400);
        //popupBg.setColor(constantsObj.COLOR_STARTER_PACK_BG);
        utilObj.addChild(popupNode, Bg3);

        var starterPack = utilObj.getSprite(constantsObj.starter_pack, centerXPos + 415, yPos - 60, 0.5, 1, constantsObj.SCALE_SPRITE_24 * 1.5, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
        utilObj.addChild(popupNode, starterPack, zOrder + 1);

        utilObj.getTTFFontLabel("Packs", constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos + 420, yPos - 320, 0.5, 1, labelArr, popupNode, zOrder + 1);

        utilObj.getTTFFontLabel("1", constantsObj.FONT_ROBOTO_MEDIUM_90, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos + 420, yPos - 420, 0.5, 1, labelArr, popupNode, zOrder + 1);


        yPos -= 810;

        var noButton = utilObj.getButton(880, 210, 0.5, 0.5, centerXPos, yPos, constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
            obj: 'starterPackPopup',
            fn: 'buy',
            screen: constantsObj.SCREEN_STARTER_PACK,
            track: {
                k: constantsObj.TRACK_DIALOG,
                p: "",
                c: gameObj.getTrackingPuzzleTheme(),
                o: trackStarter,
                f: constantsObj.TRACK_BUY,
                g: "",
                s: gameObj.getPuzzleSpeciesTracking(),
                co: 1,
                oppId: ""
            },
        }, false, ccui.Widget.PLIST_TEXTURE, 1);
        noButton.setColor(constantsObj.COLOR_BUTTON_GREEN);
        utilObj.addChild(popupNode, noButton, zOrder + 1);

        var pkgs = paymentsObj.getCashPackages();
        var price = utilObj.formatPrice(pkgs[0].price);
        pkgName = pkgs[0].name;
        utilObj.getTTFFontLabel("Buy  " + price, constantsObj.FONT_ROBOTO_MEDIUM_110, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 440, 105, 0.5, 0.5, labelArr, noButton, zOrder + 1);

        var offer_tag = utilObj.getSprite(constantsObj.starter_offer_tag, centerXPos - 410, yPos + 105, 0.5, 0.5, constantsObj.SCALE_SPRITE_6 * 1.5, null, popupNode, zOrder, constantsObj.SPRITE_MISC);
        utilObj.addChild(popupNode, offer_tag, zOrder + 1);

        utilObj.getTTFFontLabel("80%", constantsObj.FONT_ROBOTO_MEDIUM_100, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos - 400, yPos + 115, 0.5, 0.5, labelArr, popupNode, zOrder + 1);

        utilObj.getTTFFontLabel("Extra", constantsObj.FONT_ROBOTO_MEDIUM_50, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos - 410, yPos + 45, 0.5, 0.5, labelArr, popupNode, zOrder + 1);

        var popupHeaderText = stringsObj.limited_offer;
        if (gameObj.isEligibleForStarterPack2()) {
            popupHeaderText = stringsObj.special_offer;
        }

        popupLayer.popupSetup(screen, false, starterPackPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });

        popupLayer.show(popupHeight, screen, popupHeaderText, popupNode, labelArr, true, "", screenName, "", "", "", true);
        /*popupHeight, popupType, header, popupUI, popupLabels,
            showClose, screenSubType, trackGenus, trackSpecies, extraWide, extraHeader, noHeader, coinHeader*/
    };

    this.buy = function () {
        paymentsObj.purchaseItem(pkgName);
        popupLayer.closeWithDefault();
    };

    this.close = function () {
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
        //gameLayer.fbLogOut();
        popupLayer.closeWithDefault();
    };

    /*this.logoutb = function () {
        if (!utilObj.isOnline()) {
            utilObj.showMessage(stringsObj.not_online);
            return;
        }
        fbWrapperObj.logout();

        cb = gameObj.fbLogOut;
        popupLayer.closeWithDefault();
        //utilObj.showMessage("you have been logged out.");
        //utilObj.showMessage("kkkk",lastLayer);
        //fbLogoutPopup.close();
        //curLayer.hide();

    };

    this.logoutSuccess = function () {
        popupLayer.closeWithDefault();
        fbLogoutPopup.close();
    };*/

    this.updateRemainingTimeLbl = function (timeRemaining) {
        if (curScreen == constantsObj.SCREEN_STARTER_PACK) {
            if (utilObj.isNodeValid(timerLbl)) {
                timerLbl.setString(utilObj.formatTime(timeRemaining));
            }
        }
    };
};

