StorePopup = function () {
    var successCallback = null;
    var failureCallback = null;
    var listView = null;
    var popupNode = null;
    var popupHeight = 0;
    var screenName = "";
    var listViewWidth = constantsObj.POPUP_WIDTH - 60;
    var listViewHeight = 1430;
    var listBgGap = 90;
    var listOffset = 65;
    var firstPurchase = false;
    var seenCount = {};
    var lastTrigger = null;
    var genus = "";
    var performFailureCallBack = true;
    var screen = constantsObj.SCREEN_STORE;
    var showWithAnim = true;
    var parentLayer = null;
    var secondsInAnHour = constantsObj.SECONDS_IN_HOUR;

    this.show = function (withAnim, sc, fc, type, fromDesp, pL) {
        parentLayer = pL;
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        var params = {sc: sc, fc: fc, type: type, fromDesp: fromDesp};
        popupLayer.checkAndShow(storePopup.delayedShow, params);
    };

    this.delayedShow = function (sender, params) {
        var sc = params.sc;
        var fc = params.fc;
        var type = params.type;
        var fromDesp = params.fromDesp;
        successCallback = sc;
        failureCallback = fc;

        var labelArr = [];
        popupNode = new cc.Node();
        performFailureCallBack = true;

        var screenName = utilObj.getScreenName(screen);
        var puzLevel = gameObj.getCurPuzzleTracking();
        var zOrder = constantsObj.UI_Z_ORDER;

        popupHeight = 1720 + constantsObj.POPUP_START_OFFSET;
        var yPos = centerYPos + popupHeight / 2 - constantsObj.POPUP_START_OFFSET;

        var popupHeader = stringsObj.out_of_coins;

        storePopup.showNormalHeader({yPos: yPos - 40, screen: screen, type: type, fromdesp: fromDesp});


        listView = null;
        yPos = centerYPos + popupHeight / 2 - constantsObj.POPUP_START_OFFSET;
        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, centerXPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH, popupHeight - constantsObj.POPUP_START_OFFSET);
        utilObj.addChild(popupNode, popupBg);

        var curScreenName = utilObj.getScreenName(curScreen);
        if (lastTrigger != curScreenName) {
            seenCount[constantsObj.PKG_CASH] = 0;
            // seenCount[constantsObj.PKG_SEC_CASH] = 0;
        }
        seenCount[type]++;
        // loggerObj.debugLog("Cur screen:", lastTrigger, curScreenName, seenCount);
        lastTrigger = curScreenName;
        genus = curScreenName + "," + seenCount[type];

        var freeCoinsY = yPos - listViewHeight - 220;
        if (firstPurchase) {
            freeCoinsY += 200;
        }
        var storeVideoVariant = epmObj.getChosenVariant(constantsObj.EXP_STORE_VIDEO_VIEWS);
        var showVideoButton = true;
        if (storeVideoVariant == constantsObj.EXP_VAR_3 || (storeVideoVariant == constantsObj.EXP_VAR_2 && ((utilObj.getCurrentTimestamp() - gameObj.getLastVideoSeenTimeStamp()) < constantsObj.SECONDS_IN_HOUR)) || (storeVideoVariant == constantsObj.EXP_VAR_2 && !adsObj.checkRewardedVideo(false))) {
            showVideoButton = false;
        }
        if (showVideoButton) {
            var freeCoinsButton = utilObj.getButton(622, 180, 0.5, 0.5, centerXPos + 325,
                freeCoinsY + 80, constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                    obj: 'storePopup',
                    fn: 'freeCoins',
                    screen: screen,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: puzLevel,
                        c: gameObj.getTrackingPuzzleTheme(),
                        o: constantsObj.TRACK_STORE,
                        f: utilObj.getScreenName(constantsObj.SCREEN_FREE_COINS),
                        g: lastTrigger,
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            freeCoinsButton.setColor(constantsObj.COLOR_BUTTON_LIGHT_BLUE);
            utilObj.addChild(popupNode, freeCoinsButton, zOrder);
            popupLayer.earnFreeButton = freeCoinsButton;

            var coinIcon1 = utilObj.getSprite(constantsObj.coin_png_2, 110 + 370, 90, 0.5, 0.5, constantsObj.SCALE_SPRITE_7, null, freeCoinsButton, zOrder, constantsObj.SPRITE_MISC);
            utilObj.addChild(freeCoinsButton, coinIcon1, zOrder);

            var freeLabel = utilObj.getTTFFontLabel(stringsObj.earn_free, constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos + 380 - 110, freeCoinsY + 80, 0.5, 0.5, labelArr, popupNode, zOrder);
            freeLabel.setScale(0.90);


            var watchButton = utilObj.getButton(622, 180, 0.5, 0.5, centerXPos - 325,
                freeCoinsY + 80, constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                    obj: 'storePopup',
                    fn: 'watch',
                    screen: screen,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: puzLevel,
                        c: gameObj.getTrackingPuzzleTheme(),
                        o: constantsObj.TRACK_STORE,
                        f: constantsObj.TRACK_W2E,
                        g: lastTrigger,
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            watchButton.setColor(constantsObj.COLOR_BUTTON_ORANGE);
            utilObj.addChild(popupNode, watchButton, zOrder);

            var coinIcon = utilObj.getSprite(constantsObj.coin_png_2, 80 + 460, 90, 0.5, 0.5, constantsObj.SCALE_SPRITE_7, null, watchButton, zOrder, constantsObj.SPRITE_MISC);
            utilObj.addChild(watchButton, coinIcon, zOrder);
            var watchLabel = utilObj.getTTFFontLabel(stringsObj.watch_for_free, constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos - 263 - 130, freeCoinsY + 80, 0.5, 0.5, labelArr, popupNode, zOrder);
            watchLabel.setScale(0.90);
        } else {
            var freeCoinsButton = utilObj.getButton(670, 180, 0.5, 0.5, centerXPos,
                freeCoinsY + 80, constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                    obj: 'storePopup',
                    fn: 'freeCoins',
                    screen: screen,
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: puzLevel,
                        c: gameObj.getTrackingPuzzleTheme(),
                        o: constantsObj.TRACK_STORE,
                        f: utilObj.getScreenName(constantsObj.SCREEN_FREE_COINS),
                        g: lastTrigger,
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            freeCoinsButton.setColor(constantsObj.COLOR_BUTTON_LIGHT_BLUE);
            utilObj.addChild(popupNode, freeCoinsButton, zOrder);
            popupLayer.earnFreeButton = freeCoinsButton;

            var coinIcon2 = utilObj.getSprite(constantsObj.coin_png_2, 130 + 370, 90, 0.5, 0.5, constantsObj.SCALE_SPRITE_7, null, freeCoinsButton, zOrder, constantsObj.SPRITE_MISC);
            utilObj.addChild(freeCoinsButton, coinIcon2, zOrder);

            var freeLabel = utilObj.getTTFFontLabel(stringsObj.earn_free, constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos + 60 - 130, freeCoinsY + 80, 0.5, 0.5, labelArr, popupNode, zOrder);
            freeLabel.setScale(0.90);
        }

        var redrawParent = false;
        popupLayer.popupSetup(screen, redrawParent, storePopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });
        popupLayer.show(popupHeight, screen, popupHeader, popupNode, labelArr, true, "", genus);
    };

    this.showNormalHeader = function (params) {
        var yPos = params.yPos;
        var type = params.type;
        utilObj.delayedCallback(popupLayer, storePopup.delayedLoad, 0.04, {
            type: type, yPos: yPos, tabs: false,
            fromdesp: params.fromdesp
        });
    };

    this.delayedLoad = function (sender, params) {
        storePopup.loadList(params);
    };

    this.getItemIcon = function (type, qty, fromdesp, index) {
        var params = {scale: constantsObj.SCALE_SPRITE_6};
        var chosenVariant = epmObj.getChosenVariant(constantsObj.EXP_STORE_UI);
        if (type == constantsObj.PKG_CASH) {
            var compare = (fromdesp || chosenVariant != constantsObj.EXP_VAR_1);
            if (compare) {
                switch (index) {
                    case 0:
                        params.img = constantsObj.COIN_1;
                        params.scale = constantsObj.SCALE_ONE_PLUS;
                        break;
                    case 1:
                        params.trending = true;
                        params.scale = constantsObj.SCALE_90 * constantsObj.SCALE_TWO;
                        params.img = constantsObj.COIN_2;
                        break;
                    case 2:
                        params.offer = true;
                        params.scale = constantsObj.SCALE_ONE_POINT_FOUR;
                        params.img = constantsObj.COIN_3;
                        break;
                    case 3:
                        params.scale = constantsObj.SCALE_ONE_POINT_TWO * constantsObj.SCALE_ONE_POINT_FOUR;
                        params.img = constantsObj.COIN_4;
                        break;
                    case 4:
                        params.scale = constantsObj.SCALE_ONE_POINT_TWO * constantsObj.SCALE_ONE_POINT_FOUR;
                        params.img = constantsObj.COIN_5;
                        break;
                    default:
                        params.scale = constantsObj.SCALE_ONE_POINT_TWO * constantsObj.SCALE_ONE_POINT_FOUR;
                        params.img = constantsObj.COIN_5;
                        break;
                }
            } else if (chosenVariant == constantsObj.EXP_VAR_1) {
                params.img = constantsObj.cash_glow;
            }
        } else if (type == constantsObj.PKG_SEC_CASH) {
            var compare = (fromdesp || chosenVariant != constantsObj.EXP_VAR_1);
            if (compare) {
                if (qty < 2000) {
                    params.img = constantsObj.sec_cash_glow;
                } else if (qty == 2000) {
                    params.offer = true;
                    params.scale = constantsObj.SCALE_TWO_THIRD;
                    params.img = other_resources.diamond_bunch_3;
                } else {
                    params.scale = constantsObj.SCALE_TWO_THIRD;
                    params.img = other_resources.diamond_bunch_4;
                }
            } else if (chosenVariant == constantsObj.EXP_VAR_1) {
                params.img = constantsObj.sec_cash_glow;
            }
        }
        return params;

    };

    this.loadList = function (params) {
        var yPos = params.yPos;
        var type = params.type;
        var itemHeight = 220;
        var zOrder = constantsObj.UI_Z_ORDER;
        var fromdesp = params.fromdesp;
        var pkgs = [];
        var itemImg;
        var labelArr = [];
        // var secCurVariant = epmObj.getChosenVariant(constantsObj.EXP_SECONDARY_CURRENCY);
        var purchaseMethod = "purchaseItem";
        switch (type) {
            case constantsObj.PKG_CASH:
                pkgs = paymentsObj.getCashPackages();
                break;
            /*case constantsObj.PKG_SEC_CASH:
             if (secCurVariant == constantsObj.EXP_VAR_1) {
             pkgs = economyObj.getSecCashPackages();
             purchaseMethod = "purchaseItemWithPrimary";
             } else {
             pkgs = paymentsObj.getSecCashPackages();
             }
             break;
             case constantsObj.PKG_PU:
             pkgs = economyObj.getPuMinPackages();
             break;*/
        }
        // loggerObj.debugLog("package list ", utilObj.getStringifiedJson(pkgs));

        yPos -= (popupHeight / 2 - listBgGap - listOffset + 40) - 100;

        if (listView != null) {
            popupNode.removeChild(listView);
        }
        var i = 0;
        if (firstPurchase) {
            i++;
            yPos -= 120;
        }

        listView = new ccui.ListView();
        listView.setDirection(ccui.ScrollView.DIR_VERTICAL);
        listView.setTouchEnabled(true);
        listView.setContentSize(cc.size(listViewWidth, listViewHeight - 80));
        listView.setPosition(centerXPos, yPos + 30);
        listView.setItemsMargin(40);
        listView.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
        listView.setAnchorPoint(0.5, 0.5);
        listView.setColor(constantsObj.COLOR_ORANGE);

        var puzLevel = gameObj.getCurPuzzleTracking();
        // var puzType = gameObj.getCurPuzTypeTracking();

        for (; i < pkgs.length; i++) {
            var localXPos = (listViewWidth) / 2;
            yPos = itemHeight / 2;
            var pkg = pkgs[i];
            var offer = false;
            var trending = false;
            var iconscale = constantsObj.SCALE_SPRITE_24;
            /*if (type == constantsObj.PKG_PU) {
             itemImg = pkg.icon;
             iconscale = constantsObj.SCALE_SPRITE_11;
             } else {
             var ret = storePopup.getItemIcon(type, pkg.qty, fromdesp, i);
             itemImg = ret.img;
             iconscale = ret.scale;
             offer = ret.offer;
             trending = ret.trending;
             }*/
            itemImg = constantsObj.coin_png_2;
            iconscale = constantsObj.SCALE_SPRITE_24;
            var itemWidget = new ccui.Widget();
            var hDiff = 20;
            itemWidget.setContentSize(cc.size(listViewWidth, itemHeight + 10));
            itemWidget.setAnchorPoint(0.5, 0.5);
            var itemBg = utilObj.getButton(listViewWidth, itemHeight, 0.5, 0.5, localXPos, yPos, constantsObj.rounded_4, constantsObj.rounded_4, constantsObj.rounded_4, {
                obj: 'storePopup',
                fn: purchaseMethod,
                screen: constantsObj.SCREEN_STORE,
                params: {name: pkg.name, qty: pkg.qty, price: pkg.price, pu: pkg.item, type: type},
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: puzLevel,
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_STORE,
                    f: "b_" + pkg.qty,
                    g: genus,
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
            itemBg.setColor(constantsObj.COLOR_LIGHT_GREY_01);


            localXPos = 190;
            /*if (offer) {
             var offerBg = utilObj.getSprite(constantsObj.RED_PATCH, 0, 35, 0, 0.5, constantsObj.SCALE_ONE_POINT_FIVE);
             itemBg.addChild(offerBg, 1);

             utilObj.getTTFFontLabel(stringsObj.best_offer, constantsObj.FONT_GADUGI_35, constantsObj.COLOR_LIGHT_YELLOW,
             constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 50, 35, 0, 0.5, labelArr, itemBg, 1);
             offset = 20;
             }
             if (trending) {
             var offerBg = utilObj.getSprite(constantsObj.BLUE_PATCH, 0, 35, 0, 0.5, constantsObj.SCALE_ONE_POINT_FIVE);
             itemBg.addChild(offerBg, 1);

             utilObj.getTTFFontLabel(stringsObj.top_trending, constantsObj.FONT_GADUGI_35, constantsObj.COLOR_LIGHT_YELLOW,
             constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 30, 35, 0, 0.5, labelArr, itemBg, 1);
             offset = 20;
             }*/

            var cashIcon = utilObj.getSprite(itemImg, localXPos - 60, yPos, 0.5, 0.5, iconscale);
            itemBg.addChild(cashIcon);

            /*var cashGlow = utilObj.getSprite(constantsObj.BEHIND_GLOW, localXPos + constantsObj.XDIFF_FOR_ITEMS, yPos + offset, 0.5, 0.5, constantsObj.SCALE_ONE_POINT_FOUR);
             itemBg.addChild(cashGlow, zOrder - 100);*/

            localXPos += 90;

            utilObj.getTTFFontLabel(pkg.qty, constantsObj.FONT_ROBOTO_REGULAR_90, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos - 60, yPos, 0, 0.5, labelArr, itemBg, 0);

            localXPos += 625;
            var purchaseButton = utilObj.getButton(500, 150, 0.5, 0.5, localXPos + 20,
                yPos, constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                    obj: 'storePopup',
                    fn: purchaseMethod,
                    screen: constantsObj.SCREEN_STORE,
                    params: {name: pkg.name, qty: pkg.qty, price: pkg.price, pu: pkg.item, type: type},
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: puzLevel,
                        c: "",
                        o: screenName,
                        f: pkg.trackName,
                        g: genus,
                        s: "",
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            purchaseButton.setColor(constantsObj.COLOR_BUTTON_GREEN);
            purchaseButton.setTouchEnabled(false);
            utilObj.addChild(itemBg, purchaseButton);

            var extraXDiff = 65;
            /*if (secCurVariant == constantsObj.EXP_VAR_1 && type == constantsObj.PKG_SEC_CASH) {
             extraXDiff += 50;

             var primaryCashIcon = utilObj.getSprite(constantsObj.cash_glow_black, localXPos - 20, yPos + offset, 0.5, 0.5, constantsObj.SCALE_SPRITE_2);
             itemBg.addChild(primaryCashIcon, 0);
             }*/

            var price = utilObj.formatPrice(pkg.price);
            utilObj.getTTFFontLabel("Buy " + price, constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 20, yPos, 0.5, 0.5, labelArr, itemBg, 0);

            /*if (type == constantsObj.PKG_PU) {
             itemImg = constantsObj.sec_cash;
             var cashIcon = utilObj.getSprite(itemImg, localXPos - 100, yPos + 5, 0.5, 0.5, constantsObj.SCALE_SPRITE_2);
             itemBg.addChild(cashIcon);
             }*/

            utilObj.addLabels(labelArr);
            utilObj.addChild(itemWidget, itemBg);
            utilObj.addChild(listView, itemWidget);
            labelArr = [];
        }
        utilObj.addChild(popupNode, listView, zOrder - 1);
    };

    this.purchaseItemWithPrimary = function (params) {
        economyObj.purchaseWithPrimary(params, storePopup.close, storePopup.close, null);
    };

    this.purchaseItem = function (params) {
        if (popupLayer.earnFreeFtueShown == true) {
            popupLayer.removeEarnFreeFtue();
            return;
        }
        if (popupLayer.watchVideoFtueShown == true) {
            popupLayer.removeWatchVideoFtue();
            return;
        }
        var type = params.type;
        var item = params.name;
        paymentsObj.purchaseItem(item);
        /*return;
         if (type == constantsObj.PKG_PU) {
         item = params.pu;
         var isAvailable = economyObj.isPowerUpAvailable(item);
         if (!isAvailable) {
         utilObj.showMessage(stringsObj.powerup_locked + (economyObj.getPowerUpUnlockAt(item) + 1));
         return;
         }
         var puQty = params.qty;
         var price = params.price;
         var success = economyObj.buyPowerUp(storePopup.performSuccessCallback, null, item, constantsObj.PKG_SEC_CASH, puQty, price);
         if (success) {
         levelMapLayer.updateHud();
         popupLayer.updateHeader();
         storePopup.performSuccessCallback();
         }
         } else {
         paymentsObj.purchaseItem(item);
         }*/
    };

    this.close = function () {
        listView = null;
        firstPurchase = false;
        successCallback = null;
        if (failureCallback != null && performFailureCallBack) {
            var temp = failureCallback;
            failureCallback = null;
            temp();
        }
    };

    this.performSuccessCallback = function () {
        failureCallback = null;
        if (successCallback != null) {
            var temp = successCallback;
            successCallback = null;
            temp();
        }
    };

    this.freeCoins = function () {
        if (popupLayer.watchVideoFtueShown == true) {
            popupLayer.removeWatchVideoFtue();
            return;
        }
        if (popupLayer.earnFreeFtueShown == true) {
            popupLayer.removeEarnFreeFtue();
        }
        var storeVideoVariant = epmObj.getChosenVariant(constantsObj.EXP_STORE_VIDEO_VIEWS);
        var screen = utilObj.getScreenName(curScreen);
        if (adsObj.hasOfferWall()) {
            adsObj.showOfferWall();
            return;
        } else if (storeVideoVariant == constantsObj.EXP_VAR_CONTROL) {
            var coolDownPeriod = 2 * constantsObj.SECONDS_IN_HOUR;
            var firstVideoShownTimeStamp = gameObj.getFirstVideoSeenTimeStamp();
            if (firstVideoShownTimeStamp == null || (utilObj.getCurrentTimestamp() - firstVideoShownTimeStamp) > coolDownPeriod) {
                firstVideoShownTimeStamp = utilObj.getCurrentTimestamp();
                gameObj.setFirstVideoSeenTimeStamp(firstVideoShownTimeStamp);
                if (!(gameObj.isEligibleForVideoAchiement() && gameObj.getAchievementsState(43) == constantsObj.ACHIEVEMENT_IN_PROGRESS)) {
                    gameObj.setNumVideos(0);
                }
            }
            if ((utilObj.getCurrentTimestamp() - firstVideoShownTimeStamp) < coolDownPeriod && gameObj.getNumVideos() < runtimeObj.getNumVideos(constantsObj.EXP_VAR_2 - 1)) {
                if (adsObj.checkRewardedVideo(false)) {
                    popupLayer.showWatchVideoFtue();
                    return;
                }
            }
        }
        performFailureCallBack = false;
        var cb = successCallback;
        successCallback = false;
        popupLayer.popupSetup(screen, false, storePopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: true
        });
        popupLayer.closeWithDefault();
        freeCoinsPopup.show(true, cb, parentLayer);
    };

    this.watch = function () {
        if (popupLayer.earnFreeFtueShown == true) {
            popupLayer.removeEarnFreeFtue();
            return;
        }
        if (popupLayer.watchVideoFtueShown == true) {
            popupLayer.removeWatchVideoFtue();
        }

        var coolDownPeriod = 2 * secondsInAnHour;
        var storeVideoVariant = epmObj.getChosenVariant(constantsObj.EXP_STORE_VIDEO_VIEWS);
        var showFreeCoinsFtue = false;

        var firstVideoShownTimeStamp = gameObj.getFirstVideoSeenTimeStamp();
        if (firstVideoShownTimeStamp == null || (utilObj.getCurrentTimestamp() - firstVideoShownTimeStamp) > coolDownPeriod) {
            firstVideoShownTimeStamp = utilObj.getCurrentTimestamp();
            gameObj.setFirstVideoSeenTimeStamp(firstVideoShownTimeStamp);
            if (!(gameObj.isEligibleForVideoAchiement() && gameObj.getAchievementsState(43) == constantsObj.ACHIEVEMENT_IN_PROGRESS)) {
                gameObj.setNumVideos(0);
            }
        }

        var forcedEarnFreeFtue = false;
        if (storeVideoVariant == constantsObj.EXP_VAR_1) {
            var lastStoreVideoClickedTimeStamp = gameObj.getWatchVideoStoreTimeStamp();
            var currTimeStamp = utilObj.getCurrentTimestamp();
            if (currTimeStamp - lastStoreVideoClickedTimeStamp < constantsObj.SECONDS_IN_HOUR) {
                forcedEarnFreeFtue = true;
            } else {
                gameObj.setWatchVideoStoreTimeStamp(currTimeStamp);
            }
        }

        if (forcedEarnFreeFtue == true) {
            utilObj.delayedCallback(curLayer, popupLayer.showEarnFreeFtue, 0, null, false);
        } else if ((utilObj.getCurrentTimestamp() - firstVideoShownTimeStamp) < coolDownPeriod && gameObj.getNumVideos() < runtimeObj.getNumVideos(constantsObj.EXP_VAR_2 - 1)) {
            if (adsObj.checkRewardedVideo(false)) {
                gameObj.setLastVideoSeenTimeStamp(utilObj.getCurrentTimestamp());
                if (storeVideoVariant == constantsObj.EXP_VAR_2) {
                    popupLayer.closeWithDefault();
                }
                adsObj.showEarnCoinsVideo(screen);
            } else {
                if (storeVideoVariant == constantsObj.EXP_VAR_CONTROL) {
                    showFreeCoinsFtue = true;
                }
                if (showFreeCoinsFtue == true) {
                    utilObj.delayedCallback(curLayer, popupLayer.showEarnFreeFtue, 0, null, false);
                }
                // utilObj.showMessage("No Video Available. Please watch after some time");
            }
        } else {
            var timeRemaining = coolDownPeriod - (utilObj.getCurrentTimestamp() - firstVideoShownTimeStamp);
            utilObj.showMessage("Next video in " + utilObj.formatTime(timeRemaining));
            if (storeVideoVariant == constantsObj.EXP_VAR_CONTROL) {
                showFreeCoinsFtue = true;
            }
            if (showFreeCoinsFtue == true) {
                utilObj.delayedCallback(curLayer, popupLayer.showEarnFreeFtue, 0, null, false);
            }
        }
    };
};