ThemedQuestStartPopup = function () {

    var showWithAnim = true;
    var popupNode = null;
    var cb = null;
    var screen = constantsObj.SCREEN_THEMED_QUEST;

    this.show = function (withAnim) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        if (!themedQuestObj.getQuestState() && !gameObj.getIsThemedQuestFinished() && gameObj.getMastery() > 0) {

            if (gameObj.getThemedQuestLastPopupTimestamp() == null || gameObj.getThemedQuestLastPopupDay() == null || gameObj.getThemedQuestPopupCount() == 0 || gameObj.getThemedQuestPopupCount() == null) {
                gameObj.checkAndSetThemedQuestVersion();
                if (gameObj.getThemedQuestPopupCount() == null) {
                    gameObj.setThemedQuestPopupCount(0);
                }
                gameObj.setThemedQuestLastPopupTimestamp(utilObj.getCurrentTimestamp());
                gameObj.setThemedLastQuestPopupDay(gameObj.getLastLogin());
                gameObj.setThemedQuestPopupCount(gameObj.getThemedQuestPopupCount() + 1);
                popupLayer.checkAndShow(themedQuestStartPopup.delayedShow, null);
            } else if (utilObj.getCurrentTimestamp() - gameObj.getThemedQuestLastPopupTimestamp() >= 7200 && gameObj.getLastLogin() == gameObj.getThemedQuestLastPopupDay() && gameObj.getThemedQuestPopupCount() < 2) {
                gameObj.setThemedQuestLastPopupTimestamp(utilObj.getCurrentTimestamp());
                gameObj.setThemedLastQuestPopupDay(gameObj.getLastLogin());
                gameObj.setThemedQuestPopupCount(gameObj.getThemedQuestPopupCount() + 1);
                popupLayer.checkAndShow(themedQuestStartPopup.delayedShow, constantsObj.TRACK_AUTO);
            } else if (gameObj.getLastLogin() != gameObj.getThemedQuestLastPopupDay()) {
                gameObj.setThemedQuestLastPopupTimestamp(utilObj.getCurrentTimestamp());
                gameObj.setThemedLastQuestPopupDay(gameObj.getLastLogin());
                gameObj.setThemedQuestPopupCount(1);
                popupLayer.checkAndShow(themedQuestStartPopup.delayedShow, constantsObj.TRACK_AUTO);
            }

        }
    };
    this.delayedShow = function (param) {
        // checking ftue conditions
        if (homeLayoutExpNew == constantsObj.EXP_VAR_CONTROL) {
            if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
                return;
            }
            if (!ftueObj.isAchievementFtueShown()) {
                return;
            }
        } else {
            if (!homeObj.checkFtueConditions() || homeLayer.todayAnimRunning) {
                return;
            }
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }
        if(zenModeObj.isBlitzFtueVisible()){
            return ;
        }
        if( gameObj.getExpNewWeeklyQuestVariant() != constantsObj.EXP_VAR_CONTROL){
            homeLayer.hide();
            questMapLayer.show();
            return;
        }

        var source = null;

        // tracking settings
        if (param == undefined) {
            source = constantsObj.TRACK_TQ_AUTO;
        } else {
            source = constantsObj.TRACK_TQ_HOME;
        }

        var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
        var trackO = constantsObj.TRACK_TQ + "easy";
        if ((weeklyQuestExp == constantsObj.EXP_VAR_3 || weeklyQuestExp == constantsObj.EXP_VAR_4) && gameObj.getWeeklyQuestLastWeekMastery() >= runtimeObj.getWeeklyQuestMasteryLimit()) {
            trackO = constantsObj.TRACK_TQ + "hard";
        }

        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", trackO, constantsObj.TRACK_VIEW, source, "", "", "");
        var themedQuestData = themedQuestObj.getThemedQuestData();
        var popupHeight = 1550;
        var labelArr = [];
        var spriteArr = [];

        // fetching all the necessary details from the tq json for the milestone and total stars, current progress
        var totalStars = weeklyQuestObj.getWeeklyQuestTotalstars();
        var starsAchieved = gameObj.getThemedQuestMastery();
        if (starsAchieved > totalStars) {
            starsAchieved = totalStars;
        }

        // setting popup UI parts inituallly
        popupNode = new cc.Node();
        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2;
        var zOrder = constantsObj.UI_Z_ORDER;
        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH, popupHeight, spriteArr, popupNode, constantsObj.BG_Z_ORDER - 1, constantsObj.SPRITE_MISC)

        yPos = centerYPos + popupHeight / 2 - 221;

        var mileStones1 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(0));
        var mileStones2 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(1));
        var mileStones3 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(2));
        var starsText = [mileStones1, mileStones2, mileStones3];
        var themedQuestText = themedQuestData["themedQuestText"];

        // tq main icon placement
        var tq_icon = utilObj.getSprite(constantsObj.themed_quest_progress_icon_1, xPos, yPos, 0.5, 1, constantsObj.SCALE_ONE * 1.725, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);

        yPos -= tq_icon.getContentSize().height * constantsObj.SCALE_ONE * 1.725;
        yPos -= 27.5;

        // tq desc UI
        var color_TQDesctextcc = homeObj.getColorFromStringCode(themedQuestData["TQDesctextcc"]);
        var lbl = utilObj.getBMFontLabel(themedQuestText, constantsObj.FONT_HELVETICA_60, color_TQDesctextcc,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);

        yPos -= 175;

        var totalStarsLabel = 0;
        if (starsAchieved < starsText[0]) {
            totalStarsLabel = starsText[0];
        } else if (starsAchieved >= starsText[0] && starsAchieved < starsText[1]) {
            totalStarsLabel = starsText[1];
        } else if (starsAchieved >= starsText[1] && starsAchieved <starsText[2]) {
            totalStarsLabel = starsText[2];
        } else if(starsAchieved >= starsText[2]){
            totalStarsLabel = starsText[2];
        }


        // current progress text
        var lbl_progress = utilObj.getBMFontLabel("You have collected: " + starsAchieved + "/" + totalStarsLabel, constantsObj.FONT_HELVETICA_55, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);
        lbl_progress.setOpacity(constantsObj.OPACITY_40);

        yPos -= 250;

        // full bg prog bar
        var barWidth = 45;
        var color_PBbarbgcolorcode = homeObj.getColorFromStringCode(themedQuestData["PBbarbgcolorcode"]);
        var progressBarBg = utilObj.getScale9Sprite(constantsObj.full_bar, centerXPos, yPos, 0.5, 0.5, constantsObj.POPUP_WIDTH - 300, barWidth, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        progressBarBg.setColor(color_PBbarbgcolorcode);
        progressBarBg.setOpacity(constantsObj.OPACITY_10);

        var len = (starsAchieved / totalStars) * (constantsObj.POPUP_WIDTH - 300);

        // progress bar acc. to progress of user
        var color_pbBarFillColorCode = homeObj.getColorFromStringCode(themedQuestData["PBbarfillcolorcode"]);
        var progressBar = utilObj.getScale9Sprite(constantsObj.full_bar, centerXPos - (constantsObj.POPUP_WIDTH - 300) / 2, yPos, 0, 0.5, len, barWidth, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        progressBar.setColor(color_pbBarFillColorCode);

        // arr for gift arr with scalings
        var tqGiftsArr = [constantsObj.tq_gift1, constantsObj.tq_gift2, constantsObj.tq_gift3];
        var tqOpenGiftsArr = [constantsObj.tq_gift_open1, constantsObj.tq_gift_open2, constantsObj.tq_gift_open3];
        var scalingArr = [constantsObj.SCALE_ONE * 1.08, constantsObj.SCALE_ONE * 1.325, constantsObj.SCALE_ONE * 1.65];

        // variable for the showing of the desc on the nearest milestone if unfinished
        var showMoreToGo = false;

        // setting gift boxes and tick, milestone desc UI
        for (var i = 1; i <= 3; i++) {

            // setting the completed gift box to the UI
            if (starsAchieved >= starsText[i - 1]) {
                var progressBarIconStart2 = utilObj.getSprite(tqOpenGiftsArr[i - 1], centerXPos - (constantsObj.POPUP_WIDTH - 300) / 2 + (starsText[i - 1] / totalStars) * (constantsObj.POPUP_WIDTH - 300), yPos - barWidth / 2 - 10, 0.5, 0, scalingArr[i - 1] * 1.35, null, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
                // progressBarIconStart2.setColor(constantsObj.COLOR_RED_TICK);
                utilObj.addChild(popupNode, progressBarIconStart2, zOrder);

                var tick = utilObj.getSprite(constantsObj.tick, centerXPos - (constantsObj.POPUP_WIDTH - 300) / 2 + (starsText[i - 1] / totalStars) * (constantsObj.POPUP_WIDTH - 300) + 12, yPos + barWidth + 65, 0, 0, constantsObj.SCALE_SPRITE_18, null, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
                utilObj.addChild(popupNode, tick, zOrder);
                tick.setColor(constantsObj.COLOR_GREEN);

            } else {
                // milestone desc condition
                // runs only ince if any miletstone is completed and nearest
                if (!showMoreToGo) {
                    showMoreToGo = true;
                    var xLocal = centerXPos - (constantsObj.POPUP_WIDTH - 300) / 2 + (starsText[i - 1] / totalStars) * (constantsObj.POPUP_WIDTH - 300);

                    // Progress pointer for the arrow in the UI
                    var color_milestoneDescBgcc = homeObj.getColorFromStringCode(themedQuestData["Milestonedescbgcc"]);
                    var color_tQmilestoneRemTextcc = homeObj.getColorFromStringCode(themedQuestData["TQmilestoneremtextcc"]);
                    var progressPointer = utilObj.getSprite(constantsObj.themed_quest_progress_pointer, xLocal, yPos - barWidth / 2 - 20, 0.5, 1, constantsObj.SCALE_ONE * 1.5, null, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
                    progressPointer.setColor(color_milestoneDescBgcc);
                    // progressPointer.setOpacity(constantsObj.OPACITY_20);
                    utilObj.addChild(popupNode, progressPointer, zOrder);

                    var yLocal = yPos - barWidth / 2 - 20 - (progressPointer.getContentSize().height * constantsObj.SCALE_ONE * 1.5);

                    // Anchor setting based on the pos of the bg
                    // It can be at 3 places because of 3 milestones, hence adjusted acc. to the placement
                    // i value -> milestone index
                    var xAnchorBg = 0.2;
                    var xAnchorTxt = 0.12;
                    if (i == 2) {
                        xAnchorBg = 0.5;
                        xAnchorTxt = 0.5;
                    } else if (i == 3) {
                        xAnchorBg = 0.8;
                        xAnchorTxt = 0.85;
                    }

                    var widthOftileBg = 500;
                    var txt = starsText[i - 1] - starsAchieved;
                    if (txt < 10) {
                        widthOftileBg = 470;
                    }
                    txt += " more";

                    // adding text with the image in between and text atlast
                    // gives the milestone desc for the UI
                    var tileBg = utilObj.getScale9Sprite(constantsObj.white_rounded_3, xLocal, yLocal, xAnchorBg, 1, widthOftileBg, 100, null, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
                    tileBg.setColor(color_milestoneDescBgcc);
                    utilObj.addChild(popupNode, tileBg, zOrder);

                    var lblPart1 = utilObj.getBMFontLabel(txt, constantsObj.FONT_HELVETICA_55, color_tQmilestoneRemTextcc,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xLocal - (widthOftileBg * xAnchorBg) + 20, yLocal - 50, 0, 0.5, labelArr, popupNode, zOrder);

                    var smileIcon = utilObj.getSprite(constantsObj.themed_quest_progress_icon_2, xLocal - (widthOftileBg * xAnchorBg) + 20 + lblPart1.getContentSize().width, yLocal - 50, 0, 0.5, constantsObj.SCALE_ONE * 0.75, null, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
                    utilObj.addChild(popupNode, smileIcon, zOrder);

                    utilObj.getBMFontLabel(" to go!", constantsObj.FONT_HELVETICA_55, color_tQmilestoneRemTextcc,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xLocal - (widthOftileBg * xAnchorBg) + 20 + lblPart1.getContentSize().width + (smileIcon.getContentSize().width * constantsObj.SCALE_ONE * 0.75), yLocal - 50, 0, 0.5, labelArr, popupNode, zOrder);

                }

                // InProgress gift boxes UI
                var progressBarIconStart2 = utilObj.getSprite(tqGiftsArr[i - 1], centerXPos - (constantsObj.POPUP_WIDTH - 300) / 2 + (starsText[i - 1] / totalStars) * (constantsObj.POPUP_WIDTH - 300), yPos - barWidth / 2 - 10, 0.5, 0, scalingArr[i - 1], null, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
                utilObj.addChild(popupNode, progressBarIconStart2, zOrder);
            }
        }

        yPos -= 320;

        // play button UI
        var startButton = utilObj.getButton(400, 170, 0.5, 0.5, xPos, yPos,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'themedQuestStartPopup',
                fn: 'start',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: "",
                    c: "",
                    o: constantsObj.TRACK_TQ,
                    f: constantsObj.TRACK_START,
                    g: param,
                    s: "",
                    co: "",
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        var color_playButtonColorCode = homeObj.getColorFromStringCode(themedQuestData["Playbuttoncolorcode"]);
        startButton.setColor(color_playButtonColorCode);
        utilObj.addChild(popupNode, startButton, zOrder);
        utilObj.pulseButton(startButton, constantsObj.PULSE_ACTION_TAG, 0);
        var startText = themedQuestData["Playbuttontext"];

        // play button text
        var startButtonTxt = utilObj.getBMFontLabel(startText, constantsObj.FONT_HELVETICA_MEDIUM_90, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, popupNode, zOrder);
        utilObj.pulseButton(startButtonTxt, constantsObj.PULSE_ACTION_TAG, 0);

        // tq timer label
        yPos -= 140;
        var tqTimerLabel = utilObj.getBMFontLabel(themedQuestObj.getTqPopupTimerText(), constantsObj.FONT_HELVETICA_55, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 0.5, labelArr, popupNode, zOrder);
        tqTimerLabel.setOpacity(constantsObj.OPACITY_40);
        themedQuestObj.setTqPopupTimerLabel(tqTimerLabel);

        utilObj.addSprites(spriteArr);

        // setting for the placement for the popup to the handler popup.js
        popupLayer.popupSetup(screen, false, themedQuestStartPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });

        popupLayer.show(popupHeight, screen, themedQuestData["TQtitletext"], popupNode, labelArr, true);
    };

    // calls on the closing call of the popup
    this.close = function () {
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", constantsObj.TRACK_TQ, constantsObj.TRACK_CLOSE, "", "", "", "");
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    // sets the callback for the popup on closing
    this.start = function (params) {
        popupLayer.setDontGoToLastScreen(true);
        popupLayer.setPopupCallback(themedQuestStartPopup.gameScreen, params);
        popupLayer.closeWithDefault();
    };

    // opens the relevant screen after users clicks on play button functionality
    // callback is set in the above function
    // opens calendar, game screen or home screen based on conditions
    this.gameScreen = function () {
        if (gameObj.getIsAnimShown()) {
            return;
        }
        if (homeLayoutExpNew == constantsObj.EXP_VAR_CONTROL) {
            if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
                return;
            }
        } else {
            if (!homeObj.checkFtueConditions() || homeLayer.todayAnimRunning) {
                return;
            }
        }
        if(zenModeObj.isBlitzFtueVisible()){
            return ;
        }
        if(gameObj.getExpNewWeeklyQuestVariant() != constantsObj.EXP_VAR_CONTROL){
            homeLayer.hide();
            questMapLayer.show();
            return;
        }
        var completed = gameObj.getTodaysPuzzleCompleted();
        if (completed) {
            //themedQuestStartPopup.close();
            homeLayer.hide();
            calendarLayer.selectedTab = constantsObj.CALENDAR_SCREEN;
            calendarLayer.show();
        } else {
            if (gameObj.getCrosswordForDate(gameObj.getIdForTodaysPuzzle()) == null) {
                return;
            }
            homeLayer.hide();
            gameLayer.show(gameObj.getIdForTodaysPuzzle(), false);
        }
    };
};