UnlockAllPuzzlesPopup = function () {
    var popupNode = null;
    var showWithAnim = true;
    var cb = null;
    var screen = constantsObj.SCREEN_UNLOCK_ALL_PUZZLES;
    var month = null;
    var year = constantsObj.YEAR_START;
    var coinsToUnlockAll = null;
    var lockedPuzzleCount = null;

    this.show = function (selectedMonth, fullyear) {
        month = selectedMonth;
        year = fullyear;
        var labelArr = [];
        var popupHeight = 850 + constantsObj.POPUP_START_OFFSET;
        popupNode = new cc.Node();
        var text = "";
        var icon = null;

        var puzzleId = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
        lockedPuzzleCount = utilObj.getLockedPuzzleCount(selectedMonth, fullyear);
        coinsToUnlockAll = lockedPuzzleCount * economyObj.getRevealCrosswordCost();

        var popupBgHeight = popupHeight - constantsObj.POPUP_START_OFFSET;

        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2 - constantsObj.POPUP_START_OFFSET;
        var zOrder = constantsObj.UI_Z_ORDER;
        var headerText = "";
        var iconScale = null;
        var monthName = utilObj.getMonth(selectedMonth - 1);

        headerText = stringsObj.archive;
        icon = constantsObj.calendar_png;
        iconScale = constantsObj.SCALE_SPRITE_13;
        text = "Unlock %X% puzzles from %M% for %N% Coins?";
        text = text.replace("%X%", lockedPuzzleCount);
        text = text.replace("%M%", monthName);
        text = text.replace("%N%", coinsToUnlockAll);

        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH, popupBgHeight, null, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        utilObj.addChild(popupNode, popupBg);

        yPos -= 220;

        var powerupIcon = utilObj.getSprite(icon, xPos, yPos, 0.5, 0.5, iconScale);
        powerupIcon.setColor(constantsObj.COLOR_BLACK);
        utilObj.addChild(popupNode, powerupIcon, zOrder);
        yPos -= 190;

        var stringsArr = utilObj.getSplitStringsArr(text, 24);
        for (var i = 0; i < stringsArr.length; i++) {
            utilObj.getTTFFontLabel(stringsArr[i], constantsObj.FONT_ROBOTO_REGULAR_70, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, popupNode, zOrder);
            yPos -= 80;
        }

        yPos -= 50;

        var continueButton = utilObj.getButton(470, 170, 0.5, 1.0, xPos, yPos,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'unlockAllPuzzlesPopup',
                fn: 'continue',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_UNLOCK_ALL,
                    f: constantsObj.TRACK_CONTINUE,
                    g: "",
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        continueButton.setColor(constantsObj.COLOR_BUTTON_LIGHT_BLUE);
        utilObj.addChild(popupNode, continueButton, zOrder);
        utilObj.getTTFFontLabel("Continue", constantsObj.FONT_ROBOTO_MEDIUM_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 235, 85, 0.5, 0.5, labelArr, continueButton, zOrder);
        utilObj.pulseButton(continueButton, constantsObj.PULSE_ACTION_TAG, 0);

        popupLayer.popupSetup(screen, false, unlockAllPuzzlesPopup.close, null, false, {
            noAnim: true,
            dontGoToLastScreen: false
        });
        popupLayer.show(popupHeight, screen, headerText, popupNode, labelArr, true, null, null);
    };

    this.close = function () {
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.continue = function () {
        popupLayer.closeWithDefault();
        // loggerObj.debugLog("coming to this point");
        // unlockAllPuzzlesPopup.close();
        var date1 = gameObj.getTodaysPuzzleDate();
        //month = date1.getMonth() + 1;
        //year = date1.getFullYear();
        var day = date1.getDate();
        var monthStr = "";
        if (month < 10) {
            monthStr = "0" + month;
        } else {
            monthStr += month;
        }
        var daystr = "";
        if(day<10) {
            daystr = "0" + day;
        }else {
            daystr += day;
        }
        var date = year+monthStr+daystr;
        // loggerObj.debugLog("date for current month",date);
        if( gameObj.getCrosswordForDate(date) == null){
            utilObj.showMessage("No puzzles available for this month");
            return;
        }
        if (lockedPuzzleCount != 0) {
            if (!economyObj.makePayment(null, null, constantsObj.PKG_CASH, coinsToUnlockAll, constantsObj.TRACK_UNLOCK_ALL, "", calendarLayer)) {
                return false;
            }
            utilObj.unlockAllPuzzles(month, year);
            calendarLayer.redraw();
        } else {
            utilObj.showMessage("No puzzles available to buy for this month");
        }
    };

};
