WeeklyQuestIntroPopup = function () {


    var showWithAnim = true;
    var popupNode = null;
    var cb = null;
    var screen = constantsObj.SCREEN_WEEKLY_INTRO_POPUP;

    this.show = function (withAnim) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }

        if (!weeklyQuestObj.getQuestState()) {
            this.delayedShow();
        }
    };
    this.delayedShow = function (param) {
        if (homeLayoutExpNew == constantsObj.EXP_VAR_CONTROL) {
            if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
                return;
            }
        } else {
            if (!homeObj.checkFtueConditions() || homeLayer.todayAnimRunning) {
                return;
            }
        }

        gameObj.setShowCoinGrantMessage(true);

        var source = null;

        if (param == undefined) {
            source = constantsObj.TRACK_WQ_AUTO;
        } else {
            source = constantsObj.TRACK_WQ_HOME;
        }
        machineLearningDataObj.incNumAutoPopupsShown();
        gameObj.setIsWeeklyQuestIntroPopupEligible(false);

        var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
        var trackO = constantsObj.TRACK_WQ + "easy";
        if ((weeklyQuestExp == constantsObj.EXP_VAR_3 || weeklyQuestExp == constantsObj.EXP_VAR_4) && gameObj.getWeeklyQuestLastWeekMastery() >= runtimeObj.getWeeklyQuestMasteryLimit()) {
            trackO = constantsObj.TRACK_WQ + "hard";
        }
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", trackO, constantsObj.TRACK_VIEW, source, "", "", "");
        //var weeklyQuestData = weeklyQuestObj.getWeeklyQuestData();
        var popupHeight = 1300 + constantsObj.POPUP_START_OFFSET;
        var labelArr = [];
        var spriteArr = [];

        var starsAchieved = gameObj.getWeeklyQuestMastery();
        if (starsAchieved > weeklyQuestObj.getWeeklyQuestTotalstars()) {
            starsAchieved = weeklyQuestObj.getWeeklyQuestTotalstars();
        }
        popupNode = new cc.Node();
        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2 - constantsObj.POPUP_START_OFFSET;
        var zOrder = constantsObj.UI_Z_ORDER;
        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH, popupHeight - constantsObj.POPUP_START_OFFSET, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        var totalStars = weeklyQuestObj.getWeeklyQuestTotalstars();
        var coinsText = null;

        var mileStones1 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(0));
        var mileStones2 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(1));
        var mileStones3 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(2));
        var starsText = [mileStones1, mileStones2, mileStones3];
        var weeklyQuestText = "Solve any puzzle to collect stars\nand win prizes!";
        var factor = canvasWidth / 1440.0;
        var coins = null;
        var todaysDate1 = gameObj.getTodaysPuzzleDate();
        var todaysDate2 = gameObj.getTodaysPuzzleDate();
        var todayDateDay = todaysDate1.getDay();
        var newDate = new Date();
        newDate.setDate(todaysDate1.getDate() + (6 - todayDateDay));
        var formattedEndDate = utilObj.getFormattedDate1(newDate);
        var newDate1 = new Date();
        newDate1.setDate(todaysDate2.getDate() - todayDateDay);
        var formattedStartDate = utilObj.getFormattedDate1(newDate1);
        // loggerObj.debugLog("qwertyu", formattedEndDate, formattedStartDate, newDate, newDate1, todayDateDay);


        var popupOffset = 200;

        utilObj.getBMFontLabel(formattedStartDate + " To " + formattedEndDate, constantsObj.FONT_SFCOMPACT_REGULAR_60, constantsObj.COLOR_DATE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos - 100, 0.5, 0.5, labelArr, popupNode, zOrder);


        utilObj.getBMFontLabel(weeklyQuestText, constantsObj.FONT_SFCOMPACT_REGULAR_70, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos - 260, 0.5, 0.5, labelArr, popupNode, zOrder);


        var progressBg = utilObj.getScale9Sprite(constantsObj.full_bar, xPos, yPos - 600 + popupOffset, 0.5, 1, constantsObj.POPUP_WIDTH - 100, 500, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        progressBg.setColor(constantsObj.COLOR_WEEKLY_PROGRESS);

        var starLocationX = [148, 601, 920, 1198];
        var len = (starsAchieved / totalStars) * (constantsObj.POPUP_WIDTH - 370);

        utilObj.getBMFontLabel("Play", constantsObj.FONT_ROBOTO_BOLD_80, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos - 450, yPos - 500, 0.5, 0.5, labelArr, popupNode, zOrder);
        utilObj.getBMFontLabel("Earn", constantsObj.FONT_ROBOTO_BOLD_80, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos - 500, 0.5, 0.5, labelArr, popupNode, zOrder);
        utilObj.getBMFontLabel("Win", constantsObj.FONT_ROBOTO_BOLD_80, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos + 450, yPos - 500, 0.5, 0.5, labelArr, popupNode, zOrder);


        var playImage = utilObj.getSprite(constantsObj.icons_calendar, xPos - 450,
            yPos - 930 + popupOffset, 0.5, 0.5, constantsObj.SCALE_SPRITE_18 * 2.7 * 0.8, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);

        var earnImage = utilObj.getSprite(constantsObj.star_white_2, xPos,
            yPos - 930 + popupOffset, 0.5, 0.5, constantsObj.SCALE_SPRITE_18 * 3.6 * 0.8, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        earnImage.setColor(constantsObj.COLOR_BLUE_01);

        var winImage = utilObj.getSprite(constantsObj.weekly_quest_reward3, xPos + 450,
            yPos - 930 + popupOffset, 0.5, 0.5, constantsObj.SCALE_SPRITE_18 * 1.8 * 0.8, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);


        var startButton = utilObj.getButton(500, 170, 0.5, 1.0, xPos, yPos - 1250 + popupOffset,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'weeklyQuestIntroPopup',
                fn: 'start',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: "",
                    c: "",
                    o: trackO,
                    f: constantsObj.TRACK_START,
                    g: param,
                    s: "",
                    co: "",
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        startButton.setColor(constantsObj.COLOR_BUTTON_GREEN);
        utilObj.addChild(popupNode, startButton, zOrder);
        utilObj.pulseButton(startButton, constantsObj.PULSE_ACTION_TAG, 0);
        var startText = "Let's Play!";

        var startButtonTxt = utilObj.getTTFFontLabel(startText, constantsObj.FONT_ROBOTO_REGULAR_90, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos - 1280 + popupOffset, 0.5, 1, labelArr, popupNode, zOrder);
        utilObj.pulseButton(startButtonTxt, constantsObj.PULSE_ACTION_TAG, 0);


        var wqTimerLabel = utilObj.getTTFFontLabel(weeklyQuestObj.getWqPopupTimerText(), constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - 1180 + popupOffset, 0.5, 0.5, labelArr, popupNode, zOrder);
        weeklyQuestObj.setWqPopupTimerLabel(wqTimerLabel);

        utilObj.addSprites(spriteArr);

        popupLayer.popupSetup(screen, false, weeklyQuestIntroPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });

        popupLayer.show(popupHeight, screen, "Weekly Quest", popupNode, labelArr, true, null, null, null, null, null, null, null, constantsObj.COLOR_WQ_HS, constantsObj.COLOR_WHITE, constantsObj.themed_quest_popup_header);

        gameObj.setShowCoinGrantMessage(false);

    };

    this.close = function () {
        // popupLayer.dontGoToLastScreen = false;
        //popupLayer.closeWithDefault();
        var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
        var trackO = constantsObj.TRACK_WQ + "easy";
        if ((weeklyQuestExp == constantsObj.EXP_VAR_3 || weeklyQuestExp == constantsObj.EXP_VAR_4) && gameObj.getWeeklyQuestLastWeekMastery() >= runtimeObj.getWeeklyQuestMasteryLimit()) {
            trackO = constantsObj.TRACK_WQ + "hard";
        }
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", trackO, constantsObj.TRACK_CLOSE, "", "", "", "");
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.start = function (params) {
        popupLayer.setDontGoToLastScreen(true);
        popupLayer.setPopupCallback(weeklyQuestIntroPopup.gameScreen, params);
        popupLayer.closeWithDefault();
    };

    this.gameScreen = function () {
        if (homeLayoutExpNew == constantsObj.EXP_VAR_CONTROL) {
            if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
                return;
            }
        } else {
            if (!homeObj.checkFtueConditions() || homeLayer.todayAnimRunning) {
                return;
            }
        }
        var completed = gameObj.getTodaysPuzzleCompleted();
        if (completed) {
            //themedQuestStartPopup.close();
            homeLayer.hide();
            calendarLayer.show();
        } else {
            if (gameObj.getCrosswordForDate(gameObj.getIdForTodaysPuzzle()) == null) {
                return;
            }
            //themedQuestStartPopup.close();
            homeLayer.hide();
            gameLayer.show(gameObj.getIdForTodaysPuzzle(), false);
        }
    };
};
