WeeklyQuestStartPopup = function () {


    var showWithAnim = true;
    var popupNode = null;
    var cb = null;
    var screen = constantsObj.SCREEN_WEEKLY_START_POPUP;

    this.show = function (withAnim) {
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }

        if (!weeklyQuestObj.getQuestState()) {
            this.delayedShow();
        }
    };
    this.delayedShow = function (param) {
        if (homeLayoutExpNew == constantsObj.EXP_VAR_CONTROL) {
            if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
                return;
            }
            if (!ftueObj.isAchievementFtueShown()) {
                return;
            }
        } else {
            if (!homeObj.checkFtueConditions() || homeLayer.todayAnimRunning) {
                return;
            }
        }
        if (gameObj.getIsAnimShown()) {
            return;
        }
        if(zenModeObj.isBlitzFtueVisible()){
            return ;
        }
        if(gameObj.getExpNewWeeklyQuestVariant() != constantsObj.EXP_VAR_CONTROL){
            homeLayer.hide();
            questMapLayer.show();
            return;
        }

        gameObj.setShowCoinGrantMessage(true);

        var source = null;

        if (param == undefined) {
            source = constantsObj.TRACK_WQ_AUTO;
        } else {
            source = constantsObj.TRACK_WQ_HOME;
        }
        machineLearningDataObj.incNumAutoPopupsShown();

        var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
        var trackO = constantsObj.TRACK_WQ + "easy";
        if ((weeklyQuestExp == constantsObj.EXP_VAR_3 || weeklyQuestExp == constantsObj.EXP_VAR_4) && gameObj.getWeeklyQuestLastWeekMastery() >= runtimeObj.getWeeklyQuestMasteryLimit()) {
            trackO = constantsObj.TRACK_WQ + "hard";
        }
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", trackO, constantsObj.TRACK_VIEW, source, "", "", "");
        //var weeklyQuestData = weeklyQuestObj.getWeeklyQuestData();
        var popupHeight = 1300 + constantsObj.POPUP_START_OFFSET;
        var labelArr = [];
        var spriteArr = [];

        var starsAchieved = gameObj.getWeeklyQuestMastery();
        if (starsAchieved > weeklyQuestObj.getWeeklyQuestTotalstars()) {
            starsAchieved = weeklyQuestObj.getWeeklyQuestTotalstars()
        }
        popupNode = new cc.Node();
        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2 - constantsObj.POPUP_START_OFFSET;
        var zOrder = constantsObj.UI_Z_ORDER;
        var popupBg = utilObj.getScale9Sprite(constantsObj.popup_bg, xPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH, popupHeight - constantsObj.POPUP_START_OFFSET, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        var totalStars = weeklyQuestObj.getWeeklyQuestTotalstars();
        var totalStarsLabel = 0;
        var coinsText = null;

        var mileStones1 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(0));
        var mileStones2 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(1));
        var mileStones3 = parseInt(weeklyQuestObj.getWeeklyQuestMilestones(2));
        var starsText = [mileStones1, mileStones2, mileStones3];
        var weeklyQuestText = "Solve any puzzle to collect stars\nand win prizes!";
        var factor = canvasWidth / 1440.0;
        var coins = null;
        var todaysDate1 = gameObj.getTodaysPuzzleDate();
        var todaysDate2 = gameObj.getTodaysPuzzleDate();
        var todayDateDay = todaysDate1.getDay();
        var newDate = new Date();
        newDate.setDate(todaysDate1.getDate() + (6 - todayDateDay));
        var formattedEndDate = utilObj.getFormattedDate1(newDate);
        var newDate1 = new Date();
        newDate1.setDate(todaysDate2.getDate() - todayDateDay);
        var formattedStartDate = utilObj.getFormattedDate1(newDate1);
        // loggerObj.debugLog("qwertyu", formattedEndDate, formattedStartDate, newDate, newDate1, todayDateDay);

        var popupOffset = 200;
        //formattedStartDate+" To "+formattedEndDate
        utilObj.getBMFontLabel(formattedStartDate + " To " + formattedEndDate, constantsObj.FONT_SFCOMPACT_REGULAR_60, constantsObj.COLOR_DATE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos - 100, 0.5, 0.5, labelArr, popupNode, zOrder);


        utilObj.getBMFontLabel(weeklyQuestText, constantsObj.FONT_SFCOMPACT_REGULAR_70, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos - 260, 0.5, 0.5, labelArr, popupNode, zOrder);

        // utilObj.getBMFontLabel(themedQuestText, constantsObj.FONT_ROBOTO_REGULAR_80, constantsObj.COLOR_BLACK,
        //     constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos - 250, 0.5, 0.5, labelArr, popupNode, zOrder);

        // var flag = utilObj.getSprite(constantsObj.themed_quest_bottom_bg, xPos, yPos - 1250, 0.5, 1, constantsObj.SCALE_SPRITE_51, spriteArr, popupNode, zOrder);

        var progressBg = utilObj.getScale9Sprite(constantsObj.full_bar, xPos, yPos - 600 + popupOffset, 0.5, 1, constantsObj.POPUP_WIDTH - 100, 500, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        progressBg.setColor(constantsObj.COLOR_WEEKLY_PROGRESS);
        // progressBg.setOpacity(35);

        // var starBg = utilObj.getSprite(constantsObj.star_white_2, xPos - 120, yPos - 580, 0.5, 0.5, constantsObj.SCALE_SPRITE_19, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        // starBg.setColor(constantsObj.COLOR_GREY_16);
        // starBg.setOpacity(70);

        // var star = utilObj.getSprite(constantsObj.star_white_2, xPos - 120, yPos - 580, 0.5, 0.5, constantsObj.SCALE_SPRITE_11, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        // star.setColor(constantsObj.COLOR_BLUE_01);


        var progressBarBg = utilObj.getScale9Sprite(constantsObj.full_bar, xPos - 390, yPos - 800 + popupOffset, 0, 0.5, constantsObj.POPUP_WIDTH - 370, popupHeight - constantsObj.POPUP_START_OFFSET - 1234, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        progressBarBg.setColor(constantsObj.COLOR_PROGRESS_BAR_FULL_HOME);
        // progressBarBg.setOpacity(70);


        var starLocationX = [148, 601, 920, 1198];
        var len = (starsAchieved / totalStars) * (constantsObj.POPUP_WIDTH - 370);
        // if (starsAchieved <= 15) {
        //     len = (starsAchieved * (starLocationX[1] - starLocationX[0])) / 15;
        // } else if (starsAchieved > 15 && starsAchieved <= 35) {
        //     len = (starLocationX[1] - starLocationX[0]) + ((starsAchieved - 15) * (starLocationX[2] - starLocationX[1])) / 20;
        // } else {
        //     len = (starLocationX[2] - starLocationX[0]) + ((starsAchieved - 35) * (starLocationX[3] - starLocationX[2])) / 15;
        // }
        var progressBar = utilObj.getScale9Sprite(constantsObj.full_bar, xPos - 390, yPos - 800 + popupOffset, 0, 0.5, len, popupHeight - constantsObj.POPUP_START_OFFSET - 1234, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        progressBar.setColor(constantsObj.COLOR_WEEKLY_QUEST_HEADER);


        var progressBarIconStart = utilObj.getSprite(constantsObj.weekly_quest_icon, xPos - 470, yPos - 800 + popupOffset, 0.5, 0.5, constantsObj.SCALE_SPRITE_18 * 1.2, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);

        // var coin = utilObj.getSprite(constantsObj.coin_png_2, xPos + 400, yPos - 340, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);

        for (var i = 1; i <= 3; i++) {
            if (starsAchieved >= starsText[i - 1]) {
                var progressBarIconStart2 = utilObj.getSprite(constantsObj.tick, xPos - 400 + (starsText[i - 1] / totalStars) * (constantsObj.POPUP_WIDTH - 370), yPos - 730 + popupOffset + 10, 0.5, 0.5, constantsObj.SCALE_SPRITE_18 * 1.8, null, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
                progressBarIconStart2.setColor(constantsObj.COLOR_BLUE_01);
                utilObj.addChild(popupNode, progressBarIconStart2, zOrder);

            } else {
                var progressBarIconStart2Text = utilObj.getBMFontLabel(starsText[i - 1], constantsObj.FONT_SFCOMPACT_MEDIUM_50, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 400 + (starsText[i - 1] / totalStars) * (constantsObj.POPUP_WIDTH - 370), yPos - 710 + popupOffset - 10, 0.5, 0.5, labelArr, popupNode, zOrder);


                var progressBarIconStart2 = utilObj.getSprite(constantsObj.star_white_2, xPos - 400 + (starsText[i - 1] / totalStars) * (constantsObj.POPUP_WIDTH - 370), yPos - 710 + popupOffset, 0.5, 0.5, constantsObj.SCALE_SPRITE_18 * 1.8 * 1.2, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
                progressBarIconStart2.setColor(constantsObj.COLOR_BLUE_01);
            }

            var progressPointer = utilObj.getSprite(constantsObj.themed_quest_progress_pointer, xPos - 400 + (starsText[i - 1] / totalStars) * (constantsObj.POPUP_WIDTH - 370), yPos - 865 + popupOffset, 0.5, 0.5, constantsObj.SCALE_SPRITE_18 * 1.5, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
            progressPointer.setColor(constantsObj.COLOR_DATE);
            progressPointer.setRotation(180);


            // utilObj.getTTFFontLabel(coinsText[i - 1], constantsObj.FONT_ROBOTO_REGULAR_50, constantsObj.COLOR_BLACK,
            //     constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 125 + (i - 1) * 318, yPos - 750, 0.5, 0.5, labelArr, popupNode, zOrder);
            //utilObj.getBMFontLabel(coinsText[i - 1], constantsObj.FONT_SFCOMPACT_MEDIUM_50, constantsObj.COLOR_WHITE,
            //constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 400 + (starsText[i-1] / totalStars) * (constantsObj.POPUP_WIDTH - 370), yPos - 910 + popupOffset, 0.5, 0.5, labelArr, popupNode, zOrder);changed

            // var starBg1 = utilObj.getSprite(constantsObj.star_white_2, xPos - 120 + (i - 1) * 318, yPos - 884, 0.5, 0.5, constantsObj.SCALE_SPRITE_25, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
            // starBg1.setColor(constantsObj.COLOR_BLACK);
            //
            // var star1 = utilObj.getSprite(constantsObj.star_white_2, xPos - 120 + (i - 1) * 318, yPos - 884, 0.5, 0.5, constantsObj.SCALE_SPRITE_20, spriteArr, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
            // star1.setColor(constantsObj.COLOR_BLUE_01);

            // utilObj.getTTFFontLabel(starsText[i - 1], constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_BLACK,
            //     constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 120 + (i - 1) * 318, yPos - 890, 0.5, 0.5, labelArr, popupNode, zOrder);

            // utilObj.getBMFontLabel(starsText[i - 1], constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_BLACK,
            //     constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos - 120 + (i - 1) * 318, yPos - 890, 0.5, 0.5, labelArr, popupNode, zOrder);
            // loggerObj.debugLog("x pos", xPos - 120 + (i - 1) * 318);
        }
        var wqGiftsArr = [constantsObj.tq_gift1, constantsObj.tq_gift2, constantsObj.tq_gift3];
        var wqOpenGiftsArr = [constantsObj.tq_gift_open1, constantsObj.tq_gift_open2, constantsObj.tq_gift_open3];
        var scalingArr = [constantsObj.SCALE_ONE * 1.08, constantsObj.SCALE_ONE * 1.25, constantsObj.SCALE_ONE * 1.4];

        for (var  i = 0; i < 3; i++) {
            if (starsAchieved < starsText[i]) {
                var mysteryRewardIcon = utilObj.getSprite(wqGiftsArr[i], xPos - 400 + (starsText[i] / totalStars) * (constantsObj.POPUP_WIDTH - 370),
                    yPos - 1060 + popupOffset, 0.5, 0, scalingArr[i], null, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
                utilObj.addChild(popupNode, mysteryRewardIcon, constantsObj.BG_Z_ORDER + 10);
            } else {
                var mysteryRewardIcon = utilObj.getSprite(wqOpenGiftsArr[i], xPos - 400 + (starsText[i] / totalStars) * (constantsObj.POPUP_WIDTH - 370),
                    yPos - 1060 + popupOffset, 0.5, 0, scalingArr[i], null, popupNode, constantsObj.BG_Z_ORDER + 1, constantsObj.SPRITE_MISC);
                utilObj.addChild(popupNode, mysteryRewardIcon, constantsObj.BG_Z_ORDER + 10);
            }
        }
        // utilObj.getTTFFontLabel(starsAchieved + "/" + totalStars, constantsObj.FONT_ROBOTO_REGULAR_100, constantsObj.COLOR_BLACK,
        //     constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 100, yPos - 595, 0.5, 0.5, labelArr, popupNode, zOrder);
        if (starsAchieved < starsText[0]) {
            totalStarsLabel = starsText[0];
        } else if (starsAchieved >= starsText[0] && starsAchieved < starsText[1]) {
            totalStarsLabel = starsText[1];
        } else if (starsAchieved >= starsText[1] && starsAchieved <starsText[2]) {
            totalStarsLabel = starsText[2];
        } else if(starsAchieved >= starsText[2]){
            totalStarsLabel = starsText[2];
        }

        utilObj.getBMFontLabel(starsAchieved + "/" + totalStarsLabel, constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + 70, yPos - 600, 0.5, 0.5, labelArr, popupNode, zOrder);


        var startButton = utilObj.getButton(500, 170, 0.5, 1.0, xPos, yPos - 1250 + popupOffset,
            constantsObj.button_cutup, constantsObj.button_cutup, constantsObj.button_cutup, {
                obj: 'weeklyQuestStartPopup',
                fn: 'start',
                screen: screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: "",
                    c: "",
                    o: trackO,
                    f: constantsObj.TRACK_START,
                    g: param,
                    s: "",
                    co: "",
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        startButton.setColor(constantsObj.COLOR_BUTTON_GREEN);
        utilObj.addChild(popupNode, startButton, zOrder);
        utilObj.pulseButton(startButton, constantsObj.PULSE_ACTION_TAG, 0);
        var startText = "Let's Play!";
        // if (starsAchieved >= starsText[0] && starsAchieved < starsText[1]) {
        //          startText ="CONTINUE";
        //
        // } else if (starsAchieved >= starsText[1] && starsAchieved < starsText[2]) {
        //     startText ="CONTINUE";
        //
        // } else if (starsAchieved >= starsText[2]) {
        //     startText ="CONTINUE";
        // }
        var startButtonTxt = utilObj.getTTFFontLabel(startText, constantsObj.FONT_ROBOTO_REGULAR_90, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos - 1280 + popupOffset, 0.5, 1, labelArr, popupNode, zOrder);
        utilObj.pulseButton(startButtonTxt, constantsObj.PULSE_ACTION_TAG, 0);


        var wqTimerLabel = utilObj.getTTFFontLabel(weeklyQuestObj.getWqPopupTimerText(), constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos - 1180 + popupOffset, 0.5, 0.5, labelArr, popupNode, zOrder);
        weeklyQuestObj.setWqPopupTimerLabel(wqTimerLabel);

        utilObj.addSprites(spriteArr);

        popupLayer.popupSetup(screen, false, weeklyQuestStartPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });

        popupLayer.show(popupHeight, screen, "Weekly Quest", popupNode, labelArr, true, null, null, null, null, null, null, null, constantsObj.COLOR_WQ_HS, constantsObj.COLOR_WHITE, constantsObj.themed_quest_popup_header);

        gameObj.setShowCoinGrantMessage(false);

    };

    this.close = function () {
        // popupLayer.dontGoToLastScreen = false;
        //popupLayer.closeWithDefault();
        var weeklyQuestExp = epmObj.getChosenVariant(constantsObj.EXP_WEEKLY_QUEST);
        var trackO = constantsObj.TRACK_WQ + "easy";
        if ((weeklyQuestExp == constantsObj.EXP_VAR_3 || weeklyQuestExp == constantsObj.EXP_VAR_4) && gameObj.getWeeklyQuestLastWeekMastery() >= runtimeObj.getWeeklyQuestMasteryLimit()) {
            trackO = constantsObj.TRACK_WQ + "hard";
        }
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", trackO, constantsObj.TRACK_CLOSE, "", "", "", "");
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.start = function (params) {
        popupLayer.setDontGoToLastScreen(true);
        popupLayer.setPopupCallback(weeklyQuestStartPopup.gameScreen, params);
        popupLayer.closeWithDefault();
    };

    this.gameScreen = function () {
        // loggerObj.debugLog("gamescreen1");
        if (gameObj.getIsAnimShown()) {
            return;
        }
        if (homeLayoutExpNew == constantsObj.EXP_VAR_CONTROL) {
            if (gameObj.getPackFtueVisible() || gameObj.getdailyMiniFtueVisible()) {
                return;
            }
        } else {
            if (!homeObj.checkFtueConditions() || homeLayer.todayAnimRunning) {
                return;
            }
        }
        if(zenModeObj.isBlitzFtueVisible()){
            return ;
        }
        if(gameObj.getExpNewWeeklyQuestVariant() != constantsObj.EXP_VAR_CONTROL){
            homeLayer.hide();
            questMapLayer.show();
            return;
        }
        // loggerObj.debugLog("gamescreen2");
        var completed = gameObj.getTodaysPuzzleCompleted();
        if (completed) {
            //themedQuestStartPopup.close();
            homeLayer.hide();
            calendarLayer.show();
        } else {
            if (gameObj.getCrosswordForDate(gameObj.getIdForTodaysPuzzle()) == null) {
                return;
            }
            //themedQuestStartPopup.close();
            homeLayer.hide();
            gameLayer.show(gameObj.getIdForTodaysPuzzle(), false);
        }
    };
};