package in.playsimple.pspn;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.DatabaseUtils;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

import java.util.HashMap;

import in.playsimple.PSPNGameSpecific;

public class DBHelper extends SQLiteOpenHelper{
    public static final String DATABASE_NAME = "PSShareData.db";
    public static final String CONTACTS_TABLE_NAME = "sharedData";
    public static final String CONTACTS_COLUMN_ID = "id"; // this is game id
    public static final String CONTACTS_COLUMN_ALL_GAMES_DATA = "allGamesData";
    public static final String CONTACTS_COLUMN_LAST_UPDATE = "lastUpdate";
    public static final String CONTACTS_CROSS_GAME_PROGRESS = "crossGameProgress";
    private HashMap hp;

    public DBHelper(Context context) {
        super(context, DATABASE_NAME , null, 2);
    }

    @Override
    public void onCreate(SQLiteDatabase db) {
        db.execSQL(
                "create table sharedData " +
                        "(id int, allGamesData text, lastUpdate int8, crossGameProgress text)"
        );
    }

    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
        db.execSQL("DROP TABLE IF EXISTS " + CONTACTS_TABLE_NAME);
        onCreate(db);
    }

    public boolean insertContact (String allGamesData, long lastUpdate, String crossGameProgress) {
        Log.i(PSPNGameSpecific.TAG, "this is sql insert");
        SQLiteDatabase db = this.getWritableDatabase();
        ContentValues contentValues = new ContentValues();
        contentValues.put("id", PSPNGameSpecific.GAME_ID);
        contentValues.put("allGamesData", allGamesData);
        contentValues.put("lastUpdate", lastUpdate);
        contentValues.put("crossGameProgress", crossGameProgress);
        if (numberOfRows() == 0) {
            db.insert("sharedData", null, contentValues);
        } else {
            db.update("sharedData", contentValues, "id = ? ", new String[] { Integer.toString(PSPNGameSpecific.GAME_ID) } );
        }
        return true;
    }

    public Cursor getData(int id) {
        SQLiteDatabase db = this.getReadableDatabase();
        Cursor res =  db.rawQuery( "select * from sharedData where id="+Integer.toString(id)+"", null );
        return res;
    }

    public int numberOfRows(){
        SQLiteDatabase db = this.getReadableDatabase();
        int numRows = (int) DatabaseUtils.queryNumEntries(db, CONTACTS_TABLE_NAME);
        return numRows;
    }

    // will not need this, as functionality is added in insert
    public boolean updateContact (String allGamesData, long lastUpdate, String crossGameProgress) {
        SQLiteDatabase db = this.getWritableDatabase();
        ContentValues contentValues = new ContentValues();
        contentValues.put("id", PSPNGameSpecific.GAME_ID);
        contentValues.put("allGamesData", allGamesData);
        contentValues.put("lastUpdate", lastUpdate);
        contentValues.put("crossGameProgress", crossGameProgress);
        db.update("sharedData", contentValues, "id = ? ", new String[] { Integer.toString(PSPNGameSpecific.GAME_ID) } );
        return true;
    }

    public Integer deleteContact (Integer id) {
        SQLiteDatabase db = this.getWritableDatabase();
        return db.delete("sharedData",
                "id = ? ",
                new String[] { Integer.toString(id) });
    }

//    public ArrayList<String> getAllCotacts() {
//        ArrayList<String> array_list = new ArrayList<String>();
//
//        //hp = new HashMap();
//        SQLiteDatabase db = this.getReadableDatabase();
//        Cursor res =  db.rawQuery( "select * from contacts", null );
//        res.moveToFirst();
//
//        while(res.isAfterLast() == false){
//            array_list.add(res.getString(res.getColumnIndex(CONTACTS_COLUMN_NAME)));
//            res.moveToNext();
//        }
//        return array_list;
//    }
}