AdWall = function () {
    var showAdWall = 0;
    var adwallFirstShown = 0;
    var adwallShownCount = 0;
    var adWallLastScreen = null;
    var lastShownAdWallTimeStamp = 0;
    var allAdwallImagesDownloaded = 0;
    var adwallSessionCountInDay = 0;
    var lastDayToTryAdwallTrigger = -1;
    var gameIdImagesMap = {};

    var newAdWallData = {
        friendSlotsLastUpdate: 0,
        friendsShownMap: {},
        fbConnected: 0,
        xpromoClicks: {},
        incentiveAdWallShownTs: 0,
    };

    var overrideFriendData = {
        installTs: 0,
        clickTs: 0,
        friendClicked: null,
        friendInstalled: null,
        gameId: -1,
    };

    var competitorGamesInstalled = {};

    var CAROUSEL_FRIEND_SLOTS = 4;
    var CAROUSEL_AUTO_SWIPE_TIME = 6;
    var CAROUSEL_AUTO_SWIPE_TIME_NEW = 10;
    var OVERRIDE_FRIEND_RESET_DAYS = 14;

    this.isAdwallEnabled = function () {
        return true;
    };

    // Deprecated method, do not add more data fields into this - use the save method instead
    this.getXPromoGameObj = function (gameData) {
        gameData.adwallFirstShown = adwallFirstShown;
        if (gameData.adwallShownCount != undefined) {
            adwallShownCount = gameData.adwallShownCount;
        }
        gameData.adwallShownCount = adwallShownCount;
        gameData.adWallLastScreen = adWallLastScreen;
        gameData.lastShownAdWallTimeStamp = lastShownAdWallTimeStamp;
        gameData.allAdwallImagesDownloaded = allAdwallImagesDownloaded;
        gameData.adwallSessionCountInDay = adwallSessionCountInDay;
        gameData.lastDayToTryAdwallTrigger = lastDayToTryAdwallTrigger;

        return gameData;
    };

    // Deprecated method, do not add more data fields into this - use the load method instead
    this.loadLocal = function (gameData) {
        if (gameData.adwallFirstShown != undefined) {
            adwallFirstShown = gameData.adwallFirstShown;
        }
        if (gameData.adwallShownCount != undefined) {
            adwallShownCount = gameData.adwallShownCount;
        }
        if (gameData.adWallLastScreen != undefined) {
            adWallLastScreen = gameData.adWallLastScreen;
        }
        if (gameData.lastShownAdWallTimeStamp != undefined) {
            lastShownAdWallTimeStamp = gameData.lastShownAdWallTimeStamp;
        }
        if (gameData.allAdwallImagesDownloaded != undefined) {
            allAdwallImagesDownloaded = gameData.allAdwallImagesDownloaded;
        }
        if (gameData.adwallSessionCountInDay != undefined) {
            adwallSessionCountInDay = gameData.adwallSessionCountInDay;
        }
        if (gameData.lastDayToTryAdwallTrigger != undefined) {
            lastDayToTryAdwallTrigger = gameData.lastDayToTryAdwallTrigger;
        }
    };


    this.load = function (quests) {
        if (quests == null || quests == "" || quests == undefined) {
            return false;
        }

        if (quests.newAdWallData != undefined) {
            newAdWallData = quests.newAdWallData;
        }

        if(quests.competitorGamesInstalled != undefined) {
            competitorGamesInstalled = quests.competitorGamesInstalled;
        }

        if(quests.overrideFriendData != undefined) {
            overrideFriendData = quests.overrideFriendData;
        }
    };

    this.save = function (quests) {
        if (quests == null || quests == "" || quests == undefined) {
            return false;
        }
        quests.newAdWallData = newAdWallData;
        quests.competitorGamesInstalled = competitorGamesInstalled;
        quests.overrideFriendData = overrideFriendData;
        return quests;
    };


    this.getShowAdWall = function () {
        return showAdWall;
    };

    this.setShowAdWall = function (val) {
        showAdWall = val;
    };

    this.setAdwallFirstShown = function (val) {
        adwallFirstShown = val;
    };

    this.getAdwallFirstShown = function () {
        return adwallFirstShown;
    };

    this.setAdwallShownCount = function (val) {
        adwallShownCount = val;
    };

    this.getAdwallShownCount = function () {
        return adwallShownCount;
    };

    this.getAdWallLastScreen = function () {
        return adWallLastScreen;
    };

    this.setAdWallLastScreen = function (num) {
        adWallLastScreen = num;
    };

    this.getLastShownAdWallTimeStamp = function () {
        return lastShownAdWallTimeStamp;
    };

    this.setLastShownAdWallTimeStamp = function (num) {
        lastShownAdWallTimeStamp = num;
    };

    this.setAllAdwallImagesDownloaded = function (val) {
        allAdwallImagesDownloaded = val;
    };

    this.getAllAdwallImagesDownloaded = function () {
        return allAdwallImagesDownloaded;
    };

    this.setAdwallSessionCountInDay = function (val) {
        adwallSessionCountInDay = val;
    };

    this.getAdwallSessionCountInDay = function () {
        return adwallSessionCountInDay;
    };

    this.setLastDayToTryAdwallTrigger = function (val) {
        lastDayToTryAdwallTrigger = val;
    };

    this.getLastDayToTryAdwallTrigger = function () {
        return lastDayToTryAdwallTrigger;
    };

    this.setFriendClickedData = function (friendData, gameId, storeClone) {
        if(overrideFriendData == undefined) {
            overrideFriendData = {};
        }

        if(storeClone != undefined && storeClone == true) {
            overrideFriendData.friendClicked = xpromoUtilObj.shallowCopy(friendData);
        } else {
            overrideFriendData.friendClicked = friendData;
        }
        overrideFriendData.gameId = gameId;
        overrideFriendData.clickTs = utilObj.getCurrentTimestamp();
    };

    this.setFriendInstalledData = function () {
        if(overrideFriendData != undefined && overrideFriendData.friendClicked != undefined) {
            overrideFriendData.friendInstalled = overrideFriendData.friendClicked;
            overrideFriendData.installTs = utilObj.getCurrentTimestamp();
            overrideFriendData.friendClicked = null;
            overrideFriendData.clickTs = 0;
            overrideFriendData.gameId = -1;
        }
    };

    this.checkAndSetInstalledFriendData = function () {
        if(overrideFriendData != undefined && overrideFriendData.friendClicked != undefined && overrideFriendData.gameId != undefined && overrideFriendData.gameId != -1 && overrideFriendData.clickTs != undefined && overrideFriendData.clickTs > 0) {
            utilObj.resetIsAppInstalledMap();
            var gameId = overrideFriendData.gameId;
            if(xpromoUtilObj.isAppInstalledByGameId(gameId) &&
                ((utilObj.getCurrentTimestamp() - overrideFriendData.clickTs) / (60 * 60) <= xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_QUEST_SURFACING_ATTRIBUTION_WINDOW))) {
                adWallObj.setFriendInstalledData();
            }
        }
    };

    this.getOverridenFriendData = function () {
        if(overrideFriendData != undefined && overrideFriendData.friendInstalled != undefined && overrideFriendData.installTs != undefined && overrideFriendData.installTs > 0 && overrideFriendData.friendInstalled.bot == false) {
            if(xpromoUtilObj.getDaysDiffBetweenTimestamps(overrideFriendData.installTs, utilObj.getCurrentTimestamp()) < OVERRIDE_FRIEND_RESET_DAYS) {
                return overrideFriendData.friendInstalled;
            }
            overrideFriendData.friendInstalled = null;
        }
        return null;
    };

    this.showAdwallOnGameAndHome = function () {
        if (!softLaunchObj.getSoftLaunchShown() && !xPromoGameSpecificObj.getShouldShowDailyCalendarAuto() && xPromoGameSpecificObj.shouldShowStarterPack() == 0 && !popupLayer.popupOpen && utilObj.getIsNotifClicked() == false) {
            adWallObj.showAdWall(true);
        }
    };

    this.showAdWall = function (force) {
        if(pspnFlutterObj.isFlutterEnabled()) {
            return false;
        }

        if(xPromoGameSpecificObj.initialChecksForAdWall() == false) {
            return false;
        }
        var expVar = epmObj.getChosenVariant(xPromoGameSpecificObj.getAdwallExpName());
        var allImagesDownloaded = moreGamesLayer.downloadReqdImages();
        var shouldShowAdWall = false;
        var curTimeStamp = utilObj.getCurrentTimestamp();
        var isExpVarAllowed = (expVar == constantsObj.EXP_VAR_5 || expVar == constantsObj.EXP_VAR_6 || expVar == constantsObj.EXP_VAR_7);
        if (utilObj.isOnline() && force == true
                && ((isExpVarAllowed && adWallObj.checkPayerRuntime()) || (expVar == constantsObj.EXP_VAR_8))
                && curTimeStamp - adWallObj.getLastShownAdWallTimeStamp() > xpromoGameRuntimeObj.getAdwallCooldownTime() * 60
                && (curTimeStamp - adWallObj.getAdwallFirstShown() > constantsObj.SECONDS_IN_DAY || adWallObj.getAdwallShownCount() < xpromoGameRuntimeObj.getAdwallLimit())
                && (curTimeStamp - xPromoGameSpecificObj.getInstallTimeStamp() > xpromoGameRuntimeObj.getAdWallDays() * constantsObj.SECONDS_IN_DAY)) {
            softLaunchObj.shouldShowSoftLaunch();
            if (curTimeStamp - adWallObj.getAdwallFirstShown() > constantsObj.SECONDS_IN_DAY) {
                adWallObj.setAdwallFirstShown(curTimeStamp);
                adWallObj.setAdwallShownCount(0);
            }
            return true;
        }
        if (force != true) {
            return moreGamesLayer.canShowAddWallQuests(allImagesDownloaded, shouldShowAdWall, expVar);
        } else {
            return shouldShowAdWall;
        }
    };

    this.onAppResume = function() {
        adWallObj.setShowAdWall(0);
        if(curScreen == constantsObj.SCREEN_MORE_GAMES_LAYER && moreGamesLayer.incentiveAdWall) {
            // Adding a delay in navigating back as it leads to missing asset textures otherwise
            utilObj.delayedCallback(gameLayer, moreGamesLayer.back, 0.2, null, false);
        }
    };

    /**
     * Check runtime whether to enable adwall for payers / non-payers / all.
     * @returns {boolean} - true if enabled, false otherwise.
     */
    this.checkPayerRuntime = function() {
        var runtime = xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_ADWALL_NEW_PAYER_FLAG);
        var payer = xPromoGameSpecificObj.getIsPayerUser();
        return ((runtime == 2) || (runtime == 1 && payer == true) || (runtime == 0 && payer == false));
    };

    /**
     * Wrapper method to query the AdwallNewUI experiment
     */
    this.getAdWallNewUIExperiment = function() {
        if(xPromoGameSpecificObj.isAdWallNewUiEnabled() && !pspnFlutterObj.isFlutterEnabled()) {
            return epmObj.getChosenVariant(xpromoConstantsObj.EXP_ADWALL_NEW_UI);
        }
        return constantsObj.EXP_VAR_CONTROL;
    };

    /**
     * Wrapper method to query the AdwallNewUI experiment is in the social variant
     */
    this.isInAdWallNewSocialVariant = function() {
        var adWallNewUI = adWallObj.getAdWallNewUIExperiment();
        return (adWallNewUI == constantsObj.EXP_VAR_1 || adWallNewUI == constantsObj.EXP_VAR_2 || adWallNewUI == constantsObj.EXP_VAR_5);
    };

    /**
     * Wrapper method to query the AdwallNewUI experiment is in the social variant
     */
    this.updateNewAdWallData = function () {
        // Updating the ad wall data obj, but only doing it in the control variants
        if(adWallObj.isFriendDisplayDataActive()) {

            var friendCooldownSecs = xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_ADWALL_NEW_FRIEND_COOLDOWN) * constantsObj.SECONDS_IN_HOUR;
            var shouldComputeFriends = newAdWallData.friendSlotsLastUpdate + friendCooldownSecs < utilObj.getCurrentTimestamp();
            shouldComputeFriends = shouldComputeFriends || (newAdWallData.friendsShownMap == undefined) || (xPromoGameSpecificObj.isLoggedIn() && newAdWallData.fbConnected != 1);
            var gamesToShow = adWallObj.getGamesVisibleInCarousel();

            if(!shouldComputeFriends) { // Check if all the games data exist!
                for (var index = 0; index < gamesToShow.length; index++) {
                    var gameId = gamesToShow[index];
                    if(newAdWallData.friendsShownMap[gameId] == undefined) {
                        shouldComputeFriends = true;
                        break;
                    }
                }
            }

            if(shouldComputeFriends) {
                var friendImagesToShow = gamesToShow.length * CAROUSEL_FRIEND_SLOTS;

                var friendsData = [];

                // Incase of FB connected - lets try to get the friends from there first
                if(xPromoGameSpecificObj.isLoggedIn()) {
                    // getting all the playsimple friends
                    var refIds = friendsObj.getPsFriendRefIds();
                    refIds = refIds.split(",");

                    // randomizing array
                    refIds.sort(function () {
                        return .5 - Math.random();
                    });

                    // storing data for the friends on a per-game basis
                    for (var refId in refIds) {
                        var rid = refIds[refId];
                        var psFriend = friendsObj.getPsFriendForRefId(rid);

                        if (psFriend == null) {
                            break;
                        }

                        var friendData = {
                            "refId": rid,
                            "fbId": psFriend.Fbid,
                            "name": psFriend.Name,
                            "pic": psFriend.Fbid + ".jpg",
                            "bot": false
                        };

                        friendsData.push(friendData);

                        if(friendsData.length == friendImagesToShow) {
                            break;
                        }
                    }
                    newAdWallData.fbConnected = 1;
                }

                // If we do not have enough friends or aren't FB connected, we will populate with bots
                if(friendsData.length < friendImagesToShow) {
                    var botsToPopuplate = friendImagesToShow - friendsData.length;
                    var botsConfig = xpromoUtilObj.shallowCopy(socialQuestObj.getSocialQuestConfig());

                    // randomizing array
                    botsConfig.sort(function () {
                        return .5 - Math.random();
                    });


                    for(var index = 0; index < botsConfig.length && botsToPopuplate > 0; index++) {
                        var bot = botsConfig[index];
                        var botData = {
                            "refId": bot.rid,
                            "fbId": "friendly_" + bot.rid,
                            "name": bot.name,
                            "pic": "#friendly_" + bot.rid + ".jpg",
                            "bot": true
                        };
                        friendsData.push(botData);

                        botsToPopuplate--;
                        if(index == (botsConfig.length - 1)) { // Reset the index until bots to populate hits zero.
                            index = -1;
                        }
                    }
                }

                // Lets save a game -> friends array map
                for (var index = 0; index < gamesToShow.length; index++) {
                    if(newAdWallData.friendsShownMap == undefined) {
                        newAdWallData.friendsShownMap = {}
                    }

                    newAdWallData.friendsShownMap[gamesToShow[index]] = [];

                    var count = 0;
                    var friendAddedIndex = index;
                    while(count < CAROUSEL_FRIEND_SLOTS) {
                        newAdWallData.friendsShownMap[gamesToShow[index]].push(friendsData[friendAddedIndex]);
                        count++;
                        friendAddedIndex += gamesToShow.length;
                    }
                }
                newAdWallData.friendSlotsLastUpdate = utilObj.getCurrentTimestamp();
            }
        }
    };

    /**
     * Helper method to get the games that are eligible to be viewed in the more games layer carousel
     * @returns {Array} Of gameIds
     */
    this.getGamesVisibleInCarousel = function() {
        var games = [];
        var adWallQuests = questsObj.getAdWallQuests();

        for (var game in adWallQuests) {
            var gameData = adWallQuests[game];
            var gameId = gameData["gh"];
            if (gameId == constantsObj.GAME_ID || gameData["link"] != "1") {
                continue;
            }
            games.push(gameId);
        }
        return games;
    };

    /**
     * Helper method to sort the game map ids in the order of installed and non-installed, keeping priority intact
     * @returns {*}
     */
    this.getSortedGameMapKeysByInstalled = function() {
        var installed = [], others= [];
        var adWallQuests = questsObj.getAdWallQuests();
        for (var game in adWallQuests) {
            var gameData = adWallQuests[game];
            var gameId = gameData["gh"];
            if(gameId == constantsObj.GAME_ID || xpromoUtilObj.isAppInstalledByGameId(gameId)) {
                installed.push(game);
            } else {
                others.push(game);
            }
        }
        return others.concat(installed);
    };


    /**
     * Method to update and fetch the friends to be displayed
      * @returns {friendsShownMap|{}}
     */
    this.getFriendsToDisplay = function() {
        adWallObj.updateNewAdWallData();
        return newAdWallData.friendsShownMap;
    };

    /**
     * Helper method to initiate downloaded of friend images and return the status
     * @returns {boolean} - true if all friend images are downloaded, false otherwise
     */
    this.areFriendImagesDownloaded = function() {
        if(!adWallObj.isFriendDisplayDataActive()) {
            return true;
        }

        var friendsDisplayData = adWallObj.getFriendsToDisplay();
        var result = true;
        for (var gameId in friendsDisplayData) {
            for (var index in friendsDisplayData[gameId]) {
                var friendData = friendsDisplayData[gameId][index];
                if (friendData.bot == false && !utilObj.fileExists(friendData.pic)) {
                    var fbImgUrl = friendsObj.getFbPicUrl(friendData.fbId);
                    xPromoGameSpecificObj.downloadFileV2(fbImgUrl, friendData.pic);
                    result = false;
                }
            }
        }
        return result;
    };

    /**
     * Helper method to check if the friend data feature is active
     * @returns {boolean} - true if all friends display data is active, false otherwise
     */
    this.isFriendDisplayDataActive = function() {
        return xpromoUtilObj.isExitXpromoExperimentActive() || adWallObj.isInAdWallNewSocialVariant() || xpromoW2eObj.isInW2ESocialVariant();
    };

    /**
     * Wrapper method to get the carousel auto-swipe time
     * @returns {number} time in secs
     */
    this.getCarouselAutoSwipeDuration = function() {
        if(adWallObj.isInAdWallNewSocialVariant()) {
            return CAROUSEL_AUTO_SWIPE_TIME_NEW;
        }
        return CAROUSEL_AUTO_SWIPE_TIME;
    };

    /**
     * Helper method to mark the interaction with a game on the more games layer (for adwall incentivised flow)
     * @param gameId - gameId interacted with
     * @param questId - corresponding adwall quest id
     * @param coins - coins to be granted on install
     */
    this.markXpromoInteraction = function (gameId, questId, coins) {
        if(adWallObj.getAdWallNewUIExperiment() != constantsObj.EXP_VAR_5 || coins <= 0) {
            return;
        }

        questsObj.makeRelatedQuestsStatusStarted(questId);
        xpromoUtilObj.markXpromoStartedFromOtherSource(gameId, xpromoConstantsObj.TRACK_ADWALL);

        if(newAdWallData.xpromoClicks == undefined) {
            newAdWallData.xpromoClicks = {};
        }

        newAdWallData.xpromoClicks[gameId] = {
            "ts": utilObj.getCurrentTimestamp(),
            "coins": coins,
            "questId": questId
        };

        // Incase W2E was earlier seen for this game, lets update the grant value to match whats currently being shown.
        if(xpromoW2eObj.getXpromoGameId() == gameId) {
            xpromoW2eObj.setMultipliedLastCoinsAdded(coins);
        }
    };

    /**
     * Method to grant incentive rewards for players who have installed a game through adwall
     */
    this.checkAndGrantXpromoReward = function () {
        if(adWallObj.getAdWallNewUIExperiment() != constantsObj.EXP_VAR_5) {
            return;
        }

        if(newAdWallData == null || newAdWallData.xpromoClicks == undefined) {
            return;
        }

        var attributionPeriod = xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_QUEST_SURFACING_ATTRIBUTION_WINDOW) * 60 * 60;
        var curTime = utilObj.getCurrentTimestamp();
        utilObj.resetIsAppInstalledMap();
        for(var gameId in newAdWallData.xpromoClicks) {
            var delEntry = false;
            var clickData = newAdWallData.xpromoClicks[gameId];
            var clickTime = clickData["ts"];
            var questId = clickData["questId"];
            var coins = clickData["coins"];

            var incentivizedElsewhere = xpromoUtilObj.isGameAlreadyMarkedForRewarding(gameId, xpromoConstantsObj.TRACK_ADWALL);

            if(!incentivizedElsewhere && clickTime > 0 && ((clickTime + attributionPeriod) >= curTime)
                && xpromoUtilObj.isAppInstalledByGameId(gameId)
                && coins > 0) {

                // This is to account for the scenario when BP / W2E for the same game is seen after Adwall,
                // In this scenario, only the W2E / BP reward should be granted and not Adwall. Hence the check for gameId below
                if(xpromoW2eObj.getXpromoGameId() != gameId && questsObj.getCrossGameQuestStatusForId(questId) != xpromoConstantsObj.QUEST_CLAIMED && bubblePopObj.getXpromoInteractionTime(gameId) < clickTime && giftBoxObj.getXpromoInteractionTime(gameId) < clickTime) {
                    questsObj.makeRelatedQuestsForW2eClaimed(questId);
                    if((xPromoGameSpecificObj.getCash() + coins) <= constantsObj.MAX_CASH_ALLOWED) {
                        xPromoGameSpecificObj.addCash(coins, xpromoConstantsObj.TRACK_ADWALL, "", xpromoConstantsObj.TRACK_ADWALL);
                        xPromoGameSpecificObj.showCoinGrantMessage(coins);
                    }
                }
                delEntry = true;
            }

            if (((clickTime + attributionPeriod) < curTime) || incentivizedElsewhere) {
                delEntry = true;
            }

            if(delEntry) { // Lets delete the rewards for the gameId as they are either granted to expired
                delete newAdWallData.xpromoClicks[gameId];
            }
        }
    };


    /**
     * Getter method to retrieve the xpromo click time for a given game id
     * @param gameId
     * @returns number value of timestamp last interacted, zero if not applicable.
     */
    this.getXpromoInteractionTime = function (gameId) {
        var result = 0;
        if(adWallObj.getAdWallNewUIExperiment() != constantsObj.EXP_VAR_5) {
            return result;
        }

        if(newAdWallData == null || newAdWallData.xpromoClicks == undefined ||
            newAdWallData.xpromoClicks[gameId] == undefined || newAdWallData.xpromoClicks[gameId]["ts"] == undefined) {
            return result;
        }

        return newAdWallData.xpromoClicks[gameId]["ts"];
    };

    /**
     * Method to evaluate if a player is eligible for the adwall incentivised view
     * @param src - source from which adwall is trigger
     * @returns {boolean} - true / false
     */
    this.isEligibileForIncentivizedAdwall = function (src) {
        if(adWallObj.getAdWallNewUIExperiment() != constantsObj.EXP_VAR_5 || src != constantsObj.TRACK_AUTO_STRING ) {
            return false;
        }

        var runtime = xpromoQuestRuntimesObj.getRuntime("adnci", null);
        var daysPlayed = parseInt(runtime.dd[0]);
        var puzzleClears = parseInt(runtime.pc[0]);
        var daysSinceInstall = parseInt(runtime.id[0]);
        var coinsGrant = parseInt(runtime.cg[0]);

        var shownInDay = false;
        if(newAdWallData.incentiveAdWallShownTs > 0) {
            shownInDay = Math.round(xpromoUtilObj.getDaysDiffBetweenTimestamps(newAdWallData.incentiveAdWallShownTs, utilObj.getCurrentTimestamp())) < 1;
        }

        return (xPromoGameSpecificObj.isUserInteractionTrackingEnabled() && machineLearningDataObj.getDaysPlayedInLastXDays(7) >= daysPlayed && xPromoGameSpecificObj.getDailyPuzzleClears() >= puzzleClears && xpromoUtilObj.getUserDaysSinceInstall() > daysSinceInstall && !shownInDay && xpromoUtilObj.isAnyGameEligibleForXpromo());
    };

    /**
     * Method to obtain the amount of coins to be granted as a runtime
     * @returns {number} for the number of coins
     */
    this.getAdwallIncentiveCoinAmount = function () {
        if(adWallObj.getAdWallNewUIExperiment() != constantsObj.EXP_VAR_5) {
            return 0;
        }

        var runtime = xpromoQuestRuntimesObj.getRuntime("adnci", null);
        var coinsGrant = parseInt(runtime.cg[0]);

        return isNaN(coinsGrant) ? 0 : coinsGrant;
    };

    /**
     * Setter method to set the incentive ad wall shown timestamp
     */
    this.setIncentiveAdWallShown = function() {
        newAdWallData.incentiveAdWallShownTs = utilObj.getCurrentTimestamp();
    };

    /**
     * Helper method to extract a friend image from the given friend data
     * @param friendData
     * @returns string - path to the pic
     */
    this.getFriendImageFromData = function(friendData) {
        var pic = friendData.pic;
        if(!friendData.bot) {
            if(utilObj.fileExists(pic)) {
                pic = xpromoUtilObj.getAbsFilePath(pic);
            } else {
                pic = "#EmptyBox.png";
            }
        }
        return pic;
    };

    /**
     * Method to get the set of images that are updated from adwall quests.
     * @param game_id - game id for which the image needs to be fetched
     * @returns {*} - object of type as key and image name as value
     */
    this.getImagesForGameId = function(game_id) {
        if(gameIdImagesMap == undefined) {
            gameIdImagesMap = {};
        }

        if(gameIdImagesMap[game_id] != undefined) {
            return gameIdImagesMap[game_id];
        }

        var adWallQuests = questsObj.getAdWallQuests();
        for (var game in adWallQuests) {
            var result = {};
            var gameData = adWallQuests[game];
            var gameId = gameData["gh"];

            if(gameId != game_id) {
                continue;
            }

            if(gameData.creatives != undefined) {
                var questCreativeMap = xpromoUtilObj.getKeyValuePairForCreatives(gameData.creatives);
                result = {
                    "icon": questCreativeMap.adwall_icon,
                    "carousel": questCreativeMap.adwall_carousel,
                    "social_carousel": questCreativeMap.adwall_social,
                    "thumbnail": questCreativeMap.adwall_thumbnail,
                    "w2e_thumb": questCreativeMap.w2e_thumbnail,
                };
            }
            gameIdImagesMap[gameId] = result;
            break;
        }
        return result;
    };

    /**
     * Method to track and store the count of competitor games those are installed on player's device
     */
    this.trackAndStoreCompetitorGames = function() {
        if (!utilObj.isAndroid()) {
            return;
        }

        var runtimeStr = xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_COMPETITOR_APP_LIST, null);
        if(runtimeStr == undefined) {
            return;
        }

        var runtime = xpromoUtilObj.getGamewiseObjectForData(runtimeStr);

        for (var game in xpromoConstantsObj.PSGames) {
            if(runtime[game] != undefined && utilObj.isArray(runtime[game])) {
                var installedCount = 0;
                for (var index = 0; index < runtime[game].length; index++) {
                    if(xpromoUtilObj.isAppInstalled(runtime[game][index])) {
                        installedCount++;
                    }
                }

                if(competitorGamesInstalled == undefined) {
                    competitorGamesInstalled = {};
                }

                if(competitorGamesInstalled[game] == undefined) {
                    competitorGamesInstalled[game] = {
                        m: installedCount, //max count of competitor games installed
                        c: installedCount, //current count of competitor games installed
                        d: utilObj.getCurrentTimestamp(), // Time of recording the changed m value
                    };
                }

                if(competitorGamesInstalled[game].m == undefined || competitorGamesInstalled[game].m < installedCount) {
                    competitorGamesInstalled[game].m = installedCount;
                    competitorGamesInstalled[game].d = utilObj.getCurrentTimestamp();
                }

                competitorGamesInstalled[game].c = installedCount;

                trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, game + "", "",
                   "apps", runtime[game].length + "", installedCount + "", "", "", "");
            }
        }
    };
};