ContactBook = function () {
    var allContacts = "";

    this.getAllContacts = function () {
        return allContacts;
    };

    this.setAllContacts = function (allContactsString) {
        allContacts = allContactsString;
    };

    this.getXPromoGameObj = function (gameData) {
        gameData.allContacts = allContacts;
        return gameData;
    };

    this.loadLocal = function (gameData) {
        allContacts = gameData.allContacts;
    };

    this.isAlpha = function (val) {
        return (val >= 'a' && val <= 'z') || (val >= 'A' && val <= 'Z');
    };

    this.inviteContactBook = function () {
        var shareMsg = utilObj.getShareMsg("s");
        var success = true;
        var allContacts = "";
        var pkgPrefix = xpromoUtilObj.getPspnPkgPrefix();
        if (utilObj.isNative()) {
            if (utilObj.isAndroid()) {
                allContacts = jsb.reflection.callStaticMethod(pkgPrefix + "XPromoUtil", "RequestForContactsPermission", "()Ljava/lang/String;");
                //empty string when user has denied
                if (allContacts != "" || jsb.reflection.callStaticMethod(pkgPrefix + "XPromoUtil", "CheckForContactsPermission", "()Z")) {
                    contactBookObj.setAllContacts(allContacts);
                    utilObj.delayedCallback(contactBookLayer, contactBookLayer.showContactBookFromAppResume, 0.5, null, false);
                }
                success = false;
            } else if (utilObj.isIos()) {

            }
            return success;
        } else {
            utilObj.showMessage(stringsObj.error_on_mobile);
            return false;
        }

    };

    this.showContactBook = function (allContactString) {
        //0 indicates permission but no contacts fetched
        if (allContactString == "0") {
            allContactString = "";
        }
        contactBookObj.setAllContacts(allContactString);
        questsObj.incActionForQuestType(xpromoConstantsObj.QUEST_TYPE_INVITE_CONTACT_BOOK);
        questCenterLayer.hide();
        contactBookLayer.show();
    };
};