// this file contains backend for daily quests
CrossGameDailyQuests = function () {
    var dailyQuestViewed = 0;
    var dailyQuestViewIncremented = 0;
    var dailyQuestClickIncremented = 0;
    var dailyQuestToBeShown = null;
    var dailyQuestsCompleted = 0;
    var lastCohortDailyQuestCgSeen = -1;
    var dailyQuestUnlockToasterShown = false;
    var lockAnimationDone = false;

    var crossGameDailyQuestsUnlocked = 0;

    // this will hold view cooldown and click cooldown for cross game daily quests
    var crossGameDailyQuestMap = {};

    // this value stores whether a daily quest has been completed or not
    // this will be used to show secondary quest after cgdq is completed
    // this value is resetted every day.
    var crossGameDailyQuestCompletedFlag = 0;

    // this contains data of completed cgdq, if no cgdq is completed it contains null
    var crossGameDailyQuestCompletedData = null;

    // this variable is used to show toaster after completing a daily quest in cross game
    var toasterChecker = true;
    var crossGameDailyQuestCompleteTimestamp = 0;

    // this data will be picked from questsObj
    var crossGameProgress = {};
    var allGamesDataMap = {};
    var curQuests = {};
    var allQuests = {};

    // timer value for cgdq locked quest
    var dailyQuestTimerLabelValue = 0;

    var newDayHasBegunAfterCGDQComplete = 0;

    var CGDQVariablesReset = 0;

    var currentCGDQExp = -1;
    var currentCGDCOptExp = -1;

    var cgdqPayerFlag = -1;

    var shouldShowDailyQuestOnAppUpdate = 0;
    var shouldShowDailyQuestNotif = false;
    var isDailyQuestCompleted = false;
    var dailyQuestUnlockTime = 0;
    var dailyQuestUpdated = 0;
    var showDailyQuestLock = false;
    var lastQuestCompletedDaily = 1;


    var showLoopBackToaster = false;

    var cgdqReceiverActive = null;

    var checkForSendingTracking = 0;

    var crossGameDailyQuestClicked = 0;

    var secondaryQuestClaimed = 0;

    var CGDQClaimed = 0;

    this.init = function () {
        // getting data from questsObj
        crossGameProgress = questsObj.getCrossGameProgressMap();
        allGamesDataMap = questsObj.getAllGamesDataMap();
        curQuests = questsObj.getCurQuests();
        allQuests = questsObj.getAllQuests();
    };

    this.resetDailyQuestData = function () {
        crossGameDailyQuestMap = {};
        dailyQuestViewed = 0;
        dailyQuestViewIncremented = 0;
        dailyQuestClickIncremented = 0;
        dailyQuestToBeShown = null;
        crossGameDailyQuestsObj.setCrossGameDailyQuestCompletedFlag(0);
    };

    // getters and setters

    this.getLockAnimationDone = function () {
        return lockAnimationDone;
    };

    this.setLockAnimationDone = function (sender, params) {
        var val = params["lockOpen"];
        lockAnimationDone = val;
    };
    this.getToasterChecker = function () {
        return toasterChecker;
    };

    this.setToasterChecker = function (val) {
        toasterChecker = val;
    };

    this.getDailyQuestsCompleted = function () {
        return dailyQuestsCompleted;
    };

    this.setDailyQuestsCompleted = function (val) {
        dailyQuestsCompleted = val;
        if (!crossGameDailyQuestsObj.checkCGDQControl()) {
            crossGameDailyQuestsObj.decrementDailyQuestCompleteLabel();
        }
    };

    this.setDailyQuestViewed = function (val) {
        dailyQuestViewed = val;
    };

    this.getDailyQuestViewed = function () {
        return dailyQuestViewed;
    };

    this.getCrossGameDailyQuestMap = function () {
        return crossGameDailyQuestMap;
    };

    this.setCrossGameDailyQuestMap = function (val) {
        crossGameDailyQuestMap = val;
    };

    this.setCrossGameDailyQuestCompletedFlag = function (val) {
        crossGameDailyQuestCompletedFlag = val;
    };

    this.getCrossGameDailyQuestCompletedFlag = function () {
        return crossGameDailyQuestCompletedFlag;
    };

    this.getDailyQuestToBeShown = function () {
        return dailyQuestToBeShown;
    };

    this.setDailyQuestToBeShown = function (val) {
        dailyQuestToBeShown = val;
    };

    this.getCrossGameDailyQuestCompleteTimestamp = function () {
        return crossGameDailyQuestCompleteTimestamp;
    };

    this.setCrossGameDailyQuestCompleteTimestamp = function (val) {
        crossGameDailyQuestCompleteTimestamp = val;
    };

    this.getLastCohortDailyQuestCgSeen = function () {
        return lastCohortDailyQuestCgSeen;
    };

    this.setLastCohortDailyQuestCgSeen = function (val) {
        lastCohortDailyQuestCgSeen = val;
    };

    this.getDailyQuestUnlockToasterShown = function () {
        return dailyQuestUnlockToasterShown;
    };

    this.setDailyQuestUnlockToasterShown = function (val) {
        dailyQuestUnlockToasterShown = val;
    };

    this.getCrossGameDailyQuestsUnlocked = function () {
        return crossGameDailyQuestsUnlocked;
    };

    this.getShowLoopBackToaster = function () {
        return showLoopBackToaster;
    };

    this.setShowLoopBackToaster = function (val) {
        showLoopBackToaster = val;
    };

    this.getCrossGameDailyQuestClicked = function () {
        return crossGameDailyQuestClicked;
    };

    this.setCrossGameDailyQuestClicked = function (val) {
        crossGameDailyQuestClicked = val;
    };

    this.getSecondaryQuestClaimed = function () {
        return secondaryQuestClaimed;
    };

    this.setSecondaryQuestClaimed = function (val) {
        secondaryQuestClaimed = val;
    };

    this.getCGDQClaimed = function () {
        return CGDQClaimed;
    };

    this.setCGDQClaimed = function (val) {
        CGDQClaimed = val;
    };

    this.setCrossGameDailyQuestsUnlocked = function (val) {
        crossGameDailyQuestsUnlocked = val;
        var gameHostedQuest = 0;
        var curQuests = questsObj.getCurQuests();
        if (curQuests != null && val == 1 && crossGameDailyQuestsObj.getCurrentCGDQExp() != constantsObj.EXP_VAR_CONTROL) {
            for (var quest in curQuests) {
                if (curQuests[quest] != undefined && curQuests[quest].qt.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0 && curQuests[quest].gh != constantsObj.GAME_ID && questsObj.isQuestShownInGame(quest)) {
                    crossGameDailyQuestsObj.resetCrossGameDailyQuestOnUnlocking(quest);
                    gameHostedQuest = curQuests[quest].gh;
                    trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, crossGameDailyQuestsObj.getCurrentCGDQExp(), gameHostedQuest, xpromoConstantsObj.TRACK_CGDQ, xpromoConstantsObj.TRACK_UNLOCK, "", "", "", "");
                }
            }
        }
        return gameHostedQuest;
    };

    this.getDailyQuestTimerLabelValue = function () {
        return dailyQuestTimerLabelValue;
    };

    this.setDailyQuestTimerLabelValue = function (val) {
        dailyQuestTimerLabelValue = val;
        if (!crossGameDailyQuestsObj.checkCGDQControl()) {
            crossGameDailyQuestsObj.decrementDailyQuestUnlockTimerLabel(dailyQuestTimerLabelValue);
        }

    };

    this.getCurrentCGDQExp = function () {
        if (currentCGDQExp == -1 || currentCGDQExp == constantsObj.EXP_VAR_CONTROL) {
            currentCGDQExp = epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_XPROMO_DQ);
        }

        if (currentCGDQExp != constantsObj.EXP_VAR_CONTROL && epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_XPROMO_DQ) == constantsObj.EXP_VAR_CONTROL) {
            currentCGDQExp = epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_XPROMO_DQ);
        }
        return currentCGDQExp;
    };

    this.setCurrentCGDQExp = function (val) {
        currentCGDQExp = val;
    };

    this.getCGDQVariablesReset = function () {
        return CGDQVariablesReset;
    };

    this.setCGDQVariablesReset = function (val) {
        CGDQVariablesReset = val;
    };

    this.getShouldShowDailyQuestOnAppUpdate = function () {
        return shouldShowDailyQuestOnAppUpdate;
    };

    this.setShouldShowDailyQuestOnAppUpdate = function (val) {
        shouldShowDailyQuestOnAppUpdate = val;
    };

    this.setShouldShowDailyQuestNotif = function (val) {
        shouldShowDailyQuestNotif = val;
    };

    this.setIsDailyQuestCompleted = function (val) {
        isDailyQuestCompleted = val;
    };

    this.getDailyQuestUnlockTime = function () {
        if(dailyQuestUnlockTime == 0) { // This value might not be set for the first session of the lifetime as it gets set only on app pause
            return dailyQuestsObj.getDailyQuestUnlockTime();
        }
        return dailyQuestUnlockTime;
    };

    this.setDailyQuestUnlockTime = function (val) {
        dailyQuestUnlockTime = val;
    };

    this.setDailyQuestUpdated = function (val) {
        dailyQuestUpdated = val;
    };

    this.getDailyQuestUpdated = function () {
        return dailyQuestUpdated;
    };

    this.setShowDailyQuestLock = function (val) {
        showDailyQuestLock = val;
    };

    this.getShowDailyQuestLock = function () {
        return showDailyQuestLock;
    };

    this.getLastQuestCompletedDaily = function () {
        return lastQuestCompletedDaily;
    };

    this.setLastQuestCompletedDaily = function (val) {
        lastQuestCompletedDaily = val;
    };

    this.getCgdqReceiverActive = function () {
        return cgdqReceiverActive;
    };

    this.setCgdqReceiverActive = function (val) {
        if (crossGameDailyQuestsObj.getCgdqReceiverActive() == null) {
            trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, crossGameDailyQuestsObj.getCurrentCGDQExp(), val.gh, xpromoConstantsObj.TRACK_CGDQ_RECIEVER, xPromoGameSpecificObj.TRACK_SESSION_START, "", "", "","");
        }
        cgdqReceiverActive = val;
    };

    this.getCheckForSendingTracking = function () {
        return checkForSendingTracking;
    };

    this.setCheckForSendingTracking = function (val) {
        checkForSendingTracking = val;
    };

    this.load = function (quests) {
        if (quests == null || quests == "" || quests == undefined) {
            return false;
        }
        dailyQuestsCompleted = quests.dailyQuestsCompleted;
        dailyQuestViewed = quests.dailyQuestViewed;
        dailyQuestViewIncremented = quests.dailyQuestViewIncremented;
        dailyQuestClickIncremented = quests.dailyQuestClickIncremented;
        crossGameDailyQuestMap = quests.crossGameDailyQuestMap;
        crossGameDailyQuestCompletedFlag = quests.crossGameDailyQuestCompletedFlag;
        toasterChecker = quests.toasterChecker;
        crossGameDailyQuestCompleteTimestamp = quests.crossGameDailyQuestCompleteTimestamp;
        lastCohortDailyQuestCgSeen = quests.lastCohortDailyQuestCgSeen;
        dailyQuestUnlockToasterShown = quests.dailyQuestUnlockToasterShown;
        crossGameDailyQuestsUnlocked = quests.crossGameDailyQuestsUnlocked;
        dailyQuestTimerLabelValue = quests.dailyQuestTimerLabelValue;
        currentCGDQExp = quests.currentCGDQExp;
        currentCGDCOptExp = quests.currentCGDCOptExp;
        cgdqPayerFlag = quests.cgdqPayerFlag
        lockAnimationDone = quests.lockAnimationDone;
        shouldShowDailyQuestOnAppUpdate = quests.shouldShowDailyQuestOnAppUpdate;
        checkForSendingTracking = quests.checkForSendingTracking;
        crossGameDailyQuestClicked = quests.crossGameDailyQuestClicked;
        secondaryQuestClaimed = quests.secondaryQuestClaimed;
        CGDQClaimed = quests.CGDQClaimed;
        showLoopBackToaster = quests.showLoopBackToaster;

        if (dailyQuestUnlockToasterShown == undefined) {
            dailyQuestUnlockToasterShown = false;
        }

        if (lockAnimationDone == undefined) {
            lockAnimationDone = false;
        }

        if (dailyQuestsCompleted == undefined) {
            dailyQuestsCompleted = 0;
        }

        if (dailyQuestViewed == undefined) {
            dailyQuestViewed = 0;
        }

        if (dailyQuestViewIncremented == undefined) {
            dailyQuestViewIncremented = 0;
        }

        if (dailyQuestClickIncremented == undefined) {
            dailyQuestClickIncremented = 0;
        }

        if (crossGameDailyQuestMap == undefined) {
            crossGameDailyQuestMap = {};
        }

        if (crossGameDailyQuestCompletedFlag == undefined) {
            crossGameDailyQuestCompletedFlag = 0;
        }

        if (crossGameDailyQuestsUnlocked == undefined) {
            crossGameDailyQuestsUnlocked = 0;
        }

        if (dailyQuestTimerLabelValue == undefined) {
            dailyQuestTimerLabelValue = 0;
        }

        if (currentCGDQExp == undefined) {
            currentCGDQExp = -1;
        }

        if(currentCGDCOptExp == undefined) {
            currentCGDCOptExp = -1;
        }

        if(cgdqPayerFlag == undefined) {
            cgdqPayerFlag = -1;
        }

        if (toasterChecker == undefined) {
            toasterChecker = true;
        }

        if (crossGameDailyQuestCompleteTimestamp == undefined) {
            crossGameDailyQuestCompleteTimestamp = 0;
        }

        if (lastCohortDailyQuestCgSeen == undefined) {
            lastCohortDailyQuestCgSeen = -1;
        }

        if (shouldShowDailyQuestOnAppUpdate == undefined) {
            shouldShowDailyQuestOnAppUpdate = 0;
        }
        if (quests.shouldShowDailyQuestNotif != undefined) {
            shouldShowDailyQuestNotif = quests.shouldShowDailyQuestNotif;
        }
        if (quests.isDailyQuestCompleted != undefined) {
            isDailyQuestCompleted = quests.isDailyQuestCompleted;
        }
        if(quests.dailyQuestUnlockTime != undefined) {
            dailyQuestUnlockTime = quests.dailyQuestUnlockTime;
        }
        if (quests.dailyQuestUpdated != undefined) {
            dailyQuestUpdated = quests.dailyQuestUpdated;
        }
        if (quests.showDailyQuestLock != undefined) {
            showDailyQuestLock = quests.showDailyQuestLock;
        }

        if (checkForSendingTracking == undefined) {
            checkForSendingTracking = 0;
        }

        if (crossGameDailyQuestClicked == undefined) {
            crossGameDailyQuestClicked = 0;
        }

        if (secondaryQuestClaimed == undefined) {
            secondaryQuestClaimed = 0;
        }

        if (CGDQClaimed == undefined) {
            CGDQClaimed = 0;
        }

        if (showLoopBackToaster == undefined) {
            showLoopBackToaster = false;
        }

    };

    this.save = function (quests) {
        if (quests == null || quests == "" || quests == undefined) {
            return false;
        }
        quests.dailyQuestsCompleted = dailyQuestsCompleted;
        quests.dailyQuestViewed = dailyQuestViewed;
        quests.dailyQuestViewIncremented = dailyQuestViewIncremented;
        quests.dailyQuestClickIncremented = dailyQuestClickIncremented;
        quests.crossGameDailyQuestMap = crossGameDailyQuestMap;
        quests.crossGameDailyQuestCompletedFlag = crossGameDailyQuestCompletedFlag;
        quests.toasterChecker = toasterChecker;

        quests.crossGameDailyQuestCompleteTimestamp = crossGameDailyQuestCompleteTimestamp;
        quests.lastCohortDailyQuestCgSeen = lastCohortDailyQuestCgSeen;
        quests.dailyQuestUnlockToasterShown = dailyQuestUnlockToasterShown;
        quests.crossGameDailyQuestsUnlocked = crossGameDailyQuestsUnlocked;
        quests.dailyQuestTimerLabelValue = dailyQuestTimerLabelValue;
        quests.currentCGDQExp = currentCGDQExp;
        quests.cgdqPayerFlag = cgdqPayerFlag;
        quests.currentCGDCOptExp = currentCGDCOptExp;
        quests.lockAnimationDone = lockAnimationDone;
        quests.shouldShowDailyQuestOnAppUpdate = shouldShowDailyQuestOnAppUpdate;
        quests.shouldShowDailyQuestNotif = shouldShowDailyQuestNotif;
        quests.dailyQuestUnlockTime = dailyQuestUnlockTime;
        quests.isDailyQuestCompleted = isDailyQuestCompleted;
        quests.dailyQuestUpdated = dailyQuestUpdated;
        quests.showDailyQuestLock = showDailyQuestLock;
        quests.checkForSendingTracking = checkForSendingTracking;
        quests.crossGameDailyQuestClicked = crossGameDailyQuestClicked;
        quests.secondaryQuestClaimed = secondaryQuestClaimed;
        quests.CGDQClaimed = CGDQClaimed;
        quests.showLoopBackToaster = showLoopBackToaster;

        return quests;
    };

    this.resetCrossGameDailyQuestMap = function () {
        crossGameDailyQuestMap = {};
    };

    // this function evaluates local (client) time remaining for day to complete from startTime
    this.timeRemainingForDayToComplete = function (startTime) {
        var date = new Date();
        var remainingTime = constantsObj.SECONDS_IN_DAY - startTime % constantsObj.SECONDS_IN_DAY;
        var timeRemaining = remainingTime + date.getTimezoneOffset() * constantsObj.SECONDS_IN_MIN;
        if (timeRemaining < 0) {
            timeRemaining = constantsObj.SECONDS_IN_DAY + timeRemaining;
        }
        return timeRemaining;
    };

    // resetting daily quest when daily quest surfacing time is over
    this.resetCrossGameDailyQuestOnTimeComplete = function (questId) {
        crossGameProgress = questsObj.getCrossGameProgressMap();
        if (crossGameProgress[questId] == undefined || curQuests[questId] == undefined || crossGameProgress[questId].params == undefined) {
            return;
        }
        if (crossGameDailyQuestsObj.getCurrentCGDQExp() == constantsObj.EXP_VAR_3 && xPromoGameSpecificObj.getDForUser() <= crossGameDailyQuestsObj.getLastCohortDailyQuestCgSeen()) {
            return;
        }
        if (crossGameProgress[questId] == undefined) {
            crossGameProgress[questId] = {
                "id": questId,
                "status": xpromoConstantsObj.QUEST_NOT_STARTED,
            }
        }
        if (crossGameProgress[questId].params == undefined) {
            crossGameProgress[questId].params = [0,0,0,-1];
        }
        var allParams = curQuests[questId].pa.split(":");
        // resetting game progress state to not started state
        if (crossGameProgress[questId].status != xpromoConstantsObj.QUEST_NOT_STARTED) {
            questsObj.updateCrossGameQuestStatus(questId, xpromoConstantsObj.QUEST_NOT_STARTED);
        }
        // changing startlevel to current level
        crossGameProgress[questId].params[3] = 0;
        if (allGamesDataMap[curQuests[questId].gh] != undefined && allGamesDataMap[curQuests[questId].gh][allParams[10]] != undefined) {
            crossGameProgress[questId].params[3] = allGamesDataMap[curQuests[questId].gh][allParams[10]];
        }
        // resetting current progress level
        crossGameProgress[questId].params[0] = 0;
        // resetting time to current timestamp
        crossGameProgress[questId].params[1] = utilObj.getCurrentTimestamp();
        crossGameDailyQuestsObj.setDailyQuestsCompleted(0);
        crossGameDailyQuestsObj.setDailyQuestTimerLabelValue(0);
        crossGameDailyQuestsObj.setShowLoopBackToaster(false);
        // questsObj.updateCrossGameProgress();
    };

    this.updateCGDQProgressOnclick = function (questId) {
        if (crossGameProgress[questId] != undefined && crossGameProgress[questId].status == xpromoConstantsObj.QUEST_NOT_STARTED) {
            crossGameProgress[questId].params[3] = crossGameDailyQuestsObj.getCurLevelOfHostedQuest(questId);
            crossGameProgress[questId].params[0] = 0;
        }
    };

    // * reset daily quest when it is unlocked
    this.resetCrossGameDailyQuestOnUnlocking = function (questId) {
        if (curQuests == null || curQuests[questId] == undefined || curQuests[questId].gh == constantsObj.GAME_ID) {
            return;
        }
        if (crossGameProgress[questId] == undefined) {
            crossGameProgress[questId] = {
                "id": questId,
                "status": xpromoConstantsObj.QUEST_NOT_STARTED,
            }
        }
        if (crossGameProgress[questId].params == undefined) {
            crossGameProgress[questId].params = [0,0,0,-1];
        }
        var allParams = curQuests[questId].pa.split(":");
        // resetting game progress state to not started state
        if (crossGameProgress[questId].status != xpromoConstantsObj.QUEST_NOT_STARTED) {
            questsObj.updateCrossGameQuestStatus(questId, xpromoConstantsObj.QUEST_NOT_STARTED);
        }
        // changing startlevel to current level
        crossGameProgress[questId].params[3] = 0;
        if (allGamesDataMap[curQuests[questId].gh] != undefined && allGamesDataMap[curQuests[questId].gh][allParams[10]] != undefined) {
            crossGameProgress[questId].params[3] = allGamesDataMap[curQuests[questId].gh][allParams[10]];
        }
        // resetting current progress level
        crossGameProgress[questId].params[0] = 0;
        // resetting time to current timestamp
        crossGameProgress[questId].params[1] = utilObj.getCurrentTimestamp();
        // questsObj.updateCrossGameProgress();
    };

    // updating quest after completion
    this.updateCrossGameDailyQuestProgress = function (questId) {
        if (crossGameProgress[questId] != undefined && crossGameProgress[questId].status == xpromoConstantsObj.QUEST_CLAIMED && crossGameDailyQuestCompletedFlag == 0) {
            var allParams = curQuests[questId].pa.split(":");
            if (crossGameProgress[questId].status != xpromoConstantsObj.QUEST_NOT_STARTED) {
                questsObj.updateCrossGameQuestStatus(questId, xpromoConstantsObj.QUEST_NOT_STARTED);
            }
            // changing startlevel to current level
            crossGameProgress[questId].params[3] = allGamesDataMap[curQuests[questId].gh][allParams[10]];
            // resetting current progress level
            crossGameProgress[questId].params[0] = 0;
            // incrementing engagement count
            crossGameProgress[questId].params[2] = parseInt(crossGameProgress[questId].params[2]) + 1;
            crossGameDailyQuestCompletedFlag = 1;
            crossGameDailyQuestsObj.setLastCohortDailyQuestCgSeen(xPromoGameSpecificObj.getDForUser());
        }

        // questsObj.updateCrossGameProgress();
    };

    // variables to reset for cgdq
    this.resetVariablesOnDailyBasis = function () {
        var cgdqExp = crossGameDailyQuestsObj.getCurrentCGDQExp();
        if ((cgdqExp == constantsObj.EXP_VAR_3 && xPromoGameSpecificObj.getDForUser() > crossGameDailyQuestsObj.getLastCohortDailyQuestCgSeen()) || cgdqExp != constantsObj.EXP_VAR_3) {
            dailyQuestViewed = 0;
            dailyQuestClickIncremented = 0;
            dailyQuestViewIncremented = 0;
            crossGameDailyQuestsUnlocked = 0;
            crossGameDailyQuestsObj.setDailyQuestTimerLabelValue(0);
            crossGameDailyQuestsObj.setDailyQuestsCompleted(0);
            newDayHasBegunAfterCGDQComplete = 1;
            crossGameDailyQuestsObj.setLockAnimationDone(null, {"lockOpen": false});
            crossGameDailyQuestsObj.setCurrentCGDQExp(epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_XPROMO_DQ));
            cgdqPayerFlag = xPromoGameSpecificObj.getIsPayerUser() ? 1 : 0;
            currentCGDCOptExp = epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_XPROMO_CGDQ_OPT);
            this.setCrossGameDailyQuestClicked(0);
            this.setSecondaryQuestClaimed(0);
            this.setCGDQClaimed(0);
        }
        crossGameDailyQuestsObj.setToasterChecker(true);
        crossGameDailyQuestsObj.setCrossGameDailyQuestCompletedFlag(0);
        crossGameDailyQuestsObj.setCheckForSendingTracking(0);
        shouldShowDailyQuestOnAppUpdate = 1;
        showLoopBackToaster = false;
    };

    // incrementing cross game daily quest click count
    this.incrementDailyQuestClickCount = function (questId) {
        if (dailyQuestClickIncremented == 1) {
            return;
        }
        // if inside map questId is not defined, make a map for that questId
        if (crossGameDailyQuestMap[questId] == undefined) {
            crossGameDailyQuestMap[questId] = {
                "viewCount": 0,
                "clickCount": 0
            }
        }
        crossGameDailyQuestMap[questId].clickCount++;
        // dailyQuestClickIncremented variable checks whether increment has happen or not
        dailyQuestClickIncremented = 1;
    };

    // incrementing cross game daily quest view count
    this.incrementDailyQuestViewCount = function (questId) {
        if (dailyQuestViewIncremented == 1) {
            return;
        }
        // if inside map questId is not defined, make a map for that questId
        if (crossGameDailyQuestMap[questId] == undefined) {
            crossGameDailyQuestMap[questId] = {
                "viewCount": 0,
                "clickCount": 0
            }
        }
        crossGameDailyQuestMap[questId].viewCount++;
        // dailyQuestViewIncremented variable checks whether increment has happen or not
        dailyQuestViewIncremented = 1;
    };

    //cross game daily quest is shown from here
    this.showCrossGameDailyQuest = function (questId, questData, candidatesInBucket, hostGameBucket, crossGameDataAvailable) {
        var curTimestamp = utilObj.getCurrentTimestamp();
        var questBucket = questData.b;
        crossGameProgress = questsObj.getCrossGameProgressMap();
        allGamesDataMap = questsObj.getAllGamesDataMap();
        curQuests = questsObj.getCurQuests();
        allQuests = questsObj.getAllQuests();
        var cgdqExp = crossGameDailyQuestsObj.getCurrentCGDQExp();
        var engagementType = xpromoConstantsObj.TRACK_CGDQ;

        var gameHosted = questData["gh"];
        if (gameHosted == constantsObj.GAME_ID) {
            crossGameDailyQuestCompletedData = null;
        }
        if (gameHosted == constantsObj.GAME_ID && crossGameProgress[questId] != undefined && crossGameProgress[questId].status != undefined && crossGameProgress[questId].status == xpromoConstantsObj.QUEST_CLAIMED) {
            crossGameDailyQuestsObj.setToasterChecker(true);
        }
        var allParams = questData.pa.split(":");
        if (gameHosted == constantsObj.GAME_ID) {
            crossGameDailyQuestCompletedData = null;
        }
        if (newDayHasBegunAfterCGDQComplete == 1 && gameHosted != constantsObj.GAME_ID) {
            crossGameDailyQuestsObj.resetCrossGameDailyQuestOnTimeComplete(questId);
            newDayHasBegunAfterCGDQComplete = 0;
        }
        var minVersionForDailyQuest = 0;
        var minVersionForHostGame = 0;
        if (utilObj.isAndroid()) {
            minVersionForDailyQuest = xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_MINIMUM_VERSION_DAILY_QUEST_ANDROID);
            minVersionForHostGame = allParams[12];
        } else if (utilObj.isIos()) {
            minVersionForDailyQuest = xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_MINIMUM_VERSION_DAILY_QUEST_IOS);
            minVersionForHostGame = allParams[13];
        }

        if (questData.cr == undefined
            || (gameHosted != constantsObj.GAME_ID && !crossGameDailyQuestsObj.checkCGDQControl() && crossGameDailyQuestCompletedFlag == 1)
            || curQuests == null || CGDQVariablesReset == 0
            || (shouldShowDailyQuestOnAppUpdate == 0 && utilObj.getVersionCode() >= minVersionForDailyQuest)) {
            return;
        }

        if(cgdqPayerFlag == -1) {
            cgdqPayerFlag = xPromoGameSpecificObj.getIsPayerUser() ? 1 : 0;
        }

        var payerRuntime = xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_DAILY_QUEST_PAYER_FLAG);
        if((payerRuntime != 2) && ((payerRuntime == 0 && cgdqPayerFlag != 0) || (payerRuntime == 1 && cgdqPayerFlag != 1))) {
            return;
        }

        var appName = allParams[0];
        var fbid = "";

        var isAppInstalled = false;
        if (utilObj.isAndroid()) {
            isAppInstalled = xpromoUtilObj.isAppInstalled(appName);
        } else if (utilObj.isIos()) {
            isAppInstalled = xpromoUtilObj.isAppInstalled(fbid);
        }

        if (isAppInstalled == true && (allGamesDataMap[gameHosted] == undefined || allGamesDataMap[gameHosted][2] == undefined || allGamesDataMap[gameHosted][2] < minVersionForHostGame)) {
            return;
        }

        // * basic checks
        crossGameDailyQuestsObj.processBasicChecks(questId);

        var shareLink = questsObj.getGameShareLink(allParams[2]);

        if (!(dailyQuestClickIncremented || dailyQuestViewIncremented) && crossGameDailyQuestMap[questId] != undefined && (crossGameDailyQuestMap[questId].viewCount >= allParams[5] || crossGameDailyQuestMap[questId].clickCount >= allParams[6])) {
            return;
        }
        if (xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_SHOW_INSTALL_QUEST) == 0 && isAppInstalled == false) {
            return;
        }

        // reset quest on day complete, or when time gets completed for variant 3
        var questTime = curTimestamp;
        if (crossGameProgress[questId] != undefined && crossGameProgress[questId].params != undefined && crossGameProgress[questId].params[1] != undefined) {
            questTime = crossGameDailyQuestsObj.timeRemainingForDayToComplete(crossGameProgress[questId].params[1]);

            if (cgdqExp == constantsObj.EXP_VAR_3) {
                questTime = parseInt(allParams[11]) * constantsObj.SECONDS_IN_HOUR;
            }
            if (curTimestamp - crossGameProgress[questId].params[1] > questTime && crossGameProgress[questId].status != xpromoConstantsObj.QUEST_NOT_STARTED && curQuests[questId].gh != constantsObj.GAME_ID) {
                // code for reset
                if (cgdqExp == constantsObj.EXP_VAR_3) {
                    crossGameDailyQuestCompletedFlag = 1;
                    crossGameDailyQuestsObj.setLastCohortDailyQuestCgSeen(xPromoGameSpecificObj.getDForUser());
                }
                crossGameDailyQuestsObj.resetCrossGameDailyQuestOnTimeComplete(questId);
                return;
            }
        }
        var userCohortDay = xPromoGameSpecificObj.getDForUser(); //get cohortday of user from game showing
        if (userCohortDay < xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_DAILY_QUEST_DAYS_AFTER_SHOWN)) {
            return;
        }

        var lastSeenCohortDailyQuest = crossGameDailyQuestsObj.getLastCohortDailyQuestCgSeen();

        if (gameHosted != constantsObj.GAME_ID && !(xPromoGameSpecificObj.getDailyQuestsUnlocked() && (crossGameDailyQuestsObj.getCurrentCGDQExp() == constantsObj.EXP_VAR_1 || crossGameDailyQuestsObj.getCurrentCGDQExp() == constantsObj.EXP_VAR_2))) {
            if (lastSeenCohortDailyQuest == undefined || lastSeenCohortDailyQuest == -1 || (userCohortDay > (parseInt(lastSeenCohortDailyQuest)) + parseInt(xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_DAILY_QUEST_SURFACING_BTW_DAYS)))) {
                var lastSeenCohortDay = userCohortDay;
                if (cgdqExp == constantsObj.EXP_VAR_3) {
                    lastSeenCohortDay = xPromoGameSpecificObj.getDForUserFromCreatedTime(userObj.getCreated(), curTimestamp + parseInt(allParams[11]) * constantsObj.SECONDS_IN_HOUR);
                }
                crossGameDailyQuestsObj.setLastCohortDailyQuestCgSeen(lastSeenCohortDay);
            } else if (userCohortDay > crossGameDailyQuestsObj.getLastCohortDailyQuestCgSeen()) {
                return;
            }
        }

        var hostGameCreatedTimestamp = curTimestamp;
        if (allGamesDataMap[questData.gh] != undefined && allGamesDataMap[questData.gh][3] != undefined) {
            hostGameCreatedTimestamp = allGamesDataMap[questData.gh][3];
        }
        // getting host game D Day from host game install time stamp.
        var hostGameDayNumber = xPromoGameSpecificObj.getDForUserFromCreatedTime(hostGameCreatedTimestamp);

        // * decoding cohort days
        // * it is in the format startingDay-endingDay:questLevel;startingDay1-endingDay1:startingDay2
        // * example - 0-7:6;8-30:4;31-i:2;
        var questLevelRequired;
        var cohortDaysParams = questData.cr.split(";");
        for (var i = 0; i < cohortDaysParams.length; i++) {
            if (cohortDaysParams[i] != 0) {
                var cohortDaysLevelsSplit = cohortDaysParams[i].split(":");
                var cohortDays = cohortDaysLevelsSplit[0].split("-");
                if (hostGameDayNumber >= cohortDays[0] && (hostGameDayNumber <= cohortDays[1] || cohortDays[1] == "i")) {
                    questLevelRequired = cohortDaysLevelsSplit[1];
                    // curQuests[questId].re = cohortDaysLevelsSplit[2];
                    break;
                }
            }
        }
        // fetching current level of host game from quest params
        var userCurLevel = crossGameDailyQuestsObj.getCurLevelOfHostedQuest(questId);

        // getting engaged count
        var engagedCount = 0;
        if (crossGameProgress[questId] != undefined && crossGameProgress[questId].params != undefined && crossGameProgress[questId].params[2] != undefined) {
            engagedCount = parseInt(crossGameProgress[questId].params[2]);
        }
        // checking engagement count for post engagement limit
        if (engagedCount >= allParams[7] /* && (crossGameProgress[questId] != undefined && crossGameProgress[questId].status != xpromoConstantsObj.QUEST_COMPLETED) */) {
            // if engagement count increases beyond engagement limit change level required and coin grant value
            questLevelRequired = allParams[8];
            curQuests[questId].re = allParams[9];
            engagementType = xpromoConstantsObj.TRACK_POST_ENGAGEMENT_CGDQ;
        }

        // changing quest description, replacing %value% with questLevelRequired
        curQuests[questId].d = allQuests[questId].d.replace("%value%", questLevelRequired);

        // getting start level
        var startLevel = 0;
        if (crossGameProgress[questId] != undefined && crossGameProgress[questId].params != undefined && crossGameProgress[questId].params[3] != undefined) {
            startLevel = parseInt(crossGameProgress[questId].params[3]);
        } else {
            startLevel = userCurLevel;
        }
        if ((crossGameProgress[questId] == undefined || crossGameProgress[questId].status != xpromoConstantsObj.QUEST_CLAIMED)) {
            var startTime = curTimestamp;
            if (crossGameProgress[questId] != undefined && crossGameProgress[questId].status != xpromoConstantsObj.QUEST_NOT_STARTED && crossGameProgress[questId].params != undefined && crossGameProgress[questId].params.length > 0) {
                startTime = crossGameProgress[questId].params[1];
            }
            // if the game host is same as Game Id , then the quest can be either shown in the game or not
            if (questData.gh == constantsObj.GAME_ID) {
                // ! commenting this part as we want to show loop back engagement on app launch
                // if (crossGameDataAvailable != 1) {
                //     return;
                // }
                var allParams = questData.pa.split(":");
                // var questLevelRequired = parseInt(allParams[3]);
                var lastChosenRequiredLevel = constantsObj.NOT_FOUND;
                if (!questsObj.isQuestShownInGame(questId)) {
                    if (hostGameBucket[questBucket] != undefined) {
                        lastChosenRequiredLevel = parseInt(hostGameBucket[questBucket].pa);
                    }
                } else {
                    // if the quest is shown in the game , maintain the progress in candidateForBucket
                    if (candidatesInBucket[questBucket] != undefined) {
                        lastChosenRequiredLevel = parseInt(candidatesInBucket[questBucket].pa);
                    }
                }
                if (userCurLevel == NaN || userCurLevel == undefined) {
                    userCurLevel = 0;
                }

                if (startLevel == NaN || startLevel == undefined) {
                    startLevel = 0;
                }
                var curProgress = (parseInt(userCurLevel) - parseInt(startLevel));
                if (curProgress < 0) {
                    curProgress = 0;
                }

                if (questLevelRequired > curProgress
                    || (crossGameProgress[questId] != undefined && crossGameProgress[questId].status == xpromoConstantsObj.QUEST_COMPLETED)
                    || (crossGameProgress[questId] != undefined && (crossGameProgress[questId].status == xpromoConstantsObj.QUEST_STARTED))) {
                    //if (lastChosenPriority == constantsObj.NOT_FOUND || lastChosenPriority > questPriority) {
                        var questStatus = xpromoConstantsObj.QUEST_NOT_STARTED;

                        // questStatus = xpromoConstantsObj.QUEST_STARTED;

                        if (crossGameProgress[questId] != undefined) {
                            questStatus = crossGameProgress[questId].status;
                        }
                        if (questStatus == xpromoConstantsObj.QUEST_NOT_STARTED) {
                            return;
                        }
                        if (questStatus == xpromoConstantsObj.QUEST_STARTED && curProgress >= parseInt(questLevelRequired)) {
                            // // loggerObj.debugLog("15. Cross Game Engagement InUpdateAllQuests updating to completed for questid -> ", questId);
                            questStatus = xpromoConstantsObj.QUEST_COMPLETED;
                            questsObj.updateCrossGameQuestStatus(questId, xpromoConstantsObj.QUEST_COMPLETED);
                            crossGameDailyQuestsObj.setShowLoopBackToaster(true);
                        }
                        //loggerObj.debugLog("this is user cur level ", userCurLevel, questId);
                        questData.status = questStatus;
                        questData.curProgress = curProgress;
                        questData.reqProgress = questLevelRequired;
                        questData.timeLimit = questTime;
                        questData.engagementType = engagementType;
                        //// loggerObj.debugLog("this is startime ", startTime);
                        questData.params = [curProgress, startTime, engagedCount, startLevel];
                        if (questsObj.isQuestShownInGame(questId)) {
                            candidatesInBucket[questBucket].push(questData);
                            //candidateForBucket[questBucket] = questData;
                        } else {
                            hostGameBucket[questBucket] = questData;
                        }

                        if (questStatus == xpromoConstantsObj.QUEST_COMPLETED && crossGameDailyQuestsObj.getShowLoopBackToaster() == true) {
                            crossGameDailyQuestCompletedData = questData;
                            if (toasterChecker) {
                                utilObj.delayedCallback(curLayer, crossGameDailyQuestsObj.showToasterAfterDelay, xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_LOOP_BACK_TOASTER), {questId: questId}, false);
                                toasterChecker = false;
                            }
                            if (crossGameDailyQuestCompleteTimestamp == 0) {
                                crossGameDailyQuestCompleteTimestamp = utilObj.getCurrentTimestamp();
                            }
                        } else {
                            crossGameDailyQuestCompleteTimestamp = 0;
                        }
                        crossGameDailyQuestsObj.setCgdqReceiverActive(questData);
                    //}
                } else if (curProgress >= questLevelRequired && crossGameProgress[questId] == undefined && crossGameDataAvailable == 1) {
                    //// loggerObj.debugLog("this is install time quest 2 ", q);
                    crossGameProgress[questId] = {
                        'id': questId,
                        'status': xpromoConstantsObj.QUEST_COMPLETED_BEFORE_START
                    }
                }
            } else {
                if (xPromoGameSpecificObj.getDailyQuestsUnlocked() && (crossGameDailyQuestsObj.getCurrentCGDQExp() == constantsObj.EXP_VAR_1 || crossGameDailyQuestsObj.getCurrentCGDQExp() == constantsObj.EXP_VAR_2)) {
                    return;
                }
                if (candidatesInBucket[questBucket].length == 0) {
                    var tempQData = curQuests[questId];
                    if (userCurLevel == NaN || userCurLevel == undefined) {
                        userCurLevel = 0;
                    }

                    if (startLevel == NaN || startLevel == undefined) {
                        startLevel = 0;
                    }
                    var currProgress = (parseInt(userCurLevel) - parseInt(startLevel));
                    if (currProgress < 0) {
                        currProgress = 0;
                    }
                    var questStatus = xpromoConstantsObj.QUEST_NOT_STARTED;
                    if (crossGameProgress[questId] == undefined || crossGameProgress[questId].status == xpromoConstantsObj.QUEST_NOT_STARTED) {
                        if (crossGameDailyQuestsObj.getCrossGameDailyQuestsUnlocked() == 1 && crossGameDailyQuestsObj.getCrossGameDailyQuestClicked() == 1 && crossGameDailyQuestsObj.getCGDQClaimed() == 0) {
                            questStatus = xpromoConstantsObj.QUEST_STARTED;
                            questsObj.updateCrossGameQuestStatus(questId, questStatus);
                        } else {
                            currProgress = 0;
                        }
                    } else {
                        questStatus = crossGameProgress[questId].status;
                    }

                    if (crossGameProgress[questId] != undefined) {
                        questStatus = crossGameProgress[questId].status;
                    }
                    if (questStatus == xpromoConstantsObj.QUEST_STARTED && currProgress >= parseInt(questLevelRequired)) {
                        questStatus = xpromoConstantsObj.QUEST_COMPLETED;
                        questsObj.updateCrossGameQuestStatus(questId, xpromoConstantsObj.QUEST_COMPLETED);
                    }
                    questData.status = questStatus;
                    questData.curProgress = currProgress;
                    questData.reqProgress = questLevelRequired;
                    questData.timeLimit = questTime;
                    questData.shareLink = shareLink;

                    questData.params = [currProgress, startTime, engagedCount, startLevel];
                    questData.engagementType = engagementType;
                    // loggerObj.debugLog("this is dq questData wt ", questData.params, userCurLevel);
                    dailyQuestToBeShown = questData;
                    candidatesInBucket[questBucket].push(questData);
                    //candidateForBucket[questBucket] = questData;
                    // loggerObj.debugLog("this is testing of return 13");
                    if (checkForSendingTracking == 0) {
                        trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, crossGameDailyQuestsObj.getCurrentCGDQExp(), gameHosted, xpromoConstantsObj.TRACK_CGDQ, xpromoConstantsObj.TRACK_QUEST_ACTIVE, "", "", "", "");
                        checkForSendingTracking = 1;
                    }
                } else {
                    candidatesInBucket[questBucket].push(questData);
                }
            }
            // for fast syncing
            if (crossGameProgress[questId] != undefined && crossGameProgress[questId].status != xpromoConstantsObj.QUEST_NOT_STARTED && crossGameDataAvailable == 1) {
                crossGameProgress[questId].params = questData.params;
            }
        } else {
            // questsObj.updateCrossGameDailyQuestProgress(questId);
        }
    };

    // this function is to get map for quest toaster / notifier / mini popup
    // TODO: need to change this once the content is finalized
    this.getCurrentActiveNotif = function () {
        var notif = {
            "d": xpromoStringsObj.toasterText,
            "b": "1",
            "qp": "0",
            "gh": "11",
            "qt": xpromoConstantsObj.QUEST_TYPE_NOTIFIER,
            "isRequest": "0",
            "isNotifier": "1",
            "re": "0",
        };
        return notif;
    };

    this.decrementDailyQuestUnlockTimerLabel = function (dailyQuestUnlockTimerValue) {
        if(crossGameDailyQuestsObj.isCGDQOptEnabled()) {
            return;
        }

        if (xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_DAILY_QUEST_SWITCH_RUNTIMES) != xpromoConstantsObj.VARIANT_PLAY_X_TIME) {
            if (crossGameDailyQuestsObj.getCurrentCGDQExp() != constantsObj.EXP_VAR_3) {
                return;
            }
        }
        var timeLeft = xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_DAILY_QUEST_GAME_PLAYED_DAY) - dailyQuestUnlockTimerValue;
        //loggerObj.debugLog("data data data data data log 20:", timeLeft, dailyQuestUnlockTimerValue, questCenterLayer.questIdFromVisibleIndex, crossGameDailyQuestsObj.getCrossGameDailyQuestsUnlocked());
        if(timeLeft <= 0 && crossGameDailyQuestsObj.getCrossGameDailyQuestsUnlocked() == 0) {
            //loggerObj.debugLog("data data data data data log 22:", questCenterLayer.questIdFromVisibleIndex);
            timeLeft = 0;
            var gameHosted = crossGameDailyQuestsObj.setCrossGameDailyQuestsUnlocked(1);
            // crossGameDailyQuestsObj.resetCrossGameDailyQuestOnUnlocking(questCenterLayer.dailyCgQuestTimerParam.questId);
            questsObj.getAvailableCrossGameQuests();
            if (dailyQuestToBeShown != null) {
                questsObj.addQuestsToBeAnimated(xpromoConstantsObj.NOTIFIER);
                // loggerObj.debugLog("this is mini popup 1");
                trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, crossGameDailyQuestsObj.getCurrentCGDQExp(), gameHosted, xpromoConstantsObj.TRACK_CGDQ, xpromoConstantsObj.TRACK_VIEW_MINIPOP, "", "", "", "");
            }
            if (curScreen == constantsObj.SCREEN_QUEST_CENTER && crossGameDailyQuestsObj.getCurrentCGDQExp() != constantsObj.EXP_VAR_CONTROL && questCenterLayer.dailyCgQuestTimerParam != null) {
                var visibleIndex = -1;
                var questId = questCenterLayer.dailyCgQuestTimerParam.questId;
                //loggerObj.debugLog("data data data data data log 3:", visibleIndex, questId, questCenterLayer.questIdFromVisibleIndex[visibleIndex]);
                for(var j in questCenterLayer.questIdFromVisibleIndex) {
                    //loggerObj.debugLog("data data data data data log 31:", questCenterLayer.questIdFromVisibleIndex[j]);
                    if(questCenterLayer.questIdFromVisibleIndex[j] == questId) {
                        visibleIndex = j;
                        break;
                    }
                }
                var loopIndex = 1000;
                if(visibleIndex != -1) {
                    loopIndex = questCenterLayer.indexVisibleToParamsTrack[visibleIndex];
                }
                //loggerObj.debugLog("data data data data data log 5:", visibleIndex, questId, loopIndex);
                var uiReference = questCenterLayer.uiReferenceForQuest[visibleIndex];
                //loggerObj.debugLog("data data data data data log 6:", visibleIndex, questId, uiReference);
                //loopIndex = questCenterLayer.indexParamsToVisibleTrack[loopIndex];
                if (uiReference == null) {
                    //loggerObj.debugLog("in timer fnc log 3 here going null:", questCenterLayer.uiReferenceForQuest[i], loopIndex);
                    //continue;
                }
                // questId = questCenterLayer.questIdFromVisibleIndex[loopIndex];
                // var oldBucketId = questsObj.getCurQuestData(questId).b;
                // var availableQuests = questsObj.getAvailableInGameQuests();
                // for (var quest in availableQuests) {
                //     var bucketId = availableQuests[quest].b;
                //     if (oldBucketId == bucketId) {
                //         questId = availableQuests[quest].id;
                //         break;
                //     }
                // }
                //utilObj.delayedCallback(questCenterLayer.scrollView, questCenterLayer.newChangeQuestStatus, 4.0, {"visibleIndex": visibleIndex, "questId":questId}, false);
                // questCenterLayer.changeQuestStatus(visibleIndex, questId);
                //added
                //removed
                questCenterLayer.redraw();
                //removed
                return;
            }
        }

        if (curScreen == constantsObj.SCREEN_QUEST_CENTER && crossGameDailyQuestsObj.getCrossGameDailyQuestsUnlocked() == 0 && questCenterLayer.dailyCgQuestTimerParam != null) {
            if (timeLeft <= 0) {
                timeLeft = 0;
            }

            var visibleIndex = -1;
            var questId = questCenterLayer.dailyCgQuestTimerParam.questId;
            for(var j in questCenterLayer.questIdFromVisibleIndex) {
                if(questCenterLayer.questIdFromVisibleIndex[j] == questId) {
                    visibleIndex = j;
                    break;
                }
            }
            var uiReference = questCenterLayer.uiReferenceForQuest[visibleIndex];
            var labelParams = questCenterLayer.dailyCgQuestTimerParam;
            var timerLbl = labelParams.lbl;
            timerLbl = uiReference["unlockTimerLbl"];
            var formattedTimeStr = xpromoUtilObj.formatTimeHrMin(timeLeft);
            var playForStr1 = xpromoStringsObj.play_for_time;
            playForStr1 = playForStr1.replace("%VALUE%", formattedTimeStr);
            playForStr1 = playForStr1.replace("%game%", xPromoGameSpecificObj.getGameName());
            utilObj.setString(timerLbl, playForStr1);
        }
    };

    this.decrementDailyQuestCompleteLabel = function () {
        if(crossGameDailyQuestsObj.isCGDQOptEnabled()) {
            return;
        }

        var value = xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_DAILY_QUEST_COMPLETED) - crossGameDailyQuestsObj.getDailyQuestsCompleted();
        if(value <= 0 && crossGameDailyQuestsObj.getCrossGameDailyQuestsUnlocked() == 0) {
            var gameHostedIn = crossGameDailyQuestsObj.setCrossGameDailyQuestsUnlocked(1);
            // crossGameDailyQuestsObj.resetCrossGameDailyQuestOnUnlocking(questCenterLayer.dailyCgQuestTimerParam.questId);
            questsObj.getAvailableCrossGameQuests();
            if (dailyQuestToBeShown != null) {
                questsObj.addQuestsToBeAnimated(xpromoConstantsObj.NOTIFIER);
                // loggerObj.debugLog("this is mini popup 2");
                trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, crossGameDailyQuestsObj.getCurrentCGDQExp(), gameHostedIn, xpromoConstantsObj.TRACK_CGDQ, xpromoConstantsObj.TRACK_VIEW_MINIPOP, "", "", "", "");
            }
            if (curScreen == constantsObj.SCREEN_QUEST_CENTER) {
                // questCenterLayer.redraw();
                return;
            }
        }

        if (curScreen == constantsObj.SCREEN_QUEST_CENTER && crossGameDailyQuestsObj.getCrossGameDailyQuestsUnlocked() == 0 && questCenterLayer.dailyCgQuestTimerParam != null) {
            var labelParams = questCenterLayer.dailyCgQuestTimerParam;
            var timerLbl = labelParams.lbl;
            var playForStr1 = xpromoStringsObj.complete_daily_quests;
            if (value == 1) {
                playForStr1 = playForStr1.replace("quests", "quest");
            }
            playForStr1 = playForStr1.replace("%VALUE%", value.toString());
            utilObj.setString(timerLbl, playForStr1);
        }
    };

    this.updateCGDQOptUnlockStatus = function() {
        if(!crossGameDailyQuestsObj.isCGDQOptEnabled()) {
            return;
        }

        var value = Number.MAX_VALUE;

        if(crossGameDailyQuestsObj.isCGDQOptPuzzlesBased()) {
            value = crossGameDailyQuestsObj.getPuzzleCompletesRequired() - xPromoGameSpecificObj.getDailyPuzzleClears();
        } else if (crossGameDailyQuestsObj.isCGDQOptVideosBased()) {
            value = crossGameDailyQuestsObj.getVideoWatchesRequired() - xPromoGameSpecificObj.getDailyWatchVideosCount();
        }

        if(value <= 0 && crossGameDailyQuestsObj.getCrossGameDailyQuestsUnlocked() == 0) {
            var gameHostedIn = crossGameDailyQuestsObj.setCrossGameDailyQuestsUnlocked(1);
            // crossGameDailyQuestsObj.resetCrossGameDailyQuestOnUnlocking(questCenterLayer.dailyCgQuestTimerParam.questId);
            questsObj.getAvailableCrossGameQuests();
            if (dailyQuestToBeShown != null) {
                questsObj.addQuestsToBeAnimated(xpromoConstantsObj.NOTIFIER);
                // loggerObj.debugLog("this is mini popup 2");
                trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, crossGameDailyQuestsObj.getCurrentCGDQExp(), gameHostedIn, xpromoConstantsObj.TRACK_CGDQ, xpromoConstantsObj.TRACK_VIEW_MINIPOP, "", "", "", "");
            }
            if (curScreen == constantsObj.SCREEN_QUEST_CENTER) {
                // questCenterLayer.redraw();
                return;
            }
        }

        if (curScreen == constantsObj.SCREEN_QUEST_CENTER && crossGameDailyQuestsObj.getCrossGameDailyQuestsUnlocked() == 0 && questCenterLayer.dailyCgQuestTimerParam != null) {
            var labelParams = questCenterLayer.dailyCgQuestTimerParam;
            var timerLbl = labelParams.lbl;
            var questDesc = crossGameDailyQuestsObj.getUpdatedQuestDescForCGDQOpt();

            utilObj.setString(timerLbl, questDesc);
        }
    };

    this.checkDailyCrossGameLocked = function (questType, runtimeSwitch) {
        if (questType.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) != 0) {
            return false;
        }

        if(crossGameDailyQuestsObj.isCGDQOptEnabled()) {
            if(crossGameDailyQuestsObj.isCGDQOptPuzzlesBased()) {
                return xPromoGameSpecificObj.getDailyPuzzleClears() < crossGameDailyQuestsObj.getPuzzleCompletesRequired();
            }
            if(crossGameDailyQuestsObj.isCGDQOptVideosBased()) {
                return xPromoGameSpecificObj.getDailyWatchVideosCount() < crossGameDailyQuestsObj.getVideoWatchesRequired();
            }
        }

        if (runtimeSwitch == xpromoConstantsObj.VARIANT_COMPLETE_X_LEVELS) {
            if (crossGameDailyQuestsObj.getDailyQuestsCompleted() < xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_DAILY_QUEST_COMPLETED)) {
                return true;
            }
            return false;
        }
        if (crossGameDailyQuestsObj.getDailyQuestTimerLabelValue() <= xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_DAILY_QUEST_GAME_PLAYED_DAY)) {
            return true;
        }
        return false;
    };

    this.getCrossGameDailyQuestCompletedData = function () {
        return crossGameDailyQuestCompletedData;
    };

    this.processBasicChecks = function (questId) {
        if (crossGameProgress[questId] != undefined && crossGameProgress[questId].params) {
            // if curProgress is Not a number (NaN) or undefined make it zero
            if (crossGameProgress[questId].params[0] == NaN || crossGameProgress[questId].params[0] == undefined) {
                crossGameProgress[questId].params[0] = 0;
            }

            // if quest start time is Not a number (NaN) or undefined make it current time stamp
            if (crossGameProgress[questId].params[1] == NaN || crossGameProgress[questId].params[1] == undefined) {
                crossGameProgress[questId].params[1] = utilObj.getCurrentTimestamp();
            }

            // if quest engagement count is Not a number (NaN) or undefined make it zero
            if (crossGameProgress[questId].params[2] == NaN || crossGameProgress[questId].params[2] == undefined) {
                crossGameProgress[questId].params[2] = 0;
            }

            // if start level count is Not a number (NaN) or undefined make it zero
            if (crossGameProgress[questId].params[3] == NaN || crossGameProgress[questId].params[3] == undefined) {
                crossGameProgress[questId].params[3] = 0;
            }
        }
    };


    this.makeInstallQuestStarted = function (questId) {
        var gameHosted = curQuests[questId].gh;
        var sortedQuestList = questsObj.getSortedQuestList();
        for (var i = 0; i < sortedQuestList.length; i++) {
            if (sortedQuestList[i].gh == gameHosted && sortedQuestList[i].qt == xpromoConstantsObj.QUEST_TYPE_INSTALL_GAME) {
                var relatedQuestId = sortedQuestList[i].id;
                if (crossGameProgress[relatedQuestId] == undefined || crossGameProgress[relatedQuestId].status == xpromoConstantsObj.QUEST_NOT_STARTED) {
                    questsObj.updateCrossGameQuestStatus(relatedQuestId, xpromoConstantsObj.QUEST_STARTED);
                }
            }
        }
    };

    this.showToasterAfterDelay = function(sender, params) {
        trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, crossGameDailyQuestsObj.getCurrentCGDQExp(), curQuests[params.questId].gh, xpromoConstantsObj.TRACK_CGDQ, constantsObj.TRACK_VIEW_MINIPOP, "", "", "","");
        questsObj.addQuestsToBeAnimated(params.questId);
        questsObj.updateQuestStatusCounts();
    };


    this.updateDailyCgTimer = function () {
        if (xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_DAILY_QUEST_SWITCH_RUNTIMES) == 1 || crossGameDailyQuestsObj.getCurrentCGDQExp() == constantsObj.EXP_VAR_3) {
            crossGameDailyQuestsObj.setDailyQuestTimerLabelValue(crossGameDailyQuestsObj.getDailyQuestTimerLabelValue() + 1);
        }
    };

    this.fireTrackingForDailyQuest = function (puzzle) {
        if (cgdqReceiverActive != null) {
            trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, crossGameDailyQuestsObj.getCurrentCGDQExp(), puzzle, xpromoConstantsObj.TRACK_CGDQ_RECIEVER, constantsObj.TRACK_CLEAR, "", "", "","");
        }
    };

    // * this to check whether cgdq is in control experiment or not
    // * return 1 if cgdq is in control
    // * return 0 if cgdq is not in control
    this.checkCGDQControl = function () {
        return crossGameDailyQuestsObj.getCurrentCGDQExp() == constantsObj.EXP_VAR_CONTROL;
    };

    this.getCurLevelOfHostedQuest = function (questId) {
        var userCurLevel = 0;
        var curQuests = questsObj.getCurQuests();
        var questData = curQuests[questId];
        var allParams = questData.pa.split(":"), gameHosted = questData.gh;
        if (allGamesDataMap[questData.gh] != undefined && allGamesDataMap[questData.gh][allParams[10]] != undefined) {
            if (gameHosted != constantsObj.GAME_ID) {
                userCurLevel = allGamesDataMap[questData.gh][allParams[10]];
            } else {
                userCurLevel = xPromoGameSpecificObj.getPuzCompleted();
            }
        }
        return userCurLevel;
    };

    this.getCGDQOptExperiment = function() {
        var currentExpValue = epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_XPROMO_CGDQ_OPT);
        if(currentCGDCOptExp == -1 || (currentCGDCOptExp != constantsObj.EXP_VAR_CONTROL && currentExpValue == constantsObj.EXP_VAR_CONTROL)) {
            currentCGDCOptExp = currentExpValue;
        }

        return currentCGDCOptExp;
    };

    this.isCGDQOptEnabled = function() {
        return crossGameDailyQuestsObj.isCGDQOptPuzzlesBased() || crossGameDailyQuestsObj.isCGDQOptVideosBased();
    };

    this.isCGDQOptPuzzlesBased = function() {
        // Enable only if there is sufficient video history
        if(pspnActionHistory.getPuzzleClearsMedian(xpromoConstantsObj.CGDQ_OPT_HISTORY_PERIOD) == -1) {
            return false;
        }

        if(crossGameDailyQuestsObj.getCurrentCGDQExp() != constantsObj.EXP_VAR_3) {
            return crossGameDailyQuestsObj.getCGDQOptExperiment() == constantsObj.EXP_VAR_1;
        }
        return false;
    };

    this.isCGDQOptVideosBased = function() {
        // Enable only if there is sufficient video history
        if(pspnActionHistory.getW2eVideosMedian(xpromoConstantsObj.CGDQ_OPT_HISTORY_PERIOD) == -1) {
            return false;
        }

        if(crossGameDailyQuestsObj.getCurrentCGDQExp() != constantsObj.EXP_VAR_3) {
            return crossGameDailyQuestsObj.getCGDQOptExperiment() == constantsObj.EXP_VAR_2;
        }
        return false;
    };

    this.getPuzzleCompletesRequired = function() {
        return Math.max(1, Math.floor(xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_DAILY_QUEST_PUZZLES_PERCENTAGE) * pspnActionHistory.getPuzzleClearsMedian(xpromoConstantsObj.CGDQ_OPT_HISTORY_PERIOD)));
    };

    this.getVideoWatchesRequired = function() {
        return Math.max(1, Math.floor(xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_DAILY_QUEST_VIDEOS_PERCENTAGE) * pspnActionHistory.getW2eVideosMedian(xpromoConstantsObj.CGDQ_OPT_HISTORY_PERIOD)));
    };

    this.getUpdatedQuestDescForCGDQOpt = function() {
        var questDesc = "";
        var value = Number.MAX_VALUE;
        if(crossGameDailyQuestsObj.isCGDQOptPuzzlesBased()) {
            questDesc = xpromoStringsObj.cgdq_puzzle_completes;
            value = crossGameDailyQuestsObj.getPuzzleCompletesRequired() - xPromoGameSpecificObj.getDailyPuzzleClears();
            if(value == 1) {
                questDesc = questDesc.replace("puzzles", "puzzle");
            }
        }

        if(crossGameDailyQuestsObj.isCGDQOptVideosBased()) {
            questDesc = xpromoStringsObj.cgdq_video_watches;
            value = crossGameDailyQuestsObj.getVideoWatchesRequired() - xPromoGameSpecificObj.getDailyWatchVideosCount();
            if(value == 1) {
                questDesc = questDesc.replace("videos", "video");
            }
        }

        questDesc = questDesc.replace("%VALUE%", value.toString());

        return questDesc;
    }

};
