SocialQuest = function () {
    var changeFriendInSocialQuest = 0;
    var questInviteCurrentFriend = {};
    var questInviteFriend = {};
    var questConfigLoaded = false;
    var questConfigData = null;
    var socialQuestBotShown = false;
    var socialQuestBotShownTs = 0;

    this.init = function () {
        cc.loader.loadJson(res.social_quest_json, function (error, data) {
            if (error == null && data != null) {
                questConfigData = data;
                questConfigLoaded = true;
            }
        });
    };

    this.save = function (quests) {
        if (quests == null || quests == "" || quests == undefined) {
            return false;
        }
        quests.questInviteCurrentFriend = questInviteCurrentFriend;
        quests.questInviteFriend = questInviteFriend;
        quests.socialQuestBotShown = socialQuestBotShown;
        quests.socialQuestBotShownTs = socialQuestBotShownTs;
        return quests;
    };

    this.load = function (quests) {
        if (quests.questInviteCurrentFriend != undefined) {
            questInviteCurrentFriend = quests.questInviteCurrentFriend;
        }
        if (quests.questInviteFriend != undefined) {
            questInviteFriend = quests.questInviteFriend;
        }
        if(quests.socialQuestBotShown != undefined) {
            socialQuestBotShown = quests.socialQuestBotShown;
        }
        if(quests.socialQuestBotShownTs != undefined) {
            socialQuestBotShownTs = quests.socialQuestBotShownTs;
        }
    };

    this.getSocialQuestConfig = function () {
        return questConfigData;
    };

    this.getSocialQuestBotShown = function () {
        return socialQuestBotShown;
    };

    this.getChangeFriendInSocialQuest = function () {
        return changeFriendInSocialQuest;
    };

    this.setChangeFriendInSocialQuest = function (val) {
        changeFriendInSocialQuest = val;
    };

    this.getCurrentFriend = function () {
        return questInviteCurrentFriend;
    };

    this.resetCurrentFriend = function () {
        questInviteCurrentFriend = {};
    };

    this.resetQuestInviteFriend = function () {
        questInviteFriend = {};
    };

    this.resetQuestsData = function () {
        socialQuestObj.resetCurrentFriend();
        socialQuestObj.resetQuestInviteFriend();
    };

    this.getSocialQuestInvite = function () {
        return questInviteFriend;
    };

    this.getImageLinkFromName = function (fbId, gameIconName) {
        var imageUrl = friendsObj.getFbPicUrl(fbId);
        return imageUrl;
    };

    this.getAbsFilePathForFbPic = function (fbId, gameIconName) {
        if (gameIconName.indexOf("friendly_") == 0) {
            return "#" + gameIconName;
        }
        if (!utilObj.isWeb()) {
            return utilObj.getAbsFilePath(gameIconName);
        } else {
            return this.getImageLinkFromName(fbId, gameIconName);
        }
    };

    this.toShowBotsOrNot = function () {
        var expVarSocialQuest = epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSEUDO_QUEST_INVITE);
        if (expVarSocialQuest == constantsObj.EXP_VAR_CONTROL
            || xpromoUtilObj.getDaysDiffBetweenTimestamps(utilObj.getCurrentTimestamp(), userObj.getCreated()) < parseInt(xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_PSEUDO_SOCIAL, 0))
            || (xPromoGameSpecificObj.getIsPayer() == 1 && parseInt(xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_PSEUDO_SOCIAL, 1)) == 0)
            || (socialQuestBotShownTs != 0 && (utilObj.getCurrentTimestamp() - socialQuestBotShownTs) / 60 >= xpromoGameRuntimeObj.getSocialQuestRuntime() && (utilObj.getCurrentTimestamp() - socialQuestBotShownTs) / constantsObj.SECONDS_IN_DAY < parseInt(xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_PSEUDO_SOCIAL, 2)))) {
            return false;
        }
        return true;
    };

    this.edittingDataForSocialQuest = function (questData, socialQuest, shouldShowFriend) {
        var questId = questData.id;
        var expVarSocialQuest = epmObj.getChosenVariant(xpromoConstantsObj.EXP_QUEST_INVITE);
        var expVarPseudoSocialQuest = epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSEUDO_QUEST_INVITE);
        var variantSocialQuest = (expVarSocialQuest == constantsObj.EXP_VAR_1 || expVarSocialQuest == constantsObj.EXP_VAR_2);
        var botsToBeShown = socialQuestObj.toShowBotsOrNot();
        if ((variantSocialQuest || botsToBeShown) && questData.qt == xpromoConstantsObj.QUEST_TYPE_INSTALL_GAME && socialQuest == 0) {
            socialQuest = 1;
            var curTimestamp = utilObj.getCurrentTimestamp();
            if (questInviteCurrentFriend == undefined) {
                questInviteCurrentFriend = {};
            }
            var condition = questInviteCurrentFriend["friend"] == undefined || (curTimestamp - questInviteCurrentFriend["friend"].timeSeen) / 60 >= xpromoGameRuntimeObj.getSocialQuestRuntime() || changeFriendInSocialQuest == 1;
            var userLoggedIn = fbWrapperObj.isLoggedIn();
            if (condition) {
                socialQuestBotShown = false;
                changeFriendInSocialQuest = 0;
                var noFriendLeft = false;
                var friendFound = false;
                // if all the friends have been displayed then we need to repeat the friends, so emptying social quest map
                if (Object.keys(questInviteFriend).length >= friendsObj.getPsFriendRefIds().split(",").length) {
                    questInviteFriend = {};
                }

                if (!noFriendLeft && userLoggedIn && variantSocialQuest) {
                    // getting all the playsimple friends
                    var refIds = friendsObj.getPsFriendRefIds();
                    refIds = refIds.split(",");
                    // randomizing array
                    refIds.sort(function () {
                        return .5 - Math.random();
                    });
                    // selecting a friend which has not been displayed
                    for (var refId in refIds) {
                        var rid = refIds[refId];
                        if (questInviteFriend[rid] == undefined) {
                            questInviteFriend[rid] = 1;
                            var psFriend = friendsObj.getPsFriendForRefId(rid);
                            if (psFriend == null) {
                                shouldShowFriend = 0;
                                break;
                            }
                            questInviteCurrentFriend["friend"] = {
                                "refId": rid,
                                "fbId": psFriend.Fbid,
                                "name": psFriend.Name.split(" ")[0],
                                "timeSeen": curTimestamp,
                            };
                            friendFound = true;
                            shouldShowFriend = 0;
                            break;
                        }
                    }
                } /*else if (!variantSocialQuest) {
                    loggerObj.debugLog("social quest log 7");
                    noFriendLeft = true;
                }*/

                if (!friendFound) {
                    socialQuest = 0;
                    shouldShowFriend = 0;
                }

                if (botsToBeShown && (!friendFound || (userLoggedIn && noFriendLeft) || !userLoggedIn)) {
                    if (!questConfigLoaded) {
                        shouldShowFriend = 0;
                    } else {
                        socialQuestBotShown = true;
                        socialQuest = 1;
                        shouldShowFriend = 1;
                        var randInt = utilObj.getRandomIntInRange(0, questConfigData.length);
                        var bot = questConfigData[randInt];
                        questInviteCurrentFriend["friend"] = {
                            "refId": bot.rid,
                            "fbId": "friendly_" + bot.rid,
                            "name": bot.name.split(" ")[0],
                            "timeSeen": curTimestamp,
                        };
                        socialQuestBotShownTs = curTimestamp;
                    }
                }

            }
            // downloading fb photo
            if (shouldShowFriend == 1) {
                questData.isSocialQuest = 1;
                if (userLoggedIn == true) {
                    var gameIconName = questInviteCurrentFriend["friend"].fbId + ".jpg";
                    if (!utilObj.fileExists(gameIconName)) {
                        var gameIconUrl = friendsObj.getFbPicUrl(questInviteCurrentFriend["friend"].fbId);
                        utilObj.downloadFileV1(gameIconUrl, gameIconName);
                    }
                }

                // changing description of quest
                questData.psFriend = questInviteCurrentFriend["friend"];
                var questDesc = "";
                if (botsToBeShown) {
                    if (expVarPseudoSocialQuest == constantsObj.EXP_VAR_1) {
                        questDesc = xpromoGameRuntimeObj.getSocialQuestStringExp1();
                    }
                    if (expVarPseudoSocialQuest == constantsObj.EXP_VAR_2) {
                        questDesc = xpromoGameRuntimeObj.getSocialQuestStringExp2();
                    }
                } else {
                    questDesc = xpromoGameRuntimeObj.getSocialQuestString();
                }
                var allQuests = questsObj.getAllQuests();
                var gameName = "", questDescArr = allQuests[questId].d.split(" ");
                for (var i = 1; i < questDescArr.length; i++) {
                    gameName += questDescArr[i] + " ";
                }

                // This needs to called only once as on subsequent calls questData.d itself is changed to the newer description
                if(questData.originalDesc == undefined) {
                    questData.originalDesc = questData.d;
                }
                questDesc = questDesc.replace("%name%", questInviteCurrentFriend["friend"].name);
                questDesc = questDesc.replace("%game%", gameName);
                questData.d = questDesc;
            }
        }
        return [socialQuest, shouldShowFriend];
    };
};