SoftLaunch = function () {
    var softLaunchSeenCount = 0;
    var isSoftLaunchSuppressed = false;
    var currentQuestPriority = 0;
    var currentExp = constantsObj.EXP_VAR_5;
    var attemptToShowSoftLaunch = false;
    var cb = null;
    var priorityArr = [];
    var softLaunchBannerMap = {};
    var didIncrementHappened = 0;
    var puzzleCompleted = false;
    var softLaunchShown = 0;
    var var5_link = constantsObj.MISC_SERVER_STATIC_BASE + "quests/images/soft_launch/interstitial_1/";
    var var6_link = constantsObj.MISC_SERVER_STATIC_BASE + "quests/images/soft_launch/interstitial_2/";
    var gif_link = constantsObj.MISC_SERVER_STATIC_BASE + "quests/images/soft_launch/gifs/";
    var banner_link = constantsObj.MISC_SERVER_STATIC_BASE + "quests/images/soft_launch/banners/";
    var canShowSoftLaunchPopup = false;
    var priorityToQuestMap = {};


    this.getXPromoGameObj = function (gameData) {
        gameData.softLaunchSeenCount = softLaunchSeenCount;
        gameData.currentQuestPriority = currentQuestPriority;
        gameData.isSoftLaunchSuppressed = isSoftLaunchSuppressed;

        return gameData;
    };

    this.loadLocal = function (gameData) {
        if (gameData.softLaunchSeenCount != undefined) {
            softLaunchSeenCount = gameData.softLaunchSeenCount;
        }
        if (gameData.currentQuestPriority != undefined) {
            currentQuestPriority = gameData.currentQuestPriority;
        }
        if (gameData.isSoftLaunchSuppressed != undefined) {
            isSoftLaunchSuppressed = gameData.isSoftLaunchSuppressed;
        }
    };

    this.getCurrentquestPriority = function () {
        return currentQuestPriority;
    };


    this.setIsSoftLaunchSuppressed = function (val) {
        isSoftLaunchSuppressed = val;
    };

    this.getIsSoftLaunchSuppressed = function () {
        return isSoftLaunchSuppressed;
    };

    this.getAttemptToShowSoftLaunch = function () {
        return attemptToShowSoftLaunch;
    };

    this.getIsPuzzleCompleted = function () {
        return puzzleCompleted;
    };

    this.setIsPuzzleCompleted = function (val) {
        puzzleCompleted = val;
    };

    this.getSoftLaunchShown = function () {
        return softLaunchShown;
    };

    this.setSoftLaunchShown = function (val) {
        softLaunchShown = val;
    };

    this.showSoftLaunchPopupOnSpecificScreens = function () {
        if (canShowSoftLaunchPopup) {
            softLaunchPopup.show(true);
            canShowSoftLaunchPopup = false;
        }
    };

    this.getCanShowSoftLaunchPopup = function () {
        return canShowSoftLaunchPopup;
    };

    this.getSoftLaunchBannerMap = function () {
        return softLaunchBannerMap;
    };

    this.getPriorityToQuestMap = function () {
        return priorityToQuestMap;
    };

    this.softLaunchGameIncrement = function (force) {
        softLaunchSeenCount = softLaunchSeenCount + 1;
        if ((softLaunchSeenCount >= 3 || force == true) && didIncrementHappened == 0) {
            for (var i = 0; i < priorityArr.length; i++) {
                if (currentQuestPriority == priorityArr[i]) {
                    currentQuestPriority = priorityArr[i + 1];
                    softLaunchSeenCount = 0;
                    didIncrementHappened = 1;
                    break;
                }
            }
        }
    };


    this.shouldShowSoftLaunch = function () {
        currentExp = epmObj.getChosenVariant(xPromoGameSpecificObj.getAdwallExpName());
        var adwallQuests = questsObj.getAdWallQuests();
        var gradient_image = xpromoConstantsObj.popup_bg_soft_launch;
        var gradient_link = xpromoUtilObj.getImageLinkFromName(gradient_image);
        var gamesLimit = xpromoGameRuntimeObj.getSoftLaunchRuntime();
        var isGradientImageDownloaded = true;
        attemptToShowSoftLaunch = true;
        if (!utilObj.isWeb() && !utilObj.fileExists(gradient_image)) {
            xPromoGameSpecificObj.downloadFileV1(gradient_link, gradient_image);
            isGradientImageDownloaded = false;
        }
        if (currentExp == constantsObj.EXP_VAR_5 || currentExp == constantsObj.EXP_VAR_6 || (currentExp == constantsObj.EXP_VAR_8)) {
            var currentPriority = 0, gameCount = 0;
            for (var quest in adwallQuests) {
                if (adwallQuests[quest].gh != constantsObj.GAME_ID) {
                    if (gameCount >= gamesLimit) {
                        break;
                    }
                    gameCount += 1;
                    var allParams = adwallQuests[quest].pa.split(":");
                    if (xpromoUtilObj.isAppInstalled(allParams[0])) {
                        continue;
                    }
                    priorityArr.push(adwallQuests[quest].p);
                    priorityToQuestMap[adwallQuests[quest].p] = adwallQuests[quest];
                    if (currentQuestPriority == adwallQuests[quest].p) {
                        currentPriority = currentQuestPriority;
                    }
                }
            }
            //loggerObj.debugLog("this is show adwall call ", priorityArr);
            if (priorityArr.length == 0) {
                trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(), xpromoConstantsObj.TRACK_SOFT_LAUNCH, xpromoConstantsObj.TRACK_SOFT_LAUNCH_FAILED, xpromoConstantsObj.TRACK_ALL_GAMES_INSTALLED, currentExp, "", "");
                return;
            }
            // priorityArr = priorityArr.sort(function (a, b) {  return a - b;  });
            if (currentPriority == 0 || currentPriority == undefined) {
                currentQuestPriority = priorityArr[0];
            }
            if (priorityArr.length > gamesLimit) {
                priorityArr.splice(gamesLimit);
            }
            priorityArr.push(priorityArr[0]);
            //loggerObj.debugLog("this is priority arr ", priorityArr);
            if (priorityToQuestMap[currentQuestPriority].creatives == undefined) {
                return;
            }
            var creativesMap = xpromoUtilObj.getKeyValuePairForCreatives(priorityToQuestMap[currentQuestPriority].creatives);

            var isReqdCreativeDownloaded = true;
            if (utilObj.isWeb()) {

            } else if ((currentExp == constantsObj.EXP_VAR_5 || currentExp == constantsObj.EXP_VAR_8) && creativesMap.var5_gif == 0) {
                isReqdCreativeDownloaded = softLaunchObj.downloadGivenImage(var5_link + creativesMap.var5_creative, creativesMap.var5_creative);
            } else if ((currentExp == constantsObj.EXP_VAR_5 || currentExp == constantsObj.EXP_VAR_8) && creativesMap.var5_gif == 1) {
                var creativeName = creativesMap.var5_creative;
                creativeName = creativeName.split("_");
                var spriteName = creativeName[0], spritePng = creativeName[1];
                isReqdCreativeDownloaded = softLaunchObj.downloadSprites(gif_link, spriteName, spritePng);
            } else if (currentExp == constantsObj.EXP_VAR_6 && creativesMap.var6_gif == 0) {
                isReqdCreativeDownloaded = softLaunchObj.downloadGivenImage(var6_link + creativesMap.var6_creative, creativesMap.var6_creative);
            } else if (currentExp == constantsObj.EXP_VAR_6 && creativesMap.var6_gif == 1) {
                var creativeName = creativesMap.var6_creative;
                creativeName = creativeName.split("_");
                var spriteName = creativeName[0], spritePng = creativeName[1];
                isReqdCreativeDownloaded = softLaunchObj.downloadSprites(gif_link, spriteName, spritePng);
            }
            if (isReqdCreativeDownloaded == false) {
                trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(), xpromoConstantsObj.TRACK_SOFT_LAUNCH, xpromoConstantsObj.TRACK_SOFT_LAUNCH_FAILED, xpromoConstantsObj.TRACK_IMAGES_NOT_DOWNLOADED, currentExp, "", "");
                return;
            }

        } else if (currentExp == constantsObj.EXP_VAR_7) {
            var count = 0, shouldNotShow = 0, gamesCount = 0;
            for (var quest in adwallQuests) {
                if (adwallQuests[quest].gh != constantsObj.GAME_ID) {
                    var allParams = adwallQuests[quest].pa.split(":");
                    if (gamesCount >= gamesLimit) {
                        break;
                    }
                    gamesCount += 1;
                    if (xpromoUtilObj.isAppInstalled(allParams[0])) {
                        continue;
                    }
                    softLaunchBannerMap[adwallQuests[quest].p] = adwallQuests[quest];
                    count += 1;
                }
                if (count >= 3) {
                    break;
                }
            }
            //loggerObj.debugLog("this is count of surfacings ", count);
            if (count == 0) {
                trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(), xpromoConstantsObj.TRACK_SOFT_LAUNCH, xpromoConstantsObj.TRACK_SOFT_LAUNCH_FAILED, xpromoConstantsObj.TRACK_ALL_GAMES_INSTALLED, currentExp, "", "");
                return;
            }
            if (count < 3) {
                for (var quest in adwallQuests) {
                    if (adwallQuests[quest].gh != constantsObj.GAME_ID && softLaunchBannerMap[adwallQuests[quest].p] == undefined) {
                        softLaunchBannerMap[adwallQuests[quest].p] = adwallQuests[quest];
                        count += 1;
                    }
                    if (count >= 3) {
                        break;
                    }
                }
            }
            for (var quest in softLaunchBannerMap) {
                var questParams = softLaunchBannerMap[quest].pa;
                questParams = questParams.split(":");
                if (softLaunchBannerMap[quest].creatives == undefined) {
                    return;
                }
                var creativesMap = xpromoUtilObj.getKeyValuePairForCreatives(softLaunchBannerMap[quest].creatives);
                var gameIconName = creativesMap.var7_creative;
                var gameIconLink = constantsObj.MISC_SERVER_STATIC_BASE + "quests/images/soft_launch/banner/" + gameIconName;
                if (!utilObj.isWeb() && !utilObj.fileExists(gameIconName)) {
                    xPromoGameSpecificObj.downloadFileV1(gameIconLink, gameIconName);
                    //loggerObj.debugLog("this is game Icon Name w ");
                    shouldNotShow = 1;
                }
            }
            //loggerObj.debugLog("this is should show ", shouldNotShow);
            if (shouldNotShow) {
                trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(), xpromoConstantsObj.TRACK_SOFT_LAUNCH, xpromoConstantsObj.TRACK_SOFT_LAUNCH_FAILED, xpromoConstantsObj.TRACK_IMAGES_NOT_DOWNLOADED, currentExp, "", "");
                return;
            }
        } else {
            return;
        }

        if (isGradientImageDownloaded == false) {
            trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(), xpromoConstantsObj.TRACK_SOFT_LAUNCH, xpromoConstantsObj.TRACK_SOFT_LAUNCH_FAILED, xpromoConstantsObj.TRACK_GRADIENT_IMAGE_FAILED, currentExp, "", "");
            return;
        }
        // canShowSoftLaunchPopup = true;
        softLaunchPopup.show(true);
    };

    this.playNow = function (params) {
        popupLayer.closeWithDefault();
        var trackAndroidMap = {}, trackIosMap = {};
        trackAndroidMap[4] = "cnglv7h";
        trackAndroidMap[8] = "zc3zz6";
        trackAndroidMap[10] = "jgrqiq";
        trackAndroidMap[11] = "w0rvv7";
        trackAndroidMap[12] = "ogum16";
        trackAndroidMap[16] = "1smbcq4";

        trackIosMap[4] = "lfzm5rr";
        trackIosMap[8] = "zc3zz6";
        trackIosMap[10] = "jgrqiq";
        trackIosMap[11] = "w0rvv7";
        trackIosMap[12] = "ogum16";
        trackAndroidMap[16] = "1smbcq4";
        var link, installedAlready = 0;
        var campaignName = "soft_launch_" + constantsObj.GAME_ID;
        var screenName = constantsObj.SCREEN_SOFT_LAUNCH;
        //loggerObj.debugLog("this is gameLink ", params["gameLink"]);
        softLaunchObj.softLaunchGameIncrement(true);
        var redirectExp = epmObj.getChosenVariant(xpromoConstantsObj.EXP_REDIRECT_TO_APP_STORE);
        if (utilObj.isWeb()) {
            xpromoUtilObj.openPlayStoreUrl(params["appId"]);
        } else if (utilObj.isAndroid()) {
            if (xpromoUtilObj.isAppInstalled(params["appId"])) {
                installedAlready = 1;
                utilObj.launchAnotherApp(params["appId"]);
            }
            // link = questsObj.getGameShareLink(params["gameLink"], screenName, campaignName);
            // utilObj.openStore(null, link, screenName);
            else if (redirectExp == constantsObj.EXP_VAR_CONTROL) {
                link = questsObj.getGameShareLink(params["gameLink"], screenName, campaignName);
                utilObj.openStore(null, link, screenName);
            } else {
                //xpromoUtilObj.hitUrl(trackAndroidMap[params["gameId"]], campaignName);
                utilObj.openUrl("market://details?id=" + params["appId"]);
            }
        } else if (utilObj.isIos()) {
            if (xpromoUtilObj.isAppInstalled(params["fbId"])) {
                installedAlready = 1;
                utilObj.launchAnotherApp(params["fbId"]);
            } else if (redirectExp == constantsObj.EXP_VAR_CONTROL) {
                link = questsObj.getGameShareLink(params["gameLink"], screenName, campaignName);
                utilObj.openStore(null, link, screenName);
            } else if (redirectExp == constantsObj.EXP_VAR_1) {
                //xpromoUtilObj.hitUrl(trackIosMap[params["gameId"]], campaignName);
                utilObj.openUrl("itms-apps://itunes.apple.com/app/id" + params["appId"]);
            } else if (redirectExp == constantsObj.EXP_VAR_2) {
                //xpromoUtilObj.hitUrl(trackIosMap[params["gameId"]], campaignName);
                link = questsObj.getGameShareLink(params["gameLink"], screenName, campaignName);
                utilObj.openStore(params["appId"], link, screenName);
            }

            // xpromoUtilObj.hitUrl(trackIosMap[params["gameId"]], campaignName);
            // link = questsObj.getGameShareLink(params["gameLink"], screenName, campaignName);
            // utilObj.openStore(params["appId"], link, screenName);

            // if (epmObj.getChosenVariant(xpromoConstantsObj.EXP_REDIRECT_TO_APP_STORE) == constantsObj.EXP_VAR_CONTROL) {
            //     xpromoUtilObj.hitUrl(moreGamesLayer.trackAndroidMap[game_id], campaignName);
            // }
        }
        trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, xpromoConstantsObj.TRACK_SOFT_LAUNCH, params["gameId"], xpromoConstantsObj.TRACK_SOFT_LAUNCH, constantsObj.TRACK_CLICK, currentExp, redirectExp, installedAlready, "");
    };

    this.close = function () {
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.downloadGivenImage = function (imageLink, imageName) {
        if (!utilObj.fileExists(imageName)) {
            xPromoGameSpecificObj.downloadFileV1(imageLink, imageName);
            //loggerObj.debugLog("this is game Icon Name w ");
            return false;
        }
        return true;
    };

    this.downloadSprites = function (spriteLink, spriteName, spritePng) {
        var isReqdCreativeDownloaded = true;
        if (!utilObj.fileExists(spriteName)) {
            xPromoGameSpecificObj.downloadFileV1(spriteLink + spriteName, spriteName);
            //loggerObj.debugLog("this is game Icon Name w ");
            isReqdCreativeDownloaded = isReqdCreativeDownloaded && false;
        }
        if (!utilObj.fileExists(spritePng)) {
            xPromoGameSpecificObj.downloadFileV1(spriteLink + spritePng, spritePng);
            //loggerObj.debugLog("this is game Icon Name w ");
            isReqdCreativeDownloaded = isReqdCreativeDownloaded && false;
        }
        return isReqdCreativeDownloaded;
    };

    this.getSoftLaunchImageUrl = function (gameIconName, exp, isGif) {
        if (!utilObj.isWeb()) {
            return utilObj.getAbsFilePath(gameIconName);
        }
        var baseUrl = constantsObj.MISC_SERVER_STATIC_BASE + "/quests/images/soft_launch/";
        if (isGif == 1) {
            return "";
        } else {
            if (exp == constantsObj.EXP_VAR_5 || exp == constantsObj.EXP_VAR_8) {
                return baseUrl + "/interstitial_1/" + gameIconName;
            } else if (exp == constantsObj.EXP_VAR_6) {
                return baseUrl + "/interstitial_2/" + gameIconName;
            } else if (exp == constantsObj.EXP_VAR_7) {
                return baseUrl + "/banner/" + gameIconName;
            }
        }
    };

};