XpromoQuestRuntimes = function () {
    var oldQuestRuntimes = {};
    var questRuntimes = {};
    var lastRuntimeResetTimestamp = 0;
    // define default runtimes as strings
    var defaultRuntimes = {
        "qdsr": "0",
        "qsrm": "10",
        "qsdbs": "0",
        "qsvc": "3",
        "qscc": "1",
        "qsda": "20",
        "qsp": "2",
        "qsaw": "48",
        "qstg": "3",
        "qsiq": "0",
        "qsnv": "2",
        "dadq": "14",
        "qsiqn": "0",

        // quest center hour window
        "qshw": "180",
        // quest center daily cap
        "qsdc": "1",
        // nth view new variable
        "qsnvn": "2",

        // cross game daily quest runtimes
        // show install quest, should install quest be shown for cgdq

        "dqsiq": "0",
        "dqcr": "3",
        "gpdr": "300",
        "sfdq": "0",
        "stdq": "24",
        "sbd": "0",
        // loop back toaster runtime
        "lbtr": "0",

        // quest adjust tracking impression, if 0 then dont fire adjust impression tracking, if 1 fire adjust impression tracking
        "qati": "0",
        // TODO: change the default value before releasing
        // minimum version of daily quest for android
        "mdqa": "230",

        // minimum version of daily quest for ios
        "mdqi": "216",

        "cgqc": "0",
        "cgqda": "2",
        "cgqpa": "5",


        //for more watch 2 earn videos
        "werv": "25",
        "wexv": "2",  //after shown

        // psuedo social quest runtimes
        "psr": ["7", "0"],

        // adwall runtimes
        "awr": "2",

        // quest Rotation runtimes // 68-2-1:89-8-2:69-4-2:91-4-2
        "qr": {68: ["8", "2", "2", "1"], 89: ["8", "2", "2", "1"], 69: ["8", "2", "2", "1"], 91: ["8", "2", "2", "1"]},

        // streak quests runtimes
        "dqr": {"leaderboard": ["event", "1", "74", "1", "75", "1", "76", "1", "77", "1", "78", "1", "79", "1", "94", "1", "95", "1", "96", "1"]},

        // adwall new runtimes
        "adnip": "0",
        "adnfc": "1",
        "adnr1": "16^14^10^11^9^8^12^4",
        "adnr2": "9^11^8^14^10^4^12^16",
        "adnr3": "10^11^9^8^14^16^4^12",
        "adnci": {"dd": ["2"], "pc": ["1"], "id": ["30"], "cg": ["100"]},

        "adjtk": "4|cnglv7h|lfzm5rr|rhxf1tp^8|zc3zz6|zc3zz6|tb6r1tj^9|d3goyp|d3goyp|nj9qq52^10|jgrqiq|jgrqiq|tb6r1tj^11|w0rvv7|w0rvv7|niafy3w^12|ogum16|ogum16|^14|qfjq2r9|qfjq2r9|nj9qq52^16|1smbcq4|1smbcq4|nj9qq52^15|e3vvep1|e3vvep1|niafy3w",
        "psgid": "9|in.playsimple.wordtrip|fb1778394085519552|Word Trip^4|in.playsimple.word_up|fb464253443751244|Word Trek^10|com.littleengine.wordpal|com.littleengine.wordpal|Word Wars^8|in.crossy.daily_crossword|fb687283344767625|Daily Themed Crossword^11|in.playsimple.tripcross|fb465855800479707|Crossword Jam^12|in.playsimple.guessup_emoji|fb713505802062808|Guess Up^14|in.WordSearch.WordBliss|fb330712434287441|Word Bliss^16|in.cardgame.solitaire|fb1026714047510541|Solitaire^15|in.crossword.wordplanet|fb2769738636476965|Word Planet",
        "adbdl": {"bundles":["in.playsimple.wordtrip", "in.playsimple.tripcross", "in.crossy.daily_crossword", "in.WordSearch.WordBliss", "in.cardgame.solitaire", "com.littleengine.wordpal", "in.crossword.wordplanet"]},
        "adgid": {"gameids":["9", "11", "8", "14", "16", "10", "15"]},
        "iogid": {"gameids":["9", "11"]},

        "qmpt": "2.5", // Quest Mini Pop Time - Time for which the minipop is displayed before animating back
        "dqpp": "0.95",
        "dqvp": "0.95",
        "dqpf": "0",
        "pfsd": ["3", "3"],
        "pfsv": ["4", "4"],
        "svc": ["0", "0"],
        "pvc": ["0", "0"],
        "dxud": "4",
    };

    var runtimesToResetOnlyOnDayChange = [xpromoConstantsObj.RUNTIME_DAILY_QUEST_SWITCH_RUNTIMES, xpromoConstantsObj.RUNTIME_DAILY_QUEST_COMPLETED, xpromoConstantsObj.RUNTIME_DAILY_QUEST_GAME_PLAYED_DAY, xpromoConstantsObj.RUNTIME_DAILY_QUEST_DAYS_AFTER_SHOWN, xpromoConstantsObj.RUNTIME_DAILY_QUEST_SURFACING_BTW_DAYS, xpromoConstantsObj.RUNTIME_SHOW_INSTALL_QUEST, xpromoConstantsObj.RUNTIME_LOOP_BACK_TOASTER];

    this.init = function () {

    };

    this.load = function (questData) {
        questRuntimes = questData.questRuntimes;
        lastRuntimeResetTimestamp = questData.lastRuntimeResetTimestamp;
        oldQuestRuntimes = questData.oldQuestRuntimes;
        if (questRuntimes == undefined) {
            questRuntimes = {};
        }

        if (lastRuntimeResetTimestamp == undefined) {
            lastRuntimeResetTimestamp = 0;
        }

        if (oldQuestRuntimes == undefined) {
            oldQuestRuntimes = questRuntimes;
        }

        for (var r in questRuntimes) {
            questRuntimes[r] = getObjectForRuntime(questRuntimes[r]);
        }
        xpromoUtilObj.updateXpromoConstantsFromRuntime();
    };

    this.save = function (quests) {
        quests.questRuntimes = questRuntimes;
        quests.lastRuntimeResetTimestamp = lastRuntimeResetTimestamp;
        quests.oldQuestRuntimes = oldQuestRuntimes;
        return quests;
    };

    this.storeRuntimes = function (runtimes) {
        runtimes = JSON.parse(runtimes);
        questsObj.setLastRuntimeUpdate(runtimes.l);
        var runtimeData = runtimes.r.split(";");
        questRuntimes = {};
        var runtimesMap = {};
        for (var i = 0; i < runtimeData.length; i++) {
            var keyValuePair = runtimeData[i].split(",");
            if (keyValuePair[0].indexOf("$") != -1) {
                var key = keyValuePair[0].split("$");
                if (parseInt(key[0]) == constantsObj.GAME_ID) {
                    runtimesMap[key[1]] = keyValuePair[1];
                }
            } else {
                runtimesMap[keyValuePair[0]] = keyValuePair[1];
            }
        }
        for (var key in runtimesMap){
            var keyToUse = key;
            var isIosKey = checkIosKey(key);
            if(utilObj.isIos()) {
                if(!isIosKey && runtimesMap[key+"_i"] != undefined) {
                    // In iOS, and the corresponding key has an ios specific key in the map, ignore it
                    continue;
                }
                if(isIosKey) {
                    // In iOS and come across and _i key, lets update the key
                    keyToUse = key.substring(0, key.length - 2);
                }
            } else if(isIosKey) {
                // Not in iOS and come across an iOS key, ignore it
                continue;
            }
            questRuntimes[keyToUse] = getObjectForRuntime(runtimesMap[key]);
        }
        if (lastRuntimeResetTimestamp == 0) {
            lastRuntimeResetTimestamp = utilObj.getCurrentTimestamp();
            oldQuestRuntimes = questRuntimes;
        }
        xpromoUtilObj.updateXpromoConstantsFromRuntime();
        questsObj.save();
    };

    this.handleFetchRuntimes = function (curTimestamp, data, success) {
        questsObj.setLastRuntimeFetch(curTimestamp);
        if (success == false || data.runtime == "" || data.runtime == undefined) {
            return;
        }
        this.storeRuntimes(data.runtime);
    };
    this.getRuntime = function (runtimeName, runtimePos) {
        if(pspnFlutterObj.isFlutterEnabled()) {
            var flutterRuntime = pspnFlutterObj.getRuntime(runtimeName, runtimePos);
            if(flutterRuntime == null) {
                if (defaultRuntimes[runtimeName] != undefined && runtimePos != undefined) {
                    return defaultRuntimes[runtimeName][runtimePos];
                }
                return defaultRuntimes[runtimeName];
            }
            return flutterRuntime;
        }

        var isOldRuntimeRequired = false, curTimestamp = utilObj.getCurrentTimestamp();
        for (var i=0; i<runtimesToResetOnlyOnDayChange.length; i++) {
            if (runtimeName == runtimesToResetOnlyOnDayChange[i]) {
                isOldRuntimeRequired = true;
                break;
            }
        }
        if (isOldRuntimeRequired == true) {
            if (xpromoUtilObj.getDaysDiffBetweenTimestamps(lastRuntimeResetTimestamp, curTimestamp) > 0) {
                oldQuestRuntimes = questRuntimes;
                lastRuntimeResetTimestamp = curTimestamp;
            }
            if (oldQuestRuntimes[runtimeName] != undefined) {
                if (runtimePos == undefined || runtimePos == null) {
                    return oldQuestRuntimes[runtimeName];
                }
                return oldQuestRuntimes[runtimeName][runtimePos];
            }
        }
        if (questRuntimes[runtimeName] != undefined) {
            if (runtimePos == undefined || runtimePos == null) {
                return questRuntimes[runtimeName];
            }
            return questRuntimes[runtimeName][runtimePos];
        } else {
            if (defaultRuntimes[runtimeName] != undefined && runtimePos != undefined) {
                return defaultRuntimes[runtimeName][runtimePos];
            }
            return defaultRuntimes[runtimeName];
        }
    };

    function getObjectForRuntime(data) {
        if (!utilObj.isString(data) || (data.indexOf(":") == -1 && data.indexOf("-") == -1)) {
            return data;
        }
        var dataArr = data.split(":");
        var object;
        if (data.indexOf("-") != -1) {
            object = {};
            for (var i = 0; i < dataArr.length; i++) {
                var str = dataArr[i].split("-");
                object[str[0]] = [];
                for (var j = 1; j < str.length; j++) {
                    object[str[0]].push(str[j]);
                }
            }
        } else {
            object = [];
            for (var i = 0; i < dataArr.length; i++) {
                object.push(dataArr[i]);
            }
        }
        return object;
    }

    function checkIosKey(key) {
        var pos = key.lastIndexOf("_i");
        return pos != -1 && (pos == (key.length - 2));
    }
};