XpromoW2E = function () {
    var priorityArr = [];
    var cb = null;
    var noOfGamesToBeShown = 3; //xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_QUEST_SURFACING_TOP_GAMES);
    var currentQuestData = null;
    var screen = constantsObj.SCREEN_XPROMO_W2E;
    var videosWatchedForXpromoSurfacing = 0;
    var videosWatchedForXpromoMoreVideos = 0;
    var videosWatchedForXpromoPopupInDay = 0; // Unused - can be removed with a later release
    var moreVideosShown = false; // Unused - can be removed with a later release
    var lastCoinsAdded = 0; // Unused - can be removed with a later release
    var multipliedLastCoinsAdded = 0;
    var xpromoGameId = constantsObj.NOT_FOUND;
    var xpromoW2eFriendInstalled = null;
    var xpromoW2eFriendClicked = null;
    var xpromoW2eFriendSessionData = null;
    var coinRewardOverride = constantsObj.NOT_FOUND;
    var rewardValueSaved = 0;
    var screenOnVideoStarted = "";
    var dauDaysSinceXpromoW2ePopupViewed = 0;
    var videosWatchedSinceXpromoW2ePopupViewed = 0;


    this.load = function (quests) {
        if (quests == null || quests == "" || quests == undefined) {
            return false;
        }
        videosWatchedForXpromoSurfacing = quests.videosWatchedForXpromoSurfacing;
        videosWatchedForXpromoMoreVideos = quests.videosWatchedForXpromoMoreVideos;
        videosWatchedForXpromoPopupInDay = quests.videosWatchedForXpromoPopupInDay;
        moreVideosShown = quests.moreVideosShown;
        lastCoinsAdded = quests.lastCoinsAdded;
        multipliedLastCoinsAdded = quests.multipliedLastCoinsAdded;
        xpromoGameId = quests.xpromoGameId;
        xpromoW2eFriendClicked = quests.xpromoW2eFriendClicked;
        xpromoW2eFriendInstalled = quests.xpromoW2eFriendInstalled;
        dauDaysSinceXpromoW2ePopupViewed = quests.dauDaysSinceXpromoW2ePopupViewed;
        videosWatchedSinceXpromoW2ePopupViewed = quests.videosWatchedSinceXpromoW2ePopupViewed;

        if (videosWatchedForXpromoSurfacing == undefined) {
            videosWatchedForXpromoSurfacing = 0;
        }

        if(videosWatchedForXpromoMoreVideos == undefined) {
            videosWatchedForXpromoMoreVideos = 0;
        }

        if (videosWatchedForXpromoPopupInDay == undefined) {
            videosWatchedForXpromoPopupInDay = 0;
        }

        if (lastCoinsAdded == undefined) {
            lastCoinsAdded = 0;
        }

        if (multipliedLastCoinsAdded == undefined) {
            multipliedLastCoinsAdded = 0;
        }

        if(xpromoGameId == undefined) {
            xpromoGameId = constantsObj.NOT_FOUND;
        }

        if(dauDaysSinceXpromoW2ePopupViewed == undefined) {
            dauDaysSinceXpromoW2ePopupViewed = 0;
        }

        if(videosWatchedSinceXpromoW2ePopupViewed == undefined) {
            videosWatchedSinceXpromoW2ePopupViewed = 0;
        }
    };

    this.save = function (quests) {
        if (quests == null || quests == "" || quests == undefined) {
            return false;
        }
        quests.videosWatchedForXpromoSurfacing = videosWatchedForXpromoSurfacing;
        quests.videosWatchedForXpromoMoreVideos = videosWatchedForXpromoMoreVideos;
        quests.videosWatchedForXpromoPopupInDay = videosWatchedForXpromoPopupInDay;
        quests.moreVideosShown = moreVideosShown;
        quests.lastCoinsAdded = lastCoinsAdded;
        quests.multipliedLastCoinsAdded = multipliedLastCoinsAdded;
        quests.xpromoGameId = xpromoGameId;
        quests.dauDaysSinceXpromoW2ePopupViewed = dauDaysSinceXpromoW2ePopupViewed;
        quests.videosWatchedSinceXpromoW2ePopupViewed = videosWatchedSinceXpromoW2ePopupViewed;

        return quests;
    };

    this.close = function () {
        trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, "", "", xpromoConstantsObj.TRACK_W2E_QUEST, constantsObj.TRACK_CLOSE, "", "", "", "");
        xpromoW2eObj.executeCallbackOnClose();
    };

    this.executeCallbackOnClose = function() {
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.setCallbackOnClose = function(func) {
        if(func != undefined) {
            cb = func;
        }
    };

    /**
     * Handler method for xpromo when the video ad show is called
     * @param isContinueWatch - boolean true if it is from the continue watch popup. False otherwise
     */
    this.handleVideoStart = function (isContinueWatch) {
        if(isContinueWatch == undefined || isContinueWatch == false) {
            if(typeof xpromoW2eObj !== "undefined") {
                // This will reset the continue reward value
                xpromoW2eObj.resetSavedRewardValue();
            }
        }
        screenOnVideoStarted = curScreen;
    };

    /**
     * Method to increment the game priority for the next game to surfaced in the xpromo w2e
     */
    this.incrementGamePriority = function () {
        if(priorityArr.length > 0) {
            questsObj.setXpromoW2eGameCounter((1 + questsObj.getXpromoW2eGameCounter()) % priorityArr.length);
            questsObj.setXpromoW2ePopupClicks(0);
            questsObj.setXpromoW2ePopupViews(0);
        }
    };

    /**
     * Method to reset parameters for the current game post installation
     */
    this.resetPriorityPostInstall = function(questPriority) {
        // Increment game priority had happened before we installed the last game, hence we would end up skipping
        // the next possible game to install. To fix this, we need to decrement game priority by 1.
        if(questsObj.getXpromoW2eGameCounter() > 0 && (parseInt(questPriority) != -1)) {
            xpromoW2eObj.calculateAdwallPriority();
            var previousCounter = questsObj.getXpromoW2eGameCounter() - 1;
            if(priorityArr.length > previousCounter && parseInt(questPriority) < parseInt(priorityArr[previousCounter])) {
                questsObj.setXpromoW2eGameCounter(previousCounter);
            }
        }
    };

    /**
     * Handler method when a xpromo popup is interacted with - this initiates the required quests and redirects to store
     */
    this.earnNow = function () {
        var curTimestamp = utilObj.getCurrentTimestamp();

        // Check if the cooldown of the game is met, if so, increment the game priority
        if (questsObj.getShouldIncrementOnClick() == 1) {
            var clicks = 1 + questsObj.getXpromoW2ePopupClicks();
            questsObj.setXpromoW2ePopupClicks(clicks);
            if (clicks >= parseInt(xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_QUEST_SURFACING_CLICK_COOLDOWN))) {
                xpromoW2eObj.incrementGamePriority();
            }
            questsObj.setShouldIncrementOnClick(0);
        }

        // Initializaing variables for tracking and redirection
        var campaignName, screenName, redirectionParams, trackId;
        campaignName = xpromoConstantsObj.TRACK_W2E_QUEST;
        screenName = utilObj.getScreenName(screen);
        trackId = campaignName + "_" + epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_XPROMO_W2E);
        redirectionParams = xpromoUtilObj.generateRedirectionParams(currentQuestData);

        // Updating the xpromo reward value
        var rewardValue = xpromoW2eObj.getNonOverriddenRewardValue() * xpromoW2eObj.getInstallQuestMultiplier();
        xpromoW2eObj.setMultipliedLastCoinsAdded(rewardValue);

        // Important to do this after setMultipliedLastCoinsAdded call as it resets this data.
        xpromoW2eObj.setFriendClicked(currentQuestData.gh);

        // Updating the quest to started state and saving the game id interacted with
        questsObj.setXpromoW2eQuestActive(currentQuestData.id);
        questsObj.makeRelatedQuestsStatusStarted(currentQuestData.id);
        questsObj.setXpromoSurfacingButtonLastClicked(curTimestamp);
        xpromoW2eObj.setXpromoGameId(currentQuestData.gh);
        xpromoUtilObj.markXpromoStartedFromOtherSource(currentQuestData.gh, xpromoConstantsObj.TRACK_W2E_QUEST);

        trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, currentQuestData.id, currentQuestData.gh, xpromoConstantsObj.TRACK_W2E_QUEST, constantsObj.TRACK_CLICK, xpromoW2eObj.getVideosWatchedForXpromoSurfacing(), trackId, "", "");
        questsObj.redirectToStoreWithTracking(campaignName, screenName, redirectionParams, trackId);
        pspnUserTracking.trackUserSnapshot(constantsObj.SCREEN_XPROMO_W2E, constantsObj.TRACK_CLICK);
    };


    /**
     * Generic method to handle data updates and tracking when a xpromo popup is shown
     * @param layerForAnimation - layer which is currently visible
     */
    this.updateXpromoPopupShown = function(layerForAnimation) {
        // Updating data fields
        xpromoW2eObj.setVideosWatchedForXpromoSurfacing(0);
        questsObj.setXpromoLastSurfacedTimestamp(utilObj.getCurrentTimestamp());
        questsObj.setXpromoPopupSeenInDay(questsObj.getXpromoPopupSeenInDay() + 1);
        questsObj.setShouldIncrementOnClick(1);

        // Incase the reward value is overridden - lets reset it
        xpromoW2eObj.setRewardValueOverride(constantsObj.NOT_FOUND);

        // tracking for view
        var videosWatched = xpromoW2eObj.getVideosWatchedForXpromoSurfacing();
        var w2eExp = epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_XPROMO_W2E);
        var xpromoW2eExpNew = epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_XPROMO_W2E_NEW);
        var creativeId = xpromoConstantsObj.TRACK_W2E_QUEST + "_" + w2eExp + "_" + xpromoW2eExpNew;
        trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, currentQuestData.id, currentQuestData.gh, xpromoConstantsObj.TRACK_W2E_QUEST, constantsObj.TRACK_VIEW, videosWatched, creativeId, "", "");

        // adjust tracker
        var gameHosted = currentQuestData.gh;
        var trackMap = xpromoUtilObj.getAdjustTrackerForGameId(gameHosted);
        utilObj.delayedCallback(layerForAnimation, xpromoUtilObj.hitAdjustViewTrackingAfterDelay, 0.1, {trackId: trackMap, src:  xpromoConstantsObj.TRACK_W2E_QUEST, creative: creativeId, adgroup: undefined}, false);


        var views = 1 + questsObj.getXpromoW2ePopupViews();
        questsObj.setXpromoW2ePopupViews(views);

        xpromoW2eObj.setDauDaysSinceXpromoSurfacing(0);
        xpromoW2eObj.setVideosWatchedSinceXpromoSurfacing(0);

        // moving it to the end otherwise it can create problem to game displayed logic
        if (views >= parseInt(xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_QUEST_SURFACING_VIEW_COOLDOWN))) {
            xpromoW2eObj.incrementGamePriority();
        }

        if(xPromoGameSpecificObj.isUserInteractionTrackingEnabled()) {
            machineLearningDataObj.incUserOpenedXpromoW2e();
        }
        pspnUserTracking.trackUserSnapshot(constantsObj.SCREEN_XPROMO_W2E, constantsObj.TRACK_VIEW);
    };

    /**
     * Wrapper method to evaluate if the w2e popup should be shown and initiate the popup flows
     * @returns {boolean} - true / false if a popup is being shown or not
     */
    this.showW2EPopup = function() {
        // Increment the videos watched count, irrespective of the experiment
        xpromoW2eObj.incrementVideosWatched(true);

        var xpromoAfterW2eGrantExp = epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_XPROMO_W2E);
        if(xpromoAfterW2eGrantExp != constantsObj.EXP_VAR_CONTROL) {
            var screenStartedValid = (xPromoGameSpecificObj.isScreenForW2eXpromo(screenOnVideoStarted) || xPromoGameSpecificObj.checkScreenIsW2E(screenOnVideoStarted));
            var updatingToScreenValid = (xPromoGameSpecificObj.isScreenForW2eXpromo(updatingToScreen) || xPromoGameSpecificObj.checkScreenIsW2E(updatingToScreen)) && xPromoGameSpecificObj.customW2EConditions();
            if(screenStartedValid && !updatingToScreenValid && xpromoAfterW2eGrantExp == constantsObj.EXP_VAR_2) {
                //TODO - Fix the undefined constant
                trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, screenOnVideoStarted.toString(), updatingToScreen.toString(), xpromoConstantsObj.TRACK_W2E_QUEST, constantsObj.TRACK_FAILED, "", "", "", "");
                return false;
            }

            if (updatingToScreenValid) {
                return xpromoW2eObj.checkPopupToShow();
            }
        }
        return false;
    };

    /**
     * Method to open a popup based on the experiment value set.
     * NOTE: This method should not be called directly and should be called throught showW2EPopup wrapper method
     * @returns {boolean} - true / false if a popup is being shown or not.
     */
    this.checkPopupToShow = function () {
        var result = false;
        if(pspnFlutterObj.isFlutterEnabled() && !pspnFlutterObj.isW2eFeatureDataLoaded()) {
            return result;
        }

        var layerForAnimation = xPromoGameSpecificObj.getLayerForCoinGrantAnimation(updatingToScreen);
        var xpromoAfterW2eGrantExp = epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_XPROMO_W2E);

        if (xpromoAfterW2eGrantExp == constantsObj.EXP_VAR_1) {
            result = w2eCoinGrantPopup.show(xPromoGameSpecificObj.popupShowWithAnim(), layerForAnimation);
        } else if (xpromoAfterW2eGrantExp == constantsObj.EXP_VAR_2 || xpromoAfterW2eGrantExp == constantsObj.EXP_VAR_3) {
            result = xpromoW2eObj.tryShowXpromoW2ePopup(layerForAnimation);
        }
        return result;
    };

    /**
     * Method to show the xpromo popup given all the laid out conditions and runtimes are passing
     * @param layerForAnimation - layer which is currently visible
     * @returns {boolean} true / false if a popup is being shown or not
     */
    this.tryShowXpromoW2ePopup = function (layerForAnimation) {
        var curTimestamp = utilObj.getCurrentTimestamp();
        var payerStatusRuntime = parseInt(xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_QUEST_SURFACING_PAYER));
        var shouldShowW2Earn = false;
        var isPayer = xPromoGameSpecificObj.getIsPayer();
        var dForUser = xPromoGameSpecificObj.getDForUser();
        var questSurfacingDaysAfter = xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_QUEST_SURFACING_DAYS_AFTER);
        var lastXPromoSurfacedTimestamp = questsObj.getXpromoLastSurfacedTimestamp();
        var questSurfacingHourWindow = xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_QUEST_SURFACING_HOUR_WINDOWN);
        var xPromoPopupSeenInDay = questsObj.getXpromoPopupSeenInDay();
        var questSurfacingDailyCap = xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_QUEST_SURFACING_DAILY_CAP);
        var videosWatchedForQuestSurfacing = xpromoW2eObj.getVideosWatchedForXpromoSurfacing();
        var questSurfacingNView = xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_QUEST_SURFACING_N_VIEW_NEW);

        // Use variant specific runtime if its variant 3.
        if(epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_XPROMO_W2E) == constantsObj.EXP_VAR_3) {
            questSurfacingDaysAfter = xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_QUEST_SURFACING_DAYS_AFTER_V3);
            questSurfacingDailyCap = xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_QUEST_SURFACING_DAILY_CAP_V3);
            questSurfacingNView = xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_QUEST_SURFACING_N_VIEW_NEW_V3);
        }

        var conditionPopupSurfacingOpt = false;
        if(xpromoW2eObj.isInW2eSurfacingOpt()) {
            var optIndex = xpromoW2eObj.getW2eSurfacingOptIndex();
            if(optIndex != constantsObj.NOT_FOUND) {
                conditionPopupSurfacingOpt = xpromoW2eObj.getDauDaysSinceXpromoSurfacing() >= parseInt(xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_QUEST_SURFACING_POPUP_FORCED_DAYS, optIndex));
                conditionPopupSurfacingOpt = conditionPopupSurfacingOpt && (xpromoW2eObj.getVideosWatchedSinceXpromoSurfacing() >= parseInt(xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_QUEST_SURFACING_POPUP_FORCED_VIDEOS, optIndex)));
            }
        }

        if (payerStatusRuntime == 2) {
            // Show xPromo Popup
        } else if (payerStatusRuntime == 0) {
            if (isPayer) {
                shouldShowW2Earn = true;
            }
        } else if (payerStatusRuntime == 1) {
            if (!isPayer) {
                shouldShowW2Earn = true;
            }
        }

        if (dForUser < questSurfacingDaysAfter || (curTimestamp - lastXPromoSurfacedTimestamp) / 60 < questSurfacingHourWindow
            || xPromoPopupSeenInDay >= questSurfacingDailyCap || (videosWatchedForQuestSurfacing < questSurfacingNView && !conditionPopupSurfacingOpt)) {
            shouldShowW2Earn = true;
        }

        if (shouldShowW2Earn) {
            return xpromoW2eObj.tryShowW2eGrantPopup(xPromoGameSpecificObj.popupShowWithAnim(), layerForAnimation);
        }

        xpromoW2eObj.calculateAdwallPriority();
        if (priorityArr.length <= 0) {
            return xpromoW2eObj.tryShowW2eGrantPopup(xPromoGameSpecificObj.popupShowWithAnim(), layerForAnimation);
        }

        var xpromoW2eExpNew = epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_XPROMO_W2E_NEW);
        if(xPromoGameSpecificObj.isW2eXpromoSocialEnabled() && (xpromoW2eExpNew == constantsObj.EXP_VAR_1 || xpromoW2eExpNew == constantsObj.EXP_VAR_2)) {
            var areCreativesReady = true;
            var adwallQuests = questsObj.getAdWallQuests();
            for(var index in priorityArr) {
                var gameData = adwallQuests[priorityArr[index]];
                var gameId = gameData.gh;
                var gameCreative = "w2e_xpromo_" + gameId + ".jpg";
                var adWallCreatives = adWallObj.getImagesForGameId(gameId);
                if(adWallCreatives.w2e_thumb != undefined) {
                    gameCreative = adWallCreatives.w2e_thumb;
                }

                var gameCreativeLink = xpromoUtilObj.getImageLinkFromName(gameCreative);
                if (!utilObj.fileExists(gameCreative)) {
                    xPromoGameSpecificObj.downloadFileV2(gameCreativeLink, gameCreative);
                    areCreativesReady = false;
                }
            }

            adWallObj.areFriendImagesDownloaded();

            if(areCreativesReady) {
                return xpromoW2eSocial.show(xPromoGameSpecificObj.popupShowWithAnim(), layerForAnimation);
            }
        }
        return xpromoAfterW2e.show(xPromoGameSpecificObj.popupShowWithAnim(), layerForAnimation);
    };

    this.calculateAdwallPriority = function() {
        noOfGamesToBeShown = xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_QUEST_SURFACING_TOP_GAMES);
        var currentCount = 0;
        var adwallQuests = questsObj.getAdWallQuests();
        priorityArr = [];
        utilObj.resetIsAppInstalledMap();
        for (var i in adwallQuests) {
            // Pushing eligible games only to the priority array
            if(xpromoUtilObj.isGameEligibleForXpromo(adwallQuests[i].gh, adwallQuests[i].id)) {
                priorityArr.push(i);
            }
            currentCount++;
            if (currentCount >= noOfGamesToBeShown) {
                break;
            }
        }
    };

    /**
     * Method to handle coin grant popup show if xpromo w2e popup is not eligible
     * @param showAnim - true / false
     * @param layerForAnimation - layer which is currently visible
     * @returns {boolean} true / false if a popup is being shown or not
     */
    this.tryShowW2eGrantPopup = function (showAnim, layerForAnimation) {
        if (xpromoW2eObj.checkInstallQuestPayerStatus()) {
            return w2eCoinGrantPopup.show(showAnim, layerForAnimation);
        }

        var text = "Congratulations! %N% coins have been added";
        var rewardValue = xpromoW2eObj.getRewardValue();
        xpromoW2eObj.setRewardValueOverride(constantsObj.NOT_FOUND);

        text = text.replace("%N%", rewardValue);
        utilObj.showMessage(text);

        xPromoGameSpecificObj.canW2eCoinGrant(0, 0, rewardValue, false, layerForAnimation);
        return true;
    };

    /**
     * Method to get the reward value to be awarded to the player on video watch
     */
    this.getRewardValue = function () {
        // Check if the reward value is overwritten - currently done by Bubble Pop
        var overrideReward = xpromoW2eObj.getRewardValueOverride();
        if(overrideReward != constantsObj.NOT_FOUND) {
            return overrideReward;
        }

        return xpromoW2eObj.getNonOverriddenRewardValue();
    };

    /**
     * Method to get the reward value to be awarded to the player on video watch without accounting for override
     * @returns {number} - reward value
     */
    this.getNonOverriddenRewardValue = function () {
        // Check if the promised reward value is a valid number, else return the default game value
        if (rewardValueSaved == 0 || isNaN(rewardValueSaved)) {
            return xPromoGameSpecificObj.getW2EReward();
        }
        return rewardValueSaved;
    };

    /**
     * Method to check if more videos option should be displayed on coin popup
     * @returns {boolean} - true / false
     */
    this.checkToShowMoreVideos = function () {
        var xpromoAfterW2eGrantExp = epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_XPROMO_W2E);
        if (xpromoAfterW2eGrantExp != constantsObj.EXP_VAR_2 && xpromoAfterW2eGrantExp != constantsObj.EXP_VAR_3) {
            return false;
        }

        var videosWatched = xpromoW2eObj.getVideosWatchedForXpromoMoreVideos();
        return videosWatched > xpromoQuestRuntimesObj.getRuntime("wexv") && xpromoW2eObj.checkInstallQuestPayerStatus() && !xPromoGameSpecificObj.getW2ELimitReached();
    };

    /**
     * Method to check if payer runtime conditions are met
     * @returns {boolean} - true / false
     */
    this.checkInstallQuestPayerStatus = function () {
        var runtimeVal = parseInt(xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_QUEST_SURFACING_INSTALL_QUEST_NEW));
        var payerCheck = xPromoGameSpecificObj.getIsPayer();
        return (runtimeVal == 0 || (payerCheck && runtimeVal == 1) || (!payerCheck && runtimeVal == 2));
    };

    /**
     * Method to get the runtime value of the more videos reward value
     * @returns {Number}
     */
    this.getMoreVideosRewardVal = function () {
        var val = parseInt(xpromoQuestRuntimesObj.getRuntime("werv"));
        if (isNaN(val)) {
            return xPromoGameSpecificObj.getW2EReward();
        }
        return val;
    };

    /**
     * Method to get the reward multiplier value for the xpromo install reward
     * @returns {number}
     */
    this.getInstallQuestMultiplier = function () {
        var val = parseInt(xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_QUEST_SURFACING_REWARD_MULTIPLE));
        if(epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_XPROMO_W2E) == constantsObj.EXP_VAR_3) {
            val = parseInt(xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_QUEST_SURFACING_REWARD_MULTIPLE_V3));
        }

        if(isNaN(val)) {
            return 10; // Default value of the multiplier
        }
        return Math.max(val, 1);
    };

    this.saveRewardValue = function (value) {
        rewardValueSaved = value;
    };

    this.resetSavedRewardValue = function () {
        rewardValueSaved = 0;
    };

    this.getPriorityArr = function () {
        return priorityArr;
    };

    this.getCurrentQuestData = function () {
        return currentQuestData;
    };

    this.setCurrentQuestData = function (data) {
        currentQuestData = data;
    };

    this.getMoreVideosShown = function () {
        return moreVideosShown;
    };

    this.setMoreVideosShown = function (val) {
        moreVideosShown = val;
    };

    this.setLastCoinsAdded = function(val) {
        lastCoinsAdded = val;
    };

    this.getLastCoinsAdded = function() {
        return lastCoinsAdded;
    };

    this.setMultipliedLastCoinsAdded = function(val) {
        multipliedLastCoinsAdded = val;
        xpromoW2eFriendClicked = null;
    };

    this.getMultipliedLastCoinsAdded = function() {
        return multipliedLastCoinsAdded;
    };

    this.setXpromoGameId = function(id) {
        xpromoGameId = id;
    };

    this.getXpromoGameId = function() {
        return xpromoGameId;
    };

    this.getVideosWatchedForXpromoSurfacing = function () {
        return videosWatchedForXpromoSurfacing;
    };

    this.getVideosWatchedForXpromoMoreVideos = function () {
        return videosWatchedForXpromoMoreVideos;
    };

    this.getVideosWatchedSinceXpromoSurfacing = function () {
        return videosWatchedSinceXpromoW2ePopupViewed;
    };

    this.getDauDaysSinceXpromoSurfacing = function() {
        return dauDaysSinceXpromoW2ePopupViewed;
    };

    this.setVideosWatchedForXpromoSurfacing = function (val) {
        videosWatchedForXpromoSurfacing = val;
    };

    this.setVideosWatchedForXpromoMoreVideos = function (val) {
        videosWatchedForXpromoMoreVideos = val;
    };

    this.setVideosWatchedSinceXpromoSurfacing = function (val) {
        videosWatchedSinceXpromoW2ePopupViewed = val;
    };

    this.setDauDaysSinceXpromoSurfacing = function(val) {
        dauDaysSinceXpromoW2ePopupViewed = val;
    };

    this.setRewardValueOverride = function (val) {
        coinRewardOverride = val;
    };

    this.getRewardValueOverride = function () {
        return coinRewardOverride;
    };

    /**
     * Method to reset the video views / counts flag on day change
     */
    this.resetVariables = function () {
        videosWatchedForXpromoMoreVideos = 0;
        videosWatchedForXpromoSurfacing = 0;
        xpromoW2eObj.setMoreVideosShown(false);
    };

    this.updateDailyData = function() {
        xpromoW2eObj.setDauDaysSinceXpromoSurfacing(xpromoW2eObj.getDauDaysSinceXpromoSurfacing() + 1);
    };

    /**
     * Method to increment the number of videos watched. Handles days switch over as well
     */
    this.incrementVideosWatched = function (progressQuests) {
        // Check if the day is being tracked is correct, else reset the day's count back to zero.
        if (questsObj.getLastDayOfUser() != xPromoGameSpecificObj.getDForUser()) {
            questsObj.setXpromoPopupSeenInDay(0);
            videosWatchedForXpromoSurfacing = 0;
            videosWatchedForXpromoMoreVideos = 0;
            questsObj.setLastDayOfUser(xPromoGameSpecificObj.getDForUser());
        }

        // Lets go and increment the counts now
        xpromoW2eObj.setVideosWatchedForXpromoSurfacing(xpromoW2eObj.getVideosWatchedForXpromoSurfacing() + 1);
        xpromoW2eObj.setVideosWatchedForXpromoMoreVideos(xpromoW2eObj.getVideosWatchedForXpromoMoreVideos() + 1);
        xpromoW2eObj.setVideosWatchedSinceXpromoSurfacing(xpromoW2eObj.getVideosWatchedSinceXpromoSurfacing() + 1);
        if(progressQuests) {
            questsObj.incActionForQuestType(constantsObj.QUEST_TYPE_WATCH_VIDEOS);
        }
    };

    this.isInW2ESocialVariant = function() {
        if(xPromoGameSpecificObj.isW2eXpromoSocialEnabled()) {
            return epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_XPROMO_W2E_NEW) == constantsObj.EXP_VAR_2;
        }
        return false;
    };

    this.isInW2eSurfacingOpt = function() {
        if(xPromoGameSpecificObj.isW2eSurfacingOptEnabled()) {
            var variant = epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_XPROMO_W2E_OPT);
            return variant == constantsObj.EXP_VAR_1 || variant == constantsObj.EXP_VAR_2;
        }
        return false;
    };

    this.getW2eSurfacingOptIndex = function() {
        if(xpromoW2eObj.isInW2eSurfacingOpt()) {
            var variant = epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_XPROMO_W2E_OPT);
            if(variant == constantsObj.EXP_VAR_1) {
                return 0;
            } else if (variant == constantsObj.EXP_VAR_2) {
                return 1;
            }
        }
        return constantsObj.NOT_FOUND;
    };

    this.checkAndIncrementOtherVideo = function(source) {
        if(xpromoW2eObj.isInW2eSurfacingOpt()) {
            var index = xpromoW2eObj.getW2eSurfacingOptIndex();
            if(index != constantsObj.NOT_FOUND) {
                if(parseInt(xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_QUEST_SURFACING_SPIN_VIDEO, index)) == 1) {
                    xpromoW2eObj.incrementVideosWatched(false);
                }
            }
        }
    };

    this.checkAndIncrementPowerupVideo = function() {
        if(xpromoW2eObj.isInW2eSurfacingOpt()) {
            var index = xpromoW2eObj.getW2eSurfacingOptIndex();
            if(index != constantsObj.NOT_FOUND) {
                if(parseInt(xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_QUEST_SURFACING_POWERUP_VIDEO, index)) == 1) {
                    xpromoW2eObj.incrementVideosWatched(false);
                }
            }
        }
    };

    this.updateSessionFriendShown = function(friendData) {
        xpromoW2eFriendSessionData = xpromoUtilObj.shallowCopy(friendData);
    };

    this.setFriendClicked = function (gameId) {
        if(xpromoW2eFriendSessionData != null) {
            adWallObj.setFriendClickedData(xpromoW2eFriendSessionData, gameId, false);
        }
    };

    this.isW2eXpromoGifsActive = function() {
        return (xPromoGameSpecificObj.isW2eXpromoGifsEnabled() && epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_XPROMO_W2E_GIF) == constantsObj.EXP_VAR_1);
    };

    this.getDownloadedGifFiles = function (creative) {
        var result = [];

        if(creative == undefined || !xpromoW2eObj.isW2eXpromoGifsActive() || creative.indexOf("w2e_xpromo_gif_") != 0) {
            return result;
        }

        var isReqdCreativeDownloaded = true;
        var nameParts = creative.split(".");
        var spritePng = creative;
        var spriteList = nameParts[0] + ".plist";

        var spritePngPath = xpromoUtilObj.getImageLinkFromName(spritePng);
        var spriteListPath = xpromoUtilObj.getImageLinkFromName(spriteList);

        if (!utilObj.fileExists(spritePng)) {
            xPromoGameSpecificObj.downloadFileV2(spritePngPath, spritePng);
            isReqdCreativeDownloaded = isReqdCreativeDownloaded && false;
        }

        if (!utilObj.fileExists(spriteList)) {
            xPromoGameSpecificObj.downloadFileV2(spriteListPath, spriteList);
            isReqdCreativeDownloaded = isReqdCreativeDownloaded && false;
        }

        if(isReqdCreativeDownloaded) {
            result = [
                spritePng, spriteList
            ];
        }
        return result;
    }


};