XPromoBubblePopUi = function () {

    var popupNode = null;
    var showWithAnim = true;
    var cb = null;
    var screen = constantsObj.SCREEN_BUBBLE_POP;
    var parentScreen = null;
    var bubble = null;

    this.show = function(withAnim, params) {
        if ((popupLayer.popupOpen && gameObj.getIsPrivatePolicyOpen() == true) || ftueObj.isFtueVisible()) {
            return;
        }
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        popupLayer.checkAndShow(bubblePopUiObj.delayedShow, params);
    };

    this.delayedShow = function (sender, params) {
        xPromoGameSpecificObj.setCurScreen(screen);
        questsObj.setShouldIncrementOnClick(1);
        var labelArr = [];
        var spriteArr = [];
        var popupHeight = 1700;
        var popupWidth = popupLayer.getWidthForPopup(screen, false);
        var popupObj = 'bubblePopUiObj';
        var center = xPromoGameSpecificObj.getCenterPosW2ePopup(popupWidth, popupHeight);
        var screenName = utilObj.getScreenName(screen);
        var zOrder = constantsObj.UI_Z_ORDER;
        popupNode = new cc.Node();
        var yOffsetForCoinHeader = xPromoGameSpecificObj.xPromoW2eYOffsetForCoinHeader();
        var adwallQuests = questsObj.getAdWallQuests();
        var questToShowData = null;
        for (var quest in adwallQuests) {
            if (adwallQuests[quest].gh != constantsObj.GAME_ID && params.gameId == adwallQuests[quest].gh) {
                questToShowData = adwallQuests[quest];
                break;
            }
        }

        if(questToShowData == null) {
            return;
        }

        var creativesMap = xpromoUtilObj.getKeyValuePairForCreatives(questToShowData.creatives);
        var gameIcon = creativesMap.bubblePop_creative;
        var baseUrl = constantsObj.MISC_SERVER_STATIC_BASE + "/quests/images/bubblePop/creatives/";

        var scale = 1.5;
        utilObj.getSprite(utilObj.getAbsFilePath(gameIcon), center.x, center.y - 200, 0.5, 0, scale, spriteArr,
            popupNode, zOrder, constantsObj.SPRITE_LOCAL);

        var banner = utilObj.getSprite(xpromoConstantsObj.bubble_popup_ribbon, center.x, center.y + 700, 0.5, 0.5, constantsObj.SCALE_SPRITE_7, spriteArr, popupNode, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
        banner.setColor(xpromoConstantsObj.COLOR_RED_RIBBON);
        var oneTimeLbl = utilObj.getBMFontLabel(xpromoStringsObj.one_time_offer, constantsObj.FONT_SFCOMPACT_REGULAR_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), center.x, center.y + 700 , 0.5, 0.5, labelArr, popupNode, zOrder);
        var text = xpromoStringsObj.install_and_win;

        var rewardToGrant;
        if(params.isBubblePopV2 == undefined || params.isBubblePopV2 == false) {
            rewardToGrant = bubblePopObj.getSpecialRewardToGrant();
        } else {
            rewardToGrant = bubblePopNewObj.getSpecialRewardToGrant();
        }

        var coinReward = (rewardToGrant.hasOwnProperty("coins")) ? rewardToGrant["coins"] : 0;
        text = text.replace("%N%", coinReward);

        utilObj.getBMFontLabel(text, constantsObj.FONT_SFCOMPACT_REGULAR_90, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), center.x, center.y - 300, 0.5, 1, labelArr, popupNode, zOrder);

        var coinIcon = questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_ICON_COINS_4);
        utilObj.getSprite(coinIcon, center.x + 220, center.y - 350, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, popupNode, zOrder, questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_SPRITE_MISC));

        var btn = questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_BUTTON_180_LOCAL);
        var texture = questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_BTN_180_TEXTURE_LOCAL);
        var playNowbuttonUI = utilObj.getScale9Sprite(btn, center.x, center.y - 500, 0.5, 1.0, 550, 200, spriteArr, popupNode, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
        utilObj.setColor(playNowbuttonUI, constantsObj.COLOR_BUTTON_LIGHT_GREEN);
        var playNowButton = utilObj.getButton(popupWidth, 1300, 0.5, 0.5, center.x, center.y - 200,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: popupObj,
                fn: 'playNowBtn',
                screen: screen,
                params: {"sound": constantsObj.button_tap_01, "sound_on": false, "questData": questToShowData, "gameId": params.gameId, "bubbleName": params.bubbleName, "isBubblePopV2": params.isBubblePopV2},
                track: {
                    k: xpromoConstantsObj.TRACK_XPROMO,
                    p: questToShowData.id + "",
                    c: params.bubbleName,
                    o: xpromoConstantsObj.TRACK_BUBBLE_POP,
                    f: constantsObj.TRACK_CLICK,
                    g: "xpromo_popup",
                    s: "",
                    co: "",
                    oppId: ""
                },
                child: [],
                feedBackType: constantsObj.NORMALBTN_FEEDBACK
            }, false, texture, 1);
        popupNode.addChild(playNowButton, zOrder);
        animationObj.pulseButton(playNowbuttonUI, 0, 0);
        utilObj.getBMFontLabel(xpromoStringsObj.play_now, constantsObj.FONT_SFCOMPACT_MEDIUM_90, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 280, 100, 0.5, 0.5, labelArr, playNowbuttonUI, zOrder);


        popupLayer.popupSetup(screen, false, bubblePopUiObj.closeXpromoPopup, {questId: questToShowData.id, bubbleName: params.bubbleName}, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });

        xPromoGameSpecificObj.popupShow(popupHeight, screen, "", popupNode, spriteArr, labelArr, true, constantsObj.COLOR_WHITE, undefined, undefined, undefined, undefined, undefined, undefined, undefined, yOffsetForCoinHeader);

        var trackMap = xpromoUtilObj.getAdjustTrackerForGameId(params.gameId);
        utilObj.delayedCallback(popupLayer, xpromoUtilObj.hitAdjustViewTrackingAfterDelay, 0.1, {trackId: trackMap, src:  "xpromo_bubble_pop", creative: gameIcon, adgroup: undefined}, false);
        // Tracking for view of the popup
        trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, questToShowData.id + "", params.bubbleName,
            xpromoConstantsObj.TRACK_BUBBLE_POP, constantsObj.TRACK_VIEW, "xpromo_popup", "", "", "");

    };

    /**
     * clicking on play now button on xpromo bubble pop function, calls this function.
     * @param sender - layer on which function is called
     * @param params - it contains additional parameters such as quest data and gameid of the game being displayed
     */
    this.playNowBtn = function (sender, params) {
        var questData = params.questData;
        var questId = questData.id;
        var campaignName, screenName, redirectionParams, trackId;
        campaignName = xpromoConstantsObj.TRACK_BUBBLE_POP;
        screenName = utilObj.getScreenName(screen);
        var bubblePopExpVar = epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_BUBBLE_POP);
        trackId = campaignName + "_" + bubblePopExpVar;
        redirectionParams = xpromoUtilObj.generateRedirectionParams(questData);

        if(params.isBubblePopV2 == undefined || params.isBubblePopV2 == false) {
            bubblePopObj.markXpromoInteraction(params.gameId, questId, params.bubbleName);
        } else {
            bubblePopNewObj.markXpromoInteraction(params.gameId, questId, params.bubbleName);
        }

        if (questsObj.getShouldIncrementOnClick() == 1) {
            questsObj.setShouldIncrementOnClick(0);
        }
        questsObj.redirectToStoreWithTracking(campaignName, screenName, redirectionParams, trackId);
    };

    /**
     * Callback method for handling any custom actions on closing the xpromo popup
     * @param params - it contains additional parameters such as quest id and bubble name that triggered this
     */
    this.closeXpromoPopup = function (params) {
        trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, params.questId + "", params.bubbleName,
            xpromoConstantsObj.TRACK_BUBBLE_POP, constantsObj.TRACK_CLOSE, "xpromo_popup", "", "", "");
    };


    /**
     * this function handles all the functionalities related to bubble UI and animation
     * @param bubbleType - tells what type of bubble should be displayed
     * @param coinsToGrant - number of coins to grant
     */
    this.showBubble = function (bubbleType, coinsToGrant) {
        xpromoAnimationObj.setBubblePopAnimRunning(true);
        var layerForBubblePop = utilObj.getLayerForScreen(curScreen);
        var spriteArr = [];
        var labelArr = [];
        var upperLimitY = constantsObj.DESIGN_HEIGHT - 450, lowerLimitY = constantsObj.DESIGN_HEIGHT - 850;
        var randNumber = Math.random() - 0.5;
        var midPoint = (upperLimitY + lowerLimitY) / 2;

        var initialPosY = midPoint + randNumber * 400;
        bubblePopUiObj.bubble = utilObj.getSprite(xpromoConstantsObj.xpromoBubble, -150, initialPosY, 0.5, 0.5, 1.2, spriteArr, layerForBubblePop, constantsObj.FTUE_Z_ORDER + 1, constantsObj.SPRITE_QUESTS);

        // creating bubble inside content
        var giftBoxIcon = xpromoConstantsObj.bubblePopSmallGift;
        if (bubbleType == xpromoConstantsObj.BUBBLE_POP_VIDEO_LOW) {
            giftBoxIcon = xpromoConstantsObj.bubblepop_watch_video;

        } else if (bubbleType == xpromoConstantsObj.BUBBLE_POP_VIDEO_HIGH) {
            giftBoxIcon = xpromoConstantsObj.bubblepop_watch_video_high;

            var offer_tag = utilObj.getSprite(xpromoConstantsObj.bubblepop_star_gold, bubblePopUiObj.bubble.getContentSize().width - 35, bubblePopUiObj.bubble.getContentSize().height - 30, 0.5, 0.5, 1.0, spriteArr, bubblePopUiObj.bubble, constantsObj.FTUE_Z_ORDER, constantsObj.SPRITE_QUESTS);
            var label = utilObj.getBMFontLabel("2X", constantsObj.FONT_SFCOMPACT_THIN_50, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), bubblePopUiObj.bubble.getContentSize().width - 35, bubblePopUiObj.bubble.getContentSize().height - 30, 0.5, 0.5, labelArr, bubblePopUiObj.bubble, constantsObj.FTUE_Z_ORDER + 2);
            label.setScale(0.45);

        } else if (bubbleType == xpromoConstantsObj.BUBBLE_POP_XPROMO_LOW || bubbleType == xpromoConstantsObj.BUBBLE_POP_XPROMO_HIGH) {

            var labelText = "10X";
            if(bubbleType == xpromoConstantsObj.BUBBLE_POP_XPROMO_LOW) {
                giftBoxIcon = xpromoConstantsObj.bubblepop_giftbox_xpromo;
            } else {
                labelText = "20X";
                giftBoxIcon = xpromoConstantsObj.bubblepop_giftbox_xpromo_high;
            }

            var arrow = utilObj.getSprite(xpromoConstantsObj.bubblepop_arrow, bubblePopUiObj.bubble.getContentSize().width / 2 + 20, bubblePopUiObj.bubble.getContentSize().height - 60, 0.5, 0.5, 0.7, spriteArr, bubblePopUiObj.bubble, constantsObj.FTUE_Z_ORDER, constantsObj.SPRITE_QUESTS);
            var offer_tag = utilObj.getSprite(xpromoConstantsObj.bubblepop_star_gold, bubblePopUiObj.bubble.getContentSize().width - 35, bubblePopUiObj.bubble.getContentSize().height - 30, 0.5, 0.5, 1.0, spriteArr, bubblePopUiObj.bubble, constantsObj.FTUE_Z_ORDER, constantsObj.SPRITE_QUESTS);
            var label = utilObj.getBMFontLabel(labelText, constantsObj.FONT_SFCOMPACT_THIN_50, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), bubblePopUiObj.bubble.getContentSize().width - 35, bubblePopUiObj.bubble.getContentSize().height - 30, 0.5, 0.5, labelArr, bubblePopUiObj.bubble, constantsObj.FTUE_Z_ORDER + 2);
            label.setScale(0.45);
            xpromoAnimationObj.moveNodeUpAndDown(arrow);
        }
        var giftBox = utilObj.getSprite(giftBoxIcon, bubblePopUiObj.bubble.getContentSize().width / 2, bubblePopUiObj.bubble.getContentSize().height / 2, 0.5, 0.5, 1.0, spriteArr, bubblePopUiObj.bubble, constantsObj.FTUE_Z_ORDER, constantsObj.SPRITE_QUESTS);

        // adding effects for bubble inside contents
        if (bubbleType != xpromoConstantsObj.BUBBLE_POP_XPROMO_LOW && bubbleType != xpromoConstantsObj.BUBBLE_POP_XPROMO_HIGH) {
            //giftbox zoom in and out
            xpromoAnimationObj.bubbleZoomInZoomOutAnimation(giftBox);
        }

        var transButton = utilObj.getButton(bubblePopUiObj.bubble.getContentSize().width, bubblePopUiObj.bubble.getContentSize().height, 0.5, 0.5,
            bubblePopUiObj.bubble.getContentSize().width / 2, bubblePopUiObj.bubble.getContentSize().height / 2, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'bubblePopUiObj',
                fn: 'popBubble',
                screen: curScreen,
                params: {bubbleType: bubbleType, cashToGrant: coinsToGrant, layerForBubblePop: layerForBubblePop},
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        bubblePopUiObj.bubble.addChild(transButton);
        utilObj.addLabels(labelArr);
        utilObj.addSprites(spriteArr);

        bubblePopUiObj.animateBubble(layerForBubblePop, bubbleType, midPoint, randNumber);
    };

    // Once bubble is shown, it gets animated here.
    this.animateBubble = function (layerForBubblePop, bubbleType, midPoint, randNumber) {
        var earlyBurst = Math.ceil(bubblePopObj.getBubbleFloatTime() / 10);
        var timeOneWayTrip = Math.ceil(bubblePopObj.getBubbleFloatTime() / 2);
        var timeTripBack = timeOneWayTrip - 1;
        var totalTime = timeOneWayTrip + timeTripBack;
        var unstableTime = bubblePopObj.getBubbleUnstableTime();

        var bubbleScale = bubblePopUiObj.bubble.getScale();
        var bubbleWidth  = bubblePopUiObj.bubble.getContentSize().width * bubbleScale, bubbleHeight = bubblePopUiObj.bubble.getContentSize().height * 1.2;

        // adding glitter effect on bubble
        var params = {
            zOrder: constantsObj.FTUE_Z_ORDER,
            scale: constantsObj.SCALE_60,
        };
        params.name = constantsObj.EFFECT_GRATIFICATION_FLOWERS;
        params.x = bubbleWidth / 2;
        params.y = bubbleHeight / 2;
        var bubbleEffects = xPromoGameSpecificObj.getBubbleEffects();
        var p = effectsObj.getParticleEffect(bubbleEffects["bubble_giftbox_sfx"], params, 0);
        if (p != undefined && p != null) {
            p.setSpeed(p.getSpeed() * 10.0);
        }
        effectsObj.addEffect(bubblePopUiObj.bubble, p, params.zOrder);

        var xPos = -150;
        var yPos = bubblePopUiObj.bubble.getPosition().y; //constantsObj.DESIGN_HEIGHT  - headerMargin - 2 * centerYPos / 3;//take random between height in place of centerYPos

        var position = {x: xPos, y: yPos};
        var screenPartition = canvasWidth / 6;
        var positionsArr = [position], upwardCurve = randNumber < 0;
        for (var i=0; i<6; i++) {
            var newPosX = (i + 1) * screenPartition - bubbleWidth/2, newPosY = 0, transitionInY = 200 + (Math.random() - 0.5) * 200;
            if (positionsArr[i].y < midPoint) {
                newPosY = positionsArr[i].y + transitionInY;
            } else {
                newPosY = positionsArr[i].y - transitionInY;
            }
            positionsArr.push({x: newPosX, y: newPosY});
        }
        var positionsArrLength = positionsArr.length;

        var moveBubble = animationObj.getCardinalSplineTo(timeOneWayTrip, positionsArr, 0).easing(new cc.easeOut(1));
        bubblePopUiObj.bubble.runAction(moveBubble);

        var positionArr2 = [positionsArr[positionsArrLength - 1]];
        var yDiff = positionsArr[positionsArrLength - 1].y - positionsArr[positionsArrLength - 2].y;
        upwardCurve = false;
        if (yDiff < 0) {
            upwardCurve = true;
        }

        for (var i=0; i<6; i++) {
            var newPosX = (6 - (i + 1)) * screenPartition - bubbleWidth/2, newPosY = 0, transitionInY = 200 + (Math.random() - 0.5) * 200;
            if (upwardCurve) {
                newPosY = positionArr2[i].y - transitionInY;
            } else {
                newPosY = positionArr2[i].y + transitionInY;
            }
            upwardCurve = !upwardCurve;
            positionArr2.push({x: newPosX, y: newPosY});
        }

        var delay = animationObj.getDelayTime(timeOneWayTrip);
        var moveBubble1 = animationObj.getCardinalSplineTo(timeTripBack, positionArr2, 0).easing(new cc.easeIn(1)); //randomDelay-timeOneWayTrip

        // animation on striking with the wall
        var scaleUp1 = animationObj.getScaleTo(0.30, bubbleScale * 0.95);
        var scaleDown1 = animationObj.getScaleTo(0.30, bubbleScale * 1.15);
        var scalings = [];
        for (var i=0; i<2; i++) {
            scalings.push(scaleUp1);
            scalings.push(scaleDown1);
        }
        var seqAction = animationObj.getSequence(scalings);
        var spawnAction = cc.spawn(moveBubble1, seqAction);

        var seqArr = [delay, spawnAction];
        animationObj.runAction(bubblePopUiObj.bubble, animationObj.getSequence(seqArr));

        utilObj.delayedCallback(layerForBubblePop, bubblePopUiObj.destabiliseBubble, (totalTime - unstableTime) - earlyBurst, {}, false); //randomDelay-2
        utilObj.delayedCallback(layerForBubblePop, bubblePopUiObj.autoPopBubble, totalTime - earlyBurst, {}, false); //randomDelay
    };


    // Play the reward animation for the bubble type.
    this.playRewardAnim = function (params) {
        if((xPromoGameSpecificObj.getCash() + params.cashToGrant) <= constantsObj.MAX_CASH_ALLOWED) {
            var bubblePos = bubblePopUiObj.bubble.getPosition();
            xPromoGameSpecificObj.canW2eCoinGrant(bubblePos.x - centerXPos,  bubblePos.y - centerYPos, params.cashToGrant, false,  params.layerForBubblePop);
        }
    };

    /**
     * this function plays animation on clicking and calls other popup backend methods
     * @param params it contains cash to grant value and layer on animation should be played
     */
    this.popBubble = function (params) {
        // plays coin grant animation
        bubblePopUiObj.playRewardAnim(params);

        // execute backend actions on popping bubble
        bubblePopObj.popBubble(params);

        // play bubble effect on touching bubble pop
        bubblePopUiObj.playBubbleOnTouchEffect(params.layerForBubblePop);
        xpromoAnimationObj.setBubblePopAnimRunning(false);
    };

    /**
     * this function is called when bubble pop is clicked. it plays an animation with bubbles floating.
     * @param layerForBubblePop layer on which animation should be played
     */
    this.playBubbleOnTouchEffect = function (layerForBubblePop) {
        var params = {
            zOrder: constantsObj.UI_Z_ORDER + 1000,
            scale: constantsObj.SCALE_ONE,
        };
        params.name = constantsObj.EFFECT_GRATIFICATION_FLOWERS;
        params.x = bubblePopUiObj.bubble.getPosition().x + 75;
        params.y = bubblePopUiObj.bubble.getPosition().y;

        var bubbleEffects = xPromoGameSpecificObj.getBubbleEffects();

        var p = effectsObj.getParticleEffect(bubbleEffects["bubble_blast"], params, 0);
        effectsObj.addEffect(layerForBubblePop, p, params.zOrder);
        params.x = bubblePopUiObj.bubble.getPosition().x + 75;
        params.y = bubblePopUiObj.bubble.getPosition().y;
        p = effectsObj.getParticleEffect(bubbleEffects["bubble_sfx"], params, 0);
        effectsObj.addEffect(layerForBubblePop, p, params.zOrder);
        bubblePopUiObj.bubble.setVisible(false);
    };

    // After the bubble has become unstable and has indicated to the user that it will pop automatically,
    // if the user doesn't pop the bubble, this gets called.
    this.autoPopBubble = function (sender) {
        if (bubblePopObj.isBubbleVisibleOnScreen() == false || !xpromoAnimationObj.getBubblePopAnimRunning() || !xPromoGameSpecificObj.canShowBubblePopAnimationOnLayer()) {
            bubblePopObj.autoPopBubble(); // This needs to run irrespective of the layer, as the lock needs to be released.
            return;
        }

        bubblePopObj.autoPopBubble();
        bubblePopUiObj.playBubbleOnTouchEffect(sender);
    };

    this.bounceBubble = function () {
        // Call this when bubble hits the edge of the screen. Might want to play a sound and change direction here.
    };

    // This gets called when the bubble has been on screen for some time and still not popped.
    this.destabiliseBubble = function () {
        if (bubblePopObj.isBubbleVisibleOnScreen() == false || !xpromoAnimationObj.getBubblePopAnimRunning() || !xPromoGameSpecificObj.canShowBubblePopAnimationOnLayer()) {
            return;
        }
        var s = utilObj.getScale(bubblePopUiObj.bubble);
        var timeFactor = 0.05;
        var scale0 = animationObj.getScaleTo(timeFactor, s * 1.03);
        var scale1 = animationObj.getScaleTo(timeFactor, s * 0.97);
        var scale2 = animationObj.getScaleTo(timeFactor, s);
        //var scale2 = animationObj.getScaleTo(timeFactor, s);
        var actions = [scale0, scale1];
        var seqAction = animationObj.getSequence(actions);
        var seqRepeat = new cc.RepeatForever(seqAction);
        animationObj.runAction(bubblePopUiObj.bubble, seqRepeat);

    };
};