XpromoDtcSpecific = function () {
    this.init = function () {

    };

    this.diffMoreGamesUi = function (spriteArr, labelArr, zOrder, layerToAdd, sectionHeight) {
        var crossIcon = utilObj.getSprite(constantsObj.headerCross, 45, sectionHeight / 2, 0, 0.5, constantsObj.SCALE_SPRITE_14, spriteArr, layerToAdd, zOrder, constantsObj.SPRITE_LOCAL);
        var fromCreators = utilObj.getBMFontLabel(xpromoStringsObj.from_the_creators, constantsObj.FONT_ROBOTO_MEDIUM_60, constantsObj.COLOR_NEW_BLUE, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, sectionHeight - 65, 0.5, 1, labelArr, layerToAdd, zOrder);
        var gameLabel = utilObj.getBMFontLabel(stringsObj.DTC_full_form, constantsObj.FONT_ROBOTO_MEDIUM_70, constantsObj.COLOR_WHITE, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, sectionHeight - 160, 0.5, 1, labelArr, layerToAdd, zOrder);
        var gameIconName = "icon_" + constantsObj.GAME_ID + "_small.png";
        var gameLogo = utilObj.getSprite(xpromoUtilObj.getAbsFilePath(gameIconName), canvasWidth / 2 - 350, sectionHeight / 2, 1, 0.5, constantsObj.SCALE_SPRITE_2, spriteArr, layerToAdd, zOrder, constantsObj.SPRITE_LOCAL);
        return [];
    };

    this.updateQuestCenterTimeLabels = function () {
        var crossGameLabelArr = [];
        // loggerObj.debugLog("this is not working time label ", curScreen, utilObj.getStringifiedJson(achievementsLayer.crossGameTimeQuests), utilObj.getStringifiedJson(homeLayer.crossGameTimeQuests));
        if (curScreen == constantsObj.SCREEN_ACHIEVEMENTS) {
            crossGameLabelArr = achievementsLayer.crossGameTimeQuests;
        } else if (curScreen == constantsObj.SCREEN_HOME) {
            crossGameLabelArr = homeLayer.crossGameTimeQuests;
        } else {
            return;
        }
        if (crossGameLabelArr == undefined) {
            return;
        }
        for (var i = 0; i < crossGameLabelArr.length; i++) {
            var label = crossGameLabelArr[i].lbl;
            var startTime = crossGameLabelArr[i].startTime;
            var timeLimit = crossGameLabelArr[i].timeLimit;
            var timeRem = Math.max(0, parseInt(startTime) + parseInt(timeLimit) - parseInt(utilObj.getCurrentTimestamp()));
            var timeStr = utilObj.formatTime(timeRem);
            utilObj.setString(label, timeStr);
        }
    };

    this.addPopupBg = function (popupHeight, popupNode) {
        var xPos = centerXPos;
        var yPos = centerYPos + popupHeight / 2 - constantsObj.POPUP_START_OFFSET;
        var popupBg = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, xPos, yPos, 0.5, 1, constantsObj.POPUP_WIDTH, popupHeight - constantsObj.POPUP_START_OFFSET, null, popupNode, constantsObj.BG_Z_ORDER, constantsObj.SPRITE_MISC);
        //popupNode.addChild(popupBg);
        utilObj.addChild(popupNode, popupBg);
    };

    this.initialChecksForAdWall = function() {
        if ((utilObj.isIos() && gameObj.getScreenToShow() == true) || utilObj.getIsNotifClicked() == true) {
            gameObj.setScreenToShow(false);
            return false;
        }
        // loggerObj.debugLog("check the notif time124",prevNotifTime,nextNotifTime,(!gameObj.getNotifPermissionForIos()) || (gameObj.getNotifPermissionForIos() && prevNotifTime == nextNotifTime));
        // loggerObj.debugLog("calling adwall1", curScreen, utilObj.getScreenName(curScreen),utilObj.checkAnyNotifTriggered(),gameObj.getLastUnlockedPuzzle(),gameObj.getisTriggeredFromPushNotif());
        if ((utilObj.isAndroid() && utilObj.checkAnyNotifTriggered() && gameObj.getLastUnlockedPuzzle() != null)) {
            return false;
        }
        // loggerObj.debugLog("calling adwall2");
        if (utilObj.isIos()) {
            if (!((!gameObj.getNotifPermissionForIos()) || (gameObj.getNotifPermissionForIos() && gameObj.getPrevNotifTime() == gameObj.getNextNotifTime()))) {
                return false;
            }
        }
        // loggerObj.debugLog("check the notif time125",prevNotifTime,nextNotifTime);
        if (popupLayer.popupOpen) {
            return false;
        }
        return true;
    };

    this.fetchingAchievementDetails = function (ind, listItemsQuest) {
        var index = parseInt(ind);
        var title = "";
        var cta = stringsObj.install;
        var desc = "";
        var heading = "";
        var showTitle = false;
        var progress, limitProgress;
        var questDetails = listItemsQuest[ind - constantsObj.CrossPromoOffset];
        var questId = questDetails.id;
        var gameHosted = questDetails.gh;
        var hasProgressBar = 0;
        var hasTimerBar = 0;
        var timeRemaining = 0;
        var startTime = 0;
        //loggerObj.debugLog("this is quest id params xxx ", questId);
        var questType = listItemsQuest[ind - constantsObj.CrossPromoOffset].qt;
        var newQuests = 0;
        for (var i = 0; i < constantsObj.QUEST_TYPES.length; i++) {
            if (questType == constantsObj.QUEST_TYPES[i]) {
                newQuests = 1;
                break;
            }
        }
        if (newQuests) {
            var description = listItemsQuest[ind - constantsObj.CrossPromoOffset].d;
            description = description.split(" ");
            var questParams = listItemsQuest[ind - constantsObj.CrossPromoOffset].pa.split(":");
            var descLength = description.length;
            title = description[descLength - 2] + " " + description[descLength - 1];
            for (var i = 0; i < descLength - 3; i++) {
                desc += description[i] + " ";
            }
            showTitle = true;
            hasTimerBar = 0;
            var curQuests = questsObj.getCurQuests();
            //loggerObj.debugLog("this is quest id params ", utilObj.getStringifiedJson(curQuests[questId]), curQuests[questId].pa);
            var allParams = curQuests[questId].pa.split(':');
            limitProgress = allParams[3];
            progress = questDetails.curProgress;
            if (progress == undefined) {
                progress = 0;
            }
            progress = parseInt(questDetails.curProgress);
            if (questType == constantsObj.QUEST_TYPE_CROSS_GAME_LEVEL_IN_TIME || questType == constantsObj.QUEST_TYPE_CROSS_GAME_LEVEL_COMPLETE
                || questType == constantsObj.QUEST_TYPE_INSTALL_TIME || questType == constantsObj.QUEST_TYPE_INSTALL_AND) {
                hasProgressBar = 1;
                if (utilObj.isAndroid()) {
                    if (xpromoUtilObj.isAppInstalled(questParams[0])) {
                        cta = stringsObj.play_str;
                    }
                } else if (utilObj.isIos()) {
                    if (xpromoUtilObj.isAppInstalled(questParams[5])) {
                        cta = stringsObj.play_str;
                    }
                }
            }
            if (questType == constantsObj.QUEST_TYPE_CROSS_GAME_LEVEL_IN_TIME || questType == constantsObj.QUEST_TYPE_INSTALL_TIME) {
                hasTimerBar = 1;
                if (questDetails.status == constantsObj.QUEST_COMPLETED) {
                    hasTimerBar = 0;
                }
                if (utilObj.isAndroid()) {
                    if (xpromoUtilObj.isAppInstalled(questParams[0])) {
                        cta = stringsObj.play_str;
                    }
                } else if (utilObj.isIos()) {
                    if (xpromoUtilObj.isAppInstalled(questParams[6])) {
                        cta = stringsObj.play_str;
                    }
                }
                startTime = questDetails.params[1];
                //loggerObj.debugLog("this is start time params ", startTime);
                timeRemaining = questDetails.timeLimit;
            }
        } else {
            title = stringsObj.install_play;
            heading = listItemsQuest[ind - constantsObj.CrossPromoOffset].d;
            heading = heading.substr(heading.indexOf(" ") + 1);
            showTitle = true;
            desc = questDetails.d;


            if (questDetails.isSocialQuest) {
                title = stringsObj.play_with + questDetails.psFriend.name;
                // var questDesc = xpromoGameRuntimeObj.getSocialQuestString();
                // if (xpromoConstantsObj.PSGames[gameHosted] != undefined) {
                //     questDesc = questDesc.replace("%game%", xpromoConstantsObj.PSGames[gameHosted][2]);
                // } else {
                //     questDesc = questDesc.replace("%game%", "");
                // }
                // loggerObj.debugLog("this is social quest desc ", questDesc);
                // desc = questDesc;
            }

            progress = achievementsObj.getProgressForAchievement(index);
        }
        var reward = Math.round(listItemsQuest[ind - constantsObj.CrossPromoOffset].re * questsObj.getDollarValue());
        var state = gameObj.getAchievementsState(index);
        var maxCount = 1;
        var trackingId = "";
        if (ind == constantsObj.CrossPromoAchievement1) {
            if (questDetails.isSocialQuest) {
                trackingId = "social_quest_1";
            } else {
                trackingId = "quest_1";
            }
        } else if (ind == constantsObj.CrossPromoAchievement2) {
            if (questDetails.isSocialQuest) {
                trackingId = "social_quest_2";
            } else {
                trackingId = "quest_2";
            }
        }
        var achievementSection = {
            id: index,
            questId: questId,
            title: title,
            questId: listItemsQuest[ind - constantsObj.CrossPromoOffset].id,
            desc: desc,
            cta: cta,
            reward: reward,
            progress: progress,
            maxCount: limitProgress,
            state: state,
            hasProgressBar: hasProgressBar,
            hasTimerBar: hasTimerBar,
            showTitle: showTitle,
            timeRem: timeRemaining,
            startTime: startTime,
            isCrossGame: 1,
            status: questDetails.status,
            isSocialQuest: questDetails.isSocialQuest,
            psFriend: questDetails.psFriend,
            gh: questDetails.gh,
            trackingId: trackingId,
            bucket: questDetails["b"],
        };
        return achievementSection;
    };

    this.showQuestIcon = function (section, gameIcon, badgeIconToUse, localXPos, localYPos, spriteArr, zOrder, layer, oocScreen) {
        var iconScaling;
        var fromOOCScreen = false;
        if (oocScreen != undefined && oocScreen == true) {
            fromOOCScreen = true;
        }
        var socialQuestImageDownloaded = 0;
        iconScaling = constantsObj.SCALE_ONE * (170 / 206);
        var listitemsQuest = achievementsObj.getListItemsQuest();
        var gameHostedIn = listitemsQuest[section.id - constantsObj.CrossPromoOffset].gh;
        if (gameHostedIn) {
            var pathForGameIcon = utilObj.getFilesDir();
            if (utilObj.isAndroid()) {
                pathForGameIcon += "/";
            }
            var gameIconPath = "icon_" + gameHostedIn + ".png";
            gameIcon = xpromoUtilObj.getAbsFilePath(gameIconPath);
            if (!utilObj.isWeb() && !utilObj.fileExists(gameIconPath)) {
                gameIcon = badgeIconToUse;
                iconScaling = 2.5 * constantsObj.SPRITE_SCALING_FACTOR * (80 / 206);
                utilObj.downloadFileV1(gameIconPath, constantsObj.MISC_SERVER_STATIC_BASE + "quests/images/icons/" + gameIconPath);
            }

            if (section.isSocialQuest == 1) {
                var gameIconName = section.psFriend.fbId + ".jpg";
                if (!utilObj.isWeb() && gameIconName.indexOf("friendly_") == -1 && !utilObj.fileExists(gameIconName)) {
                    xPromoGameSpecificObj.downloadFileV1(friendsObj.getFbPicUrl(section.psFriend.fbId), gameIconName);
                } else {
                    socialQuestImageDownloaded = 1;
                    gameIcon = socialQuestObj.getAbsFilePathForFbPic(section.psFriend.fbId, gameIconName);
                    iconScaling = xpromoUtilObj.getIconScalingForBotAndFbPic(gameIconName);
                }
            }

        }

        var badgeImageXPromo = null;
        if (gameIcon == badgeIconToUse) {
            if (fromOOCScreen) {
                var badgeImage = utilObj.getSprite(gameIcon, localXPos, localYPos, 0, 1, constantsObj.SCALE_SPRITE_9 / 1.5, spriteArr, layer, zOrder);
            } else {
                var badgeImage = utilObj.getSprite(gameIcon, localXPos + 60, localYPos - 160, 0, 0.5, constantsObj.SCALE_SPRITE_9 * 1.5, spriteArr, layer, zOrder);
            }
            badgeImage.setColor(constantsObj.COLOR_BLACK);
            badgeImage.setOpacity(constantsObj.OPACITY_50);
            badgeImageXPromo = badgeImage;
        } else {
            var badgeImage;
            if (fromOOCScreen) {
                badgeImage = utilObj.getSprite(gameIcon, localXPos, localYPos, 0, 1, constantsObj.SCALE_60 * (170 / 206), spriteArr, layer, zOrder);
            } else {
                if (section.isSocialQuest == 1) {
                    badgeImage = utilObj.getSprite(gameIcon, localXPos, localYPos - 160, 0, 0.5, iconScaling, spriteArr, layer, zOrder);
                } else {
                    badgeImage = utilObj.getSprite(gameIcon, localXPos, localYPos - 160, 0, 0.5, iconScaling, spriteArr, layer, zOrder);
                }
            }
            badgeImageXPromo = badgeImage;
            var gameHostedIcon = "icon_" + gameHostedIn + ".png";
            iconScaling = constantsObj.SCALE_ONE;
            if ((utilObj.isWeb() || utilObj.fileExists(gameHostedIcon)) && section.isSocialQuest == 1 && socialQuestImageDownloaded == 1) {
                utilObj.getSprite(xpromoUtilObj.getAbsFilePath(gameHostedIcon), localXPos + 180, localYPos - 135 - 110, 0.5, 0.5, iconScaling * 0.3, spriteArr, layer, zOrder);
            }
        }
        return badgeImageXPromo;
    };

    this.firingAdjustTracking = function (tile, itemWidth, sectionYPos, sectionHeight, spriteArr, zOrder, section, count1) {
        //loggerObj.debugLog("entering here -> ", achievementTitle, section.id);
        var sectionBg = utilObj.getScale9Sprite(tile, itemWidth / 2, sectionYPos - sectionHeight / 2, 0.5, 0.5, itemWidth - 40, sectionHeight, spriteArr, achievementsLayer.scrollView, zOrder, constantsObj.SPRITE_MISC);
        //utilObj.addChild(itemWidget, sectionBgBig, zOrder + 1););
        sectionBg.setColor(constantsObj.COLOR_VIDEO_ACHIEVMENT);
        var questStatus = constantsObj.TRACK_VIEW;
        if (questsObj.getStatusOfQuest(section.questId) == constantsObj.QUEST_COMPLETED) {
            questStatus = constantsObj.TRACK_COMPLETE;
        }
        var trackingId = "", trackId;
        if (section.id == constantsObj.CrossPromoAchievement1 || section.id == constantsObj.CrossPromoAchievement2) {
            if (section.isSocialQuest == 1) {
                section.trackingId = "social_quest_" + count1;
            } else {
                section.trackingId = "quest_" + count1;
            }
            trackingId = section.trackingId;
            trackId = xpromoUtilObj.getAdjustTrackerForGameId(section.gh);
            xpromoUtilObj.hitAdjustViewTracking(trackId, constantsObj.TRACK_QUEST_CENTER, trackingId);
        }
        trackObj.trackCounter(constantsObj.TRACK_XPROMO, gameObj.getCurPuzzleTracking(), gameObj.getTrackingPuzzleTheme(), constantsObj.TRACK_QUEST_CENTER, section.questId, constantsObj.TRACK_VIEW, constantsObj.TRACK_ACHIEVEMENTS, trackingId, "");
        //utilObj.addChild(itemWidget, sectionBg, zOrder + 1);
    };

    this.getW2ELimitReached = function () {
        return gameObj.getNumVideos() >= xpromoDtcObj.getW2EPerHour();
    };

    this.getW2EPerHour = function () {
        var curTimestamp1 = utilObj.getCurrentTimestamp();
        var maxVideosAllowed = 5;
        if (gameObj.getIsPayer()) {
            maxVideosAllowed = runtimeObj.getNumVideosNew(2);
        } else {
            if ((curTimestamp1 - userObj.getCreated()) < 7 * constantsObj.SECONDS_IN_DAY) {
                maxVideosAllowed = runtimeObj.getNumVideosNew(0);
            } else {
                maxVideosAllowed = runtimeObj.getNumVideosNew(1);
            }
        }

        if (gameObj.isEligibleForVideoAchiement() && gameObj.getAchievementsState(43) == constantsObj.ACHIEVEMENT_IN_PROGRESS) {
            maxVideosAllowed = 6;
        }
        return maxVideosAllowed;
    };

    this.getCarouseExperimentVariant = function() {
        return epmObj.getChosenVariant(constantsObj.EXP_HOME_SCREEN_CAROUSEL);
    };

    this.shouldShowAchievementCarousel = function() {
        if(xpromoDtcObj.getCarouseExperimentVariant() != constantsObj.EXP_VAR_CONTROL) {
            var daysEligibility = runtimeObj.getCarouselDaysEligibility();
            return ((daysEligibility > -1 && ((utilObj.getCurrentTimestamp() - userObj.getCreated()) >= daysEligibility * constantsObj.SECONDS_IN_DAY)))  && xpromoDtcObj.shouldShowAchievementCarouselBasedOnHistory();
        }
        return false;
    };

    this.shouldShowAchievementCarouselBasedOnHistory = function(){
        if(xpromoDtcObj.getCarouseExperimentVariant() == xpromoConstantsObj.EXP_VAR_4){
            var relevantHistoryPeriod = runtimeObj.getCarouselRelevantHistoryRequired();
            var requiredDAUDaysInRelevantHistory = runtimeObj.getCarouselDAUDaysInHistoryPeriod();
            return requiredDAUDaysInRelevantHistory <= pspnActionHistory.getDauDaysInCalendarDays(relevantHistoryPeriod);
        }
        return true;
    };

    this.fireAdditionalVariantTracking = function(itemsLen){
      if(xpromoDtcObj.getCarouseExperimentVariant() == xpromoConstantsObj.EXP_VAR_4){
          var relevantHistoryPeriod = runtimeObj.getCarouselRelevantHistoryRequired();
          var requiredDAUDaysInRelevantHistory = runtimeObj.getCarouselDAUDaysInHistoryPeriod();
          var result = xpromoDtcObj.shouldShowAchievementCarousel();
          trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, requiredDAUDaysInRelevantHistory.toString()+"_"+relevantHistoryPeriod.toString() ,"homescreen_carousel",
              result.toString(),itemsLen.toString(),"","","","");
      }
    };

    this.getDefaultUnlockDaysForInstallQuest = function() {
        var variant = epmObj.getChosenVariant(xpromoConstantsObj.EXP_XPROMO_QUEST_UNLOCK);
        if(variant == xpromoConstantsObj.EXP_VAR_1 || variant == xpromoConstantsObj.EXP_VAR_2) {
            var value = parseInt(xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_DTC_XPROMO_UNLOCK_DAYS, variant - 1));
            if(value >= 0) {
                return value;
            }
        }
        return xpromoConstantsObj.DTC_XPROMO_UNLOCK_DAYS_DEFAULT;
    };
};