var ContactBookLayer = cc.Layer.extend({
    screen: null,
    scrollView: null,
    sHeight: 0,
    isButtonClickable: true,
    scrollViewLocalYPos: 0,
    innerContainerYPos: 0,
    transBtn: [],
    sepCounts: [],
    yPos: 2200,
    scrollViewWidth: 0,

    back: function () {
        if (xPromoGameSpecificObj.isFtueVisible() || contactBookLayer.isButtonClickable == false) {
            return;
        }
        contactBookLayer.hide();
        questCenterLayer.show(); //redraw
    },

    hide: function () {
        contactBookLayer.removeAllChildren();
    },


    clickAction: function (sender, params) {
        if (xpromoUtilObj.isAppInstalled(xpromoConstantsObj.WHATSAPP_PACKAGE_ID)) {
            xpromoUtilObj.openWhatsAppWithPhone(sender, params);
        } else {
            xpromoUtilObj.openSmsWithContact(sender, params);
        }
    },

    addingContacts: function (sender, params) {
        var start = params.start;
        var end = params.end;
        var layer = params.layer;
        var zOrder = constantsObj.SPRITE_Z_ORDER;
        var colorArr = [xpromoConstantsObj.COLOR_BLUE_09, xpromoConstantsObj.COLOR_BLUE_10, xpromoConstantsObj.COLOR_BLUE_11, xpromoConstantsObj.COLOR_BLUE_12];
        var spriteArr = [], labelArr = [];
        for (var i = start; i < end; i++) {
            var contactInfo = contactBookLayer.sepCounts[i];
            if (contactInfo[2] == "1") {
                var favIcon = utilObj.getSprite(constantsObj.favIcon, 268, contactBookLayer.yPos + 55, 0.5, 0.5, constantsObj.SCALE_SPRITE_30, spriteArr, layer, zOrder + 2, constantsObj.SPRITE_LOCAL);
                favIcon.setColor(xpromoConstantsObj.COLOR_SCREEN_GLOW_GOLDEN);
            }

            utilObj.getBMFontLabel(contactInfo[1], constantsObj.FONT_SFCOMPACT_MEDIUM_60, colorArr[0],
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 350, contactBookLayer.yPos, 0, 0.5, labelArr, layer, zOrder);
            var contactImg = utilObj.getSprite(questConfigObj.getConfigData("circle"), 140, contactBookLayer.yPos, 0.5, 0.5, xpromoUtilObj.getSpriteScale(0.74),
                spriteArr, layer, zOrder + 2, xpromoConstantsObj.SPRITE_QUESTS);
            contactImg.setColor(colorArr[i % 4]);
            utilObj.getBMFontLabel(contactInfo[1][0].toUpperCase(), constantsObj.FONT_SFCOMPACT_MEDIUM_100, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 140, contactBookLayer.yPos, 0.5, 0.5, labelArr, layer, zOrder + 3);
            contactBookLayer.transBtn[i] = utilObj.getButton(contactBookLayer.scrollViewWidth, 220, 0.5, 0.5, contactBookLayer.scrollViewWidth / 2, contactBookLayer.yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'contactBookLayer',
                fn: 'clickAction',
                screen: contactBookLayer.screen,
                params: {
                    "msg": utilObj.getShareMsg("wa"),
                    "phoneNumber": contactInfo[0],
                },
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: xPromoGameSpecificObj.getPhylumForTracking(),
                    c: xPromoGameSpecificObj.getClassForTracking(),
                    o: xpromoConstantsObj.TRACK_QUEST_CENTER,
                    f: "",
                    g: constantsObj.TRACK_CLICK,
                    s: "",
                    co: 1,
                    oppId: ""
                },
                child: [],
                feedBackType: constantsObj.NORMALBTN_FEEDBACK
            }, false, ccui.Widget.PLIST_TEXTURE, constantsObj.BTN_SCALING);
            layer.addChild(contactBookLayer.transBtn[i], zOrder + 4);
            contactBookLayer.yPos -= 110;
            var separator = utilObj.getScale9Sprite(constantsObj.white_line, centerXPos, contactBookLayer.yPos, 0.5, 0.5, 2 * centerXPos, 4,
                spriteArr, layer, zOrder, questConfigObj.getConfigData("SPRITE_MISC"));
            separator.setColor(constantsObj.COLOR_COUNTRY_SEP1);
            separator.setOpacity(constantsObj.OPACITY_20);
            contactBookLayer.yPos -= 110;
        }
        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);
    },

    show: function () {
        questCenterLayer.setContactBookClicked(false);
        questsObj.incActionForQuestType(xpromoConstantsObj.QUEST_TYPE_INVITE_CONTACT_BOOK);
        var spriteArr = [];
        var labelArr = [];
        contactBookLayer.screen = constantsObj.SCREEN_CONTACT_BOOK;
        var screenName = utilObj.getScreenName(contactBookLayer.screen);
        xPromoGameSpecificObj.setCurScreen(contactBookLayer.screen);

        var bgZOrder = constantsObj.BG_Z_ORDER;
        utilObj.updateScreenBegin(contactBookLayer.screen);
        var allContacts = contactBookObj.getAllContacts();
        var count = 0;
        var countryBgHeight = 120;
        var packsHeight = constantsObj.DESIGN_HEIGHT - countryBgHeight - xpromoConstantsObj.HEADER_HEIGHT_QUEST_CENTER;
        var listMargin = 160;
        var listYPos = packsHeight - listMargin;
        var localYPos = constantsObj.DESIGN_HEIGHT - listMargin;
        contactBookLayer.sepCounts = allContacts.split(";;");
        var totalContacts = contactBookLayer.sepCounts.length;

        var contactBookBg = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, centerYPos, 0.5, 0.5, centerXPos * 2, constantsObj.DESIGN_HEIGHT + xpromoConstantsObj.HEADER_HEIGHT_QUEST_CENTER, spriteArr, contactBookLayer, bgZOrder, questConfigObj.getConfigData("SPRITE_MISC"));
        contactBookBg.setColor(xpromoConstantsObj.COLOR_SUPPORT_BG);
        var headerBg = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, 2 * centerYPos, 0.5, 1, 2 * centerXPos, constantsObj.HEADER_NEW_HEIGHT + constantsObj.BEZEL_SAFE_AREA, spriteArr,
            contactBookLayer, bgZOrder + 1, questConfigObj.getConfigData("SPRITE_MISC"));
        headerBg.setColor(xpromoConstantsObj.COLOR_BLUE_TICK);
        utilObj.getBMFontLabel("CONTACTS", constantsObj.FONT_SFCOMPACT_MEDIUM_90, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, localYPos + 70, 0.5, 0.5, labelArr, contactBookLayer, bgZOrder + 1);

        var count = 0;
        var contactArr = [];
        var favArr = [];
        var nonFavArr = [];
        var widthErr = xPromoGameSpecificObj.getWidthErr();
        for (var i = 0; i < totalContacts; i++) {
            contactArr[i] = contactBookLayer.sepCounts[i].split("::");
            if (contactArr[i][2] == "1") {
                favArr.push(contactArr[i]);
            } else {
                nonFavArr.push(contactArr[i]);
            }
        }
        nonFavArr = utilObj.shuffleArray(nonFavArr);
        nonFavArr.splice(Math.min(200, totalContacts));
        contactArr = favArr.concat(nonFavArr);
        totalContacts = contactArr.length;
        contactArr.sort(function (a, b) {
            var strA = a[1];
            var strB = b[1];
            if (strA[0] >= 'a' && strA[0] <= 'z') {
                strA = strA.toUpperCase();
            }
            if (strB[0] >= 'a' && strB[0] <= 'z') {
                strB = strB.toUpperCase();
            }
            return strA > strB;
        });
        contactArr.sort(function (a, b) {
            var strA = a;
            var strB = b;
            return strA[2] < strB[2];
        });
        contactBookLayer.sepCounts = [];
        for (var i = 0; i < totalContacts; i++) {
            var contactInfo = contactArr[i];
            if (contactInfo == undefined || contactInfo == null || contactInfo == "" || (contactBookObj.isAlpha(contactInfo[1][0]) == false && contactInfo[2] == "0")) {
                continue;
            }
            contactBookLayer.sepCounts[count++] = contactInfo;
        }
        count = contactBookLayer.sepCounts.length;
        var scrollViewHeight = count * 220 + 220;
        contactBookLayer.yPos = scrollViewHeight - 70;
        var backImg = utilObj.getSprite(questConfigObj.getConfigData("back"), 120, localYPos + 70, 0.5, 0.5, xpromoUtilObj.getSpriteScale(1.2, xpromoConstantsObj.SPRITE_QUESTS), spriteArr, contactBookLayer, bgZOrder + 4, xpromoConstantsObj.SPRITE_QUESTS);
        var backButton = utilObj.getButton(175, 175, 0.5, 0.5,
            120, localYPos + 70, questConfigObj.getConfigData("circle_button"), questConfigObj.getConfigData("circle_button"), questConfigObj.getConfigData("circle_button"), {
                obj: 'contactBookLayer',
                fn: 'back',
                screen: contactBookLayer.screen,
                params: {"sound": constantsObj.button_tap_01, "sound_on": true},
                msg: "",
                phoneNumber: contactInfo[1],
                track: {
                    k: screenName,
                    p: xpromoConstantsObj.TRACK_COUNTRY,
                    c: xPromoGameSpecificObj.getPhylumForTracking(),
                    o: xPromoGameSpecificObj.getClassForTracking(),
                    f: constantsObj.TRACK_BACK,
                    g: "",
                    s: xPromoGameSpecificObj.getSpeciesForTracking(),
                    co: 1,
                    oppId: ""
                },
                child: [backImg],
                feedBackType: constantsObj.ZOOMIN_FEEDBACK
            }, true, ccui.Widget.PLIST_TEXTURE, xpromoUtilObj.getSpriteScale(0.72));
        contactBookLayer.addChild(backButton, bgZOrder + 2);
        backButton.setColor(constantsObj.COLOR_GREY);
        backImg.setColor(constantsObj.COLOR_WHITE);

        contactBookLayer.scrollViewWidth = canvasWidth + widthErr - 60;
        contactBookLayer.sHeight = scrollViewHeight;

        contactBookLayer.scrollView = new ccui.ScrollView();
        contactBookLayer.scrollView.setDirection(ccui.ScrollView.DIR_VERTICAL);
        contactBookLayer.scrollView.setTouchEnabled(true);
        contactBookLayer.scrollView.setBounceEnabled(false);
        contactBookLayer.scrollView.setScrollBarEnabled(false);
        contactBookLayer.scrollView.setInertiaScrollEnabled(true);
        contactBookLayer.scrollView.setAnchorPoint(cc.p(0.5, 1.0));
        contactBookLayer.scrollView.setPosition(centerXPos, constantsObj.DESIGN_HEIGHT - xpromoConstantsObj.HEADER_HEIGHT_QUEST_CENTER + 60);

        contactBookLayer.scrollView.setContentSize(cc.size(canvasWidth + widthErr, constantsObj.DESIGN_HEIGHT + 50));
        contactBookLayer.scrollView.setInnerContainerSize(cc.size(canvasWidth + widthErr, scrollViewHeight + 50));

        contactBookLayer.addChild(contactBookLayer.scrollView, constantsObj.BG_Z_ORDER + 1);
        var layer = contactBookLayer.scrollView;
        var actualHeight = contactBookLayer.sepCounts.length * 220;
        var contentHeight = constantsObj.DESIGN_HEIGHT - (constantsObj.HEADER_NEW_HEIGHT + constantsObj.BEZEL_SAFE_AREA);

        if (contentHeight > actualHeight) {
            layer = contactBookLayer;
            contactBookLayer.yPos = constantsObj.DESIGN_HEIGHT - (constantsObj.HEADER_NEW_HEIGHT + constantsObj.BEZEL_SAFE_AREA) - 110;
        }

        var counti = 0;
        for (var i = 0; i < count; i += 50) {
            var params = {
                start: i,
                end: Math.min(i + 50, count),
                layer: layer,
            };
            utilObj.delayedCallback(layer, contactBookLayer.addingContacts, counti * 0.5, params, false);
            counti++;
        }
        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);
        utilObj.updateScreen(contactBookLayer.screen, contactBookLayer, null, this.screen);
    },

    showContactBookFromAppResume: function () {
        curLayer.hide();
        contactBookLayer.show();
    },

    showContactBookOnButtonClick: function () {
        if (questCenterLayer.isContactBookClicked()) {
            var pkgPrefix = xpromoUtilObj.getPspnPkgPrefix();
            var success = jsb.reflection.callStaticMethod(pkgPrefix + "XPromoUtil", "CheckForContactsPermission", "()Z");
            if (success) {
                var allContacts = jsb.reflection.callStaticMethod(pkgPrefix + "XPromoUtil", "RequestForContactsPermission", "()Ljava/lang/String;");
                if (allContacts == "0") {
                    allContacts = "";
                }
                contactBookObj.setAllContacts(allContacts);
                questsObj.incActionForQuestType(xpromoConstantsObj.QUEST_TYPE_INVITE_CONTACT_BOOK);
                utilObj.delayedCallback(contactBookLayer, contactBookLayer.showContactBookFromAppResume, 0.5, null, false);
            }
            questCenterLayer.setContactBookClicked(false);
        }
    },


});