// This would be the screen which has all quest center related things
var QuestCenterLayer = cc.Layer.extend({
    screen: null,
    scrollView: null,
    lastCountryIndex: 0,
    nextCountryOpen: false,
    timerLabelParams: null,
    gameIconMap: {},
    centerCoinGrants: [],
    actionButton: [],
    uiReferenceForQuest: [],
    ftueActionBtn: null,
    numAvailableQuests: 0,
    sHeight: 0,
    innerContainerYPos: 0,
    isCoinGrantAnimRunning: false,
    scrollViewLocalYPos: 0,
    dailyQuestsCount: 0,
    dailyQuestTimerParam: null,
    dailyCgQuestTimerParam: null,
    watchToVideoFromQuest: 0,
    ftueShownNum: 0,
    isDailyQuestFtue: false,
    questsCountInBucket: {},
    isPopupOpenedFromQuestCenter: false,
    dailyQuestsLocked: false,
    isbuttonClickable: true,
    contactBookClicked: false,
    totalElementSpacing: 272,
    levelElementHeight: 234,
    listItemsMargin: 38,
    layer: null,
    scrollViewWidth: 0,
    dailyQuestsXShift: 0,
    btnWidth: 340,
    btnHeight: 180,
    bezelXShift: 0,
    bezelShift: 0,
    xAdjustmentMap: {1: 67, 2: 50, 3: 33},
    indexParamsToVisibleTrack: [],
    indexVisibleToParamsTrack: [],
    questIdFromVisibleIndex: [],
    cgdqParams: {},
    paramsMap: {},
    cgdqDailyQuestsCount: 0,


    back: function () {
        if ((ftueObj.shouldFtueBeShown() && questCenterLayer.ftueShownNum == 8) || questCenterLayer.isbuttonClickable == false || questCenterLayer.isCoinGrantAnimRunning == true) {
            return;
        }
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(), xpromoConstantsObj.TRACK_QUEST_CENTER, constantsObj.TRACK_BACK, utilObj.getScreenName(questsObj.getQuestCenterLastScreen()), questsObj.getQuestTrackingInfo(), "1", "");
        trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(), xpromoConstantsObj.TRACK_QUEST_CENTER, constantsObj.TRACK_CLOSE, "", "", "1", "");
        questCenterLayer.hide();
        var lastScreen = questsObj.getQuestCenterLastScreen();

        if (lastScreen == null || lastScreen == undefined) {
            questsObj.setQuestCenterLastScreen(constantsObj.SCREEN_GAME);
        }

        // 1. Handling all screens where QC surfacing is happening from individually.
        if (lastScreen == constantsObj.SCREEN_GAME || (xPromoGameSpecificObj.isDigraphAvailable() && lastScreen == constantsObj.SCREEN_DIGRAPH_GAME)) {
            questCenterLayer.openGameLayer();
        } else if (questConfigObj.isLinearProgressionAvailable() && lastScreen == constantsObj.SCREEN_LINEAR_PROGRESSION) {
            linearProgressionLayer.redraw();
        } else if (xPromoGameSpecificObj.isDigraphAvailable() && lastScreen == constantsObj.SCREEN_DIGRAPH_LINEAR_PROGRESSION) {
            digraphLLPLayer.redraw();
        } else if (xPromoGameSpecificObj.isDailyPuzzleAvailable() && lastScreen == constantsObj.SCREEN_SPELLING_BEE) {
            dailySpellingBeeLayer.redraw();
        } else if (lastLayer != undefined && utilObj.isFunction(lastLayer.redraw)) { // 2. Then looking for last layer and redrawing it
            lastLayer.redraw();
        } else {
            questCenterLayer.openGameLayer(); // 3. If that too not possible, lets open the game layer
        }
    },

    pause: function () {

    },

    resume: function () {

    },

    hide: function () {
        questCenterLayer.removeAllChildren();
    },

    redraw: function () {
        if (popupLayer.popupOpen) {
            popupLayer.close({noAnim: xPromoGameSpecificObj.popupShowWithAnim()});
        }
        questCenterLayer.hide();
        questCenterLayer.show(utilObj.getScreenName(constantsObj.SCREEN_QUEST_CENTER));
        utilObj.delayedCallback(questCenterLayer, questCenterLayer.resetCoinAnimRunning, 0.5, null, false);
    },

    redrawOnResume: function() {
        // The redraw call resets "watchToVideoFromQuest" to zero incorrectly at times
        // TODO - This is a quick fix, revisit this in the future
        if(questCenterLayer.watchToVideoFromQuest == 1) {
            questCenterLayer.redraw();
            questCenterLayer.watchToVideoFromQuest = 1;
        } else {
            questCenterLayer.redraw();
        }
    },

    isContactBookClicked: function () {
        return questCenterLayer.contactBookClicked;
    },

    setContactBookClicked: function (val) {
        questCenterLayer.contactBookClicked = val;
    },

    show: function (src, redirected) {
        questCenterLayer.watchToVideoFromQuest = 0;
        if (crossGameDailyQuestsObj.getCgdqReceiverActive() != null) {
            trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, crossGameDailyQuestsObj.getCurrentCGDQExp(), "", xpromoConstantsObj.TRACK_CGDQ_RECIEVER, xpromoConstantsObj.TRACK_VIEW_QUEST_CENTER, "", "", "", "");
        }
        questsObj.setClaimQuestFtue(false); // This variable is managed as part of game data - hence it will have the right data loaded
        trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(), xpromoConstantsObj.TRACK_QUEST_CENTER, constantsObj.TRACK_VIEW, src, questsObj.getQuestTrackingInfo(), "", "");

        // TODO - Move this to post flutter call
        if (redirected == 1 && epmObj.getChosenVariant(xpromoConstantsObj.EXP_REQUESTS_REDIRECTION) == constantsObj.EXP_VAR_2) {
            var requestRedirectTime = xpromoGameRuntimeObj.getRequestRedirectionTime();
            questCenterLayer.isbuttonClickable = false;
            utilObj.delayedCallback(questCenterLayer, questCenterLayer.redirectToMiniGame, requestRedirectTime, null, false);
            utilObj.delayedCallback(questCenterLayer, questCenterLayer.resetButtonClickable, requestRedirectTime + 1, null, false);
        }
        questsObj.setQuestCenterSeen(true); // This variable is managed as part of game data - hence it will have the right data loaded
        questsObj.setQuestCenterLastOpenedTS(utilObj.getCurrentTimestamp()); // This variable is managed as part of game data - hence it will have the right data loaded

        if(pspnFlutterObj.isFlutterEnabled()) {
            pspnFlutterObj.openQuestCenter();
            return;
        }

        questCenterLayer.isPopupOpenedFromQuestCenter = false;
        questCenterLayer.questsCountInBucket = {};
        questCenterLayer.screen = constantsObj.SCREEN_QUEST_CENTER;
        xPromoGameSpecificObj.setCurScreen(questCenterLayer.screen);
        var screenName = xPromoGameSpecificObj.getScreenName(questCenterLayer.screen);
        var spriteArr = [];
        var labelArr = [];
        var zOrder = constantsObj.SPRITE_Z_ORDER;
        xPromoGameSpecificObj.updateScreenBegin(questCenterLayer.screen);
        questsObj.getAvailableInGameQuests();
        var xPos = xLeftPos;
        var localYPos = constantsObj.DESIGN_HEIGHT;
        questCenterLayer.ftueShownNum = 0; // ftueObj.getFtueShownNum();
        xPromoGameSpecificObj.checkAndIncCompleted();
        adWallObj.setAdWallLastScreen(constantsObj.SCREEN_QUEST_CENTER);
        questsObj.shouldResetDailyQuests();

        questCenterLayer.dailyQuestsLocked = questCenterLayer.checkDailyQuestsLocked();
        if (xPromoGameSpecificObj.shouldFtueBeShown() && questCenterLayer.ftueShownNum == ftueObj.FTUE_QUEST_CLAIM) {
            var transBg = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, 0, 0.5, 0, canvasWidth + widthErr, constantsObj.DESIGN_HEIGHT + constantsObj.BEZEL_SAFE_AREA, spriteArr,
                questCenterLayer, constantsObj.FTUE_Z_ORDER - 1, questConfigObj.getConfigData("SPRITE_MISC"));
            transBg.setColor(constantsObj.COLOR_BLACK);
            transBg.setOpacity(constantsObj.OPACITY_80);
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(), constantsObj.TRACK_FTUE_QC_2, constantsObj.TRACK_VIEW, "", "", "1", "");
        }

        ////////////////////
        // Header area UI
        questCenterLayer.paramsMap = {};
        questCenterLayer.paramsMap["localYPos"] = constantsObj.DESIGN_HEIGHT;
        questCenterLayer.paramsMap["labelArr"] = labelArr;
        questCenterLayer.paramsMap["spriteArr"] = spriteArr;
        questCenterLayer.paramsMap["listZOrder"] = constantsObj.SPRITE_Z_ORDER;
        questCenterLayer.paramsMap["bgZOrder"] = constantsObj.BG_Z_ORDER;
        questCenterLayer.paramsMap["zOrder"] = zOrder;
        questCenterLayer.paramsMap["screenName"] = screenName;
        questCenterLayer.showHeaderArea();
        questCenterLayer.showUserCashAndCoins();
        // Header area end
        ///////////////////////

        var countryBgHeight = 120;
        localYPos -= countryBgHeight;

        var packsHeight = constantsObj.DESIGN_HEIGHT - countryBgHeight - xpromoConstantsObj.HEADER_HEIGHT_QUEST_CENTER;

        var listMargin = 160;
        var listYPos = packsHeight - listMargin;
        var localYPos = constantsObj.DESIGN_HEIGHT - listMargin;
        var scrollViewWidth = canvasWidth + widthErr - 60;
        questCenterLayer.scrollViewWidth = scrollViewWidth;
        var levelElementHeight = questCenterLayer.levelElementHeight;
        var countryElementHeight = 350;
        var countrySpacing = 50;

        var allQuestsCompleted = false;
        var questsNotReady = false;

        var availableGameQuests = questsObj.getSortedQuestList();

        var activeQuests = questsObj.getActiveQuests();
        var completedQuests = questsObj.getCompletedQuests();
        var claimedQuests = questsObj.getClaimedQuests();
        var numOfAvailableGameQuests = 0;
        if (availableGameQuests != undefined) {
            numOfAvailableGameQuests = availableGameQuests.length;
        }
        // config added
        var numAvailableQaConfig = qaConfigObj.getQAConfigData("numberOfQuestsAvailable");
        if (numAvailableQaConfig != "" && numAvailableQaConfig != -1) {
            numOfAvailableGameQuests = Math.min(numAvailableQaConfig, numOfAvailableGameQuests);
        }
        if ((numOfAvailableGameQuests == 0 || questsObj.getDollarValue() == 0)) {
            if (numOfAvailableGameQuests == 0 || claimedQuests == 0 || questsObj.getDollarValue() == 0) {
                questsNotReady = true;
            } else {
                allQuestsCompleted = true;
            }
        }

        if (numOfAvailableGameQuests == 0) {
            allQuestsCompleted = true;
        }
        // TODO: to fix tracking id because of quest replacement at some other position
        if (xPromoGameSpecificObj.shouldFtueBeShown() && questCenterLayer.ftueShownNum == ftueObj.FTUE_QUEST_CLAIM) {
            var tempQuestList = [];
            for (var i = 0; i < numOfAvailableGameQuests; i++) {
                if (availableGameQuests[i].id == questsObj.getQuestCompleteId()) {
                    tempQuestList.push(availableGameQuests[i]);
                    if (tempQuestList.length == 1 && dailyQuestsObj.isDailyQuestOrStreakQuest(availableGameQuests[i].qt)) {
                        questCenterLayer.isDailyQuestFtue = true;
                    }
                }
            }
            for (var i = 0; i < numOfAvailableGameQuests; i++) {
                if (availableGameQuests[i].id != questsObj.getQuestCompleteId()) {
                    tempQuestList.push(availableGameQuests[i]);
                }
            }
            availableGameQuests = tempQuestList;
        }

        questCenterLayer.dailyQuestsCount = 0;
        questCenterLayer.cgdqDailyQuestsCount = 0;
        var listItems = [];
        var expXpromoDq = crossGameDailyQuestsObj.getCurrentCGDQExp();
        var hasSocialQuest = false;


         // questToReplace is the installType Quest that will be replacing the daily Quest
         // It is computed before the loop is entered so that the DQ can be have a replacement ready when it is encountered
        var questToReplace = dailyQuestsObj.getQuestToReplace(availableGameQuests,numOfAvailableGameQuests);
        for (var i = 0; i < numOfAvailableGameQuests; i++) {
            if (availableGameQuests[i] != undefined) {
                if(questToReplace != null) {
                    // Returns true for the install type quest in the list itself
                    if(dailyQuestsObj.shouldQuestBeExcluded(availableGameQuests[i].id, availableGameQuests[i].b)){
                        continue;
                    } else if(availableGameQuests[i].id == dailyQuestsObj.getQuestToBeReplaced()){
                        //Replaces the QuestToBeReplaced (Daily Quest) with the questConfig of the installTypeQuest
                        availableGameQuests[i] = questToReplace;
                        dailyQuestsObj.setQuestReplacedTime();
                    }
                }
                var rowInfo = {
                    "id": availableGameQuests[i].id,
                    "d": availableGameQuests[i].d,
                    "qt": availableGameQuests[i].qt,
                    "reqProgress": availableGameQuests[i].reqProgress,
                    "curProgress": availableGameQuests[i].curProgress,
                    "status": availableGameQuests[i].status,
                    "gh": availableGameQuests[i].gh,
                    "re": availableGameQuests[i].re,
                    "timeLimit": availableGameQuests[i].timeLimit,
                    "params": availableGameQuests[i].params,
                    "crossGame": availableGameQuests[i].cg,
                    "i": i,
                    "shareLink": availableGameQuests[i].shareLink,
                    "pkgName": availableGameQuests[i].pkgName,
                    "bucket": availableGameQuests[i].b,
                    "isSocialQuest": availableGameQuests[i].isSocialQuest,
                    "psFriend": availableGameQuests[i].psFriend,
                    // these values are for requests
                    "isRequest": availableGameQuests[i].isRequest,
                    "botType": availableGameQuests[i].botType,
                    "senderRefId": availableGameQuests[i].senderRefId,
                    "senderFbId": availableGameQuests[i].senderFbId,
                    "trackingId": availableGameQuests[i].trackingId,
                    "engagementType": availableGameQuests[i].engagementType,
                    "isLoopbackEngagement": availableGameQuests[i].isLoopbackEngagement,
                };

                if(dailyQuestsObj.isDailyQuestReplacement(availableGameQuests[i].id)){
                    var isSocial = (rowInfo["isSocialQuest"] != undefined) && (rowInfo["isSocialQuest"] == 1) ? 1 : 0;
                    dailyQuestsObj.setDQReplacementPosition(i);
                    trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, availableGameQuests[i].id, xpromoConstantsObj.TRACK_DQ_REPLACEMENT, constantsObj.TRACK_VIEW, dailyQuestsObj.getDQReplacementPosition().toString(),  (xPromoGameSpecificObj.getDQreplacementValue()).toString(), isSocial + "", "", "");
                    if(isSocial == 1){
                        rowInfo["d"] = dailyQuestsObj.getDQReplacementSocialQuestLabel(rowInfo["gh"]);
                    }
                }
                questRotationObj.incBucketViewCount(rowInfo["bucket"]);
                listItems.push(rowInfo);
                var questType = availableGameQuests[i].qt;
                //IsDailyQuestReplacement is used everywhere the isDailyQuestOrStreakQuest is encountered because the UI has to behave exactly in the same manner as DQ
                if (dailyQuestsObj.isDailyQuestOrStreakQuest(questType) || dailyQuestsObj.isDailyQuestReplacement(availableGameQuests[i].id)) {
                    //This placement ensures DQ container has adequate height for the new replacement quest when the old DQ is replaced
                    questCenterLayer.dailyQuestsCount++;
                    questCenterLayer.cgdqDailyQuestsCount++;

                }
                if (expXpromoDq == constantsObj.EXP_VAR_1 || expXpromoDq == constantsObj.EXP_VAR_2) {
                    if (availableGameQuests[i].qt.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0 || availableGameQuests[i].qt.indexOf(xpromoConstantsObj.QUEST_TYPE_SECONDARY_QUEST_LEVEL) == 0) {
                        questCenterLayer.dailyQuestsCount++;
                        questCenterLayer.cgdqDailyQuestsCount++;
                    }
                }
                if (rowInfo["crossGame"] == "1" || rowInfo["crossGame"] == 1) {
                    var speciesTrack = undefined;
                    if (rowInfo["isSocialQuest"] == 1) {
                        var botShown = socialQuestObj.getSocialQuestBotShown();
                        if (botShown) {
                            var expVarPseudoSocialQuest = epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSEUDO_QUEST_INVITE);
                            rowInfo["trackingId"] = xpromoConstantsObj.TRACK_PSEUDO_SOCIAL_QUEST + "_" + rowInfo["trackingId"] + "_" + expVarPseudoSocialQuest;
                        } else {
                            var socialQuestExp = epmObj.getChosenVariant(xpromoConstantsObj.EXP_QUEST_INVITE);
                            rowInfo["trackingId"] = xpromoConstantsObj.TRACK_SOCIAL_QUEST + "_" + rowInfo["trackingId"] + "_" + socialQuestExp;
                        }
                        var socialFriend = socialQuestObj.getCurrentFriend();
                        speciesTrack = rowInfo["trackingId"];
                        if(socialFriend != undefined && socialFriend["friend"] != undefined) {
                            speciesTrack = rowInfo["trackingId"] + "_" + socialFriend["friend"]["refId"];
                        }
                        hasSocialQuest = true;
                    }
                    questsObj.fireTrackingForEachQuest(rowInfo, speciesTrack);
                }
            }

        }

        numOfAvailableGameQuests = listItems.length;

        // config added
        var qaConfigQuestCount = qaConfigObj.getQAConfigData("numberOfQuestsAvailable");
        if (qaConfigQuestCount != "" && utilObj.isStaging()) {
            numOfAvailableGameQuests = Math.min(qaConfigQuestCount, numOfAvailableGameQuests);
        }

        //* Checking if the quest in the cross game where the quest was surfaced to complete certain levels in trip is completed or not
        var loop_back_data = crossGameDailyQuestsObj.getCrossGameDailyQuestCompletedData();
        if (loop_back_data != null) {
            if (loop_back_data != undefined) {
                //* for increasing the size of the scrollview
                numOfAvailableGameQuests++;
            }
        }

        questCenterLayer.questsCountInBucket = questsObj.getQuestsCountInBucket();

        var dailyQuestsPaddingTop = xpromoConstantsObj.DAILY_QUESTS_PADDING_TOP;
        var dailyQuestsPaddingBottom = xpromoConstantsObj.DAILY_QUESTS_PADDING_BOTTOM;

        var scrollViewHeight = numOfAvailableGameQuests * questCenterLayer.levelElementHeight + countrySpacing + countryElementHeight + listMargin;

        if (questCenterLayer.dailyQuestsCount != 0) {
            scrollViewHeight += dailyQuestsPaddingTop + dailyQuestsPaddingBottom + questCenterLayer.listItemsMargin * 2;
        }
        if (questCenterLayer.dailyQuestsLocked) {
            scrollViewHeight += questCenterLayer.levelElementHeight;
        }
        //for extra space at bottom
        scrollViewHeight -= 130;

        scrollViewHeight += 120;
        questCenterLayer.sHeight = scrollViewHeight;
        questCenterLayer.numAvailableQuests = numOfAvailableGameQuests;
        if (allQuestsCompleted == true || questsNotReady == true) {
            var allQuestsCompletedImg = utilObj.getSprite(xpromoConstantsObj.quests_completed_icon, centerXPos, constantsObj.DESIGN_HEIGHT / 2 + 400, 0.5, 0.5, constantsObj.SCALE_SPRITE_3, spriteArr, questCenterLayer,
                zOrder, xpromoConstantsObj.SPRITE_QUESTS);
            utilObj.getBMFontLabel(stringsObj.completed_all_quests, constantsObj.FONT_SFCOMPACT_REGULAR_70, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), centerXPos, constantsObj.DESIGN_HEIGHT / 2 - 300, 0.5, 0.5, labelArr, questCenterLayer, zOrder);
        } else {
            questCenterLayer.addScrollViewProperties(scrollViewHeight);


            if (scrollViewHeight < constantsObj.DESIGN_HEIGHT - xpromoConstantsObj.HEADER_HEIGHT_QUEST_CENTER) {
                listYPos = constantsObj.DESIGN_HEIGHT - xpromoConstantsObj.HEADER_HEIGHT_QUEST_CENTER;
            } else {
                listYPos = scrollViewHeight;
            }

            var bezShift = xPromoGameSpecificObj.getBezelShift();
            if (ftueObj.shouldFtueBeShown() && questCenterLayer.ftueShownNum == ftueObj.FTUE_QUEST_CLAIM) {
                listYPos -= levelElementHeight;
                if (questCenterLayer.dailyQuestsCount != 0) {
                    listYPos -= questCenterLayer.listItemsMargin;
                }
            }

            questCenterLayer.timerLabelParams = [];
            questCenterLayer.scrollViewLocalYPos = listYPos;

            //* Creating a questCenterLayer.paramsMap for sending the variables as a whole object rather than writing them again and again, and whenever we change, the change is reflected across everywhere because maps are sent by shallow copy
            questCenterLayer.paramsMap = {
                "listItems": listItems,
                "listYPos": questCenterLayer.scrollViewLocalYPos,
                "availableGameQuests": availableGameQuests,
                "numOfAvailableGameQuests": numOfAvailableGameQuests,
                "scrollViewWidth": scrollViewWidth,
                "levelElementHeight": levelElementHeight,
                "labelArr": labelArr,
                "spriteArr": spriteArr,
                "zOrder": zOrder,
                "getDailyQuests": 1,
                "listZOrder": constantsObj.SPRITE_Z_ORDER,
                "bgZOrder": constantsObj.BG_Z_ORDER,
            };

            //*  Loop back engagement Quest surfacing, made another function for it
            if (loop_back_data != null && loop_back_data != undefined) {
                dailyQuestsLayer.showLoopBackEngagement(questCenterLayer.paramsMap, loop_back_data);
            }

            //adding daily quest items
            questCenterLayer.addQuestItems();
            questCenterLayer.scrollViewLocalYPos -= dailyQuestsPaddingBottom;

            if (ftueObj.shouldFtueBeShown() && questCenterLayer.ftueShownNum == ftueObj.FTUE_QUEST_CLAIM && questCenterLayer.isDailyQuestFtue == false) {
                questCenterLayer.scrollViewLocalYPos += questCenterLayer.levelElementHeight + questCenterLayer.listItemsMargin;
            }
            questCenterLayer.isDailyQuestFtue = false;
            questCenterLayer.paramsMap["getDailyQuests"] = 0;
            questCenterLayer.paramsMap["scrollViewWidth"] = scrollViewWidth;
            questCenterLayer.paramsMap["listYPos"] = questCenterLayer.paramsMap["listYPos"] - questCenterLayer.listItemsMargin;

            if (questCenterLayer.dailyQuestsLocked) {
                questCenterLayer.paramsMap["listYPos"] -= 250;
            }

            // adding non-daily quest items
            questCenterLayer.addQuestItems();
            questCenterLayer.addChild(questCenterLayer.scrollView, zOrder);

        }
        // Packs area end
        /////////////////////

        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);

        utilObj.updateScreen(questCenterLayer.screen, questCenterLayer, null, utilObj.getScreenName(questsObj.getQuestCenterTrackingScreen()), questsObj.getQuestTrackingInfo());
        if(src != utilObj.getScreenName(constantsObj.SCREEN_QUEST_CENTER)) {
            machineLearningDataObj.incUserOpenedQuestCenter();
            if(xPromoGameSpecificObj.isUserInteractionTrackingEnabled() && hasSocialQuest) {
                machineLearningDataObj.incSocialQuestViews();
            }
        }
        pspnUserTracking.trackUserSnapshot(constantsObj.SCREEN_QUEST_CENTER, constantsObj.TRACK_VIEW);
    },


    addQuestItems: function () {

        var questsBgHeight = questCenterLayer.paramsMap["numOfAvailableGameQuests"] * questCenterLayer.paramsMap["levelElementHeight"];
        questCenterLayer.paramsMap["centerX"] = centerXPos;
        questCenterLayer.paramsMap["dailyQuestsXShift"] = 0;
        questCenterLayer.paramsMap["dailyTimerLbl"] = null;
        questCenterLayer.paramsMap["clock"] = null;
        questCenterLayer.paramsMap["moreQuestsTomorrowLbl"] = null;
        var claimedQuests = 0;
        var inGameProgress = questsObj.getInGameProgressMap();
        var expXpromoDq = crossGameDailyQuestsObj.getCurrentCGDQExp();
        questCenterLayer.paramsMap["layer"] = questCenterLayer.scrollView;
        questCenterLayer.layer = questCenterLayer.paramsMap["layer"];
        // * to show the ui layout for daily quests. return from function after showing locked ui or after all daily quests
        if (questCenterLayer.paramsMap["getDailyQuests"] == 1) {
            var toBeReturned = questCenterLayer.getDailyQuestsLayout();
            if (toBeReturned == 1) {
                return;
            }
        }
        if (questCenterLayer.paramsMap["getDailyQuests"] == 1) {
            if (questCenterLayer.isDailyQuestFtue == true) {
                questCenterLayer.paramsMap["listYPos"] += questCenterLayer.paramsMap["levelElementHeight"] + questCenterLayer.listItemsMargin;
            }
        }
        questCenterLayer.indexParamsToVisibleTrack = [];
        questCenterLayer.indexVisibleToParamsTrack = [];
        questCenterLayer.questIdFromVisibleIndex = [];
        for (var i in questCenterLayer.paramsMap["listItems"]) {
            questCenterLayer.paramsMap["loopIndex"] = i;
            questCenterLayer.indexParamsToVisibleTrack[i] = i;
            questCenterLayer.indexVisibleToParamsTrack[i] = i;
            //to not show normal ui for locked quest like cgdq
            questCenterLayer.paramsMap["shouldDisplayUIHere"] = 1;
            var rowInfo = questCenterLayer.paramsMap["listItems"][i];
            if (rowInfo == undefined || rowInfo == null || rowInfo == {}) {
                continue;
            }
            var questDesc = rowInfo["d"];
            var questType = rowInfo["qt"];
            var gameHostedIn = rowInfo["gh"];
            var questStatus = rowInfo["status"];
            var questId = rowInfo["id"];
            questCenterLayer.questIdFromVisibleIndex[i] = questId;
            var timeLimit = rowInfo["timeLimit"];
            var crossGame = rowInfo["crossGame"];
            var shareLink = null;
            var pkgName = null;
            var appId = null;
            var isSocialQuest = rowInfo["isSocialQuest"];
            var psFriend = rowInfo["psFriend"];
            var isRequest = rowInfo["isRequest"];
            var params = rowInfo["params"];
            var copyGameHostedIn = gameHostedIn;
            // these values are for requests
            var botType = rowInfo["botType"];
            var senderRefId = rowInfo["senderRefId"];
            var senderFbId = rowInfo["senderFbId"];
            var engagementType = rowInfo["engagementType"];
            //var trackingId = rowInfo["trackingId"];
            appId = rowInfo["itunesId"];
            shareLink = rowInfo["shareLink"];
            pkgName = rowInfo["pkgName"];


            questCenterLayer.paramsMap["questId"] = questId;
            questCenterLayer.paramsMap["questType"] = questType;
            questCenterLayer.paramsMap["questStatus"] = questStatus;
            questCenterLayer.paramsMap["params"] = params;
            questCenterLayer.paramsMap["trackingId"] = rowInfo["trackingId"];
            questCenterLayer.paramsMap["timeLimit"] = timeLimit;
            questCenterLayer.paramsMap["clickAction"] = 'questAction';
            questCenterLayer.paramsMap["bucket"] = rowInfo["bucket"];
            questCenterLayer.paramsMap["reward"] = rowInfo["re"];
            questCenterLayer.paramsMap["curProgress"] = rowInfo["curProgress"];
            questCenterLayer.paramsMap["engagementType"] = engagementType;
            questCenterLayer.paramsMap["isLoopbackEngagement"] = rowInfo["isLoopbackEngagement"];

            if (questCenterLayer.paramsMap["questType"].indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0 || questCenterLayer.paramsMap["questType"].indexOf(xpromoConstantsObj.QUEST_TYPE_SECONDARY_QUEST_LEVEL) == 0) {
                if (questCenterLayer.paramsMap["questType"].indexOf(xpromoConstantsObj.QUEST_TYPE_SECONDARY_QUEST_LEVEL) == 0) {
                    engagementType = xpromoConstantsObj.TRACK_SECONDARY_QUEST;
                } else {
                    crossGameDailyQuestsObj.incrementDailyQuestViewCount(questCenterLayer.paramsMap["questId"]);
                }
                trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, crossGameDailyQuestsObj.getCurrentCGDQExp(), gameHostedIn, xpromoConstantsObj.TRACK_CGDQ, constantsObj.TRACK_VIEW, engagementType, rowInfo["curProgress"], "", "");
                if (questCenterLayer.paramsMap["questStatus"] == xpromoConstantsObj.QUEST_COMPLETED) {
                    trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, crossGameDailyQuestsObj.getCurrentCGDQExp(), gameHostedIn, xpromoConstantsObj.TRACK_CGDQ, constantsObj.TRACK_COMPLETE, engagementType, rowInfo["curProgress"], "", "");
                }
            }

            if (isRequest == 1) {
                if (utilObj.getCurrentTimestamp() - questCenterLayer.paramsMap["params"][1] >= questCenterLayer.paramsMap["timeLimit"]) {
                    var requestData = requestsObj.getCurrentActiveRequest()[0];
                    requestsObj.updateRequestStatus(requestData, xpromoConstantsObj.REQUEST_COMPLETED_BEFORE_START);
                    continue;
                }
                trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, senderRefId, "1", xpromoConstantsObj.TRACK_WARS_QUEST, constantsObj.TRACK_VIEW, "", botType, questCenterLayer.paramsMap["trackingId"], "");
            }
            // * because we have to include only daily quests in first function call with getdailyquests = 1 and include non-daily quests in second function call with getdailyquests = 0
            var exclude = questCenterLayer.excludeQuestinThisCall(expXpromoDq);
            if (exclude == 1) {
                continue;
            }
            if (dailyQuestsObj.isDailyQuestOrStreakQuest(questCenterLayer.paramsMap["questType"])) {
                questDesc = questDesc.replace("%value%", rowInfo["reqProgress"]);
            }

            if(dailyQuestsObj.isDailyQuestOrStreakQuest(questCenterLayer.paramsMap["questType"]) && questCenterLayer.paramsMap["questStatus"]== xpromoConstantsObj.QUEST_CLAIMED){
                dailyQuestsObj.setQuestToBeReplaced(questId);
            }

            //var isCrossGame = false;
            questCenterLayer.paramsMap["questDesc"] = questDesc;
            questCenterLayer.paramsMap["isCrossGame"] = false;
            if (crossGame == 1) {
                questCenterLayer.paramsMap["isCrossGame"] = true;
            }

            questCenterLayer.makeQuestDesc();
            if (questCenterLayer.paramsMap["noOfLines"] > 3 || (questCenterLayer.paramsMap["noOfLines"] >= 3 && isSocialQuest != 1)) {
                continue;
            }

            questCenterLayer.paramsMap["reqProgressForQuest"] = rowInfo["reqProgress"];
            questCenterLayer.paramsMap["currentProgressForQuest"] = rowInfo["curProgress"];
            questCenterLayer.paramsMap["progressBar"] = true;
            if (questCenterLayer.paramsMap["reqProgressForQuest"] == undefined || questCenterLayer.paramsMap["reqProgressForQuest"] == null || questCenterLayer.paramsMap["reqProgressForQuest"] == 0 || (questCenterLayer.paramsMap["reqProgressForQuest"] == 1 && !dailyQuestsObj.isDailyQuestOrStreakQuest(questCenterLayer.paramsMap["questType"]) && questCenterLayer.paramsMap["questType"].indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) != 0)
                || (questCenterLayer.paramsMap["questStatus"] == xpromoConstantsObj.QUEST_NOT_STARTED && questCenterLayer.paramsMap["questType"].indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) != 0) || questCenterLayer.paramsMap["questStatus"] == xpromoConstantsObj.QUEST_CLAIMED) {
                questCenterLayer.paramsMap["progressBar"] = false;
            }


            // * in claimed quests, only daily quests will reach here inorder to show tickmark and morequeststomorrow label
            if (questCenterLayer.paramsMap["progressBar"] == false && (dailyQuestsObj.isDailyQuestOrStreakQuest(questCenterLayer.paramsMap["questType"]) || dailyQuestsObj.isDailyQuestReplacement(questCenterLayer.paramsMap["questId"])) && questCenterLayer.paramsMap["questStatus"] == xpromoConstantsObj.QUEST_CLAIMED) {
                claimedQuests += 1;
            }

            var allDailyQuestsCompleted = 0;
            var cgdqExp = crossGameDailyQuestsObj.getCurrentCGDQExp();
            if (cgdqExp == constantsObj.EXP_VAR_1) {
                if (crossGameDailyQuestsObj.getSecondaryQuestClaimed() == 1 && claimedQuests == 2) {
                    allDailyQuestsCompleted = 1;
                }
            } else if (cgdqExp == constantsObj.EXP_VAR_2) {
                if (crossGameDailyQuestsObj.getSecondaryQuestClaimed() == 1 && claimedQuests == 3) {
                    allDailyQuestsCompleted = 1;
                }
            } else if (claimedQuests == 3) {
                allDailyQuestsCompleted = 1;
            }

            if (allDailyQuestsCompleted) {
                utilObj.setVisible(questCenterLayer.paramsMap["clock"], false);
                utilObj.setVisible(questCenterLayer.paramsMap["dailyTimerLbl"], false);
                utilObj.setVisible(questCenterLayer.paramsMap["moreQuestsTomorrowLbl"], true);
            }

            questCenterLayer.paramsMap["gameIcon"] = questConfigObj.getConfigData("icon_game");
            questCenterLayer.paramsMap["pathForGameIcon"] = "";
            questCenterLayer.paramsMap["iconScaling"] = constantsObj.SCALE_TWO_POINT_FIVE * constantsObj.SPRITE_SCALING_FACTOR * (80 / 206);
            questCenterLayer.paramsMap["spriteScaling"] = constantsObj.SCALE_ONE;
            questCenterLayer.paramsMap["isRequest"] = isRequest;
            questCenterLayer.paramsMap["botType"] = botType;
            questCenterLayer.paramsMap["senderRefId"] = senderRefId;
            questCenterLayer.paramsMap["senderFbId"] = senderFbId;
            questCenterLayer.paramsMap["isSocialQuest"] = isSocialQuest;
            questCenterLayer.paramsMap["psFriend"] = psFriend;
            questCenterLayer.paramsMap["gameHostedIn"] = gameHostedIn;
            questCenterLayer.paramsMap["levelIcon"] = null;
            questCenterLayer.paramsMap["levelsBgColor"] = constantsObj.COLOR_IN_GAME_QUEST_BG;
            questCenterLayer.paramsMap["levelsBg"] = null;
            questCenterLayer.paramsMap["shouldFade"] = false;

            // * this function is to download and display social quest.
            var socialQuestImageDownloaded = questCenterLayer.showIcon();
            questCenterLayer.paramsMap["levelYPos"] = questCenterLayer.paramsMap["listYPos"] - questCenterLayer.paramsMap["levelElementHeight"] / 2;
            //*
            if (!(questType.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0 && copyGameHostedIn != constantsObj.GAME_ID) && !questsObj.isQuestInGame(questCenterLayer.paramsMap["questId"])) {
                questCenterLayer.paramsMap["levelsBgColor"] = constantsObj.COLOR_CROSS_GAME_QUEST_BG;
            }
            if (questCenterLayer.paramsMap["questType"].indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0 && (expXpromoDq == constantsObj.EXP_VAR_1 || expXpromoDq == constantsObj.EXP_VAR_2)) {
                questCenterLayer.paramsMap["levelsBgColor"] = constantsObj.COLOR_DAILY_QUESTS_BG;
            }

            var visFlag = false;
            questCenterLayer.paramsMap["bezelShift"] = 0;
            if (utilObj.isBezelScreen()) {
                questCenterLayer.paramsMap["bezelShift"] = xPromoGameSpecificObj.getBezelShift();
            }
            questCenterLayer.bezelShift = questCenterLayer.paramsMap["bezelShift"];
            questCenterLayer.paramsMap["bezelXShift"] = xRightPosErr / 2;
            questCenterLayer.bezelXShift = questCenterLayer.paramsMap["bezelXShift"];

            if (xpromoConstantsObj.QUEST_ICON_GAME_MAP[constantsObj.GAME_ID] != undefined && xpromoConstantsObj.QUEST_ICON_GAME_MAP[constantsObj.GAME_ID][questCenterLayer.paramsMap["questType"]] != undefined) {
                questCenterLayer.paramsMap["gameIcon"] = xpromoConstantsObj.QUEST_ICON_GAME_MAP[constantsObj.GAME_ID][questCenterLayer.paramsMap["questType"]];
            } else if (xpromoConstantsObj.QUEST_ICON_MAP[questCenterLayer.paramsMap["questType"]] != undefined) {
                questCenterLayer.paramsMap["gameIcon"] = xpromoConstantsObj.QUEST_ICON_MAP[questCenterLayer.paramsMap["questType"]];
            }
            // else if (socialQuestImageDownloaded == 0) {
            //     questCenterLayer.paramsMap["spriteScaling"] = constantsObj.SCALE_TWO_POINT_FIVE * constantsObj.SPRITE_SCALING_FACTOR * (80 / 206);
            // }

            // this is to show daily quest lock UI
            questCenterLayer.paramsMap["levelXPos"] = 160 + questCenterLayer.paramsMap["dailyQuestsXShift"] / 2;
            //if cgdq is locked, we will avoid its display by this
            //save cgdq's current pos acc to questid ,to avoid paramsmap

            if (questType.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0) {
                questCenterLayer.paramsMap["lYPos"] = questCenterLayer.paramsMap["listYPos"];
                questCenterLayer.paramsMap["cgdqId"] = questCenterLayer.paramsMap["questId"];
                questCenterLayer.paramsMap["cgdqLoopIndex"] = questCenterLayer.paramsMap["loopIndex"];
                questCenterLayer.paramsMap["cgdqGameHostedIn"] = questCenterLayer.paramsMap["gameHostedIn"];
                questCenterLayer.cgdqParams = questCenterLayer.paramsMap;
            }
            var showUIForDailyQuestLocked = dailyQuestsLayer.showDailyQuestLockedState(questCenterLayer.paramsMap, questCenterLayer.paramsMap["questType"], true);
            if (showUIForDailyQuestLocked == 1) {
                questCenterLayer.paramsMap["shouldDisplayUIHere"] = 0;
            }

            if (showUIForDailyQuestLocked == 2) {
                questCenterLayer.paramsMap["shouldFade"] = true;
            }

            if (questCenterLayer.paramsMap["shouldDisplayUIHere"] == 1) {
            // * this function is for showing bg box, quest icon, gameicon and dp in social quest icon,etc
            questCenterLayer.showBgIcons(socialQuestImageDownloaded, expXpromoDq);
            }

            questCenterLayer.paramsMap["levelTxtXPos"] = questCenterLayer.paramsMap["levelXPos"] + 150;
            var levelTxtYPos = questCenterLayer.paramsMap["levelYPos"] + 70;
            if (questCenterLayer.paramsMap["progressBar"] == false) {
                levelTxtYPos -= 30;
            }

            questCenterLayer.handlingButtonUI();

            if (!visFlag) { // && questCenterLayer.paramsMap["shouldDisplayUIHere"] == 1) {
                //this function is for displaying quest description and progress bar UI
                questCenterLayer.showTextAndProgress(questCenterLayer.paramsMap["questDesc"]);
            }
            questCenterLayer.paramsMap["firstParam"] = null;
            questCenterLayer.paramsMap["itunesId"] = null;
            if (questCenterLayer.paramsMap["params"] != undefined && questCenterLayer.paramsMap["params"] != null) {
                questCenterLayer.paramsMap["firstParam"] = questCenterLayer.paramsMap["params"][0];
                if (questCenterLayer.paramsMap["params"][1] != null && questCenterLayer.paramsMap["params"][1] != undefined) {
                    questCenterLayer.paramsMap["itunesId"] = questCenterLayer.paramsMap["params"][1];
                }
            }
            if (shareLink != null) {
                questCenterLayer.paramsMap["firstParam"] = shareLink;
            }
            if (appId != null) {
                questCenterLayer.paramsMap["itunesId"] = appId;
            }
            if (questCenterLayer.paramsMap["questStatus"] != xpromoConstantsObj.QUEST_COMPLETED) { //&& questCenterLayer.paramsMap["shouldDisplayUIHere"] == 1) {
                //this function adds all the quest center timer labels
                questCenterLayer.addQcTimerLabels(questCenterLayer.paramsMap["questType"]);
            }

            if (questCenterLayer.paramsMap["getDailyQuests"] && questCenterLayer.dailyQuestsCount != 0) { // && questCenterLayer.paramsMap["shouldDisplayUIHere"] == 1) {
                // * this function adds a string at top of daily quest layout for telling how much time is left
                questCenterLayer.addDailyQuestTimeLeft();
            }

            questCenterLayer.paramsMap["btnWidth"] = questCenterLayer.btnWidth;
            questCenterLayer.paramsMap["btnHeight"] = questCenterLayer.btnHeight;
            questCenterLayer.paramsMap["rewardValue"] = questsObj.getRewardValueForQuest(rowInfo);
            if (questCenterLayer.paramsMap["questType"] == xpromoConstantsObj.QUEST_TYPE_FB_CONNECT) {
                questCenterLayer.paramsMap["rewardValue"] = economyObj.getFbConnectCash();
            } else if (questCenterLayer.paramsMap["questType"] == xpromoConstantsObj.QUEST_TYPE_INVITE_FRIENDS) {
                questCenterLayer.paramsMap["rewardValue"] = economyObj.getReferralReward();
            }
            if (ftueObj.shouldFtueBeShown() && questCenterLayer.ftueShownNum == ftueObj.FTUE_QUEST_CLAIM && questCenterLayer.paramsMap["questStatus"] == xpromoConstantsObj.QUEST_COMPLETED && questCenterLayer.paramsMap["availableGameQuests"][i].id == questsObj.getQuestCompleteId()) {
                questCenterLayer.addFtueActionBtn();
            } else { //if (questCenterLayer.paramsMap["questStatus"] != xpromoConstantsObj.QUEST_CLAIMED) { // && questCenterLayer.paramsMap["shouldDisplayUIHere"] == 1) {
                // * this function is for UI for buttons
                questCenterLayer.addButtons(expXpromoDq);
            }

            var adjust_posY = 50;
            if (questCenterLayer.paramsMap["noOfLines"] != 1) {
                adjust_posY += 30;
            }

            /*f (noOfDigits == 1 || noOfDigits == 3) {
                questCenterLayer.paramsMap["quesDescY"] += 20;
            }*/

            questCenterLayer.paramsMap["rewardTxtLbl"] = null;
            if (ftueObj.shouldFtueBeShown() && questCenterLayer.ftueShownNum == ftueObj.FTUE_QUEST_CLAIM && questCenterLayer.paramsMap["questStatus"] == xpromoConstantsObj.QUEST_COMPLETED && questCenterLayer.paramsMap["availableGameQuests"][questCenterLayer.paramsMap["loopIndex"]].id == questsObj.getQuestCompleteId()) {
                questCenterLayer.ftueClaimRewardUi();
            } else { //if (questCenterLayer.paramsMap["shouldDisplayUIHere"] == 1) {
                // * this function adds all the ui for claim string, coins ,reward etc
                questCenterLayer.claimRewardUi();
            }
            // * this function actually adds buttons to layer
            questCenterLayer.addButtonsToLayer();
            var listItemsMargin = questCenterLayer.listItemsMargin;
            questCenterLayer.paramsMap["listYPos"] -= questCenterLayer.paramsMap["levelElementHeight"] + listItemsMargin;
        }
        if (questCenterLayer.checkDailyQuestsLocked() == false && questCenterLayer.paramsMap["getDailyQuests"] == xpromoConstantsObj.SHOW_LOOP_BACK_ENGAGEMENT_QUEST) {
            questCenterLayer.paramsMap["listYPos"] += 35;
        }
        questCenterLayer.scrollViewLocalYPos = questCenterLayer.paramsMap["listYPos"];
    },

    loginSuccess: function () {
        questCenterLayer.redraw();
    },

    isRedirectionQuest: function (questType, questId) {
        var redirects = false;
        switch (questType) {
            case xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_LEVEL_COMPLETE:
            case xpromoConstantsObj.QUEST_TYPE_INSTALL_AND_DO_SOMETHING:
            case xpromoConstantsObj.QUEST_TYPE_INSTALL_AND:
            case xpromoConstantsObj.QUEST_TYPE_INSTALL_TIME:
            case xpromoConstantsObj.QUEST_TYPE_INSTALL_ACTION:
            case xpromoConstantsObj.QUEST_TYPE_FB_CONNECT:
            case xpromoConstantsObj.QUEST_TYPE_INVITE_FRIENDS:
            case xpromoConstantsObj.QUEST_TYPE_INSTALL_GAME:
            case xpromoConstantsObj.QUEST_TYPE_RATE_US:
            case xpromoConstantsObj.QUEST_TYPE_INVITE_WHATSAPP:
            case xpromoConstantsObj.QUEST_TYPE_INVITE_TWITTER:
            case xpromoConstantsObj.QUEST_TYPE_INVITE_FB_MESSENGER:
            case xpromoConstantsObj.QUEST_TYPE_INVITE_INSTAGRAM:
            case xpromoConstantsObj.QUEST_TYPE_INVITE_GOOGLE_PLUS:
            case xpromoConstantsObj.QUEST_TYPE_INVITE_TUMBLR:
            case xpromoConstantsObj.QUEST_TYPE_INVITE_MESSAGE:
            case xpromoConstantsObj.QUEST_TYPE_INVITE_EMAIL:
            case xpromoConstantsObj.QUEST_TYPE_INVITE_IMESSAGE_APP:
            case xpromoConstantsObj.QUEST_TYPE_INVITE_IMESSAGE_APP_PERSISTENT:
            case xpromoConstantsObj.QUEST_TYPE_OPEN_SUBSCIRIPTION:
            case xpromoConstantsObj.REQUEST_TYPE_WORD_WARS:
            case xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ:
            case xpromoConstantsObj.QUEST_TYPE_INVITE_CONTACT_BOOK:
            case xpromoConstantsObj.QUEST_TYPE_PURCHASE_PREMIUM_AVATAR:
                redirects = true;
                break;
            case xpromoConstantsObj.QUEST_TYPE_SECONDARY_QUEST_LEVEL:
                var exp = crossGameDailyQuestsObj.getCurrentCGDQExp();
                if (exp == constantsObj.EXP_VAR_1 || exp == constantsObj.EXP_VAR_2) {
                    redirects = true;
                }
                break;
            default:
                redirects = false;
                break;
        }
        return redirects;
    },

    shouldShowReward: function (questType, questId) {
        if (questType == xpromoConstantsObj.QUEST_TYPE_INVITE_IMESSAGE_APP_PERSISTENT) {
            return false;
        }
        return true;
    },

    getButtonColorForQuests: function (questType, questId, questStatus) {
        var btnColor = constantsObj.COLOR_IN_GAME_QUEST_BG;
        if (questCenterLayer.isRedirectionQuest(questType, questId) == true) {
            btnColor = xPromoGameSpecificObj.getColorOfQuestButton();
        } else if (dailyQuestsObj.isDailyQuestOrStreakQuest(questType) && dailyQuestsObj.isQuestTypeUnlocked(questType)) {
            btnColor = xPromoGameSpecificObj.getColorOfQuestButton();
        } else {
            btnColor = constantsObj.COLOR_IN_GAME_QUEST_BG;
        }
        if (questStatus == xpromoConstantsObj.QUEST_COMPLETED) {
            btnColor = constantsObj.COLOR_BUTTON_LIGHT_GREEN;
        }
        return btnColor;
    },

    getRewardTextColor: function (questType, questId, questStatus) {
        var color = constantsObj.COLOR_WHITE;
        if (questStatus == xpromoConstantsObj.QUEST_COMPLETED || questCenterLayer.isRedirectionQuest(questType, questId)) {
            color = constantsObj.COLOR_WHITE;
        } else if (dailyQuestsObj.isDailyQuestOrStreakQuest(questType) && dailyQuestsObj.isQuestTypeUnlocked(questType)) {
            color = constantsObj.COLOR_WHITE;
        } else {
            color = constantsObj.COLOR_BLACK;
        }
        return color;
    },

    getTxtLblOpacity: function (questType, questId, questStatus) {
        var opacity = constantsObj.OPACITY_100;
        if (questStatus == xpromoConstantsObj.QUEST_COMPLETED || dailyQuestsObj.isDailyQuestOrStreakQuest(questType)
            || questCenterLayer.isRedirectionQuest(questType, questId)) {
            opacity = constantsObj.OPACITY_100;
        } else {
            opacity = constantsObj.OPACITY_60;
        }
        return opacity;
    },

    questAction: function (sender, params) {
        if (questCenterLayer.isbuttonClickable == false || questCenterLayer.isCoinGrantAnimRunning == true) {
            return;
        }
        var isFtueflag = 0;
        if (ftueObj.shouldFtueBeShown() && questCenterLayer.ftueShownNum == ftueObj.FTUE_QUEST_CLAIM) {
            utilObj.playSound(constantsObj.button_tap_01, false);
            if (params.questId == questsObj.getQuestCompleteId()) {
                ftueObj.checkAndIncCompleted();
                trackObj.trackCounter(constantsObj.TRACK_DIALOG, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(), constantsObj.TRACK_FTUE_QC_2, constantsObj.TRACK_CLICK, "", "", "1", "");
                isFtueflag = 1;
            } else {
                return;
            }
        }
        var questStatus = params.status;
        var questType = params.qt;
        var questId = params.questId;
        var itunesId = null;
        var isCrossGame = params.isCrossGame;
        if (params.itunesId != undefined) {
            itunesId = params.itunesId;
        }
        var popupView = false;
        if(params.popupView != undefined && params.popupView == true) {
            popupView = true;
        }
        var firstParam = params.firstParam;
        var isCrossGame = params.isCrossGame;
        var reward = parseInt(params.reward);
        var isSocialQuest = params.isSocialQuest;
        var trackingId = params.trackingId;
        var gameHosted = params.gameHosted;
        var engagementType = params.engagementType;
        var curProgress = params.curProgress;
        var trackSocialQuest = ((isSocialQuest != undefined) && (isSocialQuest == 1)) ? 1 : 0;
        loggerObj.debugLog("this is loopback engagement 2 ", params.isLoopbackEngagement);
        var isLoopbackEngagement = params.isLoopbackEngagement;
        if (trackingId == undefined) {
            trackingId = "";
        }
        var pkgName = params.pkgName;
        if (questStatus == xpromoConstantsObj.QUEST_CLAIMED || questStatus == xpromoConstantsObj.QUEST_COMPLETED_BEFORE_START) {
            return;
        }

        if (isCrossGame == 1) {
            machineLearningDataObj.incCrossGameQuestsClicks();
        } else {
            machineLearningDataObj.incInGameQuestsClicks();
        }

        if (utilObj.isStaging() && qaConfigObj.getQAConfigData("shouldQuestGetCompleteOnClick")) {
            var currentQuestStatus = questsObj.getInGameProgressMap();
            if (dailyQuestsObj.isDailyQuestOrStreakQuest(questType) && currentQuestStatus.status != xpromoConstantsObj.QUEST_COMPLETED && currentQuestStatus.status != xpromoConstantsObj.QUEST_CLAIMED) {
                questsObj.updateInGameQuestStatus(questId, xpromoConstantsObj.QUEST_COMPLETED);
            }
        }

        //trackObj.trackCounter(constantsObj.TRACK_DIALOG, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(), xpromoConstantsObj.TRACK_QUEST_CENTER, constantsObj.TRACK_CLICK, utilObj.getScreenName(constantsObj.SCREEN_GAME), questsObj.getQuestTrackingInfo(), "1", "");
        if (questStatus == xpromoConstantsObj.QUEST_COMPLETED) {
            var copyGameHostedIn;
            if (params.isRequest == 1) {
                copyGameHostedIn = requestsObj.getCurrentActiveRequest()[0]["gh"];
            } else {
                var curQuests = questsObj.getCurQuests();
                if(curQuests[questId] != undefined) {
                    copyGameHostedIn = curQuests[questId]["gh"];
                }
            }
            if (copyGameHostedIn != undefined && questType.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0 && copyGameHostedIn == constantsObj.GAME_ID) {
                var game_shown_in = questsObj.getCurQuests()[questId]["gs"][0];
                if (isLoopbackEngagement == 1) {
                    trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, crossGameDailyQuestsObj.getCurrentCGDQExp(), "", xpromoConstantsObj.TRACK_CGDQ_RECIEVER, constantsObj.TRACK_CLICK, "", "", "", "");
                }
                if (xpromoConstantsObj.PSGames[game_shown_in] != undefined) {
                    if (utilObj.isAndroid()) {
                        if (xpromoUtilObj.isAppInstalled(xpromoConstantsObj.PSGames[game_shown_in][0])) {
                            utilObj.launchAnotherApp(xpromoConstantsObj.PSGames[game_shown_in][0]);
                        }
                    } else if (utilObj.isIos()) {
                        if (xpromoUtilObj.isAppInstalled(xpromoConstantsObj.PSGames[game_shown_in][1])) {
                            utilObj.launchAnotherApp(xpromoConstantsObj.PSGames[game_shown_in][1]);
                        }
                    }
                }
            } else if (questCenterLayer.isCoinGrantAnimRunning == false) {
                utilObj.playSound(constantsObj.button_tap_01, false);
                if (reward + economyObj.getCash() > constantsObj.MAX_CASH_ALLOWED) {
                    utilObj.showMessage(stringsObj.coin_limit_reached);
                    return;
                }

                var delay = 0;
                if(!popupView) {
                    questCenterLayer.isCoinGrantAnimRunning = true;
                    if (utilObj.isOnline()) {
                        if (isFtueflag) {
                            delay = 0;
                            isFtueflag = 0;
                        } else {
                            delay = 1.5;
                            if (questCenterLayer.numAvailableQuests < questCenterLayer.questSeparateCount) {
                                for (var i = 0; i < 5; i++) {
                                    utilObj.setPosition(questCenterLayer.centerCoinGrants[i], utilObj.getPosition(questCenterLayer.actionButton[params.loopIndex]).x + canvasWidth / 2 - 200, utilObj.getPosition(questCenterLayer.actionButton[params.loopIndex]).y);
                                }
                            } else {
                                var yPos = questCenterLayer.sHeight - utilObj.getPosition(questCenterLayer.actionButton[params.loopIndex]).y + questCenterLayer.scrollViewYPos - questCenterLayer.innerContainerYPos + 50;
                                for (var i = 0; i < 5; i++) {
                                    utilObj.setPosition(questCenterLayer.centerCoinGrants[i], utilObj.getPosition(questCenterLayer.actionButton[params.loopIndex]).x + canvasWidth / 2 - 200, constantsObj.DESIGN_HEIGHT - yPos - xpromoConstantsObj.HEADER_HEIGHT_QUEST_CENTER);
                                }
                            }
                            animationObj.animateCoinGrant(questCenterLayer.centerCoinGrants, questCenterLayer.headerCoins, reward, gameLayer.coinsLbl);
                        }
                    }
                } else {
                    var message = stringsObj.coins_added;
                    message = message.replace("%N%", reward.toString());
                    utilObj.showMessage(message);
                }

                var p = {
                    isCrossGame: isCrossGame,
                    questId: questId,
                    reward: reward,
                    isRequest: params.isRequest,
                    questType: questType,
                    popupView: popupView,
                };
                utilObj.delayedCallback(questCenterLayer, questCenterLayer.claimQuestReward, delay, p, false);
                trackObj.trackCounter(constantsObj.TRACK_DIALOG, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(), (!popupView) ? xpromoConstantsObj.TRACK_QUEST_CENTER : xpromoConstantsObj.TRACK_DAILY_QUEST, questId, constantsObj.TRACK_CLAIM, "", "", "");

                if (dailyQuestsObj.isDailyQuestOrStreakQuest(questType)) {
                    trackObj.trackCounter(constantsObj.TRACK_DIALOG, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(),
                        (!popupView) ? xpromoConstantsObj.TRACK_QUEST_CENTER : xpromoConstantsObj.TRACK_DAILY_QUEST, questsObj.getDailyQuestTrackingStr(questId), questId + "", constantsObj.TRACK_COLLECT, "", "");
                } else if (questType.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0 || questType.indexOf(xpromoConstantsObj.QUEST_TYPE_SECONDARY_QUEST_LEVEL) == 0) {
                    trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, crossGameDailyQuestsObj.getCurrentCGDQExp(), gameHosted, xpromoConstantsObj.TRACK_CGDQ, constantsObj.TRACK_CLAIM, engagementType, curProgress, "", "");
                } else if(dailyQuestsObj.isDailyQuestReplacement(questId)){
                    trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, questId, xpromoConstantsObj.TRACK_DQ_REPLACEMENT, constantsObj.TRACK_CLAIM, (0).toString(),  (xPromoGameSpecificObj.getDQreplacementValue()).toString(), trackSocialQuest + "", "", "");
                }
                if (isCrossGame == 1) {
                    trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(), (!popupView) ? xpromoConstantsObj.TRACK_QUEST_CENTER : xpromoConstantsObj.TRACK_DAILY_QUEST, questId, constantsObj.TRACK_CLAIM, trackingId, "", "");
                }
            }
        } else {
            var shouldPlayTapSound = true;
            var success = false;
            var showDefaultMessage = false;
            questRotationObj.incBucketClickCount(params.bucket, questId);
            if(dailyQuestsObj.isDailyQuestReplacement(questId)){
                trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, questId, xpromoConstantsObj.TRACK_DQ_REPLACEMENT, constantsObj.TRACK_CLICK, dailyQuestsObj.getDQReplacementPosition().toString(),  (xPromoGameSpecificObj.getDQreplacementValue()).toString(), trackSocialQuest + "" , "", "");
            }
            switch (questType) {
                case xpromoConstantsObj.QUEST_TYPE_PURCHASE_COINS:
                    if(epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_ALL_QUEST_CLICKABLE) == constantsObj.EXP_VAR_1) {
                        xPromoGameSpecificObj.questActionOpenStoreScreen(xpromoStringsObj.quest_default_action);
                    } else {
                        showDefaultMessage = true;
                    }
                    break;
                case xpromoConstantsObj.QUEST_TYPE_LEVEL_COMPLETE_IN_TIME:
                case xpromoConstantsObj.QUEST_TYPE_PLAY_CONSECUTIVE_DAYS:
                case xpromoConstantsObj.QUEST_TYPE_USE_HINT:
                case xpromoConstantsObj.QUEST_TYPE_USE_HINT_BURST:
                case xpromoConstantsObj.QUEST_TYPE_USE_HINT_TARGET:
                case xpromoConstantsObj.QUEST_TYPE_LEVEL_COMPLETE:
                case xpromoConstantsObj.QUEST_TYPE_OPEN_DICTIONARY:
                case xpromoConstantsObj.QUEST_TYPE_CLICK_DICTIONARY_AUDIO:
                    if(epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_ALL_QUEST_CLICKABLE) == constantsObj.EXP_VAR_1) {
                        questCenterLayer.hide();
                        questCenterLayer.openGameLayer();
                        if(!popupView && params.description != undefined) { // Showing message only if in QC view
                            utilObj.showMessage(params.description);
                        }
                    } else {
                        showDefaultMessage = true;
                    }
                    break;
                case xpromoConstantsObj.QUEST_TYPE_SPIN_SPINNER:
                    if(epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_ALL_QUEST_CLICKABLE) == constantsObj.EXP_VAR_1) {
                        xPromoGameSpecificObj.questActionSpins(params);
                    } else {
                        showDefaultMessage = true
                    }
                    break;
                case xpromoConstantsObj.QUEST_TYPE_VIP_LEVEL_COMPLETE:
                    if(epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_ALL_QUEST_CLICKABLE) == constantsObj.EXP_VAR_1) {
                        xPromoGameSpecificObj.questActionVIPPuzzle(params);
                    } else {
                        showDefaultMessage = true
                    }
                    break;
                case xpromoConstantsObj.QUEST_TYPE_PLAY_DAILY_PUZZLE:
                    if(epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_ALL_QUEST_CLICKABLE) == constantsObj.EXP_VAR_1) {
                        showDefaultMessage = !xPromoGameSpecificObj.questActionDailyPuzzle();
                    } else {
                        showDefaultMessage = true
                    }
                    break;
                case xpromoConstantsObj.QUEST_TYPE_FB_CONNECT:
                    fbWrapperObj.login(questCenterLayer.loginSuccess);
                    break;
                case xpromoConstantsObj.QUEST_TYPE_INVITE_FRIENDS:
                    xPromoGameSpecificObj.setFreeCoinsReferralLastScreen(constantsObj.SCREEN_QUEST_CENTER);
                    freeCoinsReferralPopup.show();
                    break;
                case xpromoConstantsObj.QUEST_TYPE_RATE_US:
                    xPromoGameSpecificObj.showAndAwardRateUs();
                    if (utilObj.isOnline()) {
                        success = true;
                        questsObj.incActionForQuestType(xpromoConstantsObj.QUEST_TYPE_RATE_US);
                    }
                    break;
                case xpromoConstantsObj.QUEST_TYPE_INVITE_CONTACT_BOOK:
                    questCenterLayer.contactBookClicked = true;
                    success = contactBookObj.inviteContactBook();
                    break;
                case xpromoConstantsObj.QUEST_TYPE_INVITE_WHATSAPP:
                    success = utilObj.shareOnWhatsapp();
                    break;
                case xpromoConstantsObj.QUEST_TYPE_INVITE_TWITTER:
                    success = utilObj.shareOnTwtr();
                    break;
                case xpromoConstantsObj.QUEST_TYPE_INVITE_MESSAGE:
                    success = utilObj.shareOnSms();
                    break;
                case xpromoConstantsObj.QUEST_TYPE_INVITE_EMAIL:
                    success = utilObj.shareOnMail();
                    break;
                case xpromoConstantsObj.QUEST_TYPE_INSTALL_GAME:
                    questsObj.updateCrossGameQuestStatus(questId, xpromoConstantsObj.QUEST_STARTED);
                    xpromoUtilObj.markXpromoStartedFromOtherSource(gameHosted, xpromoConstantsObj.TRACK_QUEST_CENTER);
                    trackObj.trackCounter(constantsObj.TRACK_DIALOG, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(), xpromoConstantsObj.TRACK_QUEST_CENTER, questId + "", constantsObj.TRACK_START, reward + "", "1", "");
                    // utilObj.openStore(itunesId, firstParam, questCenterLayer.screen);

                    // redirecting to appstore based on experiments
                    questsObj.redirectToPlaystoreOnClick(questId, xpromoConstantsObj.TRACK_QUEST_CENTER, trackingId);
                    pspnUserTracking.trackUserSnapshot(constantsObj.SCREEN_QUEST_CENTER, constantsObj.TRACK_CLICK);
                    break;
                case xpromoConstantsObj.QUEST_TYPE_INSTALL_AND:
                case xpromoConstantsObj.QUEST_TYPE_INSTALL_TIME:
                case xpromoConstantsObj.QUEST_TYPE_INSTALL_ACTION:
                    questsObj.updateCrossGameQuestStatus(questId, xpromoConstantsObj.QUEST_STARTED);
                    xpromoUtilObj.markXpromoStartedFromOtherSource(gameHosted, xpromoConstantsObj.TRACK_QUEST_CENTER);
                    // utilObj.openStore(itunesId, firstParam, questCenterLayer.screen);
                    questsObj.redirectToPlaystoreOnClick(questId);
                    break;
                case xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_LEVEL_COMPLETE:
                case xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_COMPLETE_WORDS:
                case xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_COMPLETE_PACK:
                case xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_ACTION:
                case xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_LEVEL_IN_TIME:
                    questsObj.redirectToPlaystoreOnClick(questId);
                    break;
                case xpromoConstantsObj.QUEST_TYPE_INVITE_FB_MESSENGER:
                    success = utilObj.shareOnMessenger();
                    break;
                case xpromoConstantsObj.QUEST_TYPE_OPEN_SUBSCIRIPTION:
                    if (xPromoGameSpecificObj.canShowSubscriptionQuest()) {
                        utilObj.showMessage(stringsObj.subscription_quest_msg);
                    } else {
                        questCenterLayer.hide();
                        questCenterLayer.isPopupOpenedFromQuestCenter = true;
                        questCenterLayer.openGameLayer();
                        xPromoGameSpecificObj.setSubscriptionSource(constantsObj.SCREEN_QUEST_CENTER);
                        subscriptionsLaunchPopup.show();
                    }
                    break;
                case xpromoConstantsObj.QUEST_TYPE_INVITE_GOOGLE_PLUS:
                    success = utilObj.shareOnGooglePlus();
                    break;
                case xpromoConstantsObj.QUEST_TYPE_INVITE_IMESSAGE_APP:
                case xpromoConstantsObj.QUEST_TYPE_INVITE_IMESSAGE_APP_PERSISTENT:
                    if (utilObj.isIos()) {
                        shouldPlayTapSound = false;
                        if (questsObj.getiMessageFtueShownCount() < 2) {
                            questsObj.setiMessageFtueShownCount(questsObj.getiMessageFtueShownCount() + 1);
                            questCenterLayer.scrollView.setTouchEnabled(false);
                            if (questType == xpromoConstantsObj.QUEST_TYPE_INVITE_IMESSAGE_APP_PERSISTENT) {
                                howToPlayPopup.show(true, 1, true);
                            } else {
                                howToPlayPopup.show(true, 1, true, questId);
                            }
                        } else {
                            if (questType == xpromoConstantsObj.QUEST_TYPE_INVITE_IMESSAGE_APP) {
                                success = howToPlayPopup.openImessageAppDirect();
                            } else {
                                howToPlayPopup.openImessageAppDirect();
                            }
                        }
                    }
                    break;
                case xpromoConstantsObj.QUEST_TYPE_WATCH_VIDEOS:
                    shouldPlayTapSound = xPromoGameSpecificObj.questActionWatchVideos(params);
                    break;
                case xpromoConstantsObj.REQUEST_TYPE_WORD_WARS:
                    questCenterLayer.redirectToMiniGame();
                    break;
                case xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ:
                    crossGameDailyQuestsObj.setCrossGameDailyQuestClicked(1);
                    crossGameDailyQuestsObj.updateCGDQProgressOnclick(questId);
                    crossGameDailyQuestsObj.makeInstallQuestStarted(questId);
                    crossGameDailyQuestsObj.incrementDailyQuestClickCount(questId);
                    questsObj.updateCrossGameQuestStatus(questId, xpromoConstantsObj.QUEST_STARTED);
                    trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, crossGameDailyQuestsObj.getCurrentCGDQExp(), gameHosted, xpromoConstantsObj.TRACK_CGDQ, constantsObj.TRACK_CLICK, engagementType, curProgress, "", "");
                    questsObj.redirectToPlaystoreOnClick(questId, xpromoConstantsObj.TRACK_QUEST_CENTER_DQ, trackingId);
                    break;
                case xpromoConstantsObj.QUEST_TYPE_SECONDARY_QUEST_LEVEL:
                    questCenterLayer.hide();
                    questCenterLayer.openGameLayer(xpromoConstantsObj.QUEST_TYPE_SECONDARY_QUEST_LEVEL);
                    trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, crossGameDailyQuestsObj.getCurrentCGDQExp(), gameHosted, xpromoConstantsObj.TRACK_CGDQ, constantsObj.TRACK_CLICK, constantsObj.TRACK_SECONDARY_QUEST, "", "", "");
                    break;
                case xpromoConstantsObj.QUEST_TYPE_PURCHASE_PREMIUM_AVATAR:
                    shouldPlayTapSound = xPromoGameSpecificObj.questActionOpenProfileAvatar(params);
                    break;

                case dailyQuestsObj.isDailyQuestOrStreakQuestEnabled(questType):
                    if (questConfigObj.isDailyQuestConfigInJson(questType)) {
                        shouldPlayTapSound = false;

                        // Check if this quest type is unlocked
                        if(!dailyQuestsObj.isQuestTypeUnlocked(questType)) {
                            // If its locked, check for any action that needs to run in that scenario
                            var lockAction = questConfigObj.getDailyQuestConfigData(questType, xpromoConstantsObj.QUEST_LOCK_ACTION);
                            if(lockAction != "") {
                                shouldPlayTapSound = eval(lockAction).apply(this, [questType]);
                            }
                        } else {
                            var functionName = questConfigObj.getDailyQuestConfigData(questType, xpromoConstantsObj.QUEST_ACTION);
                            shouldPlayTapSound = eval(functionName).apply(this, [params]);
                        }
                    }
                    break;
                default:
                    showDefaultMessage = true;
                    break;
            }
            if(showDefaultMessage) {
                utilObj.showMessage(xpromoStringsObj.quest_default_action);
            }
            if (shouldPlayTapSound) {
                utilObj.playSound(constantsObj.button_tap_01, false);
            }
            if (isCrossGame == 1) {
                trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(), xpromoConstantsObj.TRACK_QUEST_CENTER, questId, constantsObj.TRACK_CLICK, trackingId, "", "");
            }
            if (success == true) {
                questsObj.updateInGameQuestStatus(questId, xpromoConstantsObj.QUEST_COMPLETED);
                if(!popupView) {
                    questCenterLayer.redraw();
                }
                //trackObj.trackCounter(constantsObj.TRACK_DIALOG, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(), xpromoConstantsObj.TRACK_QUEST_CENTER, questId + "", constantsObj.TRACK_COMPLETED, reward + "", "1", "");
            }
        }
    },

    claimQuestReward: function (sender, params) {
        if (params.isRequest == 1) {
            requestsObj.claimRequestReward(params.questId);
        } else if (!params.isCrossGame) {
            questsObj.claimInGameQuestReward(params.questId);
        } else {
            questsObj.claimCrossGameQuestReward(params);
        }
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(), (!params.popupView) ? xpromoConstantsObj.TRACK_QUEST_CENTER : xpromoConstantsObj.TRACK_DAILY_QUEST, params.questId + "", constantsObj.TRACK_COLLECT, params.reward + "", "1", "");
        //avoiding redraw call after claim
        var loopIndex = params.loopIndex;
        loopIndex = questCenterLayer.indexParamsToVisibleTrack[loopIndex];
        var questId = questCenterLayer.questIdFromVisibleIndex[loopIndex];
        // var questType = questsObj.getCurQuestData(questId).qt;
        // TODO: This flow is not ready to be turned on - requires things to be handled regarding curQuest data.
        // questCenterLayer.removeQuestAtIndex(params.loopIndex, questId, questType);
        utilObj.delayedCallback(questCenterLayer, questCenterLayer.resetCoinAnimRunning, 0.5, null, false);
        //avoiding redraw call after claim
        //deleted code
        if(curScreen == constantsObj.SCREEN_QUEST_CENTER) {
            questCenterLayer.redraw();
        }
        //deleted code
    },

    openMfsAsk: function (msgType, invite_flag) {
        if (msgType == undefined && invite_flag == undefined) {
            msgType = constantsObj.INVITE;
            invite_flag = false;
        }
        xPromoGameSpecificObj.setRequestCount(0);
        questCenterLayer.hide();
        gameLayer.hide();
        mfsLayer.checkAndShow(msgType, constantsObj.SCREEN_QUEST_CENTER, questCenterLayer);
    },

    openGameLayer: function (questType) {
        if (curScreen == constantsObj.SCREEN_GAME) {
            return;
        }
        if (questsObj.getQuestCenterLastScreen() != null && (xPromoGameSpecificObj.isDigraphAvailable() && questsObj.getQuestCenterLastScreen() == constantsObj.SCREEN_DIGRAPH_GAME) && xpromoConstantsObj.QUEST_TYPES_QC_NORMAL_REDIRECT.indexOf(questType) == -1) {
            if (digraphGameLayer.puzzleIndex == undefined) {
                digraphGameLayer.puzzleIndex = subDigraphObj.getCurWeekPuzProgress() - 1;
                digraphGameLayer.show(subDigraphObj.puzzleDataForCurWeek(digraphGameLayer.puzzleIndex));
            } else {
                digraphGameLayer.redraw();
            }
        } else {
            if (gameLayer.puzzleIndex == undefined) {
                xPromoGameSpecificObj.openCurrentIncompletedPuzzle();
            } else {
                gameLayer.redraw();
            }
        }
    },

    checkDailyQuestsLocked: function () {
        var days = xpromoGameRuntimeObj.getDailyQuestsDaysNonPayer();
        if (xPromoGameSpecificObj.getIsPayerUser()) {
            days = xpromoGameRuntimeObj.getDailyQuestsDaysPayer();
        }
        if (days <= 0) {
            return false;
        }
        if (dailyQuestsObj.isDailyQuestsEligibleDays()) {
            return false;
        }
        return true;
    },


    redirectToMiniGame: function () {
        if (epmObj.getChosenVariant(xpromoConstantsObj.EXP_WORDWARS_REQUESTS) == constantsObj.EXP_VAR_1) {
            questCenterLayer.hide();
            wordWarsRequestLayer.show(constantsObj.SCREEN_QUEST_CENTER);
        } else if (epmObj.getChosenVariant(xpromoConstantsObj.EXP_WORDWARS_REQUESTS) == constantsObj.EXP_VAR_2) {
            var requestData = requestsObj.getCurrentActiveRequest();
            if (requestData.status == xpromoConstantsObj.REQUEST_NOT_STARTED) {
                requestsObj.updateRequestStatus(requestData, xpromoConstantsObj.REQUEST_STARTED);
            }
            wordWarsRequestLayer.redirectToWordWars();
        }
    },

    resetButtonClickable: function () {
        questCenterLayer.isbuttonClickable = true;
    },

    resetCoinAnimRunning: function () {
        questCenterLayer.isCoinGrantAnimRunning = false;
    },

    ////////////////////////////////////////////////////////////////////
    //functions in add quest function
    showFtueBgIcons: function () {
        if (questCenterLayer.isDailyQuestFtue == true) {
            questCenterLayer.paramsMap["scrollViewWidth"] += questCenterLayer.paramsMap["dailyQuestsXShift"];
            questCenterLayer.paramsMap["levelXPos"] = 160;
        }
        questCenterLayer.paramsMap["levelsBg"] = utilObj.getScale9Sprite(xpromoConstantsObj.xpromo_bg_box, questCenterLayer.paramsMap["centerX"], centerYPos + 863 + questCenterLayer.paramsMap["bezelShift"], 0.5, 0.5, questCenterLayer.paramsMap["scrollViewWidth"], questCenterLayer.paramsMap["levelElementHeight"], questCenterLayer.paramsMap["spriteArr"], questCenterLayer, constantsObj.FTUE_Z_ORDER, xpromoConstantsObj.SPRITE_QUESTS);
        utilObj.setColor(questCenterLayer.paramsMap["levelsBg"], questCenterLayer.paramsMap["levelsBgColor"]);
        questCenterLayer.paramsMap["levelIcon"] = utilObj.getSprite(questCenterLayer.paramsMap["gameIcon"], questCenterLayer.paramsMap["levelXPos"], centerYPos + 863 + questCenterLayer.paramsMap["bezelShift"], 0.5, 0.5, questCenterLayer.paramsMap["spriteScaling"], questCenterLayer.paramsMap["spriteArr"], questCenterLayer, constantsObj.FTUE_Z_ORDER, xpromoConstantsObj.SPRITE_QUESTS);
        var questDescLabel;
        if (questCenterLayer.paramsMap["noOfLines"] == 1) {
            questDescLabel = utilObj.getBMFontLabel(questCenterLayer.paramsMap["questDesc"], constantsObj.FONT_SFCOMPACT_MEDIUM_50, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), questCenterLayer.paramsMap["levelXPos"] + 140, centerYPos + 885 + questCenterLayer.paramsMap["bezelShift"], 0, 1.0, questCenterLayer.paramsMap["labelArr"], questCenterLayer, constantsObj.FTUE_Z_ORDER);
        } else {
            questDescLabel = utilObj.getBMFontLabel(questCenterLayer.paramsMap["questDesc"], constantsObj.FONT_SFCOMPACT_MEDIUM_50, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), questCenterLayer.paramsMap["levelXPos"] + 140, centerYPos + 915 + questCenterLayer.paramsMap["bezelShift"], 0, 1.0, questCenterLayer.paramsMap["labelArr"], questCenterLayer, constantsObj.FTUE_Z_ORDER);
        }
        if (questCenterLayer.isDailyQuestFtue == true) {
            questCenterLayer.paramsMap["scrollViewWidth"] -= questCenterLayer.paramsMap["dailyQuestsXShift"];
            questCenterLayer.paramsMap["levelXPos"] = 160 + questCenterLayer.paramsMap["dailyQuestsXShift"] / 2;
        }
        if (questCenterLayer.paramsMap["shouldFade"]) {
            utilObj.setOpacity(questDescLabel, 0);
            utilObj.delayedCallback(questCenterLayer.paramsMap["layer"], xpromoAnimationObj.animateQuestParticles, 3.2, {"node": questDescLabel}, false);
        }
    },

    addDailyQuestTimeLeft: function () {
        var curTimestamp = utilObj.getCurrentTimestamp();
        if (questCenterLayer.paramsMap["timeLimit"] != undefined && questCenterLayer.paramsMap["timeLimit"] != null && questCenterLayer.paramsMap["timeLimit"] != 0 && questCenterLayer.paramsMap["params"] != undefined && questCenterLayer.paramsMap["params"] != null) {
            if (questCenterLayer.paramsMap["params"][1] != undefined && questCenterLayer.paramsMap["params"][1] != null) {
                var timerBarValue = parseInt(questCenterLayer.paramsMap["params"][1]) + parseInt(questCenterLayer.paramsMap["timeLimit"]) - curTimestamp;
                var timerParams = {
                    startTime: questCenterLayer.paramsMap["params"][1],
                    timeLimit: questCenterLayer.paramsMap["timeLimit"],
                    lbl: questCenterLayer.paramsMap["dailyTimerLbl"],
                    lock: 0
                };
                questCenterLayer.dailyQuestTimerParam = timerParams;
                var dailyTimerStr = xpromoUtilObj.formatTimeHrMin(xpromoUtilObj.getTimeLeftForDayComplete());
                utilObj.setString(questCenterLayer.paramsMap["dailyTimerLbl"], dailyTimerStr + "Left");
            }
        }
    },

    addButtons: function (expXpromoDq) {
        var xShiftBtn = 25;
        var xPosBtn, factorBtn, yPos;
        factorBtn = questCenterLayer.paramsMap["listYPos"] - questCenterLayer.paramsMap["levelElementHeight"] / 2;
        //Ensures uniform button placement for DQ and replacement quests
        if (dailyQuestsObj.isDailyQuestOrStreakQuest(questCenterLayer.paramsMap["questType"]) || dailyQuestsObj.isDailyQuestReplacement(questCenterLayer.paramsMap["questId"]) || ((expXpromoDq == constantsObj.EXP_VAR_1 || expXpromoDq == constantsObj.EXP_VAR_2) && (questCenterLayer.paramsMap["questType"].indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0 || questCenterLayer.paramsMap["questType"].indexOf(xpromoConstantsObj.QUEST_TYPE_SECONDARY_QUEST_LEVEL) == 0))) {
            xPosBtn = questCenterLayer.paramsMap["scrollViewWidth"] - 100;
            yPos = 0.90;
        } else {
            xPosBtn = questCenterLayer.paramsMap["scrollViewWidth"] - 130;
            yPos = 0.80;
        }
        var yReference = questCenterLayer.paramsMap["listYPos"] - questCenterLayer.paramsMap["levelElementHeight"] / 2;
        var transButton = utilObj.getButton(questCenterLayer.paramsMap["scrollViewWidth"], questCenterLayer.paramsMap["btnHeight"] * yPos, 0.5, 0.5, (questCenterLayer.paramsMap["scrollViewWidth"] / 2), yReference, questCenterLayer.paramsMap["btnImg"], questCenterLayer.paramsMap["btnImg"], questCenterLayer.paramsMap["btnImg"], {
            obj: 'questCenterLayer',
            fn: questCenterLayer.paramsMap["clickAction"],
            screen: questCenterLayer.screen,
            params: {
                "status": questCenterLayer.paramsMap["questStatus"],
                "qt": questCenterLayer.paramsMap["questType"],
                "questId": questCenterLayer.paramsMap["questId"],
                "firstParam": questCenterLayer.paramsMap["firstParam"],
                "itunesId": questCenterLayer.paramsMap["itunesId"],
                "isCrossGame": questCenterLayer.paramsMap["isCrossGame"],
                "reward": questCenterLayer.paramsMap["rewardValue"],
                "showReward": questCenterLayer.paramsMap["showReward"],
                "isRequest": questCenterLayer.paramsMap["isRequest"],
                "isSocialQuest": questCenterLayer.paramsMap["isSocialQuest"],
                "trackingId": questCenterLayer.paramsMap["trackingId"],
                "gameHosted": questCenterLayer.paramsMap["gameHostedIn"],
                "engagementType": questCenterLayer.paramsMap["engagementType"],
                "curProgress": questCenterLayer.paramsMap["curProgress"],
                "isLoopbackEngagement": questCenterLayer.paramsMap["isLoopbackEngagement"],
                "bucket": questCenterLayer.paramsMap["bucket"],
                "loopIndex": questCenterLayer.paramsMap["loopIndex"],
                "description" : questCenterLayer.paramsMap["questDesc"]
            },
            track: {
                k: constantsObj.TRACK_DIALOG,
                p: xPromoGameSpecificObj.getPhylumForTracking(),
                c: xPromoGameSpecificObj.getClassForTracking(),
                o: xpromoConstantsObj.TRACK_QUEST_CENTER,
                f: questCenterLayer.paramsMap["questId"] + "",
                g: constantsObj.TRACK_CLICK,
                s: questCenterLayer.paramsMap["rewardValue"] + "",
                co: 1,
                oppId: ""
            },
            child: [],
            feedBackType: constantsObj.NORMALBTN_FEEDBACK
        }, false, ccui.Widget.PLIST_TEXTURE, questCenterLayer.paramsMap["btnScaling"]);
        questCenterLayer.actionButton[questCenterLayer.paramsMap["loopIndex"]] = transButton;
        if (questCenterLayer.paramsMap["shouldFade"]) {
            utilObj.setOpacity(questCenterLayer.actionButton[questCenterLayer.paramsMap["loopIndex"]], 0);
            utilObj.delayedCallback(questCenterLayer.paramsMap["layer"], xpromoAnimationObj.animateQuestParticles, 3.2, {"node": questCenterLayer.actionButton[questCenterLayer.paramsMap["loopIndex"]]}, false);
        }

        var imageQuest =utilObj.getButton(320, 180, 0.5, 0.5, xPosBtn - xShiftBtn, factorBtn, questConfigObj.getConfigData("btn_180_local"), questConfigObj.getConfigData("btn_180_local"), questConfigObj.getConfigData("btn_180_local"), {
            obj: "questCenterLayer",
            fn: '',
            screen: questCenterLayer.screen
        }, false, questConfigObj.getConfigData("btn_180_texture_local"), 1);
        questCenterLayer.paramsMap["layer"].addChild(imageQuest, questCenterLayer.paramsMap["zOrder"]);

        // var imageQuest = utilObj.getScale9Sprite(questConfigObj.getConfigData("btn_180_local"), xPosBtn - xShiftBtn, factorBtn, 0.5, 0.5, 320, 180, paramsMap["spriteArr"], paramsMap["layer"], paramsMap["zOrder"], constantsObj.SPRITE_LOCAL);
        var buttonOutline = utilObj.getSprite(constantsObj.btn_outline_1, xPosBtn - xShiftBtn, factorBtn, 0.5, 0.5, constantsObj.SCALE_SPRITE_12 * constantsObj.SPRITE_SCALING_FACTOR, questCenterLayer.paramsMap["spriteArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["zOrder"], questConfigObj.getConfigData("SPRITE_MISC"));

        questCenterLayer.addUiReferenceForQuest(questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["loopIndex"], "transButton", transButton);
        questCenterLayer.addUiReferenceForQuest(questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["loopIndex"], "button", imageQuest);
        questCenterLayer.addUiReferenceForQuest(questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["loopIndex"], "buttonOutline", buttonOutline);
        questCenterLayer.updateButtonsForQuest(questCenterLayer.paramsMap["loopIndex"], questCenterLayer.paramsMap["questId"], imageQuest, buttonOutline, questCenterLayer.paramsMap["shouldFade"], questCenterLayer.paramsMap["shouldDisplayUIHere"]);
    },

    addButtonsToLayer: function () {
        if (ftueObj.shouldFtueBeShown() && questCenterLayer.ftueShownNum == ftueObj.FTUE_QUEST_CLAIM && questCenterLayer.paramsMap["questStatus"] == xpromoConstantsObj.QUEST_COMPLETED && questCenterLayer.paramsMap["availableGameQuests"][questCenterLayer.paramsMap["loopIndex"]].id == questsObj.getQuestCompleteId()) {
            questCenterLayer.addChild(questCenterLayer.ftueActionBtn, constantsObj.FTUE_Z_ORDER + 2);
        } else if (questCenterLayer.paramsMap["questStatus"] != xpromoConstantsObj.QUEST_CLAIMED && questCenterLayer.paramsMap["shouldDisplayUIHere"] == 1) {
            questCenterLayer.scrollView.addChild(questCenterLayer.actionButton[questCenterLayer.paramsMap["loopIndex"]], questCenterLayer.paramsMap["listZOrder"] + 1);
        }
    },

    ftueClaimRewardUi: function () {
        utilObj.getBMFontLabel(stringsObj.claim, constantsObj.FONT_SFCOMPACT_MEDIUM_60, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), questCenterLayer.paramsMap["btnWidth"] / 2, questCenterLayer.paramsMap["btnHeight"] - 50, 0.5, 0.5, questCenterLayer.paramsMap["labelArr"], questCenterLayer.ftueActionBtn, constantsObj.FTUE_Z_ORDER);
        utilObj.getSprite(questConfigObj.getConfigData("icon_coins"), questCenterLayer.paramsMap["btnWidth"] / 2 - 70, questCenterLayer.paramsMap["btnHeight"] / 2 - 20, 0, 0.5, constantsObj.SCALE_SPRITE_10, questCenterLayer.paramsMap["spriteArr"], questCenterLayer.ftueActionBtn, constantsObj.FTUE_Z_ORDER, questConfigObj.getConfigData("SPRITE_MISC"));
        questCenterLayer.paramsMap["rewardTxtLbl"] = utilObj.getBMFontLabel(questCenterLayer.paramsMap["rewardValue"] + "", constantsObj.FONT_SFCOMPACT_MEDIUM_60, questCenterLayer.paramsMap["rewardTextColor"],
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), questCenterLayer.paramsMap["btnWidth"] / 2 + 10, questCenterLayer.paramsMap["btnHeight"] / 2 - 20, 0, 0.5, questCenterLayer.paramsMap["labelArr"], questCenterLayer.ftueActionBtn, constantsObj.FTUE_Z_ORDER);
        var bucketCount = questCenterLayer.questsCountInBucket[questCenterLayer.paramsMap["bucket"]];
        if (bucketCount != undefined && bucketCount != null && parseInt(bucketCount) > 0) {
            var notifXPos = questCenterLayer.ftueActionBtn.getContentSize().width * 0.82;
            var notifYPos = questCenterLayer.ftueActionBtn.getContentSize().height - 20;
            var countNotifCircle = utilObj.getSprite(xpromoConstantsObj.jewel_notif, notifXPos, notifYPos, 0.5, 0.5, constantsObj.SCALE_ONE_POINT_SIX, questCenterLayer.paramsMap["spriteArr"], questCenterLayer.ftueActionBtn, 1, questConfigObj.getConfigData("SPRITE_MISC"));
            var notifLbl = utilObj.getBMFontLabel(bucketCount + "", constantsObj.FONT_SFCOMPACT_REGULAR_50, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), notifXPos, notifYPos + 2, 0.5, 0.5, questCenterLayer.paramsMap["labelArr"], questCenterLayer.ftueActionBtn, 2);
            utilObj.setScale(notifLbl, 0.8);
        }
        if (questCenterLayer.paramsMap["shouldFade"]) {
            utilObj.setOpacity(questCenterLayer.paramsMap["rewardTxtLbl"], 0);
            utilObj.delayedCallback(questCenterLayer.paramsMap["layer"], xpromoAnimationObj.animateQuestParticles, 3.2, {"node": questCenterLayer.paramsMap["rewardTxtLbl"]}, false);
        }
    },

    getDailyQuestsLayout: function () {
        if (questCenterLayer.isDailyQuestFtue == true) {
            questCenterLayer.dailyQuestsCount -= 1;
        }
        var yReference;
        var zOrderOfBg;
        if (questCenterLayer.dailyQuestsLocked) {
            yReference = questCenterLayer.paramsMap["listYPos"];
            var lockedBg = utilObj.getScale9Sprite(xpromoConstantsObj.xpromo_bg_box, questCenterLayer.paramsMap["centerX"], yReference, 0.5, 1.0, questCenterLayer.paramsMap["scrollViewWidth"], questCenterLayer.paramsMap["levelElementHeight"], questCenterLayer.paramsMap["spriteArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["bgZOrder"], xpromoConstantsObj.SPRITE_QUESTS);
            utilObj.setColor(lockedBg, constantsObj.COLOR_DAILY_QUESTS_BG);

            utilObj.getSprite(xpromoConstantsObj.calender_2, 160, yReference - (questCenterLayer.paramsMap["levelElementHeight"] / 2), 0.5, 0.5, 1.1 * constantsObj.SPRITE_SCALING_FACTOR, questCenterLayer.paramsMap["spriteArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["listZOrder"], xpromoConstantsObj.SPRITE_QUESTS);

            utilObj.getBMFontLabel(xpromoStringsObj.daily_quests, constantsObj.FONT_SFCOMPACT_REGULAR_60, constantsObj.COLOR_WHITE, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 300, yReference - (questCenterLayer.paramsMap["levelElementHeight"] / 2) + 70, 0, 1.0, questCenterLayer.paramsMap["labelArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["bgZOrder"]);

            var clockLocal = utilObj.getSprite(constantsObj.clock, 300, yReference - (questCenterLayer.paramsMap["levelElementHeight"] / 2) - 15, 0, 1.0, 1.8, questCenterLayer.paramsMap["spriteArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["listZOrder"], questConfigObj.getConfigData("SPRITE_MISC"));

            var clockSize = utilObj.getContentSize(clockLocal);
            var unlockLbl = utilObj.getBMFontLabel(stringsObj.unlock_in, constantsObj.FONT_SFCOMPACT_REGULAR_50, constantsObj.COLOR_WHITE, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 300 + clockSize.width + 40, yReference - (questCenterLayer.paramsMap["levelElementHeight"] / 2) - 25 - (clockSize.height / 2), 0, 0.5, questCenterLayer.paramsMap["labelArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["bgZOrder"]);
            var unlockTimerLbl = utilObj.getBMFontLabel("", constantsObj.FONT_SFCOMPACT_REGULAR_50, constantsObj.COLOR_WHITE, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 300 + clockSize.width + 40 + utilObj.getContentSize(unlockLbl).width - 20, yReference - (questCenterLayer.paramsMap["levelElementHeight"] / 2) - 25 - (clockSize.height / 2), 0, 0.5, questCenterLayer.paramsMap["labelArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["bgZOrder"]);

            var days = xpromoGameRuntimeObj.getDailyQuestsDaysNonPayer();
            if (xPromoGameSpecificObj.getIsPayerUser()) {
                days = xpromoGameRuntimeObj.getDailyQuestsDaysPayer();
            }

            var installTime = xPromoGameSpecificObj.getInstallTimeStamp();
            var dayCur = new Date(installTime * 1000);
            var dqLockLimit = constantsObj.SECONDS_IN_DAY - (dayCur.getHours() * 60 * 60 + dayCur.getMinutes() * 60 + dayCur.getSeconds()) + (days - 1) * constantsObj.SECONDS_IN_DAY;
            var unlockTimerBarValue = parseInt(installTime) + parseInt(dqLockLimit) - utilObj.getCurrentTimestamp();
            var timerParam = {startTime: installTime, timeLimit: (dqLockLimit), lbl: unlockTimerLbl, lock: 1};
            questCenterLayer.dailyQuestTimerParam = timerParam;
            var dailyTimerStr = xpromoUtilObj.formatTimeHrMin(unlockTimerBarValue);
            utilObj.setString(unlockTimerLbl, dailyTimerStr);

            utilObj.getSprite(constantsObj.lock_2, questCenterLayer.paramsMap["scrollViewWidth"] - 170 + xRightPosErr / 2, yReference - (questCenterLayer.paramsMap["levelElementHeight"] / 2), 0.5, 0.5, 1.1 * constantsObj.SPRITE_SCALING_FACTOR, questCenterLayer.paramsMap["spriteArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["listZOrder"], questConfigObj.getConfigData("SPRITE_MISC"));

            questCenterLayer.scrollViewLocalYPos -= questCenterLayer.paramsMap["levelElementHeight"];

            return 1;
        }

        if (questCenterLayer.dailyQuestsCount == 0) {
            return 1;
        }

        yReference = questCenterLayer.paramsMap["listYPos"];
        zOrderOfBg = questCenterLayer.paramsMap["bgZOrder"] - 1;
        questCenterLayer.paramsMap["dailyQuestsXShift"] = xpromoConstantsObj.DAILY_QUESTS_PADDING_LEFT + xpromoConstantsObj.DAILY_QUESTS_PADDING_RIGHT;
        questCenterLayer.dailyQuestsXShift = questCenterLayer.paramsMap["dailyQuestsXShift"];
        var dailyQuestsBgHeight = questCenterLayer.dailyQuestsCount * questCenterLayer.levelElementHeight + xpromoConstantsObj.DAILY_QUESTS_PADDING_TOP + xpromoConstantsObj.DAILY_QUESTS_PADDING_BOTTOM +
            (questCenterLayer.dailyQuestsCount - 1) * questCenterLayer.listItemsMargin;
        var dailyQuestsBg = utilObj.getScale9Sprite(constantsObj.white_extra_rounded, questCenterLayer.paramsMap["centerX"], yReference, 0.5, 1.0, questCenterLayer.paramsMap["scrollViewWidth"], dailyQuestsBgHeight,
            questCenterLayer.paramsMap["spriteArr"], questCenterLayer.paramsMap["layer"], zOrderOfBg, questConfigObj.getConfigData("SPRITE_MISC"));
        utilObj.setColor(dailyQuestsBg, constantsObj.COLOR_DAILY_QUESTS_BG);

        utilObj.getSprite(constantsObj.calendar, questCenterLayer.paramsMap["centerX"] - 180, yReference - 50, 0.5, 0.5, constantsObj.SPRITE_SCALING_FACTOR, questCenterLayer.paramsMap["spriteArr"], questCenterLayer.paramsMap["layer"],
            questCenterLayer.paramsMap["listZOrder"] + 5, questConfigObj.getConfigData("SPRITE_MISC"));
        utilObj.getBMFontLabel(xpromoStringsObj.daily_quests, constantsObj.FONT_SFCOMPACT_MEDIUM_60, constantsObj.COLOR_WHITE, constantsObj.LABEL_AUTO_WIDTH,
            cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), questCenterLayer.paramsMap["centerX"] + 30, yReference - 50, 0.5, 0.5, questCenterLayer.paramsMap["labelArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["listZOrder"]);

        questCenterLayer.paramsMap["clock"] = utilObj.getSprite(constantsObj.clock, questCenterLayer.paramsMap["centerX"] - 115, yReference - 120, 0.5, 0.5, constantsObj.SPRITE_SCALING_FACTOR, questCenterLayer.paramsMap["spriteArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["listZOrder"], questConfigObj.getConfigData("SPRITE_MISC"));
        utilObj.setColor(questCenterLayer.paramsMap["clock"], constantsObj.COLOR_GREY_09);
        questCenterLayer.paramsMap["dailyTimerLbl"] = utilObj.getBMFontLabel("", constantsObj.FONT_SFCOMPACT_MEDIUM_40, constantsObj.COLOR_WHITE, constantsObj.LABEL_AUTO_WIDTH,
            cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), questCenterLayer.paramsMap["centerX"] + 30, yReference - 120, 0.5, 0.5, questCenterLayer.paramsMap["labelArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["listZOrder"]);
        utilObj.setColor(questCenterLayer.paramsMap["dailyTimerLbl"], constantsObj.COLOR_GREY_09);

        questCenterLayer.paramsMap["moreQuestsTomorrowLbl"] = utilObj.getBMFontLabel(stringsObj.more_quests_tomorrow, constantsObj.FONT_SFCOMPACT_MEDIUM_40, constantsObj.COLOR_WHITE, constantsObj.LABEL_AUTO_WIDTH,
            cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), questCenterLayer.paramsMap["centerX"], yReference - 120, 0.5, 0.5, questCenterLayer.paramsMap["labelArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["listZOrder"]);
        utilObj.setColor(questCenterLayer.paramsMap["moreQuestsTomorrowLbl"], constantsObj.COLOR_GREY_09);
        utilObj.setVisible(questCenterLayer.paramsMap["moreQuestsTomorrowLbl"], false);

        questCenterLayer.paramsMap["scrollViewWidth"] -= questCenterLayer.paramsMap["dailyQuestsXShift"];
        questCenterLayer.paramsMap["listYPos"] -= xpromoConstantsObj.DAILY_QUESTS_PADDING_TOP;
        return 0;
    },

    excludeQuestinThisCall: function (expXpromoDq) {
        //Ensures that in claimed state the replacement quest gets tickmark
        if (questCenterLayer.paramsMap["questStatus"] == xpromoConstantsObj.QUEST_CLAIMED && !dailyQuestsObj.isDailyQuestOrStreakQuest(questCenterLayer.paramsMap["questType"]) && !dailyQuestsObj.isDailyQuestReplacement(questCenterLayer.paramsMap["questId"])) {
            if (!(questCenterLayer.paramsMap["questType"].indexOf(xpromoConstantsObj.QUEST_TYPE_SECONDARY_QUEST_LEVEL) == 0 && (expXpromoDq == constantsObj.EXP_VAR_1 || expXpromoDq == constantsObj.EXP_VAR_2))) {
                return 1;
            }
        }
        if ((questCenterLayer.paramsMap["questType"].indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0 || questCenterLayer.paramsMap["questType"].indexOf(xpromoConstantsObj.QUEST_TYPE_SECONDARY_QUEST_LEVEL) == 0) && (expXpromoDq == constantsObj.EXP_VAR_1 || expXpromoDq == constantsObj.EXP_VAR_2)) {
            if (questCenterLayer.paramsMap["getDailyQuests"] == 0) {
                return 1;
            }
        } else {
            //Ensures that the replacement quest is counted with DQ and not with normal Quests
            if (questCenterLayer.paramsMap["getDailyQuests"] == 1) {
                if (!dailyQuestsObj.isDailyQuestOrStreakQuest(questCenterLayer.paramsMap["questType"]) && !dailyQuestsObj.isDailyQuestReplacement(questCenterLayer.paramsMap["questId"])){
                    return 1;
                }
            } else {
                if (dailyQuestsObj.isDailyQuestOrStreakQuest(questCenterLayer.paramsMap["questType"]) ||  dailyQuestsObj.isDailyQuestReplacement(questCenterLayer.paramsMap["questId"])) {
                    return 1;
                }
            }
        }
        return 0;
    },

    addFtueActionBtn: function () {
        questCenterLayer.ftueActionBtn = utilObj.getButton(questCenterLayer.paramsMap["btnWidth"], questCenterLayer.paramsMap["btnHeight"], 0.5, 0.5,
            centerXPos + canvasWidth / 2 - 248 + questCenterLayer.paramsMap["bezelXShift"], centerYPos + 863 + questCenterLayer.paramsMap["bezelShift"], questConfigObj.getConfigData("btn_180_local"), questConfigObj.getConfigData("btn_180_local"), questConfigObj.getConfigData("btn_180_local"), {
                obj: 'questCenterLayer',
                fn: questCenterLayer.paramsMap["clickAction"],
                screen: questCenterLayer.screen,
                params: {
                    "status": questCenterLayer.paramsMap["questStatus"],
                    "qt": questCenterLayer.paramsMap["questType"],
                    "questId": questCenterLayer.paramsMap["questId"],
                    "firstParam": questCenterLayer.paramsMap["firstParam"],
                    "itunesId": questCenterLayer.paramsMap["itunesId"],
                    "pkgName": pkgName,
                    "isCrossGame": questCenterLayer.paramsMap["isCrossGame"],
                    "reward": questCenterLayer.paramsMap["rewardValue"],
                    "showReward": questCenterLayer.paramsMap["showReward"],
                    "index": questCenterLayer.paramsMap["loopIndex"],
                    "isRequest": questCenterLayer.paramsMap["isRequest"],
                    "isSocialQuest": questCenterLayer.paramsMap["isSocialQuest"],
                    "trackingId": questCenterLayer.paramsMap["trackingId"],
                },
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: xPromoGameSpecificObj.getPhylumForTracking(),
                    c: xPromoGameSpecificObj.getClassForTracking(),
                    o: xpromoConstantsObj.TRACK_QUEST_CENTER,
                    f: questCenterLayer.paramsMap["questId"] + "",
                    g: constantsObj.TRACK_CLICK,
                    s: questCenterLayer.paramsMap["rewardValue"] + "",
                    co: 1,
                    oppId: ""
                },
                child: [],
                feedBackType: constantsObj.NORMALBTN_FEEDBACK
            }, false, ccui.Widget.LOCAL_TEXTURE, 1);
        questCenterLayer.ftueActionBtn.setColor(questCenterLayer.paramsMap["btnColor"]);
        animationObj.pulseButton(questCenterLayer.ftueActionBtn, 0, 0);
    },
    ////////////////////////////////////////////////////////////////////
    //functions in show function
    showUserCashAndCoins: function () {
        var coinXPos = xRightPos + constantsObj.BEZEL_SAFE_AREA / 4 - 150;
        var headerCenterY = constantsObj.DESIGN_HEIGHT - 75 - headerShift;

        var userCash = economyObj.getCash();
        if (userCash > 999 && userCash < 10000) {
            gameLayer.coinsLbl = utilObj.getBMFontLabel(userCash + "", constantsObj.FONT_SFCOMPACT_MEDIUM_60, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), coinXPos + 10, headerCenterY, 0.5, 0.5, questCenterLayer.paramsMap["labelArr"], questCenterLayer, questCenterLayer.paramsMap["zOrder"], constantsObj.TAG_COINS);

        } else if (userCash > 9999) {
            gameLayer.coinsLbl = utilObj.getBMFontLabel(userCash + "", constantsObj.FONT_SFCOMPACT_MEDIUM_50, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), coinXPos + 20, headerCenterY, 0.5, 0.5, questCenterLayer.paramsMap["labelArr"], questCenterLayer, questCenterLayer.paramsMap["zOrder"], constantsObj.TAG_COINS);

        } else {
            gameLayer.coinsLbl = utilObj.getBMFontLabel(userCash + "", constantsObj.FONT_SFCOMPACT_MEDIUM_60, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), coinXPos, headerCenterY, 0.5, 0.5, questCenterLayer.paramsMap["labelArr"], questCenterLayer, questCenterLayer.paramsMap["zOrder"], constantsObj.TAG_COINS);
        }

        var questLabel = utilObj.getBMFontLabel(stringsObj.quest_center, constantsObj.FONT_SFCOMPACT_MEDIUM_100, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos + 50, headerCenterY - 30 + headerShift, 0.5, 0.5, questCenterLayer.paramsMap["labelArr"], questCenterLayer, questCenterLayer.paramsMap["zOrder"]);

        utilObj.getSprite(constantsObj.icon_quest_center, questLabel.getPositionX() - 360, headerCenterY - 30 + headerShift, 0.5, 0.5, constantsObj.SCALE_SPRITE_11, questCenterLayer.paramsMap["spriteArr"], questCenterLayer, questCenterLayer.paramsMap["zOrder"], questConfigObj.getConfigData("SPRITE_MISC"));

        var coinsLabel = utilObj.getBMFontLabel(stringsObj.earn_extra_coins, constantsObj.FONT_SFCOMPACT_MEDIUM_70, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, headerCenterY - 130 + headerShift, 0.5, 0.5, questCenterLayer.paramsMap["labelArr"], questCenterLayer, questCenterLayer.paramsMap["zOrder"]);
        utilObj.getSprite(questConfigObj.getConfigData("icon_coins"), coinsLabel.getPositionX() + 290, headerCenterY - 130 + headerShift, 0.5, 0.5, constantsObj.SCALE_SPRITE_10, questCenterLayer.paramsMap["spriteArr"], questCenterLayer, questCenterLayer.paramsMap["zOrder"], questConfigObj.getConfigData("SPRITE_MISC"));

    },

    addScrollViewProperties: function (scrollViewHeight) {
        questCenterLayer.scrollView = new ccui.ScrollView();
        questCenterLayer.scrollView.setDirection(ccui.ScrollView.DIR_VERTICAL);
        questCenterLayer.scrollView.setTouchEnabled(true);
        questCenterLayer.scrollView.setBounceEnabled(false);
        questCenterLayer.scrollView.setScrollBarEnabled(false);
        questCenterLayer.scrollView.setInertiaScrollEnabled(true);
        if (scrollViewHeight < constantsObj.DESIGN_HEIGHT - xpromoConstantsObj.HEADER_HEIGHT_QUEST_CENTER) {
            questCenterLayer.scrollView.setContentSize(cc.size(canvasWidth + widthErr, constantsObj.DESIGN_HEIGHT - xpromoConstantsObj.HEADER_HEIGHT_QUEST_CENTER));
            questCenterLayer.scrollView.setInnerContainerSize(cc.size(canvasWidth + widthErr, scrollViewHeight));
        } else {
            questCenterLayer.scrollView.setContentSize(cc.size(canvasWidth + widthErr, constantsObj.DESIGN_HEIGHT - xpromoConstantsObj.HEADER_HEIGHT_QUEST_CENTER));
            questCenterLayer.scrollView.setInnerContainerSize(cc.size(canvasWidth + widthErr, scrollViewHeight));
        }

        questCenterLayer.scrollView.setAnchorPoint(cc.p(0.5, 1.0));
        questCenterLayer.scrollView.setPosition(centerXPos, constantsObj.DESIGN_HEIGHT - xpromoConstantsObj.HEADER_HEIGHT_QUEST_CENTER - 50);
        questCenterLayer.scrollView.addEventListener(function (scope, eventType) {
            questCenterLayer.scrollViewPos = questCenterLayer.scrollView.getInnerContainerPosition();
            questCenterLayer.scrollViewYPos = Math.abs(questCenterLayer.scrollViewPos.y);
        });
        if (scrollViewHeight < constantsObj.DESIGN_HEIGHT - xpromoConstantsObj.HEADER_HEIGHT_QUEST_CENTER) {
            questCenterLayer.innerContainerYPos = 0;
            questCenterLayer.scrollViewYPos = 0;
        } else {
            questCenterLayer.innerContainerYPos = Math.abs(questCenterLayer.scrollView.getInnerContainerPosition().y);
            questCenterLayer.scrollViewYPos = questCenterLayer.innerContainerYPos;
        }
    },

    showHeaderArea: function () {
        var headerBg = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, questCenterLayer.paramsMap["localYPos"] + constantsObj.BEZEL_SAFE_AREA, 0.5, 1, canvasWidth + widthErr, xpromoConstantsObj.HEADER_HEIGHT_QUEST_CENTER + 2 * constantsObj.BEZEL_SAFE_AREA, questCenterLayer.paramsMap["spriteArr"],
            questCenterLayer, constantsObj.BG_Z_ORDER, questConfigObj.getConfigData("SPRITE_MISC"));
        headerBg.setColor(constantsObj.COLOR_HEADER_BG_1);

        var backgroundImg = utilObj.getScale9Sprite(constantsObj.tile_white, 0, constantsObj.DESIGN_HEIGHT - xpromoConstantsObj.HEADER_HEIGHT_QUEST_CENTER, 0, 1, canvasWidth + widthErr, constantsObj.DESIGN_HEIGHT, questCenterLayer.paramsMap["spriteArr"],
            questCenterLayer, constantsObj.BG_Z_ORDER, questConfigObj.getConfigData("SPRITE_MISC"));
        backgroundImg.setColor(constantsObj.COLOR_WHITE);

        questCenterLayer.paramsMap["localYPos"] -= xpromoConstantsObj.HEADER_HEIGHT_QUEST_CENTER;

        var buttonProperties = questConfigObj.getConfigData("button_circular_properties");
        var headerSideSpacing = xLeftPos + 30;
        var headerCenterY = constantsObj.DESIGN_HEIGHT - buttonProperties[4] - headerShift;

        var backImg = utilObj.getSprite(questConfigObj.getConfigData("back"), headerSideSpacing + 55, headerCenterY, 0.5, 0.5, constantsObj.SCALE_SPRITE_1, questCenterLayer.paramsMap["spriteArr"], questCenterLayer, questCenterLayer.paramsMap["zOrder"] + 1, questConfigObj.getConfigData("SPRITE_MISC"));
        var childArr = [backImg];
        var backButton = utilObj.getButton(buttonProperties[0], buttonProperties[1], 0.5, 0.5,
            headerSideSpacing + 60, headerCenterY, questConfigObj.getConfigData("button_circular"), questConfigObj.getConfigData("button_circular"), questConfigObj.getConfigData("button_circular"), {
                obj: 'questCenterLayer',
                fn: 'back',
                screen: questCenterLayer.screen,
                params: {"sound": constantsObj.button_tap_01, "sound_on": true},
                track: {
                    k: questCenterLayer.paramsMap["screenName"],
                    p: xpromoConstantsObj.TRACK_COUNTRY,
                    c: xPromoGameSpecificObj.getPhylumForTracking(),
                    o: xPromoGameSpecificObj.getClassForTracking(),
                    f: constantsObj.TRACK_BACK,
                    g: "",
                    s: xPromoGameSpecificObj.getSpeciesForTracking(),
                    co: 1,
                    oppId: ""
                },
                child: childArr,
                feedBackType: constantsObj.ZOOMIN_FEEDBACK
            }, buttonProperties[2], ccui.Widget.PLIST_TEXTURE, buttonProperties[3]);
        questCenterLayer.addChild(backButton, questCenterLayer.paramsMap["zOrder"] + 1);

        var iconWidth = 250;
        var iconHeight = 100;
        var coinXPos = xRightPos + constantsObj.BEZEL_SAFE_AREA / 4 - 150;
        var headerBar1 = utilObj.getScale9Sprite(constantsObj.white_header_bar, coinXPos, headerCenterY, 0.5, 0.5, iconWidth, iconHeight, questCenterLayer.paramsMap["spriteArr"],
            questCenterLayer, constantsObj.BG_Z_ORDER, questConfigObj.getConfigData("SPRITE_MISC"));
        headerBar1.setColor(constantsObj.COLOR_HEADER_ICON_BG);

        questCenterLayer.headerCoins = utilObj.getSprite(questConfigObj.getConfigData("icon_coins"), coinXPos - 130, headerCenterY, 0.5, 0.5, constantsObj.SCALE_SPRITE_5, questCenterLayer.paramsMap["spriteArr"], questCenterLayer, constantsObj.BG_Z_ORDER, questConfigObj.getConfigData("SPRITE_MISC"));

        for (var i = 0; i < 5; i++) {
            questCenterLayer.centerCoinGrants[i] = utilObj.getSprite(questConfigObj.getConfigData("coin"), centerXPos, centerYPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_1, questCenterLayer.paramsMap["spriteArr"], questCenterLayer, constantsObj.FTUE_Z_ORDER + 1, questConfigObj.getConfigData("SPRITE_MISC"));
            utilObj.setVisible(questCenterLayer.centerCoinGrants[i], false);
        }
    },

    makeQuestDesc: function () {
        var noOfLines = 0;
        var textLine1 = "";
        var textLine2 = "";
        var textLine3 = "";
        if (utilObj.isStaging()) {
            //questCenterLayer.paramsMap["questDesc"] += " " + questCenterLayer.paramsMap["questId"] + " " + questCenterLayer.paramsMap["bucket"];
        }

        questCenterLayer.paramsMap["questDesc"] = utilObj.getSplitStringsArr(questCenterLayer.paramsMap["questDesc"], 25);

        noOfLines = questCenterLayer.paramsMap["questDesc"].length;

        if (noOfLines == 1) {
            textLine1 = questCenterLayer.paramsMap["questDesc"][0];
        } else if (noOfLines == 2) {
            textLine1 = questCenterLayer.paramsMap["questDesc"][0];
            textLine2 = questCenterLayer.paramsMap["questDesc"][1];
        } else {
            textLine1 = questCenterLayer.paramsMap["questDesc"][0];
            textLine2 = questCenterLayer.paramsMap["questDesc"][1];
            textLine3 = questCenterLayer.paramsMap["questDesc"][2];
        }

        questCenterLayer.paramsMap["questDesc"] = questCenterLayer.paramsMap["questDesc"] + " ";
        if (noOfLines == 2) {
            questCenterLayer.paramsMap["questDesc"] = textLine1 + "\n" + textLine2 + " ";
        }
        if (noOfLines == 3) {
            questCenterLayer.paramsMap["questDesc"] = textLine1 + "\n" + textLine2 + "\n" + textLine3 + " ";
        }
        questCenterLayer.paramsMap["noOfLines"] = noOfLines;
    },

    handlingButtonUI: function () {
        questCenterLayer.paramsMap["showReward"] = questCenterLayer.shouldShowReward(questCenterLayer.paramsMap["questType"], questCenterLayer.paramsMap["questId"]);
        questCenterLayer.paramsMap["btnImg"] = constantsObj.trans_button;
        // questCenterLayer.paramsMap["rewardTextColor"] = questCenterLayer.getRewardTextColor(questCenterLayer.paramsMap["questType"], questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["questStatus"]);
        // questCenterLayer.paramsMap["txtLblOpacity"] = questCenterLayer.getTxtLblOpacity(questCenterLayer.paramsMap["questType"], questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["questStatus"]);
        questCenterLayer.paramsMap["btnWidthScaling"] = constantsObj.BTN_HEIGHT_SCALING;
        questCenterLayer.paramsMap["btnScaling"] = constantsObj.BTN_SCALING;
        if (questCenterLayer.paramsMap["questStatus"] == xpromoConstantsObj.QUEST_COMPLETED) {
            questCenterLayer.paramsMap["currentProgressForQuest"] = questCenterLayer.paramsMap["reqProgressForQuest"];
            questCenterLayer.paramsMap["btnImg"] = constantsObj.trans_button;
        }
        if (questCenterLayer.paramsMap["btnImg"] == constantsObj.btn_outline) {
            questCenterLayer.paramsMap["btnWidthScaling"] = constantsObj.SCALE_ONE;
            questCenterLayer.paramsMap["btnScaling"] = constantsObj.SCALE_ONE;
        }
        questCenterLayer.paramsMap["quesDescY"] = 30;
        questCenterLayer.paramsMap["emptyProgressBar"] = null;
        questCenterLayer.paramsMap["fullProgressBar"] = null;
        if (questCenterLayer.paramsMap["progressBar"] == true) {
            questCenterLayer.paramsMap["quesDescY"] += 19;
            if (questCenterLayer.paramsMap["noOfLines"] != 1) {
                questCenterLayer.paramsMap["quesDescY"] += 30;
            }
        } else {
            if (questCenterLayer.paramsMap["noOfLines"] == 2) {
                questCenterLayer.paramsMap["quesDescY"] += 30;
            } else if (questCenterLayer.paramsMap["noOfLines"] == 3) {
                questCenterLayer.paramsMap["quesDescY"] += 65;
            }
        }
        questCenterLayer.paramsMap["ques_desc"] = null;
        questCenterLayer.paramsMap["milesYPos"] = null;
        questCenterLayer.paramsMap["milesXPos"] = null;
        questCenterLayer.paramsMap["progressBarLength"] = null;
        questCenterLayer.paramsMap["textMargin"] = null;
    },

    updateQuestCenterTimeLabels: function () {
        if (questCenterLayer == null ||
            questCenterLayer.timerLabelParams == null || questCenterLayer.timerLabelParams == undefined || curScreen != constantsObj.SCREEN_QUEST_CENTER) {
            return;
        }

        var timerLabelParams = questCenterLayer.timerLabelParams;
        //loggerObj.debugLog("timerLabels are -> ", utilObj.getStringifiedJson(timerLabelParams));
        var curTimeStamp = utilObj.getCurrentTimestamp();
        for (var i in timerLabelParams) {
            var labelParams = timerLabelParams[i];
            var startTime = parseInt(labelParams.startTime);
            var timeLimit = parseInt(labelParams.timeLimit);
            var timerLbl = labelParams.lbl;
            var timeLeft = startTime + timeLimit - curTimeStamp;
            var questType = labelParams.questType;
            //added
            var questId = "";
            //this is the visible index of quest which has to be updated
            var loopIndex = labelParams.loopIndex;
            if (timeLeft <= 0) {
                if (questType != undefined && questType != null && questType.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0 && crossGameDailyQuestsObj.getCrossGameDailyQuestCompletedFlag() == 0 && crossGameDailyQuestsObj.getCurrentCGDQExp() == constantsObj.EXP_VAR_3) {
                    crossGameDailyQuestsObj.setCrossGameDailyQuestCompletedFlag(1);
                }
                var uiReference = questCenterLayer.uiReferenceForQuest[loopIndex];
                //loopIndex = questCenterLayer.indexParamsToVisibleTrack[loopIndex];
                if (uiReference == null) {
                    //loggerObj.debugLog("in timer fnc log 3 here going null:", questCenterLayer.uiReferenceForQuest[i], loopIndex);
                    continue;
                }
                questId = questCenterLayer.questIdFromVisibleIndex[loopIndex];
                var oldBucketId = questsObj.getCurQuestData(questId).b;
                var availableQuests = questsObj.getAvailableInGameQuests();
                for (var quest in availableQuests) {
                    var bucketId = availableQuests[quest].b;
                    if (oldBucketId == bucketId) {
                        questId = availableQuests[quest].id;
                        break;
                    }
                }
                // questCenterLayer.changeQuestStatus(loopIndex, questId);
                //added
                //removed
                questCenterLayer.redraw();
                //removed
                //return or continue --what if 2 questTimes end at same time and we have to redraw inplace;
                return;
            }
            var formattedTimeStr = "";
            // if (questType != undefined && questType != null && questType.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0) {
            //     formattedTimeStr = xpromoUtilObj.formatTimeForCgdq(timeLeft);
            // } else {
            //     formattedTimeStr = utilObj.formatTime(timeLeft);
            // }
            formattedTimeStr = utilObj.formatTime(timeLeft);

            utilObj.setString(timerLbl, formattedTimeStr);
        }
    },

// TODO: remove this duplicate function
    updateDailyQuestTimer: function () {
        if (questCenterLayer == null ||
            questCenterLayer.dailyQuestTimerParam == null || questCenterLayer.dailyQuestTimerParam == undefined || curScreen != constantsObj.SCREEN_QUEST_CENTER) {
            return;
        }

        var timerLabelParams = questCenterLayer.dailyQuestTimerParam;
        //loggerObj.debugLog("timerLabels are -> ", utilObj.getStringifiedJson(timerLabelParams));
        var curTimeStamp = utilObj.getCurrentTimestamp();
        var labelParams = timerLabelParams;
        //loggerObj.debugLog("timeleft is ", labelParams.startTime);
        var startTime = parseInt(labelParams.startTime);
        var timeLimit = parseInt(labelParams.timeLimit);
        var timerLbl = labelParams.lbl;
        var timeLeft = xpromoUtilObj.getTimeLeftForDayComplete();
        var locked = parseInt(labelParams.lock);
        if (timeLeft <= 0 && curScreen == constantsObj.SCREEN_QUEST_CENTER) {
            questCenterLayer.redraw();
            return;
        }
        var formattedTimeStr = xpromoUtilObj.formatTimeHrMin((startTime + timeLimit) - curTimeStamp);
        if (!locked) {
            formattedTimeStr = xpromoUtilObj.formatTimeHrMin(timeLeft) + "Left";
        }
        utilObj.setString(timerLbl, formattedTimeStr);
    },


    //here the visible loopindex is passed
    changeQuestStatus: function (loopIndex, questId) {
        var imageQuest = questCenterLayer.uiReferenceForQuest[loopIndex]["button"];
        var buttonOutline = questCenterLayer.uiReferenceForQuest[loopIndex]["buttonOutline"];
        var strLabel = questCenterLayer.uiReferenceForQuest[loopIndex]["strLabel"];
        var coins_anim = questCenterLayer.uiReferenceForQuest[loopIndex]["coins_anim"];
        var tickImg = questCenterLayer.uiReferenceForQuest[loopIndex]["tickImg"];
        var notifLbl = questCenterLayer.uiReferenceForQuest[loopIndex]["notifLbl"];
        var countNotifCircle = questCenterLayer.uiReferenceForQuest[loopIndex]["countNotifCircle"];
        var rewardTxtLbl = questCenterLayer.uiReferenceForQuest[loopIndex]["rewardTxtLbl"];
        var ques_desc = questCenterLayer.uiReferenceForQuest[loopIndex]["ques_desc"];
        var ProgressLabel = questCenterLayer.uiReferenceForQuest[loopIndex]["ProgressLabel"];
        var emptyProgressBar = questCenterLayer.uiReferenceForQuest[loopIndex]["emptyProgressBar"];
        var fullProgressBar = questCenterLayer.uiReferenceForQuest[loopIndex]["fullProgressBar"];
        var timerBar = questCenterLayer.uiReferenceForQuest[loopIndex]["timerBar"];
        var timerBarLbl = questCenterLayer.uiReferenceForQuest[loopIndex]["timerBarLbl"];
        var levelsBg = questCenterLayer.uiReferenceForQuest[loopIndex]["levelsBg"];
        var levelIcon = questCenterLayer.uiReferenceForQuest[loopIndex]["levelIcon"];
        var icon_image = questCenterLayer.uiReferenceForQuest[loopIndex]["icon_image"];
        var lockIconUpper = questCenterLayer.uiReferenceForQuest[loopIndex]["lockIconUpper"];

        questCenterLayer.questsCountInBucket = questsObj.getQuestsCountInBucket();
        var quest = questsObj.getCurQuestData(questId);
        var questType = quest.qt;
        var shouldDisplayUi = true;
        var shouldFade = false;
        var showUIForDailyQuestLocked = dailyQuestsLayer.showDailyQuestLockedState(questCenterLayer.cgdqParams, questType, false);
        if (showUIForDailyQuestLocked == 1) {
            shouldDisplayUi = false;
        }
        if (showUIForDailyQuestLocked == 2) {
            shouldFade = true;
        }
        questCenterLayer.updateBgIcons(questId, loopIndex, levelsBg, levelIcon, icon_image, shouldFade, shouldDisplayUi);

        questCenterLayer.updateButtonsForQuest(loopIndex, questId, imageQuest, buttonOutline, shouldFade, shouldDisplayUi);

        questCenterLayer.updateClaimRewardUi(loopIndex, questId, strLabel, coins_anim, tickImg, notifLbl, countNotifCircle,
            rewardTxtLbl, shouldFade, shouldDisplayUi);

        questCenterLayer.updateShowTextAndProgress(loopIndex, questId, ques_desc, ProgressLabel, emptyProgressBar, fullProgressBar,
            shouldFade, shouldDisplayUi, timerBar, timerBarLbl);
    },

    removeQuestAtIndex: function (paramsLoopIndex, questId, questType) {
        var uiReference = null;
        paramsLoopIndex = parseInt(paramsLoopIndex);
        var visibleLoopIndex = questCenterLayer.indexParamsToVisibleTrack[paramsLoopIndex];
        uiReference = questCenterLayer.uiReferenceForQuest[visibleLoopIndex];
        var oldQuestId = questId;
        if (uiReference != undefined && uiReference != null) { //uiReference == undefined ||
            visibleLoopIndex = parseInt(visibleLoopIndex);
            oldQuestId = questCenterLayer.questIdFromVisibleIndex[visibleLoopIndex];

            var oldQuest = questsObj.getCurQuestData(oldQuestId);
            var oldBucketId = oldQuest.b;
            var oldQuestStatus = oldQuest.status;
            var availableQuests = questsObj.getAvailableInGameQuests();
            var nextQuestFound = false;
            //loop for finding next quest in the bucket of current quest
            for (var quest in availableQuests) {
                var currBucketId = availableQuests[quest].b;
                var newNextQuestIdInBucket = availableQuests[quest].id;
                if (oldBucketId == currBucketId) {
                    nextQuestFound = true;
                    questId = newNextQuestIdInBucket;
                    break;
                }
            }
            //if next quest found or daily quest, change it and return
            if (nextQuestFound || visibleLoopIndex < questCenterLayer.cgdqDailyQuestsCount) {
                questCenterLayer.questIdFromVisibleIndex[visibleLoopIndex] = questId;
                questCenterLayer.changeQuestStatus(visibleLoopIndex, questId);
                return;
            }
        }
        else {
            return;
        }
        //reach here if non-daily quest does not have a next quest in bucket, so to be removed;
        for (var element in uiReference) {
            if (utilObj.isNodeValid(uiReference[element])) {
                uiReference[element].setVisible(false);
            }
        }
        var i = 0;
        var uiRefMapLength = Object.keys(questCenterLayer.uiReferenceForQuest).length;
        for (i = 0; i < Object.keys(questCenterLayer.uiReferenceForQuest).length; i++) {
            //loggerObj.debugLog("removing quest with log 14 at:", loopIndex, questCenterLayer.uiReferenceForQuest, uiRefMapLength);
        }
        //shifting remaining quests upwards
        for (i = parseInt(visibleLoopIndex) + 1; i < Object.keys(questCenterLayer.uiReferenceForQuest).length; i++) {
            uiReference = questCenterLayer.uiReferenceForQuest[i];
            if (uiReference == null) {
                continue;
            }
            questId = questCenterLayer.questIdFromVisibleIndex[i];
            var paramsIndexOfCurrent = questCenterLayer.indexVisibleToParamsTrack[i];
            questCenterLayer.indexVisibleToParamsTrack[i - 1] = paramsIndexOfCurrent;
            questCenterLayer.indexParamsToVisibleTrack[paramsIndexOfCurrent]--;
            questCenterLayer.questIdFromVisibleIndex[i - 1] = questId;


            questCenterLayer.uiReferenceForQuest[i - 1] = uiReference;
            var questId = questCenterLayer.questIdFromVisibleIndex[i];
            questCenterLayer.changeQuestStatus(i, questId);
            for (var element in uiReference) {
                if (uiReference[element] == undefined || !utilObj.isNodeValid(uiReference[element])) {
                    continue;
                }
                var pos = uiReference[element].getPosition();
                pos.y += questCenterLayer.totalElementSpacing;

                //add possible elements here to avoid double moving elements which are already moved being children of already moved elements
                if (element != "countNotifCircle" && element != "notifLbl") {
                    var moveAction = animationObj.getMoveTo(0.3, pos.x, pos.y);
                    uiReference[element].runAction(moveAction);
                    // uiReference[element].setPosition(pos.x, pos.y);
                }
            }

        }
        //removing last reference after shifting upwards
        questCenterLayer.uiReferenceForQuest.splice(uiRefMapLength - 1);
    },

    addUiReferenceForQuest: function (questId, loopIndex, key, val) {
        if (questCenterLayer.uiReferenceForQuest[loopIndex] == undefined) {
            questCenterLayer.uiReferenceForQuest[loopIndex] = {};
        }
        questCenterLayer.uiReferenceForQuest[loopIndex][key] = val;
    },

    showBgIcons: function (socialQuestImageDownloaded, expXpromoDq) {
        var spriteArr = [], labelArr = [];
        var icon_image;
        var layer = questCenterLayer.scrollView;
        var yReference = questCenterLayer.paramsMap["listYPos"];
        questCenterLayer.paramsMap["layer"] = layer;
        var bgOrder = questCenterLayer.paramsMap["listZOrder"];
        var yLevel = questCenterLayer.paramsMap["levelYPos"];
        questCenterLayer.paramsMap["levelsBg"] = utilObj.getScale9Sprite(xpromoConstantsObj.xpromo_bg_box, questCenterLayer.paramsMap["centerX"], yReference, 0.5, 1.0, questCenterLayer.paramsMap["scrollViewWidth"], questCenterLayer.paramsMap["levelElementHeight"], spriteArr, questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["bgZOrder"], xpromoConstantsObj.SPRITE_QUESTS);
        questCenterLayer.paramsMap["levelIcon"] = utilObj.getSprite(questCenterLayer.paramsMap["gameIcon"], questCenterLayer.paramsMap["levelXPos"], yReference - questCenterLayer.paramsMap["levelElementHeight"] / 2, 0.5, 0.5, questCenterLayer.paramsMap["spriteScaling"], spriteArr, questCenterLayer.paramsMap["layer"], bgOrder, xpromoConstantsObj.SPRITE_QUESTS);
        var gameHostedIcon = "icon_" + questCenterLayer.paramsMap["gameHostedIn"] + ".png";
        if ((utilObj.isWeb() || utilObj.fileExists(gameHostedIcon)) && socialQuestImageDownloaded == 1 && questCenterLayer.paramsMap["isSocialQuest"] == 1) {
            icon_image = utilObj.getSprite(xpromoUtilObj.getAbsFilePath(gameHostedIcon), questCenterLayer.paramsMap["levelXPos"] + questCenterLayer.paramsMap["levelIcon"].getContentSize().width / 2 - 10, yLevel - questCenterLayer.paramsMap["levelIcon"].getContentSize().height / 2 + 10, 0.5, 0.5, questCenterLayer.paramsMap["spriteScaling"] * 0.3, spriteArr, questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["listZOrder"], xpromoConstantsObj.SPRITE_QUESTS);
            if (questCenterLayer.paramsMap["shouldFade"]) {
                utilObj.setOpacity(icon_image, 0);
            }
            questCenterLayer.addUiReferenceForQuest(questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["loopIndex"], "icon_image", questCenterLayer.paramsMap["icon_image"]);
        }
        if (questCenterLayer.paramsMap["questType"].indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0 && (expXpromoDq == constantsObj.EXP_VAR_1 || expXpromoDq == constantsObj.EXP_VAR_2)) {
            questCenterLayer.paramsMap["levelsBgColor"] = constantsObj.COLOR_IN_GAME_QUEST_BG;
        }
        utilObj.setColor(questCenterLayer.paramsMap["levelsBg"], questCenterLayer.paramsMap["levelsBgColor"]);
        if (questCenterLayer.paramsMap["shouldFade"]) {
            utilObj.setOpacity(questCenterLayer.paramsMap["levelsBg"], 0);
            utilObj.delayedCallback(questCenterLayer.paramsMap["layer"], xpromoAnimationObj.animateQuestParticles, 3.2, {"node": questCenterLayer.paramsMap["levelsBg"]}, false);
            utilObj.setOpacity(questCenterLayer.paramsMap["levelIcon"], 0);
        }
        questCenterLayer.addUiReferenceForQuest(questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["loopIndex"], "levelsBg", questCenterLayer.paramsMap["levelsBg"]);
        questCenterLayer.addUiReferenceForQuest(questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["loopIndex"], "levelIcon", questCenterLayer.paramsMap["levelIcon"]);
        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);
        // questCenterLayer.updateBgIcons(questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["loopIndex"], questCenterLayer.paramsMap["levelsBg"], questCenterLayer.paramsMap["levelIcon"], icon_image, questCenterLayer.paramsMap["shouldFade"], questCenterLayer.paramsMap["shouldDisplayUIHere"]);
    },

    showIcon: function () {
        var socialQuestImageDownloaded = 0;
        questCenterLayer.paramsMap["iconScaling"] = constantsObj.SCALE_ONE;
        var isRequestImageDownloaded = false;
        if (questCenterLayer.paramsMap["isRequest"] == 1) {
            var gameIconName, gameIconPath;
            if (questCenterLayer.paramsMap["botType"] == 1) {
                gameIconName = wordWarsRequestLayer.getBotImage(questCenterLayer.paramsMap["senderRefId"]);
                questCenterLayer.paramsMap["spriteScaling"] = constantsObj.SCALE_TWO_POINT_FIVE * constantsObj.SPRITE_SCALING_FACTOR * (15 / 206);
            } else {
                gameIconName = questCenterLayer.paramsMap["senderFbId"] + ".jpg";
            }
            gameIconPath = requestsObj.getImageLinkFromName(questCenterLayer.paramsMap["botType"], gameIconName, questCenterLayer.paramsMap);

            if (!utilObj.isWeb() && !utilObj.fileExists(gameIconName)) {
                questCenterLayer.paramsMap["gameIcon"] = questConfigObj.getConfigData("icon_game");
                questCenterLayer.paramsMap["iconScaling"] = constantsObj.SCALE_TWO_POINT_FIVE * constantsObj.SPRITE_SCALING_FACTOR * (80 / 206);
                xPromoGameSpecificObj.downloadFileV1(gameIconPath, gameIconName);
            } else {
                questCenterLayer.paramsMap["gameIcon"] = gameIconPath;
                isRequestImageDownloaded = true;
            }
        }
        if (questCenterLayer.paramsMap["gameHostedIn"] && isRequestImageDownloaded == false) {
            questCenterLayer.paramsMap["pathForGameIcon"] = utilObj.getFilesDir();
            questCenterLayer.paramsMap["spriteScaling"] = constantsObj.SCALE_ONE;
            if (utilObj.isAndroid()) {
                questCenterLayer.paramsMap["pathForGameIcon"] += "/";
            }
            var gameIconPath = "icon_" + questCenterLayer.paramsMap["gameHostedIn"] + ".png";
            questCenterLayer.paramsMap["gameIcon"] = xpromoUtilObj.getAbsFilePath(gameIconPath);
            if (!utilObj.isWeb() && !utilObj.fileExists(gameIconPath)) {
                questCenterLayer.paramsMap["gameIcon"] = questConfigObj.getConfigData("icon_game");
                questCenterLayer.paramsMap["iconScaling"] = constantsObj.SCALE_TWO_POINT_FIVE * constantsObj.SPRITE_SCALING_FACTOR * (80 / 206);
                xPromoGameSpecificObj.downloadFileV1(constantsObj.MISC_SERVER_STATIC_BASE + "quests/images/icons/" + gameIconPath, gameIconPath);
            }
        }


        if (questCenterLayer.paramsMap["isSocialQuest"] == 1) {
            var gameIconName = questCenterLayer.paramsMap["psFriend"].fbId + ".jpg";
            if (!utilObj.isWeb() && gameIconName.indexOf("friendly_") == -1 && !utilObj.fileExists(gameIconName)) {
                xPromoGameSpecificObj.downloadFileV1(friendsObj.getFbPicUrl(questCenterLayer.paramsMap["psFriend"].fbId), gameIconName);
            } else {
                socialQuestImageDownloaded = 1;
                questCenterLayer.paramsMap["gameIcon"] = socialQuestObj.getAbsFilePathForFbPic(questCenterLayer.paramsMap["psFriend"].fbId, gameIconName);
                questCenterLayer.paramsMap["spriteScaling"] = constantsObj.SCALE_ONE;
            }
        }
        return socialQuestImageDownloaded;
    },

    updateBgIcons: function (questId, loopIndex, levelsBg, levelIcon, icon_image, paramsMapShouldFade, shouldDisplayUi) {
        //merge showicons+quest_icon_map code piece in the beginning
        if (shouldDisplayUi == false) {
            levelsBg.setVisible(false);
            levelIcon.setVisible(false);
            if (icon_image != undefined) {
                icon_image.setVisible(false);
            }
            return;
        }
        if (!utilObj.isNodeValid(levelIcon) || !utilObj.isNodeValid(levelsBg)) {
            return;
        }
        utilObj.setVisible(levelsBg, true);
        utilObj.setVisible(levelIcon, true);
        if (icon_image != undefined) {
            icon_image.setVisible(true);
        }
        var curQuest = questsObj.getCurQuestData(questId);
        if (curQuest == undefined) {
            return;
        }
        var levelsBgColor = constantsObj.COLOR_IN_GAME_QUEST_BG;
        var questType = curQuest.qt;
        var copyGameHostedIn = curQuest.gh;
        var expXpromoDq = crossGameDailyQuestsObj.getCurrentCGDQExp();
        if (!(questType.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0 && copyGameHostedIn != constantsObj.GAME_ID) && !questsObj.isQuestInGame(questId)) {
            levelsBgColor = constantsObj.COLOR_CROSS_GAME_QUEST_BG;
        }
        if (questType.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0 && (expXpromoDq == constantsObj.EXP_VAR_1 || expXpromoDq == constantsObj.EXP_VAR_2)) {
            levelsBgColor = constantsObj.COLOR_IN_GAME_QUEST_BG;
        }
        //utilObj.setColor(levelsBg, levelsBgColor);

        ////////added showicon
        var socialQuestImageDownloaded = 0;
        var iconScaling = constantsObj.SCALE_ONE;
        var isRequestImageDownloaded = false;
        var isRequest = curQuest.isRequest;
        var gameIcon = questConfigObj.getConfigData("icon_game");
        var botType = curQuest.botType;
        var spriteScaling = constantsObj.SCALE_ONE;
        var senderRefId = curQuest.senderRefId;
        var senderFbId = curQuest.senderFbId;
        var gameHostedIn = curQuest.gh;
        var pathForGameIcon = "";
        var isSocialQuest = curQuest.isSocialQuest;
        var psFriend = curQuest.psFriend;

        if (isRequest == 1) {
            var gameIconName, gameIconPath;
            if (botType == 1) {
                gameIconName = wordWarsRequestLayer.getBotImage(senderRefId);
                spriteScaling = constantsObj.SCALE_TWO_POINT_FIVE * constantsObj.SPRITE_SCALING_FACTOR * (15 / 206);
            } else {
                gameIconName = senderFbId + ".jpg";
            }
            //third parameter to be changed
            gameIconPath = requestsObj.getImageLinkFromName(botType, gameIconName, senderFbId);

            if (!utilObj.isWeb() && !utilObj.fileExists(gameIconName)) {
                gameIcon = questConfigObj.getConfigData("icon_game");
                iconScaling = constantsObj.SCALE_TWO_POINT_FIVE * constantsObj.SPRITE_SCALING_FACTOR * (80 / 206);
                xPromoGameSpecificObj.downloadFileV1(gameIconPath, gameIconName);
            } else {
                gameIcon = gameIconPath;
                isRequestImageDownloaded = true;
            }
        }
        if (gameHostedIn && isRequestImageDownloaded == false) {
            pathForGameIcon = utilObj.getFilesDir();
            spriteScaling = constantsObj.SCALE_ONE;
            if (utilObj.isAndroid()) {
                pathForGameIcon += "/";
            }
            var gameIconPath = "icon_" + gameHostedIn + ".png";
            gameIcon = xpromoUtilObj.getAbsFilePath(gameIconPath);
            if (!utilObj.isWeb() && !utilObj.fileExists(gameIconPath)) {
                gameIcon = questConfigObj.getConfigData("icon_game");
                iconScaling = constantsObj.SCALE_TWO_POINT_FIVE * constantsObj.SPRITE_SCALING_FACTOR * (80 / 206);
                xPromoGameSpecificObj.downloadFileV1(constantsObj.MISC_SERVER_STATIC_BASE + "quests/images/icons/" + gameIconPath, gameIconPath);
            }
        }

        // var parent = levelIcon.getParent();

        if (isSocialQuest == 1) {
            var gameIconName = psFriend.fbId + ".jpg";
            if (!utilObj.isWeb() && gameIconName.indexOf("friendly_") == -1 && !utilObj.fileExists(gameIconName)) {
                xPromoGameSpecificObj.downloadFileV1(friendsObj.getFbPicUrl(psFriend.fbId), gameIconName);
            } else {
                socialQuestImageDownloaded = 1;
                gameIcon = socialQuestObj.getAbsFilePathForFbPic(psFriend.fbId, gameIconName);
                spriteScaling = constantsObj.SCALE_ONE;
            }
        }
        //return socialQuestImageDownloaded;
        if (xpromoConstantsObj.QUEST_ICON_GAME_MAP[constantsObj.GAME_ID] != undefined && xpromoConstantsObj.QUEST_ICON_GAME_MAP[constantsObj.GAME_ID][questType] != undefined) {
            gameIcon = xpromoConstantsObj.QUEST_ICON_GAME_MAP[constantsObj.GAME_ID][questType];
        } else if (xpromoConstantsObj.QUEST_ICON_MAP[questType] != undefined) {
            gameIcon = xpromoConstantsObj.QUEST_ICON_MAP[questType];
        }
        /////added showicon

        //var icon_image;
        var layer = questCenterLayer.scrollView;
        //levelsbg will be passed to this func from where it would be calculated
        var bgOrder = constantsObj.SPRITE_Z_ORDER;
        var questType = curQuest.qt;
        var gameHostedIn = curQuest.gh;
        //can come from calling function
        //var levelsBg = utilObj.getScale9Sprite(xpromoConstantsObj.xpromo_bg_box, centerXPos, yReference, 0.5, 1.0, questCenterLayer.paramsMap["scrollViewWidth"], questCenterLayer.paramsMap["levelElementHeight"], questCenterLayer.paramsMap["spriteArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["bgZOrder"], xpromoConstantsObj.SPRITE_QUESTS);
        //need to be added in ui by addsprite fnc since spritearr not here
        var levelXPos = 160 + questCenterLayer.dailyQuestsXShift / 2;
        var listZOrder = constantsObj.SPRITE_Z_ORDER;

        if (!dailyQuestsObj.isDailyQuestOrStreakQuest(questType)) {
            var xShift = questCenterLayer.dailyQuestsXShift / 2.0;
            levelXPos -= xShift;
        }

        var changedImage = utilObj.getSprite(gameIcon, levelIcon.getPosition().x, levelIcon.getPosition().y, 0.5, 0.5, spriteScaling, [], layer, bgOrder, xpromoConstantsObj.SPRITE_QUESTS);
        layer.addChild(changedImage, bgOrder);
        questCenterLayer.addUiReferenceForQuest(questId, loopIndex, "levelIcon", changedImage);
        utilObj.removeChild(layer, levelIcon);
        var gameHostedIcon = "icon_" + gameHostedIn + ".png";
        if ((utilObj.isWeb() || utilObj.fileExists(gameHostedIcon)) && socialQuestImageDownloaded == 1 && isSocialQuest == 1) {
            //TODO: same for image_icon
            //utilObj.getSprite(xpromoUtilObj.getAbsFilePath(gameHostedIcon), levelXPos + levelIcon.getContentSize().width / 2 - 10, yLevel - levelIcon.getContentSize().height / 2 + 10, 0.5, 0.5, spriteScaling * 0.3, spriteArr, layer, listZOrder, xpromoConstantsObj.SPRITE_QUESTS);
            //utilObj.changeSpriteImage(icon_image, questCenterLayer.scrollView, xpromoUtilObj.getAbsFilePath(gameHostedIcon), spriteScaling * 0.3, 100);
            if (paramsMapShouldFade) {
                utilObj.setOpacity(icon_image, 0);
            }
        }
        //utilObj.addSprites(spriteArr);
        if (paramsMapShouldFade) {
            utilObj.setOpacity(levelsBg, 0);
            utilObj.delayedCallback(layer, xpromoAnimationObj.animateQuestParticles, 3.2, {"node": levelsBg}, false);
            utilObj.setVisible(questCenterLayer.uiReferenceForQuest[loopIndex]["levelIcon"], false);
        }
    },

    updateButtonsForQuest: function (loopIndex, questId, imageQuest, buttonOutline, paramsMapShouldFade, shouldDisplayUi) {
        if(!utilObj.isNodeValid(imageQuest)) {
            return;
        }
        if (shouldDisplayUi == false) {
            imageQuest.setVisible(false);
            buttonOutline.setVisible(false);
            return;
        }
        var shouldFade = false;
        var curQuest = questsObj.getCurQuestData(questId);
        if (curQuest == undefined) {
            return;
        }
        var questStatus = curQuest.status;
        var questType = curQuest.qt;
        var buttonShown = true;
        var btnColor = questCenterLayer.getButtonColorForQuests(questType, questId, questStatus);
        if (questStatus == xpromoConstantsObj.QUEST_COMPLETED) {
            // imageQuest.setColor(constantsObj.COLOR_BUTTON_LIGHT_GREEN);
        } else if ((dailyQuestsObj.isDailyQuestOrStreakQuest(questType) && dailyQuestsObj.isQuestTypeUnlocked(questType)) || questCenterLayer.isRedirectionQuest(questType, questId) == true) {
            // imageQuest.setColor(constantsObj.COLOR_BLUE_02);
            // if(questStatus == xpromoConstantsObj.QUEST_CLAIMED) {
            //     buttonShown = false;
            // }
            //else or not since above added later
            if (paramsMapShouldFade) {
                shouldFade = true;
            }
        } else {
            buttonShown = false;
            buttonOutline.setColor(constantsObj.COLOR_GREY_11);
        }

        if (questStatus == xpromoConstantsObj.QUEST_CLAIMED && ((dailyQuestsObj.isDailyQuestOrStreakQuest(questType) && dailyQuestsObj.isQuestTypeUnlocked(questType)) || questType.indexOf(xpromoConstantsObj.QUEST_TYPE_SECONDARY_QUEST_LEVEL) == 0 || dailyQuestsObj.isDailyQuestReplacement(questId)) ) {
            //Uniform behaviour of button dissapearing on claimed for DQ and replacement quest
            imageQuest.setVisible(false);
            buttonOutline.setVisible(false);
        } else if (buttonShown) {
            imageQuest.setColor(btnColor);
            imageQuest.setVisible(true);
            buttonOutline.setVisible(false);
        } else {
            imageQuest.setVisible(false);
            buttonOutline.setVisible(true);
        }

        if (shouldFade) {
            utilObj.setOpacity(imageQuest, 0);
            utilObj.delayedCallback(questCenterLayer.layer, xpromoAnimationObj.animateQuestParticles, 3.2, {"node": imageQuest}, false);
        }

    },

    claimRewardUi: function () {
        var yReference = questCenterLayer.paramsMap["listYPos"] - questCenterLayer.paramsMap["levelElementHeight"] / 2;
        var strLabel = utilObj.getBMFontLabel("", constantsObj.FONT_SFCOMPACT_MEDIUM_60, questCenterLayer.paramsMap["rewardTextColor"],
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, centerYPos, 0.5, 0.5, questCenterLayer.paramsMap["labelArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["listZOrder"] + 1);
        var coins_anim = utilObj.getSprite(questConfigObj.getConfigData("icon_coins"), centerXPos, centerYPos, 0, 0.5, constantsObj.SCALE_SPRITE_10, questCenterLayer.paramsMap["spriteArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["zOrder"] + 1, questConfigObj.getConfigData("SPRITE_MISC"));
        questCenterLayer.paramsMap["rewardTxtLbl"] = utilObj.getBMFontLabel(questCenterLayer.paramsMap["rewardValue"] + "", constantsObj.FONT_SFCOMPACT_MEDIUM_60, questCenterLayer.paramsMap["rewardTextColor"],
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, centerYPos, 0, 0.5, questCenterLayer.paramsMap["labelArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["listZOrder"] + 1);

        var tickImg = utilObj.getSprite(constantsObj.tick, questCenterLayer.paramsMap["scrollViewWidth"] + questCenterLayer.paramsMap["dailyQuestsXShift"] / 2 - questCenterLayer.paramsMap["btnWidth"] + (questCenterLayer.paramsMap["btnWidth"] * questCenterLayer.paramsMap["btnWidthScaling"]) / 2, yReference, 0.0, 0.5, constantsObj.SPRITE_SCALING_FACTOR,
            questCenterLayer.paramsMap["spriteArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["listZOrder"], questConfigObj.getConfigData("SPRITE_MISC"));
        var notifXPos = centerXPos;
        var notifYPos = centerYPos;
        if (utilObj.isNodeValid( questCenterLayer.actionButton[questCenterLayer.paramsMap["loopIndex"]]) && questCenterLayer.actionButton[questCenterLayer.paramsMap["loopIndex"]] != undefined) {
            notifXPos = questCenterLayer.actionButton[questCenterLayer.paramsMap["loopIndex"]].getContentSize().width * 0.82;
            notifYPos = questCenterLayer.actionButton[questCenterLayer.paramsMap["loopIndex"]].getContentSize().height - 15;
        }
        var countNotifCircle = utilObj.getSprite(xpromoConstantsObj.jewel_notif, notifXPos, notifYPos, 0.5, 0.5, constantsObj.SCALE_ONE_POINT_ONE, questCenterLayer.paramsMap["spriteArr"], questCenterLayer.actionButton[questCenterLayer.paramsMap["loopIndex"]], 1, questConfigObj.getConfigData("SPRITE_MISC"));
        questCenterLayer.addUiReferenceForQuest(questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["loopIndex"], "countNotifCircle", countNotifCircle);
        var notifLbl = utilObj.getBMFontLabel("", constantsObj.FONT_SFCOMPACT_REGULAR_50, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), notifXPos, notifYPos + 2, 0.5, 0.5, questCenterLayer.paramsMap["labelArr"], questCenterLayer.actionButton[questCenterLayer.paramsMap["loopIndex"]], 2);
        utilObj.setScale(notifLbl, 0.6);
        questCenterLayer.addUiReferenceForQuest(questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["loopIndex"], "notifLbl", notifLbl);
        questCenterLayer.addUiReferenceForQuest(questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["loopIndex"], "tickImg", tickImg);
        questCenterLayer.addUiReferenceForQuest(questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["loopIndex"], "strLabel", strLabel);
        questCenterLayer.addUiReferenceForQuest(questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["loopIndex"], "coins_anim", coins_anim);
        questCenterLayer.addUiReferenceForQuest(questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["loopIndex"], "rewardTxtLbl", questCenterLayer.paramsMap["rewardTxtLbl"]);

        questCenterLayer.updateClaimRewardUi(questCenterLayer.paramsMap["loopIndex"], questCenterLayer.paramsMap["questId"], strLabel, coins_anim, tickImg, notifLbl, countNotifCircle,
            questCenterLayer.paramsMap["rewardTxtLbl"], questCenterLayer.paramsMap["shouldFade"], questCenterLayer.paramsMap["shouldDisplayUIHere"]);

    },

    updateClaimRewardUi: function (loopIndex, questId, strLabel, coins_anim, tickImg, notifLbl, countNotifCircle,
                                   rewardTxtLbl, paramsMapShouldFade, shouldDisplayUi) {
        // if(strLabel == undefined) {
        //     return;
        // }
        if (shouldDisplayUi == false) {
            strLabel.setVisible(false);
            coins_anim.setVisible(false);
            tickImg.setVisible(false);
            notifLbl.setVisible(false);
            countNotifCircle.setVisible(false);
            rewardTxtLbl.setVisible(false);
            return;
        }
        if (!utilObj.isNodeValid(questCenterLayer.uiReferenceForQuest[loopIndex]["levelsBg"])) {
            return;
        }
        var yReference = questCenterLayer.uiReferenceForQuest[loopIndex]["levelsBg"].getPositionY() - questCenterLayer.levelElementHeight / 2;
        var diff = 45;
        var curQuest = questsObj.getCurQuestData(questId);
        if (curQuest == undefined) {
            return;
        }
        var questType = curQuest.qt;
        var questStatus = curQuest.status;
        var rewardTextColor = questCenterLayer.getRewardTextColor(questType, questId, questStatus);
        var txtLblOpacity = questCenterLayer.getTxtLblOpacity(questType, questId, questStatus);
        var showReward = questCenterLayer.shouldShowReward(questType, questId);
        var reward = questsObj.getRewardValueForQuest(curQuest);
        var bucket = curQuest.b;

        var strValue = "";
        var strXPos = questCenterLayer.scrollViewWidth - questCenterLayer.btnWidth / 2.0 + questCenterLayer.bezelXShift;
        var strYPos = yReference;

        var noOfDigits = xpromoUtilObj.getNumDigits(reward);
        var adjust_posX = 0;
        if (questCenterLayer.xAdjustmentMap[noOfDigits] != undefined) {
            adjust_posX = questCenterLayer.xAdjustmentMap[noOfDigits];
        }

        var coinVisible = false;
        var coinXPos = (questCenterLayer.scrollViewWidth - questCenterLayer.btnWidth + xRightPos) / 2 - questCenterLayer.btnWidth / 2 + adjust_posX + questCenterLayer.bezelXShift + 20;
        var coinYPos = yReference;

        var rewardTxtLblVisible = false;
        var rewardTxtLblXPos = coinXPos + 80;
        var rewardTxtLblYPos = yReference;


        var shouldFade = false;

        var notifLblVisible = false;

        var tickImgVisible = false;
        var bucketCount = 0;
        if (questStatus == xpromoConstantsObj.QUEST_COMPLETED) {
            //Uniform button placement on completed between DQ and replacement
            if (dailyQuestsObj.isDailyQuestOrStreakQuest(questType) || dailyQuestsObj.isDailyQuestReplacement(questId)) {
                var xShift = questCenterLayer.dailyQuestsXShift / 2.0;
                strXPos -= xShift;
                coinXPos -= xShift;
                rewardTxtLblXPos -= xShift;
            }
            strYPos = strYPos + diff;
            strValue = stringsObj.claim;

            coinYPos -= 20;
            coinVisible = true;

            rewardTxtLblYPos -= 20;
            rewardTxtLblVisible = true;
            bucketCount = questCenterLayer.questsCountInBucket[bucket];
            if (bucketCount != undefined && bucketCount != null && parseInt(bucketCount) > 0) {
                notifLblVisible = true;
            }

            if (parseInt(bucketCount) > 1 && !dailyQuestsObj.isDailyQuestOrStreakQuest(questType)) {
                bucketCount = 1;
            }

            if (paramsMapShouldFade) {
                shouldFade = true;
            }
        } else if (questStatus == xpromoConstantsObj.QUEST_CLAIMED) {
            tickImgVisible = true;
        } else {
            if (reward == 0 || reward == "0" || showReward == false) {
                strValue = stringsObj.play;
                if (questType != constantsObj.REQUEST_TYPE_WORD_WARS) {
                    strValue = xpromoStringsObj.install;
                }
            } else if (showReward == true) {
                coinVisible = true;
                rewardTxtLblVisible = true;

                if (paramsMapShouldFade) {
                    shouldFade = true;
                }
            } else {
                strValue = stringsObj.play;
            }

            if (dailyQuestsObj.isDailyQuestOrStreakQuest(questType)) {
                var shift = questCenterLayer.dailyQuestsXShift / 2.0;
                coinXPos -= shift;
                rewardTxtLblXPos -= shift;
            }
        }
        if (shouldFade) {
            if (questStatus != xpromoConstantsObj.QUEST_COMPLETED) {
                utilObj.setOpacity(coins_anim, 0);
                utilObj.delayedCallback(questCenterLayer.scrollView, xpromoAnimationObj.animateQuestParticles, 3.2, {"node": coins_anim}, false);
            }
            utilObj.setOpacity(rewardTxtLbl, 0);
            utilObj.delayedCallback(questCenterLayer.scrollView, xpromoAnimationObj.animateQuestParticles, 3.2, {"node": rewardTxtLbl}, false);
        }

        utilObj.setPosition(strLabel, strXPos, strYPos);
        strLabel.setString(strValue);
        strLabel.setColor(rewardTextColor);
        utilObj.setPosition(coins_anim, coinXPos, coinYPos);
        //added
        strLabel.setVisible(true);
        //added
        coins_anim.setVisible(coinVisible);
        rewardTxtLbl.setString(reward + "");
        rewardTxtLbl.setColor(rewardTextColor);
        utilObj.setPosition(rewardTxtLbl, rewardTxtLblXPos, rewardTxtLblYPos);
        rewardTxtLbl.setVisible(rewardTxtLblVisible);
        utilObj.setVisible(tickImg, tickImgVisible);
        countNotifCircle.setVisible(notifLblVisible);
        notifLbl.setString(bucketCount + "");
        notifLbl.setVisible(notifLblVisible);

    },

    showTextAndProgress: function (questDesc) {
        var layer = questCenterLayer.scrollView;
        questCenterLayer.paramsMap["layer"] = layer;
        questCenterLayer.paramsMap["ques_desc"] = utilObj.getBMFontLabel("", constantsObj.FONT_SFCOMPACT_REGULAR_50, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), questCenterLayer.paramsMap["levelXPos"] + 140, questCenterLayer.paramsMap["levelYPos"] + questCenterLayer.paramsMap["quesDescY"], 0, 1.0, questCenterLayer.paramsMap["labelArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["bgZOrder"]);
        questCenterLayer.paramsMap["ques_desc"].setString(questDesc);
        if (questCenterLayer.paramsMap["shouldFade"]) {
            utilObj.setOpacity(questCenterLayer.paramsMap["ques_desc"], 0);
            utilObj.delayedCallback(questCenterLayer.paramsMap["layer"], xpromoAnimationObj.animateQuestParticles, 3.2, {"node": questCenterLayer.paramsMap["ques_desc"]}, false);
        }
        questCenterLayer.addUiReferenceForQuest(questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["loopIndex"], "ques_desc", questCenterLayer.paramsMap["ques_desc"]);

        questCenterLayer.paramsMap["milesYPos"] = questCenterLayer.paramsMap["ques_desc"].getPositionY() - 20;
        questCenterLayer.paramsMap["milesXPos"] = questCenterLayer.paramsMap["levelTxtXPos"] - 40;
        questCenterLayer.paramsMap["progressBarLength"] = canvasWidth - 60 - questCenterLayer.paramsMap["milesXPos"] - 750;
        questCenterLayer.paramsMap["textMargin"] = 20;
        var ProgressLabel = utilObj.getBMFontLabel("",
            constantsObj.FONT_SFCOMPACT_MEDIUM_40, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0),
            questCenterLayer.paramsMap["milesXPos"] + questCenterLayer.paramsMap["progressBarLength"] + questCenterLayer.paramsMap["textMargin"] + 30,
            questCenterLayer.paramsMap["milesYPos"], 0, 1.0, questCenterLayer.paramsMap["labelArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["bgZOrder"] + 1);
        if (questCenterLayer.paramsMap["progressBar"] == true) {
            if (questCenterLayer.paramsMap["currentProgressForQuest"] >= questCenterLayer.paramsMap["reqProgressForQuest"]) {
                questCenterLayer.paramsMap["currentProgressForQuest"] = questCenterLayer.paramsMap["reqProgressForQuest"];
            }
            var questProgressPercent = questCenterLayer.paramsMap["currentProgressForQuest"] / questCenterLayer.paramsMap["reqProgressForQuest"];
            var fullProgressBarLength = questProgressPercent * questCenterLayer.paramsMap["progressBarLength"];

            //var ProgressLabel;
            var diff = 30;
            questCenterLayer.paramsMap["emptyProgressBar"] = utilObj.getScale9Sprite(constantsObj.full_bar_2, questCenterLayer.paramsMap["milesXPos"] + diff, questCenterLayer.paramsMap["milesYPos"], 0, 1.0, questCenterLayer.paramsMap["progressBarLength"], 18,
                questCenterLayer.paramsMap["spriteArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["bgZOrder"] + 1, questConfigObj.getConfigData("SPRITE_MISC"));
            questCenterLayer.paramsMap["fullProgressBar"] = utilObj.getScale9Sprite(constantsObj.progress_bar_2, questCenterLayer.paramsMap["milesXPos"] + diff, questCenterLayer.paramsMap["milesYPos"], 0, 1.0, fullProgressBarLength, 18,
                questCenterLayer.paramsMap["spriteArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["bgZOrder"] + 1, questConfigObj.getConfigData("SPRITE_MISC"));
            if (questCenterLayer.paramsMap["currentProgressForQuest"] == undefined || questCenterLayer.paramsMap["currentProgressForQuest"] == NaN) {
                questCenterLayer.paramsMap["currentProgressForQuest"] = 0;
            }
            // ProgressLabel = utilObj.getBMFontLabel(questCenterLayer.paramsMap["currentProgressForQuest"] + "/" + questCenterLayer.paramsMap["reqProgressForQuest"], constantsObj.FONT_SFCOMPACT_MEDIUM_40, constantsObj.COLOR_BLACK,
            //         constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), questCenterLayer.paramsMap["milesXPos"] + questCenterLayer.paramsMap["progressBarLength"] + questCenterLayer.paramsMap["textMargin"] + 30, questCenterLayer.paramsMap["milesYPos"], 0, 1.0, questCenterLayer.paramsMap["labelArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["bgZOrder"] + 1);

            if (questCenterLayer.paramsMap["shouldFade"]) {
                utilObj.setOpacity(ProgressLabel, 0);
                utilObj.delayedCallback(questCenterLayer.paramsMap["layer"], xpromoAnimationObj.animateQuestParticles, 3.2, {"node": ProgressLabel}, false);
                utilObj.setOpacity(questCenterLayer.paramsMap["fullProgressBar"], 0);
                utilObj.delayedCallback(questCenterLayer.paramsMap["layer"], xpromoAnimationObj.animateQuestParticles, 3.2, {"node": questCenterLayer.paramsMap["fullProgressBar"]}, false);
                utilObj.setOpacity(questCenterLayer.paramsMap["emptyProgressBar"], 0);
                utilObj.delayedCallback(questCenterLayer.paramsMap["layer"], xpromoAnimationObj.animateQuestParticles, 3.2, {"node": questCenterLayer.paramsMap["emptyProgressBar"]}, false);
            }
            questCenterLayer.paramsMap["emptyProgressBar"].setColor(constantsObj.COLOR_EMPTY_PROGRESS_BAR);
            questCenterLayer.paramsMap["fullProgressBar"].setColor(constantsObj.COLOR_FULL_PROGRESS_BAR);
            if (fullProgressBarLength == questCenterLayer.paramsMap["progressBarLength"]) {
                questCenterLayer.paramsMap["emptyProgressBar"].setColor(constantsObj.COLOR_FULL_PROGRESS_BAR);
                utilObj.setVisible(questCenterLayer.paramsMap["fullProgressBar"], false);
            }
            questCenterLayer.addUiReferenceForQuest(questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["loopIndex"], "emptyProgressBar", questCenterLayer.paramsMap["emptyProgressBar"]);
            questCenterLayer.addUiReferenceForQuest(questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["loopIndex"], "fullProgressBar", questCenterLayer.paramsMap["fullProgressBar"]);
        }
        questCenterLayer.updateShowTextAndProgress(questCenterLayer.paramsMap["loopIndex"], questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["ques_desc"], ProgressLabel, questCenterLayer.paramsMap["emptyProgressBar"], questCenterLayer.paramsMap["fullProgressBar"], false, questCenterLayer.paramsMap["shouldDisplayUIHere"], undefined, undefined);
        questCenterLayer.addUiReferenceForQuest(questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["loopIndex"], "ProgressLabel", ProgressLabel);

    },

    updateShowTextAndProgress: function (loopIndex, questId, ques_desc, ProgressLabel, emptyProgressBar, fullProgressBar, paramsMapShouldFade, shouldDisplayUi, timerBar, timerBarLbl) {
        //if (shouldDisplayUi == false) {
        //ques_desc.setVisible(false);
        if (!utilObj.isNodeValid(ques_desc)) {
            return;
        }
        if (shouldDisplayUi == false) {
            ques_desc.setVisible(false);
            if (ProgressLabel != undefined) {
                ProgressLabel.setVisible(false);
            }
            if (emptyProgressBar != undefined) {
                emptyProgressBar.setVisible(false);
            }
            if (fullProgressBar != undefined) {
                fullProgressBar.setVisible(false);
            }
            if(timerBar != undefined) {
                timerBar.setVisible(false);
                timerBarLbl.setVisible(false);
            }
            return;
        }
        var layer = questCenterLayer.scrollView;
        var yReference = questCenterLayer.uiReferenceForQuest[loopIndex]["levelsBg"].getPositionY() - questCenterLayer.levelElementHeight / 2;
        //var curQuest = questCenterLayer.paramsMap["listItems"][questCenterLayer.paramsMap["loopIndex"]];
        var curQuest = questsObj.getCurQuestData(questId);
        if (curQuest == undefined) {
            return;
        }
        var questType = curQuest.qt;
        var questStatus = questCenterLayer.paramsMap["questStatus"];
        var questDesc = curQuest.d;
        if (dailyQuestsObj.isDailyQuestOrStreakQuest(questType)) {
            questDesc = questDesc.replace("%value%", questCenterLayer.paramsMap["reqProgressForQuest"]);
        }
        if(dailyQuestsObj.isDailyQuestReplacement(questId)){
            if(curQuest.isSocialQuest == 1){
                questDesc = dailyQuestsObj.getDQReplacementSocialQuestLabel(curQuest["gh"]);
            }
        }
        var noOfLines = 0;
        var textLine1 = "";
        var textLine2 = "";
        var textLine3 = "";

        questDesc = utilObj.getSplitStringsArr(questDesc, 25);

        noOfLines = questDesc.length;

        if (noOfLines == 1) {
            textLine1 = questDesc[0];
        } else if (noOfLines == 2) {
            textLine1 = questDesc[0];
            textLine2 = questDesc[1];
        } else {
            textLine1 = questDesc[0];
            textLine2 = questDesc[1];
            textLine3 = questDesc[2];
        }

        questDesc = questDesc + " ";
        if (noOfLines == 2) {
            questDesc = textLine1 + "\n" + textLine2 + " ";
        }
        if (noOfLines == 3) {
            questDesc = textLine1 + "\n" + textLine2 + "\n" + textLine3 + " ";
        }
        //questCenterLayer.paramsMap["noOfLines"] = noOfLines;
        ques_desc.setString(questDesc);
        ques_desc.setVisible(true);
        if(utilObj.isStaging()) {
            ques_desc.setString(questDesc + " " +curQuest.id + " " + curQuest.b);
        }

        if (paramsMapShouldFade) {
            utilObj.setOpacity(ques_desc, 0);
            utilObj.delayedCallback(layer, xpromoAnimationObj.animateQuestParticles, 3.2, {"node": ques_desc}, false);
        }
        //questCenterLayer.addUiReferenceForQuest(questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["loopIndex"], "questDesc", questCenterLayer.paramsMap["ques_desc"]);

        var milesYPos = ques_desc.getPositionY() - 20;
        var milesXPos = 270; //+ (questCenterLayer.dailyQuestsXShift / 2) - 40;
        if (dailyQuestsObj.isDailyQuestOrStreakQuest(questType) || (questType.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0 && crossGameDailyQuestsObj.getCurrentCGDQExp() != xpromoConstantsObj.EXP_VAR_3)) {
            milesXPos += questCenterLayer.dailyQuestsXShift / 2;
        }
        var progressBarLength = canvasWidth - 60 - milesXPos - 750;
        var textMargin = 20;
        //edit it
        var progressBar = true;
        var reqProgress = questCenterLayer.paramsMap["reqProgressForQuest"];
        var curProgress = questCenterLayer.paramsMap["currentProgressForQuest"];
        if (reqProgress == undefined || reqProgress == null || reqProgress == 0 || (reqProgress == 1 && !dailyQuestsObj.isDailyQuestOrStreakQuest(questType) && questType.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) != 0)
            || (questStatus == xpromoConstantsObj.QUEST_NOT_STARTED && questType.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) != 0) || questStatus == xpromoConstantsObj.QUEST_CLAIMED) {
            progressBar = false;
        }

        var quesDescY = 30;

        if (noOfLines == 2) {
            quesDescY += 30;
        } else if (noOfLines == 3) {
            quesDescY += 65;
        }

        var ratioBarY = 50;
        var progressBarY = 65;
        var posQuesDesc = utilObj.getPosition(ques_desc);
        posQuesDesc.y = yReference + quesDescY;
        utilObj.setPosition(ques_desc, posQuesDesc.x, posQuesDesc.y);

        if (progressBar == true) {
            quesDescY = 49;
            if (noOfLines != 1) {
                progressBarY += 44;
                ratioBarY += 40;
                quesDescY += 30;
            }
            posQuesDesc.y = yReference + quesDescY;
            utilObj.setPosition(ques_desc, posQuesDesc.x, posQuesDesc.y);
            if (curProgress >= reqProgress) {
                curProgress = reqProgress;
            }
            var questProgressPercent = curProgress / reqProgress;
            var fullProgressBarLength = questProgressPercent * progressBarLength;
            var diff = 30;
            /*questCenterLayer.paramsMap["emptyProgressBar"] = utilObj.getScale9Sprite(constantsObj.full_bar_2, questCenterLayer.paramsMap["milesXPos"] + diff, milesYPos - progressBarY, 0, 1.0, progressBarLength, 18,
                questCenterLayer.paramsMap["spriteArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["bgZOrder"] + 1, questConfigObj.getConfigData("SPRITE_MISC"));
            questCenterLayer.paramsMap["fullProgressBar"] = utilObj.getScale9Sprite(constantsObj.progress_bar_2, questCenterLayer.paramsMap["milesXPos"] + diff, milesYPos - progressBarY, 0, 1.0, fullProgressBarLength, 18,
                questCenterLayer.paramsMap["spriteArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["bgZOrder"] + 1, questConfigObj.getConfigData("SPRITE_MISC"));*/
            if (curProgress == undefined || curProgress == NaN) {
                curProgress = 0;
            }
            /*ProgressLabel = utilObj.getBMFontLabel(questCenterLayer.paramsMap["currentProgressForQuest"] + "/" + questCenterLayer.paramsMap["reqProgressForQuest"], constantsObj.FONT_SFCOMPACT_MEDIUM_40, constantsObj.COLOR_BLACK,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), milesXPos + progressBarLength + textMargin + 30, milesYPos - ratioBarY, 0, 1.0, questCenterLayer.paramsMap["labelArr"], questCenterLayer.paramsMap["layer"], questCenterLayer.paramsMap["bgZOrder"] + 1);*/
            ProgressLabel.setVisible(true);
            var progressLabelXPos = milesXPos + progressBarLength + textMargin + 30;
            var progressLabelYPos = milesYPos - ratioBarY;
            utilObj.setPosition(ProgressLabel, progressLabelXPos, progressLabelYPos);
            if (ProgressLabel != undefined) {
                ProgressLabel.setString(curProgress + "" + "/" + reqProgress + "");
            }
            if (paramsMapShouldFade) {
                if (ProgressLabel != undefined) {
                    utilObj.setOpacity(ProgressLabel, 0);
                }
                utilObj.delayedCallback(layer, xpromoAnimationObj.animateQuestParticles, 3.2, {"node": ProgressLabel}, false);
                utilObj.setOpacity(fullProgressBar, 0);
                utilObj.delayedCallback(layer, xpromoAnimationObj.animateQuestParticles, 3.2, {"node": fullProgressBar}, false);
                utilObj.setOpacity(emptyProgressBar, 0);
                utilObj.delayedCallback(layer, xpromoAnimationObj.animateQuestParticles, 3.2, {"node": emptyProgressBar}, false);
            }
            var progressBarXPos = milesXPos + diff;
            var progressBarYPos = milesYPos - progressBarY;
            utilObj.setPosition(emptyProgressBar, progressBarXPos, progressBarYPos);
            utilObj.setPosition(fullProgressBar, progressBarXPos, progressBarYPos);
            // emptyProgressBar.setContentSize(cc.size(progressBarLength, emptyProgressBar.getContentSize().height));
            emptyProgressBar.setVisible(true);
            fullProgressBar.setVisible(true);
            emptyProgressBar.width = progressBarLength;
            fullProgressBar.width = fullProgressBarLength;
            emptyProgressBar.setColor(constantsObj.COLOR_EMPTY_PROGRESS_BAR);
            fullProgressBar.setColor(constantsObj.COLOR_FULL_PROGRESS_BAR);
            if (fullProgressBarLength == progressBarLength) {
                emptyProgressBar.setColor(constantsObj.COLOR_FULL_PROGRESS_BAR);
                utilObj.setVisible(fullProgressBar, false);
            }
        }
        questCenterLayer.paramsMap["progressBarY"] = progressBarY;
        questCenterLayer.paramsMap["ratioBarY"] = ratioBarY;

        //code for addqctimerlabels

        if (questStatus == xpromoConstantsObj.QUEST_COMPLETED || (timerBar == undefined || timerBarLbl == undefined)) {
            return;
        }

        var timeLimit = questCenterLayer.paramsMap["timeLimit"];
        var params = questCenterLayer.paramsMap["params"];
        var isRequest = questCenterLayer.paramsMap["isRequest"];
        var timerMargin = 140;
        var timerBarWidth = 50;
        var timerBarLength = 200;
        var curTimestamp = utilObj.getCurrentTimestamp();
        var timerBarVisible = true;
        if (questStatus == xpromoConstantsObj.QUEST_COMPLETED) {
            timerBarVisible = false;
        }
        if (timeLimit != undefined && timeLimit != null && timeLimit != 0 && params != undefined && params != null) {
            if (params[1] != undefined && params[1] != null) {
                var timerBarValue, timerBarStr;
                timerBarValue = parseInt(params[1]) + parseInt(timeLimit) - curTimestamp;
                if (questType.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0) {
                    timerBarStr = xpromoUtilObj.formatTimeForCgdq(timerBarValue);
                } else {
                    timerBarStr = utilObj.formatTime(timerBarValue);
                }
                var timerYPos, timerXPos;
                if (isRequest == "1" || progressBar != true) {
                    timerYPos = milesYPos - progressBarY - 10;
                    timerXPos = milesXPos + progressBarLength + textMargin + timerMargin;
                } else {
                    timerYPos = emptyProgressBar.getPositionY() - 10;
                    timerXPos = milesXPos + progressBarLength + textMargin + timerMargin;
                }
                var layer = questCenterLayer.scrollView;
                if (!(dailyQuestsObj.isDailyQuestOrStreakQuest(questType) || (crossGameDailyQuestsObj.getCurrentCGDQExp() != constantsObj.EXP_VAR_3 && questType.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0))) {
                    utilObj.setPosition(timerBar, timerXPos, timerYPos);
                    timerBar.setColor(constantsObj.COLOR_TIMER_BAR);
                    timerBarLbl.setString(timerBarStr);
                    utilObj.setPosition(timerBarLbl, timerXPos + timerBarLength / 2, timerYPos);
                    timerBar.setVisible(timerBarVisible);
                    timerBarLbl.setVisible(timerBarVisible);
                }
                if (paramsMapShouldFade) {
                    utilObj.setOpacity(timerBar, 0);
                    utilObj.delayedCallback(layer, xpromoAnimationObj.animateQuestParticles, 3.2, {"node": timerBar}, false);
                    utilObj.setOpacity(timerBarLbl, 0);
                    utilObj.delayedCallback(layer, xpromoAnimationObj.animateQuestParticles, 3.2, {"node": timerBarLbl}, false);
                }
                var timerParams = {
                    startTime: params[1],
                    timeLimit: timeLimit,
                    lbl: timerBarLbl,
                    loopIndex: loopIndex,
                    questId: questId
                };
                if (!dailyQuestsObj.isDailyQuestOrStreakQuest(questType)) {
                    if (questType.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0) {
                        timerParams = {
                            startTime: params[1],
                            timeLimit: timeLimit,
                            lbl: timerBarLbl,
                            questType: questType
                        };
                    }
                    questCenterLayer.timerLabelParams.push(timerParams);
                }
                /*if (timerBar != undefined && timerBar != null) {
                    questCenterLayer.addUiReferenceForQuest(questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["loopIndex"], "timerBar", timerBar);
                }
                if (timerBarLbl != undefined && timerBarLbl != null) {
                    questCenterLayer.addUiReferenceForQuest(questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["loopIndex"], "timerBarLbl", timerBarLbl);
                }*/
            }
        }
    },

    addQcTimerLabels: function (questType) {
        var timerMargin = 140;
        var timerBarWidth = 50;
        var timerBarLength = 200;
        var curTimestamp = utilObj.getCurrentTimestamp();
        if (questCenterLayer.paramsMap["timeLimit"] != undefined && questCenterLayer.paramsMap["timeLimit"] != null && questCenterLayer.paramsMap["timeLimit"] != 0 && questCenterLayer.paramsMap["params"] != undefined && questCenterLayer.paramsMap["params"] != null) {
            if (questCenterLayer.paramsMap["params"][1] != undefined && questCenterLayer.paramsMap["params"][1] != null) {
                var timerBar, timerBarLbl;
                var timerBarValue, timerBarStr;
                timerBarValue = parseInt(questCenterLayer.paramsMap["params"][1]) + parseInt(questCenterLayer.paramsMap["timeLimit"]) - curTimestamp;
                if (questType.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0) {
                    timerBarStr = xpromoUtilObj.formatTimeForCgdq(timerBarValue);
                } else {
                    timerBarStr = utilObj.formatTime(timerBarValue);
                }
                var timerYPos, timerXPos;
                if (questCenterLayer.paramsMap["isRequest"] == "1" || questCenterLayer.paramsMap["progressBar"] != true) {
                    timerYPos = questCenterLayer.paramsMap["milesYPos"] - questCenterLayer.paramsMap["progressBarY"] - 10;
                    timerXPos = questCenterLayer.paramsMap["milesXPos"] + questCenterLayer.paramsMap["progressBarLength"] + questCenterLayer.paramsMap["textMargin"] + timerMargin;
                } else {
                    timerYPos = questCenterLayer.paramsMap["emptyProgressBar"].getPositionY() - 10;
                    timerXPos = questCenterLayer.paramsMap["milesXPos"] + questCenterLayer.paramsMap["progressBarLength"] + questCenterLayer.paramsMap["textMargin"] + timerMargin;
                }
                var layer = questCenterLayer.scrollView;
                if (!(dailyQuestsObj.isDailyQuestOrStreakQuest(questType) || (crossGameDailyQuestsObj.getCurrentCGDQExp() != constantsObj.EXP_VAR_3 && questType.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0))) {
                    timerBar = utilObj.getScale9Sprite(constantsObj.white_line, timerXPos, timerYPos, 0, 0.5, timerBarLength, timerBarWidth,
                        questCenterLayer.paramsMap["spriteArr"], layer, questCenterLayer.paramsMap["bgZOrder"] + 1, questConfigObj.getConfigData("SPRITE_MISC"));

                    timerBar.setColor(constantsObj.COLOR_TIMER_BAR);
                    timerBarLbl = utilObj.getBMFontLabel(timerBarStr, constantsObj.FONT_SFCOMPACT_MEDIUM_40, constantsObj.COLOR_WHITE,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), timerXPos + timerBarLength / 2, timerYPos, 0.5, 0.5, questCenterLayer.paramsMap["labelArr"], layer, questCenterLayer.paramsMap["bgZOrder"] + 1);
                }
                if (questCenterLayer.paramsMap["shouldFade"]) {
                    utilObj.setOpacity(timerBar, 0);
                    utilObj.delayedCallback(questCenterLayer.paramsMap["layer"], xpromoAnimationObj.animateQuestParticles, 3.2, {"node": timerBar}, false);
                    utilObj.setOpacity(timerBarLbl, 0);
                    utilObj.delayedCallback(questCenterLayer.paramsMap["layer"], xpromoAnimationObj.animateQuestParticles, 3.2, {"node": timerBarLbl}, false);
                }
                var timerParams = {
                    startTime: questCenterLayer.paramsMap["params"][1],
                    timeLimit: questCenterLayer.paramsMap["timeLimit"],
                    lbl: timerBarLbl,
                    loopIndex: questCenterLayer.paramsMap["loopIndex"],
                    questId: questCenterLayer.paramsMap["questId"]
                };
                if (!dailyQuestsObj.isDailyQuestOrStreakQuest(questType)) {
                    if (questType.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0) {
                        timerParams = {
                            startTime: questCenterLayer.paramsMap["params"][1],
                            timeLimit: questCenterLayer.paramsMap["timeLimit"],
                            lbl: timerBarLbl,
                            questType: questType
                        };
                    }
                    questCenterLayer.timerLabelParams.push(timerParams);
                }
                if (timerBar != undefined && timerBar != null) {
                    questCenterLayer.addUiReferenceForQuest(questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["loopIndex"], "timerBar", timerBar);
                }
                if (timerBarLbl != undefined && timerBarLbl != null) {
                    questCenterLayer.addUiReferenceForQuest(questCenterLayer.paramsMap["questId"], questCenterLayer.paramsMap["loopIndex"], "timerBarLbl", timerBarLbl);
                }
            }
        }
    },


});