var RedirectPushNotifLayer = cc.LayerColor.extend({
    lastScreen: null,
    lastLayer: null,
    prevMode: null,
    curQuestId: "",
    linkId: "",
    scedule_name: "",
    questName: "",
    redirect: "",
    title: "",


    ctor: function () {
        this._super();
    },

    init: function () {

    },

    clearLayer: function () {
        redirectPushNotifLayerObj.setVisible(false);
        redirectPushNotifLayerObj.removeAllChildren();
    },

    back: function (from) {
        if (status)
            return;

        utilObj.updateScreenBegin(redirectPushNotifLayerObj.lastScreen);
        utilObj.updateScreen(redirectPushNotifLayerObj.lastScreen, redirectPushNotifLayerObj.lastLayer);
        redirectPushNotifLayerObj.clearLayer();
        redirectPushNotifLayerObj.lastScreen = null;
        redirectPushNotifLayerObj.lastLayer = null;

    },
    pause: function () {

    },

    resume: function () {

    },

    hide: function () {
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "push_notif", scedhule_name, questId, questName, redirect, "close", "", "");
        // utilObj.updateScreenBegin(redirectPushNotifLayerObj.lastScreen);
        // utilObj.updateScreen(redirectPushNotifLayerObj.lastScreen, redirectPushNotifLayerObj.lastLayer);
        // redirectPushNotifLayerObj.lastScreen = null;
        // redirectPushNotifLayerObj.lastLayer = null;
        // redirectPushNotifLayerObj.removeAllChildren();
        // redirectPushNotifLayerObj.setVisible(false);
        redirectPushNotifLayerObj.removeAllChildren();
        redirectPushNotifLayerObj.setVisible(false);
        questsObj.updateCrossGameStatus(redirectPushNotifLayerObj.curQuestId, redirectPushNotifLayerObj.linkId);

        // for redirection based on different experiment variants
        questsObj.redirectToPlaystoreOnClick(redirectPushNotifLayerObj.curQuestId, xpromoConstantsObj.TRACK_QUEST_NOTIF);
        if (lastLayer == undefined || lastLayer == null || lastScreen == 0) {
            homeLayer.show();
        } else {
            if (lastLayer == gameLayer) {
                xPromoGameSpecificObj.showGameLayer(xPromoGameSpecificObj.getPuzzleToShow());
            } else {
                lastLayer.show();
            }
        }
    },

    redraw: function () {
        redirectPushNotifLayerObj.hide();
        redirectPushNotifLayerObj.show();
    },

    screenSetup: function () {
        redirectPushNotifLayerObj.setColor(cc.color(255, 255, 255));
        xPromoGameSpecificObj.showOrHideBannerAd(constantsObj.SCREEN_PUSH_NOTIF_SCREEN);

        //loggerObj.debugLog("The screen status is ", curScreen, curLayer);
        if (curScreen == -1) {
            curScreen = 1;
            curLayer = homeLayer;
        }
        if (redirectPushNotifLayerObj.lastScreen == null) {
            redirectPushNotifLayerObj.lastScreen = curScreen;
        }
        if (redirectPushNotifLayerObj.lastLayer == null) {
            redirectPushNotifLayerObj.lastLayer = curLayer;
        }

    },

    show: function (questParam) {
        if (questParam == undefined) {
            homeLayer.show();
            return;
        }
        var screen = constantsObj.SCREEN_PUSH_NOTIF_SCREEN;
        xPromoGameSpecificObj.setCurScreen(screen);
        utilObj.updateScreenBegin(screen);
        var obj = questParam.split(":");
        questId = obj[1];
        linkId = obj[2];
        questName = obj[3];
        scedhule_name = obj[4];
        redirect = obj[5];
        title = obj[6];

        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "push_notif", scedhule_name, questId, questName, redirect, "view", title, "");

        //loggerObj.debugLog("The redirect parameter ", redirect, JSON.stringify(questParam));
        if (redirect == true) {
            //loggerObj.debugLog("redirected here");
            xPromoGameSpecificObj.setPushNotifGrant(true);
        } else {
            //loggerObj.debugLog("no redirected here");
            xPromoGameSpecificObj.setPushNotifGrant(false);
        }

        redirectPushNotifLayerObj.removeAllChildren();
        redirectPushNotifLayerObj.setVisible(true);
        redirectPushNotifLayerObj.screenSetup();

        utilObj.updateScreenBegin(constantsObj.SCREEN_PUSH_NOTIF_SCREEN);
        var screenId = constantsObj.SCREEN_PUSH_NOTIF_SCREEN;


        //loggerObj.debugLog("Will hide the layer");
        redirectPushNotifLayerObj.curQuestId = questId;
        redirectPushNotifLayerObj.linkId = linkId;

        utilObj.updateScreen(screenId, redirectPushNotifLayerObj);
        window.setTimeout(redirectPushNotifLayerObj.hide, 2000);

        var spriteArr = [];
        var labelArr = [];


        var spriteBg = new ccui.Scale9Sprite(res.white_rounded);

        spriteBg.setColor(constantsObj.COLOR_BLUE_01);
        spriteBg.setScale9Enabled(true);
        spriteBg.attr({
            x: centerXPos,
            y: constantsObj.DESIGN_HEIGHT,
            width: cc.director.getWinSize().width,
            anchorX: 0.5,
            anchorY: 0
        });

        redirectPushNotifLayerObj.addChild(spriteBg);

        var spriteT = utilObj.getSprite(constantsObj.push_bg, centerXPos, constantsObj.DESIGN_HEIGHT, 0.5, 1, 1, spriteArr, redirectPushNotifLayerObj, 1, constantsObj.SPRITE_LOCAL);
        // var scaleFactor = utilObj.getDeviceWidth() / spriteT.getContentSize().width;
        // spriteT.setScale(3*scaleFactor);
        var scaleFactor = utilObj.getDeviceWidth() / spriteT.width;
        //loggerObj.debugLog("the scale factor is ", scaleFactor, spriteT._getWidth(), spriteT.width);
        //spriteT.setScale(1.45*scaleFactor);

        var coin_icon = new ccui.Scale9Sprite(res.text_bg);

        coin_icon.setColor(constantsObj.COLOR_BLUE_01);
        coin_icon.setScale9Enabled(true);
        coin_icon.attr({
            x: centerXPos,
            y: centerYPos - 100,
            width: 830
        });

        redirectPushNotifLayerObj.addChild(coin_icon);

        var titleLabel = utilObj.getBMFontLabel(title, constantsObj.FONT_SFCOMPACT_MEDIUM_100, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, centerYPos, 0.5, 0.5, labelArr, redirectPushNotifLayerObj, 1, "push");

        var install_game_txt = utilObj.getBMFontLabel(questName, constantsObj.FONT_SFCOMPACT_MEDIUM_70, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, centerYPos - 100, 0.5, 0.5, labelArr, redirectPushNotifLayerObj, 1, "push");

        install_game_txt.setScale(1);


        var first_head = utilObj.getBMFontLabel("PLAYED BY", constantsObj.FONT_SFCOMPACT_MEDIUM_70, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, centerYPos - 350, 0.5, 0.5, labelArr, redirectPushNotifLayerObj, 1, "push");


        first_head.setScale(1.4);

        var sec_head = utilObj.getBMFontLabel("MILLIONS", constantsObj.FONT_SFCOMPACT_MEDIUM_70, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, centerYPos - 480, 0.5, 0.5, labelArr, redirectPushNotifLayerObj, 1, "push");
        sec_head.setScale(1.4);

        var third_head = utilObj.getBMFontLabel("WORLD WIDE", constantsObj.FONT_SFCOMPACT_MEDIUM_70, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, centerYPos - 650, 0.5, 0.5, labelArr, redirectPushNotifLayerObj, 1, "push");
        third_head.setScale(2);

        utilObj.updateScreen(screen, redirectPushNotifLayerObj);
        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);

    }
});