var wordWarsRequestLayer = cc.Layer.extend({
    bigTileSpriteArr: [],
    curTile: null,
    letterTrackLabel: null,
    tileMovementType: 0,
    bigTileWidth: 0,
    smallTileWidth: 0,
    xInitialPos: 0,
    yInitialPos: 0,
    gridSize: 0,
    vicinityDist: 50,
    rackXPos: 30,
    tilesCount: 0,
    decodedGameBoard: [],
    requestType: "wordWarsRequest",
    letterMap: {
        "A": "1",
        "B": "3",
        "C": "3",
        "D": "2",
        "E": "1",
        "F": "4",
        "G": "3",
        "H": "4",
        "I": "1",
        "J": "10",
        "K": "5",
        "L": "1",
        "M": "3",
        "N": "2",
        "O": "1",
        "P": "3",
        "Q": "11",
        "R": "1",
        "S": "1",
        "T": "1",
        "U": "3",
        "V": "4",
        "W": "4",
        "X": "8",
        "Y": "4",
        "Z": "11"
    },
    doubleLetterCoordinates: [[0, 2, 4, 2, 6, 4], [0, 2, 2, 4, 4, 6]],
    doubleWordCoordinates: [[5, 7, 1, 3], [1, 3, 5, 7]],
    tripleLetterCoordinates: [[6, 1, 3, 0, 5], [0, 1, 3, 6, 5]],
    tripleWordCoordinates: [[3, 0], [0, 3]],
    lettersLeft: "54 letters left",
    ftueArr: {
        125: "W",
        126: "O",
        128: "D"
    },
    ftueMap: {},
    currentFTUEAnimation: null,
    currentPositionValid: 0,
    originalWord: "",
    // h means horizontal slope, v means vertical Slope
    originalWordSlope: "h",
    originalWordPosition: "112",
    newWord: "",
    newWordSlope: "h",
    newWordPosition: Number.MAX_VALUE,
    playBar: null,
    play_label: null,
    button_active_color: cc.color(23, 198, 0),
    button_disabled_color: cc.color(16, 160, 183),
    wordwars_redirect: null,
    wordwars_rays: null,
    wordwars_rays_2: null,
    playNowClicked: 0,
    miniGameOpeningSrc: null,

    show: function (src) {
        wordWarsRequestLayer.bigTileSpriteArr = [];
        wordWarsRequestLayer.curTile = null;
        wordWarsRequestLayer.letterTrackLabel = null;
        wordWarsRequestLayer.tileMovementType = 0;
        wordWarsRequestLayer.bigTileWidth = 0;
        wordWarsRequestLayer.smallTileWidth = 0;
        wordWarsRequestLayer.xInitialPos = 0;
        wordWarsRequestLayer.yInitialPos = 0;
        wordWarsRequestLayer.gridSize = 15;
        wordWarsRequestLayer.rackXPos = 30;
        wordWarsRequestLayer.tilesCount = 7;
        wordWarsRequestLayer.decodedGameBoard = [];
        wordWarsRequestLayer.requestType = "wordWarsRequest";
        wordWarsRequestLayer.originalWord = "";
        // h means horizontal slope, v means vertical Slope
        wordWarsRequestLayer.originalWordSlope = "h";
        wordWarsRequestLayer.miniGameOpeningSrc = src;
        wordWarsRequestLayer.newWord = "";
        wordWarsRequestLayer.newWordSlope = "h";
        wordWarsRequestLayer.newWordPosition = Number.MAX_VALUE;
        var screen = constantsObj.SCREEN_WORD_WARS_REQUEST;
        xPromoGameSpecificObj.setCurScreen(screen);
        var screenName = utilObj.getScreenName(screen);
        utilObj.updateScreenBegin(screen);
        xPromoGameSpecificObj.hideBannerAd(screen);
        var spriteArr = [], labelArr = [];
        var zOrder = constantsObj.UI_Z_ORDER;
        var playerAbr = "P";
        var opponentAbr = "O";
        var opponentScore = "0";
        var playerStr = "Player";
        var opponentStr = "Opponent";
        var lastMoveStr = "%name% played %word% for %score% points";
        var lettersLeftStr = wordWarsRequestLayer.lettersLeft;
        var play_str = "PLAY";
        var pic_name, picUrl, receiverPicName, receiverPicUrl;
        var spriteScaling = constantsObj.SCALE_SPRITE_2;

        var requestDataArr = requestsObj.getCurrentActiveRequest();
        if (requestDataArr.length < 1) {
            return;
        }
        var requestData = requestDataArr[0];
        trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, requestData.senderRefId, "1", xpromoConstantsObj.TRACK_WARS_QUEST, constantsObj.TRACK_GAME, src, requestData.botType, requestsObj.getTrackingIdForWordwarsRequest(), "");

        if (requestData.status == xpromoConstantsObj.REQUEST_NOT_STARTED) {
            requestsObj.updateRequestStatus(requestData, xpromoConstantsObj.REQUEST_STARTED);
        }

        if (requestData.botType == "1") {
            pic_name = wordWarsRequestLayer.getBotImage(requestData.senderRefId);
            picUrl = constantsObj.MISC_SERVER_STATIC_BASE + "wordwars/Images/botProfiles/" + pic_name;
            spriteScaling = constantsObj.SCALE_TWO_POINT_FIVE * constantsObj.SPRITE_SCALING_FACTOR * (15 / 206);
        } else {
            pic_name = requestData.senderFbId + ".jpg";
            picUrl = xPromoGameSpecificObj.getFbPicUrl(requestData.senderFbId);
        }

        if (xPromoGameSpecificObj.isLoggedIn()) {
            receiverPicName = xPromoGameSpecificObj.getFbid() + ".jpg";
            receiverPicUrl = xPromoGameSpecificObj.getFbPicUrl(xPromoGameSpecificObj.getFbid());
            if (!utilObj.fileExists(receiverPicName)) {
                xPromoGameSpecificObj.downloadFileV1(receiverPicUrl, receiverPicName);
            }
            playerStr = xPromoGameSpecificObj.getName().split(" ")[0];
            playerAbr = playerStr[0];
        }

        if (!utilObj.isWeb() && !utilObj.fileExists(pic_name)) {
            xPromoGameSpecificObj.downloadFileV1(picUrl, pic_name);
        }

        var gameBoardString = "$$$$$$$7F$7R$7I$7E$7N$7D$$$";

        if (requestData.gameBoard != undefined) {
            gameBoardString = requestData.gameBoard;
        }
        if (requestData != undefined) {
            lastMoveStr = lastMoveStr.replace("%name%", requestData.senderName);
            lastMoveStr = lastMoveStr.replace("%score%", requestData.senderScore);
            opponentStr = requestData.senderName.split(" ")[0];
            opponentAbr = requestData.senderName[0];
            opponentScore = requestData.senderScore;
        }

        cc.director.setClearColor(cc.color(31, 160, 181));

        // utilObj.getSprite(xpromoConstantsObj.tile_holder, );
        wordWarsRequestLayer.getDecodedGameBoard(gameBoardString);

        // top portion
        var header = utilObj.getScale9Sprite(constantsObj.tile_white, 0, constantsObj.DESIGN_HEIGHT - 225, 0, 0, canvasWidth, 225, spriteArr,
            wordWarsRequestLayer, zOrder, constantsObj.SPRITE_MISC);
        header.setColor(cc.color(62, 186, 198));

        var backBtn = utilObj.getSprite(xpromoConstantsObj.back_btn, 50, constantsObj.DESIGN_HEIGHT - (225) / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_3, spriteArr, wordWarsRequestLayer, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
        backBtn.setColor(cc.color(0, 46, 91));
        var backButton = utilObj.getButton(100, 225, 0.5, 0.5,
            50, constantsObj.DESIGN_HEIGHT - (225) / 2, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'wordWarsRequestLayer',
                fn: 'back',
                screen: screen,
                params: {"sound": constantsObj.button_tap_01, "sound_on": true, "src": src},
                track: {
                    k: "",
                    p: "",
                    c: xPromoGameSpecificObj.getPhylumForTracking(),
                    o: xPromoGameSpecificObj.getClassForTracking(),
                    f: constantsObj.TRACK_BACK,
                    g: "",
                    s: xPromoGameSpecificObj.getSpeciesForTracking(),
                    co: 1,
                    oppId: ""
                },
                feedBackType: constantsObj.ZOOMIN_FEEDBACK
            }, false, ccui.Widget.PLIST_TEXTURE, constantsObj.SCALE_ONE);
        wordWarsRequestLayer.addChild(backButton, zOrder);

        var playerBgX = 100 + (centerXPos - 100) / 2;
        var yPos = constantsObj.DESIGN_HEIGHT - (225) / 2;

        var playerCircularPic;
        if (utilObj.isWeb() || utilObj.fileExists(receiverPicName)) {
            playerCircularPic = utilObj.getSprite(xpromoUtilObj.getAbsFilePath(receiverPicName), 130, yPos, 0, 0.5, constantsObj.SCALE_SPRITE_2, spriteArr, wordWarsRequestLayer, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
        } else {
            playerCircularPic = utilObj.getSprite(xpromoConstantsObj.circle_player, 130, yPos, 0, 0.5, constantsObj.SCALE_SPRITE_2, spriteArr, wordWarsRequestLayer, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
            playerCircularPic.setColor(cc.color(0, 46, 91));

            var playerAbrLabel = utilObj.getBMFontLabel(playerAbr, constantsObj.FONT_SFCOMPACT_MEDIUM_40, constantsObj.COLOR_WHITE, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 220, yPos, 0.5, 0.5, labelArr, wordWarsRequestLayer, zOrder);
            playerAbrLabel.setScale(playerAbrLabel.getScale() * 10 / 4);
        }
        var playerStringLabel = utilObj.getTTFFontLabel(playerStr, constantsObj.FONT_SFCOMPACT_MEDIUM_40, cc.color(0, 46, 91), constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 340, yPos - 40, 0, 0.5, labelArr, wordWarsRequestLayer, zOrder);
        playerStringLabel.setScale(playerStringLabel.getScale() * 1.9);

        var playerScoreLabel = utilObj.getBMFontLabel("0", constantsObj.FONT_SFCOMPACT_MEDIUM_40, cc.color(0, 46, 91), constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 340, yPos + 40, 0, 0.5, labelArr, wordWarsRequestLayer, zOrder);
        playerScoreLabel.setScale(playerScoreLabel.getScale() * 2);

        var playerBg = utilObj.getScale9Sprite(xpromoConstantsObj.player_bg, playerBgX, yPos, 0.5, 0.5, centerXPos - 100 - 35, 200, spriteArr,
            wordWarsRequestLayer, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
        playerBg.setRotationY(180.0);

        var opponentCircularPic;
        if (utilObj.isWeb() || utilObj.fileExists(pic_name)) {
            opponentCircularPic = utilObj.getSprite(xpromoUtilObj.getAbsFilePath(pic_name), canvasWidth - 130, yPos, 1, 0.5, spriteScaling, spriteArr, wordWarsRequestLayer, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
        } else {
            opponentCircularPic = utilObj.getSprite(xpromoConstantsObj.circle_player, canvasWidth - 130, yPos, 1, 0.5, constantsObj.SCALE_SPRITE_2, spriteArr, wordWarsRequestLayer, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
            opponentCircularPic.setColor(cc.color(0, 46, 91));
            var OpponentAbrLabel = utilObj.getBMFontLabel(opponentAbr, constantsObj.FONT_SFCOMPACT_MEDIUM_40, constantsObj.COLOR_WHITE, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), canvasWidth - 220, yPos, 0.5, 0.5, labelArr, wordWarsRequestLayer, zOrder);
            OpponentAbrLabel.setScale(OpponentAbrLabel.getScale() * 10 / 4);
            xPromoGameSpecificObj.downloadFileV1(picUrl, pic_name);
        }

        var opponentBgX = canvasWidth - 100 - (centerXPos - 100) / 2;
        var opponentBg = utilObj.getScale9Sprite(xpromoConstantsObj.player_bg, opponentBgX, yPos, 0.5, 0.5, centerXPos - 100 - 35, 200, spriteArr,
            wordWarsRequestLayer, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
        opponentBg.setColor(cc.color(112, 202, 211));
        // opponentBg.setOpacity(constantsObj.OPACITY_25);


        var opponentStringLabel = utilObj.getTTFFontLabel(opponentStr, constantsObj.FONT_SFCOMPACT_MEDIUM_40, constantsObj.COLOR_WHITE, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), canvasWidth - 340, yPos - 40, 1, 0.5, labelArr, wordWarsRequestLayer, zOrder);
        opponentStringLabel.setScale(opponentStringLabel.getScale() * 1.9);

        var opponentScoreLabel = utilObj.getBMFontLabel(opponentScore, constantsObj.FONT_SFCOMPACT_MEDIUM_40, constantsObj.COLOR_WHITE, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), canvasWidth - 340, yPos + 40, 1, 0.5, labelArr, wordWarsRequestLayer, zOrder);
        opponentScoreLabel.setScale(opponentScoreLabel.getScale() * 2);

        var lastMoveBar = utilObj.getScale9Sprite(constantsObj.tile_white, 0, constantsObj.DESIGN_HEIGHT - 225, 0, 1, canvasWidth, 85, spriteArr,
            wordWarsRequestLayer, zOrder, constantsObj.SPRITE_MISC);
        lastMoveBar.setColor(cc.color(11, 68, 81));

        lastMoveStr = lastMoveStr.replace("%word%", wordWarsRequestLayer.originalWord);
        var lastMoveLabel = utilObj.getBMFontLabel(lastMoveStr, constantsObj.FONT_SFCOMPACT_MEDIUM_40, constantsObj.COLOR_WHITE, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, constantsObj.DESIGN_HEIGHT - (225 + 85 / 2), 0.5, 0.5, labelArr, wordWarsRequestLayer, zOrder);
        lastMoveLabel.setScale(lastMoveLabel.getScale() * 5 / 4);

        var playWithFriends = utilObj.getScale9Sprite(constantsObj.tile_white, 0, constantsObj.DESIGN_HEIGHT - 225 - 85, 0, 1, canvasWidth, 220, spriteArr,
            wordWarsRequestLayer, zOrder, constantsObj.SPRITE_MISC);
        playWithFriends.setColor(cc.color(246, 187, 26));

        var boredLabel = utilObj.getBMFontLabel(stringsObj.bored_of_playing, constantsObj.FONT_SFCOMPACT_MEDIUM_40, cc.color(0, 63, 78), constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, constantsObj.DESIGN_HEIGHT - 225 - 85 - 220 / 3, 0.5, 0.5, labelArr, wordWarsRequestLayer, zOrder);
        boredLabel.setScale(boredLabel.getScale() * 1.5);
        var playWithFriends = utilObj.getBMFontLabel(stringsObj.play_with_friends, constantsObj.FONT_SFCOMPACT_MEDIUM_40, cc.color(105, 49, 0), constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, constantsObj.DESIGN_HEIGHT - 225 - 85 - 440 / 3, 0.5, 0.5, labelArr, wordWarsRequestLayer, zOrder);
        playWithFriends.setScale(playWithFriends.getScale() * 2);
        var gridTotalSize = Math.min(constantsObj.DESIGN_HEIGHT - 1000, canvasWidth);
        var tileWidth = (gridTotalSize - 180) / 15;
        wordWarsRequestLayer.smallTileWidth = tileWidth;
        wordWarsRequestLayer.xInitialPos = (canvasWidth - tileWidth * 15 - 140) / 2;
        wordWarsRequestLayer.yInitialPos = 600 + (constantsObj.DESIGN_HEIGHT - 600 - 310 - 220) / 2 + 7 * (tileWidth + 10);
        var topShift = 0;

        var gridSize = wordWarsRequestLayer.gridSize;
        var powerStr = "";
        for (var i = 0; i < gridSize; i++) {
            for (var j = 0; j < gridSize; j++) {

                // double letter power tiles
                if (wordWarsRequestLayer.decodedGameBoard[i][j] == '.') {
                    powerStr = "";
                    if (wordWarsRequestLayer.checkIfSymmetricPoint(i, j, wordWarsRequestLayer.doubleLetterCoordinates[0], wordWarsRequestLayer.doubleLetterCoordinates[1], gridSize)) {
                        var curSprite = utilObj.getScale9Sprite(xpromoConstantsObj.tile_power, wordWarsRequestLayer.xInitialPos + j * (tileWidth + 10), wordWarsRequestLayer.yInitialPos - i * (tileWidth + 10), 0, 0.5, tileWidth, tileWidth, spriteArr, wordWarsRequestLayer, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
                        curSprite.setColor(cc.color(146, 180, 108));
                        powerStr = xpromoConstantsObj.double_letter_abr;
                    }
                    // triple word power tiles
                    else if (wordWarsRequestLayer.checkIfSymmetricPoint(i, j, wordWarsRequestLayer.tripleWordCoordinates[0], wordWarsRequestLayer.tripleWordCoordinates[1], gridSize)) {
                        var curSprite = utilObj.getScale9Sprite(xpromoConstantsObj.tile_power, wordWarsRequestLayer.xInitialPos + j * (tileWidth + 10), wordWarsRequestLayer.yInitialPos - i * (tileWidth + 10), 0, 0.5, tileWidth, tileWidth, spriteArr, wordWarsRequestLayer, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
                        curSprite.setColor(cc.color(0, 94, 135));
                        powerStr = xpromoConstantsObj.triple_word_abr;
                    }
                    // triple letter power tiles
                    else if (wordWarsRequestLayer.checkIfSymmetricPoint(i, j, wordWarsRequestLayer.tripleLetterCoordinates[0], wordWarsRequestLayer.tripleLetterCoordinates[1], gridSize)) {
                        var curSprite = utilObj.getScale9Sprite(xpromoConstantsObj.tile_power, wordWarsRequestLayer.xInitialPos + j * (tileWidth + 10), wordWarsRequestLayer.yInitialPos - i * (tileWidth + 10), 0, 0.5, tileWidth, tileWidth, spriteArr, wordWarsRequestLayer, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
                        curSprite.setColor(cc.color(216, 135, 135));

                        powerStr = xpromoConstantsObj.triple_letter_abr;
                    }
                    // double word power tiles
                    else if (wordWarsRequestLayer.checkIfSymmetricPoint(i, j, wordWarsRequestLayer.doubleWordCoordinates[0], wordWarsRequestLayer.doubleWordCoordinates[1], gridSize)) {
                        var curSprite = utilObj.getScale9Sprite(xpromoConstantsObj.tile_power, wordWarsRequestLayer.xInitialPos + j * (tileWidth + 10), wordWarsRequestLayer.yInitialPos - i * (tileWidth + 10), 0, 0.5, tileWidth, tileWidth, spriteArr, wordWarsRequestLayer, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
                        curSprite.setColor(cc.color(252, 189, 48));
                        powerStr = xpromoConstantsObj.double_word_abr;
                    } else {
                        var curSprite = utilObj.getScale9Sprite(xpromoConstantsObj.tile_holder, wordWarsRequestLayer.xInitialPos + j * (tileWidth + 10), wordWarsRequestLayer.yInitialPos - i * (tileWidth + 10), 0, 0.5, tileWidth, tileWidth, spriteArr, wordWarsRequestLayer, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
                    }

                    if (powerStr != "") {
                        utilObj.getBMFontLabel(powerStr, constantsObj.FONT_SFCOMPACT_MEDIUM_40, constantsObj.COLOR_WHITE,
                            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), wordWarsRequestLayer.xInitialPos + tileWidth / 2 + j * (tileWidth + 10), wordWarsRequestLayer.yInitialPos - i * (tileWidth + 10), 0.5, 0.5, labelArr, wordWarsRequestLayer, zOrder);
                    }
                }
                if (wordWarsRequestLayer.decodedGameBoard[i][j] != '.' || (requestsObj.getIsWordWarsFtueSeen() == false && wordWarsRequestLayer.ftueArr[i * wordWarsRequestLayer.gridSize + j] != undefined)) {
                    var labelStr = wordWarsRequestLayer.decodedGameBoard[i][j], scoreStr = "0";
                    if (wordWarsRequestLayer.decodedGameBoard[i][j] == '.') {
                        labelStr = wordWarsRequestLayer.ftueArr[i * wordWarsRequestLayer.gridSize + j];
                        scoreStr = wordWarsRequestLayer.letterMap[labelStr];
                    } else {
                        scoreStr = wordWarsRequestLayer.letterMap[wordWarsRequestLayer.decodedGameBoard[i][j]];
                    }
                    var bigTileSprite = utilObj.getSprite(xpromoConstantsObj.tile_board, wordWarsRequestLayer.xInitialPos + j * (tileWidth + 10) + tileWidth / 2, wordWarsRequestLayer.yInitialPos - i * (tileWidth + 10), 0.5, 0.5, constantsObj.SCALE_SPRITE_13, spriteArr, wordWarsRequestLayer, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
                    bigTileSprite.setScale(wordWarsRequestLayer.smallTileWidth / bigTileSprite.getContentSize().width);

                    var letterLabel = utilObj.getBMFontLabel(labelStr, constantsObj.FONT_SFCOMPACT_MEDIUM_40, cc.color(0, 46, 91),
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), wordWarsRequestLayer.xInitialPos + tileWidth / 2 + j * (tileWidth + 10), wordWarsRequestLayer.yInitialPos - i * (tileWidth + 10) + 0.1 * wordWarsRequestLayer.smallTileWidth, 0.5, 0.5, labelArr, wordWarsRequestLayer, zOrder);
                    letterLabel.setScale(letterLabel.getScale() * 65 / 40);

                    var scoreLabel = utilObj.getBMFontLabel(scoreStr.toString(), constantsObj.FONT_SFCOMPACT_MEDIUM_40, cc.color(0, 46, 91),
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), wordWarsRequestLayer.xInitialPos + tileWidth * 0.15 + j * (tileWidth + 10), wordWarsRequestLayer.yInitialPos - i * (tileWidth + 10) - 0.3 * wordWarsRequestLayer.smallTileWidth, 0.5, 0.5, labelArr, wordWarsRequestLayer, zOrder);
                    scoreLabel.setScale(scoreLabel.getScale() * 24 / 40);

                    if (wordWarsRequestLayer.decodedGameBoard[i][j] == '.') {
                        bigTileSprite.setOpacity(constantsObj.OPACITY_50);
                        letterLabel.setOpacity(constantsObj.OPACITY_50);
                        scoreLabel.setOpacity(constantsObj.OPACITY_50);
                        wordWarsRequestLayer.ftueMap[i * wordWarsRequestLayer.gridSize + j] = {
                            "tileSprite": bigTileSprite,
                            "tileLabel": letterLabel,
                            "scoreLabel": scoreLabel
                        };
                    }
                }

            }
        }

        // Horizontal Line
        var horizontalLineYpos = 600;
        var horizontalLine = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, horizontalLineYpos, 0.5, 0.5, canvasWidth, 4, spriteArr,
            wordWarsRequestLayer, zOrder, constantsObj.SPRITE_MISC);
        horizontalLine.setColor(constantsObj.COLOR_BLACK);
        horizontalLine.setOpacity(constantsObj.OPACITY_25);

        // letters rack
        var rack = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, horizontalLineYpos - 180, 0.5, 0.5, canvasWidth, 360, spriteArr,
            wordWarsRequestLayer, zOrder, constantsObj.SPRITE_MISC);
        rack.setColor(cc.color(62, 186, 198));

        wordWarsRequestLayer.letterTrackLabel = utilObj.getBMFontLabel(lettersLeftStr, constantsObj.FONT_SFCOMPACT_MEDIUM_40, cc.color(0, 46, 91), constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, horizontalLineYpos - 56, 0.5, 0.5, labelArr, wordWarsRequestLayer, zOrder);
        wordWarsRequestLayer.letterTrackLabel.setScale(wordWarsRequestLayer.letterTrackLabel.getScale() * 55 / 40);

        // big tile
        var tilesCount = wordWarsRequestLayer.tilesCount;
        var bigTileWidth = Math.min((canvasWidth - 180) / tilesCount, 200);
        wordWarsRequestLayer.bigTileWidth = bigTileWidth;
        var tileChars = ["W", "O", "R", "D", "I", "N", "G"];
        wordWarsRequestLayer.rackXPos = (canvasWidth - bigTileWidth * 7 - 120) / 2;
        var leftPos = wordWarsRequestLayer.rackXPos;
        for (var i = 0; i < tilesCount; i++) {
            var bigTileSprite = utilObj.getSprite(xpromoConstantsObj.tile_board, leftPos + bigTileWidth / 2 + i * (bigTileWidth + 20), horizontalLineYpos - 112 - bigTileWidth / 2, 0.5, 0.5, constantsObj.SCALE_SPRITE_13, spriteArr, wordWarsRequestLayer, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
            bigTileSprite.setScale(bigTileWidth / bigTileSprite.getContentSize().width);

            var tileLabel = utilObj.getBMFontLabel(tileChars[i], constantsObj.FONT_SFCOMPACT_MEDIUM_40, cc.color(0, 46, 91), constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), leftPos + i * (bigTileWidth + 20) + bigTileWidth / 2, horizontalLineYpos - 112 - 0.4 * bigTileWidth, 0.5, 0.5, labelArr, wordWarsRequestLayer, zOrder);
            tileLabel.setScale(tileLabel.getScale() * 135 / 40);

            var scoreLabel = utilObj.getBMFontLabel(wordWarsRequestLayer.letterMap[tileChars[i]], constantsObj.FONT_SFCOMPACT_MEDIUM_40, cc.color(0, 46, 91), constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), leftPos + i * (bigTileWidth + 20) + bigTileWidth * 0.15, horizontalLineYpos - 112 - 0.8 * bigTileWidth, 0.5, 0.5, labelArr, wordWarsRequestLayer, zOrder);

            wordWarsRequestLayer.bigTileSpriteArr.push({
                "tileSprite": bigTileSprite,
                "tileLabel": tileLabel,
                "scoreLabel": scoreLabel,
                "onRack": 1,
                "rackIndex": i,
                "boardIndex": [-1, -1],
            });
        }

        // play bar
        var bottom_btn = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, 120, 0.5, 0.5, canvasWidth, 240, spriteArr,
            wordWarsRequestLayer, zOrder, constantsObj.SPRITE_MISC);
        bottom_btn.setColor(cc.color(11, 68, 81));

        wordWarsRequestLayer.playBar = utilObj.getScale9Sprite(xpromoConstantsObj.play_btn, centerXPos, 120, 0.5, 0.5, 500, 150, spriteArr,
            wordWarsRequestLayer, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
        wordWarsRequestLayer.playBar.setColor(wordWarsRequestLayer.button_disabled_color)
        wordWarsRequestLayer.play_label = utilObj.getBMFontLabel(play_str, constantsObj.FONT_SFCOMPACT_MEDIUM_40, wordWarsRequestLayer.button_disabled_color, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), centerXPos, 120, 0.5, 0.5, labelArr, wordWarsRequestLayer, zOrder);
        wordWarsRequestLayer.play_label.setScale(wordWarsRequestLayer.play_label.getScale() * 2);

        var playButton = utilObj.getButton(canvasWidth, 240, 0.5, 0.5,
            centerXPos, 120, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'wordWarsRequestLayer',
                fn: 'playNow',
                screen: screen,
                params: {"sound": constantsObj.button_tap_01, "sound_on": true},
                track: {
                    k: "",
                    p: "",
                    c: "",
                    o: "",
                    f: "",
                    g: "",
                    s: "",
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, constantsObj.SCALE_ONE);
        wordWarsRequestLayer.addChild(playButton, constantsObj.UI_Z_ORDER);

        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);

        if (requestsObj.getIsWordWarsFtueSeen() == false) {
            wordWarsRequestLayer.playFTUE();
        }

        utilObj.updateScreen(screen, wordWarsRequestLayer);

        if(xPromoGameSpecificObj.isUserInteractionTrackingEnabled()) {
            machineLearningDataObj.incUserOpenedWarsRequest();
        }
        pspnUserTracking.trackUserSnapshot(constantsObj.SCREEN_WORD_WARS_REQUEST, constantsObj.TRACK_VIEW);
    },

    back: function (sender, params) {
        if (wordWarsRequestLayer.playNowClicked == 1) {
            return;
        }
        wordWarsRequestLayer.hide();

        if (wordWarsRequestLayer.miniGameOpeningSrc == xpromoConstantsObj.PUSH_NOTIF || wordWarsRequestLayer.miniGameOpeningSrc == undefined) {
            if (gameLayer.puzzleIndex == undefined) {
                // var puzToShow = xPromoGameSpecificObj.getPuzzleIdForIndex(xPromoGameSpecificObj.getPuzCompleted(), false);
                // gameLayer.show(puzToShow, constantsObj.NOT_FOUND);
                gameLayer.openCurrentIncompletedPuzzle();
            } else {
                gameLayer.show();
            }
        } else {
            questCenterLayer.show();
        }
        var requestData = requestsObj.getCurrentActiveRequest()[0];
        trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, requestData.senderRefId, "1", xpromoConstantsObj.TRACK_WARS_QUEST, constantsObj.TRACK_CLOSE, wordWarsRequestLayer.miniGameOpeningSrc, requestData.botType, "", "");
    },

    hide: function () {
        wordWarsRequestLayer.stopAllActions();
        wordWarsRequestLayer.removeAllChildren();
        utilObj.setVisible(wordWarsRequestLayer, false);
    },

    onTouchesBegan: function (touch, event) {
        // picking tile from rack
        if (wordWarsRequestLayer.playNowClicked == 1) {
            return;
        }
        if (requestsObj.getIsWordWarsFtueSeen() == false) {
            // wordWarsRequestLayer.removeAllActions();
            requestsObj.setIsWordWarsFtueSeen(true);

            wordWarsRequestLayer.bigTileSpriteArr[0].tileSprite.stopAllActions();
            wordWarsRequestLayer.bigTileSpriteArr[0].tileLabel.stopAllActions();
            wordWarsRequestLayer.bigTileSpriteArr[0].scoreLabel.stopAllActions();

            var xPos = wordWarsRequestLayer.bigTileSpriteArr[1].tileSprite.getPositionX() - wordWarsRequestLayer.bigTileWidth - 20,
                yPos = wordWarsRequestLayer.bigTileSpriteArr[1].tileSprite.getPositionY();
            utilObj.setPosition(wordWarsRequestLayer.bigTileSpriteArr[0].tileSprite, xPos, yPos);
            utilObj.setPosition(wordWarsRequestLayer.bigTileSpriteArr[0].tileLabel, xPos, yPos + 0.1 * wordWarsRequestLayer.bigTileWidth);
            utilObj.setPosition(wordWarsRequestLayer.bigTileSpriteArr[0].scoreLabel, xPos - 0.35 * wordWarsRequestLayer.bigTileWidth, yPos - 0.3 * wordWarsRequestLayer.bigTileWidth);

            // wordWarsRequestLayer.bigTileSpriteArr[0].tileSprite.setPosition(xPos, yPos);
            // wordWarsRequestLayer.bigTileSpriteArr[0].tileLabel.setPosition(xPos, yPos + 0.1 * wordWarsRequestLayer.bigTileWidth);
            // wordWarsRequestLayer.bigTileSpriteArr[0].scoreLabel.setPosition(xPos - 0.35 * wordWarsRequestLayer.bigTileWidth, yPos - 0.3 * wordWarsRequestLayer.bigTileWidth);

            wordWarsRequestLayer.bigTileSpriteArr[0].tileSprite.setScale(wordWarsRequestLayer.bigTileSpriteArr[1].tileSprite.getScale());
            wordWarsRequestLayer.bigTileSpriteArr[0].tileLabel.setScale(wordWarsRequestLayer.bigTileSpriteArr[1].tileLabel.getScale());
            wordWarsRequestLayer.bigTileSpriteArr[0].scoreLabel.setScale(wordWarsRequestLayer.bigTileSpriteArr[1].scoreLabel.getScale());

            for (var tile in wordWarsRequestLayer.ftueMap) {
                wordWarsRequestLayer.ftueMap[tile].tileSprite.setVisible(false);
                wordWarsRequestLayer.ftueMap[tile].tileLabel.setVisible(false);
                wordWarsRequestLayer.ftueMap[tile].scoreLabel.setVisible(false);
            }
        }
        wordWarsRequestLayer.tileMovementType = 0;
        var touchY = touch.getLocation().y, touchX = touch.getLocation().x;
        if (touchY < 600 && touchY > 240) {
            var tileIndex = Math.ceil(touchX / (canvasWidth / 7)) - 1;
            if (wordWarsRequestLayer.bigTileSpriteArr[tileIndex].tileSprite.getPositionY() <= 600) {
                wordWarsRequestLayer.curTile = wordWarsRequestLayer.bigTileSpriteArr[tileIndex];
                wordWarsRequestLayer.setTilePos(wordWarsRequestLayer.curTile, touchX, touchY, constantsObj.UI_Z_ORDER + 1, 1, 0);
                wordWarsRequestLayer.tileMovementType = 1;
                wordWarsRequestLayer.curTile.onRack = 0;
            }
        }
        // picking from game board
        else if (touchY >= 600) {
            var minDist = Number.MAX_VALUE, tileIndex = -1;
            for (var i = 0; i < wordWarsRequestLayer.bigTileSpriteArr.length; i++) {
                if (wordWarsRequestLayer.bigTileSpriteArr[i].onRack == 0) {
                    wordWarsRequestLayer.curTile = wordWarsRequestLayer.bigTileSpriteArr[i];
                    var sprite = wordWarsRequestLayer.curTile.tileSprite;
                    if (wordWarsRequestLayer.checkIfInVicinity(touchX, touchY, sprite.getPositionX(), sprite.getPositionY(), wordWarsRequestLayer.vicinityDist)) {
                        var dist = wordWarsRequestLayer.getDistance(touchX, touchY, sprite.getPositionX(), sprite.getPositionY());
                        if (minDist > dist) {
                            minDist = dist;
                            tileIndex = i;
                        }
                    }
                }
            }
            if (tileIndex != -1) {
                wordWarsRequestLayer.curTile = wordWarsRequestLayer.bigTileSpriteArr[tileIndex];
                wordWarsRequestLayer.curTile.onRack = 0;
                wordWarsRequestLayer.setTilePos(wordWarsRequestLayer.curTile, touchX, touchY, constantsObj.UI_Z_ORDER + 1, 1, 1);
                wordWarsRequestLayer.tileMovementType = 2;
            }
        }
    },

    onTouchEnded: function (touch, event) {
        var touchY = touch.getLocation().y, touchX = touch.getLocation().x;
        if (touchY >= 600 && (wordWarsRequestLayer.tileMovementType == 1 || wordWarsRequestLayer.tileMovementType == 2) && wordWarsRequestLayer.curTile != null) {
            // finding xpos
            touchX = touchX - wordWarsRequestLayer.xInitialPos + 5;
            var indX = Math.ceil(touchX / (wordWarsRequestLayer.smallTileWidth + 10)) - 1;
            if (indX < 0) {
                indX = 0
            }
            if (indX >= wordWarsRequestLayer.gridSize) {
                indX = wordWarsRequestLayer.gridSize - 1;
            }
            touchX = wordWarsRequestLayer.xInitialPos + wordWarsRequestLayer.smallTileWidth / 2 + indX * (wordWarsRequestLayer.smallTileWidth + 10);
            // wordWarsRequestLayer.setTilePos(wordWarsRequestLayer.curTile, touchX, touchY, constantsObj.UI_Z_ORDER, 1, 0);

            // finding ypos
            var initialYPos = wordWarsRequestLayer.yInitialPos + wordWarsRequestLayer.smallTileWidth / 2 - 15 * (wordWarsRequestLayer.smallTileWidth + 10) + 5;
            touchY = touchY - initialYPos;
            var indY = Math.ceil(touchY / (wordWarsRequestLayer.smallTileWidth + 10)) - 1;
            if (indY < 0) {
                indY = 0
            }
            if (indY >= wordWarsRequestLayer.gridSize) {
                indY = wordWarsRequestLayer.gridSize - 1;
            }
            wordWarsRequestLayer.checkClosestEmptyGrid(indX, indY, touch.getLocation().x, touch.getLocation().y);
            // touchY = initialYPos + 5 + wordWarsRequestLayer.smallTileWidth / 2 + indY * (wordWarsRequestLayer.smallTileWidth + 10);
            // wordWarsRequestLayer.curTile.boardIndex = [wordWarsRequestLayer.gridSize - indY - 1, indX];
            // wordWarsRequestLayer.setTilePos(wordWarsRequestLayer.curTile, touchX, touchY, constantsObj.UI_Z_ORDER, 0, 1);
            wordWarsRequestLayer.curTile.onRack = 0;
            wordWarsRequestLayer.changeRackString();

        } else if (touchY < 600 && (wordWarsRequestLayer.tileMovementType == 1 || wordWarsRequestLayer.tileMovementType == 2) && wordWarsRequestLayer.curTile != null) {
            var leftX = touchX - wordWarsRequestLayer.rackXPos + 10;
            var tileIndex = Math.ceil(leftX / (wordWarsRequestLayer.bigTileWidth + 20)) - 1;
            if (tileIndex < 0) {
                tileIndex = 0;
            }
            if (tileIndex >= wordWarsRequestLayer.tilesCount) {
                tileIndex = wordWarsRequestLayer.tilesCount - 1;
            }
            var indexToSwap = -1;
            for (var i = 0; i < wordWarsRequestLayer.tilesCount; i++) {
                if (tileIndex - i >= 0 && wordWarsRequestLayer.bigTileSpriteArr[tileIndex - i].onRack == 0) {
                    indexToSwap = tileIndex - i;
                }
                if (indexToSwap == -1 && (tileIndex + i < wordWarsRequestLayer.tilesCount) && wordWarsRequestLayer.bigTileSpriteArr[tileIndex + i].onRack == 0) {
                    indexToSwap = tileIndex + i;
                }
                if (indexToSwap != -1) {
                    wordWarsRequestLayer.curTile.onRack = 1;
                    wordWarsRequestLayer.setTilePos(wordWarsRequestLayer.curTile, wordWarsRequestLayer.rackXPos + wordWarsRequestLayer.bigTileWidth / 2 + indexToSwap * (wordWarsRequestLayer.bigTileWidth + 20), 600 - 112 - wordWarsRequestLayer.bigTileWidth / 2, constantsObj.UI_Z_ORDER, 1, 0);
                    var curElement = wordWarsRequestLayer.bigTileSpriteArr[indexToSwap];
                    var newElement = wordWarsRequestLayer.curTile;
                    var curRackIndex = curElement.rackIndex, newRackIndex = newElement.rackIndex;
                    newElement.rackIndex = curRackIndex;
                    curElement.rackIndex = newRackIndex;
                    wordWarsRequestLayer.bigTileSpriteArr[curRackIndex] = newElement;
                    wordWarsRequestLayer.bigTileSpriteArr[newRackIndex] = curElement;
                    break;
                }
            }
        }
        wordWarsRequestLayer.tileMovementType = 0;
        // wordWarsRequestLayer.setLocalZOrder(constantsObj.UI_Z_ORDER);
        // wordWarsRequestLayer.setLocalZOrder(constantsObj.UI_Z_ORDER);
        wordWarsRequestLayer.curTile = null;
        wordWarsRequestLayer.changeRackString();
        // loggerObj.debugLog("this is wordwarsrequestLayer ", utilObj.getStringifiedJson(wordWarsRequestLayer.bigTileSpriteArr));
    },

    onTouchMoved: function (touch, event) {
        var touchY = touch.getLocation().y, touchX = touch.getLocation().x;
        if (wordWarsRequestLayer.curTile != null && wordWarsRequestLayer.curTile != undefined && wordWarsRequestLayer.tileMovementType != 0) {
            wordWarsRequestLayer.setTilePos(wordWarsRequestLayer.curTile, touchX, touchY, constantsObj.UI_Z_ORDER + 1, 1, 0);
        }
    },

    onTouchCancelled: function (touch, event) {

    },

    setTilePos: function (tile, xPos, yPos, zOrder, onRack, shouldChangeScale) {
        var sprite = tile.tileSprite;
        var label = tile.tileLabel;
        var scoreLabel = tile.scoreLabel;
        if (curScreen != constantsObj.SCREEN_WORD_WARS_REQUEST || !utilObj.isNodeValid(sprite)) {
            return;
        }
        sprite.setLocalZOrder(zOrder);
        label.setLocalZOrder(zOrder);
        scoreLabel.setLocalZOrder(zOrder);
        utilObj.setPosition(sprite, xPos, yPos);
        //sprite.setPosition(xPos, yPos);
        if (onRack == 1) {
            if (shouldChangeScale == 1) {
                var newScale = wordWarsRequestLayer.bigTileWidth / wordWarsRequestLayer.smallTileWidth;
                sprite.setScale(sprite.getScale() * newScale);
                label.setScale(label.getScale() * newScale);
                scoreLabel.setScale(scoreLabel.getScale() * 40 / 24);
            }
            utilObj.setPosition(label, xPos, yPos+ 0.1 * wordWarsRequestLayer.bigTileWidth);
            //label.setPosition(xPos, yPos + 0.1 * wordWarsRequestLayer.bigTileWidth);
            utilObj.setPosition(scoreLabel, xPos - 0.35 * wordWarsRequestLayer.bigTileWidth, yPos - 0.3 * wordWarsRequestLayer.bigTileWidth);
            //scoreLabel.setPosition(xPos - 0.35 * wordWarsRequestLayer.bigTileWidth, yPos - 0.3 * wordWarsRequestLayer.bigTileWidth);
        } else if (onRack == 0) {
            if (shouldChangeScale == 1) {
                var newScale = wordWarsRequestLayer.smallTileWidth / wordWarsRequestLayer.bigTileWidth;
                sprite.setScale(sprite.getScale() * newScale);
                label.setScale(label.getScale() * newScale);
                scoreLabel.setScale(scoreLabel.getScale() * 24 / 40);
            }
            utilObj.setPosition(label, xPos, yPos + 0.1 * wordWarsRequestLayer.smallTileWidth);
            //label.setPosition(xPos, yPos + 0.1 * wordWarsRequestLayer.smallTileWidth);
            utilObj.setPosition(scoreLabel, xPos - 0.35 * wordWarsRequestLayer.smallTileWidth, yPos - 0.3 * wordWarsRequestLayer.smallTileWidth);
            //scoreLabel.setPosition(xPos - 0.35 * wordWarsRequestLayer.smallTileWidth, yPos - 0.3 * wordWarsRequestLayer.smallTileWidth);
        }
    },

    checkIfInVicinity: function (x1, y1, x2, y2, d) {
        return (wordWarsRequestLayer.getDistance(x1, y1, x2, y2) < (d * d));
    },

    getDistance: function (x1, y1, x2, y2) {
        return ((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
    },

    getDecodedGameBoard: function (gameBoardString) {
        wordWarsRequestLayer.originalWord = "";
        var currRowIndex = 0, currRow = [], currColIndex = 0;
        for (var i = 0; i < gameBoardString.length; i++) {
            if (gameBoardString[i] == "$") {
                for (var j = currColIndex; j < wordWarsRequestLayer.gridSize; j++) {
                    currRow.push('.');
                }
                wordWarsRequestLayer.decodedGameBoard.push(currRow);
                currRow = [];
                currRowIndex = currRowIndex + 1;
                currColIndex = 0;
            } else if (gameBoardString[i] >= 'A' && gameBoardString[i] <= 'Z') {
                currRow.push(gameBoardString[i]);
                wordWarsRequestLayer.originalWord += gameBoardString[i];
                if (wordWarsRequestLayer.decodedGameBoard[currColIndex - 1] == ".") {
                    wordWarsRequestLayer.originalWordSlope = "h";
                } else {
                    wordWarsRequestLayer.originalWordSlope = "v";
                }
                currColIndex += 1;
            } else {
                for (var j = 0; j < parseInt(gameBoardString[i]); j++) {
                    currRow.push('.');
                }
                currColIndex += parseInt(gameBoardString[i]);
            }
        }
    },

    getEncodedGameBoard: function () {
        var gameBoardString = "", lastIndex = 0;
        for (var i = 0; i < wordWarsRequestLayer.decodedGameBoard.length; i++) {
            lastIndex = 0;
            for (var j = 0; j < wordWarsRequestLayer.decodedGameBoard[i].length; j++) {
                if (wordWarsRequestLayer.decodedGameBoard[i][j] != '.') {
                    var indexNumber = j - lastIndex;
                    if (indexNumber > 0) {
                        gameBoardString += indexNumber.toString();
                    }
                    gameBoardString += wordWarsRequestLayer.decodedGameBoard[i][j];
                    lastIndex = j + 1;
                }
            }
            gameBoardString += "$";
        }
        return gameBoardString;
    },

    checkConnection: function () {
        var tilesOnBoard = [], wordsFormed = {}, totalScore = 0, tilesConnected = 1;
        for (var i = 0; i < wordWarsRequestLayer.tilesCount; i++) {
            if (wordWarsRequestLayer.bigTileSpriteArr[i].onRack == 0) {
                tilesOnBoard.push(wordWarsRequestLayer.bigTileSpriteArr[i]);
            }
        }

        var lettersOnRack = tilesOnBoard.length;
        var slope = 0;
        if (tilesOnBoard.length > 1) {
            if (tilesOnBoard[0].boardIndex[1] - tilesOnBoard[1].boardIndex[1] == 0) {
                slope = 1;
            } else if ((tilesOnBoard[0].boardIndex[0] - tilesOnBoard[1].boardIndex[0]) == 0) {
                slope = 0;
            } else {
                // utilObj.showMessage("new tiles not connected in straight line");
                // loggerObj.debugLog("new tiles not connected in straight line");
                tilesConnected = 0;
                wordWarsRequestLayer.letterTrackLabel.setString(stringsObj.new_tiles_straight_line);
            }

            for (var i = 1; i < tilesOnBoard.length; i++) {
                if (slope == 1 && tilesOnBoard[i].boardIndex[1] - tilesOnBoard[i - 1].boardIndex[1] != 0) {
                    tilesConnected = 0;
                    wordWarsRequestLayer.letterTrackLabel.setString(stringsObj.new_tiles_straight_line);
                    break;
                } else if (slope == 0 && tilesOnBoard[i].boardIndex[0] - tilesOnBoard[i - 1].boardIndex[0] != 0) {
                    tilesConnected = 0;
                    wordWarsRequestLayer.letterTrackLabel.setString(stringsObj.new_tiles_straight_line);
                    break;
                }
            }
        } else if (tilesOnBoard.length == 0) {
            return wordsFormed;
        }


        var storageMap = {}, wordsFormed = {};
        for (var i = 0; i < tilesOnBoard.length; i++) {
            storageMap[tilesOnBoard[i].boardIndex[0] * wordWarsRequestLayer.gridSize + tilesOnBoard[i].boardIndex[1]] = tilesOnBoard[i];
        }

        var firstLetter = parseInt(Object.keys(storageMap)[0]);
        wordWarsRequestLayer.newWordPosition = firstLetter;
        wordWarsRequestLayer.newWordSlope = "h";
        wordWarsRequestLayer.newWord = storageMap[firstLetter].tileLabel.getString();
        var horizontalIndex = firstLetter + 1, wordStrHor = wordWarsRequestLayer.newWord, isFinalWord = 0,
            verticalIndex = firstLetter + wordWarsRequestLayer.gridSize, wordStrVer = wordWarsRequestLayer.newWord;
        while (1) {
            var indX = Math.ceil(horizontalIndex / wordWarsRequestLayer.gridSize) - 1,
                indY = horizontalIndex % wordWarsRequestLayer.gridSize;
            if (indX >= wordWarsRequestLayer.gridSize || indY >= wordWarsRequestLayer.gridSize) {
                break;
            }
            if (storageMap[horizontalIndex] != undefined) {
                wordStrHor += storageMap[horizontalIndex].tileLabel.getString();
                wordWarsRequestLayer.newWordSlope = "h";
                isFinalWord = 1;
            } else if (wordWarsRequestLayer.decodedGameBoard[indX][indY] != '.') {
                wordStrHor += wordWarsRequestLayer.decodedGameBoard[indX][indY];
            } else {
                break;
            }
            horizontalIndex++;
        }
        if (isFinalWord == 1) {
            wordWarsRequestLayer.newWord = wordStrHor;
        }
        isFinalWord = 0;

        while (1) {
            var indX = Math.ceil(verticalIndex / wordWarsRequestLayer.gridSize) - 1,
                indY = verticalIndex % wordWarsRequestLayer.gridSize;
            if (indX >= wordWarsRequestLayer.gridSize || indY >= wordWarsRequestLayer.gridSize) {
                break;
            }
            if (storageMap[verticalIndex] != undefined) {
                wordStrVer += storageMap[verticalIndex].tileLabel.getString();
                wordWarsRequestLayer.newWordSlope = "v";
                isFinalWord = 1;
            } else if (wordWarsRequestLayer.decodedGameBoard[indX][indY] != '.') {
                wordStrVer += wordWarsRequestLayer.decodedGameBoard[indX][indY];
            } else {
                break;
            }
            verticalIndex += wordWarsRequestLayer.gridSize;
        }
        if (isFinalWord == 1) {
            wordWarsRequestLayer.newWord = wordStrVer;
        }

        for (var i = 0; i < tilesOnBoard.length; i++) {
            var indX = tilesOnBoard[i].boardIndex[0], indY = tilesOnBoard[i].boardIndex[1], yDown = 1, yUp = 1,
                doubleWordCount = 0, tripleWordCount = 0;
            var str = tilesOnBoard[i].tileLabel.getString();
            var varObj = wordWarsRequestLayer.resetParams();
            wordWarsRequestLayer.initializeParams(varObj, indX, indY, parseInt(tilesOnBoard[i].scoreLabel.getString()));
            while (1) {
                var indUp = indY - yUp, indDown = indY + yDown, wentUp = 0, wentDown = 0;
                if (indUp >= 0 && (storageMap[indX * wordWarsRequestLayer.gridSize + indUp] != undefined || wordWarsRequestLayer.decodedGameBoard[indX][indUp] != '.')) {
                    if (storageMap[indX * wordWarsRequestLayer.gridSize + indUp] != undefined) {
                        str = storageMap[indX * wordWarsRequestLayer.gridSize + indUp].tileLabel.getString() + str;
                        wordWarsRequestLayer.initializeParams(varObj, indX, indUp, parseInt(storageMap[indX * wordWarsRequestLayer.gridSize + indUp].scoreLabel.getString()));

                    } else {
                        str = wordWarsRequestLayer.decodedGameBoard[indX][indUp] + str;
                        wordWarsRequestLayer.initializeParams(varObj, indX, indUp, parseInt(wordWarsRequestLayer.letterMap[wordWarsRequestLayer.decodedGameBoard[indX][indUp]]));
                    }
                    yUp += 1;
                    wentUp = 1;
                }
                if (indDown < wordWarsRequestLayer.gridSize && (storageMap[indX * wordWarsRequestLayer.gridSize + indDown] != undefined || wordWarsRequestLayer.decodedGameBoard[indX][indDown] != '.')) {
                    if (storageMap[indX * wordWarsRequestLayer.gridSize + indDown] != undefined) {
                        str = str + storageMap[indX * wordWarsRequestLayer.gridSize + indDown].tileLabel.getString();
                        wordWarsRequestLayer.initializeParams(varObj, indX, indDown, parseInt(storageMap[indX * wordWarsRequestLayer.gridSize + indDown].scoreLabel.getString()));
                    } else {
                        str = str + wordWarsRequestLayer.decodedGameBoard[indX][indDown];
                        wordWarsRequestLayer.initializeParams(varObj, indX, indDown, parseInt(wordWarsRequestLayer.letterMap[wordWarsRequestLayer.decodedGameBoard[indX][indDown]]));
                    }
                    yDown += 1;
                    wentDown = 1;
                }
                if (wentUp == 0 && wentDown == 0) {
                    if (str.length > 1) {
                        wordsFormed[str] = varObj.totalScore * Math.pow(2, varObj.doubleWordCount) * Math.pow(3, varObj.tripleWordCount);
                    }
                    break;
                }
            }
            varObj = wordWarsRequestLayer.resetParams();
            str = tilesOnBoard[i].tileLabel.getString();
            wordWarsRequestLayer.initializeParams(varObj, indX, indY, parseInt(tilesOnBoard[i].scoreLabel.getString()));
            var xDown = 1, xUp = 1;
            while (1) {
                var indUp = indX - xUp, indDown = indX + xDown, wentUp = 0, wentDown = 0;
                if (indUp >= 0 && (storageMap[indUp * wordWarsRequestLayer.gridSize + indY] != undefined || wordWarsRequestLayer.decodedGameBoard[indUp][indY] != '.')) {
                    if (storageMap[indUp * wordWarsRequestLayer.gridSize + indY] != undefined) {
                        str = storageMap[indUp * wordWarsRequestLayer.gridSize + indY].tileLabel.getString() + str;
                        wordWarsRequestLayer.initializeParams(varObj, indUp, indY, parseInt(storageMap[indUp * wordWarsRequestLayer.gridSize + indY].scoreLabel.getString()));
                    } else {
                        str = wordWarsRequestLayer.decodedGameBoard[indUp][indY] + str;
                        wordWarsRequestLayer.initializeParams(varObj, indUp, indY, parseInt(wordWarsRequestLayer.letterMap[wordWarsRequestLayer.decodedGameBoard[indUp][indY]]));
                    }
                    xUp += 1;
                    wentUp = 1;
                }
                if (indDown < wordWarsRequestLayer.gridSize && (storageMap[indDown * wordWarsRequestLayer.gridSize + indY] != undefined || wordWarsRequestLayer.decodedGameBoard[indDown][indY] != '.')) {
                    if (storageMap[indDown * wordWarsRequestLayer.gridSize + indY] != undefined) {
                        str = str + storageMap[indDown * wordWarsRequestLayer.gridSize + indY].tileLabel.getString();
                        wordWarsRequestLayer.initializeParams(varObj, indDown, indY, parseInt(storageMap[indDown * wordWarsRequestLayer.gridSize + indY].scoreLabel.getString()));
                    } else {
                        str = str + wordWarsRequestLayer.decodedGameBoard[indDown][indY];
                        wordWarsRequestLayer.initializeParams(varObj, indDown, indY, parseInt(wordWarsRequestLayer.letterMap[wordWarsRequestLayer.decodedGameBoard[indDown][indY]]));
                    }
                    xDown += 1;
                    wentDown = 1;
                }
                if (wentUp == 0 && wentDown == 0) {
                    if (str.length > 1) {
                        wordsFormed[str] = varObj.totalScore * Math.pow(2, varObj.doubleWordCount) * Math.pow(3, varObj.tripleWordCount);
                    }
                    break;
                }
            }
        }

        if (tilesOnBoard.length == 1) {
            var indX = tilesOnBoard[0].boardIndex[0], indY = tilesOnBoard[0].boardIndex[1];
            var curTile = storageMap[indX * wordWarsRequestLayer.gridSize + indY];
            if (!((indX > 0 && wordWarsRequestLayer.decodedGameBoard[indX - 1][indY] != '.')
                || (indX < wordWarsRequestLayer.gridSize && wordWarsRequestLayer.decodedGameBoard[indX + 1][indY] != '.')
                || (indY > 0 && wordWarsRequestLayer.decodedGameBoard[indX][indY - 1] != '.')
                || (indY < wordWarsRequestLayer.gridSize && wordWarsRequestLayer.decodedGameBoard[indX][indY + 1] != '.')
            )) {
                // utilObj.showMessage("new tiles should be connected 1");
                // loggerObj.debugLog("new tiles should be connected 1");
                wordWarsRequestLayer.tilesNotTouchingOldTiles(tilesConnected);
            }
        } else {
            var isConnected = 0, lettersOnRackCounted = 0;
            for (var i = 0; i < tilesOnBoard.length; i++) {
                var indX = tilesOnBoard[i].boardIndex[0], indY = tilesOnBoard[i].boardIndex[1];
                if ((indX > 0 && wordWarsRequestLayer.decodedGameBoard[indX - 1][indY] != '.')
                    || (indX < wordWarsRequestLayer.gridSize - 1 && wordWarsRequestLayer.decodedGameBoard[indX + 1][indY] != '.')
                    || (indY > 0 && wordWarsRequestLayer.decodedGameBoard[indX][indY - 1] != '.')
                    || (indY < wordWarsRequestLayer.gridSize - 1 && wordWarsRequestLayer.decodedGameBoard[indX][indY + 1] != '.')
                ) {
                    isConnected = 1;
                    break;
                }
            }
            if (isConnected == 0) {
                // utilObj.showMessage("new tiles should be connected 2");
                // loggerObj.debugLog("new tiles should be connected 2");
                wordWarsRequestLayer.tilesNotTouchingOldTiles(tilesConnected);
            } else {
                var startIndex = Object.keys(storageMap)[0];
                var indX = Math.ceil(startIndex / wordWarsRequestLayer.gridSize) - 1,
                    indY = startIndex % wordWarsRequestLayer.gridSize;
                if (slope == 1) {
                    for (var i = indX; i < wordWarsRequestLayer.gridSize; i++) {
                        var prevTileIndex = (i) * wordWarsRequestLayer.gridSize + indY;
                        if (storageMap[prevTileIndex] == undefined && wordWarsRequestLayer.decodedGameBoard[i][indY] == '.') {
                            tilesConnected = 0;
                            // utilObj.showMessage("new tiles should be connected 3");
                            // loggerObj.debugLog("new tiles should be connected 3");
                            wordWarsRequestLayer.letterTrackLabel.setString(stringsObj.new_tiles_connected);
                            break;
                        } else {
                            if (storageMap[prevTileIndex] != undefined) {
                                lettersOnRackCounted += 1;
                            }
                            if (lettersOnRack == lettersOnRackCounted) {
                                break;
                            }
                        }
                    }
                } else if (slope == 0) {
                    for (var i = indY; i < wordWarsRequestLayer.gridSize; i++) {
                        var prevTileIndex = (indX) * wordWarsRequestLayer.gridSize + i;
                        if (storageMap[prevTileIndex] == undefined && wordWarsRequestLayer.decodedGameBoard[indX][i] == '.') {
                            // utilObj.showMessage("new tiles should be connected 4");
                            // loggerObj.debugLog("new tiles should be connected 4");
                            wordWarsRequestLayer.tilesNotTouchingOldTiles(tilesConnected);
                            break;
                        } else {
                            if (storageMap[prevTileIndex] != undefined) {
                                lettersOnRackCounted += 1;
                            }
                            if (lettersOnRack == lettersOnRackCounted) {
                                break;
                            }
                        }
                    }
                }
                if (lettersOnRackCounted == lettersOnRack && isConnected == 1) {

                } else {
                    wordsFormed = {};
                    // utilObj.showMessage("new tiles should be connected 5");
                    // loggerObj.debugLog("new tiles should be connected 5");
                    wordWarsRequestLayer.tilesNotTouchingOldTiles(tilesConnected);
                }
            }
        }
        return wordsFormed;
    },

    checkClosestEmptyGrid: function (indX, indY, touchX, touchY) {
        var minDist = Number.MAX_VALUE, finalIndX = 0, finalIndY = 0, finalXpos = 0, finalYpos = 0;
        var initialYPos = wordWarsRequestLayer.yInitialPos + wordWarsRequestLayer.smallTileWidth / 2 - 15 * (wordWarsRequestLayer.smallTileWidth + 10) + 5;
        for (var i = indX - 2; i <= indX + 2; i++) {
            for (var j = indY - 2; j <= indY + 2; j++) {
                if (i < 0 || j < 0 || i >= wordWarsRequestLayer.gridSize || j >= wordWarsRequestLayer.gridSize || wordWarsRequestLayer.decodedGameBoard[wordWarsRequestLayer.gridSize - j - 1][i] != '.' || wordWarsRequestLayer.checkIfTileIsPresent(wordWarsRequestLayer.gridSize - j - 1, i)) {
                    continue;
                }
                var posX = wordWarsRequestLayer.xInitialPos + wordWarsRequestLayer.smallTileWidth / 2 + i * (wordWarsRequestLayer.smallTileWidth + 10);
                var posY = initialYPos + 5 + wordWarsRequestLayer.smallTileWidth / 2 + j * (wordWarsRequestLayer.smallTileWidth + 10);
                if (minDist > wordWarsRequestLayer.getDistance(posX, posY, touchX, touchY)) {
                    minDist = wordWarsRequestLayer.getDistance(posX, posY, touchX, touchY);
                    finalIndX = i;
                    finalIndY = j;
                    finalXpos = posX;
                    finalYpos = posY;
                }
            }
        }
        wordWarsRequestLayer.curTile.boardIndex = [wordWarsRequestLayer.gridSize - finalIndY - 1, finalIndX];
        wordWarsRequestLayer.setTilePos(wordWarsRequestLayer.curTile, finalXpos, finalYpos, constantsObj.UI_Z_ORDER, 0, 1);
    },

    checkIfTileIsPresent: function (indX, indY) {
        var success = false;
        for (var i = 0; i < wordWarsRequestLayer.tilesCount; i++) {
            if (wordWarsRequestLayer.bigTileSpriteArr[i] != wordWarsRequestLayer.curTile && wordWarsRequestLayer.bigTileSpriteArr[i].onRack == 0) {
                success = success || (wordWarsRequestLayer.bigTileSpriteArr[i].boardIndex[0] == indX && wordWarsRequestLayer.bigTileSpriteArr[i].boardIndex[1] == indY);
            }
        }
        return success;
    },

    checkIfSymmetricPoint: function (x, y, comparedX, comparedY, gridSize) {
        var gridLength = gridSize - 1, success = false;
        for (var i = 0; i < comparedX.length; i++) {
            success = ((x == comparedX[i] && y == comparedY[i]) || (x == gridLength - comparedX[i] && y == comparedY[i]) || (x == comparedX[i] && y == gridLength - comparedY[i]) || (x == gridLength - comparedX[i] && y == gridLength - comparedY[i]));
            if (success == true) {
                return success;
            }
        }
        return success;
    },

    givePowerTile: function (x, y) {
        // double letter
        if (wordWarsRequestLayer.checkIfSymmetricPoint(x, y, wordWarsRequestLayer.doubleLetterCoordinates[0], wordWarsRequestLayer.doubleLetterCoordinates[1], wordWarsRequestLayer.gridSize)) {
            return "DL";
        }
        // double word
        else if (wordWarsRequestLayer.checkIfSymmetricPoint(x, y, wordWarsRequestLayer.doubleWordCoordinates[0], wordWarsRequestLayer.doubleWordCoordinates[1], wordWarsRequestLayer.gridSize)) {
            return "DW";
        }
        // triple letter
        else if (wordWarsRequestLayer.checkIfSymmetricPoint(x, y, wordWarsRequestLayer.tripleLetterCoordinates[0], wordWarsRequestLayer.tripleLetterCoordinates[1], wordWarsRequestLayer.gridSize)) {
            return "TL";
        }
        // triple word
        else if (wordWarsRequestLayer.checkIfSymmetricPoint(x, y, wordWarsRequestLayer.tripleWordCoordinates[0], wordWarsRequestLayer.tripleWordCoordinates[1], wordWarsRequestLayer.gridSize)) {
            return "TW";
        }
        // it is empty, then return NO
        else {
            return "NO";
        }
    },

    calculateScoreOfTile: function (varObj) {
        if (varObj.powerTile == "DL") {
            varObj.totalScore += varObj.tileScore * 2;
        } else if (varObj.powerTile == "DW") {
            varObj.totalScore += varObj.tileScore;
            varObj.doubleWordCount += 1;
        } else if (varObj.powerTile == "TL") {
            varObj.totalScore += varObj.tileScore * 3;
        } else if (varObj.powerTile == "TW") {
            varObj.totalScore += varObj.tileScore;
            varObj.tripleWordCount += 1;
        } else {
            varObj.totalScore += varObj.tileScore;
        }
    },

    initializeParams: function (varObj, xPos, yPos, tileScore) {
        if (wordWarsRequestLayer.decodedGameBoard[xPos][yPos] == '.') {
            varObj.powerTile = wordWarsRequestLayer.givePowerTile(xPos, yPos);
        } else {
            varObj.powerTile = "NO";
        }
        varObj.tileScore = tileScore;
        wordWarsRequestLayer.calculateScoreOfTile(varObj);
    },

    resetParams: function () {
        var varObj = {
            "powerTile": "NO",
            "tileScore": 0,
            "totalScore": 0,
            "doubleWordCount": 0,
            "tripleWordCount": 0
        };
        return varObj;
    },

    changeRackString: function () {
        var wordsFormed = wordWarsRequestLayer.checkConnection();
        var str = "Play %words% for %score% points";
        var tilesOnRackCount = 0;
        for (var i = 0; i < wordWarsRequestLayer.tilesCount; i++) {
            if (wordWarsRequestLayer.bigTileSpriteArr[i].onRack == 1) {
                tilesOnRackCount++;
            }
        }
        if (tilesOnRackCount == wordWarsRequestLayer.tilesCount) {
            wordWarsRequestLayer.currentPositionValid = 0;
            wordWarsRequestLayer.letterTrackLabel.setString(wordWarsRequestLayer.lettersLeft);
            wordWarsRequestLayer.play_label.setColor(wordWarsRequestLayer.button_disabled_color);
            wordWarsRequestLayer.playBar.setColor(wordWarsRequestLayer.button_disabled_color);
        } else if (Object.keys(wordsFormed).length == 0) {
            // str = wordWarsRequestLayer.lettersLeft;
            wordWarsRequestLayer.currentPositionValid = 0;
            wordWarsRequestLayer.play_label.setColor(wordWarsRequestLayer.button_disabled_color);
            wordWarsRequestLayer.playBar.setColor(wordWarsRequestLayer.button_disabled_color);
        } else {
            var wordsStr = "", score = 0;
            for (var word in wordsFormed) {
                wordsStr += word + ", ";
                score += wordsFormed[word];
            }
            wordsStr = wordsStr.slice(0, -2);
            wordsStr = wordsStr.replace(/,([^,]*)$/, " and" + '$1');
            str = str.replace("%words%", wordsStr);
            str = str.replace("%score%", score.toString());
            wordWarsRequestLayer.currentPositionValid = 1;
            wordWarsRequestLayer.letterTrackLabel.setString(str);
            wordWarsRequestLayer.play_label.setColor(wordWarsRequestLayer.button_active_color);
            wordWarsRequestLayer.playBar.setColor(wordWarsRequestLayer.button_active_color);
        }


    },

    playFTUE: function () {
        var rackTile = wordWarsRequestLayer.bigTileSpriteArr[0];
        if (!utilObj.isNodeValid(rackTile.tileSprite)) {
            return;
        }
        var rackTileSpritePosX = rackTile.tileSprite.getPositionX(),
            rackTileSpritePosY = rackTile.tileSprite.getPositionY();


        var finalTile = null;
        for (var tile in wordWarsRequestLayer.ftueMap) {
            if (wordWarsRequestLayer.ftueMap[tile].tileLabel.getString() == rackTile.tileLabel.getString()) {
                finalTile = wordWarsRequestLayer.ftueMap[tile];
                break;
            }
        }
        if (finalTile != null) {
            var params = {
                "x": finalTile.tileSprite.getPositionX(),
                "y": finalTile.tileSprite.getPositionY(),
                "time": 1,
                "tile": rackTile,
                "callBackFunc": animationObj.slideElement,
                "finalTile": finalTile
            };
            if (curScreen != constantsObj.SCREEN_WORD_WARS_REQUEST || !utilObj.isNodeValid(params.tile.tileSprite)) {
                utilObj.delayedCallback(wordWarsRequestLayer, wordWarsRequestLayer.playFTUE, 1, null, false);
                return;
            }
            wordWarsRequestLayer.animateWholeTile(null, params);
            params.scale = wordWarsRequestLayer.smallTileWidth / wordWarsRequestLayer.bigTileWidth;
            params.time = 1;
            params.callBackFunc = animationObj.getScaleTo;
            utilObj.delayedCallback(wordWarsRequestLayer, wordWarsRequestLayer.animateWholeTile, 1, params, false);
            params.x = rackTileSpritePosX, params.y = rackTileSpritePosY, params.time = 1;
            utilObj.delayedCallback(wordWarsRequestLayer, wordWarsRequestLayer.resetTile, 3.5, params, false);
        }
    },

    animateWholeTile: function (sender, params) {
        if (curScreen != constantsObj.SCREEN_WORD_WARS_REQUEST || !utilObj.isNodeValid(params.tile.tileSprite)) {
            return;
        }
        params.tile.tileSprite.setLocalZOrder(constantsObj.UI_Z_ORDER + 1);
        params.tile.tileLabel.setLocalZOrder(constantsObj.UI_Z_ORDER + 1);
        params.tile.scoreLabel.setLocalZOrder(constantsObj.UI_Z_ORDER + 1);
        if (params.callBackFunc == animationObj.slideElement && requestsObj.getIsWordWarsFtueSeen() == false) {
            var xPos = params.x, yPos = params.y;
            params.node = params.tile.tileSprite;
            params.callBackFunc(params);
            params.y = yPos + 0.1 * wordWarsRequestLayer.bigTileWidth;
            params.node = params.tile.tileLabel;
            params.callBackFunc(params);
            params.x = xPos - 0.35 * wordWarsRequestLayer.bigTileWidth, params.y = yPos - 0.3 * wordWarsRequestLayer.bigTileWidth;
            params.node = params.tile.scoreLabel;
            params.callBackFunc(params);
        } else if (params.callBackFunc == animationObj.getScaleTo && requestsObj.getIsWordWarsFtueSeen() == false) {

            var scaleTo = params.callBackFunc(params.time, params.tile.tileSprite.getScale() * params.scale);
            var easeIn1 = scaleTo.easing(new cc.easeIn(1.0));
            animationObj.runAction(params.tile.tileSprite, easeIn1);

            scaleTo = params.callBackFunc(params.time, params.tile.tileLabel.getScale() * params.scale);
            var easeIn1 = scaleTo.easing(new cc.easeIn(1.0));
            var moveTo = cc.moveTo(params.time, params.tile.tileSprite.getPositionX(), params.tile.tileSprite.getPositionY() + 0.1 * wordWarsRequestLayer.smallTileWidth);
            var scalingAndMoving = cc.Spawn(easeIn1, moveTo);
            animationObj.runAction(params.tile.tileLabel, scalingAndMoving);

            scaleTo = params.callBackFunc(params.time, params.tile.scoreLabel.getScale() * 24 / 40);
            easeIn1 = scaleTo.easing(new cc.easeIn(1.0));
            moveTo = cc.moveTo(params.time, params.tile.tileSprite.getPositionX() - 0.35 * wordWarsRequestLayer.smallTileWidth, params.tile.tileSprite.getPositionY() - 0.3 * wordWarsRequestLayer.smallTileWidth);
            scalingAndMoving = cc.Spawn(easeIn1, moveTo);
            animationObj.runAction(params.tile.scoreLabel, scalingAndMoving);

        }
    },

    resetTile: function (sender, params) {
        if (requestsObj.getIsWordWarsFtueSeen() == false) {
            wordWarsRequestLayer.setTilePos(params.tile, params.x, params.y, constantsObj.UI_Z_ORDER, 1, 1);
            utilObj.delayedCallback(wordWarsRequestLayer, wordWarsRequestLayer.playFTUE, 1, null, false);
        }
    },

    playNow: function () {
        if (wordWarsRequestLayer.currentPositionValid == 0 || wordWarsRequestLayer.playNowClicked == 1) {
            return;
        }
        // TODO: need to hit wordwars server to save position of word

        // for (var i = 0; i<wordWarsRequestLayer.bigTileSpriteArr.length; i++){
        //     if (wordWarsRequestLayer.bigTileSpriteArr[i].onRack == 0) {
        //         var indX = wordWarsRequestLayer.bigTileSpriteArr[i].boardIndex[0], indY = wordWarsRequestLayer.bigTileSpriteArr[i].boardIndex[1];
        //         wordWarsRequestLayer.decodedGameBoard[indX][indY] = wordWarsRequestLayer.bigTileSpriteArr[i].tileLabel.getString();
        //     }
        // }
        //
        // var newGameboard = wordWarsRequestLayer.getEncodedGameBoard();
        // loggerObj.debugLog("this is new game board ", newGameboard);
        //
        // wordWarsRequestLayer.decodedGameBoard = [];


        var requestData = requestsObj.getCurrentActiveRequest()[0];
        wordWarsRequestLayer.getDecodedGameBoard(requestData.gameBoard);
        requestData.extraParams = wordWarsRequestLayer.originalWord + "$" + wordWarsRequestLayer.originalWordPosition + "$" + wordWarsRequestLayer.originalWordSlope + "$" + wordWarsRequestLayer.newWord + "$" + wordWarsRequestLayer.newWordPosition + "$" + wordWarsRequestLayer.newWordSlope;
        requestsObj.updateRequestMap(requestData);
        if (requestData.status == xpromoConstantsObj.REQUEST_STARTED || requestData.status == xpromoConstantsObj.REQUEST_NOT_STARTED) {
            requestsObj.updateRequestStatus(requestData, xpromoConstantsObj.REQUEST_PLAYED);
        }
        requestsObj.updateRequestsData(0);
        trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, requestData.senderRefId, "1", xpromoConstantsObj.TRACK_WARS_QUEST, constantsObj.TRACK_PLAY, wordWarsRequestLayer.miniGameOpeningSrc, requestData.botType, "", "");
        wordWarsRequestLayer.showPlayNowAnimation();
        pspnUserTracking.trackUserSnapshot(constantsObj.SCREEN_WORD_WARS_REQUEST, constantsObj.TRACK_CLICK);
        // wordWarsRequestLayer.redirectToWordWars();

    },

    getBotImage: function (senderRefId) {
        var sRid = senderRefId;
        if (parseInt(senderRefId) <= 17) {
            sRid = (parseInt(senderRefId) + 1).toString();
        }
        return "friendly_" + sRid + ".jpg";
    },

    redirectToWordWars: function () {
        var params = {
            "gameId": "10",
            "adrAppId": "com.littleengine.wordpal",
            "gameLink": "wordwars",
            "fbId": "com.littleengine.wordpal",
            "iosAppId": "1245525899"
        };
        questsObj.redirectToStoreWithTracking("requests_" + constantsObj.GAME_ID, utilObj.getScreenName(constantsObj.SCREEN_WORD_WARS_REQUEST), params, requestsObj.getTrackingIdForWordwarsRequest());
    },

    tilesNotTouchingOldTiles: function (tilesConnected) {
        wordWarsRequestLayer.play_label.setColor(wordWarsRequestLayer.button_disabled_color);
        wordWarsRequestLayer.playBar.setColor(wordWarsRequestLayer.button_disabled_color);
        if (tilesConnected == 1) {
            wordWarsRequestLayer.letterTrackLabel.setString(stringsObj.new_tiles_touch);
        }
    },

    showPlayNowAnimation: function () {
        wordWarsRequestLayer.playNowClicked = 1;
        var spriteArr = [], labelArr = [], zOrder = constantsObj.UI_Z_ORDER;
        wordWarsRequestLayer.wordwars_rays = utilObj.getSprite(xpromoConstantsObj.wordwars_rays, centerXPos, centerYPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_11 * 1.5 * 0.9, spriteArr, wordWarsRequestLayer, zOrder, constantsObj.SPRITE_LOCAL);
        wordWarsRequestLayer.wordwars_rays_2 = utilObj.getSprite(xpromoConstantsObj.wordwars_rays, centerXPos, centerYPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_11 * 1.5 * 0.9, spriteArr, wordWarsRequestLayer, zOrder, constantsObj.SPRITE_LOCAL);
        wordWarsRequestLayer.wordwars_rays_2.setFlippedX(true);
        wordWarsRequestLayer.wordwars_redirect = utilObj.getSprite(xpromoConstantsObj.wordwars_redirect, centerXPos, centerYPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_19 * 0.9, spriteArr, wordWarsRequestLayer, zOrder, constantsObj.SPRITE_LOCAL);
        var width = wordWarsRequestLayer.wordwars_redirect.getContentSize().width,
            height = wordWarsRequestLayer.wordwars_redirect.getContentSize().height;
        var wordwarsRedirectionText = xpromoGameRuntimeObj.getWordwarsRedirectionText();
        wordwarsRedirectionText = utilObj.getSplitStringsArr(wordwarsRedirectionText, 20);
        var labelText = "";
        for (var i = 0; i < wordwarsRedirectionText.length; i++) {
            labelText += wordwarsRedirectionText[i] + "\n";
        }
        var wordwars_redirect_label = utilObj.getBMFontLabel(labelText, constantsObj.FONT_SFCOMPACT_MEDIUM_40, constantsObj.COLOR_WHITE, constantsObj.LABEL_AUTO_WIDTH, cc.VERTICAL_TEXT_ALIGNMENT_CENTER, cc.p(0, 0), width / 2, height / 2, 0.5, 0.5, labelArr, wordWarsRequestLayer.wordwars_redirect, zOrder);
        // wordwars_redirect_label.setScale(wordwars_redirect_label.getScale() * 3);
        var wordwars_redirect = utilObj.getBMFontLabel("Redirecting...", constantsObj.FONT_SFCOMPACT_MEDIUM_40, constantsObj.COLOR_WHITE, constantsObj.LABEL_AUTO_WIDTH, cc.VERTICAL_TEXT_ALIGNMENT_CENTER, cc.p(0, 0), width / 2, height / 2 - 120, 0.5, 0.5, labelArr, wordWarsRequestLayer.wordwars_redirect, zOrder);
        wordwars_redirect.setScale(wordwars_redirect.getScale() * 0.9);
        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);
        wordWarsRequestLayer.wordwars_redirect.setCascadeOpacityEnabled(true);
        utilObj.setOpacity(wordWarsRequestLayer.wordwars_redirect, 0);
        utilObj.setOpacity(wordWarsRequestLayer.wordwars_rays, 0);
        utilObj.setOpacity(wordWarsRequestLayer.wordwars_rays_2, 0);
        var fadeIn = animationObj.getFadeIn(0.4);
        var scaleUp = animationObj.getScaleTo(0.4, wordWarsRequestLayer.wordwars_redirect.getScale() / 0.9);

        //
        // var seqAction = easeIn;
        // var seqRepeat = new cc.RepeatForever(seqAction);
        var action = new cc.Spawn(fadeIn, scaleUp);
        var ease1 = action.easing(new cc.easeOut(0.4));
        wordWarsRequestLayer.wordwars_redirect.runAction(ease1);

        fadeIn = animationObj.getFadeIn(0.4);
        scaleUp = animationObj.getScaleTo(0.4, wordWarsRequestLayer.wordwars_rays.getScale() / 0.9);
        action = new cc.Spawn(fadeIn, scaleUp);
        ease1 = action.easing(new cc.easeOut(0.4));

        wordWarsRequestLayer.wordwars_rays.runAction(ease1);

        fadeIn = animationObj.getFadeIn(0.4);
        scaleUp = animationObj.getScaleTo(0.4, wordWarsRequestLayer.wordwars_rays_2.getScale() / 0.9);
        action = new cc.Spawn(fadeIn, scaleUp);
        ease1 = action.easing(new cc.easeOut(0.4));

        wordWarsRequestLayer.wordwars_rays_2.runAction(ease1);

        animationObj.rotateWordwarsCompleteAnim(wordWarsRequestLayer.wordwars_rays, 1.0, 30);
        animationObj.rotateWordwarsCompleteAnim(wordWarsRequestLayer.wordwars_rays_2, 1.0, -30);

        utilObj.delayedCallback(wordWarsRequestLayer, wordWarsRequestLayer.stopPlayNowAnimation, 2, null, false);
    },

    stopPlayNowAnimation: function () {
        var fadeout = animationObj.getFadeOut(0.4);
        var scaleUp = animationObj.getScaleTo(0.4, wordWarsRequestLayer.wordwars_redirect.getScale() * 0.9);
        var action = new cc.Spawn(fadeout, scaleUp);
        var ease1 = action.easing(new cc.easeOut(0.4));
        wordWarsRequestLayer.wordwars_redirect.runAction(ease1);

        fadeout = animationObj.getFadeOut(0.4);
        scaleUp = animationObj.getScaleTo(0.4, wordWarsRequestLayer.wordwars_rays.getScale() / 0.9);
        action = new cc.Spawn(fadeout, scaleUp);
        ease1 = action.easing(new cc.easeOut(0.4));

        wordWarsRequestLayer.wordwars_rays.runAction(ease1);

        fadeout = animationObj.getFadeOut(0.4);
        scaleUp = animationObj.getScaleTo(0.4, wordWarsRequestLayer.wordwars_rays.getScale() / 0.9);
        action = new cc.Spawn(fadeout, scaleUp);
        ease1 = action.easing(new cc.easeOut(0.4));

        wordWarsRequestLayer.wordwars_rays_2.runAction(ease1);

        utilObj.delayedCallback(wordWarsRequestLayer, wordWarsRequestLayer.redirectAfterStopingAnim, 0.2, null, false);

    },

    redirectAfterStopingAnim: function () {
        wordWarsRequestLayer.wordwars_redirect.removeAllChildren();
        wordWarsRequestLayer.wordwars_rays.removeAllChildren();
        wordWarsRequestLayer.redirectToWordWars();
        wordWarsRequestLayer.playNowClicked = 0;
    },
});
