PspnRedirectFtueUI = function () {
    var popupNode = null;
    var showWithAnim = true;
    var screen = constantsObj.SCREEN_PSPN_REDIRECT_FTUE;
    var cb = null;
    var gameId = -1;
    var trackingSpecies = "";

    var PUZZLE_TEXT_MAP = {
        8: "crossword",
        10: "move",
        16: "deck"
    };

    this.show = function (withAnim, params) {
        if ((popupLayer.popupOpen && gameObj.getIsPrivatePolicyOpen() == true) || ftueObj.isFtueVisible()) {
            return;
        }
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        popupLayer.checkAndShow(pspsRedirectFtueUiObj.delayedShow, params);
    };

    this.delayedShow = function (sender, params) {
        var labelArr = [];
        var spriteArr = [];
        var popupHeight = 1800;
        var popupWidth = popupLayer.getWidthForPopup(screen, false);
        var center = xPromoGameSpecificObj.getCenterPosW2ePopup(popupWidth, popupHeight);
        var screenName = utilObj.getScreenName(screen);
        var zOrder = constantsObj.UI_Z_ORDER;
        popupNode = new cc.Node();

        var yOffsetForCoinHeader = xPromoGameSpecificObj.xPromoW2eYOffsetForCoinHeader();
        center.y += yOffsetForCoinHeader;

        xPromoGameSpecificObj.addPopupBg(popupHeight,popupNode);

        // Grey box around the main content
        var bg = utilObj.getScale9Sprite(questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_WHITE_EXTRA_ROUNDED), center.x, center.y - 50, 0.5, 0.5, popupWidth - 150, popupHeight - 800, spriteArr, popupNode, zOrder, questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_SPRITE_MISC));
        bg.setColor(constantsObj.COLOR_IN_GAME_QUEST_BG);

        var rewardValue = params.reward;

        // Popup Header Text
        var yOffset = xPromoGameSpecificObj.xPromoW2eYOffset();
        utilObj.getBMFontLabel(xpromoStringsObj.redirect_ftue_header, constantsObj.FONT_SFCOMPACT_REGULAR_120, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), center.x, center.y + 770 - yOffset, 0.5, 1, labelArr, popupNode, zOrder);

        // Popup Ribbon Image, text and coins Icon
        var coinIcon = questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_ICON_COINS_4);
        utilObj.getSprite(xpromoConstantsObj.banner_xpromo, center.x, center.y + 470, 0.5, 0.5, constantsObj.SCALE_SPRITE_24, spriteArr, popupNode, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
        var text = stringsObj.earn_more;
        text = text.replace("%N%", rewardValue.toString());
        utilObj.getBMFontLabel(text, constantsObj.FONT_SFCOMPACT_MEDIUM_100, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), center.x, center.y + 550, 0.5, 1, labelArr, popupNode, zOrder);

        utilObj.getSprite(coinIcon, center.x - 110, center.y + 490, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, popupNode, zOrder + 1, questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_SPRITE_MISC));

        // Gift box icon
        utilObj.getSprite(xpromoConstantsObj.gift_box_3, center.x, center.y + 70, 0.5, 0.5, constantsObj.SCALE_SPRITE_11, spriteArr, popupNode, zOrder, xpromoConstantsObj.SPRITE_QUESTS);


        var replaceText = xpromoStringsObj.puzzle;
        if (utilObj.isValid(PUZZLE_TEXT_MAP[params.gameId])) {
            replaceText = PUZZLE_TEXT_MAP[params.gameId] + "";
        }
        if(params.target > 1) {
            replaceText += "s";
        }

        // Body Text - Line 1
        text = xpromoStringsObj.redirect_ftue_body.replace("%X%", params.target + "").replace("%TEXT%", replaceText);
        utilObj.getBMFontLabel(text, constantsObj.FONT_SFCOMPACT_MEDIUM_80, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), center.x, center.y - 260, 0.5, 1, labelArr, popupNode, zOrder);

        // Body Text - Line 2
        var questDescLabel = utilObj.getBMFontLabel(params.gameName, constantsObj.FONT_SFCOMPACT_MEDIUM_80, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), center.x, center.y - 360, 0.5, 1, labelArr, popupNode, zOrder);

        // Body - Game Icon
        var gameIcon = "icon_" + params.gameId + ".png";
        if (!utilObj.isWeb() && !utilObj.fileExists(gameIcon)) {
            xPromoGameSpecificObj.downloadFileV1(constantsObj.MISC_SERVER_STATIC_BASE + "quests/images/icons/" + gameIcon, gameIcon);
        } else {
            utilObj.getSprite(xpromoUtilObj.getAbsFilePath(gameIcon), center.x + questDescLabel.getContentSize().width / 2 + 10, center.y - 365, 0, 1, constantsObj.SCALE_SPRITE_8, spriteArr, popupNode, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
        }

        // Play Now Button
        var btn = questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_BUTTON_180_LOCAL);
        var texture = questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_BTN_180_TEXTURE_LOCAL);
        var closeButton = utilObj.getButton(700, 180, 0.5, 1.0, center.x, center.y - 640,
            btn, btn, btn, {
                obj: 'pspnRedirectFtueObj',
                fn: 'playNow',
                screen: screen,
                params: {"sound": constantsObj.button_tap_01, "sound_on": false, "gameId": params.gameId, "screen": screen},
                track: {
                    k: constantsObj.TRACK_XPROMO,
                    p: "popup",
                    c: params.gameId + "",
                    o: xpromoConstantsObj.TRACK_PSPN_REDIRECT_FTUE,
                    f: constantsObj.TRACK_CLICK,
                    g: xpromoConstantsObj.TRACK_XPLAY,
                    s: params.trackingSpecies,
                    co: 1,
                    oppId: ""
                },
                child: [],
                feedBackType: constantsObj.NORMALBTN_FEEDBACK
            }, false, texture, 1);
        popupNode.addChild(closeButton, zOrder + 1);
        closeButton.setColor(constantsObj.COLOR_BUTTON_BLUE_02);

        // Play Now Button Text
        var label = utilObj.getBMFontLabel(xpromoStringsObj.play_now.toUpperCase(), constantsObj.FONT_SFCOMPACT_MEDIUM_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), closeButton.getContentSize().width / 2, closeButton.getContentSize().height / 2, 0.5, 0.5, labelArr, closeButton, zOrder + 1);

        // Offer Burst Icon on the button
        var offerTag = utilObj.getSprite(xpromoConstantsObj.offer_tag_02, 10, closeButton.getContentSize().height - 15, 0.5, 0.5, constantsObj.SCALE_SPRITE_24, spriteArr, closeButton, zOrder + 2, xpromoConstantsObj.SPRITE_QUESTS);
        text = xpromoStringsObj.coin_reward.replace("%N%", rewardValue);

        // Offer burst text split into two lines
        var textArr = text.split(" ");
        label = utilObj.getBMFontLabel(textArr[0], constantsObj.FONT_SFCOMPACT_MEDIUM_50, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), offerTag.getContentSize().width / 2 - 80, (offerTag.getContentSize().height) + 60, 0.5, 0.5, labelArr, closeButton, zOrder + 2);
        label.setRotation(-25);
        label = utilObj.getBMFontLabel(textArr[1], constantsObj.FONT_SFCOMPACT_MEDIUM_50, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), offerTag.getContentSize().width / 2 - 52, (offerTag.getContentSize().height) + 10, 0.5, 0.5, labelArr, closeButton, zOrder + 2);
        label.setRotation(-25);

        xPromoGameSpecificObj.setCurScreen(screen);

        popupLayer.popupSetup(screen, false, pspsRedirectFtueUiObj.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });

        xPromoGameSpecificObj.popupShow(popupHeight, screen, "", popupNode, spriteArr, labelArr, true, constantsObj.COLOR_WHITE, undefined, undefined, undefined, undefined, undefined, undefined, undefined, yOffsetForCoinHeader);

        gameId = params.gameId;
        trackingSpecies = params.trackingSpecies;
        // Tracking for view of the popup
        trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO,
            "popup",
            params.gameId + "",
            xpromoConstantsObj.TRACK_PSPN_REDIRECT_FTUE, constantsObj.TRACK_VIEW, xpromoConstantsObj.TRACK_XPLAY, params.trackingSpecies, "", "");

    };

    this.close = function () {
        // Tracking for close of the popup
        trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO,
            "popup",
            gameId + "",
            xpromoConstantsObj.TRACK_PSPN_REDIRECT_FTUE, constantsObj.TRACK_CLOSE, xpromoConstantsObj.TRACK_XPLAY, trackingSpecies, "", "");

        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };
};