SoftLaunchPopup = function () {
    var popupNode = null;
    var showWithAnim = true;
    var screen = constantsObj.SCREEN_SOFT_LAUNCH;
    var currentExp = constantsObj.EXP_VAR_5;

    this.show = function (withAnim, params) {
        popupLayer.closeWithDefault();
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        popupLayer.checkAndShow(softLaunchPopup.delayedShow, null);
    };

    this.delayedShow = function () {
        // soft launch functionalities
        var bezelShift = xPromoGameSpecificObj.getBezelShift();
        var labelArr = [];
        var spriteArr = [];
        var popupHeight = constantsObj.DESIGN_HEIGHT + constantsObj.POPUP_START_OFFSET - 400 - constantsObj.BEZEL_SAFE_AREA;
        var popupWidth = popupLayer.getWidthForPopup(screen, false);
        var center = xPromoGameSpecificObj.getCenterPosW2ePopup(popupWidth, popupHeight);
        var screenName = utilObj.getScreenName(screen);
        xPromoGameSpecificObj.showOrHideBannerAd(screen);
        popupNode = new cc.Node();
        adWallObj.setAdwallShownCount(adWallObj.getAdwallShownCount() + 1);
        adWallObj.setLastShownAdWallTimeStamp(utilObj.getCurrentTimestamp());
        var xPos = center.x;
        var yPos = centerYPos + popupHeight / 2 - constantsObj.POPUP_START_OFFSET;
        var zOrder = constantsObj.UI_Z_ORDER;
        //loggerObj.debugLog("this is current priority ", currentQuestPriority);
        var popupWidth = constantsObj.POPUP_WIDTH;
        var scale = (popupWidth) / 1440;
        var gameLink, allParams, appId;
        softLaunchObj.setIsSoftLaunchSuppressed(false);
        softLaunchObj.setSoftLaunchShown(1);
        var currentQuestPriority = softLaunchObj.getCurrentquestPriority();
        var softLaunchBannerMap = softLaunchObj.getSoftLaunchBannerMap();
        var priorityToQuestMap = softLaunchObj.getPriorityToQuestMap();
        var currentExp = epmObj.getChosenVariant(xPromoGameSpecificObj.getAdwallExpName());
        // for sprite sheet gif animation
        // cc.spriteFrameCache.addSpriteFrames(res.loading_plist, res.loading_png);
        // var loadingPlist = cc.loader.getRes(res.loading_plist);
        // this.loading = cc.Sprite.create(res.loading_png);
        // this.loading.attr({
        //     x: center.x,
        //     y: centerYPos,
        //     scale: scale,
        // });
        // popupNode.addChild(this.loading, zOrder);
        // var animFrames = [];
        // var str = "";
        // var frameCount = Object.keys(loadingPlist["frames"]).length;
        // loggerObj.debugLog("this is loading length ", frameCount);
        // for (var i = 0; i < frameCount; i++){
        //     str = "frame_";
        //     if(i < 10){
        //         str += "0" + i;
        //     }
        //     else{
        //         str += i;
        //     }
        //     str += "_delay-0.05s.png";
        //     var frame = cc.spriteFrameCache.getSpriteFrame(str);
        //     animFrames.push(frame);
        // }
        //
        // var animation = cc.Animation.create(animFrames, 0.05, 1000);
        // var animate = cc.Animate.create(animation);
        // this.loading.runAction(animate);
        //

        var extraShift = xPromoGameSpecificObj.getBottomShiftGameScreen();
        if (utilObj.isAndroid()) {
            extraShift = bezelShift;
        }

        var diff = xPromoGameSpecificObj.yDiffSoftLaunchUi();

        var popup_bg_image = xpromoConstantsObj.popup_bg_soft_launch;
        var popup_bg = utilObj.getSprite(xpromoUtilObj.getAbsFilePath(popup_bg_image), center.x, center.y - extraShift, 0.5, 0.5, scale, spriteArr,
            popupNode, zOrder - 1, constantsObj.SPRITE_LOCAL);

        var creators_label = utilObj.getBMFontLabel(xpromoStringsObj.from_the_creators, constantsObj.FONT_SFCOMPACT_MEDIUM_70, constantsObj.COLOR_BLACK, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), center.x, popupHeight - extraShift - diff, 0.5, 0.5, labelArr, popupNode, zOrder);
        // var gradient = cc.LayerGradient.create(cc.color(0,0,0,255), cc.color(0x46,0x82,0xB4,255));
        // popupNode.addChild(gradient, zOrder);
        // for banners
        if (currentExp == constantsObj.EXP_VAR_7) {
            var banners_shown = "";
            var titleFontSize = xPromoGameSpecificObj.getSoftLaunchTitleFontSize();
            var game_label = utilObj.getBMFontLabel(questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_GAME_NAME), titleFontSize, constantsObj.COLOR_BLACK, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), center.x, popupHeight - 150 - extraShift - diff, 0.5, 0.5, labelArr, popupNode, zOrder);
            utilObj.setScale(game_label, 1.5);
            var yShift = 250;
            var count = 0;
            for (var quest in softLaunchBannerMap) {
                if (count >= 3) {
                    break;
                }
                count++;
                var gameIconName;
                allParams = softLaunchBannerMap[quest].pa;
                allParams = allParams.split(":");
                var creativesMap = xpromoUtilObj.getKeyValuePairForCreatives(softLaunchBannerMap[quest].creatives);
                var fbId;
                if (utilObj.isWeb() || utilObj.isAndroid()) {
                    gameLink = allParams[1];
                    appId = allParams[0];
                    fbId = null;
                } else if (utilObj.isIos()) {
                    gameLink = allParams[1];
                    appId = allParams[2];
                    fbId = allParams[0];
                }

                gameIconName = creativesMap.var7_creative;

                var carousel_image = utilObj.getSprite(softLaunchObj.getSoftLaunchImageUrl(gameIconName, currentExp), xPos, centerYPos + yShift - diff, 0.5, 0, scale, spriteArr,
                    popupNode, zOrder, constantsObj.SPRITE_LOCAL);

                var transBtn = utilObj.getButton(popupWidth, 550, 0.5, 0,
                    center.x, centerYPos + yShift - diff, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                        obj: 'softLaunchObj',
                        fn: 'playNow',
                        screen: screen,
                        params: {
                            "sound": constantsObj.button_tap_01,
                            "sound_on": false,
                            "gameLink": gameLink,
                            "appId": appId,
                            "gameId": softLaunchBannerMap[quest].gh,
                            "fbId": fbId
                        },
                        track: {
                            k: constantsObj.TRACK_DIALOG,
                            p: xPromoGameSpecificObj.getPhylumForTracking(),
                            c: xPromoGameSpecificObj.getClassForTracking(),
                            o: screenName,
                            f: constantsObj.TRACK_BUY,
                            g: "",
                            s: xPromoGameSpecificObj.getSpeciesForTracking(),
                            co: 1,
                            oppId: ""
                        },
                    }, false, ccui.Widget.PLIST_TEXTURE, constantsObj.SCALE_ONE);
                popupNode.addChild(transBtn, zOrder);

                yShift -= 600;
                banners_shown += softLaunchBannerMap[quest].gh + "_";

                // hitting adjust view tracking
                var trackId = xpromoUtilObj.getAdjustTrackerForGameId(softLaunchBannerMap[quest].gh);
                var campaignName = "soft_launch_9";
                var trackingInfo = "soft_launch_" + currentExp;
                xpromoUtilObj.hitAdjustViewTracking(trackId, campaignName, trackingInfo);
            }
            trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, xpromoConstantsObj.TRACK_SOFT_LAUNCH, banners_shown, xpromoConstantsObj.TRACK_SOFT_LAUNCH, constantsObj.TRACK_VIEW, currentExp, "", "", "");
        }
        // for interstitials
        else if (currentExp == constantsObj.EXP_VAR_5 || currentExp == constantsObj.EXP_VAR_6 || (currentExp == constantsObj.EXP_VAR_8)) {
            var titleFontSize = xPromoGameSpecificObj.getSoftLaunchTitleFontSize();
            var game_label = utilObj.getBMFontLabel(questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_GAME_NAME), titleFontSize, constantsObj.COLOR_BLACK, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), center.x, popupHeight - 130 - extraShift - diff, 0.5, 0.5, labelArr, popupNode, zOrder);
            var game_shown = "";
            utilObj.setScale(game_label, 1.5);
            allParams = priorityToQuestMap[currentQuestPriority].pa;
            allParams = allParams.split(":");
            var gameIconName, spriteName, spritePng;
            var creativesMap = xpromoUtilObj.getKeyValuePairForCreatives(priorityToQuestMap[currentQuestPriority].creatives);
            if (utilObj.isWeb() || utilObj.isAndroid()) {
                gameLink = allParams[1];
                appId = allParams[0];
            } else if (utilObj.isIos()) {
                gameLink = allParams[3];
                appId = allParams[2];
            }
            var isGif = 0;
            if ((currentExp == constantsObj.EXP_VAR_5 || currentExp == constantsObj.EXP_VAR_8) && creativesMap.var5_gif == 0) {
                gameIconName = creativesMap.var5_creative;
            } else if ((currentExp == constantsObj.EXP_VAR_5 || currentExp == constantsObj.EXP_VAR_8) && creativesMap.var5_gif == 1) {
                var creativeName = creativesMap.var5_creative;
                creativeName = creativeName.split("_");
                spriteName = creativeName[0], spritePng = creativeName[1];
                isGif = 1;
            } else if (currentExp == constantsObj.EXP_VAR_6 && creativesMap.var6_gif == 0) {
                gameIconName = creativesMap.var6_creative
            } else if (currentExp == constantsObj.EXP_VAR_6 && creativesMap.var6_gif == 1) {
                var creativeName = creativesMap.var6_creative;
                creativeName = creativeName.split("_");
                spriteName = creativeName[0], spritePng = creativeName[1];
                isGif = 1;
            }
            if (isGif == 0) {
                var carousel_image = utilObj.getSprite(softLaunchObj.getSoftLaunchImageUrl(gameIconName, currentExp, isGif), xPos, centerYPos - diff, 0.5, 0.5, scale, spriteArr,
                    popupNode, zOrder, constantsObj.SPRITE_LOCAL);
            } else if (isGif == 1) {
                spriteName = xpromoUtilObj.getAbsFilePath(spriteName);
                spritePng = xpromoUtilObj.getAbsFilePath(spritePng);
                cc.spriteFrameCache.addSpriteFrames(spriteName, spritePng);
                // for sprite sheet gif animation
                var loadingPlist = cc.loader.getRes(spriteName);
                this.loading = cc.Sprite.create(spritePng);
                this.loading.attr({
                    x: center.x,
                    y: centerYPos,
                    scale: scale,
                });
                popupNode.addChild(this.loading, zOrder);
                var animFrames = [];
                var str = "";
                var frameCount = Object.keys(loadingPlist["frames"]).length;
                for (var i = 0; i < frameCount; i++) {
                    str = "frame_";
                    if (i < 10) {
                        str += "0" + i;
                    } else {
                        str += i;
                    }
                    str += "_delay-0.05s.png";
                    var frame = cc.spriteFrameCache.getSpriteFrame(str);
                    animFrames.push(frame);
                }

                var animation = cc.Animation.create(animFrames, 0.05, 1000);
                var animate = cc.Animate.create(animation);
                this.loading.runAction(animate);
            }
            var buyButton = utilObj.getButton(500, 130, 0.5, 0.5, center.x, 280 + bezelShift + constantsObj.BEZEL_SAFE_AREA - diff,
                questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_BUTTON_190), questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_BUTTON_190), questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_BUTTON_190), {}, false, ccui.Widget.PLIST_TEXTURE, constantsObj.BTN_SCALING);
            buyButton.setColor(constantsObj.COLOR_BUTTON_LIGHT_GREEN);
            popupNode.addChild(buyButton, zOrder);

            // var transBtn = utilObj.getButton(popupWidth, popupHeight - 200, 0.5, 0.5,
            //     center.x, centerYPos - 100 + bezelShift + constantsObj.BEZEL_SAFE_AREA, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
            var transBtn = utilObj.getButton(popupWidth, popupHeight - 200 - diff, 0.5, 0,
                center.x, centerYPos - (popupHeight / 2), constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: 'softLaunchObj',
                    fn: 'playNow',
                    screen: screen,
                    params: {
                        "sound": constantsObj.button_tap_01,
                        "sound_on": false,
                        "gameLink": gameLink,
                        "appId": appId,
                        "gameId": priorityToQuestMap[currentQuestPriority].gh
                    },
                    track: {
                        k: xpromoConstantsObj.TRACK_XPROMO,
                        p: xPromoGameSpecificObj.getPhylumForTracking(),
                        c: xPromoGameSpecificObj.getClassForTracking(),
                        o: xpromoConstantsObj.TRACK_SOFT_LAUNCH,
                        f: constantsObj.TRACK_CLICK,
                        g: "",
                        s: xPromoGameSpecificObj.getSpeciesForTracking(),
                        co: 1,
                        oppId: ""
                    },
                }, false, ccui.Widget.PLIST_TEXTURE, constantsObj.SCALE_ONE);
            popupNode.addChild(transBtn, zOrder);

            utilObj.getBMFontLabel(stringsObj.play_now, constantsObj.FONT_SFCOMPACT_MEDIUM_70, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), 250, 65, 0.5, 0.5, labelArr, buyButton, zOrder);

            softLaunchObj.softLaunchGameIncrement();
            trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, xpromoConstantsObj.TRACK_SOFT_LAUNCH, priorityToQuestMap[currentQuestPriority].gh, xpromoConstantsObj.TRACK_SOFT_LAUNCH, constantsObj.TRACK_VIEW, currentExp, "", "", "");

            // hitting adjust view tracking
            var trackId = xpromoUtilObj.getAdjustTrackerForGameId(priorityToQuestMap[currentQuestPriority].gh);
            var campaignName = "soft_launch_9";
            var trackingInfo = "soft_launch_" + currentExp;
            xpromoUtilObj.hitAdjustViewTracking(trackId, campaignName, trackingInfo);
        }
        popupLayer.popupSetup(screen, false, softLaunchObj.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });
        //loggerObj.debugLog("this is game icon name after q ", gameIconName);
        xPromoGameSpecificObj.popupShow(popupHeight - 2 * bezelShift, screen, "", popupNode, spriteArr, labelArr, true, constantsObj.COLOR_WHITE);
        //loggerObj.debugLog("this is curscreen ", curScreen, lastScreen);
    };

    this.close = function () {
        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.playNow = function (params) {
        popupLayer.closeWithDefault();
        var trackAndroidMap = {}, trackIosMap = {};
        trackAndroidMap[4] = "cnglv7h";
        trackAndroidMap[8] = "zc3zz6";
        trackAndroidMap[10] = "jgrqiq";
        trackAndroidMap[11] = "w0rvv7";
        trackAndroidMap[12] = "ogum16";
        trackAndroidMap[16] = "1smbcq4";

        trackIosMap[4] = "lfzm5rr";
        trackIosMap[8] = "zc3zz6";
        trackIosMap[10] = "jgrqiq";
        trackIosMap[11] = "w0rvv7";
        trackIosMap[12] = "ogum16";
        trackAndroidMap[16] = "1smbcq4";
        var link, installedAlready = 0;
        var campaignName = "soft_launch_" + constantsObj.GAME_ID;
        var screenName = constantsObj.SCREEN_SOFT_LAUNCH;
        //loggerObj.debugLog("this is gameLink ", params["gameLink"]);
        questsObj.resetRedirectDataForAdjust();
        softLaunchPopup.softLaunchGameIncrement(true);
        var redirectExp = epmObj.getChosenVariant(xpromoConstantsObj.EXP_REDIRECT_TO_APP_STORE);
        if (utilObj.isAndroid()) {
            if (xpromoUtilObj.isAppInstalled(params["appId"])) {
                installedAlready = 1;
                utilObj.launchAnotherApp(params["appId"]);
            }
            // link = questsObj.getGameShareLink(params["gameLink"], screenName, campaignName);
            // utilObj.openStore(null, link, screenName);
            else if (redirectExp == constantsObj.EXP_VAR_CONTROL) {
                link = questsObj.getGameShareLink(params["gameLink"], screenName, campaignName);
                utilObj.openStore(null, link, screenName);
            } else {
                //xpromoUtilObj.hitUrl(trackAndroidMap[params["gameId"]], campaignName);
                utilObj.openUrl("market://details?id=" + params["appId"]);
            }
        } else if (utilObj.isIos()) {
            if (xpromoUtilObj.isAppInstalled(params["fbId"])) {
                installedAlready = 1;
                utilObj.launchAnotherApp(params["fbId"]);
            } else if (redirectExp == constantsObj.EXP_VAR_CONTROL) {
                link = questsObj.getGameShareLink(params["gameLink"], screenName, campaignName);
                utilObj.openStore(null, link, screenName);
            } else if (redirectExp == constantsObj.EXP_VAR_1) {
                utilObj.openUrl("itms-apps://itunes.apple.com/app/id" + params["appId"]);
            } else if (redirectExp == constantsObj.EXP_VAR_2) {
                link = questsObj.getGameShareLink(params["gameLink"], screenName, campaignName);
                utilObj.openStore(params["appId"], link, screenName);
            }

            // xpromoUtilObj.hitUrl(trackIosMap[params["gameId"]], campaignName);
            // link = questsObj.getGameShareLink(params["gameLink"], screenName, campaignName);
            // utilObj.openStore(params["appId"], link, screenName);

            // if (epmObj.getChosenVariant(xpromoConstantsObj.EXP_REDIRECT_TO_APP_STORE) == constantsObj.EXP_VAR_CONTROL) {
            //     xpromoUtilObj.hitUrl(moreGamesLayer.trackAndroidMap[game_id], campaignName);
            // }
        }
        trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, xpromoConstantsObj.TRACK_SOFT_LAUNCH, params["gameId"], xpromoConstantsObj.TRACK_SOFT_LAUNCH, constantsObj.TRACK_CLICK, currentExp, redirectExp, installedAlready, "");
    };

    this.getKeyValuePairForCreatives = function (creatives) {
        var creativeMap = {};
        creatives = creatives.split(",");
        for (var i = 0; i < creatives.length; i++) {
            var creative = creatives[i];
            creative = creative.split(":");
            creativeMap[creative[0]] = creative[1];
        }
        return creativeMap;
    };

    this.downloadGivenImage = function (imageLink, imageName) {
        if (!utilObj.fileExists(imageName)) {
            xPromoGameSpecificObj.downloadFileV1(imageLink, imageName);
            //loggerObj.debugLog("this is game Icon Name w ");
            return false;
        }
        return true;
    };

    this.downloadSprites = function (spriteLink, spriteName, spritePng) {
        var isReqdCreativeDownloaded = true;
        if (!utilObj.fileExists(spriteName)) {
            xPromoGameSpecificObj.downloadFileV1(spriteLink + spriteName, spriteName);
            //loggerObj.debugLog("this is game Icon Name w ");
            isReqdCreativeDownloaded = isReqdCreativeDownloaded && false;
        }
        if (!utilObj.fileExists(spritePng)) {
            xPromoGameSpecificObj.downloadFileV1(spriteLink + spritePng, spritePng);
            //loggerObj.debugLog("this is game Icon Name w ");
            isReqdCreativeDownloaded = isReqdCreativeDownloaded && false;
        }
        return isReqdCreativeDownloaded;
    };
};