coinGrantPopup = function () {
    var popupNode = null;
    var showWithAnim = true;
    var screen = constantsObj.SCREEN_W2E_COIN_GRANT;

    this.show = function (withAnim, layerForAnimation) {
        if (popupLayer.popupOpen && curScreen == constantsObj.SCREEN_W2E_COIN_GRANT) {
            popupLayer.close({noAnim: xPromoGameSpecificObj.popupShowWithAnim()});
        }
        if ((popupLayer.popupOpen && xPromoGameSpecificObj.getIsPrivatePolicyOpen() == true) || xPromoGameSpecificObj.isFtueVisible()) {
            return false;
        }
        if (popupLayer.popupOpen) {
            if (popupLayer.updatingToScreen == constantsObj.SCREEN_SOFT_LAUNCH) {
                softLaunchObj.setIsSoftLaunchSuppressed(true);
            }
            popupLayer.closeWithDefault();
        }
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        popupLayer.checkAndShow(w2eCoinGrantPopup.delayedShow, {layerForAnimation: layerForAnimation});
        return true;
    };

    this.delayedShow = function (sender, params) {
        var layerForAnimation = params.layerForAnimation;
        xPromoGameSpecificObj.setCurScreen(screen);

        var labelArr = [];
        var spriteArr = [];
        var popupHeight = 1200;
        var popupWidth = popupLayer.getWidthForPopup(screen, false);
        var popupObj = 'w2eCoinGrantPopup';
        var center = xPromoGameSpecificObj.getCenterPosW2ePopup(popupWidth, popupHeight);
        var yOffset = xPromoGameSpecificObj.xPromoW2eYOffset();
        var zOrder = constantsObj.UI_Z_ORDER;
        popupNode = new cc.Node();

        var creativeId = xpromoConstantsObj.TRACK_W2E_END + "_" + epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_XPROMO_W2E);
        trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, "", "", xpromoConstantsObj.TRACK_W2E_END, constantsObj.TRACK_VIEW, xpromoW2eObj.getVideosWatchedForXpromoMoreVideos(), creativeId, "", "");

        xPromoGameSpecificObj.addPopupBg(popupHeight, popupNode);

        var coin_icon = utilObj.getSprite(questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_ICON_COINS_3), center.x, center.y + 175 - yOffset, 0.5, 0.5, constantsObj.SCALE_SPRITE_13 * constantsObj.SPRITE_SCALING_FACTOR, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);
        coin_icon.setScale(coin_icon.getScale() * xPromoGameSpecificObj.scaleCoinStackInW2e());
        var text = stringsObj.you_earned;

        var rewardValue = xpromoW2eObj.getRewardValue();
        xpromoW2eObj.setRewardValueOverride(constantsObj.NOT_FOUND); // Resetting the reward value override as this is final placement for reward to be granted.

        text = text.replace("%N%", rewardValue.toString());

        utilObj.getBMFontLabel(text, constantsObj.FONT_SFCOMPACT_REGULAR_100, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), center.x, center.y - 50 - yOffset, 0.5, 1, labelArr, popupNode, zOrder);

        utilObj.getSprite(questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_ICON_COINS_4), center.x + 70, center.y - 110 - yOffset, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);
        var delay = 0.5;
        if (xpromoAnimationObj.getIsToasterAnimRunning()) {
            delay = 2.5;
        }
        utilObj.delayedCallback(layerForAnimation, xPromoGameSpecificObj.coinGrantAnimAfterDelay, delay, {
            xOffset: 70,
            yOffset: -110,
            cashToGrant: rewardValue,
            cashAlreadygranted: false
        }, false);

        var btn = questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_BUTTON_180_LOCAL);
        var texture = questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_BTN_180_TEXTURE_LOCAL);

        var buttonWidth = 500;
        var conditionForMoreVideos = xpromoW2eObj.checkToShowMoreVideos();
        if (conditionForMoreVideos) {
            buttonWidth = 1000;
        }

        var okayButton = utilObj.getButton(buttonWidth, 200, 0.5, 1.0, center.x, center.y - 300,
            btn, btn, btn, {
                obj: popupObj,
                fn: 'okayBtn',
                screen: screen,
                params: {"sound": constantsObj.button_tap_01, "sound_on": false},
                track: {
                    k: xpromoConstantsObj.TRACK_XPROMO,
                    p: xPromoGameSpecificObj.getPhylumForTracking(),
                    c: xPromoGameSpecificObj.getClassForTracking(),
                    o: xpromoConstantsObj.TRACK_W2E_END,
                    f: constantsObj.TRACK_CONTINUE,
                    g: xpromoW2eObj.getVideosWatchedForXpromoSurfacing(),
                    s: creativeId,
                    co: 1,
                    oppId: ""
                },
                child: [],
                feedBackType: constantsObj.NORMALBTN_FEEDBACK
            }, false, texture, 1);
        okayButton.setColor(constantsObj.COLOR_BUTTON_LIGHT_GREEN);
        popupNode.addChild(okayButton, zOrder);

        if (conditionForMoreVideos) {
            var str = xpromoStringsObj.watch_video_coins;
            var nextReward = xpromoW2eObj.getMoreVideosRewardVal();
            str = str.replace("%N%", nextReward.toString());
            utilObj.getBMFontLabel(str, constantsObj.FONT_SFCOMPACT_MEDIUM_90, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), center.x - 50, center.y - 340, 0.5, 1.0, labelArr, popupNode, zOrder);
            utilObj.getSprite(questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_ICON_COINS_4), center.x + 370, center.y - 340, 0.5, 1.0, constantsObj.SCALE_SPRITE_9, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);
        } else {
            utilObj.getBMFontLabel(stringsObj.okay, constantsObj.FONT_SFCOMPACT_MEDIUM_90, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), center.x, center.y - 340, 0.5, 1.0, labelArr, popupNode, zOrder);
        }
        popupLayer.popupSetup(screen, false, w2eCoinGrantPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });

        xPromoGameSpecificObj.popupShow(popupHeight, screen, stringsObj.congrats_small, popupNode, spriteArr, labelArr, true, constantsObj.COLOR_WHITE);
    };

    this.close = function () {
        var creativeId = xpromoConstantsObj.TRACK_W2E_END + "_" + epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_XPROMO_W2E);
        trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, "", "", xpromoConstantsObj.TRACK_W2E_END, constantsObj.TRACK_CLOSE, xpromoW2eObj.getVideosWatchedForXpromoMoreVideos(), creativeId, "", "");
        xpromoW2eObj.executeCallbackOnClose();
    };

    this.okayBtn = function () {
        if (xpromoW2eObj.checkToShowMoreVideos()) {
            var nextReward = xpromoW2eObj.getMoreVideosRewardVal();
            xpromoW2eObj.saveRewardValue(nextReward);
            if (!utilObj.isOnline()) {
                utilObj.playSound(constantsObj.button_tap_01, false);
                utilObj.showMessage(stringsObj.not_online);
                return;
            }
            var success = xPromoGameSpecificObj.showVideoAd(true);
            if (success == true) {
                popupLayer.closeWithDefault();
            }
        } else {
            popupLayer.closeWithDefault();
        }
    };

};