XpromoAfterW2e = function () {
    var popupNode = null;
    var showWithAnim = true;
    var screen = constantsObj.SCREEN_XPROMO_W2E;
    var showingGif = false;
    var gifFilesReference = null;

    this.show = function (withAnim, layerForAnimation) {
        if (popupLayer.popupOpen && curScreen == constantsObj.SCREEN_W2E_COIN_GRANT) {
            popupLayer.close({noAnim: xPromoGameSpecificObj.popupShowWithAnim()});
        }

        if ((popupLayer.popupOpen && xPromoGameSpecificObj.getIsPrivatePolicyOpen() == true) || xPromoGameSpecificObj.isFtueVisible()) {
            return false;
        }

        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }

        var priorityArr = xpromoW2eObj.getPriorityArr();
        var adwallQuests = questsObj.getAdWallQuests();
        var currentQuest = (questsObj.getXpromoW2eGameCounter() % priorityArr.length);
        var currentQuestData = adwallQuests[priorityArr[currentQuest]];
        if(currentQuestData == undefined) {
            return false;
        }

        popupLayer.checkAndShow(xpromoAfterW2e.delayedShow, {layerForAnimation: layerForAnimation});
        return true;
    };

    this.delayedShow = function (sender, params) {
        var layerForAnimation = params.layerForAnimation;

        var priorityArr = xpromoW2eObj.getPriorityArr();

        var adwallQuests = questsObj.getAdWallQuests();

        var labelArr = [];
        var spriteArr = [];
        var popupHeight = 1900;
        var popupWidth = popupLayer.getWidthForPopup(screen, false);
        var popupObj = 'xpromoW2eObj';
        var center = xPromoGameSpecificObj.getCenterPosW2ePopup(popupWidth, popupHeight);
        var screenName = utilObj.getScreenName(screen);
        var zOrder = constantsObj.UI_Z_ORDER;
        popupNode = new cc.Node();
        showingGif = false;
        gifFilesReference = null;

        var yOffsetForCoinHeader = xPromoGameSpecificObj.xPromoW2eYOffsetForCoinHeader();
        center.y += yOffsetForCoinHeader;

        var currentQuest = (questsObj.getXpromoW2eGameCounter() % priorityArr.length);
        var currentQuestData = adwallQuests[priorityArr[currentQuest]];

        var questDesc = currentQuestData.d;
        xPromoGameSpecificObj.addPopupBg(popupHeight,popupNode);
        var bg = utilObj.getScale9Sprite(questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_WHITE_EXTRA_ROUNDED), center.x, center.y - 275, 0.5, 0.5, popupWidth - 125, popupHeight - 720, spriteArr, popupNode, zOrder, questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_SPRITE_MISC));
        bg.setColor(constantsObj.COLOR_IN_GAME_QUEST_BG);

        var text = stringsObj.you_earned;
        var yOffset = xPromoGameSpecificObj.xPromoW2eYOffset();

        var rewardCoins = xpromoW2eObj.getRewardValue();
        var rewardValue = xpromoW2eObj.getNonOverriddenRewardValue() * xpromoW2eObj.getInstallQuestMultiplier();
        var multiplierDisplay = Math.round(rewardValue / rewardCoins);

        text = text.replace("%N%", rewardCoins.toString());
        utilObj.getBMFontLabel(text, constantsObj.FONT_SFCOMPACT_REGULAR_100, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), center.x, center.y + 650 - yOffset, 0.5, 1, labelArr, popupNode, zOrder);

        var delay = 0.1;
        if(xpromoAnimationObj.getIsToasterAnimRunning()) {
            delay = 2.5;
        }
        utilObj.delayedCallback(layerForAnimation, xPromoGameSpecificObj.coinGrantAnimAfterDelay, delay, {
            xOffset: 75,
            yOffset: 580,
            cashToGrant: rewardCoins, //xPromoGameSpecificObj.getW2EReward(),
            cashAlreadygranted: false
        }, false);

        var coinIcon = questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_ICON_COINS_4);
        utilObj.getSprite(coinIcon, center.x + 60, center.y + 585 - yOffset, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, popupNode, zOrder, questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_SPRITE_MISC));

        utilObj.getSprite(xpromoConstantsObj.banner_xpromo, center.x, center.y + 300, 0.5, 0.5, constantsObj.SCALE_SPRITE_24, spriteArr, popupNode, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
        text = stringsObj.earn_more;
        text = text.replace("%N%", rewardValue.toString());
        utilObj.getBMFontLabel(text, constantsObj.FONT_SFCOMPACT_MEDIUM_100, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), center.x, center.y + 380, 0.5, 1, labelArr, popupNode, zOrder);

        utilObj.getSprite(coinIcon, center.x - 110, center.y + 320, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, popupNode, zOrder + 1, questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_SPRITE_MISC));

        var creativeMap = xpromoUtilObj.getKeyValuePairForCreatives(currentQuestData.creatives);
        var gifFiles = xpromoW2eObj.getDownloadedGifFiles(creativeMap.w2e_gif);

        if(gifFiles.length == 2) {
            screen = constantsObj.SCREEN_XPROMO_W2E_GIF;
            screenName = utilObj.getScreenName(screen);

            // for sprite sheet gif animation
            cc.spriteFrameCache.addSpriteFrames(xpromoUtilObj.getAbsFilePath(gifFiles[1]), xpromoUtilObj.getAbsFilePath(gifFiles[0]));
            var loadingPlist = cc.loader.getRes(xpromoUtilObj.getAbsFilePath(gifFiles[1]));
            this.loading = cc.Sprite.create(xpromoUtilObj.getAbsFilePath(gifFiles[0]));
            this.loading.attr({
                x: center.x,
                y: center.y - 50,
                scale: popupWidth / 640,
            });
            popupNode.addChild(this.loading, zOrder + 1);
            var animFrames = [];
            var str = "";
            var frameCount = Object.keys(loadingPlist["frames"]).length;
            for (var i = 0; i < frameCount; i++){
                str = "Wise_" + xpromoUtilObj.padWithZeros(i*4, 5);

                str += ".jpg";
                var frame = cc.spriteFrameCache.getSpriteFrame(str);
                animFrames.push(frame);
            }

            var animation = cc.Animation.create(animFrames, 0.1, 1000);
            var animate = cc.Animate.create(animation);
            this.loading.runAction(animate);

            var trans_btn = utilObj.getButton(1000, 600, 0.5, 0.5,
                center.x, center.y - 50, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: popupObj,
                    fn: 'earnNow',
                    screen: screen,
                    params: {"sound": constantsObj.button_tap_01, "sound_on": false},
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: xPromoGameSpecificObj.getPhylumForTracking(),
                        c: xPromoGameSpecificObj.getClassForTracking(),
                        o: screenName,
                        f: constantsObj.TRACK_CONTINUE,
                        g: constantsObj.TRACK_BANNER,
                        s: xPromoGameSpecificObj.getSpeciesForTracking(),
                        co: 1,
                        oppId: ""
                    },
                    child: [],
                    feedBackType: constantsObj.NORMALBTN_FEEDBACK
                }, false, ccui.Widget.PLIST_TEXTURE, constantsObj.SCALE_ONE);
            utilObj.addChild(popupNode, trans_btn, zOrder + 1);


            utilObj.setVisible(bg, false);
            showingGif = true;
            gifFilesReference = gifFiles;
        } else {
            utilObj.getSprite(xpromoConstantsObj.gift_box_3, center.x, center.y - 50, 0.5, 0.5, constantsObj.SCALE_SPRITE_11, spriteArr, popupNode, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
        }

        // to make it generic will be using only "INSTALL AND PLAY" text
        text = xpromoConstantsObj.installAndPlay;
        utilObj.getBMFontLabel(text, constantsObj.FONT_SFCOMPACT_MEDIUM_80, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), center.x, center.y - 330, 0.5, 1, labelArr, popupNode, zOrder);
        var questDescLabel = utilObj.getBMFontLabel(questDesc, constantsObj.FONT_SFCOMPACT_MEDIUM_80, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), center.x, center.y - 430, 0.5, 1, labelArr, popupNode, zOrder);

        var gameIcon = "icon_" + currentQuestData.gh + ".png";
        if (!utilObj.isWeb() && !utilObj.fileExists(gameIcon)) {
            xPromoGameSpecificObj.downloadFileV1(constantsObj.MISC_SERVER_STATIC_BASE + "quests/images/icons/" + gameIcon, gameIcon);
        } else {
            utilObj.getSprite(xpromoUtilObj.getAbsFilePath(gameIcon), center.x + questDescLabel.getContentSize().width / 2 + 10, center.y - 435, 0, 1, constantsObj.SCALE_SPRITE_8, spriteArr, popupNode, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
        }

        var btn = questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_BUTTON_180_LOCAL);
        var texture = questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_BTN_180_TEXTURE_LOCAL);
        var closeButton = utilObj.getButton(600, 170, 0.5, 1.0, center.x, center.y - 600,
            btn, btn, btn, {
                obj: popupObj,
                fn: 'earnNow',
                screen: screen,
                params: {"sound": constantsObj.button_tap_01, "sound_on": false},
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: xPromoGameSpecificObj.getPhylumForTracking(),
                    c: xPromoGameSpecificObj.getClassForTracking(),
                    o: screenName,
                    f: constantsObj.TRACK_CONTINUE,
                    g: "",
                    s: xPromoGameSpecificObj.getSpeciesForTracking(),
                    co: 1,
                    oppId: ""
                },
                child: [],
                feedBackType: constantsObj.NORMALBTN_FEEDBACK
            }, false, texture, 1);
        popupNode.addChild(closeButton, zOrder + 1);
        closeButton.setColor(constantsObj.COLOR_BUTTON_LIGHT_GREEN);

        var label = utilObj.getBMFontLabel(stringsObj.earn_now, constantsObj.FONT_SFCOMPACT_MEDIUM_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), closeButton.getContentSize().width / 2, closeButton.getContentSize().height / 2, 0.5, 0.5, labelArr, closeButton, zOrder + 1);


        var offerTag = utilObj.getSprite(xpromoConstantsObj.offer_tag_02, 10, closeButton.getContentSize().height - 15, 0.5, 0.5, constantsObj.SCALE_SPRITE_24, spriteArr, closeButton, zOrder + 2, xpromoConstantsObj.SPRITE_QUESTS);
        text = multiplierDisplay.toString() + stringsObj.ten_times_value;
        var textArr = text.split(" ");
        label = utilObj.getBMFontLabel(textArr[0], constantsObj.FONT_SFCOMPACT_MEDIUM_50, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), offerTag.getContentSize().width / 2 - 80, (offerTag.getContentSize().height) + 60, 0.5, 0.5, labelArr, closeButton, zOrder + 2);
        label.setRotation(-25);
        label = utilObj.getBMFontLabel(textArr[1], constantsObj.FONT_SFCOMPACT_MEDIUM_50, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), offerTag.getContentSize().width / 2 - 52, (offerTag.getContentSize().height) + 10, 0.5, 0.5, labelArr, closeButton, zOrder + 2);
        label.setRotation(-25);
        xPromoGameSpecificObj.pulseButtonForXpromoAfterW2e(xpromoAfterW2e, closeButton);

        xpromoW2eObj.setCurrentQuestData(currentQuestData);

        xpromoW2eObj.setCallbackOnClose(function() {
            if(showingGif == true && utilObj.isArray(gifFilesReference)) {
                cc.spriteFrameCache.removeSpriteFramesFromFile(xpromoUtilObj.getAbsFilePath(gifFilesReference[1]));
                cc.textureCache.removeTextureForKey(xpromoUtilObj.getAbsFilePath(gifFilesReference[0]));
            }
        });

        xPromoGameSpecificObj.setCurScreen(screen);

        popupLayer.popupSetup(screen, false, xpromoW2eObj.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });

        xPromoGameSpecificObj.popupShow(popupHeight, screen, stringsObj.congrats_small, popupNode, spriteArr, labelArr, true, constantsObj.COLOR_WHITE, undefined, undefined, undefined, undefined, undefined, undefined, undefined, yOffsetForCoinHeader);
        xpromoW2eObj.updateXpromoPopupShown(layerForAnimation);
    };
};