XpromoExitPopup = function () {
    var popupNode = null;
    var showWithAnim = true;
    var cb = null;
    var screen = constantsObj.SCREEN_EXIT_CONFIRM;
    var parentScreen = null;
    var recommendationScrollView = null;
    var scrollPanes = 0;
    var scrollCount = 0;
    var prevPane = 0;
    var carouselSeqRepeat = null;
    var gameNodes = [];
    var gameTrackData = [];
    var gameQuestData = {};
    var imageDots = [];
    var gameFriendData = {};

    this.show = function (withAnim) {
        popupLayer.closeWithDefault();
        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }
        popupLayer.checkAndShow(xpromoExitPopup.delayedShow, null);
    };

    this.delayedShow = function () {
        xPromoGameSpecificObj.setCurScreen(screen);
        var labelArr = [];
        var spriteArr = [];
        var popupHeight = 1950;
        var popupWidth = popupLayer.getWidthForPopup(screen, false);
        var popupObj = 'xpromoExitPopup';
        var center = xPromoGameSpecificObj.getCenterPosW2ePopup(popupWidth, popupHeight);
        var screenName = utilObj.getScreenName(screen);
        parentScreen = curScreen;

        popupNode = new cc.Node();
        var zOrder = constantsObj.UI_Z_ORDER;
        var btn = questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_BUTTON_180_LOCAL);
        var texture = questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_BTN_180_TEXTURE_LOCAL);

        var textWidthAdjustment = 0;
        if(constantsObj.GAME_ID == 15) {
            textWidthAdjustment = 200;
        }
        xPromoGameSpecificObj.addPopupBg(popupHeight,popupNode);
        utilObj.getBMFontLabel(xpromoStringsObj.exit_desc, constantsObj.FONT_SFCOMPACT_REGULAR_80, constantsObj.COLOR_BLACK, constantsObj.POPUP_WIDTH - 400 + textWidthAdjustment,
            cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), center.x, center.y + 570, 0.5, 0.5, labelArr, popupNode, zOrder);
        var buttonHeight = 170;
        var buttonWidth = 430;
        var cancelBtn = utilObj.getButton(buttonWidth, buttonHeight, 0.5, 0.5, center.x - 305 , center.y + 280,
           btn, btn, btn, {
                obj: popupObj,
                fn: 'backToGame',
                screen: screen,
                params: {"sound": constantsObj.button_tap_01, "sound_on": false},
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: xPromoGameSpecificObj.getPhylumForTracking(),
                    c: xPromoGameSpecificObj.getClassForTracking(),
                    o: screenName,
                    f: constantsObj.TRACK_BACK,
                    g: "",
                    s: xPromoGameSpecificObj.getSpeciesForTracking(),
                    co: 1,
                    oppId: ""
                },
                child: [],
                feedBackType: constantsObj.NORMALBTN_FEEDBACK
            }, false, texture, 1);
        cancelBtn.setColor(constantsObj.COLOR_BLUE_02);
        popupNode.addChild(cancelBtn, zOrder);

        var text2 = utilObj.getBMFontLabel(stringsObj.cancel, constantsObj.FONT_SFCOMPACT_MEDIUM_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), center.x - 305, center.y + 285, 0.5, 0.5, labelArr, popupNode, zOrder);

        var yesBtn = utilObj.getButton(buttonWidth, buttonHeight, 0.5, 0.5, center.x + 305, center.y + 280,
            btn, btn, btn, {
                obj: popupObj,
                fn: 'endGame',
                screen: screen,
                params: {"sound": constantsObj.button_tap_01, "sound_on": false},
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: xPromoGameSpecificObj.getPhylumForTracking(),
                    c: xPromoGameSpecificObj.getClassForTracking(),
                    o: screenName,
                    f: constantsObj.TRACK_EXIT,
                    g: "",
                    s: xPromoGameSpecificObj.getSpeciesForTracking(),
                    co: 1,
                    oppId: ""
                },
                child: [],
                feedBackType: constantsObj.NORMALBTN_FEEDBACK
            }, false, texture, 1);
        yesBtn.setColor(constantsObj.COLOR_RED_02);
        popupNode.addChild(yesBtn, zOrder);

        var text3 = utilObj.getBMFontLabel(stringsObj.yes, constantsObj.FONT_SFCOMPACT_MEDIUM_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), center.x + 305, center.y + 285, 0.5, 0.5, labelArr, popupNode, zOrder);

        // Running game specific modifications for button colors
        if(constantsObj.GAME_ID == 11 || constantsObj.GAME_ID == 15) {
            utilObj.setColor(cancelBtn, constantsObj.COLOR_BUTTON_LIGHT_PINK_NEW);
            utilObj.setColor(yesBtn, constantsObj.COLOR_BUTTON_LIGHT_BLUE_NEW);
        } else if(constantsObj.GAME_ID == 8 || constantsObj.GAME_ID == 17) {
            utilObj.setColor(cancelBtn, constantsObj.COLOR_BUTTON_GREEN);
            utilObj.setColor(yesBtn, constantsObj.COLOR_BUTTON_ORANGE);
        }

        // From this point onwards we are popuplating the xpromo part
        //
        // Horizontal line divider
        var horizontalLine = utilObj.getScale9Sprite(constantsObj.tile_white, center.x, center.y + 100, 0.5, 0.5, 1150, 7, spriteArr, popupNode, zOrder, constantsObj.SPRITE_MISC);
        horizontalLine.setColor(xpromoConstantsObj.COLOR_SUPPORT_BG);

        // Lets get the data from adwall quests on the game that needs to be shown
        var adWallQuests = questsObj.getAdWallQuests();

        var gameMapSorted = adWallObj.getSortedGameMapKeysByInstalled();

        recommendationScrollView = new ccui.ScrollView();
        var scrollViewHeight = 1125;
        recommendationScrollView.setDirection(ccui.ScrollView.DIR_HORIZONTAL);
        recommendationScrollView.setTouchEnabled(false);
        recommendationScrollView.setBounceEnabled(false);
        recommendationScrollView.setInertiaScrollEnabled(false);
        utilObj.setPosition(recommendationScrollView, center.x, center.y + 100);
        recommendationScrollView.setContentSize(cc.size(constantsObj.POPUP_WIDTH, scrollViewHeight));
        recommendationScrollView.setSwallowTouches(false);
        recommendationScrollView.setAnchorPoint(cc.p(0.5, 1));
        utilObj.addChild(popupNode, recommendationScrollView, zOrder);

        for(var index in gameMapSorted) {
            var gameData = adWallQuests[gameMapSorted[index]];
            var gameId = gameData["gh"];
            if(gameId == constantsObj.GAME_ID) {
                continue;
            }

            gameQuestData[gameId] = gameData;

            var friendPic = "#friendly_41.jpg";
            var friendName = "Ann";

            var friendsDisplayData = adWallObj.getFriendsToDisplay();
            var overrideFriend = adWallObj.getOverridenFriendData();
            if (overrideFriend != null || (friendsDisplayData[gameId] != undefined && friendsDisplayData[gameId][0] != undefined)) {
                var friendData = overrideFriend != null ? overrideFriend : friendsDisplayData[gameId][0];
                friendPic = adWallObj.getFriendImageFromData(friendData);
                var fullName = friendData.name;
                var splitName = fullName.split(" ");
                friendName = splitName[0];
                gameFriendData[gameId] = friendData;
            }

            var carouselNode = new cc.Node();
            carouselNode.setContentSize(constantsObj.POPUP_WIDTH, scrollViewHeight);
            carouselNode.setPosition(constantsObj.POPUP_WIDTH / 2 + (gameNodes.length * constantsObj.POPUP_WIDTH), scrollViewHeight);
            carouselNode.setAnchorPoint(0.5, 1);
            utilObj.addChild(recommendationScrollView, carouselNode, zOrder);

            var xPos = constantsObj.POPUP_WIDTH / 2;
            var yPos = scrollViewHeight - 50;

            // Recommendation message
            var xpromoMsg = xpromoStringsObj.recommendation_text.replace("%NAME%", friendName);
            utilObj.getBMFontLabel(xpromoMsg, constantsObj.FONT_SFCOMPACT_REGULAR_80, constantsObj.COLOR_BLACK, constantsObj.POPUP_WIDTH - 600 + textWidthAdjustment,
                cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, carouselNode, zOrder);

            // Background circle for friend image

            var circle = utilObj.getSprite(xpromoConstantsObj.circle_player, xPos + 500, yPos - 100, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, carouselNode, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
            circle.setContentSize(194, 194);
            circle.setColor(xpromoConstantsObj.COLOR_SUPPORT_BG);

            // Friend image circle
            var clipperNode;
            if(!utilObj.isWeb()) {
                var stencil = utilObj.getSprite(xpromoConstantsObj.circle_player, xPos + 500, yPos - 100, 0.5, 0.5, constantsObj.SCALE_SPRITE_2, spriteArr);
                stencil.setContentSize(194, 194);
                clipperNode = cc.ClippingNode(stencil);
                clipperNode.setAlphaThreshold(0);
                utilObj.addChild(carouselNode, clipperNode, zOrder+1);
            } else {
                clipperNode = carouselNode
            }
            var friendPic = utilObj.getSprite(friendPic, xPos + 500, yPos - 100, 0.5, 0.5, constantsObj.SCALE_SPRITE_2, spriteArr,
                clipperNode, zOrder+1, constantsObj.SPRITE_LOCAL);
            friendPic.setContentSize(206, 206);


            // Populating the banner for the game to be shown
            var gameIcon = "w2e_xpromo_" + gameId + ".jpg";
            var adWallCreatives = adWallObj.getImagesForGameId(gameId);
            if(adWallCreatives.w2e_thumb != undefined) {
                gameIcon = adWallCreatives.w2e_thumb;
            }
            var gameCreativeLink = xpromoUtilObj.getImageLinkFromName(gameIcon);
            if (!utilObj.isWeb() && !utilObj.fileExists(gameIcon)) {
                xPromoGameSpecificObj.downloadFileV2(gameCreativeLink, gameIcon);
                utilObj.getSprite("#icon_" + gameId + ".png", xPos, yPos - 225, 0.5, 1, constantsObj.SCALE_SPRITE_4, spriteArr, carouselNode, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
            } else {
                utilObj.getSprite(xpromoUtilObj.getAbsFilePath(gameIcon), xPos, yPos - 225, 0.5, 1, constantsObj.SCALE_SPRITE_5, spriteArr, carouselNode, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
            }

            var trans_btn = utilObj.getButton(constantsObj.POPUP_WIDTH - 100, scrollViewHeight, 0.5, 1,
                xPos, yPos, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: popupObj,
                    fn: 'playNow',
                    screen: screen,
                    params: {"sound": constantsObj.button_tap_01, "sound_on": false, "gameId": gameId},
                    track: {
                        k: xpromoConstantsObj.TRACK_XPROMO,
                        p: "popup",
                        c: friendData.refId,
                        o: "exit_screen",
                        f: constantsObj.TRACK_CLICK,
                        g: "",
                        s: gameId + "",
                        co: 1,
                        oppId: ""
                    },
                    child: [],
                    feedBackType: constantsObj.NORMALBTN_FEEDBACK
                }, false, ccui.Widget.PLIST_TEXTURE, constantsObj.SCALE_ONE);
            utilObj.addChild(carouselNode, trans_btn, zOrder + 1);


            if(gameNodes.length > 0) {
                utilObj.setVisible(carouselNode, false);
            } else {
                trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, "popup", friendData.refId, "exit_screen", constantsObj.TRACK_VIEW, "", gameId + "", "", "");
                var trackMap = xpromoUtilObj.getAdjustTrackerForGameId(gameId);
                utilObj.delayedCallback(popupLayer, xpromoUtilObj.hitAdjustViewTrackingAfterDelay, 0.1, {trackId: trackMap, src:  "xpromo_exit_screen", creative: gameIcon, adgroup: undefined}, false);
            }
            gameNodes.push(carouselNode);
            gameTrackData.push({gameId: gameId, gameIcon: gameIcon, friendData: friendData});
        }

        recommendationScrollView.setInnerContainerSize(cc.size((gameNodes.length) * constantsObj.POPUP_WIDTH, scrollViewHeight));
        scrollPanes = gameNodes.length;

        if (gameNodes.length > 1) {
            var xDiff = 50;
            xPos = center.x - (xDiff * (gameNodes.length - 1) / 2);

            for (var i = 0; i < gameNodes.length; i++) {
                var b1 = utilObj.getSprite(xpromoConstantsObj.circle_player, xPos, center.y - 915, 0.5, 0.5, 0.1, spriteArr, popupNode, zOrder + 2, constantsObj.SPRITE_QUESTS);
                b1.setContentSize(194, 194);
                b1.setColor(constantsObj.COLOR_BLACK);
                b1.setOpacity(constantsObj.OPACITY_40);
                imageDots.push(b1);
                xPos += xDiff;
            }
            if (gameNodes.length > 0) {
                utilObj.setColor(imageDots[scrollCount], constantsObj.COLOR_BLACK);
                utilObj.setOpacity(imageDots[scrollCount], constantsObj.OPACITY_100);
                utilObj.setScale(imageDots[scrollCount], 0.15);
            }

            var delayAction = animationObj.getDelayTime(6.0);
            var fnCallAction = utilObj.getCallFunc(xpromoExitPopup.scrollToPercentHorizontal, xpromoExitPopup);
            var actions = [delayAction, fnCallAction];
            var seq = animationObj.getSequence(actions);
            carouselSeqRepeat = new cc.RepeatForever(seq);
            animationObj.runAction(popupLayer, carouselSeqRepeat);
        }

        popupLayer.popupSetup(screen, false, xpromoExitPopup.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });

        // For Word Jam - the game name is "Crossword Jam", and this screen requires it to be Word Jam
        var gameName = xPromoGameSpecificObj.getGameName();
        if(constantsObj.GAME_ID == 11) {
            gameName = stringsObj.word_jam;
        }

        if(constantsObj.GAME_ID == 8 || constantsObj.GAME_ID == 17){
            gameName = "Game";
        }
        var exitHeader = xpromoStringsObj.exit_game_name.replace("%GAME%", gameName);
        var exitFont = xPromoGameSpecificObj.getExitPopupHeaderFont();

        xPromoGameSpecificObj.popupShow(popupHeight, screen, exitHeader, popupNode, spriteArr, labelArr, true, constantsObj.COLOR_WHITE, undefined, undefined, undefined, undefined, undefined,exitFont, undefined, 0);
    };

    this.close = function () {
        popupLayer.stopAllActions();
        scrollPanes = 0;
        scrollCount = 0;
        prevPane = 0;
        gameNodes = [];
        gameTrackData = [];
        gameQuestData = {};
        imageDots = [];
        gameFriendData = {};

        if (cb != null) {
            var tempCb = cb;
            cb = null;
            tempCb();
        }
    };

    this.backToGame = function () {
        popupLayer.closeWithDefault();
        if(constantsObj.GAME_ID == 8 || constantsObj.GAME_ID == 17) {
            if (lastScreen == constantsObj.SCREEN_PRIVACY_POLICY) {
                //loggerObj.debugLog("check coming here awafbjkwalelWwe");
                //popupLayer.popupOpen = false;
                privacyPolicyPopup.show(constantsObj.SCREEN_QUIT);
            }
        }
    };

    this.endGame = function () {
        xPromoGameSpecificObj.onExitGameFromPopup();
        utilObj.endGame();
    };

    this.playNow = function(sender, params) {
        utilObj.resetIsAppInstalledMap();
        if(params.gameId != undefined && params.gameId > -1 &&
            gameQuestData != undefined && gameQuestData[params.gameId] != undefined && gameQuestData[params.gameId].id != undefined &&
            xpromoUtilObj.isGameEligibleForXpromo(params.gameId, gameQuestData[params.gameId].id)) {

            questsObj.makeRelatedQuestsStatusStarted(gameQuestData[params.gameId].id);
            if(gameFriendData[params.gameId] != undefined && gameFriendData[params.gameId].bot == false) {
                adWallObj.setFriendClickedData(gameFriendData[params.gameId], params.gameId, true);
            }
        }

        var campaignName, screenName, redirectionParams, trackId;
        campaignName = xpromoConstantsObj.TRACK_EXIT_PROMO;
        screenName = utilObj.getScreenName(screen);
        trackId = campaignName + "_" + epmObj.getChosenVariant(xpromoConstantsObj.EXP_XPROMO_EXIT_SCREEN);
        redirectionParams = xpromoUtilObj.generateRedirectionParams(gameQuestData[params.gameId]);

        questsObj.redirectToStoreWithTracking(campaignName, screenName, redirectionParams, trackId);
        popupLayer.closeWithDefault(); // Closing the popup when the player clicks on any game.
    };

    this.scrollToPercentHorizontal = function() {
        prevPane = scrollCount;
        if(scrollCount < (scrollPanes - 1)) {
            scrollCount++;
        } else {
            scrollCount = 0
        }

        if(gameNodes[scrollCount] != undefined) {
            utilObj.setVisible(gameNodes[scrollCount], true);
        }

        if(imageDots[scrollCount] != undefined) {
            utilObj.setOpacity(imageDots[scrollCount], constantsObj.OPACITY_100);
            utilObj.setScale(imageDots[scrollCount], 0.15);
        }

        if(imageDots[prevPane] != undefined) {
            utilObj.setOpacity(imageDots[prevPane], constantsObj.OPACITY_40);
            utilObj.setScale(imageDots[prevPane], 0.1);
        }

        recommendationScrollView.scrollToPercentHorizontal(100 * scrollCount / (scrollPanes - 1), 0.3, false);
        utilObj.delayedCallback(popupLayer, onScrollComplete, 0.5, null, false);
    };

    var onScrollComplete = function() {
        if(gameTrackData[scrollCount] != undefined && gameTrackData[scrollCount].gameId != undefined) {
            var trackMap = xpromoUtilObj.getAdjustTrackerForGameId(gameTrackData[scrollCount].gameId);
            utilObj.delayedCallback(popupLayer, xpromoUtilObj.hitAdjustViewTrackingAfterDelay, 0.1, {trackId: trackMap, src:  "xpromo_exit_screen", creative: gameTrackData[scrollCount].gameIcon, adgroup: undefined}, false);
            if(gameTrackData[scrollCount].friendData != undefined) {
                var friendData = gameTrackData[scrollCount].friendData;
                trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, "popup", friendData.refId, "exit_screen", constantsObj.TRACK_VIEW, "", gameTrackData[scrollCount].gameId + "", "", "");
            }
        }

        if(gameNodes[prevPane] != undefined) {
            utilObj.setVisible(gameNodes[prevPane], false);
        }
    };
};