XpromoW2eSocial = function () {
    var popupNode = null;
    var showWithAnim = true;
    var screen = constantsObj.SCREEN_XPROMO_W2E;
    var gameUserCountMap = {
        "4": 8,
        "8": 2,
        "9": 3,
        "10": 1,
        "11": 2,
        "12": 2,
        "14": 1,
        "15": 1,
        "16": 1,
        "17": 1
    };

    this.show = function (withAnim, layerForAnimation) {
        if (popupLayer.popupOpen && curScreen == constantsObj.SCREEN_W2E_COIN_GRANT) {
            popupLayer.close({noAnim: xPromoGameSpecificObj.popupShowWithAnim()});
        }

        if ((popupLayer.popupOpen && xPromoGameSpecificObj.getIsPrivatePolicyOpen() == true) || xPromoGameSpecificObj.isFtueVisible()) {
            return false;
        }

        if (withAnim != undefined) {
            showWithAnim = withAnim;
        }

        var priorityArr = xpromoW2eObj.getPriorityArr();
        var adwallQuests = questsObj.getAdWallQuests();
        var currentQuest = (questsObj.getXpromoW2eGameCounter() % priorityArr.length);
        var currentQuestData = adwallQuests[priorityArr[currentQuest]];
        if(currentQuestData == undefined) {
            return false;
        }

        popupLayer.checkAndShow(xpromoW2eSocial.delayedShow, {layerForAnimation: layerForAnimation});
        return true;
    };

    this.delayedShow = function (sender, params) {
        var layerForAnimation = params.layerForAnimation;
        xPromoGameSpecificObj.setCurScreen(screen);

        var priorityArr = xpromoW2eObj.getPriorityArr();

        var adwallQuests = questsObj.getAdWallQuests();

        var labelArr = [];
        var spriteArr = [];
        var withSocial = xpromoW2eObj.isInW2ESocialVariant();

        var currentQuest = (questsObj.getXpromoW2eGameCounter() % priorityArr.length);
        var currentQuestData = adwallQuests[priorityArr[currentQuest]];

        var questDesc = currentQuestData.d;
        var gameId = currentQuestData.gh;

        var friendPic = "";
        var friendName = "";
        var isBot = false;
        if (withSocial) {
            var friendsDisplayData = adWallObj.getFriendsToDisplay();
            var overrideFriend = adWallObj.getOverridenFriendData();
            if (overrideFriend != null || (friendsDisplayData[gameId] != undefined && friendsDisplayData[gameId][0] != undefined)) {
                var friendData = overrideFriend != null ? overrideFriend : friendsDisplayData[gameId][0];
                friendPic = adWallObj.getFriendImageFromData(friendData);
                var fullName = friendData.name;
                var splitName = fullName.split(" ");
                friendName = splitName[0];
                isBot = friendData.bot;
                if(!isBot) {
                    xpromoW2eObj.updateSessionFriendShown(friendData);
                }
            } else {
                withSocial = false;
            }
        }

        var popupHeight = withSocial ? 2200 : 2000;
        var socialYOffset = withSocial ? 0 : -100;
        var popupWidth = popupLayer.getWidthForPopup(screen, false);
        var popupObj = 'xpromoW2eObj';
        var center = xPromoGameSpecificObj.getCenterPosW2ePopup(popupWidth, popupHeight);
        var screenName = utilObj.getScreenName(screen);
        var zOrder = constantsObj.UI_Z_ORDER;
        popupNode = new cc.Node();

        var yOffsetForCoinHeader = xPromoGameSpecificObj.xPromoW2eYOffsetForCoinHeader();
        center.y += yOffsetForCoinHeader;

        xPromoGameSpecificObj.addPopupBg(popupHeight,popupNode);

        var text = stringsObj.you_earned;
        var yOffset = xPromoGameSpecificObj.xPromoW2eYOffset();

        var rewardCoins = xpromoW2eObj.getRewardValue();
        var rewardValue = xpromoW2eObj.getNonOverriddenRewardValue() * xpromoW2eObj.getInstallQuestMultiplier();
        var multiplierDisplay = Math.round(rewardValue / rewardCoins);

        // Sub header text for the amount of coin currently  earned
        text = text.replace("%N%", rewardCoins.toString());
        utilObj.getBMFontLabel(text, constantsObj.FONT_SFCOMPACT_REGULAR_90, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), center.x, center.y + 845 - yOffset + socialYOffset, 0.5, 1, labelArr, popupNode, zOrder);

        var delay = 0.1;
        if(xpromoAnimationObj.getIsToasterAnimRunning()) {
            delay = 2.5;
        }
        utilObj.delayedCallback(layerForAnimation, xPromoGameSpecificObj.coinGrantAnimAfterDelay, delay, {
            xOffset: 75,
            yOffset: 785 + socialYOffset,
            cashToGrant: rewardCoins,
            cashAlreadygranted: false
        }, false);

        // Banner image and the coins you can earn more through XPromo W2E
        var coinIcon = questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_ICON_COINS_4);
        utilObj.getSprite(coinIcon, center.x + 60, center.y + 790 - yOffset + socialYOffset, 0.5, 0.5, constantsObj.SCALE_SPRITE_14, spriteArr, popupNode, zOrder, questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_SPRITE_MISC));

        utilObj.getSprite(xpromoConstantsObj.banner_xpromo, center.x, center.y + 570 + socialYOffset, 0.5, 0.5, constantsObj.SCALE_SPRITE_7, spriteArr, popupNode, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
        text = stringsObj.earn_more;
        text = text.replace("%N%", rewardValue.toString());
        utilObj.getBMFontLabel(text, constantsObj.FONT_SFCOMPACT_REGULAR_90, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), center.x, center.y + 650 + socialYOffset, 0.5, 1, labelArr, popupNode, zOrder);

        utilObj.getSprite(coinIcon, center.x - 100, center.y + 590 + socialYOffset, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, popupNode, zOrder + 1, questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_SPRITE_MISC));

        // Creative image for the game
        var gameIcon = "w2e_xpromo_" + gameId + ".jpg";
        var adWallCreatives = adWallObj.getImagesForGameId(gameId);
        if(adWallCreatives.w2e_thumb != undefined) {
            gameIcon = adWallCreatives.w2e_thumb;
        }
        var gameCreativeLink = xpromoUtilObj.getImageLinkFromName(gameIcon);
        if (!utilObj.isWeb() && !utilObj.fileExists(gameIcon)) {
            xPromoGameSpecificObj.downloadFileV2(gameCreativeLink, gameIcon);
            utilObj.getSprite("#icon_" + gameId + ".png", center.x, center.y + 410 + socialYOffset, 0.5, 1, constantsObj.SCALE_SPRITE_4, spriteArr, popupNode, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
        } else {
            utilObj.getSprite(xpromoUtilObj.getAbsFilePath(gameIcon), center.x, center.y + 410 + socialYOffset, 0.5, 1, constantsObj.SCALE_SPRITE_5, spriteArr, popupNode, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
        }

        var trans_btn = utilObj.getButton(1200, 700, 0.5, 1,
            center.x, center.y + 410 + socialYOffset, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: popupObj,
                fn: 'earnNow',
                screen: screen,
                params: {"sound": constantsObj.button_tap_01, "sound_on": false},
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: xPromoGameSpecificObj.getPhylumForTracking(),
                    c: xPromoGameSpecificObj.getClassForTracking(),
                    o: screenName,
                    f: constantsObj.TRACK_CONTINUE,
                    g: "",
                    s: xPromoGameSpecificObj.getSpeciesForTracking(),
                    co: 1,
                    oppId: ""
                },
                child: [],
                feedBackType: constantsObj.NORMALBTN_FEEDBACK
            }, false, ccui.Widget.PLIST_TEXTURE, constantsObj.SCALE_ONE);
        utilObj.addChild(popupNode, trans_btn, zOrder + 1);


        // to make it generic will be using only "INSTALL AND PLAY" text
        text = xpromoConstantsObj.installAndPlay + " " + questDesc;
        utilObj.getBMFontLabel(text, constantsObj.FONT_SFCOMPACT_MEDIUM_80, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), center.x, center.y - 330 + socialYOffset, 0.5, 1, labelArr, popupNode, zOrder);


        if(withSocial) {
            // Friend image with a text
            var text = xpromoStringsObj.w2e_bot_text;
            var xBotOffset = 100;
            var socialTextWidth = constantsObj.LABEL_AUTO_WIDTH;
            if(!isBot) {
                text = xpromoStringsObj.w2e_social_text;
                text = text.replace("%VALUE%", friendName);
                xBotOffset = 50;
                socialTextWidth = popupWidth - 300;
            }

            var userCount = gameUserCountMap[gameId] != undefined ? gameUserCountMap[gameId]: 2;
            text = text.replace("%N%", userCount.toString());

            if(constantsObj.GAME_ID == 8 || constantsObj.GAME_ID == 17) {
                socialTextWidth = socialTextWidth - 100;
            }

            utilObj.getBMFontLabel(text, constantsObj.FONT_SFCOMPACT_MEDIUM_80, constantsObj.COLOR_BLACK,
                socialTextWidth, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), center.x - 370 + xBotOffset, center.y - 550, 0, 0.5, labelArr, popupNode, zOrder);

            var circle = utilObj.getSprite(xpromoConstantsObj.circle_player, center.x - 490 + xBotOffset, center.y - 550, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, popupNode, zOrder, xpromoConstantsObj.SPRITE_QUESTS);
            circle.setContentSize(194, 194);
            circle.setColor(xpromoConstantsObj.COLOR_SUPPORT_BG);

            var clipperNode;
            if(!utilObj.isWeb()) {
                var stencil = utilObj.getSprite(xpromoConstantsObj.circle_player, center.x - 490 + xBotOffset, center.y - 550, 0.5, 0.5, constantsObj.SCALE_SPRITE_2, spriteArr);
                stencil.setContentSize(194, 194);
                clipperNode = cc.ClippingNode(stencil);
                clipperNode.setAlphaThreshold(0);
                utilObj.addChild(popupNode, clipperNode, zOrder+1);
            } else {
                clipperNode = popupNode
            }
            var friendPic = utilObj.getSprite(friendPic, center.x - 490 + xBotOffset, center.y - 550, 0.5, 0.5, constantsObj.SCALE_SPRITE_2, spriteArr,
                clipperNode, zOrder+1, constantsObj.SPRITE_LOCAL);
            friendPic.setContentSize(206, 206);


            var trans_btn = utilObj.getButton(206, 206, 0.5, 0.5,
                center.x - 490 + xBotOffset, center.y - 550, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: popupObj,
                    fn: 'earnNow',
                    screen: screen,
                    params: {"sound": constantsObj.button_tap_01, "sound_on": false},
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: xPromoGameSpecificObj.getPhylumForTracking(),
                        c: xPromoGameSpecificObj.getClassForTracking(),
                        o: screenName,
                        f: constantsObj.TRACK_CONTINUE,
                        g: "",
                        s: xPromoGameSpecificObj.getSpeciesForTracking(),
                        co: 1,
                        oppId: ""
                    },
                    child: [],
                    feedBackType: constantsObj.NORMALBTN_FEEDBACK
                }, false, ccui.Widget.PLIST_TEXTURE, constantsObj.SCALE_ONE);
            utilObj.addChild(popupNode, trans_btn, zOrder + 2);
        }


        // Earn now button with a star bust text
        var btn = questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_BUTTON_180_LOCAL);
        var texture = questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_BTN_180_TEXTURE_LOCAL);

        var closeButton = utilObj.getButton(600, 170, 0.5, 1.0, center.x, center.y - 770 - socialYOffset,
            btn, btn, btn, {
                obj: popupObj,
                fn: 'earnNow',
                screen: screen,
                params: {"sound": constantsObj.button_tap_01, "sound_on": false},
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: xPromoGameSpecificObj.getPhylumForTracking(),
                    c: xPromoGameSpecificObj.getClassForTracking(),
                    o: screenName,
                    f: constantsObj.TRACK_CONTINUE,
                    g: "",
                    s: xPromoGameSpecificObj.getSpeciesForTracking(),
                    co: 1,
                    oppId: ""
                },
                child: [],
                feedBackType: constantsObj.NORMALBTN_FEEDBACK
            }, false, texture, 1);
        popupNode.addChild(closeButton, zOrder + 1);
        closeButton.setColor(constantsObj.COLOR_BUTTON_LIGHT_GREEN);

        var label = utilObj.getBMFontLabel(stringsObj.earn_now, constantsObj.FONT_SFCOMPACT_MEDIUM_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), closeButton.getContentSize().width / 2, closeButton.getContentSize().height / 2, 0.5, 0.5, labelArr, closeButton, zOrder + 1);


        var offerTag = utilObj.getSprite(xpromoConstantsObj.offer_tag_02, 10, closeButton.getContentSize().height - 15, 0.5, 0.5, constantsObj.SCALE_SPRITE_24, spriteArr, closeButton, zOrder + 2, xpromoConstantsObj.SPRITE_QUESTS);
        text = multiplierDisplay.toString() + stringsObj.ten_times_value;
        var textArr = text.split(" ");
        label = utilObj.getBMFontLabel(textArr[0], constantsObj.FONT_SFCOMPACT_MEDIUM_50, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), offerTag.getContentSize().width / 2 - 80, (offerTag.getContentSize().height) + 60, 0.5, 0.5, labelArr, closeButton, zOrder + 2);
        label.setRotation(-25);
        label = utilObj.getBMFontLabel(textArr[1], constantsObj.FONT_SFCOMPACT_MEDIUM_50, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), offerTag.getContentSize().width / 2 - 52, (offerTag.getContentSize().height) + 10, 0.5, 0.5, labelArr, closeButton, zOrder + 2);
        label.setRotation(-25);
        xPromoGameSpecificObj.pulseButtonForXpromoAfterW2e(xpromoAfterW2e, closeButton);

        xpromoW2eObj.setCurrentQuestData(currentQuestData);

        popupLayer.popupSetup(screen, false, xpromoW2eObj.close, null, showWithAnim, {
            noAnim: false,
            dontGoToLastScreen: false
        });

        xPromoGameSpecificObj.popupShow(popupHeight, screen, stringsObj.congrats_small, popupNode, spriteArr, labelArr, true, constantsObj.COLOR_WHITE, undefined, undefined, undefined, undefined, undefined, constantsObj.FONT_SFCOMPACT_REGULAR_110, undefined, yOffsetForCoinHeader);
        xpromoW2eObj.updateXpromoPopupShown(layerForAnimation);
    };
};