XpromoAnimation = function () {
    var isQuestToaster = true;
    var lastToasterAnimationTimestamp = 0;
    var isToasterAnimRunning = false;
    var screenTransitionHappened = 0;
    var bubblePopAnimRunning = false;

    this.resetAllAnimationRunning = function () {
        xpromoAnimationObj.setIsToasterAnimRunning(false);
        xpromoAnimationObj.setBubblePopAnimRunning(false);
    };

    this.getBubblePopAnimRunning = function () {
        return bubblePopAnimRunning;
    };

    this.setBubblePopAnimRunning = function (val) {
        bubblePopAnimRunning = val;
    };

    this.getIsToasterAnimRunning = function () {
        return isToasterAnimRunning;
    };

    this.setIsToasterAnimRunning = function (val) {
        isToasterAnimRunning = val;
    };

    this.getScreenTransitionHappened = function () {
        return screenTransitionHappened;
    };

    this.setScreenTransitionHappened = function (val) {
        screenTransitionHappened = val;
    };

    this.incrementLastToasterAnimationTimestamp = function () {
        lastToasterAnimationTimestamp++;
    };

    this.animateLockIcon = function (node) {
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        var sX = utilObj.getScaleX(node);
        var sY = utilObj.getScaleY(node);
        var timeFactor = 2;
        var scale0 = animationObj.getScaleDifferentTo(0.1 * timeFactor, sX * 1.05, sY * 1.05);
        var scale1 = animationObj.getScaleDifferentTo(0.1 * timeFactor, sX, sY * 0.7);
        var scale2 = animationObj.getScaleDifferentTo(0.1 * timeFactor, sX, sY * 1.0);
        var actions = [scale0, scale1, scale2];
        var seqAction = animationObj.getSequence(actions);
        node.runAction(seqAction);
    };

    this.fadeFullLock = function (sender, params) {
        var node = params["node"];
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        params["node"].runAction(animationObj.getFadeTo(0, 0));
    };

    this.unfadeLockParticlesUpper = function (sender, params) {
        var node = params["node"];
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        params["node"].runAction(animationObj.getFadeTo(0.001, constantsObj.OPACITY_80));
    };

    this.unfadeLockParticlesLower = function (sender, params) {
        var node = params["node"];
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        params["node"].runAction(animationObj.getFadeTo(0.001, constantsObj.OPACITY_80));
    };

    this.animateLockUpper = function (sender, params) {
        var node = params["node"];
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        var timeFactor = 2;
        var scale3 = animationObj.getRotateBy(0.1 * timeFactor, 50);
        node.runAction(scale3);
    };

    this.fadeBackground = function (sender, params) {
        var node = params["node"];
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        params["node"].runAction(animationObj.getFadeOut(1.5));
    };

    this.unfadeBackground = function (sender, params) {
        var node = params["node"];
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        params["node"].runAction(animationObj.getFadeTo(0.001, constantsObj.OPACITY_100));
    };

    this.animateStarEffect = function (sender, params) {
        var paramsTrail = {
            x: centerXPos * 2 - 205,
            y: params["yPos"],
            layer: params["layer"],
            zOrder: params["listZOrder"],
            scale: 1
        };
        // streakObj.playStreakLeafStarEffect(params["layer"],paramsTrail);
        var p = effectsObj.playStarToasterEffect(params["layer"], paramsTrail);
        if(p != undefined && p != null) {
            p.setSpeed(p.getSpeed() * 0.7);
        }
    };

    this.animateTimer = function (sender, params) {
        var node = params["node"];
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        var s = utilObj.getScale(node);
        var timeFactor = 3;
        var scale1 = animationObj.getScaleTo(0.1 * timeFactor, s * 1.2);
        var scale2 = animationObj.getScaleTo(0.1 * timeFactor, 0);
        var actions = [scale1, scale2];
        var seqAction = animationObj.getSequence(actions);
        params["node"].runAction(seqAction);
    };

    this.fadeLock = function (sender, params) {
        var node = params["node"];
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        node.runAction(animationObj.getFadeTo(0.8, 0));
    };

    this.animateGameIconFadeness = function (sender, params) {
        var node = params["node"];
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        params["node"].runAction(animationObj.getFadeTo(0.001, constantsObj.OPACITY_100));
    };

    this.animateInGameIconSize = function (sender, params) {
        var node = params["node"];
        if (!utilObj.isNodeValid(node)) {
            return;
        }
        var s = utilObj.getScale(node);
        var timeFactor = 3;
        var scale1 = animationObj.getScaleTo(0.1 * timeFactor, s * 8.9);
        var scale2 = animationObj.getScaleTo(0.1 * timeFactor, s * 7.2);
        var actions = [scale1, scale2];
        var seqAction = animationObj.getSequence(actions);
        params["node"].runAction(seqAction);
    };

    this.animateCrossGameIconSize = function (sender, params) {
        var node = params["node"];
        var s = utilObj.getScale(node);
        var timeFactor = 3;
        var scale0 = animationObj.getScaleTo(0 * timeFactor, s * 0.2);
        var scale1 = animationObj.getScaleTo(0.1 * timeFactor, s * 1.2);
        var scale2 = animationObj.getScaleTo(0.1 * timeFactor, s);
        var actions = [scale0, scale1, scale2];
        var seqAction = animationObj.getSequence(actions);
        params["node"].runAction(seqAction);
    };

    this.animateQuestParticles = function (sender, params) {
        if (params == undefined || params["node"] == undefined) {
            return;
        }
        params["node"].runAction(animationObj.getFadeTo(0.8, constantsObj.OPACITY_100));
        utilObj.delayedCallback(questCenterLayer, questCenterLayer.resetCoinAnimRunning, 0.8, null, false);
    };

    this.spriteTypeForToasterIcon = function (isQuestToaster, isInQuestSheet, isInQuestSheet, gameIcon) {
        var iconSpriteType;
        if (isQuestToaster) {
            if (isInQuestSheet == 0) {
                if (gameIcon == questConfigObj.getConfigData("icon_game")) {
                    iconSpriteType = questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_SPRITE_MISC);
                } else {
                    iconSpriteType = xpromoConstantsObj.SPRITE_QUESTS;
                }
            } else {
                iconSpriteType = xpromoConstantsObj.SPRITE_QUESTS;
            }
        } else {
            iconSpriteType = questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_SPRITE_MISC);
        }
        return iconSpriteType;
    };

    this.w2eCoinGrant = function (xInc, yInc, cashToGrant, layerForAnimation) {
        for (var k = 0; k < 5; k++) {
            utilObj.setScale(layerForAnimation.centerCoinGrants[k], constantsObj.SCALE_SPRITE_1);
            utilObj.setPosition(layerForAnimation.centerCoinGrants[k], centerXPos + xInc, centerYPos + yInc);
            if (utilObj.isNodeValid(layerForAnimation.centerCoinGrants[k])) {
                layerForAnimation.centerCoinGrants[k].setGlobalZOrder(constantsObj.UI_Z_ORDER + 1);
            }
        }
        animationObj.animateCoinGrant(layerForAnimation.centerCoinGrants, layerForAnimation.headerCoins, cashToGrant, layerForAnimation.coinsLbl);
    };

    this.showDailyQuestCompleteToaster = function (sender) {
        if ((questsObj.getQuestToBeAnimated().length < 1 && xPromoGameSpecificObj.getMinimapRankToBeAnimated().length <= 0) || !xPromoGameSpecificObj.isQuestCenterUnlocked() || !xPromoGameSpecificObj.shouldShowQuestToaster()) {
            return;
        }
        if (xPromoGameSpecificObj.getCoinGrantAnimRunning() == 0 && xPromoGameSpecificObj.isBurstHintAnimRunning() == false) {
            utilObj.delayedCallback(sender, xpromoAnimationObj.showDailyQuestCompleteToasterAfterDelay, 0.2, null, false);
        } else {
            utilObj.delayedCallback(sender, xpromoAnimationObj.showDailyQuestCompleteToasterAfterDelay, 2.5, null, false);
        }
    };

    this.showDailyQuestCompleteToasterAfterDelay = function (sender) {
        questsObj.updateQuestStatusCounts();
        questsObj.dailyQuestsCompleted();
        if (sender == undefined) {
            sender = gameLayer;
        }

        if (lastToasterAnimationTimestamp > xpromoConstantsObj.TOASTER_ANIMATION_OVER_TIME && lastToasterAnimationTimestamp > xpromoAnimationObj.getTimeForToasterAnimComplete()) {
            xPromoGameSpecificObj.resetCommonToasterAnimRunning();
        }

        var spriteArr = [];
        var labelArr = [];
        var isRequest = 0;
        var isNotifier = 0;
        if (sender.commonToasterAnimRunning == 1 ||
            (curScreen != constantsObj.SCREEN_GAME &&
                (!questConfigObj.isLinearProgressionAvailable() || curScreen != constantsObj.SCREEN_LINEAR_PROGRESSION) &&
                (!xPromoGameSpecificObj.isDigraphAvailable() || (curScreen != constantsObj.SCREEN_DIGRAPH_GAME && curScreen != constantsObj.SCREEN_DIGRAPH_LINEAR_PROGRESSION)) &&
                (!xPromoGameSpecificObj.isDailyPuzzleAvailable() || curScreen != constantsObj.SCREEN_SPELLING_BEE)) ||
            gameLayer.ftueShownNum == ftueObj.FTUE_PUZ_COMPLETE || gameLayer.ftueShownNum == ftueObj.FTUE_QUEST || gameLayer.ftueShown) {
            if (curLayer == gameLayer || curLayer == popupLayer || (xPromoGameSpecificObj.isDigraphAvailable() && curLayer == digraphGameLayer) || (xPromoGameSpecificObj.isDailyPuzzleAvailable() && curLayer == dailySpellingBeeLayer)) {
                xpromoAnimationObj.showDailyQuestCompleteToaster(sender);
            }
            return;
        }

        if (questsObj.getQuestToBeAnimated().length == 0 && xPromoGameSpecificObj.getMinimapRankToBeAnimated().length == 0) {
            sender.commonToasterAnimRunning = 0;
            return;
        }

        if (xPromoGameSpecificObj.getCoinGrantAnimRunning() == 1 || xPromoGameSpecificObj.isBurstHintAnimRunning() == true) {
            xpromoAnimationObj.showDailyQuestCompleteToaster(sender);
            return;
        }

        var curRequest;
        if (requestsObj.getCurrentActiveRequest().length > 0) {
            curRequest = requestsObj.getCurrentActiveRequest()[0];
            if (curRequest.id == questsObj.getQuestToBeAnimated()[0]) {
                isRequest = 1;
            }
        }

        if (questsObj.getQuestToBeAnimated()[0] == xpromoConstantsObj.NOTIFIER) {
            isNotifier = 1;
        }
        var curQuests = questsObj.getCurQuests();
        if (questsObj.getQuestToBeAnimated().length > 0) {
            isQuestToaster = true;
        } else if (xPromoGameSpecificObj.getMinimapRankToBeAnimated().length > 0) {
            isQuestToaster = false;
        }
        var questId = questsObj.getQuestToBeAnimated()[0];
        //we will store the quest data or cgdq notifier data in 'curQuestMap' whichever is to be shown
        var curQuestMap = null;
        if (isNotifier == 1) {
            curQuestMap = crossGameDailyQuestsObj.getCurrentActiveNotif();
        } else if (isRequest == 1) {
            curQuestMap = requestsObj.getCurrentActiveRequest()[0];
        } else {
            if(pspnFlutterObj.isFlutterEnabled()) {
                curQuestMap = pspnFlutterObj.getQuestCompletedConfig(questId);
            } else {
                curQuestMap = curQuests[questId];
            }
        }
        var rankId = null;
        if (curQuestMap == undefined) {
            questsObj.getQuestToBeAnimated().shift();
            xpromoAnimationObj.showDailyQuestCompleteToaster(sender);
            return;
        }
        var questType = curQuestMap.qt;
        var gameHostedIn = curQuestMap.gh;
        if (isQuestToaster && !(questType.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0 && gameHostedIn == constantsObj.GAME_ID)) {
            questId = questsObj.getQuestToBeAnimated()[0];
            if (isNotifier == 0 && isRequest == 0 && questsObj.shouldToasterBeShown(questId)) {
                questsObj.getQuestToBeAnimated().shift();
                xpromoAnimationObj.showDailyQuestCompleteToaster(sender);
                return;
            }
            //so that cgdq unlock notifier does not come after lock animation has been seen by user
            else if (isNotifier == 1 && isRequest == 0 && crossGameDailyQuestsObj.getLockAnimationDone()) { /*questsObj.shouldToasterBeShown(questId)*/
                questsObj.getQuestToBeAnimated().shift();
                xpromoAnimationObj.showDailyQuestCompleteToaster(sender);
                return;
            }
        } else if (!(questType.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0 && gameHostedIn == constantsObj.GAME_ID)) {
            rankId = xPromoGameSpecificObj.getMinimapRankToBeAnimated()[0];
            if (xPromoGameSpecificObj.shouldToasterBeShownForMinimap(rankId)) {
                xPromoGameSpecificObj.getMinimapRankToBeAnimated().shift();
                xpromoAnimationObj.showDailyQuestCompleteToaster(sender);
                return;
            }
        }
        sender.commonToasterAnimRunning = 1;
        lastToasterAnimationTimestamp = 0;
        var params = null;
        if (isQuestToaster) {
            if (isRequest == 0 && isNotifier == 0) {
                var screenName = utilObj.getScreenName(sender.screen);
                if (dailyQuestsObj.isDailyQuestOrStreakQuest(questType)) {
                    trackObj.trackCounter(constantsObj.TRACK_DIALOG, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(),
                        xpromoConstantsObj.TRACK_DAILY_QUESTS_COMPLETE_TOASTER, questsObj.getDailyQuestTrackingStr(questId), questId + "", screenName, "", "");
                }
            }
            params = {
                "spriteArr": spriteArr,
                "labelArr": labelArr,
                "curQuestMap": curQuestMap,
                "questId": questId,
                "isRequest": isRequest,
                "isNotifier": isNotifier,
            };
        } else {
            params = {
                "spriteArr": spriteArr,
                "labelArr": labelArr,
                "rankId": rankId
            };
        }
        utilObj.delayedCallback(sender, xpromoAnimationObj.delayDailyQuestChanges, 0.2, params, false);

        utilObj.delayedCallback(sender, xpromoAnimationObj.resetQuestAnim, xpromoAnimationObj.getTimeForToasterAnimComplete(), null, false);

    };

    this.delayDailyQuestChanges = function (sender, params) {
        xpromoAnimationObj.setScreenTransitionHappened(0);
        var spriteArr = params.spriteArr;
        var labelArr = params.labelArr;
        var curQuestMap = params.curQuestMap;
        var questId = params.questId;
        var isNotifier = params.isNotifier;
        var inGameProgress = questsObj.getInGameProgressMap();
        var halfProgress = 0;
        var localXPos = 150;
        var localYPos = 190;
        var questType = null;
        var currentDailyQuestMap = questsObj.getCurrentDailyQuestMap();
        var questDesc = null;
        var gameHostedIn = null;
        var gameIcon = null;
        var iconScaling = constantsObj.SCALE_ONE;
        var rankId = null;
        var toasterHeight = 290;

        var isRequest = params.isRequest;
        //we will store the quest data or cgdq notifier data in 'curQuestMap' whichever is to be shown
        // var curQuestMap;
        var expXpromoDq = crossGameDailyQuestsObj.getCurrentCGDQExp();
        // if (isNotifier != undefined && isNotifier == 1) {
        //     curQuestMap = crossGameDailyQuestsObj.getCurrentActiveNotif();
        // } else if (isRequest == 0) {
        //     curQuestMap = curQuests[questId];
        // } else if (isRequest == 1) {
        //     curQuestMap = requestsObj.getCurrentActiveRequest()[0];
        // }
        var gameShownIn = null;
        if (isNotifier == 0 && isRequest == 0) {
            gameShownIn = curQuestMap["gs"];
        }
        questType = curQuestMap.qt;
        gameHostedIn = curQuestMap.gh;
        if (questType.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0 && gameHostedIn == constantsObj.GAME_ID && xpromoConstantsObj.PSGames[gameShownIn] != undefined) {
            questDesc = stringsObj.loop_back.replace("%game%", xpromoConstantsObj.PSGames[gameShownIn][2]);
            gameHostedIn = gameShownIn[0];
        }
        if (curQuestMap == undefined) {
            return;
        }
        if (isQuestToaster) {
            // if (isRequest == 0 && (inGameProgress[questId] != undefined && inGameProgress[questId].status == xpromoConstantsObj.QUEST_STARTED)) {
            //     halfProgress = 1;
            // }

            if (isRequest == 0 && (curQuestMap == undefined || curQuestMap == null)) {
                questsObj.getQuestToBeAnimated().shift();
                xpromoAnimationObj.showDailyQuestCompleteToaster(sender);
                return;
            }
            questDesc = curQuestMap.d;
            gameHostedIn = curQuestMap.gh;
            gameIcon = questConfigObj.getConfigData("icon_game");
            iconScaling = constantsObj.SCALE_TWO_POINT_FIVE * constantsObj.SPRITE_SCALING_FACTOR * (80 / 206);
        } else {
            rankId = params.rankId;
            questDesc = stringsObj.rank_reward_unlocked;
            gameIcon = constantsObj.badge;
            iconScaling = 1.0 * constantsObj.SPRITE_SCALING_FACTOR;
        }

        if (questType.indexOf(xpromoConstantsObj.QUEST_TYPE_CROSS_GAME_DQ) == 0 && gameHostedIn == constantsObj.GAME_ID && xpromoConstantsObj.PSGames[gameShownIn] != undefined) {
            questDesc = stringsObj.loop_back.replace("%game%", xpromoConstantsObj.PSGames[gameShownIn][2]);
            gameHostedIn = gameShownIn[0];
        }

        var isInQuestSheet = 0;
        if(!pspnFlutterObj.isFlutterEnabled()) {
            if (isQuestToaster) {
                var qb = currentDailyQuestMap[curQuestMap.b];
                if (dailyQuestsObj.isDailyQuestOrStreakQuest(curQuestMap.qt)) {
                    if (inGameProgress[questId] == undefined) {
                        questsObj.getQuestToBeAnimated().shift();
                        xpromoAnimationObj.showDailyQuestCompleteToaster(sender);
                        return;
                    }
                    if (inGameProgress[questId].status == xpromoConstantsObj.QUEST_STARTED) {
                        questDesc = questDesc.replace("%value%", qb.reqProgress);
                        questDesc = questsObj.makeStringAppropriate(questDesc, qb.reqProgress, questType);
                    } else {
                        questDesc = questDesc.replace("%value%", inGameProgress[questId].params[0]);
                        questDesc = questsObj.makeStringAppropriate(questDesc, inGameProgress[questId].params[0], questType);
                    }
                }
            }
        }

        var noOfLines = 0;
        var textLine1 = "";
        var textLine2 = "";
        if (isNotifier == 1) {
            questDesc = utilObj.getSplitStringsArr(questDesc, 42);
        } else {
            questDesc = utilObj.getSplitStringsArr(questDesc, 27);
        }

        noOfLines = questDesc.length;

        if (noOfLines == 1) {
            textLine1 = questDesc[0];
        } else {
            textLine1 = questDesc[0];
            textLine2 = questDesc[1];
        }

        questDesc = textLine1 + "";
        if (noOfLines != 1) {
            questDesc += "\n" + textLine2;
        }

        if (isQuestToaster) {
            if (xpromoConstantsObj.QUEST_ICON_GAME_MAP[constantsObj.GAME_ID] != undefined && xpromoConstantsObj.QUEST_ICON_GAME_MAP[constantsObj.GAME_ID][curQuestMap.qt] != undefined) {
                gameIcon = xpromoConstantsObj.QUEST_ICON_GAME_MAP[constantsObj.GAME_ID][curQuestMap.qt];
                iconScaling = constantsObj.SCALE_ONE;
                isInQuestSheet = 1;
            } else if (xpromoConstantsObj.QUEST_ICON_MAP[curQuestMap.qt] != undefined) {
                gameIcon = xpromoConstantsObj.QUEST_ICON_MAP[curQuestMap.qt];
                iconScaling = constantsObj.SCALE_ONE;
                isInQuestSheet = 1;
            } else {
                gameIcon = "icon_" + gameHostedIn + ".png";
                iconScaling = constantsObj.SCALE_ONE;
                if (isRequest == 1) {
                    gameIcon = wordWarsRequestLayer.getBotImage(curQuestMap.senderRefId);
                    iconScaling = constantsObj.SCALE_TWO_POINT_FIVE * constantsObj.SPRITE_SCALING_FACTOR * (15 / 206);
                    if (!utilObj.fileExists(gameIcon)) {
                        gameIcon = "icon_" + gameHostedIn + ".png";
                        iconScaling = constantsObj.SCALE_ONE;
                    }
                }
                if (!utilObj.fileExists(gameIcon)) {
                    gameIcon = constantsObj.badge;
                    iconScaling = constantsObj.SCALE_TWO_POINT_FIVE * constantsObj.SPRITE_SCALING_FACTOR * (80 / 206);
                }
                if (curQuestMap.isSocialQuest == 1) {
                    var friend = socialQuestObj.getCurrentFriend()["friend"];
                    var gameIconName = friend.fbId + ".jpg";
                    if (!utilObj.isWeb() && gameIconName.indexOf("friendly_") == -1 && !utilObj.fileExists(gameIconName)) {
                        xPromoGameSpecificObj.downloadFileV1(friendsObj.getFbPicUrl(friend.fbId), gameIconName);
                    } else {
                        gameIcon = socialQuestObj.getAbsFilePathForFbPic(friend.fbId, gameIconName);
                        isInQuestSheet = 1;
                    }
                    iconScaling = constantsObj.SCALE_ONE;
                }
            }
        }
        var iconSpriteType = xpromoAnimationObj.spriteTypeForToasterIcon(isQuestToaster, isInQuestSheet, isInQuestSheet, gameIcon);
        if (isQuestToaster) {
            if (isInQuestSheet == 0) {
                if (gameIcon != undefined && gameIcon != questConfigObj.getConfigData("icon_game")) {
                    gameIcon = xpromoUtilObj.getAbsFilePath(gameIcon);
                }
            }
        }
        if (isNotifier == 1) {
            var variant = xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_DAILY_QUEST_SWITCH_RUNTIMES);
            if (variant == 0 && expXpromoDq != constantsObj.EXP_VAR_3) {
                gameIcon = xpromoConstantsObj.dq_calendar;
                iconScaling = constantsObj.SCALE_SPRITE_23;
            } else {
                gameIcon = xpromoConstantsObj.dq_clock;
                iconScaling = constantsObj.SCALE_SPRITE_9;
                utilObj.getSprite(xpromoConstantsObj.dq_clock_needle, localXPos, toasterHeight / 2, 0.5, 0.5, iconScaling, spriteArr, sender.dailyQuestToaster, 1, iconSpriteType);
            }
        }
        utilObj.getSprite(gameIcon, localXPos, toasterHeight / 2, 0.5, 0.5, iconScaling, spriteArr, sender.dailyQuestToaster, 1, iconSpriteType);
        halfProgress = 0; // halfProgress toaster is turned off
        if (halfProgress == 1 && dailyQuestsObj.isDailyQuestOrStreakQuest(curQuestMap.qt)) {

            var curBucketMap = currentDailyQuestMap[curQuestMap.b];
            var toasterHeaderTxt = "", toasterHeaderYPos;
            var toasterDescFont, toasterDescYPos;

            var progressBarLength = canvasWidth + widthErr - 750;
            var questProgressPercent = curBucketMap.params[0] / curBucketMap.reqProgress;
            var fullProgressBarLength = questProgressPercent * progressBarLength;
            var dailyQuestEmptyProgressBar, dailyQuestFullProgressBar, progBarYPos;

            if (noOfLines == 1) {
                toasterHeaderTxt = stringsObj.daily_quest;
                toasterHeaderYPos = localYPos + 10;
                toasterDescFont = constantsObj.FONT_SFCOMPACT_REGULAR_60;
                toasterDescYPos = localYPos - 55;
                progBarYPos = localYPos - 120;
            } else {
                toasterHeaderTxt = stringsObj.daily_quest;
                toasterHeaderYPos = localYPos + 40;
                toasterDescFont = constantsObj.FONT_SFCOMPACT_REGULAR_50;
                toasterDescYPos = localYPos - 45;
                progBarYPos = localYPos - 132;
            }
            dailyQuestEmptyProgressBar = utilObj.getScale9Sprite(constantsObj.full_bar_2, localXPos + 150, progBarYPos, 0, 0.5, progressBarLength, 30,
                spriteArr, sender.dailyQuestToaster, 1, questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_SPRITE_MISC));
            dailyQuestFullProgressBar = utilObj.getScale9Sprite(constantsObj.progress_bar_2, localXPos + 150, progBarYPos, 0, 0.5, fullProgressBarLength, 30,
                spriteArr, sender.dailyQuestToaster, 2, questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_SPRITE_MISC));
            utilObj.setColor(dailyQuestEmptyProgressBar, constantsObj.COLOR_EMPTY_PROGRESS_BAR);
            utilObj.setColor(dailyQuestFullProgressBar, constantsObj.COLOR_FULL_PROGRESS_BAR_2);

            utilObj.getBMFontLabel(curBucketMap.params[0] + "/" + curBucketMap.reqProgress, constantsObj.FONT_SFCOMPACT_REGULAR_60,
                constantsObj.COLOR_BLACK, constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 150 + progressBarLength + 30,
                localYPos - 120, 0, 0.5, labelArr, sender.dailyQuestToaster, 1);

            utilObj.getBMFontLabel(toasterHeaderTxt, constantsObj.FONT_SFCOMPACT_MEDIUM_60, constantsObj.COLOR_DAILY_QUESTS_TXT, constantsObj.LABEL_AUTO_WIDTH,
                cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 150, toasterHeaderYPos, 0, 0.5, labelArr, sender.dailyQuestToaster, 1);

            utilObj.getBMFontLabel(questDesc, toasterDescFont, constantsObj.COLOR_BLACK, constantsObj.LABEL_AUTO_WIDTH,
                cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 150, toasterDescYPos, 0, 0.5, labelArr, sender.dailyQuestToaster, 1);
        } else {

            var toasterHeader, toasterHeaderTxt, toasterHeaderYPos;
            var toasterDescFont;
            if (isQuestToaster) {
                if (curQuestMap.qt.indexOf(xpromoConstantsObj.QUEST_TYPE_NOTIFIER) == 0) {
                    if (expXpromoDq == constantsObj.EXP_VAR_1 || expXpromoDq == constantsObj.EXP_VAR_2) {
                        toasterHeaderTxt = xpromoStringsObj.daily_quest_cg_unlocked_1;
                    } else if (expXpromoDq == constantsObj.EXP_VAR_3) {
                        toasterHeaderTxt = xpromoStringsObj.daily_quest_cg_unlocked_2;
                    }
                } else if (dailyQuestsObj.isDailyQuestOrStreakQuest(curQuestMap.qt)) {
                    toasterHeaderTxt = stringsObj.daily_quest_complete;
                } else {
                    toasterHeaderTxt = stringsObj.quest_complete;
                }
            } else {
                var rankArticleMap = xPromoGameSpecificObj.getRankArticleMap();
                var rankStr = stringsObj.you_are_now + " " + rankArticleMap[rankId] + " " + gameObj.getRankLabelMap()[rankId] + "!";
                toasterHeaderTxt = rankStr;
                trackObj.trackCounter(constantsObj.TRACK_DIALOG, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(),
                    constantsObj.TRACK_MINIMAP_TOASTER, constantsObj.TRACK_VIEW, gameObj.getRankLabelMap()[rankId] + "", utilObj.getScreenName(sender.screen) + "", "", "");
            }
            toasterHeader = utilObj.getBMFontLabel(toasterHeaderTxt, constantsObj.FONT_SFCOMPACT_MEDIUM_60, constantsObj.COLOR_DAILY_QUESTS_TXT, constantsObj.LABEL_AUTO_WIDTH,
                cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 150, localYPos, 0, 0.5, labelArr, sender.dailyQuestToaster, 1);

            var tickX = localXPos + toasterHeader.getContentSize().width + 200;
            var tickY;

            if (noOfLines == 1) {
                toasterHeaderYPos = localYPos;
                tickY = localYPos;
                toasterDescFont = constantsObj.FONT_SFCOMPACT_REGULAR_60;
            } else {
                toasterHeaderYPos = localYPos + 20;
                tickY = localYPos + 20;
                toasterDescFont = constantsObj.FONT_SFCOMPACT_REGULAR_50;
            }
            utilObj.setPosition(toasterHeader, localXPos + 150, toasterHeaderYPos);

            if (isQuestToaster) {
                utilObj.getSprite(constantsObj.tick, tickX, tickY, 0.5, 0.5, 0.6, spriteArr, sender.dailyQuestToaster, 1.2 * constantsObj.SPRITE_SCALING_FACTOR, questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_SPRITE_MISC));
            }
            utilObj.getBMFontLabel(questDesc, toasterDescFont, constantsObj.COLOR_BLACK, constantsObj.LABEL_AUTO_WIDTH,
                cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), localXPos + 150, localYPos - 90, 0, 0.5, labelArr, sender.dailyQuestToaster, 1);

            var toasterWidth;
            var localToasterWidth;
            if (utilObj.isNodeValid(sender.dailyQuestToaster)) {
                localToasterWidth = sender.dailyQuestToaster.getContentSize().width;

            }
            if (localToasterWidth != undefined && localToasterWidth != null) {
                toasterWidth = localToasterWidth;
            }
            var rewardX = toasterWidth - 150;
            var rewardY = localYPos - 90;

            if (isQuestToaster) {
                var rewardValue = questsObj.getRewardValueForQuest(curQuestMap);
                sender.dailyQuestRewardLbl = utilObj.getBMFontLabel(rewardValue, constantsObj.FONT_SFCOMPACT_REGULAR_70, constantsObj.COLOR_BLACK,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_RIGHT, cc.p(0, 0), rewardX - 70, rewardY, 1.0, 0.5, labelArr, sender.dailyQuestToaster, 1);
                if (isNotifier != 1) {
                    sender.dailyQuestCoin = utilObj.getSprite(questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_ICON_COINS), rewardX, rewardY, 0.5, 0.5, 4.3, spriteArr, sender.dailyQuestToaster, 2,
                        questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_SPRITE_MISC));
                    utilObj.setScale(sender.dailyQuestCoin, 1.0);
                }
            } else {
                utilObj.getSprite(constantsObj.gift_new, rewardX + 30, toasterHeight / 2, 0.5, 0.5, 1.2 * constantsObj.SPRITE_SCALING_FACTOR, spriteArr, sender.dailyQuestToaster, 2, questConfigObj.getConfigData(xpromoConstantsObj.XPROMO_CONFIG_SPRITE_MISC));
            }
        }

        if(utilObj.isNodeValid(sender.dailyQuestToaster) && (questsObj.getQuestFtue() || questsObj.getClaimQuestFtue() == false) && xpromoAnimationObj.getIsMiniPopClickableEnabled()) {
            var tWidth = sender.dailyQuestToaster.getContentSize().width;
            var trans_btn = utilObj.getButton(tWidth, toasterHeight, 0.5, 0.5,
                toasterWidth / 2, toasterHeight / 2, constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: 'xpromoAnimationObj',
                    fn: 'openQuestCenter',
                    screen: sender.screen,
                    params: {screen: sender.screen},
                    track: {
                        k: xpromoConstantsObj.TRACK_XPROMO,
                        p: gameObj.getTrackingBucketId(),
                        c: gameObj.getTrackingPuzId(),
                        o: constantsObj.TRACK_QC_TOASTER,
                        f: constantsObj.TRACK_CLICK,
                        g: "",
                        s: gameObj.getTrackingPuzzleInfo(),
                        co: 1,
                        oppId: ""
                    },
                    child: [],
                    feedBackType: constantsObj.NORMALBTN_FEEDBACK
                }, false, ccui.Widget.PLIST_TEXTURE, constantsObj.SCALE_ONE);
            utilObj.addChild(sender.dailyQuestToaster, trans_btn, 2);
        }

        xpromoAnimationObj.showDailyQuestAnimation(sender);

        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);
        if(pspnFlutterObj.isFlutterEnabled()){
            pspnFlutterObj.deleteQuestCompletedId(questId);
        }
    };

    this.resetQuestAnim = function (sender) {
        sender.commonToasterAnimRunning = 0;
        utilObj.removeAllChildren(sender.dailyQuestToaster);
        // utilObj.setVisible(sender.dailyQuestToaster, false);
        isToasterAnimRunning = false;
        if (curScreen == constantsObj.SCREEN_GAME ||
            (questConfigObj.isLinearProgressionAvailable() && curScreen == constantsObj.SCREEN_LINEAR_PROGRESSION) ||
            (xPromoGameSpecificObj.isDigraphAvailable() && (curScreen == constantsObj.SCREEN_DIGRAPH_GAME || curScreen == constantsObj.SCREEN_DIGRAPH_LINEAR_PROGRESSION)) ||
            (xPromoGameSpecificObj.isDailyPuzzleAvailable() && curScreen == constantsObj.SCREEN_SPELLING_BEE)) {
            xpromoAnimationObj.showDailyQuestCompleteToaster(sender);
        }
    };

    this.showDailyQuestAnimation = function (sender) {
        if (sender.dailyQuestToaster == undefined || sender.dailyQuestToaster == null || xpromoAnimationObj.getScreenTransitionHappened()) {
            return;
        }
        isToasterAnimRunning = true;
        if (xPromoGameSpecificObj.shouldPlaySoundForToaster()) {
            utilObj.playSound(constantsObj.quest_complete_sound, false);
        }

        if(xPromoGameSpecificObj.useToasterAnimationV2()) {
            utilObj.delayedCallback(sender, xpromoAnimationObj.slideToasterAnimation, 0.185, null, true);
        } else {
            animationObj.slideElement({
                node: sender.dailyQuestToaster,
                x: centerXPos,
                y: constantsObj.DESIGN_HEIGHT - 350,
                time: 0.17
            });

            utilObj.delayedCallback(sender, xpromoAnimationObj.slightUpAnimation, 0.185, null, true);
        }


        if (curScreen == constantsObj.SCREEN_GAME ||
            (questConfigObj.isLinearProgressionAvailable() && curScreen == constantsObj.SCREEN_LINEAR_PROGRESSION) ||
            (xPromoGameSpecificObj.isDigraphAvailable() && (curScreen == constantsObj.SCREEN_DIGRAPH_GAME || curScreen == constantsObj.SCREEN_DIGRAPH_LINEAR_PROGRESSION)) ||
            (xPromoGameSpecificObj.isDailyPuzzleAvailable() && curScreen == constantsObj.SCREEN_SPELLING_BEE)) {
            if (isQuestToaster) {
                questsObj.getQuestToBeAnimated().shift();
            } else {
                xPromoGameSpecificObj.getMinimapRankToBeAnimated().shift();
            }
        }

        if(!xPromoGameSpecificObj.useToasterAnimationV2()) {
            utilObj.delayedCallback(sender, xpromoAnimationObj.slightDownAnimation, xpromoAnimationObj.getTimeForToasterAnimation(), null, false);
        }
    };

    this.slightUpAnimation = function (sender) {
        if (xpromoAnimationObj.getScreenTransitionHappened()) {
            return;
        }
        animationObj.slideElement({
            node: sender.dailyQuestToaster,
            x: centerXPos,
            y: constantsObj.DESIGN_HEIGHT - 320,
            time: 0.16
        });
    };

    this.slightDownAnimation = function (sender) {
        if (!utilObj.isNodeValid(sender.dailyQuestToaster) || sender.dailyQuestToaster == undefined || sender.dailyQuestToaster == null || xpromoAnimationObj.getScreenTransitionHappened()) {
            return;
        }
        animationObj.slideElement({
            node: sender.dailyQuestToaster,
            x: centerXPos,
            y: constantsObj.DESIGN_HEIGHT - 350,
            time: 0.14
        });

        utilObj.delayedCallback(sender, xpromoAnimationObj.closeDailyQuestAnimation, 0.15, null, false);
    };

    this.slideToasterAnimation = function (sender) {
        if (xpromoAnimationObj.getScreenTransitionHappened()) {
            return;
        }

        if (!utilObj.isNodeValid(sender.dailyQuestToaster) || sender.dailyQuestToaster == undefined || sender.dailyQuestToaster == null || xpromoAnimationObj.getScreenTransitionHappened()) {
            return;
        }

        animationObj.slideToasterAnimation(sender.dailyQuestToaster);
    };

    this.closeDailyQuestAnimation = function (sender) {
        if (sender.dailyQuestToaster == undefined || sender.dailyQuestToaster == null || xpromoAnimationObj.getScreenTransitionHappened()) {
            return;
        }
        animationObj.slideElement({
            node: sender.dailyQuestToaster,
            x: centerXPos,
            y: constantsObj.DESIGN_HEIGHT + constantsObj.BEZEL_SAFE_AREA + 10,
            time: 0.12
        });
    };

    this.getTempX = function () {
        var moveX = 50;
        var tempX = (((Math.random() - 0.5) * 2) * moveX) % moveX;
        return tempX;
    };

    this.getTempY = function (yPos, lowerLimitY, upperLimitY) {
        var moveY = 150; //300
        var tempY = (((Math.random() - 0.5) * 2) * moveY) % moveY;
        if (yPos + tempY < lowerLimitY || yPos + tempY > upperLimitY) {
            tempY = tempY * (-1);
        }
        return tempY;
    };

    this.moveNodeUpAndDown = function (node) {
        var scale0 = animationObj.getMoveBy(0.6, 0, 20);
        var scale1 = animationObj.getMoveBy(0.6, 0, -20);
        var actions = [scale0, scale1];
        var seqAction = animationObj.getSequence(actions);
        var seqRepeat = new cc.RepeatForever(seqAction);
        animationObj.runAction(node, seqRepeat);
    };

    this.bubbleZoomInZoomOutAnimation = function (node) {
        var s = utilObj.getScale(node);
        var timeFactor = 0.4;
        var scale0 = animationObj.getScaleTo(timeFactor, s * 0.95);
        var scale1 = animationObj.getScaleTo(timeFactor * 1, s * 1.15);
        var scale2 = animationObj.getScaleTo(timeFactor, s);
        var actions = [scale0, scale1, scale2];
        var seqAction = animationObj.getSequence(actions);
        var seqRepeat = new cc.RepeatForever(seqAction);
        animationObj.runAction(node, seqRepeat);
    };

    this.openQuestCenter = function(sender, params) {
        if(params.screen != undefined ) {
            var isValidScreen = true;
            if(params.screen == constantsObj.SCREEN_HOME) {
                if(!pspnFlutterObj.isFlutterEnabled()){
                    homeLayer.hide();
                }
            } else if (params.screen == constantsObj.SCREEN_GAME && !softLaunchObj.getIsPuzzleCompleted()) {
                if(!pspnFlutterObj.isFlutterEnabled()){
                    gameLayer.hide();
                }
            } else if (questConfigObj.isLinearProgressionAvailable() && params.screen == constantsObj.SCREEN_LINEAR_PROGRESSION) {
                if(!pspnFlutterObj.isFlutterEnabled()){
                    linearProgressionLayer.hide();
                }
            } else if (xPromoGameSpecificObj.isDigraphAvailable() && params.screen == constantsObj.SCREEN_DIGRAPH_LINEAR_PROGRESSION) {
                digraphLLPLayer.hide();
            } else if (xPromoGameSpecificObj.isDigraphAvailable() && params.screen == constantsObj.SCREEN_DIGRAPH_GAME) {
                digraphGameLayer.hide();
            } else if (xPromoGameSpecificObj.isDailyPuzzleAvailable() && params.screen == constantsObj.SCREEN_SPELLING_BEE) {
                dailySpellingBeeLayer.hide();
            } else {
                isValidScreen = false;
            }

            if(isValidScreen) {
                trackObj.trackCounter(xpromoConstantsObj.TRACK_XPROMO, gameObj.getTrackingBucketId(), gameObj.getTrackingPuzId(), xpromoConstantsObj.TRACK_QUEST_CENTER, constantsObj.TRACK_CLICK, constantsObj.TRACK_QC_TOASTER, "", "", "");
                questCenterLayer.show();
            }
        }
    };

    this.getIsMiniPopClickableEnabled = function() {
        return epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_QUEST_MINIPOP) != constantsObj.EXP_VAR_CONTROL;
    };

    this.getTimeForToasterAnimation = function() {
        var result = 2.5;
        if(xpromoAnimationObj.getIsMiniPopClickableEnabled()) {
            var time = xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_QUEST_MINIPOP_TIME);
            if(!isNaN(time)) {
                result = time;
            }
        }
        return parseFloat(result);
    };

    this.getTimeForToasterAnimComplete = function() {
        return parseFloat(xpromoAnimationObj.getTimeForToasterAnimation() + 0.8);
    };
};