QuestConfigObj = function () {
    var questConfigLoaded = false;
    var questConfigData = null;
    var dailyQuestConfigLoaded = false;
    var dailyQuestConfigData = null;
    var gameId = 0;

    this.init = function () {
        gameId = constantsObj.GAME_ID;
        cc.loader.loadJson(res.quest_config_json, function (error, data) {
            if (error == null && data != null) {
                questConfigData = data;
                questConfigLoaded = true;
            }
            loggerObj.debugLog("staging config data is :", questConfigData);
        });

        cc.loader.loadJson(res.daily_quest_config_json, function (error, data) {
            if (error == null && data != null) {
                dailyQuestConfigData = data;
                dailyQuestConfigLoaded = true;
            }
            loggerObj.debugLog("daily quest config data ", dailyQuestConfigData);
        });
    };

    this.isLinearProgressionAvailable = function () {
        if (questConfigLoaded) {
            var status = questConfigData[gameId]["linearProgressionAvailable"];
            if (status != undefined) {
                return status;
            }
        }
    };
    this.getConfigData = function (val) {
        if (questConfigLoaded) {
            var status = questConfigData[gameId][val];
            if (status != undefined) {
                return status;
            }
        }
        loggerObj.errorLog("object data fetched for val returning null", val, questConfigLoaded);
        return "";
    };

    this.getConfigDataAdjusted = function (val) {
        var c = "";
        if (questConfigLoaded) {
            var status = questConfigData[gameId][val];
            if (status != undefined) {
                switch (val) {
                    case xpromoConstantsObj.XPROMO_CONFIG_BTN_190_TEXTURE_LOCAL:
                    case xpromoConstantsObj.XPROMO_CONFIG_BTN_180_TEXTURE_LOCAL:
                        if (status == 1) {
                            c = ccui.Widget.LOCAL_TEXTURE;
                        } else {
                            c = ccui.Widget.PLIST_TEXTURE;
                        }
                        break;
                    default:
                        loggerObj.debugLog("Default case:");
                        break;
                }
            }
        }
        if (c == "") {
            loggerObj.errorLog("object data fetched for val returning null", val, questConfigLoaded);
        }
        return c;
    };

    this.getDailyQuestConfigData = function (questType, action) {
        var value = "";
        if (dailyQuestConfigLoaded) {
            value = dailyQuestConfigData[questType][action];
            if (value != undefined) {
                return value;
            } else {
                return "";
            }
        }
        return value;
    };

    this.isDailyQuestConfigInJson = function (questType) {
        var value = false;
        if (dailyQuestConfigLoaded) {
            if (dailyQuestConfigData[questType] != undefined) {
                value = true;
            }
        }
        return value;
    };

    this.getDailyQuestsConfigMap = function () {
        var value = "";
        if (dailyQuestConfigLoaded) {
            value = dailyQuestConfigData;
        }
        return value;
    };
};