XPromoConstants = function () {
    this.SPRITE_QUESTS = "quests_sprite";

    // XPROMO EXPERIMENTS
    this.EXP_PSPN_QUEST_ROTATION = "PSPNquestRotation";
    this.EXP_WORDWARS_REQUESTS = "wordwarsRequests";
    this.EXP_REQUESTS_REDIRECTION = "requestsRedirection";
    this.EXP_PSPN_XPROMO_W2E = "pspnXpromoW2e";
    this.EXP_PSPN_XPROMO_W2E_NEW = "pspnXpromoW2eNew";
    this.EXP_PSPN_XPROMO_W2E_OPT = "pspnXpromoW2eOpt";
    this.EXP_PSPN_XPROMO_W2E_GIF = "pspnXpromoW2eGif";
    this.EXP_PSPN_XPROMO_DQ = "PSPNcgdq";
    this.EXP_PSPN_XPROMO_CGDQ_OPT = "PSPNcgdqOpt";
    this.EXP_PSPN_XPROMO_REDIRECT = "pspnXpromoRedirect";
    this.EXP_AD_WALL = "adwall";
    this.EXP_AD_WALL_NEW = "adwall_new";
    this.EXP_REDIRECT_TO_APP_STORE = "redirectToAppStore";
    this.EXP_SHARE_LINKS = "shareLinks";
    this.EXP_QUEST_INVITE = "questInvite";
    this.EXP_PSEUDO_QUEST_INVITE = "PSPNpseudoquestInvite";
    this.EXP_DAILY_QUEST_V2 = "dailyQuestV2";
    this.EXP_PSPN_BUBBLE_POP = "PSPNbubblePop";
    this.EXP_ADWALL_NEW_UI = "AdwallNewUI";
    this.EXP_XPROMO_EXIT_SCREEN = "PSPNExitXpromo";
    this.EXP_XPROMO_ADJ_TRACKER = "PSPNAdjTrackerFix";
    this.EXP_PSPN_QUEST_MINIPOP = "PSPNQuestMinipopClick";
    this.EXP_PSPN_ALL_QUEST_CLICKABLE = "pspnAllQuestsClickable";
    this.EXP_PSPN_REDIRECT_FTUE = "pspnRedirectFtue";
    this.EXP_PSPN_DQ_REPLACEMENT = "pspnDQReplacement";
    this.EXP_XPROMO_QUEST_UNLOCK = "pspnXpromoQuestUnlock";

    this.QUEST_NOT_STARTED = 0;
    this.QUEST_STARTED = 1;
    this.QUEST_COMPLETED = 2;
    this.QUEST_CLAIMED = 3;
    this.QUEST_COMPLETED_BEFORE_START = 4; // This can happen for cross game install quests.
    this.QUEST_FAILED = 5;

    this.APP_SETUP = 1;
    this.APP_RESUME = 2;

    this.EXP_VAR_CONTROL = 0;
    this.EXP_VAR_1 = 1;
    this.EXP_VAR_2 = 2;
    this.EXP_VAR_3 = 3;
    this.EXP_VAR_4 = 4;
    this.EXP_VAR_5 = 5;
    this.EXP_VAR_6 = 6;
    this.EXP_VAR_7 = 7;
    this.EXP_VAR_8 = 8;
    this.EXP_VAR_9 = 9;

    // requests
    this.REQUEST_NOT_STARTED = "0";
    this.REQUEST_STARTED = "1";
    this.REQUEST_COMPLETED = "2";
    this.REQUEST_CLAIMED = "3";
    this.REQUEST_COMPLETED_BEFORE_START = "4";
    this.REQUEST_PLAYED = "5";
    this.REQUEST_FAILED = "6";

    this.QUEST_TYPE_COMPLETE_TUTORIAL = "completeTutorial";
    this.QUEST_TYPE_PUZZLE_COMPLETE = "puzzleComplete";
    this.QUEST_TYPE_LEVEL_COMPLETE = "levelComplete";
    this.QUEST_TYPE_LEVEL_COMPLETE_IN_TIME = "levelCompleteInTime";
    this.QUEST_TYPE_LEVEL_COMPLETE_SPECIFIC = "levelCompleteSpecific";
    this.QUEST_TYPE_VIP_LEVEL_COMPLETE = "vipLevelComplete";
    this.QUEST_TYPE_PLAY_CONSECUTIVE_DAYS = "playConsecutiveDays";
    this.QUEST_TYPE_LEVEL_COMPLETES_CONSECUTIVE_DAYS = "levelConsecutiveDays";
    this.QUEST_TYPE_WATCH_VIDEOS = "watchVideos";
    this.QUEST_TYPE_WATCH_VIDEOS_IN_TIME = "watchVideosInTime";
    this.QUEST_TYPE_SPIN_SPINNER = "spinSpinner";
    this.QUEST_TYPE_USE_HINT = "useHint";
    this.QUEST_TYPE_PURCHASE_COINS = "purchaseCoins";
    this.QUEST_TYPE_PURCHASE_PREMIUM_AVATAR = "purchasePremiumAvatar";
    this.QUEST_TYPE_PURCHASE_NO_ADS = "purchaseNoAds";
    this.QUEST_TYPE_COMPLETE_OFFER = "completeOffer";
    this.QUEST_TYPE_VALID_WORDS = "validWords";
    this.QUEST_TYPE_FB_CONNECT = "fbConnect";
    this.QUEST_TYPE_RATE_US = "rateUs";
    this.QUEST_TYPE_FB_LIKE = "fbLike";
    this.QUEST_TYPE_FOLLOW_TWITTER = "followTwitter";
    this.QUEST_TYPE_INVITE_WHATSAPP = "inviteWhatsapp";
    this.QUEST_TYPE_INVITE_TWITTER = "inviteTwitter";
    this.QUEST_TYPE_INVITE_FB_MESSENGER = "inviteFbMessenger";
    this.QUEST_TYPE_INVITE_INSTAGRAM = "inviteInstagram";
    this.QUEST_TYPE_INVITE_TUMBLR = "inviteTumblr";
    this.QUEST_TYPE_INVITE_GOOGLE_PLUS = "inviteGooglePlus";
    this.QUEST_TYPE_INVITE_MESSAGE = "inviteMessage";
    this.QUEST_TYPE_INVITE_EMAIL = "inviteEmail";
    this.QUEST_TYPE_INVITE_CONTACT_BOOK = "inviteContactBook";
    this.QUEST_TYPE_INVITE_FRIENDS = "inviteFriends";
    this.QUEST_TYPE_INVITE_X_FRIENDS = "inviteXFriends";
    this.QUEST_TYPE_INVITE_IMESSAGE_APP = "inviteImessageApp";
    this.QUEST_TYPE_INVITE_IMESSAGE_APP_PERSISTENT = "inviteImessageAppPersistent";
    this.QUEST_TYPE_CROSS_GAME_ACTION_FB_CONNECT = "crossGameActionFbConnect";
    this.QUEST_TYPE_CROSS_GAME_ACTION_USE_HINT = "crossGameActionUseHint";
    this.QUEST_TYPE_CROSS_GAME_LEVEL_IN_TIME_PUZZLES = "crossGameLevelInTimePuzzles";
    this.QUEST_TYPE_INSTALL_GAME = "installGame";
    this.QUEST_TYPE_CROSS_GAME_LEVEL_COMPLETE = "crossGameLevelComplete";
    this.QUEST_TYPE_CROSS_GAME_LEVEL_COMPLETE_IN_TIME = "crossGameLevelCompleteInTime";
    this.QUEST_TYPE_CROSS_GAME_PLAY_CONSECUTIVE_DAYS = "crossGamePlayConsecutiveDays";
    this.QUEST_TYPE_CROSS_GAME_COMPLETE_WORDS = "crossGameLevelCompleteWords";
    this.QUEST_TYPE_INSTALL_AND_COMPLETE_WORDS = "installAndCompleteWords";
    this.QUEST_TYPE_INSTALL_AND_COMPLETE_CROSSWORD = "installAndCompleteCrossword";
    this.QUEST_TYPE_INSTALL_AND_COMPLETE_PACK = "installAndCompletePack";
    this.QUEST_TYPE_CROSS_GAME_COMPLETE_PACK = "crossGameLevelCompletePacks";
    this.QUEST_TYPE_INSTALL_AND_DO_SOMETHING = "installAndDoSomething";
    this.QUEST_TYPE_CROSS_GAME_ACTION = "crossGameAction";
    this.QUEST_TYPE_CROSS_GAME_LEVEL_COMPLETE = "crossGameLevelComplete";
    this.QUEST_TYPE_CROSS_GAME_LEVEL_IN_TIME = "crossGameLevelInTime";
    this.QUEST_TYPE_INSTALL_ACTION = "installAction";
    this.QUEST_TYPE_INSTALL_AND = "installAnd";
    this.QUEST_TYPE_INSTALL_TIME = "installTime";
    this.QUEST_TYPE_INSTALL_TIME_PUZZLES = "installTimePuzzles";
    this.QUEST_TYPE_INSTALL_AND_COMPLETE_PUZZLES = "installAndCompletePuzzles";
    this.QUEST_TYPE_INSTALL_ACTION_USE_HINTS = "installActionUseHint";
    this.QUEST_TYPE_DAILY_QUESTS_SPECIAL_WORDS = "dailyQuestsSpecialWords";
    this.QUEST_TYPE_DAILY_QUESTS_SPINS = "dailyQuestsSpins";
    this.QUEST_TYPE_DAILY_QUESTS_WATCH_TO_EARN = "dailyQuestsWatchToEarn";
    this.QUEST_TYPE_DAILY_QUESTS = "dailyQuests";
    this.QUEST_TYPE_DAILY_QUESTS_BONUS_CLAIMS = "dailyQuestsBonusClaims";
    this.QUEST_TYPE_DAILY_QUESTS_PUZZLE_CLEARS = "dailyQuestsPuzzleClears";
    this.QUEST_TYPE_OPEN_SUBSCIRIPTION = "openSubscription";
    this.QUEST_TYPE_CROSS_GAME_DQ_LEVEL_ENGAGEMENT = "crossGameDQLevelEngagement";
    this.QUEST_TYPE_CROSS_GAME_DQ = "crossGameDQ";
    this.QUEST_TYPE_SECONDARY_QUEST_LEVEL = "secondaryQuestLevel";
    // this quest type is only for using notifier/ quest toaster/ mini popup
    this.QUEST_TYPE_NOTIFIER = "QUEST_TYPE_NOTIFIER";
    this.QUEST_TYPE_PLAY_DAILY_PUZZLE = "playDailyPuzzle";
    this.QUEST_TYPE_USE_HINT_TARGET = "useHintTarget";
    this.QUEST_TYPE_USE_HINT_BURST = "useHintBurst";

    this.REQUEST_TYPE_WORD_WARS = "wordWarsRequest";
    this.QUEST_TYPE_INSTALL_CROSS_GAME = "installXGame";

    this.QUEST_TYPE_INSTALL_AND = "installAnd";
    this.QUEST_TYPE_OPEN_DICTIONARY = "openDictionary";
    this.QUEST_TYPE_CLICK_DICTIONARY_AUDIO = "clickDictionaryAudio";
    this.QUEST_BUCKET_BUY_SCREEN = 60;
    this.QUEST_HOME_SCREEN = 61;
    this.QUEST_AD_WALL = 63;
    this.QUEST_TYPE_INSTALL_GAME_BUYSCREEN = "installXGame";
    this.QUEST_TYPES = [this.QUEST_TYPE_CROSS_GAME_ACTION, this.QUEST_TYPE_CROSS_GAME_LEVEL_COMPLETE, this.QUEST_TYPE_CROSS_GAME_LEVEL_IN_TIME, this.QUEST_TYPE_INSTALL_ACTION, this.QUEST_TYPE_INSTALL_AND, this.QUEST_TYPE_INSTALL_TIME];
    this.QUEST_TYPE_STREAK_QUESTS = "streakQuests";
    this.QUEST_TYPE_STREAK_QUESTS_PLAY_LEVELS = "streakQuestsPlayLevels";
    this.QUEST_TYPE_STREAK_QUESTS_STAR_WORDS = "streakQuestsStarWords";
    this.QUEST_TYPE_STREAK_QUESTS_VIDEOS = "streakQuestsVideos";
    this.QUEST_TYPE_STREAK_QUESTS_SPIN = "streakQuestsSpin";
    this.QUEST_TYPE_STREAK_QUESTS_GAME_POINTS = "streakQuestsGamePoints";
    this.QUEST_TYPE_STREAK_QUESTS_GAME_MILESTONES = "streakQuestsGameMilestones";
    this.QUEST_TYPES_QC_NORMAL_REDIRECT = [this.QUEST_TYPE_STREAK_QUESTS_PLAY_LEVELS, this.QUEST_TYPE_STREAK_QUESTS_GAME_POINTS, this.QUEST_TYPE_STREAK_QUESTS_GAME_MILESTONES, this.QUEST_TYPE_STREAK_QUESTS_STAR_WORDS, this.QUEST_TYPE_SECONDARY_QUEST_LEVEL, this.QUEST_TYPE_DAILY_QUESTS_SPECIAL_WORDS];

    this.QUEST_ICON_MAP = {
        "levelCompleteInTime": "#levelCompleteInTime.png",
        "watchVideos": "#watchVideos.png",
        "watchVideosInTime": "#watchVideos.png",
        "spinSpinner": "#spinSpinner.png",
        "useHint": "#useHint.png",
        "purchaseCoins": "#purchaseCoins.png",
        "purchaseNoAds": "#purchaseCoins.png",
        "completeOffer": "#purchaseCoins.png",
        "fbConnect": "#fbConnect.png",
        "fbLike": "#fbConnect.png",
        "followTwitter": "#inviteTwitter.png",
        "inviteWhatsapp": "#inviteWhatsApp.png",
        "inviteTwitter": "#inviteTwitter.png",
        "inviteFbMessenger": "#inviteFbMessenger.png",
        "inviteInstagram": "#inviteInstagram.png",
        "inviteTumblr": "#inviteTumblr.png",
        "inviteGooglePlus": "#inviteGooglePlus.png",
        "inviteMessage": "#inviteMessage.png",
        "inviteEmail": "#inviteEmail.png",
        "dailyQuestsSpins": "#spinSpinner.png",
        "dailyQuestsSpecialWords": "#specialWords.png",
        "dailyQuestsWatchToEarn": "#watchVideos.png",
        "openSubscription": "#openSubscription.png",
        "inviteContactBook": "#contactBook.png",
        "dailyQuestsBonusClaims": "#bonusClaims.png",
        "dailyQuestsPuzzleClears": "#dailyPuzzleClears.png",
        "playDailyPuzzle": "#puzzleClears.png",
        "useHintTarget": "#useHint.png",
        "useHintBurst": "#useHint.png",
        "streakQuestsGameMilestones": "#streakQuestsGameMilestones.png",
        "streakQuestsGamePoints": "#streakQuestsGamePoints.png",
        "streakQuestsPlayLevels": "#streakQuestsPlayLevels.png",
        "streakQuestsStarWords": "#specialWords.png",
        "streakQuestsVideos": "#watchVideos.png",
        "streakQuestsSpin": "#spinSpinner.png",
        "vipLevelComplete": "#openSubscription.png",
        "purchasePremiumAvatar": "#purchasePremiumAvatar.png",
        "inviteFriends": "#inviteFriends.png",
        "inviteXFriends": "#inviteFriends.png"
    };

    // This map is used to specify game specific icons for quest type
    this.QUEST_ICON_GAME_MAP = {
        15: {
            "dailyQuestsBonusClaims": "#bonusClaimsNew.png",
            "dailyQuestsPuzzleClears": "#dailyPuzzleClearsNew.png",
            "purchaseCoins": "#purchaseCoinsNew.png",
            "purchaseNoAds": "#purchaseCoinsNew.png",
            "completeOffer": "#purchaseCoinsNew.png",
            "playDailyPuzzle": "#puzzleClearsNew.png",
            "spinSpinner": "#spinSpinnerNew.png",
            "dailyQuestsSpins": "#spinSpinnerNew.png",
            "streakQuestsSpin": "#spinSpinnerNew.png",
            "useHint": "#useHintNew.png",
            "useHintTarget": "#useHintTarget.png",
            "useHintBurst": "#useHintBurst.png",
            "watchVideos": "#watchVideosNew.png",
            "watchVideosInTime": "#watchVideosNew.png",
            "dailyQuestsWatchToEarn": "#watchVideosNew.png",
            "streakQuestsVideos": "#watchVideosNew.png",
        }
    };


    this.MORE_GAMES = "More Games";

    this.trackAndroidMap = {}, this.trackIosMap = {}, this.trackAmazonMap = {};
    this.trackAndroidMap[4] = "cnglv7h";
    this.trackAndroidMap[8] = "zc3zz6";
    this.trackAndroidMap[9] = "d3goyp";
    this.trackAndroidMap[10] = "jgrqiq";
    this.trackAndroidMap[11] = "w0rvv7";
    this.trackAndroidMap[12] = "ogum16";
    this.trackAndroidMap[14] = "qfjq2r9";
    this.trackAndroidMap[15] = "e3vvep1";
    this.trackAndroidMap[16] = "1smbcq4";
    this.trackAndroidMap[17] = "7p4ks7y";

    this.trackIosMap[4] = "lfzm5rr";
    this.trackIosMap[8] = "zc3zz6";
    this.trackIosMap[9] = "d3goyp";
    this.trackIosMap[10] = "jgrqiq";
    this.trackIosMap[11] = "w0rvv7";
    this.trackIosMap[12] = "ogum16";
    this.trackIosMap[14] = "qfjq2r9";
    this.trackIosMap[15] = "e3vvep1";
    this.trackIosMap[16] = "1smbcq4";
    this.trackIosMap[17] = "7p4ks7y";

    // we don't have amazon builds for word wars (10), bliss (14), solitaire(16)
    this.trackAmazonMap[4] = "rhxf1tp";
    this.trackAmazonMap[8] = "tb6r1tj";
    this.trackAmazonMap[9] = "nj9qq52";
    this.trackAmazonMap[10] = "tb6r1tj";
    this.trackAmazonMap[11] = "elr7sxv";
    this.trackAmazonMap[11] = "niafy3w";
    this.trackAmazonMap[14] = "nj9qq52";
    this.trackAmazonMap[15] = "niafy3w";
    this.trackAmazonMap[16] = "nj9qq52";
    this.trackAmazonMap[17] = "tb6r1tj";

    this.trackQuestStatus = {};
    this.trackQuestStatus[0] = "view";
    this.trackQuestStatus[1] = "click";
    this.trackQuestStatus[2] = "complete";
    this.trackQuestStatus[3] = "claim";

    this.trackEachQuest = {};
    this.trackEachQuest[0] = "not_started";
    this.trackEachQuest[1] = "started";
    this.trackEachQuest[2] = "completed";
    this.trackEachQuest[3] = "claimed";

    this.TRACK_KINGDOM = "k";
    this.TRACK_PHYLUM = "p";
    this.TRACK_CLASS = "c";
    this.TRACK_ORDER = "o";
    this.TRACK_FAMILY = "f";
    this.TRACK_GENUS = "g";
    this.TRACK_SPECIES = "s";

    this.TRACK_SOFT_LAUNCH_FAILED = "soft_launch_failed";
    this.TRACK_ADWALL_FAILED = "adwall_failed";
    this.TRACK_GRADIENT_IMAGE_FAILED = "gradient_image_failed";
    this.TRACK_NOT_TRIGGERING_ADWALL = "not_triggering_adwall";
    this.TRACK_ALL_GAMES_INSTALLED = "all_games_installed";
    this.TRACK_IMAGES_NOT_DOWNLOADED = "images_not_downloaded";

    this.TRACK_QUEST_NOTIF = "quest_notif";
    this.TRACK_BONUS_CLAIMS = "bonus_claims";
    // PS-GAMES-DETAILS - This is added to check whether other playsimple is game is already installed or not
    this.PSGames = {};
    this.PSGames["9"] = ["in.playsimple.wordtrip", "fb1778394085519552", "Word Trip"];
    this.PSGames["4"] = ["in.playsimple.word_up", "fb464253443751244", "Word Trek"];
    this.PSGames["10"] = ["com.littleengine.wordpal", "com.littleengine.wordpal", "Word Wars"];
    this.PSGames["8"] = ["in.crossy.daily_crossword", "fb687283344767625", "Daily Themed Crossword"];
    this.PSGames["11"] = ["in.playsimple.tripcross", "fb465855800479707", "Crossword Jam"];
    this.PSGames["12"] = ["in.playsimple.guessup_emoji", "fb713505802062808", "Guess Up"];
    this.PSGames["14"] = ["in.WordSearch.WordBliss", "fb330712434287441", "Word Bliss"];
    this.PSGames["15"] = ["in.crossword.wordplanet", "fb2769738636476965", "Word Planet"];
    this.PSGames["16"] = ["in.cardgame.solitaire", "fb1026714047510541", "Solitaire"];
    this.PSGames["17"] = ["in.daily_puzzle.crossword", "fb2581654998781983", "Crossword Explorer"];


    this.GAMEID_ENCODE_MAPPING = {
        4: 1,
        8: 2,
        9: 4,
        10: 8,
        11: 16,
        12: 32,
        14: 64,
        16: 128,
        15: 256,
        17: 512
    };

    // wordwars requests
    this.wordwars_redirect = other_resources.wordwars_redirect;
    this.wordwars_rays = other_resources.wordwars_rays;

    // quests Runtimes

    // for xpromo surfacing after w2e
    this.RUNTIME_QUEST_DECOMPRESS_SAVE = "qdsr";
    this.RUNTIME_QUEST_SURFACING_REWARD_MULTIPLE = "qsrm";
    this.RUNTIME_QUEST_SURFACING_DAYS_BETWEEN_SURFACING = "qsdbs";
    this.RUNTIME_QUEST_SURFACING_VIEW_COOLDOWN = "qsvc";
    this.RUNTIME_QUEST_SURFACING_CLICK_COOLDOWN = "qscc";
    this.RUNTIME_QUEST_SURFACING_DAYS_AFTER = "qsda";
    this.RUNTIME_QUEST_SURFACING_PAYER = "qsp";
    this.RUNTIME_QUEST_SURFACING_ATTRIBUTION_WINDOW = "qsaw";
    this.RUNTIME_QUEST_SURFACING_TOP_GAMES = "qstg";
    this.RUNTIME_QUEST_SURFACING_INSTALL_QUEST = "qsiq";
    this.RUNTIME_QUEST_SURFACING_DAILY_CAP = "qsdc";
    this.RUNTIME_QUEST_SURFACING_VIEWS_REQUIRED = "qsnv";
    this.RUNTIME_QUEST_SURFACING_HOUR_WINDOWN = "qshw";
    this.RUNTIME_QUEST_SURFACING_N_VIEW_NEW = "qsnvn";
    this.RUNTIME_QUEST_SURFACING_INSTALL_QUEST_NEW = "qsiqn";
    this.RUNTIME_QUEST_SURFACING_POPUP_FORCED_DAYS = "pfsd";
    this.RUNTIME_QUEST_SURFACING_POPUP_FORCED_VIDEOS = "pfsv";
    this.RUNTIME_QUEST_SURFACING_SPIN_VIDEO = "svc";
    this.RUNTIME_QUEST_SURFACING_POWERUP_VIDEO = "pvc";

    // xpromo w2e runtimes for var 3
    this.RUNTIME_QUEST_SURFACING_REWARD_MULTIPLE_V3 = "qsrmv3";
    this.RUNTIME_QUEST_SURFACING_DAYS_AFTER_V3 = "qsdav3";
    this.RUNTIME_QUEST_SURFACING_DAILY_CAP_V3 = "qsdcv3";
    this.RUNTIME_QUEST_SURFACING_N_VIEW_NEW_V3 = "qsnvnv3";

    // runtimes for daily quest crossgame
    this.RUNTIME_DAILY_QUEST_COMPLETED = "dqcr";
    this.RUNTIME_DAILY_QUEST_GAME_PLAYED_DAY = "gpdr";
    this.RUNTIME_DAILY_QUEST_DAYS_AFTER_SHOWN = "dadq";
    this.RUNTIME_DAILY_QUEST_SWITCH_RUNTIMES = "sfdq";
    this.RUNTIME_DAILY_QUEST_SURFACING_BTW_DAYS = "sbd";
    this.RUNTIME_DAILY_QUEST_SURFACING_TIME_VAR_3 = "stdq";
    this.RUNTIME_DAILY_QUEST_PUZZLES_PERCENTAGE = "dqpp";
    this.RUNTIME_DAILY_QUEST_VIDEOS_PERCENTAGE = "dqvp";
    this.RUNTIME_DAILY_QUEST_PAYER_FLAG = "dqpf";
    this.RUNTIME_SHOW_INSTALL_QUEST = "dqsiq";
    this.RUNTIME_MINIMUM_VERSION_DAILY_QUEST_ANDROID = "mdqa";
    this.RUNTIME_MINIMUM_VERSION_DAILY_QUEST_IOS = "mdqi";
    this.RUNTIME_LOOP_BACK_TOASTER = "lbtr";

    // runtimes for ios quests
    this.RUNTIME_CROSS_GAME_QUEST_CLAIM = "cgqc";
    this.RUNTIME_CROSS_GAME_QUEST_SHOW_DAYS_AFTER = "cgqda";
    this.RUNTIME_CROSS_GAME_QUEST_SHOW_PUZZLES_AFTER = "cgqpa";

    // runtimes for adwall new
    this.RUNTIME_ADWALL_NEW_FRIEND_COOLDOWN = "adnfc";
    this.RUNTIME_ADWALL_NEW_PAYER_FLAG = "adnip";
    this.RUNTIME_ADWALL_NEW_RECOMMEND_1 = "adnr1";
    this.RUNTIME_ADWALL_NEW_RECOMMEND_2 = "adnr2";
    this.RUNTIME_ADWALL_NEW_RECOMMEND_3 = "adnr3";

    // runtime for tracking competitor apps
    this.RUNTIME_COMPETITOR_APP_LIST = "acal";

    //runtime for DQ replacement with installQuests
    this.RUNTIME_DAILY_QUEST_REPLACEMENT_DAYS = "dqrd";
    this.RUNTIME_DAILY_QUEST_REPLACEMENT_REWARD = "dqrr";

    // runtime for DTC Xpromo eligible days
    this.RUNTIME_DTC_XPROMO_UNLOCK_DAYS = "dxud";

    this.VARIANT_COMPLETE_X_LEVELS = 0;
    this.VARIANT_PLAY_X_TIME = 1;
    this.CGDQ_OPT_HISTORY_PERIOD = 10;
    this.RUNTIME_QUEST_ADJUST_TRACKING_IMPRESSION = "qati";
    this.RUNTIME_ADJUST_TRACKERS = "adjtk";
    this.RUNTIME_PSGAMES_IDS = "psgid";
    this.RUNTIME_PSGAMES_ANDROID_BUNDLE_IDS = "adbdl";
    this.RUNTIME_PSGAMES_ANDROID_GAME_IDS = "adgid";
    this.RUNTIME_PSGAMES_IOS_GAME_IDS = "iogid";

    this.RUNTIME_QUEST_MINIPOP_TIME = "qmpt";
    // runtime for pseudo social quest
    this.RUNTIME_PSEUDO_SOCIAL = "psr";

    // adwall runtimes
    this.RUNTIME_ADWALL = "awr";

    // quest rotation runtimes
    this.RUNTIME_QUEST_ROTATION = "qr";

    // Config constants
    this.XPROMO_CONFIG_GAME_NAME = "gameName";
    this.XPROMO_CONFIG_TRY_VALUE = "tryValue";
    this.XPROMO_CONFIG_LINEAR_PROGRESSION_AVAILABLE = "linearProgressionAvailable";
    this.XPROMO_CONFIG_ICON_GAME = "icon_game";
    this.XPROMO_CONFIG_ICON_COINS = "icon_coins";
    this.XPROMO_CONFIG_ICON_COINS_2 = "icon_coins_2";
    this.XPROMO_CONFIG_ICON_COINS_3 = "icon_coins_3";
    this.XPROMO_CONFIG_ICON_COINS_4 = "icon_coins_4";
    this.XPROMO_CONFIG_SPRITE_MISC = "SPRITE_MISC";
    this.XPROMO_CONFIG_CALENDAR = "CALENDAR";
    this.XPROMO_CONFIG_COIN = "coin";
    this.XPROMO_CONFIG_BUTTON_CIRCULAR = "button_circular";
    this.XPROMO_CONFIG_BUTTON_180_LOCAL = "btn_180_local";
    this.XPROMO_CONFIG_BTN_180_TEXTURE_LOCAL = "btn_180_texture_local";
    this.XPROMO_CONFIG_BACK = "back";
    this.XPROMO_CONFIG_BUTTON_190 = "btn_190";
    this.XPROMO_CONFIG_BTN_190_TEXTURE_LOCAL = "btn_190_texture_local";
    this.XPROMO_CONFIG_ADWALL_VERSION = "adWallVersion";
    this.XPROMO_CONFIG_WHITE_EXTRA_ROUNDED = "white_extra_rounded";

    // xpromo surfacing after w2e vars
    this.XPROMO_AFTER_W2E = "xpromo_after_w2e";
    this.TRACK_W2E_QUEST = "w2e_quest";
    this.TRACK_W2E_END = "w2e_end";
    this.TRACK_EXIT_PROMO = "xpromo_exit_screen";

    this.TRACK_BUBBLE_POP = "bubble_pop";
    this.TRACK_GIFT_BOX = "giftbox";

    this.TRACK_BUBBLE_POP_V2 = "bubble_pop_v2";
    this.TRACK_BUBBLE_POP_V2_WORD = "bubble_pop_v2_word";

    this.TRACK_PSPN_REDIRECT_FTUE = "pspn_redirect_ftue";

    this.SCREENS_TO_HIDE_FOR_PUSH_NOTIFS = [this.SCREEN_SETTINGS, this.SCREEN_MINIMAP, this.SCREEN_DAILY_CALENDAR, this.SCREEN_COLLECTION];

    this.NOTIFIER = "notifier";
    // TODO - DTC expects this to be 4?
    this.TOASTER_ANIMATION_OVER_TIME = 5;

    this.NON_PAYER = 0;
    this.NON_PAYER_BECAME_PAYER = 1;
    this.BECAME_PAYER = 2;

    // word wars requests
    this.tile_power = "tile_power.png";
    this.tile_holder = "tile_holder.png";
    this.player_bg = res.player_bg_wars;
    this.back_btn = "#back.png";
    this.circle_player = "#circle.png";
    this.blue_circle = "#blueCircle.png";
    this.tile_board = "#tile_bord_02.png";
    this.play_btn = "play.png";
    this.double_letter_abr = "DL";
    this.double_word_abr = "DW";
    this.triple_letter_abr = "TL";
    this.triple_word_abr = "TW";

    this.TRACK_QUEST_CENTER = "quest_center";
    this.TRACK_QUEST_CENTER_DQ = "quest_center_dq";
    this.TRACK_QUEST_CENTER_DAILY_QUESTS = "quest_center_daily_quests";
    this.TRACK_DAILY_QUESTS_COMPLETE_TOASTER = "Daily_quests_complete_toaster";
    this.TRACK_CGDQ = "cgdq";

    this.TRACK_WARS_QUEST = "wars_quest";
    this.TRACK_RECEIVED = "received";
    this.PUSH_NOTIF = "push_notif";
    this.TRACK_SOCIAL_QUEST = "social_quest";
    this.TRACK_PSEUDO_SOCIAL_QUEST = "pseudo_social_quest";
    this.TRACK_QUEST = "quest";
    this.TRACK_WARS_QUEST = "wars_quest";
    this.TRACK_ADWALL = "Adwall";
    this.TRACK_SOFT_LAUNCH = "soft_launch";
    this.TRACK_XPROMO = "Xpromo";
    this.TRACK_XPROMO_ADVID = "pii_xpromo";
    this.TRACK_XPROMO_INTERACTION = "xpromo_int";
    this.TRACK_SWIPE = "swipe";
    this.TRACK_CAROUSEL = "carousel";
    this.TRACK_RECOMMENDED = "recommended_apps";
    this.TRACK_OTHER_APPS = "other_apps";
    this.TRACK_COUNTRY = "country";
    this.TRACK_VIEW_MINIPOP = "view_minipopup";
    this.TRACK_PUSH = "push";
    this.TRACK_UNLOCK = "unlock";
    this.TRACK_CGDQ_RECIEVER = "cgdq_receiver";
    this.TRACK_SESSION_START = "session_start";
    this.TRACK_POST_ENGAGEMENT_CGDQ = "post_engagement_cgdq";
    this.TRACK_QUEST_ACTIVE = "quest_active";
    this.TRACK_DAILY_QUEST = "daily_quest";
    this.TRACK_QUEST_CENTER_AUTO_POP = "quest_center_ap";
    this.TRACK_XPLAY = "xplay";
    this.TRACK_DQ_REPLACEMENT = "dq_replacement";

    this.DAILY_QUESTS_PADDING_TOP = 170;
    this.DAILY_QUESTS_PADDING_LEFT = 30;
    this.DAILY_QUESTS_PADDING_RIGHT = 30;
    this.DAILY_QUESTS_PADDING_BOTTOM = 36;

    this.HEADER_HEIGHT_QUEST_CENTER = 260;


    //Reward tracking
    this.TRACK_COINS_PUZZLE_COMPLETE = 100;
    this.TRACK_COINS_PUZZLE_HELP = 25;

    // soft launch
    this.STATIC = "static";
    this.BANNER = "banner";

    //colors
    this.COLOR_BLUE_09 = cc.color(0, 46, 91);
    this.COLOR_BLUE_10 = cc.color(0, 94, 135);
    this.COLOR_BLUE_11 = cc.color(2, 130, 147);
    this.COLOR_BLUE_12 = cc.color(62, 186, 198);
    this.COLOR_SUPPORT_BG = cc.color(221, 221, 221);
    this.COLOR_SCREEN_GLOW_GOLDEN = cc.color(255, 159, 21);
    this.COLOR_BLUE_TICK = cc.color(0, 187, 242);
    this.COLOR_PURPLE_BANNER = cc.color(164, 39, 243);


    this.WHATSAPP_PACKAGE_ID = "com.whatsapp";


    this.quest_center_img = "#quest_center_img.png";
    this.more_games_img = "#more_games_img.png";
    this.more_games_txt = "#more_games_txt.png";
    this.lock_country_img = "#lock_country_img.png";
    this.coin_packs = "#coin_packs.png";
    this.lock_level_img = "lock_level_img.png";
    this.cur_level_img = "#cur_level_img.png";
    this.unlock_level_img = "unlock_level_img.png";
    this.redirect_btn = "redirect_btn.png";
    this.generic_profile_img = "#generic_profile_img.png";
    this.jewel_notif = "#jewel_notif.png";
    this.map_coin_packs = "#map_coin_packs.png";
    this.point_img = "#point.png";
    this.calender_2 = "#calender_2.png";
    this.xpromo_bg_box = "xpromo_bg_box.png";

    this.popup_bg_soft_launch = "popup_gradient.jpg";


    this.COLOR_RED_RIBBON = cc.color(240, 68, 58);

    // cgdq
    this.empty_box = "EmptyBox.png";
    //this.dq_bg = other_resources.dq_bg;
    this.dq_clock = "#dq_clock.png";
    this.dq_clock_needle = "#dq_clock_needle.png";
    //this.dq_contact_book = other_resources.dq_contact_book;
    this.dq_lock = "#dq_lock.png";
    this.dq_calendar = "#dq_calender.png";
    this.dq_lock_upper = "#dq_lock_upper.png";
    this.dq_lock_lower = "#dq_lock_lower.png";
    this.gift_box_3 = "#xpromo_gift_box.png";
    this.offer_tag_02 = "#xpromo_offer_tag.png";
    this.wordJam_appIcon = "#wj_app_icon.png";
    this.dtc_image = "src/quests/frontend/images/bubblePop/croppedDtc.png";


    this.banner_xpromo = "#banner_2.png";


    this.bubble_popup_ribbon = "#bubblePopRibbon.png";

    // Strings
    this.installAndPlay = "Install and Play";
    this.quests_completed_icon = "#quests_completed_icon.png";

    this.SHOW_REWARD_ON_QUEST_COMPLETE = 1;
    this.DONOT_SHOW_REWARD_ON_QUEST_COMPLETE = 0;

    this.SHOW_LOOP_BACK_ENGAGEMENT_QUEST = 2;
    this.TRACK_SECONDARY_QUEST = "secondary_quest";

    this.INDEX_FOR_PUZZLE_COMPLETES = 5;
    this.INDEX_FOR_LAST_PLAYED_TIMESTAMP = 4;
    this.INDEX_FOR_INSTALLED_TIMESTAMP = 3;

    this.ALL_GAMES_DATA = "allGamesData";
    this.CROSS_GAME_PROGRESS = "crossGameProgress";
    this.GAME_ID_AS_STRING = "game_id";
    this.LAST_UPDATE = "last_update";

    // Quests
    this.MERGE_QUESTS = "mergeQuests";
    this.RESET_FUNCTION_NAME =  "resetFunction";
    this.ARGUMENTS_FOR_RESET_FUNCTION = "argumentsForResetFunction";
    this.GET_SCORE = "getScore";
    this.TRACKER_NAME = "tracker";
    this.DAILY_QUEST_SINGULAR_NAME = "singular";
    this.DAILY_QUEST_PLURAL_NAME = "plural";
    this.QUEST_ACTION = "questAction";
    this.QUEST_UNLOCK_CHECK = "featureUnlockedFunction";
    this.QUEST_LOCK_ACTION = "lockedQuestAction";

    this.EXP_TO_CHANGE_ON_DAILY_BASIS = [this.EXP_DAILY_QUEST_V2];

    this.RUNTIME_DAILY_QUEST_REQUIRED_LEVEL = "dqr";

    this.NUMBER_OF_DAILY_QUESTS_IN_BUCKET = 3;

    this.DAILY_QUEST_UNLOCK_DAYS = 2;

    // Bubble pop
    this.xpromoBubble = "#bubblepop_bubble.png";
    this.bubblePopSmallGift = "#bubblepop_small_giftbox.png";
    this.bubblepop_arrow = "#bubblepop_arrow.png";
    this.bubblepop_giftbox_xpromo = "#bubblepop_giftbox_open_purple.png";
    this.bubblepop_giftbox_xpromo_high = "#bubblepop_open_giftbox.png";
    this.bubblepop_star_gold = "#bubblepop_star_gold.png";
    this.bubblepop_watch_video = "#bubblepop_giftbox_video_low.png";
    this.bubblepop_watch_video_high = "#bubblepop_giftbox_video_high.png";

    this.btn_toggle_01_off = "#btn_toggle_01_off.png";
    this.btn_toggle_01_on = "#btn_toggle_01_on.png";
    this.btn_toggle_02_off = "#btn_toggle_02_off.png";
    this.btn_toggle_02_on = "#btn_toggle_02_on.png";

    // bubble pop - v1
    this.BUBBLE_POP_COIN = 0;
    this.BUBBLE_POP_VIDEO_LOW = 1;
    this.BUBBLE_POP_VIDEO_HIGH = 2;
    this.BUBBLE_POP_XPROMO_LOW = 3;
    this.BUBBLE_POP_XPROMO_HIGH = 4;

    // bubble pop - v2
    this.BUBBLE_POP_VIDEO= 1;
    this.BUBBLE_POP_XPROMO = 2;
    this.BUBBLE_POP_IAP = 3;
    this.BUBBLE_WORD = 4;
    this.BUBBLE_XPROMO_WORD = 5;

    this.DTC_XPROMO_UNLOCK_DAYS_DEFAULT = 4;
};