xPromoFlutterGameSpecific = function () {
    var gameId = 0;
    var WORD_TREK = 4;
    var DTC = 8;
    var WORD_TRIP = 9;
    var WORD_WARS = 10;
    var WORD_JAM = 11;
    var GUESSUP = 12;
    var BLISS = 14;
    var WORD_PLANET = 15;
    var SOLITAIRE = 16;
    var XWORD_EXPLORER = 17;

    this.init = function () {
        gameId = constantsObj.GAME_ID;
    };

    ///////////////////////////////////////////////////////////////////////////////////////////////////
    ////////////////////// Section of methods with enable / disable functionality /////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////////

    this.isFlutterAlwaysEnabled = function() {
        var result = false;
        switch (gameId) {
            case XWORD_EXPLORER:
                result = true;
                break;
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            default:
                break;
        }
        return result;
    };

    this.isSpinnerAvailable = function() {
        var result = false;
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
                result = gameObj.isSpinnerAvailable();
                break;
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return result;
    };


    this.isPickHintAvailable = function() {
        var result = false;
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
                result = (gameObj.isInPickHintVariant() && gameObj.isPickHintUnlocked());
                break;
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return result;
    };

    this.isBurstHintAvailable = function() {
        var result = false;
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
                result = (gameObj.isInBurstHintVariant() && gameObj.isBurstHintUnlocked());
                break;
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return result;
    };

    this.isDailyPuzzleUnlocked = function() {
        var result = false;
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
                result = dailyPuzzleObj.isDailyPuzzleFeatureUnlocked();
                break;
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return result;
    };

    this.shouldShowVideoInTimeQuest = function() {
        var result = false;
        switch(gameId) {
            case XWORD_EXPLORER:
                result = questCenterObj.toShowVideoAchievement();
                break;
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
            case SOLITAIRE:
            case DTC:
                break;
        }
        return result;
    };

    this.shouldShowTutorialQuest = function() {
        var result = false;
        switch(gameId) {
            case XWORD_EXPLORER:
                result = questCenterObj.toShowTutorialAchievement();
                break;
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
            case SOLITAIRE:
            case DTC:
                break;
        }
        return result;
    };

    ///////////////////////////////////////////////////////////////////////////////////////////////////
    ////////////////////// Section of methods to get certain param from the game //////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////////

    this.canInviteFriends = function() {
        var result = true;
        switch(gameId) {
            case XWORD_EXPLORER:
                result = questCenterObj.canInviteFriends();
                break;
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
            case SOLITAIRE:
            case DTC:
                break;
        }
        return result;
    };

    this.getFriendsInvited = function() {
        var result = 0;
        switch(gameId) {
            case XWORD_EXPLORER:
                result = questCenterObj.noOfFriendsInvited();
                break;
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
            case SOLITAIRE:
            case DTC:
                break;
        }
        return result;
    };

    this.getPuzzleSolvedStreak = function() {
        var result = 0;
        switch(gameId) {
            case XWORD_EXPLORER:
                result = questCenterObj.puzzleSolvedStreak();
                break;
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
            case SOLITAIRE:
            case DTC:
                break;
        }
        return result;
    };

    this.getRewardedVideosWatched = function() {
        var result = 0;
        switch(gameId) {
            case XWORD_EXPLORER:
                result = gameObj.getNumVideos();
                break;
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
            case SOLITAIRE:
            case DTC:
                break;
        }
        return result;
    };

    this.getFbConnectCash = function() {
        return economyObj.getFbConnectCash();
    };

    this.getReferralReward = function() {
        return economyObj.getReferralReward();
    };

    this.getDollarValueOverride = function() {
        var result = 0;
        switch(gameId) {
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
            case SOLITAIRE:
            case DTC:
                break;
            case XWORD_EXPLORER:
                result = questCenterObj.numberOfCoinsPerDollarValue();
                break;
        }
        return result;
    };

    ///////////////////////////////////////////////////////////////////////////////////////////////////
    ////////////////////// Section of methods to handle quest actions /////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////////

    this.flutterActionWatchVideos = function() {
        switch(gameId) {
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
            case SOLITAIRE:
                utilObj.delayedCallback(gameLayer, function() {
                    if (utilObj.isNodeValid(curLayer)) {
                        curLayer.hide();
                    }
                    xPromoGameSpecificObj.showLayerOnBack();
                    gameLayer.showWatchVideo();
                }, 1, null, false);
                break;
            case DTC:
                break;
            case XWORD_EXPLORER:
                utilObj.delayedCallback(gameLayer, function() {
                    questCenterObj.handleQuestCenterVideo();
                }, 1, null, false);
                break;
        }
    };

    this.flutterActionShowInvitePopup = function() {
        switch(gameId) {
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
            case SOLITAIRE:
                utilObj.delayedCallback(gameLayer, function() {
                    xPromoGameSpecificObj.setFreeCoinsReferralLastScreen(constantsObj.SCREEN_QUEST_CENTER);
                    freeCoinsReferralPopup.show();
                }, 1, null, false);
                break;
            case DTC:
                break;
            case XWORD_EXPLORER:
                questCenterObj.handleQuestCenterInvite();
                break;
        }
    };

    this.flutterActionFbLogin = function() {
        switch(gameId) {
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
                xPromoFlutterGameSpecificObj.flutterCustomGameExitHandle(false);
                // TODO - Callback param - fbWrapperObj.login(questCenterLayer.loginSuccess);
                fbWrapperObj.login(null);
                break;
        }
    };

    this.flutterActionCoinStore = function() {
        switch(gameId) {
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
                pspnFlutterObj.setRedirectionFromFlutter(constantsObj.SCREEN_NEW_STORE_LAYER);
                utilObj.delayedCallback(gameLayer, function() {
                    newStoreLayer.show(constantsObj.SCREEN_QUEST_CENTER);
                }, 0, null, false);
                break;
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
                break;
        }
    };

    this.flutterActionCompleteOffer = function() {
        switch(gameId) {
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
            case SOLITAIRE:
            case DTC:
                break;
            case XWORD_EXPLORER:
                questCenterObj.handleQuestCenterOfferwall();
                break;
        }
    };

    this.flutterActionShowDailyPuzzle = function() {
        switch(gameId) {
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
                utilObj.delayedCallback(gameLayer,xPromoGameSpecificObj.questActionDailyPuzzle, 0, null, false);
                break;
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
                break;
        }
    }

    this.flutterActionRedirectToGame = function() {
        switch(gameId) {
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
                if (utilObj.isNodeValid(curLayer)) {
                    curLayer.hide();
                }
                xPromoGameSpecificObj.showLayerOnBack();
                break;
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
                break;
        }
    };

    this.flutterActionShowSpinner = function() {
        switch(gameId) {
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
                if (utilObj.isNodeValid(curLayer)) {
                    curLayer.hide();
                }
                xPromoGameSpecificObj.showLayerOnBack();
                utilObj.delayedCallback(gameLayer, gameLayer.showSpinner, 1, null, false);
                break;
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
                break;
        }
    };

    ///////////////////////////////////////////////////////////////////////////////////////////////////
    ////////////////////// Section of methods for notifying the host game /////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////////

    this.flutterCustomGameNotifSurfacing = function(shouldShowNewTag, completedQuestIds, activeQuestIds, claimedQuestIds) {
        switch(gameId) {
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
                var layersToChange = [gameLayer];
                var llpLayersToChange = [];

                if(xPromoGameSpecificObj.isSettingsLayerEnabled()) {
                    layersToChange.push(settingsLayer);
                }

                if(questConfigObj.isLinearProgressionAvailable()) {
                    llpLayersToChange.push(linearProgressionLayer);
                }

                if(xPromoGameSpecificObj.isDigraphAvailable()) {
                    layersToChange.push(digraphGameLayer);
                    llpLayersToChange.push(digraphLLPLayer);
                }

                if(xPromoGameSpecificObj.isDailyPuzzleAvailable()) {
                    layersToChange.push(dailySpellingBeeLayer);
                }

                if(xPromoGameSpecificObj.showQuestNotifOnHomeScreen()) {
                    layersToChange.push(homeLayer);
                }

                // * changing jewel notif as per number of completed quests
                if (questsObj.getCompletedQuests() > 0 && !questsObj.showTagOnQuestCenterBubble()) {
                    questsObj.showQuestsCompletedJewelNotif(layersToChange, llpLayersToChange);
                    if (xPromoGameSpecificObj.isInButtonFillVariant()) {
                        xPromoGameSpecificObj.showFilledQuestButton(true);
                    }
                } else if (userObj.isUserCreated() || (questsObj.getCompletedQuests() == 0 && questsObj.getQuestCenterSeen() && !questsObj.showTagOnQuestCenterBubble())) {
                    questsObj.hideQuestCompletedJewelNotif(layersToChange, llpLayersToChange);
                    if (xPromoGameSpecificObj.isInButtonFillVariant()) {
                        xPromoGameSpecificObj.showFilledQuestButton(false);
                    }
                } else {
                    if (questsObj.getQuestCenterSeenTimestamp() == null) {
                        questsObj.setQuestCenterSeenTimestamp(utilObj.getCurrentTimestamp());
                    }
                    questsObj.showNewTagJewelnotif(layersToChange, llpLayersToChange);
                    if (xPromoGameSpecificObj.isInButtonFillVariant()) {
                        xPromoGameSpecificObj.showFilledQuestButton(true);
                    }
                }
                break;
            case SOLITAIRE:
                break;
            case DTC:
                break;
            case XWORD_EXPLORER:
                questCenterObj.handleQuestNotifSurfacing(shouldShowNewTag, completedQuestIds, activeQuestIds, claimedQuestIds);
                break;
        }
    };

    this.flutterCustomGameAnimSurfacing = function(questId, questDescription, questIcon, questReward) {
        switch(gameId) {
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
                if (curScreen == constantsObj.SCREEN_GAME) {
                    xpromoAnimationObj.showDailyQuestCompleteToaster(gameLayer);
                } else if (questConfigObj.isLinearProgressionAvailable() && curScreen == constantsObj.SCREEN_LINEAR_PROGRESSION) {
                    xpromoAnimationObj.showDailyQuestCompleteToaster(linearProgressionLayer);
                } else if (xPromoGameSpecificObj.isDigraphAvailable() && curScreen == constantsObj.SCREEN_DIGRAPH_GAME) {
                    xpromoAnimationObj.showDailyQuestCompleteToaster(digraphGameLayer);
                } else if (xPromoGameSpecificObj.isDigraphAvailable() && curScreen == constantsObj.SCREEN_DIGRAPH_LINEAR_PROGRESSION) {
                    xpromoAnimationObj.showDailyQuestCompleteToaster(digraphLLPLayer);
                } else if (xPromoGameSpecificObj.isDailyPuzzleAvailable() && curScreen == constantsObj.SCREEN_SPELLING_BEE) {
                    xpromoAnimationObj.showDailyQuestCompleteToaster(dailySpellingBeeLayer);
                }
                break;
            case SOLITAIRE:
                break;
            case DTC:
                break;
            case XWORD_EXPLORER:
                questCenterObj.handleQuestCompleteSurfacing(questId, questDescription, questIcon, questReward);
                break;
        }
    };

    this.flutterCustomGameExitHandle = function(fromBackButton) {
        switch(gameId) {
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
            case SOLITAIRE:
            case DTC:
                break;
            case XWORD_EXPLORER:
                questCenterObj.handleQuestCenterExit(fromBackButton);
                break;
        }
    };

    ///////////////////////////////////////////////////////////////////////////////////////////////////
    ////////////////////// Section of methods for general debugging ///////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////////

    this.failedToHandle = function () {
        loggerObj.debugLog("failedToHandle - some xPromoFlutterGameSpecific method is unhandled for this game.");
    };

};
