xPromoGameSpecific = function () {
    var gameId = 0;
    var WORD_TREK = 4;
    var DTC = 8;
    var WORD_TRIP = 9;
    var WORD_WARS = 10;
    var WORD_JAM = 11;
    var GUESSUP = 12;
    var BLISS = 14;
    var WORD_PLANET = 15;
    var SOLITAIRE = 16;
    var XWORD_EXPLORER = 17;
    this.init = function () {
        gameId = constantsObj.GAME_ID;
    };

    this.canAdWallBeShown = function () {
        var canShow = false;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
                canShow = (!gameObj.getShouldShowDailyCalendarAuto() && gameObj.shouldShowStarterPack() == 0 && utilObj.getIsNotifClicked() == false);
                break;
            case WORD_JAM:
            case WORD_PLANET:
                canShow = (!gameObj.isHomeScreenEventFtueVisible() && utilObj.getIsNotifClicked() == false && gameObj.getNotifHintRevealed() == false && !dailyCalendarObj.getShouldShowDailyCalendarAuto());
                break;
            case DTC:
            case XWORD_EXPLORER:
                if (utilObj.getIsNotifClicked() == false) {
                    if (gameObj.adwallShouldBeShown()) {
                        // loggerObj.debugLog("calling adwall", curScreen, utilObj.getScreenName(curScreen),utilObj.checkAnyNotifTriggered(),gameObj.getLastUnlockedPuzzle());
                        if (!(utilObj.isAndroid() && utilObj.checkAnyNotifTriggered() && gameObj.getLastUnlockedPuzzle() != null) && !gameObj.getisTriggeredFromPushNotif()) {
                            // loggerObj.debugLog("check the notif time123",prevNotifTime,nextNotifTime,(!gameObj.getNotifPermissionForIos()) || (gameObj.getNotifPermissionForIos() && prevNotifTime == nextNotifTime));
                            if (utilObj.isIos()) {
                                if ((!gameObj.getNotifPermissionForIos()) || (gameObj.getNotifPermissionForIos() && gameObj.getPrevNotifTime() == gameObj.getNextNotifTime())) {
                                    canShow = true;
                                }
                            } else {
                                canShow = true;
                            }
                        }
                    }
                }
                break;
            case SOLITAIRE:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return canShow;
    };

    this.getPhylumForTracking = function () {
        var track = "";
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
                track = gameObj.getTrackingBucketId();
                break;
            case DTC:
            case XWORD_EXPLORER:
                track = gameObj.getCurPuzzleTracking();
                break;
            case SOLITAIRE:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return track;
    };

    this.getClassForTracking = function () {
        var track = "";
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
                track = gameObj.getTrackingPuzId();
                break;
            case DTC:
            case XWORD_EXPLORER:
                track = gameObj.getTrackingPuzzleTheme();
                break;
            case SOLITAIRE:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return track;
    };

    this.getSpeciesForTracking = function () {
        var track = "";
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
                track = gameObj.getTrackingPuzzleInfo();
                break;
            case DTC:
            case XWORD_EXPLORER:
                track = gameObj.getPuzzleSpeciesTracking();
                break;
            case SOLITAIRE:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return track;
    };

    this.setCurScreen = function (sc) {
        switch (gameId) {
            case WORD_TRIP:
                if(sc == constantsObj.SCREEN_QUEST_CENTER) {
                    pspnGameObj.setLastSeenQCTimeStampAndDauDay()
                }
                gameObj.setCurScreen(sc);
                break;
            case BLISS:
            case SOLITAIRE:
                gameObj.setCurScreen(sc);
                break;
            case WORD_JAM:
            case WORD_PLANET:
                // TODO: add when qa automation gets added to wordjam
                break;
            case DTC:
            case XWORD_EXPLORER:
                // TODO: add when qa automation gets added to dtc
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
    };

    this.isFtueVisible = function () {
        var boolVal = false;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                boolVal = ftueObj.isFtueVisible();
                break;
            case DTC:
            case XWORD_EXPLORER:
                // TODO: have to make or find and then include corresponding function in dtc
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return boolVal;
    };

    this.getIsPuzCompFtueShown = function () {
        var boolVal = false;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                boolVal = gameObj.getIsPuzCompFtueShown();
            case WORD_JAM:
            case WORD_PLANET:
                break;
            case DTC:
            case XWORD_EXPLORER:
                // TODO: have to make or find and then include corresponding function in dtc
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return boolVal;
    };

    this.getW2EReward = function () {
        var c = 0;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                c = runtimeObj.getW2EReward();
                break;
            case WORD_JAM:
            case WORD_PLANET:
                c = economyObj.getW2EReward();
                break;
            case DTC:
            case XWORD_EXPLORER:
                c = gameObj.getCashToGrant();
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.getW2EPerHour = function () {
        var c = 0;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                c = runtimeObj.getW2EPerHour();
                break;
            case DTC:
            case XWORD_EXPLORER:
                c = xpromoDtcObj.getW2EPerHour();
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.getBottomShiftGameScreen = function () {
        var c = 0;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                break;
            case DTC:
            case XWORD_EXPLORER:
                c = utilObj.getBottomShiftGameScreen();
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.scaleCoinStackInW2e = function () {
        var c = 0;
        switch (gameId) {
            case BLISS:
                c = 0.7;
                break;
            case WORD_TRIP:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                c = 1;
                break;
            case DTC:
            case XWORD_EXPLORER:
                c = 0.3;
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.getCenterPosW2ePopup = function (popupWidth, popupHeight) {
        var center = {"x": 0, "y": 0};
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
                center.x = popupWidth / 2;
                center.y = popupHeight / 2;
                break;
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
                center.x = centerXPos;
                center.y = centerYPos;
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return center;
    };

    this.xPromoW2eYOffset = function () {
        var c = 0;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                c = 0;
                break;
            case DTC:
            case XWORD_EXPLORER:
                c = 50;
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.xPromoW2eYOffsetForCoinHeader = function () {
        var c = 0;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                c = 0;
                break;
            case WORD_JAM:
            case WORD_PLANET:
                c = 100;
                break;
            case DTC:
            case XWORD_EXPLORER:
                c = 0;
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.addPopupBg = function (popupHeight, popupNode) {
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                break;
            case DTC:
            case XWORD_EXPLORER:
                xpromoDtcObj.addPopupBg(popupHeight, popupNode);
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
    };

    this.canW2eCoinGrant = function (xInc, yInc, cashToGrant, cashAlreadyGranted, layerForAnimation) {
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                if (layerForAnimation == undefined) {
                    layerForAnimation = gameLayer;
                }
                xpromoAnimationObj.w2eCoinGrant(xInc, yInc, cashToGrant, layerForAnimation);
                break;
            case DTC:
            case XWORD_EXPLORER:
                break;
            case WORD_JAM:
            case WORD_PLANET:
                var initialPosition = {x: centerXPos + xInc, y: centerYPos + yInc};
                animationObj.genericCoinGrantAnimation(cashToGrant, false, cashAlreadyGranted, initialPosition, undefined, constantsObj.UI_Z_ORDER);
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
    };

    this.coinGrantAnimAfterDelay = function (sender, params) {
        xPromoGameSpecificObj.canW2eCoinGrant(params.xOffset, params.yOffset, params.cashToGrant, params.cashAlreadygranted, sender);
    };

    this.showCoinGrantMessage = function (quantity) {
        var text = stringsObj.coin_added;
        if (quantity > 1) {
            text = stringsObj.coins_added;
        }
        text = text.replace("%N%", quantity);
        utilObj.showMessage(text);
    };

    this.showAdWallHeader = function (spriteArr, labelArr, zOrder, layerToAdd, sectionHeight) {
        var childArr = [];
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                childArr = moreGamesLayer.diffMoreGamesUi(spriteArr, labelArr, zOrder, layerToAdd, sectionHeight);
                break;
            case DTC:
            case XWORD_EXPLORER:
                var variant = adWallObj.getAdWallNewUIExperiment();
                if(variant == constantsObj.EXP_VAR_CONTROL || variant == constantsObj.EXP_VAR_4) {
                    childArr = xpromoDtcObj.diffMoreGamesUi(spriteArr, labelArr, zOrder, layerToAdd, sectionHeight);
                } else {
                    childArr = moreGamesLayer.diffMoreGamesUi(spriteArr, labelArr, zOrder, layerToAdd, sectionHeight);
                }
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return childArr;
    };

    this.getFullDesignHeight = function() {
        var result = constantsObj.DESIGN_HEIGHT;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                break;
            case DTC:
            case XWORD_EXPLORER:
                result = constantsObj.DESIGN_HEIGHT + topBarOffset;
                break;
        }
        return result;
    }

    this.yDiffSoftLaunchUi = function () {
        var c = 0;
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
                c = (400 + constantsObj.BEZEL_SAFE_AREA - constantsObj.POPUP_START_OFFSET) / 2;
                if (utilObj.isBezelScreen()) {
                    c = c + xPromoGameSpecificObj.getBezelShift();
                }
                break;
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
                if (utilObj.isBezelScreen()) {
                    c = -60;
                }
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.getExitPopupHeaderFont = function () {
        var font = constantsObj.FONT_SFCOMPACT_REGULAR_70;
        switch (gameId){
          case BLISS:
              font = constantsObj.FONT_SFCOMPACT_MEDIUM_120;
              break;
            case WORD_TRIP:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return font;
    };
    this.popupShow = function (popupHeight, popupType, heading, popupUI, spriteArr, popupLabels,
                               showClose, popupBgColor, screenSubType, trackGenus, trackSpecies, extraWide, extraHeader, headerFont, popupExtraHeight, yOffset) {
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                popupLayer.show(popupHeight, popupType, heading, popupUI, spriteArr, popupLabels,
                    showClose, popupBgColor, screenSubType, trackGenus, trackSpecies, extraWide, extraHeader, headerFont, popupExtraHeight, yOffset);
                break;
            case DTC:
            case XWORD_EXPLORER:
                // popupBgColor
                // headerFont
                var noHeader = false;
                var coinHeader = false;
                var headerBgColor = null;
                var headerColor = null;
                var headerBg = null;
                popupLayer.show(popupHeight, popupType, heading, popupUI, popupLabels,
                    showClose, screenSubType, trackGenus, trackSpecies, extraWide, extraHeader, noHeader, coinHeader, headerBgColor, headerColor, headerBg, spriteArr);
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
    };

    this.popupShowWithAnim = function () {
        var c = false;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
                c = true;
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.getScreenName = function (sc) {
        var screenName = "";
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
                screenName = utilObj.getScreenName(sc);
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return screenName;
    };

    this.getAdwallGameShownId = function () {
        var gid = gameId;
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
            case BLISS:
            case SOLITAIRE:
                // this was done to avoid making any additional quests for word jam
                gid = WORD_TRIP;
                break;
            case WORD_TRIP:
            case DTC:
                break;
            case XWORD_EXPLORER:
                gid = DTC;
                break;
            default:
                break;
        }
        return gid;
    };

    this.updateQuestCenterTimeLabels = function () {
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                questCenterLayer.updateQuestCenterTimeLabels();
                break;
            case DTC:
            case XWORD_EXPLORER:
                xpromoDtcObj.updateQuestCenterTimeLabels();
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
    };

    this.updateScreenBegin = function (sc) {
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                utilObj.updateScreenBegin(sc);
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
    };

    this.getBezelShift = function () {
        var c = 0;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                c = utilObj.getBezelShift();
                break;
            case DTC:
            case XWORD_EXPLORER:
                c = utilObj.getBezelShift();
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.setFreeCoinsReferralLastScreen = function () {
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                gameObj.setFreeCoinsReferralLastScreen(constantsObj.SCREEN_QUEST_CENTER);
                break;
            case WORD_JAM:
            case WORD_PLANET:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
    };

    this.getWidthErr = function () {
        var c = 0;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                c = widthErr;
                break;
            case DTC:
            case XWORD_EXPLORER:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.showAndAwardRateUs = function () {
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                gameObj.showAndAwardRateUs();
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
    };

    this.canShowSubscriptionQuest = function () {
        var canShow = false;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
                if(typeof subscriptionsTripObj !== "undefined") {
                    canShow = (subscriptionsTripObj.checkSubscriptionStatus() == constantsObj.SUBSCRIPTION_ACTIVE && subscriptionsTripObj.getIsJoiningBonusGiven() == false && subscriptionsObj.getJoiningBonusStatus() == false);
                } else {
                    canShow = (gameObj.checkSubscriptionStatus() == constantsObj.SUBSCRIPTION_ACTIVE && gameObj.getIsJoiningBonusGiven() == false && subscriptionsObj.getJoiningBonusStatus() == false);
                }
                break;
            case WORD_JAM:
            case WORD_PLANET:
                break;
            case SOLITAIRE:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return canShow;
    };

    this.setSubscriptionSource = function (sc) {
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                if(typeof subscriptionsTripObj !== "undefined") {
                    subscriptionsTripObj.setSubscriptionSource(sc);
                } else {
                    gameObj.setSubscriptionSource(sc);
                }
                break;
            case WORD_JAM:
            case WORD_PLANET:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
    };

    this.getW2ELimitReached = function () {
        var w2eLimitReached = 0;
        switch (gameId) {
            case WORD_TRIP:
                var exp_w2e = epmObj.getChosenVariant(constantsObj.EXP_W2E_COOLDOWN);
                if (exp_w2e == constantsObj.EXP_VAR_CONTROL) {
                    w2eLimitReached = gameObj.getW2ELimitReached();
                } else {
                    w2eLimitReached = !w2eCooldownObj.shouldShowVideo();
                }
                break;
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                w2eLimitReached = gameObj.getW2ELimitReached();
                break;
            case DTC:
            case XWORD_EXPLORER:
                w2eLimitReached = xpromoDtcObj.getW2ELimitReached();
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return w2eLimitReached;
    };

    this.getNextVideoIn = function () {
        var nextVideoIn = 0;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                nextVideoIn = gameObj.getNextVideoIn();
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return nextVideoIn;
    };

    this.getW2EDisabled = function () {
        var w2eDisabled = 0;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                w2eDisabled = gameObj.getW2EDisabled();
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return w2eDisabled;
    };

    this.setRequestCount = function (requestCount) {
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                gameObj.setRequestCount(requestCount);
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
    };

    this.getPuzCompleted = function () {
        var puzCompleted = 0;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
                puzCompleted = gameObj.getPuzCompleted();
                break;
            case DTC:
            case XWORD_EXPLORER:
                puzCompleted = gameObj.getMainCrosswordsClearedCount();
                break;
            case SOLITAIRE:
                puzCompleted = gameStateObj.getTotalGamesPlayedDraw1() + gameStateObj.getTotalGamesPlayedDraw3();
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return puzCompleted;
    };

    this.getVIPPuzzlesCompleted = function () {
        var vipPuzCompleted = 0;
        switch (gameId) {
            case WORD_TRIP:
                vipPuzCompleted = subDigraphObj.getVipPuzzlesCompletedForQuest();
                break;
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return vipPuzCompleted;
    };

    this.getVIPPuzzleUnlockLevel = function () {
        var vipUnlockLevel = Number.MAX_VALUE;
        switch (gameId) {
            case WORD_TRIP:
                var subscriptionStatus;
                if(typeof subscriptionsTripObj !== "undefined") {
                    subscriptionStatus = subscriptionsTripObj.checkSubscriptionStatus();
                } else {
                    subscriptionStatus = gameObj.checkSubscriptionStatus();
                }
                if (subDigraphObj.getIsDigraphFeatureUnlocked() && (subscriptionStatus == constantsObj.SUBSCRIPTION_ACTIVE || subscriptionStatus == constantsObj.SUBSCRIPTION_INACTIVE)) {
                    vipUnlockLevel = constantsObj.NEW_FLOW_FEATURE_UNLOCK_PUZNUM;
                }
                break;
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return vipUnlockLevel;
    }

    this.isProfileEnabled = function () {
        var result = false;
        switch(gameId) {
            case WORD_TRIP:
                result = (profileObj.isValidExperiment() && profileObj.getShouldShowAvatarsFeature());
                break;
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
                result = false;
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return result;
    };

    this.showOrHideBannerAd = function (scr) {
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                adsObj.showOrHideBannerAd(scr);
                break;
            case DTC:
            case XWORD_EXPLORER:
                utilObj.showOrHideAd(false, scr);
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
    };

    this.hideBannerAd = function (scr) {
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                adsObj.hideBannerAd(scr);
                break;
            case DTC:
            case XWORD_EXPLORER:
                utilObj.hideBannerAd(scr);
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
    };

    this.getCloseButton = function () {
        var result = "";
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
                result = profileConstantsObj.cross_close;
                break;
            case SOLITAIRE:
                break;
            case WORD_JAM:
            case WORD_PLANET:
                result = constantsObj.close_new;
                break;
            case DTC:
            case XWORD_EXPLORER:
                result = constantsObj.headerCross;

            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return result;
    };

    this.getHintsUsedCount = function () {
        var c = 0;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                c = gameObj.getHintsUsedCount();
                break;
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.setDailySpecialWordsFormed = function (val) {
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                gameObj.setDailySpecialWordsFormed(val);
                break;
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
    };

    this.setDailySpins = function (val) {
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                gameObj.setDailySpins(val);
                break;
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
    };

    this.setDailyWatchVideosCount = function (val) {
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                gameObj.setDailyWatchVideosCount(val);
                break;
            case DTC:
            case XWORD_EXPLORER:
                gameObj.setNumberOfVideoIntWatched(val);
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
    };

    this.getDailySpecialWordsFormed = function () {
        var c = 0;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                c = gameObj.getDailySpecialWordsFormed();
                break;
            case WORD_JAM:
            case WORD_PLANET:
                break;
            case DTC:
            case XWORD_EXPLORER:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.getDailyBonusClaims = function () {
        var c = 0;
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
                c = bonusWordsObj.getDailyBonusJarClaimsCount();
                break;
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                break;
            case DTC:
            case XWORD_EXPLORER:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.setDailyBonusClaims = function (val) {
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
                bonusWordsObj.setDailyBonusJarClaimsCount(val);
                break;
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
    };


    this.getDailyPuzzleClears = function () {
        var c = 0;
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
                c = gameObj.getDailyMainPuzzleClearsCount();
                break;
            case WORD_TRIP:
                if(typeof nuxObj !== "undefined") {
                    c = gameObj.getPuzzleSolvedTodayForQuest();
                } else {
                    c = gameObj.getPuzzlesSolvedToday();
                }
                break;
            case BLISS:
            case SOLITAIRE:
                c = gameObj.getPuzzlesSolvedToday();
                break;
            case DTC:
            case XWORD_EXPLORER:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.setDailyPuzzleClears = function (val) {
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
                gameObj.setDailyMainPuzzleClearsCount(val);
                break;
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                gameObj.setPuzzlesSolvedToday(val);
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
    };

    this.getDailyGamePoints = function () {
        var c = 0;
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
                break;
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                c = streakObj.getDailyWisdomScore();
                break;
            case DTC:
            case XWORD_EXPLORER:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.setDailyGamePoints = function (val) {
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
                break;
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                streakObj.setDailyWisdomScore(val);
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
    };

    this.getDailyGameMilestones = function () {
        var c = 0;
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
                break;
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                c = streakObj.getDailyMaxStreaks();
                break;
            case DTC:
            case XWORD_EXPLORER:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.setDailyGameMilestones = function (val) {
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
                break;
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                streakObj.setDailyMaxStreaks(val);
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
    };

    this.getDailySpins = function () {
        var c = 0;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                c = gameObj.getDailySpins();
                break;
            case WORD_JAM:
            case WORD_PLANET:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.getSpinsAvailable = function () {
        var c = 0;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
                c = economyObj.getSpinCount();
                break;
            case WORD_JAM:
            case WORD_PLANET:
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.getDailyWatchVideosCount = function () {
        var c = 0;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                c = gameObj.getDailyWatchVideosCount();
                break;
            case DTC:
            case XWORD_EXPLORER:
                c = gameObj.getNumberOfVideoIntWatched();
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    // NOTE: This condition needs to be investigated, it doesn't seem to return what the method says, probably the opposite
    this.getDailyQuestsUnlocked = function () {
        // config added
        if (utilObj.isStaging() && qaConfigObj.getQAConfigData("dailyQuestLocked") == 1) {
            return true;
        }
        var dailyQuestsUnlocked = false;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                dailyQuestsUnlocked = questCenterLayer.checkDailyQuestsLocked();
                break;
            case WORD_JAM:
            case WORD_PLANET:
                dailyQuestsUnlocked = !(questsObj.getDailyQuestLocked());
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return dailyQuestsUnlocked;
    };

    this.getShouldShowDailyCalendarAuto = function () {
        var c = false;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
                c = gameObj.getShouldShowDailyCalendarAuto();
                break;
            case WORD_JAM:
            case WORD_PLANET:
                c = dailyCalendarObj.getShouldShowDailyCalendarAuto();
                break;
            case DTC:
            case XWORD_EXPLORER:
                break;
            case SOLITAIRE:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.shouldShowStarterPack = function () {
        var c = 0;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                c = gameObj.shouldShowStarterPack();
                break;
            case WORD_JAM:
            case WORD_PLANET:
                break;
            case DTC:
            case XWORD_EXPLORER:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.getLevelForQuests = function () {
        var c = 1;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
                c = gameObj.getLevelForQuests();
                break;
            case DTC:
                c = gameObj.getMainCrosswordsClearedCount();
                break;
            case XWORD_EXPLORER:
                c = questCenterObj.noOfCrossWordsCleared();
            case SOLITAIRE:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.getLastGameOpenTimestamp = function () {
        var c = 0;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
                c = gameObj.getLastGameOpenTimestamp();
                break;
            case SOLITAIRE:
                c = utilObj.getCurrentTimestamp();
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.isInButtonFillVariant = function () {
        var c = false;
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
                c = gameObj.isInButtonFillVariant();
                break;
            case WORD_TRIP:
            case BLISS:
                c = buttonFillObj.isValidToShowButtonFill(constantsObj.BUTTON_FILL_QC);
                break;
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.initialChecksForAdWall = function () {
        var c = true;
        switch (gameId) {
            case DTC:
            case XWORD_EXPLORER:
                c = xpromoDtcObj.initialChecksForAdWall();
                break;
            case WORD_JAM:
            case WORD_PLANET:
            case WORD_TRIP:
            case SOLITAIRE:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.getIsPrivatePolicyOpen = function () {
        var c = true;
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                c = gameObj.getIsPrivatePolicyOpen();
                break;
            case DTC:
            case XWORD_EXPLORER:
                c = gameObj.getPrivacyPolicyPopupShown();
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.getTimeSpentInSession = function() {
        var c = 0;
        switch (gameId) {
            case WORD_TRIP:
            case WORD_JAM:
                c = machineLearningDataObj.getSessionTime();
                var sinceResume = analyticsObj.timeSinceResume();
                if(sinceResume > 0) {
                    c += sinceResume;
                }
                break;
            case BLISS:
            case SOLITAIRE:
            case WORD_PLANET:
                break;
            case DTC:
            case XWORD_EXPLORER:
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    }

    this.getDForUser = function () {
        return gameObj.getDForUser();
    };

    this.getDForUserFromCreatedTime = function (createdTimeStamp, curTimeStamp) {
        return gameObj.getDForUserFromCreatedTime(createdTimeStamp, curTimeStamp);
    };

    this.getIsPayer = function () {
        return gameObj.getIsPayer();
    };

    this.getIsPayerUser = function () {
        return userObj.getIsPayer();
    };

    this.getLastRatedVersion = function () {
        return gameObj.getLastRatedVersion();
    };

    this.getConsecutiveLogins = function () {
        return gameObj.getConsecutiveLogins();
    };

    this.shouldShowSubscriptionQuest = function () {
        var c = false;
        switch (gameId) {
            case WORD_TRIP:
                if(typeof subscriptionsTripObj !== "undefined") {
                    c = subscriptionsTripObj.shouldShowSubscriptionQuest();
                } else {
                    c = gameObj.shouldShowSubscriptionQuest();
                }
                break;
            case WORD_JAM:
            case WORD_PLANET:
            case BLISS:
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
                c = false;
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return c;
    };

    this.getInstallTimeStamp = function () {
        var result = 0;
        switch (gameId) {
            case WORD_TRIP:
                result = gameObj.getCreatedTime();
                if(result == 0) {
                    result = gameObj.getInstallTimeStamp();
                }
                break;
            case WORD_JAM:
            case WORD_PLANET:
            case BLISS:
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
                result = gameObj.getInstallTimeStamp();
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
        return result;
    };

    this.getPushNotifGrant = function () {
        return gameObj.getPushNotifGrant();
    };

    this.setPushNotifGrant = function (val) {
        gameObj.setPushNotifGrant(val);
    };

    this.getPuzzleIdForIndex = function (i, reverse) {
        return gameObj.getPuzzleIdForIndex(i, reverse);
    };

    this.checkSubscriptionStatus = function () {
        if(typeof subscriptionsTripObj !== "undefined") {
            return subscriptionsTripObj.checkSubscriptionStatus();
        }
        return gameObj.checkSubscriptionStatus();
    };
    this.getIsJoiningBonusGiven = function () {
        if(typeof subscriptionsTripObj !== "undefined") {
            return subscriptionsTripObj.getIsJoiningBonusGiven();
        }
        return gameObj.getIsJoiningBonusGiven();
    };
    this.setSubscriptionSource = function (val) {
        if(typeof subscriptionsTripObj !== "undefined") {
            subscriptionsTripObj.setSubscriptionSource(val);
        } else {
            gameObj.setSubscriptionSource(val);
        }
    };
    this.checkRewardedVideo = function (isUserTriggered) {
        return adsObj.checkRewardedVideo(isUserTriggered);
    };

    this.showVideoAd = function (isContinueWatch) {
        if(isContinueWatch == undefined) {
            isContinueWatch = false;
        }
        var result = false;
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                result = adsObj.showVideoAd(isContinueWatch);
                break;
            case DTC:
            case XWORD_EXPLORER:
                result = adsObj.showVideoAd(false, false, isContinueWatch);
                break;
            default:
                break;
        }
        return result;
    };

    this.checkAndIncCompleted = function () {
        ftueObj.checkAndIncCompleted();
    };

    this.shouldFtueBeShown = function () {
        return ftueObj.shouldFtueBeShown();
    };

    this.checkInstalledPlaysimpleGames = function () {
        gameObj.checkInstalledPlaysimpleGames();
    };

    this.checkIfAppInstalledWithGameId = function (gameHosted) {
        return gameObj.checkIfAppInstalledWithGameId(gameHosted);
    };

    this.getFbPicUrl = function (fbid) {
        return friendsObj.getFbPicUrl(fbid);
    };

    this.isLoggedIn = function () {
        return fbWrapperObj.isLoggedIn();
    };

    this.getFbid = function () {
        return userObj.getFbid();
    };

    this.getName = function () {
        return userObj.getName();
    };

    this.getAdwallExpName = function () {
        var expName = xpromoConstantsObj.EXP_AD_WALL;
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                break;
            case DTC:
            case XWORD_EXPLORER:
                expName = xpromoConstantsObj.EXP_AD_WALL_NEW;
        }
        return expName;
    };

    this.downloadFileV1 = function (url, saveAs) {
        return;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                utilObj.downloadFileV1(url, saveAs);
                break;
            case DTC:
            case XWORD_EXPLORER:
                utilObj.downloadFileV1(saveAs, url);
                break;
        }
    };

    this.downloadFileV2 = function (url, saveAs) {
        return;
        switch (gameId) {
            case WORD_TRIP:
            case WORD_JAM:
            case WORD_PLANET:
                utilObj.downloadFileV2(url, saveAs);
                break;
            case BLISS:
            case SOLITAIRE:
                utilObj.downloadFileV1(url, saveAs);
                break;
            case DTC:
            case XWORD_EXPLORER:
                utilObj.downloadFileV1(saveAs, url);
                break;
        }
    };

    this.getPuzzleToShow = function () {
        var puzzleToShow;
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                puzzleToShow = xPromoGameSpecificObj.getPuzzleIdForIndex(xPromoGameSpecificObj.getPuzCompleted(), false);
                break;
            case DTC:
            case XWORD_EXPLORER:
                puzzleToShow = gameObj.getCrosswordToShow();
                break;
        }
        return puzzleToShow;
    };

    this.showGameLayer = function (puzzleToShow) {
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                gameLayer.show(puzzleToShow, constantsObj.NOT_FOUND);
                break;
            case DTC:
            case XWORD_EXPLORER:
                gameLayer.show(puzzleToShow, false);
                break;
        }
    };

    this.getSoftLaunchTitleFontSize = function () {
        var fontSize = constantsObj.FONT_SFCOMPACT_MEDIUM_100;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                break;
            case WORD_JAM:
            case WORD_PLANET:
                fontSize = constantsObj.FONT_SFCOMPACT_MEDIUM_80;
                break;
            case DTC:
            case XWORD_EXPLORER:
                break;
        }
        return fontSize;
    };

    this.getGameName = function () {
        var gameName = "Word Trip";
        switch (gameId) {
            case WORD_TRIP:
            case SOLITAIRE:
                gameName = xpromoStringsObj.trip_game_name;
                break;
            case BLISS:
                gameName = xpromoStringsObj.bliss_game_name;
                break;
            case WORD_JAM:
                gameName = xpromoStringsObj.jam_game_name;
                break;
            case WORD_PLANET:
                gameName = xpromoStringsObj.planet_game_name;
                break;
            case DTC:
                gameName = xpromoStringsObj.dtc_game_name;
                break;
            case XWORD_EXPLORER:
                gameName = xpromoStringsObj.xword_explorer_game_name;
                break;
        }
        return gameName;
    };

    this.pulseButtonForXpromoAfterW2e = function (layer, node) {
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                animationObj.pulseButton(node, 0, 0);
                break;

            case DTC:
            case XWORD_EXPLORER:
                animationObj.pulseButton(layer, {"node": node});
                break;
        }
    };

    this.getMinimapRankToBeAnimated = function () {
        var minimapRankToBeAnimated = [];
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                minimapRankToBeAnimated = minimapLayer.getRankToBeAnimated();
                break;
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
                break;
        }
        return minimapRankToBeAnimated;
    };

    this.isBurstHintAnimRunning = function () {
        var burstHintRunning = false;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                burstHintRunning = gameLayer.isBurstHintAnimRunning;
                break;
            case WORD_JAM:
            case WORD_PLANET:
                burstHintRunning = gameLayer.hintAnimRunning;
                break;
            case DTC:
            case XWORD_EXPLORER:
                break;
        }
        return burstHintRunning;
    };

    this.getCoinGrantAnimRunning = function () {
        var result = false;
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                result = gameObj.getCoinGrantAnimRunning();
                break;
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return result;
    };

    this.resetCommonToasterAnimRunning = function () {
        switch (gameId) {
            case WORD_TRIP:
                gameLayer.commonToasterAnimRunning = 0;
                linearProgressionLayer.commonToasterAnimRunning = 0;
                dailySpellingBeeLayer.commonToasterAnimRunning = 0;
                digraphGameLayer.commonToasterAnimRunning = 0;
                digraphLLPLayer.commonToasterAnimRunning = 0;
                break;
            case BLISS:
            case SOLITAIRE:
                gameLayer.commonToasterAnimRunning = 0;
                linearProgressionLayer.commonToasterAnimRunning = 0;
                break;
            case WORD_JAM:
            case WORD_PLANET:
                gameLayer.commonToasterAnimRunning = 0;
                break;
            case DTC:
            case XWORD_EXPLORER:
                break;
        }
    };

    this.useToasterAnimationV2 = function() {
        var result = false;
        switch (gameId) {
            case WORD_JAM:
                result = true;
                break;
            case WORD_PLANET:
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return result;
    };

    this.shouldToasterBeShownForMinimap = function (rankId) {
        var shouldShow = false;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                shouldShow = minimapLayer.shouldToasterBeShown(rankId);
                break;
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
                break;
        }
        return shouldShow;
    };

    this.getRankArticleMap = function () {
        var rankArticleMap = {};
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                rankArticleMap = gameObj.getRankArticleMap();
                break;
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
                break;
        }
        return rankArticleMap;
    };

    this.shouldPlaySoundForToaster = function () {
        var shouldPlay = false;
        switch (gameId) {
            case WORD_TRIP:
                shouldPlay = true;
                break;
            case WORD_JAM:
            case WORD_PLANET:
            case BLISS:
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
                shouldPlay = false;
                break;
        }
        return shouldPlay;
    };

    this.openCurrentIncompletedPuzzle = function () {
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                gameLayer.openCurrentIncompletedPuzzle();
                break;
            case WORD_JAM:
            case WORD_PLANET:
                loggerObj.debugLog("this is open current puzzle");
                var puzToShow = xPromoGameSpecificObj.getPuzzleIdForIndex(xPromoGameSpecificObj.getPuzCompleted(), false);
                gameLayer.show(puzToShow, constantsObj.NOT_FOUND);
                break;
            case DTC:
            case XWORD_EXPLORER:
                break;
        }
    };

    this.areStreakQuestsEnabled = function() {
        var result = false;
        switch (gameId) {
            case WORD_TRIP:
                result = true;
                break;
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return result;
    };

    this.isBubblePopEnabled = function() {
        var result = false;
        switch (gameId) {
            case WORD_TRIP:
            case WORD_JAM:
            case WORD_PLANET:
            case BLISS:
                result = true;
                break;
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return result;
    };

    this.isBubblePopV2Enabled = function() {
        var result = false;
        switch (gameId) {
            case WORD_TRIP:
            case WORD_JAM:
                result = true;
                break;
            case BLISS:
            case SOLITAIRE:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return result;
    };

    this.getBubblePopIAPPackage = function() {
        var result = [];
        switch (gameId) {
            case WORD_TRIP:
                result = paymentsObj.getCashPackages(false, false, true);
                break;
            case WORD_JAM:
                result = paymentsObj.getPspnPackages();
                break;
            case BLISS:
            case SOLITAIRE:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return result;
    };

    this.getBaseCoinsForBubblePopIAP = function() {
        var result = 200;
        switch (gameId) {
            case WORD_TRIP:
                result = 200;
                break;
            case WORD_JAM:
                result = 250;
                break;
            case BLISS:
            case SOLITAIRE:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return result;
    };

    this.getBubblePopIAPPackageNames = function() {
        var result = null;
        switch (gameId) {
            case WORD_TRIP:
                if(utilObj.isAndroid()) {
                    result = constantsObj.android_iap_bubblePop;
                } else if (utilObj.isIos()) {
                    result = xPromoGameSpecificObj.getIAPPackageName(constantsObj.ios_iap_bubblePop);
                }
                break;
            case WORD_JAM:
                result = "in.playsimple.tripcross.pspn_bubblepop";
                break;
            case BLISS:
            case SOLITAIRE:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return result;
    };

    this.getPackagesInfoForBubblePopIAP = function() {
        var result = null;
        switch (gameId) {
            case WORD_TRIP:
                var interim = storeScreenObj.getCoinIAPPackagesInfoSortedByDollarPrice();
                if(interim != null) {
                    result = {};
                    result["packages"] = interim["pkgs"];
                    result["discounts"] = interim["percentMoreInfo"];
                    result["popularIndex"] = interim["most_popular_index"];
                }
                break;
            case WORD_JAM:
                result = storeScreenObj.getIAPInfoForBubblePop();
                break;
            case BLISS:
            case SOLITAIRE:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return result;
    };

    this.getIAPPackageName = function(name) {
        var result = name;
        switch (gameId) {
            case WORD_JAM:
                result = paymentsObj.getPackageName(name);
                break;
            case WORD_TRIP:
                if(utilObj.isIos()) {
                    var splitName = name.split(".");
                    result = splitName[splitName.length - 1];
                }
                break;
            case BLISS:
            case SOLITAIRE:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return result;
    };

    this.isDigraphAvailable = function() {
        var result = false;
        switch (gameId) {
            case WORD_TRIP:
                result = true;
                break;
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return result;
    };

    this.isDailyPuzzleAvailable = function() {
        var result = false;
        switch (gameId) {
            case WORD_TRIP:
                result = (epmObj.getChosenVariant(constantsObj.EXP_SPELLING_BEE) != constantsObj.EXP_VAR_CONTROL) &&
                    (epmObj.getChosenVariant(constantsObj.EXP_SPELLING_BEE_QC) != constantsObj.EXP_VAR_CONTROL);
                break;
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return result;
    };

    this.showQuestNotifOnHomeScreen = function() {
        var result = false;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
                result = true;
                break;
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return result;
    };

    // To enable this for games, ensure their machineLearningData.js is updated and all the tracking info methods
    // are being fired from the game code
    this.isUserInteractionTrackingEnabled = function() {
        var result = false;
        switch (gameId) {
            case WORD_TRIP:
                result = true;
                break;
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return result;
    };

    this.isBubblePopAdditionalRewardEnabled = function(){
      var result = false;
        switch (gameId) {
            case WORD_TRIP:
                result = true;
                break;
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return result;
    };

    this.isGiftBoxEnabled = function() {
        return (gameId == DTC);
    };

    this.isAdWallNewUiEnabled = function() {
        var result = false;
        switch (gameId) {
            case WORD_TRIP:
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case BLISS:
                result = true;
                break;
            case XWORD_EXPLORER:
            case SOLITAIRE:

            default:
                break;
        }
        return result;
    };

    this.isExitXpromoEnabled = function() {
        var result = false;
        switch (gameId) {
            case WORD_TRIP:
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case BLISS:
                result = true;
                break;
            case XWORD_EXPLORER:
            case SOLITAIRE:
            default:
                break;
        }
        return result;
    };

    this.isW2eXpromoSocialEnabled = function() {
        var result = false;
        switch (gameId) {
            case WORD_TRIP:
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case BLISS:
                result = true;
                break;
            case XWORD_EXPLORER:
            case SOLITAIRE:
            default:
                break;
        }
        return result;
    };

    this.isW2eSurfacingOptEnabled = function() {
        var result = false;
        switch (gameId) {
            case WORD_TRIP:
            case WORD_JAM:
            case DTC:
            case BLISS:
            case WORD_PLANET:
                result = true;
                break;
            case XWORD_EXPLORER:
            case SOLITAIRE:
            default:
                break;
        }
        return result;
    };

    this.isW2eXpromoGifsEnabled = function() {
        var result = false;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
                result = true;
                break;
            case WORD_JAM:
            case WORD_PLANET:
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return result;
    };

    this.isRedirectFtueEnabled = function() {
        var result = false;
        switch (gameId) {
            case WORD_JAM:
                result = true;
                break;
            case WORD_TRIP:
            case WORD_PLANET:
            case BLISS:
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return result;
    };

    this.isDQPersonalizationEnabled = function() {
        var result = false;
        switch (gameId) {
            case WORD_TRIP:
                result = questPersonalizationObj.isValidQuestPersonalizationExperiment();
                break;
            case WORD_JAM:
            case WORD_PLANET:
            case BLISS:
            case SOLITAIRE:
            case DTC:
            default:
                break;
        }
        return result;
    };

    this.getRequiredDQProgress = function(questType, questLevel) {
        var result = constantsObj.NOT_FOUND;
        switch (gameId) {
            case WORD_TRIP:
                result = questPersonalizationObj.getDailyQuestTarget(questType, questLevel);
                break;
            case WORD_JAM:
            case WORD_PLANET:
            case BLISS:
            case SOLITAIRE:
            case DTC:
            default:
                break;
        }
        return result;
    };

    this.getDQPayout = function(questType, questLevel) {
        var result = constantsObj.NOT_FOUND;
        switch (gameId) {
            case WORD_TRIP:
                result = questPersonalizationObj.getDailyQuestPayout(questType, questLevel);
                break;
            case WORD_JAM:
            case WORD_PLANET:
            case BLISS:
            case SOLITAIRE:
            case DTC:
            default:
                break;
        }
        return result;
    };

    this.resetDQPersonalizedValues = function() {
        switch (gameId) {
            case WORD_TRIP:
                questPersonalizationObj.resetDailyQuestsTargetDaily();
                break;
            case WORD_JAM:
            case WORD_PLANET:
            case BLISS:
            case SOLITAIRE:
            case DTC:
            default:
                break;
        }
    };

    this.getCash = function () {
        return economyObj.getCash();
    };

    this.addCash = function (c, phylum, trackClass, order) {
        switch (gameId) {
            case WORD_TRIP:
            case WORD_JAM:
            case WORD_PLANET:
            case BLISS:
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
                economyObj.addCash(c, phylum, trackClass, order);
                break;
            default:
                xPromoGameSpecificObj.failedToHandle();
        }
    };

    this.showLayerOnBack = function () {
        switch (gameId) {
            case WORD_TRIP:
            case WORD_JAM:
            case WORD_PLANET:
            case BLISS:
            case SOLITAIRE:
                gameLayer.hide();
                var puzToShow = xPromoGameSpecificObj.getPuzzleToShow();
                xPromoGameSpecificObj.showGameLayer(puzToShow);
                break;
            case DTC:
                homeLayer.show();
                break;
            case XWORD_EXPLORER:
                linearLevelProgression.show();
                break;
        }
    };

    this.shouldUpdateJewelNotif = function () {
        //TODO - Need to fix for the games this should return true, it was always returning false hence keeping it that way atm.
        var result = false;
        switch (gameId) {
            case WORD_TRIP:
            case WORD_JAM:
            case WORD_PLANET:
            case BLISS:
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
                break;
        }
        return result;
    };

    this.showFilledQuestButton = function (val) {
        switch (gameId) {
            case BLISS:
            case WORD_TRIP:
                if(!(gameLayer.ftueShown && ftueObj.FTUE_QUEST_UNLOCK != undefined && gameLayer.ftueShownNum == ftueObj.FTUE_QUEST_UNLOCK)) {
                    var layersToChange = [gameLayer, digraphGameLayer, dailySpellingBeeLayer];
                    var btnColor = (val == true) ? constantsObj.COLOR_BLACK : constantsObj.COLOR_WHITE;
                    for (var i = 0; i < layersToChange.length; i++) {
                        utilObj.setVisible(layersToChange[i].questBtnFill, val);
                        utilObj.setColor(layersToChange[i].questImg, btnColor);
                        layersToChange[i].isQuestBtnFill = val;
                    }
                    if(val == true) {
                        trackObj.trackCounter(constantsObj.TRACK_BUTTON_FILL, "", "", "quest_icon", "", "", gameObj.getTrackingPuzzleInfo(), "", "");
                    }
                }
                break;
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
                break;
            case WORD_JAM:
            case WORD_PLANET:
                gameLayer.checkButtonFillForQuestCenter(val);
                break;
        }
    };

    this.isMusicEnabled = function() {
        var result = false;
        switch(gameId) {
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
                result = gameObj.isMusicEnabled();
                break;
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
                break;
        }
        return result;
    };

    this.isLimitTrackingWithoutAdjustId = function() {
        var result = false;
        switch(gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
                result = utilObj.isLimitTrackingWithoutAdjustId();
                break;
        }
        return result;
    };

    this.getNotifPermissionForIos = function() {
        var result = false;
        switch(gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
                result = gameObj.getNotifPermissionForIos();
                break;
        }
        return result;
    };

    this.getBubbleEffects = function() {
        var result = {};
        switch(gameId) {
            case WORD_TRIP:
            case WORD_JAM:
            case WORD_PLANET:
                result = {
                    "bubble_giftbox_sfx": other_resources_effects.bubble_giftbox_sfx,
                    "bubble_blast": other_resources_effects.bubble_blast,
                    "bubble_sfx": other_resources_effects.bubble_sfx,
                };
                break;
            case BLISS:
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
                result = {
                    "bubble_giftbox_sfx": res.bubble_giftbox_sfx,
                    "bubble_blast": res.bubble_blast,
                    "bubble_sfx": res.bubble_sfx,
                };
                break;
        }
        return result;

    }

    this.getContactBookPermission = function() {
        var result = false;
        switch(gameId) {
            case WORD_TRIP:
                if (utilObj.isNative()) {
                    if (utilObj.isAndroid()) {
                        var pkgPrefix = xpromoUtilObj.getPspnPkgPrefix();
                        result = jsb.reflection.callStaticMethod(pkgPrefix + "XPromoUtil", "CheckForContactsPermission", "()Z");
                    }
                }
                break;
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
                break;
        }
        return result;
    };

    this.getLastPurchaseDate = function() {
        var result = 0;
        switch(gameId) {
            case WORD_TRIP:
            case BLISS:
                result = gameObj.getLastPurchaseDate();
                break;
            case WORD_JAM:
                result = storeScreenObj.getLastPurchaseTime();
                break;
            case WORD_PLANET:
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
                break;
        }
        return result;
    };

    this.getGameScore = function() {
        var result = 0;
        switch(gameId) {
            case WORD_TRIP:
                result = streakObj.getTotalWisdomScore();
                break;
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
                break;
        }
        return result;
    };

    this.getNumFreeHints = function() {
        var result = 0;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
                result = gameObj.getNumFreeHints();
                break;
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
                break;
        }
        return result;
    };

    this.getEventRank = function() {
        var result = -1;
        switch(gameId) {
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
                if(eventsObj.isEligibleForLeaderBoard() && eventsObj.isEventRunning()) {
                    result = eventsObj.getEventRank();
                }
                break;
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
                break;
        }
        return result;
    };

    this.isEventActive = function() {
        var result = false;
        switch(gameId) {
            case WORD_TRIP:
            case BLISS:
            case WORD_JAM:
            case WORD_PLANET:
                result = (eventsObj.isEligibleForLeaderBoard() && !eventsObj.hasEventEnded());
                break;
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
                break;
        }
        return result;
    };

    this.getDailyContentStatus = function() {
        // -1 = Not Applicable, 0 = Not Completed, 1 = Completed
        var result = -1;
        switch (gameId) {
            case WORD_TRIP:
                if (dailySpellingBeeObj.getSpellingBeeFeatureUnlocked()) {
                    result = dailySpellingBeeObj.isPuzzleReadyToPlay() ? 0 : 1;
                }
                break;
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
                break;
        }
        return result;
    };

    this.getTodaysSessionNum = function() {
        return gameObj.getTodaysSessionNum();
    };

    this.getPrevDay = function() {
        return gameObj.getPrevDay();
    };

    this.isVideoWatchedPerHourReached = function (videosWatched) {
        var isVideoWatchedPerHourReached = false;
        switch (gameId) {
            case WORD_TRIP:
                var exp_w2e = epmObj.getChosenVariant(constantsObj.EXP_W2E_COOLDOWN);
                if (exp_w2e == constantsObj.EXP_VAR_CONTROL) {
                    isVideoWatchedPerHourReached = xPromoGameSpecificObj.getW2EPerHour() != 1 && videosWatched < xPromoGameSpecificObj.getW2EPerHour();
                } else {
                    isVideoWatchedPerHourReached = w2eCooldownObj.shouldShowVideo();
                }
                break;
            case BLISS:
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
            case WORD_JAM:
            case WORD_PLANET:
                isVideoWatchedPerHourReached = xPromoGameSpecificObj.getW2EPerHour() != 1 && videosWatched < xPromoGameSpecificObj.getW2EPerHour();
                break;
        }
        return isVideoWatchedPerHourReached;
    };

    this.getLayerForCoinGrantAnimation = function (updatingToScreenNumber) {
        var layerForAnimation = gameLayer;
        switch (gameId) {
            case WORD_TRIP:
                switch (updatingToScreenNumber) {
                    case constantsObj.SCREEN_DIGRAPH_GAME:
                        layerForAnimation = digraphGameLayer;
                        break;
                    case constantsObj.SCREEN_SPELLING_BEE:
                        layerForAnimation = dailySpellingBeeLayer;
                        break;
                    default:
                        layerForAnimation = gameLayer;
                }
            case BLISS:
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
            case WORD_JAM:
            case WORD_PLANET:
                break;
        }
        return layerForAnimation;
    };

    this.isScreenForW2eXpromo = function (screenNo) {
        var isScreenForW2eXpromo = false;
        switch (gameId) {
            case WORD_TRIP:
                isScreenForW2eXpromo = (screenNo == constantsObj.SCREEN_GAME || screenNo == constantsObj.SCREEN_DIGRAPH_GAME || screenNo == constantsObj.SCREEN_SPELLING_BEE);
                break;
            case BLISS:
            case SOLITAIRE:
            case WORD_JAM:
            case WORD_PLANET:
                isScreenForW2eXpromo = (screenNo == constantsObj.SCREEN_GAME);
                break;
            case DTC:
            case XWORD_EXPLORER:
                isScreenForW2eXpromo = constantsObj.SCREENS_TO_SHOW_XPROMO_W2E.indexOf(screenNo) >= 0;
                break;
                break;
        }
        return isScreenForW2eXpromo;
    };

    this.checkScreenIsW2E = function (screenNo) {
        var result = false;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
                result = (screenNo == constantsObj.SCREEN_W2E_COIN_GRANT);
                break;
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
                break;
            case WORD_JAM:
            case WORD_PLANET:
                result = (screenNo == constantsObj.SCREEN_W2E_INFO || screenNo == constantsObj.SCREEN_EARN_COINS);
                break;
        }
        return result;
    };

    this.customW2EConditions = function () {
        var result = true;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                break;
            case DTC:
            case XWORD_EXPLORER:
                result = (curScreen != constantsObj.SCREEN_STORE_LAYER);
                break;
            case WORD_JAM:
            case WORD_PLANET:
                var allowedScreens = [constantsObj.SCREEN_STORE_LAYER, constantsObj.SCREEN_NEW_STORE_LAYER, constantsObj.SCREEN_NEW_STORE_LAYER_V2, constantsObj.SCREEN_QUEST_CENTER, constantsObj.SCREEN_SPINNER, constantsObj.SCREEN_OOC_VIDEO, constantsObj.SCREEN_OOC_OFFERWALL, constantsObj.SCREEN_EARN_COINS];
                result = !(updatingToScreen == constantsObj.SCREEN_W2E_INFO && allowedScreens.indexOf(lastScreen) >= 0);
                break;
        }
        return result;
    };

    this.isW2eCoolDownImplemented = function () {
        var isW2eCoolDownImplemented = false;
        switch (gameId) {
            case WORD_TRIP:
                isW2eCoolDownImplemented = epmObj.getChosenVariant(constantsObj.EXP_W2E_COOLDOWN) != constantsObj.EXP_VAR_CONTROL;
                break;
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
            case BLISS:
            case SOLITAIRE:
                isW2eCoolDownImplemented = false;
                break;
        }
        return isW2eCoolDownImplemented;

    };

    this.shouldShowQuestToaster = function () {
        var shouldShowQuestToaster = false;
        switch (gameId) {
            case WORD_TRIP:
            case WORD_JAM:
            case WORD_PLANET:
            case BLISS:
            case SOLITAIRE:
                shouldShowQuestToaster = true;
                break;
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return shouldShowQuestToaster;
    };

    this.shouldShowQuestAnimation = function () {
        var shouldShowQuestAnimation = false;
        switch (gameId) {
            case WORD_TRIP:
            case WORD_JAM:
            case WORD_PLANET:
            case BLISS:
            case SOLITAIRE:
                shouldShowQuestAnimation = true;
                break;
            case DTC:
            case XWORD_EXPLORER:
            default:
                break;
        }
        return shouldShowQuestAnimation;

    };

    this.onExitGameFromPopup = function () {
        switch (gameId) {
            case WORD_TRIP:
                gameObj.setNextCountryName();
                gameObj.save();
                trackObj.save();
                userObj.save();
                break;
            case WORD_PLANET:
            case WORD_JAM:
                gameObj.save();
                trackObj.save();
                userObj.save();
                break;
            case DTC:
            case XWORD_EXPLORER:
                gameObj.setLastPlayedTimeStamp(utilObj.getCurrentTimestamp());
                popupLayer.closeWithDefault();
                gameObj.setExistingUser();
                break;
            case BLISS:
            case SOLITAIRE:
                break;
        }
    };

    this.fireEarnTracking = function (isSpin, earnSource, earnItem, newBalance, changedBalance, species, isSuccessful) {
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
                economyObj.fireEarnTracking(isSpin, earnSource, earnItem, newBalance, changedBalance, species, isSuccessful);
                break;
            case WORD_TRIP:
            case DTC:
            case XWORD_EXPLORER:
            case BLISS:
            case SOLITAIRE:
            default:
                break;
        }
    };

    this.getCashEquivalent = function () {
        var result = 0;
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
                result = economyObj.getCashEquivalent();
                break;
            case WORD_TRIP:
            case DTC:
            case XWORD_EXPLORER:
            case BLISS:
            case SOLITAIRE:
                result = xPromoGameSpecificObj.getCash();
                break;
            default:
                break;
        }
        return result;
    };

    this.isQuestCenterUnlocked = function() {
        var result = true;
        switch (gameId) {
            case WORD_TRIP:
                if(typeof nuxObj !== "undefined") {
                    result = nuxObj.checkAndValidateQuestCenterUnlockState();
                }
                break;
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
            case BLISS:
            case SOLITAIRE:
            default:
                break;
        }
        return result;
    };

    this.isSpinnerUnlocked = function(questType) {
        var result = true;
        switch (gameId) {
            case WORD_TRIP:
                if(typeof nuxObj !== "undefined") {
                    result = nuxObj.checkAndValidateSpinnerUnlockState();
                }
                break;
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
            case BLISS:
            case SOLITAIRE:
            default:
                break;
        }
        return result;
    };

    this.isAudioQuestEnabled = function() {
        var result = true;
        switch (gameId) {
            case WORD_JAM:
                result = (epmObj.getChosenVariant(constantsObj.EXP_DICTIONARY_AUDIO) != constantsObj.EXP_VAR_CONTROL);
                break;
            case WORD_TRIP:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
            case BLISS:
            case SOLITAIRE:
            default:
                break;
        }
        return result;
    };

    this.isSettingsLayerEnabled = function() {
        var result = false;
        switch(gameId) {
            case WORD_JAM:
            case WORD_PLANET:
            case WORD_TRIP:
            case BLISS:
                result = true;
                break;
            case DTC:
            case XWORD_EXPLORER:
            case SOLITAIRE:
            default:
                break;
        }
        return result;
    };

    this.getColorOfQuestButton = function () {
        var btnColor = constantsObj.COLOR_BUTTON_BLUE_02;
        switch (gameId) {
            case WORD_TRIP:
            case WORD_JAM:
                break;
            case BLISS:
                btnColor = constantsObj.COLOR_BUTTON_BLUE_03;
                break;
        }
        return btnColor;
    };

    this.redrawScreenForXpromoQuest = function() {
        switch(gameId) {
            case WORD_JAM:
            case WORD_PLANET:
            case WORD_TRIP:
            case BLISS:
            case SOLITAIRE:
                if (curLayer == questCenterLayer && utilObj.isFunction(curLayer.redrawOnResume)) {
                    utilObj.delayedCallback(curLayer, curLayer.redrawOnResume, 0.2, null, false);
                }
                break;
            case DTC:
                if(curLayer == achievementsLayer && utilObj.isFunction(curLayer.redraw)) {
                    utilObj.delayedCallback(curLayer, curLayer.redraw, 0.3, null, false);
                }
                break;
            case XWORD_EXPLORER: // TODO - Handle this flow when QC is added to xword explorer
            default:
                break;
        }
    };

    this.questActionOpenStoreScreen = function(errorMessage) {
        switch(gameId) {
            case WORD_TRIP:
            case BLISS:
                gameObj.showStoreScreen();
                questCenterLayer.hide();
                gameObj.setStoreLastScreen(constantsObj.SCREEN_QUEST_CENTER);
                break;
            case WORD_JAM:
            case WORD_PLANET:
                questCenterLayer.hide();
                gameObj.showStoreScreen(constantsObj.SCREEN_QUEST_CENTER);
                break;
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
                if(errorMessage != undefined && errorMessage != "") {
                    utilObj.showMessage(errorMessage);
                }
                break;
            default:
                break;
        }
    };

    this.questActionOpenProfileAvatar = function (questData) {
        var questType = questData.qt, questId = questData.questId, shouldPlayTapSound = true;
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(),
            xpromoConstantsObj.TRACK_QUEST_CENTER, questType + "", questId + "", constantsObj.TRACK_CLICK, "", "");
        questCenterLayer.hide();

        switch (gameId) {
            case WORD_TRIP:
                avatarObj.setAvatarPrevScreen(constantsObj.SCREEN_QUEST_CENTER);
                profileBgLayer.show();
                avatarLayer.show(false);
                break;
            case BLISS:
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
            case WORD_JAM:
            case WORD_PLANET:
                break;
        }

        return shouldPlayTapSound;
    };

    this.questActionStarWords = function (questData) {
        var questType = questData.qt, questId = questData.questId, shouldPlayTapSound = true;
        var popupView = (questData.popupView != undefined && questData.popupView == true);
        var questSource = (popupView) ? xpromoConstantsObj.TRACK_DAILY_QUEST : xpromoConstantsObj.TRACK_QUEST_CENTER;
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(),
            questSource, questsObj.getDailyQuestTrackingStr(questId), questId + "", constantsObj.TRACK_CLICK, "", "");
        questCenterLayer.hide();
        questCenterLayer.openGameLayer(questType);
        if(!popupView && questData.description != undefined) { // Showing message only if in QC view
            utilObj.showMessage(questData.description);
        }

        return shouldPlayTapSound;
    };

    this.questActionSpins = function (questData) {
        var questType = questData.qt, questId = questData.questId, shouldPlayTapSound = true;
        var questSource = (questData.popupView != undefined && questData.popupView == true) ? xpromoConstantsObj.TRACK_DAILY_QUEST : xpromoConstantsObj.TRACK_QUEST_CENTER;
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(),
            questSource, questsObj.getDailyQuestTrackingStr(questId), questId + "", constantsObj.TRACK_CLICK, "", "");
        var shouldPlayTapSound = false;
        questCenterLayer.isPopupOpenedFromQuestCenter = true;
        questCenterLayer.hide();

        if (xPromoGameSpecificObj.isDailyPuzzleAvailable() && lastScreen == constantsObj.SCREEN_SPELLING_BEE && utilObj.isFunction(lastLayer.redraw)) {
            lastLayer.redraw();
        } else {
            questCenterLayer.openGameLayer();
        }

        spinnerPopup.show();
        return shouldPlayTapSound;
    };

    this.questActionVIPPuzzle = function (questData) {
        var questType = questData.qt, questId = questData.questId, shouldPlayTapSound = true;
        var questSource = (questData.popupView != undefined && questData.popupView == true) ? xpromoConstantsObj.TRACK_DAILY_QUEST : xpromoConstantsObj.TRACK_QUEST_CENTER;
        questCenterLayer.hide();

        if(xPromoGameSpecificObj.isDigraphAvailable()) {
            if (digraphGameLayer.puzzleIndex == undefined) {
                digraphGameLayer.puzzleIndex = subDigraphObj.getCurWeekPuzProgress() - 1;
                digraphGameLayer.show(subDigraphObj.puzzleDataForCurWeek(digraphGameLayer.puzzleIndex));
            } else {
                digraphGameLayer.redraw();
            }
        } else {
            questCenterLayer.openGameLayer();
        }
    };

    this.questActionDailyPuzzle = function() {
        var result = false;
        switch (gameId) {
            case WORD_JAM:
            case WORD_PLANET:
                if (!dailyPuzzleObj.isDailyPuzzleFeatureUnlocked()) {
                    var puzzleLeftToUnlockDailyPuzzle = dailyPuzzleObj.getPuzzlesLeftToUnlockDailyPuzzle();
                    var message = stringsObj.complete_levels_to_unlock;
                    if (puzzleLeftToUnlockDailyPuzzle == 1) {
                        message = stringsObj.complete_level_to_unlock;
                    }
                    message = message.replace("%N%", puzzleLeftToUnlockDailyPuzzle);
                    utilObj.showMessage(message);
                    return;
                }

                ftueObj.checkAndIncCompleted();
                if (utilObj.isNodeValid(curLayer)) {
                    curLayer.hide();
                }

                if (dailyPuzzleObj.isFtueDailyPuzzle()) {
                    dailyPuzzleObj.checkAndShowDailyPuzzleScreen();
                } else {
                    if (utilObj.isNodeValid(curLayer)) {
                        dailyPuzzleObj.setCollectionScreenLastLayer(curLayer);
                    }
                    collectionScreenLayer.show();
                }
                result = true;
                break;
            case WORD_TRIP:
            case DTC:
            case XWORD_EXPLORER:
            case BLISS:
            case SOLITAIRE:
            default:
                break;
        }
        return result;
    };

    this.questActionSpinnerLocked = function(questType) {
        var result = false;
        switch(gameId) {
            case WORD_TRIP:
                if(typeof nuxObj !== "undefined") {
                    layerObj.handleSpinnerForLockedState();
                }
                break;
            case WORD_JAM:
            case WORD_PLANET:
            case DTC:
            case XWORD_EXPLORER:
            case BLISS:
            case SOLITAIRE:
            default:
                break;
        }
        return result;
    };

    this.questActionWatchVideos = function (questData) {
        var questType = questData.qt, questId = questData.questId, shouldPlayTapSound = true;
        if (questType == xpromoConstantsObj.QUEST_TYPE_DAILY_QUESTS_WATCH_TO_EARN || questType == xpromoConstantsObj.QUEST_TYPE_STREAK_QUESTS_VIDEOS) {
            var questSource = (questData.popupView != undefined && questData.popupView == true) ? xpromoConstantsObj.TRACK_DAILY_QUEST : xpromoConstantsObj.TRACK_QUEST_CENTER;
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, xPromoGameSpecificObj.getPhylumForTracking(), xPromoGameSpecificObj.getClassForTracking(),
                questSource, questsObj.getDailyQuestTrackingStr(questId), questId + "", constantsObj.TRACK_CLICK, "", "");
        }
        var w2eCooldown = xPromoGameSpecificObj.isW2eCoolDownImplemented();
        if (!xPromoGameSpecificObj.checkRewardedVideo(false) && !w2eCooldown) {
            utilObj.showMessage(stringsObj.video_not_available);
            return shouldPlayTapSound;
        } else {
            if (!utilObj.isOnline()) {
                utilObj.showMessage(stringsObj.not_online);
                return shouldPlayTapSound;
            }
            if (!w2eCooldown) {
                if (xPromoGameSpecificObj.getW2ELimitReached()) {
                    machineLearningDataObj.setVideoTriesCooldown();
                    utilObj.showMessage(stringsObj.more_videos + " " + utilObj.formatTime(xPromoGameSpecificObj.getNextVideoIn()));
                    return shouldPlayTapSound;
                }
                if (!xPromoGameSpecificObj.checkRewardedVideo(false)) {
                    utilObj.showMessage(stringsObj.video_not_available);
                    return shouldPlayTapSound;
                }
                if(curScreen == constantsObj.SCREEN_QUEST_CENTER) {
                    questCenterLayer.watchToVideoFromQuest = 1;
                }
                if (xPromoGameSpecificObj.getW2EDisabled()) {
                    xPromoGameSpecificObj.showVideoAd();
                    //xPromoGameSpecificObj.showRewardedVideo();
                } else {
                    shouldPlayTapSound = false;
                    w2eInfoPopup.show(true);
                }
            } else {
                var fromQC = (curScreen == constantsObj.SCREEN_QUEST_CENTER);
                shouldPlayTapSound = w2eCooldownObj.watchToEarnVideo(fromQC);
            }
        }
        return shouldPlayTapSound;
    };

    this.questActionPuzzleClears = function (questData) {
        var questType = questData.qt, questId = questData.questId, shouldPlayTapSound = true;
        var popupView = (questData.popupView != undefined && questData.popupView == true);
        var questSource = (popupView) ? xpromoConstantsObj.TRACK_DAILY_QUEST : xpromoConstantsObj.TRACK_QUEST_CENTER;
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getTrackingBucketId(), gameObj.getTrackingPuzId(),
            questSource, questsObj.getDailyQuestTrackingStr(questId), questId + "", constantsObj.TRACK_CLICK, "", "");
        questCenterLayer.hide();
        questCenterLayer.openGameLayer(questType);
        if(!popupView && questData.description != undefined) { // Showing message only if in QC view
            utilObj.showMessage(questData.description);
        }

        return shouldPlayTapSound;
    };

    this.questActionBonusClaims = function (questData) {
        var questType = questData.qt, questId = questData.questId, shouldPlayTapSound = true;
        var questSource = (questData.popupView != undefined && questData.popupView == true) ? xpromoConstantsObj.TRACK_DAILY_QUEST : xpromoConstantsObj.TRACK_QUEST_CENTER;
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, gameObj.getTrackingBucketId(), gameObj.getTrackingPuzId(),
            questSource, questsObj.getDailyQuestTrackingStr(questId), questId + "", constantsObj.TRACK_CLICK, "", "");
        questCenterLayer.hide();
        if (bonusWordsObj.isBonusJarFull() && bonusWordsObj.isBonusClaimUnlocked()) {
            ftueObj.setFtueShownNum(ftueObj.FTUE_BONUS_SCREEN);
        }
        gameLayer.show();
        return shouldPlayTapSound;
    };

    this.shouldCheckForQuestCompleteOnPopupSurfacing = function () {
        var pspnXpromoW2eExp = epmObj.getChosenVariant(xpromoConstantsObj.EXP_PSPN_XPROMO_W2E);
        return (bubblePopObj.isBubblePopActive() || bubblePopNewObj.isBubblePopActive() || pspnXpromoW2eExp == constantsObj.EXP_VAR_2 || pspnXpromoW2eExp == constantsObj.EXP_VAR_3) && gameLayer.xpromoAfterW2eChecksDone == 0;
    };

    this.grantCoinsAfterDelay = function (sender, params) {
        var success = economyObj.addCash(params.cashToGrant, params.phylum, params.class, params.order, params.shouldShowToasterMessage);
        if(params.shouldTrack == undefined || params.shouldTrack == true) {
            xPromoGameSpecificObj.fireEarnTracking(false, params.class, constantsObj.TRACK_COINS, xPromoGameSpecificObj.getCashEquivalent() + "", params.cashToGrant + "", "", success);
        }

    };

    this.canShowBubblePopAnimationOnLayer = function () {
        var result = false;
        switch (gameId) {
            case WORD_TRIP:
            case BLISS:
                result = curLayer == gameLayer || curLayer == digraphGameLayer || curLayer == dailySpellingBeeLayer || ((lastLayer == gameLayer || lastLayer == digraphGameLayer || lastLayer == dailySpellingBeeLayer) && (curLayer == popupLayer || curLayer == settingsLayer));
                break;
            case SOLITAIRE:
            case DTC:
            case XWORD_EXPLORER:
                break;
            case WORD_JAM:
            case WORD_PLANET:
                result = curLayer == gameLayer || ((lastLayer == gameLayer) && (curLayer == popupLayer || curLayer == settingsLayer));
                break;
        }
        return result;
    };


    this.isDailyQuestReplacementEnabled = function(){
      var result = false;
      switch (gameId){
          case WORD_TRIP:
              result = true;
              break;
          case BLISS:
          case SOLITAIRE:
          case DTC:
          case WORD_JAM:
          case WORD_PLANET:
              break
      }
      return result;
    };

    this.getDQreplacementValue = function(){
        var value = 150;
        switch (gameId){
            case WORD_TRIP:
                value = parseInt(xpromoQuestRuntimesObj.getRuntime(xpromoConstantsObj.RUNTIME_DAILY_QUEST_REPLACEMENT_REWARD));
                break;
            case BLISS:
            case SOLITAIRE:
            case DTC:
            case WORD_JAM:
            case WORD_PLANET:
                break
        }
        return value;
    };

    // TODO - Figure out a better way to do this. Probably as a field in adwall quests itself?
    this.getAmazonAvailableGames = function() {
        return [WORD_TREK, DTC, WORD_TRIP, WORD_JAM, GUESSUP];
    };

    this.failedToHandle = function () {
        loggerObj.debugLog("failedToHandle - some xPromoGameSpecific method is unhandled for this game.");
    };

};
