/**
 * this is the ftue final outro trans layer which will be called in 2 scenarios : level 1 and level 2 time outs.
 * This looks like a layer but it is a function in a separate file.
 * it does not exhibit any properties of a layer.
 */

BlitzFtueOutro = function () {

    // array which will have all the sprites to remove
    var spritesToRemove = [];
    var transBg = null;

    /**
     * this will work similar to the layer hide functions
     * it will remove all the elements on the screen pushed to arr spritesToRemove
     */
    this.hide = function () {
        zenModeObj.setTransLayerOpen(false);
        for (var i in spritesToRemove) {
            if (utilObj.isNodeValid(spritesToRemove[i])) {
                utilObj.removeChild(curLayer, spritesToRemove[i]);
            }
        }
        spritesToRemove = [];
    };

    /**
     * here all the elements will be shown on the screen, all the elements will have the parentLayer as currentScreen
     */
    this.show = function () {
        //utilObj.playSound(constantsObj.BLITZ_OUTRO_SOUND, false);

        trackObj.trackCounter(constantsObj.TRACK_DIALOG, zenModeObj.getBlitzPuzzleTracking(), zenModeObj.getBlitzPuzzleTheme(), constantsObj.TRACK_BLITZ_OUTRO, constantsObj.TRACK_VIEW, zenModeObj.getCurrentLevel(), zenModeObj.getLivesCount(), "", "");

        zenModeObj.setStartAfterPopup(true);
        zenModeObj.setTransLayerOpen(true);
        zenModeObj.setSoundPlayed(false);

        var zOrder = constantsObj.FTUE_Z_ORDER;
        utilObj.hideBannerAd(utilObj.getScreenName(constantsObj.SCREEN_ZEN_MODE));

        // background which is same for every levels
        // trans bg for the background
        transBg = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, 0, 0.5, 0, canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset);
        utilObj.setColor(transBg, constantsObj.COLOR_BLACK);
        utilObj.setOpacity(transBg, constantsObj.OPACITY_80);
        utilObj.addChild(curLayer, transBg, zOrder);
        spritesToRemove.push(transBg);

        // trans button to prevent background screen checks
        var transBtn = utilObj.getButton(canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset, 0.5, 0, centerXPos, 0,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'blitzFtueOutro',
                fn: 'preventBackgroundScreenTouch',
                screen: zenModeLayer.screen,
                params : {sound : false},
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(curLayer, transBtn, zOrder);
        spritesToRemove.push(transBtn);


        blitzFtueOutro.showFtueOutro();

    };

    /**
     * this is the UI screen for quit option which will provide 2 options either to quit or resume.
     * Timer in the background will keep running in case of quit screen hit.
     */
    this.showFtueOutro = function () {

        //arrays which will have all the sprites and labels to show.
        var spriteArr = [];
        var labelArr = [];
        var zOrder = constantsObj.FTUE_Z_ORDER;

        var blackBg = utilObj.getScale9Sprite(constantsObj.tile_white, xLeftPos, centerYPos, 0, 0.5, canvasWidth, 900, spriteArr, zenModeLayer, zOrder, constantsObj.BOTTOM_BAR_OFFSET1);
        utilObj.setColor(blackBg, constantsObj.COLOR_WHITE);
        spritesToRemove.push(blackBg);

        var deviceHeightRatio = (constantsObj.DESIGN_HEIGHT + topBarOffset) / 2560;
        var deviceWidthRatio = canvasWidth / 1440;
        var xPos = blackBg.getContentSize().width / 2;
        var yPos = blackBg.getContentSize().height;

        //close btn

        var back_btn = utilObj.getSprite(constantsObj.close_icon2, xRightPos - (30 * deviceWidthRatio), centerYPos + 550 + (52 * deviceHeightRatio), 1, 1, constantsObj.SCALE_SPRITE_6);
        utilObj.setColor(back_btn, constantsObj.COLOR_WHITE);
        utilObj.setOpacity(back_btn , constantsObj.OPACITY_80);
        utilObj.addChild(zenModeLayer, back_btn, zOrder + 1);
        spritesToRemove.push(back_btn);

        var closeBtn = utilObj.getButton(100 * deviceWidthRatio, 100 * deviceHeightRatio, 1, 1, xRightPos - (30 * deviceWidthRatio), centerYPos + 550 + (36 * deviceHeightRatio),
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'blitzFtueOutro',
                fn: 'close',
                screen: zenModeLayer.screen
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(zenModeLayer, closeBtn, zOrder);
        spritesToRemove.push(closeBtn);


        yPos -= 53;

        var outOfTime = utilObj.getBMFontLabel("Out of Time!", constantsObj.FONT_HELVETICA_MEDIUM_110, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, blackBg, zOrder);
        utilObj.setOpacity(outOfTime, constantsObj.OPACITY_90);
        spritesToRemove.push(outOfTime);


        yPos -= 323;

        var soCloseMessage = utilObj.getBMFontLabel("Good run,\n give it another shot!", constantsObj.FONT_HELVETICA_75, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, blackBg, zOrder);
        utilObj.setOpacity(soCloseMessage, constantsObj.OPACITY_90);
        spritesToRemove.push(soCloseMessage);



        yPos -= 273;
        var puzzleTracking = zenModeObj.getBlitzPuzzleTracking();
        var puzzleTheme = zenModeObj.getBlitzPuzzleTheme();

        var xPositionForRetryBtn = xPos;

        //retry btn
        var retryButton = utilObj.getButton(520, 160, 0.5, 1.0, xPositionForRetryBtn, yPos,
            constantsObj.newButton_cutup, constantsObj.newButton_cutup, constantsObj.newButton_cutup, {
                obj: 'blitzFtueOutro',
                fn: 'playZenModeAgain',
                screen: zenModeLayer.screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: puzzleTracking,
                    c: puzzleTheme,
                    o: "",
                    f: "",
                    g: "",
                    s: "",
                    co: "",
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.setColor(retryButton, constantsObj.COLOR_GREEN_11);
        utilObj.addChild(blackBg, retryButton, zOrder);
        utilObj.pulseButton(retryButton, 34, 0);
        var retryText = "Retry";
        spritesToRemove.push(retryButton);

        var retryButtonTxt = utilObj.getBMFontLabel(retryText, constantsObj.FONT_ROBOTO_BOLD_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), 255, 80, 0.5, 0.5, labelArr, retryButton, zOrder);
        utilObj.pulseButton(retryButtonTxt, 35, 0);
        spritesToRemove.push(retryButtonTxt);


        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);


    };

    /**
     * starts the zen mode again with new session.
     */
    this.playZenModeAgain = function () {
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, zenModeObj.getBlitzPuzzleTracking(), zenModeObj.getBlitzPuzzleTheme(), constantsObj.TRACK_BLITZ_OUTRO, constantsObj.TRACK_BLITZ_RETRY, zenModeObj.getCurrentLevel(), zenModeObj.getLivesCount(), "", "");

        utilObj.showBannerAd(utilObj.getScreenName(constantsObj.SCREEN_ZEN_MODE));
        blitzFtueOutro.hide();
        zenModeLayer.hide();
        zenModeLayer.loadBlitzMode();
    };


    /**
     * returns to back to the home
     */
    this.close = function () {
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, zenModeObj.getBlitzPuzzleTracking(), zenModeObj.getBlitzPuzzleTheme(), constantsObj.TRACK_BLITZ_OUTRO, constantsObj.TRACK_BACK, zenModeObj.getCurrentLevel(), zenModeObj.getLivesCount(), "", "");

        zenModeObj.setBlitzModeOn(false);
        zenModeObj.setStartAfterPopup(false);
        blitzFtueOutro.hide();
        zenModeLayer.hide();
        homeLayer.show();
    };

    // function to do nothing
    this.preventBackgroundScreenTouch = function () {
        // do nothing -> rest here xD
    };

};

