/**
 * this is the quit trans layer which will be called in 2 scenarios : device back button and blitz gamelayer back btn.
 * This looks like a layer but it is a function in a separate file.
 * it does not exhibit any properties of a layer.
 */

BlitzQuit = function () {

    // array which will have all the sprites to remove
    var spritesToRemove = [];
    var transBg = null;

    /**
     * this will work similar to the layer hide functions
     * it will remove all the elements on the screen pushed to arr spritesToRemove
     */
    this.hide = function () {
        for (var i in spritesToRemove) {
            if (utilObj.isNodeValid(spritesToRemove[i])) {
                utilObj.removeChild(curLayer, spritesToRemove[i]);
            }
        }
        spritesToRemove = [];
    };

    /**
     * here all the elements will be shown on the screen, all the elements will have the parentLayer as currentScreen
     */
    this.show = function () {
       zenModeObj.setQuitScreenOpen(true);
        var zOrder = constantsObj.FTUE_Z_ORDER;
        utilObj.hideBannerAd(utilObj.getScreenName(constantsObj.SCREEN_ZEN_MODE));

        // background which is same for every levels
        // trans bg for the background
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, zenModeObj.getBlitzPuzzleTracking(), zenModeObj.getBlitzPuzzleTheme(), constantsObj.TRACK_BLITZ_BACK1, constantsObj.TRACK_VIEW, zenModeObj.getCurrentLevel(), "", "", "");

        transBg = utilObj.getScale9Sprite(constantsObj.tile_white, centerXPos, 0, 0.5, 0, canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset);
        utilObj.setColor(transBg, constantsObj.COLOR_BLACK);
        utilObj.setOpacity(transBg, constantsObj.OPACITY_80);
        utilObj.addChild(curLayer, transBg, zOrder);
        spritesToRemove.push(transBg);

        // trans button to prevent background screen checks
        var transBtn = utilObj.getButton(canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset, 0.5, 0, centerXPos, 0,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'blitzFtueIntro',
                fn: 'preventBackgroundScreenTouch',
                screen: zenModeLayer.screen,
                params : {sound : false},
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(curLayer, transBtn, zOrder);
        spritesToRemove.push(transBtn);


        blitzQuit.showQuitScreen();

    };

    /**
     * this is the UI screen for quit option which will provide 2 options either to quit or resume.
     * Timer in the background will keep running in case of quit screen hit.
     */
    this.showQuitScreen = function () {

        //arrays which will have all the sprites and labels to show.
        var spriteArr = [];
        var labelArr = [];
        var zOrder = constantsObj.FTUE_Z_ORDER;

        var blackBg = utilObj.getScale9Sprite(constantsObj.tile_white, xLeftPos, centerYPos, 0, 0.5, canvasWidth, 900, spriteArr, curLayer, zOrder, constantsObj.BOTTOM_BAR_OFFSET1);
        utilObj.setColor(blackBg, constantsObj.COLOR_WHITE);
        spritesToRemove.push(blackBg);

        var xPos = blackBg.getContentSize().width / 2;
        var yPos = blackBg.getContentSize().height;


        yPos -= 53;

        var quitBlitz = utilObj.getBMFontLabel("Stop Blitz-ing?", constantsObj.FONT_HELVETICA_MEDIUM_110, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, blackBg, zOrder);
        utilObj.setOpacity(quitBlitz, constantsObj.OPACITY_90);
        spritesToRemove.push(quitBlitz);


        yPos -= 268;
        var currentLevel = zenModeObj.getCurrentLevel();
        var text = "You will lose your progress on this round!";
        if(currentLevel > 2){
             text = "You will lose a Life,\nand your progress on this round!";
        }
        var loseLifeMessage = utilObj.getBMFontLabel(text, constantsObj.FONT_HELVETICA_75, constantsObj.COLOR_BLACK,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, blackBg, zOrder);
        utilObj.setOpacity(loseLifeMessage, constantsObj.OPACITY_90);
        zenModeLayer.elementsToRemove.push(loseLifeMessage);


        yPos -= 310;
        var puzzleTracking = zenModeObj.getBlitzPuzzleTracking();
        var puzzleTheme = zenModeObj.getBlitzPuzzleTheme();

        //leave or quit button
        var xPositionForUseCoinBtn = xPos - 319;

        var leaveButton = utilObj.getButton(520, 160, 0.5, 1.0, xPositionForUseCoinBtn, yPos,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'blitzQuit',
                fn: 'close',
                screen: zenModeLayer.screen,
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(blackBg, leaveButton, zOrder);
        var leaveText = "Leave";
        spritesToRemove.push(leaveButton);

        var leaveButtonTxt = utilObj.getBMFontLabel(leaveText, constantsObj.FONT_HELVETICA_MEDIUM_80, constantsObj.COLOR_BACK_2,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), 188, 80, 0.5, 0.5, labelArr, leaveButton, zOrder);
        spritesToRemove.push(leaveButtonTxt);

        var outline = utilObj.getScale9Sprite(constantsObj.button_outline, xPositionForUseCoinBtn, yPos, 0.5, 1.0, 520, 160, spriteArr, blackBg, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setColor(outline, constantsObj.COLOR_BACK_2);

       if(zenModeObj.getCurrentLevel() > 2){
           var leftHeart = utilObj.getSprite(constantsObj.blitz_heart_l, 367, 80, 0, 0.5, constantsObj.SCALE_SPRITE_7, spriteArr, leaveButton, zOrder, constantsObj.SPRITE_MISC);
           var rightHeart = utilObj.getSprite(constantsObj.blitz_heart_r, 409, 80, 0, 0.5, constantsObj.SCALE_SPRITE_7, spriteArr, leaveButton, zOrder, constantsObj.SPRITE_MISC);
           spritesToRemove.push(leftHeart);
           spritesToRemove.push(rightHeart);
       }else {
           utilObj.setPositionX(leaveButtonTxt , leaveButton.getContentSize().width/2);
       }


        //resume button
        var xPositionForResumeBtn = xPos + 319;

        var resumeButton = utilObj.getButton(520, 160, 0.5, 1.0, xPositionForResumeBtn, yPos,
            constantsObj.newButton_cutup, constantsObj.newButton_cutup, constantsObj.newButton_cutup, {
                obj: 'blitzQuit',
                fn: 'playZenModeAgain',
                screen: zenModeLayer.screen,
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.setColor(resumeButton, constantsObj.COLOR_GREEN_11);
        utilObj.addChild(blackBg, resumeButton, zOrder);
        var resumeText = "Resume";
        spritesToRemove.push(resumeButton);

        var resumeButtonTxt = utilObj.getBMFontLabel(resumeText, constantsObj.FONT_HELVETICA_MEDIUM_80, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_CENTER, cc.p(0, 0), 255, 80, 0.5, 0.5, labelArr, resumeButton, zOrder);
        spritesToRemove.push(resumeButtonTxt);


        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);

    };

    /**
     * starts the zen mode again with same progress.
     */
    this.playZenModeAgain = function () {
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, zenModeObj.getBlitzPuzzleTracking(), zenModeObj.getBlitzPuzzleTheme(), constantsObj.TRACK_BLITZ_BACK1, constantsObj.TRACK_BLITZ_RESUME, zenModeObj.getCurrentLevel(), "", "", "");

        if(zenModeObj.getCurrentBufferTime() <= 0){
            blitzQuit.hide();
            blitzQuit.timerZero();
        }
        zenModeObj.setQuitScreenOpen(false);
        utilObj.showBannerAd(utilObj.getScreenName(constantsObj.SCREEN_ZEN_MODE));
        blitzQuit.hide();
    };


    /**
     * returns to back to the home
     */
    this.close = function () {
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, zenModeObj.getBlitzPuzzleTracking(), zenModeObj.getBlitzPuzzleTheme(), constantsObj.TRACK_BLITZ_BACK1, constantsObj.TRACK_QUIT, zenModeObj.getCurrentLevel(), "", "", "");

        if(zenModeObj.getCurrentBufferTime() <= 0){
            blitzQuit.hide();
            blitzQuit.timerZero();
        }
        //ideally final outro will be called here with some edge cases to be handled.
        zenModeObj.setQuitScreenOpen(false);
        // if(zenModeObj.getCurrentLevel() > 2){
        //     blitzRetryLayer.show();
        // }else{
        //     blitzFtueOutro.show();
        // }
        zenModeObj.setBlitzModeOn(false);
        zenModeLayer.hide();
        homeLayer.show();
    };

    this.timerZero = function(){
        zenModeObj.setQuitScreenOpen(false);
        var retryCount = zenModeObj.getRetryCount();
        if(zenModeObj.getCurrentLevel() > 2){
        if ( retryCount <  zenModeObj.getRetryLimit()) {
            zenModeObj.setRetryCount(retryCount + 1);
            retryCount ++ ;
            var params = {
                retryCount : retryCount,
            };
            zenModeObj.setStopTimer(true);
            zenModeLayer.blitzRetry(zenModeLayer , params);
        } else {
            //blitzRetryPopup.show();
            // TODO: add reward overlay with retry popup

                blitzRetryLayer.show();
            }

        }else{
            blitzFtueOutro.show();
        }

        return;
    };

    // function to do nothing
    this.preventBackgroundScreenTouch = function () {
        // do nothing -> rest here xD
    };

};
