/**
 * This is a trans layer, it won't have a screen name, will work on functions similar to layers
 * @constructor
 */

DailyBonusLayer = function () {
    // array which will have all the sprites to remove
    var spritesToRemove = [];
    var spritesToRemoveAfterDelay = [];
    var spriteArr = [];
    var labelArr = [];
    var transBtnArr = [];
    var boxSpriteArr = [];
    var capSpriteArr = [];
    var lockSpriteArr = [];
    var starGlitterArr = [];
    var clipperNodeArr = [];
    var subHeader = null;
    var giftBoxesUIAvailable = false;
    var giftBoxesUIComplete = false;
    var giftBoxSelectionArr = [];
    var lockedGiftBox = true;
    var dailyBonusAnimRunning = false;
    var dailyBonusScreenVisible = false;
    var removeBtnsArr = [];
    var screenNo = 1;
    var header = null;
    var transBg = null;
    var indexClickedBeforeVideo = 1;
    var clickedOnBoxForVideo = false;
    var videoClickTimeStamp = 0;
    var cashLblArr = [];
    var skipBtn = null;
    var skipButtonOutline = null;
    var localTime = "";
    var trackAutoOpen = false;

    /**
     * this will work similar to the layer hide functions
     * it will remove all the elements on the screen pushed to arr spritesToRemove
     */
    this.hide = function () {
        for (var i in spritesToRemove) {
            if (utilObj.isNodeValid(spritesToRemove[i])) {
                utilObj.removeChild(curLayer, spritesToRemove[i]);
            }
        }
        spritesToRemove = [];
        for (var i in spritesToRemoveAfterDelay) {
            if (utilObj.isNodeValid(spritesToRemoveAfterDelay[i])) {
                utilObj.removeChild(curLayer, spritesToRemoveAfterDelay[i]);
            }
        }
        spritesToRemoveAfterDelay = [];
    };

    /**
     * here all the elements will be shown on the screen, all the elements will have the parentLayer as currentScreen
     */
    this.show = function () {
        var zOrder = constantsObj.FTUE_Z_ORDER;
        var xPos = centerXPos;
        var yPos = constantsObj.DESIGN_HEIGHT + topBarOffset;
        spritesToRemove = [];
        spritesToRemoveAfterDelay = [];
        spriteArr = [];
        labelArr = [];
        transBtnArr = [];
        boxSpriteArr = [];
        capSpriteArr = [];
        lockSpriteArr = [];
        starGlitterArr = [];
        clipperNodeArr = [];
        giftBoxesUIAvailable = false;
        giftBoxesUIComplete = false;
        giftBoxSelectionArr = [];
        lockedGiftBox = true;
        dailyBonusAnimRunning = false;
        dailyBonusScreenVisible = false;
        clickedOnBoxForVideo = false;
        videoClickTimeStamp = 0;
        indexClickedBeforeVideo = 1;
        screenNo = 1;
        cashLblArr = [];
        trackAutoOpen = false;

        // grants the daily bonus for the day and sets variables
        dailyBonusObj.grantDailyBonus();

        localTime = new Date().toLocaleDateString();
        if (localTime == undefined || localTime == null) {
            localTime = "na";
        }

        utilObj.hideBannerAd(utilObj.getScreenName(constantsObj.SCREEN_ZEN_MODE));

        // creating a button covering the entire screen
        var transBtn = utilObj.getButton(canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset, 0.5, 0, centerXPos, 0,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'dailyBonusLayer',
                fn: 'doNothing',
                screen: curLayer.screen,
                params: {sound: false},
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(curLayer, transBtn, zOrder);
        spritesToRemoveAfterDelay.push(transBtn);

        transBg = utilObj.getScale9Sprite(constantsObj.tile_white, xPos, 0, 0.5, 0, canvasWidth, constantsObj.DESIGN_HEIGHT + topBarOffset, spriteArr, curLayer, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setColor(transBg, constantsObj.COLOR_BLACK);
        utilObj.setOpacity(transBg, constantsObj.OPACITY_90);
        spritesToRemoveAfterDelay.push(transBg);

        //cashLbl for the grant anim
        var xPosCoin = xRightPos - 30;
        var xShiftTemp = 200;
        var coinBg = utilObj.getScale9Sprite(constantsObj.tile_white_curved, xPosCoin - (350 + xShiftTemp), constantsObj.DESIGN_HEIGHT - 226 - 70, 0, 0.5, 320, 80, spriteArr,
            curLayer, zOrder, constantsObj.SPRITE_MISC);
        coinBg.setOpacity(0);
        spritesToRemove.push(coinBg);
        coinBg.setColor(constantsObj.COLOR_WHITE);

        var coinImg = utilObj.getSprite(constantsObj.coin_png_2, xPosCoin - (350 + xShiftTemp), constantsObj.DESIGN_HEIGHT - 226 - 70, 0.5, 0.5, constantsObj.SCALE_SPRITE_9, spriteArr, curLayer, zOrder, constantsObj.SPRITE_MISC);
        spritesToRemove.push(coinImg);
        coinImg.setOpacity(0);

        var coinCount = economyObj.getCash();
        var cashLbl = utilObj.getBMFontLabel(coinCount + "", constantsObj.FONT_HELVETICA_60, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPosCoin - (210 + xShiftTemp), constantsObj.DESIGN_HEIGHT - 226 - 70, 0.5, 0.5, labelArr, curLayer, zOrder + 1);
        cashLbl.setOpacity(0);
        spritesToRemove.push(cashLbl);

        var plusImg = utilObj.getSprite(constantsObj.green_plus, xPosCoin - (100 + xShiftTemp), constantsObj.DESIGN_HEIGHT - 226 - 70, 0, 0.5, constantsObj.SCALE_SPRITE_1, spriteArr, curLayer, zOrder, constantsObj.SPRITE_MISC);
        spritesToRemove.push(plusImg);
        plusImg.setOpacity(0);

        cashLblArr = [coinBg, coinImg , cashLbl, plusImg];

        // -----------------

        yPos -= 640;
        header = utilObj.getBMFontLabel(stringsObj.daily_bonus_header, constantsObj.FONT_HELVETICA_BOLD_90, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, curLayer, zOrder);
        spritesToRemove.push(header);

        // subheader text created here
        yPos -= 200;
        subHeader = utilObj.getBMFontLabel(stringsObj.daily_bonus_subheader_1, constantsObj.FONT_HELVETICA_70, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, yPos, 0.5, 1, labelArr, curLayer, zOrder);
        utilObj.setOpacity(subHeader, constantsObj.OPACITY_70);
        spritesToRemove.push(subHeader);

        // creating the boxes initial UI here
        yPos -= 650;
        var numBoxes = 3;
        dailyBonusLayer.createUIForGiftBoxes(yPos, numBoxes, zOrder);
        //

        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);
    };

    /**
     *  this function removes all the sprites if all UI is done
     * otherwise it creates the UI for 2 gift boxes case
     * @param clickedBoxIndex
     * @returns {number}
     */
    this.checkAndCreateUIForGiftBoxes = function (clickedBoxIndex) {
        if (giftBoxesUIComplete) {
            var delayTime = 0.1;
            var fadeOutTime = 0.15;
            var delayErr = 0.15;
            utilObj.delayedCallback(curLayer, animObj.removeTemporarySprites, delayTime, {spriteArr: spritesToRemove, fadeDur: fadeOutTime}, false);
            utilObj.delayedCallback(curLayer, animObj.removeTemporarySprites, delayTime + delayErr, {spriteArr: spritesToRemoveAfterDelay, fadeDur: fadeOutTime}, false);
            // dailyBonusScreenVisible = false;
            utilObj.delayedCallback(curLayer, function () {
                dailyBonusObj.setLastDailyBonusClosedTimestamp(utilObj.getCurrentTimestamp());
                dailyBonusScreenVisible = false;
            }, (delayTime + fadeOutTime + delayErr), null, false);
            utilObj.showBannerAd(utilObj.getScreenName(constantsObj.SCREEN_HOME));
            utilObj.delayedCallback(curLayer, dailyBonusLayer.changeScreenAfterClose, (delayTime + fadeOutTime + delayErr), null, false);
            return (delayTime + fadeOutTime + delayErr);
        }
        if (giftBoxesUIAvailable) {
            return dailyBonusLayer.recreateUIForGiftBoxes(clickedBoxIndex);
        }
    };

    /**
     * takes the user to game screen if coming from notif
     * @param sender curLayer
     * @param params
     */
    this.changeScreenAfterClose = function (sender, params) {
        // checks where to go
        var isFromNotif = dailyBonusObj.getFromNotifClick();
        if (isFromNotif) {
            dailyBonusObj.setFromNotifClick(false);
            var puzzleToOpen = dailyBonusObj.getPuzzleIdToOpenAfterDailyBonus();
            homeLayer.hide();
            gameLayer.show(puzzleToOpen, false);
        }
        utilObj.showMessage(stringsObj.rewardTextToaster, centerYPos - 640);
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "db_close_toaster", constantsObj.TRACK_VIEW, dailyBonusObj.getBucketForUser(), "", 1, "");
    };

    /**
     * this function removes clicked box elements from the respective arrays
     * @param clickedBoxIndex
     */
    this.removeClickedBoxElements = function (clickedBoxIndex) {
        transBtnArr.splice(clickedBoxIndex, 1);
        boxSpriteArr.splice(clickedBoxIndex, 1);
        capSpriteArr.splice(clickedBoxIndex, 1);
        lockSpriteArr.splice(clickedBoxIndex, 1);
        clipperNodeArr.splice(clickedBoxIndex, 1);
    };

    /**
     * this function recreates UI by shifting gift boxes and fading button options
     * @param clickedBoxIndex
     */
    this.recreateUIForGiftBoxes = function (clickedBoxIndex) {
        dailyBonusLayer.removeClickedBoxElements(clickedBoxIndex);

        var numBoxes = boxSpriteArr.length;
        var giftBoxXPosArr = dailyBonusLayer.getXPositionValuesForGiftBoxes(numBoxes);
        giftBoxXPosArr.sort(function (a, b) {
            return a - b;
        });

        if (numBoxes == 0) {
            return;
        }

        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", localTime, constantsObj.TRACK_DB_W2E, constantsObj.TRACK_VIEW, dailyBonusObj.getBucketForUser(), "", 1, "");

        screenNo = 2;
        trackAutoOpen = false;
        var finalBoxPositionsArr = [];
        var chosenIndices = [];
        for (var i = 0; i < numBoxes; i++) {
            var xPosForGiftBox = giftBoxXPosArr[i];
            var selectedIndex = constantsObj.NOT_FOUND; // TODO: DB: update it later
            var selectedBoxXPos = 10000; // TODO: DB: update it later
            var minXDist = Math.abs(xPosForGiftBox - selectedBoxXPos);
            for (var j = 0; j < numBoxes; j++) {
                if (chosenIndices.indexOf(j) != -1) {
                    continue;
                }
                var curBoxPos = utilObj.getSpriteCoordinates(boxSpriteArr[j]);
                var curBoxXPos = curBoxPos.xPos;
                if (Math.abs(xPosForGiftBox - curBoxXPos) < minXDist) {
                    selectedBoxXPos = curBoxXPos;
                    selectedIndex = j;
                    minXDist = Math.abs(xPosForGiftBox - curBoxXPos);
                } else if (Math.abs(xPosForGiftBox - curBoxXPos) == minXDist) {
                    if (curBoxXPos < selectedBoxXPos) {
                        selectedBoxXPos = curBoxXPos;
                        selectedIndex = j;
                        minXDist = Math.abs(xPosForGiftBox - curBoxXPos);
                    }
                }
            }


            finalBoxPositionsArr[selectedIndex] = xPosForGiftBox;
            chosenIndices.push(selectedIndex);
        }

        var animDuration = 0;
        for (var i = 0; i < numBoxes; i++) {
            animDuration = animObj.moveGiftBoxes(transBtnArr[i], boxSpriteArr[i], clipperNodeArr[i], lockSpriteArr[i], finalBoxPositionsArr[i]);
        }

        var singleBoxSprite = boxSpriteArr[0];
        var giftBoxPosition = utilObj.getSpriteCoordinates(singleBoxSprite);
        var giftBoxYPos = giftBoxPosition.yPos;
        var giftBoxDimensions = utilObj.getSpriteDimensions(singleBoxSprite);
        var giftBoxHeight = giftBoxDimensions.height;
        var giftBoxZOrder = utilObj.getSpriteZOrder(singleBoxSprite);

        var yPos = giftBoxYPos + giftBoxHeight / 2;

        // subHeader text added and fade In animation run here
        var fadeInDuration = 0.5;
        utilObj.setString(subHeader, stringsObj.unlock_gift_desc);
        utilObj.setColor(subHeader, constantsObj.COLOR_WHITE);
        animObj.fadeToAnimation(curLayer, {node: subHeader, fadeDur: fadeInDuration, opacity: constantsObj.OPACITY_70});

        // add video and skip button here and update the tracking for both of them
        var videoBtnHeight = 200;
        var videoBtnWidth = 860;
        yPos -= (375 + videoBtnHeight / 2);
        var watchVideoToUnlockBtn = utilObj.getButton(videoBtnWidth, videoBtnHeight, 0.5, 1.0, centerXPos, yPos,
            constantsObj.newButton_cutup, constantsObj.newButton_cutup, constantsObj.newButton_cutup, {
                obj: 'dailyBonusLayer',
                fn: 'watchVideo',
                screen: curLayer.screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_RATE_US,
                    f: constantsObj.TRACK_RATE,
                    g: "",
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.setColor(watchVideoToUnlockBtn, constantsObj.COLOR_GREEN_09);
        utilObj.addChild(curLayer, watchVideoToUnlockBtn, giftBoxZOrder);
        spritesToRemove.push(watchVideoToUnlockBtn);
        removeBtnsArr.push(watchVideoToUnlockBtn);
        utilObj.setCascadeOpacityEnabled(watchVideoToUnlockBtn, true);

        utilObj.pulseButton(watchVideoToUnlockBtn, constantsObj.PULSE_ACTION_TAG, 0);

        var unlockLabel = utilObj.getBMFontLabel(stringsObj.video_unlock_text, constantsObj.FONT_HELVETICA_MEDIUM_90, constantsObj.COLOR_WHITE,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), videoBtnWidth/2 - 60, videoBtnHeight/2, 0.5, 0.5);
        utilObj.addChild(watchVideoToUnlockBtn, unlockLabel, constantsObj.SPRITE_Z_ORDER);
        utilObj.setOpacity(watchVideoToUnlockBtn, constantsObj.OPACITY_0);

        var w2eBtn = utilObj.getSprite(constantsObj.w2eIcon, videoBtnWidth/2 + 310, videoBtnHeight/2, 0.5, 0.5, constantsObj.SCALE_SPRITE_40);
        utilObj.addChild(watchVideoToUnlockBtn, w2eBtn, constantsObj.SPRITE_Z_ORDER);

        var skipBtnWidth = 390;
        var skipBtnHeight = 160;
        yPos -= (150 + skipBtnHeight / 2 + videoBtnHeight / 2);

        skipButtonOutline = utilObj.getScale9Sprite(constantsObj.button_outline_3, centerXPos, yPos, 0.5, 1.0, skipBtnWidth, skipBtnHeight);
        utilObj.addChild(curLayer, skipButtonOutline, giftBoxZOrder);
        utilObj.setColor(skipButtonOutline, constantsObj.COLOR_GREYISH_BTN);
        utilObj.setOpacity(skipButtonOutline , constantsObj.OPACITY_60);

         skipBtn = utilObj.getButton(skipBtnWidth, skipBtnHeight, 0.5, 1.0, centerXPos, yPos,
            constantsObj.tile_white_curved, constantsObj.tile_white_curved, constantsObj.tile_white_curved, {
                obj: 'dailyBonusLayer',
                fn: 'skip',
                screen: curLayer.screen,
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_RATE_US,
                    f: constantsObj.TRACK_RATE,
                    g: "",
                    s: gameObj.getPuzzleSpeciesTracking(),
                    co: 1,
                    oppId: ""
                },
                 feedBackType: constantsObj.GREY_EFFECT,
                 child: [skipButtonOutline]
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.setColor(skipBtn, constantsObj.COLOR_BLACK);
        utilObj.addChild(curLayer, skipBtn, giftBoxZOrder);


        spritesToRemove.push(skipBtn);
        removeBtnsArr.push(skipBtn);
        spritesToRemove.push(skipButtonOutline);
        removeBtnsArr.push(skipButtonOutline);
        utilObj.setCascadeOpacityEnabled(skipBtn, true);

        var skipLabel = utilObj.getBMFontLabel(stringsObj.skip, constantsObj.FONT_HELVETICA_MEDIUM_80, constantsObj.COLOR_GREYISH_BTN,
            constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), skipBtnWidth/2, skipBtnHeight/2, 0.5, 0.5);
        utilObj.addChild(skipBtn, skipLabel, constantsObj.SPRITE_Z_ORDER);
        utilObj.setOpacity(skipBtn, constantsObj.OPACITY_0);
        utilObj.setOpacity(skipButtonOutline, constantsObj.OPACITY_0);

        var fadeInDuration = 0.5;
        animObj.fadeToAnimation(curLayer, {node: subHeader, fadeDur: fadeInDuration, opacity: constantsObj.OPACITY_70});
        animObj.fadeInAnimation(curLayer, {node: watchVideoToUnlockBtn, fadeDur: fadeInDuration});
        animObj.fadeInAnimation(curLayer, {node: skipBtn, fadeDur: fadeInDuration});
        animObj.fadeInAnimation(curLayer, {node: skipButtonOutline, fadeDur: fadeInDuration});

        animDuration = Math.max(fadeInDuration, animDuration);
        giftBoxesUIComplete = true;
        return animDuration;
    };

    /**
     * this function is called on pressing unlock using video button
     */
    this.watchVideo = function () {
        if (utilObj.getCurrentTimestamp() - videoClickTimeStamp <= 2) {
            return;
        }

        videoClickTimeStamp = utilObj.getCurrentTimestamp();
        dailyBonusObj.triggerVideo();
        // dailyBonusLayer.videoCompleteCallBack();

        var family = "unlock";
        if (clickedOnBoxForVideo) {
            family = "pre_unlock_click_" + indexClickedBeforeVideo;
        }
        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", localTime, constantsObj.TRACK_DB_W2E, family, dailyBonusObj.getBucketForUser(), "", 1, "");
        // utilObj.showMessage("Force calling video complete callback from here");
    };

    /**
     * this function is called on pressing skip button
     */
    this.skip = function () {
        if (utilObj.getCurrentTimestamp() - videoClickTimeStamp <= 4) {
            return;
        }

        giftBoxesUIComplete = true;
        dailyBonusLayer.checkAndCreateUIForGiftBoxes();
        //utilObj.delayedCallback(curLayer,dailyBonusLayer.checkAndCreateUIForGiftBoxes , 0.1 , null , false);

        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", localTime, constantsObj.TRACK_DB_W2E, constantsObj.TRACK_SKIP, dailyBonusObj.getBucketForUser(), "", 1, "");
    };

    /**
     * this function returns the 3 gift box images to show
     */
    this.getGiftBoxImagesToShow = function () {
        var giftBoxImages = constantsObj.gift_box_imgs;
        return utilObj.shuffleArray(giftBoxImages);
    };


    /**
     * this function creates UI for gift boxes
     * @param yPos
     * @param numBoxes
     * @param visibility
     */
    this.createUIForGiftBoxes = function (yPos, numBoxes, zOrder) {
        var spriteArr = [];
        var labelArr = [];

        var giftBoxXPosArr = dailyBonusLayer.getXPositionValuesForGiftBoxes(numBoxes);
        var giftBoxImagesArr = dailyBonusLayer.getGiftBoxImagesToShow();
        giftBoxXPosArr.sort(function (a, b) {
            return a - b;
        });

        trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", localTime, constantsObj.TRACK_DB, constantsObj.TRACK_VIEW, dailyBonusObj.getBucketForUser(), "", 1, "");

        screenNo = 1;
        var numGiftBoxes = giftBoxXPosArr.length;
        for (var i = 0; i < numGiftBoxes; i++) {
            var boxImg = constantsObj.gift_box_blue;
            var capImg = constantsObj.gift_box_blue_cap;

            if (giftBoxImagesArr[i] != undefined) {
                boxImg = giftBoxImagesArr[i]["boxImg"];
                capImg = giftBoxImagesArr[i]["capImg"];
            }

            // adding box sprite here
            var boxSprite = utilObj.getSprite(boxImg, giftBoxXPosArr[i], yPos, 0.5, 0.5, constantsObj.SCALE_SPRITE_17, spriteArr, curLayer, zOrder + 1, constantsObj.SPRITE_MISC);
            var boxSpriteContentSize = utilObj.getSpriteContentSize(boxSprite);
            var boxSpriteDimensions = utilObj.getSpriteDimensions(boxSprite);
            utilObj.setCascadeOpacityEnabled(boxSprite, true);

            // adding gift box cap sprite here
            var capSprite = utilObj.getSprite(capImg, boxSpriteContentSize.width / 2, (boxSpriteContentSize.height) - 40, 0.5, 0, constantsObj.SCALE_SPRITE_14, spriteArr, boxSprite, zOrder + 1, constantsObj.SPRITE_MISC);
            var capSpriteDimensions = utilObj.getSpriteDimensions(capSprite);

            // adding clipper node here for box overlay
            var boxClone = utilObj.getSpriteClone(boxSprite);
            var capClone = utilObj.getSpriteClone(capSprite);
            utilObj.addChild(boxClone, capClone, constantsObj.SPRITE_Z_ORDER);
            var clipperNode = utilObj.getClippingNode(boxClone, 0, spriteArr, curLayer, zOrder + 2);
            var boxCoverSprite = utilObj.getScale9Sprite(constantsObj.tile_white, giftBoxXPosArr[i], yPos, 0.5, 0.5, capSpriteDimensions.width, boxSpriteContentSize.height + capSpriteDimensions.height, spriteArr, clipperNode, constantsObj.SPRITE_Z_ORDER, constantsObj.SPRITE_MISC);
            utilObj.setColor(boxCoverSprite, constantsObj.COLOR_GREY_17);
            utilObj.setOpacity(boxCoverSprite, constantsObj.OPACITY_70);
            utilObj.setCascadeOpacityEnabled(clipperNode, true);
            utilObj.setOpacity(clipperNode, constantsObj.OPACITY_0);
            // adding lock sprite Bg and lock sprite here
            var lockSpriteBg = utilObj.getSprite(constantsObj.lock_bg, giftBoxXPosArr[i], yPos + 60, 0.5, 0.5, constantsObj.SCALE_SPRITE_NEW_1 * constantsObj.SCALE_SPRITE_17, spriteArr, curLayer, zOrder + 3, constantsObj.SPRITE_MISC);
            var lockSpriteDimensions = utilObj.getSpriteContentSize(lockSpriteBg);
            utilObj.setOpacity(lockSpriteBg, constantsObj.OPACITY_0);
            utilObj.setCascadeOpacityEnabled(lockSpriteBg, true);

            utilObj.getSprite(constantsObj.lock_quest, lockSpriteDimensions.width/2,(lockSpriteDimensions.height)/2, 0.5, 0.5, constantsObj.SCALE_SPRITE_15, spriteArr, lockSpriteBg, zOrder + 1, constantsObj.SPRITE_MISC);


            var btnWidth = boxSpriteDimensions.width;
            var btnHeight = boxSpriteDimensions.height + capSpriteDimensions.height - 120;
            var transButton = utilObj.getButton(btnWidth, btnHeight, 0.5, 0.5, giftBoxXPosArr[i], yPos + capSpriteDimensions.height/2,
                constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                    obj: 'dailyBonusLayer',
                    fn: 'openGiftBox',
                    screen: curLayer.screen,
                    params: {index: i},
                    track: {
                        k: constantsObj.TRACK_DIALOG,
                        p: gameObj.getCurPuzzleTracking(),
                        c: gameObj.getTrackingPuzzleTheme(),
                        o: constantsObj.TRACK_HOME,
                        f: constantsObj.TRACK_GIFT_BOX_CLICK,
                        g: curLayer.screen,
                        s: gameObj.getPuzzleSpeciesTracking(),
                        co: 1,
                        oppId: ""
                    },
                    feedBackType: constantsObj.ZOOMOUT_FEEDBACK,
                    child: [boxSprite, boxClone, lockSpriteBg]
                }, false, ccui.Widget.PLIST_TEXTURE, 1);
            utilObj.addChild(curLayer, transButton, zOrder + 2);

            transBtnArr.push(transButton);
            boxSpriteArr.push(boxSprite);
            capSpriteArr.push(capSprite);
            lockSpriteArr.push(lockSpriteBg);
            clipperNodeArr.push(clipperNode);

            spritesToRemove.push(transButton);
            spritesToRemove.push(boxSprite);
            spritesToRemove.push(clipperNode);
            spritesToRemove.push(lockSpriteBg);
        }

        dailyBonusLayer.runAppearAnimation();

        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);

        giftBoxesUIAvailable = true;
        dailyBonusScreenVisible = true;
    };

    /**
     * this function calls the animation for pulsating gift boxes forever
     * @param sender
     * @param params
     */
    this.pulsateGiftBoxForever = function (sender, params) {
        if (!params) {
            return;
        }

        var btnSprite = params["btnSprite"];
        var boxSprite = params["boxSprite"];

        animObj.runGiftBoxPulsateAnimation(btnSprite, boxSprite);

    };

    /**
     * this function runs the appear animation for the daily bonus 3 gift box screen
     * @returns {number}
     */
    this.runAppearAnimation = function () {
        dailyBonusAnimRunning = true;

        var animDuration = 0.1;
        var bgFadeDuration = 0.4;
        var headerFadeDuration = 0.4;
        var subHeaderFadeDuration = 0.4;

        animDuration = animObj.runSingleActionAnimationWithDelay({
            node: transBg,
            animType: constantsObj.FADE_TO_ANIM,
            delayTime: animDuration,
            animParams: {
                animDuration: bgFadeDuration,
                opacity: constantsObj.OPACITY_90
            }
        });

        animDuration = animObj.runSingleActionAnimationWithDelay({
            node: header,
            animType: constantsObj.FADE_IN_ANIM,
            delayTime: animDuration,
            animParams: {
                animDuration: headerFadeDuration
            }
        });

        animDuration = animObj.runSingleActionAnimationWithDelay({
            node: subHeader,
            animType: constantsObj.FADE_TO_ANIM,
            delayTime: (animDuration - headerFadeDuration + 0.3),
            animParams: {
                animDuration: subHeaderFadeDuration,
                opacity: constantsObj.OPACITY_70
            }
        });


        var numBoxes = boxSpriteArr.length;
        var delayGapDuration = 0.06;
        var boxAppearDelay = 0;
        var maxAppearDelay = 0;
        var centerBoxIndex = Math.floor(numBoxes/2);
        var initialDelayTime = animDuration + delayGapDuration;
        for (var i = 0; i < numBoxes; i++) {
            initialDelayTime = animDuration + delayGapDuration;
            if(i == centerBoxIndex){
                initialDelayTime = animDuration;
            }
            boxAppearDelay = animObj.runGiftBoxAppearAnimation(transBtnArr[i], boxSpriteArr[i], initialDelayTime);
            dailyBonusLayer.runStarGlitterAndBoxPulsateAnimation(i, boxAppearDelay);
            maxAppearDelay = Math.max(maxAppearDelay, boxAppearDelay);
        }

        var delayErr = 0.1;
        utilObj.delayedCallback(curLayer, dailyBonusLayer.resetAnimRunning, maxAppearDelay + delayErr, null, false);
        return boxAppearDelay;
    };

    /**
     * this function resets the dailyBonusAnimRunning variable
     */
    this.resetAnimRunning = function () {
        dailyBonusAnimRunning = false;
    };

    /**
     * this function returns the x position values to create gift box UI
     * @param numBoxes
     * @returns {[*]}
     */
    this.getXPositionValuesForGiftBoxes = function (numBoxes) {
        // if there is only one gift box, it needs to positioned in the center
        if (numBoxes == 1) {
            return [centerXPos];
        }

        var xGap = 350; // required gap between each of the gift box
        var boxWidth = 250; // required width of each gift box
        var gapBetweenBoxCenters = xGap + boxWidth / 2; // gap between centers of each gift box

        if (numBoxes == 2) {
            return [centerXPos - gapBetweenBoxCenters / 2, centerXPos + gapBetweenBoxCenters / 2];
        }
        return [centerXPos - gapBetweenBoxCenters, centerXPos, centerXPos + gapBetweenBoxCenters];
    };

    /**
     * this function opens the gift box
     * @param sender
     * @param params
     * @returns {boolean}
     */
    this.openGiftBox = function (sender, params) {
        if (!params || params.index == undefined || params.index == null) {
            // loggerObj.debugLog("dailyBonusLog: invalid params sent to open gift box function , params -> ", (params ? utilObj.getStringifiedJson(params) : "undefined"));
            return false;
        }
        var totalGiftBoxesAvailable = boxSpriteArr.length;
        var indexVal = params.index;
        // setting indexVal correctly if a gift box has already been selected
        var numGiftBoxSelected = giftBoxSelectionArr.length;
        if (numGiftBoxSelected > 0) {
            if (lockedGiftBox) {
                // utilObj.showMessage("Watch Video to Unlock!!");
                indexClickedBeforeVideo = indexVal;
                clickedOnBoxForVideo = true;
                dailyBonusLayer.watchVideo();
                return false;
            }
        }
        var indexValToReduce = 0;
        for (var i = 0; i < numGiftBoxSelected; i++) {
            if (indexVal > giftBoxSelectionArr[i]) {
                indexValToReduce++;
            }
        }
        indexVal -= indexValToReduce;
        if (indexVal < 0 || indexVal > (totalGiftBoxesAvailable - 1)) {
            // loggerObj.debugLog("dailyBonusLog: invalid params index sent to open gift box function , index value -> ", indexVal);
            return false;
        }

        if(dailyBonusAnimRunning){
            // loggerObj.debugLog("dailyBonusLog: not opening boxes as daily bonus anim is running currently");
            return false;
        }
        dailyBonusAnimRunning = true;

        var family = "click_" + indexVal;
        var order = constantsObj.TRACK_DB;
        if (screenNo == 2) {
            family = "post_unlock_click_" + indexVal;
            order = constantsObj.TRACK_DB_W2E;
            utilObj.setString(header, "See you tomorrow!");
        }

        if (!trackAutoOpen) {
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", localTime, order, family, dailyBonusObj.getBucketForUser(), "", 1, "");
        }

        trackAutoOpen = false;
        // stopping all animations here for gift Box Sprite and btn sprite
        dailyBonusLayer.stopAllGiftBoxAnimations();

        // stopping plist effects here
        dailyBonusLayer.stopAllStarGlitterEffects();

        // subHeader fade out animation here
        animObj.fadeOutAnimation(curLayer, {node: subHeader, fadeDur: 0.5});

        var clickedBoxIndex = indexVal;
        var transBtn = transBtnArr[clickedBoxIndex];
        var giftBoxSprite = boxSpriteArr[clickedBoxIndex];
        var capSprite = capSpriteArr[clickedBoxIndex];
        var clipperSprite = clipperNodeArr[clickedBoxIndex];
        var lockBgSprite = lockSpriteArr[clickedBoxIndex];

        if (screenNo == 1) {
            dailyBonusLayer.fadeInOverlayOnOtherTwoBox(clickedBoxIndex);
        } else  {
            dailyBonusLayer.fadeOutOtherBox(clickedBoxIndex);
        }

        var giftBoxZOrder = utilObj.getSpriteZOrder(giftBoxSprite);
        var giftBoxClone = utilObj.getSpriteClone(giftBoxSprite);
        spritesToRemove.push(giftBoxClone);
        var capSpriteClone = utilObj.getSpriteClone(capSprite);
        spritesToRemove.push(capSpriteClone);
        utilObj.addChild(giftBoxClone, capSpriteClone, constantsObj.SPRITE_Z_ORDER);
        utilObj.addChild(curLayer, giftBoxClone, giftBoxZOrder + 1);

        var grantAnimDuration = animObj.grantDailyBonusRewardAnimation(giftBoxSprite, giftBoxClone, capSpriteClone, cashLblArr[2]);
        // removing unused sprites here
        var delayErr = 0.1;
        utilObj.delayedCallback(curLayer, animObj.removeTemporarySprites, grantAnimDuration, {spriteArr: [giftBoxClone, capSpriteClone, transBtn, giftBoxSprite, clipperSprite, lockBgSprite]}, false);
        utilObj.delayedCallback(curLayer, dailyBonusLayer.updateGiftBoxesUI, grantAnimDuration + delayErr, {index: clickedBoxIndex}, false);
        return true;
    };

    /**
     * fade out the box in background for second box click
     * @param indexVal current clicked box
     */
    this.fadeOutOtherBox = function (indexVal) {
        var indexToRemove = 0;
        if (indexVal == indexToRemove ){
            indexToRemove = 1;
        }

        var transBtn = transBtnArr[indexToRemove];
        var giftBoxSprite = boxSpriteArr[indexToRemove];
        var capSprite = capSpriteArr[indexToRemove];

        animObj.fadeSprites([transBtn, giftBoxSprite, capSprite], {type: constantsObj.FADE_OUT_ANIM});
    };

    /**
     * this function fades in overlay i.e. clipping node on top of the other two boxes
     * it firsts calculate the position to be set for the clipper node,
     * using the position difference between the stencil and the actual gift Box sprite,
     * when the pulsating forever animation stops due to stopAllActions, the box might end up in a position different form the original one
     * @param indexVal current clicked box
     */
    this.fadeInOverlayOnOtherTwoBox = function (indexVal) {
        var index1ToRemove = 0;
        var index2ToRemove = 0;
        if (indexVal == 0 ){
            index1ToRemove = 1;
            index2ToRemove = 2;
        } else if (indexVal == 1) {
            index1ToRemove = 0;
            index2ToRemove = 2;
        } else {
            index1ToRemove = 0;
            index2ToRemove = 1;
        }

        var giftBoxSprite1 = boxSpriteArr[index1ToRemove];
        var giftBoxSprite2 = boxSpriteArr[index2ToRemove];

        if(!utilObj.isNodeValid(giftBoxSprite1) || !utilObj.isNodeValid(giftBoxSprite2)){
            return;
        }

        var clipperNode1 = clipperNodeArr[index1ToRemove];
        var clipperNode2 = clipperNodeArr[index2ToRemove];

        if(!utilObj.isNodeValid(clipperNode1) || !utilObj.isNodeValid(clipperNode2)){
            return;
        }

        var stencil1 = utilObj.getStencil(clipperNode1);
        var stencil2 = utilObj.getStencil(clipperNode2);

        if(!stencil1 || !stencil2){
            return;
        }

        var giftBox1Pos = utilObj.getSpriteCoordinates(giftBoxSprite1);
        var stencil1Pos = utilObj.getSpriteCoordinates(stencil1);
        var clipperNode1Pos = utilObj.getSpriteCoordinates(clipperNode1);

        var giftBox2Pos = utilObj.getSpriteCoordinates(giftBoxSprite2);
        var stencil2Pos = utilObj.getSpriteCoordinates(stencil2);
        var clipperNode2Pos = utilObj.getSpriteCoordinates(clipperNode2);

        var yDiff1 = giftBox1Pos.yPos - stencil1Pos.yPos;
        utilObj.setPosition(clipperNode1, clipperNode1Pos.xPos, clipperNode1Pos.yPos + yDiff1);

        var yDiff2 = giftBox2Pos.yPos - stencil2Pos.yPos;
        utilObj.setPosition(clipperNode2, clipperNode2Pos.xPos, clipperNode2Pos.yPos + yDiff2);

        animObj.fadeSprites([clipperNode1, clipperNode2], {type: constantsObj.FADE_TO_ANIM, opacity: constantsObj.OPACITY_60, fadeDur: 0.2});
    };

    /**
     * this function updates the UI for daily bonus screen
     * @param sender
     * @param params
     * @returns {boolean}
     */
    this.updateGiftBoxesUI = function (sender, params) {
        if (!params || params.index == undefined || params.index == null) {
            // loggerObj.debugLog("dailyBonusLog: updateGiftBoxesUi: invalid params sent: params -> ", params);
            return false;
        }
        var totalGiftBoxesAvailable = boxSpriteArr.length;
        if (params.index < 0 || params.index > (totalGiftBoxesAvailable - 1)) {
            // loggerObj.debugLog("dailyBonusLog:  updateGiftBoxesUI: invalid params index sent to open gift box function , index value -> ", params.index);
            return false;
        }
        dailyBonusLayer.checkToCompleteGiftBoxesUI();
        var clickedBoxIndex = params.index;
        giftBoxSelectionArr.push(clickedBoxIndex);
        var updateUIDelay = dailyBonusLayer.checkAndCreateUIForGiftBoxes(clickedBoxIndex);
        utilObj.delayedCallback(curLayer, dailyBonusLayer.resetAnimRunning, updateUIDelay, null, false);
        return true;
    };

    /**
     * this function checks and completes UI status for daily bonus gift boxes
     */
    this.checkToCompleteGiftBoxesUI = function () {
        if (giftBoxesUIComplete) {
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", localTime, constantsObj.TRACK_DB_W2E, "post_unlock_close", dailyBonusObj.getBucketForUser(), "", 1, "");
            return;
        }
        if(giftBoxesUIAvailable) {
            if (!dailyBonusObj.ifVideoIsAvailable()) {
                giftBoxesUIComplete = true;
                trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", localTime, constantsObj.TRACK_DB, constantsObj.TRACK_CLOSE, dailyBonusObj.getBucketForUser(), "", 1, "");
            }
        }
    };

    /**
     * this function does nothing
     */
    this.doNothing = function () {
        if (screenNo == 1) {
            utilObj.showMessage("Click on any of the boxes!", centerYPos - 640);
            trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "db_tap_toaster", constantsObj.TRACK_VIEW, dailyBonusObj.getBucketForUser(), "", 1, "");
        }
    };

    /**
     * this function runs star glitter and pulsate action for each gift box
     * @param i
     * @param delayTime
     */
    this.runStarGlitterAndBoxPulsateAnimation = function (i, delayTime) {
        utilObj.delayedCallback(curLayer, animObj.runStarGlitterAnimation, delayTime, {
            "parentSprite": transBtnArr[i]
        }, false);
        utilObj.delayedCallback(curLayer, dailyBonusLayer.pulsateGiftBoxForever, delayTime, {
            "btnSprite": transBtnArr[i],
            "boxSprite": boxSpriteArr[i]
        }, false);
        return delayTime;
    };

    /**
     * on video complete callback, the gift box unlocks
     */
    this.videoCompleteCallBack = function(){
        var lockSpriteArrLength = lockSpriteArr.length;
        var animDelay = 0;
        var fadeOutDur = 0.5;
        videoClickTimeStamp = utilObj.getCurrentTimestamp();
        for(var j = 0; j < lockSpriteArrLength; j++){
            animObj.fadeOutAnimation(curLayer, {node: lockSpriteArr[j], fadeDur: fadeOutDur});
        }
        for(var j = 0; j < removeBtnsArr.length; j++){
            var fadeOut = utilObj.getFadeOut(fadeOutDur);
            var remove = utilObj.getIndependentRemoveSelf();
            var arr = [fadeOut, remove];
            animObj.runAction(removeBtnsArr[j], utilObj.getSequence(arr));
        }
        var clipperNodeArrLength = clipperNodeArr.length;
        for(var j = 0; j < clipperNodeArrLength; j++){
            var fadeOut = utilObj.getFadeOut(fadeOutDur);
            animObj.runAction(clipperNodeArr[j], fadeOut);
        }
        lockedGiftBox = false;
        if (clickedOnBoxForVideo) {
            utilObj.delayedCallback(curLayer, dailyBonusLayer.openGiftBox, fadeOutDur, {index: indexClickedBeforeVideo}, false);
            clickedOnBoxForVideo = false;
            trackAutoOpen = true;
        } else {
            var numBoxes = boxSpriteArr.length;
            var pulseDelay = 0.3;
            for(var i = 0 ; i < numBoxes; i++) {
                var extraDelay = (i) * pulseDelay;
                animDelay = dailyBonusLayer.runStarGlitterAndBoxPulsateAnimation(i, fadeOutDur + extraDelay);
            }
        }
        utilObj.setString(subHeader, stringsObj.choose_second_gift_desc);
    };



    /**
     * this function stops all running gift box animations
     */
    this.stopAllGiftBoxAnimations = function () {
        var numBoxes = boxSpriteArr.length;
        for (var i = 0; i < numBoxes; i++) {
            animObj.stopAllActions(boxSpriteArr[i]);
            animObj.stopAllActions(transBtnArr[i]);
        }
    };

    this.getDailyBonusScreenVisible = function () {
        return dailyBonusScreenVisible;
    };

    this.setDailyBonusScreenVisible = function (val) {
        dailyBonusScreenVisible = val;
    };


    /**
     * gets the state from the two UI boxes for anim
     * 2nd screen click, 1 -> 1st screen click
     * @returns {number}
     */
    this.getUiState = function () {
        return screenNo;
    };

    /**
     * gets the header for anim part
     * @return {*}
     */
    this.getHeader = function () {
        return header;
    };

    /**
     * pushes to starGlitterArr
     * @param val
     */
    this.addToStarGlitterArr = function (val) {
        starGlitterArr.push(val);
    };

    /**
     * this function stops all star glitter effects on daily bonus screen
     */
    this.stopAllStarGlitterEffects = function () {
        var numEffects = starGlitterArr.length;
        for(var i = 0 ; i < numEffects; i++){
            if(utilObj.isNodeValid(starGlitterArr[i])){
                utilObj.removeChild(transBtnArr[i], starGlitterArr[i]);
                if (utilObj.isNodeValid(starGlitterArr[i])) {
                    starGlitterArr[i].stopSystem();
                }
            }
        }
        starGlitterArr = [];
    };

    this.getCashLblArr = function () {
        return cashLblArr;
    };
};
