UiCreator = function () {
    var someVariable = 0;
    var spriteArr = [];
    var labelArr = [];
    var jewelElementsArr = [];

    this.someFunction = function() {

    };

    /**
     * this clears the label and sprite array
     */
    this.clearSpriteAndLabelArr = function () {
        spriteArr = [];
        labelArr = [];
    };

    /**
     * this function fetches the list of screens for a UI element
     */
    this.getScreenListForUIElement = function (element) {
        var screenList = [];
        switch(element){
            case constantsObj.UI_ELEMENT_BOTTOM_NAV:
                screenList = constantsObj.SCREENS_BOTTOM_NAV;
                break;
            default:
                break;
        }
        return screenList;
    };

    /**
     * this function checks if the UI element needs to be created for the screen
     * @param element
     */
    this.shouldCreateUIElement = function (element, screen) {
        var screenListForElement = uiCreatorObj.getScreenListForUIElement(element);
        if(screenListForElement.indexOf(screen) != -1){
            return true;
        }
        return false;
    };

    /**
     * this function adds element based on the elementType an params value
     * @param element
     * @param params
     */
    this.createUIElement = function (element, screen , heightForClaimTag) {
        switch(element){
            case 0:
                uiCreatorObj.createBottomNav(screen , heightForClaimTag);
                break;
            default:
                break;
        }
    };

    /**
     * this function checks and creates UI elements on the screen
     */
    this.checkAndCreateUIElements = function (screen , heightForClaimTag) {
        var uiElementsList = constantsObj.UI_ELEMENTS;
        var numUIElements = uiElementsList.length;
        for(var i = 0; i < numUIElements; i++){
            if(uiCreatorObj.shouldCreateUIElement(uiElementsList[i], screen)){
                uiCreatorObj.createUIElement(uiElementsList[i], screen , heightForClaimTag);
            }
        }
    };

    /**
     * this function creates bottom Nav bar based on the params passed
     * @param params
     */
    this.createBottomNav = function (screen , heightForClaimTag) {
        // loggerObj.debugLog("bottomNavLog: creating Bottom Nav here -> ", screen);
        uiCreatorObj.clearSpriteAndLabelArr();
        var layer = utilObj.getLayerForScreen(screen);
        var btnWidth = (canvasWidth / 4); //- (canvasWidth / 72);
        var btnHeight = 175;
        // calculating btnHeight here
        if(screen == constantsObj.SCREEN_CALENDAR){
            btnHeight = 228;
            if (homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2) {
                btnHeight = 175;
            }
        }
        if(screen == constantsObj.SCREEN_PACK_LAYER){
            btnHeight = 228;
            if (homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2) {
                btnHeight = 175;
            }
        }
        if(screen == constantsObj.SCREEN_ACHIEVEMENTS){
               btnHeight = 228;
            if (homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2) {
                btnHeight = 175;
            }
        }
        if(screen == constantsObj.SCREEN_HOME) {
            btnHeight = 228;
            if(homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2){
                btnHeight = 175;
            }
        }
        //
        var xPos = btnWidth / 2; //+ (canvasWidth / 120);
        var zOrder = constantsObj.SPRITE_Z_ORDER + 1;
        if(screen == constantsObj.SCREEN_PACK_LAYER){
            zOrder = constantsObj.UI_Z_ORDER + 2;
        }
        var homeNewExp = homeLayoutExp;

        var iconYShift = 35;
        if(homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2){
            iconYShift = 10;
        }

        var homeIconImg = constantsObj.home_newIcon;
        var homeIconColor = constantsObj.COLOR_WHITE;
        var homeIconXPos = btnWidth/2;
        var homeIconScaling = constantsObj.SCALE_SPRITE_12 * 2.5;
        if(screen == constantsObj.SCREEN_ACHIEVEMENTS){
            if(homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2){
                homeIconImg = constantsObj.home_newIcon;
                homeIconColor = constantsObj.COLOR_BOTTOM_NAV_HS;
                homeIconXPos = btnWidth/1.9;
                homeIconScaling = constantsObj.SCALE_SPRITE_12 * 2.5;
            } else {
                if(homeNewExp == constantsObj.EXP_VAR_1 || homeNewExp == constantsObj.EXP_VAR_2){
                    homeIconImg = constantsObj.home_normal;
                    homeIconXPos = btnWidth/1.9;
                    homeIconScaling = constantsObj.SCALE_SPRITE_9 * 1.4;
                } else {
                    homeIconImg = constantsObj.bottom_nav_home;
                    homeIconXPos = btnWidth/2;
                    homeIconScaling = constantsObj.SCALE_SPRITE_12 * 1.5;
                }
            }
        }

        if (screen == constantsObj.SCREEN_HOME) {
            if (homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2) {
                homeIconImg = constantsObj.home_newIcon;
                homeIconColor = constantsObj.COLOR_BLUE_NAV_BAR;
                homeIconXPos = xPos;
                homeIconScaling = constantsObj.SCALE_SPRITE_12 * 2.5;
            } else {
                homeIconImg = constantsObj.bottom_nav_home;
                homeIconXPos = xPos;
                homeIconScaling = constantsObj.SCALE_SPRITE_12 * 1.5;
            }
        }

        if(screen == constantsObj.SCREEN_CALENDAR){
            if(homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2) {
                homeIconImg = constantsObj.home_newIcon;
                homeIconColor = constantsObj.COLOR_BOTTOM_NAV_HS;
                homeIconXPos = btnWidth/2.0;
                homeIconScaling = constantsObj.SCALE_SPRITE_9 * 1.4;
                if(subscriptionsDTCObj.shouldShowCalendarV1()) {
                    homeIconScaling = constantsObj.SCALE_SPRITE_12 * 2.5;
                }
            } else {
                if(homeNewExp == constantsObj.EXP_VAR_1 || homeNewExp == constantsObj.EXP_VAR_2) {
                    homeIconImg = constantsObj.home_normal;
                    homeIconXPos = btnWidth/2.0;
                    homeIconScaling = constantsObj.SCALE_SPRITE_9 * 1.4;
                } else {
                    homeIconImg = constantsObj.bottom_nav_home;
                    homeIconXPos = btnWidth/2.0;
                    homeIconScaling = constantsObj.SCALE_SPRITE_12 * 1.5;
                }
            }
        }

        if(screen == constantsObj.SCREEN_PACK_LAYER) {
            if(homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2) {
                homeIconImg = constantsObj.home_newIcon;
                homeIconColor = constantsObj.COLOR_BOTTOM_NAV_HS;
                homeIconXPos = btnWidth/2.0;
                homeIconScaling = constantsObj.SCALE_SPRITE_12 * 2.5;
            } else {
                if(homeNewExp == constantsObj.EXP_VAR_1 || homeNewExp == constantsObj.EXP_VAR_2){
                    homeIconImg = constantsObj.home_normal;
                    homeIconXPos = btnWidth/2.0;
                    homeIconScaling = constantsObj.SCALE_SPRITE_9 * 1.4;
                } else {
                    homeIconImg = constantsObj.bottom_nav_home;
                    homeIconXPos = btnWidth/2.0;
                    homeIconScaling = constantsObj.SCALE_SPRITE_12 * 1.5;
                }
            }
        }

        var homeIcon = utilObj.getSprite(homeIconImg, homeIconXPos, btnHeight / 2 + iconYShift + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, homeIconScaling, spriteArr, layer, zOrder + 1, constantsObj.SPRITE_MISC);
        utilObj.setColor(homeIcon, homeIconColor);

        var transHomeButton = utilObj.getButton(btnWidth, btnHeight + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, xPos, btnHeight / 2 + constantsObj.BOTTOM_BAR_OFFSET / 2,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'bottomNavObj',
                fn: 'showHome',
                screen: screen,
                //params: {sound: false} // only present in homeV3
                params: {screen: screen},
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_BOTTOM_NAV,
                    f: constantsObj.TRACK_HOME,
                    g: utilObj.getScreenName(screen),
                    s: "",
                    co: 1,
                    oppId: ""
                },
                boundingSprite: uiCreatorObj.getTileWhiteSpriteForBtnFeedBack(xPos, btnWidth, btnHeight, spriteArr, zOrder, layer),
                feedBackType: constantsObj.DARKEN_FEEDBACK_BOUNDED
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(layer, transHomeButton, zOrder + 1);

        var homeLblFont = constantsObj.FONT_ROBOTO_REGULAR_40;
        var homeLblXPos = btnWidth/2;
        var homeLblParent = transHomeButton;
        var showHomeLabel = false;
        if(screen == constantsObj.SCREEN_HOME){
            if(homeLayoutExpNew != constantsObj.EXP_VAR_1 && homeLayoutExpNew != constantsObj.EXP_VAR_2){
                showHomeLabel = true;
                homeLblFont = constantsObj.FONT_ROBOTO_BOLD_40;
                homeLblXPos = xPos;
                homeLblParent = homeLayer;
            }
        }

        if(screen == constantsObj.SCREEN_ACHIEVEMENTS || screen == constantsObj.SCREEN_CALENDAR || screen ==constantsObj.SCREEN_PACK_LAYER){
            if(homeLayoutExpNew != constantsObj.EXP_VAR_1 && homeLayoutExpNew != constantsObj.EXP_VAR_2){
                showHomeLabel = true;
                homeLblFont = constantsObj.FONT_ROBOTO_REGULAR_40;
                homeLblXPos = btnWidth/2;
                homeLblParent = transHomeButton;
            }
        }

        if (showHomeLabel) {
            utilObj.getBMFontLabel("HOME", homeLblFont, constantsObj.COLOR_WHITE,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), homeLblXPos, 40 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, labelArr, homeLblParent, zOrder + 1);
        }

        xPos += btnWidth;//(canvasWidth / 72) - (canvasWidth / 720);

        // separate functions to handle showing of offer tags and to handle homeLayer.subscriptionTagCondition check should be made
        // loggerObj.debugLog("tagLog: 1 screen , subscriptionTagValue -> ", screen, homeLayer.subscriptionTag);
        var showOfferTag = false;
        if(screen == constantsObj.SCREEN_PACK_LAYER || (screen == constantsObj.SCREEN_ACHIEVEMENTS && ProfileExp != constantsObj.EXP_VAR_1) || screen == constantsObj.SCREEN_HOME){
            if((homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2)){
                var idMini = utilObj.getIdForDate(gameObj.getTodaysPuzzleDate());
                idMini = stringsObj.mini_prefix + idMini.substr(2, idMini.length);
                homeLayer.subscriptionTagCondition(idMini);
                if(homeLayer.subscriptionTag == 3){
                    showOfferTag = true;
                }
            }
        }

        // loggerObj.debugLog("tagLog: 2 screen , subscriptionTagValue -> ", screen, homeLayer.subscriptionTag);

        if(showOfferTag){
            utilObj.getSprite(constantsObj.offer_tag_calendar, xPos + (50 * canvasWidth / 1440), btnHeight + 75 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 1, constantsObj.SCALE_SPRITE_1, spriteArr, layer, zOrder + 1, constantsObj.SPRITE_MISC);
        }
        //

        //
        if(screen == constantsObj.SCREEN_CALENDAR){
            if(homeNewExp != constantsObj.EXP_VAR_1 && homeNewExp != constantsObj.EXP_VAR_2){
                utilObj.getScale9Sprite(constantsObj.white_rounded_bg, xPos, btnHeight / 2 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, btnWidth, btnHeight, spriteArr, layer, zOrder, constantsObj.SPRITE_MISC);
            }
        }
        //

        var calendarImage = constantsObj.calendar_normal;
        var scaleImage = constantsObj.SCALE_SPRITE_2 * 1.5;
        var calendarImgColor = constantsObj.COLOR_WHITE;
        var calendarLblColor = constantsObj.COLOR_WHITE;
        var calendarLblFont = constantsObj.FONT_ROBOTO_REGULAR_40;
        var calendarLblParent = layer;
        var showCalendarLbl = true;
        if (homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2) {
            calendarImage = constantsObj.calendar_icon;
            scaleImage = constantsObj.SCALE_SPRITE_2 * 1.6;
        }

        if(screen == constantsObj.SCREEN_PACK_LAYER || screen == constantsObj.SCREEN_ACHIEVEMENTS){
            if(homeNewExp != constantsObj.EXP_VAR_1 && homeNewExp != constantsObj.EXP_VAR_2) {
                calendarImage = constantsObj.bottom_nav_calendar;
            } else {
                if(homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2) {
                    calendarImgColor = constantsObj.COLOR_BOTTOM_NAV_HS;
                }
            }
        }

        // duplicate/similar  condition here as above above
        if(screen == constantsObj.SCREEN_HOME){
            if(homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2){
                calendarImage = constantsObj.calendar_icon;
                scaleImage = constantsObj.SCALE_SPRITE_2 * 1.6;
                calendarImgColor = constantsObj.COLOR_BOTTOM_NAV_HS;
            } else {
                calendarImage = constantsObj.calendar_normal;
                scaleImage = constantsObj.SCALE_SPRITE_2 * 1.5;
                calendarImgColor = constantsObj.COLOR_WHITE;
            }
        }

        //
        if (screen == constantsObj.SCREEN_CALENDAR) {
            calendarLblFont = constantsObj.FONT_ROBOTO_BOLD_40;
            if (homeLayoutExpNew != constantsObj.EXP_VAR_1 && homeLayoutExpNew != constantsObj.EXP_VAR_2) {
                if (homeNewExp != constantsObj.EXP_VAR_1 && homeNewExp != constantsObj.EXP_VAR_2) {
                    calendarImgColor = constantsObj.COLOR_DARK_BLUE_01;
                    calendarLblColor = constantsObj.COLOR_DARK_BLUE_01;
                } else {
                    calendarLblColor = constantsObj.COLOR_WHITE;
                }
                calendarImage = constantsObj.bottom_nav_calendar;
                scaleImage = constantsObj.SCALE_SPRITE_2;
            } else {
                calendarImgColor = constantsObj.COLOR_BLUE_NAV_BAR;
                calendarImage = constantsObj.calendar_icon;
            }
        }
        //

        //
        if(screen == constantsObj.SCREEN_PACK_LAYER || screen == constantsObj.SCREEN_HOME || screen == constantsObj.SCREEN_CALENDAR || screen == constantsObj.SCREEN_ACHIEVEMENTS){
            if(homeLayoutExpNew != constantsObj.EXP_VAR_1 && homeLayoutExpNew != constantsObj.EXP_VAR_2){
                showCalendarLbl = true;
            } else{
                showCalendarLbl = false;
            }
        }
        //

        var calendarIcon = utilObj.getSprite(calendarImage, xPos, btnHeight / 2 + iconYShift + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, scaleImage, spriteArr, layer, zOrder + 1, constantsObj.SPRITE_MISC);
        utilObj.setColor(calendarIcon, calendarImgColor);

        var transCalendarButton = utilObj.getButton(btnWidth, btnHeight + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, xPos, btnHeight / 2 + constantsObj.BOTTOM_BAR_OFFSET / 2,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'bottomNavObj',
                fn: 'showCalendar',
                screen: screen,
                params: {screen: screen},
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_BOTTOM_NAV,
                    f: constantsObj.TRACK_CALENDAR,
                    g: utilObj.getScreenName(screen),
                    s: "",
                    co: 1,
                    oppId: ""
                },
                boundingSprite: uiCreatorObj.getTileWhiteSpriteForBtnFeedBack(xPos, btnWidth, btnHeight, spriteArr, zOrder, layer),
                feedBackType: constantsObj.DARKEN_FEEDBACK_BOUNDED
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(layer, transCalendarButton, zOrder + 1);

        if(showCalendarLbl) {
            utilObj.getBMFontLabel("CALENDAR", calendarLblFont, calendarLblColor,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, 40 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, labelArr, calendarLblParent, zOrder + 1);
        }

        xPos += btnWidth; //+ (canvasWidth / 72) - (canvasWidth / 720);
        if(screen == constantsObj.SCREEN_PACK_LAYER){
            if(homeNewExp != constantsObj.EXP_VAR_1 && homeNewExp != constantsObj.EXP_VAR_2){
                utilObj.getScale9Sprite(constantsObj.white_rounded_bg, xPos, btnHeight / 2 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, btnWidth, btnHeight, spriteArr, layer, zOrder, constantsObj.SPRITE_MISC);
            }
        }

        var packIconImg = constantsObj.bottom_nav_packs;
        var packIconScale = constantsObj.SCALE_SPRITE_32 * 1.5;
        var showPackLbl = false;
        var packIconColor = constantsObj.COLOR_WHITE;
        var packLblColor = constantsObj.COLOR_WHITE;
        var packLblFont = constantsObj.FONT_ROBOTO_REGULAR_40;
        var packLblParent = layer;
        var isHalloweenOn = gameObj.checkIfHalloweenOn();

        if(screen == constantsObj.SCREEN_CALENDAR || screen == constantsObj.SCREEN_ACHIEVEMENTS){
            if(isHalloweenOn){
                packIconImg = constantsObj.bottom_nav_packs_holloween;
                packIconScale = constantsObj.SCALE_SPRITE_6;
            } else {
                if(homeNewExp != constantsObj.EXP_VAR_1 && homeNewExp != constantsObj.EXP_VAR_2) {
                    packIconImg = constantsObj.bottom_nav_packs;
                    packIconScale = constantsObj.SCALE_SPRITE_32 * 1.5;
                } else {
                    packIconImg = constantsObj.packs_normal;
                    if (homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2) {
                        packIconImg = constantsObj.pack_icon;
                    }
                    packIconScale = constantsObj.SCALE_SPRITE_2 * 1.5;
                }
            }

            if(homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2){
                packIconColor = constantsObj.COLOR_BOTTOM_NAV_HS;
                showPackLbl = false;
            } else {
                showPackLbl = true;
            }
        }

        if(screen == constantsObj.SCREEN_HOME){
            if(isHalloweenOn){
                packIconImg = constantsObj.bottom_nav_packs_holloween;
                packIconScale = constantsObj.SCALE_SPRITE_6;
            } else {
                if (homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2) {
                    packIconImg = constantsObj.pack_icon;
                    packIconColor = constantsObj.COLOR_BOTTOM_NAV_HS;
                } else {
                    packIconImg = constantsObj.packs_normal;
                }
                packIconScale = constantsObj.SCALE_SPRITE_2 * 1.5;
            }

            if(homeLayoutExpNew != constantsObj.EXP_VAR_1 && homeLayoutExpNew != constantsObj.EXP_VAR_2){
                showPackLbl = true;
            }
        }

        if(screen == constantsObj.SCREEN_PACK_LAYER){
            packLblFont = constantsObj.FONT_ROBOTO_BOLD_40;
            packIconImg = constantsObj.bottom_nav_packs;
            packIconScale = constantsObj.SCALE_SPRITE_32 * 1.5;
            if(homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2){
                packIconImg = constantsObj.pack_icon;
                packIconScale = constantsObj.SCALE_SPRITE_2 * 1.5;
            }

            if(isHalloweenOn){
                packIconImg = constantsObj.bottom_nav_packs_holloween;
                packIconScale = constantsObj.SCALE_SPRITE_6;
            } else {
                if(homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2){
                    packIconColor = constantsObj.COLOR_BLUE_NAV_BAR;
                }
            }

            if(homeLayoutExpNew != constantsObj.EXP_VAR_1 && homeLayoutExpNew != constantsObj.EXP_VAR_2){
                showPackLbl = true;
                if(homeNewExp != constantsObj.EXP_VAR_1 && homeNewExp != constantsObj.EXP_VAR_2){
                    packIconColor = constantsObj.COLOR_DARK_BLUE_01;
                    packLblColor = constantsObj.COLOR_DARK_BLUE_01;
                }
            } else {
                showPackLbl = false;
            }
        }

        var packIcon = utilObj.getSprite(packIconImg, xPos, btnHeight / 2 + iconYShift + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, packIconScale, spriteArr, layer, zOrder + 1, constantsObj.SPRITE_MISC);
        utilObj.setColor(packIcon, packIconColor);

        var packsButton = utilObj.getButton(btnWidth, btnHeight + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, xPos, btnHeight / 2 + constantsObj.BOTTOM_BAR_OFFSET / 2,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'bottomNavObj',
                fn: 'showPacks',
                screen: screen,
                params: {screen: screen},
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_BOTTOM_NAV,
                    f: constantsObj.TRACK_PACK,
                    g: utilObj.getScreenName(screen),
                    s: "",
                    co: 1,
                    oppId: ""
                },
                boundingSprite: uiCreatorObj.getTileWhiteSpriteForBtnFeedBack(xPos, btnWidth, btnHeight, spriteArr, zOrder, layer),
                feedBackType: constantsObj.DARKEN_FEEDBACK_BOUNDED
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(layer, packsButton, zOrder + 1);

        if(showPackLbl){
            utilObj.getBMFontLabel("PACKS", packLblFont, packLblColor,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, 40 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, labelArr, packLblParent, zOrder + 1);
        }

        var offset = 0;
        if (homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2) {
            offset = 20;
        }
        // taking the xPos for showing jewel Notification on Pack icon
        if(homeLayoutExpNew != constantsObj.EXP_VAR_1 && homeLayoutExpNew != constantsObj.EXP_VAR_2) {
            if (screen == constantsObj.SCREEN_CALENDAR || screen == constantsObj.SCREEN_ACHIEVEMENTS || screen == constantsObj.SCREEN_HOME) {
                var circleIcon1 = utilObj.getSprite(constantsObj.white_circle_150, xPos + btnWidth / 4 - btnHeight / 8 - offset, btnHeight / 2 + btnHeight / 4 + btnHeight / 16 + (offset * 2) + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_2, spriteArr, layer, zOrder + 1, constantsObj.SPRITE_MISC);
                utilObj.setColor(circleIcon1, constantsObj.COLOR_RED_01);

                var alreadySeenNotif = gameObj.isAlreadySeenPackNotifForPack();
                var circleIconLabel = utilObj.getBMFontLabel("!", constantsObj.FONT_ROBOTO_BOLD_60, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + btnWidth / 4 - btnHeight / 8 - offset, btnHeight / 2 + btnHeight / 4 + btnHeight / 16 + (offset * 2) + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, labelArr, layer, zOrder + 2);
                utilObj.setVisible(circleIcon1, false);
                utilObj.setVisible(circleIconLabel, false);

                if ((alreadySeenNotif == 1 || ((utilObj.getCurrentTimestamp() - gameObj.getPackLayerLastOpenedTimeStamp()) > 3 * constantsObj.SECONDS_IN_DAY && (!gameObj.getifAllPackCompleted())) || (gameObj.getPacknotiftimestamp() > gameObj.getPackLayerLastOpenedTimeStamp())) && gameObj.getMastery1() > 0) {
                    gameObj.setPacknotiftimestamp(utilObj.getCurrentTimestamp());
                    utilObj.setVisible(circleIcon1, true);
                    utilObj.setVisible(circleIconLabel, true);
                }
            }
        }
        //

        //
        xPos += btnWidth;// + (canvasWidth / 72) - (canvasWidth / 720);

        var proIcon = constantsObj.achievement_normal;
        var proIconScale = 1.5;
        var proIconColor = constantsObj.COLOR_WHITE;
        var proIconOpacity = constantsObj.OPACITY_100;
        var proIconLblTxt = "ACHIEVEMENTS";
        var proIconLblFont = constantsObj.FONT_ROBOTO_REGULAR_40;
        var proIconLblColor = constantsObj.COLOR_WHITE;
        var showProIconLbl = false;

        if(screen == constantsObj.SCREEN_PACK_LAYER || screen == constantsObj.SCREEN_CALENDAR){
            if(homeNewExp != constantsObj.EXP_VAR_1 && homeNewExp != constantsObj.EXP_VAR_2){
                proIcon = constantsObj.achievement_normal;
                if(ProfileExp == constantsObj.EXP_VAR_1){
                    proIcon = constantsObj.profile_screen;
                    proIconScale = constantsObj.SCALE_SPRITE_12 * 2.25;
                    proIconLblTxt = "PROFILE";
                } else {
                    proIcon = constantsObj.bottom_nav_badge;
                    proIconScale = constantsObj.SCALE_SPRITE_12 * 1.5;
                    proIconLblTxt = "ACHIEVEMENTS";
                }
            } else {
                proIcon = constantsObj.achievement_normal;
                proIconScale = 1.5;

                if(homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2){
                    proIcon = constantsObj.achievement_icon;
                    proIconScale = 1.75;
                }

                if(ProfileExp == constantsObj.EXP_VAR_1){
                    proIcon = constantsObj.profile_screen;
                    proIconScale = constantsObj.SCALE_SPRITE_12 * 2.25;
                    if(homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2){
                        proIconColor = constantsObj.COLOR_BOTTOM_NAV_HS;
                    }
                } else {
                    proIconScale = constantsObj.SCALE_SPRITE_2 * proIconScale;
                    if(homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2){
                        proIconColor = constantsObj.COLOR_BOTTOM_NAV_HS;
                    }
                }
            }

            if(homeLayoutExpNew != constantsObj.EXP_VAR_1 && homeLayoutExpNew != constantsObj.EXP_VAR_2){
                showProIconLbl = true;
            }
        }

        if(screen == constantsObj.SCREEN_HOME){
            if(homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2){
                proIcon = constantsObj.achievement_icon;
                proIconScale = constantsObj.SCALE_SPRITE_2 * 1.75;
                proIconColor = constantsObj.COLOR_BOTTOM_NAV_HS;
                if(ProfileExp == constantsObj.EXP_VAR_1){
                    proIcon = constantsObj.profile_screen;
                    proIconScale = constantsObj.SCALE_SPRITE_12 * 2.25;
                    proIconColor = constantsObj.COLOR_GREY;
                    proIconOpacity = constantsObj.OPACITY_30;
                }
            } else {
                showProIconLbl = true;
                proIcon = constantsObj.achievement_normal;
                proIconScale = constantsObj.SCALE_SPRITE_2 * 1.5;
                proIconLblTxt = "ACHIEVEMENTS";
                if(ProfileExp == constantsObj.EXP_VAR_1){
                    proIconLblTxt = "PROFILE";
                    proIcon = constantsObj.profile_screen;
                    proIconScale = constantsObj.SCALE_SPRITE_12 * 2.25;
                }
            }
        }

        if(screen == constantsObj.SCREEN_ACHIEVEMENTS){
            proIconLblFont = constantsObj.FONT_ROBOTO_BOLD_40;
            if(ProfileExp == constantsObj.EXP_VAR_1){
                proIcon = constantsObj.profile_screen_active;
                proIconScale = constantsObj.SCALE_SPRITE_12 * 2.25;
                proIconColor = constantsObj.COLOR_WHITE;
                if(homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2){
                    proIconColor = constantsObj.COLOR_BLUE_NAV_BAR;
                } else {
                    showProIconLbl = true;
                    if(homeNewExp != constantsObj.EXP_VAR_1 && homeNewExp != constantsObj.EXP_VAR_2){
                        proIconLblTxt = "PROFILE";
                        proIconLblColor = constantsObj.COLOR_DARK_BLUE_01;
                    } else {
                        proIconLblTxt = "PROFILE";
                        proIconLblColor = constantsObj.COLOR_WHITE;
                    }
                }

            } else {
                proIcon = constantsObj.bottom_nav_badge;
                proIconScale = constantsObj.SCALE_SPRITE_12 * 1.5;
                if(homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2){
                    proIcon = constantsObj.achievement_icon;
                    proIconScale = constantsObj.SCALE_SPRITE_2 * 1.75;
                    proIconColor = constantsObj.COLOR_BLUE_NAV_BAR;
                } else {
                    showProIconLbl = true;
                    if(homeNewExp != constantsObj.EXP_VAR_1 && homeNewExp != constantsObj.EXP_VAR_2){
                        proIconColor = constantsObj.COLOR_DARK_BLUE_01;
                        proIconLblTxt = "ACHIEVEMENTS";
                        proIconLblColor = constantsObj.COLOR_DARK_BLUE_01;
                    } else {
                        proIconLblTxt = "ACHIEVEMENTS";
                        proIconLblColor = constantsObj.COLOR_WHITE;
                    }
                }
            }
        }

        var badgeIcon = utilObj.getSprite(proIcon, xPos, btnHeight / 2 + iconYShift + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, proIconScale, spriteArr, layer, zOrder + 1, constantsObj.SPRITE_MISC);
        utilObj.setColor(badgeIcon, proIconColor);
        utilObj.setOpacity(badgeIcon, proIconOpacity);

        var transAchievementsButton = utilObj.getButton(btnWidth, btnHeight + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, xPos, btnHeight / 2 + constantsObj.BOTTOM_BAR_OFFSET / 2,
            constantsObj.trans_button, constantsObj.trans_button, constantsObj.trans_button, {
                obj: 'bottomNavObj',
                fn: 'showAchievements',
                screen: screen,
                params: {screen: screen},
                track: {
                    k: constantsObj.TRACK_DIALOG,
                    p: gameObj.getCurPuzzleTracking(),
                    c: gameObj.getTrackingPuzzleTheme(),
                    o: constantsObj.TRACK_BOTTOM_NAV,
                    f: constantsObj.TRACK_ACHIEVEMENTS,
                    g: utilObj.getScreenName(screen),
                    s: "",
                    co: 1,
                    oppId: ""
                },
                boundingSprite: uiCreatorObj.getTileWhiteSpriteForBtnFeedBack(xPos, btnWidth, btnHeight, spriteArr, zOrder, layer),
                feedBackType: constantsObj.DARKEN_FEEDBACK_BOUNDED
            }, false, ccui.Widget.PLIST_TEXTURE, 1);
        utilObj.addChild(layer, transAchievementsButton, zOrder + 1);

        if(showProIconLbl){
            utilObj.getBMFontLabel(proIconLblTxt, proIconLblFont, proIconLblColor,
                constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos, 40 + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, labelArr, layer, zOrder + 1);
        }

        // taking the achievement xPos here for showing jewel Notification
        if(homeLayoutExpNew != constantsObj.EXP_VAR_1 && homeLayoutExpNew != constantsObj.EXP_VAR_2) {
            var completedAchievementsCount = achievementsObj.getNumOfCompletedAchievements();
            var achv_claim_exp = epmObj.getChosenVariant(constantsObj.EXP_ACHV_CLAIM);
            if (screen == constantsObj.SCREEN_CALENDAR || screen == constantsObj.SCREEN_PACK_LAYER || screen == constantsObj.SCREEN_HOME) {
                if(achv_claim_exp == constantsObj.EXP_VAR_1) {
                    var circleIcon = utilObj.getSprite(constantsObj.todays_bg, xPos + btnWidth / 4 - btnHeight / 8 - ((offset + 50) * canvasWidth / 1440), heightForClaimTag + 34, 0.5, 0.5, 0.6, spriteArr, layer, zOrder + 1, constantsObj.SPRITE_MISC);
                    circleIcon.rotation = -90;
                    utilObj.setColor(circleIcon, constantsObj.ACHIEVEMENT_CLAIM_COLOR);

                    var completedAchievementsLabel = utilObj.getBMFontLabel("Claim", constantsObj.FONT_HELVETICA_MEDIUM_65, constantsObj.COLOR_WHITE,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + btnWidth / 4 - btnHeight / 8 - ((offset + 50) * canvasWidth / 1440), heightForClaimTag + 44, 0.5, 0.5, labelArr, layer, zOrder + 2);

                }else {
                    var circleIcon = utilObj.getSprite(constantsObj.white_circle_150, xPos + btnWidth / 4 - btnHeight / 8 - offset, btnHeight / 2 + btnHeight / 4 + btnHeight / 16 + (offset * 2) + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_2, spriteArr, layer, zOrder + 1, constantsObj.SPRITE_MISC);
                    utilObj.setColor(circleIcon, constantsObj.COLOR_RED_01);

                    var circleIconAnim = utilObj.getSprite(constantsObj.white_circle_150, xPos + btnWidth / 4 - btnHeight / 8 - offset, btnHeight / 2 + btnHeight / 4 + btnHeight / 16 + (offset * 2) + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_2, spriteArr, layer, zOrder + 1, constantsObj.SPRITE_MISC);
                    utilObj.setColor(circleIconAnim, constantsObj.COLOR_RED_01);

                    var indexofAchievement = achievementsObj.getAchievementToSurfaceOnStats();
                    var jewelNotif = 0;
                    if (completedAchievementsCount != 0) {
                        jewelNotif = completedAchievementsCount;
                    } else if (indexofAchievement != -1) {
                        jewelNotif = "!";
                    } else {
                        gameObj.setShowJewelNotif(false);
                    }

                    var completedAchievementsLabel = utilObj.getBMFontLabel(jewelNotif + "", constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_WHITE,
                        constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + btnWidth / 4 - btnHeight / 8 - offset, btnHeight / 2 + btnHeight / 4 + btnHeight / 16 + (offset * 2) + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, labelArr, layer, zOrder + 2);
                }


                if (jewelNotif == "!" && ProfileExp != constantsObj.EXP_VAR_1) {
                    utilObj.setVisible(circleIcon, false);
                    if(achv_claim_exp != constantsObj.EXP_VAR_1) {
                        utilObj.setVisible(circleIconAnim, false);
                    }
                    utilObj.setVisible(completedAchievementsLabel, false);
                } else if (completedAchievementsCount == 0 && gameObj.getShowJewelNotif() == false || jewelNotif == 0) {
                    utilObj.setVisible(circleIcon, false);
                    if(achv_claim_exp != constantsObj.EXP_VAR_1) {
                        utilObj.setVisible(circleIconAnim, false);
                    }
                    utilObj.setVisible(completedAchievementsLabel, false);
                } else if (homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2) {
                   if(achv_claim_exp == constantsObj.EXP_VAR_1) {
                       trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "claim_achievement", constantsObj.TRACK_VIEW, screen , "", "", "");
                       utilObj.delayedCallback(layer, homeObj.animateAchievementClaimTag, 1, {
                           icon: circleIcon,
                           label: completedAchievementsLabel,
                       }, false);
                   }else{
                       utilObj.delayedCallback(layer, homeObj.animateNudgeAchv, 1, {
                           icon: circleIcon,
                           label: completedAchievementsLabel,
                           animCircle : circleIconAnim,
                       }, false);
                   }
                }

                if (homeLayoutExpNew != constantsObj.EXP_VAR_1 && homeLayoutExpNew != constantsObj.EXP_VAR_2) {
                    if(achv_claim_exp != constantsObj.EXP_VAR_1) {
                        utilObj.setVisible(circleIconAnim, false);
                    }
                    if (!ftueObj.isAchievementFtueShown()) {
                        utilObj.setVisible(circleIcon, false);
                        utilObj.setVisible(completedAchievementsLabel, false);
                    }
                }
            }else if(screen == constantsObj.SCREEN_ACHIEVEMENTS && completedAchievementsCount > 0 && achv_claim_exp == constantsObj.EXP_VAR_1 ){
                utilObj.setVisible(circleIcon, false);
                utilObj.setVisible(completedAchievementsLabel, false);
               // gameObj.setIsAchievementScreenShownForClaimTag(true);
            }

            // if(completedAchievementsCount == 0){
            //     gameObj.setIsAchievementScreenShownForClaimTag(false);
            // }
        }


        //

        //
        if(screen == constantsObj.SCREEN_HOME){
            gameObj.setUnlockingBonusArchive(false);
            gameObj.setUnlockingW2eVideoCalendar(false);
        }
        //

        if(homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2){
            uiCreatorObj.checkAndUpdateJewelNotifForBottomNav(heightForClaimTag);
        }

        utilObj.addSprites(spriteArr);
        utilObj.addLabels(labelArr);
    };

    this.updateJewelNotifForBottomNav = function (jewelId , heightForClaimTag) {
        // duplicate stuff as in the function which creates bottom nav itself
        var screen = curScreen;
        var layer = utilObj.getLayerForScreen(screen);
        var btnWidth = (canvasWidth / 4) - (canvasWidth / 72);
        var btnHeight = 125;
        var xPos = btnWidth / 2 + (canvasWidth / 120);
        var zOrder = constantsObj.SPRITE_Z_ORDER + 1;
        if(screen == constantsObj.SCREEN_PACK_LAYER){
            zOrder = constantsObj.UI_Z_ORDER + 2;
        }
        // calculating btnHeight here
        if(screen == constantsObj.SCREEN_CALENDAR){
            btnHeight = 228;
            if (homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2) {
                btnHeight = 125;
            }
        }
        if(screen == constantsObj.SCREEN_PACK_LAYER){
            btnHeight = 228;
            if (homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2) {
                btnHeight = 125;
            }
        }
        if(screen == constantsObj.SCREEN_ACHIEVEMENTS){
            btnHeight = 228;
            if (homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2) {
                btnHeight = 125;
            }
        }
        if(screen == constantsObj.SCREEN_HOME) {
            btnHeight = 228;
            if(homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2){
                btnHeight = 125;
            }
        }
        //

        //
        // var numJewelElements = jewelElementsArr.length;
        // for(var i = 0; i < numJewelElements; i++){
        //     utilObj.removeChild(layer, jewelElementsArr[i]);
        // }
        jewelElementsArr = [];

        var packXPos = xPos + 2*(btnWidth + (canvasWidth / 72) - (canvasWidth / 720));
        var achievementXPos =  xPos + 3*(btnWidth + (canvasWidth / 72) - (canvasWidth / 720));
        var offset = 0;
        if (homeLayoutExpNew == constantsObj.EXP_VAR_1 || homeLayoutExpNew == constantsObj.EXP_VAR_2) {
            offset = 20;
        }

        if(jewelId == constantsObj.JEWEL_NOTIF_ACHIEVEMENT_ID){
            xPos = achievementXPos;
            var achv_claim_exp = epmObj.getChosenVariant(constantsObj.EXP_ACHV_CLAIM);
            if(achv_claim_exp == constantsObj.EXP_VAR_1) {
                var circleIcon = utilObj.getSprite(constantsObj.todays_bg, xPos + btnWidth / 4 - btnHeight / 8 - ((offset + 50) * canvasWidth / 1440), heightForClaimTag + 34, 0.5, 0.5, 0.6, spriteArr, layer, zOrder + 1, constantsObj.SPRITE_MISC);
                circleIcon.rotation = -90;
                utilObj.setColor(circleIcon, constantsObj.ACHIEVEMENT_CLAIM_COLOR);

                var completedAchievementsLabel = utilObj.getBMFontLabel("Claim", constantsObj.FONT_HELVETICA_MEDIUM_65, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + btnWidth / 4 - btnHeight / 8 - ((offset + 50) * canvasWidth / 1440), heightForClaimTag + 44, 0.5, 0.5, labelArr, layer, zOrder + 2);

                var jewelNotif = bottomNavObj.getJewelNotifValForAchievement();
                if(screen == constantsObj.SCREEN_ACHIEVEMENTS && jewelNotif > 0){
                    utilObj.setVisible(circleIcon, false);
                    utilObj.setVisible(completedAchievementsLabel, false);
                    //gameObj.setIsAchievementScreenShownForClaimTag(true);
                }else {
                    trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "claim_achievement", constantsObj.TRACK_VIEW, screen , "", "", "");
                    utilObj.delayedCallback(layer, homeObj.animateAchievementClaimTag, 1, {
                        icon: circleIcon,
                        label: completedAchievementsLabel,
                    }, false);
                }

            }else {
                var circleIcon = utilObj.getSprite(constantsObj.white_circle_150, xPos + btnWidth / 4 - btnHeight / 8 - offset, btnHeight / 2 + btnHeight / 4 + btnHeight / 16 + (offset * 2) + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_2, spriteArr, layer, zOrder + 1, constantsObj.SPRITE_MISC);
                utilObj.setColor(circleIcon, constantsObj.COLOR_RED_01);

                var circleIconAnim = utilObj.getSprite(constantsObj.white_circle_150, xPos + btnWidth / 4 - btnHeight / 8 - offset, btnHeight / 2 + btnHeight / 4 + btnHeight / 16 + (offset * 2) + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_2, spriteArr, layer, zOrder + 1, constantsObj.SPRITE_MISC);
                utilObj.setColor(circleIconAnim, constantsObj.COLOR_RED_01);

                var jewelNotif = bottomNavObj.getJewelNotifValForAchievement();
                var completedAchievementsLabel = utilObj.getBMFontLabel(jewelNotif + "", constantsObj.FONT_ROBOTO_REGULAR_60, constantsObj.COLOR_WHITE,
                    constantsObj.LABEL_AUTO_WIDTH, cc.TEXT_ALIGNMENT_LEFT, cc.p(0, 0), xPos + btnWidth / 4 - btnHeight / 8 - offset, btnHeight / 2 + btnHeight / 4 + btnHeight / 16 + (offset * 2) + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, labelArr, layer, zOrder + 2);
                trackObj.trackCounter(constantsObj.TRACK_DIALOG, "", "", "claim_achievement", constantsObj.TRACK_VIEW, screen , "", "", "");
                utilObj.delayedCallback(layer, homeObj.animateNudgeAchv, 1, {
                    icon: circleIcon,
                    label: completedAchievementsLabel,
                    animCircle : circleIconAnim,
                }, false);

            }


            jewelElementsArr.push(circleIcon);
            if(achv_claim_exp != constantsObj.EXP_VAR_1) {
                jewelElementsArr.push(circleIconAnim);
            }
            jewelElementsArr.push(completedAchievementsLabel);

        } else if(jewelId == constantsObj.JEWEL_NOTIF_PACK_ID){
            xPos = packXPos;
            var circleIcon1 = utilObj.getSprite(constantsObj.white_circle_150, xPos + btnWidth / 4 - btnHeight / 8 - offset, btnHeight / 2 + btnHeight / 4 + btnHeight / 16 + (offset * 3) + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_2 * 0.8, spriteArr, layer, zOrder + 1, constantsObj.SPRITE_MISC);
            utilObj.setColor(circleIcon1, constantsObj.COLOR_RED_01);

            var circleIconAnim = utilObj.getSprite(constantsObj.white_circle_150, xPos + btnWidth / 4 - btnHeight / 8 - offset, btnHeight / 2 + btnHeight / 4 + btnHeight / 16 + (offset * 3) + constantsObj.BOTTOM_BAR_OFFSET, 0.5, 0.5, constantsObj.SCALE_SPRITE_2 * 0.8, spriteArr, layer, zOrder + 1, constantsObj.SPRITE_MISC);
            utilObj.setColor(circleIconAnim, constantsObj.COLOR_RED_01);

            utilObj.delayedCallback(layer, animationObj.animateNudgePack, 1, {
                icon: circleIcon1,
                animCircle: circleIconAnim
            }, false);

            gameObj.setPacknotiftimestamp(utilObj.getCurrentTimestamp());
            jewelElementsArr.push(circleIcon1);
            jewelElementsArr.push(circleIconAnim);
        }
        //
    };



    /**
     * checks and updates jewel notif icons on bottom nav
     */
    this.checkAndUpdateJewelNotifForBottomNav = function (heightForClaimTag) {
        var bottomNavScreens = constantsObj.SCREENS_BOTTOM_NAV;
        if(bottomNavScreens.indexOf(curScreen) == -1){
            // loggerObj.debugLog("jewelNotifLog: not updating jewel notif icons as not in bottom nav screens currently -> ", curScreen);
            return;
        }
        var jewelId = bottomNavObj.getJewelNotifId();
        if(jewelId == constantsObj.NOT_FOUND){
            // loggerObj.debugLog("jewelNotifLog: jewelId not found");
            return;
        }

        uiCreatorObj.updateJewelNotifForBottomNav(jewelId , heightForClaimTag);
    };

    /**
     * adds alpha layer child to the parent layer using the size, anchor and coordinates of the given node
     * @param node
     * @param parentLayer
     * @param zOrder
     * @param spriteArr
     */
    this.addAlphaLayerChild = function (node, parentLayer, zOrder, spriteArr) {
        // zOrder += 1;
        // loggerObj.debugLog("buttonFeedBackLog: zOrder -> ", zOrder);
        var nodeDimensions = utilObj.getSpriteDimensions(node);
        var nodeCoordinates = utilObj.getSpriteCoordinates(node);

        var nodeAnchor = utilObj.getSpriteAnchor(node);

        var nodeWidth = nodeDimensions.width;
        var nodeHeight = nodeDimensions.height;
        var nodeXPos = nodeCoordinates.xPos;
        var nodeYPos = nodeCoordinates.yPos;

        var anchorX = nodeAnchor.x;
        var anchorY = nodeAnchor.y;

        var alphaLayerChild = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, nodeXPos, nodeYPos, anchorX, anchorY, nodeWidth * 1.7, nodeHeight * 1.3, spriteArr, parentLayer, zOrder, constantsObj.SPRITE_MISC);
        utilObj.setColor(alphaLayerChild, constantsObj.COLOR_BLACK);
        utilObj.setOpacity(alphaLayerChild, constantsObj.OPACITY_0);
        return alphaLayerChild;
    };

    /**
     * creates a clipper node using the given node as stencil,
     * then, adds alpha layer child to the clipper node
     * @param node
     * @returns {{childNode, clippingNode: *}}
     */
    this.addBoundedAlphaChild = function (node, nodeParent, nodeZOrder) {
        var clipperNode = cc.ClippingNode(node);
        clipperNode.setAlphaThreshold(0);
        clipperNode.setCascadeOpacityEnabled(true);

        var parentOfStencilNode = null;
        var zOrderOfStencilNode = 1;

        if(nodeParent){
            parentOfStencilNode = nodeParent;
            if(nodeZOrder){
                zOrderOfStencilNode = nodeZOrder;
            }
        } else {
            parentOfStencilNode = utilObj.getSpriteParent(node);
            zOrderOfStencilNode = utilObj.getSpriteZOrder(node);
        }

        // loggerObj.debugLog("darkenFeedBackBoundedLog: zOrder -> ", zOrderOfStencilNode);
        utilObj.addChild(parentOfStencilNode, clipperNode, zOrderOfStencilNode);

        var nodeDimensions = utilObj.getSpriteDimensions(node);
        var nodeCoordinates = utilObj.getSpriteCoordinates(node);

        var nodeAnchor = utilObj.getSpriteAnchor(node);

        var nodeWidth = nodeDimensions.width;
        var nodeHeight = nodeDimensions.height;
        var nodeXPos = nodeCoordinates.xPos;
        var nodeYPos = nodeCoordinates.yPos;

        var anchorX = nodeAnchor.x;
        var anchorY = nodeAnchor.y;

        var alphaLayerChild = utilObj.getScale9Sprite(constantsObj.white_rounded_bg, nodeXPos, nodeYPos, anchorX, anchorY, nodeWidth * 1.7, nodeHeight * 1.3, null, clipperNode, zOrderOfStencilNode + 1, constantsObj.SPRITE_MISC);
        utilObj.setColor(alphaLayerChild, constantsObj.COLOR_BLACK);
        utilObj.setOpacity(alphaLayerChild, constantsObj.OPACITY_0);
        utilObj.addChild(clipperNode, alphaLayerChild, zOrderOfStencilNode + 1);
        return {childNode: alphaLayerChild, clippingNode: clipperNode};
    };

    /**
     * makes a tile white sprite for button feedback
     * @param xPos
     * @param btnWidth
     * @param btnHeight
     * @param spriteArr
     * @param zOrder
     * @param layer
     * @returns {null}
     */
    this.getTileWhiteSpriteForBtnFeedBack = function (xPos, btnWidth, btnHeight, spriteArr, zOrder, layer) {
        if(homeLayoutExpNew != constantsObj.EXP_VAR_1 && homeLayoutExpNew != constantsObj.EXP_VAR_2){
            return null;
        }
        return utilObj.getScale9Sprite(constantsObj.tile_white, xPos, btnHeight / 2 + constantsObj.BOTTOM_BAR_OFFSET/2, 0.5, 0.5, btnWidth, btnHeight + constantsObj.BOTTOM_BAR_OFFSET, spriteArr, layer, zOrder, constantsObj.SPRITE_MISC);
    };
};